/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],oe=function(J){for(var e=[],i=0,D=J.length;i<D;i++)e[i]=re[J[i]];return e};define(re[136],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=i,e.$gb=D,e.$hb=S,e.$ib=A,e.$jb=P,e.$kb=k,e.$lb=u,e.$nb=d,e.$ob=y,e.$pb=E,e.$qb=$,e.$rb=g;function i(v,p){const m=D(v,p);if(m!==-1)return v[m]}function D(v,p,m=v.length-1){for(let f=m;f>=0;f--){const h=v[f];if(p(h))return f}return-1}function S(v,p){const m=A(v,p);return m===-1?void 0:v[m]}function A(v,p,m=0,f=v.length){let h=m,w=f;for(;h<w;){const a=Math.floor((h+w)/2);p(v[a])?h=a+1:w=a}return h-1}function P(v,p){const m=k(v,p);return m===v.length?void 0:v[m]}function k(v,p,m=0,f=v.length){let h=m,w=f;for(;h<w;){const a=Math.floor((h+w)/2);p(v[a])?w=a:h=a+1}return h}function u(v,p,m=0,f=v.length){const h=k(v,p,m,f);return h===v.length?-1:h}class l{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(l.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!p(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const m=A(this.e,p,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}e.$mb=l;function d(v,p){if(v.length===0)return;let m=v[0];for(let f=1;f<v.length;f++){const h=v[f];p(h,m)>0&&(m=h)}return m}function y(v,p){if(v.length===0)return;let m=v[0];for(let f=1;f<v.length;f++){const h=v[f];p(h,m)>=0&&(m=h)}return m}function E(v,p){return d(v,(m,f)=>-p(m,f))}function $(v,p){if(v.length===0)return-1;let m=0;for(let f=1;f<v.length;f++){const h=v[f];p(h,v[m])>0&&(m=f)}return m}function g(v,p){for(const m of v){const f=p(m);if(f!==void 0)return f}}}),define(re[137],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=i,e.$L=D,e.$M=S,e.$N=A;function i(P,k){const u=Object.create(null);for(const l of P){const d=k(l);let y=u[d];y||(y=u[d]=[]),y.push(l)}return u}function D(P,k){const u=[],l=[];for(const d of P)k.has(d)||u.push(d);for(const d of k)P.has(d)||l.push(d);return{removed:u,added:l}}function S(P,k){const u=[],l=[];for(const[d,y]of P)k.has(d)||u.push(y);for(const[d,y]of k)P.has(d)||l.push(y);return{removed:u,added:l}}function A(P,k){const u=new Set;for(const l of k)P.has(l)&&u.add(l);return u}}),define(re[138],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=e.$Ht=e.$Gt=e.$Ft=void 0;function i(k,u){const l=Math.pow(10,u);return Math.round(k*l)/l}class D{constructor(u,l,d,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=i(Math.max(Math.min(1,y),0),3)}static equals(u,l){return u.r===l.r&&u.g===l.g&&u.b===l.b&&u.a===l.a}}e.$Ft=D;class S{constructor(u,l,d,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=i(Math.max(Math.min(1,l),0),3),this.l=i(Math.max(Math.min(1,d),0),3),this.a=i(Math.max(Math.min(1,y),0),3)}static equals(u,l){return u.h===l.h&&u.s===l.s&&u.l===l.l&&u.a===l.a}static fromRGBA(u){const l=u.r/255,d=u.g/255,y=u.b/255,E=u.a,$=Math.max(l,d,y),g=Math.min(l,d,y);let v=0,p=0;const m=(g+$)/2,f=$-g;if(f>0){switch(p=Math.min(m<=.5?f/(2*m):f/(2-2*m),1),$){case l:v=(d-y)/f+(d<y?6:0);break;case d:v=(y-l)/f+2;break;case y:v=(l-d)/f+4;break}v*=60,v=Math.round(v)}return new S(v,p,m,E)}static i(u,l,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?u+(l-u)*6*d:d<1/2?l:d<2/3?u+(l-u)*(2/3-d)*6:u}static toRGBA(u){const l=u.h/360,{s:d,l:y,a:E}=u;let $,g,v;if(d===0)$=g=v=y;else{const p=y<.5?y*(1+d):y+d-y*d,m=2*y-p;$=S.i(m,p,l+1/3),g=S.i(m,p,l),v=S.i(m,p,l-1/3)}return new D(Math.round($*255),Math.round(g*255),Math.round(v*255),E)}}e.$Gt=S;class A{constructor(u,l,d,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=i(Math.max(Math.min(1,l),0),3),this.v=i(Math.max(Math.min(1,d),0),3),this.a=i(Math.max(Math.min(1,y),0),3)}static equals(u,l){return u.h===l.h&&u.s===l.s&&u.v===l.v&&u.a===l.a}static fromRGBA(u){const l=u.r/255,d=u.g/255,y=u.b/255,E=Math.max(l,d,y),$=Math.min(l,d,y),g=E-$,v=E===0?0:g/E;let p;return g===0?p=0:E===l?p=((d-y)/g%6+6)%6:E===d?p=(y-l)/g+2:p=(l-d)/g+4,new A(Math.round(p*60),v,E,u.a)}static toRGBA(u){const{h:l,s:d,v:y,a:E}=u,$=y*d,g=$*(1-Math.abs(l/60%2-1)),v=y-$;let[p,m,f]=[0,0,0];return l<60?(p=$,m=g):l<120?(p=g,m=$):l<180?(m=$,f=g):l<240?(m=g,f=$):l<300?(p=g,f=$):l<=360&&(p=$,f=g),p=Math.round((p+v)*255),m=Math.round((m+v)*255),f=Math.round((f+v)*255),new D(p,m,f,E)}}e.$Ht=A;class P{static fromHex(u){return P.Format.CSS.parseHex(u)||P.red}static equals(u,l){return!u&&!l?!0:!u||!l?!1:u.equals(l)}get hsla(){return this.i?this.i:S.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:A.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof D)this.rgba=u;else if(u instanceof S)this.i=u,this.rgba=S.toRGBA(u);else if(u instanceof A)this.j=u,this.rgba=A.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&D.equals(this.rgba,u.rgba)&&S.equals(this.hsla,u.hsla)&&A.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=P.k(this.rgba.r),l=P.k(this.rgba.g),d=P.k(this.rgba.b),y=.2126*u+.7152*l+.0722*d;return i(y,4)}static k(u){const l=u/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(u){const l=this.getRelativeLuminance(),d=u.getRelativeLuminance();return l>d?(l+.05)/(d+.05):(d+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const l=this.getRelativeLuminance(),d=u.getRelativeLuminance();return l>d}isDarkerThan(u){const l=this.getRelativeLuminance(),d=u.getRelativeLuminance();return l<d}lighten(u){return new P(new S(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new P(new S(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:l,g:d,b:y,a:E}=this.rgba;return new P(new D(l,d,y,E*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new P(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const l=u.rgba,d=this.rgba.a,y=l.a,E=d+y*(1-d);if(E<1e-6)return P.transparent;const $=this.rgba.r*d/E+l.r*y*(1-d)/E,g=this.rgba.g*d/E+l.g*y*(1-d)/E,v=this.rgba.b*d/E+l.b*y*(1-d)/E;return new P(new D($,g,v,E))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:l,g:d,b:y,a:E}=this.rgba;return new P(new D(u.rgba.r-E*(u.rgba.r-l),u.rgba.g-E*(u.rgba.g-d),u.rgba.b-E*(u.rgba.b-y),1))}flatten(...u){const l=u.reduceRight((d,y)=>P.o(y,d));return P.o(this,l)}static o(u,l){const d=1-u.rgba.a;return new P(new D(d*l.rgba.r+u.rgba.a*u.rgba.r,d*l.rgba.g+u.rgba.a*u.rgba.g,d*l.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=P.Format.CSS.format(this)),this.u}static getLighterColor(u,l,d){if(u.isLighterThan(l))return u;d=d||.5;const y=u.getRelativeLuminance(),E=l.getRelativeLuminance();return d=d*(E-y)/E,u.lighten(d)}static getDarkerColor(u,l,d){if(u.isDarkerThan(l))return u;d=d||.5;const y=u.getRelativeLuminance(),E=l.getRelativeLuminance();return d=d*(y-E)/y,u.darken(d)}static{this.white=new P(new D(255,255,255,1))}static{this.black=new P(new D(0,0,0,1))}static{this.red=new P(new D(255,0,0,1))}static{this.blue=new P(new D(0,0,255,1))}static{this.green=new P(new D(0,255,0,1))}static{this.cyan=new P(new D(0,255,255,1))}static{this.lightgrey=new P(new D(211,211,211,1))}static{this.transparent=new P(new D(0,0,0,0))}}e.$It=P,function(k){let u;(function(l){let d;(function(y){function E(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}y.formatRGB=E;function $(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}y.formatRGBA=$;function g(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}y.formatHSL=g;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}y.formatHSLA=v;function p(t){const r=t.toString(16);return r.length!==2?"0"+r:r}function m(t){return`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}`}y.formatHex=m;function f(t,r=!1){return r&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}${p(Math.round(t.rgba.a*255))}`}y.formatHexA=f;function h(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}y.format=h;function w(t){const r=t.length;if(r===0||t.charCodeAt(0)!==35)return null;if(r===7){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),n=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new k(new D(s,n,o,1))}if(r===9){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),n=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),c=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new k(new D(s,n,o,c/255))}if(r===4){const s=a(t.charCodeAt(1)),n=a(t.charCodeAt(2)),o=a(t.charCodeAt(3));return new k(new D(16*s+s,16*n+n,16*o+o))}if(r===5){const s=a(t.charCodeAt(1)),n=a(t.charCodeAt(2)),o=a(t.charCodeAt(3)),c=a(t.charCodeAt(4));return new k(new D(16*s+s,16*n+n,16*o+o,(16*c+c)/255))}return null}y.parseHex=w;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=l.CSS||(l.CSS={}))})(u=k.Format||(k.Format={}))}(P||(e.$It=P={}))}),define(re[51],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=D,e.$Wh=S,e.$Xh=A;function i(P){return(k,u,l)=>{let d=null,y=null;if(typeof l.value=="function"?(d="value",y=l.value):typeof l.get=="function"&&(d="get",y=l.get),!y)throw new Error("not supported");l[d]=P(y,u)}}function D(P,k,u){let l=null,d=null;if(typeof u.value=="function"?(l="value",d=u.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(l="get",d=u.get),!d)throw new Error("not supported");const y=`$memoize$${k}`;u[l]=function(...E){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,E)}),this[y]}}function S(P,k,u){return i((l,d)=>{const y=`$debounce$${d}`,E=`$debounce$result$${d}`;return function(...$){this[E]||(this[E]=u?u():void 0),clearTimeout(this[y]),k&&(this[E]=k(this[E],...$),$=[this[E]]),this[y]=setTimeout(()=>{l.apply(this,$),this[E]=u?u():void 0},P)}})}function A(P,k,u){return i((l,d)=>{const y=`$throttle$timer$${d}`,E=`$throttle$result$${d}`,$=`$throttle$lastRun$${d}`,g=`$throttle$pending$${d}`;return function(...v){if(this[E]||(this[E]=u?u():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),k&&(this[E]=k(this[E],...v)),this[g])return;const p=this[$]+P;p<=Date.now()?(this[$]=Date.now(),l.apply(this,[this[E]]),this[E]=u?u():void 0):(this[g]=!0,this[y]=setTimeout(()=>{this[g]=!1,this[$]=Date.now(),l.apply(this,[this[E]]),this[E]=u?u():void 0},p-Date.now()))}})}}),define(re[15],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=D,e.$Z=S,e.$1=A,e.$2=P,e.$3=k,e.$4=l,e.$6=y,e.$7=E,e.$8=$,e.$0=v;class i{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=i,e.$X=new i;function D(a){e.$X.setUnexpectedErrorHandler(a)}function S(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(a){l(a)||e.$X.onUnexpectedError(a)}function P(a){l(a)||e.$X.onUnexpectedExternalError(a)}function k(a){if(a instanceof Error){const{name:t,message:r}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:s,noTelemetry:h.isErrorNoTelemetry(a)}}return a}const u="Canceled";function l(a){return a instanceof d?!0:a instanceof Error&&a.name===u&&a.message===u}class d extends Error{constructor(){super(u),this.name=this.message}}e.$5=d;function y(){const a=new Error(u);return a.name=a.message,a}function E(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function $(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class g extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=g;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class p extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=p;class m extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=m;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const r=new h;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=h;class w extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}e.$cb=w}),define(re[22],oe([0,1,15,136]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=S,e.$tb=A,e.$ub=P,e.$vb=k,e.$wb=u,e.$xb=l,e.$yb=d,e.$zb=y,e.$Ab=E,e.$Bb=$,e.$Cb=g,e.$Db=v,e.$Eb=p,e.top=m,e.$Gb=f,e.$Hb=w,e.$Ib=a,e.$Jb=t,e.$Kb=r,e.$Lb=s,e.$Mb=n,e.$Nb=o,e.$Ob=c,e.$Pb=b,e.$Qb=L,e.$Rb=I,e.$Sb=j,e.$Tb=O,e.$Ub=R,e.$Vb=W,e.$Wb=F,e.$Xb=T,e.$Yb=q,e.$Zb=ue,e.$1b=ee,e.$2b=ce,e.$3b=K,e.$4b=X,e.$5b=B,e.$6b=M,e.$7b=ae,e.$8b=G,e.$$b=C;function S(Q,x=0){return Q[Q.length-(1+x)]}function A(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}function P(Q,x,V=(H,se)=>H===se){if(Q===x)return!0;if(!Q||!x||Q.length!==x.length)return!1;for(let H=0,se=Q.length;H<se;H++)if(!V(Q[H],x[H]))return!1;return!0}function k(Q,x){const V=Q.length-1;x<V&&(Q[x]=Q[V]),Q.pop()}function u(Q,x,V){return l(Q.length,H=>V(Q[H],x))}function l(Q,x){let V=0,H=Q-1;for(;V<=H;){const se=(V+H)/2|0,he=x(se);if(he<0)V=se+1;else if(he>0)H=se-1;else return se}return-(V+1)}function d(Q,x,V){if(Q=Q|0,Q>=x.length)throw new TypeError("invalid index");const H=x[Math.floor(x.length*Math.random())],se=[],he=[],me=[];for(const $e of x){const ye=V($e,H);ye<0?se.push($e):ye>0?he.push($e):me.push($e)}return Q<se.length?d(Q,se,V):Q<se.length+me.length?me[0]:d(Q-(se.length+me.length),he,V)}function y(Q,x){const V=[];let H;for(const se of Q.slice(0).sort(x))!H||x(H[0],se)!==0?(H=[se],V.push(H)):H.push(se);return V}function*E(Q,x){let V,H;for(const se of Q)H!==void 0&&x(H,se)?V.push(se):(V&&(yield V),V=[se]),H=se;V&&(yield V)}function $(Q,x){for(let V=0;V<=Q.length;V++)x(V===0?void 0:Q[V-1],V===Q.length?void 0:Q[V])}function g(Q,x){for(let V=0;V<Q.length;V++)x(V===0?void 0:Q[V-1],Q[V],V+1===Q.length?void 0:Q[V+1])}function v(Q,x,V){const H=[];function se($e,ye,Ee){if(ye===0&&Ee.length===0)return;const ke=H[H.length-1];ke&&ke.start+ke.deleteCount===$e?(ke.deleteCount+=ye,ke.toInsert.push(...Ee)):H.push({start:$e,deleteCount:ye,toInsert:Ee})}let he=0,me=0;for(;;){if(he===Q.length){se(he,0,x.slice(me));break}if(me===x.length){se(he,Q.length-he,[]);break}const $e=Q[he],ye=x[me],Ee=V($e,ye);Ee===0?(he+=1,me+=1):Ee<0?(se(he,1,[]),he+=1):Ee>0&&(se(he,0,[ye]),me+=1)}return H}function p(Q,x,V){const H=v(Q,x,V),se=[],he=[];for(const me of H)se.push(...Q.slice(me.start,me.start+me.deleteCount)),he.push(...me.toInsert);return{removed:se,added:he}}function m(Q,x,V){if(V===0)return[];const H=Q.slice(0,V).sort(x);return h(Q,x,H,V,Q.length),H}function f(Q,x,V,H,se){return V===0?Promise.resolve([]):new Promise((he,me)=>{(async()=>{const $e=Q.length,ye=Q.slice(0,V).sort(x);for(let Ee=V,ke=Math.min(V+H,$e);Ee<$e;Ee=ke,ke=Math.min(ke+H,$e)){if(Ee>V&&await new Promise(Oe=>setTimeout(Oe)),se&&se.isCancellationRequested)throw new i.$5;h(Q,x,ye,Ee,ke)}return ye})().then(he,me)})}function h(Q,x,V,H,se){for(const he=V.length;H<se;H++){const me=Q[H];if(x(me,V[he-1])<0){V.pop();const $e=(0,D.$kb)(V,ye=>x(me,ye)<0);V.splice($e,0,me)}}}function w(Q){return Q.filter(x=>!!x)}function a(Q){let x=0;for(let V=0;V<Q.length;V++)Q[V]&&(Q[x]=Q[V],x+=1);Q.length=x}function t(Q,x,V){Q.splice(V,0,Q.splice(x,1)[0])}function r(Q){return!Array.isArray(Q)||Q.length===0}function s(Q){return Array.isArray(Q)&&Q.length>0}function n(Q,x=V=>V){const V=new Set;return Q.filter(H=>{const se=x(H);return V.has(se)?!1:(V.add(se),!0)})}function o(Q){const x=new Set;return V=>{const H=Q(V);return x.has(H)?!1:(x.add(H),!0)}}function c(Q,x){return Q.length>0?Q[0]:x}function b(Q,x){return Q.length>0?Q[Q.length-1]:x}function L(Q,x,V=(H,se)=>H===se){let H=0;for(let se=0,he=Math.min(Q.length,x.length);se<he&&V(Q[se],x[se]);se++)H++;return H}function I(Q){return[].concat(...Q)}function j(Q,x){let V=typeof x=="number"?Q:0;typeof x=="number"?V=Q:(V=0,x=Q);const H=[];if(V<=x)for(let se=V;se<x;se++)H.push(se);else for(let se=V;se>x;se--)H.push(se);return H}function O(Q,x,V){return Q.reduce((H,se)=>(H[x(se)]=V?V(se):se,H),Object.create(null))}function R(Q,x){return Q.push(x),()=>W(Q,x)}function W(Q,x){const V=Q.indexOf(x);if(V>-1)return Q.splice(V,1),x}function F(Q,x,V){const H=Q.slice(0,x),se=Q.slice(x);return H.concat(V,se)}function T(Q,x){let V;if(typeof x=="number"){let H=x;V=()=>{const se=Math.sin(H++)*179426549;return se-Math.floor(se)}}else V=Math.random;for(let H=Q.length-1;H>0;H-=1){const se=Math.floor(V()*(H+1)),he=Q[H];Q[H]=Q[se],Q[se]=he}}function q(Q,x){const V=Q.indexOf(x);V>-1&&(Q.splice(V,1),Q.unshift(x))}function ue(Q,x){const V=Q.indexOf(x);V>-1&&(Q.splice(V,1),Q.push(x))}function ee(Q,x){for(const V of x)Q.push(V)}function ce(Q,x){return Array.isArray(Q)?Q.map(x):x(Q)}function K(Q){return Array.isArray(Q)?Q:[Q]}function X(Q){return Q[Math.floor(Math.random()*Q.length)]}function B(Q,x,V){const H=z(Q,x),se=Q.length,he=V.length;Q.length=se+he;for(let me=se-1;me>=H;me--)Q[me+he]=Q[me];for(let me=0;me<he;me++)Q[me+H]=V[me]}function M(Q,x,V,H){const se=z(Q,x);let he=Q.splice(se,V);return he===void 0&&(he=[]),B(Q,se,H),he}function z(Q,x){return x<0?Math.max(x+Q.length,0):Math.min(x,Q.length)}var U;(function(Q){function x(he){return he<0}Q.isLessThan=x;function V(he){return he<=0}Q.isLessThanOrEqual=V;function H(he){return he>0}Q.isGreaterThan=H;function se(he){return he===0}Q.isNeitherLessOrGreaterThan=se,Q.greaterThan=1,Q.lessThan=-1,Q.neitherLessOrGreaterThan=0})(U||(e.CompareResult=U={}));function ae(Q,x){return(V,H)=>x(Q(V),Q(H))}function G(...Q){return(x,V)=>{for(const H of Q){const se=H(x,V);if(!U.isNeitherLessOrGreaterThan(se))return se}return U.neitherLessOrGreaterThan}}const le=(Q,x)=>Q-x;e.$9b=le;const Y=(Q,x)=>(0,e.$9b)(Q?1:0,x?1:0);e.$0b=Y;function C(Q){return(x,V)=>-Q(x,V)}class N{constructor(x){this.g=x,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(x){let V=this.c;for(;V<this.g.length&&x(this.g[V]);)V++;const H=V===this.c?null:this.g.slice(this.c,V);return this.c=V,H}takeFromEndWhile(x){let V=this.d;for(;V>=0&&x(this.g[V]);)V--;const H=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,H}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const x=this.g[this.c];return this.c++,x}removeLast(){const x=this.g[this.d];return this.d--,x}takeCount(x){const V=this.g.slice(this.c,this.c+x);return this.c+=x,V}}e.$_b=N;class _{static{this.empty=new _(x=>{})}constructor(x){this.iterate=x}forEach(x){this.iterate(V=>(x(V),!0))}toArray(){const x=[];return this.iterate(V=>(x.push(V),!0)),x}filter(x){return new _(V=>this.iterate(H=>x(H)?V(H):!0))}map(x){return new _(V=>this.iterate(H=>V(x(H))))}some(x){let V=!1;return this.iterate(H=>(V=x(H),!V)),V}findFirst(x){let V;return this.iterate(H=>x(H)?(V=H,!1):!0),V}findLast(x){let V;return this.iterate(H=>(x(H)&&(V=H),!0)),V}findLastMaxBy(x){let V,H=!0;return this.iterate(se=>((H||U.isGreaterThan(x(se,V)))&&(H=!1,V=se),!0)),V}}e.$ac=_;class ne{constructor(x){this.c=x}static createSortPermutation(x,V){const H=Array.from(x.keys()).sort((se,he)=>V(x[se],x[he]));return new ne(H)}apply(x){return x.map((V,H)=>x[this.c[H]])}inverse(){const x=this.c.slice();for(let V=0;V<this.c.length;V++)x[this.c[V]]=V;return new ne(x)}}e.$bc=ne}),define(re[139],oe([0,1,15]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=D,e.$cd=S,e.$dd=A,e.$ed=P,e.$fd=k,e.$gd=u;function D(l,d){if(!l)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}function S(l,d="Unreachable"){throw new Error(d)}function A(l){if(!l)throw new i.$cb("Assertion Failed")}function P(l){l||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function k(l){if(!l()){debugger;l(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function u(l,d){let y=0;for(;y<l.length-1;){const E=l[y],$=l[y+1];if(!d(E,$))return!1;y++}return!0}}),define(re[86],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=i;function i(D,S){const A=this;let P=!1,k;return function(){if(P)return k;if(P=!0,S)try{k=D.apply(A,arguments)}finally{S()}else k=D.apply(A,arguments);return k}}}),define(re[71],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(D){function S(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}D.is=S;const A=Object.freeze([]);function P(){return A}D.empty=P;function*k(t){yield t}D.single=k;function u(t){return S(t)?t:k(t)}D.wrap=u;function l(t){return t||A}D.from=l;function*d(t){for(let r=t.length-1;r>=0;r--)yield t[r]}D.reverse=d;function y(t){return!t||t[Symbol.iterator]().next().done===!0}D.isEmpty=y;function E(t){return t[Symbol.iterator]().next().value}D.first=E;function $(t,r){for(const s of t)if(r(s))return!0;return!1}D.some=$;function g(t,r){for(const s of t)if(r(s))return s}D.find=g;function*v(t,r){for(const s of t)r(s)&&(yield s)}D.filter=v;function*p(t,r){let s=0;for(const n of t)yield r(n,s++)}D.map=p;function*m(...t){for(const r of t)yield*r}D.concat=m;function f(t,r,s){let n=s;for(const o of t)n=r(n,o);return n}D.reduce=f;function*h(t,r,s=t.length){for(r<0&&(r+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);r<s;r++)yield t[r]}D.slice=h;function w(t,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,t];const n=t[Symbol.iterator]();for(let o=0;o<r;o++){const c=n.next();if(c.done)return[s,D.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return n}}]}D.consume=w;async function a(t){const r=[];for await(const s of t)r.push(s);return Promise.resolve(r)}D.asyncToArray=a})(i||(e.Iterable=i={}))}),define(re[42],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Cn=P,e.$Dn=y,e.$En=E,e.$Fn=$,e.$Gn=g,e.$Hn=v,e.$In=p,e.$Jn=m,e.$Kn=f,e.$Ln=h,e.$Mn=w,e.$Nn=a;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function P(t,r=!1){let s=0;const n=t.length;let o="",c=0,b=16,L=0;function I(q){let ue=0,ee=0;for(;ue<q;){const ce=t.charCodeAt(s);if(ce>=48&&ce<=57)ee=ee*16+ce-48;else if(ce>=65&&ce<=70)ee=ee*16+ce-65+10;else if(ce>=97&&ce<=102)ee=ee*16+ce-97+10;else break;s++,ue++}return ue<q&&(ee=-1),ee}function j(q){s=q,o="",c=0,b=16,L=0}function O(){const q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&l(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&l(t.charCodeAt(s)))for(s++;s<t.length&&l(t.charCodeAt(s));)s++;else return L=3,t.substring(q,s);let ue=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&l(t.charCodeAt(s))){for(s++;s<t.length&&l(t.charCodeAt(s));)s++;ue=s}else L=3;return t.substring(q,ue)}function R(){let q="",ue=s;for(;;){if(s>=n){q+=t.substring(ue,s),L=2;break}const ee=t.charCodeAt(s);if(ee===34){q+=t.substring(ue,s),s++;break}if(ee===92){if(q+=t.substring(ue,s),s++,s>=n){L=2;break}switch(t.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const K=I(4);K>=0?q+=String.fromCharCode(K):L=4;break}default:L=5}ue=s;continue}if(ee>=0&&ee<=31)if(u(ee)){q+=t.substring(ue,s),L=2;break}else L=6;s++}return q}function W(){if(o="",L=0,c=s,s>=n)return c=n,b=17;let q=t.charCodeAt(s);if(k(q)){do s++,o+=String.fromCharCode(q),q=t.charCodeAt(s);while(k(q));return b=15}if(u(q))return s++,o+=String.fromCharCode(q),q===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),b=14;switch(q){case 123:return s++,b=1;case 125:return s++,b=2;case 91:return s++,b=3;case 93:return s++,b=4;case 58:return s++,b=6;case 44:return s++,b=5;case 34:return s++,o=R(),b=10;case 47:{const ue=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!u(t.charCodeAt(s));)s++;return o=t.substring(ue,s),b=12}if(t.charCodeAt(s+1)===42){s+=2;const ee=n-1;let ce=!1;for(;s<ee;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ce=!0;break}s++}return ce||(s++,L=1),o=t.substring(ue,s),b=13}return o+=String.fromCharCode(q),s++,b=16}case 45:if(o+=String.fromCharCode(q),s++,s===n||!l(t.charCodeAt(s)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),b=11;default:for(;s<n&&F(q);)s++,q=t.charCodeAt(s);if(c!==s){switch(o=t.substring(c,s),o){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return o+=String.fromCharCode(q),s++,b=16}}function F(q){if(k(q)||u(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let q;do q=W();while(q>=12&&q<=15);return q}return{setPosition:j,getPosition:()=>s,scan:r?T:W,getToken:()=>b,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>L}}function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var d;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(d||(d={}));function y(t,r){const s=[],n=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function L(I,j,O,R){c.value=I,c.offset=j,c.length=O,c.type=R,c.colonOffset=void 0,o=c}try{h(t,{onObjectBegin:(I,j)=>{if(r<=I)throw n;o=void 0,b=r>I,s.push("")},onObjectProperty:(I,j,O)=>{if(r<j||(L(I,j,O,"property"),s[s.length-1]=I,r<=j+O))throw n},onObjectEnd:(I,j)=>{if(r<=I)throw n;o=void 0,s.pop()},onArrayBegin:(I,j)=>{if(r<=I)throw n;o=void 0,s.push(0)},onArrayEnd:(I,j)=>{if(r<=I)throw n;o=void 0,s.pop()},onLiteralValue:(I,j,O)=>{if(r<j||(L(I,j,O,a(I)),r<=j+O))throw n},onSeparator:(I,j,O)=>{if(r<=j)throw n;if(I===":"&&o&&o.type==="property")o.colonOffset=j,b=!1,o=void 0;else if(I===","){const R=s[s.length-1];typeof R=="number"?s[s.length-1]=R+1:(b=!0,s[s.length-1]=""),o=void 0}}})}catch(I){if(I!==n)throw I}return{path:s,previousNode:o,isAtPropertyKey:b,matches:I=>{let j=0;for(let O=0;j<I.length&&O<s.length;O++)if(I[j]===s[O]||I[j]==="*")j++;else if(I[j]!=="**")return!1;return j===I.length}}}function E(t,r=[],s=A.DEFAULT){let n=null,o=[];const c=[];function b(I){Array.isArray(o)?o.push(I):n!==null&&(o[n]=I)}return h(t,{onObjectBegin:()=>{const I={};b(I),c.push(o),o=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const I=[];b(I),c.push(o),o=I,n=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:b,onError:(I,j,O)=>{r.push({error:I,offset:j,length:O})}},s),o[0]}function $(t,r=[],s=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function c(I){return n.children.push(I),I}h(t,{onObjectBegin:I=>{n=c({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,j,O)=>{n=c({type:"property",offset:j,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:j,length:O,parent:n})},onObjectEnd:(I,j)=>{n.length=I+j-n.offset,n=n.parent,o(I+j)},onArrayBegin:(I,j)=>{n=c({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,j)=>{n.length=I+j-n.offset,n=n.parent,o(I+j)},onLiteralValue:(I,j,O)=>{c({type:a(I),offset:j,length:O,parent:n,value:I}),o(j+O)},onSeparator:(I,j,O)=>{n.type==="property"&&(I===":"?n.colonOffset=j:I===","&&o(j))},onError:(I,j,O)=>{r.push({error:I,offset:j,length:O})}},s);const L=n.children[0];return L&&delete L.parent,L}function g(t,r){if(!t)return;let s=t;for(const n of r)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===n){s=c.children[1],o=!0;break}if(!o)return}else{const o=n;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}function v(t){if(!t.parent||!t.parent.children)return[];const r=v(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const r=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(r[s.children[0].value]=p(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function m(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}function f(t,r,s=!1){if(m(t,r,s)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const c=f(n[o],r,s);if(c)return c}return t}}function h(t,r,s=A.DEFAULT){const n=P(t,!1);function o(ae){return ae?()=>ae(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c(ae){return ae?G=>ae(G,n.getTokenOffset(),n.getTokenLength()):()=>!0}const b=o(r.onObjectBegin),L=c(r.onObjectProperty),I=o(r.onObjectEnd),j=o(r.onArrayBegin),O=o(r.onArrayEnd),R=c(r.onLiteralValue),W=c(r.onSeparator),F=o(r.onComment),T=c(r.onError),q=s&&s.disallowComments,ue=s&&s.allowTrailingComma;function ee(){for(;;){const ae=n.scan();switch(n.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:q||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(ae){case 12:case 13:q?ce(10):F();break;case 16:ce(1);break;case 15:case 14:break;default:return ae}}}function ce(ae,G=[],le=[]){if(T(ae),G.length+le.length>0){let Y=n.getToken();for(;Y!==17;){if(G.indexOf(Y)!==-1){ee();break}else if(le.indexOf(Y)!==-1)break;Y=ee()}}}function K(ae){const G=n.getTokenValue();return ae?R(G):L(G),ee(),!0}function X(){switch(n.getToken()){case 11:{let ae=0;try{ae=JSON.parse(n.getTokenValue()),typeof ae!="number"&&(ce(2),ae=0)}catch{ce(2)}R(ae);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return ee(),!0}function B(){return n.getToken()!==10?(ce(3,[],[2,5]),!1):(K(!1),n.getToken()===6?(W(":"),ee(),U()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function M(){b(),ee();let ae=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ae||ce(4,[],[]),W(","),ee(),n.getToken()===2&&ue)break}else ae&&ce(6,[],[]);B()||ce(4,[],[2,5]),ae=!0}return I(),n.getToken()!==2?ce(7,[2],[]):ee(),!0}function z(){j(),ee();let ae=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ae||ce(4,[],[]),W(","),ee(),n.getToken()===4&&ue)break}else ae&&ce(6,[],[]);U()||ce(4,[],[4,5]),ae=!0}return O(),n.getToken()!==4?ce(8,[4],[]):ee(),!0}function U(){switch(n.getToken()){case 3:return z();case 1:return M();case 10:return K(!0);default:return X()}}return ee(),n.getToken()===17?s.allowEmptyContent?!0:(ce(4,[],[]),!1):U()?(n.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function w(t,r){const s=P(t),n=[];let o,c=0,b;do switch(b=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:c!==b&&n.push(t.substring(c,b)),r!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,r)),c=s.getPosition();break}while(o!==17);return n.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(re[140],oe([0,1,42]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=D,e.$Pn=S,e.$Qn=k,e.$Rn=u;function D(l,d,y){let E,$,g,v,p;if(d){for(v=d.offset,p=v+d.length,g=v;g>0&&!u(l,g-1);)g--;let b=p;for(;b<l.length&&!u(l,b);)b++;$=l.substring(g,b),E=P($,y)}else $=l,E=0,g=0,v=0,p=l.length;const m=k(y,l);let f=!1,h=0,w;y.insertSpaces?w=A(" ",y.tabSize||4):w="	";const a=(0,i.$Cn)($,!1);let t=!1;function r(){return m+A(w,E+h)}function s(){let b=a.scan();for(f=!1;b===15||b===14;)f=f||b===14,b=a.scan();return t=b===16||a.getTokenError()!==0,b}const n=[];function o(b,L,I){!t&&L<p&&I>v&&l.substring(L,I)!==b&&n.push({offset:L,length:I-L,content:b})}let c=s();if(c!==17){const b=a.getTokenOffset()+g,L=A(w,E);o(L,g,b)}for(;c!==17;){let b=a.getTokenOffset()+a.getTokenLength()+g,L=s(),I="";for(;!f&&(L===12||L===13);){const O=a.getTokenOffset()+g;o(" ",b,O),b=a.getTokenOffset()+a.getTokenLength()+g,I=L===12?r():"",L=s()}if(L===2)c!==1&&(h--,I=r());else if(L===4)c!==3&&(h--,I=r());else{switch(c){case 3:case 1:h++,I=r();break;case 5:case 12:I=r();break;case 13:f?I=r():I=" ";break;case 6:I=" ";break;case 10:if(L===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:L===12||L===13?I=" ":L!==5&&L!==17&&(t=!0);break;case 16:t=!0;break}f&&(L===12||L===13)&&(I=r())}const j=a.getTokenOffset()+g;o(I,b,j),c=L}return n}function S(l,d){const y=JSON.stringify(l,void 0,d.insertSpaces?d.tabSize||4:"	");return d.eol!==void 0?y.replace(/\r\n|\r|\n/g,d.eol):y}function A(l,d){let y="";for(let E=0;E<d;E++)y+=l;return y}function P(l,d){let y=0,E=0;const $=d.tabSize||4;for(;y<l.length;){const g=l.charAt(y);if(g===" ")E++;else if(g==="	")E+=$;else break;y++}return Math.floor(E/$)}function k(l,d){for(let y=0;y<d.length;y++){const E=d.charAt(y);if(E==="\r")return y+1<d.length&&d.charAt(y+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return l&&l.eol||`
`}function u(l,d){return`\r
`.indexOf(l.charAt(d))!==-1}}),define(re[103],oe([0,1,42,140]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=S,e.$Tn=A,e.$Un=P,e.$Vn=k,e.$Wn=u;function S(l,d,y){return A(l,d,void 0,y)}function A(l,d,y,E,$){const g=d.slice(),v=[],p=(0,i.$Fn)(l,v);let m,f;for(;g.length>0&&(f=g.pop(),m=(0,i.$Gn)(p,g),m===void 0&&y!==void 0);)typeof f=="string"?y={[f]:y}:y=[y];if(m)if(m.type==="object"&&typeof f=="string"&&Array.isArray(m.children)){const h=(0,i.$Gn)(m,[f]);if(h!==void 0)if(y===void 0){if(!h.parent)throw new Error("Malformed AST");const w=m.children.indexOf(h.parent);let a,t=h.parent.offset+h.parent.length;if(w>0){const r=m.children[w-1];a=r.offset+r.length}else a=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return P(l,{offset:a,length:t-a,content:""},E)}else return P(l,{offset:h.offset,length:h.length,content:JSON.stringify(y)},E);else{if(y===void 0)return[];const w=`${JSON.stringify(f)}: ${JSON.stringify(y)}`,a=$?$(m.children.map(r=>r.children[0].value)):m.children.length;let t;if(a>0){const r=m.children[a-1];t={offset:r.offset+r.length,length:0,content:","+w}}else m.children.length===0?t={offset:m.offset+1,length:0,content:w}:t={offset:m.offset+1,length:0,content:w+","};return P(l,t,E)}}else if(m.type==="array"&&typeof f=="number"&&Array.isArray(m.children))if(y!==void 0){const h=`${JSON.stringify(y)}`;let w;if(m.children.length===0||f===0)w={offset:m.offset+1,length:0,content:m.children.length===0?h:h+","};else{const a=f===-1||f>m.children.length?m.children.length:f,t=m.children[a-1];w={offset:t.offset+t.length,length:0,content:","+h}}return P(l,w,E)}else{const h=f,w=m.children[h];let a;if(m.children.length===1)a={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===h){const t=m.children[h-1],r=t.offset+t.length,s=m.offset+m.length;a={offset:r,length:s-2-r,content:""}}else a={offset:w.offset,length:m.children[h+1].offset-w.offset,content:""};return P(l,a,E)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${m.type}`);else return y===void 0?[]:P(l,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(y)},E)}function P(l,d,y){let E=k(l,d),$=d.offset,g=d.offset+d.content.length;if(d.length===0||d.content.length===0){for(;$>0&&!(0,D.$Rn)(E,$-1);)$--;for(;g<E.length&&!(0,D.$Rn)(E,g);)g++}const v=(0,D.$On)(E,{offset:$,length:g-$},y);for(let m=v.length-1;m>=0;m--){const f=v[m];E=k(E,f),$=Math.min($,f.offset),g=Math.max(g,f.offset+f.length),g+=f.content.length-f.length}const p=l.length-(E.length-g)-$;return[{offset:$,length:p,content:E.substring($,g)}]}function k(l,d){return l.substring(0,d.offset)+d.content+l.substring(d.offset+d.length)}function u(l,d){const y=d.slice(0).sort(($,g)=>{const v=$.offset-g.offset;return v===0?$.length-g.length:v});let E=l.length;for(let $=y.length-1;$>=0;$--){const g=y[$];if(g.offset+g.length<=E)l=k(l,g);else throw new Error("Overlapping edit");E=g.offset}return l}}),define(re[62],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class i{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=i}),define(re[104],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(A){this.element=A,this.next=i.Undefined,this.prev=i.Undefined}}class D{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let A=this.a;for(;A!==i.Undefined;){const P=A.next;A.prev=i.Undefined,A.next=i.Undefined,A=P}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,P){const k=new i(A);if(this.a===i.Undefined)this.a=k,this.b=k;else if(P){const l=this.b;this.b=k,k.prev=l,l.next=k}else{const l=this.a;this.a=k,k.next=l,l.prev=k}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(k))}}shift(){if(this.a!==i.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==i.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==i.Undefined&&A.next!==i.Undefined){const P=A.prev;P.next=A.next,A.next.prev=P}else A.prev===i.Undefined&&A.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):A.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):A.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==i.Undefined;)yield A.element,A=A.next}}e.$5c=D}),define(re[31],oe([0,1]),function(J,e){"use strict";var i,D,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=A,e.$zc=P,e.$Ac=k,e.$Ic=f;function A(h,w,a){let t=h.get(w);return t===void 0&&(t=a,h.set(w,t)),t}function P(h){const w=[];return h.forEach((a,t)=>{w.push(`${t} => ${a}`)}),`Map(${h.size}) {${w.join(", ")}}`}function k(h){const w=[];return h.forEach(a=>{w.push(a)}),`Set(${h.size}) {${w.join(", ")}}`}class u{constructor(w,a){this.uri=w,this.value=a}}function l(h){return Array.isArray(h)}class d{static{this.c=w=>w.toString()}constructor(w,a){if(this[i]="ResourceMap",w instanceof d)this.d=new Map(w.d),this.e=a??d.c;else if(l(w)){this.d=new Map,this.e=a??d.c;for(const[t,r]of w)this.set(t,r)}else this.d=new Map,this.e=w??d.c}set(w,a){return this.d.set(this.e(w),new u(w,a)),this}get(w){return this.d.get(this.e(w))?.value}has(w){return this.d.has(this.e(w))}get size(){return this.d.size}clear(){this.d.clear()}delete(w){return this.d.delete(this.e(w))}forEach(w,a){typeof a<"u"&&(w=w.bind(a));for(const[t,r]of this.d)w(r.value,r.uri,this)}*values(){for(const w of this.d.values())yield w.value}*keys(){for(const w of this.d.values())yield w.uri}*entries(){for(const w of this.d.values())yield[w.uri,w.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,w]of this.d)yield[w.uri,w.value]}}e.$Bc=d;class y{constructor(w,a){this[D]="ResourceSet",!w||typeof w=="function"?this.c=new d(w):(this.c=new d(a),w.forEach(this.add,this))}get size(){return this.c.size}add(w){return this.c.set(w,w),this}clear(){this.c.clear()}delete(w){return this.c.delete(w)}forEach(w,a){this.c.forEach((t,r)=>w.call(a,r,r,this))}has(w){return this.c.has(w)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var E;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class ${constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(w){return this.c.has(w)}get(w,a=0){const t=this.c.get(w);if(t)return a!==0&&this.l(t,a),t.value}set(w,a,t=0){let r=this.c.get(w);if(r)r.value=a,t!==0&&this.l(r,t);else{switch(r={key:w,value:a,next:void 0,previous:void 0},t){case 0:this.j(r);break;case 1:this.i(r);break;case 2:this.j(r);break;default:this.j(r);break}this.c.set(w,r),this.f++}return this}delete(w){return!!this.remove(w)}remove(w){const a=this.c.get(w);if(a)return this.c.delete(w),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const w=this.d;return this.c.delete(w.key),this.k(w),this.f--,w.value}forEach(w,a){const t=this.g;let r=this.d;for(;r;){if(a?w.bind(a)(r.value,r.key,this):w(r.value,r.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const w=this,a=this.g;let t=this.d;const r={[Symbol.iterator](){return r},next(){if(w.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return r}values(){const w=this,a=this.g;let t=this.d;const r={[Symbol.iterator](){return r},next(){if(w.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return r}entries(){const w=this,a=this.g;let t=this.d;const r={[Symbol.iterator](){return r},next(){if(w.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return r}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(w){if(w>=this.size)return;if(w===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>w;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(w){if(!this.d&&!this.e)this.e=w;else if(this.d)w.next=this.d,this.d.previous=w;else throw new Error("Invalid list");this.d=w,this.g++}j(w){if(!this.d&&!this.e)this.d=w;else if(this.e)w.previous=this.e,this.e.next=w;else throw new Error("Invalid list");this.e=w,this.g++}k(w){if(w===this.d&&w===this.e)this.d=void 0,this.e=void 0;else if(w===this.d){if(!w.next)throw new Error("Invalid list");w.next.previous=void 0,this.d=w.next}else if(w===this.e){if(!w.previous)throw new Error("Invalid list");w.previous.next=void 0,this.e=w.previous}else{const a=w.next,t=w.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}w.next=void 0,w.previous=void 0,this.g++}l(w,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(w===this.d)return;const t=w.next,r=w.previous;w===this.e?(r.next=void 0,this.e=r):(t.previous=r,r.next=t),w.previous=void 0,w.next=this.d,this.d.previous=w,this.d=w,this.g++}else if(a===2){if(w===this.e)return;const t=w.next,r=w.previous;w===this.d?(t.previous=void 0,this.d=t):(t.previous=r,r.next=t),w.next=void 0,w.previous=this.e,this.e.next=w,this.e=w,this.g++}}}toJSON(){const w=[];return this.forEach((a,t)=>{w.push([t,a])}),w}fromJSON(w){this.clear();for(const[a,t]of w)this.set(a,t)}}e.$Dc=$;class g extends ${constructor(w,a=1){super(),this.m=w,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(w){this.m=w,this.o()}get ratio(){return this.n}set ratio(w){this.n=Math.min(Math.max(0,w),1),this.o()}get(w,a=2){return super.get(w,a)}peek(w){return super.get(w,0)}set(w,a){return super.set(w,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=g;class v{constructor(){this.c=new Map}add(w){return this.c.set(w,(this.c.get(w)||0)+1),this}delete(w){let a=this.c.get(w)||0;return a===0?!1:(a--,a===0?this.c.delete(w):this.c.set(w,a),!0)}has(w){return this.c.has(w)}}e.$Fc=v;class p{constructor(w){if(this.c=new Map,this.d=new Map,w)for(const[a,t]of w)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(w,a){this.c.set(w,a),this.d.set(a,w)}get(w){return this.c.get(w)}getKey(w){return this.d.get(w)}delete(w){const a=this.c.get(w);return a===void 0?!1:(this.c.delete(w),this.d.delete(a),!0)}forEach(w,a){this.c.forEach((t,r)=>{w.call(a,t,r,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=p;class m{constructor(){this.c=new Map}add(w,a){let t=this.c.get(w);t||(t=new Set,this.c.set(w,t)),t.add(a)}delete(w,a){const t=this.c.get(w);t&&(t.delete(a),t.size===0&&this.c.delete(w))}forEach(w,a){const t=this.c.get(w);t&&t.forEach(a)}get(w){const a=this.c.get(w);return a||new Set}}e.$Hc=m;function f(h,w){if(h===w)return!0;if(h.size!==w.size)return!1;for(const[a,t]of h)if(!w.has(a)||w.get(a)!==t)return!1;for(const[a]of w)if(!h.has(a))return!1;return!0}}),define(re[2],oe([0,1,22,137,31,86,71]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=d,e.$Lc=y,e.$Mc=E,e.$Nc=v,e.$Oc=p,e.$Pc=m,e.$Qc=f,e.$Rc=h,e.$Sc=w,e.$3c=I;const k=!1;let u=null;class l{constructor(){this.b=new Map}static{this.a=0}c(R){let W=this.b.get(R);return W||(W={parent:null,source:null,isSingleton:!1,value:R,idx:l.a++},this.b.set(R,W)),W}trackDisposable(R){const W=this.c(R);W.source||(W.source=new Error().stack)}setParent(R,W){const F=this.c(R);F.parent=W}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,W){const F=W.get(R);if(F)return F;const T=R.parent?this.f(this.c(R.parent),W):R;return W.set(R,T),T}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,R).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(R=10,W){let F;if(W)F=W;else{const ce=new Map,K=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,ce).isSingleton);if(K.length===0)return;const X=new Set(K.map(B=>B.value));if(F=K.filter(B=>!(B.parent&&X.has(B.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(ce){function K(B,M){for(;B.length>0&&M.some(z=>typeof z=="string"?z===B[0]:B[0].match(z));)B.shift()}const X=ce.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return K(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const q=new S.$Hc;for(const ce of F){const K=T(ce);for(let X=0;X<=K.length;X++)q.add(K.slice(0,X).join(`
`),ce)}F.sort((0,i.$7b)(ce=>ce.idx,i.$9b));let ue="",ee=0;for(const ce of F.slice(0,R)){ee++;const K=T(ce),X=[];for(let B=0;B<K.length;B++){let M=K[B];M=`(shared with ${q.get(K.slice(0,B+1).join(`
`)).size}/${F.length} leaks) at ${M}`;const U=q.get(K.slice(0,B).join(`
`)),ae=(0,D.$K)([...U].map(G=>T(G)[B]),G=>G);delete ae[K[B]];for(const[G,le]of Object.entries(ae))X.unshift(`    - stacktraces of ${le.length} other leaks continue with ${G}`);X.unshift(M)}ue+=`


==================== Leaking disposable ${ee}/${F.length}: ${ce.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return F.length>R&&(ue+=`


... and ${F.length-R} more leaking disposables

`),{leaks:F,details:ue}}}e.$Jc=l;function d(O){u=O}if(k){const O="__is_disposable_tracked__";d(new class{trackDisposable(R){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[O]||console.log(W)},3e3)}setParent(R,W){if(R&&R!==t.None)try{R[O]=!0}catch{}}markAsDisposed(R){if(R&&R!==t.None)try{R[O]=!0}catch{}}markAsSingleton(R){}})}function y(O){return u?.trackDisposable(O),O}function E(O){u?.markAsDisposed(O)}function $(O,R){u?.setParent(O,R)}function g(O,R){if(u)for(const W of O)u.setParent(W,R)}function v(O){return u?.markAsSingleton(O),O}function p(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function m(O){if(P.Iterable.is(O)){const R=[];for(const W of O)if(W)try{W.dispose()}catch(F){R.push(F)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function f(O){for(const R of O)p(R)&&R.dispose();return[]}function h(...O){const R=w(()=>m(O));return g(O,R),R}function w(O){const R=y({dispose:(0,A.$db)(()=>{E(R),O()})});return R}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(E(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return $(R,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),$(R,null))}}e.$Tc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,y(this),$(this.q,this)}dispose(){E(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}e.$Uc=t;class r{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&$(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&$(R,null),R}}e.$Vc=r;class s{constructor(R){this.a=new r,this.b=!1,this.a.value=R}get value(){return this.a.value}set value(R){this.b||R===this.a.value||(this.a.value=R)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=s;class n{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=n;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(R){let W=R;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,E(this))},this}}e.$Yc=o;class c{constructor(){this.a=new Map}acquire(R,...W){let F=this.a.get(R);F||(F={counter:0,object:this.b(R,...W)},this.a.set(R,F));const{object:T}=F,q=(0,A.$db)(()=>{--F.counter===0&&(this.c(R,F.object),this.a.delete(R))});return F.counter++,{object:T,dispose:q}}}e.$Zc=c;class b{constructor(R){this.a=R}async acquire(R,...W){const F=this.a.acquire(R,...W);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$1c=b;class L{constructor(R){this.object=R}dispose(){}}e.$2c=L;function I(O){const R=new a;try{O(R)}finally{R.dispose()}}class j{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,W,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(R)?.dispose(),this.a.set(R,W)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=j}),define(re[72],oe([0,1,31]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=void 0,e.$9l=S,e.$0l=P;const D=new i.$Ec(1e4);function S(l){return u(l,"NFC",D)}const A=new i.$Ec(1e4);function P(l){return u(l,"NFD",A)}const k=/[^\u0000-\u0080]/;function u(l,d,y){if(!l)return l;const E=y.get(l);if(E)return E;let $;return k.test(l)?$=l.normalize(d):$=l,y.set(l,$),$}e.$$l=function(){const l=/[\u0300-\u036f]/g;return function(d){return P(d).replace(l,"")}}()}),define(re[141],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=void 0,e.$wm=i,e.rot=D;function i(k,u,l){return Math.min(Math.max(k,u),l)}function D(k,u){return(u+k%u)%u}class S{constructor(){this.a=0}getNext(){return this.a++}}e.$ym=S;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$zm=A;class P{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const l=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Am=P}),function(){function J(S){const A=[];typeof S=="number"&&A.push("code/timeOrigin",S);function P(u){A.push(u,Date.now())}function k(){const u=[];for(let l=0;l<A.length;l+=2)u.push({name:A[l],startTime:A[l+1]});return u}return{mark:P,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const P of performance.getEntriesByType("mark"))A.push({name:P.name,startTime:Math.round(S+P.startTime)});return A}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function i(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=i(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var D in i)(typeof exports=="object"?exports:J)[D]=i[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function i(D){if(e[D])return e[D].exports;var S=e[D]={i:D,l:!1,exports:{}};return J[D].call(S.exports,S,S.exports,i),S.l=!0,S.exports}return i.m=J,i.c=e,i.d=function(D,S,A){i.o(D,S)||Object.defineProperty(D,S,{enumerable:!0,get:A})},i.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},i.t=function(D,S){if(1&S&&(D=i(D)),8&S||4&S&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(i.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&S&&typeof D!="string")for(var P in D)i.d(A,P,function(k){return D[k]}.bind(null,P));return A},i.n=function(D){var S=D&&D.__esModule?function(){return D.default}:function(){return D};return i.d(S,"a",S),S},i.o=function(D,S){return Object.prototype.hasOwnProperty.call(D,S)},i.p="",i(i.s=0)}([function(J,e,i){(function(D){var S;e=J.exports=le,S=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],u=e.src=[],l=0,d=l++;u[d]="0|[1-9]\\d*";var y=l++;u[y]="[0-9]+";var E=l++;u[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=l++;u[$]="("+u[d]+")\\.("+u[d]+")\\.("+u[d]+")";var g=l++;u[g]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var v=l++;u[v]="(?:"+u[d]+"|"+u[E]+")";var p=l++;u[p]="(?:"+u[y]+"|"+u[E]+")";var m=l++;u[m]="(?:-("+u[v]+"(?:\\."+u[v]+")*))";var f=l++;u[f]="(?:-?("+u[p]+"(?:\\."+u[p]+")*))";var h=l++;u[h]="[0-9A-Za-z-]+";var w=l++;u[w]="(?:\\+("+u[h]+"(?:\\."+u[h]+")*))";var a=l++,t="v?"+u[$]+u[m]+"?"+u[w]+"?";u[a]="^"+t+"$";var r="[v=\\s]*"+u[g]+u[f]+"?"+u[w]+"?",s=l++;u[s]="^"+r+"$";var n=l++;u[n]="((?:<|>)?=?)";var o=l++;u[o]=u[y]+"|x|X|\\*";var c=l++;u[c]=u[d]+"|x|X|\\*";var b=l++;u[b]="[v=\\s]*("+u[c]+")(?:\\.("+u[c]+")(?:\\.("+u[c]+")(?:"+u[m]+")?"+u[w]+"?)?)?";var L=l++;u[L]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[f]+")?"+u[w]+"?)?)?";var I=l++;u[I]="^"+u[n]+"\\s*"+u[b]+"$";var j=l++;u[j]="^"+u[n]+"\\s*"+u[L]+"$";var O=l++;u[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=l++;u[R]="(?:~>?)";var W=l++;u[W]="(\\s*)"+u[R]+"\\s+",k[W]=new RegExp(u[W],"g");var F=l++;u[F]="^"+u[R]+u[b]+"$";var T=l++;u[T]="^"+u[R]+u[L]+"$";var q=l++;u[q]="(?:\\^)";var ue=l++;u[ue]="(\\s*)"+u[q]+"\\s+",k[ue]=new RegExp(u[ue],"g");var ee=l++;u[ee]="^"+u[q]+u[b]+"$";var ce=l++;u[ce]="^"+u[q]+u[L]+"$";var K=l++;u[K]="^"+u[n]+"\\s*("+r+")$|^$";var X=l++;u[X]="^"+u[n]+"\\s*("+t+")$|^$";var B=l++;u[B]="(\\s*)"+u[n]+"\\s*("+r+"|"+u[b]+")",k[B]=new RegExp(u[B],"g");var M=l++;u[M]="^\\s*("+u[b]+")\\s+-\\s+("+u[b]+")\\s*$";var z=l++;u[z]="^\\s*("+u[L]+")\\s+-\\s+("+u[L]+")\\s*$";var U=l++;u[U]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)S(ae,u[ae]),k[ae]||(k[ae]=new RegExp(u[ae]));function G(Z,fe){if(Z instanceof le)return Z;if(typeof Z!="string"||Z.length>A||!(fe?k[s]:k[a]).test(Z))return null;try{return new le(Z,fe)}catch{return null}}function le(Z,fe){if(Z instanceof le){if(Z.loose===fe)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof le))return new le(Z,fe);S("SemVer",Z,fe),this.loose=fe;var ge=Z.trim().match(fe?k[s]:k[a]);if(!ge)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var Ae=+Le;if(Ae>=0&&Ae<P)return Ae}return Le}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=G,e.valid=function(Z,fe){var ge=G(Z,fe);return ge?ge.version:null},e.clean=function(Z,fe){var ge=G(Z.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=le,le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},le.prototype.toString=function(){return this.version},le.prototype.compare=function(Z){return S("SemVer.compare",this.version,this.loose,Z),Z instanceof le||(Z=new le(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},le.prototype.compareMain=function(Z){return Z instanceof le||(Z=new le(Z,this.loose)),C(this.major,Z.major)||C(this.minor,Z.minor)||C(this.patch,Z.patch)},le.prototype.comparePre=function(Z){if(Z instanceof le||(Z=new le(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Le=Z.prerelease[fe];if(S("prerelease compare",fe,ge,Le),ge===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(ge===void 0)return-1;if(ge!==Le)return C(ge,Le)}while(++fe)},le.prototype.inc=function(Z,fe){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,fe,ge,Le){typeof ge=="string"&&(Le=ge,ge=void 0);try{return new le(Z,ge).inc(fe,Le).version}catch{return null}},e.diff=function(Z,fe){if(Q(Z,fe))return null;var ge=G(Z),Le=G(fe);if(ge.prerelease.length||Le.prerelease.length){for(var Ae in ge)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&ge[Ae]!==Le[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in ge)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&ge[Ae]!==Le[Ae])return Ae},e.compareIdentifiers=C;var Y=/^[0-9]+$/;function C(Z,fe){var ge=Y.test(Z),Le=Y.test(fe);return ge&&Le&&(Z=+Z,fe=+fe),ge&&!Le?-1:Le&&!ge?1:Z<fe?-1:Z>fe?1:0}function N(Z,fe,ge){return new le(Z,ge).compare(new le(fe,ge))}function _(Z,fe,ge){return N(Z,fe,ge)>0}function ne(Z,fe,ge){return N(Z,fe,ge)<0}function Q(Z,fe,ge){return N(Z,fe,ge)===0}function x(Z,fe,ge){return N(Z,fe,ge)!==0}function V(Z,fe,ge){return N(Z,fe,ge)>=0}function H(Z,fe,ge){return N(Z,fe,ge)<=0}function se(Z,fe,ge,Le){var Ae;switch(fe){case"===":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Ae=Z===ge;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Ae=Z!==ge;break;case"":case"=":case"==":Ae=Q(Z,ge,Le);break;case"!=":Ae=x(Z,ge,Le);break;case">":Ae=_(Z,ge,Le);break;case">=":Ae=V(Z,ge,Le);break;case"<":Ae=ne(Z,ge,Le);break;case"<=":Ae=H(Z,ge,Le);break;default:throw new TypeError("Invalid operator: "+fe)}return Ae}function he(Z,fe){if(Z instanceof he){if(Z.loose===fe)return Z;Z=Z.value}if(!(this instanceof he))return new he(Z,fe);S("comparator",Z,fe),this.loose=fe,this.parse(Z),this.semver===me?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(Z,fe){return C(fe,Z)},e.major=function(Z,fe){return new le(Z,fe).major},e.minor=function(Z,fe){return new le(Z,fe).minor},e.patch=function(Z,fe){return new le(Z,fe).patch},e.compare=N,e.compareLoose=function(Z,fe){return N(Z,fe,!0)},e.rcompare=function(Z,fe,ge){return N(fe,Z,ge)},e.sort=function(Z,fe){return Z.sort(function(ge,Le){return e.compare(ge,Le,fe)})},e.rsort=function(Z,fe){return Z.sort(function(ge,Le){return e.rcompare(ge,Le,fe)})},e.gt=_,e.lt=ne,e.eq=Q,e.neq=x,e.gte=V,e.lte=H,e.cmp=se,e.Comparator=he;var me={};function $e(Z,fe){if(Z instanceof $e)return Z.loose===fe?Z:new $e(Z.raw,fe);if(Z instanceof he)return new $e(Z.value,fe);if(!(this instanceof $e))return new $e(Z,fe);if(this.loose=fe,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function ye(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function Ee(Z,fe,ge,Le,Ae,Be,Me,Fe,Ue,xe,Qe,Te,te){return((fe=ye(ge)?"":ye(Le)?">="+ge+".0.0":ye(Ae)?">="+ge+"."+Le+".0":">="+fe)+" "+(Fe=ye(Ue)?"":ye(xe)?"<"+(+Ue+1)+".0.0":ye(Qe)?"<"+Ue+"."+(+xe+1)+".0":Te?"<="+Ue+"."+xe+"."+Qe+"-"+Te:"<="+Fe)).trim()}function ke(Z,fe){for(var ge=0;ge<Z.length;ge++)if(!Z[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<Z.length;ge++)if(S(Z[ge].semver),Z[ge].semver!==me&&Z[ge].semver.prerelease.length>0){var Le=Z[ge].semver;if(Le.major===fe.major&&Le.minor===fe.minor&&Le.patch===fe.patch)return!0}return!1}return!0}function Oe(Z,fe,ge){try{fe=new $e(fe,ge)}catch{return!1}return fe.test(Z)}function we(Z,fe,ge,Le){var Ae,Be,Me,Fe,Ue;switch(Z=new le(Z,Le),fe=new $e(fe,Le),ge){case">":Ae=_,Be=H,Me=ne,Fe=">",Ue=">=";break;case"<":Ae=ne,Be=V,Me=_,Fe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(Z,fe,Le))return!1;for(var xe=0;xe<fe.set.length;++xe){var Qe=fe.set[xe],Te=null,te=null;if(Qe.forEach(function(de){de.semver===me&&(de=new he(">=0.0.0")),Te=Te||de,te=te||de,Ae(de.semver,Te.semver,Le)?Te=de:Me(de.semver,te.semver,Le)&&(te=de)}),Te.operator===Fe||Te.operator===Ue||(!te.operator||te.operator===Fe)&&Be(Z,te.semver)||te.operator===Ue&&Me(Z,te.semver))return!1}return!0}he.prototype.parse=function(Z){var fe=this.loose?k[K]:k[X],ge=Z.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+Z);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new le(ge[2],this.loose):this.semver=me},he.prototype.toString=function(){return this.value},he.prototype.test=function(Z){return S("Comparator.test",Z,this.loose),this.semver===me||(typeof Z=="string"&&(Z=new le(Z,this.loose)),se(Z,this.operator,this.semver,this.loose))},he.prototype.intersects=function(Z,fe){if(!(Z instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new $e(Z.value,fe),Oe(this.value,ge,fe);if(Z.operator==="")return ge=new $e(this.value,fe),Oe(Z.semver,ge,fe);var Le=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Be=this.semver.version===Z.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),Fe=se(this.semver,"<",Z.semver,fe)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Ue=se(this.semver,">",Z.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Le||Ae||Be&&Me||Fe||Ue},e.Range=$e,$e.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},$e.prototype.toString=function(){return this.range},$e.prototype.parseRange=function(Z){var fe=this.loose;Z=Z.trim(),S("range",Z,fe);var ge=fe?k[z]:k[M];Z=Z.replace(ge,Ee),S("hyphen replace",Z),Z=Z.replace(k[B],"$1$2$3"),S("comparator trim",Z,k[B]),Z=(Z=(Z=Z.replace(k[W],"$1~")).replace(k[ue],"$1^")).split(/\s+/).join(" ");var Le=fe?k[K]:k[X],Ae=Z.split(" ").map(function(Be){return function(Me,Fe){return S("comp",Me),Me=function(Ue,xe){return Ue.trim().split(/\s+/).map(function(Qe){return function(Te,te){S("caret",Te,te);var de=te?k[ce]:k[ee];return Te.replace(de,function(pe,ve,Pe,Re,ze){var Xe;return S("caret",Te,pe,ve,Pe,Re,ze),ye(ve)?Xe="":ye(Pe)?Xe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Re)?Xe=ve==="0"?">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+".0 <"+(+ve+1)+".0.0":ze?(S("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Xe=ve==="0"?Pe==="0"?">="+ve+"."+Pe+"."+Re+ze+" <"+ve+"."+Pe+"."+(+Re+1):">="+ve+"."+Pe+"."+Re+ze+" <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+"."+Re+ze+" <"+(+ve+1)+".0.0"):(S("no pr"),Xe=ve==="0"?Pe==="0"?">="+ve+"."+Pe+"."+Re+" <"+ve+"."+Pe+"."+(+Re+1):">="+ve+"."+Pe+"."+Re+" <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+"."+Re+" <"+(+ve+1)+".0.0"),S("caret return",Xe),Xe})}(Qe,xe)}).join(" ")}(Me,Fe),S("caret",Me),Me=function(Ue,xe){return Ue.trim().split(/\s+/).map(function(Qe){return function(Te,te){var de=te?k[T]:k[F];return Te.replace(de,function(pe,ve,Pe,Re,ze){var Xe;return S("tilde",Te,pe,ve,Pe,Re,ze),ye(ve)?Xe="":ye(Pe)?Xe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Re)?Xe=">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0":ze?(S("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Xe=">="+ve+"."+Pe+"."+Re+ze+" <"+ve+"."+(+Pe+1)+".0"):Xe=">="+ve+"."+Pe+"."+Re+" <"+ve+"."+(+Pe+1)+".0",S("tilde return",Xe),Xe})}(Qe,xe)}).join(" ")}(Me,Fe),S("tildes",Me),Me=function(Ue,xe){return S("replaceXRanges",Ue,xe),Ue.split(/\s+/).map(function(Qe){return function(Te,te){Te=Te.trim();var de=te?k[j]:k[I];return Te.replace(de,function(pe,ve,Pe,Re,ze,Xe){S("xRange",Te,pe,ve,Pe,Re,ze,Xe);var Ze=ye(Pe),Ye=Ze||ye(Re),Ke=Ye||ye(ze);return ve==="="&&Ke&&(ve=""),Ze?pe=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Ke?(Ye&&(Re=0),Ke&&(ze=0),ve===">"?(ve=">=",Ye?(Pe=+Pe+1,Re=0,ze=0):Ke&&(Re=+Re+1,ze=0)):ve==="<="&&(ve="<",Ye?Pe=+Pe+1:Re=+Re+1),pe=ve+Pe+"."+Re+"."+ze):Ye?pe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ke&&(pe=">="+Pe+"."+Re+".0 <"+Pe+"."+(+Re+1)+".0"),S("xRange return",pe),pe})}(Qe,xe)}).join(" ")}(Me,Fe),S("xrange",Me),Me=function(Ue,xe){return S("replaceStars",Ue,xe),Ue.trim().replace(k[U],"")}(Me,Fe),S("stars",Me),Me}(Be,fe)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Be){return!!Be.match(Le)})),Ae=Ae.map(function(Be){return new he(Be,fe)})},$e.prototype.intersects=function(Z,fe){if(!(Z instanceof $e))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Le){return Z.set.some(function(Ae){return Ae.every(function(Be){return Le.intersects(Be,fe)})})})})},e.toComparators=function(Z,fe){return new $e(Z,fe).set.map(function(ge){return ge.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},$e.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new le(Z,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],Z))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(Z,fe,ge){var Le=null,Ae=null;try{var Be=new $e(fe,ge)}catch{return null}return Z.forEach(function(Me){Be.test(Me)&&(Le&&Ae.compare(Me)!==-1||(Ae=new le(Le=Me,ge)))}),Le},e.minSatisfying=function(Z,fe,ge){var Le=null,Ae=null;try{var Be=new $e(fe,ge)}catch{return null}return Z.forEach(function(Me){Be.test(Me)&&(Le&&Ae.compare(Me)!==1||(Ae=new le(Le=Me,ge)))}),Le},e.validRange=function(Z,fe){try{return new $e(Z,fe).range||"*"}catch{return null}},e.ltr=function(Z,fe,ge){return we(Z,fe,"<",ge)},e.gtr=function(Z,fe,ge){return we(Z,fe,">",ge)},e.outside=we,e.prerelease=function(Z,fe){var ge=G(Z,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Z,fe,ge){return Z=new $e(Z,ge),fe=new $e(fe,ge),Z.intersects(fe)},e.coerce=function(Z){if(Z instanceof le)return Z;if(typeof Z!="string")return null;var fe=Z.match(k[O]);return fe==null?null:G((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,i(1))},function(J,e){var i,D,S=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function k(p){if(i===setTimeout)return setTimeout(p,0);if((i===A||!i)&&setTimeout)return i=setTimeout,setTimeout(p,0);try{return i(p,0)}catch{try{return i.call(null,p,0)}catch{return i.call(this,p,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:A}catch{i=A}try{D=typeof clearTimeout=="function"?clearTimeout:P}catch{D=P}})();var u,l=[],d=!1,y=-1;function E(){d&&u&&(d=!1,u.length?l=u.concat(l):y=-1,l.length&&$())}function $(){if(!d){var p=k(E);d=!0;for(var m=l.length;m;){for(u=l,l=[];++y<m;)u&&u[y].run();y=-1,m=l.length}u=null,d=!1,function(f){if(D===clearTimeout)return clearTimeout(f);if((D===P||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(f);try{D(f)}catch{try{return D.call(null,f)}catch{return D.call(this,f)}}}(p)}}function g(p,m){this.fun=p,this.array=m}function v(){}S.nextTick=function(p){var m=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)m[f-1]=arguments[f];l.push(new g(p,m)),l.length!==1||d||k($)},g.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=v,S.addListener=v,S.once=v,S.off=v,S.removeListener=v,S.removeAllListeners=v,S.emit=v,S.prependListener=v,S.prependOnceListener=v,S.listeners=function(p){return[]},S.binding=function(p){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(p){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(re[142],oe([0,1]),function(J,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=void 0;class D{constructor(k,u,l){this.level=k,this.key=u,this.value=l,this.forward=[]}}const S=void 0;class A{constructor(k,u=2**16){this.comparator=k,this[i]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,S,S)}get size(){return this.f}clear(){this.e=new D(this.c,S,S),this.f=0}has(k){return!!A.g(this,k,this.comparator)}get(k){return A.g(this,k,this.comparator)?.value}set(k,u){return A.h(this,k,u,this.comparator)&&(this.f+=1),this}delete(k){const u=A.k(this,k,this.comparator);return u&&(this.f-=1),u}forEach(k,u){let l=this.e.forward[0];for(;l;)k.call(u,l.value,l.key,this),l=l.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",u=this.e.forward[0];for(;u;)k+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return k}static g(k,u,l){let d=k.e;for(let y=k.d-1;y>=0;y--)for(;d.forward[y]&&l(d.forward[y].key,u)<0;)d=d.forward[y];if(d=d.forward[0],d&&l(d.key,u)===0)return d}static h(k,u,l,d){const y=[];let E=k.e;for(let $=k.d-1;$>=0;$--){for(;E.forward[$]&&d(E.forward[$].key,u)<0;)E=E.forward[$];y[$]=E}if(E=E.forward[0],E&&d(E.key,u)===0)return E.value=l,!1;{const $=A.j(k);if($>k.d){for(let g=k.d;g<$;g++)y[g]=k.e;k.d=$}E=new D($,u,l);for(let g=0;g<$;g++)E.forward[g]=y[g].forward[g],y[g].forward[g]=E;return!0}}static j(k,u=.5){let l=1;for(;Math.random()<u&&l<k.c;)l+=1;return l}static k(k,u,l){const d=[];let y=k.e;for(let E=k.d-1;E>=0;E--){for(;y.forward[E]&&l(y.forward[E].key,u)<0;)y=y.forward[E];d[E]=y}if(y=y.forward[0],!y||l(y.key,u)!==0)return!1;for(let E=0;E<k.d&&d[E].forward[E]===y;E++)d[E].forward[E]=y.forward[E];for(;k.d>0&&k.e.forward[k.d-1]===S;)k.d-=1;return!0}}e.$ts=A}),define(re[73],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(A){return new D(A)}constructor(A){this.c=i&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$0d=D}),define(re[3],oe([0,1,15,86,2,104,73]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$_d=e.Event=void 0,e.$ae=$;const k=!1,u=!1,l=!1;var d;(function(W){W.None=()=>S.$Uc.None;function F($e){if(l){const{onDidAddListener:ye}=$e,Ee=v.create();let ke=0;$e.onDidAddListener=()=>{++ke===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ee.print()),ye?.()}}}function T($e,ye){return U($e,()=>{},0,void 0,!0,void 0,ye)}W.defer=T;function q($e){return(ye,Ee=null,ke)=>{let Oe=!1,we;return we=$e(Z=>{if(!Oe)return we?we.dispose():Oe=!0,ye.call(Ee,Z)},null,ke),Oe&&we.dispose(),we}}W.once=q;function ue($e,ye,Ee){return M((ke,Oe=null,we)=>$e(Z=>ke.call(Oe,ye(Z)),null,we),Ee)}W.map=ue;function ee($e,ye,Ee){return M((ke,Oe=null,we)=>$e(Z=>{ye(Z),ke.call(Oe,Z)},null,we),Ee)}W.forEach=ee;function ce($e,ye,Ee){return M((ke,Oe=null,we)=>$e(Z=>ye(Z)&&ke.call(Oe,Z),null,we),Ee)}W.filter=ce;function K($e){return $e}W.signal=K;function X(...$e){return(ye,Ee=null,ke)=>{const Oe=(0,S.$Rc)(...$e.map(we=>we(Z=>ye.call(Ee,Z))));return z(Oe,ke)}}W.any=X;function B($e,ye,Ee,ke){let Oe=Ee;return ue($e,we=>(Oe=ye(Oe,we),Oe),ke)}W.reduce=B;function M($e,ye){let Ee;const ke={onWillAddFirstListener(){Ee=$e(Oe.fire,Oe)},onDidRemoveLastListener(){Ee?.dispose()}};ye||F(ke);const Oe=new a(ke);return ye?.add(Oe),Oe.event}function z($e,ye){return ye instanceof Array?ye.push($e):ye&&ye.add($e),$e}function U($e,ye,Ee=100,ke=!1,Oe=!1,we,Z){let fe,ge,Le,Ae=0,Be;const Me={leakWarningThreshold:we,onWillAddFirstListener(){fe=$e(Ue=>{Ae++,ge=ye(ge,Ue),ke&&!Le&&(Fe.fire(ge),ge=void 0),Be=()=>{const xe=ge;ge=void 0,Le=void 0,(!ke||Ae>1)&&Fe.fire(xe),Ae=0},typeof Ee=="number"?(clearTimeout(Le),Le=setTimeout(Be,Ee)):Le===void 0&&(Le=0,queueMicrotask(Be))})},onWillRemoveListener(){Oe&&Ae>0&&Be?.()},onDidRemoveLastListener(){Be=void 0,fe.dispose()}};Z||F(Me);const Fe=new a(Me);return Z?.add(Fe),Fe.event}W.debounce=U;function ae($e,ye=0,Ee){return W.debounce($e,(ke,Oe)=>ke?(ke.push(Oe),ke):[Oe],ye,void 0,!0,void 0,Ee)}W.accumulate=ae;function G($e,ye=(ke,Oe)=>ke===Oe,Ee){let ke=!0,Oe;return ce($e,we=>{const Z=ke||!ye(we,Oe);return ke=!1,Oe=we,Z},Ee)}W.latch=G;function le($e,ye,Ee){return[W.filter($e,ye,Ee),W.filter($e,ke=>!ye(ke),Ee)]}W.split=le;function Y($e,ye=!1,Ee=[],ke){let Oe=Ee.slice(),we=$e(ge=>{Oe?Oe.push(ge):fe.fire(ge)});ke&&ke.add(we);const Z=()=>{Oe?.forEach(ge=>fe.fire(ge)),Oe=null},fe=new a({onWillAddFirstListener(){we||(we=$e(ge=>fe.fire(ge)),ke&&ke.add(we))},onDidAddFirstListener(){Oe&&(ye?setTimeout(Z):Z())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return ke&&ke.add(fe),fe.event}W.buffer=Y;function C($e,ye){return(ke,Oe,we)=>{const Z=ye(new _);return $e(function(fe){const ge=Z.evaluate(fe);ge!==N&&ke.call(Oe,ge)},void 0,we)}}W.chain=C;const N=Symbol("HaltChainable");class _{constructor(){this.f=[]}map(ye){return this.f.push(ye),this}forEach(ye){return this.f.push(Ee=>(ye(Ee),Ee)),this}filter(ye){return this.f.push(Ee=>ye(Ee)?Ee:N),this}reduce(ye,Ee){let ke=Ee;return this.f.push(Oe=>(ke=ye(ke,Oe),ke)),this}latch(ye=(Ee,ke)=>Ee===ke){let Ee=!0,ke;return this.f.push(Oe=>{const we=Ee||!ye(Oe,ke);return Ee=!1,ke=Oe,we?Oe:N}),this}evaluate(ye){for(const Ee of this.f)if(ye=Ee(ye),ye===N)break;return ye}}function ne($e,ye,Ee=ke=>ke){const ke=(...fe)=>Z.fire(Ee(...fe)),Oe=()=>$e.on(ye,ke),we=()=>$e.removeListener(ye,ke),Z=new a({onWillAddFirstListener:Oe,onDidRemoveLastListener:we});return Z.event}W.fromNodeEventEmitter=ne;function Q($e,ye,Ee=ke=>ke){const ke=(...fe)=>Z.fire(Ee(...fe)),Oe=()=>$e.addEventListener(ye,ke),we=()=>$e.removeEventListener(ye,ke),Z=new a({onWillAddFirstListener:Oe,onDidRemoveLastListener:we});return Z.event}W.fromDOMEventEmitter=Q;function x($e){return new Promise(ye=>q($e)(ye))}W.toPromise=x;function V($e){const ye=new a;return $e.then(Ee=>{ye.fire(Ee)},()=>{ye.fire(void 0)}).finally(()=>{ye.dispose()}),ye.event}W.fromPromise=V;function H($e,ye,Ee){return ye(Ee),$e(ke=>ye(ke))}W.runAndSubscribe=H;class se{constructor(ye,Ee){this._observable=ye,this.f=0,this.g=!1;const ke={onWillAddFirstListener:()=>{ye.addObserver(this)},onDidRemoveLastListener:()=>{ye.removeObserver(this)}};Ee||F(ke),this.emitter=new a(ke),Ee&&Ee.add(this.emitter)}beginUpdate(ye){this.f++}handlePossibleChange(ye){}handleChange(ye,Ee){this.g=!0}endUpdate(ye){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function he($e,ye){return new se($e,ye).emitter.event}W.fromObservable=he;function me($e){return(ye,Ee,ke)=>{let Oe=0,we=!1;const Z={beginUpdate(){Oe++},endUpdate(){Oe--,Oe===0&&($e.reportChanges(),we&&(we=!1,ye.call(Ee)))},handlePossibleChange(){},handleChange(){we=!0}};$e.addObserver(Z),$e.reportChanges();const fe={dispose(){$e.removeObserver(Z)}};return ke instanceof S.$Tc?ke.add(fe):Array.isArray(ke)&&ke.push(fe),fe}}W.fromObservableLight=me})(d||(e.Event=d={}));class y{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${y.f++}`,y.all.add(this)}start(F){this.g=new P.$0d,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$_d=y;let E=-1;function $(W){const F=E;return E=W,{dispose(){E=F}}}class g{constructor(F,T=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=T,this.g=0}dispose(){this.f?.clear()}check(F,T){const q=this.threshold;if(q<=0||T<q)return;this.f||(this.f=new Map);const ue=this.f.get(F.value)||0;if(this.f.set(F.value,ue+1),this.g-=1,this.g<=0){this.g=q*.5;let ee,ce=0;for(const[K,X]of this.f)(!ee||ce<X)&&(ee=K,ce=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${ce}):`),console.warn(ee)}return()=>{const ee=this.f.get(F.value)||0;this.f.set(F.value,ee-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class m{constructor(F){this.value=F,this.id=p++}}const f=2,h=(W,F)=>{if(W instanceof m)F(W);else for(let T=0;T<W.length;T++){const q=W[T];q&&F(q)}},w=k?new FinalizationRegistry(W=>{typeof W=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(W))}):void 0;class a{constructor(F){this.w=0,this.f=F,this.g=E>0||this.f?.leakWarningThreshold?new g(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(u){const F=this.t;queueMicrotask(()=>{h(F,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,T,q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),S.$Uc.None;if(this.m)return S.$Uc.None;T&&(F=F.bind(T));const ue=new m(F);let ee,ce;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ue.stack=v.create(),ee=this.g.check(ue.stack,this.w+1)),u&&(ue.stack=ce??v.create()),this.t?this.t instanceof m?(this.u??=new r,this.t=[this.t,ue]):this.t.push(ue):(this.f?.onWillAddFirstListener?.(this),this.t=ue,this.f?.onDidAddFirstListener?.(this)),this.w++;const K=(0,S.$Sc)(()=>{w?.unregister(K),ee?.(),this.x(ue)});if(q instanceof S.$Tc?q.add(K):Array.isArray(q)&&q.push(K),w){const X=new Error().stack.split(`
`).slice(2).join(`
`).trim();w.register(K,X,K)}return K},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,q=T.indexOf(F);if(q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[q]=void 0;const ue=this.u.current===this;if(this.w*f<=T.length){let ee=0;for(let ce=0;ce<T.length;ce++)T[ce]?T[ee++]=T[ce]:ue&&(this.u.end--,ee<this.u.i&&this.u.i--);T.length=ee}}y(F,T){if(!F)return;const q=this.f?.onListenerError||i.$1;if(!q){F.value(T);return}try{F.value(T)}catch(ue){q(ue)}}z(F){const T=F.current.t;for(;F.i<F.end;)this.y(T[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,F);else{const T=this.u;T.enqueue(this,F,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$be=a;const t=()=>new r;e.$ce=t;class r{constructor(){this.i=-1,this.end=0}enqueue(F,T,q){this.i=0,this.end=q,this.current=F,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends a{async fireAsync(F,T,q){if(this.t)for(this.h||(this.h=new A.$5c),h(this.t,ue=>this.h.push([ue.value,F]));this.h.size>0&&!T.isCancellationRequested;){const[ue,ee]=this.h.shift(),ce=[],K={...ee,token:T,waitUntil:X=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");q&&(X=q(X,ue)),ce.push(X)}};try{ue(K)}catch(X){(0,i.$1)(X);continue}Object.freeze(ce),await Promise.allSettled(ce).then(X=>{for(const B of X)B.status==="rejected"&&(0,i.$1)(B.reason)})}}}e.$de=s;class n extends a{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new A.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ee=n;class o extends n{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$fe=o;class c extends a{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$ge=c;class b{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const T={event:F,listener:null};this.h.push(T),this.g&&this.m(T);const q=()=>{this.g&&this.o(T);const ue=this.h.indexOf(T);this.h.splice(ue,1)};return(0,S.$Sc)((0,D.$db)(q))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(T=>this.f.fire(T))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$he=b;class L{constructor(F,T,q,ue){this.f=new S.$Tc;const ee=this.f.add(new b),ce=this.f.add(new S.$4c);function K(X){ce.set(X,ee.add(ue(X)))}for(const X of F)K(X);this.f.add(T(X=>{K(X)})),this.f.add(q(X=>{ce.deleteAndDispose(X)})),this.event=ee.event}dispose(){this.f.dispose()}}e.$ie=L;class I{constructor(){this.f=[]}wrapEvent(F){return(T,q,ue)=>F(ee=>{const ce=this.f[this.f.length-1];ce?ce.push(()=>T.call(q,ee)):T.call(q,ee)},void 0,ue)}bufferEvents(F){const T=[];this.f.push(T);const q=F();return this.f.pop(),T.forEach(ue=>ue()),q}}e.$je=I;class j{constructor(){this.f=!1,this.g=d.None,this.h=S.$Uc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ke=j;class O{static const(F){return new R(F)}constructor(F){this.g=F,this.f=new a,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$le=O;class R{constructor(F){this.value=F,this.onDidChange=d.None}}}),define(re[23],oe([0,1,3]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.CancellationToken=void 0;const D=Object.freeze(function(k,u){const l=setTimeout(k.bind(u),0);return{dispose(){clearTimeout(l)}}});var S;(function(k){function u(l){return l===k.None||l===k.Cancelled||l instanceof A?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}k.isCancellationToken=u,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(S||(e.CancellationToken=S={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new i.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class P{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=S.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=S.None}}e.$me=P}),define(re[143],oe([0,1,23]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1e=e.$Ze=e.$Xe=void 0,e.$Ye=S;class D{constructor(u){this.b=u,this.a=null}get(){if(this.a)return this.a;const u=new i.$me,l=this.b(u.token);return this.a={promise:l,dispose:()=>{this.a=null,u.cancel(),u.dispose()}},this.a}}e.$Xe=D;function S(k){return k}class A{constructor(u,l){this.a=void 0,this.b=void 0,typeof u=="function"?(this.c=u,this.d=S):(this.c=l,this.d=u.getCacheKey)}get(u){const l=this.d(u);return this.b!==l&&(this.b=l,this.a=this.c(u)),this.a}}e.$Ze=A;class P{get cachedValues(){return this.a}constructor(u,l){this.a=new Map,this.b=new Map,typeof u=="function"?(this.c=u,this.d=S):(this.c=l,this.d=u.getCacheKey)}get(u){const l=this.d(u);if(this.b.has(l))return this.b.get(l);const d=this.c(u);return this.a.set(u,d),this.b.set(l,d),d}}e.$1e=P}),define(re[63],oe([0,1,15,2]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=S,e.$oe=A,e.$pe=P,e.$qe=k,e.$re=l,e.$se=d,e.$te=y,e.$ue=E,e.$ve=$,e.$we=g,e.$xe=v,e.$ye=p,e.$ze=m,e.$Ae=f,e.$Be=h;function S(w){const a=w;return a?typeof a.read=="function":!1}function A(w){const a=w;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function P(w){const a=w;return a?A(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function k(w,a){return new u(w,a)}class u{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,i.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(t);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(w,a){const t=[];let r;for(;(r=w.read())!==null;)t.push(r);return a(t)}function d(w,a,t){const r=[];let s;for(;(s=w.read())!==null&&r.length<t;)r.push(s);return s===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return w.read()}}}function y(w,a){return new Promise((t,r)=>{const s=[];E(w,{onData:n=>{a&&s.push(n)},onError:n=>{a?r(n):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}function E(w,a,t){w.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),w.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),w.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}function $(w,a){return new Promise((t,r)=>{const s=new D.$Tc,n=[],o=L=>{if(n.push(L),n.length>a)return s.dispose(),w.pause(),t({stream:w,buffer:n,ended:!1})},c=L=>(s.dispose(),r(L)),b=()=>(s.dispose(),t({stream:w,buffer:n,ended:!0}));s.add((0,D.$Sc)(()=>w.removeListener("error",c))),w.on("error",c),s.add((0,D.$Sc)(()=>w.removeListener("end",b))),w.on("end",b),s.add((0,D.$Sc)(()=>w.removeListener("data",o))),w.on("data",o)})}function g(w,a){const t=k(a);return t.end(w),t}function v(){const w=k(()=>{throw new Error("not supported")});return w.end(),w}function p(w){let a=!1;return{read:()=>a?null:(a=!0,w)}}function m(w,a,t){const r=k(t);return E(w,{onData:s=>r.write(a.data(s)),onError:s=>r.error(a.error?a.error(s):s),onEnd:()=>r.end()}),r}function f(w,a,t){let r=!1;return{read:()=>{const s=a.read();return r?s:(r=!0,s!==null?t([w,s]):w)}}}function h(w,a,t){let r=!1;const s=k(t);return E(a,{onData:n=>r?s.write(n):(r=!0,s.write(t([w,n]))),onError:n=>s.error(n),onEnd:()=>{r||(r=!0,s.write(w)),s.end()}}),s}}),define(re[17],oe([0,1,62,63]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=l,e.$Ee=d,e.$Fe=y,e.$Ge=E,e.$He=$,e.$Ie=g,e.$Je=v,e.$Ke=p,e.$Le=m,e.$Me=f,e.$Ne=h,e.$Oe=w,e.$Pe=a,e.$Qe=t,e.$Re=r,e.$Se=s,e.$Te=n,e.$Ue=o,e.$Ve=c,e.$We=I;const S=typeof Buffer<"u",A=new i.$V(()=>new Uint8Array(256));let P,k;class u{static alloc(O){return S?new u(Buffer.allocUnsafe(O)):new u(new Uint8Array(O))}static wrap(O){return S&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new u(O)}static fromString(O,R){return!(R?.dontUseNodeBuffer||!1)&&S?new u(Buffer.from(O)):(P||(P=new TextEncoder),new u(P.encode(O)))}static fromByteArray(O){const R=u.alloc(O.length);for(let W=0,F=O.length;W<F;W++)R.buffer[W]=O[W];return R}static concat(O,R){if(typeof R>"u"){R=0;for(let T=0,q=O.length;T<q;T++)R+=O[T].byteLength}const W=u.alloc(R);let F=0;for(let T=0,q=O.length;T<q;T++){const ue=O[T];W.set(ue,F),F+=ue.byteLength}return W}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=u.alloc(this.byteLength);return O.set(this),O}toString(){return S?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(O,R){return new u(this.buffer.subarray(O,R))}set(O,R){if(O instanceof u)this.buffer.set(O.buffer,R);else if(O instanceof Uint8Array)this.buffer.set(O,R);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),R);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return E(this.buffer,O)}writeUInt32BE(O,R){$(this.buffer,O,R)}readUInt32LE(O){return g(this.buffer,O)}writeUInt32LE(O,R){v(this.buffer,O,R)}readUInt8(O){return p(this.buffer,O)}writeUInt8(O,R){m(this.buffer,O,R)}indexOf(O,R=0){return l(this.buffer,O instanceof u?O.buffer:O,R)}}e.$Ce=u;function l(j,O,R=0){const W=O.byteLength,F=j.byteLength;if(W===0)return 0;if(W===1)return j.indexOf(O[0]);if(W>F-R)return-1;const T=A.value;T.fill(O.length);for(let ce=0;ce<O.length;ce++)T[O[ce]]=O.length-ce-1;let q=R+O.length-1,ue=q,ee=-1;for(;q<F;)if(j[q]===O[ue]){if(ue===0){ee=q;break}q--,ue--}else q+=Math.max(O.length-ue,T[j[q]]),ue=O.length-1;return ee}function d(j,O){return j[O+0]<<0>>>0|j[O+1]<<8>>>0}function y(j,O,R){j[R+0]=O&255,O=O>>>8,j[R+1]=O&255}function E(j,O){return j[O]*2**24+j[O+1]*2**16+j[O+2]*2**8+j[O+3]}function $(j,O,R){j[R+3]=O,O=O>>>8,j[R+2]=O,O=O>>>8,j[R+1]=O,O=O>>>8,j[R]=O}function g(j,O){return j[O+0]<<0>>>0|j[O+1]<<8>>>0|j[O+2]<<16>>>0|j[O+3]<<24>>>0}function v(j,O,R){j[R+0]=O&255,O=O>>>8,j[R+1]=O&255,O=O>>>8,j[R+2]=O&255,O=O>>>8,j[R+3]=O&255}function p(j,O){return j[O]}function m(j,O,R){j[R]=O}function f(j){return D.$re(j,O=>u.concat(O))}function h(j){return D.$ye(j)}function w(j){return D.$te(j,O=>u.concat(O))}async function a(j){return j.ended?u.concat(j.buffer):u.concat([...j.buffer,await w(j.stream)])}function t(j){return D.$we(j,O=>u.concat(O))}function r(j){return D.$ze(j,{data:O=>typeof O=="string"?u.fromString(O):u.wrap(O)},O=>u.concat(O))}function s(j){return D.$qe(O=>u.concat(O),j)}function n(j,O){return D.$Ae(j,O,R=>u.concat(R))}function o(j,O){return D.$Be(j,O,R=>u.concat(R))}function c(j){let O=0,R=0,W=0;const F=new Uint8Array(Math.floor(j.length/4*3)),T=ue=>{switch(R){case 3:F[W++]=O|ue,R=0;break;case 2:F[W++]=O|ue>>>2,O=ue<<6,R=3;break;case 1:F[W++]=O|ue>>>4,O=ue<<4,R=2;break;default:O=ue<<2,R=1}};for(let ue=0;ue<j.length;ue++){const ee=j.charCodeAt(ue);if(ee>=65&&ee<=90)T(ee-65);else if(ee>=97&&ee<=122)T(ee-97+26);else if(ee>=48&&ee<=57)T(ee-48+52);else if(ee===43||ee===45)T(62);else if(ee===47||ee===95)T(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${j[ue]}`)}}const q=W;for(;R>0;)T(0);return u.wrap(F).slice(0,q)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:j},O=!0,R=!1){const W=R?L:b;let F="";const T=j.byteLength%3;let q=0;for(;q<j.byteLength-T;q+=3){const ue=j[q+0],ee=j[q+1],ce=j[q+2];F+=W[ue>>>2],F+=W[(ue<<4|ee>>>4)&63],F+=W[(ee<<2|ce>>>6)&63],F+=W[ce&63]}if(T===1){const ue=j[q+0];F+=W[ue>>>2],F+=W[ue<<4&63],O&&(F+="==")}else if(T===2){const ue=j[q+0],ee=j[q+1];F+=W[ue>>>2],F+=W[(ue<<4|ee>>>4)&63],F+=W[ee<<2&63],O&&(F+="=")}return F}}),define(re[25],oe([0,1,143,62]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.GraphemeBreakType=e.$Rf=e.$Kf=e.$Df=e.$Cf=void 0,e.$4e=S,e.$5e=P,e.$6e=u,e.$7e=l,e.$8e=d,e.$9e=y,e.$0e=E,e.$$e=$,e.$_e=g,e.$af=v,e.$bf=p,e.$cf=m,e.$df=f,e.$ef=h,e.$ff=w,e.$gf=a,e.$hf=t,e.$if=r,e.$jf=s,e.$kf=n,e.$lf=o,e.$mf=c,e.$nf=b,e.$of=L,e.$pf=I,e.$qf=j,e.$rf=O,e.$sf=R,e.$tf=W,e.$uf=F,e.$vf=T,e.$wf=q,e.$xf=ue,e.$yf=ee,e.$zf=ce,e.$Af=K,e.$Bf=X,e.$Ef=U,e.$Ff=ae,e.$Gf=G,e.$Hf=le,e.$If=N,e.$Jf=ne,e.$Lf=Q,e.$Mf=x,e.$Nf=V,e.$Of=H,e.$Pf=he,e.$Qf=me,e.$Sf=$e,e.$Tf=ye,e.$Uf=Ee,e.$Vf=ke,e.$Wf=Oe,e.$Xf=we,e.$Yf=Z,e.$Zf=fe,e.$1f=Me;function S(te){return!te||typeof te!="string"?!0:te.trim().length===0}const A=/{(\d+)}/g;function P(te,...de){return de.length===0?te:te.replace(A,function(pe,ve){const Pe=parseInt(ve,10);return isNaN(Pe)||Pe<0||Pe>=de.length?pe:de[Pe]})}const k=/{([^}]+)}/g;function u(te,de){return Object.keys(de).length===0?te:te.replace(k,(pe,ve)=>de[ve]??pe)}function l(te){return te.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function d(te){return te.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function y(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function E(te,de){let pe=0;const ve=de.charCodeAt(0);for(let Pe=te.length-1;Pe>=0;Pe--)te.charCodeAt(Pe)===ve&&pe++;return pe}function $(te,de,pe="\u2026"){return te.length<=de?te:`${te.substr(0,de)}${pe}`}function g(te,de,pe="\u2026"){if(te.length<=de)return te;const ve=Math.ceil(de/2)-pe.length/2,Pe=Math.floor(de/2)-pe.length/2;return`${te.substr(0,ve)}${pe}${te.substr(te.length-Pe)}`}function v(te,de=" "){const pe=p(te,de);return m(pe,de)}function p(te,de){if(!te||!de)return te;const pe=de.length;if(pe===0||te.length===0)return te;let ve=0;for(;te.indexOf(de,ve)===ve;)ve=ve+pe;return te.substring(ve)}function m(te,de){if(!te||!de)return te;const pe=de.length,ve=te.length;if(pe===0||ve===0)return te;let Pe=ve,Re=-1;for(;Re=te.lastIndexOf(de,Pe-1),!(Re===-1||Re+pe!==Pe);){if(Re===0)return"";Pe=Re}return te.substring(0,Pe)}function f(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function h(te){return te.replace(/\*/g,"")}function w(te,de,pe={}){if(!te)throw new Error("Cannot create regex from empty string");de||(te=y(te)),pe.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let ve="";return pe.global&&(ve+="g"),pe.matchCase||(ve+="i"),pe.multiline&&(ve+="m"),pe.unicode&&(ve+="u"),new RegExp(te,ve)}function a(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function t(te){return te.split(/\r\n|\r|\n/)}function r(te){const de=[],pe=te.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil(pe.length/2);ve++)de.push(pe[2*ve]+(pe[2*ve+1]??""));return de}function s(te){for(let de=0,pe=te.length;de<pe;de++){const ve=te.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}function n(te,de=0,pe=te.length){for(let ve=de;ve<pe;ve++){const Pe=te.charCodeAt(ve);if(Pe!==32&&Pe!==9)return te.substring(de,ve)}return te.substring(de,pe)}function o(te,de=te.length-1){for(let pe=de;pe>=0;pe--){const ve=te.charCodeAt(pe);if(ve!==32&&ve!==9)return pe}return-1}function c(te,de,pe){const ve=[];let Pe=0;for(const Re of te.matchAll(de)){if(ve.push(te.slice(Pe,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Pe=Re.index+Re[0].length,ve.push(pe(Re[0],...Re.slice(1),Re.index,te,Re.groups))}return ve.push(te.slice(Pe)),Promise.all(ve).then(Re=>Re.join(""))}function b(te,de){return te<de?-1:te>de?1:0}function L(te,de,pe=0,ve=te.length,Pe=0,Re=de.length){for(;pe<ve&&Pe<Re;pe++,Pe++){const Ze=te.charCodeAt(pe),Ye=de.charCodeAt(Pe);if(Ze<Ye)return-1;if(Ze>Ye)return 1}const ze=ve-pe,Xe=Re-Pe;return ze<Xe?-1:ze>Xe?1:0}function I(te,de){return j(te,de,0,te.length,0,de.length)}function j(te,de,pe=0,ve=te.length,Pe=0,Re=de.length){for(;pe<ve&&Pe<Re;pe++,Pe++){let Ze=te.charCodeAt(pe),Ye=de.charCodeAt(Pe);if(Ze===Ye)continue;if(Ze>=128||Ye>=128)return L(te.toLowerCase(),de.toLowerCase(),pe,ve,Pe,Re);R(Ze)&&(Ze-=32),R(Ye)&&(Ye-=32);const Ke=Ze-Ye;if(Ke!==0)return Ke}const ze=ve-pe,Xe=Re-Pe;return ze<Xe?-1:ze>Xe?1:0}function O(te){return te>=48&&te<=57}function R(te){return te>=97&&te<=122}function W(te){return te>=65&&te<=90}function F(te,de){return te.length===de.length&&j(te,de)===0}function T(te,de){const pe=de.length;return de.length>te.length?!1:j(te,de,0,pe)===0}function q(te,de){const pe=Math.min(te.length,de.length);let ve;for(ve=0;ve<pe;ve++)if(te.charCodeAt(ve)!==de.charCodeAt(ve))return ve;return pe}function ue(te,de){const pe=Math.min(te.length,de.length);let ve;const Pe=te.length-1,Re=de.length-1;for(ve=0;ve<pe;ve++)if(te.charCodeAt(Pe-ve)!==de.charCodeAt(Re-ve))return ve;return pe}function ee(te){return 55296<=te&&te<=56319}function ce(te){return 56320<=te&&te<=57343}function K(te,de){return(te-55296<<10)+(de-56320)+65536}function X(te,de,pe){const ve=te.charCodeAt(pe);if(ee(ve)&&pe+1<de){const Pe=te.charCodeAt(pe+1);if(ce(Pe))return K(ve,Pe)}return ve}function B(te,de){const pe=te.charCodeAt(de-1);if(ce(pe)&&de>1){const ve=te.charCodeAt(de-2);if(ee(ve))return K(ve,pe)}return pe}class M{get offset(){return this.e}constructor(de,pe=0){this.c=de,this.d=de.length,this.e=pe}setOffset(de){this.e=de}prevCodePoint(){const de=B(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=X(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Cf=M;class z{get offset(){return this.c.offset}constructor(de,pe=0){this.c=new M(de,pe)}nextGraphemeLength(){const de=Ae.getInstance(),pe=this.c,ve=pe.offset;let Pe=de.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Re=pe.offset,ze=de.getGraphemeBreakType(pe.nextCodePoint());if(ge(Pe,ze)){pe.setOffset(Re);break}Pe=ze}return pe.offset-ve}prevGraphemeLength(){const de=Ae.getInstance(),pe=this.c,ve=pe.offset;let Pe=de.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Re=pe.offset,ze=de.getGraphemeBreakType(pe.prevCodePoint());if(ge(ze,Pe)){pe.setOffset(Re);break}Pe=ze}return ve-pe.offset}eol(){return this.c.eol()}}e.$Df=z;function U(te,de){return new z(te,de).nextGraphemeLength()}function ae(te,de){return new z(te,de).prevGraphemeLength()}function G(te,de){de>0&&ce(te.charCodeAt(de))&&de--;const pe=de+U(te,de);return[pe-ae(te,pe),pe]}function le(te){const de=new z(te);let pe=0;for(;!de.eol();)pe++,de.nextGraphemeLength();return pe}let Y;function C(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(te){return Y||(Y=C()),Y.test(te)}const _=/^[\t\n\r\x20-\x7E]*$/;function ne(te){return _.test(te)}e.$Kf=/[\u2028\u2029]/;function Q(te){return e.$Kf.test(te)}function x(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function V(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function H(te,de,pe=""){const ve=te.trimStart();if(ve.length<de)return ve;const Pe=/\b/g;let Re=0;for(;Pe.test(ve)&&!(ve.length-Pe.lastIndex<de);)Re=Pe.lastIndex,Pe.lastIndex+=1;return Re===0?ve:pe+ve.substring(Re).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*he(te){let de=0;for(const pe of te.matchAll(se))de!==pe.index&&(yield{isCode:!1,str:te.substring(de,pe.index)}),yield{isCode:!0,str:pe[0]},de=pe.index+pe[0].length;de!==te.length&&(yield{isCode:!1,str:te.substring(de)})}function me(te){return te&&(te=te.replace(se,"")),te}e.$Rf="\uFEFF";function $e(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}function ye(te){return $e(te)?te.substr(1):te}function Ee(te,de){if(!te||!de||te.length<de.length)return!1;const pe=de.length,ve=te.toLowerCase();let Pe=0,Re=-1;for(;Pe<pe;){const ze=ve.indexOf(de[Pe],Re+1);if(ze<0)return!1;Re=ze,Pe++}return!0}function ke(te,de=!1){return te?(de&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function Oe(te){return te.charAt(0).toUpperCase()+te.slice(1)}function we(te,de=1){if(de===0)return"";let pe=-1;do pe=te.indexOf(`
`,pe+1),de--;while(de>0&&pe>=0);return pe===-1?te:(te[pe-1]==="\r"&&pe--,te.substr(0,pe))}function Z(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}function fe(te){return Ae.getInstance().getGraphemeBreakType(te)}function ge(te,de){return te===0?de!==5&&de!==7:te===2&&de===3?!1:te===4||te===2||te===3||de===4||de===2||de===3?!0:!(te===8&&(de===8||de===9||de===11||de===12)||(te===11||te===9)&&(de===9||de===10)||(te===12||te===10)&&de===10||de===5||de===13||de===7||te===1||te===13&&de===14||te===6&&de===6)}var Le;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=Be()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const pe=this.d,ve=pe.length/3;let Pe=1;for(;Pe<=ve;)if(de<pe[3*Pe])Pe=2*Pe;else if(de>pe[3*Pe+1])Pe=2*Pe+1;else return pe[3*Pe+2];return 0}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(te,de){if(te===0)return 0;const pe=Fe(te,de);if(pe!==void 0)return pe;const ve=new M(de,te);return ve.prevCodePoint(),ve.offset}function Fe(te,de){const pe=new M(de,te);let ve=pe.prevCodePoint();for(;Ue(ve)||ve===65039||ve===8419;){if(pe.offset===0)return;ve=pe.prevCodePoint()}if(!V(ve))return;let Pe=pe.offset;return Pe>0&&pe.prevCodePoint()===8205&&(Pe=pe.offset),Pe}function Ue(te){return 127995<=te&&te<=127999}var xe;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={})),e.$2f="\xA0";class Qe{static{this.c=new D.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Ze({getCacheKey:JSON.stringify},de=>{function pe(Ke){const st=new Map;for(let it=0;it<Ke.length;it+=2)st.set(Ke[it],Ke[it+1]);return st}function ve(Ke,st){const it=new Map(Ke);for(const[ot,at]of st)it.set(ot,at);return it}function Pe(Ke,st){if(!Ke)return st;const it=new Map;for(const[ot,at]of Ke)st.has(ot)&&it.set(ot,at);return it}const Re=this.c.value;let ze=de.filter(Ke=>!Ke.startsWith("_")&&Ke in Re);ze.length===0&&(ze=["_default"]);let Xe;for(const Ke of ze){const st=pe(Re[Ke]);Xe=Pe(Xe,st)}const Ze=pe(Re._common),Ye=ve(Ze,Xe);return new Qe(Ye)})}static getInstance(de){return Qe.d.get(Array.from(de))}static{this.e=new D.$V(()=>Object.keys(Qe.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Qe.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$3f=Qe;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(de){return Te.e().has(de)}static get codePoints(){return Te.e()}}e.$4f=Te}),define(re[46],oe([0,1,25]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$jj=void 0,e.$fj=D,e.$gj=S,e.$hj=A,e.$ij=k,e.$kj=v;function D(m){return S(m,0)}function S(m,f){switch(typeof m){case"object":return m===null?A(349,f):Array.isArray(m)?u(m,f):l(m,f);case"string":return k(m,f);case"boolean":return P(m,f);case"number":return A(m,f);case"undefined":return A(937,f);default:return A(617,f)}}function A(m,f){return(f<<5)-f+m|0}function P(m,f){return A(m?433:863,f)}function k(m,f){f=A(149417,f);for(let h=0,w=m.length;h<w;h++)f=A(m.charCodeAt(h),f);return f}function u(m,f){return f=A(104579,f),m.reduce((h,w)=>S(w,h),f)}function l(m,f){return f=A(181387,f),Object.keys(m).sort().reduce((h,w)=>(h=k(w,h),S(m[w],h)),f)}class d{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=S(f,this.g),this.g}}e.$jj=d;var y;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function E(m,f,h=32){const w=h-f,a=~((1<<w)-1);return(m<<f|(a&m)>>>w)>>>0}function $(m,f=0,h=m.byteLength,w=0){for(let a=0;a<h;a++)m[f+a]=w}function g(m,f,h="0"){for(;m.length<f;)m=h+m;return m}function v(m,f=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(h=>h.toString(16).padStart(2,"0")).join(""):g((m>>>0).toString(16),f/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const h=f.length;if(h===0)return;const w=this.p;let a=this.r,t=this.u,r,s;for(t!==0?(r=t,s=-1,t=0):(r=f.charCodeAt(0),s=0);;){let n=r;if(i.$yf(r))if(s+1<h){const o=f.charCodeAt(s+1);i.$zf(o)?(s++,n=i.$Af(r,o)):n=65533}else{t=r;break}else i.$zf(r)&&(n=65533);if(a=this.w(w,a,n),s++,s<h)r=f.charCodeAt(s);else break}this.r=a,this.u=t}w(f,h,w){return w<128?f[h++]=w:w<2048?(f[h++]=192|(w&1984)>>>6,f[h++]=128|(w&63)>>>0):w<65536?(f[h++]=224|(w&61440)>>>12,f[h++]=128|(w&4032)>>>6,f[h++]=128|(w&63)>>>0):(f[h++]=240|(w&1835008)>>>18,f[h++]=128|(w&258048)>>>12,f[h++]=128|(w&4032)>>>6,f[h++]=128|(w&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=p.g,h=this.q;for(let b=0;b<64;b+=4)f.setUint32(b,h.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)f.setUint32(b,E(f.getUint32(b-12,!1)^f.getUint32(b-32,!1)^f.getUint32(b-56,!1)^f.getUint32(b-64,!1),1),!1);let w=this.h,a=this.l,t=this.m,r=this.n,s=this.o,n,o,c;for(let b=0;b<80;b++)b<20?(n=a&t|~a&r,o=1518500249):b<40?(n=a^t^r,o=1859775393):b<60?(n=a&t|a&r|t&r,o=2400959708):(n=a^t^r,o=3395469782),c=E(w,5)+n+s+o+f.getUint32(b*4,!1)&4294967295,s=r,r=t,t=E(a,30),a=w,w=c;this.h=this.h+w&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+s&4294967295}}e.$lj=p}),define(re[74],oe([0,1,25]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(D||(D={})),function(S){const A="error",P="warning",k="warn",u="info",l="ignore";function d(E){return E?i.$uf(A,E)?S.Error:i.$uf(P,E)||i.$uf(k,E)?S.Warning:i.$uf(u,E)?S.Info:S.Ignore:S.Ignore}S.fromValue=d;function y(E){switch(E){case S.Error:return A;case S.Warning:return P;case S.Info:return u;default:return l}}S.toString=y}(D||(D={})),e.default=D}),define(re[144],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(re[59],oe([0,1,22,25]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=void 0;class S{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const g=$.charCodeAt(0),v=this.b.charCodeAt(this.c);return g-v}value(){return this.b[this.c]}}e.$ti=S;class A{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,D.$of)($,this.b,0,$.length,this.c,this.d):(0,D.$qf)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ui=A;class P{constructor($=!0,g=!0){this.f=$,this.g=g}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let g=$.length-1;g>=0;g--,this.c--){const v=this.b.charCodeAt(g);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,D.$of)($,this.b,0,$.length,this.d,this.e):(0,D.$qf)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$vi=P;var k;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(k||(k={}));class u{constructor($,g){this.f=$,this.g=g,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,D.$pf)($,this.c.scheme);if(this.d[this.e]===2)return(0,D.$pf)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,D.$nf)($,this.c.query);if(this.d[this.e]===5)return(0,D.$nf)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$wi=u;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(d||(d={}));class y{static forUris($=()=>!1,g=()=>!1){return new y(new u($,g))}static forPaths($=!1){return new y(new P(void 0,!$))}static forStrings(){return new y(new S)}static forConfigKeys(){return new y(new A)}constructor($){this.b=$}clear(){this.c=void 0}fill($,g){if(g){const v=g.slice(0);(0,i.$Xb)(v);for(const p of v)this.set(p,$)}else{const v=$.slice(0);(0,i.$Xb)(v);for(const p of v)this.set(p[0],p[1])}}set($,g){const v=this.b.reset($);let p;this.c||(this.c=new l,this.c.segment=v.value());const m=[];for(p=this.c;;){const h=v.cmp(p.segment);if(h>0)p.left||(p.left=new l,p.left.segment=v.value()),m.push([-1,p]),p=p.left;else if(h<0)p.right||(p.right=new l,p.right.segment=v.value()),m.push([1,p]),p=p.right;else if(v.hasNext())v.next(),p.mid||(p.mid=new l,p.mid.segment=v.value()),m.push([0,p]),p=p.mid;else break}const f=p.value;p.value=g,p.key=$;for(let h=m.length-1;h>=0;h--){const w=m[h][1];w.updateHeight();const a=w.balanceFactor();if(a<-1||a>1){const t=m[h][0],r=m[h+1][0];if(t===1&&r===1)m[h][1]=w.rotateLeft();else if(t===-1&&r===-1)m[h][1]=w.rotateRight();else if(t===1&&r===-1)w.right=m[h+1][1]=m[h+1][1].rotateRight(),m[h][1]=w.rotateLeft();else if(t===-1&&r===1)w.left=m[h+1][1]=m[h+1][1].rotateLeft(),m[h][1]=w.rotateRight();else throw new Error;if(h>0)switch(m[h-1][0]){case-1:m[h-1][1].left=m[h][1];break;case 1:m[h-1][1].right=m[h][1];break;case 0:m[h-1][1].mid=m[h][1];break}else this.c=m[0][1]}}return f}get($){return this.d($)?.value}d($){const g=this.b.reset($);let v=this.c;for(;v;){const p=g.cmp(v.segment);if(p>0)v=v.left;else if(p<0)v=v.right;else if(g.hasNext())g.next(),v=v.mid;else break}return v}has($){const g=this.d($);return!(g?.value===void 0&&g?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,g){const v=this.b.reset($),p=[];let m=this.c;for(;m;){const f=v.cmp(m.segment);if(f>0)p.push([-1,m]),m=m.left;else if(f<0)p.push([1,m]),m=m.right;else if(v.hasNext())v.next(),p.push([0,m]),m=m.mid;else break}if(m){if(g?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const f=this.f(m.right);if(f.key){const{key:h,value:w,segment:a}=f;this.e(f.key,!1),m.key=h,m.value=w,m.segment=a}}else{const f=m.left??m.right;if(p.length>0){const[h,w]=p[p.length-1];switch(h){case-1:w.left=f;break;case 0:w.mid=f;break;case 1:w.right=f;break}}else this.c=f}for(let f=p.length-1;f>=0;f--){const h=p[f][1];h.updateHeight();const w=h.balanceFactor();if(w>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),p[f][1]=h.rotateLeft()):w<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),p[f][1]=h.rotateRight()),f>0)switch(p[f-1][0]){case-1:p[f-1][1].left=p[f][1];break;case 1:p[f-1][1].right=p[f][1];break;case 0:p[f-1][1].mid=p[f][1];break}else this.c=p[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const g=this.b.reset($);let v=this.c,p;for(;v;){const m=g.cmp(v.segment);if(m>0)v=v.left;else if(m<0)v=v.right;else if(g.hasNext())g.next(),p=v.value||p,v=v.mid;else break}return v&&v.value||p}findSuperstr($){return this.g($,!1)}g($,g){const v=this.b.reset($);let p=this.c;for(;p;){const m=v.cmp(p.segment);if(m>0)p=p.left;else if(m<0)p=p.right;else if(v.hasNext())v.next(),p=p.mid;else return p.mid?this.h(p.mid):g?p.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[g,v]of this)$(v,g)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const g=[];return this.j($,g),g[Symbol.iterator]()}j($,g){$&&($.left&&this.j($.left,g),$.value&&g.push([$.key,$.value]),$.mid&&this.j($.mid,g),$.right&&this.j($.right,g))}_isBalanced(){const $=g=>{if(!g)return!0;const v=g.balanceFactor();return v<-1||v>1?!1:$(g.left)&&$(g.right)};return $(this.c)}}e.$xi=y}),define(re[12],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=i,e.$6f=D,e.$7f=S,e.$8f=A,e.$9f=P,e.$0f=k,e.$$f=u,e.$_f=l,e.$ag=d,e.$bg=y,e.$cg=E,e.$dg=$,e.$eg=g,e.$fg=p,e.$gg=m,e.$hg=f,e.$ig=h,e.$jg=w;function i(a){return typeof a=="string"}function D(a){return Array.isArray(a)&&a.every(t=>i(t))}function S(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function A(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function P(a){return typeof a=="number"&&!isNaN(a)}function k(a){return!!a&&typeof a[Symbol.iterator]=="function"}function u(a){return a===!0||a===!1}function l(a){return typeof a>"u"}function d(a){return!y(a)}function y(a){return l(a)||a===null}function E(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function $(a){if(y(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function g(...a){const t=[];for(let r=0;r<a.length;r++){const s=a[r];if(y(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}const v=Object.prototype.hasOwnProperty;function p(a){if(!S(a))return!1;for(const t in a)if(v.call(a,t))return!1;return!0}function m(a){return typeof a=="function"}function f(...a){return a.length>0&&a.every(m)}function h(a,t){const r=Math.min(a.length,t.length);for(let s=0;s<r;s++)w(a[s],t[s])}function w(a,t){if(i(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(a instanceof t)return}catch{}if(!y(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(re[105],oe([0,1,12]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=S,e.$Mj=A;const D=Object.create(null);function S(P,k){if((0,i.$5f)(k)){const u=D[k];if(u===void 0)throw new Error(`${P} references an unknown codicon: ${k}`);k=u}return D[P]=k,{id:P}}function A(){return D}}),define(re[145],oe([0,1,105]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=void 0,e.$Nj={add:(0,i.$Lj)("add",6e4),plus:(0,i.$Lj)("plus",6e4),gistNew:(0,i.$Lj)("gist-new",6e4),repoCreate:(0,i.$Lj)("repo-create",6e4),lightbulb:(0,i.$Lj)("lightbulb",60001),lightBulb:(0,i.$Lj)("light-bulb",60001),repo:(0,i.$Lj)("repo",60002),repoDelete:(0,i.$Lj)("repo-delete",60002),gistFork:(0,i.$Lj)("gist-fork",60003),repoForked:(0,i.$Lj)("repo-forked",60003),gitPullRequest:(0,i.$Lj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Lj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Lj)("record-keys",60005),keyboard:(0,i.$Lj)("keyboard",60005),tag:(0,i.$Lj)("tag",60006),gitPullRequestLabel:(0,i.$Lj)("git-pull-request-label",60006),tagAdd:(0,i.$Lj)("tag-add",60006),tagRemove:(0,i.$Lj)("tag-remove",60006),person:(0,i.$Lj)("person",60007),personFollow:(0,i.$Lj)("person-follow",60007),personOutline:(0,i.$Lj)("person-outline",60007),personFilled:(0,i.$Lj)("person-filled",60007),gitBranch:(0,i.$Lj)("git-branch",60008),gitBranchCreate:(0,i.$Lj)("git-branch-create",60008),gitBranchDelete:(0,i.$Lj)("git-branch-delete",60008),sourceControl:(0,i.$Lj)("source-control",60008),mirror:(0,i.$Lj)("mirror",60009),mirrorPublic:(0,i.$Lj)("mirror-public",60009),star:(0,i.$Lj)("star",60010),starAdd:(0,i.$Lj)("star-add",60010),starDelete:(0,i.$Lj)("star-delete",60010),starEmpty:(0,i.$Lj)("star-empty",60010),comment:(0,i.$Lj)("comment",60011),commentAdd:(0,i.$Lj)("comment-add",60011),alert:(0,i.$Lj)("alert",60012),warning:(0,i.$Lj)("warning",60012),search:(0,i.$Lj)("search",60013),searchSave:(0,i.$Lj)("search-save",60013),logOut:(0,i.$Lj)("log-out",60014),signOut:(0,i.$Lj)("sign-out",60014),logIn:(0,i.$Lj)("log-in",60015),signIn:(0,i.$Lj)("sign-in",60015),eye:(0,i.$Lj)("eye",60016),eyeUnwatch:(0,i.$Lj)("eye-unwatch",60016),eyeWatch:(0,i.$Lj)("eye-watch",60016),circleFilled:(0,i.$Lj)("circle-filled",60017),primitiveDot:(0,i.$Lj)("primitive-dot",60017),closeDirty:(0,i.$Lj)("close-dirty",60017),debugBreakpoint:(0,i.$Lj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Lj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Lj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Lj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Lj)("primitive-square",60018),edit:(0,i.$Lj)("edit",60019),pencil:(0,i.$Lj)("pencil",60019),info:(0,i.$Lj)("info",60020),issueOpened:(0,i.$Lj)("issue-opened",60020),gistPrivate:(0,i.$Lj)("gist-private",60021),gitForkPrivate:(0,i.$Lj)("git-fork-private",60021),lock:(0,i.$Lj)("lock",60021),mirrorPrivate:(0,i.$Lj)("mirror-private",60021),close:(0,i.$Lj)("close",60022),removeClose:(0,i.$Lj)("remove-close",60022),x:(0,i.$Lj)("x",60022),repoSync:(0,i.$Lj)("repo-sync",60023),sync:(0,i.$Lj)("sync",60023),clone:(0,i.$Lj)("clone",60024),desktopDownload:(0,i.$Lj)("desktop-download",60024),beaker:(0,i.$Lj)("beaker",60025),microscope:(0,i.$Lj)("microscope",60025),vm:(0,i.$Lj)("vm",60026),deviceDesktop:(0,i.$Lj)("device-desktop",60026),file:(0,i.$Lj)("file",60027),fileText:(0,i.$Lj)("file-text",60027),more:(0,i.$Lj)("more",60028),ellipsis:(0,i.$Lj)("ellipsis",60028),kebabHorizontal:(0,i.$Lj)("kebab-horizontal",60028),mailReply:(0,i.$Lj)("mail-reply",60029),reply:(0,i.$Lj)("reply",60029),organization:(0,i.$Lj)("organization",60030),organizationFilled:(0,i.$Lj)("organization-filled",60030),organizationOutline:(0,i.$Lj)("organization-outline",60030),newFile:(0,i.$Lj)("new-file",60031),fileAdd:(0,i.$Lj)("file-add",60031),newFolder:(0,i.$Lj)("new-folder",60032),fileDirectoryCreate:(0,i.$Lj)("file-directory-create",60032),trash:(0,i.$Lj)("trash",60033),trashcan:(0,i.$Lj)("trashcan",60033),history:(0,i.$Lj)("history",60034),clock:(0,i.$Lj)("clock",60034),folder:(0,i.$Lj)("folder",60035),fileDirectory:(0,i.$Lj)("file-directory",60035),symbolFolder:(0,i.$Lj)("symbol-folder",60035),logoGithub:(0,i.$Lj)("logo-github",60036),markGithub:(0,i.$Lj)("mark-github",60036),github:(0,i.$Lj)("github",60036),terminal:(0,i.$Lj)("terminal",60037),console:(0,i.$Lj)("console",60037),repl:(0,i.$Lj)("repl",60037),zap:(0,i.$Lj)("zap",60038),symbolEvent:(0,i.$Lj)("symbol-event",60038),error:(0,i.$Lj)("error",60039),stop:(0,i.$Lj)("stop",60039),variable:(0,i.$Lj)("variable",60040),symbolVariable:(0,i.$Lj)("symbol-variable",60040),array:(0,i.$Lj)("array",60042),symbolArray:(0,i.$Lj)("symbol-array",60042),symbolModule:(0,i.$Lj)("symbol-module",60043),symbolPackage:(0,i.$Lj)("symbol-package",60043),symbolNamespace:(0,i.$Lj)("symbol-namespace",60043),symbolObject:(0,i.$Lj)("symbol-object",60043),symbolMethod:(0,i.$Lj)("symbol-method",60044),symbolFunction:(0,i.$Lj)("symbol-function",60044),symbolConstructor:(0,i.$Lj)("symbol-constructor",60044),symbolBoolean:(0,i.$Lj)("symbol-boolean",60047),symbolNull:(0,i.$Lj)("symbol-null",60047),symbolNumeric:(0,i.$Lj)("symbol-numeric",60048),symbolNumber:(0,i.$Lj)("symbol-number",60048),symbolStructure:(0,i.$Lj)("symbol-structure",60049),symbolStruct:(0,i.$Lj)("symbol-struct",60049),symbolParameter:(0,i.$Lj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Lj)("symbol-type-parameter",60050),symbolKey:(0,i.$Lj)("symbol-key",60051),symbolText:(0,i.$Lj)("symbol-text",60051),symbolReference:(0,i.$Lj)("symbol-reference",60052),goToFile:(0,i.$Lj)("go-to-file",60052),symbolEnum:(0,i.$Lj)("symbol-enum",60053),symbolValue:(0,i.$Lj)("symbol-value",60053),symbolRuler:(0,i.$Lj)("symbol-ruler",60054),symbolUnit:(0,i.$Lj)("symbol-unit",60054),activateBreakpoints:(0,i.$Lj)("activate-breakpoints",60055),archive:(0,i.$Lj)("archive",60056),arrowBoth:(0,i.$Lj)("arrow-both",60057),arrowDown:(0,i.$Lj)("arrow-down",60058),arrowLeft:(0,i.$Lj)("arrow-left",60059),arrowRight:(0,i.$Lj)("arrow-right",60060),arrowSmallDown:(0,i.$Lj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Lj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Lj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Lj)("arrow-small-up",60064),arrowUp:(0,i.$Lj)("arrow-up",60065),bell:(0,i.$Lj)("bell",60066),bold:(0,i.$Lj)("bold",60067),book:(0,i.$Lj)("book",60068),bookmark:(0,i.$Lj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Lj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Lj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Lj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Lj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Lj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Lj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Lj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Lj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Lj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Lj)("briefcase",60076),broadcast:(0,i.$Lj)("broadcast",60077),browser:(0,i.$Lj)("browser",60078),bug:(0,i.$Lj)("bug",60079),calendar:(0,i.$Lj)("calendar",60080),caseSensitive:(0,i.$Lj)("case-sensitive",60081),check:(0,i.$Lj)("check",60082),checklist:(0,i.$Lj)("checklist",60083),chevronDown:(0,i.$Lj)("chevron-down",60084),chevronLeft:(0,i.$Lj)("chevron-left",60085),chevronRight:(0,i.$Lj)("chevron-right",60086),chevronUp:(0,i.$Lj)("chevron-up",60087),chromeClose:(0,i.$Lj)("chrome-close",60088),chromeMaximize:(0,i.$Lj)("chrome-maximize",60089),chromeMinimize:(0,i.$Lj)("chrome-minimize",60090),chromeRestore:(0,i.$Lj)("chrome-restore",60091),circleOutline:(0,i.$Lj)("circle-outline",60092),circle:(0,i.$Lj)("circle",60092),debugBreakpointUnverified:(0,i.$Lj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Lj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Lj)("circle-slash",60093),circuitBoard:(0,i.$Lj)("circuit-board",60094),clearAll:(0,i.$Lj)("clear-all",60095),clippy:(0,i.$Lj)("clippy",60096),closeAll:(0,i.$Lj)("close-all",60097),cloudDownload:(0,i.$Lj)("cloud-download",60098),cloudUpload:(0,i.$Lj)("cloud-upload",60099),code:(0,i.$Lj)("code",60100),collapseAll:(0,i.$Lj)("collapse-all",60101),colorMode:(0,i.$Lj)("color-mode",60102),commentDiscussion:(0,i.$Lj)("comment-discussion",60103),creditCard:(0,i.$Lj)("credit-card",60105),dash:(0,i.$Lj)("dash",60108),dashboard:(0,i.$Lj)("dashboard",60109),database:(0,i.$Lj)("database",60110),debugContinue:(0,i.$Lj)("debug-continue",60111),debugDisconnect:(0,i.$Lj)("debug-disconnect",60112),debugPause:(0,i.$Lj)("debug-pause",60113),debugRestart:(0,i.$Lj)("debug-restart",60114),debugStart:(0,i.$Lj)("debug-start",60115),debugStepInto:(0,i.$Lj)("debug-step-into",60116),debugStepOut:(0,i.$Lj)("debug-step-out",60117),debugStepOver:(0,i.$Lj)("debug-step-over",60118),debugStop:(0,i.$Lj)("debug-stop",60119),debug:(0,i.$Lj)("debug",60120),deviceCameraVideo:(0,i.$Lj)("device-camera-video",60121),deviceCamera:(0,i.$Lj)("device-camera",60122),deviceMobile:(0,i.$Lj)("device-mobile",60123),diffAdded:(0,i.$Lj)("diff-added",60124),diffIgnored:(0,i.$Lj)("diff-ignored",60125),diffModified:(0,i.$Lj)("diff-modified",60126),diffRemoved:(0,i.$Lj)("diff-removed",60127),diffRenamed:(0,i.$Lj)("diff-renamed",60128),diff:(0,i.$Lj)("diff",60129),diffSidebyside:(0,i.$Lj)("diff-sidebyside",60129),discard:(0,i.$Lj)("discard",60130),editorLayout:(0,i.$Lj)("editor-layout",60131),emptyWindow:(0,i.$Lj)("empty-window",60132),exclude:(0,i.$Lj)("exclude",60133),extensions:(0,i.$Lj)("extensions",60134),eyeClosed:(0,i.$Lj)("eye-closed",60135),fileBinary:(0,i.$Lj)("file-binary",60136),fileCode:(0,i.$Lj)("file-code",60137),fileMedia:(0,i.$Lj)("file-media",60138),filePdf:(0,i.$Lj)("file-pdf",60139),fileSubmodule:(0,i.$Lj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Lj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Lj)("file-symlink-file",60142),fileZip:(0,i.$Lj)("file-zip",60143),files:(0,i.$Lj)("files",60144),filter:(0,i.$Lj)("filter",60145),flame:(0,i.$Lj)("flame",60146),foldDown:(0,i.$Lj)("fold-down",60147),foldUp:(0,i.$Lj)("fold-up",60148),fold:(0,i.$Lj)("fold",60149),folderActive:(0,i.$Lj)("folder-active",60150),folderOpened:(0,i.$Lj)("folder-opened",60151),gear:(0,i.$Lj)("gear",60152),gift:(0,i.$Lj)("gift",60153),gistSecret:(0,i.$Lj)("gist-secret",60154),gist:(0,i.$Lj)("gist",60155),gitCommit:(0,i.$Lj)("git-commit",60156),gitCompare:(0,i.$Lj)("git-compare",60157),compareChanges:(0,i.$Lj)("compare-changes",60157),gitMerge:(0,i.$Lj)("git-merge",60158),githubAction:(0,i.$Lj)("github-action",60159),githubAlt:(0,i.$Lj)("github-alt",60160),globe:(0,i.$Lj)("globe",60161),grabber:(0,i.$Lj)("grabber",60162),graph:(0,i.$Lj)("graph",60163),gripper:(0,i.$Lj)("gripper",60164),heart:(0,i.$Lj)("heart",60165),home:(0,i.$Lj)("home",60166),horizontalRule:(0,i.$Lj)("horizontal-rule",60167),hubot:(0,i.$Lj)("hubot",60168),inbox:(0,i.$Lj)("inbox",60169),issueReopened:(0,i.$Lj)("issue-reopened",60171),issues:(0,i.$Lj)("issues",60172),italic:(0,i.$Lj)("italic",60173),jersey:(0,i.$Lj)("jersey",60174),json:(0,i.$Lj)("json",60175),kebabVertical:(0,i.$Lj)("kebab-vertical",60176),key:(0,i.$Lj)("key",60177),law:(0,i.$Lj)("law",60178),lightbulbAutofix:(0,i.$Lj)("lightbulb-autofix",60179),linkExternal:(0,i.$Lj)("link-external",60180),link:(0,i.$Lj)("link",60181),listOrdered:(0,i.$Lj)("list-ordered",60182),listUnordered:(0,i.$Lj)("list-unordered",60183),liveShare:(0,i.$Lj)("live-share",60184),loading:(0,i.$Lj)("loading",60185),location:(0,i.$Lj)("location",60186),mailRead:(0,i.$Lj)("mail-read",60187),mail:(0,i.$Lj)("mail",60188),markdown:(0,i.$Lj)("markdown",60189),megaphone:(0,i.$Lj)("megaphone",60190),mention:(0,i.$Lj)("mention",60191),milestone:(0,i.$Lj)("milestone",60192),gitPullRequestMilestone:(0,i.$Lj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Lj)("mortar-board",60193),move:(0,i.$Lj)("move",60194),multipleWindows:(0,i.$Lj)("multiple-windows",60195),mute:(0,i.$Lj)("mute",60196),noNewline:(0,i.$Lj)("no-newline",60197),note:(0,i.$Lj)("note",60198),octoface:(0,i.$Lj)("octoface",60199),openPreview:(0,i.$Lj)("open-preview",60200),package:(0,i.$Lj)("package",60201),paintcan:(0,i.$Lj)("paintcan",60202),pin:(0,i.$Lj)("pin",60203),play:(0,i.$Lj)("play",60204),run:(0,i.$Lj)("run",60204),plug:(0,i.$Lj)("plug",60205),preserveCase:(0,i.$Lj)("preserve-case",60206),preview:(0,i.$Lj)("preview",60207),project:(0,i.$Lj)("project",60208),pulse:(0,i.$Lj)("pulse",60209),question:(0,i.$Lj)("question",60210),quote:(0,i.$Lj)("quote",60211),radioTower:(0,i.$Lj)("radio-tower",60212),reactions:(0,i.$Lj)("reactions",60213),references:(0,i.$Lj)("references",60214),refresh:(0,i.$Lj)("refresh",60215),regex:(0,i.$Lj)("regex",60216),remoteExplorer:(0,i.$Lj)("remote-explorer",60217),remote:(0,i.$Lj)("remote",60218),remove:(0,i.$Lj)("remove",60219),replaceAll:(0,i.$Lj)("replace-all",60220),replace:(0,i.$Lj)("replace",60221),repoClone:(0,i.$Lj)("repo-clone",60222),repoForcePush:(0,i.$Lj)("repo-force-push",60223),repoPull:(0,i.$Lj)("repo-pull",60224),repoPush:(0,i.$Lj)("repo-push",60225),report:(0,i.$Lj)("report",60226),requestChanges:(0,i.$Lj)("request-changes",60227),rocket:(0,i.$Lj)("rocket",60228),rootFolderOpened:(0,i.$Lj)("root-folder-opened",60229),rootFolder:(0,i.$Lj)("root-folder",60230),rss:(0,i.$Lj)("rss",60231),ruby:(0,i.$Lj)("ruby",60232),saveAll:(0,i.$Lj)("save-all",60233),saveAs:(0,i.$Lj)("save-as",60234),save:(0,i.$Lj)("save",60235),screenFull:(0,i.$Lj)("screen-full",60236),screenNormal:(0,i.$Lj)("screen-normal",60237),searchStop:(0,i.$Lj)("search-stop",60238),server:(0,i.$Lj)("server",60240),settingsGear:(0,i.$Lj)("settings-gear",60241),settings:(0,i.$Lj)("settings",60242),shield:(0,i.$Lj)("shield",60243),smiley:(0,i.$Lj)("smiley",60244),sortPrecedence:(0,i.$Lj)("sort-precedence",60245),splitHorizontal:(0,i.$Lj)("split-horizontal",60246),splitVertical:(0,i.$Lj)("split-vertical",60247),squirrel:(0,i.$Lj)("squirrel",60248),starFull:(0,i.$Lj)("star-full",60249),starHalf:(0,i.$Lj)("star-half",60250),symbolClass:(0,i.$Lj)("symbol-class",60251),symbolColor:(0,i.$Lj)("symbol-color",60252),symbolConstant:(0,i.$Lj)("symbol-constant",60253),symbolEnumMember:(0,i.$Lj)("symbol-enum-member",60254),symbolField:(0,i.$Lj)("symbol-field",60255),symbolFile:(0,i.$Lj)("symbol-file",60256),symbolInterface:(0,i.$Lj)("symbol-interface",60257),symbolKeyword:(0,i.$Lj)("symbol-keyword",60258),symbolMisc:(0,i.$Lj)("symbol-misc",60259),symbolOperator:(0,i.$Lj)("symbol-operator",60260),symbolProperty:(0,i.$Lj)("symbol-property",60261),wrench:(0,i.$Lj)("wrench",60261),wrenchSubaction:(0,i.$Lj)("wrench-subaction",60261),symbolSnippet:(0,i.$Lj)("symbol-snippet",60262),tasklist:(0,i.$Lj)("tasklist",60263),telescope:(0,i.$Lj)("telescope",60264),textSize:(0,i.$Lj)("text-size",60265),threeBars:(0,i.$Lj)("three-bars",60266),thumbsdown:(0,i.$Lj)("thumbsdown",60267),thumbsup:(0,i.$Lj)("thumbsup",60268),tools:(0,i.$Lj)("tools",60269),triangleDown:(0,i.$Lj)("triangle-down",60270),triangleLeft:(0,i.$Lj)("triangle-left",60271),triangleRight:(0,i.$Lj)("triangle-right",60272),triangleUp:(0,i.$Lj)("triangle-up",60273),twitter:(0,i.$Lj)("twitter",60274),unfold:(0,i.$Lj)("unfold",60275),unlock:(0,i.$Lj)("unlock",60276),unmute:(0,i.$Lj)("unmute",60277),unverified:(0,i.$Lj)("unverified",60278),verified:(0,i.$Lj)("verified",60279),versions:(0,i.$Lj)("versions",60280),vmActive:(0,i.$Lj)("vm-active",60281),vmOutline:(0,i.$Lj)("vm-outline",60282),vmRunning:(0,i.$Lj)("vm-running",60283),watch:(0,i.$Lj)("watch",60284),whitespace:(0,i.$Lj)("whitespace",60285),wholeWord:(0,i.$Lj)("whole-word",60286),window:(0,i.$Lj)("window",60287),wordWrap:(0,i.$Lj)("word-wrap",60288),zoomIn:(0,i.$Lj)("zoom-in",60289),zoomOut:(0,i.$Lj)("zoom-out",60290),listFilter:(0,i.$Lj)("list-filter",60291),listFlat:(0,i.$Lj)("list-flat",60292),listSelection:(0,i.$Lj)("list-selection",60293),selection:(0,i.$Lj)("selection",60293),listTree:(0,i.$Lj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Lj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Lj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Lj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Lj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Lj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Lj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Lj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Lj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Lj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Lj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Lj)("symbol-string",60301),debugReverseContinue:(0,i.$Lj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Lj)("debug-step-back",60303),debugRestartFrame:(0,i.$Lj)("debug-restart-frame",60304),debugAlt:(0,i.$Lj)("debug-alt",60305),callIncoming:(0,i.$Lj)("call-incoming",60306),callOutgoing:(0,i.$Lj)("call-outgoing",60307),menu:(0,i.$Lj)("menu",60308),expandAll:(0,i.$Lj)("expand-all",60309),feedback:(0,i.$Lj)("feedback",60310),gitPullRequestReviewer:(0,i.$Lj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Lj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Lj)("ungroup-by-ref-type",60312),account:(0,i.$Lj)("account",60313),gitPullRequestAssignee:(0,i.$Lj)("git-pull-request-assignee",60313),bellDot:(0,i.$Lj)("bell-dot",60314),debugConsole:(0,i.$Lj)("debug-console",60315),library:(0,i.$Lj)("library",60316),output:(0,i.$Lj)("output",60317),runAll:(0,i.$Lj)("run-all",60318),syncIgnored:(0,i.$Lj)("sync-ignored",60319),pinned:(0,i.$Lj)("pinned",60320),githubInverted:(0,i.$Lj)("github-inverted",60321),serverProcess:(0,i.$Lj)("server-process",60322),serverEnvironment:(0,i.$Lj)("server-environment",60323),pass:(0,i.$Lj)("pass",60324),issueClosed:(0,i.$Lj)("issue-closed",60324),stopCircle:(0,i.$Lj)("stop-circle",60325),playCircle:(0,i.$Lj)("play-circle",60326),record:(0,i.$Lj)("record",60327),debugAltSmall:(0,i.$Lj)("debug-alt-small",60328),vmConnect:(0,i.$Lj)("vm-connect",60329),cloud:(0,i.$Lj)("cloud",60330),merge:(0,i.$Lj)("merge",60331),export:(0,i.$Lj)("export",60332),graphLeft:(0,i.$Lj)("graph-left",60333),magnet:(0,i.$Lj)("magnet",60334),notebook:(0,i.$Lj)("notebook",60335),redo:(0,i.$Lj)("redo",60336),checkAll:(0,i.$Lj)("check-all",60337),pinnedDirty:(0,i.$Lj)("pinned-dirty",60338),passFilled:(0,i.$Lj)("pass-filled",60339),circleLargeFilled:(0,i.$Lj)("circle-large-filled",60340),circleLarge:(0,i.$Lj)("circle-large",60341),circleLargeOutline:(0,i.$Lj)("circle-large-outline",60341),combine:(0,i.$Lj)("combine",60342),gather:(0,i.$Lj)("gather",60342),table:(0,i.$Lj)("table",60343),variableGroup:(0,i.$Lj)("variable-group",60344),typeHierarchy:(0,i.$Lj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Lj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Lj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Lj)("git-pull-request-create",60348),runAbove:(0,i.$Lj)("run-above",60349),runBelow:(0,i.$Lj)("run-below",60350),notebookTemplate:(0,i.$Lj)("notebook-template",60351),debugRerun:(0,i.$Lj)("debug-rerun",60352),workspaceTrusted:(0,i.$Lj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Lj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Lj)("workspace-unknown",60355),terminalCmd:(0,i.$Lj)("terminal-cmd",60356),terminalDebian:(0,i.$Lj)("terminal-debian",60357),terminalLinux:(0,i.$Lj)("terminal-linux",60358),terminalPowershell:(0,i.$Lj)("terminal-powershell",60359),terminalTmux:(0,i.$Lj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Lj)("terminal-ubuntu",60361),terminalBash:(0,i.$Lj)("terminal-bash",60362),arrowSwap:(0,i.$Lj)("arrow-swap",60363),copy:(0,i.$Lj)("copy",60364),personAdd:(0,i.$Lj)("person-add",60365),filterFilled:(0,i.$Lj)("filter-filled",60366),wand:(0,i.$Lj)("wand",60367),debugLineByLine:(0,i.$Lj)("debug-line-by-line",60368),inspect:(0,i.$Lj)("inspect",60369),layers:(0,i.$Lj)("layers",60370),layersDot:(0,i.$Lj)("layers-dot",60371),layersActive:(0,i.$Lj)("layers-active",60372),compass:(0,i.$Lj)("compass",60373),compassDot:(0,i.$Lj)("compass-dot",60374),compassActive:(0,i.$Lj)("compass-active",60375),azure:(0,i.$Lj)("azure",60376),issueDraft:(0,i.$Lj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Lj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Lj)("git-pull-request-draft",60379),debugAll:(0,i.$Lj)("debug-all",60380),debugCoverage:(0,i.$Lj)("debug-coverage",60381),runErrors:(0,i.$Lj)("run-errors",60382),folderLibrary:(0,i.$Lj)("folder-library",60383),debugContinueSmall:(0,i.$Lj)("debug-continue-small",60384),beakerStop:(0,i.$Lj)("beaker-stop",60385),graphLine:(0,i.$Lj)("graph-line",60386),graphScatter:(0,i.$Lj)("graph-scatter",60387),pieChart:(0,i.$Lj)("pie-chart",60388),bracket:(0,i.$Lj)("bracket",60175),bracketDot:(0,i.$Lj)("bracket-dot",60389),bracketError:(0,i.$Lj)("bracket-error",60390),lockSmall:(0,i.$Lj)("lock-small",60391),azureDevops:(0,i.$Lj)("azure-devops",60392),verifiedFilled:(0,i.$Lj)("verified-filled",60393),newline:(0,i.$Lj)("newline",60394),layout:(0,i.$Lj)("layout",60395),layoutActivitybarLeft:(0,i.$Lj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Lj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Lj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Lj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Lj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Lj)("layout-panel-right",60401),layoutPanel:(0,i.$Lj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Lj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Lj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Lj)("layout-statusbar",60405),layoutMenubar:(0,i.$Lj)("layout-menubar",60406),layoutCentered:(0,i.$Lj)("layout-centered",60407),target:(0,i.$Lj)("target",60408),indent:(0,i.$Lj)("indent",60409),recordSmall:(0,i.$Lj)("record-small",60410),errorSmall:(0,i.$Lj)("error-small",60411),terminalDecorationError:(0,i.$Lj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Lj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Lj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Lj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Lj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Lj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Lj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Lj)("layout-sidebar-left-off",60418),blank:(0,i.$Lj)("blank",60419),heartFilled:(0,i.$Lj)("heart-filled",60420),map:(0,i.$Lj)("map",60421),mapHorizontal:(0,i.$Lj)("map-horizontal",60421),foldHorizontal:(0,i.$Lj)("fold-horizontal",60421),mapFilled:(0,i.$Lj)("map-filled",60422),mapHorizontalFilled:(0,i.$Lj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Lj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Lj)("circle-small",60423),bellSlash:(0,i.$Lj)("bell-slash",60424),bellSlashDot:(0,i.$Lj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Lj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Lj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Lj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Lj)("search-fuzzy",60429),commentDraft:(0,i.$Lj)("comment-draft",60430),send:(0,i.$Lj)("send",60431),sparkle:(0,i.$Lj)("sparkle",60432),insert:(0,i.$Lj)("insert",60433),mic:(0,i.$Lj)("mic",60434),thumbsdownFilled:(0,i.$Lj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Lj)("thumbsup-filled",60436),coffee:(0,i.$Lj)("coffee",60437),snake:(0,i.$Lj)("snake",60438),game:(0,i.$Lj)("game",60439),vr:(0,i.$Lj)("vr",60440),chip:(0,i.$Lj)("chip",60441),piano:(0,i.$Lj)("piano",60442),music:(0,i.$Lj)("music",60443),micFilled:(0,i.$Lj)("mic-filled",60444),repoFetch:(0,i.$Lj)("repo-fetch",60445),copilot:(0,i.$Lj)("copilot",60446),lightbulbSparkle:(0,i.$Lj)("lightbulb-sparkle",60447),robot:(0,i.$Lj)("robot",60448),sparkleFilled:(0,i.$Lj)("sparkle-filled",60449),diffSingle:(0,i.$Lj)("diff-single",60450),diffMultiple:(0,i.$Lj)("diff-multiple",60451),surroundWith:(0,i.$Lj)("surround-with",60452),share:(0,i.$Lj)("share",60453),gitStash:(0,i.$Lj)("git-stash",60454),gitStashApply:(0,i.$Lj)("git-stash-apply",60455),gitStashPop:(0,i.$Lj)("git-stash-pop",60456),vscode:(0,i.$Lj)("vscode",60457),vscodeInsiders:(0,i.$Lj)("vscode-insiders",60458),codeOss:(0,i.$Lj)("code-oss",60459),runCoverage:(0,i.$Lj)("run-coverage",60460),runAllCoverage:(0,i.$Lj)("run-all-coverage",60461),coverage:(0,i.$Lj)("coverage",60462),githubProject:(0,i.$Lj)("github-project",60463),mapVertical:(0,i.$Lj)("map-vertical",60464),foldVertical:(0,i.$Lj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Lj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Lj)("fold-vertical-filled",60465),goToSearch:(0,i.$Lj)("go-to-search",60466),percentage:(0,i.$Lj)("percentage",60467),sortPercentage:(0,i.$Lj)("sort-percentage",60467)}}),define(re[75],oe([0,1,105,145]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=void 0,e.$Oj=S;function S(){return Object.values(e.$Qj)}e.$Pj={dialogError:(0,i.$Lj)("dialog-error","error"),dialogWarning:(0,i.$Lj)("dialog-warning","warning"),dialogInfo:(0,i.$Lj)("dialog-info","info"),dialogClose:(0,i.$Lj)("dialog-close","close"),treeItemExpanded:(0,i.$Lj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Lj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Lj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Lj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Lj)("tree-item-loading","loading"),menuSelection:(0,i.$Lj)("menu-selection","check"),menuSubmenu:(0,i.$Lj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Lj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Lj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Lj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Lj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Lj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Lj)("toolbar-more","more"),quickInputBack:(0,i.$Lj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Lj)("drop-down-button",60084),symbolCustomColor:(0,i.$Lj)("symbol-customcolor",60252),exportIcon:(0,i.$Lj)("export",60332),workspaceUnspecified:(0,i.$Lj)("workspace-unspecified",60355),newLine:(0,i.$Lj)("newline",60394),thumbsDownFilled:(0,i.$Lj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Lj)("thumbsup-filled",60436),gitFetch:(0,i.$Lj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Lj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Lj)("debug-breakpoint-pending",60377)},e.$Qj={...D.$Nj,...e.$Pj}}),define(re[35],oe([0,1,12]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=D,e.$Yn=S,e.$Zn=P,e.$1n=u,e.$2n=l,e.$3n=d,e.$4n=y,e.$5n=E,e.$6n=$,e.$7n=g,e.$8n=v,e.$9n=p;function D(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const f=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([h,w])=>{f[h]=w&&typeof w=="object"?D(w):w}),f}function S(m){if(!m||typeof m!="object")return m;const f=[m];for(;f.length>0;){const h=f.shift();Object.freeze(h);for(const w in h)if(A.call(h,w)){const a=h[w];typeof a=="object"&&!Object.isFrozen(a)&&!(0,i.$8f)(a)&&f.push(a)}}return m}const A=Object.prototype.hasOwnProperty;function P(m,f){return k(m,f,new Set)}function k(m,f,h){if((0,i.$bg)(m))return m;const w=f(m);if(typeof w<"u")return w;if(Array.isArray(m)){const a=[];for(const t of m)a.push(k(t,f,h));return a}if((0,i.$7f)(m)){if(h.has(m))throw new Error("Cannot clone recursive data-structure");h.add(m);const a={};for(const t in m)A.call(m,t)&&(a[t]=k(m[t],f,h));return h.delete(m),a}return m}function u(m,f,h=!0){return(0,i.$7f)(m)?((0,i.$7f)(f)&&Object.keys(f).forEach(w=>{w in m?h&&((0,i.$7f)(m[w])&&(0,i.$7f)(f[w])?u(m[w],f[w],h):m[w]=f[w]):m[w]=f[w]}),m):f}function l(m,f){if(m===f)return!0;if(m==null||f===null||f===void 0||typeof m!=typeof f||typeof m!="object"||Array.isArray(m)!==Array.isArray(f))return!1;let h,w;if(Array.isArray(m)){if(m.length!==f.length)return!1;for(h=0;h<m.length;h++)if(!l(m[h],f[h]))return!1}else{const a=[];for(w in m)a.push(w);a.sort();const t=[];for(w in f)t.push(w);if(t.sort(),!l(a,t))return!1;for(h=0;h<a.length;h++)if(!l(m[a[h]],f[a[h]]))return!1}return!0}function d(m){const f=new Set;return JSON.stringify(m,(h,w)=>{if((0,i.$7f)(w)||Array.isArray(w)){if(f.has(w))return"[Circular]";f.add(w)}return typeof w=="bigint"?`[BigInt ${w.toString()}]`:w})}function y(m,f){const h=Object.create(null);return!m||!f||Object.keys(f).forEach(a=>{const t=m[a],r=f[a];l(t,r)||(h[a]=r)}),h}function E(m,f){const h=f.toLowerCase(),w=Object.keys(m).find(a=>a.toLowerCase()===h);return w?m[w]:m[f]}function $(m,f){const h=Object.create(null);for(const[w,a]of Object.entries(m))f(w,a)&&(h[w]=a);return h}function g(m){let f=[];for(;Object.prototype!==m;)f=f.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return f}function v(m){const f=[];for(const h of g(m))typeof m[h]=="function"&&f.push(h);return f}function p(m,f){const h=a=>function(){const t=Array.prototype.slice.call(arguments,0);return f(a,t)},w={};for(const a of m)w[a]=h(a);return w}}),define(re[106],oe([0,1,75]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Rj=S;var D;(function(P){function k(u){return u&&typeof u=="object"&&typeof u.id=="string"}P.isThemeColor=k})(D||(e.ThemeColor=D={}));function S(P){return{id:P}}var A;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function u(f){const h=k.exec(f.id);if(!h)return u(i.$Qj.error);const[,w,a]=h,t=["codicon","codicon-"+w];return a&&t.push("codicon-modifier-"+a.substring(1)),t}P.asClassNameArray=u;function l(f){return u(f).join(" ")}P.asClassName=l;function d(f){return"."+u(f).join(".")}P.asCSSSelector=d;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||D.isThemeColor(f.color))}P.isThemeIcon=y;const E=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function $(f){const h=E.exec(f);if(!h)return;const[,w]=h;return{id:w}}P.fromString=$;function g(f){return{id:f}}P.fromId=g;function v(f,h){let w=f.id;const a=w.lastIndexOf("~");return a!==-1&&(w=w.substring(0,a)),h&&(w=`${w}~${h}`),{id:w}}P.modify=v;function p(f){const h=f.id.lastIndexOf("~");if(h!==-1)return f.id.substring(h+1)}P.getModifier=p;function m(f,h){return f.id===h.id&&f.color?.id===h.color?.id}P.isEqual=m})(A||(e.ThemeIcon=A={}))}),define(re[33],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=void 0,e.$Mg=D;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(S){return i.test(S)}e.$Ng=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(k){for(let u=0;u<k.length;u++)k[u]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),P=[];for(let k=0;k<256;k++)P.push(k.toString(16).padStart(2,"0"));return function(){S(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,l="";return l+=P[A[u++]],l+=P[A[u++]],l+=P[A[u++]],l+=P[A[u++]],l+="-",l+=P[A[u++]],l+=P[A[u++]],l+="-",l+=P[A[u++]],l+=P[A[u++]],l+="-",l+=P[A[u++]],l+=P[A[u++]],l+="-",l+=P[A[u++]],l+=P[A[u++]],l+=P[A[u++]],l+=P[A[u++]],l+=P[A[u++]],l+=P[A[u++]],l}}()}),define(re[146],oe([0,1,87,43,86]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zW=A;async function A(P,k){if(await new Promise((d,y)=>{const E=D.createReadStream(P),$=i.createHash("sha256");E.pipe($);const g=(0,S.$db)((v,p)=>{E.removeAllListeners(),$.removeAllListeners(),v?y(v):d(p)});E.once("error",g),E.once("end",g),$.once("error",g),$.once("data",v=>g(void 0,v.toString("hex")))})!==k)throw new Error("Hash mismatch")}}),define(re[147],oe([0,1,26]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=A;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(P){const k=P.replace(/\-/g,":").toLowerCase();return!D.has(k)}function A(){const P=(0,i.networkInterfaces)();for(const k in P){const u=P[k];if(u){for(const{mac:l}of u)if(S(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(re[107],oe([0,1,88]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=void 0,e.$Pg=D,e.$Rg=A;function D(k,u,l,d=1){let y=!1;return new Promise(E=>{const $=setTimeout(()=>{if(!y)return y=!0,E(0)},l);S(k,u,d,g=>{if(!y)return y=!0,clearTimeout($),E(g)})})}function S(k,u,l,d){if(u===0)return d(0);const y=new i.Socket;y.once("connect",()=>(P(y),S(k+l,u-1,l,d))),y.once("data",()=>{}),y.once("error",E=>(P(y),E.code!=="ECONNREFUSED"?S(k+l,u-1,l,d):d(k))),y.connect(k,"127.0.0.1")}e.$Qg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(k,u,l,d="127.0.0.1"){let y=!1,E,$=1;const g=i.createServer({pauseOnConnect:!0});function v(p,m){y||(y=!0,g.removeAllListeners(),g.close(),E&&clearTimeout(E),m(p))}return new Promise(p=>{E=setTimeout(()=>{v(0,p)},l),g.on("listening",()=>{v(k,p)}),g.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&$<u?(k++,$++,g.listen(k,d)):v(0,p)}),g.on("close",()=>{v(0,p)}),g.listen(k,d)})}function P(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(u){console.error(u)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function i(u){const l=new Set;if(Array.isArray(u))for(const d of u)typeof d=="string"&&l.add(d);return Array.from(l)}function D(){const u=e();return u?Array.from(u):[]}function S(u){if(process.platform!=="win32")return;const l=e();if(l)if(typeof u=="string")l.add(u.toLowerCase());else for(const d of i(u))S(d)}function A(u){if(typeof u!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let d;for(const y of l){if(u.indexOf(y)!==0)continue;const $=u.indexOf("\\",y.length);if($===-1)continue;const g=u.substring(y.length,$);if(g){d=g;break}}return d}function P(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function k(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:D,addUNCHostToAllowlist:S,getUNCHost:A,disableUNCAccessRestrictions:P,isUNCAccessRestrictionsDisabled:k}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(re[148],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FW=e.$EW=void 0,e.$EW="vscode:contextmenu",e.$FW="vscode:onCloseContextMenu"}),define(re[149],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MW=void 0;class i{constructor(S,A){this.a=S,this.onMessage=A}send(S){try{this.a.send("vscode:message",S.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$MW=i}),define(re[150],oe([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(re[151],oe([0,1,150]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=l,e.$Xm=d,e.$Ym=y;const D=60,S=D*60,A=S*24,P=A*7,k=A*30,u=A*365;function l(E,$,g,v){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,i.localize)(0,null,l(new Date().getTime()+p*1e3,!1));if(!v&&p<30)return(0,i.localize)(1,null);let m;return p<D?(m=p,$?m===1?g?(0,i.localize)(2,null,m):(0,i.localize)(3,null,m):g?(0,i.localize)(4,null,m):(0,i.localize)(5,null,m):m===1?g?(0,i.localize)(6,null,m):(0,i.localize)(7,null,m):g?(0,i.localize)(8,null,m):(0,i.localize)(9,null,m)):p<S?(m=Math.floor(p/D),$?m===1?g?(0,i.localize)(10,null,m):(0,i.localize)(11,null,m):g?(0,i.localize)(12,null,m):(0,i.localize)(13,null,m):m===1?g?(0,i.localize)(14,null,m):(0,i.localize)(15,null,m):g?(0,i.localize)(16,null,m):(0,i.localize)(17,null,m)):p<A?(m=Math.floor(p/S),$?m===1?g?(0,i.localize)(18,null,m):(0,i.localize)(19,null,m):g?(0,i.localize)(20,null,m):(0,i.localize)(21,null,m):m===1?g?(0,i.localize)(22,null,m):(0,i.localize)(23,null,m):g?(0,i.localize)(24,null,m):(0,i.localize)(25,null,m)):p<P?(m=Math.floor(p/A),$?m===1?(0,i.localize)(26,null,m):(0,i.localize)(27,null,m):m===1?(0,i.localize)(28,null,m):(0,i.localize)(29,null,m)):p<k?(m=Math.floor(p/P),$?m===1?g?(0,i.localize)(30,null,m):(0,i.localize)(31,null,m):g?(0,i.localize)(32,null,m):(0,i.localize)(33,null,m):m===1?g?(0,i.localize)(34,null,m):(0,i.localize)(35,null,m):g?(0,i.localize)(36,null,m):(0,i.localize)(37,null,m)):p<u?(m=Math.floor(p/k),$?m===1?g?(0,i.localize)(38,null,m):(0,i.localize)(39,null,m):g?(0,i.localize)(40,null,m):(0,i.localize)(41,null,m):m===1?g?(0,i.localize)(42,null,m):(0,i.localize)(43,null,m):g?(0,i.localize)(44,null,m):(0,i.localize)(45,null,m)):(m=Math.floor(p/u),$?m===1?g?(0,i.localize)(46,null,m):(0,i.localize)(47,null,m):g?(0,i.localize)(48,null,m):(0,i.localize)(49,null,m):m===1?g?(0,i.localize)(50,null,m):(0,i.localize)(51,null,m):g?(0,i.localize)(52,null,m):(0,i.localize)(53,null,m))}function d(E,$){const g=Math.abs(E/1e3);return g<1?$?(0,i.localize)(54,null,E):(0,i.localize)(55,null,E):g<D?$?(0,i.localize)(56,null,Math.round(E)/1e3):(0,i.localize)(57,null,Math.round(E)/1e3):g<S?$?(0,i.localize)(58,null,Math.round(E/(1e3*D))):(0,i.localize)(59,null,Math.round(E/(1e3*D))):g<A?$?(0,i.localize)(60,null,Math.round(E/(1e3*S))):(0,i.localize)(61,null,Math.round(E/(1e3*S))):(0,i.localize)(62,null,Math.round(E/(1e3*A)))}function y(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(re[152],oe([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(re[47],oe([0,1,22,12,152]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=u,e.$dj=l,e.$ej=d;function A(y,E){return E&&(y.stack||y.stacktrace)?S.localize(0,null,k(y),P(y.stack)||P(y.stacktrace)):k(y)}function P(y){return Array.isArray(y)?y.join(`
`):y}function k(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?S.localize(1,null,y.message):y.message||S.localize(2,null)}function u(y=null,E=!1){if(!y)return S.localize(3,null);if(Array.isArray(y)){const $=i.$Hb(y),g=u($[0],E);return $.length>1?S.localize(4,null,g,$.length):g}if(D.$5f(y))return y;if(y.detail){const $=y.detail;if($.error)return A($.error,E);if($.exception)return A($.exception,E)}return y.stack?A(y,E):y.message?y.message:S.localize(5,null)}function l(y){const E=y;return E instanceof Error&&Array.isArray(E.actions)}function d(y,E){let $;return typeof y=="string"?$=new Error(y):$=y,$.actions=E,$}}),define(re[153],oe([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(re[154],oe([0,1,153]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=D;function D(S){switch(S){case 1:return(0,i.localize)(0,null);case 2:return(0,i.localize)(1,null);case 3:return(0,i.localize)(2,null);case 4:return(0,i.localize)(3,null);case 5:return(0,i.localize)(4,null);case 6:return(0,i.localize)(5,null);case 7:return(0,i.localize)(6,null);case 8:return(0,i.localize)(7,null);case 9:return(0,i.localize)(8,null);default:return""}}}),define(re[155],oe([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,155]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=L,e.$J=I,e.$g="en";let D=!1,S=!1,A=!1,P=!1,k=!1,u=!1,l=!1,d=!1,y=!1,E=!1,$,g=e.$g,v=e.$g,p,m;const f=globalThis;let h;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?h=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(h=process);const w=typeof h?.versions?.electron=="string",a=w&&h?.type==="renderer";if(typeof h=="object"){D=h.platform==="win32",S=h.platform==="darwin",A=h.platform==="linux",P=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,l=w,y=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$g,g=e.$g;const j=h.env.VSCODE_NLS_CONFIG;if(j)try{const O=JSON.parse(j),R=O.availableLanguages["*"];$=O.locale,v=O.osLocale,g=R||e.$g,p=O._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!a?(m=navigator.userAgent,D=m.indexOf("Windows")>=0,S=m.indexOf("Macintosh")>=0,d=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=m.indexOf("Linux")>=0,E=m?.indexOf("Mobi")>=0,u=!0,$=i.getConfiguredDefaultLocale(i.localize(0,null))||e.$g,g=$,v=navigator.language):console.error("Unable to resolve platform.");var t;(function(j){j[j.Web=0]="Web",j[j.Mac=1]="Mac",j[j.Linux=2]="Linux",j[j.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(j){switch(j){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;S?s=1:D?s=3:A&&(s=2),e.$i=D,e.$j=S,e.$k=A,e.$l=P,e.$m=k,e.$n=l,e.$o=u,e.$p=u&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=d,e.$s=E,e.$t=y,e.$u=s,e.$v=m,e.$w=g;var n;(function(j){function O(){return e.$w}j.value=O;function R(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}j.isDefaultVariant=R;function W(){return e.$w==="en"}j.isDefault=W})(n||(e.Language=n={})),e.$x=$,e.$y=v,e.$z=p,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const j=[];f.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let W=0,F=j.length;W<F;W++){const T=j[W];if(T.id===R.data.vscodeScheduleAsyncWork){j.splice(W,1),T.callback();return}}});let O=0;return R=>{const W=++O;j.push({id:W,callback:R}),f.postMessage({vscodeScheduleAsyncWork:W},"*")}}return j=>setTimeout(j)})();var o;(function(j){j[j.Windows=1]="Windows",j[j.Macintosh=2]="Macintosh",j[j.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=S||d?2:D?1:3;let c=!0,b=!1;function L(){if(!b){b=!0;const j=new Uint8Array(2);j[0]=1,j[1]=2,c=new Uint16Array(j.buffer)[0]===513}return c}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(j){return parseFloat(j)>=20}}),define(re[36],oe([0,1,4]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let D;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const A=S.process;D={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.$ec=D.platform,e.$fc=D.arch}),define(re[9],oe([0,1,36]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const D=65,S=97,A=90,P=122,k=46,u=47,l=92,d=58,y=63;class E extends Error{constructor(r,s,n){let o;typeof s=="string"&&s.indexOf("not ")===0?(o="must not be",s=s.replace(/^not /,"")):o="must be";const c=r.indexOf(".")!==-1?"property":"argument";let b=`The "${r}" ${c} ${o} of type ${s}`;b+=`. Received type ${typeof n}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function $(t,r){if(t===null||typeof t!="object")throw new E(r,"Object",t)}function g(t,r){if(typeof t!="string")throw new E(r,"string",t)}const v=i.$ec==="win32";function p(t){return t===u||t===l}function m(t){return t===u}function f(t){return t>=D&&t<=A||t>=S&&t<=P}function h(t,r,s,n){let o="",c=0,b=-1,L=0,I=0;for(let j=0;j<=t.length;++j){if(j<t.length)I=t.charCodeAt(j);else{if(n(I))break;I=u}if(n(I)){if(!(b===j-1||L===1))if(L===2){if(o.length<2||c!==2||o.charCodeAt(o.length-1)!==k||o.charCodeAt(o.length-2)!==k){if(o.length>2){const O=o.lastIndexOf(s);O===-1?(o="",c=0):(o=o.slice(0,O),c=o.length-1-o.lastIndexOf(s)),b=j,L=0;continue}else if(o.length!==0){o="",c=0,b=j,L=0;continue}}r&&(o+=o.length>0?`${s}..`:"..",c=2)}else o.length>0?o+=`${s}${t.slice(b+1,j)}`:o=t.slice(b+1,j),c=j-b-1;b=j,L=0}else I===k&&L!==-1?++L:L=-1}return o}function w(t,r){$(r,"pathObject");const s=r.dir||r.root,n=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${n}`:`${s}${t}${n}`:n}e.$gc={resolve(...t){let r="",s="",n=!1;for(let o=t.length-1;o>=-1;o--){let c;if(o>=0){if(c=t[o],g(c,"path"),c.length===0)continue}else r.length===0?c=i.cwd():(c=i.env[`=${r}`]||i.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==r.toLowerCase()&&c.charCodeAt(2)===l)&&(c=`${r}\\`));const b=c.length;let L=0,I="",j=!1;const O=c.charCodeAt(0);if(b===1)p(O)&&(L=1,j=!0);else if(p(O))if(j=!0,p(c.charCodeAt(1))){let R=2,W=R;for(;R<b&&!p(c.charCodeAt(R));)R++;if(R<b&&R!==W){const F=c.slice(W,R);for(W=R;R<b&&p(c.charCodeAt(R));)R++;if(R<b&&R!==W){for(W=R;R<b&&!p(c.charCodeAt(R));)R++;(R===b||R!==W)&&(I=`\\\\${F}\\${c.slice(W,R)}`,L=R)}}}else L=1;else f(O)&&c.charCodeAt(1)===d&&(I=c.slice(0,2),L=2,b>2&&p(c.charCodeAt(2))&&(j=!0,L=3));if(I.length>0)if(r.length>0){if(I.toLowerCase()!==r.toLowerCase())continue}else r=I;if(n){if(r.length>0)break}else if(s=`${c.slice(L)}\\${s}`,n=j,j&&r.length>0)break}return s=h(s,!n,"\\",p),n?`${r}\\${s}`:`${r}${s}`||"."},normalize(t){g(t,"path");const r=t.length;if(r===0)return".";let s=0,n,o=!1;const c=t.charCodeAt(0);if(r===1)return m(c)?"\\":t;if(p(c))if(o=!0,p(t.charCodeAt(1))){let L=2,I=L;for(;L<r&&!p(t.charCodeAt(L));)L++;if(L<r&&L!==I){const j=t.slice(I,L);for(I=L;L<r&&p(t.charCodeAt(L));)L++;if(L<r&&L!==I){for(I=L;L<r&&!p(t.charCodeAt(L));)L++;if(L===r)return`\\\\${j}\\${t.slice(I)}\\`;L!==I&&(n=`\\\\${j}\\${t.slice(I,L)}`,s=L)}}}else s=1;else f(c)&&t.charCodeAt(1)===d&&(n=t.slice(0,2),s=2,r>2&&p(t.charCodeAt(2))&&(o=!0,s=3));let b=s<r?h(t.slice(s),!o,"\\",p):"";return b.length===0&&!o&&(b="."),b.length>0&&p(t.charCodeAt(r-1))&&(b+="\\"),n===void 0?o?`\\${b}`:b:o?`${n}\\${b}`:`${n}${b}`},isAbsolute(t){g(t,"path");const r=t.length;if(r===0)return!1;const s=t.charCodeAt(0);return p(s)||r>2&&f(s)&&t.charCodeAt(1)===d&&p(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,s;for(let c=0;c<t.length;++c){const b=t[c];g(b,"path"),b.length>0&&(r===void 0?r=s=b:r+=`\\${b}`)}if(r===void 0)return".";let n=!0,o=0;if(typeof s=="string"&&p(s.charCodeAt(0))){++o;const c=s.length;c>1&&p(s.charCodeAt(1))&&(++o,c>2&&(p(s.charCodeAt(2))?++o:n=!1))}if(n){for(;o<r.length&&p(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.$gc.normalize(r)},relative(t,r){if(g(t,"from"),g(r,"to"),t===r)return"";const s=e.$gc.resolve(t),n=e.$gc.resolve(r);if(s===n||(t=s.toLowerCase(),r=n.toLowerCase(),t===r))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===l;)o++;let c=t.length;for(;c-1>o&&t.charCodeAt(c-1)===l;)c--;const b=c-o;let L=0;for(;L<r.length&&r.charCodeAt(L)===l;)L++;let I=r.length;for(;I-1>L&&r.charCodeAt(I-1)===l;)I--;const j=I-L,O=b<j?b:j;let R=-1,W=0;for(;W<O;W++){const T=t.charCodeAt(o+W);if(T!==r.charCodeAt(L+W))break;T===l&&(R=W)}if(W!==O){if(R===-1)return n}else{if(j>O){if(r.charCodeAt(L+W)===l)return n.slice(L+W+1);if(W===2)return n.slice(L+W)}b>O&&(t.charCodeAt(o+W)===l?R=W:W===2&&(R=3)),R===-1&&(R=0)}let F="";for(W=o+R+1;W<=c;++W)(W===c||t.charCodeAt(W)===l)&&(F+=F.length===0?"..":"\\..");return L+=R,F.length>0?`${F}${n.slice(L,I)}`:(n.charCodeAt(L)===l&&++L,n.slice(L,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$gc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===l){if(r.charCodeAt(1)===l){const s=r.charCodeAt(2);if(s!==y&&s!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(f(r.charCodeAt(0))&&r.charCodeAt(1)===d&&r.charCodeAt(2)===l)return`\\\\?\\${r}`;return t},dirname(t){g(t,"path");const r=t.length;if(r===0)return".";let s=-1,n=0;const o=t.charCodeAt(0);if(r===1)return p(o)?t:".";if(p(o)){if(s=n=1,p(t.charCodeAt(1))){let L=2,I=L;for(;L<r&&!p(t.charCodeAt(L));)L++;if(L<r&&L!==I){for(I=L;L<r&&p(t.charCodeAt(L));)L++;if(L<r&&L!==I){for(I=L;L<r&&!p(t.charCodeAt(L));)L++;if(L===r)return t;L!==I&&(s=n=L+1)}}}}else f(o)&&t.charCodeAt(1)===d&&(s=r>2&&p(t.charCodeAt(2))?3:2,n=s);let c=-1,b=!0;for(let L=r-1;L>=n;--L)if(p(t.charCodeAt(L))){if(!b){c=L;break}}else b=!1;if(c===-1){if(s===-1)return".";c=s}return t.slice(0,c)},basename(t,r){r!==void 0&&g(r,"ext"),g(t,"path");let s=0,n=-1,o=!0,c;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===d&&(s=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let b=r.length-1,L=-1;for(c=t.length-1;c>=s;--c){const I=t.charCodeAt(c);if(p(I)){if(!o){s=c+1;break}}else L===-1&&(o=!1,L=c+1),b>=0&&(I===r.charCodeAt(b)?--b===-1&&(n=c):(b=-1,n=L))}return s===n?n=L:n===-1&&(n=t.length),t.slice(s,n)}for(c=t.length-1;c>=s;--c)if(p(t.charCodeAt(c))){if(!o){s=c+1;break}}else n===-1&&(o=!1,n=c+1);return n===-1?"":t.slice(s,n)},extname(t){g(t,"path");let r=0,s=-1,n=0,o=-1,c=!0,b=0;t.length>=2&&t.charCodeAt(1)===d&&f(t.charCodeAt(0))&&(r=n=2);for(let L=t.length-1;L>=r;--L){const I=t.charCodeAt(L);if(p(I)){if(!c){n=L+1;break}continue}o===-1&&(c=!1,o=L+1),I===k?s===-1?s=L:b!==1&&(b=1):s!==-1&&(b=-1)}return s===-1||o===-1||b===0||b===1&&s===o-1&&s===n+1?"":t.slice(s,o)},format:w.bind(null,"\\"),parse(t){g(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.length;let n=0,o=t.charCodeAt(0);if(s===1)return p(o)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(p(o)){if(n=1,p(t.charCodeAt(1))){let R=2,W=R;for(;R<s&&!p(t.charCodeAt(R));)R++;if(R<s&&R!==W){for(W=R;R<s&&p(t.charCodeAt(R));)R++;if(R<s&&R!==W){for(W=R;R<s&&!p(t.charCodeAt(R));)R++;R===s?n=R:R!==W&&(n=R+1)}}}}else if(f(o)&&t.charCodeAt(1)===d){if(s<=2)return r.root=r.dir=t,r;if(n=2,p(t.charCodeAt(2))){if(s===3)return r.root=r.dir=t,r;n=3}}n>0&&(r.root=t.slice(0,n));let c=-1,b=n,L=-1,I=!0,j=t.length-1,O=0;for(;j>=n;--j){if(o=t.charCodeAt(j),p(o)){if(!I){b=j+1;break}continue}L===-1&&(I=!1,L=j+1),o===k?c===-1?c=j:O!==1&&(O=1):c!==-1&&(O=-1)}return L!==-1&&(c===-1||O===0||O===1&&c===L-1&&c===b+1?r.base=r.name=t.slice(b,L):(r.name=t.slice(b,c),r.base=t.slice(b,L),r.ext=t.slice(c,L))),b>0&&b!==n?r.dir=t.slice(0,b-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(v){const t=/\\/g;return()=>{const r=i.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>i.cwd()})();e.$hc={resolve(...t){let r="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const o=n>=0?t[n]:a();g(o,"path"),o.length!==0&&(r=`${o}/${r}`,s=o.charCodeAt(0)===u)}return r=h(r,!s,"/",m),s?`/${r}`:r.length>0?r:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===u,s=t.charCodeAt(t.length-1)===u;return t=h(t,!r,"/",m),t.length===0?r?"/":s?"./":".":(s&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===u},join(...t){if(t.length===0)return".";let r;for(let s=0;s<t.length;++s){const n=t[s];g(n,"path"),n.length>0&&(r===void 0?r=n:r+=`/${n}`)}return r===void 0?".":e.$hc.normalize(r)},relative(t,r){if(g(t,"from"),g(r,"to"),t===r||(t=e.$hc.resolve(t),r=e.$hc.resolve(r),t===r))return"";const s=1,n=t.length,o=n-s,c=1,b=r.length-c,L=o<b?o:b;let I=-1,j=0;for(;j<L;j++){const R=t.charCodeAt(s+j);if(R!==r.charCodeAt(c+j))break;R===u&&(I=j)}if(j===L)if(b>L){if(r.charCodeAt(c+j)===u)return r.slice(c+j+1);if(j===0)return r.slice(c+j)}else o>L&&(t.charCodeAt(s+j)===u?I=j:j===0&&(I=0));let O="";for(j=s+I+1;j<=n;++j)(j===n||t.charCodeAt(j)===u)&&(O+=O.length===0?"..":"/..");return`${O}${r.slice(c+I)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===u;let s=-1,n=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===u){if(!n){s=o;break}}else n=!1;return s===-1?r?"/":".":r&&s===1?"//":t.slice(0,s)},basename(t,r){r!==void 0&&g(r,"ext"),g(t,"path");let s=0,n=-1,o=!0,c;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let b=r.length-1,L=-1;for(c=t.length-1;c>=0;--c){const I=t.charCodeAt(c);if(I===u){if(!o){s=c+1;break}}else L===-1&&(o=!1,L=c+1),b>=0&&(I===r.charCodeAt(b)?--b===-1&&(n=c):(b=-1,n=L))}return s===n?n=L:n===-1&&(n=t.length),t.slice(s,n)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===u){if(!o){s=c+1;break}}else n===-1&&(o=!1,n=c+1);return n===-1?"":t.slice(s,n)},extname(t){g(t,"path");let r=-1,s=0,n=-1,o=!0,c=0;for(let b=t.length-1;b>=0;--b){const L=t.charCodeAt(b);if(L===u){if(!o){s=b+1;break}continue}n===-1&&(o=!1,n=b+1),L===k?r===-1?r=b:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||n===-1||c===0||c===1&&r===n-1&&r===s+1?"":t.slice(r,n)},format:w.bind(null,"/"),parse(t){g(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.charCodeAt(0)===u;let n;s?(r.root="/",n=1):n=0;let o=-1,c=0,b=-1,L=!0,I=t.length-1,j=0;for(;I>=n;--I){const O=t.charCodeAt(I);if(O===u){if(!L){c=I+1;break}continue}b===-1&&(L=!1,b=I+1),O===k?o===-1?o=I:j!==1&&(j=1):o!==-1&&(j=-1)}if(b!==-1){const O=c===0&&s?1:c;o===-1||j===0||j===1&&o===b-1&&o===c+1?r.base=r.name=t.slice(O,b):(r.name=t.slice(O,o),r.base=t.slice(O,b),r.ext=t.slice(o,b))}return c>0?r.dir=t.slice(0,c-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=v?e.$gc.normalize:e.$hc.normalize,e.$jc=v?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=v?e.$gc.join:e.$hc.join,e.$lc=v?e.$gc.resolve:e.$hc.resolve,e.$mc=v?e.$gc.relative:e.$hc.relative,e.$nc=v?e.$gc.dirname:e.$hc.dirname,e.$oc=v?e.$gc.basename:e.$hc.basename,e.$pc=v?e.$gc.extname:e.$hc.extname,e.$qc=v?e.$gc.format:e.$hc.format,e.$rc=v?e.$gc.parse:e.$hc.parse,e.$sc=v?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=v?e.$gc.sep:e.$hc.sep,e.$uc=v?e.$gc.delimiter:e.$hc.delimiter}),define(re[32],oe([0,1,9,4,25,12]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=P,e.$lg=k,e.$mg=u,e.$ng=l,e.$og=d,e.$pg=g,e.$qg=v,e.$rg=p,e.$sg=m,e.$tg=f,e.$ug=h,e.$vg=w,e.$wg=a,e.$xg=t,e.$yg=r,e.$zg=o;function P(c){return c===47||c===92}function k(c){return c.replace(/[\\/]/g,i.$hc.sep)}function u(c){return c.indexOf("/")===-1&&(c=k(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}function l(c,b=i.$hc.sep){if(!c)return"";const L=c.length,I=c.charCodeAt(0);if(P(I)){if(P(c.charCodeAt(1))&&!P(c.charCodeAt(2))){let O=3;const R=O;for(;O<L&&!P(c.charCodeAt(O));O++);if(R!==O&&!P(c.charCodeAt(O+1))){for(O+=1;O<L;O++)if(P(c.charCodeAt(O)))return c.slice(0,O+1).replace(/[\\/]/g,b)}}return b}else if(m(I)&&c.charCodeAt(1)===58)return P(c.charCodeAt(2))?c.slice(0,2)+b:c.slice(0,2);let j=c.indexOf("://");if(j!==-1){for(j+=3;j<L;j++)if(P(c.charCodeAt(j)))return c.slice(0,j+1)}return""}function d(c){if(!D.$i||!c||c.length<5)return!1;let b=c.charCodeAt(0);if(b!==92||(b=c.charCodeAt(1),b!==92))return!1;let L=2;const I=L;for(;L<c.length&&(b=c.charCodeAt(L),b!==92);L++);return!(I===L||(b=c.charCodeAt(L+1),isNaN(b)||b===92))}const y=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(c,b=D.$i){const L=b?y:E;return!(!c||c.length===0||/^\s+$/.test(c)||(L.lastIndex=0,L.test(c))||b&&$.test(c)||c==="."||c===".."||b&&c[c.length-1]==="."||b&&c.length!==c.trim().length||c.length>255)}function v(c,b,L){const I=c===b;return!L||I?I:!c||!b?!1:(0,S.$uf)(c,b)}function p(c,b,L,I=i.sep){if(c===b)return!0;if(!c||!b||b.length>c.length)return!1;if(L){if(!(0,S.$vf)(c,b))return!1;if(b.length===c.length)return!0;let O=b.length;return b.charAt(b.length-1)===I&&O--,c.charAt(O)===I}return b.charAt(b.length-1)!==I&&(b+=I),c.indexOf(b)===0}function m(c){return c>=65&&c<=90||c>=97&&c<=122}function f(c,b){return D.$i&&c.endsWith(":")&&(c+=i.sep),(0,i.$jc)(c)||(c=(0,i.$kc)(b,c)),c=(0,i.$ic)(c),D.$i?(c=(0,S.$cf)(c,i.sep),c.endsWith(":")&&(c+=i.sep)):(c=(0,S.$cf)(c,i.sep),c||(c=i.sep)),c}function h(c){const b=(0,i.$ic)(c);return D.$i?c.length>3?!1:w(b)&&(c.length===2||b.charCodeAt(2)===92):b===i.$hc.sep}function w(c,b=D.$i){return b?m(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}function a(c,b=D.$i){return w(c,b)?c[0]:void 0}function t(c,b,L){return b.length>c.length?-1:c===b?0:(L&&(c=c.toLowerCase(),b=b.toLowerCase()),c.indexOf(b))}function r(c){const b=c.split(":");let L,I,j;for(const O of b){const R=Number(O);(0,A.$9f)(R)?I===void 0?I=R:j===void 0&&(j=R):L=L?[L,O].join(":"):O}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:I!==void 0?I:void 0,column:j!==void 0?j:I!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(c,b,L=8){let I="";for(let O=0;O<L;O++){let R;O===0&&D.$i&&!b&&(L===3||L===4)?R=n:R=s,I+=R.charAt(Math.floor(Math.random()*R.length))}let j;return b?j=`${b}-${I}`:j=I,c?(0,i.$kc)(c,j):j}}),define(re[76],oe([0,1,4]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=A,e.$im=P;var D;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(D||(e.Source=D={}));var S;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function A(k,...u){const l=u.reduce((E,$)=>(E[$]=!0,E),{}),d=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(E=>!l[E]).forEach(E=>{for(let $=0;$<d.length;$++)if(E.search(d[$])!==-1){delete k[E];break}})}function P(k){k&&(delete k.DEBUG,i.$j&&delete k.DYLD_LIBRARY_PATH,i.$k&&delete k.LD_PRELOAD)}}),define(re[7],oe([0,1,9,4]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=g,e.$xc=w;const S=/^\w[\w\d+.-]*$/,A=/^\//,P=/^\/\//;function k(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!S.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!A.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(n,o){return!n&&!o?"file":n}function l(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==y&&(o=y+o):o=y;break}return o}const d="",y="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class ${static isUri(o){return o instanceof $?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,c,b,L,I,j=!1){typeof o=="object"?(this.scheme=o.scheme||d,this.authority=o.authority||d,this.path=o.path||d,this.query=o.query||d,this.fragment=o.fragment||d):(this.scheme=u(o,j),this.authority=c||d,this.path=l(this.scheme,b||d),this.query=L||d,this.fragment=I||d,k(this,j))}get fsPath(){return w(this,!1)}with(o){if(!o)return this;let{scheme:c,authority:b,path:L,query:I,fragment:j}=o;return c===void 0?c=this.scheme:c===null&&(c=d),b===void 0?b=this.authority:b===null&&(b=d),L===void 0?L=this.path:L===null&&(L=d),I===void 0?I=this.query:I===null&&(I=d),j===void 0?j=this.fragment:j===null&&(j=d),c===this.scheme&&b===this.authority&&L===this.path&&I===this.query&&j===this.fragment?this:new p(c,b,L,I,j)}static parse(o,c=!1){const b=E.exec(o);return b?new p(b[2]||d,s(b[4]||d),s(b[5]||d),s(b[7]||d),s(b[9]||d),c):new p(d,d,d,d,d)}static file(o){let c=d;if(D.$i&&(o=o.replace(/\\/g,y)),o[0]===y&&o[1]===y){const b=o.indexOf(y,2);b===-1?(c=o.substring(2),o=y):(c=o.substring(2,b),o=o.substring(b)||y)}return new p("file",c,o,d,d)}static from(o,c){return new p(o.scheme,o.authority,o.path,o.query,o.fragment,c)}static joinPath(o,...c){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return D.$i&&o.scheme==="file"?b=$.file(i.$gc.join(w(o,!0),...c)).path:b=i.$hc.join(o.path,...c),o.with({path:b})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof $)return o;{const c=new p(o);return c._formatted=o.external??null,c._fsPath=o._sep===v?o.fsPath??null:null,c}}else return o}}e.URI=$;function g(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}const v=D.$i?1:void 0;class p extends ${constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=v),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const m={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(n,o,c){let b,L=-1;for(let I=0;I<n.length;I++){const j=n.charCodeAt(I);if(j>=97&&j<=122||j>=65&&j<=90||j>=48&&j<=57||j===45||j===46||j===95||j===126||o&&j===47||c&&j===91||c&&j===93||c&&j===58)L!==-1&&(b+=encodeURIComponent(n.substring(L,I)),L=-1),b!==void 0&&(b+=n.charAt(I));else{b===void 0&&(b=n.substr(0,I));const O=m[j];O!==void 0?(L!==-1&&(b+=encodeURIComponent(n.substring(L,I)),L=-1),b+=O):L===-1&&(L=I)}}return L!==-1&&(b+=encodeURIComponent(n.substring(L))),b!==void 0?b:n}function h(n){let o;for(let c=0;c<n.length;c++){const b=n.charCodeAt(c);b===35||b===63?(o===void 0&&(o=n.substr(0,c)),o+=m[b]):o!==void 0&&(o+=n[c])}return o!==void 0?o:n}function w(n,o){let c;return n.authority&&n.path.length>1&&n.scheme==="file"?c=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?c=n.path.substr(1):c=n.path[1].toLowerCase()+n.path.substr(2):c=n.path,D.$i&&(c=c.replace(/\//g,"\\")),c}function a(n,o){const c=o?h:f;let b="",{scheme:L,authority:I,path:j,query:O,fragment:R}=n;if(L&&(b+=L,b+=":"),(I||L==="file")&&(b+=y,b+=y),I){let W=I.indexOf("@");if(W!==-1){const F=I.substr(0,W);I=I.substr(W+1),W=F.lastIndexOf(":"),W===-1?b+=c(F,!1,!1):(b+=c(F.substr(0,W),!1,!1),b+=":",b+=c(F.substr(W+1),!1,!0)),b+="@"}I=I.toLowerCase(),W=I.lastIndexOf(":"),W===-1?b+=c(I,!1,!0):(b+=c(I.substr(0,W),!1,!0),b+=I.substr(W))}if(j){if(j.length>=3&&j.charCodeAt(0)===47&&j.charCodeAt(2)===58){const W=j.charCodeAt(1);W>=65&&W<=90&&(j=`/${String.fromCharCode(W+32)}:${j.substr(3)}`)}else if(j.length>=2&&j.charCodeAt(1)===58){const W=j.charCodeAt(0);W>=65&&W<=90&&(j=`${String.fromCharCode(W+32)}:${j.substr(2)}`)}b+=c(j,!0,!1)}return O&&(b+="?",b+=c(O,!1,!1)),R&&(b+="#",b+=o?R:f(R,!1,!1)),b}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(r)?n.replace(r,o=>t(o)):n}}),define(re[156],oe([0,1,7]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=D,e.$Rq=S,e.$Sq=A,e.log=k;function D(l){const d=l;return d&&typeof d.type=="string"&&typeof d.severity=="string"}function S(l){const d=[];let y;try{const E=JSON.parse(l.arguments),$=E[E.length-1];$&&$.__$stack&&(E.pop(),y=$.__$stack),d.push(...E)}catch{d.push("Unable to log remote console arguments",l.arguments)}return{args:d,stack:y}}function A(l){if(typeof l!="string")return A(S(l).stack);const d=l;if(d){const y=P(d),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(E&&E.length===4)return{uri:i.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}function P(l){if(!l)return l;const d=l.indexOf(`
`);return d===-1?l:l.substring(0,d)}function k(l,d){const{args:y,stack:E}=S(l),$=typeof y[0]=="string"&&y.length===1;let g=P(E);g&&(g=`(${g.trim()})`);let v=[];if(typeof y[0]=="string"?g&&$?v=[`%c[${d}] %c${y[0]} %c${g}`,u("blue"),u(""),u("grey")]:v=[`%c[${d}] %c${y[0]}`,u("blue"),u(""),...y.slice(1)]:v=[`%c[${d}]%`,u("blue"),...y],g&&!$&&v.push(g),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,v)}function u(l){return`color: ${l}`}}),define(re[77],oe([0,1,17,7]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=S,e.$Zh=A,e.$1h=k;function S(u){return JSON.stringify(u,P)}function A(u){let l=JSON.parse(u);return l=k(l),l}function P(u,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function k(u,l=0){if(!u||l>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof i.$Ce||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let d=0;d<u.length;++d)u[d]=k(u[d],l+1);else for(const d in u)Object.hasOwnProperty.call(u,d)&&(u[d]=k(u[d],l+1))}return u}}),define(re[13],oe([0,1,15,4,25,7,9]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Eg=e.$Dg=e.$Cg=e.Schemas=void 0,e.$Ag=u,e.$Bg=l,e.$Fg=y;var k;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatCodeBlock="vscode-chat-code-block",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm",g.commentsInput="comment",g.codeSetting="code-setting"})(k||(e.Schemas=k={}));function u(g,v){return A.URI.isUri(g)?(0,S.$uf)(g.scheme,v):(0,S.$vf)(g,v+":")}function l(g,...v){return v.some(p=>u(g,p))}e.$Cg="vscode-tkn",e.$Dg="tkn";class d{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v,p){this.f=y(v,p)}getServerRootPath(){return this.f}get g(){return P.$hc.join(this.f,k.vscodeRemoteResource)}set(v,p,m){this.a[v]=p,this.b[v]=m}setConnectionToken(v,p){this.c[v]=p}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(a){return i.$1(a),v}const p=v.authority;let m=this.a[p];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const f=this.b[p],h=this.c[p];let w=`path=${encodeURIComponent(v.path)}`;return typeof h=="string"&&(w+=`&${e.$Dg}=${encodeURIComponent(h)}`),A.URI.from({scheme:D.$o?this.d:k.vscodeRemoteResource,authority:`${m}:${f}`,path:this.g,query:w})}}e.$Eg=new d;function y(g,v){return P.$hc.join(v??"/",`${g.quality??"oss"}-${g.commit??"dev"}`)}e.$Gg="vs/../../extensions",e.$Hg="vs/../../node_modules",e.$Ig="vs/../../node_modules.asar",e.$Jg="vs/../../node_modules.asar.unpacked",e.$Kg="vscode-app";class E{static{this.a=e.$Kg}asBrowserUri(v){const p=this.b(v,J);return this.uriToBrowserUri(p)}uriToBrowserUri(v){return v.scheme===k.vscodeRemote?e.$Eg.rewrite(v):v.scheme===k.file&&(D.$m||D.$q===`${k.vscodeFileResource}://${E.a}`)?v.with({scheme:k.vscodeFileResource,authority:v.authority||E.a,query:null,fragment:null}):v}asFileUri(v){const p=this.b(v,J);return this.uriToFileUri(p)}uriToFileUri(v){return v.scheme===k.vscodeFileResource?v.with({scheme:k.file,authority:v.authority!==E.a?v.authority:null,query:null,fragment:null}):v}b(v,p){return A.URI.isUri(v)?v:A.URI.parse(p.toUrl(v))}}e.$Lg=new E;var $;(function(g){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(v.get("3"));const p="vscode-coi";function m(h){let w;typeof h=="string"?w=new URL(h).searchParams:h instanceof URL?w=h.searchParams:A.URI.isUri(h)&&(w=new URL(h.toString(!0)).searchParams);const a=w?.get(p);if(a)return v.get(a)}g.getHeadersFromQuery=m;function f(h,w,a){if(!globalThis.crossOriginIsolated)return;const t=w&&a?"3":a?"2":"1";h instanceof URLSearchParams?h.set(p,t):h[p]=t}g.addSearchParam=f})($||(e.COI=$={}))}),define(re[19],oe([0,1,32,13,9,4,25,7]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0,e.$Sg=u,e.$bh=d,e.$ch=E;function u($){return(0,k.$xc)($,!0)}class l{constructor(g){this.a=g}compare(g,v,p=!1){return g===v?0:(0,P.$nf)(this.getComparisonKey(g,p),this.getComparisonKey(v,p))}isEqual(g,v,p=!1){return g===v?!0:!g||!v?!1:this.getComparisonKey(g,p)===this.getComparisonKey(v,p)}getComparisonKey(g,v=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,v,p=!1){if(g.scheme===v.scheme){if(g.scheme===D.Schemas.file)return i.$rg(u(g),u(v),this.a(g))&&g.query===v.query&&(p||g.fragment===v.fragment);if((0,e.$0g)(g.authority,v.authority))return i.$rg(g.path,v.path,this.a(g),"/")&&g.query===v.query&&(p||g.fragment===v.fragment)}return!1}joinPath(g,...v){return k.URI.joinPath(g,...v)}basenameOrAuthority(g){return(0,e.$2g)(g)||g.authority}basename(g){return S.$hc.basename(g.path)}extname(g){return S.$hc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let v;return g.scheme===D.Schemas.file?v=k.URI.file(S.$nc(u(g))).path:(v=S.$hc.dirname(g.path),g.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),v="/")),g.with({path:v})}normalizePath(g){if(!g.path.length)return g;let v;return g.scheme===D.Schemas.file?v=k.URI.file(S.$ic(u(g))).path:v=S.$hc.normalize(g.path),g.with({path:v})}relativePath(g,v){if(g.scheme!==v.scheme||!(0,e.$0g)(g.authority,v.authority))return;if(g.scheme===D.Schemas.file){const f=S.$mc(u(g),u(v));return A.$i?i.$lg(f):f}let p=g.path||"/";const m=v.path||"/";if(this.a(g)){let f=0;for(const h=Math.min(p.length,m.length);f<h&&!(p.charCodeAt(f)!==m.charCodeAt(f)&&p.charAt(f).toLowerCase()!==m.charAt(f).toLowerCase());f++);p=m.substr(0,f)+p.substr(f)}return S.$hc.relative(p,m)}resolvePath(g,v){if(g.scheme===D.Schemas.file){const p=k.URI.file(S.$lc(u(g),v));return g.with({authority:p.authority,path:p.path})}return v=i.$mg(v),g.with({path:S.$hc.resolve(g.path,v)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,v){return g===v||g!==void 0&&v!==void 0&&(0,P.$uf)(g,v)}hasTrailingPathSeparator(g,v=S.sep){if(g.scheme===D.Schemas.file){const p=u(g);return p.length>i.$ng(p).length&&p[p.length-1]===v}else{const p=g.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,v=S.sep){return(0,e.$$g)(g,v)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,v=S.sep){let p=!1;if(g.scheme===D.Schemas.file){const m=u(g);p=m!==void 0&&m.length===i.$ng(m).length&&m[m.length-1]===v}else{v="/";const m=g.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.$$g)(g,v)?g.with({path:g.path+"/"}):g}}e.$Tg=l,e.$Ug=new l(()=>!1),e.$Vg=new l($=>$.scheme===D.Schemas.file?!A.$k:!0),e.$Wg=new l($=>!0),e.$Xg=e.$Ug.isEqual.bind(e.$Ug),e.$Yg=e.$Ug.isEqualOrParent.bind(e.$Ug),e.$Zg=e.$Ug.getComparisonKey.bind(e.$Ug),e.$1g=e.$Ug.basenameOrAuthority.bind(e.$Ug),e.$2g=e.$Ug.basename.bind(e.$Ug),e.$3g=e.$Ug.extname.bind(e.$Ug),e.$4g=e.$Ug.dirname.bind(e.$Ug),e.$5g=e.$Ug.joinPath.bind(e.$Ug),e.$6g=e.$Ug.normalizePath.bind(e.$Ug),e.$7g=e.$Ug.relativePath.bind(e.$Ug),e.$8g=e.$Ug.resolvePath.bind(e.$Ug),e.$9g=e.$Ug.isAbsolutePath.bind(e.$Ug),e.$0g=e.$Ug.isEqualAuthority.bind(e.$Ug),e.$$g=e.$Ug.hasTrailingPathSeparator.bind(e.$Ug),e.$_g=e.$Ug.removeTrailingPathSeparator.bind(e.$Ug),e.$ah=e.$Ug.addTrailingPathSeparator.bind(e.$Ug);function d($,g){const v=[];for(let p=0;p<$.length;p++){const m=g($[p]);$.some((f,h)=>h===p?!1:(0,e.$Yg)(m,g(f)))||v.push($[p])}return v}var y;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function g(v){const p=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(h=>{const[w,a]=h.split(":");w&&a&&p.set(w,a)});const f=v.path.substring(0,v.path.indexOf(";"));return f&&p.set($.META_DATA_MIME,f),p}$.parseMetaData=g})(y||(e.DataUri=y={}));function E($,g,v){if(g){let p=$.path;return p&&p[0]!==S.$hc.sep&&(p=S.$hc.sep+p),$.with({scheme:v,authority:g,path:p})}return $.with({scheme:v})}}),define(re[8],oe([0,1,23,15,3,2,19,4,144,62]),function(J,e,i,D,S,A,P,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.Promises=e.$Oh=e.$Nh=e.$Mh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0,e.$dh=d,e.$eh=y,e.$fh=E,e.$gh=$,e.$hh=g,e.$ih=v,e.$jh=p,e.$kh=m,e.$sh=c,e.$th=b,e.$uh=L,e.$vh=I,e.$wh=j,e.$Lh=M,e.$Th=Q;function d(V){return!!V&&typeof V.then=="function"}function y(V){const H=new i.$me,se=V(H.token),he=new Promise((me,$e)=>{const ye=H.token.onCancellationRequested(()=>{ye.dispose(),$e(new D.$5)});Promise.resolve(se).then(Ee=>{ye.dispose(),H.dispose(),me(Ee)},Ee=>{ye.dispose(),H.dispose(),$e(Ee)})});return new class{cancel(){H.cancel(),H.dispose()}then(me,$e){return he.then(me,$e)}catch(me){return this.then(void 0,me)}finally(me){return he.finally(me)}}}function E(V,H,se){return new Promise((he,me)=>{const $e=H.onCancellationRequested(()=>{$e.dispose(),he(se)});V.then(he,me).finally(()=>$e.dispose())})}function $(V,H){return new Promise((se,he)=>{const me=H.onCancellationRequested(()=>{me.dispose(),he(new D.$5)});V.then(se,he).finally(()=>me.dispose())})}async function g(V){let H=-1;const se=V.map((he,me)=>he.then($e=>(H=me,$e)));try{return await Promise.race(se)}finally{V.forEach((he,me)=>{me!==H&&he.cancel()})}}function v(V,H,se){let he;const me=setTimeout(()=>{he?.(void 0),se?.()},H);return Promise.race([V.finally(()=>clearTimeout(me)),new Promise($e=>he=$e)])}function p(V){return new Promise((H,se)=>{const he=V();d(he)?he.then(H,se):H(he)})}function m(){let V,H;return{promise:new Promise((he,me)=>{V=he,H=me}),resolve:V,reject:H}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const se=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(se,se).then(he)})}return new Promise((se,he)=>{this.b.then(se,he)})}return this.a=H(),new Promise((se,he)=>{this.a.then(me=>{this.a=null,se(me)},me=>{this.a=null,he(me)})})}dispose(){this.f=!0}}e.$lh=f;class h{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$mh=h;class w{constructor(){this.a=new Map}queue(H,se){const me=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(H)===me&&this.a.delete(H)});return this.a.set(H,me),me}}e.$nh=w;const a=(V,H)=>{let se=!0;const he=setTimeout(()=>{se=!1,H()},V);return{isTriggered:()=>se,dispose:()=>{clearTimeout(he),se=!1}}},t=V=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,V())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class r{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,se=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((me,$e)=>{this.d=me,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=se===u.$$d?t(he):a(se,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new D.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$oh=r;class s{constructor(H){this.a=new r(H),this.b=new f}trigger(H,se){return this.a.trigger(()=>this.b.queue(H),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ph=s;class n{constructor(){this.a=!1,this.b=new Promise((H,se)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$qh=n;class o extends n{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$rh=o;function c(V,H){return H?new Promise((se,he)=>{const me=setTimeout(()=>{$e.dispose(),se()},V),$e=H.onCancellationRequested(()=>{clearTimeout(me),$e.dispose(),he(new D.$5)})}):y(se=>c(V,se))}function b(V,H=0,se){const he=setTimeout(()=>{V(),se&&me.dispose()},H),me=(0,A.$Sc)(()=>{clearTimeout(he),se?.deleteAndLeak(me)});return se?.add(me),me}function L(V){const H=[];let se=0;const he=V.length;function me(){return se<he?V[se++]():null}function $e(ye){ye!=null&&H.push(ye);const Ee=me();return Ee?Ee.then($e):Promise.resolve(H)}return Promise.resolve(null).then($e)}function I(V,H=he=>!!he,se=null){let he=0;const me=V.length,$e=()=>{if(he>=me)return Promise.resolve(se);const ye=V[he++];return Promise.resolve(ye()).then(ke=>H(ke)?Promise.resolve(ke):$e())};return $e()}function j(V,H=he=>!!he,se=null){if(V.length===0)return Promise.resolve(se);let he=V.length;const me=()=>{he=-1;for(const $e of V)$e.cancel?.()};return new Promise(($e,ye)=>{for(const Ee of V)Ee.then(ke=>{--he>=0&&H(ke)?(me(),$e(ke)):he===0&&$e(se)}).catch(ke=>{--he>=0&&(me(),ye(ke))})})}class O{constructor(H){this.a=0,this.b=!1,this.f=H,this.g=[],this.d=0,this.h=new S.$be}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(H){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,he)=>{this.g.push({factory:H,c:se,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const H=this.g.shift();this.d++;const se=H.factory();se.then(H.c,H.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$xh=O;class R extends O{constructor(){super(1)}}e.$yh=R;class W{constructor(){this.a=new z,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$zh=W;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new G;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueSize(H,se=P.$Ug){const he=se.getComparisonKey(H);return this.a.get(he)?.size??0}queueFor(H,se,he=P.$Ug){const me=he.getComparisonKey(H);let $e=this.a.get(me);if(!$e){$e=new R;const ye=this.f++,Ee=S.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(ye),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set(ye,Ee),this.a.set(me,$e)}return $e.queue(se)}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ah=F;class T{constructor(H,se){this.a=-1,typeof H=="function"&&typeof se=="number"&&this.setIfNotSet(H,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},se)}setIfNotSet(H,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},se))}}e.$Bh=T;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,se,he=globalThis){this.cancel();const me=he.setInterval(()=>{H()},se);this.d=(0,A.$Sc)(()=>{he.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$Ch=q;class ue{constructor(H,se){this.b=-1,this.a=H,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Dh=ue;class ee{constructor(H,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=H,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Eh=ee;class ce extends ue{constructor(H,se){super(H,se),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$Fh=ce;class K extends A.$Uc{constructor(H,se){super(),this.g=H,this.h=se,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of H)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ue(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Gh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ih=(V,H)=>{(0,k.$B)(()=>{if(se)return;const he=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Ih=(V,H,se)=>{const he=V.requestIdleCallback(H,typeof se=="number"?{timeout:se}:void 0);let me=!1;return{dispose(){me||(me=!0,V.cancelIdleCallback(he))}}},e.$Hh=V=>(0,e.$Ih)(globalThis,V)}();class X{constructor(H,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Ih)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Jh=X;class B extends X{constructor(H){super(globalThis,H)}}e.$Kh=B;async function M(V,H,se){let he;for(let me=0;me<se;me++)try{return await V()}catch($e){he=$e,await c(H)}throw he}class z{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,se,he){return this.a={taskId:H,cancel:()=>he?.(),promise:se},se.then(()=>this.d(H),()=>this.d(H)),se}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{const{promise:se,resolve:he,reject:me}=m();this.b={run:H,promise:se,promiseResolve:he,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Mh=z;class U{constructor(H,se=()=>Date.now()){this.d=H,this.f=se,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$Nh=U;var ae;(function(V){V[V.Resolved=0]="Resolved",V[V.Rejected=1]="Rejected"})(ae||(ae={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,se)=>{this.a=H,this.b=se})}complete(H){return new Promise(se=>{this.a(H),this.d={outcome:0,value:H},se()})}error(H){return new Promise(se=>{this.b(H),this.d={outcome:1,value:H},se()})}cancel(){return this.error(new D.$5)}}e.$Oh=G;var le;(function(V){async function H(he){let me;const $e=await Promise.all(he.map(ye=>ye.then(Ee=>Ee,Ee=>{me||(me=Ee)})));if(typeof me<"u")throw me;return $e}V.settled=H;function se(he){return new Promise(async(me,$e)=>{try{await he(me,$e)}catch(ye){$e(ye)}})}V.withAsyncBody=se})(le||(e.Promises=le={}));class Y{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(H){this.a=void 0,this.b=void 0,this.d=!1,this.promise=H.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new D.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ph=Y;class C{constructor(H){this.b=H,this.a=new l.$V(()=>new Y(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Qh=C;var N;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(N||(N={}));class _{static fromArray(H){return new _(se=>{se.emitMany(H)})}static fromPromise(H){return new _(async se=>{se.emitMany(await H)})}static fromPromises(H){return new _(async se=>{await Promise.all(H.map(async he=>se.emitOne(await he)))})}static merge(H){return new _(async se=>{await Promise.all(H.map(async he=>{for await(const me of he)se.emitOne(me)}))})}static{this.EMPTY=_.fromArray([])}constructor(H,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new S.$be,queueMicrotask(async()=>{const he={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(H(he)),this.k()}catch(me){this.l(me)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(H,se){return new _(async he=>{for await(const me of H)he.emitOne(se(me))})}map(H){return _.map(this,H)}static filter(H,se){return new _(async he=>{for await(const me of H)se(me)&&he.emitOne(me)})}filter(H){return _.filter(this,H)}static coalesce(H){return _.filter(H,se=>!!se)}coalesce(){return _.coalesce(this)}static async toPromise(H){const se=[];for await(const he of H)se.push(he);return se}toPromise(){return _.toPromise(this)}h(H){this.a===0&&(this.b.push(H),this.g.fire())}j(H){this.a===0&&(this.b=this.b.concat(H),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(H){this.a===0&&(this.a=2,this.d=H,this.g.fire())}}e.$Rh=_;class ne extends _{constructor(H,se){super(se),this.m=H}cancel(){this.m.cancel()}}e.$Sh=ne;function Q(V){const H=new i.$me,se=V(H.token);return new ne(H,async he=>{const me=H.token.onCancellationRequested(()=>{me.dispose(),H.dispose(),he.reject(new D.$5)});try{for await(const $e of se){if(H.token.isCancellationRequested)return;he.emitOne($e)}me.dispose(),H.dispose()}catch($e){me.dispose(),H.dispose(),he.reject($e)}})}class x{constructor(H){this.a=new G,this.b=new _(me=>{if(se){me.reject(se);return}return he&&me.emitMany(he),this.d=$e=>me.reject($e),this.f=$e=>me.emitOne($e),this.a.p},H);let se,he;this.f=me=>{he||(he=[]),he.push(me)},this.d=me=>{se||(se=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$Uh=x}),define(re[108],oe([0,1,22,8,32,31,9,4,25]),function(J,e,i,D,S,A,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=void 0,e.$gk=l,e.$jk=g,e.$kk=R,e.$lk=W,e.$mk=F,e.$nk=T,e.$ok=q,e.$pk=K;function l(){return Object.create(null)}e.$hk="**",e.$ik="/";const d="[/\\\\]",y="[^/\\\\]",E=/\//g;function $(X,B){switch(X){case 0:return"";case 1:return`${y}*?`;default:return`(?:${d}|${y}+${d}${B?`|${d}${y}+`:""})*?`}}function g(X,B){if(!X)return[];const M=[];let z=!1,U=!1,ae="";for(const G of X){switch(G){case B:if(!z&&!U){M.push(ae),ae="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":U=!0;break;case"]":U=!1;break}ae+=G}return ae&&M.push(ae),M}function v(X){if(!X)return"";let B="";const M=g(X,e.$ik);if(M.every(z=>z===e.$hk))B=".*";else{let z=!1;M.forEach((U,ae)=>{if(U===e.$hk){if(z)return;B+=$(2,ae===M.length-1)}else{let G=!1,le="",Y=!1,C="";for(const N of U){if(N!=="}"&&G){le+=N;continue}if(Y&&(N!=="]"||!C)){let _;N==="-"?_=N:(N==="^"||N==="!")&&!C?_="^":N===e.$ik?_="":_=(0,u.$9e)(N),C+=_;continue}switch(N){case"{":G=!0;continue;case"[":Y=!0;continue;case"}":{const ne=`(?:${g(le,",").map(Q=>v(Q)).join("|")})`;B+=ne,G=!1,le="";break}case"]":{B+="["+C+"]",Y=!1,C="";break}case"?":B+=y;continue;case"*":B+=$(1);continue;default:B+=(0,u.$9e)(N)}}ae<M.length-1&&(M[ae+1]!==e.$hk||ae+2<M.length)&&(B+=d)}z=U===e.$hk})}return B}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Ec(1e4),r=function(){return!1},s=function(){return null};function n(X,B){if(!X)return s;let M;typeof X!="string"?M=X.pattern:M=X,M=M.trim();const z=`${M}_${!!B.trimForExclusions}`;let U=t.get(z);if(U)return o(U,X);let ae;return p.test(M)?U=b(M.substr(4),M):(ae=m.exec(c(M,B)))?U=L(ae[1],M):(B.trimForExclusions?h:f).test(M)?U=I(M,B):(ae=w.exec(c(M,B)))?U=j(ae[1].substr(1),M,!0):(ae=a.exec(c(M,B)))?U=j(ae[1],M,!1):U=O(M),t.set(z,U),o(U,X)}function o(X,B){if(typeof B=="string")return X;const M=function(z,U){return(0,S.$rg)(z,B.base,!k.$k)?X((0,u.$bf)(z.substr(B.base.length),P.sep),U):null};return M.allBasenames=X.allBasenames,M.allPaths=X.allPaths,M.basenames=X.basenames,M.patterns=X.patterns,M}function c(X,B){return B.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function b(X,B){return function(M,z){return typeof M=="string"&&M.endsWith(X)?B:null}}function L(X,B){const M=`/${X}`,z=`\\${X}`,U=function(G,le){return typeof G!="string"?null:le?le===X?B:null:G===X||G.endsWith(M)||G.endsWith(z)?B:null},ae=[X];return U.basenames=ae,U.patterns=[B],U.allBasenames=ae,U}function I(X,B){const M=ce(X.slice(1,-1).split(",").map(le=>n(le,B)).filter(le=>le!==s),X),z=M.length;if(!z)return s;if(z===1)return M[0];const U=function(le,Y){for(let C=0,N=M.length;C<N;C++)if(M[C](le,Y))return X;return null},ae=M.find(le=>!!le.allBasenames);ae&&(U.allBasenames=ae.allBasenames);const G=M.reduce((le,Y)=>Y.allPaths?le.concat(Y.allPaths):le,[]);return G.length&&(U.allPaths=G),U}function j(X,B,M){const z=P.sep===P.$hc.sep,U=z?X:X.replace(E,P.sep),ae=P.sep+U,G=P.$hc.sep+X;let le;return M?le=function(Y,C){return typeof Y=="string"&&(Y===U||Y.endsWith(ae)||!z&&(Y===X||Y.endsWith(G)))?B:null}:le=function(Y,C){return typeof Y=="string"&&(Y===U||!z&&Y===X)?B:null},le.allPaths=[(M?"*/":"./")+X],le}function O(X){try{const B=new RegExp(`^${v(X)}$`);return function(M){return B.lastIndex=0,typeof M=="string"&&B.test(M)?X:null}}catch{return s}}function R(X,B,M){return!X||typeof B!="string"?!1:W(X)(B,void 0,M)}function W(X,B={}){if(!X)return r;if(typeof X=="string"||F(X)){const M=n(X,B);if(M===s)return r;const z=function(U,ae){return!!M(U,ae)};return M.allBasenames&&(z.allBasenames=M.allBasenames),M.allPaths&&(z.allPaths=M.allPaths),z}return ue(X,B)}function F(X){const B=X;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function T(X){return X.allBasenames||[]}function q(X){return X.allPaths||[]}function ue(X,B){const M=ce(Object.getOwnPropertyNames(X).map(le=>ee(le,X[le],B)).filter(le=>le!==s)),z=M.length;if(!z)return s;if(!M.some(le=>!!le.requiresSiblings)){if(z===1)return M[0];const le=function(N,_){let ne;for(let Q=0,x=M.length;Q<x;Q++){const V=M[Q](N,_);if(typeof V=="string")return V;(0,D.$dh)(V)&&(ne||(ne=[]),ne.push(V))}return ne?(async()=>{for(const Q of ne){const x=await Q;if(typeof x=="string")return x}return null})():null},Y=M.find(N=>!!N.allBasenames);Y&&(le.allBasenames=Y.allBasenames);const C=M.reduce((N,_)=>_.allPaths?N.concat(_.allPaths):N,[]);return C.length&&(le.allPaths=C),le}const U=function(le,Y,C){let N,_;for(let ne=0,Q=M.length;ne<Q;ne++){const x=M[ne];x.requiresSiblings&&C&&(Y||(Y=(0,P.$oc)(le)),N||(N=Y.substr(0,Y.length-(0,P.$pc)(le).length)));const V=x(le,Y,N,C);if(typeof V=="string")return V;(0,D.$dh)(V)&&(_||(_=[]),_.push(V))}return _?(async()=>{for(const ne of _){const Q=await ne;if(typeof Q=="string")return Q}return null})():null},ae=M.find(le=>!!le.allBasenames);ae&&(U.allBasenames=ae.allBasenames);const G=M.reduce((le,Y)=>Y.allPaths?le.concat(Y.allPaths):le,[]);return G.length&&(U.allPaths=G),U}function ee(X,B,M){if(B===!1)return s;const z=n(X,M);if(z===s)return s;if(typeof B=="boolean")return z;if(B){const U=B.when;if(typeof U=="string"){const ae=(G,le,Y,C)=>{if(!C||!z(G,le))return null;const N=U.replace("$(basename)",()=>Y),_=C(N);return(0,D.$dh)(_)?_.then(ne=>ne?X:null):_?X:null};return ae.requiresSiblings=!0,ae}}return z}function ce(X,B){const M=X.filter(le=>!!le.basenames);if(M.length<2)return X;const z=M.reduce((le,Y)=>{const C=Y.basenames;return C?le.concat(C):le},[]);let U;if(B){U=[];for(let le=0,Y=z.length;le<Y;le++)U.push(B)}else U=M.reduce((le,Y)=>{const C=Y.patterns;return C?le.concat(C):le},[]);const ae=function(le,Y){if(typeof le!="string")return null;if(!Y){let N;for(N=le.length;N>0;N--){const _=le.charCodeAt(N-1);if(_===47||_===92)break}Y=le.substr(N)}const C=z.indexOf(Y);return C!==-1?U[C]:null};ae.basenames=z,ae.patterns=U,ae.allBasenames=z;const G=X.filter(le=>!le.basenames);return G.push(ae),G}function K(X,B){return(0,i.$ub)(X,B,(M,z)=>typeof M=="string"&&typeof z=="string"?M===z:typeof M!="string"&&typeof z!="string"?M.base===z.base&&M.pattern===z.pattern:!1)}}),define(re[48],oe([0,1,22,32,9,4,19,25]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=u,e.$rw=d,e.$sw=E,e.$tw=$,e.$uw=m,e.$vw=h,e.$ww=w,e.$xw=a,e.$yw=t,e.$zw=r;function u(n,o){const{os:c,tildify:b,relative:L}=o;if(L){const O=l(n,L,c);if(typeof O=="string")return O}let I=n.fsPath;if(c===1&&!A.$i?I=I.replace(/\//g,"\\"):c!==1&&A.$i&&(I=I.replace(/\\/g,"/")),c!==1&&b?.userHome){const O=b.userHome.fsPath;let R;n.scheme!==b.userHome.scheme&&n.path[0]===S.$hc.sep&&n.path[1]!==S.$hc.sep?R=b.userHome.with({path:n.path}).fsPath:R=I,I=E(R,O,c)}return(c===1?S.$gc:S.$hc).normalize(d(I,c===1))}function l(n,o,c){const b=c===1?S.$gc:S.$hc,L=c===3?P.$Ug:P.$Wg,I=o.getWorkspace(),j=(0,i.$Ob)(I.folders);if(!j)return;n.scheme!==j.uri.scheme&&n.path[0]===S.$hc.sep&&n.path[1]!==S.$hc.sep&&(n=j.uri.with({path:n.path}));const O=o.getWorkspaceFolder(n);if(!O)return;let R;if(L.isEqual(O.uri,n)?R="":R=L.relativePath(O.uri,n)??"",R&&(R=b.normalize(R)),I.folders.length>1&&!o.noPrefix){const W=O.name?O.name:L.basenameOrAuthority(O.uri);R=R?`${W} \u2022 ${R}`:W}return R}function d(n,o=A.$i){return(0,D.$vg)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}let y=Object.create(null);function E(n,o,c=A.OS){if(c===1||!n||!o)return n;let b=y.original===o?y.normalized:void 0;b||(b=o,A.$i&&(b=(0,D.$lg)(b)),b=`${(0,k.$cf)(b,S.$hc.sep)}${S.$hc.sep}`,y={original:o,normalized:b});let L=n;return A.$i&&(L=(0,D.$lg)(L)),(c===3?L.startsWith(b):(0,k.$vf)(L,b))?`~/${L.substr(b.length)}`:n}function $(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}const g="\u2026",v="\\\\",p="~";function m(n,o=S.sep){const c=new Array(n.length);let b=!1;for(let L=0;L<n.length;L++){const I=n[L];if(I===""){c[L]=`.${o}`;continue}if(!I){c[L]=I;continue}b=!0;let j="",O=I;O.indexOf(v)===0?(j=O.substr(0,O.indexOf(v)+v.length),O=O.substr(O.indexOf(v)+v.length)):O.indexOf(o)===0?(j=O.substr(0,O.indexOf(o)+o.length),O=O.substr(O.indexOf(o)+o.length)):O.indexOf(p)===0&&(j=O.substr(0,O.indexOf(p)+p.length),O=O.substr(O.indexOf(p)+p.length));const R=O.split(o);for(let W=1;b&&W<=R.length;W++)for(let F=R.length-W;b&&F>=0;F--){b=!1;let T=R.slice(F,F+W).join(o);for(let q=0;!b&&q<n.length;q++)if(q!==L&&n[q]&&n[q].indexOf(T)>-1){const ue=F+W===R.length,ee=F>0&&n[q].indexOf(o)>-1?o+T:T,ce=n[q].endsWith(ee);b=!ue||ce}if(!b){let q="";(R[0].endsWith(":")||j!=="")&&(F===1&&(F=0,W++,T=R[0]+o+T),F>0&&(q=R[0]+o),q=j+q),F>0&&(q=q+g+o),q=q+T,F+W<R.length&&(q=q+o+g),c[L]=q}}b&&(c[L]=I)}return c}var f;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function h(n,o=Object.create(null)){const c=[];let b=!1,L="";for(const I of n)if(I==="$"||b&&I==="{")L&&c.push({value:L,type:f.TEXT}),L="",b=!0;else if(I==="}"&&b){const j=o[L];if(typeof j=="string")j.length&&c.push({value:j,type:f.VARIABLE});else if(j){const O=c[c.length-1];(!O||O.type!==f.SEPARATOR)&&c.push({value:j.label,type:f.SEPARATOR})}L="",b=!1}else L+=I;return L&&!b&&c.push({value:L,type:f.TEXT}),c.filter((I,j)=>{if(I.type===f.SEPARATOR){const O=c[j-1],R=c[j+1];return[O,R].every(W=>W&&(W.type===f.VARIABLE||W.type===f.TEXT)&&W.value.length>0)}return!0}).map(I=>I.value).join("")}function w(n,o){return A.$j||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):n.replace(/&&|&/g,c=>c==="&"?"&&":"&")}function a(n,o){return A.$j||o?n.replace(/\(&&\w\)|&&/g,""):A.$i?n.replace(/&&|&/g,c=>c==="&"?"&&":"&"):n.replace(/&&/g,"_")}function t(n){return n.replace(/&/g,"&&")}function r(n){if(n.endsWith("]")){const o=n.lastIndexOf(" [",n.length-2);if(o!==-1){const c=s(n.substring(0,o)),b=n.substring(o);return{name:c.name+b,parentPath:c.parentPath}}}return s(n)}function s(n){const o=n.indexOf("/")!==-1?S.$hc:S.$gc,c=o.basename(n),b=o.dirname(n);return c.length?{name:c,parentPath:b}:{name:b,parentPath:""}}}),define(re[157],oe([0,1,17,7]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=void 0,e.$vn=k,e.$wn=l,e.$xn=d;function S(y){return y.toJSON()}class A{constructor(E){this.a=E}transformIncoming(E){const $=this.a.transformIncoming(E);return $===E?E:S(D.URI.from($))}transformOutgoing(E){const $=this.a.transformOutgoing(E);return $===E?E:S(D.URI.from($))}transformOutgoingURI(E){const $=this.a.transformOutgoing(E);return $===E?E:D.URI.from($)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$tn=A,e.$un=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function P(y,E,$){if(!y||$>200)return null;if(typeof y=="object"){if(y instanceof D.URI)return E.transformOutgoing(y);for(const g in y)if(Object.hasOwnProperty.call(y,g)){const v=P(y[g],E,$+1);v!==null&&(y[g]=v)}}return null}function k(y,E){const $=P(y,E,0);return $===null?y:$}function u(y,E,$,g){if(!y||g>200)return null;if(typeof y=="object"){if(y.$mid===1)return $?D.URI.revive(E.transformIncoming(y)):E.transformIncoming(y);if(y instanceof i.$Ce)return null;for(const v in y)if(Object.hasOwnProperty.call(y,v)){const p=u(y[v],E,$,g+1);p!==null&&(y[v]=p)}}return null}function l(y,E){const $=u(y,E,!1,0);return $===null?y:$}function d(y,E){const $=u(y,E,!0,0);return $===null?y:$}}),define(re[89],oe([0,1,26,59,33,147,4]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=void 0,e.$An=u,e.$Bn=y,e.$zn=new class{c(E){return this.a||(this.a=D.$xi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(E)}value(){if(this.b===void 0){let E=0,$=0;const g=(0,i.networkInterfaces)();for(const v in g){const p=g[v];if(p)for(const{mac:m,internal:f}of p)f||($+=1,this.c(m.toUpperCase())&&(E+=1))}this.b=$>0?E/$:0}return this.b}};let k;async function u(E){return k||(k=(async()=>await l(E)||S.$Ng())()),k}async function l(E){try{const $=await new Promise((v,p)=>{J(["crypto"],v,p)}),g=(0,A.$yn)();return $.createHash("sha256").update(g,"utf8").digest("hex")}catch($){E($);return}}const d="Software\\Microsoft\\SQMClient";async function y(E){if(P.$i){const $=await new Promise((g,v)=>{J(["@vscode/windows-registry"],g,v)});try{return $.GetStringRegKey("HKEY_LOCAL_MACHINE",d,"MachineId")||""}catch(g){return E(g),""}}return""}}),define(re[21],oe([0,1,43,26,158,8,32,72,9,4,19,7]),function(J,e,i,D,S,A,P,k,u,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=p,e.readdirSync=h,e.whenDeleted=t,e.configureFlushOnWrite=c,e.writeFileSync=L;var E;(function(ee){ee[ee.UNLINK=0]="UNLINK",ee[ee.MOVE=1]="MOVE"})(E||(e.RimRafMode=E={}));async function $(ee,ce=E.UNLINK,K){if((0,P.$ug)(ee))throw new Error("rimraf - will refuse to recursively delete root");return ce===E.UNLINK?v(ee):g(ee,K)}async function g(ee,ce=(0,P.$zg)((0,D.tmpdir)())){try{try{await i.promises.rename(ee,ce)}catch(K){return K.code==="ENOENT"?void 0:v(ee)}v(ce).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function v(ee){return(0,S.promisify)(i.rm)(ee,{recursive:!0,force:!0,maxRetries:3})}function p(ee){if((0,P.$ug)(ee))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(ee,{recursive:!0,force:!0,maxRetries:3})}async function m(ee,ce){return w(await(ce?f(ee):(0,S.promisify)(i.readdir)(ee)))}async function f(ee){try{return await(0,S.promisify)(i.readdir)(ee,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const ce=[],K=await m(ee);for(const X of K){let B=!1,M=!1,z=!1;try{const U=await e.Promises.lstat((0,u.$kc)(ee,X));B=U.isFile(),M=U.isDirectory(),z=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}ce.push({name:X,isFile:()=>B,isDirectory:()=>M,isSymbolicLink:()=>z})}return ce}function h(ee){return w(i.readdirSync(ee))}function w(ee){return ee.map(ce=>typeof ce=="string"?l.$j?(0,k.$9l)(ce):ce:(ce.name=l.$j?(0,k.$9l)(ce.name):ce.name,ce))}async function a(ee){const ce=await m(ee),K=[];for(const X of ce)await r.existsDirectory((0,u.$kc)(ee,X))&&K.push(X);return K}function t(ee,ce=1e3){return new Promise(K=>{let X=!1;const B=setInterval(()=>{X||(X=!0,i.access(ee,M=>{X=!1,M&&(clearInterval(B),K(void 0))}))},ce)})}var r;(function(ee){async function ce(B){let M;try{if(M=await e.Promises.lstat(B),!M.isSymbolicLink())return{stat:M}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:M?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(l.$i&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw U}throw z}}ee.stat=ce;async function K(B){try{const{stat:M,symbolicLink:z}=await ee.stat(B);return M.isFile()&&z?.dangling!==!0}catch{}return!1}ee.existsFile=K;async function X(B){try{const{stat:M,symbolicLink:z}=await ee.stat(B);return M.isDirectory()&&z?.dangling!==!0}catch{}return!1}ee.existsDirectory=X})(r||(e.SymlinkSupport=r={}));const s=new A.$Ah;function n(ee,ce,K){return s.queueFor(y.URI.file(ee),()=>{const X=I(K);return new Promise((B,M)=>b(ee,ce,X,z=>z?M(z):B()))},d.$Vg)}let o=!0;function c(ee){o=ee}function b(ee,ce,K,X){if(!o)return i.writeFile(ee,ce,{mode:K.mode,flag:K.flag},X);i.open(ee,K.flag,K.mode,(B,M)=>{if(B)return X(B);i.writeFile(M,ce,z=>{if(z)return i.close(M,()=>X(z));i.fdatasync(M,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),c(!1)),i.close(M,ae=>X(ae))))})})}function L(ee,ce,K){const X=I(K);if(!o)return i.writeFileSync(ee,ce,{mode:X.mode,flag:X.flag});const B=i.openSync(ee,X.flag,X.mode);try{i.writeFileSync(B,ce);try{i.fdatasyncSync(B)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),c(!1)}}finally{i.closeSync(B)}}function I(ee){return ee?{mode:typeof ee.mode=="number"?ee.mode:438,flag:typeof ee.flag=="string"?ee.flag:"w"}:{mode:438,flag:"w"}}async function j(ee,ce,K=6e4){if(ee!==ce)try{l.$i&&typeof K=="number"?await O(ee,ce,Date.now(),K):await(0,S.promisify)(i.rename)(ee,ce)}catch(X){if(ee.toLowerCase()!==ce.toLowerCase()&&X.code==="EXDEV"||ee.endsWith("."))await R(ee,ce,{preserveSymlinks:!1}),await $(ee,E.MOVE);else throw X}}async function O(ee,ce,K,X,B=0){try{return await(0,S.promisify)(i.rename)(ee,ce)}catch(M){if(M.code!=="EACCES"&&M.code!=="EPERM"&&M.code!=="EBUSY")throw M;if(Date.now()-K>=X)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${M}`),M;if(B===0){let z=!1;try{const{stat:U}=await r.stat(ce);U.isFile()||(z=!0)}catch{}if(z)throw M}return await(0,A.$sh)(Math.min(100,B*10)),O(ee,ce,K,X,B+1)}}async function R(ee,ce,K){return F(ee,ce,{root:{source:ee,target:ce},options:K,handledSourcePaths:new Set})}const W=511;async function F(ee,ce,K){if(K.handledSourcePaths.has(ee))return;K.handledSourcePaths.add(ee);const{stat:X,symbolicLink:B}=await r.stat(ee);if(B){if(K.options.preserveSymlinks)try{return await ue(ee,ce,K)}catch{}if(B.dangling)return}return X.isDirectory()?T(ee,ce,X.mode&W,K):q(ee,ce,X.mode&W)}async function T(ee,ce,K,X){await e.Promises.mkdir(ce,{recursive:!0,mode:K});const B=await m(ee);for(const M of B)await F((0,u.$kc)(ee,M),(0,u.$kc)(ce,M),X)}async function q(ee,ce,K){await e.Promises.copyFile(ee,ce),await e.Promises.chmod(ce,K)}async function ue(ee,ce,K){let X=await e.Promises.readlink(ee);(0,P.$rg)(X,K.root.source,!l.$k)&&(X=(0,u.$kc)(K.root.target,X.substr(K.root.source.length+1))),await e.Promises.symlink(X,ce)}e.Promises=new class{get access(){return(0,S.promisify)(i.access)}get stat(){return(0,S.promisify)(i.stat)}get lstat(){return(0,S.promisify)(i.lstat)}get utimes(){return(0,S.promisify)(i.utimes)}get read(){return(ee,ce,K,X,B)=>new Promise((M,z)=>{i.read(ee,ce,K,X,B,(U,ae,G)=>U?z(U):M({bytesRead:ae,buffer:G}))})}get readFile(){return(0,S.promisify)(i.readFile)}get write(){return(ee,ce,K,X,B)=>new Promise((M,z)=>{i.write(ee,ce,K,X,B,(U,ae,G)=>U?z(U):M({bytesWritten:ae,buffer:G}))})}get appendFile(){return(0,S.promisify)(i.appendFile)}get fdatasync(){return(0,S.promisify)(i.fdatasync)}get truncate(){return(0,S.promisify)(i.truncate)}get copyFile(){return(0,S.promisify)(i.copyFile)}get open(){return(0,S.promisify)(i.open)}get close(){return(0,S.promisify)(i.close)}get symlink(){return(0,S.promisify)(i.symlink)}get readlink(){return(0,S.promisify)(i.readlink)}get chmod(){return(0,S.promisify)(i.chmod)}get mkdir(){return(0,S.promisify)(i.mkdir)}get unlink(){return(0,S.promisify)(i.unlink)}get rmdir(){return(0,S.promisify)(i.rmdir)}get realpath(){return(0,S.promisify)(i.realpath)}async exists(ee){try{return await e.Promises.access(ee),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return a}get writeFile(){return n}get rm(){return $}get rename(){return j}get copy(){return R}}}),define(re[109],oe([0,1,43,9,4,25,21]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=k,e.$Zq=u,e.$1q=l,e.$2q=d;function k(E){if(S.$k)return E;const $=(0,D.$nc)(E);if(E===$)return E;const g=((0,D.$oc)(E)||E).toLowerCase();try{const p=(0,P.readdirSync)($).filter(m=>m.toLowerCase()===g);if(p.length===1){const m=k($);if(m)return(0,D.$kc)(m,p[0])}else if(p.length>1){const m=p.indexOf(g);if(m>=0){const f=k($);if(f)return(0,D.$kc)(f,p[m])}}}catch{}return null}async function u(E,$){if(S.$k)return E;const g=(0,D.$nc)(E);if(E===g)return E;const v=((0,D.$oc)(E)||E).toLowerCase();try{if($?.isCancellationRequested)return null;const m=(await P.Promises.readdir(g)).filter(f=>f.toLowerCase()===v);if(m.length===1){const f=await u(g,$);if(f)return(0,D.$kc)(f,m[0])}else if(m.length>1){const f=m.indexOf(v);if(f>=0){const h=await u(g,$);if(h)return(0,D.$kc)(h,m[f])}}}catch{}return null}async function l(E){try{return await P.Promises.realpath(E)}catch{const g=y(E);return await P.Promises.access(g,i.constants.R_OK),g}}function d(E){try{return i.realpathSync(E)}catch{const g=y(E);return i.accessSync(g,i.constants.R_OK),g}}function y(E){return(0,A.$cf)((0,D.$ic)(E),D.sep)}}),define(re[110],oe([0,1,26,9,21]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=f,e.$gm=h;const A=/^\d+$/,P=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var u;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(u||(u={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let d;process.env.PROCESSOR_ARCHITEW6432?d=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?d=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?d=1:d=0;class y{constructor(a,t,r){this.exePath=a,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function E({useAlternateBitness:w=!1}={}){return w?l===0?process.env["ProgramFiles(x86)"]||null:d===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:w=!1,findPreview:a=!1}={}){const t=E({useAlternateBitness:w});if(!t)return null;const r=D.$kc(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(r))return null;let s=-1,n=null;for(const b of await S.Promises.readdir(r)){let L=-1;if(a){const j=b.indexOf("-");if(j<0)continue;const O=b.substring(0,j);if(!A.test(O)||b.substring(j+1)!=="preview")continue;L=parseInt(O,10)}else{if(!A.test(b))continue;L=parseInt(b,10)}if(L<=s)continue;const I=D.$kc(r,b,"pwsh.exe");await S.SymlinkSupport.existsFile(I)&&(n=I,s=L)}if(!n)return null;const o=t.includes("x86")?" (x86)":"",c=a?" Preview":"";return new y(n,`PowerShell${c}${o}`,!0)}async function g({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const a=D.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=w?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await S.Promises.readdir(a))if(t.test(s)){const n=D.$kc(a,s,"pwsh.exe");return new y(n,r)}return null}function v(){const w=D.$kc(i.homedir(),".dotnet","tools","pwsh.exe");return new y(w,".NET Core PowerShell Global Tool")}function p(){const w=D.$kc(process.env.windir,l===1&&d!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(w,"Windows PowerShell",!0)}async function*m(){let w=await $();w&&(yield w),w=await $({useAlternateBitness:!0}),w&&(yield w),w=await g(),w&&(yield w),w=v(),w&&(yield w),w=await $({findPreview:!0}),w&&(yield w),w=await g({findPreview:!0}),w&&(yield w),w=await $({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=p(),w&&(yield w)}async function*f(){for await(const w of m())await w.exists()&&(yield w)}async function h(){for await(const w of f())return w;return null}}),define(re[90],oe([0,1,9,4,36,76,12,21]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$jm=u,e.$km=l,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(y=S.env){return y.comspec||"cmd.exe"}function l(y){let E=[],$=!1;const g=function(v){if($){E.push(v);return}(!y.send(v,m=>{if(m&&console.error(m),$=!1,E.length>0){const f=E.slice(0);E=[],f.forEach(h=>g(h))}})||D.$i)&&($=!0)};return{send:g}}var d;(function(y){async function E($,g,v){if(i.$jc($))return $;if(g===void 0&&(g=S.cwd()),i.$nc($)!=="."||(v===void 0&&P.$5f(S.env.PATH)&&(v=S.env.PATH.split(i.$uc)),v===void 0||v.length===0))return i.$kc(g,$);async function m(f){if(await k.Promises.exists(f)){let h;try{h=await k.Promises.stat(f)}catch(w){w.message.startsWith("EACCES")&&(h=await k.Promises.lstat(f))}return h?!h.isDirectory():!1}return!1}for(const f of v){let h;if(i.$jc(f)?h=i.$kc(f,$):h=i.$kc(g,f,$),await m(h))return h;let w=h+".com";if(await m(w)||(w=h+".exe",await m(w)))return w}return i.$kc(g,$)}y.findExecutable=E})(d||(e.win32=d={}))}),define(re[111],oe([0,1,49,13]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=S;function S(P){return new Promise((k,u)=>{let l;const d=new Map;function y($,g,v,p,m){const f=d.get(g);if($===P||f){const h={name:E(v),cmd:v,pid:$,ppid:g,load:p,mem:m};d.set($,h),$===P&&(l=h),f&&(f.children||(f.children=[]),f.children.push(h),f.children.length>1&&(f.children=f.children.sort((w,a)=>w.pid-a.pid)))}}function E($){const g=/--utility-sub-type=network/i,v=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,m=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(v.exec($))return"electron-crash-reporter";if(p.exec($))return"winpty-agent";if(m.exec($))return"conpty-agent";let h=f.exec($);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?g.exec($)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const w=/[a-zA-Z-]+\.js/g;let a="";do h=w.exec($),h&&(a+=h+" ");while(h);return a&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${a})`:$}if(process.platform==="win32"){const $=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,v)=>{J(["@vscode/windows-process-tree"],g,v)}).then(g=>{g.getProcessList(P,v=>{if(!v){u(new Error(`Root process ${P} not found`));return}g.getProcessCpuUsage(v,p=>{const m=new Map;p.forEach(f=>{const h=$(f.commandLine||"");m.set(f.pid,{name:E(h),cmd:h,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),l=m.get(P),l?(m.forEach(f=>{const h=m.get(f.ppid);h&&(h.children||(h.children=[]),h.children.push(f))}),m.forEach(f=>{f.children&&(f.children=f.children.sort((h,w)=>h.pid-w.pid))}),k(l)):u(new Error(`Root process ${P} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let $=function(){let g=[l];const v=[];for(;g.length;){const m=g.shift();m&&(v.push(m.pid),m.children&&(g=g.concat(m.children)))}let p=JSON.stringify(D.$Lg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+v.join(" "),(0,i.exec)(p,{},(m,f,h)=>{if(m||h)u(m||new Error(h.toString()));else{const w=f.toString().split(`
`);for(let a=0;a<v.length;a++){const t=d.get(v[a]);t.load=parseFloat(w[a])}if(!l){u(new Error(`Root process ${P} not found`));return}k(l)}})};(0,i.exec)("which ps",{},(g,v,p)=>{if(g||p)if(process.platform!=="linux")u(g||new Error(p.toString()));else{const m=JSON.stringify(D.$Lg.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)(m,{},(f,h,w)=>{f||w?u(f||new Error(w.toString())):(A(h,y),$())})}else{const m=v.toString().trim();(0,i.exec)(`${m} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,w,a)=>{h||a&&!a.includes("screen size is bogus")?u(h||new Error(a.toString())):(A(w,y),process.platform==="linux"?$():l?k(l):u(new Error(`Root process ${P} not found`)))})}})}})}function A(P,k){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=P.toString().split(`
`);for(const d of l){const y=u.exec(d.trim());y&&y.length===6&&k(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(re[112],oe([0,1,26,4,110,90]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=P;async function P(y,E){return y===1?D.$i?d():A.$jm(E):u(y,E)}let k=null;function u(y,E){if(D.$k&&y===2||D.$j&&y===3)return"/bin/bash";if(!k){let $;if(D.$i)$="/bin/bash";else{if($=E.SHELL,!$)try{$=(0,i.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}k=$}return k}let l=null;async function d(){return l||(l=(await(0,S.$gm)()).exePath),l}});var Se=this&&this.__decorate||function(J,e,i,D){var S=arguments.length,A=S<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,i):D,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,i,D);else for(var k=J.length-1;k>=0;k--)(P=J[k])&&(A=(S<3?P(A):S>3?P(e,i,A):P(e,i))||A);return S>3&&A&&Object.defineProperty(e,i,A),A};define(re[44],oe([0,1,22,8,17,23,51,15,3,2,77,25,12]),function(J,e,i,D,S,A,P,k,u,l,d,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.ProxyChannel=e.$_h=e.$9h=e.$8h=e.$7h=e.RequestInitiator=e.$6h=e.$3h=e.$2h=void 0,e.$4h=c,e.$5h=b,e.$0h=W,e.$$h=F;var $;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})($||($={}));function g(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(v||(v={}));function p(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(m||(m={}));function f(B){let M=0;for(let z=0;;z+=7){const U=B.read(1);if(M|=(U.buffer[0]&127)<<z,!(U.buffer[0]&128))return M}}const h=s(0);function w(B,M){if(M===0){B.write(h);return}let z=0;for(let ae=M;ae!==0;ae=ae>>>7)z++;const U=S.$Ce.alloc(z);for(let ae=0;M!==0;ae++)U.buffer[ae]=M&127,M=M>>>7,M>0&&(U.buffer[ae]|=128);B.write(U)}class a{constructor(M){this.b=M,this.a=0}read(M){const z=this.b.slice(this.a,this.a+M);return this.a+=z.byteLength,z}}e.$2h=a;class t{constructor(){this.a=[]}get buffer(){return S.$Ce.concat(this.a)}write(M){this.a.push(M)}}e.$3h=t;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function s(B){const M=S.$Ce.alloc(1);return M.writeUInt8(B,0),M}const n={Undefined:s(r.Undefined),String:s(r.String),Buffer:s(r.Buffer),VSBuffer:s(r.VSBuffer),Array:s(r.Array),Object:s(r.Object),Uint:s(r.Int)},o=typeof Buffer<"u";function c(B,M){if(typeof M>"u")B.write(n.Undefined);else if(typeof M=="string"){const z=S.$Ce.fromString(M);B.write(n.String),w(B,z.byteLength),B.write(z)}else if(o&&Buffer.isBuffer(M)){const z=S.$Ce.wrap(M);B.write(n.Buffer),w(B,z.byteLength),B.write(z)}else if(M instanceof S.$Ce)B.write(n.VSBuffer),w(B,M.byteLength),B.write(M);else if(Array.isArray(M)){B.write(n.Array),w(B,M.length);for(const z of M)c(B,z)}else if(typeof M=="number"&&(M|0)===M)B.write(n.Uint),w(B,M);else{const z=S.$Ce.fromString(JSON.stringify(M));B.write(n.Object),w(B,z.byteLength),B.write(z)}}function b(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(f(B)).toString();case r.Buffer:return B.read(f(B)).buffer;case r.VSBuffer:return B.read(f(B));case r.Array:{const z=f(B),U=[];for(let ae=0;ae<z;ae++)U.push(b(B));return U}case r.Object:return JSON.parse(B.read(f(B)).toString());case r.Int:return f(B)}}class L{constructor(M,z,U=null,ae=1e3){this.h=M,this.j=z,this.k=U,this.l=ae,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(M,z){this.b.set(M,z),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const z=this.o([M.type]);this.k?.logOutgoing(z,0,1,p(M.type));return}case 201:case 202:case 204:case 203:{const z=this.o([M.type,M.id],M.data);this.k?.logOutgoing(z,M.id,1,p(M.type),M.data);return}}}o(M,z=void 0){const U=new t;return c(U,M),c(U,z),this.p(U.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const z=new a(M),U=b(z),ae=b(z),G=U[0];switch(G){case 100:return this.k?.logIncoming(M.byteLength,U[1],1,`${g(G)}: ${U[2]}.${U[3]}`,ae),this.s({type:G,id:U[1],channelName:U[2],name:U[3],arg:ae});case 102:return this.k?.logIncoming(M.byteLength,U[1],1,`${g(G)}: ${U[2]}.${U[3]}`,ae),this.t({type:G,id:U[1],channelName:U[2],name:U[3],arg:ae});case 101:return this.k?.logIncoming(M.byteLength,U[1],1,`${g(G)}`),this.u({type:G,id:U[1]});case 103:return this.k?.logIncoming(M.byteLength,U[1],1,`${g(G)}`),this.u({type:G,id:U[1]})}}s(M){const z=this.b.get(M.channelName);if(!z){this.v(M);return}const U=new A.$me;let ae;try{ae=z.call(this.j,M.name,M.arg,U.token)}catch(Y){ae=Promise.reject(Y)}const G=M.id;ae.then(Y=>{this.m({id:G,data:Y,type:201})},Y=>{Y instanceof Error?this.m({id:G,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.m({id:G,data:Y,type:203})}).finally(()=>{le.dispose(),this.d.delete(M.id)});const le=(0,l.$Sc)(()=>U.cancel());this.d.set(M.id,le)}t(M){const z=this.b.get(M.channelName);if(!z){this.v(M);return}const U=M.id,G=z.listen(this.j,M.name,M.arg)(le=>this.m({id:U,data:le,type:204}));this.d.set(M.id,G)}u(M){const z=this.d.get(M.id);z&&(z.dispose(),this.d.delete(M.id))}v(M){let z=this.g.get(M.channelName);z||(z=[],this.g.set(M.channelName,z));const U=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:M,timeoutTimer:U})}w(M){const z=this.g.get(M);if(z){for(const U of z)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.s(U.request);break;case 102:this.t(U.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Pc)(this.d.values()),this.d.clear()}}e.$6h=L;var I;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class j{constructor(M,z=null){this.l=M,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(U=>this.s(U)),this.j=z}getChannel(M){const z=this;return{call(U,ae,G){return z.a?Promise.reject(new k.$5):z.m(M,U,ae,G)},listen(U,ae){return z.a?u.Event.None:z.o(M,U,ae)}}}m(M,z,U,ae=A.CancellationToken.None){const G=this.g++,Y={id:G,type:100,channelName:M,name:z,arg:U};if(ae.isCancellationRequested)return Promise.reject(new k.$5);let C;return new Promise((_,ne)=>{if(ae.isCancellationRequested)return ne(new k.$5);const Q=()=>{const se=he=>{switch(he.type){case 201:this.f.delete(G),_(he.data);break;case 202:{this.f.delete(G);const me=new Error(he.data.message);me.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,me.name=he.data.name,ne(me);break}case 203:this.f.delete(G),ne(he.data);break}};this.f.set(G,se),this.p(Y)};let x=null;this.b===m.Idle?Q():(x=(0,D.$eh)(se=>this.u()),x.then(()=>{x=null,Q()}));const V=()=>{x?(x.cancel(),x=null):this.p({id:G,type:101}),ne(new k.$5)},H=ae.onCancellationRequested(V);C=(0,l.$Rc)((0,l.$Sc)(V),H),this.d.add(C)}).finally(()=>{C.dispose(),this.d.delete(C)})}o(M,z,U){const ae=this.g++,le={id:ae,type:102,channelName:M,name:z,arg:U};let Y=null;const C=new u.$be({onWillAddFirstListener:()=>{Y=(0,D.$eh)(_=>this.u()),Y.then(()=>{Y=null,this.d.add(C),this.p(le)})},onDidRemoveLastListener:()=>{Y?(Y.cancel(),Y=null):(this.d.delete(C),this.p({id:ae,type:103}))}}),N=_=>C.fire(_.data);return this.f.set(ae,N),C.event}p(M){switch(M.type){case 100:case 102:{const z=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(z,M.id,0,`${g(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const z=this.q([M.type,M.id]);this.j?.logOutgoing(z,M.id,0,g(M.type));return}}}q(M,z=void 0){const U=new t;return c(U,M),c(U,z),this.r(U.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const z=new a(M),U=b(z),ae=b(z),G=U[0];switch(G){case 200:return this.j?.logIncoming(M.byteLength,0,0,p(G)),this.t({type:U[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,U[1],0,p(G),ae),this.t({type:U[0],id:U[1],data:ae})}}t(M){if(M.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Pc)(this.d.values()),this.d.clear()}}e.$7h=j,Se([P.$Vh],j.prototype,"onDidInitializePromise",null);class O{get connections(){const M=[];return this.f.forEach(z=>M.push(z)),M}constructor(M,z,U){this.a=new Map,this.f=new Set,this.g=new u.$be,this.onDidAddConnection=this.g.event,this.h=new u.$be,this.onDidRemoveConnection=this.h.event,this.j=new l.$Tc,this.j.add(M(({protocol:ae,onDidClientDisconnect:G})=>{const le=u.Event.once(ae.onMessage);this.j.add(le(Y=>{const C=new a(Y),N=b(C),_=new L(ae,N,z,U),ne=new j(ae,z);this.a.forEach((x,V)=>_.registerChannel(V,x));const Q={channelServer:_,channelClient:ne,ctx:N};this.f.add(Q),this.g.fire(Q),this.j.add(G(()=>{_.dispose(),ne.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(M,z){const U=this;return{call(ae,G,le){let Y;if((0,E.$gg)(z)){const N=(0,i.$4b)(U.connections.filter(z));Y=N?Promise.resolve(N):u.Event.toPromise(u.Event.filter(U.onDidAddConnection,z))}else Y=z.routeCall(U,ae,G);const C=Y.then(N=>N.channelClient.getChannel(M));return W(C).call(ae,G,le)},listen(ae,G){if((0,E.$gg)(z))return U.k(M,z,ae,G);const le=z.routeEvent(U,ae,G).then(Y=>Y.channelClient.getChannel(M));return W(le).listen(ae,G)}}}k(M,z,U,ae){const G=this;let le;const Y=new u.$be({onWillAddFirstListener:()=>{le=new l.$Tc;const C=new u.$he,N=new Map,_=Q=>{const V=Q.channelClient.getChannel(M).listen(U,ae),H=C.add(V);N.set(Q,H)},ne=Q=>{const x=N.get(Q);x&&(x.dispose(),N.delete(Q))};G.connections.filter(z).forEach(_),u.Event.filter(G.onDidAddConnection,z)(_,void 0,le),G.onDidRemoveConnection(ne,void 0,le),C.event(Y.fire,Y,le),le.add(C)},onDidRemoveLastListener:()=>{le?.dispose(),le=void 0}});return Y.event}registerChannel(M,z){this.a.set(M,z);for(const U of this.f)U.channelServer.registerChannel(M,z)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$8h=O;class R{constructor(M,z,U=null){const ae=new t;c(ae,z),M.send(ae.buffer),this.a=new j(M,U),this.d=new L(M,z,U)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,z){this.d.registerChannel(M,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$9h=R;function W(B){return{call(M,z,U){return B.then(ae=>ae.call(M,z,U))},listen(M,z){const U=new u.$ke;return B.then(ae=>U.input=ae.listen(M,z)),U.event}}}function F(B){let M=!1;return{call(z,U,ae){return M?B.call(z,U,ae):(0,D.$sh)(0).then(()=>M=!0).then(()=>B.call(z,U,ae))},listen(z,U){if(M)return B.listen(z,U);const ae=new u.$ke;return(0,D.$sh)(0).then(()=>M=!0).then(()=>ae.input=B.listen(z,U)),ae.event}}}class T{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const z of M.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await u.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$_h=T;var q;(function(B){function M(G,le,Y){const C=G,N=Y&&Y.disableMarshalling,_=new Map;for(const ne in C)U(ne)&&_.set(ne,u.Event.buffer(C[ne],!0,void 0,le));return new class{listen(ne,Q,x){const V=_.get(Q);if(V)return V;const H=C[Q];if(typeof H=="function"){if(ae(Q))return H.call(C,x);if(U(Q))return _.set(Q,u.Event.buffer(C[Q],!0,void 0,le)),_.get(Q)}throw new k.$bb(`Event not found: ${Q}`)}call(ne,Q,x){const V=C[Q];if(typeof V=="function"){if(!N&&Array.isArray(x))for(let se=0;se<x.length;se++)x[se]=(0,d.$1h)(x[se]);let H=V.apply(C,x);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new k.$bb(`Method not found: ${Q}`)}}}B.fromService=M;function z(G,le){const Y=le&&le.disableMarshalling;return new Proxy({},{get(C,N){if(typeof N=="string")return le?.properties?.has(N)?le.properties.get(N):ae(N)?function(_){return G.listen(N,_)}:U(N)?G.listen(N):async function(..._){let ne;le&&!(0,E.$bg)(le.context)?ne=[le.context,..._]:ne=_;const Q=await G.call(N,ne);return Y?Q:(0,d.$1h)(Q)};throw new k.$bb(`Property not found: ${String(N)}`)}})}B.toService=z;function U(G){return G[0]==="o"&&G[1]==="n"&&y.$tf(G.charCodeAt(2))}function ae(G){return/^onDynamic/.test(G)&&y.$tf(G.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ee(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const M=B.toString();if(M!=="[object Object]")return M}return B}function ce(B){return Array.isArray(B)?B.map(ee):ee(B)}function K(B,M,z,U,ae,G,le){le=ce(le);const Y=ue[ae],C=Y[U%Y.length];let N=[`%c[${B}]%c[${String(M).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(G)?(N=N.concat(le),N.push(")")):N.push(le),console.log.apply(console,N)}class X{constructor(M,z){this.d=M,this.f=z,this.a=0,this.b=0}logOutgoing(M,z,U,ae,G){this.b+=M,K(this.d,this.b,M,z,U,ae,G)}logIncoming(M,z,U,ae,G){this.a+=M,K(this.f,this.a,M,z,U,ae,G)}}e.$ai=X}),define(re[159],oe([0,1,17,3,44]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KW=e.$JW=void 0;class A{constructor(u){this.a=u,this.onMessage=D.Event.fromDOMEventEmitter(this.a,"message",l=>l.data?i.$Ce.wrap(l.data):i.$Ce.alloc(0)),u.start()}send(u){this.a.postMessage(u.buffer)}disconnect(){this.a.close()}}e.$JW=A;class P extends S.$9h{constructor(u,l){const d=new A(u);super(d,l),this.b=d}dispose(){this.b.disconnect(),super.dispose()}}e.$KW=P}),define(re[113],oe([0,1,17,3,2,44]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.ProtocolConstants=e.$bi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(P||(e.SocketDiagnosticsEventType=P={}));var k;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let c=0;function b(I,j){if(!o.has(I)){const O=String(++c);o.set(I,O)}return o.get(I)}function L(I,j,O,R){if(!n.enableDiagnostics)return;const W=b(I,j);if(R instanceof i.$Ce||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const F=i.$Ce.alloc(R.byteLength);F.set(R),n.records.push({timestamp:Date.now(),id:W,label:j,type:O,buff:F})}else n.records.push({timestamp:Date.now(),id:W,label:j,type:O,data:R})}n.traceSocketEvent=L})(k||(e.SocketDiagnostics=k={}));var u;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u||(e.SocketCloseEventType=u={}));let l=null;function d(){return l||(l=i.$Ce.alloc(0)),l}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,c){if(o===0)return d();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const j=this.a[0];return c&&(this.a.shift(),this.b-=o),j}if(this.a[0].byteLength>o){const j=this.a[0].slice(0,o);return c&&(this.a[0]=this.a[0].slice(o),this.b-=o),j}const b=i.$Ce.alloc(o);let L=0,I=0;for(;o>0;){const j=this.a[I];if(j.byteLength>o){const O=j.slice(0,o);b.set(O,L),L+=o,c&&(this.a[I]=j.slice(o),this.b-=o),o-=o}else b.set(j,L),L+=j.byteLength,c?(this.a.shift(),this.b-=j.byteLength):I++,o-=j.byteLength}return b}}e.$bi=y;var E;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(E||(E={}));function $(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class v{constructor(o,c,b,L){this.type=o,this.id=c,this.ack=b,this.data=L,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends S.$Uc{constructor(o){super(),this.f=this.B(new D.$be),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new y,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,L=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new v(b,L,I,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=i.$Ce.alloc(13);c.writeUInt8(o.type,0),c.writeUInt32BE(o.id,1),c.writeUInt32BE(o.ack,5),c.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:$(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(c,o.data)}g(o,c){const b=this.f===0;return this.d.push(o,c),this.f+=o.byteLength+c.byteLength,b}h(){const o=i.$Ce.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,c){this.g(o,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class f extends S.$Uc{constructor(o){super(),this.f=new D.$be,this.onMessage=this.f.event,this.g=new D.$be,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new m(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new v(1,0,0,o))}}e.$ci=f;class h extends A.$9h{static fromSocket(o,c){return new h(new f(o),c)}get onDidDispose(){return this.b.onDidDispose}constructor(o,c,b=null){super(o,c,b),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.$di=h;class w{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.$be({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.$ei=w;class a{constructor(o){this.data=o,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let o=0,c=this.a;for(;c;)c=c.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let c=0,b=this.a;for(;b;)o[c++]=b.data,b=b.next;return o}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const c=new a(o);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const o=Date.now();for(let c=0;c<r.a;c++)this.c[c]=o-1e3*c;setInterval(()=>{for(let c=r.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),c=(1+r.a)*1e3;let b=0;for(let L=0;L<r.a;L++)o-this.c[L]<=c&&b++;return 1-b/r.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(o){this.u=new w,this.onControlMessage=this.u.event,this.v=new w,this.onMessage=this.v.event,this.w=new w,this.onDidDispose=this.w.event,this.x=new w,this.onSocketClose=this.x.event,this.y=new w,this.onSocketTimeout=this.y.event,this.s=o.loadEstimator??r.getInstance(),this.t=o.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Tc,this.o=o.socket,this.p=this.r.add(new m(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),o.initialChunk&&this.q.acceptChunk(o.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const o=new v(5,0,0,d());this.p.write(o),this.p.flush()}sendPause(){const o=new v(7,0,0,d());this.p.write(o)}sendResume(){const o=new v(8,0,0,d());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,c){this.a=!0,this.r.dispose(),this.r=new S.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=this.r.add(new m(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new v(3,0,this.h,d());this.p.write(o);const c=this.b.toArray();for(let b=0,L=c.length;b<L;b++)this.p.write(c[b]);this.B()}acceptDisconnect(){this.w.fire()}z(o){if(o.ack>this.d){this.d=o.ack;do{const c=this.b.peek();if(c&&c.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new v(6,0,0,d())))}else this.g=o.id,this.j=Date.now(),this.A(),this.v.fire(o.data);break}case 2:{this.u.fire(o.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let b=0,L=c.length;b<L;b++)this.p.write(c[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const c=++this.c;this.h=this.g;const b=new v(1,c,this.h,o);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(o){const c=new v(2,0,0,o);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-o+5)}B(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),c=Date.now()-o.writtenTime,b=Date.now()-this.q.lastReadTime,L=Date.now()-this.n;if(c>=2e4&&b>=2e4&&L>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:b});return}const I=Math.max(2e4-c,2e4-b,2e4-L,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const o=new v(3,0,this.h,d());this.p.write(o)}D(){this.h=this.g;const o=new v(9,0,this.h,d());this.p.write(o)}}e.$fi=s}),define(re[37],oe([0,1,14,15,13]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GW=void 0;class A{constructor(){this.a=new WeakMap}on(k,u){const l=(d,...y)=>{this.b(k,d)&&u(d,...y)};return this.a.set(u,l),i.ipcMain.on(k,l),this}once(k,u){return i.ipcMain.once(k,(l,...d)=>{this.b(k,l)&&u(l,...d)}),this}handle(k,u){return i.ipcMain.handle(k,(l,...d)=>this.b(k,l)?u(l,...d):Promise.reject(`Invalid channel '${k}' or sender for ipcMain.handle() usage.`)),this}removeHandler(k){return i.ipcMain.removeHandler(k),this}removeListener(k,u){const l=this.a.get(u);return l&&(i.ipcMain.removeListener(k,l),this.a.delete(u)),this}b(k,u){if(!k||!k.startsWith("vscode:"))return(0,D.$1)(`Refused to handle ipcMain event for channel '${k}' because the channel is unknown.`),!1;const l=u.senderFrame,d=l.url;if(!d||d==="about:blank")return!0;let y="unknown";try{y=new URL(d).host}catch{return(0,D.$1)(`Refused to handle ipcMain event for channel '${k}' because of a malformed URL '${d}'.`),!1}return y!==S.$Kg?((0,D.$1)(`Refused to handle ipcMain event for channel '${k}' because of a bad origin of '${y}'.`),!1):l.parent!==null?((0,D.$1)(`Refused to handle ipcMain event for channel '${k}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.$GW=new A}),define(re[160],oe([0,1,14,37,148]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HW=A;function A(){D.$GW.on(S.$EW,(k,u,l,d,y)=>{const E=P(k,d,l);E.popup({x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{E&&k.sender.send(S.$FW,u)}})})}function P(k,u,l){const d=new i.Menu;return l.forEach(y=>{let E;y.type==="separator"?E=new i.MenuItem({type:y.type}):Array.isArray(y.submenu)?E=new i.MenuItem({submenu:P(k,u,y.submenu),label:y.label}):E=new i.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:($,g,v)=>k.sender.send(u,y.id,v)}),d.append(E)}),d}}),define(re[161],oe([0,1,37,17,3,2,44,149]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NW=void 0;function u(d,y){const E=S.Event.fromNodeEventEmitter(i.$GW,y,(g,v)=>({event:g,message:v})),$=S.Event.filter(E,({event:g})=>g.sender.id===d);return S.Event.map($,({message:g})=>g&&D.$Ce.wrap(g))}class l extends P.$8h{static{this.b=new Map}static d(){const y=S.Event.fromNodeEventEmitter(i.$GW,"vscode:hello",({sender:E})=>E);return S.Event.map(y,E=>{const $=E.id;l.b.get($)?.dispose();const v=new S.$be;l.b.set($,(0,A.$Sc)(()=>v.fire()));const p=u($,"vscode:message"),m=S.Event.any(S.Event.signal(u($,"vscode:disconnect")),v.event);return{protocol:new k.$MW(E,p),onDidClientDisconnect:m}})}constructor(){super(l.d())}}e.$NW=l}),define(re[114],oe([0,1,37,3,33,159]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OW=void 0,e.$PW=k;class P extends A.$KW{constructor(l,d){super({addEventListener:(y,E)=>l.addListener(y,E),removeEventListener:(y,E)=>l.removeListener(y,E),postMessage:y=>l.postMessage(y),start:()=>l.start(),close:()=>l.close()},d)}}e.$OW=P;async function k(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,S.$Ng)();u.webContents.send("vscode:createMessageChannel",l);const d=D.Event.fromNodeEventEmitter(i.$GW,"vscode:createMessageChannelResult",(E,$)=>({nonce:$,port:E.ports[0]})),{port:y}=await D.Event.toPromise(D.Event.once(D.Event.filter(d,E=>E.nonce===l)));return y}}),define(re[162],oe([0,1,49,8,17,23,156,15,3,2,35,90,76,44]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;class g extends $.$6h{constructor(m){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>S.$Ce.wrap(Buffer.from(f,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.$Uq=g;class v{constructor(m,f){this.i=m,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$be,this.onDidProcessExit=this.h.event;const h=f&&f.timeout?f.timeout:6e4;this.b=new D.$oh(h),this.d=null,this.f=null}getChannel(m){const f=this;return{call(h,w,a){return f.k(m,h,w,a)},listen(h,w){return f.l(m,h,w)}}}k(m,f,h,w=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(k.$6());this.b.cancel();const a=this.n(m),t=(0,D.$eh)(n=>a.call(f,h,n)),r=w.onCancellationRequested(()=>t.cancel()),s=(0,l.$Sc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{r.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(m,f,h){if(!this.b)return u.Event.None;this.b.cancel();let w;const a=new u.$be({onWillAddFirstListener:()=>{w=this.n(m).listen(f,h)(a.fire,a),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const m=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,d.$Xn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,E.$im)(f.env),this.d=(0,i.fork)(this.i,m,f);const h=new u.$be,a=u.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,P.$Qq)(c)){(0,P.log)(c,`IPC Library: ${this.j.serverName}`);return}h.fire(S.$Ce.wrap(Buffer.from(c,"base64")))}),t=this.j.useQueue?(0,y.$km)(this.d):this.d,r=c=>this.d&&this.d.connected&&t.send(c.buffer.toString("base64")),s=h.event,n={send:r,onMessage:s};this.f=new $.$7h(n);const o=()=>this.o();process.once("exit",o),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,b)=>{process.removeListener("exit",o),a.dispose(),this.c.forEach(L=>(0,l.$Pc)(L)),this.c.clear(),c!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:b})})}return this.f}n(m){let f=this.g.get(m);return f||(f=this.m.getChannel(m),this.g.set(m,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Vq=v}),define(re[115],oe([0,1,8,3,2,77,12]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.StorageState=e.StorageHint=void 0,e.$Qp=u;var k;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function u(E){const $=E;return $?.changed instanceof Map||$?.deleted instanceof Set}var l;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(l||(e.StorageState=l={}));class d extends S.$Uc{static{this.a=100}constructor($,g=Object.create(null)){super(),this.r=$,this.s=g,this.b=this.B(new D.$ee),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new i.$ph(d.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((g,v)=>this.w(v,g)),$.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w($,g){if(this.c===l.Closed)return;let v=!1;(0,P.$bg)(g)?v=this.f.delete($):this.f.get($)!==g&&(this.f.set($,g),v=!0),v&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,g){const v=this.f.get($);return(0,P.$bg)(v)?g:v}getBoolean($,g){const v=this.get($);return(0,P.$bg)(v)?g:v==="true"}getNumber($,g){const v=this.get($);return(0,P.$bg)(v)?g:parseInt(v,10)}getObject($,g){const v=this.get($);return(0,P.$bg)(v)?g:(0,A.$Zh)(v)}async set($,g,v=!1){if(this.c===l.Closed)return;if((0,P.$bg)(g))return this.delete($,v);const p=(0,P.$7f)(g)||Array.isArray(g)?(0,A.$Yh)(g):String(g);if(this.f.get($)!==p)return this.f.set($,p),this.j.set($,p),this.h.delete($),this.b.fire({key:$,external:v}),this.D()}async delete($,g=!1){if(!(this.c===l.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:g}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(this.z)return this.D($)}async D($){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$Rp=d;class y{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((g,v)=>this.a.set(v,g)),$.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$Sp=y}),define(re[163],oe([0,1,8,3,31,9,21]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_W=void 0;class k{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return D.Event.None}static{this.a=2e3}static{this.b=256}constructor(d,y=Object.create(null)){this.g=d,this.h=y,this.c=(0,A.$oc)(this.g),this.d=new u(this.h.logging),this.f=this.n(this.g)}async getItems(){const d=await this.f,y=new Map;return(await this.s(d,"SELECT * FROM ItemTable")).forEach($=>y.set($.key,$.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(d){const y=await this.f;return this.j(y,d)}j(d,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,S.$zc)(y.insert):"0"}), delete(${y.delete?(0,S.$Ac)(y.delete):"0"})`),this.t(d,()=>{const E=y.insert,$=y.delete;if(E&&E.size>0){const g=[];g.push([]);let v=0;E.forEach((p,m)=>{let f=g[v];f.length>k.b&&(v++,f=[],g.push(f)),f.push(m,p)}),g.forEach(p=>{this.u(d,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,m=>m.run(p),()=>{const m=[];let f=0;return E.forEach((h,w)=>{m.push(w),f+=h.length}),`Keys: ${m.join(", ")} Length: ${f}`})})}if($&&$.size){const g=[];g.push([]);let v=0;$.forEach(p=>{let m=g[v];m.length>k.b&&(v++,m=[],g.push(m)),m.push(p)}),g.forEach(p=>{this.u(d,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,m=>m.run(p),()=>{const m=[];return $.forEach(f=>{m.push(f)}),`Keys: ${m.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const d=await this.f;return this.q(d,"VACUUM")}async close(d){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,d)}k(d,y){return new Promise((E,$)=>{d.db.close(g=>(g&&this.o(d,`[storage ${this.c}] close(): ${g}`),this.g===k.IN_MEMORY_PATH?E():!d.isErroneous&&!d.isInMemory?this.l().then(E,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),E())):typeof y=="function"?P.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const p=()=>this.k(v,void 0);return this.j(v,{insert:y()}).then(()=>p(),m=>(p(),Promise.reject(m)))})).then(E,$):$(g||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const d=this.m(this.g);return P.Promises.copy(this.g,d,{preserveSymlinks:!1})}m(d){return`${d}.backup`}async checkIntegrity(d){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${d})`);const y=await this.f,E=await this.r(y,d?"PRAGMA integrity_check":"PRAGMA quick_check"),$=d?E.integrity_check:E.quick_check;return y.isErroneous?`${$} (last error: ${y.lastError})`:y.isInMemory?`${$} (in-memory!)`:$}async n(d,y=!0){this.d.trace(`[storage ${this.c}] open(${d}, retryOnBusy: ${y})`);try{return await this.p(d)}catch(E){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&y)return await(0,i.$sh)(k.a),this.n(d,!1);try{await P.Promises.unlink(d);try{await P.Promises.rename(this.m(d),d,!1)}catch{}return await this.p(d)}catch($){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${$}`),this.p(k.IN_MEMORY_PATH)}}}o(d,y){d.isErroneous=!0,d.lastError=y,this.d.error(y)}p(d){return new Promise((y,E)=>{new Promise(($,g)=>{J(["@vscode/sqlite3"],$,g)}).then($=>{const g={db:new(this.d.isTracing?$.verbose().Database:$.Database)(d,v=>v?g.db&&v.code!=="SQLITE_CANTOPEN"?g.db.close(()=>E(v)):E(v):this.q(g,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(g),p=>g.db.close(()=>E(p)))),isInMemory:d===k.IN_MEMORY_PATH};g.db.on("error",v=>this.o(g,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&g.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},E)})}q(d,y){return new Promise((E,$)=>{d.db.exec(y,g=>g?(this.o(d,`[storage ${this.c}] exec(): ${g}`),$(g)):E())})}r(d,y){return new Promise((E,$)=>{d.db.get(y,(g,v)=>g?(this.o(d,`[storage ${this.c}] get(): ${g}`),$(g)):E(v))})}s(d,y){return new Promise((E,$)=>{d.db.all(y,(g,v)=>g?(this.o(d,`[storage ${this.c}] all(): ${g}`),$(g)):E(v))})}t(d,y){return new Promise((E,$)=>{d.db.serialize(()=>{d.db.run("BEGIN TRANSACTION"),y(),d.db.run("END TRANSACTION",g=>g?(this.o(d,`[storage ${this.c}] transaction(): ${g}`),$(g)):E())})})}u(d,y,E,$){const g=d.db.prepare(y),v=p=>{this.o(d,`[storage ${this.c}] prepare(): ${p} (${y}). Details: ${$()}`)};g.on("error",v),E(g),g.finalize(p=>{p&&v(p),g.removeListener("error",v)})}}e.$_W=k;class u{static{this.a="VSCODE_TRACE_STORAGE"}constructor(d){d&&typeof d.logTrace=="function"&&process.env[u.a]&&(this.b=d.logTrace),d&&typeof d.logError=="function"&&(this.c=d.logError)}get isTracing(){return!!this.b}trace(d){this.b?.(d)}error(d){this.c?.(d)}}}),define(re[164],oe([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(re[165],oe([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[166],oe([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(re[167],oe([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(re[168],oe([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(re[169],oe([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(re[170],oe([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(re[171],oe([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(re[172],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[173],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[174],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[175],oe([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[176],oe([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(re[177],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(re[178],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(re[179],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(re[180],oe([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(re[181],oe([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[182],oe([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(re[183],oe([11,10]),function(J,e){return J.create("vs/platform/log/common/log",e)}),define(re[184],oe([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(re[185],oe([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(re[186],oe([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(re[187],oe([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(re[188],oe([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[189],oe([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[190],oe([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[191],oe([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(re[192],oe([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[193],oe([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(re[194],oe([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(re[195],oe([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(re[196],oe([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(re[197],oe([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(re[198],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfb=i,e.$1fb=D;function i(S){return S&&S.hasOwnProperty("folderUri")}function D(S){return S&&S.hasOwnProperty("workspace")}}),define(re[199],oe([0,1,7]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=D,e.$9ac=S,e.$0ac=A;function D(P){return typeof P?.backupFolder=="string"}function S(P){let k=[];try{Array.isArray(P.workspaces)&&(k=P.workspaces.map(u=>({workspace:{id:u.id,configPath:i.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return k}function A(P){let k=[];try{Array.isArray(P.folders)&&(k=P.folders.map(u=>({folderUri:i.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return k}}),define(re[200],oe([0,1,15,167]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.TokenType=void 0;var S;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(S||(e.TokenType=S={}));function A(...l){switch(l.length){case 1:return(0,D.localize)(0,null,l[0]);case 2:return(0,D.localize)(1,null,l[0],l[1]);case 3:return(0,D.localize)(2,null,l[0],l[1],l[2]);default:return}}const P=(0,D.localize)(3,null),k=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return d.isTripleEq?"===":"==";case 4:return d.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return d.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return d.lexeme;case 18:return d.lexeme;case 19:return d.lexeme;case 20:return"EOF";default:throw(0,i.$8)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const y=this.d,E=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:E};this.g.push({offset:y,lexeme:E,additionalInfo:d}),this.f.push($)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const y=this.c.substring(this.d,this.e),E=u.b.get(y);E?this.k(E):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,y=!1,E=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(k);return}const g=this.c.charCodeAt(d);if(y)y=!1;else if(g===47&&!E){d++;break}else g===91?E=!0:g===92?y=!0:g===93&&(E=!1);d++}for(;d<this.c.length&&u.a.has(this.c.charCodeAt(d));)d++;this.e=d;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$mj=u}),define(re[201],oe([0,1,3,2]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=void 0;class S{constructor(){this.a=new i.$be,this.b=new i.$be,this.c=new i.$be,this.d=new i.$be}static{this.ChannelName="extensionhostdebugservice"}call(k,u,l){switch(u){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(k,u,l){switch(u){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Do=S;class A extends D.$Uc{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,u,l){this.b.call("attach",[k,u,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,u){this.b.call("terminate",[k,u])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,u){return this.b.call("openExtensionDevelopmentHostWindow",[k,u])}}e.$Eo=A}),define(re[202],oe([0,1,151,51,13,9,36,19,7]),function(J,e,i,D,S,A,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=void 0,e.$2m=d,e.$3m=y,e.$Zm=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,A.$nc)(S.$Lg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$kc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,k.$5g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$5g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,i.$Ym)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$kc)(this.userDataPath,"logs",$)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$5g)(u.URI.file((0,A.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$5g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$5g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$5g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=P.env.VSCODE_PORTABLE;return $?u.URI.file((0,A.$kc)($,"argv.json")):(0,k.$5g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,A.$lc)($):(0,A.$ic)((0,A.$kc)(S.$Lg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?u.URI.file((0,A.$lc)($)):u.URI.file((0,A.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,A.$lc)($);const g=P.env.VSCODE_EXTENSIONS;if(g)return g;const v=P.env.VSCODE_PORTABLE;return v?(0,A.$kc)(v,"extensions"):(0,k.$5g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(g=>/^[^:/?#]+?:\/\//.test(g)?u.URI.parse(g):u.URI.file((0,A.$ic)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?u.URI.parse($):u.URI.file((0,A.$ic)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return d(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$Zm.test($))}get extensionLogLevel(){const $=[];for(const g of this.args.log||[]){const v=e.$Zm.exec(g);v&&v[1]&&v[2]&&$.push([v[1],v[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,k.$5g)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=P.env.VSCODE_PORTABLE;return $?u.URI.file((0,A.$kc)($,"policy.json")):(0,k.$5g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,g,v){this.a=$,this.b=g,this.c=v,this.editSessionId=this.args.editSessionId}}e.$1m=l,Se([D.$Vh],l.prototype,"appRoot",null),Se([D.$Vh],l.prototype,"userHome",null),Se([D.$Vh],l.prototype,"userDataPath",null),Se([D.$Vh],l.prototype,"appSettingsHome",null),Se([D.$Vh],l.prototype,"tmpDir",null),Se([D.$Vh],l.prototype,"cacheHome",null),Se([D.$Vh],l.prototype,"stateResource",null),Se([D.$Vh],l.prototype,"userRoamingDataHome",null),Se([D.$Vh],l.prototype,"userDataSyncHome",null),Se([D.$Vh],l.prototype,"sync",null),Se([D.$Vh],l.prototype,"machineSettingsResource",null),Se([D.$Vh],l.prototype,"workspaceStorageHome",null),Se([D.$Vh],l.prototype,"localHistoryHome",null),Se([D.$Vh],l.prototype,"keyboardLayoutResource",null),Se([D.$Vh],l.prototype,"argvResource",null),Se([D.$Vh],l.prototype,"isExtensionDevelopment",null),Se([D.$Vh],l.prototype,"untitledWorkspacesHome",null),Se([D.$Vh],l.prototype,"builtinExtensionsPath",null),Se([D.$Vh],l.prototype,"extensionsPath",null),Se([D.$Vh],l.prototype,"extensionDevelopmentLocationURI",null),Se([D.$Vh],l.prototype,"extensionDevelopmentKind",null),Se([D.$Vh],l.prototype,"extensionTestsLocationURI",null),Se([D.$Vh],l.prototype,"debugExtensionHost",null),Se([D.$Vh],l.prototype,"logLevel",null),Se([D.$Vh],l.prototype,"extensionLogLevel",null),Se([D.$Vh],l.prototype,"serviceMachineIdResource",null),Se([D.$Vh],l.prototype,"disableTelemetry",null),Se([D.$Vh],l.prototype,"disableWorkspaceTrust",null),Se([D.$Vh],l.prototype,"useInMemorySecretStorage",null),Se([D.$Vh],l.prototype,"policyFile",null);function d(E,$){return y(E["inspect-extensions"],E["inspect-brk-extensions"],5870,$,E.debugId,E.extensionEnvironment)}function y(E,$,g,v,p,m){const h=Number($||E)||(v?null:g),w=h?!!$:!1;let a;if(m)try{a=JSON.parse(m)}catch{}return{port:h,break:w,debugId:p,env:a}}}),define(re[116],oe([0,1,313,4,170]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=void 0,e.$om=k,e.$pm=l,e.$qm=$,e.$rm=g;const A={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$mm=["tunnel","serve-web"],e.$nm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(v,p,m=P){const f=v.find(c=>c.length>0&&c[0]!=="-"),h={},w=["_"],a=[],t={};let r;for(const c in p){const b=p[c];b.type==="subcommand"?c===f&&(r=b):(b.alias&&(h[c]=b.alias),b.type==="string"||b.type==="string[]"?(w.push(c),b.deprecates&&w.push(...b.deprecates)):b.type==="boolean"&&(a.push(c),b.deprecates&&a.push(...b.deprecates)),b.global&&(t[c]=b))}if(r&&f){const c=t;for(const j in r.options)c[j]=r.options[j];const b=v.filter(j=>j!==f),L=m.getSubcommandReporter?m.getSubcommandReporter(f):void 0,I=k(b,c,L);return{[f]:I,_:[]}}const s=i(v,{string:w,boolean:a,alias:h}),n={},o=s;n._=s._.map(c=>String(c)).filter(c=>c.length>0),delete o._;for(const c in p){const b=p[c];if(b.type==="subcommand")continue;b.alias&&delete o[b.alias];let L=o[c];if(b.deprecates)for(const I of b.deprecates)o.hasOwnProperty(I)&&(L||(L=o[I],L&&m.onDeprecatedOption(I,b.deprecationMessage||(0,S.localize)(38,null,c))),delete o[I]);if(typeof L<"u"){if(b.type==="string[]"){if(Array.isArray(L)||(L=[L]),!b.allowEmptyValue){const I=L.filter(j=>j.length>0);I.length!==L.length&&(m.onEmptyValue(c),L=I.length>0?I:void 0)}}else b.type==="string"&&(Array.isArray(L)?(L=L.pop(),m.onMultipleValues(c,L)):!L&&!b.allowEmptyValue&&(m.onEmptyValue(c),L=void 0));n[c]=L,b.deprecationMessage&&m.onDeprecatedOption(c,b.deprecationMessage)}delete o[c]}for(const c in o)m.onUnknownOption(c);return n}function u(v,p){let m="";return p.args&&(Array.isArray(p.args)?m=` <${p.args.join("> <")}>`:m=` <${p.args}>`),p.alias?`-${p.alias} --${v}${m}`:`--${v}${m}`}function l(v,p){const m=[];for(const f in v){const h=v[f],w=u(f,h);m.push([w,h.description])}return d(m,p)}function d(v,p){const f=v.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(p-f<25)return v.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const h=p-f-1,w=[];for(const a of v){const t=a[0],r=E(a[1],h),s=y(f-t.length-2);w.push("  "+t+s+r[0]);for(let n=1;n<r.length;n++)w.push(y(f)+r[n])}return w}function y(v){return" ".repeat(v)}function E(v,p){const m=[];for(;v.length;){const f=v.length<p?v.length:v.lastIndexOf(" ",p),h=v.slice(0,f).trim();v=v.slice(f),m.push(h)}return m}function $(v,p,m,f,h){const w=process.stdout.isTTY&&process.stdout.columns||80,a=h?.noInputFiles!==!0?`[${(0,S.localize)(39,null)}...]`:"",t=[`${v} ${m}`];t.push(""),t.push(`${(0,S.localize)(40,null)}: ${p} [${(0,S.localize)(41,null)}]${a}`),t.push(""),h?.noPipe!==!0&&(D.$i?t.push((0,S.localize)(42,null,p)):t.push((0,S.localize)(43,null,p)),t.push(""));const r={},s=[];for(const n in f){const o=f[n];if(o.type==="subcommand")o.description&&s.push({command:n,description:o.description});else if(o.description&&o.cat){let c=r[o.cat];c||(r[o.cat]=c={}),c[n]=o}}for(const n in r){const o=n,c=r[o];c&&(t.push(A[o]),t.push(...l(c,w)),t.push(""))}return s.length&&(t.push((0,S.localize)(44,null)),t.push(...d(s.map(n=>[n.command,n.description]),w)),t.push("")),t.join(`
`)}function g(v,p){return`${v||(0,S.localize)(45,null)}
${p||(0,S.localize)(46,null)}
${process.arch}`}}),define(re[203],oe([0,1,88,201,116]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class A extends D.$Do{constructor(k){super(),this.f=k}call(k,u,l){return u==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(k,u,l)}async g(k,u){const l=(0,S.$om)(k,S.$nm);l.debugRenderer=u;const d=l.extensionDevelopmentPath;if(!d)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(d,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!u)return{success:!0};const E=y.win;if(!E)return{success:!0};const $=E.webContents.debugger;let g=$.isAttached()?1/0:0;const v=(0,i.createServer)(p=>{g++===0&&$.attach();let m=!1;const f=a=>{m||p.write(JSON.stringify(a)+"\0")},h=(a,t,r,s)=>f({method:t,params:r,sessionId:s});E.on("close",()=>{$.removeListener("message",h),p.end(),m=!0}),$.addListener("message",h);let w=Buffer.alloc(0);p.on("data",a=>{w=Buffer.concat([w,a]);for(let t=w.indexOf(0);t!==-1;t=w.indexOf(0)){let r;try{const s=w.slice(0,t).toString("utf8");w=w.slice(t+1),r=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}$.sendCommand(r.method,r.params,r.sessionId).then(s=>f({id:r.id,sessionId:r.sessionId,result:s})).catch(s=>f({id:r.id,sessionId:r.sessionId,error:{code:0,message:s.message}}))}}),p.on("error",a=>{console.error("error on cdp pipe:",a)}),p.on("close",()=>{m=!0,--g===0&&$.detach()})});return await new Promise(p=>v.listen(0,p)),E.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$Jbc=A}),define(re[64],oe([0,1,314,171,116]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=k,e.$tm=u,e.$um=l,e.$vm=d;function A(y,E){const $=(h,w)=>{console.warn((0,D.localize)(0,null,h,w))},g=h=>{console.warn((0,D.localize)(1,null,h))},v=(h,w)=>{console.warn((0,D.localize)(2,null,h,w))},p=h=>({onUnknownOption:w=>{S.$mm.includes(h)||console.warn((0,D.localize)(3,null,w,h))},onMultipleValues:$,onEmptyValue:g,onDeprecatedOption:v,getSubcommandReporter:S.$mm.includes(h)?p:void 0}),m={onUnknownOption:h=>{console.warn((0,D.localize)(4,null,h))},onMultipleValues:$,onEmptyValue:g,onDeprecatedOption:v,getSubcommandReporter:p},f=(0,S.$om)(y,S.$nm,E?m:void 0);return f.goto&&f._.forEach(h=>i(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(h),(0,D.localize)(5,null))),f}function P(y){const E=y.findIndex($=>!/^-/.test($));if(E>-1)return[...y.slice(0,E),...y.slice(E+1)]}function k(y){let[,...E]=y;process.env.VSCODE_DEV&&(E=P(E)||[]);const $=!d(process.env);return A(E,$)}function u(y){let[,,...E]=y;return process.env.VSCODE_DEV&&(E=P(E)||[]),A(E,!0)}function l(y,...E){const $=y.indexOf("--");return $===-1?y.push(...E):y.splice($,0,...E),y}function d(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function J(e,i,D){function S(P,k){const u=A(P,k),l=[u];return e.isAbsolute(u)||l.unshift(D),e.resolve(...l)}function A(P,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,k);const d=P["user-data-dir"];if(d)return d;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(y,"AppData","Roaming")}break;case"darwin":l=e.join(i.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,k)}return{getUserDataPath:S}}if(typeof define=="function")define(re[204],oe([117,26,36]),function(e,i,D){return J(e,i,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=J(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[91],oe([0,1,26,202,204]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=void 0,e.$5m=P,e.$6m=k;class A extends D.$1m{constructor(l,d){super(l,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,S.getUserDataPath)(l,d.nameShort)},d)}}e.$4m=A;function P(u,l){return(0,D.$3m)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l,u.extensionEnvironment)}function k(u,l){return(0,D.$3m)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,l,u.extensionEnvironment)}}),define(re[205],oe([0,1,43,26,32]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=A;function A(P){const k=(0,S.$zg)((0,D.tmpdir)());try{return(0,i.writeFileSync)(k,""),P&&console.log(`Marker file for --wait created: ${k}`),k}catch(u){P&&console.error(`Failed to create marker file for --wait: ${u}`);return}}}),define(re[206],oe([0,1,12,173]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=S;function S(P,k,u,l){try{A(P,k,u,l)}catch(d){P.error(d?.message??d)}return k}function A(P,k,u,l){const d=(y,E,$)=>{const g=y[E];if((0,i.$5f)(g)){const v=g,p=v.length;if(p>1&&v[0]==="%"&&v[p-1]==="%"){const m=v.substr(1,p-2);let f=u[m];f===void 0&&l&&(f=l[m]);const h=typeof f=="string"?f:f?.message,w=l?.[m],a=typeof w=="string"?w:w?.message;if(!h){a||P.warn(`[${k.name}]: ${(0,D.localize)(0,null,m)}`);return}if($&&(E==="title"||E==="category")&&a&&a!==h){const t={value:h,original:a};y[E]=t}else y[E]=h}}else if((0,i.$7f)(g))for(const v in g)g.hasOwnProperty(v)&&(v==="commands"?d(g,v,!0):d(g,v,$));else if(Array.isArray(g))for(let v=0;v<g.length;v++)d(g,v,$)};for(const y in k)k.hasOwnProperty(y)&&d(k,y)}}),define(re[207],oe([0,1,19,74,175,208]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=u,e.$Cp=l,e.$Dp=d,e.$Ep=y,e.$Fp=E,e.$Gp=$,e.$Hp=g;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function u(m){return m=m.trim(),m==="*"||P.test(m)}function l(m){if(!u(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=m.match(P);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}function d(m){if(!m)return null;const f=m.majorBase,h=m.majorMustEqual,w=m.minorBase;let a=m.minorMustEqual;const t=m.patchBase;let r=m.patchMustEqual;m.hasCaret&&(f===0||(a=!1),r=!1);let s=0;if(m.preRelease){const n=k.exec(m.preRelease);if(n){const[,o,c,b]=n;s=Date.UTC(Number(o),Number(c)-1,Number(b))}}return{majorBase:f,majorMustEqual:h,minorBase:w,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:m.hasGreaterEquals,notBefore:s}}function y(m,f,h){let w;typeof m=="string"?w=d(l(m)):w=m;let a;f instanceof Date?a=f.getTime():typeof f=="string"&&(a=new Date(f).getTime());let t;if(typeof h=="string"?t=d(l(h)):t=h,!w||!t)return!1;const r=w.majorBase,s=w.minorBase,n=w.patchBase;let o=t.majorBase,c=t.minorBase,b=t.patchBase;const L=t.notBefore;let I=t.majorMustEqual,j=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?r>o?!0:r<o?!1:s>c?!0:s<c||a&&a<L?!1:n>=b:(r===1&&o===0&&(!I||!j||!O)&&(o=1,c=0,b=0,I=!0,j=!1,O=!1),r<o?!1:r>o?!I:s<c?!1:s>c?!j:n<b?!1:n>b?!O:!(a&&a<L))}function E(m,f,h,w,a){const t=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return t.push([D.default.Error,S.localize(0,null)]),t;if(typeof w.name!="string")return t.push([D.default.Error,S.localize(1,null,"name")]),t;if(typeof w.version!="string")return t.push([D.default.Error,S.localize(2,null,"version")]),t;if(!w.engines)return t.push([D.default.Error,S.localize(3,null,"engines")]),t;if(typeof w.engines.vscode!="string")return t.push([D.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof w.extensionDependencies<"u"&&!p(w.extensionDependencies))return t.push([D.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof w.activationEvents<"u"){if(!p(w.activationEvents))return t.push([D.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof w.main>"u"&&typeof w.browser>"u")return t.push([D.default.Error,S.localize(7,null,"activationEvents","main","browser")]),t}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&t.push([D.default.Warning,S.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return t.push([D.default.Error,S.localize(9,null,"main")]),t;{const n=(0,i.$5g)(h,w.main);(0,i.$Yg)(n,h)||t.push([D.default.Warning,S.localize(10,null,n.path,h.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return t.push([D.default.Error,S.localize(11,null,"browser")]),t;{const n=(0,i.$5g)(h,w.browser);(0,i.$Yg)(n,h)||t.push([D.default.Warning,S.localize(12,null,n.path,h.path)])}}if(!A.valid(w.version))return t.push([D.default.Error,S.localize(13,null)]),t;const r=[];if(!$(m,f,w,a,r))for(const n of r)t.push([D.default.Error,n]);return t}function $(m,f,h,w,a){return w||typeof h.main>"u"&&typeof h.browser>"u"?!0:v(m,f,h.engines.vscode,a)}function g(m,f,h){return m==="*"||v(f,h,m)}function v(m,f,h,w=[]){const a=d(l(h));if(!a)return w.push(S.localize(14,null,h)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return w.push(S.localize(15,null,h)),!1}else if(!a.majorMustEqual)return w.push(S.localize(16,null,h)),!1;return y(m,f,a)?!0:(w.push(S.localize(17,null,m,h)),!1)}function p(m){if(!Array.isArray(m))return!1;for(let f=0,h=m.length;f<h;f++)if(typeof m[f]!="string")return!1;return!0}}),define(re[209],oe([0,1,17,33]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=S;async function S(A,P,k){let u=k&&k.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const d=(await P.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.$Mg)(d)?d:null}catch{u=null}if(!u){u=(0,D.$Ng)();try{await P.writeFile(A.serviceMachineIdResource,i.$Ce.fromString(u))}catch{}}return k?.store("storage.serviceMachineId",u,-1,1),u}}),define(re[78],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class i{constructor(S,A=[],P=!1){this.ctor=S,this.staticArguments=A,this.supportsDelayedInstantiation=P}}e.$oi=i}),define(re[210],oe([0,1,78]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$rs=A,e.$ss=P;const D=[];var S;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function A(k,u,l){u instanceof i.$oi||(u=new i.$oi(u,[],!!l)),D.push([k,u])}function P(){return D}}),define(re[211],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=void 0;class i{constructor(A,P){this.key=A,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$8q=i;class D{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const P of this.a.values())P.outgoing.size===0&&A.push(P);return A}insertEdge(A,P){const k=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(P);k.outgoing.set(u.key,u),u.incoming.set(k.key,k)}removeNode(A){const P=this.b(A);this.a.delete(P);for(const k of this.a.values())k.outgoing.delete(P),k.incoming.delete(P)}lookupOrInsertNode(A){const P=this.b(A);let k=this.a.get(P);return k||(k=new i(P,A),this.a.set(P,k)),k}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[P,k]of this.a)A.push(`${P}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,P]of this.a){const k=new Set([A]),u=this.c(P,k);if(u)return u}}c(A,P){for(const[k,u]of A.outgoing){if(P.has(k))return[...P,k].join(" -> ");P.add(k);const l=this.c(u,P);if(l)return l;P.delete(k)}}}e.$9q=D}),define(re[6],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e._util=void 0,e.$ri=S,e.$si=A;var i;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function k(u){return u[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=k})(i||(e._util=i={})),e.$qi=S("instantiationService");function D(P,k,u){k[i.DI_TARGET]===k?k[i.DI_DEPENDENCIES].push({id:P,index:u}):(k[i.DI_DEPENDENCIES]=[{id:P,index:u}],k[i.DI_TARGET]=k)}function S(P){if(i.serviceIds.has(P))return i.serviceIds.get(P);const k=function(u,l,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(k,u,d)};return k.toString=()=>P,i.serviceIds.set(P,k),k}function A(P){return P}}),define(re[79],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0,e.$2bc=(0,i.$ri)("auxiliaryWindowsMainService")}),define(re[65],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0,e.$$ac=(0,i.$ri)("backupMainService")}),define(re[18],oe([0,1,12,7,6]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Xi=void 0,e.$Yi=A,e.$Zi=P,e.$1i=u,e.$2i=l,e.$3i=d,e.$4i=y,e.$5i=E,e.$6i=g,e.$7i=v,e.$8i=p,e.$Xi=(0,S.$ri)("configurationService");function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof D.URI)}function P(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof D.URI)}var k;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function u(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function l(m){return m.applicationValue!==void 0||m.userValue!==void 0||m.userLocalValue!==void 0||m.userRemoteValue!==void 0||m.workspaceValue!==void 0||m.workspaceFolderValue!==void 0}function d(m,f){const h=Object.create(null);for(const w in m)y(h,w,m[w],f);return h}function y(m,f,h,w){const a=f.split("."),t=a.pop();let r=m;for(let s=0;s<a.length;s++){const n=a[s];let o=r[n];switch(typeof o){case"undefined":o=r[n]=Object.create(null);break;case"object":if(o===null){w(`Ignoring ${f} as ${a.slice(0,s+1).join(".")} is null`);return}break;default:w(`Ignoring ${f} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[t]=h}catch{w(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(r)}`)}else w(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(r)}`)}function E(m,f){const h=f.split(".");$(m,h)}function $(m,f){const h=f.shift();if(f.length===0){delete m[h];return}if(Object.keys(m).indexOf(h)!==-1){const w=m[h];typeof w=="object"&&!Array.isArray(w)&&($(w,f),Object.keys(w).length===0&&delete m[h])}}function g(m,f,h){function w(r,s){let n=r;for(const o of s){if(typeof n!="object"||n===null)return;n=n[o]}return n}const a=f.split("."),t=w(m,a);return typeof t>"u"?h:t}function v(m,f,h){Object.keys(f).forEach(w=>{w!=="__proto__"&&(w in m?i.$7f(m[w])&&i.$7f(f[w])?v(m[w],f[w],h):h&&(m[w]=f[w]):m[w]=f[w])})}function p(m){return m.replace(/[\[\]]/g,"")}}),define(re[118],oe([0,1,4,25,200,6,166,15]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$pj=e.$oj=e.ContextKeyExprType=void 0,e.$nj=l,e.$qj=r,e.$rj=s,e.$Kj=ae;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",i.$j),u.set("isLinux",i.$k),u.set("isWindows",i.$i),u.set("isWeb",i.$o),u.set("isMacNative",i.$j&&!i.$o),u.set("isEdge",i.$H),u.set("isFirefox",i.$F),u.set("isChrome",i.$E),u.set("isSafari",i.$G);function l(Y,C){if(u.get(Y)!==void 0)throw(0,k.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(Y,C)}const d=Object.prototype.hasOwnProperty;var y;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const E={regexParsingWithErrorRecovery:!0},$=(0,P.localize)(0,null),g=(0,P.localize)(1,null),v=(0,P.localize)(2,null),p=(0,P.localize)(3,null),m=(0,P.localize)(4,null),f=(0,P.localize)(5,null),h=(0,P.localize)(6,null),w=(0,P.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(C=E){this.k=C,this.d=new S.$mj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(C){if(C===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(C).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const _=this.D(),ne=_.type===17?f:void 0;throw this.h.push({message:m,offset:_.offset,lexeme:S.$mj.getLexeme(_),additionalInfo:ne}),a.c}return N}catch(N){if(N!==a.c)throw N;return}}l(){return this.m()}m(){const C=[this.o()];for(;this.y(16);){const N=this.o();C.push(N)}return C.length===1?C[0]:t.or(...C)}o(){const C=[this.s()];for(;this.y(15);){const N=this.s();C.push(N)}return C.length===1?C[0]:t.and(...C)}s(){if(this.y(2)){const C=this.D();switch(C.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,p),N?.negate()}case 17:return this.z(),R.create(C.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",C)}}return this.t()}t(){const C=this.D();switch(C.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,p),N}case 17:{const N=C.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const Q=ne.lexeme,x=Q.lastIndexOf("/"),V=x===Q.length-1?void 0:this.w(Q.substring(x+1));let H;try{H=new RegExp(Q.substring(1,x),V)}catch{throw this.B("REGEX",ne)}return ee.create(N,H)}switch(ne.type){case 10:case 19:{const Q=[ne.lexeme];this.z();let x=this.D(),V=0;for(let $e=0;$e<ne.lexeme.length;$e++)ne.lexeme.charCodeAt($e)===40?V++:ne.lexeme.charCodeAt($e)===41&&V--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:V++;break;case 1:V--;break;case 10:case 18:for(let $e=0;$e<x.lexeme.length;$e++)x.lexeme.charCodeAt($e)===40?V++:ne.lexeme.charCodeAt($e)===41&&V--}if(V<0)break;Q.push(S.$mj.getLexeme(x)),this.z(),x=this.D()}const H=Q.join(""),se=H.lastIndexOf("/"),he=se===H.length-1?void 0:this.w(H.substring(se+1));let me;try{me=new RegExp(H.substring(1,se),he)}catch{throw this.B("REGEX",ne)}return t.regex(N,me)}case 18:{const Q=ne.lexeme;this.z();let x=null;if(!(0,D.$4e)(Q)){const V=Q.indexOf("/"),H=Q.lastIndexOf("/");if(V!==H&&V>=0){const se=Q.slice(V+1,H),he=Q[H+1]==="i"?"i":"";try{x=new RegExp(se,he)}catch{throw this.B("REGEX",ne)}}}if(x===null)throw this.B("REGEX",ne);return ee.create(N,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const ne=this.u();return t.notIn(N,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return t.equals(N,ne);switch(ne){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return t.notEquals(N,ne);switch(ne){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,ne)}}case 5:return this.z(),q.create(N,this.u());case 6:return this.z(),ue.create(N,this.u());case 7:return this.z(),F.create(N,this.u());case 8:return this.z(),T.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:h,offset:C.offset,lexeme:"",additionalInfo:w}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const C=this.D();switch(C.type){case 17:case 18:return this.z(),C.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(C){return C.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(C){return this.C(C)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(C,N){if(this.C(C))return this.z();throw this.B(N,this.D())}B(C,N,_){const ne=(0,P.localize)(8,null,C,S.$mj.getLexeme(N)),Q=N.offset,x=S.$mj.getLexeme(N);return this.h.push({message:ne,offset:Q,lexeme:x,additionalInfo:_}),a.c}C(C){return this.D().type===C}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$oj=a;class t{static false(){return o.INSTANCE}static true(){return c.INSTANCE}static has(C){return b.create(C)}static equals(C,N){return L.create(C,N)}static notEquals(C,N){return O.create(C,N)}static regex(C,N){return ee.create(C,N)}static in(C,N){return I.create(C,N)}static notIn(C,N){return j.create(C,N)}static not(C){return R.create(C)}static and(...C){return X.create(C,null,!0)}static or(...C){return B.create(C,null,!0)}static greater(C,N){return F.create(C,N)}static greaterEquals(C,N){return T.create(C,N)}static smaller(C,N){return q.create(C,N)}static smallerEquals(C,N){return ue.create(C,N)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(C){return C==null?void 0:this.c.parse(C)}}e.$pj=t;function r(Y){const C=new a({regexParsingWithErrorRecovery:!1});return Y.map(N=>(C.parse(N),C.lexingErrors.length>0?C.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,P.localize)(9,null,_.additionalInfo):(0,P.localize)(10,null),offset:_.offset,length:_.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function s(Y,C){const N=Y?Y.substituteConstants():void 0,_=C?C.substituteConstants():void 0;return!N&&!_?!0:!N||!_?!1:N.equals(_)}function n(Y,C){return Y.cmp(C)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return c.INSTANCE}}e.$sj=o;class c{static{this.INSTANCE=new c}constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return o.INSTANCE}}e.$tj=c;class b{static create(C,N=null){const _=u.get(C);return typeof _=="boolean"?_?c.INSTANCE:o.INSTANCE:new b(C,N)}constructor(C,N){this.key=C,this.c=N,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:z(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=u.get(this.key);return typeof C=="boolean"?C?c.INSTANCE:o.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$uj=b;class L{static create(C,N,_=null){if(typeof N=="boolean")return N?b.create(C,_):R.create(C,_);const ne=u.get(C);return typeof ne=="boolean"?N===(ne?"true":"false")?c.INSTANCE:o.INSTANCE:new L(C,N,_)}constructor(C,N,_){this.c=C,this.d=N,this.f=_,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:U(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=u.get(this.c);if(typeof C=="boolean"){const N=C?"true":"false";return this.d===N?c.INSTANCE:o.INSTANCE}return this}evaluate(C){return C.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(C){return C.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$vj=L;class I{static create(C,N){return new I(C,N)}constructor(C,N){this.d=C,this.f=N,this.type=10,this.c=null}cmp(C){return C.type!==this.type?this.type-C.type:U(this.d,this.f,C.d,C.f)}equals(C){return C.type===this.type?this.d===C.d&&this.f===C.f:!1}substituteConstants(){return this}evaluate(C){const N=C.getValue(this.f),_=C.getValue(this.d);return Array.isArray(N)?N.includes(_):typeof _=="string"&&typeof N=="object"&&N!==null?d.call(N,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(C){return C.mapIn(this.d,this.f)}negate(){return this.c||(this.c=j.create(this.d,this.f)),this.c}}e.$wj=I;class j{static create(C,N){return new j(C,N)}constructor(C,N){this.d=C,this.f=N,this.type=11,this.c=I.create(C,N)}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(C){return C.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$xj=j;class O{static create(C,N,_=null){if(typeof N=="boolean")return N?R.create(C,_):b.create(C,_);const ne=u.get(C);return typeof ne=="boolean"?N===(ne?"true":"false")?o.INSTANCE:c.INSTANCE:new O(C,N,_)}constructor(C,N,_){this.c=C,this.d=N,this.f=_,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:U(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=u.get(this.c);if(typeof C=="boolean"){const N=C?"true":"false";return this.d===N?o.INSTANCE:c.INSTANCE}return this}evaluate(C){return C.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(C){return C.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$yj=O;class R{static create(C,N=null){const _=u.get(C);return typeof _=="boolean"?_?o.INSTANCE:c.INSTANCE:new R(C,N)}constructor(C,N){this.c=C,this.d=N,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:z(this.c,C.c)}equals(C){return C.type===this.type?this.c===C.c:!1}substituteConstants(){const C=u.get(this.c);return typeof C=="boolean"?C?o.INSTANCE:c.INSTANCE:this}evaluate(C){return!C.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(C){return C.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$zj=R;function W(Y,C){if(typeof Y=="string"){const N=parseFloat(Y);isNaN(N)||(Y=N)}return typeof Y=="string"||typeof Y=="number"?C(Y):o.INSTANCE}class F{static create(C,N,_=null){return W(N,ne=>new F(C,ne,_))}constructor(C,N,_){this.c=C,this.d=N,this.f=_,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:U(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Aj=F;class T{static create(C,N,_=null){return W(N,ne=>new T(C,ne,_))}constructor(C,N,_){this.c=C,this.d=N,this.f=_,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:U(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Bj=T;class q{static create(C,N,_=null){return W(N,ne=>new q(C,ne,_))}constructor(C,N,_){this.c=C,this.d=N,this.f=_,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:U(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Cj=q;class ue{static create(C,N,_=null){return W(N,ne=>new ue(C,ne,_))}constructor(C,N,_){this.c=C,this.d=N,this.f=_,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:U(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Dj=ue;class ee{static create(C,N){return new ee(C,N)}constructor(C,N){this.d=C,this.f=N,this.type=7,this.c=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.d<C.d)return-1;if(this.d>C.d)return 1;const N=this.f?this.f.source:"",_=C.f?C.f.source:"";return N<_?-1:N>_?1:0}equals(C){if(C.type===this.type){const N=this.f?this.f.source:"",_=C.f?C.f.source:"";return this.d===C.d&&N===_}return!1}substituteConstants(){return this}evaluate(C){const N=C.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const C=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${C}`}keys(){return[this.d]}map(C){return C.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Ej=ee;class ce{static create(C){return new ce(C)}constructor(C){this.c=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(C){return new ce(this.c.map(C))}negate(){return this.c}}e.$Fj=ce;function K(Y){let C=null;for(let N=0,_=Y.length;N<_;N++){const ne=Y[N].substituteConstants();if(Y[N]!==ne&&C===null){C=[];for(let Q=0;Q<N;Q++)C[Q]=Y[Q]}C!==null&&(C[N]=ne)}return C===null?Y:C}class X{static create(C,N,_){return X.d(C,N,_)}constructor(C,N){this.expr=C,this.c=N,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const ne=n(this.expr[N],C.expr[N]);if(ne!==0)return ne}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(C.expr[N]))return!1;return!0}return!1}substituteConstants(){const C=K(this.expr);return C===this.expr?this:X.create(C,this.c,!1)}evaluate(C){for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].evaluate(C))return!1;return!0}static d(C,N,_){const ne=[];let Q=!1;for(const x of C)if(x){if(x.type===1){Q=!0;continue}if(x.type===0)return o.INSTANCE;if(x.type===6){ne.push(...x.expr);continue}ne.push(x)}if(ne.length===0&&Q)return c.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(n);for(let x=1;x<ne.length;x++)ne[x-1].equals(ne[x])&&(ne.splice(x,1),x--);if(ne.length===1)return ne[0];for(;ne.length>1;){const x=ne[ne.length-1];if(x.type!==9)break;ne.pop();const V=ne.pop(),H=ne.length===0,se=B.create(x.expr.map(he=>X.create([he,V],null,_)),null,H);se&&(ne.push(se),ne.sort(n))}if(ne.length===1)return ne[0];if(_){for(let x=0;x<ne.length;x++)for(let V=x+1;V<ne.length;V++)if(ne[x].negate().equals(ne[V]))return o.INSTANCE;if(ne.length===1)return ne[0]}return new X(ne,N)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const N of this.expr)C.push(...N.keys());return C}map(C){return new X(this.expr.map(N=>N.map(C)),null)}negate(){if(!this.c){const C=[];for(const N of this.expr)C.push(N.negate());this.c=B.create(C,this,!0)}return this.c}}e.$Gj=X;class B{static create(C,N,_){return B.d(C,N,_)}constructor(C,N){this.expr=C,this.c=N,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const ne=n(this.expr[N],C.expr[N]);if(ne!==0)return ne}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(C.expr[N]))return!1;return!0}return!1}substituteConstants(){const C=K(this.expr);return C===this.expr?this:B.create(C,this.c,!1)}evaluate(C){for(let N=0,_=this.expr.length;N<_;N++)if(this.expr[N].evaluate(C))return!0;return!1}static d(C,N,_){let ne=[],Q=!1;if(C){for(let x=0,V=C.length;x<V;x++){const H=C[x];if(H){if(H.type===0){Q=!0;continue}if(H.type===1)return c.INSTANCE;if(H.type===9){ne=ne.concat(H.expr);continue}ne.push(H)}}if(ne.length===0&&Q)return o.INSTANCE;ne.sort(n)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let x=1;x<ne.length;x++)ne[x-1].equals(ne[x])&&(ne.splice(x,1),x--);if(ne.length===1)return ne[0];if(_){for(let x=0;x<ne.length;x++)for(let V=x+1;V<ne.length;V++)if(ne[x].negate().equals(ne[V]))return c.INSTANCE;if(ne.length===1)return ne[0]}return new B(ne,N)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const N of this.expr)C.push(...N.keys());return C}map(C){return new B(this.expr.map(N=>N.map(C)),null)}negate(){if(!this.c){const C=[];for(const N of this.expr)C.push(N.negate());for(;C.length>1;){const N=C.shift(),_=C.shift(),ne=[];for(const Q of le(N))for(const x of le(_))ne.push(X.create([Q,x],null,!1));C.unshift(B.create(ne,null,!1))}this.c=B.create(C,this,!0)}return this.c}}e.$Hj=B;class M extends b{static{this.d=[]}static all(){return M.d.values()}constructor(C,N,_){super(C,null),this.f=N,typeof _=="object"?M.d.push({..._,key:C}):_!==!0&&M.d.push({key:C,description:_,type:N!=null?typeof N:void 0})}bindTo(C){return C.createKey(this.key,this.f)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return L.create(this.key,C)}notEqualsTo(C){return O.create(this.key,C)}}e.$Ij=M,e.$Jj=(0,A.$ri)("contextKeyService");function z(Y,C){return Y<C?-1:Y>C?1:0}function U(Y,C,N,_){return Y<N?-1:Y>N?1:C<_?-1:C>_?1:0}function ae(Y,C){if(Y.type===0||C.type===1)return!0;if(Y.type===9)return C.type===9?G(Y.expr,C.expr):!1;if(C.type===9){for(const N of C.expr)if(ae(Y,N))return!0;return!1}if(Y.type===6){if(C.type===6)return G(C.expr,Y.expr);for(const N of Y.expr)if(ae(N,C))return!0;return!1}return Y.equals(C)}function G(Y,C){let N=0,_=0;for(;N<Y.length&&_<C.length;){const ne=Y[N].cmp(C[_]);if(ne<0)return!1;ne===0&&N++,_++}return N===Y.length}function le(Y){return Y.type===9?Y.expr:[Y]}}),define(re[92],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$$m=e.ID=void 0,e.$_m=D,e.ID="diagnosticsService",e.$$m=(0,i.$ri)(e.ID);function D(A){return!!A.hostName&&!!A.errorMessage}class S{async getPerformanceInfo(P,k){return{}}async getSystemInfo(P,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(P,k){return""}async getWorkspaceFileExtensions(P){return{extensions:[]}}async reportWorkspaceStats(P){}}e.$an=S}),define(re[119],oe([0,1,19,74,168,6,48,4,35]),function(J,e,i,D,S,A,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Cw=e.$Bw=e.$Aw=void 0,e.$Dw=$,e.$Ew=g,e.$Aw=(0,A.$ri)("dialogService");var l;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(l||(l={}));class d{a(p){return this.d(p,l.Confirmation)}b(p){return this.d(p,l.Prompt)}c(p){return this.d(p,l.Input)}d(p,m){const f=[];switch(m){case l.Confirmation:{const h=p;h.primaryButton?f.push(h.primaryButton):f.push((0,S.localize)(0,null)),h.cancelButton?f.push(h.cancelButton):f.push((0,S.localize)(1,null));break}case l.Prompt:{const h=p;Array.isArray(h.buttons)&&h.buttons.length>0&&f.push(...h.buttons.map(w=>w.label)),h.cancelButton&&(h.cancelButton===!0?f.push((0,S.localize)(2,null)):typeof h.cancelButton=="string"?f.push(h.cancelButton):h.cancelButton.label?f.push(h.cancelButton.label):f.push((0,S.localize)(3,null))),f.length===0&&f.push((0,S.localize)(4,null));break}case l.Input:{const h=p;h.primaryButton?f.push(h.primaryButton):f.push((0,S.localize)(5,null)),h.cancelButton?f.push(h.cancelButton):f.push((0,S.localize)(6,null));break}}return f}e(p){if(typeof p=="string")return p;if(typeof p=="number")return p===D.default.Info?"info":p===D.default.Error?"error":p===D.default.Warning?"warning":"none"}f(p,m,f){const h=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&h.push(p.cancelButton);let w=h[m]?.run({checkboxChecked:f});return w instanceof Promise||(w=Promise.resolve(w)),{result:w,checkboxChecked:f}}}e.$Bw=d,e.$Cw=(0,A.$ri)("fileDialogService");var y;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const E=10;function $(v){const p=[];return p.push(...v.slice(0,E).map(m=>typeof m=="string"?m:(0,i.$2g)(m))),v.length>E&&(v.length-E===1?p.push((0,S.localize)(7,null)):p.push((0,S.localize)(8,null,v.length-E))),p.push(""),p.join(`
`)}function g(v,p){const m=(0,u.$Xn)(v);let f=(m.buttons??[]).map(t=>(0,P.$xw)(t)),h=(v.buttons||[]).map((t,r)=>r),w=0,a=m.cancelId??f.length-1;if(f.length>1){const t=typeof a=="number"?f[a]:void 0;if(k.$k||k.$j){if(typeof t=="string"&&f.length>1&&a!==1){f.splice(a,1),f.splice(1,0,t);const r=h[a];h.splice(a,1),h.splice(1,0,r),a=1}k.$k&&f.length>1&&(f=f.reverse(),h=h.reverse(),w=f.length-1,typeof t=="string"&&(a=w-1))}else if(k.$i&&typeof t=="string"&&f.length>1&&a!==f.length-1){f.splice(a,1),f.push(t);const r=h[a];h.splice(a,1),h.push(r),a=f.length-1}}return m.buttons=f,m.defaultId=w,m.cancelId=a,m.noLink=!0,m.title=m.title||p.nameLong,{options:m,buttonIndeces:h}}}),define(re[120],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$pX=e.$oX=void 0,e.$qX=A,e.$rX=P,e.$oX=(0,i.$ri)("encryptionService"),e.$pX=(0,i.$ri)("encryptionMainService");var D;(function(k){k.kwallet="kwallet",k.kwallet5="kwallet5",k.gnomeLibsecret="gnome-libsecret",k.basic="basic"})(D||(e.PasswordStoreCLIOption=D={}));var S;(function(k){k.unknown="unknown",k.basicText="basic_text",k.gnomeAny="gnome_any",k.gnomeLibsecret="gnome_libsecret",k.gnomeKeyring="gnome_keyring",k.kwallet="kwallet",k.kwallet5="kwallet5",k.kwallet6="kwallet6",k.dplib="dpapi",k.keychainAccess="keychain_access"})(S||(e.KnownStorageProvider=S={}));function A(k){return k==="kwallet"||k==="kwallet5"||k==="kwallet6"}function P(k){return k==="gnome_any"||k==="gnome_libsecret"||k==="gnome_keyring"}}),define(re[38],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=void 0,e.$yi=(0,i.$ri)("environmentService"),e.$zi=(0,i.$si)(e.$yi)}),define(re[121],oe([0,1,172,6]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.ExtensionGalleryErrorCode=e.$2o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$1o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$Uo=S,e.$Vo=A,e.$Wo=P,e.$Xo=k,e.$Yo=u,e.$Zo=l,e.$Oo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Po=new RegExp(e.$Oo),e.$Qo="__web_extension",e.$Ro="skipWalkthrough",e.$So="extensionsSync",e.$To="dependecyOrPackExtensionInstall";function S(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function P(h,w){switch(h){case 3:return w==="x64"?"win32-x64":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function k(h,w){return w==="web"&&!h.includes("web")}function u(h,w,a){return k(w,a)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===a}function l(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}var d;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(d||(e.SortBy=d={}));var y;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var E;(function(h){h.Install="install",h.Uninstall="uninstall"})(E||(e.StatisticType=E={}));var $;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$1o=(0,D.$ri)("extensionGalleryService");var g;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Unknown="Unknown",h.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var v;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class p extends Error{constructor(w,a){super(w),this.code=a,this.name=a}}e.$2o=p;var m;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed"})(m||(e.ExtensionGalleryErrorCode=m={}));class f extends Error{constructor(w,a){super(w),this.code=a,this.name=a}}e.$3o=f,e.$4o=(0,D.$ri)("extensionManagementService"),e.$5o="extensionsIdentifiers/disabled",e.$6o="extensionsIdentifiers/enabled",e.$7o=(0,D.$ri)("IGlobalExtensionEnablementService"),e.$8o=(0,D.$ri)("IExtensionTipsService"),e.$9o=(0,i.localize2)(0,"Extensions"),e.$0o=(0,i.localize2)(1,"Preferences")}),define(re[212],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=e.$Qbc=void 0,e.$Qbc=(0,i.$ri)("extensionHostStarter"),e.$Rbc="extensionHostStarter"}),define(re[213],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=e.$M6b=void 0,e.$M6b=(0,i.$ri)("externalTerminal"),e.$N6b="Terminal.app"}),define(re[214],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0,e.$Tbc=(0,i.$ri)("externalTerminal")}),define(re[215],oe([0,1,49,51,13,9,4,76,21,90,176,213]),function(J,e,i,D,S,A,P,k,u,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=e.$Vbc=e.$Ubc=void 0;const E=d.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends ${static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(i,a,l.$jm(),t)}spawnTerminal(a,t,r,s){const n=t.windowsExec||g.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=A.$oc(n,".exe").toLowerCase();if(o==="cmder")return a.spawn(n,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return n.indexOf(" ")>=0&&c.push('""'),c.push(n),o==="wt"&&c.push("-d ."),new Promise((b,L)=>{const I=m(process),j=a.spawn(r,c,{cwd:s,env:I,detached:!0});j.on("error",L),j.on("exit",()=>b())})}async runInTerminal(a,t,r,s,n){const o="windowsExec"in n&&n.windowsExec?n.windowsExec:g.getDefaultTerminalWindows(),c=await g.f();return new Promise((b,L)=>{const I=`"${t} - ${E}"`,j=`"${r.join('" "')}" & pause`,O=Object.assign({},m(process),s);Object.keys(O).filter(q=>O[q]===null).forEach(q=>delete O[q]);const R={cwd:t,env:O,windowsVerbatimArguments:!0};let W,F;A.$oc(o,".exe")==="wt"?(W=o,F=["-d",".",g.b,"/c",j]):c?(W=c,F=["-d",".",o,"/c",j]):(W=g.b,F=["/c","start",I,"/wait",o,"/c",`"${j}"`]),i.spawn(W,F,R).on("error",q=>{L(f(q))}),b(void 0)})}static getDefaultTerminalWindows(){if(!g.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return g.d}static async f(){try{const a=await l.win32.findExecutable("wt");return await u.Promises.exists(a)?a:void 0}catch{return}}}e.$Ubc=g,Se([D.$Vh],g,"f",null);class v extends ${static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(i,a,t)}runInTerminal(a,t,r,s,n){const o=n.osxExec||y.$N6b;return new Promise((c,b)=>{if(o===y.$N6b||o==="iTerm.app"){const L=o===y.$N6b?"TerminalHelper":"iTermHelper",j=[S.$Lg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${L}.scpt`).fsPath,"-t",a||E,"-w",t];for(const W of r)j.push("-a"),j.push(W);if(s){const W=Object.assign({},m(process),s);for(const F in W){const T=W[F];T===null?(j.push("-u"),j.push(F)):(j.push("-e"),j.push(`${F}=${T}`))}}let O="";const R=i.spawn(v.b,j);R.on("error",W=>{b(f(W))}),R.stderr.on("data",W=>{O+=W.toString()}),R.on("exit",W=>{if(W===0)c(void 0);else if(O){const F=O.split(`
`,1);b(new Error(F[0]))}else b(new Error(d.localize(1,null,L,W)))})}else b(new Error(d.localize(2,null,o)))})}spawnTerminal(a,t,r){const s=t.osxExec||y.$N6b;return new Promise((n,o)=>{const c=["-a",s];r&&c.push(r);const b=m(process),L=a.spawn("/usr/bin/open",c,{cwd:r,env:b});L.on("error",o),L.on("exit",()=>n())})}}e.$Vbc=v;class p extends ${static{this.b=d.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(i,a,t)}runInTerminal(a,t,r,s,n){const o=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((c,b)=>{const L=[];o.then(I=>{I.indexOf("gnome-terminal")>=0?L.push("-x"):L.push("-e"),L.push("bash"),L.push("-c");const j=`${h(r)}; echo; read -p "${p.b}" -n1;`;L.push(`''${j}''`);const O=Object.assign({},m(process),s);Object.keys(O).filter(T=>O[T]===null).forEach(T=>delete O[T]);const R={cwd:t,env:O};let W="";const F=i.spawn(I,L,R);F.on("error",T=>{b(f(T))}),F.stderr.on("data",T=>{W+=T.toString()}),F.on("exit",T=>{if(T===0)c(void 0);else if(W){const q=W.split(`
`,1);b(new Error(q[0]))}else b(new Error(d.localize(4,null,I,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!P.$k)p.d=Promise.resolve("xterm");else{const a=await u.Promises.exists("/etc/debian_version");p.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return p.d}spawnTerminal(a,t,r){const s=t.linuxExec?Promise.resolve(t.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{s.then(c=>{const b=m(process),L=a.spawn(c,[],{cwd:r,env:b});L.on("error",o),L.on("exit",()=>n())})})}}e.$Wbc=p;function m(w){const a={...w.env};return(0,k.$hm)(a),a}function f(w){return"errno"in w&&w.errno==="ENOENT"&&"path"in w&&typeof w.path=="string"?new Error(d.localize(5,null,w.path)):w}function h(w){let a="";for(const t of w)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(re[16],oe([0,1,59,9,25,12,7,178,6,4,13,62]),function(J,e,i,D,S,A,P,k,u,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$ql=e.FileKind=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.FileOperationResult=e.$il=e.$hl=e.$gl=e.$el=e.FileChangeType=e.$dl=e.FileOperation=e.$0k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$Xk=void 0,e.$Yk=E,e.$Zk=p,e.$1k=f,e.$2k=h,e.$3k=w,e.$4k=a,e.$5k=t,e.$6k=r,e.$7k=s,e.$8k=n,e.$9k=o,e.$$k=L,e.$_k=I,e.$al=j,e.$bl=O,e.$cl=R,e.$fl=ue,e.$rl=M,e.$sl=z,e.$ul=ae,e.$Xk=(0,u.$ri)("fileService");function E(G){return G.create===!0}var $;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var g;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(g||(e.FilePermission=g={}));var v;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(v||(e.FileChangeFilter=v={}));function p(G){const le=G;return!!le&&typeof le.onDidChange=="function"}var m;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function f(G){return!!(G.capabilities&2)}function h(G){return!!(G.capabilities&8)}function w(G){return!!(G.capabilities&131072)}function a(G){return!!(G.capabilities&4)}function t(G){return!!(G.capabilities&16)}function r(G){return f(G)?!!(G.capabilities&16384):!1}function s(G){return f(G)?!!(G.capabilities&32768):!1}function n(G){return!!(G.capabilities&65536)}function o(G){return!!(G.capabilities&2048)}var c;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class b extends Error{static create(le,Y){const C=new b(le.toString(),Y);return j(C,Y),C}constructor(le,Y){super(le),this.code=Y}}e.$0k=b;function L(G,le){return b.create(G,le)}function I(G){return G||L((0,k.localize)(0,null),c.Unknown)}function j(G,le){return G.name=le?`${le} (FileSystemError)`:"FileSystemError",G}function O(G){if(!G)return c.Unknown;if(G instanceof b)return G.code;const le=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!le)return c.Unknown;switch(le[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}function R(G){if(G instanceof ee)return G.fileOperationResult;switch(O(G)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}var W;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(W||(e.FileOperation=W={}));class F{constructor(le,Y,C){this.resource=le,this.operation=Y,this.target=C}isOperation(le){return this.operation===le}}e.$dl=F;var T;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class q{static{this.a=null}constructor(le,Y){this.c=Y,this.b=void 0,this.d=new y.$V(()=>{const C=i.$xi.forUris(()=>this.c);return C.fill(this.rawAdded.map(N=>[N,!0])),C}),this.f=new y.$V(()=>{const C=i.$xi.forUris(()=>this.c);return C.fill(this.rawUpdated.map(N=>[N,!0])),C}),this.g=new y.$V(()=>{const C=i.$xi.forUris(()=>this.c);return C.fill(this.rawDeleted.map(N=>[N,!0])),C}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const C of le){switch(C.type){case 1:this.rawAdded.push(C.resource);break;case 0:this.rawUpdated.push(C.resource);break;case 2:this.rawDeleted.push(C.resource);break}this.b!==q.a&&(typeof C.cId=="number"?this.b===void 0?this.b=C.cId:this.b!==C.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(le,...Y){return this.h(le,{includeChildren:!1},...Y)}affects(le,...Y){return this.h(le,{includeChildren:!0},...Y)}h(le,Y,...C){if(!le)return!1;const N=C.length>0;return!!((!N||C.includes(1))&&(this.d.value.get(le)||Y.includeChildren&&this.d.value.findSuperstr(le))||(!N||C.includes(0))&&(this.f.value.get(le)||Y.includeChildren&&this.f.value.findSuperstr(le))||(!N||C.includes(2))&&(this.g.value.findSubstr(le)||Y.includeChildren&&this.g.value.findSuperstr(le)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(le){return this.b===le}hasCorrelation(){return typeof this.b=="number"}}e.$el=q;function ue(G,le,Y){return!G||!le||G===le||le.length>G.length?!1:(le.charAt(le.length-1)!==D.sep&&(le+=D.sep),Y?(0,S.$vf)(G,le):G.indexOf(le)===0)}class ee extends Error{constructor(le,Y,C){super(le),this.fileOperationResult=Y,this.options=C}}e.$gl=ee;class ce extends ee{constructor(le,Y,C,N){super(le,Y,N),this.fileOperationResult=Y,this.size=C}}e.$hl=ce;class K extends ee{constructor(le,Y,C){super(le,2,C),this.stat=Y}}e.$il=K;var X;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$jl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$kl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ll="files.associations",e.$ml="files.exclude",e.$nl="files.readonlyInclude",e.$ol="files.readonlyExclude",e.$pl="files.readonlyFromPermissions";var B;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$ql="";function M(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function z(G,le){if(!le.hasProvider(P.URI.from({scheme:G.scheme})))return new Promise(Y=>{const C=le.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===G.scheme&&N.added&&(C.dispose(),Y())})})}class U{static{this.KB=1024}static{this.MB=U.KB*U.KB}static{this.GB=U.MB*U.KB}static{this.TB=U.GB*U.KB}static formatSize(le){return(0,A.$9f)(le)||(le=0),le<U.KB?(0,k.localize)(1,null,le.toFixed(0)):le<U.MB?(0,k.localize)(2,null,(le/U.KB).toFixed(2)):le<U.GB?(0,k.localize)(3,null,(le/U.MB).toFixed(2)):le<U.TB?(0,k.localize)(4,null,(le/U.GB).toFixed(2)):(0,k.localize)(5,null,(le/U.TB).toFixed(2))}}e.$tl=U;function ae(G){const le=typeof G=="string"||G?.scheme===d.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===d.Schemas.file?1024*U.MB:le?10*U.MB:l.$o?50*U.MB:1024*U.MB}}),define(re[122],oe([0,1,17,15,179,16]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=P;async function P(d,y,E,$,g,v){let p;try{await k(d,y,E,$,g,v)}catch(m){p=m}finally{p&&g.errorTransformer&&(p=g.errorTransformer(p)),typeof p<"u"&&E.error(p),E.end()}}async function k(d,y,E,$,g,v){u(v);const p=await d.open(y,{create:!1});try{u(v);let m=0,f=0,h=g&&typeof g.length=="number"?g.length:void 0,w=i.$Ce.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),a=g&&typeof g.position=="number"?g.position:0,t=0;do f=await d.read(p,a,w.buffer,t,w.byteLength-t),a+=f,t+=f,m+=f,typeof h=="number"&&(h-=f),t===w.byteLength&&(await E.write($(w)),w=i.$Ce.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),t=0);while(f>0&&(typeof h!="number"||h>0)&&u(v)&&l(m,g));if(t>0){let r=t;typeof h=="number"&&(r=Math.min(t,h)),E.write($(w.slice(0,r)))}}catch(m){throw(0,A.$_k)(m)}finally{await d.close(p)}}function u(d){if(d.isCancellationRequested)throw(0,D.$6)();return!0}function l(d,y){if(typeof y?.limits?.size=="number"&&d>y.limits.size)throw(0,A.$$k)((0,S.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[60],oe([0,1,108,2,9,4,7,16]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=void 0,e.$Eq=u,e.$Fq=l,e.$Jq=$,e.$Kq=g,e.$Lq=v,e.$Mq=p,e.$Nq=f,e.$Oq=h;function u(w){return typeof w.correlationId=="number"}function l(w){return w.recursive===!0}class d extends D.$Uc{static{this.a=5}constructor(a,t,r,s){super(),this.h=a,this.j=t,this.m=r,this.n=s,this.c=this.B(new D.$Vc),this.f=void 0,this.g=0}s(){const a=new D.$Tc;this.c.value=a,this.b=this.r(a),this.b.setVerboseLogging(this.m),a.add(this.b.onDidChangeFile(t=>this.h(t))),a.add(this.b.onDidLogMessage(t=>this.j(t))),a.add(this.b.onDidError(t=>this.t(t)))}t(a){this.n.restartOnError?this.g<d.a&&this.f?(this.w(`restarting watcher after error: ${a}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${a}`):this.w(a)}u(a){this.g++,this.s(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.m=a,await this.b?.setVerboseLogging(a)}w(a){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${a}`})}y(a){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Gq=d;class y extends d{constructor(a,t,r){super(a,t,r,{type:"node.js",restartOnError:!1})}}e.$Hq=y;class E extends d{constructor(a,t,r){super(a,t,r,{type:"universal",restartOnError:!0})}}e.$Iq=E;function $(w){return w.map(a=>({type:a.type,resource:P.URI.revive(a.resource),cId:a.cId}))}function g(w){const a=new m;for(const t of w)a.processEvent(t);return a.coalesce()}function v(w,a){return typeof a=="string"&&!a.startsWith(i.$hk)&&!(0,S.$jc)(a)?{base:w,pattern:a}:a}function p(w,a){const t=[];for(const r of a)t.push((0,i.$lk)(v(w,r)));return t}class m{constructor(){this.a=new Set,this.b=new Map}c(a){return A.$k?a.resource.fsPath:a.resource.fsPath.toLowerCase()}processEvent(a){const t=this.b.get(this.c(a));let r=!1;if(t){const s=t.type,n=a.type;t.resource.fsPath!==a.resource.fsPath&&(a.type===2||a.type===1)?r=!0:s===1&&n===2?(this.b.delete(this.c(a)),this.a.delete(t)):s===2&&n===1?t.type=0:s===1&&n===0||(t.type=n)}else r=!0;r&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?(a.push(r),!1):!0).sort((r,s)=>r.resource.fsPath.length-s.resource.fsPath.length).filter(r=>t.some(s=>(0,k.$fl)(r.resource.fsPath,s,!A.$k))?!1:(t.push(r.resource.fsPath),!0)).concat(a)}}function f(w,a){if(typeof a=="number")switch(w.type){case 1:return(a&4)===0;case 2:return(a&8)===0;case 0:return(a&2)===0}return!1}function h(w){if(typeof w=="number"){const a=[];return w&4&&a.push("Added"),w&8&&a.push("Deleted"),w&2&&a.push("Updated"),a.length===0?"<all>":a.join(", ")}return"<none>"}}),define(re[216],oe([0,1,17,47,15,3,2,63,33,16,60]),function(J,e,i,D,S,A,P,k,u,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=e.$lQ=void 0,e.$lQ="localFilesystem";class y extends P.$Uc{constructor($,g){super(),this.a=$,this.b=g,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$be),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$be),this.onDidWatchError=this.g.event,this.h=(0,u.$Ng)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,g){const{buffer:v}=await this.a.call("readFile",[$,g]);return v}readFileStream($,g,v){const p=(0,k.$qe)(f=>i.$Ce.concat(f.map(h=>i.$Ce.wrap(h))).buffer),m=new P.$Tc;return m.add(this.a.listen("readFileStream",[$,g])(f=>{if(f instanceof i.$Ce)p.write(f.buffer);else{if(f==="end")p.end();else{let h;if(f instanceof Error)h=f;else{const w=f;h=(0,l.$$k)(w.message??(0,D.$cj)(w),w.code??l.FileSystemProviderErrorCode.Unknown)}p.error(h),p.end()}m.dispose()}})),m.add(v.onCancellationRequested(()=>{p.error((0,S.$6)()),p.end(),m.dispose()})),p}writeFile($,g,v){return this.a.call("writeFile",[$,i.$Ce.wrap(g),v])}open($,g){return this.a.call("open",[$,g])}close($){return this.a.call("close",[$])}async read($,g,v,p,m){const[f,h]=await this.a.call("read",[$,g,m]);return v.set(f.buffer.slice(0,h),p),h}write($,g,v,p,m){return this.a.call("write",[$,g,i.$Ce.wrap(v),p,m])}mkdir($){return this.a.call("mkdir",[$])}delete($,g){return this.a.call("delete",[$,g])}rename($,g,v){return this.a.call("rename",[$,g,v])}copy($,g,v){return this.a.call("copy",[$,g,v])}cloneFile($,g){return this.a.call("cloneFile",[$,g])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const g=$;this.f.fire((0,d.$Jq)(g))}else{const g=$;this.g.fire(g)}}))}watch($,g){const v=(0,u.$Ng)();return this.a.call("watch",[this.h,v,$,g]),(0,P.$Sc)(()=>this.a.call("unwatch",[this.h,v]))}}e.$mQ=y}),define(re[217],oe([0,1,43,2,60,3,7,8]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;class u extends D.$Uc{constructor(){super(),this.a=this.B(new A.$be),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$be),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$be),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new D.$4c),this.m=new Set,this.n=5007,this.r=new k.$Oh,this.B(this.f(d=>this.s(d)))}s(d){this.t(d)&&this.w(d)}t(d){return(0,S.$Eq)(d)}async watch(d){this.r.isSettled||this.r.complete(),this.r=new k.$Oh;try{this.h.clear(),this.g.clear();for(const y of d)this.t(y)?this.h.set(y.correlationId,y):this.g.add(y);for(const[y]of this.j)this.h.has(y)||(this.j.deleteAndDispose(y),this.m.delete(y));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))])}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async w(d){if(this.j.has(d.correlationId))return;const y=new D.$Tc;this.j.set(d.correlationId,y),await this.r.p,!y.isDisposed&&(this.z(d,y),this.u())}y(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.u()}z(d,y){this.C(d,y)?(this.M(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.D(d,y),this.m.add(d.correlationId))}C(d,y){const E=this.L?.subscribe(d.path,($,g)=>{y.isDisposed||($?this.z(d,y):g?.type===1&&this.F(d))});return E?(y.add(E),!0):!1}D(d,y){let E=!1;const $=(g,v)=>{if(y.isDisposed)return;const p=this.G(g),m=this.G(v),f=E;E=p,!p&&(m||f)&&this.F(d)};this.M(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,i.watchFile)(d.path,{persistent:!1,interval:this.n},$)}catch(g){this.N(`fs.watchFile() failed with error ${g} on path ${d.path} (correlationId: ${d.correlationId})`)}y.add((0,D.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,i.unwatchFile)(d.path,$)}catch(g){this.N(`fs.unwatchFile() failed with error ${g} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}F(d){this.M(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const y={resource:P.URI.file(d.path),type:1,cId:d.correlationId};this.a.fire([y]),this.H(y,d),this.y(d)}G(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(d,y){const E=` >> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.M(typeof y.correlationId=="number"?`${E} (correlationId: ${y.correlationId})`:E)}I(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,S.$Oq)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}}e.$Xq=u}),define(re[218],oe([0,1,43,8,23,32,2,72,9,4,19,7,109,21,60]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0,e.$4q=p;class v extends P.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(f,h,w,a,t,r){super(),this.s=f,this.t=h,this.u=w,this.w=a,this.y=t,this.z=r,this.c=this.B(new D.$Gh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new D.$Fh(s=>this.M(s),v.b)),this.g=(0,g.$Mq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,g.$Mq)(this.s.path,this.s.includes):void 0,this.j=(0,g.$Eq)(this.s)?this.s.filter:void 0,this.m=new S.$me,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const f=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const h=await $.Promises.stat(f);if(this.m.token.isCancellationRequested)return;this.B(await this.G(f,h.isDirectory()))}catch(f){f.code!=="ENOENT"?this.O(f):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${f})`),this.D()}}D(){this.r=!0,this.w?.()}async F(f){let h=f.path;try{h=await $.Promises.realpath(f.path),f.path===h&&(h=await(0,E.$Zq)(f.path,this.m.token)??f.path),f.path!==h&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${h})`)}catch{}return h}async G(f,h){const w=new P.$Tc;return this.H(f,h,w)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(f,h,w)),w}H(f,h,w){if(h)return!1;const a=y.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,s)=>{if(!w.isDisposed)if(r){const n=await this.G(f,h);w.isDisposed?n.dispose():w.add(n)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:a,type:s.type,cId:this.s.correlationId},!0)});return t?(w.add(t),!0):!1}async I(f,h,w){if(l.$j&&(0,A.$rg)(f,"/Volumes/",!0)){this.O(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new S.$me(this.m.token);w.add((0,P.$Sc)(()=>a.dispose(!0)));const t=new P.$Tc;w.add(t);try{const r=y.URI.file(this.s.path),s=(0,u.$oc)(f),n=(0,i.watch)(f);t.add((0,P.$Sc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${f}'`);const o=new Set;if(h)try{for(const b of await $.Promises.readdir(f))o.add(b)}catch(b){this.O(b)}if(a.token.isCancellationRequested)return;const c=new Map;t.add((0,P.$Sc)(()=>{for(const[,b]of c)b.dispose();c.clear()})),n.on("error",(b,L)=>{a.token.isCancellationRequested||(this.O(`Failed to watch ${f} for changes using fs.watch() (${b}, ${L})`),this.D())}),n.on("change",(b,L)=>{if(a.token.isCancellationRequested)return;this.Q(`[raw] ["${b}"] ${L}`);let I="";if(L&&(I=L.toString(),l.$j&&(I=(0,k.$9l)(I))),!(!I||b!=="change"&&b!=="rename"))if(h)if(b==="rename"){c.get(I)?.dispose();const j=setTimeout(async()=>{if(c.delete(I),I===s&&!await $.Promises.exists(f)){this.J(r);return}if(a.token.isCancellationRequested)return;const O=await this.N((0,u.$kc)(f,I));if(a.token.isCancellationRequested)return;let R;O?o.has(I)?R=0:(R=1,o.add(I)):(o.delete(I),R=2),this.L({resource:(0,d.$5g)(r,I),type:R,cId:this.s.correlationId})},v.a);c.set(I,(0,P.$Sc)(()=>clearTimeout(j)))}else{let j;o.has(I)?j=0:(j=1,o.add(I)),this.L({resource:(0,d.$5g)(r,I),type:j,cId:this.s.correlationId})}else if(b==="rename"||I!==s){const j=setTimeout(async()=>{const O=await $.Promises.exists(f);a.token.isCancellationRequested||(O?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(f,!1))):this.J(r))},v.a);t.clear(),t.add((0,P.$Sc)(()=>clearTimeout(j)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){a.token.isCancellationRequested||this.O(`Failed to watch ${f} for changes using fs.watch() (${r.toString()})`),this.D()}}J(f){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:f,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(f,h=!1){this.m.token.isCancellationRequested||(this.z&&this.Q(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!h&&this.g.some(w=>w(f.resource.fsPath))?this.z&&this.Q(` >> ignored (excluded) ${f.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(w=>w(f.resource.fsPath))?this.z&&this.Q(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}M(f){const h=(0,g.$Kq)(f),w=[];for(const t of h){if((0,g.$Nq)(t,this.j)){this.z&&this.Q(` >> ignored (filtered) ${t.resource.fsPath}`);continue}w.push(t)}if(w.length===0)return;if(this.z)for(const t of w)this.Q(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(w)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${w[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${w.length}, most recent change: ${w[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(f){if(l.$k)return $.Promises.exists(f);try{const h=(0,u.$oc)(f);return(await $.Promises.readdir((0,u.$nc)(f))).some(a=>a===h)}catch(h){return this.Q(h),!1}}setVerboseLogging(f){this.z=f}O(f){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}P(f){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}Q(f){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.m.dispose(!0),super.dispose()}}e.$3q=v;async function p(m,f,h,w,a=512){const t=await $.Promises.open(m,"r"),r=Buffer.allocUnsafe(a),s=new S.$me(w);let n,o=!1;const c={path:m,excludes:[],recursive:!1},b=new v(c,void 0,L=>{(async()=>{for(const{type:I}of L)if(I===0){if(o)return;o=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:j}=await $.Promises.read(t,r,0,a,null);if(!j||s.token.isCancellationRequested)break;f(r.slice(0,j))}}catch(j){n=new Error(j),s.dispose(!0)}finally{o=!1}}})()});return await b.ready,h(),new Promise((L,I)=>{s.token.onCancellationRequested(async()=>{b.dispose();try{await $.Promises.close(t)}catch(j){n=new Error(j)}n?I(n):L()})})}}),define(re[219],oe([0,1,3,108,217,4,218,32]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;class u extends S.$Xq{constructor(d){super(),this.L=d,this.onDidError=i.Event.None,this.watchers=new Set,this.O=!1}async J(d){d=this.W(d);const y=[],E=new Set(Array.from(this.watchers));for(const $ of d){const g=this.R($);g&&(0,D.$pk)(g.request.excludes,$.excludes)&&(0,D.$pk)(g.request.includes,$.includes)?E.delete(g):y.push($)}y.length&&this.M(`Request to start watching: ${y.map($=>this.I($)).join(",")}`),E.size&&this.M(`Request to stop watching: ${Array.from(E).map($=>this.I($.request)).join(",")}`);for(const $ of E)this.U($);for(const $ of y)this.S($)}R(d){for(const y of this.watchers)if(typeof d.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===d.correlationId)return y}else if((0,k.$qg)(y.request.path,d.path,!A.$k))return y}S(d){const y=new P.$3q(d,this.L,$=>this.a.fire($),()=>this.c.fire(d),$=>this.b.fire($),this.O),E={request:d,instance:y};this.watchers.add(E)}async stop(){await super.stop();for(const d of this.watchers)this.U(d)}U(d){this.M("stopping file watcher",d),this.watchers.delete(d),d.instance.dispose()}W(d){const y=new Map;for(const E of d){const $=A.$k?E.path:E.path.toLowerCase();let g=y.get(E.correlationId);g||(g=new Map,y.set(E.correlationId,g)),g.has($)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I(E)}`),g.set($,E)}return Array.from(y.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(d){this.O=d;for(const y of this.watchers)y.instance.setVerboseLogging(d)}M(d,y){this.O&&this.b.fire({type:"trace",message:this.Z(d,y)})}N(d){this.b.fire({type:"warn",message:this.Z(d)})}Z(d,y){return y?`[File Watcher (node.js)] ${d} (${this.I(y.request)})`:`[File Watcher (node.js)] ${d}`}}e.$5q=u}),define(re[220],oe([0,1,60,219]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class S extends i.$Hq{constructor(P,k,u){super(P,k,u),this.s()}r(P){return P.add(new D.$5q(void 0))}}e.$6q=S}),define(re[221],oe([0,1,13,44,162,60]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;class P extends A.$Iq{constructor(u,l,d){super(u,l,d),this.s()}r(u){const l=u.add(new S.$Vq(i.$Lg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(l.onDidProcessExit(({code:d,signal:y})=>this.t(`terminated by itself with code ${d}, signal: ${y}`))),D.ProxyChannel.toService((0,D.$$h)(l.getChannel("watcher")))}}e.$Wq=P}),define(re[93],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=void 0;class i{constructor(...S){this.a=new Map;for(const[A,P]of S)this.set(A,P)}set(S,A){const P=this.a.get(S);return this.a.set(S,A),P}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$pi=i}),define(re[222],oe([0,1,8,15,2,78,211,6,93,104]),function(J,e,i,D,S,A,P,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=void 0;const d=!1;class y extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class E{constructor(p=new u.$pi,m=!1,f,h=d){this.i=p,this.j=m,this.k=f,this.l=h,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$qi,this),this._globalGraph=h?f?._globalGraph??new P.$9q(w=>w):void 0}dispose(){if(!this.f){this.f=!0,(0,S.$Pc)(this.h),this.h.clear();for(const p of this.g)(0,S.$Oc)(p)&&p.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(p){this.m();const m=new class extends E{dispose(){this.h.delete(m),super.dispose()}}(p,this.j,this,this.l);return this.h.add(m),m}invokeFunction(p,...m){this.m();const f=g.traceInvocation(this.l,p);let h=!1;try{return p({get:a=>{if(h)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(a,f);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...m)}finally{h=!0,f.stop()}}createInstance(p,...m){this.m();let f,h;return p instanceof A.$oi?(f=g.traceCreation(this.l,p.ctor),h=this.o(p.ctor,p.staticArguments.concat(m),f)):(f=g.traceCreation(this.l,p),h=this.o(p,m,f)),f.stop(),h}o(p,m=[],f){const h=k._util.getServiceDependencies(p).sort((t,r)=>t.index-r.index),w=[];for(const t of h){const r=this.s(t.id,f);r||this.y(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),w.push(r)}const a=h.length>0?h[0].index:m.length;if(m.length!==a){console.trace(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${m.length} static arguments`);const t=a-m.length;t>0?m=m.concat(new Array(t)):m=m.slice(0,a)}return Reflect.construct(p,m.concat(w))}q(p,m){if(this.i.get(p)instanceof A.$oi)this.i.set(p,m);else if(this.k)this.k.q(p,m);else throw new Error("illegalState - setting UNKNOWN service instance")}r(p){const m=this.i.get(p);return!m&&this.k?this.k.r(p):m}s(p,m){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const f=this.r(p);return f instanceof A.$oi?this.u(p,f,m.branch(p,!0)):(m.branch(p,!1),f)}u(p,m,f){if(this.t.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.t.add(p);try{return this.v(p,m,f)}finally{this.t.delete(p)}}v(p,m,f){const h=new P.$9q(t=>t.id.toString());let w=0;const a=[{id:p,desc:m,_trace:f}];for(;a.length;){const t=a.pop();if(h.lookupOrInsertNode(t),w++>1e3)throw new y(h);for(const r of k._util.getServiceDependencies(t.desc.ctor)){const s=this.r(r.id);if(s||this.y(`[createInstance] ${p} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),s instanceof A.$oi){const n={id:r.id,desc:s,_trace:t._trace.branch(r.id,!0)};h.insertEdge(t,n),a.push(n)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new y(h);break}for(const{data:r}of t){if(this.r(r.id)instanceof A.$oi){const n=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,n)}h.removeNode(r)}}return this.r(p)}w(p,m,f=[],h,w){if(this.i.get(p)instanceof A.$oi)return this.x(p,m,f,h,w,this.g);if(this.k)return this.k.w(p,m,f,h,w);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}x(p,m,f=[],h,w,a){if(h){const t=new E(void 0,this.j,this,this.l);t.c=String(p);const r=new Map,s=new i.$Kh(()=>{const n=t.o(m,f,w);for(const[o,c]of r){const b=n[o];if(typeof b=="function")for(const L of c)L.disposable=b.apply(n,L.listener)}return r.clear(),a.add(n),n});return new Proxy(Object.create(null),{get(n,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let L=r.get(o);return L||(L=new l.$5c,r.set(o,L)),(j,O,R)=>{if(s.isInitialized)return s.value[o](j,O,R);{const W={listener:[j,O,R],disposable:void 0},F=L.push(W);return(0,S.$Sc)(()=>{F(),W.disposable?.dispose()})}}}if(o in n)return n[o];const c=s.value;let b=c[o];return typeof b!="function"||(b=b.bind(c),n[o]=b),b},set(n,o,c){return s.value[o]=c,!0},getPrototypeOf(n){return m.prototype}})}else{const t=this.o(m,f,w);return a.add(t),t}}y(p,m){if(m&&console.warn(p),this.j)throw new Error(p)}}e.$0q=E;var $;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})($||($={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,m){return p?new g(2,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(p,m){return p?new g(1,m.name):g.c}static{this.f=0}constructor(p,m){this.type=p,this.name=m,this.g=Date.now(),this.h=[]}branch(p,m){const f=new g(3,p.toString());return this.h.push([p,m,f]),f}stop(){const p=Date.now()-this.g;g.f+=p;let m=!1;function f(w,a){const t=[],r=new Array(w+1).join("	");for(const[s,n,o]of a.h)if(n&&o){m=!0,t.push(`${r}CREATES -> ${s}`);const c=f(w+1,o);c&&t.push(c)}else t.push(`${r}uses -> ${s}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(p>2||m)&&g.all.add(h.join(`
`))}}e.$$q=g}),define(re[223],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AJb=e.IssueSource=e.IssueType=void 0;var D;(function(A){A[A.Bug=0]="Bug",A[A.PerformanceIssue=1]="PerformanceIssue",A[A.FeatureRequest=2]="FeatureRequest"})(D||(e.IssueType=D={}));var S;(function(A){A.VSCode="vscode",A.Extension="extension",A.Marketplace="marketplace"})(S||(e.IssueSource=S={})),e.$AJb=(0,i.$ri)("issueService")}),define(re[5],oe([0,1,183,47,3,46,2,31,4,19,12,7,118,6]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$1j=e.LogLevel=e.$Yj=e.$Xj=void 0,e.$Zj=v,e.log=m,e.$_j=b,e.$ak=L,e.$bk=I,e.$ck=j,e.$Xj=(0,$.$ri)("logService"),e.$Yj=(0,$.$ri)("loggerService");function g(){return new Date().toISOString()}function v(O){return(0,d.$9f)(O)}var p;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$1j=p.Info;function m(O,R,W){switch(R){case p.Trace:O.trace(W);break;case p.Debug:O.debug(W);break;case p.Info:O.info(W);break;case p.Warning:O.warn(W);break;case p.Error:O.error(W);break;case p.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function f(O,R=!1){let W="";for(let F=0;F<O.length;F++){let T=O[F];if(T instanceof Error&&(T=(0,D.$cj)(T,R)),typeof T=="object")try{T=JSON.stringify(T)}catch{}W+=(F>0?" ":"")+T}return W}class h extends P.$Uc{constructor(){super(...arguments),this.b=e.$1j,this.c=this.B(new S.$be),this.onDidChangeLogLevel=this.c.event}setLevel(R){this.b!==R&&(this.b=R,this.c.fire(this.b))}getLevel(){return this.b}f(R){return this.b!==p.Off&&this.b<=R}}e.$3j=h;class w extends h{constructor(R){super(),this.h=R}f(R){return this.h||super.f(R)}trace(R,...W){this.f(p.Trace)&&this.g(p.Trace,f([R,...W],!0))}debug(R,...W){this.f(p.Debug)&&this.g(p.Debug,f([R,...W]))}info(R,...W){this.f(p.Info)&&this.g(p.Info,f([R,...W]))}warn(R,...W){this.f(p.Warning)&&this.g(p.Warning,f([R,...W]))}error(R,...W){if(this.f(p.Error))if(R instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=R.stack,this.g(p.Error,f(F))}else this.g(p.Error,f([R,...W]))}flush(){}}e.$4j=w;class a extends h{constructor(R=e.$1j){super(),this.setLevel(R),this.g=!u.$i}trace(R,...W){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,R,...W):console.log(`[main ${g()}]`,R,...W))}debug(R,...W){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,R,...W):console.log(`[main ${g()}]`,R,...W))}info(R,...W){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,R,...W):console.log(`[main ${g()}]`,R,...W))}warn(R,...W){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,R,...W):console.warn(`[main ${g()}]`,R,...W))}error(R,...W){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,R,...W):console.error(`[main ${g()}]`,R,...W))}flush(){}}e.$5j=a;class t extends h{constructor(R=e.$1j,W=!0){super(),this.g=W,this.setLevel(R)}trace(R,...W){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",R,...W):console.log(R,...W))}debug(R,...W){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",R,...W):console.log(R,...W))}info(R,...W){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",R,...W):console.log(R,...W))}warn(R,...W){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",R,...W):console.log(R,...W))}error(R,...W){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",R,...W):console.error(R,...W))}flush(){}}e.$6j=t;class r extends h{constructor(R,W=e.$1j){super(),this.g=R,this.setLevel(W)}trace(R,...W){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(R),...W])}debug(R,...W){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(R),...W])}info(R,...W){this.f(p.Info)&&this.g.log(p.Info,[this.h(R),...W])}warn(R,...W){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(R),...W])}error(R,...W){this.f(p.Error)&&this.g.log(p.Error,[this.h(R),...W])}h(R){return typeof R=="string"?R:(0,D.$cj)(R,this.f(p.Trace))}flush(){}}e.$7j=r;class s extends h{constructor(R){super(),this.g=R,R.length&&this.setLevel(R[0].getLevel())}setLevel(R){for(const W of this.g)W.setLevel(R);super.setLevel(R)}trace(R,...W){for(const F of this.g)F.trace(R,...W)}debug(R,...W){for(const F of this.g)F.debug(R,...W)}info(R,...W){for(const F of this.g)F.info(R,...W)}warn(R,...W){for(const F of this.g)F.warn(R,...W)}error(R,...W){for(const F of this.g)F.error(R,...W)}flush(){for(const R of this.g)R.flush()}dispose(){for(const R of this.g)R.dispose();super.dispose()}}e.$8j=s;class n extends P.$Uc{constructor(R,W,F){if(super(),this.h=R,this.j=W,this.b=new k.$Bc,this.c=this.B(new S.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$be),this.onDidChangeVisibility=this.g.event,F)for(const T of F)this.b.set(T.resource,{logger:void 0,info:T})}m(R){return(0,d.$5f)(R)?[...this.b.values()].find(W=>W.info.id===R):this.b.get(R)}getLogger(R){return this.m(R)?.logger}createLogger(R,W){const F=this.n(R),T=(0,d.$5f)(R)?R:W?.id??(0,A.$fj)(F.toString()).toString(16);let q=this.b.get(F)?.logger;const ue=W?.logLevel==="always"?p.Trace:W?.logLevel;q||(q=this.s(F,ue??this.getLogLevel(F)??this.h,{...W,id:T}));const ee={logger:q,info:{resource:F,id:T,logLevel:ue,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(ee.info),this.b.set(F,ee),q}n(R){return(0,d.$5f)(R)?(0,l.$5g)(this.j,`${R}.log`):R}setLogLevel(R,W){if(y.URI.isUri(R)){const F=R,T=W,q=this.b.get(F);q&&T!==q.info.logLevel&&(q.info.logLevel=T===this.h?void 0:T,q.logger?.setLevel(T),this.b.set(q.info.resource,q),this.f.fire([F,T]))}else{this.h=R;for(const[F,T]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(R,W){const F=this.m(R);F&&W!==!F.info.hidden&&(F.info.hidden=!W,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,W]))}getLogLevel(R){let W;return R&&(W=this.b.get(R)?.info.logLevel),W??this.h}registerLogger(R){const W=this.b.get(R.resource);W?W.info.hidden!==R.hidden&&this.setVisibility(R.resource,!R.hidden):(this.b.set(R.resource,{info:R,logger:void 0}),this.c.fire({added:[R],removed:[]}))}deregisterLogger(R){const W=this.b.get(R);W&&(W.logger&&W.logger.dispose(),this.b.delete(R),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const R of this.b.values())yield R.info}getRegisteredLogger(R){return this.b.get(R)?.info}dispose(){this.b.forEach(R=>R.logger?.dispose()),this.b.clear(),super.dispose()}}e.$9j=n;class o{constructor(){this.onDidChangeLogLevel=new S.$be().event}setLevel(R){}getLevel(){return p.Info}trace(R,...W){}debug(R,...W){}info(R,...W){}warn(R,...W){}error(R,...W){}critical(R,...W){}dispose(){}flush(){}}e.$0j=o;class c extends o{}e.$$j=c;function b(O){if(O.verbose)return p.Trace;if(typeof O.logLevel=="string"){const R=j(O.logLevel.toLowerCase());if(R!==void 0)return R}return e.$1j}function L(O){switch(O){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function I(O){switch(O){case p.Trace:return{original:"Trace",value:i.localize(0,null)};case p.Debug:return{original:"Debug",value:i.localize(1,null)};case p.Info:return{original:"Info",value:i.localize(2,null)};case p.Warning:return{original:"Warning",value:i.localize(3,null)};case p.Error:return{original:"Error",value:i.localize(4,null)};case p.Off:return{original:"Off",value:i.localize(5,null)}}}function j(O){switch(O){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$dk=new E.$Ij("logLevel",L(p.Info))});var ie=this&&this.__param||function(J,e){return function(i,D){e(i,D,J)}};define(re[224],oe([0,1,14,4,5]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=void 0;const A=i.safeStorage;let P=class{constructor(u){this.a=u,i.app.commandLine.getSwitchValue("password-store")==="basic"&&A.setUsePlainTextEncryption?.(!0)}async encrypt(u){this.a.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(A.encryptString(u));return this.a.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.a.error(l),l}}async decrypt(u){let l;try{if(l=JSON.parse(u),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${u}`);const d=Buffer.from(l.data);this.a.trace("[EncryptionMainService] Decrypting value.");const y=A.decryptString(d);return this.a.trace("[EncryptionMainService] Decrypted value."),y}catch(d){throw this.a.error(d),d}}isEncryptionAvailable(){return Promise.resolve(A.isEncryptionAvailable())}getKeyStorageProvider(){if(D.$i)return Promise.resolve("dpapi");if(D.$j)return Promise.resolve("keychain_access");if(A.getSelectedStorageBackend)try{const u=A.getSelectedStorageBackend();return Promise.resolve(u)}catch(u){this.a.error(u)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(D.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(D.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!A.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");A.setUsePlainTextEncryption(!0)}};e.$Pbc=P,e.$Pbc=P=Se([ie(0,S.$Xj)],P)}),define(re[225],oe([0,1,22,8,15,3,2,9,60,5]),function(J,e,i,D,S,A,P,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class d extends P.$Uc{constructor(E,$){super(),this.a=E,this.b=$,this.c=this.B(new A.$be),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$be),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$ph(0)),this.w=[],this.y=this.B(new D.$ph(0))}watch(E,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(E,$):this.z(E,$)}n(E,$){const g={path:this.I(E),excludes:$.excludes,includes:$.includes,recursive:$.recursive,filter:$.filter,correlationId:$.correlationId},v=(0,i.$Ub)(this.j,g);return this.r(),(0,P.$Sc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(E=>(0,S.$1)(E))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,u.$Jq)($)),$=>this.G($),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const E=this.b?.watcher?.recursive?.usePolling;if(E===!0)for(const $ of this.j)(0,u.$Fq)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const $ of this.j)(0,u.$Fq)($)&&E.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(E,$){const g={path:this.I(E),excludes:$.excludes,includes:$.includes,recursive:!1,filter:$.filter,correlationId:$.correlationId},v=(0,i.$Ub)(this.w,g);return this.C(),(0,P.$Sc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(E=>(0,S.$1)(E))}D(){return this.u||(this.u=this.B(this.F(E=>this.c.fire((0,u.$Jq)(E)),E=>this.G(E),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(E){E.type==="error"&&this.g.fire(E.message),this.H(E)}H(E){this.a[E.type](E.message)}I(E){return(0,k.$ic)(E.fsPath)}}e.$Pq=d}),define(re[226],oe([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;let a=class extends l.$Uc{static{w=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new P.$be),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new P.$be),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new P.$be),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new P.$be),this.onDidRunOperation=this.r.event,this.X=this.B(new P.$be),this.Y=this.B(new P.$be),this.onDidFilesChange=this.Y.event,this.Z=this.B(new P.$be),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$Ah)}registerProvider(r,s){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${r}`);const n=new l.$Tc;return this.h.set(r,s),this.c.fire({added:!0,scheme:r,provider:s}),n.add(s.onDidChangeFile(o=>{const c=new p.$el(o,!this.S(s));this.X.fire(c),c.hasCorrelation()||this.Y.fire(c)})),typeof s.onDidWatchError=="function"&&n.add(s.onDidWatchError(o=>this.Z.fire(new Error(o)))),n.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:r}))),(0,l.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:s}),this.h.delete(r),(0,l.$Pc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const s=[];this.f.fire({scheme:r,join(n){s.push(n)}}),!this.h.has(r)&&await D.Promises.settled(s)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,s){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&s)}listCapabilities(){return u.Iterable.map(this.h,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async j(r){if(!(0,$.$9g)(r))throw new p.$gl((0,v.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const s=this.h.get(r.scheme);if(!s){const n=new h.$bb;throw n.message=(0,v.localize)(1,null,r.toString()),n}return s}async m(r){const s=await this.j(r);if((0,p.$4k)(s)||(0,p.$1k)(s)||(0,p.$5k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const s=await this.j(r);if((0,p.$4k)(s)||(0,p.$1k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.s(r,s)}catch(n){throw(0,p.$bl)(n)===p.FileSystemProviderErrorCode.FileNotFound?new p.$gl((0,v.localize)(2,null,this.sb(r)),1):(0,p.$_k)(n)}}async s(r,s){const n=await this.j(r),o=this.S(n),c=s?.resolveTo,b=s?.resolveSingleChildDescendants,L=s?.resolveMetadata,I=await n.stat(r);let j;return this.t(n,r,I,void 0,!!L,(O,R)=>(j||(j=d.$xi.forUris(()=>!o),j.set(r,!0),c&&j.fill(!0,c)),j.get(O.resource)||j.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&b?R===1:!1))}async t(r,s,n,o,c,b){const{providerExtUri:L}=this.R(r),I={resource:s,name:L.basename(s),isFile:(n.type&p.FileType.File)!==0,isDirectory:(n.type&p.FileType.Directory)!==0,isSymbolicLink:(n.type&p.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&p.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&p.FilePermission.Locked),etag:(0,p.$rl)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&b(I,o)){try{const j=await r.readdir(s),O=await D.Promises.settled(j.map(async([R,W])=>{try{const F=L.joinPath(s,R),T=c?await r.stat(F):{type:W};return await this.t(r,F,T,j.length,c,b)}catch(F){return this.b.trace(F),null}}));I.children=(0,i.$Hb)(O)}catch(j){this.b.trace(j),I.children=[]}return I}return I}async resolveAll(r){return D.Promises.settled(r.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const s=await this.j(r),n=await s.stat(r);return this.t(s,r,n,void 0,!0,()=>!1)}async exists(r){const s=await this.j(r);try{return!!await s.stat(r)}catch{return!1}}async canCreateFile(r,s){try{await this.u(r,s)}catch(n){return n}return!0}async u(r,s){if(!s?.overwrite&&await this.exists(r))throw new p.$gl((0,v.localize)(3,null,this.sb(r)),3,s)}async createFile(r,s=S.$Ce.fromString(""),n){await this.u(r,n);const o=await this.writeFile(r,s);return this.r.fire(new p.$dl(r,0,o)),o}async writeFile(r,s,n){const o=this.qb(await this.n(r),r),{providerExtUri:c}=this.R(o);let b=n;if((0,p.$7k)(o)&&!b?.atomic){const L=o.enforceAtomicWriteFile?.(r);L&&(b={...n,atomic:L})}try{await this.w(o,r,b)||await this.U(o,c.dirname(r));let I;if((0,p.$1k)(o)&&!(s instanceof S.$Ce))if((0,g.$oe)(s)){const j=await(0,g.$ve)(s,3);j.ended?I=S.$Ce.concat(j.buffer):I=j}else I=(0,g.$se)(s,j=>S.$Ce.concat(j),3);else I=s;!(0,p.$4k)(o)||(0,p.$1k)(o)&&I instanceof S.$Ce||(0,p.$1k)(o)&&(0,p.$7k)(o)&&b?.atomic?await this.hb(o,r,b,I):await this.db(o,r,b,I instanceof S.$Ce?(0,S.$Ne)(I):I),this.r.fire(new p.$dl(r,4))}catch(L){throw new p.$gl((0,v.localize)(4,null,this.sb(r),(0,p.$_k)(L).toString()),(0,p.$cl)(L),b)}return this.resolve(r,{resolveMetadata:!0})}async w(r,s,n){const o=!!n?.unlock;if(o&&!(r.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(s)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(s)));if(!(r.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(s)));if(o)throw new Error((0,v.localize)(8,null,this.sb(s)))}let b;try{b=await r.stat(s)}catch{return}if(b.type&p.FileType.Directory)throw new p.$gl((0,v.localize)(9,null,this.sb(s)),0,n);if(this.rb(s,b),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==p.$ql&&typeof b.mtime=="number"&&typeof b.size=="number"&&n.mtime<b.mtime&&n.etag!==(0,p.$rl)({mtime:n.mtime,size:b.size}))throw new p.$gl((0,v.localize)(10,null),3,n);return b}async readFile(r,s,n){const o=await this.m(r);return s?.atomic?this.z(o,r,s,n):this.C(o,r,s,n)}async z(r,s,n,o){return new Promise((c,b)=>{this.cb.queueFor(s,async()=>{try{const L=await this.C(r,s,n,o);c(L)}catch(L){b(L)}},this.R(r).providerExtUri)})}async C(r,s,n,o){const c=await this.D(r,s,{...n,preferUnbuffered:!0},o);return{...c,value:await(0,S.$Oe)(c.value)}}async readFileStream(r,s,n){const o=await this.m(r);return this.D(o,r,s,n)}async D(r,s,n,o){const c=new A.$me(o);let b=n;(0,p.$6k)(r)&&r.enforceAtomicReadFile?.(s)&&(b={...n,atomic:!0});const L=this.J(s,b).then(j=>j,j=>{throw c.dispose(!0),j});let I;try{return typeof b?.etag=="string"&&b.etag!==p.$ql&&await L,b?.atomic&&(0,p.$6k)(r)||!((0,p.$4k)(r)||(0,p.$5k)(r))||(0,p.$1k)(r)&&b?.preferUnbuffered?I=this.I(r,s,b):(0,p.$5k)(r)?I=this.G(r,s,c.token,b):I=this.H(r,s,c.token,b),I.on("end",()=>c.dispose()),I.on("error",()=>c.dispose()),{...await L,value:I}}catch(j){throw I&&await(0,g.$te)(I),this.F(j,s,b)}}F(r,s,n){const o=(0,v.localize)(11,null,this.sb(s),(0,p.$_k)(r).toString());return r instanceof p.$il?new p.$il(o,r.stat,n):r instanceof p.$hl?new p.$hl(o,r.fileOperationResult,r.size,r.options):new p.$gl(o,(0,p.$cl)(r),n)}G(r,s,n,o=Object.create(null)){const c=r.readFileStream(s,o,n);return(0,g.$ze)(c,{data:b=>b instanceof S.$Ce?b:S.$Ce.wrap(b),error:b=>this.F(b,s,o)},b=>S.$Ce.concat(b))}H(r,s,n,o=Object.create(null)){const c=(0,S.$Se)();return(0,m.$Cq)(r,s,c,b=>b,{...o,bufferSize:this.a,errorTransformer:b=>this.F(b,s,o)},n),c}I(r,s,n){const o=(0,g.$qe)(c=>S.$Ce.concat(c));return(async()=>{try{let c;n?.atomic&&(0,p.$6k)(r)?c=await r.readFile(s,{atomic:!0}):c=await r.readFile(s),typeof n?.position=="number"&&(c=c.slice(n.position)),typeof n?.length=="number"&&(c=c.slice(0,n.length)),this.L(s,c.byteLength,n),o.end(S.$Ce.wrap(c))}catch(c){o.error(c),o.end()}})(),o}async J(r,s){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new p.$gl((0,v.localize)(12,null,this.sb(r)),0,s);if(typeof s?.etag=="string"&&s.etag!==p.$ql&&s.etag===n.etag)throw new p.$il((0,v.localize)(13,null),n,s);return this.L(r,n.size,s),n}L(r,s,n){if(typeof n?.limits?.size=="number"&&s>n.limits.size)throw new p.$hl((0,v.localize)(14,null,this.sb(r)),7,s,n)}async canMove(r,s,n){return this.M(r,s,"move",n)}async canCopy(r,s,n){return this.M(r,s,"copy",n)}async M(r,s,n,o){if(r.toString()!==s.toString())try{const c=n==="move"?this.qb(await this.n(r),r):await this.m(r),b=this.qb(await this.n(s),s);await this.Q(c,r,b,s,n,o)}catch(c){return c}return!0}async move(r,s,n){const o=this.qb(await this.n(r),r),c=this.qb(await this.n(s),s),b=await this.N(o,r,c,s,"move",!!n),L=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new p.$dl(r,b==="move"?2:3,L)),L}async copy(r,s,n){const o=await this.m(r),c=this.qb(await this.n(s),s),b=await this.N(o,r,c,s,"copy",!!n),L=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new p.$dl(r,b==="copy"?3:2,L)),L}async N(r,s,n,o,c,b){if(s.toString()===o.toString())return c;const{exists:L,isSameResourceWithDifferentPathCase:I}=await this.Q(r,s,n,o,c,b);if(L&&!I&&b&&await this.del(o,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(o)),c==="copy"){if(r===n&&(0,p.$2k)(r))await r.copy(s,o,{overwrite:b});else{const j=await this.resolve(s);j.isDirectory?await this.P(r,j,n,o):await this.O(r,s,n,o)}return c}else return r===n?(await r.rename(s,o,{overwrite:b}),c):(await this.N(r,s,n,o,"copy",b),await this.del(s,{recursive:!0}),"copy")}async O(r,s,n,o){if((0,p.$4k)(r)&&(0,p.$4k)(n))return this.jb(r,s,n,o);if((0,p.$4k)(r)&&(0,p.$1k)(n))return this.pb(r,s,n,o);if((0,p.$1k)(r)&&(0,p.$4k)(n))return this.nb(r,s,n,o);if((0,p.$1k)(r)&&(0,p.$1k)(n))return this.lb(r,s,n,o)}async P(r,s,n,o){await n.mkdir(o),Array.isArray(s.children)&&await D.Promises.settled(s.children.map(async c=>{const b=this.R(n).providerExtUri.joinPath(o,c.name);return c.isDirectory?this.P(r,await this.resolve(c.resource),n,b):this.O(r,c.resource,n,b)}))}async Q(r,s,n,o,c,b){let L=!1;if(r===n){const{providerExtUri:j,isPathCaseSensitive:O}=this.R(r);if(O||(L=j.isEqual(s,o)),L&&c==="copy")throw new Error((0,v.localize)(15,null,this.sb(s),this.sb(o)));if(!L&&j.isEqualOrParent(o,s))throw new Error((0,v.localize)(16,null,this.sb(s),this.sb(o)))}const I=await this.exists(o);if(I&&!L){if(!b)throw new p.$gl((0,v.localize)(17,null,this.sb(s),this.sb(o)),4);if(r===n){const{providerExtUri:j}=this.R(r);if(j.isEqualOrParent(s,o))throw new Error((0,v.localize)(18,null,this.sb(s),this.sb(o)))}}return{exists:I,isSameResourceWithDifferentPathCase:L}}R(r){const s=this.S(r);return{providerExtUri:s?$.$Ug:$.$Wg,isPathCaseSensitive:s}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.qb(await this.j(r),r);await this.U(s,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$dl(r,0,n)),n}async U(r,s){const n=[],{providerExtUri:o}=this.R(r);for(;!o.isEqual(s,o.dirname(s));)try{if(!((await r.stat(s)).type&p.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(s)));break}catch(c){if((0,p.$bl)(c)!==p.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(o.basename(s)),s=o.dirname(s)}for(let c=n.length-1;c>=0;c--){s=o.joinPath(s,n[c]);try{await r.mkdir(s)}catch(b){if((0,p.$bl)(b)!==p.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(r,s){try{await this.W(r,s)}catch(n){return n}return!0}async W(r,s){const n=this.qb(await this.j(r),r),o=!!s?.useTrash;if(o&&!(n.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(r)));const c=s?.atomic;if(c&&!(n.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(r)));if(o&&c)throw new Error((0,v.localize)(22,null,this.sb(r)));let b;try{b=await n.stat(r)}catch{}if(b)this.rb(r,b);else throw new p.$gl((0,v.localize)(23,null,this.sb(r)),1);if(!!!s?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(r)))}return n}async del(r,s){const n=await this.W(r,s);let o=s;if((0,p.$8k)(n)&&!o?.atomic){const I=n.enforceAtomicDelete?.(r);I&&(o={...s,atomic:I})}const c=!!o?.useTrash,b=!!o?.recursive,L=o?.atomic??!1;await n.delete(r,{recursive:b,useTrash:c,atomic:L}),this.r.fire(new p.$dl(r,1))}async cloneFile(r,s){const n=await this.j(r),o=this.qb(await this.n(s),s);if(!(n===o&&this.R(n).providerExtUri.isEqual(r,s)))return n===o&&(0,p.$3k)(n)?n.cloneFile(r,s):(await this.U(o,this.R(o).providerExtUri.dirname(s)),n===o&&(0,p.$2k)(n)?this.cb.queueFor(r,()=>n.copy(r,s,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,o,s),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,s){return this.watch(r,{...s,correlationId:w.ab++})}watch(r,s={recursive:!1,excludes:[]}){const n=new l.$Tc;let o=!1,c=()=>{o=!0};n.add((0,l.$Sc)(()=>c())),(async()=>{try{const L=await this.bb(r,s);o?(0,l.$Pc)(L):c=()=>(0,l.$Pc)(L)}catch(L){this.b.error(L)}})();const b=s.correlationId;if(typeof b=="number"){const L=n.add(new P.$be);return n.add(this.X.event(j=>{j.correlates(b)&&L.fire(j)})),{onDidChange:L.event,dispose:()=>n.dispose()}}return n}async bb(r,s){const n=await this.j(r),o=(0,k.$fj)([this.R(n).providerExtUri.getComparisonKey(r),s]);let c=this.$.get(o);return c||(c={count:0,disposable:n.watch(r,s)},this.$.set(o,c)),c.count+=1,(0,l.$Sc)(()=>{c&&(c.count--,c.count===0&&((0,l.$Pc)(c.disposable),this.$.delete(o)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,l.$Pc)(r.disposable);this.$.clear()}async db(r,s,n,o){return this.cb.queueFor(s,async()=>{const c=await r.open(s,{create:!0,unlock:n?.unlock??!1});try{(0,g.$oe)(o)||(0,g.$pe)(o)?await this.eb(r,c,o):await this.fb(r,c,o)}catch(b){throw(0,p.$_k)(b)}finally{await r.close(c)}},this.R(r).providerExtUri)}async eb(r,s,n){let o=0,c;if((0,g.$pe)(n)){if(n.buffer.length>0){const b=S.$Ce.concat(n.buffer);await this.gb(r,s,b,b.byteLength,o,0),o+=b.byteLength}if(n.ended)return;c=n.stream}else c=n;return new Promise((b,L)=>{(0,g.$ue)(c,{onData:async I=>{c.pause();try{await this.gb(r,s,I,I.byteLength,o,0)}catch(j){return L(j)}o+=I.byteLength,setTimeout(()=>c.resume())},onError:I=>L(I),onEnd:()=>b()})})}async fb(r,s,n){let o=0,c;for(;(c=n.read())!==null;)await this.gb(r,s,c,c.byteLength,o,0),o+=c.byteLength}async gb(r,s,n,o,c,b){let L=0;for(;L<o;){const I=await r.write(s,c+L,n.buffer,b+L,o-L);L+=I}}async hb(r,s,n,o){return this.cb.queueFor(s,()=>this.ib(r,s,n,o),this.R(r).providerExtUri)}async ib(r,s,n,o){let c;o instanceof S.$Ce?c=o:(0,g.$oe)(o)?c=await(0,S.$Oe)(o):(0,g.$pe)(o)?c=await(0,S.$Pe)(o):c=(0,S.$Me)(o),await r.writeFile(s,c.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,s,n,o){return this.cb.queueFor(o,()=>this.kb(r,s,n,o),this.R(n).providerExtUri)}async kb(r,s,n,o){let c,b;try{c=await r.open(s,{create:!1}),b=await n.open(o,{create:!0,unlock:!1});const L=S.$Ce.alloc(this.a);let I=0,j=0,O=0;do O=await r.read(c,I,L.buffer,j,L.byteLength-j),await this.gb(n,b,L,O,I,j),I+=O,j+=O,j===L.byteLength&&(j=0);while(O>0)}catch(L){throw(0,p.$_k)(L)}finally{await D.Promises.settled([typeof c=="number"?r.close(c):Promise.resolve(),typeof b=="number"?n.close(b):Promise.resolve()])}}async lb(r,s,n,o){return this.cb.queueFor(o,()=>this.mb(r,s,n,o),this.R(n).providerExtUri)}async mb(r,s,n,o){return n.writeFile(o,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,s,n,o){return this.cb.queueFor(o,()=>this.ob(r,s,n,o),this.R(n).providerExtUri)}async ob(r,s,n,o){const c=await n.open(o,{create:!0,unlock:!1});try{const b=await r.readFile(s);await this.gb(n,c,S.$Ce.wrap(b),b.byteLength,0,0)}catch(b){throw(0,p.$_k)(b)}finally{await n.close(c)}}async pb(r,s,n,o){const c=await(0,S.$Oe)(this.H(r,s,A.CancellationToken.None));await this.hb(n,o,void 0,c)}qb(r,s){if(r.capabilities&2048)throw new p.$gl((0,v.localize)(25,null,this.sb(s)),6);return r}rb(r,s){if((s.permissions??0)&p.FilePermission.Readonly)throw new p.$gl((0,v.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===y.Schemas.file?r.fsPath:r.toString(!0)}};e.$Dq=a,e.$Dq=a=w=Se([ie(0,f.$Xj)],a)}),define(re[94],oe([0,1,43,315,8,31,17,3,32,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0,(()=>{try{(0,D.gracefulify)(i)}catch(r){console.error(`Error enabling graceful-fs: ${(0,h.$cj)(r)}`)}})();class t extends f.$Pq{static{this.J=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=k.Event.None,this.O=new A.$Bc(o=>E.$Vg.getComparisonKey(o)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,y.$k&&(this.L|=1024)),this.L}async stat(s){try{const{stat:n,symbolicLink:o}=await g.SymlinkSupport.stat(this.I(s));return{type:this.N(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:p.FilePermission.Locked}}catch(n){throw this.gb(n)}}async M(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await g.Promises.readdir(this.I(s),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async c=>{try{let b;c.isSymbolicLink()?b=(await this.stat((0,E.$5g)(s,c.name))).type:b=this.N(c),o.push([c.name,b])}catch(b){this.a.trace(b)}})),o}catch(n){throw this.gb(n)}}N(s,n){let o;return n?.dangling?o=p.FileType.Unknown:s.isFile()?o=p.FileType.File:s.isDirectory()?o=p.FileType.Directory:o=p.FileType.Unknown,n&&(o|=p.FileType.SymbolicLink),o}async P(s){const n=this.I(s);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.O.get(s);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const c=new S.$qh;return this.O.set(s,c),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,l.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.O.get(s)===c&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.O.delete(s)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(s,n){let o;try{n?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),o=await this.P(s));const c=this.I(s);return await g.Promises.readFile(c)}catch(c){throw this.gb(c)}finally{o?.dispose()}}Q(s){t.J&&this.a.trace(s)}readFileStream(s,n,o){const c=(0,$.$qe)(b=>P.$Ce.concat(b.map(L=>P.$Ce.wrap(L))).buffer);return(0,m.$Cq)(this,s,c,b=>b.buffer,{...n,bufferSize:256*1024},o),c}async writeFile(s,n,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.R(s)?this.S(s,(0,E.$5g)((0,E.$4g)(s),`${(0,E.$2g)(s)}${o.atomic.postfix}`),n,o):this.U(s,n,o)}async R(s){try{const n=this.I(s),{symbolicLink:o}=await g.SymlinkSupport.stat(n);if(o)return!1}catch{}return!0}async S(s,n,o,c){const b=new l.$Tc;try{b.add(await this.P(s)),b.add(await this.P(n)),await this.U(n,o,c,!0);try{await this.rename(n,s,{overwrite:!0})}catch(L){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw L}}finally{b.dispose()}}async U(s,n,o,c){let b;try{const L=this.I(s);if(!o.create||!o.overwrite){if(await g.Promises.exists(L)){if(!o.overwrite)throw(0,p.$$k)((0,v.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,p.$$k)((0,v.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(s,{create:!0,unlock:o.unlock},c),await this.write(b,0,n,0,n.byteLength)}catch(L){throw await this.hb(s,L)}finally{typeof b=="number"&&await this.close(b)}}static{this.Z=!0}static configureFlushOnWrite(s){t.Z=s}async open(s,n,o){const c=this.I(s);let b;(0,p.$Yk)(n)&&!o&&(b=await this.P(s));let L;try{if((0,p.$Yk)(n)&&n.unlock)try{const{stat:j}=await g.SymlinkSupport.stat(c);j.mode&128||await g.Promises.chmod(c,j.mode|128)}catch(j){j.code!=="ENOENT"&&this.a.trace(j)}let I;if((0,p.$Yk)(n)){if(y.$i)try{await g.Promises.truncate(c,0),I="r+"}catch(j){j.code!=="ENOENT"&&this.a.trace(j)}I||(I="w")}else I="r";L=await g.Promises.open(c,I)}catch(I){throw b?.dispose(),(0,p.$Yk)(n)?await this.hb(s,I):this.gb(I)}if(this.W.set(L,0),(0,p.$Yk)(n)&&this.Y.set(L,s),b){const I=this.X.get(L);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${L} (${c})`),this.X.set(L,b),I&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${L} (${c})`),I.dispose())}return L}async close(s){const n=this.X.get(s);try{if(this.W.delete(s),this.Y.delete(s)&&t.Z)try{await g.Promises.fdatasync(s)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await g.Promises.close(s)}catch(o){throw this.gb(o)}finally{n&&(this.X.get(s)===n&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.X.delete(s)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,o,c,b){const L=this.$(s,n);let I=null;try{I=(await g.Promises.read(s,o,c,b,L)).bytesRead}catch(j){throw this.gb(j)}finally{this.ab(s,L,I)}return I}$(s,n){return n===this.W.get(s)?null:n}ab(s,n,o){const c=this.W.get(s);typeof c=="number"&&(typeof n=="number"||(typeof o=="number"?this.W.set(s,c+o):this.W.delete(s)))}async write(s,n,o,c,b){return(0,S.$Lh)(()=>this.bb(s,n,o,c,b),100,3)}async bb(s,n,o,c,b){const L=this.$(s,n);let I=null;try{I=(await g.Promises.write(s,o,c,b,L)).bytesWritten}catch(j){throw await this.hb(this.Y.get(s),j)}finally{this.ab(s,L,I)}return I}async mkdir(s){try{await g.Promises.mkdir(this.I(s))}catch(n){throw this.gb(n)}}async delete(s,n){try{const o=this.I(s);if(n.recursive){let c;n?.atomic!==!1&&n.atomic.postfix&&(c=(0,d.$kc)((0,d.$nc)(o),`${(0,d.$oc)(o)}${n.atomic.postfix}`)),await g.Promises.rm(o,g.RimRafMode.MOVE,c)}else try{await g.Promises.unlink(o)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let b=!1;try{const{stat:L,symbolicLink:I}=await g.SymlinkSupport.stat(o);b=L.isDirectory()&&!I}catch{}if(b)await g.Promises.rmdir(o);else throw c}else throw c}}catch(o){throw this.gb(o)}}async rename(s,n,o){const c=this.I(s),b=this.I(n);if(c!==b)try{await this.cb(s,n,"move",o.overwrite),await g.Promises.rename(c,b)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,v.localize)(2,null,(0,d.$oc)(c),(0,d.$oc)((0,d.$nc)(b)),L.toString()))),this.gb(L)}}async copy(s,n,o){const c=this.I(s),b=this.I(n);if(c!==b)try{await this.cb(s,n,"copy",o.overwrite),await g.Promises.copy(c,b,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,v.localize)(3,null,(0,d.$oc)(c),(0,d.$oc)((0,d.$nc)(b)),L.toString()))),this.gb(L)}}async cb(s,n,o,c){const b=this.I(s),L=this.I(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,u.$qg)(b,L,!0)),I){if(o==="copy")throw(0,p.$$k)((0,v.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const O=await this.M(s);if(!O)throw(0,p.$$k)((0,v.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const R=await this.M(n);if(R){if(!c)throw(0,p.$$k)((0,v.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);O.type&p.FileType.File&&R.type&p.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.db(s,n,!1)}async db(s,n,o){const c=this.I(s),b=this.I(n),L=!!(this.capabilities&1024);if((0,u.$qg)(c,b,!L))return;const I=new l.$Tc;try{I.add(await this.P(s)),I.add(await this.P(n)),o&&await g.Promises.mkdir((0,d.$nc)(b),{recursive:!0}),await g.Promises.copyFile(c,b)}catch(j){if(j.code==="ENOENT"&&!o)return this.db(s,n,!0);throw this.gb(j)}finally{I.dispose()}}t(s,n,o){return new w.$Wq(c=>s(c),c=>n(c),o)}F(s,n,o){return new a.$6q(c=>s(c),c=>n(c),o)}gb(s){if(s instanceof p.$0k)return s;let n=s,o;switch(s.code){case"ENOENT":o=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=p.FileSystemProviderErrorCode.Unknown;break;default:o=p.FileSystemProviderErrorCode.Unknown}return(0,p.$$k)(n,o)}async hb(s,n){let o=this.gb(n);if(s&&o.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await g.SymlinkSupport.stat(this.I(s));c.mode&128||(o=(0,p.$$k)(n,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}e.$7q=t}),define(re[227],oe([0,1,3,94,2,17,63,23]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=e.$Ds=void 0;class u extends S.$Uc{constructor(y,E){super(),this.a=y,this.b=E,this.F=new Map,this.G=new Map}call(y,E,$){const g=this.c(y);switch(E){case"stat":return this.g(g,$[0]);case"readdir":return this.h(g,$[0]);case"open":return this.r(g,$[0],$[1]);case"close":return this.s($[0]);case"read":return this.t($[0],$[1],$[2]);case"readFile":return this.j(g,$[0],$[1]);case"write":return this.u($[0],$[1],$[2],$[3],$[4]);case"writeFile":return this.n(g,$[0],$[1],$[2]);case"rename":return this.z(g,$[0],$[1],$[2]);case"copy":return this.C(g,$[0],$[1],$[2]);case"cloneFile":return this.D(g,$[0],$[1]);case"mkdir":return this.w(g,$[0]);case"delete":return this.y(g,$[0],$[1]);case"watch":return this.I(g,$[0],$[1],$[2],$[3]);case"unwatch":return this.J($[0],$[1])}throw new Error(`IPC Command ${E} not found`)}listen(y,E,$){const g=this.c(y);switch(E){case"fileChange":return this.H(g,$[0]);case"readFileStream":return this.m(g,$[0],$[1])}throw new Error(`Unknown event ${E}`)}g(y,E){const $=this.f(y,E,!0);return this.a.stat($)}h(y,E){const $=this.f(y,E);return this.a.readdir($)}async j(y,E,$){const g=this.f(y,E,!0),v=await this.a.readFile(g,$);return A.$Ce.wrap(v)}m(y,E,$){const g=this.f(y,E,!0),v=new k.$me,p=new i.$be({onDidRemoveLastListener:()=>{v.cancel()}}),m=this.a.readFileStream(g,$,v.token);return(0,P.$ue)(m,{onData:f=>p.fire(A.$Ce.wrap(f)),onError:f=>p.fire(f),onEnd:()=>{p.fire("end"),p.dispose(),v.dispose()}}),p.event}n(y,E,$,g){const v=this.f(y,E);return this.a.writeFile(v,$.buffer,g)}r(y,E,$){const g=this.f(y,E,!0);return this.a.open(g,$)}s(y){return this.a.close(y)}async t(y,E,$){const g=A.$Ce.alloc($),p=await this.a.read(y,E,g.buffer,0,$);return[g,p]}u(y,E,$,g,v){return this.a.write(y,E,$.buffer,g,v)}w(y,E){const $=this.f(y,E);return this.a.mkdir($)}y(y,E,$){const g=this.f(y,E);return this.a.delete(g,$)}z(y,E,$,g){const v=this.f(y,E),p=this.f(y,$);return this.a.rename(v,p,g)}C(y,E,$,g){const v=this.f(y,E),p=this.f(y,$);return this.a.copy(v,p,g)}D(y,E,$){const g=this.f(y,E),v=this.f(y,$);return this.a.cloneFile(g,v)}H(y,E){const $=new i.$be({onWillAddFirstListener:()=>{this.F.set(E,this.L(y,$))},onDidRemoveLastListener:()=>{(0,S.$Pc)(this.F.get(E)),this.F.delete(E)}});return $.event}async I(y,E,$,g,v){const p=this.F.get(E);if(p){const m=this.f(y,g),f=p.watch($,m,v);this.G.set(E+$,f)}}async J(y,E){const $=y+E,g=this.G.get($);g&&((0,S.$Pc)(g),this.G.delete($))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$Ds=u;class l extends S.$Uc{constructor(y,E,$,g){super(),this.c=y,this.f=$,this.g=g,this.a=new Map,this.b=this.B(new D.$7q(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(E)}h(y){const E=this.B(new i.$be);this.B(E.event($=>{y.fire($.map(g=>({resource:this.c.transformOutgoingURI(g.resource),type:g.type,cId:g.cId})))})),this.B(this.b.onDidChangeFile($=>E.fire($))),this.B(this.b.onDidWatchError($=>y.fire($)))}j(y){}m(y){}watch(y,E,$){const g=this.m(this.g);return Array.isArray(g)&&($.excludes=[...$.excludes,...g]),this.a.set(y,this.b.watch(E,$)),(0,S.$Sc)(()=>{(0,S.$Pc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$Es=l}),define(re[228],oe([0,1,14,180,4,7,16,9,227,157,47]),function(J,e,i,D,S,A,P,k,u,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=void 0;class y extends u.$Ds{constructor(g,v,p){super(g,v),this.M=p}c(g){return l.$un}f(g,v){return A.URI.revive(v)}async y(g,v,p){if(!p.useTrash)return super.y(g,v,p);const m=this.f(g,v),f=(0,k.$ic)(m.fsPath);try{await i.shell.trashItem(f)}catch(h){throw(0,P.$$k)(S.$i?(0,D.localize)(0,null,(0,k.$oc)(f),(0,d.$cj)(h)):(0,D.localize)(1,null,(0,k.$oc)(f),(0,d.$cj)(h)),P.FileSystemProviderErrorCode.Unknown)}}L(g,v){return new E(g,v,this.b,this.M)}}e.$Xbc=y;class E extends u.$Es{watch(g,v,p){if(p.recursive)throw(0,P.$$k)("Recursive file watching is not supported from main process for performance reasons.",P.FileSystemProviderErrorCode.Unavailable);return super.watch(g,v,p)}}}),define(re[229],oe([0,1,5]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=void 0;class D extends i.$4j{constructor(A=i.$1j){super(),this.m=[],this.n=void 0,this.setLevel(A),this.B(this.onDidChangeLogLevel(P=>{this.n?.setLevel(P)}))}set logger(A){this.n=A;for(const{level:P,message:k}of this.m)(0,i.log)(A,P,k);this.m=[]}g(A,P){this.n?(0,i.log)(this.n,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$L$b=D}),define(re[230],oe([0,1,7,3,5,2]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=void 0;class P extends S.$9j{constructor(y,E,$,g,v){super(E,$,g),this.r=y,this.t=v,this.B(v.listen("onDidChangeLogLevel",y)(p=>{(0,S.$Zj)(p)?super.setLogLevel(p):super.setLogLevel(i.URI.revive(p[0]),p[1])})),this.B(v.listen("onDidChangeVisibility",y)(([p,m])=>super.setVisibility(i.URI.revive(p),m))),this.B(v.listen("onDidChangeLoggers",y)(({added:p,removed:m})=>{for(const f of p)super.registerLogger({...f,resource:i.URI.revive(f.resource)});for(const f of m)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new S.$7j({log:(y,E)=>{this.t.call("consoleLog",[y,E])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,E){super.setLogLevel(y,E),this.t.call("setLogLevel",[y,E])}setVisibility(y,E){super.setVisibility(y,E),this.t.call("setVisibility",[this.n(y),E])}s(y,E,$){return new k(this.t,y,E,$,this.r)}static setLogLevel(y,E,$){return y.call("setLogLevel",[E,$])}}e.$6r=P;class k extends S.$4j{constructor(y,E,$,g,v){super(g?.logLevel==="always"),this.r=y,this.s=E,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[E,g,v]).then(()=>{this.u(this.n),this.m=!0})}g(y,E){const $=[[y,E]];this.m?this.u($):this.n.push(...$)}u(y){this.r.call("log",[this.s,y])}}class u{constructor(y,E){this.a=y,this.b=E}listen(y,E){const $=this.b(y);switch(E){case"onDidChangeLoggers":return D.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(v=>this.c(v,$)),removed:[...g.removed].map(v=>this.c(v,$))}));case"onDidChangeVisibility":return D.Event.map(this.a.onDidChangeVisibility,g=>[$.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return D.Event.map(this.a.onDidChangeLogLevel,g=>(0,S.$Zj)(g)?g:[$.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${E}`)}async call(y,E,$){const g=this.b(y);switch(E){case"setLogLevel":return(0,S.$Zj)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(i.URI.revive(g.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,g)))}throw new Error(`Call not found: ${E}`)}c(y,E){return{...y,resource:E.transformOutgoingURI(y.resource)}}}e.$7r=u;class l extends A.$Uc{constructor(y,E){super(),E.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel($=>E.call("setLogLevel",[$]))),E.call("getRegisteredLoggers").then($=>{for(const g of $)y.registerLogger({...g,resource:i.URI.revive(g.resource)})}),this.B(E.listen("onDidChangeVisibility")(([$,g])=>y.setVisibility(i.URI.revive($),g))),this.B(E.listen("onDidChangeLoggers")(({added:$,removed:g})=>{for(const v of $)y.registerLogger({...v,resource:i.URI.revive(v.resource)});for(const v of g)y.deregisterLogger(v.resource)}))}}e.$8r=l}),define(re[231],oe([0,1,2,5]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=void 0;class S extends i.$Uc{constructor(P,k=[]){super(),this.a=new D.$8j([P,...k]),this.B(P.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...k){this.a.trace(P,...k)}debug(P,...k){this.a.debug(P,...k)}info(P,...k){this.a.info(P,...k)}warn(P,...k){this.a.warn(P,...k)}error(P,...k){this.a.error(P,...k)}flush(){this.a.flush()}}e.$DQ=S}),define(re[232],oe([0,1,31,7,5]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class A{constructor(k){this.b=k,this.a=new i.$Bc}listen(k,u,l){switch(u){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${u}`)}async call(k,u,l){switch(u){case"createLogger":this.c(D.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(D.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,S.$Zj)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(D.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(D.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:D.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(D.URI.revive(l[0]))}throw new Error(`Call not found: ${u}`)}c(k,u,l){this.a.set(k,this.b.createLogger(k,u,l))}d(k,u){let l=console.log;switch(k){case S.LogLevel.Error:l=console.error;break;case S.LogLevel.Warning:l=console.warn;break;case S.LogLevel.Info:l=console.info;break}l.call(console,...u)}e(k,u){const l=this.a.get(k);if(!l)throw new Error("Create the logger before logging");for(const[d,y]of u)(0,S.log)(l,d,y)}}e.$Scc=A}),define(re[233],oe([0,1,16,5]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=void 0;var S;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(S||(S={}));async function A(l,d,y,E,$){try{const g=await new Promise((p,m)=>{J(["@vscode/spdlog"],p,m)});g.setFlushOn(S.Trace);const v=await g.createAsyncRotatingLogger(l,d,y,E);return $?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(g){console.error(g)}return null}function P(l,d,y){switch(d){case D.LogLevel.Trace:l.trace(y);break;case D.LogLevel.Debug:l.debug(y);break;case D.LogLevel.Info:l.info(y);break;case D.LogLevel.Warning:l.warn(y);break;case D.LogLevel.Error:l.error(y);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function k(l,d){switch(d){case D.LogLevel.Trace:l.setLevel(S.Trace);break;case D.LogLevel.Debug:l.setLevel(S.Debug);break;case D.LogLevel.Info:l.setLevel(S.Info);break;case D.LogLevel.Warning:l.setLevel(S.Warning);break;case D.LogLevel.Error:l.setLevel(S.Error);break;case D.LogLevel.Off:l.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${d}`)}}class u extends D.$4j{constructor(d,y,E,$,g){super(),this.m=[],this.setLevel(g),this.n=this.s(d,y,E,$),this.B(this.onDidChangeLogLevel(v=>{this.r&&k(this.r,v)}))}async s(d,y,E,$){const g=E?6:1,v=30/g*i.$tl.MB,p=await A(d,y,v,g,$);if(p){this.r=p,k(this.r,this.getLevel());for(const{level:m,message:f}of this.m)P(this.r,m,f);this.m=[]}}g(d,y){this.r?P(this.r,d,y):this.getLevel()<=d&&this.m.push({level:d,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$sQ=u}),define(re[234],oe([0,1,33,5,233]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=void 0;class A extends D.$9j{s(k,u,l){return new S.$sQ((0,i.$Ng)(),k.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,u)}}e.$tQ=A}),define(re[67],oe([0,1,31,3,6,5,234]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.$sbc=void 0,e.$sbc=(0,S.$si)(A.$Yj);class k extends P.$tQ{constructor(){super(...arguments),this.u=new i.$Bc}createLogger(l,d,y){y!==void 0&&this.u.set(this.n(l),y);try{return super.createLogger(l,d)}catch(E){throw this.u.delete(this.n(l)),E}}registerLogger(l,d){d!==void 0&&this.u.set(l.resource,d),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const d=[];for(const y of super.getRegisteredLoggers())l===this.u.get(y.resource)&&d.push(y);return d}getOnDidChangeLogLevelEvent(l){return D.Event.filter(this.onDidChangeLogLevel,d=>(0,A.$Zj)(d)||this.w(d[0],l))}getOnDidChangeVisibilityEvent(l){return D.Event.filter(this.onDidChangeVisibility,([d])=>this.w(d,l))}getOnDidChangeLoggersEvent(l){return D.Event.filter(D.Event.map(this.onDidChangeLoggers,d=>({added:[...d.added].filter(E=>this.w(E.resource,l)),removed:[...d.removed].filter(E=>this.w(E.resource,l))})),d=>d.added.length>0||d.removed.length>0)}deregisterLoggers(l){for(const[d,y]of this.u)y===l&&this.deregisterLogger(d)}w(l,d){const y=this.u.get(l);return y===void 0||y===d}dispose(){super.dispose(),this.u.clear()}}e.$tbc=k}),define(re[235],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=i,e.$_bc=D,e.$acc=S,e.$bcc=A;function i(P){return P.submenu!==void 0}function D(P){return P.id==="vscode.menubar.separator"}function S(P){return P.uri!==void 0}function A(P){return!i(P)&&!D(P)&&!S(P)}}),define(re[39],oe([0,1,3,71,2,6]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=void 0,e.$_n=(0,A.$ri)("policy");class P extends S.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new i.$be),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const d=Object.keys(this.f).length;return this.f={...l,...this.f},d!==Object.keys(this.f).length&&await this.j(l),D.Iterable.reduce(this.g.entries(),(y,[E,$])=>({...y,[E]:$}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(l,[d,y])=>({...l,[d]:{definition:y,value:this.g.get(d)}}),{})}}e.$ao=P;class k{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$bo=k}),define(re[236],oe([0,1,8,3,71,12,16,5,39]),function(J,e,i,D,S,A,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;function l(y,E){const $=[];for(const g of new Set(S.Iterable.concat(y.keys(),E.keys())))y.get(g)!==E.get(g)&&$.push(g);return $}let d=class extends u.$ao{constructor(E,$,g){super(),this.m=E,this.n=$,this.s=g,this.c=this.B(new i.$ph(500));const v=D.Event.filter($.onDidFilesChange,p=>p.affects(E));this.B($.watch(E)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const E=new Map;try{const $=await this.n.readFile(this.m),g=JSON.parse($.value.toString());if(!(0,A.$7f)(g))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(g))this.f[v]&&E.set(v,g[v])}catch($){$.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",$)}return E}async w(){const E=await this.u(),$=l(this.g,E);this.g=E,$.length>0&&this.h.fire($)}};e.$_cc=d,e.$_cc=d=Se([ie(1,P.$Xk),ie(2,k.$Xj)],d)}),define(re[237],oe([0,1,3,2,39]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=void 0;class A{constructor(u){this.b=u,this.a=new D.$Tc}listen(u,l){switch(l){case"onDidChange":return i.Event.map(this.b.onDidChange,d=>d.reduce((y,E)=>({...y,[E]:this.b.getPolicyValue(E)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(u,l,d){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(d)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$Jcc=A;class P extends S.$ao{constructor(u,l){super(),this.a=l;for(const d in u){const{definition:y,value:E}=u[d];this.f[d]=y,E!==void 0&&this.g.set(d,E)}this.a.listen("onDidChange")(d=>{for(const y in d){const E=d[y];E===null?this.g.delete(y):this.g.set(y,E)}this.h.fire(Object.keys(d))})}async j(u){const l=await this.a.call("updatePolicyDefinitions",u);for(const d in l)this.g.set(d,l[d])}}e.$Kcc=P}),define(re[238],oe([0,1,39,8,2,5]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;let P=class extends i.$ao{constructor(u,l){super(),this.m=u,this.n=l,this.a=new D.$lh,this.b=this.B(new S.$Vc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:l}=await new Promise((d,y)=>{J(["@vscode/policy-watcher"],d,y)});await this.a.queue(()=>new Promise((d,y)=>{try{this.b.value=l(this.n,u,E=>{this.t(E),d()})}catch(E){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",E),y(E)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const l in u){const d=u[l];d===void 0?this.g.delete(l):this.g.set(l,d)}this.h.fire(Object.keys(u))}};e.$$cc=P,e.$$cc=P=Se([ie(0,A.$Xj)],P)}),define(re[80],oe([0,1,36]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const A=S.context.configuration();if(A)D=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:A.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(re[27],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ek=void 0,e.$ek=(0,i.$ri)("productService"),e.$fk="vscode://schemas/vscode-product"}),define(re[239],oe([0,1,8,5]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;let S=class{constructor(P,k,u){this.a=P,this.b=k,this.c=u}async inspect(P){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,i.$sh)(P);const u=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),u.profile}async d(){const P=this.a.webContents.debugger;P.attach(),await P.sendCommand("Profiler.enable")}async e(){const P=this.a.webContents.debugger;await P.sendCommand("Profiler.disable"),P.detach()}};e.$1bc=S,e.$1bc=S=Se([ie(2,D.$Xj)],S)}),define(re[81],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=void 0,e.$bbc=(0,i.$ri)("protocolMainService")}),define(re[45],oe([0,1,139,12]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0;class S{constructor(){this.a=new Map}add(P,k){i.ok(D.$5f(P)),i.ok(D.$7f(k)),i.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,k)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$0n=new S}),define(re[240],oe([0,1,3,45]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=void 0,e.$$n={JSONContribution:"base.contributions.json"};function S(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this.b=new i.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,l){this.a[S(u)]=l,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const P=new A;D.$0n.add(e.$$n.JSONContribution,P)}),define(re[52],oe([0,1,22,3,12,165,18,240,45]),function(J,e,i,D,S,A,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.ConfigurationScope=e.$co=e.EditPresentationTypes=void 0,e.$no=v,e.$oo=p,e.$po=m,e.$qo=h,e.$ro=w;var l;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$co={Configuration:"base.contributions.configuration"};var d;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d||(e.ConfigurationScope=d={})),e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo="vscode://schemas/settings/resourceLanguage",e.$ko="vscode://schemas/settings/configurationDefaults";const y=u.$0n.as(k.$$n.JSONContribution);class E{constructor(){this.h=new Set,this.i=new D.$be,this.onDidSchemaChange=this.i.event,this.j=new D.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$jo,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const s=new Set;this.n(t,r,s),y.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const r=new Set;this.o(t,r),y.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const s=new Set;this.o(r,s),this.n(t,!1,s),y.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const s=[];for(const{overrides:n,source:o}of t)for(const c in n)if(r.add(c),e.$mo.test(c)){const b=this.a.get(c),L=b?.valuesSources??new Map;if(o)for(const R of Object.keys(n[c]))L.set(R,o);const I={...b?.value||{},...n[c]};this.a.set(c,{source:o,value:I,valuesSources:L});const j=(0,P.$8i)(c),O={type:"object",default:I,description:A.localize(1,null,j),$ref:e.$jo,defaultDefaultValue:I,source:S.$5f(o)?void 0:o,defaultValueSource:o};s.push(...v(c)),this.d[c]=O,this.b.properties[c]=O}else{this.a.set(c,{value:n[c],source:o});const b=this.d[c];b&&(this.w(c,b),this.r(c,b))}this.m(s)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:s,source:n}of t)for(const o in s){const c=this.a.get(o),b=S.$5f(n)?n:n?.id,L=S.$5f(c?.source)?c?.source:c?.source?.id;if(b===L)if(r.add(o),this.a.delete(o),e.$mo.test(o))delete this.d[o],delete this.b.properties[o];else{const I=this.d[o];I&&(this.w(o,I),this.r(o,I))}}this.u()}deltaConfiguration(t){let r=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,s){t.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,r){const s=n=>{if(n.properties)for(const o in n.properties){r.add(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.s(o,n.properties[o])}n.allOf?.forEach(o=>s(o))};for(const n of t){s(n);const o=this.c.indexOf(n);o!==-1&&this.c.splice(o,1)}}p(t,r=!0,s,n,o=3,c){o=S.$bg(t.scope)?o:t.scope;const b=t.properties;if(b)for(const I in b){const j=b[I];if(r&&h(I,j)){delete b[I];continue}if(j.source=s,j.defaultDefaultValue=b[I].default,this.w(I,j),e.$mo.test(I)?j.scope=void 0:(j.scope=S.$bg(j.scope)?o:j.scope,j.restricted=S.$bg(j.restricted)?!!n?.includes(I):j.restricted),b[I].hasOwnProperty("included")&&!b[I].included){this.f[I]=b[I],delete b[I];continue}else this.d[I]=b[I],b[I].policy?.name&&this.e.set(b[I].policy.name,I);!b[I].deprecationMessage&&b[I].markdownDeprecationMessage&&(b[I].deprecationMessage=b[I].markdownDeprecationMessage),c.add(I)}const L=t.allOf;if(L)for(const I of L)this.p(I,r,s,n,o,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=s=>{const n=s.properties;if(n)for(const c in n)this.r(c,n[c]);s.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$do.properties[t]=r,r.scope){case 1:e.$eo.properties[t]=r;break;case 2:e.$fo.properties[t]=r;break;case 6:e.$go.properties[t]=r;break;case 3:e.$ho.properties[t]=r;break;case 4:e.$io.properties[t]=r;break;case 5:e.$io.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$do.properties[t],r.scope){case 1:delete e.$eo.properties[t];break;case 2:delete e.$fo.properties[t];break;case 6:delete e.$go.properties[t];break;case 3:delete e.$ho.properties[t];break;case 4:case 5:delete e.$io.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$jo};this.w(r,s),e.$do.properties[r]=s,e.$eo.properties[r]=s,e.$fo.properties[r]=s,e.$go.properties[r]=s,e.$ho.properties[r]=s,e.$io.properties[r]=s}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$jo};e.$do.patternProperties[e.$lo]=t,e.$eo.patternProperties[e.$lo]=t,e.$fo.patternProperties[e.$lo]=t,e.$go.patternProperties[e.$lo]=t,e.$ho.patternProperties[e.$lo]=t,e.$io.patternProperties[e.$lo]=t,this.i.fire()}w(t,r){const s=this.a.get(t);let n=s?.value,o=s?.source;S.$_f(n)&&(n=r.defaultDefaultValue,o=void 0),S.$_f(n)&&(n=m(r.type)),r.default=n,r.defaultValueSource=o}}const $="\\[([^\\]]+)\\]",g=new RegExp($,"g");e.$lo=`^(${$})+$`,e.$mo=new RegExp(e.$lo);function v(a){const t=[];if(e.$mo.test(a)){let r=g.exec(a);for(;r?.length;){const s=r[1].trim();s&&t.push(s),r=g.exec(a)}}return(0,i.$Mb)(t)}function p(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}function m(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new E;u.$0n.add(e.$co.Configuration,f);function h(a,t){return a.trim()?e.$mo.test(a)?A.localize(7,null,a):f.getConfigurationProperties()[a]!==void 0?A.localize(8,null,a):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,a,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function w(){const a=[],t=f.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(re[123],oe([0,1,22,3,42,2,31,35,12,7,18,52,45]),function(J,e,i,D,S,A,P,k,u,l,d,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$vo=e.$uo=e.$to=e.$so=void 0,e.$wo=h;function $(r){return Object.isFrozen(r)?r:k.$Yn(r)}class g{static createEmptyModel(s){return new g({},[],[],void 0,s)}constructor(s,n,o,c,b){this.b=s,this.c=n,this.d=o,this.raw=c,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof g)return n;const o=new v("",this.f);return o.parseRaw(n),o.configurationModel});this.g=s.reduce((n,o)=>o===n?o:n.merge(o),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,d.$6i)(this.contents,s):this.contents}inspect(s,n){const o=this;return{get value(){return $(o.rawConfiguration.getValue(s))},get override(){return n?$(o.rawConfiguration.getOverrideValue(s,n)):void 0},get merged(){return $(n?o.rawConfiguration.override(n).getValue(s):o.rawConfiguration.getValue(s))},get overrides(){const c=[];for(const{contents:b,identifiers:L,keys:I}of o.rawConfiguration.overrides){const j=new g(b,I,[],void 0,o.f).getValue(s);j!==void 0&&c.push({identifiers:L,value:j})}return c.length?$(c):void 0}}}getOverrideValue(s,n){const o=this.j(n);return o?s?(0,d.$6i)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const o of this.overrides)o.identifiers.includes(s)&&n.push(...o.keys);return i.$Mb(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return i.$Mb(s)}override(s){let n=this.a.get(s);return n||(n=this.h(s),this.a.set(s,n)),n}merge(...s){const n=k.$Xn(this.contents),o=k.$Xn(this.overrides),c=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const L of s)if(b.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.i(n,L.contents);for(const I of L.overrides){const[j]=o.filter(O=>i.$ub(O.identifiers,I.identifiers));j?(this.i(j.contents,I.contents),j.keys.push(...I.keys),j.keys=i.$Mb(j.keys)):o.push(k.$Xn(I))}for(const I of L.keys)c.indexOf(I)===-1&&c.push(I)}return new g(n,c,o,b.every(L=>L instanceof g)?void 0:b,this.f)}h(s){const n=this.j(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const c of i.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let b=this.contents[c];const L=n[c];L&&(typeof b=="object"&&typeof L=="object"?(b=k.$Xn(b),this.i(b,L)):b=L),o[c]=b}return new g(o,this.keys,this.overrides,void 0,this.f)}i(s,n){for(const o of Object.keys(n)){if(o in s&&u.$7f(s[o])&&u.$7f(n[o])){this.i(s[o],n[o]);continue}s[o]=k.$Xn(n[o])}}j(s){let n=null,o=null;const c=b=>{b&&(o?this.i(o,b):o=k.$Xn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===s?n=b.contents:b.identifiers.includes(s)&&c(b.contents);return c(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.k(s,n,!0)}setValue(s,n){this.k(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,d.$5i)(this.contents,s),y.$mo.test(s)&&this.overrides.splice(this.overrides.findIndex(o=>i.$ub(o.identifiers,(0,y.$no)(s))),1))}k(s,n,o){(0,d.$4i)(this.contents,s,n,c=>this.f.error(c)),o=o||this.keys.indexOf(s)===-1,o&&this.keys.push(s),y.$mo.test(s)&&this.overrides.push({identifiers:(0,y.$no)(s),keys:Object.keys(this.contents[s]),contents:(0,d.$3i)(this.contents[s],c=>this.f.error(c))})}}e.$so=g;class v{constructor(s,n){this.f=s,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!u.$bg(s)){const o=this.h(s);this.parseRaw(o,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:o,keys:c,overrides:b,restricted:L,hasExcludedProperties:I}=this.i(s,n);this.b=new g(o,c,b,I?[s]:void 0,this.g),this.c=L||[]}h(s){let n={},o=null,c=[];const b=[],L=[];function I(O){Array.isArray(c)?c.push(O):o!==null&&(c[o]=O)}const j={onObjectBegin:()=>{const O={};I(O),b.push(c),c=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{c=b.pop()},onArrayBegin:()=>{const O=[];I(O),b.push(c),c=O,o=null},onArrayEnd:()=>{c=b.pop()},onLiteralValue:I,onError:(O,R,W)=>{L.push({error:O,offset:R,length:W})}};if(s)try{S.$Ln(s,j),n=c[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return n}i(s,n){const o=E.$0n.as(y.$co.Configuration).getConfigurationProperties(),c=this.j(s,o,!0,n);s=c.raw;const b=(0,d.$3i)(s,j=>this.g.error(`Conflict in settings file ${this.f}: ${j}`)),L=Object.keys(s),I=this.l(s,j=>this.g.error(`Conflict in settings file ${this.f}: ${j}`));return{contents:b,keys:L,overrides:I,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(s,n,o,c){let b=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:b};const L={},I=[];for(const j in s)if(y.$mo.test(j)&&o){const O=this.j(s[j],n,!1,c);L[j]=O.raw,b=b||O.hasExcludedProperties,I.push(...O.restricted)}else{const O=n[j],R=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&I.push(j),!c.exclude?.includes(j)&&(c.include?.includes(j)||(R===void 0||c.scopes===void 0||c.scopes.includes(R))&&!(c.skipRestricted&&O?.restricted))?L[j]=s[j]:b=!0}return{raw:L,restricted:I,hasExcludedProperties:b}}l(s,n){const o=[];for(const c of Object.keys(s))if(y.$mo.test(c)){const b={};for(const L in s[c])b[L]=s[c][L];o.push({identifiers:(0,y.$no)(c),keys:Object.keys(b),contents:(0,d.$3i)(b,n)})}return o}}e.$to=v;class p extends A.$Uc{constructor(s,n,o,c,b){super(),this.c=s,this.f=n,this.g=c,this.h=b,this.b=this.B(new D.$be),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),b),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,L=>L.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,L=>(L.isOperation(0)||L.isOperation(3)||L.isOperation(1)||L.isOperation(4))&&o.isEqual(L.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$uo=p;class m{constructor(s,n,o,c,b,L,I,j,O,R,W,F,T){this.a=s,this.b=n,this.c=o,this.overrideIdentifiers=c,this.d=b,this.f=L,this.g=I,this.h=j,this.i=O,this.j=R,this.k=W,this.l=F,this.m=T}get value(){return $(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(s,n,o,c,b,L,I,j,O,R){this.j=s,this.l=n,this.m=o,this.n=c,this.p=b,this.q=L,this.r=I,this.s=j,this.t=O,this.u=R,this.h=null,this.i=new P.$Bc,this.v=null}getValue(s,n,o){return this.w(s,n,o).getValue(s)}updateValue(s,n,o={}){let c;o.resource?(c=this.t.get(o.resource),c||(c=g.createEmptyModel(this.u),this.t.set(o.resource,c))):c=this.s,n===void 0?c.removeValue(s):c.setValue(s,n),o.resource||(this.h=null)}inspect(s,n,o){const c=this.w(s,n,o),b=this.A(n.resource,o),L=n.resource?this.t.get(n.resource)||this.s:this.s,I=new Set;for(const j of c.overrides)for(const O of j.identifiers)c.getOverrideValue(s,O)!==void 0&&I.add(O);return new m(s,n,c.getValue(s),I.size?[...I]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,b||void 0,L)}keys(s){const n=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,n){this.r.set(s,n),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const o=[];if(!n){const{added:c,updated:b,removed:L}=a(this.j,s);n=[...c,...b,...L]}for(const c of n)for(const b of(0,y.$no)(c)){const L=this.j.getKeysForOverrideIdentifier(b),I=s.getKeysForOverrideIdentifier(b),j=[...I.filter(O=>L.indexOf(O)===-1),...L.filter(O=>I.indexOf(O)===-1),...L.filter(O=>!k.$2n(this.j.override(b).getValue(O),s.override(b).getValue(O)))];o.push([b,j])}return this.updateDefaultConfiguration(s),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:o,removed:c}=a(this.l,s),b=[...n,...o,...c];return b.length&&this.updatePolicyConfiguration(s),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:o,removed:c,overrides:b}=a(this.applicationConfiguration,s),L=[...n,...o,...c];return L.length&&this.updateApplicationConfiguration(s),{keys:L,overrides:b}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:o,removed:c,overrides:b}=a(this.localUserConfiguration,s),L=[...n,...o,...c];return L.length&&this.updateLocalUserConfiguration(s),{keys:L,overrides:b}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:o,removed:c,overrides:b}=a(this.remoteUserConfiguration,s),L=[...n,...o,...c];return L.length&&this.updateRemoteUserConfiguration(s),{keys:L,overrides:b}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:o,removed:c,overrides:b}=a(this.workspaceConfiguration,s),L=[...n,...o,...c];return L.length&&this.updateWorkspaceConfiguration(s),{keys:L,overrides:b}}compareAndUpdateFolderConfiguration(s,n){const o=this.folderConfigurations.get(s),{added:c,updated:b,removed:L,overrides:I}=a(o,n),j=[...c,...b,...L];return(j.length||!o)&&this.updateFolderConfiguration(s,n),{keys:j,overrides:I}}compareAndDeleteFolderConfiguration(s){const n=this.folderConfigurations.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:c,removed:b,overrides:L}=a(n,void 0);return{keys:[...o,...c,...b],overrides:L}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,n,o){let c=this.x(n,o);return n.overrideIdentifier&&(c=c.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(c=c.merge(this.l)),c}x({resource:s},n){let o=this.y();if(n&&s){const c=n.getFolder(s);c&&(o=this.z(c.uri)||o);const b=this.t.get(s);b&&(o=o.merge(b))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let n=this.i.get(s);if(!n){const o=this.y(),c=this.r.get(s);c?(n=o.merge(c),this.i.set(s,n)):n=o}return n}A(s,n){if(n&&s){const o=n.getFolder(s);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,n)=>{const{contents:o,overrides:c,keys:b}=this.r.get(n);return s.push([n,{contents:o,overrides:c,keys:b}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.q.keys.forEach(n=>s.add(n)),this.r.forEach(n=>n.keys.forEach(o=>s.add(o))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}D(s){const n=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>n.add(o)),this.q.getKeysForOverrideIdentifier(s).forEach(o=>n.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(c=>n.add(c))),[...n.values()]}static parse(s,n){const o=this.E(s.defaults,n),c=this.E(s.policy,n),b=this.E(s.application,n),L=this.E(s.user,n),I=this.E(s.workspace,n),j=s.folders.reduce((O,R)=>(O.set(l.URI.revive(R[0]),this.E(R[1],n)),O),new P.$Bc);return new f(o,c,b,L,g.createEmptyModel(n),I,j,g.createEmptyModel(n),new P.$Bc,n)}static E(s,n){return new g(s.contents,s.keys,s.overrides,void 0,n)}}e.$vo=f;function h(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,n=new Map;for(const c of r)c.keys.forEach(b=>s.add(b)),c.overrides.forEach(([b,L])=>{const I=(0,P.$yc)(n,b,new Set);L.forEach(j=>I.add(j))});const o=[];return n.forEach((c,b)=>o.push([b,[...c.values()]])),{keys:[...s.values()],overrides:o}}class w{constructor(s,n,o,c,b){this.change=s,this.f=n,this.g=o,this.h=c,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const L of s.keys)this.affectedKeys.add(L);for(const[,L]of s.overrides)for(const I of L)this.affectedKeys.add(I);this.d=this.a;for(const L of this.affectedKeys)this.d+=L+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=f.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,n){const o=this.a+s,c=this.d.indexOf(o);if(c<0)return!1;const b=c+o.length;if(b>=this.d.length)return!1;const L=this.d.charCodeAt(b);if(L!==this.b&&L!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,j=this.g.getValue(s,n,this.h);return!k.$2n(I,j)}return!0}}e.$xo=w;function a(r,s){const{added:n,removed:o,updated:c}=t(s?.rawConfiguration,r?.rawConfiguration),b=[],L=r?.getAllOverrideIdentifiers()||[],I=s?.getAllOverrideIdentifiers()||[];if(s){const j=I.filter(O=>!L.includes(O));for(const O of j)b.push([O,s.getKeysForOverrideIdentifier(O)])}if(r){const j=L.filter(O=>!I.includes(O));for(const O of j)b.push([O,r.getKeysForOverrideIdentifier(O)])}if(s&&r){for(const j of L)if(I.includes(j)){const O=t({contents:r.getOverrideValue(void 0,j)||{},keys:r.getKeysForOverrideIdentifier(j)},{contents:s.getOverrideValue(void 0,j)||{},keys:s.getKeysForOverrideIdentifier(j)});b.push([j,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:o,updated:c,overrides:b}}function t(r,s){const n=r?s?r.keys.filter(b=>s.keys.indexOf(b)===-1):[...r.keys]:[],o=s?r?s.keys.filter(b=>r.keys.indexOf(b)===-1):[...s.keys]:[],c=[];if(r&&s){for(const b of s.keys)if(r.keys.indexOf(b)!==-1){const L=(0,d.$6i)(s.contents,b),I=(0,d.$6i)(r.contents,b);k.$2n(L,I)||c.push(b)}}return{added:n,removed:o,updated:c}}}),define(re[241],oe([0,1,22,3,2,35,12,123,52,5,39,45]),function(J,e,i,D,S,A,P,k,u,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=void 0;class E extends S.$Uc{get configurationModel(){return this.b}constructor(p){super(),this.c=p,this.a=this.B(new D.$be),this.onDidChangeConfiguration=this.a.event,this.b=k.$so.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(y.$0n.as(u.$co.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:m})=>this.f(Array.from(p),m))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(p,m){this.j(p,y.$0n.as(u.$co.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}g(){return{}}h(){this.b=k.$so.createEmptyModel(this.c);const p=y.$0n.as(u.$co.Configuration).getConfigurationProperties();this.j(Object.keys(p),p)}j(p,m){const f=this.g();for(const h of p){const w=f[h],a=m[h];w!==void 0?this.b.addValue(h,w):a?this.b.addValue(h,a.default):this.b.removeValue(h)}}}e.$yo=E;class ${constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=k.$so.createEmptyModel(new l.$$j)}async initialize(){return this.configurationModel}}e.$zo=$;let g=class extends S.$Uc{get configurationModel(){return this.b}constructor(p,m,f){super(),this.c=p,this.f=m,this.g=f,this.a=this.B(new D.$be),this.onDidChangeConfiguration=this.a.event,this.b=k.$so.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const m={},f=[],h=y.$0n.as(u.$co.Configuration).getConfigurationProperties();for(const w of p){const a=h[w];if(!a){f.push(w);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}f.push(w),m[a.policy.name]={type:a.type}}}return(0,P.$fg)(m)||await this.f.updatePolicyDefinitions(m),f}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const m=y.$0n.as(u.$co.Configuration).getPolicyConfigurations(),f=(0,i.$Hb)(p.map(h=>m.get(h)));this.m(f,!0)}m(p,m){this.g.trace("PolicyConfiguration#update",p);const f=y.$0n.as(u.$co.Configuration).getConfigurationProperties(),h=[],w=this.b.isEmpty();for(const a of p){const t=f[a]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(w?r!==void 0:!(0,A.$2n)(this.b.getValue(a),r))&&h.push([a,r])}else this.b.getValue(a)!==void 0&&h.push([a,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const a=this.b;this.b=k.$so.createEmptyModel(this.g);for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,r]of h)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);m&&this.a.fire(this.b)}}};e.$Ao=g,e.$Ao=g=Se([ie(1,d.$_n),ie(2,l.$Xj)],g)}),define(re[242],oe([0,1,22,8,17,3,42,103,2,31,35,4,19,18,123,52,241,39]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=void 0;class f extends u.$Uc{constructor(a,t,r,s){super(),this.m=a,this.n=s,this.h=this.B(new A.$be),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$yo(s)),this.c=r instanceof m.$bo?new p.$zo:this.B(new p.$Ao(this.b,r,s)),this.f=this.B(new g.$uo(this.m,{},E.$Vg,t,s)),this.a=new g.$vo(this.b.configurationModel,this.c.configurationModel,g.$so.createEmptyModel(s),g.$so.createEmptyModel(s),g.$so.createEmptyModel(s),g.$so.createEmptyModel(s),new l.$Bc,g.$so.createEmptyModel(s),new l.$Bc,s),this.j=new h(a,t,this),this.g=this.B(new D.$Dh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:o})=>this.s(n,o))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new g.$vo(a,t,g.$so.createEmptyModel(this.n),r,g.$so.createEmptyModel(this.n),g.$so.createEmptyModel(this.n),new l.$Bc,g.$so.createEmptyModel(this.n),new l.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,t){const r=typeof a=="string"?a:void 0,s=(0,$.$Yi)(a)?a:(0,$.$Yi)(t)?t:{};return this.a.getValue(r,s,void 0)}async updateValue(a,t,r,s,n){const o=(0,$.$Zi)(r)?r:(0,$.$Yi)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,c=o?s:r;if(c!==void 0&&c!==3&&c!==2)throw new Error(`Unable to write ${a} to target ${c}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,i.$Mb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const b=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(b.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,d.$2n)(t,b.defaultValue)&&(t=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const I=o.overrideIdentifiers.sort(),j=this.a.localUserConfiguration.overrides.find(O=>(0,i.$ub)([...O.identifiers].sort(),I));j&&(o.overrideIdentifiers=j.identifiers)}const L=o?.overrideIdentifiers?.length?[(0,v.$oo)(o.overrideIdentifiers),a]:[a];await this.j.write(L,t),await this.reloadConfiguration()}inspect(a,t={}){return this.a.inspect(a,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,t,2)}s(a,t){const r=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(a,t);this.u(s,r,7)}t(a){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,t,7)}u(a,t,r){const s=new g.$xo(a,{data:t},this.a,void 0,this.n);s.source=r,this.h.fire(s)}}e.$Bo=f;class h{constructor(a,t,r){this.b=a,this.c=t,this.d=r,this.a=new D.$yh}write(a,t){return this.a.queue(()=>this.e(a,t))}async e(a,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===1)r="{}";else throw o}const s=[];if((0,P.$En)(r,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(r,a,t);r=(0,k.$Wn)(r,n),await this.c.writeFile(this.b,S.$Ce.fromString(r))}f(a,t,r){const{tabSize:s,insertSpaces:n,eol:o}=this.h;if(!t.length){const c=JSON.stringify(r,null,n?" ".repeat(s):"	");return[{content:c,length:c.length,offset:0}]}return(0,k.$Tn)(a,t,r,{tabSize:s,insertSpaces:n,eol:o})}get h(){if(!this.g){let a=y.OS===3||y.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(re[243],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=e.$Ycc=e.$Xcc=void 0,e.$Xcc="request",e.$Ycc="remoteResourceHandler";class i{async routeCall(S,A,P){if(A!==e.$Xcc)throw new Error(`Call not found: ${A}`);const k=P[0];if(k?.authority){const u=S.connections.find(l=>l.ctx===k.authority);if(u)return u}throw new Error("Caller not found")}routeEvent(S,A){throw new Error(`Event not found: ${A}`)}}e.$Zcc=i}),define(re[244],oe([0,1,15,6]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.RemoteAuthorityResolverErrorCode=e.$El=e.$Dl=e.RemoteConnectionType=e.$Cl=void 0,e.$Gl=l,e.$Cl=(0,D.$ri)("remoteAuthorityResolverService");var S;(function(d){d[d.WebSocket=0]="WebSocket",d[d.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class A{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Dl=A;class P{constructor(y,E){this.host=y,this.port=E,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$El=P;var k;(function(d){d.Unknown="Unknown",d.NotAvailable="NotAvailable",d.TemporarilyNotAvailable="TemporarilyNotAvailable",d.NoResolverFound="NoResolverFound",d.InvalidAuthority="InvalidAuthority"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class u extends i.$bb{static isNotAvailable(y){return y instanceof u&&y._code===k.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof u&&y._code===k.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof u&&y._code===k.NoResolverFound}static isInvalidAuthority(y){return y instanceof u&&y._code===k.InvalidAuthority}static isHandled(y){return y instanceof u&&y.isHandled}constructor(y,E=k.Unknown,$){super(y),this._message=y,this._code=E,this._detail=$,this.isHandled=E===k.NotAvailable&&$===!0,Object.setPrototypeOf(this,u.prototype)}}e.$Fl=u;function l(d){const y=d.indexOf("+");return y===-1?d:d.substring(0,y)}}),define(re[245],oe([0,1,8,17,23,15,3,2,13,66,73,33,113,244]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ll=L,e.$Ml=I,e.$Nl=O;const g=30*1e3;var v;(function(Y){Y[Y.Management=1]="Management",Y[Y.ExtensionHost=2]="ExtensionHost",Y[Y.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function p(Y){switch(Y){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(Y){const C=new S.$me;return setTimeout(()=>C.cancel(),Y),C.token}function f(Y,C){if(Y.isCancellationRequested||C.isCancellationRequested)return S.CancellationToken.Cancelled;const N=new S.$me;return Y.onCancellationRequested(()=>N.cancel()),C.onCancellationRequested(()=>N.cancel()),N.token}class h{get didTimeout(){return this.c==="timedout"}constructor(C){this.c="pending",this.d=new k.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,i.$kh)(),C.isCancellationRequested?this.h():this.d.add(C.onCancellationRequested(()=>this.h()))}registerDisposable(C){this.c==="pending"?this.d.add(C):C.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const C=new Error("Time limit reached");return C.code="ETIMEDOUT",C.syscall="connect",C}resolve(C){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(C))}reject(C){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(C))}}function w(Y,C){const N=new h(C);return N.registerDisposable(Y.onControlMessage(_=>{const ne=JSON.parse(_.toString()),Q=M(ne);Q?N.reject(Q):N.resolve(ne)})),N.promise}function a(Y,C,N,_,ne,Q,x,V){const H=new h(V),se=d.$0d.create(!1);return Y.info(`Creating a socket (${x})...`),l.mark(`code/willCreateSocket/${Q}`),C.connect(N,_,ne,x).then(he=>{H.didTimeout?(l.mark(`code/didCreateSocketError/${Q}`),Y.info(`Creating a socket (${x}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(l.mark(`code/didCreateSocketOK/${Q}`),Y.info(`Creating a socket (${x}) was successful after ${se.elapsed()} ms.`),H.resolve(he))},he=>{l.mark(`code/didCreateSocketError/${Q}`),Y.info(`Creating a socket (${x}) returned an error after ${se.elapsed()} ms.`),Y.error(he),H.reject(he)}),H.promise}function t(Y,C){const N=new h(C);return Y.then(_=>{N.didTimeout||N.resolve(_)},_=>{N.didTimeout||N.reject(_)}),N.promise}async function r(Y,C,N,_){const ne=G(Y,C);Y.logService.trace(`${ne} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await a(Y.logService,Y.remoteSocketFactoryService,Y.connectTo,u.$Eg.getServerRootPath(),`reconnectionToken=${Y.reconnectionToken}&reconnection=${Y.reconnectionProtocol?"true":"false"}`,p(C),`renderer-${p(C)}-${Y.reconnectionToken}`,_)}catch(he){throw Y.logService.error(`${ne} socketFactory.connect() failed or timed out. Error:`),Y.logService.error(he),he}Y.logService.trace(`${ne} 2/6. socketFactory.connect() was successful.`);let x,V;Y.reconnectionProtocol?(Y.reconnectionProtocol.beginAcceptReconnection(Q,null),x=Y.reconnectionProtocol,V=!1):(x=new E.$fi({socket:Q}),V=!0),Y.logService.trace(`${ne} 3/6. sending AuthRequest control message.`);const H=await t(Y.signService.createNewMessage((0,y.$Ng)()),_),se={type:"auth",auth:Y.connectionToken||"00000000000000000000",data:H.data};x.sendControl(D.$Ce.fromString(JSON.stringify(se)));try{const he=await w(x,f(_,m(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(Y.logService.trace(`${ne} 4/6. received SignRequest control message.`),!await t(Y.signService.validate(H,he.signedData),_)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const $e=await t(Y.signService.sign(he.data),_),ye={type:"connectionType",commit:Y.commit,signedData:$e,desiredConnectionType:C};return N&&(ye.args=N),Y.logService.trace(`${ne} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(D.$Ce.fromString(JSON.stringify(ye))),{protocol:x,ownsProtocol:V}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(Y.logService.error(`${ne} the handshake timed out. Error:`),Y.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(Y.logService.error(`${ne} received error control message when negotiating connection. Error:`),Y.logService.error(he)),V&&B(x),he}}async function s(Y,C,N,_){const ne=Date.now(),Q=G(Y,C),{protocol:x,ownsProtocol:V}=await r(Y,C,N,_),H=new h(_);return H.registerDisposable(x.onControlMessage(se=>{const he=JSON.parse(se.toString()),me=M(he);me?(Y.logService.error(`${Q} received error control message when negotiating connection. Error:`),Y.logService.error(me),V&&B(x),H.reject(me)):(Y.reconnectionProtocol?.endAcceptReconnection(),Y.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${le(ne)}!`),H.resolve({protocol:x,firstMessage:he}))})),H.promise}async function n(Y,C){const{protocol:N}=await s(Y,1,void 0,C);return{protocol:N}}async function o(Y,C,N){const{protocol:_,firstMessage:ne}=await s(Y,2,C,N),Q=ne&&ne.debugPort;return{protocol:_,debugPort:Q}}async function c(Y,C,N){const _=Date.now(),ne=G(Y,3),{protocol:Q}=await r(Y,3,C,N);return Y.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${le(_)}!`),Q}async function b(Y,C,N){const{connectTo:_,connectionToken:ne}=await Y.addressProvider.getAddress();return{commit:Y.commit,quality:Y.quality,connectTo:_,connectionToken:ne,reconnectionToken:C,reconnectionProtocol:N,remoteSocketFactoryService:Y.remoteSocketFactoryService,signService:Y.signService,logService:Y.logService}}async function L(Y,C,N){return j(Y,async _=>{const{protocol:ne}=await n(_,S.CancellationToken.None);return new K(Y,C,N,_.reconnectionToken,ne)})}async function I(Y,C){return j(Y,async N=>{const{protocol:_,debugPort:ne}=await o(N,C,S.CancellationToken.None);return new X(Y,C,N.reconnectionToken,_,ne)})}async function j(Y,C){for(let _=1;;_++)try{const ne=(0,y.$Ng)(),Q=await b(Y,ne,null);return await C(Q)}catch(ne){if(_<5)Y.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),Y.logService.error(ne);else throw Y.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Y.logService.error(ne),ce.triggerPermanentFailure(0,0,$.$Fl.isHandled(ne)),ne}}async function O(Y,C,N){const _=await b(Y,(0,y.$Ng)(),null);return await c(_,{host:C,port:N},S.CancellationToken.None)}function R(Y){return(0,i.$eh)(C=>new Promise((N,_)=>{const ne=setTimeout(N,Y*1e3);C.onCancellationRequested(()=>{clearTimeout(ne),N()})}))}var W;(function(Y){Y[Y.ConnectionLost=0]="ConnectionLost",Y[Y.ReconnectionWait=1]="ReconnectionWait",Y[Y.ReconnectionRunning=2]="ReconnectionRunning",Y[Y.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Y[Y.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class F{constructor(C,N){this.reconnectionToken=C,this.millisSinceLastIncomingData=N,this.type=0}}e.$Ol=F;class T{constructor(C,N,_,ne){this.reconnectionToken=C,this.millisSinceLastIncomingData=N,this.durationSeconds=_,this.c=ne,this.type=1}skipWait(){this.c.cancel()}}e.$Pl=T;class q{constructor(C,N,_){this.reconnectionToken=C,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=2}}e.$Ql=q;class ue{constructor(C,N,_){this.reconnectionToken=C,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=4}}e.$Rl=ue;class ee{constructor(C,N,_,ne){this.reconnectionToken=C,this.millisSinceLastIncomingData=N,this.attempt=_,this.handled=ne,this.type=3}}e.$Sl=ee;class ce extends k.$Uc{static triggerPermanentFailure(C,N,_){this._permanentFailure=!0,this.f=C,this.g=N,this.h=_,this.j.forEach(ne=>ne.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(C=>C.y())}static debugPauseSocketWriting(){this.j.forEach(C=>C.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(C,N,_,ne,Q){super(),this.t=C,this.u=N,this.reconnectionToken=_,this.protocol=ne,this.w=Q,this.m=this.B(new P.$be),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ue(this.reconnectionToken,0,0)),this.B(ne.onSocketClose(x=>{const V=ae(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${V} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${V} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${V} received socket close event.`),this.y()})),this.B(ne.onSocketTimeout(x=>{const V=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${V} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,k.$Sc)(()=>{const x=ce.j.indexOf(this);x>=0&&ce.j.splice(x,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const C=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${C} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const ne=_<N.length?N[_]:N[N.length-1];try{if(ne>0){const x=R(ne);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ne,x)),this.u.logService.info(`${C} waiting for ${ne} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${C} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${C} resolving connection...`);const Q=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${C} connecting to ${Q.connectTo}...`),await this.G(Q,m(g)),this.u.logService.info(`${C} reconnected!`),this.m.fire(new ue(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${C} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${C} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if($.$Fl.isTemporarilyNotAvailable(Q)){this.u.logService.info(`${C} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.u.logService.info(`${C} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((0,A.$4)(Q)){this.u.logService.info(`${C} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if(Q instanceof $.$Fl){this.u.logService.error(`${C} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,$.$Fl.isHandled(Q));break}this.u.logService.error(`${C} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(C,N,_){this.w?ce.triggerPermanentFailure(C,N,_):this.D(C,N,_)}D(C,N,_){this.m.fire(new ee(this.reconnectionToken,C,N,_)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Tl=ce;class K extends ce{constructor(C,N,_,ne,Q){super(1,C,ne,Q,!0),this.client=this.B(new E.$di(Q,{remoteAuthority:N,clientId:_},C.ipcLogger))}async G(C,N){await n(C,N)}}e.$Ul=K;class X extends ce{constructor(C,N,_,ne,Q){super(2,C,_,ne,!1),this.H=N,this.debugPort=Q}async G(C,N){await o(C,this.H,N)}}e.$Vl=X;function B(Y){try{Y.acceptDisconnect();const C=Y.getSocket();Y.dispose(),C.dispose()}catch(C){(0,A.$1)(C)}}function M(Y){if(Y&&Y.type==="error"){const C=new Error(`Connection error: ${Y.reason}`);return C.code="VSCODE_CONNECTION_ERROR",C}return null}function z(Y,C){for(;Y.length<C;)Y+=" ";return Y}function U(Y,C){return`[remote-connection][${z(p(Y),13)}][${C.substr(0,5)}\u2026]`}function ae(Y,C,N){return`${U(Y,C)}[${N?"reconnect":"initial"}]`}function G(Y,C){return`${ae(C,Y.reconnectionToken,!!Y.reconnectionProtocol)}[${Y.connectTo}]`}function le(Y){return`${Date.now()-Y} ms`}}),define(re[68],oe([0,1,13]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=D,e.$Dm=S,e.$Em=A,e.$Fm=P;function D(u){return u.scheme===i.Schemas.vscodeRemote?u.authority:void 0}function S(u){if(!u)return;const l=u.indexOf("+");return l<0?u:u.substr(0,l)}function A(u){const{host:l,port:d}=k(u);if(typeof d>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:d}}function P(u,l){let{host:d,port:y}=k(u);return typeof y>"u"&&(y=l),{host:d,port:y}}function k(u){const l=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const d=u.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const y=u.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:u,port:void 0}}}),define(re[124],oe([0,1,25,6,68]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Om=e.$Nm=e.$Mm=e.TargetPlatform=e.ExtensionType=e.$Lm=e.$Jm=e.$Im=e.$Hm=e.$Gm=void 0,e.$Km=A,e.$Pm=y,e.$Qm=E,e.$Rm=$,e.$Sm=g,e.$Gm="extensions.user.cache",e.$Hm="extensions.builtin.cache",e.$Im="undefined_publisher",e.$Jm=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Lm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var P;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(P||(e.ExtensionType=P={}));var k;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class u{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,m){if(typeof p>"u"||p===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof p=="string"||typeof m=="string"){const f=typeof p=="string"?p:p.value,h=typeof m=="string"?m:m.value;return i.$uf(f,h)}return p._lower===m._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$Mm=u;class l{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const m of p)this.add(m)}add(p){this.c.add(u.toKey(p))}delete(p){return this.c.delete(u.toKey(p))}has(p){return this.c.has(u.toKey(p))}}e.$Nm=l;class d{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(u.toKey(p))}get(p){return this.c.get(u.toKey(p))}has(p){return this.c.has(u.toKey(p))}set(p,m){this.c.set(u.toKey(p),m)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Om=d;function y(v){return E(v)}function E(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}function $(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}function g(v,p){if(p){const m=`onResolveRemoteAuthority:${(0,S.$Dm)(p)}`;return!!v.activationEvents?.includes(m)}return!1}e.$Tm=(0,D.$ri)("IBuiltinExtensionsScannerService")}),define(re[246],oe([0,1,2,6]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=void 0,e.$Hl=(0,D.$ri)("remoteSocketFactoryService");class S{constructor(){this.a={}}register(P,k){return this.a[P]??=[],this.a[P].push(k),(0,i.$Sc)(()=>{const u=this.a[P]?.indexOf(k);typeof u=="number"&&u>=0&&this.a[P]?.splice(u,1)})}b(P){return(this.a[P.type]||[]).find(u=>u.supports(P))}connect(P,k,u,l){const d=this.b(P);if(!d)throw new Error(`No socket factory found for ${P}`);return d.connect(P,k,u,l)}}e.$Il=S}),define(re[247],oe([0,1,26,49,21,117]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=k;let P;async function k($=!1){return(P===void 0||$)&&(P=u()),P}async function u(){const $=l();if($===void 0)return!1;if($>=22e3){const g=y();if(g)return new Promise(v=>{D.execFile(g,["--status"],p=>v(!p))})}else{const g=E();if(g)try{if((await S.Promises.stat(g)).isFile())return!0}catch{}}return!1}function l(){const $=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());if($)return parseInt($[3])}function d($){const g=process.env.SystemRoot;if(g){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(g,v?"Sysnative":"System32",$)}}function y(){return d("wsl.exe")}function E(){return d("lxss\\LxssManager.dll")}}),define(re[53],oe([0,1,17,15,2,186,52,6,5,45]),function(J,e,i,D,S,A,P,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=void 0,e.$Kp=E,e.$Lp=$,e.$Mp=g,e.$Np=v,e.$Op=p,e.$Pp=m,e.$Ip=(0,k.$ri)("requestService");class d{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class y extends S.$Uc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,A.localize)(0,null),when:u.$dk.isEqualTo((0,u.$ak)(u.LogLevel.Trace)).serialize()})}async c(a,t,r){const s=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new d(t.headers??{}));try{const n=await r();return this.a.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,t.type,(0,D.$0)(n)),n}}}e.$Jp=y;function E(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}function $(w){return w.res.statusCode===204}async function g(w){return $(w)?null:(await(0,i.$Oe)(w.stream)).toString()}async function v(w){if(!E(w))throw new Error("Server returned "+w.res.statusCode);return g(w)}async function p(w){if(!E(w))throw new Error("Server returned "+w.res.statusCode);if($(w))return null;const t=(await(0,i.$Oe)(w.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function m(w){h(w)}let f;function h(w){const a=l.$0n.as(P.$co.Configuration),t=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:t?[t]:[]})}h(1)}),define(re[248],oe([0,1,17,23]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=void 0;class S{constructor(k){this.a=k}listen(k,u){throw new Error("Invalid listen")}call(k,u,l,d=D.CancellationToken.None){switch(u){case"request":return this.a.request(l[0],d).then(async({res:y,stream:E})=>{const $=await(0,i.$Oe)(E);return[{statusCode:y.statusCode,headers:y.headers},$]});case"resolveProxy":return this.a.resolveProxy(l[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Pr=S;class A{constructor(k){this.a=k}async request(k,u){const[l,d]=await this.a.call("request",[k],u);return{res:l,stream:(0,i.$Qe)(d)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Qr=A}),define(re[249],oe([0,1,250,12]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=A;function S(P,k){return P.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:P.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function A(P,k,u={}){const l=(0,i.parse)(P),d=u.proxyUrl||S(l,k);if(!d)return null;const y=(0,i.parse)(d);if(!/^https?:$/.test(y.protocol||""))return null;const E={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,D.$$f)(u.strictSSL)?u.strictSSL:!0};return l.protocol==="http:"?new(await new Promise(($,g)=>{J(["http-proxy-agent"],$,g)})).HttpProxyAgent(d,E):new(await new Promise(($,g)=>{J(["https-proxy-agent"],$,g)})).HttpsProxyAgent(d,E)}}),define(re[251],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=e.$hcc=void 0,e.$hcc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$icc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$jcc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(re[95],oe([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=v;let g;async function v(m,f,h,w){return h["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$vm)(w)&&!h["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$vm)(w)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=E.Promises.withAsyncBody(async(a,t)=>{const r=new A.$me;let s=1e4;const n=m.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(s=(0,$.$wm)(n,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),t(new Error((0,S.localize)(0,null)))},s);try{a(await p(f,r.token))}catch(c){!(0,k.$4)(c)&&!r.token.isCancellationRequested?t(new Error((0,S.localize)(1,null,(0,P.$cj)(c)))):a({})}finally{clearTimeout(o),r.dispose()}})),g)}async function p(m,f){const h=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",h);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",w);const a=(0,l.$Ng)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};m.trace("getUnixShellEnvironment#env",r);const s=await(0,d.$lm)(u.OS,r);return m.trace("getUnixShellEnvironment#shell",s),new Promise((n,o)=>{if(f.isCancellationRequested)return o(new k.$5);const c=(0,D.$oc)(s);let b,L;const I="";/^pwsh(-preview)?$/.test(c)?(b=`& '${process.execPath}' ${I} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,L=["-Login","-Command"]):c==="nu"?(b=`^'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,L=["-i","-l","-c"]):c==="xonsh"?(b=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,L=["-i","-l","-c"]):(b=`'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"||c==="csh"?L=["-ic"]:L=["-i","-l","-c"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(L),b);const j=(0,i.spawn)(s,[...L,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});f.onCancellationRequested(()=>(j.kill(),o(new k.$5))),j.on("error",W=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,P.$cj)(W)),o(W)});const O=[];j.stdout.on("data",W=>O.push(W));const R=[];j.stderr.on("data",W=>R.push(W)),j.on("close",(W,F)=>{const T=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",T);const q=Buffer.concat(R).toString("utf8");if(q.trim()&&m.trace("getUnixShellEnvironment#stderr",q),W||F)return o(new Error((0,S.localize)(2,null,W,F)));const ue=t.exec(T),ee=ue?ue[1]:"{}";try{const ce=JSON.parse(ee);h?ce.ELECTRON_RUN_AS_NODE=h:delete ce.ELECTRON_RUN_AS_NODE,w?ce.ELECTRON_NO_ATTACH_CONSOLE=w:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",ce),n(ce)}catch(ce){m.error("getUnixShellEnvironment#errorCaught",(0,P.$cj)(ce)),o(ce)}})})}}),define(re[252],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b$b=void 0;class i{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(S){try{const A=await this.c();if(A){const P=String(i.a++);return this.b.set(P,A),{id:P,data:A.createNewMessage(S)}}}catch{}return{id:"",data:S}}async validate(S,A){if(!S.id)return!0;const P=this.b.get(S.id);if(!P)return!1;this.b.delete(S.id);try{return P.validate(A)==="ok"}catch{return!1}finally{P.dispose?.()}}async sign(S){try{return await this.d(S)}catch{}return S}}e.$b$b=i}),define(re[96],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=void 0,e.$Jl="signService",e.$Kl=(0,i.$ri)(e.$Jl)}),define(re[253],oe([0,1,252]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class D extends i.$b$b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(P=>new P.signer().sign(A))}h(){return new Promise((A,P)=>J(["vsda"],A,P))}}e.$0cc=D}),define(re[34],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=e.$uQ=void 0,e.$uQ=(0,i.$ri)("stateReadService"),e.$vQ=(0,i.$ri)("stateService")}),define(re[125],oe([0,1,8,17,2,12,38,16,5]),function(J,e,i,D,S,A,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=e.$xQ=e.$wQ=e.SaveStrategy=void 0;var l;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class d extends S.$Uc{constructor(g,v,p,m){super(),this.h=g,this.j=v,this.m=p,this.n=m,this.a=Object.create(null),this.b="",this.c=this.B(new i.$ph(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(g){g.fileOperationResult!==1&&this.m.error(g)}}getItem(g,v){const p=this.a[g];return(0,A.$bg)(p)?v:p}setItem(g,v){this.setItems([{key:g,data:v}])}setItems(g){let v=!1;for(const{key:p,data:m}of g)this.a[p]!==m&&((0,A.$bg)(m)?(0,A.$_f)(this.a[p])||(this.a[p]=void 0,v=!0):(this.a[p]=m,v=!0));v&&this.s()}removeItem(g){(0,A.$_f)(this.a[g])||(this.a[g]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const g=JSON.stringify(this.a,null,4);if(g!==this.b)try{await this.n.writeFile(this.h,D.$Ce.fromString(g),{atomic:{postfix:".vsctmp"}}),this.b=g}catch(v){this.m.error(v)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$wQ=d;let y=class extends S.$Uc{constructor(g,v,p,m){super(),this.a=this.B(new d(v.stateResource,g,p,m))}async init(){await this.a.init()}getItem(g,v){return this.a.getItem(g,v)}};e.$xQ=y,e.$xQ=y=Se([ie(1,P.$yi),ie(2,u.$Xj),ie(3,k.$Xk)],y);class E extends y{setItem(g,v){this.a.setItem(g,v)}setItems(g){this.a.setItems(g)}removeItem(g){this.a.removeItem(g)}close(){return this.a.close()}}e.$yQ=E}),define(re[126],oe([0,1,4,36,33]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=P,e.$_o=k;function A(u){if(i.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function P(u,l,d,y,E,$,g,v,p){const m=Object.create(null);m["common.machineId"]=$,m["common.sqmId"]=g,m.sessionID=(0,S.$Ng)()+Date.now(),m.commitHash=y,m.version=E,m["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,i.$h)(i.$u),m["common.nodePlatform"]=D.$ec,m["common.nodeArch"]=d,m["common.product"]=p||"desktop",v&&(m["common.msftInternal"]=v);let f=0;const h=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),i.$l&&(m["common.snap"]="true");const w=A(l);return w&&(m["common.platformDetail"]=w),m}function k(u){const l=D.env.USERDNSDOMAIN;if(!l)return!1;const d=l.toLowerCase();return u.some(y=>d===y)}}),define(re[28],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0,e.$Wl=(0,i.$ri)("telemetryService"),e.$Xl=(0,i.$ri)("customEndpointTelemetryService"),e.$Yl="telemetry.currentSessionDate",e.$Zl="telemetry.firstSessionDate",e.$1l="telemetry.lastSessionDate",e.$2l="telemetry.machineId",e.$3l="telemetry.sqmId",e.$4l="telemetry",e.$5l="telemetry.telemetryLevel",e.$6l="telemetry.enableCrashReporter",e.$7l="telemetry.enableTelemetry";var D;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var S;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(re[254],oe([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=void 0,e.$ys=m,e.$zs=h,e.$As=w;const p=new Map;async function m(t,r){const s=`${t}::${r.join(":")}`,n=p.get(s);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,b=new Map,L=2e4;function I(O,R,W,F){const T=R.substring(O.length+1);return D.Promises.withAsyncBody(async q=>{let ue;try{ue=await d.Promises.readdir(R,{withFileTypes:!0})}catch{q();return}if(F.count>=L){F.count+=ue.length,F.maxReached=!0,q();return}let ee=ue.length;if(ee===0){q();return}let ce=ue;F.count+ue.length>L&&(F.maxReached=!0,ee=L-F.count,ce=ue.slice(0,ee)),F.count+=ue.length;for(const K of ce)if(K.isDirectory()){if(W.includes(K.name)||await I(O,(0,P.$kc)(R,K.name),W,F),--ee===0){q();return}}else{const X=K.name.lastIndexOf(".");if(X>=0){const B=K.name.substring(X+1);B&&c.set(B,(c.get(B)??0)+1)}for(const B of o)B.relativePathPattern?.test(T)!==!1&&B.filePattern.test(K.name)&&b.set(B.tag,(b.get(B.tag)??0)+1);if(--ee===0){q();return}}})}const j=D.Promises.withAsyncBody(async O=>{const R={count:0,maxReached:!1};await I(t,t,r,R);const W=await w(t);O({configFiles:f(b),fileTypes:f(c),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:W})});return p.set(s,j),j}function f(t){return Array.from(t.entries(),([r,s])=>({name:r,count:s})).sort((r,s)=>s.count-r.count)}function h(){const t={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/$.$tl.GB).toFixed(2)}GB (${(i.freemem()/$.$tl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$zn.value()*100)}%`},r=i.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function w(t){try{const r=new Map,s=(0,P.$kc)(t,".vscode","launch.json"),n=await d.Promises.readFile(s),o=[],c=(0,S.$En)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,S.$Nn)(c)==="object"&&c.configurations)for(const b of c.configurations){const L=b.type;L&&(r.has(L)?r.set(L,r.get(L)+1):r.set(L,1))}return f(r)}catch{return[]}}let a=class{constructor(r,s){this.c=r,this.d=s}f(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}g(r){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const n=i.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(i.totalmem()/$.$tl.GB).toFixed(2)}GB (${(i.freemem()/$.$tl.GB).toFixed(2)}GB free)`),k.$i||s.push(`Load (avg):       ${i.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(l.$zn.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([(0,y.$xs)(r.mainPID),this.k(r)]).then(async n=>{let[o,c]=n,b=this.m(r,o);return s.forEach(L=>{if((0,E.$_m)(L))b+=`
${L.errorMessage}`,c+=`
${L.errorMessage}`;else if(b+=`

Remote: ${L.hostName}`,L.processes&&(b+=`
${this.m(r,L.processes)}`),L.workspaceMetadata){c+=`
|  Remote: ${L.hostName}`;for(const I of Object.keys(L.workspaceMetadata)){const j=L.workspaceMetadata[I];let O=`${j.fileCount} files`;j.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${I}): ${O}`,c+=this.h(j)}}}),{processInfo:b,workspaceInfo:c}})}async getSystemInfo(r,s){const{memory:n,vmHint:o,os:c,cpus:b}=h(),L={os:c,memory:n,cpus:b,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return k.$i||(L.load=`${i.loadavg().map(I=>Math.round(I)).join(", ")}`),k.$k&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(r,s){const n=[];return(0,y.$xs)(r.mainPID).then(async o=>(n.push(""),n.push(this.g(r)),n.push(""),n.push(this.m(r,o)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(r))),s.forEach(c=>{if((0,E.$_m)(c))n.push(`
${c.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${c.hostName}`),n.push(this.f(c.machineInfo)),c.processes&&n.push(this.m(r,c.processes)),c.workspaceMetadata)for(const b of Object.keys(c.workspaceMetadata)){const L=c.workspaceMetadata[b];let I=`${L.fileCount} files`;L.maxFilesReached&&(I=`more than ${I}`),n.push(`Folder (${b}): ${I}`),n.push(this.h(L))}}),n.push(""),n.push(""),n.join(`
`)))}h(r){const s=[];let o=0;const c=(j,O)=>{const R=` ${j}(${O})`;o+R.length>60?(s.push(b),b="|                 ",o=b.length):o+=R.length,b+=R};let b="|      File types:";const L=10,I=r.fileTypes.length>L?L:r.fileTypes.length;for(let j=0;j<I;j++){const O=r.fileTypes[j];c(O.name,O.count)}if(s.push(b),r.configFiles.length>=0&&(b="|      Conf files:",o=0,r.configFiles.forEach(j=>{c(j.name,j.count)}),s.push(b)),r.launchConfigFiles.length>0){let j="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{const R=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;j+=R}),s.push(j)}return s.join(`
`)}j(r){const s=Math.max(...Object.keys(r).map(n=>n.length));return Object.keys(r).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${r[n]}`).join(`
                  `)}k(r){const s=[],n=[];return r.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(c=>{const b=u.URI.revive(c);if(b.scheme===A.Schemas.file){const L=b.fsPath;n.push(m(L,["node_modules",".git"]).then(I=>{let j=`${I.fileCount} files`;I.maxFilesReached&&(j=`more than ${j}`),s.push(`|    Folder (${(0,P.$oc)(L)}): ${j}`),s.push(this.h(I))}).catch(I=>{s.push(`|      Error: Unable to collect workspace stats for folder ${L} (${I.toString()})`)}))}else s.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,s){const n=new Map;r.windows.forEach(c=>n.set(c.pid,`window [${c.id}] (${c.title})`)),r.pidToNames.forEach(({pid:c,name:b})=>n.set(c,b));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.n(r.mainPID,n,o,s,0),o.join(`
`)}n(r,s,n,o,c){const b=c===0;let L;b?L=o.pid===r?`${this.d.applicationName} main`:"remote agent":s.has(o.pid)?L=s.get(o.pid):L=`${"  ".repeat(c)} ${o.name}`;const I=process.platform==="win32"?o.mem:i.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(I/$.$tl.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(o.children)&&o.children.forEach(j=>this.n(r,s,n,j,c+1))}async getWorkspaceFileExtensions(r){const s=new Set;for(const{uri:n}of r.folders){const o=u.URI.revive(n);if(o.scheme!==A.Schemas.file)continue;const c=o.fsPath;try{(await m(c,["node_modules",".git"])).fileTypes.forEach(L=>s.add(L.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const n=u.URI.revive(s);if(n.scheme!==A.Schemas.file)continue;const o=n.fsPath;try{const c=await m(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:b.name,count:b.count})}),c.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:b.name,count:b.count})}),c.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$Bs=a,e.$Bs=a=Se([ie(0,v.$Wl),ie(1,g.$ek)],a)}),define(re[255],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;class i{constructor(A){this.b=A}listen(A,P){throw new Error(`Event not found: ${P}`)}call(A,P,{eventName:k,data:u}){return this.b.forEach(l=>l.log(k,u)),Promise.resolve(null)}}e.$mcc=i;class D{constructor(A){this.b=A}log(A,P){return this.b.call("log",{eventName:A,data:P}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$ncc=D}),define(re[54],oe([0,1,35,12,68,126,28]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0,e.$hp=d,e.$ip=y,e.$jp=E,e.$kp=$,e.$lp=v,e.$mp=m,e.$np=f,e.$op=a;class k{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$ap=k;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$bp=u,e.$cp=new u;class l{async publicLog(r,s,n){}async publicLogError(r,s,n){}}e.$dp=l,e.$ep="telemetry",e.$fp="extensionTelemetryLog",e.$gp={log:()=>null,flush:()=>Promise.resolve(null)};function d(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function y(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function E(t){const r=t.getValue(P.$5l),s=t.getValue(P.$6l);if(t.getValue(P.$7l)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function $(t){const r={},s={},n={};p(t,n);for(let o in n){o=o.length>150?o.substr(o.length-149):o;const c=n[o];typeof c=="number"?s[o]=c:typeof c=="boolean"?s[o]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${c.length}`),r[o]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(r[o]=c)}return{properties:r,measurements:s}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function v(t){if(!t)return"none";const r=(0,S.$Dm)(t);return g.has(r)?r:"other"}function p(t,r,s=0,n){if(t)for(const o of Object.getOwnPropertyNames(t)){const c=t[o],b=n?n+o:o;Array.isArray(c)?r[b]=(0,i.$3n)(c):c instanceof Date?r[b]=c.toISOString():(0,D.$7f)(c)?s<2?p(c,r,s+1,b+"."):r[b]=(0,i.$3n)(c):r[b]=c}}function m(t,r){const s=t.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,A.$_o)(s)||n}function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function h(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const n=[];for(const L of r)for(;;){const I=L.exec(t);if(!I)break;n.push([I.index,L.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(s="";;){const L=c.exec(t);if(!L)break;const I=n.some(([j,O])=>L.index<O&&j<c.lastIndex);!o.test(L[0])&&!I&&(s+=t.substring(b,L.index)+"<REDACTED: user-file-path>",b=c.lastIndex)}return b<t.length&&(s+=t.substr(b)),s}function w(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of r)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,r){return(0,i.$Zn)(t,s=>{if(s instanceof k||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let n=s.replaceAll("%20"," ");n=h(n,r);for(const o of r)n=n.replace(o,"");return n=w(n),n}})}}),define(re[127],oe([0,1,25,121,124,4,7,15,36,54]),function(J,e,i,D,S,A,P,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$qp=void 0,e.$pp=d,e.$rp=g,e.$sp=v,e.$tp=p,e.$up=m,e.$vp=f,e.$wp=h,e.$xp=w,e.$zp=a,e.$Ap=r;function d(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,i.$pf)(s.id,n.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(n){const o=n.manifest?n.manifest.version:n.version,c=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new E(n.identifier,o,c)}static parse(n){const o=y.exec(n);return o&&o[1]&&o[2]?new E({id:o[1]},o[2],o[4]||void 0):null}constructor(n,o,c="undefined"){this.version=o,this.targetPlatform=c,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof E?d(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$qp=E;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(s){const n=$.exec(s);return n&&n[1]?[p(n[1]),n[2]]:[p(s),void 0]}function v(s,n){return`${s}.${n}`}function p(s){return s.toLowerCase()}function m(s,n){return p(v(s??S.$Im,n))}function f(s,n){const o=[],c=b=>{for(const L of o)if(L.some(I=>d(n(I),n(b))))return L;return null};for(const b of s){const L=c(b);L?L.push(b):o.push([b])}return o}function h(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function w(s){return{id:new l.$ap(s.identifier.id),name:new l.$ap(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$yp=new S.$Mm("pprice.better-merge");function a(s,n){const o=[],c=n.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const b=c.shift();if(b&&o.every(L=>!d(L.identifier,{id:b}))){const L=s.filter(I=>d(I.identifier,{id:b}));L.length===1&&(o.push(L[0]),c.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}async function t(s,n){if(!A.$k)return!1;let o;try{o=(await s.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await s.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){n.debug("Error while getting the os-release file.",(0,k.$0)(b))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,n){const o=await t(s,n),c=(0,D.$Wo)(o?"alpine":A.$u,u.$fc);return n.debug("ComputeTargetPlatform:",c),c}}),define(re[256],oe([0,1,209,54]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=S;async function S(A,P,k,u,l,d,y){const E={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${P.nameShort})`};if((0,D.$hp)(P,k)&&(0,D.$jp)(u)===3){const $=await(0,i.$2p)(k,l,d);E["X-Market-User-Id"]=$,E["VSCode-SessionId"]=y.machineId||$}return E}}),define(re[257],oe([0,1,2,35,4,25,188,18,52,80,27,45,28,54]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(m,f,h){this.k=f,this.l=h,this.d={},this.i=new i.$Tc,this.j=[],this.b=m.appenders,this.c=m.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=m.piiPaths||[],this.g=3,this.h=!!m.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,A.$9e)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$9e)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(E.$5l)||w.affectsConfiguration(E.$7l)||w.affectsConfiguration(E.$6l))&&this.m()}))}setExperimentProperty(m,f){this.d[m]=f}m(){let m=(0,$.$jp)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const h=f.usage?3:f.error?2:0;m=Math.min(m,h)}this.g=m}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(m,f,h){this.g<f||(h=(0,D.$1n)(h,this.d),h=(0,$.$op)(h,this.j),h=(0,D.$1n)(h,this.c),this.b.forEach(w=>w.log(m,h)))}publicLog(m,f){this.n(m,3,f)}publicLog2(m,f){this.publicLog(m,f)}publicLogError(m,f){this.h&&this.n(m,2,f)}publicLogError2(m,f){this.publicLogError(m,f)}};e.$Ur=g,e.$Ur=g=Se([ie(1,k.$Xi),ie(2,d.$ek)],g);function v(){const p=(0,P.localize)(0,null,l.default.nameLong),m=l.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=S.$o?"":(0,P.localize)(3,null),h=(0,P.localize)(4,null),w=(0,P.localize)(5,null),a=(0,P.localize)(6,null),t=(0,P.localize)(7,null),r=`
|       | ${h} | ${w} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,P.localize)(8,null);return`
${p} ${m} ${f}

&nbsp;

${t}
${r}

&nbsp;

${s}
`}y.$0n.as(u.$co.Configuration).registerConfiguration({id:E.$4l,order:1,type:"object",title:(0,P.localize)(9,null),properties:{[E.$5l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$0n.as(u.$co.Configuration).registerConfiguration({id:E.$4l,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[E.$7l]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,P.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,P.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${E.$5l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[258],oe([0,1,4,89,28]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=A,e.$Pcc=P;async function A(k,u){let l=k.getItem(S.$2l);return(typeof l!="string"||i.$j&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,D.$An)(u.error.bind(u))),l}async function P(k,u){let l=k.getItem(S.$3l);return typeof l!="string"&&(l=await(0,D.$Bn)(u.error.bind(u))),l}}),define(re[259],oe([0,1,28,258]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=S,e.$Rcc=A;async function S(P,k){const u=await(0,D.$Occ)(P,k);return P.setItem(i.$2l,u),u}async function A(P,k){const u=await(0,D.$Pcc)(P,k);return P.setItem(i.$3l,u),u}}),define(re[128],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(re[260],oe([0,1,4,128]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0;const S=new Map([[D.EnvironmentVariableMutatorType.Append,"APPEND"],[D.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[D.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(d){this.collections=d,this.a=new Map,this.b=new Map,d.forEach((y,E)=>{this.d(y,E);const $=y.map.entries();let g=$.next();for(;!g.done;){const v=g.value[1],p=g.value[0];let m=this.a.get(p);if(m||(m=[],this.a.set(p,m)),m.length>0&&m[0].type===D.EnvironmentVariableMutatorType.Replace){g=$.next();continue}const f={extensionIdentifier:E,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};f.scope||delete f.scope,m.unshift(f),g=$.next()}})}async applyToProcessEnvironment(d,y,E){let $;i.$i&&($={},Object.keys(d).forEach(g=>$[g.toLowerCase()]=g));for(const[g,v]of this.getVariableMap(y)){const p=i.$i&&$[g.toLowerCase()]||g;for(const m of v){const f=E?await E(m.value):m.value;if(m.options?.applyAtProcessCreation??!0)switch(m.type){case D.EnvironmentVariableMutatorType.Append:d[p]=(d[p]||"")+f;break;case D.EnvironmentVariableMutatorType.Prepend:d[p]=f+(d[p]||"");break;case D.EnvironmentVariableMutatorType.Replace:d[p]=f;break}if(m.options?.applyAtShellIntegration??!1){const h=`VSCODE_ENV_${S.get(m.type)}`;d[h]=(d[h]?d[h]+":":"")+g+"="+this.c(f)}}}}c(d){return d.replaceAll(":","\\x3a")}diff(d,y){const E=new Map,$=new Map,g=new Map;if(d.getVariableMap(y).forEach((v,p)=>{const m=this.getVariableMap(y).get(p),f=k(v,m);f&&E.set(p,f)}),this.getVariableMap(y).forEach((v,p)=>{const m=d.getVariableMap(y).get(p),f=k(v,m);f&&g.set(p,f)}),this.getVariableMap(y).forEach((v,p)=>{const m=d.getVariableMap(y).get(p),f=u(v,m);f&&$.set(p,f)}),!(E.size===0&&$.size===0&&g.size===0))return{added:E,changed:$,removed:g}}getVariableMap(d){const y=new Map;for(const E of this.a.values()){const $=E.filter(g=>P(g,d));$.length>0&&y.set($[0].variable,$)}return y}getDescriptionMap(d){const y=new Map;for(const E of this.b.values()){const $=E.filter(g=>P(g,d,!0));for(const g of $)y.set(g.extensionIdentifier,g.description)}return y}d(d,y){if(!d.descriptionMap)return;const E=d.descriptionMap.entries();let $=E.next();for(;!$.done;){const g=$.value[1],v=$.value[0];let p=this.b.get(v);p||(p=[],this.b.set(v,p));const m={extensionIdentifier:y,scope:g.scope,description:g.description};m.scope||delete m.scope,p.push(m),$=E.next()}}}e.$ls=A;function P(l,d,y=!1){return l.scope?!!(l.scope.workspaceFolder&&d?.workspaceFolder&&l.scope.workspaceFolder.index===d.workspaceFolder.index):y?d===l.scope:!0}function k(l,d){if(!d)return l;const y=new Set;d.forEach($=>y.add($.extensionIdentifier));const E=[];return l.forEach($=>{y.has($.extensionIdentifier)||E.push($)}),E.length===0?void 0:E}function u(l,d){if(!d)return;const y=new Map;d.forEach($=>y.set($.extensionIdentifier,$));const E=[];return l.forEach($=>{const g=y.get($.extensionIdentifier);g&&($.type!==g.type||$.value!==g.value||$.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index)&&E.push(g)}),E.length===0?void 0:E}}),define(re[261],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=i,e.$gs=D,e.$hs=S,e.$is=A,e.$js=P,e.$ks=k;function i(u){return[...u.entries()]}function D(u){return u?[...u.entries()]:[]}function S(u){return new Map(u)}function A(u){return new Map(u??[])}function P(u){return Array.from(u.entries()).map(l=>[l[0],i(l[1].map),D(l[1].descriptionMap)])}function k(u){return new Map(u.map(l=>[l[0],{map:S(l[1]),descriptionMap:A(l[2])}]))}}),define(re[262],oe([0,1,8,23,3,2,5]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0;let k=class extends A.$Uc{constructor(l,d){super(),this.h=d,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$be),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,A.$Sc)(()=>{for(const y of this.f.values())(0,A.$Pc)(y)}))}createRequest(l){return new Promise((d,y)=>{const E=++this.a;this.c.set(E,d),this.g.fire({requestId:E,...l});const $=new D.$me;(0,i.$sh)(this.b,$.token).then(()=>y(`Request ${E} timed out (${this.b}ms)`)),this.f.set(E,[(0,A.$Sc)(()=>$.cancel())])})}acceptReply(l,d){const y=this.c.get(l);y?(this.c.delete(l),(0,A.$Pc)(this.f.get(l)||[]),this.f.delete(l),y(d)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$9r=k,e.$9r=k=Se([ie(1,P.$Xj)],k)}),define(re[129],oe([0,1,6,118,45]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=e.$3r=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$2r=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$1r=void 0,e.$1r=new D.$Ij("terminalTabFocusMode",!1,!0);var A;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var P;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(P||(e.TerminalSettingId=P={}));var k;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(k||(e.PosixShellType=k={}));var u;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(u||(e.WindowsShellType=u={}));var l;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var d;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(d||(e.TerminalIpcChannels=d={}));var y;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$2r=(0,i.$ri)("ptyService");var E;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E||(e.HeartbeatConstants=E={}));var $;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})($||(e.TerminalLocation=$={}));var g;(function(a){a.TerminalView="view",a.Editor="editor"})(g||(e.TerminalLocationString=g={}));var v;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var p;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var m;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(m||(e.ProfileSource=m={}));var f;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var h;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(h||(e.TerminalExitReason=h={})),e.$3r={Backend:"workbench.contributions.terminal.processBackend"};class w{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const r=this.b(t.remoteAuthority);if(this.a.has(r))throw new Error(`A terminal backend with remote authority '${r}' was already registered.`);this.a.set(r,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}S.$0n.add(e.$3r.Backend,new w),e.$4r=(0,i.$ri)("localPtyService"),e.$5r=(0,i.$ri)("terminalLogService")}),define(re[263],oe([0,1,75,7,190,106]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=P,e.$$r=l,e.$_r=d,e.$as=y;function P(E,$){const g=[{name:null,description:(0,S.localize)(0,null)}];return g.push(...E.map(v=>({name:v.profileName,description:k(v)}))),$&&g.push(...$.map(v=>({name:v.title,description:u(v)}))),{values:g.map(v=>v.name),markdownDescriptions:g.map(v=>v.description)}}function k(E){let $=`$(${A.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:i.$Qj.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?$+=`
- args: "${E.args}"`:$+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&($+=`
- overrideName: ${E.overrideName}`),E.color&&($+=`
- color: ${E.color}`),E.env&&($+=`
- env: ${JSON.stringify(E.env)}`),$}function u(E){return`$(${A.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:i.$Qj.terminal.id}) ${E.title}
- extensionIdentifier: ${E.extensionIdentifier}`}function l(E,$){if(!E&&!$)return!0;if(typeof E=="string"&&typeof $=="string")return E===$;if(Array.isArray(E)&&Array.isArray($)){if(E.length!==$.length)return!1;for(let g=0;g<E.length;g++)if(E[g]!==$[g])return!1;return!0}return!1}function d(E,$){if(!E&&!$)return!0;if(!E||!$)return!1;if(A.ThemeIcon.isThemeIcon(E)&&A.ThemeIcon.isThemeIcon($))return E.id===$.id&&E.color===$.color;if(typeof E=="object"&&"light"in E&&"dark"in E&&typeof $=="object"&&"light"in $&&"dark"in $){const g=E,v=$;if((D.URI.isUri(g.light)||y(g.light))&&(D.URI.isUri(g.dark)||y(g.dark))&&(D.URI.isUri(v.light)||y(v.light))&&(D.URI.isUri(v.dark)||y(v.dark)))return g.light.path===v.light.path&&g.dark.path===v.dark.path}if(D.URI.isUri(E)&&D.URI.isUri($)||y(E)||y($)){const g=E,v=$;return g.path===v.path&&g.scheme===v.scheme}return!1}function y(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}}),define(re[264],oe([0,1,75,4,189,52,45,263]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=void 0,e.$ds=$,e.$es=v,e.$bs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$cs={type:"string",enum:Array.from((0,i.$Oj)(),p=>p.id),markdownEnumDescriptions:Array.from((0,i.$Oj)(),p=>`$(${p.id})`)};const u={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$cs},color:{description:(0,S.localize)(3,null),...e.$bs},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...u}},d={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...u}};function y(p){const m=p===2?"linux":p===1?"osx":"windows";return(0,S.localize)(7,null,(0,D.$h)(p),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const E={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...u}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...u}},{type:"null"},l]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...u}},{type:"null"},l]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...u}},{type:"null"},l]}},"terminal.integrated.useWslProfiles":{description:(0,S.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,S.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,S.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function $(){P.$0n.as(A.$co.Configuration).registerConfiguration(E),v()}let g;function v(p,m){const f=P.$0n.as(A.$co.Configuration);let h;p&&(h=(0,k.$0r)(p?.profiles,m));const w=g;g={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:p?.os===3?h?.values:void 0,markdownEnumDescriptions:p?.os===3?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:p?.os===2?h?.values:void 0,markdownEnumDescriptions:p?.os===2?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:p?.os===1?h?.values:void 0,markdownEnumDescriptions:p?.os===1?h?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[g],remove:w?[w]:[]})}}),define(re[265],oe([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=g,e.$ns=v,e.$os=p;function g(){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let b=0;return c&&c.length===4&&(b=parseInt(c[3])),b}async function v(c,b,L,I=k.env,j=d.Promises.exists){if(A.$jc(c))return await j(c)?c:void 0;if(b===void 0&&(b=k.cwd()),A.$nc(c)!=="."){const F=A.$kc(b,c);return await j(F)?F:void 0}const R=(0,S.$5n)(I,"PATH");if(L===void 0&&(0,l.$5f)(R)&&(L=R.split(A.$uc)),L===void 0||L.length===0){const F=A.$kc(b,c);return await j(F)?F:void 0}for(const F of L){let T;if(A.$jc(F)?T=A.$kc(F,c):T=A.$kc(b,F,c),await j(T))return T;if(P.$i){let q=T+".com";if(await j(q)||(q=T+".exe",await j(q)))return q}}const W=A.$kc(b,c);return await j(W)?W:void 0}function p(c,b,L,I,j){const O=P.$i&&(!b.windowsEnableConpty||g()<18309);if(!b.shellIntegration.enabled||!c.executable||c.isFeatureTerminal&&!c.forceShellIntegration||c.ignoreShellIntegration||O)return;const R=c.args,W=k.$ec==="win32"?A.$oc(c.executable).toLowerCase():A.$oc(c.executable),F=A.$nc(D.$Lg.asFileUri("").fsPath);let T;const q={VSCODE_INJECTION:"1"};if(b.shellIntegration.nonce&&(q.VSCODE_NONCE=b.shellIntegration.nonce),P.$i){if(W==="pwsh.exe"||W==="powershell.exe")return!R||n(R)?T=h.get(f.WindowsPwsh):s(R)&&(T=h.get(f.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,u.$5e)(T[T.length-1],F,""),b.shellIntegration.suggestEnabled&&(q.VSCODE_SUGGEST="1"),{newArgs:T,envMixin:q}):void 0;if(W==="bash.exe")return!R||R.length===0?T=h.get(f.Bash):o(R)&&(q.VSCODE_SHELL_LOGIN="1",m(b,q),T=h.get(f.Bash)),T?(T=[...T],T[T.length-1]=(0,u.$5e)(T[T.length-1],F),{newArgs:T,envMixin:q}):void 0;I.warn(`Shell integration cannot be enabled for executable "${c.executable}" and args`,c.args);return}switch(W){case"bash":return!R||R.length===0?T=h.get(f.Bash):o(R)&&(q.VSCODE_SHELL_LOGIN="1",m(b,q),T=h.get(f.Bash)),T?(T=[...T],T[T.length-1]=(0,u.$5e)(T[T.length-1],F),{newArgs:T,envMixin:q}):void 0;case"fish":{const ue=L?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=A.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${ue}:${ee}`,m(b,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!R||n(R)?T=h.get(f.Pwsh):s(R)&&(T=h.get(f.PwshLogin)),T?(b.shellIntegration.suggestEnabled&&(q.VSCODE_SUGGEST="1"),T=[...T],T[T.length-1]=(0,u.$5e)(T[T.length-1],F,""),{newArgs:T,envMixin:q}):void 0;case"zsh":{if(!R||R.length===0?T=h.get(f.Zsh):o(R)?(T=h.get(f.ZshLogin),m(b,q)):(R===h.get(f.Zsh)||R===h.get(f.ZshLogin))&&(T=R),!T)return;T=[...T],T[T.length-1]=(0,u.$5e)(T[T.length-1],F);let ue;try{ue=i.userInfo().username}catch{ue="unknown"}const ee=A.$kc(i.tmpdir(),`${ue}-${j.applicationName}-zsh`);q.ZDOTDIR=ee;const ce=L?.ZDOTDIR??i.homedir()??"~";q.USER_ZDOTDIR=ce;const K=[];return K.push({source:A.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.$kc(ee,".zshrc")}),K.push({source:A.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.$kc(ee,".zprofile")}),K.push({source:A.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.$kc(ee,".zshenv")}),K.push({source:A.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.$kc(ee,".zlogin")}),{newArgs:T,envMixin:q,filesToCopy:K}}}I.warn(`Shell integration cannot be enabled for executable "${c.executable}" and args`,c.args)}function m(c,b){if(P.$j&&c.environmentVariableCollections){const L=(0,E.$ks)(c.environmentVariableCollections),j=new $.$ls(L).getVariableMap({workspaceFolder:c.workspaceFolder}).get("PATH"),O=[];if(j)for(const R of j)R.type===y.EnvironmentVariableMutatorType.Prepend&&O.push(R.value);O.length>0&&(b.VSCODE_PATH_PREFIX=O.join(""))}}var f;(function(c){c.WindowsPwsh="windows-pwsh",c.WindowsPwshLogin="windows-pwsh-login",c.Pwsh="pwsh",c.PwshLogin="pwsh-login",c.Zsh="zsh",c.ZshLogin="zsh-login",c.Bash="bash"})(f||(f={}));const h=new Map;h.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),h.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),h.set(f.Zsh,["-i"]),h.set(f.ZshLogin,["-il"]),h.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],a=["--login","-l"],t=["-i","--interactive"],r=["-nol","-nologo"];function s(c){return typeof c=="string"?w.includes(c.toLowerCase()):c.length===1&&w.includes(c[0].toLowerCase())||c.length===2&&(w.includes(c[0].toLowerCase())||w.includes(c[1].toLowerCase()))&&(r.includes(c[0].toLowerCase())||r.includes(c[1].toLowerCase()))}function n(c){return typeof c=="string"?r.includes(c.toLowerCase()):c.length===0||c?.length===1&&r.includes(c[0].toLowerCase())}function o(c){return typeof c!="string"&&(c=c.filter(b=>!t.includes(b.toLowerCase()))),c==="string"&&a.includes(c.toLowerCase())||typeof c!="string"&&c.length===1&&a.includes(c[0].toLowerCase())}}),define(re[266],oe([0,1,49,75,9,4,12,21,110,265,117]),function(J,e,i,D,S,A,P,k,u,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=g;var y;(function(c){c.UnixShellsPath="/etc/shells"})(y||(y={}));let E,$=!0;function g(c,b,L,I,j=process.env,O,R,W,F){return O=O||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},A.$i?v(L,O,j,R,I.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:I.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:I.getValue("terminal.integrated.defaultProfile.windows"),F,W):s(O,R,L,c&&typeof c=="object"?{...c}:I.getValue(A.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:I.getValue(A.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,W,j)}async function v(c,b,L,I,j,O,R,W,F){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),q=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let ue=!1;(0,l.$ms)()>=16299&&(ue=!0),await h(W);const ee=new Map;if(c){ee.set("PowerShell",{source:"PowerShell",icon:D.$Qj.terminalPowershell,isAutoDetected:!0}),ee.set("Windows PowerShell",{path:`${q}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.$Qj.terminalPowershell,isAutoDetected:!0}),ee.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ee.set("Command Prompt",{path:`${q}\\cmd.exe`,icon:D.$Qj.terminalCmd,isAutoDetected:!0}),ee.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ee.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:D.$Qj.terminalBash,isAutoDetected:!0});const K=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ee.set("Cmder",{path:`${q}\\cmd.exe`,args:["/K",K],requiresPath:process.env.CMDER_ROOT?K:{path:K,isUnsafe:!0},isAutoDetected:!0})}n(O,ee);const ce=await p(ee.entries(),R,b,L,I,F);if(c&&j)try{const K=await t(`${q}\\${ue?"wsl":"bash"}.exe`,R);for(const X of K)(!O||!(X.profileName in O))&&ce.push(X)}catch{$&&(I?.trace("WSL is not installed, so could not detect WSL profiles"),$=!1)}return ce}async function p(c,b,L,I=process.env,j,O){const R=[];for(const[W,F]of c)R.push(m(W,F,b,L,I,j,O));return(await Promise.all(R)).filter(W=>!!W)}async function m(c,b,L,I,j=process.env,O,R){if(b===null)return;let W,F,T;if("source"in b&&!("path"in b)){const ce=E?.get(b.source);if(!ce)return;W=ce.paths,F=b.args||ce.args,b.icon?T=f(b.icon):ce.icon&&(T=ce.icon)}else W=Array.isArray(b.path)?b.path:[b.path],F=A.$i||Array.isArray(b.args)?b.args:void 0,T=f(b.icon);let q;if(R){const ce=W.map(X=>typeof X=="string"?X:X.path),K=await R(ce);q=new Array(W.length);for(let X=0;X<W.length;X++)typeof W[X]=="string"?q[X]=K[X]:q[X]={path:K[X],isUnsafe:!0}}else q=W.slice();let ue;if(b.requiresPath){let ce;if((0,P.$5f)(b.requiresPath)?ce=b.requiresPath:(ce=b.requiresPath.path,b.requiresPath.isUnsafe&&(ue=ce)),!await I.existsFile(ce))return}const ee=await o(c,L,q,I,j,F,b.env,b.overrideName,b.isAutoDetected,ue);if(!ee){O?.debug("Terminal profile not validated",c,W);return}return ee.isAutoDetected=b.isAutoDetected,ee.icon=T,ee.color=b.color,ee}function f(c){return typeof c=="string"?{id:c}:c}async function h(c){if(E&&!c)return;const[b,L]=await Promise.all([w(),c||a()]);E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),E.set("PowerShell",{profileName:"PowerShell",paths:L,icon:D.$Qj.terminalPowershell})}async function w(){const c=new Set,b=await(0,l.$ns)("git.exe");if(b){const j=(0,d.dirname)(b);c.add((0,d.resolve)(j,"../.."))}function L(j,O){O&&j.add(O)}L(c,process.env.ProgramW6432),L(c,process.env.ProgramFiles),L(c,process.env["ProgramFiles(X86)"]),L(c,`${process.env.LocalAppData}\\Program`);const I=[];for(const j of c)I.push(`${j}\\Git\\bin\\bash.exe`,`${j}\\Git\\usr\\bin\\bash.exe`,`${j}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function a(){const c=[];for await(const b of(0,u.$fm)())c.push(b.exePath);return c}async function t(c,b){const L=[],I=await new Promise((R,W)=>{i.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,T)=>{if(F)return W("Problem occurred when getting wsl distros");R(T)})});if(!I)return[];const j=new RegExp(/[\r?\n]/),O=I.split(j).filter(R=>R.trim().length>0&&R!=="");for(const R of O){if(R===""||R.startsWith("docker-desktop"))continue;const W=`${R} (WSL)`,F={profileName:W,path:c,args:["-d",`${R}`],isDefault:W===b,icon:r(R),isAutoDetected:!1};L.push(F)}return L}function r(c){return c.includes("Ubuntu")?D.$Qj.terminalUbuntu:c.includes("Debian")?D.$Qj.terminalDebian:D.$Qj.terminalLinux}async function s(c,b,L,I,j,O,R,W){const F=new Map;if(L&&await c.existsFile("/etc/shells")){const T=(await c.readFile("/etc/shells")).toString(),q=(O||T.split(`
`)).map(ee=>{const ce=ee.indexOf("#");return ce===-1?ee:ee.substring(0,ce)}).filter(ee=>ee.trim().length>0),ue=new Map;for(const ee of q){let ce=(0,S.$oc)(ee),K=ue.get(ce)||0;K++,K>1&&(ce=`${ce} (${K})`),ue.set(ce,K),F.set(ce,{path:ee,isAutoDetected:!0})}}return n(I,F),await p(F.entries(),j,c,W,b,R)}function n(c,b){if(c)for(const[L,I]of Object.entries(c))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?b.delete(L):(I.icon=I.icon||b.get(L)?.icon,b.set(L,I))}async function o(c,b,L,I,j,O,R,W,F,T){if(L.length===0)return Promise.resolve(void 0);const q=L.shift();if(q==="")return o(c,b,L,I,j,O,R,W,F);const ue=typeof q!="string"&&q.isUnsafe,ee=typeof q=="string"?q:q.path,ce={profileName:c,path:ee,args:O,env:R,overrideName:W,isAutoDetected:F,isDefault:c===b,isUnsafePath:ue,requiresUnsafePath:T};if((0,S.$oc)(ee)===ee){const X=j.PATH?j.PATH.split(S.$uc):void 0,B=await(0,l.$ns)(ee,void 0,X,void 0,I.existsFile);return B?(ce.path=B,ce.isFromPath=!0,ce):o(c,b,L,I,j,O)}return await I.existsFile((0,S.$ic)(ee))?ce:o(c,b,L,I,j,O,R,W,F)}}),define(re[267],oe([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,73]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0;var p;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let m=class extends D.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(h,w,a,t){super(),this.M=h,this.N=w,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new i.$be),this.onPtyHostExit=this.u.event,this.w=this.B(new i.$be),this.onPtyHostStart=this.w.event,this.y=this.B(new i.$be),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new i.$be),this.onPtyHostResponsive=this.z.event,this.C=this.B(new i.$be),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new i.$be),this.onProcessData=this.D.event,this.F=this.B(new i.$be),this.onProcessReady=this.F.event,this.G=this.B(new i.$be),this.onProcessReplay=this.G.event,this.H=this.B(new i.$be),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new i.$be),this.onDidRequestDetach=this.I.event,this.J=this.B(new i.$be),this.onDidChangeProperty=this.J.event,this.L=this.B(new i.$be),this.onProcessExit=this.L.event,(0,E.$ds)(),this.B(this.M),this.B((0,D.$Sc)(()=>this.W())),this.j=this.B(new d.$9r(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&i.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$i)return process.env;try{return await(0,l.$Bm)(this.N,this.O,{_:[]},process.env)}catch(h){return this.O.error("ptyHost was unable to resolve shell environment",h),{}}}U(){const h=this.M.start(),w=h.client;this.O.getLevel()===k.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),A.ProxyChannel.toService(w.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(h.onDidProcessExit(r=>{this.u.fire(r.code),!this.m&&!this.q.isDisposed&&(this.n<=p.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${r.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const t=A.ProxyChannel.toService(w.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(r=>this.D.fire(r))),this.B(t.onProcessReady(r=>this.F.fire(r))),this.B(t.onProcessExit(r=>this.L.fire(r))),this.B(t.onDidChangeProperty(r=>this.J.fire(r))),this.B(t.onProcessReplay(r=>this.G.fire(r))),this.B(t.onProcessOrphanQuestion(r=>this.H.fire(r))),this.B(t.onDidRequestDetach(r=>this.I.fire(r))),this.B(new u.$8r(this.P,w.getChannel(y.TerminalIpcChannels.Logger))),this.a=h,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[h,t]}async createProcess(h,w,a,t,r,s,n,o,c,b,L){const I=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),j=await this.f.createProcess(h,w,a,t,r,s,n,o,c,b,L);return clearTimeout(I),j}updateTitle(h,w,a){return this.f.updateTitle(h,w,a)}updateIcon(h,w,a,t){return this.f.updateIcon(h,w,a,t)}attachToProcess(h){return this.f.attachToProcess(h)}detachFromProcess(h,w){return this.f.detachFromProcess(h,w)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(h){return this.f.start(h)}shutdown(h,w){return this.f.shutdown(h,w)}input(h,w){return this.f.input(h,w)}processBinary(h,w){return this.f.processBinary(h,w)}resize(h,w,a){return this.f.resize(h,w,a)}clearBuffer(h){return this.f.clearBuffer(h)}acknowledgeDataEvent(h,w){return this.f.acknowledgeDataEvent(h,w)}setUnicodeVersion(h,w){return this.f.setUnicodeVersion(h,w)}getInitialCwd(h){return this.f.getInitialCwd(h)}getCwd(h){return this.f.getCwd(h)}async getLatency(){const h=new v.$0d,w=await this.f.getLatency();return h.stop(),[{label:"ptyhostservice<->ptyhost",latency:h.elapsed()},...w]}orphanQuestionReply(h){return this.f.orphanQuestionReply(h)}installAutoReply(h,w){return this.f.installAutoReply(h,w)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(h){return this.f.uninstallAutoReply(h)}getDefaultSystemShell(h){return this.g?.getDefaultSystemShell(h)??(0,g.$lm)(h??S.OS,process.env)}async getProfiles(h,w,a,t=!1){const r=await this.S();return(0,$.$ps)(w,a,t,this.N,r,void 0,this.O,this.bb.bind(this,h))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(h,w){return this.f.getWslPath(h,w)}getRevivedPtyNewId(h,w){return this.f.getRevivedPtyNewId(h,w)}setTerminalLayoutInfo(h){return this.f.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return this.g?.getTerminalLayoutInfo(h)}async requestDetachInstance(h,w){return this.f.requestDetachInstance(h,w)}async acceptDetachInstanceReply(h,w){return this.f.acceptDetachInstanceReply(h,w)}async freePortKillProcess(h){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(h)}async serializeTerminalState(h){return this.f.serializeTerminalState(h)}async reviveTerminalProcesses(h,w,a){return this.f.reviveTerminalProcesses(h,w,a)}async refreshProperty(h,w){return this.f.refreshProperty(h,w)}async updateProperty(h,w,a){return this.f.updateProperty(h,w,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(h){this.ab(),this.s=setTimeout(()=>this.Y(),h?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(h,w){return this.j.createRequest({workspaceId:h,originalText:w})}async acceptPtyHostResolvedVariables(h,w){this.j.acceptReply(h,w)}};e.$qs=m,e.$qs=m=Se([ie(1,P.$Xi),ie(2,k.$Xj),ie(3,k.$Yj)],m)}),define(re[69],oe([0,1,14,3,2,4,18,6,34]),function(J,e,i,D,S,A,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=e.$cbc=void 0;const l="#FFFFFF",d="#1E1E1E",y="#000000",E="#FFFFFF",$="theme",g="themeBackground",v="windowSplash";e.$cbc=(0,k.$ri)("themeMainService");let p=class extends S.$Uc{constructor(f,h){super(),this.b=f,this.c=h,this.a=this.B(new D.$be),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(w=>{w.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(D.Event.fromNodeEventEmitter(i.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":i.nativeTheme.themeSource="dark";break;case"light":i.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":i.nativeTheme.themeSource="light";break;case"vs-dark":i.nativeTheme.themeSource="dark";break;default:i.nativeTheme.themeSource="system"}break;default:i.nativeTheme.themeSource="system";break}}getColorScheme(){if(A.$i){if(i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.$j){if(i.nativeTheme.shouldUseInvertedColorScheme||i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.$k&&i.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?y:E;let h=this.b.getItem(g,null);if(!h)switch(this.g()){case"vs":h=l;break;case"hc-black":h=y;break;case"hc-light":h=E;break;default:h=d}return A.$j&&h.toUpperCase()===d&&(h="#171717"),h}g(){switch(this.b.getItem($,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(f,h){this.b.setItems([{key:$,data:h.baseTheme},{key:g,data:h.colorInfo.background},{key:v,data:h}]),typeof f=="number"&&this.h(f,h),this.f()}h(f,h){for(const w of i.BrowserWindow.getAllWindows())if(w.id===f){w.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};e.$dbc=p,e.$dbc=p=Se([ie(0,u.$vQ),ie(1,P.$Xi)],p)}),define(re[130],oe([0,1,3,7,18,6,5]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$cw=e.$aw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$9v=e.$8v=void 0,e.$0v=l,e.$$v=y,e.$_v=E,e.$bw=$,e.$dw=g,e.$ew=v,e.$8v=(0,A.$ri)("tunnelService"),e.$9v=(0,A.$ri)("sharedTunnelsService");var k;(function(f){f.Http="http",f.Https="https"})(k||(e.TunnelProtocol=k={}));var u;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(u||(e.TunnelPrivacyId=u={}));function l(f){return!!f.forwardPort}var d;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(h)return{address:h[1],port:+h[2]}}function E(f){if(f.scheme!=="http"&&f.scheme!=="https"||!f.query)return;const h=f.query.split("&");for(const w of h){const a=w.split("=")[1];if(/^https?:/.exec(a)){const t=y(D.URI.parse(a));if(t)return t}}}e.$aw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function $(f){return e.$aw.indexOf(f)>=0}e.$cw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(f){return e.$cw.indexOf(f)>=0}function v(f,h,w,a){if(w===1)return!1;if(w===2&&g(h)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return f<1024}class p{constructor(h,w,a){this.remoteAddress=h,this.localAddress=w,this.b=a,this.a=new i.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$fw=p;let m=class{constructor(h,w){this.k=h,this.l=w,this.a=new i.$be,this.onTunnelOpened=this.a.event,this.b=new i.$be,this.onTunnelClosed=this.b.event,this.c=new i.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const h=this.l.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.i=h.privacyOptions,this.h=h.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const h=[],w=Array.from(this.e.values());for(const a of w){const t=Array.from(a.values());for(const r of t){const s=await r.value;s&&typeof s!="string"&&h.push(s)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:w}of h.values())await w.then(a=>typeof a!="string"?a?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,w,a,t,r){this.q(h,w,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:w,localAddress:a,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,w){(g(h)||$(h))&&(h=e.$aw[0]);const a=this.s(h,w);if(a)return++a.refcount,a.value}openTunnel(h,w,a,t,r,s=!1,n,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${a} on local port ${r}.`);const c=this.f??h;if(!c)return;if(w||(w="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.t(c,w,a,t,r,s,n,o);return b?b.then(L=>{if(L){if(typeof L=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(w,a),L}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(w,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.o(L);return(L.tunnelRemoteHost!==w||L.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&L.privacy!==n&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}o(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const w=this.e.get(h.tunnelRemoteHost);if(w){const a=w.get(h.tunnelRemotePort);a&&(a.refcount--,await this.p(h.tunnelRemoteHost,h.tunnelRemotePort,a))}}}}async p(h,w,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${w}.`);const t=a.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(w),t}}async closeTunnel(h,w){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${w} `);const a=this.e.get(h);if(a&&a.has(w)){const t=a.get(w);t.refcount=0,await this.p(h,w,t)}}q(h,w,a){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(w,{refcount:1,value:a})}async r(h,w){const a=this.e.get(h);if(a){const t=a.get(w),r=t?await t.value:void 0;(!r||typeof r=="string")&&a.delete(w),a.size===0&&this.e.delete(h)}}s(h,w){const a=[h];$(h)?(a.push(...e.$aw),a.push(...e.$cw)):g(h)&&a.push(...e.$cw);const t=a.map(r=>this.e.get(r));for(const r of t){const s=r?.get(w);if(s)return s}}canTunnel(h){return!!y(h)}u(h,w,a,t,r,s,n){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${a} on local port ${t}.`);const o=a;this.j.add(o);const c=t===void 0?a:t,b={elevationRequired:r?this.isPortPrivileged(c):!1},L={remoteAddress:{host:w,port:a},localAddressPort:t,privacy:s,public:s?s!==u.Private:void 0,protocol:n},I=h.forwardPort(L,b);return I?(this.q(w,a,I),I.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),I}};e.$gw=m,e.$gw=m=Se([ie(0,P.$Xj),ie(1,S.$Xi)],m)}),define(re[50],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FX=e.$EX=e.DisablementReason=e.UpdateType=e.StateType=void 0;var D;(function(P){P.Uninitialized="uninitialized",P.Idle="idle",P.Disabled="disabled",P.CheckingForUpdates="checking for updates",P.AvailableForDownload="available for download",P.Downloading="downloading",P.Downloaded="downloaded",P.Updating="updating",P.Ready="ready"})(D||(e.StateType=D={}));var S;(function(P){P[P.Setup=0]="Setup",P[P.Archive=1]="Archive",P[P.Snap=2]="Snap"})(S||(e.UpdateType=S={}));var A;(function(P){P[P.NotBuilt=0]="NotBuilt",P[P.DisabledByEnvironment=1]="DisabledByEnvironment",P[P.ManuallyDisabled=2]="ManuallyDisabled",P[P.MissingConfiguration=3]="MissingConfiguration",P[P.InvalidConfiguration=4]="InvalidConfiguration",P[P.RunningAsAdmin=5]="RunningAsAdmin"})(A||(e.DisablementReason=A={})),e.$EX={Uninitialized:{type:"uninitialized"},Disabled:P=>({type:"disabled",reason:P}),Idle:(P,k)=>({type:"idle",updateType:P,error:k}),CheckingForUpdates:P=>({type:"checking for updates",explicit:P}),AvailableForDownload:P=>({type:"available for download",update:P}),Downloading:{type:"downloading"},Downloaded:P=>({type:"downloaded",update:P}),Updating:P=>({type:"updating",update:P}),Ready:P=>({type:"ready",update:P})},e.$FX=(0,i.$ri)("updateService")}),define(re[268],oe([0,1,4,191,52,45]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.$0n.as(S.$co.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:i.$i&&!i.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(re[269],oe([0,1,3,50]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=void 0;class S{constructor(k){this.a=k}listen(k,u){switch(u){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${u}`)}call(k,u,l){switch(u){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${u}`)}}e.$occ=S;class A{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new i.$be,this.onStateChange=this.a.event,this.b=D.$EX.Uninitialized,this.c.listen("onStateChange")(u=>this.state=u),this.c.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.$pcc=A}),define(re[40],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=void 0,e.$vl=(0,i.$ri)("IUriIdentityService")}),define(re[270],oe([0,1,40,210,16,19,142,3,2]),function(J,e,i,D,S,A,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0;class l{static{this._clock=0}constructor(E){this.uri=E,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let d=class{constructor(E){this.g=E,this.c=new u.$Tc,this.f=2**16;const $=new Map,g=v=>{let p=$.get(v.scheme);return p===void 0&&(p=E.hasProvider(v)&&!this.g.hasCapability(v,1024),$.set(v.scheme,p)),p};this.c.add(k.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(v=>{$.delete(v.scheme)})),this.extUri=new A.$Tg(g),this.d=new P.$ts((v,p)=>this.extUri.compare(v,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(E){this.g.hasProvider(E)&&(E=(0,A.$6g)(E));const $=this.d.get(E);return $?$.touch().uri.with({fragment:E.fragment}):(this.d.set(E,new l(E)),this.h(),E)}h(){if(this.d.size<this.f)return;const E=[...this.d.entries()].sort((g,v)=>g[1].time<v[1].time?1:g[1].time>v[1].time?-1:0);l._clock=0,this.d.clear();const $=this.f*.5;for(let g=0;g<$;g++)this.d.set(E[g][0],E[g][1].touch())}};e.$us=d,e.$us=d=Se([ie(0,S.$Xk)],d),(0,D.$rs)(i.$vl,d,1)}),define(re[131],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vX=void 0,e.$vX=(0,i.$ri)("urlService")}),define(re[271],oe([0,1,7]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=e.$wcc=void 0;class D{constructor(k){this.a=k}listen(k,u){throw new Error(`Event not found: ${u}`)}call(k,u,l){switch(u){case"handleURL":return this.a.handleURL(i.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${u}`)}}e.$wcc=D;class S{constructor(k){this.a=k}handleURL(k,u){return this.a.call("handleURL",[k.toJSON(),u])}}e.$xcc=S;class A{constructor(k,u){this.a=k,this.b=u}async routeCall(k,u,l,d){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(Array.isArray(l)&&l.length>0){const y=i.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",y.toString(!0)),y.query){const E=/\bwindowId=(\d+)/.exec(y.query);if(E){const $=E[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${$}"`,y.toString(!0));const g=new RegExp(`window:${$}`),v=k.connections.find(p=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),g.test(p.ctx)));if(v)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",y.toString(!0)),v;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",y.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",y.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(k,u,l,d)}routeEvent(k,u){throw new Error(`Event not found: ${u}`)}}e.$ycc=A}),define(re[272],oe([0,1,8,2,7,27]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xX=e.$wX=void 0;class P extends D.$Uc{constructor(){super(...arguments),this.a=new Set}open(l,d){const y=[...this.a.values()];return(0,i.$vh)(y.map(E=>()=>E.handleURL(l,d)),void 0,!1).then(E=>E||!1)}registerHandler(l){return this.a.add(l),(0,D.$Sc)(()=>this.a.delete(l))}}e.$wX=P;let k=class extends P{constructor(l){super(),this.b=l}create(l){let{authority:d,path:y,query:E,fragment:$}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return d&&y&&y.indexOf("/")!==0&&(y=`/${y}`),S.URI.from({scheme:this.b.urlProtocol,authority:d,path:y,query:E,fragment:$})}};e.$xX=k,e.$xX=k=Se([ie(0,A.$ek)],k)}),define(re[273],oe([0,1,14,8,3,2,4,7]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class u extends A.$Uc{constructor(d,y,E,$,g,v){if(super(),this.c=y,this.f=v,this.a=[],this.b=0,d&&(v.trace("ElectronURLListener initialUrisToHandle:",d.map(f=>f.originalUrl)),this.a=d),P.$i){const f=$.isBuilt?[]:[`"${$.appRoot}"`];f.push("--open-url","--"),i.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,f)}const p=S.Event.map(S.Event.fromNodeEventEmitter(i.app,"open-url",(f,h)=>({event:f,url:h})),({event:f,url:h})=>(f.preventDefault(),h));this.B(p(f=>{const h=this.g(f);h&&this.c.open(h,{originalUrl:f})})),E.getWindows().filter(f=>f.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(S.Event.once(E.onDidSignalReadyWindow)(()=>this.h())))}g(d){try{return k.URI.parse(d)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const d=[];for(const y of this.a)await this.c.open(y.uri,{originalUrl:y.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",y.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",y.originalUrl),d.push(y));d.length!==0&&(this.a=d,(0,D.$th)(()=>this.h(),500,this.q))}}e.$zcc=u}),define(re[274],oe([0,1,3,2,16,59,31]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;class k extends D.$Uc{constructor(l,d,y,E,$,g){super(),this.f=l,this.g=d,this.h=y,this.j=E,this.m=$,this.n=g,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new i.$be),this.onDidChangeFile=this.a.event,this.b=A.$xi.forUris(()=>!(this.capabilities&1024)),this.c=new P.$Cc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(E.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,d){return this.g.open(this.t(l),d)}close(l){return this.g.close(l)}read(l,d,y,E,$){return this.g.read(l,d,y,E,$)}write(l,d,y,E,$){return this.g.write(l,d,y,E,$)}watch(l,d){this.b.set(l,l);const y=this.g.watch(this.t(l),d);return(0,D.$Sc)(()=>{this.b.delete(l),y.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,d,y){return this.g.rename(this.t(l),this.t(d),y)}readFile(l,d){return this.g.readFile(this.t(l),d)}readFileStream(l,d,y){return this.g.readFileStream(this.t(l),d,y)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,d,y){return this.g.writeFile(this.t(l),d,y)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,d){return this.g.delete(this.t(l),d)}copy(l,d,y){if((0,S.$2k)(this.g))return this.g.copy(this.t(l),this.t(d),y);throw new Error("copy not supported")}cloneFile(l,d){if((0,S.$3k)(this.g))return this.g.cloneFile(this.t(l),this.t(d));throw new Error("clone not supported")}s(l){const d=[];for(const y of l){if(y.resource.scheme!==this.f)continue;const E=this.u(y.resource);this.b.findSubstr(E)&&d.push({resource:E,type:y.type,cId:y.cId})}d.length&&(this.n.debug("User data changed"),this.a.fire(d))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$adc=k}),define(re[275],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0,e.$Tcc="utilityProcessWorker"}),define(re[276],oe([0,1,6]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0,e.$Acc=(0,i.$ri)("webviewManagerService")}),define(re[277],oe([0,1,14,2,13,7]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class P extends D.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const u=this.b.bind(this);i.protocol.registerFileProtocol(S.Schemas.vscodeWebview,u)}b(u,l){try{const d=A.URI.parse(u.url),y=P.a.get(d.path);if(typeof y=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${y}`,$=S.$Lg.asFileUri(E);return l({path:$.fsPath,headers:{...S.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$Bcc=P}),define(re[55],oe([0,1,4]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$nD=void 0,e.$oD=D,e.$pD=S,e.$qD=A,e.$rD=P,e.$sD=k,e.$tD=y,e.$uD=E,e.$vD=$,e.$wD=g,e.$xD=v,e.$yD=p,e.$nD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(m){return typeof m.parentId=="number"}function S(m){return!!m.workspaceUri}function A(m){return!!m.folderUri}function P(m){return!!m.fileUri}function k(m){const f=E(m),h=m.getValue("window.menuBarVisibility");return h==="default"||f&&h==="compact"||i.$j&&i.$m?"classic":h}var u;(function(m){m.TITLE_BAR_STYLE="window.titleBarStyle",m.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(u||(e.TitleBarSetting=u={}));var l;(function(m){m.NATIVE="native",m.CUSTOM="custom"})(l||(e.TitlebarStyle=l={}));var d;(function(m){m.AUTO="auto",m.WINDOWED="windowed",m.NEVER="never"})(d||(e.CustomTitleBarVisibility=d={}));function y(m,f){return!0}function E(m,f){return f||(f=$(m)),f==="native"}function $(m){if(i.$o)return"custom";const f=m.getValue("window");if(f){if(i.$j&&f.nativeTabs===!0||i.$j&&f.nativeFullScreen===!1)return"native";const a=f.titleBarStyle;if(a==="native"||a==="custom")return a}return i.$k?"native":"custom"}function g(m){return!(!i.$i||i.$o||E(m))}function v(m){const f=m.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}function p(m=0){return Math.pow(1.2,m)}}),define(re[82],oe([0,1,14]),function(J,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$5ac=e.$4ac=e.UnloadReason=e.LoadReason=void 0;var D;(function(l){l[l.INITIAL=1]="INITIAL",l[l.LOAD=2]="LOAD",l[l.RELOAD=3]="RELOAD"})(D||(e.LoadReason=D={}));var S;(function(l){l[l.CLOSE=1]="CLOSE",l[l.QUIT=2]="QUIT",l[l.RELOAD=3]="RELOAD",l[l.LOAD=4]="LOAD"})(S||(e.UnloadReason=S={}));const A=function(l=1){return{width:1024,height:768,mode:l}};e.$4ac=A;const P=function(){const y=i.screen.getPrimaryDisplay().workArea,E=Math.max(y.x+y.width/2-800/2,0),$=Math.max(y.y+y.height/2-600/2,0);return{x:E,y:$,width:800,height:600,mode:1}};e.$5ac=P;var k;(function(l){l[l.Maximized=0]="Maximized",l[l.Normal=1]="Normal",l[l.Minimized=2]="Minimized",l[l.Fullscreen=3]="Fullscreen"})(k||(e.WindowMode=k={}));var u;(function(l){l[l.UNRESPONSIVE=1]="UNRESPONSIVE",l[l.PROCESS_GONE=2]="PROCESS_GONE",l[l.LOAD=3]="LOAD"})(u||(e.WindowError=u={}))}),define(re[278],oe([0,1,8,3,2]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class A extends S.$Uc{constructor({onDidOpenMainWindow:k,onDidFocusMainWindow:u,getActiveWindowId:l}){super(),this.a=this.B(new S.$Tc),D.Event.latch(D.Event.any(k,u))(this.f,this,this.a),this.b=(0,i.$eh)(()=>l()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Hcc=A}),define(re[30],oe([0,1,195,9,59,19,7,6,13]),function(J,e,i,D,S,A,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Li=e.$Ki=e.WorkbenchState=e.$Ei=e.$Di=e.$Ai=void 0,e.$Bi=l,e.$Ci=d,e.$Fi=y,e.$Gi=E,e.$Hi=$,e.$Ii=v,e.$Ji=p,e.$Mi=h,e.$Ri=w,e.$Si=a,e.$Ui=t,e.$Vi=r,e.$Wi=s,e.$Ai=(0,k.$ri)("contextService");function l(n){const o=n;return typeof o?.id=="string"&&P.URI.isUri(o.uri)}function d(n){return typeof n?.id=="string"&&!l(n)&&!E(n)}e.$Di={id:"ext-dev"},e.$Ei={id:"empty-window"};function y(n,o){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.$oc)(n)}:o?e.$Di:e.$Ei;const c=n;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}function E(n){const o=n;return typeof o?.id=="string"&&P.URI.isUri(o.configPath)}function $(n){const o=n;if(o?.uri)return{id:o.id,uri:P.URI.revive(o.uri)};const c=n;if(c?.configPath)return{id:c.id,configPath:P.URI.revive(c.configPath)};if(n?.id)return{id:n.id}}var g;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function v(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}function p(n){const o=n;return!!(o&&typeof o=="object"&&P.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}class m{constructor(o,c,b,L,I){this.h=o,this.j=b,this.k=L,this.l=I,this.c=S.$xi.forUris(this.l,()=>!0),this.folders=c}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=S.$xi.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ki=m;class f{constructor(o,c){this.raw=c,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,A.$5g)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Li=f;function h(n){return new f({uri:n,index:0,name:(0,A.$1g)(n)},{uri:n.toString()})}e.$Ni="code-workspace",e.$Oi=`.${e.$Ni}`,e.$Pi=[{name:(0,i.localize)(0,null),extensions:[e.$Ni]}],e.$Qi="workspace.json";function w(n,o){return A.$Vg.isEqualOrParent(n,o.untitledWorkspacesHome)}function a(n){let o;return P.URI.isUri(n)?o=n:o=n.configuration,o?.scheme===u.Schemas.tmp}e.$Ti="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$Ti}function r(n,o){return!w(n,o)&&!a(n)}function s(n){return(typeof n=="string"?(0,D.$pc)(n):(0,A.$3g)(n))===e.$Oi}}),define(re[56],oe([0,1,14,8,46,48,2,72,4,21,169,119,6,5,27,30]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=e.$_ac=void 0,e.$_ac=(0,E.$ri)("dialogMainService");let p=class{constructor(f,h){this.d=f,this.e=h,this.a=new Map,this.b=new Map,this.c=new D.$yh}pickFileFolder(f,h){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,d.localize)(0,null)},h)}pickFolder(f,h){return this.f({...f,pickFolders:!0,title:(0,d.localize)(1,null)},h)}pickFile(f,h){return this.f({...f,pickFiles:!0,title:(0,d.localize)(2,null)},h)}pickWorkspace(f,h){const w=(0,d.localize)(3,null),a=(0,A.$xw)((0,d.localize)(4,null)),t=v.$Pi;return this.f({...f,pickFiles:!0,title:w,filters:t,buttonLabel:a},h)}async f(f,h){const w={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(w.properties=void 0,f.pickFiles&&f.pickFolders&&(w.properties=["multiSelections","openDirectory","openFile","createDirectory"])),w.properties||(w.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),u.$j&&w.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(w,(h||i.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(f){if(f){let h=this.b.get(f.id);return h||(h=new D.$yh,this.b.set(f.id,h)),h}else return this.c}showMessageBox(f,h){return this.g(h).queue(async()=>{const{options:w,buttonIndeces:a}=(0,y.$Ew)(f,this.e);let t;return h?t=await i.dialog.showMessageBox(h,w):t=await i.dialog.showMessageBox(w),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,h){const w=this.j(f,h);if(!w)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(h).queue(async()=>{let a;return h?a=await i.dialog.showSaveDialog(h,f):a=await i.dialog.showSaveDialog(f),a.filePath=this.h(a.filePath),a})}finally{(0,P.$Pc)(w)}}h(f){return f&&u.$j&&(f=(0,k.$9l)(f)),f}i(f){return f.map(h=>this.h(h))}async showOpenDialog(f,h){f.defaultPath&&(await l.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const w=this.j(f,h);if(!w)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(h).queue(async()=>{let a;return h?a=await i.dialog.showOpenDialog(h,f):a=await i.dialog.showOpenDialog(f),a.filePaths=this.i(a.filePaths),a})}finally{(0,P.$Pc)(w)}}j(f,h){if(!h)return P.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let w=this.a.get(h.id);w||(w=new Set,this.a.set(h.id,w));const a=(0,S.$fj)(f);if(!w.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",f),w.add(a),(0,P.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),w?.delete(a),w?.size===0&&this.a.delete(h.id)})}};e.$abc=p,e.$abc=p=Se([ie(0,$.$Xj),ie(1,g.$ek)],p)}),define(re[279],oe([0,1,3,2,77,30]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class P extends D.$Uc{static{this.a=100}constructor(u,l){super(),this.f=u,this.g=l,this.b=this.B(new i.$be),this.c=new Map,this.h(l.applicationStorage,this.b)}h(u,l){this.B(i.Event.debounce(u.onDidChangeStorage,(d,y)=>(d?d.push(y):d=[y],d),P.a)(d=>{d.length&&l.fire(this.j(d,u))}))}j(u,l){const d=new Map,y=new Set;return u.forEach(E=>{const $=l.get(E.key);typeof $=="string"?d.set(E.key,$):y.add(E.key)}),{changed:Array.from(d.entries()),deleted:Array.from(y.values())}}listen(u,l,d){switch(l){case"onDidChangeStorage":{const y=d.profile?(0,S.$1h)(d.profile):void 0;if(!y)return this.b.event;let E=this.c.get(y.id);return E||(E=this.B(new i.$be),this.h(this.g.profileStorage(y),E),this.c.set(y.id,E)),E.event}}throw new Error(`Event not found: ${l}`)}async call(u,l,d){const y=d.profile?(0,S.$1h)(d.profile):void 0,E=(0,A.$Hi)(d.workspace),$=await this.m(y,E);switch(l){case"getItems":return Array.from($.items.entries());case"updateItems":{const g=d;if(g.insert)for(const[v,p]of g.insert)$.set(v,p);g.delete?.forEach(v=>$.delete(v));break}case"optimize":return $.optimize();case"isUsed":{const g=d.payload;if(typeof g=="string")return this.g.isUsed(g)}default:throw new Error(`Call not found: ${l}`)}}async m(u,l){let d;l?d=this.g.workspaceStorage(l):u?d=this.g.profileStorage(u):d=this.g.applicationStorage;try{await d.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":u?"profile":"application"} storage due to ${y}`)}return d}}e.$lcc=P}),define(re[41],oe([0,1,46,3,2,19,7,192,38,16,6,5,30,31,40,8,33,25,12]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.$xl=e.ProfileResourceType=void 0,e.$wl=w,e.$yl=a,e.$zl=t;var h;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function w(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&P.URI.isUri(o.location)&&P.URI.isUri(o.globalStorageHome)&&P.URI.isUri(o.settingsResource)&&P.URI.isUri(o.keybindingsResource)&&P.URI.isUri(o.tasksResource)&&P.URI.isUri(o.snippetsHome)&&P.URI.isUri(o.extensionsResource))}e.$xl=(0,d.$ri)("IUserDataProfilesService");function a(n,o){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:P.URI.revive(n.location).with({scheme:o}),globalStorageHome:P.URI.revive(n.globalStorageHome).with({scheme:o}),settingsResource:P.URI.revive(n.settingsResource).with({scheme:o}),keybindingsResource:P.URI.revive(n.keybindingsResource).with({scheme:o}),tasksResource:P.URI.revive(n.tasksResource).with({scheme:o}),snippetsHome:P.URI.revive(n.snippetsHome).with({scheme:o}),extensionsResource:P.URI.revive(n.extensionsResource).with({scheme:o}),cacheHome:P.URI.revive(n.cacheHome).with({scheme:o}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function t(n,o,c,b,L,I){return{id:n,name:o,location:c,isDefault:!1,shortName:L?.shortName,icon:L?.icon,globalStorageHome:I&&L?.useDefaultFlags?.globalState?I.globalStorageHome:(0,A.$5g)(c,"globalStorage"),settingsResource:I&&L?.useDefaultFlags?.settings?I.settingsResource:(0,A.$5g)(c,"settings.json"),keybindingsResource:I&&L?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,A.$5g)(c,"keybindings.json"),tasksResource:I&&L?.useDefaultFlags?.tasks?I.tasksResource:(0,A.$5g)(c,"tasks.json"),snippetsHome:I&&L?.useDefaultFlags?.snippets?I.snippetsHome:(0,A.$5g)(c,"snippets"),extensionsResource:I&&L?.useDefaultFlags?.extensions?I.extensionsResource:(0,A.$5g)(c,"extensions.json"),cacheHome:(0,A.$5g)(b,n),useDefaultFlags:L?.useDefaultFlags,isTransient:L?.transient}}let r=class extends S.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(o,c,b,L){super(),this.t=o,this.u=c,this.w=b,this.y=L,this.f=!0,this.h=this.B(new D.$be),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$be),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$be),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$be),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new $.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$5g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$5g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(o){this.f!==o&&(this.z=void 0,this.f=o)}isEnabled(){return this.f}get C(){if(!this.z){const o=this.D(),c=[o];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,f.$5f)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}c.push(t((0,A.$2g)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},o))}}catch(I){this.y.error(I)}const b=new $.$Bc,L=new Map;if(c.length)try{const I=this.Q();if(I.workspaces)for(const[j,O]of Object.entries(I.workspaces)){const R=P.URI.parse(j),W=c.find(F=>F.id===O);W&&b.set(R,W)}if(I.emptyWindows)for(const[j,O]of Object.entries(I.emptyWindows)){const R=c.find(W=>W.id===O);R&&L.set(j,R)}}catch(I){this.y.error(I)}this.z={profiles:c,workspaces:b,emptyWindows:L}}return this.z}D(){const o=t("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...o,extensionsResource:this.S()??o.extensionsResource,isDefault:!0}}async createTransientProfile(o){const c="Temp",b=new RegExp(`${(0,m.$9e)(c)}\\s(\\d+)`);let L=0;for(const j of this.profiles){const O=b.exec(j.name),R=O?parseInt(O[1]):0;L=R>L?R:L}const I=`${c} ${L+1}`;return this.createProfile((0,i.$fj)((0,p.$Ng)()).toString(16),I,{transient:!0},o)}async createNamedProfile(o,c,b){return this.createProfile((0,i.$fj)((0,p.$Ng)()).toString(16),o,c,b)}async createProfile(o,c,b,L){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(o,c,b);return L&&await this.setProfileForWorkspace(L,I),I}async F(o,c,b){if(!(0,f.$5f)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let L=this.r.get(c);return L||(L=(async()=>{try{if(this.profiles.find(R=>R.name===c||R.id===o))throw new Error(`Profile with ${c} name already exists`);const j=t(o,c,(0,A.$5g)(this.profilesHome,o),this.g,b,this.defaultProfile);await this.u.createFolder(j.location);const O=[];return this.j.fire({profile:j,join(R){O.push(R)}}),await v.Promises.settled(O),this.I([j],[],[]),j}finally{this.r.delete(c)}})(),this.r.set(c,L)),L}async updateProfile(o,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(L=>L.id===o.id);if(!b)throw new Error(`Profile '${o.name}' does not exist`);return b=t(b.id,c.name??b.name,b.location,this.g,{shortName:c.shortName??b.shortName,icon:c.icon===null?void 0:c.icon??b.icon,transient:c.transient??b.isTransient,useDefaultFlags:c.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(o.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(L=>L.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);const b=[];this.m.fire({profile:c,join(L){b.push(L)}});try{await Promise.allSettled(b)}catch(L){this.y.error(L)}for(const L of[...this.C.emptyWindows.keys()])c.id===this.C.emptyWindows.get(L)?.id&&this.C.emptyWindows.delete(L);for(const L of[...this.C.workspaces.keys()])c.id===this.C.workspaces.get(L)?.id&&this.C.workspaces.delete(L);this.M(),this.I([],[c],[]);try{await this.u.del(c.cacheHome,{recursive:!0})}catch(L){(0,l.$cl)(L)!==1&&this.y.error(L)}}async setProfileForWorkspace(o,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(L=>L.id===c.id);if(!b)throw new Error(`Profile '${c.name}' does not exist`);this.L(o,b)}unsetWorkspace(o,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(o,void 0,c)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const o=await this.u.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(c=>c.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,c.resource))).map(c=>this.u.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.s.profiles.filter(c=>!this.H(c));await Promise.allSettled(o.map(c=>this.removeProfile(c)))}getProfileForWorkspace(o){const c=this.G(o);return P.URI.isUri(c)?this.s.workspaces.get(c)??this.C.workspaces.get(c):this.s.emptyWindows.get(c)??this.C.emptyWindows.get(c)}G(o){return(0,E.$Bi)(o)?o.uri:(0,E.$Gi)(o)?o.configPath:o.id}H(o){return!!([...this.s.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,o.location))||[...this.s.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,o.location))||[...this.C.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,o.location))||[...this.C.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,o.location)))}I(o,c,b){const L=[...this.profiles,...o],I=[];this.s.profiles=[];for(let j of L)j.isDefault||c.some(O=>j.id===O.id)||(j=b.find(O=>j.id===O.id)??j,j.isTransient?this.s.profiles.push(j):I.push({location:j.location,name:j.name,shortName:j.shortName,icon:j.icon,useDefaultFlags:j.useDefaultFlags}));this.P(I),this.z=void 0,this.J(o,c,b)}J(o,c,b){this.h.fire({added:o,removed:c,updated:b,all:this.profiles})}L(o,c,b){b=c?.isTransient?!0:b,b||this.L(o,void 0,!0);const L=this.G(o),I=b?this.s:this.C;P.URI.isUri(L)?(I.workspaces.delete(L),c&&I.workspaces.set(L,c)):(I.emptyWindows.delete(L),c&&I.emptyWindows.set(L,c)),b||this.M()}M(){const o={};for(const[b,L]of this.C.workspaces.entries())o[b.toString()]=L.id;const c={};for(const[b,L]of this.C.emptyWindows.entries())c[b.toString()]=L.id;this.R({workspaces:o,emptyWindows:c}),this.z=void 0}N(o){const c={},b=this.D();if(o.workspaces)for(const[I,j]of Object.entries(o.workspaces)){const O=P.URI.parse(j);c[I]=this.w.extUri.isEqual(O,b.location)?b.id:this.w.extUri.basename(O)}const L={};if(o.emptyWindows)for(const[I,j]of Object.entries(o.emptyWindows)){const O=P.URI.parse(j);L[I]=this.w.extUri.isEqual(O,b.location)?b.id:this.w.extUri.basename(O)}return{workspaces:c,emptyWindows:L}}O(){return[]}P(o){throw new Error("not implemented")}Q(){return{}}R(o){throw new Error("not implemented")}S(){}};e.$Al=r,e.$Al=r=Se([ie(0,u.$yi),ie(1,l.$Xk),ie(2,g.$vl),ie(3,y.$Xj)],r);class s extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(o){this.a=o}Q(){return this.X}R(o){this.X=o}}e.$Bl=s}),define(re[83],oe([0,1,8,17,2,3,31,7,121,127,16,6,5,41,40,12,15,28]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class h extends Error{constructor(s,n){super(s),this.code=n}}e.$jq=h,e.$kq=(0,y.$ri)("IExtensionsProfileScannerService");let w=class extends S.$Uc{constructor(s,n,o,c,b,L){super(),this.j=s,this.m=n,this.n=o,this.r=c,this.s=b,this.t=L,this.b=this.B(new A.$be),this.onAddExtensions=this.b.event,this.c=this.B(new A.$be),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$be),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$be),this.onDidRemoveExtensions=this.g.event,this.h=new P.$Bc}scanProfileExtensions(s,n){return this.u(s,void 0,n)}async addExtensionsToProfile(s,n,o){const c=[],b=[];try{return await this.u(n,L=>{const I=[];if(o)I.push(...L);else for(const j of L)s.some(([O])=>(0,l.$pp)(O.identifier,j.identifier)&&O.manifest.version!==j.version)?c.push(j):I.push(j);for(const[j,O]of s){const R=I.findIndex(F=>(0,l.$pp)(F.identifier,j.identifier)&&F.version===j.manifest.version),W={identifier:j.identifier,version:j.manifest.version,location:j.location,metadata:O};R===-1?(b.push(W),I.push(W)):I.splice(R,1,W)}return b.length&&this.b.fire({extensions:b,profileLocation:n}),c.length&&this.f.fire({extensions:c,profileLocation:n}),I}),b.length&&this.c.fire({extensions:b,profileLocation:n}),c.length&&this.g.fire({extensions:c,profileLocation:n}),b}catch(L){throw b.length&&this.c.fire({extensions:b,error:L,profileLocation:n}),c.length&&this.g.fire({extensions:c,error:L,profileLocation:n}),L}}async updateMetadata(s,n){const o=[];return await this.u(n,c=>{const b=[];for(const L of c){const I=s.find(([j])=>(0,l.$pp)(j.identifier,L.identifier)&&j.manifest.version===L.version);I&&(L.metadata={...L.metadata,...I[1]},o.push(L)),b.push(L)}return b}),o}async removeExtensionFromProfile(s,n){const o=[];try{await this.u(n,c=>{const b=[];for(const L of c)(0,l.$pp)(L.identifier,s.identifier)?o.push(L):b.push(L);return o.length&&this.f.fire({extensions:o,profileLocation:n}),b}),o.length&&this.g.fire({extensions:o,profileLocation:n})}catch(c){throw o.length&&this.g.fire({extensions:o,error:c,profileLocation:n}),c}}async u(s,n,o){return this.F(s).queue(async()=>{let c=[],b;try{const L=await this.m.readFile(s);b=JSON.parse(L.value.toString().trim()||"[]")}catch(L){if((0,d.$cl)(L)!==1)throw L;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&o?.bailOutWhenFileNotFound)throw new h((0,p.$0)(L),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(s);let L=!1;for(const I of b){a(I)||this.w(s);let j;if((0,v.$5f)(I.relativeLocation)&&I.relativeLocation)j=this.z(I.relativeLocation);else if((0,v.$5f)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{j=k.URI.revive(I.location);const O=this.y(j);O&&(L=!0,I.relativeLocation=O)}(0,v.$_f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(L=!0,I.metadata.hasPreReleaseVersion=!0),c.push({identifier:I.identifier,location:j,version:I.version,metadata:I.metadata})}L&&await this.m.writeFile(s,D.$Ce.fromString(JSON.stringify(b)))}if(n){c=n(c);const L=c.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(s,D.$Ce.fromString(JSON.stringify(L)))}return c})}w(s){const n=new h(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let o;try{o=(await this.m.readFile(s)).value.toString()}catch(b){if((0,d.$cl)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",s.toString());let c;try{const b=JSON.parse(o);Array.isArray(b)&&b.every(L=>a(L))?c=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(c)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$Ce.fromString(JSON.stringify(c)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,d.$cl)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(s)}catch(b){(0,d.$cl)(b)!==1&&this.t.error(b)}try{await this.m.del(n)}catch(b){(0,d.$cl)(b)!==1&&this.t.error(b)}return c})()),this.C}F(s){let n=this.h.get(s);return n||(n=new i.$yh,this.h.set(s,n)),n}};e.$lq=w,e.$lq=w=Se([ie(1,d.$Xk),ie(2,$.$xl),ie(3,g.$vl),ie(4,m.$Wl),ie(5,E.$Xj)],w);function a(r){return(0,v.$7f)(r)&&(0,u.$Zo)(r.identifier)&&(t(r.location)||(0,v.$5f)(r.location)&&r.location)&&((0,v.$_f)(r.relativeLocation)||(0,v.$5f)(r.relativeLocation))&&r.version&&(0,v.$5f)(r.version)}function t(r){return r?(0,v.$5f)(r.path)&&(0,v.$5f)(r.scheme):!1}}),define(re[132],oe([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,74,12,7,174,38,127,124,207,16,6,5,27,3,77,83,41,40,206]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w,a,t,r,s,n,o,c,b,L,I,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$qq=e.$pq=e.$oq=e.Translations=void 0,e.$rq=ue;var R;(function(ce){function K(X,B){if(X===B)return!0;const M=Object.keys(X),z=new Set;for(const U of Object.keys(B))z.add(U);if(M.length!==z.size)return!1;for(const U of M){if(X[U]!==B[U])return!1;z.delete(U)}return z.size===0}ce.equals=K})(R||(e.Translations=R={})),e.$oq=(0,s.$ri)("IExtensionsScannerService");let W=class extends l.$Uc{constructor(K,X,B,M,z,U,ae,G,le,Y,C,N){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=X,this.r=B,this.s=M,this.t=z,this.u=U,this.w=ae,this.y=G,this.z=le,this.C=Y,this.D=C,this.F=N,this.g=this.B(new c.$be),this.onDidChangeCache=this.g.event,this.h=(0,$.$5g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,w.$Ap)(this.w,this.y)),this.G}async scanAllExtensions(K,X,B){const[M,z]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(X)]),U=B?await this.scanExtensionsUnderDevelopment(K,[...M,...z]):[];return this.L(M,z,U,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const X=[];X.push(this.M(!!K.useCache,K.language)),X.push(this.N(K.language,!!K.checkControlFile));const[B,M]=await Promise.all(X);return this.J([...B,...M],0,K,!1)}async scanUserExtensions(K){const X=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const B=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(X,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,B,K.productVersion??this.R()),z=K.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let U;try{U=await z.scanExtensions(M)}catch(ae){if(ae instanceof L.$jq&&ae.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),U=await z.scanExtensions(M);else throw ae}return U=await this.J(U,1,K,!0),this.y.trace("Scanned user extensions:",U.length),U}async scanExtensionsUnderDevelopment(K,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===d.Schemas.file).map(async M=>{const z=await this.P(M,!1,1,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(z)).map(ae=>(ae.type=X.find(G=>(0,w.$pp)(G.identifier,ae.identifier))?.type??ae.type,this.n.validate(ae,z)))}))).flat();return this.J(B,"development",K,!0)}return[]}async scanExistingExtension(K,X,B){const M=await this.P(K,!1,X,!0,B.language,!0,void 0,B.productVersion??this.R()),z=await this.n.scanExtension(M);return!z||!B.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(K,X,B){const M=await this.P(K,!1,X,!0,B.language,!0,void 0,B.productVersion??this.R()),z=await this.n.scanOneOrMultipleExtensions(M);return this.J(z,X,B,!0)}async scanMultipleExtensions(K,X,B){const M=[];return await Promise.all(K.map(async z=>{const U=await this.scanOneOrMultipleExtensions(z,X,B);M.push(...U)})),this.J(M,X,B,!0)}async scanMetadata(K){const X=(0,$.$5g)(K,"package.json"),B=(await this.w.readFile(X)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(K,X){const B=(0,$.$5g)(K,"package.json"),M=(await this.w.readFile(B)).value.toString(),z=JSON.parse(M);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,z.__metadata={...z.__metadata,...X},await this.w.writeFile((0,$.$5g)(K,"package.json"),A.$Ce.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof L.$jq&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Ce.fromString(JSON.stringify([])))}catch(X){(0,r.$cl)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,P.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,X,B,M){return B.includeAllVersions||(K=this.L(X===0?K:void 0,X===1?K:void 0,X==="development"?K:void 0,await this.getTargetPlatform(),M)),B.includeInvalid||(K=K.filter(z=>z.isValid)),K.sort((z,U)=>{const ae=y.$oc(z.location.fsPath),G=y.$oc(U.location.fsPath);return ae<G?-1:ae>G?1:0})}L(K,X,B,M,z){const U=(G,le,Y)=>{if(G.isValid&&!le.isValid)return!1;if(G.isValid===le.isValid){if(z&&g.gt(G.manifest.version,le.manifest.version))return this.y.debug(`Skipping extension ${le.location.path} with lower version ${le.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(g.eq(G.manifest.version,le.manifest.version)){if(G.type===0)return this.y.debug(`Skipping extension ${le.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===M)return this.y.debug(`Skipping extension ${le.location.path} from different target platform ${le.targetPlatform}`),!1}}return Y?this.y.warn(`Overwriting user extension ${G.location.path} with ${le.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${le.location.path}.`),!0},ae=new a.$Om;return K?.forEach(G=>{const le=ae.get(G.identifier.id);(!le||U(le,G,!1))&&ae.set(G.identifier.id,G)}),X?.forEach(G=>{const le=ae.get(G.identifier.id);if(!le&&K&&G.type===0){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!le||U(le,G,!1))&&ae.set(G.identifier.id,G)}),B?.forEach(G=>{const le=ae.get(G.identifier.id);(!le||U(le,G,!0))&&ae.set(G.identifier.id,G),ae.set(G.identifier.id,G)}),[...ae.values()]}async M(K,X){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0,this.R()),z=await(K&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",z.length),z}async N(K,X){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const M=X?await this.O():{},z=[],U=m.URI.file(y.$ic(y.$kc(d.$Lg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of B){const le=M[G.name]||"marketplace";switch(le){case"disabled":break;case"marketplace":z.push((0,$.$5g)(U,G.name));break;default:z.push(m.URI.file(le));break}}const ae=await Promise.all(z.map(async G=>this.n.scanExtension(await this.P(G,!1,0,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ae.length),(0,i.$Hb)(ae)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,X,B,M,z,U,ae,G){const le=await this.f(z??E.$w),Y=await this.Q(K),C=X&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,N=C?await this.Q(C):void 0;return new F(K,Y,C,N,X,ae,B,M,U,G.version,G.date,this.C.commit,!this.z.isBuilt,z,le)}async Q(K){try{const X=await this.w.stat(K);if(typeof X.mtime=="number")return X.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$pq=W,e.$pq=W=Se([ie(4,I.$xl),ie(5,L.$kq),ie(6,r.$Xk),ie(7,n.$Xj),ie(8,h.$yi),ie(9,o.$ek),ie(10,j.$vl),ie(11,s.$qi)],W);class F{constructor(K,X,B,M,z,U,ae,G,le,Y,C,N,_,ne,Q){this.location=K,this.mtime=X,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=M,this.profile=z,this.profileScanOptions=U,this.type=ae,this.excludeObsolete=G,this.validate=le,this.productVersion=Y,this.productDate=C,this.productCommit=N,this.devMode=_,this.language=ne,this.translations=Q}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,X){return(0,$.$Xg)(K.location,X.location)&&K.mtime===X.mtime&&(0,$.$Xg)(K.applicationExtensionslocation,X.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&K.profile===X.profile&&S.$2n(K.profileScanOptions,X.profileScanOptions)&&K.type===X.type&&K.excludeObsolete===X.excludeObsolete&&K.validate===X.validate&&K.productVersion===X.productVersion&&K.productDate===X.productDate&&K.productCommit===X.productCommit&&K.devMode===X.devMode&&K.language===X.language&&R.equals(K.translations,X.translations)}}e.$qq=F;let T=class extends l.$Uc{constructor(K,X,B,M,z){super(),this.f=K,this.g=X,this.h=B,this.j=M,this.m=z}async scanExtensions(K){const X=K.profile?await this.r(K):await this.n(K);let B={};if(K.excludeObsolete&&K.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(M)}catch{}return(0,p.$fg)(B)?X:X.filter(M=>!B[w.$qp.create(M).toString()])}async n(K){const X=await this.j.resolve(K.location);if(!X.children?.length)return[];const B=await Promise.all(X.children.map(async M=>{if(!M.isDirectory||K.type===1&&(0,$.$2g)(M.resource).indexOf(".")===0)return null;const z=new F(M.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(z)}));return(0,i.$Hb)(B).sort((M,z)=>M.location.path<z.location.path?-1:1)}async r(K){let X=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){X=X.filter(M=>!M.metadata?.isApplicationScoped);const B=await this.s(K.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,K);X.push(...B)}return X}async s(K,X,B){const M=await this.g.scanProfileExtensions(K,B.profileScanOptions);if(!M.length)return[];const z=await Promise.all(M.map(async U=>{if(X(U)){const ae=new F(U.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(ae,U.metadata)}return null}));return(0,i.$Hb)(z)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,$.$5g)(K.location,"package.json"))){const X=await this.scanExtension(K);return X?[X]:[]}else return await this.scanExtensions(K)}catch(X){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,P.$0)(X)),[]}}async scanExtension(K,X){try{let B=await this.scanExtensionManifest(K.location);if(B){B.publisher||(B.publisher=a.$Im),X=X??B.__metadata,delete B.__metadata;const M=(0,w.$up)(B.publisher,B.name),z=X?.id?{id:M,uuid:X.id}:{id:M},U=X?.isSystem?0:K.type,ae=U===0||!!X?.isBuiltin;B=await this.t(K.location,B,F.createNlsConfiguration(K));const G={type:U,identifier:z,manifest:B,location:K.location,isBuiltin:ae,targetPlatform:X?.targetPlatform??"undefined",publisherDisplayName:X?.publisherDisplayName,metadata:X,isValid:!0,validations:[]};return K.validate?this.validate(G,K):G}}catch(B){K.type!==0&&this.m.error(B)}return null}validate(K,X){let B=!0;const M=(0,t.$Fp)(X.productVersion,X.productDate,X.location,K.manifest,K.isBuiltin);for(const[z,U]of M)z===v.default.Error&&(B=!1,this.m.error(this.z(X.location,U)));return K.isValid=B,K.validations=M,K}async scanExtensionManifest(K){const X=(0,$.$5g)(K,"package.json");let B;try{B=(await this.j.readFile(X)).value.toString()}catch(z){return(0,r.$cl)(z)!==1&&this.m.error(this.z(K,(0,f.localize)(0,null,X.path,z.message))),null}let M;try{M=JSON.parse(B)}catch{const U=[];(0,k.$En)(B,U);for(const ae of U)this.m.error(this.z(K,(0,f.localize)(1,null,X.path,ae.offset,ae.length,(0,u.$mq)(ae.error))));return null}return(0,k.$Nn)(M)!=="object"?(this.m.error(this.z(K,(0,f.localize)(2,null,X.path))),null):M}async t(K,X,B){const M=await this.u(K,X,B);if(M)try{const z=[],U=await this.w(M.default,z);if(z.length>0)return z.forEach(G=>{this.m.error(this.z(K,(0,f.localize)(3,null,M.default?.path,(0,u.$mq)(G.error))))}),X;if((0,k.$Nn)(M)!=="object")return this.m.error(this.z(K,(0,f.localize)(4,null,M.default?.path))),X;const ae=M.values||Object.create(null);return(0,O.$nq)(this.m,X,ae,U)}catch{}return X}async u(K,X,B){const M=(0,$.$5g)(K,"package.nls.json"),z=(le,Y)=>{Y.forEach(C=>{this.m.error(this.z(K,(0,f.localize)(5,null,le?.path,(0,u.$mq)(C.error))))})},U=le=>{this.m.error(this.z(K,(0,f.localize)(6,null,le?.path)))},ae=`${X.publisher}.${X.name}`,G=B.translations[ae];if(G)try{const le=m.URI.file(G),Y=(await this.j.readFile(le)).value.toString(),C=[],N=(0,k.$En)(Y,C);return C.length>0?(z(le,C),{values:void 0,default:M}):(0,k.$Nn)(N)!=="object"?(U(le),{values:void 0,default:M}):{values:N.contents?N.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let Y;try{Y=await this.y(K,B)}catch{return}if(!Y.localized)return{values:void 0,default:Y.original};try{const C=(await this.j.readFile(Y.localized)).value.toString(),N=[],_=(0,k.$En)(C,N);return N.length>0?(z(Y.localized,N),{values:void 0,default:Y.original}):(0,k.$Nn)(_)!=="object"?(U(Y.localized),{values:void 0,default:Y.original}):{values:_,default:Y.original}}catch{return{values:void 0,default:Y.original}}}}async w(K,X){if(K)try{const B=(await this.j.readFile(K)).value.toString();return(0,k.$En)(B,X)}catch{}}y(K,X){return new Promise((B,M)=>{const z=U=>{const ae=(0,$.$5g)(K,`package.nls.${U}.json`);this.j.exists(ae).then(G=>{G&&B({localized:ae,original:(0,$.$5g)(K,"package.nls.json")});const le=U.lastIndexOf("-");le===-1?B({localized:(0,$.$5g)(K,"package.nls.json"),original:null}):(U=U.substring(0,le),z(U))})};if(X.devMode||X.pseudo||!X.language)return B({localized:(0,$.$5g)(K,"package.nls.json"),original:null});z(X.language)})}z(K,X){return`[${K.path}]: ${X}`}};T=Se([ie(1,L.$kq),ie(2,j.$vl),ie(3,r.$Xk),ie(4,n.$Xj)],T);let q=class extends T{constructor(K,X,B,M,z,U,ae){super(X,M,z,U,ae),this.G=K,this.H=B,this.D=this.B(new D.$ph(3e3)),this.F=this.B(new c.$be),this.onDidChangeCache=this.F.event}async scanExtensions(K){const X=this.M(K),B=await this.I(X);if(this.C=K,B&&B.input&&F.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",K.location.toString()),this.D.trigger(()=>this.L()),B.result.map(z=>(z.location=m.URI.revive(z.location),z));const M=await super.scanExtensions(K);return await this.J(X,{input:K,result:M}),M}async I(K){try{const X=await this.j.readFile(K),B=JSON.parse(X.value.toString());return{result:B.result,input:(0,b.$1h)(B.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",K.path,(0,P.$0)(X))}return null}async J(K,X){try{await this.j.writeFile(K,A.$Ce.fromString(JSON.stringify(X)))}catch(B){this.m.debug("Error while writing the extension cache file:",K.path,(0,P.$0)(B))}}async L(){if(!this.C)return;const K=this.M(this.C),X=await this.I(K);if(!X)return;const B=X.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$2n(M,B))try{this.m.info("Invalidating Cache",B,M),await this.j.del(K),this.F.fire()}catch(z){this.m.error(z)}}M(K){const X=this.N(K);return this.h.extUri.joinPath(X.cacheHome,K.type===0?a.$Hm:a.$Gm)}N(K){return K.type===0?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(K.location,X.extensionsResource))??this.G:this.H.defaultProfile}};q=Se([ie(2,I.$xl),ie(3,L.$kq),ie(4,j.$vl),ie(5,r.$Xk),ie(6,n.$Xj)],q);function ue(ce,K){const X=(0,w.$sp)(ce.manifest.publisher,ce.manifest.name);return{id:X,identifier:new a.$Mm(X),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:K,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class ee extends W{constructor(K,X,B,M,z,U,ae,G,le,Y,C,N){super(K,X,(0,$.$5g)(B,".vscode-oss-dev","extensions","control.json"),M,z,U,ae,G,le,Y,C,N),this.S=(async()=>{if(E.$z)try{const _=await this.w.readFile(m.URI.file(E.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$sq=ee}),define(re[280],oe([0,1,5,41,40,28,83,16,38,7]),function(J,e,i,D,S,A,P,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CQ=void 0;let d=class extends P.$lq{constructor(E,$,g,v,p,m){super(l.URI.file(E.extensionsPath),$,g,v,p,m)}};e.$CQ=d,e.$CQ=d=Se([ie(0,u.$zi),ie(1,k.$Xk),ie(2,D.$xl),ie(3,S.$vl),ie(4,A.$Wl),ie(5,i.$Xj)],d)}),define(re[281],oe([0,1,7,38,83,132,16,6,5,27,40,41]),function(J,e,i,D,S,A,P,k,u,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;let E=class extends A.$sq{constructor(g,v,p,m,f,h,w,a){super(i.URI.file(f.builtinExtensionsPath),i.URI.file(f.extensionsPath),f.userHome,g.defaultProfile,g,v,p,m,f,h,w,a)}};e.$Lcc=E,e.$Lcc=E=Se([ie(0,y.$xl),ie(1,S.$kq),ie(2,P.$Xk),ie(3,u.$Xj),ie(4,D.$zi),ie(5,l.$ek),ie(6,d.$vl),ie(7,k.$qi)],E)}),define(re[282],oe([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;let g=class extends D.$Uc{constructor(p,m,f){super(),this.c=p,this.f=f,this.a=k.$xi.forPaths(!P.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.with({scheme:S.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:p}=i.session;p.protocol.registerFileProtocol(S.Schemas.vscodeFileResource,(m,f)=>this.j(m,f)),p.protocol.interceptFileProtocol(S.Schemas.file,(m,f)=>this.h(m,f)),this.B((0,D.$Sc)(()=>{p.protocol.unregisterProtocol(S.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(S.Schemas.file)}))}addValidFileRoot(p){const m=(0,A.$ic)(p);return this.a.get(m)?D.$Uc.None:(this.a.set(m,!0),(0,D.$Sc)(()=>this.a.delete(m)))}h(p,m){const f=u.URI.parse(p.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${S.Schemas.file}: protocol (original URL: ${p.url})`),m({error:-3})}j(p,m){const f=this.m(p);let h;return this.c.crossOriginIsolated&&((0,A.$oc)(f)==="workbench.html"||(0,A.$oc)(f)==="workbench-dev.html"?h=S.COI.CoopAndCoep:h=S.COI.getHeadersFromQuery(p.url)),this.a.findSubstr(f)?m({path:f,headers:h}):this.b.has((0,A.$pc)(f).toLowerCase())?m({path:f}):(this.f.error(`${S.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${S.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),m({error:-3}))}m(p){const m=u.URI.parse(p.url),f=S.$Lg.uriToFileUri(m);return(0,A.$ic)(f.fsPath)}createIPCObjectUrl(){let p;const m=u.URI.from({scheme:"vscode",path:(0,l.$Ng)()}),f=m.toString(),h=async()=>p;return d.$GW.handle(f,h),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:m,update:w=>p=w,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),d.$GW.removeHandler(f)}}}};e.$4cc=g,e.$4cc=g=Se([ie(0,y.$zi),ie(1,$.$xl),ie(2,E.$Xj)],g)}),define(re[97],oe([0,1,8,3,2,66,12,115,6,41]),function(J,e,i,D,S,A,P,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vp=e.$Up=e.$Tp=void 0,e.$Wp=$,e.$Yp=v,e.$1p=m,e.$Tp="__$__isNewStorageMarker",e.$Up="__$__targetStorageMarker",e.$Vp=(0,u.$ri)("storageService");var d;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(d||(e.WillSaveStateReason=d={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var E;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(E||(e.StorageTarget=E={}));function $(f){const h=f.get(e.$Up);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}class g extends S.$Uc{static{this.a=60*1e3}constructor(h={flushInterval:g.a}){super(),this.m=h,this.b=this.B(new D.$ee),this.c=this.B(new D.$ee),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$be),this.onWillSaveState=this.f.event,this.h=this.B(new i.$Dh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,w,a){return D.Event.filter(this.b.event,t=>t.scope===h&&(w===void 0||t.key===w),a)}n(){this.j.value=(0,i.$Hh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,w){const{key:a,external:t}=w;if(a===e.$Up){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:a,target:this.J(h)[a],external:t})}w(h){this.f.fire({reason:h})}get(h,w,a){return this.P(w)?.get(h,a)}getBoolean(h,w,a){return this.P(w)?.getBoolean(h,a)}getNumber(h,w,a){return this.P(w)?.getNumber(h,a)}getObject(h,w,a){return this.P(w)?.getObject(h,a)}storeAll(h,w){this.y(()=>{for(const a of h)this.store(a.key,a.value,a.scope,a.target,w)})}store(h,w,a,t,r=!1){if((0,P.$bg)(w)){this.remove(h,a,r);return}this.y(()=>{this.z(h,a,t),this.P(a)?.set(h,w,r)})}remove(h,w,a=!1){this.y(()=>{this.z(h,w,void 0),this.P(w)?.delete(h,a)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,w){const a=[],t=this.J(h);for(const r of Object.keys(t))t[r]===w&&a.push(r);return a}z(h,w,a,t=!1){const r=this.J(w);typeof a=="number"?r[h]!==a&&(r[h]=a,this.P(w)?.set(e.$Up,JSON.stringify(r),t)):typeof r[h]=="number"&&(delete r[h],this.P(w)?.set(e.$Up,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const w=this.P(h);return w?$(w):Object.create(null)}isNew(h){return this.getBoolean(e.$Tp,h)===!0}async flush(h=d.NONE){this.f.fire({reason:h});const w=this.P(-1),a=this.P(0),t=this.P(1);switch(h){case d.NONE:await i.Promises.settled([w?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case d.SHUTDOWN:await i.Promises.settled([w?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,w=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return m(h,w,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,w){return this.w(d.NONE),(0,l.$wl)(h)?this.R(h,w):this.S(h,w)}M(h,w){return!(h.id===w.id||v(w)&&v(h))}N(h,w,a){this.y(()=>{const t=new Set;for(const[r,s]of h)t.add(r),w.get(r)!==s&&this.u(a,{key:r,external:!0});for(const[r]of w.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$Xp=g;function v(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class p extends g{constructor(){super(),this.U=this.B(new k.$Rp(new k.$Sp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$Rp(new k.$Sp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$Rp(new k.$Sp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$Zp=p;async function m(f,h,w,a,t,r){const s=R=>{try{return JSON.parse(R)}catch{return R}},n=new Map,o=new Map;f.forEach((R,W)=>{n.set(W,R),o.set(W,s(R))});const c=new Map,b=new Map;h.forEach((R,W)=>{c.set(W,R),b.set(W,s(R))});const L=new Map,I=new Map;w.forEach((R,W)=>{L.set(W,R),I.set(W,s(R))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const j=[];if(n.forEach((R,W)=>{j.push({key:W,value:R})}),console.table(j),console.groupEnd(),console.log(o),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const R=[];c.forEach((W,F)=>{R.push({key:F,value:W})}),console.table(R),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${r})`);const O=[];L.forEach((R,W)=>{O.push({key:W,value:R})}),console.table(O),console.groupEnd(),console.log(I)}}),define(re[283],oe([0,1,22,8,3,2,9,73,7,21,115,163,5,97,28,30,13]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=e.$Abc=e.$zbc=void 0;class m extends A.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(s,n){super(),this.m=s,this.n=n,this.b=this.B(new S.$be),this.onDidChangeStorage=this.b.event,this.c=this.B(new S.$be),this.onDidCloseStorage=this.c.event,this.f=this.B(new d.$Rp(new d.$Sp,{hint:d.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new D.$Oh,this.whenInit=this.h.p,this.j=d.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===d.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(o=>this.b.fire(o))),await this.s(s);const n=s.getBoolean($.$Tp);n===void 0?s.set($.$Tp,!0):n&&s.set($.$Tp,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=d.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===E.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,n){return this.f.get(s,n)}set(s,n){return this.f.set(s,n)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new k.$0d(!1);await this.w(),s.stop(),s.elapsed()>m.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const n=(0,i.top)(Array.from(this.f.items.entries()).map(([c,b])=>({key:c,length:b.length})),(c,b)=>b.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),o=(await this.n.stat(u.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${o}b, Large Keys: ${n}`)}catch(n){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async w(){this.g&&await this.g,this.j=d.StorageState.Closed,await this.f.close()}}class f extends m{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,P.$kc)(this.z.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,f.y)}constructor(s,n,o,c){super(o,c),this.z=s,this.C=n}async t(){return new d.$Rp(new y.$_W(this.path??y.$_W.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:d.StorageHint.STORAGE_IN_MEMORY})}}class h extends f{constructor(s,n,o,c){super(s,n,o,c)}}e.$zbc=h;class w extends f{constructor(s,n,o,c){super(n.defaultProfile,s,o,c)}async s(s){await super.s(s),this.G(s)}G(s){s.get(g.$Zl,void 0)===void 0&&s.set(g.$Zl,new Date().toUTCString());const o=s.get(g.$Yl,void 0),c=new Date().toUTCString();s.set(g.$1l,typeof o>"u"?null:o),s.set(g.$Yl,c)}}e.$Abc=w;class a extends m{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,P.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id,a.y)}constructor(s,n,o,c,b){super(o,b),this.C=s,this.D=n,this.F=c}async t(){const{storageFilePath:s,wasCreated:n}=await this.H();return new d.$Rp(new y.$_W(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?d.StorageHint.STORAGE_IN_MEMORY:n?d.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:y.$_W.IN_MEMORY_PATH,wasCreated:!0};const s=(0,P.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id),n=(0,P.$kc)(s,a.y);return await l.Promises.exists(s)?{storageFilePath:n,wasCreated:!1}:(await l.Promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:n,wasCreated:!0})}async I(s){let n;if((0,v.$Bi)(this.C)?n={folder:this.C.uri.toString()}:(0,v.$Gi)(this.C)&&(n={workspace:this.C.configPath.toString()}),n)try{const o=(0,P.$kc)(s,a.z);await l.Promises.exists(o)||await l.Promises.writeFile(o,JSON.stringify(n,void 0,2))}catch(o){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.$Bbc=a;class t extends m{get path(){}async t(){return new d.$Rp(new d.$Sp,{hint:d.StorageHint.STORAGE_IN_MEMORY})}}e.$Cbc=t}),define(re[284],oe([0,1,3,2,97]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class A extends D.$Uc{constructor(k,u,l){super(),this.b=k,this.c=u,this.f=l;const d=this.B(new D.$Vc);this.a=this.B(new i.$be({onWillAddFirstListener:()=>d.value=this.g(),onDidRemoveLastListener:()=>d.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new D.$Tc;return k.add(i.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(u,l)=>(u?u.push(l.key):u=[l.key],u),100)(u=>this.h(u))),k.add(i.Event.debounce(this.b.onDidChangeProfileStorage,(u,l)=>{u||(u=new Map);let d=u.get(l.profile.id);return d||u.set(l.profile.id,d={profile:l.profile,keys:[],storage:l.storage}),d.keys.push(l.key),u},100)(u=>this.j(u))),k}h(k){const u=k.includes(S.$Up)?[this.c.defaultProfile]:[],l=[];if(k=k.filter(d=>d!==S.$Up),k.length){const d=(0,S.$Wp)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:k.map(y=>({key:y,scope:0,target:d[y]}))})}this.m(u,l)}j(k){const u=[],l=new Map;for(const[d,y]of k.entries()){y.keys.includes(S.$Up)&&u.push(y.profile);const E=y.keys.filter($=>$!==S.$Up);if(E.length){const $=(0,S.$Wp)(y.storage.storage);l.set(d,{profile:y.profile,changes:E.map(g=>({key:g,scope:0,target:$[g]}))})}}this.m(u,[...l.values()])}m(k,u){(k.length||u.length)&&this.a.fire({valueChanges:u,targetChanges:k})}listen(k,u,l){switch(u){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${u}`)}async call(k,u){throw new Error(`Call not found: ${u}`)}}e.$Ncc=A}),define(re[285],oe([0,1,7,38,16,5,34,40,41,12,125]),function(J,e,i,D,S,A,P,k,u,l,d){"use strict";var y,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$BQ=e.$AQ=e.$zQ=void 0;let $=class extends u.$Al{static{y=this}static{this.a="profileAssociationsMigration"}constructor(m,f,h,w,a){super(h,w,f,a),this.U=m,this.W=h}O(){return this.U.getItem(y.b,[]).map(f=>({...f,location:(0,l.$5f)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):i.URI.revive(f.location)}))}Q(){const m=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?m:this.N(m)}S(){return this.w.extUri.joinPath(i.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$zQ=$,e.$zQ=$=y=Se([ie(0,P.$uQ),ie(1,k.$vl),ie(2,D.$zi),ie(3,S.$Xk),ie(4,A.$Xj)],$);let g=E=class extends ${constructor(m,f,h,w,a){super(m,f,h,w,a),this.$=m}P(m){m.length?this.$.setItem(E.b,m.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(E.b)}O(){const m=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(m),this.$.setItem("userDataProfilesMigration",!0)),m}R(m){m.emptyWindows||m.workspaces?this.$.setItem(E.c,m):this.$.removeItem(E.c)}Q(){const m="workspaceAndProfileInfo",f=this.$.getItem(m,void 0);if(f){this.$.removeItem(m);const w=f.reduce((a,{workspace:t,profile:r})=>(a[i.URI.revive(t).toString()]=i.URI.revive(r).toString(),a),{});this.$.setItem(E.c,{workspaces:w})}const h=super.Q();return this.$.getItem(E.a,!1)||(this.R(h),this.$.setItem(E.a,!0)),h}};e.$AQ=g,e.$AQ=g=E=Se([ie(0,P.$vQ),ie(1,k.$vl),ie(2,D.$zi),ie(3,S.$Xk),ie(4,A.$Xj)],g);let v=class extends g{constructor(m,f,h,w){super(new d.$yQ(0,f,w,h),m,f,h,w)}async init(){return await this.$.init(),super.init()}};e.$BQ=v,e.$BQ=v=Se([ie(0,k.$vl),ie(1,D.$zi),ie(2,S.$Xk),ie(3,A.$Xj)],v)}),define(re[57],oe([0,1,38,16,6,5,40,41,285,34]),function(J,e,i,D,S,A,P,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=e.$hbc=void 0,e.$hbc=(0,S.$si)(k.$xl);let d=class extends u.$AQ{constructor(E,$,g,v,p){super(E,$,g,v,p)}getAssociatedEmptyWindows(){const E=[];for(const $ of this.C.emptyWindows.keys())E.push({id:$});return E}};e.$ibc=d,e.$ibc=d=Se([ie(0,l.$vQ),ie(1,P.$vl),ie(2,i.$zi),ie(3,D.$Xk),ie(4,A.$Xj)],d)}),define(re[133],oe([0,1,19,7,30]),function(J,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=A,e.$kbc=P,e.$lbc=k;async function A(u,l,d){for(const E of u){const $=E.openedWorkspace;if((0,S.$Gi)($)){const g=await d($);if(g){if(g.folders.some(v=>i.$Vg.isEqualOrParent(l,v.uri)))return E}else if(i.$Vg.isEqualOrParent(l,$.configPath))return E}}const y=u.filter(E=>(0,S.$Bi)(E.openedWorkspace)&&i.$Vg.isEqualOrParent(l,E.openedWorkspace.uri));if(y.length)return y.sort((E,$)=>-(E.openedWorkspace.uri.path.length-$.openedWorkspace.uri.path.length))[0]}function P(u,l){for(const d of u)if((0,S.$Gi)(d.openedWorkspace)&&i.$Vg.isEqual(d.openedWorkspace.configPath,l)||(0,S.$Bi)(d.openedWorkspace)&&i.$Vg.isEqual(d.openedWorkspace.uri,l))return d}function k(u,l){const d=y=>l.some(E=>i.$Vg.isEqual(D.URI.file(E),D.URI.file(y)));for(const y of u)if(y.config?.extensionDevelopmentPath?.some(E=>d(E)))return y}}),define(re[98],oe([0,1,32,42,103,48,13,9,4,19,7,6,68,30]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fb=void 0,e.$3fb=g,e.$4fb=v,e.$5fb=p,e.$6fb=m,e.$7fb=w,e.$8fb=t,e.$9fb=r,e.$0fb=b,e.$$fb=L,e.$2fb=(0,y.$ri)("workspacesService");function g(I){return I.hasOwnProperty("workspace")}function v(I){return I.hasOwnProperty("folderUri")}function p(I){return I.hasOwnProperty("fileUri")}function m(I){return f(I)||h(I)}function f(I){const j=I;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}function h(I){const j=I;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}function w(I,j,O,R,W){if(I.scheme!==R.scheme)return{name:O,uri:I.toString(!0)};let F=j?void 0:W.relativePath(R,I);if(F!==void 0)F.length===0?F=".":u.$i&&(F=a(F));else if(I.scheme===P.Schemas.file)F=I.fsPath,u.$i&&(F=a(F));else if(W.isEqualAuthority(I.authority,R.authority))F=I.path;else return{name:O,uri:I.toString(!0)};return{name:O,path:F}}function a(I){return I=(0,A.$rw)(I),(0,i.$og)(I)||(I=(0,i.$lg)(I)),I}function t(I,j,O){const R=[],W=new Set,F=O.dirname(j);for(const T of I){let q;if(f(T))T.path&&(q=O.resolvePath(F,T.path));else if(h(T))try{q=d.URI.parse(T.uri),q.path[0]!==k.$hc.sep&&(q=q.with({path:k.$hc.sep+q.path}))}catch(ue){console.warn(ue)}if(q){const ue=O.getComparisonKey(q);if(!W.has(ue)){W.add(ue);const ee=T.name||O.basenameOrAuthority(q);R.push(new $.$Li({uri:q,name:ee,index:R.length},T))}}}return R}function r(I,j,O,R,W){const F=s(j,I),T=W.dirname(j),q=W.dirname(R),ue=[];for(const X of F.folders){const B=f(X)?W.resolvePath(T,X.path):d.URI.parse(X.uri);let M;O?M=!1:M=!f(X)||(0,k.$jc)(X.path),ue.push(w(B,M,X.name,q,W))}const ee={insertSpaces:!1,tabSize:4,eol:u.$k||u.$j?`
`:`\r
`},ce=S.$Tn(I,["folders"],ue,ee);let K=S.$Wn(I,ce);return(0,l.$0g)(F.remoteAuthority,(0,E.$Cm)(R))&&(K=S.$Wn(K,S.$Sn(K,["remoteAuthority"],ee))),K}function s(I,j){const O=D.$En(j);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(R=>m(R));else throw new Error(`${I} looks like an invalid workspace file.`);return O}function n(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function o(I){return typeof I.folderUri=="string"}function c(I){return typeof I.fileUri=="string"}function b(I,j){const O={workspaces:[],files:[]};if(I){const R=function(F,T){for(let q=0;q<F.length;q++)try{T(F[q],q)}catch(ue){j.warn(`Error restoring recent entry ${JSON.stringify(F[q])}: ${ue.toString()}. Skip entry.`)}},W=I;Array.isArray(W.entries)&&R(W.entries,F=>{const T=F.label,q=F.remoteAuthority;n(F)?O.workspaces.push({label:T,remoteAuthority:q,workspace:{id:F.workspace.id,configPath:d.URI.parse(F.workspace.configPath)}}):o(F)?O.workspaces.push({label:T,remoteAuthority:q,folderUri:d.URI.parse(F.folderUri)}):c(F)&&O.files.push({label:T,remoteAuthority:q,fileUri:d.URI.parse(F.fileUri)})})}return O}function L(I){const j={entries:[]};for(const O of I.workspaces)v(O)?j.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):j.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of I.files)j.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return j}}),define(re[99],oe([0,1,87,13,4,19]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=void 0,e.$nbc=P,e.$obc=k,e.$pbc=u,e.$mbc=128/4;function P(l){function d(){let y=l.scheme===D.Schemas.file?(0,A.$Sg)(l):l.toString();return S.$k||(y=y.toLowerCase()),(0,i.createHash)("md5").update(y).digest("hex")}return{id:d(),configPath:l}}function k(l,d){function y(){if(l.scheme!==D.Schemas.file)return(0,i.createHash)("md5").update(l.toString()).digest("hex");if(!d)return;let $;return S.$k?$=d.ino:S.$j?$=d.birthtime.getTime():S.$i&&(typeof d.birthtimeMs=="number"?$=Math.floor(d.birthtimeMs):$=d.birthtime.getTime()),(0,i.createHash)("md5").update(l.fsPath).update($?String($):"").digest("hex")}const E=y();if(typeof E=="string")return{id:E,uri:l}}function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(re[100],oe([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ii=e.$hi=e.$gi=void 0,e.$ji=s,e.$ki=n,e.$mi=b,e.$ni=L;class v{traceSocketEvent(j,O){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,j,O)}constructor(j,O=""){this.f=!0,this.debugLabel=O,this.socket=j,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,k.$1)(R)}},this.socket.on("error",this.a),this.b=R=>{this.traceSocketEvent("close",{hadError:R}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(j){const O=R=>{this.traceSocketEvent("read",R),j(P.$Ce.wrap(R))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(j){const O=R=>{j({type:0,hadError:R,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(j){const O=()=>{j()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(j){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",j),this.socket.write(j.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,k.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,k.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((j,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),j();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),j()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.$gi=v;var p;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var m;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(m||(m={}));class f extends l.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(j,O){this.socket.traceSocketEvent(j,O)}constructor(j,O,R,W){super(),this.f=this.B(new u.$be),this.g=this.B(new u.$be),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=j,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:R?.byteLength||0,recordInflateBytes:W}),this.a=this.B(new h(this,O,R,W,this.f,(F,T)=>this.m(F,T))),this.B(this.a.onError(F=>{console.error(F),(0,k.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new g.$bi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(j){return this.f.event(j)}onClose(j){return this.g.event(j)}onEnd(j){return this.socket.onEnd(j)}write(j){let O=0;for(;O<j.byteLength;)this.a.writeMessage(j.slice(O,Math.min(O+262144,j.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(j,{compressed:O,opcode:R}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",j);let W=2;j.byteLength<126?W+=0:j.byteLength<2**16?W+=2:W+=8;const F=P.$Ce.alloc(W),T=O?64:0,q=R&15;if(F.writeUInt8(128|T|q,0),j.byteLength<126)F.writeUInt8(j.byteLength,1);else if(j.byteLength<2**16){F.writeUInt8(126,1);let ue=1;F.writeUInt8(j.byteLength>>>8&255,++ue),F.writeUInt8(j.byteLength>>>0&255,++ue)}else{F.writeUInt8(127,1);let ue=1;F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(j.byteLength>>>24&255,++ue),F.writeUInt8(j.byteLength>>>16&255,++ue),F.writeUInt8(j.byteLength>>>8&255,++ue),F.writeUInt8(j.byteLength>>>0&255,++ue)}this.socket.write(P.$Ce.concat([F,j]))}end(){this.h=!0,this.socket.end()}n(j){if(j.byteLength!==0){for(this.b.acceptChunk(j);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),R=O.readUInt8(0),W=(R&128)>>>7,F=(R&64)>>>6,T=R&15,q=O.readUInt8(1),ue=(q&128)>>>7,ee=q&127;this.j.state=2,this.j.readLen=2+(ue?4:0)+(ee===126?2:0)+(ee===127?8:0),this.j.fin=W,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!W,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),R=O.readUInt8(1),W=(R&128)>>>7;let F=R&127,T=1;F===126?F=O.readUInt8(++T)*2**8+O.readUInt8(++T):F===127&&(F=O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T));let q=0;W&&(q=O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T)),this.j.state=3,this.j.readLen=F,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$hi=f;class h extends l.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:P.$Ce.alloc(0)}constructor(j,O,R,W,F,T){super(),this.n=j,this.r=F,this.s=T,this.a=this.B(new u.$be),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new u.$be),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new u.$be),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new w(this.n,W,R,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(j,O){this.g.push({data:j,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:j,options:O}=this.g.shift();if(this.f&&O.compressed){const R=await this.w(this.f,j);this.s(R,O)}else this.s(j,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(j,O){return new Promise((R,W)=>{j.write(O),j.flush(F=>R(F))})}acceptFrame(j,O,R){this.h.push({data:j,isCompressed:O,isLastFrameOfMessage:R}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const j=this.h.shift();if(this.b&&j.isCompressed){const O=await this.C(this.b,j.data,j.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(j.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(j,O,R){return new Promise((W,F)=>{j.write(O),R&&j.write(P.$Ce.fromByteArray([0,0,255,255])),j.flush(T=>W(T))})}}class w extends l.$Uc{get recordedInflateBytes(){return this.j?P.$Ce.concat(this.f):P.$Ce.alloc(0)}constructor(j,O,R,W){super(),this.h=j,this.j=O,this.a=this.B(new u.$be),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(W),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(P.$Ce.wrap(F))}),R&&(this.h.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this.b.write(R.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(j){this.j&&this.f.push(j.clone()),this.h.traceSocketEvent("zlibInflateWrite",j),this.b.write(j.buffer)}flush(j){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=P.$Ce.concat(this.g);this.g.length=0,j(O)})}}class a extends l.$Uc{constructor(j,O){super(),this.g=j,this.a=this.B(new u.$be),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",R=>{this.g.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this.a.fire(R)}),this.b.on("data",R=>{this.g.traceSocketEvent("zlibDeflateData",R),this.f.push(P.$Ce.wrap(R))})}write(j){this.g.traceSocketEvent("zlibDeflateWrite",j.buffer),this.b.write(j.buffer)}flush(j){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=P.$Ce.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),j(O)})}}function t(I,j){if(j===0)return;const O=I.byteLength>>>2;for(let ue=0;ue<O;ue++){const ee=I.readUInt32BE(ue*4);I.writeUInt32BE(ee^j,ue*4)}const R=O*4,W=I.byteLength-R,F=j>>>24&255,T=j>>>16&255,q=j>>>8&255;W>=1&&I.writeUInt8(I.readUInt8(R)^F,R),W>=2&&I.writeUInt8(I.readUInt8(R+1)^T,R+1),W>=3&&I.writeUInt8(I.readUInt8(R+2)^q,R+2)}e.$ii=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function s(){const I=(0,E.$Ng)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const j=process.platform!=="darwin"&&e.$ii?e.$ii:(0,S.tmpdir)(),O=(0,d.$kc)(j,`vscode-ipc-${I}.sock`);return o(O),O}function n(I,j,O){const W=(0,i.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${O}-${j}-sock`;const F=O.substr(0,4),T=j.substr(0,6);let q;return process.platform!=="darwin"&&e.$ii&&!process.env.VSCODE_PORTABLE?q=(0,d.$kc)(e.$ii,`vscode-${W}-${F}-${T}.sock`):q=(0,d.$kc)(I,`${F}-${T}.sock`),o(q),q}function o(I){const j=r[y.$u];typeof j=="number"&&I.length>=j&&console.warn(`WARNING: IPC handle "${I}" is longer than ${j} chars, try a shorter --user-data-dir`)}class c extends $.$8h{static b(j){const O=u.Event.fromNodeEventEmitter(j,"connection");return u.Event.map(O,R=>({protocol:new g.$ci(new v(R,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(R,"close"))}))}constructor(j){super(c.b(j)),this.d=j}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$li=c;function b(I){return new Promise((j,O)=>{const R=(0,D.createServer)();R.on("error",O),R.listen(I,()=>{R.removeListener("error",O),j(new c(R))})})}function L(I,j){return new Promise((O,R)=>{const W=(0,D.createConnection)(I,()=>{W.removeListener("error",R),O(g.$di.fromSocket(new v(W,`ipc-client${j}`),j))});W.once("error",R)})}}),define(re[24],oe([0,1,51,9,4,100,38,91,6]),function(J,e,i,D,S,A,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=e.$6ac=void 0,e.$6ac=(0,u.$si)(P.$yi);class l extends k.$4m{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,D.$kc)(this.userDataPath,"clp")}get backupHome(){return(0,D.$kc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,A.$ki)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,D.$kc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(S.$k){for(const y in process.env)if(y.endsWith("_VSCODE_SNAP_ORIG")){const E=y.slice(0,-17);if(this.d[E])continue;process.env[E]&&(this.d[E]=process.env[E]),process.env[y]?process.env[E]=process.env[y]:delete process.env[E]}}}restoreSnapExportedVariables(){if(S.$k)for(const y in this.d)process.env[y]=this.d[y],delete this.d[y]}}e.$7ac=l,Se([i.$Vh],l.prototype,"cachedLanguagesPath",null),Se([i.$Vh],l.prototype,"backupHome",null),Se([i.$Vh],l.prototype,"mainIPCHandle",null),Se([i.$Vh],l.prototype,"mainLockfile",null),Se([i.$Vh],l.prototype,"disableUpdates",null),Se([i.$Vh],l.prototype,"crossOriginIsolated",null),Se([i.$Vh],l.prototype,"codeCachePath",null),Se([i.$Vh],l.prototype,"useCodeCache",null)}),define(re[287],oe([0,1,87,32,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;let h=class{static{f=this}static{this.a="backupWorkspaces"}constructor(a,t,r,s){this.j=a,this.k=t,this.l=r,this.m=s,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.$Vg,this.i={isEqual:(n,o)=>(0,D.$qg)(n,o,!P.$k)}}async initialize(){const a=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,l.$9ac)(a)),this.e=await this.v((0,l.$0ac)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==$.$kl.OFF}q(){return this.s()===$.$kl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||$.$kl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(s=>a.workspace.id===s.workspace.id)||(this.d.push(a),this.C());const r=(0,A.$kc)(this.c,a.workspace.id);return t?this.t(r,t).then(()=>r):r}async t(a,t){if(await u.Promises.exists(a)&&await this.z(a),await u.Promises.exists(t))try{await u.Promises.rename(t,a,!1)}catch(r){this.l.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,A.$kc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,A.$kc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,r=[];for(const s of a){const n=s.workspace;if(!(0,p.$Gi)(n))return[];if(!t.has(n.id)){t.add(n.id);const o=(0,A.$kc)(this.c,n.id);await this.B(o)?n.configPath.scheme!==S.Schemas.file||await u.Promises.exists(n.configPath.fsPath)?r.push(s):await this.z(o):await this.x(o)}}return r}async v(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const n=s.folderUri,o=this.h.getComparisonKey(n);if(!r.has(o)){r.add(o);const c=(0,A.$kc)(this.c,this.D(s));await this.B(c)?n.scheme!==S.Schemas.file||await u.Promises.exists(n.fsPath)?t.push(s):await this.z(c):await this.x(c)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const n=s.backupFolder;if(typeof n!="string")return[];if(!r.has(n)){r.add(n);const o=(0,A.$kc)(this.c,n);await this.B(o)?t.push(s):await this.x(o)}}return t}async x(a){try{await u.Promises.rm(a,u.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,m.$pbc)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,m.$pbc)();return{backupFolder:a.id}}async z(a){const t=this.y(),r=(0,A.$kc)(this.c,t.backupFolder);try{await u.Promises.rename(a,r,!1)}catch(s){return this.l.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,l.$8ac)(a)?t=(0,A.$kc)(this.c,a.backupFolder):(0,v.$Zfb)(a)?t=(0,A.$kc)(this.c,this.D(a)):t=(0,A.$kc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await u.Promises.readdir(a);for(const r of t)try{if((await u.Promises.readdir((0,A.$kc)(a,r))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:r})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return r&&(s.remoteAuthority=r),s}),folders:this.e.map(({folderUri:t,remoteAuthority:r})=>{const s={folderUri:t.toString()};return r&&(s.remoteAuthority=r),s}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:r})=>{const s={backupFolder:t};return r&&(s.remoteAuthority=r),s})};this.m.setItem(f.a,a)}D(a){const t=a.folderUri;let r;return t.scheme===S.Schemas.file?r=P.$k?t.fsPath:t.fsPath.toLowerCase():r=t.toString().toLowerCase(),(0,i.createHash)("md5").update(r).digest("hex")}};e.$Ibc=h,e.$Ibc=h=f=Se([ie(0,y.$6ac),ie(1,d.$Xi),ie(2,g.$Xj),ie(3,E.$vQ)],h)}),define(re[20],oe([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=e.LifecycleMainPhase=e.ShutdownReason=e.$xbc=void 0,e.$xbc=(0,d.$ri)("lifecycleMainService");var v;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var p;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let m=class extends P.$Uc{static{g=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(h,w,a){super(),this.F=h,this.G=w,this.H=a,this.c=this.B(new A.$be),this.onBeforeShutdown=this.c.event,this.f=this.B(new A.$be),this.onWillShutdown=this.f.event,this.g=this.B(new A.$be),this.onWillLoadWindow=this.g.event,this.h=this.B(new A.$be),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(g.b),this.m&&this.G.removeItem(g.b)}J(){const h=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.$j&&this.t===0&&this.L(1))};i.app.addListener("before-quit",h);const w=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!k.$j)&&i.app.quit()};i.app.addListener("window-all-closed",w),i.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),i.app.removeListener("before-quit",h),i.app.removeListener("window-all-closed",w),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),i.app.quit()})})}L(h){if(this.y)return this.y;const w=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:h,join(t,r){w.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(r.finally(()=>{w.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await S.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(h){if(h<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===h)return;this.S(`lifecycle (main): phase changed (value: ${h})`),this.n=h;const w=this.C.get(this.n);w&&(w.open(),this.C.delete(this.n))}async when(h){if(h<=this.n)return;let w=this.C.get(h);w||(w=new S.$qh,this.C.set(h,w)),await w.wait()}registerWindow(h){const w=new P.$Tc;this.t++,w.add(h.onWillLoad(t=>this.g.fire({window:h,workspace:t.workspace,reason:t.reason})));const a=(0,l.$dg)(h.win);w.add(A.Event.fromNodeEventEmitter(a,"close")(t=>{const r=h.id;if(this.r.has(r)){this.r.delete(r);return}this.S(`Lifecycle#window.on('close') - window ID ${h.id}`),t.preventDefault(),this.unload(h,1).then(s=>{if(s){this.r.delete(r);return}this.r.add(r),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${r}`),this.h.fire(h),h.close()})})),w.add(A.Event.fromNodeEventEmitter(a,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${h.id}`),this.t--,w.dispose(),this.t===0&&(!k.$j||this.j)&&this.L(1)}))}registerAuxWindow(h){const w=(0,l.$dg)(h.win),a=new P.$Tc;a.add(A.Event.fromNodeEventEmitter(w,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${h.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(A.Event.fromNodeEventEmitter(w,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${h.id}`),a.dispose()}))}async reload(h,w){await this.unload(h,3)||h.reload(w)}unload(h,w){const a=this.z.get(h.id);if(a)return a;const t=this.M(h,w).finally(()=>{this.z.delete(h.id)});return this.z.set(h.id,t),t}async M(h,w){if(!h.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${h.id}`);const a=this.j?2:w,t=await this.P(h,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${h.id})`),this.N(t)):(await this.Q(h,a),!1)}N(h){return h?(this.O(!0),this.j=!1,!0):!1}O(h){this.w&&(this.w(h),this.w=void 0,this.u=void 0)}P(h,w){return new Promise(a=>{const t=this.s++,r=`vscode:ok${t}`,s=`vscode:cancel${t}`;D.$GW.once(r,()=>{a(!1)}),D.$GW.once(s,()=>{a(!0)}),h.send("vscode:onBeforeUnload",{okChannel:r,cancelChannel:s,reason:w})})}Q(h,w){return new Promise(a=>{const r=`vscode:reply${this.s++}`;D.$GW.once(r,()=>a()),h.send("vscode:onWillUnload",{replyChannel:r,reason:w})})}quit(h){return this.R(h).then(w=>{if(!w&&h)try{if(k.$i){const a=(0,u.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return w})}R(h){return this.S(`Lifecycle#quit() - begin (willRestart: ${h})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(h&&this.G.setItem(g.b,!0),this.u=new Promise(w=>{this.w=w,this.S("Lifecycle#quit() - calling app.quit()"),i.app.quit()}),this.u)}S(h){this.H.args["enable-smoke-test-driver"]?this.F.info(h):this.F.trace(h)}setRelaunchHandler(h){this.D=h}async relaunch(h){this.S("Lifecycle#relaunch()");const w=process.argv.slice(1);if(h?.addArgs&&w.push(...h.addArgs),h?.removeArgs)for(const r of h.removeArgs){const s=w.indexOf(r);s>=0&&w.splice(s,1)}const a=()=>{this.D?.handleRelaunch(h)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),i.app.relaunch({args:w}))};i.app.once("quit",a),await this.quit(!0)&&i.app.removeListener("quit",a)}async kill(h){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,S.$sh)(1e3),(async()=>{for(const w of i.BrowserWindow.getAllWindows())if(w&&!w.isDestroyed()){let a;w.webContents&&!w.webContents.isDestroyed()?a=new Promise(t=>w.once("closed",t)):a=Promise.resolve(),w.destroy(),await a}})()]),i.app.exit(h)}};e.$ybc=m,e.$ybc=m=g=Se([ie(0,y.$Xj),ie(1,E.$vQ),ie(2,$.$6ac)],m)}),define(re[288],oe([0,1,4,3,2,6,20]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=void 0,e.$6bc=(0,A.$ri)("keyboardLayoutMainService");let k=class extends S.$Uc{constructor(d){super(),this.a=this.B(new D.$be),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,d.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const d=await new Promise((y,E)=>{J(["native-keymap"],y,E)});this.c=u(d),i.$t||d.onDidChangeKeyboardLayout(()=>{this.c=u(d),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$7bc=k,e.$7bc=k=Se([ie(0,P.$xbc)],k);function u(l){const d=l.getKeyMap(),y=l.getCurrentKeyboardLayout();return{keyboardMapping:d,keyboardLayoutInfo:y}}}),define(re[289],oe([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=void 0,e.$Tr=p;let g=class extends y.$Jp{constructor(f,h,w,a){super(a),this.m=f,this.n=h,this.r=w,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,h){const{f:w,g:a}=this;let t;try{t=await(0,l.$Bm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(n)))}const r={...process.env,...t},s=f.agent?f.agent:await(0,E.$Rr)(f.url||"",r,{proxyUrl:w,strictSSL:a});return f.agent=s,f.strictSSL=a,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>p(f,h))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((h,w)=>{J(["@vscode/proxy-agent"],h,w)})).loadSystemCertificates({log:this.r})}};e.$Sr=g,e.$Sr=g=Se([ie(0,k.$Xi),ie(1,u.$zi),ie(2,d.$Xj),ie(3,d.$Yj)],g);async function v(m){return((0,i.parse)(m.url).protocol==="https:"?await new Promise((w,a)=>{J(["https"],w,a)}):await new Promise((w,a)=>{J(["http"],w,a)})).request}async function p(m,f){return D.Promises.withAsyncBody(async(h,w)=>{const a=(0,i.parse)(m.url),t=m.getRawRequest?m.getRawRequest(m):await v(m),r={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,P.$$f)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(r.auth=m.user+":"+m.password);const s=t(r,n=>{const o=(0,P.$9f)(m.followRedirects)?m.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&o>0&&n.headers.location)p({...m,url:n.headers.location,followRedirects:o-1},f).then(h,w);else{let c=n;!m.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(c=n.pipe((0,$.createGunzip)())),h({res:n,stream:(0,S.$Re)(c)})}});s.on("error",w),m.timeout&&s.setTimeout(m.timeout),m.isChromiumNetwork&&s.removeHeader("Content-Length"),m.data&&typeof m.data=="string"&&s.write(m.data),s.end(),f.onCancellationRequested(()=>{s.abort(),w(new A.$5)})})}}),define(re[290],oe([0,1,14,289]),function(J,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;function S(P){return i.net.request}class A extends D.$Sr{request(k,u){return super.request({...k||{},getRawRequest:S,isChromiumNetwork:!0},u)}}e.$9cc=A}),define(re[84],oe([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=e.$Fbc=e.$Ebc=e.$Dbc=void 0,e.$Dbc=(0,k.$ri)("storageMainService");let p=class extends S.$Uc{constructor(h,w,a,t,r,s){super(),this.c=h,this.f=w,this.g=a,this.h=t,this.j=r,this.m=s,this.a=void 0,this.b=this.B(new D.$be),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(h=>{h.window.profile&&this.profileStorage(h.window.profile).init(),h.workspace&&this.workspaceStorage(h.workspace).init()})),this.B(this.h.onWillShutdown(h=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=h.reason,h.join("applicationStorage",this.applicationStorage.close());for(const[,w]of this.t)h.join("profileStorage",w.close());for(const[,w]of this.w)h.join("workspaceStorage",w.close())})),this.B(this.g.onWillCreateProfile(h=>{h.join((async()=>{await this.j.exists(h.profile.globalStorageHome)||await this.j.createFolder(h.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(h=>{const w=this.t.get(h.profile.id);w&&h.join(w.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const h=new y.$Abc(this.n(),this.g,this.c,this.j);return this.B(D.Event.once(h.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),h}profileStorage(h){if((0,d.$Yp)(h))return this.applicationStorage;let w=this.t.get(h.id);if(!w){this.c.trace(`StorageMainService: creating profile storage (${h.name})`),w=this.B(this.u(h)),this.t.set(h.id,w);const a=this.B(w.onDidChangeStorage(t=>this.b.fire({...t,storage:w,profile:h})));this.B(D.Event.once(w.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${h.name})`),this.t.delete(h.id),a.dispose()}))}return w}u(h){return this.a===2?new y.$Cbc(this.c,this.j):new y.$zbc(h,this.n(),this.c,this.j)}workspaceStorage(h){let w=this.w.get(h.id);return w||(this.c.trace(`StorageMainService: creating workspace storage (${h.id})`),w=this.B(this.y(h)),this.w.set(h.id,w),this.B(D.Event.once(w.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${h.id})`),this.w.delete(h.id)}))),w}y(h){return this.a===2?new y.$Cbc(this.c,this.j):new y.$Bbc(h,this.n(),this.c,this.f,this.j)}isUsed(h){const w=i.URI.file(h);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(i.URI.file(a.path),w))return!0;return!1}};e.$Ebc=p,e.$Ebc=p=Se([ie(0,l.$Xj),ie(1,A.$yi),ie(2,$.$hbc),ie(3,u.$xbc),ie(4,P.$Xk),ie(5,g.$vl)],p),e.$Fbc=(0,k.$ri)("applicationStorageMainService");let m=class extends d.$Xp{constructor(h,w){super(),this.s=h,this.U=w,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(h){if(h===-1)return this.U.applicationStorage.storage}Q(h){if(h===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$Gbc=m,e.$Gbc=m=Se([ie(0,E.$xl),ie(1,e.$Dbc)],m)}),define(re[291],oe([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=e.$7cc=e.$6cc=e.$5cc=void 0;async function m(t,r,s,n,o){let c;for(let b=3;b&&(c?.dispose(),c=await new f(t,r,s,n,o).waitForReady(),!(o&&S.$Qg[o]||!S.$Qg[c.tunnelLocalPort]));b--);return c}class f extends k.$Uc{constructor(r,s,n,o,c){super(),this.m=s,this.n=c,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=i.createServer(),this.c=new P.$qh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=o,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,s=(0,v.$dw)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,S.$Rg)(r,2,1e3,s),o=null;return this.b.listen(n,this.m),await this.c.wait(),o=this.b.address(),o||(n=0,this.b.listen(n,this.m),await this.c.wait(),o=this.b.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async r(r){r.pause();const s=(0,v.$bw)(this.tunnelRemoteHost)||(0,v.$dw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,E.$Nl)(this.a,s,this.tunnelRemotePort),o=n.getSocket(),c=n.readEntireBuffer();n.dispose(),c.byteLength>0&&r.write(c.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),o.end()}),r.on("close",()=>o.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),o instanceof A.$gi?o.socket.destroy():o.end()}),o instanceof A.$gi?this.t(r,o):this.s(r,o),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),o.end()})}s(r,s){s.onClose(()=>r.destroy()),s.onEnd(()=>r.end()),s.onData(n=>r.write(n.buffer)),r.on("data",n=>s.write(p.$Ce.wrap(n))),r.resume()}t(r,s){const n=s.socket;n.on("end",()=>r.end()),n.on("close",()=>r.end()),n.on("error",()=>{r.destroy()}),n.pipe(r),r.pipe(n)}}e.$5cc=f;let h=class extends v.$gw{constructor(r,s,n,o,c){super(s,c),this.v=r,this.w=n,this.y=o}isPortPrivileged(r){return(0,v.$ew)(r,this.m,u.OS,D.release())}t(r,s,n,o,c,b,L,I){const j=this.s(s,n);if(j)return++j.refcount,j.value;if((0,v.$0v)(r))return this.u(r,s,n,c,b,L,I);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${c}.`);const O={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},R=m(O,o,s,n,c);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,n,R),R}}};e.$6cc=h,e.$6cc=h=Se([ie(0,$.$Hl),ie(1,d.$Xj),ie(2,g.$Kl),ie(3,y.$ek),ie(4,l.$Xi)],h);let w=class extends h{constructor(r,s,n,o,c){super(r,s,n,o,c)}};e.$7cc=w,e.$7cc=w=Se([ie(0,$.$Hl),ie(1,d.$Xj),ie(2,g.$Kl),ie(3,y.$ek),ie(4,l.$Xi)],w);let a=class extends k.$Uc{constructor(r,s,n,o,c){super(),this.b=r,this.c=s,this.f=n,this.g=o,this.h=c,this.a=new Map}async openTunnel(r,s,n,o,c,b,L,I,j){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${o} on local port ${b}.`),!this.a.has(r)){const O=new w(this.b,this.c,this.g,this.f,this.h);this.B(O),this.a.set(r,O),O.onTunnelClosed(async()=>{(await O.tunnels).length===0&&(O.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(s,n,o,c,b,L,I,j)}};e.$8cc=a,e.$8cc=a=Se([ie(0,$.$Hl),ie(1,d.$Xj),ie(2,y.$ek),ie(3,g.$Kl),ie(4,l.$Xi)],a)}),define(re[101],oe([0,1,8,23,3,18,24,20,5,27,53,50]),function(J,e,i,D,S,A,P,k,u,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0,e.$qcc=E;function E(g,v,p){return`${p.updateUrl}/api/update/${g}/${v}/${p.commit}`}let $=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,p,m,f,h,w){this.f=v,this.g=p,this.h=m,this.i=f,this.j=h,this.k=w,this.b=y.$EX.Uninitialized,this.c=new S.$be,this.onStateChange=this.c.event,v.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(y.$EX.Disabled(0));return}if(this.h.disableUpdates){this.d(y.$EX.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(y.$EX.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.g.getValue("update.mode"),p=this.m(v);if(!p){this.d(y.$EX.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(p),!this.a){this.d(y.$EX.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const m=new URL(this.a);m.searchParams.set("prss","true"),this.a=m.toString()}if(this.d(y.$EX.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,m=>this.j.error(m))}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,i.$sh)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},D.CancellationToken.None)).res.statusCode===204}catch(p){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(p);return}}async _applySpecificUpdate(v){}q(){return 1}r(){}};e.$rcc=$,e.$rcc=$=Se([ie(0,k.$xbc),ie(1,A.$Xi),ie(2,P.$6ac),ie(3,d.$Ip),ie(4,u.$Xj),ie(5,l.$ek)],$)}),define(re[292],oe([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;let p=class extends v.$rcc{get v(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"error",(f,h)=>h)}get w(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get x(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-available")}get y(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",(f,h,w,a)=>({version:w,productVersion:w,timestamp:a}))}constructor(f,h,w,a,t,r,s){super(f,h,a,t,r,s),this.z=w,this.u=new P.$Tc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,A.$fj)(String(f)))}),this.j.error("UpdateService error:",f);const h=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d(g.$EX.Idle(1,h))}s(f){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const w=(0,v.$qcc)(h,f,this.k);try{i.autoUpdater.setFeedURL({url:w})}catch(a){this.j.error("Failed to set update feed URL",a);return}return w}t(f){this.d(g.$EX.CheckingForUpdates(f)),i.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(g.$EX.Downloading)}F(f){this.state.type==="downloading"&&(this.d(g.$EX.Downloaded(f)),this.z.publicLog2("update:downloaded",{version:f.version}),this.d(g.$EX.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(g.$EX.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$scc=p,Se([D.$Vh],p.prototype,"v",null),Se([D.$Vh],p.prototype,"w",null),Se([D.$Vh],p.prototype,"x",null),Se([D.$Vh],p.prototype,"y",null),e.$scc=p=Se([ie(0,l.$xbc),ie(1,k.$Xi),ie(2,$.$Wl),ie(3,u.$6ac),ie(4,E.$Ip),ie(5,d.$Xj),ie(6,y.$ek)],p)}),define(re[293],oe([0,1,49,43,8,3,9,24,20,5,28,50]),function(J,e,i,D,S,A,P,k,u,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0;let E=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,p,m){if(this.f=v,this.g=m,this.a=y.$EX.Uninitialized,this.b=new A.$be,this.onStateChange=this.b.event,p.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.$EX.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(v=60*60*1e3){return(0,S.$sh)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};E=Se([ie(0,u.$xbc),ie(1,k.$6ac),ie(2,l.$Xj)],E);let $=class extends E{constructor(v,p,m,f,h,w){super(m,f,h),this.o=v,this.p=p,this.q=w;const a=(0,D.watch)(P.$nc(this.o)),t=A.Event.fromNodeEventEmitter(a,"change",(o,c)=>c),r=A.Event.filter(t,o=>o==="current"),n=A.Event.debounce(r,(o,c)=>c,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{n.dispose(),a.close()})}m(){this.d(y.$EX.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(y.$EX.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$EX.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$EX.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+P.$oc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise((m,f)=>(0,D.realpath)(`${P.$nc(this.o)}/current`,(h,w)=>h?f(h):m(w))),p=P.$oc(v);return this.p!==p}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$ucc=$,e.$ucc=$=Se([ie(2,u.$xbc),ie(3,k.$6ac),ie(4,l.$Xj),ie(5,d.$Wl)],$)}),define(re[29],oe([0,1,14,4,6,82,55,69,27,18,24,9,138]),function(J,e,i,D,S,A,P,k,u,l,d,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$ebc=void 0,e.$fbc=g,e.$gbc=v,e.$ebc=(0,S.$ri)("windowsMainService");var $;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})($||(e.OpenContext=$={}));function g(m,f,h){const w=m.get(k.$cbc),a=m.get(u.$ek),t=m.get(l.$Xi),r=m.get(d.$6ac),s=t.getValue("window"),n={backgroundColor:w.getBackgroundColor(),minWidth:P.$nD.WIDTH,minHeight:P.$nD.HEIGHT,title:a.nameLong,show:f.mode!==0&&f.mode!==3,x:f.x,y:f.y,width:f.width,height:f.height,webPreferences:{...h,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,P.$yD)(f.zoomLevel??s?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(D.$k?n.icon=(0,y.$kc)(r.appRoot,"resources/linux/code.png"):D.$i&&!r.isBuilt&&(n.icon=(0,y.$kc)(r.appRoot,"resources/win32/code_150x150.png")),D.$j&&(n.acceptFirstMouse=!0,s?.clickThroughInactive===!1&&(n.acceptFirstMouse=!1)),D.$j&&!(0,P.$xD)(t)&&(n.fullscreenable=!1),D.$j&&s?.nativeTabs===!0&&(n.tabbingIdentifier=a.nameShort),!(0,P.$uD)(t)&&(n.titleBarStyle="hidden",D.$j||(n.frame=!1),(0,P.$wD)(t))){const b=w.getWindowSplash()?.colorInfo.titleBarBackground??w.getBackgroundColor(),L=E.$It.fromHex(b).isDarker()?"#FFFFFF":"#000000";n.titleBarOverlay={height:29,color:b,symbolColor:L}}return n}function v(m){let f,h=Number.MIN_VALUE;for(const w of m)w.lastFocusTime>h&&(h=w.lastFocusTime,f=w);return f}var p;(function(m){function f(w,a,t=i.screen.getAllDisplays()){if(w.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){w.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){w.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const n=h(t[0]);if(w.trace("window#validateWindowState: single monitor working area",n),n){let o=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!n||(a.x<n.x&&(a.x=n.x),a.y<n.y&&(a.y=n.y))};o(),a.width>n.width&&(a.width=n.width),a.height>n.height&&(a.height=n.height),a.x>n.x+n.width-128&&(a.x=n.x+n.width-a.width),a.y>n.y+n.height-128&&(a.y=n.y+n.height-a.height),o()}return a}if(a.display&&a.mode===3){const n=t.find(o=>o.id===a.display);if(n&&typeof n.bounds?.x=="number"&&typeof n.bounds?.y=="number"){w.trace("window#validateWindowState: restoring fullscreen to previous display");const o=(0,A.$4ac)(3);return o.x=n.bounds.x,o.y=n.bounds.y,o}}let r,s;try{r=i.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),s=h(r),w.trace("window#validateWindowState: multi-monitor working area",s)}catch(n){w.error("window#validateWindowState: error finding display for window state",n)}if(r&&s&&a.x+a.width>s.x&&a.y+a.height>s.y&&a.x<s.x+s.width&&a.y<s.y+s.height)return a;w.trace("window#validateWindowState: state is outside of the multi-monitor working area")}m.validateWindowState=f;function h(w){if(w.workArea.width>0&&w.workArea.height>0)return w.workArea;if(w.bounds.width>0&&w.bounds.height>0)return w.bounds}})(p||(e.WindowStateValidator=p={}))}),define(re[294],oe([0,1,14,23,3,46,2,33,120,5,84,29]),function(J,e,i,D,S,A,P,k,u,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=void 0;var E;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(E||(E={}));let $=class extends P.$Uc{constructor(v,p,m,f){super(),this.g=v,this.h=p,this.j=m,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=E.Initial,this.f=void 0,this.n()}n(){const v=S.Event.fromNodeEventEmitter(i.app,"login",(p,m,f,h,w)=>({event:p,webContents:m,req:f,authInfo:h,callback:w}));this.B(v(this.r,this))}async r({event:v,authInfo:p,req:m,callback:f}){if(!p.isProxy)return;if(!this.b&&this.c===E.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}v.preventDefault();let h;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(p);try{h=await this.b}finally{this.b=void 0}}f(h?.username,h?.password)}async s(v){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.t(v);if(p)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(v){this.g.trace("auth#doResolveProxyCredentials - enter",v);const p=String((0,A.$fj)({scheme:v.scheme,host:v.host,port:v.port}));let m,f;try{const t=this.m.get(this.a+p,-1);if(t){const r=JSON.parse(await this.j.decrypt(t));m=r.username,f=r.password}}catch(t){this.g.error(t)}if(this.c!==E.StoredCredentialsUsed&&typeof m=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=E.StoredCredentialsUsed,{username:m,password:f};const h=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!h){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const w={authInfo:v,username:this.f?.username??m,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,k.$Ng)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,w),this.c=E.LoginDialogShown;const a=await new Promise(t=>{const r=async(s,n,o)=>{if(n===w.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",r),o){const c={username:o.username,password:o.password};try{if(o.remember){const b=await this.j.encrypt(JSON.stringify(c));this.m.store(this.a+p,b,-1,1)}else this.m.remove(this.a+p,-1)}catch(b){this.g.error(b)}t({username:c.username,password:c.password})}else t(void 0)};h.win?.webContents.on("ipc-message",r)});return this.f=a,a}};e.$Hbc=$,e.$Hbc=$=Se([ie(0,l.$Xj),ie(1,y.$ebc),ie(2,u.$pX),ie(3,d.$Fbc)],$)}),define(re[295],oe([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(J,e,i,D,S,A,P,k,u,l,d,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=e.ID=void 0,e.ID="launchMainService",e.$9bc=(0,l.$ri)(e.ID);let $=class{constructor(v,p,m,f){this.a=v,this.b=p,this.c=m,this.d=f}async start(v,p){this.a.trace("Received data from other instance: ",v,p),S.$j&&i.app.focus({steal:!0});const m=this.e(v);if(m.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const h=(0,D.$Ob)(await this.b.openEmptyWindow({context:4}));h&&(f=h.ready())}f.then(()=>{for(const{uri:h,originalUrl:w}of m)this.c.open(h,{originalUrl:w})})}else return this.f(v,p)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,D.$Hb)(v._urls.map(p=>{try{return{uri:A.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async f(v,p){const m=(0,u.$vm)(p)?0:4;let f=[];const h=v.wait&&v.waitMarkerFilePath?A.URI.file(v.waitMarkerFilePath):void 0,w=v.remote||void 0,a={context:m,cli:v,userEnv:v["preserve-env"]||m===0?p:void 0,waitMarkerFileURI:h,remoteAuthority:w,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,a);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||a.forceProfile||a.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!S.$j}if(t)f=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,a),f=[r]):f=await this.b.open({...a,forceEmpty:!0})}}else f=await this.b.open({...a,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(h&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,P.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$0bc=$,e.$0bc=$=Se([ie(0,d.$Xj),ie(1,E.$ebc),ie(2,y.$vX),ie(3,k.$Xi)],$)}),define(re[296],oe([0,1,2,20,57,30,8,29]),function(J,e,i,D,S,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;let u=class extends i.$Uc{constructor(d,y,E){super(),this.a=y,this.b=E,this.B(d.onWillLoadWindow($=>{$.reason===2&&this.c($.window)})),this.B(d.onBeforeCloseWindow($=>this.c($))),this.B(new P.$Dh(()=>this.g(),30*1e3)).schedule()}async c(d){const y=this.f(d),E=this.a.getProfileForWorkspace(y);E?.isTransient&&(this.a.unsetWorkspace(y,E.isTransient),E.isTransient&&await this.a.cleanUpTransientProfiles())}f(d){return d.openedWorkspace??(0,A.$Fi)(d.backupPath,d.isExtensionDevelopmentHost)}g(){const d=this.a.getAssociatedEmptyWindows();if(d.length===0)return;const y=this.b.getWindows().map(E=>this.f(E));for(const E of d)y.some($=>$.id===E.id)||this.a.unsetWorkspace(E,!1)}};e.$Mcc=u,e.$Mcc=u=Se([ie(0,D.$xbc),ie(1,S.$hbc),ie(2,k.$ebc)],u)}),define(re[61],oe([0,1,14,2,3,5,316,8,13,29,74,28,20,76,35,4,102]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=e.$Kbc=void 0;function f(a){return typeof a.responseWindowId=="number"}let h=class extends D.$Uc{static{m=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(m.b.values())}constructor(t,r,s){super(),this.u=t,this.w=r,this.y=s,this.c=String(++m.a),this.f=this.B(new S.$be),this.onStdout=this.f.event,this.g=this.B(new S.$be),this.onStderr=this.g.event,this.h=this.B(new S.$be),this.onMessage=this.h.event,this.j=this.B(new S.$be),this.onSpawn=this.j.event,this.m=this.B(new S.$be),this.onExit=this.m.event,this.n=this.B(new S.$be),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,r){let s;switch(this.t?.correlationId?s=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,r){case d.default.Error:this.u.error(s);break;case d.default.Warning:this.u.warn(s);break;case d.default.Info:this.u.trace(s);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",d.default.Error),!1):!0}start(t){const r=this.D(t);return r&&t.payload&&this.postMessage(t.payload)&&this.z("payload sent via postMessage()",d.default.Info),r}D(t){if(!this.C())return!1;this.t=t;const r=`${this.t.type}-${this.c}`,s=u.$Lg.asFileUri("bootstrap-fork.js").fsPath,n=this.t.args??[],o=this.t.execArgv??[],c=this.t.allowLoadingUnsignedLibraries,b=this.t.forceAllocationsToV8Sandbox,L="pipe",I=this.F(t);return this.z("creating new...",d.default.Info),this.r=i.utilityProcess.fork(s,n,{serviceName:r,env:I,execArgv:o,allowLoadingUnsignedLibraries:c,forceAllocationsToV8Sandbox:b,stdio:L}),this.G(this.r,this.t,r),!0}F(t){const r=t.env?{...t.env}:{...(0,g.$Xn)(process.env)};r.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(r.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),r.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,v.$i&&((0,p.isUNCAccessRestrictionsDisabled)()?r.NODE_DISABLE_UNC_ACCESS_CHECKS="1":r.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,$.$im)(r);for(const s of Object.keys(r))r[s]=String(r[s]);return r}G(t,r,s){if(t.stdout){const n=new P.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stdout,"data")(o=>this.f.fire(typeof o=="string"?o:n.write(o))))}if(t.stderr){const n=new P.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stderr,"data")(o=>this.g.fire(typeof o=="string"?o:n.write(o))))}this.B(S.Event.fromNodeEventEmitter(t,"message")(n=>this.h.fire(n))),this.B(S.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&m.b.set(t.pid,{pid:t.pid,name:f(r)?`${r.type} [${r.responseWindowId}]`:r.type}),this.z("successfully created",d.default.Info),this.j.fire(t.pid)})),this.B(S.Event.fromNodeEventEmitter(t,"exit")(n=>{this.z(`received exit event with code ${n}`,d.default.Info),this.m.fire({pid:this.s,code:n,signal:"unknown"}),this.H()})),this.B(S.Event.fromNodeEventEmitter(i.app,"child-process-gone",(n,o)=>({event:n,details:o}))(({details:n})=>{n.type==="Utility"&&n.name===s&&(this.z(`crashed with code ${n.exitCode} and reason '${n.reason}'`,d.default.Error),this.w.publicLog2("utilityprocesscrash",{type:r.type,reason:n.reason,code:n.exitCode}),this.n.fire({pid:this.s,code:n.exitCode,reason:n.reason}),this.H())}))}once(t,r){const s=this.B(this.h.event(n=>{n===t&&(s.dispose(),r())}))}postMessage(t,r){return this.r?(this.r.postMessage(t,r),!0):!1}connect(t){const{port1:r,port2:s}=new i.MessageChannelMain;return this.postMessage(t,[s]),r}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",d.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",d.default.Info),this.r.kill()?(this.z("successfully killed the process",d.default.Info),this.H()):this.z("unable to kill the process",d.default.Warning)}H(){typeof this.s=="number"&&m.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",d.default.Info),await Promise.race([S.Event.toPromise(this.onExit),(0,k.$sh)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,d.default.Info),this.kill()))}};e.$Kbc=h,e.$Kbc=h=m=Se([ie(0,A.$Xj),ie(1,y.$Wl),ie(2,E.$xbc)],h);let w=class extends h{constructor(t,r,s,n){super(t,s,n),this.I=r}start(t){const r=this.I.getWindowById(t.responseWindowId);if(!r?.win||r.win.isDestroyed()||r.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",d.default.Error),!0;if(!super.D(t))return!1;this.J(r.win,t);const n=this.connect(t.payload);return r.win.webContents.postMessage(t.responseChannel,t.responseNonce,[n]),!0}J(t,r){r.windowLifecycleBound&&(this.B(S.Event.filter(this.y.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this.B(S.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$Lbc=w,e.$Lbc=w=Se([ie(0,A.$Xj),ie(1,l.$ebc),ie(2,y.$Wl),ie(3,E.$xbc)],w)}),define(re[297],oe([0,1,15,3,5,20,8,61,29,28]),function(J,e,i,D,S,A,P,k,u,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;let y=class{static{d=this}static{this.a=0}constructor($,g,v,p){this.d=$,this.f=g,this.g=v,this.h=p,this.b=new Map,this.c=!1,this.f.onWillShutdown(m=>{this.c=!0,m.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i($){const g=this.b.get($);if(!g)throw new Error("Unknown extension host!");return g}onDynamicStdout($){return this.i($).onStdout}onDynamicStderr($){return this.i($).onStderr}onDynamicMessage($){return this.i($).onMessage}onDynamicExit($){return this.i($).onExit}async createExtensionHost(){if(this.c)throw(0,i.$6)();const $=String(++d.a),g=new k.$Lbc(this.d,this.g,this.h,this.f);return this.b.set($,g),g.onExit(({pid:v,code:p,signal:m})=>{this.d.info(`Extension host with pid ${v} exited with code: ${p}, signal: ${m}.`),setTimeout(()=>{g.dispose(),this.b.delete($)}),setTimeout(()=>{try{process.kill(v,0),this.d.error(`Extension host with pid ${v} still exists, forcefully killing it...`),process.kill(v)}catch{}},1e3)}),{id:$}}async start($,g){if(this.c)throw(0,i.$6)();const v=this.i($);return v.start({...g,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:g.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:$}),{pid:await D.Event.toPromise(v.onSpawn)}}async enableInspectPort($){if(this.c)throw(0,i.$6)();const g=this.b.get($);return g?g.enableInspectPort():!1}async kill($){if(this.c)throw(0,i.$6)();const g=this.b.get($);g&&g.kill()}async _killAllNow(){for(const[,$]of this.b)$.kill()}async _waitForAllExit($){const g=[];for(const[,v]of this.b)g.push(v.waitForExit($));return P.Promises.settled(g).then(()=>{})}};e.$Sbc=y,e.$Sbc=y=d=Se([ie(0,S.$Xj),ie(1,A.$xbc),ie(2,u.$ebc),ie(3,l.$Wl)],y)}),define(re[298],oe([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;let p=class extends S.$Uc{constructor(f,h,w,a,t,r,s,n){super(),this.f=f,this.g=h,this.h=w,this.j=a,this.m=t,this.n=r,this.r=s,this.s=n,this.a=new D.$qh,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){i.$GW.on(v.$icc.request,(f,h)=>this.u(f,h,v.$icc.response)),i.$GW.on(v.$jcc.request,(f,h)=>this.u(f,h,v.$jcc.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(f,h,w){this.n.trace(`[SharedProcess] onWindowConnection for: ${w}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(w);if(f.sender.isDestroyed())return a.close();f.sender.postMessage(w,h,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(v.$hcc.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const f=new D.$Oh;this.b?.once(v.$hcc.initDone,()=>f.complete()),await f.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const f=new D.$Oh;this.b?.once(v.$hcc.ipcReady,()=>f.complete()),await f.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new y.$Kbc(this.n,E.$cp,this.m)),this.c=this.b.onMessage(w=>{typeof w.warning=="string"?this.n.warn(w.warning):typeof w.error=="string"&&this.n.error(w.error)});const f=(0,$.$6m)(this.h.args,this.h.isBuilt);let h;f.port&&(h=["--nolazy"],f.break?h.push(`--inspect-brk=${f.port}`):h.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:h})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(f){return await this.C,(0,g.$dg)(this.b).connect(f)}};e.$kcc=p,e.$kcc=p=Se([ie(2,A.$6ac),ie(3,u.$xl),ie(4,P.$xbc),ie(5,k.$Xj),ie(6,d.$sbc),ie(7,l.$_n)],p)}),define(re[299],oe([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=void 0;let v=class extends d.$Uc{constructor(m,f,h,w,a){super(),this.f=m,this.g=f,this.h=h,this.j=w,this.m=a,this.a=void 0,this.b=new y.$be,this.onRequestConnection=this.b.event,this.c=new y.$be,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),l.$GW.on("vscode:createPtyHostMessageChannel",(t,r)=>this.r(t,r)),this.B((0,d.$Sc)(()=>{l.$GW.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new k.$Kbc(this.m,P.$cp,this.j);const m=(0,D.$5m)(this.h.args,this.h.isBuilt),f=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:g.Schemas.file}).fsPath],env:this.n()});const h=this.a.connect(),w=new u.$OW(h,"ptyHost"),a=new d.$Tc;return a.add(w),a.add((0,d.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:w,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const m={...(0,E.$Xn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&(m.VSCODE_LATENCY=String(f));const h=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return h&&typeof h=="number"&&(m.VSCODE_STARTUP_DELAY=String(h)),this.h.restoreSnapExportedVariables(),m}r(m,f){this.b.fire();const h=this.a.connect();if(m.sender.isDestroyed()){h.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[h])}};e.$Wcc=v,e.$Wcc=v=Se([ie(1,$.$Xi),ie(2,i.$6ac),ie(3,S.$xbc),ie(4,A.$Xj)],v)}),define(re[300],oe([0,1,2,6,5,29,61,28,46,3,8,20]),function(J,e,i,D,S,A,P,k,u,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=void 0,e.$Ucc=(0,D.$ri)("utilityProcessWorker");let E=class extends i.$Uc{constructor(v,p,m,f){super(),this.b=v,this.c=p,this.f=m,this.g=f,this.a=new Map}async createWorker(v){const p=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${p})`);const m=this.h(v);this.a.has(m)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(v));const f=new $(this.b,this.c,this.f,this.g,v);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(m,f);const h=new d.$Oh;return l.Event.once(f.onDidTerminate)(w=>{w.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${w.code}, signal: ${w.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${w.code}, signal: ${w.signal}`),this.a.delete(m),h.complete({reason:w})}),h.p}h(v){return(0,u.$fj)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const p=this.h(v),m=this.a.get(p);m&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),m.kill(),this.a.delete(p))}};e.$Vcc=E,e.$Vcc=E=Se([ie(0,S.$Xj),ie(1,A.$ebc),ie(2,k.$Wl),ie(3,y.$xbc)],E);let $=class extends i.$Uc{constructor(v,p,m,f,h){super(),this.c=v,this.f=p,this.g=m,this.h=f,this.j=h,this.a=this.B(new l.$be),this.onDidTerminate=this.a.event,this.b=new P.$Lbc(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(v=>this.a.fire({code:v.code,signal:v.signal}))),this.B(this.b.onCrash(v=>this.a.fire({code:v.code,signal:"ECRASH"})))}spawn(){const p=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};$=Se([ie(0,S.$Xj),ie(1,A.$ebc),ie(2,k.$Wl),ie(3,y.$xbc)],$)}),define(re[301],oe([0,1,14,3,2,277,29]),function(J,e,i,D,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;let k=class extends S.$Uc{constructor(l){super(),this.b=l,this.a=this.B(new D.$be),this.onFoundInFrame=this.a.event,this.B(new A.$Bcc)}async setIgnoreMenuShortcuts(l,d){let y;if(typeof l.windowId=="number"){const{windowId:E}=l,$=this.b.getWindowById(E);if(!$?.win)throw new Error(`Invalid windowId: ${E}`);y=$.win.webContents}else{const{webContentsId:E}=l;if(y=i.webContents.fromId(E),!y)throw new Error(`Invalid webContentsId: ${E}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(d)}async findInFrame(l,d,y,E){const g=this.c(l,d);if(typeof g.findInFrame=="function"){g.findInFrame(y,{findNext:E.findNext,forward:E.forward});const v=(p,m)=>{m.finalUpdate&&(this.a.fire(m),g.removeListener("found-in-frame",v))};g.on("found-in-frame",v)}}async stopFindInFrame(l,d,y){const $=this.c(l,d);typeof $.stopFindInFrame=="function"&&$.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(l,d){const y=this.b.getWindowById(l.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${l}`);const E=y.win.webContents.mainFrame.framesInSubtree.find($=>$.name===d);if(!E)throw new Error(`Unknown frame: ${d}`);return E}};e.$Ccc=k,e.$Ccc=k=Se([ie(0,P.$ebc)],k)}),define(re[302],oe([0,1,14,2,4,19,7,18,20,5,34,29,82,30]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0,e.$Ecc=p,e.$Fcc=f;let v=class extends D.$Uc{static{g=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,r,s,n){super(),this.g=a,this.h=t,this.j=r,this.m=s,this.n=n,this.b=p(this.h.getItem(g.a)),this.c=void 0,this.f=!1,this.r()}r(){i.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(o=>!o.isExtensionDevelopmentHost)),n&&(t.lastActiveWindow=this.w(n),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const r=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);r&&(t.lastPluginDevelopmentHostWindow=this.w(r),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?S.$j&&!r.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const o=this.w(n);return o.uiState.mode===3&&(a.has(o.uiState.display)?S.$j&&o.windowId!==t.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(o.uiState.mode=1):a.add(o.uiState.display)),o}));const s=f(t);this.h.setItem(g.a,s),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",s)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(r=>{const s=(0,$.$Gi)(a.openedWorkspace)&&r.workspace?.id===a.openedWorkspace.id,n=(0,$.$Bi)(a.openedWorkspace)&&r.folderUri&&A.$Vg.isEqual(r.folderUri,a.openedWorkspace.uri);(s||n)&&(r.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,$.$Gi)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,$.$Bi)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),r=this.n.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(r?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(r.newWindowDimensions)>=0):s=!!(this.j.wasRestarted||r?.restoreFullscreen),s||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=a.workspace;if((0,$.$Gi)(b)){const I=this.state.openedWindows.filter(j=>j.workspace&&j.workspace.id===b.id).map(j=>j.uiState);if(I.length)return I[0]}if((0,$.$Bi)(b)){const I=this.state.openedWindows.filter(j=>j.folderUri&&A.$Vg.isEqual(j.folderUri,b.uri)).map(j=>j.uiState);if(I.length)return I[0]}else if(a.backupPath){const I=this.state.openedWindows.filter(j=>j.backupPath===a.backupPath).map(j=>j.uiState);if(I.length)return I[0]}const L=this.c||this.state.lastActiveWindow;if(!t&&L)return L.uiState}let r;const s=i.screen.getAllDisplays();if(s.length===1)r=s[0];else{if(S.$j){const b=i.screen.getCursorScreenPoint();r=i.screen.getDisplayNearestPoint(b)}!r&&t&&(r=i.screen.getDisplayMatching(t.getBounds())),r||(r=i.screen.getPrimaryDisplay()||s[0])}let n=(0,E.$4ac)();n.x=Math.round(r.bounds.x+r.bounds.width/2-n.width/2),n.y=Math.round(r.bounds.y+r.bounds.height/2-n.height/2);const o=this.n.getValue("window");let c=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")n.mode=0,c=!1;else if(o.newWindowDimensions==="fullscreen")n.mode=3,c=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?n.mode=3:n={...b,zoomLevel:void 0},c=n.mode!==3&&o.newWindowDimensions==="offset"}}return c&&(n=this.C(n)),n.hasDefaultState=!0,n}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(r=>r.getBounds());for(;t.some(r=>r.x===a.x||r.y===a.y);)a.x+=30,a.y+=30;return a}};e.$Dcc=v,e.$Dcc=v=g=Se([ie(0,y.$ebc),ie(1,d.$vQ),ie(2,u.$xbc),ie(3,l.$Xj),ie(4,k.$Xi)],v);function p(w){const a={openedWindows:[]},t=w||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=m(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=m(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(r=>m(r))),a}function m(w){const a={uiState:w.uiState};return w.backupPath&&(a.backupPath=w.backupPath),w.remoteAuthority&&(a.remoteAuthority=w.remoteAuthority),w.folder&&(a.folderUri=P.URI.parse(w.folder)),w.workspaceIdentifier&&(a.workspace={id:w.workspaceIdentifier.id,configPath:P.URI.parse(w.workspaceIdentifier.configURIPath)}),a}function f(w){return{lastActiveWindow:w.lastActiveWindow&&h(w.lastActiveWindow),lastPluginDevelopmentHostWindow:w.lastPluginDevelopmentHostWindow&&h(w.lastPluginDevelopmentHostWindow),openedWindows:w.openedWindows.map(a=>h(a))}}function h(w){return{workspaceIdentifier:w.workspace&&{id:w.workspace.id,configURIPath:w.workspace.configPath.toString()},folder:w.folderUri&&w.folderUri.toString(),backupPath:w.backupPath,remoteAuthority:w.remoteAuthority,uiState:w.uiState}}}),define(re[58],oe([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=void 0,e.$qbc=(0,g.$ri)("workspacesManagementMainService");let a=class extends A.$Uc{constructor(r,s,n,o,c){super(),this.g=r,this.h=s,this.j=n,this.m=o,this.n=c,this.a=this.B(new D.$be),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new D.$be),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const r=(await l.Promises.readdir(this.c.with({scheme:P.Schemas.file}).fsPath)).map(s=>(0,u.$5g)(this.c,s,f.$Qi));for(const s of r){const n=(0,w.$nbc)(s),o=await this.resolveLocalWorkspace(s);o?this.f.push({workspace:n,remoteAuthority:o.remoteAuthority}):await this.deleteUntitledWorkspace(n)}}catch(r){r.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${r}).`)}}resolveLocalWorkspace(r){return this.r(r,s=>l.Promises.readFile(s,"utf8"))}r(r,s){if(this.s(r)&&r.scheme===P.Schemas.file)try{const n=s(r.fsPath);return n instanceof Promise?n.then(o=>this.t(r,o),o=>{}):this.t(r,n)}catch{return}}s(r){return(0,f.$Ri)(r,this.g)||(0,f.$Wi)(r)}t(r,s){try{const n=this.u(r,s),o=(0,w.$nbc)(r);return{id:o.id,configPath:o.configPath,folders:(0,h.$8fb)(n.folders,o.configPath,u.$Vg),remoteAuthority:n.remoteAuthority,transient:n.transient}}catch(n){this.h.warn(n.toString())}}u(r,s){const n=(0,S.$En)(s);if(n&&Array.isArray(n.folders))n.folders=n.folders.filter(o=>(0,h.$6fb)(o));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return n}async createUntitledWorkspace(r,s){const{workspace:n,storedWorkspace:o}=this.w(r,s),c=n.configPath.fsPath;return await l.Promises.mkdir((0,k.$nc)(c),{recursive:!0}),await l.Promises.writeFile(c,JSON.stringify(o,null,"	")),this.f.push({workspace:n,remoteAuthority:s}),n}w(r=[],s){const n=(Date.now()+Math.round(Math.random()*1e3)).toString(),o=(0,u.$5g)(this.c,n),c=(0,u.$5g)(o,f.$Qi),b=[];for(const L of r)b.push((0,h.$7fb)(L.uri,!0,L.name,o,u.$Vg));return{workspace:(0,w.$nbc)(c),storedWorkspace:{folders:b,remoteAuthority:s}}}async getWorkspaceIdentifier(r){return(0,w.$nbc)(r)}isUntitledWorkspace(r){return(0,f.$Ri)(r.configPath,this.g)}async deleteUntitledWorkspace(r){this.isUntitledWorkspace(r)&&(await this.y(r),this.j.isEnabled()&&this.j.unsetWorkspace(r),this.a.fire(r))}async y(r){const s=(0,u.$Sg)(r.configPath);try{await l.Promises.rm((0,k.$nc)(s));const n=(0,k.$kc)(this.g.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath,r.id);await l.Promises.exists(n)&&await l.Promises.writeFile((0,k.$kc)(n,"obsolete"),""),this.f=this.f.filter(o=>o.workspace.id!==r.id)}catch(n){this.h.warn(`Unable to delete untitled workspace ${s} (${n}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(r,s,n){if(!r||!r.win||!r.isReady||!await this.z(r,s,n))return;const c=await this.C(r,(0,w.$nbc)(n));if(c)return this.b.fire({window:r,workspace:c.workspace}),c}async z(r,s,n){return n?(0,f.$Gi)(r.openedWorkspace)&&u.$Vg.isEqual(r.openedWorkspace.configPath,n)?!1:(0,m.$kbc)(s,n)?(await this.n.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:(0,d.localize)(1,null,(0,u.$2g)(n)),detail:(0,d.localize)(2,null)},i.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(r,s){if(!r.config)return;r.focus();let n;return r.config.extensionDevelopmentPath||(r.config.backupPath?n=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority},r.config.backupPath):n=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority})),(0,f.$Gi)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=s,r.config.backupPath=n,{workspace:s,backupPath:n}}};e.$rbc=a,e.$rbc=a=Se([ie(0,$.$6ac),ie(1,v.$Xj),ie(2,p.$hbc),ie(3,y.$$ac),ie(4,E.$_ac)],a)}),define(re[134],oe([0,1,14,37,23,6,29,30,58,12,5,61]),function(J,e,i,D,S,A,P,k,u,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=e.ID=void 0,e.ID="diagnosticsMainService",e.$Nbc=(0,A.$ri)(e.ID);let E=class{constructor(g,v,p){this.a=g,this.b=v,this.c=p}async getRemoteDiagnostics(g){const v=this.a.getWindows();return(await Promise.all(v.map(async m=>{const f=m.remoteAuthority;if(!f)return;const h=`vscode:getDiagnosticInfoResponse${m.id}`,w={includeProcesses:g.includeProcesses,folders:g.includeWorkspaceMetadata?await this.f(m):void 0};return new Promise(a=>{m.sendWhenReady("vscode:getDiagnosticInfo",S.CancellationToken.None,{replyChannel:h,args:w}),D.$GW.once(h,(t,r)=>{r||a({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),a(r)}),setTimeout(()=>{a({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter(m=>!!m)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const g=[];for(const p of i.BrowserWindow.getAllWindows()){const m=this.a.getWindowById(p.id);m?g.push(await this.d(m)):g.push(this.e(p))}const v=[];for(const{pid:p,name:m}of y.$Kbc.getAll())v.push({pid:p,name:m});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:g,pidToNames:v,screenReader:!!i.app.accessibilitySupportEnabled,gpuFeatureStatus:i.app.getGPUFeatureStatus()}}async d(g){const v=await this.f(g),p=(0,l.$dg)(g.win);return this.e(p,v,g.remoteAuthority)}e(g,v=[],p){return{id:g.id,pid:g.webContents.getOSProcessId(),title:g.getTitle(),folderURIs:v,remoteAuthority:p}}async f(g){const v=[],p=g.openedWorkspace;if((0,k.$Bi)(p))v.push(p.uri);else if((0,k.$Gi)(p)){const m=await this.b.resolveLocalWorkspace(p.configPath);m&&m.folders.forEach(h=>{v.push(h.uri)})}return v}};e.$Obc=E,e.$Obc=E=Se([ie(0,P.$ebc),ie(1,u.$qbc),ie(2,d.$Xj)],E)}),define(re[70],oe([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,79,15]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w,a,t,r,s,n,o,c,b,L,I,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=e.$3bc=void 0,e.$3bc=(0,w.$ri)("nativeHostMainService");let R=class extends u.$Uc{constructor(F,T,q,ue,ee,ce,K,X,B){super(),this.a=F,this.b=T,this.c=q,this.f=ue,this.g=ee,this.h=ce,this.j=K,this.m=X,this.n=B,this.onDidOpenMainWindow=k.Event.map(this.a.onDidOpenWindow,M=>M.id),this.onDidTriggerWindowSystemContextMenu=k.Event.any(k.Event.map(this.a.onDidTriggerSystemContextMenu,({window:M,x:z,y:U})=>({windowId:M.id,x:z,y:U})),k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:M,x:z,y:U})=>({windowId:M.id,x:z,y:U}))),this.onDidMaximizeWindow=k.Event.any(k.Event.map(this.a.onDidMaximizeWindow,M=>M.id),k.Event.map(this.b.onDidMaximizeWindow,M=>M.id)),this.onDidUnmaximizeWindow=k.Event.any(k.Event.map(this.a.onDidUnmaximizeWindow,M=>M.id),k.Event.map(this.b.onDidUnmaximizeWindow,M=>M.id)),this.onDidChangeWindowFullScreen=k.Event.any(k.Event.map(this.a.onDidChangeFullScreen,M=>({windowId:M.window.id,fullscreen:M.fullscreen})),k.Event.map(this.b.onDidChangeFullScreen,M=>({windowId:M.window.id,fullscreen:M.fullscreen}))),this.onDidBlurMainWindow=k.Event.filter(k.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(M,z)=>z.id),M=>!!this.a.getWindowById(M)),this.onDidFocusMainWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),M=>!!M),M=>M.id),k.Event.filter(k.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(M,z)=>z.id),M=>!!this.a.getWindowById(M))),this.onDidBlurMainOrAuxiliaryWindow=k.Event.any(this.onDidBlurMainWindow,k.Event.map(k.Event.filter(k.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(M,z)=>this.b.getWindowByWebContents(z.webContents)),M=>!!M),M=>M.id)),this.onDidFocusMainOrAuxiliaryWindow=k.Event.any(this.onDidFocusMainWindow,k.Event.map(k.Event.filter(k.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(M,z)=>this.b.getWindowByWebContents(z.webContents)),M=>!!M),M=>M.id)),this.onDidResumeOS=k.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new k.$be),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(M,z,U)=>U),M=>!(Array.isArray(M)&&M.length===1&&M[0]==="workArea")),k.Event.fromNodeEventEmitter(D.screen,"display-added"),k.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,T){const q=this.a.getWindows().map(ee=>({id:ee.id,workspace:ee.openedWorkspace??(0,o.$Fi)(ee.backupPath,ee.isExtensionDevelopmentHost),title:ee.win?.getTitle()??"",filename:ee.getRepresentedFilename(),dirty:ee.isDocumentEdited()})),ue=[];return T.includeAuxiliaryWindows&&ue.push(...this.b.getWindows().map(ee=>({id:ee.id,parentId:ee.parentId,title:ee.win?.getTitle()??"",filename:ee.getRepresentedFilename()}))),[...q,...ue]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const T=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(T)return T.id}openWindow(F,T,q){return Array.isArray(T)?this.s(F,T,q):this.t(F,T)}async s(F,T,q=Object.create(null)){T.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:T,cli:this.g.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0,forceProfile:q.forceProfile,forceTempProfile:q.forceTempProfile})}async t(F,T){await this.a.openEmptyWindow({context:5,contextWindowId:F},T)}async toggleFullScreen(F,T){this.C(T?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,T){this.C(T?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const T=D.screen.getCursorScreenPoint(),q=D.screen.getDisplayNearestPoint(T);return{point:T,display:q.bounds}}async isMaximized(F,T){return this.C(T?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,T){this.C(T?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,T,q){const ue=this.C(q?.targetWindowId,F);if(ue?.win){if(ue.win.isFullScreen()){const ee=k.Event.toPromise(k.Event.once(k.Event.fromNodeEventEmitter(ue.win,"leave-full-screen")));ue.win.setFullScreen(!1),await ee}ue.win.setBounds(T)}}async updateWindowControls(F,T){this.C(T?.targetWindowId,F)?.updateWindowControls(T)}async focusWindow(F,T){this.C(T?.targetWindowId,F)?.focus({force:T?.force??!1})}async setMinimumSize(F,T,q){const ue=this.D(F);if(ue?.win){const[ee,ce]=ue.win.getSize(),[K,X]=ue.win.getMinimumSize(),[B,M]=[T??K,q??X],[z,U]=[Math.max(ee,B),Math.max(ce,M)];(K!==B||X!==M)&&ue.win.setMinimumSize(B,M),(ee!==z||ce!==U)&&ue.win.setSize(z,U)}}async saveWindowSplash(F,T){this.m.saveWindowSplash(F,T)}async installShellCommand(F){const{source:T,target:q}=await this.u();try{const{symbolicLink:ue}=await v.SymlinkSupport.stat(T);if(ue&&!ue.dangling){const ee=await(0,$.$1q)(T);if(q===ee)return}await v.Promises.unlink(T)}catch(ue){if(ue.code!=="ENOENT")throw ue}try{await v.Promises.symlink(q,T)}catch(ue){if(ue.code!=="EACCES"&&ue.code!=="ENOENT")throw ue;const{response:ee}=await this.showMessageBox(F,{type:"info",message:(0,m.localize)(0,null,this.j.nameShort),buttons:[(0,m.localize)(1,null),(0,m.localize)(2,null)]});if(ee===1)throw new O.$5;try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${T}'\\" with administrator privileges"`;await(0,A.promisify)(i.exec)(ce)}catch{throw new Error((0,m.localize)(3,null,T))}}}async uninstallShellCommand(F){const{source:T}=await this.u();try{await v.Promises.unlink(T)}catch(q){switch(q.code){case"EACCES":{const{response:ue}=await this.showMessageBox(F,{type:"info",message:(0,m.localize)(4,null,this.j.nameShort),buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]});if(ue===1)throw new O.$5;try{const ee=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,A.promisify)(i.exec)(ee)}catch{throw new Error((0,m.localize)(7,null,T))}break}case"ENOENT":break;default:throw q}}}async u(){const F=(0,d.$lc)(this.g.appRoot,"bin","code"),T=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(F))throw new Error((0,m.localize)(8,null,F));return{source:T,target:F}}async showMessageBox(F,T){const q=this.C(T?.targetWindowId,F);return this.c.showMessageBox(T,q?.win??void 0)}async showSaveDialog(F,T){const q=this.C(T?.targetWindowId,F);return this.c.showSaveDialog(T,q?.win??void 0)}async showOpenDialog(F,T){const q=this.C(T?.targetWindowId,F);return this.c.showOpenDialog(T,q?.win??void 0)}async pickFileFolderAndOpen(F,T){const q=await this.c.pickFileFolder(T);q&&await this.w(await Promise.all(q.map(async ue=>await v.SymlinkSupport.existsDirectory(ue)?{folderUri:E.URI.file(ue)}:{fileUri:E.URI.file(ue)})),T,F)}async pickFolderAndOpen(F,T){const q=await this.c.pickFolder(T);q&&await this.w(q.map(ue=>({folderUri:E.URI.file(ue)})),T,F)}async pickFileAndOpen(F,T){const q=await this.c.pickFile(T);q&&await this.w(q.map(ue=>({fileUri:E.URI.file(ue)})),T,F)}async pickWorkspaceAndOpen(F,T){const q=await this.c.pickWorkspace(T);q&&await this.w(q.map(ue=>({workspaceUri:E.URI.file(ue)})),T,F)}async w(F,T,q){await this.a.open({context:3,contextWindowId:q,cli:this.g.args,urisToOpen:F,forceNewWindow:T.forceNewWindow})}async showItemInFolder(F,T){D.shell.showItemInFolder(T)}async setRepresentedFilename(F,T,q){this.C(q?.targetWindowId,F)?.setRepresentedFilename(T)}async setDocumentEdited(F,T,q){this.C(q?.targetWindowId,F)?.setDocumentEdited(T)}async openExternal(F,T){return this.g.unsetSnapExportedVariables(),D.shell.openExternal(T),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,T){return D.shell.trashItem(T)}async isAdmin(){let F;return y.$i?F=(await new Promise((T,q)=>{J(["native-is-elevated"],T,q)}))():F=process.getuid?.()===0,F}async writeElevated(F,T,q,ue){const ee=await new Promise((ce,K)=>{J(["@vscode/sudo-prompt"],ce,K)});return new Promise((ce,K)=>{const X=[`"${this.z}"`];ue?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${T.fsPath}"`,`"${q.fsPath}"`);const B={name:this.j.nameLong.replace("-",""),icns:y.$j&&this.g.isBuilt?(0,d.$kc)((0,d.$nc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ee.exec(X.join(" "),B,(M,z,U)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),U&&this.h.trace(`[sudo-prompt] received stderr: ${U}`),M?K(M):ce(void 0)})})}async isRunningUnderARM64Translation(){return y.$k||y.$i?!1:D.app.runningUnderARM64Translation}get z(){return y.$i?this.g.isBuilt?(0,d.$kc)((0,d.$nc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,d.$kc)(this.g.appRoot,"scripts","code-cli.bat"):y.$k?this.g.isBuilt?(0,d.$kc)((0,d.$nc)(process.execPath),"bin",`${this.j.applicationName}`):(0,d.$kc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,d.$kc)(this.g.appRoot,"bin","code"):(0,d.$kc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,S.totalmem)(),freemem:(0,S.freemem)(),loadavg:(0,S.loadavg)()}}async getOSProperties(){return{arch:(0,S.arch)(),platform:(0,S.platform)(),release:(0,S.release)(),type:(0,S.type)(),cpus:(0,S.cpus)()}}async getOSVirtualMachineHint(){return g.$zn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return y.$i&&(0,L.$Zbc)()}async killProcess(F,T,q){process.kill(T,q)}async readClipboardText(F,T){return D.clipboard.readText(T)}async writeClipboardText(F,T,q){return D.clipboard.writeText(T,q)}async readClipboardFindText(F){return D.clipboard.readFindText()}async writeClipboardFindText(F,T){return D.clipboard.writeFindText(T)}async writeClipboardBuffer(F,T,q,ue){return D.clipboard.writeBuffer(T,Buffer.from(q.buffer),ue)}async readClipboardBuffer(F,T){return b.$Ce.wrap(D.clipboard.readBuffer(T))}async hasClipboard(F,T,q){return D.clipboard.has(T,q)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,T){this.D(F)?.updateTouchBar(T)}async notifyReady(F){this.D(F)?.setReady()}async relaunch(F,T){return this.f.relaunch(T)}async reload(F,T){const q=this.D(F);if(q){if((0,o.$Gi)(q.openedWorkspace)){const ue=q.openedWorkspace.configPath;if(ue.scheme===l.Schemas.file&&(await this.n.resolveLocalWorkspace(ue))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.f.reload(q,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(F,T){return this.C(T?.targetWindowId,F)?.win?.close()}async quit(F){const T=this.a.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&T.win?T.win.close():this.f.quit()}async exit(F,T){await this.f.kill(T)}async resolveProxy(F,T){return this.D(F)?.win?.webContents?.session?.resolveProxy(T)}async loadCertificates(F){return(await new Promise((q,ue)=>{J(["@vscode/proxy-agent"],q,ue)})).loadSystemCertificates({log:this.h})}findFreePort(F,T,q,ue,ee=1){return(0,p.$Pg)(T,q,ue,ee)}async openDevTools(F,T){this.C(T?.targetWindowId,F)?.win?.webContents.openDevTools(T?.mode?{mode:T.mode,activate:T.activate}:void 0)}async toggleDevTools(F,T){this.C(T?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,T,q){const ue=this.D(F);if(!ue||!ue.win)throw new Error;return await new I.$1bc(ue.win,T,this.h).inspect(q)}async windowsGetStringRegKey(F,T,q,ue){if(!y.$i)return;const ee=await new Promise((ce,K)=>{J(["@vscode/windows-registry"],ce,K)});try{return ee.GetStringRegKey(T,q,ue)}catch{return}}C(F,T){return this.D(F)??this.F(F)??this.D(T)}D(F){if(typeof F=="number")return this.a.getWindowById(F)}F(F){if(typeof F!="number")return;const T=D.webContents.fromId(F);if(T)return this.b.getWindowByWebContents(T)}};e.$4bc=R,Se([P.$Vh],R.prototype,"z",null),e.$4bc=R=Se([ie(0,n.$ebc),ie(1,j.$2bc),ie(2,f.$_ac),ie(3,a.$xbc),ie(4,h.$6ac),ie(5,t.$Xj),ie(6,r.$ek),ie(7,s.$cbc),ie(8,c.$qbc)],R)}),define(re[303],oe([0,1,14,26,8,23,32,2,13,4,111,37,182,92,134,56,24,5,70,80,27,81,34,61,55,29]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w,a,t,r,s,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;const c="issue.processExplorerWindowState";let b=class{static{o=this}static{this.a="#1E1E1E"}constructor(j,O,R,W,F,T,q,ue,ee,ce,K){this.g=j,this.h=O,this.i=R,this.j=W,this.k=F,this.l=T,this.m=q,this.n=ue,this.o=ee,this.p=ce,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){y.$GW.on("vscode:listProcesses",async j=>{const O=[];try{O.push({name:(0,E.localize)(0,null),rootProcess:await(0,d.$xs)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,$.$_m)(W)?O.push({name:W.hostName,rootProcess:W}):W.processes&&O.push({name:W.hostName,rootProcess:W.processes})})}catch(R){this.i.error(`Listing processes failed: ${R}`)}this.t(j,"vscode:listProcessesResponse",O)}),y.$GW.on("vscode:workbenchCommand",(j,O)=>{const{id:R,from:W,args:F}=O;let T;switch(W){case"processExplorer":T=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}T?.webContents.send("vscode:runAction",{id:R,from:W,args:F})}),y.$GW.on("vscode:closeProcessExplorer",j=>{this.d?.close()}),y.$GW.on("vscode:pidToNameRequest",async j=>{const O=await this.k.getMainDiagnostics(),R=[];for(const W of O.windows)R.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:F}of r.$Kbc.getAll())R.push([W,F]);this.t(j,"vscode:pidToNameResponse",R)})}async openReporter(j){if(this.b)this.b&&this.s(this.b);else if(this.c=i.BrowserWindow.getFocusedWindow(),this.c){const O=new k.$Tc,R=O.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,R,{backgroundColor:j.styles.backgroundColor,title:(0,E.localize)(1,null),zoomLevel:j.zoomLevel,alwaysOnTop:!1},"issue-reporter"),R.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:j,disableExtensions:!!this.h.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:h.default}),this.b.loadURL(u.$Lg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,O.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,O.dispose())})}}async openProcessExplorer(j){if(!this.d&&(this.f=i.BrowserWindow.getFocusedWindow(),this.f)){const O=new k.$Tc,R=O.add(this.n.createIPCObjectUrl()),W=this.p.getItem(c,void 0),F=L(W)?W:this.v(this.f,800,500);this.d=this.u(F,R,{backgroundColor:j.styles.backgroundColor,title:(0,E.localize)(2,null),zoomLevel:j.zoomLevel,alwaysOnTop:!0},"process-explorer"),R.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:j,product:h.default}),this.d.loadURL(u.$Lg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,O.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,O.dispose())});const T=()=>{if(!this.d)return;const q=this.d.getSize(),ue=this.d.getPosition();if(!q||!ue)return;const ee={width:q[0],height:q[1],x:ue[0],y:ue[1]};this.p.setItem(c,ee)};this.d.on("moved",T),this.d.on("resized",T)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const j=await i.contentTracing.stopRecording(`${(0,P.$zg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,E.localize)(3,null),detail:(0,E.localize)(4,null,j),buttons:[(0,E.localize)(5,null)]},i.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,j)}async getSystemStatus(){const[j,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(j,O)}async $getSystemInfo(){const[j,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(j,O)}async $getPerformanceInfo(){try{const[j,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(j,O)}catch(j){throw this.i.warn("issueService#getPerformanceInfo ",j.message),j}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(j){this.i.error(j)}}async $showConfirmCloseDialog(){if(this.b){const{response:j}=await this.l.showMessageBox({type:"warning",message:(0,E.localize)(6,null),buttons:[(0,E.localize)(7,null),(0,E.localize)(8,null)]},this.b);j===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:j}=await this.l.showMessageBox({type:"warning",message:(0,E.localize)(9,null),buttons:[(0,E.localize)(10,null),(0,E.localize)(11,null)]},this.b);return j===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const j=this.q.getWindowById(this.c.id);if(!j)throw new Error("Window not found");return j}async $sendReporterMenu(j,O){const R=this.issueReporterWindowCheck(),W="vscode:triggerReporterMenu",F=new A.$me;return R.sendWhenReady(W,F.token,{replyChannel:W,extensionId:j,extensionName:O}),await(0,S.$ih)(new Promise(q=>y.$GW.once(`vscode:triggerReporterMenuResponse:${j}`,(ue,ee)=>q(ee))),5e3,()=>{this.i.error(`Error: Extension ${j} timed out waiting for menu response`),F.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(j){j.isMinimized()&&j.restore(),j.focus()}t(j,O,...R){j.sender.isDestroyed()||j.sender.send(O,...R)}u(j,O,R,W){const F=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:j.width,height:j.height,minWidth:300,minHeight:200,x:j.x,y:j.y,title:R.title,backgroundColor:R.backgroundColor||o.a,webPreferences:{preload:u.$Lg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$yD)(R.zoomLevel),sandbox:!0},alwaysOnTop:R.alwaysOnTop,experimentalDarkMode:!0});return F.setMenuBarVisibility(!1),F}v(j,O,R){let W;const F=i.screen.getAllDisplays();if(F.length===1)W=F[0];else{if(l.$j){const ue=i.screen.getCursorScreenPoint();W=i.screen.getDisplayNearestPoint(ue)}!W&&j&&(W=i.screen.getDisplayMatching(j.getBounds())),W||(W=i.screen.getPrimaryDisplay()||F[0])}const T=W.bounds,q={width:O,height:R,x:T.x+T.width/2-O/2,y:T.y+T.height/2-R/2};return T.width>0&&T.height>0&&(q.x<T.x&&(q.x=T.x),q.y<T.y&&(q.y=T.y),q.x>T.x+T.width&&(q.x=T.x),q.y>T.y+T.height&&(q.y=T.y),q.width>T.width&&(q.width=T.width),q.height>T.height&&(q.height=T.height)),q}};e.$5bc=b,e.$5bc=b=o=Se([ie(1,p.$6ac),ie(2,m.$Xj),ie(3,$.$$m),ie(4,g.$Nbc),ie(5,v.$_ac),ie(6,f.$3bc),ie(7,a.$bbc),ie(8,w.$ek),ie(9,t.$vQ),ie(10,n.$ebc)],b);function L(I){return typeof I!="object"||I===null?!1:"x"in I&&"y"in I&&"width"in I&&"height"in I}}),define(re[304],oe([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(J,e,i,D,S,A,P,k,u,l,d,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;let $=class extends E.$rcc{constructor(v,p,m,f,h,w,a,t){super(v,p,f,h,w,t),this.e=m,this.u=a}s(v){return(0,E.$qcc)(`linux-${process.arch}`,v,this.k)}t(v){this.a&&(this.d(y.$EX.CheckingForUpdates(v)),this.i.request({url:this.a},i.CancellationToken.None).then(l.$Op).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(y.$EX.Idle(1))):this.d(y.$EX.AvailableForDownload(p))}).then(void 0,p=>{this.j.error(p);const m=v?p.message||p:void 0;this.d(y.$EX.Idle(1,m))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(y.$EX.Idle(1))}};e.$tcc=$,e.$tcc=$=Se([ie(0,A.$xbc),ie(1,D.$Xi),ie(2,d.$Wl),ie(3,S.$6ac),ie(4,l.$Ip),ie(5,P.$Xj),ie(6,k.$3bc),ie(7,u.$ek)],$)}),define(re[305],oe([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;async function s(b,L=1e3){for(;!b();)await(0,A.$sh)(L)}let n;function o(){return typeof n>"u"&&(n=D.existsSync(l.$kc(l.$nc(process.execPath),"unins000.exe"))?0:1),n}let c=class extends r.$rcc{get cachePath(){const L=l.$kc((0,S.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return E.Promises.mkdir(L,{recursive:!0}).then(()=>L)}constructor(L,I,j,O,R,W,F,T,q){super(L,I,O,R,W,q),this.u=j,this.v=F,this.w=T,L.setRelaunchHandler(this)}handleRelaunch(L){return L?.addArgs||L?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$EX.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(L){let I=`win32-${process.arch}`;return o()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,r.$qcc)(I,L,this.k)}t(L){this.a&&(this.d(t.$EX.CheckingForUpdates(L)),this.i.request({url:this.a},P.CancellationToken.None).then(w.$Op).then(I=>{const j=o();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!L}),this.d(t.$EX.Idle(j)),Promise.resolve(null)):j===1?(this.d(t.$EX.AvailableForDownload(I)),Promise.resolve(null)):(this.d(t.$EX.Downloading),this.C(I.version).then(()=>this.B(I.version).then(O=>E.Promises.exists(O).then(R=>{if(R)return Promise.resolve(O);const W=`${O}.tmp`;return this.i.request({url:I.url},P.CancellationToken.None).then(F=>this.v.writeFile(d.URI.file(W),F.stream)).then(I.sha256hash?()=>(0,y.$zW)(W,I.sha256hash):()=>{}).then(()=>E.Promises.rename(W,O,!1)).then(()=>O)})).then(O=>{this.e={packagePath:O},this.d(t.$EX.Downloaded(I)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$EX.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,u.$fj)(String(I)))}),this.j.error(I);const j=L?I.message||I:void 0;this.d(t.$EX.Idle(o(),j))}))}async o(L){L.update.url&&this.w.openExternal(void 0,L.update.url),this.d(t.$EX.Idle(o()))}async B(L){const I=await this.cachePath;return l.$kc(I,`CodeSetup-${this.k.quality}-${L}.exe`)}async C(L=null){const I=L?W=>!new RegExp(`${this.k.quality}-${L}\\.exe$`).test(W):()=>!0,j=await this.cachePath,R=(await E.Promises.readdir(j)).filter(I).map(async W=>{try{await E.Promises.unlink(l.$kc(j,W))}catch{}});await Promise.all(R)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const L=this.state.update;this.d(t.$EX.Updating(L));const I=await this.cachePath;this.e.updateFilePath=l.$kc(I,`CodeSetup-${this.k.quality}-${L.version}.flag`),await E.Promises.writeFile(this.e.updateFilePath,"flag"),(0,i.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$EX.Idle(o()))});const O=`${this.k.win32MutexName}-ready`,R=await new Promise((W,F)=>{J(["@vscode/windows-mutex"],W,F)});s(()=>R.isActive(O)).then(()=>this.d(t.$EX.Ready(L)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?D.unlinkSync(this.e.updateFilePath):(0,i.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return o()}async _applySpecificUpdate(L){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),j={version:"unknown",productVersion:"unknown"};this.d(t.$EX.Downloading),this.e={packagePath:L},this.d(t.$EX.Downloaded(j)),I?this.k.target==="user"&&this.p():this.d(t.$EX.Ready(j))}};e.$vcc=c,Se([k.$Vh],c.prototype,"cachePath",null),e.$vcc=c=Se([ie(0,p.$xbc),ie(1,$.$Xi),ie(2,a.$Wl),ie(3,g.$6ac),ie(4,w.$Ip),ie(5,m.$Xj),ie(6,v.$Xk),ie(7,f.$3bc),ie(8,h.$ek)],c)}),define(re[135],oe([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,81,256,84,28,106,69,55,29,30,58,82,39,34,57,67,22,6]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w,a,t,r,s,n,o,c,b,L,I,j,O,R,W,F,T,q,ue,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=e.$ubc=void 0;var ce;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(ce||(ce={}));class K extends k.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(M){this.m=M,this.B(P.Event.fromNodeEventEmitter(M,"maximize")(()=>this.b.fire())),this.B(P.Event.fromNodeEventEmitter(M,"unmaximize")(()=>this.c.fire())),this.B(P.Event.fromNodeEventEmitter(M,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(P.Event.fromNodeEventEmitter(M,"focus")(()=>{this.j=Date.now()})),this.B(P.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(P.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const z=!(0,L.$uD)(this.r);if(d.$j&&z&&M.setSheetOffset((0,d.$J)((0,$.release)())?28:22),z&&(d.$i&&(0,L.$wD)(this.r)||d.$j)){const U=this.s.getItem(K.D);U&&this.updateWindowControls({height:U})}d.$i&&z&&M.hookWindowMessage(278,()=>{const[ae,G]=M.getPosition(),le=i.screen.getCursorScreenPoint(),Y=le.x-ae,C=le.y-G;return!(Y>30&&C>=0&&C<=Math.max(M.getBounds().height*.15,35))||(M.setEnabled(!1),M.setEnabled(!0),this.f.fire({x:Y,y:C})),0}),this.t.args["open-devtools"]===!0&&M.webContents.openDevTools(),d.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(M,z,U,ae){super(),this.r=M,this.s=z,this.t=U,this.u=ae,this.a=this.B(new P.$be),this.onDidClose=this.a.event,this.b=this.B(new P.$be),this.onDidMaximize=this.b.event,this.c=this.B(new P.$be),this.onDidUnmaximize=this.c.event,this.f=this.B(new P.$be),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new P.$be),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new P.$be),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,L.$wD)(this.r),this.G=void 0,this.H=void 0}w(M,z=i.screen.getAllDisplays().length>0){const U=this.r.getValue("window"),ae=d.$j&&U?.nativeTabs===!0;(d.$j||d.$i)&&z&&(!ae||i.BrowserWindow.getAllWindows().length===1)&&[M.width,M.height,M.x,M.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:M.width,height:M.height,x:M.x,y:M.y}),(M.mode===0||M.mode===3)&&(this.m?.maximize(),M.mode===3&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(M){d.$j?this.win?.setRepresentedFilename(M):this.z=M}getRepresentedFilename(){return d.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(M){d.$j&&this.win?.setDocumentEdited(M),this.C=M}isDocumentEdited(){return d.$j?!!this.win?.isDocumentEdited():!!this.C}focus(M){d.$j&&M?.force&&i.app.focus({steal:!0});const z=this.win;z&&(z.isMinimized()&&z.restore(),z.focus())}handleTitleDoubleClick(){const M=this.win;if(M)if(d.$j)switch(i.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":M.minimize();break;case"None":break;case"Maximize":default:M.isMaximized()?M.unmaximize():M.maximize()}else M.isMaximized()?M.unmaximize():M.maximize()}static{this.D="windowControlHeight"}updateWindowControls(M){const z=this.win;if(z){if(M.height&&this.s.setItem(X.D,M.height),d.$i&&this.F)z.setTitleBarOverlay({color:M.backgroundColor?.trim()===""?void 0:M.backgroundColor,symbolColor:M.foregroundColor?.trim()===""?void 0:M.foregroundColor,height:M.height?M.height-1:void 0});else if(d.$j&&M.height!==void 0){const U=(M.height-15)/2;U?z.setWindowButtonPosition({x:U,y:U}):z.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(M,z){(0,L.$xD)(this.r)?this.J(M,z):this.M(M)}get isFullScreen(){if(d.$j&&typeof this.G=="boolean")return this.G;const M=this.win,z=M?.isFullScreen(),U=M?.isSimpleFullScreen();return!!(z||U)}J(M,z){const U=this.win;U?.isSimpleFullScreen()&&U?.setSimpleFullScreen(!1),this.L(M,z)}L(M,z){if(d.$j){this.G=M;const ae=this.H=new D.$Oh;(async()=>{const G=await Promise.race([ae.p,(0,D.$sh)(1e4).then(()=>!1)]);this.H===ae&&(this.G=void 0,this.H=void 0,!G&&M&&z&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(M)}M(M){const z=this.win;z?.isFullScreen()&&this.L(!1,!1),z?.setSimpleFullScreen(M),z?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$ubc=K;let X=class extends K{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const M=this.hb.profiles.find(z=>z.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&M?M:this.hb.getProfileForWorkspace(this.config.workspace??(0,j.$Fi)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(M,z,U,ae,G,le,Y,C,N,_,ne,Q,x,V,H,se,he,me,$e,ye,Ee){super(_,ye,ae,z),this.fb=U,this.gb=G,this.hb=le,this.ib=Y,this.jb=C,this.kb=N,this.lb=ne,this.mb=Q,this.nb=x,this.ob=V,this.pb=H,this.qb=se,this.rb=he,this.sb=me,this.tb=$e,this.N=this.B(new P.$be),this.onWillLoad=this.N.event,this.O=this.B(new P.$be),this.onDidSignalReady=this.O.event,this.P=this.B(new P.$be),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=0;{const[ke,Oe]=this.Eb(M.state);this.U=ke,this.u.trace("window#ctor: using window state",ke);const we=Ee.invokeFunction(I.$fbc,this.U,{preload:u.$Lg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,l.mark)("code/willCreateCodeBrowserWindow"),this.m=new i.BrowserWindow(we),(0,l.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Oe),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=2;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(M=>{if(this.isReady)return M(this);this.X.push(M)})}get isReady(){return this.ub===2}get whenClosedOrLoaded(){return new Promise(M=>{function z(){U.dispose(),ae.dispose(),M()}const U=this.onDidClose(()=>z()),ae=this.onWillLoad(()=>z())})}vb(){this.B(P.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(1))),this.B(P.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(z,U)=>U)(z=>this.yb(2,{...z}))),this.B(P.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(z,U,ae)=>({exitCode:U,reason:ae}))(({exitCode:z,reason:U})=>this.yb(3,{reason:U,exitCode:z}))),this.B(P.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(z=>z.preventDefault())),this.B(P.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",S.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",S.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(z=>this.Bb(z))),this.B(this.mb.onDidDeleteUntitledWorkspace(z=>this.Ab(z)));const M=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:M},async(z,U)=>{const ae=await this.xb();U({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,ae)})})}xb(){return this.wb||(this.wb=(0,s.$3p)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(M,z){switch(M){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:M,reason:z?.reason,code:z?.exitCode}),M){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(M===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:U,checkboxChecked:ae}=await this.pb.showMessageBox({type:"warning",buttons:[(0,E.localize)(0,null),(0,E.localize)(1,null),(0,E.localize)(2,null)],message:(0,E.localize)(3,null),detail:(0,E.localize)(4,null),checkboxLabel:this.S?.workspace?(0,E.localize)(5,null):void 0},this.m);if(U!==2){const G=U===0;await this.zb(G,ae)}}else if(M===2){let U;z?U=(0,E.localize)(7,null,z.reason,z.exitCode??"<unknown>"):U=(0,E.localize)(6,null);const{response:ae,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,E.localize)(8,null):(0,E.localize)(9,null),(0,E.localize)(10,null)],message:U,detail:this.S?.workspace?(0,E.localize)(11,null):(0,E.localize)(12,null),checkboxLabel:this.S?.workspace?(0,E.localize)(13,null):void 0},this.m),le=ae===0;await this.zb(le,G)}break}}async zb(M,z){const U=this.S?.workspace;if(z&&U)try{const ae=this.kb.workspaceStorage(U);await ae.init(),ae.delete("memento/workbench.parts.editor"),await ae.close()}catch(ae){this.u.error(ae)}this.P.fire();try{if(M&&this.S){let ae,G;(0,j.$Bi)(U)?ae={folderUri:U.uri}:(0,j.$Gi)(U)?ae={workspaceUri:U.configPath}:G=!0,(0,ue.$Ob)(await this.tb.open({context:5,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:ae?[ae]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(M){this.S?.workspace?.id===M.id&&(this.S.workspace=void 0)}Bb(M){if(!M||M.affectsConfiguration("window.menuBarVisibility")){const z=this.Gb();z!==this.W&&(this.W=z,this.Hb(z))}if(!M||M.affectsConfiguration("http.proxy")){let z=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.Z||U!==this.$)){this.Z=z,this.$=U;const ae=z||"",G=U?`${U},<local>`:"<local>";this.u.trace(`Setting proxy to '${ae}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:ae,proxyBypassRules:G,pacScript:""}),typeof i.app.setProxy=="function"&&i.app.setProxy({proxyRules:ae,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(M){d.$j&&M.win&&this.m.addTabbedWindow(M.win)}load(M,z=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!z.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),z.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(M,z),this.ub===0?this.S=M:this.db=M,this.ub=1,this.m.loadURL(u.$Lg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const U=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new D.$Dh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:M.workspace,reason:z.isReload?3:U?2:1})}Cb(M,z){const U=(this.S??this.db)?.userEnv;if(U){const ae=(0,f.$vm)(U)&&!(0,f.$vm)(M.userEnv),G=this.isExtensionDevelopmentHost;(ae||G)&&(M.userEnv={...U,...M.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(M.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),z.disableExtensions!==void 0&&(M["disable-extensions"]=z.disableExtensions),M.fullscreen=this.isFullScreen,M.maximized=this.m.isMaximized(),M.partsSplash=this.lb.getWindowSplash(),M.zoomLevel=this.Jb(),M.isCustomZoomLevel=typeof this.ab=="number",M.isCustomZoomLevel&&M.partsSplash&&(M.partsSplash.zoomLevel=M.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),M.perfMarks=(0,l.getMarks)(),this.bb.update(M)}async reload(M){const z=Object.assign({},this.S);z.workspace=await this.Db(z),delete z.filesToOpenOrCreate,delete z.filesToDiff,delete z.filesToMerge,delete z.filesToWait,this.isExtensionDevelopmentHost&&M&&(z.verbose=M.verbose,z.debugId=M.debugId,z.extensionEnvironment=M.extensionEnvironment,z["inspect-extensions"]=M["inspect-extensions"],z["inspect-brk-extensions"]=M["inspect-brk-extensions"],z["extensions-dir"]=M["extensions-dir"]),z.accessibilitySupport=i.app.isAccessibilitySupportEnabled(),z.isInitialStartup=!1,z.policiesData=this.gb.serialize(),z.continueOn=this.t.continueOn,z.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},z.logLevel=this.fb.getLogLevel(),z.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(z,{isReload:!0,disableExtensions:M?.["disable-extensions"]})}async Db(M){if((0,j.$Gi)(M.workspace)){const z=M.workspace.configPath;if(z.scheme===u.Schemas.file&&!await this.ib.exists(z))return}else if((0,j.$Bi)(M.workspace)){const z=M.workspace.uri;if(z.scheme===u.Schemas.file&&!await this.ib.exists(z))return}return M.workspace}serializeWindowState(){if(!this.m)return(0,R.$4ac)();if(this.isFullScreen){let U;try{U=i.screen.getDisplayMatching(this.getBounds())}catch{}const ae=(0,R.$4ac)();return{mode:3,display:U?U.id:void 0,width:this.U.width||ae.width,height:this.U.height||ae.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const M=Object.create(null);let z;if(!d.$j&&this.m.isMaximized()?z=0:z=1,z===0?M.mode=0:M.mode=1,z===1||z===0){let U;z===1?U=this.getBounds():U=this.m.getNormalBounds(),M.x=U.x,M.y=U.y,M.width=U.width,M.height=U.height}return M.zoomLevel=this.ab,M}Eb(M){(0,l.mark)("code/willRestoreCodeWindowState");let z=!1;if(M){this.ab=M.zoomLevel;try{const U=i.screen.getAllDisplays();z=U.length>1,M=I.WindowStateValidator.validateWindowState(this.u,M,U)}catch(U){this.u.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[M||(0,R.$4ac)(),z]}getBounds(){const[M,z]=this.m.getPosition(),[U,ae]=this.m.getSize();return{x:M,y:z,width:U,height:ae}}I(M,z){super.I(M,z),this.sendWhenReady(M?"vscode:enterFullScreen":"vscode:leaveFullScreen",S.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let M=(0,L.$sD)(this.r);return["visible","toggle","hidden"].indexOf(M)<0&&(M="classic"),M}Hb(M,z=!0){d.$j||(M==="toggle"&&z&&this.send("vscode:showInfoMessage",(0,E.localize)(14,null)),M==="hidden"?setTimeout(()=>{this.Ib(M)}):this.Ib(M))}Ib(M){const z=this.isFullScreen;switch(M){case"classic":this.m.setMenuBarVisibility(!z),this.m.autoHideMenuBar=z;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(M){this.ab=M}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(M,z,...U){this.isReady?this.send(M,...U):this.ready().then(()=>{z.isCancellationRequested||this.send(M,...U)})}send(M,...z){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${M}' for window that is destroyed`);return}try{this.m.webContents.send(M,...z)}catch(U){this.u.warn(`Error sending IPC message to channel '${M}' of window ${this.Q}: ${(0,A.$cj)(U)}`)}}}updateTouchBar(M){d.$j&&this.Y.forEach((z,U)=>{const ae=M[U];z.segments=this.Mb(ae)})}Kb(){if(d.$j){for(let M=0;M<10;M++){const z=this.Lb();this.Y.push(z)}this.m.setTouchBar(new i.TouchBar({items:this.Y}))}}Lb(M=[]){const z=this.Mb(M),U=new i.TouchBar.TouchBarSegmentedControl({segments:z,mode:"buttons",segmentStyle:"automatic",change:ae=>{this.sendWhenReady("vscode:runAction",S.CancellationToken.None,{id:U.segments[ae].id,from:"touchbar"})}});return U}Mb(M=[]){return M.map(U=>{let ae;U.icon&&!c.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===u.Schemas.file&&(ae=i.nativeImage.createFromPath(y.URI.revive(U.icon.dark).fsPath),ae.isEmpty()&&(ae=void 0));let G;return typeof U.title=="string"?G=U.title:G=U.title.value,{id:U.id,label:ae?void 0:G,icon:ae}})}matches(M){return this.m?.webContents.id===M.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$vbc=X,e.$vbc=X=Se([ie(1,a.$Xj),ie(2,q.$sbc),ie(3,m.$6ac),ie(4,W.$_n),ie(5,T.$hbc),ie(6,h.$Xk),ie(7,n.$Fbc),ie(8,n.$Dbc),ie(9,v.$Xi),ie(10,b.$cbc),ie(11,O.$qbc),ie(12,g.$$ac),ie(13,o.$Wl),ie(14,p.$_ac),ie(15,w.$xbc),ie(16,t.$ek),ie(17,r.$bbc),ie(18,I.$ebc),ie(19,F.$vQ),ie(20,ee.$qi)],X)}),define(re[306],oe([0,1,14,4,18,24,20,5,34,55,135]),function(J,e,i,D,S,A,P,k,u,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=void 0;let y=class extends d.$ubc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor($,g,v,p,m,f){super(p,m,g,v),this.O=$,this.P=f,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow($){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),$&&!this.N&&(this.N=!0,this.w({x:$.x,y:$.y,width:$.width,height:$.height,mode:$.show===!1?0:1})))}Q(){if(this.m)return;const $=i.BrowserWindow.fromWebContents(this.O);$&&(this.u.trace("[aux window] Claimed browser window instance"),this.n($),$.setMenu(null),(D.$i||D.$k)&&(0,l.$uD)(this.r)&&$.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches($){return this.O.id===$.id}};e.$wbc=y,e.$wbc=y=Se([ie(1,A.$6ac),ie(2,k.$Xj),ie(3,S.$Xi),ie(4,u.$vQ),ie(5,P.$xbc)],y)}),define(re[307],oe([0,1,14,3,2,13,37,306,6,5,82,29]),function(J,e,i,D,S,A,P,k,u,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;let E=class extends S.$Uc{constructor(g,v){super(),this.h=g,this.j=v,this.a=this.B(new D.$be),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new D.$be),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new D.$be),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new D.$be),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){i.app.on("browser-window-created",(g,v)=>{const p=this.getWindowByWebContents(v.webContents);if(p)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow();else{const m=new S.$Tc;m.add(D.Event.fromNodeEventEmitter(v.webContents,"did-create-window",(f,h)=>({browserWindow:f,details:h}))(({browserWindow:f,details:h})=>{const w=this.getWindowByWebContents(f.webContents);w&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),w.tryClaimWindow(h.options))})),m.add(D.Event.fromNodeEventEmitter(v,"closed")(()=>m.dispose()))}}),P.$GW.handle("vscode:registerAuxiliaryWindow",async(g,v)=>{const p=this.getWindowByWebContents(g.sender);return p&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=v),g.sender.id})}createWindow(g){return this.h.invokeFunction(y.$fbc,this.n(g),{preload:A.$Lg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(g){const v={},p=g.features.split(",");for(const f of p){const[h,w]=f.split("=");switch(h){case"width":v.width=parseInt(w,10);break;case"height":v.height=parseInt(w,10);break;case"left":v.x=parseInt(w,10);break;case"top":v.y=parseInt(w,10);break;case"window-maximized":v.mode=0;break;case"window-fullscreen":v.mode=3;break}}const m=y.WindowStateValidator.validateWindowState(this.j,v)??(0,d.$5ac)();return this.j.trace("[aux window] using window state",m),m}registerWindow(g){const v=new S.$Tc,p=this.h.createInstance(k.$wbc,g);this.g.set(p.id,p),v.add((0,S.$Sc)(()=>this.g.delete(p.id))),v.add(p.onDidMaximize(()=>this.a.fire(p))),v.add(p.onDidUnmaximize(()=>this.b.fire(p))),v.add(p.onDidEnterFullScreen(()=>this.c.fire({window:p,fullscreen:!0}))),v.add(p.onDidLeaveFullScreen(()=>this.c.fire({window:p,fullscreen:!1}))),v.add(p.onDidTriggerSystemContextMenu(({x:m,y:f})=>this.f.fire({window:p,x:m,y:f}))),D.Event.once(p.onDidClose)(()=>v.dispose())}getWindowByWebContents(g){const v=this.g.get(g.id);return v?.matches(g)?v:void 0}getFocusedWindow(){const g=i.BrowserWindow.getFocusedWindow();if(g)return this.getWindowByWebContents(g.webContents)}getLastActiveWindow(){return(0,y.$gbc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$1cc=E,e.$1cc=E=Se([ie(0,u.$qi),ie(1,l.$Xj)],E)}),define(re[85],oe([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,84,98,30,58,31,56]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=e.$ccc=void 0,e.$ccc=(0,g.$ri)("workspacesHistoryMainService");let s=class extends k.$Uc{static{r=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(o,c,b,L,I){super(),this.f=o,this.g=c,this.h=b,this.j=L,this.m=I,this.c=this.B(new A.$be),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new S.$ph(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){let c=[],b=[];for(const I of o)if((0,f.$3fb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(c,I.workspace)&&c.push(I);else if((0,f.$4fb)(I))this.y(c,I.folderUri)||c.push(I);else{const j=this.z(b,I.fileUri),O=I.fileUri.scheme===u.Schemas.file&&r.G.indexOf((0,d.$2g)(I.fileUri))>=0;!j&&!O&&(b.push(I),l.$i&&I.fileUri.scheme===u.Schemas.file&&i.app.addRecentDocument(I.fileUri.fsPath))}const L=await this.r({workspaces:c,files:b});c=L.workspaces,b=L.files,c.length>r.a&&(c.length=r.a),b.length>r.a&&(b.length=r.a),await this.t({workspaces:c,files:b}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(o){const c=j=>{const O=this.u(j);for(const R of o)if(d.$Vg.isEqual(R,O))return!1;return!0},b=await this.getRecentlyOpened(),L=b.workspaces.filter(c),I=b.files.filter(c);(L.length!==b.workspaces.length||I.length!==b.files.length)&&(await this.t({files:I,workspaces:L}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(o){if(o?.confirm){const{response:c}=await this.m.showMessageBox({type:"warning",buttons:[(0,$.localize)(0,null),(0,$.localize)(1,null)],message:(0,$.localize)(2,null),detail:(0,$.localize)(3,null),cancelId:1});if(c!==0)return}await this.t({workspaces:[],files:[]}),i.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(o){const c=new a.$Bc(I=>d.$Vg.getComparisonKey(I));if(o?.workspaces)for(const I of o.workspaces)c.set(this.u(I),I);const b=new a.$Bc(I=>d.$Vg.getComparisonKey(I));if(o?.files)for(const I of o.files)b.set(this.u(I),I);const L=await this.s();for(const I of L.workspaces){const j=c.get(this.u(I));j?j.label=j.label??I.label:c.set(this.u(I),I)}for(const I of L.files){const j=b.get(this.u(I));j?j.label=j.label??I.label:b.set(this.u(I),I)}return{workspaces:[...c.values()],files:[...b.values()]}}async s(){await this.j.whenReady;let o;const c=this.j.get(r.b,-1);if(typeof c=="string")try{o=JSON.parse(c)}catch(b){this.f.error("Unexpected error parsing opened paths list",b)}return(0,f.$0fb)(o,this.f)}async t(o){await this.j.whenReady,this.j.store(r.b,JSON.stringify((0,f.$$fb)(o)),-1,1)}u(o){return(0,f.$4fb)(o)?o.folderUri:(0,f.$5fb)(o)?o.fileUri:o.workspace.configPath}w(o,c){return!!o.find(b=>(0,f.$3fb)(b)&&b.workspace.id===c.id)}y(o,c){return!!o.find(b=>(0,f.$4fb)(b)&&d.$Vg.isEqual(b.folderUri,c))}z(o,c){return!!o.find(b=>d.$Vg.isEqual(b.fileUri,c))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){l.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!l.$i)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,$.localize)(4,null),description:(0,$.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const c=[];for(const I of i.app.getJumpListSettings().removedItems){const j=I.args;if(j){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(j);O&&c.push(y.URI.parse(O[2]))}}await this.removeRecentlyOpened(c);let b=!1;const L=(0,D.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,r.F).map(I=>{const j=(0,f.$3fb)(I)?I.workspace:I.folderUri,{title:O,description:R}=this.L(j,I.label);let W;return y.URI.isUri(j)?W=`--folder-uri "${j.toString()}"`:(b=!0,W=`--file-uri "${j.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:R.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));L.length>0&&o.push({type:"custom",name:b?(0,$.localize)(6,null):(0,$.localize)(7,null),items:L})}o.push({type:"recent"});try{const c=i.app.setJumpList(o);c&&c!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${c}`)}catch(c){this.f.warn("updateWindowsJumpList#setJumpList",c)}}L(o,c){if(c)return{title:(0,P.$zw)(c).name,description:c};if(y.URI.isUri(o))return{title:(0,d.$2g)(o),description:this.M(o)};if(this.g.isUntitledWorkspace(o))return{title:(0,$.localize)(8,null),description:""};let b=(0,d.$2g)(o.configPath);return b.endsWith(h.$Ni)&&(b=b.substr(0,b.length-h.$Ni.length-1)),{title:(0,$.localize)(9,null,b),description:this.M(o.configPath)}}M(o){return o.scheme==="file"?(0,P.$rw)(o.fsPath):o.toString()}async N(){if(!l.$j)return;i.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),c=[];let b=0;for(let I=0;I<o.workspaces.length&&b<r.C;I++){const j=this.u(o.workspaces[I]);if(j.scheme===u.Schemas.file){const O=(0,d.$Sg)(j);await E.Promises.exists(O)&&(c.push(O),b++)}}const L=[];for(let I=0;I<o.files.length&&b<r.D;I++){const j=this.u(o.files[I]);if(j.scheme===u.Schemas.file){const O=(0,d.$Sg)(j);if(r.G.includes((0,d.$2g)(j))||c.includes(O))continue;await E.Promises.exists(O)&&(L.push(O),b++)}}L.reverse().forEach(I=>i.app.addRecentDocument(I)),c.reverse().forEach(I=>i.app.addRecentDocument(I))}};e.$dcc=s,e.$dcc=s=r=Se([ie(0,p.$Xj),ie(1,w.$qbc),ie(2,v.$xbc),ie(3,m.$Fbc),ie(4,t.$_ac)],s)}),define(re[308],oe([0,1,14,8,23,48,4,7,184,79,18,24,20,5,235,70,27,34,28,50,55,29,85]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=void 0;const s="menu";let n=class{static{r=this}static{this.a="lastKnownMenubarData"}constructor(b,L,I,j,O,R,W,F,T,q,ue,ee){this.n=b,this.o=L,this.p=I,this.q=j,this.r=O,this.s=R,this.t=W,this.u=F,this.v=T,this.w=q,this.x=ue,this.y=ee,this.m=Object.create(null),this.g=new D.$Dh(()=>this.F(),0),this.h=new D.$Dh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(P.$j||(0,w.$uD)(L))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const b=this.t.getItem(r.a);b&&(b.menus&&(this.k=b.menus),b.keybindings&&(this.l=b.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(R,W,F)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:W?.id})},this.m["workbench.action.newWindow"]=(R,W,F)=>this.p.openEmptyWindow({context:2,contextWindowId:W?.id}),this.m["workbench.action.files.openFileFolder"]=(R,W,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.files.openFolder"]=(R,W,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.openWorkspace"]=(R,W,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const b=this.x.youTubeUrl;b&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(b,"openYouTubeUrl"));const L=this.x.requestFeatureUrl;L&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(L,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const j=this.x.licenseUrl;j&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(P.$w){const R=j.indexOf("?")>0?"&":"?";this.ab(`${j}${R}lang=${P.$w}`,"openLicenseUrl")}else this.ab(j,"openLicenseUrl")});const O=this.x.privacyStatementUrl;O&&j&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(O,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(b=>this.G(b)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const b=this.o.getValue("window.enableMenuBarMnemonics");return typeof b!="boolean"?!0:b}get D(){if(!P.$j)return!1;const b=this.o.getValue("window.nativeTabs");return typeof b!="boolean"?!1:b}updateMenu(b,L){this.k=b.menus,this.l=b.keybindings,this.t.setItem(r.a,b),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(b){P.$j&&(b.oldCount===0&&b.newCount>0||b.oldCount>0&&b.newCount===0)&&(this.d=b.newCount===0,this.E())}H(){if(!P.$j)return;const b=i.BrowserWindow.getFocusedWindow();this.f=!b||!!this.y.getWindowByWebContents(b.webContents),this.E()}I(){const b=i.Menu.getApplicationMenu();if(b&&this.j.push(b),Object.keys(this.k).length===0){this.J(P.$j?new i.Menu:null);return}const L=new i.Menu;let I;if(P.$j){const O=new i.Menu;I=new i.MenuItem({label:this.x.nameShort,submenu:O}),this.K(O),L.append(I)}if(P.$j&&!this.c){this.c=!0;const O=new i.Menu;O.append(new i.MenuItem({label:this.cb(u.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),i.app.dock.setMenu(O)}if(this.M("File")){const O=new i.Menu,R=new i.MenuItem({label:this.cb(u.localize(1,null)),submenu:O});this.O(O,"File"),L.append(R)}if(this.M("Edit")){const O=new i.Menu,R=new i.MenuItem({label:this.cb(u.localize(2,null)),submenu:O});this.O(O,"Edit"),L.append(R)}if(this.M("Selection")){const O=new i.Menu,R=new i.MenuItem({label:this.cb(u.localize(3,null)),submenu:O});this.O(O,"Selection"),L.append(R)}if(this.M("View")){const O=new i.Menu,R=new i.MenuItem({label:this.cb(u.localize(4,null)),submenu:O});this.O(O,"View"),L.append(R)}if(this.M("Go")){const O=new i.Menu,R=new i.MenuItem({label:this.cb(u.localize(5,null)),submenu:O});this.O(O,"Go"),L.append(R)}if(this.M("Run")){const O=new i.Menu,R=new i.MenuItem({label:this.cb(u.localize(6,null)),submenu:O});this.O(O,"Run"),L.append(R)}if(this.M("Terminal")){const O=new i.Menu,R=new i.MenuItem({label:this.cb(u.localize(7,null)),submenu:O});this.O(O,"Terminal"),L.append(R)}let j;if(this.M("Window")){const O=new i.Menu;j=new i.MenuItem({label:this.cb(u.localize(8,null)),submenu:O,role:"window"}),this.U(O)}if(j&&L.append(j),this.M("Help")){const O=new i.Menu,R=new i.MenuItem({label:this.cb(u.localize(9,null)),submenu:O,role:"help"});this.O(O,"Help"),L.append(R)}L.items&&L.items.length>0?this.J(L):this.J(null),this.h.schedule()}J(b){if(i.Menu.setApplicationMenu(b),b)for(const L of this.y.getWindows())L.win?.setMenu(null)}K(b){const L=this.W(u.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let j;if(this.M("Preferences")){const ee=new i.Menu;this.O(ee,"Preferences"),j=new i.MenuItem({label:this.cb(u.localize(11,null)),submenu:ee})}const O=new i.Menu,R=new i.MenuItem({label:u.localize(12,null),role:"services",submenu:O}),W=new i.MenuItem({label:u.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new i.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),T=new i.MenuItem({label:u.localize(15,null),role:"unhide"}),q=new i.MenuItem(this.$("workbench.action.quit",{label:u.localize(16,null,this.x.nameLong),click:async(ee,ce,K)=>{const X=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||i.BrowserWindow.getFocusedWindow()||X?.win?.isMinimized())&&await this.L(K)&&this.w.quit(void 0)}})),ue=[L];ue.push(...I),j&&ue.push(o(),j),ue.push(o(),R,o(),W,F,T,o(),q),ue.forEach(ee=>b.append(ee))}async L(b){if(this.p.getWindowCount()===0)return!0;const L=this.o.getValue("window.confirmBeforeClose");if(L==="always"||L==="keyboardOnly"&&this.S(b)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[u.localize(17,null),u.localize(18,null)],message:u.localize(19,null)});return I===0}return!0}M(b){if(!P.$j&&!(0,w.$uD)(this.o))return!1;switch(b){case"File":case"Help":if(P.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[b];case"Window":if(P.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[b]}}N(b,L){L.forEach(I=>{if((0,g.$_bc)(I))b.append(o());else if((0,g.$$bc)(I)){const j=new i.Menu,O=new i.MenuItem({label:this.cb(I.label),submenu:j});this.N(j,I.submenu.items),b.append(O)}else(0,g.$acc)(I)?b.append(this.Q(I)):(0,g.$bcc)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(b),P.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?b.append(new i.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):b.append(this.W(I.label,I.id,!1,I.checked)):b.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):b.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(b,L){this.k&&this.k[L]&&this.N(b,this.k[L].items)}P(b){const L=this.V();L.length&&(L.forEach(I=>b.append(I)),b.append(o()))}Q(b){const L=k.URI.revive(b.uri),I=b.id,j=I==="openRecentFile"?{fileUri:L}:I==="openRecentWorkspace"?{workspaceUri:L}:{folderUri:L};return new i.MenuItem(this.$(I,{label:b.label,click:async(O,R,W)=>{const F=this.R(W);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[j],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:b.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([L])}},!1))}R(b){return!!(b&&(!P.$j&&(b.ctrlKey||b.shiftKey)||P.$j&&(b.metaKey||b.altKey)))}S(b){return!!(b.triggeredByAccelerator||b.altKey||b.ctrlKey||b.metaKey||b.shiftKey)}T(b,L,I){const j={label:this.cb(b),role:I,enabled:!0};return new i.MenuItem(this.Z(L,j))}U(b){const L=new i.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new i.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),j=new i.MenuItem({label:u.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),O=this.W(u.localize(23,null),"workbench.action.switchWindow"),R=[];this.D&&(R.push(o()),R.push(this.W(u.localize(24,null),"workbench.action.newWindowTab")),R.push(this.T(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.T(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.T(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.T(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[L,I,o(),O,...R,o(),j].forEach(W=>b.append(W))}V(){switch(this.n.state.type){case"idle":return[new i.MenuItem({label:this.cb(u.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new i.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new i.MenuItem({label:this.cb(u.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new i.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return P.$j?[]:[new i.MenuItem({label:this.cb(u.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new i.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new i.MenuItem({label:this.cb(u.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(b,L,I,j){const O=this.cb(b),R=typeof L=="function"?L:(ue,ee,ce)=>{const K=ue?ue.userSettingsLabel:null;let X=L;Array.isArray(L)&&(X=this.R(ce)?L[1]:L[0]),K&&ce.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:K}):this.Y({type:"commandId",commandId:X})},W=typeof I=="boolean"?I:this.p.getWindowCount()>0,F=typeof j=="boolean"?j:!1,T={label:O,click:R,enabled:W};F&&(T.type="checkbox",T.checked=F);let q;return typeof L=="string"?q=L:Array.isArray(L)&&(q=L[0]),P.$j&&(q==="editor.action.clipboardCutAction"?T.role="cut":q==="editor.action.clipboardCopyAction"?T.role="copy":q==="editor.action.clipboardPasteAction"&&(T.role="paste"),q==="undo"?T.click=this.X(R,{inDevTools:ue=>ue.undo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?T.click=this.X(R,{inDevTools:ue=>ue.redo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&(T.click=this.X(R,{inDevTools:ue=>ue.selectAll(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("selectAll:")}))),new i.MenuItem(this.Z(q,T))}X(b,L){return(I,j,O)=>{const R=i.BrowserWindow.getFocusedWindow();if(!R)return L.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return L.inDevTools(R.webContents.devToolsWebContents);b(I,j||R,O)}}Y(b){let L=i.BrowserWindow.getFocusedWindow();if(L){const j=this.y.getWindowByWebContents(L.webContents);j&&(L=this.p.getWindowById(j.parentId)?.win??null)}if(!L){const j=this.p.getLastActiveWindow();j?.win?.isMinimized()&&(L=j.win)}const I=L?this.p.getWindowById(L.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",b),P.$j&&!this.q.isBuilt&&!I.isReady&&(b.type==="commandId"&&b.commandId==="workbench.action.toggleDevTools"||b.type!=="commandId"&&b.userSettingsLabel==="alt+cmd+i"))return!1;if(b.type==="commandId"){const j={id:b.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",S.CancellationToken.None,j)}else{const j={userSettingsLabel:b.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",S.CancellationToken.None,j)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",b),!1}Z(b,L){const I=typeof b=="string"?this.l[b]:void 0;if(I?.label){if(I.isNative!==!1)L.accelerator=I.label,L.userSettingsLabel=I.userSettingsLabel;else if(typeof L.label=="string"){const j=L.label.indexOf("[");j>=0?L.label=`${L.label.substr(0,j)} [${I.label}]`:L.label=`${L.label} [${I.label}]`}}else L.accelerator=void 0;return L}$(b,L,I=!L.accelerator){I&&(L=this.Z(b,L));const j=L.click;return L.click=(O,R,W)=>{this.bb(b),j?.(O,R,W)},L}ab(b,L){this.w.openExternal(void 0,b),this.bb(L)}bb(b){this.r.publicLog2("workbenchActionExecuted",{id:b,from:s})}cb(b){return(0,A.$ww)(b,!this.C)}};e.$ecc=n,e.$ecc=n=r=Se([ie(0,h.$FX),ie(1,d.$Xi),ie(2,a.$ebc),ie(3,y.$6ac),ie(4,f.$Wl),ie(5,t.$ccc),ie(6,m.$vQ),ie(7,E.$xbc),ie(8,$.$Xj),ie(9,v.$3bc),ie(10,p.$ek),ie(11,l.$2bc)],n);function o(){return new i.MenuItem({type:"separator"})}}),define(re[309],oe([0,1,6,20,5,308]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=e.$fcc=void 0,e.$fcc=(0,i.$ri)("menubarMainService");let P=class{constructor(u,l,d){this.b=u,this.c=l,this.d=d,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(A.$ecc)}async updateMenubar(u,l){this.d.trace("menubarService#updateMenubar",u),(await this.a).updateMenu(l,u)}};e.$gcc=P,e.$gcc=P=Se([ie(0,i.$qi),ie(1,D.$xbc),ie(2,S.$Xj)],P)}),define(re[310],oe([0,1,14,21,102,26,22,23,3,32,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,80,81,68,34,55,135,29,133,302,30,99,85,58,69,39,57,67,79]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w,a,t,r,s,n,o,c,b,L,I,j,O,R,W,F,T,q,ue,ee,ce,K,X,B,M,z,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;function ae(Y){return(0,ue.$Gi)(Y?.workspace)}function G(Y){return(0,ue.$Bi)(Y?.workspace)}let le=class extends y.$Uc{constructor(C,N,_,ne,Q,x,V,H,se,he,me,$e,ye,Ee,ke,Oe,we,Z,fe,ge){super(),this.s=C,this.t=N,this.u=_,this.w=ne,this.z=Q,this.C=x,this.D=V,this.F=H,this.G=se,this.H=he,this.I=me,this.J=$e,this.L=ye,this.M=Ee,this.N=ke,this.O=Oe,this.P=we,this.Q=Z,this.R=fe,this.S=ge,this.a=this.B(new u.$be),this.onDidOpenWindow=this.a.event,this.b=this.B(new u.$be),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new u.$be),this.onDidDestroyWindow=this.c.event,this.f=this.B(new u.$be),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new u.$be),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new u.$be),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new u.$be),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new u.$be),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new q.$Dcc(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(C=>this.b.fire(C.window))),this.B(this.onDidSignalReadyWindow(C=>{if(C.config?.extensionDevelopmentPath||C.config?.extensionTestsPath){const N=new y.$Tc;if(N.add(u.Event.any(C.onDidClose,C.onDidDestroy)(()=>N.dispose())),C.config.extensionDevelopmentPath)for(const _ of C.config.extensionDevelopmentPath)N.add(this.Q.addValidFileRoot(_));C.config.extensionTestsPath&&N.add(this.Q.addValidFileRoot(C.config.extensionTestsPath))}}))}openEmptyWindow(C,N){const _=this.F.args,ne=N?.remoteAuthority||void 0,Q=!0,x=N?.forceReuseWindow,V=!x;return this.open({...C,cli:_,forceEmpty:Q,forceNewWindow:V,forceReuseWindow:x,remoteAuthority:ne})}openExistingWindow(C,N){C.focus(),this.W(N,[C])}async open(C){this.w.trace("windowsManager#open"),C.addMode&&(C.initialStartup||!this.getLastActiveWindow())&&(C.addMode=!1);const N=[],_=[],ne=[],Q=[],x=[];let V,H=0;const se=await this.cb(C);this.w.trace("windowsManager#open pathsToOpen",se);for(const Ee of se)G(Ee)?C.addMode?N.push(Ee):_.push(Ee):ae(Ee)?ne.push(Ee):Ee.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ee.remoteAuthority}),V.filesToOpenOrCreate.push(Ee)):Ee.backupPath?x.push({backupFolder:(0,$.$oc)(Ee.backupPath),remoteAuthority:Ee.remoteAuthority}):H++;C.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),C.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&C.waitMarkerFileURI&&(V.filesToWait={paths:(0,P.$Hb)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:C.waitMarkerFileURI}),C.initialStartup?(Q.push(...this.M.getUntitledWorkspaces()),ne.push(...Q),x.push(...this.I.getEmptyWindowBackups())):x.length=0;const{windows:he,filesOpenedInWindow:me}=await this.X(C,ne,_,x,H,V,N);if(this.w.trace(`windowsManager#open used window count ${he.length} (workspacesToOpen: ${ne.length}, foldersToOpen: ${_.length}, emptyToRestore: ${x.length}, emptyToOpen: ${H})`),he.length>1)if(me)me.focus();else{const Ee=this.r.state.lastActiveWindow&&!C.forceEmpty&&!C.cli._.length&&!C.cli["file-uri"]&&!C.cli["folder-uri"]&&!(C.urisToOpen&&C.urisToOpen.length);let ke=!0,Oe=!0;if(Ee){const we=he.filter(Z=>this.r.state.lastActiveWindow&&Z.backupPath===this.r.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),ke=!1,Oe=!1)}if(ke)for(let we=he.length-1;we>=0;we--){const Z=he[we];if(!(Z.openedWorkspace&&Q.some(fe=>Z.openedWorkspace&&fe.workspace.id===Z.openedWorkspace.id)||Z.backupPath&&x.some(fe=>Z.backupPath&&fe.backupFolder===(0,$.$oc)(Z.backupPath)))){Z.focus(),Oe=!1;break}}Oe&&he[he.length-1].focus()}const $e=V&&V.filesToDiff.length>0,ye=V&&V.filesToMerge.length>0;if(!he.some(Ee=>Ee.isExtensionDevelopmentHost)&&!$e&&!ye&&!C.noRecentEntry){const Ee=[];for(const ke of se)ae(ke)&&!ke.transient?Ee.push({label:ke.label,workspace:ke.workspace,remoteAuthority:ke.remoteAuthority}):G(ke)?Ee.push({label:ke.label,folderUri:ke.workspace.uri,remoteAuthority:ke.remoteAuthority}):ke.fileUri&&Ee.push({label:ke.label,fileUri:ke.fileUri,remoteAuthority:ke.remoteAuthority});this.L.addRecentlyOpened(Ee)}return this.W(C,he),he}W(C,N){const _=C.waitMarkerFileURI;C.context===0&&_&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(C,N,_,ne,Q,x,V){const H=[];let se;function he(we,Z){H.push(we),Z&&(se=we,x=void 0)}let{openFolderInNewWindow:me,openFilesInNewWindow:$e}=this.ob(C);if(!C.initialStartup&&V.length>0){const we=V[0].remoteAuthority,Z=this.ub(we);Z&&he(this.$(Z,V.map(fe=>fe.workspace.uri)))}const ye=_.length+N.length+ne.length;if(x&&ye===0){const we=x.filesToOpenOrCreate[0]||x.filesToDiff[0]||x.filesToMerge[3],Z=this.getWindows().filter(ge=>x&&(0,m.$0g)(ge.remoteAuthority,x.remoteAuthority));let fe;we?.fileUri&&!$e&&((C.context===4||C.context===0||C.context===1)&&(fe=await(0,T.$jbc)(Z,we.fileUri,async ge=>ge.configPath.scheme===E.Schemas.file?this.M.resolveLocalWorkspace(ge.configPath):void 0)),fe||(fe=this.vb(Z))),fe?(0,ue.$Gi)(fe.openedWorkspace)?N.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,ue.$Bi)(fe.openedWorkspace)?_.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):he(this.Y(C,fe,x),!0):he(await this.pb({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,filesToOpen:x,forceNewWindow:!0,remoteAuthority:x.remoteAuthority,forceNewTabbedWindow:C.forceNewTabbedWindow,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile}),!0)}const Ee=(0,P.$Mb)(N,we=>we.workspace.id);if(Ee.length>0){const we=(0,P.$Hb)(Ee.map(Z=>(0,T.$kbc)(this.getWindows(),Z.workspace.configPath)));if(we.length>0){const Z=we[0],fe=(0,m.$0g)(x?.remoteAuthority,Z.remoteAuthority)?x:void 0;he(this.Y(C,Z,fe),!!fe),me=!0}for(const Z of Ee){if(we.some(Le=>Le.openedWorkspace&&Le.openedWorkspace.id===Z.workspace.id))continue;const fe=Z.remoteAuthority,ge=(0,m.$0g)(x?.remoteAuthority,fe)?x:void 0;he(await this.bb(C,Z,me,ge),!!ge),me=!0}}const ke=(0,P.$Mb)(_,we=>m.$Vg.getComparisonKey(we.workspace.uri));if(ke.length>0){const we=(0,P.$Hb)(ke.map(Z=>(0,T.$kbc)(this.getWindows(),Z.workspace.uri)));if(we.length>0){const Z=we[0],fe=(0,m.$0g)(x?.remoteAuthority,Z.remoteAuthority)?x:void 0;he(this.Y(C,Z,fe),!!fe),me=!0}for(const Z of ke){if(we.some(Le=>(0,ue.$Bi)(Le.openedWorkspace)&&m.$Vg.isEqual(Le.openedWorkspace.uri,Z.workspace.uri)))continue;const fe=Z.remoteAuthority,ge=(0,m.$0g)(x?.remoteAuthority,fe)?x:void 0;he(await this.bb(C,Z,me,ge),!!ge),me=!0}}const Oe=(0,P.$Mb)(ne,we=>we.backupFolder);if(Oe.length>0)for(const we of Oe){const Z=we.remoteAuthority,fe=(0,m.$0g)(x?.remoteAuthority,Z)?x:void 0;he(await this.ab(C,!0,Z,fe,we),!!fe),me=!0}if(H.length===0||x){x&&!Q&&Q++;const we=x?x.remoteAuthority:C.remoteAuthority;for(let Z=0;Z<Q;Z++)he(await this.ab(C,me,we,x),!!x),me=!0}return{windows:(0,P.$Mb)(H),filesOpenedInWindow:se}}Y(C,N,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(N);const ne={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:C?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",k.CancellationToken.None,ne),N}Z(C){let N=C;const _=i.BrowserWindow.getFocusedWindow();if(_&&_.id!==C.id){const ne=this.S.getWindowByWebContents(_.webContents);ne&&ne.parentId===C.id&&(N=ne)}N.focus()}$(C,N){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),C.focus();const _={foldersToAdd:N};return C.sendWhenReady("vscode:addFolders",k.CancellationToken.None,_),C}ab(C,N,_,ne,Q){this.w.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:_,filesToOpen:ne,forceNewWindow:N});let x;return!N&&typeof C.contextWindowId=="number"&&(x=this.getWindowById(C.contextWindowId)),this.pb({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:_,forceNewWindow:N,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:ne,windowToUse:x,emptyWindowBackupInfo:Q,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile})}bb(C,N,_,ne,Q){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:ne}),!_&&!Q&&typeof C.contextWindowId=="number"&&(Q=this.getWindowById(C.contextWindowId)),this.pb({workspace:N.workspace,userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:ne,windowToUse:Q,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile})}async cb(C){let N,_=!1,ne=!1;if(C.urisToOpen&&C.urisToOpen.length>0?(N=await this.db(C),_=!0):C.forceEmpty?N=[Object.create(null)]:C.cli._.length||C.cli["folder-uri"]||C.cli["file-uri"]?(N=await this.eb(C.cli),N.length===0&&N.push(Object.create(null)),_=!0):(N=await this.gb(),N.length===0&&N.push(Object.create(null)),ne=!0),!C.addMode&&_){const Q=N.filter(x=>G(x));if(Q.length>1){const x=Q[0].remoteAuthority;if(Q.every(V=>(0,m.$0g)(V.remoteAuthority,x))){const V=await this.M.createUntitledWorkspace(Q.map(H=>({uri:H.workspace.uri})));N.push({workspace:V,remoteAuthority:x}),N=N.filter(H=>!G(H))}}}if(C.initialStartup&&!ne&&this.J.getValue("window")?.restoreWindows==="preserve"){const Q=await this.gb();N.unshift(...Q.filter(x=>ae(x)||G(x)||x.backupPath))}return N}async db(C){const N={gotoLineMode:C.gotoLineMode,remoteAuthority:C.remoteAuthority},_=await Promise.all((0,P.$Hb)(C.urisToOpen||[]).map(async ne=>{const Q=await this.ib(ne,N);if(Q)return Q.label=ne.label,Q;const x=this.kb(ne);this.O.showMessageBox({type:"info",buttons:[(0,w.localize)(0,null)],message:x.scheme===E.Schemas.file?(0,w.localize)(1,null):(0,w.localize)(2,null),detail:x.scheme===E.Schemas.file?(0,w.localize)(3,null,(0,d.$qw)(x,{os:v.OS,tildify:this.F})):(0,w.localize)(4,null,x.toString(!0))},i.BrowserWindow.getFocusedWindow()??void 0)}));return(0,P.$Hb)(_)}async eb(C){const N=[],_={ignoreFileNotFound:!0,gotoLineMode:C.goto,remoteAuthority:C.remote||void 0,forceOpenWorkspaceAsFile:C.diff&&C._.length===2||C.merge&&C._.length===4},ne=C["folder-uri"];if(ne){const V=await Promise.all(ne.map(H=>{const se=this.fb(H);if(se)return this.ib({folderUri:se},_)}));N.push(...(0,P.$Hb)(V))}const Q=C["file-uri"];if(Q){const V=await Promise.all(Q.map(H=>{const se=this.fb(H);if(se)return this.ib((0,ue.$Wi)(H)?{workspaceUri:se}:{fileUri:se},_)}));N.push(...(0,P.$Hb)(V))}const x=await Promise.all(C._.map(V=>_.remoteAuthority?this.nb(V,_):this.lb(V,_)));return N.push(...(0,P.$Hb)(x)),N}fb(C){try{const N=h.URI.parse(C);if(!N.scheme){this.w.error(`Invalid URI input string, scheme missing: ${C}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.w.error(`Invalid URI input string: ${C}, ${N.message}`)}}async gb(){const C=this.hb();switch(C){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];C!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const _=await Promise.all(N.map(async ne=>{if(ne.workspace){const Q=await this.ib({workspaceUri:ne.workspace.configPath},{remoteAuthority:ne.remoteAuthority,rejectTransientWorkspaces:!0});if(ae(Q))return Q}else if(ne.folderUri){const Q=await this.ib({folderUri:ne.folderUri},{remoteAuthority:ne.remoteAuthority});if(G(Q))return Q}else if(C!=="folders"&&ne.backupPath)return{backupPath:ne.backupPath,remoteAuthority:ne.remoteAuthority}}));return(0,P.$Hb)(_)}}}hb(){let C;return this.H.wasRestarted?C="all":(C=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(C)||(C="all")),C}async ib(C,N=Object.create(null)){const _=this.kb(C);return _.scheme===E.Schemas.file?((0,R.$rD)(C)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,N)):this.jb(C,N)}jb(C,N){let _=this.kb(C);const ne=(0,j.$Cm)(_)||N.remoteAuthority;if(_=(0,m.$_g)((0,m.$6g)(_)),(0,R.$rD)(C)){if(N.gotoLineMode){const{path:Q,line:x,column:V}=(0,l.$yg)(_.path);return{fileUri:_.with({path:Q}),options:{selection:x?{startLineNumber:x,startColumn:V||1}:void 0},remoteAuthority:ne}}return{fileUri:_,remoteAuthority:ne}}else if((0,R.$pD)(C))return{workspace:(0,ee.$nbc)(_),remoteAuthority:ne};return{workspace:(0,ee.$obc)(_),remoteAuthority:ne}}kb(C){return(0,R.$pD)(C)?C.workspaceUri:(0,R.$qD)(C)?C.folderUri:C.fileUri}async lb(C,N,_){let ne,Q;N.gotoLineMode&&({path:C,line:ne,column:Q}=(0,l.$yg)(C)),C=(0,l.$tg)((0,$.$ic)(C),(0,p.cwd)());try{const x=await D.Promises.stat(C);if(x.isFile()){if(!N.forceOpenWorkspaceAsFile){const V=await this.M.resolveLocalWorkspace(h.URI.file(C));if(V)return V.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:n.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:h.URI.file(C),type:n.FileType.File,exists:!0,options:{selection:ne?{startLineNumber:ne,startColumn:Q||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,ee.$obc)(h.URI.file(C),x),type:n.FileType.Directory,exists:!0};if(!v.$i&&C==="/dev/null")return{fileUri:h.URI.file(C),type:n.FileType.File,exists:!0}}}catch(x){if(x.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(C,N);const V=h.URI.file(C);if(this.L.removeRecentlyOpened([V]),N.ignoreFileNotFound)return{fileUri:V,type:n.FileType.File,exists:!1}}}async mb(C,N){const _=h.URI.file(C),{response:ne,checkboxChecked:Q}=await this.O.showMessageBox({type:"warning",buttons:[(0,w.localize)(5,null),(0,w.localize)(6,null),(0,w.localize)(7,null)],message:(0,w.localize)(8,null,_.authority),detail:(0,w.localize)(9,null,(0,d.$qw)(_,{os:v.OS,tildify:this.F})),checkboxLabel:(0,w.localize)(10,null,_.authority),cancelId:1});if(ne===0){if((0,S.addUNCHostToAllowlist)(_.authority),Q){const x={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(x.channel,x.args),this.sendToOpeningWindow(x.channel,x.args)}return this.lb(C,N,!0)}if(ne===2)return i.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(C,N)}nb(C,N){const _=C.charCodeAt(0),ne=N.remoteAuthority;let Q,x;N.gotoLineMode&&({path:C,line:Q,column:x}=(0,l.$yg)(C)),_!==47&&((0,l.$sg)(_)&&C.charCodeAt(C.charCodeAt(1))===58&&(C=(0,l.$lg)(C)),C=`/${C}`);const V=h.URI.from({scheme:E.Schemas.vscodeRemote,authority:ne,path:C});if(C.charCodeAt(C.length-1)!==47){if((0,ue.$Wi)(C))return N.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:Q?{startLineNumber:Q,startColumn:x||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,ee.$nbc)(V),remoteAuthority:ne};if(N.gotoLineMode||$.$hc.basename(C).indexOf(".")!==-1)return{fileUri:V,options:{selection:Q?{startLineNumber:Q,startColumn:x||1}:void 0},remoteAuthority:ne}}return{workspace:(0,ee.$obc)(V),remoteAuthority:ne}}ob(C){const N=this.J.getValue("window"),_=N?.openFoldersInNewWindow||"default",ne=N?.openFilesInNewWindow||"off";let Q=(C.preferNewWindow||C.forceNewWindow)&&!C.forceReuseWindow;!C.forceNewWindow&&!C.forceReuseWindow&&(_==="on"||_==="off")&&(Q=_==="on");let x=!1;return C.forceNewWindow||C.forceReuseWindow?x=!!C.forceNewWindow&&!C.forceReuseWindow:(v.$j?C.context===1&&(x=!0):C.context!==3&&C.context!==2&&!(C.userEnv&&C.userEnv.TERM_PROGRAM==="vscode")&&(x=!0),!C.cli.extensionDevelopmentPath&&(ne==="on"||ne==="off")&&(x=ne==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:x}}async openExtensionDevelopmentHostWindow(C,N){const _=(0,T.$lbc)(this.getWindows(),C);if(_)return this.H.reload(_,N.cli),_.focus(),[_];let ne=N.cli["folder-uri"]||[],Q=N.cli["file-uri"]||[],x=N.cli._;if(!x.length&&!ne.length&&!Q.length&&!N.cli.extensionTestsPath){const se=this.r.state.lastPluginDevelopmentHostWindow,he=se?.workspace??se?.folderUri;he&&(h.URI.isUri(he)?he.scheme===E.Schemas.file?x=[he.fsPath]:ne=[he.toString()]:he.configPath.scheme===E.Schemas.file?x=[(0,m.$Sg)(he.configPath)]:Q=[he.configPath.toString()])}let V=N.remoteAuthority;for(const se of C)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=h.URI.parse(se),me=(0,j.$Cm)(he);me&&(V?(0,m.$0g)(me,V)||this.w.error("more than one extension development path authority"):V=me)}x=x.filter(se=>{const he=h.URI.file(se);return(0,T.$kbc)(this.getWindows(),he)?!1:(0,m.$0g)((0,j.$Cm)(he),V)}),ne=ne.filter(se=>{const he=this.fb(se);return he&&(0,T.$kbc)(this.getWindows(),he)?!1:he?(0,m.$0g)((0,j.$Cm)(he),V):!1}),Q=Q.filter(se=>{const he=this.fb(se);return he&&(0,T.$kbc)(this.getWindows(),he)?!1:he?(0,m.$0g)((0,j.$Cm)(he),V):!1}),N.cli._=x,N.cli["folder-uri"]=ne,N.cli["file-uri"]=Q;const H={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!x.length&&!ne.length&&!Q.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:V,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(H)}async pb(C){const N=this.J.getValue("window"),_=this.getLastActiveWindow(),ne=_?.profile??this.G.defaultProfile;let Q;!C.forceNewWindow&&!C.forceNewTabbedWindow&&(Q=C.windowToUse||_,Q&&Q.focus());const x={...this.F.args,...C.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:C.emptyWindowBackupInfo?(0,$.$kc)(this.F.backupHome,C.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:ne},homeDir:this.F.userHome.with({scheme:E.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:E.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:C.remoteAuthority,workspace:C.workspace,userEnv:{...this.u,...C.userEnv},filesToOpenOrCreate:C.filesToOpen?.filesToOpenOrCreate,filesToDiff:C.filesToOpen?.filesToDiff,filesToMerge:C.filesToOpen?.filesToMerge,filesToWait:C.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:E.Schemas.file}).fsPath,product:L.default,isInitialStartup:C.initialStartup,perfMarks:(0,g.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)(),arch:(0,A.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:i.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(Q){const V=Q.config;!x.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(x.extensionDevelopmentPath=V.extensionDevelopmentPath,x.extensionDevelopmentKind=V.extensionDevelopmentKind,x["enable-proposed-api"]=V["enable-proposed-api"],x.verbose=V.verbose,x["inspect-extensions"]=V["inspect-extensions"],x["inspect-brk-extensions"]=V["inspect-brk-extensions"],x.debugId=V.debugId,x.extensionEnvironment=V.extensionEnvironment,x["extensions-dir"]=V["extensions-dir"],x["disable-extensions"]=V["disable-extensions"]),x.loggers={global:x.loggers.global,window:V?.loggers.window??x.loggers.window}}else{const V=this.r.getNewWindowState(x);(0,g.mark)("code/willCreateCodeWindow");const H=Q=this.N.createInstance(W.$vbc,{state:V,extensionDevelopmentPath:x.extensionDevelopmentPath,isExtensionTestHost:!!x.extensionTestsPath});(0,g.mark)("code/didCreateCodeWindow"),C.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(H),this.n.set(H.id,H),this.a.fire(H),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const se=new y.$Tc;se.add(H.onDidSignalReady(()=>this.b.fire(H))),se.add(u.Event.once(H.onDidClose)(()=>this.sb(H,se))),se.add(u.Event.once(H.onDidDestroy)(()=>this.tb(H))),se.add(H.onDidMaximize(()=>this.g.fire(H))),se.add(H.onDidUnmaximize(()=>this.h.fire(H))),se.add(H.onDidEnterFullScreen(()=>this.j.fire({window:H,fullscreen:!0}))),se.add(H.onDidLeaveFullScreen(()=>this.j.fire({window:H,fullscreen:!1}))),se.add(H.onDidTriggerSystemContextMenu(({x:me,y:$e})=>this.m.fire({window:H,x:me,y:$e})));const he=(0,f.$dg)(H.win?.webContents);he.removeAllListeners("devtools-reload-page"),se.add(u.Event.fromNodeEventEmitter(he,"devtools-reload-page")(()=>this.H.reload(H))),this.H.registerWindow(H)}return x.windowId=Q.id,Q.isReady?this.H.unload(Q,4).then(async V=>{V||await this.qb(Q,x,C,ne)}):await this.qb(Q,x,C,ne),Q}async qb(C,N,_,ne){if(N.extensionDevelopmentPath||((0,ue.$Gi)(N.workspace)?N.backupPath=this.I.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,ue.$Bi)(N.workspace)?N.backupPath=this.I.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,ee.$pbc)().id,remoteAuthority:N.remoteAuthority})),this.G.isEnabled()){const Q=N.workspace??(0,ue.$Fi)(N.backupPath,!1),x=this.rb(_,Q,ne),V=x instanceof Promise?await x:x;N.profiles.profile=V,N.extensionDevelopmentPath||await this.G.setProfileForWorkspace(Q,V)}C.load(N)}rb(C,N,_){return C.forceProfile?this.G.profiles.find(ne=>ne.name===C.forceProfile)??this.G.createNamedProfile(C.forceProfile):C.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(N)??_}sb(C,N){this.n.delete(C.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}tb(C){this.n.delete(C.id),this.c.fire(C)}getFocusedWindow(){const C=i.BrowserWindow.getFocusedWindow();if(C)return this.getWindowById(C.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(C){return this.vb(this.getWindows().filter(N=>(0,m.$0g)(N.remoteAuthority,C)))}vb(C){return(0,F.$gbc)(C)}sendToFocused(C,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(C,k.CancellationToken.None,...N)}sendToOpeningWindow(C,...N){this.B(u.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(C,k.CancellationToken.None,...N)}))}sendToAll(C,N,_){for(const ne of this.getWindows())_&&_.indexOf(ne.id)>=0||ne.sendWhenReady(C,k.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(C){return this.n.get(C)}getWindowByWebContents(C){const N=i.BrowserWindow.fromWebContents(C);if(!N)return;const _=this.getWindowById(N.id);return _?.matches(C)?_:void 0}};e.$Gcc=le,e.$Gcc=le=Se([ie(3,b.$Xj),ie(4,z.$sbc),ie(5,O.$vQ),ie(6,B.$_n),ie(7,s.$6ac),ie(8,M.$hbc),ie(9,c.$xbc),ie(10,a.$$ac),ie(11,t.$Xi),ie(12,ce.$ccc),ie(13,K.$qbc),ie(14,o.$qi),ie(15,r.$_ac),ie(16,n.$Xk),ie(17,I.$bbc),ie(18,X.$cbc),ie(19,U.$2bc)],le)}),define(re[311],oe([0,1,65,29,85,58]),function(J,e,i,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;let P=class{constructor(u,l,d,y){this.a=u,this.b=l,this.c=d,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(u,l){const d=this.b.getWindowById(u);if(d)return this.a.enterWorkspace(d,this.b.getWindows(),l)}createUntitledWorkspace(u,l,d){return this.a.createUntitledWorkspace(l,d)}deleteUntitledWorkspace(u,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(u,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(u){return this.c.getRecentlyOpened()}addRecentlyOpened(u,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(u,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(u){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$Icc=P,e.$Icc=P=Se([ie(0,A.$qbc),ie(1,D.$ebc),ie(2,S.$ccc),ie(3,i.$$ac)],P)}),define(re[312],oe([0,1,14,102,37,26,17,47,15,32,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,78,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,84,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,85,311,58,39,237,57,248,53,83,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,79,307,72]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w,a,t,r,s,n,o,c,b,L,I,j,O,R,W,F,T,q,ue,ee,ce,K,X,B,M,z,U,ae,G,le,Y,C,N,_,ne,Q,x,V,H,se,he,me,$e,ye,Ee,ke,Oe,we,Z,fe,ge,Le,Ae,Be,Me,Fe,Ue,xe,Qe,Te,te,de,pe,ve,Pe,Re,ze,Xe,Ze,Ye,Ke,st,it,ot,at,vt,Et,kt,St,Pt,ct,gt,Lt,jt,It,lt,Dt,mt,ut,Ct,At,ht,Ot,$t,Rt,wt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;let dt=class extends $.$Uc{static{ft=this}static{this.a={[g.Schemas.file]:"security.promptForLocalFileProtocolHandling",[g.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(je,Ie,Ce,be,De,qe,He,Ge,We,Ne,Ve,Je){super(),this.g=je,this.h=Ie,this.j=Ce,this.m=be,this.n=De,this.s=qe,this.t=He,this.u=Ge,this.w=We,this.y=Ne,this.z=Ve,this.C=Je,this.D(),this.F()}D(){const je=We=>We?.startsWith(`${g.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);i.session.defaultSession.setPermissionRequestHandler((We,Ne,Ve,Je)=>je(Je.requestingUrl)?Ve(Ie.has(Ne)):Ve(!1)),i.session.defaultSession.setPermissionCheckHandler((We,Ne,Ve,Je)=>je(Je.requestingUrl)?Ie.has(Ne):!1);const Ce=new Set([g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemoteResource,g.Schemas.vscodeManagedRemoteResource,"devtools"]),be=We=>{for(let Ne=We;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${g.Schemas.vscodeWebview}://`))return!0;return!1},De=We=>We.resourceType==="xhr"||be(We.frame),qe=We=>{const Ne=We.frame;if(!Ne||!this.b)return!1;const Ve=i.BrowserWindow.getAllWindows();for(const Je of Ve)if(Ne.processId===Je.webContents.mainFrame.processId)return!0;return!1},He=(We,Ne)=>{if(We.path!=="/index.html")return!0;const Ve=Ne.frame;if(!Ve||!this.b)return!1;for(const Je of this.b.getWindows())if(Je.win&&Ve.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};i.session.defaultSession.webRequest.onBeforeRequest((We,Ne)=>{const Ve=f.URI.parse(We.url);return Ve.scheme===g.Schemas.vscodeWebview&&!He(Ve,We)?(this.m.error("Blocked vscode-webview request",We.url),Ne({cancel:!0})):Ve.scheme===g.Schemas.vscodeFileResource&&!qe(We)?(this.m.error("Blocked vscode-file request",We.url),Ne({cancel:!0})):Ve.path.endsWith(".svg")&&!Ce.has(Ve.scheme)?Ne({cancel:!De(We)}):Ne({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{const Ve=We.responseHeaders,Je=Ve["content-type"]||Ve["Content-Type"];if(Je&&Array.isArray(Je)){const _e=f.URI.parse(We.url);if(_e.path.endsWith(".svg")&&Ce.has(_e.scheme))return Ve["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:Ve});if(!_e.path.endsWith(g.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!De(We)})}return Ne({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ve=We.responseHeaders??Object.create(null);if(Ve["Access-Control-Allow-Origin"]===void 0)return Ve["Access-Control-Allow-Origin"]=["*"],Ne({cancel:!1,responseHeaders:Ve})}return Ne({cancel:!1})});const Ge=i.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,v.$kc)(this.s.codeCachePath,"chrome")),p.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,D.disableUNCAccessRestrictions)():(0,D.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,u.setUnexpectedErrorHandler)(Ce=>this.H(Ce)),process.on("uncaughtException",Ce=>{(0,u.$Z)(Ce)||(0,u.$1)(Ce)}),process.on("unhandledRejection",Ce=>(0,u.$1)(Ce)),this.t.onWillShutdown(()=>this.dispose()),(0,w.$HW)(),i.app.on("accessibility-support-changed",(Ce,be)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",be)}),i.app.on("activate",async(Ce,be)=>{this.m.trace("app#activate"),be||await this.b?.openEmptyWindow({context:1})}),i.app.on("web-contents-created",(Ce,be)=>{be?.opener?.url.startsWith(`${g.Schemas.vscodeFileResource}://${g.$Kg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(be)),be.on("will-navigate",De=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),be.setWindowOpenHandler(De=>De.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(De)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${De.url}}`),this.f?.openExternal(void 0,De.url),{action:"deny"}))});let je=[],Ie;i.app.on("open-file",(Ce,be)=>{be=(0,wt.$9l)(be),this.m.trace("app#open-file: ",be),Ce.preventDefault(),je.push((0,Re.$Wi)(be)?{workspaceUri:f.URI.file(be)}:{fileUri:f.URI.file(be)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:je,gotoLineMode:!1,preferNewWindow:!0}),je=[],Ie=void 0},100)}),i.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),S.$GW.handle("vscode:fetchShellEnv",Ce=>{const be=this.b?.getWindowByWebContents(Ce.sender);let De,qe;return be?.config?(De=be.config,qe={...process.env,...be.config.userEnv}):(De=this.s.args,qe=process.env),this.X(De,qe,!1)}),S.$GW.handle("vscode:writeNlsFile",(Ce,be,De)=>{const qe=this.G([be]);if(!qe||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(qe,P.$Ce.fromString(De))}),S.$GW.handle("vscode:readNlsFile",async(Ce,...be)=>{const De=this.G(be);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(De)).value.toString()}),S.$GW.on("vscode:toggleDevTools",Ce=>Ce.sender.toggleDevTools()),S.$GW.on("vscode:openDevTools",Ce=>Ce.sender.openDevTools()),S.$GW.on("vscode:reloadWindow",Ce=>Ce.sender.reload()),S.$GW.handle("vscode:notifyZoomLevel",async(Ce,be)=>{const De=this.b?.getWindowByWebContents(Ce.sender);De&&De.notifyZoomLevel(be)})}G(je){let Ie;for(const Ce of je)typeof Ce=="string"&&(typeof Ie!="string"?Ie=Ce:Ie=(0,v.$kc)(Ie,Ce));if(!(typeof Ie!="string"||!(0,v.$jc)(Ie)||!(0,l.$rg)(Ie,this.s.cachedLanguagesPath,!p.$k)))return f.URI.file(Ie)}H(je){if(je){const Ie={message:`[uncaught exception in main]: ${je.message}`,stack:je.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.m.error(`[uncaught exception in main]: ${je}`),je.stack&&this.m.error(je.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const je=this.z.win32AppUserModelId;p.$i&&je&&i.app.setAppUserModelId(je);try{p.$j&&this.u.getValue("window.nativeTabs")===!0&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.m.error(Ne)}const Ie=new t.$NW;this.t.onWillShutdown(Ne=>{Ne.reason===2&&Ie.dispose()}),this.m.trace("Resolving machine identifier...");const[Ce,be]=await Promise.all([(0,gt.$Qcc)(this.w,this.m),(0,gt.$Rcc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Ce}`);const{sharedProcessReady:De,sharedProcessClient:qe}=this.P(Ce,be),He=await this.Q(Ce,be,De);this.B(He.createInstance(s.$Hbc)),this.B(He.createInstance(St.$Mcc)),He.invokeFunction(Ne=>this.R(Ne,Ie,qe));const Ge=await He.invokeFunction(Ne=>this.I(Ne,Ie));this.J(Ie),this.t.phase=2,await He.invokeFunction(Ne=>this.S(Ne,Ge)),this.t.phase=3,this.U(),this.B(new ct.$Dh(()=>{this.B((0,ct.$Hh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(je,Ie){const Ce=this.b=je.get(pe.$ebc),be=je.get(Fe.$vX),De=this.f=je.get(x.$3bc),qe=je.get(O.$_ac),He=this;be.registerHandler({async handleURL(_e,nt){return He.O(Ce,qe,be,_e,nt)}});const Ge=this.B(new Pe.$Hcc({onDidOpenMainWindow:De.onDidOpenMainWindow,onDidFocusMainWindow:De.onDidFocusMainWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),We=new a.$_h(_e=>Ge.getActiveClientId().then(nt=>_e===nt)),Ne=new Ue.$ycc(We,this.m),Ve=Ie.getChannel("urlHandler",Ne);be.registerHandler(new Ue.$xcc(Ve));const Je=await this.L(Ce,qe);return this.B(new Qe.$zcc(Je?.urls,be,Ce,this.s,this.z,this.m)),Je}J(je){const Ie=()=>({statusCode:404,data:"Not found"}),Ce=new Ot.$V(()=>je.getChannel(ht.$Ycc,new ht.$Zcc));i.protocol.registerBufferProtocol(g.Schemas.vscodeManagedRemoteResource,(be,De)=>{const qe=f.URI.parse(be.url);if(!qe.authority.startsWith("window:"))return De(Ie());Ce.value.call(ht.$Xcc,[qe]).then(He=>De({...He,data:Buffer.from(He.body,"base64")}),He=>{this.m.warn("error dispatching remote resource call",He),De({statusCode:500,data:String(He)})})})}async L(je,Ie){const Ce=this.s.args["open-url"]?this.s.args._urls||[]:[];Ce.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ce);const be=global.getOpenUrls()||[];if(be.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",be),Ce.length+be.length===0)return;const De=[...Ce,...be].map(Ge=>{try{return{uri:f.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),qe=[],He=[];for(const Ge of De){if(!Ge)continue;const We=this.N(Ge.uri);if(We)if(await this.M(We,je,Ie)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),We),qe.push(We);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),He.push(Ge)}return{urls:He,openables:qe}}async M(je,Ie,Ce){let be,De;if((0,de.$pD)(je)?(be=je.workspaceUri,De=(0,n.localize)(0,null,be.scheme===g.Schemas.file?(0,E.$qw)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(0,de.$qD)(je)?(be=je.folderUri,De=(0,n.localize)(1,null,be.scheme===g.Schemas.file?(0,E.$qw)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(be=je.fileUri,De=(0,n.localize)(2,null,be.scheme===g.Schemas.file?(0,E.$qw)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)),be.scheme!==g.Schemas.file&&be.scheme!==g.Schemas.vscodeRemote||this.u.getValue(ft.a[be.scheme])===!1)return!1;const{response:He,checkboxChecked:Ge}=await Ce.showMessageBox({type:"warning",buttons:[(0,n.localize)(3,null),(0,n.localize)(4,null)],message:De,detail:(0,n.localize)(5,null),checkboxLabel:be.scheme===g.Schemas.file?(0,n.localize)(6,null):(0,n.localize)(7,null),cancelId:1});if(He!==0)return!0;if(Ge){const We={channel:"vscode:disablePromptForProtocolHandling",args:be.scheme===g.Schemas.file?"local":"remote"};Ie.sendToFocused(We.channel,We.args),Ie.sendToOpeningWindow(We.channel,We.args)}return!1}N(je){if(je.path){if(je.authority===g.Schemas.file){const Ie=f.URI.file(je.fsPath);return(0,Re.$Wi)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(je.authority===g.Schemas.vscodeRemote){const Ie=je.path.indexOf(v.$hc.sep,1);if(Ie!==-1){const Ce=je.path.substring(1,Ie),be=je.path.substring(Ie);let De=je.query;const qe=new URLSearchParams(je.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),De=qe.toString());const He=f.URI.from({scheme:g.Schemas.vscodeRemote,authority:Ce,path:be,query:De,fragment:je.fragment});return(0,Re.$Wi)(be)?{workspaceUri:He}:/:[\d]+$/.test(be)?{fileUri:He}:{folderUri:He}}}}}async O(je,Ie,Ce,be,De){this.m.trace("app#handleProtocolUrl():",be.toString(!0),De),be.scheme===this.z.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:f.URI.parse(be.query).path,query:""}));let qe=!1;const He=new URLSearchParams(be.query);He.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),He.delete("windowId"),be=be.with({query:He.toString()}),qe=!0):p.$j&&je.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),qe=!0);const Ge=He.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),He.delete("continueOn"),be=be.with({query:He.toString()}),this.s.continueOn=Ge??void 0);const We=this.N(be);return We?await this.M(We,je,Ie)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",We,be.toString(!0)),(0,mt.$Ob)(await je.open({context:5,cli:{...this.s.args},urisToOpen:[We],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,mt.$Ob)(await je.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,H.$Cm)(be)}))?.ready(),Ce.open(be,De)):(this.m.trace("app#handleProtocolUrl(): not handled",be.toString(!0),De),!1)}P(je,Ie){const Ce=this.B(this.j.createInstance(se.$kcc,je,Ie)),be=(async()=>{this.m.trace("Main->SharedProcess#connect");const qe=await Ce.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new r.$OW(qe,"main")})();return{sharedProcessReady:(async()=>(await Ce.whenReady(),be))(),sharedProcessClient:be}}async Q(je,Ie,Ce){const be=new G.$pi;switch(process.platform){case"win32":be.set(fe.$FX,new U.$oi(Me.$vcc));break;case"linux":p.$l?be.set(fe.$FX,new U.$oi(Be.$ucc,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(fe.$FX,new U.$oi(Ae.$tcc));break;case"darwin":be.set(fe.$FX,new U.$oi(Le.$scc));break}be.set(pe.$ebc,new U.$oi(ve.$Gcc,[je,Ie,this.h],!1)),be.set($t.$2bc,new U.$oi(Rt.$1cc,void 0,!1));const De=new O.$abc(this.m,this.z);be.set(O.$_ac,De),be.set(N.$9bc,new U.$oi(N.$0bc,void 0,!1)),be.set(j.$Nbc,new U.$oi(j.$Obc,void 0,!1)),be.set(I.$$m,a.ProxyChannel.toService((0,a.$0h)(Ce.then(Ne=>Ne.getChannel("diagnostics"))))),be.set(le.$AJb,new U.$oi(Y.$5bc,[this.h])),be.set(R.$pX,new U.$oi(W.$Pbc)),be.set(C.$6bc,new U.$oi(C.$7bc)),be.set(x.$3bc,new U.$oi(x.$4bc,void 0,!1)),be.set(Te.$Acc,new U.$oi(te.$Ccc)),be.set(Q.$fcc,new U.$oi(Q.$gcc)),be.set(ue.$Qbc,new U.$oi(ee.$Sbc)),be.set(ye.$Dbc,new U.$oi(ye.$Ebc)),be.set(ye.$Fbc,new U.$oi(ye.$Gbc));const qe=new Ct.$Wcc({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),He=new At.$qs(qe,this.u,this.m,this.n);be.set(ut.$4r,He),p.$i?be.set(ce.$Tbc,new U.$oi(K.$Ubc)):p.$j?be.set(ce.$Tbc,new U.$oi(K.$Vbc)):p.$k&&be.set(ce.$Tbc,new U.$oi(K.$Wbc));const Ge=new c.$Ibc(this.s,this.u,this.m,this.w);be.set(o.$$ac,Ge);const We=new Ye.$rbc(this.s,this.m,this.C,Ge,De);if(be.set(Ye.$qbc,We),be.set(ze.$2fb,new U.$oi(Ze.$Icc,void 0,!1)),be.set(Xe.$ccc,new U.$oi(Xe.$dcc,void 0,!1)),be.set(Fe.$vX,new U.$oi(xe.$xX,void 0,!1)),(0,Z.$hp)(this.z,this.s)){const Ne=(0,Z.$mp)(this.z,this.u),Ve=(0,a.$0h)(Ce.then(rt=>rt.getChannel("telemetryAppender"))),Je=new Oe.$ncc(Ve),_e=(0,Ee.$$o)((0,A.release)(),(0,A.hostname)(),process.arch,this.z.commit,this.z.version,je,Ie,Ne),nt=(0,Z.$np)(this.s),et={appenders:[Je],commonProperties:_e,piiPaths:nt,sendErrorTelemetry:!0};be.set(ke.$Wl,new U.$oi(we.$Ur,[et],!1))}else be.set(ke.$Wl,Z.$cp);return be.set(vt.$kq,new U.$oi(Lt.$CQ,void 0,!0)),be.set(Et.$oq,new U.$oi(kt.$Lcc,void 0,!0)),be.set(lt.$Ucc,new U.$oi(lt.$Vcc,void 0,!0)),await ct.Promises.settled([Ge.initialize(),We.initialize()]),this.j.createChild(be)}R(je,Ie,Ce){const be=this.B(new $.$Tc),De=a.ProxyChannel.fromService(je.get(N.$9bc),be,{disableMarshalling:!0});this.g.registerChannel("launch",De);const qe=a.ProxyChannel.fromService(je.get(j.$Nbc),be,{disableMarshalling:!0});this.g.registerChannel("diagnostics",qe);const He=new st.$Jcc(je.get(Ke.$_n));Ie.registerChannel("policy",He),Ce.then(tt=>tt.registerChannel("policy",He));const Ge=this.y.getProvider(g.Schemas.file);(0,m.$cg)(Ge instanceof z.$7q);const We=new M.$Xbc(Ge,this.m,this.s);Ie.registerChannel(X.$lQ,We),Ce.then(tt=>tt.registerChannel(X.$lQ,We));const Ne=a.ProxyChannel.fromService(je.get(it.$hbc),be);Ie.registerChannel("userDataProfiles",Ne),Ce.then(tt=>tt.registerChannel("userDataProfiles",Ne));const Ve=new ot.$Pr(je.get(at.$Ip));Ce.then(tt=>tt.registerChannel("request",Ve));const Je=new ge.$occ(je.get(fe.$FX));Ie.registerChannel("update",Je);const _e=a.ProxyChannel.fromService(je.get(le.$AJb),be);Ie.registerChannel("issue",_e);const nt=a.ProxyChannel.fromService(je.get(R.$pX),be);Ie.registerChannel("encryption",nt);const et=a.ProxyChannel.fromService(je.get(he.$Kl),be);Ie.registerChannel("sign",et);const rt=a.ProxyChannel.fromService(je.get(C.$6bc),be);Ie.registerChannel("keyboardLayout",rt),this.f=je.get(x.$3bc);const pt=a.ProxyChannel.fromService(this.f,be);Ie.registerChannel("nativeHost",pt),Ce.then(tt=>tt.registerChannel("nativeHost",pt));const Mt=a.ProxyChannel.fromService(je.get(ze.$2fb),be);Ie.registerChannel("workspaces",Mt);const Ft=a.ProxyChannel.fromService(je.get(Q.$fcc),be);Ie.registerChannel("menubar",Ft);const Wt=a.ProxyChannel.fromService(je.get(Fe.$vX),be);Ie.registerChannel("url",Wt);const Nt=a.ProxyChannel.fromService(je.get(Te.$Acc),be);Ie.registerChannel("webview",Nt);const bt=this.B(new $e.$lcc(this.m,je.get(ye.$Dbc)));Ie.registerChannel("storage",bt),Ce.then(tt=>tt.registerChannel("storage",bt));const Tt=this.B(new Pt.$Ncc(je.get(ye.$Dbc),je.get(it.$hbc),this.m));Ce.then(tt=>tt.registerChannel("profileStorageListener",Tt));const zt=a.ProxyChannel.fromService(je.get(ut.$4r),be);Ie.registerChannel(ut.TerminalIpcChannels.LocalPty,zt);const Bt=a.ProxyChannel.fromService(je.get(ce.$Tbc),be);Ie.registerChannel("externalTerminal",Bt);const yt=new jt.$Scc(je.get(It.$sbc));Ie.registerChannel("logger",yt),Ce.then(tt=>tt.registerChannel("logger",yt));const qt=new L.$Jbc(je.get(pe.$ebc));Ie.registerChannel("extensionhostdebugservice",qt);const Ut=a.ProxyChannel.fromService(je.get(ue.$Qbc),be);Ie.registerChannel(ue.$Rbc,Ut);const Ht=a.ProxyChannel.fromService(je.get(lt.$Ucc),be);Ie.registerChannel(Dt.$Tcc,Ht)}async S(je,Ie){const Ce=this.b=je.get(pe.$ebc);this.c=je.get($t.$2bc);const be=(0,T.$vm)(process.env)?0:4,De=this.s.args;if(Ie){if(Ie.openables.length>0)return Ce.open({context:be,cli:De,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const et of Ie.urls){const rt=new URLSearchParams(et.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:rt.toString()}),Ce.open({context:be,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,He=De._.length,Ge=!!De["folder-uri"],We=!!De["file-uri"],Ne=De["skip-add-to-recently-opened"]===!0,Ve=De.wait&&De.waitMarkerFilePath?f.URI.file(De.waitMarkerFilePath):void 0,Je=De.remote||void 0,_e=De.profile,nt=De["profile-temp"];if(!He&&!Ge&&!We){if(De["new-window"]||_e||nt)return Ce.open({context:be,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt});if(qe.length)return Ce.open({context:1,cli:De,urisToOpen:qe.map(et=>(et=(0,wt.$9l)(et),(0,Re.$Wi)(et)?{workspaceUri:f.URI.file(et)}:{fileUri:f.URI.file(et)})),noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0})}return Ce.open({context:be,cli:De,forceNewWindow:De["new-window"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Ne,waitMarkerFileURI:Ve,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt})}U(){this.W(),i.protocol.registerHttpProtocol(g.Schemas.vscodeRemoteResource,(je,Ie)=>{Ie({url:je.url.replace(/^vscode-remote-resource:/,"http:"),method:je.method})}),this.X(this.s.args,process.env,!0),this.Y(),p.$j&&i.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const je=this.z.win32MutexName;if(p.$i&&je)try{const Ie=await new Promise((be,De)=>{J(["@vscode/windows-mutex"],be,De)}),Ce=new Ie.Mutex(je);d.Event.once(this.t.onWillShutdown)(()=>Ce.release())}catch(Ie){this.m.error(Ie)}}async X(je,Ie,Ce){try{return await(0,q.$Bm)(this.u,this.m,je,Ie)}catch(be){const De=(0,k.$cj)(be);Ce?this.b?.sendToFocused("vscode:showResolveShellEnvError",De):this.m.error(De)}return{}}async Y(){try{const Ie=(await this.y.readFile(this.s.argvResource)).value.toString(),Ce=JSON.parse((0,y.$Mn)(Ie)),De=(0,Z.$jp)(this.u)>=1;if(Ce["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.$Ng)()}"`,"}"],He=Ie.substring(0,Ie.length-2).concat(`,
`,qe.join(`
`));await this.y.writeFile(this.s.argvResource,P.$Ce.fromString(He))}else{const qe=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);qe!==Ie&&await this.y.writeFile(this.s.argvResource,P.$Ce.fromString(qe))}}catch(je){this.m.error(je)}}};e.$2cc=dt,e.$2cc=dt=ft=Se([ie(2,ae.$qi),ie(3,ne.$Xj),ie(4,ne.$Yj),ie(5,F.$6ac),ie(6,_.$xbc),ie(7,b.$Xi),ie(8,me.$vQ),ie(9,B.$Xk),ie(10,V.$ek),ie(11,it.$hbc)],dt)}),define(re[317],oe([0,1,14,43,7,22,8,47,15,32,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,78,222,93,20,229,5,80,27,81,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(J,e,i,D,S,A,P,k,u,l,d,y,E,$,g,v,p,m,f,h,w,a,t,r,s,n,o,c,b,L,I,j,O,R,W,F,T,q,ue,ee,ce,K,X,B,M,z,U,ae,G,le,Y,C,N,_,ne,Q,x,V,H,se,he,me,$e,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ee{main(){try{this.a()}catch(we){console.error(we.message),i.app.exit(1)}}async a(){(0,u.setUnexpectedErrorHandler)(Fe=>console.error(Fe));const[we,Z,fe,ge,Le,Ae,Be,Me]=this.b();try{try{await this.d(fe,Me,ge,Le,Be)}catch(Fe){throw this.g(fe,Be,Fe),Fe}await we.invokeFunction(async Fe=>{const Ue=Fe.get(q.$Xj),xe=Fe.get(F.$xbc),Qe=Fe.get(L.$Xk),Te=Fe.get(q.$Yj),te=await this.f(Ue,fe,xe,we,Be,!0);return f.Promises.writeFile(fe.mainLockfile,String(process.pid)).catch(de=>{Ue.warn(`app#startup(): Error writing main lockfile: ${de.stack}`)}),Ae.logger=Te.createLogger("main",{name:(0,t.localize)(0,null)}),d.Event.once(xe.onWillShutdown)(de=>{Qe.dispose(),ge.dispose(),de.join("instanceLockfile",f.Promises.unlink(fe.mainLockfile).catch(()=>{}))}),we.createInstance(a.$2cc,te,Z).startup()})}catch(Fe){we.invokeFunction(this.j,Fe)}}b(){const we=new W.$pi,Z=new Q.$Tc;process.once("exit",()=>Z.dispose());const fe={_serviceBrand:void 0,...ue.default};we.set(ee.$ek,fe);const ge=new o.$7ac(this.k(),fe),Le=this.c(ge);we.set(o.$6ac,ge);const Ae=new H.$tbc((0,q.$_j)(ge),ge.logsHome);we.set(H.$sbc,Ae);const Be=new T.$L$b(Ae.getLogLevel()),Me=Z.add(new se.$DQ(Be,[new q.$5j(Ae.getLogLevel())]));we.set(q.$Xj,Me);const Fe=new I.$Dq(Me);we.set(L.$Xk,Fe);const Ue=new j.$7q(Me);Fe.registerProvider(E.Schemas.file,Ue);const xe=new V.$us(Fe);we.set(x.$vl,xe);const Qe=new me.$yQ(1,ge,Me,Fe);we.set(G.$uQ,Qe),we.set(G.$vQ,Qe);const Te=new C.$ibc(Qe,xe,ge,Fe,Me);we.set(C.$hbc,Te),Fe.registerProvider(E.Schemas.vscodeUserData,new $e.$adc(E.Schemas.file,Ue,E.Schemas.vscodeUserData,Te,xe,Me));const te=v.$i&&fe.win32RegValueName?Z.add(new _.$$cc(Me,fe.win32RegValueName)):ge.policyFile?Z.add(new ne.$_cc(ge.policyFile,Fe,Me)):new N.$bo;we.set(N.$_n,te);const de=new s.$Bo(Te.defaultProfile.settingsResource,Fe,te,Me);return we.set(r.$Xi,de),we.set(F.$xbc,new O.$oi(F.$ybc,void 0,!1)),we.set(M.$Ip,new O.$oi(z.$9cc,void 0,!0)),we.set(Y.$cbc,new O.$oi(Y.$dbc)),we.set(U.$Kl,new O.$oi(ae.$0cc,void 0,!1)),we.set(X.$8v,new O.$oi(B.$7cc)),we.set(ce.$bbc,new K.$4cc(ge,Te,Me)),[new R.$0q(we,!0),Le,ge,de,Qe,Be,fe,Te]}c(we){const Z={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(fe=>{const ge=process.env[fe];typeof ge=="string"&&(Z[fe]=ge)}),Object.assign(process.env,Z),Z}async d(we,Z,fe,ge,Le){await P.Promises.settled([Promise.all([this.e(we.extensionsPath),we.codeCachePath,we.logsHome.with({scheme:E.Schemas.file}).fsPath,Z.defaultProfile.globalStorageHome.with({scheme:E.Schemas.file}).fsPath,we.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath,we.localHistoryHome.with({scheme:E.Schemas.file}).fsPath,we.backupHome].map(Ae=>Ae?f.Promises.mkdir(Ae,{recursive:!0}):void 0)),ge.init(),fe.initialize()]),Z.init()}e(we){if(v.$i){const Z=(0,ye.getUNCHost)(we);Z&&(0,ye.addUNCHostToAllowlist)(Z)}return we}async f(we,Z,fe,ge,Le,Ae){let Be;try{(0,g.mark)("code/willStartMainServer"),Be=await(0,w.$mi)(Z.mainIPCHandle),(0,g.mark)("code/didStartMainServer"),d.Event.once(fe.onWillShutdown)(()=>Be.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(Z,Le,Me),Me;let Fe;try{Fe=await(0,w.$ni)(Z.mainIPCHandle,"main")}catch(Te){if(!Ae||v.$i||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.h((0,t.localize)(1,null,Le.nameShort),(0,t.localize)(2,null),Le),Te;try{(0,D.unlinkSync)(Z.mainIPCHandle)}catch(te){throw we.warn("Could not delete obsolete instance handle",te),te}return this.f(we,Z,fe,ge,Le,!1)}if(Z.extensionTestsLocationURI&&!Z.debugExtensionHost.break){const Te=`Running extension tests from the command line is currently only supported if no other instance of ${Le.nameShort} is running.`;throw we.error(Te),Fe.dispose(),new Error(Te)}let Ue;!Z.args.wait&&!Z.args.status&&(Ue=setTimeout(()=>{this.h((0,t.localize)(3,null,Le.nameShort),(0,t.localize)(4,null),Le)},1e4));const xe=h.ProxyChannel.toService(Fe.getChannel("launch"),{disableMarshalling:!0}),Qe=h.ProxyChannel.toService(Fe.getChannel("diagnostics"),{disableMarshalling:!0});if(Z.args.status)return ge.invokeFunction(async()=>{const Te=new n.$Bs(le.$cp,Le),te=await Qe.getMainDiagnostics(),de=await Qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),pe=await Te.getDiagnostics(te,de);throw console.log(pe),new u.$ab});throw v.$i&&await this.i(xe,we),we.trace("Sending env to running instance..."),await xe.start(Z.args,process.env),Fe.dispose(),Ue&&clearTimeout(Ue),new u.$ab("Sent env to running instance. Terminating...")}if(Z.args.status)throw console.log((0,t.localize)(5,null,Le.nameShort)),new u.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Be}g(we,Z,fe){if(fe.code==="EACCES"||fe.code==="EPERM"){const ge=(0,A.$Hb)([we.userDataPath,we.extensionsPath,w.$ii]).map(Le=>(0,y.$qw)(S.URI.file(Le),{os:v.OS,tildify:we}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,k.$cj)(fe),ge.join(`
`)),Z)}}h(we,Z,fe){i.dialog.showMessageBoxSync((0,he.$Ew)({type:"warning",buttons:[(0,t.localize)(8,null)],message:we,detail:Z},fe).options)}async i(we,Z){if(v.$i){const fe=await we.getMainProcessId();Z.trace("Sending some foreground love to the running instance:",fe);try{(await new Promise((ge,Le)=>{J(["windows-foreground-love"],ge,Le)})).allowSetForegroundWindow(fe)}catch(ge){Z.error(ge)}}}j(we,Z){const fe=we.get(q.$Xj),ge=we.get(F.$xbc);let Le=0;Z&&(Z.isExpected?Z.message&&fe.trace(Z.message):(Le=1,Z.stack?fe.error(Z.stack):fe.error(`Startup error: ${Z.toString()}`))),ge.kill(Le)}k(){const we=this.l((0,c.$sm)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const Z=(0,b.$3cc)(we.verbose);Z&&((0,c.$um)(process.argv,"--waitMarkerFilePath",Z),we.waitMarkerFilePath=Z)}return we}l(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const Z=this.m(we._,we.goto);we._=Z}return we}m(we,Z){const fe=(0,p.cwd)(),ge=we.map(Be=>{let Me=String(Be),Fe;Z&&(Fe=(0,l.$yg)(Me),Me=Fe.path),Me&&(Me=this.n(fe,Me));const Ue=(0,l.$tg)(Me,fe),xe=(0,$.$oc)(Ue);return xe&&!(0,l.$pg)(xe)?null:Z&&Fe?(Fe.path=Ue,this.o(Fe)):Ue}),Le=v.$i||v.$j,Ae=(0,A.$Mb)(ge,Be=>Be&&Le?Be.toLowerCase():Be||"");return(0,A.$Hb)(Ae)}n(we,Z){return v.$i&&(Z=(0,m.$cf)(Z,'"')),Z=(0,m.$af)((0,m.$af)(Z," "),"	"),v.$i&&(Z=(0,$.$lc)(we,Z),Z=(0,m.$cf)(Z,".")),Z}o(we){const Z=[we.path];return typeof we.line=="number"&&Z.push(String(we.line)),typeof we.column=="number"&&Z.push(String(we.column)),Z.join(":")}}new Ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/910284865c34fd492e3f6fd5a8ab8e571432cc58/core/vs/code/electron-main/main.js.map
