/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/base/common/types","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/assert","vs/base/common/equals","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/observable","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(se){for(var t=[],i=0,k=se.length;i<k;i++)t[i]=me[se[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:xt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Ct,construct:Nt}=typeof Reflect<"u"&&Reflect;Ct||(Ct=function(t,i,k){return t.apply(i,k)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Nt||(Nt=function(t,i){return new t(...i)});const oi=ct(Array.prototype.forEach),zt=ct(Array.prototype.pop),wt=ct(Array.prototype.push),Dt=ct(String.prototype.toLowerCase),Rt=ct(String.prototype.toString),ai=ct(String.prototype.match),dt=ct(String.prototype.replace),li=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),vt=ui(TypeError);function ct(se){return function(t){for(var i=arguments.length,k=new Array(i>1?i-1:0),P=1;P<i;P++)k[P-1]=arguments[P];return Ct(se,t,k)}}function ui(se){return function(){for(var t=arguments.length,i=new Array(t),k=0;k<t;k++)i[k]=arguments[k];return Nt(se,i)}}function He(se,t,i){var k;i=(k=i)!==null&&k!==void 0?k:Dt,xt&&xt(se,null);let P=t.length;for(;P--;){let W=t[P];if(typeof W=="string"){const S=i(W);S!==W&&(ii(t)||(t[P]=S),W=S)}se[W]=!0}return se}function bt(se){const t=ri(null);for(const[i,k]of Bt(se))t[i]=k;return t}function Et(se,t){for(;se!==null;){const k=si(se,t);if(k){if(k.get)return ct(k.get);if(typeof k.value=="function")return ct(k.value)}se=ni(se)}function i(k){return console.warn("fallback value for",k),null}return i}const Ht=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),It=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Mt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),jt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ot=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),St=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),Kt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Gt=ft(/^html$/i);var Yt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Gt});const vi=()=>typeof window>"u"?null:window,yi=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let k=null;const P="data-tt-policy-suffix";i&&i.hasAttribute(P)&&(k=i.getAttribute(P));const W="dompurify"+(k?"#"+k:"");try{return t.createPolicy(W,{createHTML(S){return S},createScriptURL(S){return S}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Ut(){let se=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Be=>Ut(Be);if(t.version="3.0.5",t.removed=[],!se||!se.document||se.document.nodeType!==9)return t.isSupported=!1,t;const i=se.document,k=i.currentScript;let{document:P}=se;const{DocumentFragment:W,HTMLTemplateElement:S,Node:A,Element:g,NodeFilter:b,NamedNodeMap:p=se.NamedNodeMap||se.MozNamedAttrMap,HTMLFormElement:O,DOMParser:c,trustedTypes:f}=se,e=g.prototype,n=Et(e,"cloneNode"),r=Et(e,"nextSibling"),h=Et(e,"childNodes"),m=Et(e,"parentNode");if(typeof S=="function"){const Be=P.createElement("template");Be.content&&Be.content.ownerDocument&&(P=Be.content.ownerDocument)}let y,o="";const{implementation:d,createNodeIterator:a,createDocumentFragment:L,getElementsByTagName:C}=P,{importNode:N}=i;let I={};t.isSupported=typeof Bt=="function"&&typeof m=="function"&&d&&d.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:M,ERB_EXPR:E,TMPLIT_EXPR:z,DATA_ATTR:q,ARIA_ATTR:F,IS_SCRIPT_OR_DATA:x,ATTR_WHITESPACE:B}=Yt;let{IS_ALLOWED_URI:Y}=Yt,K=null;const ae=He({},[...Ht,...It,...Mt,...jt,...Wt]);let ie=null;const ee=He({},[...Vt,...Ot,...qt,...St]);let ce=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),De=null,Ee=null,Ie=!0,le=!0,_=!1,ue=!0,re=!1,ye=!1,V=!1,Q=!1,ge=!1,we=!1,Le=!1,Te=!0,Me=!1;const H="user-content-";let u=!0,v=!1,l={},w=null;const T=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let s=null;const D=He({},["audio","video","img","source","image","track"]);let $=null;const R=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),j="http://www.w3.org/1998/Math/MathML",U="http://www.w3.org/2000/svg",J="http://www.w3.org/1999/xhtml";let oe=J,pe=!1,fe=null;const Re=He({},[j,U,J],Rt);let ke;const Oe=["application/xhtml+xml","text/html"],Se="text/html";let Fe,We=null;const Xe=P.createElement("form"),Ue=function(he){return he instanceof RegExp||he instanceof Function},_e=function(he){if(!(We&&We===he)){if((!he||typeof he!="object")&&(he={}),he=bt(he),ke=Oe.indexOf(he.PARSER_MEDIA_TYPE)===-1?ke=Se:ke=he.PARSER_MEDIA_TYPE,Fe=ke==="application/xhtml+xml"?Rt:Dt,K="ALLOWED_TAGS"in he?He({},he.ALLOWED_TAGS,Fe):ae,ie="ALLOWED_ATTR"in he?He({},he.ALLOWED_ATTR,Fe):ee,fe="ALLOWED_NAMESPACES"in he?He({},he.ALLOWED_NAMESPACES,Rt):Re,$="ADD_URI_SAFE_ATTR"in he?He(bt(R),he.ADD_URI_SAFE_ATTR,Fe):R,s="ADD_DATA_URI_TAGS"in he?He(bt(D),he.ADD_DATA_URI_TAGS,Fe):D,w="FORBID_CONTENTS"in he?He({},he.FORBID_CONTENTS,Fe):T,De="FORBID_TAGS"in he?He({},he.FORBID_TAGS,Fe):{},Ee="FORBID_ATTR"in he?He({},he.FORBID_ATTR,Fe):{},l="USE_PROFILES"in he?he.USE_PROFILES:!1,Ie=he.ALLOW_ARIA_ATTR!==!1,le=he.ALLOW_DATA_ATTR!==!1,_=he.ALLOW_UNKNOWN_PROTOCOLS||!1,ue=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,re=he.SAFE_FOR_TEMPLATES||!1,ye=he.WHOLE_DOCUMENT||!1,ge=he.RETURN_DOM||!1,we=he.RETURN_DOM_FRAGMENT||!1,Le=he.RETURN_TRUSTED_TYPE||!1,Q=he.FORCE_BODY||!1,Te=he.SANITIZE_DOM!==!1,Me=he.SANITIZE_NAMED_PROPS||!1,u=he.KEEP_CONTENT!==!1,v=he.IN_PLACE||!1,Y=he.ALLOWED_URI_REGEXP||Kt,oe=he.NAMESPACE||J,ce=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&Ue(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ce.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&Ue(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ce.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ce.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),re&&(le=!1),we&&(ge=!0),l&&(K=He({},[...Wt]),ie=[],l.html===!0&&(He(K,Ht),He(ie,Vt)),l.svg===!0&&(He(K,It),He(ie,Ot),He(ie,St)),l.svgFilters===!0&&(He(K,Mt),He(ie,Ot),He(ie,St)),l.mathMl===!0&&(He(K,jt),He(ie,qt),He(ie,St))),he.ADD_TAGS&&(K===ae&&(K=bt(K)),He(K,he.ADD_TAGS,Fe)),he.ADD_ATTR&&(ie===ee&&(ie=bt(ie)),He(ie,he.ADD_ATTR,Fe)),he.ADD_URI_SAFE_ATTR&&He($,he.ADD_URI_SAFE_ATTR,Fe),he.FORBID_CONTENTS&&(w===T&&(w=bt(w)),He(w,he.FORBID_CONTENTS,Fe)),u&&(K["#text"]=!0),ye&&He(K,["html","head","body"]),K.table&&(He(K,["tbody"]),delete De.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');y=he.TRUSTED_TYPES_POLICY,o=y.createHTML("")}else y===void 0&&(y=yi(f,k)),y!==null&&typeof o=="string"&&(o=y.createHTML(""));ot&&ot(he),We=he}},Z=He({},["mi","mo","mn","ms","mtext"]),ne=He({},["foreignobject","desc","title","annotation-xml"]),$e=He({},["title","style","font","a","script"]),ve=He({},It);He(ve,Mt),He(ve,ci);const Ne=He({},jt);He(Ne,fi);const ze=function(he){let Ce=m(he);(!Ce||!Ce.tagName)&&(Ce={namespaceURI:oe,tagName:"template"});const je=Dt(he.tagName),Ge=Dt(Ce.tagName);return fe[he.namespaceURI]?he.namespaceURI===U?Ce.namespaceURI===J?je==="svg":Ce.namespaceURI===j?je==="svg"&&(Ge==="annotation-xml"||Z[Ge]):!!ve[je]:he.namespaceURI===j?Ce.namespaceURI===J?je==="math":Ce.namespaceURI===U?je==="math"&&ne[Ge]:!!Ne[je]:he.namespaceURI===J?Ce.namespaceURI===U&&!ne[Ge]||Ce.namespaceURI===j&&!Z[Ge]?!1:!Ne[je]&&($e[je]||!ve[je]):!!(ke==="application/xhtml+xml"&&fe[he.namespaceURI]):!1},Ve=function(he){wt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},et=function(he,Ce){try{wt(t.removed,{attribute:Ce.getAttributeNode(he),from:Ce})}catch{wt(t.removed,{attribute:null,from:Ce})}if(Ce.removeAttribute(he),he==="is"&&!ie[he])if(ge||we)try{Ve(Ce)}catch{}else try{Ce.setAttribute(he,"")}catch{}},it=function(he){let Ce,je;if(Q)he="<remove></remove>"+he;else{const lt=ai(he,/^[\r\n\t ]+/);je=lt&&lt[0]}ke==="application/xhtml+xml"&&oe===J&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const Ge=y?y.createHTML(he):he;if(oe===J)try{Ce=new c().parseFromString(Ge,ke)}catch{}if(!Ce||!Ce.documentElement){Ce=d.createDocument(oe,"template",null);try{Ce.documentElement.innerHTML=pe?o:Ge}catch{}}const nt=Ce.body||Ce.documentElement;return he&&je&&nt.insertBefore(P.createTextNode(je),nt.childNodes[0]||null),oe===J?C.call(Ce,ye?"html":"body")[0]:ye?Ce.documentElement:nt},st=function(he){return a.call(he.ownerDocument||he,he,b.SHOW_ELEMENT|b.SHOW_COMMENT|b.SHOW_TEXT,null,!1)},Qe=function(he){return he instanceof O&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof p)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},rt=function(he){return typeof A=="object"?he instanceof A:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},tt=function(he,Ce,je){I[he]&&oi(I[he],Ge=>{Ge.call(t,Ce,je,We)})},mt=function(he){let Ce;if(tt("beforeSanitizeElements",he,null),Qe(he))return Ve(he),!0;const je=Fe(he.nodeName);if(tt("uponSanitizeElement",he,{tagName:je,allowedTags:K}),he.hasChildNodes()&&!rt(he.firstElementChild)&&(!rt(he.content)||!rt(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return Ve(he),!0;if(!K[je]||De[je]){if(!De[je]&&At(je)&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,je)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(je)))return!1;if(u&&!w[je]){const Ge=m(he)||he.parentNode,nt=h(he)||he.childNodes;if(nt&&Ge){const lt=nt.length;for(let Ze=lt-1;Ze>=0;--Ze)Ge.insertBefore(n(nt[Ze],!0),r(he))}}return Ve(he),!0}return he instanceof g&&!ze(he)||(je==="noscript"||je==="noembed"||je==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(Ve(he),!0):(re&&he.nodeType===3&&(Ce=he.textContent,Ce=dt(Ce,M," "),Ce=dt(Ce,E," "),Ce=dt(Ce,z," "),he.textContent!==Ce&&(wt(t.removed,{element:he.cloneNode()}),he.textContent=Ce)),tt("afterSanitizeElements",he,null),!1)},gt=function(he,Ce,je){if(Te&&(Ce==="id"||Ce==="name")&&(je in P||je in Xe))return!1;if(!(le&&!Ee[Ce]&&ht(q,Ce))){if(!(Ie&&ht(F,Ce))){if(!ie[Ce]||Ee[Ce]){if(!(At(he)&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,he)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(he))&&(ce.attributeNameCheck instanceof RegExp&&ht(ce.attributeNameCheck,Ce)||ce.attributeNameCheck instanceof Function&&ce.attributeNameCheck(Ce))||Ce==="is"&&ce.allowCustomizedBuiltInElements&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,je)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(je))))return!1}else if(!$[Ce]){if(!ht(Y,dt(je,B,""))){if(!((Ce==="src"||Ce==="xlink:href"||Ce==="href")&&he!=="script"&&li(je,"data:")===0&&s[he])){if(!(_&&!ht(x,dt(je,B,"")))){if(je)return!1}}}}}}return!0},At=function(he){return he.indexOf("-")>0},Lt=function(he){let Ce,je,Ge,nt;tt("beforeSanitizeAttributes",he,null);const{attributes:lt}=he;if(!lt)return;const Ze={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ie};for(nt=lt.length;nt--;){Ce=lt[nt];const{name:ut,namespaceURI:$t}=Ce;if(je=ut==="value"?Ce.value:hi(Ce.value),Ge=Fe(ut),Ze.attrName=Ge,Ze.attrValue=je,Ze.keepAttr=!0,Ze.forceKeepAttr=void 0,tt("uponSanitizeAttribute",he,Ze),je=Ze.attrValue,Ze.forceKeepAttr||(et(ut,he),!Ze.keepAttr))continue;if(!ue&&ht(/\/>/i,je)){et(ut,he);continue}re&&(je=dt(je,M," "),je=dt(je,E," "),je=dt(je,z," "));const Tt=Fe(he.nodeName);if(gt(Tt,Ge,je)){if(Me&&(Ge==="id"||Ge==="name")&&(et(ut,he),je=H+je),y&&typeof f=="object"&&typeof f.getAttributeType=="function"&&!$t)switch(f.getAttributeType(Tt,Ge)){case"TrustedHTML":{je=y.createHTML(je);break}case"TrustedScriptURL":{je=y.createScriptURL(je);break}}try{$t?he.setAttributeNS($t,ut,je):he.setAttribute(ut,je),zt(t.removed)}catch{}}}tt("afterSanitizeAttributes",he,null)},kt=function Be(he){let Ce;const je=st(he);for(tt("beforeSanitizeShadowDOM",he,null);Ce=je.nextNode();)tt("uponSanitizeShadowNode",Ce,null),!mt(Ce)&&(Ce.content instanceof W&&Be(Ce.content),Lt(Ce));tt("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(Be){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Ce,je,Ge,nt;if(pe=!Be,pe&&(Be="<!-->"),typeof Be!="string"&&!rt(Be))if(typeof Be.toString=="function"){if(Be=Be.toString(),typeof Be!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return Be;if(V||_e(he),t.removed=[],typeof Be=="string"&&(v=!1),v){if(Be.nodeName){const ut=Fe(Be.nodeName);if(!K[ut]||De[ut])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(Be instanceof A)Ce=it("<!---->"),je=Ce.ownerDocument.importNode(Be,!0),je.nodeType===1&&je.nodeName==="BODY"||je.nodeName==="HTML"?Ce=je:Ce.appendChild(je);else{if(!ge&&!re&&!ye&&Be.indexOf("<")===-1)return y&&Le?y.createHTML(Be):Be;if(Ce=it(Be),!Ce)return ge?null:Le?o:""}Ce&&Q&&Ve(Ce.firstChild);const lt=st(v?Be:Ce);for(;Ge=lt.nextNode();)mt(Ge)||(Ge.content instanceof W&&kt(Ge.content),Lt(Ge));if(v)return Be;if(ge){if(we)for(nt=L.call(Ce.ownerDocument);Ce.firstChild;)nt.appendChild(Ce.firstChild);else nt=Ce;return(ie.shadowroot||ie.shadowrootmode)&&(nt=N.call(i,nt,!0)),nt}let Ze=ye?Ce.outerHTML:Ce.innerHTML;return ye&&K["!doctype"]&&Ce.ownerDocument&&Ce.ownerDocument.doctype&&Ce.ownerDocument.doctype.name&&ht(Gt,Ce.ownerDocument.doctype.name)&&(Ze="<!DOCTYPE "+Ce.ownerDocument.doctype.name+`>
`+Ze),re&&(Ze=dt(Ze,M," "),Ze=dt(Ze,E," "),Ze=dt(Ze,z," ")),y&&Le?y.createHTML(Ze):Ze},t.setConfig=function(Be){_e(Be),V=!0},t.clearConfig=function(){We=null,V=!1},t.isValidAttribute=function(Be,he,Ce){We||_e({});const je=Fe(Be),Ge=Fe(he);return gt(je,Ge,Ce)},t.addHook=function(Be,he){typeof he=="function"&&(I[Be]=I[Be]||[],wt(I[Be],he))},t.removeHook=function(Be){if(I[Be])return zt(I[Be])},t.removeHooks=function(Be){I[Be]&&(I[Be]=[])},t.removeAllHooks=function(){I={}},t}var Di=Ut();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define(me[51],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gT=void 0,t.$hT=P;class i{constructor(S){this.domNode=S,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(S){const A=k(S);this.a!==A&&(this.a=A,this.domNode.style.maxWidth=this.a)}setWidth(S){const A=k(S);this.b!==A&&(this.b=A,this.domNode.style.width=this.b)}setHeight(S){const A=k(S);this.c!==A&&(this.c=A,this.domNode.style.height=this.c)}setTop(S){const A=k(S);this.d!==A&&(this.d=A,this.domNode.style.top=this.d)}setLeft(S){const A=k(S);this.e!==A&&(this.e=A,this.domNode.style.left=this.e)}setBottom(S){const A=k(S);this.f!==A&&(this.f=A,this.domNode.style.bottom=this.f)}setRight(S){const A=k(S);this.g!==A&&(this.g=A,this.domNode.style.right=this.g)}setPaddingTop(S){const A=k(S);this.h!==A&&(this.h=A,this.domNode.style.paddingTop=this.h)}setPaddingLeft(S){const A=k(S);this.i!==A&&(this.i=A,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(S){const A=k(S);this.j!==A&&(this.j=A,this.domNode.style.paddingBottom=this.j)}setPaddingRight(S){const A=k(S);this.k!==A&&(this.k=A,this.domNode.style.paddingRight=this.k)}setFontFamily(S){this.l!==S&&(this.l=S,this.domNode.style.fontFamily=this.l)}setFontWeight(S){this.m!==S&&(this.m=S,this.domNode.style.fontWeight=this.m)}setFontSize(S){const A=k(S);this.n!==A&&(this.n=A,this.domNode.style.fontSize=this.n)}setFontStyle(S){this.o!==S&&(this.o=S,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(S){this.p!==S&&(this.p=S,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(S){this.q!==S&&(this.q=S,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(S){this.r!==S&&(this.r=S,this.domNode.style.textDecoration=this.r)}setLineHeight(S){const A=k(S);this.s!==A&&(this.s=A,this.domNode.style.lineHeight=this.s)}setLetterSpacing(S){const A=k(S);this.t!==A&&(this.t=A,this.domNode.style.letterSpacing=this.t)}setClassName(S){this.u!==S&&(this.u=S,this.domNode.className=this.u)}toggleClassName(S,A){this.domNode.classList.toggle(S,A),this.u=this.domNode.className}setDisplay(S){this.v!==S&&(this.v=S,this.domNode.style.display=this.v)}setPosition(S){this.w!==S&&(this.w=S,this.domNode.style.position=this.w)}setVisibility(S){this.x!==S&&(this.x=S,this.domNode.style.visibility=this.x)}setColor(S){this.y!==S&&(this.y=S,this.domNode.style.color=this.y)}setBackgroundColor(S){this.z!==S&&(this.z=S,this.domNode.style.backgroundColor=this.z)}setLayerHinting(S){this.A!==S&&(this.A=S,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(S){this.C!==S&&(this.C=S,this.domNode.style.boxShadow=S)}setContain(S){this.B!==S&&(this.B=S,this.domNode.style.contain=this.B)}setAttribute(S,A){this.domNode.setAttribute(S,A)}removeAttribute(S){this.domNode.removeAttribute(S)}appendChild(S){this.domNode.appendChild(S.domNode)}removeChild(S){this.domNode.removeChild(S.domNode)}}t.$gT=i;function k(W){return typeof W=="number"?`${W}px`:W}function P(W){return new i(W)}}),define(me[79],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yR=void 0,t.$zR=W;const i=new WeakMap;function k(A){if(!A.parent||A.parent===A)return null;try{const g=A.location,b=A.parent.location;if(g.origin!=="null"&&b.origin!=="null"&&g.origin!==b.origin)return null}catch{return null}return A.parent}class P{static a(g){let b=i.get(g);if(!b){b=[],i.set(g,b);let p=g,O;do O=k(p),O?b.push({window:new WeakRef(p),iframeElement:p.frameElement||null}):b.push({window:new WeakRef(p),iframeElement:null}),p=O;while(p)}return b.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(g,b){if(!b||g===b)return{top:0,left:0};let p=0,O=0;const c=this.a(g);for(const f of c){const e=f.window.deref();if(p+=e?.scrollY??0,O+=e?.scrollX??0,e===b||!f.iframeElement)break;const n=f.iframeElement.getBoundingClientRect();p+=n.top,O+=n.left}return{top:p,left:O}}}t.$yR=P;async function W(A,g){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const b=JSON.stringify({parentOrigin:A,salt:g}),O=new TextEncoder().encode(b),c=await crypto.subtle.digest("sha-256",O);return S(c)}function S(A){const b=Array.from(new Uint8Array(A)).map(p=>p.toString(16).padStart(2,"0")).join("");return BigInt(`0x${b}`).toString(32).padStart(52,"0")}}),define(me[29],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lU=k,t.$mU=P;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupUpdatableHover:()=>null};function k(W){i=W}function P(){return i}}),define(me[80],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1T=t.$ZT=t.$YT=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(S){S[S.Copy=0]="Copy",S[S.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var k;(function(S){S.Over="drop-target",S.Before="drop-target-before",S.After="drop-target-after"})(k||(t.ListDragOverEffectPosition=k={})),t.$YT={reject(){return{accept:!1}},accept(){return{accept:!0}}};class P extends Error{constructor(A,g){super(`ListError [${A}] ${g}`)}}t.$ZT=P;class W{constructor(){this.c=new WeakMap}getHeight(A){return this.c.get(A)??this.d(A)}setDynamicHeight(A,g){g>0&&this.c.set(A,g)}}t.$1T=W}),define(me[81],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OT=void 0;class i{constructor(P){this.a=P}splice(P,W,S){this.a.forEach(A=>A.splice(P,W,S))}}t.$OT=i}),define(me[52],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mT=void 0;const i=20;class k{constructor(W,S,A,g,b,p){this.a=Math.round(S),this.b=Math.round(A),this.c=Math.round(W),this.d=g,this.e=b,this.f=p,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new k(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(W){const S=Math.round(W);return this.d!==S?(this.d=S,this.m(),!0):!1}setScrollSize(W){const S=Math.round(W);return this.e!==S?(this.e=S,this.m(),!0):!1}setScrollPosition(W){const S=Math.round(W);return this.f!==S?(this.f=S,this.m(),!0):!1}setScrollbarSize(W){this.a=Math.round(W)}setOppositeScrollbarSize(W){this.b=Math.round(W)}static l(W,S,A,g,b){const p=Math.max(0,A-W),O=Math.max(0,p-2*S),c=g>0&&g>A;if(!c)return{computedAvailableSize:Math.round(p),computedIsNeeded:c,computedSliderSize:Math.round(O),computedSliderRatio:0,computedSliderPosition:0};const f=Math.round(Math.max(i,Math.floor(A*O/g))),e=(O-f)/(g-A),n=b*e;return{computedAvailableSize:Math.round(p),computedIsNeeded:c,computedSliderSize:Math.round(f),computedSliderRatio:e,computedSliderPosition:Math.round(n)}}m(){const W=k.l(this.b,this.c,this.d,this.e,this.f);this.g=W.computedAvailableSize,this.h=W.computedIsNeeded,this.i=W.computedSliderSize,this.j=W.computedSliderRatio,this.k=W.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(W){if(!this.h)return 0;const S=W-this.c-this.i/2;return Math.round(S/this.j)}getDesiredScrollPositionFromOffsetPaged(W){if(!this.h)return 0;const S=W-this.c;let A=this.f;return S<this.k?A-=this.d:A+=this.d,A}getDesiredScrollPositionFromDelta(W){if(!this.h)return 0;const S=this.k+W;return Math.round(S/this.j)}}t.$mT=k}),define(me[30],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VV=t.$UV=t.$TV=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var i;(function(g){g[g.Hidden=0]="Hidden",g[g.Visible=1]="Visible",g[g.Recurse=2]="Recurse"})(i||(t.TreeVisibility=i={}));var k;(function(g){g[g.Expanded=0]="Expanded",g[g.Collapsed=1]="Collapsed",g[g.PreserveOrExpanded=2]="PreserveOrExpanded",g[g.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(k||(t.ObjectTreeElementCollapseState=k={}));var P;(function(g){g[g.Unknown=0]="Unknown",g[g.Twistie=1]="Twistie",g[g.Element=2]="Element",g[g.Filter=3]="Filter"})(P||(t.TreeMouseEventTarget=P={}));var W;(function(g){g[g.Down=0]="Down",g[g.Up=1]="Up"})(W||(t.TreeDragOverBubble=W={})),t.$TV={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(g=!1){return{accept:!0,bubble:0,autoExpand:g}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(g=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:g}}};class S extends Error{constructor(b,p){super(`TreeError [${b}] ${p}`)}}t.$UV=S;class A{constructor(b){this.a=b,this.b=new WeakMap}map(b){let p=this.b.get(b);return p||(p=this.a(b),this.b.set(b,p)),p}}t.$VV=A}),define(me[22],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cR=void 0,t.$bR=i,t.$dR=k;function i(P,W){const S=P;typeof S.vscodeWindowId!="number"&&Object.defineProperty(S,"vscodeWindowId",{get:()=>W})}t.$cR=window;function k(P){return P===t.$cR?!1:typeof P?.vscodeWindowId=="number"}}),define(me[82],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=k,t.$hb=P,t.$ib=W,t.$jb=S,t.$kb=A,t.$lb=g,t.$nb=p,t.$ob=O,t.$pb=c,t.$qb=f,t.$rb=e;function i(n,r){const h=k(n,r);if(h!==-1)return n[h]}function k(n,r,h=n.length-1){for(let m=h;m>=0;m--){const y=n[m];if(r(y))return m}return-1}function P(n,r){const h=W(n,r);return h===-1?void 0:n[h]}function W(n,r,h=0,m=n.length){let y=h,o=m;for(;y<o;){const d=Math.floor((y+o)/2);r(n[d])?y=d+1:o=d}return y-1}function S(n,r){const h=A(n,r);return h===n.length?void 0:n[h]}function A(n,r,h=0,m=n.length){let y=h,o=m;for(;y<o;){const d=Math.floor((y+o)/2);r(n[d])?o=d:y=d+1}return y}function g(n,r,h=0,m=n.length){const y=A(n,r,h,m);return y===n.length?-1:y}class b{static{this.assertInvariants=!1}constructor(r){this.e=r,this.c=0}findLastMonotonous(r){if(b.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!r(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=r}const h=W(this.e,r,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}t.$mb=b;function p(n,r){if(n.length===0)return;let h=n[0];for(let m=1;m<n.length;m++){const y=n[m];r(y,h)>0&&(h=y)}return h}function O(n,r){if(n.length===0)return;let h=n[0];for(let m=1;m<n.length;m++){const y=n[m];r(y,h)>=0&&(h=y)}return h}function c(n,r){return p(n,(h,m)=>-r(h,m))}function f(n,r){if(n.length===0)return-1;let h=0;for(let m=1;m<n.length;m++){const y=n[m];r(y,n[h])>0&&(h=m)}return h}function e(n,r){for(const h of n){const m=r(h);if(m!==void 0)return m}}}),define(me[83],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=k,t.$M=P,t.$N=W;function i(S,A){const g=Object.create(null);for(const b of S){const p=A(b);let O=g[p];O||(O=g[p]=[]),O.push(b)}return g}function k(S,A){const g=[],b=[];for(const p of S)A.has(p)||g.push(p);for(const p of A)S.has(p)||b.push(p);return{removed:g,added:b}}function P(S,A){const g=[],b=[];for(const[p,O]of S)A.has(p)||g.push(O);for(const[p,O]of A)S.has(p)||b.push(O);return{removed:g,added:b}}function W(S,A){const g=new Set;for(const b of A)S.has(b)&&g.add(b);return g}}),define(me[84],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$It=t.$Ht=t.$Gt=t.$Ft=void 0;function i(A,g){const b=Math.pow(10,g);return Math.round(A*b)/b}class k{constructor(g,b,p,O=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,b))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=i(Math.max(Math.min(1,O),0),3)}static equals(g,b){return g.r===b.r&&g.g===b.g&&g.b===b.b&&g.a===b.a}}t.$Ft=k;class P{constructor(g,b,p,O){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=i(Math.max(Math.min(1,b),0),3),this.l=i(Math.max(Math.min(1,p),0),3),this.a=i(Math.max(Math.min(1,O),0),3)}static equals(g,b){return g.h===b.h&&g.s===b.s&&g.l===b.l&&g.a===b.a}static fromRGBA(g){const b=g.r/255,p=g.g/255,O=g.b/255,c=g.a,f=Math.max(b,p,O),e=Math.min(b,p,O);let n=0,r=0;const h=(e+f)/2,m=f-e;if(m>0){switch(r=Math.min(h<=.5?m/(2*h):m/(2-2*h),1),f){case b:n=(p-O)/m+(p<O?6:0);break;case p:n=(O-b)/m+2;break;case O:n=(b-p)/m+4;break}n*=60,n=Math.round(n)}return new P(n,r,h,c)}static i(g,b,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?g+(b-g)*6*p:p<1/2?b:p<2/3?g+(b-g)*(2/3-p)*6:g}static toRGBA(g){const b=g.h/360,{s:p,l:O,a:c}=g;let f,e,n;if(p===0)f=e=n=O;else{const r=O<.5?O*(1+p):O+p-O*p,h=2*O-r;f=P.i(h,r,b+1/3),e=P.i(h,r,b),n=P.i(h,r,b-1/3)}return new k(Math.round(f*255),Math.round(e*255),Math.round(n*255),c)}}t.$Gt=P;class W{constructor(g,b,p,O){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=i(Math.max(Math.min(1,b),0),3),this.v=i(Math.max(Math.min(1,p),0),3),this.a=i(Math.max(Math.min(1,O),0),3)}static equals(g,b){return g.h===b.h&&g.s===b.s&&g.v===b.v&&g.a===b.a}static fromRGBA(g){const b=g.r/255,p=g.g/255,O=g.b/255,c=Math.max(b,p,O),f=Math.min(b,p,O),e=c-f,n=c===0?0:e/c;let r;return e===0?r=0:c===b?r=((p-O)/e%6+6)%6:c===p?r=(O-b)/e+2:r=(b-p)/e+4,new W(Math.round(r*60),n,c,g.a)}static toRGBA(g){const{h:b,s:p,v:O,a:c}=g,f=O*p,e=f*(1-Math.abs(b/60%2-1)),n=O-f;let[r,h,m]=[0,0,0];return b<60?(r=f,h=e):b<120?(r=e,h=f):b<180?(h=f,m=e):b<240?(h=e,m=f):b<300?(r=e,m=f):b<=360&&(r=f,m=e),r=Math.round((r+n)*255),h=Math.round((h+n)*255),m=Math.round((m+n)*255),new k(r,h,m,c)}}t.$Ht=W;class S{static fromHex(g){return S.Format.CSS.parseHex(g)||S.red}static equals(g,b){return!g&&!b?!0:!g||!b?!1:g.equals(b)}get hsla(){return this.i?this.i:P.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:W.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof k)this.rgba=g;else if(g instanceof P)this.i=g,this.rgba=P.toRGBA(g);else if(g instanceof W)this.j=g,this.rgba=W.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&k.equals(this.rgba,g.rgba)&&P.equals(this.hsla,g.hsla)&&W.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=S.k(this.rgba.r),b=S.k(this.rgba.g),p=S.k(this.rgba.b),O=.2126*g+.7152*b+.0722*p;return i(O,4)}static k(g){const b=g/255;return b<=.03928?b/12.92:Math.pow((b+.055)/1.055,2.4)}getContrastRatio(g){const b=this.getRelativeLuminance(),p=g.getRelativeLuminance();return b>p?(b+.05)/(p+.05):(p+.05)/(b+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const b=this.getRelativeLuminance(),p=g.getRelativeLuminance();return b>p}isDarkerThan(g){const b=this.getRelativeLuminance(),p=g.getRelativeLuminance();return b<p}lighten(g){return new S(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new S(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:b,g:p,b:O,a:c}=this.rgba;return new S(new k(b,p,O,c*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new S(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const b=g.rgba,p=this.rgba.a,O=b.a,c=p+O*(1-p);if(c<1e-6)return S.transparent;const f=this.rgba.r*p/c+b.r*O*(1-p)/c,e=this.rgba.g*p/c+b.g*O*(1-p)/c,n=this.rgba.b*p/c+b.b*O*(1-p)/c;return new S(new k(f,e,n,c))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:b,g:p,b:O,a:c}=this.rgba;return new S(new k(g.rgba.r-c*(g.rgba.r-b),g.rgba.g-c*(g.rgba.g-p),g.rgba.b-c*(g.rgba.b-O),1))}flatten(...g){const b=g.reduceRight((p,O)=>S.o(O,p));return S.o(this,b)}static o(g,b){const p=1-g.rgba.a;return new S(new k(p*b.rgba.r+g.rgba.a*g.rgba.r,p*b.rgba.g+g.rgba.a*g.rgba.g,p*b.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this.u||(this.u=S.Format.CSS.format(this)),this.u}static getLighterColor(g,b,p){if(g.isLighterThan(b))return g;p=p||.5;const O=g.getRelativeLuminance(),c=b.getRelativeLuminance();return p=p*(c-O)/c,g.lighten(p)}static getDarkerColor(g,b,p){if(g.isDarkerThan(b))return g;p=p||.5;const O=g.getRelativeLuminance(),c=b.getRelativeLuminance();return p=p*(O-c)/O,g.darken(p)}static{this.white=new S(new k(255,255,255,1))}static{this.black=new S(new k(0,0,0,1))}static{this.red=new S(new k(255,0,0,1))}static{this.blue=new S(new k(0,0,255,1))}static{this.green=new S(new k(0,255,0,1))}static{this.cyan=new S(new k(0,255,255,1))}static{this.lightgrey=new S(new k(211,211,211,1))}static{this.transparent=new S(new k(0,0,0,0))}}t.$It=S,function(A){let g;(function(b){let p;(function(O){function c(a){return a.rgba.a===1?`rgb(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b})`:A.Format.CSS.formatRGBA(a)}O.formatRGB=c;function f(a){return`rgba(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b}, ${+a.rgba.a.toFixed(2)})`}O.formatRGBA=f;function e(a){return a.hsla.a===1?`hsl(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(a)}O.formatHSL=e;function n(a){return`hsla(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%, ${a.hsla.a.toFixed(2)})`}O.formatHSLA=n;function r(a){const L=a.toString(16);return L.length!==2?"0"+L:L}function h(a){return`#${r(a.rgba.r)}${r(a.rgba.g)}${r(a.rgba.b)}`}O.formatHex=h;function m(a,L=!1){return L&&a.rgba.a===1?A.Format.CSS.formatHex(a):`#${r(a.rgba.r)}${r(a.rgba.g)}${r(a.rgba.b)}${r(Math.round(a.rgba.a*255))}`}O.formatHexA=m;function y(a){return a.isOpaque()?A.Format.CSS.formatHex(a):A.Format.CSS.formatRGBA(a)}O.format=y;function o(a){const L=a.length;if(L===0||a.charCodeAt(0)!==35)return null;if(L===7){const C=16*d(a.charCodeAt(1))+d(a.charCodeAt(2)),N=16*d(a.charCodeAt(3))+d(a.charCodeAt(4)),I=16*d(a.charCodeAt(5))+d(a.charCodeAt(6));return new A(new k(C,N,I,1))}if(L===9){const C=16*d(a.charCodeAt(1))+d(a.charCodeAt(2)),N=16*d(a.charCodeAt(3))+d(a.charCodeAt(4)),I=16*d(a.charCodeAt(5))+d(a.charCodeAt(6)),M=16*d(a.charCodeAt(7))+d(a.charCodeAt(8));return new A(new k(C,N,I,M/255))}if(L===4){const C=d(a.charCodeAt(1)),N=d(a.charCodeAt(2)),I=d(a.charCodeAt(3));return new A(new k(16*C+C,16*N+N,16*I+I))}if(L===5){const C=d(a.charCodeAt(1)),N=d(a.charCodeAt(2)),I=d(a.charCodeAt(3)),M=d(a.charCodeAt(4));return new A(new k(16*C+C,16*N+N,16*I+I,(16*M+M)/255))}return null}O.parseHex=o;function d(a){switch(a){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=b.CSS||(b.CSS={}))})(g=A.Format||(A.Format={}))}(S||(t.$It=S={}))}),define(me[31],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vh=k,t.$Wh=P,t.$Xh=W;function i(S){return(A,g,b)=>{let p=null,O=null;if(typeof b.value=="function"?(p="value",O=b.value):typeof b.get=="function"&&(p="get",O=b.get),!O)throw new Error("not supported");b[p]=S(O,g)}}function k(S,A,g){let b=null,p=null;if(typeof g.value=="function"?(b="value",p=g.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(b="get",p=g.get),!p)throw new Error("not supported");const O=`$memoize$${A}`;g[b]=function(...c){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,c)}),this[O]}}function P(S,A,g){return i((b,p)=>{const O=`$debounce$${p}`,c=`$debounce$result$${p}`;return function(...f){this[c]||(this[c]=g?g():void 0),clearTimeout(this[O]),A&&(this[c]=A(this[c],...f),f=[this[c]]),this[O]=setTimeout(()=>{b.apply(this,f),this[c]=g?g():void 0},S)}})}function W(S,A,g){return i((b,p)=>{const O=`$throttle$timer$${p}`,c=`$throttle$result$${p}`,f=`$throttle$lastRun$${p}`,e=`$throttle$pending$${p}`;return function(...n){if(this[c]||(this[c]=g?g():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),A&&(this[c]=A(this[c],...n)),this[e])return;const r=this[f]+S;r<=Date.now()?(this[f]=Date.now(),b.apply(this,[this[c]]),this[c]=g?g():void 0):(this[e]=!0,this[O]=setTimeout(()=>{this[e]=!1,this[f]=Date.now(),b.apply(this,[this[c]]),this[c]=g?g():void 0},r-Date.now()))}})}}),define(me[85],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qt=void 0;class i{constructor(P,W,S,A){this.originalStart=P,this.originalLength=W,this.modifiedStart=S,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$qt=i}),define(me[6],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=k,t.$Z=P,t.$1=W,t.$2=S,t.$3=A,t.$4=b,t.$6=O,t.$7=c,t.$8=f,t.$0=n;class i{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?y.isErrorNoTelemetry(a)?new y(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(L=>{L(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}t.$W=i,t.$X=new i;function k(d){t.$X.setUnexpectedErrorHandler(d)}function P(d){if(!d||typeof d!="object")return!1;const a=d;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}function W(d){b(d)||t.$X.onUnexpectedError(d)}function S(d){b(d)||t.$X.onUnexpectedExternalError(d)}function A(d){if(d instanceof Error){const{name:a,message:L}=d,C=d.stacktrace||d.stack;return{$isError:!0,name:a,message:L,stack:C,noTelemetry:y.isErrorNoTelemetry(d)}}return d}const g="Canceled";function b(d){return d instanceof p?!0:d instanceof Error&&d.name===g&&d.message===g}class p extends Error{constructor(){super(g),this.name=this.message}}t.$5=p;function O(){const d=new Error(g);return d.name=d.message,d}function c(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}function f(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}class e extends TypeError{constructor(a){super(a?`${a} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function n(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}class r extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}t.$$=r;class h extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}t.$_=h;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=m;class y extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof y)return a;const L=new y;return L.message=a.message,L.stack=a.stack,L}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}t.$bb=y;class o extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}t.$cb=o}),define(me[8],be([1,0,6,82]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=P,t.$tb=W,t.$ub=S,t.$vb=A,t.$wb=g,t.$xb=b,t.$yb=p,t.$zb=O,t.$Ab=c,t.$Bb=f,t.$Cb=e,t.$Db=n,t.$Eb=r,t.top=h,t.$Gb=m,t.$Hb=o,t.$Ib=d,t.$Jb=a,t.$Kb=L,t.$Lb=C,t.$Mb=N,t.$Nb=I,t.$Ob=M,t.$Pb=E,t.$Qb=z,t.$Rb=q,t.$Sb=F,t.$Tb=x,t.$Ub=B,t.$Vb=Y,t.$Wb=K,t.$Xb=ae,t.$Yb=ie,t.$Zb=ee,t.$1b=ce,t.$2b=De,t.$3b=Ee,t.$4b=Ie,t.$5b=le,t.$6b=_,t.$7b=ye,t.$8b=V,t.$$b=we;function P(H,u=0){return H[H.length-(1+u)]}function W(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}function S(H,u,v=(l,w)=>l===w){if(H===u)return!0;if(!H||!u||H.length!==u.length)return!1;for(let l=0,w=H.length;l<w;l++)if(!v(H[l],u[l]))return!1;return!0}function A(H,u){const v=H.length-1;u<v&&(H[u]=H[v]),H.pop()}function g(H,u,v){return b(H.length,l=>v(H[l],u))}function b(H,u){let v=0,l=H-1;for(;v<=l;){const w=(v+l)/2|0,T=u(w);if(T<0)v=w+1;else if(T>0)l=w-1;else return w}return-(v+1)}function p(H,u,v){if(H=H|0,H>=u.length)throw new TypeError("invalid index");const l=u[Math.floor(u.length*Math.random())],w=[],T=[],s=[];for(const D of u){const $=v(D,l);$<0?w.push(D):$>0?T.push(D):s.push(D)}return H<w.length?p(H,w,v):H<w.length+s.length?s[0]:p(H-(w.length+s.length),T,v)}function O(H,u){const v=[];let l;for(const w of H.slice(0).sort(u))!l||u(l[0],w)!==0?(l=[w],v.push(l)):l.push(w);return v}function*c(H,u){let v,l;for(const w of H)l!==void 0&&u(l,w)?v.push(w):(v&&(yield v),v=[w]),l=w;v&&(yield v)}function f(H,u){for(let v=0;v<=H.length;v++)u(v===0?void 0:H[v-1],v===H.length?void 0:H[v])}function e(H,u){for(let v=0;v<H.length;v++)u(v===0?void 0:H[v-1],H[v],v+1===H.length?void 0:H[v+1])}function n(H,u,v){const l=[];function w(D,$,R){if($===0&&R.length===0)return;const j=l[l.length-1];j&&j.start+j.deleteCount===D?(j.deleteCount+=$,j.toInsert.push(...R)):l.push({start:D,deleteCount:$,toInsert:R})}let T=0,s=0;for(;;){if(T===H.length){w(T,0,u.slice(s));break}if(s===u.length){w(T,H.length-T,[]);break}const D=H[T],$=u[s],R=v(D,$);R===0?(T+=1,s+=1):R<0?(w(T,1,[]),T+=1):R>0&&(w(T,0,[$]),s+=1)}return l}function r(H,u,v){const l=n(H,u,v),w=[],T=[];for(const s of l)w.push(...H.slice(s.start,s.start+s.deleteCount)),T.push(...s.toInsert);return{removed:w,added:T}}function h(H,u,v){if(v===0)return[];const l=H.slice(0,v).sort(u);return y(H,u,l,v,H.length),l}function m(H,u,v,l,w){return v===0?Promise.resolve([]):new Promise((T,s)=>{(async()=>{const D=H.length,$=H.slice(0,v).sort(u);for(let R=v,j=Math.min(v+l,D);R<D;R=j,j=Math.min(j+l,D)){if(R>v&&await new Promise(U=>setTimeout(U)),w&&w.isCancellationRequested)throw new i.$5;y(H,u,$,R,j)}return $})().then(T,s)})}function y(H,u,v,l,w){for(const T=v.length;l<w;l++){const s=H[l];if(u(s,v[T-1])<0){v.pop();const D=(0,k.$kb)(v,$=>u(s,$)<0);v.splice(D,0,s)}}}function o(H){return H.filter(u=>!!u)}function d(H){let u=0;for(let v=0;v<H.length;v++)H[v]&&(H[u]=H[v],u+=1);H.length=u}function a(H,u,v){H.splice(v,0,H.splice(u,1)[0])}function L(H){return!Array.isArray(H)||H.length===0}function C(H){return Array.isArray(H)&&H.length>0}function N(H,u=v=>v){const v=new Set;return H.filter(l=>{const w=u(l);return v.has(w)?!1:(v.add(w),!0)})}function I(H){const u=new Set;return v=>{const l=H(v);return u.has(l)?!1:(u.add(l),!0)}}function M(H,u){return H.length>0?H[0]:u}function E(H,u){return H.length>0?H[H.length-1]:u}function z(H,u,v=(l,w)=>l===w){let l=0;for(let w=0,T=Math.min(H.length,u.length);w<T&&v(H[w],u[w]);w++)l++;return l}function q(H){return[].concat(...H)}function F(H,u){let v=typeof u=="number"?H:0;typeof u=="number"?v=H:(v=0,u=H);const l=[];if(v<=u)for(let w=v;w<u;w++)l.push(w);else for(let w=v;w>u;w--)l.push(w);return l}function x(H,u,v){return H.reduce((l,w)=>(l[u(w)]=v?v(w):w,l),Object.create(null))}function B(H,u){return H.push(u),()=>Y(H,u)}function Y(H,u){const v=H.indexOf(u);if(v>-1)return H.splice(v,1),u}function K(H,u,v){const l=H.slice(0,u),w=H.slice(u);return l.concat(v,w)}function ae(H,u){let v;if(typeof u=="number"){let l=u;v=()=>{const w=Math.sin(l++)*179426549;return w-Math.floor(w)}}else v=Math.random;for(let l=H.length-1;l>0;l-=1){const w=Math.floor(v()*(l+1)),T=H[l];H[l]=H[w],H[w]=T}}function ie(H,u){const v=H.indexOf(u);v>-1&&(H.splice(v,1),H.unshift(u))}function ee(H,u){const v=H.indexOf(u);v>-1&&(H.splice(v,1),H.push(u))}function ce(H,u){for(const v of u)H.push(v)}function De(H,u){return Array.isArray(H)?H.map(u):u(H)}function Ee(H){return Array.isArray(H)?H:[H]}function Ie(H){return H[Math.floor(Math.random()*H.length)]}function le(H,u,v){const l=ue(H,u),w=H.length,T=v.length;H.length=w+T;for(let s=w-1;s>=l;s--)H[s+T]=H[s];for(let s=0;s<T;s++)H[s+l]=v[s]}function _(H,u,v,l){const w=ue(H,u);let T=H.splice(w,v);return T===void 0&&(T=[]),le(H,w,l),T}function ue(H,u){return u<0?Math.max(u+H.length,0):Math.min(u,H.length)}var re;(function(H){function u(T){return T<0}H.isLessThan=u;function v(T){return T<=0}H.isLessThanOrEqual=v;function l(T){return T>0}H.isGreaterThan=l;function w(T){return T===0}H.isNeitherLessOrGreaterThan=w,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(re||(t.CompareResult=re={}));function ye(H,u){return(v,l)=>u(H(v),H(l))}function V(...H){return(u,v)=>{for(const l of H){const w=l(u,v);if(!re.isNeitherLessOrGreaterThan(w))return w}return re.neitherLessOrGreaterThan}}const Q=(H,u)=>H-u;t.$9b=Q;const ge=(H,u)=>(0,t.$9b)(H?1:0,u?1:0);t.$0b=ge;function we(H){return(u,v)=>-H(u,v)}class Le{constructor(u){this.g=u,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(u){let v=this.c;for(;v<this.g.length&&u(this.g[v]);)v++;const l=v===this.c?null:this.g.slice(this.c,v);return this.c=v,l}takeFromEndWhile(u){let v=this.d;for(;v>=0&&u(this.g[v]);)v--;const l=v===this.d?null:this.g.slice(v+1,this.d+1);return this.d=v,l}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const u=this.g[this.c];return this.c++,u}removeLast(){const u=this.g[this.d];return this.d--,u}takeCount(u){const v=this.g.slice(this.c,this.c+u);return this.c+=u,v}}t.$_b=Le;class Te{static{this.empty=new Te(u=>{})}constructor(u){this.iterate=u}forEach(u){this.iterate(v=>(u(v),!0))}toArray(){const u=[];return this.iterate(v=>(u.push(v),!0)),u}filter(u){return new Te(v=>this.iterate(l=>u(l)?v(l):!0))}map(u){return new Te(v=>this.iterate(l=>v(u(l))))}some(u){let v=!1;return this.iterate(l=>(v=u(l),!v)),v}findFirst(u){let v;return this.iterate(l=>u(l)?(v=l,!1):!0),v}findLast(u){let v;return this.iterate(l=>(u(l)&&(v=l),!0)),v}findLastMaxBy(u){let v,l=!0;return this.iterate(w=>((l||re.isGreaterThan(u(w,v)))&&(l=!1,v=w),!0)),v}}t.$ac=Te;class Me{constructor(u){this.c=u}static createSortPermutation(u,v){const l=Array.from(u.keys()).sort((w,T)=>v(u[w],u[T]));return new Me(l)}apply(u){return u.map((v,l)=>u[this.c[l]])}inverse(){const u=this.c.slice();for(let v=0;v<this.c.length;v++)u[this.c[v]]=v;return new Me(u)}}t.$bc=Me}),define(me[37],be([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=k,t.$cd=P,t.$dd=W,t.$ed=S,t.$fd=A,t.$gd=g;function k(b,p){if(!b)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}function P(b,p="Unreachable"){throw new Error(p)}function W(b){if(!b)throw new i.$cb("Assertion Failed")}function S(b){b||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function A(b){if(!b()){debugger;b(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function g(b,p){let O=0;for(;O<b.length-1;){const c=b[O],f=b[O+1];if(!p(c,f))return!1;O++}return!0}}),define(me[38],be([1,0,8]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0,t.$7c=P,t.$8c=W,t.$9c=S,t.$0c=A;const k=(g,b)=>g===b;t.$6c=k;function P(g=t.$6c){return(b,p)=>i.$ub(b,p,g)}function W(){return(g,b)=>JSON.stringify(g)===JSON.stringify(b)}function S(){return(g,b)=>g.equals(b)}function A(g,b,p){return!g||!b?g===b:p(g,b)}}),define(me[53],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(k,P){const W=this;let S=!1,A;return function(){if(S)return A;if(S=!0,P)try{A=k.apply(W,arguments)}finally{P()}else A=k.apply(W,arguments);return A}}}),define(me[86],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lP=t.$kP=void 0;class i{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}t.$kP=i,t.$lP=new i("id#")}),define(me[32],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(k){function P(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}k.is=P;const W=Object.freeze([]);function S(){return W}k.empty=S;function*A(a){yield a}k.single=A;function g(a){return P(a)?a:A(a)}k.wrap=g;function b(a){return a||W}k.from=b;function*p(a){for(let L=a.length-1;L>=0;L--)yield a[L]}k.reverse=p;function O(a){return!a||a[Symbol.iterator]().next().done===!0}k.isEmpty=O;function c(a){return a[Symbol.iterator]().next().value}k.first=c;function f(a,L){for(const C of a)if(L(C))return!0;return!1}k.some=f;function e(a,L){for(const C of a)if(L(C))return C}k.find=e;function*n(a,L){for(const C of a)L(C)&&(yield C)}k.filter=n;function*r(a,L){let C=0;for(const N of a)yield L(N,C++)}k.map=r;function*h(...a){for(const L of a)yield*L}k.concat=h;function m(a,L,C){let N=C;for(const I of a)N=L(N,I);return N}k.reduce=m;function*y(a,L,C=a.length){for(L<0&&(L+=a.length),C<0?C+=a.length:C>a.length&&(C=a.length);L<C;L++)yield a[L]}k.slice=y;function o(a,L=Number.POSITIVE_INFINITY){const C=[];if(L===0)return[C,a];const N=a[Symbol.iterator]();for(let I=0;I<L;I++){const M=N.next();if(M.done)return[C,k.empty()];C.push(M.value)}return[C,{[Symbol.iterator](){return N}}]}k.consume=o;async function d(a){const L=[];for await(const C of a)L.push(C);return Promise.resolve(L)}k.asyncToArray=d})(i||(t.Iterable=i={}))}),define(me[54],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$yr=t.$xr=t.$wr=t.$vr=t.$ur=t.ScanCode=t.KeyCode=void 0,t.$zr=f;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(k||(t.ScanCode=k={}));class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(n,r){this._keyCodeToStr[n]=r,this._strToKeyCode[r.toLowerCase()]=n}keyCodeToStr(n){return this._keyCodeToStr[n]}strToKeyCode(n){return this._strToKeyCode[n.toLowerCase()]||0}}const W=new P,S=new P,A=new P;t.$ur=new Array(230),t.$vr={};const g=[],b=Object.create(null),p=Object.create(null);t.$wr={lowerCaseToEnum:e=>p[e]||0,toEnum:e=>b[e]||0,toString:e=>g[e]||"None"},t.$xr=[],t.$yr=[];for(let e=0;e<=193;e++)t.$xr[e]=-1;for(let e=0;e<=132;e++)t.$yr[e]=-1;(function(){const e="",n=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],r=[],h=[];for(const m of n){const[y,o,d,a,L,C,N,I,M]=m;if(h[o]||(h[o]=!0,g[o]=d,b[d]=o,p[d.toLowerCase()]=o,y&&(t.$xr[o]=a,a!==0&&a!==3&&a!==5&&a!==4&&a!==6&&a!==57&&(t.$yr[a]=o))),!r[a]){if(r[a]=!0,!L)throw new Error(`String representation missing for key code ${a} around scan code ${d}`);W.define(a,L),S.define(a,I||L),A.define(a,M||I||L)}C&&(t.$ur[C]=a),N&&(t.$vr[N]=a)}t.$yr[3]=46})();var O;(function(e){function n(d){return W.keyCodeToStr(d)}e.toString=n;function r(d){return W.strToKeyCode(d)}e.fromString=r;function h(d){return S.keyCodeToStr(d)}e.toUserSettingsUS=h;function m(d){return A.keyCodeToStr(d)}e.toUserSettingsGeneral=m;function y(d){return S.strToKeyCode(d)||A.strToKeyCode(d)}e.fromUserSettings=y;function o(d){if(d>=98&&d<=113)return null;switch(d){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(d)}e.toElectronAccelerator=o})(O||(t.KeyCodeUtils=O={}));var c;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(c||(t.KeyMod=c={}));function f(e,n){const r=(n&65535)<<16>>>0;return(e|r)>>>0}}),define(me[87],be([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gr=t.$Fr=t.$Er=t.$Dr=t.$Cr=void 0,t.$Ar=P,t.$Br=W;var k;(function(O){O[O.CtrlCmd=2048]="CtrlCmd",O[O.Shift=1024]="Shift",O[O.Alt=512]="Alt",O[O.WinCtrl=256]="WinCtrl",O[O.KeyCode=255]="KeyCode"})(k||(k={}));function P(O,c){if(typeof O=="number"){if(O===0)return null;const f=(O&65535)>>>0,e=(O&4294901760)>>>16;return e!==0?new g([W(f,c),W(e,c)]):new g([W(f,c)])}else{const f=[];for(let e=0;e<O.length;e++)f.push(W(O[e],c));return new g(f)}}function W(O,c){const f=!!(O&2048),e=!!(O&256),n=c===2?e:f,r=!!(O&1024),h=!!(O&512),m=c===2?f:e,y=O&255;return new S(n,r,h,m,y)}class S{constructor(c,f,e,n,r){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.keyCode=r}equals(c){return c instanceof S&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`K${c}${f}${e}${n}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Cr=S;class A{constructor(c,f,e,n,r){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.scanCode=r}equals(c){return c instanceof A&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.scanCode===c.scanCode}getHashCode(){const c=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`S${c}${f}${e}${n}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Dr=A;class g{constructor(c){if(c.length===0)throw(0,i.$7)("chords");this.chords=c}getHashCode(){let c="";for(let f=0,e=this.chords.length;f<e;f++)f!==0&&(c+=";"),c+=this.chords[f].getHashCode();return c}equals(c){if(c===null||this.chords.length!==c.chords.length)return!1;for(let f=0;f<this.chords.length;f++)if(!this.chords[f].equals(c.chords[f]))return!1;return!0}}t.$Er=g;class b{constructor(c,f,e,n,r,h){this.ctrlKey=c,this.shiftKey=f,this.altKey=e,this.metaKey=n,this.keyLabel=r,this.keyAriaLabel=h}}t.$Fr=b;class p{}t.$Gr=p}),define(me[23],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),define(me[14],be([1,0,23]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zT=A,t.$AT=g,t.$BT=b;let P=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const W=new i.$V(()=>P("mouse",!1)),S=new i.$V(()=>P("element",!1));function A(p){P=p}function g(p){return p==="element"?S.value:W.value}function b(){return P("element",!0)}}),define(me[55],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(W){this.element=W,this.next=i.Undefined,this.prev=i.Undefined}}class k{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let W=this.a;for(;W!==i.Undefined;){const S=W.next;W.prev=i.Undefined,W.next=i.Undefined,W=S}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(W){return this.d(W,!1)}push(W){return this.d(W,!0)}d(W,S){const A=new i(W);if(this.a===i.Undefined)this.a=A,this.b=A;else if(S){const b=this.b;this.b=A,A.prev=b,b.next=A}else{const b=this.a;this.a=A,A.next=b,b.prev=A}this.c+=1;let g=!1;return()=>{g||(g=!0,this.e(A))}}shift(){if(this.a!==i.Undefined){const W=this.a.element;return this.e(this.a),W}}pop(){if(this.b!==i.Undefined){const W=this.b.element;return this.e(this.b),W}}e(W){if(W.prev!==i.Undefined&&W.next!==i.Undefined){const S=W.prev;S.next=W.next,W.next.prev=S}else W.prev===i.Undefined&&W.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):W.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):W.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let W=this.a;for(;W!==i.Undefined;)yield W.element,W=W.next}}t.$5c=k}),define(me[39],be([1,0]),function(se,t){"use strict";var i,k,P;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=W,t.$zc=S,t.$Ac=A,t.$Ic=m;function W(y,o,d){let a=y.get(o);return a===void 0&&(a=d,y.set(o,a)),a}function S(y){const o=[];return y.forEach((d,a)=>{o.push(`${a} => ${d}`)}),`Map(${y.size}) {${o.join(", ")}}`}function A(y){const o=[];return y.forEach(d=>{o.push(d)}),`Set(${y.size}) {${o.join(", ")}}`}class g{constructor(o,d){this.uri=o,this.value=d}}function b(y){return Array.isArray(y)}class p{static{this.c=o=>o.toString()}constructor(o,d){if(this[i]="ResourceMap",o instanceof p)this.d=new Map(o.d),this.e=d??p.c;else if(b(o)){this.d=new Map,this.e=d??p.c;for(const[a,L]of o)this.set(a,L)}else this.d=new Map,this.e=o??p.c}set(o,d){return this.d.set(this.e(o),new g(o,d)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,d){typeof d<"u"&&(o=o.bind(d));for(const[a,L]of this.d)o(L.value,L.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}t.$Bc=p;class O{constructor(o,d){this[k]="ResourceSet",!o||typeof o=="function"?this.c=new p(o):(this.c=new p(d),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,d){this.c.forEach((a,L)=>o.call(d,L,L,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=O;var c;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(c||(t.Touch=c={}));class f{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,d=0){const a=this.c.get(o);if(a)return d!==0&&this.l(a,d),a.value}set(o,d,a=0){let L=this.c.get(o);if(L)L.value=d,a!==0&&this.l(L,a);else{switch(L={key:o,value:d,next:void 0,previous:void 0},a){case 0:this.j(L);break;case 1:this.i(L);break;case 2:this.j(L);break;default:this.j(L);break}this.c.set(o,L),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const d=this.c.get(o);if(d)return this.c.delete(o),this.k(d),this.f--,d.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.k(o),this.f--,o.value}forEach(o,d){const a=this.g;let L=this.d;for(;L;){if(d?o.bind(d)(L.value,L.key,this):o(L.value,L.key,this),this.g!==a)throw new Error("LinkedMap got modified during iteration.");L=L.next}}keys(){const o=this,d=this.g;let a=this.d;const L={[Symbol.iterator](){return L},next(){if(o.g!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const C={value:a.key,done:!1};return a=a.next,C}else return{value:void 0,done:!0}}};return L}values(){const o=this,d=this.g;let a=this.d;const L={[Symbol.iterator](){return L},next(){if(o.g!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const C={value:a.value,done:!1};return a=a.next,C}else return{value:void 0,done:!0}}};return L}entries(){const o=this,d=this.g;let a=this.d;const L={[Symbol.iterator](){return L},next(){if(o.g!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const C={value:[a.key,a.value],done:!1};return a=a.next,C}else return{value:void 0,done:!0}}};return L}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let d=this.d,a=this.size;for(;d&&a>o;)this.c.delete(d.key),d=d.next,a--;this.d=d,this.f=a,d&&(d.previous=void 0),this.g++}i(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}j(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}k(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const d=o.next,a=o.previous;if(!d||!a)throw new Error("Invalid list");d.previous=a,a.next=d}o.next=void 0,o.previous=void 0,this.g++}l(o,d){if(!this.d||!this.e)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(o===this.d)return;const a=o.next,L=o.previous;o===this.e?(L.next=void 0,this.e=L):(a.previous=L,L.next=a),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(d===2){if(o===this.e)return;const a=o.next,L=o.previous;o===this.d?(a.previous=void 0,this.d=a):(a.previous=L,L.next=a),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((d,a)=>{o.push([a,d])}),o}fromJSON(o){this.clear();for(const[d,a]of o)this.set(d,a)}}t.$Dc=f;class e extends f{constructor(o,d=1){super(),this.m=o,this.n=Math.min(Math.max(0,d),1)}get limit(){return this.m}set limit(o){this.m=o,this.o()}get ratio(){return this.n}set ratio(o){this.n=Math.min(Math.max(0,o),1),this.o()}get(o,d=2){return super.get(o,d)}peek(o){return super.get(o,0)}set(o,d){return super.set(o,d,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Ec=e;class n{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let d=this.c.get(o)||0;return d===0?!1:(d--,d===0?this.c.delete(o):this.c.set(o,d),!0)}has(o){return this.c.has(o)}}t.$Fc=n;class r{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[d,a]of o)this.set(d,a)}clear(){this.c.clear(),this.d.clear()}set(o,d){this.c.set(o,d),this.d.set(d,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const d=this.c.get(o);return d===void 0?!1:(this.c.delete(o),this.d.delete(d),!0)}forEach(o,d){this.c.forEach((a,L)=>{o.call(d,a,L,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=r;class h{constructor(){this.c=new Map}add(o,d){let a=this.c.get(o);a||(a=new Set,this.c.set(o,a)),a.add(d)}delete(o,d){const a=this.c.get(o);a&&(a.delete(d),a.size===0&&this.c.delete(o))}forEach(o,d){const a=this.c.get(o);a&&a.forEach(d)}get(o){const d=this.c.get(o);return d||new Set}}t.$Hc=h;function m(y,o){if(y===o)return!0;if(y.size!==o.size)return!1;for(const[d,a]of y)if(!o.has(d)||o.get(d)!==a)return!1;for(const[d]of o)if(!y.has(d))return!1;return!0}}),define(me[2],be([1,0,8,83,39,53,32]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=p,t.$Lc=O,t.$Mc=c,t.$Nc=n,t.$Oc=r,t.$Pc=h,t.$Qc=m,t.$Rc=y,t.$Sc=o,t.$3c=q;const A=!1;let g=null;class b{constructor(){this.b=new Map}static{this.a=0}c(B){let Y=this.b.get(B);return Y||(Y={parent:null,source:null,isSingleton:!1,value:B,idx:b.a++},this.b.set(B,Y)),Y}trackDisposable(B){const Y=this.c(B);Y.source||(Y.source=new Error().stack)}setParent(B,Y){const K=this.c(B);K.parent=Y}markAsDisposed(B){this.b.delete(B)}markAsSingleton(B){this.c(B).isSingleton=!0}f(B,Y){const K=Y.get(B);if(K)return K;const ae=B.parent?this.f(this.c(B.parent),Y):B;return Y.set(B,ae),ae}getTrackedDisposables(){const B=new Map;return[...this.b.entries()].filter(([,K])=>K.source!==null&&!this.f(K,B).isSingleton).flatMap(([K])=>K)}computeLeakingDisposables(B=10,Y){let K;if(Y)K=Y;else{const De=new Map,Ee=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,De).isSingleton);if(Ee.length===0)return;const Ie=new Set(Ee.map(le=>le.value));if(K=Ee.filter(le=>!(le.parent&&Ie.has(le.parent))),K.length===0)throw new Error("There are cyclic diposable chains!")}if(!K)return;function ae(De){function Ee(le,_){for(;le.length>0&&_.some(ue=>typeof ue=="string"?ue===le[0]:le[0].match(ue));)le.shift()}const Ie=De.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Ee(Ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Ie.reverse()}const ie=new P.$Hc;for(const De of K){const Ee=ae(De);for(let Ie=0;Ie<=Ee.length;Ie++)ie.add(Ee.slice(0,Ie).join(`
`),De)}K.sort((0,i.$7b)(De=>De.idx,i.$9b));let ee="",ce=0;for(const De of K.slice(0,B)){ce++;const Ee=ae(De),Ie=[];for(let le=0;le<Ee.length;le++){let _=Ee[le];_=`(shared with ${ie.get(Ee.slice(0,le+1).join(`
`)).size}/${K.length} leaks) at ${_}`;const re=ie.get(Ee.slice(0,le).join(`
`)),ye=(0,k.$K)([...re].map(V=>ae(V)[le]),V=>V);delete ye[Ee[le]];for(const[V,Q]of Object.entries(ye))Ie.unshift(`    - stacktraces of ${Q.length} other leaks continue with ${V}`);Ie.unshift(_)}ee+=`


==================== Leaking disposable ${ce}/${K.length}: ${De.value.constructor.name} ====================
${Ie.join(`
`)}
============================================================

`}return K.length>B&&(ee+=`


... and ${K.length-B} more leaking disposables

`),{leaks:K,details:ee}}}t.$Jc=b;function p(x){g=x}if(A){const x="__is_disposable_tracked__";p(new class{trackDisposable(B){const Y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{B[x]||console.log(Y)},3e3)}setParent(B,Y){if(B&&B!==a.None)try{B[x]=!0}catch{}}markAsDisposed(B){if(B&&B!==a.None)try{B[x]=!0}catch{}}markAsSingleton(B){}})}function O(x){return g?.trackDisposable(x),x}function c(x){g?.markAsDisposed(x)}function f(x,B){g?.setParent(x,B)}function e(x,B){if(g)for(const Y of x)g.setParent(Y,B)}function n(x){return g?.markAsSingleton(x),x}function r(x){return typeof x=="object"&&x!==null&&typeof x.dispose=="function"&&x.dispose.length===0}function h(x){if(S.Iterable.is(x)){const B=[];for(const Y of x)if(Y)try{Y.dispose()}catch(K){B.push(K)}if(B.length===1)throw B[0];if(B.length>1)throw new AggregateError(B,"Encountered errors while disposing of store");return Array.isArray(x)?[]:x}else if(x)return x.dispose(),x}function m(x){for(const B of x)r(B)&&B.dispose();return[]}function y(...x){const B=o(()=>h(x));return e(x,B),B}function o(x){const B=O({dispose:(0,W.$db)(()=>{c(B),x()})});return B}class d{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,O(this)}dispose(){this.g||(c(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(B){if(!B)return B;if(B===this)throw new Error("Cannot register a disposable on itself!");return f(B,this),this.g?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(B),B}delete(B){if(B){if(B===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(B),B.dispose()}}deleteAndLeak(B){B&&this.f.has(B)&&(this.f.delete(B),f(B,null))}}t.$Tc=d;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new d,O(this),f(this.q,this)}dispose(){c(this),this.q.dispose()}B(B){if(B===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(B)}}t.$Uc=a;class L{constructor(){this.b=!1,O(this)}get value(){return this.b?void 0:this.a}set value(B){this.b||B===this.a||(this.a?.dispose(),B&&f(B,this),this.a=B)}clear(){this.value=void 0}dispose(){this.b=!0,c(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const B=this.a;return this.a=void 0,B&&f(B,null),B}}t.$Vc=L;class C{constructor(B){this.a=new L,this.b=!1,this.a.value=B}get value(){return this.a.value}set value(B){this.b||B===this.a.value||(this.a.value=B)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=C;class N{constructor(B){this.b=B,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=N;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,O(this)}set(B){let Y=B;return this.unset=()=>Y=void 0,this.isset=()=>Y!==void 0,this.dispose=()=>{Y&&(Y(),Y=void 0,c(this))},this}}t.$Yc=I;class M{constructor(){this.a=new Map}acquire(B,...Y){let K=this.a.get(B);K||(K={counter:0,object:this.b(B,...Y)},this.a.set(B,K));const{object:ae}=K,ie=(0,W.$db)(()=>{--K.counter===0&&(this.c(B,K.object),this.a.delete(B))});return K.counter++,{object:ae,dispose:ie}}}t.$Zc=M;class E{constructor(B){this.a=B}async acquire(B,...Y){const K=this.a.acquire(B,...Y);try{return{object:await K.object,dispose:()=>K.dispose()}}catch(ae){throw K.dispose(),ae}}}t.$1c=E;class z{constructor(B){this.object=B}dispose(){}}t.$2c=z;function q(x){const B=new d;try{x(B)}finally{B.dispose()}}class F{constructor(){this.a=new Map,this.b=!1,O(this)}dispose(){c(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(B){return this.a.has(B)}get size(){return this.a.size}get(B){return this.a.get(B)}set(B,Y,K=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),K||this.a.get(B)?.dispose(),this.a.set(B,Y)}deleteAndDispose(B){this.a.get(B)?.dispose(),this.a.delete(B)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=F}),function(se,t){typeof define=="function"&&define.amd?define(me[88],be([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(se=typeof globalThis<"u"?globalThis:se||self,t(se.marked={}))}(this,function(se){"use strict";function t(H,u){for(var v=0;v<u.length;v++){var l=u[v];l.enumerable=l.enumerable||!1,l.configurable=!0,"value"in l&&(l.writable=!0),Object.defineProperty(H,l.key,l)}}function i(H,u,v){return u&&t(H.prototype,u),v&&t(H,v),Object.defineProperty(H,"prototype",{writable:!1}),H}function k(H,u){if(H){if(typeof H=="string")return P(H,u);var v=Object.prototype.toString.call(H).slice(8,-1);if(v==="Object"&&H.constructor&&(v=H.constructor.name),v==="Map"||v==="Set")return Array.from(H);if(v==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(v))return P(H,u)}}function P(H,u){(u==null||u>H.length)&&(u=H.length);for(var v=0,l=new Array(u);v<u;v++)l[v]=H[v];return l}function W(H,u){var v=typeof Symbol<"u"&&H[Symbol.iterator]||H["@@iterator"];if(v)return(v=v.call(H)).next.bind(v);if(Array.isArray(H)||(v=k(H))||u&&H&&typeof H.length=="number"){v&&(H=v);var l=0;return function(){return l>=H.length?{done:!0}:{done:!1,value:H[l++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=S();function A(H){se.defaults=H}var g=/[&<>"']/,b=/[&<>"']/g,p=/[<>"']|&(?!#?\w+;)/,O=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(u){return c[u]};function e(H,u){if(u){if(g.test(H))return H.replace(b,f)}else if(p.test(H))return H.replace(O,f);return H}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(H){return H.replace(n,function(u,v){return v=v.toLowerCase(),v==="colon"?":":v.charAt(0)==="#"?v.charAt(1)==="x"?String.fromCharCode(parseInt(v.substring(2),16)):String.fromCharCode(+v.substring(1)):""})}var h=/(^|[^\[])\^/g;function m(H,u){H=typeof H=="string"?H:H.source,u=u||"";var v={replace:function(w,T){return T=T.source||T,T=T.replace(h,"$1"),H=H.replace(w,T),v},getRegex:function(){return new RegExp(H,u)}};return v}var y=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(H,u,v){if(H){var l;try{l=decodeURIComponent(r(v)).replace(y,"").toLowerCase()}catch{return null}if(l.indexOf("javascript:")===0||l.indexOf("vbscript:")===0||l.indexOf("data:")===0)return null}u&&!o.test(v)&&(v=I(u,v));try{v=encodeURI(v).replace(/%25/g,"%")}catch{return null}return v}var a={},L=/^[^:]+:\/*[^/]*$/,C=/^([^:]+:)[\s\S]*$/,N=/^([^:]+:\/*[^/]*)[\s\S]*$/;function I(H,u){a[" "+H]||(L.test(H)?a[" "+H]=H+"/":a[" "+H]=q(H,"/",!0)),H=a[" "+H];var v=H.indexOf(":")===-1;return u.substring(0,2)==="//"?v?u:H.replace(C,"$1")+u:u.charAt(0)==="/"?v?u:H.replace(N,"$1")+u:H+u}var M={exec:function(){}};function E(H){for(var u=1,v,l;u<arguments.length;u++){v=arguments[u];for(l in v)Object.prototype.hasOwnProperty.call(v,l)&&(H[l]=v[l])}return H}function z(H,u){var v=H.replace(/\|/g,function(T,s,D){for(var $=!1,R=s;--R>=0&&D[R]==="\\";)$=!$;return $?"|":" |"}),l=v.split(/ \|/),w=0;if(l[0].trim()||l.shift(),l.length>0&&!l[l.length-1].trim()&&l.pop(),l.length>u)l.splice(u);else for(;l.length<u;)l.push("");for(;w<l.length;w++)l[w]=l[w].trim().replace(/\\\|/g,"|");return l}function q(H,u,v){var l=H.length;if(l===0)return"";for(var w=0;w<l;){var T=H.charAt(l-w-1);if(T===u&&!v)w++;else if(T!==u&&v)w++;else break}return H.slice(0,l-w)}function F(H,u){if(H.indexOf(u[1])===-1)return-1;for(var v=H.length,l=0,w=0;w<v;w++)if(H[w]==="\\")w++;else if(H[w]===u[0])l++;else if(H[w]===u[1]&&(l--,l<0))return w;return-1}function x(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(H,u){if(u<1)return"";for(var v="";u>1;)u&1&&(v+=H),u>>=1,H+=H;return v+H}function Y(H,u,v,l){var w=u.href,T=u.title?e(u.title):null,s=H[1].replace(/\\([\[\]])/g,"$1");if(H[0].charAt(0)!=="!"){l.state.inLink=!0;var D={type:"link",raw:v,href:w,title:T,text:s,tokens:l.inlineTokens(s)};return l.state.inLink=!1,D}return{type:"image",raw:v,href:w,title:T,text:e(s)}}function K(H,u){var v=H.match(/^(\s+)(?:```)/);if(v===null)return u;var l=v[1];return u.split(`
`).map(function(w){var T=w.match(/^\s+/);if(T===null)return w;var s=T[0];return s.length>=l.length?w.slice(l.length):w}).join(`
`)}var ae=function(){function H(v){this.options=v||se.defaults}var u=H.prototype;return u.space=function(l){var w=this.rules.block.newline.exec(l);if(w&&w[0].length>0)return{type:"space",raw:w[0]}},u.code=function(l){var w=this.rules.block.code.exec(l);if(w){var T=w[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:w[0],codeBlockStyle:"indented",text:this.options.pedantic?T:q(T,`
`)}}},u.fences=function(l){var w=this.rules.block.fences.exec(l);if(w){var T=w[0],s=K(T,w[3]||"");return{type:"code",raw:T,lang:w[2]?w[2].trim():w[2],text:s}}},u.heading=function(l){var w=this.rules.block.heading.exec(l);if(w){var T=w[2].trim();if(/#$/.test(T)){var s=q(T,"#");(this.options.pedantic||!s||/ $/.test(s))&&(T=s.trim())}return{type:"heading",raw:w[0],depth:w[1].length,text:T,tokens:this.lexer.inline(T)}}},u.hr=function(l){var w=this.rules.block.hr.exec(l);if(w)return{type:"hr",raw:w[0]}},u.blockquote=function(l){var w=this.rules.block.blockquote.exec(l);if(w){var T=w[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:w[0],tokens:this.lexer.blockTokens(T,[]),text:T}}},u.list=function(l){var w=this.rules.block.list.exec(l);if(w){var T,s,D,$,R,j,U,J,oe,pe,fe,Re,ke=w[1].trim(),Oe=ke.length>1,Se={type:"list",raw:"",ordered:Oe,start:Oe?+ke.slice(0,-1):"",loose:!1,items:[]};ke=Oe?"\\d{1,9}\\"+ke.slice(-1):"\\"+ke,this.options.pedantic&&(ke=Oe?ke:"[*+-]");for(var Fe=new RegExp("^( {0,3}"+ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");l&&(Re=!1,!(!(w=Fe.exec(l))||this.rules.block.hr.test(l)));){if(T=w[0],l=l.substring(T.length),J=w[2].split(`
`,1)[0],oe=l.split(`
`,1)[0],this.options.pedantic?($=2,fe=J.trimLeft()):($=w[2].search(/[^ ]/),$=$>4?1:$,fe=J.slice($),$+=w[1].length),j=!1,!J&&/^ *$/.test(oe)&&(T+=oe+`
`,l=l.substring(oe.length+1),Re=!0),!Re)for(var We=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Xe=new RegExp("^ {0,"+Math.min(3,$-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ue=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:```|~~~)"),_e=new RegExp("^ {0,"+Math.min(3,$-1)+"}#");l&&(pe=l.split(`
`,1)[0],J=pe,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ue.test(J)||_e.test(J)||We.test(J)||Xe.test(l)));){if(J.search(/[^ ]/)>=$||!J.trim())fe+=`
`+J.slice($);else if(!j)fe+=`
`+J;else break;!j&&!J.trim()&&(j=!0),T+=pe+`
`,l=l.substring(pe.length+1)}Se.loose||(U?Se.loose=!0:/\n *\n *$/.test(T)&&(U=!0)),this.options.gfm&&(s=/^\[[ xX]\] /.exec(fe),s&&(D=s[0]!=="[ ] ",fe=fe.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:T,task:!!s,checked:D,loose:!1,text:fe}),Se.raw+=T}Se.items[Se.items.length-1].raw=T.trimRight(),Se.items[Se.items.length-1].text=fe.trimRight(),Se.raw=Se.raw.trimRight();var Z=Se.items.length;for(R=0;R<Z;R++){this.lexer.state.top=!1,Se.items[R].tokens=this.lexer.blockTokens(Se.items[R].text,[]);var ne=Se.items[R].tokens.filter(function(ve){return ve.type==="space"}),$e=ne.every(function(ve){for(var Ne=ve.raw.split(""),ze=0,Ve=W(Ne),et;!(et=Ve()).done;){var it=et.value;if(it===`
`&&(ze+=1),ze>1)return!0}return!1});!Se.loose&&ne.length&&$e&&(Se.loose=!0,Se.items[R].loose=!0)}return Se}},u.html=function(l){var w=this.rules.block.html.exec(l);if(w){var T={type:"html",raw:w[0],pre:!this.options.sanitizer&&(w[1]==="pre"||w[1]==="script"||w[1]==="style"),text:w[0]};if(this.options.sanitize){var s=this.options.sanitizer?this.options.sanitizer(w[0]):e(w[0]);T.type="paragraph",T.text=s,T.tokens=this.lexer.inline(s)}return T}},u.def=function(l){var w=this.rules.block.def.exec(l);if(w){w[3]&&(w[3]=w[3].substring(1,w[3].length-1));var T=w[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:T,raw:w[0],href:w[2],title:w[3]}}},u.table=function(l){var w=this.rules.block.table.exec(l);if(w){var T={type:"table",header:z(w[1]).map(function(U){return{text:U}}),align:w[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:w[3]&&w[3].trim()?w[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(T.header.length===T.align.length){T.raw=w[0];var s=T.align.length,D,$,R,j;for(D=0;D<s;D++)/^ *-+: *$/.test(T.align[D])?T.align[D]="right":/^ *:-+: *$/.test(T.align[D])?T.align[D]="center":/^ *:-+ *$/.test(T.align[D])?T.align[D]="left":T.align[D]=null;for(s=T.rows.length,D=0;D<s;D++)T.rows[D]=z(T.rows[D],T.header.length).map(function(U){return{text:U}});for(s=T.header.length,$=0;$<s;$++)T.header[$].tokens=this.lexer.inline(T.header[$].text);for(s=T.rows.length,$=0;$<s;$++)for(j=T.rows[$],R=0;R<j.length;R++)j[R].tokens=this.lexer.inline(j[R].text);return T}}},u.lheading=function(l){var w=this.rules.block.lheading.exec(l);if(w)return{type:"heading",raw:w[0],depth:w[2].charAt(0)==="="?1:2,text:w[1],tokens:this.lexer.inline(w[1])}},u.paragraph=function(l){var w=this.rules.block.paragraph.exec(l);if(w){var T=w[1].charAt(w[1].length-1)===`
`?w[1].slice(0,-1):w[1];return{type:"paragraph",raw:w[0],text:T,tokens:this.lexer.inline(T)}}},u.text=function(l){var w=this.rules.block.text.exec(l);if(w)return{type:"text",raw:w[0],text:w[0],tokens:this.lexer.inline(w[0])}},u.escape=function(l){var w=this.rules.inline.escape.exec(l);if(w)return{type:"escape",raw:w[0],text:e(w[1])}},u.tag=function(l){var w=this.rules.inline.tag.exec(l);if(w)return!this.lexer.state.inLink&&/^<a /i.test(w[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(w[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(w[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(w[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:w[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(w[0]):e(w[0]):w[0]}},u.link=function(l){var w=this.rules.inline.link.exec(l);if(w){var T=w[2].trim();if(!this.options.pedantic&&/^</.test(T)){if(!/>$/.test(T))return;var s=q(T.slice(0,-1),"\\");if((T.length-s.length)%2===0)return}else{var D=F(w[2],"()");if(D>-1){var $=w[0].indexOf("!")===0?5:4,R=$+w[1].length+D;w[2]=w[2].substring(0,D),w[0]=w[0].substring(0,R).trim(),w[3]=""}}var j=w[2],U="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);J&&(j=J[1],U=J[3])}else U=w[3]?w[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(T)?j=j.slice(1):j=j.slice(1,-1)),Y(w,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:U&&U.replace(this.rules.inline._escapes,"$1")},w[0],this.lexer)}},u.reflink=function(l,w){var T;if((T=this.rules.inline.reflink.exec(l))||(T=this.rules.inline.nolink.exec(l))){var s=(T[2]||T[1]).replace(/\s+/g," ");if(s=w[s.toLowerCase()],!s||!s.href){var D=T[0].charAt(0);return{type:"text",raw:D,text:D}}return Y(T,s,T[0],this.lexer)}},u.emStrong=function(l,w,T){T===void 0&&(T="");var s=this.rules.inline.emStrong.lDelim.exec(l);if(s&&!(s[3]&&T.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var D=s[1]||s[2]||"";if(!D||D&&(T===""||this.rules.inline.punctuation.exec(T))){var $=s[0].length-1,R,j,U=$,J=0,oe=s[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,w=w.slice(-1*l.length+$);(s=oe.exec(w))!=null;)if(R=s[1]||s[2]||s[3]||s[4]||s[5]||s[6],!!R){if(j=R.length,s[3]||s[4]){U+=j;continue}else if((s[5]||s[6])&&$%3&&!(($+j)%3)){J+=j;continue}if(U-=j,!(U>0)){if(j=Math.min(j,j+U+J),Math.min($,j)%2){var pe=l.slice(1,$+s.index+j);return{type:"em",raw:l.slice(0,$+s.index+j+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}var fe=l.slice(2,$+s.index+j-1);return{type:"strong",raw:l.slice(0,$+s.index+j+1),text:fe,tokens:this.lexer.inlineTokens(fe)}}}}}},u.codespan=function(l){var w=this.rules.inline.code.exec(l);if(w){var T=w[2].replace(/\n/g," "),s=/[^ ]/.test(T),D=/^ /.test(T)&&/ $/.test(T);return s&&D&&(T=T.substring(1,T.length-1)),T=e(T,!0),{type:"codespan",raw:w[0],text:T}}},u.br=function(l){var w=this.rules.inline.br.exec(l);if(w)return{type:"br",raw:w[0]}},u.del=function(l){var w=this.rules.inline.del.exec(l);if(w)return{type:"del",raw:w[0],text:w[2],tokens:this.lexer.inlineTokens(w[2])}},u.autolink=function(l,w){var T=this.rules.inline.autolink.exec(l);if(T){var s,D;return T[2]==="@"?(s=e(this.options.mangle?w(T[1]):T[1]),D="mailto:"+s):(s=e(T[1]),D=s),{type:"link",raw:T[0],text:s,href:D,tokens:[{type:"text",raw:s,text:s}]}}},u.url=function(l,w){var T;if(T=this.rules.inline.url.exec(l)){var s,D;if(T[2]==="@")s=e(this.options.mangle?w(T[0]):T[0]),D="mailto:"+s;else{var $;do $=T[0],T[0]=this.rules.inline._backpedal.exec(T[0])[0];while($!==T[0]);s=e(T[0]),T[1]==="www."?D="http://"+s:D=s}return{type:"link",raw:T[0],text:s,href:D,tokens:[{type:"text",raw:s,text:s}]}}},u.inlineText=function(l,w){var T=this.rules.inline.text.exec(l);if(T){var s;return this.lexer.state.inRawBlock?s=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(T[0]):e(T[0]):T[0]:s=e(this.options.smartypants?w(T[0]):T[0]),{type:"text",raw:T[0],text:s}}},H}(),ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=m(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=m(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=m(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=m(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=m(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=m(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=E({},ie),ie.gfm=E({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=m(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.paragraph=m(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ie.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=E({},ie.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:m(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=m(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=m(ie._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=m(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=m(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=m(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=m(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=m(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=m(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=m(ee.reflink).replace("label",ee._label).replace("ref",ie._label).getRegex(),ee.nolink=m(ee.nolink).replace("ref",ie._label).getRegex(),ee.reflinkSearch=m(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=E({},ee),ee.pedantic=E({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=E({},ee.normal,{escape:m(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=m(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=E({},ee.gfm,{br:m(ee.br).replace("{2,}","*").getRegex(),text:m(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ce(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function De(H){var u="",v,l,w=H.length;for(v=0;v<w;v++)l=H.charCodeAt(v),Math.random()>.5&&(l="x"+l.toString(16)),u+="&#"+l+";";return u}var Ee=function(){function H(v){this.tokens=[],this.tokens.links=Object.create(null),this.options=v||se.defaults,this.options.tokenizer=this.options.tokenizer||new ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var l={block:ie.normal,inline:ee.normal};this.options.pedantic?(l.block=ie.pedantic,l.inline=ee.pedantic):this.options.gfm&&(l.block=ie.gfm,this.options.breaks?l.inline=ee.breaks:l.inline=ee.gfm),this.tokenizer.rules=l}H.lex=function(l,w){var T=new H(w);return T.lex(l)},H.lexInline=function(l,w){var T=new H(w);return T.inlineTokens(l)};var u=H.prototype;return u.lex=function(l){l=l.replace(/\r\n|\r/g,`
`),this.blockTokens(l,this.tokens);for(var w;w=this.inlineQueue.shift();)this.inlineTokens(w.src,w.tokens);return this.tokens},u.blockTokens=function(l,w){var T=this;w===void 0&&(w=[]),this.options.pedantic?l=l.replace(/\t/g,"    ").replace(/^ +$/gm,""):l=l.replace(/^( *)(\t+)/gm,function(U,J,oe){return J+"    ".repeat(oe.length)});for(var s,D,$,R;l;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(U){return(s=U.call({lexer:T},l,w))?(l=l.substring(s.raw.length),w.push(s),!0):!1}))){if(s=this.tokenizer.space(l)){l=l.substring(s.raw.length),s.raw.length===1&&w.length>0?w[w.length-1].raw+=`
`:w.push(s);continue}if(s=this.tokenizer.code(l)){l=l.substring(s.raw.length),D=w[w.length-1],D&&(D.type==="paragraph"||D.type==="text")?(D.raw+=`
`+s.raw,D.text+=`
`+s.text,this.inlineQueue[this.inlineQueue.length-1].src=D.text):w.push(s);continue}if(s=this.tokenizer.fences(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.heading(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.hr(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.blockquote(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.list(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.html(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.def(l)){l=l.substring(s.raw.length),D=w[w.length-1],D&&(D.type==="paragraph"||D.type==="text")?(D.raw+=`
`+s.raw,D.text+=`
`+s.raw,this.inlineQueue[this.inlineQueue.length-1].src=D.text):this.tokens.links[s.tag]||(this.tokens.links[s.tag]={href:s.href,title:s.title});continue}if(s=this.tokenizer.table(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.lheading(l)){l=l.substring(s.raw.length),w.push(s);continue}if($=l,this.options.extensions&&this.options.extensions.startBlock&&function(){var U=1/0,J=l.slice(1),oe=void 0;T.options.extensions.startBlock.forEach(function(pe){oe=pe.call({lexer:this},J),typeof oe=="number"&&oe>=0&&(U=Math.min(U,oe))}),U<1/0&&U>=0&&($=l.substring(0,U+1))}(),this.state.top&&(s=this.tokenizer.paragraph($))){D=w[w.length-1],R&&D.type==="paragraph"?(D.raw+=`
`+s.raw,D.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=D.text):w.push(s),R=$.length!==l.length,l=l.substring(s.raw.length);continue}if(s=this.tokenizer.text(l)){l=l.substring(s.raw.length),D=w[w.length-1],D&&D.type==="text"?(D.raw+=`
`+s.raw,D.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=D.text):w.push(s);continue}if(l){var j="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,w},u.inline=function(l,w){return w===void 0&&(w=[]),this.inlineQueue.push({src:l,tokens:w}),w},u.inlineTokens=function(l,w){var T=this;w===void 0&&(w=[]);var s,D,$,R=l,j,U,J;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(R))!=null;)oe.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(R=R.slice(0,j.index)+"["+B("a",j[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(R))!=null;)R=R.slice(0,j.index)+"["+B("a",j[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(R))!=null;)R=R.slice(0,j.index)+"++"+R.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;l;)if(U||(J=""),U=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(fe){return(s=fe.call({lexer:T},l,w))?(l=l.substring(s.raw.length),w.push(s),!0):!1}))){if(s=this.tokenizer.escape(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.tag(l)){l=l.substring(s.raw.length),D=w[w.length-1],D&&s.type==="text"&&D.type==="text"?(D.raw+=s.raw,D.text+=s.text):w.push(s);continue}if(s=this.tokenizer.link(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.reflink(l,this.tokens.links)){l=l.substring(s.raw.length),D=w[w.length-1],D&&s.type==="text"&&D.type==="text"?(D.raw+=s.raw,D.text+=s.text):w.push(s);continue}if(s=this.tokenizer.emStrong(l,R,J)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.codespan(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.br(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.del(l)){l=l.substring(s.raw.length),w.push(s);continue}if(s=this.tokenizer.autolink(l,De)){l=l.substring(s.raw.length),w.push(s);continue}if(!this.state.inLink&&(s=this.tokenizer.url(l,De))){l=l.substring(s.raw.length),w.push(s);continue}if($=l,this.options.extensions&&this.options.extensions.startInline&&function(){var fe=1/0,Re=l.slice(1),ke=void 0;T.options.extensions.startInline.forEach(function(Oe){ke=Oe.call({lexer:this},Re),typeof ke=="number"&&ke>=0&&(fe=Math.min(fe,ke))}),fe<1/0&&fe>=0&&($=l.substring(0,fe+1))}(),s=this.tokenizer.inlineText($,ce)){l=l.substring(s.raw.length),s.raw.slice(-1)!=="_"&&(J=s.raw.slice(-1)),U=!0,D=w[w.length-1],D&&D.type==="text"?(D.raw+=s.raw,D.text+=s.text):w.push(s);continue}if(l){var pe="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return w},i(H,null,[{key:"rules",get:function(){return{block:ie,inline:ee}}}]),H}(),Ie=function(){function H(v){this.options=v||se.defaults}var u=H.prototype;return u.code=function(l,w,T){var s=(w||"").match(/\S*/)[0];if(this.options.highlight){var D=this.options.highlight(l,s);D!=null&&D!==l&&(T=!0,l=D)}return l=l.replace(/\n$/,"")+`
`,s?'<pre><code class="'+this.options.langPrefix+e(s,!0)+'">'+(T?l:e(l,!0))+`</code></pre>
`:"<pre><code>"+(T?l:e(l,!0))+`</code></pre>
`},u.blockquote=function(l){return`<blockquote>
`+l+`</blockquote>
`},u.html=function(l){return l},u.heading=function(l,w,T,s){if(this.options.headerIds){var D=this.options.headerPrefix+s.slug(T);return"<h"+w+' id="'+D+'">'+l+"</h"+w+`>
`}return"<h"+w+">"+l+"</h"+w+`>
`},u.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},u.list=function(l,w,T){var s=w?"ol":"ul",D=w&&T!==1?' start="'+T+'"':"";return"<"+s+D+`>
`+l+"</"+s+`>
`},u.listitem=function(l){return"<li>"+l+`</li>
`},u.checkbox=function(l){return"<input "+(l?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},u.paragraph=function(l){return"<p>"+l+`</p>
`},u.table=function(l,w){return w&&(w="<tbody>"+w+"</tbody>"),`<table>
<thead>
`+l+`</thead>
`+w+`</table>
`},u.tablerow=function(l){return`<tr>
`+l+`</tr>
`},u.tablecell=function(l,w){var T=w.header?"th":"td",s=w.align?"<"+T+' align="'+w.align+'">':"<"+T+">";return s+l+("</"+T+`>
`)},u.strong=function(l){return"<strong>"+l+"</strong>"},u.em=function(l){return"<em>"+l+"</em>"},u.codespan=function(l){return"<code>"+l+"</code>"},u.br=function(){return this.options.xhtml?"<br/>":"<br>"},u.del=function(l){return"<del>"+l+"</del>"},u.link=function(l,w,T){if(l=d(this.options.sanitize,this.options.baseUrl,l),l===null)return T;var s='<a href="'+e(l)+'"';return w&&(s+=' title="'+w+'"'),s+=">"+T+"</a>",s},u.image=function(l,w,T){if(l=d(this.options.sanitize,this.options.baseUrl,l),l===null)return T;var s='<img src="'+l+'" alt="'+T+'"';return w&&(s+=' title="'+w+'"'),s+=this.options.xhtml?"/>":">",s},u.text=function(l){return l},H}(),le=function(){function H(){}var u=H.prototype;return u.strong=function(l){return l},u.em=function(l){return l},u.codespan=function(l){return l},u.del=function(l){return l},u.html=function(l){return l},u.text=function(l){return l},u.link=function(l,w,T){return""+T},u.image=function(l,w,T){return""+T},u.br=function(){return""},H}(),_=function(){function H(){this.seen={}}var u=H.prototype;return u.serialize=function(l){return l.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},u.getNextSafeSlug=function(l,w){var T=l,s=0;if(this.seen.hasOwnProperty(T)){s=this.seen[l];do s++,T=l+"-"+s;while(this.seen.hasOwnProperty(T))}return w||(this.seen[l]=s,this.seen[T]=0),T},u.slug=function(l,w){w===void 0&&(w={});var T=this.serialize(l);return this.getNextSafeSlug(T,w.dryrun)},H}(),ue=function(){function H(v){this.options=v||se.defaults,this.options.renderer=this.options.renderer||new Ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new _}H.parse=function(l,w){var T=new H(w);return T.parse(l)},H.parseInline=function(l,w){var T=new H(w);return T.parseInline(l)};var u=H.prototype;return u.parse=function(l,w){w===void 0&&(w=!0);var T="",s,D,$,R,j,U,J,oe,pe,fe,Re,ke,Oe,Se,Fe,We,Xe,Ue,_e,Z=l.length;for(s=0;s<Z;s++){if(fe=l[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(_e=this.options.extensions.renderers[fe.type].call({parser:this},fe),_e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(fe.type))){T+=_e||"";continue}switch(fe.type){case"space":continue;case"hr":{T+=this.renderer.hr();continue}case"heading":{T+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,r(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{T+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(oe="",J="",R=fe.header.length,D=0;D<R;D++)J+=this.renderer.tablecell(this.parseInline(fe.header[D].tokens),{header:!0,align:fe.align[D]});for(oe+=this.renderer.tablerow(J),pe="",R=fe.rows.length,D=0;D<R;D++){for(U=fe.rows[D],J="",j=U.length,$=0;$<j;$++)J+=this.renderer.tablecell(this.parseInline(U[$].tokens),{header:!1,align:fe.align[$]});pe+=this.renderer.tablerow(J)}T+=this.renderer.table(oe,pe);continue}case"blockquote":{pe=this.parse(fe.tokens),T+=this.renderer.blockquote(pe);continue}case"list":{for(Re=fe.ordered,ke=fe.start,Oe=fe.loose,R=fe.items.length,pe="",D=0;D<R;D++)Fe=fe.items[D],We=Fe.checked,Xe=Fe.task,Se="",Fe.task&&(Ue=this.renderer.checkbox(We),Oe?Fe.tokens.length>0&&Fe.tokens[0].type==="paragraph"?(Fe.tokens[0].text=Ue+" "+Fe.tokens[0].text,Fe.tokens[0].tokens&&Fe.tokens[0].tokens.length>0&&Fe.tokens[0].tokens[0].type==="text"&&(Fe.tokens[0].tokens[0].text=Ue+" "+Fe.tokens[0].tokens[0].text)):Fe.tokens.unshift({type:"text",text:Ue}):Se+=Ue),Se+=this.parse(Fe.tokens,Oe),pe+=this.renderer.listitem(Se,Xe,We);T+=this.renderer.list(pe,Re,ke);continue}case"html":{T+=this.renderer.html(fe.text);continue}case"paragraph":{T+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(pe=fe.tokens?this.parseInline(fe.tokens):fe.text;s+1<Z&&l[s+1].type==="text";)fe=l[++s],pe+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);T+=w?this.renderer.paragraph(pe):pe;continue}default:{var ne='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return T},u.parseInline=function(l,w){w=w||this.renderer;var T="",s,D,$,R=l.length;for(s=0;s<R;s++){if(D=l[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[D.type]&&($=this.options.extensions.renderers[D.type].call({parser:this},D),$!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(D.type))){T+=$||"";continue}switch(D.type){case"escape":{T+=w.text(D.text);break}case"html":{T+=w.html(D.text);break}case"link":{T+=w.link(D.href,D.title,this.parseInline(D.tokens,w));break}case"image":{T+=w.image(D.href,D.title,D.text);break}case"strong":{T+=w.strong(this.parseInline(D.tokens,w));break}case"em":{T+=w.em(this.parseInline(D.tokens,w));break}case"codespan":{T+=w.codespan(D.text);break}case"br":{T+=w.br();break}case"del":{T+=w.del(this.parseInline(D.tokens,w));break}case"text":{T+=w.text(D.text);break}default:{var j='Token with "'+D.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return T},H}();function re(H,u,v){if(typeof H>"u"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof u=="function"&&(v=u,u=null),u=E({},re.defaults,u||{}),x(u),v){var l=u.highlight,w;try{w=Ee.lex(H,u)}catch(R){return v(R)}var T=function(j){var U;if(!j)try{u.walkTokens&&re.walkTokens(w,u.walkTokens),U=ue.parse(w,u)}catch(J){j=J}return u.highlight=l,j?v(j):v(null,U)};if(!l||l.length<3||(delete u.highlight,!w.length))return T();var s=0;re.walkTokens(w,function(R){R.type==="code"&&(s++,setTimeout(function(){l(R.text,R.lang,function(j,U){if(j)return T(j);U!=null&&U!==R.text&&(R.text=U,R.escaped=!0),s--,s===0&&T()})},0))}),s===0&&T();return}function D(R){if(R.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(R.message+"",!0)+"</pre>";throw R}try{var $=Ee.lex(H,u);if(u.walkTokens){if(u.async)return Promise.all(re.walkTokens($,u.walkTokens)).then(function(){return ue.parse($,u)}).catch(D);re.walkTokens($,u.walkTokens)}return ue.parse($,u)}catch(R){D(R)}}re.options=re.setOptions=function(H){return E(re.defaults,H),A(re.defaults),re},re.getDefaults=S,re.defaults=se.defaults,re.use=function(){for(var H=arguments.length,u=new Array(H),v=0;v<H;v++)u[v]=arguments[v];var l=E.apply(void 0,[{}].concat(u)),w=re.defaults.extensions||{renderers:{},childTokens:{}},T;u.forEach(function(s){if(s.extensions&&(T=!0,s.extensions.forEach(function($){if(!$.name)throw new Error("extension name required");if($.renderer){var R=w.renderers?w.renderers[$.name]:null;R?w.renderers[$.name]=function(){for(var j=arguments.length,U=new Array(j),J=0;J<j;J++)U[J]=arguments[J];var oe=$.renderer.apply(this,U);return oe===!1&&(oe=R.apply(this,U)),oe}:w.renderers[$.name]=$.renderer}if($.tokenizer){if(!$.level||$.level!=="block"&&$.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");w[$.level]?w[$.level].unshift($.tokenizer):w[$.level]=[$.tokenizer],$.start&&($.level==="block"?w.startBlock?w.startBlock.push($.start):w.startBlock=[$.start]:$.level==="inline"&&(w.startInline?w.startInline.push($.start):w.startInline=[$.start]))}$.childTokens&&(w.childTokens[$.name]=$.childTokens)})),s.renderer&&function(){var $=re.defaults.renderer||new Ie,R=function(J){var oe=$[J];$[J]=function(){for(var pe=arguments.length,fe=new Array(pe),Re=0;Re<pe;Re++)fe[Re]=arguments[Re];var ke=s.renderer[J].apply($,fe);return ke===!1&&(ke=oe.apply($,fe)),ke}};for(var j in s.renderer)R(j);l.renderer=$}(),s.tokenizer&&function(){var $=re.defaults.tokenizer||new ae,R=function(J){var oe=$[J];$[J]=function(){for(var pe=arguments.length,fe=new Array(pe),Re=0;Re<pe;Re++)fe[Re]=arguments[Re];var ke=s.tokenizer[J].apply($,fe);return ke===!1&&(ke=oe.apply($,fe)),ke}};for(var j in s.tokenizer)R(j);l.tokenizer=$}(),s.walkTokens){var D=re.defaults.walkTokens;l.walkTokens=function($){var R=[];return R.push(s.walkTokens.call(this,$)),D&&(R=R.concat(D.call(this,$))),R}}T&&(l.extensions=w),re.setOptions(l)})},re.walkTokens=function(H,u){for(var v=[],l=function(){var D=T.value;switch(v=v.concat(u.call(re,D)),D.type){case"table":{for(var $=W(D.header),R;!(R=$()).done;){var j=R.value;v=v.concat(re.walkTokens(j.tokens,u))}for(var U=W(D.rows),J;!(J=U()).done;)for(var oe=J.value,pe=W(oe),fe;!(fe=pe()).done;){var Re=fe.value;v=v.concat(re.walkTokens(Re.tokens,u))}break}case"list":{v=v.concat(re.walkTokens(D.items,u));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[D.type]?re.defaults.extensions.childTokens[D.type].forEach(function(ke){v=v.concat(re.walkTokens(D[ke],u))}):D.tokens&&(v=v.concat(re.walkTokens(D.tokens,u)))}},w=W(H),T;!(T=w()).done;)l();return v},re.parseInline=function(H,u){if(typeof H>"u"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");u=E({},re.defaults,u||{}),x(u);try{var v=Ee.lexInline(H,u);return u.walkTokens&&re.walkTokens(v,u.walkTokens),ue.parseInline(v,u)}catch(l){if(l.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(l.message+"",!0)+"</pre>";throw l}},re.Parser=ue,re.parser=ue.parse,re.Renderer=Ie,re.TextRenderer=le,re.Lexer=Ee,re.lexer=Ee.lex,re.Tokenizer=ae,re.Slugger=_,re.parse=re;var ye=re.options,V=re.setOptions,Q=re.use,ge=re.walkTokens,we=re.parseInline,Le=re,Te=ue.parse,Me=Ee.lex;se.Lexer=Ee,se.Parser=ue,se.Renderer=Ie,se.Slugger=_,se.TextRenderer=le,se.Tokenizer=ae,se.getDefaults=S,se.lexer=Me,se.marked=re,se.options=ye,se.parse=Le,se.parseInline=we,se.parser=Te,se.setOptions=V,se.use=Q,se.walkTokens=ge,Object.defineProperty(se,"__esModule",{value:!0})}),define(me[89],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qk=i;function i(n){const r=W(n);if(r&&r.length>0)return new Uint32Array(r)}let k=0;const P=new Uint32Array(10);function W(n){if(k=0,S(n,O,4352),k>0||(S(n,c,4449),k>0)||(S(n,f,4520),k>0)||(S(n,e,12593),k))return P.subarray(0,k);if(n>=44032&&n<=55203){const r=n-44032,h=r%588,m=Math.floor(r/588),y=Math.floor(h/28),o=h%28-1;if(m<O.length?S(m,O,0):4352+m-12593<e.length&&S(4352+m,e,12593),y<c.length?S(y,c,0):4449+y-12593<e.length&&S(4449+y-12593,e,12593),o>=0&&(o<f.length?S(o,f,0):4520+o-12593<e.length&&S(4520+o-12593,e,12593)),k>0)return P.subarray(0,k)}}function S(n,r,h){n>=h&&n<h+r.length&&A(r[n-h])}function A(n){n!==0&&(P[k++]=n&255,n>>8&&(P[k++]=n>>8&255),n>>16&&(P[k++]=n>>16&255))}var g;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var b;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(b||(b={}));var p;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(p||(p={}));const O=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),c=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),f=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(me[90],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aV=void 0;class i{constructor(P,W=0,S=P.length,A=W-1){this.a=P,this.b=W,this.c=S,this.d=A}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$aV=i}),define(me[91],be([1,0,90]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cV=t.$bV=void 0;class k{constructor(S=[],A=10){this.h(S),this.b=A,this.d()}getHistory(){return this.j}add(S){this.a.delete(S),this.a.add(S),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(S){return this.a.has(S)}clear(){this.h([]),this.d()}d(){this.f();const S=this.j;this.c=new i.$aV(S,0,S.length,S.length)}f(){const S=this.j;S.length>this.b&&this.h(S.slice(S.length-this.b))}g(){const S=this.c.current();return S?this.j.indexOf(S):-1}h(S){this.a=new Set;for(const A of S)this.a.add(A)}get j(){const S=[];return this.a.forEach(A=>S.push(A)),S}}t.$bV=k;class P{get size(){return this.f}constructor(S,A=10){if(this.g=A,S.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:S[0],previous:void 0,next:void 0},this.a=new Set([S[0]]);for(let g=1;g<S.length;g++)this.add(S[g])}add(S){const A={value:S,previous:this.c,next:void 0};for(this.c.next=A,this.c=A,this.d=this.c,this.f++,this.a.has(S)?this.h(S):this.a.add(S);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(S){if(this.c.value===S)return S;const A=this.c.value;return this.a.delete(A),this.c.value=S,this.a.has(S)?this.h(S):this.a.add(S),A}prepend(S){if(this.f===this.g||this.a.has(S))return;const A={value:S,previous:void 0,next:this.b};this.b.previous=A,this.b=A,this.f++,this.a.add(S)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(S){return this.a.has(S)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let S=this.b;for(;S;)yield S.value,S=S.next}h(S){let A=this.b;for(;A!==this.c;)A.value===S&&(A===this.b?(this.b=this.b.next,this.b.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this.f--),A=A.next}}t.$cV=P}),define(me[40],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Am=t.$zm=t.$ym=void 0,t.$wm=i,t.rot=k;function i(A,g,b){return Math.min(Math.max(A,g),b)}function k(A,g){return(g+A%g)%g}class P{constructor(){this.a=0}getNext(){return this.a++}}t.$ym=P;class W{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$zm=W;class S{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const b=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Am=S}),define(me[26],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$c=void 0,t.$_c=W,t.$ad=c;class i{constructor(e,n,r){this.owner=e,this.debugNameSource=n,this.referenceFn=r}getDebugName(e){return W(e,this)}}t.$$c=i;const k=new Map,P=new WeakMap;function W(f,e){const n=P.get(f);if(n)return n;const r=S(f,e);if(r){let h=k.get(r)??0;h++,k.set(r,h);const m=h===1?r:`${r}#${h}`;return P.set(f,m),m}}function S(f,e){const n=P.get(f);if(n)return n;const r=e.owner?p(e.owner)+".":"";let h;const m=e.debugNameSource;if(m!==void 0)if(typeof m=="function"){if(h=m(),h!==void 0)return r+h}else return r+m;const y=e.referenceFn;if(y!==void 0&&(h=c(y),h!==void 0))return r+h;if(e.owner!==void 0){const o=A(e.owner,f);if(o!==void 0)return r+o}}function A(f,e){for(const n in f)if(f[n]===e)return n}const g=new Map,b=new WeakMap;function p(f){const e=b.get(f);if(e)return e;const n=O(f);let r=g.get(n)??0;r++,g.set(n,r);const h=r===1?n:`${n}#${r}`;return b.set(f,h),h}function O(f){const e=f.constructor;return e?e.name:"Object"}function c(f){const e=f.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(r?r[1]:void 0)?.trim()}}),define(me[27],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hd=void 0,t.$Fd=k,t.$Gd=P;let i;function k(n){i=n}function P(){return i}class W{constructor(){this.a=0,this.d=new WeakMap}b(r){return S([A(f("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[A(" "),b(p(r.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),b(p(r.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),b(p(r.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(r,h){console.log(...this.b([g("observable value changed"),b(r.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(r){if(r.size!==0)return b(" (changed deps: "+[...r].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(m,y)=>(this.d.get(r).add(m),h.apply(r,[m,y]))}handleDerivedRecomputed(r,h){const m=this.d.get(r);console.log(...this.b([g("derived recomputed"),b(r.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(m),{data:[{fn:r._computeFn}]}])),m.clear()}handleFromEventObservableTriggered(r,h){console.log(...this.b([g("observable from event triggered"),b(r.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(m,y)=>(this.d.get(r).add(m),h.apply(r,[m,y]))}handleAutorunTriggered(r){const h=this.d.get(r);console.log(...this.b([g("autorun"),b(r.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:r._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let h=r.getDebugName();h===void 0&&(h=""),console.log(...this.b([g("transaction"),b(h,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Hd=W;function S(n){const r=new Array,h=[];let m="";function y(d){if("length"in d)for(const a of d)a&&y(a);else"text"in d?(m+=`%c${d.text}`,r.push(d.style),d.data&&h.push(...d.data)):"data"in d&&h.push(...d.data)}y(n);const o=[m,...r];return o.push(...h),o}function A(n){return b(n,{color:"black"})}function g(n){return b(e(`${n}: `,10),{color:"black",bold:!0})}function b(n,r={color:"black"}){function h(y){return Object.entries(y).reduce((o,[d,a])=>`${o}${d}:${a};`,"")}const m={color:r.color};return r.strikeThrough&&(m["text-decoration"]="line-through"),r.bold&&(m["font-weight"]="bold"),{text:n,style:h(m)}}function p(n,r){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=r?`"${n}"`:`"${n.substr(0,r-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?O(n,r):c(n,r);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function O(n,r){let h="[ ",m=!0;for(const y of n){if(m||(h+=", "),h.length-5>r){h+="...";break}m=!1,h+=`${p(y,r-h.length)}`}return h+=" ]",h}function c(n,r){let h="{ ",m=!0;for(const[y,o]of Object.entries(n)){if(m||(h+=", "),h.length-5>r){h+="...";break}m=!1,h+=`${y}: ${p(o,r-h.length)}`}return h+=" }",h}function f(n,r){let h="";for(let m=1;m<=r;m++)h+=n;return h}function e(n,r){for(;n.length<r;)n+=" ";return n}}),define(me[41],be([1,0,37,2,26,27]),function(se,t,i,k,P,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nd=void 0,t.$hd=S,t.$id=A,t.$jd=g,t.$kd=b,t.$ld=p,t.$md=O;function S(e){return new f(new P.$$c(void 0,void 0,e),e,void 0,void 0)}function A(e,n){return new f(new P.$$c(e.owner,e.debugName,e.debugReferenceFn??n),n,void 0,void 0)}function g(e,n){return new f(new P.$$c(e.owner,e.debugName,e.debugReferenceFn??n),n,e.createEmptyChangeSummary,e.handleChange)}function b(e,n){const r=new k.$Tc,h=g({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(m,y)=>{r.clear(),n(m,y,r)});return(0,k.$Sc)(()=>{h.dispose(),r.dispose()})}function p(e){const n=new k.$Tc,r=A({owner:void 0,debugName:void 0,debugReferenceFn:e},h=>{n.clear(),e(h,n)});return(0,k.$Sc)(()=>{r.dispose(),n.dispose()})}function O(e,n){let r;return A({debugReferenceFn:n},h=>{const m=e.read(h),y=r;r=m,n({lastValue:y,newValue:m})})}var c;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(c||(c={}));class f{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(n,r,h,m){this.h=n,this._runFn=r,this.i=h,this.j=m,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,W.$Gd)()?.handleAutorunCreated(this),this.k(),(0,k.$Lc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,k.$Mc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const r=this.c;try{if(!r){(0,W.$Gd)()?.handleAutorunTriggered(this);const h=this.g;this.g=this.i?.(),this._runFn(this,h)}}finally{r||(0,W.$Gd)()?.handleAutorunFinished(this);for(const h of this.f)h.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,i.$fd)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,r){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:r,didChange:m=>m===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const r=n.get();return this.e.add(n),this.f.delete(n),r}}t.$nd=f,function(e){e.Observer=f}(S||(t.$hd=S={}))}),define(me[33],be([1,0,38,26,27]),function(se,t,i,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=t.$1d=t.$Xd=t.$Sd=t.$Rd=void 0,t.$Od=S,t.$Pd=g,t.$Qd=p,t.$Td=f,t.$Ud=n,t.$Vd=r,t.$Wd=h,t.$Yd=y,t.$Zd=o,t.$2d=a;let W;function S(C){W=C}let A;function g(C){A=C}let b;function p(C){b=C}class O{get TChange(){return null}reportChanges(){this.get()}read(N){return N?N.readObservable(this):this.get()}map(N,I){const M=I===void 0?void 0:N,E=I===void 0?N:I;return b({owner:M,debugName:()=>{const z=(0,k.$ad)(E);if(z!==void 0)return z;const F=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(F)return`${this.debugName}.${F[2]}`;if(!M)return`${this.debugName} (mapped)`},debugReferenceFn:E},z=>E(this.read(z),z))}recomputeInitiallyAndOnChange(N,I){return N.add(W(this,I)),this}keepObserved(N){return N.add(A(this)),this}get a(){return this.get()}}t.$Rd=O;class c extends O{constructor(){super(...arguments),this.b=new Set}addObserver(N){const I=this.b.size;this.b.add(N),I===0&&this.c()}removeObserver(N){this.b.delete(N)&&this.b.size===0&&this.f()}c(){}f(){}}t.$Sd=c;function f(C,N){const I=new m(C,N);try{C(I)}finally{I.finish()}}let e;function n(C){if(e)C(e);else{const N=new m(C,void 0);e=N;try{C(N)}finally{N.finish(),e=void 0}}}async function r(C,N){const I=new m(C,N);try{await C(I)}finally{I.finish()}}function h(C,N,I){C?N(C):f(N,I)}class m{constructor(N,I){this._fn=N,this.b=I,this.a=[],(0,P.$Gd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,k.$ad)(this._fn)}updateObserver(N,I){this.a.push({observer:N,observable:I}),N.beginUpdate(I)}finish(){const N=this.a;for(let I=0;I<N.length;I++){const{observer:M,observable:E}=N[I];M.endUpdate(E)}this.a=null,(0,P.$Gd)()?.handleEndTransaction()}}t.$Xd=m;function y(C,N){let I;return typeof C=="string"?I=new k.$$c(void 0,C,void 0):I=new k.$$c(C,void 0,void 0),new d(I,N,i.$6c)}function o(C,N){return new d(new k.$$c(C.owner,C.debugName,void 0),N,C.equalsFn??i.$6c)}class d extends c{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(N,I,M){super(),this.e=N,this.g=M,this.d=I}get(){return this.d}set(N,I,M){if(this.g(this.d,N))return;let E;I||(I=E=new m(()=>{},()=>`Setting ${this.debugName}`));try{const z=this.d;this.h(N),(0,P.$Gd)()?.handleObservableChanged(this,{oldValue:z,newValue:N,change:M,didChange:!0,hadValue:!0});for(const q of this.b)I.updateObserver(q,this),q.handleChange(this,M)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(N){this.d=N}}t.$1d=d;function a(C,N){let I;return typeof C=="string"?I=new k.$$c(void 0,C,void 0):I=new k.$$c(C,void 0,void 0),new L(I,N,i.$6c)}class L extends d{h(N){this.d!==N&&(this.d&&this.d.dispose(),this.d=N)}dispose(){this.d?.dispose()}}t.$3d=L}),define(me[42],be([1,0,37,38,2,33,26,27]),function(se,t,i,k,P,W,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nd=void 0,t.$Id=g,t.$Jd=b,t.$Kd=p,t.$Ld=O,t.$Md=c;function g(n,r){return r!==void 0?new e(new S.$$c(n,void 0,r),r,void 0,void 0,void 0,k.$6c):new e(new S.$$c(void 0,void 0,n),n,void 0,void 0,void 0,k.$6c)}function b(n,r){return new e(new S.$$c(n.owner,n.debugName,n.debugReferenceFn),r,void 0,void 0,n.onLastObserverRemoved,n.equalsFn??k.$6c)}(0,W.$Qd)(b);function p(n,r){return new e(new S.$$c(n.owner,n.debugName,void 0),r,n.createEmptyChangeSummary,n.handleChange,void 0,n.equalityComparer??k.$6c)}function O(n,r){let h,m;r===void 0?(h=n,m=void 0):(m=n,h=r);const y=new P.$Tc;return new e(new S.$$c(m,void 0,h),o=>(y.clear(),h(o,y)),void 0,void 0,()=>y.dispose(),k.$6c)}function c(n,r){let h,m;r===void 0?(h=n,m=void 0):(m=n,h=r);const y=new P.$Tc;return new e(new S.$$c(m,void 0,h),o=>{y.clear();const d=h(o);return d&&y.add(d),d},void 0,void 0,()=>y.dispose(),k.$6c)}var f;(function(n){n[n.initial=0]="initial",n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(f||(f={}));class e extends W.$Sd{get debugName(){return this.m.getDebugName(this)??"(anonymous)"}constructor(r,h,m,y,o=void 0,d){super(),this.m=r,this._computeFn=h,this.n=m,this.p=y,this.q=o,this.s=d,this.e=0,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,A.$Gd)()?.handleDerivedCreated(this)}f(){this.e=0,this.g=void 0;for(const r of this.j)r.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.b.size===0){const r=this._computeFn(this,this.n?.());return this.f(),r}else{do{if(this.e===1){for(const r of this.j)if(r.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.u()}while(this.e!==3);return this.g}}u(){if(this.e===3)return;const r=this.k;this.k=this.j,this.j=r;const h=this.e!==0,m=this.g;this.e=3;const y=this.l;this.l=this.n?.();try{this.g=this._computeFn(this,y)}finally{for(const d of this.k)d.removeObserver(this);this.k.clear()}const o=h&&!this.s(m,this.g);if((0,A.$Gd)()?.handleDerivedRecomputed(this,{oldValue:m,newValue:this.g,change:void 0,didChange:o,hadValue:h}),o)for(const d of this.b)d.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(r){this.h++;const h=this.h===1;if(this.e===3&&(this.e=1,!h))for(const m of this.b)m.handlePossibleChange(this);if(h)for(const m of this.b)m.beginUpdate(this)}endUpdate(r){if(this.h--,this.h===0){const h=[...this.b];for(const m of h)m.endUpdate(this)}(0,i.$fd)(()=>this.h>=0)}handlePossibleChange(r){if(this.e===3&&this.j.has(r)&&!this.k.has(r)){this.e=1;for(const h of this.b)h.handlePossibleChange(this)}}handleChange(r,h){if(this.j.has(r)&&!this.k.has(r)){const m=this.p?this.p({changedObservable:r,change:h,didChange:o=>o===r},this.l):!0,y=this.e===3;if(m&&(this.e===1||y)&&(this.e=2,y))for(const o of this.b)o.handlePossibleChange(this)}}readObservable(r){r.addObserver(this);const h=r.get();return this.j.add(r),this.k.delete(r),h}addObserver(r){const h=!this.b.has(r)&&this.h>0;super.addObserver(r),h&&r.beginUpdate(this)}removeObserver(r){const h=this.b.has(r)&&this.h>0;super.removeObserver(r),h&&r.endUpdate(this)}}t.$Nd=e}),define(me[56],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(k){function P(g,b){if(g.start>=b.end||b.start>=g.end)return{start:0,end:0};const p=Math.max(g.start,b.start),O=Math.min(g.end,b.end);return O-p<=0?{start:0,end:0}:{start:p,end:O}}k.intersect=P;function W(g){return g.end-g.start<=0}k.isEmpty=W;function S(g,b){return!W(P(g,b))}k.intersects=S;function A(g,b){const p=[],O={start:g.start,end:Math.min(b.start,g.end)},c={start:Math.max(b.end,g.start),end:g.end};return W(O)||p.push(O),W(c)||p.push(c),p}k.relativeComplement=A})(i||(t.Range=i={}))}),define(me[92],be([1,0,56]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ST=void 0,t.$PT=k,t.$QT=P,t.$RT=W;function k(g,b){const p=[];for(const O of b){if(g.start>=O.range.end)continue;if(g.end<O.range.start)break;const c=i.Range.intersect(g,O.range);i.Range.isEmpty(c)||p.push({range:c,size:O.size})}return p}function P({start:g,end:b},p){return{start:g+p,end:b+p}}function W(g){const b=[];let p=null;for(const O of g){const c=O.range.start,f=O.range.end,e=O.size;if(p&&e===p.size){p.range.end=f;continue}p={range:{start:c,end:f},size:e},b.push(p)}return b}function S(...g){return W(g.reduce((b,p)=>b.concat(p),[]))}class A{get paddingTop(){return this.c}set paddingTop(b){this.b=this.b+b-this.c,this.c=b}constructor(b){this.a=[],this.b=0,this.c=0,this.c=b??0,this.b=this.c}splice(b,p,O=[]){const c=O.length-p,f=k({start:0,end:b},this.a),e=k({start:b+p,end:Number.POSITIVE_INFINITY},this.a).map(r=>({range:P(r.range,c),size:r.size})),n=O.map((r,h)=>({range:{start:b+h,end:b+h+1},size:r.size}));this.a=S(f,n,e),this.b=this.c+this.a.reduce((r,h)=>r+h.size*(h.range.end-h.range.start),0)}get count(){const b=this.a.length;return b?this.a[b-1].range.end:0}get size(){return this.b}indexAt(b){if(b<0)return-1;if(b<this.c)return 0;let p=0,O=this.c;for(const c of this.a){const f=c.range.end-c.range.start,e=O+f*c.size;if(b<e)return p+Math.floor((b-O)/c.size);p+=f,O=e}return p}indexAfter(b){return Math.min(this.indexAt(b)+1,this.count)}positionAt(b){if(b<0)return-1;let p=0,O=0;for(const c of this.a){const f=c.range.end-c.range.start,e=O+f;if(b<e)return this.c+p+(b-O)*c.size;p+=f*c.size,O=e}return-1}}t.$ST=A}),define(me[93],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class k{static create(W){return new k(W)}constructor(W){this.c=i&&W===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$0d=k}),define(me[3],be([1,0,6,53,2,55,93]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$_d=t.Event=void 0,t.$ae=f;const A=!1,g=!1,b=!1;var p;(function(Y){Y.None=()=>P.$Uc.None;function K(D){if(b){const{onDidAddListener:$}=D,R=n.create();let j=0;D.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),R.print()),$?.()}}}function ae(D,$){return re(D,()=>{},0,void 0,!0,void 0,$)}Y.defer=ae;function ie(D){return($,R=null,j)=>{let U=!1,J;return J=D(oe=>{if(!U)return J?J.dispose():U=!0,$.call(R,oe)},null,j),U&&J.dispose(),J}}Y.once=ie;function ee(D,$,R){return _((j,U=null,J)=>D(oe=>j.call(U,$(oe)),null,J),R)}Y.map=ee;function ce(D,$,R){return _((j,U=null,J)=>D(oe=>{$(oe),j.call(U,oe)},null,J),R)}Y.forEach=ce;function De(D,$,R){return _((j,U=null,J)=>D(oe=>$(oe)&&j.call(U,oe),null,J),R)}Y.filter=De;function Ee(D){return D}Y.signal=Ee;function Ie(...D){return($,R=null,j)=>{const U=(0,P.$Rc)(...D.map(J=>J(oe=>$.call(R,oe))));return ue(U,j)}}Y.any=Ie;function le(D,$,R,j){let U=R;return ee(D,J=>(U=$(U,J),U),j)}Y.reduce=le;function _(D,$){let R;const j={onWillAddFirstListener(){R=D(U.fire,U)},onDidRemoveLastListener(){R?.dispose()}};$||K(j);const U=new d(j);return $?.add(U),U.event}function ue(D,$){return $ instanceof Array?$.push(D):$&&$.add(D),D}function re(D,$,R=100,j=!1,U=!1,J,oe){let pe,fe,Re,ke=0,Oe;const Se={leakWarningThreshold:J,onWillAddFirstListener(){pe=D(We=>{ke++,fe=$(fe,We),j&&!Re&&(Fe.fire(fe),fe=void 0),Oe=()=>{const Xe=fe;fe=void 0,Re=void 0,(!j||ke>1)&&Fe.fire(Xe),ke=0},typeof R=="number"?(clearTimeout(Re),Re=setTimeout(Oe,R)):Re===void 0&&(Re=0,queueMicrotask(Oe))})},onWillRemoveListener(){U&&ke>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,pe.dispose()}};oe||K(Se);const Fe=new d(Se);return oe?.add(Fe),Fe.event}Y.debounce=re;function ye(D,$=0,R){return Y.debounce(D,(j,U)=>j?(j.push(U),j):[U],$,void 0,!0,void 0,R)}Y.accumulate=ye;function V(D,$=(j,U)=>j===U,R){let j=!0,U;return De(D,J=>{const oe=j||!$(J,U);return j=!1,U=J,oe},R)}Y.latch=V;function Q(D,$,R){return[Y.filter(D,$,R),Y.filter(D,j=>!$(j),R)]}Y.split=Q;function ge(D,$=!1,R=[],j){let U=R.slice(),J=D(fe=>{U?U.push(fe):pe.fire(fe)});j&&j.add(J);const oe=()=>{U?.forEach(fe=>pe.fire(fe)),U=null},pe=new d({onWillAddFirstListener(){J||(J=D(fe=>pe.fire(fe)),j&&j.add(J))},onDidAddFirstListener(){U&&($?setTimeout(oe):oe())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return j&&j.add(pe),pe.event}Y.buffer=ge;function we(D,$){return(j,U,J)=>{const oe=$(new Te);return D(function(pe){const fe=oe.evaluate(pe);fe!==Le&&j.call(U,fe)},void 0,J)}}Y.chain=we;const Le=Symbol("HaltChainable");class Te{constructor(){this.f=[]}map($){return this.f.push($),this}forEach($){return this.f.push(R=>($(R),R)),this}filter($){return this.f.push(R=>$(R)?R:Le),this}reduce($,R){let j=R;return this.f.push(U=>(j=$(j,U),j)),this}latch($=(R,j)=>R===j){let R=!0,j;return this.f.push(U=>{const J=R||!$(U,j);return R=!1,j=U,J?U:Le}),this}evaluate($){for(const R of this.f)if($=R($),$===Le)break;return $}}function Me(D,$,R=j=>j){const j=(...pe)=>oe.fire(R(...pe)),U=()=>D.on($,j),J=()=>D.removeListener($,j),oe=new d({onWillAddFirstListener:U,onDidRemoveLastListener:J});return oe.event}Y.fromNodeEventEmitter=Me;function H(D,$,R=j=>j){const j=(...pe)=>oe.fire(R(...pe)),U=()=>D.addEventListener($,j),J=()=>D.removeEventListener($,j),oe=new d({onWillAddFirstListener:U,onDidRemoveLastListener:J});return oe.event}Y.fromDOMEventEmitter=H;function u(D){return new Promise($=>ie(D)($))}Y.toPromise=u;function v(D){const $=new d;return D.then(R=>{$.fire(R)},()=>{$.fire(void 0)}).finally(()=>{$.dispose()}),$.event}Y.fromPromise=v;function l(D,$,R){return $(R),D(j=>$(j))}Y.runAndSubscribe=l;class w{constructor($,R){this._observable=$,this.f=0,this.g=!1;const j={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};R||K(j),this.emitter=new d(j),R&&R.add(this.emitter)}beginUpdate($){this.f++}handlePossibleChange($){}handleChange($,R){this.g=!0}endUpdate($){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function T(D,$){return new w(D,$).emitter.event}Y.fromObservable=T;function s(D){return($,R,j)=>{let U=0,J=!1;const oe={beginUpdate(){U++},endUpdate(){U--,U===0&&(D.reportChanges(),J&&(J=!1,$.call(R)))},handlePossibleChange(){},handleChange(){J=!0}};D.addObserver(oe),D.reportChanges();const pe={dispose(){D.removeObserver(oe)}};return j instanceof P.$Tc?j.add(pe):Array.isArray(j)&&j.push(pe),pe}}Y.fromObservableLight=s})(p||(t.Event=p={}));class O{static{this.all=new Set}static{this.f=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${O.f++}`,O.all.add(this)}start(K){this.g=new S.$0d,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}t.$_d=O;let c=-1;function f(Y){const K=c;return c=Y,{dispose(){c=K}}}class e{constructor(K,ae=Math.random().toString(18).slice(2,5)){this.threshold=K,this.name=ae,this.g=0}dispose(){this.f?.clear()}check(K,ae){const ie=this.threshold;if(ie<=0||ae<ie)return;this.f||(this.f=new Map);const ee=this.f.get(K.value)||0;if(this.f.set(K.value,ee+1),this.g-=1,this.g<=0){this.g=ie*.5;let ce,De=0;for(const[Ee,Ie]of this.f)(!ce||De<Ie)&&(ce=Ee,De=Ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${ae} listeners already. MOST frequent listener (${De}):`),console.warn(ce)}return()=>{const ce=this.f.get(K.value)||0;this.f.set(K.value,ce-1)}}}class n{static create(){return new n(new Error().stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let r=0;class h{constructor(K){this.value=K,this.id=r++}}const m=2,y=(Y,K)=>{if(Y instanceof h)K(Y);else for(let ae=0;ae<Y.length;ae++){const ie=Y[ae];ie&&K(ie)}},o=A?new FinalizationRegistry(Y=>{typeof Y=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(Y))}):void 0;class d{constructor(K){this.w=0,this.f=K,this.g=c>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??c):void 0,this.j=this.f?._profName?new O(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(g){const K=this.t;queueMicrotask(()=>{y(K,ae=>ae.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(K,ae,ie)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.$Uc.None;if(this.m)return P.$Uc.None;ae&&(K=K.bind(ae));const ee=new h(K);let ce,De;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=n.create(),ce=this.g.check(ee.stack,this.w+1)),g&&(ee.stack=De??n.create()),this.t?this.t instanceof h?(this.u??=new L,this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const Ee=(0,P.$Sc)(()=>{o?.unregister(Ee),ce?.(),this.x(ee)});if(ie instanceof P.$Tc?ie.add(Ee):Array.isArray(ie)&&ie.push(Ee),o){const Ie=new Error().stack.split(`
`).slice(2).join(`
`).trim();o.register(Ee,Ie,Ee)}return Ee},this.q}x(K){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const ae=this.t,ie=ae.indexOf(K);if(ie===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,ae[ie]=void 0;const ee=this.u.current===this;if(this.w*m<=ae.length){let ce=0;for(let De=0;De<ae.length;De++)ae[De]?ae[ce++]=ae[De]:ee&&(this.u.end--,ce<this.u.i&&this.u.i--);ae.length=ce}}y(K,ae){if(!K)return;const ie=this.f?.onListenerError||i.$1;if(!ie){K.value(ae);return}try{K.value(ae)}catch(ee){ie(ee)}}z(K){const ae=K.current.t;for(;K.i<K.end;)this.y(ae[K.i++],K.value);K.reset()}fire(K){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,K);else{const ae=this.u;ae.enqueue(this,K,this.t.length),this.z(ae)}this.j?.stop()}hasListeners(){return this.w>0}}t.$be=d;const a=()=>new L;t.$ce=a;class L{constructor(){this.i=-1,this.end=0}enqueue(K,ae,ie){this.i=0,this.end=ie,this.current=K,this.value=ae}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class C extends d{async fireAsync(K,ae,ie){if(this.t)for(this.h||(this.h=new W.$5c),y(this.t,ee=>this.h.push([ee.value,K]));this.h.size>0&&!ae.isCancellationRequested;){const[ee,ce]=this.h.shift(),De=[],Ee={...ce,token:ae,waitUntil:Ie=>{if(Object.isFrozen(De))throw new Error("waitUntil can NOT be called asynchronous");ie&&(Ie=ie(Ie,ee)),De.push(Ie)}};try{ee(Ee)}catch(Ie){(0,i.$1)(Ie);continue}Object.freeze(De),await Promise.allSettled(De).then(Ie=>{for(const le of Ie)le.status==="rejected"&&(0,i.$1)(le.reason)})}}}t.$de=C;class N extends d{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new W.$5c,this.A=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.A(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.w&&(this.h!==0?this.s.push(K):super.fire(K))}}t.$ee=N;class I extends N{constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}t.$fe=I;class M extends d{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ae=>super.fire(ae)),this.h=[]}))}}t.$ge=M;class E{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const ae={event:K,listener:null};this.h.push(ae),this.g&&this.m(ae);const ie=()=>{this.g&&this.o(ae);const ee=this.h.indexOf(ae);this.h.splice(ee,1)};return(0,P.$Sc)((0,k.$db)(ie))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(ae=>this.f.fire(ae))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}t.$he=E;class z{constructor(K,ae,ie,ee){this.f=new P.$Tc;const ce=this.f.add(new E),De=this.f.add(new P.$4c);function Ee(Ie){De.set(Ie,ce.add(ee(Ie)))}for(const Ie of K)Ee(Ie);this.f.add(ae(Ie=>{Ee(Ie)})),this.f.add(ie(Ie=>{De.deleteAndDispose(Ie)})),this.event=ce.event}dispose(){this.f.dispose()}}t.$ie=z;class q{constructor(){this.f=[]}wrapEvent(K){return(ae,ie,ee)=>K(ce=>{const De=this.f[this.f.length-1];De?De.push(()=>ae.call(ie,ce)):ae.call(ie,ce)},void 0,ee)}bufferEvents(K){const ae=[];this.f.push(ae);const ie=K();return this.f.pop(),ae.forEach(ee=>ee()),ie}}t.$je=q;class F{constructor(){this.f=!1,this.g=p.None,this.h=P.$Uc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ke=F;class x{static const(K){return new B(K)}constructor(K){this.g=K,this.f=new d,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}t.$le=x;class B{constructor(K){this.value=K,this.onDidChange=p.None}}}),define(me[17],be([1,0,22,3]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uR=t.$tR=t.$sR=t.$rR=t.$qR=t.$pR=t.$oR=t.$nR=t.$iR=void 0,t.$fR=W,t.$gR=S,t.$hR=A,t.$jR=g,t.$kR=b,t.$lR=p,t.$mR=O,t.$vR=e,t.$wR=n;class P{constructor(){this.a=new Map,this.b=new k.$be,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new k.$be,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new P}getZoomLevel(h){return this.a.get(this.f(h))??0}setZoomLevel(h,m){if(this.getZoomLevel(m)===h)return;const y=this.f(m);this.a.set(y,h),this.b.fire(y)}getZoomFactor(h){return this.c.get(this.f(h))??1}setZoomFactor(h,m){this.c.set(this.f(m),h)}setFullscreen(h,m){if(this.isFullscreen(m)===h)return;const y=this.f(m);this.e.set(y,h),this.d.fire(y)}isFullscreen(h){return!!this.e.get(this.f(h))}f(h){return h.vscodeWindowId}}function W(r,h,m){typeof h=="string"&&(h=r.matchMedia(h)),h.addEventListener("change",m)}function S(r,h){P.INSTANCE.setZoomLevel(r,h)}function A(r){return P.INSTANCE.getZoomLevel(r)}t.$iR=P.INSTANCE.onDidChangeZoomLevel;function g(r){return P.INSTANCE.getZoomFactor(r)}function b(r,h){P.INSTANCE.setZoomFactor(r,h)}function p(r,h){P.INSTANCE.setFullscreen(r,h)}function O(r){return P.INSTANCE.isFullscreen(r)}t.$nR=P.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;t.$oR=c.indexOf("Firefox")>=0,t.$pR=c.indexOf("AppleWebKit")>=0,t.$qR=c.indexOf("Chrome")>=0,t.$rR=!t.$qR&&c.indexOf("Safari")>=0,t.$sR=!t.$qR&&!t.$rR&&t.$pR,t.$tR=c.indexOf("Electron/")>=0,t.$uR=c.indexOf("Android")>=0;let f=!1;if(typeof i.$cR.matchMedia=="function"){const r=i.$cR.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),h=i.$cR.matchMedia("(display-mode: fullscreen)");f=r.matches,W(i.$cR,r,({matches:m})=>{f&&h.matches||(f=m)})}function e(){return f}function n(){return navigator?.windowControlsOverlay?.visible}}),define(me[24],be([1,0,3]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KT=void 0;class k{get event(){return this.a.event}constructor(W,S,A){const g=b=>this.a.fire(b);this.a=new i.$be({onWillAddFirstListener:()=>W.addEventListener(S,g,A),onDidRemoveLastListener:()=>W.removeEventListener(S,g,A)})}dispose(){this.a.dispose()}}t.$KT=k}),define(me[34],be([1,0,3]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$me=t.CancellationToken=void 0;const k=Object.freeze(function(A,g){const b=setTimeout(A.bind(g),0);return{dispose(){clearTimeout(b)}}});var P;(function(A){function g(b){return b===A.None||b===A.Cancelled||b instanceof W?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}A.isCancellationToken=g,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(P||(t.CancellationToken=P={}));class W{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?k:(this.b||(this.b=new i.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class S{constructor(g){this.f=void 0,this.g=void 0,this.g=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new W),this.f}cancel(){this.f?this.f instanceof W&&this.f.cancel():this.f=P.Cancelled}dispose(g=!1){g&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof W&&this.f.dispose():this.f=P.None}}t.$me=S}),define(me[94],be([1,0,34]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1e=t.$Ze=t.$Xe=void 0,t.$Ye=P;class k{constructor(g){this.b=g,this.a=null}get(){if(this.a)return this.a;const g=new i.$me,b=this.b(g.token);return this.a={promise:b,dispose:()=>{this.a=null,g.cancel(),g.dispose()}},this.a}}t.$Xe=k;function P(A){return A}class W{constructor(g,b){this.a=void 0,this.b=void 0,typeof g=="function"?(this.c=g,this.d=P):(this.c=b,this.d=g.getCacheKey)}get(g){const b=this.d(g);return this.b!==b&&(this.b=b,this.a=this.c(g)),this.a}}t.$Ze=W;class S{get cachedValues(){return this.a}constructor(g,b){this.a=new Map,this.b=new Map,typeof g=="function"?(this.c=g,this.d=P):(this.c=b,this.d=g.getCacheKey)}get(g){const b=this.d(g);if(this.b.has(b))return this.b.get(b);const p=this.c(g);return this.a.set(g,p),this.b.set(b,p),p}}t.$1e=S}),define(me[95],be([1,0,41,33,42,34,26,38]),function(se,t,i,k,P,W,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7d=t.$6d=t.$5d=t.$4d=void 0,t.$8d=c,t.$9d=f;class g{get cachedValue(){return this.a}constructor(n){this.b=n,this.a=(0,k.$Yd)(this,void 0)}getValue(){let n=this.a.get();return n||(n=this.b(),this.a.set(n,void 0)),n}}t.$4d=g;class b{constructor(n){this.a=(0,k.$Yd)(this,void 0),this.promiseResult=this.a,this.promise=n.then(r=>((0,k.$Td)(h=>{this.a.set(new p(r,void 0),h)}),r),r=>{throw(0,k.$Td)(h=>{this.a.set(new p(void 0,r),h)}),r})}}t.$5d=b;class p{constructor(n,r){this.data=n,this.error=r}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$6d=p;class O{constructor(n){this.b=n,this.a=new g(()=>new b(this.b())),this.cachedPromiseResult=(0,P.$Id)(this,r=>this.a.cachedValue.read(r)?.promiseResult.read(r))}getPromise(){return this.a.getValue().promise}}t.$7d=O;function c(e,n,r){return n||(n=h=>h!=null),new Promise((h,m)=>{let y=!0,o=!1;const d=e.map(L=>({isFinished:n(L),error:r?r(L):!1,state:L})),a=(0,i.$hd)(L=>{const{isFinished:C,error:N,state:I}=d.read(L);(C||N)&&(y?o=!0:a.dispose(),N?m(N===!0?I:N):h(I))});y=!1,o&&a.dispose()})}function f(e,n){let r,h;n===void 0?(r=e,h=void 0):(h=e,r=n);let m;return new P.$Nd(new S.$$c(h,void 0,r),y=>(m&&m.dispose(!0),m=new W.$me,r(y,m.token)),void 0,void 0,()=>m?.dispose(),A.$6c)}}),define(me[96],be([1,0,3,2,41,33,26,42,27]),function(se,t,i,k,P,W,S,A,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dd=t.$zd=t.$rd=void 0,t.$od=b,t.$pd=O,t.$qd=c,t.$sd=e,t.$td=r,t.$ud=m,t.$vd=y,t.$wd=o,t.$xd=d,t.$yd=a,t.$Ad=C,t.$Bd=N,t.$Cd=I,t.$Ed=z;function b(q){return new p(q)}class p extends W.$Rd{constructor(F){super(),this.b=F}get debugName(){return this.toString()}get(){return this.b}addObserver(F){}removeObserver(F){}toString(){return`Const: ${this.b}`}}function O(q){const F=(0,W.$Yd)("promiseValue",{});return q.then(x=>{F.set({value:x},void 0)}),F}function c(q,F){return new f(q,F)}class f extends W.$Sd{constructor(F,x){super(),this.j=F,this._getValue=x,this.g=!1,this.n=B=>{const Y=this._getValue(B),K=this.e,ae=!this.g||K!==Y;let ie=!1;ae&&(this.e=Y,this.g&&(ie=!0,(0,W.$Wd)(f.globalTransaction,ee=>{(0,g.$Gd)()?.handleFromEventObservableTriggered(this,{oldValue:K,newValue:Y,change:void 0,didChange:ae,hadValue:this.g});for(const ce of this.b)ee.updateObserver(ce,this),ce.handleChange(this,void 0)},()=>{const ee=this.k();return"Event fired"+(ee?`: ${ee}`:"")})),this.g=!0),ie||(0,g.$Gd)()?.handleFromEventObservableTriggered(this,{oldValue:K,newValue:Y,change:void 0,didChange:ae,hadValue:this.g})}}k(){return(0,S.$ad)(this._getValue)}get debugName(){const F=this.k();return"From Event"+(F?`: ${F}`:"")}c(){this.h=this.j(this.n)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.n(void 0),this.e):this._getValue(void 0)}}t.$rd=f,function(q){q.Observer=f;function F(x,B){let Y=!1;f.globalTransaction===void 0&&(f.globalTransaction=x,Y=!0);try{B()}finally{Y&&(f.globalTransaction=void 0)}}q.batchEventsGlobally=F}(c||(t.$qd=c={}));function e(q,F){return new n(q,F)}class n extends W.$Sd{constructor(F,x){super(),this.debugName=F,this.g=x,this.j=()=>{(0,W.$Td)(B=>{for(const Y of this.b)B.updateObserver(Y,this),Y.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function r(q){return typeof q=="string"?new h(q):new h(void 0,q)}class h extends W.$Sd{get debugName(){return new S.$$c(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}constructor(F,x){super(),this.e=F,this.g=x}trigger(F,x){if(!F){(0,W.$Td)(B=>{this.trigger(B,x)},()=>`Trigger signal ${this.debugName}`);return}for(const B of this.b)F.updateObserver(B,this),B.handleChange(this,x)}get(){}}function m(q,F,x){const B=(0,W.$Yd)("debounced",void 0);let Y;return x.add((0,P.$hd)(K=>{const ae=q.read(K);Y&&clearTimeout(Y),Y=setTimeout(()=>{(0,W.$Td)(ie=>{B.set(ae,ie)})},F)})),B}function y(q,F){let x=!1,B,Y;return c(K=>{const ae=(0,P.$hd)(ie=>{const ee=q.read(ie);x?(Y&&clearTimeout(Y),Y=setTimeout(()=>{B=ee,K()},F)):(x=!0,B=ee)});return{dispose(){ae.dispose(),x=!1,B=void 0}}},()=>x?B:q.get())}function o(q,F,x){const B=(0,W.$Yd)("triggeredRecently",!1);let Y;return x.add(q(()=>{B.set(!0,void 0),Y&&clearTimeout(Y),Y=setTimeout(()=>{B.set(!1,void 0)},F)})),B}function d(q){const F=new L(!1,void 0);return q.addObserver(F),(0,k.$Sc)(()=>{q.removeObserver(F)})}(0,W.$Pd)(d);function a(q,F){const x=new L(!0,F);return q.addObserver(x),F?F(q.get()):q.reportChanges(),(0,k.$Sc)(()=>{q.removeObserver(x)})}(0,W.$Od)(a);class L{constructor(F,x){this.b=F,this.c=x,this.a=0}beginUpdate(F){this.a++}endUpdate(F){this.a--,this.a===0&&this.b&&(this.c?this.c(F.get()):F.reportChanges())}handlePossibleChange(F){}handleChange(F,x){}}t.$zd=L;function C(q,F){let x;return(0,A.$Id)(q,Y=>(x=F(Y,x),x))}function N(q,F){let x;const B=r("derivedObservableWithWritableCache"),Y=(0,A.$Id)(q,K=>(B.read(K),x=F(K,x),x));return Object.assign(Y,{clearCache:K=>{x=void 0,B.trigger(K)},setCache:(K,ae)=>{x=K,B.trigger(ae)}})}function I(q,F,x,B){let Y=new M(x,B);return(0,A.$Jd)({debugReferenceFn:x,owner:q,onLastObserverRemoved:()=>{Y.dispose(),Y=new M(x)}},ae=>(Y.setItems(F.read(ae)),Y.getItems()))}class M{constructor(F,x){this.c=F,this.e=x,this.a=new Map,this.b=[]}dispose(){this.a.forEach(F=>F.store.dispose()),this.a.clear()}setItems(F){const x=[],B=new Set(this.a.keys());for(const Y of F){const K=this.e?this.e(Y):Y;let ae=this.a.get(K);if(ae)B.delete(K);else{const ie=new k.$Tc;ae={out:this.c(Y,ie),store:ie},this.a.set(K,ae)}x.push(ae.out)}for(const Y of B)this.a.get(Y).store.dispose(),this.a.delete(Y);this.b=x}getItems(){return this.b}}class E{constructor(F){this.observable=F}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Dd=E;function z(q,F){return F instanceof E?F.observable:c(F.onDidChange,()=>F.value)}}),define(me[57],be([1,0,33,42,41,96,95,27]),function(se,t,i,k,P,W,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$Yd}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$2d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$Td}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$Wd}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return k.$Id}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return k.$Jd}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return k.$Kd}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return k.$Ld}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return P.$hd}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return P.$md}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return P.$jd}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return P.$ld}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return P.$id}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return P.$kd}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return W.$od}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return W.$ud}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return W.$Ad}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return W.$Bd}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return W.$xd}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return W.$yd}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return W.$qd}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return W.$pd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return W.$td}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return W.$sd}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return W.$wd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return S.$4d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return S.$7d}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return S.$5d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return S.$6d}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return S.$8d}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return S.$9d}}),!1&&(0,A.$Fd)(new A.$Hd)}),define(me[58],be([1,0,3,2]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ss=t.$Rs=t.$Qs=t.$Ps=t.ScrollbarVisibility=void 0;var P;(function(f){f[f.Auto=1]="Auto",f[f.Hidden=2]="Hidden",f[f.Visible=3]="Visible"})(P||(t.ScrollbarVisibility=P={}));class W{constructor(e,n,r,h,m,y,o){this.c=e,this._scrollStateBrand=void 0,this.c&&(n=n|0,r=r|0,h=h|0,m=m|0,y=y|0,o=o|0),this.rawScrollLeft=h,this.rawScrollTop=o,n<0&&(n=0),h+n>r&&(h=r-n),h<0&&(h=0),m<0&&(m=0),o+m>y&&(o=y-m),o<0&&(o=0),this.width=n,this.scrollWidth=r,this.scrollLeft=h,this.height=m,this.scrollHeight=y,this.scrollTop=o}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,n){return new W(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new W(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,n){const r=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,m=this.scrollLeft!==e.scrollLeft,y=this.height!==e.height,o=this.scrollHeight!==e.scrollHeight,d=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:n,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:h,scrollLeftChanged:m,heightChanged:y,scrollHeightChanged:o,scrollTopChanged:d}}}t.$Ps=W;class S extends k.$Uc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$be),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new W(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,n){const r=this.g.withScrollDimensions(e,n);this.n(r,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const n=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(e,n){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const r=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===r.scrollLeft&&this.h.to.scrollTop===r.scrollTop)return;let h;n?h=new p(this.h.from,r,this.h.startTime,this.h.duration):h=this.h.combine(this.g,r,this.c),this.h.dispose(),this.h=h}else{const r=this.g.withScrollPosition(e);this.h=p.start(this.g,r,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),n=this.g.withScrollPosition(e);if(this.n(n,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,n){const r=this.g;r.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(r,n)))}}t.$Qs=S;class A{constructor(e,n,r){this.scrollLeft=e,this.scrollTop=n,this.isDone=r}}t.$Rs=A;function g(f,e){const n=e-f;return function(r){return f+n*c(r)}}function b(f,e,n){return function(r){return r<n?f(r/n):e((r-n)/(1-n))}}class p{constructor(e,n,r,h){this.from=e,this.to=n,this.duration=h,this.startTime=r,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,n,r){if(Math.abs(e-n)>2.5*r){let m,y;return e<n?(m=e+.75*r,y=n-.75*r):(m=e-.75*r,y=n+.75*r),b(g(e,m),g(y,n),.33)}return g(e,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const n=(e-this.startTime)/this.duration;if(n<1){const r=this.c(n),h=this.d(n);return new A(r,h,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,n,r){return p.start(e,n,r)}static start(e,n,r){r=r+10;const h=Date.now()-10;return new p(e,n,h,r)}}t.$Ss=p;function O(f){return Math.pow(f,3)}function c(f){return 1-O(1-f)}}),define(me[97],be([1,0,6,2]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ne=P,t.$oe=W,t.$pe=S,t.$qe=A,t.$re=b,t.$se=p,t.$te=O,t.$ue=c,t.$ve=f,t.$we=e,t.$xe=n,t.$ye=r,t.$ze=h,t.$Ae=m,t.$Be=y;function P(o){const d=o;return d?typeof d.read=="function":!1}function W(o){const d=o;return d?[d.on,d.pause,d.resume,d.destroy].every(a=>typeof a=="function"):!1}function S(o){const d=o;return d?W(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}function A(o,d){return new g(o,d)}class g{constructor(d,a){this.e=d,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(a=>a(d))}h(d){this.c.error.length===0?(0,i.$1)(d):this.c.error.slice(0).forEach(a=>a(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,a){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(d,a){if(this.a.destroyed)return;let L;switch(d){case"data":L=this.c.data;break;case"end":L=this.c.end;break;case"error":L=this.c.error;break}if(L){const C=L.indexOf(a);C>=0&&L.splice(C,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(L=>L())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(o,d){const a=[];let L;for(;(L=o.read())!==null;)a.push(L);return d(a)}function p(o,d,a){const L=[];let C;for(;(C=o.read())!==null&&L.length<a;)L.push(C);return C===null&&L.length>0?d(L):{read:()=>{if(L.length>0)return L.shift();if(typeof C<"u"){const N=C;return C=void 0,N}return o.read()}}}function O(o,d){return new Promise((a,L)=>{const C=[];c(o,{onData:N=>{d&&C.push(N)},onError:N=>{d?L(N):a(void 0)},onEnd:()=>{a(d?d(C):void 0)}})})}function c(o,d,a){o.on("error",L=>{a?.isCancellationRequested||d.onError(L)}),o.on("end",()=>{a?.isCancellationRequested||d.onEnd()}),o.on("data",L=>{a?.isCancellationRequested||d.onData(L)})}function f(o,d){return new Promise((a,L)=>{const C=new k.$Tc,N=[],I=z=>{if(N.push(z),N.length>d)return C.dispose(),o.pause(),a({stream:o,buffer:N,ended:!1})},M=z=>(C.dispose(),L(z)),E=()=>(C.dispose(),a({stream:o,buffer:N,ended:!0}));C.add((0,k.$Sc)(()=>o.removeListener("error",M))),o.on("error",M),C.add((0,k.$Sc)(()=>o.removeListener("end",E))),o.on("end",E),C.add((0,k.$Sc)(()=>o.removeListener("data",I))),o.on("data",I)})}function e(o,d){const a=A(d);return a.end(o),a}function n(){const o=A(()=>{throw new Error("not supported")});return o.end(),o}function r(o){let d=!1;return{read:()=>d?null:(d=!0,o)}}function h(o,d,a){const L=A(a);return c(o,{onData:C=>L.write(d.data(C)),onError:C=>L.error(d.error?d.error(C):C),onEnd:()=>L.end()}),L}function m(o,d,a){let L=!1;return{read:()=>{const C=d.read();return L?C:(L=!0,C!==null?a([o,C]):o)}}}function y(o,d,a){let L=!1;const C=A(a);return c(d,{onData:N=>L?C.write(N):(L=!0,C.write(a([o,N]))),onError:N=>C.error(N),onEnd:()=>{L||(L=!0,C.write(o)),C.end()}}),C}}),define(me[43],be([1,0,23,97]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ce=void 0,t.$De=b,t.$Ee=p,t.$Fe=O,t.$Ge=c,t.$He=f,t.$Ie=e,t.$Je=n,t.$Ke=r,t.$Le=h,t.$Me=m,t.$Ne=y,t.$Oe=o,t.$Pe=d,t.$Qe=a,t.$Re=L,t.$Se=C,t.$Te=N,t.$Ue=I,t.$Ve=M,t.$We=q;const P=typeof Buffer<"u",W=new i.$V(()=>new Uint8Array(256));let S,A;class g{static alloc(x){return P?new g(Buffer.allocUnsafe(x)):new g(new Uint8Array(x))}static wrap(x){return P&&!Buffer.isBuffer(x)&&(x=Buffer.from(x.buffer,x.byteOffset,x.byteLength)),new g(x)}static fromString(x,B){return!(B?.dontUseNodeBuffer||!1)&&P?new g(Buffer.from(x)):(S||(S=new TextEncoder),new g(S.encode(x)))}static fromByteArray(x){const B=g.alloc(x.length);for(let Y=0,K=x.length;Y<K;Y++)B.buffer[Y]=x[Y];return B}static concat(x,B){if(typeof B>"u"){B=0;for(let ae=0,ie=x.length;ae<ie;ae++)B+=x[ae].byteLength}const Y=g.alloc(B);let K=0;for(let ae=0,ie=x.length;ae<ie;ae++){const ee=x[ae];Y.set(ee,K),K+=ee.byteLength}return Y}constructor(x){this.buffer=x,this.byteLength=this.buffer.byteLength}clone(){const x=g.alloc(this.byteLength);return x.set(this),x}toString(){return P?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(x,B){return new g(this.buffer.subarray(x,B))}set(x,B){if(x instanceof g)this.buffer.set(x.buffer,B);else if(x instanceof Uint8Array)this.buffer.set(x,B);else if(x instanceof ArrayBuffer)this.buffer.set(new Uint8Array(x),B);else if(ArrayBuffer.isView(x))this.buffer.set(new Uint8Array(x.buffer,x.byteOffset,x.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(x){return c(this.buffer,x)}writeUInt32BE(x,B){f(this.buffer,x,B)}readUInt32LE(x){return e(this.buffer,x)}writeUInt32LE(x,B){n(this.buffer,x,B)}readUInt8(x){return r(this.buffer,x)}writeUInt8(x,B){h(this.buffer,x,B)}indexOf(x,B=0){return b(this.buffer,x instanceof g?x.buffer:x,B)}}t.$Ce=g;function b(F,x,B=0){const Y=x.byteLength,K=F.byteLength;if(Y===0)return 0;if(Y===1)return F.indexOf(x[0]);if(Y>K-B)return-1;const ae=W.value;ae.fill(x.length);for(let De=0;De<x.length;De++)ae[x[De]]=x.length-De-1;let ie=B+x.length-1,ee=ie,ce=-1;for(;ie<K;)if(F[ie]===x[ee]){if(ee===0){ce=ie;break}ie--,ee--}else ie+=Math.max(x.length-ee,ae[F[ie]]),ee=x.length-1;return ce}function p(F,x){return F[x+0]<<0>>>0|F[x+1]<<8>>>0}function O(F,x,B){F[B+0]=x&255,x=x>>>8,F[B+1]=x&255}function c(F,x){return F[x]*2**24+F[x+1]*2**16+F[x+2]*2**8+F[x+3]}function f(F,x,B){F[B+3]=x,x=x>>>8,F[B+2]=x,x=x>>>8,F[B+1]=x,x=x>>>8,F[B]=x}function e(F,x){return F[x+0]<<0>>>0|F[x+1]<<8>>>0|F[x+2]<<16>>>0|F[x+3]<<24>>>0}function n(F,x,B){F[B+0]=x&255,x=x>>>8,F[B+1]=x&255,x=x>>>8,F[B+2]=x&255,x=x>>>8,F[B+3]=x&255}function r(F,x){return F[x]}function h(F,x,B){F[B]=x}function m(F){return k.$re(F,x=>g.concat(x))}function y(F){return k.$ye(F)}function o(F){return k.$te(F,x=>g.concat(x))}async function d(F){return F.ended?g.concat(F.buffer):g.concat([...F.buffer,await o(F.stream)])}function a(F){return k.$we(F,x=>g.concat(x))}function L(F){return k.$ze(F,{data:x=>typeof x=="string"?g.fromString(x):g.wrap(x)},x=>g.concat(x))}function C(F){return k.$qe(x=>g.concat(x),F)}function N(F,x){return k.$Ae(F,x,B=>g.concat(B))}function I(F,x){return k.$Be(F,x,B=>g.concat(B))}function M(F){let x=0,B=0,Y=0;const K=new Uint8Array(Math.floor(F.length/4*3)),ae=ee=>{switch(B){case 3:K[Y++]=x|ee,B=0;break;case 2:K[Y++]=x|ee>>>2,x=ee<<6,B=3;break;case 1:K[Y++]=x|ee>>>4,x=ee<<4,B=2;break;default:x=ee<<2,B=1}};for(let ee=0;ee<F.length;ee++){const ce=F.charCodeAt(ee);if(ce>=65&&ce<=90)ae(ce-65);else if(ce>=97&&ce<=122)ae(ce-97+26);else if(ce>=48&&ce<=57)ae(ce-48+52);else if(ce===43||ce===45)ae(62);else if(ce===47||ce===95)ae(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${F[ee]}`)}}const ie=Y;for(;B>0;)ae(0);return g.wrap(K).slice(0,ie)}const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function q({buffer:F},x=!0,B=!1){const Y=B?z:E;let K="";const ae=F.byteLength%3;let ie=0;for(;ie<F.byteLength-ae;ie+=3){const ee=F[ie+0],ce=F[ie+1],De=F[ie+2];K+=Y[ee>>>2],K+=Y[(ee<<4|ce>>>4)&63],K+=Y[(ce<<2|De>>>6)&63],K+=Y[De&63]}if(ae===1){const ee=F[ie+0];K+=Y[ee>>>2],K+=Y[ee<<4&63],x&&(K+="==")}else if(ae===2){const ee=F[ie+0],ce=F[ie+1];K+=Y[ee>>>2],K+=Y[(ee<<4|ce>>>4)&63],K+=Y[ce<<2&63],x&&(K+="=")}return K}}),define(me[9],be([1,0,94,23]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4f=t.$3f=t.$2f=t.GraphemeBreakType=t.$Rf=t.$Kf=t.$Df=t.$Cf=void 0,t.$4e=P,t.$5e=S,t.$6e=g,t.$7e=b,t.$8e=p,t.$9e=O,t.$0e=c,t.$$e=f,t.$_e=e,t.$af=n,t.$bf=r,t.$cf=h,t.$df=m,t.$ef=y,t.$ff=o,t.$gf=d,t.$hf=a,t.$if=L,t.$jf=C,t.$kf=N,t.$lf=I,t.$mf=M,t.$nf=E,t.$of=z,t.$pf=q,t.$qf=F,t.$rf=x,t.$sf=B,t.$tf=Y,t.$uf=K,t.$vf=ae,t.$wf=ie,t.$xf=ee,t.$yf=ce,t.$zf=De,t.$Af=Ee,t.$Bf=Ie,t.$Ef=re,t.$Ff=ye,t.$Gf=V,t.$Hf=Q,t.$If=Le,t.$Jf=Me,t.$Lf=H,t.$Mf=u,t.$Nf=v,t.$Of=l,t.$Pf=T,t.$Qf=s,t.$Sf=D,t.$Tf=$,t.$Uf=R,t.$Vf=j,t.$Wf=U,t.$Xf=J,t.$Yf=oe,t.$Zf=pe,t.$1f=Se;function P(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}const W=/{(\d+)}/g;function S(Z,...ne){return ne.length===0?Z:Z.replace(W,function($e,ve){const Ne=parseInt(ve,10);return isNaN(Ne)||Ne<0||Ne>=ne.length?$e:ne[Ne]})}const A=/{([^}]+)}/g;function g(Z,ne){return Object.keys(ne).length===0?Z:Z.replace(A,($e,ve)=>ne[ve]??$e)}function b(Z){return Z.replace(/[<>"'&]/g,ne=>{switch(ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ne})}function p(Z){return Z.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}function O(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(Z,ne){let $e=0;const ve=ne.charCodeAt(0);for(let Ne=Z.length-1;Ne>=0;Ne--)Z.charCodeAt(Ne)===ve&&$e++;return $e}function f(Z,ne,$e="\u2026"){return Z.length<=ne?Z:`${Z.substr(0,ne)}${$e}`}function e(Z,ne,$e="\u2026"){if(Z.length<=ne)return Z;const ve=Math.ceil(ne/2)-$e.length/2,Ne=Math.floor(ne/2)-$e.length/2;return`${Z.substr(0,ve)}${$e}${Z.substr(Z.length-Ne)}`}function n(Z,ne=" "){const $e=r(Z,ne);return h($e,ne)}function r(Z,ne){if(!Z||!ne)return Z;const $e=ne.length;if($e===0||Z.length===0)return Z;let ve=0;for(;Z.indexOf(ne,ve)===ve;)ve=ve+$e;return Z.substring(ve)}function h(Z,ne){if(!Z||!ne)return Z;const $e=ne.length,ve=Z.length;if($e===0||ve===0)return Z;let Ne=ve,ze=-1;for(;ze=Z.lastIndexOf(ne,Ne-1),!(ze===-1||ze+$e!==Ne);){if(ze===0)return"";Ne=ze}return Z.substring(0,Ne)}function m(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function y(Z){return Z.replace(/\*/g,"")}function o(Z,ne,$e={}){if(!Z)throw new Error("Cannot create regex from empty string");ne||(Z=O(Z)),$e.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let ve="";return $e.global&&(ve+="g"),$e.matchCase||(ve+="i"),$e.multiline&&(ve+="m"),$e.unicode&&(ve+="u"),new RegExp(Z,ve)}function d(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}function a(Z){return Z.split(/\r\n|\r|\n/)}function L(Z){const ne=[],$e=Z.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil($e.length/2);ve++)ne.push($e[2*ve]+($e[2*ve+1]??""));return ne}function C(Z){for(let ne=0,$e=Z.length;ne<$e;ne++){const ve=Z.charCodeAt(ne);if(ve!==32&&ve!==9)return ne}return-1}function N(Z,ne=0,$e=Z.length){for(let ve=ne;ve<$e;ve++){const Ne=Z.charCodeAt(ve);if(Ne!==32&&Ne!==9)return Z.substring(ne,ve)}return Z.substring(ne,$e)}function I(Z,ne=Z.length-1){for(let $e=ne;$e>=0;$e--){const ve=Z.charCodeAt($e);if(ve!==32&&ve!==9)return $e}return-1}function M(Z,ne,$e){const ve=[];let Ne=0;for(const ze of Z.matchAll(ne)){if(ve.push(Z.slice(Ne,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Ne=ze.index+ze[0].length,ve.push($e(ze[0],...ze.slice(1),ze.index,Z,ze.groups))}return ve.push(Z.slice(Ne)),Promise.all(ve).then(ze=>ze.join(""))}function E(Z,ne){return Z<ne?-1:Z>ne?1:0}function z(Z,ne,$e=0,ve=Z.length,Ne=0,ze=ne.length){for(;$e<ve&&Ne<ze;$e++,Ne++){const it=Z.charCodeAt($e),st=ne.charCodeAt(Ne);if(it<st)return-1;if(it>st)return 1}const Ve=ve-$e,et=ze-Ne;return Ve<et?-1:Ve>et?1:0}function q(Z,ne){return F(Z,ne,0,Z.length,0,ne.length)}function F(Z,ne,$e=0,ve=Z.length,Ne=0,ze=ne.length){for(;$e<ve&&Ne<ze;$e++,Ne++){let it=Z.charCodeAt($e),st=ne.charCodeAt(Ne);if(it===st)continue;if(it>=128||st>=128)return z(Z.toLowerCase(),ne.toLowerCase(),$e,ve,Ne,ze);B(it)&&(it-=32),B(st)&&(st-=32);const Qe=it-st;if(Qe!==0)return Qe}const Ve=ve-$e,et=ze-Ne;return Ve<et?-1:Ve>et?1:0}function x(Z){return Z>=48&&Z<=57}function B(Z){return Z>=97&&Z<=122}function Y(Z){return Z>=65&&Z<=90}function K(Z,ne){return Z.length===ne.length&&F(Z,ne)===0}function ae(Z,ne){const $e=ne.length;return ne.length>Z.length?!1:F(Z,ne,0,$e)===0}function ie(Z,ne){const $e=Math.min(Z.length,ne.length);let ve;for(ve=0;ve<$e;ve++)if(Z.charCodeAt(ve)!==ne.charCodeAt(ve))return ve;return $e}function ee(Z,ne){const $e=Math.min(Z.length,ne.length);let ve;const Ne=Z.length-1,ze=ne.length-1;for(ve=0;ve<$e;ve++)if(Z.charCodeAt(Ne-ve)!==ne.charCodeAt(ze-ve))return ve;return $e}function ce(Z){return 55296<=Z&&Z<=56319}function De(Z){return 56320<=Z&&Z<=57343}function Ee(Z,ne){return(Z-55296<<10)+(ne-56320)+65536}function Ie(Z,ne,$e){const ve=Z.charCodeAt($e);if(ce(ve)&&$e+1<ne){const Ne=Z.charCodeAt($e+1);if(De(Ne))return Ee(ve,Ne)}return ve}function le(Z,ne){const $e=Z.charCodeAt(ne-1);if(De($e)&&ne>1){const ve=Z.charCodeAt(ne-2);if(ce(ve))return Ee(ve,$e)}return $e}class _{get offset(){return this.e}constructor(ne,$e=0){this.c=ne,this.d=ne.length,this.e=$e}setOffset(ne){this.e=ne}prevCodePoint(){const ne=le(this.c,this.e);return this.e-=ne>=65536?2:1,ne}nextCodePoint(){const ne=Ie(this.c,this.d,this.e);return this.e+=ne>=65536?2:1,ne}eol(){return this.e>=this.d}}t.$Cf=_;class ue{get offset(){return this.c.offset}constructor(ne,$e=0){this.c=new _(ne,$e)}nextGraphemeLength(){const ne=ke.getInstance(),$e=this.c,ve=$e.offset;let Ne=ne.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const ze=$e.offset,Ve=ne.getGraphemeBreakType($e.nextCodePoint());if(fe(Ne,Ve)){$e.setOffset(ze);break}Ne=Ve}return $e.offset-ve}prevGraphemeLength(){const ne=ke.getInstance(),$e=this.c,ve=$e.offset;let Ne=ne.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const ze=$e.offset,Ve=ne.getGraphemeBreakType($e.prevCodePoint());if(fe(Ve,Ne)){$e.setOffset(ze);break}Ne=Ve}return ve-$e.offset}eol(){return this.c.eol()}}t.$Df=ue;function re(Z,ne){return new ue(Z,ne).nextGraphemeLength()}function ye(Z,ne){return new ue(Z,ne).prevGraphemeLength()}function V(Z,ne){ne>0&&De(Z.charCodeAt(ne))&&ne--;const $e=ne+re(Z,ne);return[$e-ye(Z,$e),$e]}function Q(Z){const ne=new ue(Z);let $e=0;for(;!ne.eol();)$e++,ne.nextGraphemeLength();return $e}let ge;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Le(Z){return ge||(ge=we()),ge.test(Z)}const Te=/^[\t\n\r\x20-\x7E]*$/;function Me(Z){return Te.test(Z)}t.$Kf=/[\u2028\u2029]/;function H(Z){return t.$Kf.test(Z)}function u(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}function v(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}function l(Z,ne,$e=""){const ve=Z.trimStart();if(ve.length<ne)return ve;const Ne=/\b/g;let ze=0;for(;Ne.test(ve)&&!(ve.length-Ne.lastIndex<ne);)ze=Ne.lastIndex,Ne.lastIndex+=1;return ze===0?ve:$e+ve.substring(ze).trimStart()}const w=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*T(Z){let ne=0;for(const $e of Z.matchAll(w))ne!==$e.index&&(yield{isCode:!1,str:Z.substring(ne,$e.index)}),yield{isCode:!0,str:$e[0]},ne=$e.index+$e[0].length;ne!==Z.length&&(yield{isCode:!1,str:Z.substring(ne)})}function s(Z){return Z&&(Z=Z.replace(w,"")),Z}t.$Rf="\uFEFF";function D(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}function $(Z){return D(Z)?Z.substr(1):Z}function R(Z,ne){if(!Z||!ne||Z.length<ne.length)return!1;const $e=ne.length,ve=Z.toLowerCase();let Ne=0,ze=-1;for(;Ne<$e;){const Ve=ve.indexOf(ne[Ne],ze+1);if(Ve<0)return!1;ze=Ve,Ne++}return!0}function j(Z,ne=!1){return Z?(ne&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}function U(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}function J(Z,ne=1){if(ne===0)return"";let $e=-1;do $e=Z.indexOf(`
`,$e+1),ne--;while(ne>0&&$e>=0);return $e===-1?Z:(Z[$e-1]==="\r"&&$e--,Z.substr(0,$e))}function oe(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}function pe(Z){return ke.getInstance().getGraphemeBreakType(Z)}function fe(Z,ne){return Z===0?ne!==5&&ne!==7:Z===2&&ne===3?!1:Z===4||Z===2||Z===3||ne===4||ne===2||ne===3?!0:!(Z===8&&(ne===8||ne===9||ne===11||ne===12)||(Z===11||Z===9)&&(ne===9||ne===10)||(Z===12||Z===10)&&ne===10||ne===5||ne===13||ne===7||Z===1||Z===13&&ne===14||Z===6&&ne===6)}var Re;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Re||(t.GraphemeBreakType=Re={}));class ke{static{this.c=null}static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=Oe()}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const $e=this.d,ve=$e.length/3;let Ne=1;for(;Ne<=ve;)if(ne<$e[3*Ne])Ne=2*Ne;else if(ne>$e[3*Ne+1])Ne=2*Ne+1;else return $e[3*Ne+2];return 0}}function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(Z,ne){if(Z===0)return 0;const $e=Fe(Z,ne);if($e!==void 0)return $e;const ve=new _(ne,Z);return ve.prevCodePoint(),ve.offset}function Fe(Z,ne){const $e=new _(ne,Z);let ve=$e.prevCodePoint();for(;We(ve)||ve===65039||ve===8419;){if($e.offset===0)return;ve=$e.prevCodePoint()}if(!v(ve))return;let Ne=$e.offset;return Ne>0&&$e.prevCodePoint()===8205&&(Ne=$e.offset),Ne}function We(Z){return 127995<=Z&&Z<=127999}var Xe;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),t.$2f="\xA0";class Ue{static{this.c=new k.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Ze({getCacheKey:JSON.stringify},ne=>{function $e(Qe){const rt=new Map;for(let tt=0;tt<Qe.length;tt+=2)rt.set(Qe[tt],Qe[tt+1]);return rt}function ve(Qe,rt){const tt=new Map(Qe);for(const[mt,gt]of rt)tt.set(mt,gt);return tt}function Ne(Qe,rt){if(!Qe)return rt;const tt=new Map;for(const[mt,gt]of Qe)rt.has(mt)&&tt.set(mt,gt);return tt}const ze=this.c.value;let Ve=ne.filter(Qe=>!Qe.startsWith("_")&&Qe in ze);Ve.length===0&&(Ve=["_default"]);let et;for(const Qe of Ve){const rt=$e(ze[Qe]);et=Ne(et,rt)}const it=$e(ze._common),st=ve(it,et);return new Ue(st)})}static getInstance(ne){return Ue.d.get(Array.from(ne))}static{this.e=new k.$V(()=>Object.keys(Ue.c.value).filter(ne=>!ne.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(ne){this.f=ne}isAmbiguous(ne){return this.f.has(ne)}getPrimaryConfusable(ne){return this.f.get(ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$3f=Ue;class _e{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(_e.c())),this.d}static isInvisibleCharacter(ne){return _e.e().has(ne)}static get codePoints(){return _e.e()}}t.$4f=_e}),define(me[44],be([1,0,39,89,9]),function(se,t,i,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ek=t.FuzzyScore=t.$tk=t.$sk=void 0,t.or=W,t.$uk=A,t.$vk=g,t.$wk=O,t.$xk=M,t.$yk=E,t.$zk=Y,t.$Ak=K,t.$Bk=ae,t.$Ck=ie,t.$Dk=Le,t.$Fk=u,t.$Gk=w,t.$Hk=T;function W(...$){return function(R,j){for(let U=0,J=$.length;U<J;U++){const oe=$[U](R,j);if(oe)return oe}return null}}t.$sk=S.bind(void 0,!1),t.$tk=S.bind(void 0,!0);function S($,R,j){if(!j||j.length<R.length)return null;let U;return $?U=P.$vf(j,R):U=j.indexOf(R)===0,U?R.length>0?[{start:0,end:R.length}]:[]:null}function A($,R){const j=R.toLowerCase().indexOf($.toLowerCase());return j===-1?null:[{start:j,end:j+$.length}]}function g($,R){return b($.toLowerCase(),R.toLowerCase(),0,0)}function b($,R,j,U){if(j===$.length)return[];if(U===R.length)return null;if($[j]===R[U]){let J=null;return(J=b($,R,j+1,U+1))?o({start:U,end:U+1},J):null}return b($,R,j,U+1)}function p($){return 97<=$&&$<=122}function O($){return 65<=$&&$<=90}function c($){return 48<=$&&$<=57}function f($){return $===32||$===9||$===10||$===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach($=>e.add($.charCodeAt(0)));function n($){return f($)||e.has($)}function r($,R){return $===R||n($)&&n(R)}const h=new Map;function m($){if(h.has($))return h.get($);let R;const j=(0,k.$qk)($);return j&&(R=j),h.set($,R),R}function y($){return p($)||O($)||c($)}function o($,R){return R.length===0?R=[$]:$.end===R[0].start?R[0].start=$.start:R.unshift($),R}function d($,R){for(let j=R;j<$.length;j++){const U=$.charCodeAt(j);if(O(U)||c(U)||j>0&&!y($.charCodeAt(j-1)))return j}return $.length}function a($,R,j,U){if(j===$.length)return[];if(U===R.length)return null;if($[j]!==R[U].toLowerCase())return null;{let J=null,oe=U+1;for(J=a($,R,j+1,U+1);!J&&(oe=d(R,oe))<R.length;)J=a($,R,j+1,oe),oe++;return J===null?null:o({start:U,end:U+1},J)}}function L($){let R=0,j=0,U=0,J=0,oe=0;for(let Oe=0;Oe<$.length;Oe++)oe=$.charCodeAt(Oe),O(oe)&&R++,p(oe)&&j++,y(oe)&&U++,c(oe)&&J++;const pe=R/$.length,fe=j/$.length,Re=U/$.length,ke=J/$.length;return{upperPercent:pe,lowerPercent:fe,alphaPercent:Re,numericPercent:ke}}function C($){const{upperPercent:R,lowerPercent:j}=$;return j===0&&R>.6}function N($){const{upperPercent:R,lowerPercent:j,alphaPercent:U,numericPercent:J}=$;return j>.2&&R<.8&&U>.6&&J<.2}function I($){let R=0,j=0,U=0,J=0;for(let oe=0;oe<$.length;oe++)U=$.charCodeAt(oe),O(U)&&R++,p(U)&&j++,f(U)&&J++;return(R===0||j===0)&&J===0?$.length<=30:R<=5}function M($,R){if(!R||(R=R.trim(),R.length===0)||!I($))return null;R.length>60&&(R=R.substring(0,60));const j=L(R);if(!N(j)){if(!C(j))return null;R=R.toLowerCase()}let U=null,J=0;for($=$.toLowerCase();J<R.length&&(U=a($,R,0,J))===null;)J=d(R,J+1);return U}function E($,R,j=!1){if(!R||R.length===0)return null;let U=null,J=0;for($=$.toLowerCase(),R=R.toLowerCase();J<R.length&&(U=z($,R,0,J,j),U===null);)J=q(R,J+1);return U}function z($,R,j,U,J){let oe=0;if(j===$.length)return[];if(U===R.length)return null;if(!r($.charCodeAt(j),R.charCodeAt(U))){const Re=m($.charCodeAt(j));if(!Re)return null;for(let ke=0;ke<Re.length;ke++)if(!r(Re[ke],R.charCodeAt(U+ke)))return null;oe+=Re.length-1}let pe=null,fe=U+oe+1;if(pe=z($,R,j+1,fe,J),!J)for(;!pe&&(fe=q(R,fe))<R.length;)pe=z($,R,j+1,fe,J),fe++;if(!pe)return null;if($.charCodeAt(j)!==R.charCodeAt(U)){const Re=m($.charCodeAt(j));if(!Re)return pe;for(let ke=0;ke<Re.length;ke++)if(Re[ke]!==R.charCodeAt(U+ke))return pe}return o({start:U,end:U+oe+1},pe)}function q($,R){for(let j=R;j<$.length;j++)if(n($.charCodeAt(j))||j>0&&n($.charCodeAt(j-1)))return j;return $.length}const F=W(t.$tk,M,A),x=W(t.$tk,M,g),B=new i.$Ec(1e4);function Y($,R,j=!1){if(typeof $!="string"||typeof R!="string")return null;let U=B.get($);U||(U=new RegExp(P.$df($),"i"),B.set($,U));const J=U.exec(R);return J?[{start:J.index,end:J.index+J[0].length}]:j?x($,R):F($,R)}function K($,R){const j=u($,$.toLowerCase(),0,R,R.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?ie(j):null}function ae($,R,j,U,J,oe){const pe=Math.min(13,$.length);for(;j<pe;j++){const fe=u($,R,j,U,J,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,oe]}function ie($){if(typeof $>"u")return[];const R=[],j=$[1];for(let U=$.length-1;U>1;U--){const J=$[U]+j,oe=R[R.length-1];oe&&oe.end===J?oe.end=J+1:R.push({start:J,end:J+1})}return R}const ee=128;function ce(){const $=[],R=[];for(let j=0;j<=ee;j++)R[j]=0;for(let j=0;j<=ee;j++)$.push(R.slice(0));return $}function De($){const R=[];for(let j=0;j<=$;j++)R[j]=0;return R}const Ee=De(2*ee),Ie=De(2*ee),le=ce(),_=ce(),ue=ce(),re=!1;function ye($,R,j,U,J){function oe(fe,Re,ke=" "){for(;fe.length<Re;)fe=ke+fe;return fe}let pe=` |   |${U.split("").map(fe=>oe(fe,3)).join("|")}
`;for(let fe=0;fe<=j;fe++)fe===0?pe+=" |":pe+=`${R[fe-1]}|`,pe+=$[fe].slice(0,J+1).map(Re=>oe(Re.toString(),3)).join("|")+`
`;return pe}function V($,R,j,U){$=$.substr(R),j=j.substr(U),console.log(ye(_,$,$.length,j,j.length)),console.log(ye(ue,$,$.length,j,j.length)),console.log(ye(le,$,$.length,j,j.length))}function Q($,R){if(R<0||R>=$.length)return!1;const j=$.codePointAt(R);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.$Nf(j)}}function ge($,R){if(R<0||R>=$.length)return!1;switch($.charCodeAt(R)){case 32:case 9:return!0;default:return!1}}function we($,R,j){return R[$]!==j[$]}function Le($,R,j,U,J,oe,pe=!1){for(;R<j&&J<oe;)$[R]===U[J]&&(pe&&(Ee[R]=J),R+=1),J+=1;return R===j}var Te;(function($){$[$.Diag=1]="Diag",$[$.Left=2]="Left",$[$.LeftLeft=3]="LeftLeft"})(Te||(Te={}));var Me;(function($){$.Default=[-100,0];function R(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}$.isDefault=R})(Me||(t.FuzzyScore=Me={}));class H{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(R,j){this.firstMatchCanBeWeak=R,this.boostFullMatch=j}}t.$Ek=H;function u($,R,j,U,J,oe,pe=H.default){const fe=$.length>ee?ee:$.length,Re=U.length>ee?ee:U.length;if(j>=fe||oe>=Re||fe-j>Re-oe||!Le(R,j,fe,J,oe,Re,!0))return;v(fe,Re,j,oe,R,J);let ke=1,Oe=1,Se=j,Fe=oe;const We=[!1];for(ke=1,Se=j;Se<fe;ke++,Se++){const ne=Ee[Se],$e=Ie[Se],ve=Se+1<fe?Ie[Se+1]:Re;for(Oe=ne-oe+1,Fe=ne;Fe<ve;Oe++,Fe++){let Ne=Number.MIN_SAFE_INTEGER,ze=!1;Fe<=$e&&(Ne=l($,R,Se,j,U,J,Fe,Re,oe,le[ke-1][Oe-1]===0,We));let Ve=0;Ne!==Number.MAX_SAFE_INTEGER&&(ze=!0,Ve=Ne+_[ke-1][Oe-1]);const et=Fe>ne,it=et?_[ke][Oe-1]+(le[ke][Oe-1]>0?-5:0):0,st=Fe>ne+1&&le[ke][Oe-1]>0,Qe=st?_[ke][Oe-2]+(le[ke][Oe-2]>0?-5:0):0;if(st&&(!et||Qe>=it)&&(!ze||Qe>=Ve))_[ke][Oe]=Qe,ue[ke][Oe]=3,le[ke][Oe]=0;else if(et&&(!ze||it>=Ve))_[ke][Oe]=it,ue[ke][Oe]=2,le[ke][Oe]=0;else if(ze)_[ke][Oe]=Ve,ue[ke][Oe]=1,le[ke][Oe]=le[ke-1][Oe-1]+1;else throw new Error("not possible")}}if(re&&V($,j,U,oe),!We[0]&&!pe.firstMatchCanBeWeak)return;ke--,Oe--;const Xe=[_[ke][Oe],oe];let Ue=0,_e=0;for(;ke>=1;){let ne=Oe;do{const $e=ue[ke][ne];if($e===3)ne=ne-2;else if($e===2)ne=ne-1;else break}while(ne>=1);Ue>1&&R[j+ke-1]===J[oe+Oe-1]&&!we(ne+oe-1,U,J)&&Ue+1>le[ke][ne]&&(ne=Oe),ne===Oe?Ue++:Ue=1,_e||(_e=ne),ke--,Oe=ne-1,Xe.push(Oe)}Re===fe&&pe.boostFullMatch&&(Xe[0]+=2);const Z=_e-fe;return Xe[0]-=Z,Xe}function v($,R,j,U,J,oe){let pe=$-1,fe=R-1;for(;pe>=j&&fe>=U;)J[pe]===oe[fe]&&(Ie[pe]=fe,pe--),fe--}function l($,R,j,U,J,oe,pe,fe,Re,ke,Oe){if(R[j]!==oe[pe])return Number.MIN_SAFE_INTEGER;let Se=1,Fe=!1;return pe===j-U?Se=$[j]===J[pe]?7:5:we(pe,J,oe)&&(pe===0||!we(pe-1,J,oe))?(Se=$[j]===J[pe]?7:5,Fe=!0):Q(oe,pe)&&(pe===0||!Q(oe,pe-1))?Se=5:(Q(oe,pe-1)||ge(oe,pe-1))&&(Se=5,Fe=!0),Se>1&&j===U&&(Oe[0]=!0),Fe||(Fe=we(pe,J,oe)||Q(oe,pe-1)||ge(oe,pe-1)),j===U?pe>Re&&(Se-=Fe?3:5):ke?Se+=Fe?2:0:Se+=Fe?0:1,pe+1===fe&&(Se-=Fe?3:5),Se}function w($,R,j,U,J,oe,pe){return s($,R,j,U,J,oe,!0,pe)}function T($,R,j,U,J,oe,pe){return s($,R,j,U,J,oe,!1,pe)}function s($,R,j,U,J,oe,pe,fe){let Re=u($,R,j,U,J,oe,fe);if(Re&&!pe)return Re;if($.length>=3){const ke=Math.min(7,$.length-1);for(let Oe=j+1;Oe<ke;Oe++){const Se=D($,Oe);if(Se){const Fe=u(Se,Se.toLowerCase(),j,U,J,oe,fe);Fe&&(Fe[0]-=3,(!Re||Fe[0]>Re[0])&&(Re=Fe))}}}return Re}function D($,R){if(R+1>=$.length)return;const j=$[R],U=$[R+1];if(j!==U)return $.slice(0,R)+U+j+$.slice(R+2)}}),define(me[59],be([1,0,9]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lj=t.$jj=void 0,t.$fj=k,t.$gj=P,t.$hj=W,t.$ij=A,t.$kj=n;function k(h){return P(h,0)}function P(h,m){switch(typeof h){case"object":return h===null?W(349,m):Array.isArray(h)?g(h,m):b(h,m);case"string":return A(h,m);case"boolean":return S(h,m);case"number":return W(h,m);case"undefined":return W(937,m);default:return W(617,m)}}function W(h,m){return(m<<5)-m+h|0}function S(h,m){return W(h?433:863,m)}function A(h,m){m=W(149417,m);for(let y=0,o=h.length;y<o;y++)m=W(h.charCodeAt(y),m);return m}function g(h,m){return m=W(104579,m),h.reduce((y,o)=>P(o,y),m)}function b(h,m){return m=W(181387,m),Object.keys(h).sort().reduce((y,o)=>(y=A(o,y),P(h[o],y)),m)}class p{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=P(m,this.g),this.g}}t.$jj=p;var O;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function c(h,m,y=32){const o=y-m,d=~((1<<o)-1);return(h<<m|(d&h)>>>o)>>>0}function f(h,m=0,y=h.byteLength,o=0){for(let d=0;d<y;d++)h[m+d]=o}function e(h,m,y="0"){for(;h.length<m;)h=y+h;return h}function n(h,m=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(y=>y.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),m/4)}class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const y=m.length;if(y===0)return;const o=this.p;let d=this.r,a=this.u,L,C;for(a!==0?(L=a,C=-1,a=0):(L=m.charCodeAt(0),C=0);;){let N=L;if(i.$yf(L))if(C+1<y){const I=m.charCodeAt(C+1);i.$zf(I)?(C++,N=i.$Af(L,I)):N=65533}else{a=L;break}else i.$zf(L)&&(N=65533);if(d=this.w(o,d,N),C++,C<y)L=m.charCodeAt(C);else break}this.r=d,this.u=a}w(m,y,o){return o<128?m[y++]=o:o<2048?(m[y++]=192|(o&1984)>>>6,m[y++]=128|(o&63)>>>0):o<65536?(m[y++]=224|(o&61440)>>>12,m[y++]=128|(o&4032)>>>6,m[y++]=128|(o&63)>>>0):(m[y++]=240|(o&1835008)>>>18,m[y++]=128|(o&258048)>>>12,m[y++]=128|(o&4032)>>>6,m[y++]=128|(o&63)>>>0),y>=64&&(this.y(),y-=64,this.t+=64,m[0]=m[64],m[1]=m[65],m[2]=m[66]),y}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),n(this.h)+n(this.l)+n(this.m)+n(this.n)+n(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=r.g,y=this.q;for(let E=0;E<64;E+=4)m.setUint32(E,y.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)m.setUint32(E,c(m.getUint32(E-12,!1)^m.getUint32(E-32,!1)^m.getUint32(E-56,!1)^m.getUint32(E-64,!1),1),!1);let o=this.h,d=this.l,a=this.m,L=this.n,C=this.o,N,I,M;for(let E=0;E<80;E++)E<20?(N=d&a|~d&L,I=1518500249):E<40?(N=d^a^L,I=1859775393):E<60?(N=d&a|d&L|a&L,I=2400959708):(N=d^a^L,I=3395469782),M=c(o,5)+N+C+I+m.getUint32(E*4,!1)&4294967295,C=L,L=a,a=c(d,30),d=o,o=M;this.h=this.h+o&4294967295,this.l=this.l+d&4294967295,this.m=this.m+a&4294967295,this.n=this.n+L&4294967295,this.o=this.o+C&4294967295}}t.$lj=r}),define(me[98],be([1,0,85,59]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tt=t.$rt=void 0,t.$st=W;class P{constructor(c){this.a=c}getElements(){const c=this.a,f=new Int32Array(c.length);for(let e=0,n=c.length;e<n;e++)f[e]=c.charCodeAt(e);return f}}t.$rt=P;function W(O,c,f){return new p(new P(O),new P(c)).ComputeDiff(f).changes}class S{static Assert(c,f){if(!c)throw new Error(f)}}class A{static Copy(c,f,e,n,r){for(let h=0;h<r;h++)e[n+h]=c[f+h]}static Copy2(c,f,e,n,r){for(let h=0;h<r;h++)e[n+h]=c[f+h]}}var g;(function(O){O[O.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(g||(g={}));class b{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$qt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(c,f){this.b=Math.min(this.b,c),this.c=Math.min(this.c,f),this.d++}AddModifiedElement(c,f){this.b=Math.min(this.b,c),this.c=Math.min(this.c,f),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class p{constructor(c,f,e=null){this.a=e,this.b=c,this.c=f;const[n,r,h]=p.o(c),[m,y,o]=p.o(f);this.d=h&&o,this.e=n,this.f=r,this.g=m,this.h=y,this.k=[],this.m=[]}static n(c){return c.length>0&&typeof c[0]=="string"}static o(c){const f=c.getElements();if(p.n(f)){const e=new Int32Array(f.length);for(let n=0,r=f.length;n<r;n++)e[n]=(0,k.$ij)(f[n],0);return[f,e,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}p(c,f){return this.f[c]!==this.h[f]?!1:this.d?this.e[c]===this.g[f]:!0}q(c,f){if(!this.p(c,f))return!1;const e=p.r(this.b,c),n=p.r(this.c,f);return e===n}static r(c,f){return typeof c.getStrictElement=="function"?c.getStrictElement(f):null}s(c,f){return this.f[c]!==this.f[f]?!1:this.d?this.e[c]===this.e[f]:!0}u(c,f){return this.h[c]!==this.h[f]?!1:this.d?this.g[c]===this.g[f]:!0}ComputeDiff(c){return this.v(0,this.f.length-1,0,this.h.length-1,c)}v(c,f,e,n,r){const h=[!1];let m=this.w(c,f,e,n,h);return r&&(m=this.z(m)),{quitEarly:h[0],changes:m}}w(c,f,e,n,r){for(r[0]=!1;c<=f&&e<=n&&this.p(c,e);)c++,e++;for(;f>=c&&n>=e&&this.p(f,n);)f--,n--;if(c>f||e>n){let a;return e<=n?(S.Assert(c===f+1,"originalStart should only be one more than originalEnd"),a=[new i.$qt(c,0,e,n-e+1)]):c<=f?(S.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),a=[new i.$qt(c,f-c+1,e,0)]):(S.Assert(c===f+1,"originalStart should only be one more than originalEnd"),S.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}const h=[0],m=[0],y=this.y(c,f,e,n,h,m,r),o=h[0],d=m[0];if(y!==null)return y;if(!r[0]){const a=this.w(c,o,e,d,r);let L=[];return r[0]?L=[new i.$qt(o+1,f-(o+1)+1,d+1,n-(d+1)+1)]:L=this.w(o+1,f,d+1,n,r),this.H(a,L)}return[new i.$qt(c,f-c+1,e,n-e+1)]}x(c,f,e,n,r,h,m,y,o,d,a,L,C,N,I,M,E,z){let q=null,F=null,x=new b,B=f,Y=e,K=C[0]-M[0]-n,ae=-1073741824,ie=this.k.length-1;do{const ee=K+c;ee===B||ee<Y&&o[ee-1]<o[ee+1]?(a=o[ee+1],N=a-K-n,a<ae&&x.MarkNextChange(),ae=a,x.AddModifiedElement(a+1,N),K=ee+1-c):(a=o[ee-1]+1,N=a-K-n,a<ae&&x.MarkNextChange(),ae=a-1,x.AddOriginalElement(a,N+1),K=ee-1-c),ie>=0&&(o=this.k[ie],c=o[0],B=1,Y=o.length-1)}while(--ie>=-1);if(q=x.getReverseChanges(),z[0]){let ee=C[0]+1,ce=M[0]+1;if(q!==null&&q.length>0){const De=q[q.length-1];ee=Math.max(ee,De.getOriginalEnd()),ce=Math.max(ce,De.getModifiedEnd())}F=[new i.$qt(ee,L-ee+1,ce,I-ce+1)]}else{x=new b,B=h,Y=m,K=C[0]-M[0]-y,ae=1073741824,ie=E?this.m.length-1:this.m.length-2;do{const ee=K+r;ee===B||ee<Y&&d[ee-1]>=d[ee+1]?(a=d[ee+1]-1,N=a-K-y,a>ae&&x.MarkNextChange(),ae=a+1,x.AddOriginalElement(a+1,N+1),K=ee+1-r):(a=d[ee-1],N=a-K-y,a>ae&&x.MarkNextChange(),ae=a,x.AddModifiedElement(a+1,N+1),K=ee-1-r),ie>=0&&(d=this.m[ie],r=d[0],B=1,Y=d.length-1)}while(--ie>=-1);F=x.getChanges()}return this.H(q,F)}y(c,f,e,n,r,h,m){let y=0,o=0,d=0,a=0,L=0,C=0;c--,e--,r[0]=0,h[0]=0,this.k=[],this.m=[];const N=f-c+(n-e),I=N+1,M=new Int32Array(I),E=new Int32Array(I),z=n-e,q=f-c,F=c-e,x=f-n,Y=(q-z)%2===0;M[z]=c,E[q]=f,m[0]=!1;for(let K=1;K<=N/2+1;K++){let ae=0,ie=0;d=this.J(z-K,K,z,I),a=this.J(z+K,K,z,I);for(let ce=d;ce<=a;ce+=2){ce===d||ce<a&&M[ce-1]<M[ce+1]?y=M[ce+1]:y=M[ce-1]+1,o=y-(ce-z)-F;const De=y;for(;y<f&&o<n&&this.p(y+1,o+1);)y++,o++;if(M[ce]=y,y+o>ae+ie&&(ae=y,ie=o),!Y&&Math.abs(ce-q)<=K-1&&y>=E[ce])return r[0]=y,h[0]=o,De<=E[ce]&&1447>0&&K<=1448?this.x(z,d,a,F,q,L,C,x,M,E,y,f,r,o,n,h,Y,m):null}const ee=(ae-c+(ie-e)-K)/2;if(this.a!==null&&!this.a(ae,ee))return m[0]=!0,r[0]=ae,h[0]=ie,ee>0&&1447>0&&K<=1448?this.x(z,d,a,F,q,L,C,x,M,E,y,f,r,o,n,h,Y,m):(c++,e++,[new i.$qt(c,f-c+1,e,n-e+1)]);L=this.J(q-K,K,q,I),C=this.J(q+K,K,q,I);for(let ce=L;ce<=C;ce+=2){ce===L||ce<C&&E[ce-1]>=E[ce+1]?y=E[ce+1]-1:y=E[ce-1],o=y-(ce-q)-x;const De=y;for(;y>c&&o>e&&this.p(y,o);)y--,o--;if(E[ce]=y,Y&&Math.abs(ce-z)<=K&&y<=M[ce])return r[0]=y,h[0]=o,De>=M[ce]&&1447>0&&K<=1448?this.x(z,d,a,F,q,L,C,x,M,E,y,f,r,o,n,h,Y,m):null}if(K<=1447){let ce=new Int32Array(a-d+2);ce[0]=z-d+1,A.Copy2(M,d,ce,1,a-d+1),this.k.push(ce),ce=new Int32Array(C-L+2),ce[0]=q-L+1,A.Copy2(E,L,ce,1,C-L+1),this.m.push(ce)}}return this.x(z,d,a,F,q,L,C,x,M,E,y,f,r,o,n,h,Y,m)}z(c){for(let f=0;f<c.length;f++){const e=c[f],n=f<c.length-1?c[f+1].originalStart:this.f.length,r=f<c.length-1?c[f+1].modifiedStart:this.h.length,h=e.originalLength>0,m=e.modifiedLength>0;for(;e.originalStart+e.originalLength<n&&e.modifiedStart+e.modifiedLength<r&&(!h||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!m||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const y=[null];if(f<c.length-1&&this.I(c[f],c[f+1],y)){c[f]=y[0],c.splice(f+1,1),f--;continue}}for(let f=c.length-1;f>=0;f--){const e=c[f];let n=0,r=0;if(f>0){const a=c[f-1];n=a.originalStart+a.originalLength,r=a.modifiedStart+a.modifiedLength}const h=e.originalLength>0,m=e.modifiedLength>0;let y=0,o=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let a=1;;a++){const L=e.originalStart-a,C=e.modifiedStart-a;if(L<n||C<r||h&&!this.s(L,L+e.originalLength)||m&&!this.u(C,C+e.modifiedLength))break;const I=(L===n&&C===r?5:0)+this.G(L,e.originalLength,C,e.modifiedLength);I>o&&(o=I,y=a)}e.originalStart-=y,e.modifiedStart-=y;const d=[null];if(f>0&&this.I(c[f-1],c[f],d)){c[f-1]=d[0],c.splice(f,1),f++;continue}}if(this.d)for(let f=1,e=c.length;f<e;f++){const n=c[f-1],r=c[f],h=r.originalStart-n.originalStart-n.originalLength,m=n.originalStart,y=r.originalStart+r.originalLength,o=y-m,d=n.modifiedStart,a=r.modifiedStart+r.modifiedLength,L=a-d;if(h<5&&o<20&&L<20){const C=this.A(m,o,d,L,h);if(C){const[N,I]=C;(N!==n.originalStart+n.originalLength||I!==n.modifiedStart+n.modifiedLength)&&(n.originalLength=N-n.originalStart,n.modifiedLength=I-n.modifiedStart,r.originalStart=N+h,r.modifiedStart=I+h,r.originalLength=y-r.originalStart,r.modifiedLength=a-r.modifiedStart)}}}return c}A(c,f,e,n,r){if(f<r||n<r)return null;const h=c+f-r+1,m=e+n-r+1;let y=0,o=0,d=0;for(let a=c;a<h;a++)for(let L=e;L<m;L++){const C=this.B(a,L,r);C>0&&C>y&&(y=C,o=a,d=L)}return y>0?[o,d]:null}B(c,f,e){let n=0;for(let r=0;r<e;r++){if(!this.p(c+r,f+r))return 0;n+=this.e[c+r].length}return n}C(c){return c<=0||c>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[c])}D(c,f){if(this.C(c)||this.C(c-1))return!0;if(f>0){const e=c+f;if(this.C(e-1)||this.C(e))return!0}return!1}E(c){return c<=0||c>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[c])}F(c,f){if(this.E(c)||this.E(c-1))return!0;if(f>0){const e=c+f;if(this.E(e-1)||this.E(e))return!0}return!1}G(c,f,e,n){const r=this.D(c,f)?1:0,h=this.F(e,n)?1:0;return r+h}H(c,f){const e=[];if(c.length===0||f.length===0)return f.length>0?f:c;if(this.I(c[c.length-1],f[0],e)){const n=new Array(c.length+f.length-1);return A.Copy(c,0,n,0,c.length-1),n[c.length-1]=e[0],A.Copy(f,1,n,c.length,f.length-1),n}else{const n=new Array(c.length+f.length);return A.Copy(c,0,n,0,c.length),A.Copy(f,0,n,c.length,f.length),n}}I(c,f,e){if(S.Assert(c.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),S.Assert(c.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=f.originalStart||c.modifiedStart+c.modifiedLength>=f.modifiedStart){const n=c.originalStart;let r=c.originalLength;const h=c.modifiedStart;let m=c.modifiedLength;return c.originalStart+c.originalLength>=f.originalStart&&(r=f.originalStart+f.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=f.modifiedStart&&(m=f.modifiedStart+f.modifiedLength-c.modifiedStart),e[0]=new i.$qt(n,r,h,m),!0}else return e[0]=null,!1}J(c,f,e,n){if(c>=0&&c<n)return c;const r=e,h=n-e-1,m=f%2===0;if(c<0){const y=r%2===0;return m===y?0:1}else{const y=h%2===0;return m===y?n-1:n-2}}}t.$tt=p}),define(me[60],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$d=void 0,t.$$d=Symbol("MicrotaskDelay")}),define(me[99],be([1,0,8,9]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xi=t.$wi=t.$vi=t.$ui=t.$ti=void 0;class P{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const e=f.charCodeAt(0),n=this.b.charCodeAt(this.c);return e-n}value(){return this.b[this.c]}}t.$ti=P;class W{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,k.$of)(f,this.b,0,f.length,this.c,this.d):(0,k.$qf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$ui=W;class S{constructor(f=!0,e=!0){this.f=f,this.g=e}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let e=f.length-1;e>=0;e--,this.c--){const n=this.b.charCodeAt(e);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,k.$of)(f,this.b,0,f.length,this.d,this.e):(0,k.$qf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$vi=S;var A;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(A||(A={}));class g{constructor(f,e){this.f=f,this.g=e,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,k.$pf)(f,this.c.scheme);if(this.d[this.e]===2)return(0,k.$pf)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,k.$nf)(f,this.c.query);if(this.d[this.e]===5)return(0,k.$nf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$wi=g;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(p||(p={}));class O{static forUris(f=()=>!1,e=()=>!1){return new O(new g(f,e))}static forPaths(f=!1){return new O(new S(void 0,!f))}static forStrings(){return new O(new P)}static forConfigKeys(){return new O(new W)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,e){if(e){const n=e.slice(0);(0,i.$Xb)(n);for(const r of n)this.set(r,f)}else{const n=f.slice(0);(0,i.$Xb)(n);for(const r of n)this.set(r[0],r[1])}}set(f,e){const n=this.b.reset(f);let r;this.c||(this.c=new b,this.c.segment=n.value());const h=[];for(r=this.c;;){const y=n.cmp(r.segment);if(y>0)r.left||(r.left=new b,r.left.segment=n.value()),h.push([-1,r]),r=r.left;else if(y<0)r.right||(r.right=new b,r.right.segment=n.value()),h.push([1,r]),r=r.right;else if(n.hasNext())n.next(),r.mid||(r.mid=new b,r.mid.segment=n.value()),h.push([0,r]),r=r.mid;else break}const m=r.value;r.value=e,r.key=f;for(let y=h.length-1;y>=0;y--){const o=h[y][1];o.updateHeight();const d=o.balanceFactor();if(d<-1||d>1){const a=h[y][0],L=h[y+1][0];if(a===1&&L===1)h[y][1]=o.rotateLeft();else if(a===-1&&L===-1)h[y][1]=o.rotateRight();else if(a===1&&L===-1)o.right=h[y+1][1]=h[y+1][1].rotateRight(),h[y][1]=o.rotateLeft();else if(a===-1&&L===1)o.left=h[y+1][1]=h[y+1][1].rotateLeft(),h[y][1]=o.rotateRight();else throw new Error;if(y>0)switch(h[y-1][0]){case-1:h[y-1][1].left=h[y][1];break;case 1:h[y-1][1].right=h[y][1];break;case 0:h[y-1][1].mid=h[y][1];break}else this.c=h[0][1]}}return m}get(f){return this.d(f)?.value}d(f){const e=this.b.reset(f);let n=this.c;for(;n;){const r=e.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(e.hasNext())e.next(),n=n.mid;else break}return n}has(f){const e=this.d(f);return!(e?.value===void 0&&e?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,e){const n=this.b.reset(f),r=[];let h=this.c;for(;h;){const m=n.cmp(h.segment);if(m>0)r.push([-1,h]),h=h.left;else if(m<0)r.push([1,h]),h=h.right;else if(n.hasNext())n.next(),r.push([0,h]),h=h.mid;else break}if(h){if(e?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const m=this.f(h.right);if(m.key){const{key:y,value:o,segment:d}=m;this.e(m.key,!1),h.key=y,h.value=o,h.segment=d}}else{const m=h.left??h.right;if(r.length>0){const[y,o]=r[r.length-1];switch(y){case-1:o.left=m;break;case 0:o.mid=m;break;case 1:o.right=m;break}}else this.c=m}for(let m=r.length-1;m>=0;m--){const y=r[m][1];y.updateHeight();const o=y.balanceFactor();if(o>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),r[m][1]=y.rotateLeft()):o<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),r[m][1]=y.rotateRight()),m>0)switch(r[m-1][0]){case-1:r[m-1][1].left=r[m][1];break;case 1:r[m-1][1].right=r[m][1];break;case 0:r[m-1][1].mid=r[m][1];break}else this.c=r[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const e=this.b.reset(f);let n=this.c,r;for(;n;){const h=e.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(e.hasNext())e.next(),r=n.value||r,n=n.mid;else break}return n&&n.value||r}findSuperstr(f){return this.g(f,!1)}g(f,e){const n=this.b.reset(f);let r=this.c;for(;r;){const h=n.cmp(r.segment);if(h>0)r=r.left;else if(h<0)r=r.right;else if(n.hasNext())n.next(),r=r.mid;else return r.mid?this.h(r.mid):e?r.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[e,n]of this)f(n,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const e=[];return this.j(f,e),e[Symbol.iterator]()}j(f,e){f&&(f.left&&this.j(f.left,e),f.value&&e.push([f.key,f.value]),f.mid&&this.j(f.mid,e),f.right&&this.j(f.right,e))}_isBalanced(){const f=e=>{if(!e)return!0;const n=e.balanceFactor();return n<-1||n>1?!1:f(e.left)&&f(e.right)};return f(this.c)}}t.$xi=O}),define(me[10],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5f=i,t.$6f=k,t.$7f=P,t.$8f=W,t.$9f=S,t.$0f=A,t.$$f=g,t.$_f=b,t.$ag=p,t.$bg=O,t.$cg=c,t.$dg=f,t.$eg=e,t.$fg=r,t.$gg=h,t.$hg=m,t.$ig=y,t.$jg=o;function i(d){return typeof d=="string"}function k(d){return Array.isArray(d)&&d.every(a=>i(a))}function P(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}function W(d){const a=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof a}function S(d){return typeof d=="number"&&!isNaN(d)}function A(d){return!!d&&typeof d[Symbol.iterator]=="function"}function g(d){return d===!0||d===!1}function b(d){return typeof d>"u"}function p(d){return!O(d)}function O(d){return b(d)||d===null}function c(d,a){if(!d)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}function f(d){if(O(d))throw new Error("Assertion Failed: argument is undefined or null");return d}function e(...d){const a=[];for(let L=0;L<d.length;L++){const C=d[L];if(O(C))throw new Error(`Assertion Failed: argument at index ${L} is undefined or null`);a.push(C)}return a}const n=Object.prototype.hasOwnProperty;function r(d){if(!P(d))return!1;for(const a in d)if(n.call(d,a))return!1;return!0}function h(d){return typeof d=="function"}function m(...d){return d.length>0&&d.every(h)}function y(d,a){const L=Math.min(d.length,a.length);for(let C=0;C<L;C++)o(d[C],a[C])}function o(d,a){if(i(a)){if(typeof d!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(h(a)){try{if(d instanceof a)return}catch{}if(!O(d)&&d.constructor===a||a.length===1&&a.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(me[45],be([1,0,10]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lj=P,t.$Mj=W;const k=Object.create(null);function P(S,A){if((0,i.$5f)(A)){const g=k[A];if(g===void 0)throw new Error(`${S} references an unknown codicon: ${A}`);A=g}return k[S]=A,{id:S}}function W(){return k}}),define(me[100],be([1,0,45]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nj=void 0,t.$Nj={add:(0,i.$Lj)("add",6e4),plus:(0,i.$Lj)("plus",6e4),gistNew:(0,i.$Lj)("gist-new",6e4),repoCreate:(0,i.$Lj)("repo-create",6e4),lightbulb:(0,i.$Lj)("lightbulb",60001),lightBulb:(0,i.$Lj)("light-bulb",60001),repo:(0,i.$Lj)("repo",60002),repoDelete:(0,i.$Lj)("repo-delete",60002),gistFork:(0,i.$Lj)("gist-fork",60003),repoForked:(0,i.$Lj)("repo-forked",60003),gitPullRequest:(0,i.$Lj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Lj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Lj)("record-keys",60005),keyboard:(0,i.$Lj)("keyboard",60005),tag:(0,i.$Lj)("tag",60006),gitPullRequestLabel:(0,i.$Lj)("git-pull-request-label",60006),tagAdd:(0,i.$Lj)("tag-add",60006),tagRemove:(0,i.$Lj)("tag-remove",60006),person:(0,i.$Lj)("person",60007),personFollow:(0,i.$Lj)("person-follow",60007),personOutline:(0,i.$Lj)("person-outline",60007),personFilled:(0,i.$Lj)("person-filled",60007),gitBranch:(0,i.$Lj)("git-branch",60008),gitBranchCreate:(0,i.$Lj)("git-branch-create",60008),gitBranchDelete:(0,i.$Lj)("git-branch-delete",60008),sourceControl:(0,i.$Lj)("source-control",60008),mirror:(0,i.$Lj)("mirror",60009),mirrorPublic:(0,i.$Lj)("mirror-public",60009),star:(0,i.$Lj)("star",60010),starAdd:(0,i.$Lj)("star-add",60010),starDelete:(0,i.$Lj)("star-delete",60010),starEmpty:(0,i.$Lj)("star-empty",60010),comment:(0,i.$Lj)("comment",60011),commentAdd:(0,i.$Lj)("comment-add",60011),alert:(0,i.$Lj)("alert",60012),warning:(0,i.$Lj)("warning",60012),search:(0,i.$Lj)("search",60013),searchSave:(0,i.$Lj)("search-save",60013),logOut:(0,i.$Lj)("log-out",60014),signOut:(0,i.$Lj)("sign-out",60014),logIn:(0,i.$Lj)("log-in",60015),signIn:(0,i.$Lj)("sign-in",60015),eye:(0,i.$Lj)("eye",60016),eyeUnwatch:(0,i.$Lj)("eye-unwatch",60016),eyeWatch:(0,i.$Lj)("eye-watch",60016),circleFilled:(0,i.$Lj)("circle-filled",60017),primitiveDot:(0,i.$Lj)("primitive-dot",60017),closeDirty:(0,i.$Lj)("close-dirty",60017),debugBreakpoint:(0,i.$Lj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Lj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Lj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Lj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Lj)("primitive-square",60018),edit:(0,i.$Lj)("edit",60019),pencil:(0,i.$Lj)("pencil",60019),info:(0,i.$Lj)("info",60020),issueOpened:(0,i.$Lj)("issue-opened",60020),gistPrivate:(0,i.$Lj)("gist-private",60021),gitForkPrivate:(0,i.$Lj)("git-fork-private",60021),lock:(0,i.$Lj)("lock",60021),mirrorPrivate:(0,i.$Lj)("mirror-private",60021),close:(0,i.$Lj)("close",60022),removeClose:(0,i.$Lj)("remove-close",60022),x:(0,i.$Lj)("x",60022),repoSync:(0,i.$Lj)("repo-sync",60023),sync:(0,i.$Lj)("sync",60023),clone:(0,i.$Lj)("clone",60024),desktopDownload:(0,i.$Lj)("desktop-download",60024),beaker:(0,i.$Lj)("beaker",60025),microscope:(0,i.$Lj)("microscope",60025),vm:(0,i.$Lj)("vm",60026),deviceDesktop:(0,i.$Lj)("device-desktop",60026),file:(0,i.$Lj)("file",60027),fileText:(0,i.$Lj)("file-text",60027),more:(0,i.$Lj)("more",60028),ellipsis:(0,i.$Lj)("ellipsis",60028),kebabHorizontal:(0,i.$Lj)("kebab-horizontal",60028),mailReply:(0,i.$Lj)("mail-reply",60029),reply:(0,i.$Lj)("reply",60029),organization:(0,i.$Lj)("organization",60030),organizationFilled:(0,i.$Lj)("organization-filled",60030),organizationOutline:(0,i.$Lj)("organization-outline",60030),newFile:(0,i.$Lj)("new-file",60031),fileAdd:(0,i.$Lj)("file-add",60031),newFolder:(0,i.$Lj)("new-folder",60032),fileDirectoryCreate:(0,i.$Lj)("file-directory-create",60032),trash:(0,i.$Lj)("trash",60033),trashcan:(0,i.$Lj)("trashcan",60033),history:(0,i.$Lj)("history",60034),clock:(0,i.$Lj)("clock",60034),folder:(0,i.$Lj)("folder",60035),fileDirectory:(0,i.$Lj)("file-directory",60035),symbolFolder:(0,i.$Lj)("symbol-folder",60035),logoGithub:(0,i.$Lj)("logo-github",60036),markGithub:(0,i.$Lj)("mark-github",60036),github:(0,i.$Lj)("github",60036),terminal:(0,i.$Lj)("terminal",60037),console:(0,i.$Lj)("console",60037),repl:(0,i.$Lj)("repl",60037),zap:(0,i.$Lj)("zap",60038),symbolEvent:(0,i.$Lj)("symbol-event",60038),error:(0,i.$Lj)("error",60039),stop:(0,i.$Lj)("stop",60039),variable:(0,i.$Lj)("variable",60040),symbolVariable:(0,i.$Lj)("symbol-variable",60040),array:(0,i.$Lj)("array",60042),symbolArray:(0,i.$Lj)("symbol-array",60042),symbolModule:(0,i.$Lj)("symbol-module",60043),symbolPackage:(0,i.$Lj)("symbol-package",60043),symbolNamespace:(0,i.$Lj)("symbol-namespace",60043),symbolObject:(0,i.$Lj)("symbol-object",60043),symbolMethod:(0,i.$Lj)("symbol-method",60044),symbolFunction:(0,i.$Lj)("symbol-function",60044),symbolConstructor:(0,i.$Lj)("symbol-constructor",60044),symbolBoolean:(0,i.$Lj)("symbol-boolean",60047),symbolNull:(0,i.$Lj)("symbol-null",60047),symbolNumeric:(0,i.$Lj)("symbol-numeric",60048),symbolNumber:(0,i.$Lj)("symbol-number",60048),symbolStructure:(0,i.$Lj)("symbol-structure",60049),symbolStruct:(0,i.$Lj)("symbol-struct",60049),symbolParameter:(0,i.$Lj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Lj)("symbol-type-parameter",60050),symbolKey:(0,i.$Lj)("symbol-key",60051),symbolText:(0,i.$Lj)("symbol-text",60051),symbolReference:(0,i.$Lj)("symbol-reference",60052),goToFile:(0,i.$Lj)("go-to-file",60052),symbolEnum:(0,i.$Lj)("symbol-enum",60053),symbolValue:(0,i.$Lj)("symbol-value",60053),symbolRuler:(0,i.$Lj)("symbol-ruler",60054),symbolUnit:(0,i.$Lj)("symbol-unit",60054),activateBreakpoints:(0,i.$Lj)("activate-breakpoints",60055),archive:(0,i.$Lj)("archive",60056),arrowBoth:(0,i.$Lj)("arrow-both",60057),arrowDown:(0,i.$Lj)("arrow-down",60058),arrowLeft:(0,i.$Lj)("arrow-left",60059),arrowRight:(0,i.$Lj)("arrow-right",60060),arrowSmallDown:(0,i.$Lj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Lj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Lj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Lj)("arrow-small-up",60064),arrowUp:(0,i.$Lj)("arrow-up",60065),bell:(0,i.$Lj)("bell",60066),bold:(0,i.$Lj)("bold",60067),book:(0,i.$Lj)("book",60068),bookmark:(0,i.$Lj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Lj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Lj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Lj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Lj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Lj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Lj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Lj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Lj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Lj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Lj)("briefcase",60076),broadcast:(0,i.$Lj)("broadcast",60077),browser:(0,i.$Lj)("browser",60078),bug:(0,i.$Lj)("bug",60079),calendar:(0,i.$Lj)("calendar",60080),caseSensitive:(0,i.$Lj)("case-sensitive",60081),check:(0,i.$Lj)("check",60082),checklist:(0,i.$Lj)("checklist",60083),chevronDown:(0,i.$Lj)("chevron-down",60084),chevronLeft:(0,i.$Lj)("chevron-left",60085),chevronRight:(0,i.$Lj)("chevron-right",60086),chevronUp:(0,i.$Lj)("chevron-up",60087),chromeClose:(0,i.$Lj)("chrome-close",60088),chromeMaximize:(0,i.$Lj)("chrome-maximize",60089),chromeMinimize:(0,i.$Lj)("chrome-minimize",60090),chromeRestore:(0,i.$Lj)("chrome-restore",60091),circleOutline:(0,i.$Lj)("circle-outline",60092),circle:(0,i.$Lj)("circle",60092),debugBreakpointUnverified:(0,i.$Lj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Lj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Lj)("circle-slash",60093),circuitBoard:(0,i.$Lj)("circuit-board",60094),clearAll:(0,i.$Lj)("clear-all",60095),clippy:(0,i.$Lj)("clippy",60096),closeAll:(0,i.$Lj)("close-all",60097),cloudDownload:(0,i.$Lj)("cloud-download",60098),cloudUpload:(0,i.$Lj)("cloud-upload",60099),code:(0,i.$Lj)("code",60100),collapseAll:(0,i.$Lj)("collapse-all",60101),colorMode:(0,i.$Lj)("color-mode",60102),commentDiscussion:(0,i.$Lj)("comment-discussion",60103),creditCard:(0,i.$Lj)("credit-card",60105),dash:(0,i.$Lj)("dash",60108),dashboard:(0,i.$Lj)("dashboard",60109),database:(0,i.$Lj)("database",60110),debugContinue:(0,i.$Lj)("debug-continue",60111),debugDisconnect:(0,i.$Lj)("debug-disconnect",60112),debugPause:(0,i.$Lj)("debug-pause",60113),debugRestart:(0,i.$Lj)("debug-restart",60114),debugStart:(0,i.$Lj)("debug-start",60115),debugStepInto:(0,i.$Lj)("debug-step-into",60116),debugStepOut:(0,i.$Lj)("debug-step-out",60117),debugStepOver:(0,i.$Lj)("debug-step-over",60118),debugStop:(0,i.$Lj)("debug-stop",60119),debug:(0,i.$Lj)("debug",60120),deviceCameraVideo:(0,i.$Lj)("device-camera-video",60121),deviceCamera:(0,i.$Lj)("device-camera",60122),deviceMobile:(0,i.$Lj)("device-mobile",60123),diffAdded:(0,i.$Lj)("diff-added",60124),diffIgnored:(0,i.$Lj)("diff-ignored",60125),diffModified:(0,i.$Lj)("diff-modified",60126),diffRemoved:(0,i.$Lj)("diff-removed",60127),diffRenamed:(0,i.$Lj)("diff-renamed",60128),diff:(0,i.$Lj)("diff",60129),diffSidebyside:(0,i.$Lj)("diff-sidebyside",60129),discard:(0,i.$Lj)("discard",60130),editorLayout:(0,i.$Lj)("editor-layout",60131),emptyWindow:(0,i.$Lj)("empty-window",60132),exclude:(0,i.$Lj)("exclude",60133),extensions:(0,i.$Lj)("extensions",60134),eyeClosed:(0,i.$Lj)("eye-closed",60135),fileBinary:(0,i.$Lj)("file-binary",60136),fileCode:(0,i.$Lj)("file-code",60137),fileMedia:(0,i.$Lj)("file-media",60138),filePdf:(0,i.$Lj)("file-pdf",60139),fileSubmodule:(0,i.$Lj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Lj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Lj)("file-symlink-file",60142),fileZip:(0,i.$Lj)("file-zip",60143),files:(0,i.$Lj)("files",60144),filter:(0,i.$Lj)("filter",60145),flame:(0,i.$Lj)("flame",60146),foldDown:(0,i.$Lj)("fold-down",60147),foldUp:(0,i.$Lj)("fold-up",60148),fold:(0,i.$Lj)("fold",60149),folderActive:(0,i.$Lj)("folder-active",60150),folderOpened:(0,i.$Lj)("folder-opened",60151),gear:(0,i.$Lj)("gear",60152),gift:(0,i.$Lj)("gift",60153),gistSecret:(0,i.$Lj)("gist-secret",60154),gist:(0,i.$Lj)("gist",60155),gitCommit:(0,i.$Lj)("git-commit",60156),gitCompare:(0,i.$Lj)("git-compare",60157),compareChanges:(0,i.$Lj)("compare-changes",60157),gitMerge:(0,i.$Lj)("git-merge",60158),githubAction:(0,i.$Lj)("github-action",60159),githubAlt:(0,i.$Lj)("github-alt",60160),globe:(0,i.$Lj)("globe",60161),grabber:(0,i.$Lj)("grabber",60162),graph:(0,i.$Lj)("graph",60163),gripper:(0,i.$Lj)("gripper",60164),heart:(0,i.$Lj)("heart",60165),home:(0,i.$Lj)("home",60166),horizontalRule:(0,i.$Lj)("horizontal-rule",60167),hubot:(0,i.$Lj)("hubot",60168),inbox:(0,i.$Lj)("inbox",60169),issueReopened:(0,i.$Lj)("issue-reopened",60171),issues:(0,i.$Lj)("issues",60172),italic:(0,i.$Lj)("italic",60173),jersey:(0,i.$Lj)("jersey",60174),json:(0,i.$Lj)("json",60175),kebabVertical:(0,i.$Lj)("kebab-vertical",60176),key:(0,i.$Lj)("key",60177),law:(0,i.$Lj)("law",60178),lightbulbAutofix:(0,i.$Lj)("lightbulb-autofix",60179),linkExternal:(0,i.$Lj)("link-external",60180),link:(0,i.$Lj)("link",60181),listOrdered:(0,i.$Lj)("list-ordered",60182),listUnordered:(0,i.$Lj)("list-unordered",60183),liveShare:(0,i.$Lj)("live-share",60184),loading:(0,i.$Lj)("loading",60185),location:(0,i.$Lj)("location",60186),mailRead:(0,i.$Lj)("mail-read",60187),mail:(0,i.$Lj)("mail",60188),markdown:(0,i.$Lj)("markdown",60189),megaphone:(0,i.$Lj)("megaphone",60190),mention:(0,i.$Lj)("mention",60191),milestone:(0,i.$Lj)("milestone",60192),gitPullRequestMilestone:(0,i.$Lj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Lj)("mortar-board",60193),move:(0,i.$Lj)("move",60194),multipleWindows:(0,i.$Lj)("multiple-windows",60195),mute:(0,i.$Lj)("mute",60196),noNewline:(0,i.$Lj)("no-newline",60197),note:(0,i.$Lj)("note",60198),octoface:(0,i.$Lj)("octoface",60199),openPreview:(0,i.$Lj)("open-preview",60200),package:(0,i.$Lj)("package",60201),paintcan:(0,i.$Lj)("paintcan",60202),pin:(0,i.$Lj)("pin",60203),play:(0,i.$Lj)("play",60204),run:(0,i.$Lj)("run",60204),plug:(0,i.$Lj)("plug",60205),preserveCase:(0,i.$Lj)("preserve-case",60206),preview:(0,i.$Lj)("preview",60207),project:(0,i.$Lj)("project",60208),pulse:(0,i.$Lj)("pulse",60209),question:(0,i.$Lj)("question",60210),quote:(0,i.$Lj)("quote",60211),radioTower:(0,i.$Lj)("radio-tower",60212),reactions:(0,i.$Lj)("reactions",60213),references:(0,i.$Lj)("references",60214),refresh:(0,i.$Lj)("refresh",60215),regex:(0,i.$Lj)("regex",60216),remoteExplorer:(0,i.$Lj)("remote-explorer",60217),remote:(0,i.$Lj)("remote",60218),remove:(0,i.$Lj)("remove",60219),replaceAll:(0,i.$Lj)("replace-all",60220),replace:(0,i.$Lj)("replace",60221),repoClone:(0,i.$Lj)("repo-clone",60222),repoForcePush:(0,i.$Lj)("repo-force-push",60223),repoPull:(0,i.$Lj)("repo-pull",60224),repoPush:(0,i.$Lj)("repo-push",60225),report:(0,i.$Lj)("report",60226),requestChanges:(0,i.$Lj)("request-changes",60227),rocket:(0,i.$Lj)("rocket",60228),rootFolderOpened:(0,i.$Lj)("root-folder-opened",60229),rootFolder:(0,i.$Lj)("root-folder",60230),rss:(0,i.$Lj)("rss",60231),ruby:(0,i.$Lj)("ruby",60232),saveAll:(0,i.$Lj)("save-all",60233),saveAs:(0,i.$Lj)("save-as",60234),save:(0,i.$Lj)("save",60235),screenFull:(0,i.$Lj)("screen-full",60236),screenNormal:(0,i.$Lj)("screen-normal",60237),searchStop:(0,i.$Lj)("search-stop",60238),server:(0,i.$Lj)("server",60240),settingsGear:(0,i.$Lj)("settings-gear",60241),settings:(0,i.$Lj)("settings",60242),shield:(0,i.$Lj)("shield",60243),smiley:(0,i.$Lj)("smiley",60244),sortPrecedence:(0,i.$Lj)("sort-precedence",60245),splitHorizontal:(0,i.$Lj)("split-horizontal",60246),splitVertical:(0,i.$Lj)("split-vertical",60247),squirrel:(0,i.$Lj)("squirrel",60248),starFull:(0,i.$Lj)("star-full",60249),starHalf:(0,i.$Lj)("star-half",60250),symbolClass:(0,i.$Lj)("symbol-class",60251),symbolColor:(0,i.$Lj)("symbol-color",60252),symbolConstant:(0,i.$Lj)("symbol-constant",60253),symbolEnumMember:(0,i.$Lj)("symbol-enum-member",60254),symbolField:(0,i.$Lj)("symbol-field",60255),symbolFile:(0,i.$Lj)("symbol-file",60256),symbolInterface:(0,i.$Lj)("symbol-interface",60257),symbolKeyword:(0,i.$Lj)("symbol-keyword",60258),symbolMisc:(0,i.$Lj)("symbol-misc",60259),symbolOperator:(0,i.$Lj)("symbol-operator",60260),symbolProperty:(0,i.$Lj)("symbol-property",60261),wrench:(0,i.$Lj)("wrench",60261),wrenchSubaction:(0,i.$Lj)("wrench-subaction",60261),symbolSnippet:(0,i.$Lj)("symbol-snippet",60262),tasklist:(0,i.$Lj)("tasklist",60263),telescope:(0,i.$Lj)("telescope",60264),textSize:(0,i.$Lj)("text-size",60265),threeBars:(0,i.$Lj)("three-bars",60266),thumbsdown:(0,i.$Lj)("thumbsdown",60267),thumbsup:(0,i.$Lj)("thumbsup",60268),tools:(0,i.$Lj)("tools",60269),triangleDown:(0,i.$Lj)("triangle-down",60270),triangleLeft:(0,i.$Lj)("triangle-left",60271),triangleRight:(0,i.$Lj)("triangle-right",60272),triangleUp:(0,i.$Lj)("triangle-up",60273),twitter:(0,i.$Lj)("twitter",60274),unfold:(0,i.$Lj)("unfold",60275),unlock:(0,i.$Lj)("unlock",60276),unmute:(0,i.$Lj)("unmute",60277),unverified:(0,i.$Lj)("unverified",60278),verified:(0,i.$Lj)("verified",60279),versions:(0,i.$Lj)("versions",60280),vmActive:(0,i.$Lj)("vm-active",60281),vmOutline:(0,i.$Lj)("vm-outline",60282),vmRunning:(0,i.$Lj)("vm-running",60283),watch:(0,i.$Lj)("watch",60284),whitespace:(0,i.$Lj)("whitespace",60285),wholeWord:(0,i.$Lj)("whole-word",60286),window:(0,i.$Lj)("window",60287),wordWrap:(0,i.$Lj)("word-wrap",60288),zoomIn:(0,i.$Lj)("zoom-in",60289),zoomOut:(0,i.$Lj)("zoom-out",60290),listFilter:(0,i.$Lj)("list-filter",60291),listFlat:(0,i.$Lj)("list-flat",60292),listSelection:(0,i.$Lj)("list-selection",60293),selection:(0,i.$Lj)("selection",60293),listTree:(0,i.$Lj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Lj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Lj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Lj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Lj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Lj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Lj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Lj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Lj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Lj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Lj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Lj)("symbol-string",60301),debugReverseContinue:(0,i.$Lj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Lj)("debug-step-back",60303),debugRestartFrame:(0,i.$Lj)("debug-restart-frame",60304),debugAlt:(0,i.$Lj)("debug-alt",60305),callIncoming:(0,i.$Lj)("call-incoming",60306),callOutgoing:(0,i.$Lj)("call-outgoing",60307),menu:(0,i.$Lj)("menu",60308),expandAll:(0,i.$Lj)("expand-all",60309),feedback:(0,i.$Lj)("feedback",60310),gitPullRequestReviewer:(0,i.$Lj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Lj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Lj)("ungroup-by-ref-type",60312),account:(0,i.$Lj)("account",60313),gitPullRequestAssignee:(0,i.$Lj)("git-pull-request-assignee",60313),bellDot:(0,i.$Lj)("bell-dot",60314),debugConsole:(0,i.$Lj)("debug-console",60315),library:(0,i.$Lj)("library",60316),output:(0,i.$Lj)("output",60317),runAll:(0,i.$Lj)("run-all",60318),syncIgnored:(0,i.$Lj)("sync-ignored",60319),pinned:(0,i.$Lj)("pinned",60320),githubInverted:(0,i.$Lj)("github-inverted",60321),serverProcess:(0,i.$Lj)("server-process",60322),serverEnvironment:(0,i.$Lj)("server-environment",60323),pass:(0,i.$Lj)("pass",60324),issueClosed:(0,i.$Lj)("issue-closed",60324),stopCircle:(0,i.$Lj)("stop-circle",60325),playCircle:(0,i.$Lj)("play-circle",60326),record:(0,i.$Lj)("record",60327),debugAltSmall:(0,i.$Lj)("debug-alt-small",60328),vmConnect:(0,i.$Lj)("vm-connect",60329),cloud:(0,i.$Lj)("cloud",60330),merge:(0,i.$Lj)("merge",60331),export:(0,i.$Lj)("export",60332),graphLeft:(0,i.$Lj)("graph-left",60333),magnet:(0,i.$Lj)("magnet",60334),notebook:(0,i.$Lj)("notebook",60335),redo:(0,i.$Lj)("redo",60336),checkAll:(0,i.$Lj)("check-all",60337),pinnedDirty:(0,i.$Lj)("pinned-dirty",60338),passFilled:(0,i.$Lj)("pass-filled",60339),circleLargeFilled:(0,i.$Lj)("circle-large-filled",60340),circleLarge:(0,i.$Lj)("circle-large",60341),circleLargeOutline:(0,i.$Lj)("circle-large-outline",60341),combine:(0,i.$Lj)("combine",60342),gather:(0,i.$Lj)("gather",60342),table:(0,i.$Lj)("table",60343),variableGroup:(0,i.$Lj)("variable-group",60344),typeHierarchy:(0,i.$Lj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Lj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Lj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Lj)("git-pull-request-create",60348),runAbove:(0,i.$Lj)("run-above",60349),runBelow:(0,i.$Lj)("run-below",60350),notebookTemplate:(0,i.$Lj)("notebook-template",60351),debugRerun:(0,i.$Lj)("debug-rerun",60352),workspaceTrusted:(0,i.$Lj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Lj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Lj)("workspace-unknown",60355),terminalCmd:(0,i.$Lj)("terminal-cmd",60356),terminalDebian:(0,i.$Lj)("terminal-debian",60357),terminalLinux:(0,i.$Lj)("terminal-linux",60358),terminalPowershell:(0,i.$Lj)("terminal-powershell",60359),terminalTmux:(0,i.$Lj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Lj)("terminal-ubuntu",60361),terminalBash:(0,i.$Lj)("terminal-bash",60362),arrowSwap:(0,i.$Lj)("arrow-swap",60363),copy:(0,i.$Lj)("copy",60364),personAdd:(0,i.$Lj)("person-add",60365),filterFilled:(0,i.$Lj)("filter-filled",60366),wand:(0,i.$Lj)("wand",60367),debugLineByLine:(0,i.$Lj)("debug-line-by-line",60368),inspect:(0,i.$Lj)("inspect",60369),layers:(0,i.$Lj)("layers",60370),layersDot:(0,i.$Lj)("layers-dot",60371),layersActive:(0,i.$Lj)("layers-active",60372),compass:(0,i.$Lj)("compass",60373),compassDot:(0,i.$Lj)("compass-dot",60374),compassActive:(0,i.$Lj)("compass-active",60375),azure:(0,i.$Lj)("azure",60376),issueDraft:(0,i.$Lj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Lj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Lj)("git-pull-request-draft",60379),debugAll:(0,i.$Lj)("debug-all",60380),debugCoverage:(0,i.$Lj)("debug-coverage",60381),runErrors:(0,i.$Lj)("run-errors",60382),folderLibrary:(0,i.$Lj)("folder-library",60383),debugContinueSmall:(0,i.$Lj)("debug-continue-small",60384),beakerStop:(0,i.$Lj)("beaker-stop",60385),graphLine:(0,i.$Lj)("graph-line",60386),graphScatter:(0,i.$Lj)("graph-scatter",60387),pieChart:(0,i.$Lj)("pie-chart",60388),bracket:(0,i.$Lj)("bracket",60175),bracketDot:(0,i.$Lj)("bracket-dot",60389),bracketError:(0,i.$Lj)("bracket-error",60390),lockSmall:(0,i.$Lj)("lock-small",60391),azureDevops:(0,i.$Lj)("azure-devops",60392),verifiedFilled:(0,i.$Lj)("verified-filled",60393),newline:(0,i.$Lj)("newline",60394),layout:(0,i.$Lj)("layout",60395),layoutActivitybarLeft:(0,i.$Lj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Lj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Lj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Lj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Lj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Lj)("layout-panel-right",60401),layoutPanel:(0,i.$Lj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Lj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Lj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Lj)("layout-statusbar",60405),layoutMenubar:(0,i.$Lj)("layout-menubar",60406),layoutCentered:(0,i.$Lj)("layout-centered",60407),target:(0,i.$Lj)("target",60408),indent:(0,i.$Lj)("indent",60409),recordSmall:(0,i.$Lj)("record-small",60410),errorSmall:(0,i.$Lj)("error-small",60411),terminalDecorationError:(0,i.$Lj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Lj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Lj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Lj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Lj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Lj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Lj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Lj)("layout-sidebar-left-off",60418),blank:(0,i.$Lj)("blank",60419),heartFilled:(0,i.$Lj)("heart-filled",60420),map:(0,i.$Lj)("map",60421),mapHorizontal:(0,i.$Lj)("map-horizontal",60421),foldHorizontal:(0,i.$Lj)("fold-horizontal",60421),mapFilled:(0,i.$Lj)("map-filled",60422),mapHorizontalFilled:(0,i.$Lj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Lj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Lj)("circle-small",60423),bellSlash:(0,i.$Lj)("bell-slash",60424),bellSlashDot:(0,i.$Lj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Lj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Lj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Lj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Lj)("search-fuzzy",60429),commentDraft:(0,i.$Lj)("comment-draft",60430),send:(0,i.$Lj)("send",60431),sparkle:(0,i.$Lj)("sparkle",60432),insert:(0,i.$Lj)("insert",60433),mic:(0,i.$Lj)("mic",60434),thumbsdownFilled:(0,i.$Lj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Lj)("thumbsup-filled",60436),coffee:(0,i.$Lj)("coffee",60437),snake:(0,i.$Lj)("snake",60438),game:(0,i.$Lj)("game",60439),vr:(0,i.$Lj)("vr",60440),chip:(0,i.$Lj)("chip",60441),piano:(0,i.$Lj)("piano",60442),music:(0,i.$Lj)("music",60443),micFilled:(0,i.$Lj)("mic-filled",60444),repoFetch:(0,i.$Lj)("repo-fetch",60445),copilot:(0,i.$Lj)("copilot",60446),lightbulbSparkle:(0,i.$Lj)("lightbulb-sparkle",60447),robot:(0,i.$Lj)("robot",60448),sparkleFilled:(0,i.$Lj)("sparkle-filled",60449),diffSingle:(0,i.$Lj)("diff-single",60450),diffMultiple:(0,i.$Lj)("diff-multiple",60451),surroundWith:(0,i.$Lj)("surround-with",60452),share:(0,i.$Lj)("share",60453),gitStash:(0,i.$Lj)("git-stash",60454),gitStashApply:(0,i.$Lj)("git-stash-apply",60455),gitStashPop:(0,i.$Lj)("git-stash-pop",60456),vscode:(0,i.$Lj)("vscode",60457),vscodeInsiders:(0,i.$Lj)("vscode-insiders",60458),codeOss:(0,i.$Lj)("code-oss",60459),runCoverage:(0,i.$Lj)("run-coverage",60460),runAllCoverage:(0,i.$Lj)("run-all-coverage",60461),coverage:(0,i.$Lj)("coverage",60462),githubProject:(0,i.$Lj)("github-project",60463),mapVertical:(0,i.$Lj)("map-vertical",60464),foldVertical:(0,i.$Lj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Lj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Lj)("fold-vertical-filled",60465),goToSearch:(0,i.$Lj)("go-to-search",60466),percentage:(0,i.$Lj)("percentage",60467),sortPercentage:(0,i.$Lj)("sort-percentage",60467)}}),define(me[18],be([1,0,45,100]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qj=t.$Pj=void 0,t.$Oj=P;function P(){return Object.values(t.$Qj)}t.$Pj={dialogError:(0,i.$Lj)("dialog-error","error"),dialogWarning:(0,i.$Lj)("dialog-warning","warning"),dialogInfo:(0,i.$Lj)("dialog-info","info"),dialogClose:(0,i.$Lj)("dialog-close","close"),treeItemExpanded:(0,i.$Lj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Lj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Lj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Lj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Lj)("tree-item-loading","loading"),menuSelection:(0,i.$Lj)("menu-selection","check"),menuSubmenu:(0,i.$Lj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Lj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Lj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Lj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Lj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Lj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Lj)("toolbar-more","more"),quickInputBack:(0,i.$Lj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Lj)("drop-down-button",60084),symbolCustomColor:(0,i.$Lj)("symbol-customcolor",60252),exportIcon:(0,i.$Lj)("export",60332),workspaceUnspecified:(0,i.$Lj)("workspace-unspecified",60355),newLine:(0,i.$Lj)("newline",60394),thumbsDownFilled:(0,i.$Lj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Lj)("thumbsup-filled",60436),gitFetch:(0,i.$Lj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Lj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Lj)("debug-breakpoint-pending",60377)},t.$Qj={...k.$Nj,...t.$Pj}}),define(me[61],be([1,0,10]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xn=k,t.$Yn=P,t.$Zn=S,t.$1n=g,t.$2n=b,t.$3n=p,t.$4n=O,t.$5n=c,t.$6n=f,t.$7n=e,t.$8n=n,t.$9n=r;function k(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const m=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([y,o])=>{m[y]=o&&typeof o=="object"?k(o):o}),m}function P(h){if(!h||typeof h!="object")return h;const m=[h];for(;m.length>0;){const y=m.shift();Object.freeze(y);for(const o in y)if(W.call(y,o)){const d=y[o];typeof d=="object"&&!Object.isFrozen(d)&&!(0,i.$8f)(d)&&m.push(d)}}return h}const W=Object.prototype.hasOwnProperty;function S(h,m){return A(h,m,new Set)}function A(h,m,y){if((0,i.$bg)(h))return h;const o=m(h);if(typeof o<"u")return o;if(Array.isArray(h)){const d=[];for(const a of h)d.push(A(a,m,y));return d}if((0,i.$7f)(h)){if(y.has(h))throw new Error("Cannot clone recursive data-structure");y.add(h);const d={};for(const a in h)W.call(h,a)&&(d[a]=A(h[a],m,y));return y.delete(h),d}return h}function g(h,m,y=!0){return(0,i.$7f)(h)?((0,i.$7f)(m)&&Object.keys(m).forEach(o=>{o in h?y&&((0,i.$7f)(h[o])&&(0,i.$7f)(m[o])?g(h[o],m[o],y):h[o]=m[o]):h[o]=m[o]}),h):m}function b(h,m){if(h===m)return!0;if(h==null||m===null||m===void 0||typeof h!=typeof m||typeof h!="object"||Array.isArray(h)!==Array.isArray(m))return!1;let y,o;if(Array.isArray(h)){if(h.length!==m.length)return!1;for(y=0;y<h.length;y++)if(!b(h[y],m[y]))return!1}else{const d=[];for(o in h)d.push(o);d.sort();const a=[];for(o in m)a.push(o);if(a.sort(),!b(d,a))return!1;for(y=0;y<d.length;y++)if(!b(h[d[y]],m[d[y]]))return!1}return!0}function p(h){const m=new Set;return JSON.stringify(h,(y,o)=>{if((0,i.$7f)(o)||Array.isArray(o)){if(m.has(o))return"[Circular]";m.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function O(h,m){const y=Object.create(null);return!h||!m||Object.keys(m).forEach(d=>{const a=h[d],L=m[d];b(a,L)||(y[d]=L)}),y}function c(h,m){const y=m.toLowerCase(),o=Object.keys(h).find(d=>d.toLowerCase()===y);return o?h[o]:h[m]}function f(h,m){const y=Object.create(null);for(const[o,d]of Object.entries(h))m(o,d)&&(y[o]=d);return y}function e(h){let m=[];for(;Object.prototype!==h;)m=m.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return m}function n(h){const m=[];for(const y of e(h))typeof h[y]=="function"&&m.push(y);return m}function r(h,m){const y=d=>function(){const a=Array.prototype.slice.call(arguments,0);return m(d,a)},o={};for(const d of h)o[d]=y(d);return o}}),define(me[19],be([1,0,18]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$Rj=P;var k;(function(S){function A(g){return g&&typeof g=="object"&&typeof g.id=="string"}S.isThemeColor=A})(k||(t.ThemeColor=k={}));function P(S){return{id:S}}var W;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function g(m){const y=A.exec(m.id);if(!y)return g(i.$Qj.error);const[,o,d]=y,a=["codicon","codicon-"+o];return d&&a.push("codicon-modifier-"+d.substring(1)),a}S.asClassNameArray=g;function b(m){return g(m).join(" ")}S.asClassName=b;function p(m){return"."+g(m).join(".")}S.asCSSSelector=p;function O(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||k.isThemeColor(m.color))}S.isThemeIcon=O;const c=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function f(m){const y=c.exec(m);if(!y)return;const[,o]=y;return{id:o}}S.fromString=f;function e(m){return{id:m}}S.fromId=e;function n(m,y){let o=m.id;const d=o.lastIndexOf("~");return d!==-1&&(o=o.substring(0,d)),y&&(o=`${o}~${y}`),{id:o}}S.modify=n;function r(m){const y=m.id.lastIndexOf("~");if(y!==-1)return m.id.substring(y+1)}S.getModifier=r;function h(m,y){return m.id===y.id&&m.color?.id===y.color?.id}S.isEqual=h})(W||(t.ThemeIcon=W={}))}),define(me[62],be([1,0,44,9,19]),function(se,t,i,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ik=g,t.$Jk=p,t.$Kk=c,t.$Lk=f,t.$Mk=n,t.$Nk=r;const W="$(",S=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${S.source}`,"g");function g(h){return h.replace(A,(m,y)=>y?m:`\\${m}`)}const b=new RegExp(`\\\\${S.source}`,"g");function p(h){return h.replace(b,m=>`\\${m}`)}const O=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function c(h){return h.indexOf(W)===-1?h:h.replace(O,(m,y,o,d)=>o?m:y||d||"")}function f(h){return h?h.replace(/\$\((.*?)\)/g,(m,y)=>` ${y} `).trim():""}const e=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(h){e.lastIndex=0;let m="";const y=[];let o=0;for(;;){const d=e.lastIndex,a=e.exec(h),L=h.substring(d,a?.index);if(L.length>0){m+=L;for(let C=0;C<L.length;C++)y.push(o)}if(!a)break;o+=a[0].length}return{text:m,iconOffsets:y}}function r(h,m,y=!1){const{text:o,iconOffsets:d}=m;if(!d||d.length===0)return(0,i.$zk)(h,o,y);const a=(0,k.$bf)(o," "),L=o.length-a.length,C=(0,i.$zk)(h,a,y);if(C)for(const N of C){const I=d[N.start+L]+L;N.start+=I,N.end+=I}return C}}),define(me[101],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FW=t.$EW=void 0,t.$EW="vscode:contextmenu",t.$FW="vscode:onCloseContextMenu"}),define(me[102],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MW=void 0;class i{constructor(P,W){this.a=P,this.onMessage=W}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$MW=i}),define(me[35],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const i=globalThis.vscode;t.$O=i.ipcRenderer,t.$P=i.ipcMessagePort,t.$Q=i.webFrame,t.$R=i.process,t.$S=i.context}),define(me[103],be([1,0,101,35]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IW=W;let P=0;function W(A,g,b){const p=[],O=P++,c=`vscode:onContextMenu${O}`,f=(e,n,r)=>{p[n].click?.(r)};k.$O.once(c,f),k.$O.once(i.$FW,(e,n)=>{n===O&&(k.$O.removeListener(c,f),b?.())}),k.$O.send(i.$EW,O,A.map(e=>S(e,p)),c,g)}function S(A,g){const b={id:g.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return g.push(A),Array.isArray(A.submenu)&&(b.submenu=A.submenu.map(p=>S(p,g))),b}}),define(me[63],be([7]),{}),define(me[104],be([7]),{}),define(me[105],be([7]),{}),define(me[106],be([7]),{}),define(me[107],be([1,0,105,106]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(me[108],be([7]),{}),define(me[109],be([7]),{}),define(me[110],be([7]),{}),define(me[111],be([7]),{}),define(me[112],be([7]),{}),define(me[113],be([7]),{}),define(me[114],be([7]),{}),define(me[115],be([7]),{}),define(me[116],be([7]),{}),define(me[117],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[118],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[119],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[120],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[121],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[122],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[123],be([13,12]),function(se,t){return se.create("vs/base/common/actions",t)}),define(me[46],be([1,0,3,2,123]),function(se,t,i,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aj=t.$_i=t.$$i=t.$0i=t.$9i=void 0,t.$bj=p;class W extends k.$Uc{constructor(c,f="",e="",n=!0,r){super(),this.h=this.B(new i.$be),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=f,this.u=e,this.w=n,this.C=r}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,f){this.C&&await this.C(c)}}t.$9i=W;class S extends k.$Uc{constructor(){super(...arguments),this.f=this.B(new i.$be),this.onWillRun=this.f.event,this.m=this.B(new i.$be),this.onDidRun=this.m.event}async run(c,f){if(!c.enabled)return;this.f.fire({action:c});let e;try{await this.u(c,f)}catch(n){e=n}this.m.fire({action:c,error:e})}async u(c,f){await c.run(f)}}t.$0i=S;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let f=[];for(const e of c)e.length&&(f.length?f=[...f,new A,...e]:f=e);return f}static{this.ID="vs.actions.separator"}async run(){}}t.$$i=A;class g{get actions(){return this.a}constructor(c,f,e,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=f,this.class=n,this.a=e}async run(){}}t.$_i=g;class b extends W{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,P.localize(0,null),void 0,!1)}}t.$aj=b;function p(O){return{id:O.id,label:O.label,class:O.class,enabled:O.enabled??!0,checked:O.checked,run:async(...c)=>O.run(...c),tooltip:O.label}}}),define(me[124],be([13,12]),function(se,t){return se.create("vs/base/common/platform",t)}),define(me[5],be([1,0,124]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=L,t.$D=z,t.$J=q,t.$g="en";let k=!1,P=!1,W=!1,S=!1,A=!1,g=!1,b=!1,p=!1,O=!1,c=!1,f,e=t.$g,n=t.$g,r,h;const m=globalThis;let y;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?y=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(y=process);const o=typeof y?.versions?.electron=="string",d=o&&y?.type==="renderer";if(typeof y=="object"){k=y.platform==="win32",P=y.platform==="darwin",W=y.platform==="linux",S=W&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,b=o,O=!!y.env.CI||!!y.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t.$g,e=t.$g;const F=y.env.VSCODE_NLS_CONFIG;if(F)try{const x=JSON.parse(F),B=x.availableLanguages["*"];f=x.locale,n=x.osLocale,e=B||t.$g,r=x._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!d?(h=navigator.userAgent,k=h.indexOf("Windows")>=0,P=h.indexOf("Macintosh")>=0,p=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=h.indexOf("Linux")>=0,c=h?.indexOf("Mobi")>=0,g=!0,f=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=f,n=navigator.language):console.error("Unable to resolve platform.");var a;(function(F){F[F.Web=0]="Web",F[F.Mac=1]="Mac",F[F.Linux=2]="Linux",F[F.Windows=3]="Windows"})(a||(t.Platform=a={}));function L(F){switch(F){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let C=0;P?C=1:k?C=3:W&&(C=2),t.$i=k,t.$j=P,t.$k=W,t.$l=S,t.$m=A,t.$n=b,t.$o=g,t.$p=g&&typeof m.importScripts=="function",t.$q=t.$p?m.origin:void 0,t.$r=p,t.$s=c,t.$t=O,t.$u=C,t.$v=h,t.$w=e;var N;(function(F){function x(){return t.$w}F.value=x;function B(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}F.isDefaultVariant=B;function Y(){return t.$w==="en"}F.isDefault=Y})(N||(t.Language=N={})),t.$x=f,t.$y=n,t.$z=r,t.$A=typeof m.postMessage=="function"&&!m.importScripts,t.$B=(()=>{if(t.$A){const F=[];m.addEventListener("message",B=>{if(B.data&&B.data.vscodeScheduleAsyncWork)for(let Y=0,K=F.length;Y<K;Y++){const ae=F[Y];if(ae.id===B.data.vscodeScheduleAsyncWork){F.splice(Y,1),ae.callback();return}}});let x=0;return B=>{const Y=++x;F.push({id:Y,callback:B}),m.postMessage({vscodeScheduleAsyncWork:Y},"*")}}return F=>setTimeout(F)})();var I;(function(F){F[F.Windows=1]="Windows",F[F.Macintosh=2]="Macintosh",F[F.Linux=3]="Linux"})(I||(t.OperatingSystem=I={})),t.OS=P||p?2:k?1:3;let M=!0,E=!1;function z(){if(!E){E=!0;const F=new Uint8Array(2);F[0]=1,F[1]=2,M=new Uint16Array(F.buffer)[0]===513}return M}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function q(F){return parseFloat(F)>=20}}),define(me[125],be([1,0,17,22,5]),function(se,t,i,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xR=t.KeyboardSupport=void 0;var W;(function(S){S[S.Always=0]="Always",S[S.FullScreen=1]="FullScreen",S[S.None=2]="None"})(W||(t.KeyboardSupport=W={})),t.$xR={clipboard:{writeText:P.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:P.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:P.$m||i.$vR()?0:navigator.keyboard||i.$rR?1:2,touch:"ontouchstart"in k.$cR||navigator.maxTouchPoints>0,pointerEvents:k.$cR.PointerEvent&&("ontouchstart"in k.$cR||navigator.maxTouchPoints>0)}}),define(me[15],be([1,0,17,54,87,5]),function(se,t,i,k,P,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FR=void 0,t.$DR=O,t.$ER=c;function S(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return k.KeyCodeUtils.fromString(r)}const n=e.keyCode;if(n===3)return 7;if(i.$oR)switch(n){case 59:return 85;case 60:if(W.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(W.$j)return 57;break}else if(i.$pR){if(W.$j&&n===93)return 57;if(!W.$j&&n===92)return 57}return k.$ur[n]||0}const A=W.$j?256:2048,g=512,b=1024,p=W.$j?2048:256;function O(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function c(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${k.KeyCodeUtils.toString(e.keyCode)}')`}class f{constructor(n){this._standardKeyboardEventBrand=!0;const r=n;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState?.("AltGraph"),this.keyCode=S(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(n){return this.a===n}c(){let n=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode);let r=0;return this.ctrlKey&&(r|=A),this.altKey&&(r|=g),this.shiftKey&&(r|=b),this.metaKey&&(r|=p),r|=n,r}d(){let n=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode),new P.$Cr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,n)}}t.$FR=f}),define(me[20],be([1,0,17,79,5]),function(se,t,i,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CR=t.$BR=t.$AR=void 0;class W{constructor(b,p){this.timestamp=Date.now(),this.browserEvent=p,this.leftButton=p.button===0,this.middleButton=p.button===1,this.rightButton=p.button===2,this.buttons=p.buttons,this.target=p.target,this.detail=p.detail||1,p.type==="dblclick"&&(this.detail=2),this.ctrlKey=p.ctrlKey,this.shiftKey=p.shiftKey,this.altKey=p.altKey,this.metaKey=p.metaKey,typeof p.pageX=="number"?(this.posx=p.pageX,this.posy=p.pageY):(this.posx=p.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=p.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const O=k.$yR.getPositionOfChildWindowRelativeToAncestorWindow(b,p.view);this.posx-=O.left,this.posy-=O.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$AR=W;class S extends W{constructor(b,p){super(b,p),this.dataTransfer=p.dataTransfer}}t.$BR=S;class A{constructor(b,p=0,O=0){this.browserEvent=b||null,this.target=b?b.target||b.targetNode||b.srcElement:null,this.deltaY=O,this.deltaX=p;let c=!1;if(i.$qR){const f=navigator.userAgent.match(/Chrome\/(\d+)/);c=(f?parseInt(f[1]):123)<=122}if(b){const f=b,e=b,n=b.view?.devicePixelRatio||1;if(typeof f.wheelDeltaY<"u")c?this.deltaY=f.wheelDeltaY/(120*n):this.deltaY=f.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(b.type==="wheel"){const r=b;r.deltaMode===r.DOM_DELTA_LINE?i.$oR&&!P.$j?this.deltaY=-b.deltaY/3:this.deltaY=-b.deltaY:this.deltaY=-b.deltaY/40}if(typeof f.wheelDeltaX<"u")i.$rR&&P.$i?this.deltaX=-(f.wheelDeltaX/120):c?this.deltaX=f.wheelDeltaX/(120*n):this.deltaX=f.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-b.detail/3;else if(b.type==="wheel"){const r=b;r.deltaMode===r.DOM_DELTA_LINE?i.$oR&&!P.$j?this.deltaX=-b.deltaX/3:this.deltaX=-b.deltaX:this.deltaX=-b.deltaX/40}this.deltaY===0&&this.deltaX===0&&b.wheelDelta&&(c?this.deltaY=b.wheelDelta/(120*n):this.deltaY=b.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$CR=A}),define(me[126],be([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let k;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const W=P.process;k={get platform(){return W.platform},get arch(){return W.arch},get env(){return W.env},cwd(){return W.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=k.cwd,t.env=k.env,t.$ec=k.platform,t.$fc=k.arch}),define(me[25],be([1,0,126]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const k=65,P=97,W=90,S=122,A=46,g=47,b=92,p=58,O=63;class c extends Error{constructor(L,C,N){let I;typeof C=="string"&&C.indexOf("not ")===0?(I="must not be",C=C.replace(/^not /,"")):I="must be";const M=L.indexOf(".")!==-1?"property":"argument";let E=`The "${L}" ${M} ${I} of type ${C}`;E+=`. Received type ${typeof N}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function f(a,L){if(a===null||typeof a!="object")throw new c(L,"Object",a)}function e(a,L){if(typeof a!="string")throw new c(L,"string",a)}const n=i.$ec==="win32";function r(a){return a===g||a===b}function h(a){return a===g}function m(a){return a>=k&&a<=W||a>=P&&a<=S}function y(a,L,C,N){let I="",M=0,E=-1,z=0,q=0;for(let F=0;F<=a.length;++F){if(F<a.length)q=a.charCodeAt(F);else{if(N(q))break;q=g}if(N(q)){if(!(E===F-1||z===1))if(z===2){if(I.length<2||M!==2||I.charCodeAt(I.length-1)!==A||I.charCodeAt(I.length-2)!==A){if(I.length>2){const x=I.lastIndexOf(C);x===-1?(I="",M=0):(I=I.slice(0,x),M=I.length-1-I.lastIndexOf(C)),E=F,z=0;continue}else if(I.length!==0){I="",M=0,E=F,z=0;continue}}L&&(I+=I.length>0?`${C}..`:"..",M=2)}else I.length>0?I+=`${C}${a.slice(E+1,F)}`:I=a.slice(E+1,F),M=F-E-1;E=F,z=0}else q===A&&z!==-1?++z:z=-1}return I}function o(a,L){f(L,"pathObject");const C=L.dir||L.root,N=L.base||`${L.name||""}${L.ext||""}`;return C?C===L.root?`${C}${N}`:`${C}${a}${N}`:N}t.$gc={resolve(...a){let L="",C="",N=!1;for(let I=a.length-1;I>=-1;I--){let M;if(I>=0){if(M=a[I],e(M,"path"),M.length===0)continue}else L.length===0?M=i.cwd():(M=i.env[`=${L}`]||i.cwd(),(M===void 0||M.slice(0,2).toLowerCase()!==L.toLowerCase()&&M.charCodeAt(2)===b)&&(M=`${L}\\`));const E=M.length;let z=0,q="",F=!1;const x=M.charCodeAt(0);if(E===1)r(x)&&(z=1,F=!0);else if(r(x))if(F=!0,r(M.charCodeAt(1))){let B=2,Y=B;for(;B<E&&!r(M.charCodeAt(B));)B++;if(B<E&&B!==Y){const K=M.slice(Y,B);for(Y=B;B<E&&r(M.charCodeAt(B));)B++;if(B<E&&B!==Y){for(Y=B;B<E&&!r(M.charCodeAt(B));)B++;(B===E||B!==Y)&&(q=`\\\\${K}\\${M.slice(Y,B)}`,z=B)}}}else z=1;else m(x)&&M.charCodeAt(1)===p&&(q=M.slice(0,2),z=2,E>2&&r(M.charCodeAt(2))&&(F=!0,z=3));if(q.length>0)if(L.length>0){if(q.toLowerCase()!==L.toLowerCase())continue}else L=q;if(N){if(L.length>0)break}else if(C=`${M.slice(z)}\\${C}`,N=F,F&&L.length>0)break}return C=y(C,!N,"\\",r),N?`${L}\\${C}`:`${L}${C}`||"."},normalize(a){e(a,"path");const L=a.length;if(L===0)return".";let C=0,N,I=!1;const M=a.charCodeAt(0);if(L===1)return h(M)?"\\":a;if(r(M))if(I=!0,r(a.charCodeAt(1))){let z=2,q=z;for(;z<L&&!r(a.charCodeAt(z));)z++;if(z<L&&z!==q){const F=a.slice(q,z);for(q=z;z<L&&r(a.charCodeAt(z));)z++;if(z<L&&z!==q){for(q=z;z<L&&!r(a.charCodeAt(z));)z++;if(z===L)return`\\\\${F}\\${a.slice(q)}\\`;z!==q&&(N=`\\\\${F}\\${a.slice(q,z)}`,C=z)}}}else C=1;else m(M)&&a.charCodeAt(1)===p&&(N=a.slice(0,2),C=2,L>2&&r(a.charCodeAt(2))&&(I=!0,C=3));let E=C<L?y(a.slice(C),!I,"\\",r):"";return E.length===0&&!I&&(E="."),E.length>0&&r(a.charCodeAt(L-1))&&(E+="\\"),N===void 0?I?`\\${E}`:E:I?`${N}\\${E}`:`${N}${E}`},isAbsolute(a){e(a,"path");const L=a.length;if(L===0)return!1;const C=a.charCodeAt(0);return r(C)||L>2&&m(C)&&a.charCodeAt(1)===p&&r(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let L,C;for(let M=0;M<a.length;++M){const E=a[M];e(E,"path"),E.length>0&&(L===void 0?L=C=E:L+=`\\${E}`)}if(L===void 0)return".";let N=!0,I=0;if(typeof C=="string"&&r(C.charCodeAt(0))){++I;const M=C.length;M>1&&r(C.charCodeAt(1))&&(++I,M>2&&(r(C.charCodeAt(2))?++I:N=!1))}if(N){for(;I<L.length&&r(L.charCodeAt(I));)I++;I>=2&&(L=`\\${L.slice(I)}`)}return t.$gc.normalize(L)},relative(a,L){if(e(a,"from"),e(L,"to"),a===L)return"";const C=t.$gc.resolve(a),N=t.$gc.resolve(L);if(C===N||(a=C.toLowerCase(),L=N.toLowerCase(),a===L))return"";let I=0;for(;I<a.length&&a.charCodeAt(I)===b;)I++;let M=a.length;for(;M-1>I&&a.charCodeAt(M-1)===b;)M--;const E=M-I;let z=0;for(;z<L.length&&L.charCodeAt(z)===b;)z++;let q=L.length;for(;q-1>z&&L.charCodeAt(q-1)===b;)q--;const F=q-z,x=E<F?E:F;let B=-1,Y=0;for(;Y<x;Y++){const ae=a.charCodeAt(I+Y);if(ae!==L.charCodeAt(z+Y))break;ae===b&&(B=Y)}if(Y!==x){if(B===-1)return N}else{if(F>x){if(L.charCodeAt(z+Y)===b)return N.slice(z+Y+1);if(Y===2)return N.slice(z+Y)}E>x&&(a.charCodeAt(I+Y)===b?B=Y:Y===2&&(B=3)),B===-1&&(B=0)}let K="";for(Y=I+B+1;Y<=M;++Y)(Y===M||a.charCodeAt(Y)===b)&&(K+=K.length===0?"..":"\\..");return z+=B,K.length>0?`${K}${N.slice(z,q)}`:(N.charCodeAt(z)===b&&++z,N.slice(z,q))},toNamespacedPath(a){if(typeof a!="string"||a.length===0)return a;const L=t.$gc.resolve(a);if(L.length<=2)return a;if(L.charCodeAt(0)===b){if(L.charCodeAt(1)===b){const C=L.charCodeAt(2);if(C!==O&&C!==A)return`\\\\?\\UNC\\${L.slice(2)}`}}else if(m(L.charCodeAt(0))&&L.charCodeAt(1)===p&&L.charCodeAt(2)===b)return`\\\\?\\${L}`;return a},dirname(a){e(a,"path");const L=a.length;if(L===0)return".";let C=-1,N=0;const I=a.charCodeAt(0);if(L===1)return r(I)?a:".";if(r(I)){if(C=N=1,r(a.charCodeAt(1))){let z=2,q=z;for(;z<L&&!r(a.charCodeAt(z));)z++;if(z<L&&z!==q){for(q=z;z<L&&r(a.charCodeAt(z));)z++;if(z<L&&z!==q){for(q=z;z<L&&!r(a.charCodeAt(z));)z++;if(z===L)return a;z!==q&&(C=N=z+1)}}}}else m(I)&&a.charCodeAt(1)===p&&(C=L>2&&r(a.charCodeAt(2))?3:2,N=C);let M=-1,E=!0;for(let z=L-1;z>=N;--z)if(r(a.charCodeAt(z))){if(!E){M=z;break}}else E=!1;if(M===-1){if(C===-1)return".";M=C}return a.slice(0,M)},basename(a,L){L!==void 0&&e(L,"ext"),e(a,"path");let C=0,N=-1,I=!0,M;if(a.length>=2&&m(a.charCodeAt(0))&&a.charCodeAt(1)===p&&(C=2),L!==void 0&&L.length>0&&L.length<=a.length){if(L===a)return"";let E=L.length-1,z=-1;for(M=a.length-1;M>=C;--M){const q=a.charCodeAt(M);if(r(q)){if(!I){C=M+1;break}}else z===-1&&(I=!1,z=M+1),E>=0&&(q===L.charCodeAt(E)?--E===-1&&(N=M):(E=-1,N=z))}return C===N?N=z:N===-1&&(N=a.length),a.slice(C,N)}for(M=a.length-1;M>=C;--M)if(r(a.charCodeAt(M))){if(!I){C=M+1;break}}else N===-1&&(I=!1,N=M+1);return N===-1?"":a.slice(C,N)},extname(a){e(a,"path");let L=0,C=-1,N=0,I=-1,M=!0,E=0;a.length>=2&&a.charCodeAt(1)===p&&m(a.charCodeAt(0))&&(L=N=2);for(let z=a.length-1;z>=L;--z){const q=a.charCodeAt(z);if(r(q)){if(!M){N=z+1;break}continue}I===-1&&(M=!1,I=z+1),q===A?C===-1?C=z:E!==1&&(E=1):C!==-1&&(E=-1)}return C===-1||I===-1||E===0||E===1&&C===I-1&&C===N+1?"":a.slice(C,I)},format:o.bind(null,"\\"),parse(a){e(a,"path");const L={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return L;const C=a.length;let N=0,I=a.charCodeAt(0);if(C===1)return r(I)?(L.root=L.dir=a,L):(L.base=L.name=a,L);if(r(I)){if(N=1,r(a.charCodeAt(1))){let B=2,Y=B;for(;B<C&&!r(a.charCodeAt(B));)B++;if(B<C&&B!==Y){for(Y=B;B<C&&r(a.charCodeAt(B));)B++;if(B<C&&B!==Y){for(Y=B;B<C&&!r(a.charCodeAt(B));)B++;B===C?N=B:B!==Y&&(N=B+1)}}}}else if(m(I)&&a.charCodeAt(1)===p){if(C<=2)return L.root=L.dir=a,L;if(N=2,r(a.charCodeAt(2))){if(C===3)return L.root=L.dir=a,L;N=3}}N>0&&(L.root=a.slice(0,N));let M=-1,E=N,z=-1,q=!0,F=a.length-1,x=0;for(;F>=N;--F){if(I=a.charCodeAt(F),r(I)){if(!q){E=F+1;break}continue}z===-1&&(q=!1,z=F+1),I===A?M===-1?M=F:x!==1&&(x=1):M!==-1&&(x=-1)}return z!==-1&&(M===-1||x===0||x===1&&M===z-1&&M===E+1?L.base=L.name=a.slice(E,z):(L.name=a.slice(E,M),L.base=a.slice(E,z),L.ext=a.slice(M,z))),E>0&&E!==N?L.dir=a.slice(0,E-1):L.dir=L.root,L},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(n){const a=/\\/g;return()=>{const L=i.cwd().replace(a,"/");return L.slice(L.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...a){let L="",C=!1;for(let N=a.length-1;N>=-1&&!C;N--){const I=N>=0?a[N]:d();e(I,"path"),I.length!==0&&(L=`${I}/${L}`,C=I.charCodeAt(0)===g)}return L=y(L,!C,"/",h),C?`/${L}`:L.length>0?L:"."},normalize(a){if(e(a,"path"),a.length===0)return".";const L=a.charCodeAt(0)===g,C=a.charCodeAt(a.length-1)===g;return a=y(a,!L,"/",h),a.length===0?L?"/":C?"./":".":(C&&(a+="/"),L?`/${a}`:a)},isAbsolute(a){return e(a,"path"),a.length>0&&a.charCodeAt(0)===g},join(...a){if(a.length===0)return".";let L;for(let C=0;C<a.length;++C){const N=a[C];e(N,"path"),N.length>0&&(L===void 0?L=N:L+=`/${N}`)}return L===void 0?".":t.$hc.normalize(L)},relative(a,L){if(e(a,"from"),e(L,"to"),a===L||(a=t.$hc.resolve(a),L=t.$hc.resolve(L),a===L))return"";const C=1,N=a.length,I=N-C,M=1,E=L.length-M,z=I<E?I:E;let q=-1,F=0;for(;F<z;F++){const B=a.charCodeAt(C+F);if(B!==L.charCodeAt(M+F))break;B===g&&(q=F)}if(F===z)if(E>z){if(L.charCodeAt(M+F)===g)return L.slice(M+F+1);if(F===0)return L.slice(M+F)}else I>z&&(a.charCodeAt(C+F)===g?q=F:F===0&&(q=0));let x="";for(F=C+q+1;F<=N;++F)(F===N||a.charCodeAt(F)===g)&&(x+=x.length===0?"..":"/..");return`${x}${L.slice(M+q)}`},toNamespacedPath(a){return a},dirname(a){if(e(a,"path"),a.length===0)return".";const L=a.charCodeAt(0)===g;let C=-1,N=!0;for(let I=a.length-1;I>=1;--I)if(a.charCodeAt(I)===g){if(!N){C=I;break}}else N=!1;return C===-1?L?"/":".":L&&C===1?"//":a.slice(0,C)},basename(a,L){L!==void 0&&e(L,"ext"),e(a,"path");let C=0,N=-1,I=!0,M;if(L!==void 0&&L.length>0&&L.length<=a.length){if(L===a)return"";let E=L.length-1,z=-1;for(M=a.length-1;M>=0;--M){const q=a.charCodeAt(M);if(q===g){if(!I){C=M+1;break}}else z===-1&&(I=!1,z=M+1),E>=0&&(q===L.charCodeAt(E)?--E===-1&&(N=M):(E=-1,N=z))}return C===N?N=z:N===-1&&(N=a.length),a.slice(C,N)}for(M=a.length-1;M>=0;--M)if(a.charCodeAt(M)===g){if(!I){C=M+1;break}}else N===-1&&(I=!1,N=M+1);return N===-1?"":a.slice(C,N)},extname(a){e(a,"path");let L=-1,C=0,N=-1,I=!0,M=0;for(let E=a.length-1;E>=0;--E){const z=a.charCodeAt(E);if(z===g){if(!I){C=E+1;break}continue}N===-1&&(I=!1,N=E+1),z===A?L===-1?L=E:M!==1&&(M=1):L!==-1&&(M=-1)}return L===-1||N===-1||M===0||M===1&&L===N-1&&L===C+1?"":a.slice(L,N)},format:o.bind(null,"/"),parse(a){e(a,"path");const L={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return L;const C=a.charCodeAt(0)===g;let N;C?(L.root="/",N=1):N=0;let I=-1,M=0,E=-1,z=!0,q=a.length-1,F=0;for(;q>=N;--q){const x=a.charCodeAt(q);if(x===g){if(!z){M=q+1;break}continue}E===-1&&(z=!1,E=q+1),x===A?I===-1?I=q:F!==1&&(F=1):I!==-1&&(F=-1)}if(E!==-1){const x=M===0&&C?1:M;I===-1||F===0||F===1&&I===E-1&&I===M+1?L.base=L.name=a.slice(x,E):(L.name=a.slice(x,I),L.base=a.slice(x,E),L.ext=a.slice(I,E))}return M>0?L.dir=a.slice(0,M-1):C&&(L.dir="/"),L},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=n?t.$gc.normalize:t.$hc.normalize,t.$jc=n?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=n?t.$gc.join:t.$hc.join,t.$lc=n?t.$gc.resolve:t.$hc.resolve,t.$mc=n?t.$gc.relative:t.$hc.relative,t.$nc=n?t.$gc.dirname:t.$hc.dirname,t.$oc=n?t.$gc.basename:t.$hc.basename,t.$pc=n?t.$gc.extname:t.$hc.extname,t.$qc=n?t.$gc.format:t.$hc.format,t.$rc=n?t.$gc.parse:t.$hc.parse,t.$sc=n?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=n?t.$gc.sep:t.$hc.sep,t.$uc=n?t.$gc.delimiter:t.$hc.delimiter}),define(me[127],be([1,0,25,5,9,10]),function(se,t,i,k,P,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kg=S,t.$lg=A,t.$mg=g,t.$ng=b,t.$og=p,t.$pg=e,t.$qg=n,t.$rg=r,t.$sg=h,t.$tg=m,t.$ug=y,t.$vg=o,t.$wg=d,t.$xg=a,t.$yg=L,t.$zg=I;function S(M){return M===47||M===92}function A(M){return M.replace(/[\\/]/g,i.$hc.sep)}function g(M){return M.indexOf("/")===-1&&(M=A(M)),/^[a-zA-Z]:(\/|$)/.test(M)&&(M="/"+M),M}function b(M,E=i.$hc.sep){if(!M)return"";const z=M.length,q=M.charCodeAt(0);if(S(q)){if(S(M.charCodeAt(1))&&!S(M.charCodeAt(2))){let x=3;const B=x;for(;x<z&&!S(M.charCodeAt(x));x++);if(B!==x&&!S(M.charCodeAt(x+1))){for(x+=1;x<z;x++)if(S(M.charCodeAt(x)))return M.slice(0,x+1).replace(/[\\/]/g,E)}}return E}else if(h(q)&&M.charCodeAt(1)===58)return S(M.charCodeAt(2))?M.slice(0,2)+E:M.slice(0,2);let F=M.indexOf("://");if(F!==-1){for(F+=3;F<z;F++)if(S(M.charCodeAt(F)))return M.slice(0,F+1)}return""}function p(M){if(!k.$i||!M||M.length<5)return!1;let E=M.charCodeAt(0);if(E!==92||(E=M.charCodeAt(1),E!==92))return!1;let z=2;const q=z;for(;z<M.length&&(E=M.charCodeAt(z),E!==92);z++);return!(q===z||(E=M.charCodeAt(z+1),isNaN(E)||E===92))}const O=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(M,E=k.$i){const z=E?O:c;return!(!M||M.length===0||/^\s+$/.test(M)||(z.lastIndex=0,z.test(M))||E&&f.test(M)||M==="."||M===".."||E&&M[M.length-1]==="."||E&&M.length!==M.trim().length||M.length>255)}function n(M,E,z){const q=M===E;return!z||q?q:!M||!E?!1:(0,P.$uf)(M,E)}function r(M,E,z,q=i.sep){if(M===E)return!0;if(!M||!E||E.length>M.length)return!1;if(z){if(!(0,P.$vf)(M,E))return!1;if(E.length===M.length)return!0;let x=E.length;return E.charAt(E.length-1)===q&&x--,M.charAt(x)===q}return E.charAt(E.length-1)!==q&&(E+=q),M.indexOf(E)===0}function h(M){return M>=65&&M<=90||M>=97&&M<=122}function m(M,E){return k.$i&&M.endsWith(":")&&(M+=i.sep),(0,i.$jc)(M)||(M=(0,i.$kc)(E,M)),M=(0,i.$ic)(M),k.$i?(M=(0,P.$cf)(M,i.sep),M.endsWith(":")&&(M+=i.sep)):(M=(0,P.$cf)(M,i.sep),M||(M=i.sep)),M}function y(M){const E=(0,i.$ic)(M);return k.$i?M.length>3?!1:o(E)&&(M.length===2||E.charCodeAt(2)===92):E===i.$hc.sep}function o(M,E=k.$i){return E?h(M.charCodeAt(0))&&M.charCodeAt(1)===58:!1}function d(M,E=k.$i){return o(M,E)?M[0]:void 0}function a(M,E,z){return E.length>M.length?-1:M===E?0:(z&&(M=M.toLowerCase(),E=E.toLowerCase()),M.indexOf(E))}function L(M){const E=M.split(":");let z,q,F;for(const x of E){const B=Number(x);(0,W.$9f)(B)?q===void 0?q=B:F===void 0&&(F=B):z=z?[z,x].join(":"):x}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:q!==void 0?q:void 0,column:F!==void 0?F:q!==void 0?1:void 0}}const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",N="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function I(M,E,z=8){let q="";for(let x=0;x<z;x++){let B;x===0&&k.$i&&!E&&(z===3||z===4)?B=N:B=C,q+=B.charAt(Math.floor(Math.random()*B.length))}let F;return E?F=`${E}-${q}`:F=q,M?(0,i.$kc)(M,F):F}}),define(me[128],be([1,0,25]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ks=void 0,t.$Ls=W,t.$Ms=S,t.$Ns=A,t.$Os=b,t.$Ks=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(p){const O=(0,i.$pc)(p),c=k[O.toLowerCase()];return c!==void 0?c:S(p)}function S(p){const O=(0,i.$pc)(p);return P[O.toLowerCase()]}function A(p){for(const O in P)if(P[O]===p)return O}const g=/^(.+)\/(.+?)(;.+)?$/;function b(p,O){const c=g.exec(p);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:O?void 0:p}}),define(me[16],be([1,0,25,5]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=o;const P=/^\w[\w\d+.-]*$/,W=/^\//,S=/^\/\//;function A(N,I){if(!N.scheme&&I)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${N.authority}", path: "${N.path}", query: "${N.query}", fragment: "${N.fragment}"}`);if(N.scheme&&!P.test(N.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(N.path){if(N.authority){if(!W.test(N.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(N.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(N,I){return!N&&!I?"file":N}function b(N,I){switch(N){case"https":case"http":case"file":I?I[0]!==O&&(I=O+I):I=O;break}return I}const p="",O="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(I){return I instanceof f?!0:I?typeof I.authority=="string"&&typeof I.fragment=="string"&&typeof I.path=="string"&&typeof I.query=="string"&&typeof I.scheme=="string"&&typeof I.fsPath=="string"&&typeof I.with=="function"&&typeof I.toString=="function":!1}constructor(I,M,E,z,q,F=!1){typeof I=="object"?(this.scheme=I.scheme||p,this.authority=I.authority||p,this.path=I.path||p,this.query=I.query||p,this.fragment=I.fragment||p):(this.scheme=g(I,F),this.authority=M||p,this.path=b(this.scheme,E||p),this.query=z||p,this.fragment=q||p,A(this,F))}get fsPath(){return o(this,!1)}with(I){if(!I)return this;let{scheme:M,authority:E,path:z,query:q,fragment:F}=I;return M===void 0?M=this.scheme:M===null&&(M=p),E===void 0?E=this.authority:E===null&&(E=p),z===void 0?z=this.path:z===null&&(z=p),q===void 0?q=this.query:q===null&&(q=p),F===void 0?F=this.fragment:F===null&&(F=p),M===this.scheme&&E===this.authority&&z===this.path&&q===this.query&&F===this.fragment?this:new r(M,E,z,q,F)}static parse(I,M=!1){const E=c.exec(I);return E?new r(E[2]||p,C(E[4]||p),C(E[5]||p),C(E[7]||p),C(E[9]||p),M):new r(p,p,p,p,p)}static file(I){let M=p;if(k.$i&&(I=I.replace(/\\/g,O)),I[0]===O&&I[1]===O){const E=I.indexOf(O,2);E===-1?(M=I.substring(2),I=O):(M=I.substring(2,E),I=I.substring(E)||O)}return new r("file",M,I,p,p)}static from(I,M){return new r(I.scheme,I.authority,I.path,I.query,I.fragment,M)}static joinPath(I,...M){if(!I.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return k.$i&&I.scheme==="file"?E=f.file(i.$gc.join(o(I,!0),...M)).path:E=i.$hc.join(I.path,...M),I.with({path:E})}toString(I=!1){return d(this,I)}toJSON(){return this}static revive(I){if(I){if(I instanceof f)return I;{const M=new r(I);return M._formatted=I.external??null,M._fsPath=I._sep===n?I.fsPath??null:null,M}}else return I}}t.URI=f;function e(N){return!N||typeof N!="object"?!1:typeof N.scheme=="string"&&(typeof N.authority=="string"||typeof N.authority>"u")&&(typeof N.path=="string"||typeof N.path>"u")&&(typeof N.query=="string"||typeof N.query>"u")&&(typeof N.fragment=="string"||typeof N.fragment>"u")}const n=k.$i?1:void 0;class r extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(I=!1){return I?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const I={$mid:1};return this._fsPath&&(I.fsPath=this._fsPath,I._sep=n),this._formatted&&(I.external=this._formatted),this.path&&(I.path=this.path),this.scheme&&(I.scheme=this.scheme),this.authority&&(I.authority=this.authority),this.query&&(I.query=this.query),this.fragment&&(I.fragment=this.fragment),I}}const h={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function m(N,I,M){let E,z=-1;for(let q=0;q<N.length;q++){const F=N.charCodeAt(q);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||I&&F===47||M&&F===91||M&&F===93||M&&F===58)z!==-1&&(E+=encodeURIComponent(N.substring(z,q)),z=-1),E!==void 0&&(E+=N.charAt(q));else{E===void 0&&(E=N.substr(0,q));const x=h[F];x!==void 0?(z!==-1&&(E+=encodeURIComponent(N.substring(z,q)),z=-1),E+=x):z===-1&&(z=q)}}return z!==-1&&(E+=encodeURIComponent(N.substring(z))),E!==void 0?E:N}function y(N){let I;for(let M=0;M<N.length;M++){const E=N.charCodeAt(M);E===35||E===63?(I===void 0&&(I=N.substr(0,M)),I+=h[E]):I!==void 0&&(I+=N[M])}return I!==void 0?I:N}function o(N,I){let M;return N.authority&&N.path.length>1&&N.scheme==="file"?M=`//${N.authority}${N.path}`:N.path.charCodeAt(0)===47&&(N.path.charCodeAt(1)>=65&&N.path.charCodeAt(1)<=90||N.path.charCodeAt(1)>=97&&N.path.charCodeAt(1)<=122)&&N.path.charCodeAt(2)===58?I?M=N.path.substr(1):M=N.path[1].toLowerCase()+N.path.substr(2):M=N.path,k.$i&&(M=M.replace(/\//g,"\\")),M}function d(N,I){const M=I?y:m;let E="",{scheme:z,authority:q,path:F,query:x,fragment:B}=N;if(z&&(E+=z,E+=":"),(q||z==="file")&&(E+=O,E+=O),q){let Y=q.indexOf("@");if(Y!==-1){const K=q.substr(0,Y);q=q.substr(Y+1),Y=K.lastIndexOf(":"),Y===-1?E+=M(K,!1,!1):(E+=M(K.substr(0,Y),!1,!1),E+=":",E+=M(K.substr(Y+1),!1,!0)),E+="@"}q=q.toLowerCase(),Y=q.lastIndexOf(":"),Y===-1?E+=M(q,!1,!0):(E+=M(q.substr(0,Y),!1,!0),E+=q.substr(Y))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const Y=F.charCodeAt(1);Y>=65&&Y<=90&&(F=`/${String.fromCharCode(Y+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const Y=F.charCodeAt(0);Y>=65&&Y<=90&&(F=`${String.fromCharCode(Y+32)}:${F.substr(2)}`)}E+=M(F,!0,!1)}return x&&(E+="?",E+=M(x,!1,!1)),B&&(E+="#",E+=I?B:m(B,!1,!1)),E}function a(N){try{return decodeURIComponent(N)}catch{return N.length>3?N.substr(0,3)+a(N.substr(3)):N}}const L=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function C(N){return N.match(L)?N.replace(L,I=>a(I)):N}}),define(me[64],be([1,0,43,16]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yh=P,t.$Zh=W,t.$1h=A;function P(g){return JSON.stringify(g,S)}function W(g){let b=JSON.parse(g);return b=A(b),b}function S(g,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function A(g,b=0){if(!g||b>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return k.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof i.$Ce||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let p=0;p<g.length;++p)g[p]=A(g[p],b+1);else for(const p in g)Object.hasOwnProperty.call(g,p)&&(g[p]=A(g[p],b+1))}return g}}),define(me[36],be([1,0,6,5,9,16,25]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Eg=t.$Dg=t.$Cg=t.Schemas=void 0,t.$Ag=g,t.$Bg=b,t.$Fg=O;var A;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(A||(t.Schemas=A={}));function g(e,n){return W.URI.isUri(e)?(0,P.$uf)(e.scheme,n):(0,P.$vf)(e,n+":")}function b(e,...n){return n.some(r=>g(e,r))}t.$Cg="vscode-tkn",t.$Dg="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,r){this.f=O(n,r)}getServerRootPath(){return this.f}get g(){return S.$hc.join(this.f,A.vscodeRemoteResource)}set(n,r,h){this.a[n]=r,this.b[n]=h}setConnectionToken(n,r){this.c[n]=r}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(d){return i.$1(d),n}const r=n.authority;let h=this.a[r];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const m=this.b[r],y=this.c[r];let o=`path=${encodeURIComponent(n.path)}`;return typeof y=="string"&&(o+=`&${t.$Dg}=${encodeURIComponent(y)}`),W.URI.from({scheme:k.$o?this.d:A.vscodeRemoteResource,authority:`${h}:${m}`,path:this.g,query:o})}}t.$Eg=new p;function O(e,n){return S.$hc.join(n??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Gg="vs/../../extensions",t.$Hg="vs/../../node_modules",t.$Ig="vs/../../node_modules.asar",t.$Jg="vs/../../node_modules.asar.unpacked",t.$Kg="vscode-app";class c{static{this.a=t.$Kg}asBrowserUri(n){const r=this.b(n,se);return this.uriToBrowserUri(r)}uriToBrowserUri(n){return n.scheme===A.vscodeRemote?t.$Eg.rewrite(n):n.scheme===A.file&&(k.$m||k.$q===`${A.vscodeFileResource}://${c.a}`)?n.with({scheme:A.vscodeFileResource,authority:n.authority||c.a,query:null,fragment:null}):n}asFileUri(n){const r=this.b(n,se);return this.uriToFileUri(r)}uriToFileUri(n){return n.scheme===A.vscodeFileResource?n.with({scheme:A.file,authority:n.authority!==c.a?n.authority:null,query:null,fragment:null}):n}b(n,r){return W.URI.isUri(n)?n:W.URI.parse(r.toUrl(n))}}t.$Lg=new c;var f;(function(e){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(n.get("3"));const r="vscode-coi";function h(y){let o;typeof y=="string"?o=new URL(y).searchParams:y instanceof URL?o=y.searchParams:W.URI.isUri(y)&&(o=new URL(y.toString(!0)).searchParams);const d=o?.get(r);if(d)return n.get(d)}e.getHeadersFromQuery=h;function m(y,o,d){if(!globalThis.crossOriginIsolated)return;const a=o&&d?"3":d?"2":"1";y instanceof URLSearchParams?y.set(r,a):y[r]=a}e.addSearchParam=m})(f||(t.COI=f={}))}),define(me[47],be([1,0,127,36,25,5,9,16]),function(se,t,i,k,P,W,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=void 0,t.$Sg=g,t.$bh=p,t.$ch=c;function g(f){return(0,A.$xc)(f,!0)}class b{constructor(e){this.a=e}compare(e,n,r=!1){return e===n?0:(0,S.$nf)(this.getComparisonKey(e,r),this.getComparisonKey(n,r))}isEqual(e,n,r=!1){return e===n?!0:!e||!n?!1:this.getComparisonKey(e,r)===this.getComparisonKey(n,r)}getComparisonKey(e,n=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,n,r=!1){if(e.scheme===n.scheme){if(e.scheme===k.Schemas.file)return i.$rg(g(e),g(n),this.a(e))&&e.query===n.query&&(r||e.fragment===n.fragment);if((0,t.$0g)(e.authority,n.authority))return i.$rg(e.path,n.path,this.a(e),"/")&&e.query===n.query&&(r||e.fragment===n.fragment)}return!1}joinPath(e,...n){return A.URI.joinPath(e,...n)}basenameOrAuthority(e){return(0,t.$2g)(e)||e.authority}basename(e){return P.$hc.basename(e.path)}extname(e){return P.$hc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let n;return e.scheme===k.Schemas.file?n=A.URI.file(P.$nc(g(e))).path:(n=P.$hc.dirname(e.path),e.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),n="/")),e.with({path:n})}normalizePath(e){if(!e.path.length)return e;let n;return e.scheme===k.Schemas.file?n=A.URI.file(P.$ic(g(e))).path:n=P.$hc.normalize(e.path),e.with({path:n})}relativePath(e,n){if(e.scheme!==n.scheme||!(0,t.$0g)(e.authority,n.authority))return;if(e.scheme===k.Schemas.file){const m=P.$mc(g(e),g(n));return W.$i?i.$lg(m):m}let r=e.path||"/";const h=n.path||"/";if(this.a(e)){let m=0;for(const y=Math.min(r.length,h.length);m<y&&!(r.charCodeAt(m)!==h.charCodeAt(m)&&r.charAt(m).toLowerCase()!==h.charAt(m).toLowerCase());m++);r=h.substr(0,m)+r.substr(m)}return P.$hc.relative(r,h)}resolvePath(e,n){if(e.scheme===k.Schemas.file){const r=A.URI.file(P.$lc(g(e),n));return e.with({authority:r.authority,path:r.path})}return n=i.$mg(n),e.with({path:P.$hc.resolve(e.path,n)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,n){return e===n||e!==void 0&&n!==void 0&&(0,S.$uf)(e,n)}hasTrailingPathSeparator(e,n=P.sep){if(e.scheme===k.Schemas.file){const r=g(e);return r.length>i.$ng(r).length&&r[r.length-1]===n}else{const r=e.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,n=P.sep){return(0,t.$$g)(e,n)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,n=P.sep){let r=!1;if(e.scheme===k.Schemas.file){const h=g(e);r=h!==void 0&&h.length===i.$ng(h).length&&h[h.length-1]===n}else{n="/";const h=e.path;r=h.length===1&&h.charCodeAt(h.length-1)===47}return!r&&!(0,t.$$g)(e,n)?e.with({path:e.path+"/"}):e}}t.$Tg=b,t.$Ug=new b(()=>!1),t.$Vg=new b(f=>f.scheme===k.Schemas.file?!W.$k:!0),t.$Wg=new b(f=>!0),t.$Xg=t.$Ug.isEqual.bind(t.$Ug),t.$Yg=t.$Ug.isEqualOrParent.bind(t.$Ug),t.$Zg=t.$Ug.getComparisonKey.bind(t.$Ug),t.$1g=t.$Ug.basenameOrAuthority.bind(t.$Ug),t.$2g=t.$Ug.basename.bind(t.$Ug),t.$3g=t.$Ug.extname.bind(t.$Ug),t.$4g=t.$Ug.dirname.bind(t.$Ug),t.$5g=t.$Ug.joinPath.bind(t.$Ug),t.$6g=t.$Ug.normalizePath.bind(t.$Ug),t.$7g=t.$Ug.relativePath.bind(t.$Ug),t.$8g=t.$Ug.resolvePath.bind(t.$Ug),t.$9g=t.$Ug.isAbsolutePath.bind(t.$Ug),t.$0g=t.$Ug.isEqualAuthority.bind(t.$Ug),t.$$g=t.$Ug.hasTrailingPathSeparator.bind(t.$Ug),t.$_g=t.$Ug.removeTrailingPathSeparator.bind(t.$Ug),t.$ah=t.$Ug.addTrailingPathSeparator.bind(t.$Ug);function p(f,e){const n=[];for(let r=0;r<f.length;r++){const h=e(f[r]);f.some((m,y)=>y===r?!1:(0,t.$Yg)(h,e(m)))||n.push(f[r])}return n}var O;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function e(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(y=>{const[o,d]=y.split(":");o&&d&&r.set(o,d)});const m=n.path.substring(0,n.path.indexOf(";"));return m&&r.set(f.META_DATA_MIME,m),r}f.parseMetaData=e})(O||(t.DataUri=O={}));function c(f,e,n){if(e){let r=f.path;return r&&r[0]!==P.$hc.sep&&(r=P.$hc.sep+r),f.with({scheme:n,authority:e,path:r})}return f.with({scheme:n})}}),define(me[11],be([1,0,34,6,3,2,47,5,60,23]),function(se,t,i,k,P,W,S,A,g,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uh=t.$Sh=t.$Rh=t.$Qh=t.$Ph=t.Promises=t.$Oh=t.$Nh=t.$Mh=t.$Kh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$Bh=t.$Ah=t.$zh=t.$yh=t.$xh=t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=t.$mh=t.$lh=void 0,t.$dh=p,t.$eh=O,t.$fh=c,t.$gh=f,t.$hh=e,t.$ih=n,t.$jh=r,t.$kh=h,t.$sh=M,t.$th=E,t.$uh=z,t.$vh=q,t.$wh=F,t.$Lh=_,t.$Th=H;function p(v){return!!v&&typeof v.then=="function"}function O(v){const l=new i.$me,w=v(l.token),T=new Promise((s,D)=>{const $=l.token.onCancellationRequested(()=>{$.dispose(),D(new k.$5)});Promise.resolve(w).then(R=>{$.dispose(),l.dispose(),s(R)},R=>{$.dispose(),l.dispose(),D(R)})});return new class{cancel(){l.cancel(),l.dispose()}then(s,D){return T.then(s,D)}catch(s){return this.then(void 0,s)}finally(s){return T.finally(s)}}}function c(v,l,w){return new Promise((T,s)=>{const D=l.onCancellationRequested(()=>{D.dispose(),T(w)});v.then(T,s).finally(()=>D.dispose())})}function f(v,l){return new Promise((w,T)=>{const s=l.onCancellationRequested(()=>{s.dispose(),T(new k.$5)});v.then(w,T).finally(()=>s.dispose())})}async function e(v){let l=-1;const w=v.map((T,s)=>T.then(D=>(l=s,D)));try{return await Promise.race(w)}finally{v.forEach((T,s)=>{s!==l&&T.cancel()})}}function n(v,l,w){let T;const s=setTimeout(()=>{T?.(void 0),w?.()},l);return Promise.race([v.finally(()=>clearTimeout(s)),new Promise(D=>T=D)])}function r(v){return new Promise((l,w)=>{const T=v();p(T)?T.then(l,w):l(T)})}function h(){let v,l;return{promise:new Promise((T,s)=>{v=T,l=s}),resolve:v,reject:l}}class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(l){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=l,!this.b){const w=()=>{if(this.b=null,this.f)return;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(w,w).then(T)})}return new Promise((w,T)=>{this.b.then(w,T)})}return this.a=l(),new Promise((w,T)=>{this.a.then(s=>{this.a=null,w(s)},s=>{this.a=null,T(s)})})}dispose(){this.f=!0}}t.$lh=m;class y{constructor(){this.a=Promise.resolve(null)}queue(l){return this.a=this.a.then(()=>l(),()=>l())}}t.$mh=y;class o{constructor(){this.a=new Map}queue(l,w){const s=(this.a.get(l)??Promise.resolve()).catch(()=>{}).then(w).finally(()=>{this.a.get(l)===s&&this.a.delete(l)});return this.a.set(l,s),s}}t.$nh=o;const d=(v,l)=>{let w=!0;const T=setTimeout(()=>{w=!1,l()},v);return{isTriggered:()=>w,dispose:()=>{clearTimeout(T),w=!1}}},a=v=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,v())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class L{constructor(l){this.defaultDelay=l,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(l,w=this.defaultDelay){this.g=l,this.h(),this.b||(this.b=new Promise((s,D)=>{this.d=s,this.f=D}).then(()=>{if(this.b=null,this.d=null,this.g){const s=this.g;return this.g=null,s()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=w===g.$$d?a(T):d(w,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$oh=L;class C{constructor(l){this.a=new L(l),this.b=new m}trigger(l,w){return this.a.trigger(()=>this.b.queue(l),w)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$ph=C;class N{constructor(){this.a=!1,this.b=new Promise((l,w)=>{this.d=l})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$qh=N;class I extends N{constructor(l){super(),this.f=setTimeout(()=>this.open(),l)}open(){clearTimeout(this.f),super.open()}}t.$rh=I;function M(v,l){return l?new Promise((w,T)=>{const s=setTimeout(()=>{D.dispose(),w()},v),D=l.onCancellationRequested(()=>{clearTimeout(s),D.dispose(),T(new k.$5)})}):O(w=>M(v,w))}function E(v,l=0,w){const T=setTimeout(()=>{v(),w&&s.dispose()},l),s=(0,W.$Sc)(()=>{clearTimeout(T),w?.deleteAndLeak(s)});return w?.add(s),s}function z(v){const l=[];let w=0;const T=v.length;function s(){return w<T?v[w++]():null}function D($){$!=null&&l.push($);const R=s();return R?R.then(D):Promise.resolve(l)}return Promise.resolve(null).then(D)}function q(v,l=T=>!!T,w=null){let T=0;const s=v.length,D=()=>{if(T>=s)return Promise.resolve(w);const $=v[T++];return Promise.resolve($()).then(j=>l(j)?Promise.resolve(j):D())};return D()}function F(v,l=T=>!!T,w=null){if(v.length===0)return Promise.resolve(w);let T=v.length;const s=()=>{T=-1;for(const D of v)D.cancel?.()};return new Promise((D,$)=>{for(const R of v)R.then(j=>{--T>=0&&l(j)?(s(),D(j)):T===0&&D(w)}).catch(j=>{--T>=0&&(s(),$(j))})})}class x{constructor(l){this.a=0,this.b=!1,this.f=l,this.g=[],this.d=0,this.h=new P.$be}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(l){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((w,T)=>{this.g.push({factory:l,c:w,e:T}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const l=this.g.shift();this.d++;const w=l.factory();w.then(l.c,l.e),w.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$xh=x;class B extends x{constructor(){super(1)}}t.$yh=B;class Y{constructor(){this.a=new ue,this.b=0}queue(l){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,l())):this.a.run(this.b++,l())}}t.$zh=Y;class K{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const l=new V;return this.b.add(l),l.p}g(){for(const[,l]of this.a)if(l.size>0)return!1;return!0}queueSize(l,w=S.$Ug){const T=w.getComparisonKey(l);return this.a.get(T)?.size??0}queueFor(l,w,T=S.$Ug){const s=T.getComparisonKey(l);let D=this.a.get(s);if(!D){D=new B;const $=this.f++,R=P.Event.once(D.onDrained)(()=>{D?.dispose(),this.a.delete(s),this.h(),this.d?.deleteAndDispose($),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new W.$4c),this.d.set($,R),this.a.set(s,D)}return D.queue(w)}h(){this.g()&&this.j()}j(){for(const l of this.b)l.complete();this.b.clear()}dispose(){for(const[,l]of this.a)l.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Ah=K;class ae{constructor(l,w){this.a=-1,typeof l=="function"&&typeof w=="number"&&this.setIfNotSet(l,w)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(l,w){this.cancel(),this.a=setTimeout(()=>{this.a=-1,l()},w)}setIfNotSet(l,w){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,l()},w))}}t.$Bh=ae;class ie{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(l,w,T=globalThis){this.cancel();const s=T.setInterval(()=>{l()},w);this.d=(0,W.$Sc)(()=>{T.clearInterval(s),this.d=void 0})}dispose(){this.cancel()}}t.$Ch=ie;class ee{constructor(l,w){this.b=-1,this.a=l,this.d=w,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(l=this.d){this.cancel(),this.b=setTimeout(this.f,l)}get delay(){return this.d}set delay(l){this.d=l}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Dh=ee;class ce{constructor(l,w){w%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${w}ms is not a multiple of 1000ms.`),this.a=l,this.b=w,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(l=this.b){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(l/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Eh=ce;class De extends ee{constructor(l,w){super(l,w),this.j=[]}work(l){this.j.push(l),this.isScheduled()||this.schedule()}h(){const l=this.j;this.j=[],this.a?.(l)}dispose(){this.j=[],super.dispose()}}t.$Fh=De;class Ee extends W.$Uc{constructor(l,w){super(),this.g=l,this.h=w,this.a=[],this.b=this.B(new W.$Vc),this.f=!1}get pending(){return this.a.length}work(l){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+l.length>this.g.maxBufferedWork)return!1}else if(this.pending+l.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const w of l)this.a.push(w);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Gh=Ee,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Ih=(v,l)=>{(0,A.$B)(()=>{if(w)return;const T=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let w=!1;return{dispose(){w||(w=!0)}}}:t.$Ih=(v,l,w)=>{const T=v.requestIdleCallback(l,typeof w=="number"?{timeout:w}:void 0);let s=!1;return{dispose(){s||(s=!0,v.cancelIdleCallback(T))}}},t.$Hh=v=>(0,t.$Ih)(globalThis,v)}();class Ie{constructor(l,w){this.g=!1,this.d=()=>{try{this.j=w()}catch(T){this.l=T}finally{this.g=!0}},this.f=(0,t.$Ih)(l,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Jh=Ie;class le extends Ie{constructor(l){super(globalThis,l)}}t.$Kh=le;async function _(v,l,w){let T;for(let s=0;s<w;s++)try{return await v()}catch(D){T=D,await M(l)}throw T}class ue{isRunning(l){return typeof l=="number"?this.a?.taskId===l:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(l,w,T){return this.a={taskId:l,cancel:()=>T?.(),promise:w},w.then(()=>this.d(l),()=>this.d(l)),w}d(l){this.a&&l===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const l=this.b;this.b=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this.b)this.b.run=l;else{const{promise:w,resolve:T,reject:s}=h();this.b={run:l,promise:w,promiseResolve:T,promiseReject:s}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Mh=ue;class re{constructor(l,w=()=>Date.now()){this.d=l,this.f=w,this.a=0,this.b=0}increment(){const l=this.f();return l-this.a>this.d&&(this.a=l,this.b=0),this.b++,this.b}}t.$Nh=re;var ye;(function(v){v[v.Resolved=0]="Resolved",v[v.Rejected=1]="Rejected"})(ye||(ye={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((l,w)=>{this.a=l,this.b=w})}complete(l){return new Promise(w=>{this.a(l),this.d={outcome:0,value:l},w()})}error(l){return new Promise(w=>{this.b(l),this.d={outcome:1,value:l},w()})}cancel(){return this.error(new k.$5)}}t.$Oh=V;var Q;(function(v){async function l(T){let s;const D=await Promise.all(T.map($=>$.then(R=>R,R=>{s||(s=R)})));if(typeof s<"u")throw s;return D}v.settled=l;function w(T){return new Promise(async(s,D)=>{try{await T(s,D)}catch($){D($)}})}v.withAsyncBody=w})(Q||(t.Promises=Q={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(l){this.a=void 0,this.b=void 0,this.d=!1,this.promise=l.then(w=>(this.a=w,this.d=!0,w),w=>{throw this.b=w,this.d=!0,w})}requireValue(){if(!this.d)throw new k.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Ph=ge;class we{constructor(l){this.b=l,this.a=new b.$V(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Qh=we;var Le;(function(v){v[v.Initial=0]="Initial",v[v.DoneOK=1]="DoneOK",v[v.DoneError=2]="DoneError"})(Le||(Le={}));class Te{static fromArray(l){return new Te(w=>{w.emitMany(l)})}static fromPromise(l){return new Te(async w=>{w.emitMany(await l)})}static fromPromises(l){return new Te(async w=>{await Promise.all(l.map(async T=>w.emitOne(await T)))})}static merge(l){return new Te(async w=>{await Promise.all(l.map(async T=>{for await(const s of T)w.emitOne(s)}))})}static{this.EMPTY=Te.fromArray([])}constructor(l,w){this.a=0,this.b=[],this.d=null,this.f=w,this.g=new P.$be,queueMicrotask(async()=>{const T={emitOne:s=>this.h(s),emitMany:s=>this.j(s),reject:s=>this.l(s)};try{await Promise.resolve(l(T)),this.k()}catch(s){this.l(s)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(l<this.b.length)return{done:!1,value:this.b[l++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(l,w){return new Te(async T=>{for await(const s of l)T.emitOne(w(s))})}map(l){return Te.map(this,l)}static filter(l,w){return new Te(async T=>{for await(const s of l)w(s)&&T.emitOne(s)})}filter(l){return Te.filter(this,l)}static coalesce(l){return Te.filter(l,w=>!!w)}coalesce(){return Te.coalesce(this)}static async toPromise(l){const w=[];for await(const T of l)w.push(T);return w}toPromise(){return Te.toPromise(this)}h(l){this.a===0&&(this.b.push(l),this.g.fire())}j(l){this.a===0&&(this.b=this.b.concat(l),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(l){this.a===0&&(this.a=2,this.d=l,this.g.fire())}}t.$Rh=Te;class Me extends Te{constructor(l,w){super(w),this.m=l}cancel(){this.m.cancel()}}t.$Sh=Me;function H(v){const l=new i.$me,w=v(l.token);return new Me(l,async T=>{const s=l.token.onCancellationRequested(()=>{s.dispose(),l.dispose(),T.reject(new k.$5)});try{for await(const D of w){if(l.token.isCancellationRequested)return;T.emitOne(D)}s.dispose(),l.dispose()}catch(D){s.dispose(),l.dispose(),T.reject(D)}})}class u{constructor(l){this.a=new V,this.b=new Te(s=>{if(w){s.reject(w);return}return T&&s.emitMany(T),this.d=D=>s.reject(D),this.f=D=>s.emitOne(D),this.a.p},l);let w,T;this.f=s=>{T||(T=[]),T.push(s)},this.d=s=>{w||(w=s)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(l){this.d(l),this.a.complete()}emitOne(l){this.f(l)}}t.$Uh=u}),define(me[4],be([1,0,17,125,15,20,11,6,3,129,2,36,5,16,59,22]),function(se,t,i,k,P,W,S,A,g,b,p,O,c,f,e,n){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.$$S=t.$9S=t.$6S=t.DetectedFullscreenMode=t.Namespace=t.$DS=t.$BS=t.$sS=t.$1R=t.$UR=t.$SR=t.$RR=t.$QR=t.$LR=t.$KR=t.$JR=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$HR=h,t.$IR=y,t.$MR=N,t.$NR=I,t.$OR=M,t.$PR=E,t.$TR=q,t.$VR=B,t.$WR=Y,t.$XR=ee,t.$YR=ce,t.$ZR=De,t.$2R=le,t.$3R=_,t.$4R=ue,t.$5R=re,t.$6R=ye,t.$7R=V,t.$8R=Q,t.$9R=ge,t.$0R=we,t.$$R=Le,t.$_R=Me,t.$aS=H,t.$bS=v,t.$cS=w,t.$dS=T,t.$eS=s,t.$fS=D,t.$gS=$,t.$hS=R,t.$iS=j,t.$jS=U,t.$kS=J,t.$lS=oe,t.$mS=pe,t.$nS=fe,t.$oS=ke,t.$pS=Oe,t.$qS=Fe,t.$rS=We,t.$tS=Ue,t.$uS=_e,t.$vS=Ne,t.$wS=ze,t.$xS=et,t.$yS=it,t.$zS=st,t.$AS=Qe,t.$CS=rt,t.$ES=tt,t.$FS=mt,t.$GS=At,t.$HS=Lt,t.$IS=kt,t.$JS=Be,t.$KS=he,t.$=nt,t.$MS=lt,t.$NS=Ze,t.$OS=ut,t.$PS=$t,t.$QS=Xt,t.$RS=Si,t.$SS=Ai,t.$TS=Li,t.$US=ki,t.$VS=Ti,t.$WS=Fi,t.$XS=Ci,t.$YS=Ni,t.$ZS=Ri,t.$1S=Qt,t.$2S=Ii,t.$3S=Mi,t.$4S=ji,t.$5S=_t,t.$7S=Bi,t.$8S=zi,t.$0S=Hi,t.h=qi,t.$aT=ti,t.$bT=Gi,r=function(){const G=new Map;(0,n.$bR)(n.$cR,1);const X={window:n.$cR,disposables:new p.$Tc};G.set(n.$cR.vscodeWindowId,X);const te=new g.$be,de=new g.$be,Ae=new g.$be;function xe(Pe,qe){return(typeof Pe=="number"?G.get(Pe):void 0)??(qe?X:void 0)}return{onDidRegisterWindow:te.event,onWillUnregisterWindow:Ae.event,onDidUnregisterWindow:de.event,registerWindow(Pe){if(G.has(Pe.vscodeWindowId))return p.$Uc.None;const qe=new p.$Tc,Ke={window:Pe,disposables:qe.add(new p.$Tc)};return G.set(Pe.vscodeWindowId,Ke),qe.add((0,p.$Sc)(()=>{G.delete(Pe.vscodeWindowId),de.fire(Pe)})),qe.add(y(Pe,t.$BS.BEFORE_UNLOAD,()=>{Ae.fire(Pe)})),te.fire(Ke),qe},getWindows(){return G.values()},getWindowsCount(){return G.size},getWindowId(Pe){return Pe.vscodeWindowId},hasWindow(Pe){return G.has(Pe)},getWindowById:xe,getWindow(Pe){const qe=Pe;if(qe?.ownerDocument?.defaultView)return qe.ownerDocument.defaultView.window;const Ke=Pe;return Ke?.view?Ke.view.window:n.$cR},getDocument(Pe){const qe=Pe;return(0,t.getWindow)(qe).document}}}(),t.registerWindow=r.registerWindow,t.getWindow=r.getWindow,t.getDocument=r.getDocument,t.getWindows=r.getWindows,t.getWindowsCount=r.getWindowsCount,t.getWindowId=r.getWindowId,t.getWindowById=r.getWindowById,t.hasWindow=r.hasWindow,t.onDidRegisterWindow=r.onDidRegisterWindow,t.onWillUnregisterWindow=r.onWillUnregisterWindow,t.onDidUnregisterWindow=r.onDidUnregisterWindow;function h(G){for(;G.firstChild;)G.firstChild.remove()}class m{constructor(X,te,de,Ae){this.f=X,this.g=te,this.d=de,this.j=Ae||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function y(G,X,te,de){return new m(G,X,te,de)}function o(G,X){return function(te){return X(new W.$AR(G,te))}}function d(G){return function(X){return G(new P.$FR(X))}}const a=function(X,te,de,Ae){let xe=de;return te==="click"||te==="mousedown"?xe=o((0,t.getWindow)(X),de):(te==="keydown"||te==="keypress"||te==="keyup")&&(xe=d(de)),y(X,te,xe,Ae)};t.$JR=a;const L=function(X,te,de){const Ae=o((0,t.getWindow)(X),te);return N(X,Ae,de)};t.$KR=L;const C=function(X,te,de){const Ae=o((0,t.getWindow)(X),te);return M(X,Ae,de)};t.$LR=C;function N(G,X,te){return y(G,c.$r&&k.$xR.pointerEvents?t.$BS.POINTER_DOWN:t.$BS.MOUSE_DOWN,X,te)}function I(G,X,te){return y(G,c.$r&&k.$xR.pointerEvents?t.$BS.POINTER_MOVE:t.$BS.MOUSE_MOVE,X,te)}function M(G,X,te){return y(G,c.$r&&k.$xR.pointerEvents?t.$BS.POINTER_UP:t.$BS.MOUSE_UP,X,te)}function E(G,X,te){return(0,S.$Ih)(G,X,te)}class z extends S.$Jh{constructor(X,te){super(X,te)}}t.$QR=z;function q(G,X,te,de){let Ae=0;const xe=G.setInterval(()=>{Ae++,(typeof de=="number"&&Ae>=de||X()===!0)&&Pe.dispose()},te),Pe=(0,p.$Sc)(()=>{G.clearInterval(xe)});return Pe}class F extends S.$Ch{constructor(X){super(),this.f=X&&(0,t.getWindow)(X)}cancelAndSet(X,te,de){return super.cancelAndSet(X,te,de??this.f)}}t.$UR=F;class x{constructor(X,te=0){this.d=X,this.priority=te,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(X){(0,A.$1)(X)}}static sort(X,te){return te.priority-X.priority}}(function(){const G=new Map,X=new Map,te=new Map,de=new Map,Ae=xe=>{te.set(xe,!1);const Pe=G.get(xe)??[];for(X.set(xe,Pe),G.set(xe,[]),de.set(xe,!0);Pe.length>0;)Pe.sort(x.sort),Pe.shift().execute();de.set(xe,!1)};t.$SR=(xe,Pe,qe=0)=>{const Ke=(0,t.getWindowId)(xe),Ye=new x(Pe,qe);let at=G.get(Ke);return at||(at=[],G.set(Ke,at)),at.push(Ye),te.get(Ke)||(te.set(Ke,!0),xe.requestAnimationFrame(()=>Ae(Ke))),Ye},t.$RR=(xe,Pe,qe)=>{const Ke=(0,t.getWindowId)(xe);if(de.get(Ke)){const Ye=new x(Pe,qe);let at=X.get(Ke);return at||(at=[],X.set(Ke,at)),at.push(Ye),Ye}else return(0,t.$SR)(xe,Pe,qe)}})();function B(G,X){return(0,t.$SR)(G,X,1e4)}function Y(G,X){return(0,t.$SR)(G,X,-1e4)}const K=8,ae=function(G,X){return X};class ie extends p.$Uc{constructor(X,te,de,Ae=ae,xe=K){super();let Pe=null,qe=0;const Ke=this.B(new S.$Bh),Ye=()=>{qe=new Date().getTime(),de(Pe),Pe=null};this.B(y(X,te,at=>{Pe=Ae(Pe,at);const Ft=new Date().getTime()-qe;Ft>=xe?(Ke.cancel(),Ye()):Ke.setIfNotSet(Ye,xe-Ft)}))}}function ee(G,X,te,de,Ae){return new ie(G,X,te,de,Ae)}function ce(G){return(0,t.getWindow)(G).getComputedStyle(G,null)}function De(G,X){const te=(0,t.getWindow)(G),de=te.document;if(G!==de.body)return new Ie(G.clientWidth,G.clientHeight);if(c.$r&&te?.visualViewport)return new Ie(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Ie(te.innerWidth,te.innerHeight);if(de.body&&de.body.clientWidth&&de.body.clientHeight)return new Ie(de.body.clientWidth,de.body.clientHeight);if(de.documentElement&&de.documentElement.clientWidth&&de.documentElement.clientHeight)return new Ie(de.documentElement.clientWidth,de.documentElement.clientHeight);if(X)return De(X);throw new Error("Unable to figure out browser width and height")}class Ee{static d(X,te){return parseFloat(te)||0}static f(X,te,de){const Ae=ce(X),xe=Ae?Ae.getPropertyValue(te):"0";return Ee.d(X,xe)}static getBorderLeftWidth(X){return Ee.f(X,"border-left-width","borderLeftWidth")}static getBorderRightWidth(X){return Ee.f(X,"border-right-width","borderRightWidth")}static getBorderTopWidth(X){return Ee.f(X,"border-top-width","borderTopWidth")}static getBorderBottomWidth(X){return Ee.f(X,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(X){return Ee.f(X,"padding-left","paddingLeft")}static getPaddingRight(X){return Ee.f(X,"padding-right","paddingRight")}static getPaddingTop(X){return Ee.f(X,"padding-top","paddingTop")}static getPaddingBottom(X){return Ee.f(X,"padding-bottom","paddingBottom")}static getMarginLeft(X){return Ee.f(X,"margin-left","marginLeft")}static getMarginTop(X){return Ee.f(X,"margin-top","marginTop")}static getMarginRight(X){return Ee.f(X,"margin-right","marginRight")}static getMarginBottom(X){return Ee.f(X,"margin-bottom","marginBottom")}}class Ie{static{this.None=new Ie(0,0)}constructor(X,te){this.width=X,this.height=te}with(X=this.width,te=this.height){return X!==this.width||te!==this.height?new Ie(X,te):this}static is(X){return typeof X=="object"&&typeof X.height=="number"&&typeof X.width=="number"}static lift(X){return X instanceof Ie?X:new Ie(X.width,X.height)}static equals(X,te){return X===te?!0:!X||!te?!1:X.width===te.width&&X.height===te.height}}t.$1R=Ie;function le(G){let X=G.offsetParent,te=G.offsetTop,de=G.offsetLeft;for(;(G=G.parentNode)!==null&&G!==G.ownerDocument.body&&G!==G.ownerDocument.documentElement;){te-=G.scrollTop;const Ae=D(G)?null:ce(G);Ae&&(de-=Ae.direction!=="rtl"?G.scrollLeft:-G.scrollLeft),G===X&&(de+=Ee.getBorderLeftWidth(G),te+=Ee.getBorderTopWidth(G),te+=G.offsetTop,de+=G.offsetLeft,X=G.offsetParent)}return{left:de,top:te}}function _(G,X,te){typeof X=="number"&&(G.style.width=`${X}px`),typeof te=="number"&&(G.style.height=`${te}px`)}function ue(G,X,te,de,Ae,xe="absolute"){typeof X=="number"&&(G.style.top=`${X}px`),typeof te=="number"&&(G.style.right=`${te}px`),typeof de=="number"&&(G.style.bottom=`${de}px`),typeof Ae=="number"&&(G.style.left=`${Ae}px`),G.style.position=xe}function re(G){const X=G.getBoundingClientRect(),te=(0,t.getWindow)(G);return{left:X.left+te.scrollX,top:X.top+te.scrollY,width:X.width,height:X.height}}function ye(G){let X=G,te=1;do{const de=ce(X).zoom;de!=null&&de!=="1"&&(te*=de),X=X.parentElement}while(X!==null&&X!==X.ownerDocument.documentElement);return te}function V(G){const X=Ee.getMarginLeft(G)+Ee.getMarginRight(G);return G.offsetWidth+X}function Q(G){const X=Ee.getBorderLeftWidth(G)+Ee.getBorderRightWidth(G),te=Ee.getPaddingLeft(G)+Ee.getPaddingRight(G);return G.offsetWidth-X-te}function ge(G){const X=Ee.getMarginLeft(G)+Ee.getMarginRight(G);return G.scrollWidth+X}function we(G){const X=Ee.getBorderTopWidth(G)+Ee.getBorderBottomWidth(G),te=Ee.getPaddingTop(G)+Ee.getPaddingBottom(G);return G.offsetHeight-X-te}function Le(G){const X=Ee.getMarginTop(G)+Ee.getMarginBottom(G);return G.offsetHeight+X}function Te(G,X){if(G===null)return 0;const te=le(G),de=le(X);return te.left-de.left}function Me(G,X){const te=X.map(Ae=>Math.max(ge(Ae),V(Ae))+Te(Ae,G)||0);return Math.max(...te)}function H(G,X){return!!X?.contains(G)}const u="parentFlowToElementId";function v(G,X){G.dataset[u]=X.id}function l(G){const X=G.dataset[u];return typeof X=="string"?G.ownerDocument.getElementById(X):null}function w(G,X){let te=G;for(;te;){if(te===X)return!0;if(te instanceof HTMLElement){const de=l(te);if(de){te=de;continue}}te=te.parentNode}return!1}function T(G,X,te){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G.classList.contains(X))return G;if(te){if(typeof te=="string"){if(G.classList.contains(te))return null}else if(G===te)return null}G=G.parentNode}return null}function s(G,X,te){return!!T(G,X,te)}function D(G){return G&&!!G.host&&!!G.mode}function $(G){return!!R(G)}function R(G){for(;G.parentNode;){if(G===G.ownerDocument?.body)return null;G=G.parentNode}return D(G)?G:null}function j(){let G=pe().activeElement;for(;G?.shadowRoot;)G=G.shadowRoot.activeElement;return G}function U(G){return j()===G}function J(G){return H(j(),G)}function oe(G){return G.ownerDocument===pe()}function pe(){return(0,t.getWindowsCount)()<=1?n.$cR.document:Array.from((0,t.getWindows)()).map(({window:X})=>X.document).find(X=>X.hasFocus())??n.$cR.document}function fe(){return pe().defaultView?.window??n.$cR}const Re=new Map;function ke(G){return Re.has(G)}function Oe(){return new Se}class Se{constructor(){this.d="",this.f=void 0}setStyle(X){X!==this.d&&(this.d=X,this.f?this.f.innerText=X:this.f=Fe(n.$cR.document.head,te=>te.innerText=X))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Fe(G=n.$cR.document.head,X,te){const de=document.createElement("style");if(de.type="text/css",de.media="screen",X?.(de),G.appendChild(de),te&&te.add((0,p.$Sc)(()=>G.removeChild(de))),G===n.$cR.document.head){const Ae=new Set;Re.set(de,Ae);for(const{window:xe,disposables:Pe}of(0,t.getWindows)()){if(xe===n.$cR)continue;const qe=Pe.add(Xe(de,Ae,xe));te?.add(qe)}}return de}function We(G){const X=new p.$Tc;for(const[te,de]of Re)X.add(Xe(te,de,G));return X}function Xe(G,X,te){const de=new p.$Tc,Ae=G.cloneNode(!0);te.document.head.appendChild(Ae),de.add((0,p.$Sc)(()=>te.document.head.removeChild(Ae)));for(const xe of ve(G))Ae.sheet?.insertRule(xe.cssText,Ae.sheet?.cssRules.length);return de.add(t.$sS.observe(G,de,{childList:!0})(()=>{Ae.textContent=G.textContent})),X.add(Ae),de.add((0,p.$Sc)(()=>X.delete(Ae))),de}t.$sS=new class{constructor(){this.mutationObservers=new Map}observe(G,X,te){let de=this.mutationObservers.get(G);de||(de=new Map,this.mutationObservers.set(G,de));const Ae=(0,e.$fj)(te);let xe=de.get(Ae);if(xe)xe.users+=1;else{const Pe=new g.$be,qe=new MutationObserver(Ye=>Pe.fire(Ye));qe.observe(G,te);const Ke=xe={users:1,observer:qe,onDidMutate:Pe.event};X.add((0,p.$Sc)(()=>{Ke.users-=1,Ke.users===0&&(Pe.dispose(),qe.disconnect(),de?.delete(Ae),de?.size===0&&this.mutationObservers.delete(G))})),de.set(Ae,xe)}return xe.onDidMutate}};function Ue(G=n.$cR.document.head){return Z("meta",G)}function _e(G=n.$cR.document.head){return Z("link",G)}function Z(G,X=n.$cR.document.head){const te=document.createElement(G);return X.appendChild(te),te}let ne=null;function $e(){return ne||(ne=Fe()),ne}function ve(G){return G?.sheet?.rules?G.sheet.rules:G?.sheet?.cssRules?G.sheet.cssRules:[]}function Ne(G,X,te=$e()){if(!(!te||!X)){te.sheet?.insertRule(`${G} {${X}}`,0);for(const de of Re.get(te)??[])Ne(G,X,de)}}function ze(G,X=$e()){if(!X)return;const te=ve(X),de=[];for(let Ae=0;Ae<te.length;Ae++){const xe=te[Ae];Ve(xe)&&xe.selectorText.indexOf(G)!==-1&&de.push(Ae)}for(let Ae=de.length-1;Ae>=0;Ae--)X.sheet?.deleteRule(de[Ae]);for(const Ae of Re.get(X)??[])ze(G,Ae)}function Ve(G){return typeof G.selectorText=="string"}function et(G){return G instanceof MouseEvent||G instanceof(0,t.getWindow)(G).MouseEvent}function it(G){return G instanceof KeyboardEvent||G instanceof(0,t.getWindow)(G).KeyboardEvent}function st(G){return G instanceof PointerEvent||G instanceof(0,t.getWindow)(G).PointerEvent}function Qe(G){return G instanceof DragEvent||G instanceof(0,t.getWindow)(G).DragEvent}t.$BS={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$pR?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$pR?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$pR?"webkitAnimationIteration":"animationiteration"};function rt(G){const X=G;return!!(X&&typeof X.preventDefault=="function"&&typeof X.stopPropagation=="function")}t.$DS={stop:(G,X)=>(G.preventDefault(),X&&G.stopPropagation(),G)};function tt(G){const X=[];for(let te=0;G&&G.nodeType===G.ELEMENT_NODE;te++)X[te]=G.scrollTop,G=G.parentNode;return X}function mt(G,X){for(let te=0;G&&G.nodeType===G.ELEMENT_NODE;te++)G.scrollTop!==X[te]&&(G.scrollTop=X[te]),G=G.parentNode}class gt extends p.$Uc{static m(X){if(X instanceof HTMLElement){const te=R(X),de=te?te.activeElement:X.ownerDocument.activeElement;return H(de,X)}else{const te=X;return H(te.document.activeElement,te.document)}}constructor(X){super(),this.f=this.B(new g.$be),this.onDidFocus=this.f.event,this.g=this.B(new g.$be),this.onDidBlur=this.g.event;let te=gt.m(X),de=!1;const Ae=()=>{de=!1,te||(te=!0,this.f.fire())},xe=()=>{te&&(de=!0,(X instanceof HTMLElement?(0,t.getWindow)(X):X).setTimeout(()=>{de&&(de=!1,te=!1,this.g.fire())},0))};this.j=()=>{gt.m(X)!==te&&(te?xe():Ae())},this.B(y(X,t.$BS.FOCUS,Ae,!0)),this.B(y(X,t.$BS.BLUR,xe,!0)),X instanceof HTMLElement&&(this.B(y(X,t.$BS.FOCUS_IN,()=>this.j())),this.B(y(X,t.$BS.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function At(G){return new gt(G)}function Lt(G,X){return G.after(X),X}function kt(G,...X){if(G.append(...X),X.length===1&&typeof X[0]!="string")return X[0]}function Be(G,X){return G.insertBefore(X,G.firstChild),X}function he(G,...X){G.innerText="",kt(G,...X)}const Ce=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var je;(function(G){G.HTML="http://www.w3.org/1999/xhtml",G.SVG="http://www.w3.org/2000/svg"})(je||(t.Namespace=je={}));function Ge(G,X,te,...de){const Ae=Ce.exec(X);if(!Ae)throw new Error("Bad use of emmet");const xe=Ae[1]||"div";let Pe;return G!==je.HTML?Pe=document.createElementNS(G,xe):Pe=document.createElement(xe),Ae[3]&&(Pe.id=Ae[3]),Ae[4]&&(Pe.className=Ae[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([qe,Ke])=>{typeof Ke>"u"||(/^on\w+$/.test(qe)?Pe[qe]=Ke:qe==="selected"?Ke&&Pe.setAttribute(qe,"true"):Pe.setAttribute(qe,Ke))}),Pe.append(...de),Pe}function nt(G,X,...te){return Ge(je.HTML,G,X,...te)}nt.SVG=function(G,X,...te){return Ge(je.SVG,G,X,...te)};function lt(G,X){const te=[];return G.forEach((de,Ae)=>{Ae>0&&(X instanceof Node?te.push(X.cloneNode()):te.push(document.createTextNode(X))),te.push(de)}),te}function Ze(G,...X){G?ut(...X):$t(...X)}function ut(...G){for(const X of G)X.style.display="",X.removeAttribute("aria-hidden")}function $t(...G){for(const X of G)X.style.display="none",X.setAttribute("aria-hidden","true")}function Tt(G,X){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G instanceof HTMLElement&&G.hasAttribute(X))return G;G=G.parentNode}return null}function Xt(G){!G||!G.hasAttribute("tabIndex")||(G.ownerDocument.activeElement===G&&Tt(G.parentElement,"tabIndex")?.focus(),G.removeAttribute("tabindex"))}function Si(G){return X=>{X.preventDefault(),X.stopPropagation(),G(X)}}function Ai(G){return new Promise(X=>{if(G.document.readyState==="complete"||G.document&&G.document.body!==null)X(void 0);else{const de=()=>{G.window.removeEventListener("DOMContentLoaded",de,!1),X()};G.window.addEventListener("DOMContentLoaded",de,!1)}})}function Li(G,X){const te=G.devicePixelRatio*X;return Math.max(1,Math.floor(te))/G.devicePixelRatio}function ki(G){n.$cR.open(G,"_blank","noopener")}const Zt=780,Jt=640;function Ti(G){const X=Math.floor(n.$cR.screenLeft+n.$cR.innerWidth/2-Zt/2),te=Math.floor(n.$cR.screenTop+n.$cR.innerHeight/2-Jt/2);n.$cR.open(G,"_blank",`width=${Zt},height=${Jt},top=${te},left=${X}`)}function Fi(G,X=!0){const te=n.$cR.open();return te?(X&&(te.opener=null),te.location.href=G,!0):!1}function Ci(G,X){const te=()=>{X(),de=(0,t.$SR)(G,te)};let de=(0,t.$SR)(G,te);return(0,p.$Sc)(()=>de.dispose())}O.$Eg.setPreferredWebSchema(/^https:/.test(n.$cR.location.href)?"https":"http");function Ni(G){return G?`url('${O.$Lg.uriToBrowserUri(G).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Ri(G){return`'${G.replace(/'/g,"%27")}'`}function Qt(G,X){if(G!==void 0){const te=G.match(/^\s*var\((.+)\)$/);if(te){const de=te[1].split(",",2);return de.length===2&&(X=Qt(de[1].trim(),X)),`var(${de[0]}, ${X})`}return G}return X}function Ii(G,X){let te;if(f.URI.isUri(G))te=G.toString(!0);else{const xe=new Blob([G]);te=URL.createObjectURL(xe),setTimeout(()=>URL.revokeObjectURL(te))}const de=fe(),Ae=document.createElement("a");de.document.body.appendChild(Ae),Ae.download=X,Ae.href=te,Ae.click(),setTimeout(()=>de.document.body.removeChild(Ae))}function Mi(){return new Promise(G=>{const X=fe(),te=document.createElement("input");X.document.body.appendChild(te),te.type="file",te.multiple=!0,g.Event.once(g.Event.fromDOMEventEmitter(te,"input"))(()=>{G(te.files??void 0)}),te.click(),setTimeout(()=>X.document.body.removeChild(te))})}var yt;(function(G){G[G.DOCUMENT=1]="DOCUMENT",G[G.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function ji(G){return G.document.fullscreenElement||G.document.webkitFullscreenElement||G.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:G.innerHeight===G.screen.height?{mode:yt.BROWSER,guess:!1}:(c.$j||c.$k)&&G.outerHeight===G.screen.height&&G.outerWidth===G.screen.width?{mode:yt.BROWSER,guess:!0}:null}function _t(G,X=!1){const te=document.createElement("a");return b.addHook("afterSanitizeAttributes",de=>{for(const Ae of["href","src"])if(de.hasAttribute(Ae)){const xe=de.getAttribute(Ae);if(Ae==="href"&&xe.startsWith("#"))continue;if(te.href=xe,!G.includes(te.protocol.replace(/:$/,""))){if(X&&Ae==="src"&&te.href.startsWith("data:"))continue;de.removeAttribute(Ae)}}}),(0,p.$Sc)(()=>{b.removeHook("afterSanitizeAttributes")})}const Oi=[O.Schemas.http,O.Schemas.https,O.Schemas.command];t.$6S=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Pi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(G,X){const te=_t(Oi);try{const de=b.sanitize(X,Pi);G.innerHTML=de}finally{te.dispose()}}function xi(G){const X=new Uint16Array(G.length);for(let Ae=0;Ae<X.length;Ae++)X[Ae]=G.charCodeAt(Ae);let te="";const de=new Uint8Array(X.buffer);for(let Ae=0;Ae<de.length;Ae++)te+=String.fromCharCode(de[Ae]);return te}function zi(G){return btoa(xi(G))}class pt extends g.$be{constructor(){super(),this.o=new p.$Tc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(g.Event.runAndSubscribe(t.onDidRegisterWindow,({window:X,disposables:te})=>this.C(X,te),{window:n.$cR,disposables:this.o}))}C(X,te){te.add(y(X,"keydown",de=>{if(de.defaultPrevented)return;const Ae=new P.$FR(de);if(!(Ae.keyCode===6&&de.repeat)){if(de.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(de.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(de.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(de.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Ae.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyPressed&&(this.A.event=de,this.fire(this.A))}},!0)),te.add(y(X,"keyup",de=>{de.defaultPrevented||(!de.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!de.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!de.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!de.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyReleased&&(this.A.event=de,this.fire(this.A)))},!0)),te.add(y(X.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(y(X.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(y(X.document.body,"mousemove",de=>{de.buttons&&(this.A.lastKeyPressed=void 0)},!0)),te.add(y(X,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$9S=pt;function Hi(G){const X=document.cookie.match("(^|[^;]+)\\s*"+G+"\\s*=\\s*([^;]+)");return X?X.pop():void 0}class Wi extends p.$Uc{constructor(X,te){super(),this.j=X,this.m=te,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(y(this.j,t.$BS.DRAG_START,X=>{this.m.onDragStart?.(X)})),this.m.onDrag&&this.B(y(this.j,t.$BS.DRAG,X=>{this.m.onDrag?.(X)})),this.B(y(this.j,t.$BS.DRAG_ENTER,X=>{this.f++,this.g=X.timeStamp,this.m.onDragEnter?.(X)})),this.B(y(this.j,t.$BS.DRAG_OVER,X=>{X.preventDefault(),this.m.onDragOver?.(X,X.timeStamp-this.g)})),this.B(y(this.j,t.$BS.DRAG_LEAVE,X=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(X))})),this.B(y(this.j,t.$BS.DRAG_END,X=>{this.f=0,this.g=0,this.m.onDragEnd?.(X)})),this.B(y(this.j,t.$BS.DROP,X=>{this.f=0,this.g=0,this.m.onDrop?.(X)}))}}t.$$S=Wi;const Vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(G,...X){let te,de;Array.isArray(X[0])?(te={},de=X[0]):(te=X[0]||{},de=X[1]);const Ae=Vi.exec(G);if(!Ae||!Ae.groups)throw new Error("Bad use of h");const xe=Ae.groups.tag||"div",Pe=document.createElement(xe);Ae.groups.id&&(Pe.id=Ae.groups.id);const qe=[];if(Ae.groups.class)for(const Ye of Ae.groups.class.split("."))Ye!==""&&qe.push(Ye);if(te.className!==void 0)for(const Ye of te.className.split("."))Ye!==""&&qe.push(Ye);qe.length>0&&(Pe.className=qe.join(" "));const Ke={};if(Ae.groups.name&&(Ke[Ae.groups.name]=Pe),de)for(const Ye of de)Ye instanceof HTMLElement?Pe.appendChild(Ye):typeof Ye=="string"?Pe.append(Ye):"root"in Ye&&(Object.assign(Ke,Ye),Pe.appendChild(Ye.root));for(const[Ye,at]of Object.entries(te))if(Ye!=="className")if(Ye==="style")for(const[Ft,Pt]of Object.entries(at))Pe.style.setProperty(ei(Ft),typeof Pt=="number"?Pt+"px":""+Pt);else Ye==="tabIndex"?Pe.tabIndex=at:Pe.setAttribute(ei(Ye),at.toString());return Ke.root=Pe,Ke}function ei(G){return G.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(G,X,te){for(const{name:de,value:Ae}of G.attributes)(!te||te.includes(de))&&X.setAttribute(de,Ae)}function Ki(G,X,te){const de=G.getAttribute(te);de?X.setAttribute(te,de):X.removeAttribute(te)}function Gi(G,X,te){ti(G,X,te);const de=new p.$Tc;return de.add(t.$sS.observe(G,de,{attributes:!0,attributeFilter:te})(Ae=>{for(const xe of Ae)xe.type==="attributes"&&xe.attributeName&&Ki(G,X,xe.attributeName)})),de}}),define(me[65],be([1,0,4,2,128]),function(se,t,i,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dT=t.$cT=void 0,t.$eT=S;class W extends k.$Uc{constructor(g,b){super(),this.B((0,i.$IR)(g,"dragover",p=>{p.preventDefault(),this.a||(this.a=setTimeout(()=>{b(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(p=>{this.B((0,i.$IR)(g,p,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$cT=W,t.$dT={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:P.$Ks.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function S(A,g,b,p,O){const c=document.createElement("div");if(c.className=b,c.textContent=g,O&&(c.style.color=O),p&&(c.style.background=p),A.dataTransfer){const f=(0,i.getWindow)(A).document;f.body.appendChild(c),A.dataTransfer.setDragImage(c,-10,-10),setTimeout(()=>f.body.removeChild(c),0)}}}),define(me[66],be([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HT=k,t.$IT=P,t.$JT=W;function k(c,f={}){const e=W(f);return e.textContent=c,e}function P(c,f={}){const e=W(f);return g(e,b(c,!!f.renderCodeSegments),f.actionHandler,f.renderCodeSegments),e}function W(c){const f=c.inline?"span":"div",e=document.createElement(f);return c.className&&(e.className=c.className),e}class S{constructor(f){this.b=f,this.c=0}eos(){return this.c>=this.b.length}next(){const f=this.peek();return this.advance(),f}peek(){return this.b[this.c]}advance(){this.c++}}var A;(function(c){c[c.Invalid=0]="Invalid",c[c.Root=1]="Root",c[c.Text=2]="Text",c[c.Bold=3]="Bold",c[c.Italics=4]="Italics",c[c.Action=5]="Action",c[c.ActionClose=6]="ActionClose",c[c.Code=7]="Code",c[c.NewLine=8]="NewLine"})(A||(A={}));function g(c,f,e,n){let r;if(f.type===2)r=document.createTextNode(f.content||"");else if(f.type===3)r=document.createElement("b");else if(f.type===4)r=document.createElement("i");else if(f.type===7&&n)r=document.createElement("code");else if(f.type===5&&e){const h=document.createElement("a");e.disposables.add(i.$JR(h,"click",m=>{e.callback(String(f.index),m)})),r=h}else f.type===8?r=document.createElement("br"):f.type===1&&(r=c);r&&c!==r&&c.appendChild(r),r&&Array.isArray(f.children)&&f.children.forEach(h=>{g(r,h,e,n)})}function b(c,f){const e={type:1,children:[]};let n=0,r=e;const h=[],m=new S(c);for(;!m.eos();){let y=m.next();const o=y==="\\"&&O(m.peek(),f)!==0;if(o&&(y=m.next()),!o&&p(y,f)&&y===m.peek()){m.advance(),r.type===2&&(r=h.pop());const d=O(y,f);if(r.type===d||r.type===5&&d===6)r=h.pop();else{const a={type:d,children:[]};d===5&&(a.index=n,n++),r.children.push(a),h.push(r),r=a}}else if(y===`
`)r.type===2&&(r=h.pop()),r.children.push({type:8});else if(r.type!==2){const d={type:2,content:y};r.children.push(d),h.push(r),r=d}else r.content+=y}return r.type===2&&(r=h.pop()),h.length,e}function p(c,f){return O(c,f)!==0}function O(c,f){switch(c){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return f?7:0;default:return 0}}}),define(me[67],be([1,0,4,2]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iT=void 0;class P{constructor(){this.a=new k.$Tc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(S,A){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const g=this.c;this.c=null,S&&g&&g(A)}isMonitoring(){return!!this.b}startMonitoring(S,A,g,b,p){this.isMonitoring()&&this.stopMonitoring(!1),this.b=b,this.c=p;let O=S;try{S.setPointerCapture(A),this.a.add((0,k.$Sc)(()=>{try{S.releasePointerCapture(A)}catch{}}))}catch{O=i.getWindow(S)}this.a.add(i.$IR(O,i.$BS.POINTER_MOVE,c=>{if(c.buttons!==g){this.stopMonitoring(!0);return}c.preventDefault(),this.b(c)})),this.a.add(i.$IR(O,i.$BS.POINTER_UP,c=>this.stopMonitoring(!0)))}}t.$iT=P});var Je=this&&this.__decorate||function(se,t,i,k){var P=arguments.length,W=P<3?t:k===null?k=Object.getOwnPropertyDescriptor(t,i):k,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(se,t,i,k);else for(var A=se.length-1;A>=0;A--)(S=se[A])&&(W=(P<3?S(W):P>3?S(t,i,W):S(t,i))||W);return P>3&&W&&Object.defineProperty(t,i,W),W};define(me[28],be([1,0,4,22,8,31,3,2,55]),function(se,t,i,k,P,W,S,A,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fT=t.EventType=void 0;var b;(function(O){O.Tap="-monaco-gesturetap",O.Change="-monaco-gesturechange",O.Start="-monaco-gesturestart",O.End="-monaco-gesturesend",O.Contextmenu="-monaco-gesturecontextmenu"})(b||(t.EventType=b={}));class p extends A.$Uc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new g.$5c,this.m=new g.$5c,this.r={},this.n=null,this.s=0,this.B(S.Event.runAndSubscribe(i.onDidRegisterWindow,({window:c,disposables:f})=>{f.add(i.$IR(c.document,"touchstart",e=>this.w(e),{passive:!1})),f.add(i.$IR(c.document,"touchend",e=>this.z(c,e))),f.add(i.$IR(c.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:k.$cR,disposables:this.q}))}static addTarget(c){if(!p.isTouchDevice())return A.$Uc.None;p.f||(p.f=(0,A.$Nc)(new p));const f=p.f.j.push(c);return(0,A.$Sc)(f)}static ignoreTarget(c){if(!p.isTouchDevice())return A.$Uc.None;p.f||(p.f=(0,A.$Nc)(new p));const f=p.f.m.push(c);return(0,A.$Sc)(f)}static isTouchDevice(){return"ontouchstart"in k.$cR||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w(c){const f=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,n=c.targetTouches.length;e<n;e++){const r=c.targetTouches.item(e);this.r[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:f,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[f],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const h=this.C(b.Start,r.target);h.pageX=r.pageX,h.pageY=r.pageY,this.D(h)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}z(c,f){const e=Date.now(),n=Object.keys(this.r).length;for(let r=0,h=f.changedTouches.length;r<h;r++){const m=f.changedTouches.item(r);if(!this.r.hasOwnProperty(String(m.identifier))){console.warn("move of an UNKNOWN touch",m);continue}const y=this.r[m.identifier],o=Date.now()-y.initialTimeStamp;if(o<p.g&&Math.abs(y.initialPageX-P.$sb(y.rollingPageX))<30&&Math.abs(y.initialPageY-P.$sb(y.rollingPageY))<30){const d=this.C(b.Tap,y.initialTarget);d.pageX=P.$sb(y.rollingPageX),d.pageY=P.$sb(y.rollingPageY),this.D(d)}else if(o>=p.g&&Math.abs(y.initialPageX-P.$sb(y.rollingPageX))<30&&Math.abs(y.initialPageY-P.$sb(y.rollingPageY))<30){const d=this.C(b.Contextmenu,y.initialTarget);d.pageX=P.$sb(y.rollingPageX),d.pageY=P.$sb(y.rollingPageY),this.D(d)}else if(n===1){const d=P.$sb(y.rollingPageX),a=P.$sb(y.rollingPageY),L=P.$sb(y.rollingTimestamps)-y.rollingTimestamps[0],C=d-y.rollingPageX[0],N=a-y.rollingPageY[0],I=[...this.j].filter(M=>y.initialTarget instanceof Node&&M.contains(y.initialTarget));this.F(c,I,e,Math.abs(C)/L,C>0?1:-1,d,Math.abs(N)/L,N>0?1:-1,a)}this.D(this.C(b.End,y.initialTarget)),delete this.r[m.identifier]}this.h&&(f.preventDefault(),f.stopPropagation(),this.h=!1)}C(c,f){const e=document.createEvent("CustomEvent");return e.initEvent(c,!1,!0),e.initialTarget=f,e.tapCount=0,e}D(c){if(c.type===b.Tap){const f=new Date().getTime();let e=0;f-this.s>p.u?e=1:e=2,this.s=f,c.tapCount=e}else(c.type===b.Change||c.type===b.Contextmenu)&&(this.s=0);if(c.initialTarget instanceof Node){for(const e of this.m)if(e.contains(c.initialTarget))return;const f=[];for(const e of this.j)if(e.contains(c.initialTarget)){let n=0,r=c.initialTarget;for(;r&&r!==e;)n++,r=r.parentElement;f.push([n,e])}f.sort((e,n)=>e[0]-n[0]);for(const[e,n]of f)n.dispatchEvent(c),this.h=!0}}F(c,f,e,n,r,h,m,y,o){this.n=i.$SR(c,()=>{const d=Date.now(),a=d-e;let L=0,C=0,N=!0;n+=p.c*a,m+=p.c*a,n>0&&(N=!1,L=r*n*a),m>0&&(N=!1,C=y*m*a);const I=this.C(b.Change);I.translationX=L,I.translationY=C,f.forEach(M=>M.dispatchEvent(I)),N||this.F(c,f,d,n,r,h+L,m,y,o+C)})}G(c){const f=Date.now();for(let e=0,n=c.changedTouches.length;e<n;e++){const r=c.changedTouches.item(e);if(!this.r.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const h=this.r[r.identifier],m=this.C(b.Change,h.initialTarget);m.translationX=r.pageX-P.$sb(h.rollingPageX),m.translationY=r.pageY-P.$sb(h.rollingPageY),m.pageX=r.pageX,m.pageY=r.pageY,this.D(m),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(r.pageX),h.rollingPageY.push(r.pageY),h.rollingTimestamps.push(f)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}}t.$fT=p,Je([W.$Vh],p,"isTouchDevice",null)}),define(me[68],be([1,0,4,104]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LT=b,t.$MT=p,t.$NT=O;const k=2e4;let P,W,S,A,g;function b(f){P=document.createElement("div"),P.className="monaco-aria-container";const e=()=>{const r=document.createElement("div");return r.className="monaco-alert",r.setAttribute("role","alert"),r.setAttribute("aria-atomic","true"),P.appendChild(r),r};W=e(),S=e();const n=()=>{const r=document.createElement("div");return r.className="monaco-status",r.setAttribute("aria-live","polite"),r.setAttribute("aria-atomic","true"),P.appendChild(r),r};A=n(),g=n(),f.appendChild(P)}function p(f){P&&(W.textContent!==f?(i.$HR(S),c(W,f)):(i.$HR(W),c(S,f)))}function O(f){P&&(A.textContent!==f?(i.$HR(g),c(A,f)):(i.$HR(A),c(g,f)))}function c(f,e){i.$HR(f),e.length>k&&(e=e.substr(0,k)),f.textContent=e,f.style.visibility="hidden",f.style.visibility="visible"}}),define(me[130],be([1,0,4,19]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eU=W,t.$fU=S;const P=new RegExp(`(\\\\)?\\$\\((${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(A){const g=new Array;let b,p=0,O=0;for(;(b=P.exec(A))!==null;){O=b.index||0,p<O&&g.push(A.substring(p,O)),p=(b.index||0)+b[0].length;const[,c,f]=b;g.push(c?`$(${f})`:S({id:f}))}return p<A.length&&g.push(A.substring(p)),g}function S(A){const g=i.$("span");return g.classList.add(...k.ThemeIcon.asClassNameArray(A)),g}}),define(me[131],be([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TT=void 0;function k(W){try{W.parentElement?.removeChild(W)}catch{}}class P{constructor(S){this.d=S,this.a=new Map,this.b=new Set,this.c=!1}alloc(S){let A=this.h(S).pop(),g=!1;if(A)g=this.b.has(A.domNode),g&&this.b.delete(A.domNode);else{const b=(0,i.$)(".monaco-list-row"),O=this.i(S).renderTemplate(b);A={domNode:b,templateId:S,templateData:O}}return{row:A,isReusingConnectedDomNode:g}}release(S){S&&this.f(S)}transact(S){if(this.c)throw new Error("Already in transaction");this.c=!0;try{S()}finally{for(const A of this.b)this.g(A);this.b.clear(),this.c=!1}}f(S){const{domNode:A,templateId:g}=S;A&&(this.c?this.b.add(A):this.g(A)),this.h(g).push(S)}g(S){S.classList.remove("scrolling"),k(S)}h(S){let A=this.a.get(S);return A||(A=[],this.a.set(S,A)),A}dispose(){this.a.forEach((S,A)=>{for(const g of S)this.i(A).disposeTemplate(g.templateData),g.templateData=null}),this.a.clear(),this.b.clear()}i(S){const A=this.d.get(S);if(!A)throw new Error(`No renderer found for ${S}`);return A}}t.$TT=P}),define(me[132],be([1,0,11,2]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nT=void 0;class P extends k.$Uc{constructor(S,A,g){super(),this.a=S,this.b=A,this.c=g,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$Bh)}setVisibility(S){this.a!==S&&(this.a=S,this.s())}setShouldBeVisible(S){this.g=S,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const S=this.r();this.h!==S&&(this.h=S,this.ensureVisibility())}setIsNeeded(S){this.j!==S&&(this.j=S,this.ensureVisibility())}setDomNode(S){this.f=S,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(S){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(S?" fade":"")))}}t.$nT=P}),define(me[133],be([1,0,4,28,8,3,2,5]),function(se,t,i,k,P,W,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oU=void 0;class g extends S.$Uc{constructor(p,O,c,f){super(),this.f=0,this.b=f||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new W.$be),this.h=c,this.j(),this.setOptions(p,O)}j(){this.B(k.$fT.addTarget(this.a)),[k.EventType.Tap].forEach(p=>{this.B(i.$IR(this.a,p,O=>{this.a.focus()}))}),this.B(i.$JR(this.a,"click",p=>{i.$DS.stop(p,!0)})),this.B(i.$JR(this.a,"change",p=>{this.a.title=p.target.value,this.g.fire({index:p.target.selectedIndex,selected:p.target.value})})),this.B(i.$JR(this.a,"keydown",p=>{let O=!1;A.$j?(p.keyCode===18||p.keyCode===16||p.keyCode===10)&&(O=!0):(p.keyCode===18&&p.altKey||p.keyCode===10||p.keyCode===3)&&(O=!0),O&&p.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(p,O){(!this.c||!P.$ub(this.c,p))&&(this.c=p,this.a.options.length=0,this.c.forEach((c,f)=>{this.a.add(this.m(c.text,f,c.isDisabled))})),O!==void 0&&this.select(O)}select(p){this.c.length===0?this.f=0:p>=0&&p<this.c.length?this.f=p:p>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(p){this.b.ariaLabel=p,this.a.setAttribute("aria-label",p)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(p){this.a.tabIndex=p?0:-1}render(p){p.classList.add("select-container"),p.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(p){this.h=p,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(p,O,c){const f=document.createElement("option");return f.value=p,f.text=p,f.disabled=!!c,f}}t.$oU=g}),define(me[69],be([1,0,30,8,11,60,98,3,32]),function(se,t,i,k,P,W,S,A,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YV=void 0,t.$WV=b,t.$XV=p;function b(f){return typeof f=="object"&&"visibility"in f&&"data"in f}function p(f){switch(f){case!0:return 1;case!1:return 0;default:return f}}function O(f){return typeof f.collapsible=="boolean"}class c{constructor(e,n,r,h={}){this.p=e,this.q=n,this.rootRef=[],this.d=new A.$je,this.f=new A.$be,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new A.$be,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new A.$be,this.onDidSplice=this.m.event,this.o=new P.$oh(W.$$d),this.h=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.j=h.allowNonCollapsibleParents??!1,this.k=h.filter,this.l=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.c={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,n,r=g.Iterable.empty(),h={}){if(e.length===0)throw new i.$UV(this.p,"Invalid tree location");h.diffIdentityProvider?this.s(h.diffIdentityProvider,e,n,r,h):this.t(e,n,r,h)}s(e,n,r,h=g.Iterable.empty(),m,y=m.diffDepth??0){const{parentNode:o}=this.H(n);if(!o.lastDiffIds)return this.t(n,r,h,m);const d=[...h],a=n[n.length-1],L=new S.$tt({getElements:()=>o.lastDiffIds},{getElements:()=>[...o.children.slice(0,a),...d,...o.children.slice(a+r)].map(E=>e.getId(E.element).toString())}).ComputeDiff(!1);if(L.quitEarly)return o.lastDiffIds=void 0,this.t(n,r,d,m);const C=n.slice(0,-1),N=(E,z,q)=>{if(y>0)for(let F=0;F<q;F++)E--,z--,this.s(e,[...C,E,0],Number.MAX_SAFE_INTEGER,d[z].children,m,y-1)};let I=Math.min(o.children.length,a+r),M=d.length;for(const E of L.changes.sort((z,q)=>q.originalStart-z.originalStart))N(I,M,I-(E.originalStart+E.originalLength)),I=E.originalStart,M=E.modifiedStart-a,this.t([...C,I],E.originalLength,g.Iterable.slice(d,M,M+E.modifiedLength),m);N(I,M,I)}t(e,n,r=g.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:m,diffIdentityProvider:y}){const{parentNode:o,listIndex:d,revealed:a,visible:L}=this.H(e),C=[],N=g.Iterable.map(r,Y=>this.x(Y,o,o.visible?1:0,a,C,h)),I=e[e.length-1];let M=0;for(let Y=I;Y>=0&&Y<o.children.length;Y--){const K=o.children[Y];if(K.visible){M=K.visibleChildIndex;break}}const E=[];let z=0,q=0;for(const Y of N)E.push(Y),q+=Y.renderNodeCount,Y.visible&&(Y.visibleChildIndex=M+z++);const F=(0,k.$6b)(o.children,I,n,E);y?o.lastDiffIds?(0,k.$6b)(o.lastDiffIds,I,n,E.map(Y=>y.getId(Y.element).toString())):o.lastDiffIds=o.children.map(Y=>y.getId(Y.element).toString()):o.lastDiffIds=void 0;let x=0;for(const Y of F)Y.visible&&x++;if(x!==0)for(let Y=I+E.length;Y<o.children.length;Y++){const K=o.children[Y];K.visible&&(K.visibleChildIndex-=x)}if(o.visibleChildrenCount+=z-x,a&&L){const Y=F.reduce((K,ae)=>K+(ae.visible?ae.renderNodeCount:0),0);this.C(o,q-Y),this.q.splice(d,Y,C)}if(F.length>0&&m){const Y=K=>{m(K),K.children.forEach(Y)};F.forEach(Y)}this.m.fire({insertedNodes:E,deletedNodes:F});let B=o;for(;B;){if(B.visibility===2){this.o.trigger(()=>this.refilter());break}B=B.parent}}rerender(e){if(e.length===0)throw new i.$UV(this.p,"Invalid tree location");const{node:n,listIndex:r,revealed:h}=this.G(e);n.visible&&h&&this.q.splice(r,1,[n])}updateElementHeight(e,n){if(e.length===0)throw new i.$UV(this.p,"Invalid tree location");const{listIndex:r}=this.G(e);this.q.updateElementHeight(r,n)}has(e){return this.E(e)}getListIndex(e){const{listIndex:n,visible:r,revealed:h}=this.G(e);return r&&h?n:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,n){const r=this.F(e);typeof n>"u"&&(n=!r.collapsible);const h={collapsible:n};return this.d.bufferEvents(()=>this.u(e,h))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,n,r){const h=this.F(e);typeof n>"u"&&(n=!h.collapsed);const m={collapsed:n,recursive:r||!1};return this.d.bufferEvents(()=>this.u(e,m))}u(e,n){const{node:r,listIndex:h,revealed:m}=this.G(e),y=this.v(r,h,m,n);if(r!==this.c&&this.l&&y&&!O(n)&&r.collapsible&&!r.collapsed&&!n.recursive){let o=-1;for(let d=0;d<r.children.length;d++)if(r.children[d].visible)if(o>-1){o=-1;break}else o=d;o>-1&&this.u([...e,o],n)}return y}v(e,n,r,h){const m=this.w(e,h,!1);if(!r||!e.visible||!m)return m;const y=e.renderNodeCount,o=this.y(e),d=y-(n===-1?0:1);return this.q.splice(n+1,d,o.slice(1)),m}w(e,n,r){let h;if(e===this.c?h=!1:(O(n)?(h=e.collapsible!==n.collapsible,e.collapsible=n.collapsible):e.collapsible?(h=e.collapsed!==n.collapsed,e.collapsed=n.collapsed):h=!1,h&&this.f.fire({node:e,deep:r})),!O(n)&&n.recursive)for(const m of e.children)h=this.w(m,n,!0)||h;return h}expandTo(e){this.d.bufferEvents(()=>{let n=this.F(e);for(;n.parent;)n=n.parent,e=e.slice(0,e.length-1),n.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,n=this.A(this.c);this.q.splice(0,e,n),this.o.cancel()}x(e,n,r,h,m,y){const o={parent:n,element:e.element,children:[],depth:n.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},d=this.D(o,r);o.visibility=d,h&&m.push(o);const a=e.children||g.Iterable.empty(),L=h&&d!==0&&!o.collapsed;let C=0,N=1;for(const I of a){const M=this.x(I,o,d,L,m,y);o.children.push(M),N+=M.renderNodeCount,M.visible&&(M.visibleChildIndex=C++)}return this.j||(o.collapsible=o.collapsible||o.children.length>0),o.visibleChildrenCount=C,o.visible=d===2?C>0:d===1,o.visible?o.collapsed||(o.renderNodeCount=N):(o.renderNodeCount=0,h&&m.pop()),y?.(o),o}y(e){const n=e.renderNodeCount,r=[];return this.z(e,r),this.C(e.parent,r.length-n),r}z(e,n){if(e.visible===!1)return 0;if(n.push(e),e.renderNodeCount=1,!e.collapsed)for(const r of e.children)e.renderNodeCount+=this.z(r,n);return this.g.fire(e),e.renderNodeCount}A(e){const n=e.renderNodeCount,r=[];return this.B(e,e.visible?1:0,r),this.C(e.parent,r.length-n),r}B(e,n,r,h=!0){let m;if(e!==this.c){if(m=this.D(e,n),m===0)return e.visible=!1,e.renderNodeCount=0,!1;h&&r.push(e)}const y=r.length;e.renderNodeCount=e===this.c?0:1;let o=!1;if(!e.collapsed||m!==0){let d=0;for(const a of e.children)o=this.B(a,m,r,h&&!e.collapsed)||o,a.visible&&(a.visibleChildIndex=d++);e.visibleChildrenCount=d}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=m===2?o:m===1,e.visibility=m),e.visible?e.collapsed||(e.renderNodeCount+=r.length-y):(e.renderNodeCount=0,h&&r.pop()),this.g.fire(e),e.visible}C(e,n){if(n!==0)for(;e;)e.renderNodeCount+=n,this.g.fire(e),e=e.parent}D(e,n){const r=this.k?this.k.filter(e.element,n):1;return typeof r=="boolean"?(e.filterData=void 0,r?1:0):b(r)?(e.filterData=r.data,p(r.visibility)):(e.filterData=void 0,p(r))}E(e,n=this.c){if(!e||e.length===0)return!0;const[r,...h]=e;return r<0||r>n.children.length?!1:this.E(h,n.children[r])}F(e,n=this.c){if(!e||e.length===0)return n;const[r,...h]=e;if(r<0||r>n.children.length)throw new i.$UV(this.p,"Invalid tree location");return this.F(h,n.children[r])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:n,listIndex:r,revealed:h,visible:m}=this.H(e),y=e[e.length-1];if(y<0||y>n.children.length)throw new i.$UV(this.p,"Invalid tree location");const o=n.children[y];return{node:o,listIndex:r,revealed:h,visible:m&&o.visible}}H(e,n=this.c,r=0,h=!0,m=!0){const[y,...o]=e;if(y<0||y>n.children.length)throw new i.$UV(this.p,"Invalid tree location");for(let d=0;d<y;d++)r+=n.children[d].renderNodeCount;return h=h&&!n.collapsed,m=m&&n.visible,o.length===0?{parentNode:n,listIndex:r,revealed:h,visible:m}:this.H(o,n.children[y],r+1,h,m)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const n=[];let r=e;for(;r.parent;)n.push(r.parent.children.indexOf(r)),r=r.parent;return n.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,k.$tb)(e)[0]}getFirstElementChild(e){const n=this.F(e);if(n.children.length!==0)return n.children[0].element}getLastElementAncestor(e=[]){const n=this.F(e);if(n.children.length!==0)return this.I(n)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$YV=c}),define(me[134],be([1,0,69,30,32]),function(se,t,i,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6V=void 0;class W{get size(){return this.d.size}constructor(A,g,b={}){this.k=A,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$YV(A,g,null,b),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,b.sorter&&(this.j={compare(p,O){return b.sorter.compare(p.element,O.element)}}),this.h=b.identityProvider}setChildren(A,g=P.Iterable.empty(),b={}){const p=this.o(A);this.l(p,this.m(g),b)}l(A,g=P.Iterable.empty(),b){const p=new Set,O=new Set,c=e=>{if(e.element===null)return;const n=e;if(p.add(n.element),this.d.set(n.element,n),this.h){const r=this.h.getId(n.element).toString();O.add(r),this.f.set(r,n)}b.onDidCreateNode?.(n)},f=e=>{if(e.element===null)return;const n=e;if(p.has(n.element)||this.d.delete(n.element),this.h){const r=this.h.getId(n.element).toString();O.has(r)||this.f.delete(r)}b.onDidDeleteNode?.(n)};this.c.splice([...A,0],Number.MAX_VALUE,g,{...b,onDidCreateNode:c,onDidDeleteNode:f})}m(A=P.Iterable.empty()){return this.j&&(A=[...A].sort(this.j.compare.bind(this.j))),P.Iterable.map(A,g=>{let b=this.d.get(g.element);if(!b&&this.h){const c=this.h.getId(g.element).toString();b=this.f.get(c)}if(!b){let c;return typeof g.collapsed>"u"?c=void 0:g.collapsed===k.ObjectTreeElementCollapseState.Collapsed||g.collapsed===k.ObjectTreeElementCollapseState.PreserveOrCollapsed?c=!0:g.collapsed===k.ObjectTreeElementCollapseState.Expanded||g.collapsed===k.ObjectTreeElementCollapseState.PreserveOrExpanded?c=!1:c=!!g.collapsed,{...g,children:this.m(g.children),collapsed:c}}const p=typeof g.collapsible=="boolean"?g.collapsible:b.collapsible;let O;return typeof g.collapsed>"u"||g.collapsed===k.ObjectTreeElementCollapseState.PreserveOrCollapsed||g.collapsed===k.ObjectTreeElementCollapseState.PreserveOrExpanded?O=b.collapsed:g.collapsed===k.ObjectTreeElementCollapseState.Collapsed?O=!0:g.collapsed===k.ObjectTreeElementCollapseState.Expanded?O=!1:O=!!g.collapsed,{...g,collapsible:p,collapsed:O,children:this.m(g.children)}})}rerender(A){const g=this.o(A);this.c.rerender(g)}updateElementHeight(A,g){const b=this.o(A);this.c.updateElementHeight(b,g)}resort(A=null,g=!0){if(!this.j)return;const b=this.o(A),p=this.c.getNode(b);this.l(b,this.n(p,g),{})}n(A,g,b=!0){let p=[...A.children];return(g||b)&&(p=p.sort(this.j.compare.bind(this.j))),P.Iterable.map(p,O=>({element:O.element,collapsible:O.collapsible,collapsed:O.collapsed,children:this.n(O,g,!1)}))}getFirstElementChild(A=null){const g=this.o(A);return this.c.getFirstElementChild(g)}getLastElementAncestor(A=null){const g=this.o(A);return this.c.getLastElementAncestor(g)}has(A){return this.d.has(A)}getListIndex(A){const g=this.o(A);return this.c.getListIndex(g)}getListRenderCount(A){const g=this.o(A);return this.c.getListRenderCount(g)}isCollapsible(A){const g=this.o(A);return this.c.isCollapsible(g)}setCollapsible(A,g){const b=this.o(A);return this.c.setCollapsible(b,g)}isCollapsed(A){const g=this.o(A);return this.c.isCollapsed(g)}setCollapsed(A,g,b){const p=this.o(A);return this.c.setCollapsed(p,g,b)}expandTo(A){const g=this.o(A);this.c.expandTo(g)}refilter(){this.c.refilter()}getNode(A=null){if(A===null)return this.c.getNode(this.c.rootRef);const g=this.d.get(A);if(!g)throw new k.$UV(this.k,`Tree element not found: ${A}`);return g}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new k.$UV(this.k,"Invalid getParentNodeLocation call");const g=this.d.get(A);if(!g)throw new k.$UV(this.k,`Tree element not found: ${A}`);const b=this.c.getNodeLocation(g),p=this.c.getParentNodeLocation(b);return this.c.getNode(p).element}o(A){if(A===null)return[];const g=this.d.get(A);if(!g)throw new k.$UV(this.k,`Tree element not found: ${A}`);return this.c.getNodeLocation(g)}}t.$6V=W}),define(me[21],be([1,0,4,15,20,28,2]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jT=void 0;class A extends S.$Uc{f(b,p){this.B(i.$IR(b,i.$BS.CLICK,O=>p(new P.$AR(i.getWindow(b),O))))}j(b,p){this.B(i.$IR(b,i.$BS.MOUSE_DOWN,O=>p(new P.$AR(i.getWindow(b),O))))}m(b,p){this.B(i.$IR(b,i.$BS.MOUSE_OVER,O=>p(new P.$AR(i.getWindow(b),O))))}u(b,p){this.B(i.$IR(b,i.$BS.MOUSE_LEAVE,O=>p(new P.$AR(i.getWindow(b),O))))}z(b,p){this.B(i.$IR(b,i.$BS.KEY_DOWN,O=>p(new k.$FR(O))))}C(b,p){this.B(i.$IR(b,i.$BS.KEY_UP,O=>p(new k.$FR(O))))}D(b,p){this.B(i.$IR(b,i.$BS.INPUT,p))}F(b,p){this.B(i.$IR(b,i.$BS.BLUR,p))}G(b,p){this.B(i.$IR(b,i.$BS.FOCUS,p))}H(b,p){this.B(i.$IR(b,i.$BS.CHANGE,p))}I(b){return W.$fT.ignoreTarget(b)}}t.$jT=A}),define(me[48],be([1,0,67,21,11,19,4]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lT=t.$kT=void 0,t.$kT=11;class A extends k.$jT{constructor(b){super(),this.a=b.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=b.bgWidth+"px",this.bgDomNode.style.height=b.bgHeight+"px",typeof b.top<"u"&&(this.bgDomNode.style.top="0px"),typeof b.left<"u"&&(this.bgDomNode.style.left="0px"),typeof b.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof b.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=b.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(b.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$kT+"px",this.domNode.style.height=t.$kT+"px",typeof b.top<"u"&&(this.domNode.style.top=b.top+"px"),typeof b.left<"u"&&(this.domNode.style.left=b.left+"px"),typeof b.bottom<"u"&&(this.domNode.style.bottom=b.bottom+"px"),typeof b.right<"u"&&(this.domNode.style.right=b.right+"px"),this.g=this.B(new i.$iT),this.B(S.$JR(this.bgDomNode,S.$BS.POINTER_DOWN,p=>this.h(p))),this.B(S.$JR(this.domNode,S.$BS.POINTER_DOWN,p=>this.h(p))),this.b=this.B(new S.$UR),this.c=this.B(new P.$Bh)}h(b){if(!b.target||!(b.target instanceof Element))return;const p=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,S.getWindow(b))};this.a(),this.b.cancel(),this.c.cancelAndSet(p,200),this.g.startMonitoring(b.target,b.pointerId,b.buttons,O=>{},()=>{this.b.cancel(),this.c.cancel()}),b.preventDefault()}}t.$lT=A}),define(me[70],be([1,0,4,51,67,48,132,21,5]),function(se,t,i,k,P,W,S,A,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=void 0;const b=140;class p extends A.$jT{constructor(c){super(),this.g=c.lazyRender,this.a=c.host,this.b=c.scrollable,this.c=c.scrollByPage,this.h=c.scrollbarState,this.n=this.B(new S.$nT(c.visibility,"visible scrollbar "+c.extraScrollbarClassName,"invisible scrollbar "+c.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new P.$iT),this.s=!0,this.domNode=(0,k.$hT)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$IR(this.domNode.domNode,i.$BS.POINTER_DOWN,f=>this.M(f)))}t(c){const f=this.B(new W.$lT(c));this.domNode.domNode.appendChild(f.bgDomNode),this.domNode.domNode.appendChild(f.domNode)}w(c,f,e,n){this.slider=(0,k.$hT)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(c),this.slider.setLeft(f),typeof e=="number"&&this.slider.setWidth(e),typeof n=="number"&&this.slider.setHeight(n),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$IR(this.slider.domNode,i.$BS.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this.O(r))})),this.f(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}y(c){return this.h.setVisibleSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(c){return this.h.setScrollSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(c){return this.h.setScrollPosition(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(c){c.target===this.domNode.domNode&&this.N(c)}delegatePointerDown(c){const f=this.domNode.domNode.getClientRects()[0].top,e=f+this.h.getSliderPosition(),n=f+this.h.getSliderPosition()+this.h.getSliderSize(),r=this.U(c);e<=r&&r<=n?c.button===0&&(c.preventDefault(),this.O(c)):this.N(c)}N(c){let f,e;if(c.target===this.domNode.domNode&&typeof c.offsetX=="number"&&typeof c.offsetY=="number")f=c.offsetX,e=c.offsetY;else{const r=i.$5R(this.domNode.domNode);f=c.pageX-r.left,e=c.pageY-r.top}const n=this.S(f,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(n):this.h.getDesiredScrollPositionFromOffset(n)),c.button===0&&(c.preventDefault(),this.O(c))}O(c){if(!c.target||!(c.target instanceof Element))return;const f=this.U(c),e=this.W(c),n=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(c.target,c.pointerId,c.buttons,r=>{const h=this.W(r),m=Math.abs(h-e);if(g.$i&&m>b){this.P(n.getScrollPosition());return}const o=this.U(r)-f;this.P(n.getDesiredScrollPositionFromDelta(o))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(c){const f={};this.writeScrollPosition(f,c),this.b.setScrollPositionNow(f)}updateScrollbarSize(c){this.X(c),this.h.setScrollbarSize(c),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$oT=p}),define(me[135],be([1,0,20,70,48,52,18]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pT=void 0;class A extends k.$oT{constructor(b,p,O){const c=b.getScrollDimensions(),f=b.getCurrentScrollPosition();if(super({lazyRender:p.lazyRender,host:O,scrollbarState:new W.$mT(p.horizontalHasArrows?p.arrowSize:0,p.horizontal===2?0:p.horizontalScrollbarSize,p.vertical===2?0:p.verticalScrollbarSize,c.width,c.scrollWidth,f.scrollLeft),visibility:p.horizontal,extraScrollbarClassName:"horizontal",scrollable:b,scrollByPage:p.scrollByPage}),p.horizontalHasArrows){const e=(p.arrowSize-P.$kT)/2,n=(p.horizontalScrollbarSize-P.$kT)/2;this.t({className:"scra",icon:S.$Qj.scrollbarButtonLeft,top:n,left:e,bottom:void 0,right:void 0,bgWidth:p.arrowSize,bgHeight:p.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$CR(null,1,0))}),this.t({className:"scra",icon:S.$Qj.scrollbarButtonRight,top:n,left:void 0,bottom:void 0,right:e,bgWidth:p.arrowSize,bgHeight:p.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$CR(null,-1,0))})}this.w(Math.floor((p.horizontalScrollbarSize-p.horizontalSliderSize)/2),0,void 0,p.horizontalSliderSize)}R(b,p){this.slider.setWidth(b),this.slider.setLeft(p)}Q(b,p){this.domNode.setWidth(b),this.domNode.setHeight(p),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(b){return this.s=this.J(b.scrollWidth)||this.s,this.s=this.L(b.scrollLeft)||this.s,this.s=this.y(b.width)||this.s,this.s}S(b,p){return b}U(b){return b.pageX}W(b){return b.pageY}X(b){this.slider.setHeight(b)}writeScrollPosition(b,p){b.scrollLeft=p}updateOptions(b){this.updateScrollbarSize(b.horizontal===2?0:b.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this.n.setVisibility(b.horizontal),this.c=b.scrollByPage}}t.$pT=A}),define(me[136],be([1,0,20,70,48,52,18]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qT=void 0;class A extends k.$oT{constructor(b,p,O){const c=b.getScrollDimensions(),f=b.getCurrentScrollPosition();if(super({lazyRender:p.lazyRender,host:O,scrollbarState:new W.$mT(p.verticalHasArrows?p.arrowSize:0,p.vertical===2?0:p.verticalScrollbarSize,0,c.height,c.scrollHeight,f.scrollTop),visibility:p.vertical,extraScrollbarClassName:"vertical",scrollable:b,scrollByPage:p.scrollByPage}),p.verticalHasArrows){const e=(p.arrowSize-P.$kT)/2,n=(p.verticalScrollbarSize-P.$kT)/2;this.t({className:"scra",icon:S.$Qj.scrollbarButtonUp,top:e,left:n,bottom:void 0,right:void 0,bgWidth:p.verticalScrollbarSize,bgHeight:p.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$CR(null,0,1))}),this.t({className:"scra",icon:S.$Qj.scrollbarButtonDown,top:void 0,left:n,bottom:e,right:void 0,bgWidth:p.verticalScrollbarSize,bgHeight:p.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$CR(null,0,-1))})}this.w(0,Math.floor((p.verticalScrollbarSize-p.verticalSliderSize)/2),p.verticalSliderSize,void 0)}R(b,p){this.slider.setHeight(b),this.slider.setTop(p)}Q(b,p){this.domNode.setWidth(p),this.domNode.setHeight(b),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(b){return this.s=this.J(b.scrollHeight)||this.s,this.s=this.L(b.scrollTop)||this.s,this.s=this.y(b.height)||this.s,this.s}S(b,p){return p}U(b){return b.pageY}W(b){return b.pageX}X(b){this.slider.setWidth(b)}writeScrollPosition(b,p){b.scrollTop=p}updateOptions(b){this.updateScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(b.vertical),this.c=b.scrollByPage}}t.$qT=A}),define(me[71],be([1,0,17,4,51,20,135,136,21,11,3,2,5,58,111]),function(se,t,i,k,P,W,S,A,g,b,p,O,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vT=t.$uT=t.$tT=t.$sT=t.$rT=void 0;const e=500,n=50,r=!0;class h{constructor(N,I,M){this.timestamp=N,this.deltaX=I,this.deltaY=M,this.score=0}}class m{static{this.INSTANCE=new m}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let N=1,I=0,M=1,E=this.d;do{const z=E===this.c?N:Math.pow(2,-M);if(N-=z,I+=this.b[E].score*z,E===this.c)break;E=(this.a+E-1)%this.a,M++}while(!0);return I<=.5}acceptStandardWheelEvent(N){if(i.$qR){const I=k.getWindow(N.browserEvent),M=(0,i.$jR)(I);this.accept(Date.now(),N.deltaX*M,N.deltaY*M)}else this.accept(Date.now(),N.deltaX,N.deltaY)}accept(N,I,M){let E=null;const z=new h(N,I,M);this.c===-1&&this.d===-1?(this.b[0]=z,this.c=0,this.d=0):(E=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=z),z.score=this.f(z,E)}f(N,I){if(Math.abs(N.deltaX)>0&&Math.abs(N.deltaY)>0)return 1;let M=.5;if((!this.g(N.deltaX)||!this.g(N.deltaY))&&(M+=.25),I){const E=Math.abs(N.deltaX),z=Math.abs(N.deltaY),q=Math.abs(I.deltaX),F=Math.abs(I.deltaY),x=Math.max(Math.min(E,q),1),B=Math.max(Math.min(z,F),1),Y=Math.max(E,q),K=Math.max(z,F);Y%x===0&&K%B===0&&(M-=.5)}return Math.min(Math.max(M,0),1)}g(N){return Math.abs(Math.round(N)-N)<.01}}t.$rT=m;class y extends g.$jT{get options(){return this.a}constructor(N,I,M){super(),this.O=this.B(new p.$be),this.onScroll=this.O.event,this.P=this.B(new p.$be),this.onWillScroll=this.P.event,N.style.overflow="hidden",this.a=L(I),this.b=M,this.B(this.b.onScroll(z=>{this.P.fire(z),this.S(z),this.O.fire(z)}));const E={onMouseWheel:z=>this.R(z),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new A.$qT(this.b,this.a,E)),this.g=this.B(new S.$pT(this.b,this.a,E)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(N),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,P.$hT)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,P.$hT)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,P.$hT)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,z=>this.Z(z)),this.u(this.t,z=>this.Y(z)),this.L=this.B(new b.$Bh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,O.$Pc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(N){this.c.delegatePointerDown(N)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(N){this.b.setScrollDimensions(N,!1)}updateClassName(N){this.a.className=N,c.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(N){typeof N.handleMouseWheel<"u"&&(this.a.handleMouseWheel=N.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof N.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=N.mouseWheelScrollSensitivity),typeof N.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=N.fastScrollSensitivity),typeof N.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=N.scrollPredominantAxis),typeof N.horizontal<"u"&&(this.a.horizontal=N.horizontal),typeof N.vertical<"u"&&(this.a.vertical=N.vertical),typeof N.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=N.horizontalScrollbarSize),typeof N.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=N.verticalScrollbarSize),typeof N.scrollByPage<"u"&&(this.a.scrollByPage=N.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(N){this.N=N}delegateScrollFromMouseWheelEvent(N){this.R(new W.$CR(N))}Q(N){if(this.w.length>0!==N&&(this.w=(0,O.$Pc)(this.w),N)){const M=E=>{this.R(new W.$CR(E))};this.w.push(k.$IR(this.t,k.$BS.MOUSE_WHEEL,M,{passive:!1}))}}R(N){if(N.browserEvent?.defaultPrevented)return;const I=m.INSTANCE;r&&I.acceptStandardWheelEvent(N);let M=!1;if(N.deltaY||N.deltaX){let z=N.deltaY*this.a.mouseWheelScrollSensitivity,q=N.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&q+z===0?q=z=0:Math.abs(z)>=Math.abs(q)?q=0:z=0),this.a.flipAxes&&([z,q]=[q,z]);const F=!c.$j&&N.browserEvent&&N.browserEvent.shiftKey;(this.a.scrollYToX||F)&&!q&&(q=z,z=0),N.browserEvent&&N.browserEvent.altKey&&(q=q*this.a.fastScrollSensitivity,z=z*this.a.fastScrollSensitivity);const x=this.b.getFutureScrollPosition();let B={};if(z){const Y=n*z,K=x.scrollTop-(Y<0?Math.floor(Y):Math.ceil(Y));this.c.writeScrollPosition(B,K)}if(q){const Y=n*q,K=x.scrollLeft-(Y<0?Math.floor(Y):Math.ceil(Y));this.g.writeScrollPosition(B,K)}B=this.b.validateScrollPosition(B),(x.scrollLeft!==B.scrollLeft||x.scrollTop!==B.scrollTop)&&(r&&this.a.mouseWheelSmoothScroll&&I.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(B):this.b.setScrollPositionNow(B),M=!0)}let E=M;!E&&this.a.alwaysConsumeMouseWheel&&(E=!0),!E&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(E=!0),E&&(N.preventDefault(),N.stopPropagation())}S(N){this.M=this.g.onDidScroll(N)||this.M,this.M=this.c.onDidScroll(N)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const N=this.b.getCurrentScrollPosition(),I=N.scrollTop>0,M=N.scrollLeft>0,E=M?" left":"",z=I?" top":"",q=M||I?" top-left-corner":"";this.n.setClassName(`shadow${E}`),this.r.setClassName(`shadow${z}`),this.s.setClassName(`shadow${q}${z}${E}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(N){this.J=!1,this.ab()}Z(N){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$sT=y;class o extends y{constructor(N,I){I=I||{},I.mouseWheelSmoothScroll=!1;const M=new f.$Qs({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:E=>k.$SR(k.getWindow(N),E)});super(N,I,M),this.B(M)}setScrollPosition(N){this.b.setScrollPositionNow(N)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$tT=o;class d extends y{constructor(N,I,M){super(N,I,M)}setScrollPosition(N){N.reuseAnimation?this.b.setScrollPositionSmooth(N,N.reuseAnimation):this.b.setScrollPositionNow(N)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$uT=d;class a extends y{constructor(N,I){I=I||{},I.mouseWheelSmoothScroll=!1;const M=new f.$Qs({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:E=>k.$SR(k.getWindow(N),E)});super(N,I,M),this.B(M),this.cb=N,this.B(this.onScroll(E=>{E.scrollTopChanged&&(this.cb.scrollTop=E.scrollTop),E.scrollLeftChanged&&(this.cb.scrollLeft=E.scrollLeft)})),this.scanDomNode()}setScrollPosition(N){this.b.setScrollPositionNow(N)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$vT=a;function L(C){const N={lazyRender:typeof C.lazyRender<"u"?C.lazyRender:!1,className:typeof C.className<"u"?C.className:"",useShadows:typeof C.useShadows<"u"?C.useShadows:!0,handleMouseWheel:typeof C.handleMouseWheel<"u"?C.handleMouseWheel:!0,flipAxes:typeof C.flipAxes<"u"?C.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof C.consumeMouseWheelIfScrollbarIsNeeded<"u"?C.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof C.alwaysConsumeMouseWheel<"u"?C.alwaysConsumeMouseWheel:!1,scrollYToX:typeof C.scrollYToX<"u"?C.scrollYToX:!1,mouseWheelScrollSensitivity:typeof C.mouseWheelScrollSensitivity<"u"?C.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof C.fastScrollSensitivity<"u"?C.fastScrollSensitivity:5,scrollPredominantAxis:typeof C.scrollPredominantAxis<"u"?C.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof C.mouseWheelSmoothScroll<"u"?C.mouseWheelSmoothScroll:!0,arrowSize:typeof C.arrowSize<"u"?C.arrowSize:11,listenOnDomNode:typeof C.listenOnDomNode<"u"?C.listenOnDomNode:null,horizontal:typeof C.horizontal<"u"?C.horizontal:1,horizontalScrollbarSize:typeof C.horizontalScrollbarSize<"u"?C.horizontalScrollbarSize:10,horizontalSliderSize:typeof C.horizontalSliderSize<"u"?C.horizontalSliderSize:0,horizontalHasArrows:typeof C.horizontalHasArrows<"u"?C.horizontalHasArrows:!1,vertical:typeof C.vertical<"u"?C.vertical:1,verticalScrollbarSize:typeof C.verticalScrollbarSize<"u"?C.verticalScrollbarSize:10,verticalHasArrows:typeof C.verticalHasArrows<"u"?C.verticalHasArrows:!1,verticalSliderSize:typeof C.verticalSliderSize<"u"?C.verticalSliderSize:0,scrollByPage:typeof C.scrollByPage<"u"?C.scrollByPage:!1};return N.horizontalSliderSize=typeof C.horizontalSliderSize<"u"?C.horizontalSliderSize:N.horizontalScrollbarSize,N.verticalSliderSize=typeof C.verticalSliderSize<"u"?C.verticalSliderSize:N.verticalScrollbarSize,c.$j&&(N.className+=" mac"),N}}),define(me[72],be([1,0,65,4,24,28,71,8,11,31,3,2,56,58,92,131,6,40]),function(se,t,i,k,P,W,S,A,g,b,p,O,c,f,e,n,r,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XT=t.$WT=t.$VT=t.$UT=t.ListViewTargetSector=void 0;const m={CurrentDragAndDropData:void 0};var y;(function(M){M[M.TOP=0]="TOP",M[M.CENTER_TOP=1]="CENTER_TOP",M[M.CENTER_BOTTOM=2]="CENTER_BOTTOM",M[M.BOTTOM=3]="BOTTOM"})(y||(t.ListViewTargetSector=y={}));const o={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(M){return[M]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class d{get context(){return this.d}set context(E){this.d=E}constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.$UT=d;class a{constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.$VT=a;class L{constructor(){this.types=[],this.files=[]}update(E){if(E.types&&this.types.splice(0,this.types.length,...E.types),E.files){this.files.splice(0,this.files.length);for(let z=0;z<E.files.length;z++){const q=E.files.item(z);q&&(q.size||q.type)&&this.files.push(q)}}}getData(){return{types:this.types,files:this.files}}}t.$WT=L;function C(M,E){return Array.isArray(M)&&Array.isArray(E)?(0,A.$ub)(M,E):M===E}class N{constructor(E){E?.getSetSize?this.getSetSize=E.getSetSize.bind(E):this.getSetSize=(z,q,F)=>F,E?.getPosInSet?this.getPosInSet=E.getPosInSet.bind(E):this.getPosInSet=(z,q)=>q+1,E?.getRole?this.getRole=E.getRole.bind(E):this.getRole=z=>"listitem",E?.isChecked?this.isChecked=E.isChecked.bind(E):this.isChecked=z=>{}}}class I{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(E){if(E!==this.P){if(E&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=E,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const z of this.d)this.ab(z);this.X(),this.q.setScrollDimensions({width:(0,k.$8R)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(E,z,q,F=o){if(this.R=z,this.domId=`list_id_${++I.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new g.$oh(50),this.v=!1,this.x=O.$Uc.None,this.y=0,this.G=!1,this.K=O.$Uc.None,this.L=O.$Uc.None,this.M=new O.$Tc,this.N=new p.$be,this.O=new p.$be,this.onDidChangeContentHeight=p.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=p.Event.latch(this.O.event,void 0,this.M),this.P=!1,F.horizontalScrolling&&F.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(F.paddingTop??0);for(const B of q)this.j.set(B.templateId,B);this.h=this.M.add(new n.$TT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof F.mouseSupport=="boolean"?F.mouseSupport:!0),this.P=F.horizontalScrolling??o.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof F.paddingBottom>"u"?0:F.paddingBottom,this.D=new N(F.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(F.transformOptimization??o.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(W.$fT.addTarget(this.o)),this.p=this.M.add(new f.$Qs({forceIntegerValues:!0,smoothScrollDuration:F.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:B=>(0,k.$SR)((0,k.getWindow)(this.domNode),B)})),this.q=this.M.add(new S.$uT(this.o,{alwaysConsumeMouseWheel:F.alwaysConsumeMouseWheel??o.alwaysConsumeMouseWheel,horizontal:1,vertical:F.verticalScrollMode??o.verticalScrollMode,useShadows:F.useShadows??o.useShadows,mouseWheelScrollSensitivity:F.mouseWheelScrollSensitivity,fastScrollSensitivity:F.fastScrollSensitivity,scrollByPage:F.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),E.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,k.$IR)(this.o,W.EventType.Change,B=>this.jb(B))),this.M.add((0,k.$IR)(this.q.getDomNode(),"scroll",B=>B.target.scrollTop=0)),this.M.add((0,k.$IR)(this.domNode,"dragover",B=>this.lb(this.hb(B)))),this.M.add((0,k.$IR)(this.domNode,"drop",B=>this.nb(this.hb(B)))),this.M.add((0,k.$IR)(this.domNode,"dragleave",B=>this.mb(this.hb(B)))),this.M.add((0,k.$IR)(this.domNode,"dragend",B=>this.ob(B))),this.z=F.setRowLineHeight??o.setRowLineHeight,this.A=F.setRowHeight??o.setRowHeight,this.B=F.supportDynamicHeights??o.supportDynamicHeights,this.F=F.dnd??this.M.add(o.dnd),this.layout(F.initialSize?.height,F.initialSize?.width)}updateOptions(E){E.paddingBottom!==void 0&&(this.C=E.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),E.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(E.smoothScrolling?125:0),E.horizontalScrolling!==void 0&&(this.Q=E.horizontalScrolling);let z;if(E.scrollByPage!==void 0&&(z={...z??{},scrollByPage:E.scrollByPage}),E.mouseWheelScrollSensitivity!==void 0&&(z={...z??{},mouseWheelScrollSensitivity:E.mouseWheelScrollSensitivity}),E.fastScrollSensitivity!==void 0&&(z={...z??{},fastScrollSensitivity:E.fastScrollSensitivity}),z&&this.q.updateOptions(z),E.paddingTop!==void 0&&E.paddingTop!==this.g.paddingTop){const q=this.vb(this.k,this.m),F=E.paddingTop-this.g.paddingTop;this.g.paddingTop=E.paddingTop,this.Y(q,Math.max(0,this.k+F),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(E){this.q.delegateScrollFromMouseWheelEvent(E)}delegateVerticalScrollbarPointerDown(E){this.q.delegateVerticalScrollbarPointerDown(E)}updateElementHeight(E,z,q){if(E<0||E>=this.d.length)return;const F=this.d[E].size;if(typeof z>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[E].lastDynamicHeightWidth=void 0,z=F+this.xb(E)}if(F===z)return;const x=this.vb(this.k,this.m);let B=0;E<x.start||q!==null&&q>E&&q<x.end?B=z-F:B=0,this.g.splice(E,1,[{size:z}]),this.d[E].size=z,this.Y(x,Math.max(0,this.k+B),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(E){return new e.$ST(E)}splice(E,z,q=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(E,z,q)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(E,z,q=[]){const F=this.vb(this.k,this.m),x={start:E,end:E+z},B=c.Range.intersect(F,x),Y=new Map;for(let V=B.end-1;V>=B.start;V--){const Q=this.d[V];if(Q.dragStartDisposable.dispose(),Q.checkedDisposable.dispose(),Q.row){let ge=Y.get(Q.templateId);ge||(ge=[],Y.set(Q.templateId,ge));const we=this.j.get(Q.templateId);we&&we.disposeElement&&we.disposeElement(Q.element,V,Q.row.templateData,Q.size),ge.unshift(Q.row)}Q.row=null,Q.stale=!0}const K={start:E+z,end:this.d.length},ae=c.Range.intersect(K,F),ie=c.Range.relativeComplement(K,F),ee=q.map(V=>({id:String(this.f++),element:V,templateId:this.R.getTemplateId(V),size:this.R.getHeight(V),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:O.$Uc.None,checkedDisposable:O.$Uc.None,stale:!1}));let ce;E===0&&z>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ee),ce=this.d,this.d=ee):(this.g.splice(E,z,ee),ce=this.d.splice(E,z,...ee));const De=q.length-z,Ee=this.vb(this.k,this.m),Ie=(0,e.$QT)(ae,De),le=c.Range.intersect(Ee,Ie);for(let V=le.start;V<le.end;V++)this.bb(this.d[V],V);const _=c.Range.relativeComplement(Ie,Ee);for(const V of _)for(let Q=V.start;Q<V.end;Q++)this.db(Q);const ue=ie.map(V=>(0,e.$QT)(V,De)),ye=[{start:E,end:E+q.length},...ue].map(V=>c.Range.intersect(Ee,V)).reverse();for(const V of ye)for(let Q=V.end-1;Q>=V.start;Q--){const ge=this.d[Q],Le=Y.get(ge.templateId)?.pop();this.Z(Q,Le)}for(const V of Y.values())for(const Q of V)this.h.release(Q);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ce.map(V=>V.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,k.$SR)((0,k.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let E=0;for(const z of this.d)typeof z.width<"u"&&(E=Math.max(E,z.width));this.E=E,this.q.setScrollDimensions({scrollWidth:E===0?0:E+10}),this.O.fire(this.E)}updateWidth(E){if(!this.Q||typeof this.E>"u")return;const z=this.d[E];this.ab(z),typeof z.width<"u"&&z.width>this.E&&(this.E=z.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const E of this.d)E.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const E=this.firstVisibleIndex,z=this.g.positionAt(E),q=this.g.positionAt(E+1);return q!==-1&&(q-z)/2+z<this.scrollTop?E+1:E}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(E){return this.d[E].element}indexOf(E){return this.d.findIndex(z=>z.element===E)}domElement(E){const z=this.d[E].row;return z&&z.domNode}elementHeight(E){return this.d[E].size}elementTop(E){return this.g.positionAt(E)}indexAt(E){return this.g.indexAt(E)}indexAfter(E){return this.g.indexAfter(E)}layout(E,z){const q={height:typeof E=="number"?E:(0,k.$0R)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,q.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(q),typeof z<"u"&&(this.n=z,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof z=="number"?z:(0,k.$8R)(this.domNode)})}Y(E,z,q,F,x,B=!1){const Y=this.vb(z,q),K=c.Range.relativeComplement(Y,E).reverse(),ae=c.Range.relativeComplement(E,Y);if(B){const ie=c.Range.intersect(E,Y);for(let ee=ie.start;ee<ie.end;ee++)this.bb(this.d[ee],ee)}this.h.transact(()=>{for(const ie of ae)for(let ee=ie.start;ee<ie.end;ee++)this.db(ee);for(const ie of K)for(let ee=ie.end-1;ee>=ie.start;ee--)this.Z(ee)}),F!==void 0&&(this.o.style.left=`-${F}px`),this.o.style.top=`-${z}px`,this.Q&&x!==void 0&&(this.o.style.width=`${Math.max(x,this.n)}px`),this.k=z,this.m=q}Z(E,z){const q=this.d[E];if(!q.row)if(z)q.row=z,q.stale=!0;else{const K=this.h.alloc(q.templateId);q.row=K.row,q.stale||=K.isReusingConnectedDomNode}const F=this.D.getRole(q.element)||"listitem";q.row.domNode.setAttribute("role",F);const x=this.D.isChecked(q.element);if(typeof x=="boolean")q.row.domNode.setAttribute("aria-checked",String(!!x));else if(x){const K=ae=>q.row.domNode.setAttribute("aria-checked",String(!!ae));K(x.value),q.checkedDisposable=x.onDidChange(()=>K(x.value))}if(q.stale||!q.row.domNode.parentElement){const K=this.d.at(E+1)?.row?.domNode??null;(q.row.domNode.parentElement!==this.o||q.row.domNode.nextElementSibling!==K)&&this.o.insertBefore(q.row.domNode,K),q.stale=!1}this.bb(q,E);const B=this.j.get(q.templateId);if(!B)throw new Error(`No renderer found for template id ${q.templateId}`);B?.renderElement(q.element,E,q.row.templateData,q.size);const Y=this.F.getDragURI(q.element);q.dragStartDisposable.dispose(),q.row.domNode.draggable=!!Y,Y&&(q.dragStartDisposable=(0,k.$IR)(q.row.domNode,"dragstart",K=>this.kb(q.element,Y,K))),this.Q&&(this.ab(q),this.W())}ab(E){if(!E.row||!E.row.domNode)return;E.row.domNode.style.width="fit-content",E.width=(0,k.$8R)(E.row.domNode);const z=(0,k.getWindow)(E.row.domNode).getComputedStyle(E.row.domNode);z.paddingLeft&&(E.width+=parseFloat(z.paddingLeft)),z.paddingRight&&(E.width+=parseFloat(z.paddingRight)),E.row.domNode.style.width=""}bb(E,z){E.row.domNode.style.top=`${this.elementTop(z)}px`,this.A&&(E.row.domNode.style.height=`${E.size}px`),this.z&&(E.row.domNode.style.lineHeight=`${E.size}px`),E.row.domNode.setAttribute("data-index",`${z}`),E.row.domNode.setAttribute("data-last-element",z===this.length-1?"true":"false"),E.row.domNode.setAttribute("data-parity",z%2===0?"even":"odd"),E.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(E.element,z,this.length))),E.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(E.element,z))),E.row.domNode.setAttribute("id",this.getElementDomId(z)),E.row.domNode.classList.toggle("drop-target",E.dropTarget)}db(E){const z=this.d[E];if(z.dragStartDisposable.dispose(),z.checkedDisposable.dispose(),z.row){const q=this.j.get(z.templateId);q&&q.disposeElement&&q.disposeElement(z.element,E,z.row.templateData,z.size),this.h.release(z.row),z.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(E,z){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:E,reuseAnimation:z})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(E){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:E})}get scrollTop(){return this.getScrollTop()}set scrollTop(E){this.setScrollTop(E)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return p.Event.map(this.M.add(new P.$KT(this.domNode,"click")).event,E=>this.eb(E),this.M)}get onMouseDblClick(){return p.Event.map(this.M.add(new P.$KT(this.domNode,"dblclick")).event,E=>this.eb(E),this.M)}get onMouseMiddleClick(){return p.Event.filter(p.Event.map(this.M.add(new P.$KT(this.domNode,"auxclick")).event,E=>this.eb(E),this.M),E=>E.browserEvent.button===1,this.M)}get onMouseUp(){return p.Event.map(this.M.add(new P.$KT(this.domNode,"mouseup")).event,E=>this.eb(E),this.M)}get onMouseDown(){return p.Event.map(this.M.add(new P.$KT(this.domNode,"mousedown")).event,E=>this.eb(E),this.M)}get onMouseOver(){return p.Event.map(this.M.add(new P.$KT(this.domNode,"mouseover")).event,E=>this.eb(E),this.M)}get onMouseMove(){return p.Event.map(this.M.add(new P.$KT(this.domNode,"mousemove")).event,E=>this.eb(E),this.M)}get onMouseOut(){return p.Event.map(this.M.add(new P.$KT(this.domNode,"mouseout")).event,E=>this.eb(E),this.M)}get onContextMenu(){return p.Event.any(p.Event.map(this.M.add(new P.$KT(this.domNode,"contextmenu")).event,E=>this.eb(E),this.M),p.Event.map(this.M.add(new P.$KT(this.domNode,W.EventType.Contextmenu)).event,E=>this.gb(E),this.M))}get onTouchStart(){return p.Event.map(this.M.add(new P.$KT(this.domNode,"touchstart")).event,E=>this.fb(E),this.M)}get onTap(){return p.Event.map(this.M.add(new P.$KT(this.o,W.EventType.Tap)).event,E=>this.gb(E),this.M)}eb(E){const z=this.ub(E.target||null),q=typeof z>"u"?void 0:this.d[z],F=q&&q.element;return{browserEvent:E,index:z,element:F}}fb(E){const z=this.ub(E.target||null),q=typeof z>"u"?void 0:this.d[z],F=q&&q.element;return{browserEvent:E,index:z,element:F}}gb(E){const z=this.ub(E.initialTarget||null),q=typeof z>"u"?void 0:this.d[z],F=q&&q.element;return{browserEvent:E,index:z,element:F}}hb(E){const z=this.ub(E.target||null),q=typeof z>"u"?void 0:this.d[z],F=q&&q.element,x=this.tb(E,z);return{browserEvent:E,index:z,element:F,sector:x}}ib(E){try{const z=this.vb(this.k,this.m);this.Y(z,E.scrollTop,E.height,E.scrollLeft,E.scrollWidth),this.B&&this.wb(E.scrollTop,E.height,E.inSmoothScrolling)}catch(z){throw console.error("Got bad scroll event:",E),z}}jb(E){E.preventDefault(),E.stopPropagation(),this.scrollTop-=E.translationY}kb(E,z,q){if(!q.dataTransfer)return;const F=this.F.getDragElements(E);if(q.dataTransfer.effectAllowed="copyMove",q.dataTransfer.setData(i.$dT.TEXT,z),q.dataTransfer.setDragImage){let x;this.F.getDragLabel&&(x=this.F.getDragLabel(F,q)),typeof x>"u"&&(x=String(F.length));const B=(0,k.$)(".monaco-drag-image");B.textContent=x;const K=(ae=>{for(;ae&&!ae.classList.contains("monaco-workbench");)ae=ae.parentElement;return ae||this.domNode.ownerDocument})(this.domNode);K.appendChild(B),q.dataTransfer.setDragImage(B,-10,-10),setTimeout(()=>K.removeChild(B),0)}this.domNode.classList.add("dragging"),this.H=new d(F),m.CurrentDragAndDropData=new a(F),this.F.onDragStart?.(this.H,q)}lb(E){if(E.browserEvent.preventDefault(),this.L.dispose(),m.CurrentDragAndDropData&&m.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(E.browserEvent),!E.browserEvent.dataTransfer))return!1;if(!this.H)if(m.CurrentDragAndDropData)this.H=m.CurrentDragAndDropData;else{if(!E.browserEvent.dataTransfer.types)return!1;this.H=new L}const z=this.F.onDragOver(this.H,E.element,E.index,E.sector,E.browserEvent);if(this.G=typeof z=="boolean"?z:z.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;E.browserEvent.dataTransfer.dropEffect=typeof z!="boolean"&&z.effect?.type===0?"copy":"move";let q;typeof z!="boolean"&&z.feedback?q=z.feedback:typeof E.index>"u"?q=[-1]:q=[E.index],q=(0,A.$Mb)(q).filter(x=>x>=-1&&x<this.length).sort((x,B)=>x-B),q=q[0]===-1?[-1]:q;let F=typeof z!="boolean"&&z.effect&&z.effect.position?z.effect.position:"drop-target";if(C(this.I,q)&&this.J===F)return!0;if(this.I=q,this.J=F,this.K.dispose(),q[0]===-1)this.domNode.classList.add(F),this.o.classList.add(F),this.K=(0,O.$Sc)(()=>{this.domNode.classList.remove(F),this.o.classList.remove(F)});else{if(q.length>1&&F!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");F==="drop-target-after"&&q[0]<this.length-1&&(q[0]+=1,F="drop-target-before");for(const x of q){const B=this.d[x];B.dropTarget=!0,B.row?.domNode.classList.add(F)}this.K=(0,O.$Sc)(()=>{for(const x of q){const B=this.d[x];B.dropTarget=!1,B.row?.domNode.classList.remove(F)}})}return!0}mb(E){this.L.dispose(),this.L=(0,g.$th)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,E.element,E.index,E.browserEvent)}nb(E){if(!this.G)return;const z=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,!(!z||!E.browserEvent.dataTransfer)&&(E.browserEvent.preventDefault(),z.update(E.browserEvent.dataTransfer),this.F.drop(z,E.element,E.index,E.sector,E.browserEvent))}ob(E){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(E)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=O.$Uc.None}qb(E){if(!this.w){const z=(0,k.$2R)(this.domNode).top;this.w=(0,k.$XS)((0,k.getWindow)(this.domNode),this.rb.bind(this,z))}this.x.dispose(),this.x=(0,g.$th)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=E.pageY}rb(E){if(this.y===void 0)return;const z=this.y-E,q=this.renderHeight-35;z<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(z-35))):z>q&&(this.scrollTop+=Math.min(14,Math.floor(.3*(z-q))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(E,z){if(z===void 0)return;const q=E.offsetY/this.d[z].size,F=Math.floor(q/.25);return(0,h.$wm)(F,0,3)}ub(E){const z=this.q.getDomNode();let q=E;for(;q instanceof HTMLElement&&q!==this.o&&z.contains(q);){const F=q.getAttribute("data-index");if(F){const x=Number(F);if(!isNaN(x))return x}q=q.parentElement}}vb(E,z){return{start:this.g.indexAt(E),end:this.g.indexAfter(E+z-1)}}wb(E,z,q){const F=this.vb(E,z);let x,B;E===this.elementTop(F.start)?(x=F.start,B=0):F.end-F.start>1&&(x=F.start+1,B=this.elementTop(x)-E);let Y=0;for(;;){const K=this.vb(E,z);let ae=!1;for(let ie=K.start;ie<K.end;ie++){const ee=this.xb(ie);ee!==0&&this.g.splice(ie,1,[this.d[ie]]),Y+=ee,ae=ae||ee!==0}if(!ae){Y!==0&&this.V();const ie=c.Range.relativeComplement(F,K);for(const ce of ie)for(let De=ce.start;De<ce.end;De++)this.d[De].row&&this.db(De);const ee=c.Range.relativeComplement(K,F).reverse();for(const ce of ee)for(let De=ce.end-1;De>=ce.start;De--)this.Z(De);for(let ce=K.start;ce<K.end;ce++)this.d[ce].row&&this.bb(this.d[ce],ce);if(typeof x=="number"){const ce=this.p.getFutureScrollPosition().scrollTop-E,De=this.elementTop(x)-B+ce;this.setScrollTop(De,q)}this.N.fire(this.contentHeight);return}}}xb(E){const z=this.d[E];if(this.R.getDynamicHeight){const B=this.R.getDynamicHeight(z.element);if(B!==null){const Y=z.size;return z.size=B,z.lastDynamicHeightWidth=this.n,B-Y}}if(!z.hasDynamicHeight||z.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(z.element))return 0;const q=z.size;if(z.row)return z.row.domNode.style.height="",z.size=z.row.domNode.offsetHeight,z.size===0&&!(0,k.$aS)(z.row.domNode,(0,k.getWindow)(z.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),z.lastDynamicHeightWidth=this.n,z.size-q;const{row:F}=this.h.alloc(z.templateId);F.domNode.style.height="",this.o.appendChild(F.domNode);const x=this.j.get(z.templateId);if(!x)throw new r.$cb("Missing renderer for templateId: "+z.templateId);return x.renderElement(z.element,E,F.templateData,void 0),z.size=F.domNode.offsetHeight,x.disposeElement?.(z.element,E,F.templateData,void 0),this.R.setDynamicHeight?.(z.element,z.size),z.lastDynamicHeightWidth=this.n,this.o.removeChild(F.domNode),this.h.release(F),z.size-q}getElementDomId(E){return`${this.domId}_${E}`}dispose(){for(const E of this.d)if(E.dragStartDisposable.dispose(),E.checkedDisposable.dispose(),E.row){const z=this.j.get(E.row.templateId);z&&(z.disposeElement?.(E.element,-1,E.row.templateData,void 0),z.disposeTemplate(E.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$XT=I,Je([b.$Vh],I.prototype,"onMouseClick",null),Je([b.$Vh],I.prototype,"onMouseDblClick",null),Je([b.$Vh],I.prototype,"onMouseMiddleClick",null),Je([b.$Vh],I.prototype,"onMouseUp",null),Je([b.$Vh],I.prototype,"onMouseDown",null),Je([b.$Vh],I.prototype,"onMouseOver",null),Je([b.$Vh],I.prototype,"onMouseMove",null),Je([b.$Vh],I.prototype,"onMouseOut",null),Je([b.$Vh],I.prototype,"onContextMenu",null),Je([b.$Vh],I.prototype,"onTouchStart",null),Je([b.$Vh],I.prototype,"onTap",null)}),define(me[49],be([1,0,4,24,15,28,68,81,8,11,84,31,3,44,2,40,5,10,80,72,20,57,110]),function(se,t,i,k,P,W,S,A,g,b,p,O,c,f,e,n,r,h,m,y,o,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dU=t.$cU=t.$bU=t.$aU=t.$0T=t.TypeNavigationMode=void 0,t.$2T=I,t.$3T=E,t.$4T=z,t.$5T=q,t.$6T=F,t.$7T=x,t.$8T=B,t.$9T=Y,t.$$T=De,t.$_T=Ee;class a{constructor(u){this.d=u,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(u){return u}renderElement(u,v,l){const w=this.c.findIndex(T=>T.templateData===l);if(w>=0){const T=this.c[w];this.d.unrender(l),T.index=v}else{const T={index:v,templateData:l};this.c.push(T)}this.d.renderIndex(v,l)}splice(u,v,l){const w=[];for(const T of this.c)T.index<u?w.push(T):T.index>=u+v&&w.push({index:T.index+l-v,templateData:T.templateData});this.c=w}renderIndexes(u){for(const{index:v,templateData:l}of this.c)u.indexOf(v)>-1&&this.d.renderIndex(v,l)}disposeTemplate(u){const v=this.c.findIndex(l=>l.templateData===u);v<0||this.c.splice(v,1)}}class L{get name(){return this.g}get renderer(){return new a(this)}constructor(u){this.g=u,this.c=[],this.d=[],this.f=new c.$be,this.onChange=this.f.event}splice(u,v,l){const w=l.length-v,T=u+v,s=[];let D=0;for(;D<this.d.length&&this.d[D]<u;)s.push(this.d[D++]);for(let $=0;$<l.length;$++)l[$]&&s.push($+u);for(;D<this.d.length&&this.d[D]>=T;)s.push(this.d[D++]+w);this.renderer.splice(u,v,l.length),this.h(s,s)}renderIndex(u,v){v.classList.toggle(this.g,this.contains(u))}unrender(u){u.classList.remove(this.g)}set(u,v){return this.h(u,[...u].sort(ge),v)}h(u,v,l){const w=this.c,T=this.d;this.c=u,this.d=v;const s=V(T,u);return this.renderer.renderIndexes(s),this.f.fire({indexes:u,browserEvent:l}),w}get(){return this.c}contains(u){return(0,g.$wb)(this.d,u,ge)>=0}dispose(){(0,e.$Pc)(this.f)}}Je([O.$Vh],L.prototype,"renderer",null);class C extends L{constructor(u){super("selected"),this.k=u}renderIndex(u,v){super.renderIndex(u,v),this.k&&(this.contains(u)?v.setAttribute("aria-selected","true"):v.setAttribute("aria-selected","false"))}}class N{constructor(u,v,l){this.c=u,this.d=v,this.f=l}splice(u,v,l){if(!this.f)return this.c.splice(u,v,new Array(l.length).fill(!1));const w=this.c.get().map(D=>this.f.getId(this.d.element(D)).toString());if(w.length===0)return this.c.splice(u,v,new Array(l.length).fill(!1));const T=new Set(w),s=l.map(D=>T.has(this.f.getId(D).toString()));this.c.splice(u,v,s)}}function I(H){return H.tagName==="INPUT"||H.tagName==="TEXTAREA"}function M(H,u){return H.classList.contains(u)?!0:H.classList.contains("monaco-list")||!H.parentElement?!1:M(H.parentElement,u)}function E(H){return M(H,"monaco-editor")}function z(H){return M(H,"monaco-custom-toggle")}function q(H){return M(H,"action-item")}function F(H){return M(H,"monaco-tl-twistie")}function x(H){return M(H,"monaco-tree-sticky-row")}function B(H){return H.classList.contains("monaco-tree-sticky-container")}function Y(H){return H.tagName==="A"&&H.classList.contains("monaco-button")||H.tagName==="DIV"&&H.classList.contains("monaco-button-dropdown")?!0:H.classList.contains("monaco-list")||!H.parentElement?!1:Y(H.parentElement)}class K{get g(){return c.Event.chain(this.c.add(new k.$KT(this.k.domNode,"keydown")).event,u=>u.filter(v=>!I(v.target)).map(v=>new P.$FR(v)))}constructor(u,v,l){this.h=u,this.k=v,this.c=new e.$Tc,this.d=new e.$Tc,this.f=l.multipleSelectionSupport,this.c.add(this.g(w=>{switch(w.keyCode){case 3:return this.l(w);case 16:return this.o(w);case 18:return this.p(w);case 11:return this.q(w);case 12:return this.s(w);case 9:return this.u(w);case 31:this.f&&(r.$j?w.metaKey:w.ctrlKey)&&this.t(w)}}))}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.f=u.multipleSelectionSupport)}l(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection(this.h.getFocus(),u.browserEvent)}o(u){u.preventDefault(),u.stopPropagation(),this.h.focusPrevious(1,!1,u.browserEvent);const v=this.h.getFocus()[0];this.h.setAnchor(v),this.h.reveal(v),this.k.domNode.focus()}p(u){u.preventDefault(),u.stopPropagation(),this.h.focusNext(1,!1,u.browserEvent);const v=this.h.getFocus()[0];this.h.setAnchor(v),this.h.reveal(v),this.k.domNode.focus()}q(u){u.preventDefault(),u.stopPropagation(),this.h.focusPreviousPage(u.browserEvent);const v=this.h.getFocus()[0];this.h.setAnchor(v),this.h.reveal(v),this.k.domNode.focus()}s(u){u.preventDefault(),u.stopPropagation(),this.h.focusNextPage(u.browserEvent);const v=this.h.getFocus()[0];this.h.setAnchor(v),this.h.reveal(v),this.k.domNode.focus()}t(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection((0,g.$Sb)(this.h.length),u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(u){this.h.getSelection().length&&(u.preventDefault(),u.stopPropagation(),this.h.setSelection([],u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Je([O.$Vh],K.prototype,"g",null);var ae;(function(H){H[H.Automatic=0]="Automatic",H[H.Trigger=1]="Trigger"})(ae||(t.TypeNavigationMode=ae={}));var ie;(function(H){H[H.Idle=0]="Idle",H[H.Typing=1]="Typing"})(ie||(ie={})),t.$0T=new class{mightProducePrintableCharacter(H){return H.ctrlKey||H.metaKey||H.altKey?!1:H.keyCode>=31&&H.keyCode<=56||H.keyCode>=21&&H.keyCode<=30||H.keyCode>=98&&H.keyCode<=107||H.keyCode>=85&&H.keyCode<=95}};class ee{constructor(u,v,l,w,T){this.o=u,this.p=v,this.q=l,this.s=w,this.t=T,this.c=!1,this.d=ie.Idle,this.f=ae.Automatic,this.g=!1,this.h=-1,this.k=new e.$Tc,this.l=new e.$Tc,this.updateOptions(u.options)}updateOptions(u){u.typeNavigationEnabled??!0?this.u():this.v(),this.f=u.typeNavigationMode??ae.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let u=!1;const v=c.Event.chain(this.k.add(new k.$KT(this.p.domNode,"keydown")).event,T=>T.filter(s=>!I(s.target)).filter(()=>this.f===ae.Automatic||this.g).map(s=>new P.$FR(s)).filter(s=>u||this.s(s)).filter(s=>this.t.mightProducePrintableCharacter(s)).forEach(s=>i.$DS.stop(s,!0)).map(s=>s.browserEvent.key)),l=c.Event.debounce(v,()=>null,800,void 0,void 0,void 0,this.k);c.Event.reduce(c.Event.any(v,l),(T,s)=>s===null?null:(T||"")+s,void 0,this.k)(this.x,this,this.k),l(this.w,this,this.k),v(()=>u=!0,void 0,this.k),l(()=>u=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const u=this.o.getFocus();if(u.length>0&&u[0]===this.h){const v=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(u[0]));typeof v=="string"?(0,S.$MT)(v):v&&(0,S.$MT)(v.get())}this.h=-1}x(u){if(!u){this.d=ie.Idle,this.g=!1;return}const v=this.o.getFocus(),l=v.length>0?v[0]:0,w=this.d===ie.Idle?1:0;this.d=ie.Typing;for(let T=0;T<this.o.length;T++){const s=(l+T+w)%this.o.length,D=this.q.getKeyboardNavigationLabel(this.p.element(s)),$=D&&D.toString();if(this.o.options.typeNavigationEnabled){if(typeof $<"u"){if((0,f.$tk)(u,$)){this.h=l,this.o.setFocus([s]),this.o.reveal(s);return}const R=(0,f.$Ak)(u,$);if(R&&R[0].end-R[0].start>1&&R.length===1){this.h=l,this.o.setFocus([s]),this.o.reveal(s);return}}}else if(typeof $>"u"||(0,f.$tk)(u,$)){this.h=l,this.o.setFocus([s]),this.o.reveal(s);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ce{constructor(u,v){this.d=u,this.f=v,this.c=new e.$Tc;const l=c.Event.chain(this.c.add(new k.$KT(v.domNode,"keydown")).event,T=>T.filter(s=>!I(s.target)).map(s=>new P.$FR(s)));c.Event.chain(l,T=>T.filter(s=>s.keyCode===2&&!s.ctrlKey&&!s.metaKey&&!s.shiftKey&&!s.altKey))(this.g,this,this.c)}g(u){if(u.target!==this.f.domNode)return;const v=this.d.getFocus();if(v.length===0)return;const l=this.f.domElement(v[0]);if(!l)return;const w=l.querySelector("[tabIndex]");if(!w||!(w instanceof HTMLElement)||w.tabIndex===-1)return;const T=(0,i.getWindow)(w).getComputedStyle(w);T.visibility==="hidden"||T.display==="none"||(u.preventDefault(),u.stopPropagation(),w.focus())}dispose(){this.c.dispose()}}function De(H){return r.$j?H.browserEvent.metaKey:H.browserEvent.ctrlKey}function Ee(H){return H.browserEvent.shiftKey}function Ie(H){return(0,i.$xS)(H)&&H.button===2}const le={isSelectionSingleChangeEvent:De,isSelectionRangeChangeEvent:Ee};class _{constructor(u){this.k=u,this.f=new e.$Tc,this.g=new c.$be,this.onPointer=this.g.event,u.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||le),this.d=typeof u.options.mouseSupport>"u"||!!u.options.mouseSupport,this.d&&(u.onMouseDown(this.s,this,this.f),u.onContextMenu(this.t,this,this.f),u.onMouseDblClick(this.v,this,this.f),u.onTouchStart(this.s,this,this.f),this.f.add(W.$fT.addTarget(u.getHTMLElement()))),c.Event.any(u.onMouseClick,u.onMouseMiddleClick,u.onTap)(this.u,this,this.f)}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.c=void 0,u.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||le))}o(u){return this.c?this.c.isSelectionSingleChangeEvent(u):!1}p(u){return this.c?this.c.isSelectionRangeChangeEvent(u):!1}q(u){return this.o(u)||this.p(u)}s(u){E(u.browserEvent.target)||(0,i.$iS)()!==u.browserEvent.target&&this.k.domFocus()}t(u){if(I(u.browserEvent.target)||E(u.browserEvent.target))return;const v=typeof u.index>"u"?[]:[u.index];this.k.setFocus(v,u.browserEvent)}u(u){if(!this.d||I(u.browserEvent.target)||E(u.browserEvent.target)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const v=u.index;if(typeof v>"u"){this.k.setFocus([],u.browserEvent),this.k.setSelection([],u.browserEvent),this.k.setAnchor(void 0);return}if(this.q(u))return this.w(u);this.k.setFocus([v],u.browserEvent),this.k.setAnchor(v),Ie(u.browserEvent)||this.k.setSelection([v],u.browserEvent),this.g.fire(u)}v(u){if(I(u.browserEvent.target)||E(u.browserEvent.target)||this.q(u)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const v=this.k.getFocus();this.k.setSelection(v,u.browserEvent)}w(u){const v=u.index;let l=this.k.getAnchor();if(this.p(u)){typeof l>"u"&&(l=this.k.getFocus()[0]??v,this.k.setAnchor(l));const w=Math.min(l,v),T=Math.max(l,v),s=(0,g.$Sb)(w,T+1),D=this.k.getSelection(),$=ye(V(D,[l]),l);if($.length===0)return;const R=V(s,Q(D,$));this.k.setSelection(R,u.browserEvent),this.k.setFocus([v],u.browserEvent)}else if(this.o(u)){const w=this.k.getSelection(),T=w.filter(s=>s!==v);this.k.setFocus([v]),this.k.setAnchor(v),w.length===T.length?this.k.setSelection([...T,v],u.browserEvent):this.k.setSelection(T,u.browserEvent)}}dispose(){this.f.dispose()}}t.$aU=_;class ue{constructor(u,v){this.c=u,this.d=v}style(u){const v=this.d&&`.${this.d}`,l=[];u.listBackground&&l.push(`.monaco-list${v} .monaco-list-rows { background: ${u.listBackground}; }`),u.listFocusBackground&&(l.push(`.monaco-list${v}:focus .monaco-list-row.focused { background-color: ${u.listFocusBackground}; }`),l.push(`.monaco-list${v}:focus .monaco-list-row.focused:hover { background-color: ${u.listFocusBackground}; }`)),u.listFocusForeground&&l.push(`.monaco-list${v}:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),u.listActiveSelectionBackground&&(l.push(`.monaco-list${v}:focus .monaco-list-row.selected { background-color: ${u.listActiveSelectionBackground}; }`),l.push(`.monaco-list${v}:focus .monaco-list-row.selected:hover { background-color: ${u.listActiveSelectionBackground}; }`)),u.listActiveSelectionForeground&&l.push(`.monaco-list${v}:focus .monaco-list-row.selected { color: ${u.listActiveSelectionForeground}; }`),u.listActiveSelectionIconForeground&&l.push(`.monaco-list${v}:focus .monaco-list-row.selected .codicon { color: ${u.listActiveSelectionIconForeground}; }`),u.listFocusAndSelectionBackground&&l.push(`
				.monaco-drag-image,
				.monaco-list${v}:focus .monaco-list-row.selected.focused { background-color: ${u.listFocusAndSelectionBackground}; }
			`),u.listFocusAndSelectionForeground&&l.push(`
				.monaco-drag-image,
				.monaco-list${v}:focus .monaco-list-row.selected.focused { color: ${u.listFocusAndSelectionForeground}; }
			`),u.listInactiveFocusForeground&&(l.push(`.monaco-list${v} .monaco-list-row.focused { color:  ${u.listInactiveFocusForeground}; }`),l.push(`.monaco-list${v} .monaco-list-row.focused:hover { color:  ${u.listInactiveFocusForeground}; }`)),u.listInactiveSelectionIconForeground&&l.push(`.monaco-list${v} .monaco-list-row.focused .codicon { color:  ${u.listInactiveSelectionIconForeground}; }`),u.listInactiveFocusBackground&&(l.push(`.monaco-list${v} .monaco-list-row.focused { background-color:  ${u.listInactiveFocusBackground}; }`),l.push(`.monaco-list${v} .monaco-list-row.focused:hover { background-color:  ${u.listInactiveFocusBackground}; }`)),u.listInactiveSelectionBackground&&(l.push(`.monaco-list${v} .monaco-list-row.selected { background-color:  ${u.listInactiveSelectionBackground}; }`),l.push(`.monaco-list${v} .monaco-list-row.selected:hover { background-color:  ${u.listInactiveSelectionBackground}; }`)),u.listInactiveSelectionForeground&&l.push(`.monaco-list${v} .monaco-list-row.selected { color: ${u.listInactiveSelectionForeground}; }`),u.listHoverBackground&&l.push(`.monaco-list${v}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${u.listHoverBackground}; }`),u.listHoverForeground&&l.push(`.monaco-list${v}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${u.listHoverForeground}; }`);const w=(0,i.$1S)(u.listFocusAndSelectionOutline,(0,i.$1S)(u.listSelectionOutline,u.listFocusOutline??""));w&&l.push(`.monaco-list${v}:focus .monaco-list-row.focused.selected { outline: 1px solid ${w}; outline-offset: -1px;}`),u.listFocusOutline&&l.push(`
				.monaco-drag-image,
				.monaco-list${v}:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${v}.last-focused .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
			`);const T=(0,i.$1S)(u.listSelectionOutline,u.listInactiveFocusOutline??"");T&&l.push(`.monaco-list${v} .monaco-list-row.focused.selected { outline: 1px dotted ${T}; outline-offset: -1px; }`),u.listSelectionOutline&&l.push(`.monaco-list${v} .monaco-list-row.selected { outline: 1px dotted ${u.listSelectionOutline}; outline-offset: -1px; }`),u.listInactiveFocusOutline&&l.push(`.monaco-list${v} .monaco-list-row.focused { outline: 1px dotted ${u.listInactiveFocusOutline}; outline-offset: -1px; }`),u.listHoverOutline&&l.push(`.monaco-list${v} .monaco-list-row:hover { outline: 1px dashed ${u.listHoverOutline}; outline-offset: -1px; }`),u.listDropOverBackground&&l.push(`
				.monaco-list${v}.drop-target,
				.monaco-list${v} .monaco-list-rows.drop-target,
				.monaco-list${v} .monaco-list-row.drop-target { background-color: ${u.listDropOverBackground} !important; color: inherit !important; }
			`),u.listDropBetweenBackground&&(l.push(`
			.monaco-list${v} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${v} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`),l.push(`
			.monaco-list${v} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${v} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`)),u.tableColumnsBorder&&l.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${u.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),u.tableOddRowsBackgroundColor&&l.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${u.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=l.join(`
`)}}t.$bU=ue,t.$cU={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:p.$It.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:p.$It.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:p.$It.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const re={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function ye(H,u){const v=H.indexOf(u);if(v===-1)return[];const l=[];let w=v-1;for(;w>=0&&H[w]===u-(v-w);)l.push(H[w--]);for(l.reverse(),w=v;w<H.length&&H[w]===u+(w-v);)l.push(H[w++]);return l}function V(H,u){const v=[];let l=0,w=0;for(;l<H.length||w<u.length;)if(l>=H.length)v.push(u[w++]);else if(w>=u.length)v.push(H[l++]);else if(H[l]===u[w]){v.push(H[l]),l++,w++;continue}else H[l]<u[w]?v.push(H[l++]):v.push(u[w++]);return v}function Q(H,u){const v=[];let l=0,w=0;for(;l<H.length||w<u.length;)if(l>=H.length)v.push(u[w++]);else if(w>=u.length)v.push(H[l++]);else if(H[l]===u[w]){l++,w++;continue}else H[l]<u[w]?v.push(H[l++]):w++;return v}const ge=(H,u)=>H-u;class we{constructor(u,v){this.c=u,this.d=v}get templateId(){return this.c}renderTemplate(u){return this.d.map(v=>v.renderTemplate(u))}renderElement(u,v,l,w){let T=0;for(const s of this.d)s.renderElement(u,v,l[T++],w)}disposeElement(u,v,l,w){let T=0;for(const s of this.d)s.disposeElement?.(u,v,l[T],w),T+=1}disposeTemplate(u){let v=0;for(const l of this.d)l.disposeTemplate(u[v++])}}class Le{constructor(u){this.c=u,this.templateId="a18n"}renderTemplate(u){return{container:u,disposables:new e.$Tc}}renderElement(u,v,l){const w=this.c.getAriaLabel(u),T=w&&typeof w!="string"?w:(0,d.constObservable)(w);l.disposables.add((0,d.autorun)(D=>{this.d(D.readObservable(T),l.container)}));const s=this.c.getAriaLevel&&this.c.getAriaLevel(u);typeof s=="number"?l.container.setAttribute("aria-level",`${s}`):l.container.removeAttribute("aria-level")}d(u,v){u?v.setAttribute("aria-label",u):v.removeAttribute("aria-label")}disposeElement(u,v,l,w){l.disposables.clear()}disposeTemplate(u){u.disposables.dispose()}}class Te{constructor(u,v){this.c=u,this.d=v}getDragElements(u){const v=this.c.getSelectedElements();return v.indexOf(u)>-1?v:[u]}getDragURI(u){return this.d.getDragURI(u)}getDragLabel(u,v){if(this.d.getDragLabel)return this.d.getDragLabel(u,v)}onDragStart(u,v){this.d.onDragStart?.(u,v)}onDragOver(u,v,l,w,T){return this.d.onDragOver(u,v,l,w,T)}onDragLeave(u,v,l,w){this.d.onDragLeave?.(u,v,l,w)}onDragEnd(u){this.d.onDragEnd?.(u)}drop(u,v,l,w,T){this.d.drop(u,v,l,w,T)}dispose(){this.d.dispose()}}class Me{get onDidChangeFocus(){return c.Event.map(this.g.wrapEvent(this.c.onChange),u=>this.G(u),this.y)}get onDidChangeSelection(){return c.Event.map(this.g.wrapEvent(this.d.onChange),u=>this.G(u),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let u=!1;const v=c.Event.chain(this.y.add(new k.$KT(this.k.domNode,"keydown")).event,T=>T.map(s=>new P.$FR(s)).filter(s=>u=s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$DS.stop(s,!0)).filter(()=>!1)),l=c.Event.chain(this.y.add(new k.$KT(this.k.domNode,"keyup")).event,T=>T.forEach(()=>u=!1).map(s=>new P.$FR(s)).filter(s=>s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$DS.stop(s,!0)).map(({browserEvent:s})=>{const D=this.getFocus(),$=D.length?D[0]:void 0,R=typeof $<"u"?this.k.element($):void 0,j=typeof $<"u"?this.k.domElement($):this.k.domNode;return{index:$,element:R,anchor:j,browserEvent:s}})),w=c.Event.chain(this.k.onContextMenu,T=>T.filter(s=>!u).map(({element:s,index:D,browserEvent:$})=>({element:s,index:D,anchor:new o.$AR((0,i.getWindow)(this.k.domNode),$),browserEvent:$})));return c.Event.any(v,l,w)}get onKeyDown(){return this.y.add(new k.$KT(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new k.$KT(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new k.$KT(this.k.domNode,"keypress")).event}get onDidFocus(){return c.Event.signal(this.y.add(new k.$KT(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return c.Event.signal(this.y.add(new k.$KT(this.k.domNode,"blur",!0)).event)}constructor(u,v,l,w,T=re){this.A=u,this.B=T,this.c=new L("focused"),this.f=new L("anchor"),this.g=new c.$je,this.x="",this.y=new e.$Tc,this.z=new c.$be,this.onDidDispose=this.z.event;const s=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new C(s!=="listbox");const D=[this.c.renderer,this.d.renderer];this.u=T.accessibilityProvider,this.u&&(D.push(new Le(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),w=w.map(R=>new we(R.templateId,[...D,R]));const $={...T,dnd:T.dnd&&new Te(this,T.dnd)};if(this.k=this.C(v,l,w,$),this.k.domNode.setAttribute("role",s),T.styleController)this.q=T.styleController(this.k.domId);else{const R=(0,i.$qS)(this.k.domNode);this.q=new ue(R,this.k.domId)}if(this.o=new A.$OT([new N(this.c,this.k,T.identityProvider),new N(this.d,this.k,T.identityProvider),new N(this.f,this.k,T.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ce(this,this.k)),(typeof T.keyboardSupport!="boolean"||T.keyboardSupport)&&(this.v=new K(this,this.k,T),this.y.add(this.v)),T.keyboardNavigationLabelProvider){const R=T.keyboardNavigationDelegate||t.$0T;this.t=new ee(this,this.k,T.keyboardNavigationLabelProvider,T.keyboardNavigationEventFilter??(()=>!0),R),this.y.add(this.t)}this.w=this.D(T),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(u,v,l,w){return new y.$XT(u,v,l,w)}D(u){return new _(this)}updateOptions(u={}){this.B={...this.B,...u},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(u),this.v?.updateOptions(u),this.k.updateOptions(u)}get options(){return this.B}splice(u,v,l=[]){if(u<0||u>this.k.length)throw new m.$ZT(this.A,`Invalid start index: ${u}`);if(v<0)throw new m.$ZT(this.A,`Invalid delete count: ${v}`);v===0&&l.length===0||this.g.bufferEvents(()=>this.o.splice(u,v,l))}updateWidth(u){this.k.updateWidth(u)}updateElementHeight(u,v){this.k.updateElementHeight(u,v,null)}rerender(){this.k.rerender()}element(u){return this.k.element(u)}indexOf(u){return this.k.indexOf(u)}indexAt(u){return this.k.indexAt(u)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(u){this.k.setScrollTop(u)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(u){this.k.setScrollLeft(u)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(u){this.x=u,this.k.domNode.setAttribute("aria-label",u)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(u,v){this.k.layout(u,v)}triggerTypeNavigation(){this.t?.trigger()}setSelection(u,v){for(const l of u)if(l<0||l>=this.length)throw new m.$ZT(this.A,`Invalid index ${l}`);this.d.set(u,v)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(u=>this.k.element(u))}setAnchor(u){if(typeof u>"u"){this.f.set([]);return}if(u<0||u>=this.length)throw new m.$ZT(this.A,`Invalid index ${u}`);this.f.set([u])}getAnchor(){return(0,g.$Ob)(this.f.get(),void 0)}getAnchorElement(){const u=this.getAnchor();return typeof u>"u"?void 0:this.element(u)}setFocus(u,v){for(const l of u)if(l<0||l>=this.length)throw new m.$ZT(this.A,`Invalid index ${l}`);this.c.set(u,v)}focusNext(u=1,v=!1,l,w){if(this.length===0)return;const T=this.c.get(),s=this.E(T.length>0?T[0]+u:0,v,w);s>-1&&this.setFocus([s],l)}focusPrevious(u=1,v=!1,l,w){if(this.length===0)return;const T=this.c.get(),s=this.F(T.length>0?T[0]-u:0,v,w);s>-1&&this.setFocus([s],l)}async focusNextPage(u,v){let l=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);l=l===0?0:l-1;const w=this.getFocus()[0];if(w!==l&&(w===void 0||l>w)){const T=this.F(l,!1,v);T>-1&&w!==T?this.setFocus([T],u):this.setFocus([l],u)}else{const T=this.k.getScrollTop();let s=T+this.k.renderHeight;l>w&&(s-=this.k.elementHeight(l)),this.k.setScrollTop(s),this.k.getScrollTop()!==T&&(this.setFocus([]),await(0,b.$sh)(0),await this.focusNextPage(u,v))}}async focusPreviousPage(u,v,l=()=>0){let w;const T=l(),s=this.k.getScrollTop()+T;s===0?w=this.k.indexAt(s):w=this.k.indexAfter(s-1);const D=this.getFocus()[0];if(D!==w&&(D===void 0||D>=w)){const $=this.E(w,!1,v);$>-1&&D!==$?this.setFocus([$],u):this.setFocus([w],u)}else{const $=s;this.k.setScrollTop(s-this.k.renderHeight-T),this.k.getScrollTop()+l()!==$&&(this.setFocus([]),await(0,b.$sh)(0),await this.focusPreviousPage(u,v,l))}}focusLast(u,v){if(this.length===0)return;const l=this.F(this.length-1,!1,v);l>-1&&this.setFocus([l],u)}focusFirst(u,v){this.focusNth(0,u,v)}focusNth(u,v,l){if(this.length===0)return;const w=this.E(u,!1,l);w>-1&&this.setFocus([w],v)}E(u,v=!1,l){for(let w=0;w<this.length;w++){if(u>=this.length&&!v)return-1;if(u=u%this.length,!l||l(this.element(u)))return u;u++}return-1}F(u,v=!1,l){for(let w=0;w<this.length;w++){if(u<0&&!v)return-1;if(u=(this.length+u%this.length)%this.length,!l||l(this.element(u)))return u;u--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(u=>this.k.element(u))}reveal(u,v,l=0){if(u<0||u>=this.length)throw new m.$ZT(this.A,`Invalid index ${u}`);const w=this.k.getScrollTop(),T=this.k.elementTop(u),s=this.k.elementHeight(u);if((0,h.$9f)(v)){const D=s-this.k.renderHeight+l;this.k.setScrollTop(D*(0,n.$wm)(v,0,1)+T-l)}else{const D=T+s,$=w+this.k.renderHeight;T<w+l&&D>=$||(T<w+l||D>=$&&s>=this.k.renderHeight?this.k.setScrollTop(T-l):D>=$&&this.k.setScrollTop(D-this.k.renderHeight))}}getRelativeTop(u,v=0){if(u<0||u>=this.length)throw new m.$ZT(this.A,`Invalid index ${u}`);const l=this.k.getScrollTop(),w=this.k.elementTop(u),T=this.k.elementHeight(u);if(w<l+v||w+T>l+this.k.renderHeight)return null;const s=T-this.k.renderHeight+v;return Math.abs((l+v-w)/s)}isDOMFocused(){return(0,i.$jS)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(u){return this.k.getElementDomId(u)}getElementTop(u){return this.k.elementTop(u)}style(u){this.q.style(u)}G({indexes:u,browserEvent:v}){return{indexes:u,elements:u.map(l=>this.k.element(l)),browserEvent:v}}H(){const u=this.c.get();this.k.domNode.classList.toggle("element-focused",u.length>0),this.I()}I(){const u=this.c.get();if(u.length>0){let v;this.u?.getActiveDescendantId&&(v=this.u.getActiveDescendantId(this.k.element(u[0]))),this.k.domNode.setAttribute("aria-activedescendant",v||this.k.getElementDomId(u[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const u=this.d.get();this.k.domNode.classList.toggle("selection-none",u.length===0),this.k.domNode.classList.toggle("selection-single",u.length===1),this.k.domNode.classList.toggle("selection-multiple",u.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$dU=Me,Je([O.$Vh],Me.prototype,"onDidChangeFocus",null),Je([O.$Vh],Me.prototype,"onDidChangeSelection",null),Je([O.$Vh],Me.prototype,"onContextMenu",null),Je([O.$Vh],Me.prototype,"onKeyDown",null),Je([O.$Vh],Me.prototype,"onKeyUp",null),Je([O.$Vh],Me.prototype,"onKeyPress",null),Je([O.$Vh],Me.prototype,"onDidFocus",null),Je([O.$Vh],Me.prototype,"onDidBlur",null)}),define(me[137],be([1,0,6,62,47,9,16]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ok=t.MarkdownStringTextNewlineStyle=void 0,t.$Pk=b,t.$Qk=p,t.$Rk=O,t.$Sk=c,t.$Tk=f,t.$Uk=e,t.$Vk=n,t.$Wk=r;var A;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(A||(t.MarkdownStringTextNewlineStyle=A={}));class g{constructor(m="",y=!1){if(this.value=m,typeof this.value!="string")throw(0,i.$7)("value");typeof y=="boolean"?(this.isTrusted=y,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=y.isTrusted??void 0,this.supportThemeIcons=y.supportThemeIcons??!1,this.supportHtml=y.supportHtml??!1)}appendText(m,y=0){return this.value+=c(this.supportThemeIcons?(0,k.$Ik)(m):m).replace(/([ \t]+)/g,(o,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,y===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,y){return this.value+=`
${f(y,m)}
`,this}appendLink(m,y,o){return this.value+="[",this.value+=this.c(y,"]"),this.value+="](",this.value+=this.c(String(m),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(m,y){const o=new RegExp((0,W.$9e)(y),"g");return m.replace(o,(d,a)=>m.charAt(a-1)!=="\\"?`\\${d}`:d)}}t.$Ok=g;function b(h){return p(h)?!h.value:Array.isArray(h)?h.every(b):!0}function p(h){return h instanceof g?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function O(h,m){return h===m?!0:!h||!m?!1:h.value===m.value&&h.isTrusted===m.isTrusted&&h.supportThemeIcons===m.supportThemeIcons&&h.supportHtml===m.supportHtml&&(h.baseUri===m.baseUri||!!h.baseUri&&!!m.baseUri&&(0,P.$Xg)(S.URI.from(h.baseUri),S.URI.from(m.baseUri)))}function c(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function f(h,m){const y=h.match(/^`+/gm)?.reduce((d,a)=>d.length>a.length?d:a).length??0,o=y>=3?y+1:3;return[`${"`".repeat(o)}${m}`,h,`${"`".repeat(o)}`].join(`
`)}function e(h){return h.replace(/"/g,"&quot;")}function n(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(h){const m=[],y=h.split("|").map(d=>d.trim());h=y[0];const o=y[1];if(o){const d=/height=(\d+)/.exec(o),a=/width=(\d+)/.exec(o),L=d?d[1]:"",C=a?a[1]:"",N=isFinite(parseInt(C)),I=isFinite(parseInt(L));N&&m.push(`width="${C}"`),I&&m.push(`height="${L}"`)}return{href:h,dimensions:m}}}),define(me[138],be([1,0,4,129,24,66,15,20,130,6,3,137,62,86,23,2,88,64,36,61,47,9,16]),function(se,t,i,k,P,W,S,A,g,b,p,O,c,f,e,n,r,h,m,y,o,d,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hU=void 0,t.$gU=C,t.$iU=z,t.$jU=q,t.$kU=ae;const L=Object.freeze({image:(V,Q,ge)=>{let we=[],Le=[];return V&&({href:V,dimensions:we}=(0,O.$Wk)(V),Le.push(`src="${(0,O.$Uk)(V)}"`)),ge&&Le.push(`alt="${(0,O.$Uk)(ge)}"`),Q&&Le.push(`title="${(0,O.$Uk)(Q)}"`),we.length&&(Le=Le.concat(we)),"<img "+Le.join(" ")+">"},paragraph:V=>`<p>${V}</p>`,link:(V,Q,ge)=>typeof V!="string"?"":(V===ge&&(ge=(0,O.$Vk)(ge)),Q=typeof Q=="string"?(0,O.$Uk)((0,O.$Vk)(Q)):"",V=(0,O.$Vk)(V),V=V.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${V}" title="${Q||V}" draggable="false">${ge}</a>`)});function C(V,Q={},ge={}){const we=new n.$Tc;let Le=!1;const Te=(0,W.$JT)(Q),Me=function($){let R;try{R=(0,h.$Zh)(decodeURIComponent($))}catch{}return R?(R=(0,y.$Zn)(R,j=>{if(V.uris&&V.uris[j])return a.URI.revive(V.uris[j])}),encodeURIComponent(JSON.stringify(R))):$},H=function($,R){const j=V.uris&&V.uris[$];let U=a.URI.revive(j);return R?$.startsWith(m.Schemas.data+":")?$:(U||(U=a.URI.parse($)),m.$Lg.uriToBrowserUri(U).toString(!0)):!U||a.URI.parse($).toString()===U.toString()?$:(U.query&&(U=U.with({query:Me(U.query)})),U.toString())},u=new r.marked.Renderer;u.image=L.image,u.link=L.link,u.paragraph=L.paragraph;const v=[],l=[];if(Q.codeBlockRendererSync?u.code=($,R)=>{const j=f.$lP.nextId(),U=Q.codeBlockRendererSync(N(R),$);return l.push([j,U]),`<div class="code" data-code="${j}">${(0,d.$8e)($)}</div>`}:Q.codeBlockRenderer&&(u.code=($,R)=>{const j=f.$lP.nextId(),U=Q.codeBlockRenderer(N(R),$);return v.push(U.then(J=>[j,J])),`<div class="code" data-code="${j}">${(0,d.$8e)($)}</div>`}),Q.actionHandler){const $=function(U){let J=U.target;if(!(J.tagName!=="A"&&(J=J.parentElement,!J||J.tagName!=="A")))try{let oe=J.dataset.href;oe&&(V.baseUri&&(oe=I(a.URI.from(V.baseUri),oe)),Q.actionHandler.callback(oe,U))}catch(oe){(0,b.$1)(oe)}finally{U.preventDefault()}},R=Q.actionHandler.disposables.add(new P.$KT(Te,"click")),j=Q.actionHandler.disposables.add(new P.$KT(Te,"auxclick"));Q.actionHandler.disposables.add(p.Event.any(R.event,j.event)(U=>{const J=new A.$AR(i.getWindow(Te),U);!J.leftButton&&!J.middleButton||$(J)})),Q.actionHandler.disposables.add(i.$IR(Te,"keydown",U=>{const J=new S.$FR(U);!J.equals(10)&&!J.equals(3)||$(J)}))}V.supportHtml||(ge.sanitizer=$=>(V.isTrusted?$.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?$:"",ge.sanitize=!0,ge.silent=!0),ge.renderer=u;let w=V.value??"";w.length>1e5&&(w=`${w.substr(0,1e5)}\u2026`),V.supportThemeIcons&&(w=(0,c.$Jk)(w));let T;if(Q.fillInIncompleteTokens){const $={...r.marked.defaults,...ge},R=r.marked.lexer(w,$),j=ae(R);T=r.marked.parser(j,$)}else T=r.marked.parse(w,ge);V.supportThemeIcons&&(T=(0,g.$eU)(T).map(R=>typeof R=="string"?R:R.outerHTML).join(""));const D=new DOMParser().parseFromString(M(V,T),"text/html");if(D.body.querySelectorAll("img, audio, video, source").forEach($=>{const R=$.getAttribute("src");if(R){let j=R;try{V.baseUri&&(j=I(a.URI.from(V.baseUri),j))}catch{}if($.setAttribute("src",H(j,!0)),Q.disallowRemoteImages){const U=a.URI.parse(j).scheme;U!==m.Schemas.file&&U!==m.Schemas.data&&$.replaceWith(i.$("",void 0,$.outerHTML))}}}),D.body.querySelectorAll("a").forEach($=>{const R=$.getAttribute("href");if($.setAttribute("href",""),!R||/^data:|javascript:/i.test(R)||/^command:/i.test(R)&&!V.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(R))$.replaceWith(...$.childNodes);else{let j=H(R,!1);V.baseUri&&(j=I(a.URI.from(V.baseUri),R)),$.dataset.href=j}}),Te.innerHTML=M(V,D.body.innerHTML),v.length>0)Promise.all(v).then($=>{if(Le)return;const R=new Map($),j=Te.querySelectorAll("div[data-code]");for(const U of j){const J=R.get(U.dataset.code??"");J&&i.$KS(U,J)}Q.asyncRenderCallback?.()});else if(l.length>0){const $=new Map(l),R=Te.querySelectorAll("div[data-code]");for(const j of R){const U=$.get(j.dataset.code??"");U&&i.$KS(j,U)}}if(Q.asyncRenderCallback)for(const $ of Te.getElementsByTagName("img")){const R=we.add(i.$IR($,"load",()=>{R.dispose(),Q.asyncRenderCallback()}))}return{element:Te,dispose:()=>{Le=!0,we.dispose()}}}function N(V){if(!V)return"";const Q=V.split(/[\s+|:|,|\{|\?]/,1);return Q.length?Q[0]:V}function I(V,Q){return/^\w[\w\d+.-]*:/.test(Q)?Q:V.path.endsWith("/")?(0,o.$8g)(V,Q).toString():(0,o.$8g)((0,o.$4g)(V),Q).toString()}function M(V,Q){const{config:ge,allowedSchemes:we}=E(V);k.addHook("uponSanitizeAttribute",(Te,Me)=>{if(Me.attrName==="style"||Me.attrName==="class"){if(Te.tagName==="SPAN"){if(Me.attrName==="style"){Me.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Me.attrValue);return}else if(Me.attrName==="class"){Me.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Me.attrValue);return}}Me.keepAttr=!1;return}else if(Te.tagName==="INPUT"&&Te.attributes.getNamedItem("type")?.value==="checkbox"){if(Me.attrName==="type"&&Me.attrValue==="checkbox"||Me.attrName==="disabled"||Me.attrName==="checked"){Me.keepAttr=!0;return}Me.keepAttr=!1}}),k.addHook("uponSanitizeElement",(Te,Me)=>{Me.tagName==="input"&&(Te.attributes.getNamedItem("type")?.value==="checkbox"?Te.setAttribute("disabled",""):Te.parentElement?.removeChild(Te))});const Le=i.$5S(we);try{return k.sanitize(Q,{...ge,RETURN_TRUSTED_TYPE:!0})}finally{k.removeHook("uponSanitizeAttribute"),Le.dispose()}}t.$hU=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function E(V){const Q=[m.Schemas.http,m.Schemas.https,m.Schemas.mailto,m.Schemas.data,m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemote,m.Schemas.vscodeRemoteResource];return V.isTrusted&&Q.push(m.Schemas.command),{config:{ALLOWED_TAGS:[...i.$6S],ALLOWED_ATTR:t.$hU,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:Q}}function z(V){return typeof V=="string"?V:q(V)}function q(V){let Q=V.value??"";Q.length>1e5&&(Q=`${Q.substr(0,1e5)}\u2026`);const ge=r.marked.parse(Q,{renderer:x.value}).replace(/&(#\d+|[a-zA-Z]+);/g,we=>F.get(we)??we);return M({isTrusted:!1},ge).toString()}const F=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),x=new e.$V(()=>{const V=new r.marked.Renderer;return V.code=Q=>Q,V.blockquote=Q=>Q,V.html=Q=>"",V.heading=(Q,ge,we)=>Q+`
`,V.hr=()=>"",V.list=(Q,ge)=>Q,V.listitem=Q=>Q+`
`,V.paragraph=Q=>Q+`
`,V.table=(Q,ge)=>Q+ge+`
`,V.tablerow=Q=>Q,V.tablecell=(Q,ge)=>Q+" ",V.strong=Q=>Q,V.em=Q=>Q,V.codespan=Q=>Q,V.br=()=>`
`,V.del=Q=>Q,V.image=(Q,ge,we)=>"",V.text=Q=>Q,V.link=(Q,ge,we)=>we,V});function B(V){let Q="";return V.forEach(ge=>{Q+=ge.raw}),Q}function Y(V){for(let Q=0;Q<V.tokens.length;Q++){const ge=V.tokens[Q];if(ge.type==="text"){const we=ge.raw.split(`
`),Le=we[we.length-1];if(Le.includes("`"))return ee(V);if(Le.includes("**"))return _(V);if(Le.match(/\*\w/))return ce(V);if(Le.match(/(^|\s)__\w/))return ue(V);if(Le.match(/(^|\s)_\w/))return De(V);if(Le.match(/(^|\s)\[.*\]\(\w*/)){const Te=V.tokens.slice(Q+1);return Te[0]?.type==="link"&&Te[1]?.type==="text"&&Te[1].raw.match(/^ *"[^"]*$/)?Ie(V):Ee(V)}else{if(K(Le))return Ee(V);if(Le.match(/(^|\s)\[\w/)&&!V.tokens.slice(Q+1).some(Te=>K(Te.raw)))return le(V)}}}}function K(V){return!!V.match(/^[^\[]*\]\([^\)]*$/)}function ae(V){let Q,ge;for(Q=0;Q<V.length;Q++){const we=V[Q];let Le;if(we.type==="paragraph"&&(Le=we.raw.match(/(\n|^)(````*)/))){const Te=Le[2];ge=ie(V.slice(Q),Te);break}if(we.type==="paragraph"&&we.raw.match(/(\n|^)\|/)){ge=ye(V.slice(Q));break}if(Q===V.length-1&&we.type==="paragraph"){const Te=Y(we);if(Te){ge=[Te];break}}}if(ge){const we=[...V.slice(0,Q),...ge];return we.links=V.links,we}return V}function ie(V,Q){const ge=B(V);return r.marked.lexer(ge+`
${Q}`)}function ee(V){return re(V,"`")}function ce(V){return re(V,"*")}function De(V){return re(V,"_")}function Ee(V){return re(V,")")}function Ie(V){return re(V,'")')}function le(V){return re(V,"](about:blank)")}function _(V){return re(V,"**")}function ue(V){return re(V,"__")}function re(V,Q){const ge=B(Array.isArray(V)?V:[V]);return r.marked.lexer(ge+Q)[0]}function ye(V){const Q=B(V),ge=Q.split(`
`);let we,Le=!1;for(let Te=0;Te<ge.length;Te++){const Me=ge[Te].trim();if(typeof we>"u"&&Me.match(/^\s*\|/)){const H=Me.match(/(\|[^\|]+)(?=\||$)/g);H&&(we=H.length)}else if(typeof we=="number")if(Me.match(/^\s*\|/)){if(Te!==ge.length-1)return;Le=!0}else return}if(typeof we=="number"&&we>0){const Te=Le?ge.slice(0,-1).join(`
`):Q,Me=!!Te.match(/\|\s*$/),H=Te+(Me?"":"|")+`
|${" --- |".repeat(we)}`;return r.marked.lexer(H)}}}),define(me[139],be([1,0,4,24,15,138,29,14,49,8,3,54,2,5,121,113]),function(se,t,i,k,P,W,S,A,g,b,p,O,c,f,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nU=void 0;const n=i.$,r="selectOption.entry.template";class h{get templateId(){return r}renderTemplate(o){const d=Object.create(null);return d.root=o,d.text=i.$IS(o,n(".option-text")),d.detail=i.$IS(o,n(".option-detail")),d.decoratorRight=i.$IS(o,n(".option-decorator-right")),d}renderElement(o,d,a){const L=a,C=o.text,N=o.detail,I=o.decoratorRight,M=o.isDisabled;L.text.textContent=C,L.detail.textContent=N||"",L.decoratorRight.innerText=I||"",M?L.root.classList.add("option-disabled"):L.root.classList.remove("option-disabled")}disposeTemplate(o){}}class m extends c.$Uc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(o,d,a,L,C){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=L,this.g=C||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=m.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new p.$be,this.B(this.r),this.Q(),this.P(a),this.n=d||0,o&&this.setOptions(o,d),this.S()}O(o){!this.M&&o?this.M=this.B((0,S.$mU)().setupUpdatableHover((0,A.$AT)("mouse"),this.h,o)):this.M&&this.M.update(o)}getHeight(){return 22}getTemplateId(){return r}P(o){this.u=o,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$IS(this.w,n(".select-box-details-pane"));const d=i.$IS(this.w,n(".select-box-dropdown-container-width-control")),a=i.$IS(d,n(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$IS(a,this.D),this.G=0,this.y=i.$qS(this.w),this.w.setAttribute("draggable","true"),this.B(i.$IR(this.w,i.$BS.DRAG_START,L=>{i.$DS.stop(L,!0)}))}Q(){this.B(i.$JR(this.h,"change",d=>{this.n=d.target.selectedIndex,this.r.fire({index:d.target.selectedIndex,selected:d.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$IR(this.h,i.$BS.CLICK,d=>{i.$DS.stop(d),this.f?this.Z(!0):this.Y()})),this.B(i.$IR(this.h,i.$BS.MOUSE_DOWN,d=>{i.$DS.stop(d)}));let o;this.B(i.$IR(this.h,"touchstart",d=>{o=this.f})),this.B(i.$IR(this.h,"touchend",d=>{i.$DS.stop(d),o?this.Z(!0):this.Y()})),this.B(i.$IR(this.h,i.$BS.KEY_DOWN,d=>{const a=new P.$FR(d);let L=!1;f.$j?(a.keyCode===18||a.keyCode===16||a.keyCode===10||a.keyCode===3)&&(L=!0):(a.keyCode===18&&a.altKey||a.keyCode===16&&a.altKey||a.keyCode===10||a.keyCode===3)&&(L=!0),L&&(this.Y(),i.$DS.stop(d,!0))}))}get onDidSelect(){return this.r.event}setOptions(o,d){b.$ub(this.m,o)||(this.m=o,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((a,L)=>{this.h.add(this.X(a.text,L,a.isDisabled)),typeof a.description=="string"&&(this.H=!0)})),d!==void 0&&(this.select(d),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(o){o>=0&&o<this.m.length?this.n=o:o>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(o){this.g.ariaLabel=o,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(o){this.h.tabIndex=o?0:-1}render(o){this.j=o,o.classList.add("select-container"),o.appendChild(this.h),this.U()}S(){const o=[];this.s.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=o.join(`
`)}U(){const o=this.s.selectBackground??"",d=this.s.selectForeground??"",a=this.s.selectBorder??"";this.h.style.backgroundColor=o,this.h.style.color=d,this.h.style.borderColor=a}W(){const o=this.s.selectBackground??"",d=i.$1S(this.s.selectListBackground,o);this.C.style.backgroundColor=d,this.I.style.backgroundColor=d;const a=this.s.focusBorder??"";this.w.style.outlineColor=a,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(o,d,a){const L=document.createElement("option");return L.value=o,L.text=o,L.disabled=!!a,L}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(o){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),o&&this.h.focus(),this.u.hideContextView())}ab(o,d){return o.appendChild(this.w),this.cb(d),{dispose:()=>{try{o.removeChild(this.w)}catch{}}}}bb(){let o=0;return this.m.forEach((d,a)=>{this.jb(a),this.I.offsetHeight>o&&(o=this.I.offsetHeight)}),o}cb(o){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const d=i.getWindow(this.h),a=i.$5R(this.h),L=i.getWindow(this.h).getComputedStyle(this.h),C=parseFloat(L.getPropertyValue("--dropdown-padding-top"))+parseFloat(L.getPropertyValue("--dropdown-padding-bottom")),N=d.innerHeight-a.top-a.height-(this.g.minBottomMargin||0),I=a.top-m.b,M=this.h.offsetWidth,E=this.db(this.D),z=Math.max(E,Math.round(M)).toString()+"px";this.w.style.width=z,this.z.getHTMLElement().style.height="",this.z.layout();let q=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const F=this.H?this.L:0,x=q+C+F,B=Math.floor((N-C-F)/this.getHeight()),Y=Math.floor((I-C-F)/this.getHeight());if(o)return a.top+a.height>d.innerHeight-22||a.top<m.b||B<1&&Y<1?!1:(B<m.c&&Y>B&&this.m.length>B?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(a.top+a.height>d.innerHeight-22||a.top<m.b||this.G===0&&B<1||this.G===1&&Y<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&B+Y<1)return this.Z(!0),!1;x>N&&(q=B*this.getHeight())}else x>I&&(q=Y*this.getHeight());return this.z.layout(q),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=q+C+"px",this.w.style.height=""):this.w.style.height=q+C+"px",this.jb(this.n),this.w.style.width=z,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(o){let d=0;if(o){let a=0,L=0;this.m.forEach((C,N)=>{const I=C.detail?C.detail.length:0,M=C.decoratorRight?C.decoratorRight.length:0,E=C.text.length+I+M;E>L&&(a=N,L=E)}),o.textContent=this.m[a].text+(this.m[a].decoratorRight?this.m[a].decoratorRight+" ":""),d=i.$7R(o)}return d}eb(o){if(this.z)return;this.C=i.$IS(o,n(".select-box-dropdown-list-container")),this.t=new h,this.z=new g.$dU("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:L=>{let C=L.text;return L.detail&&(C+=`. ${L.detail}`),L.decoratorRight&&(C+=`. ${L.decoratorRight}`),L.description&&(C+=`. ${L.description}`),C},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>f.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const d=this.B(new k.$KT(this.C,"keydown")),a=p.Event.chain(d.event,L=>L.filter(()=>this.z.length>0).map(C=>new P.$FR(C)));this.B(p.Event.chain(a,L=>L.filter(C=>C.keyCode===3))(this.lb,this)),this.B(p.Event.chain(a,L=>L.filter(C=>C.keyCode===2))(this.lb,this)),this.B(p.Event.chain(a,L=>L.filter(C=>C.keyCode===9))(this.kb,this)),this.B(p.Event.chain(a,L=>L.filter(C=>C.keyCode===16))(this.nb,this)),this.B(p.Event.chain(a,L=>L.filter(C=>C.keyCode===18))(this.mb,this)),this.B(p.Event.chain(a,L=>L.filter(C=>C.keyCode===12))(this.pb,this)),this.B(p.Event.chain(a,L=>L.filter(C=>C.keyCode===11))(this.ob,this)),this.B(p.Event.chain(a,L=>L.filter(C=>C.keyCode===14))(this.qb,this)),this.B(p.Event.chain(a,L=>L.filter(C=>C.keyCode===13))(this.rb,this)),this.B(p.Event.chain(a,L=>L.filter(C=>C.keyCode>=21&&C.keyCode<=56||C.keyCode>=85&&C.keyCode<=113))(this.sb,this)),this.B(i.$IR(this.z.getHTMLElement(),i.$BS.POINTER_UP,L=>this.fb(L))),this.B(this.z.onMouseOver(L=>typeof L.index<"u"&&this.z.setFocus([L.index]))),this.B(this.z.onDidChangeFocus(L=>this.ib(L))),this.B(i.$IR(this.w,i.$BS.FOCUS_OUT,L=>{!this.f||i.$aS(L.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(o){if(!this.z.length)return;i.$DS.stop(o);const d=o.target;if(!d||d.classList.contains("slider"))return;const a=d.closest(".monaco-list-row");if(!a)return;const L=Number(a.getAttribute("data-index")),C=a.classList.contains("option-disabled");L>=0&&L<this.m.length&&!C&&(this.n=L,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(o,d){const a=C=>{for(let N=0;N<C.childNodes.length;N++){const I=C.childNodes.item(N);(I.tagName&&I.tagName.toLowerCase())==="img"?C.removeChild(I):a(I)}},L=(0,W.$gU)({value:o,supportThemeIcons:!0},{actionHandler:d});return L.element.classList.add("select-box-description-markdown"),a(L.element),L.element}ib(o){!this.f||!this.H||this.jb(o.indexes[0])}jb(o){this.I.innerText="";const d=this.m[o],a=d?.description??"",L=d?.descriptionIsMarkdown??!1;if(a){if(L){const C=d.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(a,C))}else this.I.innerText=a;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(o){i.$DS.stop(o),this.select(this.F),this.Z(!0)}lb(o){i.$DS.stop(o),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(o){if(this.n<this.m.length-1){i.$DS.stop(o,!0);const d=this.m[this.n+1].isDisabled;if(d&&this.m.length>this.n+2)this.n+=2;else{if(d)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(o){this.n>0&&(i.$DS.stop(o,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(o){i.$DS.stop(o),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(o){i.$DS.stop(o),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(o){i.$DS.stop(o),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(o){i.$DS.stop(o),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(o){const d=O.KeyCodeUtils.toString(o.keyCode);let a=-1;for(let L=0;L<this.m.length-1;L++)if(a=(L+this.n+1)%this.m.length,this.m[a].text.charAt(0).toUpperCase()===d&&!this.m[a].isDisabled){this.select(a),this.z.setFocus([a]),this.z.reveal(this.z.getFocus()[0]),i.$DS.stop(o);break}}dispose(){this.Z(!1),super.dispose()}}t.$nU=m}),define(me[140],be([1,0,49,139,133,21,5,112]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qU=t.$pU=void 0,t.$pU={...i.$cU,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends W.$jT{constructor(b,p,O,c,f){super(),S.$j&&!f?.useCustomDrawn?this.a=new P.$oU(b,p,c,f):this.a=new k.$nU(b,p,O,c,f),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(b,p){this.a.setOptions(b,p)}select(b){this.a.select(b)}setAriaLabel(b){this.a.setAriaLabel(b)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(b){this.a.setFocusable(b)}render(b){this.a.render(b)}}t.$qU=A}),define(me[73],be([1,0,17,65,4,28,14,140,46,2,5,10,117,29,63]),function(se,t,i,k,P,W,S,A,g,b,p,O,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yU=t.$xU=t.$wU=void 0;class e extends b.$Uc{get action(){return this._action}constructor(m,y,o={}){super(),this.m=o,this._context=m||this,this._action=y,y instanceof g.$9i&&this.B(y.onDidChange(d=>{this.element&&this.t(d)}))}t(m){m.enabled!==void 0&&this.u(),m.checked!==void 0&&this.H(),m.class!==void 0&&this.G(),m.label!==void 0&&(this.w(),this.D()),m.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new g.$0i)),this.j}set actionRunner(m){this.j=m}isEnabled(){return this._action.enabled}setActionContext(m){this._context=m}render(m){const y=this.element=m;this.B(W.$fT.addTarget(m));const o=this.m&&this.m.draggable;o&&(m.draggable=!0,i.$oR&&this.B((0,P.$IR)(m,P.$BS.DRAG_START,d=>d.dataTransfer?.setData(k.$dT.TEXT,this._action.label)))),this.B((0,P.$IR)(y,W.EventType.Tap,d=>this.onClick(d,!0))),this.B((0,P.$IR)(y,P.$BS.MOUSE_DOWN,d=>{o||P.$DS.stop(d,!0),this._action.enabled&&d.button===0&&y.classList.add("active")})),p.$j&&this.B((0,P.$IR)(y,P.$BS.CONTEXT_MENU,d=>{d.button===0&&d.ctrlKey===!0&&this.onClick(d)})),this.B((0,P.$IR)(y,P.$BS.CLICK,d=>{P.$DS.stop(d,!0),this.m&&this.m.isMenu||this.onClick(d)})),this.B((0,P.$IR)(y,P.$BS.DBLCLICK,d=>{P.$DS.stop(d,!0)})),[P.$BS.MOUSE_UP,P.$BS.MOUSE_OUT].forEach(d=>{this.B((0,P.$IR)(y,d,a=>{P.$DS.stop(a),y.classList.remove("active")}))})}onClick(m,y=!1){P.$DS.stop(m,!0);const o=O.$bg(this._context)?this.m?.useEventAsContext?m:{preserveFocus:y}:this._context;this.actionRunner.run(this._action,o)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(m){this.element&&(this.element.tabIndex=m?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const m=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=m;else if(!this.f&&m!==""){const y=this.m.hoverDelegate??(0,S.$AT)("element");this.f=this.q.add((0,f.$mU)().setupUpdatableHover(y,this.element,m))}else this.f&&this.f.update(m)}F(){if(this.element){const m=this.C()??"";this.element.setAttribute("aria-label",m)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$wU=e;class n extends e{constructor(m,y,o){super(m,y,o),this.m=o,this.m.icon=o.icon!==void 0?o.icon:!1,this.m.label=o.label!==void 0?o.label:!0,this.L=""}render(m){super.render(m),O.$cg(this.element);const y=document.createElement("a");if(y.classList.add("action-label"),y.setAttribute("role",this.M()),this.I=y,this.element.appendChild(y),this.m.label&&this.m.keybinding){const o=document.createElement("span");o.classList.add("keybinding"),o.textContent=this.m.keybinding,this.element.appendChild(o)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===g.$$i.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(m){this.I&&(this.I.tabIndex=m?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let m=null;return this.action.tooltip?m=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(m=this.action.label,this.m.keybinding&&(m=c.localize(0,null,m,this.m.keybinding))),m??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const m=this.C()??"";this.I.setAttribute("aria-label",m)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$xU=n;class r extends e{constructor(m,y,o,d,a,L,C){super(m,y),this.b=new A.$qU(o,d,a,L,C),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(m,y){this.b.setOptions(m,y)}select(m){this.b.select(m)}g(){this.B(this.b.onDidSelect(m=>this.n(m.selected,m.index)))}n(m,y){this.actionRunner.run(this._action,this.r(m,y))}r(m,y){return m}setFocusable(m){this.b.setFocusable(m)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(m){this.b.render(m)}}t.$yU=r}),define(me[74],be([1,0,4,15,73,14,46,3,2,10,63]),function(se,t,i,k,P,W,S,A,g,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CT=t.ActionsOrientation=void 0,t.$DT=c;var p;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(p||(t.ActionsOrientation=p={}));class O extends g.$Uc{constructor(e,n={}){super(),this.j=this.B(new g.$Tc),this.s=this.B(new g.$4c),this.y=!1,this.z=!0,this.D=this.B(new A.$be),this.onDidBlur=this.D.event,this.F=this.B(new A.$be({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new A.$be),this.onDidRun=this.H.event,this.I=this.B(new A.$be),this.onWillRun=this.I.event,this.b=n,this.m=n.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=n.hoverDelegate??this.B((0,W.$BT)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new S.$0i,this.j.add(this.g)),this.j.add(this.g.onDidRun(m=>this.H.fire(m))),this.j.add(this.g.onWillRun(m=>this.I.fire(m))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let r,h;switch(this.n){case 0:r=[15],h=[17];break;case 1:r=[16],h=[18],this.domNode.className+=" vertical";break}this.B(i.$IR(this.domNode,i.$BS.KEY_DOWN,m=>{const y=new k.$FR(m);let o=!0;const d=typeof this.u=="number"?this.viewItems[this.u]:void 0;r&&(y.equals(r[0])||y.equals(r[1]))?o=this.Q():h&&(y.equals(h[0])||y.equals(h[1]))?o=this.P():y.equals(9)&&this.G?this.F.fire():y.equals(14)?o=this.N():y.equals(13)?o=this.O():y.equals(2)&&d instanceof P.$wU&&d.trapsArrowNavigation?o=this.P():this.L(y)?this.r.keyDown?this.S(y):this.y=!0:o=!1,o&&(y.preventDefault(),y.stopPropagation())})),this.B(i.$IR(this.domNode,i.$BS.KEY_UP,m=>{const y=new k.$FR(m);this.L(y)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(y)),y.preventDefault(),y.stopPropagation()):(y.equals(2)||y.equals(1026)||y.equals(16)||y.equals(18)||y.equals(15)||y.equals(17))&&this.M()})),this.w=this.B(i.$GS(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$iS()===this.domNode||!i.$aS(i.$iS(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),e.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(e){e?this.C.setAttribute("aria-label",e):this.C.removeAttribute("aria-label")}setFocusable(e){if(this.z=e,this.z){const n=this.viewItems.find(r=>r instanceof P.$wU&&r.isEnabled());n instanceof P.$wU&&n.setFocusable(!0)}else this.viewItems.forEach(n=>{n instanceof P.$wU&&n.setFocusable(!1)})}L(e){let n=!1;return this.r.keys.forEach(r=>{n=n||e.equals(r)}),n}M(){for(let e=0;e<this.C.children.length;e++){const n=this.C.children[e];if(i.$aS(i.$iS(),n)){this.u=e,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(e){this.m=e,this.viewItems.forEach(n=>n.setActionContext(e))}get actionRunner(){return this.g}set actionRunner(e){this.g=e,this.j.clear(),this.j.add(this.g.onDidRun(n=>this.H.fire(n))),this.j.add(this.g.onWillRun(n=>this.I.fire(n))),this.viewItems.forEach(n=>n.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(n=>n.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.C;){if(!e.parentElement)return;e=e.parentElement}for(let n=0;n<this.C.childNodes.length;n++)if(this.C.childNodes[n]===e)return this.viewItems[n].action}}push(e,n={}){const r=Array.isArray(e)?e:[e];let h=b.$9f(n.index)?n.index:null;r.forEach(m=>{const y=document.createElement("li");y.className="action-item",y.setAttribute("role","presentation");let o;const d={hoverDelegate:this.f,...n};this.b.actionViewItemProvider&&(o=this.b.actionViewItemProvider(m,d)),o||(o=new P.$xU(this.context,m,d)),this.b.allowContextMenu||this.s.set(o,i.$IR(y,i.$BS.CONTEXT_MENU,a=>{i.$DS.stop(a,!0)})),o.actionRunner=this.g,o.setActionContext(this.context),o.render(y),this.z&&o instanceof P.$wU&&this.viewItems.length===0&&o.setFocusable(!0),h===null||h<0||h>=this.C.children.length?(this.C.appendChild(y),this.viewItems.push(o)):(this.C.insertBefore(y,this.C.children[h]),this.viewItems.splice(h,0,o),h++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[e]),this.s.deleteAndDispose(this.viewItems[e]),(0,g.$Pc)(this.viewItems.splice(e,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,g.$Pc)(this.viewItems),this.s.clearAndDisposeAll(),i.$HR(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let n=!1,r;if(e===void 0?n=!0:typeof e=="number"?r=e:typeof e=="boolean"&&(n=e),n&&typeof this.u>"u"){const h=this.viewItems.findIndex(m=>m.isEnabled());this.u=h===-1?void 0:h,this.R(void 0,void 0,!0)}else r!==void 0&&(this.u=r),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(e){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const n=this.u;let r;do{if(!e&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=n,!1;this.u=(this.u+1)%this.viewItems.length,r=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===S.$$i.ID));return this.R(),!0}Q(e){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const n=this.u;let r;do{if(this.u=this.u-1,this.u<0){if(!e&&this.b.preventLoopNavigation)return this.u=n,!1;this.u=this.viewItems.length-1}r=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===S.$$i.ID));return this.R(!0),!0}R(e,n,r=!1){typeof this.u>"u"&&this.C.focus({preventScroll:n}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const h=this.u!==void 0?this.viewItems[this.u]:void 0;if(h){let m=!0;b.$gg(h.focus)||(m=!1),this.b.focusOnlyEnabledItems&&b.$gg(h.isEnabled)&&!h.isEnabled()&&(m=!1),h.action.id===S.$$i.ID&&(m=!1),m?(r||this.t!==this.u)&&(h.focus(e),this.t=this.u):(this.C.focus({preventScroll:n}),this.t=void 0),m&&h.showHover?.()}}S(e){if(typeof this.u>"u")return;const n=this.viewItems[this.u];if(n instanceof P.$wU){const r=n._context===null||n._context===void 0?e:n._context;this.run(n._action,r)}}async run(e,n){await this.g.run(e,n)}dispose(){this.m=void 0,this.viewItems=(0,g.$Pc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$CT=O;function c(f){if(!f.length)return f;let e=-1;for(let r=0;r<f.length;r++)if(f[r].id!==S.$$i.ID){e=r;break}if(e===-1)return[];f=f.slice(e);for(let r=f.length-1;r>=0&&f[r].id===S.$$i.ID;r--)f.splice(r,1);let n=!1;for(let r=f.length-1;r>=0;r--){const h=f[r].id===S.$$i.ID;h&&!n?f.splice(r,1):h?h&&(n=!1):n=!0}return f}}),define(me[75],be([1,0,4,24,66,74,68,29,14,71,21,3,91,61,120,109]),function(se,t,i,k,P,W,S,A,g,b,p,O,c,f,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fV=t.$eV=t.$dV=t.MessageType=void 0;const n=i.$;var r;(function(y){y[y.INFO=1]="INFO",y[y.WARNING=2]="WARNING",y[y.ERROR=3]="ERROR"})(r||(t.MessageType=r={})),t.$dV={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class h extends p.$jT{constructor(o,d,a){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new O.$be),this.onDidChange=this.P.event,this.Q=this.B(new O.$be),this.onDidHeightChange=this.Q.event,this.a=d,this.g=a,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$IS(o,n(".monaco-inputbox.idle"));const L=this.g.flexibleHeight?"textarea":"input",C=i.$IS(this.element,n(".ibwrapper"));if(this.b=i.$IS(C,n(L+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$IS(C,n("div.mirror")),this.y.innerText="\xA0",this.N=new b.$tT(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$IS(o,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(M=>this.b.scrollTop=M.scrollTop));const N=this.B(new k.$KT(o.ownerDocument,"selectionchange")),I=O.Event.filter(N.event,()=>o.ownerDocument.getSelection()?.anchorNode===C);this.B(I(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new W.$CT(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(o){this.n=o,this.b.setAttribute("placeholder",o)}setTooltip(o){this.r=o,this.O?this.O.update(o):this.O=this.B((0,A.$mU)().setupUpdatableHover((0,g.$AT)("mouse"),this.b,o))}setAriaLabel(o){this.s=o,o?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(o){this.b.value!==o&&(this.b.value=o,this.Z())}get step(){return this.b.step}set step(o){this.b.step=o}get height(){return typeof this.J=="number"?this.J:i.$$R(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$jS(this.b)}select(o=null){this.b.select(),o&&(this.b.setSelectionRange(o.start,o.end),o.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const o=this.b.selectionStart;if(o===null)return null;const d=this.b.selectionEnd??o;return{start:o,end:d}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(o){o?this.enable():this.disable()}get width(){return i.$7R(this.b)}set width(o){if(this.g.flexibleHeight&&this.g.flexibleWidth){let d=0;if(this.y){const a=parseFloat(this.y.style.paddingLeft||"")||0,L=parseFloat(this.y.style.paddingRight||"")||0;d=a+L}this.b.style.width=o-d+"px"}else this.b.style.width=o+"px";this.y&&(this.y.style.width=o+"px")}set paddingRight(o){this.b.style.width=`calc(100% - ${o}px)`,this.y&&(this.y.style.paddingRight=o+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const o=this.L,d=this.J,a=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:o,height:d}),this.N.setScrollPosition({scrollTop:a})}showMessage(o,d){if(this.w==="open"&&(0,f.$2n)(this.h,o))return;this.h=o,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(o.type));const a=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$1S(a.border,"transparent")}`,this.h.content&&(this.hasFocus()||d)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let o=null;return this.t&&(o=this.t(this.value),o?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(o)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),o?.type}stylesForType(o){const d=this.g.inputBoxStyles;switch(o){case 1:return{border:d.inputValidationInfoBorder,background:d.inputValidationInfoBackground,foreground:d.inputValidationInfoForeground};case 2:return{border:d.inputValidationWarningBorder,background:d.inputValidationWarningBackground,foreground:d.inputValidationWarningForeground};default:return{border:d.inputValidationErrorBorder,background:d.inputValidationErrorBackground,foreground:d.inputValidationErrorForeground}}}W(o){switch(o){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let o;const d=()=>o.style.width=i.$7R(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:L=>{if(!this.h)return null;o=i.$IS(L,n(".monaco-inputbox-container")),d();const C={inline:!0,className:"monaco-inputbox-message"},N=this.h.formatContent?(0,P.$IT)(this.h.content,C):(0,P.$HT)(this.h.content,C);N.classList.add(this.W(this.h.type));const I=this.stylesForType(this.h.type);return N.style.backgroundColor=I.background??"",N.style.color=I.foreground??"",N.style.border=I.border?`1px solid ${I.border}`:"",i.$IS(o,N),null},onHide:()=>{this.w="closed"},layout:d});let a;this.h.type===3?a=e.localize(0,null,this.h.content):this.h.type===2?a=e.localize(1,null,this.h.content):a=e.localize(2,null,this.h.content),S.$MT(a),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const o=this.value,a=o.charCodeAt(o.length-1)===10?" ":"";(o+a).replace(/\u000c/g,"")?this.y.textContent=o+a:this.y.innerText="\xA0",this.layout()}bb(){const o=this.g.inputBoxStyles,d=o.inputBackground??"",a=o.inputForeground??"",L=o.inputBorder??"";this.element.style.backgroundColor=d,this.element.style.color=a,this.b.style.backgroundColor="inherit",this.b.style.color=a,this.element.style.border=`1px solid ${i.$1S(L,"transparent")}`}layout(){if(!this.y)return;const o=this.L;this.L=i.$$R(this.y),o!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(o){const d=this.inputElement,a=d.selectionStart,L=d.selectionEnd,C=d.value;a!==null&&L!==null&&(this.value=C.substr(0,a)+o+C.substr(L),d.setSelectionRange(a+1,a+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$eV=h;class m extends h{constructor(o,d,a){const L=e.localize(3,null,"\u21C5"),C=e.localize(4,null,"\u21C5");super(o,d,a),this.eb=this.B(new O.$be),this.onDidFocus=this.eb.event,this.fb=this.B(new O.$be),this.onDidBlur=this.fb.event,this.cb=new c.$bV(a.history,100);const N=()=>{if(a.showHistoryHint&&a.showHistoryHint()&&!this.n.endsWith(L)&&!this.n.endsWith(C)&&this.cb.getHistory().length){const I=this.n.endsWith(")")?L:C,M=this.n+I;a.showPlaceholderOnFocus&&!i.$jS(this.b)?this.n=M:this.setPlaceHolder(M)}};this.db=new MutationObserver((I,M)=>{I.forEach(E=>{E.target.textContent||N()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>N()),this.F(this.b,()=>{const I=M=>{if(this.n.endsWith(M)){const E=this.n.slice(0,this.n.length-M.length);return a.showPlaceholderOnFocus?this.n=E:this.setPlaceHolder(E),!0}else return!1};I(C)||I(L)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(o){this.value&&(o||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(o){const d=this.getHistory();this.clearHistory(),o.forEach(a=>{this.cb.add(a)}),d.forEach(a=>{this.cb.add(a)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let o=this.kb();o&&(o=o===this.value?this.kb():o),this.value=o??"",S.$NT(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let o=this.jb();o&&(o=o===this.value?this.jb():o),o&&(this.value=o,S.$NT(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(o){super.setPlaceHolder(o),this.setTooltip(o)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let o=this.cb.current();return o||(o=this.cb.last(),this.cb.next()),o}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$fV=m}),define(me[76],be([1,0,73,21,18,19,3,4,14,29,114]),function(se,t,i,k,P,W,S,A,g,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vU=t.$uU=t.$tU=t.$sU=t.$rU=void 0,t.$rU={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class p extends i.$wU{constructor(n,r,h){super(n,r,h),this.a=this.B(new O({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:h.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:h.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:h.toggleStyles?.inputActiveOptionForeground,hoverDelegate:h.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(n){this.element=n,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$sU=p;class O extends k.$jT{constructor(n){super(),this.a=this.B(new S.$be),this.onChange=this.a.event,this.b=this.B(new S.$be),this.onKeyDown=this.b.event,this.c=n,this.s=this.c.isChecked;const r=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,r.push(...W.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&r.push(...this.c.actionClassName.split(" ")),this.s&&r.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,b.$mU)().setupUpdatableHover(n.hoverDelegate??(0,g.$AT)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...r),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,h=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),h.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,h=>{if(h.keyCode===10||h.keyCode===3){this.checked=!this.s,this.a.fire(!0),h.preventDefault(),h.stopPropagation();return}this.b.fire(h)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(n){this.s=n,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(n){this.g&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this.g)),this.g=n,this.g&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(n){this.t.update(n),this.domNode.setAttribute("aria-label",n)}set visible(n){this.domNode.style.display=n?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$tU=O;class c extends k.$jT{constructor(n,r,h){super(),this.g=n,this.h=r,this.a=this.B(new S.$be),this.onChange=this.a.event,this.b=this.B(new O({title:this.g,isChecked:this.h,icon:P.$Qj.check,actionClassName:"monaco-checkbox",...t.$rU})),this.domNode=this.b.domNode,this.c=h,this.n(),this.B(this.b.onChange(m=>{this.n(),this.a.fire(m)}))}get checked(){return this.b.checked}set checked(n){this.b.checked=n,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,A.$jS)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$uU=c;class f extends i.$wU{constructor(n,r,h){super(n,r,h),this.a=this.B(new c(this._action.label,!!this._action.checked,h.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(n){if(this.element=n,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const r=this.element.appendChild((0,A.$)("span.checkbox-label",void 0,this._action.label));this.B((0,A.$IR)(r,A.$BS.CLICK,h=>{this.a.checked=!this.a.checked,h.stopPropagation(),h.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$vU=f}),define(me[141],be([1,0,14,76,18,119]),function(se,t,i,k,P,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sV=t.$rV=t.$qV=void 0;const S=W.localize(0,null),A=W.localize(1,null),g=W.localize(2,null);class b extends k.$tU{constructor(f){super({icon:P.$Qj.caseSensitive,title:S+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$AT)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$qV=b;class p extends k.$tU{constructor(f){super({icon:P.$Qj.wholeWord,title:A+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$AT)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$rV=p;class O extends k.$tU{constructor(f){super({icon:P.$Qj.regex,title:g+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,i.$AT)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$sV=O}),define(me[142],be([1,0,4,141,75,21,3,118,2,14,108]),function(se,t,i,k,P,W,S,A,g,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tV=void 0;const p=A.localize(0,null);class O extends W.$jT{static{this.OPTION_CHANGE="optionChange"}constructor(f,e,n){super(),this.n=!0,this.s=!1,this.w=this.B(new g.$Vc),this.N=[],this.O=this.B(new S.$be),this.onDidOptionChange=this.O.event,this.P=this.B(new S.$be),this.onKeyDown=this.P.event,this.Q=this.B(new S.$be),this.onMouseDown=this.Q.event,this.R=this.B(new S.$be),this.onInput=this.R.event,this.S=this.B(new S.$be),this.onKeyUp=this.S.event,this.U=this.B(new S.$be),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new S.$be),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=n.placeholder||"",this.b=n.validation,this.c=n.label||p,this.h=!!n.showCommonFindToggles;const r=n.appendCaseSensitiveLabel||"",h=n.appendWholeWordsLabel||"",m=n.appendRegexLabel||"",y=n.history||[],o=!!n.flexibleHeight,d=!!n.flexibleWidth,a=n.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new P.$fV(this.domNode,e,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:y,showHistoryHint:n.showHistoryHint,flexibleHeight:o,flexibleWidth:d,flexibleMaxHeight:a,inputBoxStyles:n.inputBoxStyles}));const L=this.B((0,b.$BT)());if(this.h){this.J=this.B(new k.$sV({appendTitle:m,isChecked:!1,hoverDelegate:L,...n.toggleStyles})),this.B(this.J.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(N=>{this.W.fire(N)})),this.L=this.B(new k.$rV({appendTitle:h,isChecked:!1,hoverDelegate:L,...n.toggleStyles})),this.B(this.L.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new k.$qV({appendTitle:r,isChecked:!1,hoverDelegate:L,...n.toggleStyles})),this.B(this.M.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(N=>{this.U.fire(N)}));const C=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const I=C.indexOf(this.domNode.ownerDocument.activeElement);if(I>=0){let M=-1;N.equals(17)?M=(I+1)%C.length:N.equals(15)&&(I===0?M=C.length-1:M=I-1),N.equals(9)?(C[I].blur(),this.inputBox.focus()):M>=0&&C[M].focus(),i.$DS.stop(N,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(n?.additionalToggles),this.y&&this.domNode.appendChild(this.y),f?.appendChild(this.domNode),this.B(i.$IR(this.inputBox.inputElement,"compositionstart",C=>{this.s=!0})),this.B(i.$IR(this.inputBox.inputElement,"compositionend",C=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,C=>this.P.fire(C)),this.C(this.inputBox.inputElement,C=>this.S.fire(C)),this.D(this.inputBox.inputElement,C=>this.R.fire()),this.j(this.inputBox.inputElement,C=>this.Q.fire(C))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(f){this.inputBox.layout(),this.X(f.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const f of this.N)f.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const f of this.N)f.disable()}setFocusInputOnOptionClick(f){this.n=f}setEnabled(f){f?this.enable():this.disable()}setAdditionalToggles(f){for(const e of this.N)e.domNode.remove();this.N=[],this.w.value=new g.$Tc;for(const e of f??[])this.w.value.add(e),this.y.appendChild(e.domNode),this.w.value.add(e.onChange(n=>{this.O.fire(n),!n&&this.n&&this.inputBox.focus()})),this.N.push(e);this.N.length>0&&(this.y.style.display=""),this.X()}X(f=!1){f?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((e,n)=>e+n.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(f){this.inputBox.value!==f&&(this.inputBox.value=f)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(f){this.M&&(this.M.checked=f)}getWholeWords(){return this.L?.checked??!1}setWholeWords(f){this.L&&(this.L.checked=f)}getRegex(){return this.J?.checked??!1}setRegex(f){this.J&&(this.J.checked=f,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(f){this.inputBox.showMessage(f)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$tV=O}),define(me[143],be([1,0,4,24,15,74,142,75,72,49,76,69,30,46,8,11,18,19,39,3,44,2,40,10,122,14,57,115]),function(se,t,i,k,P,W,S,A,g,b,p,O,c,f,e,n,r,h,m,y,o,d,a,L,C,N,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5V=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$4V=t.$3V=t.$2V=t.RenderIndentGuides=t.$1V=t.$ZV=void 0;class M extends g.$UT{set context(s){this.c.context=s}get context(){return this.c.context}constructor(s){super(s.elements.map(D=>D.element)),this.c=s}}function E(T){return T instanceof g.$UT?new M(T):T}class z{constructor(s,D){this.d=s,this.f=D,this.b=d.$Uc.None,this.c=new d.$Tc}getDragURI(s){return this.f.getDragURI(s.element)}getDragLabel(s,D){if(this.f.getDragLabel)return this.f.getDragLabel(s.map($=>$.element),D)}onDragStart(s,D){this.f.onDragStart?.(E(s),D)}onDragOver(s,D,$,R,j,U=!0){const J=this.f.onDragOver(E(s),D&&D.element,$,R,j),oe=this.a!==D;if(oe&&(this.b.dispose(),this.a=D),typeof D>"u")return J;if(oe&&typeof J!="boolean"&&J.autoExpand&&(this.b=(0,n.$th)(()=>{const Oe=this.d(),Se=Oe.getNodeLocation(D);Oe.isCollapsed(Se)&&Oe.setCollapsed(Se,!1),this.a=void 0},500,this.c)),typeof J=="boolean"||!J.accept||typeof J.bubble>"u"||J.feedback){if(!U){const Oe=typeof J=="boolean"?J:J.accept,Se=typeof J=="boolean"?void 0:J.effect;return{accept:Oe,effect:Se,feedback:[$]}}return J}if(J.bubble===1){const Oe=this.d(),Se=Oe.getNodeLocation(D),Fe=Oe.getParentNodeLocation(Se),We=Oe.getNode(Fe),Xe=Fe&&Oe.getListIndex(Fe);return this.onDragOver(s,We,Xe,R,j,!1)}const pe=this.d(),fe=pe.getNodeLocation(D),Re=pe.getListIndex(fe),ke=pe.getListRenderCount(fe);return{...J,feedback:(0,e.$Sb)(Re,Re+ke)}}drop(s,D,$,R,j){this.b.dispose(),this.a=void 0,this.f.drop(E(s),D&&D.element,$,R,j)}onDragEnd(s){this.f.onDragEnd?.(s)}dispose(){this.c.dispose(),this.f.dispose()}}function q(T,s){return s&&{...s,identityProvider:s.identityProvider&&{getId(D){return s.identityProvider.getId(D.element)}},dnd:s.dnd&&new z(T,s.dnd),multipleSelectionController:s.multipleSelectionController&&{isSelectionSingleChangeEvent(D){return s.multipleSelectionController.isSelectionSingleChangeEvent({...D,element:D.element})},isSelectionRangeChangeEvent(D){return s.multipleSelectionController.isSelectionRangeChangeEvent({...D,element:D.element})}},accessibilityProvider:s.accessibilityProvider&&{...s.accessibilityProvider,getSetSize(D){const $=T(),R=$.getNodeLocation(D),j=$.getParentNodeLocation(R);return $.getNode(j).visibleChildrenCount},getPosInSet(D){return D.visibleChildIndex+1},isChecked:s.accessibilityProvider&&s.accessibilityProvider.isChecked?D=>s.accessibilityProvider.isChecked(D.element):void 0,getRole:s.accessibilityProvider&&s.accessibilityProvider.getRole?D=>s.accessibilityProvider.getRole(D.element):()=>"treeitem",getAriaLabel(D){return s.accessibilityProvider.getAriaLabel(D.element)},getWidgetAriaLabel(){return s.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:s.accessibilityProvider&&s.accessibilityProvider.getWidgetRole?()=>s.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:s.accessibilityProvider&&s.accessibilityProvider.getAriaLevel?D=>s.accessibilityProvider.getAriaLevel(D.element):D=>D.depth,getActiveDescendantId:s.accessibilityProvider.getActiveDescendantId&&(D=>s.accessibilityProvider.getActiveDescendantId(D.element))},keyboardNavigationLabelProvider:s.keyboardNavigationLabelProvider&&{...s.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(D){return s.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(D.element)}}}}class F{constructor(s){this.a=s}getHeight(s){return this.a.getHeight(s.element)}getTemplateId(s){return this.a.getTemplateId(s.element)}hasDynamicHeight(s){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(s.element)}setDynamicHeight(s,D){this.a.setDynamicHeight?.(s.element,D)}}t.$ZV=F;class x{static lift(s){return s instanceof x?s:new x(s)}static empty(s=0){return new x({focus:[],selection:[],expanded:Object.create(null),scrollTop:s})}constructor(s){if(this.focus=new Set(s.focus),this.selection=new Set(s.selection),s.expanded instanceof Array){this.expanded=Object.create(null);for(const D of s.expanded)this.expanded[D]=1}else this.expanded=s.expanded;this.expanded=s.expanded,this.scrollTop=s.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$1V=x;var B;(function(T){T.None="none",T.OnHover="onHover",T.Always="always"})(B||(t.RenderIndentGuides=B={}));class Y{get elements(){return this.b}constructor(s,D=[]){this.b=D,this.a=new d.$Tc,this.onDidChange=y.Event.forEach(s,$=>this.b=$,this.a)}dispose(){this.a.dispose()}}class K{static{this.a=8}constructor(s,D,$,R,j,U={}){this.o=s,this.p=D,this.q=R,this.s=j,this.b=new Map,this.c=new Map,this.d=K.a,this.f=!1,this.g=!1,this.j=new Set,this.k=d.$Uc.None,this.m=new d.$Tc,this.templateId=s.templateId,this.updateOptions(U),y.Event.map($,J=>J.node)(this.u,this,this.m),s.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(s={}){if(typeof s.indent<"u"){const D=(0,a.$wm)(s.indent,0,40);if(D!==this.d){this.d=D;for(const[$,R]of this.c)this.v($,R)}}if(typeof s.renderIndentGuides<"u"){const D=s.renderIndentGuides!==B.None;if(D!==this.g){this.g=D;for(const[$,R]of this.c)this.w($,R);if(this.k.dispose(),D){const $=new d.$Tc;this.q.onDidChange(this.x,this,$),this.k=$,this.x(this.q.elements)}}}typeof s.hideTwistiesOfChildlessElements<"u"&&(this.f=s.hideTwistiesOfChildlessElements)}renderTemplate(s){const D=(0,i.$IS)(s,(0,i.$)(".monaco-tl-row")),$=(0,i.$IS)(D,(0,i.$)(".monaco-tl-indent")),R=(0,i.$IS)(D,(0,i.$)(".monaco-tl-twistie")),j=(0,i.$IS)(D,(0,i.$)(".monaco-tl-contents")),U=this.o.renderTemplate(j);return{container:s,indent:$,twistie:R,indentGuidesDisposable:d.$Uc.None,templateData:U}}renderElement(s,D,$,R){this.c.set(s,$),this.b.set(s.element,s),this.v(s,$),this.o.renderElement(s,D,$.templateData,R)}disposeElement(s,D,$,R){$.indentGuidesDisposable.dispose(),this.o.disposeElement?.(s,D,$.templateData,R),typeof R=="number"&&(this.c.delete(s),this.b.delete(s.element))}disposeTemplate(s){this.o.disposeTemplate(s.templateData)}t(s){const D=this.b.get(s);D&&this.u(D)}u(s){const D=this.c.get(s);D&&(this.x(this.q.elements),this.v(s,D))}v(s,D){const $=K.a+(s.depth-1)*this.d;D.twistie.style.paddingLeft=`${$}px`,D.indent.style.width=`${$+this.d-16}px`,s.collapsible?D.container.setAttribute("aria-expanded",String(!s.collapsed)):D.container.removeAttribute("aria-expanded"),D.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(r.$Qj.treeItemExpanded));let R=!1;this.o.renderTwistie&&(R=this.o.renderTwistie(s.element,D.twistie)),s.collapsible&&(!this.f||s.visibleChildrenCount>0)?(R||D.twistie.classList.add(...h.ThemeIcon.asClassNameArray(r.$Qj.treeItemExpanded)),D.twistie.classList.add("collapsible"),D.twistie.classList.toggle("collapsed",s.collapsed)):D.twistie.classList.remove("collapsible","collapsed"),this.w(s,D)}w(s,D){if((0,i.$HR)(D.indent),D.indentGuidesDisposable.dispose(),!this.g)return;const $=new d.$Tc,R=this.p();for(;;){const j=R.getNodeLocation(s),U=R.getParentNodeLocation(j);if(!U)break;const J=R.getNode(U),oe=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(J)&&oe.classList.add("active"),D.indent.childElementCount===0?D.indent.appendChild(oe):D.indent.insertBefore(oe,D.indent.firstElementChild),this.s.add(J,oe),$.add((0,d.$Sc)(()=>this.s.delete(J,oe))),s=J}D.indentGuidesDisposable=$}x(s){if(!this.g)return;const D=new Set,$=this.p();s.forEach(R=>{const j=$.getNodeLocation(R);try{const U=$.getParentNodeLocation(j);R.collapsible&&R.children.length>0&&!R.collapsed?D.add(R):U&&D.add($.getNode(U))}catch{}}),this.j.forEach(R=>{D.has(R)||this.s.forEach(R,j=>j.classList.remove("active"))}),D.forEach(R=>{this.j.has(R)||this.s.forEach(R,j=>j.classList.add("active"))}),this.j=D}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,d.$Pc)(this.m)}}t.$2V=K;class ae{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(s){this.c=s,this.d=s.toLowerCase()}constructor(s,D,$){this.g=s,this.j=D,this.k=$,this.a=0,this.b=0,this.c="",this.d="",this.f=new d.$Tc,s.onWillRefilter(this.m,this,this.f)}filter(s,D){let $=1;if(this.k){const U=this.k.filter(s,D);if(typeof U=="boolean"?$=U?1:0:(0,O.$WV)(U)?$=(0,O.$XV)(U.visibility):$=U,$===0)return!1}if(this.a++,!this.c)return this.b++,{data:o.FuzzyScore.Default,visibility:$};const R=this.j.getKeyboardNavigationLabel(s),j=Array.isArray(R)?R:[R];for(const U of j){const J=U&&U.toString();if(typeof J>"u")return{data:o.FuzzyScore.Default,visibility:$};let oe;if(this.g.findMatchType===Ee.Contiguous){const pe=J.toLowerCase().indexOf(this.d);if(pe>-1){oe=[Number.MAX_SAFE_INTEGER,0];for(let fe=this.d.length;fe>0;fe--)oe.push(pe+fe-1)}}else oe=(0,o.$Fk)(this.c,this.d,0,J,J.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return this.b++,j.length===1?{data:oe,visibility:$}:{data:{label:J,score:oe},visibility:$}}return this.g.findMode===De.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(s):2:{data:o.FuzzyScore.Default,visibility:$}}m(){this.a=0,this.b=0}dispose(){(0,d.$Pc)(this.f)}}class ie extends p.$tU{constructor(s){super({icon:r.$Qj.listFilter,title:(0,C.localize)(0,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,N.$AT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$3V=ie;class ee extends p.$tU{constructor(s){super({icon:r.$Qj.searchFuzzy,title:(0,C.localize)(1,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,N.$AT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$4V=ee;const ce={inputBoxStyles:A.$dV,toggleStyles:p.$rU,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var De;(function(T){T[T.Highlight=0]="Highlight",T[T.Filter=1]="Filter"})(De||(t.TreeFindMode=De={}));var Ee;(function(T){T[T.Fuzzy=0]="Fuzzy",T[T.Contiguous=1]="Contiguous"})(Ee||(t.TreeFindMatchType=Ee={}));class Ie extends d.$Uc{set mode(s){this.b.checked=s===De.Filter,this.f.inputBox.setPlaceHolder(s===De.Filter?(0,C.localize)(2,null):(0,C.localize)(3,null))}set matchType(s){this.c.checked=s===Ee.Fuzzy}get value(){return this.f.inputBox.value}set value(s){this.f.inputBox.value=s}constructor(s,D,$,R,j,U){super(),this.t=D,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new y.$be,this.onDidDisable=this._onDidDisable.event,s.appendChild(this.a.root),this.B((0,d.$Sc)(()=>s.removeChild(this.a.root)));const J=U?.styles??ce;J.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=J.listFilterWidgetBackground),J.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${J.listFilterWidgetShadow}`);const oe=this.B((0,N.$BT)());this.b=this.B(new ie({...J.toggleStyles,isChecked:R===De.Filter,hoverDelegate:oe})),this.c=this.B(new ee({...J.toggleStyles,isChecked:j===Ee.Fuzzy,hoverDelegate:oe})),this.onDidChangeMode=y.Event.map(this.b.onChange,()=>this.b.checked?De.Filter:De.Highlight,this.q),this.onDidChangeMatchType=y.Event.map(this.c.onChange,()=>this.c.checked?Ee.Fuzzy:Ee.Contiguous,this.q),this.f=this.B(new S.$tV(this.a.findInput,$,{label:(0,C.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:J.inputBoxStyles,toggleStyles:J.toggleStyles,history:U?.history})),this.g=this.B(new W.$CT(this.a.actionbar)),this.mode=R;const pe=this.B(new k.$KT(this.f.inputBox.inputElement,"keydown")),fe=y.Event.chain(pe.event,Se=>Se.map(Fe=>new P.$FR(Fe)));this.B(fe(Se=>{if(Se.equals(3)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Se.equals(18)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Se.equals(16)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const Re=this.B(new f.$9i("close",(0,C.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(Re,{icon:!0,label:!1});const ke=this.B(new k.$KT(this.a.grab,"mousedown"));this.B(ke.event(Se=>{const Fe=new d.$Tc,We=Fe.add(new k.$KT((0,i.getWindow)(Se),"mousemove")),Xe=Fe.add(new k.$KT((0,i.getWindow)(Se),"mouseup")),Ue=this.m,_e=Se.pageX,Z=this.s,ne=Se.pageY;this.a.grab.classList.add("grabbing");const $e=this.a.root.style.transition;this.a.root.style.transition="unset";const ve=Ne=>{const ze=Ne.pageX-_e;this.m=Ue-ze;const Ve=Ne.pageY-ne;this.s=Z+Ve,this.layout()};Fe.add(We.event(ve)),Fe.add(Xe.event(Ne=>{ve(Ne),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=$e,Fe.dispose()}))}));const Oe=y.Event.chain(this.B(new k.$KT(this.a.grab,"keydown")).event,Se=>Se.map(Fe=>new P.$FR(Fe)));this.B(Oe(Se=>{let Fe,We;if(Se.keyCode===15?Fe=Number.POSITIVE_INFINITY:Se.keyCode===17?Fe=0:Se.keyCode===10&&(Fe=this.m===0?Number.POSITIVE_INFINITY:0),Se.keyCode===16?We=0:Se.keyCode===18&&(We=Number.POSITIVE_INFINITY),Fe!==void 0&&(Se.preventDefault(),Se.stopPropagation(),this.m=Fe,this.layout()),We!==void 0){Se.preventDefault(),Se.stopPropagation(),this.s=We;const Xe=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Xe},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(s=this.j){this.j=s,this.m=(0,a.$wm)(this.m,0,Math.max(0,s-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,a.$wm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(s){this.f.showMessage(s)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,n.$sh)(300),super.dispose()}}class le{get pattern(){return this.b}get mode(){return this.d}set mode(s){s!==this.d&&(this.d=s,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(s))}get matchType(){return this.f}set matchType(s){s!==this.f&&(this.f=s,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(s))}constructor(s,D,$,R,j,U={}){this.t=s,this.u=$,this.v=R,this.w=j,this.x=U,this.b="",this.c="",this.j=0,this.k=new y.$be,this.onDidChangeMode=this.k.event,this.m=new y.$be,this.onDidChangeMatchType=this.m.event,this.o=new y.$be,this.onDidChangePattern=this.o.event,this.p=new y.$be,this.onDidChangeOpenState=this.p.event,this.q=new d.$Tc,this.s=new d.$Tc,this.d=s.options.defaultFindMode??De.Highlight,this.f=s.options.defaultFindMatchType??Ee.Fuzzy,D.onDidSplice(this.z,this,this.s)}updateOptions(s={}){s.defaultFindMode!==void 0&&(this.mode=s.defaultFindMode),s.defaultFindMatchType!==void 0&&(this.matchType=s.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Ie(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(s=>this.mode=s,void 0,this.q),this.g.onDidChangeMatchType(s=>this.matchType=s,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(s){this.b=s,this.o.fire(s),this.v.pattern=s,this.t.refilter(),s&&this.t.focusNext(0,!0,void 0,$=>!o.FuzzyScore.isDefault($.filterData));const D=this.t.getFocus();if(D.length>0){const $=D[0];this.t.getRelativeTop($)===null&&this.t.reveal($,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const s=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&s?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,C.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(s){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!o.FuzzyScore.isDefault(s.filterData)}layout(s){this.j=s,this.g?.layout(s)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function _(T,s){return T.position===s.position&&ue(T,s)}function ue(T,s){return T.node.element===s.node.element&&T.startIndex===s.startIndex&&T.height===s.height&&T.endIndex===s.endIndex}class re{constructor(s=[]){this.stickyNodes=s}get count(){return this.stickyNodes.length}equal(s){return(0,e.$ub)(this.stickyNodes,s.stickyNodes,_)}lastNodePartiallyVisible(){if(this.count===0)return!1;const s=this.stickyNodes[this.count-1];if(this.count===1)return s.position!==0;const D=this.stickyNodes[this.count-2];return D.position+D.height!==s.position}animationStateChanged(s){if(!(0,e.$ub)(this.stickyNodes,s.stickyNodes,ue)||this.count===0)return!1;const D=this.stickyNodes[this.count-1],$=s.stickyNodes[s.count-1];return D.position!==$.position}}class ye{constrainStickyScrollNodes(s,D,$){for(let R=0;R<s.length;R++){const j=s[R];if(j.position+j.height>$||R>=D)return s.slice(0,R)}return s}}class V extends d.$Uc{constructor(s,D,$,R,j,U={}){super(),this.g=s,this.j=D,this.m=$,this.s=j,this.c=.4;const J=this.validateStickySettings(U);this.b=J.stickyScrollMaxItemCount,this.a=U.stickyScrollDelegate??new ye,this.f=this.B(new Q($.getScrollableElement(),$,s,R,j,U.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B($.onDidScroll(()=>this.u())),this.B($.onDidChangeContentHeight(()=>this.u())),this.B(s.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(s){return this.f.getNode(s)}t(s){let D;if(s===0?D=this.m.firstVisibleIndex:D=this.m.indexAt(s+this.m.scrollTop),!(D<0||D>=this.m.length))return this.m.element(D)}u(){const s=this.t(0);if(!s||this.g.scrollTop===0){this.f.setState(void 0);return}const D=this.w(s);this.f.setState(D)}w(s){const D=[];let $=s,R=0,j=this.z($,void 0,R);for(;j&&(D.push(j),R+=j.height,!(D.length<=this.b&&($=this.y(j),!$)));)j=this.z($,j.node,R);const U=this.H(D);return U.length?new re(U):void 0}y(s){return this.t(s.position+s.height)}z(s,D,$){const R=this.F(s,D);if(R&&!(R===s&&(!this.J(s)||this.C(s,$))))return this.D(R,$)}C(s,D){const $=this.L(s),R=this.m.getElementTop($),j=D;return this.m.scrollTop===R-j}D(s,D){const $=this.s.getHeight(s),{startIndex:R,endIndex:j}=this.M(s),U=this.G(j,D,$);return{node:s,position:U,height:$,startIndex:R,endIndex:j}}F(s,D=void 0){let $=s,R=this.I($);for(;R;){if(R===D)return $;$=R,R=this.I($)}if(D===void 0)return $}G(s,D,$){let R=this.m.getRelativeTop(s);if(R===null&&this.m.firstVisibleIndex===s&&s+1<this.m.length){const pe=this.s.getHeight(this.m.element(s)),fe=this.m.getRelativeTop(s+1);R=fe?fe-pe/this.m.renderHeight:null}if(R===null)return D;const j=this.m.element(s),U=this.s.getHeight(j),oe=R*this.m.renderHeight+U;return D+$>oe&&D<=oe?oe-$:D}H(s){if(s.length===0)return[];const D=this.m.renderHeight*this.c,$=s[s.length-1];if(s.length<=this.b&&$.position+$.height<=D)return s;const R=this.a.constrainStickyScrollNodes(s,this.b,D);if(!R.length)return[];const j=R[R.length-1];if(R.length>this.b||j.position+j.height>D)throw new Error("stickyScrollDelegate violates constraints");return R}I(s){const D=this.j.getNodeLocation(s),$=this.j.getParentNodeLocation(D);return $?this.j.getNode($):void 0}J(s){const D=this.j.getNodeLocation(s);return this.j.getListRenderCount(D)>1}L(s){const D=this.j.getNodeLocation(s);return this.j.getListIndex(D)}M(s){const D=this.j.getNodeLocation(s),$=this.j.getListIndex(D);if($<0)throw new Error("Node not found in tree");const R=this.j.getListRenderCount(D),j=$+R-1;return{startIndex:$,endIndex:j}}nodePositionTopBelowWidget(s){const D=[];let $=this.I(s);for(;$;)D.push($),$=this.I($);let R=0;for(let j=0;j<D.length&&j<this.b;j++)R+=this.s.getHeight(D[j]);return R}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(s={}){if(!s.stickyScrollMaxItemCount)return;const D=this.validateStickySettings(s);this.b!==D.stickyScrollMaxItemCount&&(this.b=D.stickyScrollMaxItemCount,this.u())}validateStickySettings(s){let D=7;return typeof s.stickyScrollMaxItemCount=="number"&&(D=Math.max(s.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:D}}}class Q{constructor(s,D,$,R,j,U){this.g=D,this.j=$,this.k=R,this.m=j,this.o=U,this.c=[],this.d=new d.$Tc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),s.appendChild(this.a);const J=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(J),this.f=new ge(this.a,D),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const s=this.b.stickyNodes[this.b.count-1];return s.position+s.height}get count(){return this.b?.count??0}getNode(s){return this.b?.stickyNodes.find(D=>D.node===s)}setState(s){const D=!!this.b&&this.b.count>0,$=!!s&&s.count>0;if(!D&&!$||D&&$&&this.b.equal(s))return;if(D!==$&&this.s($),!$){this.b=void 0,this.c=[],this.d.clear();return}const R=s.stickyNodes[s.count-1];if(this.b&&s.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${R.position}px`;else{this.d.clear();const j=Array(s.count);for(let U=s.count-1;U>=0;U--){const J=s.stickyNodes[U],{element:oe,disposable:pe}=this.p(J,U,s.count);j[U]=oe,this.a.appendChild(oe),this.d.add(pe)}this.f.updateElements(j,s),this.c=j}this.b=s,this.a.style.height=`${R.position+R.height}px`}p(s,D,$){const R=s.startIndex,j=document.createElement("div");j.style.top=`${s.position}px`,this.j.options.setRowHeight!==!1&&(j.style.height=`${s.height}px`),this.j.options.setRowLineHeight!==!1&&(j.style.lineHeight=`${s.height}px`),j.classList.add("monaco-tree-sticky-row"),j.classList.add("monaco-list-row"),j.setAttribute("data-index",`${R}`),j.setAttribute("data-parity",R%2===0?"even":"odd"),j.setAttribute("id",this.g.getElementID(R));const U=this.q(j,s.node.element,D,$),J=this.m.getTemplateId(s.node),oe=this.k.find(ke=>ke.templateId===J);if(!oe)throw new Error(`No renderer found for template id ${J}`);let pe=s.node;pe===this.j.getNode(this.j.getNodeLocation(s.node))&&(pe=new Proxy(s.node,{}));const fe=oe.renderTemplate(j);oe.renderElement(pe,s.startIndex,fe,s.height);const Re=(0,d.$Sc)(()=>{U.dispose(),oe.disposeElement(pe,s.startIndex,fe,s.height),oe.disposeTemplate(fe),j.remove()});return{element:j,disposable:Re}}q(s,D,$,R){if(!this.o)return d.$Uc.None;this.o.getSetSize&&s.setAttribute("aria-setsize",String(this.o.getSetSize(D,$,R))),this.o.getPosInSet&&s.setAttribute("aria-posinset",String(this.o.getPosInSet(D,$))),this.o.getRole&&s.setAttribute("role",this.o.getRole(D)??"treeitem");const j=this.o.getAriaLabel(D),U=j&&typeof j!="string"?j:(0,I.constObservable)(j),J=(0,I.autorun)(pe=>{const fe=pe.readObservable(U);fe?s.setAttribute("aria-label",fe):s.removeAttribute("aria-label")});typeof j=="string"||j&&s.setAttribute("aria-label",j.get());const oe=this.o.getAriaLevel&&this.o.getAriaLevel(D);return typeof oe=="number"&&s.setAttribute("aria-level",`${oe}`),s.setAttribute("aria-selected",String(!1)),J}s(s){this.a.classList.toggle("empty",!s),s||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class ge extends d.$Uc{get m(){return this.j}set m(s){s!==this.j&&(this.f.fire(s),this.j=s)}constructor(s,D){super(),this.s=s,this.t=D,this.a=-1,this.b=[],this.f=new y.$be,this.onDidChangeHasFocus=this.f.event,this.g=new y.$be,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown($=>this.w($))),this.B(this.t.onMouseDown($=>this.y($))),this.B(this.t.onContextMenu($=>this.u($)))}u(s){const D=s.browserEvent.target;if(!(0,b.$8T)(D)&&!(0,b.$7T)(D)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$yS)(s.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const U=this.c.stickyNodes.findIndex(J=>J.node.element===s.element?.element);if(U===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(U);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const R=this.c.stickyNodes[this.a].node.element,j=this.b[this.a];this.g.fire({element:R,anchor:j,browserEvent:s.browserEvent,isStickyScroll:!0})}w(s){if(this.m&&this.c){if(s.key==="ArrowUp")this.z(Math.max(0,this.a-1)),s.preventDefault(),s.stopPropagation();else if(s.key==="ArrowDown"||s.key==="ArrowRight"){if(this.a>=this.c.count-1){const D=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([D]),this.C(D,this.c)}else this.z(this.a+1);s.preventDefault(),s.stopPropagation()}}}y(s){const D=s.browserEvent.target;!(0,b.$8T)(D)&&!(0,b.$7T)(D)||(s.browserEvent.preventDefault(),s.browserEvent.stopPropagation())}updateElements(s,D){if(D&&D.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(D&&D.count!==s.length)throw new Error("Sticky scroll focus received illigel state");const $=this.a;if(this.D(),this.b=s,this.c=D,D){const R=(0,a.$wm)($,0,D.count-1);this.F(R)}else this.m&&this.t.domFocus();this.s.tabIndex=D?0:-1}z(s){const D=this.c;if(!D)throw new Error("Cannot set focus when state is undefined");if(this.F(s),!(s<D.count-1)&&D.lastNodePartiallyVisible()){const $=D.stickyNodes[s];this.C($.endIndex+1,D)}}C(s,D){const $=D.stickyNodes[D.count-1],R=D.count>1?D.stickyNodes[D.count-2]:void 0,j=this.t.getElementTop(s),U=R?R.position+R.height+$.height:$.height;this.t.scrollTop=j-U}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(s){if(0>s)throw new Error("addFocus() can not remove focus");if(!this.c&&s>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&s>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const D=this.a;D>=0&&this.G(this.b[D],!1),s>=0&&this.G(this.b[s],!0),this.a=s}G(s,D){this.I(s,D&&this.m),this.J(s,D)}H(s){this.a!==-1&&this.I(this.b[this.a],s)}I(s,D){s.classList.toggle("focused",D)}J(s,D){s.classList.toggle("passive-focused",D)}L(s){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",s)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function we(T){let s=c.TreeMouseEventTarget.Unknown;return(0,i.$eS)(T.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?s=c.TreeMouseEventTarget.Twistie:(0,i.$eS)(T.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?s=c.TreeMouseEventTarget.Element:(0,i.$eS)(T.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(s=c.TreeMouseEventTarget.Filter),{browserEvent:T.browserEvent,element:T.element?T.element.element:null,target:s}}function Le(T){const s=(0,b.$8T)(T.browserEvent.target);return{element:T.element?T.element.element:null,browserEvent:T.browserEvent,anchor:T.anchor,isStickyScroll:s}}function Te(T,s){s(T),T.children.forEach(D=>Te(D,s))}class Me{get f(){return this.d||(this.d=this.m()),this.d}constructor(s,D){this.g=s,this.j=D,this.a=[],this.c=new y.$be,this.onDidChange=this.c.event}set(s,D){!D?.__forceEvent&&(0,e.$ub)(this.a,s)||this.k(s,!1,D)}k(s,D,$){if(this.a=[...s],this.b=void 0,this.d=void 0,!D){const R=this;this.c.fire({get elements(){return R.get()},browserEvent:$})}}get(){return this.b||(this.b=this.a.map(s=>s.element)),[...this.b]}getNodes(){return this.a}has(s){return this.f.has(s)}onDidModelSplice({insertedNodes:s,deletedNodes:D}){if(!this.j){const oe=this.m(),pe=fe=>oe.delete(fe);D.forEach(fe=>Te(fe,pe)),this.set([...oe.values()]);return}const $=new Set,R=oe=>$.add(this.j.getId(oe.element).toString());D.forEach(oe=>Te(oe,R));const j=new Map,U=oe=>j.set(this.j.getId(oe.element).toString(),oe);s.forEach(oe=>Te(oe,U));const J=[];for(const oe of this.a){const pe=this.j.getId(oe.element).toString();if(!$.has(pe))J.push(oe);else{const Re=j.get(pe);Re&&Re.visible&&J.push(Re)}}if(this.a.length>0&&J.length===0){const oe=this.g();oe&&J.push(oe)}this.k(J,!0)}m(){const s=new Set;for(const D of this.a)s.add(D);return s}}class H extends b.$aU{constructor(s,D,$){super(s),this.x=D,this.y=$}u(s){if((0,b.$9T)(s.browserEvent.target)||(0,b.$2T)(s.browserEvent.target)||(0,b.$3T)(s.browserEvent.target)||s.browserEvent.isHandledByList)return;const D=s.element;if(!D)return super.u(s);if(this.p(s)||this.o(s))return super.u(s);const $=s.browserEvent.target,R=$.classList.contains("monaco-tl-twistie")||$.classList.contains("monaco-icon-label")&&$.classList.contains("folder-icon")&&s.browserEvent.offsetX<16,j=(0,b.$7T)(s.browserEvent.target);let U=!1;if(j?U=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?U=this.x.expandOnlyOnTwistieClick(D.element):U=!!this.x.expandOnlyOnTwistieClick,j)this.A(s,D);else{if(U&&!R&&s.browserEvent.detail!==2)return super.u(s);if(!this.x.expandOnDoubleClick&&s.browserEvent.detail===2)return super.u(s)}if(D.collapsible&&(!j||R)){const J=this.x.getNodeLocation(D),oe=s.browserEvent.altKey;if(this.x.setFocus([J]),this.x.toggleCollapsed(J,oe),R){s.browserEvent.isHandledByList=!0;return}}j||super.u(s)}A(s,D){if((0,b.$4T)(s.browserEvent.target)||(0,b.$5T)(s.browserEvent.target))return;const $=this.y();if(!$)throw new Error("Sticky scroll controller not found");const R=this.k.indexOf(D),j=this.k.getElementTop(R),U=$.nodePositionTopBelowWidget(D);this.x.scrollTop=j-U,this.k.domFocus(),this.k.setFocus([R]),this.k.setSelection([R])}v(s){s.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||s.browserEvent.isHandledByList||super.v(s)}s(s){const D=s.browserEvent.target;if(!(0,b.$8T)(D)&&!(0,b.$7T)(D)){super.s(s);return}}t(s){const D=s.browserEvent.target;if(!(0,b.$8T)(D)&&!(0,b.$7T)(D)){super.t(s);return}}}class u extends b.$dU{constructor(s,D,$,R,j,U,J,oe){super(s,D,$,R,oe),this.p=j,this.s=U,this.K=J}D(s){return new H(this,s.tree,s.stickyScrollProvider)}splice(s,D,$=[]){if(super.splice(s,D,$),$.length===0)return;const R=[],j=[];let U;$.forEach((J,oe)=>{this.p.has(J)&&R.push(s+oe),this.s.has(J)&&j.push(s+oe),this.K.has(J)&&(U=s+oe)}),R.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...R])),j.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...j])),typeof U=="number"&&super.setAnchor(U)}setFocus(s,D,$=!1){super.setFocus(s,D),$||this.p.set(s.map(R=>this.element(R)),D)}setSelection(s,D,$=!1){super.setSelection(s,D),$||this.s.set(s.map(R=>this.element(R)),D)}setAnchor(s,D=!1){super.setAnchor(s),D||(typeof s>"u"?this.K.set([]):this.K.set([this.element(s)]))}}var v;(function(T){T[T.Tree=0]="Tree",T[T.StickyScroll=1]="StickyScroll"})(v||(t.AbstractTreePart=v={}));class l{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return y.Event.map(this.j.onMouseClick,we)}get onMouseDblClick(){return y.Event.filter(y.Event.map(this.j.onMouseDblClick,we),s=>s.target!==c.TreeMouseEventTarget.Filter)}get onMouseOver(){return y.Event.map(this.j.onMouseOver,we)}get onMouseOut(){return y.Event.map(this.j.onMouseOut,we)}get onContextMenu(){return y.Event.any(y.Event.filter(y.Event.map(this.j.onContextMenu,Le),s=>!s.isStickyScroll),this.B?.onContextMenu??y.Event.None)}get onTap(){return y.Event.map(this.j.onTap,we)}get onPointer(){return y.Event.map(this.j.onPointer,we)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return y.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??De.Highlight}set findMode(s){this.z&&(this.z.mode=s)}get findMatchType(){return this.z?.matchType??Ee.Fuzzy}set findMatchType(s){this.z&&(this.z.matchType=s)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:y.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(s,D,$,R,j={}){this.G=s,this.H=j,this.y=new y.$je,this.onDidChangeFindOpenState=y.Event.None,this.onDidChangeStickyScrollFocused=y.Event.None,this.D=new d.$Tc,this.E=new y.$be,this.onWillRefilter=this.E.event,this.F=new y.$be,this.onDidUpdateOptions=this.F.event,this.p=new F($);const U=new y.$ke,J=new y.$ke,oe=this.D.add(new Y(J.event)),pe=new m.$Hc;this.k=R.map(Se=>new K(Se,()=>this.o,U.event,oe,pe,j));for(const Se of this.k)this.D.add(Se);let fe;j.keyboardNavigationLabelProvider&&(fe=new ae(this,j.keyboardNavigationLabelProvider,j.filter),j={...j,filter:fe},this.D.add(fe)),this.q=new Me(()=>this.j.getFocusedElements()[0],j.identityProvider),this.w=new Me(()=>this.j.getSelectedElements()[0],j.identityProvider),this.x=new Me(()=>this.j.getAnchorElement(),j.identityProvider),this.j=new u(s,D,this.p,this.k,this.q,this.w,this.x,{...q(()=>this.o,j),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(s,this.j,j),U.input=this.o.onDidChangeCollapseState;const Re=y.Event.forEach(this.o.onDidSplice,Se=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Se),this.w.onDidModelSplice(Se)})},this.D);Re(()=>null,null,this.D);const ke=this.D.add(new y.$be),Oe=this.D.add(new n.$oh(0));if(this.D.add(y.Event.any(Re,this.q.onDidChange,this.w.onDidChange)(()=>{Oe.trigger(()=>{const Se=new Set;for(const Fe of this.q.getNodes())Se.add(Fe);for(const Fe of this.w.getNodes())Se.add(Fe);ke.fire([...Se.values()])})})),J.input=ke.event,j.keyboardSupport!==!1){const Se=y.Event.chain(this.j.onKeyDown,Fe=>Fe.filter(We=>!(0,b.$2T)(We.target)).map(We=>new P.$FR(We)));y.Event.chain(Se,Fe=>Fe.filter(We=>We.keyCode===15))(this.J,this,this.D),y.Event.chain(Se,Fe=>Fe.filter(We=>We.keyCode===17))(this.K,this,this.D),y.Event.chain(Se,Fe=>Fe.filter(We=>We.keyCode===10))(this.L,this,this.D)}if((j.findWidgetEnabled??!0)&&j.keyboardNavigationLabelProvider&&j.contextViewProvider){const Se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new le(this,this.o,this.j,fe,j.contextViewProvider,Se),this.A=Fe=>this.z.shouldAllowFocus(Fe),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=y.Event.None,this.onDidChangeFindMatchType=y.Event.None;j.enableStickyScroll&&(this.B=new V(this,this.o,this.j,this.k,this.p,j),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$qS)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===B.Always)}updateOptions(s={}){this.H={...this.H,...s};for(const D of this.k)D.updateOptions(s);this.j.updateOptions(this.H),this.z?.updateOptions(s),this.I(s),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===B.Always)}get options(){return this.H}I(s){!this.B&&this.H.enableStickyScroll?(this.B=new V(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=y.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(s)}updateWidth(s){const D=this.o.getListIndex(s);D!==-1&&this.j.updateWidth(D)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(s){this.j.scrollTop=s}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(s){this.j.scrollLeft=s}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let s=this.j.firstVisibleIndex;return this.B&&(s+=this.B.count),s<0||s>=this.j.length?void 0:this.j.element(s).element}get lastVisibleElement(){const s=this.j.lastVisibleIndex;return this.j.element(s).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(s){this.j.ariaLabel=s}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$jS)(this.getHTMLElement())}layout(s,D){this.j.layout(s,D),(0,L.$9f)(D)&&this.z?.layout(D)}style(s){const D=`.${this.j.domId}`,$=[];s.treeIndentGuidesStroke&&($.push(`.monaco-list${D}:hover .monaco-tl-indent > .indent-guide, .monaco-list${D}.always .monaco-tl-indent > .indent-guide  { border-color: ${s.treeInactiveIndentGuidesStroke}; }`),$.push(`.monaco-list${D} .monaco-tl-indent > .indent-guide.active { border-color: ${s.treeIndentGuidesStroke}; }`));const R=s.treeStickyScrollBackground??s.listBackground;R&&($.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${R}; }`),$.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${R}; }`)),s.treeStickyScrollBorder&&$.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${s.treeStickyScrollBorder}; }`),s.treeStickyScrollShadow&&$.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${s.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),s.listFocusForeground&&($.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${s.listFocusForeground}; }`),$.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const j=(0,i.$1S)(s.listFocusAndSelectionOutline,(0,i.$1S)(s.listSelectionOutline,s.listFocusOutline??""));j&&($.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${j}; outline-offset: -1px;}`),$.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),s.listFocusOutline&&($.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),$.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),$.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),$.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),$.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=$.join(`
`),this.j.style(s)}getParentElement(s){const D=this.o.getParentNodeLocation(s);return this.o.getNode(D).element}getFirstElementChild(s){return this.o.getFirstElementChild(s)}getNode(s){return this.o.getNode(s)}getNodeLocation(s){return this.o.getNodeLocation(s)}collapse(s,D=!1){return this.o.setCollapsed(s,!0,D)}expand(s,D=!1){return this.o.setCollapsed(s,!1,D)}toggleCollapsed(s,D=!1){return this.o.setCollapsed(s,void 0,D)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(s){return this.o.isCollapsible(s)}setCollapsible(s,D){return this.o.setCollapsible(s,D)}isCollapsed(s){return this.o.isCollapsed(s)}expandTo(s){this.o.expandTo(s)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(s){if(typeof s>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const D=this.o.getNode(s);this.x.set([D]);const $=this.o.getListIndex(s);$>-1&&this.j.setAnchor($,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(s,D){this.y.bufferEvents(()=>{const $=s.map(j=>this.o.getNode(j));this.w.set($,D);const R=s.map(j=>this.o.getListIndex(j)).filter(j=>j>-1);this.j.setSelection(R,D,!0)})}getSelection(){return this.w.get()}setFocus(s,D){this.y.bufferEvents(()=>{const $=s.map(j=>this.o.getNode(j));this.q.set($,D);const R=s.map(j=>this.o.getListIndex(j)).filter(j=>j>-1);this.j.setFocus(R,D,!0)})}focusNext(s=1,D=!1,$,R=(0,i.$yS)($)&&$.altKey?void 0:this.A){this.j.focusNext(s,D,$,R)}focusPrevious(s=1,D=!1,$,R=(0,i.$yS)($)&&$.altKey?void 0:this.A){this.j.focusPrevious(s,D,$,R)}focusNextPage(s,D=(0,i.$yS)(s)&&s.altKey?void 0:this.A){return this.j.focusNextPage(s,D)}focusPreviousPage(s,D=(0,i.$yS)(s)&&s.altKey?void 0:this.A){return this.j.focusPreviousPage(s,D,()=>this.B?.height??0)}focusLast(s,D=(0,i.$yS)(s)&&s.altKey?void 0:this.A){this.j.focusLast(s,D)}focusFirst(s,D=(0,i.$yS)(s)&&s.altKey?void 0:this.A){this.j.focusFirst(s,D)}getFocus(){return this.q.get()}getStickyScrollFocus(){const s=this.B?.getFocus();return s!==void 0?[s]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(s,D){this.o.expandTo(s);const $=this.o.getListIndex(s);if($!==-1)if(!this.B)this.j.reveal($,D);else{const R=this.B.nodePositionTopBelowWidget(this.getNode(s));this.j.reveal($,D,R)}}getRelativeTop(s){const D=this.o.getListIndex(s);if(D===-1)return null;const $=this.B?.getNode(this.getNode(s));return this.j.getRelativeTop(D,$?.position??this.B?.height)}getViewState(s=this.options.identityProvider){if(!s)throw new c.$UV(this.G,"Can't get tree view state without an identity provider");const D=U=>s.getId(U).toString(),$=x.empty(this.scrollTop);for(const U of this.getFocus())$.focus.add(D(U));for(const U of this.getSelection())$.selection.add(D(U));const R=this.o.getNode(),j=[R];for(;j.length>0;){const U=j.shift();U!==R&&U.collapsible&&($.expanded[D(U.element)]=U.collapsed?0:1),j.push(...U.children)}return $}J(s){s.preventDefault(),s.stopPropagation();const D=this.j.getFocusedElements();if(D.length===0)return;const $=D[0],R=this.o.getNodeLocation($);if(!this.o.setCollapsed(R,!0)){const U=this.o.getParentNodeLocation(R);if(!U)return;const J=this.o.getListIndex(U);this.j.reveal(J),this.j.setFocus([J])}}K(s){s.preventDefault(),s.stopPropagation();const D=this.j.getFocusedElements();if(D.length===0)return;const $=D[0],R=this.o.getNodeLocation($);if(!this.o.setCollapsed(R,!1)){if(!$.children.some(oe=>oe.visible))return;const[U]=this.j.getFocus(),J=U+1;this.j.reveal(J),this.j.setFocus([J])}}L(s){s.preventDefault(),s.stopPropagation();const D=this.j.getFocusedElements();if(D.length===0)return;const $=D[0],R=this.o.getNodeLocation($),j=s.browserEvent.altKey;this.o.setCollapsed(R,void 0,j)}navigate(s){return new w(this.j,this.o,s)}dispose(){(0,d.$Pc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$5V=l;class w{constructor(s,D,$){this.b=s,this.c=D,$?this.a=this.c.getListIndex($):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[144],be([1,0,143,134,30,32]),function(se,t,i,k,P,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dW=void 0;class S extends i.$5V{constructor(g,b,p,O,c,f={}){super(g,b,p,O,f),this.f=g,this.g=c,this.d=new Map,this.c=f.identityProvider}getInput(){return this.b}setInput(g,b){if(b&&!this.c)throw new P.$UV(this.f,"Can't restore tree view state without an identity provider");if(this.b=g,!g){this.d.clear(),this.o.setChildren(null,W.Iterable.empty());return}if(!b){this.m(g);return}const p=[],O=[],c=e=>{const n=this.c.getId(e).toString();return!b.expanded[n]},f=e=>{const n=this.c.getId(e.element).toString();b.focus.has(n)&&p.push(e.element),b.selection.has(n)&&O.push(e.element)};this.m(g,c,f),this.setFocus(p),this.setSelection(O),b&&typeof b.scrollTop=="number"&&(this.scrollTop=b.scrollTop)}updateChildren(g=this.b){if(typeof this.b>"u")throw new P.$UV(this.f,"Tree input not set");let b;this.c&&(b=p=>{const O=this.c.getId(p).toString(),c=this.d.get(O);if(c)return c.collapsed}),this.m(g,b)}resort(g=this.b,b=!0){this.o.resort(g===this.b?null:g,b)}refresh(g){if(g===void 0){this.j.rerender();return}this.o.rerender(g)}m(g,b,p){let O;if(this.c){const c=new Set,f=p;p=e=>{const n=this.c.getId(e.element).toString();c.add(n),this.d.set(n,e),f?.(e)},O=e=>{const n=this.c.getId(e.element).toString();c.has(n)||this.d.delete(n)}}this.o.setChildren(g===this.b?null:g,this.s(g,b).elements,{onDidCreateNode:p,onDidDeleteNode:O})}s(g,b){const p=[...this.g.getChildren(g)];return{elements:W.Iterable.map(p,c=>{const{elements:f,size:e}=this.s(c,b),n=this.g.hasChildren?this.g.hasChildren(c):void 0,r=e===0?void 0:b&&b(c);return{element:c,children:f,collapsible:n,collapsed:r}}),size:p.length}}M(g,b,p){return new k.$6V(g,b,p)}}t.$dW=S}),define(me[77],be([1,0,8,11,43,34,31,6,3,2,64,9,10]),function(se,t,i,k,P,W,S,A,g,b,p,O,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ai=t.ProxyChannel=t.$_h=t.$9h=t.$8h=t.$7h=t.RequestInitiator=t.$6h=t.$3h=t.$2h=void 0,t.$4h=M,t.$5h=E,t.$0h=Y,t.$$h=K;var f;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(f||(f={}));function e(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var n;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(n||(n={}));function r(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(h||(h={}));function m(le){let _=0;for(let ue=0;;ue+=7){const re=le.read(1);if(_|=(re.buffer[0]&127)<<ue,!(re.buffer[0]&128))return _}}const y=C(0);function o(le,_){if(_===0){le.write(y);return}let ue=0;for(let ye=_;ye!==0;ye=ye>>>7)ue++;const re=P.$Ce.alloc(ue);for(let ye=0;_!==0;ye++)re.buffer[ye]=_&127,_=_>>>7,_>0&&(re.buffer[ye]|=128);le.write(re)}class d{constructor(_){this.b=_,this.a=0}read(_){const ue=this.b.slice(this.a,this.a+_);return this.a+=ue.byteLength,ue}}t.$2h=d;class a{constructor(){this.a=[]}get buffer(){return P.$Ce.concat(this.a)}write(_){this.a.push(_)}}t.$3h=a;var L;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(L||(L={}));function C(le){const _=P.$Ce.alloc(1);return _.writeUInt8(le,0),_}const N={Undefined:C(L.Undefined),String:C(L.String),Buffer:C(L.Buffer),VSBuffer:C(L.VSBuffer),Array:C(L.Array),Object:C(L.Object),Uint:C(L.Int)},I=typeof Buffer<"u";function M(le,_){if(typeof _>"u")le.write(N.Undefined);else if(typeof _=="string"){const ue=P.$Ce.fromString(_);le.write(N.String),o(le,ue.byteLength),le.write(ue)}else if(I&&Buffer.isBuffer(_)){const ue=P.$Ce.wrap(_);le.write(N.Buffer),o(le,ue.byteLength),le.write(ue)}else if(_ instanceof P.$Ce)le.write(N.VSBuffer),o(le,_.byteLength),le.write(_);else if(Array.isArray(_)){le.write(N.Array),o(le,_.length);for(const ue of _)M(le,ue)}else if(typeof _=="number"&&(_|0)===_)le.write(N.Uint),o(le,_);else{const ue=P.$Ce.fromString(JSON.stringify(_));le.write(N.Object),o(le,ue.byteLength),le.write(ue)}}function E(le){switch(le.read(1).readUInt8(0)){case L.Undefined:return;case L.String:return le.read(m(le)).toString();case L.Buffer:return le.read(m(le)).buffer;case L.VSBuffer:return le.read(m(le));case L.Array:{const ue=m(le),re=[];for(let ye=0;ye<ue;ye++)re.push(E(le));return re}case L.Object:return JSON.parse(le.read(m(le)).toString());case L.Int:return m(le)}}class z{constructor(_,ue,re=null,ye=1e3){this.h=_,this.j=ue,this.k=re,this.l=ye,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(V=>this.q(V)),this.m({type:200})}registerChannel(_,ue){this.b.set(_,ue),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const ue=this.o([_.type]);this.k?.logOutgoing(ue,0,1,r(_.type));return}case 201:case 202:case 204:case 203:{const ue=this.o([_.type,_.id],_.data);this.k?.logOutgoing(ue,_.id,1,r(_.type),_.data);return}}}o(_,ue=void 0){const re=new a;return M(re,_),M(re,ue),this.p(re.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const ue=new d(_),re=E(ue),ye=E(ue),V=re[0];switch(V){case 100:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(V)}: ${re[2]}.${re[3]}`,ye),this.s({type:V,id:re[1],channelName:re[2],name:re[3],arg:ye});case 102:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(V)}: ${re[2]}.${re[3]}`,ye),this.t({type:V,id:re[1],channelName:re[2],name:re[3],arg:ye});case 101:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(V)}`),this.u({type:V,id:re[1]});case 103:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(V)}`),this.u({type:V,id:re[1]})}}s(_){const ue=this.b.get(_.channelName);if(!ue){this.v(_);return}const re=new W.$me;let ye;try{ye=ue.call(this.j,_.name,_.arg,re.token)}catch(ge){ye=Promise.reject(ge)}const V=_.id;ye.then(ge=>{this.m({id:V,data:ge,type:201})},ge=>{ge instanceof Error?this.m({id:V,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split?ge.stack.split(`
`):ge.stack:void 0},type:202}):this.m({id:V,data:ge,type:203})}).finally(()=>{Q.dispose(),this.d.delete(_.id)});const Q=(0,b.$Sc)(()=>re.cancel());this.d.set(_.id,Q)}t(_){const ue=this.b.get(_.channelName);if(!ue){this.v(_);return}const re=_.id,V=ue.listen(this.j,_.name,_.arg)(Q=>this.m({id:re,data:Q,type:204}));this.d.set(_.id,V)}u(_){const ue=this.d.get(_.id);ue&&(ue.dispose(),this.d.delete(_.id))}v(_){let ue=this.g.get(_.channelName);ue||(ue=[],this.g.set(_.channelName,ue));const re=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ue.push({request:_,timeoutTimer:re})}w(_){const ue=this.g.get(_);if(ue){for(const re of ue)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Pc)(this.d.values()),this.d.clear()}}t.$6h=z;var q;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(q||(t.RequestInitiator=q={}));class F{constructor(_,ue=null){this.l=_,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ue}getChannel(_){const ue=this;return{call(re,ye,V){return ue.a?Promise.reject(new A.$5):ue.m(_,re,ye,V)},listen(re,ye){return ue.a?g.Event.None:ue.o(_,re,ye)}}}m(_,ue,re,ye=W.CancellationToken.None){const V=this.g++,ge={id:V,type:100,channelName:_,name:ue,arg:re};if(ye.isCancellationRequested)return Promise.reject(new A.$5);let we;return new Promise((Te,Me)=>{if(ye.isCancellationRequested)return Me(new A.$5);const H=()=>{const w=T=>{switch(T.type){case 201:this.f.delete(V),Te(T.data);break;case 202:{this.f.delete(V);const s=new Error(T.data.message);s.stack=Array.isArray(T.data.stack)?T.data.stack.join(`
`):T.data.stack,s.name=T.data.name,Me(s);break}case 203:this.f.delete(V),Me(T.data);break}};this.f.set(V,w),this.p(ge)};let u=null;this.b===h.Idle?H():(u=(0,k.$eh)(w=>this.u()),u.then(()=>{u=null,H()}));const v=()=>{u?(u.cancel(),u=null):this.p({id:V,type:101}),Me(new A.$5)},l=ye.onCancellationRequested(v);we=(0,b.$Rc)((0,b.$Sc)(v),l),this.d.add(we)}).finally(()=>{we.dispose(),this.d.delete(we)})}o(_,ue,re){const ye=this.g++,Q={id:ye,type:102,channelName:_,name:ue,arg:re};let ge=null;const we=new g.$be({onWillAddFirstListener:()=>{ge=(0,k.$eh)(Te=>this.u()),ge.then(()=>{ge=null,this.d.add(we),this.p(Q)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(we),this.p({id:ye,type:103}))}}),Le=Te=>we.fire(Te.data);return this.f.set(ye,Le),we.event}p(_){switch(_.type){case 100:case 102:{const ue=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(ue,_.id,0,`${e(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const ue=this.q([_.type,_.id]);this.j?.logOutgoing(ue,_.id,0,e(_.type));return}}}q(_,ue=void 0){const re=new a;return M(re,_),M(re,ue),this.r(re.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const ue=new d(_),re=E(ue),ye=E(ue),V=re[0];switch(V){case 200:return this.j?.logIncoming(_.byteLength,0,0,r(V)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,re[1],0,r(V),ye),this.t({type:re[0],id:re[1],data:ye})}}t(_){if(_.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Pc)(this.d.values()),this.d.clear()}}t.$7h=F,Je([S.$Vh],F.prototype,"onDidInitializePromise",null);class x{get connections(){const _=[];return this.f.forEach(ue=>_.push(ue)),_}constructor(_,ue,re){this.a=new Map,this.f=new Set,this.g=new g.$be,this.onDidAddConnection=this.g.event,this.h=new g.$be,this.onDidRemoveConnection=this.h.event,this.j=new b.$Tc,this.j.add(_(({protocol:ye,onDidClientDisconnect:V})=>{const Q=g.Event.once(ye.onMessage);this.j.add(Q(ge=>{const we=new d(ge),Le=E(we),Te=new z(ye,Le,ue,re),Me=new F(ye,ue);this.a.forEach((u,v)=>Te.registerChannel(v,u));const H={channelServer:Te,channelClient:Me,ctx:Le};this.f.add(H),this.g.fire(H),this.j.add(V(()=>{Te.dispose(),Me.dispose(),this.f.delete(H),this.h.fire(H)}))}))}))}getChannel(_,ue){const re=this;return{call(ye,V,Q){let ge;if((0,c.$gg)(ue)){const Le=(0,i.$4b)(re.connections.filter(ue));ge=Le?Promise.resolve(Le):g.Event.toPromise(g.Event.filter(re.onDidAddConnection,ue))}else ge=ue.routeCall(re,ye,V);const we=ge.then(Le=>Le.channelClient.getChannel(_));return Y(we).call(ye,V,Q)},listen(ye,V){if((0,c.$gg)(ue))return re.k(_,ue,ye,V);const Q=ue.routeEvent(re,ye,V).then(ge=>ge.channelClient.getChannel(_));return Y(Q).listen(ye,V)}}}k(_,ue,re,ye){const V=this;let Q;const ge=new g.$be({onWillAddFirstListener:()=>{Q=new b.$Tc;const we=new g.$he,Le=new Map,Te=H=>{const v=H.channelClient.getChannel(_).listen(re,ye),l=we.add(v);Le.set(H,l)},Me=H=>{const u=Le.get(H);u&&(u.dispose(),Le.delete(H))};V.connections.filter(ue).forEach(Te),g.Event.filter(V.onDidAddConnection,ue)(Te,void 0,Q),V.onDidRemoveConnection(Me,void 0,Q),we.event(ge.fire,ge,Q),Q.add(we)},onDidRemoveLastListener:()=>{Q?.dispose(),Q=void 0}});return ge.event}registerChannel(_,ue){this.a.set(_,ue);for(const re of this.f)re.channelServer.registerChannel(_,ue)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$8h=x;class B{constructor(_,ue,re=null){const ye=new a;M(ye,ue),_.send(ye.buffer),this.a=new F(_,re),this.d=new z(_,ue,re)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,ue){this.d.registerChannel(_,ue)}dispose(){this.a.dispose(),this.d.dispose()}}t.$9h=B;function Y(le){return{call(_,ue,re){return le.then(ye=>ye.call(_,ue,re))},listen(_,ue){const re=new g.$ke;return le.then(ye=>re.input=ye.listen(_,ue)),re.event}}}function K(le){let _=!1;return{call(ue,re,ye){return _?le.call(ue,re,ye):(0,k.$sh)(0).then(()=>_=!0).then(()=>le.call(ue,re,ye))},listen(ue,re){if(_)return le.listen(ue,re);const ye=new g.$ke;return(0,k.$sh)(0).then(()=>_=!0).then(()=>ye.input=le.listen(ue,re)),ye.event}}}class ae{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const ue of _.connections)if(await Promise.resolve(this.a(ue.ctx)))return Promise.resolve(ue);return await g.Event.toPromise(_.onDidAddConnection),await this.b(_)}}t.$_h=ae;var ie;(function(le){function _(V,Q,ge){const we=V,Le=ge&&ge.disableMarshalling,Te=new Map;for(const Me in we)re(Me)&&Te.set(Me,g.Event.buffer(we[Me],!0,void 0,Q));return new class{listen(Me,H,u){const v=Te.get(H);if(v)return v;const l=we[H];if(typeof l=="function"){if(ye(H))return l.call(we,u);if(re(H))return Te.set(H,g.Event.buffer(we[H],!0,void 0,Q)),Te.get(H)}throw new A.$bb(`Event not found: ${H}`)}call(Me,H,u){const v=we[H];if(typeof v=="function"){if(!Le&&Array.isArray(u))for(let w=0;w<u.length;w++)u[w]=(0,p.$1h)(u[w]);let l=v.apply(we,u);return l instanceof Promise||(l=Promise.resolve(l)),l}throw new A.$bb(`Method not found: ${H}`)}}}le.fromService=_;function ue(V,Q){const ge=Q&&Q.disableMarshalling;return new Proxy({},{get(we,Le){if(typeof Le=="string")return Q?.properties?.has(Le)?Q.properties.get(Le):ye(Le)?function(Te){return V.listen(Le,Te)}:re(Le)?V.listen(Le):async function(...Te){let Me;Q&&!(0,c.$bg)(Q.context)?Me=[Q.context,...Te]:Me=Te;const H=await V.call(Le,Me);return ge?H:(0,p.$1h)(H)};throw new A.$bb(`Property not found: ${String(Le)}`)}})}le.toService=ue;function re(V){return V[0]==="o"&&V[1]==="n"&&O.$tf(V.charCodeAt(2))}function ye(V){return/^onDynamic/.test(V)&&O.$tf(V.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const _=le.toString();if(_!=="[object Object]")return _}return le}function De(le){return Array.isArray(le)?le.map(ce):ce(le)}function Ee(le,_,ue,re,ye,V,Q){Q=De(Q);const ge=ee[ye],we=ge[re%ge.length];let Le=[`%c[${le}]%c[${String(_).padStart(7," ")}]%c[len: ${String(ue).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${we}`];/\($/.test(V)?(Le=Le.concat(Q),Le.push(")")):Le.push(Q),console.log.apply(console,Le)}class Ie{constructor(_,ue){this.d=_,this.f=ue,this.a=0,this.b=0}logOutgoing(_,ue,re,ye,V){this.b+=_,Ee(this.d,this.b,_,ue,re,ye,V)}logIncoming(_,ue,re,ye,V){this.a+=_,Ee(this.f,this.a,_,ue,re,ye,V)}}t.$ai=Ie}),define(me[145],be([1,0,43,3,77,102,35]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QW=void 0;class A extends P.$9h{static f(){const b=k.Event.fromNodeEventEmitter(S.$O,"vscode:message",(p,O)=>i.$Ce.wrap(O));return S.$O.send("vscode:hello"),new W.$MW(S.$O,b)}constructor(b){const p=A.f();super(p,b),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}t.$QW=A}),define(me[146],be([13,12]),function(se,t){return se.create("vs/platform/files/common/files",t)}),define(me[147],be([13,12]),function(se,t){return se.create("vs/platform/theme/common/iconRegistry",t)}),define(me[50],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qi=t._util=void 0,t.$ri=P,t.$si=W;var i;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function A(g){return g[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=A})(i||(t._util=i={})),t.$qi=P("instantiationService");function k(S,A,g){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:S,index:g}):(A[i.DI_DEPENDENCIES]=[{id:S,index:g}],A[i.DI_TARGET]=A)}function P(S){if(i.serviceIds.has(S))return i.serviceIds.get(S);const A=function(g,b,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(A,g,p)};return A.toString=()=>S,i.serviceIds.set(S,A),A}function W(S){return S}}),define(me[148],be([1,0,50]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$an=t.$$m=t.ID=void 0,t.$_m=k,t.ID="diagnosticsService",t.$$m=(0,i.$ri)(t.ID);function k(W){return!!W.hostName&&!!W.errorMessage}class P{async getPerformanceInfo(S,A){return{}}async getSystemInfo(S,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(S,A){return""}async getWorkspaceFileExtensions(S){return{extensions:[]}}async reportWorkspaceStats(S){}}t.$an=P}),define(me[149],be([1,0,99,25,9,10,16,146,50,5,36,23]),function(se,t,i,k,P,W,S,A,g,b,p,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tl=t.$ql=t.FileKind=t.$pl=t.$ol=t.$nl=t.$ml=t.$ll=t.$kl=t.$jl=t.FileOperationResult=t.$il=t.$hl=t.$gl=t.$el=t.FileChangeType=t.$dl=t.FileOperation=t.$0k=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.$Xk=void 0,t.$Yk=c,t.$Zk=r,t.$1k=m,t.$2k=y,t.$3k=o,t.$4k=d,t.$5k=a,t.$6k=L,t.$7k=C,t.$8k=N,t.$9k=I,t.$$k=z,t.$_k=q,t.$al=F,t.$bl=x,t.$cl=B,t.$fl=ee,t.$rl=_,t.$sl=ue,t.$ul=ye,t.$Xk=(0,g.$ri)("fileService");function c(V){return V.create===!0}var f;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(f||(t.FileType=f={}));var e;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var n;(function(V){V[V.UPDATED=2]="UPDATED",V[V.ADDED=4]="ADDED",V[V.DELETED=8]="DELETED"})(n||(t.FileChangeFilter=n={}));function r(V){const Q=V;return!!Q&&typeof Q.onDidChange=="function"}var h;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(h||(t.FileSystemProviderCapabilities=h={}));function m(V){return!!(V.capabilities&2)}function y(V){return!!(V.capabilities&8)}function o(V){return!!(V.capabilities&131072)}function d(V){return!!(V.capabilities&4)}function a(V){return!!(V.capabilities&16)}function L(V){return m(V)?!!(V.capabilities&16384):!1}function C(V){return m(V)?!!(V.capabilities&32768):!1}function N(V){return!!(V.capabilities&65536)}function I(V){return!!(V.capabilities&2048)}var M;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(M||(t.FileSystemProviderErrorCode=M={}));class E extends Error{static create(Q,ge){const we=new E(Q.toString(),ge);return F(we,ge),we}constructor(Q,ge){super(Q),this.code=ge}}t.$0k=E;function z(V,Q){return E.create(V,Q)}function q(V){return V||z((0,A.localize)(0,null),M.Unknown)}function F(V,Q){return V.name=Q?`${Q} (FileSystemError)`:"FileSystemError",V}function x(V){if(!V)return M.Unknown;if(V instanceof E)return V.code;const Q=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!Q)return M.Unknown;switch(Q[1]){case M.FileExists:return M.FileExists;case M.FileIsADirectory:return M.FileIsADirectory;case M.FileNotADirectory:return M.FileNotADirectory;case M.FileNotFound:return M.FileNotFound;case M.FileTooLarge:return M.FileTooLarge;case M.FileWriteLocked:return M.FileWriteLocked;case M.NoPermissions:return M.NoPermissions;case M.Unavailable:return M.Unavailable}return M.Unknown}function B(V){if(V instanceof ce)return V.fileOperationResult;switch(x(V)){case M.FileNotFound:return 1;case M.FileIsADirectory:return 0;case M.FileNotADirectory:return 9;case M.FileWriteLocked:return 5;case M.NoPermissions:return 6;case M.FileExists:return 4;case M.FileTooLarge:return 7;default:return 10}}var Y;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(Y||(t.FileOperation=Y={}));class K{constructor(Q,ge,we){this.resource=Q,this.operation=ge,this.target=we}isOperation(Q){return this.operation===Q}}t.$dl=K;var ae;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(ae||(t.FileChangeType=ae={}));class ie{static{this.a=null}constructor(Q,ge){this.c=ge,this.b=void 0,this.d=new O.$V(()=>{const we=i.$xi.forUris(()=>this.c);return we.fill(this.rawAdded.map(Le=>[Le,!0])),we}),this.f=new O.$V(()=>{const we=i.$xi.forUris(()=>this.c);return we.fill(this.rawUpdated.map(Le=>[Le,!0])),we}),this.g=new O.$V(()=>{const we=i.$xi.forUris(()=>this.c);return we.fill(this.rawDeleted.map(Le=>[Le,!0])),we}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const we of Q){switch(we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}this.b!==ie.a&&(typeof we.cId=="number"?this.b===void 0?this.b=we.cId:this.b!==we.cId&&(this.b=ie.a):this.b!==void 0&&(this.b=ie.a))}}contains(Q,...ge){return this.h(Q,{includeChildren:!1},...ge)}affects(Q,...ge){return this.h(Q,{includeChildren:!0},...ge)}h(Q,ge,...we){if(!Q)return!1;const Le=we.length>0;return!!((!Le||we.includes(1))&&(this.d.value.get(Q)||ge.includeChildren&&this.d.value.findSuperstr(Q))||(!Le||we.includes(0))&&(this.f.value.get(Q)||ge.includeChildren&&this.f.value.findSuperstr(Q))||(!Le||we.includes(2))&&(this.g.value.findSubstr(Q)||ge.includeChildren&&this.g.value.findSuperstr(Q)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Q){return this.b===Q}hasCorrelation(){return typeof this.b=="number"}}t.$el=ie;function ee(V,Q,ge){return!V||!Q||V===Q||Q.length>V.length?!1:(Q.charAt(Q.length-1)!==k.sep&&(Q+=k.sep),ge?(0,P.$vf)(V,Q):V.indexOf(Q)===0)}class ce extends Error{constructor(Q,ge,we){super(Q),this.fileOperationResult=ge,this.options=we}}t.$gl=ce;class De extends ce{constructor(Q,ge,we,Le){super(Q,ge,Le),this.fileOperationResult=ge,this.size=we}}t.$hl=De;class Ee extends ce{constructor(Q,ge,we){super(Q,2,we),this.stat=ge}}t.$il=Ee;var Ie;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ie||(t.FileOperationResult=Ie={})),t.$jl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$kl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$ll="files.associations",t.$ml="files.exclude",t.$nl="files.readonlyInclude",t.$ol="files.readonlyExclude",t.$pl="files.readonlyFromPermissions";var le;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(t.FileKind=le={})),t.$ql="";function _(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}async function ue(V,Q){if(!Q.hasProvider(S.URI.from({scheme:V.scheme})))return new Promise(ge=>{const we=Q.onDidChangeFileSystemProviderRegistrations(Le=>{Le.scheme===V.scheme&&Le.added&&(we.dispose(),ge())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(Q){return(0,W.$9f)(Q)||(Q=0),Q<re.KB?(0,A.localize)(1,null,Q.toFixed(0)):Q<re.MB?(0,A.localize)(2,null,(Q/re.KB).toFixed(2)):Q<re.GB?(0,A.localize)(3,null,(Q/re.MB).toFixed(2)):Q<re.TB?(0,A.localize)(4,null,(Q/re.GB).toFixed(2)):(0,A.localize)(5,null,(Q/re.TB).toFixed(2))}}t.$tl=re;function ye(V){const Q=typeof V=="string"||V?.scheme===p.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===p.Schemas.file?1024*re.MB:Q?10*re.MB:b.$o?50*re.MB:1024*re.MB}}),define(me[150],be([1,0,50]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cdc=t.$bdc=void 0,t.$bdc=(0,i.$ri)("mainProcessService");class k{constructor(W,S){this.a=W,this.b=S}getChannel(W){return this.a.getChannel(W,this.b)}registerChannel(W,S){this.a.registerChannel(W,S)}}t.$cdc=k}),define(me[151],be([1,0,2,145]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ddc=void 0;class P extends i.$Uc{constructor(S){super(),this.a=this.B(new k.$QW(`window:${S}`))}getChannel(S){return this.a.getChannel(S)}registerChannel(S,A){this.a.registerChannel(S,A)}}t.$ddc=P});var Ei=this&&this.__param||function(se,t){return function(i,k){t(i,k,se)}};define(me[152],be([1,0,77,150]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hdc=void 0;let P=class{constructor(S,A){return this.windowId=S,i.ProxyChannel.toService(A.getChannel("nativeHost"),{context:S,properties:(()=>{const g=new Map;return g.set("windowId",S),g})()})}};t.$hdc=P,t.$hdc=P=Je([Ei(1,k.$bdc)],P)}),define(me[78],be([1,0,37,10]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0n=void 0;class P{constructor(){this.a=new Map}add(S,A){i.ok(k.$5f(S)),i.ok(k.$7f(A)),i.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,A)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}t.$0n=new P}),define(me[153],be([1,0,3,78]),function(se,t,i,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$n=void 0,t.$$n={JSONContribution:"base.contributions.json"};function P(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class W{constructor(){this.b=new i.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,b){this.a[P(g)]=b,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const S=new W;k.$0n.add(t.$$n.JSONContribution,S)}),define(me[154],be([1,0,11,18,45,19,3,10,16,147,153,78]),function(se,t,i,k,P,W,S,A,g,b,p,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_w=t.$$w=t.$0w=t.$9w=t.$8w=t.$7w=t.IconFontDefinition=t.IconContribution=t.$4w=void 0,t.$5w=r,t.$6w=h,t.$4w={IconContribution:"base.contributions.icons"};var c;(function(d){function a(L,C){let N=L.defaults;for(;W.ThemeIcon.isThemeIcon(N);){const I=n.getIcon(N.id);if(!I)return;N=I.defaults}return N}d.getDefinition=a})(c||(t.IconContribution=c={}));var f;(function(d){function a(C){return{weight:C.weight,style:C.style,src:C.src.map(N=>({format:N.format,location:N.location.toString()}))}}d.toJSONObject=a;function L(C){const N=I=>(0,A.$5f)(I)?I:void 0;if(C&&Array.isArray(C.src)&&C.src.every(I=>(0,A.$5f)(I.format)&&(0,A.$5f)(I.location)))return{weight:N(C.weight),style:N(C.style),src:C.src.map(I=>({format:I.format,location:g.URI.parse(I.location)}))}}d.fromJSONObject=L})(f||(t.IconFontDefinition=f={}));class e{constructor(){this.a=new S.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${W.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,L,C,N){const I=this.b[a];if(I){if(C&&!I.description){I.description=C,this.d.properties[a].markdownDescription=`${C} $(${a})`;const z=this.e.enum.indexOf(a);z!==-1&&(this.e.enumDescriptions[z]=C),this.a.fire()}return I}const M={id:a,description:C,defaults:L,deprecationMessage:N};this.b[a]=M;const E={$ref:"#/definitions/icons"};return N&&(E.deprecationMessage=N),C&&(E.markdownDescription=`${C}: $(${a})`),this.d.properties[a]=E,this.e.enum.push(a),this.e.enumDescriptions.push(C||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const L=this.e.enum.indexOf(a);L!==-1&&(this.e.enum.splice(L,1),this.e.enumDescriptions.splice(L,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,L){const C=this.f[a];return C||(this.f[a]=L,this.a.fire(),L)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(I,M)=>I.id.localeCompare(M.id),L=I=>{for(;W.ThemeIcon.isThemeIcon(I.defaults);)I=this.b[I.defaults.id];return`codicon codicon-${I?I.id:""}`},C=[];C.push("| preview     | identifier                        | default codicon ID                | description"),C.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const N=Object.keys(this.b).map(I=>this.b[I]);for(const I of N.filter(M=>!!M.description).sort(a))C.push(`|<i class="${L(I)}"></i>|${I.id}|${W.ThemeIcon.isThemeIcon(I.defaults)?I.defaults.id:I.id}|${I.description||""}|`);C.push("| preview     | identifier                        "),C.push("| ----------- | --------------------------------- |");for(const I of N.filter(M=>!W.ThemeIcon.isThemeIcon(M.defaults)).sort(a))C.push(`|<i class="${L(I)}"></i>|${I.id}|`);return C.join(`
`)}}const n=new e;O.$0n.add(t.$4w.IconContribution,n);function r(d,a,L,C){return n.registerIcon(d,a,L,C)}function h(){return n}function m(){const d=(0,P.$Mj)();for(const a in d){const L="\\"+d[a].toString(16);n.registerIcon(a,{fontCharacter:L})}}m(),t.$7w="vscode://schemas/icons";const y=O.$0n.as(p.$$n.JSONContribution);y.registerSchema(t.$7w,n.getIconSchema());const o=new i.$Dh(()=>y.notifySchemaChanged(t.$7w),200);n.onDidChange(()=>{o.isScheduled()||o.schedule()}),t.$8w=r("widget-close",k.$Qj.close,(0,b.localize)(2,null)),t.$9w=r("goto-previous-location",k.$Qj.arrowUp,(0,b.localize)(3,null)),t.$0w=r("goto-next-location",k.$Qj.arrowDown,(0,b.localize)(4,null)),t.$$w=W.ThemeIcon.modify(k.$Qj.sync,"spin"),t.$_w=W.ThemeIcon.modify(k.$Qj.loading,"spin")}),define(me[155],be([1,0,4,3,2,19,154]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tJb=void 0,t.$sJb=A;function A(b){const p=new P.$Tc,O=p.add(new k.$be),c=(0,S.$6w)();return p.add(c.onDidChange(()=>O.fire())),b&&p.add(b.onDidProductIconThemeChange(()=>O.fire())),{dispose:()=>p.dispose(),onDidChange:O.event,getCSS(){const f=b?b.getProductIconTheme():new g,e={},n=[],r=[];for(const h of c.getIcons()){const m=f.getIcon(h);if(!m)continue;const y=m.font,o=`--vscode-icon-${h.id}-font-family`,d=`--vscode-icon-${h.id}-content`;y?(e[y.id]=y.definition,r.push(`${o}: ${(0,i.$ZS)(y.id)};`,`${d}: '${m.fontCharacter}';`),n.push(`.codicon-${h.id}:before { content: '${m.fontCharacter}'; font-family: ${(0,i.$ZS)(y.id)}; }`)):(r.push(`${d}: '${m.fontCharacter}'; ${o}: 'codicon';`),n.push(`.codicon-${h.id}:before { content: '${m.fontCharacter}'; }`))}for(const h in e){const m=e[h],y=m.weight?`font-weight: ${m.weight};`:"",o=m.style?`font-style: ${m.style};`:"",d=m.src.map(a=>`${(0,i.$YS)(a.location)} format('${a.format}')`).join(", ");n.push(`@font-face { src: ${d}; font-family: ${(0,i.$ZS)(h)};${y}${o} font-display: block; }`)}return n.push(`:root { ${r.join(" ")} }`),n.join(`
`)}}}class g{getIcon(p){const O=(0,S.$6w)();let c=p.defaults;for(;W.ThemeIcon.isThemeIcon(c);){const f=O.getIcon(c.id);if(!f)return;c=f.defaults}return c}}t.$tJb=g}),define(me[156],be([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$nD=void 0,t.$oD=k,t.$pD=P,t.$qD=W,t.$rD=S,t.$sD=A,t.$tD=O,t.$uD=c,t.$vD=f,t.$wD=e,t.$xD=n,t.$yD=r,t.$nD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function k(h){return typeof h.parentId=="number"}function P(h){return!!h.workspaceUri}function W(h){return!!h.folderUri}function S(h){return!!h.fileUri}function A(h){const m=c(h),y=h.getValue("window.menuBarVisibility");return y==="default"||m&&y==="compact"||i.$j&&i.$m?"classic":y}var g;(function(h){h.TITLE_BAR_STYLE="window.titleBarStyle",h.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(g||(t.TitleBarSetting=g={}));var b;(function(h){h.NATIVE="native",h.CUSTOM="custom"})(b||(t.TitlebarStyle=b={}));var p;(function(h){h.AUTO="auto",h.WINDOWED="windowed",h.NEVER="never"})(p||(t.CustomTitleBarVisibility=p={}));function O(h,m){return!0}function c(h,m){return m||(m=f(h)),m==="native"}function f(h){if(i.$o)return"custom";const m=h.getValue("window");if(m){if(i.$j&&m.nativeTabs===!0||i.$j&&m.nativeFullScreen===!1)return"native";const d=m.titleBarStyle;if(d==="native"||d==="custom")return d}return i.$k?"native":"custom"}function e(h){return!(!i.$i||i.$o||c(h))}function n(h){const m=h.getValue("window");return!m||typeof m.nativeFullScreen!="boolean"||m.nativeTabs?!0:m.nativeFullScreen!==!1}function r(h=0){return Math.pow(1.2,h)}}),define(me[157],be([1,0,17,4,22,35,156]),function(se,t,i,k,P,W,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kdc=t.$jdc=t.ApplyZoomTarget=void 0,t.$ldc=g,t.$mdc=p,t.$ndc=O;var A;(function(c){c[c.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",c[c.ALL_WINDOWS=2]="ALL_WINDOWS"})(A||(t.ApplyZoomTarget=A={})),t.$jdc=8,t.$kdc=-8;function g(c,f){c=Math.min(Math.max(c,t.$kdc),t.$jdc);const e=[];f===A.ACTIVE_WINDOW?e.push((0,k.$nS)()):f===A.ALL_WINDOWS?e.push(...Array.from((0,k.getWindows)()).map(({window:n})=>n)):e.push(f);for(const n of e)b(n)?.webFrame?.setZoomLevel(c),(0,i.$kR)((0,S.$yD)(c),n),(0,i.$gR)(c,n)}function b(c){if(c===P.$cR)return{ipcRenderer:W.$O,webFrame:W.$Q};{const f=c;if(f?.vscode?.ipcRenderer&&f?.vscode?.webFrame)return f.vscode}}function p(c){g((0,i.$hR)(typeof c=="number"?(0,k.$nS)():c)+1,c)}function O(c){g((0,i.$hR)(typeof c=="number"?(0,k.$nS)():c)-1,c)}}),define(me[158],be([1,0,12,4,144,11,103,35,148,149,151,152,155,157,15,22,116,107]),function(se,t,i,k,P,W,S,A,g,b,p,O,c,f,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=z;const r=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,h=/\s--inspect-port=(?<port>\d+)/;class m{getHeight(F){return 22}getTemplateId(F){return I(F)?"process":C(F)?"machine":(0,g.$_m)(F)?"error":N(F)?"header":""}}class y{hasChildren(F){return(0,g.$_m)(F)?!1:I(F)?!!F.children?.length:!0}getChildren(F){return I(F)?F.children?F.children:[]:(0,g.$_m)(F)?[]:N(F)?F.processRoots.length>1?F.processRoots:[F.processRoots[0].rootProcess]:C(F)?[F.rootProcess]:[F.processes]}}class o{constructor(){this.templateId="header"}renderTemplate(F){const x=(0,k.$IS)(F,(0,k.$)(".row")),B=(0,k.$IS)(x,(0,k.$)(".nameLabel")),Y=(0,k.$IS)(x,(0,k.$)(".cpu")),K=(0,k.$IS)(x,(0,k.$)(".memory")),ae=(0,k.$IS)(x,(0,k.$)(".pid"));return{name:B,CPU:Y,memory:K,PID:ae}}renderElement(F,x,B,Y){B.name.textContent=(0,i.localize)(0,null),B.CPU.textContent=(0,i.localize)(1,null),B.PID.textContent=(0,i.localize)(2,null),B.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(F){}}class d{constructor(){this.templateId="machine"}renderTemplate(F){const x=Object.create(null),B=(0,k.$IS)(F,(0,k.$)(".row"));return x.name=(0,k.$IS)(B,(0,k.$)(".nameLabel")),x}renderElement(F,x,B,Y){B.name.textContent=F.element.name}disposeTemplate(F){}}class a{constructor(){this.templateId="error"}renderTemplate(F){const x=Object.create(null),B=(0,k.$IS)(F,(0,k.$)(".row"));return x.name=(0,k.$IS)(B,(0,k.$)(".nameLabel")),x}renderElement(F,x,B,Y){B.name.textContent=F.element.errorMessage}disposeTemplate(F){}}class L{constructor(F,x,B){this.a=F,this.b=x,this.c=B,this.templateId="process"}renderTemplate(F){const x=(0,k.$IS)(F,(0,k.$)(".row")),B=(0,k.$IS)(x,(0,k.$)(".nameLabel")),Y=(0,k.$IS)(x,(0,k.$)(".cpu")),K=(0,k.$IS)(x,(0,k.$)(".memory")),ae=(0,k.$IS)(x,(0,k.$)(".pid"));return{name:B,CPU:Y,PID:ae,memory:K}}renderElement(F,x,B,Y){const{element:K}=F,ae=K.pid.toFixed(0);let ie=K.name;this.c.has(K.pid)&&(ie=this.c.get(K.pid)),B.name.textContent=ie,B.name.title=K.cmd,B.CPU.textContent=K.load.toFixed(0),B.PID.textContent=ae,B.PID.parentElement.id=`pid-${ae}`;const ee=this.a==="win32"?K.mem:this.b*(K.mem/100);B.memory.textContent=(ee/b.$tl.MB).toFixed(0)}disposeTemplate(F){}}function C(q){return!!q.name&&!!q.rootProcess}function N(q){return!!q.processRoots}function I(q){return!!q.pid}class M{constructor(F,x){this.f=x,this.b=new Map;const B=new p.$ddc(F);this.c=new O.$hdc(F,B),this.k(x.styles),this.g(x),A.$O.on("vscode:pidToNameResponse",(Y,K)=>{this.b.clear();for(const[ae,ie]of K)this.b.set(ae,ie)}),A.$O.on("vscode:listProcessesResponse",async(Y,K)=>{K.forEach((ae,ie)=>{I(ae.rootProcess)&&(ae.rootProcess.name=ie===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:K}}),this.d.layout(n.$cR.innerHeight,n.$cR.innerWidth)):await this.h(K),this.m(0)}),this.a=Date.now(),A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")}g(F){n.$cR.document.onkeydown=x=>{const B=F.platform==="darwin"?x.metaKey:x.ctrlKey;B&&x.keyCode===87&&(x.stopPropagation(),x.preventDefault(),A.$O.send("vscode:closeProcessExplorer")),B&&x.keyCode===187&&(0,f.$mdc)(n.$cR),B&&x.keyCode===189&&(0,f.$ndc)(n.$cR)}}async h(F){const x=n.$cR.document.getElementById("process-list");if(!x)return;const{totalmem:B}=await this.c.getOSStatistics(),Y=[new L(this.f.platform,B,this.b),new o,new d,new a];this.d=new P.$dW("processExplorer",x,new m,Y,new y,{identityProvider:{getId:K=>I(K)?K.pid.toString():(0,g.$_m)(K)?K.hostName:N(K)?"processes":C(K)?K.name:"header"}}),this.d.setInput({processes:{processRoots:F}}),this.d.layout(n.$cR.innerHeight,n.$cR.innerWidth),this.d.onKeyDown(K=>{const ae=new e.$FR(K);if(ae.keyCode===35&&ae.altKey){const ie=this.n();Promise.all(ie.map(ee=>this.c.killProcess(ee,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(K=>{I(K.element)&&this.l(K.element,!0)}),x.style.height=`${n.$cR.innerHeight}px`,n.$cR.addEventListener("resize",()=>{x.style.height=`${n.$cR.innerHeight}px`,this.d?.layout(n.$cR.innerHeight,n.$cR.innerWidth)})}i(F){const x=r.exec(F);return x&&x.groups.port!=="0"||F.indexOf("node ")>=0||F.indexOf("node.exe")>=0}j(F){const x={type:"node",request:"attach",name:`process ${F.pid}`};let B=r.exec(F.cmd);B?x.port=Number(B.groups.port):x.processId=String(F.pid),B=h.exec(F.cmd),B&&(x.port=Number(B.groups.port)),A.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[x]})}k(F){const x=(0,k.$qS)(),B=[];F.listFocusBackground&&(B.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${F.listFocusBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${F.listFocusBackground}; }`)),F.listFocusForeground&&B.push(`.monaco-list:focus .monaco-list-row.focused { color: ${F.listFocusForeground}; }`),F.listActiveSelectionBackground&&(B.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${F.listActiveSelectionBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${F.listActiveSelectionBackground}; }`)),F.listActiveSelectionForeground&&B.push(`.monaco-list:focus .monaco-list-row.selected { color: ${F.listActiveSelectionForeground}; }`),F.listHoverBackground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${F.listHoverBackground}; }`),F.listHoverForeground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${F.listHoverForeground}; }`),F.listFocusOutline&&B.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${F.listFocusOutline}; outline-offset: -1px; }`),F.listHoverOutline&&B.push(`.monaco-list-row:hover { outline: 1px dashed ${F.listHoverOutline}; outline-offset: -1px; }`),F.scrollbarShadowColor&&B.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${F.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${F.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${F.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),F.scrollbarSliderBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${F.scrollbarSliderBackgroundColor};
				}
			`),F.scrollbarSliderHoverBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${F.scrollbarSliderHoverBackgroundColor};
				}
			`),F.scrollbarSliderActiveBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${F.scrollbarSliderActiveBackgroundColor};
				}
			`),x.textContent=B.join(`
`),F.color&&(n.$cR.document.body.style.color=F.color)}l(F,x){const B=[],Y=Number(F.pid);x&&(B.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(Y,"SIGTERM")}}),B.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(Y,"SIGKILL")}}),B.push({type:"separator"})),B.push({label:(0,i.localize)(6,null),click:()=>{const K=this.n();K?.includes(Y)||(K.length=0,K.push(Y));const ae=K?.map(ie=>n.$cR.document.getElementById(`pid-${ie}`)).filter(ie=>!!ie);if(ae){const ie=ae.map(ee=>ee.innerText).filter(ee=>!!ee);this.c.writeClipboardText(ie.join(`
`))}}}),B.push({label:(0,i.localize)(7,null),click:()=>{const K=n.$cR.document.getElementById("process-list");K&&this.c.writeClipboardText(K.innerText)}}),F&&x&&this.i(F.cmd)&&(B.push({type:"separator"}),B.push({label:(0,i.localize)(8,null),click:()=>{this.j(F)}})),(0,S.$IW)(B)}m(F){setTimeout(()=>{const x=Date.now(),B=F+x-this.a;this.a=x,B>1e3?(A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")):this.m(B)},200)}n(){return this.d?.getSelection()?.map(F=>{if(!(!F||!("pid"in F)))return F.pid}).filter(F=>!!F)}}function E(){const q=(0,k.$qS)();q.id="codiconStyles";const F=(0,c.$sJb)(void 0);function x(){q.textContent=F.getCSS()}const B=new W.$Dh(x,0);F.onDidChange(()=>B.schedule()),B.schedule()}function z(q){const F=q.data.platform==="win32"?"windows":q.data.platform==="linux"?"linux":"mac";n.$cR.document.body.classList.add(F),E(),(0,f.$ldc)(q.data.zoomLevel,n.$cR),new M(q.windowId,q.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/910284865c34fd492e3f6fd5a8ab8e571432cc58/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
