/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ne){for(var e=[],R=0,N=ne.length;R<N;R++)e[R]=ae[ne[R]];return e};define(ae[124],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class R{static get(){const L=new Map,j=new Map,A=new Map,I=new Map;function C(u,l){u.has(l.detail)||u.set(l.detail,-l.timestamp)}function $(u,l){const w=u.get(l.detail);w&&(w>=0||u.set(l.detail,w+l.timestamp))}let E=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(E=ne.getStats().slice(0).sort((u,l)=>u.timestamp-l.timestamp));for(const u of E)switch(u.type){case 10:C(L,u);break;case 11:case 12:$(L,u);break;case 21:C(j,u);break;case 22:$(j,u);break;case 33:C(A,u);break;case 34:$(A,u);break;case 31:C(I,u);break;case 32:$(I,u);break}let b=0;A.forEach(u=>b+=u);function m(u){const l=[];return u.forEach((w,p)=>l.push([p,w])),l}return{amdLoad:m(L),amdInvoke:m(j),nodeRequire:m(A),nodeEval:m(I),nodeRequireTotal:b}}static toMarkdownTable(L,j){let A="";const I=[];return L.forEach((C,$)=>{I[$]=C.length}),j.forEach(C=>{C.forEach(($,E)=>{typeof $>"u"&&($=C[E]="-");const b=$.toString().length;I[E]=Math.max(b,I[E])})}),L.forEach((C,$)=>{A+=`| ${C+" ".repeat(I[$]-C.toString().length)} `}),A+=`|
`,L.forEach((C,$)=>{A+=`| ${"-".repeat(I[$])} `}),A+=`|
`,j.forEach(C=>{C.forEach(($,E)=>{typeof $<"u"&&(A+=`| ${$+" ".repeat(I[E]-$.toString().length)} `)}),A+=`|
`}),A}}e.$U=R}),define(ae[125],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=R,e.$gb=N,e.$hb=L,e.$ib=j,e.$jb=A,e.$kb=I,e.$lb=C,e.$nb=E,e.$ob=b,e.$pb=m,e.$qb=u,e.$rb=l;function R(w,p){const h=N(w,p);if(h!==-1)return w[h]}function N(w,p,h=w.length-1){for(let g=h;g>=0;g--){const f=w[g];if(p(f))return g}return-1}function L(w,p){const h=j(w,p);return h===-1?void 0:w[h]}function j(w,p,h=0,g=w.length){let f=h,c=g;for(;f<c;){const d=Math.floor((f+c)/2);p(w[d])?f=d+1:c=d}return f-1}function A(w,p){const h=I(w,p);return h===w.length?void 0:w[h]}function I(w,p,h=0,g=w.length){let f=h,c=g;for(;f<c;){const d=Math.floor((f+c)/2);p(w[d])?c=d:f=d+1}return f}function C(w,p,h=0,g=w.length){const f=I(w,p,h,g);return f===w.length?-1:f}class ${static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if($.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!p(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const h=j(this.e,p,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$mb=$;function E(w,p){if(w.length===0)return;let h=w[0];for(let g=1;g<w.length;g++){const f=w[g];p(f,h)>0&&(h=f)}return h}function b(w,p){if(w.length===0)return;let h=w[0];for(let g=1;g<w.length;g++){const f=w[g];p(f,h)>=0&&(h=f)}return h}function m(w,p){return E(w,(h,g)=>-p(h,g))}function u(w,p){if(w.length===0)return-1;let h=0;for(let g=1;g<w.length;g++){const f=w[g];p(f,w[h])>0&&(h=g)}return h}function l(w,p){for(const h of w){const g=p(h);if(g!==void 0)return g}}}),define(ae[126],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=R,e.$L=N,e.$M=L,e.$N=j;function R(A,I){const C=Object.create(null);for(const $ of A){const E=I($);let b=C[E];b||(b=C[E]=[]),b.push($)}return C}function N(A,I){const C=[],$=[];for(const E of A)I.has(E)||C.push(E);for(const E of I)A.has(E)||$.push(E);return{removed:C,added:$}}function L(A,I){const C=[],$=[];for(const[E,b]of A)I.has(E)||C.push(b);for(const[E,b]of I)A.has(E)||$.push(b);return{removed:C,added:$}}function j(A,I){const C=new Set;for(const $ of I)A.has($)&&C.add($);return C}}),define(ae[84],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=N,e.$Wh=L,e.$Xh=j;function R(A){return(I,C,$)=>{let E=null,b=null;if(typeof $.value=="function"?(E="value",b=$.value):typeof $.get=="function"&&(E="get",b=$.get),!b)throw new Error("not supported");$[E]=A(b,C)}}function N(A,I,C){let $=null,E=null;if(typeof C.value=="function"?($="value",E=C.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&($="get",E=C.get),!E)throw new Error("not supported");const b=`$memoize$${I}`;C[$]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,m)}),this[b]}}function L(A,I,C){return R(($,E)=>{const b=`$debounce$${E}`,m=`$debounce$result$${E}`;return function(...u){this[m]||(this[m]=C?C():void 0),clearTimeout(this[b]),I&&(this[m]=I(this[m],...u),u=[this[m]]),this[b]=setTimeout(()=>{$.apply(this,u),this[m]=C?C():void 0},A)}})}function j(A,I,C){return R(($,E)=>{const b=`$throttle$timer$${E}`,m=`$throttle$result$${E}`,u=`$throttle$lastRun$${E}`,l=`$throttle$pending$${E}`;return function(...w){if(this[m]||(this[m]=C?C():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...w)),this[l])return;const p=this[u]+A;p<=Date.now()?(this[u]=Date.now(),$.apply(this,[this[m]]),this[m]=C?C():void 0):(this[l]=!0,this[b]=setTimeout(()=>{this[l]=!1,this[u]=Date.now(),$.apply(this,[this[m]]),this[m]=C?C():void 0},p-Date.now()))}})}}),define(ae[7],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=j,e.$2=A,e.$3=I,e.$4=$,e.$6=b,e.$7=m,e.$8=u,e.$0=w;class R{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?f.isErrorNoTelemetry(i)?new f(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=R,e.$X=new R;function N(d){e.$X.setUnexpectedErrorHandler(d)}function L(d){if(!d||typeof d!="object")return!1;const i=d;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function j(d){$(d)||e.$X.onUnexpectedError(d)}function A(d){$(d)||e.$X.onUnexpectedExternalError(d)}function I(d){if(d instanceof Error){const{name:i,message:o}=d,n=d.stacktrace||d.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:f.isErrorNoTelemetry(d)}}return d}const C="Canceled";function $(d){return d instanceof E?!0:d instanceof Error&&d.name===C&&d.message===C}class E extends Error{constructor(){super(C),this.name=this.message}}e.$5=E;function b(){const d=new Error(C);return d.name=d.message,d}function m(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}function u(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}class l extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=l;function w(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}class p extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=p;class h extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=h;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=g;class f extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof f)return i;const o=new f;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=f;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(ae[17],ce([0,1,7,125]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=j,e.$ub=A,e.$vb=I,e.$wb=C,e.$xb=$,e.$yb=E,e.$zb=b,e.$Ab=m,e.$Bb=u,e.$Cb=l,e.$Db=w,e.$Eb=p,e.top=h,e.$Gb=g,e.$Hb=c,e.$Ib=d,e.$Jb=i,e.$Kb=o,e.$Lb=n,e.$Mb=s,e.$Nb=t,e.$Ob=r,e.$Pb=a,e.$Qb=y,e.$Rb=v,e.$Sb=P,e.$Tb=S,e.$Ub=k,e.$Vb=D,e.$Wb=T,e.$Xb=F,e.$Yb=U,e.$Zb=Q,e.$1b=G,e.$2b=Y,e.$3b=W,e.$4b=J,e.$5b=H,e.$6b=B,e.$7b=he,e.$8b=te,e.$$b=O;function L(K,ee=0){return K[K.length-(1+ee)]}function j(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}function A(K,ee,_=(Z,se)=>Z===se){if(K===ee)return!0;if(!K||!ee||K.length!==ee.length)return!1;for(let Z=0,se=K.length;Z<se;Z++)if(!_(K[Z],ee[Z]))return!1;return!0}function I(K,ee){const _=K.length-1;ee<_&&(K[ee]=K[_]),K.pop()}function C(K,ee,_){return $(K.length,Z=>_(K[Z],ee))}function $(K,ee){let _=0,Z=K-1;for(;_<=Z;){const se=(_+Z)/2|0,ue=ee(se);if(ue<0)_=se+1;else if(ue>0)Z=se-1;else return se}return-(_+1)}function E(K,ee,_){if(K=K|0,K>=ee.length)throw new TypeError("invalid index");const Z=ee[Math.floor(ee.length*Math.random())],se=[],ue=[],ge=[];for(const fe of ee){const $e=_(fe,Z);$e<0?se.push(fe):$e>0?ue.push(fe):ge.push(fe)}return K<se.length?E(K,se,_):K<se.length+ge.length?ge[0]:E(K-(se.length+ge.length),ue,_)}function b(K,ee){const _=[];let Z;for(const se of K.slice(0).sort(ee))!Z||ee(Z[0],se)!==0?(Z=[se],_.push(Z)):Z.push(se);return _}function*m(K,ee){let _,Z;for(const se of K)Z!==void 0&&ee(Z,se)?_.push(se):(_&&(yield _),_=[se]),Z=se;_&&(yield _)}function u(K,ee){for(let _=0;_<=K.length;_++)ee(_===0?void 0:K[_-1],_===K.length?void 0:K[_])}function l(K,ee){for(let _=0;_<K.length;_++)ee(_===0?void 0:K[_-1],K[_],_+1===K.length?void 0:K[_+1])}function w(K,ee,_){const Z=[];function se(fe,$e,ye){if($e===0&&ye.length===0)return;const ve=Z[Z.length-1];ve&&ve.start+ve.deleteCount===fe?(ve.deleteCount+=$e,ve.toInsert.push(...ye)):Z.push({start:fe,deleteCount:$e,toInsert:ye})}let ue=0,ge=0;for(;;){if(ue===K.length){se(ue,0,ee.slice(ge));break}if(ge===ee.length){se(ue,K.length-ue,[]);break}const fe=K[ue],$e=ee[ge],ye=_(fe,$e);ye===0?(ue+=1,ge+=1):ye<0?(se(ue,1,[]),ue+=1):ye>0&&(se(ue,0,[$e]),ge+=1)}return Z}function p(K,ee,_){const Z=w(K,ee,_),se=[],ue=[];for(const ge of Z)se.push(...K.slice(ge.start,ge.start+ge.deleteCount)),ue.push(...ge.toInsert);return{removed:se,added:ue}}function h(K,ee,_){if(_===0)return[];const Z=K.slice(0,_).sort(ee);return f(K,ee,Z,_,K.length),Z}function g(K,ee,_,Z,se){return _===0?Promise.resolve([]):new Promise((ue,ge)=>{(async()=>{const fe=K.length,$e=K.slice(0,_).sort(ee);for(let ye=_,ve=Math.min(_+Z,fe);ye<fe;ye=ve,ve=Math.min(ve+Z,fe)){if(ye>_&&await new Promise(Ce=>setTimeout(Ce)),se&&se.isCancellationRequested)throw new R.$5;f(K,ee,$e,ye,ve)}return $e})().then(ue,ge)})}function f(K,ee,_,Z,se){for(const ue=_.length;Z<se;Z++){const ge=K[Z];if(ee(ge,_[ue-1])<0){_.pop();const fe=(0,N.$kb)(_,$e=>ee(ge,$e)<0);_.splice(fe,0,ge)}}}function c(K){return K.filter(ee=>!!ee)}function d(K){let ee=0;for(let _=0;_<K.length;_++)K[_]&&(K[ee]=K[_],ee+=1);K.length=ee}function i(K,ee,_){K.splice(_,0,K.splice(ee,1)[0])}function o(K){return!Array.isArray(K)||K.length===0}function n(K){return Array.isArray(K)&&K.length>0}function s(K,ee=_=>_){const _=new Set;return K.filter(Z=>{const se=ee(Z);return _.has(se)?!1:(_.add(se),!0)})}function t(K){const ee=new Set;return _=>{const Z=K(_);return ee.has(Z)?!1:(ee.add(Z),!0)}}function r(K,ee){return K.length>0?K[0]:ee}function a(K,ee){return K.length>0?K[K.length-1]:ee}function y(K,ee,_=(Z,se)=>Z===se){let Z=0;for(let se=0,ue=Math.min(K.length,ee.length);se<ue&&_(K[se],ee[se]);se++)Z++;return Z}function v(K){return[].concat(...K)}function P(K,ee){let _=typeof ee=="number"?K:0;typeof ee=="number"?_=K:(_=0,ee=K);const Z=[];if(_<=ee)for(let se=_;se<ee;se++)Z.push(se);else for(let se=_;se>ee;se--)Z.push(se);return Z}function S(K,ee,_){return K.reduce((Z,se)=>(Z[ee(se)]=_?_(se):se,Z),Object.create(null))}function k(K,ee){return K.push(ee),()=>D(K,ee)}function D(K,ee){const _=K.indexOf(ee);if(_>-1)return K.splice(_,1),ee}function T(K,ee,_){const Z=K.slice(0,ee),se=K.slice(ee);return Z.concat(_,se)}function F(K,ee){let _;if(typeof ee=="number"){let Z=ee;_=()=>{const se=Math.sin(Z++)*179426549;return se-Math.floor(se)}}else _=Math.random;for(let Z=K.length-1;Z>0;Z-=1){const se=Math.floor(_()*(Z+1)),ue=K[Z];K[Z]=K[se],K[se]=ue}}function U(K,ee){const _=K.indexOf(ee);_>-1&&(K.splice(_,1),K.unshift(ee))}function Q(K,ee){const _=K.indexOf(ee);_>-1&&(K.splice(_,1),K.push(ee))}function G(K,ee){for(const _ of ee)K.push(_)}function Y(K,ee){return Array.isArray(K)?K.map(ee):ee(K)}function W(K){return Array.isArray(K)?K:[K]}function J(K){return K[Math.floor(Math.random()*K.length)]}function H(K,ee,_){const Z=ie(K,ee),se=K.length,ue=_.length;K.length=se+ue;for(let ge=se-1;ge>=Z;ge--)K[ge+ue]=K[ge];for(let ge=0;ge<ue;ge++)K[ge+Z]=_[ge]}function B(K,ee,_,Z){const se=ie(K,ee);let ue=K.splice(se,_);return ue===void 0&&(ue=[]),H(K,se,Z),ue}function ie(K,ee){return ee<0?Math.max(ee+K.length,0):Math.min(ee,K.length)}var re;(function(K){function ee(ue){return ue<0}K.isLessThan=ee;function _(ue){return ue<=0}K.isLessThanOrEqual=_;function Z(ue){return ue>0}K.isGreaterThan=Z;function se(ue){return ue===0}K.isNeitherLessOrGreaterThan=se,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function he(K,ee){return(_,Z)=>ee(K(_),K(Z))}function te(...K){return(ee,_)=>{for(const Z of K){const se=Z(ee,_);if(!re.isNeitherLessOrGreaterThan(se))return se}return re.neitherLessOrGreaterThan}}const V=(K,ee)=>K-ee;e.$9b=V;const z=(K,ee)=>(0,e.$9b)(K?1:0,ee?1:0);e.$0b=z;function O(K){return(ee,_)=>-K(ee,_)}class M{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let _=this.c;for(;_<this.g.length&&ee(this.g[_]);)_++;const Z=_===this.c?null:this.g.slice(this.c,_);return this.c=_,Z}takeFromEndWhile(ee){let _=this.d;for(;_>=0&&ee(this.g[_]);)_--;const Z=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,Z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const _=this.g.slice(this.c,this.c+ee);return this.c+=ee,_}}e.$_b=M;class q{static{this.empty=new q(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(_=>(ee(_),!0))}toArray(){const ee=[];return this.iterate(_=>(ee.push(_),!0)),ee}filter(ee){return new q(_=>this.iterate(Z=>ee(Z)?_(Z):!0))}map(ee){return new q(_=>this.iterate(Z=>_(ee(Z))))}some(ee){let _=!1;return this.iterate(Z=>(_=ee(Z),!_)),_}findFirst(ee){let _;return this.iterate(Z=>ee(Z)?(_=Z,!1):!0),_}findLast(ee){let _;return this.iterate(Z=>(ee(Z)&&(_=Z),!0)),_}findLastMaxBy(ee){let _,Z=!0;return this.iterate(se=>((Z||re.isGreaterThan(ee(se,_)))&&(Z=!1,_=se),!0)),_}}e.$ac=q;class x{constructor(ee){this.c=ee}static createSortPermutation(ee,_){const Z=Array.from(ee.keys()).sort((se,ue)=>_(ee[se],ee[ue]));return new x(Z)}apply(ee){return ee.map((_,Z)=>ee[this.c[Z]])}inverse(){const ee=this.c.slice();for(let _=0;_<this.c.length;_++)ee[this.c[_]]=_;return new x(ee)}}e.$bc=x}),define(ae[127],ce([0,1,7]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$cd=L,e.$dd=j,e.$ed=A,e.$fd=I,e.$gd=C;function N($,E){if(!$)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function L($,E="Unreachable"){throw new Error(E)}function j($){if(!$)throw new R.$cb("Assertion Failed")}function A($){$||(0,R.$1)(new R.$cb("Soft Assertion Failed"))}function I($){if(!$()){debugger;$(),(0,R.$1)(new R.$cb("Assertion Failed"))}}function C($,E){let b=0;for(;b<$.length-1;){const m=$[b],u=$[b+1];if(!E(m,u))return!1;b++}return!0}}),define(ae[85],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=R;function R(N,L){const j=this;let A=!1,I;return function(){if(A)return I;if(A=!0,L)try{I=N.apply(j,arguments)}finally{L()}else I=N.apply(j,arguments);return I}}}),define(ae[61],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(N){function L(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}N.is=L;const j=Object.freeze([]);function A(){return j}N.empty=A;function*I(i){yield i}N.single=I;function C(i){return L(i)?i:I(i)}N.wrap=C;function $(i){return i||j}N.from=$;function*E(i){for(let o=i.length-1;o>=0;o--)yield i[o]}N.reverse=E;function b(i){return!i||i[Symbol.iterator]().next().done===!0}N.isEmpty=b;function m(i){return i[Symbol.iterator]().next().value}N.first=m;function u(i,o){for(const n of i)if(o(n))return!0;return!1}N.some=u;function l(i,o){for(const n of i)if(o(n))return n}N.find=l;function*w(i,o){for(const n of i)o(n)&&(yield n)}N.filter=w;function*p(i,o){let n=0;for(const s of i)yield o(s,n++)}N.map=p;function*h(...i){for(const o of i)yield*o}N.concat=h;function g(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}N.reduce=g;function*f(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}N.slice=f;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,N.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}N.consume=c;async function d(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}N.asyncToArray=d})(R||(e.Iterable=R={}))}),define(ae[35],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Cn=A,e.$Dn=b,e.$En=m,e.$Fn=u,e.$Gn=l,e.$Hn=w,e.$In=p,e.$Jn=h,e.$Kn=g,e.$Ln=f,e.$Mn=c,e.$Nn=d;var R;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var j;(function(i){i.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function A(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,y=0;function v(U){let Q=0,G=0;for(;Q<U;){const Y=i.charCodeAt(n);if(Y>=48&&Y<=57)G=G*16+Y-48;else if(Y>=65&&Y<=70)G=G*16+Y-65+10;else if(Y>=97&&Y<=102)G=G*16+Y-97+10;else break;n++,Q++}return Q<U&&(G=-1),G}function P(U){n=U,t="",r=0,a=16,y=0}function S(){const U=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&$(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&$(i.charCodeAt(n)))for(n++;n<i.length&&$(i.charCodeAt(n));)n++;else return y=3,i.substring(U,n);let Q=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&$(i.charCodeAt(n))){for(n++;n<i.length&&$(i.charCodeAt(n));)n++;Q=n}else y=3;return i.substring(U,Q)}function k(){let U="",Q=n;for(;;){if(n>=s){U+=i.substring(Q,n),y=2;break}const G=i.charCodeAt(n);if(G===34){U+=i.substring(Q,n),n++;break}if(G===92){if(U+=i.substring(Q,n),n++,n>=s){y=2;break}switch(i.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const W=v(4);W>=0?U+=String.fromCharCode(W):y=4;break}default:y=5}Q=n;continue}if(G>=0&&G<=31)if(C(G)){U+=i.substring(Q,n),y=2;break}else y=6;n++}return U}function D(){if(t="",y=0,r=n,n>=s)return r=s,a=17;let U=i.charCodeAt(n);if(I(U)){do n++,t+=String.fromCharCode(U),U=i.charCodeAt(n);while(I(U));return a=15}if(C(U))return n++,t+=String.fromCharCode(U),U===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(U){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=k(),a=10;case 47:{const Q=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!C(i.charCodeAt(n));)n++;return t=i.substring(Q,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const G=s-1;let Y=!1;for(;n<G;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Y=!0;break}n++}return Y||(n++,y=1),t=i.substring(Q,n),a=13}return t+=String.fromCharCode(U),n++,a=16}case 45:if(t+=String.fromCharCode(U),n++,n===s||!$(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=S(),a=11;default:for(;n<s&&T(U);)n++,U=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(U),n++,a=16}}function T(U){if(I(U)||C(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let U;do U=D();while(U>=12&&U<=15);return U}return{setPosition:P,getPosition:()=>n,scan:o?F:D,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>y}}function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function C(i){return i===10||i===13||i===8232||i===8233}function $(i){return i>=48&&i<=57}var E;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(E||(E={}));function b(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function y(v,P,S,k){r.value=v,r.offset=P,r.length=S,r.type=k,r.colonOffset=void 0,t=r}try{f(i,{onObjectBegin:(v,P)=>{if(o<=v)throw s;t=void 0,a=o>v,n.push("")},onObjectProperty:(v,P,S)=>{if(o<P||(y(v,P,S,"property"),n[n.length-1]=v,o<=P+S))throw s},onObjectEnd:(v,P)=>{if(o<=v)throw s;t=void 0,n.pop()},onArrayBegin:(v,P)=>{if(o<=v)throw s;t=void 0,n.push(0)},onArrayEnd:(v,P)=>{if(o<=v)throw s;t=void 0,n.pop()},onLiteralValue:(v,P,S)=>{if(o<P||(y(v,P,S,d(v)),o<=P+S))throw s},onSeparator:(v,P,S)=>{if(o<=P)throw s;if(v===":"&&t&&t.type==="property")t.colonOffset=P,a=!1,t=void 0;else if(v===","){const k=n[n.length-1];typeof k=="number"?n[n.length-1]=k+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(v){if(v!==s)throw v}return{path:n,previousNode:t,isAtPropertyKey:a,matches:v=>{let P=0;for(let S=0;P<v.length&&S<n.length;S++)if(v[P]===n[S]||v[P]==="*")P++;else if(v[P]!=="**")return!1;return P===v.length}}}function m(i,o=[],n=j.DEFAULT){let s=null,t=[];const r=[];function a(v){Array.isArray(t)?t.push(v):s!==null&&(t[s]=v)}return f(i,{onObjectBegin:()=>{const v={};a(v),r.push(t),t=v,s=null},onObjectProperty:v=>{s=v},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const v=[];a(v),r.push(t),t=v,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(v,P,S)=>{o.push({error:v,offset:P,length:S})}},n),t[0]}function u(i,o=[],n=j.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(v){s.type==="property"&&(s.length=v-s.offset,s=s.parent)}function r(v){return s.children.push(v),v}f(i,{onObjectBegin:v=>{s=r({type:"object",offset:v,length:-1,parent:s,children:[]})},onObjectProperty:(v,P,S)=>{s=r({type:"property",offset:P,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:v,offset:P,length:S,parent:s})},onObjectEnd:(v,P)=>{s.length=v+P-s.offset,s=s.parent,t(v+P)},onArrayBegin:(v,P)=>{s=r({type:"array",offset:v,length:-1,parent:s,children:[]})},onArrayEnd:(v,P)=>{s.length=v+P-s.offset,s=s.parent,t(v+P)},onLiteralValue:(v,P,S)=>{r({type:d(v),offset:P,length:S,parent:s,value:v}),t(P+S)},onSeparator:(v,P,S)=>{s.type==="property"&&(v===":"?s.colonOffset=P:v===","&&t(P))},onError:(v,P,S)=>{o.push({error:v,offset:P,length:S})}},n);const y=s.children[0];return y&&delete y.parent,y}function l(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function w(i){if(!i.parent||!i.parent.children)return[];const o=w(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}function p(i){switch(i.type){case"array":return i.children.map(p);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=p(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function h(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}function g(i,o,n=!1){if(h(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=g(s[t],o,n);if(r)return r}return i}}function f(i,o,n=j.DEFAULT){const s=A(i,!1);function t(he){return he?()=>he(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(he){return he?te=>he(te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),y=r(o.onObjectProperty),v=t(o.onObjectEnd),P=t(o.onArrayBegin),S=t(o.onArrayEnd),k=r(o.onLiteralValue),D=r(o.onSeparator),T=t(o.onComment),F=r(o.onError),U=n&&n.disallowComments,Q=n&&n.allowTrailingComma;function G(){for(;;){const he=s.scan();switch(s.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:U||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(he){case 12:case 13:U?Y(10):T();break;case 16:Y(1);break;case 15:case 14:break;default:return he}}}function Y(he,te=[],V=[]){if(F(he),te.length+V.length>0){let z=s.getToken();for(;z!==17;){if(te.indexOf(z)!==-1){G();break}else if(V.indexOf(z)!==-1)break;z=G()}}}function W(he){const te=s.getTokenValue();return he?k(te):y(te),G(),!0}function J(){switch(s.getToken()){case 11:{let he=0;try{he=JSON.parse(s.getTokenValue()),typeof he!="number"&&(Y(2),he=0)}catch{Y(2)}k(he);break}case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return G(),!0}function H(){return s.getToken()!==10?(Y(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(D(":"),G(),re()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function B(){a(),G();let he=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(he||Y(4,[],[]),D(","),G(),s.getToken()===2&&Q)break}else he&&Y(6,[],[]);H()||Y(4,[],[2,5]),he=!0}return v(),s.getToken()!==2?Y(7,[2],[]):G(),!0}function ie(){P(),G();let he=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(he||Y(4,[],[]),D(","),G(),s.getToken()===4&&Q)break}else he&&Y(6,[],[]);re()||Y(4,[],[4,5]),he=!0}return S(),s.getToken()!==4?Y(8,[4],[]):G(),!0}function re(){switch(s.getToken()){case 3:return ie();case 1:return B();case 10:return W(!0);default:return J()}}return G(),s.getToken()===17?n.allowEmptyContent?!0:(Y(4,[],[]),!1):re()?(s.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}function c(i,o){const n=A(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}function d(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ae[43],ce([0,1,35]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=N,e.$Pn=L,e.$Qn=I,e.$Rn=C;function N($,E,b){let m,u,l,w,p;if(E){for(w=E.offset,p=w+E.length,l=w;l>0&&!C($,l-1);)l--;let a=p;for(;a<$.length&&!C($,a);)a++;u=$.substring(l,a),m=A(u,b)}else u=$,m=0,l=0,w=0,p=$.length;const h=I(b,$);let g=!1,f=0,c;b.insertSpaces?c=j(" ",b.tabSize||4):c="	";const d=(0,R.$Cn)(u,!1);let i=!1;function o(){return h+j(c,m+f)}function n(){let a=d.scan();for(g=!1;a===15||a===14;)g=g||a===14,a=d.scan();return i=a===16||d.getTokenError()!==0,a}const s=[];function t(a,y,v){!i&&y<p&&v>w&&$.substring(y,v)!==a&&s.push({offset:y,length:v-y,content:a})}let r=n();if(r!==17){const a=d.getTokenOffset()+l,y=j(c,m);t(y,l,a)}for(;r!==17;){let a=d.getTokenOffset()+d.getTokenLength()+l,y=n(),v="";for(;!g&&(y===12||y===13);){const S=d.getTokenOffset()+l;t(" ",a,S),a=d.getTokenOffset()+d.getTokenLength()+l,v=y===12?o():"",y=n()}if(y===2)r!==1&&(f--,v=o());else if(y===4)r!==3&&(f--,v=o());else{switch(r){case 3:case 1:f++,v=o();break;case 5:case 12:v=o();break;case 13:g?v=o():v=" ";break;case 6:v=" ";break;case 10:if(y===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?v=" ":y!==5&&y!==17&&(i=!0);break;case 16:i=!0;break}g&&(y===12||y===13)&&(v=o())}const P=d.getTokenOffset()+l;t(v,a,P),r=y}return s}function L($,E){const b=JSON.stringify($,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?b.replace(/\r\n|\r|\n/g,E.eol):b}function j($,E){let b="";for(let m=0;m<E;m++)b+=$;return b}function A($,E){let b=0,m=0;const u=E.tabSize||4;for(;b<$.length;){const l=$.charAt(b);if(l===" ")m++;else if(l==="	")m+=u;else break;b++}return Math.floor(m/u)}function I($,E){for(let b=0;b<E.length;b++){const m=E.charAt(b);if(m==="\r")return b+1<E.length&&E.charAt(b+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return $&&$.eol||`
`}function C($,E){return`\r
`.indexOf($.charAt(E))!==-1}}),define(ae[62],ce([0,1,35,43]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=L,e.$Tn=j,e.$Un=A,e.$Vn=I,e.$Wn=C;function L($,E,b){return j($,E,void 0,b)}function j($,E,b,m,u){const l=E.slice(),w=[],p=(0,R.$Fn)($,w);let h,g;for(;l.length>0&&(g=l.pop(),h=(0,R.$Gn)(p,l),h===void 0&&b!==void 0);)typeof g=="string"?b={[g]:b}:b=[b];if(h)if(h.type==="object"&&typeof g=="string"&&Array.isArray(h.children)){const f=(0,R.$Gn)(h,[g]);if(f!==void 0)if(b===void 0){if(!f.parent)throw new Error("Malformed AST");const c=h.children.indexOf(f.parent);let d,i=f.parent.offset+f.parent.length;if(c>0){const o=h.children[c-1];d=o.offset+o.length}else d=h.offset+1,h.children.length>1&&(i=h.children[1].offset);return A($,{offset:d,length:i-d,content:""},m)}else return A($,{offset:f.offset,length:f.length,content:JSON.stringify(b)},m);else{if(b===void 0)return[];const c=`${JSON.stringify(g)}: ${JSON.stringify(b)}`,d=u?u(h.children.map(o=>o.children[0].value)):h.children.length;let i;if(d>0){const o=h.children[d-1];i={offset:o.offset+o.length,length:0,content:","+c}}else h.children.length===0?i={offset:h.offset+1,length:0,content:c}:i={offset:h.offset+1,length:0,content:c+","};return A($,i,m)}}else if(h.type==="array"&&typeof g=="number"&&Array.isArray(h.children))if(b!==void 0){const f=`${JSON.stringify(b)}`;let c;if(h.children.length===0||g===0)c={offset:h.offset+1,length:0,content:h.children.length===0?f:f+","};else{const d=g===-1||g>h.children.length?h.children.length:g,i=h.children[d-1];c={offset:i.offset+i.length,length:0,content:","+f}}return A($,c,m)}else{const f=g,c=h.children[f];let d;if(h.children.length===1)d={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===f){const i=h.children[f-1],o=i.offset+i.length,n=h.offset+h.length;d={offset:o,length:n-2-o,content:""}}else d={offset:c.offset,length:h.children[f+1].offset-c.offset,content:""};return A($,d,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${h.type}`);else return b===void 0?[]:A($,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(b)},m)}function A($,E,b){let m=I($,E),u=E.offset,l=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;u>0&&!(0,N.$Rn)(m,u-1);)u--;for(;l<m.length&&!(0,N.$Rn)(m,l);)l++}const w=(0,N.$On)(m,{offset:u,length:l-u},b);for(let h=w.length-1;h>=0;h--){const g=w[h];m=I(m,g),u=Math.min(u,g.offset),l=Math.max(l,g.offset+g.length),l+=g.content.length-g.length}const p=$.length-(m.length-l)-u;return[{offset:u,length:p,content:m.substring(u,l)}]}function I($,E){return $.substring(0,E.offset)+E.content+$.substring(E.offset+E.length)}function C($,E){const b=E.slice(0).sort((u,l)=>{const w=u.offset-l.offset;return w===0?u.length-l.length:w});let m=$.length;for(let u=b.length-1;u>=0;u--){const l=b[u];if(l.offset+l.length<=m)$=I($,l);else throw new Error("Overlapping edit");m=l.offset}return $}}),define(ae[53],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class R{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=R}),define(ae[86],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class R{static{this.Undefined=new R(void 0)}constructor(j){this.element=j,this.next=R.Undefined,this.prev=R.Undefined}}class N{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let j=this.a;for(;j!==R.Undefined;){const A=j.next;j.prev=R.Undefined,j.next=R.Undefined,j=A}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,A){const I=new R(j);if(this.a===R.Undefined)this.a=I,this.b=I;else if(A){const $=this.b;this.b=I,I.prev=$,$.next=I}else{const $=this.a;this.a=I,I.next=$,$.prev=I}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(I))}}shift(){if(this.a!==R.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==R.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==R.Undefined&&j.next!==R.Undefined){const A=j.prev;A.next=j.next,j.next.prev=A}else j.prev===R.Undefined&&j.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):j.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):j.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==R.Undefined;)yield j.element,j=j.next}}e.$5c=N}),define(ae[34],ce([0,1]),function(ne,e){"use strict";var R,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=j,e.$zc=A,e.$Ac=I,e.$Ic=g;function j(f,c,d){let i=f.get(c);return i===void 0&&(i=d,f.set(c,i)),i}function A(f){const c=[];return f.forEach((d,i)=>{c.push(`${i} => ${d}`)}),`Map(${f.size}) {${c.join(", ")}}`}function I(f){const c=[];return f.forEach(d=>{c.push(d)}),`Set(${f.size}) {${c.join(", ")}}`}class C{constructor(c,d){this.uri=c,this.value=d}}function $(f){return Array.isArray(f)}class E{static{this.c=c=>c.toString()}constructor(c,d){if(this[R]="ResourceMap",c instanceof E)this.d=new Map(c.d),this.e=d??E.c;else if($(c)){this.d=new Map,this.e=d??E.c;for(const[i,o]of c)this.set(i,o)}else this.d=new Map,this.e=c??E.c}set(c,d){return this.d.set(this.e(c),new C(c,d)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,d){typeof d<"u"&&(c=c.bind(d));for(const[i,o]of this.d)c(o.value,o.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}e.$Bc=E;class b{constructor(c,d){this[N]="ResourceSet",!c||typeof c=="function"?this.c=new E(c):(this.c=new E(d),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,d){this.c.forEach((i,o)=>c.call(d,o,o,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=b;var m;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class u{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,d=0){const i=this.c.get(c);if(i)return d!==0&&this.l(i,d),i.value}set(c,d,i=0){let o=this.c.get(c);if(o)o.value=d,i!==0&&this.l(o,i);else{switch(o={key:c,value:d,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(c,o),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const d=this.c.get(c);if(d)return this.c.delete(c),this.k(d),this.f--,d.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,d){const i=this.g;let o=this.d;for(;o;){if(d?c.bind(d)(o.value,o.key,this):c(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,d=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==d)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,d=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==d)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,d=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==d)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let d=this.d,i=this.size;for(;d&&i>c;)this.c.delete(d.key),d=d.next,i--;this.d=d,this.f=i,d&&(d.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const d=c.next,i=c.previous;if(!d||!i)throw new Error("Invalid list");d.previous=i,i.next=d}c.next=void 0,c.previous=void 0,this.g++}l(c,d){if(!this.d||!this.e)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(c===this.d)return;const i=c.next,o=c.previous;c===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(d===2){if(c===this.e)return;const i=c.next,o=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((d,i)=>{c.push([i,d])}),c}fromJSON(c){this.clear();for(const[d,i]of c)this.set(d,i)}}e.$Dc=u;class l extends u{constructor(c,d=1){super(),this.m=c,this.n=Math.min(Math.max(0,d),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,d=2){return super.get(c,d)}peek(c){return super.get(c,0)}set(c,d){return super.set(c,d,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=l;class w{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let d=this.c.get(c)||0;return d===0?!1:(d--,d===0?this.c.delete(c):this.c.set(c,d),!0)}has(c){return this.c.has(c)}}e.$Fc=w;class p{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[d,i]of c)this.set(d,i)}clear(){this.c.clear(),this.d.clear()}set(c,d){this.c.set(c,d),this.d.set(d,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const d=this.c.get(c);return d===void 0?!1:(this.c.delete(c),this.d.delete(d),!0)}forEach(c,d){this.c.forEach((i,o)=>{c.call(d,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=p;class h{constructor(){this.c=new Map}add(c,d){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add(d)}delete(c,d){const i=this.c.get(c);i&&(i.delete(d),i.size===0&&this.c.delete(c))}forEach(c,d){const i=this.c.get(c);i&&i.forEach(d)}get(c){const d=this.c.get(c);return d||new Set}}e.$Hc=h;function g(f,c){if(f===c)return!0;if(f.size!==c.size)return!1;for(const[d,i]of f)if(!c.has(d)||c.get(d)!==i)return!1;for(const[d]of c)if(!f.has(d))return!1;return!0}}),define(ae[2],ce([0,1,17,126,34,85,61]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=E,e.$Lc=b,e.$Mc=m,e.$Nc=w,e.$Oc=p,e.$Pc=h,e.$Qc=g,e.$Rc=f,e.$Sc=c,e.$3c=v;const I=!1;let C=null;class ${constructor(){this.b=new Map}static{this.a=0}c(k){let D=this.b.get(k);return D||(D={parent:null,source:null,isSingleton:!1,value:k,idx:$.a++},this.b.set(k,D)),D}trackDisposable(k){const D=this.c(k);D.source||(D.source=new Error().stack)}setParent(k,D){const T=this.c(k);T.parent=D}markAsDisposed(k){this.b.delete(k)}markAsSingleton(k){this.c(k).isSingleton=!0}f(k,D){const T=D.get(k);if(T)return T;const F=k.parent?this.f(this.c(k.parent),D):k;return D.set(k,F),F}getTrackedDisposables(){const k=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,k).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(k=10,D){let T;if(D)T=D;else{const Y=new Map,W=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,Y).isSingleton);if(W.length===0)return;const J=new Set(W.map(H=>H.value));if(T=W.filter(H=>!(H.parent&&J.has(H.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function F(Y){function W(H,B){for(;H.length>0&&B.some(ie=>typeof ie=="string"?ie===H[0]:H[0].match(ie));)H.shift()}const J=Y.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return W(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const U=new L.$Hc;for(const Y of T){const W=F(Y);for(let J=0;J<=W.length;J++)U.add(W.slice(0,J).join(`
`),Y)}T.sort((0,R.$7b)(Y=>Y.idx,R.$9b));let Q="",G=0;for(const Y of T.slice(0,k)){G++;const W=F(Y),J=[];for(let H=0;H<W.length;H++){let B=W[H];B=`(shared with ${U.get(W.slice(0,H+1).join(`
`)).size}/${T.length} leaks) at ${B}`;const re=U.get(W.slice(0,H).join(`
`)),he=(0,N.$K)([...re].map(te=>F(te)[H]),te=>te);delete he[W[H]];for(const[te,V]of Object.entries(he))J.unshift(`    - stacktraces of ${V.length} other leaks continue with ${te}`);J.unshift(B)}Q+=`


==================== Leaking disposable ${G}/${T.length}: ${Y.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return T.length>k&&(Q+=`


... and ${T.length-k} more leaking disposables

`),{leaks:T,details:Q}}}e.$Jc=$;function E(S){C=S}if(I){const S="__is_disposable_tracked__";E(new class{trackDisposable(k){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{k[S]||console.log(D)},3e3)}setParent(k,D){if(k&&k!==i.None)try{k[S]=!0}catch{}}markAsDisposed(k){if(k&&k!==i.None)try{k[S]=!0}catch{}}markAsSingleton(k){}})}function b(S){return C?.trackDisposable(S),S}function m(S){C?.markAsDisposed(S)}function u(S,k){C?.setParent(S,k)}function l(S,k){if(C)for(const D of S)C.setParent(D,k)}function w(S){return C?.markAsSingleton(S),S}function p(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function h(S){if(A.Iterable.is(S)){const k=[];for(const D of S)if(D)try{D.dispose()}catch(T){k.push(T)}if(k.length===1)throw k[0];if(k.length>1)throw new AggregateError(k,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function g(S){for(const k of S)p(k)&&k.dispose();return[]}function f(...S){const k=c(()=>h(S));return l(S,k),k}function c(S){const k=b({dispose:(0,j.$db)(()=>{m(k),S()})});return k}class d{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(k){if(!k)return k;if(k===this)throw new Error("Cannot register a disposable on itself!");return u(k,this),this.g?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(k),k}delete(k){if(k){if(k===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(k),k.dispose()}}deleteAndLeak(k){k&&this.f.has(k)&&(this.f.delete(k),u(k,null))}}e.$Tc=d;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new d,b(this),u(this.q,this)}dispose(){m(this),this.q.dispose()}B(k){if(k===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(k)}}e.$Uc=i;class o{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(k){this.b||k===this.a||(this.a?.dispose(),k&&u(k,this),this.a=k)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const k=this.a;return this.a=void 0,k&&u(k,null),k}}e.$Vc=o;class n{constructor(k){this.a=new o,this.b=!1,this.a.value=k}get value(){return this.a.value}set value(k){this.b||k===this.a.value||(this.a.value=k)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=n;class s{constructor(k){this.b=k,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(k){let D=k;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,m(this))},this}}e.$Yc=t;class r{constructor(){this.a=new Map}acquire(k,...D){let T=this.a.get(k);T||(T={counter:0,object:this.b(k,...D)},this.a.set(k,T));const{object:F}=T,U=(0,j.$db)(()=>{--T.counter===0&&(this.c(k,T.object),this.a.delete(k))});return T.counter++,{object:F,dispose:U}}}e.$Zc=r;class a{constructor(k){this.a=k}async acquire(k,...D){const T=this.a.acquire(k,...D);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(F){throw T.dispose(),F}}}e.$1c=a;class y{constructor(k){this.object=k}dispose(){}}e.$2c=y;function v(S){const k=new d;try{S(k)}finally{k.dispose()}}class P{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(k){return this.a.has(k)}get size(){return this.a.size}get(k){return this.a.get(k)}set(k,D,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(k)?.dispose(),this.a.set(k,D)}deleteAndDispose(k){this.a.get(k)?.dispose(),this.a.delete(k)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=P}),define(ae[87],ce([0,1,34]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=void 0,e.$9l=L,e.$0l=A;const N=new R.$Ec(1e4);function L($){return C($,"NFC",N)}const j=new R.$Ec(1e4);function A($){return C($,"NFD",j)}const I=/[^\u0000-\u0080]/;function C($,E,b){if(!$)return $;const m=b.get($);if(m)return m;let u;return I.test($)?u=$.normalize(E):u=$,b.set($,u),u}e.$$l=function(){const $=/[\u0300-\u036f]/g;return function(E){return A(E).replace($,"")}}()}),function(){function ne(L){const j=[];typeof L=="number"&&j.push("code/timeOrigin",L);function A(C){j.push(C,Date.now())}function I(){const C=[];for(let $=0;$<j.length;$+=2)C.push({name:j[$],startTime:j[$+1]});return C}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))j.push({name:A.name,startTime:Math.round(L+A.startTime)});return j}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function R(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=R(N))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var N in R)(typeof exports=="object"?exports:ne)[N]=R[N]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function R(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return ne[N].call(L.exports,L,L.exports,R),L.l=!0,L.exports}return R.m=ne,R.c=e,R.d=function(N,L,j){R.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:j})},R.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},R.t=function(N,L){if(1&L&&(N=R(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var j=Object.create(null);if(R.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var A in N)R.d(j,A,function(I){return N[I]}.bind(null,A));return j},R.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return R.d(L,"a",L),L},R.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},R.p="",R(R.s=0)}([function(ne,e,R){(function(N){var L;e=ne.exports=V,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],C=e.src=[],$=0,E=$++;C[E]="0|[1-9]\\d*";var b=$++;C[b]="[0-9]+";var m=$++;C[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=$++;C[u]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var l=$++;C[l]="("+C[b]+")\\.("+C[b]+")\\.("+C[b]+")";var w=$++;C[w]="(?:"+C[E]+"|"+C[m]+")";var p=$++;C[p]="(?:"+C[b]+"|"+C[m]+")";var h=$++;C[h]="(?:-("+C[w]+"(?:\\."+C[w]+")*))";var g=$++;C[g]="(?:-?("+C[p]+"(?:\\."+C[p]+")*))";var f=$++;C[f]="[0-9A-Za-z-]+";var c=$++;C[c]="(?:\\+("+C[f]+"(?:\\."+C[f]+")*))";var d=$++,i="v?"+C[u]+C[h]+"?"+C[c]+"?";C[d]="^"+i+"$";var o="[v=\\s]*"+C[l]+C[g]+"?"+C[c]+"?",n=$++;C[n]="^"+o+"$";var s=$++;C[s]="((?:<|>)?=?)";var t=$++;C[t]=C[b]+"|x|X|\\*";var r=$++;C[r]=C[E]+"|x|X|\\*";var a=$++;C[a]="[v=\\s]*("+C[r]+")(?:\\.("+C[r]+")(?:\\.("+C[r]+")(?:"+C[h]+")?"+C[c]+"?)?)?";var y=$++;C[y]="[v=\\s]*("+C[t]+")(?:\\.("+C[t]+")(?:\\.("+C[t]+")(?:"+C[g]+")?"+C[c]+"?)?)?";var v=$++;C[v]="^"+C[s]+"\\s*"+C[a]+"$";var P=$++;C[P]="^"+C[s]+"\\s*"+C[y]+"$";var S=$++;C[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var k=$++;C[k]="(?:~>?)";var D=$++;C[D]="(\\s*)"+C[k]+"\\s+",I[D]=new RegExp(C[D],"g");var T=$++;C[T]="^"+C[k]+C[a]+"$";var F=$++;C[F]="^"+C[k]+C[y]+"$";var U=$++;C[U]="(?:\\^)";var Q=$++;C[Q]="(\\s*)"+C[U]+"\\s+",I[Q]=new RegExp(C[Q],"g");var G=$++;C[G]="^"+C[U]+C[a]+"$";var Y=$++;C[Y]="^"+C[U]+C[y]+"$";var W=$++;C[W]="^"+C[s]+"\\s*("+o+")$|^$";var J=$++;C[J]="^"+C[s]+"\\s*("+i+")$|^$";var H=$++;C[H]="(\\s*)"+C[s]+"\\s*("+o+"|"+C[a]+")",I[H]=new RegExp(C[H],"g");var B=$++;C[B]="^\\s*("+C[a]+")\\s+-\\s+("+C[a]+")\\s*$";var ie=$++;C[ie]="^\\s*("+C[y]+")\\s+-\\s+("+C[y]+")\\s*$";var re=$++;C[re]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)L(he,C[he]),I[he]||(I[he]=new RegExp(C[he]));function te(le,me){if(le instanceof V)return le;if(typeof le!="string"||le.length>j||!(me?I[n]:I[d]).test(le))return null;try{return new V(le,me)}catch{return null}}function V(le,me){if(le instanceof V){if(le.loose===me)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof V))return new V(le,me);L("SemVer",le,me),this.loose=me;var pe=le.trim().match(me?I[n]:I[d]);if(!pe)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<A)return Re}return Pe}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=te,e.valid=function(le,me){var pe=te(le,me);return pe?pe.version:null},e.clean=function(le,me){var pe=te(le.trim().replace(/^[=v]+/,""),me);return pe?pe.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(le){return L("SemVer.compare",this.version,this.loose,le),le instanceof V||(le=new V(le,this.loose)),this.compareMain(le)||this.comparePre(le)},V.prototype.compareMain=function(le){return le instanceof V||(le=new V(le,this.loose)),O(this.major,le.major)||O(this.minor,le.minor)||O(this.patch,le.patch)},V.prototype.comparePre=function(le){if(le instanceof V||(le=new V(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var me=0;do{var pe=this.prerelease[me],Pe=le.prerelease[me];if(L("prerelease compare",me,pe,Pe),pe===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(pe===void 0)return-1;if(pe!==Pe)return O(pe,Pe)}while(++me)},V.prototype.inc=function(le,me){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,me,pe,Pe){typeof pe=="string"&&(Pe=pe,pe=void 0);try{return new V(le,pe).inc(me,Pe).version}catch{return null}},e.diff=function(le,me){if(K(le,me))return null;var pe=te(le),Pe=te(me);if(pe.prerelease.length||Pe.prerelease.length){for(var Re in pe)if((Re==="major"||Re==="minor"||Re==="patch")&&pe[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in pe)if((Re==="major"||Re==="minor"||Re==="patch")&&pe[Re]!==Pe[Re])return Re},e.compareIdentifiers=O;var z=/^[0-9]+$/;function O(le,me){var pe=z.test(le),Pe=z.test(me);return pe&&Pe&&(le=+le,me=+me),pe&&!Pe?-1:Pe&&!pe?1:le<me?-1:le>me?1:0}function M(le,me,pe){return new V(le,pe).compare(new V(me,pe))}function q(le,me,pe){return M(le,me,pe)>0}function x(le,me,pe){return M(le,me,pe)<0}function K(le,me,pe){return M(le,me,pe)===0}function ee(le,me,pe){return M(le,me,pe)!==0}function _(le,me,pe){return M(le,me,pe)>=0}function Z(le,me,pe){return M(le,me,pe)<=0}function se(le,me,pe,Pe){var Re;switch(me){case"===":typeof le=="object"&&(le=le.version),typeof pe=="object"&&(pe=pe.version),Re=le===pe;break;case"!==":typeof le=="object"&&(le=le.version),typeof pe=="object"&&(pe=pe.version),Re=le!==pe;break;case"":case"=":case"==":Re=K(le,pe,Pe);break;case"!=":Re=ee(le,pe,Pe);break;case">":Re=q(le,pe,Pe);break;case">=":Re=_(le,pe,Pe);break;case"<":Re=x(le,pe,Pe);break;case"<=":Re=Z(le,pe,Pe);break;default:throw new TypeError("Invalid operator: "+me)}return Re}function ue(le,me){if(le instanceof ue){if(le.loose===me)return le;le=le.value}if(!(this instanceof ue))return new ue(le,me);L("comparator",le,me),this.loose=me,this.parse(le),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(le,me){return O(me,le)},e.major=function(le,me){return new V(le,me).major},e.minor=function(le,me){return new V(le,me).minor},e.patch=function(le,me){return new V(le,me).patch},e.compare=M,e.compareLoose=function(le,me){return M(le,me,!0)},e.rcompare=function(le,me,pe){return M(me,le,pe)},e.sort=function(le,me){return le.sort(function(pe,Pe){return e.compare(pe,Pe,me)})},e.rsort=function(le,me){return le.sort(function(pe,Pe){return e.rcompare(pe,Pe,me)})},e.gt=q,e.lt=x,e.eq=K,e.neq=ee,e.gte=_,e.lte=Z,e.cmp=se,e.Comparator=ue;var ge={};function fe(le,me){if(le instanceof fe)return le.loose===me?le:new fe(le.raw,me);if(le instanceof ue)return new fe(le.value,me);if(!(this instanceof fe))return new fe(le,me);if(this.loose=me,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function $e(le){return!le||le.toLowerCase()==="x"||le==="*"}function ye(le,me,pe,Pe,Re,Te,De,Ue,Me,qe,ze,je,oe){return((me=$e(pe)?"":$e(Pe)?">="+pe+".0.0":$e(Re)?">="+pe+"."+Pe+".0":">="+me)+" "+(Ue=$e(Me)?"":$e(qe)?"<"+(+Me+1)+".0.0":$e(ze)?"<"+Me+"."+(+qe+1)+".0":je?"<="+Me+"."+qe+"."+ze+"-"+je:"<="+Ue)).trim()}function ve(le,me){for(var pe=0;pe<le.length;pe++)if(!le[pe].test(me))return!1;if(me.prerelease.length){for(pe=0;pe<le.length;pe++)if(L(le[pe].semver),le[pe].semver!==ge&&le[pe].semver.prerelease.length>0){var Pe=le[pe].semver;if(Pe.major===me.major&&Pe.minor===me.minor&&Pe.patch===me.patch)return!0}return!1}return!0}function Ce(le,me,pe){try{me=new fe(me,pe)}catch{return!1}return me.test(le)}function Ae(le,me,pe,Pe){var Re,Te,De,Ue,Me;switch(le=new V(le,Pe),me=new fe(me,Pe),pe){case">":Re=q,Te=Z,De=x,Ue=">",Me=">=";break;case"<":Re=x,Te=_,De=q,Ue="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(le,me,Pe))return!1;for(var qe=0;qe<me.set.length;++qe){var ze=me.set[qe],je=null,oe=null;if(ze.forEach(function(de){de.semver===ge&&(de=new ue(">=0.0.0")),je=je||de,oe=oe||de,Re(de.semver,je.semver,Pe)?je=de:De(de.semver,oe.semver,Pe)&&(oe=de)}),je.operator===Ue||je.operator===Me||(!oe.operator||oe.operator===Ue)&&Te(le,oe.semver)||oe.operator===Me&&De(le,oe.semver))return!1}return!0}ue.prototype.parse=function(le){var me=this.loose?I[W]:I[J],pe=le.match(me);if(!pe)throw new TypeError("Invalid comparator: "+le);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new V(pe[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(le){return L("Comparator.test",le,this.loose),this.semver===ge||(typeof le=="string"&&(le=new V(le,this.loose)),se(le,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(le,me){if(!(le instanceof ue))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new fe(le.value,me),Ce(this.value,pe,me);if(le.operator==="")return pe=new fe(this.value,me),Ce(le.semver,pe,me);var Pe=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Te=this.semver.version===le.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Ue=se(this.semver,"<",le.semver,me)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Me=se(this.semver,">",le.semver,me)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Pe||Re||Te&&De||Ue||Me},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(le){var me=this.loose;le=le.trim(),L("range",le,me);var pe=me?I[ie]:I[B];le=le.replace(pe,ye),L("hyphen replace",le),le=le.replace(I[H],"$1$2$3"),L("comparator trim",le,I[H]),le=(le=(le=le.replace(I[D],"$1~")).replace(I[Q],"$1^")).split(/\s+/).join(" ");var Pe=me?I[W]:I[J],Re=le.split(" ").map(function(Te){return function(De,Ue){return L("comp",De),De=function(Me,qe){return Me.trim().split(/\s+/).map(function(ze){return function(je,oe){L("caret",je,oe);var de=oe?I[Y]:I[G];return je.replace(de,function(we,be,Se,Ie,Oe){var Ne;return L("caret",je,we,be,Se,Ie,Oe),$e(be)?Ne="":$e(Se)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":$e(Ie)?Ne=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":Oe?(L("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+Oe+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+Oe+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+Oe+" <"+(+be+1)+".0.0"):(L("no pr"),Ne=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+" <"+(+be+1)+".0.0"),L("caret return",Ne),Ne})}(ze,qe)}).join(" ")}(De,Ue),L("caret",De),De=function(Me,qe){return Me.trim().split(/\s+/).map(function(ze){return function(je,oe){var de=oe?I[F]:I[T];return je.replace(de,function(we,be,Se,Ie,Oe){var Ne;return L("tilde",je,we,be,Se,Ie,Oe),$e(be)?Ne="":$e(Se)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":$e(Ie)?Ne=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":Oe?(L("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=">="+be+"."+Se+"."+Ie+Oe+" <"+be+"."+(+Se+1)+".0"):Ne=">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0",L("tilde return",Ne),Ne})}(ze,qe)}).join(" ")}(De,Ue),L("tildes",De),De=function(Me,qe){return L("replaceXRanges",Me,qe),Me.split(/\s+/).map(function(ze){return function(je,oe){je=je.trim();var de=oe?I[P]:I[v];return je.replace(de,function(we,be,Se,Ie,Oe,Ne){L("xRange",je,we,be,Se,Ie,Oe,Ne);var We=$e(Se),Be=We||$e(Ie),Fe=Be||$e(Oe);return be==="="&&Fe&&(be=""),We?we=be===">"||be==="<"?"<0.0.0":"*":be&&Fe?(Be&&(Ie=0),Fe&&(Oe=0),be===">"?(be=">=",Be?(Se=+Se+1,Ie=0,Oe=0):Fe&&(Ie=+Ie+1,Oe=0)):be==="<="&&(be="<",Be?Se=+Se+1:Ie=+Ie+1),we=be+Se+"."+Ie+"."+Oe):Be?we=">="+Se+".0.0 <"+(+Se+1)+".0.0":Fe&&(we=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0"),L("xRange return",we),we})}(ze,qe)}).join(" ")}(De,Ue),L("xrange",De),De=function(Me,qe){return L("replaceStars",Me,qe),Me.trim().replace(I[re],"")}(De,Ue),L("stars",De),De}(Te,me)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Te){return!!Te.match(Pe)})),Re=Re.map(function(Te){return new ue(Te,me)})},fe.prototype.intersects=function(le,me){if(!(le instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(Pe){return le.set.some(function(Re){return Re.every(function(Te){return Pe.intersects(Te,me)})})})})},e.toComparators=function(le,me){return new fe(le,me).set.map(function(pe){return pe.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new V(le,this.loose));for(var me=0;me<this.set.length;me++)if(ve(this.set[me],le))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(le,me,pe){var Pe=null,Re=null;try{var Te=new fe(me,pe)}catch{return null}return le.forEach(function(De){Te.test(De)&&(Pe&&Re.compare(De)!==-1||(Re=new V(Pe=De,pe)))}),Pe},e.minSatisfying=function(le,me,pe){var Pe=null,Re=null;try{var Te=new fe(me,pe)}catch{return null}return le.forEach(function(De){Te.test(De)&&(Pe&&Re.compare(De)!==1||(Re=new V(Pe=De,pe)))}),Pe},e.validRange=function(le,me){try{return new fe(le,me).range||"*"}catch{return null}},e.ltr=function(le,me,pe){return Ae(le,me,"<",pe)},e.gtr=function(le,me,pe){return Ae(le,me,">",pe)},e.outside=Ae,e.prerelease=function(le,me){var pe=te(le,me);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(le,me,pe){return le=new fe(le,pe),me=new fe(me,pe),le.intersects(me)},e.coerce=function(le){if(le instanceof V)return le;if(typeof le!="string")return null;var me=le.match(I[S]);return me==null?null:te((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,R(1))},function(ne,e){var R,N,L=ne.exports={};function j(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(p){if(R===setTimeout)return setTimeout(p,0);if((R===j||!R)&&setTimeout)return R=setTimeout,setTimeout(p,0);try{return R(p,0)}catch{try{return R.call(null,p,0)}catch{return R.call(this,p,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:j}catch{R=j}try{N=typeof clearTimeout=="function"?clearTimeout:A}catch{N=A}})();var C,$=[],E=!1,b=-1;function m(){E&&C&&(E=!1,C.length?$=C.concat($):b=-1,$.length&&u())}function u(){if(!E){var p=I(m);E=!0;for(var h=$.length;h;){for(C=$,$=[];++b<h;)C&&C[b].run();b=-1,h=$.length}C=null,E=!1,function(g){if(N===clearTimeout)return clearTimeout(g);if((N===A||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(g);try{N(g)}catch{try{return N.call(null,g)}catch{return N.call(this,g)}}}(p)}}function l(p,h){this.fun=p,this.array=h}function w(){}L.nextTick=function(p){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];$.push(new l(p,h)),$.length!==1||E||I(u)},l.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=w,L.addListener=w,L.once=w,L.off=w,L.removeListener=w,L.removeAllListeners=w,L.emit=w,L.prependListener=w,L.prependOnceListener=w,L.listeners=function(p){return[]},L.binding=function(p){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(p){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ae[128],ce([0,1]),function(ne,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=void 0;class N{constructor(I,C,$){this.level=I,this.key=C,this.value=$,this.forward=[]}}const L=void 0;class j{constructor(I,C=2**16){this.comparator=I,this[R]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new N(this.c,L,L)}get size(){return this.f}clear(){this.e=new N(this.c,L,L),this.f=0}has(I){return!!j.g(this,I,this.comparator)}get(I){return j.g(this,I,this.comparator)?.value}set(I,C){return j.h(this,I,C,this.comparator)&&(this.f+=1),this}delete(I){const C=j.k(this,I,this.comparator);return C&&(this.f-=1),C}forEach(I,C){let $=this.e.forward[0];for(;$;)I.call(C,$.value,$.key,this),$=$.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",C=this.e.forward[0];for(;C;)I+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return I}static g(I,C,$){let E=I.e;for(let b=I.d-1;b>=0;b--)for(;E.forward[b]&&$(E.forward[b].key,C)<0;)E=E.forward[b];if(E=E.forward[0],E&&$(E.key,C)===0)return E}static h(I,C,$,E){const b=[];let m=I.e;for(let u=I.d-1;u>=0;u--){for(;m.forward[u]&&E(m.forward[u].key,C)<0;)m=m.forward[u];b[u]=m}if(m=m.forward[0],m&&E(m.key,C)===0)return m.value=$,!1;{const u=j.j(I);if(u>I.d){for(let l=I.d;l<u;l++)b[l]=I.e;I.d=u}m=new N(u,C,$);for(let l=0;l<u;l++)m.forward[l]=b[l].forward[l],b[l].forward[l]=m;return!0}}static j(I,C=.5){let $=1;for(;Math.random()<C&&$<I.c;)$+=1;return $}static k(I,C,$){const E=[];let b=I.e;for(let m=I.d-1;m>=0;m--){for(;b.forward[m]&&$(b.forward[m].key,C)<0;)b=b.forward[m];E[m]=b}if(b=b.forward[0],!b||$(b.key,C)!==0)return!1;for(let m=0;m<I.d&&E[m].forward[m]===b;m++)E[m].forward[m]=b.forward[m];for(;I.d>0&&I.e.forward[I.d-1]===L;)I.d-=1;return!0}}e.$ts=j}),define(ae[63],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(j){return new N(j)}constructor(j){this.c=R&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$0d=N}),define(ae[3],ce([0,1,7,85,2,86,63]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$_d=e.Event=void 0,e.$ae=u;const I=!1,C=!1,$=!1;var E;(function(D){D.None=()=>L.$Uc.None;function T(fe){if($){const{onDidAddListener:$e}=fe,ye=w.create();let ve=0;fe.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ye.print()),$e?.()}}}function F(fe,$e){return re(fe,()=>{},0,void 0,!0,void 0,$e)}D.defer=F;function U(fe){return($e,ye=null,ve)=>{let Ce=!1,Ae;return Ae=fe(le=>{if(!Ce)return Ae?Ae.dispose():Ce=!0,$e.call(ye,le)},null,ve),Ce&&Ae.dispose(),Ae}}D.once=U;function Q(fe,$e,ye){return B((ve,Ce=null,Ae)=>fe(le=>ve.call(Ce,$e(le)),null,Ae),ye)}D.map=Q;function G(fe,$e,ye){return B((ve,Ce=null,Ae)=>fe(le=>{$e(le),ve.call(Ce,le)},null,Ae),ye)}D.forEach=G;function Y(fe,$e,ye){return B((ve,Ce=null,Ae)=>fe(le=>$e(le)&&ve.call(Ce,le),null,Ae),ye)}D.filter=Y;function W(fe){return fe}D.signal=W;function J(...fe){return($e,ye=null,ve)=>{const Ce=(0,L.$Rc)(...fe.map(Ae=>Ae(le=>$e.call(ye,le))));return ie(Ce,ve)}}D.any=J;function H(fe,$e,ye,ve){let Ce=ye;return Q(fe,Ae=>(Ce=$e(Ce,Ae),Ce),ve)}D.reduce=H;function B(fe,$e){let ye;const ve={onWillAddFirstListener(){ye=fe(Ce.fire,Ce)},onDidRemoveLastListener(){ye?.dispose()}};$e||T(ve);const Ce=new d(ve);return $e?.add(Ce),Ce.event}function ie(fe,$e){return $e instanceof Array?$e.push(fe):$e&&$e.add(fe),fe}function re(fe,$e,ye=100,ve=!1,Ce=!1,Ae,le){let me,pe,Pe,Re=0,Te;const De={leakWarningThreshold:Ae,onWillAddFirstListener(){me=fe(Me=>{Re++,pe=$e(pe,Me),ve&&!Pe&&(Ue.fire(pe),pe=void 0),Te=()=>{const qe=pe;pe=void 0,Pe=void 0,(!ve||Re>1)&&Ue.fire(qe),Re=0},typeof ye=="number"?(clearTimeout(Pe),Pe=setTimeout(Te,ye)):Pe===void 0&&(Pe=0,queueMicrotask(Te))})},onWillRemoveListener(){Ce&&Re>0&&Te?.()},onDidRemoveLastListener(){Te=void 0,me.dispose()}};le||T(De);const Ue=new d(De);return le?.add(Ue),Ue.event}D.debounce=re;function he(fe,$e=0,ye){return D.debounce(fe,(ve,Ce)=>ve?(ve.push(Ce),ve):[Ce],$e,void 0,!0,void 0,ye)}D.accumulate=he;function te(fe,$e=(ve,Ce)=>ve===Ce,ye){let ve=!0,Ce;return Y(fe,Ae=>{const le=ve||!$e(Ae,Ce);return ve=!1,Ce=Ae,le},ye)}D.latch=te;function V(fe,$e,ye){return[D.filter(fe,$e,ye),D.filter(fe,ve=>!$e(ve),ye)]}D.split=V;function z(fe,$e=!1,ye=[],ve){let Ce=ye.slice(),Ae=fe(pe=>{Ce?Ce.push(pe):me.fire(pe)});ve&&ve.add(Ae);const le=()=>{Ce?.forEach(pe=>me.fire(pe)),Ce=null},me=new d({onWillAddFirstListener(){Ae||(Ae=fe(pe=>me.fire(pe)),ve&&ve.add(Ae))},onDidAddFirstListener(){Ce&&($e?setTimeout(le):le())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return ve&&ve.add(me),me.event}D.buffer=z;function O(fe,$e){return(ve,Ce,Ae)=>{const le=$e(new q);return fe(function(me){const pe=le.evaluate(me);pe!==M&&ve.call(Ce,pe)},void 0,Ae)}}D.chain=O;const M=Symbol("HaltChainable");class q{constructor(){this.f=[]}map($e){return this.f.push($e),this}forEach($e){return this.f.push(ye=>($e(ye),ye)),this}filter($e){return this.f.push(ye=>$e(ye)?ye:M),this}reduce($e,ye){let ve=ye;return this.f.push(Ce=>(ve=$e(ve,Ce),ve)),this}latch($e=(ye,ve)=>ye===ve){let ye=!0,ve;return this.f.push(Ce=>{const Ae=ye||!$e(Ce,ve);return ye=!1,ve=Ce,Ae?Ce:M}),this}evaluate($e){for(const ye of this.f)if($e=ye($e),$e===M)break;return $e}}function x(fe,$e,ye=ve=>ve){const ve=(...me)=>le.fire(ye(...me)),Ce=()=>fe.on($e,ve),Ae=()=>fe.removeListener($e,ve),le=new d({onWillAddFirstListener:Ce,onDidRemoveLastListener:Ae});return le.event}D.fromNodeEventEmitter=x;function K(fe,$e,ye=ve=>ve){const ve=(...me)=>le.fire(ye(...me)),Ce=()=>fe.addEventListener($e,ve),Ae=()=>fe.removeEventListener($e,ve),le=new d({onWillAddFirstListener:Ce,onDidRemoveLastListener:Ae});return le.event}D.fromDOMEventEmitter=K;function ee(fe){return new Promise($e=>U(fe)($e))}D.toPromise=ee;function _(fe){const $e=new d;return fe.then(ye=>{$e.fire(ye)},()=>{$e.fire(void 0)}).finally(()=>{$e.dispose()}),$e.event}D.fromPromise=_;function Z(fe,$e,ye){return $e(ye),fe(ve=>$e(ve))}D.runAndSubscribe=Z;class se{constructor($e,ye){this._observable=$e,this.f=0,this.g=!1;const ve={onWillAddFirstListener:()=>{$e.addObserver(this)},onDidRemoveLastListener:()=>{$e.removeObserver(this)}};ye||T(ve),this.emitter=new d(ve),ye&&ye.add(this.emitter)}beginUpdate($e){this.f++}handlePossibleChange($e){}handleChange($e,ye){this.g=!0}endUpdate($e){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue(fe,$e){return new se(fe,$e).emitter.event}D.fromObservable=ue;function ge(fe){return($e,ye,ve)=>{let Ce=0,Ae=!1;const le={beginUpdate(){Ce++},endUpdate(){Ce--,Ce===0&&(fe.reportChanges(),Ae&&(Ae=!1,$e.call(ye)))},handlePossibleChange(){},handleChange(){Ae=!0}};fe.addObserver(le),fe.reportChanges();const me={dispose(){fe.removeObserver(le)}};return ve instanceof L.$Tc?ve.add(me):Array.isArray(ve)&&ve.push(me),me}}D.fromObservableLight=ge})(E||(e.Event=E={}));class b{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${b.f++}`,b.all.add(this)}start(T){this.g=new A.$0d,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}e.$_d=b;let m=-1;function u(D){const T=m;return m=D,{dispose(){m=T}}}class l{constructor(T,F=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=F,this.g=0}dispose(){this.f?.clear()}check(T,F){const U=this.threshold;if(U<=0||F<U)return;this.f||(this.f=new Map);const Q=this.f.get(T.value)||0;if(this.f.set(T.value,Q+1),this.g-=1,this.g<=0){this.g=U*.5;let G,Y=0;for(const[W,J]of this.f)(!G||Y<J)&&(G=W,Y=J);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${Y}):`),console.warn(G)}return()=>{const G=this.f.get(T.value)||0;this.f.set(T.value,G-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class h{constructor(T){this.value=T,this.id=p++}}const g=2,f=(D,T)=>{if(D instanceof h)T(D);else for(let F=0;F<D.length;F++){const U=D[F];U&&T(U)}},c=I?new FinalizationRegistry(D=>{typeof D=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(D))}):void 0;class d{constructor(T){this.w=0,this.f=T,this.g=m>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(C){const T=this.t;queueMicrotask(()=>{f(T,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,F,U)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;F&&(T=T.bind(F));const Q=new h(T);let G,Y;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Q.stack=w.create(),G=this.g.check(Q.stack,this.w+1)),C&&(Q.stack=Y??w.create()),this.t?this.t instanceof h?(this.u??=new o,this.t=[this.t,Q]):this.t.push(Q):(this.f?.onWillAddFirstListener?.(this),this.t=Q,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,L.$Sc)(()=>{c?.unregister(W),G?.(),this.x(Q)});if(U instanceof L.$Tc?U.add(W):Array.isArray(U)&&U.push(W),c){const J=new Error().stack.split(`
`).slice(2).join(`
`).trim();c.register(W,J,W)}return W},this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,U=F.indexOf(T);if(U===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[U]=void 0;const Q=this.u.current===this;if(this.w*g<=F.length){let G=0;for(let Y=0;Y<F.length;Y++)F[Y]?F[G++]=F[Y]:Q&&(this.u.end--,G<this.u.i&&this.u.i--);F.length=G}}y(T,F){if(!T)return;const U=this.f?.onListenerError||R.$1;if(!U){T.value(F);return}try{T.value(F)}catch(Q){U(Q)}}z(T){const F=T.current.t;for(;T.i<T.end;)this.y(F[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,T);else{const F=this.u;F.enqueue(this,T,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}e.$be=d;const i=()=>new o;e.$ce=i;class o{constructor(){this.i=-1,this.end=0}enqueue(T,F,U){this.i=0,this.end=U,this.current=T,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends d{async fireAsync(T,F,U){if(this.t)for(this.h||(this.h=new j.$5c),f(this.t,Q=>this.h.push([Q.value,T]));this.h.size>0&&!F.isCancellationRequested;){const[Q,G]=this.h.shift(),Y=[],W={...G,token:F,waitUntil:J=>{if(Object.isFrozen(Y))throw new Error("waitUntil can NOT be called asynchronous");U&&(J=U(J,Q)),Y.push(J)}};try{Q(W)}catch(J){(0,R.$1)(J);continue}Object.freeze(Y),await Promise.allSettled(Y).then(J=>{for(const H of J)H.status==="rejected"&&(0,R.$1)(H.reason)})}}}e.$de=n;class s extends d{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new j.$5c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}e.$ee=s;class t extends s{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}e.$fe=t;class r extends d{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}e.$ge=r;class a{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const F={event:T,listener:null};this.h.push(F),this.g&&this.m(F);const U=()=>{this.g&&this.o(F);const Q=this.h.indexOf(F);this.h.splice(Q,1)};return(0,L.$Sc)((0,N.$db)(U))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(F=>this.f.fire(F))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}e.$he=a;class y{constructor(T,F,U,Q){this.f=new L.$Tc;const G=this.f.add(new a),Y=this.f.add(new L.$4c);function W(J){Y.set(J,G.add(Q(J)))}for(const J of T)W(J);this.f.add(F(J=>{W(J)})),this.f.add(U(J=>{Y.deleteAndDispose(J)})),this.event=G.event}dispose(){this.f.dispose()}}e.$ie=y;class v{constructor(){this.f=[]}wrapEvent(T){return(F,U,Q)=>T(G=>{const Y=this.f[this.f.length-1];Y?Y.push(()=>F.call(U,G)):F.call(U,G)},void 0,Q)}bufferEvents(T){const F=[];this.f.push(F);const U=T();return this.f.pop(),F.forEach(Q=>Q()),U}}e.$je=v;class P{constructor(){this.f=!1,this.g=E.None,this.h=L.$Uc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ke=P;class S{static const(T){return new k(T)}constructor(T){this.g=T,this.f=new d,this.onDidChange=this.f.event}get value(){return this.g}set value(T){T!==this.g&&(this.g=T,this.f.fire(void 0))}}e.$le=S;class k{constructor(T){this.value=T,this.onDidChange=E.None}}}),define(ae[26],ce([0,1,3]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.CancellationToken=void 0;const N=Object.freeze(function(I,C){const $=setTimeout(I.bind(C),0);return{dispose(){clearTimeout($)}}});var L;(function(I){function C($){return $===I.None||$===I.Cancelled||$ instanceof j?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}I.isCancellationToken=C,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new R.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(C){this.f=void 0,this.g=void 0,this.g=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=L.Cancelled}dispose(C=!1){C&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=L.None}}e.$me=A}),define(ae[129],ce([0,1,26]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1e=e.$Ze=e.$Xe=void 0,e.$Ye=L;class N{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new R.$me,$=this.b(C.token);return this.a={promise:$,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}e.$Xe=N;function L(I){return I}class j{constructor(C,$){this.a=void 0,this.b=void 0,typeof C=="function"?(this.c=C,this.d=L):(this.c=$,this.d=C.getCacheKey)}get(C){const $=this.d(C);return this.b!==$&&(this.b=$,this.a=this.c(C)),this.a}}e.$Ze=j;class A{get cachedValues(){return this.a}constructor(C,$){this.a=new Map,this.b=new Map,typeof C=="function"?(this.c=C,this.d=L):(this.c=$,this.d=C.getCacheKey)}get(C){const $=this.d(C);if(this.b.has($))return this.b.get($);const E=this.c(C);return this.a.set(C,E),this.b.set($,E),E}}e.$1e=A}),define(ae[50],ce([0,1,7,2]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=L,e.$oe=j,e.$pe=A,e.$qe=I,e.$re=$,e.$se=E,e.$te=b,e.$ue=m,e.$ve=u,e.$we=l,e.$xe=w,e.$ye=p,e.$ze=h,e.$Ae=g,e.$Be=f;function L(c){const d=c;return d?typeof d.read=="function":!1}function j(c){const d=c;return d?[d.on,d.pause,d.resume,d.destroy].every(i=>typeof i=="function"):!1}function A(c){const d=c;return d?j(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}function I(c,d){return new C(c,d)}class C{constructor(d,i){this.e=d,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(i=>i(d))}h(d){this.c.error.length===0?(0,R.$1)(d):this.c.error.slice(0).forEach(i=>i(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,i){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(d,i){if(this.a.destroyed)return;let o;switch(d){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(c,d){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return d(i)}function E(c,d,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?d(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}function b(c,d){return new Promise((i,o)=>{const n=[];m(c,{onData:s=>{d&&n.push(s)},onError:s=>{d?o(s):i(void 0)},onEnd:()=>{i(d?d(n):void 0)}})})}function m(c,d,i){c.on("error",o=>{i?.isCancellationRequested||d.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||d.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||d.onData(o)})}function u(c,d){return new Promise((i,o)=>{const n=new N.$Tc,s=[],t=y=>{if(s.push(y),s.length>d)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=y=>(n.dispose(),o(y)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,N.$Sc)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,N.$Sc)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,N.$Sc)(()=>c.removeListener("data",t))),c.on("data",t)})}function l(c,d){const i=I(d);return i.end(c),i}function w(){const c=I(()=>{throw new Error("not supported")});return c.end(),c}function p(c){let d=!1;return{read:()=>d?null:(d=!0,c)}}function h(c,d,i){const o=I(i);return m(c,{onData:n=>o.write(d.data(n)),onError:n=>o.error(d.error?d.error(n):n),onEnd:()=>o.end()}),o}function g(c,d,i){let o=!1;return{read:()=>{const n=d.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}function f(c,d,i){let o=!1;const n=I(i);return m(d,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}}),define(ae[15],ce([0,1,53,50]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=$,e.$Ee=E,e.$Fe=b,e.$Ge=m,e.$He=u,e.$Ie=l,e.$Je=w,e.$Ke=p,e.$Le=h,e.$Me=g,e.$Ne=f,e.$Oe=c,e.$Pe=d,e.$Qe=i,e.$Re=o,e.$Se=n,e.$Te=s,e.$Ue=t,e.$Ve=r,e.$We=v;const L=typeof Buffer<"u",j=new R.$V(()=>new Uint8Array(256));let A,I;class C{static alloc(S){return L?new C(Buffer.allocUnsafe(S)):new C(new Uint8Array(S))}static wrap(S){return L&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new C(S)}static fromString(S,k){return!(k?.dontUseNodeBuffer||!1)&&L?new C(Buffer.from(S)):(A||(A=new TextEncoder),new C(A.encode(S)))}static fromByteArray(S){const k=C.alloc(S.length);for(let D=0,T=S.length;D<T;D++)k.buffer[D]=S[D];return k}static concat(S,k){if(typeof k>"u"){k=0;for(let F=0,U=S.length;F<U;F++)k+=S[F].byteLength}const D=C.alloc(k);let T=0;for(let F=0,U=S.length;F<U;F++){const Q=S[F];D.set(Q,T),T+=Q.byteLength}return D}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=C.alloc(this.byteLength);return S.set(this),S}toString(){return L?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(S,k){return new C(this.buffer.subarray(S,k))}set(S,k){if(S instanceof C)this.buffer.set(S.buffer,k);else if(S instanceof Uint8Array)this.buffer.set(S,k);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),k);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return m(this.buffer,S)}writeUInt32BE(S,k){u(this.buffer,S,k)}readUInt32LE(S){return l(this.buffer,S)}writeUInt32LE(S,k){w(this.buffer,S,k)}readUInt8(S){return p(this.buffer,S)}writeUInt8(S,k){h(this.buffer,S,k)}indexOf(S,k=0){return $(this.buffer,S instanceof C?S.buffer:S,k)}}e.$Ce=C;function $(P,S,k=0){const D=S.byteLength,T=P.byteLength;if(D===0)return 0;if(D===1)return P.indexOf(S[0]);if(D>T-k)return-1;const F=j.value;F.fill(S.length);for(let Y=0;Y<S.length;Y++)F[S[Y]]=S.length-Y-1;let U=k+S.length-1,Q=U,G=-1;for(;U<T;)if(P[U]===S[Q]){if(Q===0){G=U;break}U--,Q--}else U+=Math.max(S.length-Q,F[P[U]]),Q=S.length-1;return G}function E(P,S){return P[S+0]<<0>>>0|P[S+1]<<8>>>0}function b(P,S,k){P[k+0]=S&255,S=S>>>8,P[k+1]=S&255}function m(P,S){return P[S]*2**24+P[S+1]*2**16+P[S+2]*2**8+P[S+3]}function u(P,S,k){P[k+3]=S,S=S>>>8,P[k+2]=S,S=S>>>8,P[k+1]=S,S=S>>>8,P[k]=S}function l(P,S){return P[S+0]<<0>>>0|P[S+1]<<8>>>0|P[S+2]<<16>>>0|P[S+3]<<24>>>0}function w(P,S,k){P[k+0]=S&255,S=S>>>8,P[k+1]=S&255,S=S>>>8,P[k+2]=S&255,S=S>>>8,P[k+3]=S&255}function p(P,S){return P[S]}function h(P,S,k){P[k]=S}function g(P){return N.$re(P,S=>C.concat(S))}function f(P){return N.$ye(P)}function c(P){return N.$te(P,S=>C.concat(S))}async function d(P){return P.ended?C.concat(P.buffer):C.concat([...P.buffer,await c(P.stream)])}function i(P){return N.$we(P,S=>C.concat(S))}function o(P){return N.$ze(P,{data:S=>typeof S=="string"?C.fromString(S):C.wrap(S)},S=>C.concat(S))}function n(P){return N.$qe(S=>C.concat(S),P)}function s(P,S){return N.$Ae(P,S,k=>C.concat(k))}function t(P,S){return N.$Be(P,S,k=>C.concat(k))}function r(P){let S=0,k=0,D=0;const T=new Uint8Array(Math.floor(P.length/4*3)),F=Q=>{switch(k){case 3:T[D++]=S|Q,k=0;break;case 2:T[D++]=S|Q>>>2,S=Q<<6,k=3;break;case 1:T[D++]=S|Q>>>4,S=Q<<4,k=2;break;default:S=Q<<2,k=1}};for(let Q=0;Q<P.length;Q++){const G=P.charCodeAt(Q);if(G>=65&&G<=90)F(G-65);else if(G>=97&&G<=122)F(G-97+26);else if(G>=48&&G<=57)F(G-48+52);else if(G===43||G===45)F(62);else if(G===47||G===95)F(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${P[Q]}`)}}const U=D;for(;k>0;)F(0);return C.wrap(T).slice(0,U)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:P},S=!0,k=!1){const D=k?y:a;let T="";const F=P.byteLength%3;let U=0;for(;U<P.byteLength-F;U+=3){const Q=P[U+0],G=P[U+1],Y=P[U+2];T+=D[Q>>>2],T+=D[(Q<<4|G>>>4)&63],T+=D[(G<<2|Y>>>6)&63],T+=D[Y&63]}if(F===1){const Q=P[U+0];T+=D[Q>>>2],T+=D[Q<<4&63],S&&(T+="==")}else if(F===2){const Q=P[U+0],G=P[U+1];T+=D[Q>>>2],T+=D[(Q<<4|G>>>4)&63],T+=D[G<<2&63],S&&(T+="=")}return T}}),define(ae[27],ce([0,1,129,53]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.GraphemeBreakType=e.$Rf=e.$Kf=e.$Df=e.$Cf=void 0,e.$4e=L,e.$5e=A,e.$6e=C,e.$7e=$,e.$8e=E,e.$9e=b,e.$0e=m,e.$$e=u,e.$_e=l,e.$af=w,e.$bf=p,e.$cf=h,e.$df=g,e.$ef=f,e.$ff=c,e.$gf=d,e.$hf=i,e.$if=o,e.$jf=n,e.$kf=s,e.$lf=t,e.$mf=r,e.$nf=a,e.$of=y,e.$pf=v,e.$qf=P,e.$rf=S,e.$sf=k,e.$tf=D,e.$uf=T,e.$vf=F,e.$wf=U,e.$xf=Q,e.$yf=G,e.$zf=Y,e.$Af=W,e.$Bf=J,e.$Ef=re,e.$Ff=he,e.$Gf=te,e.$Hf=V,e.$If=M,e.$Jf=x,e.$Lf=K,e.$Mf=ee,e.$Nf=_,e.$Of=Z,e.$Pf=ue,e.$Qf=ge,e.$Sf=fe,e.$Tf=$e,e.$Uf=ye,e.$Vf=ve,e.$Wf=Ce,e.$Xf=Ae,e.$Yf=le,e.$Zf=me,e.$1f=De;function L(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}const j=/{(\d+)}/g;function A(oe,...de){return de.length===0?oe:oe.replace(j,function(we,be){const Se=parseInt(be,10);return isNaN(Se)||Se<0||Se>=de.length?we:de[Se]})}const I=/{([^}]+)}/g;function C(oe,de){return Object.keys(de).length===0?oe:oe.replace(I,(we,be)=>de[be]??we)}function $(oe){return oe.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function E(oe){return oe.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function b(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function m(oe,de){let we=0;const be=de.charCodeAt(0);for(let Se=oe.length-1;Se>=0;Se--)oe.charCodeAt(Se)===be&&we++;return we}function u(oe,de,we="\u2026"){return oe.length<=de?oe:`${oe.substr(0,de)}${we}`}function l(oe,de,we="\u2026"){if(oe.length<=de)return oe;const be=Math.ceil(de/2)-we.length/2,Se=Math.floor(de/2)-we.length/2;return`${oe.substr(0,be)}${we}${oe.substr(oe.length-Se)}`}function w(oe,de=" "){const we=p(oe,de);return h(we,de)}function p(oe,de){if(!oe||!de)return oe;const we=de.length;if(we===0||oe.length===0)return oe;let be=0;for(;oe.indexOf(de,be)===be;)be=be+we;return oe.substring(be)}function h(oe,de){if(!oe||!de)return oe;const we=de.length,be=oe.length;if(we===0||be===0)return oe;let Se=be,Ie=-1;for(;Ie=oe.lastIndexOf(de,Se-1),!(Ie===-1||Ie+we!==Se);){if(Ie===0)return"";Se=Ie}return oe.substring(0,Se)}function g(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function f(oe){return oe.replace(/\*/g,"")}function c(oe,de,we={}){if(!oe)throw new Error("Cannot create regex from empty string");de||(oe=b(oe)),we.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let be="";return we.global&&(be+="g"),we.matchCase||(be+="i"),we.multiline&&(be+="m"),we.unicode&&(be+="u"),new RegExp(oe,be)}function d(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}function i(oe){return oe.split(/\r\n|\r|\n/)}function o(oe){const de=[],we=oe.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(we.length/2);be++)de.push(we[2*be]+(we[2*be+1]??""));return de}function n(oe){for(let de=0,we=oe.length;de<we;de++){const be=oe.charCodeAt(de);if(be!==32&&be!==9)return de}return-1}function s(oe,de=0,we=oe.length){for(let be=de;be<we;be++){const Se=oe.charCodeAt(be);if(Se!==32&&Se!==9)return oe.substring(de,be)}return oe.substring(de,we)}function t(oe,de=oe.length-1){for(let we=de;we>=0;we--){const be=oe.charCodeAt(we);if(be!==32&&be!==9)return we}return-1}function r(oe,de,we){const be=[];let Se=0;for(const Ie of oe.matchAll(de)){if(be.push(oe.slice(Se,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");Se=Ie.index+Ie[0].length,be.push(we(Ie[0],...Ie.slice(1),Ie.index,oe,Ie.groups))}return be.push(oe.slice(Se)),Promise.all(be).then(Ie=>Ie.join(""))}function a(oe,de){return oe<de?-1:oe>de?1:0}function y(oe,de,we=0,be=oe.length,Se=0,Ie=de.length){for(;we<be&&Se<Ie;we++,Se++){const We=oe.charCodeAt(we),Be=de.charCodeAt(Se);if(We<Be)return-1;if(We>Be)return 1}const Oe=be-we,Ne=Ie-Se;return Oe<Ne?-1:Oe>Ne?1:0}function v(oe,de){return P(oe,de,0,oe.length,0,de.length)}function P(oe,de,we=0,be=oe.length,Se=0,Ie=de.length){for(;we<be&&Se<Ie;we++,Se++){let We=oe.charCodeAt(we),Be=de.charCodeAt(Se);if(We===Be)continue;if(We>=128||Be>=128)return y(oe.toLowerCase(),de.toLowerCase(),we,be,Se,Ie);k(We)&&(We-=32),k(Be)&&(Be-=32);const Fe=We-Be;if(Fe!==0)return Fe}const Oe=be-we,Ne=Ie-Se;return Oe<Ne?-1:Oe>Ne?1:0}function S(oe){return oe>=48&&oe<=57}function k(oe){return oe>=97&&oe<=122}function D(oe){return oe>=65&&oe<=90}function T(oe,de){return oe.length===de.length&&P(oe,de)===0}function F(oe,de){const we=de.length;return de.length>oe.length?!1:P(oe,de,0,we)===0}function U(oe,de){const we=Math.min(oe.length,de.length);let be;for(be=0;be<we;be++)if(oe.charCodeAt(be)!==de.charCodeAt(be))return be;return we}function Q(oe,de){const we=Math.min(oe.length,de.length);let be;const Se=oe.length-1,Ie=de.length-1;for(be=0;be<we;be++)if(oe.charCodeAt(Se-be)!==de.charCodeAt(Ie-be))return be;return we}function G(oe){return 55296<=oe&&oe<=56319}function Y(oe){return 56320<=oe&&oe<=57343}function W(oe,de){return(oe-55296<<10)+(de-56320)+65536}function J(oe,de,we){const be=oe.charCodeAt(we);if(G(be)&&we+1<de){const Se=oe.charCodeAt(we+1);if(Y(Se))return W(be,Se)}return be}function H(oe,de){const we=oe.charCodeAt(de-1);if(Y(we)&&de>1){const be=oe.charCodeAt(de-2);if(G(be))return W(be,we)}return we}class B{get offset(){return this.e}constructor(de,we=0){this.c=de,this.d=de.length,this.e=we}setOffset(de){this.e=de}prevCodePoint(){const de=H(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=J(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Cf=B;class ie{get offset(){return this.c.offset}constructor(de,we=0){this.c=new B(de,we)}nextGraphemeLength(){const de=Re.getInstance(),we=this.c,be=we.offset;let Se=de.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Ie=we.offset,Oe=de.getGraphemeBreakType(we.nextCodePoint());if(pe(Se,Oe)){we.setOffset(Ie);break}Se=Oe}return we.offset-be}prevGraphemeLength(){const de=Re.getInstance(),we=this.c,be=we.offset;let Se=de.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Ie=we.offset,Oe=de.getGraphemeBreakType(we.prevCodePoint());if(pe(Oe,Se)){we.setOffset(Ie);break}Se=Oe}return be-we.offset}eol(){return this.c.eol()}}e.$Df=ie;function re(oe,de){return new ie(oe,de).nextGraphemeLength()}function he(oe,de){return new ie(oe,de).prevGraphemeLength()}function te(oe,de){de>0&&Y(oe.charCodeAt(de))&&de--;const we=de+re(oe,de);return[we-he(oe,we),we]}function V(oe){const de=new ie(oe);let we=0;for(;!de.eol();)we++,de.nextGraphemeLength();return we}let z;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(oe){return z||(z=O()),z.test(oe)}const q=/^[\t\n\r\x20-\x7E]*$/;function x(oe){return q.test(oe)}e.$Kf=/[\u2028\u2029]/;function K(oe){return e.$Kf.test(oe)}function ee(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}function _(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}function Z(oe,de,we=""){const be=oe.trimStart();if(be.length<de)return be;const Se=/\b/g;let Ie=0;for(;Se.test(be)&&!(be.length-Se.lastIndex<de);)Ie=Se.lastIndex,Se.lastIndex+=1;return Ie===0?be:we+be.substring(Ie).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ue(oe){let de=0;for(const we of oe.matchAll(se))de!==we.index&&(yield{isCode:!1,str:oe.substring(de,we.index)}),yield{isCode:!0,str:we[0]},de=we.index+we[0].length;de!==oe.length&&(yield{isCode:!1,str:oe.substring(de)})}function ge(oe){return oe&&(oe=oe.replace(se,"")),oe}e.$Rf="\uFEFF";function fe(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}function $e(oe){return fe(oe)?oe.substr(1):oe}function ye(oe,de){if(!oe||!de||oe.length<de.length)return!1;const we=de.length,be=oe.toLowerCase();let Se=0,Ie=-1;for(;Se<we;){const Oe=be.indexOf(de[Se],Ie+1);if(Oe<0)return!1;Ie=Oe,Se++}return!0}function ve(oe,de=!1){return oe?(de&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}function Ce(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}function Ae(oe,de=1){if(de===0)return"";let we=-1;do we=oe.indexOf(`
`,we+1),de--;while(de>0&&we>=0);return we===-1?oe:(oe[we-1]==="\r"&&we--,oe.substr(0,we))}function le(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}function me(oe){return Re.getInstance().getGraphemeBreakType(oe)}function pe(oe,de){return oe===0?de!==5&&de!==7:oe===2&&de===3?!1:oe===4||oe===2||oe===3||de===4||de===2||de===3?!0:!(oe===8&&(de===8||de===9||de===11||de===12)||(oe===11||oe===9)&&(de===9||de===10)||(oe===12||oe===10)&&de===10||de===5||de===13||de===7||oe===1||oe===13&&de===14||oe===6&&de===6)}var Pe;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Te()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const we=this.d,be=we.length/3;let Se=1;for(;Se<=be;)if(de<we[3*Se])Se=2*Se;else if(de>we[3*Se+1])Se=2*Se+1;else return we[3*Se+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(oe,de){if(oe===0)return 0;const we=Ue(oe,de);if(we!==void 0)return we;const be=new B(de,oe);return be.prevCodePoint(),be.offset}function Ue(oe,de){const we=new B(de,oe);let be=we.prevCodePoint();for(;Me(be)||be===65039||be===8419;){if(we.offset===0)return;be=we.prevCodePoint()}if(!_(be))return;let Se=we.offset;return Se>0&&we.prevCodePoint()===8205&&(Se=we.offset),Se}function Me(oe){return 127995<=oe&&oe<=127999}var qe;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$2f="\xA0";class ze{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new R.$Ze({getCacheKey:JSON.stringify},de=>{function we(Fe){const Xe=new Map;for(let Ge=0;Ge<Fe.length;Ge+=2)Xe.set(Fe[Ge],Fe[Ge+1]);return Xe}function be(Fe,Xe){const Ge=new Map(Fe);for(const[_e,tt]of Xe)Ge.set(_e,tt);return Ge}function Se(Fe,Xe){if(!Fe)return Xe;const Ge=new Map;for(const[_e,tt]of Fe)Xe.has(_e)&&Ge.set(_e,tt);return Ge}const Ie=this.c.value;let Oe=de.filter(Fe=>!Fe.startsWith("_")&&Fe in Ie);Oe.length===0&&(Oe=["_default"]);let Ne;for(const Fe of Oe){const Xe=we(Ie[Fe]);Ne=Se(Ne,Xe)}const We=we(Ie._common),Be=be(We,Ne);return new ze(Be)})}static getInstance(de){return ze.d.get(Array.from(de))}static{this.e=new N.$V(()=>Object.keys(ze.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return ze.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$3f=ze;class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(de){return je.e().has(de)}static get codePoints(){return je.e()}}e.$4f=je}),define(ae[54],ce([0,1,27]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$jj=void 0,e.$fj=N,e.$gj=L,e.$hj=j,e.$ij=I,e.$kj=w;function N(h){return L(h,0)}function L(h,g){switch(typeof h){case"object":return h===null?j(349,g):Array.isArray(h)?C(h,g):$(h,g);case"string":return I(h,g);case"boolean":return A(h,g);case"number":return j(h,g);case"undefined":return j(937,g);default:return j(617,g)}}function j(h,g){return(g<<5)-g+h|0}function A(h,g){return j(h?433:863,g)}function I(h,g){g=j(149417,g);for(let f=0,c=h.length;f<c;f++)g=j(h.charCodeAt(f),g);return g}function C(h,g){return g=j(104579,g),h.reduce((f,c)=>L(c,f),g)}function $(h,g){return g=j(181387,g),Object.keys(h).sort().reduce((f,c)=>(f=I(c,f),L(h[c],f)),g)}class E{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=L(g,this.g),this.g}}e.$jj=E;var b;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function m(h,g,f=32){const c=f-g,d=~((1<<c)-1);return(h<<g|(d&h)>>>c)>>>0}function u(h,g=0,f=h.byteLength,c=0){for(let d=0;d<f;d++)h[g+d]=c}function l(h,g,f="0"){for(;h.length<g;)h=f+h;return h}function w(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(f=>f.toString(16).padStart(2,"0")).join(""):l((h>>>0).toString(16),g/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const f=g.length;if(f===0)return;const c=this.p;let d=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=g.charCodeAt(0),n=0);;){let s=o;if(R.$yf(o))if(n+1<f){const t=g.charCodeAt(n+1);R.$zf(t)?(n++,s=R.$Af(o,t)):s=65533}else{i=o;break}else R.$zf(o)&&(s=65533);if(d=this.w(c,d,s),n++,n<f)o=g.charCodeAt(n);else break}this.r=d,this.u=i}w(g,f,c){return c<128?g[f++]=c:c<2048?(g[f++]=192|(c&1984)>>>6,g[f++]=128|(c&63)>>>0):c<65536?(g[f++]=224|(c&61440)>>>12,g[f++]=128|(c&4032)>>>6,g[f++]=128|(c&63)>>>0):(g[f++]=240|(c&1835008)>>>18,g[f++]=128|(c&258048)>>>12,g[f++]=128|(c&4032)>>>6,g[f++]=128|(c&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,g[0]=g[64],g[1]=g[65],g[2]=g[66]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=p.g,f=this.q;for(let a=0;a<64;a+=4)g.setUint32(a,f.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,m(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let c=this.h,d=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=d&i|~d&o,t=1518500249):a<40?(s=d^i^o,t=1859775393):a<60?(s=d&i|d&o|i&o,t=2400959708):(s=d^i^o,t=3395469782),r=m(c,5)+s+n+t+g.getUint32(a*4,!1)&4294967295,n=o,o=i,i=m(d,30),d=c,c=r;this.h=this.h+c&4294967295,this.l=this.l+d&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$lj=p}),define(ae[88],ce([0,1,27]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const j="error",A="warning",I="warn",C="info",$="ignore";function E(m){return m?R.$uf(j,m)?L.Error:R.$uf(A,m)||R.$uf(I,m)?L.Warning:R.$uf(C,m)?L.Info:L.Ignore:L.Ignore}L.fromValue=E;function b(m){switch(m){case L.Error:return j;case L.Warning:return A;case L.Info:return C;default:return $}}L.toString=b}(N||(N={})),e.default=N}),define(ae[130],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(ae[51],ce([0,1,17,27]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=void 0;class L{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const l=u.charCodeAt(0),w=this.b.charCodeAt(this.c);return l-w}value(){return this.b[this.c]}}e.$ti=L;class j{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,N.$of)(u,this.b,0,u.length,this.c,this.d):(0,N.$qf)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ui=j;class A{constructor(u=!0,l=!0){this.f=u,this.g=l}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let l=u.length-1;l>=0;l--,this.c--){const w=this.b.charCodeAt(l);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const l=this.b.charCodeAt(this.e);if(l===47||this.f&&l===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,N.$of)(u,this.b,0,u.length,this.d,this.e):(0,N.$qf)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$vi=A;var I;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(I||(I={}));class C{constructor(u,l){this.f=u,this.g=l,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,N.$pf)(u,this.c.scheme);if(this.d[this.e]===2)return(0,N.$pf)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,N.$nf)(u,this.c.query);if(this.d[this.e]===5)return(0,N.$nf)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$wi=C;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(E||(E={}));class b{static forUris(u=()=>!1,l=()=>!1){return new b(new C(u,l))}static forPaths(u=!1){return new b(new A(void 0,!u))}static forStrings(){return new b(new L)}static forConfigKeys(){return new b(new j)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,l){if(l){const w=l.slice(0);(0,R.$Xb)(w);for(const p of w)this.set(p,u)}else{const w=u.slice(0);(0,R.$Xb)(w);for(const p of w)this.set(p[0],p[1])}}set(u,l){const w=this.b.reset(u);let p;this.c||(this.c=new $,this.c.segment=w.value());const h=[];for(p=this.c;;){const f=w.cmp(p.segment);if(f>0)p.left||(p.left=new $,p.left.segment=w.value()),h.push([-1,p]),p=p.left;else if(f<0)p.right||(p.right=new $,p.right.segment=w.value()),h.push([1,p]),p=p.right;else if(w.hasNext())w.next(),p.mid||(p.mid=new $,p.mid.segment=w.value()),h.push([0,p]),p=p.mid;else break}const g=p.value;p.value=l,p.key=u;for(let f=h.length-1;f>=0;f--){const c=h[f][1];c.updateHeight();const d=c.balanceFactor();if(d<-1||d>1){const i=h[f][0],o=h[f+1][0];if(i===1&&o===1)h[f][1]=c.rotateLeft();else if(i===-1&&o===-1)h[f][1]=c.rotateRight();else if(i===1&&o===-1)c.right=h[f+1][1]=h[f+1][1].rotateRight(),h[f][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=h[f+1][1]=h[f+1][1].rotateLeft(),h[f][1]=c.rotateRight();else throw new Error;if(f>0)switch(h[f-1][0]){case-1:h[f-1][1].left=h[f][1];break;case 1:h[f-1][1].right=h[f][1];break;case 0:h[f-1][1].mid=h[f][1];break}else this.c=h[0][1]}}return g}get(u){return this.d(u)?.value}d(u){const l=this.b.reset(u);let w=this.c;for(;w;){const p=l.cmp(w.segment);if(p>0)w=w.left;else if(p<0)w=w.right;else if(l.hasNext())l.next(),w=w.mid;else break}return w}has(u){const l=this.d(u);return!(l?.value===void 0&&l?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,l){const w=this.b.reset(u),p=[];let h=this.c;for(;h;){const g=w.cmp(h.segment);if(g>0)p.push([-1,h]),h=h.left;else if(g<0)p.push([1,h]),h=h.right;else if(w.hasNext())w.next(),p.push([0,h]),h=h.mid;else break}if(h){if(l?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this.f(h.right);if(g.key){const{key:f,value:c,segment:d}=g;this.e(g.key,!1),h.key=f,h.value=c,h.segment=d}}else{const g=h.left??h.right;if(p.length>0){const[f,c]=p[p.length-1];switch(f){case-1:c.left=g;break;case 0:c.mid=g;break;case 1:c.right=g;break}}else this.c=g}for(let g=p.length-1;g>=0;g--){const f=p[g][1];f.updateHeight();const c=f.balanceFactor();if(c>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),p[g][1]=f.rotateLeft()):c<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),p[g][1]=f.rotateRight()),g>0)switch(p[g-1][0]){case-1:p[g-1][1].left=p[g][1];break;case 1:p[g-1][1].right=p[g][1];break;case 0:p[g-1][1].mid=p[g][1];break}else this.c=p[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const l=this.b.reset(u);let w=this.c,p;for(;w;){const h=l.cmp(w.segment);if(h>0)w=w.left;else if(h<0)w=w.right;else if(l.hasNext())l.next(),p=w.value||p,w=w.mid;else break}return w&&w.value||p}findSuperstr(u){return this.g(u,!1)}g(u,l){const w=this.b.reset(u);let p=this.c;for(;p;){const h=w.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(w.hasNext())w.next(),p=p.mid;else return p.mid?this.h(p.mid):l?p.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[l,w]of this)u(w,l)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const l=[];return this.j(u,l),l[Symbol.iterator]()}j(u,l){u&&(u.left&&this.j(u.left,l),u.value&&l.push([u.key,u.value]),u.mid&&this.j(u.mid,l),u.right&&this.j(u.right,l))}_isBalanced(){const u=l=>{if(!l)return!0;const w=l.balanceFactor();return w<-1||w>1?!1:u(l.left)&&u(l.right)};return u(this.c)}}e.$xi=b}),define(ae[13],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=R,e.$6f=N,e.$7f=L,e.$8f=j,e.$9f=A,e.$0f=I,e.$$f=C,e.$_f=$,e.$ag=E,e.$bg=b,e.$cg=m,e.$dg=u,e.$eg=l,e.$fg=p,e.$gg=h,e.$hg=g,e.$ig=f,e.$jg=c;function R(d){return typeof d=="string"}function N(d){return Array.isArray(d)&&d.every(i=>R(i))}function L(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}function j(d){const i=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof i}function A(d){return typeof d=="number"&&!isNaN(d)}function I(d){return!!d&&typeof d[Symbol.iterator]=="function"}function C(d){return d===!0||d===!1}function $(d){return typeof d>"u"}function E(d){return!b(d)}function b(d){return $(d)||d===null}function m(d,i){if(!d)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function u(d){if(b(d))throw new Error("Assertion Failed: argument is undefined or null");return d}function l(...d){const i=[];for(let o=0;o<d.length;o++){const n=d[o];if(b(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}const w=Object.prototype.hasOwnProperty;function p(d){if(!L(d))return!1;for(const i in d)if(w.call(d,i))return!1;return!0}function h(d){return typeof d=="function"}function g(...d){return d.length>0&&d.every(h)}function f(d,i){const o=Math.min(d.length,i.length);for(let n=0;n<o;n++)c(d[n],i[n])}function c(d,i){if(R(i)){if(typeof d!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if(d instanceof i)return}catch{}if(!b(d)&&d.constructor===i||i.length===1&&i.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ae[30],ce([0,1,13]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=N,e.$Yn=L,e.$Zn=A,e.$1n=C,e.$2n=$,e.$3n=E,e.$4n=b,e.$5n=m,e.$6n=u,e.$7n=l,e.$8n=w,e.$9n=p;function N(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([f,c])=>{g[f]=c&&typeof c=="object"?N(c):c}),g}function L(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const f=g.shift();Object.freeze(f);for(const c in f)if(j.call(f,c)){const d=f[c];typeof d=="object"&&!Object.isFrozen(d)&&!(0,R.$8f)(d)&&g.push(d)}}return h}const j=Object.prototype.hasOwnProperty;function A(h,g){return I(h,g,new Set)}function I(h,g,f){if((0,R.$bg)(h))return h;const c=g(h);if(typeof c<"u")return c;if(Array.isArray(h)){const d=[];for(const i of h)d.push(I(i,g,f));return d}if((0,R.$7f)(h)){if(f.has(h))throw new Error("Cannot clone recursive data-structure");f.add(h);const d={};for(const i in h)j.call(h,i)&&(d[i]=I(h[i],g,f));return f.delete(h),d}return h}function C(h,g,f=!0){return(0,R.$7f)(h)?((0,R.$7f)(g)&&Object.keys(g).forEach(c=>{c in h?f&&((0,R.$7f)(h[c])&&(0,R.$7f)(g[c])?C(h[c],g[c],f):h[c]=g[c]):h[c]=g[c]}),h):g}function $(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let f,c;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(f=0;f<h.length;f++)if(!$(h[f],g[f]))return!1}else{const d=[];for(c in h)d.push(c);d.sort();const i=[];for(c in g)i.push(c);if(i.sort(),!$(d,i))return!1;for(f=0;f<d.length;f++)if(!$(h[d[f]],g[d[f]]))return!1}return!0}function E(h){const g=new Set;return JSON.stringify(h,(f,c)=>{if((0,R.$7f)(c)||Array.isArray(c)){if(g.has(c))return"[Circular]";g.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function b(h,g){const f=Object.create(null);return!h||!g||Object.keys(g).forEach(d=>{const i=h[d],o=g[d];$(i,o)||(f[d]=o)}),f}function m(h,g){const f=g.toLowerCase(),c=Object.keys(h).find(d=>d.toLowerCase()===f);return c?h[c]:h[g]}function u(h,g){const f=Object.create(null);for(const[c,d]of Object.entries(h))g(c,d)&&(f[c]=d);return f}function l(h){let g=[];for(;Object.prototype!==h;)g=g.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return g}function w(h){const g=[];for(const f of l(h))typeof h[f]=="function"&&g.push(f);return g}function p(h,g){const f=d=>function(){const i=Array.prototype.slice.call(arguments,0);return g(d,i)},c={};for(const d of h)c[d]=f(d);return c}}),define(ae[32],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=void 0,e.$Mg=N;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return R.test(L)}e.$Ng=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(I){for(let C=0;C<I.length;C++)I[C]=Math.floor(Math.random()*256);return I};const j=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){L(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let C=0,$="";return $+=A[j[C++]],$+=A[j[C++]],$+=A[j[C++]],$+=A[j[C++]],$+="-",$+=A[j[C++]],$+=A[j[C++]],$+="-",$+=A[j[C++]],$+=A[j[C++]],$+="-",$+=A[j[C++]],$+=A[j[C++]],$+="-",$+=A[j[C++]],$+=A[j[C++]],$+=A[j[C++]],$+=A[j[C++]],$+=A[j[C++]],$+=A[j[C++]],$}}()}),define(ae[131],ce([0,1,37]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=j;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(A){const I=A.replace(/\-/g,":").toLowerCase();return!N.has(I)}function j(){const A=(0,R.networkInterfaces)();for(const I in A){const C=A[I];if(C){for(const{mac:$}of C)if(L($))return $}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ae[132],ce([0,1,273,15]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AW=void 0;class L extends R.Transform{constructor(A){if(super(),typeof A=="number")this.b=A,this.c=1;else{const I=Buffer.isBuffer(A)?A:Buffer.from(A);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(A,I,C){this.a?this.a=Buffer.concat([this.a,A]):this.a=A;let $=0;for(;$<this.a.length;){const E=typeof this.b=="number"?this.a.indexOf(this.b,$):(0,N.$De)(this.a,this.b,$);if(E===-1)break;this.push(this.a.slice($,E+this.c)),$=E+this.c}this.a=$===this.a.length?void 0:this.a.slice($),C()}_flush(A){this.a&&this.push(this.a),A()}}e.$AW=L}),define(ae[133],ce([0,1,64]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=void 0,e.$Pg=N,e.$Rg=j;function N(I,C,$,E=1){let b=!1;return new Promise(m=>{const u=setTimeout(()=>{if(!b)return b=!0,m(0)},$);L(I,C,E,l=>{if(!b)return b=!0,clearTimeout(u),m(l)})})}function L(I,C,$,E){if(C===0)return E(0);const b=new R.Socket;b.once("connect",()=>(A(b),L(I+$,C-1,$,E))),b.once("data",()=>{}),b.once("error",m=>(A(b),m.code!=="ECONNREFUSED"?L(I+$,C-1,$,E):E(I))),b.connect(I,"127.0.0.1")}e.$Qg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(I,C,$,E="127.0.0.1"){let b=!1,m,u=1;const l=R.createServer({pauseOnConnect:!0});function w(p,h){b||(b=!0,l.removeAllListeners(),l.close(),m&&clearTimeout(m),h(p))}return new Promise(p=>{m=setTimeout(()=>{w(0,p)},$),l.on("listening",()=>{w(I,p)}),l.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&u<C?(I++,u++,l.listen(I,E)):w(0,p)}),l.on("close",()=>{w(0,p)}),l.listen(I,E)})}function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(C){console.error(C)}}}),define(ae[134],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SW=R;function R(N){return!!N.parentPort}}),define(ae[135],ce([11,10]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ae[65],ce([0,1,135]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=$,e.$Xm=E,e.$Ym=b;const N=60,L=N*60,j=L*24,A=j*7,I=j*30,C=j*365;function $(m,u,l,w){typeof m!="number"&&(m=m.getTime());const p=Math.round((new Date().getTime()-m)/1e3);if(p<-30)return(0,R.localize)(0,null,$(new Date().getTime()+p*1e3,!1));if(!w&&p<30)return(0,R.localize)(1,null);let h;return p<N?(h=p,u?h===1?l?(0,R.localize)(2,null,h):(0,R.localize)(3,null,h):l?(0,R.localize)(4,null,h):(0,R.localize)(5,null,h):h===1?l?(0,R.localize)(6,null,h):(0,R.localize)(7,null,h):l?(0,R.localize)(8,null,h):(0,R.localize)(9,null,h)):p<L?(h=Math.floor(p/N),u?h===1?l?(0,R.localize)(10,null,h):(0,R.localize)(11,null,h):l?(0,R.localize)(12,null,h):(0,R.localize)(13,null,h):h===1?l?(0,R.localize)(14,null,h):(0,R.localize)(15,null,h):l?(0,R.localize)(16,null,h):(0,R.localize)(17,null,h)):p<j?(h=Math.floor(p/L),u?h===1?l?(0,R.localize)(18,null,h):(0,R.localize)(19,null,h):l?(0,R.localize)(20,null,h):(0,R.localize)(21,null,h):h===1?l?(0,R.localize)(22,null,h):(0,R.localize)(23,null,h):l?(0,R.localize)(24,null,h):(0,R.localize)(25,null,h)):p<A?(h=Math.floor(p/j),u?h===1?(0,R.localize)(26,null,h):(0,R.localize)(27,null,h):h===1?(0,R.localize)(28,null,h):(0,R.localize)(29,null,h)):p<I?(h=Math.floor(p/A),u?h===1?l?(0,R.localize)(30,null,h):(0,R.localize)(31,null,h):l?(0,R.localize)(32,null,h):(0,R.localize)(33,null,h):h===1?l?(0,R.localize)(34,null,h):(0,R.localize)(35,null,h):l?(0,R.localize)(36,null,h):(0,R.localize)(37,null,h)):p<C?(h=Math.floor(p/I),u?h===1?l?(0,R.localize)(38,null,h):(0,R.localize)(39,null,h):l?(0,R.localize)(40,null,h):(0,R.localize)(41,null,h):h===1?l?(0,R.localize)(42,null,h):(0,R.localize)(43,null,h):l?(0,R.localize)(44,null,h):(0,R.localize)(45,null,h)):(h=Math.floor(p/C),u?h===1?l?(0,R.localize)(46,null,h):(0,R.localize)(47,null,h):l?(0,R.localize)(48,null,h):(0,R.localize)(49,null,h):h===1?l?(0,R.localize)(50,null,h):(0,R.localize)(51,null,h):l?(0,R.localize)(52,null,h):(0,R.localize)(53,null,h))}function E(m,u){const l=Math.abs(m/1e3);return l<1?u?(0,R.localize)(54,null,m):(0,R.localize)(55,null,m):l<N?u?(0,R.localize)(56,null,Math.round(m)/1e3):(0,R.localize)(57,null,Math.round(m)/1e3):l<L?u?(0,R.localize)(58,null,Math.round(m/(1e3*N))):(0,R.localize)(59,null,Math.round(m/(1e3*N))):l<j?u?(0,R.localize)(60,null,Math.round(m/(1e3*L))):(0,R.localize)(61,null,Math.round(m/(1e3*L))):(0,R.localize)(62,null,Math.round(m/(1e3*j)))}function b(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ae[136],ce([11,10]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,17,13,136]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=C,e.$dj=$,e.$ej=E;function j(b,m){return m&&(b.stack||b.stacktrace)?L.localize(0,null,I(b),A(b.stack)||A(b.stacktrace)):I(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function I(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?L.localize(1,null,b.message):b.message||L.localize(2,null)}function C(b=null,m=!1){if(!b)return L.localize(3,null);if(Array.isArray(b)){const u=R.$Hb(b),l=C(u[0],m);return u.length>1?L.localize(4,null,l,u.length):l}if(N.$5f(b))return b;if(b.detail){const u=b.detail;if(u.error)return j(u.error,m);if(u.exception)return j(u.exception,m)}return b.stack?j(b,m):b.message?b.message:L.localize(5,null)}function $(b){const m=b;return m instanceof Error&&Array.isArray(m.actions)}function E(b,m){let u;return typeof b=="string"?u=new Error(b):u=b,u.actions=m,u}}),define(ae[137],ce([11,10]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ae[138],ce([0,1,137]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=N;function N(L){switch(L){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}}),define(ae[139],ce([11,10]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,139]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=y,e.$J=v,e.$g="en";let N=!1,L=!1,j=!1,A=!1,I=!1,C=!1,$=!1,E=!1,b=!1,m=!1,u,l=e.$g,w=e.$g,p,h;const g=globalThis;let f;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?f=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const c=typeof f?.versions?.electron=="string",d=c&&f?.type==="renderer";if(typeof f=="object"){N=f.platform==="win32",L=f.platform==="darwin",j=f.platform==="linux",A=j&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,$=c,b=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$g,l=e.$g;const P=f.env.VSCODE_NLS_CONFIG;if(P)try{const S=JSON.parse(P),k=S.availableLanguages["*"];u=S.locale,w=S.osLocale,l=k||e.$g,p=S._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!d?(h=navigator.userAgent,N=h.indexOf("Windows")>=0,L=h.indexOf("Macintosh")>=0,E=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=h.indexOf("Linux")>=0,m=h?.indexOf("Mobi")>=0,C=!0,u=R.getConfiguredDefaultLocale(R.localize(0,null))||e.$g,l=u,w=navigator.language):console.error("Unable to resolve platform.");var i;(function(P){P[P.Web=0]="Web",P[P.Mac=1]="Mac",P[P.Linux=2]="Linux",P[P.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(P){switch(P){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;L?n=1:N?n=3:j&&(n=2),e.$i=N,e.$j=L,e.$k=j,e.$l=A,e.$m=I,e.$n=$,e.$o=C,e.$p=C&&typeof g.importScripts=="function",e.$q=e.$p?g.origin:void 0,e.$r=E,e.$s=m,e.$t=b,e.$u=n,e.$v=h,e.$w=l;var s;(function(P){function S(){return e.$w}P.value=S;function k(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}P.isDefaultVariant=k;function D(){return e.$w==="en"}P.isDefault=D})(s||(e.Language=s={})),e.$x=u,e.$y=w,e.$z=p,e.$A=typeof g.postMessage=="function"&&!g.importScripts,e.$B=(()=>{if(e.$A){const P=[];g.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let D=0,T=P.length;D<T;D++){const F=P[D];if(F.id===k.data.vscodeScheduleAsyncWork){P.splice(D,1),F.callback();return}}});let S=0;return k=>{const D=++S;P.push({id:D,callback:k}),g.postMessage({vscodeScheduleAsyncWork:D},"*")}}return P=>setTimeout(P)})();var t;(function(P){P[P.Windows=1]="Windows",P[P.Macintosh=2]="Macintosh",P[P.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=L||E?2:N?1:3;let r=!0,a=!1;function y(){if(!a){a=!0;const P=new Uint8Array(2);P[0]=1,P[1]=2,r=new Uint16Array(P.buffer)[0]===513}return r}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function v(P){return parseFloat(P)>=20}}),define(ae[36],ce([0,1,5]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const j=L.process;N={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return R.$i?"win32":R.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ae[140],ce([0,1,36]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hW=A;var N;(function(I){I.UNKNOWN="UNKNOWN",I.CINNAMON="CINNAMON",I.DEEPIN="DEEPIN",I.GNOME="GNOME",I.KDE3="KDE3",I.KDE4="KDE4",I.KDE5="KDE5",I.KDE6="KDE6",I.PANTHEON="PANTHEON",I.UNITY="UNITY",I.XFCE="XFCE",I.UKUI="UKUI",I.LXQT="LXQT"})(N||(N={}));const L="XDG_CURRENT_DESKTOP",j="KDE_SESSION_VERSION";function A(){const I=R.env[L];if(I){const $=I.split(":").map(E=>E.trim()).filter(E=>E.length>0);for(const E of $)switch(E){case"Unity":{const b=R.env.DESKTOP_SESSION;return b&&b.includes("gnome-fallback")?N.GNOME:N.UNITY}case"Deepin":return N.DEEPIN;case"GNOME":return N.GNOME;case"X-Cinnamon":return N.CINNAMON;case"KDE":{const b=R.env[j];return b==="5"?N.KDE5:b==="6"?N.KDE6:N.KDE4}case"Pantheon":return N.PANTHEON;case"XFCE":return N.XFCE;case"UKUI":return N.UKUI;case"LXQt":return N.LXQT}}const C=R.env.DESKTOP_SESSION;if(C)switch(C){case"deepin":return N.DEEPIN;case"gnome":case"mate":return N.GNOME;case"kde4":case"kde-plasma":return N.KDE4;case"kde":return j in R.env?N.KDE4:N.KDE3;case"xfce":case"xubuntu":return N.XFCE;case"ukui":return N.UKUI}return"GNOME_DESKTOP_SESSION_ID"in R.env?N.GNOME:"KDE_FULL_SESSION"in R.env?j in R.env?N.KDE4:N.KDE3:N.UNKNOWN}}),define(ae[14],ce([0,1,36]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,L=97,j=90,A=122,I=46,C=47,$=92,E=58,b=63;class m extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function u(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function l(i,o){if(typeof i!="string")throw new m(o,"string",i)}const w=R.$ec==="win32";function p(i){return i===C||i===$}function h(i){return i===C}function g(i){return i>=N&&i<=j||i>=L&&i<=A}function f(i,o,n,s){let t="",r=0,a=-1,y=0,v=0;for(let P=0;P<=i.length;++P){if(P<i.length)v=i.charCodeAt(P);else{if(s(v))break;v=C}if(s(v)){if(!(a===P-1||y===1))if(y===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==I||t.charCodeAt(t.length-2)!==I){if(t.length>2){const S=t.lastIndexOf(n);S===-1?(t="",r=0):(t=t.slice(0,S),r=t.length-1-t.lastIndexOf(n)),a=P,y=0;continue}else if(t.length!==0){t="",r=0,a=P,y=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,P)}`:t=i.slice(a+1,P),r=P-a-1;a=P,y=0}else v===I&&y!==-1?++y:y=-1}return t}function c(i,o){u(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$gc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],l(r,"path"),r.length===0)continue}else o.length===0?r=R.cwd():(r=R.env[`=${o}`]||R.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===$)&&(r=`${o}\\`));const a=r.length;let y=0,v="",P=!1;const S=r.charCodeAt(0);if(a===1)p(S)&&(y=1,P=!0);else if(p(S))if(P=!0,p(r.charCodeAt(1))){let k=2,D=k;for(;k<a&&!p(r.charCodeAt(k));)k++;if(k<a&&k!==D){const T=r.slice(D,k);for(D=k;k<a&&p(r.charCodeAt(k));)k++;if(k<a&&k!==D){for(D=k;k<a&&!p(r.charCodeAt(k));)k++;(k===a||k!==D)&&(v=`\\\\${T}\\${r.slice(D,k)}`,y=k)}}}else y=1;else g(S)&&r.charCodeAt(1)===E&&(v=r.slice(0,2),y=2,a>2&&p(r.charCodeAt(2))&&(P=!0,y=3));if(v.length>0)if(o.length>0){if(v.toLowerCase()!==o.toLowerCase())continue}else o=v;if(s){if(o.length>0)break}else if(n=`${r.slice(y)}\\${n}`,s=P,P&&o.length>0)break}return n=f(n,!s,"\\",p),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){l(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return h(r)?"\\":i;if(p(r))if(t=!0,p(i.charCodeAt(1))){let y=2,v=y;for(;y<o&&!p(i.charCodeAt(y));)y++;if(y<o&&y!==v){const P=i.slice(v,y);for(v=y;y<o&&p(i.charCodeAt(y));)y++;if(y<o&&y!==v){for(v=y;y<o&&!p(i.charCodeAt(y));)y++;if(y===o)return`\\\\${P}\\${i.slice(v)}\\`;y!==v&&(s=`\\\\${P}\\${i.slice(v,y)}`,n=y)}}}else n=1;else g(r)&&i.charCodeAt(1)===E&&(s=i.slice(0,2),n=2,o>2&&p(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?f(i.slice(n),!t,"\\",p):"";return a.length===0&&!t&&(a="."),a.length>0&&p(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){l(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return p(n)||o>2&&g(n)&&i.charCodeAt(1)===E&&p(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];l(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&p(n.charCodeAt(0))){++t;const r=n.length;r>1&&p(n.charCodeAt(1))&&(++t,r>2&&(p(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&p(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$gc.normalize(o)},relative(i,o){if(l(i,"from"),l(o,"to"),i===o)return"";const n=e.$gc.resolve(i),s=e.$gc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===$;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===$;)r--;const a=r-t;let y=0;for(;y<o.length&&o.charCodeAt(y)===$;)y++;let v=o.length;for(;v-1>y&&o.charCodeAt(v-1)===$;)v--;const P=v-y,S=a<P?a:P;let k=-1,D=0;for(;D<S;D++){const F=i.charCodeAt(t+D);if(F!==o.charCodeAt(y+D))break;F===$&&(k=D)}if(D!==S){if(k===-1)return s}else{if(P>S){if(o.charCodeAt(y+D)===$)return s.slice(y+D+1);if(D===2)return s.slice(y+D)}a>S&&(i.charCodeAt(t+D)===$?k=D:D===2&&(k=3)),k===-1&&(k=0)}let T="";for(D=t+k+1;D<=r;++D)(D===r||i.charCodeAt(D)===$)&&(T+=T.length===0?"..":"\\..");return y+=k,T.length>0?`${T}${s.slice(y,v)}`:(s.charCodeAt(y)===$&&++y,s.slice(y,v))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$gc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===$){if(o.charCodeAt(1)===$){const n=o.charCodeAt(2);if(n!==b&&n!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===E&&o.charCodeAt(2)===$)return`\\\\?\\${o}`;return i},dirname(i){l(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return p(t)?i:".";if(p(t)){if(n=s=1,p(i.charCodeAt(1))){let y=2,v=y;for(;y<o&&!p(i.charCodeAt(y));)y++;if(y<o&&y!==v){for(v=y;y<o&&p(i.charCodeAt(y));)y++;if(y<o&&y!==v){for(v=y;y<o&&!p(i.charCodeAt(y));)y++;if(y===o)return i;y!==v&&(n=s=y+1)}}}}else g(t)&&i.charCodeAt(1)===E&&(n=o>2&&p(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let y=o-1;y>=s;--y)if(p(i.charCodeAt(y))){if(!a){r=y;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&l(o,"ext"),l(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===E&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,y=-1;for(r=i.length-1;r>=n;--r){const v=i.charCodeAt(r);if(p(v)){if(!t){n=r+1;break}}else y===-1&&(t=!1,y=r+1),a>=0&&(v===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=y))}return n===s?s=y:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(p(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){l(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===E&&g(i.charCodeAt(0))&&(o=s=2);for(let y=i.length-1;y>=o;--y){const v=i.charCodeAt(y);if(p(v)){if(!r){s=y+1;break}continue}t===-1&&(r=!1,t=y+1),v===I?n===-1?n=y:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){l(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return p(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(p(t)){if(s=1,p(i.charCodeAt(1))){let k=2,D=k;for(;k<n&&!p(i.charCodeAt(k));)k++;if(k<n&&k!==D){for(D=k;k<n&&p(i.charCodeAt(k));)k++;if(k<n&&k!==D){for(D=k;k<n&&!p(i.charCodeAt(k));)k++;k===n?s=k:k!==D&&(s=k+1)}}}}else if(g(t)&&i.charCodeAt(1)===E){if(n<=2)return o.root=o.dir=i,o;if(s=2,p(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,y=-1,v=!0,P=i.length-1,S=0;for(;P>=s;--P){if(t=i.charCodeAt(P),p(t)){if(!v){a=P+1;break}continue}y===-1&&(v=!1,y=P+1),t===I?r===-1?r=P:S!==1&&(S=1):r!==-1&&(S=-1)}return y!==-1&&(r===-1||S===0||S===1&&r===y-1&&r===a+1?o.base=o.name=i.slice(a,y):(o.name=i.slice(a,r),o.base=i.slice(a,y),o.ext=i.slice(r,y))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(w){const i=/\\/g;return()=>{const o=R.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>R.cwd()})();e.$hc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:d();l(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===C)}return o=f(o,!n,"/",h),n?`/${o}`:o.length>0?o:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===C,n=i.charCodeAt(i.length-1)===C;return i=f(i,!o,"/",h),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===C},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];l(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$hc.normalize(o)},relative(i,o){if(l(i,"from"),l(o,"to"),i===o||(i=e.$hc.resolve(i),o=e.$hc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,y=t<a?t:a;let v=-1,P=0;for(;P<y;P++){const k=i.charCodeAt(n+P);if(k!==o.charCodeAt(r+P))break;k===C&&(v=P)}if(P===y)if(a>y){if(o.charCodeAt(r+P)===C)return o.slice(r+P+1);if(P===0)return o.slice(r+P)}else t>y&&(i.charCodeAt(n+P)===C?v=P:P===0&&(v=0));let S="";for(P=n+v+1;P<=s;++P)(P===s||i.charCodeAt(P)===C)&&(S+=S.length===0?"..":"/..");return`${S}${o.slice(r+v)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===C;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===C){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&l(o,"ext"),l(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,y=-1;for(r=i.length-1;r>=0;--r){const v=i.charCodeAt(r);if(v===C){if(!t){n=r+1;break}}else y===-1&&(t=!1,y=r+1),a>=0&&(v===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=y))}return n===s?s=y:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===C){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){l(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const y=i.charCodeAt(a);if(y===C){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),y===I?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){l(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===C;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,y=!0,v=i.length-1,P=0;for(;v>=s;--v){const S=i.charCodeAt(v);if(S===C){if(!y){r=v+1;break}continue}a===-1&&(y=!1,a=v+1),S===I?t===-1?t=v:P!==1&&(P=1):t!==-1&&(P=-1)}if(a!==-1){const S=r===0&&n?1:r;t===-1||P===0||P===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(S,a):(o.name=i.slice(S,t),o.base=i.slice(S,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=w?e.$gc.normalize:e.$hc.normalize,e.$jc=w?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=w?e.$gc.join:e.$hc.join,e.$lc=w?e.$gc.resolve:e.$hc.resolve,e.$mc=w?e.$gc.relative:e.$hc.relative,e.$nc=w?e.$gc.dirname:e.$hc.dirname,e.$oc=w?e.$gc.basename:e.$hc.basename,e.$pc=w?e.$gc.extname:e.$hc.extname,e.$qc=w?e.$gc.format:e.$hc.format,e.$rc=w?e.$gc.parse:e.$hc.parse,e.$sc=w?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=w?e.$gc.sep:e.$hc.sep,e.$uc=w?e.$gc.delimiter:e.$hc.delimiter}),define(ae[44],ce([0,1,14,5,27,13]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=A,e.$lg=I,e.$mg=C,e.$ng=$,e.$og=E,e.$pg=l,e.$qg=w,e.$rg=p,e.$sg=h,e.$tg=g,e.$ug=f,e.$vg=c,e.$wg=d,e.$xg=i,e.$yg=o,e.$zg=t;function A(r){return r===47||r===92}function I(r){return r.replace(/[\\/]/g,R.$hc.sep)}function C(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}function $(r,a=R.$hc.sep){if(!r)return"";const y=r.length,v=r.charCodeAt(0);if(A(v)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let S=3;const k=S;for(;S<y&&!A(r.charCodeAt(S));S++);if(k!==S&&!A(r.charCodeAt(S+1))){for(S+=1;S<y;S++)if(A(r.charCodeAt(S)))return r.slice(0,S+1).replace(/[\\/]/g,a)}}return a}else if(h(v)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let P=r.indexOf("://");if(P!==-1){for(P+=3;P<y;P++)if(A(r.charCodeAt(P)))return r.slice(0,P+1)}return""}function E(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let y=2;const v=y;for(;y<r.length&&(a=r.charCodeAt(y),a!==92);y++);return!(v===y||(a=r.charCodeAt(y+1),isNaN(a)||a===92))}const b=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(r,a=N.$i){const y=a?b:m;return!(!r||r.length===0||/^\s+$/.test(r)||(y.lastIndex=0,y.test(r))||a&&u.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}function w(r,a,y){const v=r===a;return!y||v?v:!r||!a?!1:(0,L.$uf)(r,a)}function p(r,a,y,v=R.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(y){if(!(0,L.$vf)(r,a))return!1;if(a.length===r.length)return!0;let S=a.length;return a.charAt(a.length-1)===v&&S--,r.charAt(S)===v}return a.charAt(a.length-1)!==v&&(a+=v),r.indexOf(a)===0}function h(r){return r>=65&&r<=90||r>=97&&r<=122}function g(r,a){return N.$i&&r.endsWith(":")&&(r+=R.sep),(0,R.$jc)(r)||(r=(0,R.$kc)(a,r)),r=(0,R.$ic)(r),N.$i?(r=(0,L.$cf)(r,R.sep),r.endsWith(":")&&(r+=R.sep)):(r=(0,L.$cf)(r,R.sep),r||(r=R.sep)),r}function f(r){const a=(0,R.$ic)(r);return N.$i?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===R.$hc.sep}function c(r,a=N.$i){return a?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}function d(r,a=N.$i){return c(r,a)?r[0]:void 0}function i(r,a,y){return a.length>r.length?-1:r===a?0:(y&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}function o(r){const a=r.split(":");let y,v,P;for(const S of a){const k=Number(S);(0,j.$9f)(k)?v===void 0?v=k:P===void 0&&(P=k):y=y?[y,S].join(":"):S}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:v!==void 0?v:void 0,column:P!==void 0?P:v!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,y=8){let v="";for(let S=0;S<y;S++){let k;S===0&&N.$i&&!a&&(y===3||y===4)?k=s:k=n,v+=k.charAt(Math.floor(Math.random()*k.length))}let P;return a?P=`${a}-${v}`:P=v,r?(0,R.$kc)(r,P):P}}),define(ae[141],ce([0,1,14]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=void 0,e.$Ls=j,e.$Ms=A,e.$Ns=I,e.$Os=$,e.$Ks=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(E){const b=(0,R.$pc)(E),m=N[b.toLowerCase()];return m!==void 0?m:A(E)}function A(E){const b=(0,R.$pc)(E);return L[b.toLowerCase()]}function I(E){for(const b in L)if(L[b]===E)return b}const C=/^(.+)\/(.+?)(;.+)?$/;function $(E,b){const m=C.exec(E);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:b?void 0:E}}),define(ae[89],ce([0,1,5]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=j,e.$im=A;var N;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function j(I,...C){const $=C.reduce((m,u)=>(m[u]=!0,m),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!$[m]).forEach(m=>{for(let u=0;u<E.length;u++)if(m.search(E[u])!==-1){delete I[m];break}})}function A(I){I&&(delete I.DEBUG,R.$j&&delete I.DYLD_LIBRARY_PATH,R.$k&&delete I.LD_PRELOAD)}}),define(ae[8],ce([0,1,14,5]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=l,e.$xc=c;const L=/^\w[\w\d+.-]*$/,j=/^\//,A=/^\/\//;function I(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!j.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(s,t){return!s&&!t?"file":s}function $(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==b&&(t=b+t):t=b;break}return t}const E="",b="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(t){return t instanceof u?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,y,v,P=!1){typeof t=="object"?(this.scheme=t.scheme||E,this.authority=t.authority||E,this.path=t.path||E,this.query=t.query||E,this.fragment=t.fragment||E):(this.scheme=C(t,P),this.authority=r||E,this.path=$(this.scheme,a||E),this.query=y||E,this.fragment=v||E,I(this,P))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:y,query:v,fragment:P}=t;return r===void 0?r=this.scheme:r===null&&(r=E),a===void 0?a=this.authority:a===null&&(a=E),y===void 0?y=this.path:y===null&&(y=E),v===void 0?v=this.query:v===null&&(v=E),P===void 0?P=this.fragment:P===null&&(P=E),r===this.scheme&&a===this.authority&&y===this.path&&v===this.query&&P===this.fragment?this:new p(r,a,y,v,P)}static parse(t,r=!1){const a=m.exec(t);return a?new p(a[2]||E,n(a[4]||E),n(a[5]||E),n(a[7]||E),n(a[9]||E),r):new p(E,E,E,E,E)}static file(t){let r=E;if(N.$i&&(t=t.replace(/\\/g,b)),t[0]===b&&t[1]===b){const a=t.indexOf(b,2);a===-1?(r=t.substring(2),t=b):(r=t.substring(2,a),t=t.substring(a)||b)}return new p("file",r,t,E,E)}static from(t,r){return new p(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&t.scheme==="file"?a=u.file(R.$gc.join(c(t,!0),...r)).path:a=R.$hc.join(t.path,...r),t.with({path:a})}toString(t=!1){return d(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof u)return t;{const r=new p(t);return r._formatted=t.external??null,r._fsPath=t._sep===w?t.fsPath??null:null,r}}else return t}}e.URI=u;function l(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const w=N.$i?1:void 0;class p extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=w),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const h={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(s,t,r){let a,y=-1;for(let v=0;v<s.length;v++){const P=s.charCodeAt(v);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||t&&P===47||r&&P===91||r&&P===93||r&&P===58)y!==-1&&(a+=encodeURIComponent(s.substring(y,v)),y=-1),a!==void 0&&(a+=s.charAt(v));else{a===void 0&&(a=s.substr(0,v));const S=h[P];S!==void 0?(y!==-1&&(a+=encodeURIComponent(s.substring(y,v)),y=-1),a+=S):y===-1&&(y=v)}}return y!==-1&&(a+=encodeURIComponent(s.substring(y))),a!==void 0?a:s}function f(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=h[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,N.$i&&(r=r.replace(/\//g,"\\")),r}function d(s,t){const r=t?f:g;let a="",{scheme:y,authority:v,path:P,query:S,fragment:k}=s;if(y&&(a+=y,a+=":"),(v||y==="file")&&(a+=b,a+=b),v){let D=v.indexOf("@");if(D!==-1){const T=v.substr(0,D);v=v.substr(D+1),D=T.lastIndexOf(":"),D===-1?a+=r(T,!1,!1):(a+=r(T.substr(0,D),!1,!1),a+=":",a+=r(T.substr(D+1),!1,!0)),a+="@"}v=v.toLowerCase(),D=v.lastIndexOf(":"),D===-1?a+=r(v,!1,!0):(a+=r(v.substr(0,D),!1,!0),a+=v.substr(D))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const D=P.charCodeAt(1);D>=65&&D<=90&&(P=`/${String.fromCharCode(D+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const D=P.charCodeAt(0);D>=65&&D<=90&&(P=`${String.fromCharCode(D+32)}:${P.substr(2)}`)}a+=r(P,!0,!1)}return S&&(a+="?",a+=r(S,!1,!1)),k&&(a+="#",a+=t?k:g(k,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(ae[142],ce([0,1,8]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=N,e.$Rq=L,e.$Sq=j,e.log=I;function N($){const E=$;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function L($){const E=[];let b;try{const m=JSON.parse($.arguments),u=m[m.length-1];u&&u.__$stack&&(m.pop(),b=u.__$stack),E.push(...m)}catch{E.push("Unable to log remote console arguments",$.arguments)}return{args:E,stack:b}}function j($){if(typeof $!="string")return j(L($).stack);const E=$;if(E){const b=A(E),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(m&&m.length===4)return{uri:R.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function A($){if(!$)return $;const E=$.indexOf(`
`);return E===-1?$:$.substring(0,E)}function I($,E){const{args:b,stack:m}=L($),u=typeof b[0]=="string"&&b.length===1;let l=A(m);l&&(l=`(${l.trim()})`);let w=[];if(typeof b[0]=="string"?l&&u?w=[`%c[${E}] %c${b[0]} %c${l}`,C("blue"),C(""),C("grey")]:w=[`%c[${E}] %c${b[0]}`,C("blue"),C(""),...b.slice(1)]:w=[`%c[${E}]%`,C("blue"),...b],l&&!u&&w.push(l),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,w)}function C($){return`color: ${$}`}}),define(ae[66],ce([0,1,15,8]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=L,e.$Zh=j,e.$1h=I;function L(C){return JSON.stringify(C,A)}function j(C){let $=JSON.parse(C);return $=I($),$}function A(C,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function I(C,$=0){if(!C||$>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return N.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 17:return new Date(C.source)}if(C instanceof R.$Ce||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let E=0;E<C.length;++E)C[E]=I(C[E],$+1);else for(const E in C)Object.hasOwnProperty.call(C,E)&&(C[E]=I(C[E],$+1))}return C}}),define(ae[23],ce([0,1,7,5,27,8,14]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Eg=e.$Dg=e.$Cg=e.Schemas=void 0,e.$Ag=C,e.$Bg=$,e.$Fg=b;var I;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(I||(e.Schemas=I={}));function C(l,w){return j.URI.isUri(l)?(0,L.$uf)(l.scheme,w):(0,L.$vf)(l,w+":")}function $(l,...w){return w.some(p=>C(l,p))}e.$Cg="vscode-tkn",e.$Dg="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w,p){this.f=b(w,p)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,I.vscodeRemoteResource)}set(w,p,h){this.a[w]=p,this.b[w]=h}setConnectionToken(w,p){this.c[w]=p}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)try{return this.e(w)}catch(d){return R.$1(d),w}const p=w.authority;let h=this.a[p];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const g=this.b[p],f=this.c[p];let c=`path=${encodeURIComponent(w.path)}`;return typeof f=="string"&&(c+=`&${e.$Dg}=${encodeURIComponent(f)}`),j.URI.from({scheme:N.$o?this.d:I.vscodeRemoteResource,authority:`${h}:${g}`,path:this.g,query:c})}}e.$Eg=new E;function b(l,w){return A.$hc.join(w??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Gg="vs/../../extensions",e.$Hg="vs/../../node_modules",e.$Ig="vs/../../node_modules.asar",e.$Jg="vs/../../node_modules.asar.unpacked",e.$Kg="vscode-app";class m{static{this.a=e.$Kg}asBrowserUri(w){const p=this.b(w,ne);return this.uriToBrowserUri(p)}uriToBrowserUri(w){return w.scheme===I.vscodeRemote?e.$Eg.rewrite(w):w.scheme===I.file&&(N.$m||N.$q===`${I.vscodeFileResource}://${m.a}`)?w.with({scheme:I.vscodeFileResource,authority:w.authority||m.a,query:null,fragment:null}):w}asFileUri(w){const p=this.b(w,ne);return this.uriToFileUri(p)}uriToFileUri(w){return w.scheme===I.vscodeFileResource?w.with({scheme:I.file,authority:w.authority!==m.a?w.authority:null,query:null,fragment:null}):w}b(w,p){return j.URI.isUri(w)?w:j.URI.parse(p.toUrl(w))}}e.$Lg=new m;var u;(function(l){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(w.get("3"));const p="vscode-coi";function h(f){let c;typeof f=="string"?c=new URL(f).searchParams:f instanceof URL?c=f.searchParams:j.URI.isUri(f)&&(c=new URL(f.toString(!0)).searchParams);const d=c?.get(p);if(d)return w.get(d)}l.getHeadersFromQuery=h;function g(f,c,d){if(!globalThis.crossOriginIsolated)return;const i=c&&d?"3":d?"2":"1";f instanceof URLSearchParams?f.set(p,i):f[p]=i}l.addSearchParam=g})(u||(e.COI=u={}))}),define(ae[143],ce([0,1,124,23,5,8]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TD=E;class A{constructor(m,u,l){this.id=m,this.dependencies=u,this.callback=l}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,u,l)=>{typeof m!="string"&&(l=u,u=m,m=null),(typeof u!="object"||!Array.isArray(u))&&(l=u,u=null),this.c.push(new A(m,u,l))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const u=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!u)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(m){return new Promise((u,l)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const p=()=>{w.removeEventListener("load",h),w.removeEventListener("error",g)},h=f=>{p(),u(this.c.pop())},g=f=>{p(),l(f)};w.addEventListener("load",h),w.addEventListener("error",g),this.f&&(m=this.f.createScriptURL(m)),w.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(w)})}i(m){return new Promise((u,l)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),u(this.c.pop())}catch(w){l(w)}})}async j(m){try{const u=globalThis._VSCODE_NODE_MODULES.fs,l=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,p=j.URI.parse(m).fsPath,h=u.readFileSync(p).toString(),g=w.wrap(h.replace(/^#!.*/,""));return new l.Script(g).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const C=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function E(b,m,u){if(R.$T){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[b]&&(b=$[b]);const l=`${b}/${m}`;if(C.has(l))return C.get(l);let w;if(/^\w[\w\d+.-]*:\/\//.test(l))w=l;else{const f=`${u&&!L.$o?N.$Ig:N.$Hg}/${l}`;w=N.$Lg.asBrowserUri(f).toString(!0)}const p=I.INSTANCE.load(w);return C.set(l,p),p}else return await new Promise((l,w)=>{ne([b],l,w)})}}),define(ae[20],ce([0,1,44,23,14,5,27,8]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0,e.$Sg=C,e.$bh=E,e.$ch=m;function C(u){return(0,I.$xc)(u,!0)}class ${constructor(l){this.a=l}compare(l,w,p=!1){return l===w?0:(0,A.$nf)(this.getComparisonKey(l,p),this.getComparisonKey(w,p))}isEqual(l,w,p=!1){return l===w?!0:!l||!w?!1:this.getComparisonKey(l,p)===this.getComparisonKey(w,p)}getComparisonKey(l,w=!1){return l.with({path:this.a(l)?l.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(l){return this.a(l)}isEqualOrParent(l,w,p=!1){if(l.scheme===w.scheme){if(l.scheme===N.Schemas.file)return R.$rg(C(l),C(w),this.a(l))&&l.query===w.query&&(p||l.fragment===w.fragment);if((0,e.$0g)(l.authority,w.authority))return R.$rg(l.path,w.path,this.a(l),"/")&&l.query===w.query&&(p||l.fragment===w.fragment)}return!1}joinPath(l,...w){return I.URI.joinPath(l,...w)}basenameOrAuthority(l){return(0,e.$2g)(l)||l.authority}basename(l){return L.$hc.basename(l.path)}extname(l){return L.$hc.extname(l.path)}dirname(l){if(l.path.length===0)return l;let w;return l.scheme===N.Schemas.file?w=I.URI.file(L.$nc(C(l))).path:(w=L.$hc.dirname(l.path),l.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),w="/")),l.with({path:w})}normalizePath(l){if(!l.path.length)return l;let w;return l.scheme===N.Schemas.file?w=I.URI.file(L.$ic(C(l))).path:w=L.$hc.normalize(l.path),l.with({path:w})}relativePath(l,w){if(l.scheme!==w.scheme||!(0,e.$0g)(l.authority,w.authority))return;if(l.scheme===N.Schemas.file){const g=L.$mc(C(l),C(w));return j.$i?R.$lg(g):g}let p=l.path||"/";const h=w.path||"/";if(this.a(l)){let g=0;for(const f=Math.min(p.length,h.length);g<f&&!(p.charCodeAt(g)!==h.charCodeAt(g)&&p.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);p=h.substr(0,g)+p.substr(g)}return L.$hc.relative(p,h)}resolvePath(l,w){if(l.scheme===N.Schemas.file){const p=I.URI.file(L.$lc(C(l),w));return l.with({authority:p.authority,path:p.path})}return w=R.$mg(w),l.with({path:L.$hc.resolve(l.path,w)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,w){return l===w||l!==void 0&&w!==void 0&&(0,A.$uf)(l,w)}hasTrailingPathSeparator(l,w=L.sep){if(l.scheme===N.Schemas.file){const p=C(l);return p.length>R.$ng(p).length&&p[p.length-1]===w}else{const p=l.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,w=L.sep){return(0,e.$$g)(l,w)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,w=L.sep){let p=!1;if(l.scheme===N.Schemas.file){const h=C(l);p=h!==void 0&&h.length===R.$ng(h).length&&h[h.length-1]===w}else{w="/";const h=l.path;p=h.length===1&&h.charCodeAt(h.length-1)===47}return!p&&!(0,e.$$g)(l,w)?l.with({path:l.path+"/"}):l}}e.$Tg=$,e.$Ug=new $(()=>!1),e.$Vg=new $(u=>u.scheme===N.Schemas.file?!j.$k:!0),e.$Wg=new $(u=>!0),e.$Xg=e.$Ug.isEqual.bind(e.$Ug),e.$Yg=e.$Ug.isEqualOrParent.bind(e.$Ug),e.$Zg=e.$Ug.getComparisonKey.bind(e.$Ug),e.$1g=e.$Ug.basenameOrAuthority.bind(e.$Ug),e.$2g=e.$Ug.basename.bind(e.$Ug),e.$3g=e.$Ug.extname.bind(e.$Ug),e.$4g=e.$Ug.dirname.bind(e.$Ug),e.$5g=e.$Ug.joinPath.bind(e.$Ug),e.$6g=e.$Ug.normalizePath.bind(e.$Ug),e.$7g=e.$Ug.relativePath.bind(e.$Ug),e.$8g=e.$Ug.resolvePath.bind(e.$Ug),e.$9g=e.$Ug.isAbsolutePath.bind(e.$Ug),e.$0g=e.$Ug.isEqualAuthority.bind(e.$Ug),e.$$g=e.$Ug.hasTrailingPathSeparator.bind(e.$Ug),e.$_g=e.$Ug.removeTrailingPathSeparator.bind(e.$Ug),e.$ah=e.$Ug.addTrailingPathSeparator.bind(e.$Ug);function E(u,l){const w=[];for(let p=0;p<u.length;p++){const h=l(u[p]);u.some((g,f)=>f===p?!1:(0,e.$Yg)(h,l(g)))||w.push(u[p])}return w}var b;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function l(w){const p=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,d]=f.split(":");c&&d&&p.set(c,d)});const g=w.path.substring(0,w.path.indexOf(";"));return g&&p.set(u.META_DATA_MIME,g),p}u.parseMetaData=l})(b||(e.DataUri=b={}));function m(u,l,w){if(l){let p=u.path;return p&&p[0]!==L.$hc.sep&&(p=L.$hc.sep+p),u.with({scheme:w,authority:l,path:p})}return u.with({scheme:w})}}),define(ae[6],ce([0,1,26,7,3,2,20,5,130,53]),function(ne,e,R,N,L,j,A,I,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.Promises=e.$Oh=e.$Nh=e.$Mh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0,e.$dh=E,e.$eh=b,e.$fh=m,e.$gh=u,e.$hh=l,e.$ih=w,e.$jh=p,e.$kh=h,e.$sh=r,e.$th=a,e.$uh=y,e.$vh=v,e.$wh=P,e.$Lh=B,e.$Th=K;function E(_){return!!_&&typeof _.then=="function"}function b(_){const Z=new R.$me,se=_(Z.token),ue=new Promise((ge,fe)=>{const $e=Z.token.onCancellationRequested(()=>{$e.dispose(),fe(new N.$5)});Promise.resolve(se).then(ye=>{$e.dispose(),Z.dispose(),ge(ye)},ye=>{$e.dispose(),Z.dispose(),fe(ye)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(ge,fe){return ue.then(ge,fe)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function m(_,Z,se){return new Promise((ue,ge)=>{const fe=Z.onCancellationRequested(()=>{fe.dispose(),ue(se)});_.then(ue,ge).finally(()=>fe.dispose())})}function u(_,Z){return new Promise((se,ue)=>{const ge=Z.onCancellationRequested(()=>{ge.dispose(),ue(new N.$5)});_.then(se,ue).finally(()=>ge.dispose())})}async function l(_){let Z=-1;const se=_.map((ue,ge)=>ue.then(fe=>(Z=ge,fe)));try{return await Promise.race(se)}finally{_.forEach((ue,ge)=>{ge!==Z&&ue.cancel()})}}function w(_,Z,se){let ue;const ge=setTimeout(()=>{ue?.(void 0),se?.()},Z);return Promise.race([_.finally(()=>clearTimeout(ge)),new Promise(fe=>ue=fe)])}function p(_){return new Promise((Z,se)=>{const ue=_();E(ue)?ue.then(Z,se):Z(ue)})}function h(){let _,Z;return{promise:new Promise((ue,ge)=>{_=ue,Z=ge}),resolve:_,reject:Z}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const se=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(se,se).then(ue)})}return new Promise((se,ue)=>{this.b.then(se,ue)})}return this.a=Z(),new Promise((se,ue)=>{this.a.then(ge=>{this.a=null,se(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$lh=g;class f{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$mh=f;class c{constructor(){this.a=new Map}queue(Z,se){const ge=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(Z)===ge&&this.a.delete(Z)});return this.a.set(Z,ge),ge}}e.$nh=c;const d=(_,Z)=>{let se=!0;const ue=setTimeout(()=>{se=!1,Z()},_);return{isTriggered:()=>se,dispose:()=>{clearTimeout(ue),se=!1}}},i=_=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,_())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class o{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,se=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((ge,fe)=>{this.d=ge,this.f=fe}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=se===C.$$d?i(ue):d(se,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$oh=o;class n{constructor(Z){this.a=new o(Z),this.b=new g}trigger(Z,se){return this.a.trigger(()=>this.b.queue(Z),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ph=n;class s{constructor(){this.a=!1,this.b=new Promise((Z,se)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$qh=s;class t extends s{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$rh=t;function r(_,Z){return Z?new Promise((se,ue)=>{const ge=setTimeout(()=>{fe.dispose(),se()},_),fe=Z.onCancellationRequested(()=>{clearTimeout(ge),fe.dispose(),ue(new N.$5)})}):b(se=>r(_,se))}function a(_,Z=0,se){const ue=setTimeout(()=>{_(),se&&ge.dispose()},Z),ge=(0,j.$Sc)(()=>{clearTimeout(ue),se?.deleteAndLeak(ge)});return se?.add(ge),ge}function y(_){const Z=[];let se=0;const ue=_.length;function ge(){return se<ue?_[se++]():null}function fe($e){$e!=null&&Z.push($e);const ye=ge();return ye?ye.then(fe):Promise.resolve(Z)}return Promise.resolve(null).then(fe)}function v(_,Z=ue=>!!ue,se=null){let ue=0;const ge=_.length,fe=()=>{if(ue>=ge)return Promise.resolve(se);const $e=_[ue++];return Promise.resolve($e()).then(ve=>Z(ve)?Promise.resolve(ve):fe())};return fe()}function P(_,Z=ue=>!!ue,se=null){if(_.length===0)return Promise.resolve(se);let ue=_.length;const ge=()=>{ue=-1;for(const fe of _)fe.cancel?.()};return new Promise((fe,$e)=>{for(const ye of _)ye.then(ve=>{--ue>=0&&Z(ve)?(ge(),fe(ve)):ue===0&&fe(se)}).catch(ve=>{--ue>=0&&(ge(),$e(ve))})})}class S{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new L.$be}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,ue)=>{this.g.push({factory:Z,c:se,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const se=Z.factory();se.then(Z.c,Z.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$xh=S;class k extends S{constructor(){super(1)}}e.$yh=k;class D{constructor(){this.a=new ie,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$zh=D;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new te;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,se=A.$Ug){const ue=se.getComparisonKey(Z);return this.a.get(ue)?.size??0}queueFor(Z,se,ue=A.$Ug){const ge=ue.getComparisonKey(Z);let fe=this.a.get(ge);if(!fe){fe=new k;const $e=this.f++,ye=L.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$4c),this.d.set($e,ye),this.a.set(ge,fe)}return fe.queue(se)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ah=T;class F{constructor(Z,se){this.a=-1,typeof Z=="function"&&typeof se=="number"&&this.setIfNotSet(Z,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},se)}setIfNotSet(Z,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},se))}}e.$Bh=F;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,se,ue=globalThis){this.cancel();const ge=ue.setInterval(()=>{Z()},se);this.d=(0,j.$Sc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel()}}e.$Ch=U;class Q{constructor(Z,se){this.b=-1,this.a=Z,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Dh=Q;class G{constructor(Z,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=Z,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Eh=G;class Y extends Q{constructor(Z,se){super(Z,se),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Fh=Y;class W extends j.$Uc{constructor(Z,se){super(),this.g=Z,this.h=se,this.a=[],this.b=this.B(new j.$Vc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of Z)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Gh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ih=(_,Z)=>{(0,I.$B)(()=>{if(se)return;const ue=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Ih=(_,Z,se)=>{const ue=_.requestIdleCallback(Z,typeof se=="number"?{timeout:se}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,_.cancelIdleCallback(ue))}}},e.$Hh=_=>(0,e.$Ih)(globalThis,_)}();class J{constructor(Z,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Ih)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Jh=J;class H extends J{constructor(Z){super(globalThis,Z)}}e.$Kh=H;async function B(_,Z,se){let ue;for(let ge=0;ge<se;ge++)try{return await _()}catch(fe){ue=fe,await r(Z)}throw ue}class ie{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,se,ue){return this.a={taskId:Z,cancel:()=>ue?.(),promise:se},se.then(()=>this.d(Z),()=>this.d(Z)),se}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:se,resolve:ue,reject:ge}=h();this.b={run:Z,promise:se,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Mh=ie;class re{constructor(Z,se=()=>Date.now()){this.d=Z,this.f=se,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$Nh=re;var he;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(he||(he={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Z,se)=>{this.a=Z,this.b=se})}complete(Z){return new Promise(se=>{this.a(Z),this.d={outcome:0,value:Z},se()})}error(Z){return new Promise(se=>{this.b(Z),this.d={outcome:1,value:Z},se()})}cancel(){return this.error(new N.$5)}}e.$Oh=te;var V;(function(_){async function Z(ue){let ge;const fe=await Promise.all(ue.map($e=>$e.then(ye=>ye,ye=>{ge||(ge=ye)})));if(typeof ge<"u")throw ge;return fe}_.settled=Z;function se(ue){return new Promise(async(ge,fe)=>{try{await ue(ge,fe)}catch($e){fe($e)}})}_.withAsyncBody=se})(V||(e.Promises=V={}));class z{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ph=z;class O{constructor(Z){this.b=Z,this.a=new $.$V(()=>new z(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Qh=O;var M;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(M||(M={}));class q{static fromArray(Z){return new q(se=>{se.emitMany(Z)})}static fromPromise(Z){return new q(async se=>{se.emitMany(await Z)})}static fromPromises(Z){return new q(async se=>{await Promise.all(Z.map(async ue=>se.emitOne(await ue)))})}static merge(Z){return new q(async se=>{await Promise.all(Z.map(async ue=>{for await(const ge of ue)se.emitOne(ge)}))})}static{this.EMPTY=q.fromArray([])}constructor(Z,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new L.$be,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Z(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,se){return new q(async ue=>{for await(const ge of Z)ue.emitOne(se(ge))})}map(Z){return q.map(this,Z)}static filter(Z,se){return new q(async ue=>{for await(const ge of Z)se(ge)&&ue.emitOne(ge)})}filter(Z){return q.filter(this,Z)}static coalesce(Z){return q.filter(Z,se=>!!se)}coalesce(){return q.coalesce(this)}static async toPromise(Z){const se=[];for await(const ue of Z)se.push(ue);return se}toPromise(){return q.toPromise(this)}h(Z){this.a===0&&(this.b.push(Z),this.g.fire())}j(Z){this.a===0&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Z){this.a===0&&(this.a=2,this.d=Z,this.g.fire())}}e.$Rh=q;class x extends q{constructor(Z,se){super(se),this.m=Z}cancel(){this.m.cancel()}}e.$Sh=x;function K(_){const Z=new R.$me,se=_(Z.token);return new x(Z,async ue=>{const ge=Z.token.onCancellationRequested(()=>{ge.dispose(),Z.dispose(),ue.reject(new N.$5)});try{for await(const fe of se){if(Z.token.isCancellationRequested)return;ue.emitOne(fe)}ge.dispose(),Z.dispose()}catch(fe){ge.dispose(),Z.dispose(),ue.reject(fe)}})}class ee{constructor(Z){this.a=new te,this.b=new q(ge=>{if(se){ge.reject(se);return}return ue&&ge.emitMany(ue),this.d=fe=>ge.reject(fe),this.f=fe=>ge.emitOne(fe),this.a.p},Z);let se,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{se||(se=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$Uh=ee}),define(ae[90],ce([0,1,17,6,44,34,14,5,27]),function(ne,e,R,N,L,j,A,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=void 0,e.$gk=$,e.$jk=l,e.$kk=k,e.$lk=D,e.$mk=T,e.$nk=F,e.$ok=U,e.$pk=W;function $(){return Object.create(null)}e.$hk="**",e.$ik="/";const E="[/\\\\]",b="[^/\\\\]",m=/\//g;function u(J,H){switch(J){case 0:return"";case 1:return`${b}*?`;default:return`(?:${E}|${b}+${E}${H?`|${E}${b}+`:""})*?`}}function l(J,H){if(!J)return[];const B=[];let ie=!1,re=!1,he="";for(const te of J){switch(te){case H:if(!ie&&!re){B.push(he),he="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":re=!0;break;case"]":re=!1;break}he+=te}return he&&B.push(he),B}function w(J){if(!J)return"";let H="";const B=l(J,e.$ik);if(B.every(ie=>ie===e.$hk))H=".*";else{let ie=!1;B.forEach((re,he)=>{if(re===e.$hk){if(ie)return;H+=u(2,he===B.length-1)}else{let te=!1,V="",z=!1,O="";for(const M of re){if(M!=="}"&&te){V+=M;continue}if(z&&(M!=="]"||!O)){let q;M==="-"?q=M:(M==="^"||M==="!")&&!O?q="^":M===e.$ik?q="":q=(0,C.$9e)(M),O+=q;continue}switch(M){case"{":te=!0;continue;case"[":z=!0;continue;case"}":{const x=`(?:${l(V,",").map(K=>w(K)).join("|")})`;H+=x,te=!1,V="";break}case"]":{H+="["+O+"]",z=!1,O="";break}case"?":H+=b;continue;case"*":H+=u(1);continue;default:H+=(0,C.$9e)(M)}}he<B.length-1&&(B[he+1]!==e.$hk||he+2<B.length)&&(H+=E)}ie=re===e.$hk})}return H}const p=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new j.$Ec(1e4),o=function(){return!1},n=function(){return null};function s(J,H){if(!J)return n;let B;typeof J!="string"?B=J.pattern:B=J,B=B.trim();const ie=`${B}_${!!H.trimForExclusions}`;let re=i.get(ie);if(re)return t(re,J);let he;return p.test(B)?re=a(B.substr(4),B):(he=h.exec(r(B,H)))?re=y(he[1],B):(H.trimForExclusions?f:g).test(B)?re=v(B,H):(he=c.exec(r(B,H)))?re=P(he[1].substr(1),B,!0):(he=d.exec(r(B,H)))?re=P(he[1],B,!1):re=S(B),i.set(ie,re),t(re,J)}function t(J,H){if(typeof H=="string")return J;const B=function(ie,re){return(0,L.$rg)(ie,H.base,!I.$k)?J((0,C.$bf)(ie.substr(H.base.length),A.sep),re):null};return B.allBasenames=J.allBasenames,B.allPaths=J.allPaths,B.basenames=J.basenames,B.patterns=J.patterns,B}function r(J,H){return H.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function a(J,H){return function(B,ie){return typeof B=="string"&&B.endsWith(J)?H:null}}function y(J,H){const B=`/${J}`,ie=`\\${J}`,re=function(te,V){return typeof te!="string"?null:V?V===J?H:null:te===J||te.endsWith(B)||te.endsWith(ie)?H:null},he=[J];return re.basenames=he,re.patterns=[H],re.allBasenames=he,re}function v(J,H){const B=Y(J.slice(1,-1).split(",").map(V=>s(V,H)).filter(V=>V!==n),J),ie=B.length;if(!ie)return n;if(ie===1)return B[0];const re=function(V,z){for(let O=0,M=B.length;O<M;O++)if(B[O](V,z))return J;return null},he=B.find(V=>!!V.allBasenames);he&&(re.allBasenames=he.allBasenames);const te=B.reduce((V,z)=>z.allPaths?V.concat(z.allPaths):V,[]);return te.length&&(re.allPaths=te),re}function P(J,H,B){const ie=A.sep===A.$hc.sep,re=ie?J:J.replace(m,A.sep),he=A.sep+re,te=A.$hc.sep+J;let V;return B?V=function(z,O){return typeof z=="string"&&(z===re||z.endsWith(he)||!ie&&(z===J||z.endsWith(te)))?H:null}:V=function(z,O){return typeof z=="string"&&(z===re||!ie&&z===J)?H:null},V.allPaths=[(B?"*/":"./")+J],V}function S(J){try{const H=new RegExp(`^${w(J)}$`);return function(B){return H.lastIndex=0,typeof B=="string"&&H.test(B)?J:null}}catch{return n}}function k(J,H,B){return!J||typeof H!="string"?!1:D(J)(H,void 0,B)}function D(J,H={}){if(!J)return o;if(typeof J=="string"||T(J)){const B=s(J,H);if(B===n)return o;const ie=function(re,he){return!!B(re,he)};return B.allBasenames&&(ie.allBasenames=B.allBasenames),B.allPaths&&(ie.allPaths=B.allPaths),ie}return Q(J,H)}function T(J){const H=J;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}function F(J){return J.allBasenames||[]}function U(J){return J.allPaths||[]}function Q(J,H){const B=Y(Object.getOwnPropertyNames(J).map(V=>G(V,J[V],H)).filter(V=>V!==n)),ie=B.length;if(!ie)return n;if(!B.some(V=>!!V.requiresSiblings)){if(ie===1)return B[0];const V=function(M,q){let x;for(let K=0,ee=B.length;K<ee;K++){const _=B[K](M,q);if(typeof _=="string")return _;(0,N.$dh)(_)&&(x||(x=[]),x.push(_))}return x?(async()=>{for(const K of x){const ee=await K;if(typeof ee=="string")return ee}return null})():null},z=B.find(M=>!!M.allBasenames);z&&(V.allBasenames=z.allBasenames);const O=B.reduce((M,q)=>q.allPaths?M.concat(q.allPaths):M,[]);return O.length&&(V.allPaths=O),V}const re=function(V,z,O){let M,q;for(let x=0,K=B.length;x<K;x++){const ee=B[x];ee.requiresSiblings&&O&&(z||(z=(0,A.$oc)(V)),M||(M=z.substr(0,z.length-(0,A.$pc)(V).length)));const _=ee(V,z,M,O);if(typeof _=="string")return _;(0,N.$dh)(_)&&(q||(q=[]),q.push(_))}return q?(async()=>{for(const x of q){const K=await x;if(typeof K=="string")return K}return null})():null},he=B.find(V=>!!V.allBasenames);he&&(re.allBasenames=he.allBasenames);const te=B.reduce((V,z)=>z.allPaths?V.concat(z.allPaths):V,[]);return te.length&&(re.allPaths=te),re}function G(J,H,B){if(H===!1)return n;const ie=s(J,B);if(ie===n)return n;if(typeof H=="boolean")return ie;if(H){const re=H.when;if(typeof re=="string"){const he=(te,V,z,O)=>{if(!O||!ie(te,V))return null;const M=re.replace("$(basename)",()=>z),q=O(M);return(0,N.$dh)(q)?q.then(x=>x?J:null):q?J:null};return he.requiresSiblings=!0,he}}return ie}function Y(J,H){const B=J.filter(V=>!!V.basenames);if(B.length<2)return J;const ie=B.reduce((V,z)=>{const O=z.basenames;return O?V.concat(O):V},[]);let re;if(H){re=[];for(let V=0,z=ie.length;V<z;V++)re.push(H)}else re=B.reduce((V,z)=>{const O=z.patterns;return O?V.concat(O):V},[]);const he=function(V,z){if(typeof V!="string")return null;if(!z){let M;for(M=V.length;M>0;M--){const q=V.charCodeAt(M-1);if(q===47||q===92)break}z=V.substr(M)}const O=ie.indexOf(z);return O!==-1?re[O]:null};he.basenames=ie,he.patterns=re,he.allBasenames=ie;const te=J.filter(V=>!V.basenames);return te.push(he),te}function W(J,H){return(0,R.$ub)(J,H,(B,ie)=>typeof B=="string"&&typeof ie=="string"?B===ie:typeof B!="string"&&typeof ie!="string"?B.base===ie.base&&B.pattern===ie.pattern:!1)}}),define(ae[91],ce([0,1,15,8]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=void 0,e.$vn=I,e.$wn=$,e.$xn=E;function L(b){return b.toJSON()}class j{constructor(m){this.a=m}transformIncoming(m){const u=this.a.transformIncoming(m);return u===m?m:L(N.URI.from(u))}transformOutgoing(m){const u=this.a.transformOutgoing(m);return u===m?m:L(N.URI.from(u))}transformOutgoingURI(m){const u=this.a.transformOutgoing(m);return u===m?m:N.URI.from(u)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$tn=j,e.$un=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function A(b,m,u){if(!b||u>200)return null;if(typeof b=="object"){if(b instanceof N.URI)return m.transformOutgoing(b);for(const l in b)if(Object.hasOwnProperty.call(b,l)){const w=A(b[l],m,u+1);w!==null&&(b[l]=w)}}return null}function I(b,m){const u=A(b,m,0);return u===null?b:u}function C(b,m,u,l){if(!b||l>200)return null;if(typeof b=="object"){if(b.$mid===1)return u?N.URI.revive(m.transformIncoming(b)):m.transformIncoming(b);if(b instanceof R.$Ce)return null;for(const w in b)if(Object.hasOwnProperty.call(b,w)){const p=C(b[w],m,u,l+1);p!==null&&(b[w]=p)}}return null}function $(b,m){const u=C(b,m,!1,0);return u===null?b:u}function E(b,m){const u=C(b,m,!0,0);return u===null?b:u}}),define(ae[144],ce([0,1,37,51,32,131,5]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=void 0,e.$An=C,e.$Bn=b,e.$zn=new class{c(m){return this.a||(this.a=N.$xi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,u=0;const l=(0,R.networkInterfaces)();for(const w in l){const p=l[w];if(p)for(const{mac:h,internal:g}of p)g||(u+=1,this.c(h.toUpperCase())&&(m+=1))}this.b=u>0?m/u:0}return this.b}};let I;async function C(m){return I||(I=(async()=>await $(m)||L.$Ng())()),I}async function $(m){try{const u=await new Promise((w,p)=>{ne(["crypto"],w,p)}),l=(0,j.$yn)();return u.createHash("sha256").update(l,"utf8").digest("hex")}catch(u){m(u);return}}const E="Software\\Microsoft\\SQMClient";async function b(m){if(A.$i){const u=await new Promise((l,w)=>{ne(["@vscode/windows-registry"],l,w)});try{return u.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(l){return m(l),""}}return""}}),define(ae[145],ce([0,1,40,146,14,36]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BW=E,e.$CW=b;const A="XDG_SESSION_TYPE",I="WAYLAND_DISPLAY",C="XDG_RUNTIME_DIR";var $;(function(m){m.Wayland="wayland",m.XWayland="xwayland",m.X11="x11",m.Unknown="unknown"})($||($={}));async function E(m){const u=j.env[A];if(u)return u==="wayland"||u==="x11"?u:"unknown";if(j.env[I]){const w=j.env[C];if(w){const p=(0,L.$kc)(w,"wayland-0");try{return await(0,N.access)(p,R.constants.R_OK),"wayland"}catch(h){return m(h),"unknown"}}else return"unknown"}else return"x11"}function b(m,u){if(u)switch(u){case"auto":return m;case"x11":return m==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return m==="wayland"?"xwayland":"x11"}}),define(ae[147],ce([0,1,40,146,274,5]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Og=A;async function A(I){if(j.$j||j.$i)return;let C;for(const $ of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{C=await(0,N.open)($,R.constants.R_OK);break}catch{}if(!C){I("Unable to retrieve release information from known identifier paths.");return}try{const $=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const b of(0,L.createInterface)({input:C.createReadStream(),crlfDelay:1/0})){if(!b.includes("="))continue;const m=b.split("=")[0].toUpperCase().trim();if($.has(m)){const u=b.split("=")[1].replace(/"/g,"").toLowerCase().trim();m==="ID"||m==="DISTRIB_ID"?E.id=u:m==="ID_LIKE"?E.id_like=u:(m==="VERSION_ID"||m==="DISTRIB_RELEASE")&&(E.version_id=u)}}return E}catch($){I($)}}}),define(ae[31],ce([0,1,40,37,275,6,44,87,14,5,20,8]),function(ne,e,R,N,L,j,A,I,C,$,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=p,e.readdirSync=f,e.whenDeleted=i,e.configureFlushOnWrite=r,e.writeFileSync=y;var m;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function u(G,Y=m.UNLINK,W){if((0,A.$ug)(G))throw new Error("rimraf - will refuse to recursively delete root");return Y===m.UNLINK?w(G):l(G,W)}async function l(G,Y=(0,A.$zg)((0,N.tmpdir)())){try{try{await R.promises.rename(G,Y)}catch(W){return W.code==="ENOENT"?void 0:w(G)}w(Y).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function w(G){return(0,L.promisify)(R.rm)(G,{recursive:!0,force:!0,maxRetries:3})}function p(G){if((0,A.$ug)(G))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function h(G,Y){return c(await(Y?g(G):(0,L.promisify)(R.readdir)(G)))}async function g(G){try{return await(0,L.promisify)(R.readdir)(G,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const Y=[],W=await h(G);for(const J of W){let H=!1,B=!1,ie=!1;try{const re=await e.Promises.lstat((0,C.$kc)(G,J));H=re.isFile(),B=re.isDirectory(),ie=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}Y.push({name:J,isFile:()=>H,isDirectory:()=>B,isSymbolicLink:()=>ie})}return Y}function f(G){return c(R.readdirSync(G))}function c(G){return G.map(Y=>typeof Y=="string"?$.$j?(0,I.$9l)(Y):Y:(Y.name=$.$j?(0,I.$9l)(Y.name):Y.name,Y))}async function d(G){const Y=await h(G),W=[];for(const J of Y)await o.existsDirectory((0,C.$kc)(G,J))&&W.push(J);return W}function i(G,Y=1e3){return new Promise(W=>{let J=!1;const H=setInterval(()=>{J||(J=!0,R.access(G,B=>{J=!1,B&&(clearInterval(H),W(void 0))}))},Y)})}var o;(function(G){async function Y(H){let B;try{if(B=await e.Promises.lstat(H),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if($.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw re}throw ie}}G.stat=Y;async function W(H){try{const{stat:B,symbolicLink:ie}=await G.stat(H);return B.isFile()&&ie?.dangling!==!0}catch{}return!1}G.existsFile=W;async function J(H){try{const{stat:B,symbolicLink:ie}=await G.stat(H);return B.isDirectory()&&ie?.dangling!==!0}catch{}return!1}G.existsDirectory=J})(o||(e.SymlinkSupport=o={}));const n=new j.$Ah;function s(G,Y,W){return n.queueFor(b.URI.file(G),()=>{const J=v(W);return new Promise((H,B)=>a(G,Y,J,ie=>ie?B(ie):H()))},E.$Vg)}let t=!0;function r(G){t=G}function a(G,Y,W,J){if(!t)return R.writeFile(G,Y,{mode:W.mode,flag:W.flag},J);R.open(G,W.flag,W.mode,(H,B)=>{if(H)return J(H);R.writeFile(B,Y,ie=>{if(ie)return R.close(B,()=>J(ie));R.fdatasync(B,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),r(!1)),R.close(B,he=>J(he))))})})}function y(G,Y,W){const J=v(W);if(!t)return R.writeFileSync(G,Y,{mode:J.mode,flag:J.flag});const H=R.openSync(G,J.flag,J.mode);try{R.writeFileSync(H,Y);try{R.fdatasyncSync(H)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r(!1)}}finally{R.closeSync(H)}}function v(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function P(G,Y,W=6e4){if(G!==Y)try{$.$i&&typeof W=="number"?await S(G,Y,Date.now(),W):await(0,L.promisify)(R.rename)(G,Y)}catch(J){if(G.toLowerCase()!==Y.toLowerCase()&&J.code==="EXDEV"||G.endsWith("."))await k(G,Y,{preserveSymlinks:!1}),await u(G,m.MOVE);else throw J}}async function S(G,Y,W,J,H=0){try{return await(0,L.promisify)(R.rename)(G,Y)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-W>=J)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${B}`),B;if(H===0){let ie=!1;try{const{stat:re}=await o.stat(Y);re.isFile()||(ie=!0)}catch{}if(ie)throw B}return await(0,j.$sh)(Math.min(100,H*10)),S(G,Y,W,J,H+1)}}async function k(G,Y,W){return T(G,Y,{root:{source:G,target:Y},options:W,handledSourcePaths:new Set})}const D=511;async function T(G,Y,W){if(W.handledSourcePaths.has(G))return;W.handledSourcePaths.add(G);const{stat:J,symbolicLink:H}=await o.stat(G);if(H){if(W.options.preserveSymlinks)try{return await Q(G,Y,W)}catch{}if(H.dangling)return}return J.isDirectory()?F(G,Y,J.mode&D,W):U(G,Y,J.mode&D)}async function F(G,Y,W,J){await e.Promises.mkdir(Y,{recursive:!0,mode:W});const H=await h(G);for(const B of H)await T((0,C.$kc)(G,B),(0,C.$kc)(Y,B),J)}async function U(G,Y,W){await e.Promises.copyFile(G,Y),await e.Promises.chmod(Y,W)}async function Q(G,Y,W){let J=await e.Promises.readlink(G);(0,A.$rg)(J,W.root.source,!$.$k)&&(J=(0,C.$kc)(W.root.target,J.substr(W.root.source.length+1))),await e.Promises.symlink(J,Y)}e.Promises=new class{get access(){return(0,L.promisify)(R.access)}get stat(){return(0,L.promisify)(R.stat)}get lstat(){return(0,L.promisify)(R.lstat)}get utimes(){return(0,L.promisify)(R.utimes)}get read(){return(G,Y,W,J,H)=>new Promise((B,ie)=>{R.read(G,Y,W,J,H,(re,he,te)=>re?ie(re):B({bytesRead:he,buffer:te}))})}get readFile(){return(0,L.promisify)(R.readFile)}get write(){return(G,Y,W,J,H)=>new Promise((B,ie)=>{R.write(G,Y,W,J,H,(re,he,te)=>re?ie(re):B({bytesWritten:he,buffer:te}))})}get appendFile(){return(0,L.promisify)(R.appendFile)}get fdatasync(){return(0,L.promisify)(R.fdatasync)}get truncate(){return(0,L.promisify)(R.truncate)}get copyFile(){return(0,L.promisify)(R.copyFile)}get open(){return(0,L.promisify)(R.open)}get close(){return(0,L.promisify)(R.close)}get symlink(){return(0,L.promisify)(R.symlink)}get readlink(){return(0,L.promisify)(R.readlink)}get chmod(){return(0,L.promisify)(R.chmod)}get mkdir(){return(0,L.promisify)(R.mkdir)}get unlink(){return(0,L.promisify)(R.unlink)}get rmdir(){return(0,L.promisify)(R.rmdir)}get realpath(){return(0,L.promisify)(R.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return d}get writeFile(){return s}get rm(){return u}get rename(){return P}get copy(){return k}}}),define(ae[148],ce([0,1,40,14,5,27,31]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=I,e.$Zq=C,e.$1q=$,e.$2q=E;function I(m){if(L.$k)return m;const u=(0,N.$nc)(m);if(m===u)return m;const l=((0,N.$oc)(m)||m).toLowerCase();try{const p=(0,A.readdirSync)(u).filter(h=>h.toLowerCase()===l);if(p.length===1){const h=I(u);if(h)return(0,N.$kc)(h,p[0])}else if(p.length>1){const h=p.indexOf(l);if(h>=0){const g=I(u);if(g)return(0,N.$kc)(g,p[h])}}}catch{}return null}async function C(m,u){if(L.$k)return m;const l=(0,N.$nc)(m);if(m===l)return m;const w=((0,N.$oc)(m)||m).toLowerCase();try{if(u?.isCancellationRequested)return null;const h=(await A.Promises.readdir(l)).filter(g=>g.toLowerCase()===w);if(h.length===1){const g=await C(l,u);if(g)return(0,N.$kc)(g,h[0])}else if(h.length>1){const g=h.indexOf(w);if(g>=0){const f=await C(l,u);if(f)return(0,N.$kc)(f,h[g])}}}catch{}return null}async function $(m){try{return await A.Promises.realpath(m)}catch{const l=b(m);return await A.Promises.access(l,R.constants.R_OK),l}}function E(m){try{return R.realpathSync(m)}catch{const l=b(m);return R.accessSync(l,R.constants.R_OK),l}}function b(m){return(0,j.$cf)((0,N.$ic)(m),N.sep)}}),define(ae[149],ce([0,1,14,5,36,89,13,31]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$jm=C,e.$km=$,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function C(b=L.env){return b.comspec||"cmd.exe"}function $(b){let m=[],u=!1;const l=function(w){if(u){m.push(w);return}(!b.send(w,h=>{if(h&&console.error(h),u=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(f=>l(f))}})||N.$i)&&(u=!0)};return{send:l}}var E;(function(b){async function m(u,l,w){if(R.$jc(u))return u;if(l===void 0&&(l=L.cwd()),R.$nc(u)!=="."||(w===void 0&&A.$5f(L.env.PATH)&&(w=L.env.PATH.split(R.$uc)),w===void 0||w.length===0))return R.$kc(l,u);async function h(g){if(await I.Promises.exists(g)){let f;try{f=await I.Promises.stat(g)}catch(c){c.message.startsWith("EACCES")&&(f=await I.Promises.lstat(g))}return f?!f.isDirectory():!1}return!1}for(const g of w){let f;if(R.$jc(g)?f=R.$kc(g,u):f=R.$kc(l,g,u),await h(f))return f;let c=f+".com";if(await h(c)||(c=f+".exe",await h(c)))return c}return R.$kc(l,u)}b.findExecutable=m})(E||(e.win32=E={}))}),define(ae[150],ce([0,1,67,23]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=L;function L(A){return new Promise((I,C)=>{let $;const E=new Map;function b(u,l,w,p,h){const g=E.get(l);if(u===A||g){const f={name:m(w),cmd:w,pid:u,ppid:l,load:p,mem:h};E.set(u,f),u===A&&($=f),g&&(g.children||(g.children=[]),g.children.push(f),g.children.length>1&&(g.children=g.children.sort((c,d)=>c.pid-d.pid)))}}function m(u){const l=/--utility-sub-type=network/i,w=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(w.exec(u))return"electron-crash-reporter";if(p.exec(u))return"winpty-agent";if(h.exec(u))return"conpty-agent";let f=g.exec(u);if(f&&f.length===2)return f[1]==="renderer"?"window":f[1]==="utility"?l.exec(u)?"utility-network-service":"utility-process":f[1]==="extensionHost"?"extension-host":f[1];const c=/[a-zA-Z-]+\.js/g;let d="";do f=c.exec(u),f&&(d+=f+" ");while(f);return d&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${d})`:u}if(process.platform==="win32"){const u=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,w)=>{ne(["@vscode/windows-process-tree"],l,w)}).then(l=>{l.getProcessList(A,w=>{if(!w){C(new Error(`Root process ${A} not found`));return}l.getProcessCpuUsage(w,p=>{const h=new Map;p.forEach(g=>{const f=u(g.commandLine||"");h.set(g.pid,{name:m(f),cmd:f,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),$=h.get(A),$?(h.forEach(g=>{const f=h.get(g.ppid);f&&(f.children||(f.children=[]),f.children.push(g))}),h.forEach(g=>{g.children&&(g.children=g.children.sort((f,c)=>f.pid-c.pid))}),I($)):C(new Error(`Root process ${A} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let u=function(){let l=[$];const w=[];for(;l.length;){const h=l.shift();h&&(w.push(h.pid),h.children&&(l=l.concat(h.children)))}let p=JSON.stringify(N.$Lg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+w.join(" "),(0,R.exec)(p,{},(h,g,f)=>{if(h||f)C(h||new Error(f.toString()));else{const c=g.toString().split(`
`);for(let d=0;d<w.length;d++){const i=E.get(w[d]);i.load=parseFloat(c[d])}if(!$){C(new Error(`Root process ${A} not found`));return}I($)}})};(0,R.exec)("which ps",{},(l,w,p)=>{if(l||p)if(process.platform!=="linux")C(l||new Error(p.toString()));else{const h=JSON.stringify(N.$Lg.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(h,{},(g,f,c)=>{g||c?C(g||new Error(c.toString())):(j(f,b),u())})}else{const h=w.toString().trim();(0,R.exec)(`${h} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,c,d)=>{f||d&&!d.includes("screen size is bogus")?C(f||new Error(d.toString())):(j(c,b),process.platform==="linux"?u():$?I($):C(new Error(`Root process ${A} not found`)))})}})}})}function j(A,I){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,$=A.toString().split(`
`);for(const E of $){const b=C.exec(E.trim());b&&b.length===6&&I(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}});var Ee=this&&this.__decorate||function(ne,e,R,N){var L=arguments.length,j=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,R):N,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ne,e,R,N);else for(var I=ne.length-1;I>=0;I--)(A=ne[I])&&(j=(L<3?A(j):L>3?A(e,R,j):A(e,R))||j);return L>3&&j&&Object.defineProperty(e,R,j),j};define(ae[41],ce([0,1,17,6,15,26,84,7,3,2,66,27,13]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.ProxyChannel=e.$_h=e.$9h=e.$8h=e.$7h=e.RequestInitiator=e.$6h=e.$3h=e.$2h=void 0,e.$4h=r,e.$5h=a,e.$0h=D,e.$$h=T;var u;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(u||(u={}));function l(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(w||(w={}));function p(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(h||(h={}));function g(H){let B=0;for(let ie=0;;ie+=7){const re=H.read(1);if(B|=(re.buffer[0]&127)<<ie,!(re.buffer[0]&128))return B}}const f=n(0);function c(H,B){if(B===0){H.write(f);return}let ie=0;for(let he=B;he!==0;he=he>>>7)ie++;const re=L.$Ce.alloc(ie);for(let he=0;B!==0;he++)re.buffer[he]=B&127,B=B>>>7,B>0&&(re.buffer[he]|=128);H.write(re)}class d{constructor(B){this.b=B,this.a=0}read(B){const ie=this.b.slice(this.a,this.a+B);return this.a+=ie.byteLength,ie}}e.$2h=d;class i{constructor(){this.a=[]}get buffer(){return L.$Ce.concat(this.a)}write(B){this.a.push(B)}}e.$3h=i;var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(o||(o={}));function n(H){const B=L.$Ce.alloc(1);return B.writeUInt8(H,0),B}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(H,B){if(typeof B>"u")H.write(s.Undefined);else if(typeof B=="string"){const ie=L.$Ce.fromString(B);H.write(s.String),c(H,ie.byteLength),H.write(ie)}else if(t&&Buffer.isBuffer(B)){const ie=L.$Ce.wrap(B);H.write(s.Buffer),c(H,ie.byteLength),H.write(ie)}else if(B instanceof L.$Ce)H.write(s.VSBuffer),c(H,B.byteLength),H.write(B);else if(Array.isArray(B)){H.write(s.Array),c(H,B.length);for(const ie of B)r(H,ie)}else if(typeof B=="number"&&(B|0)===B)H.write(s.Uint),c(H,B);else{const ie=L.$Ce.fromString(JSON.stringify(B));H.write(s.Object),c(H,ie.byteLength),H.write(ie)}}function a(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(g(H)).toString();case o.Buffer:return H.read(g(H)).buffer;case o.VSBuffer:return H.read(g(H));case o.Array:{const ie=g(H),re=[];for(let he=0;he<ie;he++)re.push(a(H));return re}case o.Object:return JSON.parse(H.read(g(H)).toString());case o.Int:return g(H)}}class y{constructor(B,ie,re=null,he=1e3){this.h=B,this.j=ie,this.k=re,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(B,ie){this.b.set(B,ie),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const ie=this.o([B.type]);this.k?.logOutgoing(ie,0,1,p(B.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([B.type,B.id],B.data);this.k?.logOutgoing(ie,B.id,1,p(B.type),B.data);return}}}o(B,ie=void 0){const re=new i;return r(re,B),r(re,ie),this.p(re.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const ie=new d(B),re=a(ie),he=a(ie),te=re[0];switch(te){case 100:return this.k?.logIncoming(B.byteLength,re[1],1,`${l(te)}: ${re[2]}.${re[3]}`,he),this.s({type:te,id:re[1],channelName:re[2],name:re[3],arg:he});case 102:return this.k?.logIncoming(B.byteLength,re[1],1,`${l(te)}: ${re[2]}.${re[3]}`,he),this.t({type:te,id:re[1],channelName:re[2],name:re[3],arg:he});case 101:return this.k?.logIncoming(B.byteLength,re[1],1,`${l(te)}`),this.u({type:te,id:re[1]});case 103:return this.k?.logIncoming(B.byteLength,re[1],1,`${l(te)}`),this.u({type:te,id:re[1]})}}s(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const re=new j.$me;let he;try{he=ie.call(this.j,B.name,B.arg,re.token)}catch(z){he=Promise.reject(z)}const te=B.id;he.then(z=>{this.m({id:te,data:z,type:201})},z=>{z instanceof Error?this.m({id:te,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:te,data:z,type:203})}).finally(()=>{V.dispose(),this.d.delete(B.id)});const V=(0,$.$Sc)(()=>re.cancel());this.d.set(B.id,V)}t(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const re=B.id,te=ie.listen(this.j,B.name,B.arg)(V=>this.m({id:re,data:V,type:204}));this.d.set(B.id,te)}u(B){const ie=this.d.get(B.id);ie&&(ie.dispose(),this.d.delete(B.id))}v(B){let ie=this.g.get(B.channelName);ie||(ie=[],this.g.set(B.channelName,ie));const re=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:B,timeoutTimer:re})}w(B){const ie=this.g.get(B);if(ie){for(const re of ie)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}e.$6h=y;var v;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class P{constructor(B,ie=null){this.l=B,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ie}getChannel(B){const ie=this;return{call(re,he,te){return ie.a?Promise.reject(new I.$5):ie.m(B,re,he,te)},listen(re,he){return ie.a?C.Event.None:ie.o(B,re,he)}}}m(B,ie,re,he=j.CancellationToken.None){const te=this.g++,z={id:te,type:100,channelName:B,name:ie,arg:re};if(he.isCancellationRequested)return Promise.reject(new I.$5);let O;return new Promise((q,x)=>{if(he.isCancellationRequested)return x(new I.$5);const K=()=>{const se=ue=>{switch(ue.type){case 201:this.f.delete(te),q(ue.data);break;case 202:{this.f.delete(te);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,x(ge);break}case 203:this.f.delete(te),x(ue.data);break}};this.f.set(te,se),this.p(z)};let ee=null;this.b===h.Idle?K():(ee=(0,N.$eh)(se=>this.u()),ee.then(()=>{ee=null,K()}));const _=()=>{ee?(ee.cancel(),ee=null):this.p({id:te,type:101}),x(new I.$5)},Z=he.onCancellationRequested(_);O=(0,$.$Rc)((0,$.$Sc)(_),Z),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(B,ie,re){const he=this.g++,V={id:he,type:102,channelName:B,name:ie,arg:re};let z=null;const O=new C.$be({onWillAddFirstListener:()=>{z=(0,N.$eh)(q=>this.u()),z.then(()=>{z=null,this.d.add(O),this.p(V)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(O),this.p({id:he,type:103}))}}),M=q=>O.fire(q.data);return this.f.set(he,M),O.event}p(B){switch(B.type){case 100:case 102:{const ie=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(ie,B.id,0,`${l(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const ie=this.q([B.type,B.id]);this.j?.logOutgoing(ie,B.id,0,l(B.type));return}}}q(B,ie=void 0){const re=new i;return r(re,B),r(re,ie),this.r(re.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const ie=new d(B),re=a(ie),he=a(ie),te=re[0];switch(te){case 200:return this.j?.logIncoming(B.byteLength,0,0,p(te)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,re[1],0,p(te),he),this.t({type:re[0],id:re[1],data:he})}}t(B){if(B.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}e.$7h=P,Ee([A.$Vh],P.prototype,"onDidInitializePromise",null);class S{get connections(){const B=[];return this.f.forEach(ie=>B.push(ie)),B}constructor(B,ie,re){this.a=new Map,this.f=new Set,this.g=new C.$be,this.onDidAddConnection=this.g.event,this.h=new C.$be,this.onDidRemoveConnection=this.h.event,this.j=new $.$Tc,this.j.add(B(({protocol:he,onDidClientDisconnect:te})=>{const V=C.Event.once(he.onMessage);this.j.add(V(z=>{const O=new d(z),M=a(O),q=new y(he,M,ie,re),x=new P(he,ie);this.a.forEach((ee,_)=>q.registerChannel(_,ee));const K={channelServer:q,channelClient:x,ctx:M};this.f.add(K),this.g.fire(K),this.j.add(te(()=>{q.dispose(),x.dispose(),this.f.delete(K),this.h.fire(K)}))}))}))}getChannel(B,ie){const re=this;return{call(he,te,V){let z;if((0,m.$gg)(ie)){const M=(0,R.$4b)(re.connections.filter(ie));z=M?Promise.resolve(M):C.Event.toPromise(C.Event.filter(re.onDidAddConnection,ie))}else z=ie.routeCall(re,he,te);const O=z.then(M=>M.channelClient.getChannel(B));return D(O).call(he,te,V)},listen(he,te){if((0,m.$gg)(ie))return re.k(B,ie,he,te);const V=ie.routeEvent(re,he,te).then(z=>z.channelClient.getChannel(B));return D(V).listen(he,te)}}}k(B,ie,re,he){const te=this;let V;const z=new C.$be({onWillAddFirstListener:()=>{V=new $.$Tc;const O=new C.$he,M=new Map,q=K=>{const _=K.channelClient.getChannel(B).listen(re,he),Z=O.add(_);M.set(K,Z)},x=K=>{const ee=M.get(K);ee&&(ee.dispose(),M.delete(K))};te.connections.filter(ie).forEach(q),C.Event.filter(te.onDidAddConnection,ie)(q,void 0,V),te.onDidRemoveConnection(x,void 0,V),O.event(z.fire,z,V),V.add(O)},onDidRemoveLastListener:()=>{V?.dispose(),V=void 0}});return z.event}registerChannel(B,ie){this.a.set(B,ie);for(const re of this.f)re.channelServer.registerChannel(B,ie)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$8h=S;class k{constructor(B,ie,re=null){const he=new i;r(he,ie),B.send(he.buffer),this.a=new P(B,re),this.d=new y(B,ie,re)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,ie){this.d.registerChannel(B,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$9h=k;function D(H){return{call(B,ie,re){return H.then(he=>he.call(B,ie,re))},listen(B,ie){const re=new C.$ke;return H.then(he=>re.input=he.listen(B,ie)),re.event}}}function T(H){let B=!1;return{call(ie,re,he){return B?H.call(ie,re,he):(0,N.$sh)(0).then(()=>B=!0).then(()=>H.call(ie,re,he))},listen(ie,re){if(B)return H.listen(ie,re);const he=new C.$ke;return(0,N.$sh)(0).then(()=>B=!0).then(()=>he.input=H.listen(ie,re)),he.event}}}class F{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const ie of B.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await C.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$_h=F;var U;(function(H){function B(te,V,z){const O=te,M=z&&z.disableMarshalling,q=new Map;for(const x in O)re(x)&&q.set(x,C.Event.buffer(O[x],!0,void 0,V));return new class{listen(x,K,ee){const _=q.get(K);if(_)return _;const Z=O[K];if(typeof Z=="function"){if(he(K))return Z.call(O,ee);if(re(K))return q.set(K,C.Event.buffer(O[K],!0,void 0,V)),q.get(K)}throw new I.$bb(`Event not found: ${K}`)}call(x,K,ee){const _=O[K];if(typeof _=="function"){if(!M&&Array.isArray(ee))for(let se=0;se<ee.length;se++)ee[se]=(0,E.$1h)(ee[se]);let Z=_.apply(O,ee);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new I.$bb(`Method not found: ${K}`)}}}H.fromService=B;function ie(te,V){const z=V&&V.disableMarshalling;return new Proxy({},{get(O,M){if(typeof M=="string")return V?.properties?.has(M)?V.properties.get(M):he(M)?function(q){return te.listen(M,q)}:re(M)?te.listen(M):async function(...q){let x;V&&!(0,m.$bg)(V.context)?x=[V.context,...q]:x=q;const K=await te.call(M,x);return z?K:(0,E.$1h)(K)};throw new I.$bb(`Property not found: ${String(M)}`)}})}H.toService=ie;function re(te){return te[0]==="o"&&te[1]==="n"&&b.$tf(te.charCodeAt(2))}function he(te){return/^onDynamic/.test(te)&&b.$tf(te.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const B=H.toString();if(B!=="[object Object]")return B}return H}function Y(H){return Array.isArray(H)?H.map(G):G(H)}function W(H,B,ie,re,he,te,V){V=Y(V);const z=Q[he],O=z[re%z.length];let M=[`%c[${H}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(te)?(M=M.concat(V),M.push(")")):M.push(V),console.log.apply(console,M)}class J{constructor(B,ie){this.d=B,this.f=ie,this.a=0,this.b=0}logOutgoing(B,ie,re,he,te){this.b+=B,W(this.d,this.b,B,ie,re,he,te)}logIncoming(B,ie,re,he,te){this.a+=B,W(this.f,this.a,B,ie,re,he,te)}}e.$ai=J}),define(ae[68],ce([0,1,15,3,2,41]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.ProtocolConstants=e.$bi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(v,P){if(!t.has(v)){const S=String(++r);t.set(v,S)}return t.get(v)}function y(v,P,S,k){if(!s.enableDiagnostics)return;const D=a(v,P);if(k instanceof R.$Ce||k instanceof Uint8Array||k instanceof ArrayBuffer||ArrayBuffer.isView(k)){const T=R.$Ce.alloc(k.byteLength);T.set(k),s.records.push({timestamp:Date.now(),id:D,label:P,type:S,buff:T})}else s.records.push({timestamp:Date.now(),id:D,label:P,type:S,data:k})}s.traceSocketEvent=y})(I||(e.SocketDiagnostics=I={}));var C;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C||(e.SocketCloseEventType=C={}));let $=null;function E(){return $||($=R.$Ce.alloc(0)),$}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return E();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const P=this.a[0];return r&&(this.a.shift(),this.b-=t),P}if(this.a[0].byteLength>t){const P=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),P}const a=R.$Ce.alloc(t);let y=0,v=0;for(;t>0;){const P=this.a[v];if(P.byteLength>t){const S=P.slice(0,t);a.set(S,y),y+=t,r&&(this.a[v]=P.slice(t),this.b-=t),t-=t}else a.set(P,y),y+=P.byteLength,r?(this.a.shift(),this.b-=P.byteLength):v++,t-=P.byteLength}return a}}e.$bi=b;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function u(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var l;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class w{constructor(t,r,a,y){this.type=t,this.id=r,this.ack=a,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends L.$Uc{constructor(t){super(),this.f=this.B(new N.$be),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new b,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,y=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new w(a,y,v,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=R.$Ce.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=R.$Ce.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class g extends L.$Uc{constructor(t){super(),this.f=new N.$be,this.onMessage=this.f.event,this.g=new N.$be,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new h(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new w(1,0,0,t))}}e.$ci=g;class f extends j.$9h{static fromSocket(t,r){return new f(new g(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$di=f;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$be({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$ei=c;class d{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new d(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let y=0;y<o.a;y++)t-this.c[y]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=t.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new w(5,0,0,E());this.p.write(t),this.p.flush()}sendPause(){const t=new w(7,0,0,E());this.p.write(t)}sendResume(){const t=new w(8,0,0,E());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new w(3,0,this.h,E());this.p.write(t);const r=this.b.toArray();for(let a=0,y=r.length;a<y;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new w(6,0,0,E())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,y=r.length;a<y;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new w(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new w(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(r>=2e4&&a>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const v=Math.max(2e4-r,2e4-a,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new w(3,0,this.h,E());this.p.write(t)}D(){this.h=this.g;const t=new w(9,0,this.h,E());this.p.write(t)}}e.$fi=n}),define(ae[92],ce([0,1,67,6,15,26,142,7,3,2,30,149,89,41]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;class l extends u.$6h{constructor(h){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",g=>L.$Ce.wrap(Buffer.from(g,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Uq=l;class w{constructor(h,g){this.i=h,this.j=g,this.c=new Set,this.g=new Map,this.h=new C.$be,this.onDidProcessExit=this.h.event;const f=g&&g.timeout?g.timeout:6e4;this.b=new N.$oh(f),this.d=null,this.f=null}getChannel(h){const g=this;return{call(f,c,d){return g.k(h,f,c,d)},listen(f,c){return g.l(h,f,c)}}}k(h,g,f,c=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const d=this.n(h),i=(0,N.$eh)(s=>d.call(g,f,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,$.$Sc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(h,g,f){if(!this.b)return C.Event.None;this.b.cancel();let c;const d=new C.$be({onWillAddFirstListener:()=>{c=this.n(h).listen(g,f)(d.fire,d),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return d.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,E.$Xn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.$im)(g.env),this.d=(0,R.fork)(this.i,h,g);const f=new C.$be,d=C.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,A.$Qq)(r)){(0,A.log)(r,`IPC Library: ${this.j.serverName}`);return}f.fire(L.$Ce.wrap(Buffer.from(r,"base64")))}),i=this.j.useQueue?(0,b.$km)(this.d):this.d,o=r=>this.d&&this.d.connected&&i.send(r.buffer.toString("base64")),n=f.event,s={send:o,onMessage:n};this.f=new u.$7h(s);const t=()=>this.o();process.once("exit",t),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",t),d.dispose(),this.c.forEach(y=>(0,$.$Pc)(y)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(h){let g=this.g.get(h);return g||(g=this.m.getChannel(h),this.g.set(h,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Vq=w}),define(ae[151],ce([0,1,134,15,41,3,13,17]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TW=void 0,e.$UW=E;class C{constructor(m){this.a=m,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",u=>u.data?N.$Ce.wrap(u.data):N.$Ce.alloc(0)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class $ extends L.$8h{static b(m){(0,A.$cg)((0,R.$SW)(process),"Electron Utility Process");const u=new j.$be;return process.parentPort.on("message",l=>{if(m?.handledClientConnection(l))return;const w=(0,I.$Ob)(l.ports);w&&u.fire(w)}),j.Event.map(u.event,l=>({protocol:new C(l),onDidClientDisconnect:j.Event.fromNodeEventEmitter(l,"close")}))}constructor(m){super($.b(m))}}e.$TW=$;function E(b,m,u){const l=w=>{w.data===m&&(b.removeListener("message",l),u())};b.on("message",l)}}),define(ae[69],ce([0,1,6,3,2,66,13]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.StorageState=e.StorageHint=void 0,e.$Qp=C;var I;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function C(m){const u=m;return u?.changed instanceof Map||u?.deleted instanceof Set}var $;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})($||(e.StorageState=$={}));class E extends L.$Uc{static{this.a=100}constructor(u,l=Object.create(null)){super(),this.r=u,this.s=l,this.b=this.B(new N.$ee),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=this.B(new R.$ph(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(u=>this.u(u)))}u(u){this.b.pause();try{u.changed?.forEach((l,w)=>this.w(w,l)),u.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(u,l){if(this.c===$.Closed)return;let w=!1;(0,A.$bg)(l)?w=this.f.delete(u):this.f.get(u)!==l&&(this.f.set(u,l),w=!0),w&&this.b.fire({key:u,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(u,l){const w=this.f.get(u);return(0,A.$bg)(w)?l:w}getBoolean(u,l){const w=this.get(u);return(0,A.$bg)(w)?l:w==="true"}getNumber(u,l){const w=this.get(u);return(0,A.$bg)(w)?l:parseInt(w,10)}getObject(u,l){const w=this.get(u);return(0,A.$bg)(w)?l:(0,j.$Zh)(w)}async set(u,l,w=!1){if(this.c===$.Closed)return;if((0,A.$bg)(l))return this.delete(u,w);const p=(0,A.$7f)(l)||Array.isArray(l)?(0,j.$Yh)(l):String(l);if(this.f.get(u)!==p)return this.f.set(u,p),this.j.set(u,p),this.h.delete(u),this.b.fire({key:u,external:w}),this.D()}async delete(u,l=!1){if(!(this.c===$.Closed||!this.f.delete(u)))return this.h.has(u)||this.h.add(u),this.j.delete(u),this.b.fire({key:u,external:l}),this.D()}async optimize(){if(this.c!==$.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=$.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const u={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(u).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(u){if(this.z)return this.D(u)}async D(u){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),u)}async whenFlushed(){if(this.z)return new Promise(u=>this.n.push(u))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$Rp=E;class b{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(u){u.insert?.forEach((l,w)=>this.a.set(w,l)),u.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$Sp=b}),define(ae[152],ce([11,10]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ae[70],ce([0,1,40,6,14,13,31,152]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0,e.zip=p,e.$dq=h,e.$eq=f,e.$aq="end of central directory record signature not found";const C=new RegExp(e.$aq);class $ extends Error{constructor(d,i){let o=i.message;switch(d){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=d,this.cause=i}}e.$bq=$;function E(c){const d=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>d&i).reduce((i,o)=>i+o,d&61440)}function b(c){if(c instanceof $)return c;let d;return C.test(c.message)&&(d="CorruptZip"),new $(d,c)}function m(c,d,i,o,n,s){const t=L.$nc(d),r=L.$kc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(I.localize(0,null,d)));const a=L.$kc(o,d);let y;return s.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(A.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((v,P)=>{if(!s.isCancellationRequested)try{y=(0,R.createWriteStream)(a,{mode:i}),y.once("close",()=>v()),y.once("error",P),c.once("error",P),c.pipe(y)}catch(S){P(S)}}))}function u(c,d,i,o){let n=(0,N.$eh)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const y=new N.$mh,v=P=>{P.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new $("Incomplete",new Error(I.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",P=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(P.fileName)){v(o);return}const S=P.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(S)){const T=L.$kc(d,S);n=(0,N.$eh)(F=>A.Promises.mkdir(T,{recursive:!0}).then(()=>v(F)).then(void 0,a));return}const k=w(c,P),D=E(P);n=(0,N.$eh)(T=>y.queue(()=>k.then(F=>m(F,S,D,d,i,T).then(()=>v(T)))).then(null,a))})}).finally(()=>t.dispose())}async function l(c,d=!1){const{open:i}=await new Promise((o,n)=>{ne(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,d?{lazyEntries:!0}:void 0,(s,t)=>{s?n(b(s)):o((0,j.$dg)(t))})})}function w(c,d){return new Promise((i,o)=>{c.openReadStream(d,(n,s)=>{n?o(b(n)):i((0,j.$dg)(s))})})}async function p(c,d){const{ZipFile:i}=await new Promise((o,n)=>{ne(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;d.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,R.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}function h(c,d,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=l(c,!0);return i.overwrite&&(s=s.then(t=>A.Promises.rm(d).then(()=>t))),s.then(t=>u(t,d,{sourcePathRegex:n},o))}function g(c,d){return l(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===d&&w(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(I.localize(2,null,d))))}))}function f(c,d){return g(c,d).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}}),define(ae[153],ce([11,10]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[154],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[155],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ae[156],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[157],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[158],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[159],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[160],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[161],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[162],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[163],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ae[164],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ae[165],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ae[166],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[167],ce([11,10]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[168],ce([11,10]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(ae[169],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[170],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[171],ce([11,10]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ae[172],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[173],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[174],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[175],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[176],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[177],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[178],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[179],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[180],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[181],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[182],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[183],ce([11,10]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ae[184],ce([0,1,7,155]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.TokenType=void 0;var L;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(L||(e.TokenType=L={}));function j(...$){switch($.length){case 1:return(0,N.localize)(0,null,$[0]);case 2:return(0,N.localize)(1,null,$[0],$[1]);case 3:return(0,N.localize)(2,null,$[0],$[1],$[2]);default:return}}const A=(0,N.localize)(3,null),I=(0,N.localize)(4,null);class C{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,R.$8)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const b=this.d,m=this.c.substring(this.d,this.e),u={type:19,offset:this.d,lexeme:m};this.g.push({offset:b,lexeme:m,additionalInfo:E}),this.f.push(u)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const b=this.c.substring(this.d,this.e),m=C.b.get(b);m?this.k(m):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,b=!1,m=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(I);return}const l=this.c.charCodeAt(E);if(b)b=!1;else if(l===47&&!m){E++;break}else l===91?m=!0:l===92?b=!0:l===93&&(m=!1);E++}for(;E<this.c.length&&C.a.has(this.c.charCodeAt(E));)E++;this.e=E;const u=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.$mj=C}),define(ae[185],ce([0,1,65,84,23,14,36,20,8]),function(ne,e,R,N,L,j,A,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=void 0,e.$2m=E,e.$3m=b,e.$Zm=/^([^.]+\..+)[:=](.+)$/;class ${get appRoot(){return(0,j.$nc)(L.$Lg.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,j.$kc)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,I.$5g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$5g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,R.$Ym)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$kc)(this.userDataPath,"logs",u)}return C.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$5g)(C.URI.file((0,j.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$5g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$5g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$5g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=A.env.VSCODE_PORTABLE;return u?C.URI.file((0,j.$kc)(u,"argv.json")):(0,I.$5g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,j.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,j.$lc)(u):(0,j.$ic)((0,j.$kc)(L.$Lg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?C.URI.file((0,j.$lc)(u)):C.URI.file((0,j.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,j.$lc)(u);const l=A.env.VSCODE_EXTENSIONS;if(l)return l;const w=A.env.VSCODE_PORTABLE;return w?(0,j.$kc)(w,"extensions"):(0,I.$5g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(l=>/^[^:/?#]+?:\/\//.test(l)?C.URI.parse(l):C.URI.file((0,j.$ic)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?C.URI.parse(u):C.URI.file((0,j.$ic)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$Zm.test(u))}get extensionLogLevel(){const u=[];for(const l of this.args.log||[]){const w=e.$Zm.exec(l);w&&w[1]&&w[2]&&u.push([w[1],w[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,I.$5g)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=A.env.VSCODE_PORTABLE;return u?C.URI.file((0,j.$kc)(u,"policy.json")):(0,I.$5g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,l,w){this.a=u,this.b=l,this.c=w,this.editSessionId=this.args.editSessionId}}e.$1m=$,Ee([N.$Vh],$.prototype,"appRoot",null),Ee([N.$Vh],$.prototype,"userHome",null),Ee([N.$Vh],$.prototype,"userDataPath",null),Ee([N.$Vh],$.prototype,"appSettingsHome",null),Ee([N.$Vh],$.prototype,"tmpDir",null),Ee([N.$Vh],$.prototype,"cacheHome",null),Ee([N.$Vh],$.prototype,"stateResource",null),Ee([N.$Vh],$.prototype,"userRoamingDataHome",null),Ee([N.$Vh],$.prototype,"userDataSyncHome",null),Ee([N.$Vh],$.prototype,"sync",null),Ee([N.$Vh],$.prototype,"machineSettingsResource",null),Ee([N.$Vh],$.prototype,"workspaceStorageHome",null),Ee([N.$Vh],$.prototype,"localHistoryHome",null),Ee([N.$Vh],$.prototype,"keyboardLayoutResource",null),Ee([N.$Vh],$.prototype,"argvResource",null),Ee([N.$Vh],$.prototype,"isExtensionDevelopment",null),Ee([N.$Vh],$.prototype,"untitledWorkspacesHome",null),Ee([N.$Vh],$.prototype,"builtinExtensionsPath",null),Ee([N.$Vh],$.prototype,"extensionsPath",null),Ee([N.$Vh],$.prototype,"extensionDevelopmentLocationURI",null),Ee([N.$Vh],$.prototype,"extensionDevelopmentKind",null),Ee([N.$Vh],$.prototype,"extensionTestsLocationURI",null),Ee([N.$Vh],$.prototype,"debugExtensionHost",null),Ee([N.$Vh],$.prototype,"logLevel",null),Ee([N.$Vh],$.prototype,"extensionLogLevel",null),Ee([N.$Vh],$.prototype,"serviceMachineIdResource",null),Ee([N.$Vh],$.prototype,"disableTelemetry",null),Ee([N.$Vh],$.prototype,"disableWorkspaceTrust",null),Ee([N.$Vh],$.prototype,"useInMemorySecretStorage",null),Ee([N.$Vh],$.prototype,"policyFile",null);function E(m,u){return b(m["inspect-extensions"],m["inspect-brk-extensions"],5870,u,m.debugId,m.extensionEnvironment)}function b(m,u,l,w,p,h){const f=Number(u||m)||(w?null:l),c=f?!!u:!1;let d;if(h)try{d=JSON.parse(h)}catch{}return{port:f,break:c,debugId:p,env:d}}}),function(){"use strict";function ne(e,R,N){function L(A,I){const C=j(A,I),$=[C];return e.isAbsolute(C)||$.unshift(N),e.resolve(...$)}function j(A,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let $=process.env.VSCODE_APPDATA;if($)return e.join($,I);const E=A["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if($=process.env.APPDATA,!$){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");$=e.join(b,"AppData","Roaming")}break;case"darwin":$=e.join(R.homedir(),"Library","Application Support");break;case"linux":$=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join($,I)}return{getUserDataPath:L}}if(typeof define=="function")define(ae[186],ce([276,37,36]),function(e,R,N){return ne(e,R,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=ne(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[187],ce([0,1,37,185,186]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=void 0,e.$5m=A,e.$6m=I;class j extends N.$1m{constructor($,E){super($,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,L.getUserDataPath)($,E.nameShort)},E)}}e.$4m=j;function A(C,$){return(0,N.$3m)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,$,C.extensionEnvironment)}function I(C,$){return(0,N.$3m)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,$,C.extensionEnvironment)}}),define(ae[188],ce([0,1,13,158]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=L;function L(A,I,C,$){try{j(A,I,C,$)}catch(E){A.error(E?.message??E)}return I}function j(A,I,C,$){const E=(b,m,u)=>{const l=b[m];if((0,R.$5f)(l)){const w=l,p=w.length;if(p>1&&w[0]==="%"&&w[p-1]==="%"){const h=w.substr(1,p-2);let g=C[h];g===void 0&&$&&(g=$[h]);const f=typeof g=="string"?g:g?.message,c=$?.[h],d=typeof c=="string"?c:c?.message;if(!f){d||A.warn(`[${I.name}]: ${(0,N.localize)(0,null,h)}`);return}if(u&&(m==="title"||m==="category")&&d&&d!==f){const i={value:f,original:d};b[m]=i}else b[m]=f}}else if((0,R.$7f)(l))for(const w in l)l.hasOwnProperty(w)&&(w==="commands"?E(l,w,!0):E(l,w,u));else if(Array.isArray(l))for(let w=0;w<l.length;w++)E(l,w,u)};for(const b in I)I.hasOwnProperty(b)&&E(I,b)}}),define(ae[189],ce([0,1,70,161]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=L;function L(j){return(0,R.$eq)(j,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}}),define(ae[190],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=void 0;class R{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$6dc=R;class N{constructor(j){this.a=j}listen(j,A){throw new Error(`Event not found: ${A}`)}call(j,A,I){switch(A){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${A}`)}}e.$7dc=N}),define(ae[71],ce([0,1,20,88,162,55]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=C,e.$Cp=$,e.$Dp=E,e.$Ep=b,e.$Fp=m,e.$Gp=u,e.$Hp=l;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(h){return h=h.trim(),h==="*"||A.test(h)}function $(h){if(!C(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=h.match(A);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}function E(h){if(!h)return null;const g=h.majorBase,f=h.majorMustEqual,c=h.minorBase;let d=h.minorMustEqual;const i=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(g===0||(d=!1),o=!1);let n=0;if(h.preRelease){const s=I.exec(h.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:g,majorMustEqual:f,minorBase:c,minorMustEqual:d,patchBase:i,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:n}}function b(h,g,f){let c;typeof h=="string"?c=E($(h)):c=h;let d;g instanceof Date?d=g.getTime():typeof g=="string"&&(d=new Date(g).getTime());let i;if(typeof f=="string"?i=E($(f)):i=f,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const y=i.notBefore;let v=i.majorMustEqual,P=i.minorMustEqual,S=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||d&&d<y?!1:s>=a:(o===1&&t===0&&(!v||!P||!S)&&(t=1,r=0,a=0,v=!0,P=!1,S=!1),o<t?!1:o>t?!v:n<r?!1:n>r?!P:s<a?!1:s>a?!S:!(d&&d<y))}function m(h,g,f,c,d){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([N.default.Error,L.localize(0,null)]),i;if(typeof c.name!="string")return i.push([N.default.Error,L.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([N.default.Error,L.localize(2,null,"version")]),i;if(!c.engines)return i.push([N.default.Error,L.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([N.default.Error,L.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!p(c.extensionDependencies))return i.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!p(c.activationEvents))return i.push([N.default.Error,L.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([N.default.Error,L.localize(9,null,"main")]),i;{const s=(0,R.$5g)(f,c.main);(0,R.$Yg)(s,f)||i.push([N.default.Warning,L.localize(10,null,s.path,f.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([N.default.Error,L.localize(11,null,"browser")]),i;{const s=(0,R.$5g)(f,c.browser);(0,R.$Yg)(s,f)||i.push([N.default.Warning,L.localize(12,null,s.path,f.path)])}}if(!j.valid(c.version))return i.push([N.default.Error,L.localize(13,null)]),i;const o=[];if(!u(h,g,c,d,o))for(const s of o)i.push([N.default.Error,s]);return i}function u(h,g,f,c,d){return c||typeof f.main>"u"&&typeof f.browser>"u"?!0:w(h,g,f.engines.vscode,d)}function l(h,g,f){return h==="*"||w(g,f,h)}function w(h,g,f,c=[]){const d=E($(f));if(!d)return c.push(L.localize(14,null,f)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return c.push(L.localize(15,null,f)),!1}else if(!d.majorMustEqual)return c.push(L.localize(16,null,f)),!1;return b(h,g,d)?!0:(c.push(L.localize(17,null,h,f)),!1)}function p(h){if(!Array.isArray(h))return!1;for(let g=0,f=h.length;g<f;g++)if(typeof h[g]!="string")return!1;return!0}}),define(ae[45],ce([0,1,15,32]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=L;async function L(j,A,I){let C=I&&I.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const E=(await A.readFile(j.serviceMachineIdResource)).value.toString();C=(0,N.$Mg)(E)?E:null}catch{C=null}if(!C){C=(0,N.$Ng)();try{await A.writeFile(j.serviceMachineIdResource,R.$Ce.fromString(C))}catch{}}return I?.store("storage.serviceMachineId",C,-1,1),C}}),define(ae[72],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class R{constructor(L,j=[],A=!1){this.ctor=L,this.staticArguments=j,this.supportsDelayedInstantiation=A}}e.$oi=R}),define(ae[191],ce([0,1,72]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$rs=j,e.$ss=A;const N=[];var L;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function j(I,C,$){C instanceof R.$oi||(C=new R.$oi(C,[],!!$)),N.push([I,C])}function A(){return N}}),define(ae[192],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=void 0;class R{constructor(j,A){this.key=j,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$8q=R;class N{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const A of this.a.values())A.outgoing.size===0&&j.push(A);return j}insertEdge(j,A){const I=this.lookupOrInsertNode(j),C=this.lookupOrInsertNode(A);I.outgoing.set(C.key,C),C.incoming.set(I.key,I)}removeNode(j){const A=this.b(j);this.a.delete(A);for(const I of this.a.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(j){const A=this.b(j);let I=this.a.get(A);return I||(I=new R(A,j),this.a.set(A,I)),I}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[A,I]of this.a)j.push(`${A}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,A]of this.a){const I=new Set([j]),C=this.c(A,I);if(C)return C}}c(j,A){for(const[I,C]of j.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const $=this.c(C,A);if($)return $;A.delete(I)}}}e.$9q=N}),define(ae[4],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e._util=void 0,e.$ri=L,e.$si=j;var R;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(C){return C[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(R||(e._util=R={})),e.$qi=L("instantiationService");function N(A,I,C){I[R.DI_TARGET]===I?I[R.DI_DEPENDENCIES].push({id:A,index:C}):(I[R.DI_DEPENDENCIES]=[{id:A,index:C}],I[R.DI_TARGET]=I)}function L(A){if(R.serviceIds.has(A))return R.serviceIds.get(A);const I=function(C,$,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(I,C,E)};return I.toString=()=>A,R.serviceIds.set(A,I),I}function j(A){return A}}),define(ae[193],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0,e.$Fdc=(0,R.$ri)("checksumService")}),define(ae[21],ce([0,1,13,8,4]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Xi=void 0,e.$Yi=j,e.$Zi=A,e.$1i=C,e.$2i=$,e.$3i=E,e.$4i=b,e.$5i=m,e.$6i=l,e.$7i=w,e.$8i=p,e.$Xi=(0,L.$ri)("configurationService");function j(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof N.URI)}function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof N.URI)}var I;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function C(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function $(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}function E(h,g){const f=Object.create(null);for(const c in h)b(f,c,h[c],g);return f}function b(h,g,f,c){const d=g.split("."),i=d.pop();let o=h;for(let n=0;n<d.length;n++){const s=d[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":if(t===null){c(`Ignoring ${g} as ${d.slice(0,n+1).join(".")} is null`);return}break;default:c(`Ignoring ${g} as ${d.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=f}catch{c(`Ignoring ${g} as ${d.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${g} as ${d.join(".")} is ${JSON.stringify(o)}`)}function m(h,g){const f=g.split(".");u(h,f)}function u(h,g){const f=g.shift();if(g.length===0){delete h[f];return}if(Object.keys(h).indexOf(f)!==-1){const c=h[f];typeof c=="object"&&!Array.isArray(c)&&(u(c,g),Object.keys(c).length===0&&delete h[f])}}function l(h,g,f){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const d=g.split("."),i=c(h,d);return typeof i>"u"?f:i}function w(h,g,f){Object.keys(g).forEach(c=>{c!=="__proto__"&&(c in h?R.$7f(h[c])&&R.$7f(g[c])?w(h[c],g[c],f):f&&(h[c]=g[c]):h[c]=g[c])})}function p(h){return h.replace(/[\[\]]/g,"")}}),define(ae[93],ce([0,1,5,27,184,4,154,7]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$pj=e.$oj=e.ContextKeyExprType=void 0,e.$nj=$,e.$qj=o,e.$rj=n,e.$Kj=he;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",R.$j),C.set("isLinux",R.$k),C.set("isWindows",R.$i),C.set("isWeb",R.$o),C.set("isMacNative",R.$j&&!R.$o),C.set("isEdge",R.$H),C.set("isFirefox",R.$F),C.set("isChrome",R.$E),C.set("isSafari",R.$G);function $(z,O){if(C.get(z)!==void 0)throw(0,I.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");C.set(z,O)}const E=Object.prototype.hasOwnProperty;var b;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const m={regexParsingWithErrorRecovery:!0},u=(0,A.localize)(0,null),l=(0,A.localize)(1,null),w=(0,A.localize)(2,null),p=(0,A.localize)(3,null),h=(0,A.localize)(4,null),g=(0,A.localize)(5,null),f=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class d{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=m){this.k=O,this.d=new L.$mj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:l});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const M=this.l();if(!this.E()){const q=this.D(),x=q.type===17?g:void 0;throw this.h.push({message:h,offset:q.offset,lexeme:L.$mj.getLexeme(q),additionalInfo:x}),d.c}return M}catch(M){if(M!==d.c)throw M;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const M=this.o();O.push(M)}return O.length===1?O[0]:i.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const M=this.s();O.push(M)}return O.length===1?O[0]:i.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const M=this.l();return this.A(1,p),M?.negate()}case 17:return this.z(),k.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const M=this.l();return this.A(1,p),M}case 17:{const M=O.lexeme;if(this.z(),this.y(9)){const x=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),x.type!==10)throw this.B("REGEX",x);const K=x.lexeme,ee=K.lastIndexOf("/"),_=ee===K.length-1?void 0:this.w(K.substring(ee+1));let Z;try{Z=new RegExp(K.substring(1,ee),_)}catch{throw this.B("REGEX",x)}return G.create(M,Z)}switch(x.type){case 10:case 19:{const K=[x.lexeme];this.z();let ee=this.D(),_=0;for(let fe=0;fe<x.lexeme.length;fe++)x.lexeme.charCodeAt(fe)===40?_++:x.lexeme.charCodeAt(fe)===41&&_--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let fe=0;fe<ee.lexeme.length;fe++)ee.lexeme.charCodeAt(fe)===40?_++:x.lexeme.charCodeAt(fe)===41&&_--}if(_<0)break;K.push(L.$mj.getLexeme(ee)),this.z(),ee=this.D()}const Z=K.join(""),se=Z.lastIndexOf("/"),ue=se===Z.length-1?void 0:this.w(Z.substring(se+1));let ge;try{ge=new RegExp(Z.substring(1,se),ue)}catch{throw this.B("REGEX",x)}return i.regex(M,ge)}case 18:{const K=x.lexeme;this.z();let ee=null;if(!(0,N.$4e)(K)){const _=K.indexOf("/"),Z=K.lastIndexOf("/");if(_!==Z&&_>=0){const se=K.slice(_+1,Z),ue=K[Z+1]==="i"?"i":"";try{ee=new RegExp(se,ue)}catch{throw this.B("REGEX",x)}}}if(ee===null)throw this.B("REGEX",x);return G.create(M,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const x=this.u();return i.notIn(M,x)}switch(this.D().type){case 3:{this.z();const x=this.u();if(this.x().type===18)return i.equals(M,x);switch(x){case"true":return i.has(M);case"false":return i.not(M);default:return i.equals(M,x)}}case 4:{this.z();const x=this.u();if(this.x().type===18)return i.notEquals(M,x);switch(x){case"true":return i.not(M);case"false":return i.has(M);default:return i.notEquals(M,x)}}case 5:return this.z(),U.create(M,this.u());case 6:return this.z(),Q.create(M,this.u());case 7:return this.z(),T.create(M,this.u());case 8:return this.z(),F.create(M,this.u());case 13:return this.z(),i.in(M,this.u());default:return i.has(M)}}case 20:throw this.h.push({message:f,offset:O.offset,lexeme:"",additionalInfo:c}),d.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,M){if(this.C(O))return this.z();throw this.B(M,this.D())}B(O,M,q){const x=(0,A.localize)(8,null,O,L.$mj.getLexeme(M)),K=M.offset,ee=L.$mj.getLexeme(M);return this.h.push({message:x,offset:K,lexeme:ee,additionalInfo:q}),d.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$oj=d;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(O){return a.create(O)}static equals(O,M){return y.create(O,M)}static notEquals(O,M){return S.create(O,M)}static regex(O,M){return G.create(O,M)}static in(O,M){return v.create(O,M)}static notIn(O,M){return P.create(O,M)}static not(O){return k.create(O)}static and(...O){return J.create(O,null,!0)}static or(...O){return H.create(O,null,!0)}static greater(O,M){return T.create(O,M)}static greaterEquals(O,M){return F.create(O,M)}static smaller(O,M){return U.create(O,M)}static smallerEquals(O,M){return Q.create(O,M)}static{this.c=new d({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$pj=i;function o(z){const O=new d({regexParsingWithErrorRecovery:!1});return z.map(M=>(O.parse(M),O.lexingErrors.length>0?O.lexingErrors.map(q=>({errorMessage:q.additionalInfo?(0,A.localize)(9,null,q.additionalInfo):(0,A.localize)(10,null),offset:q.offset,length:q.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(q=>({errorMessage:q.additionalInfo?`${q.message}. ${q.additionalInfo}`:q.message,offset:q.offset,length:q.lexeme.length})):[]))}function n(z,O){const M=z?z.substituteConstants():void 0,q=O?O.substituteConstants():void 0;return!M&&!q?!0:!M||!q?!1:M.equals(q)}function s(z,O){return z.cmp(O)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return r.INSTANCE}}e.$sj=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return t.INSTANCE}}e.$tj=r;class a{static create(O,M=null){const q=C.get(O);return typeof q=="boolean"?q?r.INSTANCE:t.INSTANCE:new a(O,M)}constructor(O,M){this.key=O,this.c=M,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:ie(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=C.get(this.key);return typeof O=="boolean"?O?r.INSTANCE:t.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=k.create(this.key,this)),this.c}}e.$uj=a;class y{static create(O,M,q=null){if(typeof M=="boolean")return M?a.create(O,q):k.create(O,q);const x=C.get(O);return typeof x=="boolean"?M===(x?"true":"false")?r.INSTANCE:t.INSTANCE:new y(O,M,q)}constructor(O,M,q){this.c=O,this.d=M,this.f=q,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:re(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=C.get(this.c);if(typeof O=="boolean"){const M=O?"true":"false";return this.d===M?r.INSTANCE:t.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$vj=y;class v{static create(O,M){return new v(O,M)}constructor(O,M){this.d=O,this.f=M,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:re(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const M=O.getValue(this.f),q=O.getValue(this.d);return Array.isArray(M)?M.includes(q):typeof q=="string"&&typeof M=="object"&&M!==null?E.call(M,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=P.create(this.d,this.f)),this.c}}e.$wj=v;class P{static create(O,M){return new P(O,M)}constructor(O,M){this.d=O,this.f=M,this.type=11,this.c=v.create(O,M)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$xj=P;class S{static create(O,M,q=null){if(typeof M=="boolean")return M?k.create(O,q):a.create(O,q);const x=C.get(O);return typeof x=="boolean"?M===(x?"true":"false")?t.INSTANCE:r.INSTANCE:new S(O,M,q)}constructor(O,M,q){this.c=O,this.d=M,this.f=q,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:re(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=C.get(this.c);if(typeof O=="boolean"){const M=O?"true":"false";return this.d===M?t.INSTANCE:r.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$yj=S;class k{static create(O,M=null){const q=C.get(O);return typeof q=="boolean"?q?t.INSTANCE:r.INSTANCE:new k(O,M)}constructor(O,M){this.c=O,this.d=M,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:ie(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=C.get(this.c);return typeof O=="boolean"?O?t.INSTANCE:r.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$zj=k;function D(z,O){if(typeof z=="string"){const M=parseFloat(z);isNaN(M)||(z=M)}return typeof z=="string"||typeof z=="number"?O(z):t.INSTANCE}class T{static create(O,M,q=null){return D(M,x=>new T(O,x,q))}constructor(O,M,q){this.c=O,this.d=M,this.f=q,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:re(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Aj=T;class F{static create(O,M,q=null){return D(M,x=>new F(O,x,q))}constructor(O,M,q){this.c=O,this.d=M,this.f=q,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:re(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Bj=F;class U{static create(O,M,q=null){return D(M,x=>new U(O,x,q))}constructor(O,M,q){this.c=O,this.d=M,this.f=q,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:re(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Cj=U;class Q{static create(O,M,q=null){return D(M,x=>new Q(O,x,q))}constructor(O,M,q){this.c=O,this.d=M,this.f=q,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:re(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Dj=Q;class G{static create(O,M){return new G(O,M)}constructor(O,M){this.d=O,this.f=M,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const M=this.f?this.f.source:"",q=O.f?O.f.source:"";return M<q?-1:M>q?1:0}equals(O){if(O.type===this.type){const M=this.f?this.f.source:"",q=O.f?O.f.source:"";return this.d===O.d&&M===q}return!1}substituteConstants(){return this}evaluate(O){const M=O.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Y.create(this)),this.c}}e.$Ej=G;class Y{static create(O){return new Y(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new Y(this.c.map(O))}negate(){return this.c}}e.$Fj=Y;function W(z){let O=null;for(let M=0,q=z.length;M<q;M++){const x=z[M].substituteConstants();if(z[M]!==x&&O===null){O=[];for(let K=0;K<M;K++)O[K]=z[K]}O!==null&&(O[M]=x)}return O===null?z:O}class J{static create(O,M,q){return J.d(O,M,q)}constructor(O,M){this.expr=O,this.c=M,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let M=0,q=this.expr.length;M<q;M++){const x=s(this.expr[M],O.expr[M]);if(x!==0)return x}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let M=0,q=this.expr.length;M<q;M++)if(!this.expr[M].equals(O.expr[M]))return!1;return!0}return!1}substituteConstants(){const O=W(this.expr);return O===this.expr?this:J.create(O,this.c,!1)}evaluate(O){for(let M=0,q=this.expr.length;M<q;M++)if(!this.expr[M].evaluate(O))return!1;return!0}static d(O,M,q){const x=[];let K=!1;for(const ee of O)if(ee){if(ee.type===1){K=!0;continue}if(ee.type===0)return t.INSTANCE;if(ee.type===6){x.push(...ee.expr);continue}x.push(ee)}if(x.length===0&&K)return r.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(s);for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];for(;x.length>1;){const ee=x[x.length-1];if(ee.type!==9)break;x.pop();const _=x.pop(),Z=x.length===0,se=H.create(ee.expr.map(ue=>J.create([ue,_],null,q)),null,Z);se&&(x.push(se),x.sort(s))}if(x.length===1)return x[0];if(q){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return t.INSTANCE;if(x.length===1)return x[0]}return new J(x,M)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const M of this.expr)O.push(...M.keys());return O}map(O){return new J(this.expr.map(M=>M.map(O)),null)}negate(){if(!this.c){const O=[];for(const M of this.expr)O.push(M.negate());this.c=H.create(O,this,!0)}return this.c}}e.$Gj=J;class H{static create(O,M,q){return H.d(O,M,q)}constructor(O,M){this.expr=O,this.c=M,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let M=0,q=this.expr.length;M<q;M++){const x=s(this.expr[M],O.expr[M]);if(x!==0)return x}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let M=0,q=this.expr.length;M<q;M++)if(!this.expr[M].equals(O.expr[M]))return!1;return!0}return!1}substituteConstants(){const O=W(this.expr);return O===this.expr?this:H.create(O,this.c,!1)}evaluate(O){for(let M=0,q=this.expr.length;M<q;M++)if(this.expr[M].evaluate(O))return!0;return!1}static d(O,M,q){let x=[],K=!1;if(O){for(let ee=0,_=O.length;ee<_;ee++){const Z=O[ee];if(Z){if(Z.type===0){K=!0;continue}if(Z.type===1)return r.INSTANCE;if(Z.type===9){x=x.concat(Z.expr);continue}x.push(Z)}}if(x.length===0&&K)return t.INSTANCE;x.sort(s)}if(x.length!==0){if(x.length===1)return x[0];for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];if(q){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return r.INSTANCE;if(x.length===1)return x[0]}return new H(x,M)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const M of this.expr)O.push(...M.keys());return O}map(O){return new H(this.expr.map(M=>M.map(O)),null)}negate(){if(!this.c){const O=[];for(const M of this.expr)O.push(M.negate());for(;O.length>1;){const M=O.shift(),q=O.shift(),x=[];for(const K of V(M))for(const ee of V(q))x.push(J.create([K,ee],null,!1));O.unshift(H.create(x,null,!1))}this.c=H.create(O,this,!0)}return this.c}}e.$Hj=H;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(O,M,q){super(O,null),this.f=M,typeof q=="object"?B.d.push({...q,key:O}):q!==!0&&B.d.push({key:O,description:q,type:M!=null?typeof M:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return y.create(this.key,O)}notEqualsTo(O){return S.create(this.key,O)}}e.$Ij=B,e.$Jj=(0,j.$ri)("contextKeyService");function ie(z,O){return z<O?-1:z>O?1:0}function re(z,O,M,q){return z<M?-1:z>M?1:O<q?-1:O>q?1:0}function he(z,O){if(z.type===0||O.type===1)return!0;if(z.type===9)return O.type===9?te(z.expr,O.expr):!1;if(O.type===9){for(const M of O.expr)if(he(z,M))return!0;return!1}if(z.type===6){if(O.type===6)return te(O.expr,z.expr);for(const M of z.expr)if(he(M,O))return!0;return!1}return z.equals(O)}function te(z,O){let M=0,q=0;for(;M<z.length&&q<O.length;){const x=z[M].cmp(O[q]);if(x<0)return!1;x===0&&M++,q++}return M===z.length}function V(z){return z.type===9?z.expr:[z]}}),define(ae[94],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$$m=e.ID=void 0,e.$_m=N,e.ID="diagnosticsService",e.$$m=(0,R.$ri)(e.ID);function N(j){return!!j.hostName&&!!j.errorMessage}class L{async getPerformanceInfo(A,I){return{}}async getSystemInfo(A,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,I){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$an=L}),define(ae[95],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=void 0,e.$Fo=(0,R.$ri)("downloadService")}),define(ae[16],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=void 0,e.$yi=(0,R.$ri)("environmentService"),e.$zi=(0,R.$si)(e.$yi)}),define(ae[29],ce([0,1,157,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.ExtensionGalleryErrorCode=e.$2o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$1o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$Uo=L,e.$Vo=j,e.$Wo=A,e.$Xo=I,e.$Yo=C,e.$Zo=$,e.$Oo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Po=new RegExp(e.$Oo),e.$Qo="__web_extension",e.$Ro="skipWalkthrough",e.$So="extensionsSync",e.$To="dependecyOrPackExtensionInstall";function L(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function j(f){switch(f){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(f,c){switch(f){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function I(f,c){return c==="web"&&!f.includes("web")}function C(f,c,d){return I(c,d)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===d}function $(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}var E;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var b;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var m;(function(f){f.Install="install",f.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var u;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(u||(e.InstallOperation=u={})),e.$1o=(0,N.$ri)("extensionGalleryService");var l;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.DownloadSignature="DownloadSignature",f.UpdateMetadata="UpdateMetadata",f.Extract="Extract",f.Scanning="Scanning",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.NotAllowed="NotAllowed",f.Gallery="Gallery",f.Unknown="Unknown",f.Internal="Internal"})(l||(e.ExtensionManagementErrorCode=l={}));var w;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class p extends Error{constructor(c,d){super(c),this.code=d,this.name=d}}e.$2o=p;var h;(function(f){f.Timeout="Timeout",f.Cancelled="Cancelled",f.Failed="Failed"})(h||(e.ExtensionGalleryErrorCode=h={}));class g extends Error{constructor(c,d){super(c),this.code=d,this.name=d}}e.$3o=g,e.$4o=(0,N.$ri)("extensionManagementService"),e.$5o="extensionsIdentifiers/disabled",e.$6o="extensionsIdentifiers/enabled",e.$7o=(0,N.$ri)("IGlobalExtensionEnablementService"),e.$8o=(0,N.$ri)("IExtensionTipsService"),e.$9o=(0,R.localize2)(0,"Extensions"),e.$0o=(0,R.localize2)(1,"Preferences")}),define(ae[194],ce([0,1,3,2,30,8,91,29]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=void 0;function C(p,h){return p?j.URI.revive(h?h.transformIncoming(p):p):void 0}function $(p,h){return h?h.transformOutgoingURI(p):p}function E(p,h){h=h||A.$un;const g=p.manifest;return{...(0,A.$xn)({...p,manifest:void 0},h),manifest:g}}function b(p,h){return p?.profileLocation?(0,A.$xn)(p,h??A.$un):p}function m(p,h){return h?(0,L.$Zn)(p,g=>g instanceof j.URI?h.transformOutgoingURI(g):void 0):p}class u{constructor(h,g){this.a=h,this.b=g,this.onInstallExtension=R.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,g){const f=this.b(h);switch(g){case"onInstallExtension":return R.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?$(c.profileLocation,f):c.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,c=>c.map(d=>({...d,local:d.local?m(d.local,f):d.local,profileLocation:d.profileLocation?$(d.profileLocation,f):d.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?$(c.profileLocation,f):c.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?$(c.profileLocation,f):c.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,c=>m(c,f))}throw new Error("Invalid listen")}async call(h,g,f){const c=this.b(h);switch(g){case"zip":{const d=E(f[0],c),i=await this.a.zip(d);return $(i,c)}case"unzip":return this.a.unzip(C(f[0],c));case"install":return this.a.install(C(f[0],c),b(f[1],c));case"installFromLocation":return this.a.installFromLocation(C(f[0],c),C(f[1],c));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(f[0],C(f[1],c),C(f[2],c));case"getManifest":return this.a.getManifest(C(f[0],c));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(f[0]);case"installFromGallery":return this.a.installFromGallery(f[0],b(f[1],c));case"installGalleryExtensions":{const d=f[0];return this.a.installGalleryExtensions(d.map(({extension:i,options:o})=>({extension:i,options:b(o,c)??{}})))}case"uninstall":return this.a.uninstall(E(f[0],c),b(f[1],c));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(f[0],c));case"getInstalled":return(await this.a.getInstalled(f[0],C(f[1],c),f[2])).map(i=>m(i,c));case"toggleAppliationScope":{const d=await this.a.toggleAppliationScope(E(f[0],c),C(f[1],c));return m(d,c)}case"copyExtensions":return this.a.copyExtensions(C(f[0],c),C(f[1],c));case"updateMetadata":{const d=await this.a.updateMetadata(E(f[0],c),f[1],C(f[2],c));return m(d,c)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(f[0],f[1],f[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$0p=u;class l extends N.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new R.$be),this.f=this.B(new R.$be),this.g=this.B(new R.$be),this.h=this.B(new R.$be),this.j=this.B(new R.$be),this.B(this.m.listen("onInstallExtension")(g=>this.n(this.c,{...g,source:this.r(g.source)?j.URI.revive(g.source):g.source,profileLocation:j.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(g=>this.n(this.f,g.map(f=>({...f,local:f.local?E(f.local,null):f.local,source:this.r(f.source)?j.URI.revive(f.source):f.source,profileLocation:j.URI.revive(f.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(g=>this.n(this.g,{...g,profileLocation:j.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(g=>this.n(this.h,{...g,profileLocation:j.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(g=>this.j.fire(E(g,null))))}n(h,g){h.fire(g)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const g=await this.getTargetPlatform();return h.allTargetPlatforms.some(f=>(0,I.$Yo)(f,h.allTargetPlatforms,g))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(g=>j.URI.revive(g)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,g){return Promise.resolve(this.m.call("install",[h,g])).then(f=>E(f,null))}installFromLocation(h,g){return Promise.resolve(this.m.call("installFromLocation",[h,g])).then(f=>E(f,null))}async installExtensionsFromProfile(h,g,f){return(await this.m.call("installExtensionsFromProfile",[h,g,f])).map(d=>E(d,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,g){return Promise.resolve(this.m.call("installFromGallery",[h,g])).then(f=>E(f,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map(f=>({...f,local:f.local?E(f.local,null):f.local,source:this.r(f.source)?j.URI.revive(f.source):f.source,profileLocation:j.URI.revive(f.profileLocation)}))}uninstall(h,g){if(h.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[h,g]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(g=>E(g,null))}getInstalled(h=null,g,f){return Promise.resolve(this.m.call("getInstalled",[h,g,f])).then(c=>c.map(d=>E(d,null)))}updateMetadata(h,g,f){return Promise.resolve(this.m.call("updateMetadata",[h,g,f])).then(c=>E(c,null))}toggleAppliationScope(h,g){return this.m.call("toggleAppliationScope",[h,g]).then(f=>E(f,null))}copyExtensions(h,g){return this.m.call("copyExtensions",[h,g])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,g,f){const c=await this.m.call("download",[h,g,f]);return j.URI.revive(c)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$$p=l;class w{constructor(h){this.a=h}listen(h,g){throw new Error("Invalid listen")}call(h,g,f){switch(g){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$_p=w}),define(ae[96],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U3b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$T3b=L;var N;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var j;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$U3b=(0,R.$ri)("IExtensionRecommendationNotificationService")}),define(ae[12],ce([0,1,51,14,27,13,8,164,4,5,23,53]),function(ne,e,R,N,L,j,A,I,C,$,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$ql=e.FileKind=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.FileOperationResult=e.$il=e.$hl=e.$gl=e.$el=e.FileChangeType=e.$dl=e.FileOperation=e.$0k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$Xk=void 0,e.$Yk=m,e.$Zk=p,e.$1k=g,e.$2k=f,e.$3k=c,e.$4k=d,e.$5k=i,e.$6k=o,e.$7k=n,e.$8k=s,e.$9k=t,e.$$k=y,e.$_k=v,e.$al=P,e.$bl=S,e.$cl=k,e.$fl=Q,e.$rl=B,e.$sl=ie,e.$ul=he,e.$Xk=(0,C.$ri)("fileService");function m(te){return te.create===!0}var u;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var l;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var w;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(w||(e.FileChangeFilter=w={}));function p(te){const V=te;return!!V&&typeof V.onDidChange=="function"}var h;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(h||(e.FileSystemProviderCapabilities=h={}));function g(te){return!!(te.capabilities&2)}function f(te){return!!(te.capabilities&8)}function c(te){return!!(te.capabilities&131072)}function d(te){return!!(te.capabilities&4)}function i(te){return!!(te.capabilities&16)}function o(te){return g(te)?!!(te.capabilities&16384):!1}function n(te){return g(te)?!!(te.capabilities&32768):!1}function s(te){return!!(te.capabilities&65536)}function t(te){return!!(te.capabilities&2048)}var r;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class a extends Error{static create(V,z){const O=new a(V.toString(),z);return P(O,z),O}constructor(V,z){super(V),this.code=z}}e.$0k=a;function y(te,V){return a.create(te,V)}function v(te){return te||y((0,I.localize)(0,null),r.Unknown)}function P(te,V){return te.name=V?`${V} (FileSystemError)`:"FileSystemError",te}function S(te){if(!te)return r.Unknown;if(te instanceof a)return te.code;const V=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!V)return r.Unknown;switch(V[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function k(te){if(te instanceof G)return te.fileOperationResult;switch(S(te)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}var D;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class T{constructor(V,z,O){this.resource=V,this.operation=z,this.target=O}isOperation(V){return this.operation===V}}e.$dl=T;var F;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class U{static{this.a=null}constructor(V,z){this.c=z,this.b=void 0,this.d=new b.$V(()=>{const O=R.$xi.forUris(()=>this.c);return O.fill(this.rawAdded.map(M=>[M,!0])),O}),this.f=new b.$V(()=>{const O=R.$xi.forUris(()=>this.c);return O.fill(this.rawUpdated.map(M=>[M,!0])),O}),this.g=new b.$V(()=>{const O=R.$xi.forUris(()=>this.c);return O.fill(this.rawDeleted.map(M=>[M,!0])),O}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const O of V){switch(O.type){case 1:this.rawAdded.push(O.resource);break;case 0:this.rawUpdated.push(O.resource);break;case 2:this.rawDeleted.push(O.resource);break}this.b!==U.a&&(typeof O.cId=="number"?this.b===void 0?this.b=O.cId:this.b!==O.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(V,...z){return this.h(V,{includeChildren:!1},...z)}affects(V,...z){return this.h(V,{includeChildren:!0},...z)}h(V,z,...O){if(!V)return!1;const M=O.length>0;return!!((!M||O.includes(1))&&(this.d.value.get(V)||z.includeChildren&&this.d.value.findSuperstr(V))||(!M||O.includes(0))&&(this.f.value.get(V)||z.includeChildren&&this.f.value.findSuperstr(V))||(!M||O.includes(2))&&(this.g.value.findSubstr(V)||z.includeChildren&&this.g.value.findSuperstr(V)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(V){return this.b===V}hasCorrelation(){return typeof this.b=="number"}}e.$el=U;function Q(te,V,z){return!te||!V||te===V||V.length>te.length?!1:(V.charAt(V.length-1)!==N.sep&&(V+=N.sep),z?(0,L.$vf)(te,V):te.indexOf(V)===0)}class G extends Error{constructor(V,z,O){super(V),this.fileOperationResult=z,this.options=O}}e.$gl=G;class Y extends G{constructor(V,z,O,M){super(V,z,M),this.fileOperationResult=z,this.size=O}}e.$hl=Y;class W extends G{constructor(V,z,O){super(V,2,O),this.stat=z}}e.$il=W;var J;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$jl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$kl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ll="files.associations",e.$ml="files.exclude",e.$nl="files.readonlyInclude",e.$ol="files.readonlyExclude",e.$pl="files.readonlyFromPermissions";var H;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$ql="";function B(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function ie(te,V){if(!V.hasProvider(A.URI.from({scheme:te.scheme})))return new Promise(z=>{const O=V.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===te.scheme&&M.added&&(O.dispose(),z())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(V){return(0,j.$9f)(V)||(V=0),V<re.KB?(0,I.localize)(1,null,V.toFixed(0)):V<re.MB?(0,I.localize)(2,null,(V/re.KB).toFixed(2)):V<re.GB?(0,I.localize)(3,null,(V/re.MB).toFixed(2)):V<re.TB?(0,I.localize)(4,null,(V/re.GB).toFixed(2)):(0,I.localize)(5,null,(V/re.TB).toFixed(2))}}e.$tl=re;function he(te){const V=typeof te=="string"||te?.scheme===E.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===E.Schemas.file?1024*re.MB:V?10*re.MB:$.$o?50*re.MB:1024*re.MB}});var X=this&&this.__param||function(ne,e){return function(R,N){e(R,N,ne)}};define(ae[195],ce([0,1,73,50,12]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;let j=class{constructor(I){this.a=I}async checksum(I){const C=(await this.a.readFileStream(I)).value;return new Promise(($,E)=>{const b=(0,R.createHash)("sha256");(0,N.$ue)(C,{onData:m=>b.update(m.buffer),onError:m=>E(m),onEnd:()=>$(b.digest("base64").replace(/=+$/,""))})})}};e.$Gdc=j,e.$Gdc=j=Ee([X(0,L.$Xk)],j)}),define(ae[97],ce([0,1,15,7,165,12]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=A;async function A(E,b,m,u,l,w){let p;try{await I(E,b,m,u,l,w)}catch(h){p=h}finally{p&&l.errorTransformer&&(p=l.errorTransformer(p)),typeof p<"u"&&m.error(p),m.end()}}async function I(E,b,m,u,l,w){C(w);const p=await E.open(b,{create:!1});try{C(w);let h=0,g=0,f=l&&typeof l.length=="number"?l.length:void 0,c=R.$Ce.alloc(Math.min(l.bufferSize,typeof f=="number"?f:l.bufferSize)),d=l&&typeof l.position=="number"?l.position:0,i=0;do g=await E.read(p,d,c.buffer,i,c.byteLength-i),d+=g,i+=g,h+=g,typeof f=="number"&&(f-=g),i===c.byteLength&&(await m.write(u(c)),c=R.$Ce.alloc(Math.min(l.bufferSize,typeof f=="number"?f:l.bufferSize)),i=0);while(g>0&&(typeof f!="number"||f>0)&&C(w)&&$(h,l));if(i>0){let o=i;typeof f=="number"&&(o=Math.min(i,f)),m.write(u(c.slice(0,o)))}}catch(h){throw(0,j.$_k)(h)}finally{await E.close(p)}}function C(E){if(E.isCancellationRequested)throw(0,N.$6)();return!0}function $(E,b){if(typeof b?.limits?.size=="number"&&E>b.limits.size)throw(0,j.$$k)((0,L.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[46],ce([0,1,90,2,14,5,8,12]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=void 0,e.$Eq=C,e.$Fq=$,e.$Jq=u,e.$Kq=l,e.$Lq=w,e.$Mq=p,e.$Nq=g,e.$Oq=f;function C(c){return typeof c.correlationId=="number"}function $(c){return c.recursive===!0}class E extends N.$Uc{static{this.a=5}constructor(d,i,o,n){super(),this.h=d,this.j=i,this.m=o,this.n=n,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const d=new N.$Tc;this.c.value=d,this.b=this.r(d),this.b.setVerboseLogging(this.m),d.add(this.b.onDidChangeFile(i=>this.h(i))),d.add(this.b.onDidLogMessage(i=>this.j(i))),d.add(this.b.onDidError(i=>this.t(i)))}t(d){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${d}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${d}`):this.w(d)}u(d){this.g++,this.s(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.m=d,await this.b?.setVerboseLogging(d)}w(d){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${d}`})}y(d){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Gq=E;class b extends E{constructor(d,i,o){super(d,i,o,{type:"node.js",restartOnError:!1})}}e.$Hq=b;class m extends E{constructor(d,i,o){super(d,i,o,{type:"universal",restartOnError:!0})}}e.$Iq=m;function u(c){return c.map(d=>({type:d.type,resource:A.URI.revive(d.resource),cId:d.cId}))}function l(c){const d=new h;for(const i of c)d.processEvent(i);return d.coalesce()}function w(c,d){return typeof d=="string"&&!d.startsWith(R.$hk)&&!(0,L.$jc)(d)?{base:c,pattern:d}:d}function p(c,d){const i=[];for(const o of d)i.push((0,R.$lk)(w(c,o)));return i}class h{constructor(){this.a=new Set,this.b=new Map}c(d){return j.$k?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const i=this.b.get(this.c(d));let o=!1;if(i){const n=i.type,s=d.type;i.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?o=!0:n===1&&s===2?(this.b.delete(this.c(d)),this.a.delete(i)):n===2&&s===1?i.type=0:n===1&&s===0||(i.type=s)}else o=!0;o&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],i=[];return Array.from(this.a).filter(o=>o.type!==2?(d.push(o),!1):!0).sort((o,n)=>o.resource.fsPath.length-n.resource.fsPath.length).filter(o=>i.some(n=>(0,I.$fl)(o.resource.fsPath,n,!j.$k))?!1:(i.push(o.resource.fsPath),!0)).concat(d)}}function g(c,d){if(typeof d=="number")switch(c.type){case 1:return(d&4)===0;case 2:return(d&8)===0;case 0:return(d&2)===0}return!1}function f(c){if(typeof c=="number"){const d=[];return c&4&&d.push("Added"),c&8&&d.push("Deleted"),c&2&&d.push("Updated"),d.length===0?"<all>":d.join(", ")}return"<none>"}}),define(ae[196],ce([0,1,15,38,7,3,2,50,32,12,46]),function(ne,e,R,N,L,j,A,I,C,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=e.$lQ=void 0,e.$lQ="localFilesystem";class b extends A.$Uc{constructor(u,l){super(),this.a=u,this.b=l,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$be),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$be),this.onDidWatchError=this.g.event,this.h=(0,C.$Ng)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,l){const{buffer:w}=await this.a.call("readFile",[u,l]);return w}readFileStream(u,l,w){const p=(0,I.$qe)(g=>R.$Ce.concat(g.map(f=>R.$Ce.wrap(f))).buffer),h=new A.$Tc;return h.add(this.a.listen("readFileStream",[u,l])(g=>{if(g instanceof R.$Ce)p.write(g.buffer);else{if(g==="end")p.end();else{let f;if(g instanceof Error)f=g;else{const c=g;f=(0,$.$$k)(c.message??(0,N.$cj)(c),c.code??$.FileSystemProviderErrorCode.Unknown)}p.error(f),p.end()}h.dispose()}})),h.add(w.onCancellationRequested(()=>{p.error((0,L.$6)()),p.end(),h.dispose()})),p}writeFile(u,l,w){return this.a.call("writeFile",[u,R.$Ce.wrap(l),w])}open(u,l){return this.a.call("open",[u,l])}close(u){return this.a.call("close",[u])}async read(u,l,w,p,h){const[g,f]=await this.a.call("read",[u,l,h]);return w.set(g.buffer.slice(0,f),p),f}write(u,l,w,p,h){return this.a.call("write",[u,l,R.$Ce.wrap(w),p,h])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,l){return this.a.call("delete",[u,l])}rename(u,l,w){return this.a.call("rename",[u,l,w])}copy(u,l,w){return this.a.call("copy",[u,l,w])}cloneFile(u,l){return this.a.call("cloneFile",[u,l])}j(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const l=u;this.f.fire((0,E.$Jq)(l))}else{const l=u;this.g.fire(l)}}))}watch(u,l){const w=(0,C.$Ng)();return this.a.call("watch",[this.h,w,u,l]),(0,A.$Sc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$mQ=b}),define(ae[197],ce([0,1,40,2,46,3,8,6]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;class C extends N.$Uc{constructor(){super(),this.a=this.B(new j.$be),this.onDidChangeFile=this.a.event,this.b=this.B(new j.$be),this.onDidLogMessage=this.b.event,this.c=this.B(new j.$be),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new I.$Oh,this.B(this.f(E=>this.s(E)))}s(E){this.t(E)&&this.w(E)}t(E){return(0,L.$Eq)(E)}async watch(E){this.r.isSettled||this.r.complete(),this.r=new I.$Oh;try{this.h.clear(),this.g.clear();for(const b of E)this.t(b)?this.h.set(b.correlationId,b):this.g.add(b);for(const[b]of this.j)this.h.has(b)||(this.j.deleteAndDispose(b),this.m.delete(b));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(E=>!this.j.has(E.correlationId))])}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async w(E){if(this.j.has(E.correlationId))return;const b=new N.$Tc;this.j.set(E.correlationId,b),await this.r.p,!b.isDisposed&&(this.z(E,b),this.u())}y(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.u()}z(E,b){this.C(E,b)?(this.M(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.D(E,b),this.m.add(E.correlationId))}C(E,b){const m=this.L?.subscribe(E.path,(u,l)=>{b.isDisposed||(u?this.z(E,b):l?.type===1&&this.F(E))});return m?(b.add(m),!0):!1}D(E,b){let m=!1;const u=(l,w)=>{if(b.isDisposed)return;const p=this.G(l),h=this.G(w),g=m;m=p,!p&&(h||g)&&this.F(E)};this.M(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,R.watchFile)(E.path,{persistent:!1,interval:this.n},u)}catch(l){this.N(`fs.watchFile() failed with error ${l} on path ${E.path} (correlationId: ${E.correlationId})`)}b.add((0,N.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,R.unwatchFile)(E.path,u)}catch(l){this.N(`fs.unwatchFile() failed with error ${l} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}F(E){this.M(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const b={resource:A.URI.file(E.path),type:1,cId:E.correlationId};this.a.fire([b]),this.H(b,E),this.y(E)}G(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(E,b){const m=` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.M(typeof b.correlationId=="number"?`${m} (correlationId: ${b.correlationId})`:m)}I(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,L.$Oq)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}}e.$Xq=C}),define(ae[198],ce([0,1,40,6,26,44,2,87,14,5,20,8,148,31,46]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0,e.$4q=p;class w extends A.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(g,f,c,d,i,o){super(),this.s=g,this.t=f,this.u=c,this.w=d,this.y=i,this.z=o,this.c=this.B(new N.$Gh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.u(n))),this.f=this.B(new N.$Fh(n=>this.M(n),w.b)),this.g=(0,l.$Mq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,l.$Mq)(this.s.path,this.s.includes):void 0,this.j=(0,l.$Eq)(this.s)?this.s.filter:void 0,this.m=new L.$me,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const g=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const f=await u.Promises.stat(g);if(this.m.token.isCancellationRequested)return;this.B(await this.G(g,f.isDirectory()))}catch(g){g.code!=="ENOENT"?this.O(g):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${g})`),this.D()}}D(){this.r=!0,this.w?.()}async F(g){let f=g.path;try{f=await u.Promises.realpath(g.path),g.path===f&&(f=await(0,m.$Zq)(g.path,this.m.token)??g.path),g.path!==f&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${f})`)}catch{}return f}async G(g,f){const c=new A.$Tc;return this.H(g,f,c)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(g,f,c)),c}H(g,f,c){if(f)return!1;const d=b.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(o,n)=>{if(!c.isDisposed)if(o){const s=await this.G(g,f);c.isDisposed?s.dispose():c.add(s)}else n&&(typeof n.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:d,type:n.type,cId:this.s.correlationId},!0)});return i?(c.add(i),!0):!1}async I(g,f,c){if($.$j&&(0,j.$rg)(g,"/Volumes/",!0)){this.O(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const d=new L.$me(this.m.token);c.add((0,A.$Sc)(()=>d.dispose(!0)));const i=new A.$Tc;c.add(i);try{const o=b.URI.file(this.s.path),n=(0,C.$oc)(g),s=(0,R.watch)(g);i.add((0,A.$Sc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${g}'`);const t=new Set;if(f)try{for(const a of await u.Promises.readdir(g))t.add(a)}catch(a){this.O(a)}if(d.token.isCancellationRequested)return;const r=new Map;i.add((0,A.$Sc)(()=>{for(const[,a]of r)a.dispose();r.clear()})),s.on("error",(a,y)=>{d.token.isCancellationRequested||(this.O(`Failed to watch ${g} for changes using fs.watch() (${a}, ${y})`),this.D())}),s.on("change",(a,y)=>{if(d.token.isCancellationRequested)return;this.Q(`[raw] ["${a}"] ${y}`);let v="";if(y&&(v=y.toString(),$.$j&&(v=(0,I.$9l)(v))),!(!v||a!=="change"&&a!=="rename"))if(f)if(a==="rename"){r.get(v)?.dispose();const P=setTimeout(async()=>{if(r.delete(v),v===n&&!await u.Promises.exists(g)){this.J(o);return}if(d.token.isCancellationRequested)return;const S=await this.N((0,C.$kc)(g,v));if(d.token.isCancellationRequested)return;let k;S?t.has(v)?k=0:(k=1,t.add(v)):(t.delete(v),k=2),this.L({resource:(0,E.$5g)(o,v),type:k,cId:this.s.correlationId})},w.a);r.set(v,(0,A.$Sc)(()=>clearTimeout(P)))}else{let P;t.has(v)?P=0:(P=1,t.add(v)),this.L({resource:(0,E.$5g)(o,v),type:P,cId:this.s.correlationId})}else if(a==="rename"||v!==n){const P=setTimeout(async()=>{const S=await u.Promises.exists(g);d.token.isCancellationRequested||(S?(this.L({resource:o,type:0,cId:this.s.correlationId},!0),i.add(await this.G(g,!1))):this.J(o))},w.a);i.clear(),i.add((0,A.$Sc)(()=>clearTimeout(P)))}else this.L({resource:o,type:0,cId:this.s.correlationId},!0)})}catch(o){d.token.isCancellationRequested||this.O(`Failed to watch ${g} for changes using fs.watch() (${o.toString()})`),this.D()}}J(g){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:g,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(g,f=!1){this.m.token.isCancellationRequested||(this.z&&this.Q(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`),!f&&this.g.some(c=>c(g.resource.fsPath))?this.z&&this.Q(` >> ignored (excluded) ${g.resource.fsPath}`):!f&&this.h&&this.h.length>0&&!this.h.some(c=>c(g.resource.fsPath))?this.z&&this.Q(` >> ignored (not included) ${g.resource.fsPath}`):this.f.work(g))}M(g){const f=(0,l.$Kq)(g),c=[];for(const i of f){if((0,l.$Nq)(i,this.j)){this.z&&this.Q(` >> ignored (filtered) ${i.resource.fsPath}`);continue}c.push(i)}if(c.length===0)return;if(this.z)for(const i of c)this.Q(` >> normalized ${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(c)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(g){if($.$k)return u.Promises.exists(g);try{const f=(0,C.$oc)(g);return(await u.Promises.readdir((0,C.$nc)(g))).some(d=>d===f)}catch(f){return this.Q(f),!1}}setVerboseLogging(g){this.z=g}O(g){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}P(g){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}Q(g){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.m.dispose(!0),super.dispose()}}e.$3q=w;async function p(h,g,f,c,d=512){const i=await u.Promises.open(h,"r"),o=Buffer.allocUnsafe(d),n=new L.$me(c);let s,t=!1;const r={path:h,excludes:[],recursive:!1},a=new w(r,void 0,y=>{(async()=>{for(const{type:v}of y)if(v===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:P}=await u.Promises.read(i,o,0,d,null);if(!P||n.token.isCancellationRequested)break;g(o.slice(0,P))}}catch(P){s=new Error(P),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,f(),new Promise((y,v)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await u.Promises.close(i)}catch(P){s=new Error(P)}s?v(s):y()})})}}),define(ae[199],ce([0,1,3,90,197,5,198,44]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;class C extends L.$Xq{constructor(E){super(),this.L=E,this.onDidError=R.Event.None,this.watchers=new Set,this.O=!1}async J(E){E=this.W(E);const b=[],m=new Set(Array.from(this.watchers));for(const u of E){const l=this.R(u);l&&(0,N.$pk)(l.request.excludes,u.excludes)&&(0,N.$pk)(l.request.includes,u.includes)?m.delete(l):b.push(u)}b.length&&this.M(`Request to start watching: ${b.map(u=>this.I(u)).join(",")}`),m.size&&this.M(`Request to stop watching: ${Array.from(m).map(u=>this.I(u.request)).join(",")}`);for(const u of m)this.U(u);for(const u of b)this.S(u)}R(E){for(const b of this.watchers)if(typeof E.correlationId=="number"||typeof b.request.correlationId=="number"){if(b.request.correlationId===E.correlationId)return b}else if((0,I.$qg)(b.request.path,E.path,!j.$k))return b}S(E){const b=new A.$3q(E,this.L,u=>this.a.fire(u),()=>this.c.fire(E),u=>this.b.fire(u),this.O),m={request:E,instance:b};this.watchers.add(m)}async stop(){await super.stop();for(const E of this.watchers)this.U(E)}U(E){this.M("stopping file watcher",E),this.watchers.delete(E),E.instance.dispose()}W(E){const b=new Map;for(const m of E){const u=j.$k?m.path:m.path.toLowerCase();let l=b.get(m.correlationId);l||(l=new Map,b.set(m.correlationId,l)),l.has(u)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I(m)}`),l.set(u,m)}return Array.from(b.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(E){this.O=E;for(const b of this.watchers)b.instance.setVerboseLogging(E)}M(E,b){this.O&&this.b.fire({type:"trace",message:this.Z(E,b)})}N(E){this.b.fire({type:"warn",message:this.Z(E)})}Z(E,b){return b?`[File Watcher (node.js)] ${E} (${this.I(b.request)})`:`[File Watcher (node.js)] ${E}`}}e.$5q=C}),define(ae[200],ce([0,1,46,199]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class L extends R.$Hq{constructor(A,I,C){super(A,I,C),this.s()}r(A){return A.add(new N.$5q(void 0))}}e.$6q=L}),define(ae[201],ce([0,1,23,41,92,46]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;class A extends j.$Iq{constructor(C,$,E){super(C,$,E),this.s()}r(C){const $=C.add(new L.$Vq(R.$Lg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add($.onDidProcessExit(({code:E,signal:b})=>this.t(`terminated by itself with code ${E}, signal: ${b}`))),N.ProxyChannel.toService((0,N.$$h)($.getChannel("watcher")))}}e.$Wq=A}),define(ae[74],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=void 0;class R{constructor(...L){this.a=new Map;for(const[j,A]of L)this.set(j,A)}set(L,j){const A=this.a.get(L);return this.a.set(L,j),A}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$pi=R}),define(ae[202],ce([0,1,6,7,2,72,192,4,74,86]),function(ne,e,R,N,L,j,A,I,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=void 0;const E=!1;class b extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class m{constructor(p=new C.$pi,h=!1,g,f=E){this.i=p,this.j=h,this.k=g,this.l=f,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$qi,this),this._globalGraph=f?g?._globalGraph??new A.$9q(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const p of this.g)(0,L.$Oc)(p)&&p.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(p){this.m();const h=new class extends m{dispose(){this.h.delete(h),super.dispose()}}(p,this.j,this,this.l);return this.h.add(h),h}invokeFunction(p,...h){this.m();const g=l.traceInvocation(this.l,p);let f=!1;try{return p({get:d=>{if(f)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(d,g);if(!i)throw new Error(`[invokeFunction] unknown service '${d}'`);return i}},...h)}finally{f=!0,g.stop()}}createInstance(p,...h){this.m();let g,f;return p instanceof j.$oi?(g=l.traceCreation(this.l,p.ctor),f=this.o(p.ctor,p.staticArguments.concat(h),g)):(g=l.traceCreation(this.l,p),f=this.o(p,h,g)),g.stop(),f}o(p,h=[],g){const f=I._util.getServiceDependencies(p).sort((i,o)=>i.index-o.index),c=[];for(const i of f){const o=this.s(i.id,g);o||this.y(`[createInstance] ${p.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const d=f.length>0?f[0].index:h.length;if(h.length!==d){console.trace(`[createInstance] First service dependency of ${p.name} at position ${d+1} conflicts with ${h.length} static arguments`);const i=d-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,d)}return Reflect.construct(p,h.concat(c))}q(p,h){if(this.i.get(p)instanceof j.$oi)this.i.set(p,h);else if(this.k)this.k.q(p,h);else throw new Error("illegalState - setting UNKNOWN service instance")}r(p){const h=this.i.get(p);return!h&&this.k?this.k.r(p):h}s(p,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const g=this.r(p);return g instanceof j.$oi?this.u(p,g,h.branch(p,!0)):(h.branch(p,!1),g)}u(p,h,g){if(this.t.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.t.add(p);try{return this.v(p,h,g)}finally{this.t.delete(p)}}v(p,h,g){const f=new A.$9q(i=>i.id.toString());let c=0;const d=[{id:p,desc:h,_trace:g}];for(;d.length;){const i=d.pop();if(f.lookupOrInsertNode(i),c++>1e3)throw new b(f);for(const o of I._util.getServiceDependencies(i.desc.ctor)){const n=this.r(o.id);if(n||this.y(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof j.$oi){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};f.insertEdge(i,s),d.push(s)}}}for(;;){const i=f.roots();if(i.length===0){if(!f.isEmpty())throw new b(f);break}for(const{data:o}of i){if(this.r(o.id)instanceof j.$oi){const s=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,s)}f.removeNode(o)}}return this.r(p)}w(p,h,g=[],f,c){if(this.i.get(p)instanceof j.$oi)return this.x(p,h,g,f,c,this.g);if(this.k)return this.k.w(p,h,g,f,c);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}x(p,h,g=[],f,c,d){if(f){const i=new m(void 0,this.j,this,this.l);i.c=String(p);const o=new Map,n=new R.$Kh(()=>{const s=i.o(h,g,c);for(const[t,r]of o){const a=s[t];if(typeof a=="function")for(const y of r)y.disposable=a.apply(s,y.listener)}return o.clear(),d.add(s),s});return new Proxy(Object.create(null),{get(s,t){if(!n.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let y=o.get(t);return y||(y=new $.$5c,o.set(t,y)),(P,S,k)=>{if(n.isInitialized)return n.value[t](P,S,k);{const D={listener:[P,S,k],disposable:void 0},T=y.push(D);return(0,L.$Sc)(()=>{T(),D.disposable?.dispose()})}}}if(t in s)return s[t];const r=n.value;let a=r[t];return typeof a!="function"||(a=a.bind(r),s[t]=a),a},set(s,t,r){return n.value[t]=r,!0},getPrototypeOf(s){return h.prototype}})}else{const i=this.o(h,g,c);return d.add(i),i}}y(p,h){if(h&&console.warn(p),this.j)throw new Error(p)}}e.$0q=m;var u;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(u||(u={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,h){return p?new l(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(p,h){return p?new l(1,h.name):l.c}static{this.f=0}constructor(p,h){this.type=p,this.name=h,this.g=Date.now(),this.h=[]}branch(p,h){const g=new l(3,p.toString());return this.h.push([p,h,g]),g}stop(){const p=Date.now()-this.g;l.f+=p;let h=!1;function g(c,d){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of d.h)if(s&&t){h=!0,i.push(`${o}CREATES -> ${n}`);const r=g(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(p>2||h)&&l.all.add(f.join(`
`))}}e.$$q=l}),define(ae[56],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=void 0,e.$bdc=(0,R.$ri)("mainProcessService");class N{constructor(j,A){this.a=j,this.b=A}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,A){this.a.registerChannel(j,A)}}e.$cdc=N}),define(ae[75],ce([0,1,26,2,5,167,29,4]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=void 0,e.$Lr=C;function C(E){return E.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.$Mr=(0,I.$ri)("languagePackService");let $=class extends N.$Uc{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new R.$me;setTimeout(()=>b.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const l=m.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some(p=>p.startsWith("lp-"))).map(w=>{const p=w.properties.localizedLanguages?.[0],h=C(w);return{...this.f(h,p,w),extensionId:w.identifier.id,galleryExtension:w}});return l.push(this.f("en","English")),l}f(b,m,u){const l=m??b;let w;if(l!==b&&(w=`(${b})`),b.toLowerCase()===L.$w.toLowerCase()&&(w??="",w+=(0,j.localize)(0,null)),u?.installCount){w??="";const p=u.installCount;let h;p>1e6?h=`${Math.floor(p/1e5)/10}M`:p>1e3?h=`${Math.floor(p/1e3)}K`:h=String(p),w+=` $(cloud-download) ${h}`}return{id:b,label:l,description:w}}};e.$Nr=$,e.$Nr=$=Ee([X(0,A.$1o)],$)}),define(ae[203],ce([0,1,2,75]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;let L=class extends R.$Uc{constructor(A){super(),this.a=A,this.b()}b(){this.a.update()}};e.$Cdc=L,e.$Cdc=L=Ee([X(0,N.$Mr)],L)}),define(ae[9],ce([0,1,168,38,3,54,2,34,5,20,13,8,93,4]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$1j=e.LogLevel=e.$Yj=e.$Xj=void 0,e.$Zj=w,e.log=h,e.$_j=a,e.$ak=y,e.$bk=v,e.$ck=P,e.$Xj=(0,u.$ri)("logService"),e.$Yj=(0,u.$ri)("loggerService");function l(){return new Date().toISOString()}function w(S){return(0,E.$9f)(S)}var p;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$1j=p.Info;function h(S,k,D){switch(k){case p.Trace:S.trace(D);break;case p.Debug:S.debug(D);break;case p.Info:S.info(D);break;case p.Warning:S.warn(D);break;case p.Error:S.error(D);break;case p.Off:break;default:throw new Error(`Invalid log level ${k}`)}}function g(S,k=!1){let D="";for(let T=0;T<S.length;T++){let F=S[T];if(F instanceof Error&&(F=(0,N.$cj)(F,k)),typeof F=="object")try{F=JSON.stringify(F)}catch{}D+=(T>0?" ":"")+F}return D}class f extends A.$Uc{constructor(){super(...arguments),this.b=e.$1j,this.c=this.B(new L.$be),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==p.Off&&this.b<=k}}e.$3j=f;class c extends f{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...D){this.f(p.Trace)&&this.g(p.Trace,g([k,...D],!0))}debug(k,...D){this.f(p.Debug)&&this.g(p.Debug,g([k,...D]))}info(k,...D){this.f(p.Info)&&this.g(p.Info,g([k,...D]))}warn(k,...D){this.f(p.Warning)&&this.g(p.Warning,g([k,...D]))}error(k,...D){if(this.f(p.Error))if(k instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=k.stack,this.g(p.Error,g(T))}else this.g(p.Error,g([k,...D]))}flush(){}}e.$4j=c;class d extends f{constructor(k=e.$1j){super(),this.setLevel(k),this.g=!C.$i}trace(k,...D){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,k,...D):console.log(`[main ${l()}]`,k,...D))}debug(k,...D){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,k,...D):console.log(`[main ${l()}]`,k,...D))}info(k,...D){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,k,...D):console.log(`[main ${l()}]`,k,...D))}warn(k,...D){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,k,...D):console.warn(`[main ${l()}]`,k,...D))}error(k,...D){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,k,...D):console.error(`[main ${l()}]`,k,...D))}flush(){}}e.$5j=d;class i extends f{constructor(k=e.$1j,D=!0){super(),this.g=D,this.setLevel(k)}trace(k,...D){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...D):console.log(k,...D))}debug(k,...D){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...D):console.log(k,...D))}info(k,...D){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...D):console.log(k,...D))}warn(k,...D){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...D):console.log(k,...D))}error(k,...D){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...D):console.error(k,...D))}flush(){}}e.$6j=i;class o extends f{constructor(k,D=e.$1j){super(),this.g=k,this.setLevel(D)}trace(k,...D){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(k),...D])}debug(k,...D){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(k),...D])}info(k,...D){this.f(p.Info)&&this.g.log(p.Info,[this.h(k),...D])}warn(k,...D){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(k),...D])}error(k,...D){this.f(p.Error)&&this.g.log(p.Error,[this.h(k),...D])}h(k){return typeof k=="string"?k:(0,N.$cj)(k,this.f(p.Trace))}flush(){}}e.$7j=o;class n extends f{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const D of this.g)D.setLevel(k);super.setLevel(k)}trace(k,...D){for(const T of this.g)T.trace(k,...D)}debug(k,...D){for(const T of this.g)T.debug(k,...D)}info(k,...D){for(const T of this.g)T.info(k,...D)}warn(k,...D){for(const T of this.g)T.warn(k,...D)}error(k,...D){for(const T of this.g)T.error(k,...D)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose();super.dispose()}}e.$8j=n;class s extends A.$Uc{constructor(k,D,T){if(super(),this.h=k,this.j=D,this.b=new I.$Bc,this.c=this.B(new L.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$be),this.onDidChangeVisibility=this.g.event,T)for(const F of T)this.b.set(F.resource,{logger:void 0,info:F})}m(k){return(0,E.$5f)(k)?[...this.b.values()].find(D=>D.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,D){const T=this.n(k),F=(0,E.$5f)(k)?k:D?.id??(0,j.$fj)(T.toString()).toString(16);let U=this.b.get(T)?.logger;const Q=D?.logLevel==="always"?p.Trace:D?.logLevel;U||(U=this.s(T,Q??this.getLogLevel(T)??this.h,{...D,id:F}));const G={logger:U,info:{resource:T,id:F,logLevel:Q,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(G.info),this.b.set(T,G),U}n(k){return(0,E.$5f)(k)?(0,$.$5g)(this.j,`${k}.log`):k}setLogLevel(k,D){if(b.URI.isUri(k)){const T=k,F=D,U=this.b.get(T);U&&F!==U.info.logLevel&&(U.info.logLevel=F===this.h?void 0:F,U.logger?.setLevel(F),this.b.set(U.info.resource,U),this.f.fire([T,F]))}else{this.h=k;for(const[T,F]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,D){const T=this.m(k);T&&D!==!T.info.hidden&&(T.info.hidden=!D,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,D]))}getLogLevel(k){let D;return k&&(D=this.b.get(k)?.info.logLevel),D??this.h}registerLogger(k){const D=this.b.get(k.resource);D?D.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const D=this.b.get(k);D&&(D.logger&&D.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$9j=s;class t{constructor(){this.onDidChangeLogLevel=new L.$be().event}setLevel(k){}getLevel(){return p.Info}trace(k,...D){}debug(k,...D){}info(k,...D){}warn(k,...D){}error(k,...D){}critical(k,...D){}dispose(){}flush(){}}e.$0j=t;class r extends t{}e.$$j=r;function a(S){if(S.verbose)return p.Trace;if(typeof S.logLevel=="string"){const k=P(S.logLevel.toLowerCase());if(k!==void 0)return k}return e.$1j}function y(S){switch(S){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function v(S){switch(S){case p.Trace:return{original:"Trace",value:R.localize(0,null)};case p.Debug:return{original:"Debug",value:R.localize(1,null)};case p.Info:return{original:"Info",value:R.localize(2,null)};case p.Warning:return{original:"Warning",value:R.localize(3,null)};case p.Error:return{original:"Error",value:R.localize(4,null)};case p.Off:return{original:"Off",value:R.localize(5,null)}}}function P(S){switch(S){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$dk=new m.$Ij("logLevel",y(p.Info))}),define(ae[204],ce([0,1,6,7,2,23,14,20,31,16,9]),function(ne,e,R,N,L,j,A,I,C,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;let b=class extends L.$Uc{constructor(u,l){super(),this.a=u,this.b=l,this.B(new R.$Dh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const u=(0,I.$2g)(this.a.logsHome),l=(0,I.$4g)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,h=(await C.Promises.readdir(l)).filter(f=>/^\d{8}T\d{6}$/.test(f)).sort().filter(f=>f!==u),g=h.slice(0,Math.max(0,h.length-9));g.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${g.join(", ")}'`),await Promise.all(g.map(f=>C.Promises.rm((0,A.$kc)(l,f)))))}catch(u){(0,N.$1)(u)}}};e.$Ddc=b,e.$Ddc=b=Ee([X(0,$.$yi),X(1,E.$Xj)],b)}),define(ae[205],ce([0,1,17,6,7,3,2,14,46,9]),function(ne,e,R,N,L,j,A,I,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class E extends A.$Uc{constructor(m,u){super(),this.a=m,this.b=u,this.c=this.B(new j.$be),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$be),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$ph(0)),this.w=[],this.y=this.B(new N.$ph(0))}watch(m,u){return u.recursive||this.b?.watcher?.forceUniversal?this.n(m,u):this.z(m,u)}n(m,u){const l={path:this.I(m),excludes:u.excludes,includes:u.includes,recursive:u.recursive,filter:u.filter,correlationId:u.correlationId},w=(0,R.$Ub)(this.j,l);return this.r(),(0,A.$Sc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,L.$1)(m))}s(){this.h||(this.h=this.B(this.t(u=>this.c.fire((0,C.$Jq)(u)),u=>this.G(u),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const u of this.j)(0,C.$Fq)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const u of this.j)(0,C.$Fq)(u)&&m.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,u){const l={path:this.I(m),excludes:u.excludes,includes:u.includes,recursive:!1,filter:u.filter,correlationId:u.correlationId},w=(0,R.$Ub)(this.w,l);return this.C(),(0,A.$Sc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,L.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,C.$Jq)(m)),m=>this.G(m),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,I.$ic)(m.fsPath)}}e.$Pq=E}),define(ae[206],ce([0,1,17,6,15,26,3,54,61,2,51,23,98,20,50,163,12,97,9,7]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;let d=class extends $.$Uc{static{c=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new A.$be),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$be),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$be),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$be),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$be),this.Y=this.B(new A.$be),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$be),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$Ah)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const s=new $.$Tc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new p.$el(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,$.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,$.$Pc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await N.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return C.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,u.$9g)(o))throw new p.$gl((0,w.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new f.$bb;throw s.message=(0,w.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,p.$4k)(n)||(0,p.$1k)(n)||(0,p.$5k)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,p.$4k)(n)||(0,p.$1k)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,p.$bl)(s)===p.FileSystemProviderErrorCode.FileNotFound?new p.$gl((0,w.localize)(2,null,this.sb(o)),1):(0,p.$_k)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,y=n?.resolveMetadata,v=await s.stat(o);let P;return this.t(s,o,v,void 0,!!y,(S,k)=>(P||(P=E.$xi.forUris(()=>!t),P.set(o,!0),r&&P.fill(!0,r)),P.get(S.resource)||P.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&a?k===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:y}=this.R(o),v={resource:n,name:y.basename(n),isFile:(s.type&p.FileType.File)!==0,isDirectory:(s.type&p.FileType.Directory)!==0,isSymbolicLink:(s.type&p.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&p.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&p.FilePermission.Locked),etag:(0,p.$rl)({mtime:s.mtime,size:s.size}),children:void 0};if(v.isDirectory&&a(v,t)){try{const P=await o.readdir(n),S=await N.Promises.settled(P.map(async([k,D])=>{try{const T=y.joinPath(n,k),F=r?await o.stat(T):{type:D};return await this.t(o,T,F,P.length,r,a)}catch(T){return this.b.trace(T),null}}));v.children=(0,R.$Hb)(S)}catch(P){this.b.trace(P),v.children=[]}return v}return v}async resolveAll(o){return N.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new p.$gl((0,w.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=L.$Ce.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new p.$dl(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,p.$7k)(t)&&!a?.atomic){const y=t.enforceAtomicWriteFile?.(o);y&&(a={...s,atomic:y})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let v;if((0,p.$1k)(t)&&!(n instanceof L.$Ce))if((0,l.$oe)(n)){const P=await(0,l.$ve)(n,3);P.ended?v=L.$Ce.concat(P.buffer):v=P}else v=(0,l.$se)(n,P=>L.$Ce.concat(P),3);else v=n;!(0,p.$4k)(t)||(0,p.$1k)(t)&&v instanceof L.$Ce||(0,p.$1k)(t)&&(0,p.$7k)(t)&&a?.atomic?await this.hb(t,o,a,v):await this.db(t,o,a,v instanceof L.$Ce?(0,L.$Ne)(v):v),this.r.fire(new p.$dl(o,4))}catch(y){throw new p.$gl((0,w.localize)(4,null,this.sb(o),(0,p.$_k)(y).toString()),(0,p.$cl)(y),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,w.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,w.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,w.localize)(7,null,this.sb(n)));if(t)throw new Error((0,w.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&p.FileType.Directory)throw new p.$gl((0,w.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==p.$ql&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,p.$rl)({mtime:s.mtime,size:a.size}))throw new p.$gl((0,w.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const y=await this.C(o,n,s,t);r(y)}catch(y){a(y)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,L.$Oe)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new j.$me(t);let a=s;(0,p.$6k)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const y=this.J(n,a).then(P=>P,P=>{throw r.dispose(!0),P});let v;try{return typeof a?.etag=="string"&&a.etag!==p.$ql&&await y,a?.atomic&&(0,p.$6k)(o)||!((0,p.$4k)(o)||(0,p.$5k)(o))||(0,p.$1k)(o)&&a?.preferUnbuffered?v=this.I(o,n,a):(0,p.$5k)(o)?v=this.G(o,n,r.token,a):v=this.H(o,n,r.token,a),v.on("end",()=>r.dispose()),v.on("error",()=>r.dispose()),{...await y,value:v}}catch(P){throw v&&await(0,l.$te)(v),this.F(P,n,a)}}F(o,n,s){const t=(0,w.localize)(11,null,this.sb(n),(0,p.$_k)(o).toString());return o instanceof p.$il?new p.$il(t,o.stat,s):o instanceof p.$hl?new p.$hl(t,o.fileOperationResult,o.size,o.options):new p.$gl(t,(0,p.$cl)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,l.$ze)(r,{data:a=>a instanceof L.$Ce?a:L.$Ce.wrap(a),error:a=>this.F(a,n,t)},a=>L.$Ce.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,L.$Se)();return(0,h.$Cq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,l.$qe)(r=>L.$Ce.concat(r));return(async()=>{try{let r;s?.atomic&&(0,p.$6k)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(L.$Ce.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new p.$gl((0,w.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==p.$ql&&n.etag===s.etag)throw new p.$il((0,w.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new p.$hl((0,w.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),y=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new p.$dl(o,a==="move"?2:3,y)),y}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),y=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new p.$dl(o,a==="copy"?3:2,y)),y}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:y,isSameResourceWithDifferentPathCase:v}=await this.Q(o,n,s,t,r,a);if(y&&!v&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,p.$2k)(o))await o.copy(n,t,{overwrite:a});else{const P=await this.resolve(n);P.isDirectory?await this.P(o,P,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,p.$4k)(o)&&(0,p.$4k)(s))return this.jb(o,n,s,t);if((0,p.$4k)(o)&&(0,p.$1k)(s))return this.pb(o,n,s,t);if((0,p.$1k)(o)&&(0,p.$4k)(s))return this.nb(o,n,s,t);if((0,p.$1k)(o)&&(0,p.$1k)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let y=!1;if(o===s){const{providerExtUri:P,isPathCaseSensitive:S}=this.R(o);if(S||(y=P.isEqual(n,t)),y&&r==="copy")throw new Error((0,w.localize)(15,null,this.sb(n),this.sb(t)));if(!y&&P.isEqualOrParent(t,n))throw new Error((0,w.localize)(16,null,this.sb(n),this.sb(t)))}const v=await this.exists(t);if(v&&!y){if(!a)throw new p.$gl((0,w.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:P}=this.R(o);if(P.isEqualOrParent(n,t))throw new Error((0,w.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:v,isSameResourceWithDifferentPathCase:y}}R(o){const n=this.S(o);return{providerExtUri:n?u.$Ug:u.$Wg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new p.$dl(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&p.FileType.Directory))throw new Error((0,w.localize)(19,null,this.sb(n)));break}catch(r){if((0,p.$bl)(r)!==p.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,p.$bl)(a)!==p.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,w.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,w.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,w.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new p.$gl((0,w.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const v=await this.resolve(o);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,w.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,p.$8k)(s)&&!t?.atomic){const v=s.enforceAtomicDelete?.(o);v&&(t={...n,atomic:v})}const r=!!t?.useTrash,a=!!t?.recursive,y=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:y}),this.r.fire(new p.$dl(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,p.$3k)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,p.$2k)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new $.$Tc;let t=!1,r=()=>{t=!0};s.add((0,$.$Sc)(()=>r())),(async()=>{try{const y=await this.bb(o,n);t?(0,$.$Pc)(y):r=()=>(0,$.$Pc)(y)}catch(y){this.b.error(y)}})();const a=n.correlationId;if(typeof a=="number"){const y=s.add(new A.$be);return s.add(this.X.event(P=>{P.correlates(a)&&y.fire(P)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,I.$fj)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,$.$Sc)(()=>{r&&(r.count--,r.count===0&&((0,$.$Pc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,$.$Pc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,l.$oe)(t)||(0,l.$pe)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,p.$_k)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,l.$pe)(s)){if(s.buffer.length>0){const a=L.$Ce.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,y)=>{(0,l.$ue)(r,{onData:async v=>{r.pause();try{await this.gb(o,n,v,v.byteLength,t,0)}catch(P){return y(P)}t+=v.byteLength,setTimeout(()=>r.resume())},onError:v=>y(v),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let y=0;for(;y<t;){const v=await o.write(n,r+y,s.buffer,a+y,t-y);y+=v}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof L.$Ce?r=t:(0,l.$oe)(t)?r=await(0,L.$Oe)(t):(0,l.$pe)(t)?r=await(0,L.$Pe)(t):r=(0,L.$Me)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const y=L.$Ce.alloc(this.a);let v=0,P=0,S=0;do S=await o.read(r,v,y.buffer,P,y.byteLength-P),await this.gb(s,a,y,S,v,P),v+=S,P+=S,P===y.byteLength&&(P=0);while(S>0)}catch(y){throw(0,p.$_k)(y)}finally{await N.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,L.$Ce.wrap(a),a.byteLength,0,0)}catch(a){throw(0,p.$_k)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,L.$Oe)(this.H(o,n,j.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new p.$gl((0,w.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&p.FilePermission.Readonly)throw new p.$gl((0,w.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}};e.$Dq=d,e.$Dq=d=c=Ee([X(0,g.$Xj)],d)}),define(ae[207],ce([0,1,40,277,6,34,15,3,44,2,14,5,20,50,31,166,12,97,205,38,201,200]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0,(()=>{try{(0,N.gracefulify)(R)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.$cj)(o)}`)}})();class i extends g.$Pq{static{this.J=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=I.Event.None,this.O=new j.$Bc(t=>m.$Vg.getComparisonKey(t)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,b.$k&&(this.L|=1024)),this.L}async stat(n){try{const{stat:s,symbolicLink:t}=await l.SymlinkSupport.stat(this.I(n));return{type:this.N(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:p.FilePermission.Locked}}catch(s){throw this.gb(s)}}async M(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await l.Promises.readdir(this.I(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,m.$5g)(n,r.name))).type:a=this.N(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.gb(s)}}N(n,s){let t;return s?.dangling?t=p.FileType.Unknown:n.isFile()?t=p.FileType.File:n.isDirectory()?t=p.FileType.Directory:t=p.FileType.Unknown,s&&(t|=p.FileType.SymbolicLink),t}async P(n){const s=this.I(n);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.O.get(n);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new L.$qh;return this.O.set(n,r),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,$.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.O.get(n)===r&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.O.delete(n)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(n)})`),t=await this.P(n));const r=this.I(n);return await l.Promises.readFile(r)}catch(r){throw this.gb(r)}finally{t?.dispose()}}Q(n){i.J&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,u.$qe)(a=>A.$Ce.concat(a.map(y=>A.$Ce.wrap(y))).buffer);return(0,h.$Cq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.R(n)?this.S(n,(0,m.$5g)((0,m.$4g)(n),`${(0,m.$2g)(n)}${t.atomic.postfix}`),s,t):this.U(n,s,t)}async R(n){try{const s=this.I(n),{symbolicLink:t}=await l.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async S(n,s,t,r){const a=new $.$Tc;try{a.add(await this.P(n)),a.add(await this.P(s)),await this.U(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(y){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw y}}finally{a.dispose()}}async U(n,s,t,r){let a;try{const y=this.I(n);if(!t.create||!t.overwrite){if(await l.Promises.exists(y)){if(!t.overwrite)throw(0,p.$$k)((0,w.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,p.$$k)((0,w.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(y){throw await this.hb(n,y)}finally{typeof a=="number"&&await this.close(a)}}static{this.Z=!0}static configureFlushOnWrite(n){i.Z=n}async open(n,s,t){const r=this.I(n);let a;(0,p.$Yk)(s)&&!t&&(a=await this.P(n));let y;try{if((0,p.$Yk)(s)&&s.unlock)try{const{stat:P}=await l.SymlinkSupport.stat(r);P.mode&128||await l.Promises.chmod(r,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}let v;if((0,p.$Yk)(s)){if(b.$i)try{await l.Promises.truncate(r,0),v="r+"}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}v||(v="w")}else v="r";y=await l.Promises.open(r,v)}catch(v){throw a?.dispose(),(0,p.$Yk)(s)?await this.hb(n,v):this.gb(v)}if(this.W.set(y,0),(0,p.$Yk)(s)&&this.Y.set(y,n),a){const v=this.X.get(y);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${r})`),this.X.set(y,a),v&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${r})`),v.dispose())}return y}async close(n){const s=this.X.get(n);try{if(this.W.delete(n),this.Y.delete(n)&&i.Z)try{await l.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await l.Promises.close(n)}catch(t){throw this.gb(t)}finally{s&&(this.X.get(n)===s&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.X.delete(n)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const y=this.$(n,s);let v=null;try{v=(await l.Promises.read(n,t,r,a,y)).bytesRead}catch(P){throw this.gb(P)}finally{this.ab(n,y,v)}return v}$(n,s){return s===this.W.get(n)?null:s}ab(n,s,t){const r=this.W.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.W.set(n,r+t):this.W.delete(n)))}async write(n,s,t,r,a){return(0,L.$Lh)(()=>this.bb(n,s,t,r,a),100,3)}async bb(n,s,t,r,a){const y=this.$(n,s);let v=null;try{v=(await l.Promises.write(n,t,r,a,y)).bytesWritten}catch(P){throw await this.hb(this.Y.get(n),P)}finally{this.ab(n,y,v)}return v}async mkdir(n){try{await l.Promises.mkdir(this.I(n))}catch(s){throw this.gb(s)}}async delete(n,s){try{const t=this.I(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,E.$kc)((0,E.$nc)(t),`${(0,E.$oc)(t)}${s.atomic.postfix}`)),await l.Promises.rm(t,l.RimRafMode.MOVE,r)}else try{await l.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:y,symbolicLink:v}=await l.SymlinkSupport.stat(t);a=y.isDirectory()&&!v}catch{}if(a)await l.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.gb(t)}}async rename(n,s,t){const r=this.I(n),a=this.I(s);if(r!==a)try{await this.cb(n,s,"move",t.overwrite),await l.Promises.rename(r,a)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,w.localize)(2,null,(0,E.$oc)(r),(0,E.$oc)((0,E.$nc)(a)),y.toString()))),this.gb(y)}}async copy(n,s,t){const r=this.I(n),a=this.I(s);if(r!==a)try{await this.cb(n,s,"copy",t.overwrite),await l.Promises.copy(r,a,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,w.localize)(3,null,(0,E.$oc)(r),(0,E.$oc)((0,E.$nc)(a)),y.toString()))),this.gb(y)}}async cb(n,s,t,r){const a=this.I(n),y=this.I(s);let v=!1;if(!!(this.capabilities&1024)||(v=(0,C.$qg)(a,y,!0)),v){if(t==="copy")throw(0,p.$$k)((0,w.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const S=await this.M(n);if(!S)throw(0,p.$$k)((0,w.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const k=await this.M(s);if(k){if(!r)throw(0,p.$$k)((0,w.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);S.type&p.FileType.File&&k.type&p.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.db(n,s,!1)}async db(n,s,t){const r=this.I(n),a=this.I(s),y=!!(this.capabilities&1024);if((0,C.$qg)(r,a,!y))return;const v=new $.$Tc;try{v.add(await this.P(n)),v.add(await this.P(s)),t&&await l.Promises.mkdir((0,E.$nc)(a),{recursive:!0}),await l.Promises.copyFile(r,a)}catch(P){if(P.code==="ENOENT"&&!t)return this.db(n,s,!0);throw this.gb(P)}finally{v.dispose()}}t(n,s,t){return new c.$Wq(r=>n(r),r=>s(r),t)}F(n,s,t){return new d.$6q(r=>n(r),r=>s(r),t)}gb(n){if(n instanceof p.$0k)return n;let s=n,t;switch(n.code){case"ENOENT":t=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=p.FileSystemProviderErrorCode.Unknown;break;default:t=p.FileSystemProviderErrorCode.Unknown}return(0,p.$$k)(s,t)}async hb(n,s){let t=this.gb(s);if(n&&t.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await l.SymlinkSupport.stat(this.I(n));r.mode&128||(t=(0,p.$$k)(s,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$7q=i}),define(ae[99],ce([0,1,3,2,4,9]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=e.$3dc=void 0,e.$3dc=(0,L.$ri)("sharedProcessLifecycleService");let A=class extends N.$Uc{constructor(C){super(),this.b=C,this.a=this.B(new R.$be),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$4dc=A,e.$4dc=A=Ee([X(0,j.$Xj)],A)}),define(ae[208],ce([0,1,8,3,9,2]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=void 0;class A extends L.$9j{constructor(b,m,u,l,w){super(m,u,l),this.r=b,this.t=w,this.B(w.listen("onDidChangeLogLevel",b)(p=>{(0,L.$Zj)(p)?super.setLogLevel(p):super.setLogLevel(R.URI.revive(p[0]),p[1])})),this.B(w.listen("onDidChangeVisibility",b)(([p,h])=>super.setVisibility(R.URI.revive(p),h))),this.B(w.listen("onDidChangeLoggers",b)(({added:p,removed:h})=>{for(const g of p)super.registerLogger({...g,resource:R.URI.revive(g.resource)});for(const g of h)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new L.$7j({log:(b,m)=>{this.t.call("consoleLog",[b,m])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,m){super.setLogLevel(b,m),this.t.call("setLogLevel",[b,m])}setVisibility(b,m){super.setVisibility(b,m),this.t.call("setVisibility",[this.n(b),m])}s(b,m,u){return new I(this.t,b,m,u,this.r)}static setLogLevel(b,m,u){return b.call("setLogLevel",[m,u])}}e.$6r=A;class I extends L.$4j{constructor(b,m,u,l,w){super(l?.logLevel==="always"),this.r=b,this.s=m,this.m=!1,this.n=[],this.setLevel(u),this.r.call("createLogger",[m,l,w]).then(()=>{this.u(this.n),this.m=!0})}g(b,m){const u=[[b,m]];this.m?this.u(u):this.n.push(...u)}u(b){this.r.call("log",[this.s,b])}}class C{constructor(b,m){this.a=b,this.b=m}listen(b,m){const u=this.b(b);switch(m){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(w=>this.c(w,u)),removed:[...l.removed].map(w=>this.c(w,u))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,l=>[u.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,l=>(0,L.$Zj)(l)?l:[u.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${m}`)}async call(b,m,u){const l=this.b(b);switch(m){case"setLogLevel":return(0,L.$Zj)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(R.URI.revive(l.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,l)))}throw new Error(`Call not found: ${m}`)}c(b,m){return{...b,resource:m.transformOutgoingURI(b.resource)}}}e.$7r=C;class $ extends j.$Uc{constructor(b,m){super(),m.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(u=>m.call("setLogLevel",[u]))),m.call("getRegisteredLoggers").then(u=>{for(const l of u)b.registerLogger({...l,resource:R.URI.revive(l.resource)})}),this.B(m.listen("onDidChangeVisibility")(([u,l])=>b.setVisibility(R.URI.revive(u),l))),this.B(m.listen("onDidChangeLoggers")(({added:u,removed:l})=>{for(const w of u)b.registerLogger({...w,resource:R.URI.revive(w.resource)});for(const w of l)b.deregisterLogger(w.resource)}))}}e.$8r=$}),define(ae[209],ce([0,1,2,9]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=void 0;class L extends R.$Uc{constructor(A,I=[]){super(),this.a=new N.$8j([A,...I]),this.B(A.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...I){this.a.trace(A,...I)}debug(A,...I){this.a.debug(A,...I)}info(A,...I){this.a.info(A,...I)}warn(A,...I){this.a.warn(A,...I)}error(A,...I){this.a.error(A,...I)}flush(){this.a.flush()}}e.$DQ=L}),define(ae[57],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=void 0,e.$Ybc=(0,R.$ri)("nativeHostService")}),define(ae[210],ce([0,1,41,56]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;let L=class{constructor(A,I){return this.windowId=A,R.ProxyChannel.toService(I.getChannel("nativeHost"),{context:A,properties:(()=>{const C=new Map;return C.set("windowId",A),C})()})}};e.$hdc=L,e.$hdc=L=Ee([X(1,N.$bdc)],L)}),define(ae[58],ce([0,1,3,61,2,4]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=void 0,e.$_n=(0,j.$ri)("policy");class A extends L.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new R.$be),this.onDidChange=this.h.event}async updatePolicyDefinitions($){const E=Object.keys(this.f).length;return this.f={...$,...this.f},E!==Object.keys(this.f).length&&await this.j($),N.Iterable.reduce(this.g.entries(),(b,[m,u])=>({...b,[m]:u}),{})}getPolicyValue($){return this.g.get($)}serialize(){return N.Iterable.reduce(Object.entries(this.f),($,[E,b])=>({...$,[E]:{definition:b,value:this.g.get(E)}}),{})}}e.$ao=A;class I{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$bo=I}),define(ae[211],ce([0,1,3,2,58]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=void 0;class j{constructor(C){this.b=C,this.a=new N.$Tc}listen(C,$){switch($){case"onDidChange":return R.Event.map(this.b.onDidChange,E=>E.reduce((b,m)=>({...b,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${$}`)}call(C,$,E){switch($){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(E)}throw new Error(`Call not found: ${$}`)}dispose(){this.a.dispose()}}e.$Jcc=j;class A extends L.$ao{constructor(C,$){super(),this.a=$;for(const E in C){const{definition:b,value:m}=C[E];this.f[E]=b,m!==void 0&&this.g.set(E,m)}this.a.listen("onDidChange")(E=>{for(const b in E){const m=E[b];m===null?this.g.delete(b):this.g.set(b,m)}this.h.fire(Object.keys(E))})}async j(C){const $=await this.a.call("updatePolicyDefinitions",C);for(const E in $)this.g.set(E,$[E])}}e.$Kcc=A}),define(ae[100],ce([0,1,36]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const j=L.context.configuration();if(j)N=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:j.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ae[24],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ek=void 0,e.$ek=(0,R.$ri)("productService"),e.$fk="vscode://schemas/vscode-product"}),define(ae[212],ce([0,1,6,7,2,14,31,9,24]),function(ne,e,R,N,L,j,A,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;let $=class extends L.$Uc{constructor(b,m,u){super(),this.b=m,this.c=u,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this.B(new R.$Dh(()=>{this.f(b)},3e4)).schedule()}async f(b){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),u=(0,j.$nc)(b),l=(0,j.$oc)(b),w=await A.Promises.readdir(u);await Promise.all(w.map(async p=>{if(p===l)return;const h=(0,j.$kc)(u,p),g=await A.Promises.stat(h);if(g.isDirectory()&&m-g.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${p}.`),A.Promises.rm(h)}))}catch(m){(0,N.$1)(m)}}};e.$Adc=$,e.$Adc=$=Ee([X(1,C.$ek),X(2,I.$Xj)],$)}),define(ae[213],ce([0,1,6,7,2,14,31,16,9,24]),function(ne,e,R,N,L,j,A,I,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;let E=class extends L.$Uc{constructor(m,u,l){super(),this.b=m,this.c=u,this.f=l,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new R.$Dh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),u=JSON.parse(await A.Promises.readFile((0,j.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(u)){const f=u[g];m[`${f.hash}.${g}`]=!0}const l=(0,j.$kc)(this.b.userDataPath,"clp");if(!await A.Promises.exists(l))return;const p=await A.Promises.readdir(l);for(const g of p){if(m[g]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await A.Promises.rm((0,j.$kc)(l,g))}const h=Date.now();for(const g of Object.keys(m)){const f=(0,j.$kc)(l,g),c=await A.Promises.readdir(f);for(const d of c){if(d==="tcf.json")continue;const i=(0,j.$kc)(f,d),o=await A.Promises.stat(i);o.isDirectory()&&h-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$kc)(g,d)}`),await A.Promises.rm(i))}}}catch(m){(0,N.$1)(m)}}};e.$Bdc=E,e.$Bdc=E=Ee([X(0,I.$zi),X(1,C.$Xj),X(2,$.$ek)],E)}),define(ae[214],ce([0,1,14,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$gG=void 0,e.$gG=(0,N.$ri)("IV8InspectProfilingService");var L;(function(j){function A(C){return!!(C.samples&&C.timeDeltas)}j.isValidProfile=A;function I(C,$="noAbsolutePaths"){for(const E of C.nodes)E.callFrame&&E.callFrame.url&&((0,R.$jc)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,R.$kc)($,(0,R.$oc)(E.callFrame.url)));return C}j.rewriteAbsolutePaths=I})(L||(e.Utils=L={}))}),define(ae[215],ce([0,1,32]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class N{constructor(){this.a=new Map}async startProfiling(j){const I=await(await new Promise(($,E)=>{ne(["v8-inspect-profiler"],$,E)})).startProfiling({host:j.host,port:j.port,checkForPaused:!0}),C=(0,R.$Ng)();return this.a.set(C,I),C}async stopProfiling(j){const A=this.a.get(j);if(!A)throw new Error(`UNKNOWN session '${j}'`);const I=await A.stop();return this.a.delete(j),I.profile}}e.$Sdc=N}),define(ae[42],ce([0,1,127,13]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0;class L{constructor(){this.a=new Map}add(A,I){R.ok(N.$5f(A)),R.ok(N.$7f(I)),R.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,I)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$0n=new L}),define(ae[101],ce([0,1,3,42]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=void 0,e.$$n={JSONContribution:"base.contributions.json"};function L(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class j{constructor(){this.b=new R.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,$){this.a[L(C)]=$,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const A=new j;N.$0n.add(e.$$n.JSONContribution,A)}),define(ae[47],ce([0,1,17,3,13,153,21,101,42]),function(ne,e,R,N,L,j,A,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.ConfigurationScope=e.$co=e.EditPresentationTypes=void 0,e.$no=w,e.$oo=p,e.$po=h,e.$qo=f,e.$ro=c;var $;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$co={Configuration:"base.contributions.configuration"};var E;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo="vscode://schemas/settings/resourceLanguage",e.$ko="vscode://schemas/settings/configurationDefaults";const b=C.$0n.as(I.$$n.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.$be,this.onDidSchemaChange=this.i.event,this.j=new N.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$jo,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),b.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),b.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),b.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$mo.test(r)){const a=this.a.get(r),y=a?.valuesSources??new Map;if(t)for(const k of Object.keys(s[r]))y.set(k,t);const v={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:v,valuesSources:y});const P=(0,A.$8i)(r),S={type:"object",default:v,description:j.localize(1,null,P),$ref:e.$jo,defaultDefaultValue:v,source:L.$5f(t)?void 0:t,defaultValueSource:t};n.push(...w(r)),this.d[r]=S,this.b.properties[r]=S}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=L.$5f(s)?s:s?.id,y=L.$5f(r?.source)?r?.source:r?.source?.id;if(a===y)if(o.add(t),this.a.delete(t),e.$mo.test(t))delete this.d[t],delete this.b.properties[t];else{const v=this.d[t];v&&(this.w(t,v),this.r(t,v))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=L.$bg(i.scope)?t:i.scope;const a=i.properties;if(a)for(const v in a){const P=a[v];if(o&&f(v,P)){delete a[v];continue}if(P.source=n,P.defaultDefaultValue=a[v].default,this.w(v,P),e.$mo.test(v)?P.scope=void 0:(P.scope=L.$bg(P.scope)?t:P.scope,P.restricted=L.$bg(P.restricted)?!!s?.includes(v):P.restricted),a[v].hasOwnProperty("included")&&!a[v].included){this.f[v]=a[v],delete a[v];continue}else this.d[v]=a[v],a[v].policy?.name&&this.e.set(a[v].policy.name,v);!a[v].deprecationMessage&&a[v].markdownDeprecationMessage&&(a[v].deprecationMessage=a[v].markdownDeprecationMessage),r.add(v)}const y=i.allOf;if(y)for(const v of y)this.p(v,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$do.properties[i]=o,o.scope){case 1:e.$eo.properties[i]=o;break;case 2:e.$fo.properties[i]=o;break;case 6:e.$go.properties[i]=o;break;case 3:e.$ho.properties[i]=o;break;case 4:e.$io.properties[i]=o;break;case 5:e.$io.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$do.properties[i],o.scope){case 1:delete e.$eo.properties[i];break;case 2:delete e.$fo.properties[i];break;case 6:delete e.$go.properties[i];break;case 3:delete e.$ho.properties[i];break;case 4:case 5:delete e.$io.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$jo};this.w(o,n),e.$do.properties[o]=n,e.$eo.properties[o]=n,e.$fo.properties[o]=n,e.$go.properties[o]=n,e.$ho.properties[o]=n,e.$io.properties[o]=n}}v(){const i={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$jo};e.$do.patternProperties[e.$lo]=i,e.$eo.patternProperties[e.$lo]=i,e.$fo.patternProperties[e.$lo]=i,e.$go.patternProperties[e.$lo]=i,e.$ho.patternProperties[e.$lo]=i,e.$io.patternProperties[e.$lo]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;L.$_f(s)&&(s=o.defaultDefaultValue,t=void 0),L.$_f(s)&&(s=h(o.type)),o.default=s,o.defaultValueSource=t}}const u="\\[([^\\]]+)\\]",l=new RegExp(u,"g");e.$lo=`^(${u})+$`,e.$mo=new RegExp(e.$lo);function w(d){const i=[];if(e.$mo.test(d)){let o=l.exec(d);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=l.exec(d)}}return(0,R.$Mb)(i)}function p(d){return d.reduce((i,o)=>`${i}[${o}]`,"")}function h(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new m;C.$0n.add(e.$co.Configuration,g);function f(d,i){return d.trim()?e.$mo.test(d)?j.localize(7,null,d):g.getConfigurationProperties()[d]!==void 0?j.localize(8,null,d):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?j.localize(9,null,d,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:j.localize(6,null)}function c(){const d=[],i=g.getConfigurationProperties();for(const o of Object.keys(i))d.push([o,i[o].scope]);return d.push(["launch",4]),d.push(["task",4]),d}}),define(ae[76],ce([0,1,17,3,35,2,34,30,13,8,21,47,42]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$vo=e.$uo=e.$to=e.$so=void 0,e.$wo=f;function u(o){return Object.isFrozen(o)?o:I.$Yn(o)}class l{static createEmptyModel(n){return new l({},[],[],void 0,n)}constructor(n,s,t,r,a){this.b=n,this.c=s,this.d=t,this.raw=r,this.f=a,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof l)return s;const t=new w("",this.f);return t.parseRaw(s),t.configurationModel});this.g=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,E.$6i)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return u(t.rawConfiguration.getValue(n))},get override(){return s?u(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return u(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:y,keys:v}of t.rawConfiguration.overrides){const P=new l(a,v,[],void 0,t.f).getValue(n);P!==void 0&&r.push({identifiers:y,value:P})}return r.length?u(r):void 0}}}getOverrideValue(n,s){const t=this.j(s);return t?n?(0,E.$6i)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return R.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return R.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.h(n),this.a.set(n,s)),s}merge(...n){const s=I.$Xn(this.contents),t=I.$Xn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const y of n)if(a.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(s,y.contents);for(const v of y.overrides){const[P]=t.filter(S=>R.$ub(S.identifiers,v.identifiers));P?(this.i(P.contents,v.contents),P.keys.push(...v.keys),P.keys=R.$Mb(P.keys)):t.push(I.$Xn(v))}for(const v of y.keys)r.indexOf(v)===-1&&r.push(v)}return new l(s,r,t,a.every(y=>y instanceof l)?void 0:a,this.f)}h(n){const s=this.j(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of R.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const y=s[r];y&&(typeof a=="object"&&typeof y=="object"?(a=I.$Xn(a),this.i(a,y)):a=y),t[r]=a}return new l(t,this.keys,this.overrides,void 0,this.f)}i(n,s){for(const t of Object.keys(s)){if(t in n&&C.$7f(n[t])&&C.$7f(s[t])){this.i(n[t],s[t]);continue}n[t]=I.$Xn(s[t])}}j(n){let s=null,t=null;const r=a=>{a&&(t?this.i(t,a):t=I.$Xn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.k(n,s,!0)}setValue(n,s){this.k(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,E.$5i)(this.contents,n),b.$mo.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>R.$ub(t.identifiers,(0,b.$no)(n))),1))}k(n,s,t){(0,E.$4i)(this.contents,n,s,r=>this.f.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),b.$mo.test(n)&&this.overrides.push({identifiers:(0,b.$no)(n),keys:Object.keys(this.contents[n]),contents:(0,E.$3i)(this.contents[n],r=>this.f.error(r))})}}e.$so=l;class w{constructor(n,s){this.f=n,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||l.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!C.$bg(n)){const t=this.h(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:y,hasExcludedProperties:v}=this.i(n,s);this.b=new l(t,r,a,v?[n]:void 0,this.g),this.c=y||[]}h(n){let s={},t=null,r=[];const a=[],y=[];function v(S){Array.isArray(r)?r.push(S):t!==null&&(r[t]=S)}const P={onObjectBegin:()=>{const S={};v(S),a.push(r),r=S,t=null},onObjectProperty:S=>{t=S},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const S=[];v(S),a.push(r),r=S,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:v,onError:(S,k,D)=>{y.push({error:S,offset:k,length:D})}};if(n)try{L.$Ln(n,P),s=r[0]||{}}catch(S){this.g.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return s}i(n,s){const t=m.$0n.as(b.$co.Configuration).getConfigurationProperties(),r=this.j(n,t,!0,s);n=r.raw;const a=(0,E.$3i)(n,P=>this.g.error(`Conflict in settings file ${this.f}: ${P}`)),y=Object.keys(n),v=this.l(n,P=>this.g.error(`Conflict in settings file ${this.f}: ${P}`));return{contents:a,keys:y,overrides:v,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}j(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const y={},v=[];for(const P in n)if(b.$mo.test(P)&&t){const S=this.j(n[P],s,!1,r);y[P]=S.raw,a=a||S.hasExcludedProperties,v.push(...S.restricted)}else{const S=s[P],k=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&v.push(P),!r.exclude?.includes(P)&&(r.include?.includes(P)||(k===void 0||r.scopes===void 0||r.scopes.includes(k))&&!(r.skipRestricted&&S?.restricted))?y[P]=n[P]:a=!0}return{raw:y,restricted:v,hasExcludedProperties:a}}l(n,s){const t=[];for(const r of Object.keys(n))if(b.$mo.test(r)){const a={};for(const y in n[r])a[y]=n[r][y];t.push({identifiers:(0,b.$no)(r),keys:Object.keys(a),contents:(0,E.$3i)(a,s)})}return t}}e.$to=w;class p extends j.$Uc{constructor(n,s,t,r,a){super(),this.c=n,this.f=s,this.g=r,this.h=a,this.b=this.B(new N.$be),this.onDidChange=this.b.event,this.a=new w(this.c.toString(),a),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&t.isEqual(y.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return l.createEmptyModel(this.h)}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$uo=p;class h{constructor(n,s,t,r,a,y,v,P,S,k,D,T,F){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=y,this.g=v,this.h=P,this.i=S,this.j=k,this.k=D,this.l=T,this.m=F}get value(){return u(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class g{constructor(n,s,t,r,a,y,v,P,S,k){this.j=n,this.l=s,this.m=t,this.n=r,this.p=a,this.q=y,this.r=v,this.s=P,this.t=S,this.u=k,this.h=null,this.i=new A.$Bc,this.v=null}getValue(n,s,t){return this.w(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.t.get(t.resource),r||(r=l.createEmptyModel(this.u),this.t.set(t.resource,r))):r=this.s,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.h=null)}inspect(n,s,t){const r=this.w(n,s,t),a=this.A(s.resource,t),y=s.resource?this.t.get(s.resource)||this.s:this.s,v=new Set;for(const P of r.overrides)for(const S of P.identifiers)r.getOverrideValue(n,S)!==void 0&&v.add(S);return new h(n,s,r.getValue(n),v.size?[...v]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.q:void 0,a||void 0,y)}keys(n){const s=this.A(void 0,n);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.j=n,this.h=null,this.i.clear()}updatePolicyConfiguration(n){this.l=n}updateApplicationConfiguration(n){this.m=n,this.h=null,this.i.clear()}updateLocalUserConfiguration(n){this.n=n,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(n){this.p=n,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(n){this.q=n,this.h=null,this.i.clear()}updateFolderConfiguration(n,s){this.r.set(n,s),this.i.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.i.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:y}=d(this.j,n);s=[...r,...a,...y]}for(const r of s)for(const a of(0,b.$no)(r)){const y=this.j.getKeysForOverrideIdentifier(a),v=n.getKeysForOverrideIdentifier(a),P=[...v.filter(S=>y.indexOf(S)===-1),...y.filter(S=>v.indexOf(S)===-1),...y.filter(S=>!I.$2n(this.j.override(a).getValue(S),n.override(a).getValue(S)))];t.push([a,P])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=d(this.l,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=d(this.applicationConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateApplicationConfiguration(n),{keys:y,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=d(this.localUserConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateLocalUserConfiguration(n),{keys:y,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=d(this.remoteUserConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateRemoteUserConfiguration(n),{keys:y,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=d(this.workspaceConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateWorkspaceConfiguration(n),{keys:y,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:y,overrides:v}=d(t,s),P=[...r,...a,...y];return(P.length||!t)&&this.updateFolderConfiguration(n,s),{keys:P,overrides:v}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:y}=d(s,void 0);return{keys:[...t,...r,...a],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(n,s,t){let r=this.x(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(n)!==void 0&&(r=r.merge(this.l)),r}x({resource:n},s){let t=this.y();if(s&&n){const r=s.getFolder(n);r&&(t=this.z(r.uri)||t);const a=this.t.get(n);a&&(t=t.merge(a))}return t}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(n){let s=this.i.get(n);if(!s){const t=this.y(),r=this.r.get(n);r?(s=t.merge(r),this.i.set(n,s)):s=t}return s}A(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.r.get(t.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.r.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.j.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.q.keys.forEach(s=>n.add(s)),this.r.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}B(){const n=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}D(n){const s=new Set;return this.j.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.q.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.r.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n,s){const t=this.E(n.defaults,s),r=this.E(n.policy,s),a=this.E(n.application,s),y=this.E(n.user,s),v=this.E(n.workspace,s),P=n.folders.reduce((S,k)=>(S.set($.URI.revive(k[0]),this.E(k[1],s)),S),new A.$Bc);return new g(t,r,a,y,l.createEmptyModel(s),v,P,l.createEmptyModel(s),new A.$Bc,s)}static E(n,s){return new l(n.contents,n.keys,n.overrides,void 0,s)}}e.$vo=g;function f(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,y])=>{const v=(0,A.$yc)(s,a,new Set);y.forEach(P=>v.add(P))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}class c{constructor(n,s,t,r,a){this.change=n,this.f=s,this.g=t,this.h=r,this.i=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of n.keys)this.affectedKeys.add(y);for(const[,y]of n.overrides)for(const v of y)this.affectedKeys.add(v);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=g.parse(this.f.data,this.i)),this.j}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const y=this.d.charCodeAt(a);if(y!==this.b&&y!==this.c)return!1;if(s){const v=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,P=this.g.getValue(n,s,this.h);return!I.$2n(v,P)}return!0}}e.$xo=c;function d(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],y=o?.getAllOverrideIdentifiers()||[],v=n?.getAllOverrideIdentifiers()||[];if(n){const P=v.filter(S=>!y.includes(S));for(const S of P)a.push([S,n.getKeysForOverrideIdentifier(S)])}if(o){const P=y.filter(S=>!v.includes(S));for(const S of P)a.push([S,o.getKeysForOverrideIdentifier(S)])}if(n&&o){for(const P of y)if(v.includes(P)){const S=i({contents:o.getOverrideValue(void 0,P)||{},keys:o.getKeysForOverrideIdentifier(P)},{contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)});a.push([P,[...S.added,...S.removed,...S.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const y=(0,E.$6i)(n.contents,a),v=(0,E.$6i)(o.contents,a);I.$2n(y,v)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(ae[216],ce([0,1,17,3,2,30,13,76,47,9,58,42]),function(ne,e,R,N,L,j,A,I,C,$,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=void 0;class m extends L.$Uc{get configurationModel(){return this.b}constructor(p){super(),this.c=p,this.a=this.B(new N.$be),this.onDidChangeConfiguration=this.a.event,this.b=I.$so.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(b.$0n.as(C.$co.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:h})=>this.f(Array.from(p),h))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(p,h){this.j(p,b.$0n.as(C.$co.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}g(){return{}}h(){this.b=I.$so.createEmptyModel(this.c);const p=b.$0n.as(C.$co.Configuration).getConfigurationProperties();this.j(Object.keys(p),p)}j(p,h){const g=this.g();for(const f of p){const c=g[f],d=h[f];c!==void 0?this.b.addValue(f,c):d?this.b.addValue(f,d.default):this.b.removeValue(f)}}}e.$yo=m;class u{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=I.$so.createEmptyModel(new $.$$j)}async initialize(){return this.configurationModel}}e.$zo=u;let l=class extends L.$Uc{get configurationModel(){return this.b}constructor(p,h,g){super(),this.c=p,this.f=h,this.g=g,this.a=this.B(new N.$be),this.onDidChangeConfiguration=this.a.event,this.b=I.$so.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const h={},g=[],f=b.$0n.as(C.$co.Configuration).getConfigurationProperties();for(const c of p){const d=f[c];if(!d){g.push(c);continue}if(d.policy){if(d.type!=="string"&&d.type!=="number"){this.g.warn(`Policy ${d.policy.name} has unsupported type ${d.type}`);continue}g.push(c),h[d.policy.name]={type:d.type}}}return(0,A.$fg)(h)||await this.f.updatePolicyDefinitions(h),g}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const h=b.$0n.as(C.$co.Configuration).getPolicyConfigurations(),g=(0,R.$Hb)(p.map(f=>h.get(f)));this.m(g,!0)}m(p,h){this.g.trace("PolicyConfiguration#update",p);const g=b.$0n.as(C.$co.Configuration).getConfigurationProperties(),f=[],c=this.b.isEmpty();for(const d of p){const i=g[d]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(c?o!==void 0:!(0,j.$2n)(this.b.getValue(d),o))&&f.push([d,o])}else this.b.getValue(d)!==void 0&&f.push([d,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const d=this.b;this.b=I.$so.createEmptyModel(this.g);for(const i of d.keys)this.b.setValue(i,d.getValue(i));for(const[i,o]of f)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);h&&this.a.fire(this.b)}}};e.$Ao=l,e.$Ao=l=Ee([X(1,E.$_n),X(2,$.$Xj)],l)}),define(ae[217],ce([0,1,17,6,15,3,35,62,2,34,30,5,20,21,76,47,216,58]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=void 0;class g extends C.$Uc{constructor(d,i,o,n){super(),this.m=d,this.n=n,this.h=this.B(new j.$be),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$yo(n)),this.c=o instanceof h.$bo?new p.$zo:this.B(new p.$Ao(this.b,o,n)),this.f=this.B(new l.$uo(this.m,{},m.$Vg,i,n)),this.a=new l.$vo(this.b.configurationModel,this.c.configurationModel,l.$so.createEmptyModel(n),l.$so.createEmptyModel(n),l.$so.createEmptyModel(n),l.$so.createEmptyModel(n),new $.$Bc,l.$so.createEmptyModel(n),new $.$Bc,n),this.j=new f(d,i,this),this.g=this.B(new N.$Dh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:t})=>this.s(s,t))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,i,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$vo(d,i,l.$so.createEmptyModel(this.n),o,l.$so.createEmptyModel(this.n),l.$so.createEmptyModel(this.n),new $.$Bc,l.$so.createEmptyModel(this.n),new $.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(d,i){const o=typeof d=="string"?d:void 0,n=(0,u.$Yi)(d)?d:(0,u.$Yi)(i)?i:{};return this.a.getValue(o,n,void 0)}async updateValue(d,i,o,n,s){const t=(0,u.$Zi)(o)?o:(0,u.$Yi)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,r=t?n:o;if(r!==void 0&&r!==3&&r!==2)throw new Error(`Unable to write ${d} to target ${r}.`);t?.overrideIdentifiers&&(t.overrideIdentifiers=(0,R.$Mb)(t.overrideIdentifiers),t.overrideIdentifiers=t.overrideIdentifiers.length?t.overrideIdentifiers:void 0);const a=this.inspect(d,{resource:t?.resource,overrideIdentifier:t?.overrideIdentifiers?t.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${d} because it is configured in system policy.`);if((0,E.$2n)(i,a.defaultValue)&&(i=void 0),t?.overrideIdentifiers?.length&&t.overrideIdentifiers.length>1){const v=t.overrideIdentifiers.sort(),P=this.a.localUserConfiguration.overrides.find(S=>(0,R.$ub)([...S.identifiers].sort(),v));P&&(t.overrideIdentifiers=P.identifiers)}const y=t?.overrideIdentifiers?.length?[(0,w.$oo)(t.overrideIdentifiers),d]:[d];await this.j.write(y,i),await this.reloadConfiguration()}inspect(d,i={}){return this.a.inspect(d,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.r(d)}r(d){const i=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(d);this.u(o,i,2)}s(d,i){const o=this.a.toData(),n=this.a.compareAndUpdateDefaultConfiguration(d,i);this.u(n,o,7)}t(d){const i=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(d);this.u(o,i,7)}u(d,i,o){const n=new l.$xo(d,{data:i},this.a,void 0,this.n);n.source=o,this.h.fire(n)}}e.$Bo=g;class f{constructor(d,i,o){this.b=d,this.c=i,this.d=o,this.a=new N.$yh}write(d,i){return this.a.queue(()=>this.e(d,i))}async e(d,i){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(t){if(t.fileOperationResult===1)o="{}";else throw t}const n=[];if((0,A.$En)(o,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(o,d,i);o=(0,I.$Wn)(o,s),await this.c.writeFile(this.b,L.$Ce.fromString(o))}f(d,i,o){const{tabSize:n,insertSpaces:s,eol:t}=this.h;if(!i.length){const r=JSON.stringify(o,null,s?" ".repeat(n):"	");return[{content:r,length:r.length,offset:0}]}return(0,I.$Tn)(d,i,o,{tabSize:n,insertSpaces:s,eol:t})}get h(){if(!this.g){let d=b.OS===3||b.OS===2?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(d=i),this.g={eol:d,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[218],ce([0,1,15,3,2,68]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ssb=e.$Qsb=e.$Psb=void 0,e.$Rsb=I;const A=($,E,b)=>{const m=new Uint8Array(16);for(let w=0;w<16;w++)m[w]=Math.round(Math.random()*256);const u=(0,R.$We)(R.$Ce.wrap(m));return[`GET ws://localhost${$}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`].join(`\r
`)+`\r
\r
`};e.$Psb=A,e.$Qsb=R.$Ce.fromString(`\r
\r
`);async function I($,E,b,m,u){$.write(R.$Ce.fromString((0,e.$Psb)(E,b,m)));const l=new L.$Tc;try{return await new Promise((w,p)=>{let h;l.add($.onData(g=>{h?h=R.$Ce.concat([h,g],h.byteLength+g.byteLength):h=g;const f=h.indexOf(e.$Qsb);if(f===-1)return;w($),$.pauseData();const c=h.slice(f+e.$Qsb.byteLength);c.byteLength&&u.onData.fire(c)})),l.add($.onClose(g=>p(g??new Error("socket closed")))),l.add($.onEnd(()=>p(new Error("socket ended"))))})}catch(w){throw $.dispose(),w}finally{l.dispose()}}class C extends L.$Uc{constructor(E,b){super(),this.g=E,this.a=this.B(new N.$ee),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new N.$be),this.onDidDispose=this.b.event,this.f=!1,this.B(b.onData),this.B(b.onData.event(m=>this.a.fire(m))),this.onClose=this.B(b.onClose).event,this.onEnd=this.B(b.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(E,b){j.SocketDiagnostics.traceSocketEvent(this,this.g,E,b)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Ssb=C}),define(ae[219],ce([0,1,7,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.RemoteAuthorityResolverErrorCode=e.$El=e.$Dl=e.RemoteConnectionType=e.$Cl=void 0,e.$Gl=$,e.$Cl=(0,N.$ri)("remoteAuthorityResolverService");var L;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class j{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.$Dl=j;class A{constructor(b,m){this.host=b,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$El=A;var I;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class C extends R.$bb{static isNotAvailable(b){return b instanceof C&&b._code===I.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof C&&b._code===I.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof C&&b._code===I.NoResolverFound}static isInvalidAuthority(b){return b instanceof C&&b._code===I.InvalidAuthority}static isHandled(b){return b instanceof C&&b.isHandled}constructor(b,m=I.Unknown,u){super(b),this._message=b,this._code=m,this._detail=u,this.isHandled=m===I.NotAvailable&&u===!0,Object.setPrototypeOf(this,C.prototype)}}e.$Fl=C;function $(E){const b=E.indexOf("+");return b===-1?E:E.substring(0,b)}}),define(ae[220],ce([0,1,6,15,26,7,3,2,23,98,63,32,68,219]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ll=y,e.$Ml=v,e.$Nl=S;const l=30*1e3;var w;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function p(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(z){const O=new L.$me;return setTimeout(()=>O.cancel(),z),O.token}function g(z,O){if(z.isCancellationRequested||O.isCancellationRequested)return L.CancellationToken.Cancelled;const M=new L.$me;return z.onCancellationRequested(()=>M.cancel()),O.onCancellationRequested(()=>M.cancel()),M.token}class f{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new I.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,R.$kh)(),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function c(z,O){const M=new f(O);return M.registerDisposable(z.onControlMessage(q=>{const x=JSON.parse(q.toString()),K=B(x);K?M.reject(K):M.resolve(x)})),M.promise}function d(z,O,M,q,x,K,ee,_){const Z=new f(_),se=E.$0d.create(!1);return z.info(`Creating a socket (${ee})...`),$.mark(`code/willCreateSocket/${K}`),O.connect(M,q,x,ee).then(ue=>{Z.didTimeout?($.mark(`code/didCreateSocketError/${K}`),z.info(`Creating a socket (${ee}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):($.mark(`code/didCreateSocketOK/${K}`),z.info(`Creating a socket (${ee}) was successful after ${se.elapsed()} ms.`),Z.resolve(ue))},ue=>{$.mark(`code/didCreateSocketError/${K}`),z.info(`Creating a socket (${ee}) returned an error after ${se.elapsed()} ms.`),z.error(ue),Z.reject(ue)}),Z.promise}function i(z,O){const M=new f(O);return z.then(q=>{M.didTimeout||M.resolve(q)},q=>{M.didTimeout||M.reject(q)}),M.promise}async function o(z,O,M,q){const x=te(z,O);z.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let K;try{K=await d(z.logService,z.remoteSocketFactoryService,z.connectTo,C.$Eg.getServerRootPath(),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,p(O),`renderer-${p(O)}-${z.reconnectionToken}`,q)}catch(ue){throw z.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ue),ue}z.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let ee,_;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(K,null),ee=z.reconnectionProtocol,_=!1):(ee=new m.$fi({socket:K}),_=!0),z.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const Z=await i(z.signService.createNewMessage((0,b.$Ng)()),q),se={type:"auth",auth:z.connectionToken||"00000000000000000000",data:Z.data};ee.sendControl(N.$Ce.fromString(JSON.stringify(se)));try{const ue=await c(ee,g(q,h(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(z.logService.trace(`${x} 4/6. received SignRequest control message.`),!await i(z.signService.validate(Z,ue.signedData),q)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const fe=await i(z.signService.sign(ue.data),q),$e={type:"connectionType",commit:z.commit,signedData:fe,desiredConnectionType:O};return M&&($e.args=M),z.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(N.$Ce.fromString(JSON.stringify($e))),{protocol:ee,ownsProtocol:_}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(z.logService.error(`${x} the handshake timed out. Error:`),z.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${x} received error control message when negotiating connection. Error:`),z.logService.error(ue)),_&&H(ee),ue}}async function n(z,O,M,q){const x=Date.now(),K=te(z,O),{protocol:ee,ownsProtocol:_}=await o(z,O,M,q),Z=new f(q);return Z.registerDisposable(ee.onControlMessage(se=>{const ue=JSON.parse(se.toString()),ge=B(ue);ge?(z.logService.error(`${K} received error control message when negotiating connection. Error:`),z.logService.error(ge),_&&H(ee),Z.reject(ge)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${V(x)}!`),Z.resolve({protocol:ee,firstMessage:ue}))})),Z.promise}async function s(z,O){const{protocol:M}=await n(z,1,void 0,O);return{protocol:M}}async function t(z,O,M){const{protocol:q,firstMessage:x}=await n(z,2,O,M),K=x&&x.debugPort;return{protocol:q,debugPort:K}}async function r(z,O,M){const q=Date.now(),x=te(z,3),{protocol:K}=await o(z,3,O,M);return z.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${V(q)}!`),K}async function a(z,O,M){const{connectTo:q,connectionToken:x}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,connectTo:q,connectionToken:x,reconnectionToken:O,reconnectionProtocol:M,remoteSocketFactoryService:z.remoteSocketFactoryService,signService:z.signService,logService:z.logService}}async function y(z,O,M){return P(z,async q=>{const{protocol:x}=await s(q,L.CancellationToken.None);return new W(z,O,M,q.reconnectionToken,x)})}async function v(z,O){return P(z,async M=>{const{protocol:q,debugPort:x}=await t(M,O,L.CancellationToken.None);return new J(z,O,M.reconnectionToken,q,x)})}async function P(z,O){for(let q=1;;q++)try{const x=(0,b.$Ng)(),K=await a(z,x,null);return await O(K)}catch(x){if(q<5)z.logService.error(`[remote-connection][attempt ${q}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(x);else throw z.logService.error(`[remote-connection][attempt ${q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(x),Y.triggerPermanentFailure(0,0,u.$Fl.isHandled(x)),x}}async function S(z,O,M){const q=await a(z,(0,b.$Ng)(),null);return await r(q,{host:O,port:M},L.CancellationToken.None)}function k(z){return(0,R.$eh)(O=>new Promise((M,q)=>{const x=setTimeout(M,z*1e3);O.onCancellationRequested(()=>{clearTimeout(x),M()})}))}var D;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(D||(e.PersistentConnectionEventType=D={}));class T{constructor(O,M){this.reconnectionToken=O,this.millisSinceLastIncomingData=M,this.type=0}}e.$Ol=T;class F{constructor(O,M,q,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=M,this.durationSeconds=q,this.c=x,this.type=1}skipWait(){this.c.cancel()}}e.$Pl=F;class U{constructor(O,M,q){this.reconnectionToken=O,this.millisSinceLastIncomingData=M,this.attempt=q,this.type=2}}e.$Ql=U;class Q{constructor(O,M,q){this.reconnectionToken=O,this.millisSinceLastIncomingData=M,this.attempt=q,this.type=4}}e.$Rl=Q;class G{constructor(O,M,q,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=M,this.attempt=q,this.handled=x,this.type=3}}e.$Sl=G;class Y extends I.$Uc{static triggerPermanentFailure(O,M,q){this._permanentFailure=!0,this.f=O,this.g=M,this.h=q,this.j.forEach(x=>x.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Y._permanentFailure}constructor(O,M,q,x,K){super(),this.t=O,this.u=M,this.reconnectionToken=q,this.protocol=x,this.w=K,this.m=this.B(new A.$be),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Q(this.reconnectionToken,0,0)),this.B(x.onSocketClose(ee=>{const _=he(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(x.onSocketTimeout(ee=>{const _=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),Y.j.push(this),this.B((0,I.$Sc)(()=>{const ee=Y.j.indexOf(this);ee>=0&&Y.j.splice(ee,1)})),this.n&&this.D(Y.f,Y.g,Y.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const x=q<M.length?M[q]:M[M.length-1];try{if(x>0){const ee=k(x);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,ee)),this.u.logService.info(`${O} waiting for ${x} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this.u.logService.info(`${O} resolving connection...`);const K=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${K.connectTo}...`),await this.G(K,h(l)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(u.$Fl.isTemporarilyNotAvailable(K)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((0,j.$4)(K)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if(K instanceof u.$Fl){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,u.$Fl.isHandled(K));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!this.n&&!this.s)}C(O,M,q){this.w?Y.triggerPermanentFailure(O,M,q):this.D(O,M,q)}D(O,M,q){this.m.fire(new G(this.reconnectionToken,O,M,q)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Tl=Y;class W extends Y{constructor(O,M,q,x,K){super(1,O,x,K,!0),this.client=this.B(new m.$di(K,{remoteAuthority:M,clientId:q},O.ipcLogger))}async G(O,M){await s(O,M)}}e.$Ul=W;class J extends Y{constructor(O,M,q,x,K){super(2,O,q,x,!1),this.H=M,this.debugPort=K}async G(O,M){await t(O,this.H,M)}}e.$Vl=J;function H(z){try{z.acceptDisconnect();const O=z.getSocket();z.dispose(),O.dispose()}catch(O){(0,j.$1)(O)}}function B(z){if(z&&z.type==="error"){const O=new Error(`Connection error: ${z.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function ie(z,O){for(;z.length<O;)z+=" ";return z}function re(z,O){return`[remote-connection][${ie(p(z),13)}][${O.substr(0,5)}\u2026]`}function he(z,O,M){return`${re(z,O)}[${M?"reconnect":"initial"}]`}function te(z,O){return`${he(O,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.connectTo}]`}function V(z){return`${Date.now()-z} ms`}}),define(ae[102],ce([0,1,23]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=N,e.$Dm=L,e.$Em=j,e.$Fm=A;function N(C){return C.scheme===R.Schemas.vscodeRemote?C.authority:void 0}function L(C){if(!C)return;const $=C.indexOf("+");return $<0?C:C.substr(0,$)}function j(C){const{host:$,port:E}=I(C);if(typeof E>"u")throw new Error(`Invalid remote authority: ${C}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:$,port:E}}function A(C,$){let{host:E,port:b}=I(C);return typeof b>"u"&&(b=$),{host:E,port:b}}function I(C){const $=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const E=C.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const b=C.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:C,port:void 0}}}),define(ae[48],ce([0,1,27,4,102]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Om=e.$Nm=e.$Mm=e.TargetPlatform=e.ExtensionType=e.$Lm=e.$Jm=e.$Im=e.$Hm=e.$Gm=void 0,e.$Km=j,e.$Pm=b,e.$Qm=m,e.$Rm=u,e.$Sm=l,e.$Gm="extensions.user.cache",e.$Hm="extensions.builtin.cache",e.$Im="undefined_publisher",e.$Jm=["ui","workspace","web"];function j(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Lm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(A||(e.ExtensionType=A={}));var I;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class C{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p>"u"||p===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){const g=typeof p=="string"?p:p.value,f=typeof h=="string"?h:h.value;return R.$uf(g,f)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$Mm=C;class ${get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const h of p)this.add(h)}add(p){this.c.add(C.toKey(p))}delete(p){return this.c.delete(C.toKey(p))}has(p){return this.c.has(C.toKey(p))}}e.$Nm=$;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(C.toKey(p))}get(p){return this.c.get(C.toKey(p))}has(p){return this.c.has(C.toKey(p))}set(p,h){this.c.set(C.toKey(p),h)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Om=E;function b(w){return m(w)}function m(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}function u(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}function l(w,p){if(p){const h=`onResolveRemoteAuthority:${(0,L.$Dm)(p)}`;return!!w.activationEvents?.includes(h)}return!1}e.$Tm=(0,N.$ri)("IBuiltinExtensionsScannerService")}),define(ae[221],ce([0,1,2,48,12]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=void 0;class j extends R.$Uc{constructor(I,C,$,E,b){super(),this.a=I,this.b=C,this.c=$,this.f=b,this.B(E.onDidInstallExtensions(m=>this.g(m))),this.B(E.onDidUninstallExtension(m=>this.h(m)))}g(I){for(const C of I)C.local&&this.invalidate(C.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const C of this.a.profiles)this.c.extUri.isEqual(C.extensionsResource,I)&&await this.j(C);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,N.$Gm))}catch(C){(0,L.$cl)(C)!==1&&this.f.error(C)}}}e.$wq=j}),define(ae[103],ce([0,1,2,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=void 0,e.$Hl=(0,N.$ri)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(A,I){return this.a[A]??=[],this.a[A].push(I),(0,R.$Sc)(()=>{const C=this.a[A]?.indexOf(I);typeof C=="number"&&C>=0&&this.a[A]?.splice(C,1)})}b(A){return(this.a[A.type]||[]).find(C=>C.supports(A))}connect(A,I,C,$){const E=this.b(A);if(!E)throw new Error(`No socket factory found for ${A}`);return E.connect(A,I,C,$)}}e.$Il=L}),define(ae[222],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=e.$Pdc=void 0,e.$Pdc=(0,R.$ri)("sharedProcessTunnelService"),e.$Qdc="sharedProcessTunnel"}),define(ae[104],ce([0,1,4,169]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=e.$Ydc=e.$Xdc=e.$Wdc=e.TunnelStates=e.$Vdc=e.$Udc=void 0,e.$Udc=(0,R.$ri)("IRemoteTunnelService"),e.$Vdc={active:!1};var L;(function(j){j.disconnected=A=>({type:"disconnected",onTokenFailed:A}),j.connected=(A,I)=>({type:"connected",info:A,serviceInstallFailed:I}),j.connecting=A=>({type:"connecting",progress:A}),j.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$Wdc="remote.tunnels.access",e.$Xdc=e.$Wdc+".hostNameOverride",e.$Ydc=e.$Wdc+".preventSleep",e.$Zdc="remoteTunnelService",e.$1dc=(0,N.localize)(0,null)}),define(ae[59],ce([0,1,15,7,2,171,47,4,9,42]),function(ne,e,R,N,L,j,A,I,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=void 0,e.$Kp=m,e.$Lp=u,e.$Mp=l,e.$Np=w,e.$Op=p,e.$Pp=h,e.$Ip=(0,I.$ri)("requestService");class E{constructor(d){this.b=d}toJSON(){if(!this.a){const d=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?d[i]="*****":d[i]=this.b[i];this.a=d}return this.a}}class b extends L.$Uc{constructor(d){super(),this.b=0,this.a=d.createLogger("network",{name:(0,j.localize)(0,null),when:C.$dk.isEqualTo((0,C.$ak)(C.LogLevel.Trace)).serialize()})}async c(d,i,o){const n=`${d} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new E(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,N.$0)(s)),s}}}e.$Jp=b;function m(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function u(c){return c.res.statusCode===204}async function l(c){return u(c)?null:(await(0,R.$Oe)(c.stream)).toString()}async function w(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);return l(c)}async function p(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);if(u(c))return null;const i=(await(0,R.$Oe)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}function h(c){f(c)}let g;function f(c){const d=$.$0n.as(A.$co.Configuration),i=g;g={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},d.updateConfigurations({add:[g],remove:i?[i]:[]})}f(1)}),define(ae[223],ce([0,1,26,23,12,59]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=void 0;let A=class{constructor(C,$){this.a=C,this.b=$}async download(C,$,E=R.CancellationToken.None){if(C.scheme===N.Schemas.file||C.scheme===N.Schemas.vscodeRemote){await this.b.copy(C,$);return}const b={type:"GET",url:C.toString(!0)},m=await this.a.request(b,E);if(m.res.statusCode===200)await this.b.writeFile($,m.stream);else{const u=await(0,j.$Np)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${u}`)}}};e.$SQ=A,e.$SQ=A=Ee([X(0,j.$Ip),X(1,L.$Xk)],A)}),define(ae[224],ce([0,1,15,26]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=void 0;class L{constructor(I){this.a=I}listen(I,C){throw new Error("Invalid listen")}call(I,C,$,E=N.CancellationToken.None){switch(C){case"request":return this.a.request($[0],E).then(async({res:b,stream:m})=>{const u=await(0,R.$Oe)(m);return[{statusCode:b.statusCode,headers:b.headers},u]});case"resolveProxy":return this.a.resolveProxy($[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Pr=L;class j{constructor(I){this.a=I}async request(I,C){const[$,E]=await this.a.call("request",[I],C);return{res:$,stream:(0,R.$Qe)(E)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Qr=j}),define(ae[225],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=e.$hcc=void 0,e.$hcc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$icc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$jcc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[226],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b$b=void 0;class R{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const j=await this.c();if(j){const A=String(R.a++);return this.b.set(A,j),{id:A,data:j.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,j){if(!L.id)return!0;const A=this.b.get(L.id);if(!A)return!1;this.b.delete(L.id);try{return A.validate(j)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$b$b=R}),define(ae[105],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=void 0,e.$Jl="signService",e.$Kl=(0,R.$ri)(e.$Jl)}),define(ae[227],ce([0,1,226]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class N extends R.$b$b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(A=>new A.signer().sign(j))}h(){return new Promise((j,A)=>ne(["vsda"],j,A))}}e.$0cc=N}),define(ae[77],ce([0,1,3,2]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Jb=e.$$Jb=e.$0Jb=e.$9Jb=void 0;class L extends N.$Uc{constructor(b,m,u){super(),this.a=b,this.b=m,this.c=u}async getItems(){const b={profile:this.b,workspace:this.c},m=await this.a.call("getItems",b);return new Map(m)}updateItems(b){const m={profile:this.b,workspace:this.c};return b.insert&&(m.insert=Array.from(b.insert.entries())),b.delete&&(m.delete=Array.from(b.delete.values())),this.a.call("updateItems",m)}optimize(){const b={profile:this.b,workspace:this.c};return this.a.call("optimize",b)}}class j extends L{constructor(b,m){super(b,m,void 0),this.f=this.B(new R.$be),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(b=>this.h(b)))}h(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this.f.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class A extends j{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.$9Jb=A;class I extends j{constructor(b,m){super(b,m)}async close(){this.dispose()}}e.$0Jb=I;class C extends L{constructor(b,m){super(b,void 0,m),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.$$Jb=C;class ${constructor(b){this.a=b}isUsed(b){const m={payload:b,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$_Jb=$}),define(ae[106],ce([0,1,5,36,32]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=A,e.$_o=I;function j(C){if(R.$u===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}function A(C,$,E,b,m,u,l,w,p){const h=Object.create(null);h["common.machineId"]=u,h["common.sqmId"]=l,h.sessionID=(0,L.$Ng)()+Date.now(),h.commitHash=b,h.version=m,h["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,R.$h)(R.$u),h["common.nodePlatform"]=N.$ec,h["common.nodeArch"]=E,h["common.product"]=p||"desktop",w&&(h["common.msftInternal"]=w);let g=0;const f=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),R.$l&&(h["common.snap"]="true");const c=j($);return c&&(h["common.platformDetail"]=c),h}function I(C){const $=N.env.USERDNSDOMAIN;if(!$)return!1;const E=$.toLowerCase();return C.some(b=>E===b)}}),define(ae[22],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0,e.$Wl=(0,R.$ri)("telemetryService"),e.$Xl=(0,R.$ri)("customEndpointTelemetryService"),e.$Yl="telemetry.currentSessionDate",e.$Zl="telemetry.firstSessionDate",e.$1l="telemetry.lastSessionDate",e.$2l="telemetry.machineId",e.$3l="telemetry.sqmId",e.$4l="telemetry",e.$5l="telemetry.telemetryLevel",e.$6l="telemetry.enableCrashReporter",e.$7l="telemetry.enableTelemetry";var N;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ae[228],ce([0,1,37,6,35,23,14,5,8,144,31,150,94,12,24,22]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=void 0,e.$ys=h,e.$zs=f,e.$As=c;const p=new Map;async function h(i,o){const n=`${i}::${o.join(":")}`,s=p.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,y=2e4;function v(S,k,D,T){const F=k.substring(S.length+1);return N.Promises.withAsyncBody(async U=>{let Q;try{Q=await E.Promises.readdir(k,{withFileTypes:!0})}catch{U();return}if(T.count>=y){T.count+=Q.length,T.maxReached=!0,U();return}let G=Q.length;if(G===0){U();return}let Y=Q;T.count+Q.length>y&&(T.maxReached=!0,G=y-T.count,Y=Q.slice(0,G)),T.count+=Q.length;for(const W of Y)if(W.isDirectory()){if(D.includes(W.name)||await v(S,(0,A.$kc)(k,W.name),D,T),--G===0){U();return}}else{const J=W.name.lastIndexOf(".");if(J>=0){const H=W.name.substring(J+1);H&&r.set(H,(r.get(H)??0)+1)}for(const H of t)H.relativePathPattern?.test(F)!==!1&&H.filePattern.test(W.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--G===0){U();return}}})}const P=N.Promises.withAsyncBody(async S=>{const k={count:0,maxReached:!1};await v(i,i,o,k);const D=await c(i);S({configFiles:g(a),fileTypes:g(r),fileCount:k.count,maxFilesReached:k.maxReached,launchConfigFiles:D})});return p.set(n,P),P}function g(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function f(){const i={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/u.$tl.GB).toFixed(2)}GB (${(R.freemem()/u.$tl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$zn.value()*100)}%`},o=R.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}async function c(i){try{const o=new Map,n=(0,A.$kc)(i,".vscode","launch.json"),s=await E.Promises.readFile(n),t=[],r=(0,L.$En)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$Nn)(r)==="object"&&r.configurations)for(const a of r.configurations){const y=a.type;y&&(o.has(y)?o.set(y,o.get(y)+1):o.set(y,1))}return g(o)}catch{return[]}}let d=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const s=R.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(R.totalmem()/u.$tl.GB).toFixed(2)}GB (${(R.freemem()/u.$tl.GB).toFixed(2)}GB free)`),I.$i||n.push(`Load (avg):       ${R.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round($.$zn.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,b.$xs)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(y=>{if((0,m.$_m)(y))a+=`
${y.errorMessage}`,r+=`
${y.errorMessage}`;else if(a+=`

Remote: ${y.hostName}`,y.processes&&(a+=`
${this.m(o,y.processes)}`),y.workspaceMetadata){r+=`
|  Remote: ${y.hostName}`;for(const v of Object.keys(y.workspaceMetadata)){const P=y.workspaceMetadata[v];let S=`${P.fileCount} files`;P.maxFilesReached&&(S=`more than ${S}`),r+=`|    Folder (${v}): ${S}`,r+=this.h(P)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=f(),y={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return I.$i||(y.load=`${R.loadavg().map(v=>Math.round(v)).join(", ")}`),I.$k&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(o,n){const s=[];return(0,b.$xs)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,m.$_m)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const y=r.workspaceMetadata[a];let v=`${y.fileCount} files`;y.maxFilesReached&&(v=`more than ${v}`),s.push(`Folder (${a}): ${v}`),s.push(this.h(y))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(P,S)=>{const k=` ${P}(${S})`;t+k.length>60?(n.push(a),a="|                 ",t=a.length):t+=k.length,a+=k};let a="|      File types:";const y=10,v=o.fileTypes.length>y?y:o.fileTypes.length;for(let P=0;P<v;P++){const S=o.fileTypes[P];r(S.name,S.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(P=>{r(P.name,P.count)}),n.push(a)),o.launchConfigFiles.length>0){let P="|      Launch Configs:";o.launchConfigFiles.forEach(S=>{const k=S.count>1?` ${S.name}(${S.count})`:` ${S.name}`;P+=k}),n.push(P)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=C.URI.revive(r);if(a.scheme===j.Schemas.file){const y=a.fsPath;s.push(h(y,["node_modules",".git"]).then(v=>{let P=`${v.fileCount} files`;v.maxFilesReached&&(P=`more than ${P}`),n.push(`|    Folder (${(0,A.$oc)(y)}): ${P}`),n.push(this.h(v))}).catch(v=>{n.push(`|      Error: Unable to collect workspace stats for folder ${y} (${v.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let y;a?y=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?y=n.get(t.pid):y=`${"  ".repeat(r)} ${t.name}`;const v=process.platform==="win32"?t.mem:R.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(v/u.$tl.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(t.children)&&t.children.forEach(P=>this.n(o,n,s,P,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=C.URI.revive(s);if(t.scheme!==j.Schemas.file)continue;const r=t.fsPath;try{(await h(r,["node_modules",".git"])).fileTypes.forEach(y=>n.add(y.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=C.URI.revive(n);if(s.scheme!==j.Schemas.file)continue;const t=s.fsPath;try{const r=await h(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Bs=d,e.$Bs=d=Ee([X(0,w.$Wl),X(1,l.$ek)],d)}),define(ae[107],ce([0,1,7,4,9,22]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0,e.$7p=(0,N.$ri)("IExtensionSignatureVerificationService");let A=class{constructor(C,$){this.b=C,this.c=$}d(){return this.a||(this.a=new Promise((C,$)=>ne(["@vscode/vsce-sign"],async E=>C(E),$))),this.a}async verify(C,$,E){let b;try{b=await this.d()}catch(w){return this.b.error("Could not load vsce-sign module",(0,R.$0)(w)),!1}const m=new Date().getTime();let u,l;try{return u=await b.verify(C,$,E),u}catch(w){throw l=w,w}finally{const w=new Date().getTime()-m;this.c.publicLog2("extensionsignature:verification",{duration:w,verified:u,error:l?l.code??"unknown":void 0})}}};e.$8p=A,e.$8p=A=Ee([X(0,L.$Xj),X(1,j.$Wl)],A)}),define(ae[108],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;class R{constructor(j){this.b=j}listen(j,A){throw new Error(`Event not found: ${A}`)}call(j,A,{eventName:I,data:C}){return this.b.forEach($=>$.log(I,C)),Promise.resolve(null)}}e.$mcc=R;class N{constructor(j){this.b=j}log(j,A){return this.b.call("log",{eventName:j,data:A}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$ncc=N}),define(ae[49],ce([0,1,30,13,102,106,22]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0,e.$hp=E,e.$ip=b,e.$jp=m,e.$kp=u,e.$lp=w,e.$mp=h,e.$np=g,e.$op=d;class I{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$ap=I;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$bp=C,e.$cp=new C;class ${async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$dp=$,e.$ep="telemetry",e.$fp="extensionTelemetryLog",e.$gp={log:()=>null,flush:()=>Promise.resolve(null)};function E(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}function b(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function m(i){const o=i.getValue(A.$5l),n=i.getValue(A.$6l);if(i.getValue(A.$7l)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function u(i){const o={},n={},s={};p(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function w(i){if(!i)return"none";const o=(0,L.$Dm)(i);return l.has(o)?o:"other"}function p(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,R.$3n)(r):r instanceof Date?o[a]=r.toISOString():(0,N.$7f)(r)?n<2?p(r,o,n+1,a+"."):o[a]=(0,R.$3n)(r):o[a]=r}}function h(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,j.$_o)(n)||s}function g(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function f(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const y of o)for(;;){const v=y.exec(i);if(!v)break;s.push([v.index,y.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const y=r.exec(i);if(!y)break;const v=s.some(([P,S])=>y.index<S&&P<r.lastIndex);!t.test(y[0])&&!v&&(n+=i.substring(a,y.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function d(i,o){return(0,R.$Zn)(i,n=>{if(n instanceof I||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=f(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}}),define(ae[33],ce([0,1,27,29,48,5,8,7,36,49]),function(ne,e,R,N,L,j,A,I,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$qp=void 0,e.$pp=E,e.$rp=l,e.$sp=w,e.$tp=p,e.$up=h,e.$vp=g,e.$wp=f,e.$xp=c,e.$zp=d,e.$Ap=o;function E(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,R.$pf)(n.id,s.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,t,r)}static parse(s){const t=b.exec(s);return t&&t[1]&&t[2]?new m({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?E(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$qp=m;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(n){const s=u.exec(n);return s&&s[1]?[p(s[1]),s[2]]:[p(n),void 0]}function w(n,s){return`${n}.${s}`}function p(n){return n.toLowerCase()}function h(n,s){return p(w(n??L.$Im,s))}function g(n,s){const t=[],r=a=>{for(const y of t)if(y.some(v=>E(s(v),s(a))))return y;return null};for(const a of n){const y=r(a);y?y.push(a):t.push([a])}return t}function f(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function c(n){return{id:new $.$ap(n.identifier.id),name:new $.$ap(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$yp=new L.$Mm("pprice.better-merge");function d(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(y=>!E(y.identifier,{id:a}))){const y=n.filter(v=>E(v.identifier,{id:a}));y.length===1&&(t.push(y[0]),r.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}async function i(n,s){if(!j.$k)return!1;let t;try{t=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,I.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,N.$Wo)(t?"alpine":j.$u,C.$fc);return s.debug("ComputeTargetPlatform:",r),r}}),define(ae[229],ce([0,1,17,2,20,8,12,24,6,3,14,5,36,33]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=e.$kac=void 0;let l=class extends N.$Uc{constructor(f,c){super(),this.b=f,this.c=c,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,d])=>this.a.set(d.configPath,d))}getConfigBasedTips(f){return this.f(f)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(f){const c=[];for(const[d,i]of this.a)if(!(i.configScheme&&i.configScheme!==f.scheme))try{const o=(await this.b.readFile((0,L.$5g)(f,d))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.$kac=l,e.$kac=l=Ee([X(0,A.$Xk),X(1,I.$ek)],l);const w="extensionTips/promptedExecutableTips",p="extensionTips/lastPromptedMediumImpExeTime";class h extends l{constructor(f,c,d,i,o,n,s,t){super(s,t),this.r=f,this.s=c,this.t=d,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const y=[],v=[],P=[];Object.entries(a.recommendations).forEach(([S,k])=>{k.important?a.important?y.push({extensionId:S,extensionName:k.name,isExtensionPack:!!k.isExtensionPack}):v.push({extensionId:S,extensionName:k.name,isExtensionPack:!!k.isExtensionPack}):P.push({extensionId:S,extensionName:k.name,isExtensionPack:!!k.isExtensionPack})}),y.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:y}),v.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),P.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:P})}),(0,C.$th)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const f=await this.O(this.g),c=await this.O(this.h);return[...f,...c]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const f=await this.O(this.g),c=await this.O(this.h),d=await this.u.getInstalled();this.m=this.D(f,d),this.n=this.D(c,d)}D(f,c){const d=new Map;f.forEach(t=>d.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...d.keys()],c);for(const t of i){const r=d.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=d.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=d.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[f,c]=[...this.m.entries()][0];this.H(c).then(d=>{switch(d){case"reacted":this.M(c[0].exeName,c);break;case"ignored":this.m.delete(f);break;case"incompatibleWindow":{const i=$.Event.once($.Event.latch($.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new N.$Vc);i.value=(0,C.$th)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const f=this.I(),c=Date.now()-f,d=7*24*60*60*1e3;if(c<d){const n=this.B(new N.$Vc);n.value=(0,C.$th)(()=>{n.dispose(),this.G()},d-c);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new N.$Vc);s.value=(0,C.$th)(()=>{s.dispose(),this.G()},d);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=$.Event.once($.Event.latch($.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new N.$Vc);s.value=(0,C.$th)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(f){const c=await this.u.getInstalled(1),d=f.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,u.$pp)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:d,source:3,name:f[0].exeFriendlyName,searchValue:`@exe:"${f[0].exeName}"`})}I(){let f=this.w.getNumber(p,-1);return f||(f=Date.now(),this.J(f)),f}J(f){this.w.store(p,f,-1,1)}L(){return JSON.parse(this.w.get(w,-1,"{}"))}M(f,c){const d=this.L();d[f]=c.map(({extensionId:i})=>i.toLowerCase()),this.w.store(w,JSON.stringify(d),-1,0)}N(f,c){const d=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return f.forEach(n=>{o.has(n.toLowerCase())?d.push(n):i.push(n)}),{installed:d,uninstalled:i}}async O(f){const c=[],d=new Map;for(const i of f.keys()){const o=f.get(i);if(!o||!(0,R.$Lb)(o.recommendations))continue;const n=[];b.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(n.push((0,E.$kc)("/usr/local/bin",i)),n.push((0,E.$kc)("/usr/bin",i)),n.push((0,E.$kc)(this.r.fsPath,i)));for(const s of n){let t=d.get(s);if(t===void 0&&(t=await this.b.exists(j.URI.file(s)),d.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:y,whenNotInstalled:v}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:y,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:v})}}return c}}e.$lac=h}),define(ae[230],ce([0,1,26,33]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$3b=L;async function L(j,A,I,C,$){try{const E=await j.getExtensionsControlManifest();if(!E.deprecated)return;const b=await j.getInstalled(1);for(const[m,u]of Object.entries(E.deprecated)){if(!u?.extension)continue;const{id:l,autoMigrate:w,preRelease:p}=u.extension;if(!w)continue;const h=b.find(f=>(0,N.$pp)(f.identifier,{id:m}));if(!h)continue;const g=(await A.getExtensions([{id:l,preRelease:p}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!g){$.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${l}' extension is not found`);continue}try{$.info(`Migrating '${h.identifier.id}' extension to '${l}' extension...`);const f=!C.getDisabledExtensions().some(d=>(0,N.$pp)(d,h.identifier));await j.uninstall(h),$.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let c=b.find(d=>(0,N.$pp)(d.identifier,{id:l}));(!c||!c.isPreReleaseVersion&&f)&&(c=await j.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),$.info(`Installed the pre-release extension '${c.identifier.id}'`),f||(await C.disableExtension(c.identifier),$.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),w.storage&&(I.addToMigrationList((0,N.$sp)(h.manifest.publisher,h.manifest.name),(0,N.$sp)(c.manifest.publisher,c.manifest.name)),$.info("Added pre-release extension to the storage migration list"))),$.info(`Migrated '${h.identifier.id}' extension to '${l}' extension.`)}catch(f){$.error(f)}}}catch(E){$.error(E)}}}),define(ae[231],ce([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,107,12,9]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;let c=class extends L.$Uc{static{f=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,A.$5g)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new l.$2o(r.message,l.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===g.LogLevel.Trace)}catch(a){const y=a;if(t=y.code,y.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${y.output}`),t===l.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===l.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(v){this.r.error(v)}throw new l.$2o(b.$aq,l.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,C.$$f)(o)?o:!0}async u(i){await this.g;const o=(0,A.$5g)(this.extensionsDownloadDir,`${this.z(i)}${f.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new l.$2o(n.message,l.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await n(o);return}const s=(0,A.$5g)(this.extensionsDownloadDir,`.${(0,$.$Ng)()}`);await this.h.exists(s)||await n(s);try{await E.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(f.c))s.push(a.resource);else{const y=w.$qp.parse(a.name);y&&n.push([y,a])}const t=(0,w.$vp)(n,([a])=>a),r=[];for(const a of t)a.sort((y,v)=>I.rcompare(y[0].version,v[0].version)),o.push(...a.slice(1).map(y=>y[1].resource)),r.push(a[0][1]);r.sort((a,y)=>a.mtime-y.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await R.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?w.$qp.create(i).toString().toLowerCase():(0,$.$Ng)()}};e.$tq=c,e.$tq=c=f=Ee([X(0,u.$zi),X(1,h.$Xk),X(2,l.$1o),X(3,m.$Xi),X(4,p.$7p),X(5,g.$Xj)],c)}),define(ae[232],ce([0,1,3,2,34,33,48]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=void 0;class I extends N.$Uc{constructor($,E,b,m,u,l,w){super(),this.f=$,this.g=E,this.h=b,this.j=m,this.m=u,this.n=l,this.r=w,this.a=this.B(new R.$be),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$4c),this.s().then(null,p=>w.error(p))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles($=>this.u($.added))),this.B(this.j.onAddExtensions($=>this.w($))),this.B(this.j.onDidAddExtensions($=>this.y($))),this.B(this.j.onRemoveExtensions($=>this.z($))),this.B(this.j.onDidRemoveExtensions($=>this.C($))),this.B(this.n.onDidFilesChange($=>this.D($)))}async u($){try{$.length&&await Promise.all($.map(E=>(this.c.set(E.id,(0,N.$Rc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w($){for(const E of $.extensions)this.I(this.L(E.identifier,E.version),$.profileLocation)}async y($){for(const E of $.extensions){const b=this.L(E.identifier,E.version);$.error?this.J(b,$.profileLocation):this.I(b,$.profileLocation)}}async z($){for(const E of $.extensions)this.J(this.L(E.identifier,E.version),$.profileLocation)}async C($){const E=[],b=[];for(const m of $.extensions){const u=this.L(m.identifier,m.version);$.error?this.I(u,$.profileLocation):(this.J(u,$.profileLocation),this.b.has(u)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),b.push(this.f.scanInstalledExtensionAtLocation(m.location).then(l=>{l?E.push(l):this.r.info("Extension not found at the location",m.location.toString())},l=>this.r.error(l)))))}try{await Promise.all(b),E.length&&await this.H(E)}catch(m){this.r.error(m)}}D($){for(const E of this.h.profiles)$.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F($){const E=[],b=[],m=await this.j.scanProfileExtensions($),u=new Set,l=new Set;for(const[w,p]of this.b)p.has($)&&l.add(w);for(const w of m){const p=this.L(w.identifier,w.version);u.add(p),l.has(p)||(E.push(w.identifier),this.I(p,$))}for(const w of l)if(!u.has(w)){const p=this.M(w);p&&(b.push(p.identifier),this.J(w,$))}(E.length||b.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:$}:void 0,removed:b.length?{extensions:b,profileLocation:$}:void 0})}async G($){const E=await this.j.scanProfileExtensions($);for(const b of E)this.I(this.L(b.identifier,b.version),$)}async H($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(b=>!this.b.has(this.L(b.identifier,b.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}I($,E){let b=this.b.get($);b||this.b.set($,b=new L.$Cc(m=>this.m.extUri.getComparisonKey(m))),b.add(E)}J($,E){const b=this.b.get($);b&&b.delete(E),b?.size||this.b.delete($)}L($,E){return`${A.$Mm.toKey($.id)}@${E}`}M($){const[E,b]=(0,j.$rp)($);return b?{identifier:{id:E},version:b}:void 0}}e.$xq=I}),define(ae[233],ce([0,1,45,49]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=L;async function L(j,A,I,C,$,E,b){const m={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${A.nameShort})`};if((0,N.$hp)(A,I)&&(0,N.$jp)(C)===3){const u=await(0,R.$2p)(I,$,E);m["X-Market-User-Id"]=u,m["VSCode-SessionId"]=b.machineId||u}return m}}),define(ae[234],ce([0,1,73,17,6,2,23,14,31,16,29,33,9,75,8]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;let w=class extends u.$Nr{constructor(f,c,d,i){super(d),this.h=f,this.j=i,this.g=this.B(new p(c,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(f,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const o=i.translations[f];return o?l.URI.file(o):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),c=Object.keys(f).map(d=>{const i=f[d];return{...this.f(d,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((d,i)=>d.label.localeCompare(i.label)),c}async m(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",f.identifier.id),await this.update())}async n(f){const c=await this.g.getLanguagePacks();Object.keys(c).some(d=>c[d]&&c[d].extensions.some(i=>(0,b.$pp)(i.extensionIdentifier,f.identifier)))&&(this.j.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),d=await this.g.update(c);return!(0,N.$ub)(Object.keys(f),Object.keys(d))}};e.$Or=w,e.$Or=w=Ee([X(0,E.$4o),X(1,$.$zi),X(2,E.$1o),X(3,m.$Xj)],w);let p=class extends j.$Uc{constructor(f,c){super(),this.j=c,this.c={},this.f=(0,I.$kc)(f.userDataPath,"languagepacks.json"),this.g=new L.$yh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.s(c=>{Object.keys(c).forEach(d=>delete c[d]),this.m(c,...f)}).then(()=>this.c)}m(f,...c){for(const d of c)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&this.n(f,d);Object.keys(f).forEach(d=>this.r(f[d]))}n(f,c){const d=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===A.Schemas.file&&h(o)){let n=f[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},f[o.languageId]=n);const s=n.extensions.filter(t=>(0,b.$pp)(t.extensionIdentifier,d))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:d,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,I.$kc)(c.location.fsPath,t.path)}}r(f){if(f){const c=(0,R.createHash)("md5");for(const d of f.extensions)c.update(d.extensionIdentifier.uuid||d.extensionIdentifier.id).update(d.version);f.hash=c.digest("hex")}}s(f=()=>null){return this.g.queue(()=>{let c=null;return C.Promises.readFile(this.f,"utf8").then(void 0,d=>d.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(d)).then(d=>{try{return JSON.parse(d)}catch{return{}}}).then(d=>(c=f(d),d)).then(d=>{for(const o of Object.keys(d))d[o]||delete d[o];this.c=d,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),C.Promises.writeFile(this.f,i)}).then(()=>c,d=>this.j.error(d))})}};p=Ee([X(0,$.$zi),X(1,m.$Xj)],p);function h(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const f of g.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(ae[235],ce([0,1,143,7,30,49]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function C(E,b,m){const u=await(0,R.$TD)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,R.$TD)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new u.AppInsightsCore,p=new l.PostChannel,h={instrumentationKey:E,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(m){h.extensionConfig={};const g={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};h.extensionConfig[p.identifier]=g}return w.initialize(h,[]),w.addTelemetryInitializer(g=>{g.ext=g.ext??{},g.ext.web=g.ext.web??{},g.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',b&&(g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),w}class ${constructor(b,m,u,l,w){this.e=b,this.f=m,this.g=u,this.h=w,this.c=A,this.d=I,this.g||(this.g={}),typeof l=="function"?this.a=l():this.a=l,this.b=null}i(b){if(this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=C(this.a,this.e,this.h)),this.b.then(m=>{b(m)},m=>{(0,N.$1)(m),console.error(m)})}}log(b,m){if(!this.a)return;m=(0,L.$1n)(m,this.g),m=(0,j.$kp)(m);const u=this.f+"/"+b;try{this.i(l=>{l.pluginVersionString=m?.properties.version??"Unknown",l.track({name:u,baseData:{name:u,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.$qQ=$}),define(ae[109],ce([0,1,2,172,16,9,24,49]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K_b=void 0;let C=class extends R.$Uc{constructor(E,b,m,u,l=""){super(),this.b=l;const w=b.getLogger(I.$ep);if(w)this.a=this.B(w);else{const h=(0,I.$ip)(u,m)?" (Not Sent)":"",g=()=>(0,I.$hp)(u,m)&&E.getLevel()===j.LogLevel.Trace;this.a=this.B(b.createLogger(I.$ep,{name:(0,N.localize)(0,null,h),hidden:!g()})),this.B(E.onDidChangeLogLevel(()=>b.setVisibility(I.$ep,g()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(E,b){this.a.trace(`${this.b}telemetry/${E}`,(0,I.$kp)(b))}};e.$K_b=C,e.$K_b=C=Ee([X(0,j.$Xj),X(1,j.$Yj),X(2,L.$yi),X(3,A.$ek)],C)}),define(ae[110],ce([0,1,2,30,5,27,173,21,47,100,24,42,22,49]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0;let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,g,f){this.k=g,this.l=f,this.d={},this.i=new R.$Tc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.j.push(new RegExp((0,j.$9e)(c),"gi")),c.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$9e)(c.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(c=>{(c.affectsConfiguration(m.$5l)||c.affectsConfiguration(m.$7l)||c.affectsConfiguration(m.$6l))&&this.m()}))}setExperimentProperty(h,g){this.d[h]=g}m(){let h=(0,u.$jp)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const f=g.usage?3:g.error?2:0;h=Math.min(h,f)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,g,f){this.g<g||(f=(0,N.$1n)(f,this.d),f=(0,u.$op)(f,this.j),f=(0,N.$1n)(f,this.c),this.b.forEach(c=>c.log(h,f)))}publicLog(h,g){this.n(h,3,g)}publicLog2(h,g){this.publicLog(h,g)}publicLogError(h,g){this.h&&this.n(h,2,g)}publicLogError2(h,g){this.publicLogError(h,g)}};e.$Ur=l,e.$Ur=l=Ee([X(1,I.$Xi),X(2,E.$ek)],l);function w(){const p=(0,A.localize)(0,null,$.default.nameLong),h=$.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",$.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=L.$o?"":(0,A.localize)(3,null),f=(0,A.localize)(4,null),c=(0,A.localize)(5,null),d=(0,A.localize)(6,null),i=(0,A.localize)(7,null),o=`
|       | ${f} | ${c} | ${d} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,A.localize)(8,null);return`
${p} ${h} ${g}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}b.$0n.as(C.$co.Configuration).registerConfiguration({id:m.$4l,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[m.$5l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$0n.as(C.$co.Configuration).registerConfiguration({id:m.$4l,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[m.$7l]:{type:"boolean",markdownDescription:$.default.privacyStatementUrl?(0,A.localize)(16,null,$.default.nameLong,$.default.privacyStatementUrl):(0,A.localize)(15,null,$.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${m.$5l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[236],ce([0,1,15,26,278,235]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rQ=void 0;async function A(E,b){const m=await b.request(E,N.CancellationToken.None),u=(await(0,R.$Oe)(m.stream)).toString(),l=m.res.statusCode??200;return{headers:m.res.headers,statusCode:l,responseData:u}}async function I(E){const b={method:E.type,headers:E.headers};return new Promise((u,l)=>{const w=L.request(E.url??"",b,p=>{p.on("data",function(h){u({headers:p.headers,statusCode:p.statusCode??200,responseData:h.toString()})}),p.on("error",function(h){l(h)})});w.write(E.data,p=>{p&&l(p)}),w.end()})}async function C(E,b,m){const u=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),l={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:u};try{const w=E?await A(l,E):await I(l);m(w.statusCode,w.headers,w.responseData)}catch{m(0,{})}}class $ extends j.$qQ{constructor(b,m,u,l,w){const p={sendPOST:(h,g)=>{C(b,h,g)}};super(m,u,l,w,p)}}e.$rQ=$}),define(ae[237],ce([0,1,23,92,21,16,9,24,22,108,109,110]),function(ne,e,R,N,L,j,A,I,C,$,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;let m=class{constructor(l,w,p,h,g,f){this.b=l,this.c=w,this.d=p,this.e=h,this.f=g,this.g=f,this.a=new Map}h(l){if(!this.a.has(l.id)){const w=Object.create(null);w["common.vscodemachineid"]=this.c.machineId,w["common.vscodesessionid"]=this.c.sessionId;const p=[l.id,JSON.stringify(w),l.aiKey],g=new N.$Vq(R.$Lg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:p,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),f=[new $.$ncc(g),new E.$K_b(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new b.$Ur({appenders:f,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,w,p){this.h(l).publicLog(w,p)}publicLogError(l,w,p){this.h(l).publicLogError(w,p)}};e.$Hdc=m,e.$Hdc=m=Ee([X(0,L.$Xi),X(1,C.$Wl),X(2,A.$Xj),X(3,A.$Yj),X(4,j.$yi),X(5,I.$ek)],m)}),define(ae[78],ce([0,1,3,8,21,4,9]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$cw=e.$aw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$9v=e.$8v=void 0,e.$0v=$,e.$$v=b,e.$_v=m,e.$bw=u,e.$dw=l,e.$ew=w,e.$8v=(0,j.$ri)("tunnelService"),e.$9v=(0,j.$ri)("sharedTunnelsService");var I;(function(g){g.Http="http",g.Https="https"})(I||(e.TunnelProtocol=I={}));var C;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(C||(e.TunnelPrivacyId=C={}));function $(g){return!!g.forwardPort}var E;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function b(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(f)return{address:f[1],port:+f[2]}}function m(g){if(g.scheme!=="http"&&g.scheme!=="https"||!g.query)return;const f=g.query.split("&");for(const c of f){const d=c.split("=")[1];if(/^https?:/.exec(d)){const i=b(N.URI.parse(d));if(i)return i}}}e.$aw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function u(g){return e.$aw.indexOf(g)>=0}e.$cw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(g){return e.$cw.indexOf(g)>=0}function w(g,f,c,d){if(c===1)return!1;if(c===2&&l(f)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(i?.length===4&&parseInt(i[1])>=18)return!1}return g<1024}class p{constructor(f,c,d){this.remoteAddress=f,this.localAddress=c,this.b=d,this.a=new R.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$fw=p;let h=class{constructor(f,c){this.k=f,this.l=c,this.a=new R.$be,this.onTunnelOpened=this.a.event,this.b=new R.$be,this.onTunnelClosed=this.b.event,this.c=new R.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const f=this.l.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(f){return this.f=f,f?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this.g=f.elevation,this.i=f.privacyOptions,this.h=f.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const f=[],c=Array.from(this.e.values());for(const d of c){const i=Array.from(d.values());for(const o of i){const n=await o.value;n&&typeof n!="string"&&f.push(n)}}return f}async dispose(){for(const f of this.e.values()){for(const{value:c}of f.values())await c.then(d=>typeof d!="string"?d?.dispose():void 0);f.clear()}this.e.clear()}setEnvironmentTunnel(f,c,d,i,o){this.q(f,c,Promise.resolve({tunnelRemoteHost:f,tunnelRemotePort:c,localAddress:d,privacy:i,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(f,c){(l(f)||u(f))&&(f=e.$aw[0]);const d=this.s(f,c);if(d)return++d.refcount,d.value}openTunnel(f,c,d,i,o,n=!1,s,t){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${d} on local port ${o}.`);const r=this.f??f;if(!r)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(d)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(r,c,d,i,o,n,s,t);return a?a.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,d),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,d);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==d)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&y.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const c=this.e.get(f.tunnelRemoteHost);if(c){const d=c.get(f.tunnelRemotePort);d&&(d.refcount--,await this.p(f.tunnelRemoteHost,f.tunnelRemotePort,d))}}}}async p(f,c,d){if(d.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${c}.`);const i=d.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(f)&&this.e.get(f).delete(c),i}}async closeTunnel(f,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${c} `);const d=this.e.get(f);if(d&&d.has(c)){const i=d.get(c);i.refcount=0,await this.p(f,c,i)}}q(f,c,d){this.e.has(f)||this.e.set(f,new Map),this.e.get(f).set(c,{refcount:1,value:d})}async r(f,c){const d=this.e.get(f);if(d){const i=d.get(c),o=i?await i.value:void 0;(!o||typeof o=="string")&&d.delete(c),d.size===0&&this.e.delete(f)}}s(f,c){const d=[f];u(f)?(d.push(...e.$aw),d.push(...e.$cw)):l(f)&&d.push(...e.$cw);const i=d.map(o=>this.e.get(o));for(const o of i){const n=o?.get(c);if(n)return n}}canTunnel(f){return!!b(f)}u(f,c,d,i,o,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${d} on local port ${i}.`);const t=d;this.j.add(t);const r=i===void 0?d:i,a={elevationRequired:o?this.isPortPrivileged(r):!1},y={remoteAddress:{host:c,port:d},localAddressPort:i,privacy:n,public:n?n!==C.Private:void 0,protocol:s},v=f.forwardPort(y,a);return v?(this.q(c,d,v),v.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(t)})):this.j.delete(t),v}};e.$gw=h,e.$gw=h=Ee([X(0,A.$Xj),X(1,L.$Xi)],h)}),define(ae[238],ce([0,1,9,78,2,7,6]),function(ne,e,R,N,L,j,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class C extends L.$Uc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new A.$Oh),this.b.p)}setAddress(b){this.a=b,this.b&&(this.b.complete(b),this.b=null)}setTunnel(b){this.B(b)}}let $=class extends L.$Uc{static{I=this}static{this.a=0}constructor(b,m){super(),this.f=b,this.g=m,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(b=>b.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(b,m,u,l,w,p,h){const g=new C,f=await Promise.resolve(this.f.openTunnel(b,g,u,l,w,p,h));if(!f||typeof f=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${u}:${l} (remote).`),g.dispose(),new Error("Could not create tunnel");if(this.c.has(m))throw this.c.delete(m),g.dispose(),await f.dispose(),(0,j.$6)();return g.setTunnel(f),this.b.set(m,g),this.g.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${f.localAddress} (local) to ${u}:${l} (remote).`),{tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress}}async setAddress(b,m){const u=this.b.get(b);u&&u.setAddress(m)}async destroyTunnel(b){const m=this.b.get(b);if(m){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${b}.`),this.b.delete(b),await m.dispose();return}this.c.add(b)}};e.$Rdc=$,e.$Rdc=$=I=Ee([X(0,N.$9v),X(1,R.$Xj)],$)}),define(ae[28],ce([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=void 0,e.$vl=(0,R.$ri)("IUriIdentityService")}),define(ae[239],ce([0,1,28,191,12,20,128,3,2]),function(ne,e,R,N,L,j,A,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0;class ${static{this._clock=0}constructor(m){this.uri=m,this.time=$._clock++}touch(){return this.time=$._clock++,this}}let E=class{constructor(m){this.g=m,this.c=new C.$Tc,this.f=2**16;const u=new Map,l=w=>{let p=u.get(w.scheme);return p===void 0&&(p=m.hasProvider(w)&&!this.g.hasCapability(w,1024),u.set(w.scheme,p)),p};this.c.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(w=>{u.delete(w.scheme)})),this.extUri=new j.$Tg(l),this.d=new A.$ts((w,p)=>this.extUri.compare(w,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,j.$6g)(m));const u=this.d.get(m);return u?u.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new $(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((l,w)=>l[1].time<w[1].time?1:l[1].time>w[1].time?-1:0);$._clock=0,this.d.clear();const u=this.f*.5;for(let l=0;l<u;l++)this.d.set(m[l][0],m[l][1].touch())}};e.$us=E,e.$us=E=Ee([X(0,L.$Xk)],E),(0,N.$rs)(R.$vl,E,1)}),define(ae[240],ce([0,1,3,2,12,51,34]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;class I extends N.$Uc{constructor($,E,b,m,u,l){super(),this.f=$,this.g=E,this.h=b,this.j=m,this.m=u,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new R.$be),this.onDidChangeFile=this.a.event,this.b=j.$xi.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Cc(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const $ of this.j.profiles)this.c.add($.settingsResource),this.c.add($.keybindingsResource),this.c.add($.tasksResource),this.c.add($.extensionsResource)}open($,E){return this.g.open(this.t($),E)}close($){return this.g.close($)}read($,E,b,m,u){return this.g.read($,E,b,m,u)}write($,E,b,m,u){return this.g.write($,E,b,m,u)}watch($,E){this.b.set($,$);const b=this.g.watch(this.t($),E);return(0,N.$Sc)(()=>{this.b.delete($),b.dispose()})}stat($){return this.g.stat(this.t($))}mkdir($){return this.g.mkdir(this.t($))}rename($,E,b){return this.g.rename(this.t($),this.t(E),b)}readFile($,E){return this.g.readFile(this.t($),E)}readFileStream($,E,b){return this.g.readFileStream(this.t($),E,b)}readdir($){return this.g.readdir(this.t($))}enforceAtomicReadFile($){return this.c.has($)}writeFile($,E,b){return this.g.writeFile(this.t($),E,b)}enforceAtomicWriteFile($){return this.c.has($)?{postfix:".vsctmp"}:!1}delete($,E){return this.g.delete(this.t($),E)}copy($,E,b){if((0,L.$2k)(this.g))return this.g.copy(this.t($),this.t(E),b);throw new Error("copy not supported")}cloneFile($,E){if((0,L.$3k)(this.g))return this.g.cloneFile(this.t($),this.t(E));throw new Error("clone not supported")}s($){const E=[];for(const b of $){if(b.resource.scheme!==this.f)continue;const m=this.u(b.resource);this.b.findSubstr(m)&&E.push({resource:m,type:b.type,cId:b.cId})}E.length&&(this.n.debug("User data changed"),this.a.fire(E))}t($){return $.with({scheme:this.f})}u($){return $.with({scheme:this.h})}}e.$adc=I}),define(ae[79],ce([0,1,62]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=N,e.$OJb=L,e.$PJb=j;function N(A,I,C,$){const E=(0,R.$Tn)(A,I,C,$)[0];return E&&(A=A.substring(0,E.offset)+E.content+A.substring(E.offset+E.length)),A}function L(A,I,C){let $=C;for(;$>=0;){if(A.charAt($)===I.charAt(I.length-1)&&I.length===1)return $+1;if($--,I.length===2&&$>=0&&A.charAt($)===I.charAt(0))return $+2}return 0}function j(A,I,C){let $=C;for(;$>=0;)if(A.charAt($)===I.charAt(I.length-1)&&I.length===1||($++,I.length===2&&$>=0&&A.charAt($)===I.charAt(1)))return $;return A.length-1}}),define(ae[241],ce([0,1,30,55,13]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o$b=j;function j(u,l,w,p,h,g){const f=[],c=[],d=[];if(!l){const U=u.filter(({identifier:Q})=>h.every(G=>G.toLowerCase()!==Q.id.toLowerCase()));return{local:{added:f,removed:c,updated:d},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}u=u.map(b),l=l.map(b),w=w?w.map(b):null;const i=new Map,o=U=>{U.uuid&&i.set(U.id.toLowerCase(),U.uuid)};u.forEach(({identifier:U})=>o(U)),l.forEach(({identifier:U})=>o(U)),w?.forEach(({identifier:U})=>o(U)),p?.forEach(({identifier:U})=>o(U)),g?.forEach(U=>o(U));const n=U=>{const Q=U.identifier.uuid||i.get(U.identifier.id.toLowerCase());return Q?`uuid:${Q}`:`id:${U.identifier.id.toLowerCase()}`},s=(U,Q)=>(U.set(n(Q),Q),U),t=u.reduce(s,new Map),r=l.reduce(s,new Map),a=l.reduce((U,Q)=>s(U,(0,R.$Xn)(Q)),new Map),y=w?w.reduce(s,new Map):null,v=p.reduce(s,new Map),P=h.reduce((U,Q)=>{const G=i.get(Q.toLowerCase());return U.add(G?`uuid:${G}`:`id:${Q.toLowerCase()}`)},new Set),S=g?g.reduce((U,{id:Q,uuid:G})=>(G=G??i.get(Q.toLowerCase()),U.add(G?`uuid:${G}`:`id:${Q.toLowerCase()}`)),new Set):null,k=A(t,r,P,!1);if(k.added.size>0||k.removed.size>0||k.updated.size>0){const U=A(y,t,P,!1),Q=A(y,r,P,!0),G=(Y,W,J,H)=>{let B,ie,re;return W.installed?(B=H.pinned,re=H.preRelease,B&&(ie=H.version)):(B=J.pinned,re=J.preRelease,B&&(ie=J.version)),B===void 0&&(B=W.pinned,B&&(ie=W.version)),re===void 0&&(re=W.preRelease),{...H,installed:W.installed||J.installed,pinned:B,preRelease:re,version:ie??(J.version&&(!W.installed||N.gt(J.version,W.version))?J.version:W.version),state:C(W,J,y?.get(Y))}};for(const Y of Q.removed.values()){const W=t.get(Y);if(!W)continue;const J=(0,L.$dg)(y?.get(Y)),H=S&&!S.has(Y)&&J.installed;W.installed&&H?c.push(W.identifier):a.set(Y,W)}for(const Y of Q.added.values()){const W=(0,L.$dg)(r.get(Y)),J=t.get(Y);if(J){if(k.updated.has(Y)){const H=G(Y,J,W,W);I(J,W,!1,!1)||d.push(m(H,Y)),a.set(Y,H)}}else W.installed&&f.push(m(W,Y))}for(const Y of Q.updated.values()){const W=(0,L.$dg)(r.get(Y)),J=(0,L.$dg)(y?.get(Y)),H=t.get(Y);if(H)if(S&&!S.has(Y)&&J.installed&&H.installed&&!W.installed)c.push(H.identifier);else{const ie=G(Y,H,W,W);d.push(m(ie,Y)),a.set(Y,ie)}else W.installed&&f.push(m(W,Y))}for(const Y of U.added.values())Q.added.has(Y)||a.set(Y,(0,L.$dg)(t.get(Y)));for(const Y of U.updated.values()){if(Q.removed.has(Y)||Q.updated.has(Y))continue;const W=(0,L.$dg)(t.get(Y)),J=(0,L.$dg)(r.get(Y));a.set(Y,G(Y,W,J,W))}for(const Y of U.removed.values())Q.updated.has(Y)||Q.removed.has(Y)||v.has(Y)||(0,L.$dg)(r.get(Y)).installed&&S&&(S.has(Y)||!(0,L.$dg)(y?.get(Y)).installed||a.delete(Y))}const D=[],T=A(r,a,new Set,!0),F=T.added.size>0||T.updated.size>0||T.removed.size>0;return F&&a.forEach((U,Q)=>D.push(m(U,Q))),{local:{added:f,removed:c,updated:d},remote:F?{added:[...T.added].map(U=>a.get(U)),updated:[...T.updated].map(U=>a.get(U)),removed:[...T.removed].map(U=>r.get(U)),all:D}:null}}function A(u,l,w,p){const h=u?[...u.keys()].filter(i=>!w.has(i)):[],g=[...l.keys()].filter(i=>!w.has(i)),f=g.filter(i=>!h.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=h.filter(i=>!g.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),d=new Set;for(const i of h){if(c.has(i))continue;const o=u.get(i),n=l.get(i);(!n||!I(o,n,p,!0))&&d.add(i)}return{added:f,removed:c,updated:d}}function I(u,l,w,p){return!(u.disabled!==l.disabled||!!u.isApplicationScoped!=!!l.isApplicationScoped||p&&u.installed!==l.installed||u.installed&&l.installed&&(u.preRelease!==l.preRelease||u.pinned!==l.pinned||l.pinned&&u.version!==l.version)||!E(u.state,l.state)||w&&u.version!==l.version)}function C(u,l,w){const p=u.state,h=l.state,g=w?.state;if(!l.version||p&&N.gt(u.version,l.version))return p;if(h&&N.gt(l.version,u.version)||!p)return h;if(!h)return p;const f=(0,R.$Xn)(p),c=g?$(g,h):{added:Object.keys(h).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},d=g?$(g,p):{added:Object.keys(p).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])f[i]=h[i];for(const i of c.removed.values())d.updated.has(i)||delete f[i];return f}function $(u,l){const w=Object.keys(u),p=Object.keys(l),h=p.filter(c=>!w.includes(c)).reduce((c,d)=>(c.add(d),c),new Set),g=w.filter(c=>!p.includes(c)).reduce((c,d)=>(c.add(d),c),new Set),f=new Set;for(const c of w){if(g.has(c))continue;const d=u[c],i=l[c];(0,R.$2n)(d,i)||f.add(c)}return{added:h,removed:g,updated:f}}function E(u={},l={}){const{added:w,removed:p,updated:h}=$(u,l);return w.size===0&&p.size===0&&h.size===0}function b(u){return{...u,disabled:!!u.disabled,installed:!!u.installed}}function m(u,l){const w={...u,identifier:{id:u.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!u.preRelease,pinned:!!u.pinned};return u.disabled||delete w.disabled,u.installed||delete w.installed,u.state||delete w.state,u.isApplicationScoped||delete w.isApplicationScoped,w}}),define(ae[111],ce([0,1,17,21,4]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XLb=e.$WLb=void 0,e.$WLb=(0,L.$ri)("IIgnoredExtensionsManagementService");let j=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,C){let $=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return $=$.filter(E=>E!==I&&E!==`-${I}`),C&&$.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",$.length?$:void 0,2)}updateSynchronizedExtensions(I,C){let $=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return $=$.filter(E=>E!==I&&E!==`-${I}`),C&&$.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",$.length?$:void 0,2)}getIgnoredExtensions(I){const C=I.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),$=this.b().map(m=>m.toLowerCase()),E=[],b=[];if(Array.isArray($))for(const m of $)m.startsWith("-")?b.push(m.substring(1)):E.push(m);return(0,R.$Mb)([...C,...E].filter(m=>!b.includes(m)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};e.$XLb=j,e.$XLb=j=Ee([X(0,N.$Xi)],j)}),define(ae[242],ce([0,1,17,35,30,93,79]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u$b=C;function I(c){return(0,N.$En)(c)||[]}async function C(c,d,i,o,n){const s=I(c),t=I(d),r=i?I(i):null,a=[...s,...t,...r||[]].map(G=>G.key),y=await n.resolveUserBindings(a),v=E(s,t,r,y);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const P=m(s),S=m(t),k=r?m(r):null,D=l(P,S,y),T=k?l(k,P,y):{added:[...P.keys()].reduce((G,Y)=>(G.add(Y),G),new Set),removed:new Set,updated:new Set},F=k?l(k,S,y):{added:[...S.keys()].reduce((G,Y)=>(G.add(Y),G),new Set),removed:new Set,updated:new Set},U=$(D,T,F);let Q=c;for(const G of U.removed.values())U.conflicts.has(G)||(Q=g(Q,G,o));for(const G of U.added.values()){if(U.conflicts.has(G))continue;const Y=S.get(G);if(Y.some(W=>W.command!==`-${G}`&&v.conflicts.has(y[W.key]))){U.conflicts.add(G);continue}Q=h(Q,Y,o)}for(const G of U.updated.values()){if(U.conflicts.has(G))continue;const Y=S.get(G);if(Y.some(W=>W.command!==`-${G}`&&v.conflicts.has(y[W.key]))){U.conflicts.add(G);continue}Q=f(Q,G,Y,o)}return{mergeContent:Q,hasChanges:!0,hasConflicts:U.conflicts.size>0}}function $(c,d,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of d.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(d.updated.has(r)?t.add(r):n.add(r));for(const r of d.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(d.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of d.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(d.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function E(c,d,i,o){const n=new Set,s=b(c,o),t=b(d,o),r=i?b(i,o):null,a=u(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const y=r?u(r,s):{added:[...s.keys()].reduce((T,F)=>(T.add(F),T),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const v=r?u(r,t):{added:[...t.keys()].reduce((T,F)=>(T.add(F),T),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:P,removed:S,updated:k,conflicts:D}=$(a,y,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:P,removed:S,updated:k,conflicts:D}}function b(c,d){const i=new Map;for(const o of c){const n=d[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function m(c){const d=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=d.get(o);n||(n=[],d.set(o,n)),n.push(i)}return d}function u(c,d){const i=[...c.keys()],o=[...d.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(v=>({...v,key:r})),y=d.get(r).map(v=>({...v,key:r}));(0,R.$ub)(a,y,(v,P)=>p(v,P))||t.add(r)}return{added:n,removed:s,updated:t}}function l(c,d,i){const o=[...c.keys()],n=[...d.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,y)=>(a.add(y),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,y)=>(a.add(y),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const y=c.get(a).map(P=>({...P,key:i[P.key]})),v=d.get(a).map(P=>({...P,key:i[P.key]}));w(y,v)||r.add(a)}return{added:s,removed:t,updated:r}}function w(c,d){return!(!(0,R.$ub)(c.filter(({command:i})=>i[0]!=="-"),d.filter(({command:i})=>i[0]!=="-"),(i,o)=>p(i,o))||!(0,R.$ub)(c.filter(({command:i})=>i[0]==="-"),d.filter(({command:i})=>i[0]==="-"),(i,o)=>p(i,o)))}function p(c,d){if(c.command!==d.command||c.key!==d.key)return!1;const i=j.$pj.deserialize(c.when),o=j.$pj.deserialize(d.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!L.$2n(c.args,d.args))}function h(c,d,i){for(const o of d)c=A.edit(c,[-1],o,i);return c}function g(c,d,i){const o=I(c);for(let n=o.length-1;n>=0;n--)(o[n].command===d||o[n].command===`-${d}`)&&(c=A.edit(c,[n],void 0,i));return c}function f(c,d,i,o){const n=I(c),s=n.findIndex(t=>t.command===d||t.command===`-${d}`);for(let t=n.length-1;t>=0;t--)(n[t].command===d||n[t].command===`-${d}`)&&(c=A.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=A.edit(c,[s],i[t],o);return c}}),define(ae[243],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B$b=R,e.$C$b=L;function R(j,A,I){const C={},$={},E=new Set;if(!A)return{local:{added:C,updated:$,removed:[...E.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const b=N(j,A);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:C,updated:$,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=N(I,j),u=N(I,A),l={},w={},p=new Set,h=new Set;for(const g of m.removed.values())u.updated.has(g)?C[g]=A[g]:p.add(g);for(const g of u.removed.values())h.has(g)||(m.updated.has(g)?h.add(g):E.add(g));for(const g of m.updated.values())h.has(g)||(u.updated.has(g)?b.updated.has(g)&&h.add(g):w[g]=j[g]);for(const g of u.updated.values())h.has(g)||(m.updated.has(g)?b.updated.has(g)&&h.add(g):j[g]!==void 0&&($[g]=A[g]));for(const g of m.added.values())h.has(g)||(u.added.has(g)?b.updated.has(g)&&h.add(g):l[g]=j[g]);for(const g of u.added.values())h.has(g)||(m.added.has(g)?b.updated.has(g)&&h.add(g):C[g]=A[g]);return{local:{added:C,removed:[...E.values()],updated:$},remote:{added:l,removed:[...p.values()],updated:w},conflicts:[...h.values()]}}function N(j,A){const I=j?Object.keys(j):[],C=A?Object.keys(A):[],$=C.filter(m=>!I.includes(m)).reduce((m,u)=>(m.add(u),m),new Set),E=I.filter(m=>!C.includes(m)).reduce((m,u)=>(m.add(u),m),new Set),b=new Set;for(const m of I){if(E.has(m))continue;const u=j[m],l=A[m];u!==l&&b.add(m)}return{added:$,removed:E,updated:b}}function L(j,A){const{added:I,removed:C,updated:$}=N(j,A);return I.size===0&&C.size===0&&$.size===0}}),define(ae[244],ce([0,1,30]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=N;function N(j,A,I,C){const $={added:[],removed:[],updated:[]};let E={added:[],removed:[],updated:[]};if(!A){const m=j.filter(({id:u})=>!C.includes(u));return m.length?E.added=m:E=null,{local:$,remote:E}}const b=L(j,A,C);if(b.added.length>0||b.removed.length>0||b.updated.length>0){const m=L(I,j,C),u=L(I,A,C);for(const l of u.removed){const w=j.find(p=>p.id===l);w&&$.removed.push(w)}for(const l of u.added){const w=A.find(p=>p.id===l);m.added.includes(l)?b.updated.includes(l)&&$.updated.push(w):$.added.push(w)}for(const l of u.updated)$.updated.push(A.find(w=>w.id===l));for(const l of m.added)u.added.includes(l)||E.added.push(j.find(w=>w.id===l));for(const l of m.updated)u.removed.includes(l)||u.updated.includes(l)||E.updated.push(j.find(w=>w.id===l));for(const l of m.removed){const w=A.find(p=>p.id===l);w&&E.removed.push(w)}}return E.added.length===0&&E.removed.length===0&&E.updated.length===0&&(E=null),{local:$,remote:E}}function L(j,A,I){j=j?j.filter(({id:u})=>!I.includes(u)):[],A=A.filter(({id:u})=>!I.includes(u));const C=j.map(({id:u})=>u),$=A.map(({id:u})=>u),E=$.filter(u=>!C.includes(u)),b=C.filter(u=>!$.includes(u)),m=[];for(const{id:u,name:l,shortName:w,icon:p,useDefaultFlags:h}of j){if(b.includes(u))continue;const g=A.find(f=>f.id===u);(!g||g.name!==l||g.shortName!==w||g.icon!==p||!(0,R.$2n)(g.useDefaultFlags,h))&&m.push(u)}return{added:E,removed:b,updated:m}}}),define(ae[25],ce([0,1,17,13,179,47,29,4,101,42]),function(ne,e,R,N,L,j,A,I,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vAb=e.$uAb=e.$tAb=e.$sAb=e.$rAb=e.$qAb=e.$pAb=e.$oAb=e.$nAb=e.$lAb=e.MergeState=e.Change=e.SyncStatus=e.$kAb=e.$jAb=e.$iAb=e.UserDataSyncErrorCode=e.$gAb=e.$fAb=e.$eAb=e.$dAb=e.$cAb=e.$_zb=e.SyncResource=e.$9zb=e.$8zb=void 0,e.$6zb=E,e.$7zb=b,e.$0zb=m,e.$$zb=u,e.$aAb=w,e.$bAb=p,e.$hAb=h,e.$mAb=s;function E(){const t=$.$0n.as(j.$co.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}function b(){const t=$.$0n.as(j.$co.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(v=>!!t[v].ignoreSync),a=Object.keys(t).filter(v=>t[v].scope===2||t[v].scope===6),y=E();return(0,R.$Mb)([...r,...a,...y])}e.$8zb="settingsSync",e.$9zb="settingsSync.keybindingsPerPlatform";function m(){const t="vscode://schemas/ignoredSettings",r=$.$0n.as(j.$co.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$9zb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:A.$Oo,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=$.$0n.as(C.$$n.JSONContribution),y=()=>{const v=E(),P=b(),S=Object.keys(j.$do.properties).filter(T=>!P.includes(T)),k=P.filter(T=>!v.includes(T)),D={items:{type:"string",enum:[...S,...k.map(T=>`-${T}`)]}};a.registerSchema(t,D)};return r.onDidUpdateConfiguration(()=>y())}function u(t){return t&&(0,N.$7f)(t)&&(0,N.$5f)(t.id)&&Array.isArray(t.scopes)}var l;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(l||(e.SyncResource=l={})),e.$_zb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function w(t,...r){return t?[t,...r]:r}function p(t,r,a,y){return y.joinPath(a.userDataSyncHome,...w(t,r,`lastSync${r}.json`))}e.$cAb=(0,I.$ri)("IUserDataSyncStoreManagementService"),e.$dAb=(0,I.$ri)("IUserDataSyncStoreService"),e.$eAb=(0,I.$ri)("IUserDataSyncLocalStoreService"),e.$fAb="x-operation-id",e.$gAb="X-Execution-Id";function h(t){const r={};return r[e.$gAb]=t,r}var g;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(g||(e.UserDataSyncErrorCode=g={}));class f extends Error{constructor(r,a,y,v){super(r),this.code=a,this.resource=y,this.operationId=v,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$iAb=f;class c extends f{constructor(r,a,y,v,P){super(r,y,void 0,P),this.url=a,this.serverCode=v}}e.$jAb=c;class d extends f{constructor(r,a){super(r,a)}}e.$kAb=d,function(t){function r(a){if(a instanceof t)return a;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(y&&y[1]){const v=y[2]==="unknown"?void 0:y[2],P=y[3]==="unknown"?void 0:y[3];return new t(a.message,y[1],v,P)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(f||(e.$iAb=f={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$lAb="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$nAb=(0,I.$ri)("IUserDataSyncEnablementService"),e.$oAb=(0,I.$ri)("IUserDataSyncService"),e.$pAb=(0,I.$ri)("IUserDataSyncResourceProviderService"),e.$qAb=(0,I.$ri)("IUserDataAutoSyncService"),e.$rAb=(0,I.$ri)("IUserDataSyncUtilService"),e.$sAb=(0,I.$ri)("IUserDataSyncLogService"),e.$tAb="userDataSync",e.$uAb="vscode-userdata-sync",e.$vAb="preview"}),define(ae[245],ce([0,1,30,25]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cLb=L;function L(A,I,C,$,E){if(!I)return{remote:{added:Object.keys(A),removed:[],updated:[],all:Object.keys(A).length>0?A:null},local:{added:{},removed:[],updated:{}}};const b=j(A,I);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=C?j(C,I):{added:Object.keys(I).reduce((g,f)=>(g.add(f),g),new Set),removed:new Set,updated:new Set},u=C?j(C,A):{added:Object.keys(A).reduce((g,f)=>(g.add(f),g),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},w=R.$Xn(I),p=!C;for(const g of u.added.values())g!==N.$lAb&&p&&m.added.has(g)||(w[g]=A[g]);for(const g of u.updated.values())w[g]=A[g];for(const g of u.removed.values())$.unregistered.includes(g)||delete w[g];for(const g of m.added.values()){const f=I[g];if($.machine.includes(g)){E.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(C&&u.added.has(g))continue;const c=A[g];c&&c.value===f.value||g===N.$lAb&&p&&u.added.has(g)||(c?l.updated[g]=f:l.added[g]=f)}for(const g of m.updated.values()){const f=I[g];if($.machine.includes(g)){E.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(g)||u.removed.has(g))continue;const c=A[g];c&&c.value===f.value||(l.updated[g]=f)}for(const g of m.removed.values()){if($.machine.includes(g)){E.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}u.updated.has(g)||u.removed.has(g)||l.removed.push(g)}const h=j(I,w);return{local:l,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:w}}}function j(A,I){const C=Object.keys(A),$=Object.keys(I),E=$.filter(u=>!C.includes(u)).reduce((u,l)=>(u.add(l),u),new Set),b=C.filter(u=>!$.includes(u)).reduce((u,l)=>(u.add(l),u),new Set),m=new Set;for(const u of C){if(b.has(u))continue;const l=A[u],w=I[u];R.$2n(l,w)||m.add(u)}return{added:E,removed:b,updated:m}}}),define(ae[246],ce([0,1,17,35,62,43,30,79,25]),function(ne,e,R,N,L,j,A,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJb=$,e.$RJb=m,e.$SJb=u,e.$TJb=l,e.$UJb=p,e.$VJb=g;function $(a,y,v){let P=[];v?P=b(v):P=E(y);const S=[],k=[...(0,C.$6zb)()];if(Array.isArray(P))for(const D of P)D.startsWith("-")?k.push(D.substring(1)):S.push(D);return(0,R.$Mb)([...a,...S].filter(D=>!k.includes(D)))}function E(a){let y=a.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=a.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:a.getValue("settingsSync.ignoredSettings")||[]}function b(a){const y=(0,N.$En)(a);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function m(a,y){const v=(0,N.$En)(a)||{};let P="{}";for(const S of Object.keys(v)){const k=(0,L.$Tn)(P,[S],v[S],y);P=(0,L.$Wn)(P,k)}return P}function u(a,y,v,P){if(v.length){const S=r(y),k=(0,N.$En)(y)||{},D=(0,N.$En)(a);if(!D)return a;const T=[];for(const F of v){const U=k[F],Q=D[F];U===void 0?a=I.edit(a,[F],void 0,P):Q!==void 0?a=I.edit(a,[F],U,P):T.push(i(F,S))}T.sort((F,U)=>F.startOffset-U.startOffset),T.forEach(F=>a=g(F.setting.key,y,a,P))}return a}function l(a,y,v,P,S,k){const D=u(a,y,P,k),T=v!==D,F=v!==y;if(!T&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!F)return{conflictsSettings:[],localContent:null,remoteContent:D,hasConflicts:!1};if(F&&!T)return{conflictsSettings:[],localContent:u(y,a,P,k),remoteContent:null,hasConflicts:!1};if(v===null&&p(a)){const M=w(a,y,P)?null:u(y,a,P,k);return{conflictsSettings:[],localContent:M,remoteContent:null,hasConflicts:!1}}let U=a,Q=y;const G=(0,N.$En)(a),Y=(0,N.$En)(y),W=v?(0,N.$En)(v):null,J=P.reduce((M,q)=>(M.add(q),M),new Set),H=h(G,Y,J),B=h(W,G,J),ie=h(W,Y,J),re=new Map,he=new Set,te=M=>{he.add(M);const q=S.filter(({key:x})=>x===M)[0];q?(U=I.edit(U,[M],q.value,k),Q=I.edit(Q,[M],q.value,k)):re.set(M,{key:M,localValue:G[M],remoteValue:Y[M]})};for(const M of B.removed.values())ie.updated.has(M)?te(M):Q=I.edit(Q,[M],void 0,k);for(const M of ie.removed.values())he.has(M)||(B.updated.has(M)?te(M):U=I.edit(U,[M],void 0,k));for(const M of B.updated.values())he.has(M)||(ie.updated.has(M)?H.updated.has(M)&&te(M):Q=I.edit(Q,[M],G[M],k));for(const M of ie.updated.values())he.has(M)||(B.updated.has(M)?H.updated.has(M)&&te(M):U=I.edit(U,[M],Y[M],k));for(const M of B.added.values())he.has(M)||(ie.added.has(M)?H.updated.has(M)&&te(M):Q=g(M,U,Q,k));for(const M of ie.added.values())he.has(M)||(B.added.has(M)?H.updated.has(M)&&te(M):U=g(M,Q,U,k));const V=re.size>0||!w(U,Q,P),z=V||!w(U,a,[]),O=V||!w(Q,y,[]);return{localContent:z?U:null,remoteContent:O?Q:null,conflictsSettings:[...re.values()],hasConflicts:V}}function w(a,y,v){if(a===y)return!0;const P=(0,N.$En)(a),S=(0,N.$En)(y),k=v.reduce((F,U)=>(F.add(U),F),new Set),D=r(a).filter(F=>!(F.setting&&k.has(F.setting.key))),T=r(y).filter(F=>!(F.setting&&k.has(F.setting.key)));if(D.length!==T.length)return!1;for(let F=0;F<D.length;F++){const U=D[F],Q=T[F];if(U.setting&&Q.setting){if(U.setting.key!==Q.setting.key||!A.$2n(P[U.setting.key],S[U.setting.key]))return!1}else if(!U.setting&&!Q.setting){if(U.value!==Q.value)return!1}else return!1}return!0}function p(a){return a?r(a).length===0:!0}function h(a,y,v){const P=a?Object.keys(a).filter(F=>!v.has(F)):[],S=Object.keys(y).filter(F=>!v.has(F)),k=S.filter(F=>!P.includes(F)).reduce((F,U)=>(F.add(U),F),new Set),D=P.filter(F=>!S.includes(F)).reduce((F,U)=>(F.add(U),F),new Set),T=new Set;if(a)for(const F of P){if(D.has(F))continue;const U=a[F],Q=y[F];A.$2n(U,Q)||T.add(F)}return{added:k,removed:D,updated:T}}function g(a,y,v,P){const S=(0,N.$En)(y),k=r(y),D=r(v),T=f(a,k,D);return c(v,a,S[a],T,D,P)}function f(a,y,v){const P=y.findIndex(k=>k.setting?.key===a),S=y[P-1];if(S){if(S.setting){const D=i(S.setting.key,v);if(D)return{index:v.indexOf(D),insertAfter:!0}}else{const D=o(P,y);if(D){const T=i(D.setting.key,v);if(T){const F=n(v.indexOf(T),v),U=s(y,D,y[P]);if(F){const Q=s(v,T,F),G=t(U,Q);return G?{index:v.indexOf(G),insertAfter:!0}:{index:v.indexOf(F),insertAfter:!1}}else{const Q=s(v,T,v[v.length-1]),G=t(U,Q);return G?{index:v.indexOf(G),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const k=y[P+1];if(k)if(k.setting){const D=i(k.setting.key,v);if(D)return{index:v.indexOf(D),insertAfter:!1}}else{const D=n(P,y);if(D){const T=i(D.setting.key,v);if(T){const F=o(v.indexOf(T),v),U=s(y,y[P],D);if(F){const Q=s(v,F,T),G=t(U.reverse(),Q.reverse());return G?{index:v.indexOf(G),insertAfter:!1}:{index:v.indexOf(F),insertAfter:!0}}else{const Q=s(v,v[0],T),G=t(U.reverse(),Q.reverse());return G?{index:v.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function c(a,y,v,P,S,k){let D;return P.index===-1?D=(0,L.$Tn)(a,[y],v,k):D=d(a,y,v,P,S,k).map(T=>(0,L.$Un)(a,T,k)[0]),(0,L.$Wn)(a,D)}function d(a,y,v,P,S,k){const D=`${JSON.stringify(y)}: ${JSON.stringify(v)}`,T=(0,j.$Qn)(k,a),F=S[P.index];if(P.insertAfter){const U=[];if(F.setting)U.push({offset:F.endOffset,length:0,content:","+D});else{const Q=n(P.index,S),G=o(P.index,S),Y=G?.setting?.commaOffset;G&&Y===void 0&&U.push({offset:G.endOffset,length:0,content:","});const W=Y!==void 0&&Y>F.endOffset;U.push({offset:W?Y+1:F.endOffset,length:0,content:Q?T+D+",":T+D})}return U}else{if(F.setting)return[{offset:F.startOffset,length:0,content:D+","}];const U=(S[P.index-1]&&!S[P.index-1].setting?T:"")+D+(n(P.index,S)?",":"")+T;return[{offset:F.startOffset,length:0,content:U}]}}function i(a,y){return y.filter(v=>v.setting?.key===a)[0]}function o(a,y){for(let v=a-1;v>=0;v--)if(y[v].setting)return y[v]}function n(a,y){for(let v=a+1;v<y.length;v++)if(y[v].setting)return y[v]}function s(a,y,v){const P=a.indexOf(y),S=a.indexOf(v);return a.filter((k,D)=>P<D&&D<S)}function t(a,y){if(a.length&&y.length){let v=0;for(;v<y.length&&v<a.length;v++)if(a[v].value!==y[v].value)return y[v-1];return y[v-1]}}function r(a){const y=[];let v=-1,P,S;const k={onObjectBegin:D=>{v++},onObjectProperty:(D,T,F)=>{v===0&&(P=T,S=D)},onObjectEnd:(D,T)=>{v--,v===0&&y.push({startOffset:P,endOffset:D+T,value:a.substring(P,D+T),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(D,T)=>{v++},onArrayEnd:(D,T)=>{v--,v===0&&y.push({startOffset:P,endOffset:D+T,value:a.substring(P,D+T),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(D,T,F)=>{v===0&&y.push({startOffset:P,endOffset:T+F,value:a.substring(P,T+F),setting:{key:S,commaOffset:void 0}})},onSeparator:(D,T,F)=>{if(v===0&&D===","){let U=y.length-1;for(;U>=0&&!y[U].setting;U--);const Q=y[U];Q&&y.splice(U,1,{startOffset:Q.startOffset,endOffset:Q.endOffset,value:Q.value,setting:{key:Q.setting.key,commaOffset:T}})}},onComment:(D,T)=>{v===0&&y.push({startOffset:D,endOffset:D+T,value:a.substring(D,D+T)})}};return(0,N.$Ln)(a,k),y}}),define(ae[80],ce([0,1,3,2,4,25]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zJb=e.$yJb=void 0,e.$yJb=(0,L.$ri)("IUserDataSyncAccountService");let A=class extends N.$Uc{get account(){return this.a}constructor(C,$){super(),this.g=C,this.h=$,this.b=this.B(new R.$be),this.onDidChangeAccount=this.b.event,this.c=this.B(new R.$be),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(E=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,E),this.updateAccount(void 0),E==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};e.$zJb=A,e.$zJb=A=Ee([X(0,j.$dAb),X(1,j.$sAb)],A)}),define(ae[247],ce([0,1,20,180,16,9,25]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YLb=void 0;let I=class extends j.$3j{constructor($,E){super(),this.g=this.B($.createLogger((0,R.$5g)(E.logsHome,`${A.$tAb}.log`),{id:A.$tAb,name:(0,N.localize)(0,null)}))}trace($,...E){this.g.trace($,...E)}debug($,...E){this.g.debug($,...E)}info($,...E){this.g.info($,...E)}warn($,...E){this.g.warn($,...E)}error($,...E){this.g.error($,...E)}flush(){this.g.flush()}};e.$YLb=I,e.$YLb=I=Ee([X(0,j.$Yj),X(1,L.$yi)],I)}),define(ae[248],ce([0,1,6,3,2]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class j extends L.$Uc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:C,getActiveWindowId:$}){super(),this.a=this.B(new L.$Tc),N.Event.latch(N.Event.any(I,C))(this.f,this,this.a),this.b=(0,R.$eh)(()=>$()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Hcc=j}),define(ae[112],ce([0,1,183,14,51,20,8,4,23]),function(ne,e,R,N,L,j,A,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Li=e.$Ki=e.WorkbenchState=e.$Ei=e.$Di=e.$Ai=void 0,e.$Bi=$,e.$Ci=E,e.$Fi=b,e.$Gi=m,e.$Hi=u,e.$Ii=w,e.$Ji=p,e.$Mi=f,e.$Ri=c,e.$Si=d,e.$Ui=i,e.$Vi=o,e.$Wi=n,e.$Ai=(0,I.$ri)("contextService");function $(s){const t=s;return typeof t?.id=="string"&&A.URI.isUri(t.uri)}function E(s){return typeof s?.id=="string"&&!$(s)&&!m(s)}e.$Di={id:"ext-dev"},e.$Ei={id:"empty-window"};function b(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$oc)(s)}:t?e.$Di:e.$Ei;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function m(s){const t=s;return typeof t?.id=="string"&&A.URI.isUri(t.configPath)}function u(s){const t=s;if(t?.uri)return{id:t.id,uri:A.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:A.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}var l;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function w(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}function p(s){const t=s;return!!(t&&typeof t=="object"&&A.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}class h{constructor(t,r,a,y,v){this.h=t,this.j=a,this.k=y,this.l=v,this.c=L.$xi.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=L.$xi.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ki=h;class g{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,j.$5g)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Li=g;function f(s){return new g({uri:s,index:0,name:(0,j.$1g)(s)},{uri:s.toString()})}e.$Ni="code-workspace",e.$Oi=`.${e.$Ni}`,e.$Pi=[{name:(0,R.localize)(0,null),extensions:[e.$Ni]}],e.$Qi="workspace.json";function c(s,t){return j.$Vg.isEqualOrParent(s,t.untitledWorkspacesHome)}function d(s){let t;return A.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===C.Schemas.tmp}e.$Ti="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$Ti}function o(s,t){return!c(s,t)&&!d(s)}function n(s){return(typeof s=="string"?(0,N.$pc)(s):(0,j.$3g)(s))===e.$Oi}}),define(ae[18],ce([0,1,54,3,2,20,8,174,16,12,4,9,112,34,28,6,32,27,13]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.$xl=e.ProfileResourceType=void 0,e.$wl=c,e.$yl=d,e.$zl=i;var f;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(f||(e.ProfileResourceType=f={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&A.URI.isUri(t.location)&&A.URI.isUri(t.globalStorageHome)&&A.URI.isUri(t.settingsResource)&&A.URI.isUri(t.keybindingsResource)&&A.URI.isUri(t.tasksResource)&&A.URI.isUri(t.snippetsHome)&&A.URI.isUri(t.extensionsResource))}e.$xl=(0,E.$ri)("IUserDataProfilesService");function d(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:A.URI.revive(s.location).with({scheme:t}),globalStorageHome:A.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:A.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:A.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:A.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:A.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:A.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:A.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function i(s,t,r,a,y,v){return{id:s,name:t,location:r,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:v&&y?.useDefaultFlags?.globalState?v.globalStorageHome:(0,j.$5g)(r,"globalStorage"),settingsResource:v&&y?.useDefaultFlags?.settings?v.settingsResource:(0,j.$5g)(r,"settings.json"),keybindingsResource:v&&y?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,j.$5g)(r,"keybindings.json"),tasksResource:v&&y?.useDefaultFlags?.tasks?v.tasksResource:(0,j.$5g)(r,"tasks.json"),snippetsHome:v&&y?.useDefaultFlags?.snippets?v.snippetsHome:(0,j.$5g)(r,"snippets"),extensionsResource:v&&y?.useDefaultFlags?.extensions?v.extensionsResource:(0,j.$5g)(r,"extensions.json"),cacheHome:(0,j.$5g)(a,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let o=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,y){super(),this.t=t,this.u=r,this.w=a,this.y=y,this.f=!0,this.h=this.B(new N.$be),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$be),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$be),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$be),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new u.$Bc,emptyWindows:new Map},this.profilesHome=(0,j.$5g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$5g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,g.$5f)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}r.push(i((0,j.$2g)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},t))}}catch(v){this.y.error(v)}const a=new u.$Bc,y=new Map;if(r.length)try{const v=this.Q();if(v.workspaces)for(const[P,S]of Object.entries(v.workspaces)){const k=A.URI.parse(P),D=r.find(T=>T.id===S);D&&a.set(k,D)}if(v.emptyWindows)for(const[P,S]of Object.entries(v.emptyWindows)){const k=r.find(D=>D.id===S);k&&y.set(P,k)}}catch(v){this.y.error(v)}this.z={profiles:r,workspaces:a,emptyWindows:y}}return this.z}D(){const t=i("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,h.$9e)(r)}\\s(\\d+)`);let y=0;for(const P of this.profiles){const S=a.exec(P.name),k=S?parseInt(S[1]):0;y=k>y?k:y}const v=`${r} ${y+1}`;return this.createProfile((0,R.$fj)((0,p.$Ng)()).toString(16),v,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,R.$fj)((0,p.$Ng)()).toString(16),t,r,a)}async createProfile(t,r,a,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(t,r,a);return y&&await this.setProfileForWorkspace(y,v),v}async F(t,r,a){if(!(0,g.$5f)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(r);return y||(y=(async()=>{try{if(this.profiles.find(k=>k.name===r||k.id===t))throw new Error(`Profile with ${r} name already exists`);const P=i(t,r,(0,j.$5g)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(P.location);const S=[];return this.j.fire({profile:P,join(k){S.push(k)}}),await w.Promises.settled(S),this.I([P],[],[]),P}finally{this.r.delete(r)}})(),this.r.set(r,y)),y}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(y=>y.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(y=>y.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(y){a.push(y)}});try{await Promise.allSettled(a)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(y){(0,$.$cl)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(y=>y.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return A.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,m.$Bi)(t)?t.uri:(0,m.$Gi)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const y=[...this.profiles,...t],v=[];this.s.profiles=[];for(let P of y)P.isDefault||r.some(S=>P.id===S.id)||(P=a.find(S=>P.id===S.id)??P,P.isTransient?this.s.profiles.push(P):v.push({location:P.location,name:P.name,shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags}));this.P(v),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const y=this.G(t),v=a?this.s:this.C;A.URI.isUri(y)?(v.workspaces.delete(y),r&&v.workspaces.set(y,r)):(v.emptyWindows.delete(y),r&&v.emptyWindows.set(y,r)),a||this.M()}M(){const t={};for(const[a,y]of this.C.workspaces.entries())t[a.toString()]=y.id;const r={};for(const[a,y]of this.C.emptyWindows.entries())r[a.toString()]=y.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[v,P]of Object.entries(t.workspaces)){const S=A.URI.parse(P);r[v]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}const y={};if(t.emptyWindows)for(const[v,P]of Object.entries(t.emptyWindows)){const S=A.URI.parse(P);y[v]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}return{workspaces:r,emptyWindows:y}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Al=o,e.$Al=o=Ee([X(0,C.$yi),X(1,$.$Xk),X(2,l.$vl),X(3,b.$Xj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Bl=n}),define(ae[249],ce([0,1,6,2,18]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;let j=class extends N.$Uc{constructor(I){super(),this.B(new R.$Dh(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$Tdc=j,e.$Tdc=j=Ee([X(0,L.$xl)],j)}),define(ae[250],ce([0,1,17,6,26,7,3,2,5,13,8,156,29,33,48,9,24,22,28,18]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$fq=void 0,e.$gq=d,e.$hq=i;let c=class extends I.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,y,v,P){super(),this.z=t,this.C=r,this.D=a,this.F=y,this.G=v,this.H=P,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$be),this.s=this.B(new A.$be),this.t=this.B(new A.$be),this.u=this.B(new A.$be),this.w=this.B(new A.$be),this.y=[],this.B((0,I.$Sc)(()=>{this.j.forEach(({task:S})=>S.cancel()),this.m.forEach(S=>S.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,m.$Yo)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const y=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:v})=>(0,u.$pp)(v,t.identifier));if(y?.local)return y?.local;throw y?.error?y.error:new m.$2o(`Unknown error while installing extension ${t.identifier.id}`,m.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new m.$2o(b.localize(0,null),m.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:y,options:v})=>{try{const P=await this.N(y,!!v?.installGivenVersion,!!v?.installPreReleaseVersion,v.productVersion??{version:this.G.version,date:this.G.date});a.push({...P,options:v})}catch(P){r.push({identifier:y.identifier,operation:2,source:y,error:P})}})),a.length&&r.push(...await this.I(a));for(const y of r)y.error&&(this.F.error("Failed to install extension.",y.identifier.id),this.F.error(y.error),y.source&&!E.URI.isUri(y.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,u.$xp)(y.source),error:y.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,r)}async toggleAppliationScope(t,r){if((0,l.$Pm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(t,this.H.defaultProfile.extensionsResource,r));for(const y of this.H.profiles){const v=(await this.getInstalled(1,y.extensionsResource)).find(P=>(0,u.$pp)(P.identifier,t.identifier));v?this.w.fire(v):this.u.fire({identifier:t.identifier,profileLocation:y.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=new Map,a=new Map,y=[],v=(S,k)=>`${u.$qp.create(S).toString()}-${k.toString()}`,P=(S,k,D,T)=>{const F=this.Y(S,k,D),U=`${(0,u.$up)(S.publisher,S.name)}-${D.profileLocation.toString()}`;a.set(U,{task:F,root:T}),this.n.fire({identifier:F.identifier,source:k,profileLocation:D.profileLocation}),this.F.info("Installing extension:",F.identifier.id),E.URI.isUri(k)||this.j.set(v(k,D.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:S,extension:k,options:D}of t){const T=D.isApplicationScoped||D.isBuiltin||(0,l.$Pm)(S),F={...D,installOnlyNewlyAddedFromExtensionPack:D.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(k),isApplicationScoped:T,profileLocation:T?this.H.defaultProfile.extensionsResource:D.profileLocation??this.X(),productVersion:D.productVersion??{version:this.G.version,date:this.G.date}},U=E.URI.isUri(k)?void 0:this.j.get(v(k,F.profileLocation));U?(this.F.info("Extension is already requested to install",U.task.identifier.id),y.push(U.task.waitUntilTaskIsFinished())):P(S,k,F,void 0)}return await Promise.all([...a.values()].map(async({task:S})=>{if(S.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",S.identifier.id);else try{const k=await this.M(S.identifier,S.manifest,!!S.options.installOnlyNewlyAddedFromExtensionPack,!!S.options.installPreReleaseVersion,S.options.profileLocation,S.options.productVersion),D=await this.getInstalled(void 0,S.options.profileLocation,S.options.productVersion),T={...S.options,context:{...S.options.context,[m.$To]:!0}};for(const{gallery:F,manifest:U}of(0,R.$Mb)(k,({gallery:Q})=>Q.identifier.id)){if(a.has(`${F.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`))continue;const Q=this.j.get(v(F,T.profileLocation));if(Q){if(this.J(S,Q.task)){const G=Q.task.identifier;this.F.info("Waiting for already requested installing extension",G.id,S.identifier.id),Q.waitingTasks.push(S),y.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,Y=>Y.some(W=>(0,u.$pp)(W.identifier,G)))).then(Y=>{if(this.F.info("Finished waiting for already requested installing extension",G.id,S.identifier.id),!Y.find(J=>(0,u.$pp)(J.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else D.some(({identifier:G})=>(0,u.$pp)(G,F.identifier))||P(U,F,T,S)}}catch(k){if(E.URI.isUri(S.source))(0,R.$Lb)(S.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",S.identifier.id,k.message),(0,R.$Lb)(S.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",S.identifier.id,k.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",S.identifier.id),k}})),await this.L([...a.entries()].map(async([S,{task:k}])=>{const D=new Date().getTime();try{const T=await k.run();if(await this.L(this.y.map(F=>F.postInstall(T,k.source,k.options,L.CancellationToken.None))),!E.URI.isUri(k.source)){const F=k.operation===3,U=F?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(o(this.C,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.$xp)(k.source),verificationStatus:k.verificationStatus,duration:new Date().getTime()-D,durationSinceUpdate:U}),C.$o&&k.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}r.set(S,{local:T,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){throw r.set(S,{error:T,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:k.options.isApplicationScoped}),this.F.error("Error while installing the extension",k.identifier.id,(0,j.$0)(T)),T}})),y.length&&await this.L(y),[...r.values()]}catch(S){const k=(F,U,Q)=>{const G=[];F.manifest.extensionDependencies?.length&&G.push(...F.manifest.extensionDependencies),F.manifest.extensionPack?.length&&G.push(...F.manifest.extensionPack);for(const Y of G){if(Q.includes(Y.toLowerCase()))continue;Q.push(Y.toLowerCase());const W=r.get(`${Y.toLowerCase()}-${U.toString()}`);W?.local&&(Q=k(W.local,U,Q))}return Q},D=F=>({identifier:F.identifier,operation:2,source:F.source,context:F.options.context,profileLocation:F.profileLocation,error:S}),T=[];for(const[F,{task:U,root:Q}]of a){const G=r.get(F);G?G.local&&Q&&!r.get(`${Q.identifier.id.toLowerCase()}-${U.profileLocation.toString()}`)?.local&&(T.push(this.Z(G.local,{versionOnly:!0,profileLocation:U.profileLocation})),r.set(F,D(U))):(U.cancel(),r.set(F,D(U)))}for(const[F,{task:U}]of a){const Q=r.get(F);if(!Q?.local||U.options.donotIncludePackAndDependencies)continue;k(Q.local,U.profileLocation,[Q.local.identifier.id.toLowerCase()]).slice(1).some(Y=>a.has(`${Y.toLowerCase()}-${U.profileLocation.toString()}`)&&!r.get(`${Y.toLowerCase()}-${U.profileLocation.toString()}`)?.local)&&(T.push(this.Z(Q.local,{versionOnly:!0,profileLocation:U.profileLocation})),r.set(F,D(U)))}throw T.length&&await Promise.allSettled(T.map(async F=>{try{await F.run(),this.F.info("Rollback: Uninstalled extension",F.extension.identifier.id)}catch(U){this.F.warn("Rollback: Error while uninstalling extension",F.extension.identifier.id,(0,j.$0)(U))}})),S}finally{for(const{task:S}of a.values())S.source&&!E.URI.isUri(S.source)&&this.j.delete(v(S.source,S.profileLocation));if(r.size){const S=[...r.values()];for(const k of S)k.local&&this.F.info("Extension installed successfully:",k.identifier.id);this.s.fire(S)}}}J(t,r){for(const[,{task:a,waitingTasks:y}]of this.j.entries())if(a===t&&(y.includes(r)||y.some(v=>this.J(v,r)))||a===r&&y[0]&&!this.J(t,y[0]))return!1;return!0}async L(t){const r=[],a=[],y=await Promise.allSettled(t);for(const v of y)v.status==="fulfilled"?r.push(v.value):a.push(v.reason);if(a.length)throw d(a);return r}async M(t,r,a,y,v,P){if(!this.z.isEnabled())return[];const S=await this.getInstalled(void 0,v,P),k=[],D=[],T=async(F,U)=>{k.push(F);const Q=U.extensionDependencies||[],G=[...Q];if(U.extensionPack){const Y=a?S.find(W=>(0,u.$pp)(W.identifier,F)):void 0;for(const W of U.extensionPack)Y&&Y.manifest.extensionPack&&Y.manifest.extensionPack.some(J=>(0,u.$pp)({id:J},{id:W}))||G.every(J=>!(0,u.$pp)({id:J},{id:W}))&&G.push(W)}if(G.length){const Y=G.filter(W=>k.every(J=>!(0,u.$pp)(J,{id:W})));if(Y.length){const W=await this.z.getExtensions(Y.map(J=>({id:J,preRelease:y})),L.CancellationToken.None);for(const J of W){if(k.find(ie=>(0,u.$pp)(ie,J.identifier)))continue;const H=Q.some(ie=>(0,u.$pp)({id:ie},J.identifier));let B;try{B=await this.N(J,!1,y,P)}catch(ie){if(H)throw ie;this.F.info("Skipping the packed extension as it cannot be installed",J.identifier.id,(0,j.$0)(ie));continue}D.push({gallery:B.extension,manifest:B.manifest}),await T(B.extension.identifier,B.manifest)}}}};return await T(t,r),D}async N(t,r,a,y){let v;const P=await this.getExtensionsControlManifest();if(P.malicious.some(D=>(0,u.$pp)(t.identifier,D)))throw new m.$2o(b.localize(1,null,t.identifier.id),m.ExtensionManagementErrorCode.Malicious);const S=P.deprecated[t.identifier.id.toLowerCase()];if(S?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${S.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:S.extension.id,preRelease:S.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:y},L.CancellationToken.None))[0],!v)throw new m.$2o(b.localize(2,null,t.identifier.id,S.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const D=await this.getTargetPlatform();throw new m.$2o(b.localize(3,null,t.identifier.id,this.G.nameLong,(0,m.$Uo)(D)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.O(t,r,a,y),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],L.CancellationToken.None))[0]?new m.$2o(b.localize(4,null,t.displayName??t.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$2o(b.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const k=await this.z.getManifest(v,L.CancellationToken.None);if(k===null)throw new m.$2o(`Missing manifest for extension ${v.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(k.version!==v.version)throw new m.$2o(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:k}}async O(t,r,a,y){const v=await this.getTargetPlatform();let P=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(P=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0,productVersion:y},L.CancellationToken.None))[0]||null),!P&&await this.z.isExtensionCompatible(t,a,v,y)&&(P=t),P||(r?P=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0,productVersion:y},L.CancellationToken.None))[0]||null:P=await this.z.getCompatibleExtension(t,a,v,y)),P}async P(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},y=T=>`${T.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,v=this.m.get(y(t.identifier));if(v)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),v.waitUntilTaskIsFinished();const P=T=>{const F=this.Z(T,a);return this.m.set(y(F.extension.identifier),F),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped}),F},S=(T,F)=>{F?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString(),F.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,F.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,u.$wp)(T),error:F}),this.u.fire({identifier:T.identifier,error:F?.code,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped})},k=[],D=[];try{k.push(P(t));const T=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.S(t,T);for(const U of F)this.m.has(y(U.identifier))?this.F.info("Extensions is already requested to uninstall",U.identifier.id):k.push(P(U))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(k.map(F=>F.extension),T,t),await this.L(k.map(async F=>{try{if(await F.run(),await this.L(this.y.map(U=>U.postUninstall(F.extension,a,L.CancellationToken.None))),F.extension.identifier.uuid)try{await this.z.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}S(F.extension)}catch(U){const Q=U instanceof m.$2o?U:new m.$2o((0,j.$0)(U),m.ExtensionManagementErrorCode.Internal);throw S(F.extension,Q),Q}finally{D.push(F)}}))}catch(T){const F=T instanceof m.$2o?T:new m.$2o((0,j.$0)(T),m.ExtensionManagementErrorCode.Internal);for(const U of k){try{U.cancel()}catch{}D.includes(U)||S(U.extension,F)}throw F}finally{for(const T of k)this.m.delete(y(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}Q(t,r,a){for(const y of t){const v=this.U(y,r);if(v.length){const P=v.filter(S=>!t.some(k=>(0,u.$pp)(k.identifier,S.identifier)));if(P.length)throw new Error(this.R(y,P,a))}}}R(t,r,a){return a===t?r.length===1?b.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const y=t.manifest.extensionPack?t.manifest.extensionPack:[];if(y.length){const v=r.filter(S=>!S.isBuiltin&&y.some(k=>(0,u.$pp)({id:k},S.identifier))),P=[];for(const S of v)P.push(...this.S(S,r,a));return[...v,...P]}return[]}U(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(y=>(0,u.$pp)({id:y},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,j.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$fq=c,e.$fq=c=Ee([X(0,m.$1o),X(1,h.$Wl),X(2,g.$vl),X(3,w.$Xj),X(4,p.$ek),X(5,f.$xl)],c);function d(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}function i(s){if(s instanceof m.$2o)return s;if(s instanceof m.$3o){const r=new m.$2o(s.message,m.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new m.$2o(s.message,m.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function o(s,t,{extensionData:r,verificationStatus:a,duration:y,error:v,durationSinceUpdate:P}){let S,k;(0,$.$ag)(a)&&(a===!0?a="Verified":(a===!1||(S=m.ExtensionManagementErrorCode.Signature,k=a),a="Unverified")),v&&(v instanceof m.$2o||v instanceof m.$3o?(S=v.code,v.code===m.ExtensionManagementErrorCode.Signature&&(k=v.message)):S=m.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!v,duration:y,errorcode:S,errorcodeDetail:k,durationSinceUpdate:P})}class n{constructor(){this.d=new N.$qh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,N.$eh)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$eh)(t=>new Promise((r,a)=>{const y=t.onCancellationRequested(()=>{y.dispose(),a(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$iq=n}),define(ae[52],ce([0,1,6,15,2,3,34,8,29,33,12,4,9,18,28,13,7,22]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class f extends Error{constructor(n,s){super(n),this.code=s}}e.$jq=f,e.$kq=(0,b.$ri)("IExtensionsProfileScannerService");let c=class extends L.$Uc{constructor(n,s,t,r,a,y){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=y,this.b=this.B(new j.$be),this.onAddExtensions=this.b.event,this.c=this.B(new j.$be),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$be),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$be),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Bc}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,t){const r=[],a=[];try{return await this.u(s,y=>{const v=[];if(t)v.push(...y);else for(const P of y)n.some(([S])=>(0,$.$pp)(S.identifier,P.identifier)&&S.manifest.version!==P.version)?r.push(P):v.push(P);for(const[P,S]of n){const k=v.findIndex(T=>(0,$.$pp)(T.identifier,P.identifier)&&T.version===P.manifest.version),D={identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:S};k===-1?(a.push(D),v.push(D)):v.splice(k,1,D)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),r.length&&this.f.fire({extensions:r,profileLocation:s}),v}),a.length&&this.c.fire({extensions:a,profileLocation:s}),r.length&&this.g.fire({extensions:r,profileLocation:s}),a}catch(y){throw a.length&&this.c.fire({extensions:a,error:y,profileLocation:s}),r.length&&this.g.fire({extensions:r,error:y,profileLocation:s}),y}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const y of r){const v=n.find(([P])=>(0,$.$pp)(P.identifier,y.identifier)&&P.manifest.version===y.version);v&&(y.metadata={...y.metadata,...v[1]},t.push(y)),a.push(y)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const y of r)(0,$.$pp)(y.identifier,n.identifier)?t.push(y):a.push(y);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const y=await this.m.readFile(n);a=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,E.$cl)(y)!==1)throw y;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new f((0,p.$0)(y),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let y=!1;for(const v of a){d(v)||this.w(n);let P;if((0,w.$5f)(v.relativeLocation)&&v.relativeLocation)P=this.z(v.relativeLocation);else if((0,w.$5f)(v.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${v.location}`);continue}else{P=I.URI.revive(v.location);const S=this.y(P);S&&(y=!0,v.relativeLocation=S)}(0,w.$_f)(v.metadata?.hasPreReleaseVersion)&&v.metadata?.preRelease&&(y=!0,v.metadata.hasPreReleaseVersion=!0),r.push({identifier:v.identifier,location:P,version:v.version,metadata:v.metadata})}y&&await this.m.writeFile(n,N.$Ce.fromString(JSON.stringify(a)))}if(s){r=s(r);const y=r.map(v=>({identifier:v.identifier,version:v.version,location:v.location.toJSON(),relativeLocation:this.y(v.location),metadata:v.metadata}));await this.m.writeFile(n,N.$Ce.fromString(JSON.stringify(y)))}return r})}w(n){const s=new f(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,E.$cl)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(y=>d(y))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$Ce.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,E.$cl)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,E.$cl)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,E.$cl)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new R.$yh,this.h.set(n,s)),s}};e.$lq=c,e.$lq=c=Ee([X(1,E.$Xk),X(2,u.$xl),X(3,l.$vl),X(4,h.$Wl),X(5,m.$Xj)],c);function d(o){return(0,w.$7f)(o)&&(0,C.$Zo)(o.identifier)&&(i(o.location)||(0,w.$5f)(o.location)&&o.location)&&((0,w.$_f)(o.relativeLocation)||(0,w.$5f)(o.relativeLocation))&&o.version&&(0,w.$5f)(o.version)}function i(o){return o?(0,w.$5f)(o.path)&&(0,w.$5f)(o.scheme):!1}}),define(ae[81],ce([0,1,17,6,30,15,7,35,138,2,23,14,5,20,55,88,13,8,159,16,33,48,71,12,4,9,24,3,66,52,18,28,188]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c,d,i,o,n,s,t,r,a,y,v,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$qq=e.$pq=e.$oq=e.Translations=void 0,e.$rq=Q;var k;(function(Y){function W(J,H){if(J===H)return!0;const B=Object.keys(J),ie=new Set;for(const re of Object.keys(H))ie.add(re);if(B.length!==ie.size)return!1;for(const re of B){if(J[re]!==H[re])return!1;ie.delete(re)}return ie.size===0}Y.equals=W})(k||(e.Translations=k={})),e.$oq=(0,n.$ri)("IExtensionsScannerService");let D=class extends $.$Uc{constructor(W,J,H,B,ie,re,he,te,V,z,O,M){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=J,this.r=H,this.s=B,this.t=ie,this.u=re,this.w=he,this.y=te,this.z=V,this.C=z,this.D=O,this.F=M,this.g=this.B(new r.$be),this.onDidChangeCache=this.g.event,this.h=(0,u.$5g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,c.$Ap)(this.w,this.y)),this.G}async scanAllExtensions(W,J,H){const[B,ie]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(J)]),re=H?await this.scanExtensionsUnderDevelopment(W,[...B,...ie]):[];return this.L(B,ie,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const J=[];J.push(this.M(!!W.useCache,W.language)),J.push(this.N(W.language,!!W.checkControlFile));const[H,B]=await Promise.all(J);return this.J([...H,...B],0,W,!1)}async scanUserExtensions(W){const J=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const H=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(J,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,H,W.productVersion??this.R()),ie=W.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let re;try{re=await ie.scanExtensions(B)}catch(he){if(he instanceof y.$jq&&he.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),re=await ie.scanExtensions(B);else throw he}return re=await this.J(re,1,W,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(W,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===E.Schemas.file).map(async B=>{const ie=await this.P(B,!1,1,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(he=>(he.type=J.find(te=>(0,c.$pp)(te.identifier,he.identifier))?.type??he.type,this.n.validate(he,ie)))}))).flat();return this.J(H,"development",W,!0)}return[]}async scanExistingExtension(W,J,H){const B=await this.P(W,!1,J,!0,H.language,!0,void 0,H.productVersion??this.R()),ie=await this.n.scanExtension(B);return!ie||!H.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(W,J,H){const B=await this.P(W,!1,J,!0,H.language,!0,void 0,H.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(B);return this.J(ie,J,H,!0)}async scanMultipleExtensions(W,J,H){const B=[];return await Promise.all(W.map(async ie=>{const re=await this.scanOneOrMultipleExtensions(ie,J,H);B.push(...re)})),this.J(B,J,H,!0)}async scanMetadata(W){const J=(0,u.$5g)(W,"package.json"),H=(await this.w.readFile(J)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(W,J){const H=(0,u.$5g)(W,"package.json"),B=(await this.w.readFile(H)).value.toString(),ie=JSON.parse(B);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,ie.__metadata={...ie.__metadata,...J},await this.w.writeFile((0,u.$5g)(W,"package.json"),j.$Ce.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof y.$jq&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$Ce.fromString(JSON.stringify([])))}catch(J){(0,o.$cl)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,J,H,B){return H.includeAllVersions||(W=this.L(J===0?W:void 0,J===1?W:void 0,J==="development"?W:void 0,await this.getTargetPlatform(),B)),H.includeInvalid||(W=W.filter(ie=>ie.isValid)),W.sort((ie,re)=>{const he=b.$oc(ie.location.fsPath),te=b.$oc(re.location.fsPath);return he<te?-1:he>te?1:0})}L(W,J,H,B,ie){const re=(te,V,z)=>{if(te.isValid&&!V.isValid)return!1;if(te.isValid===V.isValid){if(ie&&l.gt(te.manifest.version,V.manifest.version))return this.y.debug(`Skipping extension ${V.location.path} with lower version ${V.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(l.eq(te.manifest.version,V.manifest.version)){if(te.type===0)return this.y.debug(`Skipping extension ${V.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===B)return this.y.debug(`Skipping extension ${V.location.path} from different target platform ${V.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${te.location.path} with ${V.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${V.location.path}.`),!0},he=new d.$Om;return W?.forEach(te=>{const V=he.get(te.identifier.id);(!V||re(V,te,!1))&&he.set(te.identifier.id,te)}),J?.forEach(te=>{const V=he.get(te.identifier.id);if(!V&&W&&te.type===0){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!V||re(V,te,!1))&&he.set(te.identifier.id,te)}),H?.forEach(te=>{const V=he.get(te.identifier.id);(!V||re(V,te,!0))&&he.set(te.identifier.id,te),he.set(te.identifier.id,te)}),[...he.values()]}async M(W,J){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0,this.R()),ie=await(W&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(W,J){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const B=J?await this.O():{},ie=[],re=h.URI.file(b.$ic(b.$kc(E.$Lg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of H){const V=B[te.name]||"marketplace";switch(V){case"disabled":break;case"marketplace":ie.push((0,u.$5g)(re,te.name));break;default:ie.push(h.URI.file(V));break}}const he=await Promise.all(ie.map(async te=>this.n.scanExtension(await this.P(te,!1,0,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",he.length),(0,R.$Hb)(he)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,J,H,B,ie,re,he,te){const V=await this.f(ie??m.$w),z=await this.Q(W),O=J&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=O?await this.Q(O):void 0;return new T(W,z,O,M,J,he,H,B,re,te.version,te.date,this.C.commit,!this.z.isBuilt,ie,V)}async Q(W){try{const J=await this.w.stat(W);if(typeof J.mtime=="number")return J.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$pq=D,e.$pq=D=Ee([X(4,v.$xl),X(5,y.$kq),X(6,o.$Xk),X(7,s.$Xj),X(8,f.$yi),X(9,t.$ek),X(10,P.$vl),X(11,n.$qi)],D);class T{constructor(W,J,H,B,ie,re,he,te,V,z,O,M,q,x,K){this.location=W,this.mtime=J,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=B,this.profile=ie,this.profileScanOptions=re,this.type=he,this.excludeObsolete=te,this.validate=V,this.productVersion=z,this.productDate=O,this.productCommit=M,this.devMode=q,this.language=x,this.translations=K}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,J){return(0,u.$Xg)(W.location,J.location)&&W.mtime===J.mtime&&(0,u.$Xg)(W.applicationExtensionslocation,J.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&W.profile===J.profile&&L.$2n(W.profileScanOptions,J.profileScanOptions)&&W.type===J.type&&W.excludeObsolete===J.excludeObsolete&&W.validate===J.validate&&W.productVersion===J.productVersion&&W.productDate===J.productDate&&W.productCommit===J.productCommit&&W.devMode===J.devMode&&W.language===J.language&&k.equals(W.translations,J.translations)}}e.$qq=T;let F=class extends $.$Uc{constructor(W,J,H,B,ie){super(),this.f=W,this.g=J,this.h=H,this.j=B,this.m=ie}async scanExtensions(W){const J=W.profile?await this.r(W):await this.n(W);let H={};if(W.excludeObsolete&&W.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(B)}catch{}return(0,p.$fg)(H)?J:J.filter(B=>!H[c.$qp.create(B).toString()])}async n(W){const J=await this.j.resolve(W.location);if(!J.children?.length)return[];const H=await Promise.all(J.children.map(async B=>{if(!B.isDirectory||W.type===1&&(0,u.$2g)(B.resource).indexOf(".")===0)return null;const ie=new T(B.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ie)}));return(0,R.$Hb)(H).sort((B,ie)=>B.location.path<ie.location.path?-1:1)}async r(W){let J=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){J=J.filter(B=>!B.metadata?.isApplicationScoped);const H=await this.s(W.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,W);J.push(...H)}return J}async s(W,J,H){const B=await this.g.scanProfileExtensions(W,H.profileScanOptions);if(!B.length)return[];const ie=await Promise.all(B.map(async re=>{if(J(re)){const he=new T(re.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(he,re.metadata)}return null}));return(0,R.$Hb)(ie)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,u.$5g)(W.location,"package.json"))){const J=await this.scanExtension(W);return J?[J]:[]}else return await this.scanExtensions(W)}catch(J){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,A.$0)(J)),[]}}async scanExtension(W,J){try{let H=await this.scanExtensionManifest(W.location);if(H){H.publisher||(H.publisher=d.$Im),J=J??H.__metadata,delete H.__metadata;const B=(0,c.$up)(H.publisher,H.name),ie=J?.id?{id:B,uuid:J.id}:{id:B},re=J?.isSystem?0:W.type,he=re===0||!!J?.isBuiltin;H=await this.t(W.location,H,T.createNlsConfiguration(W));const te={type:re,identifier:ie,manifest:H,location:W.location,isBuiltin:he,targetPlatform:J?.targetPlatform??"undefined",publisherDisplayName:J?.publisherDisplayName,metadata:J,isValid:!0,validations:[]};return W.validate?this.validate(te,W):te}}catch(H){W.type!==0&&this.m.error(H)}return null}validate(W,J){let H=!0;const B=(0,i.$Fp)(J.productVersion,J.productDate,J.location,W.manifest,W.isBuiltin);for(const[ie,re]of B)ie===w.default.Error&&(H=!1,this.m.error(this.z(J.location,re)));return W.isValid=H,W.validations=B,W}async scanExtensionManifest(W){const J=(0,u.$5g)(W,"package.json");let H;try{H=(await this.j.readFile(J)).value.toString()}catch(ie){return(0,o.$cl)(ie)!==1&&this.m.error(this.z(W,(0,g.localize)(0,null,J.path,ie.message))),null}let B;try{B=JSON.parse(H)}catch{const re=[];(0,I.$En)(H,re);for(const he of re)this.m.error(this.z(W,(0,g.localize)(1,null,J.path,he.offset,he.length,(0,C.$mq)(he.error))));return null}return(0,I.$Nn)(B)!=="object"?(this.m.error(this.z(W,(0,g.localize)(2,null,J.path))),null):B}async t(W,J,H){const B=await this.u(W,J,H);if(B)try{const ie=[],re=await this.w(B.default,ie);if(ie.length>0)return ie.forEach(te=>{this.m.error(this.z(W,(0,g.localize)(3,null,B.default?.path,(0,C.$mq)(te.error))))}),J;if((0,I.$Nn)(B)!=="object")return this.m.error(this.z(W,(0,g.localize)(4,null,B.default?.path))),J;const he=B.values||Object.create(null);return(0,S.$nq)(this.m,J,he,re)}catch{}return J}async u(W,J,H){const B=(0,u.$5g)(W,"package.nls.json"),ie=(V,z)=>{z.forEach(O=>{this.m.error(this.z(W,(0,g.localize)(5,null,V?.path,(0,C.$mq)(O.error))))})},re=V=>{this.m.error(this.z(W,(0,g.localize)(6,null,V?.path)))},he=`${J.publisher}.${J.name}`,te=H.translations[he];if(te)try{const V=h.URI.file(te),z=(await this.j.readFile(V)).value.toString(),O=[],M=(0,I.$En)(z,O);return O.length>0?(ie(V,O),{values:void 0,default:B}):(0,I.$Nn)(M)!=="object"?(re(V),{values:void 0,default:B}):{values:M.contents?M.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let z;try{z=await this.y(W,H)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const O=(await this.j.readFile(z.localized)).value.toString(),M=[],q=(0,I.$En)(O,M);return M.length>0?(ie(z.localized,M),{values:void 0,default:z.original}):(0,I.$Nn)(q)!=="object"?(re(z.localized),{values:void 0,default:z.original}):{values:q,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(W,J){if(W)try{const H=(await this.j.readFile(W)).value.toString();return(0,I.$En)(H,J)}catch{}}y(W,J){return new Promise((H,B)=>{const ie=re=>{const he=(0,u.$5g)(W,`package.nls.${re}.json`);this.j.exists(he).then(te=>{te&&H({localized:he,original:(0,u.$5g)(W,"package.nls.json")});const V=re.lastIndexOf("-");V===-1?H({localized:(0,u.$5g)(W,"package.nls.json"),original:null}):(re=re.substring(0,V),ie(re))})};if(J.devMode||J.pseudo||!J.language)return H({localized:(0,u.$5g)(W,"package.nls.json"),original:null});ie(J.language)})}z(W,J){return`[${W.path}]: ${J}`}};F=Ee([X(1,y.$kq),X(2,P.$vl),X(3,o.$Xk),X(4,s.$Xj)],F);let U=class extends F{constructor(W,J,H,B,ie,re,he){super(J,B,ie,re,he),this.G=W,this.H=H,this.D=this.B(new N.$ph(3e3)),this.F=this.B(new r.$be),this.onDidChangeCache=this.F.event}async scanExtensions(W){const J=this.M(W),H=await this.I(J);if(this.C=W,H&&H.input&&T.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),H.result.map(ie=>(ie.location=h.URI.revive(ie.location),ie));const B=await super.scanExtensions(W);return await this.J(J,{input:W,result:B}),B}async I(W){try{const J=await this.j.readFile(W),H=JSON.parse(J.value.toString());return{result:H.result,input:(0,a.$1h)(H.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",W.path,(0,A.$0)(J))}return null}async J(W,J){try{await this.j.writeFile(W,j.$Ce.fromString(JSON.stringify(J)))}catch(H){this.m.debug("Error while writing the extension cache file:",W.path,(0,A.$0)(H))}}async L(){if(!this.C)return;const W=this.M(this.C),J=await this.I(W);if(!J)return;const H=J.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$2n(B,H))try{this.m.info("Invalidating Cache",H,B),await this.j.del(W),this.F.fire()}catch(ie){this.m.error(ie)}}M(W){const J=this.N(W);return this.h.extUri.joinPath(J.cacheHome,W.type===0?d.$Hm:d.$Gm)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(W.location,J.extensionsResource))??this.G:this.H.defaultProfile}};U=Ee([X(2,v.$xl),X(3,y.$kq),X(4,P.$vl),X(5,o.$Xk),X(6,s.$Xj)],U);function Q(Y,W){const J=(0,c.$sp)(Y.manifest.publisher,Y.manifest.name);return{id:J,identifier:new d.$Mm(J),isBuiltin:Y.type===0,isUserBuiltin:Y.type===1&&Y.isBuiltin,isUnderDevelopment:W,extensionLocation:Y.location,uuid:Y.identifier.uuid,targetPlatform:Y.targetPlatform,publisherDisplayName:Y.publisherDisplayName,...Y.manifest}}class G extends D{constructor(W,J,H,B,ie,re,he,te,V,z,O,M){super(W,J,(0,u.$5g)(H,".vscode-oss-dev","extensions","control.json"),B,ie,re,he,te,V,z,O,M),this.S=(async()=>{if(m.$z)try{const q=await this.w.readFile(h.URI.file(m.$z));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$sq=G}),define(ae[251],ce([0,1,67,6,38,3,2,23,14,31,9,18]),function(ne,e,R,N,L,j,A,I,C,$,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;let m=class extends A.$Uc{constructor(l,w){super(),this.b=l,this.f=w,this.a=new N.$xh(5)}async postUninstall(l){const w=this.g(l,"uninstall");w&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(p){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(p)}}));try{await $.Promises.rm(this.m(l))}catch(p){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(p)}}g(l,w){const p=`vscode:${w}`;if(l.location.scheme===I.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[p]=="string"){const h=l.manifest.scripts[p].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${p} should be a node script`),null):{script:(0,C.$kc)(l.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(l,w,p,h,g){return new Promise((f,c)=>{const d=this.j(l,w,p,g);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):f(void 0)};d.on("error",n=>{o((0,L.$cj)(n)||"Unknown")}),d.on("exit",(n,s)=>{o(n?`post-${w} process exited with code ${n}`:void 0)}),h&&(i=setTimeout(()=>{i=null,d.kill(),c("timed out")},5e3))})}j(l,w,p,h){const g={silent:!0,execArgv:void 0},f=(0,R.fork)(l,[`--type=extension-post-${w}`,...p],g);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const c=j.Event.fromNodeEventEmitter(f.stdout,"data"),d=j.Event.fromNodeEventEmitter(f.stderr,"data");c(n=>this.f.info(h.identifier.id,h.manifest.version,`post-${w}`,n)),d(n=>this.f.error(h.identifier.id,h.manifest.version,`post-${w}`,n));const i=j.Event.any(j.Event.map(c,n=>({data:`%c${n}`,format:[""]})),j.Event.map(d,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(h.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}m(l){return(0,C.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$uq=m,e.$uq=m=Ee([X(0,b.$xl),X(1,E.$Xj)],m)}),define(ae[113],ce([0,1,6,15,26,38,7,3,54,2,34,23,14,20,55,13,8,32,31,70,160,95,16,250,29,33,52,81,231,251,189,221,232,71,12,4,9,24,22,28,18]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c,d,i,o,n,s,t,r,a,y,v,P,S,k,D,T,F,U,Q,G,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=e.$zq=e.$yq=void 0,e.$yq=(0,T.$si)(n.$4o);const W=".vsctmp";let J=class extends o.$fq{constructor(V,z,O,M,q,x,K,ee,_,Z,se,ue){super(V,z,se,O,Z,ue),this.eb=q,this.fb=x,this.gb=K,this.hb=_,this.db=new Map,this.qb=new E.$Cc;const ge=this.B(ee.createInstance(y.$uq));this.ab=this.B(ee.createInstance(H,$e=>ge.postUninstall($e))),this.bb=this.B(new P.$wq(ue,_,se,this,this.F)),this.cb=this.B(ee.createInstance(a.$tq));const fe=this.B(new S.$xq(this,this.eb,ue,x,se,_,O));this.B(fe.onDidChangeExtensionsByAnotherSource($e=>this.pb($e))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$Ap)(this.hb,this.F)),this.ib}async zip(V){this.F.trace("ExtensionManagementService#zip",V.identifier.id);const z=await this.ob(V),O=await(0,f.zip)((0,u.$5g)(this.cb.extensionsDownloadDir,(0,h.$Ng)()).fsPath,z);return p.URI.file(O)}async unzip(V){return this.F.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const{location:z,cleanup:O}=await this.kb(V),M=m.$lc(z.fsPath);try{return await(0,v.$vq)(M)}finally{await O()}}getInstalled(V,z=this.H.defaultProfile.extensionsResource,O={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(V??null,z,O)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(V){return this.ab.scanUserExtensionAtLocation(V)}async install(V,z={}){this.F.trace("ExtensionManagementService#install",V.toString());const{location:O,cleanup:M}=await this.kb(V);try{const q=await(0,v.$vq)(m.$lc(O.fsPath)),x=(0,s.$up)(q.publisher,q.name);if(q.engines&&q.engines.vscode&&!(0,k.$Hp)(q.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(0,null,x,this.G.version));const ee=(await this.I([{manifest:q,extension:O,options:z}])).find(({identifier:_})=>(0,s.$pp)(_,{id:x}));if(ee?.local)return ee.local;throw ee?.error?ee.error:(0,o.$hq)(new Error(`Unknown error while installing extension ${x}`))}finally{await M()}}async installFromLocation(V,z){this.F.trace("ExtensionManagementService#installFromLocation",V.toString());const O=await this.ab.scanUserExtensionAtLocation(V);if(!O||!O.manifest.name||!O.manifest.version)throw new Error(`Cannot find a valid extension from the location ${V.toString()}`);return await this.tb([[O,{source:"resource"}]],z),this.F.info("Successfully installed extension",O.identifier.id,z.toString()),O}async installExtensionsFromProfile(V,z,O){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",V,z.toString(),O.toString());const M=(await this.getInstalled(1,z)).filter(q=>V.some(x=>(0,s.$pp)(x,q.identifier)));if(M.length){const q=await Promise.all(M.map(x=>this.ab.scanMetadata(x,z)));await this.tb(M.map((x,K)=>[x,q[K]]),O),this.F.info("Successfully installed extensions",M.map(x=>x.identifier.id),O.toString())}return M}async updateMetadata(V,z,O=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",V.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),V=await this.ab.updateMetadata(V,z,O),this.bb.invalidate(O),this.w.fire(V),V}async reinstallFromGallery(V){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",V.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1,null));const z=await this.getTargetPlatform(),[O]=await this.z.getExtensions([{...V.identifier,preRelease:V.preRelease}],{targetPlatform:z,compatible:!0},L.CancellationToken.None);if(!O)throw new Error(c.localize(2,null));await this.ab.setUninstalled(V);try{await this.ab.removeUninstalledExtension(V)}catch(M){throw new Error(c.localize(3,null,(0,j.$cj)(M)))}return this.installFromGallery(O)}$(V,z,O,M){return this.ab.copyExtension(V,z,O,M)}copyExtensions(V,z){return this.ab.copyExtensions(V,z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...V){return this.ab.setUninstalled(...V)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(V){this.F.error(V)}}async download(V,z,O){const{location:M}=await this.cb.download(V,z,!O);return M}async kb(V){if(V.scheme===b.Schemas.file)return{location:V,async cleanup(){}};this.F.trace("Downloading extension from",V.toString());const z=(0,u.$5g)(this.cb.extensionsDownloadDir,(0,h.$Ng)());return await this.gb.download(V,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.hb.del(z)}catch(M){this.F.error(M)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(V,z,O){if(p.URI.isUri(z))return new re(V,z,O,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const M=s.$qp.create(z).toString();let q=this.db.get(M);return q||(this.db.set(M,q=new ie(V,z,O,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),q.waitUntilTaskIsFinished().finally(()=>this.db.delete(M))),q}Z(V,z){return new he(V,z.profileLocation,this.fb)}async ob(V){const z=async M=>{let q=await g.Promises.readdir(M);q=q.map(ee=>m.$kc(M,ee));const x=await Promise.all(q.map(ee=>g.Promises.stat(ee)));let K=Promise.resolve([]);return x.forEach((ee,_)=>{const Z=q[_];ee.isFile()&&(K=K.then(se=>[...se,Z])),ee.isDirectory()&&(K=K.then(se=>z(Z).then(ue=>[...se,...ue])))}),K};return(await z(V.location.fsPath)).map(M=>({path:`extension/${m.$mc(V.location.fsPath,M)}`,localPath:M}))}async pb({added:V,removed:z}){if(z){const O=V&&this.D.extUri.isEqual(z.profileLocation,V.profileLocation)?z.extensions.filter(M=>V.extensions.every(q=>!(0,s.$pp)(q,M))):z.extensions;for(const M of O)this.F.info("Extensions removed from another source",M.id,z.profileLocation.toString()),this.u.fire({identifier:M,profileLocation:z.profileLocation})}if(V){const M=(await this.getInstalled(1,V.profileLocation)).filter(q=>V.extensions.some(x=>(0,s.$pp)(x,q.identifier)));this.s.fire(M.map(q=>(this.F.info("Extensions added from another source",q.identifier.id,V.profileLocation.toString()),{identifier:q.identifier,local:q,profileLocation:V.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(z=>this.qb.add(z)));const V=await this.hb.resolve(this.eb.userExtensionsLocation);for(const z of V.children??[])z.isDirectory&&this.qb.add(z.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(z=>this.sb(z)))}async sb(V){if(!V.affects(this.eb.userExtensionsLocation,1))return;const z=[];for(const O of V.rawAdded){if(this.qb.has(O)||!this.D.extUri.isEqual(this.D.extUri.dirname(O),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(O,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(O).startsWith(".")||!(await this.hb.stat(O)).isDirectory)continue;const M=await this.ab.scanUserExtensionAtLocation(O);M&&M.installedTimestamp===void 0&&(this.qb.add(O),z.push(M))}z.length&&(await this.tb(z.map(O=>[O,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(O=>O.identifier.id)))}async tb(V,z){const O=V.map(M=>M[0]);await this.ub(O),await this.fb.addExtensionsToProfile(V,z),this.s.fire(O.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:z})))}async ub(V){const z=await this.ab.getUninstalledExtensions();for(const O of V){const M=s.$qp.create(O);z[M.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",M.id),await this.ab.setInstalled(M),this.F.info("Removed the extension from uninstalled list:",M.id))}}};e.$zq=J,e.$zq=J=Ee([X(0,n.$1o),X(1,Q.$Wl),X(2,F.$Xj),X(3,i.$zi),X(4,r.$oq),X(5,t.$kq),X(6,d.$Fo),X(7,T.$qi),X(8,D.$Xk),X(9,U.$ek),X(10,G.$vl),X(11,Y.$xl)],J);let H=class extends $.$Uc{constructor(V,z,O,M,q,x){super(),this.j=V,this.m=z,this.n=O,this.s=M,this.t=q,this.u=x,this.h=this.B(new I.$be),this.onExtract=this.h.event,this.c=(0,u.$5g)(this.n.userExtensionsLocation,".obsolete"),this.g=new R.$yh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(V,z,O){const M={includeInvalid:!0,profileLocation:z,productVersion:O};let q=[];return V===null||V===0?q.push(...await this.n.scanAllExtensions({includeInvalid:!0},M,!1)):V===1&&q.push(...await this.n.scanUserExtensions(M)),q=V!==null?q.filter(x=>x.type===V):q,Promise.all(q.map(x=>this.F(x)))}async scanAllUserExtensions(V){const z=await this.n.scanUserExtensions({includeAllVersions:!V,includeInvalid:!0});return Promise.all(z.map(O=>this.F(O)))}async scanUserExtensionAtLocation(V){try{const z=await this.n.scanExistingExtension(V,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(V,z,O,M,q){const x=V.toString(),K=p.URI.file(m.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$Ng)()}`)),ee=p.URI.file(m.$kc(this.n.userExtensionsLocation.fsPath,x));let _=await this.m.exists(ee);if(_&&M){try{await this.y(V.id,ee,"removeExisting")}catch{throw new n.$2o(c.localize(4,null,ee.fsPath,V.id),n.ExtensionManagementErrorCode.Delete)}_=!1}if(_)await this.n.updateMetadata(ee,O);else try{try{this.u.trace(`Started extracting the extension from ${z} to ${ee.fsPath}`),await(0,f.$dq)(z,K.fsPath,{sourcePath:"extension",overwrite:!0},q),this.u.info(`Extracted extension to ${ee}:`,V.id)}catch(Z){let se=n.ExtensionManagementErrorCode.Extract;throw Z instanceof f.$bq&&(Z.type==="CorruptZip"?se=n.ExtensionManagementErrorCode.CorruptZip:Z.type==="Incomplete"&&(se=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$2o(Z.message,se)}await this.n.updateMetadata(K,O);try{this.u.trace(`Started renaming the extension from ${K.fsPath} to ${ee.fsPath}`),await this.C(K.fsPath,ee.fsPath),this.u.info("Renamed to",ee.fsPath)}catch(Z){if(Z.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",V.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(Z)}. Deleted from extracted location`,K),Z}this.h.fire(ee)}catch(Z){try{await this.m.del(K,{recursive:!0})}catch{}throw Z}return this.D(ee,1)}async scanMetadata(V,z){return z?(await this.w(V,z))?.metadata:this.n.scanMetadata(V.location)}async w(V,z){return(await this.s.scanProfileExtensions(z)).find(M=>(0,s.$pp)(M.identifier,V.identifier))}async updateMetadata(V,z,O){return O?await this.s.updateMetadata([[V,z]],O):await this.n.updateMetadata(V.location,z),this.D(V.location,V.type,O)}getUninstalledExtensions(){return this.z()}async setUninstalled(...V){const z=V.map(O=>s.$qp.create(O));await this.z(O=>z.forEach(M=>{O[M.toString()]=!0,this.u.info("Marked extension as uninstalled",M.toString())}))}async setInstalled(V){await this.z(z=>delete z[V.toString()])}async removeExtension(V,z){if(this.t.extUri.isEqualOrParent(V.location,this.n.userExtensionsLocation))return this.y(V.identifier.id,V.location,z)}async removeUninstalledExtension(V){await this.removeExtension(V,"uninstalled"),await this.z(z=>delete z[s.$qp.create(V).toString()])}async copyExtension(V,z,O,M){const q=await this.w(V,z),x=await this.w(V,O);if(M={...q?.metadata,...M},x)if(this.t.extUri.isEqual(x.location,V.location))await this.s.updateMetadata([[V,{...x.metadata,...M}]],O);else{const K=await this.D(x.location,V.type,O);await this.s.removeExtensionFromProfile(K,O),await this.s.addExtensionsToProfile([[V,{...x.metadata,...M}]],O)}else await this.s.addExtensionsToProfile([[V,M]],O);return this.D(V.location,V.type,O)}async copyExtensions(V,z,O){const M=await this.scanExtensions(1,V,O),q=await Promise.all(M.filter(x=>!x.isApplicationScoped).map(async x=>[x,await this.scanMetadata(x,V)]));await this.s.addExtensionsToProfile(q,z)}async y(V,z,O){this.u.trace(`Deleting ${O} extension from disk`,V,z.fsPath);const M=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,C.$fj)((0,h.$Ng)()).toString(16)}${W}`);await this.C(z.fsPath,M.fsPath),await this.m.del(M,{recursive:!0}),this.u.info(`Deleted ${O} extension from disk`,V,z.fsPath)}async z(V){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(M){if((0,D.$cl)(M)!==1)throw M}let O={};if(z)try{O=JSON.parse(z)}catch{}return V&&(V(O),Object.keys(O).length?await this.m.writeFile(this.c,N.$Ce.fromString(JSON.stringify(O))):await this.m.del(this.c)),O})}async C(V,z){try{await g.Promises.rename(V,z,2*60*1e3)}catch(O){throw new n.$2o(O.message||c.localize(5,null,V,z),O.code||n.ExtensionManagementErrorCode.Rename)}}async D(V,z,O){if(O){const q=(await this.n.scanUserExtensions({profileLocation:O})).find(x=>this.t.extUri.isEqual(x.location,V));if(q)return this.F(q)}else{const M=await this.n.scanExistingExtension(V,z,{includeInvalid:!0});if(M)return this.F(M)}throw new Error(c.localize(6,null,V.path))}async F(V){const z=await this.m.resolve(V.location);let O,M;return z.children&&(O=z.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,M=z.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource),{identifier:V.identifier,type:V.type,isBuiltin:V.isBuiltin||!!V.metadata?.isBuiltin,location:V.location,manifest:V.manifest,targetPlatform:V.targetPlatform,validations:V.validations,isValid:V.isValid,readmeUrl:O,changelogUrl:M,publisherDisplayName:V.metadata?.publisherDisplayName,publisherId:V.metadata?.publisherId||null,isApplicationScoped:!!V.metadata?.isApplicationScoped,isMachineScoped:!!V.metadata?.isMachineScoped,isPreReleaseVersion:!!V.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!V.metadata?.hasPreReleaseVersion,preRelease:!!V.metadata?.preRelease,installedTimestamp:V.metadata?.installedTimestamp,updated:!!V.metadata?.updated,pinned:!!V.metadata?.pinned,isWorkspaceScoped:!1,source:V.metadata?.source??(V.identifier.uuid?"gallery":"vsix")}}async G(){const V=await this.getUninstalledExtensions();if(Object.keys(V).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(V));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const q of z)V[s.$qp.create(q).toString()]||O.add(q.identifier.id.toLowerCase());try{const q=(0,s.$vp)(z,x=>x.identifier);await R.Promises.settled(q.map(async x=>{const K=x.sort((ee,_)=>l.rcompare(ee.manifest.version,_.manifest.version))[0];O.has(K.identifier.id.toLowerCase())||await this.j(await this.F(K))}))}catch(q){this.u.error(q)}const M=z.filter(q=>q.metadata&&V[s.$qp.create(q).toString()]);await Promise.allSettled(M.map(q=>this.removeUninstalledExtension(q)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let V;try{V=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,D.$cl)(z)!==1&&this.u.error(z);return}if(V?.children)try{await Promise.allSettled(V.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(O){(0,D.$cl)(O)!==1&&this.u.error(O)}}}))}catch{}}};e.$Aq=H,e.$Aq=H=Ee([X(1,D.$Xk),X(2,r.$oq),X(3,t.$kq),X(4,G.$vl),X(5,F.$Xj)],H);class B extends o.$iq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,w.$_f)(this.options.operation)?this.l:this.options.operation}constructor(V,z,O,M,q,x,K,ee,_,Z){super(),this.manifest=V,this.identifier=z,this.source=O,this.options=M,this.m=q,this.n=x,this.o=K,this.p=ee,this.q=_,this.s=Z,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(V){const[z,O]=await this.x(V);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,O]],this.j,!z.isValid),z}async u({zipPath:V,key:z,metadata:O},M,q){let x=await this.v(z);return x?x=await this.m.updateMetadata(x,O):(this.s.trace("Extracting extension...",z.id),x=await this.m.extractUserExtension(z,V,O,M,q),this.s.info("Extracting extension completed.",z.id)),x}async v(V){return await this.w(V)?(this.s.trace("Removing the extension from uninstalled list:",V.id),await this.m.setInstalled(V),this.s.info("Removed the extension from uninstalled list:",V.id),(await this.m.scanAllUserExtensions(!0)).find(M=>s.$qp.create(M).equals(V))):void 0}async w(V){return!!(await this.m.getUninstalledExtensions())[V.toString()]}}class ie extends B{constructor(V,z,O,M,q,x,K,ee,_,Z,se){super(V,z.identifier,z,O,q,x,K,ee,_,Z),this.y=z,this.z=M,this.A=se}async x(V){let z;try{z=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(q){throw new n.$2o(q,n.ExtensionManagementErrorCode.Scanning)}const O=z.find(q=>(0,s.$pp)(q.identifier,this.y.identifier));O&&(this.l=3);const M={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:O?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??O?.pinned,preRelease:(0,w.$$f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||O?.preRelease,source:"gallery"};if(O&&O.type!==0&&O.manifest.version===this.y.version)try{return[await this.m.updateMetadata(O,M),M]}catch(q){throw new n.$2o((0,A.$0)(q),n.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(M,V)}catch(q){if(q instanceof n.$2o&&(q.code===n.ExtensionManagementErrorCode.CorruptZip||q.code===n.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const x=await this.C(M,V);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),x}catch(x){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),x}}else throw q}}async C(V,z){const{location:O,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.D(O.fsPath),[await this.u({zipPath:O.fsPath,key:s.$qp.create(this.y),metadata:V},!1,z),V]}catch(q){try{await this.z.delete(O)}catch(x){this.s.warn("Error while deleting the downloaded file",O.toString(),(0,A.$0)(x))}throw q}}async D(V){try{await(0,v.$vq)(V)}catch(z){throw new n.$2o((0,o.$gq)(z).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Bq=ie;class re extends B{constructor(V,z,O,M,q,x,K,ee,_,Z){super(V,{id:(0,s.$up)(V.publisher,V.name)},z,O,q,x,K,ee,_,Z),this.y=z,this.z=M}async h(V){const z=await super.h(V);return this.C(z,V),z}async x(V){const z=new s.$qp(this.identifier,this.manifest.version),M=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(K=>(0,s.$pp)(this.identifier,K.identifier)),q={isApplicationScoped:this.options.isApplicationScoped||M?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??M?.pinned,source:"vsix"};if(M)if(this.l=3,z.equals(new s.$qp(M.identifier,M.manifest.version)))try{await this.m.removeExtension(M,"existing")}catch{throw new Error(c.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&l.gt(M.manifest.version,this.manifest.version)&&await this.m.setUninstalled(M);else{const K=await this.v(z);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(c.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:m.$lc(this.y.fsPath),key:z,metadata:q},!0,V),q]}async C(V,z){try{let[O]=await this.z.getExtensions([{id:V.identifier.id,version:V.manifest.version}],z);if(O||([O]=await this.z.getExtensions([{id:V.identifier.id}],z)),O){const M={id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,hasPreReleaseVersion:V.hasPreReleaseVersion||O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(V,M,this.options.profileLocation)}}catch{}}}class he extends o.$iq{constructor(V,z,O){super(),this.extension=V,this.j=z,this.k=O}async h(V){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[252],ce([0,1,9,18,28,22,52,12,16,8]),function(ne,e,R,N,L,j,A,I,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CQ=void 0;let E=class extends A.$lq{constructor(m,u,l,w,p,h){super($.URI.file(m.extensionsPath),u,l,w,p,h)}};e.$CQ=E,e.$CQ=E=Ee([X(0,C.$zi),X(1,I.$Xk),X(2,N.$xl),X(3,L.$vl),X(4,j.$Wl),X(5,R.$Xj)],E)}),define(ae[253],ce([0,1,8,16,52,81,12,4,9,24,28,18]),function(ne,e,R,N,L,j,A,I,C,$,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;let m=class extends j.$sq{constructor(l,w,p,h,g,f,c,d){super(R.URI.file(g.builtinExtensionsPath),R.URI.file(g.extensionsPath),g.userHome,l.defaultProfile,l,w,p,h,g,f,c,d)}};e.$Lcc=m,e.$Lcc=m=Ee([X(0,b.$xl),X(1,L.$kq),X(2,A.$Xk),X(3,C.$Xj),X(4,N.$zi),X(5,$.$ek),X(6,E.$vl),X(7,I.$qi)],m)}),define(ae[19],ce([0,1,6,3,2,98,13,69,4,18]),function(ne,e,R,N,L,j,A,I,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vp=e.$Up=e.$Tp=void 0,e.$Wp=u,e.$Yp=w,e.$1p=h,e.$Tp="__$__isNewStorageMarker",e.$Up="__$__targetStorageMarker",e.$Vp=(0,C.$ri)("storageService");var E;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var b;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function u(g){const f=g.get(e.$Up);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}class l extends L.$Uc{static{this.a=60*1e3}constructor(f={flushInterval:l.a}){super(),this.m=f,this.b=this.B(new N.$ee),this.c=this.B(new N.$ee),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$be),this.onWillSaveState=this.f.event,this.h=this.B(new R.$Dh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(f,c,d){return N.Event.filter(this.b.event,i=>i.scope===f&&(c===void 0||i.key===c),d)}n(){this.j.value=(0,R.$Hh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(f,c){const{key:d,external:i}=c;if(d===e.$Up){switch(f){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:d,target:this.J(f)[d],external:i})}w(f){this.f.fire({reason:f})}get(f,c,d){return this.P(c)?.get(f,d)}getBoolean(f,c,d){return this.P(c)?.getBoolean(f,d)}getNumber(f,c,d){return this.P(c)?.getNumber(f,d)}getObject(f,c,d){return this.P(c)?.getObject(f,d)}storeAll(f,c){this.y(()=>{for(const d of f)this.store(d.key,d.value,d.scope,d.target,c)})}store(f,c,d,i,o=!1){if((0,A.$bg)(c)){this.remove(f,d,o);return}this.y(()=>{this.z(f,d,i),this.P(d)?.set(f,c,o)})}remove(f,c,d=!1){this.y(()=>{this.z(f,c,void 0),this.P(c)?.delete(f,d)})}y(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,c){const d=[],i=this.J(f);for(const o of Object.keys(i))i[o]===c&&d.push(o);return d}z(f,c,d,i=!1){const o=this.J(c);typeof d=="number"?o[f]!==d&&(o[f]=d,this.P(c)?.set(e.$Up,JSON.stringify(o),i)):typeof o[f]=="number"&&(delete o[f],this.P(c)?.set(e.$Up,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(f){switch(f){case-1:return this.I;case 0:return this.G;default:return this.D}}L(f){const c=this.P(f);return c?u(c):Object.create(null)}isNew(f){return this.getBoolean(e.$Tp,f)===!0}async flush(f=E.NONE){this.f.fire({reason:f});const c=this.P(-1),d=this.P(0),i=this.P(1);switch(f){case E.NONE:await R.Promises.settled([c?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await R.Promises.settled([c?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,d=this.P(1)?.items??new Map;return h(f,c,d,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(f){return await this.flush(),this.P(f)?.optimize()}async switch(f,c){return this.w(E.NONE),(0,$.$wl)(f)?this.R(f,c):this.S(f,c)}M(f,c){return!(f.id===c.id||w(c)&&w(f))}N(f,c,d){this.y(()=>{const i=new Set;for(const[o,n]of f)i.add(o),c.get(o)!==n&&this.u(d,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.u(d,{key:o,external:!0})})}}e.$Xp=l;function w(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class p extends l{constructor(){super(),this.U=this.B(new I.$Rp(new I.$Sp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$Rp(new I.$Sp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$Rp(new I.$Sp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(f=>this.u(1,f))),this.B(this.W.onDidChangeStorage(f=>this.u(0,f))),this.B(this.U.onDidChangeStorage(f=>this.u(-1,f)))}P(f){switch(f){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(f){return!1}}e.$Zp=p;async function h(g,f,c,d,i,o){const n=k=>{try{return JSON.parse(k)}catch{return k}},s=new Map,t=new Map;g.forEach((k,D)=>{s.set(D,k),t.set(D,n(k))});const r=new Map,a=new Map;f.forEach((k,D)=>{r.set(D,k),a.set(D,n(k))});const y=new Map,v=new Map;c.forEach((k,D)=>{y.set(D,k),v.set(D,n(k))}),console.group(d!==i?`Storage: Application (path: ${d})`:`Storage: Application & Profile (path: ${d}, default profile)`);const P=[];if(s.forEach((k,D)=>{P.push({key:D,value:k})}),console.table(P),console.groupEnd(),console.log(t),d!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const k=[];r.forEach((D,T)=>{k.push({key:T,value:D})}),console.table(k),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const S=[];y.forEach((k,D)=>{S.push({key:D,value:k})}),console.table(S),console.groupEnd(),console.log(v)}}),define(ae[114],ce([0,1,3,2,13,29,33,19]),function(ne,e,R,N,L,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJb=e.$wJb=void 0;let C=class extends N.$Uc{constructor(b,m){super(),this.a=new R.$be,this.onDidChangeEnablement=this.a.event,this.b=this.B(new $(b)),this.B(this.b.onDidChange(u=>this.a.fire({extensions:u,source:"storage"}))),this.B(m.onDidInstallExtensions(u=>u.forEach(({local:l,operation:w})=>{l&&w===4&&this.f(l.identifier)})))}async enableExtension(b,m){return this.f(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}async disableExtension(b,m){return this.c(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}getDisabledExtensions(){return this.h(j.$5o)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(b){const m=this.getDisabledExtensions();return m.every(u=>!(0,A.$pp)(u,b))?(m.push(b),this.g(m),!0):!1}f(b){const m=this.getDisabledExtensions();for(let u=0;u<m.length;u++){const l=m[u];if((0,A.$pp)(l,b))return m.splice(u,1),this.g(m),!0}return!1}g(b){this.j(j.$5o,b)}h(b){return this.b.get(b,0)}j(b,m){this.b.set(b,m,0)}};e.$wJb=C,e.$wJb=C=Ee([X(0,I.$Vp),X(1,j.$4o)],C);class $ extends N.$Uc{constructor(b){super(),this.c=b,this.a=Object.create(null),this.b=this.B(new R.$be),this.onDidChange=this.b.event,this.B(b.onDidChangeValue(0,void 0,this.B(new N.$Tc))(m=>this.f(m)))}get(b,m){let u;return m===0?((0,L.$bg)(this.a[b])&&(this.a[b]=this.g(b,m)),u=this.a[b]):u=this.g(b,m),JSON.parse(u)}set(b,m,u){const l=JSON.stringify(m.map(({id:p,uuid:h})=>({id:p,uuid:h})));this.g(b,u)!==l&&(u===0&&(m.length?this.a[b]=l:delete this.a[b]),this.h(b,m.length?l:void 0,u))}f(b){if(!(0,L.$bg)(this.a[b.key])&&this.g(b.key,b.scope)!==this.a[b.key]){const u=this.get(b.key,b.scope);delete this.a[b.key];const l=this.get(b.key,b.scope),w=u.filter(h=>!l.some(g=>(0,A.$pp)(h,g))),p=l.filter(h=>!u.some(g=>(0,A.$pp)(g,h)));(w.length||p.length)&&this.b.fire([...w,...p])}}g(b,m){return this.c.get(b,m,"[]")}h(b,m,u){m?this.c.store(b,m,u,1):this.c.remove(b,u)}}e.$xJb=$}),define(ae[254],ce([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,233,19,22,63]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$4p=re;const i=j.$o?"web":(0,b.$Wo)(j.$u,A.$fc),o="X-Market-Search-Activity-Id";var n;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...M){return String(M.reduce((q,x)=>q|x,0))}var t;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},v={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class P{constructor(q=v){this.d=q}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(q,x=this.d.pageSize){return new P({...this.d,pageNumber:q,pageSize:x})}withFilter(q,...x){const K=[...this.d.criteria,...x.length?x.map(ee=>({filterType:q,value:ee})):[{filterType:q}]];return new P({...this.d,criteria:K})}withSortBy(q){return new P({...this.d,sortBy:q})}withSortOrder(q){return new P({...this.d,sortOrder:q})}withFlags(...q){return new P({...this.d,flags:q.reduce((x,K)=>x|K,0)})}withAssetTypes(...q){return new P({...this.d,assetTypes:q})}withSource(q){return new P({...this.d,source:q})}get raw(){const{criteria:q,pageNumber:x,pageSize:K,sortBy:ee,sortOrder:_,flags:Z,assetTypes:se}=this.d;return{filters:[{criteria:q,pageNumber:x,pageSize:K,sortBy:ee,sortOrder:_}],assetTypes:se,flags:Z}}get searchText(){const q=this.d.criteria.filter(x=>x.filterType===t.SearchText)[0];return q&&q.value?q.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(q=>String(q.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function S(M,q){const x=(M||[]).filter(K=>K.statisticName===q)[0];return x?x.value:0}function k(M){const q="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(K=>K.assetType.indexOf(q)===0).reduce((K,ee)=>{const _=F(M,ee.assetType);return _&&K.push([ee.assetType.substring(q.length),_]),K},[])}function D(M){if(M.properties){const q=M.properties.filter(ee=>ee.key===r.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=q.filter(ee=>x.test(ee.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return F(M,r.Repository)}function T(M){return{uri:`${M.fallbackAssetUri}/${r.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${r.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function F(M,q){return M.files.filter(K=>K.assetType===q)[0]?{uri:`${M.assetUri}/${q}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${q}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function U(M,q){const x=M.properties?M.properties.filter(ee=>ee.key===q):[],K=x.length>0&&x[0].value;return K?K.split(",").map(ee=>(0,m.$tp)(ee)):[]}function Q(M){const q=M.properties?M.properties.filter(x=>x.key===a.Engine):[];return q.length>0&&q[0].value||""}function G(M){const q=M.properties?M.properties.filter(x=>x.key===a.PreRelease):[];return q.length>0&&q[0].value==="true"}function Y(M){const q=M.properties?M.properties.filter(K=>K.key===a.LocalizedLanguages):[],x=q.length>0&&q[0].value||"";return x?x.split(","):[]}function W(M){return M.properties?.find(q=>q.key===a.SponsorLink)?.value}function J(M){return M.properties?.find(q=>q.key===a.SupportLink)?.value}function H(M){return M.indexOf("preview")!==-1}function B(M){return M.targetPlatform?(0,b.$Vo)(M.targetPlatform):"undefined"}function ie(M){const q=(0,R.$Mb)(M.versions.map(B)),x=!!M.tags?.includes(b.$Qo),K=q.indexOf("web");return x?K===-1&&q.push("web"):K!==-1&&q.splice(K,1),q}function re(M,q){for(let x=0;x<M.length;x++){const K=M[x];if(K.version===M[x-1]?.version){let ee=x;if(B(K)===q)for(;ee>0&&M[ee-1].version===K.version;)ee--;ee!==x&&(M.splice(x,1),M.splice(ee,0,K))}}return M}function he(M,q,x){M.telemetryData={index:q,querySource:x,queryActivityId:M.queryContext?.[o]}}function te(M,q,x,K){const ee=M.versions[0],_={manifest:F(q,r.Manifest),readme:F(q,r.Details),changelog:F(q,r.Changelog),license:F(q,r.License),repository:D(q),download:T(q),icon:F(q,r.Icon),signature:F(q,r.Signature),coreTranslations:k(q)};return{identifier:{id:(0,m.$up)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:q.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(ee),description:M.shortDescription??"",installCount:S(M.statistics,"install"),rating:S(M.statistics,"averagerating"),ratingCount:S(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:x,assets:_,properties:{dependencies:U(q,a.Dependency),extensionPack:U(q,a.ExtensionPack),engine:Q(q),localizedLanguages:Y(q),targetPlatform:B(q),isPreReleaseVersion:G(q)},hasPreReleaseVersion:G(ee),hasReleaseVersion:!0,preview:H(M.flags),isSigned:!!_.signature,queryContext:K,supportLink:J(ee)}}let V=class{constructor(q,x,K,ee,_,Z,se,ue){this.k=x,this.l=K,this.n=ee,this.o=_,this.q=Z,this.u=se,this.w=ue;const ge=se.extensionsGallery,fe=ge?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=fe?ge.servicePPEUrl:ge?.serviceUrl,this.g=fe?void 0:ge?.searchUrl,this.h=ge?.controlUrl,this.j=(0,g.$3p)(se.version,se,this.n,this.w,this.q,q,this.o)}x(q=""){return`${this.d}${q}`}isEnabled(){return!!this.d}async getExtensions(q,x,K){const ee=N.CancellationToken.isCancellationToken(x)?{}:x,_=N.CancellationToken.isCancellationToken(x)?x:K,Z=[],se=[],ue=[],ge=[];let fe=!0;for(const ve of q){ve.uuid?se.push(ve.uuid):Z.push(ve.id);const Ce=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ce}),ve.version&&ge.push({id:ve.id,uuid:ve.uuid,version:ve.version}),fe=fe&&!!ve.hasPreRelease&&!Ce}if(!se.length&&!Z.length)return[];let $e=new P().withPage(1,q.length);se.length&&($e=$e.withFilter(t.ExtensionId,...se)),Z.length&&($e=$e.withFilter(t.ExtensionName,...Z)),(ee.queryAllVersions||fe)&&($e=$e.withFlags($e.flags,n.IncludeVersions)),ee.source&&($e=$e.withSource(ee.source));const{extensions:ye}=await this.z($e,{targetPlatform:ee.targetPlatform??i,includePreRelease:ue,versions:ge,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.u.version,date:this.u.date}},_);return ee.source&&ye.forEach((ve,Ce)=>he(ve,Ce,ee.source)),ye}async getCompatibleExtension(q,x,K,ee={version:this.u.version,date:this.u.date}){if((0,b.$Xo)(q.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(q,x,K))return q;const _=new P().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,q.identifier.uuid),{extensions:Z}=await this.z(_,{targetPlatform:K,compatible:!0,includePreRelease:x,productVersion:ee},N.CancellationToken.None);return Z[0]||null}async isExtensionCompatible(q,x,K,ee={version:this.u.version,date:this.u.date}){if(!(0,b.$Yo)(q.properties.targetPlatform,q.allTargetPlatforms,K)||!x&&q.properties.isPreReleaseVersion)return!1;let _=q.properties.engine;if(!_){const Z=await this.getManifest(q,N.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");_=Z.engines.vscode}return(0,u.$Hp)(_,ee.version,ee.date)}async y(q,x,K,ee,_,Z,se={version:this.u.version,date:this.u.date}){if(!(0,b.$Yo)(B(x),_,Z)||K!=="any"&&G(x)!==(K==="prerelease"))return!1;if(ee)try{const ue=await this.E(q,x);if(!(0,u.$Hp)(ue,se.version,se.date))return!1}catch(ue){return this.l.error(`Error while getting the engine for the version ${x.version}.`,(0,L.$0)(ue)),!1}return!0}async query(q,x){let K=q.text||"";const ee=q.pageSize??50;let _=new P().withPage(1,ee);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,$e,ye)=>(_=_.withFilter(t.Category,ye||$e),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,$e,ye)=>(_=_.withFilter(t.Tag,ye||$e),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(t.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),_=_.withFilter(t.SearchText,K)),_=_.withSortBy(0)):q.ids?_=_.withFilter(t.ExtensionId,...q.ids):q.names?_=_.withFilter(t.ExtensionName,...q.names):_=_.withSortBy(4),typeof q.sortBy=="number"&&(_=_.withSortBy(q.sortBy)),typeof q.sortOrder=="number"&&(_=_.withSortOrder(q.sortOrder)),q.source&&(_=_.withSource(q.source));const Z=async(fe,$e)=>{const{extensions:ye,total:ve}=await this.z(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!q.includePreRelease,productVersion:q.productVersion??{version:this.u.version,date:this.u.date}},$e);return ye.forEach((Ce,Ae)=>he(Ce,(fe.pageNumber-1)*fe.pageSize+Ae,q.source)),{extensions:ye,total:ve}},{extensions:se,total:ue}=await Z(_,x),ge=async(fe,$e)=>{if($e.isCancellationRequested)throw new L.$5;const{extensions:ye}=await Z(_.withPage(fe+1),$e);return ye};return{firstPage:se,total:ue,pageSize:_.pageSize,getPage:ge}}async z(q,x,K){const ee=q.flags;q.flags&n.IncludeLatestVersionOnly&&q.flags&n.IncludeVersions&&(q=q.withFlags(q.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(q.flags&n.IncludeLatestVersionOnly)&&!(q.flags&n.IncludeVersions)&&(q=q.withFlags(q.flags,n.IncludeLatestVersionOnly)),x.versions?.length&&(q=q.withFlags(q.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),q=q.withFlags(q.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:_,total:Z,context:se}=await this.B(q,K);if(!(q.flags&n.IncludeLatestVersionOnly)){const $e=[];for(const ye of _){const ve=await this.A(ye,x,se);ve&&$e.push(ve)}return{extensions:$e,total:Z}}const ge=[],fe=new Map;for(let $e=0;$e<_.length;$e++){const ye=_[$e],ve={id:(0,m.$up)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},Ce=(0,I.$$f)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(le=>(0,m.$pp)(le,ve))?.includePreRelease;if(x.compatible&&(0,b.$Xo)(ie(ye),x.targetPlatform))continue;const Ae=await this.A(ye,x,se);!Ae||Ae.properties.isPreReleaseVersion&&(!Ce||!Ae.hasReleaseVersion)||!Ae.properties.isPreReleaseVersion&&Ae.properties.targetPlatform!==x.targetPlatform&&Ae.hasPreReleaseVersion?fe.set(ye.extensionId,$e):ge.push([$e,Ae])}if(fe.size){const $e=new d.$0d,ye=new P().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,fe.size).withFilter(t.ExtensionId,...fe.keys()),{extensions:ve}=await this.z(ye,x,K);this.o.publicLog2("galleryService:additionalQuery",{duration:$e.elapsed(),count:fe.size});for(const Ce of ve){const Ae=fe.get(Ce.identifier.uuid);ge.push([Ae,Ce])}}return{extensions:ge.sort(($e,ye)=>$e[0]-ye[0]).map(([,$e])=>$e),total:Z}}async A(q,x,K){const ee={id:(0,m.$up)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},_=x.versions?.find(ge=>(0,m.$pp)(ge,ee))?.version,Z=(0,I.$$f)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(ge=>(0,m.$pp)(ge,ee))?.includePreRelease,se=ie(q),ue=re(q.versions,x.targetPlatform);if(x.compatible&&(0,b.$Xo)(se,x.targetPlatform))return null;for(let ge=0;ge<ue.length;ge++){const fe=ue[ge];if(!(_&&fe.version!==_)){if(await this.y((0,m.$up)(q.publisher.publisherName,q.extensionName),fe,Z?"any":"release",x.compatible,se,x.targetPlatform,x.productVersion))return te(q,fe,se,K);if(_&&fe.version===_)return null}}return _||x.compatible?null:te(q,q.versions[0],se)}async B(q,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");q=q.withFlags(q.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const K=await this.j,ee=JSON.stringify(q.raw),_={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Z=new d.$0d;let se,ue,ge=0;try{if(se=await this.k.request({type:"POST",url:this.g&&q.criteria.some($e=>$e.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:_},x),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:ge};const fe=await(0,h.$Op)(se);if(fe){const $e=fe.results[0],ye=$e.extensions,ve=$e.resultMetadata&&$e.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ge=ve&&ve.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ge,context:{[o]:se.res.headers.activityid}}}return{galleryExtensions:[],total:ge}}catch(fe){const $e=(0,L.$4)(fe)?b.ExtensionGalleryErrorCode.Cancelled:(0,L.$0)(fe).startsWith("XHR timeout")?b.ExtensionGalleryErrorCode.Timeout:b.ExtensionGalleryErrorCode.Failed;throw ue=new b.$3o((0,L.$0)(fe),$e),ue}finally{this.o.publicLog2("galleryService:query",{...q.telemetryData,requestBodySize:String(ee.length),duration:Z.elapsed(),success:!!se&&(0,h.$Kp)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:ue?.code,count:String(ge)})}}async reportStatistic(q,x,K,ee){if(!this.isEnabled())return;const _=j.$o?this.x(`/itemName/${q}.${x}/version/${K}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${q}/extensions/${x}/${K}/stats?statType=${ee}`),Z=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:Z};try{await this.k.request({type:"POST",url:_,headers:ue},N.CancellationToken.None)}catch{}}async download(q,x,K){this.l.trace("ExtensionGalleryService#download",q.identifier.id);const ee=(0,m.$xp)(q),_=new Date().getTime(),Z=$e=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:$e}),se=K===2?"install":K===3?"update":"",ue=se?{uri:`${q.assets.download.uri}${C.URI.parse(q.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${q.assets.download.fallbackUri}${C.URI.parse(q.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:q.assets.download,ge=q.queryContext?.[o]?{[o]:q.queryContext[o]}:void 0,fe=await this.D(q.identifier.id,ue,r.VSIX,ge?{headers:ge}:void 0);await this.q.writeFile(x,fe.stream),Z(new Date().getTime()-_)}async downloadSignatureArchive(q,x){if(!q.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",q.identifier.id);const K=await this.D(q.identifier.id,q.assets.signature,r.Signature);await this.q.writeFile(x,K.stream)}async getReadme(q,x){if(q.assets.readme){const K=await this.D(q.identifier.id,q.assets.readme,r.Details,{},x);return await(0,h.$Np)(K)||""}return""}async getManifest(q,x){if(q.assets.manifest){const K=await this.D(q.identifier.id,q.assets.manifest,r.Manifest,{},x),ee=await(0,h.$Np)(K);return ee?JSON.parse(ee):null}return null}async C(q,x,K){const ee=F(x,r.Manifest);if(!ee)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},Z=await this.D(q,ee,r.Manifest,{headers:_});return await(0,h.$Op)(Z)}async getCoreTranslation(q,x){const K=q.assets.coreTranslations.filter(ee=>ee[0]===x.toUpperCase())[0];if(K){const ee=await this.D(q.identifier.id,K[1],K[0]),_=await(0,h.$Np)(ee);return _?JSON.parse(_):null}return null}async getChangelog(q,x){if(q.assets.changelog){const K=await this.D(q.identifier.id,q.assets.changelog,r.Changelog,{},x);return await(0,h.$Np)(K)||""}return""}async getAllCompatibleVersions(q,x,K){let ee=new P().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);q.identifier.uuid?ee=ee.withFilter(t.ExtensionId,q.identifier.uuid):ee=ee.withFilter(t.ExtensionName,q.identifier.id);const{galleryExtensions:_}=await this.B(ee,N.CancellationToken.None);if(!_.length)return[];const Z=ie(_[0]);if((0,b.$Xo)(Z,K))return[];const se=[];await Promise.all(_[0].versions.map(async fe=>{try{await this.y(q.identifier.id,fe,x?"any":"release",!0,Z,K)&&se.push(fe)}catch{}}));const ue=[],ge=new Set;for(const fe of re(se,K))ge.has(fe.version)||(ge.add(fe.version),ue.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:G(fe)}));return ue}async D(q,x,K,ee={},_=N.CancellationToken.None){const Z=await this.j,se={type:"GET"},ue={...Z,...ee.headers||{}};ee={...ee,...se,headers:ue};const ge=x.uri,fe=x.fallbackUri,$e={...ee,url:ge};try{const ye=await this.k.request($e,_);if(ye.res.statusCode===200)return ye;const ve=await(0,h.$Np)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${ve}`)}catch(ye){if((0,L.$4)(ye))throw ye;const ve=(0,L.$0)(ye);this.o.publicLog2("galleryService:cdnFallback",{extension:q,assetType:K,message:ve});const Ce={...ee,url:fe};return this.k.request(Ce,_)}}async E(q,x){let K=Q(x);if(!K){this.o.publicLog2("galleryService:engineFallback",{extension:q,version:x.version});const ee=await this.C(q,x,N.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");K=ee.engines.vscode}return K}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const q=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(q.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,h.$Op)(q),K=[],ee={},_=[];if(x){for(const Z of x.malicious)K.push({id:Z});if(x.migrateToPreRelease)for(const[Z,se]of Object.entries(x.migrateToPreRelease))(!se.engine||(0,u.$Hp)(se.engine,this.u.version,this.u.date))&&(ee[Z.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[Z,se]of Object.entries(x.deprecated))se&&(ee[Z.toLowerCase()]=(0,I.$$f)(se)?{}:se);if(x.search)for(const Z of x.search)_.push(Z)}return{malicious:K,deprecated:ee,search:_}}};V=Ee([X(1,h.$Ip),X(2,w.$Xj),X(3,E.$yi),X(4,c.$Wl),X(5,l.$Xk),X(6,p.$ek),X(7,$.$Xi)],V);let z=class extends V{constructor(q,x,K,ee,_,Z,se,ue){super(q,x,K,ee,_,Z,se,ue)}};e.$5p=z,e.$5p=z=Ee([X(0,f.$Vp),X(1,h.$Ip),X(2,w.$Xj),X(3,E.$yi),X(4,c.$Wl),X(5,l.$Xk),X(6,p.$ek),X(7,$.$Xi)],z);let O=class extends V{constructor(q,x,K,ee,_,Z,se){super(void 0,q,x,K,ee,_,Z,se)}};e.$6p=O,e.$6p=O=Ee([X(0,h.$Ip),X(1,w.$Xj),X(2,E.$yi),X(3,c.$Wl),X(4,l.$Xk),X(5,p.$ek),X(6,$.$Xi)],O)}),define(ae[82],ce([0,1,4,3,2,19,33,24,17,9,13]),function(ne,e,R,N,L,j,A,I,C,$,E){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Uv=e.$Tv=void 0,e.$Tv=(0,R.$ri)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let u=class extends L.$Uc{static{b=this}static{this.a=512*1024}static b(w){return`extensionKeys/${(0,A.$tp)(w.id)}@${w.version}`}static c(w){const p=m.exec(w);if(p&&p[1])return{id:p[1],version:p[2]}}static async removeOutdatedExtensionVersions(w,p){const h=await w.getInstalled(),g=[];for(const[f,c]of b.f(p)){const d=h.find(i=>(0,A.$pp)(i.identifier,{id:f}))?.manifest.version;for(const i of c)d!==i&&g.push(b.b({id:f,version:i}))}for(const f of g)p.remove(f,0)}static f(w){const p=new Map,h=w.keys(0,1);for(const g of h){const f=b.c(g);if(f){let c=p.get(f.id.toLowerCase());c||p.set(f.id.toLowerCase(),c=[]),c.push(f.version)}}return p}constructor(w,p,h){super(),this.j=w,this.m=p,this.n=h,this.g=this.B(new N.$be),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=b.f(w),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Tc))(g=>this.r(g)))}r(w){if(this.h.has(w.key.toLowerCase())){this.g.fire();return}const p=b.c(w.key);if(p){if(this.j.get(w.key,0)===void 0)this.h.delete(p.id.toLowerCase());else{let h=this.h.get(p.id.toLowerCase());h||this.h.set(p.id.toLowerCase(),h=[]),h.push(p.version),this.g.fire()}return}}s(w){if((0,E.$5f)(w))return w;const p=w.manifest?w.manifest.publisher:w.publisher,h=w.manifest?w.manifest.name:w.name;return(0,A.$sp)(p,h)}getExtensionState(w,p){const h=this.s(w),g=this.getExtensionStateRaw(w,p);if(g)try{return JSON.parse(g)}catch(f){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${p}): ${f}`)}}getExtensionStateRaw(w,p){const h=this.s(w),g=this.j.get(h,p?0:1);return g&&g?.length>b.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${p}): ${g.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),g}setExtensionState(w,p,h){const g=this.s(w);p===void 0?this.j.remove(g,h?0:1):this.j.store(g,JSON.stringify(p),h?0:1,1)}setKeysForSync(w,p){this.j.store(b.b(w),JSON.stringify(p),0,1)}getKeysForSync(w){const p=this.m.extensionSyncedKeys?.[w.id.toLowerCase()],h=this.j.get(b.b(w),0),g=h?JSON.parse(h):void 0;return g&&p?(0,C.$Mb)([...g,...p]):g||p}addToMigrationList(w,p){if(w!==p){const h=this.t.filter(g=>!g.includes(w)&&!g.includes(p));h.push([w,p]),this.t=h}}getSourceExtensionToMigrate(w){const p=this.t.find(([,h])=>w===h);return p?p[0]:void 0}get t(){const w=this.j.get("extensionStorage.migrationList",-1,"[]");try{const p=JSON.parse(w);if(Array.isArray(p))return p}catch{}return[]}set t(w){w.length?this.j.store("extensionStorage.migrationList",JSON.stringify(w),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Uv=u,e.$Uv=u=b=Ee([X(0,j.$Vp),X(1,I.$ek),X(2,$.$Xj)],u)}),define(ae[255],ce([0,1,2,29,82,230,113,9,19]),function(ne,e,R,N,L,j,A,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;let $=class extends R.$Uc{constructor(b,m,u,l,w,p){super(),b.cleanUp(),(0,j.$$3b)(b,m,u,l,p),L.$Uv.removeOutdatedExtensionVersions(b,w)}};e.$2dc=$,e.$2dc=$=Ee([X(0,A.$yq),X(1,N.$1o),X(2,L.$Tv),X(3,N.$7o),X(4,C.$Vp),X(5,I.$Xj)],$)}),define(ae[256],ce([0,1,29,12,24,16,96,57,19,22,229]),function(ne,e,R,N,L,j,A,I,C,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;let b=class extends E.$lac{constructor(u,l,w,p,h,g,f,c){super(u.userHome,h,l,w,p,g,f,c)}};e.$9dc=b,e.$9dc=b=Ee([X(0,j.$zi),X(1,$.$Wl),X(2,R.$4o),X(3,C.$Vp),X(4,I.$Ybc),X(5,A.$U3b),X(6,N.$Xk),X(7,L.$ek)],b)}),define(ae[257],ce([0,1,104,3,22,16,2,9,14,67,24,5,6,99,21,170,37,19,13,132,20]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;const d=[R.$Xdc,R.$Ydc],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends A.$Uc{constructor(a,y,v,P,S,k,D){super(),this.y=a,this.z=y,this.C=v,this.D=k,this.F=D,this.f=new N.$be,this.onDidTokenFailed=this.f.event,this.g=new N.$be,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$be,this.onDidChangeMode=this.h.event,this.n=R.$Vdc,this.w=!1,this.I=(T,F)=>{F?this.j.error(T):this.j.info(T)},this.j=this.B(P.createLogger((0,c.$5g)(v.logsHome,`${R.$Zdc}.log`),{id:R.$Zdc,name:R.$1dc})),this.t=new m.$oh(100),this.B(this.j.onDidChangeLogLevel(T=>this.j.info("Log level changed to "+(0,I.$ak)(T)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(k.onDidChangeConfiguration(T=>{d.some(F=>T.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=R.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}J(){if(!this.u){let a;b.$j?a=this.C.appRoot:a=(0,C.$nc)((0,C.$nc)(this.C.appRoot)),this.u=(0,C.$kc)(a,"bin",`${this.z.tunnelApplicationName}${b.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(R.$Vdc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(y){this.j.error(y)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(R.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",y=!1;const v=(F,U)=>{U?this.j.error(F):a+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(R.TunnelStates.connecting((0,w.localize)(0,null)))},P=this.O("status",["status"],v);this.r=P;try{if(await P,this.r!==P)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(U=>U.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(R.TunnelStates.disconnected());return}if(y=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(R.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(R.TunnelStates.disconnected());return}finally{this.r===P&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const F=S.token;this.G(R.TunnelStates.connecting((0,w.localize)(1,null,S.accountLabel,S.providerId)));const U=(G,Y)=>{G=G.replaceAll(F,"*".repeat(4)),v(G,Y)},Q=this.O("login",["user","login","--provider",S.providerId,"--access-token",F,"--log",(0,I.$ak)(this.j.getLevel())],U);this.r=Q;try{if(await Q,this.r!==Q)return}catch(G){this.j.error(G),this.r=void 0,this.f.fire(S),this.G(R.TunnelStates.disconnected(S));return}}const k=this.Q();k?this.G(R.TunnelStates.connecting((0,w.localize)(2,null,k))):this.G(R.TunnelStates.connecting((0,w.localize)(3,null)));const D=["--accept-server-license-terms","--log",(0,I.$ak)(this.j.getLevel())];k?D.push("--name",k):D.push("--random-name");let T=!1;return this.n.active&&this.n.asService&&!y&&(T=await this.M(D)===!1),this.N(S,D,T)}async M(a){let y;try{y=await this.O("serviceInstall",["service","install",...a])}catch(v){this.j.error(v),y=1}if(y!==0){const v=(0,w.localize)(4,null);return this.j.warn(v),this.G(R.TunnelStates.connecting(v)),!1}return!0}async N(a,y,v){y.push("--parent-process-id",String(process.pid)),this.P()&&y.push("--no-sleep");let P=!1;const S=this.O("tunnel",y,(k,D)=>{D?this.j.error(k):this.j.info(k),k.includes("Connected to an existing tunnel process")&&(P=!0);const T=k.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const F={link:T[1],domain:T[2],tunnelName:T[4],isAttached:P};this.G(R.TunnelStates.connected(F,v))}else k.match(/error refreshing token/)&&(S.cancel(),this.f.fire(a),this.G(R.TunnelStates.disconnected(a)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=R.$Vdc,this.G(R.TunnelStates.disconnected()))})}O(a,y,v=this.I){return(0,m.$eh)(P=>new Promise((S,k)=>{P.isCancellationRequested&&S(-1);let D;const T=["ignore","pipe","pipe"];if(P.onCancellationRequested(()=>{D&&(this.j.info(`${a} terminating(${D.pid})`),D.kill())}),!this.C.isBuilt)v(`Building tunnel CLI from sources and run
`,!1),v(`${a} Spawning: cargo run -- tunnel ${y.join(" ")}
`,!1),D=(0,$.spawn)("cargo",["run","--","tunnel",...y],{cwd:(0,C.$kc)(this.C.appRoot,"cli"),stdio:T});else{v(`Running tunnel CLI
`,!1);const F=this.J();v(`${a} Spawning: ${F} tunnel ${y.join(" ")}
`,!1),D=(0,$.spawn)(F,["tunnel",...y],{cwd:(0,p.homedir)(),stdio:T})}D.stdout.pipe(new f.$AW(`
`)).on("data",F=>{if(D){const U=F.toString();v(U,!1)}}),D.stderr.pipe(new f.$AW(`
`)).on("data",F=>{if(D){const U=F.toString();v(U,!0)}}),D.on("exit",F=>{D&&(v(`${a} exit(${D.pid}): + ${F} `,!1),D=void 0,S(F||0))}),D.on("error",F=>{D&&(v(`${a} error(${D.pid}): + ${F} `,!0),D=void 0,k())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(R.$Ydc)}Q(){let a=this.D.getValue(R.$Xdc)||(0,p.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),y=this.F.getBoolean(o,-1,!1);if(a){const v=JSON.parse(a);if(v&&(0,g.$5f)(v.accountLabel)&&(0,g.$5f)(v.sessionId)&&(0,g.$5f)(v.providerId))return{active:!0,session:v,asService:y};this.j.error("Problems restoring session from storage, invalid format",v)}}catch(a){this.j.error("Problems restoring session from storage",a)}return R.$Vdc}S(a){if(a.active){const y={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(y),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$5dc=n,e.$5dc=n=Ee([X(0,L.$Wl),X(1,E.$ek),X(2,j.$zi),X(3,I.$Yj),X(4,u.$3dc),X(5,l.$Xi),X(6,h.$Vp)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(ae[258],ce([0,1,6,2,23,20,69,19,77,18]),function(ne,e,R,N,L,j,A,I,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;class E extends I.$Xp{constructor(m,u,l,w){super(),this.bb=m,this.cb=u,this.db=l,this.eb=w,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Tc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Tc),this.ab=this.hb(this.bb)}fb(){const m=this.B(new C.$9Jb(this.db.getChannel("storage"))),u=this.B(new A.$Rp(m));return this.B(u.onDidChangeStorage(l=>this.u(-1,l))),u}gb(m){this.X.clear(),this.W=m;let u;if((0,I.$Yp)(m))u=this.U;else{const l=this.X.add(new C.$0Jb(this.db.getChannel("storage"),m));u=this.X.add(new A.$Rp(l))}return this.X.add(u.onDidChangeStorage(l=>this.u(0,l))),u}hb(m){this.$.clear(),this.Z=m?.id;let u;if(m){const l=this.$.add(new C.$$Jb(this.db.getChannel("storage"),m));u=this.$.add(new A.$Rp(l)),this.$.add(u.onDidChangeStorage(w=>this.u(1,w)))}return u}async O(){await R.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(m){switch(m){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(m){switch(m){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$5g)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(m){if(!this.M(this.W,m))return;const u=this.Y,l=u.items;u!==this.U&&await u.close(),this.Y=this.gb(m),await this.Y.init(),this.N(l,this.Y,0)}async S(m,u){const l=this.ab,w=l?.items??new Map;await l?.close(),this.ab=this.hb(m),await this.ab.init(),this.N(w,this.ab,1)}hasScope(m){return(0,$.$wl)(m)?this.W.id===m.id:this.Z===m.id}}e.$0dc=E}),define(ae[259],ce([0,1,3,2,18,91]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=e.$JQ=void 0;class A{constructor($,E){this.a=$,this.b=E}listen($,E){const b=this.b($);switch(E){case"onDidChangeProfiles":return R.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(u=>(0,j.$vn)({...u},b)),added:m.added.map(u=>(0,j.$vn)({...u},b)),removed:m.removed.map(u=>(0,j.$vn)({...u},b)),updated:m.updated.map(u=>(0,j.$vn)({...u},b))}))}throw new Error(`Invalid listen ${E}`)}async call($,E,b){const m=this.b($);switch(E){case"createProfile":{const u=await this.a.createProfile(b[0],b[1],b[2]);return(0,j.$vn)({...u},m)}case"updateProfile":{let u=(0,L.$yl)((0,j.$wn)(b[0],m),this.a.profilesHome.scheme);return u=await this.a.updateProfile(u,b[1]),(0,j.$vn)({...u},m)}case"removeProfile":{const u=(0,L.$yl)((0,j.$wn)(b[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(u)}}throw new Error(`Invalid call ${E}`)}}e.$JQ=A;class I extends N.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor($,E,b){super(),this.profilesHome=E,this.f=b,this.a=[],this.b=this.B(new R.$be),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=$.map(m=>(0,L.$yl)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const u=m.added.map(p=>(0,L.$yl)(p,this.profilesHome.scheme)),l=m.removed.map(p=>(0,L.$yl)(p,this.profilesHome.scheme)),w=m.updated.map(p=>(0,L.$yl)(p,this.profilesHome.scheme));this.a=m.all.map(p=>(0,L.$yl)(p,this.profilesHome.scheme)),this.b.fire({added:u,removed:l,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement($){this.c=$}isEnabled(){return this.c}async createNamedProfile($,E,b){const m=await this.f.call("createNamedProfile",[$,E,b]);return(0,L.$yl)(m,this.profilesHome.scheme)}async createProfile($,E,b,m){const u=await this.f.call("createProfile",[$,E,b,m]);return(0,L.$yl)(u,this.profilesHome.scheme)}async createTransientProfile($){const E=await this.f.call("createTransientProfile",[$]);return(0,L.$yl)(E,this.profilesHome.scheme)}async setProfileForWorkspace($,E){await this.f.call("setProfileForWorkspace",[$,E])}removeProfile($){return this.f.call("removeProfile",[$])}async updateProfile($,E){const b=await this.f.call("updateProfile",[$,E]);return(0,L.$yl)(b,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$KQ=I}),define(ae[60],ce([0,1,2,69,4,19,3,77,18]),function(ne,e,R,N,L,j,A,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cKb=e.$bKb=e.$aKb=void 0,e.$aKb=(0,L.$ri)("IUserDataProfileStorageService");let $=class extends R.$Uc{constructor(u){super(),this.a=u}async readStorageData(u){return this.withProfileScopedStorageService(u,async l=>this.b(l))}async updateStorageData(u,l,w){return this.withProfileScopedStorageService(u,async p=>this.c(p,l,w))}async withProfileScopedStorageService(u,l){if(this.a.hasScope(u))return l(this.a);const w=await this.g(u),p=new b(w);try{await p.initialize();const h=await l(p);return await p.flush(),h}finally{p.dispose(),await this.f(w)}}b(u){const l=new Map,w=p=>{for(const h of u.keys(0,p))l.set(h,{value:u.get(h,0),target:p})};return w(0),w(1),l}c(u,l,w){u.storeAll(Array.from(l.entries()).map(([p,h])=>({key:p,value:h,scope:0,target:w})),!0)}async f(u){try{await u.close()}finally{(0,R.$Oc)(u)&&u.dispose()}}};e.$bKb=$,e.$bKb=$=Ee([X(0,j.$Vp)],$);class E extends ${constructor(u,l,w,p){super(w),this.j=u;const h=u.getChannel("profileStorageListener"),g=this.B(new R.$Vc);this.h=this.B(new A.$be({onWillAddFirstListener:()=>{g.value=h.listen("onDidChange")(f=>{p.trace("profile storage changes",f),this.h.fire({targetChanges:f.targetChanges.map(c=>(0,C.$yl)(c,l.profilesHome.scheme)),valueChanges:f.valueChanges.map(c=>({...c,profile:(0,C.$yl)(c.profile,l.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>g.value=void 0})),this.onDidChange=this.h.event}async g(u){const l=this.j.getChannel("storage");return(0,j.$Yp)(u)?new I.$9Jb(l):new I.$0Jb(l,u)}}e.$cKb=E;class b extends j.$Xp{constructor(u){super({flushInterval:100}),this.s=this.B(new N.$Rp(u))}O(){return this.s.init()}P(u){return u===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ae[260],ce([0,1,19,9,18,56,60]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;let I=class extends A.$cKb{constructor($,E,b,m){super($,E,b,m)}};e.$Odc=I,e.$Odc=I=Ee([X(0,j.$bdc),X(1,L.$xl),X(2,R.$Vp),X(3,N.$Xj)],I)}),define(ae[39],ce([0,1,17,6,15,26,3,35,2,27,13,175,21,16,12,9,45,19,22,28,25,18]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bLb=e.$aLb=e.$_Kb=e.$$Kb=void 0,e.$8Kb=i,e.$9Kb=o,e.$0Kb=n;function i(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||o(y.syncData)))}function o(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}function n(y,v){return`${(0,$.$Wf)(y)}${v.isDefault?"":` (${v.name})`}`}let s=class extends C.$Uc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(v,P,S,k,D,T,F,U,Q,G,Y,W){super(),this.syncResource=v,this.collection=P,this.G=S,this.H=k,this.I=D,this.J=T,this.L=F,this.M=U,this.N=Q,this.O=G,this.P=Y,this.c=null,this.m="idle",this.n=this.B(new A.$be),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new A.$be),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$ph(50)),this.w=this.B(new A.$be),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(v.syncResource,v.profile),this.h=W.extUri,this.f=this.h.joinPath(k.userDataSyncHome,...(0,c.$aAb)(v.profile.isDefault?void 0:v.profile.id,v.syncResource)),this.g=this.h.joinPath(this.f,c.$vAb),this.y=(0,c.$bAb)(v.profile.isDefault?void 0:v.profile.id,v.syncResource,k,this.h),this.j=(0,p.$2p)(k,S,D)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const v=await this.c;this.c=null;const P=await this.Y(v.remoteUserData,v.lastSyncUserData,!0,this.ob());this.S(P)}else{this.O.trace(`${this.D}: Checking for local changes...`);const v=await this.getLastSyncUserData();(v?await this.ub(v):!0)&&this.w.fire()}}S(v){this.m!==v&&(this.m=v,this.n.fire(v))}async sync(v,P={}){await this.U(v,!0,this.ob(),P)}async preview(v,P,S={}){return this.U(v,!1,P,S)}async apply(v,P={}){try{this.F={...P};const S=await this.ab(v);return this.S(S),this.c}finally{this.F={}}}async U(v,P,S,k){try{if(this.F={...k},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let D="idle";try{const T=await this.getLastSyncUserData(),F=await this.X(v,T);return D=await this.Y(F,T,P,S),D==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):D==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(D)}}finally{this.F={}}}async replace(v){const P=this.kb(v);if(!P)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const S=await this.getLastSyncUserData(),k=await this.X(null,S),D=await this.W(k),T=await this.qb({ref:k.ref,syncData:P},S,D,this.ob(),j.CancellationToken.None),F=[];for(const U of T){const Q=await this.sb(U,U.remoteResource,void 0,j.CancellationToken.None),{remoteChange:G}=await this.sb(U,U.previewResource,U.remoteContent,j.CancellationToken.None);F.push([U,{...Q,remoteChange:G!==0?G:2}])}await this.tb(k,S,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(v){const P=await this.j;return!!v.syncData?.machineId&&v.syncData.machineId===P}async X(v,P){if(P){const S=v?v[this.resource]:void 0;if(P.ref===S||S===void 0&&P.syncData===null)return P}return this.getRemoteUserData(P)}async Y(v,P,S,k){if(v.syncData&&v.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new c.$iAb((0,b.localize)(0,null,this.resource,this.pb,v.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(v,P,S,k)}catch(D){if(D instanceof c.$iAb)switch(D.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(v,P,S,k);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),v=await this.getRemoteUserData(null),P=await this.getLastSyncUserData(),this.Y(v,P,S,k)}throw D}}async Z(v,P,S,k){try{const D=await this.W(v),T=!D&&P===null&&this.gb()!==void 0,F=S&&!T;this.c||(this.c=(0,N.$eh)(Q=>this.eb(v,P,D,F,k,Q)));let U=await this.c;if(S&&T){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Q of U.resourcePreviews)U=await this.accept(Q.remoteResource)||U}return this.cb(U.resourcePreviews),U.resourcePreviews.some(({mergeState:Q})=>Q==="conflict")?"hasConflicts":S?await this.ab(!1):"syncing"}catch(D){throw this.c=null,D}}async merge(v){return await this.$(v,async P=>{const S=await this.rb(P,j.CancellationToken.None);await this.G.writeFile(P.previewResource,L.$Ce.fromString(S?.content||""));const k=S&&!S.hasConflicts?await this.sb(P,P.previewResource,void 0,j.CancellationToken.None):void 0;return P.acceptResult=k,P.mergeState=S.hasConflicts?"conflict":k?"accepted":"preview",P.localChange=k?k.localChange:S.localChange,P.remoteChange=k?k.remoteChange:S.remoteChange,P}),this.c}async accept(v,P){return await this.$(v,async S=>{const k=await this.sb(S,v,P,j.CancellationToken.None);return S.acceptResult=k,S.mergeState="accepted",S.localChange=k.localChange,S.remoteChange=k.remoteChange,S}),this.c}async discard(v){return await this.$(v,async P=>{const S=await this.rb(P,j.CancellationToken.None);return await this.G.writeFile(P.previewResource,L.$Ce.fromString(S.content||"")),P.acceptResult=void 0,P.mergeState="preview",P.localChange=S.localChange,P.remoteChange=S.remoteChange,P}),this.c}async $(v,P){if(!this.c)return;let S=await this.c;const k=S.resourcePreviews.findIndex(({localResource:D,remoteResource:T,previewResource:F})=>this.h.isEqual(D,v)||this.h.isEqual(T,v)||this.h.isEqual(F,v));k!==-1&&(this.c=(0,N.$eh)(async D=>{const T=[...S.resourcePreviews];return T[k]=await P(T[k]),{...S,resourcePreviews:T}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:D})=>D==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(v){if(!this.c)return"idle";const P=await this.c;return P.resourcePreviews.some(({mergeState:S})=>S==="conflict")?"hasConflicts":P.resourcePreviews.some(({mergeState:S})=>S!=="accepted")?"syncing":(await this.tb(P.remoteUserData,P.lastSyncUserData,P.resourcePreviews.map(S=>[S,S.acceptResult]),v),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(v){const P=v.filter(({mergeState:S})=>S==="conflict");(0,R.$ub)(this.s,P,(S,k)=>this.h.isEqual(S.previewResource,k.previewResource))||(this.s=P,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const v=await this.getLastSyncUserData();return!!v&&v.syncData!==null}async db(v){const P=this.c?await this.c:null;if(P)for(const S of P.resourcePreviews){if(this.h.isEqual(S.acceptedResource,v))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,v))return S.remoteContent;if(this.h.isEqual(S.localResource,v))return S.localContent;if(this.h.isEqual(S.baseResource,v))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(v){(0,l.$cl)(v)!==1&&this.O.error(v)}}async eb(v,P,S,k,D,T){const F=await this.qb(v,P,S,D,T),U=[];for(const Q of F){const G=Q.previewResource.with({scheme:c.$uAb,authority:"accepted"});if(Q.localChange===0&&Q.remoteChange===0)U.push({...Q,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Y=k?await this.rb(Q,T):void 0;if(T.isCancellationRequested)break;await this.G.writeFile(Q.previewResource,L.$Ce.fromString(Y?.content||""));const W=Y&&!Y.hasConflicts?await this.sb(Q,Q.previewResource,void 0,T):void 0;U.push({...Q,acceptResult:W,mergeState:Y?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:Y?Y.localChange:Q.localChange,remoteChange:W?W.remoteChange:Y?Y.remoteChange:Q.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:v,lastSyncUserData:P,resourcePreviews:U,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let v=this.gb();if(v||(v=await this.jb()),!v)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const P=JSON.parse(v),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!P.version&&!!S&&P.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${P.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let k,D=1;for(;k===void 0&&D++<6;)try{const T=await this.hb();T&&(T.ref===P.ref?k=T.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(T){if(T instanceof l.$gl&&T.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(T instanceof c.$iAb)throw T;this.O.error(T,D)}}if(k===void 0)try{const T=await this.J.resolveResourceContent(this.resource,P.ref,this.collection,this.F);k=T===null?null:this.kb(T),await this.ib({ref:P.ref,syncData:k})}catch(T){if(T instanceof c.$iAb&&T.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw T}return k===void 0?null:{...P,syncData:k}}async fb(v,P={}){if(P.ref||P.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),k={ref:v.ref,version:S,...P};this.I.store(this.z,JSON.stringify(k),-1,1),await this.ib(v)}gb(){return this.I.get(this.z,-1)}async hb(){const v=(await this.G.readFile(this.y)).value.toString();try{const P=v?JSON.parse(v):void 0;if(i(P))return P}catch(P){this.O.error(P)}}async ib(v){await this.G.writeFile(this.y,L.$Ce.fromString(JSON.stringify(v)))}async jb(){try{const v=await this.G.readFile(this.y),P=JSON.parse(v.value.toString());await this.G.del(this.y),P.ref&&P.content!==void 0?(this.I.store(this.z,JSON.stringify({...P,content:void 0}),-1,1),await this.ib({ref:P.ref,syncData:P.content===null?null:JSON.parse(P.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,P)}catch(v){v instanceof l.$gl&&v.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(v)}return this.I.get(this.z,-1)}async getRemoteUserData(v){const{ref:P,content:S}=await this.lb(v);let k=null;return S!==null&&(k=this.kb(S)),{ref:P,syncData:k}}kb(v){try{const P=JSON.parse(v);if(o(P))return P}catch(P){this.O.error(P)}throw new c.$iAb((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(v){const P=v?{ref:v.ref,content:v.syncData?JSON.stringify(v.syncData):null}:null;return this.J.readResource(this.resource,P,this.collection,this.F)}async mb(v,P){const S=await this.j,k={version:this.pb,machineId:S,content:v};try{return P=await this.J.writeResource(this.resource,JSON.stringify(k),P,this.collection,this.F),{ref:P,syncData:k}}catch(D){throw D instanceof c.$iAb&&D.code==="TooLarge"&&(D=new c.$iAb(D.message,D.code,this.resource)),D}}async nb(v){const P={version:this.pb,content:v};return this.L.writeResource(this.resource,JSON.stringify(P),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(c.$8zb)}};e.$$Kb=s,e.$$Kb=s=Ee([X(2,l.$Xk),X(3,u.$yi),X(4,h.$Vp),X(5,c.$dAb),X(6,c.$eAb),X(7,c.$nAb),X(8,g.$Wl),X(9,c.$sAb),X(10,m.$Xi),X(11,f.$vl)],s);let t=class extends s{constructor(v,P,S,k,D,T,F,U,Q,G,Y,W,J){super(P,S,k,D,T,F,U,Q,G,Y,W,J),this.r=v,this.B(this.G.watch(this.h.dirname(v))),this.B(this.G.onDidFilesChange(H=>this.yb(H)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(v,P,S){try{P?await this.G.writeFile(this.r,L.$Ce.fromString(v),S?void 0:P):await this.G.createFile(this.r,L.$Ce.fromString(v),{overwrite:S})}catch(k){throw k instanceof l.$gl&&k.fileOperationResult===1||k instanceof l.$gl&&k.fileOperationResult===3?new c.$iAb(k.message,"LocalPreconditionFailed"):k}}async xb(){try{await this.G.del(this.r)}catch(v){if(!(v instanceof l.$gl&&v.fileOperationResult===1))throw v}}yb(v){v.contains(this.r)&&this.Q()}};e.$_Kb=t,e.$_Kb=t=Ee([X(3,l.$Xk),X(4,u.$yi),X(5,h.$Vp),X(6,c.$dAb),X(7,c.$eAb),X(8,c.$nAb),X(9,g.$Wl),X(10,c.$sAb),X(11,m.$Xi),X(12,f.$vl)],t);let r=class extends t{constructor(v,P,S,k,D,T,F,U,Q,G,Y,W,J,H){super(v,P,S,k,D,T,F,U,Q,G,Y,J,H),this.zb=W,this.Bb=void 0}Ab(v,P){const S=[],k=(0,I.$En)(v,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,E.$_f)(k)&&P!==Array.isArray(k)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$aLb=r,e.$aLb=r=Ee([X(3,l.$Xk),X(4,u.$yi),X(5,h.$Vp),X(6,c.$dAb),X(7,c.$eAb),X(8,c.$nAb),X(9,g.$Wl),X(10,c.$sAb),X(11,c.$rAb),X(12,m.$Xi),X(13,f.$vl)],r);let a=class{constructor(v,P,S,k,D,T,F){this.resource=v,this.g=P,this.h=S,this.j=k,this.k=D,this.l=T,this.d=F.extUri,this.f=(0,c.$bAb)(void 0,this.resource,S,this.d)}async initialize({ref:v,content:P}){if(!P){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(P);if(S)try{await this.o({ref:v,syncData:S})}catch(k){this.j.error(k)}}m(v){try{const P=JSON.parse(v);if(o(P))return P}catch(P){this.j.error(P)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(v,P={}){if(P.ref||P.version)throw new Error("Cannot have core properties as additional");const S={ref:v.ref,version:void 0,...P};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),-1,1),await this.k.writeFile(this.f,L.$Ce.fromString(JSON.stringify(v)))}};e.$bLb=a,e.$bLb=a=Ee([X(1,d.$xl),X(2,u.$yi),X(3,w.$Xj),X(4,l.$Xk),X(5,h.$Vp),X(6,f.$vl)],a)}),define(ae[115],ce([0,1,6,26,7,3,43,2,27,21,16,114,29,33,82,48,12,4,74,9,19,22,28,18,39,241,111,25,60]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c,d,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t$b=e.$s$b=e.$r$b=void 0,e.$p$b=v,e.$q$b=P;async function y(T,F){const U=JSON.parse(T.content);if(T.version===1||T.version===2){const Q=(await F.getInstalled(0)).filter(G=>G.isBuiltin);for(const G of U)T.version===1&&(G.enabled===!1&&(G.disabled=!0),delete G.enabled),T.version===2&&Q.every(Y=>!(0,u.$pp)(Y.identifier,G.identifier))&&(G.installed=!0)}return U}function v(T){return JSON.parse(T.content)}function P(T,F){return T.sort((U,Q)=>!U.identifier.uuid&&Q.identifier.uuid?-1:U.identifier.uuid&&!Q.identifier.uuid?1:(0,C.$nf)(U.identifier.id,Q.identifier.id)),F?(0,A.$Pn)(T,{}):JSON.stringify(T)}let S=class extends n.$$Kb{constructor(F,U,Q,G,Y,W,J,H,B,ie,re,he,te,V,z,O,M){super({syncResource:"extensions",profile:F},U,G,Q,Y,W,J,he,te,ie,re,z),this.Cb=H,this.Db=B,this.Eb=M,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$uAb,authority:"base"}),this.yb=this.wb.with({scheme:r.$uAb,authority:"local"}),this.zb=this.wb.with({scheme:r.$uAb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$uAb,authority:"accepted"}),this.Bb=this.Eb.createInstance(k),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,q=>q.some(({local:x})=>!!x)),j.Event.filter(this.Cb.onDidUninstallExtension,q=>!q.error),j.Event.filter(O.onDidChange,q=>q.valueChanges.some(({profile:x,changes:K})=>this.syncResource.profile.id===x.id&&K.some(ee=>ee.key===m.$5o))),V.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,U){const Q=F.syncData?await y(F.syncData,this.Cb):null,G=U?.skippedExtensions??[],Y=U?.builtinExtensions??null,W=U?.syncData?await y(U.syncData,this.Cb):null,{localExtensions:J,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile);Q?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ie}=(0,s.$o$b)(J,Q,W,G,H,Y),re={local:B,remote:ie,content:this.Hb(J,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:ie!==null?2:0},he=this.Ob(J,!1);return[{skippedExtensions:G,builtinExtensions:Y,baseResource:this.xb,baseContent:W?this.Ob(W,!1):he,localResource:this.yb,localContent:he,localExtensions:J,remoteResource:this.zb,remoteExtensions:Q,remoteContent:Q?this.Ob(Q,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(F){const U=F.syncData?await y(F.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Y}=(0,s.$o$b)(Q,U,U,F.skippedExtensions||[],G,F.builtinExtensions||[]);return Y!==null}Hb(F,U,Q,G){const Y=[...U,...Q],W=new Set,J=H=>{W.add(H.id.toLowerCase()),H.uuid&&W.add(H.uuid)};Y.forEach(({identifier:H})=>J(H)),G.forEach(J);for(const H of F)W.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&W.has(H.identifier.uuid)||Y.push(H);return this.Ob(Y,!1)}async rb(F,U){return{...F.previewResult,hasConflicts:!1}}async sb(F,U,Q,G){if(this.h.isEqual(U,this.yb))return this.Kb(F);if(this.h.isEqual(U,this.zb))return this.Lb(F);if(this.h.isEqual(U,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async Kb(F){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.Db.getIgnoredExtensions(U),G=(0,s.$o$b)(F.localExtensions,null,null,F.skippedExtensions,Q,F.builtinExtensions),{local:Y,remote:W}=G;return{content:F.localContent,local:Y,remote:W,localChange:Y.added.length>0||Y.removed.length>0||Y.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(F){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.Db.getIgnoredExtensions(U),G=F.remoteContent?JSON.parse(F.remoteContent):null;if(G!==null){const Y=(0,s.$o$b)(F.localExtensions,G,F.localExtensions,[],Q,F.builtinExtensions),{local:W,remote:J}=Y;return{content:F.remoteContent,local:W,remote:J,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:J!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(F,U,Q,G){let{skippedExtensions:Y,builtinExtensions:W,localExtensions:J}=Q[0][0];const{local:H,remote:B,localChange:ie,remoteChange:re}=Q[0][1];if(ie===0&&re===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(J)),Y=await this.Bb.updateLocalExtensions(H.added,H.removed,H.updated,Y,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const he=JSON.stringify(B.all);F=await this.mb(he,G?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(te=>te.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(te=>te.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(te=>te.identifier.id))}.`:""}`)}U?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(J,W),await this.fb(F,{skippedExtensions:Y,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${Y.length?` Skipped: ${JSON.stringify(Y.map(he=>he.identifier.id))}.`:""}`))}Nb(F,U){const Q=new Set,G=[];for(const Y of F)Q.add(Y.identifier.id.toLowerCase()),Y.installed||G.push(Y.identifier);if(U)for(const Y of U)Q.has(Y.id.toLowerCase())||G.push(Y);return G}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const U=await this.db(F);return U&&this.Ob(JSON.parse(U),!0)}return null}Ob(F,U){return P(F,U)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(U=>U.installed||U.disabled))return!0}catch{}return!1}};e.$r$b=S,e.$r$b=S=Ee([X(2,E.$yi),X(3,p.$Xk),X(4,c.$Vp),X(5,r.$dAb),X(6,r.$eAb),X(7,m.$4o),X(8,t.$WLb),X(9,r.$sAb),X(10,$.$Xi),X(11,r.$nAb),X(12,d.$Wl),X(13,l.$Tv),X(14,i.$vl),X(15,a.$aKb),X(16,h.$qi)],S);let k=class{constructor(F,U,Q,G,Y,W){this.a=F,this.b=U,this.c=Q,this.d=G,this.f=Y,this.g=W}async getLocalExtensions(F){const U=await this.a.getInstalled(void 0,F.extensionsResource),Q=this.d.getIgnoredExtensions(U);return{localExtensions:await this.j(F,async(Y,W)=>{const J=Y.getDisabledExtensions();return U.map(H=>{const{identifier:B,isBuiltin:ie,manifest:re,preRelease:he,pinned:te,isApplicationScoped:V}=H,z={identifier:B,preRelease:he,version:re.version,pinned:!!te};V&&!(0,w.$Pm)(re)&&(z.isApplicationScoped=V),J.some(O=>(0,u.$pp)(O,B))&&(z.disabled=!0),ie||(z.installed=!0);try{const O=W.getKeysForSync({id:B.id,version:re.version});if(O){const M=W.getExtensionState(H,!0)||{};z.state=Object.keys(M).reduce((q,x)=>(O.includes(x)&&(q[x]=M[x]),q),{})}}catch(O){this.g.info(`${(0,n.$0Kb)("extensions",F)}: Error while parsing extension state`,(0,L.$0)(O))}return z})}),ignoredExtensions:Q}}async updateLocalExtensions(F,U,Q,G,Y){const W=(0,n.$0Kb)("extensions",Y),J=[],H=new Map,B=[],ie=[],re=await this.a.getInstalled(void 0,Y.extensionsResource);if((F.length||Q.length)&&await this.j(Y,async(V,z)=>{await R.Promises.settled([...F,...Q].map(async O=>{const M=re.find(K=>(0,u.$pp)(K.identifier,O.identifier));if(M&&M.isBuiltin){O.state&&M.manifest.version===O.version&&this.h(O.state,M,M.manifest.version,z),V.getDisabledExtensions().some(ee=>(0,u.$pp)(ee,O.identifier))!==!!O.disabled&&(O.disabled?(this.g.trace(`${W}: Disabling extension...`,O.identifier.id),await V.disableExtension(O.identifier),this.g.info(`${W}: Disabled extension`,O.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,O.identifier.id),await V.enableExtension(O.identifier),this.g.info(`${W}: Enabled extension`,O.identifier.id))),B.push(O.identifier);return}const q=O.pinned?O.version:void 0,x=(await this.c.getExtensions([{...O.identifier,version:q,preRelease:q?void 0:O.preRelease}],N.CancellationToken.None))[0];if(O.state&&(M?M.manifest.version===O.version:x)&&this.h(O.state,M||x,M?.manifest.version,z),x)try{V.getDisabledExtensions().some(ee=>(0,u.$pp)(ee,O.identifier))!==!!O.disabled&&(O.disabled?(this.g.trace(`${W}: Disabling extension...`,O.identifier.id,x.version),await V.disableExtension(x.identifier),this.g.info(`${W}: Disabled extension`,O.identifier.id,x.version)):(this.g.trace(`${W}: Enabling extension...`,O.identifier.id,x.version),await V.enableExtension(x.identifier),this.g.info(`${W}: Enabled extension`,O.identifier.id,x.version))),(!M||M.preRelease!==O.preRelease||M.pinned!==O.pinned||q&&M.manifest.version!==q)&&(await this.a.canInstall(x)?(J.push({extension:x,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:O.pinned&&!!O.version,installPreReleaseVersion:O.preRelease,profileLocation:Y.extensionsResource,isApplicationScoped:O.isApplicationScoped,context:{[m.$Ro]:!0,[m.$So]:!0}}}),H.set(x.identifier.id.toLowerCase(),O)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,x.displayName||x.identifier.id),ie.push(O)))}catch(K){ie.push(O),this.g.error(K),this.g.info(`${W}: Skipped synchronizing extension`,x.displayName||x.identifier.id)}else ie.push(O),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,O.identifier.id)}))}),U.length){const V=re.filter(({identifier:z,isBuiltin:O})=>!O&&U.some(M=>(0,u.$pp)(z,M)));await R.Promises.settled(V.map(async z=>{this.g.trace(`${W}: Uninstalling local extension...`,z.identifier.id),await this.a.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Y.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,z.identifier.id),B.push(z.identifier)}))}const he=await this.a.installGalleryExtensions(J);for(const{identifier:V,local:z,error:O,source:M}of he){const q=M;if(z)this.g.info(`${W}: Installed extension.`,V.id,q.version),B.push(V);else{const x=H.get(V.id.toLowerCase());x&&(ie.push(x),this.g.info(`${W}: Skipped synchronizing extension`,q.displayName||q.identifier.id)),O instanceof m.$2o&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(O.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,q.displayName||q.identifier.id):O&&this.g.error(O)}}const te=[];for(const V of G)B.some(z=>(0,u.$pp)(z,V.identifier))||te.push(V);for(const V of ie)te.some(z=>(0,u.$pp)(z.identifier,V.identifier))||te.push(V);return te}h(F,U,Q,G){const Y=G.getExtensionState(U,!0)||{},W=Q?G.getKeysForSync({id:U.identifier.id,version:Q}):void 0;W?W.forEach(J=>{Y[J]=F[J]}):Object.keys(F).forEach(J=>Y[J]=F[J]),G.setExtensionState(U,Y,!0)}async j(F,U){return this.b.withProfileScopedStorageService(F,async Q=>{const G=new I.$Tc,Y=this.f.createChild(new g.$pi([c.$Vp,Q])),W=G.add(Y.createInstance(b.$wJb)),J=G.add(Y.createInstance(l.$Uv));try{return await U(W,J)}finally{G.dispose()}})}};e.$s$b=k,e.$s$b=k=Ee([X(0,m.$4o),X(1,a.$aKb),X(2,m.$1o),X(3,t.$WLb),X(4,h.$qi),X(5,r.$sAb)],k);let D=class extends n.$bLb{constructor(F,U,Q,G,Y,W,J,H){super("extensions",G,Y,W,Q,J,H),this.p=F,this.q=U}async t(F){return F.syncData?await y(F.syncData,this.p):null}u(F,U){const Q=[],G=[],Y=[];for(const W of F){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const J=U.find(H=>(0,u.$pp)(H.identifier,W.identifier));J?(Q.push(J),W.disabled&&Y.push(W.identifier)):W.installed&&(G.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&Y.push(W.identifier))}return{installedExtensions:Q,newExtensions:G,disabledExtensions:Y,remoteExtensions:F}}};e.$t$b=D,e.$t$b=D=Ee([X(0,m.$4o),X(1,t.$WLb),X(2,p.$Xk),X(3,o.$xl),X(4,E.$yi),X(5,f.$Xj),X(6,c.$Vp),X(7,i.$vl)],D)}),define(ae[116],ce([0,1,15,7,3,35,43,5,32,21,16,12,9,45,19,22,28,39,79,245,25,18,60,4]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c,d,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hLb=e.$gLb=e.$fLb=e.$eLb=void 0,e.$dLb=t;const n="globalState.argv.",s=["locale"];function t(S,k){const D=S.storage?Object.keys(S.storage).sort():[],T={};return D.forEach(F=>T[F]=S.storage[F]),S.storage=T,k?(0,A.$Pn)(S,{}):JSON.stringify(S)}const r=1;let a=class extends h.$$Kb{constructor(k,D,T,F,U,Q,G,Y,W,J,H,B,ie,re){super({syncResource:"globalState",profile:k},D,F,Y,B,U,Q,W,J,G,H,ie),this.Bb=T,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:c.$uAb,authority:"base"}),this.xb=this.vb.with({scheme:c.$uAb,authority:"local"}),this.yb=this.vb.with({scheme:c.$uAb,authority:"remote"}),this.zb=this.vb.with({scheme:c.$uAb,authority:"accepted"}),this.Ab=re.createInstance(y),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(F.onDidFilesChange,he=>he.contains(this.H.argvResource)),L.Event.filter(T.onDidChange,he=>!!(he.targetChanges.some(te=>this.syncResource.profile.id===te.id)||he.valueChanges.some(({profile:te,changes:V})=>this.syncResource.profile.id===te.id&&V.some(z=>z.target===0)))))(()=>this.Q()))}async qb(k,D,T){const F=k.syncData?JSON.parse(k.syncData.content):null;D=D===null&&T?k:D;const U=D&&D.syncData?JSON.parse(D.syncData.content):null,Q=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.Jb(U),{local:Y,remote:W}=(0,f.$cLb)(Q.storage,F?F.storage:null,U?U.storage:null,G,this.O),J={content:null,local:Y,remote:W,localChange:Object.keys(Y.added).length>0||Object.keys(Y.updated).length>0||Y.removed.length>0?2:0,remoteChange:W.all!==null?2:0},H=t(Q,!1);return[{baseResource:this.wb,baseContent:U?t(U,!1):H,localResource:this.xb,localContent:H,localUserData:Q,remoteResource:this.yb,remoteContent:F?t(F,!1):null,previewResource:this.vb,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.zb,storageKeys:G}]}async ub(k){const D=k.syncData?JSON.parse(k.syncData.content):null;if(D===null)return!0;const T=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(D),{remote:U}=(0,f.$cLb)(T.storage,D.storage,D.storage,F,this.O);return U.all!==null}async rb(k,D){return{...k.previewResult,hasConflicts:!1}}async sb(k,D,T,F){if(this.h.isEqual(D,this.xb))return this.Gb(k);if(this.h.isEqual(D,this.yb))return this.Hb(k);if(this.h.isEqual(D,this.vb))return k.previewResult;throw new Error(`Invalid Resource: ${D.toString()}`)}async Gb(k){return{content:k.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(k.localUserData.storage),removed:[],updated:[],all:k.localUserData.storage},localChange:0,remoteChange:2}}async Hb(k){if(k.remoteContent!==null){const D=JSON.parse(k.remoteContent),{local:T,remote:F}=(0,f.$cLb)(k.localUserData.storage,D.storage,null,k.storageKeys,this.O);return{content:k.remoteContent,local:T,remote:F,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:k.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(k,D,T,F){const{localUserData:U}=T[0][0],{local:Q,remote:G,localChange:Y,remoteChange:W}=T[0][1];if(Y===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Y!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(U)),await this.Ab.writeLocalGlobalState(Q,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const J=JSON.stringify({storage:G.all});k=await this.mb(J,F?null:k.ref),this.O.info(`${this.D}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}D?.ref!==k.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(k),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(k){if(this.h.isEqual(this.yb,k)||this.h.isEqual(this.wb,k)||this.h.isEqual(this.xb,k)||this.h.isEqual(this.zb,k)){const D=await this.db(k);return D&&t(JSON.parse(D),!0)}return null}async hasLocalData(){try{const{storage:k}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(k).length>1||k[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(k){const D=await this.Bb.readStorageData(this.syncResource.profile),T=[],F=[];for(const[G,Y]of D)Y.target===0?T.push(G):Y.target===1&&F.push(G);const U=[...T,...F],Q=k?.storage?Object.keys(k.storage).filter(G=>!G.startsWith(n)&&!U.includes(G)&&D.get(G)!==void 0):[];if(!I.$o){const G=[...c.$_zb.map(Y=>(0,c.$mAb)(Y)),c.$lAb];Q.push(...G),F.push(...G)}return{user:T,machine:F,unregistered:Q}}};e.$eLb=a,e.$eLb=a=Ee([X(2,i.$aKb),X(3,b.$Xk),X(4,c.$dAb),X(5,c.$eAb),X(6,c.$sAb),X(7,E.$yi),X(8,c.$nAb),X(9,w.$Wl),X(10,$.$Xi),X(11,l.$Vp),X(12,p.$vl),X(13,o.$qi)],a);let y=class{constructor(k,D,T,F){this.a=k,this.b=D,this.c=T,this.d=F}async getLocalGlobalState(k){const D={};if(k.isDefault){const F=await this.f(),U=(0,j.$En)(F);for(const Q of s)U[Q]!==void 0&&(D[`${n}${Q}`]={version:1,value:U[Q]})}const T=await this.c.readStorageData(k);for(const[F,U]of T)U.value&&U.target===0&&(D[F]={version:1,value:U.value});return{storage:D}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const k=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),k.value.toString()}catch(k){this.d.debug((0,N.$0)(k))}return"{}"}async writeLocalGlobalState({added:k,removed:D,updated:T},F){const U=(0,h.$0Kb)("globalState",F),Q={},G=new Map,Y=await this.c.readStorageData(F),W=(J,H)=>{for(const B of J){if(B.startsWith(n)){Q[B.substring(n.length)]=H?H[B].value:void 0;continue}if(H){const ie=H[B];ie.value!==Y.get(B)?.value&&G.set(B,ie.value)}else Y.get(B)!==void 0&&G.set(B,void 0)}};if(W(Object.keys(k),k),W(Object.keys(T),T),W(D),Object.keys(Q).length){this.d.trace(`${U}: Updating locale...`);const J=await this.f();let H=J;for(const B of Object.keys(Q))H=(0,g.edit)(H,[B],Q[B],{});J!==H&&(this.d.trace(`${U}: Updating locale...`),await this.a.writeFile(this.b.argvResource,R.$Ce.fromString(H)),this.d.info(`${U}: Updated locale.`)),this.d.info(`${U}: Updated locale`)}G.size&&(this.d.trace(`${U}: Updating global state...`),await this.c.updateStorageData(F,G,0),this.d.info(`${U}: Updated global state`,[...G.keys()]))}};e.$fLb=y,e.$fLb=y=Ee([X(0,b.$Xk),X(1,E.$yi),X(2,i.$aKb),X(3,c.$sAb)],y);let v=class extends h.$bLb{constructor(k,D,T,F,U,Q){super("globalState",T,F,U,D,k,Q)}async o(k){const D=k.syncData?JSON.parse(k.syncData.content):null;if(!D){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const T={},F={};for(const U of Object.keys(D.storage))U.startsWith(n)?T[U.substring(n.length)]=D.storage[U].value:this.l.get(U,0)===void 0&&(F[U]=D.storage[U].value);if(Object.keys(T).length){let U="{}";try{U=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Q of Object.keys(T))U=(0,g.edit)(U,[Q],T[Q],{});await this.k.writeFile(this.h.argvResource,R.$Ce.fromString(U))}if(Object.keys(F).length){const U=[];for(const Q of Object.keys(F))U.push({key:Q,value:F[Q],scope:0,target:0});this.l.storeAll(U,!0)}}};e.$gLb=v,e.$gLb=v=Ee([X(0,l.$Vp),X(1,b.$Xk),X(2,d.$xl),X(3,E.$yi),X(4,c.$sAb),X(5,p.$vl)],v);let P=class{constructor(k,D,T,F,U){this.a=k,this.b=D,this.c=T,this.d=F,this.f=U}getSyncStoreType(k){return this.h(k)?.storage[c.$lAb]?.value}async sync(k){const D=(0,c.$hAb)((0,C.$Ng)());try{return await this.g(k,D)}catch(T){if(T instanceof c.$iAb)switch(T.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(k,D)}throw T}}async g(k,D){const T=await this.a.readResource("globalState",null,void 0,D),F=this.h(T)||{storage:{}};F.storage[c.$lAb]={value:k,version:r};const U=await(0,u.$2p)(this.c,this.d,this.b),Q={version:r,machineId:U,content:t(F,!1)};await this.a.writeResource("globalState",JSON.stringify(Q),T.ref,void 0,D)}h({content:k}){if(!k)return null;const D=JSON.parse(k);if((0,h.$9Kb)(D))return D?JSON.parse(D.content):null;throw new Error("Invalid remote data")}};e.$hLb=P,e.$hLb=P=Ee([X(1,l.$Vp),X(2,E.$yi),X(3,b.$Xk),X(4,m.$Xj)],P)}),define(ae[117],ce([0,1,17,15,3,35,5,13,176,21,16,12,19,22,28,18,39,242,25]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$b=e.$w$b=void 0,e.$v$b=f;function f(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,I.$_f)(s.all)?null:s.all;switch(A.OS){case 2:return(0,I.$_f)(s.mac)?null:s.mac;case 3:return(0,I.$_f)(s.linux)?null:s.linux;case 1:return(0,I.$_f)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let c=class extends p.$aLb{constructor(o,n,s,t,r,a,y,v,P,S,k,D,T){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,v,P,S,s,t,y,D,r,k,a,T),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:g.$uAb,authority:"base"}),this.Gb=this.Eb.with({scheme:g.$uAb,authority:"local"}),this.Hb=this.Eb.with({scheme:g.$uAb,authority:"remote"}),this.Ib=this.Eb.with({scheme:g.$uAb,authority:"accepted"}),this.B(L.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?f(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,y=await this.vb(),v=await this.Cb();let P=null,S=!1,k=!1,D=!1;if(r){let U=y?y.value.toString():"[]";if(U=U||"[]",this.Ab(U,!0))throw new g.$iAb((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Q=await(0,h.$u$b)(U,r,a,v,this.zb);Q.hasChanges&&(P=Q.mergeContent,D=Q.hasConflicts,S=D||Q.mergeContent!==U,k=D||Q.mergeContent!==r)}}else y&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),P=y.value.toString(),k=!0);const T={content:D?a:P,localChange:S?y?2:1:0,remoteChange:k?2:0,hasConflicts:D},F=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:F,localChange:T.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:T.remoteChange,previewResource:this.Eb,previewResult:T,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,h.$u$b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:y,remoteChange:v}=s[0][1];if(y===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new g.$iAb((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(y!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),v!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const P=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(P,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,j.$En)(o.value.toString());if((0,R.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:f(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,A.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(g.$9zb)}};e.$w$b=c,e.$w$b=c=Ee([X(2,g.$dAb),X(3,g.$eAb),X(4,g.$sAb),X(5,$.$Xi),X(6,g.$nAb),X(7,b.$Xk),X(8,E.$yi),X(9,m.$Vp),X(10,g.$rAb),X(11,u.$Wl),X(12,l.$vl)],c);let d=class extends p.$bLb{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$Ce.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$En)(o.value.toString());return!(0,R.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return f(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$x$b=d,e.$x$b=d=Ee([X(0,b.$Xk),X(1,w.$xl),X(2,E.$yi),X(3,g.$sAb),X(4,m.$Vp),X(5,l.$vl)],d)}),define(ae[118],ce([0,1,15,3,177,21,76,16,29,12,19,22,28,18,39,246,25]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A$b=e.$z$b=void 0,e.$y$b=g;function h(d){return d&&d.settings&&typeof d.settings=="string"&&Object.keys(d).length===1}function g(d){const i=JSON.parse(d);return h(i)?i:{settings:d}}let f=class extends l.$aLb{constructor(i,o,n,s,t,r,a,y,v,P,S,k,D,T){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,S,k,y,v,P,T),this.Eb=D,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.$uAb,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.$uAb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.$uAb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.$uAb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new A.$to(p.$8zb,this.O);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(p.$8zb)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,y=await this.Pb();let v=null,P=!1,S=!1,k=!1;if(r){let U=s?s.value.toString().trim():"{}";U=U||"{}",this.Qb(U),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Q=(0,w.$TJb)(U,r.settings,a?a.settings:null,y,[],t);v=Q.localContent||Q.remoteContent,P=Q.localContent!==null,S=Q.remoteContent!==null,k=Q.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),v=s.value.toString().trim()||"{}",this.Qb(v),S=!0);const D=s?s.value.toString():null,T=a?.settings??null,F={content:k?T:v,localChange:P?2:0,remoteChange:S?2:0,hasConflicts:k};return[{fileContent:s,baseResource:this.baseResource,baseContent:T,localResource:this.localResource,localContent:D,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,w.$TJb)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,w.$SJb)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,w.$SJb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,w.$SJb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,w.$SJb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:y}=n[0][1];if(a===0&&y===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),y!==0){const v=await this.Cb(),P=this.Lb(i),S=await this.Pb(r);r=(0,w.$SJb)(r,P?P.settings:"{}",S,v),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,w.$UJb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,w.$SJb)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return g(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,w.$QJb)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new p.$iAb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$z$b=f,e.$z$b=f=Ee([X(2,$.$Xk),X(3,I.$yi),X(4,E.$Vp),X(5,p.$dAb),X(6,p.$eAb),X(7,p.$sAb),X(8,p.$rAb),X(9,j.$Xi),X(10,p.$nAb),X(11,b.$Wl),X(12,C.$4o),X(13,m.$vl)],f);let c=class extends l.$bLb{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,R.$Ce.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,w.$UJb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return g(i)}catch(o){this.j.error(o)}return null}};e.$A$b=c,e.$A$b=c=Ee([X(0,$.$Xk),X(1,u.$xl),X(2,I.$yi),X(3,p.$sAb),X(4,E.$Vp),X(5,m.$vl)],c)}),define(ae[119],ce([0,1,15,3,30,21,16,12,19,22,28,18,39,243,25]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=e.$E$b=void 0,e.$D$b=w;function w(g){return JSON.parse(g.content)}let p=class extends m.$$Kb{constructor(f,c,d,i,o,n,s,t,r,a,y,v){super({syncResource:"snippets",profile:f},c,i,d,o,n,s,a,y,t,r,v),this.pb=1,this.vb=f.snippetsHome,this.B(this.G.watch(d.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,P=>P.affects(this.vb))(()=>this.Q()))}async qb(f,c,d){const i=await this.Hb(),o=this.Gb(i),n=f.syncData?this.Fb(f.syncData):null;c=c===null&&d?f:c;const s=c&&c.syncData?this.Fb(c.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,u.$B$b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub(f){const c=f.syncData?this.Fb(f.syncData):null;if(c===null)return!0;const d=await this.Hb(),i=this.Gb(d),o=(0,u.$B$b)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(f,c){return f.previewResult}async sb(f,c,d,i){if(this.h.isEqualOrParent(c,this.g.with({scheme:l.$uAb,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(c,this.g.with({scheme:l.$uAb,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(c,this.g))return d===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:d,localChange:d===null?f.fileContent!==null?3:0:2,remoteChange:d===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(f,c,d,i){const o=d.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&(f=await this.Eb(o,f,i)),c?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(f,c,d,i){const o=new Map;for(const n of Object.keys(f.local.added)){const s={content:f.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"remote"}),remoteContent:d[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"accepted"})})}for(const n of Object.keys(f.local.updated)){const s={content:f.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"remote"}),remoteContent:d[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"accepted"})})}for(const n of f.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"accepted"})})}for(const n of Object.keys(f.remote.added)){const s={content:f.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"accepted"})})}for(const n of Object.keys(f.remote.updated)){const s={content:f.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"remote"}),remoteContent:d[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"accepted"})})}for(const n of f.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"remote"}),remoteContent:d[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"accepted"})})}for(const n of f.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:d[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"remote"}),remoteContent:d[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"remote"}),remoteContent:d[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$uAb,authority:"accepted"})})}return[...o.values()]}async resolveContent(f){return this.h.isEqualOrParent(f,this.g.with({scheme:l.$uAb,authority:"remote"}))||this.h.isEqualOrParent(f,this.g.with({scheme:l.$uAb,authority:"local"}))||this.h.isEqualOrParent(f,this.g.with({scheme:l.$uAb,authority:"base"}))||this.h.isEqualOrParent(f,this.g.with({scheme:l.$uAb,authority:"accepted"}))?this.db(f):null}async hasLocalData(){try{const f=await this.Hb();if(Object.keys(f).length)return!0}catch{}return!1}async Cb(f){const c={};for(const d of f)d.fileContent&&(c[this.h.basename(d.localResource)]=d.fileContent);await this.nb(JSON.stringify(this.Gb(c)))}async Db(f,c){for(const{fileContent:d,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of f)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,R.$Ce.fromString(i.content),{overwrite:c}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,R.$Ce.fromString(i.content),c?void 0:d),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(f,c,d){const i=c.syncData?this.Fb(c.syncData):{},o=(0,L.$Xn)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of f)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,u.$C$b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),c=await this.mb(JSON.stringify(o),d?null:c.ref),this.O.info(`${this.D}: Updated remote snippets`)),c}Fb(f){return w(f)}Gb(f){const c={};for(const d of Object.keys(f))c[d]=f[d].value.toString();return c}async Hb(){const f={};let c;try{c=await this.G.resolve(this.vb)}catch(d){if(d instanceof I.$gl&&d.fileOperationResult===1)return f;throw d}for(const d of c.children||[]){const i=d.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);f[n]=s}}return f}};e.$E$b=p,e.$E$b=p=Ee([X(2,A.$yi),X(3,I.$Xk),X(4,C.$Vp),X(5,l.$dAb),X(6,l.$eAb),X(7,l.$sAb),X(8,j.$Xi),X(9,l.$nAb),X(10,$.$Wl),X(11,E.$vl)],p);let h=class extends m.$bLb{constructor(f,c,d,i,o,n){super("snippets",c,d,i,f,o,n)}async o(f){const c=f.syncData?JSON.parse(f.syncData.content):null;if(!c){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,R.$Ce.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(f)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};e.$F$b=h,e.$F$b=h=Ee([X(0,I.$Xk),X(1,b.$xl),X(2,A.$yi),X(3,l.$sAb),X(4,C.$Vp),X(5,E.$vl)],h)}),define(ae[120],ce([0,1,15,21,16,12,19,22,28,18,39,25]),function(ne,e,R,N,L,j,A,I,C,$,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=e.$H$b=void 0,e.$G$b=m;function m(p,h){try{return JSON.parse(p).tasks??null}catch(g){return h.error(g),null}}let u=class extends E.$_Kb{constructor(h,g,f,c,d,i,o,n,s,t,r,a){super(h.tasksResource,{syncResource:"tasks",profile:h},g,n,s,t,f,c,o,r,d,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:b.$uAb,authority:"base"}),this.Cb=this.Ab.with({scheme:b.$uAb,authority:"local"}),this.Db=this.Ab.with({scheme:b.$uAb,authority:"remote"}),this.Eb=this.Ab.with({scheme:b.$uAb,authority:"accepted"})}async qb(h,g,f,c){const d=h.syncData?m(h.syncData.content,this.O):null;g=g===null&&f?h:g;const i=g?.syncData?m(g.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(h.syncData){const v=o?o.value.toString():null;if(!i||i!==v||i!==d){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const P=w(v,d,i);n=P.content,r=P.hasConflicts,s=P.hasLocalChanged,t=P.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},y=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:y,localChange:a.localChange,remoteResource:this.Db,remoteContent:d,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(h){const g=h?.syncData?m(h.syncData.content,this.O):null;if(g===null)return!0;const f=await this.vb(),c=f?f.value.toString():null,d=w(c,g,g);return d.hasLocalChanged||d.hasRemoteChanged}async rb(h,g){return h.previewResult}async sb(h,g,f,c){if(this.h.isEqual(g,this.Cb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(g,this.Db))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(g,this.Ab))return f===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:f,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async tb(h,g,f,c){const{fileContent:d}=f[0][0],{content:i,localChange:o,remoteChange:n}=f[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),d&&await this.nb(JSON.stringify(this.Kb(d.value.toString()))),i?await this.wb(i,d,c):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));h=await this.mb(s,c?null:h.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}g?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(h){return this.h.isEqual(this.Db,h)||this.h.isEqual(this.Bb,h)||this.h.isEqual(this.Cb,h)||this.h.isEqual(this.Eb,h)?this.db(h):null}Kb(h){return h?{tasks:h}:{}}};e.$H$b=u,e.$H$b=u=Ee([X(2,b.$dAb),X(3,b.$eAb),X(4,b.$sAb),X(5,N.$Xi),X(6,b.$nAb),X(7,j.$Xk),X(8,L.$yi),X(9,A.$Vp),X(10,I.$Wl),X(11,C.$vl)],u);let l=class extends E.$bLb{constructor(h,g,f,c,d,i){super("tasks",g,f,c,h,d,i),this.c=this.g.defaultProfile.tasksResource}async o(h){const g=h.syncData?m(h.syncData.content,this.j):null;if(!g){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,R.$Ce.fromString(g)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.$I$b=l,e.$I$b=l=Ee([X(0,j.$Xk),X(1,$.$xl),X(2,L.$yi),X(3,b.$sAb),X(4,A.$Vp),X(5,C.$vl)],l);function w(p,h,g){if(p===null&&h===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(p===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const f=g!==p,c=g!==h;return!f&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:f&&!c?{content:p,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!f?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:p,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[121],ce([0,1,43,21,16,12,19,22,28,18,39,244,25]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0,e.$qac=l,e.$rac=w;let u=class extends E.$$Kb{constructor(h,g,f,c,d,i,o,n,s,t,r,a,y){super({syncResource:"profiles",profile:h},g,c,d,i,o,n,r,a,s,t,y),this.vb=f,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$uAb,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$uAb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$uAb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$uAb,authority:"accepted"}),this.B(f.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?w(h.syncData):null}async getRemoteSyncedProfiles(h){const g=await this.getLastSyncUserData(),f=await this.X(h,g);return f?.syncData?w(f.syncData):null}async qb(h,g,f){if(!this.vb.isEnabled())throw new m.$iAb("Cannot sync profiles because they are disabled","LocalError");const c=h.syncData?w(h.syncData):null,d=g?.syncData?w(g.syncData):null,i=this.Db(),{local:o,remote:n}=(0,b.$oac)(i,c,d,[]),s={local:o,remote:n,content:d?this.Eb(d):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=l(i,!1);return[{baseResource:this.baseResource,baseContent:d?this.Eb(d):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.Eb(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(h){const g=h?.syncData?w(h.syncData):null,f=this.Db(),{remote:c}=(0,b.$oac)(f,g,g,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async rb(h,g){return{...h.previewResult,hasConflicts:!1}}async sb(h,g,f,c){if(this.h.isEqual(g,this.localResource))return this.Ab(h);if(this.h.isEqual(g,this.remoteResource))return this.Bb(h);if(this.h.isEqual(g,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async Ab(h){const g=this.Db(),f=(0,b.$oac)(g,null,null,[]),{local:c,remote:d}=f;return{content:h.localContent,local:c,remote:d,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:d!==null?2:0}}async Bb(h){const g=h.remoteContent?JSON.parse(h.remoteContent):null,f=[],c=[];for(const d of this.Db()){const i=g?.find(o=>o.id===d.id);i&&(f.push({id:d.id,name:d.name,collection:i.collection}),c.push(d))}if(g!==null){const d=(0,b.$oac)(c,g,f,[]),{local:i,remote:o}=d;return{content:h.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(h,g,f,c){const{local:d,remote:i,localChange:o,remoteChange:n}=f[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=f[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.$iAb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0&&(await this.nb(l(this.Db(),!1)),await Promise.all(d.removed.map(async t=>{this.O.trace(`${this.D}: Removing '${t.name}' profile...`),await this.vb.removeProfile(t),this.O.info(`${this.D}: Removed profile '${t.name}'.`)})),await Promise.all(d.added.map(async t=>{this.O.trace(`${this.D}: Creating '${t.name}' profile...`),await this.vb.createProfile(t.id,t.name,{shortName:t.shortName,icon:t.icon,useDefaultFlags:t.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${t.name}'.`)})),await Promise.all(d.updated.map(async t=>{const r=this.vb.profiles.find(a=>a.id===t.id);r?(this.O.trace(`${this.D}: Updating '${t.name}' profile...`),await this.vb.updateProfile(r,{name:t.name,shortName:t.shortName,icon:t.icon,useDefaultFlags:t.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${t.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${t.id}' to update.`)}))),n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const y=await this.J.createCollection(this.F);t.push(y),s.push({id:a.id,name:a.name,collection:y,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:y})=>a.id===y),1);for(const a of i?.updated||[]){const y=s.find(({id:v})=>a.id===v);y&&s.splice(s.indexOf(y),1,{...y,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{h=await this.updateRemoteProfiles(s,c?null:h.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of t)await this.J.deleteCollection(y,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}g?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,g){return this.mb(this.Eb(h),g)}async hasLocalData(){return this.Db().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const g=await this.db(h);return g&&(0,R.$Pn)(JSON.parse(g),{})}return null}Db(){return this.vb.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Eb(h){return JSON.stringify([...h].sort((g,f)=>g.name.localeCompare(f.name)))}};e.$pac=u,e.$pac=u=Ee([X(2,$.$xl),X(3,j.$Xk),X(4,L.$yi),X(5,A.$Vp),X(6,m.$dAb),X(7,m.$eAb),X(8,m.$sAb),X(9,N.$Xi),X(10,m.$nAb),X(11,I.$Wl),X(12,C.$vl)],u);function l(p,h){const g=[...p].sort((f,c)=>f.name.localeCompare(c.name)).map(f=>({id:f.id,name:f.name}));return h?(0,R.$Pn)(g,{}):JSON.stringify(g)}function w(p){return JSON.parse(p.content)}}),define(ae[261],ce([0,1,3,2,5,16,19,22,25]),function(ne,e,R,N,L,j,A,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=void 0;const $="sync.enable";let E=class extends N.$Uc{constructor(m,u,l,w){super(),this.c=m,this.f=u,this.g=l,this.h=w,this.a=new R.$be,this.onDidChangeEnablement=this.a.event,this.b=new R.$be,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(-1,void 0,this.B(new N.$Tc))(p=>this.m(p)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean($,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2($,{enabled:m}),this.c.store($,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,C.$mAb)(m),-1,!0)}setResourceEnablement(m,u){if(this.isResourceEnabled(m)!==u){const l=(0,C.$mAb)(m);this.j(l,u)}}getResourceSyncStateVersion(m){}j(m,u){this.c.store(m,u,-1,L.$o?0:1)}m(m){if($===m.key){this.a.fire(this.isEnabled());return}const u=C.$_zb.filter(l=>(0,C.$mAb)(l)===m.key)[0];if(u){this.b.fire([u,this.isResourceEnabled(u)]);return}}};e.$cac=E,e.$cac=E=Ee([X(0,A.$Vp),X(1,I.$Wl),X(2,j.$yi),X(3,C.$cAb)],E)}),define(ae[262],ce([0,1,6,15,65,2,20,21,16,12,18,25]),function(ne,e,R,N,L,j,A,I,C,$,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=void 0;let m=class extends j.$Uc{constructor(l,w,p,h,g){super(),this.a=l,this.b=w,this.c=p,this.f=h,this.g=g,this.h()}async h(){for(const w of this.g.profiles)for(const p of b.$_zb)try{await this.m(this.j(p,w.isDefault?void 0:w.id))}catch(h){this.f.error(h)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(w){(0,$.$cl)(w)!==1&&this.f.error(w);return}if(l.children){for(const w of l.children)if(w.isDirectory&&!this.g.profiles.some(p=>p.id===w.name))try{this.f.info("Deleting non existing profile from backup",w.resource.path),await this.b.del(w.resource,{recursive:!0})}catch(p){this.f.error(p)}}}async getAllResourceRefs(l,w,p){const h=this.j(l,w,p);try{const g=await this.b.resolve(h);if(g.children)return g.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.n(c)}))}catch(g){if((0,$.$cl)(g)!==1)throw g}return[]}async resolveResourceContent(l,w,p,h){const g=this.j(l,p,h),f=(0,A.$5g)(g,w);try{return(await this.b.readFile(f)).value.toString()}catch(c){return this.f.error(c),null}}async writeResource(l,w,p,h,g){const f=this.j(l,h,g),c=(0,A.$5g)(f,`${(0,L.$Ym)(p).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(c,N.$Ce.fromString(w))}catch(d){this.f.error(d)}}j(l,w,p=this.a.userDataSyncHome){return(0,A.$5g)(p,...w?[w,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const w=await this.b.resolve(l);if(w.children){const p=w.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let g=p.filter(c=>Date.now()-this.n(c)>h);const f=p.length-g.length;f<10&&(g=g.slice(10-f)),await R.Promises.settled(g.map(async c=>{this.f.info("Deleting from backup",c.resource.path),await this.b.del(c.resource)}))}}catch(w){this.f.error(w)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$nac=m,e.$nac=m=Ee([X(0,C.$yi),X(1,$.$Xk),X(2,I.$Xi),X(3,b.$sAb),X(4,E.$xl)],m)}),define(ae[83],ce([0,1,3,2,5,27,181,16,12,4,24,45,19,25]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$5zb=e.$3zb=void 0,e.$4zb=d,e.$3zb=(0,$.$ri)("IUserDataSyncMachinesService");const w="sync.currentMachineName",p="Safari",h="Chrome",g="Edge",f="Firefox",c="Android";function d(n){switch(n){case p:case h:case g:case f:case c:case(0,L.$h)(0):return!0}return!1}function i(){return L.$G?p:L.$E?h:L.$H?g:L.$F?f:L.$I?c:(0,L.$h)(L.$o?0:L.$u)}let o=class extends N.$Uc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,y,v){super(),this.h=r,this.j=a,this.m=y,this.n=v,this.c=this.B(new R.$be),this.onDidChange=this.c.event,this.g=null,this.f=(0,b.$2p)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:y})=>y!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),y=a.machines.find(({id:v})=>v===s);if(y){y.name=t,await this.t(a);const v=await this.f;s===v&&this.h.store(w,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const y=t.machines.find(v=>v.id===r);y&&(y.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(w,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$9e)(r)}\\s#(\\d+)`);let y=0;for(const v of s){const P=a.exec(v.name),S=P?parseInt(P[1]):0;y=S>y?S:y}return`${r} #${y+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==l.a)throw new Error((0,A.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource(l.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[l.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:l.a,machines:[]}}};e.$5zb=o,e.$5zb=o=l=Ee([X(0,I.$yi),X(1,C.$Xk),X(2,m.$Vp),X(3,u.$dAb),X(4,u.$sAb),X(5,E.$ek)],o)}),define(ae[263],ce([0,1,6,65,38,7,3,2,5,20,8,178,24,19,22,25,80,83]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=void 0;const g="sync.disableMachineEventually",f="sync.sessionId",c="sync.storeUrl",d="sync.productQuality";let i=class extends I.$Uc{get n(){const s=this.H.get(c,-1);return s?E.URI.parse(s):void 0}set n(s){s?this.H.store(c,s.toString(),-1,1):this.H.remove(c,-1)}get s(){return this.H.get(d,-1)}set s(s){s?this.H.store(d,s,-1,1):this.H.remove(d,-1)}constructor(s,t,r,a,y,v,P,S,k,D){super(),this.u=t,this.w=r,this.y=a,this.z=y,this.C=v,this.D=P,this.F=S,this.G=k,this.H=D,this.a=this.B(new I.$Vc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new A.$be),this.onError=this.h.event,this.S=[],this.f=this.B(new R.$ph(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,$.$Xg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(P.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(y.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this.B(A.Event.filter(this.y.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$Ym)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(f,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=w.$iAb.toUserDataSyncError(s);t instanceof w.$kAb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?C.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(g,!0,-1,1),await(0,R.$sh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(g,-1,!1)}R(){this.H.remove(g,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$tac=i,e.$tac=i=Ee([X(0,m.$ek),X(1,w.$cAb),X(2,w.$dAb),X(3,w.$nAb),X(4,w.$oAb),X(5,w.$sAb),X(6,p.$yJb),X(7,l.$Wl),X(8,h.$3zb),X(9,u.$Vp)],i);class o extends I.$Uc{static{this.a="Interval"}constructor(s,t,r,a,y,v,P,S,k){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=y,this.w=v,this.y=P,this.z=S,this.C=k,this.b=this.B(new I.$Vc),this.c=this.B(new A.$be),this.onDidStartSync=this.c.event,this.f=this.B(new A.$be),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$Sc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,R.$th)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,R.$eh)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(y){if((0,j.$4)(y))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,$.$Xg)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,$.$Xg)(t.defaultUrl,s.defaultUrl)||!(0,$.$Xg)(t.insidersUrl,s.insidersUrl)||!(0,$.$Xg)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(y){if(this.y.error(y),a=y,w.$iAb.toUserDataSyncError(y).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(v){this.y.error(v),a=v}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new w.$kAb((0,b.localize)(0,null),"DefaultServiceChanged"):new w.$kAb((0,b.localize)(1,null),"ServiceChanged"):new w.$kAb((0,b.localize)(2,null),"TurnedOff");const r=this.C.get(f,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new w.$kAb((0,b.localize)(3,null),"DefaultServiceChanged"):new w.$kAb((0,b.localize)(4,null),"ServiceChanged"):new w.$kAb((0,b.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const y=a.find(P=>P.isCurrent);if(y?.disabled)throw new w.$kAb((0,b.localize)(6,null),"TurnedOff");const v=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-v}),this.g===null)try{this.g=await this.s.manifest(null)}catch(P){throw new w.$kAb((0,L.$cj)(P),P instanceof w.$iAb?P.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(f,this.g.session,-1,1),!t.isCancellationRequested&&(y||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(ae[264],ce([0,1,8,182,16,12,45,19,28,25,18,39,119,118,117,21,120,115,116,4,121,43,27]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c,d,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,y,v,P,S,k,D,T){this.e=t,this.f=r,this.g=a,this.h=v,this.i=P,this.j=S,this.k=k,this.l=D,this.n=T,this.d=y.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,c.$rac)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const y=this.L(a,"profiles");return(0,c.$rac)(y)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(v=>({...v,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:y,ref:v})=>({created:y,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:v,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:v,ref:P})=>({created:v,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:P,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(y=>y.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(y=>y.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,A.$2p)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,y,v){if(t){const{content:P}=await this.M(r,y,a);return P}return this.f.resolveResourceContent(r,y,a,v)}q(t,r,a){const y=this.L(r,t);switch(t){case"settings":return this.t(y,a);case"keybindings":return this.v(y,a);case"tasks":return this.x(y,a);case"snippets":return this.z(y,a);case"globalState":return this.E(y,a);case"extensions":return this.B(y,a);case"profiles":return this.H(y,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(y=>y.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),y=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}t(t,r){switch(r){case"settings.json":return(0,u.$y$b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),y=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}v(t,r){switch(r){case"keybindings.json":return(0,l.$v$b)(t.content,!!this.l.getValue($.$9zb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),y=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}x(t,r){switch(r){case"tasks.json":return(0,p.$G$b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const y=this.L(a,"snippets");if(y){const v=(0,m.$D$b)(y),P=[];for(const S of Object.keys(v)){const k=this.d.joinPath(t,S),D=r?this.d.joinPath(r.snippetsHome,S):this.d.joinPath(t,o.a);P.push({resource:k,comparableResource:D})}return P}}return[]}z(t,r){return(0,m.$D$b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),y=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}B(t,r){switch(r){case"extensions.json":return(0,h.$q$b)((0,h.$p$b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(h.$s$b).getLocalExtensions(t);return(0,h.$q$b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),y=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}E(t,r){switch(r){case"globalState.json":return(0,g.$dLb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(g.$fLb).getLocalGlobalState(t);return(0,g.$dLb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),y=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:y}]}H(t,r){switch(r){case"profiles.json":return(0,d.$Pn)(JSON.parse(t.content),{})}return null}async I(t){return(0,c.$qac)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$af)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(R.URI.from({scheme:$.$uAb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==$.$uAb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let y,v;const P=[];let S,k,D,T,F;for(;r.length;){const U=r.shift();U.startsWith("scheme:")?y=U.substring(7):U.startsWith("authority:")?v=U.substring(10):U.startsWith("syncResource:")?S=U.substring(13):U.startsWith("profile:")?k=U.substring(8):U.startsWith("collection:")?D=U.substring(11):U.startsWith("ref:")?T=U.substring(4):S?F=U:P.push(U)}return{remote:a,syncResource:S,profile:k,collection:D,ref:T,node:F,location:y&&v!==void 0?this.d.joinPath(R.URI.from({scheme:y,authority:v,query:t.query,fragment:t.fragment,path:"/"}),...P):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,b.$9Kb)(a))return a}catch(a){this.g.error(a)}throw new $.$iAb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const y=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:y}}};e.$2ac=n,e.$2ac=n=o=Ee([X(0,$.$dAb),X(1,$.$eAb),X(2,$.$sAb),X(3,C.$vl),X(4,L.$yi),X(5,I.$Vp),X(6,j.$Xk),X(7,E.$xl),X(8,w.$Xi),X(9,f.$qi)],n)}),define(ae[265],ce([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c,d,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0;const t="sync.lastSyncTime";let r=class extends I.$Uc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,k,D,T,F,U,Q,G,Y,W,J){super(),this.C=S,this.D=k,this.F=D,this.G=T,this.H=F,this.I=U,this.J=Q,this.L=G,this.M=Y,this.N=W,this.O=J,this.f="uninitialized",this.g=this.B(new A.$be),this.onDidChangeStatus=this.g.event,this.h=this.B(new A.$be),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new A.$be),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new A.$be),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new A.$be),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new A.$be),this.onDidResetLocal=this.w.event,this.y=this.B(new A.$be),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=D.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,I.$Sc)(()=>this.bb()))}async createSyncTask(S,k){this.cb(),this.H.info("Sync started.");const D=new Date().getTime(),T=(0,E.$Ng)();try{const G=(0,s.$hAb)(T);k&&(G["Cache-Control"]="no-cache"),S=await this.D.manifest(S,G)}catch(G){const Y=s.$iAb.toUserDataSyncError(G);throw v(Y,T,this.F,this.I),Y}const F=!1,U=this;let Q;return{manifest:S,async run(){if(F)throw new Error("Can run a task only once");Q=(0,N.$eh)(G=>U.P(S,!1,T,G)),await Q.finally(()=>Q=void 0),U.H.info(`Sync done. Took ${new Date().getTime()-D}ms`),U.$()},stop(){return Q?.cancel(),U.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$iAb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const S=new Date().getTime(),k=(0,E.$Ng)(),D=(0,s.$hAb)(k);let T;try{T=await this.D.manifest(null,D)}catch(Q){const G=s.$iAb.toUserDataSyncError(Q);throw v(G,k,this.F,this.I),G}await this.resetLocal();const F=this,U=new L.$me;return{id:k,async merge(){return F.P(T,!0,k,U.token)},async apply(){try{try{await F.R(T,k,U.token)}catch(Q){if(s.$iAb.toUserDataSyncError(Q).code==="MethodNotFound")F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(T,k,U.token);else throw Q}}catch(Q){throw F.H.error(Q),Q}F.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),F.$()},async stop(){U.cancel(),await F.U(),await F.resetLocal()}}}async P(S,k,D,T){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,S,k,D,T));const U=F.enabled.find(Q=>Q.resource==="profiles");if(U){const Q=await U.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.Q(Q,S,k,D,T)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(S,k,D,T,F){for(const U of S){if(F.isCancellationRequested)return;const Q=this.M.profiles.find(Y=>Y.id===U.id);if(!Q){this.H.error(`Profile with id:${U.id} and name: ${U.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",U.name);const G=this.getOrCreateActiveProfileSynchronizer(Q,U);this.n.push(...await this.S(G,k,D,T,F))}for(const[U,Q]of this.z.entries())this.M.profiles.some(G=>G.id===Q[0].profile.id)||(Q[1].dispose(),this.z.delete(U))}async R(S,k,D){const T=this.ab();for(const Y of T){if(D.isCancellationRequested)return;await Y.apply(k,D)}const F=T.find(Y=>Y.profile.isDefault);if(!F)return;const U=F.enabled.find(Y=>Y.resource==="profiles");if(!U)return;const G=(await U.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(Y=>T.every(W=>W.profile.id!==Y.id));G.length&&await this.Q(G,S,!1,k,D)}async S(S,k,D,T,F){return(await S.sync(k,D,T,F)).map(([Q,G])=>({profile:S.profile,syncResource:Q,error:G}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(S=>S.stop()))}async resolveContent(S){const k=await this.N.resolveContent(S);if(k)return k;for(const D of this.ab())for(const T of D.enabled){const F=await T.resolveContent(S);if(F)return F}return null}async replace(S){this.cb();const k=this.N.resolveUserDataSyncResource(S);if(!k)return;const D=await this.resolveContent(S.uri);D&&await this.W(k.profile,async T=>{if(k.syncResource===T.resource)return await T.replace(D),!0})}async accept(S,k,D,T){this.cb(),await this.W(S.profile,async F=>{if(S.syncResource===F.resource)return await F.accept(k,D),T&&await F.apply((0,$.$$f)(T)?!1:T.force,(0,s.$hAb)((0,E.$Ng)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async k=>{if(k.resource!=="globalState"&&await k.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async k=>{if(await k.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[S]of this.z.values())try{await S.resetLocal()}catch(k){this.H.error(k)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),k=S.map(U=>U.collection),D=await this.D.getAllCollections(),T=D.filter(U=>!k.includes(U));T.length&&(this.H.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(U=>this.D.deleteCollection(U))),this.H.info("Deleted redundant collections on server"));const F=S.filter(U=>D.includes(U.collection));if(F.length!==S.length){const U=this.G.createInstance(n.$pac,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await U.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await U.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{U.dispose()}}}async saveRemoteActivityData(S){this.cb();const k=await this.D.getActivityData();await this.C.writeFile(S,k)}async extractActivityData(S,k){const D=(await this.C.readFile(S)).value.toString(),T=JSON.parse(D);if(T.resources)for(const F in T.resources)for(const U of T.resources[F])await this.O.writeResource(F,U.content,new Date(U.created*1e3),void 0,k);if(T.collections)for(const F in T.collections)for(const U in T.collections[F].resources)for(const Q of T.collections[F].resources?.[U]??[])await this.O.writeResource(U,Q.content,new Date(Q.created*1e3),F,k)}async W(S,k){const D=new I.$Tc;try{const T=this.z.get(S.id);if(T){const Y=await this.X(T[0],k,D);return(0,$.$_f)(Y)?null:Y}if(S.isDefault){const Y=D.add(this.G.createInstance(a,S,void 0)),W=await this.X(Y,k,D);return(0,$.$_f)(W)?null:W}if(this.M.isEnabled())return null;const F=D.add(this.G.createInstance(n.$pac,S,void 0)),U=await this.D.manifest(null),G=(await F.getRemoteSyncedProfiles(U?.latest??null)||[]).find(Y=>Y.id===S.id);if(G){const Y=D.add(this.G.createInstance(a,S,G.collection)),W=await this.X(Y,k,D);return(0,$.$_f)(W)?null:W}return null}finally{D.dispose()}}async X(S,k,D){const T=[...S.enabled,...S.disabled.reduce((F,U)=>(U!=="workspaceState"&&F.push(D.add(S.createSynchronizer(U))),F),[])];for(const F of T){const U=await k(F);if(!(0,$.$_f)(U))return U}}Y(S){const k=this.f;this.f!==S&&(this.f=S,this.g.fire(S),k==="hasConflicts"&&this.$())}Z(){const S=this.ab().map(k=>k.conflicts).flat();(0,R.$ub)(this.j,S,(k,D)=>k.profile.id===D.profile.id&&k.syncResource===D.syncResource&&(0,R.$ub)(k.conflicts,D.conflicts,(T,F)=>(0,C.$Xg)(T.previewResource,F.previewResource)))||(this.j=S,this.m.fire(S))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,k){let D=this.z.get(S.id);if(D&&D[0].collection!==k?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),D[1].dispose(),D=void 0,this.z.delete(S.id)),!D){const T=new I.$Tc,F=T.add(this.G.createInstance(a,S,k?.collection));T.add(F.onDidChangeStatus(U=>this.Y(U))),T.add(F.onDidChangeConflicts(U=>this.Z())),T.add(F.onDidChangeLocal(U=>this.h.fire(U))),this.z.set(S.id,D=[F,T])}return D[0]}ab(){const S=[];for(const[k]of this.z.values())S.push(k);return S}bb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$sac=r,e.$sac=r=Ee([X(0,u.$Xk),X(1,s.$dAb),X(2,s.$cAb),X(3,l.$qi),X(4,s.$sAb),X(5,p.$Wl),X(6,w.$Vp),X(7,s.$nAb),X(8,h.$xl),X(9,s.$pAb),X(10,s.$eAb)],r);let a=class extends I.$Uc{get enabled(){return this.f.sort((S,k)=>S[1]-k[1]).map(([S])=>S)}get disabled(){return s.$_zb.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,k,D,T,F,U,Q,G,Y,W){super(),this.profile=S,this.collection=k,this.r=D,this.t=T,this.u=F,this.w=U,this.y=Q,this.z=G,this.C=Y,this.D=W,this.f=[],this.g="idle",this.h=this.B(new A.$be),this.onDidChangeStatus=this.h.event,this.j=this.B(new A.$be),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new A.$be),this.onDidChangeConflicts=this.n.event,this.B(D.onDidChangeResourceEnablement(([J,H])=>this.F(J,H))),this.B((0,I.$Sc)(()=>this.f.splice(0,this.f.length).forEach(([,,J])=>J.dispose())));for(const J of s.$_zb)D.isResourceEnabled(J)&&this.G(J)}F(S,k){k?this.G(S):this.H(S)}G(S){if(this.f.some(([F])=>F.resource===S))return;if(S==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||S==="workspaceState")return;if(S!=="profiles"&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const k=new I.$Tc,D=k.add(this.createSynchronizer(S));k.add(D.onDidChangeStatus(()=>this.L())),k.add(D.onDidChangeConflicts(()=>this.M())),k.add(D.onDidChangeLocal(()=>this.j.fire(S)));const T=this.N(S);this.f.push([D,T,k])}H(S){const k=this.f.findIndex(([D])=>D.resource===S);if(k!==-1){const[[D,,T]]=this.f.splice(k,1);T.dispose(),this.L(),Promise.allSettled([D.stop(),D.resetLocal()]).then(null,F=>this.z.error(F))}}createSynchronizer(S){switch(S){case"settings":return this.t.createInstance(d.$z$b,this.profile,this.collection);case"keybindings":return this.t.createInstance(c.$w$b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$E$b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$H$b,this.profile,this.collection);case"globalState":return this.t.createInstance(f.$eLb,this.profile,this.collection);case"extensions":return this.t.createInstance(g.$r$b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$pac,this.profile,this.collection)}}async sync(S,k,D,T){if(T.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const U=[],Q=(0,s.$hAb)(D),G=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,Y=k?await this.I(G):{};for(const W of F){if(T.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(k){const J=await W.preview(G,Y,Q);if(J)for(const H of J.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await W.merge(H.previewResource)}else await W.sync(G,Q)}catch(J){const H=s.$iAb.toUserDataSyncError(J);if(v(H,D,this.w,this.y),y(J))throw H;this.z.error(J),this.z.error(`${W.resource}: ${(0,j.$cj)(J)}`),U.push([W.resource,H])}}return U}finally{this.L()}}async apply(S,k){const D=(0,s.$hAb)(S);for(const T of this.enabled){if(k.isCancellationRequested)return;try{await T.apply(!1,D)}catch(F){const U=s.$iAb.toUserDataSyncError(F);if(v(U,S,this.w,this.y),y(F))throw U;this.z.error(F),this.z.error(`${T.resource}: ${(0,j.$cj)(F)}`)}}}async stop(){for(const S of this.enabled)try{S.status!=="idle"&&await S.stop()}catch(k){this.z.error(k)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(k){this.z.error(`${S.resource}: ${(0,j.$cj)(k)}`),this.z.error(k)}}async I(S){if(!this.profile.isDefault)return{};const k=this.D.getValue(s.$8zb),D=this.enabled.find(T=>T instanceof d.$z$b);if(D){const T=await D.getRemoteUserDataSyncConfiguration(S);return{...k,...T}}return k}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(S=>S.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const S=this.enabled.filter(k=>k.status==="hasConflicts").filter(k=>k.conflicts.conflicts.length>0).map(k=>k.conflicts);(0,R.$ub)(this.m,S,(k,D)=>k.syncResource===D.syncResource&&(0,R.$ub)(k.conflicts,D.conflicts,(T,F)=>(0,C.$Xg)(T.previewResource,F.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=Ee([X(2,s.$nAb),X(3,l.$qi),X(4,m.$1o),X(5,s.$cAb),X(6,p.$Wl),X(7,s.$sAb),X(8,h.$xl),X(9,b.$Xi)],a);function y(P){if(P instanceof s.$iAb)switch(P.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function v(P,S,k,D){D.publicLog2("sync/error",{code:P.code,serverCode:P instanceof s.$jAb?String(P.serverCode):void 0,url:P instanceof s.$jAb?P.url:void 0,resource:P.resource,executionId:S,service:k.userDataSyncStore.url.toString()})}}),define(ae[266],ce([0,1,3,2,8,18,25]),function(ne,e,R,N,L,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=void 0;function I(m,u){return{...m,profile:(0,j.$yl)(m.profile,u.profilesHome.scheme)}}function C(m){return{created:m.created,uri:L.URI.revive(m.uri)}}class ${constructor(u,l,w){this.c=u,this.d=l,this.f=w,this.a=new Map,this.b=new R.$be}listen(u,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(u,l,w){try{return await this.g(u,l,w)}catch(p){throw this.f.error(p),p}}async g(u,l,w){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(w[0]));case"accept":return this.c.accept(I(w[0],this.d),L.URI.revive(w[1]),w[2],w[3]);case"replace":return this.c.replace(C(w[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(w[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(w[0]),L.URI.revive(w[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const p=l.substring(11),h=w[0],g=this.h(h);switch(w=w.slice(1),p){case"merge":return g.merge();case"apply":return g.apply().then(()=>this.a.delete(this.j(g.id)));case"stop":return g.stop().finally(()=>this.a.delete(this.j(g.id)))}}throw new Error("Invalid call")}h(u){const l=this.a.get(this.j(u));if(!l)throw new Error(`Manual sync taks not found: ${u}`);return l}async i(){const u=await this.c.createManualSyncTask();return this.a.set(this.j(u.id),u),u.id}j(u){return`manualSyncTask-${u}`}}e.$Mdc=$;let E=class extends N.$Uc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(u,l){super(),this.n=l,this.b="uninitialized",this.c=this.B(new R.$be),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new R.$be),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new R.$be),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new R.$be),this.onSyncErrors=this.m.event,this.a={call(w,p,h){return u.call(w,p,h).then(null,g=>{throw A.$iAb.toUserDataSyncError(g)})},listen(w,p){return u.listen(w,p)}},this.a.call("_getInitialData").then(([w,p,h])=>{this.s(w),this.t(p),h&&this.u(h),this.B(this.a.listen("onDidChangeStatus")(g=>this.s(g))),this.B(this.a.listen("onDidChangeLastSyncTime")(g=>this.u(g)))}),this.B(this.a.listen("onDidChangeConflicts")(w=>this.t(w))),this.B(this.a.listen("onSyncErrors")(w=>this.m.fire(w.map(p=>({...p,error:A.$iAb.toUserDataSyncError(p.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const u=await this.a.call("createManualSyncTask"),l=this;return new b(u,{async call(p,h,g){return l.a.call(`manualSync/${p}`,[u,...Array.isArray(h)?h:[h]],g)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(u,l,w,p){return this.a.call("accept",[u,l,w,p])}resolveContent(u){return this.a.call("resolveContent",[u])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(u){return this.a.call("replace",[u])}saveRemoteActivityData(u){return this.a.call("getRemoteActivityData",[u])}extractActivityData(u,l){return this.a.call("extractActivityData",[u,l])}async s(u){this.b=u,this.c.fire(u)}async t(u){this.f=u.map(l=>({syncResource:l.syncResource,profile:(0,j.$yl)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(w=>({...w,baseResource:L.URI.revive(w.baseResource),localResource:L.URI.revive(w.localResource),remoteResource:L.URI.revive(w.remoteResource),previewResource:L.URI.revive(w.previewResource)}))})),this.g.fire(this.f)}u(u){this.h!==u&&(this.h=u,this.j.fire(u))}};e.$Ndc=E,e.$Ndc=E=Ee([X(1,j.$xl)],E);class b extends N.$Uc{constructor(u,l){super(),this.id=u,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ae[122],ce([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,45,19,25]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Kb=e.$6Kb=e.$5Kb=e.$4Kb=e.$3Kb=void 0;const d="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends A.$Uc{get userDataSyncStore(){return this.b}get c(){return this.h.get(c.$lAb,-1)}set c(D){this.h.store(c.$lAb,D,-1,C.$o?0:1)}constructor(D,T,F){super(),this.f=D,this.g=T,this.h=F,this.a=this.B(new j.$be),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const U=this.B(new A.$Tc);this.B(j.Event.filter(F.onDidChangeValue(-1,c.$lAb,U),()=>this.c!==this.userDataSyncStore?.type,U)(()=>this.j()))}j(){this.b=this.m(this.f[d]),this.a.fire()}m(D){if(D&&(D=C.$o&&D.web?{...D,...D.web}:D,(0,E.$5f)(D.url)&&(0,E.$7f)(D.authenticationProviders)&&Object.keys(D.authenticationProviders).every(T=>Array.isArray(D.authenticationProviders[T].scopes)))){const T=D,F=!!T.canSwitch,U=T.url===T.insidersUrl?"insiders":"stable",Q=(F?this.c:void 0)||U,G=Q==="insiders"?T.insidersUrl:Q==="stable"?T.stableUrl:T.url;return{url:b.URI.parse(G),type:Q,defaultType:U,defaultUrl:b.URI.parse(T.url),stableUrl:b.URI.parse(T.stableUrl),insidersUrl:b.URI.parse(T.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(T.authenticationProviders).reduce((Y,W)=>(Y.push({id:W,scopes:T.authenticationProviders[W].scopes}),Y),[])}}}};e.$3Kb=a,e.$3Kb=a=Ee([X(0,p.$ek),X(1,u.$Xi),X(2,f.$Vp)],a);let y=class extends a{constructor(D,T,F){super(D,T,F);const U=this.h.get(i,-1);U&&(this.n=JSON.parse(U));const Q=this.f[d];Q?this.h.store(i,JSON.stringify(Q),-1,1):this.h.remove(i,-1)}async switch(D){D!==this.c&&(this.c=D,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$4Kb=y,e.$4Kb=y=Ee([X(0,p.$ek),X(1,u.$Xi),X(2,f.$Vp)],y);let v=class extends A.$Uc{get donotMakeRequestsUntil(){return this.j}constructor(D,T,F,U,Q,G,Y){super(),this.n=F,this.r=U,this.s=Y,this.g=this.B(new j.$be),this.onTokenFailed=this.g.event,this.h=this.B(new j.$be),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$be),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(D),this.c=(0,g.$2p)(Q,G,Y).then(W=>{const J={"X-Client-Name":`${T.applicationName}${C.$o?"-web":""}`,"X-Client-Version":T.version};return T.commit&&(J["X-Client-Commit"]=T.commit),J}),this.f=new S(t,r,this.n,this.r),this.u(),this.B((0,A.$Sc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(D,T){this.b={token:D,type:T}}t(D){this.a=D?(0,$.$5g)(D,"v1"):void 0}u(){const D=this.s.getNumber(o,-1);D&&Date.now()<D&&this.y(new Date(D))}y(D){this.j?.getTime()!==D?.getTime()&&(this.j=D,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,R.$eh)(T=>(0,R.$sh)(this.j.getTime()-Date.now(),T).then(()=>this.y(void 0))),this.w.then(null,T=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(D={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,$.$5g)(this.a,"collection").toString();D={...D},D["Content-Type"]="application/json";const F=await this.D(T,{type:"GET",headers:D},[],N.CancellationToken.None);return(await(0,h.$Op)(F))?.map(({id:U})=>U)||[]}async createCollection(D={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,$.$5g)(this.a,"collection").toString();D={...D},D["Content-Type"]=I.$Ks.text;const F=await this.D(T,{type:"POST",headers:D},[],N.CancellationToken.None),U=await(0,h.$Np)(F);if(!U)throw new c.$jAb("Server did not return the collection id",T,"NoCollection",F.res.statusCode,F.res.headers[c.$fAb]);return U}async deleteCollection(D,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=D?(0,$.$5g)(this.a,"collection",D).toString():(0,$.$5g)(this.a,"collection").toString();T={...T},await this.D(F,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async getAllResourceRefs(D,T){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,T,D),U={},Q=await this.D(F.toString(),{type:"GET",headers:U},[],N.CancellationToken.None);return(await(0,h.$Op)(Q)||[]).map(({url:Y,created:W})=>({ref:(0,$.$7g)(F,F.with({path:Y})),created:W*1e3}))}async resolveResourceContent(D,T,F,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=(0,$.$5g)(this.z(this.a,F,D),T).toString();U={...U},U["Cache-Control"]="no-cache";const G=await this.D(Q,{type:"GET",headers:U},[],N.CancellationToken.None);return await(0,h.$Np)(G)}async deleteResource(D,T,F){if(!this.a)throw new Error("No settings sync store url configured.");const U=T!==null?(0,$.$5g)(this.z(this.a,F,D),T).toString():this.z(this.a,F,D).toString(),Q={};await this.D(U,{type:"DELETE",headers:Q},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,$.$5g)(this.a,"resource").toString(),T={"Content-Type":I.$Ks.text};await this.D(D,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async readResource(D,T,F,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=(0,$.$5g)(this.z(this.a,F,D),"latest").toString();U={...U},U["Cache-Control"]="no-cache",T&&(U["If-None-Match"]=T.ref);const G=await this.D(Q,{type:"GET",headers:U},[304],N.CancellationToken.None);let Y=null;if(G.res.statusCode===304&&(Y=T),Y===null){const W=G.res.headers.etag;if(!W)throw new c.$jAb("Server did not return the ref",Q,"NoRef",G.res.statusCode,G.res.headers[c.$fAb]);const J=await(0,h.$Np)(G);if(!J&&G.res.statusCode===304)throw new c.$jAb("Empty response",Q,"EmptyResponse",G.res.statusCode,G.res.headers[c.$fAb]);Y={ref:W,content:J}}return Y}async writeResource(D,T,F,U,Q={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=this.z(this.a,U,D).toString();Q={...Q},Q["Content-Type"]=I.$Ks.text,F&&(Q["If-Match"]=F);const Y=await this.D(G,{type:"POST",data:T,headers:Q},[],N.CancellationToken.None),W=Y.res.headers.etag;if(!W)throw new c.$jAb("Server did not return the ref",G,"NoRef",Y.res.statusCode,Y.res.headers[c.$fAb]);return W}async manifest(D,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,$.$5g)(this.a,"manifest").toString();T={...T},T["Content-Type"]="application/json",D&&(T["If-None-Match"]=D.ref);const U=await this.D(F,{type:"GET",headers:T},[304],N.CancellationToken.None);let Q=null;if(U.res.statusCode===304&&(Q=D),!Q){const Y=U.res.headers.etag;if(!Y)throw new c.$jAb("Server did not return the ref",F,"NoRef",U.res.statusCode,U.res.headers[c.$fAb]);const W=await(0,h.$Np)(U);if(!W&&U.res.statusCode===304)throw new c.$jAb("Empty response",F,"EmptyResponse",U.res.statusCode,U.res.headers[c.$fAb]);W&&(Q={...JSON.parse(W),ref:Y})}const G=this.s.get(n,-1);return G&&Q&&G!==Q.session&&this.C(),Q===null&&G&&this.C(),Q&&this.s.store(n,Q.session,-1,1),Q}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,$.$5g)(this.a,"download").toString(),T={},F=await this.D(D,{type:"GET",headers:T},[],N.CancellationToken.None);if(!(0,h.$Kp)(F))throw new c.$jAb("Server returned "+F.res.statusCode,D,"EmptyResponse",F.res.statusCode,F.res.headers[c.$fAb]);if((0,h.$Lp)(F))throw new c.$jAb("Empty response",D,"EmptyResponse",F.res.statusCode,F.res.headers[c.$fAb]);return F.stream}z(D,T,F){return T?(0,$.$5g)(D,"collection",T,"resource",F):(0,$.$5g)(D,"resource",F)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(D,T,F,U){if(!this.b)throw new c.$jAb("No Auth Token Available",D,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new c.$jAb(`${T.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Q=await this.c;T.headers={...T.headers||{},...Q,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(T.headers),this.r.trace("Sending request to server",{url:D,type:T.type,headers:{...T.headers,authorization:void 0}});let G;try{G=await this.f.request(D,T,U)}catch(B){if(!(B instanceof c.$jAb)){let ie="RequestFailed";const re=(0,L.$0)(B).toLowerCase();re.includes("xhr timeout")?ie="RequestTimeout":re.includes("protocol")&&re.includes("not supported")?ie="RequestProtocolNotSupported":re.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":re.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,L.$4)(B)&&(ie="RequestCanceled"),B=new c.$jAb(`Connection refused for the request '${D}'.`,D,ie,void 0,void 0)}throw this.r.info("Request failed",D),B}const Y=G.res.headers[c.$fAb],W={url:D,status:G.res.statusCode,"execution-id":T.headers[c.$gAb],"operation-id":Y},J=(0,h.$Kp)(G)||G.res.statusCode&&F.includes(G.res.statusCode);let H="";if(J?this.r.trace("Request succeeded",W):(H=await(0,h.$Mp)(G)||"",this.r.info("Request failed",W,H)),G.res.statusCode===401||G.res.statusCode===403){if(this.b=void 0,G.res.statusCode===401)throw this.g.fire("Unauthorized"),new c.$jAb(`${T.type} request '${D}' failed because of Unauthorized (401).`,D,"Unauthorized",G.res.statusCode,Y);if(G.res.statusCode===403)throw this.g.fire("Forbidden"),new c.$jAb(`${T.type} request '${D}' failed because the access is forbidden (403).`,D,"Forbidden",G.res.statusCode,Y)}if(this.h.fire(),G.res.statusCode===404)throw new c.$jAb(`${T.type} request '${D}' failed because the requested resource is not found (404).`,D,"NotFound",G.res.statusCode,Y);if(G.res.statusCode===405)throw new c.$jAb(`${T.type} request '${D}' failed because the requested endpoint is not found (405). ${H}`,D,"MethodNotFound",G.res.statusCode,Y);if(G.res.statusCode===409)throw new c.$jAb(`${T.type} request '${D}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,D,"Conflict",G.res.statusCode,Y);if(G.res.statusCode===410)throw new c.$jAb(`${T.type} request '${D}' failed because the requested resource is not longer available (410).`,D,"Gone",G.res.statusCode,Y);if(G.res.statusCode===412)throw new c.$jAb(`${T.type} request '${D}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,D,"PreconditionFailed",G.res.statusCode,Y);if(G.res.statusCode===413)throw new c.$jAb(`${T.type} request '${D}' failed because of too large payload (413).`,D,"TooLarge",G.res.statusCode,Y);if(G.res.statusCode===426)throw new c.$jAb(`${T.type} request '${D}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,D,"UpgradeRequired",G.res.statusCode,Y);if(G.res.statusCode===429){const B=G.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new c.$jAb(`${T.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",G.res.statusCode,Y)):new c.$jAb(`${T.type} request '${D}' failed because of too many requests (429).`,D,"RemoteTooManyRequests",G.res.statusCode,Y)}if(!J)throw new c.$jAb("Server returned "+G.res.statusCode,D,"Unknown",G.res.statusCode,Y);return G}F(D){let T=this.s.get(s,-1);T===void 0&&(T=(0,m.$Ng)(),this.s.store(s,T,-1,1)),D["X-Machine-Session-Id"]=T;const F=this.s.get(n,-1);F!==void 0&&(D["X-User-Session-Id"]=F)}};e.$5Kb=v,e.$5Kb=v=Ee([X(1,p.$ek),X(2,h.$Ip),X(3,c.$sAb),X(4,l.$yi),X(5,w.$Xk),X(6,f.$Vp)],v);let P=class extends v{constructor(D,T,F,U,Q,G,Y){super(D.userDataSyncStore?.url,T,F,U,Q,G,Y),this.B(D.onDidChangeUserDataSyncStore(()=>this.t(D.userDataSyncStore?.url)))}};e.$6Kb=P,e.$6Kb=P=Ee([X(0,c.$cAb),X(1,p.$ek),X(2,h.$Ip),X(3,c.$sAb),X(4,l.$yi),X(5,w.$Xk),X(6,f.$Vp)],P);class S{constructor(D,T,F,U){this.c=D,this.d=T,this.f=F,this.g=U,this.a=[],this.b=void 0}request(D,T,F){if(this.h()&&this.i(),T.url=D,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new c.$jAb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,D,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(D),this.f.request(T,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$7Kb=S}),define(ae[267],ce([0,1,3,2,8,21,24,19,122]),function(ne,e,R,N,L,j,A,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=e.$Kdc=e.$Jdc=e.$Idc=void 0;class ${constructor(l){this.a=l}listen(l,w){switch(w){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${w}`)}call(l,w,p){switch(w){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(p)}throw new Error("Invalid call")}}e.$Idc=$;class E extends N.$Uc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new R.$be),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(w=>{this.a=w,this.B(this.c.listen("onDidChangeAccount")(p=>{this.a=p,this.b.fire(p)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$Jdc=E;class b{constructor(l){this.a=l}listen(l,w){switch(w){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${w}`)}call(l,w,p){switch(w){case"switch":return this.a.switch(p[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Kdc=b;let m=class extends C.$3Kb{constructor(l,w,p,h){super(w,p,h),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:L.URI.revive(l.url),type:l.type,defaultUrl:L.URI.revive(l.defaultUrl),insidersUrl:L.URI.revive(l.insidersUrl),stableUrl:L.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$Ldc=m,e.$Ldc=m=Ee([X(1,A.$ek),X(2,j.$Xi),X(3,I.$Vp)],m)}),define(ae[268],ce([0,1,3,57,24,19,22,263,25,80,83]),function(ne,e,R,N,L,j,A,I,C,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;let b=class extends I.$tac{constructor(u,l,w,p,h,g,f,c,d,i,o){super(u,l,w,p,h,f,c,d,i,o),this.B(R.Event.debounce(R.Event.any(R.Event.map(g.onDidFocusMainWindow,()=>"windowFocus"),R.Event.map(g.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$8dc=b,e.$8dc=b=Ee([X(0,L.$ek),X(1,C.$cAb),X(2,C.$dAb),X(3,C.$nAb),X(4,C.$oAb),X(5,N.$Ybc),X(6,C.$sAb),X(7,$.$yJb),X(8,A.$Wl),X(9,E.$3zb),X(10,j.$Vp)],b)}),define(ae[269],ce([0,1,73,23,5,20]),function(ne,e,R,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=void 0,e.$nbc=A,e.$obc=I,e.$pbc=C,e.$mbc=128/4;function A($){function E(){let b=$.scheme===N.Schemas.file?(0,j.$Sg)($):$.toString();return L.$k||(b=b.toLowerCase()),(0,R.createHash)("md5").update(b).digest("hex")}return{id:E(),configPath:$}}function I($,E){function b(){if($.scheme!==N.Schemas.file)return(0,R.createHash)("md5").update($.toString()).digest("hex");if(!E)return;let u;return L.$k?u=E.ino:L.$j?u=E.birthtime.getTime():L.$i&&(typeof E.birthtimeMs=="number"?u=Math.floor(E.birthtimeMs):u=E.birthtime.getTime()),(0,R.createHash)("md5").update($.fsPath).update(u?String(u):"").digest("hex")}const m=b();if(typeof m=="string")return{id:m,uri:$}}function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ae[270],ce([0,1,6,7,2,14,31,16,9,77,112,269,57,56,23]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;let w=class extends L.$Uc{constructor(h,g,f,c){super(),this.a=h,this.b=g,this.c=f,this.f=c,this.B(new R.$Dh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,g=await A.Promises.readdir(h),f=new $.$_Jb(this.f.getChannel("storage"));await Promise.all(g.map(async c=>{const d=(0,j.$kc)(h,c);c.length===b.$mbc||c===E.$Di.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await f.isUsed(d)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await A.Promises.rm(d))}))}catch(h){(0,N.$1)(h)}}};e.$Edc=w,e.$Edc=w=Ee([X(0,I.$zi),X(1,C.$Xj),X(2,m.$Ybc),X(3,u.$bdc)],w)}),define(ae[123],ce([0,1,73,64,37,279,15,7,3,2,14,5,32,41,68]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ii=e.$hi=e.$gi=void 0,e.$ji=n,e.$ki=s,e.$mi=a,e.$ni=y;class w{traceSocketEvent(P,S){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,S)}constructor(P,S=""){this.f=!0,this.debugLabel=S,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=k=>{if(this.traceSocketEvent("error",{code:k?.code,message:k?.message}),k){if(k.code==="EPIPE")return;(0,I.$1)(k)}},this.socket.on("error",this.a),this.b=k=>{this.traceSocketEvent("close",{hadError:k}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(P){const S=k=>{this.traceSocketEvent("read",k),P(A.$Ce.wrap(k))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(P){const S=k=>{P({type:0,hadError:k,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(P){const S=()=>{P()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(P){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,I.$1)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,I.$1)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const k=()=>{this.socket.off("close",k),this.socket.off("end",k),this.socket.off("error",k),this.socket.off("timeout",k),this.socket.off("drain",k),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",k),this.socket.on("end",k),this.socket.on("error",k),this.socket.on("timeout",k),this.socket.on("drain",k)})}}e.$gi=w;var p;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var h;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(h||(h={}));class g extends $.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(P,S){this.socket.traceSocketEvent(P,S)}constructor(P,S,k,D){super(),this.f=this.B(new C.$be),this.g=this.B(new C.$be),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:k?.byteLength||0,recordInflateBytes:D}),this.a=this.B(new f(this,S,k,D,this.f,(T,F)=>this.m(T,F))),this.B(this.a.onError(T=>{console.error(T),(0,I.$1)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new l.$bi,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this.f.event(P)}onClose(P){return this.g.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){let S=0;for(;S<P.byteLength;)this.a.writeMessage(P.slice(S,Math.min(S+262144,P.byteLength)),{compressed:!0,opcode:2}),S+=262144}m(P,{compressed:S,opcode:k}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let D=2;P.byteLength<126?D+=0:P.byteLength<2**16?D+=2:D+=8;const T=A.$Ce.alloc(D),F=S?64:0,U=k&15;if(T.writeUInt8(128|F|U,0),P.byteLength<126)T.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){T.writeUInt8(126,1);let Q=1;T.writeUInt8(P.byteLength>>>8&255,++Q),T.writeUInt8(P.byteLength>>>0&255,++Q)}else{T.writeUInt8(127,1);let Q=1;T.writeUInt8(0,++Q),T.writeUInt8(0,++Q),T.writeUInt8(0,++Q),T.writeUInt8(0,++Q),T.writeUInt8(P.byteLength>>>24&255,++Q),T.writeUInt8(P.byteLength>>>16&255,++Q),T.writeUInt8(P.byteLength>>>8&255,++Q),T.writeUInt8(P.byteLength>>>0&255,++Q)}this.socket.write(A.$Ce.concat([T,P]))}end(){this.h=!0,this.socket.end()}n(P){if(P.byteLength!==0){for(this.b.acceptChunk(P);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),k=S.readUInt8(0),D=(k&128)>>>7,T=(k&64)>>>6,F=k&15,U=S.readUInt8(1),Q=(U&128)>>>7,G=U&127;this.j.state=2,this.j.readLen=2+(Q?4:0)+(G===126?2:0)+(G===127?8:0),this.j.fin=D,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!D,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),k=S.readUInt8(1),D=(k&128)>>>7;let T=k&127,F=1;T===126?T=S.readUInt8(++F)*2**8+S.readUInt8(++F):T===127&&(T=S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*2**24+S.readUInt8(++F)*2**16+S.readUInt8(++F)*2**8+S.readUInt8(++F));let U=0;D&&(U=S.readUInt8(++F)*2**24+S.readUInt8(++F)*2**16+S.readUInt8(++F)*2**8+S.readUInt8(++F)),this.j.state=3,this.j.readLen=T,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),i(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(S,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$hi=g;class f extends $.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Ce.alloc(0)}constructor(P,S,k,D,T,F){super(),this.n=P,this.r=T,this.s=F,this.a=this.B(new C.$be),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.$be),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new C.$be),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,S?(this.b=this.B(new c(this.n,D,k,{windowBits:15})),this.f=this.B(new d(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(P,S){this.g.push({data:P,options:S}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:P,options:S}=this.g.shift();if(this.f&&S.compressed){const k=await this.w(this.f,P);this.s(k,S)}else this.s(P,{...S,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(P,S){return new Promise((k,D)=>{P.write(S),P.flush(T=>k(T))})}acceptFrame(P,S,k){this.h.push({data:P,isCompressed:S,isLastFrameOfMessage:k}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const P=this.h.shift();if(this.b&&P.isCompressed){const S=await this.C(this.b,P.data,P.isLastFrameOfMessage);this.r.fire(S)}else this.r.fire(P.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(P,S,k){return new Promise((D,T)=>{P.write(S),k&&P.write(A.$Ce.fromByteArray([0,0,255,255])),P.flush(F=>D(F))})}}class c extends $.$Uc{get recordedInflateBytes(){return this.j?A.$Ce.concat(this.f):A.$Ce.alloc(0)}constructor(P,S,k,D){super(),this.h=P,this.j=S,this.a=this.B(new C.$be),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(D),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(A.$Ce.wrap(T))}),k&&(this.h.traceSocketEvent("zlibInflateInitialWrite",k.buffer),this.b.write(k.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(P){this.j&&this.f.push(P.clone()),this.h.traceSocketEvent("zlibInflateWrite",P),this.b.write(P.buffer)}flush(P){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=A.$Ce.concat(this.g);this.g.length=0,P(S)})}}class d extends $.$Uc{constructor(P,S){super(),this.g=P,this.a=this.B(new C.$be),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",k=>{this.g.traceSocketEvent("zlibDeflateError",{message:k?.message,code:k?.code}),this.a.fire(k)}),this.b.on("data",k=>{this.g.traceSocketEvent("zlibDeflateData",k),this.f.push(A.$Ce.wrap(k))})}write(P){this.g.traceSocketEvent("zlibDeflateWrite",P.buffer),this.b.write(P.buffer)}flush(P){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=A.$Ce.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),P(S)})}}function i(v,P){if(P===0)return;const S=v.byteLength>>>2;for(let Q=0;Q<S;Q++){const G=v.readUInt32BE(Q*4);v.writeUInt32BE(G^P,Q*4)}const k=S*4,D=v.byteLength-k,T=P>>>24&255,F=P>>>16&255,U=P>>>8&255;D>=1&&v.writeUInt8(v.readUInt8(k)^T,k),D>=2&&v.writeUInt8(v.readUInt8(k+1)^F,k+1),D>=3&&v.writeUInt8(v.readUInt8(k+2)^U,k+2)}e.$ii=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const v=(0,m.$Ng)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const P=process.platform!=="darwin"&&e.$ii?e.$ii:(0,L.tmpdir)(),S=(0,E.$kc)(P,`vscode-ipc-${v}.sock`);return t(S),S}function s(v,P,S){const D=(0,R.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${S}-${P}-sock`;const T=S.substr(0,4),F=P.substr(0,6);let U;return process.platform!=="darwin"&&e.$ii&&!process.env.VSCODE_PORTABLE?U=(0,E.$kc)(e.$ii,`vscode-${D}-${T}-${F}.sock`):U=(0,E.$kc)(v,`${T}-${F}.sock`),t(U),U}function t(v){const P=o[b.$u];typeof P=="number"&&v.length>=P&&console.warn(`WARNING: IPC handle "${v}" is longer than ${P} chars, try a shorter --user-data-dir`)}class r extends u.$8h{static b(P){const S=C.Event.fromNodeEventEmitter(P,"connection");return C.Event.map(S,k=>({protocol:new l.$ci(new w(k,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(k,"close"))}))}constructor(P){super(r.b(P)),this.d=P}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$li=r;function a(v){return new Promise((P,S)=>{const k=(0,N.createServer)();k.on("error",S),k.listen(v,()=>{k.removeListener("error",S),P(new r(k))})})}function y(v,P){return new Promise((S,k)=>{const D=(0,N.createConnection)(v,()=>{D.removeListener("error",k),S(l.$di.fromSocket(new w(D,`ipc-client${P}`),P))});D.once("error",k)})}}),define(ae[271],ce([0,1,64,123,218]),function(ne,e,R,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0,e.$$dc=new class{supports(j){return!0}connect({host:j,port:A},I,C,$){return new Promise((E,b)=>{const m=R.createConnection({host:j,port:A},()=>{m.removeListener("error",b),m.write((0,L.$Psb)(I,C,$));const u=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",u),E(new N.$gi(m,$)))};m.on("data",u)});m.setNoDelay(!0),m.once("error",b)})}}}),define(ae[272],ce([0,1,64,37,133,123,6,2,5,21,9,24,220,103,105,78,15]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=e.$7cc=e.$6cc=e.$5cc=void 0;async function h(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new g(i,o,n,s,t).waitForReady(),!(t&&L.$Qg[t]||!L.$Qg[r.tunnelLocalPort]));a--);return r}class g extends I.$Uc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=R.createServer(),this.c=new A.$qh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,w.$dw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,L.$Rg)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,w.$bw)(this.tunnelRemoteHost)||(0,w.$dw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,m.$Nl)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof j.$gi?t.socket.destroy():t.end()}),t instanceof j.$gi?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(p.$Ce.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$5cc=g;let f=class extends w.$gw{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,w.$ew)(o,this.m,C.OS,N.release())}t(o,n,s,t,r,a,y,v){const P=this.s(n,s);if(P)return++P.refcount,P.value;if((0,w.$0v)(o))return this.u(o,n,s,r,a,y,v);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const S={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},k=h(S,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,k),k}}};e.$6cc=f,e.$6cc=f=Ee([X(0,u.$Hl),X(1,E.$Xj),X(2,l.$Kl),X(3,b.$ek),X(4,$.$Xi)],f);let c=class extends f{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$7cc=c,e.$7cc=c=Ee([X(0,u.$Hl),X(1,E.$Xj),X(2,l.$Kl),X(3,b.$ek),X(4,$.$Xi)],c);let d=class extends I.$Uc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,y,v,P){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const S=new c(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(o,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,y,v,P)}};e.$8cc=d,e.$8cc=d=Ee([X(0,u.$Hl),X(1,E.$Xj),X(2,b.$ek),X(3,l.$Kl),X(4,$.$Xi)],d)}),define(ae[280],ce([0,1,37,38,7,2,23,8,17,3,41,151,212,213,203,204,270,193,195,21,217,94,228,95,223,16,114,254,29,107,194,113,96,12,206,207,72,4,202,74,75,234,9,208,100,24,59,19,106,22,108,109,110,49,237,82,111,25,80,262,267,247,83,261,265,266,122,60,260,248,105,227,78,272,222,238,28,239,5,240,196,215,214,81,253,18,52,211,58,259,236,249,104,264,255,10,209,99,257,252,224,190,57,210,268,256,56,258,103,271,187,225,147,140,145]),function(ne,e,R,N,L,j,A,I,C,$,E,b,m,u,l,w,p,h,g,f,c,d,i,o,n,s,t,r,a,y,v,P,S,k,D,T,F,U,Q,G,Y,W,J,H,B,ie,re,he,te,V,z,O,M,q,x,K,ee,_,Z,se,ue,ge,fe,$e,ye,ve,Ce,Ae,le,me,pe,Pe,Re,Te,De,Ue,Me,qe,ze,je,oe,de,we,be,Se,Ie,Oe,Ne,We,Be,Fe,Xe,Ge,_e,tt,St,kt,gt,Ct,Pt,It,Rt,At,Ot,Dt,Lt,$t,jt,mt,Nt,Tt,st,Mt,Ft,pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=wt;class Ut extends j.$Uc{constructor(ke){super(),this.f=ke,this.a=this.B(new b.$TW(this)),this.b=void 0,this.c=this.B(new $.$be),this.g()}g(){let ke=!1;const Le=()=>{ke||(ke=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,b.$UW)(process.parentPort,st.$hcc.exit,Le)}async init(){const ke=await this.h();(0,_.$0zb)(),ke.invokeFunction(Le=>{const He=Le.get(J.$Xj),Ve=Le.get(V.$Wl),Qe=Le.get(Ie.$xl);He.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(He),this.n(Ve,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(Ve,Qe))),this.r(Ve,He)}),this.B((0,j.$Rc)(ke.createInstance(m.$Adc,this.f.codeCachePath),ke.createInstance(u.$Bdc),ke.createInstance(p.$Edc),ke.createInstance(w.$Ddc),ke.createInstance(l.$Cdc),ke.createInstance(tt.$2dc),ke.createInstance(Xe.$Tdc)))}async h(){const ke=new G.$pi,Le={_serviceBrand:void 0,...B.default};ke.set(ie.$ek,Le);const He=new E.$_h(Ke=>Ke==="main"),Ve=new $t.$cdc(this.a,He);ke.set($t.$bdc,Ve);const Qe=this.f.policiesData?new Ne.$Kcc(this.f.policiesData,Ve.getChannel("policy")):new We.$bo;ke.set(We.$_n,Qe);const Je=new Tt.$4m(this.f.args,Le);ke.set(s.$zi,Je);const et=new H.$6r(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:I.URI.revive(Ke.resource)})),Ve.getChannel("logger"));ke.set(J.$Yj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),ht=this.B(new J.$6j(ot.getLevel())),Ye=this.B(new kt.$DQ(ot,[ht]));ke.set(J.$Xj,Ye),this.b=this.B(new gt.$4dc(Ye)),ke.set(gt.$3dc,this.b);const Ze=this.B(new D.$Dq(Ye));ke.set(k.$Xk,Ze);const ut=this.B(new T.$7q(Ye));Ze.registerProvider(A.Schemas.file,ut);const at=new qe.$us(Ze);ke.set(Me.$vl,at);const xe=this.B(new Be.$KQ(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));ke.set(Ie.$xl,xe);const ft=this.B(new je.$adc(A.Schemas.file,this.B(new oe.$mQ(Ve.getChannel(oe.$lQ),{pathCaseSensitive:ze.$k})),A.Schemas.vscodeUserData,xe,at,Ye));Ze.registerProvider(A.Schemas.vscodeUserData,ft);const it=this.B(new c.$Bo(xe.defaultProfile.settingsResource,Ze,Qe,Ye));ke.set(f.$Xi,it);const dt=new jt.$0dc(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},Ve,Je);ke.set(he.$Vp,dt),this.B((0,j.$Sc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const bt=new It.$Qr(Ve.getChannel("request"));ke.set(re.$Ip,bt),ke.set(h.$Fdc,new F.$oi(g.$Gdc,void 0,!1)),ke.set(we.$gG,new F.$oi(de.$Sdc,void 0,!1));const yt=new Ot.$hdc(-1,Ve);ke.set(At.$Ybc,yt),ke.set(o.$Fo,new F.$oi(n.$SQ,void 0,!0));const zt=this.B(new me.$Hcc(yt)),Bt=new E.$_h(Ke=>zt.getActiveClientId().then(lt=>Ke===lt));ke.set(S.$U3b,new Rt.$6dc(this.a.getChannel("extensionRecommendationNotification",Bt)));let ct;const nt=[],vt=(0,q.$mp)(Le,it);if((0,q.$hp)(Le,Je)){const Ke=new O.$K_b(Ye,et,Je,Le);if(nt.push(Ke),!(0,q.$ip)(Le,Je)&&Le.aiConfig?.ariaKey){const lt=new Fe.$rQ(bt,vt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,j.$Sc)(()=>lt.flush())),nt.push(lt)}ct=new M.$Ur({appenders:nt,commonProperties:(0,te.$$o)((0,R.release)(),(0,R.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,this.f.sqmId,vt),sendErrorTelemetry:!0,piiPaths:(0,q.$np)(Je)},it,Le)}else{ct=q.$cp;const Ke=q.$gp;nt.push(Ke)}this.a.registerChannel("telemetryAppender",new z.$mcc(nt)),ke.set(V.$Wl,ct);const Vt=new x.$Hdc(it,ct,Ye,et,Je,Le);ke.set(V.$Xl,Vt),ke.set(Oe.$kq,new F.$oi(Pt.$CQ,void 0,!0)),ke.set(be.$oq,new F.$oi(Se.$Lcc,void 0,!0)),ke.set(y.$7p,new F.$oi(y.$8p,void 0,!0)),ke.set(P.$yq,new F.$oi(P.$zq,void 0,!0)),ke.set(a.$1o,new F.$oi(r.$5p,void 0,!0)),ke.set(a.$8o,new F.$oi(Lt.$9dc,void 0,!1)),ke.set(Y.$Mr,new F.$oi(W.$Or,void 0,!1)),ke.set(d.$$m,new F.$oi(i.$Bs,void 0,!1)),ke.set(Z.$yJb,new F.$oi(Z.$zJb,void 0,!0)),ke.set(_.$sAb,new F.$oi(ge.$YLb,void 0,!0)),ke.set(_.$rAb,E.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),ke.set(a.$7o,new F.$oi(t.$wJb,void 0,!1)),ke.set(ee.$WLb,new F.$oi(ee.$XLb,void 0,!0)),ke.set(K.$Tv,new F.$oi(K.$Uv)),ke.set(_.$cAb,new F.$oi(Ce.$4Kb,void 0,!0)),ke.set(_.$dAb,new F.$oi(Ce.$6Kb,void 0,!0)),ke.set(fe.$3zb,new F.$oi(fe.$5zb,void 0,!0)),ke.set(_.$eAb,new F.$oi(se.$nac,void 0,!1)),ke.set(_.$nAb,new F.$oi($e.$cac,void 0,!0)),ke.set(_.$oAb,new F.$oi(ye.$sac,void 0,!1)),ke.set(Ae.$aKb,new F.$oi(le.$Odc,void 0,!0)),ke.set(_.$pAb,new F.$oi(_e.$2ac,void 0,!0)),ke.set(pe.$Kl,new F.$oi(Pe.$0cc,void 0,!1));const Et=new mt.$Il;return ke.set(mt.$Hl,Et),Et.register(0,Nt.$$dc),ke.set(Re.$9v,new F.$oi(Te.$8cc)),ke.set(De.$Pdc,new F.$oi(Ue.$Rdc)),ke.set(Ge.$Udc,new F.$oi(Ct.$5dc)),new Q.$0q(ke)}j(ke){const Le=new v.$0p(ke.get(a.$4o),()=>null);this.a.registerChannel("extensions",Le);const He=E.ProxyChannel.fromService(ke.get(Y.$Mr),this.q);this.a.registerChannel("languagePacks",He);const Ve=E.ProxyChannel.fromService(ke.get(d.$$m),this.q);this.a.registerChannel("diagnostics",Ve);const Qe=new v.$_p(ke.get(a.$8o));this.a.registerChannel("extensionTipsService",Qe);const Je=E.ProxyChannel.fromService(ke.get(h.$Fdc),this.q);this.a.registerChannel("checksum",Je);const et=E.ProxyChannel.fromService(ke.get(we.$gG),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=E.ProxyChannel.fromService(ke.get(fe.$3zb),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=E.ProxyChannel.fromService(ke.get(V.$Xl),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Ye=new ue.$Idc(ke.get(Z.$yJb));this.a.registerChannel("userDataSyncAccount",Ye);const Ze=new ue.$Kdc(ke.get(_.$cAb));this.a.registerChannel("userDataSyncStoreManagement",Ze);const ut=new ve.$Mdc(ke.get(_.$oAb),ke.get(Ie.$xl),ke.get(J.$Xj));this.a.registerChannel("userDataSync",ut);const at=this.B(ke.get(U.$qi).createInstance(Dt.$8dc));this.a.registerChannel("userDataAutoSync",E.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",E.ProxyChannel.fromService(ke.get(_.$pAb),this.q));const xe=E.ProxyChannel.fromService(ke.get(De.$Pdc),this.q);this.a.registerChannel(De.$Qdc,xe);const ft=E.ProxyChannel.fromService(ke.get(Ge.$Udc),this.q);this.a.registerChannel("remoteTunnel",ft)}m(ke){process.on("uncaughtException",Le=>(0,L.$1)(Le)),process.on("unhandledRejection",Le=>(0,L.$1)(Le)),(0,L.setUnexpectedErrorHandler)(Le=>{const He=(0,N.$cj)(Le,!0);He&&ke.error(`[uncaught exception in sharedProcess]: ${He}`)})}n(ke,Le){ke.publicLog2("profilesInfo",{count:Le.profiles.length})}async r(ke,Le){if(ze.$k){const[He,Ve]=await Promise.all([(0,Mt.$Og)(Le.error.bind(Le)),(0,pt.$BW)(Le.error.bind(Le))]),Qe=(0,Ft.$hW)(),Je=(0,pt.$CW)(Ve,this.f.args["ozone-platform"]);He&&ke.publicLog2("clientPlatformInfo",{platformId:He.id,platformVersionId:He.version_id,platformIdLike:He.id_like,desktopEnvironment:Qe,displayProtocol:Ve,codeDisplayProtocol:Je})}}handledClientConnection(ke){if(ke.data!==st.$jcc.response)return!1;const Le=(0,C.$Ob)(ke.ports);return Le?(this.c.fire(Le),!0):!1}}async function wt(rt){try{const ke=new Ut(rt);process.parentPort.postMessage(st.$hcc.ipcReady),await ke.init(),process.parentPort.postMessage(st.$hcc.initDone)}catch(ke){process.parentPort.postMessage({error:ke.toString()})}}const qt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout(qt),wt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/910284865c34fd492e3f6fd5a8ab8e571432cc58/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
