/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(le){for(var e=[],u=0,N=le.length;u<N;u++)e[u]=ke[le[u]];return e};define(ke[162],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class u{static get(){const M=new Map,A=new Map,R=new Map,w=new Map;function $(y,v){y.has(v.detail)||y.set(v.detail,-v.timestamp)}function S(y,v){const l=y.get(v.detail);l&&(l>=0||y.set(v.detail,l+v.timestamp))}let L=[];typeof le=="function"&&typeof le.getStats=="function"&&(L=le.getStats().slice(0).sort((y,v)=>y.timestamp-v.timestamp));for(const y of L)switch(y.type){case 10:$(M,y);break;case 11:case 12:S(M,y);break;case 21:$(A,y);break;case 22:S(A,y);break;case 33:$(R,y);break;case 34:S(R,y);break;case 31:$(w,y);break;case 32:S(w,y);break}let C=0;R.forEach(y=>C+=y);function m(y){const v=[];return y.forEach((l,g)=>v.push([g,l])),v}return{amdLoad:m(M),amdInvoke:m(A),nodeRequire:m(R),nodeEval:m(w),nodeRequireTotal:C}}static toMarkdownTable(M,A){let R="";const w=[];return M.forEach(($,S)=>{w[S]=$.length}),A.forEach($=>{$.forEach((S,L)=>{typeof S>"u"&&(S=$[L]="-");const C=S.toString().length;w[L]=Math.max(C,w[L])})}),M.forEach(($,S)=>{R+=`| ${$+" ".repeat(w[S]-$.toString().length)} `}),R+=`|
`,M.forEach(($,S)=>{R+=`| ${"-".repeat(w[S])} `}),R+=`|
`,A.forEach($=>{$.forEach((S,L)=>{typeof S<"u"&&(R+=`| ${S+" ".repeat(w[L]-S.toString().length)} `)}),R+=`|
`}),R}}e.$U=u}),define(ke[163],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=u,e.$gb=N,e.$hb=M,e.$ib=A,e.$jb=R,e.$kb=w,e.$lb=$,e.$nb=L,e.$ob=C,e.$pb=m,e.$qb=y,e.$rb=v;function u(l,g){const c=N(l,g);if(c!==-1)return l[c]}function N(l,g,c=l.length-1){for(let n=c;n>=0;n--){const i=l[n];if(g(i))return n}return-1}function M(l,g){const c=A(l,g);return c===-1?void 0:l[c]}function A(l,g,c=0,n=l.length){let i=c,s=n;for(;i<s;){const r=Math.floor((i+s)/2);g(l[r])?i=r+1:s=r}return i-1}function R(l,g){const c=w(l,g);return c===l.length?void 0:l[c]}function w(l,g,c=0,n=l.length){let i=c,s=n;for(;i<s;){const r=Math.floor((i+s)/2);g(l[r])?s=r:i=r+1}return i}function $(l,g,c=0,n=l.length){const i=w(l,g,c,n);return i===l.length?-1:i}class S{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(S.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!g(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const c=A(this.e,g,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$mb=S;function L(l,g){if(l.length===0)return;let c=l[0];for(let n=1;n<l.length;n++){const i=l[n];g(i,c)>0&&(c=i)}return c}function C(l,g){if(l.length===0)return;let c=l[0];for(let n=1;n<l.length;n++){const i=l[n];g(i,c)>=0&&(c=i)}return c}function m(l,g){return L(l,(c,n)=>-g(c,n))}function y(l,g){if(l.length===0)return-1;let c=0;for(let n=1;n<l.length;n++){const i=l[n];g(i,l[c])>0&&(c=n)}return c}function v(l,g){for(const c of l){const n=g(c);if(n!==void 0)return n}}}),define(ke[73],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=u,e.$L=N,e.$M=M,e.$N=A;function u(R,w){const $=Object.create(null);for(const S of R){const L=w(S);let C=$[L];C||(C=$[L]=[]),C.push(S)}return $}function N(R,w){const $=[],S=[];for(const L of R)w.has(L)||$.push(L);for(const L of w)R.has(L)||S.push(L);return{removed:$,added:S}}function M(R,w){const $=[],S=[];for(const[L,C]of R)w.has(L)||$.push(C);for(const[L,C]of w)R.has(L)||S.push(C);return{removed:$,added:S}}function A(R,w){const $=new Set;for(const S of w)R.has(S)&&$.add(S);return $}}),define(ke[55],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=N,e.$Wh=M,e.$Xh=A;function u(R){return(w,$,S)=>{let L=null,C=null;if(typeof S.value=="function"?(L="value",C=S.value):typeof S.get=="function"&&(L="get",C=S.get),!C)throw new Error("not supported");S[L]=R(C,$)}}function N(R,w,$){let S=null,L=null;if(typeof $.value=="function"?(S="value",L=$.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(S="get",L=$.get),!L)throw new Error("not supported");const C=`$memoize$${w}`;$[S]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,m)}),this[C]}}function M(R,w,$){return u((S,L)=>{const C=`$debounce$${L}`,m=`$debounce$result$${L}`;return function(...y){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),w&&(this[m]=w(this[m],...y),y=[this[m]]),this[C]=setTimeout(()=>{S.apply(this,y),this[m]=$?$():void 0},R)}})}function A(R,w,$){return u((S,L)=>{const C=`$throttle$timer$${L}`,m=`$throttle$result$${L}`,y=`$throttle$lastRun$${L}`,v=`$throttle$pending$${L}`;return function(...l){if(this[m]||(this[m]=$?$():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),w&&(this[m]=w(this[m],...l)),this[v])return;const g=this[y]+R;g<=Date.now()?(this[y]=Date.now(),S.apply(this,[this[m]]),this[m]=$?$():void 0):(this[v]=!0,this[C]=setTimeout(()=>{this[v]=!1,this[y]=Date.now(),S.apply(this,[this[m]]),this[m]=$?$():void 0},g-Date.now()))}})}}),define(ke[13],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=M,e.$1=A,e.$2=R,e.$3=w,e.$4=S,e.$6=C,e.$7=m,e.$8=y,e.$0=l;class u{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(d=>{d(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=u,e.$X=new u;function N(r){e.$X.setUnexpectedErrorHandler(r)}function M(r){if(!r||typeof r!="object")return!1;const t=r;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(r){S(r)||e.$X.onUnexpectedError(r)}function R(r){S(r)||e.$X.onUnexpectedExternalError(r)}function w(r){if(r instanceof Error){const{name:t,message:d}=r,a=r.stacktrace||r.stack;return{$isError:!0,name:t,message:d,stack:a,noTelemetry:i.isErrorNoTelemetry(r)}}return r}const $="Canceled";function S(r){return r instanceof L?!0:r instanceof Error&&r.name===$&&r.message===$}class L extends Error{constructor(){super($),this.name=this.message}}e.$5=L;function C(){const r=new Error($);return r.name=r.message,r}function m(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}function y(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function l(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=c;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const d=new i;return d.message=t.message,d.stack=t.stack,d}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$cb=s}),define(ke[19],Se([1,0,13,163]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=M,e.$tb=A,e.$ub=R,e.$vb=w,e.$wb=$,e.$xb=S,e.$yb=L,e.$zb=C,e.$Ab=m,e.$Bb=y,e.$Cb=v,e.$Db=l,e.$Eb=g,e.top=c,e.$Gb=n,e.$Hb=s,e.$Ib=r,e.$Jb=t,e.$Kb=d,e.$Lb=a,e.$Mb=h,e.$Nb=o,e.$Ob=p,e.$Pb=f,e.$Qb=D,e.$Rb=b,e.$Sb=k,e.$Tb=E,e.$Ub=P,e.$Vb=I,e.$Wb=F,e.$Xb=j,e.$Yb=z,e.$Zb=O,e.$1b=T,e.$2b=B,e.$3b=W,e.$4b=X,e.$5b=Z,e.$6b=Y,e.$7b=ge,e.$8b=ue,e.$$b=U;function M(se,re=0){return se[se.length-(1+re)]}function A(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}function R(se,re,oe=(K,ie)=>K===ie){if(se===re)return!0;if(!se||!re||se.length!==re.length)return!1;for(let K=0,ie=se.length;K<ie;K++)if(!oe(se[K],re[K]))return!1;return!0}function w(se,re){const oe=se.length-1;re<oe&&(se[re]=se[oe]),se.pop()}function $(se,re,oe){return S(se.length,K=>oe(se[K],re))}function S(se,re){let oe=0,K=se-1;for(;oe<=K;){const ie=(oe+K)/2|0,$e=re(ie);if($e<0)oe=ie+1;else if($e>0)K=ie-1;else return ie}return-(oe+1)}function L(se,re,oe){if(se=se|0,se>=re.length)throw new TypeError("invalid index");const K=re[Math.floor(re.length*Math.random())],ie=[],$e=[],we=[];for(const Le of re){const fe=oe(Le,K);fe<0?ie.push(Le):fe>0?$e.push(Le):we.push(Le)}return se<ie.length?L(se,ie,oe):se<ie.length+we.length?we[0]:L(se-(ie.length+we.length),$e,oe)}function C(se,re){const oe=[];let K;for(const ie of se.slice(0).sort(re))!K||re(K[0],ie)!==0?(K=[ie],oe.push(K)):K.push(ie);return oe}function*m(se,re){let oe,K;for(const ie of se)K!==void 0&&re(K,ie)?oe.push(ie):(oe&&(yield oe),oe=[ie]),K=ie;oe&&(yield oe)}function y(se,re){for(let oe=0;oe<=se.length;oe++)re(oe===0?void 0:se[oe-1],oe===se.length?void 0:se[oe])}function v(se,re){for(let oe=0;oe<se.length;oe++)re(oe===0?void 0:se[oe-1],se[oe],oe+1===se.length?void 0:se[oe+1])}function l(se,re,oe){const K=[];function ie(Le,fe,De){if(fe===0&&De.length===0)return;const Ie=K[K.length-1];Ie&&Ie.start+Ie.deleteCount===Le?(Ie.deleteCount+=fe,Ie.toInsert.push(...De)):K.push({start:Le,deleteCount:fe,toInsert:De})}let $e=0,we=0;for(;;){if($e===se.length){ie($e,0,re.slice(we));break}if(we===re.length){ie($e,se.length-$e,[]);break}const Le=se[$e],fe=re[we],De=oe(Le,fe);De===0?($e+=1,we+=1):De<0?(ie($e,1,[]),$e+=1):De>0&&(ie($e,0,[fe]),we+=1)}return K}function g(se,re,oe){const K=l(se,re,oe),ie=[],$e=[];for(const we of K)ie.push(...se.slice(we.start,we.start+we.deleteCount)),$e.push(...we.toInsert);return{removed:ie,added:$e}}function c(se,re,oe){if(oe===0)return[];const K=se.slice(0,oe).sort(re);return i(se,re,K,oe,se.length),K}function n(se,re,oe,K,ie){return oe===0?Promise.resolve([]):new Promise(($e,we)=>{(async()=>{const Le=se.length,fe=se.slice(0,oe).sort(re);for(let De=oe,Ie=Math.min(oe+K,Le);De<Le;De=Ie,Ie=Math.min(Ie+K,Le)){if(De>oe&&await new Promise(Te=>setTimeout(Te)),ie&&ie.isCancellationRequested)throw new u.$5;i(se,re,fe,De,Ie)}return fe})().then($e,we)})}function i(se,re,oe,K,ie){for(const $e=oe.length;K<ie;K++){const we=se[K];if(re(we,oe[$e-1])<0){oe.pop();const Le=(0,N.$kb)(oe,fe=>re(we,fe)<0);oe.splice(Le,0,we)}}}function s(se){return se.filter(re=>!!re)}function r(se){let re=0;for(let oe=0;oe<se.length;oe++)se[oe]&&(se[re]=se[oe],re+=1);se.length=re}function t(se,re,oe){se.splice(oe,0,se.splice(re,1)[0])}function d(se){return!Array.isArray(se)||se.length===0}function a(se){return Array.isArray(se)&&se.length>0}function h(se,re=oe=>oe){const oe=new Set;return se.filter(K=>{const ie=re(K);return oe.has(ie)?!1:(oe.add(ie),!0)})}function o(se){const re=new Set;return oe=>{const K=se(oe);return re.has(K)?!1:(re.add(K),!0)}}function p(se,re){return se.length>0?se[0]:re}function f(se,re){return se.length>0?se[se.length-1]:re}function D(se,re,oe=(K,ie)=>K===ie){let K=0;for(let ie=0,$e=Math.min(se.length,re.length);ie<$e&&oe(se[ie],re[ie]);ie++)K++;return K}function b(se){return[].concat(...se)}function k(se,re){let oe=typeof re=="number"?se:0;typeof re=="number"?oe=se:(oe=0,re=se);const K=[];if(oe<=re)for(let ie=oe;ie<re;ie++)K.push(ie);else for(let ie=oe;ie>re;ie--)K.push(ie);return K}function E(se,re,oe){return se.reduce((K,ie)=>(K[re(ie)]=oe?oe(ie):ie,K),Object.create(null))}function P(se,re){return se.push(re),()=>I(se,re)}function I(se,re){const oe=se.indexOf(re);if(oe>-1)return se.splice(oe,1),re}function F(se,re,oe){const K=se.slice(0,re),ie=se.slice(re);return K.concat(oe,ie)}function j(se,re){let oe;if(typeof re=="number"){let K=re;oe=()=>{const ie=Math.sin(K++)*179426549;return ie-Math.floor(ie)}}else oe=Math.random;for(let K=se.length-1;K>0;K-=1){const ie=Math.floor(oe()*(K+1)),$e=se[K];se[K]=se[ie],se[ie]=$e}}function z(se,re){const oe=se.indexOf(re);oe>-1&&(se.splice(oe,1),se.unshift(re))}function O(se,re){const oe=se.indexOf(re);oe>-1&&(se.splice(oe,1),se.push(re))}function T(se,re){for(const oe of re)se.push(oe)}function B(se,re){return Array.isArray(se)?se.map(re):re(se)}function W(se){return Array.isArray(se)?se:[se]}function X(se){return se[Math.floor(Math.random()*se.length)]}function Z(se,re,oe){const K=x(se,re),ie=se.length,$e=oe.length;se.length=ie+$e;for(let we=ie-1;we>=K;we--)se[we+$e]=se[we];for(let we=0;we<$e;we++)se[we+K]=oe[we]}function Y(se,re,oe,K){const ie=x(se,re);let $e=se.splice(ie,oe);return $e===void 0&&($e=[]),Z(se,ie,K),$e}function x(se,re){return re<0?Math.max(re+se.length,0):Math.min(re,se.length)}var ne;(function(se){function re($e){return $e<0}se.isLessThan=re;function oe($e){return $e<=0}se.isLessThanOrEqual=oe;function K($e){return $e>0}se.isGreaterThan=K;function ie($e){return $e===0}se.isNeitherLessOrGreaterThan=ie,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function ge(se,re){return(oe,K)=>re(se(oe),se(K))}function ue(...se){return(re,oe)=>{for(const K of se){const ie=K(re,oe);if(!ne.isNeitherLessOrGreaterThan(ie))return ie}return ne.neitherLessOrGreaterThan}}const ve=(se,re)=>se-re;e.$9b=ve;const te=(se,re)=>(0,e.$9b)(se?1:0,re?1:0);e.$0b=te;function U(se){return(re,oe)=>-se(re,oe)}class _{constructor(re){this.g=re,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(re){let oe=this.c;for(;oe<this.g.length&&re(this.g[oe]);)oe++;const K=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,K}takeFromEndWhile(re){let oe=this.d;for(;oe>=0&&re(this.g[oe]);)oe--;const K=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,K}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const re=this.g[this.c];return this.c++,re}removeLast(){const re=this.g[this.d];return this.d--,re}takeCount(re){const oe=this.g.slice(this.c,this.c+re);return this.c+=re,oe}}e.$_b=_;class be{static{this.empty=new be(re=>{})}constructor(re){this.iterate=re}forEach(re){this.iterate(oe=>(re(oe),!0))}toArray(){const re=[];return this.iterate(oe=>(re.push(oe),!0)),re}filter(re){return new be(oe=>this.iterate(K=>re(K)?oe(K):!0))}map(re){return new be(oe=>this.iterate(K=>oe(re(K))))}some(re){let oe=!1;return this.iterate(K=>(oe=re(K),!oe)),oe}findFirst(re){let oe;return this.iterate(K=>re(K)?(oe=K,!1):!0),oe}findLast(re){let oe;return this.iterate(K=>(re(K)&&(oe=K),!0)),oe}findLastMaxBy(re){let oe,K=!0;return this.iterate(ie=>((K||ne.isGreaterThan(re(ie,oe)))&&(K=!1,oe=ie),!0)),oe}}e.$ac=be;class Pe{constructor(re){this.c=re}static createSortPermutation(re,oe){const K=Array.from(re.keys()).sort((ie,$e)=>oe(re[ie],re[$e]));return new Pe(K)}apply(re){return re.map((oe,K)=>re[this.c[K]])}inverse(){const re=this.c.slice();for(let oe=0;oe<this.c.length;oe++)re[this.c[oe]]=oe;return new Pe(re)}}e.$bc=Pe}),define(ke[62],Se([1,0,13]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$cd=M,e.$dd=A,e.$ed=R,e.$fd=w,e.$gd=$;function N(S,L){if(!S)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}function M(S,L="Unreachable"){throw new Error(L)}function A(S){if(!S)throw new u.$cb("Assertion Failed")}function R(S){S||(0,u.$1)(new u.$cb("Soft Assertion Failed"))}function w(S){if(!S()){debugger;S(),(0,u.$1)(new u.$cb("Assertion Failed"))}}function $(S,L){let C=0;for(;C<S.length-1;){const m=S[C],y=S[C+1];if(!L(m,y))return!1;C++}return!0}}),define(ke[74],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=u;function u(N,M){const A=this;let R=!1,w;return function(){if(R)return w;if(R=!0,M)try{w=N.apply(A,arguments)}finally{M()}else w=N.apply(A,arguments);return w}}}),define(ke[124],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=void 0;class u{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$kP=u,e.$lP=new u("id#")}),define(ke[39],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(N){function M(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=M;const A=Object.freeze([]);function R(){return A}N.empty=R;function*w(t){yield t}N.single=w;function $(t){return M(t)?t:w(t)}N.wrap=$;function S(t){return t||A}N.from=S;function*L(t){for(let d=t.length-1;d>=0;d--)yield t[d]}N.reverse=L;function C(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=C;function m(t){return t[Symbol.iterator]().next().value}N.first=m;function y(t,d){for(const a of t)if(d(a))return!0;return!1}N.some=y;function v(t,d){for(const a of t)if(d(a))return a}N.find=v;function*l(t,d){for(const a of t)d(a)&&(yield a)}N.filter=l;function*g(t,d){let a=0;for(const h of t)yield d(h,a++)}N.map=g;function*c(...t){for(const d of t)yield*d}N.concat=c;function n(t,d,a){let h=a;for(const o of t)h=d(h,o);return h}N.reduce=n;function*i(t,d,a=t.length){for(d<0&&(d+=t.length),a<0?a+=t.length:a>t.length&&(a=t.length);d<a;d++)yield t[d]}N.slice=i;function s(t,d=Number.POSITIVE_INFINITY){const a=[];if(d===0)return[a,t];const h=t[Symbol.iterator]();for(let o=0;o<d;o++){const p=h.next();if(p.done)return[a,N.empty()];a.push(p.value)}return[a,{[Symbol.iterator](){return h}}]}N.consume=s;async function r(t){const d=[];for await(const a of t)d.push(a);return Promise.resolve(d)}N.asyncToArray=r})(u||(e.Iterable=u={}))}),define(ke[164],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Cn=R,e.$Dn=C,e.$En=m,e.$Fn=y,e.$Gn=v,e.$Hn=l,e.$In=g,e.$Jn=c,e.$Kn=n,e.$Ln=i,e.$Mn=s,e.$Nn=r;var u;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(t,d=!1){let a=0;const h=t.length;let o="",p=0,f=16,D=0;function b(z){let O=0,T=0;for(;O<z;){const B=t.charCodeAt(a);if(B>=48&&B<=57)T=T*16+B-48;else if(B>=65&&B<=70)T=T*16+B-65+10;else if(B>=97&&B<=102)T=T*16+B-97+10;else break;a++,O++}return O<z&&(T=-1),T}function k(z){a=z,o="",p=0,f=16,D=0}function E(){const z=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&S(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&S(t.charCodeAt(a)))for(a++;a<t.length&&S(t.charCodeAt(a));)a++;else return D=3,t.substring(z,a);let O=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&S(t.charCodeAt(a))){for(a++;a<t.length&&S(t.charCodeAt(a));)a++;O=a}else D=3;return t.substring(z,O)}function P(){let z="",O=a;for(;;){if(a>=h){z+=t.substring(O,a),D=2;break}const T=t.charCodeAt(a);if(T===34){z+=t.substring(O,a),a++;break}if(T===92){if(z+=t.substring(O,a),a++,a>=h){D=2;break}switch(t.charCodeAt(a++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const W=b(4);W>=0?z+=String.fromCharCode(W):D=4;break}default:D=5}O=a;continue}if(T>=0&&T<=31)if($(T)){z+=t.substring(O,a),D=2;break}else D=6;a++}return z}function I(){if(o="",D=0,p=a,a>=h)return p=h,f=17;let z=t.charCodeAt(a);if(w(z)){do a++,o+=String.fromCharCode(z),z=t.charCodeAt(a);while(w(z));return f=15}if($(z))return a++,o+=String.fromCharCode(z),z===13&&t.charCodeAt(a)===10&&(a++,o+=`
`),f=14;switch(z){case 123:return a++,f=1;case 125:return a++,f=2;case 91:return a++,f=3;case 93:return a++,f=4;case 58:return a++,f=6;case 44:return a++,f=5;case 34:return a++,o=P(),f=10;case 47:{const O=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<h&&!$(t.charCodeAt(a));)a++;return o=t.substring(O,a),f=12}if(t.charCodeAt(a+1)===42){a+=2;const T=h-1;let B=!1;for(;a<T;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,B=!0;break}a++}return B||(a++,D=1),o=t.substring(O,a),f=13}return o+=String.fromCharCode(z),a++,f=16}case 45:if(o+=String.fromCharCode(z),a++,a===h||!S(t.charCodeAt(a)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=E(),f=11;default:for(;a<h&&F(z);)a++,z=t.charCodeAt(a);if(p!==a){switch(o=t.substring(p,a),o){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return o+=String.fromCharCode(z),a++,f=16}}function F(z){if(w(z)||$(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let z;do z=I();while(z>=12&&z<=15);return z}return{setPosition:k,getPosition:()=>a,scan:d?j:I,getToken:()=>f,getTokenValue:()=>o,getTokenOffset:()=>p,getTokenLength:()=>a-p,getTokenError:()=>D}}function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function C(t,d){const a=[],h=new Object;let o;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function D(b,k,E,P){p.value=b,p.offset=k,p.length=E,p.type=P,p.colonOffset=void 0,o=p}try{i(t,{onObjectBegin:(b,k)=>{if(d<=b)throw h;o=void 0,f=d>b,a.push("")},onObjectProperty:(b,k,E)=>{if(d<k||(D(b,k,E,"property"),a[a.length-1]=b,d<=k+E))throw h},onObjectEnd:(b,k)=>{if(d<=b)throw h;o=void 0,a.pop()},onArrayBegin:(b,k)=>{if(d<=b)throw h;o=void 0,a.push(0)},onArrayEnd:(b,k)=>{if(d<=b)throw h;o=void 0,a.pop()},onLiteralValue:(b,k,E)=>{if(d<k||(D(b,k,E,r(b)),d<=k+E))throw h},onSeparator:(b,k,E)=>{if(d<=k)throw h;if(b===":"&&o&&o.type==="property")o.colonOffset=k,f=!1,o=void 0;else if(b===","){const P=a[a.length-1];typeof P=="number"?a[a.length-1]=P+1:(f=!0,a[a.length-1]=""),o=void 0}}})}catch(b){if(b!==h)throw b}return{path:a,previousNode:o,isAtPropertyKey:f,matches:b=>{let k=0;for(let E=0;k<b.length&&E<a.length;E++)if(b[k]===a[E]||b[k]==="*")k++;else if(b[k]!=="**")return!1;return k===b.length}}}function m(t,d=[],a=A.DEFAULT){let h=null,o=[];const p=[];function f(b){Array.isArray(o)?o.push(b):h!==null&&(o[h]=b)}return i(t,{onObjectBegin:()=>{const b={};f(b),p.push(o),o=b,h=null},onObjectProperty:b=>{h=b},onObjectEnd:()=>{o=p.pop()},onArrayBegin:()=>{const b=[];f(b),p.push(o),o=b,h=null},onArrayEnd:()=>{o=p.pop()},onLiteralValue:f,onError:(b,k,E)=>{d.push({error:b,offset:k,length:E})}},a),o[0]}function y(t,d=[],a=A.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(b){h.type==="property"&&(h.length=b-h.offset,h=h.parent)}function p(b){return h.children.push(b),b}i(t,{onObjectBegin:b=>{h=p({type:"object",offset:b,length:-1,parent:h,children:[]})},onObjectProperty:(b,k,E)=>{h=p({type:"property",offset:k,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:b,offset:k,length:E,parent:h})},onObjectEnd:(b,k)=>{h.length=b+k-h.offset,h=h.parent,o(b+k)},onArrayBegin:(b,k)=>{h=p({type:"array",offset:b,length:-1,parent:h,children:[]})},onArrayEnd:(b,k)=>{h.length=b+k-h.offset,h=h.parent,o(b+k)},onLiteralValue:(b,k,E)=>{p({type:r(b),offset:k,length:E,parent:h,value:b}),o(k+E)},onSeparator:(b,k,E)=>{h.type==="property"&&(b===":"?h.colonOffset=k:b===","&&o(k))},onError:(b,k,E)=>{d.push({error:b,offset:k,length:E})}},a);const D=h.children[0];return D&&delete D.parent,D}function v(t,d){if(!t)return;let a=t;for(const h of d)if(typeof h=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let o=!1;for(const p of a.children)if(Array.isArray(p.children)&&p.children[0].value===h){a=p.children[1],o=!0;break}if(!o)return}else{const o=h;if(a.type!=="array"||o<0||!Array.isArray(a.children)||o>=a.children.length)return;a=a.children[o]}return a}function l(t){if(!t.parent||!t.parent.children)return[];const d=l(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;d.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&d.push(a)}return d}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const d=Object.create(null);for(const a of t.children){const h=a.children[1];h&&(d[a.children[0].value]=g(h))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,d,a=!1){return d>=t.offset&&d<t.offset+t.length||a&&d===t.offset+t.length}function n(t,d,a=!1){if(c(t,d,a)){const h=t.children;if(Array.isArray(h))for(let o=0;o<h.length&&h[o].offset<=d;o++){const p=n(h[o],d,a);if(p)return p}return t}}function i(t,d,a=A.DEFAULT){const h=R(t,!1);function o(ge){return ge?()=>ge(h.getTokenOffset(),h.getTokenLength()):()=>!0}function p(ge){return ge?ue=>ge(ue,h.getTokenOffset(),h.getTokenLength()):()=>!0}const f=o(d.onObjectBegin),D=p(d.onObjectProperty),b=o(d.onObjectEnd),k=o(d.onArrayBegin),E=o(d.onArrayEnd),P=p(d.onLiteralValue),I=p(d.onSeparator),F=o(d.onComment),j=p(d.onError),z=a&&a.disallowComments,O=a&&a.allowTrailingComma;function T(){for(;;){const ge=h.scan();switch(h.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:z||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ge){case 12:case 13:z?B(10):F();break;case 16:B(1);break;case 15:case 14:break;default:return ge}}}function B(ge,ue=[],ve=[]){if(j(ge),ue.length+ve.length>0){let te=h.getToken();for(;te!==17;){if(ue.indexOf(te)!==-1){T();break}else if(ve.indexOf(te)!==-1)break;te=T()}}}function W(ge){const ue=h.getTokenValue();return ge?P(ue):D(ue),T(),!0}function X(){switch(h.getToken()){case 11:{let ge=0;try{ge=JSON.parse(h.getTokenValue()),typeof ge!="number"&&(B(2),ge=0)}catch{B(2)}P(ge);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return T(),!0}function Z(){return h.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),h.getToken()===6?(I(":"),T(),ne()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Y(){f(),T();let ge=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(ge||B(4,[],[]),I(","),T(),h.getToken()===2&&O)break}else ge&&B(6,[],[]);Z()||B(4,[],[2,5]),ge=!0}return b(),h.getToken()!==2?B(7,[2],[]):T(),!0}function x(){k(),T();let ge=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(ge||B(4,[],[]),I(","),T(),h.getToken()===4&&O)break}else ge&&B(6,[],[]);ne()||B(4,[],[4,5]),ge=!0}return E(),h.getToken()!==4?B(8,[4],[]):T(),!0}function ne(){switch(h.getToken()){case 3:return x();case 1:return Y();case 10:return W(!0);default:return X()}}return T(),h.getToken()===17?a.allowEmptyContent?!0:(B(4,[],[]),!1):ne()?(h.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function s(t,d){const a=R(t),h=[];let o,p=0,f;do switch(f=a.getPosition(),o=a.scan(),o){case 12:case 13:case 17:p!==f&&h.push(t.substring(p,f)),d!==void 0&&h.push(a.getTokenValue().replace(/[^\r\n]/g,d)),p=a.getPosition();break}while(o!==17);return h.join("")}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class u{constructor(M){this.d=M,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(M){this.c=M}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=u}),define(ke[75],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class u{static{this.Undefined=new u(void 0)}constructor(A){this.element=A,this.next=u.Undefined,this.prev=u.Undefined}}class N{constructor(){this.a=u.Undefined,this.b=u.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===u.Undefined}clear(){let A=this.a;for(;A!==u.Undefined;){const R=A.next;A.prev=u.Undefined,A.next=u.Undefined,A=R}this.a=u.Undefined,this.b=u.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,R){const w=new u(A);if(this.a===u.Undefined)this.a=w,this.b=w;else if(R){const S=this.b;this.b=w,w.prev=S,S.next=w}else{const S=this.a;this.a=w,w.next=S,S.prev=w}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(w))}}shift(){if(this.a!==u.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==u.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==u.Undefined&&A.next!==u.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===u.Undefined&&A.next===u.Undefined?(this.a=u.Undefined,this.b=u.Undefined):A.next===u.Undefined?(this.b=this.b.prev,this.b.next=u.Undefined):A.prev===u.Undefined&&(this.a=this.a.next,this.a.prev=u.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==u.Undefined;)yield A.element,A=A.next}}e.$5c=N}),define(ke[27],Se([1,0]),function(le,e){"use strict";var u,N,M;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=A,e.$zc=R,e.$Ac=w,e.$Ic=n;function A(i,s,r){let t=i.get(s);return t===void 0&&(t=r,i.set(s,t)),t}function R(i){const s=[];return i.forEach((r,t)=>{s.push(`${t} => ${r}`)}),`Map(${i.size}) {${s.join(", ")}}`}function w(i){const s=[];return i.forEach(r=>{s.push(r)}),`Set(${i.size}) {${s.join(", ")}}`}class ${constructor(s,r){this.uri=s,this.value=r}}function S(i){return Array.isArray(i)}class L{static{this.c=s=>s.toString()}constructor(s,r){if(this[u]="ResourceMap",s instanceof L)this.d=new Map(s.d),this.e=r??L.c;else if(S(s)){this.d=new Map,this.e=r??L.c;for(const[t,d]of s)this.set(t,d)}else this.d=new Map,this.e=s??L.c}set(s,r){return this.d.set(this.e(s),new $(s,r)),this}get(s){return this.d.get(this.e(s))?.value}has(s){return this.d.has(this.e(s))}get size(){return this.d.size}clear(){this.d.clear()}delete(s){return this.d.delete(this.e(s))}forEach(s,r){typeof r<"u"&&(s=s.bind(r));for(const[t,d]of this.d)s(d.value,d.uri,this)}*values(){for(const s of this.d.values())yield s.value}*keys(){for(const s of this.d.values())yield s.uri}*entries(){for(const s of this.d.values())yield[s.uri,s.value]}*[(u=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.d)yield[s.uri,s.value]}}e.$Bc=L;class C{constructor(s,r){this[N]="ResourceSet",!s||typeof s=="function"?this.c=new L(s):(this.c=new L(r),s.forEach(this.add,this))}get size(){return this.c.size}add(s){return this.c.set(s,s),this}clear(){this.c.clear()}delete(s){return this.c.delete(s)}forEach(s,r){this.c.forEach((t,d)=>s.call(r,d,d,this))}has(s){return this.c.has(s)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=C;var m;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class y{constructor(){this[M]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(s){return this.c.has(s)}get(s,r=0){const t=this.c.get(s);if(t)return r!==0&&this.l(t,r),t.value}set(s,r,t=0){let d=this.c.get(s);if(d)d.value=r,t!==0&&this.l(d,t);else{switch(d={key:s,value:r,next:void 0,previous:void 0},t){case 0:this.j(d);break;case 1:this.i(d);break;case 2:this.j(d);break;default:this.j(d);break}this.c.set(s,d),this.f++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this.c.get(s);if(r)return this.c.delete(s),this.k(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const s=this.d;return this.c.delete(s.key),this.k(s),this.f--,s.value}forEach(s,r){const t=this.g;let d=this.d;for(;d;){if(r?s.bind(r)(d.value,d.key,this):s(d.value,d.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const s=this,r=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(s.g!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const a={value:t.key,done:!1};return t=t.next,a}else return{value:void 0,done:!0}}};return d}values(){const s=this,r=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(s.g!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const a={value:t.value,done:!1};return t=t.next,a}else return{value:void 0,done:!0}}};return d}entries(){const s=this,r=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(s.g!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const a={value:[t.key,t.value],done:!1};return t=t.next,a}else return{value:void 0,done:!0}}};return d}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this.d,t=this.size;for(;r&&t>s;)this.c.delete(r.key),r=r.next,t--;this.d=r,this.f=t,r&&(r.previous=void 0),this.g++}i(s){if(!this.d&&!this.e)this.e=s;else if(this.d)s.next=this.d,this.d.previous=s;else throw new Error("Invalid list");this.d=s,this.g++}j(s){if(!this.d&&!this.e)this.d=s;else if(this.e)s.previous=this.e,this.e.next=s;else throw new Error("Invalid list");this.e=s,this.g++}k(s){if(s===this.d&&s===this.e)this.d=void 0,this.e=void 0;else if(s===this.d){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.d=s.next}else if(s===this.e){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.e=s.previous}else{const r=s.next,t=s.previous;if(!r||!t)throw new Error("Invalid list");r.previous=t,t.next=r}s.next=void 0,s.previous=void 0,this.g++}l(s,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this.d)return;const t=s.next,d=s.previous;s===this.e?(d.next=void 0,this.e=d):(t.previous=d,d.next=t),s.previous=void 0,s.next=this.d,this.d.previous=s,this.d=s,this.g++}else if(r===2){if(s===this.e)return;const t=s.next,d=s.previous;s===this.d?(t.previous=void 0,this.d=t):(t.previous=d,d.next=t),s.next=void 0,s.previous=this.e,this.e.next=s,this.e=s,this.g++}}}toJSON(){const s=[];return this.forEach((r,t)=>{s.push([t,r])}),s}fromJSON(s){this.clear();for(const[r,t]of s)this.set(r,t)}}e.$Dc=y;class v extends y{constructor(s,r=1){super(),this.m=s,this.n=Math.min(Math.max(0,r),1)}get limit(){return this.m}set limit(s){this.m=s,this.o()}get ratio(){return this.n}set ratio(s){this.n=Math.min(Math.max(0,s),1),this.o()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=v;class l{constructor(){this.c=new Map}add(s){return this.c.set(s,(this.c.get(s)||0)+1),this}delete(s){let r=this.c.get(s)||0;return r===0?!1:(r--,r===0?this.c.delete(s):this.c.set(s,r),!0)}has(s){return this.c.has(s)}}e.$Fc=l;class g{constructor(s){if(this.c=new Map,this.d=new Map,s)for(const[r,t]of s)this.set(r,t)}clear(){this.c.clear(),this.d.clear()}set(s,r){this.c.set(s,r),this.d.set(r,s)}get(s){return this.c.get(s)}getKey(s){return this.d.get(s)}delete(s){const r=this.c.get(s);return r===void 0?!1:(this.c.delete(s),this.d.delete(r),!0)}forEach(s,r){this.c.forEach((t,d)=>{s.call(r,t,d,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=g;class c{constructor(){this.c=new Map}add(s,r){let t=this.c.get(s);t||(t=new Set,this.c.set(s,t)),t.add(r)}delete(s,r){const t=this.c.get(s);t&&(t.delete(r),t.size===0&&this.c.delete(s))}forEach(s,r){const t=this.c.get(s);t&&t.forEach(r)}get(s){const r=this.c.get(s);return r||new Set}}e.$Hc=c;function n(i,s){if(i===s)return!0;if(i.size!==s.size)return!1;for(const[r,t]of i)if(!s.has(r)||s.get(r)!==t)return!1;for(const[r]of s)if(!i.has(r))return!1;return!0}}),define(ke[3],Se([1,0,19,73,27,74,39]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=L,e.$Lc=C,e.$Mc=m,e.$Nc=l,e.$Oc=g,e.$Pc=c,e.$Qc=n,e.$Rc=i,e.$Sc=s,e.$3c=b;const w=!1;let $=null;class S{constructor(){this.b=new Map}static{this.a=0}c(P){let I=this.b.get(P);return I||(I={parent:null,source:null,isSingleton:!1,value:P,idx:S.a++},this.b.set(P,I)),I}trackDisposable(P){const I=this.c(P);I.source||(I.source=new Error().stack)}setParent(P,I){const F=this.c(P);F.parent=I}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,I){const F=I.get(P);if(F)return F;const j=P.parent?this.f(this.c(P.parent),I):P;return I.set(P,j),j}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,P).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(P=10,I){let F;if(I)F=I;else{const B=new Map,W=[...this.b.values()].filter(Z=>Z.source!==null&&!this.f(Z,B).isSingleton);if(W.length===0)return;const X=new Set(W.map(Z=>Z.value));if(F=W.filter(Z=>!(Z.parent&&X.has(Z.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function j(B){function W(Z,Y){for(;Z.length>0&&Y.some(x=>typeof x=="string"?x===Z[0]:Z[0].match(x));)Z.shift()}const X=B.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return W(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const z=new M.$Hc;for(const B of F){const W=j(B);for(let X=0;X<=W.length;X++)z.add(W.slice(0,X).join(`
`),B)}F.sort((0,u.$7b)(B=>B.idx,u.$9b));let O="",T=0;for(const B of F.slice(0,P)){T++;const W=j(B),X=[];for(let Z=0;Z<W.length;Z++){let Y=W[Z];Y=`(shared with ${z.get(W.slice(0,Z+1).join(`
`)).size}/${F.length} leaks) at ${Y}`;const ne=z.get(W.slice(0,Z).join(`
`)),ge=(0,N.$K)([...ne].map(ue=>j(ue)[Z]),ue=>ue);delete ge[W[Z]];for(const[ue,ve]of Object.entries(ge))X.unshift(`    - stacktraces of ${ve.length} other leaks continue with ${ue}`);X.unshift(Y)}O+=`


==================== Leaking disposable ${T}/${F.length}: ${B.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return F.length>P&&(O+=`


... and ${F.length-P} more leaking disposables

`),{leaks:F,details:O}}}e.$Jc=S;function L(E){$=E}if(w){const E="__is_disposable_tracked__";L(new class{trackDisposable(P){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[E]||console.log(I)},3e3)}setParent(P,I){if(P&&P!==t.None)try{P[E]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[E]=!0}catch{}}markAsSingleton(P){}})}function C(E){return $?.trackDisposable(E),E}function m(E){$?.markAsDisposed(E)}function y(E,P){$?.setParent(E,P)}function v(E,P){if($)for(const I of E)$.setParent(I,P)}function l(E){return $?.markAsSingleton(E),E}function g(E){return typeof E=="object"&&E!==null&&typeof E.dispose=="function"&&E.dispose.length===0}function c(E){if(R.Iterable.is(E)){const P=[];for(const I of E)if(I)try{I.dispose()}catch(F){P.push(F)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}function n(E){for(const P of E)g(P)&&P.dispose();return[]}function i(...E){const P=s(()=>c(E));return v(E,P),P}function s(E){const P=C({dispose:(0,A.$db)(()=>{m(P),E()})});return P}class r{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return y(P,this),this.g?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),y(P,null))}}e.$Tc=r;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new r,C(this),y(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Uc=t;class d{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&y(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&y(P,null),P}}e.$Vc=d;class a{constructor(P){this.a=new d,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=a;class h{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=h;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let I=P;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,m(this))},this}}e.$Yc=o;class p{constructor(){this.a=new Map}acquire(P,...I){let F=this.a.get(P);F||(F={counter:0,object:this.b(P,...I)},this.a.set(P,F));const{object:j}=F,z=(0,A.$db)(()=>{--F.counter===0&&(this.c(P,F.object),this.a.delete(P))});return F.counter++,{object:j,dispose:z}}}e.$Zc=p;class f{constructor(P){this.a=P}async acquire(P,...I){const F=this.a.acquire(P,...I);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(j){throw F.dispose(),j}}}e.$1c=f;class D{constructor(P){this.object=P}dispose(){}}e.$2c=D;function b(E){const P=new r;try{E(P)}finally{P.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,I,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(P)?.dispose(),this.a.set(P,I)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=k}),function(le,e){typeof define=="function"&&define.amd?define(ke[165],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(se,re){for(var oe=0;oe<re.length;oe++){var K=re[oe];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(se,K.key,K)}}function u(se,re,oe){return re&&e(se.prototype,re),oe&&e(se,oe),Object.defineProperty(se,"prototype",{writable:!1}),se}function N(se,re){if(se){if(typeof se=="string")return M(se,re);var oe=Object.prototype.toString.call(se).slice(8,-1);if(oe==="Object"&&se.constructor&&(oe=se.constructor.name),oe==="Map"||oe==="Set")return Array.from(se);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return M(se,re)}}function M(se,re){(re==null||re>se.length)&&(re=se.length);for(var oe=0,K=new Array(re);oe<re;oe++)K[oe]=se[oe];return K}function A(se,re){var oe=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(oe)return(oe=oe.call(se)).next.bind(oe);if(Array.isArray(se)||(oe=N(se))||re&&se&&typeof se.length=="number"){oe&&(se=oe);var K=0;return function(){return K>=se.length?{done:!0}:{done:!1,value:se[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=R();function w(se){le.defaults=se}var $=/[&<>"']/,S=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(re){return m[re]};function v(se,re){if(re){if($.test(se))return se.replace(S,y)}else if(L.test(se))return se.replace(C,y);return se}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(se){return se.replace(l,function(re,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var c=/(^|[^\[])\^/g;function n(se,re){se=typeof se=="string"?se:se.source,re=re||"";var oe={replace:function(ie,$e){return $e=$e.source||$e,$e=$e.replace(c,"$1"),se=se.replace(ie,$e),oe},getRegex:function(){return new RegExp(se,re)}};return oe}var i=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function r(se,re,oe){if(se){var K;try{K=decodeURIComponent(g(oe)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}re&&!s.test(oe)&&(oe=o(re,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var t={},d=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(se,re){t[" "+se]||(d.test(se)?t[" "+se]=se+"/":t[" "+se]=b(se,"/",!0)),se=t[" "+se];var oe=se.indexOf(":")===-1;return re.substring(0,2)==="//"?oe?re:se.replace(a,"$1")+re:re.charAt(0)==="/"?oe?re:se.replace(h,"$1")+re:se+re}var p={exec:function(){}};function f(se){for(var re=1,oe,K;re<arguments.length;re++){oe=arguments[re];for(K in oe)Object.prototype.hasOwnProperty.call(oe,K)&&(se[K]=oe[K])}return se}function D(se,re){var oe=se.replace(/\|/g,function($e,we,Le){for(var fe=!1,De=we;--De>=0&&Le[De]==="\\";)fe=!fe;return fe?"|":" |"}),K=oe.split(/ \|/),ie=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>re)K.splice(re);else for(;K.length<re;)K.push("");for(;ie<K.length;ie++)K[ie]=K[ie].trim().replace(/\\\|/g,"|");return K}function b(se,re,oe){var K=se.length;if(K===0)return"";for(var ie=0;ie<K;){var $e=se.charAt(K-ie-1);if($e===re&&!oe)ie++;else if($e!==re&&oe)ie++;else break}return se.slice(0,K-ie)}function k(se,re){if(se.indexOf(re[1])===-1)return-1;for(var oe=se.length,K=0,ie=0;ie<oe;ie++)if(se[ie]==="\\")ie++;else if(se[ie]===re[0])K++;else if(se[ie]===re[1]&&(K--,K<0))return ie;return-1}function E(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(se,re){if(re<1)return"";for(var oe="";re>1;)re&1&&(oe+=se),re>>=1,se+=se;return oe+se}function I(se,re,oe,K){var ie=re.href,$e=re.title?v(re.title):null,we=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){K.state.inLink=!0;var Le={type:"link",raw:oe,href:ie,title:$e,text:we,tokens:K.inlineTokens(we)};return K.state.inLink=!1,Le}return{type:"image",raw:oe,href:ie,title:$e,text:v(we)}}function F(se,re){var oe=se.match(/^(\s+)(?:```)/);if(oe===null)return re;var K=oe[1];return re.split(`
`).map(function(ie){var $e=ie.match(/^\s+/);if($e===null)return ie;var we=$e[0];return we.length>=K.length?ie.slice(K.length):ie}).join(`
`)}var j=function(){function se(oe){this.options=oe||le.defaults}var re=se.prototype;return re.space=function(K){var ie=this.rules.block.newline.exec(K);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},re.code=function(K){var ie=this.rules.block.code.exec(K);if(ie){var $e=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:b($e,`
`)}}},re.fences=function(K){var ie=this.rules.block.fences.exec(K);if(ie){var $e=ie[0],we=F($e,ie[3]||"");return{type:"code",raw:$e,lang:ie[2]?ie[2].trim():ie[2],text:we}}},re.heading=function(K){var ie=this.rules.block.heading.exec(K);if(ie){var $e=ie[2].trim();if(/#$/.test($e)){var we=b($e,"#");(this.options.pedantic||!we||/ $/.test(we))&&($e=we.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:$e,tokens:this.lexer.inline($e)}}},re.hr=function(K){var ie=this.rules.block.hr.exec(K);if(ie)return{type:"hr",raw:ie[0]}},re.blockquote=function(K){var ie=this.rules.block.blockquote.exec(K);if(ie){var $e=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},re.list=function(K){var ie=this.rules.block.list.exec(K);if(ie){var $e,we,Le,fe,De,Ie,Te,V,q,Q,J,he,pe=ie[1].trim(),ze=pe.length>1,qe={type:"list",raw:"",ordered:ze,start:ze?+pe.slice(0,-1):"",loose:!1,items:[]};pe=ze?"\\d{1,9}\\"+pe.slice(-1):"\\"+pe,this.options.pedantic&&(pe=ze?pe:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(he=!1,!(!(ie=Ye.exec(K))||this.rules.block.hr.test(K)));){if($e=ie[0],K=K.substring($e.length),V=ie[2].split(`
`,1)[0],q=K.split(`
`,1)[0],this.options.pedantic?(fe=2,J=V.trimLeft()):(fe=ie[2].search(/[^ ]/),fe=fe>4?1:fe,J=V.slice(fe),fe+=ie[1].length),Ie=!1,!V&&/^ *$/.test(q)&&($e+=q+`
`,K=K.substring(q.length+1),he=!0),!he)for(var it=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");K&&(Q=K.split(`
`,1)[0],V=Q,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(V)||st.test(V)||it.test(V)||ot.test(K)));){if(V.search(/[^ ]/)>=fe||!V.trim())J+=`
`+V.slice(fe);else if(!Ie)J+=`
`+V;else break;!Ie&&!V.trim()&&(Ie=!0),$e+=Q+`
`,K=K.substring(Q.length+1)}qe.loose||(Te?qe.loose=!0:/\n *\n *$/.test($e)&&(Te=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(J),we&&(Le=we[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:$e,task:!!we,checked:Le,loose:!1,text:J}),qe.raw+=$e}qe.items[qe.items.length-1].raw=$e.trimRight(),qe.items[qe.items.length-1].text=J.trimRight(),qe.raw=qe.raw.trimRight();var Ce=qe.items.length;for(De=0;De<Ce;De++){this.lexer.state.top=!1,qe.items[De].tokens=this.lexer.blockTokens(qe.items[De].text,[]);var Be=qe.items[De].tokens.filter(function(Ne){return Ne.type==="space"}),Ge=Be.every(function(Ne){for(var Xe=Ne.raw.split(""),ae=0,ce=A(Xe),Ae;!(Ae=ce()).done;){var Ke=Ae.value;if(Ke===`
`&&(ae+=1),ae>1)return!0}return!1});!qe.loose&&Be.length&&Ge&&(qe.loose=!0,qe.items[De].loose=!0)}return qe}},re.html=function(K){var ie=this.rules.block.html.exec(K);if(ie){var $e={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]);$e.type="paragraph",$e.text=we,$e.tokens=this.lexer.inline(we)}return $e}},re.def=function(K){var ie=this.rules.block.def.exec(K);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var $e=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:ie[0],href:ie[2],title:ie[3]}}},re.table=function(K){var ie=this.rules.block.table.exec(K);if(ie){var $e={type:"table",header:D(ie[1]).map(function(Te){return{text:Te}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=ie[0];var we=$e.align.length,Le,fe,De,Ie;for(Le=0;Le<we;Le++)/^ *-+: *$/.test($e.align[Le])?$e.align[Le]="right":/^ *:-+: *$/.test($e.align[Le])?$e.align[Le]="center":/^ *:-+ *$/.test($e.align[Le])?$e.align[Le]="left":$e.align[Le]=null;for(we=$e.rows.length,Le=0;Le<we;Le++)$e.rows[Le]=D($e.rows[Le],$e.header.length).map(function(Te){return{text:Te}});for(we=$e.header.length,fe=0;fe<we;fe++)$e.header[fe].tokens=this.lexer.inline($e.header[fe].text);for(we=$e.rows.length,fe=0;fe<we;fe++)for(Ie=$e.rows[fe],De=0;De<Ie.length;De++)Ie[De].tokens=this.lexer.inline(Ie[De].text);return $e}}},re.lheading=function(K){var ie=this.rules.block.lheading.exec(K);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},re.paragraph=function(K){var ie=this.rules.block.paragraph.exec(K);if(ie){var $e=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:$e,tokens:this.lexer.inline($e)}}},re.text=function(K){var ie=this.rules.block.text.exec(K);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},re.escape=function(K){var ie=this.rules.inline.escape.exec(K);if(ie)return{type:"escape",raw:ie[0],text:v(ie[1])}},re.tag=function(K){var ie=this.rules.inline.tag.exec(K);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]}},re.link=function(K){var ie=this.rules.inline.link.exec(K);if(ie){var $e=ie[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var we=b($e.slice(0,-1),"\\");if(($e.length-we.length)%2===0)return}else{var Le=k(ie[2],"()");if(Le>-1){var fe=ie[0].indexOf("!")===0?5:4,De=fe+ie[1].length+Le;ie[2]=ie[2].substring(0,Le),ie[0]=ie[0].substring(0,De).trim(),ie[3]=""}}var Ie=ie[2],Te="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);V&&(Ie=V[1],Te=V[3])}else Te=ie[3]?ie[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test($e)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),I(ie,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},re.reflink=function(K,ie){var $e;if(($e=this.rules.inline.reflink.exec(K))||($e=this.rules.inline.nolink.exec(K))){var we=($e[2]||$e[1]).replace(/\s+/g," ");if(we=ie[we.toLowerCase()],!we||!we.href){var Le=$e[0].charAt(0);return{type:"text",raw:Le,text:Le}}return I($e,we,$e[0],this.lexer)}},re.emStrong=function(K,ie,$e){$e===void 0&&($e="");var we=this.rules.inline.emStrong.lDelim.exec(K);if(we&&!(we[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Le=we[1]||we[2]||"";if(!Le||Le&&($e===""||this.rules.inline.punctuation.exec($e))){var fe=we[0].length-1,De,Ie,Te=fe,V=0,q=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,ie=ie.slice(-1*K.length+fe);(we=q.exec(ie))!=null;)if(De=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!De){if(Ie=De.length,we[3]||we[4]){Te+=Ie;continue}else if((we[5]||we[6])&&fe%3&&!((fe+Ie)%3)){V+=Ie;continue}if(Te-=Ie,!(Te>0)){if(Ie=Math.min(Ie,Ie+Te+V),Math.min(fe,Ie)%2){var Q=K.slice(1,fe+we.index+Ie);return{type:"em",raw:K.slice(0,fe+we.index+Ie+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var J=K.slice(2,fe+we.index+Ie-1);return{type:"strong",raw:K.slice(0,fe+we.index+Ie+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},re.codespan=function(K){var ie=this.rules.inline.code.exec(K);if(ie){var $e=ie[2].replace(/\n/g," "),we=/[^ ]/.test($e),Le=/^ /.test($e)&&/ $/.test($e);return we&&Le&&($e=$e.substring(1,$e.length-1)),$e=v($e,!0),{type:"codespan",raw:ie[0],text:$e}}},re.br=function(K){var ie=this.rules.inline.br.exec(K);if(ie)return{type:"br",raw:ie[0]}},re.del=function(K){var ie=this.rules.inline.del.exec(K);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},re.autolink=function(K,ie){var $e=this.rules.inline.autolink.exec(K);if($e){var we,Le;return $e[2]==="@"?(we=v(this.options.mangle?ie($e[1]):$e[1]),Le="mailto:"+we):(we=v($e[1]),Le=we),{type:"link",raw:$e[0],text:we,href:Le,tokens:[{type:"text",raw:we,text:we}]}}},re.url=function(K,ie){var $e;if($e=this.rules.inline.url.exec(K)){var we,Le;if($e[2]==="@")we=v(this.options.mangle?ie($e[0]):$e[0]),Le="mailto:"+we;else{var fe;do fe=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(fe!==$e[0]);we=v($e[0]),$e[1]==="www."?Le="http://"+we:Le=we}return{type:"link",raw:$e[0],text:we,href:Le,tokens:[{type:"text",raw:we,text:we}]}}},re.inlineText=function(K,ie){var $e=this.rules.inline.text.exec(K);if($e){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):v($e[0]):$e[0]:we=v(this.options.smartypants?ie($e[0]):$e[0]),{type:"text",raw:$e[0],text:we}}},se}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=f({},z),z.gfm=f({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=f({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=n(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=n(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=n(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=n(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=n(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=n(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=n(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=n(O.reflink).replace("label",O._label).replace("ref",z._label).getRegex(),O.nolink=n(O.nolink).replace("ref",z._label).getRegex(),O.reflinkSearch=n(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=f({},O),O.pedantic=f({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=f({},O.normal,{escape:n(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=n(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=f({},O.gfm,{br:n(O.br).replace("{2,}","*").getRegex(),text:n(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(se){var re="",oe,K,ie=se.length;for(oe=0;oe<ie;oe++)K=se.charCodeAt(oe),Math.random()>.5&&(K="x"+K.toString(16)),re+="&#"+K+";";return re}var W=function(){function se(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||le.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:z.normal,inline:O.normal};this.options.pedantic?(K.block=z.pedantic,K.inline=O.pedantic):this.options.gfm&&(K.block=z.gfm,this.options.breaks?K.inline=O.breaks:K.inline=O.gfm),this.tokenizer.rules=K}se.lex=function(K,ie){var $e=new se(ie);return $e.lex(K)},se.lexInline=function(K,ie){var $e=new se(ie);return $e.inlineTokens(K)};var re=se.prototype;return re.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},re.blockTokens=function(K,ie){var $e=this;ie===void 0&&(ie=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(Te,V,q){return V+"    ".repeat(q.length)});for(var we,Le,fe,De;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(we=Te.call({lexer:$e},K,ie))?(K=K.substring(we.raw.length),ie.push(we),!0):!1}))){if(we=this.tokenizer.space(K)){K=K.substring(we.raw.length),we.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(we);continue}if(we=this.tokenizer.code(K)){K=K.substring(we.raw.length),Le=ie[ie.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+we.raw,Le.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ie.push(we);continue}if(we=this.tokenizer.fences(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.heading(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.hr(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.blockquote(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.list(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.html(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.def(K)){K=K.substring(we.raw.length),Le=ie[ie.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+we.raw,Le.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.lheading(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(fe=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,V=K.slice(1),q=void 0;$e.options.extensions.startBlock.forEach(function(Q){q=Q.call({lexer:this},V),typeof q=="number"&&q>=0&&(Te=Math.min(Te,q))}),Te<1/0&&Te>=0&&(fe=K.substring(0,Te+1))}(),this.state.top&&(we=this.tokenizer.paragraph(fe))){Le=ie[ie.length-1],De&&Le.type==="paragraph"?(Le.raw+=`
`+we.raw,Le.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ie.push(we),De=fe.length!==K.length,K=K.substring(we.raw.length);continue}if(we=this.tokenizer.text(K)){K=K.substring(we.raw.length),Le=ie[ie.length-1],Le&&Le.type==="text"?(Le.raw+=`
`+we.raw,Le.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ie.push(we);continue}if(K){var Ie="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,ie},re.inline=function(K,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:K,tokens:ie}),ie},re.inlineTokens=function(K,ie){var $e=this;ie===void 0&&(ie=[]);var we,Le,fe,De=K,Ie,Te,V;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)q.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Ie.index)+"["+P("a",Ie[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Ie.index)+"["+P("a",Ie[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Ie.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(Te||(V=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(we=J.call({lexer:$e},K,ie))?(K=K.substring(we.raw.length),ie.push(we),!0):!1}))){if(we=this.tokenizer.escape(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.tag(K)){K=K.substring(we.raw.length),Le=ie[ie.length-1],Le&&we.type==="text"&&Le.type==="text"?(Le.raw+=we.raw,Le.text+=we.text):ie.push(we);continue}if(we=this.tokenizer.link(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(we.raw.length),Le=ie[ie.length-1],Le&&we.type==="text"&&Le.type==="text"?(Le.raw+=we.raw,Le.text+=we.text):ie.push(we);continue}if(we=this.tokenizer.emStrong(K,De,V)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.codespan(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.br(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.del(K)){K=K.substring(we.raw.length),ie.push(we);continue}if(we=this.tokenizer.autolink(K,B)){K=K.substring(we.raw.length),ie.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(K,B))){K=K.substring(we.raw.length),ie.push(we);continue}if(fe=K,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,he=K.slice(1),pe=void 0;$e.options.extensions.startInline.forEach(function(ze){pe=ze.call({lexer:this},he),typeof pe=="number"&&pe>=0&&(J=Math.min(J,pe))}),J<1/0&&J>=0&&(fe=K.substring(0,J+1))}(),we=this.tokenizer.inlineText(fe,T)){K=K.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(V=we.raw.slice(-1)),Te=!0,Le=ie[ie.length-1],Le&&Le.type==="text"?(Le.raw+=we.raw,Le.text+=we.text):ie.push(we);continue}if(K){var Q="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return ie},u(se,null,[{key:"rules",get:function(){return{block:z,inline:O}}}]),se}(),X=function(){function se(oe){this.options=oe||le.defaults}var re=se.prototype;return re.code=function(K,ie,$e){var we=(ie||"").match(/\S*/)[0];if(this.options.highlight){var Le=this.options.highlight(K,we);Le!=null&&Le!==K&&($e=!0,K=Le)}return K=K.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+v(we,!0)+'">'+($e?K:v(K,!0))+`</code></pre>
`:"<pre><code>"+($e?K:v(K,!0))+`</code></pre>
`},re.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},re.html=function(K){return K},re.heading=function(K,ie,$e,we){if(this.options.headerIds){var Le=this.options.headerPrefix+we.slug($e);return"<h"+ie+' id="'+Le+'">'+K+"</h"+ie+`>
`}return"<h"+ie+">"+K+"</h"+ie+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(K,ie,$e){var we=ie?"ol":"ul",Le=ie&&$e!==1?' start="'+$e+'"':"";return"<"+we+Le+`>
`+K+"</"+we+`>
`},re.listitem=function(K){return"<li>"+K+`</li>
`},re.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(K){return"<p>"+K+`</p>
`},re.table=function(K,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ie+`</table>
`},re.tablerow=function(K){return`<tr>
`+K+`</tr>
`},re.tablecell=function(K,ie){var $e=ie.header?"th":"td",we=ie.align?"<"+$e+' align="'+ie.align+'">':"<"+$e+">";return we+K+("</"+$e+`>
`)},re.strong=function(K){return"<strong>"+K+"</strong>"},re.em=function(K){return"<em>"+K+"</em>"},re.codespan=function(K){return"<code>"+K+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(K){return"<del>"+K+"</del>"},re.link=function(K,ie,$e){if(K=r(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var we='<a href="'+v(K)+'"';return ie&&(we+=' title="'+ie+'"'),we+=">"+$e+"</a>",we},re.image=function(K,ie,$e){if(K=r(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var we='<img src="'+K+'" alt="'+$e+'"';return ie&&(we+=' title="'+ie+'"'),we+=this.options.xhtml?"/>":">",we},re.text=function(K){return K},se}(),Z=function(){function se(){}var re=se.prototype;return re.strong=function(K){return K},re.em=function(K){return K},re.codespan=function(K){return K},re.del=function(K){return K},re.html=function(K){return K},re.text=function(K){return K},re.link=function(K,ie,$e){return""+$e},re.image=function(K,ie,$e){return""+$e},re.br=function(){return""},se}(),Y=function(){function se(){this.seen={}}var re=se.prototype;return re.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(K,ie){var $e=K,we=0;if(this.seen.hasOwnProperty($e)){we=this.seen[K];do we++,$e=K+"-"+we;while(this.seen.hasOwnProperty($e))}return ie||(this.seen[K]=we,this.seen[$e]=0),$e},re.slug=function(K,ie){ie===void 0&&(ie={});var $e=this.serialize(K);return this.getNextSafeSlug($e,ie.dryrun)},se}(),x=function(){function se(oe){this.options=oe||le.defaults,this.options.renderer=this.options.renderer||new X,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new Y}se.parse=function(K,ie){var $e=new se(ie);return $e.parse(K)},se.parseInline=function(K,ie){var $e=new se(ie);return $e.parseInline(K)};var re=se.prototype;return re.parse=function(K,ie){ie===void 0&&(ie=!0);var $e="",we,Le,fe,De,Ie,Te,V,q,Q,J,he,pe,ze,qe,Ye,it,ot,nt,st,Ce=K.length;for(we=0;we<Ce;we++){if(J=K[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(st=this.options.extensions.renderers[J.type].call({parser:this},J),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){$e+=st||"";continue}switch(J.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(J.tokens),J.depth,g(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(q="",V="",De=J.header.length,Le=0;Le<De;Le++)V+=this.renderer.tablecell(this.parseInline(J.header[Le].tokens),{header:!0,align:J.align[Le]});for(q+=this.renderer.tablerow(V),Q="",De=J.rows.length,Le=0;Le<De;Le++){for(Te=J.rows[Le],V="",Ie=Te.length,fe=0;fe<Ie;fe++)V+=this.renderer.tablecell(this.parseInline(Te[fe].tokens),{header:!1,align:J.align[fe]});Q+=this.renderer.tablerow(V)}$e+=this.renderer.table(q,Q);continue}case"blockquote":{Q=this.parse(J.tokens),$e+=this.renderer.blockquote(Q);continue}case"list":{for(he=J.ordered,pe=J.start,ze=J.loose,De=J.items.length,Q="",Le=0;Le<De;Le++)Ye=J.items[Le],it=Ye.checked,ot=Ye.task,qe="",Ye.task&&(nt=this.renderer.checkbox(it),ze?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=nt+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=nt+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:nt}):qe+=nt),qe+=this.parse(Ye.tokens,ze),Q+=this.renderer.listitem(qe,ot,it);$e+=this.renderer.list(Q,he,pe);continue}case"html":{$e+=this.renderer.html(J.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(Q=J.tokens?this.parseInline(J.tokens):J.text;we+1<Ce&&K[we+1].type==="text";)J=K[++we],Q+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);$e+=ie?this.renderer.paragraph(Q):Q;continue}default:{var Be='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return $e},re.parseInline=function(K,ie){ie=ie||this.renderer;var $e="",we,Le,fe,De=K.length;for(we=0;we<De;we++){if(Le=K[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Le.type]&&(fe=this.options.extensions.renderers[Le.type].call({parser:this},Le),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Le.type))){$e+=fe||"";continue}switch(Le.type){case"escape":{$e+=ie.text(Le.text);break}case"html":{$e+=ie.html(Le.text);break}case"link":{$e+=ie.link(Le.href,Le.title,this.parseInline(Le.tokens,ie));break}case"image":{$e+=ie.image(Le.href,Le.title,Le.text);break}case"strong":{$e+=ie.strong(this.parseInline(Le.tokens,ie));break}case"em":{$e+=ie.em(this.parseInline(Le.tokens,ie));break}case"codespan":{$e+=ie.codespan(Le.text);break}case"br":{$e+=ie.br();break}case"del":{$e+=ie.del(this.parseInline(Le.tokens,ie));break}case"text":{$e+=ie.text(Le.text);break}default:{var Ie='Token with "'+Le.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return $e},se}();function ne(se,re,oe){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof re=="function"&&(oe=re,re=null),re=f({},ne.defaults,re||{}),E(re),oe){var K=re.highlight,ie;try{ie=W.lex(se,re)}catch(De){return oe(De)}var $e=function(Ie){var Te;if(!Ie)try{re.walkTokens&&ne.walkTokens(ie,re.walkTokens),Te=x.parse(ie,re)}catch(V){Ie=V}return re.highlight=K,Ie?oe(Ie):oe(null,Te)};if(!K||K.length<3||(delete re.highlight,!ie.length))return $e();var we=0;ne.walkTokens(ie,function(De){De.type==="code"&&(we++,setTimeout(function(){K(De.text,De.lang,function(Ie,Te){if(Ie)return $e(Ie);Te!=null&&Te!==De.text&&(De.text=Te,De.escaped=!0),we--,we===0&&$e()})},0))}),we===0&&$e();return}function Le(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+v(De.message+"",!0)+"</pre>";throw De}try{var fe=W.lex(se,re);if(re.walkTokens){if(re.async)return Promise.all(ne.walkTokens(fe,re.walkTokens)).then(function(){return x.parse(fe,re)}).catch(Le);ne.walkTokens(fe,re.walkTokens)}return x.parse(fe,re)}catch(De){Le(De)}}ne.options=ne.setOptions=function(se){return f(ne.defaults,se),w(ne.defaults),ne},ne.getDefaults=R,ne.defaults=le.defaults,ne.use=function(){for(var se=arguments.length,re=new Array(se),oe=0;oe<se;oe++)re[oe]=arguments[oe];var K=f.apply(void 0,[{}].concat(re)),ie=ne.defaults.extensions||{renderers:{},childTokens:{}},$e;re.forEach(function(we){if(we.extensions&&($e=!0,we.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var De=ie.renderers?ie.renderers[fe.name]:null;De?ie.renderers[fe.name]=function(){for(var Ie=arguments.length,Te=new Array(Ie),V=0;V<Ie;V++)Te[V]=arguments[V];var q=fe.renderer.apply(this,Te);return q===!1&&(q=De.apply(this,Te)),q}:ie.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[fe.level]?ie[fe.level].unshift(fe.tokenizer):ie[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?ie.startBlock?ie.startBlock.push(fe.start):ie.startBlock=[fe.start]:fe.level==="inline"&&(ie.startInline?ie.startInline.push(fe.start):ie.startInline=[fe.start]))}fe.childTokens&&(ie.childTokens[fe.name]=fe.childTokens)})),we.renderer&&function(){var fe=ne.defaults.renderer||new X,De=function(V){var q=fe[V];fe[V]=function(){for(var Q=arguments.length,J=new Array(Q),he=0;he<Q;he++)J[he]=arguments[he];var pe=we.renderer[V].apply(fe,J);return pe===!1&&(pe=q.apply(fe,J)),pe}};for(var Ie in we.renderer)De(Ie);K.renderer=fe}(),we.tokenizer&&function(){var fe=ne.defaults.tokenizer||new j,De=function(V){var q=fe[V];fe[V]=function(){for(var Q=arguments.length,J=new Array(Q),he=0;he<Q;he++)J[he]=arguments[he];var pe=we.tokenizer[V].apply(fe,J);return pe===!1&&(pe=q.apply(fe,J)),pe}};for(var Ie in we.tokenizer)De(Ie);K.tokenizer=fe}(),we.walkTokens){var Le=ne.defaults.walkTokens;K.walkTokens=function(fe){var De=[];return De.push(we.walkTokens.call(this,fe)),Le&&(De=De.concat(Le.call(this,fe))),De}}$e&&(K.extensions=ie),ne.setOptions(K)})},ne.walkTokens=function(se,re){for(var oe=[],K=function(){var Le=$e.value;switch(oe=oe.concat(re.call(ne,Le)),Le.type){case"table":{for(var fe=A(Le.header),De;!(De=fe()).done;){var Ie=De.value;oe=oe.concat(ne.walkTokens(Ie.tokens,re))}for(var Te=A(Le.rows),V;!(V=Te()).done;)for(var q=V.value,Q=A(q),J;!(J=Q()).done;){var he=J.value;oe=oe.concat(ne.walkTokens(he.tokens,re))}break}case"list":{oe=oe.concat(ne.walkTokens(Le.items,re));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[Le.type]?ne.defaults.extensions.childTokens[Le.type].forEach(function(pe){oe=oe.concat(ne.walkTokens(Le[pe],re))}):Le.tokens&&(oe=oe.concat(ne.walkTokens(Le.tokens,re)))}},ie=A(se),$e;!($e=ie()).done;)K();return oe},ne.parseInline=function(se,re){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");re=f({},ne.defaults,re||{}),E(re);try{var oe=W.lexInline(se,re);return re.walkTokens&&ne.walkTokens(oe,re.walkTokens),x.parseInline(oe,re)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+v(K.message+"",!0)+"</pre>";throw K}},ne.Parser=x,ne.parser=x.parse,ne.Renderer=X,ne.TextRenderer=Z,ne.Lexer=W,ne.lexer=W.lex,ne.Tokenizer=j,ne.Slugger=Y,ne.parse=ne;var ge=ne.options,ue=ne.setOptions,ve=ne.use,te=ne.walkTokens,U=ne.parseInline,_=ne,be=x.parse,Pe=W.lex;le.Lexer=W,le.Parser=x,le.Renderer=X,le.Slugger=Y,le.TextRenderer=Z,le.Tokenizer=j,le.getDefaults=R,le.lexer=Pe,le.marked=ne,le.options=ge,le.parse=_,le.parseInline=U,le.parser=be,le.setOptions=ue,le.use=ve,le.walkTokens=te,Object.defineProperty(le,"__esModule",{value:!0})}),define(ke[166],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=u;function u(l){const g=A(l);if(g&&g.length>0)return new Uint32Array(g)}let N=0;const M=new Uint32Array(10);function A(l){if(N=0,R(l,C,4352),N>0||(R(l,m,4449),N>0)||(R(l,y,4520),N>0)||(R(l,v,12593),N))return M.subarray(0,N);if(l>=44032&&l<=55203){const g=l-44032,c=g%588,n=Math.floor(g/588),i=Math.floor(c/28),s=c%28-1;if(n<C.length?R(n,C,0):4352+n-12593<v.length&&R(4352+n,v,12593),i<m.length?R(i,m,0):4449+i-12593<v.length&&R(4449+i-12593,v,12593),s>=0&&(s<y.length?R(s,y,0):4520+s-12593<v.length&&R(4520+s-12593,v,12593)),N>0)return M.subarray(0,N)}}function R(l,g,c){l>=c&&l<c+g.length&&w(g[l-c])}function w(l){l!==0&&(M[N++]=l&255,l>>8&&(M[N++]=l>>8&255),l>>16&&(M[N++]=l>>16&255))}var $;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var S;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(S||(S={}));var L;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(L||(L={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),y=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Se([1,0,27]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=void 0,e.$9l=M,e.$0l=R;const N=new u.$Ec(1e4);function M(S){return $(S,"NFC",N)}const A=new u.$Ec(1e4);function R(S){return $(S,"NFD",A)}const w=/[^\u0000-\u0080]/;function $(S,L,C){if(!S)return S;const m=C.get(S);if(m)return m;let y;return w.test(S)?y=S.normalize(L):y=S,C.set(S,y),y}e.$$l=function(){const S=/[\u0300-\u036f]/g;return function(L){return R(L).replace(S,"")}}()}),define(ke[125],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=void 0,e.$wm=u,e.rot=N;function u(w,$,S){return Math.min(Math.max(w,$),S)}function N(w,$){return($+w%$)%$}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$ym=M;class A{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$zm=A;class R{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const S=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Am=R}),function(){function le(M){const A=[];typeof M=="number"&&A.push("code/timeOrigin",M);function R($){A.push($,Date.now())}function w(){const $=[];for(let S=0;S<A.length;S+=2)$.push({name:A[S],startTime:A[S+1]});return $}return{mark:R,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(M+R.startTime)});return A}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function u(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=u(N))}(),define(ke[167],Se([1,0,39]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=void 0;const N=Symbol("unset");class M{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||u.Iterable.empty()}insert($,S,L){this.d($,C=>C._value=S,L)}mutate($,S){this.d($,L=>L._value=S(L._value===N?void 0:L._value))}delete($){const S=this.c($);if(!S)return;let L=S.length-1;const C=S[L].node._value;if(C!==N){for(this.b--,S[L].node._value=N;L>0;L--){const{node:m,part:y}=S[L];if(m.children?.size||m._value!==N)break;S[L-1].node.children.delete(y)}return C}}*deleteRecursive($){const S=this.c($);if(!S)return;const L=S[S.length-1].node;for(let C=S.length-1;C>0;C--){const m=S[C-1];if(m.node.children.delete(S[C].part),m.node.children.size>0||m.node._value!==N)break}for(const C of A(L))C._value!==N&&(this.b--,yield C._value)}find($){let S=this.a;for(const L of $){const C=S.children?.get(L);if(!C)return;S=C}return S._value===N?void 0:S._value}hasKeyOrParent($){let S=this.a;for(const L of $){const C=S.children?.get(L);if(!C)return!1;if(C._value!==N)return!0;S=C}return!1}hasKeyOrChildren($){let S=this.a;for(const L of $){const C=S.children?.get(L);if(!C)return!1;S=C}return!0}hasKey($){let S=this.a;for(const L of $){const C=S.children?.get(L);if(!C)return!1;S=C}return S._value!==N}c($){const S=[{part:"",node:this.a}];let L=0;for(const C of $){const m=S[L].node.children?.get(C);if(!m)return;S.push({part:C,node:m}),L++}return S}d($,S,L){let C=this.a;for(const v of $){if(C.children)if(C.children.has(v))C=C.children.get(v);else{const l=new R;C.children.set(v,l),C=l}else{const l=new R;C.children=new Map([[v,l]]),C=l}L?.(C)}const m=C._value===N?0:1;S(C);const y=C._value===N?0:1;this.b+=y-m}*values(){for(const{_value:$}of A(this.a))$!==N&&(yield $)}}e.$7O=M;function*A(w){const $=[w];for(;$.length>0;){const S=$.pop();if(yield S,S.children)for(const L of S.children.values())$.push(L)}}class R{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value($){this._value=$===void 0?N:$}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var N in u)(typeof exports=="object"?exports:le)[N]=u[N]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function u(N){if(e[N])return e[N].exports;var M=e[N]={i:N,l:!1,exports:{}};return le[N].call(M.exports,M,M.exports,u),M.l=!0,M.exports}return u.m=le,u.c=e,u.d=function(N,M,A){u.o(N,M)||Object.defineProperty(N,M,{enumerable:!0,get:A})},u.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},u.t=function(N,M){if(1&M&&(N=u(N)),8&M||4&M&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(u.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&M&&typeof N!="string")for(var R in N)u.d(A,R,function(w){return N[w]}.bind(null,R));return A},u.n=function(N){var M=N&&N.__esModule?function(){return N.default}:function(){return N};return u.d(M,"a",M),M},u.o=function(N,M){return Object.prototype.hasOwnProperty.call(N,M)},u.p="",u(u.s=0)}([function(le,e,u){(function(N){var M;e=le.exports=ve,M=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],$=e.src=[],S=0,L=S++;$[L]="0|[1-9]\\d*";var C=S++;$[C]="[0-9]+";var m=S++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=S++;$[y]="("+$[L]+")\\.("+$[L]+")\\.("+$[L]+")";var v=S++;$[v]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var l=S++;$[l]="(?:"+$[L]+"|"+$[m]+")";var g=S++;$[g]="(?:"+$[C]+"|"+$[m]+")";var c=S++;$[c]="(?:-("+$[l]+"(?:\\."+$[l]+")*))";var n=S++;$[n]="(?:-?("+$[g]+"(?:\\."+$[g]+")*))";var i=S++;$[i]="[0-9A-Za-z-]+";var s=S++;$[s]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var r=S++,t="v?"+$[y]+$[c]+"?"+$[s]+"?";$[r]="^"+t+"$";var d="[v=\\s]*"+$[v]+$[n]+"?"+$[s]+"?",a=S++;$[a]="^"+d+"$";var h=S++;$[h]="((?:<|>)?=?)";var o=S++;$[o]=$[C]+"|x|X|\\*";var p=S++;$[p]=$[L]+"|x|X|\\*";var f=S++;$[f]="[v=\\s]*("+$[p]+")(?:\\.("+$[p]+")(?:\\.("+$[p]+")(?:"+$[c]+")?"+$[s]+"?)?)?";var D=S++;$[D]="[v=\\s]*("+$[o]+")(?:\\.("+$[o]+")(?:\\.("+$[o]+")(?:"+$[n]+")?"+$[s]+"?)?)?";var b=S++;$[b]="^"+$[h]+"\\s*"+$[f]+"$";var k=S++;$[k]="^"+$[h]+"\\s*"+$[D]+"$";var E=S++;$[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=S++;$[P]="(?:~>?)";var I=S++;$[I]="(\\s*)"+$[P]+"\\s+",w[I]=new RegExp($[I],"g");var F=S++;$[F]="^"+$[P]+$[f]+"$";var j=S++;$[j]="^"+$[P]+$[D]+"$";var z=S++;$[z]="(?:\\^)";var O=S++;$[O]="(\\s*)"+$[z]+"\\s+",w[O]=new RegExp($[O],"g");var T=S++;$[T]="^"+$[z]+$[f]+"$";var B=S++;$[B]="^"+$[z]+$[D]+"$";var W=S++;$[W]="^"+$[h]+"\\s*("+d+")$|^$";var X=S++;$[X]="^"+$[h]+"\\s*("+t+")$|^$";var Z=S++;$[Z]="(\\s*)"+$[h]+"\\s*("+d+"|"+$[f]+")",w[Z]=new RegExp($[Z],"g");var Y=S++;$[Y]="^\\s*("+$[f]+")\\s+-\\s+("+$[f]+")\\s*$";var x=S++;$[x]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var ne=S++;$[ne]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)M(ge,$[ge]),w[ge]||(w[ge]=new RegExp($[ge]));function ue(q,Q){if(q instanceof ve)return q;if(typeof q!="string"||q.length>A||!(Q?w[a]:w[r]).test(q))return null;try{return new ve(q,Q)}catch{return null}}function ve(q,Q){if(q instanceof ve){if(q.loose===Q)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ve))return new ve(q,Q);M("SemVer",q,Q),this.loose=Q;var J=q.trim().match(Q?w[a]:w[r]);if(!J)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var pe=+he;if(pe>=0&&pe<R)return pe}return he}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=ue,e.valid=function(q,Q){var J=ue(q,Q);return J?J.version:null},e.clean=function(q,Q){var J=ue(q.trim().replace(/^[=v]+/,""),Q);return J?J.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(q){return M("SemVer.compare",this.version,this.loose,q),q instanceof ve||(q=new ve(q,this.loose)),this.compareMain(q)||this.comparePre(q)},ve.prototype.compareMain=function(q){return q instanceof ve||(q=new ve(q,this.loose)),U(this.major,q.major)||U(this.minor,q.minor)||U(this.patch,q.patch)},ve.prototype.comparePre=function(q){if(q instanceof ve||(q=new ve(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Q=0;do{var J=this.prerelease[Q],he=q.prerelease[Q];if(M("prerelease compare",Q,J,he),J===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(J===void 0)return-1;if(J!==he)return U(J,he)}while(++Q)},ve.prototype.inc=function(q,Q){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Q,J,he){typeof J=="string"&&(he=J,J=void 0);try{return new ve(q,J).inc(Q,he).version}catch{return null}},e.diff=function(q,Q){if(se(q,Q))return null;var J=ue(q),he=ue(Q);if(J.prerelease.length||he.prerelease.length){for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return"pre"+pe;return"prerelease"}for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return pe},e.compareIdentifiers=U;var te=/^[0-9]+$/;function U(q,Q){var J=te.test(q),he=te.test(Q);return J&&he&&(q=+q,Q=+Q),J&&!he?-1:he&&!J?1:q<Q?-1:q>Q?1:0}function _(q,Q,J){return new ve(q,J).compare(new ve(Q,J))}function be(q,Q,J){return _(q,Q,J)>0}function Pe(q,Q,J){return _(q,Q,J)<0}function se(q,Q,J){return _(q,Q,J)===0}function re(q,Q,J){return _(q,Q,J)!==0}function oe(q,Q,J){return _(q,Q,J)>=0}function K(q,Q,J){return _(q,Q,J)<=0}function ie(q,Q,J,he){var pe;switch(Q){case"===":typeof q=="object"&&(q=q.version),typeof J=="object"&&(J=J.version),pe=q===J;break;case"!==":typeof q=="object"&&(q=q.version),typeof J=="object"&&(J=J.version),pe=q!==J;break;case"":case"=":case"==":pe=se(q,J,he);break;case"!=":pe=re(q,J,he);break;case">":pe=be(q,J,he);break;case">=":pe=oe(q,J,he);break;case"<":pe=Pe(q,J,he);break;case"<=":pe=K(q,J,he);break;default:throw new TypeError("Invalid operator: "+Q)}return pe}function $e(q,Q){if(q instanceof $e){if(q.loose===Q)return q;q=q.value}if(!(this instanceof $e))return new $e(q,Q);M("comparator",q,Q),this.loose=Q,this.parse(q),this.semver===we?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(q,Q){return U(Q,q)},e.major=function(q,Q){return new ve(q,Q).major},e.minor=function(q,Q){return new ve(q,Q).minor},e.patch=function(q,Q){return new ve(q,Q).patch},e.compare=_,e.compareLoose=function(q,Q){return _(q,Q,!0)},e.rcompare=function(q,Q,J){return _(Q,q,J)},e.sort=function(q,Q){return q.sort(function(J,he){return e.compare(J,he,Q)})},e.rsort=function(q,Q){return q.sort(function(J,he){return e.rcompare(J,he,Q)})},e.gt=be,e.lt=Pe,e.eq=se,e.neq=re,e.gte=oe,e.lte=K,e.cmp=ie,e.Comparator=$e;var we={};function Le(q,Q){if(q instanceof Le)return q.loose===Q?q:new Le(q.raw,Q);if(q instanceof $e)return new Le(q.value,Q);if(!(this instanceof Le))return new Le(q,Q);if(this.loose=Q,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function fe(q){return!q||q.toLowerCase()==="x"||q==="*"}function De(q,Q,J,he,pe,ze,qe,Ye,it,ot,nt,st,Ce){return((Q=fe(J)?"":fe(he)?">="+J+".0.0":fe(pe)?">="+J+"."+he+".0":">="+Q)+" "+(Ye=fe(it)?"":fe(ot)?"<"+(+it+1)+".0.0":fe(nt)?"<"+it+"."+(+ot+1)+".0":st?"<="+it+"."+ot+"."+nt+"-"+st:"<="+Ye)).trim()}function Ie(q,Q){for(var J=0;J<q.length;J++)if(!q[J].test(Q))return!1;if(Q.prerelease.length){for(J=0;J<q.length;J++)if(M(q[J].semver),q[J].semver!==we&&q[J].semver.prerelease.length>0){var he=q[J].semver;if(he.major===Q.major&&he.minor===Q.minor&&he.patch===Q.patch)return!0}return!1}return!0}function Te(q,Q,J){try{Q=new Le(Q,J)}catch{return!1}return Q.test(q)}function V(q,Q,J,he){var pe,ze,qe,Ye,it;switch(q=new ve(q,he),Q=new Le(Q,he),J){case">":pe=be,ze=K,qe=Pe,Ye=">",it=">=";break;case"<":pe=Pe,ze=oe,qe=be,Ye="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(q,Q,he))return!1;for(var ot=0;ot<Q.set.length;++ot){var nt=Q.set[ot],st=null,Ce=null;if(nt.forEach(function(Be){Be.semver===we&&(Be=new $e(">=0.0.0")),st=st||Be,Ce=Ce||Be,pe(Be.semver,st.semver,he)?st=Be:qe(Be.semver,Ce.semver,he)&&(Ce=Be)}),st.operator===Ye||st.operator===it||(!Ce.operator||Ce.operator===Ye)&&ze(q,Ce.semver)||Ce.operator===it&&qe(q,Ce.semver))return!1}return!0}$e.prototype.parse=function(q){var Q=this.loose?w[W]:w[X],J=q.match(Q);if(!J)throw new TypeError("Invalid comparator: "+q);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new ve(J[2],this.loose):this.semver=we},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(q){return M("Comparator.test",q,this.loose),this.semver===we||(typeof q=="string"&&(q=new ve(q,this.loose)),ie(q,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(q,Q){if(!(q instanceof $e))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Le(q.value,Q),Te(this.value,J,Q);if(q.operator==="")return J=new Le(this.value,Q),Te(q.semver,J,Q);var he=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),ze=this.semver.version===q.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Ye=ie(this.semver,"<",q.semver,Q)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),it=ie(this.semver,">",q.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return he||pe||ze&&qe||Ye||it},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(q){var Q=this.loose;q=q.trim(),M("range",q,Q);var J=Q?w[x]:w[Y];q=q.replace(J,De),M("hyphen replace",q),q=q.replace(w[Z],"$1$2$3"),M("comparator trim",q,w[Z]),q=(q=(q=q.replace(w[I],"$1~")).replace(w[O],"$1^")).split(/\s+/).join(" ");var he=Q?w[W]:w[X],pe=q.split(" ").map(function(ze){return function(qe,Ye){return M("comp",qe),qe=function(it,ot){return it.trim().split(/\s+/).map(function(nt){return function(st,Ce){M("caret",st,Ce);var Be=Ce?w[B]:w[T];return st.replace(Be,function(Ge,Ne,Xe,ae,ce){var Ae;return M("caret",st,Ge,Ne,Xe,ae,ce),fe(Ne)?Ae="":fe(Xe)?Ae=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":fe(ae)?Ae=Ne==="0"?">="+Ne+"."+Xe+".0 <"+Ne+"."+(+Xe+1)+".0":">="+Ne+"."+Xe+".0 <"+(+Ne+1)+".0.0":ce?(M("replaceCaret pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Ae=Ne==="0"?Xe==="0"?">="+Ne+"."+Xe+"."+ae+ce+" <"+Ne+"."+Xe+"."+(+ae+1):">="+Ne+"."+Xe+"."+ae+ce+" <"+Ne+"."+(+Xe+1)+".0":">="+Ne+"."+Xe+"."+ae+ce+" <"+(+Ne+1)+".0.0"):(M("no pr"),Ae=Ne==="0"?Xe==="0"?">="+Ne+"."+Xe+"."+ae+" <"+Ne+"."+Xe+"."+(+ae+1):">="+Ne+"."+Xe+"."+ae+" <"+Ne+"."+(+Xe+1)+".0":">="+Ne+"."+Xe+"."+ae+" <"+(+Ne+1)+".0.0"),M("caret return",Ae),Ae})}(nt,ot)}).join(" ")}(qe,Ye),M("caret",qe),qe=function(it,ot){return it.trim().split(/\s+/).map(function(nt){return function(st,Ce){var Be=Ce?w[j]:w[F];return st.replace(Be,function(Ge,Ne,Xe,ae,ce){var Ae;return M("tilde",st,Ge,Ne,Xe,ae,ce),fe(Ne)?Ae="":fe(Xe)?Ae=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":fe(ae)?Ae=">="+Ne+"."+Xe+".0 <"+Ne+"."+(+Xe+1)+".0":ce?(M("replaceTilde pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Ae=">="+Ne+"."+Xe+"."+ae+ce+" <"+Ne+"."+(+Xe+1)+".0"):Ae=">="+Ne+"."+Xe+"."+ae+" <"+Ne+"."+(+Xe+1)+".0",M("tilde return",Ae),Ae})}(nt,ot)}).join(" ")}(qe,Ye),M("tildes",qe),qe=function(it,ot){return M("replaceXRanges",it,ot),it.split(/\s+/).map(function(nt){return function(st,Ce){st=st.trim();var Be=Ce?w[k]:w[b];return st.replace(Be,function(Ge,Ne,Xe,ae,ce,Ae){M("xRange",st,Ge,Ne,Xe,ae,ce,Ae);var Ke=fe(Xe),Re=Ke||fe(ae),tt=Re||fe(ce);return Ne==="="&&tt&&(Ne=""),Ke?Ge=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&tt?(Re&&(ae=0),tt&&(ce=0),Ne===">"?(Ne=">=",Re?(Xe=+Xe+1,ae=0,ce=0):tt&&(ae=+ae+1,ce=0)):Ne==="<="&&(Ne="<",Re?Xe=+Xe+1:ae=+ae+1),Ge=Ne+Xe+"."+ae+"."+ce):Re?Ge=">="+Xe+".0.0 <"+(+Xe+1)+".0.0":tt&&(Ge=">="+Xe+"."+ae+".0 <"+Xe+"."+(+ae+1)+".0"),M("xRange return",Ge),Ge})}(nt,ot)}).join(" ")}(qe,Ye),M("xrange",qe),qe=function(it,ot){return M("replaceStars",it,ot),it.trim().replace(w[ne],"")}(qe,Ye),M("stars",qe),qe}(ze,Q)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(ze){return!!ze.match(he)})),pe=pe.map(function(ze){return new $e(ze,Q)})},Le.prototype.intersects=function(q,Q){if(!(q instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(he){return q.set.some(function(pe){return pe.every(function(ze){return he.intersects(ze,Q)})})})})},e.toComparators=function(q,Q){return new Le(q,Q).set.map(function(J){return J.map(function(he){return he.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new ve(q,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Ie(this.set[Q],q))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(q,Q,J){var he=null,pe=null;try{var ze=new Le(Q,J)}catch{return null}return q.forEach(function(qe){ze.test(qe)&&(he&&pe.compare(qe)!==-1||(pe=new ve(he=qe,J)))}),he},e.minSatisfying=function(q,Q,J){var he=null,pe=null;try{var ze=new Le(Q,J)}catch{return null}return q.forEach(function(qe){ze.test(qe)&&(he&&pe.compare(qe)!==1||(pe=new ve(he=qe,J)))}),he},e.validRange=function(q,Q){try{return new Le(q,Q).range||"*"}catch{return null}},e.ltr=function(q,Q,J){return V(q,Q,"<",J)},e.gtr=function(q,Q,J){return V(q,Q,">",J)},e.outside=V,e.prerelease=function(q,Q){var J=ue(q,Q);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(q,Q,J){return q=new Le(q,J),Q=new Le(Q,J),q.intersects(Q)},e.coerce=function(q){if(q instanceof ve)return q;if(typeof q!="string")return null;var Q=q.match(w[E]);return Q==null?null:ue((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,u(1))},function(le,e){var u,N,M=le.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function w(g){if(u===setTimeout)return setTimeout(g,0);if((u===A||!u)&&setTimeout)return u=setTimeout,setTimeout(g,0);try{return u(g,0)}catch{try{return u.call(null,g,0)}catch{return u.call(this,g,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:A}catch{u=A}try{N=typeof clearTimeout=="function"?clearTimeout:R}catch{N=R}})();var $,S=[],L=!1,C=-1;function m(){L&&$&&(L=!1,$.length?S=$.concat(S):C=-1,S.length&&y())}function y(){if(!L){var g=w(m);L=!0;for(var c=S.length;c;){for($=S,S=[];++C<c;)$&&$[C].run();C=-1,c=S.length}$=null,L=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===R||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(g)}}function v(g,c){this.fun=g,this.array=c}function l(){}M.nextTick=function(g){var c=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)c[n-1]=arguments[n];S.push(new v(g,c)),S.length!==1||L||w(y)},v.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=l,M.addListener=l,M.once=l,M.off=l,M.removeListener=l,M.removeAllListeners=l,M.emit=l,M.prependListener=l,M.prependOnceListener=l,M.listeners=function(g){return[]},M.binding=function(g){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(g){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(ke[40],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=void 0;const u=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=u&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$0d=N}),define(ke[4],Se([1,0,13,74,3,75,40]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$_d=e.Event=void 0,e.$ae=y;const w=!1,$=!1,S=!1;var L;(function(I){I.None=()=>M.$Uc.None;function F(Le){if(S){const{onDidAddListener:fe}=Le,De=l.create();let Ie=0;Le.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),De.print()),fe?.()}}}function j(Le,fe){return ne(Le,()=>{},0,void 0,!0,void 0,fe)}I.defer=j;function z(Le){return(fe,De=null,Ie)=>{let Te=!1,V;return V=Le(q=>{if(!Te)return V?V.dispose():Te=!0,fe.call(De,q)},null,Ie),Te&&V.dispose(),V}}I.once=z;function O(Le,fe,De){return Y((Ie,Te=null,V)=>Le(q=>Ie.call(Te,fe(q)),null,V),De)}I.map=O;function T(Le,fe,De){return Y((Ie,Te=null,V)=>Le(q=>{fe(q),Ie.call(Te,q)},null,V),De)}I.forEach=T;function B(Le,fe,De){return Y((Ie,Te=null,V)=>Le(q=>fe(q)&&Ie.call(Te,q),null,V),De)}I.filter=B;function W(Le){return Le}I.signal=W;function X(...Le){return(fe,De=null,Ie)=>{const Te=(0,M.$Rc)(...Le.map(V=>V(q=>fe.call(De,q))));return x(Te,Ie)}}I.any=X;function Z(Le,fe,De,Ie){let Te=De;return O(Le,V=>(Te=fe(Te,V),Te),Ie)}I.reduce=Z;function Y(Le,fe){let De;const Ie={onWillAddFirstListener(){De=Le(Te.fire,Te)},onDidRemoveLastListener(){De?.dispose()}};fe||F(Ie);const Te=new r(Ie);return fe?.add(Te),Te.event}function x(Le,fe){return fe instanceof Array?fe.push(Le):fe&&fe.add(Le),Le}function ne(Le,fe,De=100,Ie=!1,Te=!1,V,q){let Q,J,he,pe=0,ze;const qe={leakWarningThreshold:V,onWillAddFirstListener(){Q=Le(it=>{pe++,J=fe(J,it),Ie&&!he&&(Ye.fire(J),J=void 0),ze=()=>{const ot=J;J=void 0,he=void 0,(!Ie||pe>1)&&Ye.fire(ot),pe=0},typeof De=="number"?(clearTimeout(he),he=setTimeout(ze,De)):he===void 0&&(he=0,queueMicrotask(ze))})},onWillRemoveListener(){Te&&pe>0&&ze?.()},onDidRemoveLastListener(){ze=void 0,Q.dispose()}};q||F(qe);const Ye=new r(qe);return q?.add(Ye),Ye.event}I.debounce=ne;function ge(Le,fe=0,De){return I.debounce(Le,(Ie,Te)=>Ie?(Ie.push(Te),Ie):[Te],fe,void 0,!0,void 0,De)}I.accumulate=ge;function ue(Le,fe=(Ie,Te)=>Ie===Te,De){let Ie=!0,Te;return B(Le,V=>{const q=Ie||!fe(V,Te);return Ie=!1,Te=V,q},De)}I.latch=ue;function ve(Le,fe,De){return[I.filter(Le,fe,De),I.filter(Le,Ie=>!fe(Ie),De)]}I.split=ve;function te(Le,fe=!1,De=[],Ie){let Te=De.slice(),V=Le(J=>{Te?Te.push(J):Q.fire(J)});Ie&&Ie.add(V);const q=()=>{Te?.forEach(J=>Q.fire(J)),Te=null},Q=new r({onWillAddFirstListener(){V||(V=Le(J=>Q.fire(J)),Ie&&Ie.add(V))},onDidAddFirstListener(){Te&&(fe?setTimeout(q):q())},onDidRemoveLastListener(){V&&V.dispose(),V=null}});return Ie&&Ie.add(Q),Q.event}I.buffer=te;function U(Le,fe){return(Ie,Te,V)=>{const q=fe(new be);return Le(function(Q){const J=q.evaluate(Q);J!==_&&Ie.call(Te,J)},void 0,V)}}I.chain=U;const _=Symbol("HaltChainable");class be{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(De=>(fe(De),De)),this}filter(fe){return this.f.push(De=>fe(De)?De:_),this}reduce(fe,De){let Ie=De;return this.f.push(Te=>(Ie=fe(Ie,Te),Ie)),this}latch(fe=(De,Ie)=>De===Ie){let De=!0,Ie;return this.f.push(Te=>{const V=De||!fe(Te,Ie);return De=!1,Ie=Te,V?Te:_}),this}evaluate(fe){for(const De of this.f)if(fe=De(fe),fe===_)break;return fe}}function Pe(Le,fe,De=Ie=>Ie){const Ie=(...Q)=>q.fire(De(...Q)),Te=()=>Le.on(fe,Ie),V=()=>Le.removeListener(fe,Ie),q=new r({onWillAddFirstListener:Te,onDidRemoveLastListener:V});return q.event}I.fromNodeEventEmitter=Pe;function se(Le,fe,De=Ie=>Ie){const Ie=(...Q)=>q.fire(De(...Q)),Te=()=>Le.addEventListener(fe,Ie),V=()=>Le.removeEventListener(fe,Ie),q=new r({onWillAddFirstListener:Te,onDidRemoveLastListener:V});return q.event}I.fromDOMEventEmitter=se;function re(Le){return new Promise(fe=>z(Le)(fe))}I.toPromise=re;function oe(Le){const fe=new r;return Le.then(De=>{fe.fire(De)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}I.fromPromise=oe;function K(Le,fe,De){return fe(De),Le(Ie=>fe(Ie))}I.runAndSubscribe=K;class ie{constructor(fe,De){this._observable=fe,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};De||F(Ie),this.emitter=new r(Ie),De&&De.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,De){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(Le,fe){return new ie(Le,fe).emitter.event}I.fromObservable=$e;function we(Le){return(fe,De,Ie)=>{let Te=0,V=!1;const q={beginUpdate(){Te++},endUpdate(){Te--,Te===0&&(Le.reportChanges(),V&&(V=!1,fe.call(De)))},handlePossibleChange(){},handleChange(){V=!0}};Le.addObserver(q),Le.reportChanges();const Q={dispose(){Le.removeObserver(q)}};return Ie instanceof M.$Tc?Ie.add(Q):Array.isArray(Ie)&&Ie.push(Q),Q}}I.fromObservableLight=we})(L||(e.Event=L={}));class C{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${C.f++}`,C.all.add(this)}start(F){this.g=new R.$0d,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$_d=C;let m=-1;function y(I){const F=m;return m=I,{dispose(){m=F}}}class v{constructor(F,j=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=j,this.g=0}dispose(){this.f?.clear()}check(F,j){const z=this.threshold;if(z<=0||j<z)return;this.f||(this.f=new Map);const O=this.f.get(F.value)||0;if(this.f.set(F.value,O+1),this.g-=1,this.g<=0){this.g=z*.5;let T,B=0;for(const[W,X]of this.f)(!T||B<X)&&(T=W,B=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${j} listeners already. MOST frequent listener (${B}):`),console.warn(T)}return()=>{const T=this.f.get(F.value)||0;this.f.set(F.value,T-1)}}}class l{static create(){return new l(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class c{constructor(F){this.value=F,this.id=g++}}const n=2,i=(I,F)=>{if(I instanceof c)F(I);else for(let j=0;j<I.length;j++){const z=I[j];z&&F(z)}},s=w?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class r{constructor(F){this.w=0,this.f=F,this.g=m>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const F=this.t;queueMicrotask(()=>{i(F,j=>j.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,j,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),M.$Uc.None;if(this.m)return M.$Uc.None;j&&(F=F.bind(j));const O=new c(F);let T,B;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=l.create(),T=this.g.check(O.stack,this.w+1)),$&&(O.stack=B??l.create()),this.t?this.t instanceof c?(this.u??=new d,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,M.$Sc)(()=>{s?.unregister(W),T?.(),this.x(O)});if(z instanceof M.$Tc?z.add(W):Array.isArray(z)&&z.push(W),s){const X=new Error().stack.split(`
`).slice(2).join(`
`).trim();s.register(W,X,W)}return W},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const j=this.t,z=j.indexOf(F);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,j[z]=void 0;const O=this.u.current===this;if(this.w*n<=j.length){let T=0;for(let B=0;B<j.length;B++)j[B]?j[T++]=j[B]:O&&(this.u.end--,T<this.u.i&&this.u.i--);j.length=T}}y(F,j){if(!F)return;const z=this.f?.onListenerError||u.$1;if(!z){F.value(j);return}try{F.value(j)}catch(O){z(O)}}z(F){const j=F.current.t;for(;F.i<F.end;)this.y(j[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof c)this.y(this.t,F);else{const j=this.u;j.enqueue(this,F,this.t.length),this.z(j)}this.j?.stop()}hasListeners(){return this.w>0}}e.$be=r;const t=()=>new d;e.$ce=t;class d{constructor(){this.i=-1,this.end=0}enqueue(F,j,z){this.i=0,this.end=z,this.current=F,this.value=j}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends r{async fireAsync(F,j,z){if(this.t)for(this.h||(this.h=new A.$5c),i(this.t,O=>this.h.push([O.value,F]));this.h.size>0&&!j.isCancellationRequested;){const[O,T]=this.h.shift(),B=[],W={...T,token:j,waitUntil:X=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");z&&(X=z(X,O)),B.push(X)}};try{O(W)}catch(X){(0,u.$1)(X);continue}Object.freeze(B),await Promise.allSettled(B).then(X=>{for(const Z of X)Z.status==="rejected"&&(0,u.$1)(Z.reason)})}}}e.$de=a;class h extends r{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new A.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ee=h;class o extends h{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$fe=o;class p extends r{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(j=>super.fire(j)),this.h=[]}))}}e.$ge=p;class f{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const j={event:F,listener:null};this.h.push(j),this.g&&this.m(j);const z=()=>{this.g&&this.o(j);const O=this.h.indexOf(j);this.h.splice(O,1)};return(0,M.$Sc)((0,N.$db)(z))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(j=>this.f.fire(j))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$he=f;class D{constructor(F,j,z,O){this.f=new M.$Tc;const T=this.f.add(new f),B=this.f.add(new M.$4c);function W(X){B.set(X,T.add(O(X)))}for(const X of F)W(X);this.f.add(j(X=>{W(X)})),this.f.add(z(X=>{B.deleteAndDispose(X)})),this.event=T.event}dispose(){this.f.dispose()}}e.$ie=D;class b{constructor(){this.f=[]}wrapEvent(F){return(j,z,O)=>F(T=>{const B=this.f[this.f.length-1];B?B.push(()=>j.call(z,T)):j.call(z,T)},void 0,O)}bufferEvents(F){const j=[];this.f.push(j);const z=F();return this.f.pop(),j.forEach(O=>O()),z}}e.$je=b;class k{constructor(){this.f=!1,this.g=L.None,this.h=M.$Uc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ke=k;class E{static const(F){return new P(F)}constructor(F){this.g=F,this.f=new r,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$le=E;class P{constructor(F){this.value=F,this.onDidChange=L.None}}}),define(ke[22],Se([1,0,4]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.CancellationToken=void 0;const N=Object.freeze(function(w,$){const S=setTimeout(w.bind($),0);return{dispose(){clearTimeout(S)}}});var M;(function(w){function $(S){return S===w.None||S===w.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}w.isCancellationToken=$,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(M||(e.CancellationToken=M={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new u.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=M.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=M.None}}e.$me=R}),define(ke[168],Se([1,0,22]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1e=e.$Ze=e.$Xe=void 0,e.$Ye=M;class N{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new u.$me,S=this.b($.token);return this.a={promise:S,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$Xe=N;function M(w){return w}class A{constructor($,S){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=M):(this.c=S,this.d=$.getCacheKey)}get($){const S=this.d($);return this.b!==S&&(this.b=S,this.a=this.c($)),this.a}}e.$Ze=A;class R{get cachedValues(){return this.a}constructor($,S){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=M):(this.c=S,this.d=$.getCacheKey)}get($){const S=this.d($);if(this.b.has(S))return this.b.get(S);const L=this.c($);return this.a.set($,L),this.b.set(S,L),L}}e.$1e=R}),define(ke[98],Se([1,0,13,3]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=M,e.$oe=A,e.$pe=R,e.$qe=w,e.$re=S,e.$se=L,e.$te=C,e.$ue=m,e.$ve=y,e.$we=v,e.$xe=l,e.$ye=g,e.$ze=c,e.$Ae=n,e.$Be=i;function M(s){const r=s;return r?typeof r.read=="function":!1}function A(s){const r=s;return r?[r.on,r.pause,r.resume,r.destroy].every(t=>typeof t=="function"):!1}function R(s){const r=s;return r?A(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}function w(s,r){return new $(s,r)}class ${constructor(r,t){this.e=r,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(r){if(!this.a.destroyed){if(this.a.flowing)this.g(r);else if(this.b.data.push(r),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(r){this.a.destroyed||(this.a.flowing?this.h(r):this.b.error.push(r))}end(r){this.a.destroyed||(typeof r<"u"&&this.write(r),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(r){this.c.data.slice(0).forEach(t=>t(r))}h(r){this.c.error.length===0?(0,u.$1)(r):this.c.error.slice(0).forEach(t=>t(r))}i(){this.c.end.slice(0).forEach(r=>r())}on(r,t){if(!this.a.destroyed)switch(r){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(r,t){if(this.a.destroyed)return;let d;switch(r){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const a=d.indexOf(t);a>=0&&d.splice(a,1)}}j(){if(this.b.data.length>0){const r=this.e(this.b.data);this.g(r),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const r of this.b.error)this.h(r);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(s,r){const t=[];let d;for(;(d=s.read())!==null;)t.push(d);return r(t)}function L(s,r,t){const d=[];let a;for(;(a=s.read())!==null&&d.length<t;)d.push(a);return a===null&&d.length>0?r(d):{read:()=>{if(d.length>0)return d.shift();if(typeof a<"u"){const h=a;return a=void 0,h}return s.read()}}}function C(s,r){return new Promise((t,d)=>{const a=[];m(s,{onData:h=>{r&&a.push(h)},onError:h=>{r?d(h):t(void 0)},onEnd:()=>{t(r?r(a):void 0)}})})}function m(s,r,t){s.on("error",d=>{t?.isCancellationRequested||r.onError(d)}),s.on("end",()=>{t?.isCancellationRequested||r.onEnd()}),s.on("data",d=>{t?.isCancellationRequested||r.onData(d)})}function y(s,r){return new Promise((t,d)=>{const a=new N.$Tc,h=[],o=D=>{if(h.push(D),h.length>r)return a.dispose(),s.pause(),t({stream:s,buffer:h,ended:!1})},p=D=>(a.dispose(),d(D)),f=()=>(a.dispose(),t({stream:s,buffer:h,ended:!0}));a.add((0,N.$Sc)(()=>s.removeListener("error",p))),s.on("error",p),a.add((0,N.$Sc)(()=>s.removeListener("end",f))),s.on("end",f),a.add((0,N.$Sc)(()=>s.removeListener("data",o))),s.on("data",o)})}function v(s,r){const t=w(r);return t.end(s),t}function l(){const s=w(()=>{throw new Error("not supported")});return s.end(),s}function g(s){let r=!1;return{read:()=>r?null:(r=!0,s)}}function c(s,r,t){const d=w(t);return m(s,{onData:a=>d.write(r.data(a)),onError:a=>d.error(r.error?r.error(a):a),onEnd:()=>d.end()}),d}function n(s,r,t){let d=!1;return{read:()=>{const a=r.read();return d?a:(d=!0,a!==null?t([s,a]):s)}}}function i(s,r,t){let d=!1;const a=w(t);return m(r,{onData:h=>d?a.write(h):(d=!0,a.write(t([s,h]))),onError:h=>a.error(h),onEnd:()=>{d||(d=!0,a.write(s)),a.end()}}),a}}),define(ke[21],Se([1,0,46,98]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=S,e.$Ee=L,e.$Fe=C,e.$Ge=m,e.$He=y,e.$Ie=v,e.$Je=l,e.$Ke=g,e.$Le=c,e.$Me=n,e.$Ne=i,e.$Oe=s,e.$Pe=r,e.$Qe=t,e.$Re=d,e.$Se=a,e.$Te=h,e.$Ue=o,e.$Ve=p,e.$We=b;const M=typeof Buffer<"u",A=new u.$V(()=>new Uint8Array(256));let R,w;class ${static alloc(E){return M?new $(Buffer.allocUnsafe(E)):new $(new Uint8Array(E))}static wrap(E){return M&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new $(E)}static fromString(E,P){return!(P?.dontUseNodeBuffer||!1)&&M?new $(Buffer.from(E)):(R||(R=new TextEncoder),new $(R.encode(E)))}static fromByteArray(E){const P=$.alloc(E.length);for(let I=0,F=E.length;I<F;I++)P.buffer[I]=E[I];return P}static concat(E,P){if(typeof P>"u"){P=0;for(let j=0,z=E.length;j<z;j++)P+=E[j].byteLength}const I=$.alloc(P);let F=0;for(let j=0,z=E.length;j<z;j++){const O=E[j];I.set(O,F),F+=O.byteLength}return I}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=$.alloc(this.byteLength);return E.set(this),E}toString(){return M?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(E,P){return new $(this.buffer.subarray(E,P))}set(E,P){if(E instanceof $)this.buffer.set(E.buffer,P);else if(E instanceof Uint8Array)this.buffer.set(E,P);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),P);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,P){y(this.buffer,E,P)}readUInt32LE(E){return v(this.buffer,E)}writeUInt32LE(E,P){l(this.buffer,E,P)}readUInt8(E){return g(this.buffer,E)}writeUInt8(E,P){c(this.buffer,E,P)}indexOf(E,P=0){return S(this.buffer,E instanceof $?E.buffer:E,P)}}e.$Ce=$;function S(k,E,P=0){const I=E.byteLength,F=k.byteLength;if(I===0)return 0;if(I===1)return k.indexOf(E[0]);if(I>F-P)return-1;const j=A.value;j.fill(E.length);for(let B=0;B<E.length;B++)j[E[B]]=E.length-B-1;let z=P+E.length-1,O=z,T=-1;for(;z<F;)if(k[z]===E[O]){if(O===0){T=z;break}z--,O--}else z+=Math.max(E.length-O,j[k[z]]),O=E.length-1;return T}function L(k,E){return k[E+0]<<0>>>0|k[E+1]<<8>>>0}function C(k,E,P){k[P+0]=E&255,E=E>>>8,k[P+1]=E&255}function m(k,E){return k[E]*2**24+k[E+1]*2**16+k[E+2]*2**8+k[E+3]}function y(k,E,P){k[P+3]=E,E=E>>>8,k[P+2]=E,E=E>>>8,k[P+1]=E,E=E>>>8,k[P]=E}function v(k,E){return k[E+0]<<0>>>0|k[E+1]<<8>>>0|k[E+2]<<16>>>0|k[E+3]<<24>>>0}function l(k,E,P){k[P+0]=E&255,E=E>>>8,k[P+1]=E&255,E=E>>>8,k[P+2]=E&255,E=E>>>8,k[P+3]=E&255}function g(k,E){return k[E]}function c(k,E,P){k[P]=E}function n(k){return N.$re(k,E=>$.concat(E))}function i(k){return N.$ye(k)}function s(k){return N.$te(k,E=>$.concat(E))}async function r(k){return k.ended?$.concat(k.buffer):$.concat([...k.buffer,await s(k.stream)])}function t(k){return N.$we(k,E=>$.concat(E))}function d(k){return N.$ze(k,{data:E=>typeof E=="string"?$.fromString(E):$.wrap(E)},E=>$.concat(E))}function a(k){return N.$qe(E=>$.concat(E),k)}function h(k,E){return N.$Ae(k,E,P=>$.concat(P))}function o(k,E){return N.$Be(k,E,P=>$.concat(P))}function p(k){let E=0,P=0,I=0;const F=new Uint8Array(Math.floor(k.length/4*3)),j=O=>{switch(P){case 3:F[I++]=E|O,P=0;break;case 2:F[I++]=E|O>>>2,E=O<<6,P=3;break;case 1:F[I++]=E|O>>>4,E=O<<4,P=2;break;default:E=O<<2,P=1}};for(let O=0;O<k.length;O++){const T=k.charCodeAt(O);if(T>=65&&T<=90)j(T-65);else if(T>=97&&T<=122)j(T-97+26);else if(T>=48&&T<=57)j(T-48+52);else if(T===43||T===45)j(62);else if(T===47||T===95)j(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${k[O]}`)}}const z=I;for(;P>0;)j(0);return $.wrap(F).slice(0,z)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:k},E=!0,P=!1){const I=P?D:f;let F="";const j=k.byteLength%3;let z=0;for(;z<k.byteLength-j;z+=3){const O=k[z+0],T=k[z+1],B=k[z+2];F+=I[O>>>2],F+=I[(O<<4|T>>>4)&63],F+=I[(T<<2|B>>>6)&63],F+=I[B&63]}if(j===1){const O=k[z+0];F+=I[O>>>2],F+=I[O<<4&63],E&&(F+="==")}else if(j===2){const O=k[z+0],T=k[z+1];F+=I[O>>>2],F+=I[(O<<4|T>>>4)&63],F+=I[T<<2&63],E&&(F+="=")}return F}}),define(ke[14],Se([1,0,168,46]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.GraphemeBreakType=e.$Rf=e.$Kf=e.$Df=e.$Cf=void 0,e.$4e=M,e.$5e=R,e.$6e=$,e.$7e=S,e.$8e=L,e.$9e=C,e.$0e=m,e.$$e=y,e.$_e=v,e.$af=l,e.$bf=g,e.$cf=c,e.$df=n,e.$ef=i,e.$ff=s,e.$gf=r,e.$hf=t,e.$if=d,e.$jf=a,e.$kf=h,e.$lf=o,e.$mf=p,e.$nf=f,e.$of=D,e.$pf=b,e.$qf=k,e.$rf=E,e.$sf=P,e.$tf=I,e.$uf=F,e.$vf=j,e.$wf=z,e.$xf=O,e.$yf=T,e.$zf=B,e.$Af=W,e.$Bf=X,e.$Ef=ne,e.$Ff=ge,e.$Gf=ue,e.$Hf=ve,e.$If=_,e.$Jf=Pe,e.$Lf=se,e.$Mf=re,e.$Nf=oe,e.$Of=K,e.$Pf=$e,e.$Qf=we,e.$Sf=Le,e.$Tf=fe,e.$Uf=De,e.$Vf=Ie,e.$Wf=Te,e.$Xf=V,e.$Yf=q,e.$Zf=Q,e.$1f=qe;function M(Ce){return!Ce||typeof Ce!="string"?!0:Ce.trim().length===0}const A=/{(\d+)}/g;function R(Ce,...Be){return Be.length===0?Ce:Ce.replace(A,function(Ge,Ne){const Xe=parseInt(Ne,10);return isNaN(Xe)||Xe<0||Xe>=Be.length?Ge:Be[Xe]})}const w=/{([^}]+)}/g;function $(Ce,Be){return Object.keys(Be).length===0?Ce:Ce.replace(w,(Ge,Ne)=>Be[Ne]??Ge)}function S(Ce){return Ce.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function L(Ce){return Ce.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function C(Ce){return Ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function m(Ce,Be){let Ge=0;const Ne=Be.charCodeAt(0);for(let Xe=Ce.length-1;Xe>=0;Xe--)Ce.charCodeAt(Xe)===Ne&&Ge++;return Ge}function y(Ce,Be,Ge="\u2026"){return Ce.length<=Be?Ce:`${Ce.substr(0,Be)}${Ge}`}function v(Ce,Be,Ge="\u2026"){if(Ce.length<=Be)return Ce;const Ne=Math.ceil(Be/2)-Ge.length/2,Xe=Math.floor(Be/2)-Ge.length/2;return`${Ce.substr(0,Ne)}${Ge}${Ce.substr(Ce.length-Xe)}`}function l(Ce,Be=" "){const Ge=g(Ce,Be);return c(Ge,Be)}function g(Ce,Be){if(!Ce||!Be)return Ce;const Ge=Be.length;if(Ge===0||Ce.length===0)return Ce;let Ne=0;for(;Ce.indexOf(Be,Ne)===Ne;)Ne=Ne+Ge;return Ce.substring(Ne)}function c(Ce,Be){if(!Ce||!Be)return Ce;const Ge=Be.length,Ne=Ce.length;if(Ge===0||Ne===0)return Ce;let Xe=Ne,ae=-1;for(;ae=Ce.lastIndexOf(Be,Xe-1),!(ae===-1||ae+Ge!==Xe);){if(ae===0)return"";Xe=ae}return Ce.substring(0,Xe)}function n(Ce){return Ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Ce){return Ce.replace(/\*/g,"")}function s(Ce,Be,Ge={}){if(!Ce)throw new Error("Cannot create regex from empty string");Be||(Ce=C(Ce)),Ge.wholeWord&&(/\B/.test(Ce.charAt(0))||(Ce="\\b"+Ce),/\B/.test(Ce.charAt(Ce.length-1))||(Ce=Ce+"\\b"));let Ne="";return Ge.global&&(Ne+="g"),Ge.matchCase||(Ne+="i"),Ge.multiline&&(Ne+="m"),Ge.unicode&&(Ne+="u"),new RegExp(Ce,Ne)}function r(Ce){return Ce.source==="^"||Ce.source==="^$"||Ce.source==="$"||Ce.source==="^\\s*$"?!1:!!(Ce.exec("")&&Ce.lastIndex===0)}function t(Ce){return Ce.split(/\r\n|\r|\n/)}function d(Ce){const Be=[],Ge=Ce.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(Ge.length/2);Ne++)Be.push(Ge[2*Ne]+(Ge[2*Ne+1]??""));return Be}function a(Ce){for(let Be=0,Ge=Ce.length;Be<Ge;Be++){const Ne=Ce.charCodeAt(Be);if(Ne!==32&&Ne!==9)return Be}return-1}function h(Ce,Be=0,Ge=Ce.length){for(let Ne=Be;Ne<Ge;Ne++){const Xe=Ce.charCodeAt(Ne);if(Xe!==32&&Xe!==9)return Ce.substring(Be,Ne)}return Ce.substring(Be,Ge)}function o(Ce,Be=Ce.length-1){for(let Ge=Be;Ge>=0;Ge--){const Ne=Ce.charCodeAt(Ge);if(Ne!==32&&Ne!==9)return Ge}return-1}function p(Ce,Be,Ge){const Ne=[];let Xe=0;for(const ae of Ce.matchAll(Be)){if(Ne.push(Ce.slice(Xe,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");Xe=ae.index+ae[0].length,Ne.push(Ge(ae[0],...ae.slice(1),ae.index,Ce,ae.groups))}return Ne.push(Ce.slice(Xe)),Promise.all(Ne).then(ae=>ae.join(""))}function f(Ce,Be){return Ce<Be?-1:Ce>Be?1:0}function D(Ce,Be,Ge=0,Ne=Ce.length,Xe=0,ae=Be.length){for(;Ge<Ne&&Xe<ae;Ge++,Xe++){const Ke=Ce.charCodeAt(Ge),Re=Be.charCodeAt(Xe);if(Ke<Re)return-1;if(Ke>Re)return 1}const ce=Ne-Ge,Ae=ae-Xe;return ce<Ae?-1:ce>Ae?1:0}function b(Ce,Be){return k(Ce,Be,0,Ce.length,0,Be.length)}function k(Ce,Be,Ge=0,Ne=Ce.length,Xe=0,ae=Be.length){for(;Ge<Ne&&Xe<ae;Ge++,Xe++){let Ke=Ce.charCodeAt(Ge),Re=Be.charCodeAt(Xe);if(Ke===Re)continue;if(Ke>=128||Re>=128)return D(Ce.toLowerCase(),Be.toLowerCase(),Ge,Ne,Xe,ae);P(Ke)&&(Ke-=32),P(Re)&&(Re-=32);const tt=Ke-Re;if(tt!==0)return tt}const ce=Ne-Ge,Ae=ae-Xe;return ce<Ae?-1:ce>Ae?1:0}function E(Ce){return Ce>=48&&Ce<=57}function P(Ce){return Ce>=97&&Ce<=122}function I(Ce){return Ce>=65&&Ce<=90}function F(Ce,Be){return Ce.length===Be.length&&k(Ce,Be)===0}function j(Ce,Be){const Ge=Be.length;return Be.length>Ce.length?!1:k(Ce,Be,0,Ge)===0}function z(Ce,Be){const Ge=Math.min(Ce.length,Be.length);let Ne;for(Ne=0;Ne<Ge;Ne++)if(Ce.charCodeAt(Ne)!==Be.charCodeAt(Ne))return Ne;return Ge}function O(Ce,Be){const Ge=Math.min(Ce.length,Be.length);let Ne;const Xe=Ce.length-1,ae=Be.length-1;for(Ne=0;Ne<Ge;Ne++)if(Ce.charCodeAt(Xe-Ne)!==Be.charCodeAt(ae-Ne))return Ne;return Ge}function T(Ce){return 55296<=Ce&&Ce<=56319}function B(Ce){return 56320<=Ce&&Ce<=57343}function W(Ce,Be){return(Ce-55296<<10)+(Be-56320)+65536}function X(Ce,Be,Ge){const Ne=Ce.charCodeAt(Ge);if(T(Ne)&&Ge+1<Be){const Xe=Ce.charCodeAt(Ge+1);if(B(Xe))return W(Ne,Xe)}return Ne}function Z(Ce,Be){const Ge=Ce.charCodeAt(Be-1);if(B(Ge)&&Be>1){const Ne=Ce.charCodeAt(Be-2);if(T(Ne))return W(Ne,Ge)}return Ge}class Y{get offset(){return this.e}constructor(Be,Ge=0){this.c=Be,this.d=Be.length,this.e=Ge}setOffset(Be){this.e=Be}prevCodePoint(){const Be=Z(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=X(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$Cf=Y;class x{get offset(){return this.c.offset}constructor(Be,Ge=0){this.c=new Y(Be,Ge)}nextGraphemeLength(){const Be=pe.getInstance(),Ge=this.c,Ne=Ge.offset;let Xe=Be.getGraphemeBreakType(Ge.nextCodePoint());for(;!Ge.eol();){const ae=Ge.offset,ce=Be.getGraphemeBreakType(Ge.nextCodePoint());if(J(Xe,ce)){Ge.setOffset(ae);break}Xe=ce}return Ge.offset-Ne}prevGraphemeLength(){const Be=pe.getInstance(),Ge=this.c,Ne=Ge.offset;let Xe=Be.getGraphemeBreakType(Ge.prevCodePoint());for(;Ge.offset>0;){const ae=Ge.offset,ce=Be.getGraphemeBreakType(Ge.prevCodePoint());if(J(ce,Xe)){Ge.setOffset(ae);break}Xe=ce}return Ne-Ge.offset}eol(){return this.c.eol()}}e.$Df=x;function ne(Ce,Be){return new x(Ce,Be).nextGraphemeLength()}function ge(Ce,Be){return new x(Ce,Be).prevGraphemeLength()}function ue(Ce,Be){Be>0&&B(Ce.charCodeAt(Be))&&Be--;const Ge=Be+ne(Ce,Be);return[Ge-ge(Ce,Ge),Ge]}function ve(Ce){const Be=new x(Ce);let Ge=0;for(;!Be.eol();)Ge++,Be.nextGraphemeLength();return Ge}let te;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Ce){return te||(te=U()),te.test(Ce)}const be=/^[\t\n\r\x20-\x7E]*$/;function Pe(Ce){return be.test(Ce)}e.$Kf=/[\u2028\u2029]/;function se(Ce){return e.$Kf.test(Ce)}function re(Ce){return Ce>=11904&&Ce<=55215||Ce>=63744&&Ce<=64255||Ce>=65281&&Ce<=65374}function oe(Ce){return Ce>=127462&&Ce<=127487||Ce===8986||Ce===8987||Ce===9200||Ce===9203||Ce>=9728&&Ce<=10175||Ce===11088||Ce===11093||Ce>=127744&&Ce<=128591||Ce>=128640&&Ce<=128764||Ce>=128992&&Ce<=129008||Ce>=129280&&Ce<=129535||Ce>=129648&&Ce<=129782}function K(Ce,Be,Ge=""){const Ne=Ce.trimStart();if(Ne.length<Be)return Ne;const Xe=/\b/g;let ae=0;for(;Xe.test(Ne)&&!(Ne.length-Xe.lastIndex<Be);)ae=Xe.lastIndex,Xe.lastIndex+=1;return ae===0?Ne:Ge+Ne.substring(ae).trimStart()}const ie=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(Ce){let Be=0;for(const Ge of Ce.matchAll(ie))Be!==Ge.index&&(yield{isCode:!1,str:Ce.substring(Be,Ge.index)}),yield{isCode:!0,str:Ge[0]},Be=Ge.index+Ge[0].length;Be!==Ce.length&&(yield{isCode:!1,str:Ce.substring(Be)})}function we(Ce){return Ce&&(Ce=Ce.replace(ie,"")),Ce}e.$Rf="\uFEFF";function Le(Ce){return!!(Ce&&Ce.length>0&&Ce.charCodeAt(0)===65279)}function fe(Ce){return Le(Ce)?Ce.substr(1):Ce}function De(Ce,Be){if(!Ce||!Be||Ce.length<Be.length)return!1;const Ge=Be.length,Ne=Ce.toLowerCase();let Xe=0,ae=-1;for(;Xe<Ge;){const ce=Ne.indexOf(Be[Xe],ae+1);if(ce<0)return!1;ae=ce,Xe++}return!0}function Ie(Ce,Be=!1){return Ce?(Be&&(Ce=Ce.replace(/\\./g,"")),Ce.toLowerCase()!==Ce):!1}function Te(Ce){return Ce.charAt(0).toUpperCase()+Ce.slice(1)}function V(Ce,Be=1){if(Be===0)return"";let Ge=-1;do Ge=Ce.indexOf(`
`,Ge+1),Be--;while(Be>0&&Ge>=0);return Ge===-1?Ce:(Ce[Ge-1]==="\r"&&Ge--,Ce.substr(0,Ge))}function q(Ce){return Ce=Ce%(2*26),Ce<26?String.fromCharCode(97+Ce):String.fromCharCode(65+Ce-26)}function Q(Ce){return pe.getInstance().getGraphemeBreakType(Ce)}function J(Ce,Be){return Ce===0?Be!==5&&Be!==7:Ce===2&&Be===3?!1:Ce===4||Ce===2||Ce===3||Be===4||Be===2||Be===3?!0:!(Ce===8&&(Be===8||Be===9||Be===11||Be===12)||(Ce===11||Ce===9)&&(Be===9||Be===10)||(Ce===12||Ce===10)&&Be===10||Be===5||Be===13||Be===7||Ce===1||Ce===13&&Be===14||Ce===6&&Be===6)}var he;(function(Ce){Ce[Ce.Other=0]="Other",Ce[Ce.Prepend=1]="Prepend",Ce[Ce.CR=2]="CR",Ce[Ce.LF=3]="LF",Ce[Ce.Control=4]="Control",Ce[Ce.Extend=5]="Extend",Ce[Ce.Regional_Indicator=6]="Regional_Indicator",Ce[Ce.SpacingMark=7]="SpacingMark",Ce[Ce.L=8]="L",Ce[Ce.V=9]="V",Ce[Ce.T=10]="T",Ce[Ce.LV=11]="LV",Ce[Ce.LVT=12]="LVT",Ce[Ce.ZWJ=13]="ZWJ",Ce[Ce.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class pe{static{this.c=null}static getInstance(){return pe.c||(pe.c=new pe),pe.c}constructor(){this.d=ze()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const Ge=this.d,Ne=Ge.length/3;let Xe=1;for(;Xe<=Ne;)if(Be<Ge[3*Xe])Xe=2*Xe;else if(Be>Ge[3*Xe+1])Xe=2*Xe+1;else return Ge[3*Xe+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(Ce,Be){if(Ce===0)return 0;const Ge=Ye(Ce,Be);if(Ge!==void 0)return Ge;const Ne=new Y(Be,Ce);return Ne.prevCodePoint(),Ne.offset}function Ye(Ce,Be){const Ge=new Y(Be,Ce);let Ne=Ge.prevCodePoint();for(;it(Ne)||Ne===65039||Ne===8419;){if(Ge.offset===0)return;Ne=Ge.prevCodePoint()}if(!oe(Ne))return;let Xe=Ge.offset;return Xe>0&&Ge.prevCodePoint()===8205&&(Xe=Ge.offset),Xe}function it(Ce){return 127995<=Ce&&Ce<=127999}var ot;(function(Ce){Ce[Ce.zwj=8205]="zwj",Ce[Ce.emojiVariantSelector=65039]="emojiVariantSelector",Ce[Ce.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={})),e.$2f="\xA0";class nt{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new u.$Ze({getCacheKey:JSON.stringify},Be=>{function Ge(tt){const ht=new Map;for(let wt=0;wt<tt.length;wt+=2)ht.set(tt[wt],tt[wt+1]);return ht}function Ne(tt,ht){const wt=new Map(tt);for(const[Nt,At]of ht)wt.set(Nt,At);return wt}function Xe(tt,ht){if(!tt)return ht;const wt=new Map;for(const[Nt,At]of tt)ht.has(Nt)&&wt.set(Nt,At);return wt}const ae=this.c.value;let ce=Be.filter(tt=>!tt.startsWith("_")&&tt in ae);ce.length===0&&(ce=["_default"]);let Ae;for(const tt of ce){const ht=Ge(ae[tt]);Ae=Xe(Ae,ht)}const Ke=Ge(ae._common),Re=Ne(Ke,Ae);return new nt(Re)})}static getInstance(Be){return nt.d.get(Array.from(Be))}static{this.e=new N.$V(()=>Object.keys(nt.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return nt.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$3f=nt;class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(Be){return st.e().has(Be)}static get codePoints(){return st.e()}}e.$4f=st}),define(ke[126],Se([1,0,27,166,14]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.FuzzyScore=e.$tk=e.$sk=void 0,e.or=A,e.$uk=w,e.$vk=$,e.$wk=C,e.$xk=p,e.$yk=f,e.$zk=I,e.$Ak=F,e.$Bk=j,e.$Ck=z,e.$Dk=_,e.$Fk=re,e.$Gk=ie,e.$Hk=$e;function A(...fe){return function(De,Ie){for(let Te=0,V=fe.length;Te<V;Te++){const q=fe[Te](De,Ie);if(q)return q}return null}}e.$sk=R.bind(void 0,!1),e.$tk=R.bind(void 0,!0);function R(fe,De,Ie){if(!Ie||Ie.length<De.length)return null;let Te;return fe?Te=M.$vf(Ie,De):Te=Ie.indexOf(De)===0,Te?De.length>0?[{start:0,end:De.length}]:[]:null}function w(fe,De){const Ie=De.toLowerCase().indexOf(fe.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+fe.length}]}function $(fe,De){return S(fe.toLowerCase(),De.toLowerCase(),0,0)}function S(fe,De,Ie,Te){if(Ie===fe.length)return[];if(Te===De.length)return null;if(fe[Ie]===De[Te]){let V=null;return(V=S(fe,De,Ie+1,Te+1))?s({start:Te,end:Te+1},V):null}return S(fe,De,Ie,Te+1)}function L(fe){return 97<=fe&&fe<=122}function C(fe){return 65<=fe&&fe<=90}function m(fe){return 48<=fe&&fe<=57}function y(fe){return fe===32||fe===9||fe===10||fe===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>v.add(fe.charCodeAt(0)));function l(fe){return y(fe)||v.has(fe)}function g(fe,De){return fe===De||l(fe)&&l(De)}const c=new Map;function n(fe){if(c.has(fe))return c.get(fe);let De;const Ie=(0,N.$qk)(fe);return Ie&&(De=Ie),c.set(fe,De),De}function i(fe){return L(fe)||C(fe)||m(fe)}function s(fe,De){return De.length===0?De=[fe]:fe.end===De[0].start?De[0].start=fe.start:De.unshift(fe),De}function r(fe,De){for(let Ie=De;Ie<fe.length;Ie++){const Te=fe.charCodeAt(Ie);if(C(Te)||m(Te)||Ie>0&&!i(fe.charCodeAt(Ie-1)))return Ie}return fe.length}function t(fe,De,Ie,Te){if(Ie===fe.length)return[];if(Te===De.length)return null;if(fe[Ie]!==De[Te].toLowerCase())return null;{let V=null,q=Te+1;for(V=t(fe,De,Ie+1,Te+1);!V&&(q=r(De,q))<De.length;)V=t(fe,De,Ie+1,q),q++;return V===null?null:s({start:Te,end:Te+1},V)}}function d(fe){let De=0,Ie=0,Te=0,V=0,q=0;for(let ze=0;ze<fe.length;ze++)q=fe.charCodeAt(ze),C(q)&&De++,L(q)&&Ie++,i(q)&&Te++,m(q)&&V++;const Q=De/fe.length,J=Ie/fe.length,he=Te/fe.length,pe=V/fe.length;return{upperPercent:Q,lowerPercent:J,alphaPercent:he,numericPercent:pe}}function a(fe){const{upperPercent:De,lowerPercent:Ie}=fe;return Ie===0&&De>.6}function h(fe){const{upperPercent:De,lowerPercent:Ie,alphaPercent:Te,numericPercent:V}=fe;return Ie>.2&&De<.8&&Te>.6&&V<.2}function o(fe){let De=0,Ie=0,Te=0,V=0;for(let q=0;q<fe.length;q++)Te=fe.charCodeAt(q),C(Te)&&De++,L(Te)&&Ie++,y(Te)&&V++;return(De===0||Ie===0)&&V===0?fe.length<=30:De<=5}function p(fe,De){if(!De||(De=De.trim(),De.length===0)||!o(fe))return null;De.length>60&&(De=De.substring(0,60));const Ie=d(De);if(!h(Ie)){if(!a(Ie))return null;De=De.toLowerCase()}let Te=null,V=0;for(fe=fe.toLowerCase();V<De.length&&(Te=t(fe,De,0,V))===null;)V=r(De,V+1);return Te}function f(fe,De,Ie=!1){if(!De||De.length===0)return null;let Te=null,V=0;for(fe=fe.toLowerCase(),De=De.toLowerCase();V<De.length&&(Te=D(fe,De,0,V,Ie),Te===null);)V=b(De,V+1);return Te}function D(fe,De,Ie,Te,V){let q=0;if(Ie===fe.length)return[];if(Te===De.length)return null;if(!g(fe.charCodeAt(Ie),De.charCodeAt(Te))){const he=n(fe.charCodeAt(Ie));if(!he)return null;for(let pe=0;pe<he.length;pe++)if(!g(he[pe],De.charCodeAt(Te+pe)))return null;q+=he.length-1}let Q=null,J=Te+q+1;if(Q=D(fe,De,Ie+1,J,V),!V)for(;!Q&&(J=b(De,J))<De.length;)Q=D(fe,De,Ie+1,J,V),J++;if(!Q)return null;if(fe.charCodeAt(Ie)!==De.charCodeAt(Te)){const he=n(fe.charCodeAt(Ie));if(!he)return Q;for(let pe=0;pe<he.length;pe++)if(he[pe]!==De.charCodeAt(Te+pe))return Q}return s({start:Te,end:Te+q+1},Q)}function b(fe,De){for(let Ie=De;Ie<fe.length;Ie++)if(l(fe.charCodeAt(Ie))||Ie>0&&l(fe.charCodeAt(Ie-1)))return Ie;return fe.length}const k=A(e.$tk,p,w),E=A(e.$tk,p,$),P=new u.$Ec(1e4);function I(fe,De,Ie=!1){if(typeof fe!="string"||typeof De!="string")return null;let Te=P.get(fe);Te||(Te=new RegExp(M.$df(fe),"i"),P.set(fe,Te));const V=Te.exec(De);return V?[{start:V.index,end:V.index+V[0].length}]:Ie?E(fe,De):k(fe,De)}function F(fe,De){const Ie=re(fe,fe.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ie?z(Ie):null}function j(fe,De,Ie,Te,V,q){const Q=Math.min(13,fe.length);for(;Ie<Q;Ie++){const J=re(fe,De,Ie,Te,V,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,q]}function z(fe){if(typeof fe>"u")return[];const De=[],Ie=fe[1];for(let Te=fe.length-1;Te>1;Te--){const V=fe[Te]+Ie,q=De[De.length-1];q&&q.end===V?q.end=V+1:De.push({start:V,end:V+1})}return De}const O=128;function T(){const fe=[],De=[];for(let Ie=0;Ie<=O;Ie++)De[Ie]=0;for(let Ie=0;Ie<=O;Ie++)fe.push(De.slice(0));return fe}function B(fe){const De=[];for(let Ie=0;Ie<=fe;Ie++)De[Ie]=0;return De}const W=B(2*O),X=B(2*O),Z=T(),Y=T(),x=T(),ne=!1;function ge(fe,De,Ie,Te,V){function q(J,he,pe=" "){for(;J.length<he;)J=pe+J;return J}let Q=` |   |${Te.split("").map(J=>q(J,3)).join("|")}
`;for(let J=0;J<=Ie;J++)J===0?Q+=" |":Q+=`${De[J-1]}|`,Q+=fe[J].slice(0,V+1).map(he=>q(he.toString(),3)).join("|")+`
`;return Q}function ue(fe,De,Ie,Te){fe=fe.substr(De),Ie=Ie.substr(Te),console.log(ge(Y,fe,fe.length,Ie,Ie.length)),console.log(ge(x,fe,fe.length,Ie,Ie.length)),console.log(ge(Z,fe,fe.length,Ie,Ie.length))}function ve(fe,De){if(De<0||De>=fe.length)return!1;const Ie=fe.codePointAt(De);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Nf(Ie)}}function te(fe,De){if(De<0||De>=fe.length)return!1;switch(fe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function U(fe,De,Ie){return De[fe]!==Ie[fe]}function _(fe,De,Ie,Te,V,q,Q=!1){for(;De<Ie&&V<q;)fe[De]===Te[V]&&(Q&&(W[De]=V),De+=1),V+=1;return De===Ie}var be;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(be||(be={}));var Pe;(function(fe){fe.Default=[-100,0];function De(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}fe.isDefault=De})(Pe||(e.FuzzyScore=Pe={}));class se{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Ie){this.firstMatchCanBeWeak=De,this.boostFullMatch=Ie}}e.$Ek=se;function re(fe,De,Ie,Te,V,q,Q=se.default){const J=fe.length>O?O:fe.length,he=Te.length>O?O:Te.length;if(Ie>=J||q>=he||J-Ie>he-q||!_(De,Ie,J,V,q,he,!0))return;oe(J,he,Ie,q,De,V);let pe=1,ze=1,qe=Ie,Ye=q;const it=[!1];for(pe=1,qe=Ie;qe<J;pe++,qe++){const Be=W[qe],Ge=X[qe],Ne=qe+1<J?X[qe+1]:he;for(ze=Be-q+1,Ye=Be;Ye<Ne;ze++,Ye++){let Xe=Number.MIN_SAFE_INTEGER,ae=!1;Ye<=Ge&&(Xe=K(fe,De,qe,Ie,Te,V,Ye,he,q,Z[pe-1][ze-1]===0,it));let ce=0;Xe!==Number.MAX_SAFE_INTEGER&&(ae=!0,ce=Xe+Y[pe-1][ze-1]);const Ae=Ye>Be,Ke=Ae?Y[pe][ze-1]+(Z[pe][ze-1]>0?-5:0):0,Re=Ye>Be+1&&Z[pe][ze-1]>0,tt=Re?Y[pe][ze-2]+(Z[pe][ze-2]>0?-5:0):0;if(Re&&(!Ae||tt>=Ke)&&(!ae||tt>=ce))Y[pe][ze]=tt,x[pe][ze]=3,Z[pe][ze]=0;else if(Ae&&(!ae||Ke>=ce))Y[pe][ze]=Ke,x[pe][ze]=2,Z[pe][ze]=0;else if(ae)Y[pe][ze]=ce,x[pe][ze]=1,Z[pe][ze]=Z[pe-1][ze-1]+1;else throw new Error("not possible")}}if(ne&&ue(fe,Ie,Te,q),!it[0]&&!Q.firstMatchCanBeWeak)return;pe--,ze--;const ot=[Y[pe][ze],q];let nt=0,st=0;for(;pe>=1;){let Be=ze;do{const Ge=x[pe][Be];if(Ge===3)Be=Be-2;else if(Ge===2)Be=Be-1;else break}while(Be>=1);nt>1&&De[Ie+pe-1]===V[q+ze-1]&&!U(Be+q-1,Te,V)&&nt+1>Z[pe][Be]&&(Be=ze),Be===ze?nt++:nt=1,st||(st=Be),pe--,ze=Be-1,ot.push(ze)}he===J&&Q.boostFullMatch&&(ot[0]+=2);const Ce=st-J;return ot[0]-=Ce,ot}function oe(fe,De,Ie,Te,V,q){let Q=fe-1,J=De-1;for(;Q>=Ie&&J>=Te;)V[Q]===q[J]&&(X[Q]=J,Q--),J--}function K(fe,De,Ie,Te,V,q,Q,J,he,pe,ze){if(De[Ie]!==q[Q])return Number.MIN_SAFE_INTEGER;let qe=1,Ye=!1;return Q===Ie-Te?qe=fe[Ie]===V[Q]?7:5:U(Q,V,q)&&(Q===0||!U(Q-1,V,q))?(qe=fe[Ie]===V[Q]?7:5,Ye=!0):ve(q,Q)&&(Q===0||!ve(q,Q-1))?qe=5:(ve(q,Q-1)||te(q,Q-1))&&(qe=5,Ye=!0),qe>1&&Ie===Te&&(ze[0]=!0),Ye||(Ye=U(Q,V,q)||ve(q,Q-1)||te(q,Q-1)),Ie===Te?Q>he&&(qe-=Ye?3:5):pe?qe+=Ye?2:0:qe+=Ye?0:1,Q+1===J&&(qe-=Ye?3:5),qe}function ie(fe,De,Ie,Te,V,q,Q){return we(fe,De,Ie,Te,V,q,!0,Q)}function $e(fe,De,Ie,Te,V,q,Q){return we(fe,De,Ie,Te,V,q,!1,Q)}function we(fe,De,Ie,Te,V,q,Q,J){let he=re(fe,De,Ie,Te,V,q,J);if(he&&!Q)return he;if(fe.length>=3){const pe=Math.min(7,fe.length-1);for(let ze=Ie+1;ze<pe;ze++){const qe=Le(fe,ze);if(qe){const Ye=re(qe,qe.toLowerCase(),Ie,Te,V,q,J);Ye&&(Ye[0]-=3,(!he||Ye[0]>he[0])&&(he=Ye))}}}return he}function Le(fe,De){if(De+1>=fe.length)return;const Ie=fe[De],Te=fe[De+1];if(Ie!==Te)return fe.slice(0,De)+Te+Ie+fe.slice(De+2)}}),define(ke[56],Se([1,0,14]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$jj=void 0,e.$fj=N,e.$gj=M,e.$hj=A,e.$ij=w,e.$kj=l;function N(c){return M(c,0)}function M(c,n){switch(typeof c){case"object":return c===null?A(349,n):Array.isArray(c)?$(c,n):S(c,n);case"string":return w(c,n);case"boolean":return R(c,n);case"number":return A(c,n);case"undefined":return A(937,n);default:return A(617,n)}}function A(c,n){return(n<<5)-n+c|0}function R(c,n){return A(c?433:863,n)}function w(c,n){n=A(149417,n);for(let i=0,s=c.length;i<s;i++)n=A(c.charCodeAt(i),n);return n}function $(c,n){return n=A(104579,n),c.reduce((i,s)=>M(s,i),n)}function S(c,n){return n=A(181387,n),Object.keys(c).sort().reduce((i,s)=>(i=w(s,i),M(c[s],i)),n)}class L{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=M(n,this.g),this.g}}e.$jj=L;var C;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(c,n,i=32){const s=i-n,r=~((1<<s)-1);return(c<<n|(r&c)>>>s)>>>0}function y(c,n=0,i=c.byteLength,s=0){for(let r=0;r<i;r++)c[n+r]=s}function v(c,n,i="0"){for(;c.length<n;)c=i+c;return c}function l(c,n=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((c>>>0).toString(16),n/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const s=this.p;let r=this.r,t=this.u,d,a;for(t!==0?(d=t,a=-1,t=0):(d=n.charCodeAt(0),a=0);;){let h=d;if(u.$yf(d))if(a+1<i){const o=n.charCodeAt(a+1);u.$zf(o)?(a++,h=u.$Af(d,o)):h=65533}else{t=d;break}else u.$zf(d)&&(h=65533);if(r=this.w(s,r,h),a++,a<i)d=n.charCodeAt(a);else break}this.r=r,this.u=t}w(n,i,s){return s<128?n[i++]=s:s<2048?(n[i++]=192|(s&1984)>>>6,n[i++]=128|(s&63)>>>0):s<65536?(n[i++]=224|(s&61440)>>>12,n[i++]=128|(s&4032)>>>6,n[i++]=128|(s&63)>>>0):(n[i++]=240|(s&1835008)>>>18,n[i++]=128|(s&258048)>>>12,n[i++]=128|(s&4032)>>>6,n[i++]=128|(s&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=g.g,i=this.q;for(let f=0;f<64;f+=4)n.setUint32(f,i.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)n.setUint32(f,m(n.getUint32(f-12,!1)^n.getUint32(f-32,!1)^n.getUint32(f-56,!1)^n.getUint32(f-64,!1),1),!1);let s=this.h,r=this.l,t=this.m,d=this.n,a=this.o,h,o,p;for(let f=0;f<80;f++)f<20?(h=r&t|~r&d,o=1518500249):f<40?(h=r^t^d,o=1859775393):f<60?(h=r&t|r&d|t&d,o=2400959708):(h=r^t^d,o=3395469782),p=m(s,5)+h+a+o+n.getUint32(f*4,!1)&4294967295,a=d,d=t,t=m(r,30),r=s,s=p;this.h=this.h+s&4294967295,this.l=this.l+r&4294967295,this.m=this.m+t&4294967295,this.n=this.n+d&4294967295,this.o=this.o+a&4294967295}}e.$lj=g}),define(ke[41],Se([1,0,14]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(N||(N={})),function(M){const A="error",R="warning",w="warn",$="info",S="ignore";function L(m){return m?u.$uf(A,m)?M.Error:u.$uf(R,m)||u.$uf(w,m)?M.Warning:u.$uf($,m)?M.Info:M.Ignore:M.Ignore}M.fromValue=L;function C(m){switch(m){case M.Error:return A;case M.Warning:return R;case M.Info:return $;default:return S}}M.toString=C}(N||(N={})),e.default=N}),define(ke[169],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,14]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=void 0;class M{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const v=y.charCodeAt(0),l=this.b.charCodeAt(this.c);return v-l}value(){return this.b[this.c]}}e.$ti=M;class A{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,N.$of)(y,this.b,0,y.length,this.c,this.d):(0,N.$qf)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ui=A;class R{constructor(y=!0,v=!0){this.f=y,this.g=v}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let v=y.length-1;v>=0;v--,this.c--){const l=this.b.charCodeAt(v);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,N.$of)(y,this.b,0,y.length,this.d,this.e):(0,N.$qf)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$vi=R;var w;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(w||(w={}));class ${constructor(y,v){this.f=y,this.g=v,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,N.$pf)(y,this.c.scheme);if(this.d[this.e]===2)return(0,N.$pf)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,N.$nf)(y,this.c.query);if(this.d[this.e]===5)return(0,N.$nf)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$wi=$;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(L||(L={}));class C{static forUris(y=()=>!1,v=()=>!1){return new C(new $(y,v))}static forPaths(y=!1){return new C(new R(void 0,!y))}static forStrings(){return new C(new M)}static forConfigKeys(){return new C(new A)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,v){if(v){const l=v.slice(0);(0,u.$Xb)(l);for(const g of l)this.set(g,y)}else{const l=y.slice(0);(0,u.$Xb)(l);for(const g of l)this.set(g[0],g[1])}}set(y,v){const l=this.b.reset(y);let g;this.c||(this.c=new S,this.c.segment=l.value());const c=[];for(g=this.c;;){const i=l.cmp(g.segment);if(i>0)g.left||(g.left=new S,g.left.segment=l.value()),c.push([-1,g]),g=g.left;else if(i<0)g.right||(g.right=new S,g.right.segment=l.value()),c.push([1,g]),g=g.right;else if(l.hasNext())l.next(),g.mid||(g.mid=new S,g.mid.segment=l.value()),c.push([0,g]),g=g.mid;else break}const n=g.value;g.value=v,g.key=y;for(let i=c.length-1;i>=0;i--){const s=c[i][1];s.updateHeight();const r=s.balanceFactor();if(r<-1||r>1){const t=c[i][0],d=c[i+1][0];if(t===1&&d===1)c[i][1]=s.rotateLeft();else if(t===-1&&d===-1)c[i][1]=s.rotateRight();else if(t===1&&d===-1)s.right=c[i+1][1]=c[i+1][1].rotateRight(),c[i][1]=s.rotateLeft();else if(t===-1&&d===1)s.left=c[i+1][1]=c[i+1][1].rotateLeft(),c[i][1]=s.rotateRight();else throw new Error;if(i>0)switch(c[i-1][0]){case-1:c[i-1][1].left=c[i][1];break;case 1:c[i-1][1].right=c[i][1];break;case 0:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}return n}get(y){return this.d(y)?.value}d(y){const v=this.b.reset(y);let l=this.c;for(;l;){const g=v.cmp(l.segment);if(g>0)l=l.left;else if(g<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else break}return l}has(y){const v=this.d(y);return!(v?.value===void 0&&v?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,v){const l=this.b.reset(y),g=[];let c=this.c;for(;c;){const n=l.cmp(c.segment);if(n>0)g.push([-1,c]),c=c.left;else if(n<0)g.push([1,c]),c=c.right;else if(l.hasNext())l.next(),g.push([0,c]),c=c.mid;else break}if(c){if(v?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const n=this.f(c.right);if(n.key){const{key:i,value:s,segment:r}=n;this.e(n.key,!1),c.key=i,c.value=s,c.segment=r}}else{const n=c.left??c.right;if(g.length>0){const[i,s]=g[g.length-1];switch(i){case-1:s.left=n;break;case 0:s.mid=n;break;case 1:s.right=n;break}}else this.c=n}for(let n=g.length-1;n>=0;n--){const i=g[n][1];i.updateHeight();const s=i.balanceFactor();if(s>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),g[n][1]=i.rotateLeft()):s<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),g[n][1]=i.rotateRight()),n>0)switch(g[n-1][0]){case-1:g[n-1][1].left=g[n][1];break;case 1:g[n-1][1].right=g[n][1];break;case 0:g[n-1][1].mid=g[n][1];break}else this.c=g[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const v=this.b.reset(y);let l=this.c,g;for(;l;){const c=v.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(v.hasNext())v.next(),g=l.value||g,l=l.mid;else break}return l&&l.value||g}findSuperstr(y){return this.g(y,!1)}g(y,v){const l=this.b.reset(y);let g=this.c;for(;g;){const c=l.cmp(g.segment);if(c>0)g=g.left;else if(c<0)g=g.right;else if(l.hasNext())l.next(),g=g.mid;else return g.mid?this.h(g.mid):v?g.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[v,l]of this)y(l,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const v=[];return this.j(y,v),v[Symbol.iterator]()}j(y,v){y&&(y.left&&this.j(y.left,v),y.value&&v.push([y.key,y.value]),y.mid&&this.j(y.mid,v),y.right&&this.j(y.right,v))}_isBalanced(){const y=v=>{if(!v)return!0;const l=v.balanceFactor();return l<-1||l>1?!1:y(v.left)&&y(v.right)};return y(this.c)}}e.$xi=C}),define(ke[18],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=u,e.$6f=N,e.$7f=M,e.$8f=A,e.$9f=R,e.$0f=w,e.$$f=$,e.$_f=S,e.$ag=L,e.$bg=C,e.$cg=m,e.$dg=y,e.$eg=v,e.$fg=g,e.$gg=c,e.$hg=n,e.$ig=i,e.$jg=s;function u(r){return typeof r=="string"}function N(r){return Array.isArray(r)&&r.every(t=>u(t))}function M(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}function A(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}function R(r){return typeof r=="number"&&!isNaN(r)}function w(r){return!!r&&typeof r[Symbol.iterator]=="function"}function $(r){return r===!0||r===!1}function S(r){return typeof r>"u"}function L(r){return!C(r)}function C(r){return S(r)||r===null}function m(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function y(r){if(C(r))throw new Error("Assertion Failed: argument is undefined or null");return r}function v(...r){const t=[];for(let d=0;d<r.length;d++){const a=r[d];if(C(a))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);t.push(a)}return t}const l=Object.prototype.hasOwnProperty;function g(r){if(!M(r))return!1;for(const t in r)if(l.call(r,t))return!1;return!0}function c(r){return typeof r=="function"}function n(...r){return r.length>0&&r.every(c)}function i(r,t){const d=Math.min(r.length,t.length);for(let a=0;a<d;a++)s(r[a],t[a])}function s(r,t){if(u(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(r instanceof t)return}catch{}if(!C(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Se([1,0,18]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=M,e.$Mj=A;const N=Object.create(null);function M(R,w){if((0,u.$5f)(w)){const $=N[w];if($===void 0)throw new Error(`${R} references an unknown codicon: ${w}`);w=$}return N[R]=w,{id:R}}function A(){return N}}),define(ke[170],Se([1,0,99]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=void 0,e.$Nj={add:(0,u.$Lj)("add",6e4),plus:(0,u.$Lj)("plus",6e4),gistNew:(0,u.$Lj)("gist-new",6e4),repoCreate:(0,u.$Lj)("repo-create",6e4),lightbulb:(0,u.$Lj)("lightbulb",60001),lightBulb:(0,u.$Lj)("light-bulb",60001),repo:(0,u.$Lj)("repo",60002),repoDelete:(0,u.$Lj)("repo-delete",60002),gistFork:(0,u.$Lj)("gist-fork",60003),repoForked:(0,u.$Lj)("repo-forked",60003),gitPullRequest:(0,u.$Lj)("git-pull-request",60004),gitPullRequestAbandoned:(0,u.$Lj)("git-pull-request-abandoned",60004),recordKeys:(0,u.$Lj)("record-keys",60005),keyboard:(0,u.$Lj)("keyboard",60005),tag:(0,u.$Lj)("tag",60006),gitPullRequestLabel:(0,u.$Lj)("git-pull-request-label",60006),tagAdd:(0,u.$Lj)("tag-add",60006),tagRemove:(0,u.$Lj)("tag-remove",60006),person:(0,u.$Lj)("person",60007),personFollow:(0,u.$Lj)("person-follow",60007),personOutline:(0,u.$Lj)("person-outline",60007),personFilled:(0,u.$Lj)("person-filled",60007),gitBranch:(0,u.$Lj)("git-branch",60008),gitBranchCreate:(0,u.$Lj)("git-branch-create",60008),gitBranchDelete:(0,u.$Lj)("git-branch-delete",60008),sourceControl:(0,u.$Lj)("source-control",60008),mirror:(0,u.$Lj)("mirror",60009),mirrorPublic:(0,u.$Lj)("mirror-public",60009),star:(0,u.$Lj)("star",60010),starAdd:(0,u.$Lj)("star-add",60010),starDelete:(0,u.$Lj)("star-delete",60010),starEmpty:(0,u.$Lj)("star-empty",60010),comment:(0,u.$Lj)("comment",60011),commentAdd:(0,u.$Lj)("comment-add",60011),alert:(0,u.$Lj)("alert",60012),warning:(0,u.$Lj)("warning",60012),search:(0,u.$Lj)("search",60013),searchSave:(0,u.$Lj)("search-save",60013),logOut:(0,u.$Lj)("log-out",60014),signOut:(0,u.$Lj)("sign-out",60014),logIn:(0,u.$Lj)("log-in",60015),signIn:(0,u.$Lj)("sign-in",60015),eye:(0,u.$Lj)("eye",60016),eyeUnwatch:(0,u.$Lj)("eye-unwatch",60016),eyeWatch:(0,u.$Lj)("eye-watch",60016),circleFilled:(0,u.$Lj)("circle-filled",60017),primitiveDot:(0,u.$Lj)("primitive-dot",60017),closeDirty:(0,u.$Lj)("close-dirty",60017),debugBreakpoint:(0,u.$Lj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,u.$Lj)("debug-breakpoint-disabled",60017),debugHint:(0,u.$Lj)("debug-hint",60017),terminalDecorationSuccess:(0,u.$Lj)("terminal-decoration-success",60017),primitiveSquare:(0,u.$Lj)("primitive-square",60018),edit:(0,u.$Lj)("edit",60019),pencil:(0,u.$Lj)("pencil",60019),info:(0,u.$Lj)("info",60020),issueOpened:(0,u.$Lj)("issue-opened",60020),gistPrivate:(0,u.$Lj)("gist-private",60021),gitForkPrivate:(0,u.$Lj)("git-fork-private",60021),lock:(0,u.$Lj)("lock",60021),mirrorPrivate:(0,u.$Lj)("mirror-private",60021),close:(0,u.$Lj)("close",60022),removeClose:(0,u.$Lj)("remove-close",60022),x:(0,u.$Lj)("x",60022),repoSync:(0,u.$Lj)("repo-sync",60023),sync:(0,u.$Lj)("sync",60023),clone:(0,u.$Lj)("clone",60024),desktopDownload:(0,u.$Lj)("desktop-download",60024),beaker:(0,u.$Lj)("beaker",60025),microscope:(0,u.$Lj)("microscope",60025),vm:(0,u.$Lj)("vm",60026),deviceDesktop:(0,u.$Lj)("device-desktop",60026),file:(0,u.$Lj)("file",60027),fileText:(0,u.$Lj)("file-text",60027),more:(0,u.$Lj)("more",60028),ellipsis:(0,u.$Lj)("ellipsis",60028),kebabHorizontal:(0,u.$Lj)("kebab-horizontal",60028),mailReply:(0,u.$Lj)("mail-reply",60029),reply:(0,u.$Lj)("reply",60029),organization:(0,u.$Lj)("organization",60030),organizationFilled:(0,u.$Lj)("organization-filled",60030),organizationOutline:(0,u.$Lj)("organization-outline",60030),newFile:(0,u.$Lj)("new-file",60031),fileAdd:(0,u.$Lj)("file-add",60031),newFolder:(0,u.$Lj)("new-folder",60032),fileDirectoryCreate:(0,u.$Lj)("file-directory-create",60032),trash:(0,u.$Lj)("trash",60033),trashcan:(0,u.$Lj)("trashcan",60033),history:(0,u.$Lj)("history",60034),clock:(0,u.$Lj)("clock",60034),folder:(0,u.$Lj)("folder",60035),fileDirectory:(0,u.$Lj)("file-directory",60035),symbolFolder:(0,u.$Lj)("symbol-folder",60035),logoGithub:(0,u.$Lj)("logo-github",60036),markGithub:(0,u.$Lj)("mark-github",60036),github:(0,u.$Lj)("github",60036),terminal:(0,u.$Lj)("terminal",60037),console:(0,u.$Lj)("console",60037),repl:(0,u.$Lj)("repl",60037),zap:(0,u.$Lj)("zap",60038),symbolEvent:(0,u.$Lj)("symbol-event",60038),error:(0,u.$Lj)("error",60039),stop:(0,u.$Lj)("stop",60039),variable:(0,u.$Lj)("variable",60040),symbolVariable:(0,u.$Lj)("symbol-variable",60040),array:(0,u.$Lj)("array",60042),symbolArray:(0,u.$Lj)("symbol-array",60042),symbolModule:(0,u.$Lj)("symbol-module",60043),symbolPackage:(0,u.$Lj)("symbol-package",60043),symbolNamespace:(0,u.$Lj)("symbol-namespace",60043),symbolObject:(0,u.$Lj)("symbol-object",60043),symbolMethod:(0,u.$Lj)("symbol-method",60044),symbolFunction:(0,u.$Lj)("symbol-function",60044),symbolConstructor:(0,u.$Lj)("symbol-constructor",60044),symbolBoolean:(0,u.$Lj)("symbol-boolean",60047),symbolNull:(0,u.$Lj)("symbol-null",60047),symbolNumeric:(0,u.$Lj)("symbol-numeric",60048),symbolNumber:(0,u.$Lj)("symbol-number",60048),symbolStructure:(0,u.$Lj)("symbol-structure",60049),symbolStruct:(0,u.$Lj)("symbol-struct",60049),symbolParameter:(0,u.$Lj)("symbol-parameter",60050),symbolTypeParameter:(0,u.$Lj)("symbol-type-parameter",60050),symbolKey:(0,u.$Lj)("symbol-key",60051),symbolText:(0,u.$Lj)("symbol-text",60051),symbolReference:(0,u.$Lj)("symbol-reference",60052),goToFile:(0,u.$Lj)("go-to-file",60052),symbolEnum:(0,u.$Lj)("symbol-enum",60053),symbolValue:(0,u.$Lj)("symbol-value",60053),symbolRuler:(0,u.$Lj)("symbol-ruler",60054),symbolUnit:(0,u.$Lj)("symbol-unit",60054),activateBreakpoints:(0,u.$Lj)("activate-breakpoints",60055),archive:(0,u.$Lj)("archive",60056),arrowBoth:(0,u.$Lj)("arrow-both",60057),arrowDown:(0,u.$Lj)("arrow-down",60058),arrowLeft:(0,u.$Lj)("arrow-left",60059),arrowRight:(0,u.$Lj)("arrow-right",60060),arrowSmallDown:(0,u.$Lj)("arrow-small-down",60061),arrowSmallLeft:(0,u.$Lj)("arrow-small-left",60062),arrowSmallRight:(0,u.$Lj)("arrow-small-right",60063),arrowSmallUp:(0,u.$Lj)("arrow-small-up",60064),arrowUp:(0,u.$Lj)("arrow-up",60065),bell:(0,u.$Lj)("bell",60066),bold:(0,u.$Lj)("bold",60067),book:(0,u.$Lj)("book",60068),bookmark:(0,u.$Lj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,u.$Lj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,u.$Lj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,u.$Lj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,u.$Lj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,u.$Lj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,u.$Lj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,u.$Lj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,u.$Lj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,u.$Lj)("debug-breakpoint-log-disabled",60075),briefcase:(0,u.$Lj)("briefcase",60076),broadcast:(0,u.$Lj)("broadcast",60077),browser:(0,u.$Lj)("browser",60078),bug:(0,u.$Lj)("bug",60079),calendar:(0,u.$Lj)("calendar",60080),caseSensitive:(0,u.$Lj)("case-sensitive",60081),check:(0,u.$Lj)("check",60082),checklist:(0,u.$Lj)("checklist",60083),chevronDown:(0,u.$Lj)("chevron-down",60084),chevronLeft:(0,u.$Lj)("chevron-left",60085),chevronRight:(0,u.$Lj)("chevron-right",60086),chevronUp:(0,u.$Lj)("chevron-up",60087),chromeClose:(0,u.$Lj)("chrome-close",60088),chromeMaximize:(0,u.$Lj)("chrome-maximize",60089),chromeMinimize:(0,u.$Lj)("chrome-minimize",60090),chromeRestore:(0,u.$Lj)("chrome-restore",60091),circleOutline:(0,u.$Lj)("circle-outline",60092),circle:(0,u.$Lj)("circle",60092),debugBreakpointUnverified:(0,u.$Lj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,u.$Lj)("terminal-decoration-incomplete",60092),circleSlash:(0,u.$Lj)("circle-slash",60093),circuitBoard:(0,u.$Lj)("circuit-board",60094),clearAll:(0,u.$Lj)("clear-all",60095),clippy:(0,u.$Lj)("clippy",60096),closeAll:(0,u.$Lj)("close-all",60097),cloudDownload:(0,u.$Lj)("cloud-download",60098),cloudUpload:(0,u.$Lj)("cloud-upload",60099),code:(0,u.$Lj)("code",60100),collapseAll:(0,u.$Lj)("collapse-all",60101),colorMode:(0,u.$Lj)("color-mode",60102),commentDiscussion:(0,u.$Lj)("comment-discussion",60103),creditCard:(0,u.$Lj)("credit-card",60105),dash:(0,u.$Lj)("dash",60108),dashboard:(0,u.$Lj)("dashboard",60109),database:(0,u.$Lj)("database",60110),debugContinue:(0,u.$Lj)("debug-continue",60111),debugDisconnect:(0,u.$Lj)("debug-disconnect",60112),debugPause:(0,u.$Lj)("debug-pause",60113),debugRestart:(0,u.$Lj)("debug-restart",60114),debugStart:(0,u.$Lj)("debug-start",60115),debugStepInto:(0,u.$Lj)("debug-step-into",60116),debugStepOut:(0,u.$Lj)("debug-step-out",60117),debugStepOver:(0,u.$Lj)("debug-step-over",60118),debugStop:(0,u.$Lj)("debug-stop",60119),debug:(0,u.$Lj)("debug",60120),deviceCameraVideo:(0,u.$Lj)("device-camera-video",60121),deviceCamera:(0,u.$Lj)("device-camera",60122),deviceMobile:(0,u.$Lj)("device-mobile",60123),diffAdded:(0,u.$Lj)("diff-added",60124),diffIgnored:(0,u.$Lj)("diff-ignored",60125),diffModified:(0,u.$Lj)("diff-modified",60126),diffRemoved:(0,u.$Lj)("diff-removed",60127),diffRenamed:(0,u.$Lj)("diff-renamed",60128),diff:(0,u.$Lj)("diff",60129),diffSidebyside:(0,u.$Lj)("diff-sidebyside",60129),discard:(0,u.$Lj)("discard",60130),editorLayout:(0,u.$Lj)("editor-layout",60131),emptyWindow:(0,u.$Lj)("empty-window",60132),exclude:(0,u.$Lj)("exclude",60133),extensions:(0,u.$Lj)("extensions",60134),eyeClosed:(0,u.$Lj)("eye-closed",60135),fileBinary:(0,u.$Lj)("file-binary",60136),fileCode:(0,u.$Lj)("file-code",60137),fileMedia:(0,u.$Lj)("file-media",60138),filePdf:(0,u.$Lj)("file-pdf",60139),fileSubmodule:(0,u.$Lj)("file-submodule",60140),fileSymlinkDirectory:(0,u.$Lj)("file-symlink-directory",60141),fileSymlinkFile:(0,u.$Lj)("file-symlink-file",60142),fileZip:(0,u.$Lj)("file-zip",60143),files:(0,u.$Lj)("files",60144),filter:(0,u.$Lj)("filter",60145),flame:(0,u.$Lj)("flame",60146),foldDown:(0,u.$Lj)("fold-down",60147),foldUp:(0,u.$Lj)("fold-up",60148),fold:(0,u.$Lj)("fold",60149),folderActive:(0,u.$Lj)("folder-active",60150),folderOpened:(0,u.$Lj)("folder-opened",60151),gear:(0,u.$Lj)("gear",60152),gift:(0,u.$Lj)("gift",60153),gistSecret:(0,u.$Lj)("gist-secret",60154),gist:(0,u.$Lj)("gist",60155),gitCommit:(0,u.$Lj)("git-commit",60156),gitCompare:(0,u.$Lj)("git-compare",60157),compareChanges:(0,u.$Lj)("compare-changes",60157),gitMerge:(0,u.$Lj)("git-merge",60158),githubAction:(0,u.$Lj)("github-action",60159),githubAlt:(0,u.$Lj)("github-alt",60160),globe:(0,u.$Lj)("globe",60161),grabber:(0,u.$Lj)("grabber",60162),graph:(0,u.$Lj)("graph",60163),gripper:(0,u.$Lj)("gripper",60164),heart:(0,u.$Lj)("heart",60165),home:(0,u.$Lj)("home",60166),horizontalRule:(0,u.$Lj)("horizontal-rule",60167),hubot:(0,u.$Lj)("hubot",60168),inbox:(0,u.$Lj)("inbox",60169),issueReopened:(0,u.$Lj)("issue-reopened",60171),issues:(0,u.$Lj)("issues",60172),italic:(0,u.$Lj)("italic",60173),jersey:(0,u.$Lj)("jersey",60174),json:(0,u.$Lj)("json",60175),kebabVertical:(0,u.$Lj)("kebab-vertical",60176),key:(0,u.$Lj)("key",60177),law:(0,u.$Lj)("law",60178),lightbulbAutofix:(0,u.$Lj)("lightbulb-autofix",60179),linkExternal:(0,u.$Lj)("link-external",60180),link:(0,u.$Lj)("link",60181),listOrdered:(0,u.$Lj)("list-ordered",60182),listUnordered:(0,u.$Lj)("list-unordered",60183),liveShare:(0,u.$Lj)("live-share",60184),loading:(0,u.$Lj)("loading",60185),location:(0,u.$Lj)("location",60186),mailRead:(0,u.$Lj)("mail-read",60187),mail:(0,u.$Lj)("mail",60188),markdown:(0,u.$Lj)("markdown",60189),megaphone:(0,u.$Lj)("megaphone",60190),mention:(0,u.$Lj)("mention",60191),milestone:(0,u.$Lj)("milestone",60192),gitPullRequestMilestone:(0,u.$Lj)("git-pull-request-milestone",60192),mortarBoard:(0,u.$Lj)("mortar-board",60193),move:(0,u.$Lj)("move",60194),multipleWindows:(0,u.$Lj)("multiple-windows",60195),mute:(0,u.$Lj)("mute",60196),noNewline:(0,u.$Lj)("no-newline",60197),note:(0,u.$Lj)("note",60198),octoface:(0,u.$Lj)("octoface",60199),openPreview:(0,u.$Lj)("open-preview",60200),package:(0,u.$Lj)("package",60201),paintcan:(0,u.$Lj)("paintcan",60202),pin:(0,u.$Lj)("pin",60203),play:(0,u.$Lj)("play",60204),run:(0,u.$Lj)("run",60204),plug:(0,u.$Lj)("plug",60205),preserveCase:(0,u.$Lj)("preserve-case",60206),preview:(0,u.$Lj)("preview",60207),project:(0,u.$Lj)("project",60208),pulse:(0,u.$Lj)("pulse",60209),question:(0,u.$Lj)("question",60210),quote:(0,u.$Lj)("quote",60211),radioTower:(0,u.$Lj)("radio-tower",60212),reactions:(0,u.$Lj)("reactions",60213),references:(0,u.$Lj)("references",60214),refresh:(0,u.$Lj)("refresh",60215),regex:(0,u.$Lj)("regex",60216),remoteExplorer:(0,u.$Lj)("remote-explorer",60217),remote:(0,u.$Lj)("remote",60218),remove:(0,u.$Lj)("remove",60219),replaceAll:(0,u.$Lj)("replace-all",60220),replace:(0,u.$Lj)("replace",60221),repoClone:(0,u.$Lj)("repo-clone",60222),repoForcePush:(0,u.$Lj)("repo-force-push",60223),repoPull:(0,u.$Lj)("repo-pull",60224),repoPush:(0,u.$Lj)("repo-push",60225),report:(0,u.$Lj)("report",60226),requestChanges:(0,u.$Lj)("request-changes",60227),rocket:(0,u.$Lj)("rocket",60228),rootFolderOpened:(0,u.$Lj)("root-folder-opened",60229),rootFolder:(0,u.$Lj)("root-folder",60230),rss:(0,u.$Lj)("rss",60231),ruby:(0,u.$Lj)("ruby",60232),saveAll:(0,u.$Lj)("save-all",60233),saveAs:(0,u.$Lj)("save-as",60234),save:(0,u.$Lj)("save",60235),screenFull:(0,u.$Lj)("screen-full",60236),screenNormal:(0,u.$Lj)("screen-normal",60237),searchStop:(0,u.$Lj)("search-stop",60238),server:(0,u.$Lj)("server",60240),settingsGear:(0,u.$Lj)("settings-gear",60241),settings:(0,u.$Lj)("settings",60242),shield:(0,u.$Lj)("shield",60243),smiley:(0,u.$Lj)("smiley",60244),sortPrecedence:(0,u.$Lj)("sort-precedence",60245),splitHorizontal:(0,u.$Lj)("split-horizontal",60246),splitVertical:(0,u.$Lj)("split-vertical",60247),squirrel:(0,u.$Lj)("squirrel",60248),starFull:(0,u.$Lj)("star-full",60249),starHalf:(0,u.$Lj)("star-half",60250),symbolClass:(0,u.$Lj)("symbol-class",60251),symbolColor:(0,u.$Lj)("symbol-color",60252),symbolConstant:(0,u.$Lj)("symbol-constant",60253),symbolEnumMember:(0,u.$Lj)("symbol-enum-member",60254),symbolField:(0,u.$Lj)("symbol-field",60255),symbolFile:(0,u.$Lj)("symbol-file",60256),symbolInterface:(0,u.$Lj)("symbol-interface",60257),symbolKeyword:(0,u.$Lj)("symbol-keyword",60258),symbolMisc:(0,u.$Lj)("symbol-misc",60259),symbolOperator:(0,u.$Lj)("symbol-operator",60260),symbolProperty:(0,u.$Lj)("symbol-property",60261),wrench:(0,u.$Lj)("wrench",60261),wrenchSubaction:(0,u.$Lj)("wrench-subaction",60261),symbolSnippet:(0,u.$Lj)("symbol-snippet",60262),tasklist:(0,u.$Lj)("tasklist",60263),telescope:(0,u.$Lj)("telescope",60264),textSize:(0,u.$Lj)("text-size",60265),threeBars:(0,u.$Lj)("three-bars",60266),thumbsdown:(0,u.$Lj)("thumbsdown",60267),thumbsup:(0,u.$Lj)("thumbsup",60268),tools:(0,u.$Lj)("tools",60269),triangleDown:(0,u.$Lj)("triangle-down",60270),triangleLeft:(0,u.$Lj)("triangle-left",60271),triangleRight:(0,u.$Lj)("triangle-right",60272),triangleUp:(0,u.$Lj)("triangle-up",60273),twitter:(0,u.$Lj)("twitter",60274),unfold:(0,u.$Lj)("unfold",60275),unlock:(0,u.$Lj)("unlock",60276),unmute:(0,u.$Lj)("unmute",60277),unverified:(0,u.$Lj)("unverified",60278),verified:(0,u.$Lj)("verified",60279),versions:(0,u.$Lj)("versions",60280),vmActive:(0,u.$Lj)("vm-active",60281),vmOutline:(0,u.$Lj)("vm-outline",60282),vmRunning:(0,u.$Lj)("vm-running",60283),watch:(0,u.$Lj)("watch",60284),whitespace:(0,u.$Lj)("whitespace",60285),wholeWord:(0,u.$Lj)("whole-word",60286),window:(0,u.$Lj)("window",60287),wordWrap:(0,u.$Lj)("word-wrap",60288),zoomIn:(0,u.$Lj)("zoom-in",60289),zoomOut:(0,u.$Lj)("zoom-out",60290),listFilter:(0,u.$Lj)("list-filter",60291),listFlat:(0,u.$Lj)("list-flat",60292),listSelection:(0,u.$Lj)("list-selection",60293),selection:(0,u.$Lj)("selection",60293),listTree:(0,u.$Lj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,u.$Lj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,u.$Lj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,u.$Lj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,u.$Lj)("debug-stackframe-active",60297),circleSmallFilled:(0,u.$Lj)("circle-small-filled",60298),debugStackframeDot:(0,u.$Lj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,u.$Lj)("terminal-decoration-mark",60298),debugStackframe:(0,u.$Lj)("debug-stackframe",60299),debugStackframeFocused:(0,u.$Lj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,u.$Lj)("debug-breakpoint-unsupported",60300),symbolString:(0,u.$Lj)("symbol-string",60301),debugReverseContinue:(0,u.$Lj)("debug-reverse-continue",60302),debugStepBack:(0,u.$Lj)("debug-step-back",60303),debugRestartFrame:(0,u.$Lj)("debug-restart-frame",60304),debugAlt:(0,u.$Lj)("debug-alt",60305),callIncoming:(0,u.$Lj)("call-incoming",60306),callOutgoing:(0,u.$Lj)("call-outgoing",60307),menu:(0,u.$Lj)("menu",60308),expandAll:(0,u.$Lj)("expand-all",60309),feedback:(0,u.$Lj)("feedback",60310),gitPullRequestReviewer:(0,u.$Lj)("git-pull-request-reviewer",60310),groupByRefType:(0,u.$Lj)("group-by-ref-type",60311),ungroupByRefType:(0,u.$Lj)("ungroup-by-ref-type",60312),account:(0,u.$Lj)("account",60313),gitPullRequestAssignee:(0,u.$Lj)("git-pull-request-assignee",60313),bellDot:(0,u.$Lj)("bell-dot",60314),debugConsole:(0,u.$Lj)("debug-console",60315),library:(0,u.$Lj)("library",60316),output:(0,u.$Lj)("output",60317),runAll:(0,u.$Lj)("run-all",60318),syncIgnored:(0,u.$Lj)("sync-ignored",60319),pinned:(0,u.$Lj)("pinned",60320),githubInverted:(0,u.$Lj)("github-inverted",60321),serverProcess:(0,u.$Lj)("server-process",60322),serverEnvironment:(0,u.$Lj)("server-environment",60323),pass:(0,u.$Lj)("pass",60324),issueClosed:(0,u.$Lj)("issue-closed",60324),stopCircle:(0,u.$Lj)("stop-circle",60325),playCircle:(0,u.$Lj)("play-circle",60326),record:(0,u.$Lj)("record",60327),debugAltSmall:(0,u.$Lj)("debug-alt-small",60328),vmConnect:(0,u.$Lj)("vm-connect",60329),cloud:(0,u.$Lj)("cloud",60330),merge:(0,u.$Lj)("merge",60331),export:(0,u.$Lj)("export",60332),graphLeft:(0,u.$Lj)("graph-left",60333),magnet:(0,u.$Lj)("magnet",60334),notebook:(0,u.$Lj)("notebook",60335),redo:(0,u.$Lj)("redo",60336),checkAll:(0,u.$Lj)("check-all",60337),pinnedDirty:(0,u.$Lj)("pinned-dirty",60338),passFilled:(0,u.$Lj)("pass-filled",60339),circleLargeFilled:(0,u.$Lj)("circle-large-filled",60340),circleLarge:(0,u.$Lj)("circle-large",60341),circleLargeOutline:(0,u.$Lj)("circle-large-outline",60341),combine:(0,u.$Lj)("combine",60342),gather:(0,u.$Lj)("gather",60342),table:(0,u.$Lj)("table",60343),variableGroup:(0,u.$Lj)("variable-group",60344),typeHierarchy:(0,u.$Lj)("type-hierarchy",60345),typeHierarchySub:(0,u.$Lj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,u.$Lj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,u.$Lj)("git-pull-request-create",60348),runAbove:(0,u.$Lj)("run-above",60349),runBelow:(0,u.$Lj)("run-below",60350),notebookTemplate:(0,u.$Lj)("notebook-template",60351),debugRerun:(0,u.$Lj)("debug-rerun",60352),workspaceTrusted:(0,u.$Lj)("workspace-trusted",60353),workspaceUntrusted:(0,u.$Lj)("workspace-untrusted",60354),workspaceUnknown:(0,u.$Lj)("workspace-unknown",60355),terminalCmd:(0,u.$Lj)("terminal-cmd",60356),terminalDebian:(0,u.$Lj)("terminal-debian",60357),terminalLinux:(0,u.$Lj)("terminal-linux",60358),terminalPowershell:(0,u.$Lj)("terminal-powershell",60359),terminalTmux:(0,u.$Lj)("terminal-tmux",60360),terminalUbuntu:(0,u.$Lj)("terminal-ubuntu",60361),terminalBash:(0,u.$Lj)("terminal-bash",60362),arrowSwap:(0,u.$Lj)("arrow-swap",60363),copy:(0,u.$Lj)("copy",60364),personAdd:(0,u.$Lj)("person-add",60365),filterFilled:(0,u.$Lj)("filter-filled",60366),wand:(0,u.$Lj)("wand",60367),debugLineByLine:(0,u.$Lj)("debug-line-by-line",60368),inspect:(0,u.$Lj)("inspect",60369),layers:(0,u.$Lj)("layers",60370),layersDot:(0,u.$Lj)("layers-dot",60371),layersActive:(0,u.$Lj)("layers-active",60372),compass:(0,u.$Lj)("compass",60373),compassDot:(0,u.$Lj)("compass-dot",60374),compassActive:(0,u.$Lj)("compass-active",60375),azure:(0,u.$Lj)("azure",60376),issueDraft:(0,u.$Lj)("issue-draft",60377),gitPullRequestClosed:(0,u.$Lj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,u.$Lj)("git-pull-request-draft",60379),debugAll:(0,u.$Lj)("debug-all",60380),debugCoverage:(0,u.$Lj)("debug-coverage",60381),runErrors:(0,u.$Lj)("run-errors",60382),folderLibrary:(0,u.$Lj)("folder-library",60383),debugContinueSmall:(0,u.$Lj)("debug-continue-small",60384),beakerStop:(0,u.$Lj)("beaker-stop",60385),graphLine:(0,u.$Lj)("graph-line",60386),graphScatter:(0,u.$Lj)("graph-scatter",60387),pieChart:(0,u.$Lj)("pie-chart",60388),bracket:(0,u.$Lj)("bracket",60175),bracketDot:(0,u.$Lj)("bracket-dot",60389),bracketError:(0,u.$Lj)("bracket-error",60390),lockSmall:(0,u.$Lj)("lock-small",60391),azureDevops:(0,u.$Lj)("azure-devops",60392),verifiedFilled:(0,u.$Lj)("verified-filled",60393),newline:(0,u.$Lj)("newline",60394),layout:(0,u.$Lj)("layout",60395),layoutActivitybarLeft:(0,u.$Lj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,u.$Lj)("layout-activitybar-right",60397),layoutPanelLeft:(0,u.$Lj)("layout-panel-left",60398),layoutPanelCenter:(0,u.$Lj)("layout-panel-center",60399),layoutPanelJustify:(0,u.$Lj)("layout-panel-justify",60400),layoutPanelRight:(0,u.$Lj)("layout-panel-right",60401),layoutPanel:(0,u.$Lj)("layout-panel",60402),layoutSidebarLeft:(0,u.$Lj)("layout-sidebar-left",60403),layoutSidebarRight:(0,u.$Lj)("layout-sidebar-right",60404),layoutStatusbar:(0,u.$Lj)("layout-statusbar",60405),layoutMenubar:(0,u.$Lj)("layout-menubar",60406),layoutCentered:(0,u.$Lj)("layout-centered",60407),target:(0,u.$Lj)("target",60408),indent:(0,u.$Lj)("indent",60409),recordSmall:(0,u.$Lj)("record-small",60410),errorSmall:(0,u.$Lj)("error-small",60411),terminalDecorationError:(0,u.$Lj)("terminal-decoration-error",60411),arrowCircleDown:(0,u.$Lj)("arrow-circle-down",60412),arrowCircleLeft:(0,u.$Lj)("arrow-circle-left",60413),arrowCircleRight:(0,u.$Lj)("arrow-circle-right",60414),arrowCircleUp:(0,u.$Lj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,u.$Lj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,u.$Lj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,u.$Lj)("layout-sidebar-left-off",60418),blank:(0,u.$Lj)("blank",60419),heartFilled:(0,u.$Lj)("heart-filled",60420),map:(0,u.$Lj)("map",60421),mapHorizontal:(0,u.$Lj)("map-horizontal",60421),foldHorizontal:(0,u.$Lj)("fold-horizontal",60421),mapFilled:(0,u.$Lj)("map-filled",60422),mapHorizontalFilled:(0,u.$Lj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,u.$Lj)("fold-horizontal-filled",60422),circleSmall:(0,u.$Lj)("circle-small",60423),bellSlash:(0,u.$Lj)("bell-slash",60424),bellSlashDot:(0,u.$Lj)("bell-slash-dot",60425),commentUnresolved:(0,u.$Lj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,u.$Lj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,u.$Lj)("git-pull-request-new-changes",60428),searchFuzzy:(0,u.$Lj)("search-fuzzy",60429),commentDraft:(0,u.$Lj)("comment-draft",60430),send:(0,u.$Lj)("send",60431),sparkle:(0,u.$Lj)("sparkle",60432),insert:(0,u.$Lj)("insert",60433),mic:(0,u.$Lj)("mic",60434),thumbsdownFilled:(0,u.$Lj)("thumbsdown-filled",60435),thumbsupFilled:(0,u.$Lj)("thumbsup-filled",60436),coffee:(0,u.$Lj)("coffee",60437),snake:(0,u.$Lj)("snake",60438),game:(0,u.$Lj)("game",60439),vr:(0,u.$Lj)("vr",60440),chip:(0,u.$Lj)("chip",60441),piano:(0,u.$Lj)("piano",60442),music:(0,u.$Lj)("music",60443),micFilled:(0,u.$Lj)("mic-filled",60444),repoFetch:(0,u.$Lj)("repo-fetch",60445),copilot:(0,u.$Lj)("copilot",60446),lightbulbSparkle:(0,u.$Lj)("lightbulb-sparkle",60447),robot:(0,u.$Lj)("robot",60448),sparkleFilled:(0,u.$Lj)("sparkle-filled",60449),diffSingle:(0,u.$Lj)("diff-single",60450),diffMultiple:(0,u.$Lj)("diff-multiple",60451),surroundWith:(0,u.$Lj)("surround-with",60452),share:(0,u.$Lj)("share",60453),gitStash:(0,u.$Lj)("git-stash",60454),gitStashApply:(0,u.$Lj)("git-stash-apply",60455),gitStashPop:(0,u.$Lj)("git-stash-pop",60456),vscode:(0,u.$Lj)("vscode",60457),vscodeInsiders:(0,u.$Lj)("vscode-insiders",60458),codeOss:(0,u.$Lj)("code-oss",60459),runCoverage:(0,u.$Lj)("run-coverage",60460),runAllCoverage:(0,u.$Lj)("run-all-coverage",60461),coverage:(0,u.$Lj)("coverage",60462),githubProject:(0,u.$Lj)("github-project",60463),mapVertical:(0,u.$Lj)("map-vertical",60464),foldVertical:(0,u.$Lj)("fold-vertical",60464),mapVerticalFilled:(0,u.$Lj)("map-vertical-filled",60465),foldVerticalFilled:(0,u.$Lj)("fold-vertical-filled",60465),goToSearch:(0,u.$Lj)("go-to-search",60466),percentage:(0,u.$Lj)("percentage",60467),sortPercentage:(0,u.$Lj)("sort-percentage",60467)}}),define(ke[78],Se([1,0,99,170]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=void 0,e.$Oj=M;function M(){return Object.values(e.$Qj)}e.$Pj={dialogError:(0,u.$Lj)("dialog-error","error"),dialogWarning:(0,u.$Lj)("dialog-warning","warning"),dialogInfo:(0,u.$Lj)("dialog-info","info"),dialogClose:(0,u.$Lj)("dialog-close","close"),treeItemExpanded:(0,u.$Lj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,u.$Lj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,u.$Lj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,u.$Lj)("tree-filter-clear","close"),treeItemLoading:(0,u.$Lj)("tree-item-loading","loading"),menuSelection:(0,u.$Lj)("menu-selection","check"),menuSubmenu:(0,u.$Lj)("menu-submenu","chevron-right"),menuBarMore:(0,u.$Lj)("menubar-more","more"),scrollbarButtonLeft:(0,u.$Lj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,u.$Lj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,u.$Lj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,u.$Lj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,u.$Lj)("toolbar-more","more"),quickInputBack:(0,u.$Lj)("quick-input-back","arrow-left"),dropDownButton:(0,u.$Lj)("drop-down-button",60084),symbolCustomColor:(0,u.$Lj)("symbol-customcolor",60252),exportIcon:(0,u.$Lj)("export",60332),workspaceUnspecified:(0,u.$Lj)("workspace-unspecified",60355),newLine:(0,u.$Lj)("newline",60394),thumbsDownFilled:(0,u.$Lj)("thumbsdown-filled",60435),thumbsUpFilled:(0,u.$Lj)("thumbsup-filled",60436),gitFetch:(0,u.$Lj)("git-fetch",60445),lightbulbSparkleAutofix:(0,u.$Lj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,u.$Lj)("debug-breakpoint-pending",60377)},e.$Qj={...N.$Nj,...e.$Pj}}),define(ke[24],Se([1,0,18]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=N,e.$Yn=M,e.$Zn=R,e.$1n=$,e.$2n=S,e.$3n=L,e.$4n=C,e.$5n=m,e.$6n=y,e.$7n=v,e.$8n=l,e.$9n=g;function N(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const n=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([i,s])=>{n[i]=s&&typeof s=="object"?N(s):s}),n}function M(c){if(!c||typeof c!="object")return c;const n=[c];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const s in i)if(A.call(i,s)){const r=i[s];typeof r=="object"&&!Object.isFrozen(r)&&!(0,u.$8f)(r)&&n.push(r)}}return c}const A=Object.prototype.hasOwnProperty;function R(c,n){return w(c,n,new Set)}function w(c,n,i){if((0,u.$bg)(c))return c;const s=n(c);if(typeof s<"u")return s;if(Array.isArray(c)){const r=[];for(const t of c)r.push(w(t,n,i));return r}if((0,u.$7f)(c)){if(i.has(c))throw new Error("Cannot clone recursive data-structure");i.add(c);const r={};for(const t in c)A.call(c,t)&&(r[t]=w(c[t],n,i));return i.delete(c),r}return c}function $(c,n,i=!0){return(0,u.$7f)(c)?((0,u.$7f)(n)&&Object.keys(n).forEach(s=>{s in c?i&&((0,u.$7f)(c[s])&&(0,u.$7f)(n[s])?$(c[s],n[s],i):c[s]=n[s]):c[s]=n[s]}),c):n}function S(c,n){if(c===n)return!0;if(c==null||n===null||n===void 0||typeof c!=typeof n||typeof c!="object"||Array.isArray(c)!==Array.isArray(n))return!1;let i,s;if(Array.isArray(c)){if(c.length!==n.length)return!1;for(i=0;i<c.length;i++)if(!S(c[i],n[i]))return!1}else{const r=[];for(s in c)r.push(s);r.sort();const t=[];for(s in n)t.push(s);if(t.sort(),!S(r,t))return!1;for(i=0;i<r.length;i++)if(!S(c[r[i]],n[r[i]]))return!1}return!0}function L(c){const n=new Set;return JSON.stringify(c,(i,s)=>{if((0,u.$7f)(s)||Array.isArray(s)){if(n.has(s))return"[Circular]";n.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function C(c,n){const i=Object.create(null);return!c||!n||Object.keys(n).forEach(r=>{const t=c[r],d=n[r];S(t,d)||(i[r]=d)}),i}function m(c,n){const i=n.toLowerCase(),s=Object.keys(c).find(r=>r.toLowerCase()===i);return s?c[s]:c[n]}function y(c,n){const i=Object.create(null);for(const[s,r]of Object.entries(c))n(s,r)&&(i[s]=r);return i}function v(c){let n=[];for(;Object.prototype!==c;)n=n.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return n}function l(c){const n=[];for(const i of v(c))typeof c[i]=="function"&&n.push(i);return n}function g(c,n){const i=r=>function(){const t=Array.prototype.slice.call(arguments,0);return n(r,t)},s={};for(const r of c)s[r]=i(r);return s}}),define(ke[57],Se([1,0,78]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Rj=M;var N;(function(R){function w($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=w})(N||(e.ThemeColor=N={}));function M(R){return{id:R}}var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(n){const i=w.exec(n.id);if(!i)return $(u.$Qj.error);const[,s,r]=i,t=["codicon","codicon-"+s];return r&&t.push("codicon-modifier-"+r.substring(1)),t}R.asClassNameArray=$;function S(n){return $(n).join(" ")}R.asClassName=S;function L(n){return"."+$(n).join(".")}R.asCSSSelector=L;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}R.isThemeIcon=C;const m=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function y(n){const i=m.exec(n);if(!i)return;const[,s]=i;return{id:s}}R.fromString=y;function v(n){return{id:n}}R.fromId=v;function l(n,i){let s=n.id;const r=s.lastIndexOf("~");return r!==-1&&(s=s.substring(0,r)),i&&(s=`${s}~${i}`),{id:s}}R.modify=l;function g(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}R.getModifier=g;function c(n,i){return n.id===i.id&&n.color?.id===i.color?.id}R.isEqual=c})(A||(e.ThemeIcon=A={}))}),define(ke[171],Se([1,0,126,14,57]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=$,e.$Jk=L,e.$Kk=m,e.$Lk=y,e.$Mk=l,e.$Nk=g;const A="$(",R=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${R.source}`,"g");function $(c){return c.replace(w,(n,i)=>i?n:`\\${n}`)}const S=new RegExp(`\\\\${R.source}`,"g");function L(c){return c.replace(S,n=>`\\${n}`)}const C=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function m(c){return c.indexOf(A)===-1?c:c.replace(C,(n,i,s,r)=>s?n:i||r||"")}function y(c){return c?c.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(c){v.lastIndex=0;let n="";const i=[];let s=0;for(;;){const r=v.lastIndex,t=v.exec(c),d=c.substring(r,t?.index);if(d.length>0){n+=d;for(let a=0;a<d.length;a++)i.push(s)}if(!t)break;s+=t[0].length}return{text:n,iconOffsets:i}}function g(c,n,i=!1){const{text:s,iconOffsets:r}=n;if(!r||r.length===0)return(0,u.$zk)(c,s,i);const t=(0,N.$bf)(s," "),d=s.length-t.length,a=(0,u.$zk)(c,t,i);if(a)for(const h of a){const o=r[h.start+d]+d;h.start+=o,h.end+=o}return a}}),define(ke[127],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$2e=N,e.$3e=M;var u;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function N(A){return A<0?0:A>255?255:A|0}function M(A){return A<0?0:A>4294967295?4294967295:A|0}}),define(ke[30],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=void 0,e.$Mg=N;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(M){return u.test(M)}e.$Ng=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(w){for(let $=0;$<w.length;$++)w[$]=Math.floor(Math.random()*256);return w};const A=new Uint8Array(16),R=[];for(let w=0;w<256;w++)R.push(w.toString(16).padStart(2,"0"));return function(){M(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let $=0,S="";return S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S+="-",S+=R[A[$++]],S+=R[A[$++]],S+="-",S+=R[A[$++]],S+=R[A[$++]],S+="-",S+=R[A[$++]],S+=R[A[$++]],S+="-",S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S+=R[A[$++]],S}}()}),define(ke[172],Se([1,0,19,39,30]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=e.$Lt=void 0,e.$Jt=A,e.$Kt=R,e.$Mt=S;function A(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}function R(C,m,y){const v={id:(0,M.$Ng)(),name:C,uri:m,data:y};return{asString:async()=>"",asFile:()=>v,value:void 0}}class w{constructor(){this.a=new Map}get size(){let m=0;for(const y of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const y=[...this.a.keys()];return N.Iterable.some(this,([v,l])=>l.asFile())&&y.push("files"),L($(m),y)}get(m){return this.a.get(this.b(m))?.[0]}append(m,y){const v=this.a.get(m);v?v.push(y):this.a.set(this.b(m),[y])}replace(m,y){this.a.set(this.b(m),[y])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,y]of this.a)for(const v of y)yield[m,v]}b(m){return $(m)}}e.$Lt=w;function $(C){return C.toLowerCase()}function S(C,m){return L($(C),m.map($))}function L(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const y=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[v,l,g]=y;return g==="*"?m.some(c=>c.startsWith(l+"/")):!1}e.$Nt=Object.freeze({create:C=>(0,u.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$Nt.split(C).filter(m=>!m.startsWith("#"))})}),define(ke[173],Se([1,0,63]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=void 0,e.$Pg=N,e.$Rg=A;function N(w,$,S,L=1){let C=!1;return new Promise(m=>{const y=setTimeout(()=>{if(!C)return C=!0,m(0)},S);M(w,$,L,v=>{if(!C)return C=!0,clearTimeout(y),m(v)})})}function M(w,$,S,L){if($===0)return L(0);const C=new u.Socket;C.once("connect",()=>(R(C),M(w+S,$-1,S,L))),C.once("data",()=>{}),C.once("error",m=>(R(C),m.code!=="ECONNREFUSED"?M(w+S,$-1,S,L):L(w))),C.connect(w,"127.0.0.1")}e.$Qg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(w,$,S,L="127.0.0.1"){let C=!1,m,y=1;const v=u.createServer({pauseOnConnect:!0});function l(g,c){C||(C=!0,v.removeAllListeners(),v.close(),m&&clearTimeout(m),c(g))}return new Promise(g=>{m=setTimeout(()=>{l(0,g)},S),v.on("listening",()=>{l(w,g)}),v.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&y<$?(w++,y++,v.listen(w,L)):l(0,g)}),v.on("close",()=>{l(0,g)}),v.listen(w,L)})}function R(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch($){console.error($)}}}),define(ke[128],Se([1,0,127]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.$Bt=void 0;class N{constructor(w){const $=(0,u.$2e)(w);this.c=$,this.a=N.d($),this.b=new Map}static d(w){const $=new Uint8Array(256);return $.fill(w),$}set(w,$){const S=(0,u.$2e)($);w>=0&&w<256?this.a[w]=S:this.b.set(w,S)}get(w){return w>=0&&w<256?this.a[w]:this.b.get(w)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Bt=N;var M;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(M||(M={}));class A{constructor(){this.a=new N(0)}add(w){this.a.set(w,1)}has(w){return this.a.get(w)===1}clear(){return this.a.clear()}}e.$Ct=A}),define(ke[174],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Qt=N;var u;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function N(M){let A=0,R=0,w=0,$=0;for(let S=0,L=M.length;S<L;S++){const C=M.charCodeAt(S);C===13?(A===0&&(R=S),A++,S+1<L&&M.charCodeAt(S+1)===10?($|=2,S++):$|=3,w=S+1):C===10&&($|=1,A===0&&(R=S),A++,w=S+1)}return A===0&&(R=M.length),[A,R,M.length-w,$]}}),define(ke[50],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=void 0;class u{constructor(M,A){this.lineNumber=M,this.column=A}with(M=this.lineNumber,A=this.column){return M===this.lineNumber&&A===this.column?this:new u(M,A)}delta(M=0,A=0){return this.with(this.lineNumber+M,this.column+A)}equals(M){return u.equals(this,M)}static equals(M,A){return!M&&!A?!0:!!M&&!!A&&M.lineNumber===A.lineNumber&&M.column===A.column}isBefore(M){return u.isBefore(this,M)}static isBefore(M,A){return M.lineNumber<A.lineNumber?!0:A.lineNumber<M.lineNumber?!1:M.column<A.column}isBeforeOrEqual(M){return u.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,A){return M.lineNumber<A.lineNumber?!0:A.lineNumber<M.lineNumber?!1:M.column<=A.column}static compare(M,A){const R=M.lineNumber|0,w=A.lineNumber|0;if(R===w){const $=M.column|0,S=A.column|0;return $-S}return R-w}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new u(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$mt=u}),define(ke[29],Se([1,0,50]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=void 0;class N{constructor(A,R,w,$){A>w||A===w&&R>$?(this.startLineNumber=w,this.startColumn=$,this.endLineNumber=A,this.endColumn=R):(this.startLineNumber=A,this.startColumn=R,this.endLineNumber=w,this.endColumn=$)}isEmpty(){return N.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return N.containsPosition(this,A)}static containsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<A.startColumn||R.lineNumber===A.endLineNumber&&R.column>A.endColumn)}static strictContainsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<=A.startColumn||R.lineNumber===A.endLineNumber&&R.column>=A.endColumn)}containsRange(A){return N.containsRange(this,A)}static containsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>A.endColumn)}strictContainsRange(A){return N.strictContainsRange(this,A)}static strictContainsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<=A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>=A.endColumn)}plusRange(A){return N.plusRange(this,A)}static plusRange(A,R){let w,$,S,L;return R.startLineNumber<A.startLineNumber?(w=R.startLineNumber,$=R.startColumn):R.startLineNumber===A.startLineNumber?(w=R.startLineNumber,$=Math.min(R.startColumn,A.startColumn)):(w=A.startLineNumber,$=A.startColumn),R.endLineNumber>A.endLineNumber?(S=R.endLineNumber,L=R.endColumn):R.endLineNumber===A.endLineNumber?(S=R.endLineNumber,L=Math.max(R.endColumn,A.endColumn)):(S=A.endLineNumber,L=A.endColumn),new N(w,$,S,L)}intersectRanges(A){return N.intersectRanges(this,A)}static intersectRanges(A,R){let w=A.startLineNumber,$=A.startColumn,S=A.endLineNumber,L=A.endColumn;const C=R.startLineNumber,m=R.startColumn,y=R.endLineNumber,v=R.endColumn;return w<C?(w=C,$=m):w===C&&($=Math.max($,m)),S>y?(S=y,L=v):S===y&&(L=Math.min(L,v)),w>S||w===S&&$>L?null:new N(w,$,S,L)}equalsRange(A){return N.equalsRange(this,A)}static equalsRange(A,R){return!A&&!R?!0:!!A&&!!R&&A.startLineNumber===R.startLineNumber&&A.startColumn===R.startColumn&&A.endLineNumber===R.endLineNumber&&A.endColumn===R.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(A){return new u.$mt(A.endLineNumber,A.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(A){return new u.$mt(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,R){return new N(this.startLineNumber,this.startColumn,A,R)}setStartPosition(A,R){return new N(A,R,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(A){return new N(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(A){return new N(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new N(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,R=A){return new N(A.lineNumber,A.column,R.lineNumber,R.column)}static lift(A){return A?new N(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn)}static areIntersecting(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,R){if(A&&R){const S=A.startLineNumber|0,L=R.startLineNumber|0;if(S===L){const C=A.startColumn|0,m=R.startColumn|0;if(C===m){const y=A.endLineNumber|0,v=R.endLineNumber|0;if(y===v){const l=A.endColumn|0,g=R.endColumn|0;return l-g}return y-v}return C-m}return S-L}return(A?1:0)-(R?1:0)}static compareRangesUsingEnds(A,R){return A.endLineNumber===R.endLineNumber?A.endColumn===R.endColumn?A.startLineNumber===R.startLineNumber?A.startColumn-R.startColumn:A.startLineNumber-R.startLineNumber:A.endColumn-R.endColumn:A.endLineNumber-R.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$nt=N}),define(ke[175],Se([1,0,29]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=void 0;class N{static insert(A,R){return{range:new u.$nt(A.lineNumber,A.column,A.lineNumber,A.column),text:R,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,R){return{range:A,text:R}}static replaceMove(A,R){return{range:A,text:R,forceMoveMarkers:!0}}}e.$ot=N}),define(ke[176],Se([1,0,50,29]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pt=e.SelectionDirection=void 0;var M;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(M||(e.SelectionDirection=M={}));class A extends N.$nt{constructor(w,$,S,L){super(w,$,S,L),this.selectionStartLineNumber=w,this.selectionStartColumn=$,this.positionLineNumber=S,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return A.selectionsEqual(this,w)}static selectionsEqual(w,$){return w.selectionStartLineNumber===$.selectionStartLineNumber&&w.selectionStartColumn===$.selectionStartColumn&&w.positionLineNumber===$.positionLineNumber&&w.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,$){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,w,$):new A(w,$,this.startLineNumber,this.startColumn)}getPosition(){return new u.$mt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.$mt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,$){return this.getDirection()===0?new A(w,$,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,w,$)}static fromPositions(w,$=w){return new A(w.lineNumber,w.column,$.lineNumber,$.column)}static fromRange(w,$){return $===0?new A(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new A(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new A(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,$){if(w&&!$||!w&&$)return!1;if(!w&&!$)return!0;if(w.length!==$.length)return!1;for(let S=0,L=w.length;S<L;S++)if(!this.selectionsEqual(w[S],$[S]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,$,S,L,C){return C===0?new A(w,$,S,L):new A(S,L,w,$)}}e.$pt=A}),define(ke[177],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0,e.$Xs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[178],Se([1,0,27,128]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.WordCharacterClass=void 0,e.$Et=w;var M;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(M||(e.WordCharacterClass=M={}));class A extends N.$Bt{constructor(S,L){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=L,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let C=0,m=S.length;C<m;C++)this.set(S.charCodeAt(C),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(S,L){let C=null;for(const m of this.h(S)){if(m.index>L)break;C=m}return C}findNextIntlWordAtOrAfterOffset(S,L){for(const C of this.h(S))if(!(C.index<L))return C;return null}h(S){return this.e?this.f===S?this.g:(this.f=S,this.g=this.j(this.e.segment(S)),this.g):[]}j(S){const L=[];for(const C of S)this.k(C)&&L.push(C);return L}k(S){return!!S.isWordLike}}e.$Dt=A;const R=new u.$Ec(10);function w($,S){const L=`${$}/${S.join(",")}`;let C=R.get(L);return C||(C=new A($,S),R.set(L,C)),C}}),define(ke[129],Se([1,0,39,3,75]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=void 0,e.$1s=R,e.$2s=$,e.$3s=S,e.$Ys="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$Ys)C.indexOf(y)>=0||(m+="\\"+y);return m+="\\s]+)",new RegExp(m,"g")}e.$Zs=A();function R(C){let m=e.$Zs;if(C&&C instanceof RegExp)if(C.global)m=C;else{let y="g";C.ignoreCase&&(y+="i"),C.multiline&&(y+="m"),C.unicode&&(y+="u"),m=new RegExp(C.source,y)}return m.lastIndex=0,m}const w=new M.$5c;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=w.unshift(C);return(0,N.$Sc)(m)}function S(C,m,y,v,l){if(m=R(m),l||(l=u.Iterable.first(w)),y.length>l.maxLen){let s=C-l.maxLen/2;return s<0?s=0:v+=s,y=y.substring(s,C+l.maxLen/2),S(C,m,y,v,l)}const g=Date.now(),c=C-1-v;let n=-1,i=null;for(let s=1;!(Date.now()-g>=l.timeBudget);s++){const r=c-l.windowSize*s;m.lastIndex=Math.max(0,r);const t=L(m,y,c,n);if(!t&&i||(i=t,r<=0))break;n=r}if(i){const s={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return m.lastIndex=0,s}return null}function L(C,m,y,v){let l;for(;l=C.exec(m);){const g=l.index||0;if(g<=y&&C.lastIndex>=y)return l;if(v>0&&g>v)return null}return null}}),define(ke[179],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=e.$du=e.IndentAction=void 0;var u;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class N{constructor(w){if(this.e=null,this.f=!1,this.open=w.open,this.close=w.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(w.notIn))for(let $=0,S=w.notIn.length;$<S;$++)switch(w.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(w,$){if(w.getTokenCount()===0)return!0;const S=w.findTokenIndexAtOffset($-2),L=w.getStandardTokenType(S);return this.isOK(L)}g(w,$){for(let S=w;S<=$;S++){const L=String.fromCharCode(S);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$du=N;class M{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of w)A(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),A(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),A(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),A(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&A(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$eu=M;function A(R,w,$){R.has(w)?R.get(w).push($):R.set(w,[$])}}),define(ke[180],Se([1,0,128]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$72=e.$62=e.State=void 0,e.$82=m;var N;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class M{constructor(v,l,g){const c=new Uint8Array(v*l);for(let n=0,i=v*l;n<i;n++)c[n]=g;this.a=c,this.rows=v,this.cols=l}get(v,l){return this.a[v*this.cols+l]}set(v,l,g){this.a[v*this.cols+l]=g}}class A{constructor(v){let l=0,g=0;for(let n=0,i=v.length;n<i;n++){const[s,r,t]=v[n];r>l&&(l=r),s>g&&(g=s),t>g&&(g=t)}l++,g++;const c=new M(g,l,0);for(let n=0,i=v.length;n<i;n++){const[s,r,t]=v[n];c.set(s,r,t)}this.a=c,this.b=l}nextState(v,l){return l<0||l>=this.b?0:this.a.get(v,l)}}e.$62=A;let R=null;function w(){return R===null&&(R=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var $;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})($||($={}));let S=null;function L(){if(S===null){S=new u.$Bt(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<y.length;l++)S.set(y.charCodeAt(l),1);const v=".,;:";for(let l=0;l<v.length;l++)S.set(v.charCodeAt(l),2)}return S}class C{static a(v,l,g,c,n){let i=n-1;do{const s=l.charCodeAt(i);if(v.get(s)!==2)break;i--}while(i>c);if(c>0){const s=l.charCodeAt(c-1),r=l.charCodeAt(i);(s===40&&r===41||s===91&&r===93||s===123&&r===125)&&i--}return{range:{startLineNumber:g,startColumn:c+1,endLineNumber:g,endColumn:i+2},url:l.substring(c,i+1)}}static computeLinks(v,l=w()){const g=L(),c=[];for(let n=1,i=v.getLineCount();n<=i;n++){const s=v.getLineContent(n),r=s.length;let t=0,d=0,a=0,h=1,o=!1,p=!1,f=!1,D=!1;for(;t<r;){let b=!1;const k=s.charCodeAt(t);if(h===13){let E;switch(k){case 40:o=!0,E=0;break;case 41:E=o?0:1;break;case 91:f=!0,p=!0,E=0;break;case 93:f=!1,E=p?0:1;break;case 123:D=!0,E=0;break;case 125:E=D?0:1;break;case 39:case 34:case 96:a===k?E=1:a===39||a===34||a===96?E=0:E=1;break;case 42:E=a===42?1:0;break;case 124:E=a===124?1:0;break;case 32:E=f?0:1;break;default:E=g.get(k)}E===1&&(c.push(C.a(g,s,n,d,t)),b=!0)}else if(h===12){let E;k===91?(p=!0,E=0):E=g.get(k),E===1?b=!0:h=13}else h=l.nextState(h,k),h===0&&(b=!0);b&&(h=1,o=!1,p=!1,D=!1,d=t+1,a=k),t++}h===13&&c.push(C.a(g,s,n,d,r))}return c}}e.$72=C;function m(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:C.computeLinks(y)}}),define(ke[79],Se([1,0,24]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cv=e.$Bv=e.$Av=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$yv=e.$xv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$zv=v,e.$Dv=s;var N;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var M;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(M||(e.GlyphMarginLane=M={}));var A;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var R;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(R||(e.MinimapSectionHeaderStyle=R={}));var w;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(w||(e.InjectedTextCursorStops=w={}));var $;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var S;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(S||(e.DefaultEndOfLine=S={}));var L;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(L||(e.EndOfLineSequence=L={}));class C{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,u.$2n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$xv=C;class m{constructor(t,d){this._findMatchBrand=void 0,this.range=t,this.matches=d}}e.$yv=m;var y;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y||(e.TrackedRangeStickiness=y={}));function v(r){return r&&typeof r.read=="function"}var l;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(l||(e.PositionAffinity=l={}));var g;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(e.ModelConstants=g={}));class c{constructor(t,d,a,h,o,p){this.identifier=t,this.range=d,this.text=a,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=o,this._isTracked=p}}e.$Av=c;class n{constructor(t,d,a){this.regex=t,this.wordSeparators=d,this.simpleSearch=a}}e.$Bv=n;class i{constructor(t,d,a){this.reverseEdits=t,this.changes=d,this.trimAutoWhitespaceLineNumbers=a}}e.$Cv=i;function s(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}}),define(ke[181],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tC=e.NodeColor=e.$sC=void 0,e.$uC=M,e.$vC=A,e.$wC=S,e.$xC=L,e.$yC=C,e.$zC=m,e.$AC=y,e.$BC=v;class u{constructor(g,c){this.piece=g,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$tC)return M(this.right);let g=this;for(;g.parent!==e.$tC&&g.parent.left!==g;)g=g.parent;return g.parent===e.$tC?e.$tC:g.parent}prev(){if(this.left!==e.$tC)return A(this.left);let g=this;for(;g.parent!==e.$tC&&g.parent.right!==g;)g=g.parent;return g.parent===e.$tC?e.$tC:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$sC=u;var N;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$tC=new u(null,0),e.$tC.parent=e.$tC,e.$tC.left=e.$tC,e.$tC.right=e.$tC,e.$tC.color=0;function M(l){for(;l.left!==e.$tC;)l=l.left;return l}function A(l){for(;l.right!==e.$tC;)l=l.right;return l}function R(l){return l===e.$tC?0:l.size_left+l.piece.length+R(l.right)}function w(l){return l===e.$tC?0:l.lf_left+l.piece.lineFeedCnt+w(l.right)}function $(){e.$tC.parent=e.$tC}function S(l,g){const c=g.right;c.size_left+=g.size_left+(g.piece?g.piece.length:0),c.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=c.left,c.left!==e.$tC&&(c.left.parent=g),c.parent=g.parent,g.parent===e.$tC?l.root=c:g.parent.left===g?g.parent.left=c:g.parent.right=c,c.left=g,g.parent=c}function L(l,g){const c=g.left;g.left=c.right,c.right!==e.$tC&&(c.right.parent=g),c.parent=g.parent,g.size_left-=c.size_left+(c.piece?c.piece.length:0),g.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),g.parent===e.$tC?l.root=c:g===g.parent.right?g.parent.right=c:g.parent.left=c,c.right=g,g.parent=c}function C(l,g){let c,n;if(g.left===e.$tC?(n=g,c=n.right):g.right===e.$tC?(n=g,c=n.left):(n=M(g.right),c=n.right),n===l.root){l.root=c,c.color=0,g.detach(),$(),l.root.parent=e.$tC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=c:n.parent.right=c,n===g?(c.parent=n.parent,v(l,c)):(n.parent===g?c.parent=n:c.parent=n.parent,v(l,c),n.left=g.left,n.right=g.right,n.parent=g.parent,n.color=g.color,g===l.root?l.root=n:g===g.parent.left?g.parent.left=n:g.parent.right=n,n.left!==e.$tC&&(n.left.parent=n),n.right!==e.$tC&&(n.right.parent=n),n.size_left=g.size_left,n.lf_left=g.lf_left,v(l,n)),g.detach(),c.parent.left===c){const r=R(c),t=w(c);if(r!==c.parent.size_left||t!==c.parent.lf_left){const d=r-c.parent.size_left,a=t-c.parent.lf_left;c.parent.size_left=r,c.parent.lf_left=t,y(l,c.parent,d,a)}}if(v(l,c.parent),i){$();return}let s;for(;c!==l.root&&c.color===0;)c===c.parent.left?(s=c.parent.right,s.color===1&&(s.color=0,c.parent.color=1,S(l,c.parent),s=c.parent.right),s.left.color===0&&s.right.color===0?(s.color=1,c=c.parent):(s.right.color===0&&(s.left.color=0,s.color=1,L(l,s),s=c.parent.right),s.color=c.parent.color,c.parent.color=0,s.right.color=0,S(l,c.parent),c=l.root)):(s=c.parent.left,s.color===1&&(s.color=0,c.parent.color=1,L(l,c.parent),s=c.parent.left),s.left.color===0&&s.right.color===0?(s.color=1,c=c.parent):(s.left.color===0&&(s.right.color=0,s.color=1,S(l,s),s=c.parent.left),s.color=c.parent.color,c.parent.color=0,s.left.color=0,L(l,c.parent),c=l.root));c.color=0,$()}function m(l,g){for(v(l,g);g!==l.root&&g.parent.color===1;)if(g.parent===g.parent.parent.left){const c=g.parent.parent.right;c.color===1?(g.parent.color=0,c.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,S(l,g)),g.parent.color=0,g.parent.parent.color=1,L(l,g.parent.parent))}else{const c=g.parent.parent.left;c.color===1?(g.parent.color=0,c.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,L(l,g)),g.parent.color=0,g.parent.parent.color=1,S(l,g.parent.parent))}l.root.color=0}function y(l,g,c,n){for(;g!==l.root&&g!==e.$tC;)g.parent.left===g&&(g.parent.size_left+=c,g.parent.lf_left+=n),g=g.parent}function v(l,g){let c=0,n=0;if(g!==l.root){for(;g!==l.root&&g===g.parent.right;)g=g.parent;if(g!==l.root)for(g=g.parent,c=R(g.left)-g.size_left,n=w(g.left)-g.lf_left,g.size_left+=c,g.lf_left+=n;g!==l.root&&(c!==0||n!==0);)g.parent.left===g&&(g.parent.size_left+=c,g.parent.lf_left+=n),g=g.parent}}}),define(ke[182],Se([1,0,19,127]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rv=e.$Qv=e.$Pv=void 0;class M{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,S){$=(0,N.$3e)($);const L=this.a,C=this.b,m=S.length;return m===0?!1:(this.a=new Uint32Array(L.length+m),this.a.set(L.subarray(0,$),0),this.a.set(L.subarray($),$+m),this.a.set(S,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,S){return $=(0,N.$3e)($),S=(0,N.$3e)(S),this.a[$]===S?!1:(this.a[$]=S,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,S){$=(0,N.$3e)($),S=(0,N.$3e)(S);const L=this.a,C=this.b;if($>=L.length)return!1;const m=L.length-$;return S>=m&&(S=m),S===0?!1:(this.a=new Uint32Array(L.length-S),this.a.set(L.subarray(0,$),0),this.a.set(L.subarray($+S),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,N.$3e)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let S=this.c[0]+1;S===0&&(this.b[0]=this.a[0],S++),$>=this.a.length&&($=this.a.length-1);for(let L=S;L<=$;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let S=0,L=this.a.length-1,C=0,m=0,y=0;for(;S<=L;)if(C=S+(L-S)/2|0,m=this.b[C],y=m-this.a[C],$<y)L=C-1;else if($>=m)S=C+1;else break;return new R(C,$-y)}}e.$Pv=M;class A{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const S=this.e[$],L=S>0?this.d[S-1]:0;return new R(S,$-L)}removeValues($,S){this.a.splice($,S),this.f($)}insertValues($,S){this.a=(0,u.$Wb)(this.a,$,S),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,S=this.a.length;$<S;$++){const L=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+L;for(let m=0;m<L;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,S){this.a[$]!==S&&(this.a[$]=S,this.f($))}}e.$Qv=A;class R{constructor($,S){this.index=$,this.remainder=S,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=S}}e.$Rv=R}),define(ke[183],Se([1,0,14,50,182]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sv=void 0;class A{constructor(w,$,S,L){this.d=w,this.f=$,this.g=S,this.h=L,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(w){w.eol&&w.eol!==this.g&&(this.g=w.eol,this.j=null);const $=w.changes;for(const S of $)this.o(S.range),this.p(new N.$mt(S.range.startLineNumber,S.range.startColumn),S.text);this.h=w.versionId,this.k=null}l(){if(!this.j){const w=this.g.length,$=this.f.length,S=new Uint32Array($);for(let L=0;L<$;L++)S[L]=this.f[L].length+w;this.j=new M.$Pv(S)}}n(w,$){this.f[w]=$,this.j&&this.j.setValue(w,this.f[w].length+this.g.length)}o(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.startLineNumber-1].substring(w.endColumn-1));return}this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.endLineNumber-1].substring(w.endColumn-1)),this.f.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this.j&&this.j.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}p(w,$){if($.length===0)return;const S=(0,u.$hf)($);if(S.length===1){this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+S[0]+this.f[w.lineNumber-1].substring(w.column-1));return}S[S.length-1]+=this.f[w.lineNumber-1].substring(w.column-1),this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+S[0]);const L=new Uint32Array(S.length-1);for(let C=1;C<S.length;C++)this.f.splice(w.lineNumber+C-1,0,S[C]),L[C-1]=S[C].length+this.g.length;this.j&&this.j.insertValues(w.lineNumber,L)}}e.$Sv=A}),define(ke[100],Se([1,0,14,178,50,29,79]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HC=e.$FC=e.$CC=void 0,e.$DC=S,e.$EC=L,e.$GC=l;const w=999;class ${constructor(n,i,s,r){this.searchString=n,this.isRegex=i,this.matchCase=s,this.wordSeparators=r}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=S(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=u.$ff(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let s=!this.isRegex&&!n;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new R.$Bv(i,this.wordSeparators?(0,N.$Et)(this.wordSeparators,[]):null,s?this.searchString:null)}}e.$CC=$;function S(c){if(!c||c.length===0)return!1;for(let n=0,i=c.length;n<i;n++){const s=c.charCodeAt(n);if(s===10)return!0;if(s===92){if(n++,n>=i)break;const r=c.charCodeAt(n);if(r===110||r===114||r===87)return!0}}return!1}function L(c,n,i){if(!i)return new R.$yv(c,null);const s=[];for(let r=0,t=n.length;r<t;r++)s[r]=n[r];return new R.$yv(c,s)}class C{constructor(n){const i=[];let s=0;for(let r=0,t=n.length;r<t;r++)n.charCodeAt(r)===10&&(i[s++]=r);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let s=0,r=i.length-1;if(r===-1||n<=i[0])return 0;for(;s<r;){const t=s+((r-s)/2>>0);i[t]>=n?r=t-1:i[t+1]>=n?(s=t,r=t):s=t+1}return s+1}}class m{static findMatches(n,i,s,r,t){const d=i.parseSearchRequest();return d?d.regex.multiline?this.b(n,s,new g(d.wordSeparators,d.regex),r,t):this.c(n,s,d,r,t):[]}static a(n,i,s,r,t,d){let a,h=0;r?(h=r.findLineFeedCountBeforeOffset(t),a=i+t+h):a=i+t;let o;if(r){const b=r.findLineFeedCountBeforeOffset(t+d.length)-h;o=a+d.length+b}else o=a+d.length;const p=n.getPositionAt(a),f=n.getPositionAt(o);return new A.$nt(p.lineNumber,p.column,f.lineNumber,f.column)}static b(n,i,s,r,t){const d=n.getOffsetAt(i.getStartPosition()),a=n.getValueInRange(i,1),h=n.getEOL()===`\r
`?new C(a):null,o=[];let p=0,f;for(s.reset(0);f=s.next(a);)if(o[p++]=L(this.a(n,d,a,h,f.index,f[0]),f,r),p>=t)return o;return o}static c(n,i,s,r,t){const d=[];let a=0;if(i.startLineNumber===i.endLineNumber){const o=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return a=this.d(s,o,i.startLineNumber,i.startColumn-1,a,d,r,t),d}const h=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);a=this.d(s,h,i.startLineNumber,i.startColumn-1,a,d,r,t);for(let o=i.startLineNumber+1;o<i.endLineNumber&&a<t;o++)a=this.d(s,n.getLineContent(o),o,0,a,d,r,t);if(a<t){const o=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);a=this.d(s,o,i.endLineNumber,0,a,d,r,t)}return d}static d(n,i,s,r,t,d,a,h){const o=n.wordSeparators;if(!a&&n.simpleSearch){const D=n.simpleSearch,b=D.length,k=i.length;let E=-b;for(;(E=i.indexOf(D,E+b))!==-1;)if((!o||l(o,i,k,E,b))&&(d[t++]=new R.$yv(new A.$nt(s,E+1+r,s,E+1+b+r),null),t>=h))return t;return t}const p=new g(n.wordSeparators,n.regex);let f;p.reset(0);do if(f=p.next(i),f&&(d[t++]=L(new A.$nt(s,f.index+1+r,s,f.index+1+f[0].length+r),f,a),t>=h))return t;while(f);return t}static findNextMatch(n,i,s,r){const t=i.parseSearchRequest();if(!t)return null;const d=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,s,d,r):this.f(n,s,d,r)}static e(n,i,s,r){const t=new M.$mt(i.lineNumber,1),d=n.getOffsetAt(t),a=n.getLineCount(),h=n.getValueInRange(new A.$nt(t.lineNumber,t.column,a,n.getLineMaxColumn(a)),1),o=n.getEOL()===`\r
`?new C(h):null;s.reset(i.column-1);const p=s.next(h);return p?L(this.a(n,d,h,o,p.index,p[0]),p,r):i.lineNumber!==1||i.column!==1?this.e(n,new M.$mt(1,1),s,r):null}static f(n,i,s,r){const t=n.getLineCount(),d=i.lineNumber,a=n.getLineContent(d),h=this.g(s,a,d,i.column,r);if(h)return h;for(let o=1;o<=t;o++){const p=(d+o-1)%t,f=n.getLineContent(p+1),D=this.g(s,f,p+1,1,r);if(D)return D}return null}static g(n,i,s,r,t){n.reset(r-1);const d=n.next(i);return d?L(new A.$nt(s,d.index+1,s,d.index+1+d[0].length),d,t):null}static findPreviousMatch(n,i,s,r){const t=i.parseSearchRequest();if(!t)return null;const d=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,s,d,r):this.j(n,s,d,r)}static h(n,i,s,r){const t=this.b(n,new A.$nt(1,1,i.lineNumber,i.column),s,r,10*w);if(t.length>0)return t[t.length-1];const d=n.getLineCount();return i.lineNumber!==d||i.column!==n.getLineMaxColumn(d)?this.h(n,new M.$mt(d,n.getLineMaxColumn(d)),s,r):null}static j(n,i,s,r){const t=n.getLineCount(),d=i.lineNumber,a=n.getLineContent(d).substring(0,i.column-1),h=this.k(s,a,d,r);if(h)return h;for(let o=1;o<=t;o++){const p=(t+d-o-1)%t,f=n.getLineContent(p+1),D=this.k(s,f,p+1,r);if(D)return D}return null}static k(n,i,s,r){let t=null,d;for(n.reset(0);d=n.next(i);)t=L(new A.$nt(s,d.index+1,s,d.index+1+d[0].length),d,r);return t}}e.$FC=m;function y(c,n,i,s,r){if(s===0)return!0;const t=n.charCodeAt(s-1);if(c.get(t)!==0||t===13||t===10)return!0;if(r>0){const d=n.charCodeAt(s);if(c.get(d)!==0)return!0}return!1}function v(c,n,i,s,r){if(s+r===i)return!0;const t=n.charCodeAt(s+r);if(c.get(t)!==0||t===13||t===10)return!0;if(r>0){const d=n.charCodeAt(s+r-1);if(c.get(d)!==0)return!0}return!1}function l(c,n,i,s,r){return y(c,n,i,s,r)&&v(c,n,i,s,r)}class g{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let s;do{if(this.b+this.c===i||(s=this.a.exec(n),!s))return null;const r=s.index,t=s[0].length;if(r===this.b&&t===this.c){if(t===0){u.$Bf(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=r,this.c=t,!this._wordSeparators||l(this._wordSeparators,n,i,r,t))return s}while(s);return null}}e.$HC=g}),define(ke[130],Se([1,0,50,29,79,181,100]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=e.$LC=e.$KC=void 0,e.$IC=L,e.$JC=C;const w=65535;function $(c){let n;return c[c.length-1]<65536?n=new Uint16Array(c.length):n=new Uint32Array(c.length),n.set(c,0),n}class S{constructor(n,i,s,r,t){this.lineStarts=n,this.cr=i,this.lf=s,this.crlf=r,this.isBasicASCII=t}}function L(c,n=!0){const i=[0];let s=1;for(let r=0,t=c.length;r<t;r++){const d=c.charCodeAt(r);d===13?r+1<t&&c.charCodeAt(r+1)===10?(i[s++]=r+2,r++):i[s++]=r+1:d===10&&(i[s++]=r+1)}return n?$(i):i}function C(c,n){c.length=0,c[0]=0;let i=1,s=0,r=0,t=0,d=!0;for(let h=0,o=n.length;h<o;h++){const p=n.charCodeAt(h);p===13?h+1<o&&n.charCodeAt(h+1)===10?(t++,c[i++]=h+2,h++):(s++,c[i++]=h+1):p===10?(r++,c[i++]=h+1):d&&p!==9&&(p<32||p>126)&&(d=!1)}const a=new S($(c),s,r,t,d);return c.length=0,a}class m{constructor(n,i,s,r,t){this.bufferIndex=n,this.start=i,this.end=s,this.lineFeedCnt=r,this.length=t}}e.$KC=m;class y{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$LC=y;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==A.$tC&&n.iterate(n.root,s=>(s!==A.$tC&&this.a.push(s.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class l{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const s=this.b[i];if(s.nodeStartOffset<=n&&s.nodeStartOffset+s.node.piece.length>=n)return s}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const s=this.b[i];if(s.nodeStartLineNumber&&s.nodeStartLineNumber<n&&s.nodeStartLineNumber+s.node.piece.lineFeedCnt>=n)return s}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const s=this.b;for(let r=0;r<s.length;r++){const t=s[r];if(t.node.parent===null||t.nodeStartOffset>=n){s[r]=null,i=!0;continue}}if(i){const r=[];for(const t of s)t!==null&&r.push(t);this.b=r}}}class g{constructor(n,i,s){this.create(n,i,s)}create(n,i,s){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=A.$tC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=s;let r=null;for(let t=0,d=n.length;t<d;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=L(n[t].buffer));const a=new m(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),r=this.S(r,a)}this.h=new l(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=w,s=i-Math.floor(i/3),r=s*2;let t="",d=0;const a=[];if(this.iterate(this.root,h=>{const o=this.R(h),p=o.length;if(d<=s||d+p<r)return t+=o,d+=p,!0;const f=t.replace(/\r\n|\r|\n/g,n);return a.push(new y(f,L(f))),t=o,d=p,!0}),d>0){const h=t.replace(/\r\n|\r|\n/g,n);a.push(new y(h,L(h)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,r=>{if(r===A.$tC)return!0;const t=this.R(r),d=t.length,a=n.G(i),h=n.G(i+d),o=n.getValueInRange2(a,h);return i+=d,t===o})}getOffsetAt(n,i){let s=0,r=this.root;for(;r!==A.$tC;)if(r.left!==A.$tC&&r.lf_left+1>=n)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt+1>=n){s+=r.size_left;const t=this.B(r,n-r.lf_left-2);return s+=t+i-1}else n-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;return s}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,s=0;const r=n;for(;i!==A.$tC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(s+=i.lf_left+t.index,t.index===0){const d=this.getOffsetAt(s+1,1),a=r-d;return new u.$mt(s+1,a+1)}return new u.$mt(s+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,s+=i.lf_left+i.piece.lineFeedCnt,i.right===A.$tC){const t=this.getOffsetAt(s+1,1),d=r-n-t;return new u.$mt(s+1,d+1)}else i=i.right;return new u.$mt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const s=this.H(n.startLineNumber,n.startColumn),r=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(s,r);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const a=n.node,h=this.a[a.piece.bufferIndex].buffer,o=this.u(a.piece.bufferIndex,a.piece.start);return h.substring(o+n.remainder,o+i.remainder)}let s=n.node;const r=this.a[s.piece.bufferIndex].buffer,t=this.u(s.piece.bufferIndex,s.piece.start);let d=r.substring(t+n.remainder,t+s.piece.length);for(s=s.next();s!==A.$tC;){const a=this.a[s.piece.bufferIndex].buffer,h=this.u(s.piece.bufferIndex,s.piece.start);if(s===i.node){d+=a.substring(h,h+i.remainder);break}else d+=a.substr(h,s.piece.length);s=s.next()}return d}getLinesContent(){const n=[];let i=0,s="",r=!1;return this.iterate(this.root,t=>{if(t===A.$tC)return!0;const d=t.piece;let a=d.length;if(a===0)return!0;const h=this.a[d.bufferIndex].buffer,o=this.a[d.bufferIndex].lineStarts,p=d.start.line,f=d.end.line;let D=o[p]+d.start.column;if(r&&(h.charCodeAt(D)===10&&(D++,a--),n[i++]=s,s="",r=!1,a===0))return!0;if(p===f)return!this.f&&h.charCodeAt(D+a-1)===13?(r=!0,s+=h.substr(D,a-1)):s+=h.substr(D,a),!0;s+=this.f?h.substring(D,Math.max(D,o[p+1]-this.e)):h.substring(D,o[p+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=s;for(let b=p+1;b<f;b++)s=this.f?h.substring(o[b],o[b+1]-this.e):h.substring(o[b],o[b+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=s;return!this.f&&h.charCodeAt(o[f]+d.end.column-1)===13?(r=!0,d.end.column===0?i--:s=h.substr(o[f],d.end.column-1)):s=h.substr(o[f],d.end.column),!0}),r&&(n[i++]=s,s=""),n[i++]=s,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const s=this.a[i.piece.bufferIndex],r=this.u(i.piece.bufferIndex,i.piece.start);return s.buffer.charCodeAt(r)}else{const i=this.a[n.node.piece.bufferIndex],r=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(r)}}getLineCharCode(n,i){const s=this.H(n,i+1);return this.l(s)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,s,r,t,d,a,h,o,p,f){const D=this.a[n.piece.bufferIndex],b=this.u(n.piece.bufferIndex,n.piece.start),k=this.u(n.piece.bufferIndex,t),E=this.u(n.piece.bufferIndex,d);let P;const I={line:0,column:0};let F,j;i._wordSeparators?(F=D.buffer.substring(k,E),j=z=>z+k,i.reset(0)):(F=D.buffer,j=z=>z,i.reset(k));do if(P=i.next(F),P){if(j(P.index)>=E)return p;this.s(n,j(P.index)-b,I);const z=this.t(n.piece.bufferIndex,t,I),O=I.line===t.line?I.column-t.column+r:I.column+1,T=O+P[0].length;if(f[p++]=(0,R.$EC)(new N.$nt(s+z,O,s+z,T),P,h),j(P.index)+P[0].length>=E||p>=o)return p}while(P);return p}findMatchesLineByLine(n,i,s,r){const t=[];let d=0;const a=new R.$HC(i.wordSeparators,i.regex);let h=this.H(n.startLineNumber,n.startColumn);if(h===null)return[];const o=this.H(n.endLineNumber,n.endColumn);if(o===null)return[];let p=this.s(h.node,h.remainder);const f=this.s(o.node,o.remainder);if(h.node===o.node)return this.findMatchesInNode(h.node,a,n.startLineNumber,n.startColumn,p,f,i,s,r,d,t),t;let D=n.startLineNumber,b=h.node;for(;b!==o.node;){const E=this.t(b.piece.bufferIndex,p,b.piece.end);if(E>=1){const I=this.a[b.piece.bufferIndex].lineStarts,F=this.u(b.piece.bufferIndex,b.piece.start),j=I[p.line+E],z=D===n.startLineNumber?n.startColumn:1;if(d=this.findMatchesInNode(b,a,D,z,p,this.s(b,j-F),i,s,r,d,t),d>=r)return t;D+=E}const P=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const I=this.getLineContent(D).substring(P,n.endColumn-1);return d=this.n(i,a,I,n.endLineNumber,P,d,t,s,r),t}if(d=this.n(i,a,this.getLineContent(D).substr(P),D,P,d,t,s,r),d>=r)return t;D++,h=this.H(D,1),b=h.node,p=this.s(h.node,h.remainder)}if(D===n.endLineNumber){const E=D===n.startLineNumber?n.startColumn-1:0,P=this.getLineContent(D).substring(E,n.endColumn-1);return d=this.n(i,a,P,n.endLineNumber,E,d,t,s,r),t}const k=D===n.startLineNumber?n.startColumn:1;return d=this.findMatchesInNode(o.node,a,D,k,p,f,i,s,r,d,t),t}n(n,i,s,r,t,d,a,h,o){const p=n.wordSeparators;if(!h&&n.simpleSearch){const D=n.simpleSearch,b=D.length,k=s.length;let E=-b;for(;(E=s.indexOf(D,E+b))!==-1;)if((!p||(0,R.$GC)(p,s,k,E,b))&&(a[d++]=new M.$yv(new N.$nt(r,E+1+t,r,E+1+b+t),null),d>=o))return d;return d}let f;i.reset(0);do if(f=i.next(s),f&&(a[d++]=(0,R.$EC)(new N.$nt(r,f.index+1+t,r,f.index+1+f[0].length+t),f,h),d>=o))return d;while(f);return d}insert(n,i,s=!1){if(this.f=this.f&&s,this.j.lineNumber=0,this.j.value="",this.root!==A.$tC){const{node:r,remainder:t,nodeStartOffset:d}=this.G(n),a=r.piece,h=a.bufferIndex,o=this.s(r,t);if(r.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&d+a.length===n&&i.length<w){this.F(r,i),this.y();return}if(d===n)this.o(i,r),this.h.validate(n);else if(d+r.piece.length>n){const p=[];let f=new m(a.bufferIndex,o,a.end,this.t(a.bufferIndex,o,a.end),this.u(h,a.end)-this.u(h,o));if(this.K()&&this.M(i)&&this.I(r,t)===10){const E={line:f.start.line+1,column:0};f=new m(f.bufferIndex,E,f.end,this.t(f.bufferIndex,E,f.end),f.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(r,t-1)===13){const E=this.s(r,t-1);this.C(r,E),i="\r"+i,r.piece.length===0&&p.push(r)}else this.C(r,o);else this.C(r,o);const D=this.w(i);f.length>0&&this.S(r,f);let b=r;for(let k=0;k<D.length;k++)b=this.S(b,D[k]);this.v(p)}else this.q(i,r)}else{const r=this.w(i);let t=this.T(null,r[0]);for(let d=1;d<r.length;d++)t=this.S(t,r[d])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===A.$tC)return;const s=this.G(n),r=this.G(n+i),t=s.node,d=r.node;if(t===d){const D=this.s(t,s.remainder),b=this.s(t,r.remainder);if(s.nodeStartOffset===n){if(i===t.piece.length){const k=t.next();(0,A.$yC)(this,t),this.N(k),this.y();return}this.D(t,b),this.h.validate(n),this.N(t),this.y();return}if(s.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,b),this.y();return}const a=[],h=this.s(t,s.remainder);this.C(t,h),this.h.validate(n),t.piece.length===0&&a.push(t);const o=this.s(d,r.remainder);this.D(d,o),d.piece.length===0&&a.push(d);const p=t.next();for(let D=p;D!==A.$tC&&D!==d;D=D.next())a.push(D);const f=t.piece.length===0?t.prev():t;this.v(a),this.O(f),this.y()}o(n,i){const s=[];if(this.K()&&this.M(n)&&this.L(i)){const d=i.piece,a={line:d.start.line+1,column:0},h=new m(d.bufferIndex,a,d.end,this.t(d.bufferIndex,a,d.end),d.length-1);i.piece=h,n+=`
`,(0,A.$AC)(this,i,-1,-1),i.piece.length===0&&s.push(i)}const r=this.w(n);let t=this.T(i,r[r.length-1]);for(let d=r.length-2;d>=0;d--)t=this.T(t,r[d]);this.N(t),this.v(s)}q(n,i){this.Q(n,i)&&(n+=`
`);const s=this.w(n),r=this.S(i,s[0]);let t=r;for(let d=1;d<s.length;d++)t=this.S(t,s[d]);this.N(r)}s(n,i,s){const r=n.piece,t=n.piece.bufferIndex,d=this.a[t].lineStarts,h=d[r.start.line]+r.start.column+i;let o=r.start.line,p=r.end.line,f=0,D=0,b=0;for(;o<=p&&(f=o+(p-o)/2|0,b=d[f],f!==p);)if(D=d[f+1],h<b)p=f-1;else if(h>=D)o=f+1;else break;return s?(s.line=f,s.column=h-b,null):{line:f,column:h-b}}t(n,i,s){if(s.column===0)return s.line-i.line;const r=this.a[n].lineStarts;if(s.line===r.length-1)return s.line-i.line;const t=r[s.line+1],d=r[s.line]+s.column;if(t>d+1)return s.line-i.line;const a=d-1;return this.a[n].buffer.charCodeAt(a)===13?s.line-i.line+1:s.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,A.$yC)(this,n[i])}w(n){if(n.length>w){const p=[];for(;n.length>w;){const D=n.charCodeAt(w-1);let b;D===13||D>=55296&&D<=56319?(b=n.substring(0,w-1),n=n.substring(w-1)):(b=n.substring(0,w),n=n.substring(w));const k=L(b);p.push(new m(this.a.length,{line:0,column:0},{line:k.length-1,column:b.length-k[k.length-1]},k.length-1,b.length)),this.a.push(new y(b,k))}const f=L(n);return p.push(new m(this.a.length,{line:0,column:0},{line:f.length-1,column:n.length-f[f.length-1]},f.length-1,n.length)),this.a.push(new y(n,f)),p}let i=this.a[0].buffer.length;const s=L(n,!1);let r=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},r=this.g;for(let p=0;p<s.length;p++)s[p]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let p=0;p<s.length;p++)s[p]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[d],h={line:d,column:a},o=new m(0,r,h,this.t(0,r,h),t-i);return this.g=h,[o]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let s=this.root,r="";const t=this.h.get2(n);if(t){s=t.node;const d=this.B(s,n-t.nodeStartLineNumber-1),a=this.a[s.piece.bufferIndex].buffer,h=this.u(s.piece.bufferIndex,s.piece.start);if(t.nodeStartLineNumber+s.piece.lineFeedCnt===n)r=a.substring(h+d,h+s.piece.length);else{const o=this.B(s,n-t.nodeStartLineNumber);return a.substring(h+d,h+o-i)}}else{let d=0;const a=n;for(;s!==A.$tC;)if(s.left!==A.$tC&&s.lf_left>=n-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>n-1){const h=this.B(s,n-s.lf_left-2),o=this.B(s,n-s.lf_left-1),p=this.a[s.piece.bufferIndex].buffer,f=this.u(s.piece.bufferIndex,s.piece.start);return d+=s.size_left,this.h.set({node:s,nodeStartOffset:d,nodeStartLineNumber:a-(n-1-s.lf_left)}),p.substring(f+h,f+o-i)}else if(s.lf_left+s.piece.lineFeedCnt===n-1){const h=this.B(s,n-s.lf_left-2),o=this.a[s.piece.bufferIndex].buffer,p=this.u(s.piece.bufferIndex,s.piece.start);r=o.substring(p+h,p+s.piece.length);break}else n-=s.lf_left+s.piece.lineFeedCnt,d+=s.size_left+s.piece.length,s=s.right}for(s=s.next();s!==A.$tC;){const d=this.a[s.piece.bufferIndex].buffer;if(s.piece.lineFeedCnt>0){const a=this.B(s,0),h=this.u(s.piece.bufferIndex,s.piece.start);return r+=d.substring(h,h+a-i),r}else{const a=this.u(s.piece.bufferIndex,s.piece.start);r+=d.substr(a,s.piece.length)}s=s.next()}return r}y(){let n=this.root,i=1,s=0;for(;n!==A.$tC;)i+=n.lf_left+n.piece.lineFeedCnt,s+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=s,this.h.validate(this.c)}A(n,i){const s=n.piece,r=this.s(n,i),t=r.line-s.start.line;if(this.u(s.bufferIndex,s.end)-this.u(s.bufferIndex,s.start)===i){const d=this.t(n.piece.bufferIndex,s.start,r);if(d!==t)return{index:d,remainder:0}}return{index:t,remainder:r.column}}B(n,i){if(i<0)return 0;const s=n.piece,r=this.a[s.bufferIndex].lineStarts,t=s.start.line+i+1;return t>s.end.line?r[s.end.line]+s.end.column-r[s.start.line]-s.start.column:r[t]-r[s.start.line]-s.start.column}C(n,i){const s=n.piece,r=s.lineFeedCnt,t=this.u(s.bufferIndex,s.end),d=i,a=this.u(s.bufferIndex,d),h=this.t(s.bufferIndex,s.start,d),o=h-r,p=a-t,f=s.length+p;n.piece=new m(s.bufferIndex,s.start,d,h,f),(0,A.$AC)(this,n,p,o)}D(n,i){const s=n.piece,r=s.lineFeedCnt,t=this.u(s.bufferIndex,s.start),d=i,a=this.t(s.bufferIndex,d,s.end),h=this.u(s.bufferIndex,d),o=a-r,p=t-h,f=s.length+p;n.piece=new m(s.bufferIndex,d,s.end,a,f),(0,A.$AC)(this,n,p,o)}E(n,i,s){const r=n.piece,t=r.start,d=r.end,a=r.length,h=r.lineFeedCnt,o=i,p=this.t(r.bufferIndex,r.start,o),f=this.u(r.bufferIndex,i)-this.u(r.bufferIndex,t);n.piece=new m(r.bufferIndex,r.start,o,p,f),(0,A.$AC)(this,n,f-a,p-h);const D=new m(r.bufferIndex,s,d,this.t(r.bufferIndex,s,d),this.u(r.bufferIndex,d)-this.u(r.bufferIndex,s)),b=this.S(n,D);this.N(b)}F(n,i){this.Q(i,n)&&(i+=`
`);const s=this.K()&&this.L(i)&&this.M(n),r=this.a[0].buffer.length;this.a[0].buffer+=i;const t=L(i,!1);for(let b=0;b<t.length;b++)t[b]+=r;if(s){const b=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:r-b}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const d=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[d],h={line:d,column:a},o=n.piece.length+i.length,p=n.piece.lineFeedCnt,f=this.t(0,n.piece.start,h),D=f-p;n.piece=new m(n.piece.bufferIndex,n.piece.start,h,f,o),this.g=h,(0,A.$AC)(this,n,i.length,D)}G(n){let i=this.root;const s=this.h.get(n);if(s)return{node:s.node,nodeStartOffset:s.nodeStartOffset,remainder:n-s.nodeStartOffset};let r=0;for(;i!==A.$tC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){r+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:r};return this.h.set(t),t}else n-=i.size_left+i.piece.length,r+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let s=this.root,r=0;for(;s!==A.$tC;)if(s.left!==A.$tC&&s.lf_left>=n-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>n-1){const t=this.B(s,n-s.lf_left-2),d=this.B(s,n-s.lf_left-1);return r+=s.size_left,{node:s,remainder:Math.min(t+i-1,d),nodeStartOffset:r}}else if(s.lf_left+s.piece.lineFeedCnt===n-1){const t=this.B(s,n-s.lf_left-2);if(t+i-1<=s.piece.length)return{node:s,remainder:t+i-1,nodeStartOffset:r};i-=s.piece.length-t;break}else n-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;for(s=s.next();s!==A.$tC;){if(s.piece.lineFeedCnt>0){const t=this.B(s,0),d=this.J(s);return{node:s,remainder:Math.min(i-1,t),nodeStartOffset:d}}else if(s.piece.length>=i-1){const t=this.J(s);return{node:s,remainder:i-1,nodeStartOffset:t}}else i-=s.piece.length;s=s.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const s=this.a[n.piece.bufferIndex],r=this.u(n.piece.bufferIndex,n.piece.start)+i;return s.buffer.charCodeAt(r)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===A.$tC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,s=this.a[i.bufferIndex].lineStarts,r=i.start.line,t=s[r]+i.start.column;return r===s.length-1||s[r+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===A.$tC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const s=[],r=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:r[n.piece.end.line]-r[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const d=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new m(n.piece.bufferIndex,n.piece.start,t,a,d),(0,A.$AC)(this,n,-1,-1),n.piece.length===0&&s.push(n);const h={line:i.piece.start.line+1,column:0},o=i.piece.length-1,p=this.t(i.piece.bufferIndex,h,i.piece.end);i.piece=new m(i.piece.bufferIndex,h,i.piece.end,p,o),(0,A.$AC)(this,i,-1,-1),i.piece.length===0&&s.push(i);const f=this.w(`\r
`);this.S(n,f[0]);for(let D=0;D<s.length;D++)(0,A.$yC)(this,s[D])}Q(n,i){if(this.K()&&this.M(n)){const s=i.next();if(this.L(s)){if(n+=`
`,s.piece.length===1)(0,A.$yC)(this,s);else{const r=s.piece,t={line:r.start.line+1,column:0},d=r.length-1,a=this.t(r.bufferIndex,t,r.end);s.piece=new m(r.bufferIndex,t,r.end,a,d),(0,A.$AC)(this,s,-1,-1)}return!0}}return!1}iterate(n,i){if(n===A.$tC)return i(A.$tC);const s=this.iterate(n.left,i);return s&&i(n)&&this.iterate(n.right,i)}R(n){if(n===A.$tC)return"";const i=this.a[n.piece.bufferIndex],s=n.piece,r=this.u(s.bufferIndex,s.start),t=this.u(s.bufferIndex,s.end);return i.buffer.substring(r,t)}getPieceContent(n){const i=this.a[n.bufferIndex],s=this.u(n.bufferIndex,n.start),r=this.u(n.bufferIndex,n.end);return i.buffer.substring(s,r)}S(n,i){const s=new A.$sC(i,1);if(s.left=A.$tC,s.right=A.$tC,s.parent=A.$tC,s.size_left=0,s.lf_left=0,this.root===A.$tC)this.root=s,s.color=0;else if(n.right===A.$tC)n.right=s,s.parent=n;else{const t=(0,A.$uC)(n.right);t.left=s,s.parent=t}return(0,A.$zC)(this,s),s}T(n,i){const s=new A.$sC(i,1);if(s.left=A.$tC,s.right=A.$tC,s.parent=A.$tC,s.size_left=0,s.lf_left=0,this.root===A.$tC)this.root=s,s.color=0;else if(n.left===A.$tC)n.left=s,s.parent=n;else{const r=(0,A.$vC)(n.left);r.right=s,s.parent=r}return(0,A.$zC)(this,s),s}U(n){let i="";return this.iterate(n,s=>(i+=this.R(s),!0)),i}}e.$MC=g}),define(ke[184],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v9=e.$u9=void 0;class u{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const R=this.a.get(A);return this.a.delete(A),R}}addDragOperationTransfer(A,R){this.a.set(A,R)}}e.$u9=u;class N{constructor(A){this.identifier=A}}e.$v9=N}),define(ke[185],Se([1,0,4,3]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=void 0;class M{constructor(){this.a=new Map,this.b=new Map,this.c=new u.$be,this.onDidChange=this.c.event,this.d=null}handleChange(w){this.c.fire({changedLanguages:w,changedColorMap:!1})}register(w,$){return this.a.set(w,$),this.handleChange([w]),(0,N.$Sc)(()=>{this.a.get(w)===$&&(this.a.delete(w),this.handleChange([w]))})}get(w){return this.a.get(w)||null}registerFactory(w,$){this.b.get(w)?.dispose();const S=new A(this,w,$);return this.b.set(w,S),(0,N.$Sc)(()=>{const L=this.b.get(w);!L||L!==S||(this.b.delete(w),L.dispose())})}async getOrCreate(w){const $=this.get(w);if($)return $;const S=this.b.get(w);return!S||S.isResolved?null:(await S.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const S=this.b.get(w);return!!(!S||S.isResolved)}setColorMap(w){this.d=w,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Pt=M;class A extends N.$Uc{get isResolved(){return this.c}constructor(w,$,S){super(),this.f=w,this.g=$,this.h=S,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const w=await this.h.tokenizationSupport;this.c=!0,w&&!this.a&&this.B(this.f.register(this.g,w))}}}),define(ke[186],Se([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(ke[187],Se([1,0,4,3,186]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=void 0,e.$bj=L;class A extends N.$Uc{constructor(m,y="",v="",l=!0,g){super(),this.h=this.B(new u.$be),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=y,this.u=v,this.w=l,this.C=g}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,y){this.C&&await this.C(m)}}e.$9i=A;class R extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new u.$be),this.onWillRun=this.f.event,this.m=this.B(new u.$be),this.onDidRun=this.m.event}async run(m,y){if(!m.enabled)return;this.f.fire({action:m});let v;try{await this.u(m,y)}catch(l){v=l}this.m.fire({action:m,error:v})}async u(m,y){await m.run(y)}}e.$0i=R;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let y=[];for(const v of m)v.length&&(y.length?y=[...y,new w,...v]:y=v);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$$i=w;class ${get actions(){return this.a}constructor(m,y,v,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=y,this.class=l,this.a=v}async run(){}}e.$_i=$;class S extends A{static{this.ID="vs.actions.empty"}constructor(){super(S.ID,M.localize(0,null),void 0,!1)}}e.$aj=S;function L(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...m)=>C.run(...m),tooltip:C.label}}}),define(ke[188],Se([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(ke[189],Se([1,0,188]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=S,e.$Xm=L,e.$Ym=C;const N=60,M=N*60,A=M*24,R=A*7,w=A*30,$=A*365;function S(m,y,v,l){typeof m!="number"&&(m=m.getTime());const g=Math.round((new Date().getTime()-m)/1e3);if(g<-30)return(0,u.localize)(0,null,S(new Date().getTime()+g*1e3,!1));if(!l&&g<30)return(0,u.localize)(1,null);let c;return g<N?(c=g,y?c===1?v?(0,u.localize)(2,null,c):(0,u.localize)(3,null,c):v?(0,u.localize)(4,null,c):(0,u.localize)(5,null,c):c===1?v?(0,u.localize)(6,null,c):(0,u.localize)(7,null,c):v?(0,u.localize)(8,null,c):(0,u.localize)(9,null,c)):g<M?(c=Math.floor(g/N),y?c===1?v?(0,u.localize)(10,null,c):(0,u.localize)(11,null,c):v?(0,u.localize)(12,null,c):(0,u.localize)(13,null,c):c===1?v?(0,u.localize)(14,null,c):(0,u.localize)(15,null,c):v?(0,u.localize)(16,null,c):(0,u.localize)(17,null,c)):g<A?(c=Math.floor(g/M),y?c===1?v?(0,u.localize)(18,null,c):(0,u.localize)(19,null,c):v?(0,u.localize)(20,null,c):(0,u.localize)(21,null,c):c===1?v?(0,u.localize)(22,null,c):(0,u.localize)(23,null,c):v?(0,u.localize)(24,null,c):(0,u.localize)(25,null,c)):g<R?(c=Math.floor(g/A),y?c===1?(0,u.localize)(26,null,c):(0,u.localize)(27,null,c):c===1?(0,u.localize)(28,null,c):(0,u.localize)(29,null,c)):g<w?(c=Math.floor(g/R),y?c===1?v?(0,u.localize)(30,null,c):(0,u.localize)(31,null,c):v?(0,u.localize)(32,null,c):(0,u.localize)(33,null,c):c===1?v?(0,u.localize)(34,null,c):(0,u.localize)(35,null,c):v?(0,u.localize)(36,null,c):(0,u.localize)(37,null,c)):g<$?(c=Math.floor(g/w),y?c===1?v?(0,u.localize)(38,null,c):(0,u.localize)(39,null,c):v?(0,u.localize)(40,null,c):(0,u.localize)(41,null,c):c===1?v?(0,u.localize)(42,null,c):(0,u.localize)(43,null,c):v?(0,u.localize)(44,null,c):(0,u.localize)(45,null,c)):(c=Math.floor(g/$),y?c===1?v?(0,u.localize)(46,null,c):(0,u.localize)(47,null,c):v?(0,u.localize)(48,null,c):(0,u.localize)(49,null,c):c===1?v?(0,u.localize)(50,null,c):(0,u.localize)(51,null,c):v?(0,u.localize)(52,null,c):(0,u.localize)(53,null,c))}function L(m,y){const v=Math.abs(m/1e3);return v<1?y?(0,u.localize)(54,null,m):(0,u.localize)(55,null,m):v<N?y?(0,u.localize)(56,null,Math.round(m)/1e3):(0,u.localize)(57,null,Math.round(m)/1e3):v<M?y?(0,u.localize)(58,null,Math.round(m/(1e3*N))):(0,u.localize)(59,null,Math.round(m/(1e3*N))):v<A?y?(0,u.localize)(60,null,Math.round(m/(1e3*M))):(0,u.localize)(61,null,Math.round(m/(1e3*M))):(0,u.localize)(62,null,Math.round(m/(1e3*A)))}function C(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[190],Se([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(ke[47],Se([1,0,19,18,190]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=$,e.$dj=S,e.$ej=L;function A(C,m){return m&&(C.stack||C.stacktrace)?M.localize(0,null,w(C),R(C.stack)||R(C.stacktrace)):w(C)}function R(C){return Array.isArray(C)?C.join(`
`):C}function w(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?M.localize(1,null,C.message):C.message||M.localize(2,null)}function $(C=null,m=!1){if(!C)return M.localize(3,null);if(Array.isArray(C)){const y=u.$Hb(C),v=$(y[0],m);return y.length>1?M.localize(4,null,v,y.length):v}if(N.$5f(C))return C;if(C.detail){const y=C.detail;if(y.error)return A(y.error,m);if(y.exception)return A(y.exception,m)}return C.stack?A(C,m):C.message?C.message:M.localize(5,null)}function S(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}function L(C,m){let y;return typeof C=="string"?y=new Error(C):y=C,y.actions=m,y}}),define(ke[191],Se([9,10]),function(le,e){return le.create("vs/base/common/platform",e)}),define(ke[11],Se([1,0,191]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=d,e.$D=D,e.$J=b,e.$g="en";let N=!1,M=!1,A=!1,R=!1,w=!1,$=!1,S=!1,L=!1,C=!1,m=!1,y,v=e.$g,l=e.$g,g,c;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const s=typeof i?.versions?.electron=="string",r=s&&i?.type==="renderer";if(typeof i=="object"){N=i.platform==="win32",M=i.platform==="darwin",A=i.platform==="linux",R=A&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,S=s,C=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,v=e.$g;const k=i.env.VSCODE_NLS_CONFIG;if(k)try{const E=JSON.parse(k),P=E.availableLanguages["*"];y=E.locale,l=E.osLocale,v=P||e.$g,g=E._translationsConfigFile}catch{}w=!0}else typeof navigator=="object"&&!r?(c=navigator.userAgent,N=c.indexOf("Windows")>=0,M=c.indexOf("Macintosh")>=0,L=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,m=c?.indexOf("Mobi")>=0,$=!0,y=u.getConfiguredDefaultLocale(u.localize(0,null))||e.$g,v=y,l=navigator.language):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function d(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let a=0;M?a=1:N?a=3:A&&(a=2),e.$i=N,e.$j=M,e.$k=A,e.$l=R,e.$m=w,e.$n=S,e.$o=$,e.$p=$&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=L,e.$s=m,e.$t=C,e.$u=a,e.$v=c,e.$w=v;var h;(function(k){function E(){return e.$w}k.value=E;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=P;function I(){return e.$w==="en"}k.isDefault=I})(h||(e.Language=h={})),e.$x=y,e.$y=l,e.$z=g,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const k=[];n.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let I=0,F=k.length;I<F;I++){const j=k[I];if(j.id===P.data.vscodeScheduleAsyncWork){k.splice(I,1),j.callback();return}}});let E=0;return P=>{const I=++E;k.push({id:I,callback:P}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return k=>setTimeout(k)})();var o;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=M||L?2:N?1:3;let p=!0,f=!1;function D(){if(!f){f=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,p=new Uint16Array(k.buffer)[0]===513}return p}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function b(k){return parseFloat(k)>=20}}),define(ke[51],Se([1,0,11]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const A=M.process;N={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return u.$i?"win32":u.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ke[17],Se([1,0,51]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,M=97,A=90,R=122,w=46,$=47,S=92,L=58,C=63;class m extends Error{constructor(d,a,h){let o;typeof a=="string"&&a.indexOf("not ")===0?(o="must not be",a=a.replace(/^not /,"")):o="must be";const p=d.indexOf(".")!==-1?"property":"argument";let f=`The "${d}" ${p} ${o} of type ${a}`;f+=`. Received type ${typeof h}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,d){if(t===null||typeof t!="object")throw new m(d,"Object",t)}function v(t,d){if(typeof t!="string")throw new m(d,"string",t)}const l=u.$ec==="win32";function g(t){return t===$||t===S}function c(t){return t===$}function n(t){return t>=N&&t<=A||t>=M&&t<=R}function i(t,d,a,h){let o="",p=0,f=-1,D=0,b=0;for(let k=0;k<=t.length;++k){if(k<t.length)b=t.charCodeAt(k);else{if(h(b))break;b=$}if(h(b)){if(!(f===k-1||D===1))if(D===2){if(o.length<2||p!==2||o.charCodeAt(o.length-1)!==w||o.charCodeAt(o.length-2)!==w){if(o.length>2){const E=o.lastIndexOf(a);E===-1?(o="",p=0):(o=o.slice(0,E),p=o.length-1-o.lastIndexOf(a)),f=k,D=0;continue}else if(o.length!==0){o="",p=0,f=k,D=0;continue}}d&&(o+=o.length>0?`${a}..`:"..",p=2)}else o.length>0?o+=`${a}${t.slice(f+1,k)}`:o=t.slice(f+1,k),p=k-f-1;f=k,D=0}else b===w&&D!==-1?++D:D=-1}return o}function s(t,d){y(d,"pathObject");const a=d.dir||d.root,h=d.base||`${d.name||""}${d.ext||""}`;return a?a===d.root?`${a}${h}`:`${a}${t}${h}`:h}e.$gc={resolve(...t){let d="",a="",h=!1;for(let o=t.length-1;o>=-1;o--){let p;if(o>=0){if(p=t[o],v(p,"path"),p.length===0)continue}else d.length===0?p=u.cwd():(p=u.env[`=${d}`]||u.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==d.toLowerCase()&&p.charCodeAt(2)===S)&&(p=`${d}\\`));const f=p.length;let D=0,b="",k=!1;const E=p.charCodeAt(0);if(f===1)g(E)&&(D=1,k=!0);else if(g(E))if(k=!0,g(p.charCodeAt(1))){let P=2,I=P;for(;P<f&&!g(p.charCodeAt(P));)P++;if(P<f&&P!==I){const F=p.slice(I,P);for(I=P;P<f&&g(p.charCodeAt(P));)P++;if(P<f&&P!==I){for(I=P;P<f&&!g(p.charCodeAt(P));)P++;(P===f||P!==I)&&(b=`\\\\${F}\\${p.slice(I,P)}`,D=P)}}}else D=1;else n(E)&&p.charCodeAt(1)===L&&(b=p.slice(0,2),D=2,f>2&&g(p.charCodeAt(2))&&(k=!0,D=3));if(b.length>0)if(d.length>0){if(b.toLowerCase()!==d.toLowerCase())continue}else d=b;if(h){if(d.length>0)break}else if(a=`${p.slice(D)}\\${a}`,h=k,k&&d.length>0)break}return a=i(a,!h,"\\",g),h?`${d}\\${a}`:`${d}${a}`||"."},normalize(t){v(t,"path");const d=t.length;if(d===0)return".";let a=0,h,o=!1;const p=t.charCodeAt(0);if(d===1)return c(p)?"\\":t;if(g(p))if(o=!0,g(t.charCodeAt(1))){let D=2,b=D;for(;D<d&&!g(t.charCodeAt(D));)D++;if(D<d&&D!==b){const k=t.slice(b,D);for(b=D;D<d&&g(t.charCodeAt(D));)D++;if(D<d&&D!==b){for(b=D;D<d&&!g(t.charCodeAt(D));)D++;if(D===d)return`\\\\${k}\\${t.slice(b)}\\`;D!==b&&(h=`\\\\${k}\\${t.slice(b,D)}`,a=D)}}}else a=1;else n(p)&&t.charCodeAt(1)===L&&(h=t.slice(0,2),a=2,d>2&&g(t.charCodeAt(2))&&(o=!0,a=3));let f=a<d?i(t.slice(a),!o,"\\",g):"";return f.length===0&&!o&&(f="."),f.length>0&&g(t.charCodeAt(d-1))&&(f+="\\"),h===void 0?o?`\\${f}`:f:o?`${h}\\${f}`:`${h}${f}`},isAbsolute(t){v(t,"path");const d=t.length;if(d===0)return!1;const a=t.charCodeAt(0);return g(a)||d>2&&n(a)&&t.charCodeAt(1)===L&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let d,a;for(let p=0;p<t.length;++p){const f=t[p];v(f,"path"),f.length>0&&(d===void 0?d=a=f:d+=`\\${f}`)}if(d===void 0)return".";let h=!0,o=0;if(typeof a=="string"&&g(a.charCodeAt(0))){++o;const p=a.length;p>1&&g(a.charCodeAt(1))&&(++o,p>2&&(g(a.charCodeAt(2))?++o:h=!1))}if(h){for(;o<d.length&&g(d.charCodeAt(o));)o++;o>=2&&(d=`\\${d.slice(o)}`)}return e.$gc.normalize(d)},relative(t,d){if(v(t,"from"),v(d,"to"),t===d)return"";const a=e.$gc.resolve(t),h=e.$gc.resolve(d);if(a===h||(t=a.toLowerCase(),d=h.toLowerCase(),t===d))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===S;)o++;let p=t.length;for(;p-1>o&&t.charCodeAt(p-1)===S;)p--;const f=p-o;let D=0;for(;D<d.length&&d.charCodeAt(D)===S;)D++;let b=d.length;for(;b-1>D&&d.charCodeAt(b-1)===S;)b--;const k=b-D,E=f<k?f:k;let P=-1,I=0;for(;I<E;I++){const j=t.charCodeAt(o+I);if(j!==d.charCodeAt(D+I))break;j===S&&(P=I)}if(I!==E){if(P===-1)return h}else{if(k>E){if(d.charCodeAt(D+I)===S)return h.slice(D+I+1);if(I===2)return h.slice(D+I)}f>E&&(t.charCodeAt(o+I)===S?P=I:I===2&&(P=3)),P===-1&&(P=0)}let F="";for(I=o+P+1;I<=p;++I)(I===p||t.charCodeAt(I)===S)&&(F+=F.length===0?"..":"\\..");return D+=P,F.length>0?`${F}${h.slice(D,b)}`:(h.charCodeAt(D)===S&&++D,h.slice(D,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const d=e.$gc.resolve(t);if(d.length<=2)return t;if(d.charCodeAt(0)===S){if(d.charCodeAt(1)===S){const a=d.charCodeAt(2);if(a!==C&&a!==w)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(n(d.charCodeAt(0))&&d.charCodeAt(1)===L&&d.charCodeAt(2)===S)return`\\\\?\\${d}`;return t},dirname(t){v(t,"path");const d=t.length;if(d===0)return".";let a=-1,h=0;const o=t.charCodeAt(0);if(d===1)return g(o)?t:".";if(g(o)){if(a=h=1,g(t.charCodeAt(1))){let D=2,b=D;for(;D<d&&!g(t.charCodeAt(D));)D++;if(D<d&&D!==b){for(b=D;D<d&&g(t.charCodeAt(D));)D++;if(D<d&&D!==b){for(b=D;D<d&&!g(t.charCodeAt(D));)D++;if(D===d)return t;D!==b&&(a=h=D+1)}}}}else n(o)&&t.charCodeAt(1)===L&&(a=d>2&&g(t.charCodeAt(2))?3:2,h=a);let p=-1,f=!0;for(let D=d-1;D>=h;--D)if(g(t.charCodeAt(D))){if(!f){p=D;break}}else f=!1;if(p===-1){if(a===-1)return".";p=a}return t.slice(0,p)},basename(t,d){d!==void 0&&v(d,"ext"),v(t,"path");let a=0,h=-1,o=!0,p;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(a=2),d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let f=d.length-1,D=-1;for(p=t.length-1;p>=a;--p){const b=t.charCodeAt(p);if(g(b)){if(!o){a=p+1;break}}else D===-1&&(o=!1,D=p+1),f>=0&&(b===d.charCodeAt(f)?--f===-1&&(h=p):(f=-1,h=D))}return a===h?h=D:h===-1&&(h=t.length),t.slice(a,h)}for(p=t.length-1;p>=a;--p)if(g(t.charCodeAt(p))){if(!o){a=p+1;break}}else h===-1&&(o=!1,h=p+1);return h===-1?"":t.slice(a,h)},extname(t){v(t,"path");let d=0,a=-1,h=0,o=-1,p=!0,f=0;t.length>=2&&t.charCodeAt(1)===L&&n(t.charCodeAt(0))&&(d=h=2);for(let D=t.length-1;D>=d;--D){const b=t.charCodeAt(D);if(g(b)){if(!p){h=D+1;break}continue}o===-1&&(p=!1,o=D+1),b===w?a===-1?a=D:f!==1&&(f=1):a!==-1&&(f=-1)}return a===-1||o===-1||f===0||f===1&&a===o-1&&a===h+1?"":t.slice(a,o)},format:s.bind(null,"\\"),parse(t){v(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const a=t.length;let h=0,o=t.charCodeAt(0);if(a===1)return g(o)?(d.root=d.dir=t,d):(d.base=d.name=t,d);if(g(o)){if(h=1,g(t.charCodeAt(1))){let P=2,I=P;for(;P<a&&!g(t.charCodeAt(P));)P++;if(P<a&&P!==I){for(I=P;P<a&&g(t.charCodeAt(P));)P++;if(P<a&&P!==I){for(I=P;P<a&&!g(t.charCodeAt(P));)P++;P===a?h=P:P!==I&&(h=P+1)}}}}else if(n(o)&&t.charCodeAt(1)===L){if(a<=2)return d.root=d.dir=t,d;if(h=2,g(t.charCodeAt(2))){if(a===3)return d.root=d.dir=t,d;h=3}}h>0&&(d.root=t.slice(0,h));let p=-1,f=h,D=-1,b=!0,k=t.length-1,E=0;for(;k>=h;--k){if(o=t.charCodeAt(k),g(o)){if(!b){f=k+1;break}continue}D===-1&&(b=!1,D=k+1),o===w?p===-1?p=k:E!==1&&(E=1):p!==-1&&(E=-1)}return D!==-1&&(p===-1||E===0||E===1&&p===D-1&&p===f+1?d.base=d.name=t.slice(f,D):(d.name=t.slice(f,p),d.base=t.slice(f,D),d.ext=t.slice(p,D))),f>0&&f!==h?d.dir=t.slice(0,f-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const r=(()=>{if(l){const t=/\\/g;return()=>{const d=u.cwd().replace(t,"/");return d.slice(d.indexOf("/"))}}return()=>u.cwd()})();e.$hc={resolve(...t){let d="",a=!1;for(let h=t.length-1;h>=-1&&!a;h--){const o=h>=0?t[h]:r();v(o,"path"),o.length!==0&&(d=`${o}/${d}`,a=o.charCodeAt(0)===$)}return d=i(d,!a,"/",c),a?`/${d}`:d.length>0?d:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===$,a=t.charCodeAt(t.length-1)===$;return t=i(t,!d,"/",c),t.length===0?d?"/":a?"./":".":(a&&(t+="/"),d?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let d;for(let a=0;a<t.length;++a){const h=t[a];v(h,"path"),h.length>0&&(d===void 0?d=h:d+=`/${h}`)}return d===void 0?".":e.$hc.normalize(d)},relative(t,d){if(v(t,"from"),v(d,"to"),t===d||(t=e.$hc.resolve(t),d=e.$hc.resolve(d),t===d))return"";const a=1,h=t.length,o=h-a,p=1,f=d.length-p,D=o<f?o:f;let b=-1,k=0;for(;k<D;k++){const P=t.charCodeAt(a+k);if(P!==d.charCodeAt(p+k))break;P===$&&(b=k)}if(k===D)if(f>D){if(d.charCodeAt(p+k)===$)return d.slice(p+k+1);if(k===0)return d.slice(p+k)}else o>D&&(t.charCodeAt(a+k)===$?b=k:k===0&&(b=0));let E="";for(k=a+b+1;k<=h;++k)(k===h||t.charCodeAt(k)===$)&&(E+=E.length===0?"..":"/..");return`${E}${d.slice(p+b)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===$;let a=-1,h=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===$){if(!h){a=o;break}}else h=!1;return a===-1?d?"/":".":d&&a===1?"//":t.slice(0,a)},basename(t,d){d!==void 0&&v(d,"ext"),v(t,"path");let a=0,h=-1,o=!0,p;if(d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let f=d.length-1,D=-1;for(p=t.length-1;p>=0;--p){const b=t.charCodeAt(p);if(b===$){if(!o){a=p+1;break}}else D===-1&&(o=!1,D=p+1),f>=0&&(b===d.charCodeAt(f)?--f===-1&&(h=p):(f=-1,h=D))}return a===h?h=D:h===-1&&(h=t.length),t.slice(a,h)}for(p=t.length-1;p>=0;--p)if(t.charCodeAt(p)===$){if(!o){a=p+1;break}}else h===-1&&(o=!1,h=p+1);return h===-1?"":t.slice(a,h)},extname(t){v(t,"path");let d=-1,a=0,h=-1,o=!0,p=0;for(let f=t.length-1;f>=0;--f){const D=t.charCodeAt(f);if(D===$){if(!o){a=f+1;break}continue}h===-1&&(o=!1,h=f+1),D===w?d===-1?d=f:p!==1&&(p=1):d!==-1&&(p=-1)}return d===-1||h===-1||p===0||p===1&&d===h-1&&d===a+1?"":t.slice(d,h)},format:s.bind(null,"/"),parse(t){v(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const a=t.charCodeAt(0)===$;let h;a?(d.root="/",h=1):h=0;let o=-1,p=0,f=-1,D=!0,b=t.length-1,k=0;for(;b>=h;--b){const E=t.charCodeAt(b);if(E===$){if(!D){p=b+1;break}continue}f===-1&&(D=!1,f=b+1),E===w?o===-1?o=b:k!==1&&(k=1):o!==-1&&(k=-1)}if(f!==-1){const E=p===0&&a?1:p;o===-1||k===0||k===1&&o===f-1&&o===p+1?d.base=d.name=t.slice(E,f):(d.name=t.slice(E,o),d.base=t.slice(E,f),d.ext=t.slice(o,f))}return p>0?d.dir=t.slice(0,p-1):a&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=l?e.$gc.normalize:e.$hc.normalize,e.$jc=l?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=l?e.$gc.join:e.$hc.join,e.$lc=l?e.$gc.resolve:e.$hc.resolve,e.$mc=l?e.$gc.relative:e.$hc.relative,e.$nc=l?e.$gc.dirname:e.$hc.dirname,e.$oc=l?e.$gc.basename:e.$hc.basename,e.$pc=l?e.$gc.extname:e.$hc.extname,e.$qc=l?e.$gc.format:e.$hc.format,e.$rc=l?e.$gc.parse:e.$hc.parse,e.$sc=l?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=l?e.$gc.sep:e.$hc.sep,e.$uc=l?e.$gc.delimiter:e.$hc.delimiter}),define(ke[131],Se([1,0,46,17]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=w,e.$cr=$,e.$dr=S,e.$er=L,e.$fr=C,e.$gr=m,e.$hr=y,e.$ir=v,e.$jr=l,e.$kr=g,e.$lr=o,e.$mr=p,e.$nr=f;const M=new u.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),A=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(D,b,k=!1){const E=D||"",P=b||"",I=M.value.collator.compare(E,P);return M.value.collatorIsNumeric&&I===0&&E!==P?E<P?-1:1:I}function $(D,b){const k=A.value.collator;return D=D||"",b=b||"",s(k,D,b)}function S(D,b){const k=A.value.collator;return D=D||"",b=b||"",a(D,b)||s(k,D,b)}function L(D,b){const k=A.value.collator;return D=D||"",b=b||"",d(D,b)||s(k,D,b)}function C(D,b){return D=D||"",b=b||"",D===b?0:D<b?-1:1}function m(D,b){const[k,E]=n(D),[P,I]=n(b);let F=M.value.collator.compare(E,I);if(F===0){if(M.value.collatorIsNumeric&&E!==I)return E<I?-1:1;if(F=M.value.collator.compare(k,P),M.value.collatorIsNumeric&&F===0&&k!==P)return k<P?-1:1}return F}function y(D,b){D=D||"",b=b||"";const k=i(D),E=i(b),P=A.value.collator,I=R.value.collator;return s(I,k,E)||s(P,D,b)}function v(D,b){D=D||"",b=b||"";const k=i(D),E=i(b),P=A.value.collator,I=R.value.collator;return s(I,k,E)||a(D,b)||s(P,D,b)}function l(D,b){D=D||"",b=b||"";const k=i(D),E=i(b),P=A.value.collator,I=R.value.collator;return s(I,k,E)||d(D,b)||s(P,D,b)}function g(D,b){D=D||"",b=b||"";const k=i(D).toLowerCase(),E=i(b).toLowerCase();return k!==E?k<E?-1:1:D!==b?D<b?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function n(D,b=!1){const k=D?c.exec(D):[];let E=[k&&k[1]||"",k&&k[3]||""];return b&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function i(D){const b=D?c.exec(D):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function s(D,b,k){const E=D.compare(b,k);return E!==0?E:b.length!==k.length?b.length<k.length?-1:1:0}function r(D){const b=D.charAt(0);return b.toLocaleUpperCase()!==b}function t(D){const b=D.charAt(0);return b.toLocaleLowerCase()!==b}function d(D,b){return r(D)&&t(b)?-1:t(D)&&r(b)?1:0}function a(D,b){return t(D)&&r(b)?-1:r(D)&&t(b)?1:0}function h(D,b,k=!1){return k||(D=D&&D.toLowerCase(),b=b&&b.toLowerCase()),D===b?0:D<b?-1:1}function o(D,b,k=!1){const E=D.split(N.sep),P=b.split(N.sep),I=E.length-1,F=P.length-1;let j,z;for(let O=0;;O++){if(j=I===O,z=F===O,j&&z)return w(E[O],P[O],k);if(j)return-1;if(z)return 1;const T=h(E[O],P[O],k);if(T!==0)return T}}function p(D,b,k){const E=D.toLowerCase(),P=b.toLowerCase(),I=f(D,b,k);if(I)return I;const F=E.endsWith(k),j=P.endsWith(k);if(F!==j)return F?-1:1;const z=w(E,P);return z!==0?z:E.localeCompare(P)}function f(D,b,k){const E=D.toLowerCase(),P=b.toLowerCase(),I=E.startsWith(k),F=P.startsWith(k);if(I!==F)return I?-1:1;if(I&&F){if(E.length<P.length)return-1;if(E.length>P.length)return 1}return 0}}),define(ke[34],Se([1,0,17,11,14,18]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=R,e.$lg=w,e.$mg=$,e.$ng=S,e.$og=L,e.$pg=v,e.$qg=l,e.$rg=g,e.$sg=c,e.$tg=n,e.$ug=i,e.$vg=s,e.$wg=r,e.$xg=t,e.$yg=d,e.$zg=o;function R(p){return p===47||p===92}function w(p){return p.replace(/[\\/]/g,u.$hc.sep)}function $(p){return p.indexOf("/")===-1&&(p=w(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function S(p,f=u.$hc.sep){if(!p)return"";const D=p.length,b=p.charCodeAt(0);if(R(b)){if(R(p.charCodeAt(1))&&!R(p.charCodeAt(2))){let E=3;const P=E;for(;E<D&&!R(p.charCodeAt(E));E++);if(P!==E&&!R(p.charCodeAt(E+1))){for(E+=1;E<D;E++)if(R(p.charCodeAt(E)))return p.slice(0,E+1).replace(/[\\/]/g,f)}}return f}else if(c(b)&&p.charCodeAt(1)===58)return R(p.charCodeAt(2))?p.slice(0,2)+f:p.slice(0,2);let k=p.indexOf("://");if(k!==-1){for(k+=3;k<D;k++)if(R(p.charCodeAt(k)))return p.slice(0,k+1)}return""}function L(p){if(!N.$i||!p||p.length<5)return!1;let f=p.charCodeAt(0);if(f!==92||(f=p.charCodeAt(1),f!==92))return!1;let D=2;const b=D;for(;D<p.length&&(f=p.charCodeAt(D),f!==92);D++);return!(b===D||(f=p.charCodeAt(D+1),isNaN(f)||f===92))}const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(p,f=N.$i){const D=f?C:m;return!(!p||p.length===0||/^\s+$/.test(p)||(D.lastIndex=0,D.test(p))||f&&y.test(p)||p==="."||p===".."||f&&p[p.length-1]==="."||f&&p.length!==p.trim().length||p.length>255)}function l(p,f,D){const b=p===f;return!D||b?b:!p||!f?!1:(0,M.$uf)(p,f)}function g(p,f,D,b=u.sep){if(p===f)return!0;if(!p||!f||f.length>p.length)return!1;if(D){if(!(0,M.$vf)(p,f))return!1;if(f.length===p.length)return!0;let E=f.length;return f.charAt(f.length-1)===b&&E--,p.charAt(E)===b}return f.charAt(f.length-1)!==b&&(f+=b),p.indexOf(f)===0}function c(p){return p>=65&&p<=90||p>=97&&p<=122}function n(p,f){return N.$i&&p.endsWith(":")&&(p+=u.sep),(0,u.$jc)(p)||(p=(0,u.$kc)(f,p)),p=(0,u.$ic)(p),N.$i?(p=(0,M.$cf)(p,u.sep),p.endsWith(":")&&(p+=u.sep)):(p=(0,M.$cf)(p,u.sep),p||(p=u.sep)),p}function i(p){const f=(0,u.$ic)(p);return N.$i?p.length>3?!1:s(f)&&(p.length===2||f.charCodeAt(2)===92):f===u.$hc.sep}function s(p,f=N.$i){return f?c(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}function r(p,f=N.$i){return s(p,f)?p[0]:void 0}function t(p,f,D){return f.length>p.length?-1:p===f?0:(D&&(p=p.toLowerCase(),f=f.toLowerCase()),p.indexOf(f))}function d(p){const f=p.split(":");let D,b,k;for(const E of f){const P=Number(E);(0,A.$9f)(P)?b===void 0?b=P:k===void 0&&(k=P):D=D?[D,E].join(":"):E}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:b!==void 0?b:void 0,column:k!==void 0?k:b!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(p,f,D=8){let b="";for(let E=0;E<D;E++){let P;E===0&&N.$i&&!f&&(D===3||D===4)?P=h:P=a,b+=P.charAt(Math.floor(Math.random()*P.length))}let k;return f?k=`${f}-${b}`:k=b,p?(0,u.$kc)(p,k):k}}),define(ke[132],Se([1,0,131,126,56,17,11,14]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=L,e.$pr=g,e.$qr=a,e.$rr=k,e.$sr=z,e.$tr=T;const $=0,S=[$,[]];function L(B,W,X,Z){if(!B||!W)return S;const Y=B.length,x=W.length;if(Y<x)return S;const ne=B.toLowerCase();return C(W,X,x,B,ne,Y,Z)}function C(B,W,X,Z,Y,x,ne){const ge=[],ue=[];for(let _=0;_<X;_++){const be=_*x,Pe=be-x,se=_>0,re=B[_],oe=W[_];for(let K=0;K<x;K++){const ie=K>0,$e=be+K,we=$e-1,Le=Pe+K-1,fe=ie?ge[we]:0,De=se&&ie?ge[Le]:0,Ie=se&&ie?ue[Le]:0;let Te;!De&&se?Te=0:Te=m(re,oe,Z,Y,K,Ie),Te&&De+Te>=fe&&(ne||se||Y.startsWith(W,K))?(ue[$e]=Ie+1,ge[$e]=De+Te):(ue[$e]=$,ge[$e]=fe)}}const ve=[];let te=X-1,U=x-1;for(;te>=0&&U>=0;){const _=te*x+U;ue[_]===$||(ve.push(U),te--),U--}return[ge[X*x-1],ve.reverse()]}function m(B,W,X,Z,Y,x){let ne=0;if(!y(W,Z[Y]))return ne;if(ne+=1,x>0&&(ne+=x*5),B===X[Y]&&(ne+=1),Y===0)ne+=8;else{const ge=v(X.charCodeAt(Y-1));ge?ne+=ge:(0,N.$wk)(X.charCodeAt(Y))&&x===0&&(ne+=2)}return ne}function y(B,W){return B===W?!0:B==="/"||B==="\\"?W==="/"||W==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function g(B,W,X=0,Z=0){const Y=W;return Y.values&&Y.values.length>1?c(B,Y.values,X,Z):n(B,W,X,Z)}function c(B,W,X,Z){let Y=0;const x=[];for(const ne of W){const[ge,ue]=n(B,ne,X,Z);if(typeof ge!="number")return l;Y+=ge,x.push(...ue)}return[Y,D(x)]}function n(B,W,X,Z){const Y=(0,N.$Fk)(W.original,W.originalLowercase,X,B,B.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,N.$Ck)(Y)]:l}const i=Object.freeze({score:0}),s=1<<18,r=1<<17,t=65536;function d(B,W,X,Z){const Y=Z.values?Z.values:[Z];return(0,M.$fj)({[Z.normalized]:{values:Y.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:B,description:W,allowNonContiguousMatches:X}})}function a(B,W,X,Z,Y){if(!B||!W.normalized)return i;const x=Z.getItemLabel(B);if(!x)return i;const ne=Z.getItemDescription(B),ge=d(x,ne,X,W),ue=Y[ge];if(ue)return ue;const ve=h(x,ne,Z.getItemPath(B),W,X);return Y[ge]=ve,ve}function h(B,W,X,Z,Y){const x=!X||!Z.containsPathSeparator;return X&&(R.$k?Z.pathNormalized===X:(0,w.$uf)(Z.pathNormalized,X))?{score:s,labelMatch:[{start:0,end:B.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:Z.values&&Z.values.length>1?o(B,W,X,Z.values,x,Y):p(B,W,X,Z,x,Y)}function o(B,W,X,Z,Y,x){let ne=0;const ge=[],ue=[];for(const ve of Z){const{score:te,labelMatch:U,descriptionMatch:_}=p(B,W,X,ve,Y,x);if(te===$)return i;ne+=te,U&&ge.push(...U),_&&ue.push(..._)}return{score:ne,labelMatch:D(ge),descriptionMatch:D(ue)}}function p(B,W,X,Z,Y,x){if(Y||!W){const[ne,ge]=L(B,Z.normalized,Z.normalizedLowercase,x&&!Z.expectContiguousMatch);if(ne){const ue=(0,N.$tk)(Z.normalized,B);let ve;if(ue){ve=r;const te=Math.round(Z.normalized.length/B.length*100);ve+=te}else ve=t;return{score:ve+ne,labelMatch:ue||f(ge)}}}if(W){let ne=W;X&&(ne=`${W}${A.sep}`);const ge=ne.length,ue=`${ne}${B}`,[ve,te]=L(ue,Z.normalized,Z.normalizedLowercase,x&&!Z.expectContiguousMatch);if(ve){const U=f(te),_=[],be=[];return U.forEach(Pe=>{Pe.start<ge&&Pe.end>ge?(_.push({start:0,end:Pe.end-ge}),be.push({start:Pe.start,end:ge})):Pe.start>=ge?_.push({start:Pe.start-ge,end:Pe.end-ge}):be.push(Pe)}),{score:ve,labelMatch:_,descriptionMatch:be}}}return i}function f(B){const W=[];if(!B)return W;let X;for(const Z of B)X&&X.end===Z?X.end+=1:(X={start:Z,end:Z+1},W.push(X));return W}function D(B){const W=B.sort((Y,x)=>Y.start-x.start),X=[];let Z;for(const Y of W)!Z||!b(Z,Y)?(Z=Y,X.push(Y)):(Z.start=Math.min(Z.start,Y.start),Z.end=Math.max(Z.end,Y.end));return X}function b(B,W){return!(B.end<W.start||W.end<B.start)}function k(B,W,X,Z,Y,x){const ne=a(B,X,Z,Y,x),ge=a(W,X,Z,Y,x),ue=ne.score,ve=ge.score;if((ue===s||ve===s)&&ue!==ve)return ue===s?-1:1;if(ue>t||ve>t){if(ue!==ve)return ue>ve?-1:1;if(ue<r&&ve<r){const re=P(ne.labelMatch,ge.labelMatch);if(re!==0)return re}const Pe=Y.getItemLabel(B)||"",se=Y.getItemLabel(W)||"";if(Pe.length!==se.length)return Pe.length-se.length}if(ue!==ve)return ue>ve?-1:1;const te=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,U=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(te&&!U)return-1;if(U&&!te)return 1;const _=E(B,ne,Y),be=E(W,ge,Y);return _&&be&&_!==be?be>_?-1:1:I(B,W,X,Y)}function E(B,W,X){let Z=-1,Y=-1;if(W.descriptionMatch&&W.descriptionMatch.length?Z=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(Z=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(Y=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const x=X.getItemDescription(B);x&&(Y+=x.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(Y=W.descriptionMatch[W.descriptionMatch.length-1].end);return Y-Z}function P(B,W){if(!B&&!W||(!B||!B.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!B||!B.length)return 1;const X=B[0].start,Y=B[B.length-1].end-X,x=W[0].start,ge=W[W.length-1].end-x;return Y===ge?0:ge<Y?1:-1}function I(B,W,X,Z){const Y=Z.getItemLabel(B)||"",x=Z.getItemLabel(W)||"",ne=Z.getItemDescription(B),ge=Z.getItemDescription(W),ue=Y.length+(ne?ne.length:0),ve=x.length+(ge?ge.length:0);if(ue!==ve)return ue-ve;const te=Z.getItemPath(B),U=Z.getItemPath(W);return te&&U&&te.length!==U.length?te.length-U.length:Y!==x?(0,u.$mr)(Y,x,X.normalized):ne&&ge&&ne!==ge?(0,u.$mr)(ne,ge,X.normalized):te&&U&&te!==U?(0,u.$mr)(te,U,X.normalized):0}function F(B){return B.startsWith('"')&&B.endsWith('"')}const j=" ";function z(B){typeof B!="string"&&(B="");const W=B.toLowerCase(),{pathNormalized:X,normalized:Z,normalizedLowercase:Y}=O(B),x=X.indexOf(A.sep)>=0,ne=F(B);let ge;const ue=B.split(j);if(ue.length>1)for(const ve of ue){const te=F(ve),{pathNormalized:U,normalized:_,normalizedLowercase:be}=O(ve);_&&(ge||(ge=[]),ge.push({original:ve,originalLowercase:ve.toLowerCase(),pathNormalized:U,normalized:_,normalizedLowercase:be,expectContiguousMatch:te}))}return{original:B,originalLowercase:W,pathNormalized:X,normalized:Z,normalizedLowercase:Y,values:ge,containsPathSeparator:x,expectContiguousMatch:ne}}function O(B){let W;R.$i?W=B.replace(/\//g,A.sep):W=B.replace(/\\/g,A.sep);const X=(0,w.$ef)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:X,normalizedLowercase:X.toLowerCase()}}function T(B){return Array.isArray(B)?z(B.map(W=>W.original).join(j)):z(B.original)}}),define(ke[101],Se([1,0,17]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=void 0,e.$Ls=A,e.$Ms=R,e.$Ns=w,e.$Os=S,e.$Ks=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(L){const C=(0,u.$pc)(L),m=N[C.toLowerCase()];return m!==void 0?m:R(L)}function R(L){const C=(0,u.$pc)(L);return M[C.toLowerCase()]}function w(L){for(const C in M)if(M[C]===L)return C}const $=/^(.+)\/(.+?)(;.+)?$/;function S(L,C){const m=$.exec(L);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:L}}),define(ke[102],Se([1,0,11]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=A,e.$im=R;var N;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(N||(e.Source=N={}));var M;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(M||(e.TerminateResponseCode=M={}));function A(w,...$){const S=$.reduce((m,y)=>(m[y]=!0,m),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(m=>!S[m]).forEach(m=>{for(let y=0;y<L.length;y++)if(m.search(L[y])!==-1){delete w[m];break}})}function R(w){w&&(delete w.DEBUG,u.$j&&delete w.DYLD_LIBRARY_PATH,u.$k&&delete w.LD_PRELOAD)}}),define(ke[2],Se([1,0,17,11]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=v,e.$xc=s;const M=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function w(h,o){if(!h.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!M.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!A.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(h,o){return!h&&!o?"file":h}function S(h,o){switch(h){case"https":case"http":case"file":o?o[0]!==C&&(o=C+o):o=C;break}return o}const L="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(o){return o instanceof y?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,p,f,D,b,k=!1){typeof o=="object"?(this.scheme=o.scheme||L,this.authority=o.authority||L,this.path=o.path||L,this.query=o.query||L,this.fragment=o.fragment||L):(this.scheme=$(o,k),this.authority=p||L,this.path=S(this.scheme,f||L),this.query=D||L,this.fragment=b||L,w(this,k))}get fsPath(){return s(this,!1)}with(o){if(!o)return this;let{scheme:p,authority:f,path:D,query:b,fragment:k}=o;return p===void 0?p=this.scheme:p===null&&(p=L),f===void 0?f=this.authority:f===null&&(f=L),D===void 0?D=this.path:D===null&&(D=L),b===void 0?b=this.query:b===null&&(b=L),k===void 0?k=this.fragment:k===null&&(k=L),p===this.scheme&&f===this.authority&&D===this.path&&b===this.query&&k===this.fragment?this:new g(p,f,D,b,k)}static parse(o,p=!1){const f=m.exec(o);return f?new g(f[2]||L,a(f[4]||L),a(f[5]||L),a(f[7]||L),a(f[9]||L),p):new g(L,L,L,L,L)}static file(o){let p=L;if(N.$i&&(o=o.replace(/\\/g,C)),o[0]===C&&o[1]===C){const f=o.indexOf(C,2);f===-1?(p=o.substring(2),o=C):(p=o.substring(2,f),o=o.substring(f)||C)}return new g("file",p,o,L,L)}static from(o,p){return new g(o.scheme,o.authority,o.path,o.query,o.fragment,p)}static joinPath(o,...p){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return N.$i&&o.scheme==="file"?f=y.file(u.$gc.join(s(o,!0),...p)).path:f=u.$hc.join(o.path,...p),o.with({path:f})}toString(o=!1){return r(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof y)return o;{const p=new g(o);return p._formatted=o.external??null,p._fsPath=o._sep===l?o.fsPath??null:null,p}}else return o}}e.URI=y;function v(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const l=N.$i?1:void 0;class g extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(o=!1){return o?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=l),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(h,o,p){let f,D=-1;for(let b=0;b<h.length;b++){const k=h.charCodeAt(b);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||o&&k===47||p&&k===91||p&&k===93||p&&k===58)D!==-1&&(f+=encodeURIComponent(h.substring(D,b)),D=-1),f!==void 0&&(f+=h.charAt(b));else{f===void 0&&(f=h.substr(0,b));const E=c[k];E!==void 0?(D!==-1&&(f+=encodeURIComponent(h.substring(D,b)),D=-1),f+=E):D===-1&&(D=b)}}return D!==-1&&(f+=encodeURIComponent(h.substring(D))),f!==void 0?f:h}function i(h){let o;for(let p=0;p<h.length;p++){const f=h.charCodeAt(p);f===35||f===63?(o===void 0&&(o=h.substr(0,p)),o+=c[f]):o!==void 0&&(o+=h[p])}return o!==void 0?o:h}function s(h,o){let p;return h.authority&&h.path.length>1&&h.scheme==="file"?p=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?o?p=h.path.substr(1):p=h.path[1].toLowerCase()+h.path.substr(2):p=h.path,N.$i&&(p=p.replace(/\//g,"\\")),p}function r(h,o){const p=o?i:n;let f="",{scheme:D,authority:b,path:k,query:E,fragment:P}=h;if(D&&(f+=D,f+=":"),(b||D==="file")&&(f+=C,f+=C),b){let I=b.indexOf("@");if(I!==-1){const F=b.substr(0,I);b=b.substr(I+1),I=F.lastIndexOf(":"),I===-1?f+=p(F,!1,!1):(f+=p(F.substr(0,I),!1,!1),f+=":",f+=p(F.substr(I+1),!1,!0)),f+="@"}b=b.toLowerCase(),I=b.lastIndexOf(":"),I===-1?f+=p(b,!1,!0):(f+=p(b.substr(0,I),!1,!0),f+=b.substr(I))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const I=k.charCodeAt(1);I>=65&&I<=90&&(k=`/${String.fromCharCode(I+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const I=k.charCodeAt(0);I>=65&&I<=90&&(k=`${String.fromCharCode(I+32)}:${k.substr(2)}`)}f+=p(k,!0,!1)}return E&&(f+="?",f+=p(E,!1,!1)),P&&(f+="#",f+=o?P:n(P,!1,!1)),f}function t(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+t(h.substr(3)):h}}const d=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(h){return h.match(d)?h.replace(d,o=>t(o)):h}}),define(ke[192],Se([1,0,2]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=N,e.$Rq=M,e.$Sq=A,e.log=w;function N(S){const L=S;return L&&typeof L.type=="string"&&typeof L.severity=="string"}function M(S){const L=[];let C;try{const m=JSON.parse(S.arguments),y=m[m.length-1];y&&y.__$stack&&(m.pop(),C=y.__$stack),L.push(...m)}catch{L.push("Unable to log remote console arguments",S.arguments)}return{args:L,stack:C}}function A(S){if(typeof S!="string")return A(M(S).stack);const L=S;if(L){const C=R(L),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:u.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function R(S){if(!S)return S;const L=S.indexOf(`
`);return L===-1?S:S.substring(0,L)}function w(S,L){const{args:C,stack:m}=M(S),y=typeof C[0]=="string"&&C.length===1;let v=R(m);v&&(v=`(${v.trim()})`);let l=[];if(typeof C[0]=="string"?v&&y?l=[`%c[${L}] %c${C[0]} %c${v}`,$("blue"),$(""),$("grey")]:l=[`%c[${L}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:l=[`%c[${L}]%`,$("blue"),...C],v&&!y&&l.push(v),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,l)}function $(S){return`color: ${S}`}}),define(ke[58],Se([1,0,21,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=M,e.$Zh=A,e.$1h=w;function M($){return JSON.stringify($,R)}function A($){let S=JSON.parse($);return S=w(S),S}function R($,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:S.flags}:S}function w($,S=0){if(!$||S>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return N.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof u.$Ce||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let L=0;L<$.length;++L)$[L]=w($[L],S+1);else for(const L in $)Object.hasOwnProperty.call($,L)&&($[L]=w($[L],S+1))}return $}}),define(ke[15],Se([1,0,13,11,14,2,17]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Eg=e.$Dg=e.$Cg=e.Schemas=void 0,e.$Ag=$,e.$Bg=S,e.$Fg=C;var w;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting"})(w||(e.Schemas=w={}));function $(v,l){return A.URI.isUri(v)?(0,M.$uf)(v.scheme,l):(0,M.$vf)(v,l+":")}function S(v,...l){return l.some(g=>$(v,g))}e.$Cg="vscode-tkn",e.$Dg="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l,g){this.f=C(l,g)}getServerRootPath(){return this.f}get g(){return R.$hc.join(this.f,w.vscodeRemoteResource)}set(l,g,c){this.a[l]=g,this.b[l]=c}setConnectionToken(l,g){this.c[l]=g}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(r){return u.$1(r),l}const g=l.authority;let c=this.a[g];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const n=this.b[g],i=this.c[g];let s=`path=${encodeURIComponent(l.path)}`;return typeof i=="string"&&(s+=`&${e.$Dg}=${encodeURIComponent(i)}`),A.URI.from({scheme:N.$o?this.d:w.vscodeRemoteResource,authority:`${c}:${n}`,path:this.g,query:s})}}e.$Eg=new L;function C(v,l){return R.$hc.join(l??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Gg="vs/../../extensions",e.$Hg="vs/../../node_modules",e.$Ig="vs/../../node_modules.asar",e.$Jg="vs/../../node_modules.asar.unpacked",e.$Kg="vscode-app";class m{static{this.a=e.$Kg}asBrowserUri(l){const g=this.b(l,le);return this.uriToBrowserUri(g)}uriToBrowserUri(l){return l.scheme===w.vscodeRemote?e.$Eg.rewrite(l):l.scheme===w.file&&(N.$m||N.$q===`${w.vscodeFileResource}://${m.a}`)?l.with({scheme:w.vscodeFileResource,authority:l.authority||m.a,query:null,fragment:null}):l}asFileUri(l){const g=this.b(l,le);return this.uriToFileUri(g)}uriToFileUri(l){return l.scheme===w.vscodeFileResource?l.with({scheme:w.file,authority:l.authority!==m.a?l.authority:null,query:null,fragment:null}):l}b(l,g){return A.URI.isUri(l)?l:A.URI.parse(g.toUrl(l))}}e.$Lg=new m;var y;(function(v){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(l.get("3"));const g="vscode-coi";function c(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:A.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const r=s?.get(g);if(r)return l.get(r)}v.getHeadersFromQuery=c;function n(i,s,r){if(!globalThis.crossOriginIsolated)return;const t=s&&r?"3":r?"2":"1";i instanceof URLSearchParams?i.set(g,t):i[g]=t}v.addSearchParam=n})(y||(e.COI=y={}))}),define(ke[193],Se([1,0,162,15,11,2]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TD=L;class R{constructor(m,y,v){this.id=m,this.dependencies=y,this.callback=v}}class w{static{this.INSTANCE=new w}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,y,v)=>{typeof m!="string"&&(v=y,y=m,m=null),(typeof y!="object"||!Array.isArray(y))&&(v=y,y=null),this.c.push(new R(m,y,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const y=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!y)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(m){return new Promise((y,v)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const g=()=>{l.removeEventListener("load",c),l.removeEventListener("error",n)},c=i=>{g(),y(this.c.pop())},n=i=>{g(),v(i)};l.addEventListener("load",c),l.addEventListener("error",n),this.f&&(m=this.f.createScriptURL(m)),l.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(l)})}i(m){return new Promise((y,v)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),y(this.c.pop())}catch(l){v(l)}})}async j(m){try{const y=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,g=A.URI.parse(m).fsPath,c=y.readFileSync(g).toString(),n=l.wrap(c.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const $=new Map;let S={};typeof globalThis.require=="object"&&(S=globalThis.require.paths??{});async function L(C,m,y){if(u.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),S[C]&&(C=S[C]);const v=`${C}/${m}`;if($.has(v))return $.get(v);let l;if(/^\w[\w\d+.-]*:\/\//.test(v))l=v;else{const i=`${y&&!M.$o?N.$Ig:N.$Hg}/${v}`;l=N.$Lg.asBrowserUri(i).toString(!0)}const g=w.INSTANCE.load(l);return $.set(v,g),g}else return await new Promise((v,l)=>{le([C],v,l)})}}),define(ke[23],Se([1,0,34,15,17,11,14,2]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0,e.$Sg=$,e.$bh=L,e.$ch=m;function $(y){return(0,w.$xc)(y,!0)}class S{constructor(v){this.a=v}compare(v,l,g=!1){return v===l?0:(0,R.$nf)(this.getComparisonKey(v,g),this.getComparisonKey(l,g))}isEqual(v,l,g=!1){return v===l?!0:!v||!l?!1:this.getComparisonKey(v,g)===this.getComparisonKey(l,g)}getComparisonKey(v,l=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,l,g=!1){if(v.scheme===l.scheme){if(v.scheme===N.Schemas.file)return u.$rg($(v),$(l),this.a(v))&&v.query===l.query&&(g||v.fragment===l.fragment);if((0,e.$0g)(v.authority,l.authority))return u.$rg(v.path,l.path,this.a(v),"/")&&v.query===l.query&&(g||v.fragment===l.fragment)}return!1}joinPath(v,...l){return w.URI.joinPath(v,...l)}basenameOrAuthority(v){return(0,e.$2g)(v)||v.authority}basename(v){return M.$hc.basename(v.path)}extname(v){return M.$hc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let l;return v.scheme===N.Schemas.file?l=w.URI.file(M.$nc($(v))).path:(l=M.$hc.dirname(v.path),v.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),l="/")),v.with({path:l})}normalizePath(v){if(!v.path.length)return v;let l;return v.scheme===N.Schemas.file?l=w.URI.file(M.$ic($(v))).path:l=M.$hc.normalize(v.path),v.with({path:l})}relativePath(v,l){if(v.scheme!==l.scheme||!(0,e.$0g)(v.authority,l.authority))return;if(v.scheme===N.Schemas.file){const n=M.$mc($(v),$(l));return A.$i?u.$lg(n):n}let g=v.path||"/";const c=l.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(g.length,c.length);n<i&&!(g.charCodeAt(n)!==c.charCodeAt(n)&&g.charAt(n).toLowerCase()!==c.charAt(n).toLowerCase());n++);g=c.substr(0,n)+g.substr(n)}return M.$hc.relative(g,c)}resolvePath(v,l){if(v.scheme===N.Schemas.file){const g=w.URI.file(M.$lc($(v),l));return v.with({authority:g.authority,path:g.path})}return l=u.$mg(l),v.with({path:M.$hc.resolve(v.path,l)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,l){return v===l||v!==void 0&&l!==void 0&&(0,R.$uf)(v,l)}hasTrailingPathSeparator(v,l=M.sep){if(v.scheme===N.Schemas.file){const g=$(v);return g.length>u.$ng(g).length&&g[g.length-1]===l}else{const g=v.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,l=M.sep){return(0,e.$$g)(v,l)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,l=M.sep){let g=!1;if(v.scheme===N.Schemas.file){const c=$(v);g=c!==void 0&&c.length===u.$ng(c).length&&c[c.length-1]===l}else{l="/";const c=v.path;g=c.length===1&&c.charCodeAt(c.length-1)===47}return!g&&!(0,e.$$g)(v,l)?v.with({path:v.path+"/"}):v}}e.$Tg=S,e.$Ug=new S(()=>!1),e.$Vg=new S(y=>y.scheme===N.Schemas.file?!A.$k:!0),e.$Wg=new S(y=>!0),e.$Xg=e.$Ug.isEqual.bind(e.$Ug),e.$Yg=e.$Ug.isEqualOrParent.bind(e.$Ug),e.$Zg=e.$Ug.getComparisonKey.bind(e.$Ug),e.$1g=e.$Ug.basenameOrAuthority.bind(e.$Ug),e.$2g=e.$Ug.basename.bind(e.$Ug),e.$3g=e.$Ug.extname.bind(e.$Ug),e.$4g=e.$Ug.dirname.bind(e.$Ug),e.$5g=e.$Ug.joinPath.bind(e.$Ug),e.$6g=e.$Ug.normalizePath.bind(e.$Ug),e.$7g=e.$Ug.relativePath.bind(e.$Ug),e.$8g=e.$Ug.resolvePath.bind(e.$Ug),e.$9g=e.$Ug.isAbsolutePath.bind(e.$Ug),e.$0g=e.$Ug.isEqualAuthority.bind(e.$Ug),e.$$g=e.$Ug.hasTrailingPathSeparator.bind(e.$Ug),e.$_g=e.$Ug.removeTrailingPathSeparator.bind(e.$Ug),e.$ah=e.$Ug.addTrailingPathSeparator.bind(e.$Ug);function L(y,v){const l=[];for(let g=0;g<y.length;g++){const c=v(y[g]);y.some((n,i)=>i===g?!1:(0,e.$Yg)(c,v(n)))||l.push(y[g])}return l}var C;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function v(l){const g=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(i=>{const[s,r]=i.split(":");s&&r&&g.set(s,r)});const n=l.path.substring(0,l.path.indexOf(";"));return n&&g.set(y.META_DATA_MIME,n),g}y.parseMetaData=v})(C||(e.DataUri=C={}));function m(y,v,l){if(v){let g=y.path;return g&&g[0]!==M.$hc.sep&&(g=M.$hc.sep+g),y.with({scheme:l,authority:v,path:g})}return y.with({scheme:l})}}),define(ke[8],Se([1,0,22,13,4,3,23,11,169,46]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.Promises=e.$Oh=e.$Nh=e.$Mh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0,e.$dh=L,e.$eh=C,e.$fh=m,e.$gh=y,e.$hh=v,e.$ih=l,e.$jh=g,e.$kh=c,e.$sh=p,e.$th=f,e.$uh=D,e.$vh=b,e.$wh=k,e.$Lh=Y,e.$Th=se;function L(oe){return!!oe&&typeof oe.then=="function"}function C(oe){const K=new u.$me,ie=oe(K.token),$e=new Promise((we,Le)=>{const fe=K.token.onCancellationRequested(()=>{fe.dispose(),Le(new N.$5)});Promise.resolve(ie).then(De=>{fe.dispose(),K.dispose(),we(De)},De=>{fe.dispose(),K.dispose(),Le(De)})});return new class{cancel(){K.cancel(),K.dispose()}then(we,Le){return $e.then(we,Le)}catch(we){return this.then(void 0,we)}finally(we){return $e.finally(we)}}}function m(oe,K,ie){return new Promise(($e,we)=>{const Le=K.onCancellationRequested(()=>{Le.dispose(),$e(ie)});oe.then($e,we).finally(()=>Le.dispose())})}function y(oe,K){return new Promise((ie,$e)=>{const we=K.onCancellationRequested(()=>{we.dispose(),$e(new N.$5)});oe.then(ie,$e).finally(()=>we.dispose())})}async function v(oe){let K=-1;const ie=oe.map(($e,we)=>$e.then(Le=>(K=we,Le)));try{return await Promise.race(ie)}finally{oe.forEach(($e,we)=>{we!==K&&$e.cancel()})}}function l(oe,K,ie){let $e;const we=setTimeout(()=>{$e?.(void 0),ie?.()},K);return Promise.race([oe.finally(()=>clearTimeout(we)),new Promise(Le=>$e=Le)])}function g(oe){return new Promise((K,ie)=>{const $e=oe();L($e)?$e.then(K,ie):K($e)})}function c(){let oe,K;return{promise:new Promise(($e,we)=>{oe=$e,K=we}),resolve:oe,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const ie=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(ie,ie).then($e)})}return new Promise((ie,$e)=>{this.b.then(ie,$e)})}return this.a=K(),new Promise((ie,$e)=>{this.a.then(we=>{this.a=null,ie(we)},we=>{this.a=null,$e(we)})})}dispose(){this.f=!0}}e.$lh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$mh=i;class s{constructor(){this.a=new Map}queue(K,ie){const we=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(K)===we&&this.a.delete(K)});return this.a.set(K,we),we}}e.$nh=s;const r=(oe,K)=>{let ie=!0;const $e=setTimeout(()=>{ie=!1,K()},oe);return{isTriggered:()=>ie,dispose:()=>{clearTimeout($e),ie=!1}}},t=oe=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,oe())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class d{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,ie=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((we,Le)=>{this.d=we,this.f=Le}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=ie===$.$$d?t($e):r(ie,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$oh=d;class a{constructor(K){this.a=new d(K),this.b=new n}trigger(K,ie){return this.a.trigger(()=>this.b.queue(K),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ph=a;class h{constructor(){this.a=!1,this.b=new Promise((K,ie)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$qh=h;class o extends h{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$rh=o;function p(oe,K){return K?new Promise((ie,$e)=>{const we=setTimeout(()=>{Le.dispose(),ie()},oe),Le=K.onCancellationRequested(()=>{clearTimeout(we),Le.dispose(),$e(new N.$5)})}):C(ie=>p(oe,ie))}function f(oe,K=0,ie){const $e=setTimeout(()=>{oe(),ie&&we.dispose()},K),we=(0,A.$Sc)(()=>{clearTimeout($e),ie?.deleteAndLeak(we)});return ie?.add(we),we}function D(oe){const K=[];let ie=0;const $e=oe.length;function we(){return ie<$e?oe[ie++]():null}function Le(fe){fe!=null&&K.push(fe);const De=we();return De?De.then(Le):Promise.resolve(K)}return Promise.resolve(null).then(Le)}function b(oe,K=$e=>!!$e,ie=null){let $e=0;const we=oe.length,Le=()=>{if($e>=we)return Promise.resolve(ie);const fe=oe[$e++];return Promise.resolve(fe()).then(Ie=>K(Ie)?Promise.resolve(Ie):Le())};return Le()}function k(oe,K=$e=>!!$e,ie=null){if(oe.length===0)return Promise.resolve(ie);let $e=oe.length;const we=()=>{$e=-1;for(const Le of oe)Le.cancel?.()};return new Promise((Le,fe)=>{for(const De of oe)De.then(Ie=>{--$e>=0&&K(Ie)?(we(),Le(Ie)):$e===0&&Le(ie)}).catch(Ie=>{--$e>=0&&(we(),fe(Ie))})})}class E{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new M.$be}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,$e)=>{this.g.push({factory:K,c:ie,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const ie=K.factory();ie.then(K.c,K.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$xh=E;class P extends E{constructor(){super(1)}}e.$yh=P;class I{constructor(){this.a=new x,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$zh=I;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new ue;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,ie=R.$Ug){const $e=ie.getComparisonKey(K);return this.a.get($e)?.size??0}queueFor(K,ie,$e=R.$Ug){const we=$e.getComparisonKey(K);let Le=this.a.get(we);if(!Le){Le=new P;const fe=this.f++,De=M.Event.once(Le.onDrained)(()=>{Le?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set(fe,De),this.a.set(we,Le)}return Le.queue(ie)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ah=F;class j{constructor(K,ie){this.a=-1,typeof K=="function"&&typeof ie=="number"&&this.setIfNotSet(K,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},ie)}setIfNotSet(K,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},ie))}}e.$Bh=j;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,ie,$e=globalThis){this.cancel();const we=$e.setInterval(()=>{K()},ie);this.d=(0,A.$Sc)(()=>{$e.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$Ch=z;class O{constructor(K,ie){this.b=-1,this.a=K,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Dh=O;class T{constructor(K,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=K,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Eh=T;class B extends O{constructor(K,ie){super(K,ie),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Fh=B;class W extends A.$Uc{constructor(K,ie){super(),this.g=K,this.h=ie,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of K)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Gh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ih=(oe,K)=>{(0,w.$B)(()=>{if(ie)return;const $e=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Ih=(oe,K,ie)=>{const $e=oe.requestIdleCallback(K,typeof ie=="number"?{timeout:ie}:void 0);let we=!1;return{dispose(){we||(we=!0,oe.cancelIdleCallback($e))}}},e.$Hh=oe=>(0,e.$Ih)(globalThis,oe)}();class X{constructor(K,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Ih)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Jh=X;class Z extends X{constructor(K){super(globalThis,K)}}e.$Kh=Z;async function Y(oe,K,ie){let $e;for(let we=0;we<ie;we++)try{return await oe()}catch(Le){$e=Le,await p(K)}throw $e}class x{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,ie,$e){return this.a={taskId:K,cancel:()=>$e?.(),promise:ie},ie.then(()=>this.d(K),()=>this.d(K)),ie}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:ie,resolve:$e,reject:we}=c();this.b={run:K,promise:ie,promiseResolve:$e,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Mh=x;class ne{constructor(K,ie=()=>Date.now()){this.d=K,this.f=ie,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Nh=ne;var ge;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(ge||(ge={}));class ue{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,ie)=>{this.a=K,this.b=ie})}complete(K){return new Promise(ie=>{this.a(K),this.d={outcome:0,value:K},ie()})}error(K){return new Promise(ie=>{this.b(K),this.d={outcome:1,value:K},ie()})}cancel(){return this.error(new N.$5)}}e.$Oh=ue;var ve;(function(oe){async function K($e){let we;const Le=await Promise.all($e.map(fe=>fe.then(De=>De,De=>{we||(we=De)})));if(typeof we<"u")throw we;return Le}oe.settled=K;function ie($e){return new Promise(async(we,Le)=>{try{await $e(we,Le)}catch(fe){Le(fe)}})}oe.withAsyncBody=ie})(ve||(e.Promises=ve={}));class te{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ph=te;class U{constructor(K){this.b=K,this.a=new S.$V(()=>new te(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Qh=U;var _;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(_||(_={}));class be{static fromArray(K){return new be(ie=>{ie.emitMany(K)})}static fromPromise(K){return new be(async ie=>{ie.emitMany(await K)})}static fromPromises(K){return new be(async ie=>{await Promise.all(K.map(async $e=>ie.emitOne(await $e)))})}static merge(K){return new be(async ie=>{await Promise.all(K.map(async $e=>{for await(const we of $e)ie.emitOne(we)}))})}static{this.EMPTY=be.fromArray([])}constructor(K,ie){this.a=0,this.b=[],this.d=null,this.f=ie,this.g=new M.$be,queueMicrotask(async()=>{const $e={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(K($e)),this.k()}catch(we){this.l(we)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(K,ie){return new be(async $e=>{for await(const we of K)$e.emitOne(ie(we))})}map(K){return be.map(this,K)}static filter(K,ie){return new be(async $e=>{for await(const we of K)ie(we)&&$e.emitOne(we)})}filter(K){return be.filter(this,K)}static coalesce(K){return be.filter(K,ie=>!!ie)}coalesce(){return be.coalesce(this)}static async toPromise(K){const ie=[];for await(const $e of K)ie.push($e);return ie}toPromise(){return be.toPromise(this)}h(K){this.a===0&&(this.b.push(K),this.g.fire())}j(K){this.a===0&&(this.b=this.b.concat(K),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(K){this.a===0&&(this.a=2,this.d=K,this.g.fire())}}e.$Rh=be;class Pe extends be{constructor(K,ie){super(ie),this.m=K}cancel(){this.m.cancel()}}e.$Sh=Pe;function se(oe){const K=new u.$me,ie=oe(K.token);return new Pe(K,async $e=>{const we=K.token.onCancellationRequested(()=>{we.dispose(),K.dispose(),$e.reject(new N.$5)});try{for await(const Le of ie){if(K.token.isCancellationRequested)return;$e.emitOne(Le)}we.dispose(),K.dispose()}catch(Le){we.dispose(),K.dispose(),$e.reject(Le)}})}class re{constructor(K){this.a=new ue,this.b=new be(we=>{if(ie){we.reject(ie);return}return $e&&we.emitMany($e),this.d=Le=>we.reject(Le),this.f=Le=>we.emitOne(Le),this.a.p},K);let ie,$e;this.f=we=>{$e||($e=[]),$e.push(we)},this.d=we=>{ie||(ie=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Uh=re}),define(ke[35],Se([1,0,19,8,34,27,17,11,14]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=void 0,e.$gk=S,e.$jk=v,e.$kk=P,e.$lk=I,e.$mk=F,e.$nk=j,e.$ok=z,e.$pk=W;function S(){return Object.create(null)}e.$hk="**",e.$ik="/";const L="[/\\\\]",C="[^/\\\\]",m=/\//g;function y(X,Z){switch(X){case 0:return"";case 1:return`${C}*?`;default:return`(?:${L}|${C}+${L}${Z?`|${L}${C}+`:""})*?`}}function v(X,Z){if(!X)return[];const Y=[];let x=!1,ne=!1,ge="";for(const ue of X){switch(ue){case Z:if(!x&&!ne){Y.push(ge),ge="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}ge+=ue}return ge&&Y.push(ge),Y}function l(X){if(!X)return"";let Z="";const Y=v(X,e.$ik);if(Y.every(x=>x===e.$hk))Z=".*";else{let x=!1;Y.forEach((ne,ge)=>{if(ne===e.$hk){if(x)return;Z+=y(2,ge===Y.length-1)}else{let ue=!1,ve="",te=!1,U="";for(const _ of ne){if(_!=="}"&&ue){ve+=_;continue}if(te&&(_!=="]"||!U)){let be;_==="-"?be=_:(_==="^"||_==="!")&&!U?be="^":_===e.$ik?be="":be=(0,$.$9e)(_),U+=be;continue}switch(_){case"{":ue=!0;continue;case"[":te=!0;continue;case"}":{const Pe=`(?:${v(ve,",").map(se=>l(se)).join("|")})`;Z+=Pe,ue=!1,ve="";break}case"]":{Z+="["+U+"]",te=!1,U="";break}case"?":Z+=C;continue;case"*":Z+=y(1);continue;default:Z+=(0,$.$9e)(_)}}ge<Y.length-1&&(Y[ge+1]!==e.$hk||ge+2<Y.length)&&(Z+=L)}x=ne===e.$hk})}return Z}const g=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Ec(1e4),d=function(){return!1},a=function(){return null};function h(X,Z){if(!X)return a;let Y;typeof X!="string"?Y=X.pattern:Y=X,Y=Y.trim();const x=`${Y}_${!!Z.trimForExclusions}`;let ne=t.get(x);if(ne)return o(ne,X);let ge;return g.test(Y)?ne=f(Y.substr(4),Y):(ge=c.exec(p(Y,Z)))?ne=D(ge[1],Y):(Z.trimForExclusions?i:n).test(Y)?ne=b(Y,Z):(ge=s.exec(p(Y,Z)))?ne=k(ge[1].substr(1),Y,!0):(ge=r.exec(p(Y,Z)))?ne=k(ge[1],Y,!1):ne=E(Y),t.set(x,ne),o(ne,X)}function o(X,Z){if(typeof Z=="string")return X;const Y=function(x,ne){return(0,M.$rg)(x,Z.base,!w.$k)?X((0,$.$bf)(x.substr(Z.base.length),R.sep),ne):null};return Y.allBasenames=X.allBasenames,Y.allPaths=X.allPaths,Y.basenames=X.basenames,Y.patterns=X.patterns,Y}function p(X,Z){return Z.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function f(X,Z){return function(Y,x){return typeof Y=="string"&&Y.endsWith(X)?Z:null}}function D(X,Z){const Y=`/${X}`,x=`\\${X}`,ne=function(ue,ve){return typeof ue!="string"?null:ve?ve===X?Z:null:ue===X||ue.endsWith(Y)||ue.endsWith(x)?Z:null},ge=[X];return ne.basenames=ge,ne.patterns=[Z],ne.allBasenames=ge,ne}function b(X,Z){const Y=B(X.slice(1,-1).split(",").map(ve=>h(ve,Z)).filter(ve=>ve!==a),X),x=Y.length;if(!x)return a;if(x===1)return Y[0];const ne=function(ve,te){for(let U=0,_=Y.length;U<_;U++)if(Y[U](ve,te))return X;return null},ge=Y.find(ve=>!!ve.allBasenames);ge&&(ne.allBasenames=ge.allBasenames);const ue=Y.reduce((ve,te)=>te.allPaths?ve.concat(te.allPaths):ve,[]);return ue.length&&(ne.allPaths=ue),ne}function k(X,Z,Y){const x=R.sep===R.$hc.sep,ne=x?X:X.replace(m,R.sep),ge=R.sep+ne,ue=R.$hc.sep+X;let ve;return Y?ve=function(te,U){return typeof te=="string"&&(te===ne||te.endsWith(ge)||!x&&(te===X||te.endsWith(ue)))?Z:null}:ve=function(te,U){return typeof te=="string"&&(te===ne||!x&&te===X)?Z:null},ve.allPaths=[(Y?"*/":"./")+X],ve}function E(X){try{const Z=new RegExp(`^${l(X)}$`);return function(Y){return Z.lastIndex=0,typeof Y=="string"&&Z.test(Y)?X:null}}catch{return a}}function P(X,Z,Y){return!X||typeof Z!="string"?!1:I(X)(Z,void 0,Y)}function I(X,Z={}){if(!X)return d;if(typeof X=="string"||F(X)){const Y=h(X,Z);if(Y===a)return d;const x=function(ne,ge){return!!Y(ne,ge)};return Y.allBasenames&&(x.allBasenames=Y.allBasenames),Y.allPaths&&(x.allPaths=Y.allPaths),x}return O(X,Z)}function F(X){const Z=X;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}function j(X){return X.allBasenames||[]}function z(X){return X.allPaths||[]}function O(X,Z){const Y=B(Object.getOwnPropertyNames(X).map(ve=>T(ve,X[ve],Z)).filter(ve=>ve!==a)),x=Y.length;if(!x)return a;if(!Y.some(ve=>!!ve.requiresSiblings)){if(x===1)return Y[0];const ve=function(_,be){let Pe;for(let se=0,re=Y.length;se<re;se++){const oe=Y[se](_,be);if(typeof oe=="string")return oe;(0,N.$dh)(oe)&&(Pe||(Pe=[]),Pe.push(oe))}return Pe?(async()=>{for(const se of Pe){const re=await se;if(typeof re=="string")return re}return null})():null},te=Y.find(_=>!!_.allBasenames);te&&(ve.allBasenames=te.allBasenames);const U=Y.reduce((_,be)=>be.allPaths?_.concat(be.allPaths):_,[]);return U.length&&(ve.allPaths=U),ve}const ne=function(ve,te,U){let _,be;for(let Pe=0,se=Y.length;Pe<se;Pe++){const re=Y[Pe];re.requiresSiblings&&U&&(te||(te=(0,R.$oc)(ve)),_||(_=te.substr(0,te.length-(0,R.$pc)(ve).length)));const oe=re(ve,te,_,U);if(typeof oe=="string")return oe;(0,N.$dh)(oe)&&(be||(be=[]),be.push(oe))}return be?(async()=>{for(const Pe of be){const se=await Pe;if(typeof se=="string")return se}return null})():null},ge=Y.find(ve=>!!ve.allBasenames);ge&&(ne.allBasenames=ge.allBasenames);const ue=Y.reduce((ve,te)=>te.allPaths?ve.concat(te.allPaths):ve,[]);return ue.length&&(ne.allPaths=ue),ne}function T(X,Z,Y){if(Z===!1)return a;const x=h(X,Y);if(x===a)return a;if(typeof Z=="boolean")return x;if(Z){const ne=Z.when;if(typeof ne=="string"){const ge=(ue,ve,te,U)=>{if(!U||!x(ue,ve))return null;const _=ne.replace("$(basename)",()=>te),be=U(_);return(0,N.$dh)(be)?be.then(Pe=>Pe?X:null):be?X:null};return ge.requiresSiblings=!0,ge}}return x}function B(X,Z){const Y=X.filter(ve=>!!ve.basenames);if(Y.length<2)return X;const x=Y.reduce((ve,te)=>{const U=te.basenames;return U?ve.concat(U):ve},[]);let ne;if(Z){ne=[];for(let ve=0,te=x.length;ve<te;ve++)ne.push(Z)}else ne=Y.reduce((ve,te)=>{const U=te.patterns;return U?ve.concat(U):ve},[]);const ge=function(ve,te){if(typeof ve!="string")return null;if(!te){let _;for(_=ve.length;_>0;_--){const be=ve.charCodeAt(_-1);if(be===47||be===92)break}te=ve.substr(_)}const U=x.indexOf(te);return U!==-1?ne[U]:null};ge.basenames=x,ge.patterns=ne,ge.allBasenames=x;const ue=X.filter(ve=>!ve.basenames);return ue.push(ge),ue}function W(X,Z){return(0,u.$ub)(X,Z,(Y,x)=>typeof Y=="string"&&typeof x=="string"?Y===x:typeof Y!="string"&&typeof x!="string"?Y.base===x.base&&Y.pattern===x.pattern:!1)}}),define(ke[80],Se([1,0,13,171,23,14,2]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.MarkdownStringTextNewlineStyle=void 0,e.$Pk=S,e.$Qk=L,e.$Rk=C,e.$Sk=m,e.$Tk=y,e.$Uk=v,e.$Vk=l,e.$Wk=g;var w;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,u.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=m(this.supportThemeIcons?(0,N.$Ik)(n):n).replace(/([ \t]+)/g,(s,r)=>"&nbsp;".repeat(r.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${y(i,n)}
`,this}appendLink(n,i,s){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(n,i){const s=new RegExp((0,A.$9e)(i),"g");return n.replace(s,(r,t)=>n.charAt(t-1)!=="\\"?`\\${r}`:r)}}e.$Ok=$;function S(c){return L(c)?!c.value:Array.isArray(c)?c.every(S):!0}function L(c){return c instanceof $?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function C(c,n){return c===n?!0:!c||!n?!1:c.value===n.value&&c.isTrusted===n.isTrusted&&c.supportThemeIcons===n.supportThemeIcons&&c.supportHtml===n.supportHtml&&(c.baseUri===n.baseUri||!!c.baseUri&&!!n.baseUri&&(0,M.$Xg)(R.URI.from(c.baseUri),R.URI.from(n.baseUri)))}function m(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function y(c,n){const i=c.match(/^`+/gm)?.reduce((r,t)=>r.length>t.length?r:t).length??0,s=i>=3?i+1:3;return[`${"`".repeat(s)}${n}`,c,`${"`".repeat(s)}`].join(`
`)}function v(c){return c.replace(/"/g,"&quot;")}function l(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function g(c){const n=[],i=c.split("|").map(r=>r.trim());c=i[0];const s=i[1];if(s){const r=/height=(\d+)/.exec(s),t=/width=(\d+)/.exec(s),d=r?r[1]:"",a=t?t[1]:"",h=isFinite(parseInt(a)),o=isFinite(parseInt(d));h&&n.push(`width="${a}"`),o&&n.push(`height="${d}"`)}return{href:c,dimensions:n}}}),define(ke[103],Se([1,0,19,34,17,11,23,14]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=$,e.$rw=L,e.$sw=m,e.$tw=y,e.$uw=c,e.$vw=i,e.$ww=s,e.$xw=r,e.$yw=t,e.$zw=d;function $(h,o){const{os:p,tildify:f,relative:D}=o;if(D){const E=S(h,D,p);if(typeof E=="string")return E}let b=h.fsPath;if(p===1&&!A.$i?b=b.replace(/\//g,"\\"):p!==1&&A.$i&&(b=b.replace(/\\/g,"/")),p!==1&&f?.userHome){const E=f.userHome.fsPath;let P;h.scheme!==f.userHome.scheme&&h.path[0]===M.$hc.sep&&h.path[1]!==M.$hc.sep?P=f.userHome.with({path:h.path}).fsPath:P=b,b=m(P,E,p)}return(p===1?M.$gc:M.$hc).normalize(L(b,p===1))}function S(h,o,p){const f=p===1?M.$gc:M.$hc,D=p===3?R.$Ug:R.$Wg,b=o.getWorkspace(),k=(0,u.$Ob)(b.folders);if(!k)return;h.scheme!==k.uri.scheme&&h.path[0]===M.$hc.sep&&h.path[1]!==M.$hc.sep&&(h=k.uri.with({path:h.path}));const E=o.getWorkspaceFolder(h);if(!E)return;let P;if(D.isEqual(E.uri,h)?P="":P=D.relativePath(E.uri,h)??"",P&&(P=f.normalize(P)),b.folders.length>1&&!o.noPrefix){const I=E.name?E.name:D.basenameOrAuthority(E.uri);P=P?`${I} \u2022 ${P}`:I}return P}function L(h,o=A.$i){return(0,N.$vg)(h,o)?h.charAt(0).toUpperCase()+h.slice(1):h}let C=Object.create(null);function m(h,o,p=A.OS){if(p===1||!h||!o)return h;let f=C.original===o?C.normalized:void 0;f||(f=o,A.$i&&(f=(0,N.$lg)(f)),f=`${(0,w.$cf)(f,M.$hc.sep)}${M.$hc.sep}`,C={original:o,normalized:f});let D=h;return A.$i&&(D=(0,N.$lg)(D)),(p===3?D.startsWith(f):(0,w.$vf)(D,f))?`~/${D.substr(f.length)}`:h}function y(h,o){return h.replace(/^~($|\/|\\)/,`${o}$1`)}const v="\u2026",l="\\\\",g="~";function c(h,o=M.sep){const p=new Array(h.length);let f=!1;for(let D=0;D<h.length;D++){const b=h[D];if(b===""){p[D]=`.${o}`;continue}if(!b){p[D]=b;continue}f=!0;let k="",E=b;E.indexOf(l)===0?(k=E.substr(0,E.indexOf(l)+l.length),E=E.substr(E.indexOf(l)+l.length)):E.indexOf(o)===0?(k=E.substr(0,E.indexOf(o)+o.length),E=E.substr(E.indexOf(o)+o.length)):E.indexOf(g)===0&&(k=E.substr(0,E.indexOf(g)+g.length),E=E.substr(E.indexOf(g)+g.length));const P=E.split(o);for(let I=1;f&&I<=P.length;I++)for(let F=P.length-I;f&&F>=0;F--){f=!1;let j=P.slice(F,F+I).join(o);for(let z=0;!f&&z<h.length;z++)if(z!==D&&h[z]&&h[z].indexOf(j)>-1){const O=F+I===P.length,T=F>0&&h[z].indexOf(o)>-1?o+j:j,B=h[z].endsWith(T);f=!O||B}if(!f){let z="";(P[0].endsWith(":")||k!=="")&&(F===1&&(F=0,I++,j=P[0]+o+j),F>0&&(z=P[0]+o),z=k+z),F>0&&(z=z+v+o),z=z+j,F+I<P.length&&(z=z+o+v),p[D]=z}}f&&(p[D]=b)}return p}var n;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(h,o=Object.create(null)){const p=[];let f=!1,D="";for(const b of h)if(b==="$"||f&&b==="{")D&&p.push({value:D,type:n.TEXT}),D="",f=!0;else if(b==="}"&&f){const k=o[D];if(typeof k=="string")k.length&&p.push({value:k,type:n.VARIABLE});else if(k){const E=p[p.length-1];(!E||E.type!==n.SEPARATOR)&&p.push({value:k.label,type:n.SEPARATOR})}D="",f=!1}else D+=b;return D&&!f&&p.push({value:D,type:n.TEXT}),p.filter((b,k)=>{if(b.type===n.SEPARATOR){const E=p[k-1],P=p[k+1];return[E,P].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(b=>b.value).join("")}function s(h,o){return A.$j||o?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):h.replace(/&&|&/g,p=>p==="&"?"&&":"&")}function r(h,o){return A.$j||o?h.replace(/\(&&\w\)|&&/g,""):A.$i?h.replace(/&&|&/g,p=>p==="&"?"&&":"&"):h.replace(/&&/g,"_")}function t(h){return h.replace(/&/g,"&&")}function d(h){if(h.endsWith("]")){const o=h.lastIndexOf(" [",h.length-2);if(o!==-1){const p=a(h.substring(0,o)),f=h.substring(o);return{name:p.name+f,parentPath:p.parentPath}}}return a(h)}function a(h){const o=h.indexOf("/")!==-1?M.$hc:M.$gc,p=o.basename(h),f=o.dirname(h);return p.length?{name:p,parentPath:f}:{name:f,parentPath:""}}}),define(ke[133],Se([1,0,21,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=void 0,e.$vn=w,e.$wn=S,e.$xn=L;function M(C){return C.toJSON()}class A{constructor(m){this.a=m}transformIncoming(m){const y=this.a.transformIncoming(m);return y===m?m:M(N.URI.from(y))}transformOutgoing(m){const y=this.a.transformOutgoing(m);return y===m?m:M(N.URI.from(y))}transformOutgoingURI(m){const y=this.a.transformOutgoing(m);return y===m?m:N.URI.from(y)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$tn=A,e.$un=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,m,y){if(!C||y>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return m.transformOutgoing(C);for(const v in C)if(Object.hasOwnProperty.call(C,v)){const l=R(C[v],m,y+1);l!==null&&(C[v]=l)}}return null}function w(C,m){const y=R(C,m,0);return y===null?C:y}function $(C,m,y,v){if(!C||v>200)return null;if(typeof C=="object"){if(C.$mid===1)return y?N.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof u.$Ce)return null;for(const l in C)if(Object.hasOwnProperty.call(C,l)){const g=$(C[l],m,y,v+1);g!==null&&(C[l]=g)}}return null}function S(C,m){const y=$(C,m,!1,0);return y===null?C:y}function L(C,m){const y=$(C,m,!0,0);return y===null?C:y}}),define(ke[31],Se([1,0,52,64,394,8,34,76,17,11,23,2]),function(le,e,u,N,M,A,R,w,$,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=p,e.writeFileSync=D;var m;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function y(T,B=m.UNLINK,W){if((0,R.$ug)(T))throw new Error("rimraf - will refuse to recursively delete root");return B===m.UNLINK?l(T):v(T,W)}async function v(T,B=(0,R.$zg)((0,N.tmpdir)())){try{try{await u.promises.rename(T,B)}catch(W){return W.code==="ENOENT"?void 0:l(T)}l(B).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function l(T){return(0,M.promisify)(u.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function g(T){if((0,R.$ug)(T))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}async function c(T,B){return s(await(B?n(T):(0,M.promisify)(u.readdir)(T)))}async function n(T){try{return await(0,M.promisify)(u.readdir)(T,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const B=[],W=await c(T);for(const X of W){let Z=!1,Y=!1,x=!1;try{const ne=await e.Promises.lstat((0,$.$kc)(T,X));Z=ne.isFile(),Y=ne.isDirectory(),x=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}B.push({name:X,isFile:()=>Z,isDirectory:()=>Y,isSymbolicLink:()=>x})}return B}function i(T){return s(u.readdirSync(T))}function s(T){return T.map(B=>typeof B=="string"?S.$j?(0,w.$9l)(B):B:(B.name=S.$j?(0,w.$9l)(B.name):B.name,B))}async function r(T){const B=await c(T),W=[];for(const X of B)await d.existsDirectory((0,$.$kc)(T,X))&&W.push(X);return W}function t(T,B=1e3){return new Promise(W=>{let X=!1;const Z=setInterval(()=>{X||(X=!0,u.access(T,Y=>{X=!1,Y&&(clearInterval(Z),W(void 0))}))},B)})}var d;(function(T){async function B(Z){let Y;try{if(Y=await e.Promises.lstat(Z),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(S.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw ne}throw x}}T.stat=B;async function W(Z){try{const{stat:Y,symbolicLink:x}=await T.stat(Z);return Y.isFile()&&x?.dangling!==!0}catch{}return!1}T.existsFile=W;async function X(Z){try{const{stat:Y,symbolicLink:x}=await T.stat(Z);return Y.isDirectory()&&x?.dangling!==!0}catch{}return!1}T.existsDirectory=X})(d||(e.SymlinkSupport=d={}));const a=new A.$Ah;function h(T,B,W){return a.queueFor(C.URI.file(T),()=>{const X=b(W);return new Promise((Z,Y)=>f(T,B,X,x=>x?Y(x):Z()))},L.$Vg)}let o=!0;function p(T){o=T}function f(T,B,W,X){if(!o)return u.writeFile(T,B,{mode:W.mode,flag:W.flag},X);u.open(T,W.flag,W.mode,(Z,Y)=>{if(Z)return X(Z);u.writeFile(Y,B,x=>{if(x)return u.close(Y,()=>X(x));u.fdatasync(Y,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),p(!1)),u.close(Y,ge=>X(ge))))})})}function D(T,B,W){const X=b(W);if(!o)return u.writeFileSync(T,B,{mode:X.mode,flag:X.flag});const Z=u.openSync(T,X.flag,X.mode);try{u.writeFileSync(Z,B);try{u.fdatasyncSync(Z)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),p(!1)}}finally{u.closeSync(Z)}}function b(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function k(T,B,W=6e4){if(T!==B)try{S.$i&&typeof W=="number"?await E(T,B,Date.now(),W):await(0,M.promisify)(u.rename)(T,B)}catch(X){if(T.toLowerCase()!==B.toLowerCase()&&X.code==="EXDEV"||T.endsWith("."))await P(T,B,{preserveSymlinks:!1}),await y(T,m.MOVE);else throw X}}async function E(T,B,W,X,Z=0){try{return await(0,M.promisify)(u.rename)(T,B)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-W>=X)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${Y}`),Y;if(Z===0){let x=!1;try{const{stat:ne}=await d.stat(B);ne.isFile()||(x=!0)}catch{}if(x)throw Y}return await(0,A.$sh)(Math.min(100,Z*10)),E(T,B,W,X,Z+1)}}async function P(T,B,W){return F(T,B,{root:{source:T,target:B},options:W,handledSourcePaths:new Set})}const I=511;async function F(T,B,W){if(W.handledSourcePaths.has(T))return;W.handledSourcePaths.add(T);const{stat:X,symbolicLink:Z}=await d.stat(T);if(Z){if(W.options.preserveSymlinks)try{return await O(T,B,W)}catch{}if(Z.dangling)return}return X.isDirectory()?j(T,B,X.mode&I,W):z(T,B,X.mode&I)}async function j(T,B,W,X){await e.Promises.mkdir(B,{recursive:!0,mode:W});const Z=await c(T);for(const Y of Z)await F((0,$.$kc)(T,Y),(0,$.$kc)(B,Y),X)}async function z(T,B,W){await e.Promises.copyFile(T,B),await e.Promises.chmod(B,W)}async function O(T,B,W){let X=await e.Promises.readlink(T);(0,R.$rg)(X,W.root.source,!S.$k)&&(X=(0,$.$kc)(W.root.target,X.substr(W.root.source.length+1))),await e.Promises.symlink(X,B)}e.Promises=new class{get access(){return(0,M.promisify)(u.access)}get stat(){return(0,M.promisify)(u.stat)}get lstat(){return(0,M.promisify)(u.lstat)}get utimes(){return(0,M.promisify)(u.utimes)}get read(){return(T,B,W,X,Z)=>new Promise((Y,x)=>{u.read(T,B,W,X,Z,(ne,ge,ue)=>ne?x(ne):Y({bytesRead:ge,buffer:ue}))})}get readFile(){return(0,M.promisify)(u.readFile)}get write(){return(T,B,W,X,Z)=>new Promise((Y,x)=>{u.write(T,B,W,X,Z,(ne,ge,ue)=>ne?x(ne):Y({bytesWritten:ge,buffer:ue}))})}get appendFile(){return(0,M.promisify)(u.appendFile)}get fdatasync(){return(0,M.promisify)(u.fdatasync)}get truncate(){return(0,M.promisify)(u.truncate)}get copyFile(){return(0,M.promisify)(u.copyFile)}get open(){return(0,M.promisify)(u.open)}get close(){return(0,M.promisify)(u.close)}get symlink(){return(0,M.promisify)(u.symlink)}get readlink(){return(0,M.promisify)(u.readlink)}get chmod(){return(0,M.promisify)(u.chmod)}get mkdir(){return(0,M.promisify)(u.mkdir)}get unlink(){return(0,M.promisify)(u.unlink)}get rmdir(){return(0,M.promisify)(u.rmdir)}get realpath(){return(0,M.promisify)(u.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return r}get writeFile(){return h}get rm(){return y}get rename(){return k}get copy(){return P}}}),define(ke[104],Se([1,0,52,17,11,14,31]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=w,e.$Zq=$,e.$1q=S,e.$2q=L;function w(m){if(M.$k)return m;const y=(0,N.$nc)(m);if(m===y)return m;const v=((0,N.$oc)(m)||m).toLowerCase();try{const g=(0,R.readdirSync)(y).filter(c=>c.toLowerCase()===v);if(g.length===1){const c=w(y);if(c)return(0,N.$kc)(c,g[0])}else if(g.length>1){const c=g.indexOf(v);if(c>=0){const n=w(y);if(n)return(0,N.$kc)(n,g[c])}}}catch{}return null}async function $(m,y){if(M.$k)return m;const v=(0,N.$nc)(m);if(m===v)return m;const l=((0,N.$oc)(m)||m).toLowerCase();try{if(y?.isCancellationRequested)return null;const c=(await R.Promises.readdir(v)).filter(n=>n.toLowerCase()===l);if(c.length===1){const n=await $(v,y);if(n)return(0,N.$kc)(n,c[0])}else if(c.length>1){const n=c.indexOf(l);if(n>=0){const i=await $(v,y);if(i)return(0,N.$kc)(i,c[n])}}}catch{}return null}async function S(m){try{return await R.Promises.realpath(m)}catch{const v=C(m);return await R.Promises.access(v,u.constants.R_OK),v}}function L(m){try{return u.realpathSync(m)}catch{const v=C(m);return u.accessSync(v,u.constants.R_OK),v}}function C(m){return(0,A.$cf)((0,N.$ic)(m),N.sep)}}),define(ke[105],Se([1,0,17,11,51,102,18,31]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$jm=$,e.$km=S,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function $(C=M.env){return C.comspec||"cmd.exe"}function S(C){let m=[],y=!1;const v=function(l){if(y){m.push(l);return}(!C.send(l,c=>{if(c&&console.error(c),y=!1,m.length>0){const n=m.slice(0);m=[],n.forEach(i=>v(i))}})||N.$i)&&(y=!0)};return{send:v}}var L;(function(C){async function m(y,v,l){if(u.$jc(y))return y;if(v===void 0&&(v=M.cwd()),u.$nc(y)!=="."||(l===void 0&&R.$5f(M.env.PATH)&&(l=M.env.PATH.split(u.$uc)),l===void 0||l.length===0))return u.$kc(v,y);async function c(n){if(await w.Promises.exists(n)){let i;try{i=await w.Promises.stat(n)}catch(s){s.message.startsWith("EACCES")&&(i=await w.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of l){let i;if(u.$jc(n)?i=u.$kc(n,y):i=u.$kc(v,n,y),await c(i))return i;let s=i+".com";if(await c(s)||(s=i+".exe",await c(s)))return s}return u.$kc(v,y)}C.findExecutable=m})(L||(e.win32=L={}))});var Qe=this&&this.__decorate||function(le,e,u,N){var M=arguments.length,A=M<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,u):N,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(le,e,u,N);else for(var w=le.length-1;w>=0;w--)(R=le[w])&&(A=(M<3?R(A):M>3?R(e,u,A):R(e,u))||A);return M>3&&A&&Object.defineProperty(e,u,A),A};define(ke[81],Se([1,0,19,8,21,22,55,13,4,3,58,14,18]),function(le,e,u,N,M,A,R,w,$,S,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.ProxyChannel=e.$_h=e.$9h=e.$8h=e.$7h=e.RequestInitiator=e.$6h=e.$3h=e.$2h=void 0,e.$4h=p,e.$5h=f,e.$0h=I,e.$$h=F;var y;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(y||(y={}));function v(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(l||(l={}));function g(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(c||(c={}));function n(Z){let Y=0;for(let x=0;;x+=7){const ne=Z.read(1);if(Y|=(ne.buffer[0]&127)<<x,!(ne.buffer[0]&128))return Y}}const i=a(0);function s(Z,Y){if(Y===0){Z.write(i);return}let x=0;for(let ge=Y;ge!==0;ge=ge>>>7)x++;const ne=M.$Ce.alloc(x);for(let ge=0;Y!==0;ge++)ne.buffer[ge]=Y&127,Y=Y>>>7,Y>0&&(ne.buffer[ge]|=128);Z.write(ne)}class r{constructor(Y){this.b=Y,this.a=0}read(Y){const x=this.b.slice(this.a,this.a+Y);return this.a+=x.byteLength,x}}e.$2h=r;class t{constructor(){this.a=[]}get buffer(){return M.$Ce.concat(this.a)}write(Y){this.a.push(Y)}}e.$3h=t;var d;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(d||(d={}));function a(Z){const Y=M.$Ce.alloc(1);return Y.writeUInt8(Z,0),Y}const h={Undefined:a(d.Undefined),String:a(d.String),Buffer:a(d.Buffer),VSBuffer:a(d.VSBuffer),Array:a(d.Array),Object:a(d.Object),Uint:a(d.Int)},o=typeof Buffer<"u";function p(Z,Y){if(typeof Y>"u")Z.write(h.Undefined);else if(typeof Y=="string"){const x=M.$Ce.fromString(Y);Z.write(h.String),s(Z,x.byteLength),Z.write(x)}else if(o&&Buffer.isBuffer(Y)){const x=M.$Ce.wrap(Y);Z.write(h.Buffer),s(Z,x.byteLength),Z.write(x)}else if(Y instanceof M.$Ce)Z.write(h.VSBuffer),s(Z,Y.byteLength),Z.write(Y);else if(Array.isArray(Y)){Z.write(h.Array),s(Z,Y.length);for(const x of Y)p(Z,x)}else if(typeof Y=="number"&&(Y|0)===Y)Z.write(h.Uint),s(Z,Y);else{const x=M.$Ce.fromString(JSON.stringify(Y));Z.write(h.Object),s(Z,x.byteLength),Z.write(x)}}function f(Z){switch(Z.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return Z.read(n(Z)).toString();case d.Buffer:return Z.read(n(Z)).buffer;case d.VSBuffer:return Z.read(n(Z));case d.Array:{const x=n(Z),ne=[];for(let ge=0;ge<x;ge++)ne.push(f(Z));return ne}case d.Object:return JSON.parse(Z.read(n(Z)).toString());case d.Int:return n(Z)}}class D{constructor(Y,x,ne=null,ge=1e3){this.h=Y,this.j=x,this.k=ne,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(Y,x){this.b.set(Y,x),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const x=this.o([Y.type]);this.k?.logOutgoing(x,0,1,g(Y.type));return}case 201:case 202:case 204:case 203:{const x=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(x,Y.id,1,g(Y.type),Y.data);return}}}o(Y,x=void 0){const ne=new t;return p(ne,Y),p(ne,x),this.p(ne.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const x=new r(Y),ne=f(x),ge=f(x),ue=ne[0];switch(ue){case 100:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${v(ue)}: ${ne[2]}.${ne[3]}`,ge),this.s({type:ue,id:ne[1],channelName:ne[2],name:ne[3],arg:ge});case 102:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${v(ue)}: ${ne[2]}.${ne[3]}`,ge),this.t({type:ue,id:ne[1],channelName:ne[2],name:ne[3],arg:ge});case 101:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${v(ue)}`),this.u({type:ue,id:ne[1]});case 103:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${v(ue)}`),this.u({type:ue,id:ne[1]})}}s(Y){const x=this.b.get(Y.channelName);if(!x){this.v(Y);return}const ne=new A.$me;let ge;try{ge=x.call(this.j,Y.name,Y.arg,ne.token)}catch(te){ge=Promise.reject(te)}const ue=Y.id;ge.then(te=>{this.m({id:ue,data:te,type:201})},te=>{te instanceof Error?this.m({id:ue,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.m({id:ue,data:te,type:203})}).finally(()=>{ve.dispose(),this.d.delete(Y.id)});const ve=(0,S.$Sc)(()=>ne.cancel());this.d.set(Y.id,ve)}t(Y){const x=this.b.get(Y.channelName);if(!x){this.v(Y);return}const ne=Y.id,ue=x.listen(this.j,Y.name,Y.arg)(ve=>this.m({id:ne,data:ve,type:204}));this.d.set(Y.id,ue)}u(Y){const x=this.d.get(Y.id);x&&(x.dispose(),this.d.delete(Y.id))}v(Y){let x=this.g.get(Y.channelName);x||(x=[],this.g.set(Y.channelName,x));const ne=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:Y,timeoutTimer:ne})}w(Y){const x=this.g.get(Y);if(x){for(const ne of x)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$6h=D;var b;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class k{constructor(Y,x=null){this.l=Y,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=x}getChannel(Y){const x=this;return{call(ne,ge,ue){return x.a?Promise.reject(new w.$5):x.m(Y,ne,ge,ue)},listen(ne,ge){return x.a?$.Event.None:x.o(Y,ne,ge)}}}m(Y,x,ne,ge=A.CancellationToken.None){const ue=this.g++,te={id:ue,type:100,channelName:Y,name:x,arg:ne};if(ge.isCancellationRequested)return Promise.reject(new w.$5);let U;return new Promise((be,Pe)=>{if(ge.isCancellationRequested)return Pe(new w.$5);const se=()=>{const ie=$e=>{switch($e.type){case 201:this.f.delete(ue),be($e.data);break;case 202:{this.f.delete(ue);const we=new Error($e.data.message);we.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,we.name=$e.data.name,Pe(we);break}case 203:this.f.delete(ue),Pe($e.data);break}};this.f.set(ue,ie),this.p(te)};let re=null;this.b===c.Idle?se():(re=(0,N.$eh)(ie=>this.u()),re.then(()=>{re=null,se()}));const oe=()=>{re?(re.cancel(),re=null):this.p({id:ue,type:101}),Pe(new w.$5)},K=ge.onCancellationRequested(oe);U=(0,S.$Rc)((0,S.$Sc)(oe),K),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Y,x,ne){const ge=this.g++,ve={id:ge,type:102,channelName:Y,name:x,arg:ne};let te=null;const U=new $.$be({onWillAddFirstListener:()=>{te=(0,N.$eh)(be=>this.u()),te.then(()=>{te=null,this.d.add(U),this.p(ve)})},onDidRemoveLastListener:()=>{te?(te.cancel(),te=null):(this.d.delete(U),this.p({id:ge,type:103}))}}),_=be=>U.fire(be.data);return this.f.set(ge,_),U.event}p(Y){switch(Y.type){case 100:case 102:{const x=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(x,Y.id,0,`${v(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const x=this.q([Y.type,Y.id]);this.j?.logOutgoing(x,Y.id,0,v(Y.type));return}}}q(Y,x=void 0){const ne=new t;return p(ne,Y),p(ne,x),this.r(ne.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const x=new r(Y),ne=f(x),ge=f(x),ue=ne[0];switch(ue){case 200:return this.j?.logIncoming(Y.byteLength,0,0,g(ue)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,ne[1],0,g(ue),ge),this.t({type:ne[0],id:ne[1],data:ge})}}t(Y){if(Y.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$7h=k,Qe([R.$Vh],k.prototype,"onDidInitializePromise",null);class E{get connections(){const Y=[];return this.f.forEach(x=>Y.push(x)),Y}constructor(Y,x,ne){this.a=new Map,this.f=new Set,this.g=new $.$be,this.onDidAddConnection=this.g.event,this.h=new $.$be,this.onDidRemoveConnection=this.h.event,this.j=new S.$Tc,this.j.add(Y(({protocol:ge,onDidClientDisconnect:ue})=>{const ve=$.Event.once(ge.onMessage);this.j.add(ve(te=>{const U=new r(te),_=f(U),be=new D(ge,_,x,ne),Pe=new k(ge,x);this.a.forEach((re,oe)=>be.registerChannel(oe,re));const se={channelServer:be,channelClient:Pe,ctx:_};this.f.add(se),this.g.fire(se),this.j.add(ue(()=>{be.dispose(),Pe.dispose(),this.f.delete(se),this.h.fire(se)}))}))}))}getChannel(Y,x){const ne=this;return{call(ge,ue,ve){let te;if((0,m.$gg)(x)){const _=(0,u.$4b)(ne.connections.filter(x));te=_?Promise.resolve(_):$.Event.toPromise($.Event.filter(ne.onDidAddConnection,x))}else te=x.routeCall(ne,ge,ue);const U=te.then(_=>_.channelClient.getChannel(Y));return I(U).call(ge,ue,ve)},listen(ge,ue){if((0,m.$gg)(x))return ne.k(Y,x,ge,ue);const ve=x.routeEvent(ne,ge,ue).then(te=>te.channelClient.getChannel(Y));return I(ve).listen(ge,ue)}}}k(Y,x,ne,ge){const ue=this;let ve;const te=new $.$be({onWillAddFirstListener:()=>{ve=new S.$Tc;const U=new $.$he,_=new Map,be=se=>{const oe=se.channelClient.getChannel(Y).listen(ne,ge),K=U.add(oe);_.set(se,K)},Pe=se=>{const re=_.get(se);re&&(re.dispose(),_.delete(se))};ue.connections.filter(x).forEach(be),$.Event.filter(ue.onDidAddConnection,x)(be,void 0,ve),ue.onDidRemoveConnection(Pe,void 0,ve),U.event(te.fire,te,ve),ve.add(U)},onDidRemoveLastListener:()=>{ve?.dispose(),ve=void 0}});return te.event}registerChannel(Y,x){this.a.set(Y,x);for(const ne of this.f)ne.channelServer.registerChannel(Y,x)}dispose(){this.j.dispose();for(const Y of this.f)Y.channelClient.dispose(),Y.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$8h=E;class P{constructor(Y,x,ne=null){const ge=new t;p(ge,x),Y.send(ge.buffer),this.a=new k(Y,ne),this.d=new D(Y,x,ne)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,x){this.d.registerChannel(Y,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$9h=P;function I(Z){return{call(Y,x,ne){return Z.then(ge=>ge.call(Y,x,ne))},listen(Y,x){const ne=new $.$ke;return Z.then(ge=>ne.input=ge.listen(Y,x)),ne.event}}}function F(Z){let Y=!1;return{call(x,ne,ge){return Y?Z.call(x,ne,ge):(0,N.$sh)(0).then(()=>Y=!0).then(()=>Z.call(x,ne,ge))},listen(x,ne){if(Y)return Z.listen(x,ne);const ge=new $.$ke;return(0,N.$sh)(0).then(()=>Y=!0).then(()=>ge.input=Z.listen(x,ne)),ge.event}}}class j{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const x of Y.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.$_h=j;var z;(function(Z){function Y(ue,ve,te){const U=ue,_=te&&te.disableMarshalling,be=new Map;for(const Pe in U)ne(Pe)&&be.set(Pe,$.Event.buffer(U[Pe],!0,void 0,ve));return new class{listen(Pe,se,re){const oe=be.get(se);if(oe)return oe;const K=U[se];if(typeof K=="function"){if(ge(se))return K.call(U,re);if(ne(se))return be.set(se,$.Event.buffer(U[se],!0,void 0,ve)),be.get(se)}throw new w.$bb(`Event not found: ${se}`)}call(Pe,se,re){const oe=U[se];if(typeof oe=="function"){if(!_&&Array.isArray(re))for(let ie=0;ie<re.length;ie++)re[ie]=(0,L.$1h)(re[ie]);let K=oe.apply(U,re);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new w.$bb(`Method not found: ${se}`)}}}Z.fromService=Y;function x(ue,ve){const te=ve&&ve.disableMarshalling;return new Proxy({},{get(U,_){if(typeof _=="string")return ve?.properties?.has(_)?ve.properties.get(_):ge(_)?function(be){return ue.listen(_,be)}:ne(_)?ue.listen(_):async function(...be){let Pe;ve&&!(0,m.$bg)(ve.context)?Pe=[ve.context,...be]:Pe=be;const se=await ue.call(_,Pe);return te?se:(0,L.$1h)(se)};throw new w.$bb(`Property not found: ${String(_)}`)}})}Z.toService=x;function ne(ue){return ue[0]==="o"&&ue[1]==="n"&&C.$tf(ue.charCodeAt(2))}function ge(ue){return/^onDynamic/.test(ue)&&C.$tf(ue.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const Y=Z.toString();if(Y!=="[object Object]")return Y}return Z}function B(Z){return Array.isArray(Z)?Z.map(T):T(Z)}function W(Z,Y,x,ne,ge,ue,ve){ve=B(ve);const te=O[ge],U=te[ne%te.length];let _=[`%c[${Z}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ue)?(_=_.concat(ve),_.push(")")):_.push(ve),console.log.apply(console,_)}class X{constructor(Y,x){this.d=Y,this.f=x,this.a=0,this.b=0}logOutgoing(Y,x,ne,ge,ue){this.b+=Y,W(this.d,this.b,Y,x,ne,ge,ue)}logIncoming(Y,x,ne,ge,ue){this.a+=Y,W(this.f,this.a,Y,x,ne,ge,ue)}}e.$ai=X}),define(ke[82],Se([1,0,21,4,3,81]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.ProtocolConstants=e.$bi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(h){h.Created="created",h.Read="read",h.Write="write",h.Open="open",h.Error="error",h.Close="close",h.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",h.NodeEndReceived="nodeEndReceived",h.NodeEndSent="nodeEndSent",h.NodeDrainBegin="nodeDrainBegin",h.NodeDrainEnd="nodeDrainEnd",h.zlibInflateError="zlibInflateError",h.zlibInflateData="zlibInflateData",h.zlibInflateInitialWrite="zlibInflateInitialWrite",h.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",h.zlibInflateWrite="zlibInflateWrite",h.zlibInflateFlushFired="zlibInflateFlushFired",h.zlibDeflateError="zlibDeflateError",h.zlibDeflateData="zlibDeflateData",h.zlibDeflateWrite="zlibDeflateWrite",h.zlibDeflateFlushFired="zlibDeflateFlushFired",h.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",h.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",h.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",h.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",h.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",h.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",h.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",h.ProtocolHeaderRead="protocolHeaderRead",h.ProtocolMessageRead="protocolMessageRead",h.ProtocolHeaderWrite="protocolHeaderWrite",h.ProtocolMessageWrite="protocolMessageWrite",h.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var w;(function(h){h.enableDiagnostics=!1,h.records=[];const o=new WeakMap;let p=0;function f(b,k){if(!o.has(b)){const E=String(++p);o.set(b,E)}return o.get(b)}function D(b,k,E,P){if(!h.enableDiagnostics)return;const I=f(b,k);if(P instanceof u.$Ce||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const F=u.$Ce.alloc(P.byteLength);F.set(P),h.records.push({timestamp:Date.now(),id:I,label:k,type:E,buff:F})}else h.records.push({timestamp:Date.now(),id:I,label:k,type:E,data:P})}h.traceSocketEvent=D})(w||(e.SocketDiagnostics=w={}));var $;(function(h){h[h.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",h[h.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let S=null;function L(){return S||(S=u.$Ce.alloc(0)),S}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,p){if(o===0)return L();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const k=this.a[0];return p&&(this.a.shift(),this.b-=o),k}if(this.a[0].byteLength>o){const k=this.a[0].slice(0,o);return p&&(this.a[0]=this.a[0].slice(o),this.b-=o),k}const f=u.$Ce.alloc(o);let D=0,b=0;for(;o>0;){const k=this.a[b];if(k.byteLength>o){const E=k.slice(0,o);f.set(E,D),D+=o,p&&(this.a[b]=k.slice(o),this.b-=o),o-=o}else f.set(k,D),D+=k.byteLength,p?(this.a.shift(),this.b-=k.byteLength):b++,o-=k.byteLength}return f}}e.$bi=C;var m;(function(h){h[h.None=0]="None",h[h.Regular=1]="Regular",h[h.Control=2]="Control",h[h.Ack=3]="Ack",h[h.Disconnect=5]="Disconnect",h[h.ReplayRequest=6]="ReplayRequest",h[h.Pause=7]="Pause",h[h.Resume=8]="Resume",h[h.KeepAlive=9]="KeepAlive"})(m||(m={}));function y(h){switch(h){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(h){h[h.HeaderLength=13]="HeaderLength",h[h.AcknowledgeTime=2e3]="AcknowledgeTime",h[h.TimeoutTime=2e4]="TimeoutTime",h[h.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",h[h.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",h[h.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class l{constructor(o,p,f,D){this.type=o,this.id=p,this.ack=f,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends M.$Uc{constructor(o){super(),this.f=this.B(new N.$be),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new C,this.B(this.a.onData(p=>this.acceptChunk(p))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const p=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=p.readUInt32BE(9),this.g.messageType=p.readUInt8(0),this.g.id=p.readUInt32BE(1),this.g.ack=p.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const f=this.g.messageType,D=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",p),this.f.fire(new l(f,D,b,p)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const p=u.$Ce.alloc(13);p.writeUInt8(o.type,0),p.writeUInt32BE(o.id,1),p.writeUInt32BE(o.ack,5),p.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(p,o.data)}g(o,p){const f=this.f===0;return this.d.push(o,p),this.f+=o.byteLength+p.byteLength,f}h(){const o=u.$Ce.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,p){this.g(o,p)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class n extends M.$Uc{constructor(o){super(),this.f=new N.$be,this.onMessage=this.f.event,this.g=new N.$be,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new c(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(p=>{p.type===1&&this.f.fire(p.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new l(1,0,0,o))}}e.$ci=n;class i extends A.$9h{static fromSocket(o,p){return new i(new n(o),p)}get onDidDispose(){return this.b.onDidDispose}constructor(o,p,f=null){super(o,p,f),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.$di=i;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$be({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.$ei=s;class r{constructor(o){this.data=o,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let o=0,p=this.a;for(;p;)p=p.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let p=0,f=this.a;for(;f;)o[p++]=f.data,f=f.next;return o}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const p=new r(o);if(!this.a){this.a=p,this.b=p;return}this.b.next=p,this.b=p}}class d{static{this.a=10}static{this.b=null}static getInstance(){return d.b||(d.b=new d),d.b}constructor(){this.c=[];const o=Date.now();for(let p=0;p<d.a;p++)this.c[p]=o-1e3*p;setInterval(()=>{for(let p=d.a;p>=1;p--)this.c[p]=this.c[p-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),p=(1+d.a)*1e3;let f=0;for(let D=0;D<d.a;D++)o-this.c[D]<=p&&f++;return 1-f/d.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(o){this.u=new s,this.onControlMessage=this.u.event,this.v=new s,this.onMessage=this.v.event,this.w=new s,this.onDidDispose=this.w.event,this.x=new s,this.onSocketClose=this.x.event,this.y=new s,this.onSocketTimeout=this.y.event,this.s=o.loadEstimator??d.getInstance(),this.t=o.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new M.$Tc,this.o=o.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),o.initialChunk&&this.q.acceptChunk(o.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const o=new l(5,0,0,L());this.p.write(o),this.p.flush()}sendPause(){const o=new l(7,0,0,L());this.p.write(o)}sendResume(){const o=new l(8,0,0,L());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,p){this.a=!0,this.r.dispose(),this.r=new M.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),this.q.acceptChunk(p)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new l(3,0,this.h,L());this.p.write(o);const p=this.b.toArray();for(let f=0,D=p.length;f<D;f++)this.p.write(p[f]);this.B()}acceptDisconnect(){this.w.fire()}z(o){if(o.ack>this.d){this.d=o.ack;do{const p=this.b.peek();if(p&&p.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const p=Date.now();p-this.m>1e4&&(this.m=p,this.p.write(new l(6,0,0,L())))}else this.g=o.id,this.j=Date.now(),this.A(),this.v.fire(o.data);break}case 2:{this.u.fire(o.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const p=this.b.toArray();for(let f=0,D=p.length;f<D;f++)this.p.write(p[f]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const p=++this.c;this.h=this.g;const f=new l(1,p,this.h,o);this.b.push(f),this.a||(this.p.write(f),this.B())}sendControl(o){const p=new l(2,0,0,o);this.p.write(p)}A(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-o+5)}B(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),p=Date.now()-o.writtenTime,f=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(p>=2e4&&f>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:p,timeSinceLastReceivedSomeData:f});return}const b=Math.max(2e4-p,2e4-f,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const o=new l(3,0,this.h,L());this.p.write(o)}D(){this.h=this.g;const o=new l(9,0,this.h,L());this.p.write(o)}}e.$fi=a}),define(ke[194],Se([1,0,53,8,21,22,192,13,4,3,24,105,102,81]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;class v extends y.$6h{constructor(c){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",n=>M.$Ce.wrap(Buffer.from(n,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Uq=v;class l{constructor(c,n){this.i=c,this.j=n,this.c=new Set,this.g=new Map,this.h=new $.$be,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new N.$oh(i),this.d=null,this.f=null}getChannel(c){const n=this;return{call(i,s,r){return n.k(c,i,s,r)},listen(i,s){return n.l(c,i,s)}}}k(c,n,i,s=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(w.$6());this.b.cancel();const r=this.n(c),t=(0,N.$eh)(h=>r.call(n,i,h)),d=s.onCancellationRequested(()=>t.cancel()),a=(0,S.$Sc)(()=>t.cancel());return this.c.add(a),t.finally(()=>{d.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,n,i){if(!this.b)return $.Event.None;this.b.cancel();let s;const r=new $.$be({onWillAddFirstListener:()=>{s=this.n(c).listen(n,i)(r.fire,r),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return r.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,L.$Xn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(p=>!/^--inspect(-brk)?=/.test(p)).filter(p=>!p.startsWith("--vscode-"))),(0,m.$im)(n.env),this.d=(0,u.fork)(this.i,c,n);const i=new $.$be,r=$.Event.fromNodeEventEmitter(this.d,"message",p=>p)(p=>{if((0,R.$Qq)(p)){(0,R.log)(p,`IPC Library: ${this.j.serverName}`);return}i.fire(M.$Ce.wrap(Buffer.from(p,"base64")))}),t=this.j.useQueue?(0,C.$km)(this.d):this.d,d=p=>this.d&&this.d.connected&&t.send(p.buffer.toString("base64")),a=i.event,h={send:d,onMessage:a};this.f=new y.$7h(h);const o=()=>this.o();process.once("exit",o),this.d.on("error",p=>console.warn('IPC "'+this.j.serverName+'" errored with '+p)),this.d.on("exit",(p,f)=>{process.removeListener("exit",o),r.dispose(),this.c.forEach(D=>(0,S.$Pc)(D)),this.c.clear(),p!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+p+" and signal "+f),this.b?.cancel(),this.o(),this.h.fire({code:p,signal:f})})}return this.f}n(c){let n=this.g.get(c);return n||(n=this.m.getChannel(c),this.g.set(c,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Vq=l}),define(ke[195],Se([1,0,8,4,3,58,18]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.StorageState=e.StorageHint=void 0,e.$Qp=$;var w;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function $(m){const y=m;return y?.changed instanceof Map||y?.deleted instanceof Set}var S;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(S||(e.StorageState=S={}));class L extends M.$Uc{static{this.a=100}constructor(y,v=Object.create(null)){super(),this.r=y,this.s=v,this.b=this.B(new N.$ee),this.onDidChangeStorage=this.b.event,this.c=S.None,this.f=new Map,this.g=this.B(new u.$ph(L.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((v,l)=>this.w(l,v)),y.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(y,v){if(this.c===S.Closed)return;let l=!1;(0,R.$bg)(v)?l=this.f.delete(y):this.f.get(y)!==v&&(this.f.set(y,v),l=!0),l&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===S.None&&(this.c=S.Initialized,this.s.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,v){const l=this.f.get(y);return(0,R.$bg)(l)?v:l}getBoolean(y,v){const l=this.get(y);return(0,R.$bg)(l)?v:l==="true"}getNumber(y,v){const l=this.get(y);return(0,R.$bg)(l)?v:parseInt(l,10)}getObject(y,v){const l=this.get(y);return(0,R.$bg)(l)?v:(0,A.$Zh)(l)}async set(y,v,l=!1){if(this.c===S.Closed)return;if((0,R.$bg)(v))return this.delete(y,l);const g=(0,R.$7f)(v)||Array.isArray(v)?(0,A.$Yh)(v):String(v);if(this.f.get(y)!==g)return this.f.set(y,g),this.j.set(y,g),this.h.delete(y),this.b.fire({key:y,external:l}),this.D()}async delete(y,v=!1){if(!(this.c===S.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:v}),this.D()}async optimize(){if(this.c!==S.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=S.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===w.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===w.STORAGE_IN_MEMORY}}e.$Rp=L;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((v,l)=>this.a.set(l,v)),y.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Sp=C}),define(ke[196],Se([1,0,14,11,21]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=void 0,e.$wt=L,e.$xt=C;let A;function R(){return A||(A=new TextDecoder("UTF-16LE")),A}let w;function $(){return w||(w=new TextDecoder("UTF-16BE")),w}let S;function L(){return S||(S=N.$D()?R():$()),S}function C(v,l,g){const c=new Uint16Array(v.buffer,l,g);return g>0&&(c[0]===65279||c[0]===65534)?m(v,l,g):R().decode(c)}function m(v,l,g){const c=[];let n=0;for(let i=0;i<g;i++){const s=M.$Ee(v,l);l+=2,c[n++]=String.fromCharCode(s)}return c.join("")}class y{constructor(l){this.a=l|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const l=new Uint16Array(this.b.buffer,0,this.d);return L().decode(l)}f(){const l=this.e();this.d=0,this.c===null?this.c=[l]:this.c[this.c.length]=l}appendCharCode(l){const g=this.a-this.d;g<=1&&(g===0||u.$yf(l))&&this.f(),this.b[this.d++]=l}appendASCIICharCode(l){this.d===this.a&&this.f(),this.b[this.d++]=l}appendString(l){const g=l.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=l;return}for(let c=0;c<g;c++)this.b[this.d++]=l.charCodeAt(c)}}e.$yt=y}),define(ke[197],Se([1,0,21,196]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=void 0,e.$At=R;function M($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(S,L,C,m){this.oldPosition=S,this.oldText=L,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(S){return 4+2*S.length}static c(S,L,C){const m=L.length;u.$He(S,m,C),C+=4;for(let y=0;y<m;y++)u.$Fe(S,L.charCodeAt(y),C),C+=2;return C}static d(S,L){const C=u.$Ge(S,L);return L+=4,(0,N.$xt)(S,L,C)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(S,L){return u.$He(S,this.oldPosition,L),L+=4,u.$He(S,this.newPosition,L),L+=4,L=A.c(S,this.oldText,L),L=A.c(S,this.newText,L),L}static read(S,L,C){const m=u.$Ge(S,L);L+=4;const y=u.$Ge(S,L);L+=4;const v=A.d(S,L);L+=A.a(v);const l=A.d(S,L);return L+=A.a(l),C.push(new A(m,v,y,l)),L}}e.$zt=A;function R($,S){return $===null||$.length===0?S:new w($,S).compress()}class w{constructor(S,L){this.a=S,this.c=L,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let S=0,L=0,C=this.n(S),m=this.l(L);for(;S<this.f||L<this.h;){if(C===null){this.k(m),m=this.l(++L);continue}if(m===null){this.m(C),C=this.n(++S);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++L);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++S);continue}if(m.oldPosition<C.newPosition){const[c,n]=w.r(m,C.newPosition-m.oldPosition);this.k(c),m=n;continue}if(C.newPosition<m.oldPosition){const[c,n]=w.q(C,m.oldPosition-C.newPosition);this.m(c),C=n;continue}let l,g;if(m.oldEnd===C.newEnd)l=C,g=m,C=this.n(++S),m=this.l(++L);else if(m.oldEnd<C.newEnd){const[c,n]=w.q(C,m.oldLength);l=c,g=m,C=n,m=this.l(++L)}else{const[c,n]=w.r(m,C.newLength);l=C,g=c,C=this.n(++S),m=n}this.d[this.e++]=new A(l.oldPosition,l.oldText,g.newPosition,g.newText),this.g+=l.newLength-l.oldLength,this.j+=g.newLength-g.oldLength}const y=w.s(this.d);return w.t(y)}k(S){this.d[this.e++]=w.o(this.g,S),this.j+=S.newLength-S.oldLength}l(S){return S<this.h?this.c[S]:null}m(S){this.d[this.e++]=w.p(this.j,S),this.g+=S.newLength-S.oldLength}n(S){return S<this.f?this.a[S]:null}static o(S,L){return new A(L.oldPosition-S,L.oldText,L.newPosition,L.newText)}static p(S,L){return new A(L.oldPosition,L.oldText,L.newPosition+S,L.newText)}static q(S,L){const C=S.newText.substr(0,L),m=S.newText.substr(L);return[new A(S.oldPosition,S.oldText,S.newPosition,C),new A(S.oldEnd,"",S.newPosition+L,m)]}static r(S,L){const C=S.oldText.substr(0,L),m=S.oldText.substr(L);return[new A(S.oldPosition,C,S.newPosition,S.newText),new A(S.oldPosition+L,m,S.newEnd,"")]}static s(S){if(S.length===0)return S;const L=[];let C=0,m=S[0];for(let y=1;y<S.length;y++){const v=S[y];m.oldEnd===v.oldPosition?m=new A(m.oldPosition,m.oldText+v.oldText,m.newPosition,m.newText+v.newText):(L[C++]=m,m=v)}return L[C++]=m,L}static t(S){if(S.length===0)return S;const L=[];let C=0;for(let m=0;m<S.length;m++){const y=S[m];y.oldText!==y.newText&&(L[C++]=y)}return L}}}),define(ke[198],Se([1,0,35,17]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=M,e.$Yt=A;function M(R,w,$,S,L,C){if(Array.isArray(R)){let m=0;for(const y of R){const v=M(y,w,$,S,L,C);if(v===10)return v;v>m&&(m=v)}return m}else{if(typeof R=="string")return S?R==="*"?5:R===$?10:0:0;if(R){const{language:m,pattern:y,scheme:v,hasAccessToAllModels:l,notebookType:g}=R;if(!S&&!l)return 0;g&&L&&(w=L);let c=0;if(v)if(v===w.scheme)c=10;else if(v==="*")c=5;else return 0;if(m)if(m===$)c=10;else if(m==="*")c=Math.max(c,5);else return 0;if(g)if(g===C)c=10;else if(g==="*"&&C!==void 0)c=Math.max(c,5);else return 0;if(y){let n;if(typeof y=="string"?n=y:n={...y,base:(0,N.$ic)(y.base)},n===w.fsPath||(0,u.$kk)(n,w.fsPath))c=10;else return 0}return c}else return 0}}function A(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(A):!!R.notebookType}}),define(ke[199],Se([1,0,4,14,29,79,130,174,197,3]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=void 0;class L extends S.$Uc{constructor(m,y,v,l,g,c,n){super(),this.m=this.B(new u.$be),this.onDidChangeContent=this.m.event,this.f=y,this.j=!c,this.g=l,this.h=g,this.c=new R.$MC(m,v,n)}equals(m){return!(m instanceof L)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,y){return this.c.getOffsetAt(m,y)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,y){const v=m+y,l=this.getPositionAt(m),g=this.getPositionAt(v);return new M.$nt(l.lineNumber,l.column,g.lineNumber,g.column)}getValueInRange(m,y=0){if(m.isEmpty())return"";const v=this.n(y);return this.c.getValueInRange(m,v)}getValueLengthInRange(m,y=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const v=this.getOffsetAt(m.startLineNumber,m.startColumn),l=this.getOffsetAt(m.endLineNumber,m.endColumn);let g=0;const c=this.n(y),n=this.getEOL();if(c.length!==n.length){const i=c.length-n.length,s=m.endLineNumber-m.startLineNumber;g=i*s}return l-v+g}getCharacterCountInRange(m,y=0){if(this.j){let v=0;const l=m.startLineNumber,g=m.endLineNumber;for(let c=l;c<=g;c++){const n=this.getLineContent(c),i=c===l?m.startColumn-1:0,s=c===g?m.endColumn-1:n.length;for(let r=i;r<s;r++)N.$yf(n.charCodeAt(r))?(v=v+1,r=r+1):v=v+1}return v+=this.n(y).length*(g-l),v}return this.getValueLengthInRange(m,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,y){return this.c.getLineCharCode(m,y)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const y=N.$jf(this.getLineContent(m));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(m){const y=N.$lf(this.getLineContent(m));return y===-1?0:y+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,y,v){let l=this.g,g=this.h,c=this.j,n=!0,i=[];for(let o=0;o<m.length;o++){const p=m[o];n&&p._isTracked&&(n=!1);const f=p.range;if(p.text){let P=!0;c||(P=!N.$Jf(p.text),c=P),!l&&P&&(l=N.$If(p.text)),!g&&P&&(g=N.$Lf(p.text))}let D="",b=0,k=0,E=0;if(p.text){let P;[b,k,E,P]=(0,w.$Qt)(p.text);const I=this.getEOL();P===0||P===(I===`\r
`?2:1)?D=p.text:D=p.text.replace(/\r\n|\r|\n/g,I)}i[o]={sortIndex:o,identifier:p.identifier||null,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f),text:D,eolCount:b,firstLineLength:k,lastLineLength:E,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}i.sort(L.u);let s=!1;for(let o=0,p=i.length-1;o<p;o++){const f=i[o].range.getEndPosition(),D=i[o+1].range.getStartPosition();if(D.isBeforeOrEqual(f)){if(D.isBefore(f))throw new Error("Overlapping ranges are not allowed!");s=!0}}n&&(i=this.s(i));const r=v||y?L._getInverseEditRanges(i):[],t=[];if(y)for(let o=0;o<i.length;o++){const p=i[o],f=r[o];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let D=f.startLineNumber;D<=f.endLineNumber;D++){let b="";D===f.startLineNumber&&(b=this.getLineContent(p.range.startLineNumber),N.$jf(b)!==-1)||t.push({lineNumber:D,oldContent:b})}}let d=null;if(v){let o=0;d=[];for(let p=0;p<i.length;p++){const f=i[p],D=r[p],b=this.getValueInRange(f.range),k=f.rangeOffset+o;o+=f.text.length-b.length,d[p]={sortIndex:f.sortIndex,identifier:f.identifier,range:D,text:b,textChange:new $.$zt(f.rangeOffset,b,k,f.text)}}s||d.sort((p,f)=>p.sortIndex-f.sortIndex)}this.g=l,this.h=g,this.j=c;const a=this.t(i);let h=null;if(y&&t.length>0){t.sort((o,p)=>p.lineNumber-o.lineNumber),h=[];for(let o=0,p=t.length;o<p;o++){const f=t[o].lineNumber;if(o>0&&t[o-1].lineNumber===f)continue;const D=t[o].oldContent,b=this.getLineContent(f);b.length===0||b===D||N.$jf(b)!==-1||h.push(f)}}return this.m.fire(),new A.$Cv(d,a,h)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let y=!1;const v=m[0].range,l=m[m.length-1].range,g=new M.$nt(v.startLineNumber,v.startColumn,l.endLineNumber,l.endColumn);let c=v.startLineNumber,n=v.startColumn;const i=[];for(let a=0,h=m.length;a<h;a++){const o=m[a],p=o.range;y=y||o.forceMoveMarkers,i.push(this.getValueInRange(new M.$nt(c,n,p.startLineNumber,p.startColumn))),o.text.length>0&&i.push(o.text),c=p.endLineNumber,n=p.endColumn}const s=i.join(""),[r,t,d]=(0,w.$Qt)(s);return{sortIndex:0,identifier:m[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,0),text:s,eolCount:r,firstLineLength:t,lastLineLength:d,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t(m){m.sort(L.w);const y=[];for(let v=0;v<m.length;v++){const l=m[v],g=l.range.startLineNumber,c=l.range.startColumn,n=l.range.endLineNumber,i=l.range.endColumn;if(g===n&&c===i&&l.text.length===0)continue;l.text?(this.c.delete(l.rangeOffset,l.rangeLength),this.c.insert(l.rangeOffset,l.text,!0)):this.c.delete(l.rangeOffset,l.rangeLength);const s=new M.$nt(g,c,n,i);y.push({range:s,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return y}findMatchesLineByLine(m,y,v,l){return this.c.findMatchesLineByLine(m,y,v,l)}getPieceTree(){return this.c}static _getInverseEditRange(m,y){const v=m.startLineNumber,l=m.startColumn,[g,c,n]=(0,w.$Qt)(y);let i;if(y.length>0){const s=g+1;s===1?i=new M.$nt(v,l,v,l+c):i=new M.$nt(v,l,v+s-1,n+1)}else i=new M.$nt(v,l,v,l);return i}static _getInverseEditRanges(m){const y=[];let v=0,l=0,g=null;for(let c=0,n=m.length;c<n;c++){const i=m[c];let s,r;g?g.range.endLineNumber===i.range.startLineNumber?(s=v,r=l+(i.range.startColumn-g.range.endColumn)):(s=v+(i.range.startLineNumber-g.range.endLineNumber),r=i.range.startColumn):(s=i.range.startLineNumber,r=i.range.startColumn);let t;if(i.text.length>0){const d=i.eolCount+1;d===1?t=new M.$nt(s,r,s,r+i.firstLineLength):t=new M.$nt(s,r,s+d-1,i.lastLineLength+1)}else t=new M.$nt(s,r,s,r);v=t.endLineNumber,l=t.endColumn,y.push(t),g=i}return y}static u(m,y){const v=M.$nt.compareRangesUsingEnds(m.range,y.range);return v===0?m.sortIndex-y.sortIndex:v}static w(m,y){const v=M.$nt.compareRangesUsingEnds(m.range,y.range);return v===0?y.sortIndex-m.sortIndex:-v}}e.$NC=L}),define(ke[200],Se([1,0,14,130,199]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OC=void 0;class A{constructor($,S,L,C,m,y,v,l,g){this.a=$,this.b=S,this.c=L,this.d=C,this.e=m,this.f=y,this.g=v,this.h=l,this.j=g}k($){const S=this.c+this.d+this.e,L=this.c+this.e;return S===0?$===1?`
`:`\r
`:L>S/2?`\r
`:`
`}create($){const S=this.k($),L=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let m=0,y=L.length;m<y;m++){const v=L[m].buffer.replace(/\r\n|\r|\n/g,S),l=(0,N.$IC)(v);L[m]=new N.$LC(v,l)}const C=new M.$NC(L,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&u.$Sf($)&&(this.b=u.$Rf,$=$.substr(1));const S=$.charCodeAt($.length-1);S===13||S>=55296&&S<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=S):(this.m($,!1),this.c=!1,this.d=S)}m($,S){!S&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const S=(0,N.$JC)(this.e,$);this.a.push(new N.$LC($,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=u.$If($)),this.k||(this.k=u.$Lf($)))}finish($=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const S=(0,N.$IC)($.buffer);$.lineStarts=S,this.d===13&&this.f++}}}e.$OC=R}),define(ke[134],Se([1,0,21,11]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbb=$,e.$Nbb=L;var M;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(M||(M={}));function A(C){for(let m=0,y=C.length;m<y;m+=4){const v=C[m+0],l=C[m+1],g=C[m+2],c=C[m+3];C[m+0]=c,C[m+1]=g,C[m+2]=l,C[m+3]=v}}function R(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return N.$D()||A(m),u.$Ce.wrap(m)}function w(C){const m=C.buffer;if(N.$D()||A(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const y=new Uint8Array(m.byteLength);return y.set(m),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function $(C){const m=new Uint32Array(S(C));let y=0;if(m[y++]=C.id,C.type==="full")m[y++]=1,m[y++]=C.data.length,m.set(C.data,y),y+=C.data.length;else{m[y++]=2,m[y++]=C.deltas.length;for(const v of C.deltas)m[y++]=v.start,m[y++]=v.deleteCount,v.data?(m[y++]=v.data.length,m.set(v.data,y),y+=v.data.length):m[y++]=0}return R(m)}function S(C){let m=0;if(m+=2,C.type==="full")m+=1+C.data.length;else{m+=1,m+=3*C.deltas.length;for(const y of C.deltas)y.data&&(m+=y.data.length)}return m}function L(C){const m=w(C);let y=0;const v=m[y++];if(m[y++]===1){const n=m[y++],i=m.subarray(y,y+n);return y+=n,{id:v,type:"full",data:i}}const g=m[y++],c=[];for(let n=0;n<g;n++){const i=m[y++],s=m[y++],r=m[y++];let t;r>0&&(t=m.subarray(y,y+r),y+=r),c[n]={start:i,deleteCount:s,data:t}}return{id:v,type:"delta",deltas:c}}}),define(ke[201],Se([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(ke[135],Se([1,0,19,24,11,177,129,201]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=g,e.clampedInt=n,e.clampedFloat=s,e.stringSet=d,e.cursorStyleToString=E,e.filterValidationDecorations=we;var $;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=S;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class C{constructor(ce,Ae,Ke,Re){this.id=ce,this.name=Ae,this.defaultValue=Ke,this.schema=Re}applyUpdate(ce,Ae){return y(ce,Ae)}compute(ce,Ae,Ke){return Ke}}class m{constructor(ce,Ae){this.newValue=ce,this.didChange=Ae}}e.ApplyUpdateResult=m;function y(ae,ce){if(typeof ae!="object"||typeof ce!="object"||!ae||!ce)return new m(ce,ae!==ce);if(Array.isArray(ae)||Array.isArray(ce)){const Ke=Array.isArray(ae)&&Array.isArray(ce)&&u.$ub(ae,ce);return new m(ce,!Ke)}let Ae=!1;for(const Ke in ce)if(ce.hasOwnProperty(Ke)){const Re=y(ae[Ke],ce[Ke]);Re.didChange&&(ae[Ke]=Re.newValue,Ae=!0)}return new m(ae,Ae)}class v{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Ae){return y(ce,Ae)}validate(ce){return this.defaultValue}}class l{constructor(ce,Ae,Ke,Re){this.id=ce,this.name=Ae,this.defaultValue=Ke,this.schema=Re}applyUpdate(ce,Ae){return y(ce,Ae)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Ae,Ke){return Ke}}function g(ae,ce){return typeof ae>"u"?ce:ae==="false"?!1:!!ae}class c extends l{constructor(ce,Ae,Ke,Re=void 0){typeof Re<"u"&&(Re.type="boolean",Re.default=Ke),super(ce,Ae,Ke,Re)}validate(ce){return g(ce,this.defaultValue)}}function n(ae,ce,Ae,Ke){if(typeof ae>"u")return ce;let Re=parseInt(ae,10);return isNaN(Re)?ce:(Re=Math.max(Ae,Re),Re=Math.min(Ke,Re),Re|0)}class i extends l{static clampedInt(ce,Ae,Ke,Re){return n(ce,Ae,Ke,Re)}constructor(ce,Ae,Ke,Re,tt,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=Ke,ht.minimum=Re,ht.maximum=tt),super(ce,Ae,Ke,ht),this.minimum=Re,this.maximum=tt}validate(ce){return i.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function s(ae,ce,Ae,Ke){if(typeof ae>"u")return ce;const Re=r.float(ae,ce);return r.clamp(Re,Ae,Ke)}class r extends l{static clamp(ce,Ae,Ke){return ce<Ae?Ae:ce>Ke?Ke:ce}static float(ce,Ae){if(typeof ce=="number")return ce;if(typeof ce>"u")return Ae;const Ke=parseFloat(ce);return isNaN(Ke)?Ae:Ke}constructor(ce,Ae,Ke,Re,tt){typeof tt<"u"&&(tt.type="number",tt.default=Ke),super(ce,Ae,Ke,tt),this.validationFn=Re}validate(ce){return this.validationFn(r.float(ce,this.defaultValue))}}class t extends l{static string(ce,Ae){return typeof ce!="string"?Ae:ce}constructor(ce,Ae,Ke,Re=void 0){typeof Re<"u"&&(Re.type="string",Re.default=Ke),super(ce,Ae,Ke,Re)}validate(ce){return t.string(ce,this.defaultValue)}}function d(ae,ce,Ae,Ke){return typeof ae!="string"?ce:Ke&&ae in Ke?Ke[ae]:Ae.indexOf(ae)===-1?ce:ae}class a extends l{constructor(ce,Ae,Ke,Re,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Re,tt.default=Ke),super(ce,Ae,Ke,tt),this.c=Re}validate(ce){return d(ce,this.defaultValue,this.c)}}class h extends C{constructor(ce,Ae,Ke,Re,tt,ht,wt=void 0){typeof wt<"u"&&(wt.type="string",wt.enum=tt,wt.default=Re),super(ce,Ae,Ke,wt),this.c=tt,this.d=ht}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function o(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Ae,Ke){return Ke===0?ce.accessibilitySupport:Ke}}class f extends C{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:w.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{insertSpace:g(Ae.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Ae.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function b(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var k;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(k||(e.TextEditorCursorStyle=k={}));function E(ae){switch(ae){case k.Line:return"line";case k.Block:return"block";case k.Underline:return"underline";case k.LineThin:return"line-thin";case k.BlockOutline:return"block-outline";case k.UnderlineThin:return"underline-thin"}}function P(ae){switch(ae){case"line":return k.Line;case"block":return k.Block;case"underline":return k.Underline;case"line-thin":return k.LineThin;case"block-outline":return k.BlockOutline;case"underline-thin":return k.UnderlineThin}}class I extends v{constructor(){super(142)}compute(ce,Ae,Ke){const Re=["monaco-editor"];return Ae.get(39)&&Re.push(Ae.get(39)),ce.extraEditorClassName&&Re.push(ce.extraEditorClassName),Ae.get(74)==="default"?Re.push("mouse-default"):Ae.get(74)==="copy"&&Re.push("mouse-copy"),Ae.get(111)&&Re.push("showUnused"),Ae.get(140)&&Re.push("showDeprecated"),Re.join(" ")}}class F extends c{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(ce,Ae,Ke){return Ke&&ce.emptySelectionClipboard}}class j extends C{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:w.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:w.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{cursorMoveOnType:g(Ae.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":d(Ae.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":d(Ae.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Ae.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Ae.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Ae.loop,this.defaultValue.loop)}}}class z extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"||ce.length===0?z.OFF:ce==="true"?z.ON:ce:ce?z.ON:z.OFF}}e.EditorFontLigatures=z;class O extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?O.OFF:ce==="true"?O.TRANSLATE:ce:ce?O.TRANSLATE:O.OFF}compute(ce,Ae,Ke){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class T extends v{constructor(){super(50)}compute(ce,Ae,Ke){return ce.fontInfo}}class B extends l{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(ce){const Ae=r.float(ce,this.defaultValue);return Ae===0?e.EDITOR_FONT_DEFAULTS.fontSize:r.clamp(Ae,6,100)}compute(ce,Ae,Ke){return ce.fontInfo.fontSize}}class W extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(i.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}class X extends C{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ae={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...Ae},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...Ae},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...Ae},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...Ae},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...Ae},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:Ke,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:Ke,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:Ke,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:Ke,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:Ke,description:w.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{multiple:d(Ae.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ae.multipleDefinitions??d(Ae.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ae.multipleTypeDefinitions??d(Ae.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ae.multipleDeclarations??d(Ae.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ae.multipleImplementations??d(Ae.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ae.multipleReferences??d(Ae.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ae.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ae.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ae.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ae.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ae.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends C{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:w.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ae.delay,this.defaultValue.delay,0,1e4),sticky:g(Ae.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ae.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Ae.above,this.defaultValue.above)}}}var Y;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(Y||(e.RenderMinimap=Y={}));class x extends v{constructor(){super(145)}compute(ce,Ae,Ke){return x.computeLayout(Ae,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Ae=ce.height/ce.lineHeight,Ke=Math.floor(ce.paddingTop/ce.lineHeight);let Re=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Re=Math.max(Re,Ae-1));const tt=(Ke+ce.viewLineCount+Re)/(ce.pixelRatio*ce.height),ht=Math.floor(ce.viewLineCount/tt);return{typicalViewportLineCount:Ae,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Re,desiredRatio:tt,minimapLineCount:ht}}static c(ce,Ae){const Ke=ce.outerWidth,Re=ce.outerHeight,tt=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Re),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Re};const ht=Ae.stableMinimapLayoutInput,wt=ht&&ce.outerHeight===ht.outerHeight&&ce.lineHeight===ht.lineHeight&&ce.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&ce.pixelRatio===ht.pixelRatio&&ce.scrollBeyondLastLine===ht.scrollBeyondLastLine&&ce.paddingTop===ht.paddingTop&&ce.paddingBottom===ht.paddingBottom&&ce.minimap.enabled===ht.minimap.enabled&&ce.minimap.side===ht.minimap.side&&ce.minimap.size===ht.minimap.size&&ce.minimap.showSlider===ht.minimap.showSlider&&ce.minimap.renderCharacters===ht.minimap.renderCharacters&&ce.minimap.maxColumn===ht.minimap.maxColumn&&ce.minimap.scale===ht.minimap.scale&&ce.verticalScrollbarWidth===ht.verticalScrollbarWidth&&ce.isViewportWrapping===ht.isViewportWrapping,Nt=ce.lineHeight,At=ce.typicalHalfwidthCharacterWidth,xt=ce.scrollBeyondLastLine,_t=ce.minimap.renderCharacters;let Pt=tt>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const qt=ce.minimap.maxColumn,Xt=ce.minimap.size,et=ce.minimap.side,si=ce.verticalScrollbarWidth,Yt=ce.viewLineCount,dt=ce.remainingWidth,vt=ce.isViewportWrapping,ti=_t?2:3;let Zt=Math.floor(tt*Re);const zt=Zt/tt;let gt=!1,Ut=!1,Wt=ti*Pt,Ht=Pt/tt,Ze=1;if(Xt==="fill"||Xt==="fit"){const{typicalViewportLineCount:Ft,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Kt,desiredRatio:ni,minimapLineCount:Ot}=x.computeContainedMinimapLineCount({viewLineCount:Yt,scrollBeyondLastLine:xt,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Re,lineHeight:Nt,pixelRatio:tt});if(Yt/Ot>1)gt=!0,Ut=!0,Pt=1,Wt=1,Ht=Pt/tt;else{let It=!1,St=Pt+1;if(Xt==="fit"){const bt=Math.ceil((ii+Yt+Kt)*Wt);vt&&wt&&dt<=Ae.stableFitRemainingWidth?(It=!0,St=Ae.stableFitMaxMinimapScale):It=bt>Zt}if(Xt==="fill"||It){gt=!0;const bt=Pt;Wt=Math.min(Nt*tt,Math.max(1,Math.floor(1/ni))),vt&&wt&&dt<=Ae.stableFitRemainingWidth&&(St=Ae.stableFitMaxMinimapScale),Pt=Math.min(St,Math.max(1,Math.floor(Wt/ti))),Pt>bt&&(Ze=Math.min(2,Pt/bt)),Ht=Pt/tt/Ze,Zt=Math.ceil(Math.max(Ft,ii+Yt+Kt)*Wt),vt?(Ae.stableMinimapLayoutInput=ce,Ae.stableFitRemainingWidth=dt,Ae.stableFitMaxMinimapScale=Pt):(Ae.stableMinimapLayoutInput=null,Ae.stableFitRemainingWidth=0)}}}const ui=Math.floor(qt*Ht),Gt=Math.min(ui,Math.max(0,Math.floor((dt-si-2)*Ht/(At+Ht)))+e.MINIMAP_GUTTER_WIDTH);let Bt=Math.floor(tt*Gt);const mt=Bt/tt;Bt=Math.floor(Bt*Ze);const Tt=_t?1:2,Rt=et==="left"?0:Ke-Gt-si;return{renderMinimap:Tt,minimapLeft:Rt,minimapWidth:Gt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Ut,minimapScale:Pt,minimapLineHeight:Wt,minimapCanvasInnerWidth:Bt,minimapCanvasInnerHeight:Zt,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:zt}}static computeLayout(ce,Ae){const Ke=Ae.outerWidth|0,Re=Ae.outerHeight|0,tt=Ae.lineHeight|0,ht=Ae.lineNumbersDigitCount|0,wt=Ae.typicalHalfwidthCharacterWidth,Nt=Ae.maxDigitWidth,At=Ae.pixelRatio,xt=Ae.viewLineCount,_t=ce.get(137),Pt=_t==="inherit"?ce.get(136):_t,qt=Pt==="inherit"?ce.get(132):Pt,Xt=ce.get(135),et=Ae.isDominatedByLongLines,si=ce.get(57),Yt=ce.get(68).renderType!==0,dt=ce.get(69),vt=ce.get(105),ti=ce.get(84),Zt=ce.get(73),zt=ce.get(103),gt=zt.verticalScrollbarSize,Ut=zt.verticalHasArrows,Wt=zt.arrowSize,Ht=zt.horizontalScrollbarSize,Ze=ce.get(43),ui=ce.get(110)!=="never";let Gt=ce.get(66);Ze&&ui&&(Gt+=16);let Bt=0;if(Yt){const li=Math.max(ht,dt);Bt=Math.round(li*Nt)}let mt=0;si&&(mt=tt*Ae.glyphMarginDecorationLaneCount);let Tt=0,Rt=Tt+mt,Ft=Rt+Bt,ii=Ft+Gt;const Kt=Ke-mt-Bt-Gt;let ni=!1,Ot=!1,Lt=-1;Pt==="inherit"&&et?(ni=!0,Ot=!0):qt==="on"||qt==="bounded"?Ot=!0:qt==="wordWrapColumn"&&(Lt=Xt);const It=x.c({outerWidth:Ke,outerHeight:Re,lineHeight:tt,typicalHalfwidthCharacterWidth:wt,pixelRatio:At,scrollBeyondLastLine:vt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:Zt,verticalScrollbarWidth:gt,viewLineCount:xt,remainingWidth:Kt,isViewportWrapping:Ot},Ae.memory||new L);It.renderMinimap!==0&&It.minimapLeft===0&&(Tt+=It.minimapWidth,Rt+=It.minimapWidth,Ft+=It.minimapWidth,ii+=It.minimapWidth);const St=Kt-It.minimapWidth,bt=Math.max(1,Math.floor((St-gt-2)/wt)),Ct=Ut?Wt:0;return Ot&&(Lt=Math.max(1,bt),qt==="bounded"&&(Lt=Math.min(Lt,Xt))),{width:Ke,height:Re,glyphMarginLeft:Tt,glyphMarginWidth:mt,glyphMarginDecorationLaneCount:Ae.glyphMarginDecorationLaneCount,lineNumbersLeft:Rt,lineNumbersWidth:Bt,decorationsLeft:Ft,decorationsWidth:Gt,contentLeft:ii,contentWidth:St,minimap:It,viewportColumn:bt,isWordWrapMinified:ni,isViewportWrapping:Ot,wrappingColumn:Lt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Ht,overviewRuler:{top:Ct,width:gt,height:Re-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=x;class ne extends C{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(ce){return d(ce,"simple",["simple","advanced"])}compute(ce,Ae,Ke){return Ae.get(2)===2?"advanced":Ke}}var ge;(function(ae){ae.Off="off",ae.OnCode="onCode",ae.On="on"})(ge||(e.ShowLightbulbIconMode=ge={}));class ue extends C{constructor(){const ce={enabled:ge.On};super(65,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ge.Off,ge.OnCode,ge.On],default:ce.enabled,enumDescriptions:[w.localize(50,null),w.localize(51,null),w.localize(52,null)],description:w.localize(53,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:d(ce.enabled,this.defaultValue.enabled,[ge.Off,ge.OnCode,ge.On])}}}class ve extends C{constructor(){const ce={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:w.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:20,description:w.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:w.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:w.localize(57,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ae.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d(Ae.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Ae.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends C{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:w.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(59,null),w.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:w.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:w.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:w.localize(65,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return typeof Ae.enabled=="boolean"&&(Ae.enabled=Ae.enabled?"on":"off"),{enabled:d(Ae.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ae.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ae.fontFamily,this.defaultValue.fontFamily),padding:g(Ae.padding,this.defaultValue.padding)}}}class U extends C{constructor(){super(66,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):i.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Ae,Ke){return Ke<0?i.clampedInt(-Ke*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class _ extends r{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>r.clamp(ce,0,150),{markdownDescription:w.localize(66,null)})}compute(ce,Ae,Ke){return ce.fontInfo.lineHeight}}class be extends C{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:w.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:w.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(69,null),w.localize(70,null),w.localize(71,null)],default:ce.size,description:w.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:w.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:w.localize(74,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:w.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:w.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ce.showRegionSectionHeaders,description:w.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ce.showMarkSectionHeaders,description:w.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ce.sectionHeaderFontSize,description:w.localize(80,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),autohide:g(Ae.autohide,this.defaultValue.autohide),size:d(Ae.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(Ae.side,this.defaultValue.side,["right","left"]),showSlider:d(Ae.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Ae.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ae.scale,1,1,3),maxColumn:i.clampedInt(Ae.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:g(Ae.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:g(Ae.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:r.clamp(Ae.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Pe(ae){return ae==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class se extends C{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(82,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{top:i.clampedInt(Ae.top,0,0,1e3),bottom:i.clampedInt(Ae.bottom,0,0,1e3)}}}class re extends C{constructor(){const ce={enabled:!0,cycle:!0};super(86,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:w.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:w.localize(84,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),cycle:g(Ae.cycle,this.defaultValue.cycle)}}}class oe extends v{constructor(){super(143)}compute(ce,Ae,Ke){return ce.pixelRatio}}class K extends C{constructor(){const ce={other:"on",comments:"off",strings:"off"},Ae=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(85,null),w.localize(86,null),w.localize(87,null)]}];super(89,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ae,default:ce.strings,description:w.localize(88,null)},comments:{anyOf:Ae,default:ce.comments,description:w.localize(89,null)},other:{anyOf:Ae,default:ce.other,description:w.localize(90,null)}},default:ce,markdownDescription:w.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const At=ce?"on":"off";return{comments:At,strings:At,other:At}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Ae,comments:Ke,strings:Re}=ce,tt=["on","inline","off"];let ht,wt,Nt;return typeof Ae=="boolean"?ht=Ae?"on":"off":ht=d(Ae,this.defaultValue.other,tt),typeof Ke=="boolean"?wt=Ke?"on":"off":wt=d(Ke,this.defaultValue.comments,tt),typeof Re=="boolean"?Nt=Re?"on":"off":Nt=d(Re,this.defaultValue.strings,tt),{other:ht,comments:wt,strings:Nt}}}var ie;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class $e extends C{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(92,null),w.localize(93,null),w.localize(94,null),w.localize(95,null)],default:"on",description:w.localize(96,null)})}validate(ce){let Ae=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Ae=4,Ke=ce):ce==="interval"?Ae=3:ce==="relative"?Ae=2:ce==="on"?Ae=1:Ae=0),{renderType:Ae,renderFn:Ke}}}function we(ae){const ce=ae.get(98);return ce==="editable"?ae.get(91):ce!=="on"}class Le extends C{constructor(){const ce=[],Ae={type:"number",description:w.localize(97,null)};super(102,"rulers",ce,{type:"array",items:{anyOf:[Ae,{type:["object"],properties:{column:Ae,color:{type:"string",description:w.localize(98,null),format:"color-hex"}}}]},default:ce,description:w.localize(99,null)})}validate(ce){if(Array.isArray(ce)){const Ae=[];for(const Ke of ce)if(typeof Ke=="number")Ae.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Re=Ke;Ae.push({column:i.clampedInt(Re.column,0,0,1e4),color:Re.color})}return Ae.sort((Ke,Re)=>Ke.column-Re.column),Ae}return this.defaultValue}}class fe extends C{constructor(){super(92,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function De(ae,ce){if(typeof ae!="string")return ce;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ie extends C{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(100,null),w.localize(101,null),w.localize(102,null)],default:"auto",description:w.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(104,null),w.localize(105,null),w.localize(106,null)],default:"auto",description:w.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:w.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:w.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:w.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:w.localize(111,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce,Ke=i.clampedInt(Ae.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Re=i.clampedInt(Ae.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ae.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Ae.vertical,this.defaultValue.vertical),horizontal:De(Ae.horizontal,this.defaultValue.horizontal),useShadows:g(Ae.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Ae.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Ae.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Ae.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Ae.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(Ae.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Re,verticalSliderSize:i.clampedInt(Ae.verticalSliderSize,Re,0,1e3),scrollByPage:g(Ae.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Ae.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Te extends C{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:w.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:w.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:w.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:w.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:w.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:w.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:w.localize(118,null)}})}applyUpdate(ce,Ae){let Ke=!1;Ae.allowedCharacters&&ce&&(N.$2n(ce.allowedCharacters,Ae.allowedCharacters)||(ce={...ce,allowedCharacters:Ae.allowedCharacters},Ke=!0)),Ae.allowedLocales&&ce&&(N.$2n(ce.allowedLocales,Ae.allowedLocales)||(ce={...ce,allowedLocales:Ae.allowedLocales},Ke=!0));const Re=super.applyUpdate(ce,Ae);return Ke?new m(Re.newValue,!0):Re}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{nonBasicASCII:he(Ae.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Ae.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Ae.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ae.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ae.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Ae){if(typeof ce!="object"||!ce)return Ae;const Ke={};for(const[Re,tt]of Object.entries(ce))tt===!0&&(Ke[Re]=!0);return Ke}}class V extends C{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:w.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(120,null),w.localize(121,null),w.localize(122,null)],description:w.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:w.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ce.fontFamily,description:w.localize(125,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),mode:d(Ae.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(Ae.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Ae.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Ae.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ae.fontFamily,this.defaultValue.fontFamily)}}}class q extends C{constructor(){const ce={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ce,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ce.enabled,description:w.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(127,null),w.localize(128,null),w.localize(129,null)],description:w.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ce.fontFamily,description:w.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ce.backgroundColoring,description:w.localize(132,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),showToolbar:d(Ae.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ae.fontFamily,this.defaultValue.fontFamily),keepOnBlur:g(Ae.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:g(Ae.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Q extends C{constructor(){const ce={enabled:A.$Xs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$Xs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:w.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:w.localize(134,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Ae.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends C{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(135,null),w.localize(136,null),w.localize(137,null)],default:ce.bracketPairs,description:w.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(139,null),w.localize(140,null),w.localize(141,null)],default:ce.bracketPairsHorizontal,description:w.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:w.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:w.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(145,null),w.localize(146,null),w.localize(147,null)],default:ce.highlightActiveIndentation,description:w.localize(148,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{bracketPairs:he(Ae.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ae.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Ae.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Ae.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ae.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(ae,ce,Ae){const Ke=Ae.indexOf(ae);return Ke===-1?ce:Ae[Ke]}class pe extends C{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(149,null),w.localize(150,null)],default:ce.insertMode,description:w.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:w.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:w.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:w.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(155,null),w.localize(156,null),w.localize(157,null),w.localize(158,null)],default:ce.selectionMode,markdownDescription:w.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:w.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:w.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:w.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:w.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:w.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(196,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{insertMode:d(Ae.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Ae.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Ae.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Ae.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Ae.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(Ae.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Ae.showIcons,this.defaultValue.showIcons),showStatusBar:g(Ae.showStatusBar,this.defaultValue.showStatusBar),preview:g(Ae.preview,this.defaultValue.preview),previewMode:d(Ae.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Ae.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Ae.showMethods,this.defaultValue.showMethods),showFunctions:g(Ae.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Ae.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Ae.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Ae.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Ae.showFields,this.defaultValue.showFields),showVariables:g(Ae.showVariables,this.defaultValue.showVariables),showClasses:g(Ae.showClasses,this.defaultValue.showClasses),showStructs:g(Ae.showStructs,this.defaultValue.showStructs),showInterfaces:g(Ae.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Ae.showModules,this.defaultValue.showModules),showProperties:g(Ae.showProperties,this.defaultValue.showProperties),showEvents:g(Ae.showEvents,this.defaultValue.showEvents),showOperators:g(Ae.showOperators,this.defaultValue.showOperators),showUnits:g(Ae.showUnits,this.defaultValue.showUnits),showValues:g(Ae.showValues,this.defaultValue.showValues),showConstants:g(Ae.showConstants,this.defaultValue.showConstants),showEnums:g(Ae.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Ae.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Ae.showKeywords,this.defaultValue.showKeywords),showWords:g(Ae.showWords,this.defaultValue.showWords),showColors:g(Ae.showColors,this.defaultValue.showColors),showFiles:g(Ae.showFiles,this.defaultValue.showFiles),showReferences:g(Ae.showReferences,this.defaultValue.showReferences),showFolders:g(Ae.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Ae.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Ae.showSnippets,this.defaultValue.showSnippets),showUsers:g(Ae.showUsers,this.defaultValue.showUsers),showIssues:g(Ae.showIssues,this.defaultValue.showIssues)}}}class ze extends C{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(198,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(ce.selectSubwords,this.defaultValue.selectSubwords)}}}class qe extends C{constructor(){const ce=[];super(130,"wordSegmenterLocales",ce,{anyOf:[{description:w.localize(199,null),type:"string"},{description:w.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ce){if(typeof ce=="string"&&(ce=[ce]),Array.isArray(ce)){const Ae=[];for(const Ke of ce)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&Ae.push(Ke)}catch{}return Ae}return this.defaultValue}}var Ye;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Ye||(e.WrappingIndent=Ye={}));class it extends C{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(201,null),w.localize(202,null),w.localize(203,null),w.localize(204,null)],description:w.localize(205,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Ae,Ke){return Ae.get(2)===2?0:Ke}}class ot extends v{constructor(){super(146)}compute(ce,Ae,Ke){const Re=Ae.get(145);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Re.isWordWrapMinified,isViewportWrapping:Re.isViewportWrapping,wrappingColumn:Re.wrappingColumn}}}class nt extends C{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:w.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(208,null),w.localize(209,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),showDropSelector:d(Ae.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends C{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:w.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(212,null),w.localize(213,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ae=ce;return{enabled:g(Ae.enabled,this.defaultValue.enabled),showPasteSelector:d(Ae.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ce="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?Be:M.$k?Ge:Ce,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var Xe;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.inlineEdit=63]="inlineEdit",ae[ae.letterSpacing=64]="letterSpacing",ae[ae.lightbulb=65]="lightbulb",ae[ae.lineDecorationsWidth=66]="lineDecorationsWidth",ae[ae.lineHeight=67]="lineHeight",ae[ae.lineNumbers=68]="lineNumbers",ae[ae.lineNumbersMinChars=69]="lineNumbersMinChars",ae[ae.linkedEditing=70]="linkedEditing",ae[ae.links=71]="links",ae[ae.matchBrackets=72]="matchBrackets",ae[ae.minimap=73]="minimap",ae[ae.mouseStyle=74]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=76]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=78]="multiCursorModifier",ae[ae.multiCursorPaste=79]="multiCursorPaste",ae[ae.multiCursorLimit=80]="multiCursorLimit",ae[ae.occurrencesHighlight=81]="occurrencesHighlight",ae[ae.overviewRulerBorder=82]="overviewRulerBorder",ae[ae.overviewRulerLanes=83]="overviewRulerLanes",ae[ae.padding=84]="padding",ae[ae.pasteAs=85]="pasteAs",ae[ae.parameterHints=86]="parameterHints",ae[ae.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=89]="quickSuggestions",ae[ae.quickSuggestionsDelay=90]="quickSuggestionsDelay",ae[ae.readOnly=91]="readOnly",ae[ae.readOnlyMessage=92]="readOnlyMessage",ae[ae.renameOnType=93]="renameOnType",ae[ae.renderControlCharacters=94]="renderControlCharacters",ae[ae.renderFinalNewline=95]="renderFinalNewline",ae[ae.renderLineHighlight=96]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=98]="renderValidationDecorations",ae[ae.renderWhitespace=99]="renderWhitespace",ae[ae.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ae[ae.roundedSelection=101]="roundedSelection",ae[ae.rulers=102]="rulers",ae[ae.scrollbar=103]="scrollbar",ae[ae.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=105]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=106]="scrollPredominantAxis",ae[ae.selectionClipboard=107]="selectionClipboard",ae[ae.selectionHighlight=108]="selectionHighlight",ae[ae.selectOnLineNumbers=109]="selectOnLineNumbers",ae[ae.showFoldingControls=110]="showFoldingControls",ae[ae.showUnused=111]="showUnused",ae[ae.snippetSuggestions=112]="snippetSuggestions",ae[ae.smartSelect=113]="smartSelect",ae[ae.smoothScrolling=114]="smoothScrolling",ae[ae.stickyScroll=115]="stickyScroll",ae[ae.stickyTabStops=116]="stickyTabStops",ae[ae.stopRenderingLineAfter=117]="stopRenderingLineAfter",ae[ae.suggest=118]="suggest",ae[ae.suggestFontSize=119]="suggestFontSize",ae[ae.suggestLineHeight=120]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ae[ae.suggestSelection=122]="suggestSelection",ae[ae.tabCompletion=123]="tabCompletion",ae[ae.tabIndex=124]="tabIndex",ae[ae.unicodeHighlighting=125]="unicodeHighlighting",ae[ae.unusualLineTerminators=126]="unusualLineTerminators",ae[ae.useShadowDOM=127]="useShadowDOM",ae[ae.useTabStops=128]="useTabStops",ae[ae.wordBreak=129]="wordBreak",ae[ae.wordSegmenterLocales=130]="wordSegmenterLocales",ae[ae.wordSeparators=131]="wordSeparators",ae[ae.wordWrap=132]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=135]="wordWrapColumn",ae[ae.wordWrapOverride1=136]="wordWrapOverride1",ae[ae.wordWrapOverride2=137]="wordWrapOverride2",ae[ae.wrappingIndent=138]="wrappingIndent",ae[ae.wrappingStrategy=139]="wrappingStrategy",ae[ae.showDeprecated=140]="showDeprecated",ae[ae.inlayHints=141]="inlayHints",ae[ae.editorClassName=142]="editorClassName",ae[ae.pixelRatio=143]="pixelRatio",ae[ae.tabFocusMode=144]="tabFocusMode",ae[ae.layoutInfo=145]="layoutInfo",ae[ae.wrappingInfo=146]="wrappingInfo",ae[ae.defaultColorDecorators=147]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(214,null)})),acceptSuggestionOnEnter:Ne(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(215,null),""],markdownDescription:w.localize(216,null)})),accessibilitySupport:Ne(new p),accessibilityPageSize:Ne(new i(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(217,null),tags:["accessibility"]})),ariaLabel:Ne(new t(4,"ariaLabel",w.localize(218,null))),ariaRequired:Ne(new c(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new c(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(220,null),w.localize(221,null),""],description:w.localize(222,null)})),autoClosingComments:Ne(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(223,null),w.localize(224,null),""],description:w.localize(225,null)})),autoClosingDelete:Ne(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(226,null),""],description:w.localize(227,null)})),autoClosingOvertype:Ne(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(228,null),""],description:w.localize(229,null)})),autoClosingQuotes:Ne(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(230,null),w.localize(231,null),""],description:w.localize(232,null)})),autoIndent:Ne(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[w.localize(233,null),w.localize(234,null),w.localize(235,null),w.localize(236,null),w.localize(237,null)],description:w.localize(238,null)})),automaticLayout:Ne(new c(13,"automaticLayout",!1)),autoSurround:Ne(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(239,null),w.localize(240,null),w.localize(241,null),""],description:w.localize(242,null)})),bracketPairColorization:Ne(new Q),bracketPairGuides:Ne(new J),stickyTabStops:Ne(new c(116,"stickyTabStops",!1,{description:w.localize(243,null)})),codeLens:Ne(new c(17,"codeLens",!0,{description:w.localize(244,null)})),codeLensFontFamily:Ne(new t(18,"codeLensFontFamily","",{description:w.localize(245,null)})),codeLensFontSize:Ne(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(246,null)})),colorDecorators:Ne(new c(20,"colorDecorators",!0,{description:w.localize(247,null)})),colorDecoratorActivatedOn:Ne(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(248,null),w.localize(249,null),w.localize(250,null)],description:w.localize(251,null)})),colorDecoratorsLimit:Ne(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(252,null)})),columnSelection:Ne(new c(22,"columnSelection",!1,{description:w.localize(253,null)})),comments:Ne(new f),contextmenu:Ne(new c(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new c(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(254,null)})),cursorBlinking:Ne(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:w.localize(255,null)})),cursorSmoothCaretAnimation:Ne(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(256,null),w.localize(257,null),w.localize(258,null)],description:w.localize(259,null)})),cursorStyle:Ne(new h(28,"cursorStyle",k.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:w.localize(260,null)})),cursorSurroundingLines:Ne(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(261,null)})),cursorSurroundingLinesStyle:Ne(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(262,null),w.localize(263,null)],markdownDescription:w.localize(264,null)})),cursorWidth:Ne(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(265,null)})),disableLayerHinting:Ne(new c(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new c(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new c(34,"domReadOnly",!1)),dragAndDrop:Ne(new c(35,"dragAndDrop",!0,{description:w.localize(266,null)})),emptySelectionClipboard:Ne(new F),dropIntoEditor:Ne(new nt),stickyScroll:Ne(new ve),experimentalWhitespaceRendering:Ne(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(267,null),w.localize(268,null),w.localize(269,null)],description:w.localize(270,null)})),extraEditorClassName:Ne(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ne(new r(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:w.localize(271,null)})),find:Ne(new j),fixedOverflowWidgets:Ne(new c(42,"fixedOverflowWidgets",!1)),folding:Ne(new c(43,"folding",!0,{description:w.localize(272,null)})),foldingStrategy:Ne(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(273,null),w.localize(274,null)],description:w.localize(275,null)})),foldingHighlight:Ne(new c(45,"foldingHighlight",!0,{description:w.localize(276,null)})),foldingImportsByDefault:Ne(new c(46,"foldingImportsByDefault",!1,{description:w.localize(277,null)})),foldingMaximumRegions:Ne(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ne(new c(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(279,null)})),fontFamily:Ne(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(280,null)})),fontInfo:Ne(new T),fontLigatures2:Ne(new z),fontSize:Ne(new B),fontWeight:Ne(new W),fontVariations:Ne(new O),formatOnPaste:Ne(new c(55,"formatOnPaste",!1,{description:w.localize(281,null)})),formatOnType:Ne(new c(56,"formatOnType",!1,{description:w.localize(282,null)})),glyphMargin:Ne(new c(57,"glyphMargin",!0,{description:w.localize(283,null)})),gotoLocation:Ne(new X),hideCursorInOverviewRuler:Ne(new c(59,"hideCursorInOverviewRuler",!1,{description:w.localize(284,null)})),hover:Ne(new Z),inDiffEditor:Ne(new c(61,"inDiffEditor",!1)),letterSpacing:Ne(new r(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>r.clamp(ae,-5,20),{description:w.localize(285,null)})),lightbulb:Ne(new ue),lineDecorationsWidth:Ne(new U),lineHeight:Ne(new _),lineNumbers:Ne(new $e),lineNumbersMinChars:Ne(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new c(70,"linkedEditing",!1,{description:w.localize(286,null)})),links:Ne(new c(71,"links",!0,{description:w.localize(287,null)})),matchBrackets:Ne(new a(72,"matchBrackets","always",["always","near","never"],{description:w.localize(288,null)})),minimap:Ne(new be),mouseStyle:Ne(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new r(75,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:w.localize(289,null)})),mouseWheelZoom:Ne(new c(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?w.localize(290,null):w.localize(291,null)})),multiCursorMergeOverlapping:Ne(new c(77,"multiCursorMergeOverlapping",!0,{description:w.localize(292,null)})),multiCursorModifier:Ne(new h(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Pe,{markdownEnumDescriptions:[w.localize(293,null),w.localize(294,null)],markdownDescription:w.localize(295,null)})),multiCursorPaste:Ne(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(296,null),w.localize(297,null)],markdownDescription:w.localize(298,null)})),multiCursorLimit:Ne(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(299,null)})),occurrencesHighlight:Ne(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[w.localize(300,null),w.localize(301,null),w.localize(302,null)],markdownDescription:w.localize(303,null)})),overviewRulerBorder:Ne(new c(82,"overviewRulerBorder",!0,{description:w.localize(304,null)})),overviewRulerLanes:Ne(new i(83,"overviewRulerLanes",3,0,3)),padding:Ne(new se),pasteAs:Ne(new st),parameterHints:Ne(new re),peekWidgetDefaultFocus:Ne(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(305,null),w.localize(306,null)],description:w.localize(307,null)})),definitionLinkOpensInPeek:Ne(new c(88,"definitionLinkOpensInPeek",!1,{description:w.localize(308,null)})),quickSuggestions:Ne(new K),quickSuggestionsDelay:Ne(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(309,null)})),readOnly:Ne(new c(91,"readOnly",!1)),readOnlyMessage:Ne(new fe),renameOnType:Ne(new c(93,"renameOnType",!1,{description:w.localize(310,null),markdownDeprecationMessage:w.localize(311,null)})),renderControlCharacters:Ne(new c(94,"renderControlCharacters",!0,{description:w.localize(312,null),restricted:!0})),renderFinalNewline:Ne(new a(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:w.localize(313,null)})),renderLineHighlight:Ne(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(314,null)],description:w.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ne(new c(97,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(316,null)})),renderValidationDecorations:Ne(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(317,null),w.localize(318,null),w.localize(319,null),""],description:w.localize(320,null)})),revealHorizontalRightPadding:Ne(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new c(101,"roundedSelection",!0,{description:w.localize(321,null)})),rulers:Ne(new Le),scrollbar:Ne(new Ie),scrollBeyondLastColumn:Ne(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(322,null)})),scrollBeyondLastLine:Ne(new c(105,"scrollBeyondLastLine",!0,{description:w.localize(323,null)})),scrollPredominantAxis:Ne(new c(106,"scrollPredominantAxis",!0,{description:w.localize(324,null)})),selectionClipboard:Ne(new c(107,"selectionClipboard",!0,{description:w.localize(325,null),included:M.$k})),selectionHighlight:Ne(new c(108,"selectionHighlight",!0,{description:w.localize(326,null)})),selectOnLineNumbers:Ne(new c(109,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(327,null),w.localize(328,null),w.localize(329,null)],description:w.localize(330,null)})),showUnused:Ne(new c(111,"showUnused",!0,{description:w.localize(331,null)})),showDeprecated:Ne(new c(140,"showDeprecated",!0,{description:w.localize(332,null)})),inlayHints:Ne(new te),snippetSuggestions:Ne(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(333,null),w.localize(334,null),w.localize(335,null),w.localize(336,null)],description:w.localize(337,null)})),smartSelect:Ne(new ze),smoothScrolling:Ne(new c(114,"smoothScrolling",!1,{description:w.localize(338,null)})),stopRenderingLineAfter:Ne(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new pe),inlineSuggest:Ne(new V),inlineEdit:Ne(new q),inlineCompletionsAccessibilityVerbose:Ne(new c(149,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(339,null)})),suggestFontSize:Ne(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new c(121,"suggestOnTriggerCharacters",!0,{description:w.localize(342,null)})),suggestSelection:Ne(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(343,null),w.localize(344,null),w.localize(345,null)],description:w.localize(346,null)})),tabCompletion:Ne(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(347,null),w.localize(348,null),w.localize(349,null)],description:w.localize(350,null)})),tabIndex:Ne(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new Te),unusualLineTerminators:Ne(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(351,null),w.localize(352,null),w.localize(353,null)],description:w.localize(354,null)})),useShadowDOM:Ne(new c(127,"useShadowDOM",!0)),useTabStops:Ne(new c(128,"useTabStops",!0,{description:w.localize(355,null)})),wordBreak:Ne(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(356,null),w.localize(357,null)],description:w.localize(358,null)})),wordSegmenterLocales:Ne(new qe),wordSeparators:Ne(new t(131,"wordSeparators",R.$Ys,{description:w.localize(359,null)})),wordWrap:Ne(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(360,null),w.localize(361,null),w.localize(362,null),w.localize(363,null)],description:w.localize(364,null)})),wordWrapBreakAfterCharacters:Ne(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(365,null)})),wordWrapOverride1:Ne(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new I),defaultColorDecorators:Ne(new c(147,"defaultColorDecorators",!1,{markdownDescription:w.localize(366,null)})),pixelRatio:Ne(new oe),tabFocusMode:Ne(new c(144,"tabFocusMode",!1,{markdownDescription:w.localize(367,null)})),layoutInfo:Ne(new x),wrappingInfo:Ne(new ot),wrappingIndent:Ne(new it),wrappingStrategy:Ne(new ne)}}),define(ke[202],Se([9,10]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,175,29,185,202]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$$t=e.$0t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$9t=e.$8t=e.SymbolKinds=e.SymbolTag=e.$6t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$4t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$3t=e.$2t=e.$1t=void 0,e.$5t=d,e.$7t=h;class ${constructor(X,Z,Y){this.offset=X,this.type=Z,this.language=Y,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$1t=$;class S{constructor(X,Z){this.tokens=X,this.endState=Z,this._tokenizationResultBrand=void 0}}e.$2t=S;class L{constructor(X,Z){this.tokens=X,this.endState=Z,this._encodedTokenizationResultBrand=void 0}}e.$3t=L;var C;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(W){const X=new Map;X.set(0,u.$Qj.symbolMethod),X.set(1,u.$Qj.symbolFunction),X.set(2,u.$Qj.symbolConstructor),X.set(3,u.$Qj.symbolField),X.set(4,u.$Qj.symbolVariable),X.set(5,u.$Qj.symbolClass),X.set(6,u.$Qj.symbolStruct),X.set(7,u.$Qj.symbolInterface),X.set(8,u.$Qj.symbolModule),X.set(9,u.$Qj.symbolProperty),X.set(10,u.$Qj.symbolEvent),X.set(11,u.$Qj.symbolOperator),X.set(12,u.$Qj.symbolUnit),X.set(13,u.$Qj.symbolValue),X.set(15,u.$Qj.symbolEnum),X.set(14,u.$Qj.symbolConstant),X.set(15,u.$Qj.symbolEnum),X.set(16,u.$Qj.symbolEnumMember),X.set(17,u.$Qj.symbolKeyword),X.set(27,u.$Qj.symbolSnippet),X.set(18,u.$Qj.symbolText),X.set(19,u.$Qj.symbolColor),X.set(20,u.$Qj.symbolFile),X.set(21,u.$Qj.symbolReference),X.set(22,u.$Qj.symbolCustomColor),X.set(23,u.$Qj.symbolFolder),X.set(24,u.$Qj.symbolTypeParameter),X.set(25,u.$Qj.account),X.set(26,u.$Qj.issues);function Z(ne){let ge=X.get(ne);return ge||(console.info("No codicon found for CompletionItemKind "+ne),ge=u.$Qj.symbolProperty),ge}W.toIcon=Z;const Y=new Map;Y.set("method",0),Y.set("function",1),Y.set("constructor",2),Y.set("field",3),Y.set("variable",4),Y.set("class",5),Y.set("struct",6),Y.set("interface",7),Y.set("module",8),Y.set("property",9),Y.set("event",10),Y.set("operator",11),Y.set("unit",12),Y.set("value",13),Y.set("constant",14),Y.set("enum",15),Y.set("enum-member",16),Y.set("enumMember",16),Y.set("keyword",17),Y.set("snippet",27),Y.set("text",18),Y.set("color",19),Y.set("file",20),Y.set("reference",21),Y.set("customcolor",22),Y.set("folder",23),Y.set("type-parameter",24),Y.set("typeParameter",24),Y.set("account",25),Y.set("issue",26);function x(ne,ge){let ue=Y.get(ne);return typeof ue>"u"&&!ge&&(ue=9),ue}W.fromString=x})(m||(e.CompletionItemKinds=m={}));var y;(function(W){W[W.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var v;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(v||(e.CompletionItemInsertTextRule=v={}));var l;(function(W){W[W.Word=0]="Word",W[W.Line=1]="Line",W[W.Suggest=2]="Suggest"})(l||(e.PartialAcceptTriggerKind=l={}));var g;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(e.CompletionTriggerKind=g={}));var c;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(c||(e.InlineCompletionTriggerKind=c={}));class n{constructor(X,Z,Y,x){this.range=X,this.text=Z,this.completionKind=Y,this.isSnippetText=x}equals(X){return A.$nt.lift(this.range).equalsRange(X.range)&&this.text===X.text&&this.completionKind===X.completionKind&&this.isSnippetText===X.isSnippetText}}e.$4t=n;var i;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var s;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(s||(e.DocumentPasteTriggerKind=s={}));var r;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(r||(e.SignatureHelpTriggerKind=r={}));var t;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function d(W){return W&&N.URI.isUri(W.uri)&&A.$nt.isIRange(W.range)&&(A.$nt.isIRange(W.originSelectionRange)||A.$nt.isIRange(W.targetSelectionRange))}var a;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(a||(e.SymbolKind=a={})),e.$6t={17:(0,w.localize)(0,null),16:(0,w.localize)(1,null),4:(0,w.localize)(2,null),13:(0,w.localize)(3,null),8:(0,w.localize)(4,null),9:(0,w.localize)(5,null),21:(0,w.localize)(6,null),23:(0,w.localize)(7,null),7:(0,w.localize)(8,null),0:(0,w.localize)(9,null),11:(0,w.localize)(10,null),10:(0,w.localize)(11,null),19:(0,w.localize)(12,null),5:(0,w.localize)(13,null),1:(0,w.localize)(14,null),2:(0,w.localize)(15,null),20:(0,w.localize)(16,null),15:(0,w.localize)(17,null),18:(0,w.localize)(18,null),24:(0,w.localize)(19,null),3:(0,w.localize)(20,null),6:(0,w.localize)(21,null),14:(0,w.localize)(22,null),22:(0,w.localize)(23,null),25:(0,w.localize)(24,null),12:(0,w.localize)(25,null)};function h(W,X){return(0,w.localize)(26,null,W,e.$6t[X])}var o;(function(W){W[W.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var p;(function(W){const X=new Map;X.set(0,u.$Qj.symbolFile),X.set(1,u.$Qj.symbolModule),X.set(2,u.$Qj.symbolNamespace),X.set(3,u.$Qj.symbolPackage),X.set(4,u.$Qj.symbolClass),X.set(5,u.$Qj.symbolMethod),X.set(6,u.$Qj.symbolProperty),X.set(7,u.$Qj.symbolField),X.set(8,u.$Qj.symbolConstructor),X.set(9,u.$Qj.symbolEnum),X.set(10,u.$Qj.symbolInterface),X.set(11,u.$Qj.symbolFunction),X.set(12,u.$Qj.symbolVariable),X.set(13,u.$Qj.symbolConstant),X.set(14,u.$Qj.symbolString),X.set(15,u.$Qj.symbolNumber),X.set(16,u.$Qj.symbolBoolean),X.set(17,u.$Qj.symbolArray),X.set(18,u.$Qj.symbolObject),X.set(19,u.$Qj.symbolKey),X.set(20,u.$Qj.symbolNull),X.set(21,u.$Qj.symbolEnumMember),X.set(22,u.$Qj.symbolStruct),X.set(23,u.$Qj.symbolEvent),X.set(24,u.$Qj.symbolOperator),X.set(25,u.$Qj.symbolTypeParameter);function Z(Y){let x=X.get(Y);return x||(console.info("No codicon found for SymbolKind "+Y),x=u.$Qj.symbolProperty),x}W.toIcon=Z})(p||(e.SymbolKinds=p={}));class f{static asEditOperation(X){return M.$ot.replace(A.$nt.lift(X.range),X.text)}}e.$8t=f;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(X){switch(X){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(X)}constructor(X){this.value=X}}e.$9t=D;var b;(function(W){W[W.AIGenerated=1]="AIGenerated"})(b||(e.NewSymbolNameTag=b={}));var k;(function(W){function X(Z){return!Z||typeof Z!="object"?!1:typeof Z.id=="string"&&typeof Z.title=="string"}W.is=X})(k||(e.Command=k={}));var E;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(E||(e.CommentThreadCollapsibleState=E={}));var P;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(P||(e.CommentThreadState=P={}));var I;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(I||(e.CommentThreadApplicability=I={}));var F;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(F||(e.CommentMode=F={}));var j;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(j||(e.CommentState=j={}));var z;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(z||(e.InlayHintKind=z={}));class O{constructor(X){this.b=X,this.a=null}dispose(){this.a&&this.a.then(X=>{X&&X.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$0t=O,e.$$t=new R.$Pt;var T;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(T||(e.ExternalUriOpenerPriority=T={}));var B;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(ke[203],Se([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[204],Se([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[205],Se([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(ke[206],Se([9,10]),function(le,e){return le.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[207],Se([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[208],Se([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[209],Se([9,10]),function(le,e){return le.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[210],Se([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(ke[211],Se([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(ke[212],Se([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[213],Se([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(ke[214],Se([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(ke[215],Se([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[216],Se([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[217],Se([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(ke[218],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[219],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[220],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[221],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[222],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[223],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[224],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[225],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[226],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[227],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[228],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[229],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[230],Se([9,10]),function(le,e){return le.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[231],Se([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(ke[232],Se([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(ke[233],Se([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(ke[234],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[235],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[236],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[237],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[238],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[239],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[240],Se([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[241],Se([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[242],Se([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[243],Se([9,10]),function(le,e){return le.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[244],Se([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[245],Se([1,0,13,205]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.TokenType=void 0;var M;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(M||(e.TokenType=M={}));function A(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const R=(0,N.localize)(3,null),w=(0,N.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const C=this.d,m=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:L}),this.f.push(y)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,C=!1,m=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(w);return}const v=this.c.charCodeAt(L);if(C)C=!1;else if(v===47&&!m){L++;break}else v===91?m=!0:v===92?C=!0:v===93&&(m=!1);L++}for(;L<this.c.length&&$.a.has(this.c.charCodeAt(L));)L++;this.e=L;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$mj=$}),define(ke[246],Se([1,0,23,41,208,395]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=$,e.$Cp=S,e.$Dp=L,e.$Ep=C,e.$Fp=m,e.$Gp=y,e.$Hp=v;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function $(c){return c=c.trim(),c==="*"||R.test(c)}function S(c){if(!$(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=c.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function L(c){if(!c)return null;const n=c.majorBase,i=c.majorMustEqual,s=c.minorBase;let r=c.minorMustEqual;const t=c.patchBase;let d=c.patchMustEqual;c.hasCaret&&(n===0||(r=!1),d=!1);let a=0;if(c.preRelease){const h=w.exec(c.preRelease);if(h){const[,o,p,f]=h;a=Date.UTC(Number(o),Number(p)-1,Number(f))}}return{majorBase:n,majorMustEqual:i,minorBase:s,minorMustEqual:r,patchBase:t,patchMustEqual:d,isMinimum:c.hasGreaterEquals,notBefore:a}}function C(c,n,i){let s;typeof c=="string"?s=L(S(c)):s=c;let r;n instanceof Date?r=n.getTime():typeof n=="string"&&(r=new Date(n).getTime());let t;if(typeof i=="string"?t=L(S(i)):t=i,!s||!t)return!1;const d=s.majorBase,a=s.minorBase,h=s.patchBase;let o=t.majorBase,p=t.minorBase,f=t.patchBase;const D=t.notBefore;let b=t.majorMustEqual,k=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?d>o?!0:d<o?!1:a>p?!0:a<p||r&&r<D?!1:h>=f:(d===1&&o===0&&(!b||!k||!E)&&(o=1,p=0,f=0,b=!0,k=!1,E=!1),d<o?!1:d>o?!b:a<p?!1:a>p?!k:h<f?!1:h>f?!E:!(r&&r<D))}function m(c,n,i,s,r){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([N.default.Error,M.localize(0,null)]),t;if(typeof s.name!="string")return t.push([N.default.Error,M.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([N.default.Error,M.localize(2,null,"version")]),t;if(!s.engines)return t.push([N.default.Error,M.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([N.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!g(s.extensionDependencies))return t.push([N.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!g(s.activationEvents))return t.push([N.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([N.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([N.default.Warning,M.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([N.default.Error,M.localize(9,null,"main")]),t;{const h=(0,u.$5g)(i,s.main);(0,u.$Yg)(h,i)||t.push([N.default.Warning,M.localize(10,null,h.path,i.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([N.default.Error,M.localize(11,null,"browser")]),t;{const h=(0,u.$5g)(i,s.browser);(0,u.$Yg)(h,i)||t.push([N.default.Warning,M.localize(12,null,h.path,i.path)])}}if(!A.valid(s.version))return t.push([N.default.Error,M.localize(13,null)]),t;const d=[];if(!y(c,n,s,r,d))for(const h of d)t.push([N.default.Error,h]);return t}function y(c,n,i,s,r){return s||typeof i.main>"u"&&typeof i.browser>"u"?!0:l(c,n,i.engines.vscode,r)}function v(c,n,i){return c==="*"||l(n,i,c)}function l(c,n,i,s=[]){const r=L(S(i));if(!r)return s.push(M.localize(14,null,i)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return s.push(M.localize(15,null,i)),!1}else if(!r.majorMustEqual)return s.push(M.localize(16,null,i)),!1;return C(c,n,r)?!0:(s.push(M.localize(17,null,c,i)),!1)}function g(c){if(!Array.isArray(c))return!1;for(let n=0,i=c.length;n<i;n++)if(typeof c[n]!="string")return!1;return!0}}),define(ke[106],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class u{constructor(M,A=[],R=!1){this.ctor=M,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.$oi=u}),define(ke[84],Se([1,0,106]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$rs=A,e.$ss=R;const N=[];var M;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function A(w,$,S){$ instanceof u.$oi||($=new u.$oi($,[],!!S)),N.push([w,$])}function R(){return N}}),define(ke[247],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=void 0;class u{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$8q=u;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const w=this.lookupOrInsertNode(A),$=this.lookupOrInsertNode(R);w.outgoing.set($.key,$),$.incoming.set(w.key,w)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const w of this.a.values())w.outgoing.delete(R),w.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let w=this.a.get(R);return w||(w=new u(R,A),this.a.set(R,w)),w}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,w]of this.a)A.push(`${R}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const w=new Set([A]),$=this.c(R,w);if($)return $}}c(A,R){for(const[w,$]of A.outgoing){if(R.has(w))return[...R,w].join(" -> ");R.add(w);const S=this.c($,R);if(S)return S;R.delete(w)}}}e.$9q=N}),define(ke[5],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e._util=void 0,e.$ri=M,e.$si=A;var u;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function w($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=w})(u||(e._util=u={})),e.$qi=M("instantiationService");function N(R,w,$){w[u.DI_TARGET]===w?w[u.DI_DEPENDENCIES].push({id:R,index:$}):(w[u.DI_DEPENDENCIES]=[{id:R,index:$}],w[u.DI_TARGET]=w)}function M(R){if(u.serviceIds.has(R))return u.serviceIds.get(R);const w=function($,S,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(w,$,L)};return w.toString=()=>R,u.serviceIds.set(R,w),w}function A(R){return R}}),define(ke[54],Se([1,0,18,2,5]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Xi=void 0,e.$Yi=A,e.$Zi=R,e.$1i=$,e.$2i=S,e.$3i=L,e.$4i=C,e.$5i=m,e.$6i=v,e.$7i=l,e.$8i=g,e.$Xi=(0,M.$ri)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof N.URI)}function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof N.URI)}var w;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function $(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function S(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function L(c,n){const i=Object.create(null);for(const s in c)C(i,s,c[s],n);return i}function C(c,n,i,s){const r=n.split("."),t=r.pop();let d=c;for(let a=0;a<r.length;a++){const h=r[a];let o=d[h];switch(typeof o){case"undefined":o=d[h]=Object.create(null);break;case"object":if(o===null){s(`Ignoring ${n} as ${r.slice(0,a+1).join(".")} is null`);return}break;default:s(`Ignoring ${n} as ${r.slice(0,a+1).join(".")} is ${JSON.stringify(o)}`);return}d=o}if(typeof d=="object"&&d!==null)try{d[t]=i}catch{s(`Ignoring ${n} as ${r.join(".")} is ${JSON.stringify(d)}`)}else s(`Ignoring ${n} as ${r.join(".")} is ${JSON.stringify(d)}`)}function m(c,n){const i=n.split(".");y(c,i)}function y(c,n){const i=n.shift();if(n.length===0){delete c[i];return}if(Object.keys(c).indexOf(i)!==-1){const s=c[i];typeof s=="object"&&!Array.isArray(s)&&(y(s,n),Object.keys(s).length===0&&delete c[i])}}function v(c,n,i){function s(d,a){let h=d;for(const o of a){if(typeof h!="object"||h===null)return;h=h[o]}return h}const r=n.split("."),t=s(c,r);return typeof t>"u"?i:t}function l(c,n,i){Object.keys(n).forEach(s=>{s!=="__proto__"&&(s in c?u.$7f(c[s])&&u.$7f(n[s])?l(c[s],n[s],i):i&&(c[s]=n[s]):c[s]=n[s])})}function g(c){return c.replace(/[\[\]]/g,"")}}),define(ke[37],Se([1,0,11,14,245,5,204,13]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$pj=e.$oj=e.ContextKeyExprType=void 0,e.$nj=S,e.$qj=d,e.$rj=a,e.$Kj=ge;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",u.$j),$.set("isLinux",u.$k),$.set("isWindows",u.$i),$.set("isWeb",u.$o),$.set("isMacNative",u.$j&&!u.$o),$.set("isEdge",u.$H),$.set("isFirefox",u.$F),$.set("isChrome",u.$E),$.set("isSafari",u.$G);function S(te,U){if($.get(te)!==void 0)throw(0,w.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(te,U)}const L=Object.prototype.hasOwnProperty;var C;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},y=(0,R.localize)(0,null),v=(0,R.localize)(1,null),l=(0,R.localize)(2,null),g=(0,R.localize)(3,null),c=(0,R.localize)(4,null),n=(0,R.localize)(5,null),i=(0,R.localize)(6,null),s=(0,R.localize)(7,null);class r{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=m){this.k=U,this.d=new M.$mj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const be=this.D(),Pe=be.type===17?n:void 0;throw this.h.push({message:c,offset:be.offset,lexeme:M.$mj.getLexeme(be),additionalInfo:Pe}),r.c}return _}catch(_){if(_!==r.c)throw _;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const _=this.o();U.push(_)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const _=this.s();U.push(_)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,g),_?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const _=this.l();return this.A(1,g),_}case 17:{const _=U.lexeme;if(this.z(),this.y(9)){const Pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Pe.type!==10)throw this.B("REGEX",Pe);const se=Pe.lexeme,re=se.lastIndexOf("/"),oe=re===se.length-1?void 0:this.w(se.substring(re+1));let K;try{K=new RegExp(se.substring(1,re),oe)}catch{throw this.B("REGEX",Pe)}return T.create(_,K)}switch(Pe.type){case 10:case 19:{const se=[Pe.lexeme];this.z();let re=this.D(),oe=0;for(let Le=0;Le<Pe.lexeme.length;Le++)Pe.lexeme.charCodeAt(Le)===40?oe++:Pe.lexeme.charCodeAt(Le)===41&&oe--;for(;!this.E()&&re.type!==15&&re.type!==16;){switch(re.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let Le=0;Le<re.lexeme.length;Le++)re.lexeme.charCodeAt(Le)===40?oe++:Pe.lexeme.charCodeAt(Le)===41&&oe--}if(oe<0)break;se.push(M.$mj.getLexeme(re)),this.z(),re=this.D()}const K=se.join(""),ie=K.lastIndexOf("/"),$e=ie===K.length-1?void 0:this.w(K.substring(ie+1));let we;try{we=new RegExp(K.substring(1,ie),$e)}catch{throw this.B("REGEX",Pe)}return t.regex(_,we)}case 18:{const se=Pe.lexeme;this.z();let re=null;if(!(0,N.$4e)(se)){const oe=se.indexOf("/"),K=se.lastIndexOf("/");if(oe!==K&&oe>=0){const ie=se.slice(oe+1,K),$e=se[K+1]==="i"?"i":"";try{re=new RegExp(ie,$e)}catch{throw this.B("REGEX",Pe)}}}if(re===null)throw this.B("REGEX",Pe);return T.create(_,re)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const Pe=this.u();return t.notIn(_,Pe)}switch(this.D().type){case 3:{this.z();const Pe=this.u();if(this.x().type===18)return t.equals(_,Pe);switch(Pe){case"true":return t.has(_);case"false":return t.not(_);default:return t.equals(_,Pe)}}case 4:{this.z();const Pe=this.u();if(this.x().type===18)return t.notEquals(_,Pe);switch(Pe){case"true":return t.not(_);case"false":return t.has(_);default:return t.notEquals(_,Pe)}}case 5:return this.z(),z.create(_,this.u());case 6:return this.z(),O.create(_,this.u());case 7:return this.z(),F.create(_,this.u());case 8:return this.z(),j.create(_,this.u());case 13:return this.z(),t.in(_,this.u());default:return t.has(_)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:s}),r.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,_){if(this.C(U))return this.z();throw this.B(_,this.D())}B(U,_,be){const Pe=(0,R.localize)(8,null,U,M.$mj.getLexeme(_)),se=_.offset,re=M.$mj.getLexeme(_);return this.h.push({message:Pe,offset:se,lexeme:re,additionalInfo:be}),r.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$oj=r;class t{static false(){return o.INSTANCE}static true(){return p.INSTANCE}static has(U){return f.create(U)}static equals(U,_){return D.create(U,_)}static notEquals(U,_){return E.create(U,_)}static regex(U,_){return T.create(U,_)}static in(U,_){return b.create(U,_)}static notIn(U,_){return k.create(U,_)}static not(U){return P.create(U)}static and(...U){return X.create(U,null,!0)}static or(...U){return Z.create(U,null,!0)}static greater(U,_){return F.create(U,_)}static greaterEquals(U,_){return j.create(U,_)}static smaller(U,_){return z.create(U,_)}static smallerEquals(U,_){return O.create(U,_)}static{this.c=new r({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$pj=t;function d(te){const U=new r({regexParsingWithErrorRecovery:!1});return te.map(_=>(U.parse(_),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,R.localize)(9,null,be.additionalInfo):(0,R.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function a(te,U){const _=te?te.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!_&&!be?!0:!_||!be?!1:_.equals(be)}function h(te,U){return te.cmp(U)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return p.INSTANCE}}e.$sj=o;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return o.INSTANCE}}e.$tj=p;class f{static create(U,_=null){const be=$.get(U);return typeof be=="boolean"?be?p.INSTANCE:o.INSTANCE:new f(U,_)}constructor(U,_){this.key=U,this.c=_,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:x(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?p.INSTANCE:o.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$uj=f;class D{static create(U,_,be=null){if(typeof _=="boolean")return _?f.create(U,be):P.create(U,be);const Pe=$.get(U);return typeof Pe=="boolean"?_===(Pe?"true":"false")?p.INSTANCE:o.INSTANCE:new D(U,_,be)}constructor(U,_,be){this.c=U,this.d=_,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const _=U?"true":"false";return this.d===_?p.INSTANCE:o.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$vj=D;class b{static create(U,_){return new b(U,_)}constructor(U,_){this.d=U,this.f=_,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const _=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(_)?_.includes(be):typeof be=="string"&&typeof _=="object"&&_!==null?L.call(_,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$wj=b;class k{static create(U,_){return new k(U,_)}constructor(U,_){this.d=U,this.f=_,this.type=11,this.c=b.create(U,_)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$xj=k;class E{static create(U,_,be=null){if(typeof _=="boolean")return _?P.create(U,be):f.create(U,be);const Pe=$.get(U);return typeof Pe=="boolean"?_===(Pe?"true":"false")?o.INSTANCE:p.INSTANCE:new E(U,_,be)}constructor(U,_,be){this.c=U,this.d=_,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const _=U?"true":"false";return this.d===_?o.INSTANCE:p.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$yj=E;class P{static create(U,_=null){const be=$.get(U);return typeof be=="boolean"?be?o.INSTANCE:p.INSTANCE:new P(U,_)}constructor(U,_){this.c=U,this.d=_,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?o.INSTANCE:p.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$zj=P;function I(te,U){if(typeof te=="string"){const _=parseFloat(te);isNaN(_)||(te=_)}return typeof te=="string"||typeof te=="number"?U(te):o.INSTANCE}class F{static create(U,_,be=null){return I(_,Pe=>new F(U,Pe,be))}constructor(U,_,be){this.c=U,this.d=_,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Aj=F;class j{static create(U,_,be=null){return I(_,Pe=>new j(U,Pe,be))}constructor(U,_,be){this.c=U,this.d=_,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Bj=j;class z{static create(U,_,be=null){return I(_,Pe=>new z(U,Pe,be))}constructor(U,_,be){this.c=U,this.d=_,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Cj=z;class O{static create(U,_,be=null){return I(_,Pe=>new O(U,Pe,be))}constructor(U,_,be){this.c=U,this.d=_,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Dj=O;class T{static create(U,_){return new T(U,_)}constructor(U,_){this.d=U,this.f=_,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const _=this.f?this.f.source:"",be=U.f?U.f.source:"";return _<be?-1:_>be?1:0}equals(U){if(U.type===this.type){const _=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&_===be}return!1}substituteConstants(){return this}evaluate(U){const _=U.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Ej=T;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Fj=B;function W(te){let U=null;for(let _=0,be=te.length;_<be;_++){const Pe=te[_].substituteConstants();if(te[_]!==Pe&&U===null){U=[];for(let se=0;se<_;se++)U[se]=te[se]}U!==null&&(U[_]=Pe)}return U===null?te:U}class X{static create(U,_,be){return X.d(U,_,be)}constructor(U,_){this.expr=U,this.c=_,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let _=0,be=this.expr.length;_<be;_++){const Pe=h(this.expr[_],U.expr[_]);if(Pe!==0)return Pe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let _=0,be=this.expr.length;_<be;_++)if(!this.expr[_].equals(U.expr[_]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:X.create(U,this.c,!1)}evaluate(U){for(let _=0,be=this.expr.length;_<be;_++)if(!this.expr[_].evaluate(U))return!1;return!0}static d(U,_,be){const Pe=[];let se=!1;for(const re of U)if(re){if(re.type===1){se=!0;continue}if(re.type===0)return o.INSTANCE;if(re.type===6){Pe.push(...re.expr);continue}Pe.push(re)}if(Pe.length===0&&se)return p.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(h);for(let re=1;re<Pe.length;re++)Pe[re-1].equals(Pe[re])&&(Pe.splice(re,1),re--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const re=Pe[Pe.length-1];if(re.type!==9)break;Pe.pop();const oe=Pe.pop(),K=Pe.length===0,ie=Z.create(re.expr.map($e=>X.create([$e,oe],null,be)),null,K);ie&&(Pe.push(ie),Pe.sort(h))}if(Pe.length===1)return Pe[0];if(be){for(let re=0;re<Pe.length;re++)for(let oe=re+1;oe<Pe.length;oe++)if(Pe[re].negate().equals(Pe[oe]))return o.INSTANCE;if(Pe.length===1)return Pe[0]}return new X(Pe,_)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const _ of this.expr)U.push(..._.keys());return U}map(U){return new X(this.expr.map(_=>_.map(U)),null)}negate(){if(!this.c){const U=[];for(const _ of this.expr)U.push(_.negate());this.c=Z.create(U,this,!0)}return this.c}}e.$Gj=X;class Z{static create(U,_,be){return Z.d(U,_,be)}constructor(U,_){this.expr=U,this.c=_,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let _=0,be=this.expr.length;_<be;_++){const Pe=h(this.expr[_],U.expr[_]);if(Pe!==0)return Pe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let _=0,be=this.expr.length;_<be;_++)if(!this.expr[_].equals(U.expr[_]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:Z.create(U,this.c,!1)}evaluate(U){for(let _=0,be=this.expr.length;_<be;_++)if(this.expr[_].evaluate(U))return!0;return!1}static d(U,_,be){let Pe=[],se=!1;if(U){for(let re=0,oe=U.length;re<oe;re++){const K=U[re];if(K){if(K.type===0){se=!0;continue}if(K.type===1)return p.INSTANCE;if(K.type===9){Pe=Pe.concat(K.expr);continue}Pe.push(K)}}if(Pe.length===0&&se)return o.INSTANCE;Pe.sort(h)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let re=1;re<Pe.length;re++)Pe[re-1].equals(Pe[re])&&(Pe.splice(re,1),re--);if(Pe.length===1)return Pe[0];if(be){for(let re=0;re<Pe.length;re++)for(let oe=re+1;oe<Pe.length;oe++)if(Pe[re].negate().equals(Pe[oe]))return p.INSTANCE;if(Pe.length===1)return Pe[0]}return new Z(Pe,_)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const _ of this.expr)U.push(..._.keys());return U}map(U){return new Z(this.expr.map(_=>_.map(U)),null)}negate(){if(!this.c){const U=[];for(const _ of this.expr)U.push(_.negate());for(;U.length>1;){const _=U.shift(),be=U.shift(),Pe=[];for(const se of ve(_))for(const re of ve(be))Pe.push(X.create([se,re],null,!1));U.unshift(Z.create(Pe,null,!1))}this.c=Z.create(U,this,!0)}return this.c}}e.$Hj=Z;class Y extends f{static{this.d=[]}static all(){return Y.d.values()}constructor(U,_,be){super(U,null),this.f=_,typeof be=="object"?Y.d.push({...be,key:U}):be!==!0&&Y.d.push({key:U,description:be,type:_!=null?typeof _:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return E.create(this.key,U)}}e.$Ij=Y,e.$Jj=(0,A.$ri)("contextKeyService");function x(te,U){return te<U?-1:te>U?1:0}function ne(te,U,_,be){return te<_?-1:te>_?1:U<be?-1:U>be?1:0}function ge(te,U){if(te.type===0||U.type===1)return!0;if(te.type===9)return U.type===9?ue(te.expr,U.expr):!1;if(U.type===9){for(const _ of U.expr)if(ge(te,_))return!0;return!1}if(te.type===6){if(U.type===6)return ue(U.expr,te.expr);for(const _ of te.expr)if(ge(_,U))return!0;return!1}return te.equals(U)}function ue(te,U){let _=0,be=0;for(;_<te.length&&be<U.length;){const Pe=te[_].cmp(U[be]);if(Pe<0)return!1;Pe===0&&_++,be++}return _===te.length}function ve(te){return te.type===9?te.expr:[te]}}),define(ke[248],Se([1,0,23,41,206,5,103,11,24]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Cw=e.$Bw=e.$Aw=void 0,e.$Dw=y,e.$Ew=v,e.$Aw=(0,A.$ri)("dialogService");var S;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(S||(S={}));class L{a(g){return this.d(g,S.Confirmation)}b(g){return this.d(g,S.Prompt)}c(g){return this.d(g,S.Input)}d(g,c){const n=[];switch(c){case S.Confirmation:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,M.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,M.localize)(1,null));break}case S.Prompt:{const i=g;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(s=>s.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,M.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,M.localize)(3,null))),n.length===0&&n.push((0,M.localize)(4,null));break}case S.Input:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,M.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,M.localize)(6,null));break}}return n}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===N.default.Info?"info":g===N.default.Error?"error":g===N.default.Warning?"warning":"none"}f(g,c,n){const i=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&i.push(g.cancelButton);let s=i[c]?.run({checkboxChecked:n});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:n}}}e.$Bw=L,e.$Cw=(0,A.$ri)("fileDialogService");var C;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function y(l){const g=[];return g.push(...l.slice(0,m).map(c=>typeof c=="string"?c:(0,u.$2g)(c))),l.length>m&&(l.length-m===1?g.push((0,M.localize)(7,null)):g.push((0,M.localize)(8,null,l.length-m))),g.push(""),g.join(`
`)}function v(l,g){const c=(0,$.$Xn)(l);let n=(c.buttons??[]).map(t=>(0,R.$xw)(t)),i=(l.buttons||[]).map((t,d)=>d),s=0,r=c.cancelId??n.length-1;if(n.length>1){const t=typeof r=="number"?n[r]:void 0;if(w.$k||w.$j){if(typeof t=="string"&&n.length>1&&r!==1){n.splice(r,1),n.splice(1,0,t);const d=i[r];i.splice(r,1),i.splice(1,0,d),r=1}w.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),s=n.length-1,typeof t=="string"&&(r=s-1))}else if(w.$i&&typeof t=="string"&&n.length>1&&r!==n.length-1){n.splice(r,1),n.push(t);const d=i[r];i.splice(r,1),i.push(d),r=n.length-1}}return c.buttons=n,c.defaultId=s,c.cancelId=r,c.noLink=!0,c.title=c.title||g.nameLong,{options:c,buttonIndeces:i}}}),define(ke[136],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=void 0,e.$yi=(0,u.$ri)("environmentService"),e.$zi=(0,u.$si)(e.$yi)}),define(ke[137],Se([1,0,207,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.ExtensionGalleryErrorCode=e.$2o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$1o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$Uo=M,e.$Vo=A,e.$Wo=R,e.$Xo=w,e.$Yo=$,e.$Zo=S,e.$Oo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Po=new RegExp(e.$Oo),e.$Qo="__web_extension",e.$Ro="skipWalkthrough",e.$So="extensionsSync",e.$To="dependecyOrPackExtensionInstall";function M(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(i,s){switch(i){case 3:return s==="x64"?"win32-x64":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function w(i,s){return s==="web"&&!i.includes("web")}function $(i,s,r){return w(s,r)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===r}function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var L;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var C;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(i){i.Install="install",i.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var y;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$1o=(0,N.$ri)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var l;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class g extends Error{constructor(s,r){super(s),this.code=r,this.name=r}}e.$2o=g;var c;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class n extends Error{constructor(s,r){super(s),this.code=r,this.name=r}}e.$3o=n,e.$4o=(0,N.$ri)("extensionManagementService"),e.$5o="extensionsIdentifiers/disabled",e.$6o="extensionsIdentifiers/enabled",e.$7o=(0,N.$ri)("IGlobalExtensionEnablementService"),e.$8o=(0,N.$ri)("IExtensionTipsService"),e.$9o=(0,u.localize2)(0,"Extensions"),e.$0o=(0,u.localize2)(1,"Preferences")}),define(ke[249],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=e.$M6b=void 0,e.$M6b=(0,u.$ri)("externalTerminal"),e.$N6b="Terminal.app"}),define(ke[250],Se([1,0,53,55,15,17,11,102,31,105,209,249]),function(le,e,u,N,M,A,R,w,$,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=e.$Vbc=e.$Ubc=void 0;const m=L.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends y{static{this.b="cmd.exe"}openTerminal(r,t){return this.spawnTerminal(u,r,S.$jm(),t)}spawnTerminal(r,t,d,a){const h=t.windowsExec||v.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const o=A.$oc(h,".exe").toLowerCase();if(o==="cmder")return r.spawn(h,a?[a]:void 0),Promise.resolve(void 0);const p=["/c","start","/wait"];return h.indexOf(" ")>=0&&p.push('""'),p.push(h),o==="wt"&&p.push("-d ."),new Promise((f,D)=>{const b=c(process),k=r.spawn(d,p,{cwd:a,env:b,detached:!0});k.on("error",D),k.on("exit",()=>f())})}async runInTerminal(r,t,d,a,h){const o="windowsExec"in h&&h.windowsExec?h.windowsExec:v.getDefaultTerminalWindows(),p=await v.f();return new Promise((f,D)=>{const b=`"${t} - ${m}"`,k=`"${d.join('" "')}" & pause`,E=Object.assign({},c(process),a);Object.keys(E).filter(z=>E[z]===null).forEach(z=>delete E[z]);const P={cwd:t,env:E,windowsVerbatimArguments:!0};let I,F;A.$oc(o,".exe")==="wt"?(I=o,F=["-d",".",v.b,"/c",k]):p?(I=p,F=["-d",".",o,"/c",k]):(I=v.b,F=["/c","start",b,"/wait",o,"/c",`"${k}"`]),u.spawn(I,F,P).on("error",z=>{D(n(z))}),f(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const r=await S.win32.findExecutable("wt");return await $.Promises.exists(r)?r:void 0}catch{return}}}e.$Ubc=v,Qe([N.$Vh],v,"f",null);class l extends y{static{this.b="/usr/bin/osascript"}openTerminal(r,t){return this.spawnTerminal(u,r,t)}runInTerminal(r,t,d,a,h){const o=h.osxExec||C.$N6b;return new Promise((p,f)=>{if(o===C.$N6b||o==="iTerm.app"){const D=o===C.$N6b?"TerminalHelper":"iTermHelper",k=[M.$Lg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",r||m,"-w",t];for(const I of d)k.push("-a"),k.push(I);if(a){const I=Object.assign({},c(process),a);for(const F in I){const j=I[F];j===null?(k.push("-u"),k.push(F)):(k.push("-e"),k.push(`${F}=${j}`))}}let E="";const P=u.spawn(l.b,k);P.on("error",I=>{f(n(I))}),P.stderr.on("data",I=>{E+=I.toString()}),P.on("exit",I=>{if(I===0)p(void 0);else if(E){const F=E.split(`
`,1);f(new Error(F[0]))}else f(new Error(L.localize(1,null,D,I)))})}else f(new Error(L.localize(2,null,o)))})}spawnTerminal(r,t,d){const a=t.osxExec||C.$N6b;return new Promise((h,o)=>{const p=["-a",a];d&&p.push(d);const f=c(process),D=r.spawn("/usr/bin/open",p,{cwd:d,env:f});D.on("error",o),D.on("exit",()=>h())})}}e.$Vbc=l;class g extends y{static{this.b=L.localize(3,null)}openTerminal(r,t){return this.spawnTerminal(u,r,t)}runInTerminal(r,t,d,a,h){const o=h.linuxExec?Promise.resolve(h.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((p,f)=>{const D=[];o.then(b=>{b.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const k=`${i(d)}; echo; read -p "${g.b}" -n1;`;D.push(`''${k}''`);const E=Object.assign({},c(process),a);Object.keys(E).filter(j=>E[j]===null).forEach(j=>delete E[j]);const P={cwd:t,env:E};let I="";const F=u.spawn(b,D,P);F.on("error",j=>{f(n(j))}),F.stderr.on("data",j=>{I+=j.toString()}),F.on("exit",j=>{if(j===0)p(void 0);else if(I){const z=I.split(`
`,1);f(new Error(z[0]))}else f(new Error(L.localize(4,null,b,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!R.$k)g.d=Promise.resolve("xterm");else{const r=await $.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{r?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(r,t,d){const a=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((h,o)=>{a.then(p=>{const f=c(process),D=r.spawn(p,[],{cwd:d,env:f});D.on("error",o),D.on("exit",()=>h())})})}}e.$Wbc=g;function c(s){const r={...s.env};return(0,w.$hm)(r),r}function n(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(L.localize(5,null,s.path)):s}function i(s){let r="";for(const t of s)t.indexOf(" ")>=0?r+='"'+t+'"':r+=t,r+=" ";return r}}),define(ke[32],Se([1,0,77,17,14,18,2,210,5,11,15,46]),function(le,e,u,N,M,A,R,w,$,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$ql=e.FileKind=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.FileOperationResult=e.$il=e.$hl=e.$gl=e.$el=e.FileChangeType=e.$dl=e.FileOperation=e.$0k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$Xk=void 0,e.$Yk=m,e.$Zk=g,e.$1k=n,e.$2k=i,e.$3k=s,e.$4k=r,e.$5k=t,e.$6k=d,e.$7k=a,e.$8k=h,e.$9k=o,e.$$k=D,e.$_k=b,e.$al=k,e.$bl=E,e.$cl=P,e.$fl=O,e.$rl=Y,e.$sl=x,e.$ul=ge,e.$Xk=(0,$.$ri)("fileService");function m(ue){return ue.create===!0}var y;(function(ue){ue[ue.Unknown=0]="Unknown",ue[ue.File=1]="File",ue[ue.Directory=2]="Directory",ue[ue.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var v;(function(ue){ue[ue.Readonly=1]="Readonly",ue[ue.Locked=2]="Locked"})(v||(e.FilePermission=v={}));var l;(function(ue){ue[ue.UPDATED=2]="UPDATED",ue[ue.ADDED=4]="ADDED",ue[ue.DELETED=8]="DELETED"})(l||(e.FileChangeFilter=l={}));function g(ue){const ve=ue;return!!ve&&typeof ve.onDidChange=="function"}var c;(function(ue){ue[ue.None=0]="None",ue[ue.FileReadWrite=2]="FileReadWrite",ue[ue.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ue[ue.FileReadStream=16]="FileReadStream",ue[ue.FileFolderCopy=8]="FileFolderCopy",ue[ue.PathCaseSensitive=1024]="PathCaseSensitive",ue[ue.Readonly=2048]="Readonly",ue[ue.Trash=4096]="Trash",ue[ue.FileWriteUnlock=8192]="FileWriteUnlock",ue[ue.FileAtomicRead=16384]="FileAtomicRead",ue[ue.FileAtomicWrite=32768]="FileAtomicWrite",ue[ue.FileAtomicDelete=65536]="FileAtomicDelete",ue[ue.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function n(ue){return!!(ue.capabilities&2)}function i(ue){return!!(ue.capabilities&8)}function s(ue){return!!(ue.capabilities&131072)}function r(ue){return!!(ue.capabilities&4)}function t(ue){return!!(ue.capabilities&16)}function d(ue){return n(ue)?!!(ue.capabilities&16384):!1}function a(ue){return n(ue)?!!(ue.capabilities&32768):!1}function h(ue){return!!(ue.capabilities&65536)}function o(ue){return!!(ue.capabilities&2048)}var p;(function(ue){ue.FileExists="EntryExists",ue.FileNotFound="EntryNotFound",ue.FileNotADirectory="EntryNotADirectory",ue.FileIsADirectory="EntryIsADirectory",ue.FileExceedsStorageQuota="EntryExceedsStorageQuota",ue.FileTooLarge="EntryTooLarge",ue.FileWriteLocked="EntryWriteLocked",ue.NoPermissions="NoPermissions",ue.Unavailable="Unavailable",ue.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class f extends Error{static create(ve,te){const U=new f(ve.toString(),te);return k(U,te),U}constructor(ve,te){super(ve),this.code=te}}e.$0k=f;function D(ue,ve){return f.create(ue,ve)}function b(ue){return ue||D((0,w.localize)(0,null),p.Unknown)}function k(ue,ve){return ue.name=ve?`${ve} (FileSystemError)`:"FileSystemError",ue}function E(ue){if(!ue)return p.Unknown;if(ue instanceof f)return ue.code;const ve=/^(.+) \(FileSystemError\)$/.exec(ue.name);if(!ve)return p.Unknown;switch(ve[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}function P(ue){if(ue instanceof T)return ue.fileOperationResult;switch(E(ue)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}var I;(function(ue){ue[ue.CREATE=0]="CREATE",ue[ue.DELETE=1]="DELETE",ue[ue.MOVE=2]="MOVE",ue[ue.COPY=3]="COPY",ue[ue.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class F{constructor(ve,te,U){this.resource=ve,this.operation=te,this.target=U}isOperation(ve){return this.operation===ve}}e.$dl=F;var j;(function(ue){ue[ue.UPDATED=0]="UPDATED",ue[ue.ADDED=1]="ADDED",ue[ue.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class z{static{this.a=null}constructor(ve,te){this.c=te,this.b=void 0,this.d=new C.$V(()=>{const U=u.$xi.forUris(()=>this.c);return U.fill(this.rawAdded.map(_=>[_,!0])),U}),this.f=new C.$V(()=>{const U=u.$xi.forUris(()=>this.c);return U.fill(this.rawUpdated.map(_=>[_,!0])),U}),this.g=new C.$V(()=>{const U=u.$xi.forUris(()=>this.c);return U.fill(this.rawDeleted.map(_=>[_,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of ve){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==z.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(ve,...te){return this.h(ve,{includeChildren:!1},...te)}affects(ve,...te){return this.h(ve,{includeChildren:!0},...te)}h(ve,te,...U){if(!ve)return!1;const _=U.length>0;return!!((!_||U.includes(1))&&(this.d.value.get(ve)||te.includeChildren&&this.d.value.findSuperstr(ve))||(!_||U.includes(0))&&(this.f.value.get(ve)||te.includeChildren&&this.f.value.findSuperstr(ve))||(!_||U.includes(2))&&(this.g.value.findSubstr(ve)||te.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$el=z;function O(ue,ve,te){return!ue||!ve||ue===ve||ve.length>ue.length?!1:(ve.charAt(ve.length-1)!==N.sep&&(ve+=N.sep),te?(0,M.$vf)(ue,ve):ue.indexOf(ve)===0)}class T extends Error{constructor(ve,te,U){super(ve),this.fileOperationResult=te,this.options=U}}e.$gl=T;class B extends T{constructor(ve,te,U,_){super(ve,te,_),this.fileOperationResult=te,this.size=U}}e.$hl=B;class W extends T{constructor(ve,te,U){super(ve,2,U),this.stat=te}}e.$il=W;var X;(function(ue){ue[ue.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ue[ue.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ue[ue.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ue[ue.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ue[ue.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ue[ue.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ue[ue.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ue[ue.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ue[ue.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ue[ue.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ue[ue.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$jl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$kl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ll="files.associations",e.$ml="files.exclude",e.$nl="files.readonlyInclude",e.$ol="files.readonlyExclude",e.$pl="files.readonlyFromPermissions";var Z;(function(ue){ue[ue.FILE=0]="FILE",ue[ue.FOLDER=1]="FOLDER",ue[ue.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$ql="";function Y(ue){if(!(typeof ue.size!="number"||typeof ue.mtime!="number"))return ue.mtime.toString(29)+ue.size.toString(31)}async function x(ue,ve){if(!ve.hasProvider(R.URI.from({scheme:ue.scheme})))return new Promise(te=>{const U=ve.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===ue.scheme&&_.added&&(U.dispose(),te())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(ve){return(0,A.$9f)(ve)||(ve=0),ve<ne.KB?(0,w.localize)(1,null,ve.toFixed(0)):ve<ne.MB?(0,w.localize)(2,null,(ve/ne.KB).toFixed(2)):ve<ne.GB?(0,w.localize)(3,null,(ve/ne.MB).toFixed(2)):ve<ne.TB?(0,w.localize)(4,null,(ve/ne.GB).toFixed(2)):(0,w.localize)(5,null,(ve/ne.TB).toFixed(2))}}e.$tl=ne;function ge(ue){const ve=typeof ue=="string"||ue?.scheme===L.Schemas.vscodeRemote;return typeof ue!="string"&&ue?.scheme===L.Schemas.file?1024*ne.MB:ve?10*ne.MB:S.$o?50*ne.MB:1024*ne.MB}}),define(ke[251],Se([1,0,21,13,211,32]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=R;async function R(L,C,m,y,v,l){let g;try{await w(L,C,m,y,v,l)}catch(c){g=c}finally{g&&v.errorTransformer&&(g=v.errorTransformer(g)),typeof g<"u"&&m.error(g),m.end()}}async function w(L,C,m,y,v,l){$(l);const g=await L.open(C,{create:!1});try{$(l);let c=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,s=u.$Ce.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),r=v&&typeof v.position=="number"?v.position:0,t=0;do n=await L.read(g,r,s.buffer,t,s.byteLength-t),r+=n,t+=n,c+=n,typeof i=="number"&&(i-=n),t===s.byteLength&&(await m.write(y(s)),s=u.$Ce.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&$(l)&&S(c,v));if(t>0){let d=t;typeof i=="number"&&(d=Math.min(t,i)),m.write(y(s.slice(0,d)))}}catch(c){throw(0,A.$_k)(c)}finally{await L.close(g)}}function $(L){if(L.isCancellationRequested)throw(0,N.$6)();return!0}function S(L,C){if(typeof C?.limits?.size=="number"&&L>C.limits.size)throw(0,A.$$k)((0,M.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],Se([1,0,35,3,17,11,2,32]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=void 0,e.$Eq=$,e.$Fq=S,e.$Jq=y,e.$Kq=v,e.$Lq=l,e.$Mq=g,e.$Nq=n,e.$Oq=i;function $(s){return typeof s.correlationId=="number"}function S(s){return s.recursive===!0}class L extends N.$Uc{static{this.a=5}constructor(r,t,d,a){super(),this.h=r,this.j=t,this.m=d,this.n=a,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const r=new N.$Tc;this.c.value=r,this.b=this.r(r),this.b.setVerboseLogging(this.m),r.add(this.b.onDidChangeFile(t=>this.h(t))),r.add(this.b.onDidLogMessage(t=>this.j(t))),r.add(this.b.onDidError(t=>this.t(t)))}t(r){this.n.restartOnError?this.g<L.a&&this.f?(this.w(`restarting watcher after error: ${r}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${r}`):this.w(r)}u(r){this.g++,this.s(),this.watch(r)}async watch(r){this.f=r,await this.b?.watch(r)}async setVerboseLogging(r){this.m=r,await this.b?.setVerboseLogging(r)}w(r){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${r}`})}y(r){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${r}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Gq=L;class C extends L{constructor(r,t,d){super(r,t,d,{type:"node.js",restartOnError:!1})}}e.$Hq=C;class m extends L{constructor(r,t,d){super(r,t,d,{type:"universal",restartOnError:!0})}}e.$Iq=m;function y(s){return s.map(r=>({type:r.type,resource:R.URI.revive(r.resource),cId:r.cId}))}function v(s){const r=new c;for(const t of s)r.processEvent(t);return r.coalesce()}function l(s,r){return typeof r=="string"&&!r.startsWith(u.$hk)&&!(0,M.$jc)(r)?{base:s,pattern:r}:r}function g(s,r){const t=[];for(const d of r)t.push((0,u.$lk)(l(s,d)));return t}class c{constructor(){this.a=new Set,this.b=new Map}c(r){return A.$k?r.resource.fsPath:r.resource.fsPath.toLowerCase()}processEvent(r){const t=this.b.get(this.c(r));let d=!1;if(t){const a=t.type,h=r.type;t.resource.fsPath!==r.resource.fsPath&&(r.type===2||r.type===1)?d=!0:a===1&&h===2?(this.b.delete(this.c(r)),this.a.delete(t)):a===2&&h===1?t.type=0:a===1&&h===0||(t.type=h)}else d=!0;d&&(this.a.add(r),this.b.set(this.c(r),r))}coalesce(){const r=[],t=[];return Array.from(this.a).filter(d=>d.type!==2?(r.push(d),!1):!0).sort((d,a)=>d.resource.fsPath.length-a.resource.fsPath.length).filter(d=>t.some(a=>(0,w.$fl)(d.resource.fsPath,a,!A.$k))?!1:(t.push(d.resource.fsPath),!0)).concat(r)}}function n(s,r){if(typeof r=="number")switch(s.type){case 1:return(r&4)===0;case 2:return(r&8)===0;case 0:return(r&2)===0}return!1}function i(s){if(typeof s=="number"){const r=[];return s&4&&r.push("Added"),s&8&&r.push("Deleted"),s&2&&r.push("Updated"),r.length===0?"<all>":r.join(", ")}return"<none>"}}),define(ke[252],Se([1,0,52,3,65,4,2,8]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;class $ extends N.$Uc{constructor(){super(),this.a=this.B(new A.$be),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$be),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$be),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new w.$Oh,this.B(this.f(L=>this.s(L)))}s(L){this.t(L)&&this.w(L)}t(L){return(0,M.$Eq)(L)}async watch(L){this.r.isSettled||this.r.complete(),this.r=new w.$Oh;try{this.h.clear(),this.g.clear();for(const C of L)this.t(C)?this.h.set(C.correlationId,C):this.g.add(C);for(const[C]of this.j)this.h.has(C)||(this.j.deleteAndDispose(C),this.m.delete(C));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(L=>!this.j.has(L.correlationId))])}isSuspended(L){return typeof L.correlationId!="number"?!1:this.m.has(L.correlationId)?"polling":this.j.has(L.correlationId)}async w(L){if(this.j.has(L.correlationId))return;const C=new N.$Tc;this.j.set(L.correlationId,C),await this.r.p,!C.isDisposed&&(this.z(L,C),this.u())}y(L){this.j.deleteAndDispose(L.correlationId),this.m.delete(L.correlationId),this.u()}z(L,C){this.C(L,C)?(this.M(`reusing an existing recursive watcher to monitor ${L.path}`),this.m.delete(L.correlationId)):(this.D(L,C),this.m.add(L.correlationId))}C(L,C){const m=this.L?.subscribe(L.path,(y,v)=>{C.isDisposed||(y?this.z(L,C):v?.type===1&&this.F(L))});return m?(C.add(m),!0):!1}D(L,C){let m=!1;const y=(v,l)=>{if(C.isDisposed)return;const g=this.G(v),c=this.G(l),n=m;m=g,!g&&(c||n)&&this.F(L)};this.M(`starting fs.watchFile() on ${L.path} (correlationId: ${L.correlationId})`);try{(0,u.watchFile)(L.path,{persistent:!1,interval:this.n},y)}catch(v){this.N(`fs.watchFile() failed with error ${v} on path ${L.path} (correlationId: ${L.correlationId})`)}C.add((0,N.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${L.path} (correlationId: ${L.correlationId})`);try{(0,u.unwatchFile)(L.path,y)}catch(v){this.N(`fs.unwatchFile() failed with error ${v} on path ${L.path} (correlationId: ${L.correlationId})`)}}))}F(L){this.M(`detected ${L.path} exists again, resuming watcher (correlationId: ${L.correlationId})`);const C={resource:R.URI.file(L.path),type:1,cId:L.correlationId};this.a.fire([C]),this.H(C,L),this.y(L)}G(L){return L.ctimeMs===0&&L.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(L,C){const m=` >> normalized ${L.type===1?"[ADDED]":L.type===2?"[DELETED]":"[CHANGED]"} ${L.resource.fsPath}`;this.M(typeof C.correlationId=="number"?`${m} (correlationId: ${C.correlationId})`:m)}I(L){return`${L.path} (excludes: ${L.excludes.length>0?L.excludes:"<none>"}, includes: ${L.includes&&L.includes.length>0?JSON.stringify(L.includes):"<all>"}, filter: ${(0,M.$Oq)(L.filter)}, correlationId: ${typeof L.correlationId=="number"?L.correlationId:"<none>"})`}}e.$Xq=$}),define(ke[253],Se([1,0,52,8,22,34,3,76,17,11,23,2,104,31,65]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0,e.$4q=g;class l extends R.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,i,s,r,t,d){super(),this.s=n,this.t=i,this.u=s,this.w=r,this.y=t,this.z=d,this.c=this.B(new N.$Gh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},a=>this.u(a))),this.f=this.B(new N.$Fh(a=>this.M(a),l.b)),this.g=(0,v.$Mq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,v.$Mq)(this.s.path,this.s.includes):void 0,this.j=(0,v.$Eq)(this.s)?this.s.filter:void 0,this.m=new M.$me,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const i=await y.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let i=n.path;try{i=await y.Promises.realpath(n.path),n.path===i&&(i=await(0,m.$Zq)(n.path,this.m.token)??n.path),n.path!==i&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async G(n,i){const s=new R.$Tc;return this.H(n,i,s)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,i,s)),s}H(n,i,s){if(i)return!1;const r=C.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(d,a)=>{if(!s.isDisposed)if(d){const h=await this.G(n,i);s.isDisposed?h.dispose():s.add(h)}else a&&(typeof a.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:r,type:a.type,cId:this.s.correlationId},!0)});return t?(s.add(t),!0):!1}async I(n,i,s){if(S.$j&&(0,A.$rg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const r=new M.$me(this.m.token);s.add((0,R.$Sc)(()=>r.dispose(!0)));const t=new R.$Tc;s.add(t);try{const d=C.URI.file(this.s.path),a=(0,$.$oc)(n),h=(0,u.watch)(n);t.add((0,R.$Sc)(()=>{h.removeAllListeners(),h.close()})),this.Q(`Started watching: '${n}'`);const o=new Set;if(i)try{for(const f of await y.Promises.readdir(n))o.add(f)}catch(f){this.O(f)}if(r.token.isCancellationRequested)return;const p=new Map;t.add((0,R.$Sc)(()=>{for(const[,f]of p)f.dispose();p.clear()})),h.on("error",(f,D)=>{r.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${f}, ${D})`),this.D())}),h.on("change",(f,D)=>{if(r.token.isCancellationRequested)return;this.Q(`[raw] ["${f}"] ${D}`);let b="";if(D&&(b=D.toString(),S.$j&&(b=(0,w.$9l)(b))),!(!b||f!=="change"&&f!=="rename"))if(i)if(f==="rename"){p.get(b)?.dispose();const k=setTimeout(async()=>{if(p.delete(b),b===a&&!await y.Promises.exists(n)){this.J(d);return}if(r.token.isCancellationRequested)return;const E=await this.N((0,$.$kc)(n,b));if(r.token.isCancellationRequested)return;let P;E?o.has(b)?P=0:(P=1,o.add(b)):(o.delete(b),P=2),this.L({resource:(0,L.$5g)(d,b),type:P,cId:this.s.correlationId})},l.a);p.set(b,(0,R.$Sc)(()=>clearTimeout(k)))}else{let k;o.has(b)?k=0:(k=1,o.add(b)),this.L({resource:(0,L.$5g)(d,b),type:k,cId:this.s.correlationId})}else if(f==="rename"||b!==a){const k=setTimeout(async()=>{const E=await y.Promises.exists(n);r.token.isCancellationRequested||(E?(this.L({resource:d,type:0,cId:this.s.correlationId},!0),t.add(await this.G(n,!1))):this.J(d))},l.a);t.clear(),t.add((0,R.$Sc)(()=>clearTimeout(k)))}else this.L({resource:d,type:0,cId:this.s.correlationId},!0)})}catch(d){r.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${d.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,i=!1){this.m.token.isCancellationRequested||(this.z&&this.Q(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(s=>s(n.resource.fsPath))?this.z&&this.Q(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(s=>s(n.resource.fsPath))?this.z&&this.Q(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const i=(0,v.$Kq)(n),s=[];for(const t of i){if((0,v.$Nq)(t,this.j)){this.z&&this.Q(` >> ignored (filtered) ${t.resource.fsPath}`);continue}s.push(t)}if(s.length===0)return;if(this.z)for(const t of s)this.Q(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(S.$k)return y.Promises.exists(n);try{const i=(0,$.$oc)(n);return(await y.Promises.readdir((0,$.$nc)(n))).some(r=>r===i)}catch(i){return this.Q(i),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.m.dispose(!0),super.dispose()}}e.$3q=l;async function g(c,n,i,s,r=512){const t=await y.Promises.open(c,"r"),d=Buffer.allocUnsafe(r),a=new M.$me(s);let h,o=!1;const p={path:c,excludes:[],recursive:!1},f=new l(p,void 0,D=>{(async()=>{for(const{type:b}of D)if(b===0){if(o)return;o=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:k}=await y.Promises.read(t,d,0,r,null);if(!k||a.token.isCancellationRequested)break;n(d.slice(0,k))}}catch(k){h=new Error(k),a.dispose(!0)}finally{o=!1}}})()});return await f.ready,i(),new Promise((D,b)=>{a.token.onCancellationRequested(async()=>{f.dispose();try{await y.Promises.close(t)}catch(k){h=new Error(k)}h?b(h):D()})})}}),define(ke[254],Se([1,0,4,35,252,11,253,34]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;class $ extends M.$Xq{constructor(L){super(),this.L=L,this.onDidError=u.Event.None,this.watchers=new Set,this.O=!1}async J(L){L=this.W(L);const C=[],m=new Set(Array.from(this.watchers));for(const y of L){const v=this.R(y);v&&(0,N.$pk)(v.request.excludes,y.excludes)&&(0,N.$pk)(v.request.includes,y.includes)?m.delete(v):C.push(y)}C.length&&this.M(`Request to start watching: ${C.map(y=>this.I(y)).join(",")}`),m.size&&this.M(`Request to stop watching: ${Array.from(m).map(y=>this.I(y.request)).join(",")}`);for(const y of m)this.U(y);for(const y of C)this.S(y)}R(L){for(const C of this.watchers)if(typeof L.correlationId=="number"||typeof C.request.correlationId=="number"){if(C.request.correlationId===L.correlationId)return C}else if((0,w.$qg)(C.request.path,L.path,!A.$k))return C}S(L){const C=new R.$3q(L,this.L,y=>this.a.fire(y),()=>this.c.fire(L),y=>this.b.fire(y),this.O),m={request:L,instance:C};this.watchers.add(m)}async stop(){await super.stop();for(const L of this.watchers)this.U(L)}U(L){this.M("stopping file watcher",L),this.watchers.delete(L),L.instance.dispose()}W(L){const C=new Map;for(const m of L){const y=A.$k?m.path:m.path.toLowerCase();let v=C.get(m.correlationId);v||(v=new Map,C.set(m.correlationId,v)),v.has(y)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I(m)}`),v.set(y,m)}return Array.from(C.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(L){this.O=L;for(const C of this.watchers)C.instance.setVerboseLogging(L)}M(L,C){this.O&&this.b.fire({type:"trace",message:this.Z(L,C)})}N(L){this.b.fire({type:"warn",message:this.Z(L)})}Z(L,C){return C?`[File Watcher (node.js)] ${L} (${this.I(C.request)})`:`[File Watcher (node.js)] ${L}`}}e.$5q=$}),define(ke[255],Se([1,0,65,254]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class M extends u.$Hq{constructor(R,w,$){super(R,w,$),this.s()}r(R){return R.add(new N.$5q(void 0))}}e.$6q=M}),define(ke[256],Se([1,0,15,81,194,65]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;class R extends A.$Iq{constructor($,S,L){super($,S,L),this.s()}r($){const S=$.add(new M.$Vq(u.$Lg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(S.onDidProcessExit(({code:L,signal:C})=>this.t(`terminated by itself with code ${L}, signal: ${C}`))),N.ProxyChannel.toService((0,N.$$h)(S.getChannel("watcher")))}}e.$Wq=R}),define(ke[107],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=void 0;class u{constructor(...M){this.a=new Map;for(const[A,R]of M)this.set(A,R)}set(M,A){const R=this.a.get(M);return this.a.set(M,A),R}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$pi=u}),define(ke[257],Se([1,0,8,13,3,106,247,5,107,75]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=void 0;const L=!1;class C extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class m{constructor(g=new $.$pi,c=!1,n,i=L){this.i=g,this.j=c,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(w.$qi,this),this._globalGraph=i?n?._globalGraph??new R.$9q(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,M.$Pc)(this.h),this.h.clear();for(const g of this.g)(0,M.$Oc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const c=new class extends m{dispose(){this.h.delete(c),super.dispose()}}(g,this.j,this,this.l);return this.h.add(c),c}invokeFunction(g,...c){this.m();const n=v.traceInvocation(this.l,g);let i=!1;try{return g({get:r=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(r,n);if(!t)throw new Error(`[invokeFunction] unknown service '${r}'`);return t}},...c)}finally{i=!0,n.stop()}}createInstance(g,...c){this.m();let n,i;return g instanceof A.$oi?(n=v.traceCreation(this.l,g.ctor),i=this.o(g.ctor,g.staticArguments.concat(c),n)):(n=v.traceCreation(this.l,g),i=this.o(g,c,n)),n.stop(),i}o(g,c=[],n){const i=w._util.getServiceDependencies(g).sort((t,d)=>t.index-d.index),s=[];for(const t of i){const d=this.s(t.id,n);d||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(d)}const r=i.length>0?i[0].index:c.length;if(c.length!==r){console.trace(`[createInstance] First service dependency of ${g.name} at position ${r+1} conflicts with ${c.length} static arguments`);const t=r-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,r)}return Reflect.construct(g,c.concat(s))}q(g,c){if(this.i.get(g)instanceof A.$oi)this.i.set(g,c);else if(this.k)this.k.q(g,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const c=this.i.get(g);return!c&&this.k?this.k.r(g):c}s(g,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const n=this.r(g);return n instanceof A.$oi?this.u(g,n,c.branch(g,!0)):(c.branch(g,!1),n)}u(g,c,n){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,c,n)}finally{this.t.delete(g)}}v(g,c,n){const i=new R.$9q(t=>t.id.toString());let s=0;const r=[{id:g,desc:c,_trace:n}];for(;r.length;){const t=r.pop();if(i.lookupOrInsertNode(t),s++>1e3)throw new C(i);for(const d of w._util.getServiceDependencies(t.desc.ctor)){const a=this.r(d.id);if(a||this.y(`[createInstance] ${g} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),a instanceof A.$oi){const h={id:d.id,desc:a,_trace:t._trace.branch(d.id,!0)};i.insertEdge(t,h),r.push(h)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new C(i);break}for(const{data:d}of t){if(this.r(d.id)instanceof A.$oi){const h=this.w(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.q(d.id,h)}i.removeNode(d)}}return this.r(g)}w(g,c,n=[],i,s){if(this.i.get(g)instanceof A.$oi)return this.x(g,c,n,i,s,this.g);if(this.k)return this.k.w(g,c,n,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(g,c,n=[],i,s,r){if(i){const t=new m(void 0,this.j,this,this.l);t.c=String(g);const d=new Map,a=new u.$Kh(()=>{const h=t.o(c,n,s);for(const[o,p]of d){const f=h[o];if(typeof f=="function")for(const D of p)D.disposable=f.apply(h,D.listener)}return d.clear(),r.add(h),h});return new Proxy(Object.create(null),{get(h,o){if(!a.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let D=d.get(o);return D||(D=new S.$5c,d.set(o,D)),(k,E,P)=>{if(a.isInitialized)return a.value[o](k,E,P);{const I={listener:[k,E,P],disposable:void 0},F=D.push(I);return(0,M.$Sc)(()=>{F(),I.disposable?.dispose()})}}}if(o in h)return h[o];const p=a.value;let f=p[o];return typeof f!="function"||(f=f.bind(p),h[o]=f),f},set(h,o,p){return a.value[o]=p,!0},getPrototypeOf(h){return c.prototype}})}else{const t=this.o(c,n,s);return r.add(t),t}}y(g,c){if(c&&console.warn(g),this.j)throw new Error(g)}}e.$0q=m;var y;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(y||(y={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,c){return g?new v(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(g,c){return g?new v(1,c.name):v.c}static{this.f=0}constructor(g,c){this.type=g,this.name=c,this.g=Date.now(),this.h=[]}branch(g,c){const n=new v(3,g.toString());return this.h.push([g,c,n]),n}stop(){const g=Date.now()-this.g;v.f+=g;let c=!1;function n(s,r){const t=[],d=new Array(s+1).join("	");for(const[a,h,o]of r.h)if(h&&o){c=!0,t.push(`${d}CREATES -> ${a}`);const p=n(s+1,o);p&&t.push(p)}else t.push(`${d}uses -> ${a}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(g>2||c)&&v.all.add(i.join(`
`))}}e.$$q=v}),define(ke[12],Se([1,0,213,47,4,56,3,27,11,23,18,2,37,5]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$1j=e.LogLevel=e.$Yj=e.$Xj=void 0,e.$Zj=l,e.log=c,e.$_j=f,e.$ak=D,e.$bk=b,e.$ck=k,e.$Xj=(0,y.$ri)("logService"),e.$Yj=(0,y.$ri)("loggerService");function v(){return new Date().toISOString()}function l(E){return(0,L.$9f)(E)}var g;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$1j=g.Info;function c(E,P,I){switch(P){case g.Trace:E.trace(I);break;case g.Debug:E.debug(I);break;case g.Info:E.info(I);break;case g.Warning:E.warn(I);break;case g.Error:E.error(I);break;case g.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function n(E,P=!1){let I="";for(let F=0;F<E.length;F++){let j=E[F];if(j instanceof Error&&(j=(0,N.$cj)(j,P)),typeof j=="object")try{j=JSON.stringify(j)}catch{}I+=(F>0?" ":"")+j}return I}class i extends R.$Uc{constructor(){super(...arguments),this.b=e.$1j,this.c=this.B(new M.$be),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==g.Off&&this.b<=P}}e.$3j=i;class s extends i{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...I){this.f(g.Trace)&&this.g(g.Trace,n([P,...I],!0))}debug(P,...I){this.f(g.Debug)&&this.g(g.Debug,n([P,...I]))}info(P,...I){this.f(g.Info)&&this.g(g.Info,n([P,...I]))}warn(P,...I){this.f(g.Warning)&&this.g(g.Warning,n([P,...I]))}error(P,...I){if(this.f(g.Error))if(P instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=P.stack,this.g(g.Error,n(F))}else this.g(g.Error,n([P,...I]))}flush(){}}e.$4j=s;class r extends i{constructor(P=e.$1j){super(),this.setLevel(P),this.g=!$.$i}trace(P,...I){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}debug(P,...I){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}info(P,...I){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}warn(P,...I){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,P,...I):console.warn(`[main ${v()}]`,P,...I))}error(P,...I){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,P,...I):console.error(`[main ${v()}]`,P,...I))}flush(){}}e.$5j=r;class t extends i{constructor(P=e.$1j,I=!0){super(),this.g=I,this.setLevel(P)}trace(P,...I){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...I):console.log(P,...I))}debug(P,...I){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...I):console.log(P,...I))}info(P,...I){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...I):console.log(P,...I))}warn(P,...I){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...I):console.log(P,...I))}error(P,...I){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...I):console.error(P,...I))}flush(){}}e.$6j=t;class d extends i{constructor(P,I=e.$1j){super(),this.g=P,this.setLevel(I)}trace(P,...I){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(P),...I])}debug(P,...I){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(P),...I])}info(P,...I){this.f(g.Info)&&this.g.log(g.Info,[this.h(P),...I])}warn(P,...I){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(P),...I])}error(P,...I){this.f(g.Error)&&this.g.log(g.Error,[this.h(P),...I])}h(P){return typeof P=="string"?P:(0,N.$cj)(P,this.f(g.Trace))}flush(){}}e.$7j=d;class a extends i{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const I of this.g)I.setLevel(P);super.setLevel(P)}trace(P,...I){for(const F of this.g)F.trace(P,...I)}debug(P,...I){for(const F of this.g)F.debug(P,...I)}info(P,...I){for(const F of this.g)F.info(P,...I)}warn(P,...I){for(const F of this.g)F.warn(P,...I)}error(P,...I){for(const F of this.g)F.error(P,...I)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$8j=a;class h extends R.$Uc{constructor(P,I,F){if(super(),this.h=P,this.j=I,this.b=new w.$Bc,this.c=this.B(new M.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$be),this.onDidChangeVisibility=this.g.event,F)for(const j of F)this.b.set(j.resource,{logger:void 0,info:j})}m(P){return(0,L.$5f)(P)?[...this.b.values()].find(I=>I.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,I){const F=this.n(P),j=(0,L.$5f)(P)?P:I?.id??(0,A.$fj)(F.toString()).toString(16);let z=this.b.get(F)?.logger;const O=I?.logLevel==="always"?g.Trace:I?.logLevel;z||(z=this.s(F,O??this.getLogLevel(F)??this.h,{...I,id:j}));const T={logger:z,info:{resource:F,id:j,logLevel:O,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(T.info),this.b.set(F,T),z}n(P){return(0,L.$5f)(P)?(0,S.$5g)(this.j,`${P}.log`):P}setLogLevel(P,I){if(C.URI.isUri(P)){const F=P,j=I,z=this.b.get(F);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([F,j]))}else{this.h=P;for(const[F,j]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,I){const F=this.m(P);F&&I!==!F.info.hidden&&(F.info.hidden=!I,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,I]))}getLogLevel(P){let I;return P&&(I=this.b.get(P)?.info.logLevel),I??this.h}registerLogger(P){const I=this.b.get(P.resource);I?I.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const I=this.b.get(P);I&&(I.logger&&I.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$9j=h;class o{constructor(){this.onDidChangeLogLevel=new M.$be().event}setLevel(P){}getLevel(){return g.Info}trace(P,...I){}debug(P,...I){}info(P,...I){}warn(P,...I){}error(P,...I){}critical(P,...I){}dispose(){}flush(){}}e.$0j=o;class p extends o{}e.$$j=p;function f(E){if(E.verbose)return g.Trace;if(typeof E.logLevel=="string"){const P=k(E.logLevel.toLowerCase());if(P!==void 0)return P}return e.$1j}function D(E){switch(E){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function b(E){switch(E){case g.Trace:return{original:"Trace",value:u.localize(0,null)};case g.Debug:return{original:"Debug",value:u.localize(1,null)};case g.Info:return{original:"Info",value:u.localize(2,null)};case g.Warning:return{original:"Warning",value:u.localize(3,null)};case g.Error:return{original:"Error",value:u.localize(4,null)};case g.Off:return{original:"Off",value:u.localize(5,null)}}}function k(E){switch(E){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$dk=new m.$Ij("logLevel",D(g.Info))}),define(ke[258],Se([1,0,19,8,13,4,3,17,65,12]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class L extends R.$Uc{constructor(m,y){super(),this.a=m,this.b=y,this.c=this.B(new A.$be),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$be),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$ph(0)),this.w=[],this.y=this.B(new N.$ph(0))}watch(m,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(m,y):this.z(m,y)}n(m,y){const v={path:this.I(m),excludes:y.excludes,includes:y.includes,recursive:y.recursive,filter:y.filter,correlationId:y.correlationId},l=(0,u.$Ub)(this.j,v);return this.r(),(0,R.$Sc)(()=>{l(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,M.$1)(m))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,$.$Jq)(y)),y=>this.G(y),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const y of this.j)(0,$.$Fq)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const y of this.j)(0,$.$Fq)(y)&&m.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,y){const v={path:this.I(m),excludes:y.excludes,includes:y.includes,recursive:!1,filter:y.filter,correlationId:y.correlationId},l=(0,u.$Ub)(this.w,v);return this.C(),(0,R.$Sc)(()=>{l(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,M.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$Jq)(m)),m=>this.G(m),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,w.$ic)(m.fsPath)}}e.$Pq=L}),define(ke[259],Se([1,0,52,396,8,27,21,4,34,3,17,11,23,98,31,212,32,251,258,47,256,255]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0,(()=>{try{(0,N.gracefulify)(u)}catch(d){console.error(`Error enabling graceful-fs: ${(0,i.$cj)(d)}`)}})();class t extends n.$Pq{static{this.J=!1}constructor(a,h){super(a,h),this.onDidChangeCapabilities=w.Event.None,this.O=new A.$Bc(o=>m.$Vg.getComparisonKey(o)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,C.$k&&(this.L|=1024)),this.L}async stat(a){try{const{stat:h,symbolicLink:o}=await v.SymlinkSupport.stat(this.I(a));return{type:this.N(h,o),ctime:h.birthtime.getTime(),mtime:h.mtime.getTime(),size:h.size,permissions:h.mode&128?void 0:g.FilePermission.Locked}}catch(h){throw this.gb(h)}}async M(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const h=await v.Promises.readdir(this.I(a),{withFileTypes:!0}),o=[];return await Promise.all(h.map(async p=>{try{let f;p.isSymbolicLink()?f=(await this.stat((0,m.$5g)(a,p.name))).type:f=this.N(p),o.push([p.name,f])}catch(f){this.a.trace(f)}})),o}catch(h){throw this.gb(h)}}N(a,h){let o;return h?.dangling?o=g.FileType.Unknown:a.isFile()?o=g.FileType.File:a.isDirectory()?o=g.FileType.Directory:o=g.FileType.Unknown,h&&(o|=g.FileType.SymbolicLink),o}async P(a){const h=this.I(a);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${h})`);let o;for(;o=this.O.get(a);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${h})`),await o.wait();const p=new M.$qh;return this.O.set(a,p),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${h})`),(0,S.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${h})`),this.O.get(a)===p&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${h})`),this.O.delete(a)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${h})`),p.open()})}async readFile(a,h){let o;try{h?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(a)})`),o=await this.P(a));const p=this.I(a);return await v.Promises.readFile(p)}catch(p){throw this.gb(p)}finally{o?.dispose()}}Q(a){t.J&&this.a.trace(a)}readFileStream(a,h,o){const p=(0,y.$qe)(f=>R.$Ce.concat(f.map(D=>R.$Ce.wrap(D))).buffer);return(0,c.$Cq)(this,a,p,f=>f.buffer,{...h,bufferSize:256*1024},o),p}async writeFile(a,h,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.R(a)?this.S(a,(0,m.$5g)((0,m.$4g)(a),`${(0,m.$2g)(a)}${o.atomic.postfix}`),h,o):this.U(a,h,o)}async R(a){try{const h=this.I(a),{symbolicLink:o}=await v.SymlinkSupport.stat(h);if(o)return!1}catch{}return!0}async S(a,h,o,p){const f=new S.$Tc;try{f.add(await this.P(a)),f.add(await this.P(h)),await this.U(h,o,p,!0);try{await this.rename(h,a,{overwrite:!0})}catch(D){try{await this.delete(h,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{f.dispose()}}async U(a,h,o,p){let f;try{const D=this.I(a);if(!o.create||!o.overwrite){if(await v.Promises.exists(D)){if(!o.overwrite)throw(0,g.$$k)((0,l.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,g.$$k)((0,l.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(a,{create:!0,unlock:o.unlock},p),await this.write(f,0,h,0,h.byteLength)}catch(D){throw await this.hb(a,D)}finally{typeof f=="number"&&await this.close(f)}}static{this.Z=!0}static configureFlushOnWrite(a){t.Z=a}async open(a,h,o){const p=this.I(a);let f;(0,g.$Yk)(h)&&!o&&(f=await this.P(a));let D;try{if((0,g.$Yk)(h)&&h.unlock)try{const{stat:k}=await v.SymlinkSupport.stat(p);k.mode&128||await v.Promises.chmod(p,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let b;if((0,g.$Yk)(h)){if(C.$i)try{await v.Promises.truncate(p,0),b="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}b||(b="w")}else b="r";D=await v.Promises.open(p,b)}catch(b){throw f?.dispose(),(0,g.$Yk)(h)?await this.hb(a,b):this.gb(b)}if(this.W.set(D,0),(0,g.$Yk)(h)&&this.Y.set(D,a),f){const b=this.X.get(D);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${p})`),this.X.set(D,f),b&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${p})`),b.dispose())}return D}async close(a){const h=this.X.get(a);try{if(this.W.delete(a),this.Y.delete(a)&&t.Z)try{await v.Promises.fdatasync(a)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await v.Promises.close(a)}catch(o){throw this.gb(o)}finally{h&&(this.X.get(a)===h&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.X.delete(a)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),h.dispose())}}async read(a,h,o,p,f){const D=this.$(a,h);let b=null;try{b=(await v.Promises.read(a,o,p,f,D)).bytesRead}catch(k){throw this.gb(k)}finally{this.ab(a,D,b)}return b}$(a,h){return h===this.W.get(a)?null:h}ab(a,h,o){const p=this.W.get(a);typeof p=="number"&&(typeof h=="number"||(typeof o=="number"?this.W.set(a,p+o):this.W.delete(a)))}async write(a,h,o,p,f){return(0,M.$Lh)(()=>this.bb(a,h,o,p,f),100,3)}async bb(a,h,o,p,f){const D=this.$(a,h);let b=null;try{b=(await v.Promises.write(a,o,p,f,D)).bytesWritten}catch(k){throw await this.hb(this.Y.get(a),k)}finally{this.ab(a,D,b)}return b}async mkdir(a){try{await v.Promises.mkdir(this.I(a))}catch(h){throw this.gb(h)}}async delete(a,h){try{const o=this.I(a);if(h.recursive){let p;h?.atomic!==!1&&h.atomic.postfix&&(p=(0,L.$kc)((0,L.$nc)(o),`${(0,L.$oc)(o)}${h.atomic.postfix}`)),await v.Promises.rm(o,v.RimRafMode.MOVE,p)}else try{await v.Promises.unlink(o)}catch(p){if(p.code==="EPERM"||p.code==="EISDIR"){let f=!1;try{const{stat:D,symbolicLink:b}=await v.SymlinkSupport.stat(o);f=D.isDirectory()&&!b}catch{}if(f)await v.Promises.rmdir(o);else throw p}else throw p}}catch(o){throw this.gb(o)}}async rename(a,h,o){const p=this.I(a),f=this.I(h);if(p!==f)try{await this.cb(a,h,"move",o.overwrite),await v.Promises.rename(p,f)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,l.localize)(2,null,(0,L.$oc)(p),(0,L.$oc)((0,L.$nc)(f)),D.toString()))),this.gb(D)}}async copy(a,h,o){const p=this.I(a),f=this.I(h);if(p!==f)try{await this.cb(a,h,"copy",o.overwrite),await v.Promises.copy(p,f,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,l.localize)(3,null,(0,L.$oc)(p),(0,L.$oc)((0,L.$nc)(f)),D.toString()))),this.gb(D)}}async cb(a,h,o,p){const f=this.I(a),D=this.I(h);let b=!1;if(!!(this.capabilities&1024)||(b=(0,$.$qg)(f,D,!0)),b){if(o==="copy")throw(0,g.$$k)((0,l.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const E=await this.M(a);if(!E)throw(0,g.$$k)((0,l.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const P=await this.M(h);if(P){if(!p)throw(0,g.$$k)((0,l.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);E.type&g.FileType.File&&P.type&g.FileType.File||await this.delete(h,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,h){return this.db(a,h,!1)}async db(a,h,o){const p=this.I(a),f=this.I(h),D=!!(this.capabilities&1024);if((0,$.$qg)(p,f,!D))return;const b=new S.$Tc;try{b.add(await this.P(a)),b.add(await this.P(h)),o&&await v.Promises.mkdir((0,L.$nc)(f),{recursive:!0}),await v.Promises.copyFile(p,f)}catch(k){if(k.code==="ENOENT"&&!o)return this.db(a,h,!0);throw this.gb(k)}finally{b.dispose()}}t(a,h,o){return new s.$Wq(p=>a(p),p=>h(p),o)}F(a,h,o){return new r.$6q(p=>a(p),p=>h(p),o)}gb(a){if(a instanceof g.$0k)return a;let h=a,o;switch(a.code){case"ENOENT":o=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":h=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=g.FileSystemProviderErrorCode.Unknown;break;default:o=g.FileSystemProviderErrorCode.Unknown}return(0,g.$$k)(h,o)}async hb(a,h){let o=this.gb(h);if(a&&o.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await v.SymlinkSupport.stat(this.I(a));p.mode&128||(o=(0,g.$$k)(h,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.a.trace(p)}return o}}e.$7q=t}),define(ke[260],Se([1,0,3,12]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=void 0;class M extends u.$Uc{constructor(R,w=[]){super(),this.a=new N.$8j([R,...w]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...w){this.a.trace(R,...w)}debug(R,...w){this.a.debug(R,...w)}info(R,...w){this.a.info(R,...w)}warn(R,...w){this.a.warn(R,...w)}error(R,...w){this.a.error(R,...w)}flush(){this.a.flush()}}e.$DQ=M}),define(ke[261],Se([1,0,32,12]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=void 0;var M;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(M||(M={}));async function A(S,L,C,m,y){try{const v=await new Promise((g,c)=>{le(["@vscode/spdlog"],g,c)});v.setFlushOn(M.Trace);const l=await v.createAsyncRotatingLogger(S,L,C,m);return y?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(v){console.error(v)}return null}function R(S,L,C){switch(L){case N.LogLevel.Trace:S.trace(C);break;case N.LogLevel.Debug:S.debug(C);break;case N.LogLevel.Info:S.info(C);break;case N.LogLevel.Warning:S.warn(C);break;case N.LogLevel.Error:S.error(C);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function w(S,L){switch(L){case N.LogLevel.Trace:S.setLevel(M.Trace);break;case N.LogLevel.Debug:S.setLevel(M.Debug);break;case N.LogLevel.Info:S.setLevel(M.Info);break;case N.LogLevel.Warning:S.setLevel(M.Warning);break;case N.LogLevel.Error:S.setLevel(M.Error);break;case N.LogLevel.Off:S.setLevel(M.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class $ extends N.$4j{constructor(L,C,m,y,v){super(),this.m=[],this.setLevel(v),this.n=this.s(L,C,m,y),this.B(this.onDidChangeLogLevel(l=>{this.r&&w(this.r,l)}))}async s(L,C,m,y){const v=m?6:1,l=30/v*u.$tl.MB,g=await A(L,C,l,v,y);if(g){this.r=g,w(this.r,this.getLevel());for(const{level:c,message:n}of this.m)R(this.r,c,n);this.m=[]}}g(L,C){this.r?R(this.r,L,C):this.getLevel()<=L&&this.m.push({level:L,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$sQ=$}),define(ke[138],Se([1,0,41,214,5]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function S(v,l){return l-v}$.compare=S;const L=Object.create(null);L[$.Error]=(0,N.localize)(0,null),L[$.Warning]=(0,N.localize)(1,null),L[$.Info]=(0,N.localize)(2,null);function C(v){return L[v]||""}$.toString=C;function m(v){switch(v){case u.default.Error:return $.Error;case u.default.Warning:return $.Warning;case u.default.Info:return $.Info;case u.default.Ignore:return $.Hint}}$.fromSeverity=m;function y(v){switch(v){case $.Error:return u.default.Error;case $.Warning:return u.default.Warning;case $.Info:return u.default.Info;case $.Hint:return u.default.Ignore}}$.toSeverity=y}(R||(e.MarkerSeverity=R={}));var w;(function($){const S="";function L(m){return C(m,!0)}$.makeKey=L;function C(m,y){const v=[S];return m.source?v.push(m.source.replace("\xA6","\\\xA6")):v.push(S),m.code?typeof m.code=="string"?v.push(m.code.replace("\xA6","\\\xA6")):v.push(m.code.value.replace("\xA6","\\\xA6")):v.push(S),m.severity!==void 0&&m.severity!==null?v.push(R.toString(m.severity)):v.push(S),m.message&&y?v.push(m.message.replace("\xA6","\\\xA6")):v.push(S),m.startLineNumber!==void 0&&m.startLineNumber!==null?v.push(m.startLineNumber.toString()):v.push(S),m.startColumn!==void 0&&m.startColumn!==null?v.push(m.startColumn.toString()):v.push(S),m.endLineNumber!==void 0&&m.endLineNumber!==null?v.push(m.endLineNumber.toString()):v.push(S),m.endColumn!==void 0&&m.endColumn!==null?v.push(m.endColumn.toString()):v.push(S),v.push(S),v.join("\xA6")}$.makeKeyOptionalMessage=C})(w||(e.IMarkerData=w={})),e.$Wt=(0,M.$ri)("markerService")}),define(ke[262],Se([1,0,4,41,5]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zv=e.$Yv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Wv=e.Severity=void 0,e.$Xv=w,e.Severity=N.default,e.$Wv=(0,M.$ri)("notificationService");var A;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var R;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function w(C){if(C){const m=C;return typeof m.id=="string"&&typeof m.label=="string"}return!1}var $;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class S{constructor(){this.progress=new L,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(m){}updateMessage(m){}updateActions(m){}close(){}}e.$Yv=S;class L{infinite(){}done(){}total(m){}worked(m){}}e.$Zv=L}),define(ke[263],Se([1,0,51]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.context<"u"){const A=M.context.configuration();if(A)N=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,u.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:A.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ke[139],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ek=void 0,e.$ek=(0,u.$ri)("productService"),e.$fk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(le,e){return function(u,N){e(u,N,le)}};define(ke[108],Se([1,0,8,22,3,5]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.ProgressLocation=e.$1v=void 0,e.$1v=(0,A.$ri)("progressService");var R;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$2v=Object.freeze({total(){},worked(){},done(){}});class w{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$3v=w;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const y=this.d;this.d=()=>{y?.(),m()}}):Promise.resolve()}}e.$4v=$;let S=class extends M.$Uc{constructor(m,y){super(),this.a=new u.$Oh,y.withProgress(m,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$5v=S,e.$5v=S=Qe([Ve(1,e.$1v)],S);class L extends M.$Uc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new M.$Tc)}start(m){this.stop();const y=++this.a,v=new N.$me;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>v.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:y,token:v.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$6v=L,e.$7v=(0,A.$ri)("editorProgressService")}),define(ke[38],Se([1,0,62,18]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0;class M{constructor(){this.a=new Map}add(R,w){u.ok(N.$5f(R)),u.ok(N.$7f(w)),u.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,w)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$0n=new M}),define(ke[109],Se([1,0,4,38]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=void 0,e.$$n={JSONContribution:"base.contributions.json"};function M(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class A{constructor(){this.b=new u.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,S){this.a[M($)]=S,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;N.$0n.add(e.$$n.JSONContribution,R)}),define(ke[85],Se([1,0,19,4,18,203,54,109,38]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.ConfigurationScope=e.$co=e.EditPresentationTypes=void 0,e.$no=l,e.$oo=g,e.$po=c,e.$qo=i,e.$ro=s;var S;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.$co={Configuration:"base.contributions.configuration"};var L;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo="vscode://schemas/settings/resourceLanguage",e.$ko="vscode://schemas/settings/configurationDefaults";const C=$.$0n.as(w.$$n.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.$be,this.onDidSchemaChange=this.i.event,this.j=new N.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$jo,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const a=new Set;this.n(t,d,a),C.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const d=new Set;this.o(t,d),C.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const a=new Set;this.o(d,a),this.n(t,!1,a),C.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const a=[];for(const{overrides:h,source:o}of t)for(const p in h)if(d.add(p),e.$mo.test(p)){const f=this.a.get(p),D=f?.valuesSources??new Map;if(o)for(const P of Object.keys(h[p]))D.set(P,o);const b={...f?.value||{},...h[p]};this.a.set(p,{source:o,value:b,valuesSources:D});const k=(0,R.$8i)(p),E={type:"object",default:b,description:A.localize(1,null,k),$ref:e.$jo,defaultDefaultValue:b,source:M.$5f(o)?void 0:o,defaultValueSource:o};a.push(...l(p)),this.d[p]=E,this.b.properties[p]=E}else{this.a.set(p,{value:h[p],source:o});const f=this.d[p];f&&(this.w(p,f),this.r(p,f))}this.m(a)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:a,source:h}of t)for(const o in a){const p=this.a.get(o),f=M.$5f(h)?h:h?.id,D=M.$5f(p?.source)?p?.source:p?.source?.id;if(f===D)if(d.add(o),this.a.delete(o),e.$mo.test(o))delete this.d[o],delete this.b.properties[o];else{const b=this.d[o];b&&(this.w(o,b),this.r(o,b))}}this.u()}deltaConfiguration(t){let d=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,a){t.forEach(h=>{this.p(h,d,h.extensionInfo,h.restrictedProperties,void 0,a),this.c.push(h),this.q(h)})}o(t,d){const a=h=>{if(h.properties)for(const o in h.properties){d.add(o);const p=this.d[o];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[o],this.s(o,h.properties[o])}h.allOf?.forEach(o=>a(o))};for(const h of t){a(h);const o=this.c.indexOf(h);o!==-1&&this.c.splice(o,1)}}p(t,d=!0,a,h,o=3,p){o=M.$bg(t.scope)?o:t.scope;const f=t.properties;if(f)for(const b in f){const k=f[b];if(d&&i(b,k)){delete f[b];continue}if(k.source=a,k.defaultDefaultValue=f[b].default,this.w(b,k),e.$mo.test(b)?k.scope=void 0:(k.scope=M.$bg(k.scope)?o:k.scope,k.restricted=M.$bg(k.restricted)?!!h?.includes(b):k.restricted),f[b].hasOwnProperty("included")&&!f[b].included){this.f[b]=f[b],delete f[b];continue}else this.d[b]=f[b],f[b].policy?.name&&this.e.set(f[b].policy.name,b);!f[b].deprecationMessage&&f[b].markdownDeprecationMessage&&(f[b].deprecationMessage=f[b].markdownDeprecationMessage),p.add(b)}const D=t.allOf;if(D)for(const b of D)this.p(b,d,a,h,o,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=a=>{const h=a.properties;if(h)for(const p in h)this.r(p,h[p]);a.allOf?.forEach(d)};d(t)}r(t,d){switch(e.$do.properties[t]=d,d.scope){case 1:e.$eo.properties[t]=d;break;case 2:e.$fo.properties[t]=d;break;case 6:e.$go.properties[t]=d;break;case 3:e.$ho.properties[t]=d;break;case 4:e.$io.properties[t]=d;break;case 5:e.$io.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.$do.properties[t],d.scope){case 1:delete e.$eo.properties[t];break;case 2:delete e.$fo.properties[t];break;case 6:delete e.$go.properties[t];break;case 3:delete e.$ho.properties[t];break;case 4:case 5:delete e.$io.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,a={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$jo};this.w(d,a),e.$do.properties[d]=a,e.$eo.properties[d]=a,e.$fo.properties[d]=a,e.$go.properties[d]=a,e.$ho.properties[d]=a,e.$io.properties[d]=a}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$jo};e.$do.patternProperties[e.$lo]=t,e.$eo.patternProperties[e.$lo]=t,e.$fo.patternProperties[e.$lo]=t,e.$go.patternProperties[e.$lo]=t,e.$ho.patternProperties[e.$lo]=t,e.$io.patternProperties[e.$lo]=t,this.i.fire()}w(t,d){const a=this.a.get(t);let h=a?.value,o=a?.source;M.$_f(h)&&(h=d.defaultDefaultValue,o=void 0),M.$_f(h)&&(h=c(d.type)),d.default=h,d.defaultValueSource=o}}const y="\\[([^\\]]+)\\]",v=new RegExp(y,"g");e.$lo=`^(${y})+$`,e.$mo=new RegExp(e.$lo);function l(r){const t=[];if(e.$mo.test(r)){let d=v.exec(r);for(;d?.length;){const a=d[1].trim();a&&t.push(a),d=v.exec(r)}}return(0,u.$Mb)(t)}function g(r){return r.reduce((t,d)=>`${t}[${d}]`,"")}function c(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new m;$.$0n.add(e.$co.Configuration,n);function i(r,t){return r.trim()?e.$mo.test(r)?A.localize(7,null,r):n.getConfigurationProperties()[r]!==void 0?A.localize(8,null,r):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,r,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function s(){const r=[],t=n.getConfigurationProperties();for(const d of Object.keys(t))r.push([d,t[d].scope]);return r.push(["launch",4]),r.push(["task",4]),r}}),define(ke[264],Se([1,0,19,4,164,3,27,24,18,2,54,85,38]),function(le,e,u,N,M,A,R,w,$,S,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$vo=e.$uo=e.$to=e.$so=void 0,e.$wo=i;function y(d){return Object.isFrozen(d)?d:w.$Yn(d)}class v{static createEmptyModel(a){return new v({},[],[],void 0,a)}constructor(a,h,o,p,f){this.b=a,this.c=h,this.d=o,this.raw=p,this.f=f,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(h=>{if(h instanceof v)return h;const o=new l("",this.f);return o.parseRaw(h),o.configurationModel});this.g=a.reduce((h,o)=>o===h?o:h.merge(o),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,L.$6i)(this.contents,a):this.contents}inspect(a,h){const o=this;return{get value(){return y(o.rawConfiguration.getValue(a))},get override(){return h?y(o.rawConfiguration.getOverrideValue(a,h)):void 0},get merged(){return y(h?o.rawConfiguration.override(h).getValue(a):o.rawConfiguration.getValue(a))},get overrides(){const p=[];for(const{contents:f,identifiers:D,keys:b}of o.rawConfiguration.overrides){const k=new v(f,b,[],void 0,o.f).getValue(a);k!==void 0&&p.push({identifiers:D,value:k})}return p.length?y(p):void 0}}}getOverrideValue(a,h){const o=this.j(h);return o?a?(0,L.$6i)(o,a):o:void 0}getKeysForOverrideIdentifier(a){const h=[];for(const o of this.overrides)o.identifiers.includes(a)&&h.push(...o.keys);return u.$Mb(h)}getAllOverrideIdentifiers(){const a=[];for(const h of this.overrides)a.push(...h.identifiers);return u.$Mb(a)}override(a){let h=this.a.get(a);return h||(h=this.h(a),this.a.set(a,h)),h}merge(...a){const h=w.$Xn(this.contents),o=w.$Xn(this.overrides),p=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const D of a)if(f.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(h,D.contents);for(const b of D.overrides){const[k]=o.filter(E=>u.$ub(E.identifiers,b.identifiers));k?(this.i(k.contents,b.contents),k.keys.push(...b.keys),k.keys=u.$Mb(k.keys)):o.push(w.$Xn(b))}for(const b of D.keys)p.indexOf(b)===-1&&p.push(b)}return new v(h,p,o,f.every(D=>D instanceof v)?void 0:f,this.f)}h(a){const h=this.j(a);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const o={};for(const p of u.$Mb([...Object.keys(this.contents),...Object.keys(h)])){let f=this.contents[p];const D=h[p];D&&(typeof f=="object"&&typeof D=="object"?(f=w.$Xn(f),this.i(f,D)):f=D),o[p]=f}return new v(o,this.keys,this.overrides,void 0,this.f)}i(a,h){for(const o of Object.keys(h)){if(o in a&&$.$7f(a[o])&&$.$7f(h[o])){this.i(a[o],h[o]);continue}a[o]=w.$Xn(h[o])}}j(a){let h=null,o=null;const p=f=>{f&&(o?this.i(o,f):o=w.$Xn(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===a?h=f.contents:f.identifiers.includes(a)&&p(f.contents);return p(h),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,h){this.k(a,h,!0)}setValue(a,h){this.k(a,h,!1)}removeValue(a){const h=this.keys.indexOf(a);h!==-1&&(this.keys.splice(h,1),(0,L.$5i)(this.contents,a),C.$mo.test(a)&&this.overrides.splice(this.overrides.findIndex(o=>u.$ub(o.identifiers,(0,C.$no)(a))),1))}k(a,h,o){(0,L.$4i)(this.contents,a,h,p=>this.f.error(p)),o=o||this.keys.indexOf(a)===-1,o&&this.keys.push(a),C.$mo.test(a)&&this.overrides.push({identifiers:(0,C.$no)(a),keys:Object.keys(this.contents[a]),contents:(0,L.$3i)(this.contents[a],p=>this.f.error(p))})}}e.$so=v;class l{constructor(a,h){this.f=a,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||v.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,h){if(!$.$bg(a)){const o=this.h(a);this.parseRaw(o,h)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,h){this.a=a;const{contents:o,keys:p,overrides:f,restricted:D,hasExcludedProperties:b}=this.i(a,h);this.b=new v(o,p,f,b?[a]:void 0,this.g),this.c=D||[]}h(a){let h={},o=null,p=[];const f=[],D=[];function b(E){Array.isArray(p)?p.push(E):o!==null&&(p[o]=E)}const k={onObjectBegin:()=>{const E={};b(E),f.push(p),p=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{p=f.pop()},onArrayBegin:()=>{const E=[];b(E),f.push(p),p=E,o=null},onArrayEnd:()=>{p=f.pop()},onLiteralValue:b,onError:(E,P,I)=>{D.push({error:E,offset:P,length:I})}};if(a)try{M.$Ln(a,k),h=p[0]||{}}catch(E){this.g.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return h}i(a,h){const o=m.$0n.as(C.$co.Configuration).getConfigurationProperties(),p=this.j(a,o,!0,h);a=p.raw;const f=(0,L.$3i)(a,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`)),D=Object.keys(a),b=this.l(a,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:f,keys:D,overrides:b,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}j(a,h,o,p){let f=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:f};const D={},b=[];for(const k in a)if(C.$mo.test(k)&&o){const E=this.j(a[k],h,!1,p);D[k]=E.raw,f=f||E.hasExcludedProperties,b.push(...E.restricted)}else{const E=h[k],P=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&b.push(k),!p.exclude?.includes(k)&&(p.include?.includes(k)||(P===void 0||p.scopes===void 0||p.scopes.includes(P))&&!(p.skipRestricted&&E?.restricted))?D[k]=a[k]:f=!0}return{raw:D,restricted:b,hasExcludedProperties:f}}l(a,h){const o=[];for(const p of Object.keys(a))if(C.$mo.test(p)){const f={};for(const D in a[p])f[D]=a[p][D];o.push({identifiers:(0,C.$no)(p),keys:Object.keys(f),contents:(0,L.$3i)(f,h)})}return o}}e.$to=l;class g extends A.$Uc{constructor(a,h,o,p,f){super(),this.c=a,this.f=h,this.g=p,this.h=f,this.b=this.B(new N.$be),this.onDidChange=this.b.event,this.a=new l(this.c.toString(),f),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&o.isEqual(D.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return v.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$uo=g;class c{constructor(a,h,o,p,f,D,b,k,E,P,I,F,j){this.a=a,this.b=h,this.c=o,this.overrideIdentifiers=p,this.d=f,this.f=D,this.g=b,this.h=k,this.i=E,this.j=P,this.k=I,this.l=F,this.m=j}get value(){return y(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,h,o,p,f,D,b,k,E,P){this.j=a,this.l=h,this.m=o,this.n=p,this.p=f,this.q=D,this.r=b,this.s=k,this.t=E,this.u=P,this.h=null,this.i=new R.$Bc,this.v=null}getValue(a,h,o){return this.w(a,h,o).getValue(a)}updateValue(a,h,o={}){let p;o.resource?(p=this.t.get(o.resource),p||(p=v.createEmptyModel(this.u),this.t.set(o.resource,p))):p=this.s,h===void 0?p.removeValue(a):p.setValue(a,h),o.resource||(this.h=null)}inspect(a,h,o){const p=this.w(a,h,o),f=this.A(h.resource,o),D=h.resource?this.t.get(h.resource)||this.s:this.s,b=new Set;for(const k of p.overrides)for(const E of k.identifiers)p.getOverrideValue(a,E)!==void 0&&b.add(E);return new c(a,h,p.getValue(a),b.size?[...b]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,f||void 0,D)}keys(a){const h=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,h){this.r.set(a,h),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,h){const o=[];if(!h){const{added:p,updated:f,removed:D}=r(this.j,a);h=[...p,...f,...D]}for(const p of h)for(const f of(0,C.$no)(p)){const D=this.j.getKeysForOverrideIdentifier(f),b=a.getKeysForOverrideIdentifier(f),k=[...b.filter(E=>D.indexOf(E)===-1),...D.filter(E=>b.indexOf(E)===-1),...D.filter(E=>!w.$2n(this.j.override(f).getValue(E),a.override(f).getValue(E)))];o.push([f,k])}return this.updateDefaultConfiguration(a),{keys:h,overrides:o}}compareAndUpdatePolicyConfiguration(a){const{added:h,updated:o,removed:p}=r(this.l,a),f=[...h,...o,...p];return f.length&&this.updatePolicyConfiguration(a),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:h,updated:o,removed:p,overrides:f}=r(this.applicationConfiguration,a),D=[...h,...o,...p];return D.length&&this.updateApplicationConfiguration(a),{keys:D,overrides:f}}compareAndUpdateLocalUserConfiguration(a){const{added:h,updated:o,removed:p,overrides:f}=r(this.localUserConfiguration,a),D=[...h,...o,...p];return D.length&&this.updateLocalUserConfiguration(a),{keys:D,overrides:f}}compareAndUpdateRemoteUserConfiguration(a){const{added:h,updated:o,removed:p,overrides:f}=r(this.remoteUserConfiguration,a),D=[...h,...o,...p];return D.length&&this.updateRemoteUserConfiguration(a),{keys:D,overrides:f}}compareAndUpdateWorkspaceConfiguration(a){const{added:h,updated:o,removed:p,overrides:f}=r(this.workspaceConfiguration,a),D=[...h,...o,...p];return D.length&&this.updateWorkspaceConfiguration(a),{keys:D,overrides:f}}compareAndUpdateFolderConfiguration(a,h){const o=this.folderConfigurations.get(a),{added:p,updated:f,removed:D,overrides:b}=r(o,h),k=[...p,...f,...D];return(k.length||!o)&&this.updateFolderConfiguration(a,h),{keys:k,overrides:b}}compareAndDeleteFolderConfiguration(a){const h=this.folderConfigurations.get(a);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:o,updated:p,removed:f,overrides:D}=r(h,void 0);return{keys:[...o,...p,...f],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,h,o){let p=this.x(h,o);return h.overrideIdentifier&&(p=p.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(p=p.merge(this.l)),p}x({resource:a},h){let o=this.y();if(h&&a){const p=h.getFolder(a);p&&(o=this.z(p.uri)||o);const f=this.t.get(a);f&&(o=o.merge(f))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let h=this.i.get(a);if(!h){const o=this.y(),p=this.r.get(a);p?(h=o.merge(p),this.i.set(a,h)):h=o}return h}A(a,h){if(h&&a){const o=h.getFolder(a);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,h)=>{const{contents:o,overrides:p,keys:f}=this.r.get(h);return a.push([h,{contents:o,overrides:p,keys:f}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(h=>a.add(h)),this.userConfiguration.keys.forEach(h=>a.add(h)),this.q.keys.forEach(h=>a.add(h)),this.r.forEach(h=>h.keys.forEach(o=>a.add(o))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>a.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>a.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>a.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(o=>a.add(o))),[...a.values()]}D(a){const h=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(o=>h.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(o=>h.add(o)),this.q.getKeysForOverrideIdentifier(a).forEach(o=>h.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(a).forEach(p=>h.add(p))),[...h.values()]}static parse(a,h){const o=this.E(a.defaults,h),p=this.E(a.policy,h),f=this.E(a.application,h),D=this.E(a.user,h),b=this.E(a.workspace,h),k=a.folders.reduce((E,P)=>(E.set(S.URI.revive(P[0]),this.E(P[1],h)),E),new R.$Bc);return new n(o,p,f,D,v.createEmptyModel(h),b,k,v.createEmptyModel(h),new R.$Bc,h)}static E(a,h){return new v(a.contents,a.keys,a.overrides,void 0,h)}}e.$vo=n;function i(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const a=new Set,h=new Map;for(const p of d)p.keys.forEach(f=>a.add(f)),p.overrides.forEach(([f,D])=>{const b=(0,R.$yc)(h,f,new Set);D.forEach(k=>b.add(k))});const o=[];return h.forEach((p,f)=>o.push([f,[...p.values()]])),{keys:[...a.values()],overrides:o}}class s{constructor(a,h,o,p,f){this.change=a,this.f=h,this.g=o,this.h=p,this.i=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of a.keys)this.affectedKeys.add(D);for(const[,D]of a.overrides)for(const b of D)this.affectedKeys.add(b);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,h){const o=this.a+a,p=this.d.indexOf(o);if(p<0)return!1;const f=p+o.length;if(f>=this.d.length)return!1;const D=this.d.charCodeAt(f);if(D!==this.b&&D!==this.c)return!1;if(h){const b=this.previousConfiguration?this.previousConfiguration.getValue(a,h,this.f?.workspace):void 0,k=this.g.getValue(a,h,this.h);return!w.$2n(b,k)}return!0}}e.$xo=s;function r(d,a){const{added:h,removed:o,updated:p}=t(a?.rawConfiguration,d?.rawConfiguration),f=[],D=d?.getAllOverrideIdentifiers()||[],b=a?.getAllOverrideIdentifiers()||[];if(a){const k=b.filter(E=>!D.includes(E));for(const E of k)f.push([E,a.getKeysForOverrideIdentifier(E)])}if(d){const k=D.filter(E=>!b.includes(E));for(const E of k)f.push([E,d.getKeysForOverrideIdentifier(E)])}if(a&&d){for(const k of D)if(b.includes(k)){const E=t({contents:d.getOverrideValue(void 0,k)||{},keys:d.getKeysForOverrideIdentifier(k)},{contents:a.getOverrideValue(void 0,k)||{},keys:a.getKeysForOverrideIdentifier(k)});f.push([k,[...E.added,...E.removed,...E.updated]])}}return{added:h,removed:o,updated:p,overrides:f}}function t(d,a){const h=d?a?d.keys.filter(f=>a.keys.indexOf(f)===-1):[...d.keys]:[],o=a?d?a.keys.filter(f=>d.keys.indexOf(f)===-1):[...a.keys]:[],p=[];if(d&&a){for(const f of a.keys)if(d.keys.indexOf(f)!==-1){const D=(0,L.$6i)(a.contents,f),b=(0,L.$6i)(d.contents,f);w.$2n(D,b)||p.push(f)}}return{added:h,removed:o,updated:p}}}),define(ke[265],Se([1,0,21,4,3,82]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ssb=e.$Qsb=e.$Psb=void 0,e.$Rsb=w;const R=(S,L,C)=>{const m=new Uint8Array(16);for(let l=0;l<16;l++)m[l]=Math.round(Math.random()*256);const y=(0,u.$We)(u.$Ce.wrap(m));return[`GET ws://localhost${S}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$Psb=R,e.$Qsb=u.$Ce.fromString(`\r
\r
`);async function w(S,L,C,m,y){S.write(u.$Ce.fromString((0,e.$Psb)(L,C,m)));const v=new M.$Tc;try{return await new Promise((l,g)=>{let c;v.add(S.onData(n=>{c?c=u.$Ce.concat([c,n],c.byteLength+n.byteLength):c=n;const i=c.indexOf(e.$Qsb);if(i===-1)return;l(S),S.pauseData();const s=c.slice(i+e.$Qsb.byteLength);s.byteLength&&y.onData.fire(s)})),v.add(S.onClose(n=>g(n??new Error("socket closed")))),v.add(S.onEnd(()=>g(new Error("socket ended"))))})}catch(l){throw S.dispose(),l}finally{v.dispose()}}class $ extends M.$Uc{constructor(L,C){super(),this.g=L,this.a=this.B(new N.$ee),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new N.$be),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(L,C){A.SocketDiagnostics.traceSocketEvent(this,this.g,L,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Ssb=$}),define(ke[66],Se([1,0,13,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.RemoteAuthorityResolverErrorCode=e.$El=e.$Dl=e.RemoteConnectionType=e.$Cl=void 0,e.$Gl=S,e.$Cl=(0,N.$ri)("remoteAuthorityResolverService");var M;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class A{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$Dl=A;class R{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$El=R;var w;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class $ extends u.$bb{static isNotAvailable(C){return C instanceof $&&C._code===w.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===w.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===w.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===w.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=w.Unknown,y){super(C),this._message=C,this._code=m,this._detail=y,this.isHandled=m===w.NotAvailable&&y===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Fl=$;function S(L){const C=L.indexOf("+");return C===-1?L:L.substring(0,C)}}),define(ke[266],Se([1,0,8,21,22,13,4,3,15,59,40,30,82,66]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ll=D,e.$Ml=b,e.$Nl=E;const v=30*1e3;var l;(function(te){te[te.Management=1]="Management",te[te.ExtensionHost=2]="ExtensionHost",te[te.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function g(te){switch(te){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(te){const U=new M.$me;return setTimeout(()=>U.cancel(),te),U.token}function n(te,U){if(te.isCancellationRequested||U.isCancellationRequested)return M.CancellationToken.Cancelled;const _=new M.$me;return te.onCancellationRequested(()=>_.cancel()),U.onCancellationRequested(()=>_.cancel()),_.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new w.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,u.$kh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function s(te,U){const _=new i(U);return _.registerDisposable(te.onControlMessage(be=>{const Pe=JSON.parse(be.toString()),se=Y(Pe);se?_.reject(se):_.resolve(Pe)})),_.promise}function r(te,U,_,be,Pe,se,re,oe){const K=new i(oe),ie=L.$0d.create(!1);return te.info(`Creating a socket (${re})...`),S.mark(`code/willCreateSocket/${se}`),U.connect(_,be,Pe,re).then($e=>{K.didTimeout?(S.mark(`code/didCreateSocketError/${se}`),te.info(`Creating a socket (${re}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(S.mark(`code/didCreateSocketOK/${se}`),te.info(`Creating a socket (${re}) was successful after ${ie.elapsed()} ms.`),K.resolve($e))},$e=>{S.mark(`code/didCreateSocketError/${se}`),te.info(`Creating a socket (${re}) returned an error after ${ie.elapsed()} ms.`),te.error($e),K.reject($e)}),K.promise}function t(te,U){const _=new i(U);return te.then(be=>{_.didTimeout||_.resolve(be)},be=>{_.didTimeout||_.reject(be)}),_.promise}async function d(te,U,_,be){const Pe=ue(te,U);te.logService.trace(`${Pe} 1/6. invoking socketFactory.connect().`);let se;try{se=await r(te.logService,te.remoteSocketFactoryService,te.connectTo,$.$Eg.getServerRootPath(),`reconnectionToken=${te.reconnectionToken}&reconnection=${te.reconnectionProtocol?"true":"false"}`,g(U),`renderer-${g(U)}-${te.reconnectionToken}`,be)}catch($e){throw te.logService.error(`${Pe} socketFactory.connect() failed or timed out. Error:`),te.logService.error($e),$e}te.logService.trace(`${Pe} 2/6. socketFactory.connect() was successful.`);let re,oe;te.reconnectionProtocol?(te.reconnectionProtocol.beginAcceptReconnection(se,null),re=te.reconnectionProtocol,oe=!1):(re=new m.$fi({socket:se}),oe=!0),te.logService.trace(`${Pe} 3/6. sending AuthRequest control message.`);const K=await t(te.signService.createNewMessage((0,C.$Ng)()),be),ie={type:"auth",auth:te.connectionToken||"00000000000000000000",data:K.data};re.sendControl(N.$Ce.fromString(JSON.stringify(ie)));try{const $e=await s(re,n(be,c(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(te.logService.trace(`${Pe} 4/6. received SignRequest control message.`),!await t(te.signService.validate(K,$e.signedData),be)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Le=await t(te.signService.sign($e.data),be),fe={type:"connectionType",commit:te.commit,signedData:Le,desiredConnectionType:U};return _&&(fe.args=_),te.logService.trace(`${Pe} 5/6. sending ConnectionTypeRequest control message.`),re.sendControl(N.$Ce.fromString(JSON.stringify(fe))),{protocol:re,ownsProtocol:oe}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(te.logService.error(`${Pe} the handshake timed out. Error:`),te.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(te.logService.error(`${Pe} received error control message when negotiating connection. Error:`),te.logService.error($e)),oe&&Z(re),$e}}async function a(te,U,_,be){const Pe=Date.now(),se=ue(te,U),{protocol:re,ownsProtocol:oe}=await d(te,U,_,be),K=new i(be);return K.registerDisposable(re.onControlMessage(ie=>{const $e=JSON.parse(ie.toString()),we=Y($e);we?(te.logService.error(`${se} received error control message when negotiating connection. Error:`),te.logService.error(we),oe&&Z(re),K.reject(we)):(te.reconnectionProtocol?.endAcceptReconnection(),te.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${ve(Pe)}!`),K.resolve({protocol:re,firstMessage:$e}))})),K.promise}async function h(te,U){const{protocol:_}=await a(te,1,void 0,U);return{protocol:_}}async function o(te,U,_){const{protocol:be,firstMessage:Pe}=await a(te,2,U,_),se=Pe&&Pe.debugPort;return{protocol:be,debugPort:se}}async function p(te,U,_){const be=Date.now(),Pe=ue(te,3),{protocol:se}=await d(te,3,U,_);return te.logService.trace(`${Pe} 6/6. handshake finished, connection is up and running after ${ve(be)}!`),se}async function f(te,U,_){const{connectTo:be,connectionToken:Pe}=await te.addressProvider.getAddress();return{commit:te.commit,quality:te.quality,connectTo:be,connectionToken:Pe,reconnectionToken:U,reconnectionProtocol:_,remoteSocketFactoryService:te.remoteSocketFactoryService,signService:te.signService,logService:te.logService}}async function D(te,U,_){return k(te,async be=>{const{protocol:Pe}=await h(be,M.CancellationToken.None);return new W(te,U,_,be.reconnectionToken,Pe)})}async function b(te,U){return k(te,async _=>{const{protocol:be,debugPort:Pe}=await o(_,U,M.CancellationToken.None);return new X(te,U,_.reconnectionToken,be,Pe)})}async function k(te,U){for(let be=1;;be++)try{const Pe=(0,C.$Ng)(),se=await f(te,Pe,null);return await U(se)}catch(Pe){if(be<5)te.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),te.logService.error(Pe);else throw te.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),te.logService.error(Pe),B.triggerPermanentFailure(0,0,y.$Fl.isHandled(Pe)),Pe}}async function E(te,U,_){const be=await f(te,(0,C.$Ng)(),null);return await p(be,{host:U,port:_},M.CancellationToken.None)}function P(te){return(0,u.$eh)(U=>new Promise((_,be)=>{const Pe=setTimeout(_,te*1e3);U.onCancellationRequested(()=>{clearTimeout(Pe),_()})}))}var I;(function(te){te[te.ConnectionLost=0]="ConnectionLost",te[te.ReconnectionWait=1]="ReconnectionWait",te[te.ReconnectionRunning=2]="ReconnectionRunning",te[te.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",te[te.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class F{constructor(U,_){this.reconnectionToken=U,this.millisSinceLastIncomingData=_,this.type=0}}e.$Ol=F;class j{constructor(U,_,be,Pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=_,this.durationSeconds=be,this.c=Pe,this.type=1}skipWait(){this.c.cancel()}}e.$Pl=j;class z{constructor(U,_,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=_,this.attempt=be,this.type=2}}e.$Ql=z;class O{constructor(U,_,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=_,this.attempt=be,this.type=4}}e.$Rl=O;class T{constructor(U,_,be,Pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=_,this.attempt=be,this.handled=Pe,this.type=3}}e.$Sl=T;class B extends w.$Uc{static triggerPermanentFailure(U,_,be){this._permanentFailure=!0,this.f=U,this.g=_,this.h=be,this.j.forEach(Pe=>Pe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,_,be,Pe,se){super(),this.t=U,this.u=_,this.reconnectionToken=be,this.protocol=Pe,this.w=se,this.m=this.B(new R.$be),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new O(this.reconnectionToken,0,0)),this.B(Pe.onSocketClose(re=>{const oe=ge(this.t,this.reconnectionToken,!0);re?re.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${re.hadError}).`),re.error&&this.u.logService.error(re.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${re.wasClean}, code: ${re.code}, reason: ${re.reason}).`),re.event&&this.u.logService.error(re.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(Pe.onSocketTimeout(re=>{const oe=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${re.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${re.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${re.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,w.$Sc)(()=>{const re=B.j.indexOf(this);re>=0&&B.j.splice(re,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const Pe=be<_.length?_[be]:_[_.length-1];try{if(Pe>0){const re=P(Pe);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Pe,re)),this.u.logService.info(`${U} waiting for ${Pe} seconds before reconnecting...`);try{await re}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const se=await f(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${se.connectTo}...`),await this.G(se,c(v)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(se){if(se.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(y.$Fl.isTemporarilyNotAvailable(se)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((se.code==="ETIMEDOUT"||se.code==="ENETUNREACH"||se.code==="ECONNREFUSED"||se.code==="ECONNRESET")&&se.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((0,A.$4)(se)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if(se instanceof y.$Fl){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,y.$Fl.isHandled(se));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,_,be){this.w?B.triggerPermanentFailure(U,_,be):this.D(U,_,be)}D(U,_,be){this.m.fire(new T(this.reconnectionToken,U,_,be)),Z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Tl=B;class W extends B{constructor(U,_,be,Pe,se){super(1,U,Pe,se,!0),this.client=this.B(new m.$di(se,{remoteAuthority:_,clientId:be},U.ipcLogger))}async G(U,_){await h(U,_)}}e.$Ul=W;class X extends B{constructor(U,_,be,Pe,se){super(2,U,be,Pe,!1),this.H=_,this.debugPort=se}async G(U,_){await o(U,this.H,_)}}e.$Vl=X;function Z(te){try{te.acceptDisconnect();const U=te.getSocket();te.dispose(),U.dispose()}catch(U){(0,A.$1)(U)}}function Y(te){if(te&&te.type==="error"){const U=new Error(`Connection error: ${te.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function x(te,U){for(;te.length<U;)te+=" ";return te}function ne(te,U){return`[remote-connection][${x(g(te),13)}][${U.substr(0,5)}\u2026]`}function ge(te,U,_){return`${ne(te,U)}[${_?"reconnect":"initial"}]`}function ue(te,U){return`${ge(U,te.reconnectionToken,!!te.reconnectionProtocol)}[${te.connectTo}]`}function ve(te){return`${Date.now()-te} ms`}}),define(ke[86],Se([1,0,15]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=N,e.$Dm=M,e.$Em=A,e.$Fm=R;function N($){return $.scheme===u.Schemas.vscodeRemote?$.authority:void 0}function M($){if(!$)return;const S=$.indexOf("+");return S<0?$:$.substr(0,S)}function A($){const{host:S,port:L}=w($);if(typeof L>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:S,port:L}}function R($,S){let{host:L,port:C}=w($);return typeof C>"u"&&(C=S),{host:L,port:C}}function w($){const S=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const L=$.match(/^(\[[0-9a-z:]+\])$/);if(L)return{host:L[1],port:void 0};const C=$.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:$,port:void 0}}}),define(ke[25],Se([1,0,14,5,86]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Om=e.$Nm=e.$Mm=e.TargetPlatform=e.ExtensionType=e.$Lm=e.$Jm=e.$Im=e.$Hm=e.$Gm=void 0,e.$Km=A,e.$Pm=C,e.$Qm=m,e.$Rm=y,e.$Sm=v,e.$Gm="extensions.user.cache",e.$Hm="extensions.builtin.cache",e.$Im="undefined_publisher",e.$Jm=["ui","workspace","web"];function A(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.$Lm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(R||(e.ExtensionType=R={}));var w;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class ${constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,c){if(typeof g>"u"||g===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof g=="string"||typeof c=="string"){const n=typeof g=="string"?g:g.value,i=typeof c=="string"?c:c.value;return u.$uf(n,i)}return g._lower===c._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Mm=$;class S{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const c of g)this.add(c)}add(g){this.c.add($.toKey(g))}delete(g){return this.c.delete($.toKey(g))}has(g){return this.c.has($.toKey(g))}}e.$Nm=S;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete($.toKey(g))}get(g){return this.c.get($.toKey(g))}has(g){return this.c.has($.toKey(g))}set(g,c){this.c.set($.toKey(g),c)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Om=L;function C(l){return m(l)}function m(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}function y(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}function v(l,g){if(g){const c=`onResolveRemoteAuthority:${(0,M.$Dm)(g)}`;return!!l.activationEvents?.includes(c)}return!1}e.$Tm=(0,N.$ri)("IBuiltinExtensionsScannerService")}),define(ke[140],Se([1,0,13,25]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fG=e.$eG=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(R,w){this.a.set(R,w)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const w=Object.create(null);for(const $ of R){const S=this.readActivationEvents($);S.length>0&&(w[N.$Mm.toKey($.identifier)]=S)}return w}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const w=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<w.length;$++)w[$]==="onUri"&&(w[$]=`onUri:${N.$Mm.toKey(R.identifier)}`);if(!R.contributes)return w;for(const $ in R.contributes){const S=this.a.get($);if(!S)continue;const L=R.contributes[$],C=Array.isArray(L)?L:[L];try{S(C,w)}catch(m){(0,u.$1)(m)}}return w}}e.$eG=M,e.$fG=new M}),define(ke[267],Se([1,0,3,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=void 0,e.$Hl=(0,N.$ri)("remoteSocketFactoryService");class M{constructor(){this.a={}}register(R,w){return this.a[R]??=[],this.a[R].push(w),(0,u.$Sc)(()=>{const $=this.a[R]?.indexOf(w);typeof $=="number"&&$>=0&&this.a[R]?.splice($,1)})}b(R){return(this.a[R.type]||[]).find($=>$.supports(R))}connect(R,w,$,S){const L=this.b(R);if(!L)throw new Error(`No socket factory found for ${R}`);return L.connect(R,w,$,S)}}e.$Il=M}),define(ke[268],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b$b=void 0;class u{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(M){try{const A=await this.c();if(A){const R=String(u.a++);return this.b.set(R,A),{id:R,data:A.createNewMessage(M)}}}catch{}return{id:"",data:M}}async validate(M,A){if(!M.id)return!0;const R=this.b.get(M.id);if(!R)return!1;this.b.delete(M.id);try{return R.validate(A)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(M){try{return await this.d(M)}catch{}return M}}e.$b$b=u}),define(ke[110],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=void 0,e.$Jl="signService",e.$Kl=(0,u.$ri)(e.$Jl)}),define(ke[141],Se([1,0,268]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class N extends u.$b$b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(R=>new R.signer().sign(A))}h(){return new Promise((A,R)=>le(["vsda"],A,R))}}e.$0cc=N}),define(ke[269],Se([1,0,11,51,30]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=R,e.$_o=w;function A($){if(u.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,S,L,C,m,y,v,l,g){const c=Object.create(null);c["common.machineId"]=y,c["common.sqmId"]=v,c.sessionID=(0,M.$Ng)()+Date.now(),c.commitHash=C,c.version=m,c["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,u.$h)(u.$u),c["common.nodePlatform"]=N.$ec,c["common.nodeArch"]=L,c["common.product"]=g||"desktop",l&&(c["common.msftInternal"]=l);let n=0;const i=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),u.$l&&(c["common.snap"]="true");const s=A(S);return s&&(c["common.platformDetail"]=s),c}function w($){const S=N.env.USERDNSDOMAIN;if(!S)return!1;const L=S.toLowerCase();return $.some(C=>L===C)}}),define(ke[270],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0,e.$Wl=(0,u.$ri)("telemetryService"),e.$Xl=(0,u.$ri)("customEndpointTelemetryService"),e.$Yl="telemetry.currentSessionDate",e.$Zl="telemetry.firstSessionDate",e.$1l="telemetry.lastSessionDate",e.$2l="telemetry.machineId",e.$3l="telemetry.sqmId",e.$4l="telemetry",e.$5l="telemetry.telemetryLevel",e.$6l="telemetry.enableCrashReporter",e.$7l="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var M;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(ke[87],Se([1,0,24,18,86,269,270]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0,e.$hp=L,e.$ip=C,e.$jp=m,e.$kp=y,e.$lp=l,e.$mp=c,e.$np=n,e.$op=r;class w{constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.$ap=w;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$bp=$,e.$cp=new $;class S{async publicLog(d,a,h){}async publicLogError(d,a,h){}}e.$dp=S,e.$ep="telemetry",e.$fp="extensionTelemetryLog",e.$gp={log:()=>null,flush:()=>Promise.resolve(null)};function L(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry)}function C(t,d){return d.extensionTestsLocationURI?!0:!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function m(t){const d=t.getValue(R.$5l),a=t.getValue(R.$6l);if(t.getValue(R.$7l)===!1||a===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function y(t){const d={},a={},h={};g(t,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const p=h[o];typeof p=="number"?a[o]=p:typeof p=="boolean"?a[o]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${p.length}`),d[o]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(d[o]=p)}return{properties:d,measurements:a}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(t){if(!t)return"none";const d=(0,M.$Dm)(t);return v.has(d)?d:"other"}function g(t,d,a=0,h){if(t)for(const o of Object.getOwnPropertyNames(t)){const p=t[o],f=h?h+o:o;Array.isArray(p)?d[f]=(0,u.$3n)(p):p instanceof Date?d[f]=p.toISOString():(0,N.$7f)(p)?a<2?g(p,d,a+1,f+"."):d[f]=(0,u.$3n)(p):d[f]=p}}function c(t,d){const a=t.msftInternalDomains||[],h=d.getValue("telemetry.internalTesting");return(0,A.$_o)(a)||h}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const h=[];for(const D of d)for(;;){const b=D.exec(t);if(!b)break;h.push([b.index,D.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(a="";;){const D=p.exec(t);if(!D)break;const b=h.some(([k,E])=>D.index<E&&k<p.lastIndex);!o.test(D[0])&&!b&&(a+=t.substring(f,D.index)+"<REDACTED: user-file-path>",f=p.lastIndex)}return f<t.length&&(a+=t.substr(f)),a}function s(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of d)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function r(t,d){return(0,u.$Zn)(t,a=>{if(a instanceof w||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let h=a.replaceAll("%20"," ");h=i(h,d);for(const o of d)h=h.replace(o,"");return h=s(h),h}})}}),define(ke[271],Se([1,0,14,137,25,11,2,13,51,87]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$qp=void 0,e.$pp=L,e.$rp=v,e.$sp=l,e.$tp=g,e.$up=c,e.$vp=n,e.$wp=i,e.$xp=s,e.$zp=r,e.$Ap=d;function L(a,h){return a.uuid&&h.uuid?a.uuid===h.uuid:a.id===h.id?!0:(0,u.$pf)(a.id,h.id)===0}const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(h){const o=h.manifest?h.manifest.version:h.version,p=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new m(h.identifier,o,p)}static parse(h){const o=C.exec(h);return o&&o[1]&&o[2]?new m({id:o[1]},o[2],o[4]||void 0):null}constructor(h,o,p="undefined"){this.version=o,this.targetPlatform=p,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof m?L(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.$qp=m;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(a){const h=y.exec(a);return h&&h[1]?[g(h[1]),h[2]]:[g(a),void 0]}function l(a,h){return`${a}.${h}`}function g(a){return a.toLowerCase()}function c(a,h){return g(l(a??M.$Im,h))}function n(a,h){const o=[],p=f=>{for(const D of o)if(D.some(b=>L(h(b),h(f))))return D;return null};for(const f of a){const D=p(f);D?D.push(f):o.push([f])}return o}function i(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function s(a){return{id:new S.$ap(a.identifier.id),name:new S.$ap(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$yp=new M.$Mm("pprice.better-merge");function r(a,h){const o=[],p=h.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const f=p.shift();if(f&&o.every(D=>!L(D.identifier,{id:f}))){const D=a.filter(b=>L(b.identifier,{id:f}));D.length===1&&(o.push(D[0]),p.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}async function t(a,h){if(!A.$k)return!1;let o;try{o=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){h.debug("Error while getting the os-release file.",(0,w.$0)(f))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(a,h){const o=await t(a,h),p=(0,N.$Wo)(o?"alpine":A.$u,$.$fc);return h.debug("ComputeTargetPlatform:",p),p}}),define(ke[272],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=u,e.$gs=N,e.$hs=M,e.$is=A,e.$js=R,e.$ks=w;function u($){return[...$.entries()]}function N($){return $?[...$.entries()]:[]}function M($){return new Map($)}function A($){return new Map($??[])}function R($){return Array.from($.entries()).map(S=>[S[0],u(S[1].map),N(S[1].descriptionMap)])}function w($){return new Map($.map(S=>[S[0],{map:M(S[1]),descriptionMap:A(S[2])}]))}}),define(ke[273],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$sb=void 0;class u{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,A,R=5){const w=A($=>{const S=typeof $=="string"?$:$.data;let L=this.a.get(M);if(L){L.data.push(S);return}const C=setTimeout(()=>this.flushBuffer(M),R);L={data:[S],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(M),w.dispose()}},this.a.set(M,L)});return w}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const A=this.a.get(M);A&&(this.a.delete(M),this.b(M,A.data.join("")))}}e.$$sb=u}),define(ke[274],Se([1,0,8,78,99,57,4,18,2,215,109,38]),function(le,e,u,N,M,A,R,w,$,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_w=e.$$w=e.$0w=e.$9w=e.$8w=e.$7w=e.IconFontDefinition=e.IconContribution=e.$4w=void 0,e.$5w=g,e.$6w=c,e.$4w={IconContribution:"base.contributions.icons"};var m;(function(r){function t(d,a){let h=d.defaults;for(;A.ThemeIcon.isThemeIcon(h);){const o=l.getIcon(h.id);if(!o)return;h=o.defaults}return h}r.getDefinition=t})(m||(e.IconContribution=m={}));var y;(function(r){function t(a){return{weight:a.weight,style:a.style,src:a.src.map(h=>({format:h.format,location:h.location.toString()}))}}r.toJSONObject=t;function d(a){const h=o=>(0,w.$5f)(o)?o:void 0;if(a&&Array.isArray(a.src)&&a.src.every(o=>(0,w.$5f)(o.format)&&(0,w.$5f)(o.location)))return{weight:h(a.weight),style:h(a.style),src:a.src.map(o=>({format:o.format,location:$.URI.parse(o.location)}))}}r.fromJSONObject=d})(y||(e.IconFontDefinition=y={}));class v{constructor(){this.a=new R.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,d,a,h){const o=this.b[t];if(o){if(a&&!o.description){o.description=a,this.d.properties[t].markdownDescription=`${a} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=a),this.a.fire()}return o}const p={id:t,description:a,defaults:d,deprecationMessage:h};this.b[t]=p;const f={$ref:"#/definitions/icons"};return h&&(f.deprecationMessage=h),a&&(f.markdownDescription=`${a}: $(${t})`),this.d.properties[t]=f,this.e.enum.push(t),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const d=this.e.enum.indexOf(t);d!==-1&&(this.e.enum.splice(d,1),this.e.enumDescriptions.splice(d,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,d){const a=this.f[t];return a||(this.f[t]=d,this.a.fire(),d)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(o,p)=>o.id.localeCompare(p.id),d=o=>{for(;A.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.b).map(o=>this.b[o]);for(const o of h.filter(p=>!!p.description).sort(t))a.push(`|<i class="${d(o)}"></i>|${o.id}|${A.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const o of h.filter(p=>!A.ThemeIcon.isThemeIcon(p.defaults)).sort(t))a.push(`|<i class="${d(o)}"></i>|${o.id}|`);return a.join(`
`)}}const l=new v;C.$0n.add(e.$4w.IconContribution,l);function g(r,t,d,a){return l.registerIcon(r,t,d,a)}function c(){return l}function n(){const r=(0,M.$Mj)();for(const t in r){const d="\\"+r[t].toString(16);l.registerIcon(t,{fontCharacter:d})}}n(),e.$7w="vscode://schemas/icons";const i=C.$0n.as(L.$$n.JSONContribution);i.registerSchema(e.$7w,l.getIconSchema());const s=new u.$Dh(()=>i.notifySchemaChanged(e.$7w),200);l.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$8w=g("widget-close",N.$Qj.close,(0,S.localize)(2,null)),e.$9w=g("goto-previous-location",N.$Qj.arrowUp,(0,S.localize)(3,null)),e.$0w=g("goto-next-location",N.$Qj.arrowDown,(0,S.localize)(4,null)),e.$$w=A.ThemeIcon.modify(N.$Qj.sync,"spin"),e.$_w=A.ThemeIcon.modify(N.$Qj.loading,"spin")}),define(ke[88],Se([1,0,4,2,54,5,12]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$cw=e.$aw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$9v=e.$8v=void 0,e.$0v=S,e.$$v=C,e.$_v=m,e.$bw=y,e.$dw=v,e.$ew=l,e.$8v=(0,A.$ri)("tunnelService"),e.$9v=(0,A.$ri)("sharedTunnelsService");var w;(function(n){n.Http="http",n.Https="https"})(w||(e.TunnelProtocol=w={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function S(n){return!!n.forwardPort}var L;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(L||(e.ProvidedOnAutoForward=L={}));function C(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function m(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const s of i){const r=s.split("=")[1];if(/^https?:/.exec(r)){const t=C(N.URI.parse(r));if(t)return t}}}e.$aw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(n){return e.$aw.indexOf(n)>=0}e.$cw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$cw.indexOf(n)>=0}function l(n,i,s,r){if(s===1)return!1;if(s===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class g{constructor(i,s,r){this.remoteAddress=i,this.localAddress=s,this.b=r,this.a=new u.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$fw=g;let c=class{constructor(i,s){this.k=i,this.l=s,this.a=new u.$be,this.onTunnelOpened=this.a.event,this.b=new u.$be,this.onTunnelClosed=this.b.event,this.c=new u.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],s=Array.from(this.e.values());for(const r of s){const t=Array.from(r.values());for(const d of t){const a=await d.value;a&&typeof a!="string"&&i.push(a)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:s}of i.values())await s.then(r=>typeof r!="string"?r?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,s,r,t,d){this.q(i,s,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:s,localAddress:r,privacy:t,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,s){(v(i)||y(i))&&(i=e.$aw[0]);const r=this.s(i,s);if(r)return++r.refcount,r.value}openTunnel(i,s,r,t,d,a=!1,h,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${s}:${r} on local port ${d}.`);const p=this.f??i;if(!p)return;if(s||(s="localhost"),t||(t=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const f=this.t(p,s,r,t,d,a,h,o);return f?f.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(s,r),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(s,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.o(D);return(D.tunnelRemoteHost!==s||D.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&D.privacy!==h&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),f)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const s=this.e.get(i.tunnelRemoteHost);if(s){const r=s.get(i.tunnelRemotePort);r&&(r.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,r))}}}}async p(i,s,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${s}.`);const t=r.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(s),t}}async closeTunnel(i,s){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${s} `);const r=this.e.get(i);if(r&&r.has(s)){const t=r.get(s);t.refcount=0,await this.p(i,s,t)}}q(i,s,r){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(s,{refcount:1,value:r})}async r(i,s){const r=this.e.get(i);if(r){const t=r.get(s),d=t?await t.value:void 0;(!d||typeof d=="string")&&r.delete(s),r.size===0&&this.e.delete(i)}}s(i,s){const r=[i];y(i)?(r.push(...e.$aw),r.push(...e.$cw)):v(i)&&r.push(...e.$cw);const t=r.map(d=>this.e.get(d));for(const d of t){const a=d?.get(s);if(a)return a}}canTunnel(i){return!!C(i)}u(i,s,r,t,d,a,h){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${s}:${r} on local port ${t}.`);const o=r;this.j.add(o);const p=t===void 0?r:t,f={elevationRequired:d?this.isPortPrivileged(p):!1},D={remoteAddress:{host:s,port:r},localAddressPort:t,privacy:a,public:a?a!==$.Private:void 0,protocol:h},b=i.forwardPort(D,f);return b?(this.q(s,r,b),b.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),b}};e.$gw=c,e.$gw=c=Qe([Ve(0,R.$Xj),Ve(1,M.$Xi)],c)}),define(ke[275],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=void 0,e.$vl=(0,u.$ri)("IUriIdentityService")}),define(ke[276],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$hw=void 0,e.$hw=(0,u.$ri)("editSessionIdentityService");var N;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ke[277],Se([1,0,15]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=N,e.$qM=M,e.$rM=A,e.$sM=R,e.$tM=w;function N($){return $.scheme!==u.Schemas.file&&$.scheme!==u.Schemas.vscodeRemote}function M($){if($.folders.length)return $.folders.every(S=>N(S.uri))?$.folders[0].uri:void 0;if($.configuration&&N($.configuration))return $.configuration}function A($){return M($)?.scheme}function R($){return M($)?.authority}function w($){return M($)!==void 0}}),define(ke[42],Se([1,0,217,17,77,23,2,5,15]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Li=e.$Ki=e.WorkbenchState=e.$Ei=e.$Di=e.$Ai=void 0,e.$Bi=S,e.$Ci=L,e.$Fi=C,e.$Gi=m,e.$Hi=y,e.$Ii=l,e.$Ji=g,e.$Mi=i,e.$Ri=s,e.$Si=r,e.$Ui=t,e.$Vi=d,e.$Wi=a,e.$Ai=(0,w.$ri)("contextService");function S(h){const o=h;return typeof o?.id=="string"&&R.URI.isUri(o.uri)}function L(h){return typeof h?.id=="string"&&!S(h)&&!m(h)}e.$Di={id:"ext-dev"},e.$Ei={id:"empty-window"};function C(h,o){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,N.$oc)(h)}:o?e.$Di:e.$Ei;const p=h;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}function m(h){const o=h;return typeof o?.id=="string"&&R.URI.isUri(o.configPath)}function y(h){const o=h;if(o?.uri)return{id:o.id,uri:R.URI.revive(o.uri)};const p=h;if(p?.configPath)return{id:p.id,configPath:R.URI.revive(p.configPath)};if(h?.id)return{id:h.id}}var v;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function l(h){const o=h;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}function g(h){const o=h;return!!(o&&typeof o=="object"&&R.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}class c{constructor(o,p,f,D,b){this.h=o,this.j=f,this.k=D,this.l=b,this.c=M.$xi.forUris(this.l,()=>!0),this.folders=p}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=M.$xi.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ki=c;class n{constructor(o,p){this.raw=p,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,A.$5g)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Li=n;function i(h){return new n({uri:h,index:0,name:(0,A.$1g)(h)},{uri:h.toString()})}e.$Ni="code-workspace",e.$Oi=`.${e.$Ni}`,e.$Pi=[{name:(0,u.localize)(0,null),extensions:[e.$Ni]}],e.$Qi="workspace.json";function s(h,o){return A.$Vg.isEqualOrParent(h,o.untitledWorkspacesHome)}function r(h){let o;return R.URI.isUri(h)?o=h:o=h.configuration,o?.scheme===$.Schemas.tmp}e.$Ti="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(h){return h.id===e.$Ti}function d(h,o){return!s(h,o)&&!r(h)}function a(h){return(typeof h=="string"?(0,N.$pc)(h):(0,A.$3g)(h))===e.$Oi}}),define(ke[278],Se([1,0,56,4,3,23,2,216,136,32,5,12,42,27,275,8,30,14,18]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.$xl=e.ProfileResourceType=void 0,e.$wl=s,e.$yl=r,e.$zl=t;var i;(function(h){h.Settings="settings",h.Keybindings="keybindings",h.Snippets="snippets",h.Tasks="tasks",h.Extensions="extensions",h.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function s(h){const o=h;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&R.URI.isUri(o.location)&&R.URI.isUri(o.globalStorageHome)&&R.URI.isUri(o.settingsResource)&&R.URI.isUri(o.keybindingsResource)&&R.URI.isUri(o.tasksResource)&&R.URI.isUri(o.snippetsHome)&&R.URI.isUri(o.extensionsResource))}e.$xl=(0,L.$ri)("IUserDataProfilesService");function r(h,o){return{id:h.id,isDefault:h.isDefault,name:h.name,shortName:h.shortName,icon:h.icon,location:R.URI.revive(h.location).with({scheme:o}),globalStorageHome:R.URI.revive(h.globalStorageHome).with({scheme:o}),settingsResource:R.URI.revive(h.settingsResource).with({scheme:o}),keybindingsResource:R.URI.revive(h.keybindingsResource).with({scheme:o}),tasksResource:R.URI.revive(h.tasksResource).with({scheme:o}),snippetsHome:R.URI.revive(h.snippetsHome).with({scheme:o}),extensionsResource:R.URI.revive(h.extensionsResource).with({scheme:o}),cacheHome:R.URI.revive(h.cacheHome).with({scheme:o}),useDefaultFlags:h.useDefaultFlags,isTransient:h.isTransient}}function t(h,o,p,f,D,b){return{id:h,name:o,location:p,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:b&&D?.useDefaultFlags?.globalState?b.globalStorageHome:(0,A.$5g)(p,"globalStorage"),settingsResource:b&&D?.useDefaultFlags?.settings?b.settingsResource:(0,A.$5g)(p,"settings.json"),keybindingsResource:b&&D?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,A.$5g)(p,"keybindings.json"),tasksResource:b&&D?.useDefaultFlags?.tasks?b.tasksResource:(0,A.$5g)(p,"tasks.json"),snippetsHome:b&&D?.useDefaultFlags?.snippets?b.snippetsHome:(0,A.$5g)(p,"snippets"),extensionsResource:b&&D?.useDefaultFlags?.extensions?b.extensionsResource:(0,A.$5g)(p,"extensions.json"),cacheHome:(0,A.$5g)(f,h),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let d=class extends M.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(o,p,f,D){super(),this.t=o,this.u=p,this.w=f,this.y=D,this.f=!0,this.h=this.B(new N.$be),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$be),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$be),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$be),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$5g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$5g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(o){this.f!==o&&(this.z=void 0,this.f=o)}isEnabled(){return this.f}get C(){if(!this.z){const o=this.D(),p=[o];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,n.$5f)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}p.push(t((0,A.$2g)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},o))}}catch(b){this.y.error(b)}const f=new y.$Bc,D=new Map;if(p.length)try{const b=this.Q();if(b.workspaces)for(const[k,E]of Object.entries(b.workspaces)){const P=R.URI.parse(k),I=p.find(F=>F.id===E);I&&f.set(P,I)}if(b.emptyWindows)for(const[k,E]of Object.entries(b.emptyWindows)){const P=p.find(I=>I.id===E);P&&D.set(k,P)}}catch(b){this.y.error(b)}this.z={profiles:p,workspaces:f,emptyWindows:D}}return this.z}D(){const o=t("__default__profile__",(0,w.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...o,extensionsResource:this.S()??o.extensionsResource,isDefault:!0}}async createTransientProfile(o){const p="Temp",f=new RegExp(`${(0,c.$9e)(p)}\\s(\\d+)`);let D=0;for(const k of this.profiles){const E=f.exec(k.name),P=E?parseInt(E[1]):0;D=P>D?P:D}const b=`${p} ${D+1}`;return this.createProfile((0,u.$fj)((0,g.$Ng)()).toString(16),b,{transient:!0},o)}async createNamedProfile(o,p,f){return this.createProfile((0,u.$fj)((0,g.$Ng)()).toString(16),o,p,f)}async createProfile(o,p,f,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(o,p,f);return D&&await this.setProfileForWorkspace(D,b),b}async F(o,p,f){if(!(0,n.$5f)(p)||!p)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(p);return D||(D=(async()=>{try{if(this.profiles.find(P=>P.name===p||P.id===o))throw new Error(`Profile with ${p} name already exists`);const k=t(o,p,(0,A.$5g)(this.profilesHome,o),this.g,f,this.defaultProfile);await this.u.createFolder(k.location);const E=[];return this.j.fire({profile:k,join(P){E.push(P)}}),await l.Promises.settled(E),this.I([k],[],[]),k}finally{this.r.delete(p)}})(),this.r.set(p,D)),D}async updateProfile(o,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(D=>D.id===o.id);if(!f)throw new Error(`Profile '${o.name}' does not exist`);return f=t(f.id,p.name??f.name,f.location,this.g,{shortName:p.shortName??f.shortName,icon:p.icon===null?void 0:p.icon??f.icon,transient:p.transient??f.isTransient,useDefaultFlags:p.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.I([],[],[f]),f}async removeProfile(o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(o.isDefault)throw new Error("Cannot remove default profile");const p=this.profiles.find(D=>D.id===o.id);if(!p)throw new Error(`Profile '${o.name}' does not exist`);const f=[];this.m.fire({profile:p,join(D){f.push(D)}});try{await Promise.allSettled(f)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])p.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])p.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[p],[]);try{await this.u.del(p.cacheHome,{recursive:!0})}catch(D){(0,S.$cl)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(o,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(D=>D.id===p.id);if(!f)throw new Error(`Profile '${p.name}' does not exist`);this.L(o,f)}unsetWorkspace(o,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(o,void 0,p)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const o=await this.u.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(p=>p.isDirectory&&this.profiles.every(f=>!this.w.extUri.isEqual(f.location,p.resource))).map(p=>this.u.del(p.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.s.profiles.filter(p=>!this.H(p));await Promise.allSettled(o.map(p=>this.removeProfile(p)))}getProfileForWorkspace(o){const p=this.G(o);return R.URI.isUri(p)?this.s.workspaces.get(p)??this.C.workspaces.get(p):this.s.emptyWindows.get(p)??this.C.emptyWindows.get(p)}G(o){return(0,m.$Bi)(o)?o.uri:(0,m.$Gi)(o)?o.configPath:o.id}H(o){return!!([...this.s.emptyWindows.values()].some(p=>this.w.extUri.isEqual(p.location,o.location))||[...this.s.workspaces.values()].some(p=>this.w.extUri.isEqual(p.location,o.location))||[...this.C.emptyWindows.values()].some(p=>this.w.extUri.isEqual(p.location,o.location))||[...this.C.workspaces.values()].some(p=>this.w.extUri.isEqual(p.location,o.location)))}I(o,p,f){const D=[...this.profiles,...o],b=[];this.s.profiles=[];for(let k of D)k.isDefault||p.some(E=>k.id===E.id)||(k=f.find(E=>k.id===E.id)??k,k.isTransient?this.s.profiles.push(k):b.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(b),this.z=void 0,this.J(o,p,f)}J(o,p,f){this.h.fire({added:o,removed:p,updated:f,all:this.profiles})}L(o,p,f){f=p?.isTransient?!0:f,f||this.L(o,void 0,!0);const D=this.G(o),b=f?this.s:this.C;R.URI.isUri(D)?(b.workspaces.delete(D),p&&b.workspaces.set(D,p)):(b.emptyWindows.delete(D),p&&b.emptyWindows.set(D,p)),f||this.M()}M(){const o={};for(const[f,D]of this.C.workspaces.entries())o[f.toString()]=D.id;const p={};for(const[f,D]of this.C.emptyWindows.entries())p[f.toString()]=D.id;this.R({workspaces:o,emptyWindows:p}),this.z=void 0}N(o){const p={},f=this.D();if(o.workspaces)for(const[b,k]of Object.entries(o.workspaces)){const E=R.URI.parse(k);p[b]=this.w.extUri.isEqual(E,f.location)?f.id:this.w.extUri.basename(E)}const D={};if(o.emptyWindows)for(const[b,k]of Object.entries(o.emptyWindows)){const E=R.URI.parse(k);D[b]=this.w.extUri.isEqual(E,f.location)?f.id:this.w.extUri.basename(E)}return{workspaces:p,emptyWindows:D}}O(){return[]}P(o){throw new Error("not implemented")}Q(){return{}}R(o){throw new Error("not implemented")}S(){}};e.$Al=d,e.$Al=d=Qe([Ve(0,$.$yi),Ve(1,S.$Xk),Ve(2,v.$vl),Ve(3,C.$Xj)],d);class a extends d{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(o){this.a=o}Q(){return this.X}R(o){this.X=o}}e.$Bl=a}),define(ke[279],Se([1,0,8,4,3,59,18,195,5,278]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vp=e.$Up=e.$Tp=void 0,e.$Wp=y,e.$Yp=l,e.$1p=c,e.$Tp="__$__isNewStorageMarker",e.$Up="__$__targetStorageMarker",e.$Vp=(0,$.$ri)("storageService");var L;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var C;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function y(n){const i=n.get(e.$Up);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends M.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new N.$ee),this.c=this.B(new N.$ee),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$be),this.onWillSaveState=this.f.event,this.h=this.B(new u.$Dh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new M.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,s,r){return N.Event.filter(this.b.event,t=>t.scope===i&&(s===void 0||t.key===s),r)}n(){this.j.value=(0,u.$Hh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,M.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,s){const{key:r,external:t}=s;if(r===e.$Up){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:r,target:this.J(i)[r],external:t})}w(i){this.f.fire({reason:i})}get(i,s,r){return this.P(s)?.get(i,r)}getBoolean(i,s,r){return this.P(s)?.getBoolean(i,r)}getNumber(i,s,r){return this.P(s)?.getNumber(i,r)}getObject(i,s,r){return this.P(s)?.getObject(i,r)}storeAll(i,s){this.y(()=>{for(const r of i)this.store(r.key,r.value,r.scope,r.target,s)})}store(i,s,r,t,d=!1){if((0,R.$bg)(s)){this.remove(i,r,d);return}this.y(()=>{this.z(i,r,t),this.P(r)?.set(i,s,d)})}remove(i,s,r=!1){this.y(()=>{this.z(i,s,void 0),this.P(s)?.delete(i,r)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,s){const r=[],t=this.J(i);for(const d of Object.keys(t))t[d]===s&&r.push(d);return r}z(i,s,r,t=!1){const d=this.J(s);typeof r=="number"?d[i]!==r&&(d[i]=r,this.P(s)?.set(e.$Up,JSON.stringify(d),t)):typeof d[i]=="number"&&(delete d[i],this.P(s)?.set(e.$Up,JSON.stringify(d),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const s=this.P(i);return s?y(s):Object.create(null)}isNew(i){return this.getBoolean(e.$Tp,i)===!0}async flush(i=L.NONE){this.f.fire({reason:i});const s=this.P(-1),r=this.P(0),t=this.P(1);switch(i){case L.NONE:await u.Promises.settled([s?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await u.Promises.settled([s?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,s=this.P(0)?.items??new Map,r=this.P(1)?.items??new Map;return c(i,s,r,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,s){return this.w(L.NONE),(0,S.$wl)(i)?this.R(i,s):this.S(i,s)}M(i,s){return!(i.id===s.id||l(s)&&l(i))}N(i,s,r){this.y(()=>{const t=new Set;for(const[d,a]of i)t.add(d),s.get(d)!==a&&this.u(r,{key:d,external:!0});for(const[d]of s.items)t.has(d)||this.u(r,{key:d,external:!0})})}}e.$Xp=v;function l(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class g extends v{constructor(){super(),this.U=this.B(new w.$Rp(new w.$Sp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new w.$Rp(new w.$Sp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new w.$Rp(new w.$Sp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Zp=g;async function c(n,i,s,r,t,d){const a=P=>{try{return JSON.parse(P)}catch{return P}},h=new Map,o=new Map;n.forEach((P,I)=>{h.set(I,P),o.set(I,a(P))});const p=new Map,f=new Map;i.forEach((P,I)=>{p.set(I,P),f.set(I,a(P))});const D=new Map,b=new Map;s.forEach((P,I)=>{D.set(I,P),b.set(I,a(P))}),console.group(r!==t?`Storage: Application (path: ${r})`:`Storage: Application & Profile (path: ${r}, default profile)`);const k=[];if(h.forEach((P,I)=>{k.push({key:I,value:P})}),console.table(k),console.groupEnd(),console.log(o),r!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];p.forEach((I,F)=>{P.push({key:F,value:I})}),console.table(P),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${d})`);const E=[];D.forEach((P,I)=>{E.push({key:I,value:P})}),console.table(E),console.groupEnd(),console.log(b)}}),define(ke[111],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class u{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const A=this.c++;return this.b.set(A,M),this.e(),A}get(M,A){return this.b.has(M)?this.b.get(M)[A]:void 0}delete(M){this.b.delete(M),this.e()}e(){u.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$zkc=u}),define(ke[60],Se([1,0,15,23,5]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=e.$Ekc=void 0;class A{constructor(){this.a=new Set(Object.keys(u.Schemas)),this.b=new Map,this.extUri=new N.$Tg(w=>{const $=this.b.get(w.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(w,$){$===null?this.b.delete(w.scheme):this.b.set(w.scheme,$)}isFreeScheme(w){return!this.b.has(w)&&!this.a.has(w)}getCapabilities(w){return this.b.get(w)}}e.$Ekc=A,e.$Fkc=(0,M.$ri)("IExtHostFileSystemInfo")}),define(ke[28],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=void 0,e.$vP=(0,u.$ri)("IExtHostInitDataService")}),define(ke[280],Se([1,0,222,12,260,28]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=void 0;let R=class extends M.$DQ{constructor($,S,L){const C=L.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=L.remote.isRemote?(0,u.localize)(0,null):$?(0,u.localize)(1,null):(0,u.localize)(2,null);super(S.createLogger(C,{name:m}))}};e.$Lmc=R,e.$Lmc=R=Qe([Ve(1,N.$Yj),Ve(2,A.$vP)],R)}),define(ke[281],Se([1,0,8]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=void 0;class N{constructor(R,w,$){this.h=new Map,this.a=R,this.b=w,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(S=>(this.f=S,this)),this.g=this.c.onDidChangeStorage(S=>{S.shared===this.b&&S.key===this.a&&(this.f=S.value)}),this.i=new u.$Dh(()=>{const S=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of S.values())L.complete()}catch(L){for(const C of S.values())C.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,w){let $=this.f[R];return typeof $>"u"&&($=w),$}update(R,w){this.f[R]=w;const $=this.h.get(R);if($!==void 0)return $.p;const S=new u.$Oh;return this.h.set(R,S),this.i.isScheduled()||this.i.schedule(),S.p}dispose(){this.g.dispose()}}e.$klc=N;class M extends N{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,w){super(R.identifier.value,!0,w),this.j=R}}e.$llc=M}),define(ke[282],Se([1,0,4,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;class M{constructor(R){this.c=R,this.a=new u.$be,this.onDidSaveNotebookDocument=this.a.event,this.b=new u.$be,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,w,$,S){const C=this.c.getNotebookDocument(N.URI.revive(R)).acceptModelChanged(w.value,$,S);this.b.fire(C)}$acceptDirtyStateChanged(R,w){this.c.getNotebookDocument(N.URI.revive(R)).acceptDirty(w)}$acceptModelSaved(R){const w=this.c.getNotebookDocument(N.URI.revive(R));this.a.fire(w.apiNotebook)}}e.$_lc=M}),define(ke[20],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0,e.$fP=(0,u.$ri)("IExtHostRpcService");class N{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$gP=N}),define(ke[283],Se([1,0,25,4]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class M{#e;constructor(R,w){this.b=new N.$be,this.onDidChange=this.b.event,this.a=u.$Mm.toKey(R.identifier),this.#e=w,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(R){return this.#e.get(this.a,R)}store(R,w){return this.#e.store(this.a,R,w)}delete(R){return this.#e.delete(this.a,R)}}e.$ulc=M}),define(ke[67],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=e.$Ukc=void 0,e.$Ukc=(0,u.$ri)("IURITransformerService");class N{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Vkc=N}),define(ke[284],Se([1,0,21]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qob=M,e.$rob=R;class N{constructor(){this.buffers=[]}add($){let S=this.buffers.indexOf($);return S<0&&(S=this.buffers.length,this.buffers.push($)),S}}function M(w,$){if($.serializeBuffersForPostMessage){const S=new N,C=JSON.stringify(w,(y,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v)};if(ArrayBuffer.isView(v)){const l=A(v);if(l)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v.buffer),view:{type:l,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),m=S.buffers.map(y=>{const v=new Uint8Array(y);return u.$Ce.wrap(v)});return{message:C,buffers:m}}else return{message:JSON.stringify(w),buffers:[]}}function A(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(w,$){const S=$.map(m=>{const y=new ArrayBuffer(m.byteLength);return new Uint8Array(y).set(m.buffer),y}),L=$.length?(m,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const v=y,{index:l}=v,g=S[l];if(v.view)switch(v.view.type){case 1:return new Int8Array(g,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return y}:void 0;return{message:JSON.parse(w,L),arrayBuffers:S}}}),define(ke[285],Se([1,0,286,397,398,63,2,12,399]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=L;const S=!1;function L(i,s,r,t,d,a){const h=a.environment.useHostProxy,o=typeof h=="boolean"?h:!a.remote.isRemote,p={resolveProxy:b=>i.resolveProxy(b),lookupProxyAuthorization:g.bind(void 0,t,d,s,{},a.remote.isRemote),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(s),addCertificatesV2:()=>y(s),log:t,getLogLevel:()=>{const b=t.getLevel();switch(b){case w.LogLevel.Trace:return $.LogLevel.Trace;case w.LogLevel.Debug:return $.LogLevel.Debug;case w.LogLevel.Info:return $.LogLevel.Info;case w.LogLevel.Warning:return $.LogLevel.Warning;case w.LogLevel.Error:return $.LogLevel.Error;case w.LogLevel.Off:return $.LogLevel.Off;default:return k(b)}function k(E){return t.error("Unknown log level",E),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:o,loadAdditionalCertificates:async()=>{const b=[];if(a.remote.isRemote&&b.push((0,$.loadSystemCertificates)({log:t})),o){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const k=i.loadCertificates();k.then(E=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),b.push(k)}return(await Promise.all(b)).flat()},env:process.env},f=(0,$.createProxyResolver)(p),D=C(p,f);return l(r,D)}function C(i,s){return{http:Object.assign(u,(0,$.createHttpPatch)(i,u,s)),https:Object.assign(N,(0,$.createHttpPatch)(i,N,s)),net:Object.assign(A,(0,$.createNetPatch)(i,A)),tls:Object.assign(M,(0,$.createTlsPatch)(i,M))}}function m(i){const s=i.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",S)&&!!s.get("systemCertificates")}function y(i){const s=i.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",S)&&!!s.get("systemCertificates")}const v=new Map;function l(i,s){return i.getExtensionPathIndex().then(r=>{const t=globalThis._VSCODE_NODE_MODULES.module,d=t._load;t._load=function(h,o,p){if(h==="net")return s.net;if(h==="tls")return s.tls;if(h!=="http"&&h!=="https")return d.apply(this,arguments);const f=r.findSubstr(R.URI.file(o.filename));let D=v.get(f);if(D||v.set(f,D={}),!D[h]){const b=s[h];D[h]={...b}}return D[h]}})}async function g(i,s,r,t,d,a,h,o){const p=t[a];h&&(t[a]=h),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${a}`,`proxyAuthenticate:${h}`,`proxyAuthenticateCache:${p}`);const f=h||p,D=Array.isArray(f)?f:typeof f=="string"?[f]:[];if(n(s,D,d),D.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!o.kerberosRequested)try{o.kerberosRequested=!0;const b=await new Promise((F,j)=>{le(["kerberos"],F,j)}),k=new URL(a),E=r.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${k.hostname}`:`HTTP@${k.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${a}`,`spn:${E}`),"Negotiate "+await(await b.initializeClient(E)).step("")}catch(b){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let c=!1;function n(i,s,r){c||!s.length||(c=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(t=>t.split(" ")[0]).join(","),extensionHostType:r?"remote":"local"}))}}),define(ke[287],Se([1,0,133]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=M;function N(A){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:A,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function M(A){return new u.$tn(N(A))}}),define(ke[142],Se([1,0,232,18,2,3,5,38,32,15,47,187,41]),function(le,e,u,N,M,A,R,w,$,S,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$DF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$uF=e.EditorInputCapabilities=e.$tF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=void 0,e.$kF=l,e.$lF=g,e.$mF=c,e.$nF=n,e.$oF=i,e.$pF=s,e.$qF=r,e.$rF=t,e.$sF=d,e.$vF=D,e.$wF=k,e.$xF=E,e.$yF=P,e.$zF=I,e.$AF=F,e.$BF=j,e.$CF=X,e.$EF=x,e.$FF=ge,e.$GF=ue,e.$HF=ve,e.$fF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$gF={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.$hF="workbench.editor.sidebysideEditor",e.$iF="workbench.editors.textDiffEditor",e.$jF="workbench.editors.binaryResourceDiffEditor";var y;(function(te){te[te.PROGRAMMATIC=1]="PROGRAMMATIC",te[te.USER=2]="USER",te[te.EDIT=3]="EDIT",te[te.NAVIGATION=4]="NAVIGATION",te[te.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var v;(function(te){te[te.IDENTICAL=1]="IDENTICAL",te[te.SIMILAR=2]="SIMILAR",te[te.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function l(te){const U=te;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function g(te){const U=te;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function c(te,U,_){for(const be of _.visibleEditorPanes)if(be.group.id===U&&te.matches(be.input))return be.getViewState()}function n(te){if(D(te))return!1;const U=te;return M.URI.isUri(U?.resource)}function i(te){if(D(te))return!1;const U=te;return U?.original!==void 0&&U.modified!==void 0}function s(te){if(D(te))return!1;const U=te;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function r(te){if(D(te)||i(te))return!1;const U=te;return U?.primary!==void 0&&U.secondary!==void 0}function t(te){if(D(te))return!1;const U=te;return U?U.resource===void 0||U.resource.scheme===S.Schemas.untitled||U.forceUntitled===!0:!1}function d(te){if(D(te))return!1;const U=te;return M.URI.isUri(U?.base?.resource)&&M.URI.isUri(U?.input1?.resource)&&M.URI.isUri(U?.input2?.resource)&&M.URI.isUri(U?.result?.resource)}var a;(function(te){te[te.SHORT=0]="SHORT",te[te.MEDIUM=1]="MEDIUM",te[te.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var h;(function(te){te[te.EXPLICIT=1]="EXPLICIT",te[te.AUTO=2]="AUTO",te[te.FOCUS_CHANGE=3]="FOCUS_CHANGE",te[te.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class o{constructor(){this.a=new Map}registerSource(U,_){let be=this.a.get(U);return be||(be={source:U,label:_},this.a.set(U,be)),be.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$tF=new o;var p;(function(te){te[te.None=0]="None",te[te.Readonly=2]="Readonly",te[te.Untitled=4]="Untitled",te[te.Singleton=8]="Singleton",te[te.RequiresTrust=16]="RequiresTrust",te[te.CanSplitInGroup=32]="CanSplitInGroup",te[te.ForceDescription=64]="ForceDescription",te[te.CanDropIntoEditor=128]="CanDropIntoEditor",te[te.MultipleEditors=256]="MultipleEditors",te[te.Scratchpad=512]="Scratchpad"})(p||(e.EditorInputCapabilities=p={}));class f extends A.$Uc{}e.$uF=f;function D(te){return te instanceof f}function b(te){const U=te;return M.URI.isUri(U?.preferredResource)}function k(te){const U=te;return D(U?.primary)&&D(U?.secondary)}function E(te){const U=te;return D(U?.modified)&&D(U?.original)}function P(te,U,_,be,Pe){return ve(be,[(0,C.$bj)({id:"workbench.action.openLargeFile",label:(0,u.localize)(2,null),run:()=>{const se={..._,limits:{size:Number.MAX_VALUE}};te.openEditor(U,se)}}),(0,C.$bj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,u.localize)(3,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}function I(te){return D(te?.editor)}function F(te){const U=te;return I(te)&&U?.group!==void 0}function j(te){const U=te;return typeof U?.groupId=="number"&&D(U.editor)}var z;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.REPLACE=1]="REPLACE",te[te.MOVE=2]="MOVE",te[te.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var O;(function(te){te[te.GROUP_ACTIVE=0]="GROUP_ACTIVE",te[te.GROUP_INDEX=1]="GROUP_INDEX",te[te.GROUP_LABEL=2]="GROUP_LABEL",te[te.GROUP_LOCKED=3]="GROUP_LOCKED",te[te.EDITOR_OPEN=4]="EDITOR_OPEN",te[te.EDITOR_CLOSE=5]="EDITOR_CLOSE",te[te.EDITOR_MOVE=6]="EDITOR_MOVE",te[te.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",te[te.EDITOR_LABEL=8]="EDITOR_LABEL",te[te.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",te[te.EDITOR_PIN=10]="EDITOR_PIN",te[te.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",te[te.EDITOR_STICKY=12]="EDITOR_STICKY",te[te.EDITOR_DIRTY=13]="EDITOR_DIRTY",te[te.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var T;(function(te){te[te.PRIMARY=1]="PRIMARY",te[te.SECONDARY=2]="SECONDARY",te[te.BOTH=3]="BOTH",te[te.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class B{getOriginalUri(U,_){if(!U)return;if(d(U))return e.$DF.getOriginalUri(U.result,_);if(_?.supportSideBySide){const{primary:Pe,secondary:se}=this.a(U);if(Pe&&se){if(_?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(se,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===T.ANY)return this.getOriginalUri(Pe,{filterByScheme:_.filterByScheme})??this.getOriginalUri(se,{filterByScheme:_.filterByScheme});U=_.supportSideBySide===T.PRIMARY?Pe:se}}if(i(U)||s(U)||r(U)||d(U))return;const be=b(U)?U.preferredResource:U.resource;return!be||!_||!_.filterByScheme?be:this.b(be,_.filterByScheme)}a(U){return k(U)||r(U)?{primary:U.primary,secondary:U.secondary}:E(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,_){if(!U)return;if(d(U))return e.$DF.getCanonicalUri(U.result,_);if(_?.supportSideBySide){const{primary:Pe,secondary:se}=this.a(U);if(Pe&&se){if(_?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(se,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===T.ANY)return this.getCanonicalUri(Pe,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(se,{filterByScheme:_.filterByScheme});U=_.supportSideBySide===T.PRIMARY?Pe:se}}if(i(U)||s(U)||r(U)||d(U))return;const be=U.resource;return!be||!_||!_.filterByScheme?be:this.b(be,_.filterByScheme)}b(U,_){if(Array.isArray(_)){if(_.some(be=>U.scheme===be))return U}else if(_===U.scheme)return U}}var W;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.KEYBOARD=1]="KEYBOARD",te[te.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function X(te,U,_,be){if(!te.isSticky(U))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return _===W.MOUSE||_===W.KEYBOARD;case"mouse":return _===W.MOUSE;case"keyboard":return _===W.KEYBOARD}return!1}e.$DF=new B;var Z;(function(te){te[te.LEFT=0]="LEFT",te[te.RIGHT=1]="RIGHT"})(Z||(e.CloseDirection=Z={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(U){const _=this.a=U.get(R.$qi);for(const[be,Pe]of this.c)this.e(be,Pe,_);this.c.clear()}e(U,_,be){const Pe=be.createInstance(_);this.d.set(U,Pe)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,N.$dg)(this.b)}registerEditorSerializer(U,_){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,_,this.a):this.c.set(U,_),(0,A.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}w.$0n.add(e.$fF.EditorFactory,new Y);async function x(te,U,_){return!te||!te.length?[]:await Promise.all(te.map(async be=>{const Pe=M.URI.revive(be.fileUri);if(!Pe){_.info("Cannot resolve the path because it is not valid.",be);return}if(!await U.canHandleResource(Pe)){_.info("Cannot resolve the path because it cannot be handled",be);return}let re=be.exists,oe=be.type;if(typeof re!="boolean"||typeof oe!="number")try{oe=(await U.stat(Pe)).isDirectory?$.FileType.Directory:$.FileType.Unknown,re=!0}catch(ie){_.error(ie),re=!1}if(!re&&be.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",be);return}if(oe===$.FileType.Directory){_.info("Cannot resolve the path because it is a directory",be);return}const K={...be.options,pinned:!0};return re?{resource:Pe,options:K}:{resource:Pe,options:K,forceUntitled:!0}}))}var ne;(function(te){te[te.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",te[te.SEQUENTIAL=1]="SEQUENTIAL"})(ne||(e.EditorsOrder=ne={}));function ge(te){const U=te;if(!U)return!1;const _=U;if(_.modified)return ge(_.modified);const be=U;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function ue(te){return(0,L.$dj)(te)}function ve(te,U,_){const be=(0,L.$ej)(te,U);return be.forceMessage=_?.forceMessage,be.forceSeverity=_?.forceSeverity,be.allowDialog=_?.allowDialog,be}}),define(ke[288],Se([1,0,4,233,5,3,27,38,19,24,78,274]),function(le,e,u,N,M,A,R,w,$,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PF=e.$OF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$NF=e.ViewContentGroups=e.$LF=e.ViewContainerLocation=e.Extensions=e.$KF=e.$JF=e.$IF=void 0,e.$MF=v,e.$IF="views",e.$JF=(0,N.localize)(0,null),e.$KF=(0,C.$5w)("default-view-icon",L.$Qj.window,(0,N.localize)(1,null));var m;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var y;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$LF=[0,1,2];function v(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class l extends A.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$be),this.onDidRegister=this.c.event,this.f=this.B(new u.$be),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(a,h,o){const p=this.get(a.id);if(p)return p;const f=a;return f.openCommandActionDescriptor=o?.doNotRegisterOpenCommand?void 0:f.openCommandActionDescriptor??{id:f.id},(0,R.$yc)(this.g,h,[]).push(f),o?.isDefault&&this.h.push(f),this.c.fire({viewContainer:f,viewContainerLocation:h}),f}deregisterViewContainer(a){for(const h of this.g.keys()){const o=this.g.get(h),p=o?.indexOf(a);if(p!==-1){o?.splice(p,1),o.length===0&&this.g.delete(h),this.f.fire({viewContainer:a,viewContainerLocation:h});return}}}get(a){return this.all.filter(h=>h.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(o=>o?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(h=>this.getViewContainerLocation(h)===a)}}w.$0n.add(m.ViewContainersRegistry,new l);var g;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(g||(e.ViewContentGroups=g={}));function c(d,a){const h=d.group??g.More,o=a.group??g.More;return h!==o?h.localeCompare(o):(d.order??5)-(a.order??5)}class n extends A.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$be),this.onViewsRegistered=this.c.event,this.f=this.B(new u.$be),this.onViewsDeregistered=this.f.event,this.g=this.B(new u.$be),this.onDidChangeContainer=this.g.event,this.h=this.B(new u.$be),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Hc}registerViews(a,h){this.registerViews2([{views:a,viewContainer:h}])}registerViews2(a){a.forEach(({views:h,viewContainer:o})=>this.r(h,o)),this.c.fire(a)}deregisterViews(a,h){const o=this.s(a,h);o.length&&this.f.fire({views:o,viewContainer:h})}moveViews(a,h){for(const o of this.m.keys())if(o!==h){const p=this.s(a,o);p.length&&(this.r(p,h),this.g.fire({views:p,from:o,to:h}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const h of this.j){const o=(this.m.get(h)||[]).filter(p=>p.id===a)[0];if(o)return o}return null}getViewContainer(a){for(const h of this.j)if((this.m.get(h)||[]).filter(p=>p.id===a)[0])return h;return null}registerViewWelcomeContent(a,h){return this.n.add(a,h),this.h.fire(a),(0,A.$Sc)(()=>{this.n.delete(a,h),this.h.fire(a)})}registerViewWelcomeContent2(a,h){const o=new Map;for(const[p,f]of h)this.n.add(a,f),o.set(p,(0,A.$Sc)(()=>{this.n.delete(a,f),this.h.fire(a)}));return this.h.fire(a),o}getViewWelcomeContent(a){const h=[];return this.n.forEach(a,o=>h.push(o)),h.sort(c)}r(a,h){let o=this.m.get(h);o||(o=[],this.m.set(h,o),this.j.push(h));for(const p of a){if(this.getView(p.id)!==null)throw new Error((0,N.localize)(2,null,p.id));o.push(p)}}s(a,h){const o=this.m.get(h);if(!o)return[];const p=[],f=[];for(const D of o)a.includes(D)?p.push(D):f.push(D);return p.length&&(f.length?this.m.set(h,f):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),p}}w.$0n.add(m.ViewsRegistry,new n),e.$NF=(0,M.$ri)("viewDescriptorService");var i;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var s;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(s||(e.TreeItemCollapsibleState=s={}));class r{constructor(a,h){this.c=!1,this.d=!1,(0,S.$1n)(this,a),this.d=!!h,this.resolve=async o=>{if(h&&!this.c){const p=await h(o);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}o.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$OF=r;class t extends Error{constructor(a){super((0,N.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$PF=t}),define(ke[289],Se([1,0,234,37]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0,e.$TF=new N.$Ij("chatSessionResponseVote","",{type:"string",description:(0,u.localize)(0,null)}),e.$UF=new N.$Ij("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,u.localize)(1,null)}),e.$VF=new N.$Ij("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,u.localize)(2,null)}),e.$WF=new N.$Ij("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,u.localize)(3,null)}),e.$XF=new N.$Ij("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,u.localize)(4,null)}),e.$YF=new N.$Ij("chatResponse",!1,{type:"boolean",description:(0,u.localize)(5,null)}),e.$ZF=new N.$Ij("chatRequest",!1,{type:"boolean",description:(0,u.localize)(6,null)}),e.$1F=new N.$Ij("chatInputHasText",!1,{type:"boolean",description:(0,u.localize)(7,null)}),e.$2F=new N.$Ij("chatInputHasFocus",!1,{type:"boolean",description:(0,u.localize)(8,null)}),e.$3F=new N.$Ij("inChatInput",!1,{type:"boolean",description:(0,u.localize)(9,null)}),e.$4F=new N.$Ij("inChat",!1,{type:"boolean",description:(0,u.localize)(10,null)}),e.$5F=new N.$Ij("chatIsEnabled",!1,{type:"boolean",description:(0,u.localize)(11,null)}),e.$6F=new N.$Ij("chatCursorAtTop",!1),e.$7F=new N.$Ij("chatInputHasAgent",!1),e.$8F=new N.$Ij("chatLocation",void 0)}),define(ke[290],Se([1,0,4,39,3,37,5,289]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8G=e.$7G=e.$6G=e.ChatAgentLocation=void 0;var $;(function(C){C.Panel="panel",C.Terminal="terminal",C.Notebook="notebook",C.Editor="editor"})($||(e.ChatAgentLocation=$={})),function(C){function m(y){switch(y){case"panel":return C.Panel;case"terminal":return C.Terminal;case"notebook":return C.Notebook;case"editor":return C.Editor}return C.Panel}C.fromRaw=m}($||(e.ChatAgentLocation=$={})),e.$6G=(0,R.$ri)("chatAgentService");let S=class{static{this.AGENT_LEADER="@"}constructor(m){this.f=m,this.b=[],this.d=new u.$be,this.onDidChangeAgents=this.d.event,this.e=w.$5F.bindTo(this.f)}registerAgent(m,y){if(this.getAgent(m))throw new Error(`Agent already registered: ${JSON.stringify(m)}`);const l=this,g=y.slashCommands;y={...y,get slashCommands(){return g.filter(n=>!n.when||l.f.contextMatchesRules(A.$pj.deserialize(n.when)))}};const c={data:y};return this.b.push(c),(0,M.$Sc)(()=>{this.b=this.b.filter(n=>n!==c),this.d.fire(void 0)})}registerAgentImplementation(m,y){const v=this.g(m);if(!v)throw new Error(`Unknown agent: ${JSON.stringify(m)}`);if(v.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(m)}`);return v.data.isDefault&&this.e.set(!0),v.impl=y,this.d.fire(new L(v.data,y)),(0,M.$Sc)(()=>{v.impl=void 0,this.d.fire(void 0),v.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(m,y){const v={data:m,impl:y};return this.b.push(v),this.d.fire(new L(m,y)),(0,M.$Sc)(()=>{this.b=this.b.filter(l=>l!==v),this.d.fire(void 0)})}updateAgent(m,y){const v=this.g(m);if(!v?.impl)throw new Error(`No activated agent with id ${JSON.stringify(m)} registered`);v.data.metadata={...v.data.metadata,...y},this.d.fire(new L(v.data,v.impl))}getDefaultAgent(m){return this.getActivatedAgents().find(y=>!!y.isDefault&&y.locations.includes(m))}getContributedDefaultAgent(m){return this.getAgents().find(y=>!!y.isDefault&&y.locations.includes(m))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),m=>!!m.data.metadata.isSecondary)?.data}g(m){return this.b.find(y=>y.data.id===m)}getAgent(m){return this.g(m)?.data}getAgents(){return this.b.map(m=>m.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(m=>!!m.impl).map(m=>new L(m.data,m.impl))}getAgentsByName(m){return this.getAgents().filter(y=>y.name===m)}async invokeAgent(m,y,v,l,g){const c=this.g(m);if(!c?.impl)throw new Error(`No activated agent with id ${m}`);return await c.impl.invoke(y,v,l,g)}async getFollowups(m,y,v,l,g){const c=this.g(m);if(!c?.impl)throw new Error(`No activated agent with id ${m}`);return c.impl?.provideFollowups?c.impl.provideFollowups(y,v,l,g):[]}};e.$7G=S,e.$7G=S=Qe([Ve(0,A.$Jj)],S);class L{constructor(m,y){this.b=m,this.d=y}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(m,y,v,l){return this.d.invoke(m,y,v,l)}async provideFollowups(m,y,v,l){return this.d.provideFollowups?this.d.provideFollowups(m,y,v,l):[]}provideWelcomeMessage(m,y){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(m,y)}provideSampleQuestions(m,y){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(m,y)}}e.$8G=L}),define(ke[291],Se([1,0,2,29,5]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$aG=A,e.$bG=R;function A(S){return!!S&&typeof S=="object"&&"uri"in S&&S.uri instanceof u.URI&&"version"in S&&typeof S.version=="number"&&"ranges"in S&&Array.isArray(S.ranges)&&S.ranges.every(N.$nt.isIRange)}function R(S){return!!S&&typeof S=="object"&&"documents"in S&&Array.isArray(S.documents)&&S.documents.every(A)}var w;(function(S){S[S.Down=0]="Down",S[S.Up=1]="Up"})(w||(e.InteractiveSessionVoteDirection=w={}));var $;(function(S){S[S.Action=1]="Action",S[S.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$cG=(0,M.$ri)("IChatService"),e.$dG="accessibility.voice.keywordActivation"}),define(ke[143],Se([1,0,4,8,235]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xob=void 0;class A{constructor(){this.f=new Map,this.m=[],this.n=new u.$be,this.o=new u.$be,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(w){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=w}onEvent(w){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=w}onRequest(w){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=w}sendResponse(w){w.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.u("response",w)}sendRequest(w,$,S,L){const C={command:w};if($&&Object.keys($).length>0&&(C.arguments=$),this.u("request",C),typeof L=="number"){const m=setTimeout(()=>{clearTimeout(m);const y=this.f.get(C.seq);if(y){this.f.delete(C.seq);const v={type:"response",seq:0,request_seq:C.seq,success:!1,command:w,message:(0,M.localize)(0,null,L,w)};y(v)}},L)}return S&&this.f.set(C.seq,S),C.seq}acceptMessage(w){this.k?this.k(w):(this.m.push(w),this.m.length===1&&this.s())}q(w,$){return w.type!=="event"||$.type!=="event"}async s(){let w;for(;this.m.length;){if((!w||this.q(this.m[0],w))&&await(0,N.$sh)(0),w=this.m.shift(),!w)return;switch(w.type){case"event":this.j?.(w);break;case"request":this.g?.(w);break;case"response":{const $=w,S=this.f.get($.request_seq);S&&(this.f.delete($.request_seq),S($));break}}}}u(w,$){$.type=w,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const w=new Map;this.f.forEach(($,S)=>w.set(S,$)),await(0,N.$sh)(500),w.forEach(($,S)=>{$({type:"response",seq:0,request_seq:S,success:!1,command:"canceled",message:"canceled"}),this.f.delete(S)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Xob=A}),define(ke[292],Se([1,0,2,236,37,5]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$lJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$jJ=e.MemoryRangeType=e.State=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=void 0,e.$iJ=$,e.$kJ=L,e.$9H="workbench.view.debug",e.$0H="workbench.debug.variablesView",e.$$H="workbench.debug.watchExpressionsView",e.$_H="workbench.debug.callStackView",e.$aI="workbench.debug.loadedScriptsView",e.$bI="workbench.debug.breakPointsView",e.$cI="workbench.debug.disassemblyView",e.$dI="workbench.panel.repl",e.$eI="workbench.panel.repl.view",e.$fI=new M.$Ij("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$gI=new M.$Ij("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$hI=new M.$Ij("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$iI="debugUx",e.$jI=new M.$Ij(e.$iI,"default",{type:"string",description:N.localize(3,null)}),e.$kI=new M.$Ij("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$lI=new M.$Ij("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$mI=new M.$Ij("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$nI=new M.$Ij("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$oI=new M.$Ij("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$pI=new M.$Ij("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$qI=new M.$Ij("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$rI=new M.$Ij("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$sI=new M.$Ij("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$tI=new M.$Ij("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$uI=new M.$Ij("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$vI=new M.$Ij("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$wI=new M.$Ij("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$xI=new M.$Ij("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$yI=new M.$Ij("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$zI=new M.$Ij("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$AI=new M.$Ij("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$BI=new M.$Ij("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$CI=new M.$Ij("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$DI=new M.$Ij("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$EI=new M.$Ij("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$FI=new M.$Ij("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$GI=new M.$Ij("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$HI=new M.$Ij("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$II=new M.$Ij("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$JI=new M.$Ij("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$KI=new M.$Ij("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$LI=new M.$Ij("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$MI=new M.$Ij("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$NI=new M.$Ij("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$OI=new M.$Ij("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$PI=new M.$Ij("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$QI=new M.$Ij("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$RI=new M.$Ij("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$SI=new M.$Ij("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$TI=new M.$Ij("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$UI=new M.$Ij("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$VI=new M.$Ij("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$WI=new M.$Ij("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$XI=new M.$Ij("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$YI=new M.$Ij("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$ZI=new M.$Ij("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$1I=new M.$Ij("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$2I=new M.$Ij("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$3I=new M.$Ij("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$4I=new M.$Ij("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$5I=new M.$Ij("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$6I=new M.$Ij("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$7I=new M.$Ij("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$8I=new M.$Ij("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$9I=new M.$Ij("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$0I=new M.$Ij("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$$I=new M.$Ij("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$_I=new M.$Ij("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$aJ=new M.$Ij("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$bJ=new M.$Ij("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$cJ=new M.$Ij("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const R=i=>N.localize(61,null,i);e.$dJ=R,e.$eJ="editor.contrib.debug",e.$fJ="editor.contrib.breakpoint",e.$gJ="debug",e.$hJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var w;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(w||(e.State=w={}));function $(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var S;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$jJ="vscode-debug-memory";function L(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var C;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(C||(e.DataBreakpointSetType=C={}));var m;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var y;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(y||(e.DebuggerString=y={})),e.$lJ=(0,A.$ri)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var l;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(l||(e.DebugVisualizationType=l={}));var g;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(g||(e.DebugTreeItemCollapsibleState=g={}));var c;(function(i){i.deserialize=s=>s,i.serialize=s=>s})(c||(e.IDebugVisualizationTreeItem=c={}));var n;(function(i){i.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:u.URI.revive(s.iconPath.light),dark:u.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),i.serialize=s=>s})(n||(e.IDebugVisualization=n={}))}),define(ke[293],Se([1,0,14,2,17,24,15,29,22,19]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kH=void 0,e.$$G=C,e.$_G=m,e.$aH=y,e.$bH=v,e.$cH=l,e.$dH=g,e.$eH=c,e.$fH=i,e.$gH=t,e.$hH=d,e.$iH=h,e.$jH=p;const L=/{([^}]+)}/g;function C(D,b,k){return D.replace(L,function(E,P){return b&&P.length>0&&P[0]!=="_"?E:k&&k.hasOwnProperty(P)?k[P]:E})}function m(D){const b={};for(const k of Object.keys(D))k.startsWith("!")||(b[k]=D[k]);return b}function y(D){return D.configuration.request==="attach"&&!v(D)&&(!D.parentSession||y(D.parentSession))}function v(D){let b=D.configuration.type;if(b)return b==="vslsShare"&&(b=D.configuration.adapterProxy.configuration.type),(0,u.$uf)(b,"extensionhost")||(0,u.$uf)(b,"pwa-extensionhost")?D:D.parentSession?v(D.parentSession):void 0}function l(D){return D.type&&(D.label||D.program||D.runtime)}function g(D,b,k){let E,P=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=I.exec(D);){const j=F.index+1,z=j+F[0].length;if(j<=b&&z>=k){E=F[0],P=j;break}}if(E){const j=/\w+/g;let z=null;for(;(z=j.exec(E))&&!(z.index+1+P+z[0].length>=k););z&&(E=E.substring(0,j.lastIndex))}return E?{start:P,end:P+E.length-1}:{start:0,end:0}}async function c(D,b,k,E){if(D.evaluatableExpressionProvider.has(b)){const P=D.evaluatableExpressionProvider.ordered(b),I=(0,S.$Hb)(await Promise.all(P.map(async F=>{try{return await F.provideEvaluatableExpression(b,k,E??$.CancellationToken.None)}catch{return}})));if(I.length>0){let F=I[0].expression;const j=I[0].range;return F||(F=b.getLineContent(k.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:F}}}else{const P=b.getLineContent(k.lineNumber),{start:I,end:F}=g(P,k.column,k.column),j=P.substring(I-1,F);return{matchingExpression:j,range:new w.$nt(k.lineNumber,I,k.lineNumber,I+j.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function s(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return N.URI.parse(D.path);if((0,M.$jc)(D.path))return N.URI.file(D.path)}return D.path}function r(D){if(typeof D.path=="object"){const b=N.URI.revive(D.path);if(b)return b.scheme===R.Schemas.file?b.fsPath:b.toString()}return D.path}function t(D,b){const k=b?s:r,E=(0,A.$Xn)(D);return a(E,(P,I)=>{P&&I&&(I.path=k(I))}),E}function d(D,b){const k=b?s:r,E=(0,A.$Xn)(D);return a(E,(P,I)=>{!P&&I&&(I.path=k(I))}),E}function a(D,b){switch(D.type){case"event":{const k=D;switch(k.event){case"output":b(!1,k.body.source);break;case"loadedSource":b(!1,k.body.source);break;case"breakpoint":b(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=D;switch(k.command){case"setBreakpoints":b(!0,k.arguments.source);break;case"breakpointLocations":b(!0,k.arguments.source);break;case"source":b(!0,k.arguments.source);break;case"gotoTargets":b(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(E=>b(!1,E));break;default:break}break}case"response":{const k=D;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(E=>b(!1,E.source));break;case"loadedSources":k.body.sources.forEach(E=>b(!1,E));break;case"scopes":k.body.scopes.forEach(E=>b(!1,E.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(E=>b(!1,E.source));break;case"setBreakpoints":k.body.breakpoints.forEach(E=>b(!1,E.source));break;case"disassemble":k.body?.instructions.forEach(P=>b(!1,P.location));break;default:break}break}}}function h(D){return D.filter(b=>!b.presentation?.hidden).sort((b,k)=>b.presentation?k.presentation?b.presentation.group?k.presentation.group?b.presentation.group!==k.presentation.group?b.presentation.group.localeCompare(k.presentation.group):o(b.presentation.order,k.presentation.order):-1:k.presentation.group?1:o(b.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function o(D,b){return typeof D!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:D-b}async function p(D,b){const k=D.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(k!=="none"&&(await b.saveAll(),k==="allEditorsInActiveGroup")){const E=b.activeEditorPane;E&&E.input.resource?.scheme===R.Schemas.untitled&&await b.save({editor:E.input,groupId:E.group.id})}await D.reloadConfiguration()}const f=(D,b)=>!D||!b?D===b:D.name===b.name&&D.path===b.path&&D.sourceReference===b.sourceReference;e.$kH=f}),define(ke[294],Se([1,0,53,63,24,17,11,14,31,237,143]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=e.$Umc=e.$Tmc=e.$Smc=e.$Rmc=void 0;class C extends L.$Xob{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(c,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,c.on("data",i=>this.v(i))}sendMessage(c){if(this.l){const n=JSON.stringify(c);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${C.a}${n}`,"utf8")}}v(c){for(this.p=Buffer.concat([this.p,c]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(C.a);if(n!==-1){const s=this.p.toString("utf8",0,n).split(C.b);for(const r of s){const t=r.split(C.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+C.a.length);continue}}break}}}e.$Rmc=C;class m extends C{startSession(){return new Promise((c,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),c(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",s=>{i?this.n.fire(s):n(s)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Smc=m;class y extends m{constructor(c){super(),this.z=c}y(c){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",c)}}e.$Tmc=y;class v extends m{constructor(c){super(),this.z=c}y(c){return N.createConnection(this.z.path,c)}}e.$Umc=v;class l extends C{constructor(c,n){super(),this.y=c,this.z=n}async startSession(){const c=this.y.command,n=this.y.args,i=this.y.options||{};try{if(c)if(A.$jc(c)){if(!await $.Promises.exists(c))throw new Error(S.localize(0,null,c))}else c.indexOf("/")<0&&c.indexOf("\\")<0;else throw new Error(S.localize(1,null,this.z));let s=process.env;if(i.env&&Object.keys(i.env).length>0&&(s=M.$1n(M.$Xn(process.env),i.env)),c==="node")if(Array.isArray(n)&&n.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:s,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const d=u.fork(n[0],n.slice(1),t);if(!d.pid)throw new Error(S.localize(2,null,n[0]));this.x=d}else throw new Error(S.localize(3,null));else{const r={env:s};i.cwd&&(r.cwd=i.cwd),this.x=u.spawn(c,n,r)}this.x.on("error",r=>{this.n.fire(r)}),this.x.on("exit",(r,t)=>{this.o.fire(r)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",r=>{this.n.fire(r)}),this.x.stdin.on("error",r=>{this.n.fire(r)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(s){this.n.fire(s)}}async stopSession(){return this.x?(await this.w(),R.$i?new Promise((c,n)=>{const i=u.exec(`taskkill /F /T /PID ${this.x.pid}`,function(s,r,t){if(s)return n(s)});i.on("exit",c),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(c,n){if(!c)return;const i=Object.create(null);c.runtime&&(c.runtime.indexOf("./")===0?i.runtime=A.$kc(n,c.runtime):i.runtime=c.runtime),c.runtimeArgs&&(i.runtimeArgs=c.runtimeArgs),c.program&&(A.$jc(c.program)?i.program=c.program:i.program=A.$kc(n,c.program)),c.args&&(i.args=c.args);const s=c;return s.win&&(i.win=l.A(s.win,n)),s.winx86&&(i.winx86=l.A(s.winx86,n)),s.windows&&(i.windows=l.A(s.windows,n)),s.osx&&(i.osx=l.A(s.osx,n)),s.linux&&(i.linux=l.A(s.linux,n)),i}static platformAdapterExecutable(c,n){let i=Object.create(null);n=n.toLowerCase();for(const h of c)if(h.contributes){const o=h.contributes.debuggers;o&&o.length>0&&o.filter(p=>typeof p.type=="string"&&w.$uf(p.type,n)).forEach(p=>{const f=l.A(p,h.extensionLocation.fsPath);i=M.$1n(i,f,h.isBuiltin)})}let s;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=i.winx86||i.win||i.windows:R.$i?s=i.win||i.windows:R.$j?s=i.osx:R.$k&&(s=i.linux),s=s||i;const r=s.program||i.program,t=s.args||i.args,d=s.runtime||i.runtime,a=s.runtimeArgs||i.runtimeArgs;if(d)return{type:"executable",command:d,args:(a||[]).concat(typeof r=="string"?[r]:[]).concat(t||[])};if(r)return{type:"executable",command:r,args:t||[]}}}e.$Vmc=l}),define(ke[295],Se([1,0,53,34,11]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=R,e.$Xmc=$;function A(S,L){return new Promise((C,m)=>{let y="";const v=u.spawn(S,L);v.pid&&v.stdout.on("data",l=>{y+=l.toString()}),v.on("error",l=>{m(l)}),v.on("close",l=>{C(y)})})}async function R(S){if(S)if(M.$i){const L=await new Promise((C,m)=>{le(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{L.getProcessTree(S,m=>{C(!!m&&m.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(S)]).then(L=>{const C=L.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}var w;(function(S){S[S.cmd=0]="cmd",S[S.powershell=1]="powershell",S[S.bash=2]="bash"})(w||(w={}));function $(S,L,C,m,y){S=S.trim().toLowerCase();let v;S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0?v=1:S.indexOf("cmd.exe")>=0?v=0:S.indexOf("bash")>=0?v=2:M.$i?v=0:v=2;let l,g=" ";switch(v){case 1:if(l=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),m){const c=(0,N.$wg)(m);c&&(g+=`${c}:; `),g+=`cd ${l(m)}; `}if(y)for(const c in y){const n=y[c];n===null?g+=`Remove-Item env:${c}; `:g+=`\${env:${c}}='${n}'; `}if(L.length>0){const c=L.shift(),n=C?c:l(c);g+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of L)g+=i==="<"||i===">"||C?i:l(i),g+=" "}break;case 0:if(l=c=>(c=c.replace(/\"/g,'""'),c=c.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>c.includes(n))||c.length===0?`"${c}"`:c),m){const c=(0,N.$wg)(m);c&&(g+=`${c}: && `),g+=`cd ${l(m)} && `}if(y){g+='cmd /C "';for(const c in y){let n=y[c];n===null?g+=`set "${c}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),g+=`set "${c}=${n}" && `)}}for(const c of L)g+=c==="<"||c===">"||C?c:l(c),g+=" ";y&&(g+='"');break;case 2:{l=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const c=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(m&&(g+=`cd ${l(m)} ; `),y){g+="/usr/bin/env";for(const n in y){const i=y[n];i===null?g+=` -u ${c(n)}`:g+=` ${c(`${n}=${i}`)}`}g+=" "}for(const n of L)g+=n==="<"||n===">"||C?n:l(n),g+=" ";break}}return g}}),define(ke[296],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yK=e.CellExecutionUpdateType=void 0;var N;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$yK=(0,u.$ri)("INotebookExecutionService")}),define(ke[297],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rib=e.$Qib=e.ProxyKernelState=e.$Pib=void 0,e.$Pib=100;var N;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$Qib=(0,u.$ri)("INotebookKernelService"),e.$Rib=(0,u.$ri)("INotebookKernelHistoryService")}),define(ke[298],Se([1,0,3,29,200,100]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IWb=void 0;class R extends u.$Uc{constructor($,S,L){super(),this._source=$,this.b=S,this.c=L,this.a=void 0}f($){const S=$.getLineCount();return new N.$nt(1,1,S,this.g($,S))}g($,S){if(S<1||S>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(S)+1}get inputTextBuffer(){if(!this.b){const $=new M.$OC;$.acceptChunk(this._source);const S=$.finish(!0),{textBuffer:L,disposable:C}=S.create(1);this.b=L,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const S=new M.$OC;S.acceptChunk($);const L=S.finish(!0),{textBuffer:C,disposable:m}=L.create(1);return this.B(m),C})),this.a}findInInputs($){const L=new A.$CC($,!1,!1,null).parseSearchRequest();if(!L)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,L,!0,5e3)}findInOutputs($){const L=new A.$CC($,!1,!1,null).parseSearchRequest();return L?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),L,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$IWb=R}),define(ke[68],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(A){A.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var N;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class M{static fromExtHostTestItem(R,w,$=R.parent){if(R._isRoot)return new M([w]);const S=[R.id];for(let L=$;L&&L.id!==w;L=L.parent)S.push(L.id);return S.push(w),new M(S.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const w=R.indexOf("\0");return w===-1?R:R.slice(0,w)}static fromString(R){return new M(R.split("\0"))}static join(R,w){return new M([...R.path,w])}static joinToString(R,w){return R.toString()+"\0"+w}static parentId(R){const w=R.lastIndexOf("\0");return w===-1?void 0:R.slice(0,w)}static localId(R){const w=R.lastIndexOf("\0");return w===-1?R:R.slice(w+1)}static isChild(R,w){return w.startsWith(R)&&w[R.length]==="\0"}static compare(R,w){return R===w?0:M.isChild(R,w)?2:M.isChild(w,R)?3:1}constructor(R,w=R.length){if(this.path=R,this.d=w,R.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new M(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new M(this.path,R)}compare(R){if(typeof R=="string")return M.compare(this.toString(),R);for(let w=0;w<R.d&&w<this.d;w++)if(R.path[w]!==this.path[w])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$EL=M}),define(ke[89],Se([1,0,2,50,29,68]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$ML=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$LL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$KL=e.$JL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$IL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$HL=e.$GL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$FL=e.TestResultState=void 0;var R;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$FL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var w;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(w||(e.ExtTestRunProfileKind=w={}));var $;(function(O){O[O.Run=2]="Run",O[O.Debug=4]="Debug",O[O.Coverage=8]="Coverage",O[O.HasNonDefaultProfile=16]="HasNonDefaultProfile",O[O.HasConfigurable=32]="HasConfigurable",O[O.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$GL=[2,4,8,16,32,64];const S=O=>"runId"in O;e.$HL=S;var L;(function(O){O.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({range:M.$nt.lift(B.range),uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(L||(e.IRichLocation=L={}));var C;(function(O){O[O.Error=0]="Error",O[O.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(O){O.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&L.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&L.deserialize(T,B.location)})})(m||(e.ITestErrorMessage=m={}));const y=(O,T)=>`${T?"s":"e"}${O}`;e.$IL=y;var v;(function(O){O.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&L.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&L.deserialize(T,B.location)})})(v||(e.ITestOutputMessage=v={}));var l;(function(O){O.serialize=T=>T.type===0?m.serialize(T):v.serialize(T),O.deserialize=(T,B)=>B.type===0?m.deserialize(T,B):v.deserialize(T,B)})(l||(e.ITestMessage=l={}));var g;(function(O){O.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),O.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(l.serialize)}),O.deserialize=(T,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(W=>l.deserialize(T,W))})})(g||(e.ITestTaskState=g={}));const c="\0",n=(O,T)=>O+c+T;e.$JL=n;const i=O=>{const T=O.indexOf(c);return{ctrlId:O.slice(0,T),tagId:O.slice(T+1)}};e.$KL=i;var s;(function(O){O.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),O.deserialize=(T,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?T.asCanonicalUri(u.URI.revive(B.uri)):void 0,range:B.range?M.$nt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(s||(e.ITestItem=s={}));var r;(function(O){O[O.NotExpandable=0]="NotExpandable",O[O.Expandable=1]="Expandable",O[O.BusyExpanding=2]="BusyExpanding",O[O.Expanded=3]="Expanded"})(r||(e.TestItemExpandState=r={}));var t;(function(O){O.serialize=T=>({expand:T.expand,item:s.serialize(T.item)}),O.deserialize=(T,B)=>({controllerId:A.$EL.root(B.item.extId),expand:B.expand,item:s.deserialize(T,B.item)})})(t||(e.InternalTestItem=t={}));var d;(function(O){O.serialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.uri!==void 0&&(B.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(B.range=T.item.range?.toJSON()),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}},O.deserialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.range!==void 0&&(B.range=T.item.range?M.$nt.lift(T.item.range):null),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}}})(d||(e.ITestItemUpdate=d={}));const a=(O,T)=>{T.expand!==void 0&&(O.expand=T.expand),T.item!==void 0&&(O.item=O.item?Object.assign(O.item,T.item):T.item)};e.$LL=a;var h;(function(O){O.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(g.serializeWithoutMessages)}),O.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(g.serialize)}),O.deserialize=(T,B)=>({...t.deserialize(T,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(W=>g.deserialize(T,W)),retired:!0})})(h||(e.TestResultItem=h={}));var o;(function(O){O.empty=()=>({covered:0,total:0}),O.sum=(T,B)=>{T.covered+=B.covered,T.total+=B.total}})(o||(e.ICoverageCount=o={}));var p;(function(O){O.serialize=T=>({id:T.id,statement:T.statement,branch:T.branch,declaration:T.declaration,uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(p||(e.IFileCoverage=p={}));function f(O){return{...O,location:O.location?.toJSON()}}function D(O){return O.location=O.location?N.$mt.isIPosition(O.location)?N.$mt.lift(O.location):M.$nt.lift(O.location):void 0,O}e.$ML=3;var b;(function(O){O[O.Declaration=0]="Declaration",O[O.Statement=1]="Statement",O[O.Branch=2]="Branch"})(b||(e.DetailType=b={}));var k;(function(O){O.serialize=T=>T.type===0?P.serialize(T):I.serialize(T),O.deserialize=T=>T.type===0?P.deserialize(T):I.deserialize(T)})(k||(e.CoverageDetails=k={}));var E;(function(O){O.serialize=f,O.deserialize=D})(E||(e.IBranchCoverage=E={}));var P;(function(O){O.serialize=f,O.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var I;(function(O){O.serialize=T=>({...f(T),branches:T.branches?.map(E.serialize)}),O.deserialize=T=>({...D(T),branches:T.branches?.map(E.deserialize)})})(I||(e.IStatementCoverage=I={}));var F;(function(O){O[O.Add=0]="Add",O[O.Update=1]="Update",O[O.DocumentSynced=2]="DocumentSynced",O[O.Remove=3]="Remove",O[O.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",O[O.Retire=5]="Retire",O[O.AddTag=6]="AddTag",O[O.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var j;(function(O){O.deserialize=(T,B)=>B.op===0?{op:B.op,item:t.deserialize(T,B.item)}:B.op===1?{op:B.op,item:d.deserialize(B.item)}:B.op===2?{op:B.op,uri:T.asCanonicalUri(u.URI.revive(B.uri)),docv:B.docv}:B,O.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:d.serialize(T.item)}:T})(j||(e.TestsDiffOp=j={}));class z{constructor(T){this.k=T,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(T){const B=this.v();for(const W of T)switch(W.op){case 0:this.l(t.deserialize(this.k,W.item),B);break;case 1:this.o(d.deserialize(W.item),B);break;case 3:this.p(W.itemId,B);break;case 5:this.q(W.itemId);break;case 4:this.updatePendingRoots(W.amount);break;case 6:this.c.set(W.tag.id,W.tag);break;case 7:this.c.delete(W.id);break}B.complete?.()}l(T,B){const W=A.$EL.parentId(T.item.extId)?.toString();let X;if(!W)X=this.w(T),this.g.add(X),this.f.set(T.item.extId,X);else if(this.f.has(W)){const Z=this.f.get(W);Z.children.add(T.item.extId),X=this.w(T,Z),this.f.set(T.item.extId,X)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return B.add?.(X),T.expand===2&&this.h++,X}o(T,B){const W=this.f.get(T.extId);if(W)return T.expand!==void 0&&(W.expand===2&&this.h--,T.expand===2&&this.h++),(0,e.$LL)(W,T),B.update?.(W),W}p(T,B){const W=this.f.get(T);if(!W)return;const X=A.$EL.parentId(W.item.extId)?.toString();X?this.f.get(X).children.delete(W.item.extId):this.g.delete(W);const Z=[[T]];for(;Z.length;)for(const Y of Z.pop()){const x=this.f.get(Y);x&&(Z.push(x.children),this.f.delete(Y),B.remove?.(x,x!==W),x.expand===2&&this.h--)}}q(T){}updatePendingRoots(T){this.j+=T}v(){return{}}}e.$NL=z}),define(ke[112],Se([1,0,8,4,3,62,89,68]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const S=(n,i)=>n===i,C=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:S,label:S,description:S,error:S,sortText:S,tags:(n,i)=>!(n.length!==i.length||n.some(s=>!i.includes(s)))}),m=(n,i)=>{let s;for(const[r,t]of C)t(n[r],i[r])||(s?s[r]=i[r]:s={[r]:i[r]});return s};class y extends M.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new u.$Dh(()=>this.flushDiff(),200)),this.g=this.B(new N.$be),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const s of this.m)if(s.op===2&&s.uri===i.uri){s.docv=i.docv;return}break}case 1:{const s=this.m[this.m.length-1];if(s){if(s.op===1&&s.item.extId===i.item.extId){(0,R.$LL)(s.item,i.item);return}if(s.op===0&&s.item.item.extId===i.item.extId){(0,R.$LL)(s.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,s){const r=this.tree.get(i);if(r){if((r.expandLevels===void 0||s>r.expandLevels)&&(r.expandLevels=s),r.expand===1){const t=this.M(r);return t.isOpen()?this.L(r,s-1):t.wait().then(()=>this.L(r,s-1))}else if(r.expand===3)return r.resolveBarrier?.isOpen()===!1?r.resolveBarrier.wait().then(()=>this.L(r,s-1)):this.L(r,s-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,s){switch(s.op){case 3:this.O(w.$EL.joinToString(i.fullId,s.id));break;case 0:this.z(s.item,i);break;case 5:for(const r of s.ops)this.w(i,r);break;case 1:this.C(s.new,s.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:s.update}});break;case 6:this.y(i.actual.uri);break;default:(0,A.$cd)(s)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,s){const r=w.$EL.fromExtHostTestItem(i,this.root.id,s?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==s?.actual&&this.s.getChildren(t.parent).delete(i.id);let d=this.tree.get(r.toString());if(!d){d={fullId:r,actual:i,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(d.fullId.toString(),d),this.G(i,s),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:d.expand,item:this.s.toITestItem(i)}}),this.I(i,d,s);return}if(d.actual===i){this.H(i,d,s);return}if(d.actual.uri?.toString()!==i.uri?.toString())return this.O(r.toString()),this.z(i,s);const a=this.s.getChildren(d.actual),h=d.actual,o=m(this.s.toITestItem(h),this.s.toITestItem(i));this.s.getApiFor(h).listener=void 0,d.actual=i,d.resolveBarrier=void 0,d.expand=0,o&&(o.hasOwnProperty("tags")&&(this.C(i.tags,h.tags,r.toString()),delete o.tags),this.w(d,{op:4,update:o})),this.I(i,d,s);for(const[f,D]of a)this.s.getChildren(i).get(D.id)||this.O(w.$EL.joinToString(r,D.id));const p=d.expandLevels;p!==void 0&&queueMicrotask(()=>{d.expand===1&&(d.expandLevels=void 0,this.expand(r.toString(),p))}),this.y(d.actual.uri)}C(i,s,r){const t=new Set(s.map(d=>d.id));for(const d of i)t.delete(d.id)||this.D(d);this.pushDiff({op:1,item:{extId:r,item:{tags:i.map(d=>(0,R.$JL)(this.s.controllerId,d.id))}}}),t.forEach(this.F,this)}D(i){const s=this.j.get(i.id);s?s.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$JL)(this.s.controllerId,i.id)}}))}F(i){const s=this.j.get(i);s&&!--s.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,R.$JL)(this.s.controllerId,i)}))}G(i,s){this.s.getApiFor(i).parent=s&&s.actual!==this.root?s.actual:void 0}H(i,s,r){this.G(i,r);const t=this.s.getApiFor(i);t.parent=r?.actual,t.listener=d=>this.w(s,d),this.J(s)}I(i,s,r){this.H(i,s,r);for(const[t,d]of this.s.getChildren(i))this.z(d,s)}J(i){let s;this.h?i.resolveBarrier?s=i.resolveBarrier.isOpen()?3:2:s=i.actual.canResolveChildren?1:0:s=0,s!==i.expand&&(i.expand=s,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:s}}),s===1&&i.expandLevels!==void 0&&this.M(i))}L(i,s){if(s<0)return;const r=[];for(const[t,d]of this.s.getChildren(i.actual)){const a=this.expand(w.$EL.joinToString(i.fullId,d.id),s);(0,u.$dh)(a)&&r.push(a)}if(r.length)return Promise.all(r).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const d=new u.$qh;return d.open(),d}i.expand=2,this.N(i);const s=i.resolveBarrier=new u.$qh,r=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,d)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(d){r(d)}return(0,u.$dh)(t)?t.catch(r).then(()=>{s.open(),this.J(i)}):(s.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const s=this.tree.get(i);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const r=[s];for(;r.length;){const t=r.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.F(d.id);this.tree.delete(t.fullId.toString());for(const[d,a]of this.s.getChildren(t.actual))r.push(this.tree.get(w.$EL.joinToString(t.fullId,a.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$8O=y;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$9O=v;class l extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$0O=l;class g extends Error{constructor(i,s,r){super(`TestItem with ID "${i}" is from controller "${s}" and cannot be added as a child of an item from controller "${r}".`)}}e.$$O=g;const c=(n,i,s)=>{let r=new Map;return{get size(){return r.size},forEach(t,d){for(const a of r.values())t.call(d,a,this)},[Symbol.iterator](){return r.entries()},replace(t){const d=new Map,a=new Set(r.keys()),h={op:5,ops:[]};for(const o of t){if(!(o instanceof s))throw new l(o.id);const p=i(o).controllerId;if(p!==n.controllerId)throw new g(o.id,p,n.controllerId);if(d.has(o.id))throw new v(o.id);d.set(o.id,o),a.delete(o.id),h.ops.push({op:0,item:o})}for(const o of a.keys())h.ops.push({op:3,id:o});n.listener?.(h),r=d},add(t){if(!(t instanceof s))throw new l(t.id);r.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){r.delete(t)&&n.listener?.({op:3,id:t})},get(t){return r.get(t)},toJSON(){return Array.from(r.values())}}};e.$_O=c}),define(ke[144],Se([1,0,112]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=void 0;const N=new WeakMap,M=(R,w)=>{const $={controllerId:w};return N.set(R,$),$};e.$aP=M;const A=R=>{const w=N.get(R);if(!w)throw new u.$0O(R?.id||"<unknown>");return w};e.$bP=A}),define(ke[113],Se([1,0,15,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$xb=e.$0xb=e.$9xb=void 0,e.$_xb=M,e.$ayb=R,e.$9xb="vscode-cdn.net",e.$0xb=`vscode-resource.${e.$9xb}`,e.$$xb=`'self' https://*.${e.$9xb}`;function M(w,$){return w.scheme===u.Schemas.http||w.scheme===u.Schemas.https?w:($&&$.authority&&$.isRemote&&w.scheme===u.Schemas.file&&(w=N.URI.from({scheme:u.Schemas.vscodeRemote,authority:$.authority,path:w.path})),N.URI.from({scheme:u.Schemas.https,authority:`${w.scheme}+${A(w.authority)}.${e.$0xb}`,path:w.path,fragment:w.fragment,query:w.query}))}function A(w){return w.replace(/./g,$=>{const S=$.charCodeAt(0);return S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57?$:"-"+S.toString(16).padStart(4,"0")})}function R(w){return w.replace(/-([0-9a-f]{4})/g,($,S)=>String.fromCharCode(parseInt(S,16)))}}),define(ke[299],Se([1,0,4,3,113]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=void 0;class A{constructor(w,$,S){this.d=w,this.e=$,this.f=S,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const L=$.getVisibleTextEditors();for(const C of this.c.values())L.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(w=>w.inset.dispose()),this.b.dispose()}createWebviewEditorInset(w,$,S,L,C){let m;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===w){m=i;break}if(!m)throw new Error("not a visible editor");const y=this,v=this.a++,l=new u.$be,g=new u.$be,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,M.$_xb)(i,y.f)}get cspSource(){return M.$$xb}set options(i){this.b=i,y.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,y.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(i){return y.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=w,this.line=$,this.height=S,this.webview=c,this.onDidDispose=g.event}dispose(){y.c.has(v)&&(y.c.delete(v),y.d.$disposeEditorInset(v),g.fire(),g.dispose(),l.dispose())}};return this.d.$createEditorInset(v,m.id,m.value.document.uri,$+1,S,L||{},C.identifier,C.extensionLocation),this.c.set(v,{editor:w,inset:n,onDidReceiveMessage:l}),n}$onDidDispose(w){const $=this.c.get(w);$&&$.inset.dispose()}$onDidReceiveMessage(w,$){this.c.get(w)?.onDidReceiveMessage.fire($)}}e.$Skc=A}),define(ke[145],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=e.$UL=void 0,e.$UL="__",e.$VL=(0,u.$ri)("IAuthenticationService"),e.$WL=(0,u.$ri)("IAuthenticationExtensionsService")}),define(ke[300],Se([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=e.VariableKind=e.$4P=void 0,e.$4P=(0,u.$ri)("configurationResolverService");var N;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class M extends Error{constructor(R,w){super(w),this.variable=R}}e.$5P=M}),define(ke[301],Se([1,0,17,51,18,24,11,103,240,300,14]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hQ=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,v,l,g){this.h=new Map,this.a=y,this.b=v,this.g=l,g&&(this.c=g.then(c=>this.i(c)))}i(y){if(R.$i){const v=Object.create(null);return Object.keys(y).forEach(l=>{v[l.toLowerCase()]=y[l]}),v}return y}resolveWithEnvironment(y,v,l){return this.l({env:this.i(y),userHome:void 0},v?v.uri:void 0,l)}async resolveAsync(y,v){const l={env:await this.c,userHome:await this.g};return this.l(l,y?y.uri:void 0,v)}async j(y,v,l,g){const c=A.$Xn(v);R.$i&&c.windows?Object.keys(c.windows).forEach(i=>c[i]=c.windows[i]):R.$j&&c.osx?Object.keys(c.osx).forEach(i=>c[i]=c.osx[i]):R.$k&&c.linux&&Object.keys(c.linux).forEach(i=>c[i]=c.linux[i]),delete c.windows,delete c.osx,delete c.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,y?y.uri:void 0,c,l,g)}async resolveAnyAsync(y,v,l){return this.j(y,v,l)}async resolveAnyMap(y,v,l){const g=new Map;return{newConfig:await this.j(y,v,l,g),resolvedVariables:g}}resolveWithInteractionReplace(y,v,l,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,v,l,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,v){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,v)}async l(y,v,l,g,c){if(M.$5f(l))return this.m(y,v,l,g,c);if(Array.isArray(l))return Promise.all(l.map(n=>this.l(y,v,n,g,c)));if(M.$7f(l)){const n=Object.create(null),i=await Promise.all(Object.keys(l).map(async s=>[await this.m(y,v,s,g,c),await this.l(y,v,l[s],g,c)]));for(const[s,r]of i)n[s]=r;return n}return l}m(y,v,l,g,c){return(0,L.$mf)(l,C.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(C.VARIABLE_LHS))return n;let s=await this.o(y,n,i,v,g);return c?.set(i,s),s!==n&&M.$5f(s)&&s.match(C.VARIABLE_REGEXP)&&(s=await this.m(y,v,s,g,c)),s})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,v,l,g,c){let n;const i=l.split(":");i.length>1&&(l=i[0],n=i[1]);const s=d=>{const a=this.a.getFilePath();if(a)return(0,w.$rw)(a);throw new S.$5P(d,(0,$.localize)(0,null,v))},r=d=>{const a=s(d);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return(0,w.$rw)(h)}throw new S.$5P(d,(0,$.localize)(1,null,v,u.$oc(a)))},t=d=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new S.$5P(d,(0,$.localize)(2,null,v,n))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new S.$5P(d,(0,$.localize)(3,null,v)):new S.$5P(d,(0,$.localize)(4,null,v))};switch(l){case"env":if(n){if(y.env){const d=y.env[R.$i?n.toLowerCase():n];if(M.$5f(d))return d}return""}throw new S.$5P(S.VariableKind.Env,(0,$.localize)(5,null,v));case"config":if(n){const d=this.a.getConfigurationValue(g,n);if(M.$bg(d))throw new S.$5P(S.VariableKind.Config,(0,$.localize)(6,null,v,n));if(M.$7f(d))throw new S.$5P(S.VariableKind.Config,(0,$.localize)(7,null,v,n));return d}throw new S.$5P(S.VariableKind.Config,(0,$.localize)(8,null,v));case"command":return this.p(S.VariableKind.Command,v,n,c,"command");case"input":return this.p(S.VariableKind.Input,v,n,c,"input");case"extensionInstallFolder":if(n){const d=await this.a.getExtension(n);if(!d)throw new S.$5P(S.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,v,n));return this.n(d.extensionLocation)}throw new S.$5P(S.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,v));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,w.$rw)(this.n(t(S.VariableKind.WorkspaceFolder)));case"cwd":return g||n?(0,w.$rw)(this.n(t(S.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.$rw)(u.$oc(this.n(t(S.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new S.$5P(S.VariableKind.UserHome,(0,$.localize)(11,null,v))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new S.$5P(S.VariableKind.LineNumber,(0,$.localize)(12,null,v))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new S.$5P(S.VariableKind.SelectedText,(0,$.localize)(13,null,v))}case"file":return s(S.VariableKind.File);case"fileWorkspaceFolder":return r(S.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return u.$oc(r(S.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||n?u.$mc(this.n(t(S.VariableKind.RelativeFile)),s(S.VariableKind.RelativeFile)):s(S.VariableKind.RelativeFile);case"relativeFileDirname":{const d=u.$nc(s(S.VariableKind.RelativeFileDirname));if(g||n){const a=u.$mc(this.n(t(S.VariableKind.RelativeFileDirname)),d);return a.length===0?".":a}return d}case"fileDirname":return u.$nc(s(S.VariableKind.FileDirname));case"fileExtname":return u.$pc(s(S.VariableKind.FileExtname));case"fileBasename":return u.$oc(s(S.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=u.$oc(s(S.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-u.$pc(d).length)}case"fileDirnameBasename":return u.$oc(u.$nc(s(S.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||v}case"execInstallFolder":{const d=this.a.getAppRoot();return d||v}case"pathSeparator":case"/":return u.sep;default:try{const d=n?`${l}:${n}`:l;return this.p(S.VariableKind.Unknown,v,d,c,void 0)}catch{return v}}}}p(y,v,l,g,c){if(l&&g){const n=c===void 0?g[l]:g[c+":"+l];if(typeof n=="string")return n;throw new S.$5P(y,(0,$.localize)(14,null,v))}return v}}e.$hQ=C}),define(ke[146],Se([1,0,5,142]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$KD=void 0,e.$LD=S,e.$MD=m,e.$ND=y,e.$KD=(0,u.$ri)("editorGroupsService");var M;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var R;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var w;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var $;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function S(v){const l=v;return(0,N.$vF)(l?.editor)&&(0,N.$vF)(l?.replacement)}var L;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var C;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(v){const l=v;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}function y(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[302],Se([1,0,5,146]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RD=e.$QD=e.$PD=e.$OD=void 0,e.$SD=M,e.$OD=(0,u.$ri)("editorService"),e.$PD=-1,e.$QD=-2,e.$RD=-3;function M(A){const R=A;return typeof A=="number"||(0,N.$MD)(R)}}),define(ke[147],Se([1,0,5,136]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=void 0,e.$dM=(0,u.$si)(N.$yi)}),define(ke[148],Se([1,0,25,4,17,3,8]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_b=e.$d_b=e.$c_b=e.$b_b=e.$a_b=void 0;class w{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$a_b=w;class ${static isHostExtension(n,i,s){if(i.getExtensionDescription(n))return!1;const r=s.getExtensionDescription(n);return r?!!((r.main||r.browser)&&r.api==="none"):!1}constructor(n,i){this.j=n,this.c=new N.$be,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(l),this.f=new u.$Om,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const s of i)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=g(this.e,i),this.e=this.e.concat(n);const s=$.l(this.e);return this.e=g(this.e,s.map(r=>r.identifier)),this.k(),this.d++,this.c.fire(void 0),new w(this.d,s)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,h){this.addNode(a),this.addNode(h),this.c.has(a)?this.c.get(a).push(h):this.c.set(a,[h])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,h){const o=i.getArcs(a);for(let p=0;p<o.length;p++)if(!h.has(o[p]))return!1;return!0}getNodes(){return this.e}},s=new u.$Om;for(const a of n)if(s.set(a.identifier,a),a.extensionDependencies)for(const h of a.extensionDependencies)i.addArc(u.$Mm.toKey(a.identifier),u.$Mm.toKey(h));const r=new Set;i.getNodes().filter(a=>i.getArcs(a).length===0).forEach(a=>r.add(a));const t=i.getNodes().filter(a=>!r.has(a));let d;do{d=!1;for(let a=0;a<t.length;a++){const h=t[a];i.hasOnlyGoodArcs(h,r)&&(t.splice(a,1),a--,r.add(h),d=!0)}}while(d);return t.map(a=>s.get(a))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new S(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$b_b=$;class S{constructor(n,i){this.versionId=n,this.extensions=i}}e.$c_b=S;class L{constructor(n){this.d=new y,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new C(this,i)}deltaExtensions(n,i,s){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$d_b=L;class C extends A.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$e_b=C;class m{constructor(n){this.name=n;const i=(0,R.$kh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class y{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new m(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),r=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};n.resolve((0,A.$Sc)(r))}}var v;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(v||(v={}));function l(c,n){const i=c.isBuiltin?0:c.isUnderDevelopment?2:1,s=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==s)return i-s;const r=M.$hc.basename(c.extensionLocation.path),t=M.$hc.basename(n.extensionLocation.path);return r<t?-1:r>t?1:0}function g(c,n){const i=new u.$Nm(n);return c.filter(s=>!i.has(s.identifier))}}),define(ke[303],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.ExtHostConnectionType=void 0,e.$in=w,e.$jn=$;var u;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(u||(e.ExtHostConnectionType=u={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[N.ENV_KEY]=this.pipeName}}e.$fn=N;class M{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[M.ENV_KEY]="1"}}e.$gn=M;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[A.ENV_KEY]="1"}}e.$hn=A;function R(L){delete L[N.ENV_KEY],delete L[M.ENV_KEY],delete L[A.ENV_KEY]}function w(L,C){R(C),L.serialize(C)}function $(L){if(L[N.ENV_KEY])return S(L,new N(L[N.ENV_KEY]));if(L[M.ENV_KEY])return S(L,new M);if(L[A.ENV_KEY])return S(L,new A);throw new Error("No connection information defined in environment!")}function S(L,C){return R(L),C}}),define(ke[114],Se([1,0,21]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Um=R,e.$Vm=w;var N;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(N||(e.UIKind=N={}));var M;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var A;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function R(S){const L=u.$Ce.alloc(1);switch(S){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}function w(S,L){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}var $;(function(S){S.Start="START_NATIVE_LOG",S.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],Se([1,0,5,4,12,28,114,86,87,24,2,3,225]),function(le,e,u,N,M,A,R,w,$,S,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=e.$xP=e.$wP=void 0,e.$yP=l;let y=class extends C.$Uc{constructor(c,n){super(),this.s=c,this.t=n,this.a=this.B(new N.$be),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$be),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=L.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$fp,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,M.$Zj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,n,i){const s=this.getTelemetryDetails(),r=new v(n,i,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}),t=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...t,r]),r.apiTelemetryLogger}$initializeTelemetryLevel(c,n,i){this.f=c,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const n=Object.create(null);switch(n["common.extname"]=`${c.publisher}.${c.name}`,n["common.extversion"]=c.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=l(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,w.$Dm)((0,$.$lp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const n=this.getTelemetryDetails();this.r.forEach((i,s)=>{const r=i.filter(t=>!t.isDisposed);r.length===0?this.r.delete(s):this.r.set(s,r)}),this.r.forEach(i=>{for(const s of i)s.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,n){const s=this.r.get(c.value)?.filter(t=>!t.isDisposed);if(!s)return this.r.delete(c.value),!1;let r=!1;for(const t of s)t.ignoreUnhandledExtHostErrors||(t.logError(n),r=!0);return r}};e.$wP=y,e.$wP=y=Qe([Ve(0,A.$vP),Ve(1,M.$Yj)],y);class v{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,n,i,s,r,t,d){this.g=i,this.h=s,this.i=r,this.j=t,this.a=new N.$be,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(c,n){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let n="properties"in c?c.properties??{}:c;return n=(0,$.$op)(n,[]),this.c&&(n=(0,S.$1n)(n,this.c)),this.b||(n=(0,S.$1n)(n,this.j)),"properties"in c?c.properties=n:c=n,c}k(c,n){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(c,n),this.h.trace(c,n))}logUsage(c,n){this.d.isUsageEnabled&&this.k(c,n)}logError(c,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,n);else{const i={name:c.name,message:c.message,stack:c.stack,cause:c.cause},s=(0,$.$op)(i,[]),r=new Error(s.message,{cause:s.cause});r.stack=s.stack,r.name=s.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(r,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const c=this,n={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$xP=v;function l(g){const c=Date.now()-new Date(g).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$zP=(0,u.$ri)("IExtHostTelemetry")}),define(ke[26],Se([1,0,4,2,271,140,25,5]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FG=e.ActivationKind=e.$CG=e.$BG=e.$yG=e.ExtensionHostStartup=e.$xG=e.$wG=e.$vG=e.$uG=void 0,e.$zG=m,e.$AG=y,e.$DG=c,e.$EG=n,e.$uG=Object.freeze({identifier:new R.$Mm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$vG="extensions.webWorker",e.$wG=(0,w.$ri)("extensionService");class ${constructor(r){this.dependency=r}}e.$xG=$;var S;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(S||(e.ExtensionHostStartup=S={}));class L{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(r,t,d){this.c=r,this.d=t.slice(0),this.e=d.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$fG.createActivationEventsMap(this.d)}}set(r,t,d){if(this.c>r)throw new Error(`ExtensionHostExtensions: invalid versionId ${r} (current: ${this.c})`);const a=[],h=[],o=[],p=[],f=C(this.d),D=C(t),b=(F,j)=>F.extensionLocation.toString()===j.extensionLocation.toString()||F.isBuiltin===j.isBuiltin||F.isUserBuiltin===j.isUserBuiltin||F.isUnderDevelopment===j.isUnderDevelopment;for(const F of this.d){const j=D.get(F.identifier);if(!j){a.push(F.identifier),f.delete(F.identifier);continue}if(!b(F,j)){a.push(F.identifier),f.delete(F.identifier);continue}}for(const F of t){const j=f.get(F.identifier);if(!j){h.push(F);continue}if(!b(j,F)){a.push(j.identifier),f.delete(j.identifier);continue}}const k=new R.$Nm(this.e),E=new R.$Nm(d);for(const F of this.e)E.has(F)||o.push(F);for(const F of d)k.has(F)||p.push(F);const P=A.$fG.createActivationEventsMap(h),I={versionId:r,toRemove:a,toAdd:h,addActivationEvents:P,myToRemove:o,myToAdd:p};return this.delta(I),I}delta(r){if(this.c>=r.versionId)return null;const{toRemove:t,toAdd:d,myToRemove:a,myToAdd:h}=r,o=new R.$Nm(t),p=new R.$Nm(a);for(let f=0;f<this.d.length;f++)o.has(this.d[f].identifier)&&(this.d.splice(f,1),f--);for(let f=0;f<this.e.length;f++)p.has(this.e[f])&&(this.e.splice(f,1),f--);for(const f of d)this.d.push(f);for(const f of h)this.e.push(f);return this.f=null,r}containsExtension(r){for(const t of this.e)if(R.$Mm.equals(t,r))return!0;return!1}containsActivationEvent(r){return this.f||(this.f=this.g()),this.f.has(r)}g(){const r=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const d=A.$fG.readActivationEvents(t);for(const a of d)r.add(a)}return r}}e.$yG=L;function C(s){const r=new R.$Om;for(const t of s)r.set(t.identifier,t);return r}function m(s,r){return s.enabledApiProposals?s.enabledApiProposals.includes(r):!1}function y(s,r){if(!m(s,r))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${r}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${r}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class v{constructor(r,t,d,a){this.codeLoadingTime=r,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=a}}e.$BG=v;class l{constructor(r,t){this.description=r,this.value=t}}e.$CG=l;var g;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function c(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,M.$up)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function n(s,r){return{identifier:new R.$Mm((0,M.$sp)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!r,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.onWillStop=u.Event.None,this.extensions=[]}activateByEvent(r){return Promise.resolve(void 0)}activateById(r,t){return Promise.resolve(void 0)}activationEventIsDone(r){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(r){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(r,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(r){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$FG=i}),define(ke[304],Se([1,0,13,148,25,26,12,8]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=e.$glc=e.$flc=e.$elc=e.$dlc=e.$clc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(c,n,i,s){this.startup=c,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=s}}e.$clc=$;class S{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,n){return c===-1||n===-1?-1:n-c}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$dlc=S;class L{constructor(c,n,i,s,r,t){this.activationFailed=c,this.activationFailedError=n,this.activationTimes=i,this.module=s,this.exports=r,this.subscriptions=t}}e.$elc=L;class C extends L{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$flc=C;class m extends L{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$glc=m;class y extends L{constructor(c){super(!0,c,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(c,n,i,s){this.g=s,this.a=c,this.b=n,this.c=i,this.d=new M.$Om,this.f=Object.create(null)}dispose(){for(const[c,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const c=[];for(const[n,i]of this.d)c.push(i.wait());await Promise.all(c)}isActivated(c){const n=this.d.get(c);return!!(n&&n.value)}getActivatedExtension(c){const n=this.d.get(c);if(!n||!n.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return n.value}async activateByEvent(c,n){if(this.f[c])return;const i=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(i.map(s=>({id:s.identifier,reason:{startup:n,extensionId:s.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,n){const i=this.a.getExtensionDescription(c);if(!i)throw new Error(`Extension '${c.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(c){const n=c.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const n=this.a.getExtensionDescription(c.id);if(!n){const r=new Error(`Cannot activate unknown extension '${c.id.value}'`),t=this.k(c,null,[],new y(r));return this.c.onExtensionActivationError(c.id,r,new A.$xG(c.id.value)),t}const i=[],s=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const r of s){if(this.m(r))continue;const t=this.d.get(r);if(t){i.push(t);continue}if(this.l(r)){i.push(this.j({id:this.b.getExtensionDescription(r).identifier,reason:c.reason}));continue}const d=this.a.getExtensionDescription(r);if(d){if(!d.main&&!d.browser)continue;i.push(this.j({id:d.identifier,reason:c.reason}));continue}const a=n.displayName||n.identifier.value,h=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${r}'`),o=this.k(c,n.displayName,[],new y(h));return this.c.onExtensionActivationError(n.identifier,h,new A.$xG(r)),o}return this.k(c,n.displayName,i,null)}k(c,n,i,s){const r=new l(c.id,n,c.reason,i,s,this.c,this.g);return this.d.set(c.id,r),r}l(c){return N.$b_b.isHostExtension(c,this.a,this.b)}m(c){const n=this.b.getExtensionDescription(c);return n?!n.main&&!n.browser:!1}};e.$hlc=v,e.$hlc=v=Qe([Ve(3,R.$Xj)],v);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,n,i,s,r,t,d){this.c=c,this.d=n,this.f=i,this.g=s,this.h=r,this.j=t,this.k=d,this.a=new w.$qh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const n=this.g[c];if(n.value&&!n.value.activationFailed){this.g.splice(c,1),c--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new y(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const n=new Error;if(c&&c.name&&(n.name=c.name),c&&c.message?n.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(n.stack=c.stack),this.h=new y(n),this.b&&u.$4(c))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};l=Qe([Ve(6,R.$Xj)],l)}),define(ke[305],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[306],Se([1,0,242,13,41,137,109,38,25,305,139,140]),function(le,e,u,N,M,A,R,w,$,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=void 0;const m=w.$0n.as(R.$$n.JSONContribution);class y{constructor(r,t,d){this.a=r,this.b=t,this.c=d}d(r,t){this.a({type:r,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(r){this.d(M.default.Error,r)}warn(r){this.d(M.default.Warning,r)}info(r){this.d(M.default.Info,r)}}e.$oG=y;class v{static a(r){const t=new $.$Nm;for(let d=0,a=r.length;d<a;d++)t.add(r[d].description.identifier);return t}static compute(r,t){if(!r||!r.length)return new v(t,[]);if(!t||!t.length)return new v([],r);const d=this.a(r),a=this.a(t),h=t.filter(p=>!d.has(p.description.identifier)),o=r.filter(p=>!a.has(p.description.identifier));return new v(h,o)}constructor(r,t){this.added=r,this.removed=t}}e.$pG=v;class l{constructor(r,t){this.name=r,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(r){if(this.a!==null)throw new Error("Handler already set!");this.a=r,this.d()}acceptUsers(r){this.c=v.compute(this.b,r),this.b=r,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(r){(0,N.$1)(r)}}}e.$qG=l;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$rG={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Lm},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}},api:{markdownDescription:u.localize(15,null),type:"string",enum:["none"],enumDescriptions:[u.localize(16,null)]},activationEvents:{description:u.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(32,null)},{label:"onUri",body:"onUri",description:u.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(37,null)},{label:"onRenderer",description:u.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:u.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:u.localize(42,null)},{label:"*",description:u.localize(43,null),body:"*"}]}},badges:{type:"array",description:u.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(45,null)},href:{type:"string",description:u.localize(46,null)},description:{type:"string",description:u.localize(47,null)}}}},markdown:{type:"string",description:u.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Oo}},extensionPack:{description:u.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Oo}},extensionKind:{description:u.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(53,null)},{body:["workspace"],description:u.localize(54,null)},{body:["ui","workspace"],description:u.localize(55,null)},{body:["workspace","ui"],description:u.localize(56,null)},{body:[],description:u.localize(57,null)}]},capabilities:{description:u.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(61,null),u.localize(62,null),u.localize(63,null)]},description:{type:"string",markdownDescription:u.localize(64,null)}}},untrustedWorkspaces:{description:u.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]},restrictedConfigurations:{description:u.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(71,null)}}}}},sponsor:{description:u.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(74,null),type:"string"},"vscode:uninstall":{description:u.localize(75,null),type:"string"}}},icon:{type:"string",description:u.localize(76,null)},l10n:{type:"string",description:u.localize(77,null)},pricing:{type:"string",markdownDescription:u.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(r){if(this.a.has(r.extensionPoint))throw new Error("Duplicate extension point: "+r.extensionPoint);const t=new l(r.extensionPoint,r.defaultExtensionKind);return this.a.set(r.extensionPoint,t),r.activationEventsGenerator&&C.$fG.register(r.extensionPoint,r.activationEventsGenerator),e.$rG.properties.contributes.properties[r.extensionPoint]=r.jsonSchema,m.registerSchema(c,e.$rG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$sG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};w.$0n.add(i.ExtensionsRegistry,new n),e.$tG=w.$0n.as(i.ExtensionsRegistry),m.registerSchema(c,e.$rG),m.registerSchema(L.$fk,{properties:{extensionEnabledApiProposals:{description:u.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}}]}}}})}),define(ke[307],Se([1,0,238,18,24,306,37,4]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var S;(function(m){function y(v,l,g){if(!v)return;const c=N.$5f(v.type)?v.type:void 0;if(!c||c.length===0){g.error(u.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)N.$5f(i)&&n.push(i);return{extensionId:l.value,taskType:c,required:n,properties:v.properties?M.$Xn(v.properties):{},when:v.when?R.$pj.deserialize(v.when):void 0}}m.from=y})(S||(S={}));const L=A.$tG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,y)=>{for(const v of m)v.type&&y.push(`onTaskType:${v.type}`)},jsonSchema:{description:u.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new w.$be,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,v)=>{L.setHandler((l,g)=>{this.c=void 0;try{for(const c of g.removed){const n=c.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const c of g.added){const n=c.value;for(const i of n){const s=S.from(i,c.description.identifier,c.collector);s&&(this.a[s.taskType]=s)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const v of this.all()){const l={type:"object",additionalProperties:!1};v.required.length>0&&(l.required=v.required.slice(0)),v.properties!==void 0?l.properties=M.$Xn(v.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[v.taskType]},y.push(l)}this.c={oneOf:y}}return this.c}}e.$XH=new C}),define(ke[308],Se([1,0,239,18,23,24,37,307]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$8H=e.JsonSchemaVersion=e.ExecutionEngine=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$2H=e.ShellQuoting=e.$1H=e.$ZH=e.$YH=void 0,e.$YH="settings",e.$ZH=new R.$Ij("taskRunning",!1,u.localize(0,null)),e.$1H=u.localize2(2,"Tasks");var $;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$2H="$customized",function(O){function T(B){if(!B)return O.Strong;switch(B.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=T}($||(e.ShellQuoting=$={}));var S;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(S||(e.CommandOptions=S={}));var L;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(L||(e.RevealKind=L={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=T}(L||(e.RevealKind=L={}));var C;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=T}(C||(e.RevealProblemKind=C={}));var m;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(m||(e.PanelKind=m={})),function(O){function T(B){switch(B.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=T}(m||(e.PanelKind=m={}));var y;(function(O){O.defaults={echo:!0,reveal:L.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var v;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(O){function T(W){switch(W.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=T;function B(W){switch(W){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=B}(v||(e.RuntimeType=v={}));var l;(function(O){function T(B){return N.$5f(B)?B:B.value}O.value=T})(l||(e.CommandString=l={}));var g;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function T(W){return W===O.Clean._id||W===O.Build._id||W===O.Rebuild._id||W===O.Test._id}O.is=T;function B(W){if(W!==void 0)return N.$5f(W)?T(W)?{_id:W,isDefault:!1}:void 0:W}O.from=B})(g||(e.TaskGroup=g={}));var c;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var n;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function T(B){switch(B){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=T})(n||(e.TaskSourceKind=n={}));var i;(function(O){O.parallel="parallel",O.sequence="sequence"})(i||(e.DependsOrder=i={}));var s;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(s||(e.RunOnOptions=s={}));var r;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:s.default,instanceLimit:1}})(r||(e.RunOptions=r={}));class t{constructor(T,B,W,X,Z,Y){this._label="",this._id=T,B&&(this._label=B),W&&(this.type=W),this.runOptions=X,this.configurationProperties=Z,this._source=Y}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,B=!1){if(T===void 0)return!1;if(N.$5f(T))return T===this._label||T===this.configurationProperties.identifier||B&&T===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$3H=t;class d extends t{constructor(T,B,W,X,Z,Y,x,ne){super(T,W,void 0,x,ne,B),this.command={},this._source=B,this.hasDefinedMatchers=Y,Z&&(this.command=Z)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(T){return T instanceof d}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$YH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$2H,folder:T,id:B};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$2g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new d(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$4H=d;class a extends t{constructor(T,B,W,X,Z,Y,x){super(T,W,X,Y,x,B),this._source=B,this.configures=Z}static is(T){return T instanceof a}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$2g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$YH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$2H,folder:T,id:B};return JSON.stringify(W)}}e.$5H=a;class h extends t{constructor(T,B,W,X,Z,Y,x,ne,ge){super(T,W,X,ne,ge,B),this.defines=Z,this.hasDefinedMatchers=x,this.command=Y,this.icon=ge.icon,this.hide=ge.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof h}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new h(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$6H=h;class o extends t{constructor(T,B,W,X,Z,Y){super(T,W,X,Z,Y,B),this._source=B}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new o(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$7H=o;var p;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(O){O._default=O.Terminal}(p||(e.ExecutionEngine=p={}));var f;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(f||(e.JsonSchemaVersion=f={}));class D{constructor(T){this.c=new Map;for(let B=0;B<T.length;B++)this.c.set(T[B].uri.toString(),B)}compare(T,B){const W=T.getWorkspaceFolder(),X=B.getWorkspaceFolder();if(W&&X){let Z=this.c.get(W.uri.toString());Z=Z===void 0?0:Z+1;let Y=this.c.get(X.uri.toString());return Y=Y===void 0?0:Y+1,Z===Y?T._label.localeCompare(B._label):Z-Y}else return!W&&X?-1:W&&!X?1:0}}e.$8H=D;var b;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(b||(e.TaskEventKind=b={}));var k;(function(O){O.SingleRun="singleRun",O.Background="background"})(k||(e.TaskRunType=k={}));var E;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var P;(function(O){function T(ne){return{taskId:ne._id,taskName:ne.configurationProperties.name,runType:ne.configurationProperties.isBackground?"background":"singleRun",group:ne.configurationProperties.group,__task:ne}}function B(ne,ge,ue){return{...T(ne),kind:"start",terminalId:ge,resolvedVariables:ue}}O.start=B;function W(ne,ge,ue){return{...T(ne),kind:"processStarted",terminalId:ge,processId:ue}}O.processStarted=W;function X(ne,ge,ue){return{...T(ne),kind:"processEnded",terminalId:ge,exitCode:ue}}O.processEnded=X;function Z(ne,ge,ue){return{...T(ne),kind:"terminated",exitReason:ue,terminalId:ge}}O.terminated=Z;function Y(ne,ge,ue){return{...T(ge),kind:ne,terminalId:ue}}O.general=Y;function x(){return{kind:"changed"}}O.changed=x})(P||(e.TaskEvent=P={}));var I;(function(O){function T(W){const X=Object.keys(W).sort();let Z="";for(const Y of X){let x=W[Y];x instanceof Object?x=T(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),Z+=Y+","+x+","}return Z}function B(W){const Z={_key:T(W),type:W.taskType};return Object.assign(Z,W),Z}O.create=B})(I||(e.KeyedTaskIdentifier=I={}));var F;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection",O.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var j;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(O){function T(B,W){const X=w.$XH.get(B.type);if(X===void 0){const ne=A.$Xn(B);return delete ne._key,I.create(ne)}const Z=Object.create(null);Z.type=X.taskType;const Y=new Set;X.required.forEach(ne=>Y.add(ne));const x=X.properties;for(const ne of Object.keys(x)){const ge=B[ne];if(ge!=null)Z[ne]=ge;else if(Y.has(ne)){const ue=x[ne];if(ue.default!==void 0)Z[ne]=A.$Xn(ue.default);else switch(ue.type){case"boolean":Z[ne]=!1;break;case"number":case"integer":Z[ne]=0;break;case"string":Z[ne]="";break;default:W.error(u.localize(1,null,JSON.stringify(B,void 0,0),ne));return}}}return I.create(Z)}O.createTaskIdentifier=T})(z||(e.TaskDefinition=z={}))}),define(ke[309],Se([1,0,13]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g_b=e.$f_b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,w)=>{this.b=R,this.d=w,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,u.$1)(R))}then(R,w){return this.j().then(R,w)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$f_b=N;class M extends N{constructor(){super(),this.h=!0,this.i=new u.$5}}e.$g_b=M}),define(ke[48],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$lw=void 0,e.$mw=M,e.$nw=A;class u{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++u.count}}e.$lw=u;const N=[];function M(w){const $=new u(w);return N[$.nid]=$,$}function A(w){return N[w].sid}class R{constructor($){this.value=$}}e.$ow=R}),define(ke[6],Se([1,0,48]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$RM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var M;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput",l[l.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(M||(e.TabInputKind=M={}));var A;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var R;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var w;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var $;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var S;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(S||(e.NotebookEditorRevealType=S={}));var L;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class C{static{this.a=0}static mixin(g){return g._id=C.a++,g}}e.$RM=C;var m;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var y;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var v;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$SM={MainThreadAuthentication:(0,u.$mw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.$mw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,u.$mw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,u.$mw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,u.$mw)("MainThreadChatVariables"),MainThreadClipboard:(0,u.$mw)("MainThreadClipboard"),MainThreadCommands:(0,u.$mw)("MainThreadCommands"),MainThreadComments:(0,u.$mw)("MainThreadComments"),MainThreadConfiguration:(0,u.$mw)("MainThreadConfiguration"),MainThreadConsole:(0,u.$mw)("MainThreadConsole"),MainThreadDebugService:(0,u.$mw)("MainThreadDebugService"),MainThreadDecorations:(0,u.$mw)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.$mw)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.$mw)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.$mw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.$mw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.$mw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.$mw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.$mw)("MainThreadEditorTabs"),MainThreadErrors:(0,u.$mw)("MainThreadErrors"),MainThreadTreeViews:(0,u.$mw)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.$mw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,u.$mw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.$mw)("MainThreadLanguages"),MainThreadLogger:(0,u.$mw)("MainThreadLogger"),MainThreadMessageService:(0,u.$mw)("MainThreadMessageService"),MainThreadOutputService:(0,u.$mw)("MainThreadOutputService"),MainThreadProgress:(0,u.$mw)("MainThreadProgress"),MainThreadQuickDiff:(0,u.$mw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,u.$mw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.$mw)("MainThreadStatusBar"),MainThreadSecretState:(0,u.$mw)("MainThreadSecretState"),MainThreadStorage:(0,u.$mw)("MainThreadStorage"),MainThreadSpeech:(0,u.$mw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,u.$mw)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.$mw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,u.$mw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,u.$mw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.$mw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.$mw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.$mw)("MainThreadCustomEditors"),MainThreadUrls:(0,u.$mw)("MainThreadUrls"),MainThreadUriOpeners:(0,u.$mw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,u.$mw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,u.$mw)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.$mw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,u.$mw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,u.$mw)("MainThreadExtensionService"),MainThreadSCM:(0,u.$mw)("MainThreadSCM"),MainThreadSearch:(0,u.$mw)("MainThreadSearch"),MainThreadShare:(0,u.$mw)("MainThreadShare"),MainThreadTask:(0,u.$mw)("MainThreadTask"),MainThreadWindow:(0,u.$mw)("MainThreadWindow"),MainThreadLabelService:(0,u.$mw)("MainThreadLabelService"),MainThreadNotebook:(0,u.$mw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.$mw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.$mw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.$mw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.$mw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.$mw)("MainThreadInteractive"),MainThreadInlineChat:(0,u.$mw)("MainThreadInlineChatShape"),MainThreadTheming:(0,u.$mw)("MainThreadTheming"),MainThreadTunnelService:(0,u.$mw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,u.$mw)("MainThreadManagedSockets"),MainThreadTimeline:(0,u.$mw)("MainThreadTimeline"),MainThreadTesting:(0,u.$mw)("MainThreadTesting"),MainThreadLocalization:(0,u.$mw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,u.$mw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,u.$mw)("MainThreadAiEmbeddingVector")},e.$TM={ExtHostCommands:(0,u.$mw)("ExtHostCommands"),ExtHostConfiguration:(0,u.$mw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.$mw)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.$mw)("ExtHostDebugService"),ExtHostDecorations:(0,u.$mw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.$mw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.$mw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.$mw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.$mw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.$mw)("ExtHostEditors"),ExtHostTreeViews:(0,u.$mw)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.$mw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.$mw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.$mw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.$mw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.$mw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.$mw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,u.$mw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,u.$mw)("ExtHostStatusBar"),ExtHostShare:(0,u.$mw)("ExtHostShare"),ExtHostExtensionService:(0,u.$mw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.$mw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.$mw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,u.$mw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,u.$mw)("ExtHostSCM"),ExtHostSearch:(0,u.$mw)("ExtHostSearch"),ExtHostTask:(0,u.$mw)("ExtHostTask"),ExtHostWorkspace:(0,u.$mw)("ExtHostWorkspace"),ExtHostWindow:(0,u.$mw)("ExtHostWindow"),ExtHostWebviews:(0,u.$mw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.$mw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.$mw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.$mw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.$mw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.$mw)("ExtHostEditorTabs"),ExtHostProgress:(0,u.$mw)("ExtHostProgress"),ExtHostComments:(0,u.$mw)("ExtHostComments"),ExtHostSecretState:(0,u.$mw)("ExtHostSecretState"),ExtHostStorage:(0,u.$mw)("ExtHostStorage"),ExtHostUrls:(0,u.$mw)("ExtHostUrls"),ExtHostUriOpeners:(0,u.$mw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,u.$mw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,u.$mw)("ExtHostOutputService"),ExtHostLabelService:(0,u.$mw)("ExtHostLabelService"),ExtHostNotebook:(0,u.$mw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.$mw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.$mw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.$mw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.$mw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,u.$mw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,u.$mw)("ExtHostInteractive"),ExtHostInlineChat:(0,u.$mw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,u.$mw)("ExtHostChatAgents"),ExtHostChatVariables:(0,u.$mw)("ExtHostChatVariables"),ExtHostChatProvider:(0,u.$mw)("ExtHostChatProvider"),ExtHostSpeech:(0,u.$mw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,u.$mw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,u.$mw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,u.$mw)("ExtHostTheming"),ExtHostTunnelService:(0,u.$mw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,u.$mw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,u.$mw)("ExtHostAuthentication"),ExtHostTimeline:(0,u.$mw)("ExtHostTimeline"),ExtHostTesting:(0,u.$mw)("ExtHostTesting"),ExtHostTelemetry:(0,u.$mw)("ExtHostTelemetry"),ExtHostLocalization:(0,u.$mw)("ExtHostLocalization")}}),define(ke[91],Se([1,0,5,12,6,20]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=e.$Ckc=e.$Bkc=void 0,e.$Bkc=(0,u.$ri)("IExtHostApiDeprecationService");let R=class{constructor($,S){this.c=S,this.a=new Set,this.b=$.getProxy(M.$SM.MainThreadTelemetry)}report($,S,L){const C=this.d($,S);this.a.has(C)||(this.a.add(C),S.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:S.identifier.value,apiId:$}))}d($,S){return`${$}-${S.identifier.value}`}};e.$Ckc=R,e.$Ckc=R=Qe([Ve(0,A.$fP),Ve(1,N.$Xj)],R),e.$Dkc=Object.freeze(new class{report(w,$,S){}})}),define(ke[310],Se([1,0,6]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;class N{constructor(A){const R=A.getProxy(u.$SM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(w){return R.$writeText(w)}})}}e.$Qkc=N}),define(ke[311],Se([1,0,24,6,28,20]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=void 0;let R=class{constructor(L,C){this.a=L.getProxy(N.$SM.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(L,C){const m=this,y=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){m.e(L,C,y,arguments)}})}e(L,C,m,y){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(y,this.b)}),this.c&&this.f(L,m,y)}};e.$Kmc=R,e.$Kmc=R=Qe([Ve(0,A.$fP),Ve(1,M.$vP)],R);const w=1e5;function $(S,L){const C=[];if(S.length)for(let m=0;m<S.length;m++){let y=S[m];if(typeof y>"u")y="undefined";else if(y instanceof Error){const v=y;v.stack?y=v.stack:y=v.toString()}C.push(y)}if(L){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,u.$3n)(C);return m.length>w?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ke[312],Se([1,0,2,6,26]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;class A{constructor(w){this.a=w.getProxy(N.$SM.MainThreadDialogs)}showOpenDialog(w,$){return $?.allowUIResources&&(0,M.$AG)(w,"showLocal"),this.a.$showOpenDialog($).then(S=>S?S.map(L=>u.URI.revive(L)):void 0)}showSaveDialog(w){return this.a.$showSaveDialog(w).then($=>$?u.URI.revive($):void 0)}}e.$Nlc=A}),define(ke[313],Se([1,0,3,6]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=void 0;class M{constructor(R){this.b=0,this.a=R.getProxy(N.$SM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const w=this.b++;return this.a.$registerResourceLabelFormatter(w,R),(0,u.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(w)})}}e.$8lc=M}),define(ke[115],Se([1,0,11,14,2,5,12,6,28,20]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$vlc=void 0;let L=class{constructor(m,y,v){this.f=v,this.d=new Map,this.a=y.getProxy(w.$SM.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===u.$g}getMessage(m,y){const{message:v,args:l,comment:g}=y;if(this.c)return(0,N.$6e)(v,l??{});let c=v;g&&g.length>0&&(c+=`/${Array.isArray(g)?g.join(""):g}`);const n=this.d.get(m)?.contents[c];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,N.$6e)(n??v,l??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let y;const v=await this.g(m);if(!v){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(v),g=JSON.parse(l);y=m.isBuiltin?g.contents?.bundle:g}catch(l){this.f.error(`Failed to load translations for ${m.identifier.value} from ${v}: ${l.message}`);return}y&&this.d.set(m.identifier.value,{contents:y,uri:v})}async g(m){if(m.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return M.URI.revive(y)}return m.l10n?M.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$vlc=L,e.$vlc=L=Qe([Ve(0,$.$vP),Ve(1,S.$fP),Ve(2,R.$Xj)],L),e.$wlc=(0,A.$ri)("IExtHostLocalizationService")}),define(ke[149],Se([1,0,12,6,28,20,2,58]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;let $=class extends u.$9j{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(y=>(0,w.$1h)(y))),this.r=C.getProxy(N.$SM.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(R.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,y){return new S(this.r,C,m,y)}};e.$Jmc=$,e.$Jmc=$=Qe([Ve(0,A.$fP),Ve(1,M.$vP)],$);class S extends u.$4j{constructor(C,m,y,v){super(v?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(m,v).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const y=[[C,m]];this.m?this.u(y):this.n.push(...y)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,21]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=e.$xlc=void 0,e.$xlc=(0,N.$ri)("IExtHostManagedSockets");let w=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(u.$SM.MainThreadManagedSockets)}setFactory(C,m){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,y=await this.c.makeConnection(),v=new M.$Tc;return this.d.set(m,new S(m,y,v)),v.add((0,M.$Sc)(()=>this.d.delete(m))),v.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),v.dispose()})),v.add(y.onDidClose(l=>{this.a.$onDidManagedSocketClose(m,l?.stack??l?.message),v.dispose()})),v.add(y.onDidReceiveMessage(l=>this.a.$onDidManagedSocketHaveData(m,R.$Ce.wrap(l)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$ylc=w,e.$ylc=w=Qe([Ve(0,A.$fP)],w);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class S extends M.$Uc{constructor(C,m,y){super(),this.socketId=C,this.actual=m,this.B(y)}}}),define(ke[314],Se([1,0,6,12,26]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;function A(w){return w&&w.title}let R=class{constructor($,S){this.b=S,this.a=$.getProxy(u.$SM.MainThreadMessageService)}showMessage($,S,L,C,m){const y={source:{identifier:$.identifier,label:$.displayName||$.name}};let v;typeof C=="string"||A(C)?v=[C,...m]:(y.modal=C?.modal,y.useCustom=C?.useCustom,y.detail=C?.detail,v=m),y.useCustom&&(0,M.$AG)($,"resolvers");const l=[];let g=!1;for(let c=0;c<v.length;c++){const n=v[c];if(typeof n=="string")l.push({title:n,handle:c,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:s}=n;l.push({title:i,isCloseAffordance:!!s,handle:c}),s&&(g?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):g=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(S,L,y,l).then(c=>{if(typeof c=="number")return v[c]})}};e.$0lc=R,e.$0lc=R=Qe([Ve(1,N.$Xj)],R)}),define(ke[315],Se([1,0,3,18,2,26,6]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;class w{constructor(S){this.b=new Map,this.a=S.getProxy(R.$SM.MainThreadProfileContentHandlers)}registerProfileContentHandler(S,L,C){if((0,A.$AG)(S,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,C),this.a.$registerProfileContentHandler(L,C.name,C.description,S.identifier.value),(0,u.$Sc)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(S,L,C,m){const y=this.b.get(S);if(!y)throw new Error(`Unknown handler with id: ${S}`);return y.saveProfile(L,C,m)}async $readProfile(S,L,C){const m=this.b.get(S);if(!m)throw new Error(`Unknown handler with id: ${S}`);return m.readProfile((0,N.$5f)(L)?L:M.URI.revive(L),C)}}e.$gmc=w}),define(ke[117],Se([1,0,6,4,5]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=e.$slc=void 0;class A{constructor(w){this.b=new N.$be,this.onDidChangePassword=this.b.event,this.a=w.getProxy(u.$SM.MainThreadSecretState)}async $onDidChangePassword(w){this.b.fire(w)}get(w,$){return this.a.$getPassword(w,$)}store(w,$,S){return this.a.$setPassword(w,$,S)}delete(w,$){return this.a.$deletePassword(w,$)}}e.$slc=A,e.$tlc=(0,M.$ri)("IExtHostSecretState")}),define(ke[316],Se([1,0,22,3,6]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=void 0;class A{static{this.a=1}constructor(w){this.c=new Map,this.d=new Map,this.b=w.getProxy(M.$SM.MainThreadSpeech)}async $createSpeechToTextSession(w,$,S){const L=this.c.get(w);if(!L)return;const C=new N.$Tc,m=new u.$me;this.d.set($,m);const y=C.add(L.provideSpeechToTextSession(m.token,S?{language:S}:void 0));C.add(y.onDidChange(v=>{m.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),C.add(m.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}async $createKeywordRecognitionSession(w,$){const S=this.c.get(w);if(!S)return;const L=new N.$Tc,C=new u.$me;this.d.set($,C);const m=L.add(S.provideKeywordRecognitionSession(C.token));L.add(m.onDidChange(y=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,y)})),L.add(C.token.onCancellationRequested(()=>L.dispose()))}async $cancelKeywordRecognitionSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}registerProvider(w,$,S){const L=A.a++;return this.c.set(L,S),this.b.$registerProvider(L,$,{extension:w,displayName:w.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(L),this.c.delete(L)})}}e.$nmc=A}),define(ke[118],Se([1,0,6,4,5]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=e.$ilc=void 0;class A{constructor(w,$){this.c=$,this.b=new N.$be,this.onDidChangeStorage=this.b.event,this.a=w.getProxy(u.$SM.MainThreadStorage)}registerExtensionStorageKeysToSync(w,$){this.a.$registerExtensionStorageKeysToSync(w,$)}async initializeExtensionStorage(w,$,S){const L=await this.a.$initializeExtensionStorage(w,$);let C;return L&&(C=this.d(w,$,L)),C||S}setValue(w,$,S){return this.a.$setValue(w,$,S)}$acceptValue(w,$,S){const L=this.d(w,$,S);L&&this.b.fire({shared:w,key:$,value:L})}d(w,$,S){try{return JSON.parse(S)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${w}): ${L}`)}}}e.$ilc=A,e.$jlc=(0,M.$ri)("IExtHostStorage")}),define(ke[317],Se([1,0,3,15,2,6]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;class R{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(A.$SM.MainThreadUriOpeners)}registerExternalUriOpener($,S,L,C){if(this.c.has(S))throw new Error(`Opener with id '${S}' already registered`);const m=C.schemes.find(y=>!R.a.has(y));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(S,L),this.b.$registerUriOpener(S,C.schemes,$,C.label),(0,u.$Sc)(()=>{this.c.delete(S),this.b.$unregisterUriOpener(S)})}async $canOpenUri($,S,L){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=M.URI.revive(S);return C.canOpenExternalUri(m,L)}async $openUri($,S,L){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(M.URI.revive(S.resolvedUri),{sourceUri:M.URI.revive(S.sourceUri)},L)}}e.$Dmc=R}),define(ke[318],Se([1,0,6,2,3,13,25]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class w{static{this.a=0}constructor(S){this.c=new R.$Nm,this.d=new Map,this.b=S.getProxy(u.$SM.MainThreadUrls)}registerUriHandler(S,L){const C=S.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=w.a++;return this.c.add(C),this.d.set(m,L),this.b.$registerUriHandler(m,C,S.displayName||S.name),(0,M.$Sc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(S,L){const C=this.d.get(S);if(!C)return Promise.resolve(void 0);try{C.handleUri(N.URI.revive(L))}catch(m){(0,A.$1)(m)}return Promise.resolve(void 0)}async createAppUri(S){return N.URI.revive(await this.b.$createAppUri(S))}}e.$Emc=w}),define(ke[92],Se([1,0,4,3,15,24,2,246,284,113,6]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=e.$6kc=void 0,e.$7kc=m,e.$9kc=l,e.$0kc=g;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(s,r,t,d,a,h,o){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new u.$be,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new u.$be,this._onDidDispose=this.#h.event,this.#e=s,this.#t=r,this.#o=t,this.#n=d,this.#s=a,this.#r=h,this.#l=m(h),this.#d=y(h),this.#i=o}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#u=!0,(0,S.$_xb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===M.Schemas.https||s.scheme===M.Schemas.http){let r=s.toString();return r.endsWith("/")||(r+="/"),r+" "+S.$$xb}return S.$$xb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),A.$2n(this.#o,s)||this.#t.$setOptions(this.#e,g(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const r=(0,$.$qob)(s,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,r.message,...r.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const r=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,a,h,o,p,f)=>{const D=R.URI.from({scheme:o||"file",path:decodeURIComponent(p)}),b=(0,S.$_xb)(D,{isRemote:r,authority:t}).toString();return`${a}${b}${f}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,a,h,o,p,f)=>{const D=R.URI.from({scheme:o||"file",path:decodeURIComponent(p)}),b=(0,S.$_xb)(D,{isRemote:r,authority:t}).toString();return`${a}${b}${f}`})}}e.$6kc=C;function m(i){try{const s=(0,w.$Dp)((0,w.$Cp)(i.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function y(i){try{const s=(0,w.$Dp)((0,w.$Cp)(i.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class v extends N.$Uc{constructor(s,r,t,d,a){super(),this.c=r,this.f=t,this.g=d,this.h=a,this.b=new Map,this.a=s.getProxy(L.$SM.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,r,t){const d=this.j(s);if(d){const{message:a}=(0,$.$rob)(r,t.value);d._onMessageEmitter.fire(a)}}$onMissingCsp(s,r){this.g.warn(`${r} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,r,t){const d=new C(s,this.a,c(r),this.c,this.f,t,this.h);this.b.set(s,d);const a=d._onDidDispose(()=>{a.dispose(),this.deleteWebview(s)});return d}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$8kc=v;function l(i){return{id:i.identifier,location:i.extensionLocation}}function g(i,s,r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots||n(i,s)}}function c(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(s=>R.URI.from(s))}}function n(i,s){return[...(s?.getWorkspaceFolders()||[]).map(r=>r.uri),i.extensionLocation]}}),define(ke[150],Se([1,0,4,15,14,2,5,20,6]),function(le,e,u,N,M,A,R,w,$){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=e.$Gmc=void 0;let L=class{static{S=this}static{this.a={focused:!0,active:!0}}getState(){const m=this.d;return{get focused(){return m.focused},get active(){return m.active}}}constructor(m){this.c=new u.$be,this.onDidChangeWindowState=this.c.event,this.d=S.a,this.b=m.getProxy($.$SM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:v})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(m){this.onDidChangeWindowProperty("focused",m)}$onDidChangeWindowActive(m){this.onDidChangeWindowProperty("active",m)}onDidChangeWindowProperty(m,y){y!==this.d[m]&&(this.d={...this.d,[m]:y},this.c.fire(this.d))}openUri(m,y){let v;if(typeof m=="string"){v=m;try{m=A.URI.parse(m)}catch{return Promise.reject(`Invalid uri - '${m}'`)}}return(0,M.$4e)(m.scheme)?Promise.reject("Invalid scheme - cannot be empty"):m.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${m.scheme}'`):this.b.$openUri(m,v,y)}async asExternalUri(m,y){if((0,M.$4e)(m.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(m,y);return A.URI.from(v)}};e.$Gmc=L,e.$Gmc=L=S=Qe([Ve(0,w.$fP)],L),e.$Hmc=(0,R.$ri)("IExtHostWindow")}),define(ke[319],Se([1,0,311,28,20]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0;const A=1024*1024;let R=class extends u.$Kmc{constructor($,S){super($,S),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,S,L){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),S.apply(console,L),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,S){const L=process[$],C=L.write;let m="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(y,v,l)=>{if(!this.g){m+=y.toString(v);const g=m.length>A?m.length:m.lastIndexOf(`
`);g!==-1&&(console[S](m.slice(0,g)),m=m.slice(g+1))}C.call(L,y,v,l)}})}};e.$jnc=R,e.$jnc=R=Qe([Ve(0,M.$fP),Ve(1,N.$vP)],R)}),define(ke[320],Se([1,0,149,15,261,30]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;class R extends u.$Jmc{s($,S,L){return $.scheme===N.Schemas.file?new M.$sQ(L?.name||(0,A.$Ng)(),$.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,S):super.s($,S,L)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$vnc=R}),define(ke[321],Se([1,0,8,21,22,13,4,3,133,309,48]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$h_b=g,e.$i_b=c;function m(E,P){try{return JSON.stringify(E,P)}catch{return"null"}}const y="$$ref$$",v={[y]:-1};class l{constructor(P,I){this.jsonString=P,this.referencedBuffers=I}}function g(E,P=null,I=!1){const F=[];return{jsonString:(I?m:JSON.stringify)(E,(z,O)=>{if(typeof O>"u")return v;if(typeof O=="object"){if(O instanceof N.$Ce){const T=F.push(O)-1;return{[y]:T}}if(P)return P(z,O)}return O}),referencedBuffers:F}}function c(E,P,I){return JSON.parse(E,(F,j)=>{if(j){const z=j[y];if(typeof z=="number")return P[z];if(I&&j.$mid===1)return I.transformIncoming(j)}return j})}function n(E,P){return JSON.stringify(E,P)}function i(E){return E?(P,I)=>I&&I.$mid===1?E.transformOutgoing(I):I:null}var s;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(s||(e.RequestInitiator=s={}));var r;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(r||(e.ResponsiveState=r={}));const t=()=>{},d=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class h extends w.$Uc{static{C=d}static{this.a=3*1e3}constructor(P,I=null,F=null){super(),this[C]=!0,this.b=this.B(new R.$be),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=I,this.g=F,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,z=L.$lw.count;j<z;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new u.$Dh(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const I=this.w[P];delete this.w[P],I.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+h.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+h.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,$.$wn)(P,this.g):P}getProxy(P){const{nid:I,sid:F}=P;return this.s[I]||(this.s[I]=this.J(I,F)),this.s[I]}J(P,I){const F={get:(j,z)=>(typeof z=="string"&&!j[z]&&z.charCodeAt(0)===36&&(j[z]=(...O)=>this.U(P,z,O)),z===a?I:j[z])};return new Proxy(Object.create(null),F)}set(P,I){return this.m[P.nid]=I,I}assertRegistered(P){for(let I=0,F=P.length;I<F;I++){const j=P[I];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(P){if(this.j)return;const I=P.byteLength,F=p.read(P,0),j=F.readUInt8(),z=F.readUInt32();switch(j){case 1:case 2:{let{rpcId:O,method:T,args:B}=D.deserializeRequestJSONArgs(F);this.g&&(B=(0,$.$wn)(B,this.g)),this.M(I,z,O,T,B,j===2);break}case 3:case 4:{let{rpcId:O,method:T,args:B}=D.deserializeRequestMixedArgs(F);this.g&&(B=(0,$.$wn)(B,this.g)),this.M(I,z,O,T,B,j===4);break}case 5:{this.f?.logIncoming(I,z,0,"ack"),this.G(z);break}case 6:{this.N(I,z);break}case 7:{this.O(I,z,void 0);break}case 9:{let O=D.deserializeReplyOKJSON(F);this.g&&(O=(0,$.$wn)(O,this.g)),this.O(I,z,O);break}case 10:{const O=D.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(I,z,O);break}case 8:{const O=D.deserializeReplyOKVSBuffer(F);this.O(I,z,O);break}case 11:{let O=D.deserializeReplyErrError(F);this.g&&(O=(0,$.$wn)(O,this.g)),this.P(I,z,O);break}case 12:{this.P(I,z,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,I,F,j,z,O){this.f?.logIncoming(P,I,1,`receiveRequest ${(0,L.$nw)(F)}.${j}(`,z);const T=String(I);let B,W;if(O){const Z=new M.$me;z.push(Z.token),B=this.Q(F,j,z),W=()=>Z.cancel()}else B=this.Q(F,j,z),W=t;this.u[T]=W;const X=D.serializeAcknowledged(I);this.f?.logOutgoing(X.byteLength,I,1,"ack"),this.c.send(X),B.then(Z=>{delete this.u[T];const Y=D.serializeReplyOK(I,Z,this.h);this.f?.logOutgoing(Y.byteLength,I,1,"reply:",Z),this.c.send(Y)},Z=>{delete this.u[T];const Y=D.serializeReplyErr(I,Z);this.f?.logOutgoing(Y.byteLength,I,1,"replyErr:",Z),this.c.send(Y)})}N(P,I){this.f?.logIncoming(P,I,1,"receiveCancel");const F=String(I);this.u[F]?.()}O(P,I,F){this.f?.logIncoming(P,I,0,"receiveReply:",F);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j],z.resolveOk(F)}P(P,I,F){this.f?.logIncoming(P,I,0,"receiveReplyErr:",F);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j];let O;F&&(F.$isError?(O=new Error,O.name=F.name,O.message=F.message,O.stack=F.stack):O=F),z.resolveErr(O)}Q(P,I,F){try{return Promise.resolve(this.S(P,I,F))}catch(j){return Promise.reject(j)}}S(P,I,F){const j=this.m[P];if(!j)throw new Error("Unknown actor "+(0,L.$nw)(P));const z=j[I];if(typeof z!="function")throw new Error("Unknown method "+I+" on actor "+(0,L.$nw)(P));return z.apply(j,F)}U(P,I,F){if(this.j)return new S.$g_b;let j=null;if(F.length>0&&M.CancellationToken.isCancellationToken(F[F.length-1])&&(j=F.pop()),j&&j.isCancellationRequested)return Promise.reject(A.$6());const z=D.serializeRequestArguments(F,this.h),O=++this.t,T=String(O),B=new S.$f_b,W=new w.$Tc;j&&W.add(j.onCancellationRequested(()=>{const Z=D.serializeCancel(O);this.f?.logOutgoing(Z.byteLength,O,0,"cancel"),this.c.send(D.serializeCancel(O))})),this.w[T]=new o(B,W),this.F(O);const X=D.serializeRequest(O,P,I,z,!!j);return this.f?.logOutgoing(X.byteLength,O,0,`request: ${(0,L.$nw)(P)}.${I}(`,F),this.c.send(X),B}}e.$j_b=h;class o{constructor(P,I){this.a=P,this.b=I}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class p{static alloc(P,I,F){const j=new p(N.$Ce.alloc(F+1+4),0);return j.writeUInt8(P),j.writeUInt32(I),j}static read(P,I){return new p(P,I)}get buffer(){return this.a}constructor(P,I){this.a=P,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+P).toString();return this.b+=P,F}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+P).toString();return this.b+=P,F}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+P);return this.b+=P,I}static sizeMixedArray(P){let I=0;I+=1;for(let F=0,j=P.length;F<j;F++){const z=P[F];switch(I+=1,z.type){case 1:I+=this.sizeLongString(z.value);break;case 2:I+=this.sizeVSBuffer(z.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(z.value);for(let O=0;O<z.buffers.length;++O)I+=this.sizeVSBuffer(z.buffers[O]);break;case 4:break}}return I}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let I=0,F=P.length;I<F;I++){const j=P[I];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let z=0;z<j.buffers.length;++z)this.writeBuffer(j.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const I=new Array(P);for(let F=0;F<P;F++)switch(this.readUInt8()){case 1:I[F]=this.readLongString();break;case 2:I[F]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),O=this.readLongString(),T=[];for(let B=0;B<z;++B)T.push(this.readVSBuffer());I[F]=new L.$ow(c(O,T,null));break}case 4:I[F]=void 0;break}return I}}var f;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(f||(f={}));class D{static a(P){for(let I=0,F=P.length;I<F;I++)if(P[I]instanceof N.$Ce||P[I]instanceof L.$ow||typeof P[I]>"u")return!0;return!1}static serializeRequestArguments(P,I){if(this.a(P)){const F=[];for(let j=0,z=P.length;j<z;j++){const O=P[j];if(O instanceof N.$Ce)F[j]={type:2,value:O};else if(typeof O>"u")F[j]={type:4};else if(O instanceof L.$ow){const{jsonString:T,referencedBuffers:B}=g(O.value,I);F[j]={type:3,value:N.$Ce.fromString(T),buffers:B}}else F[j]={type:1,value:N.$Ce.fromString(n(O,I))}}return{type:1,args:F}}return{type:0,args:n(P,I)}}static serializeRequest(P,I,F,j,z){switch(j.type){case 0:return this.b(P,I,F,j.args,z);case 1:return this.c(P,I,F,j.args,z)}}static b(P,I,F,j,z){const O=N.$Ce.fromString(F),T=N.$Ce.fromString(j);let B=0;B+=p.sizeUInt8(),B+=p.sizeShortString(O),B+=p.sizeLongString(T);const W=p.alloc(z?2:1,P,B);return W.writeUInt8(I),W.writeShortString(O),W.writeLongString(T),W.buffer}static deserializeRequestJSONArgs(P){const I=P.readUInt8(),F=P.readShortString(),j=P.readLongString();return{rpcId:I,method:F,args:JSON.parse(j)}}static c(P,I,F,j,z){const O=N.$Ce.fromString(F);let T=0;T+=p.sizeUInt8(),T+=p.sizeShortString(O),T+=p.sizeMixedArray(j);const B=p.alloc(z?4:3,P,T);return B.writeUInt8(I),B.writeShortString(O),B.writeMixedArray(j),B.buffer}static deserializeRequestMixedArgs(P){const I=P.readUInt8(),F=P.readShortString(),j=P.readMixedArray(),z=new Array(j.length);for(let O=0,T=j.length;O<T;O++){const B=j[O];typeof B=="string"?z[O]=JSON.parse(B):z[O]=B}return{rpcId:I,method:F,args:z}}static serializeAcknowledged(P){return p.alloc(5,P,0).buffer}static serializeCancel(P){return p.alloc(6,P,0).buffer}static serializeReplyOK(P,I,F){if(typeof I>"u")return this.d(P);if(I instanceof N.$Ce)return this.e(P,I);if(I instanceof L.$ow){const{jsonString:j,referencedBuffers:z}=g(I.value,F,!0);return this.g(P,j,z)}else return this.f(P,m(I,F))}static d(P){return p.alloc(7,P,0).buffer}static e(P,I){let F=0;F+=p.sizeVSBuffer(I);const j=p.alloc(8,P,F);return j.writeVSBuffer(I),j.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,I){const F=N.$Ce.fromString(I);let j=0;j+=p.sizeLongString(F);const z=p.alloc(9,P,j);return z.writeLongString(F),z.buffer}static g(P,I,F){const j=N.$Ce.fromString(I);let z=0;z+=p.sizeUInt32,z+=p.sizeLongString(j);for(const T of F)z+=p.sizeVSBuffer(T);const O=p.alloc(10,P,z);O.writeUInt32(F.length),O.writeLongString(j);for(const T of F)O.writeBuffer(T);return O.buffer}static deserializeReplyOKJSON(P){const I=P.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(P,I){const F=P.readUInt32(),j=P.readLongString(),z=[];for(let O=0;O<F;++O)z.push(P.readVSBuffer());return new L.$ow(c(j,z,I))}static serializeReplyErr(P,I){const F=I?m(A.$3(I),null):void 0;if(typeof F!="string")return this.h(P);const j=N.$Ce.fromString(F);let z=0;z+=p.sizeLongString(j);const O=p.alloc(11,P,z);return O.writeLongString(j),O.buffer}static deserializeReplyErrError(P){const I=P.readLongString();return JSON.parse(I)}static h(P){return p.alloc(12,P,0).buffer}}var b;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var k;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(k||(k={}))}),define(ke[322],Se([1,0,21,27,15,84,5]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xK=e.$uK=void 0,e.$vK=L,e.$wK=C,e.$uK=(0,R.$ri)("notebookDocumentService");const w=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${w.join("")}]+`),S=7;function L(y){if(y.scheme!==M.Schemas.vscodeNotebookCell)return;const v=y.fragment.indexOf("s");if(v<0)return;const l=parseInt(y.fragment.substring(0,v).replace($,""),S),g=(0,u.$Ve)(y.fragment.substring(v+1)).toString();if(!isNaN(l))return{handle:l,notebook:y.with({scheme:g,fragment:null})}}function C(y,v){const l=v.toString(S),c=`${l.length<w.length?w[l.length-1]:"z"}${l}s${(0,u.$We)(u.$Ce.fromString(y.scheme),!0,!0)}`;return y.with({scheme:M.Schemas.vscodeNotebookCell,fragment:c})}class m{constructor(){this.a=new N.$Bc}getNotebook(v){if(v.scheme===M.Schemas.vscodeNotebookCell){const l=L(v);if(l){const g=this.a.get(l.notebook);if(g)return g}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$xK=m,(0,A.$rs)(e.$uK,m,1)}),define(ke[119],Se([1,0,21,35,39,101,15,17,11,37,322]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.$OK=e.CellStatusbarAlignment=e.$NK=e.NotebookEditorPriority=e.$KK=e.$JK=e.$HK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$GK=e.$FK=e.$EK=e.$DK=e.CellKind=e.$CK=e.$BK=e.$AK=void 0,e.$IK=d,e.$LK=h,e.$MK=o,e.$PK=D,e.$QK=k,e.$AK="workbench.editor.notebook",e.$BK="workbench.editor.notebookTextDiffEditor",e.$CK="workbench.editor.interactive";var C;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(C||(e.CellKind=C={})),e.$DK=["application/json","application/javascript","text/html","image/svg+xml",A.$Ks.latex,A.$Ks.markdown,"image/png","image/jpeg",A.$Ks.text],e.$EK=[A.$Ks.latex,A.$Ks.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$Ks.text],e.$FK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$GK="_notAvailable";var m;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(m||(e.NotebookRunState=m={}));var y;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(y||(e.NotebookCellExecutionState=y={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var l;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(l||(e.NotebookRendererMatch=l={}));var g;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var c;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var s;(function(B){B.scheme=R.Schemas.vscodeNotebookCell;function W(ge,ue){return(0,L.$wK)(ge,ue)}B.generate=W;function X(ge){return(0,L.$vK)(ge)}B.parse=X;function Z(ge,ue){return ge.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ue??""},${ge.scheme!==R.Schemas.file?ge.scheme:""}`})}B.generateCellOutputUri=Z;function Y(ge){if(ge.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ue=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ge.fragment);if(!ue)return;const ve=ue[1]&&ue[1]!==""?ue[1]:void 0,te=ue[2];return{outputId:ve,notebook:ge.with({scheme:te||R.Schemas.file,fragment:null})}}B.parseCellOutputUri=Y;function x(ge,ue,ve){return B.generate(ge,ue).with({scheme:ve})}B.generateCellPropertyUri=x;function ne(ge,ue){if(ge.scheme===ue)return B.parse(ge.with({scheme:B.scheme}))}B.parseCellPropertyUri=ne})(s||(e.CellUri=s={}));const r=B=>$.$i?B.replace(/\//g,"\\"):B;class t{constructor(W=[],X=e.$DK){this.e=X,this.d=[...new Set(W)].map(Z=>({pattern:Z,matches:N.$lk(r(Z))}))}sort(W){const X=new Map(M.Iterable.map(W,Y=>[Y,r(Y)]));let Z=[];for(const{matches:Y}of this.d)for(const[x,ne]of X)if(Y(ne)){Z.push(x),X.delete(x);break}return X.size&&(Z=Z.concat([...X.keys()].sort((Y,x)=>this.e.indexOf(Y)-this.e.indexOf(x)))),Z}prioritize(W,X){const Z=this.f(W);if(Z===-1){this.d.unshift({pattern:W,matches:N.$lk(r(W))});return}const Y=new Set(X.map(ne=>this.f(ne,Z)));Y.delete(-1);const x=Array.from(Y).sort();this.d.splice(Z+1,0,...x.map(ne=>this.d[ne]));for(let ne=x.length-1;ne>=0;ne--)this.d.splice(x[ne],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,X=this.d.length){const Z=r(W);for(let Y=0;Y<X;Y++)if(this.d[Y].matches(Z))return Y;return-1}}e.$HK=t;function d(B,W,X,Z=(Y,x)=>Y===x){const Y=[];function x(ue,ve,te){if(ve===0&&te.length===0)return;const U=Y[Y.length-1];U&&U.start+U.deleteCount===ue?(U.deleteCount+=ve,U.toInsert.push(...te)):Y.push({start:ue,deleteCount:ve,toInsert:te})}let ne=0,ge=0;for(;;){if(ne===B.length){x(ne,0,W.slice(ge));break}if(ge===W.length){x(ne,B.length-ne,[]);break}const ue=B[ne],ve=W[ge];if(Z(ue,ve)){ne+=1,ge+=1;continue}X(ve)?(x(ne,1,[]),ne+=1):(x(ne,0,[ve]),ge+=1)}return Y}e.$JK=new S.$Ij("notebookEditorCursorAtBoundary","none"),e.$KK=new S.$Ij("notebookEditorCursorAtLineBoundary","none");var a;(function(B){B.default="default",B.option="option"})(a||(e.NotebookEditorPriority=a={}));function h(B){const W=B;return!!((typeof W.include=="string"||N.$mk(W.include))&&(typeof W.exclude=="string"||N.$mk(W.exclude)))}function o(B,W,X){if(Array.isArray(B.viewType)&&B.viewType.indexOf(W)>=0||B.viewType===W)return!0;if(B.filenamePattern){const Z=h(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,Y=h(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(N.$kk(Z,(0,w.$oc)(X.fsPath).toLowerCase()))return!(Y&&N.$kk(Y,(0,w.$oc)(X.fsPath).toLowerCase()))}return!1}e.$NK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var p;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class f{static{this.d="notebook/"}static create(W){return`${f.d}${W}`}static parse(W){if(W.startsWith(f.d))return W.substring(f.d.length)}}e.$OK=f;function D(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const b=new TextDecoder;function k(B){const W=[];let X=!1;for(const ne of B)(W.length===0||X)&&(W.push(ne),X=!0);let Z=I(W);const Y=u.$Ce.concat(W.map(ne=>u.$Ce.wrap(ne))),x=T(Y);return Z=Z||x.byteLength!==Y.byteLength,{data:x,didCompression:Z}}e.$RK="\x1B[A";const E=e.$RK.split("").map(B=>B.charCodeAt(0)),P=10;function I(B){let W=!1;return B.forEach((X,Z)=>{if(Z===0||X.length<e.$RK.length)return;const Y=B[Z-1],x=X.subarray(0,e.$RK.length);if(x[0]===E[0]&&x[1]===E[1]&&x[2]===E[2]){const ne=Y.lastIndexOf(P);if(ne===-1)return;W=!0,B[Z-1]=Y.subarray(0,ne),B[Z]=X.subarray(e.$RK.length)}}),W}function F(B){let W=B;do B=W,W=B.replace(/[^\n]\x08/gm,"");while(W.length<B.length);return B}function j(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const W=B.match(/^(.*)\r+/m)[1];let X=B.match(/\r+(.*)$/m)[1];X=X+W.slice(X.length,W.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return B}const z=8,O=13;function T(B){return!B.buffer.includes(z)&&!B.buffer.includes(O)?B:u.$Ce.fromString(j(F(b.decode(B.buffer))))}}),define(ke[7],Se([1,0,19,13,80,27,101,14,18,2,30,25,32,66,119]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v){"use strict";var l,g,c,n,i,s,r,t,d,a,h,o,p,f,D,b,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$6O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$5O=e.$4O=e.$3O=e.$2O=e.ChatLocation=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$PO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$CO=e.$BO=e.$AO=e.$zO=e.$xO=e.$wO=e.$vO=e.$uO=e.TestRunProfileKind=e.TestResultState=e.$tO=e.$sO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$rO=e.NotebookVariablesRequestKind=e.$qO=e.$pO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$oO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.ColorThemeKind=e.$iO=e.$hO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$gO=e.$fO=e.DebugConsoleMode=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$_N=e.$$N=e.FileChangeType=e.$0N=e.NewSymbolNameTag=e.$9N=e.$8N=e.$7N=e.$6N=e.InlineCompletionTriggerKind=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$SN=e.ConfigurationTarget=e.$RN=e.$QN=e.$PN=e.$ON=e.DocumentPasteTriggerKind=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$HN=e.ViewBadge=e.ProgressLocation=e.$GN=e.$FN=e.TaskScope=e.ShellQuoting=e.$EN=e.$DN=e.$CN=e.TaskPanelKind=e.TaskRevealKind=e.$BN=e.TerminalLocation=e.$AN=e.$zN=e.$yN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$xN=e.$wN=e.$vN=e.$uN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$sN=e.$rN=e.$qN=e.$pN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$oN=e.$nN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.LanguageStatusSeverity=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.CodeActionTriggerKind=e.$bN=e.$aN=e.SymbolTag=e.SymbolKind=e.$_M=e.$$M=e.DocumentHighlightKind=e.$0M=e.$9M=e.$8M=e.$7M=e.DiagnosticSeverity=e.DiagnosticTag=e.$6M=e.$5M=e.FileEditType=e.$4M=e.$3M=e.$2M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$tN=ht,e.$TN=ee,e.$yO=Mt;function E(G){return Object.assign(G,{apply:function(...me){if(me.length===0)return Reflect.construct(G,[]);{const Oe=me.length===1?[]:me[1];return Reflect.construct(G,Oe,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(G,[]);{const[Oe,...xe]=me;return Reflect.construct(G,xe,Oe.constructor)}}})}var P;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var I;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let F=l=class{static from(...H){let me=H;return new l(function(){if(me){for(const Oe of me)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();me=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$UM=F,e.$UM=F=l=Qe([E],F);let j=g=class{static Min(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Oe=1;Oe<H.length;Oe++){const xe=H[Oe];xe.isBefore(me)&&(me=xe)}return me}static Max(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Oe=1;Oe<H.length;Oe++){const xe=H[Oe];xe.isAfter(me)&&(me=xe)}return me}static isPosition(H){if(!H)return!1;if(H instanceof g)return!0;const{line:me,character:Oe}=H;return typeof me=="number"&&typeof Oe=="number"}static of(H){if(H instanceof g)return H;if(this.isPosition(H))return new g(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,me){if(H<0)throw(0,N.$7)("line must be non-negative");if(me<0)throw(0,N.$7)("character must be non-negative");this.c=H,this.e=me}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,me=0){if(H===null||me===null)throw(0,N.$7)();let Oe;return typeof H>"u"?Oe=0:typeof H=="number"?Oe=H:(Oe=typeof H.lineDelta=="number"?H.lineDelta:0,me=typeof H.characterDelta=="number"?H.characterDelta:0),Oe===0&&me===0?this:new g(this.line+Oe,this.character+me)}with(H,me=this.character){if(H===null||me===null)throw(0,N.$7)();let Oe;return typeof H>"u"?Oe=this.line:typeof H=="number"?Oe=H:(Oe=typeof H.line=="number"?H.line:this.line,me=typeof H.character=="number"?H.character:this.character),Oe===this.line&&me===this.character?this:new g(Oe,me)}toJSON(){return{line:this.line,character:this.character}}};e.$VM=j,e.$VM=j=g=Qe([E],j);let z=c=class{static isRange(H){return H instanceof c?!0:H?j.isPosition(H.start)&&j.isPosition(H.end):!1}static of(H){if(H instanceof c)return H;if(this.isRange(H))return new c(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,me,Oe,xe){let rt,ft;if(typeof H=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof xe=="number"?(rt=new j(H,me),ft=new j(Oe,xe)):j.isPosition(H)&&j.isPosition(me)&&(rt=j.of(H),ft=j.of(me)),!rt||!ft)throw new Error("Invalid arguments");rt.isBefore(ft)?(this.c=rt,this.e=ft):(this.c=ft,this.e=rt)}contains(H){return c.isRange(H)?this.contains(H.start)&&this.contains(H.end):j.isPosition(H)?!(j.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const me=j.Max(H.start,this.c),Oe=j.Min(H.end,this.e);if(!me.isAfter(Oe))return new c(me,Oe)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const me=j.Min(H.start,this.c),Oe=j.Max(H.end,this.end);return new c(me,Oe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,me=this.end){if(H===null||me===null)throw(0,N.$7)();let Oe;return H?j.isPosition(H)?Oe=H:(Oe=H.start||this.start,me=H.end||this.end):Oe=this.start,Oe.isEqual(this.c)&&me.isEqual(this.end)?this:new c(Oe,me)}toJSON(){return[this.start,this.end]}};e.$WM=z,e.$WM=z=c=Qe([E],z);let O=n=class extends z{static isSelection(H){return H instanceof n?!0:H?z.isRange(H)&&j.isPosition(H.anchor)&&j.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,me,Oe,xe){let rt,ft;if(typeof H=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof xe=="number"?(rt=new j(H,me),ft=new j(Oe,xe)):j.isPosition(H)&&j.isPosition(me)&&(rt=j.of(H),ft=j.of(me)),!rt||!ft)throw new Error("Invalid arguments");super(rt,ft),this.f=rt,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$XM=O,e.$XM=O=n=Qe([E],O);const T=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,N.$7)("connectionToken")};class B{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me,Oe){if(typeof H!="string"||H.length===0)throw(0,N.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,N.$7)("port");typeof Oe<"u"&&T(Oe),this.host=H,this.port=Math.round(me),this.connectionToken=Oe}}e.$YM=B;class W{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me){this.makeConnection=H,this.connectionToken=me,typeof me<"u"&&T(me)}}e.$ZM=W;class X extends Error{static NotAvailable(H,me){return new X(H,y.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(H){return new X(H,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,me=y.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(H),this._message=H,this._code=me,this._detail=Oe,Object.setPrototypeOf(this,X.prototype)}}e.$1M=X;var Z;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var Y;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let x=i=class{static isTextEdit(H){return H instanceof i?!0:H?z.isRange(H)&&typeof H.newText=="string":!1}static replace(H,me){return new i(H,me)}static insert(H,me){return i.replace(new z(H,H),me)}static delete(H){return i.replace(H,"")}static setEndOfLine(H){const me=new i(new z(new j(0,0),new j(0,0)),"");return me.newEol=H,me}get range(){return this.c}set range(H){if(H&&!z.isRange(H))throw(0,N.$7)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,N.$7)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,N.$7)("newEol");this.f=H}constructor(H,me){this.c=H,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$2M=x,e.$2M=x=i=Qe([E],x);let ne=s=class{static isNotebookCellEdit(H){return H instanceof s?!0:H?at.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,me){return new s(H,me)}static insertCells(H,me){return new s(new at(H,H),me)}static deleteCells(H){return new s(H,[])}static updateCellMetadata(H,me){const Oe=new s(new at(H,H),[]);return Oe.newCellMetadata=me,Oe}static updateNotebookMetadata(H){const me=new s(new at(0,0),[]);return me.newNotebookMetadata=H,me}constructor(H,me){this.range=H,this.newCells=me}};e.$3M=ne,e.$3M=ne=s=Qe([E],ne);class ge{static isSnippetTextEdit(H){return H instanceof ge?!0:H?z.isRange(H.range)&&te.isSnippetString(H.snippet):!1}static replace(H,me){return new ge(H,me)}static insert(H,me){return ge.replace(new z(H,H),me)}constructor(H,me){this.range=H,this.snippet=me}}e.$4M=ge;var ue;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ue||(e.FileEditType=ue={}));let ve=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,me,Oe,xe){this.c.push({_type:1,from:H,to:me,options:Oe,metadata:xe})}createFile(H,me,Oe){this.c.push({_type:1,from:void 0,to:H,options:me,metadata:Oe})}deleteFile(H,me,Oe){this.c.push({_type:1,from:H,to:void 0,options:me,metadata:Oe})}e(H,me,Oe){this.c.push({_type:3,metadata:Oe,uri:H,edit:{editType:5,metadata:me},notebookMetadata:me})}f(H,me,Oe,xe){const rt=me.start,ft=me.end;(rt!==ft||Oe.length>0)&&this.c.push({_type:5,uri:H,index:rt,count:ft-rt,cells:Oe,metadata:xe})}g(H,me,Oe,xe){this.c.push({_type:3,metadata:xe,uri:H,edit:{editType:3,index:me,metadata:Oe}})}replace(H,me,Oe,xe){this.c.push({_type:2,uri:H,edit:new x(me,Oe),metadata:xe})}insert(H,me,Oe,xe){this.replace(H,new z(me,me),Oe,xe)}delete(H,me,Oe){this.replace(H,me,"",Oe)}has(H){return this.c.some(me=>me._type===2&&me.uri.toString()===H.toString())}set(H,me){if(me)for(const Oe of me){if(!Oe)continue;let xe,rt;Array.isArray(Oe)?(xe=Oe[0],rt=Oe[1]):xe=Oe,ne.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(H,xe.range.start,xe.newCellMetadata,rt):xe.newNotebookMetadata?this.e(H,xe.newNotebookMetadata,rt):this.f(H,xe.range,xe.newCells,rt):ge.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:H,range:xe.range,edit:xe.snippet,metadata:rt}):this.c.push({_type:2,uri:H,edit:xe,metadata:rt})}else{for(let Oe=0;Oe<this.c.length;Oe++){const xe=this.c[Oe];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===H.toString()&&(this.c[Oe]=void 0);break}}(0,u.$Ib)(this.c)}}get(H){const me=[];for(const Oe of this.c)Oe._type===2&&Oe.uri.toString()===H.toString()&&me.push(Oe.edit);return me}entries(){const H=new A.$Bc;for(const me of this.c)if(me._type===2){let Oe=H.get(me.uri);Oe||(Oe=[me.uri,[]],H.set(me.uri,Oe)),Oe[1].push(me.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$5M=ve,e.$5M=ve=Qe([E],ve);let te=r=class{static isSnippetString(H){return H instanceof r?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=r.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,me=this.e++){if(typeof H=="function"){const Oe=new r;Oe.e=this.e,H(Oe),this.e=Oe.e,H=Oe.value}else H=r.c(H);return this.value+="${",this.value+=me,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,me=this.e++){const Oe=H.map(xe=>xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(H,me){if(typeof me=="function"){const Oe=new r;Oe.e=this.e,me(Oe),this.e=Oe.e,me=Oe.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$6M=te,e.$6M=te=r=Qe([E],te);var U;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var _;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let be=t=class{static isLocation(H){return H instanceof t?!0:H?z.isRange(H.range)&&S.URI.isUri(H.uri):!1}constructor(H,me){if(this.uri=H,me)if(z.isRange(me))this.range=z.of(me);else if(j.isPosition(me))this.range=new z(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$7M=be,e.$7M=be=t=Qe([E],be);let Pe=class{static is(H){return H?typeof H.message=="string"&&H.location&&z.isRange(H.location.range)&&S.URI.isUri(H.location.uri):!1}constructor(H,me){this.location=H,this.message=me}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.location.range.isEqual(me.location.range)&&H.location.uri.toString()===me.location.uri.toString()}};e.$8M=Pe,e.$8M=Pe=Qe([E],Pe);let se=class{constructor(H,me,Oe=_.Error){if(!z.isRange(H))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=H,this.message=me,this.severity=Oe}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.severity===me.severity&&H.code===me.code&&H.severity===me.severity&&H.source===me.source&&H.range.isEqual(me.range)&&(0,u.$ub)(H.tags,me.tags)&&(0,u.$ub)(H.relatedInformation,me.relatedInformation,Pe.isEqual)}};e.$9M=se,e.$9M=se=Qe([E],se);let re=class{constructor(H,me){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=me}};e.$0M=re,e.$0M=re=Qe([E],re);var oe;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let K=class{constructor(H,me=oe.Text){this.range=H,this.kind=me}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$$M=K,e.$$M=K=Qe([E],K);let ie=class{constructor(H,me){this.uri=H,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$_M=ie,e.$_M=ie=Qe([E],ie);var $e;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})($e||(e.SymbolKind=$e={}));var we;(function(G){G[G.Deprecated=1]="Deprecated"})(we||(e.SymbolTag=we={}));let Le=d=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,me,Oe,xe,rt){this.name=H,this.kind=me,this.containerName=rt,typeof Oe=="string"&&(this.containerName=Oe),xe instanceof be?this.location=xe:Oe instanceof z&&(this.location=new be(xe,Oe)),d.validate(this)}toJSON(){return{name:this.name,kind:$e[this.kind],location:this.location,containerName:this.containerName}}};e.$aN=Le,e.$aN=Le=d=Qe([E],Le);let fe=a=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(a.validate)}constructor(H,me,Oe,xe,rt){this.name=H,this.detail=me,this.kind=Oe,this.range=xe,this.selectionRange=rt,this.children=[],a.validate(this)}};e.$bN=fe,e.$bN=fe=a=Qe([E],fe);var De;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let Ie=class{constructor(H,me){this.title=H,this.kind=me}};e.$cN=Ie,e.$cN=Ie=Qe([E],Ie);let Te=class{static{h=this}static{this.c="."}constructor(H){this.value=H}append(H){return new h(this.value?this.value+h.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+h.c)}};e.$dN=Te,e.$dN=Te=h=Qe([E],Te),Te.Empty=new Te(""),Te.QuickFix=Te.Empty.append("quickfix"),Te.Refactor=Te.Empty.append("refactor"),Te.RefactorExtract=Te.Refactor.append("extract"),Te.RefactorInline=Te.Refactor.append("inline"),Te.RefactorMove=Te.Refactor.append("move"),Te.RefactorRewrite=Te.Refactor.append("rewrite"),Te.Source=Te.Empty.append("source"),Te.SourceOrganizeImports=Te.Source.append("organizeImports"),Te.SourceFixAll=Te.Source.append("fixAll"),Te.Notebook=Te.Empty.append("notebook");let V=class{constructor(H,me){if(this.range=H,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$eN=V,e.$eN=V=Qe([E],V);class q{constructor(H,me,Oe,xe,rt,ft){this.kind=H,this.name=me,this.detail=Oe,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$fN=q;class Q{constructor(H,me){this.fromRanges=me,this.from=H}}e.$gN=Q;class J{constructor(H,me){this.fromRanges=me,this.to=H}}e.$hN=J;var he;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(he||(e.LanguageStatusSeverity=he={}));let pe=class{constructor(H,me){this.range=H,this.command=me}get isResolved(){return!!this.command}};e.$iN=pe,e.$iN=pe=Qe([E],pe);let ze=o=class{#e;static isMarkdownString(H){return H instanceof o?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,me=!1){this.#e=new M.$Ok(H,{supportThemeIcons:me})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,me){return this.#e.appendCodeblock(me??"",H),this}};e.$jN=ze,e.$jN=ze=o=Qe([E],ze);let qe=class{constructor(H,me){this.label=H,this.documentation=me}};e.$kN=qe,e.$kN=qe=Qe([E],qe);let Ye=class{constructor(H,me){this.label=H,this.documentation=me,this.parameters=[]}};e.$lN=Ye,e.$lN=Ye=Qe([E],Ye);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$mN=it,e.$mN=it=Qe([E],it);var ot;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var nt;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(nt||(e.InlayHintKind=nt={}));let st=class{constructor(H){this.value=H}};e.$nN=st,e.$nN=st=Qe([E],st);let Ce=class{constructor(H,me,Oe){this.position=H,this.label=me,this.kind=Oe}};e.$oN=Ce,e.$oN=Ce=Qe([E],Ce);var Be;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Ge;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ge||(e.CompletionItemKind=Ge={}));var Ne;(function(G){G[G.Deprecated=1]="Deprecated"})(Ne||(e.CompletionItemTag=Ne={}));let Xe=class{constructor(H,me){this.label=H,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$pN=Xe,e.$pN=Xe=Qe([E],Xe);let ae=class{constructor(H=[],me=!1){this.items=H,this.isIncomplete=me}};e.$qN=ae,e.$qN=ae=Qe([E],ae);let ce=class{constructor(H,me,Oe){this.insertText=H,this.range=me,this.command=Oe}};e.$rN=ce,e.$rN=ce=Qe([E],ce);let Ae=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$sN=Ae,e.$sN=Ae=Qe([E],Ae);var Ke;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(Ke||(e.PartialAcceptTriggerKind=Ke={}));var Re;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Re||(e.ViewColumn=Re={}));var tt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(tt||(e.StatusBarAlignment=tt={}));function ht(G,H){return`${C.$Mm.toKey(G)}.${H}`}var wt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var Nt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Nt||(e.TextDocumentSaveReason=Nt={}));var At;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var xt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(xt||(e.TextEditorSelectionChangeKind=xt={}));var _t;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Pt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Pt||(e.DecorationRangeBehavior=Pt={})),function(G){function H(me){switch(me){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(xt||(e.TextEditorSelectionChangeKind=xt={}));var qt;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(qt||(e.SyntaxTokenType=qt={})),function(G){function H(me){switch(me){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=H}(qt||(e.SyntaxTokenType=qt={}));let Xt=class{constructor(H,me){if(me&&!S.URI.isUri(me))throw(0,N.$7)("target");if(!z.isRange(H)||H.isEmpty)throw(0,N.$7)("range");this.range=H,this.target=me}};e.$uN=Xt,e.$uN=Xt=Qe([E],Xt);let et=class{constructor(H,me,Oe,xe){this.red=H,this.green=me,this.blue=Oe,this.alpha=xe}};e.$vN=et,e.$vN=et=Qe([E],et);let si=class{constructor(H,me){if(me&&!(me instanceof et))throw(0,N.$7)("color");if(!z.isRange(H)||H.isEmpty)throw(0,N.$7)("range");this.range=H,this.color=me}};e.$wN=si,e.$wN=si=Qe([E],si);let Yt=class{constructor(H){if(!H||typeof H!="string")throw(0,N.$7)("label");this.label=H}};e.$xN=Yt,e.$xN=Yt=Qe([E],Yt);var dt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(dt||(e.ColorFormat=dt={}));var vt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(vt||(e.SourceControlInputBoxValidationType=vt={}));var ti;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));var Zt;(function(G){G[G.Low=0]="Low",G[G.Medium=1]="Medium",G[G.High=2]="High"})(Zt||(e.TerminalShellExecutionCommandLineConfidence=Zt={}));class zt{constructor(H,me,Oe){if(this.startIndex=H,this.length=me,this.tooltip=Oe,typeof H!="number"||H<0)throw(0,N.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,N.$7)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,N.$7)("tooltip")}}e.$yN=zt;class gt{constructor(H){this.uri=H}}e.$zN=gt;class Ut{constructor(H){this.terminalCommand=H}}e.$AN=Ut;var Wt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Wt||(e.TerminalLocation=Wt={}));class Ht{constructor(H){if(this.options=H,typeof H!="object")throw(0,N.$7)("options")}}e.$BN=Ht;var Ze;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Ze||(e.TaskRevealKind=Ze={}));var ui;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Gt=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(H){switch(H){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(H,me){if(this.label=me,typeof H!="string"||typeof me!="string")throw(0,N.$7)("name");this.c=H}get id(){return this.c}};e.$CN=Gt,e.$CN=Gt=p=Qe([E],Gt);function Bt(G){let H="";for(let me=0;me<G.length;me++)H+=G[me].replace(/,/g,",,")+",";return H}let mt=class{constructor(H,me,Oe){if(typeof H!="string")throw(0,N.$7)("process");this.e=[],this.c=H,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Oe):this.f=me)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,N.$7)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const me of this.e)H.push(me);return Bt(H)}};e.$DN=mt,e.$DN=mt=Qe([E],mt);let Tt=class{constructor(H,me,Oe){if(this.f=[],Array.isArray(me)){if(!H)throw(0,N.$7)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,N.$7)("command");this.e=H,this.f=me,this.g=Oe}else{if(typeof H!="string")throw(0,N.$7)("commandLine");this.c=H,this.g=me}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,N.$7)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,N.$7)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)H.push(typeof me=="string"?me:me.value);return Bt(H)}};e.$EN=Tt,e.$EN=Tt=Qe([E],Tt);var Rt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Rt||(e.ShellQuoting=Rt={}));var Ft;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Ft||(e.TaskScope=Ft={}));class ii{constructor(H){this.c=H}computeId(){return"customExecution"+(0,L.$Ng)()}set callback(H){this.c=H}get callback(){return this.c}}e.$FN=ii;let Kt=class{static{f=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,me,Oe,xe,rt,ft){this.k=!1,this.l=this.definition=H;let $t;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Oe,this.execution=xe,$t=rt,this.k=!0):me===Ft.Global||me===Ft.Workspace?(this.target=me,this.o=this.name=Oe,this.w=this.source=xe,this.execution=rt,$t=ft):(this.target=me,this.o=this.name=Oe,this.w=this.source=xe,this.execution=rt,$t=ft),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof mt?this.l={type:f.e,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:f.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:f.c,id:this.q.computeId()}:this.l={type:f.g,id:(0,L.$Ng)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,N.$7)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const me=this.l.type;(f.g===me||f.e===me||f.f===me||f.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$GN=Kt,e.$GN=Kt=f=Qe([E],Kt);var ni;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var Ot;(function(G){function H(me){const Oe=me;return(0,$.$9f)(Oe.value)?Oe.tooltip&&!(0,$.$5f)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}G.isViewBadge=H})(Ot||(e.ViewBadge=Ot={}));let Lt=D=class{static isTreeItem(H,me){const Oe=H;if(Oe.checkboxState!==void 0){const xe=(0,$.$9f)(Oe.checkboxState)?Oe.checkboxState:(0,$.$7f)(Oe.checkboxState)&&(0,$.$9f)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,rt=!(0,$.$9f)(Oe.checkboxState)&&(0,$.$7f)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(xe===void 0||xe!==St.Checked&&xe!==St.Unchecked||rt!==void 0&&!(0,$.$5f)(rt))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(H instanceof D)return!0;if(Oe.label!==void 0&&!(0,$.$5f)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,$.$5f)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,$.$5f)(Oe.iconPath)&&!S.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,$.$5f)(Oe.iconPath.id))){const xe=Oe.iconPath;if(!xe||!(0,$.$5f)(xe.light)&&!S.URI.isUri(xe.light)&&!(0,$.$5f)(xe.dark)&&!S.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,$.$5f)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!S.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,$.$5f)(Oe.tooltip)&&!(Oe.tooltip instanceof ze)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<It.None&&Oe.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,$.$5f)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(H,me=It.None){this.collapsibleState=me,S.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$HN=Lt,e.$HN=Lt=D=Qe([E],Lt);var It;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var St;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$IN=bt,e.$IN=bt=Qe([E],bt);class Ct extends bt{}e.$JN=Ct;class li extends Ct{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$KN=li;class Dt{constructor(H,me,Oe,xe){this.name=H,this.uri=me,this._itemId=Oe,this.c=xe}data(){return this.c()}}e.$LN=Dt;let hi=class{#e=new Map;constructor(H){for(const[me,Oe]of H??[]){const xe=this.#e.get(this.#t(me));xe?xe.push(Oe):this.#e.set(this.#t(me),[Oe])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,me){this.#e.set(this.#t(H),[me])}forEach(H,me){for(const[Oe,xe]of this.#e)for(const rt of xe)H.call(me,rt,Oe,this)}*[Symbol.iterator](){for(const[H,me]of this.#e)for(const Oe of me)yield[H,Oe]}#t(H){return H.toLowerCase()}};e.$MN=hi,e.$MN=hi=Qe([E],hi);let Qt=class{constructor(H,me,Oe){this.insertText=H,this.title=me,this.kind=Oe}};e.$NN=Qt,e.$NN=Qt=Qe([E],Qt);var wi;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class ei{static{this.c="."}constructor(H){this.value=H}append(...H){return new ei((this.value?[this.value,...H]:H).join(ei.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+ei.c)}}e.$ON=ei,ei.Empty=new ei("");class vi{constructor(H,me,Oe){this.title=me,this.insertText=H,this.kind=Oe}}e.$PN=vi;let Et=class{constructor(H,me){this.id=H,this.color=me}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$QN=Et,e.$QN=Et=Qe([E],Et),Et.File=new Et("file"),Et.Folder=new Et("folder");let $i=class{constructor(H){this.id=H}};e.$RN=$i,e.$RN=$i=Qe([E],$i);var Me;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Me||(e.ConfigurationTarget=Me={}));let je=class{get base(){return this.c}set base(H){this.c=H,this.e=S.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,me){if(typeof H!="string"&&(!H||!S.URI.isUri(H)&&!S.URI.isUri(H.uri)))throw(0,N.$7)("base");if(typeof me!="string")throw(0,N.$7)("pattern");typeof H=="string"?this.baseUri=S.URI.file(H):S.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$SN=je,e.$SN=je=Qe([E],je);const Ee=new WeakMap;function ee(G,H){Ee.set(G,H)}let Fe=class{constructor(H,me,Oe,xe,rt){this.enabled=typeof H=="boolean"?H:!0,typeof me=="string"&&(this.condition=me),typeof Oe=="string"&&(this.hitCondition=Oe),typeof xe=="string"&&(this.logMessage=xe),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=Ee.get(this)??(0,L.$Ng)()),this.c}};e.$UN=Fe,e.$UN=Fe=Qe([E],Fe);let He=class extends Fe{constructor(H,me,Oe,xe,rt,ft){if(super(me,Oe,xe,rt,ft),H===null)throw(0,N.$7)("location");this.location=H}};e.$VN=He,e.$VN=He=Qe([E],He);let _e=class extends Fe{constructor(H,me,Oe,xe,rt,ft){super(me,Oe,xe,rt,ft),this.functionName=H}};e.$WN=_e,e.$WN=_e=Qe([E],_e);let Je=class extends Fe{constructor(H,me,Oe,xe,rt,ft,$t,Jt){if(super(xe,rt,ft,$t,Jt),!me)throw(0,N.$7)("dataId");this.label=H,this.dataId=me,this.canPersist=Oe}};e.$XN=Je,e.$XN=Je=Qe([E],Je);let lt=class{constructor(H,me,Oe){this.command=H,this.args=me||[],this.options=Oe}};e.$YN=lt,e.$YN=lt=Qe([E],lt);let kt=class{constructor(H,me){this.port=H,this.host=me}};e.$ZN=kt,e.$ZN=kt=Qe([E],kt);let jt=class{constructor(H){this.path=H}};e.$1N=jt,e.$1N=jt=Qe([E],jt);let Vt=class{constructor(H){this.implementation=H}};e.$2N=Vt,e.$2N=Vt=Qe([E],Vt);class ut{constructor(H,me,Oe){this.session=H,this.threadId=me,this.frameId=Oe}}e.$3N=ut;class ri{constructor(H,me){this.session=H,this.threadId=me}}e.$4N=ri;let di=class{constructor(H,me){this.range=H,this.expression=me}};e.$5N=di,e.$5N=di=Qe([E],di);var bi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(bi||(e.InlineCompletionTriggerKind=bi={}));let Di=class{constructor(H,me){this.range=H,this.text=me}};e.$6N=Di,e.$6N=Di=Qe([E],Di);let Ai=class{constructor(H,me,Oe=!0){this.range=H,this.variableName=me,this.caseSensitiveLookup=Oe}};e.$7N=Ai,e.$7N=Ai=Qe([E],Ai);let Ri=class{constructor(H,me){this.range=H,this.expression=me}};e.$8N=Ri,e.$8N=Ri=Qe([E],Ri);let Mi=class{constructor(H,me){this.frameId=H,this.stoppedLocation=me}};e.$9N=Mi,e.$9N=Mi=Qe([E],Mi);var Ni;(function(G){G[G.AIGenerated=1]="AIGenerated"})(Ni||(e.NewSymbolNameTag=Ni={}));class cn{constructor(H,me){this.newSymbolName=H,this.tags=me}}e.$0N=cn;var Oi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Ti=b=class extends Error{static FileExists(H){return new b(H,m.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(H){return new b(H,m.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(H){return new b(H,m.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(H){return new b(H,m.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(H){return new b(H,m.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(H){return new b(H,m.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(H,me=m.FileSystemProviderErrorCode.Unknown,Oe){super(S.URI.isUri(H)?H.toString(!0):H),this.code=Oe?.name??"Unknown",(0,m.$al)(this,me),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.$$N=Ti,e.$$N=Ti=b=Qe([E],Ti);let yi=class{constructor(H,me,Oe){this.start=H,this.end=me,this.kind=Oe}};e.$_N=yi,e.$_N=yi=Qe([E],yi);var Ci;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Ci||(e.FoldingRangeKind=Ci={}));var Gi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Gi||(e.CommentThreadCollapsibleState=Gi={}));var Ki;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var pi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(pi||(e.CommentState=pi={}));var Qi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Qi||(e.CommentThreadState=Qi={}));var Ji;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(Ji||(e.CommentThreadApplicability=Ji={}));class un{constructor(H,me=[]){this.tokenTypes=H,this.tokenModifiers=me}}e.$aO=un;function Fi(G){return typeof G>"u"||(0,$.$6f)(G)}class ji{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let me=0,Oe=H.tokenTypes.length;me<Oe;me++)this.k.set(H.tokenTypes[me],me);for(let me=0,Oe=H.tokenModifiers.length;me<Oe;me++)this.l.set(H.tokenModifiers[me],me)}}push(H,me,Oe,xe,rt){if(typeof H=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof xe=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(H,me,Oe,xe,rt);if(z.isRange(H)&&typeof me=="string"&&Fi(Oe))return this.o(H,me,Oe);throw(0,N.$7)()}o(H,me,Oe){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const xe=H.start.line,rt=H.start.character,ft=H.end.character-H.start.character,$t=this.k.get(me);let Jt=0;if(Oe)for(const ci of Oe){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ci);Jt|=1<<fi>>>0}this.q(xe,rt,ft,$t,Jt)}q(H,me,Oe,xe,rt){if(this.f&&(H<this.c||H===this.c&&me<this.e)){this.f=!1;const Jt=this.g.length/5|0;let ci=0,fi=0;for(let gi=0;gi<Jt;gi++){let mi=this.g[5*gi],qi=this.g[5*gi+1];mi===0?(mi=ci,qi+=fi):mi+=ci,this.g[5*gi]=mi,this.g[5*gi+1]=qi,ci=mi,fi=qi}}let ft=H,$t=me;this.f&&this.j>0&&(ft-=this.c,ft===0&&($t-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=$t,this.g[this.j++]=Oe,this.g[this.j++]=xe,this.g[this.j++]=rt,this.c=H,this.e=me}static r(H){const me=[],Oe=H.length/5|0;for(let $t=0;$t<Oe;$t++)me[$t]=$t;me.sort(($t,Jt)=>{const ci=H[5*$t],fi=H[5*Jt];if(ci===fi){const gi=H[5*$t+1],mi=H[5*Jt+1];return gi-mi}return ci-fi});const xe=new Uint32Array(H.length);let rt=0,ft=0;for(let $t=0;$t<Oe;$t++){const Jt=5*me[$t],ci=H[Jt+0],fi=H[Jt+1],gi=H[Jt+2],mi=H[Jt+3],qi=H[Jt+4],Rn=ci-rt,ur=Rn===0?fi-ft:fi,Hi=5*$t;xe[Hi+0]=Rn,xe[Hi+1]=ur,xe[Hi+2]=gi,xe[Hi+3]=mi,xe[Hi+4]=qi,rt=ci,ft=fi}return xe}build(H){return this.f?new Pi(new Uint32Array(this.g),H):new Pi(ji.r(this.g),H)}}e.$bO=ji;class Pi{constructor(H,me){this.resultId=me,this.data=H}}e.$cO=Pi;class ln{constructor(H,me,Oe){this.start=H,this.deleteCount=me,this.data=Oe}}e.$dO=ln;class Xi{constructor(H,me){this.resultId=me,this.edits=H}}e.$eO=Xi;var Yi;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));class hn{constructor(H){this.name=H}}e.$fO=hn;let zi=class{static{this.Back={iconPath:new Et("arrow-left")}}constructor(){}};e.$gO=zi,e.$gO=zi=Qe([E],zi);var Zi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Zi||(e.QuickPickItemKind=Zi={}));var Ii;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Ii||(e.InputBoxValidationSeverity=Ii={}));var Bi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Bi||(e.ExtensionKind=Bi={}));class We{static validate(H){if(typeof H.badge=="string"){let me=(0,w.$Ef)(H.badge,0);if(me<H.badge.length&&(me+=(0,w.$Ef)(H.badge,me)),H.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Et.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,me,Oe){this.badge=H,this.tooltip=me,this.color=Oe}}e.$hO=We;let oi=class{constructor(H){this.kind=H}};e.$iO=oi,e.$iO=oi=Qe([E],oi);var Ui;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Ui||(e.ColorThemeKind=Ui={}));class at{static isNotebookRange(H){return H instanceof at?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,me){if(H<0)throw(0,N.$7)("start must be positive");if(me<0)throw(0,N.$7)("end must be positive");H<=me?(this.c=H,this.e=me):(this.c=me,this.e=H)}with(H){let me=this.c,Oe=this.e;return H.start!==void 0&&(me=H.start),H.end!==void 0&&(Oe=H.end),me===this.c&&Oe===this.e?this:new at(me,Oe)}}e.$jO=at;class pt{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(me=>pt.isNotebookCellData(me))}static isNotebookCellData(H){return!0}constructor(H,me,Oe,xe,rt,ft,$t){this.kind=H,this.value=me,this.languageId=Oe,this.mime=xe,this.outputs=rt??[],this.metadata=ft,this.executionSummary=$t,pt.validate(this)}}e.$kO=pt;class dn{constructor(H){this.cells=H}}e.$lO=dn;class ai{static isNotebookCellOutputItem(H){return H instanceof ai?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const me={name:H.name,message:H.message,stack:H.stack};return ai.json(me,"application/vnd.code.notebook.error")}static stdout(H){return ai.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return ai.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,me="application/octet-stream"){return new ai(H,me)}static#e=new TextEncoder;static text(H,me=R.$Ks.text){const Oe=ai.#e.encode(String(H));return new ai(Oe,me)}static json(H,me="text/x-json"){const Oe=JSON.stringify(H,void 0,"	");return ai.text(Oe,me)}constructor(H,me){this.data=H,this.mime=me;const Oe=(0,R.$Os)(me,!0);if(!Oe)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.$mO=ai;class Ei{static isNotebookCellOutput(H){return H instanceof Ei?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,me=!1){const Oe=new Set,xe=new Set;for(let rt=0;rt<H.length;rt++){const ft=H[rt],$t=(0,R.$Os)(ft.mime);if(!Oe.has($t)||(0,v.$PK)($t)){Oe.add($t);continue}xe.add(rt),me&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return xe.size===0?H:H.filter((rt,ft)=>!xe.has(ft))}constructor(H,me,Oe){this.items=Ei.ensureUniqueMimeTypes(H,!0),typeof me=="string"?(this.id=me,this.metadata=Oe):(this.id=(0,L.$Ng)(),this.metadata=me??Oe)}}e.$nO=Ei;var xi;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var ki;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(ki||(e.NotebookCellExecutionState=ki={}));var _i;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(H,me){this.text=H,this.alignment=me}}e.$oO=fn;var Wi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Wi||(e.NotebookControllerAffinity=Wi={}));var tn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(H,me=[]){this.uri=H,this.provides=(0,u.$3b)(me)}}e.$pO=gn;class mn{constructor(H){this.label=H}}e.$qO=mn;var nn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Vi=class{constructor(H,me){this.label=H,this.timestamp=me}};e.$rO=Vi,e.$rO=Vi=Qe([E],Vi);var rn;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(H,me){this.ranges=H,this.wordPattern=me}}e.$sO=$n;class bn{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$tO=bn;var an;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var de;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(de||(e.TestRunProfileKind=de={}));let ye=class{constructor(H=void 0,me=void 0,Oe=void 0,xe=!1){this.include=H,this.exclude=me,this.profile=Oe,this.continuous=xe}};e.$uO=ye,e.$uO=ye=Qe([E],ye);let Ue=k=class{static diff(H,me,Oe){const xe=new k(H);return xe.expectedOutput=me,xe.actualOutput=Oe,xe}constructor(H){this.message=H}};e.$vO=Ue,e.$vO=Ue=k=Qe([E],Ue);let ct=class{constructor(H){this.id=H}};e.$wO=ct,e.$wO=ct=Qe([E],ct);class yt{constructor(H,me){this.covered=H,this.total=me,Mt(this)}}e.$xO=yt;function Mt(G){if(G){if(G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`);if(G.total<0)throw new Error(`The number of covered items (${G.total}) cannot be negative`)}}class Si{static fromDetails(H,me){const Oe=new yt(0,0),xe=new yt(0,0),rt=new yt(0,0);for(const $t of me)if("branches"in $t){Oe.total+=1,Oe.covered+=$t.executed?1:0;for(const Jt of $t.branches)xe.total+=1,xe.covered+=Jt.executed?1:0}else rt.total+=1,rt.covered+=$t.executed?1:0;const ft=new Si(H,Oe,xe.total>0?xe:void 0,rt.total>0?rt:void 0);return ft.detailedCoverage=me,ft}constructor(H,me,Oe,xe){this.uri=H,this.statementCoverage=me,this.branchCoverage=Oe,this.declarationCoverage=xe}}e.$zO=Si;class Mn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Oe=[]){this.executed=H,this.location=me,this.branches=Oe}}e.$AO=Mn;class Nn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Oe){this.executed=H,this.location=me,this.label=Oe}}e.$BO=Nn;class On{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Oe){this.name=H,this.executed=me,this.location=Oe}}e.$CO=On;var pn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(pn||(e.ExternalUriOpenerPriority=pn={}));var wn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var vn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn||(e.PortAutoForwardAction=vn={}));class Tn{constructor(H,me,Oe,xe,rt,ft){this.kind=H,this.name=me,this.detail=Oe,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$DO=Tn;class Fn{constructor(H){this.uri=H}}e.$EO=Fn;class jn{constructor(H,me){this.original=H,this.modified=me}}e.$FO=jn;class zn{constructor(H,me,Oe,xe){this.base=H,this.input1=me,this.input2=Oe,this.result=xe}}e.$GO=zn;class Bn{constructor(H,me){this.uri=H,this.viewType=me}}e.$HO=Bn;class Un{constructor(H){this.viewType=H}}e.$IO=Un;class Wn{constructor(H,me){this.uri=H,this.notebookType=me}}e.$JO=Wn;class Vn{constructor(H,me,Oe){this.original=H,this.modified=me,this.notebookType=Oe}}e.$KO=Vn;class qn{constructor(){}}e.$LO=qn;class Hn{constructor(H,me){this.uri=H,this.inputBoxUri=me}}e.$MO=Hn;class Gn{constructor(){}}e.$NO=Gn;class Kn{constructor(H){this.textDiffs=H}}e.$OO=Kn;var yn;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var En;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(En||(e.ChatCopyKind=En={}));var kn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Qn{constructor(H,me){this.label=H,this.values=me}}e.$PO=Qn;var Sn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var Dn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(Dn||(e.ChatResultFeedbackKind=Dn={}));class Jn{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new ze(H):H}}e.$QO=Jn;class Xn{constructor(H,me){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new ze(H):H,this.vulnerabilities=me}}e.$RO=Xn;class Yn{constructor(H,me){this.participant=H,this.command=me}}e.$SO=Yn;class Zn{constructor(H,me){this.value=H,this.baseUri=me}}e.$TO=Zn;class xn{constructor(H,me){this.value=H,this.title=me}}e.$UO=xn;class _n{constructor(H){this.value=H}}e.$VO=_n;class er{constructor(H){this.value=H}}e.$WO=er;class tr{constructor(H){this.value=H}}e.$XO=tr;class ir{constructor(H,me){this.uri=H,this.edits=Array.isArray(me)?me:[me]}}e.$YO=ir;class nr{constructor(H,me,Oe,xe){this.prompt=H,this.command=me,this.variables=Oe,this.participant=xe}}e.$ZO=nr;class rr{constructor(H,me,Oe,xe){this.response=H,this.result=me,this.participant=Oe,this.command=xe}}e.$1O=rr;var Cn;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook",G[G.Editor=4]="Editor"})(Cn||(e.ChatLocation=Cn={}));class sr{constructor(H){this.content=H}}e.$2O=sr;class or{constructor(H,me){this.content=H,this.name=me}}e.$3O=or;class ar{constructor(H,me){this.content=H,this.name=me}}e.$4O=ar;class Li extends Error{static NotFound(H){return new Li(H,Li.NotFound.name)}static NoPermissions(H){return new Li(H,Li.NoPermissions.name)}constructor(H,me,Oe){super(H,{cause:Oe}),this.name="LanguageModelError",this.code=me??""}}e.$5O=Li;var Pn;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var In;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped",G[G.Error=5]="Error"})(In||(e.SpeechToTextStatus=In={}));var Ln;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Ln||(e.KeywordRecognitionStatus=Ln={}));class cr{constructor(H,me){this.text=H,this.range=me}}e.$6O=cr;var An;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(An||(e.InlineEditTriggerKind=An={}))}),define(ke[323],Se([1,0,6,7]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(u.$SM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,w,$){if(this.a.size===0)throw new Error("No related information providers registered");const S=this.a.get(R);if(!S)throw new Error("related information provider not found");return await S.provideRelatedInformation(w,$)??[]}getRelatedInformation(R,w,$){return this.c.$getAiRelatedInformation(w,$)}registerRelatedInformationProvider(R,w,$){const S=this.b;return this.b++,this.a.set(S,$),this.c.$registerAiRelatedInformationProvider(S,w),new N.$UM(()=>{this.c.$unregisterAiRelatedInformationProvider(S),this.a.delete(S)})}}e.$Akc=M}),define(ke[120],Se([1,0,4,6,7,25,145,5,20]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=e.$Lkc=void 0,e.$Lkc=(0,w.$ri)("IExtHostAuthentication");let S=class{constructor(m){this.b=new Map,this.c=new u.$be,this.onDidChangeSessions=this.c.event,this.d=new L,this.f=new L,this.a=m.getProxy(N.$SM.MainThreadAuthentication)}async getSession(m,y,v,l={}){const g=A.$Mm.toKey(m.identifier),c=[...v].sort().join(" ");return await this.d.getOrCreate(`${g} ${y} ${c}`,async()=>{await this.a.$ensureProvider(y);const n=m.displayName||m.name;return this.a.$getSession(y,v,g,n,l)})}async getSessions(m,y,v){const l=A.$Mm.toKey(m.identifier),g=[...v].sort().join(" ");return await this.f.getOrCreate(`${l} ${g}`,async()=>{await this.a.$ensureProvider(y);const c=m.displayName||m.name;return this.a.$getSessions(y,v,l,c)})}async removeSession(m,y){const v=this.b.get(m);return v?v.provider.removeSession(y):this.a.$removeSession(m,y)}registerAuthenticationProvider(m,y,v,l){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:y,provider:v,options:l??{supportsMultipleAccounts:!1}});const g=v.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(m,c));return this.a.$registerAuthenticationProvider(m,y,l?.supportsMultipleAccounts??!1),new M.$UM(()=>{g.dispose(),this.b.delete(m),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,y,v){const l=this.b.get(m);if(l)return Promise.resolve(l.provider.createSession(y,v));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,y){const v=this.b.get(m);if(v)return Promise.resolve(v.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,y){const v=this.b.get(m);if(v)return Promise.resolve(v.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,y){return m.startsWith(R.$UL)||this.c.fire({provider:{id:m,label:y}}),Promise.resolve()}};e.$Mkc=S,e.$Mkc=S=Qe([Ve(0,$.$fP)],S);class L{constructor(){this.a=new Map}getOrCreate(m,y){const v=this.a.get(m);if(v)return v;const l=y().finally(()=>this.a.delete(m));return this.a.set(m,l),l}}}),define(ke[151],Se([1,0,2,6,7,5,20,12,19,14,17,26]),function(le,e,u,N,M,A,R,w,$,S,L,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0;let y=class{static{m=this}static{this.c=0}static{this.d=250}constructor(l,g){this.h=g,this.f=new Map,this.g=l.getProxy(N.$SM.MainThreadDecorations)}registerFileDecorationProvider(l,g){const c=m.c++;this.f.set(c,{provider:l,extensionDescription:g}),this.g.$registerDecorationProvider(c,g.identifier.value);const n=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(c,null);return}const s=(0,$.$3b)(i);if(s.length<=m.d){this.g.$onDidChange(c,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,s.length);const r=s.map(a=>({uri:a,rank:(0,S.$0e)(a.path,"/")})),t=(0,$.$zb)(r,(a,h)=>a.rank-h.rank||(0,S.$nf)(a.uri.path,h.uri.path)),d=[];e:for(const a of t){let h;for(const o of a){const p=(0,L.$nc)(o.uri.path);if(h!==p&&(h=p,d.push(o.uri)>=m.d))break e}}this.g.$onDidChange(c,d)});return new M.$UM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(l,g,c){if(!this.f.has(l))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:s}=this.f.get(l);return await Promise.all(g.map(async r=>{try{const{uri:t,id:d}=r,a=await Promise.resolve(i.provideFileDecoration(u.URI.revive(t),c));if(!a)return;try{M.$hO.validate(a),a.badge&&typeof a.badge!="string"&&(0,C.$AG)(s,"codiconDecoration"),n[d]=[a.propagate,a.tooltip,a.badge,a.color]}catch(h){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${h}`)}}catch(t){this.h.error(t)}})),n}};e.$Llc=y,e.$Llc=y=m=Qe([Ve(0,R.$fP),Ve(1,w.$Xj)],y),e.$Mlc=(0,A.$ri)("IExtHostDecorations")}),define(ke[324],Se([1,0,13,2,7,6,15,22,14]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=void 0;class S{static{this.a=0}constructor(C,m,y){this.d=m,this.e=y,this.b=new Map,this.c=C.getProxy(A.$SM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const y=S.a++;this.b.set(y,m),this.c.$registerTextContentProvider(y,C);let v;if(typeof m.onDidChange=="function"){let l;v=m.onDidChange(async g=>{if(g.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;l&&await l;const c=this.$provideTextDocumentContent(y,g).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(g);if(!i)return;const s=(0,$.$hf)(n);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(g,n)}).catch(u.$1).finally(()=>{l===c&&(l=void 0)});l=c})}return new M.$UM(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(C,m){const y=this.b.get(C);return y?Promise.resolve(y.provideTextDocumentContent(N.URI.revive(m),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$Olc=S}),define(ke[152],Se([1,0,62,15,14,183,129,7,19]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jP=e.$iP=void 0,e.$hP=L;const S=new Map;function L(v,l){l?S.set(v,l):S.delete(v)}function C(v){return S.get(v)}class m extends A.$Sv{constructor(l,g,c,n,i,s,r){super(g,c,n,i),this.c=l,this.m=s,this.q=r,this.b=!1}dispose(){(0,u.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,$.$ub)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===N.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(g){return g?l.s(g):l.getText()},get eol(){return l.g===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(g){return l.t(g)},offsetAt(g){return l.u(g)},positionAt(g){return l.v(g)},validateRange(g){return l.w(g)},validatePosition(g){return l.x(g)},getWordRangeAtPosition(g,c){return l.y(g,c)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,u.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,u.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const g=this.w(l);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const c=this.g,n=g.start.line,i=g.end.line,s=[];s.push(this.f[n].substring(g.start.character));for(let r=n+1;r<i;r++)s.push(this.f[r]);return s.push(this.f[i].substring(0,g.end.character)),s.join(c)}t(l){let g;if(l instanceof w.$VM?g=l.line:typeof l=="number"&&(g=l),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new y(g,this.f[g],g===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const g=this.j.getIndexOf(l),c=this.f[g.index].length;return new w.$VM(g.index,Math.min(g.remainder,c))}w(l){if(!(l instanceof w.$WM))throw new Error("Invalid argument");const g=this.x(l.start),c=this.x(l.end);return g===l.start&&c===l.end?l:new w.$WM(g.line,g.character,c.line,c.character)}x(l){if(!(l instanceof w.$VM))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:g,character:c}=l,n=!1;if(g<0)g=0,c=0,n=!0;else if(g>=this.f.length)g=this.f.length-1,c=this.f[g].length,n=!0;else{const i=this.f[g].length;c<0?(c=0,n=!0):c>i&&(c=i,n=!0)}return n?new w.$VM(g,c):l}y(l,g){const c=this.x(l);if(!g)g=C(this.m);else if((0,M.$gf)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const n=(0,R.$3s)(c.character+1,(0,R.$1s)(g),this.f[c.line],0);if(n)return new w.$WM(c.line,n.startColumn-1,c.line,n.endColumn-1)}}e.$iP=m;class y{constructor(l,g,c){this.a=l,this.b=g,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new w.$WM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new w.$WM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$jP=y}),define(ke[325],Se([1,0,6,7]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(u.$SM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,w,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const S=this.a.get(R);if(!S)throw new Error("Embedding vector provider not found");const L=await S.provideEmbeddingVector(w,$);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(R,w,$){const S=this.b;return this.b++,this.a.set(S,$),this.c.$registerAiEmbeddingVectorProvider(w,S),new N.$UM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(S),this.a.delete(S)})}}e.$Qlc=M}),define(ke[69],Se([1,0,6,32,7,21,5,20,60,3,8,23,15]),function(le,e,u,N,M,A,R,w,$,S,L,C,m){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=e.$2kc=void 0;let v=y=class{constructor(g,c){this.b=new Map,this.c=new L.$Ah,this.a=g.getProxy(u.$SM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let s;const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),s=await r.impl.stat(i)):s=await n.a.$stat(i),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===N.FilePermission.Readonly?1:void 0}}catch(s){y.e(s)}},async readDirectory(i){try{const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),(await s.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(s){return y.e(s)}},async createDirectory(i){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,i)):await n.a.$mkdir(i)}catch(s){return y.e(s)}},async readFile(i){try{const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),(await s.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(s){return y.e(s)}},async writeFile(i,s){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(r.impl,r.extUri,r.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(r.impl.writeFile(i,s,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,A.$Ce.wrap(s))}catch(r){return y.e(r)}},async delete(i,s){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly&&!s?.useTrash?(await n.a.$ensureActivation(i.scheme),await r.impl.delete(i,{recursive:!1,...s})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(r){return y.e(r)}},async rename(i,s,r){try{return await n.a.$rename(i,s,{overwrite:!1,...r})}catch(t){return y.e(t)}},async copy(i,s,r){try{return await n.a.$copy(i,s,{overwrite:!1,...r})}catch(t){return y.e(t)}},isWritableFileSystem(i){const s=c.getCapabilities(i);if(typeof s=="number")return!(s&2048)}})}async d(g,c,n){const i=[];for(;!c.isEqual(n,c.dirname(n));)try{if(!((await g.stat(n)).type&N.FileType.Directory))throw M.$$N.FileExists(`Unable to create folder '${n.scheme===m.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(N.$bl(s)!==N.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(c.basename(n)),n=c.dirname(n)}for(let s=i.length-1;s>=0;s--){n=c.joinPath(n,i[s]);try{await g.createDirectory(n)}catch(r){if(N.$bl(r)!==N.FileSystemProviderErrorCode.FileExists)throw r}}}static e(g){if(g instanceof M.$$N)throw g;if(g instanceof N.$0k)switch(g.code){case N.FileSystemProviderErrorCode.FileExists:throw M.$$N.FileExists(g.message);case N.FileSystemProviderErrorCode.FileNotFound:throw M.$$N.FileNotFound(g.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw M.$$N.FileNotADirectory(g.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw M.$$N.FileIsADirectory(g.message);case N.FileSystemProviderErrorCode.NoPermissions:throw M.$$N.NoPermissions(g.message);case N.FileSystemProviderErrorCode.Unavailable:throw M.$$N.Unavailable(g.message);default:throw new M.$$N(g.message,g.name)}if(!(g instanceof Error))throw new M.$$N(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw M.$$N.Unavailable(g.message);switch(g.name){case N.FileSystemProviderErrorCode.FileExists:throw M.$$N.FileExists(g.message);case N.FileSystemProviderErrorCode.FileNotFound:throw M.$$N.FileNotFound(g.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw M.$$N.FileNotADirectory(g.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw M.$$N.FileIsADirectory(g.message);case N.FileSystemProviderErrorCode.NoPermissions:throw M.$$N.NoPermissions(g.message);case N.FileSystemProviderErrorCode.Unavailable:throw M.$$N.Unavailable(g.message);default:throw new M.$$N(g.message,g.name)}}addFileSystemProvider(g,c,n){return this.b.set(g,{impl:c,extUri:n?.isCaseSensitive?C.$Ug:C.$Wg,isReadonly:!!n?.isReadonly}),(0,S.$Sc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??C.$Ug}};e.$2kc=v,e.$2kc=v=y=Qe([Ve(0,w.$fP),Ve(1,$.$Fkc)],v),e.$3kc=(0,R.$ri)("IExtHostConsumerFileSystem")}),define(ke[93],Se([1,0,5,28,12,69,2]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=e.$4kc=void 0,e.$4kc=(0,u.$ri)("IExtensionStoragePaths");let w=class{constructor(S,L,C){this.d=L,this.f=C,this.a=S.workspace??void 0,this.b=S.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(S){return R.URI.joinPath(this.b.workspaceStorageHome,S)}async h(){if(!this.a)return Promise.resolve(void 0);const S=this.a.id,L=await this.g(S);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(R.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(S){if(this.c)return R.URI.joinPath(this.c,S.identifier.value)}globalValue(S){return R.URI.joinPath(this.b.globalStorageHome,S.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$5kc=w,e.$5kc=w=Qe([Ve(0,N.$vP),Ve(1,M.$Xj),Ve(2,A.$3kc)],w)}),define(ke[326],Se([1,0,7,20,4]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;let A=class{constructor(w){this.a=new u.$iO(u.ColorThemeKind.Dark),this.b=new M.$be}get activeColorTheme(){return this.a}$onColorThemeChange(w){let $;switch(w){case"light":$=u.ColorThemeKind.Light;break;case"hcDark":$=u.ColorThemeKind.HighContrast;break;case"hcLight":$=u.ColorThemeKind.HighContrastLight;break;default:$=u.ColorThemeKind.Dark}this.a=new u.$iO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$zmc=A,e.$zmc=A=Qe([Ve(0,N.$fP)],A)}),define(ke[70],Se([1,0,22,4,3,228,5,12,88,6,28,20,7]),function(le,e,u,N,M,A,R,w,$,S,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XCb=e.$WCb=e.TunnelDtoConverter=void 0;class y extends $.$fw{}var v;(function(g){function c(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}g.fromApiTunnel=c;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}g.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$WCb=(0,R.$ri)("IExtHostTunnelService");let l=class extends M.$Uc{constructor(c,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$be,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(S.$SM.MainThreadTunnelService)}async openTunnel(c,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,c.displayName);if(i){const s=new y(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,n){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:c,provider:n}),this.a.$registerPortsAttributesProvider(c,i),new m.$UM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(c,n,i,s,r){const t=[];for(const a of c){const h=this.r.get(a);if(!h)return[];t.push(...await Promise.all(n.map(async o=>{let p;try{p=await h.provider.providePortAttributes({port:o,pid:i,commandLine:s},r)}catch{p=await h.provider.providePortAttributes(o,i,s,r)}return{providedAttributes:p,port:o}})))}const d=t.filter(a=>!!a.providedAttributes);return d.length>0?d.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,r)=>await c.provideTunnel(s,r,u.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,n){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const i=c.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let s=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const r=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(r)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,n){if(this.g.has(c.host)){const i=this.g.get(c.host);i.has(c.port)&&(n&&i.get(c.port).disposeListener.dispose(),await i.get(c.port).tunnel.dispose(),i.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(c,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const s=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const r=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:s,disposeListener:r}),v.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(c){const n=await Promise.all(c.map(s=>this.f(s.host,s.port,s.detail??""))),i=c.filter((s,r)=>n[r]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(s=>s.port).join(", ")} to ${i.map(s=>s.port).join(", ")}`),i}};e.$XCb=l,e.$XCb=l=Qe([Ve(0,C.$fP),Ve(1,L.$vP),Ve(2,w.$Xj)],l)}),define(ke[16],Se([1,0,19,21,172,74,80,27,165,58,101,24,167,23,18,2,29,83,138,144,142,290,119,68,89,302,7]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s,r,t,d,a,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$cP=T,e.$dP=W,e.$eP=X;var p;(function(Me){function je(ee){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:_e,positionColumn:Je}=ee,lt=new o.$VM(Fe-1,He-1),kt=new o.$VM(_e-1,Je-1);return new o.$XM(lt,kt)}Me.to=je;function Ee(ee){const{anchor:Fe,active:He}=ee;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Me.from=Ee})(p||(e.Selection=p={}));var f;(function(Me){function je(ee){if(!ee)return;const{start:Fe,end:He}=ee;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Me.from=je;function Ee(ee){if(!ee)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:_e,endColumn:Je}=ee;return new o.$WM(Fe-1,He-1,_e-1,Je-1)}Me.to=Ee})(f||(e.Range=f={}));var D;(function(Me){function je(ee){return{uri:ee.uri,range:f.from(ee.range)}}Me.from=je;function Ee(ee){return new o.$7M(l.URI.revive(ee.uri),f.to(ee.range))}Me.to=Ee})(D||(e.Location=D={}));var b;(function(Me){function je(Ee){switch(Ee){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Me.to=je})(b||(e.TokenType=b={}));var k;(function(Me){function je(ee){return new o.$VM(ee.lineNumber-1,ee.column-1)}Me.to=je;function Ee(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Me.from=Ee})(k||(e.Position=k={}));var E;(function(Me){function je(Fe,He,_e){return(0,u.$Hb)((0,u.$3b)(Fe).map(Je=>Ee(Je,He,_e)))}Me.from=je;function Ee(Fe,He,_e){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:_e?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ee(Fe.scheme,He),pattern:ce.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:_e?.isBuiltin}}function ee(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(E||(e.DocumentSelector=E={}));var P;(function(Me){function je(ee){switch(ee){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Me.from=je;function Ee(ee){switch(ee){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Me.to=Ee})(P||(e.DiagnosticTag=P={}));var I;(function(Me){function je(ee){let Fe;return ee.code&&((0,v.$5f)(ee.code)||(0,v.$9f)(ee.code)?Fe=String(ee.code):Fe={value:String(ee.code.value),target:ee.code.target}),{...f.from(ee.range),message:ee.message,source:ee.source,code:Fe,severity:j.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(F.from),tags:Array.isArray(ee.tags)?(0,u.$Hb)(ee.tags.map(P.from)):void 0}}Me.from=je;function Ee(ee){const Fe=new o.$9M(f.to(ee),ee.message,j.to(ee.severity));return Fe.source=ee.source,Fe.code=(0,v.$5f)(ee.code)?ee.code:ee.code?.value,Fe.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(F.to),Fe.tags=ee.tags&&(0,u.$Hb)(ee.tags.map(P.to)),Fe}Me.to=Ee})(I||(e.Diagnostic=I={}));var F;(function(Me){function je(ee){return{...f.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Me.from=je;function Ee(ee){return new o.$8M(new o.$7M(ee.resource,f.to(ee)),ee.message)}Me.to=Ee})(F||(e.DiagnosticRelatedInformation=F={}));var j;(function(Me){function je(ee){switch(ee){case o.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Me.from=je;function Ee(ee){switch(ee){case n.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Me.to=Ee})(j||(e.DiagnosticSeverity=j={}));var z;(function(Me){function je(ee){return typeof ee=="number"&&ee>=o.ViewColumn.One?ee-1:ee===o.ViewColumn.Beside?h.$QD:h.$PD}Me.from=je;function Ee(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ee})(z||(e.ViewColumn=z={}));function O(Me){return typeof Me.range<"u"}function T(Me){return Me.length===0?!0:!!O(Me[0])}var B;(function(Me){function je(Je){return Je.map(Me.from)}Me.fromMany=je;function Ee(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ee(Je){let lt;if(Ee(Je)){const{language:ut,value:ri}=Je;lt={value:"```"+ut+`
`+ri+"\n```\n"}}else o.$jN.isMarkdownString(Je)?lt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?lt={value:Je}:lt={value:""};const kt=Object.create(null);lt.uris=kt;const jt=ut=>{try{let ri=l.URI.parse(ut,!0);ri=ri.with({query:Fe(ri.query,kt)}),kt[ut]=ri}catch{}return""},Vt=new $.marked.Renderer;return Vt.link=jt,Vt.image=ut=>typeof ut=="string"?jt(R.$Wk(ut).href):"",(0,$.marked)(lt.value,{renderer:Vt}),lt}Me.from=ee;function Fe(Je,lt){if(!Je)return Je;let kt;try{kt=(0,S.$Zh)(Je)}catch{}if(!kt)return Je;let jt=!1;return kt=(0,C.$Zn)(kt,Vt=>{if(l.URI.isUri(Vt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[ut]=Vt,jt=!0,ut}else return}),jt?JSON.stringify(kt):Je}function He(Je){const lt=new o.$jN(Je.value,Je.supportThemeIcons);return lt.isTrusted=Je.isTrusted,lt.supportHtml=Je.supportHtml,lt.baseUri=Je.baseUri?l.URI.from(Je.baseUri):void 0,lt}Me.to=He;function _e(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=_e})(B||(e.MarkdownString=B={}));function W(Me){return T(Me)?Me.map(je=>({range:f.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?B.fromMany(je.hoverMessage):je.hoverMessage?B.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Me.map(je=>({range:f.from(je)}))}function X(Me){return typeof Me>"u"?Me:typeof Me=="string"?l.URI.file(Me):Me}var Z;(function(Me){function je(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?X(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Me.from=je})(Z||(e.ThemableDecorationAttachmentRenderOptions=Z={}));var Y;(function(Me){function je(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?X(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?Z.from(Ee.before):void 0,after:Ee.after?Z.from(Ee.after):void 0}}Me.from=je})(Y||(e.ThemableDecorationRenderOptions=Y={}));var x;(function(Me){function je(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=je})(x||(e.DecorationRangeBehavior=x={}));var ne;(function(Me){function je(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?x.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?Y.from(Ee.light):void 0,dark:Ee.dark?Y.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?X(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?Z.from(Ee.before):void 0,after:Ee.after?Z.from(Ee.after):void 0}}Me.from=je})(ne||(e.DecorationRenderOptions=ne={}));var ge;(function(Me){function je(ee){return{text:ee.newText,eol:ee.newEol&&Be.from(ee.newEol),range:f.from(ee.range)}}Me.from=je;function Ee(ee){const Fe=new o.$2M(f.to(ee.range),ee.text);return Fe.newEol=typeof ee.eol>"u"?void 0:Be.to(ee.eol),Fe}Me.to=Ee})(ge||(e.TextEdit=ge={}));var ue;(function(Me){function je(ee,Fe){const He={edits:[]};if(ee instanceof o.$5M){const _e=new w.$Cc;for(const Je of ee._allEntries())Je._type===1&&l.URI.isUri(Je.to)&&Je.from===void 0&&_e.add(Je.to);for(const Je of ee._allEntries())if(Je._type===1){let lt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?lt={type:"base64",value:(0,N.$We)(N.$Ce.wrap(Je.options.contents))}:lt={type:"dataTransferItem",id:Je.options.contents._itemId}),He.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:lt},metadata:Je.metadata})}else Je._type===2?He.edits.push({resource:Je.uri,textEdit:ge.from(Je.edit),versionId:_e.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?He.edits.push({resource:Je.uri,textEdit:{range:f.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:_e.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?He.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&He.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(At.from)}})}return He}Me.from=je;function Ee(ee){const Fe=new o.$5M,He=new w.$Bc;for(const _e of ee.edits)if(_e.textEdit){const Je=_e,lt=l.URI.revive(Je.resource),kt=f.to(Je.textEdit.range),jt=Je.textEdit.text,Vt=Je.textEdit.insertAsSnippet;let ut;Vt?ut=o.$4M.replace(kt,new o.$6M(jt)):ut=o.$2M.replace(kt,jt);const ri=He.get(lt);ri?ri.push(ut):He.set(lt,[ut])}else Fe.renameFile(l.URI.revive(_e.oldResource),l.URI.revive(_e.newResource),_e.options);for(const[_e,Je]of He)Fe.set(_e,Je);return Fe}Me.to=Ee})(ue||(e.WorkspaceEdit=ue={}));var ve;(function(Me){const je=Object.create(null);je[o.SymbolKind.File]=0,je[o.SymbolKind.Module]=1,je[o.SymbolKind.Namespace]=2,je[o.SymbolKind.Package]=3,je[o.SymbolKind.Class]=4,je[o.SymbolKind.Method]=5,je[o.SymbolKind.Property]=6,je[o.SymbolKind.Field]=7,je[o.SymbolKind.Constructor]=8,je[o.SymbolKind.Enum]=9,je[o.SymbolKind.Interface]=10,je[o.SymbolKind.Function]=11,je[o.SymbolKind.Variable]=12,je[o.SymbolKind.Constant]=13,je[o.SymbolKind.String]=14,je[o.SymbolKind.Number]=15,je[o.SymbolKind.Boolean]=16,je[o.SymbolKind.Array]=17,je[o.SymbolKind.Object]=18,je[o.SymbolKind.Key]=19,je[o.SymbolKind.Null]=20,je[o.SymbolKind.EnumMember]=21,je[o.SymbolKind.Struct]=22,je[o.SymbolKind.Event]=23,je[o.SymbolKind.Operator]=24,je[o.SymbolKind.TypeParameter]=25;function Ee(Fe){return typeof je[Fe]=="number"?je[Fe]:6}Me.from=Ee;function ee(Fe){for(const He in je)if(je[He]===Fe)return Number(He);return o.SymbolKind.Property}Me.to=ee})(ve||(e.SymbolKind=ve={}));var te;(function(Me){function je(ee){switch(ee){case o.SymbolTag.Deprecated:return 1}}Me.from=je;function Ee(ee){switch(ee){case 1:return o.SymbolTag.Deprecated}}Me.to=Ee})(te||(e.SymbolTag=te={}));var U;(function(Me){function je(ee){return{name:ee.name,kind:ve.from(ee.kind),tags:ee.tags&&ee.tags.map(te.from),containerName:ee.containerName,location:re.from(ee.location)}}Me.from=je;function Ee(ee){const Fe=new o.$aN(ee.name,ve.to(ee.kind),ee.containerName,re.to(ee.location));return Fe.tags=ee.tags&&ee.tags.map(te.to),Fe}Me.to=Ee})(U||(e.WorkspaceSymbol=U={}));var _;(function(Me){function je(ee){const Fe={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:f.from(ee.range),selectionRange:f.from(ee.selectionRange),kind:ve.from(ee.kind),tags:ee.tags?.map(te.from)??[]};return ee.children&&(Fe.children=ee.children.map(je)),Fe}Me.from=je;function Ee(ee){const Fe=new o.$bN(ee.name,ee.detail,ve.to(ee.kind),f.to(ee.range),f.to(ee.selectionRange));return(0,u.$Lb)(ee.tags)&&(Fe.tags=ee.tags.map(te.to)),ee.children&&(Fe.children=ee.children.map(Ee)),Fe}Me.to=Ee})(_||(e.DocumentSymbol=_={}));var be;(function(Me){function je(ee){const Fe=new o.$fN(ve.to(ee.kind),ee.name,ee.detail||"",l.URI.revive(ee.uri),f.to(ee.range),f.to(ee.selectionRange));return Fe._sessionId=ee._sessionId,Fe._itemId=ee._itemId,Fe}Me.to=je;function Ee(ee,Fe,He){if(Fe=Fe??ee._sessionId,He=He??ee._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:ee.name,detail:ee.detail,kind:ve.from(ee.kind),uri:ee.uri,range:f.from(ee.range),selectionRange:f.from(ee.selectionRange),tags:ee.tags?.map(te.from)}}Me.from=Ee})(be||(e.CallHierarchyItem=be={}));var Pe;(function(Me){function je(Ee){return new o.$gN(be.to(Ee.from),Ee.fromRanges.map(ee=>f.to(ee)))}Me.to=je})(Pe||(e.CallHierarchyIncomingCall=Pe={}));var se;(function(Me){function je(Ee){return new o.$hN(be.to(Ee.to),Ee.fromRanges.map(ee=>f.to(ee)))}Me.to=je})(se||(e.CallHierarchyOutgoingCall=se={}));var re;(function(Me){function je(ee){return{range:ee.range&&f.from(ee.range),uri:ee.uri}}Me.from=je;function Ee(ee){return new o.$7M(l.URI.revive(ee.uri),f.to(ee.range))}Me.to=Ee})(re||(e.location=re={}));var oe;(function(Me){function je(ee){const Fe=ee,He=ee;return{originSelectionRange:Fe.originSelectionRange?f.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:f.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?f.from(Fe.targetSelectionRange):void 0}}Me.from=je;function Ee(ee){return{targetUri:l.URI.revive(ee.uri),targetRange:f.to(ee.range),targetSelectionRange:ee.targetSelectionRange?f.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?f.to(ee.originSelectionRange):void 0}}Me.to=Ee})(oe||(e.DefinitionLink=oe={}));var K;(function(Me){function je(ee){return{range:f.from(ee.range),contents:B.fromMany(ee.contents)}}Me.from=je;function Ee(ee){return new o.$0M(ee.contents.map(B.to),f.to(ee.range))}Me.to=Ee})(K||(e.Hover=K={}));var ie;(function(Me){function je(ee){return{range:f.from(ee.range),expression:ee.expression}}Me.from=je;function Ee(ee){return new o.$5N(f.to(ee.range),ee.expression)}Me.to=Ee})(ie||(e.EvaluatableExpression=ie={}));var $e;(function(Me){function je(ee){if(ee instanceof o.$6N)return{type:"text",range:f.from(ee.range),text:ee.text};if(ee instanceof o.$7N)return{type:"variable",range:f.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof o.$8N)return{type:"expression",range:f.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=je;function Ee(ee){switch(ee.type){case"text":return{range:f.to(ee.range),text:ee.text};case"variable":return{range:f.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:f.to(ee.range),expression:ee.expression}}}Me.to=Ee})($e||(e.InlineValue=$e={}));var we;(function(Me){function je(ee){return{frameId:ee.frameId,stoppedLocation:f.from(ee.stoppedLocation)}}Me.from=je;function Ee(ee){return new o.$9N(ee.frameId,f.to(ee.stoppedLocation))}Me.to=Ee})(we||(e.InlineValueContext=we={}));var Le;(function(Me){function je(ee){return{range:f.from(ee.range),kind:ee.kind}}Me.from=je;function Ee(ee){return new o.$$M(f.to(ee.range),ee.kind)}Me.to=Ee})(Le||(e.DocumentHighlight=Le={}));var fe;(function(Me){function je(ee){return{uri:ee.uri,highlights:ee.highlights.map(Le.from)}}Me.from=je;function Ee(ee){return new o.$_M(l.URI.revive(ee.uri),ee.highlights.map(Le.to))}Me.to=Ee})(fe||(e.MultiDocumentHighlight=fe={}));var De;(function(Me){function je(Ee){switch(Ee){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Me.to=je})(De||(e.CompletionTriggerKind=De={}));var Ie;(function(Me){function je(Ee){return{triggerKind:De.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Me.to=je})(Ie||(e.CompletionContext=Ie={}));var Te;(function(Me){function je(ee){switch(ee){case o.CompletionItemTag.Deprecated:return 1}}Me.from=je;function Ee(ee){switch(ee){case 1:return o.CompletionItemTag.Deprecated}}Me.to=Ee})(Te||(e.CompletionItemTag=Te={}));var V;(function(Me){const je=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Ee(He){return je.get(He)??9}Me.from=Ee;const ee=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Fe(He){return ee.get(He)??o.CompletionItemKind.Property}Me.to=Fe})(V||(e.CompletionItemKind=V={}));var q;(function(Me){function je(Ee,ee){const Fe=new o.$pN(Ee.label);return Fe.insertText=Ee.insertText,Fe.kind=V.to(Ee.kind),Fe.tags=Ee.tags?.map(Te.to),Fe.detail=Ee.detail,Fe.documentation=R.$Qk(Ee.documentation)?B.to(Ee.documentation):Ee.documentation,Fe.sortText=Ee.sortText,Fe.filterText=Ee.filterText,Fe.preselect=Ee.preselect,Fe.commitCharacters=Ee.commitCharacters,g.$nt.isIRange(Ee.range)?Fe.range=f.to(Ee.range):typeof Ee.range=="object"&&(Fe.range={inserting:f.to(Ee.range.insert),replacing:f.to(Ee.range.replace)}),Fe.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Fe.insertText=new o.$6M(Ee.insertText):(Fe.insertText=Ee.insertText,Fe.textEdit=Fe.range instanceof o.$WM?new o.$2M(Fe.range,Fe.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Ee.additionalTextEdits.map(He=>ge.to(He))),Fe.command=ee&&Ee.command?ee.fromInternal(Ee.command):void 0,Fe}Me.to=je})(q||(e.CompletionItem=q={}));var Q;(function(Me){function je(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:B.fromStrict(ee.documentation)}}Me.from=je;function Ee(ee){return{label:ee.label,documentation:R.$Qk(ee.documentation)?B.to(ee.documentation):ee.documentation}}Me.to=Ee})(Q||(e.ParameterInformation=Q={}));var J;(function(Me){function je(ee){return{label:ee.label,documentation:B.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(Q.from):[],activeParameter:ee.activeParameter}}Me.from=je;function Ee(ee){return{label:ee.label,documentation:R.$Qk(ee.documentation)?B.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(Q.to):[],activeParameter:ee.activeParameter}}Me.to=Ee})(J||(e.SignatureInformation=J={}));var he;(function(Me){function je(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(J.from):[]}}Me.from=je;function Ee(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(J.to):[]}}Me.to=Ee})(he||(e.SignatureHelp=he={}));var pe;(function(Me){function je(Ee,ee){const Fe=new o.$oN(k.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(ze.to.bind(void 0,Ee)),ee.kind&&qe.to(ee.kind));return Fe.textEdits=ee.textEdits&&ee.textEdits.map(ge.to),Fe.tooltip=R.$Qk(ee.tooltip)?B.to(ee.tooltip):ee.tooltip,Fe.paddingLeft=ee.paddingLeft,Fe.paddingRight=ee.paddingRight,Fe}Me.to=je})(pe||(e.InlayHint=pe={}));var ze;(function(Me){function je(Ee,ee){const Fe=new o.$nN(ee.label);return Fe.tooltip=R.$Qk(ee.tooltip)?B.to(ee.tooltip):ee.tooltip,c.Command.is(ee.command)&&(Fe.command=Ee.fromInternal(ee.command)),ee.location&&(Fe.location=re.to(ee.location)),Fe}Me.to=je})(ze||(e.InlayHintLabelPart=ze={}));var qe;(function(Me){function je(ee){return ee}Me.from=je;function Ee(ee){return ee}Me.to=Ee})(qe||(e.InlayHintKind=qe={}));var Ye;(function(Me){function je(ee){return{range:f.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Me.from=je;function Ee(ee){let Fe;if(ee.url)try{Fe=typeof ee.url=="string"?l.URI.parse(ee.url,!0):l.URI.revive(ee.url)}catch{}return new o.$uN(f.to(ee.range),Fe)}Me.to=Ee})(Ye||(e.DocumentLink=Ye={}));var it;(function(Me){function je(ee){const Fe=new o.$xN(ee.label);return ee.textEdit&&(Fe.textEdit=ge.to(ee.textEdit)),ee.additionalTextEdits&&(Fe.additionalTextEdits=ee.additionalTextEdits.map(He=>ge.to(He))),Fe}Me.to=je;function Ee(ee){return{label:ee.label,textEdit:ee.textEdit?ge.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Fe=>ge.from(Fe)):void 0}}Me.from=Ee})(it||(e.ColorPresentation=it={}));var ot;(function(Me){function je(ee){return new o.$vN(ee[0],ee[1],ee[2],ee[3])}Me.to=je;function Ee(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Me.from=Ee})(ot||(e.Color=ot={}));var nt;(function(Me){function je(ee){return{range:f.from(ee.range)}}Me.from=je;function Ee(ee){return new o.$eN(f.to(ee.range))}Me.to=Ee})(nt||(e.SelectionRange=nt={}));var st;(function(Me){function je(Ee){switch(Ee){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Me.to=je})(st||(e.TextDocumentSaveReason=st={}));var Ce;(function(Me){function je(ee){switch(ee){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.Interval:return 3;case o.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=je;function Ee(ee){switch(ee){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 3:return o.TextEditorLineNumbersStyle.Interval;case 1:default:return o.TextEditorLineNumbersStyle.On}}Me.to=Ee})(Ce||(e.TextEditorLineNumbersStyle=Ce={}));var Be;(function(Me){function je(ee){if(ee===o.EndOfLine.CRLF)return 1;if(ee===o.EndOfLine.LF)return 0}Me.from=je;function Ee(ee){if(ee===1)return o.EndOfLine.CRLF;if(ee===0)return o.EndOfLine.LF}Me.to=Ee})(Be||(e.EndOfLine=Be={}));var Ge;(function(Me){function je(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=je})(Ge||(e.ProgressLocation=Ge={}));var Ne;(function(Me){function je(ee){const Fe={start:ee.start+1,end:ee.end+1};return ee.kind&&(Fe.kind=Xe.from(ee.kind)),Fe}Me.from=je;function Ee(ee){const Fe={start:ee.start-1,end:ee.end-1};return ee.kind&&(Fe.kind=Xe.to(ee.kind)),Fe}Me.to=Ee})(Ne||(e.FoldingRange=Ne={}));var Xe;(function(Me){function je(ee){if(ee)switch(ee){case o.FoldingRangeKind.Comment:return c.$9t.Comment;case o.FoldingRangeKind.Imports:return c.$9t.Imports;case o.FoldingRangeKind.Region:return c.$9t.Region}}Me.from=je;function Ee(ee){if(ee)switch(ee.value){case c.$9t.Comment.value:return o.FoldingRangeKind.Comment;case c.$9t.Imports.value:return o.FoldingRangeKind.Imports;case c.$9t.Region.value:return o.FoldingRangeKind.Region}}Me.to=Ee})(Xe||(e.FoldingRangeKind=Xe={}));var ae;(function(Me){function je(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?f.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?s.$gF.id:void 0}}Me.from=je})(ae||(e.TextEditorOpenOptions=ae={}));var ce;(function(Me){function je(He){return He instanceof o.$SN?He.toJSON():typeof He=="string"?He:Ee(He)||ee(He)?new o.$SN(He.baseUri??He.base,He.pattern).toJSON():He}Me.from=je;function Ee(He){const _e=He;return _e?l.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ee(He){const _e=He;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new o.$SN(l.URI.revive(He.baseUri),He.pattern)}Me.to=Fe})(ce||(e.GlobPattern=ce={}));var Ae;(function(Me){function je(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(je);if(typeof Ee=="string")return Ee;{const ee=Ee;return{language:ee.language,scheme:ee.scheme,pattern:ce.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Me.from=je})(Ae||(e.LanguageSelector=Ae={}));var Ke;(function(Me){function je(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(He=>He&&typeof He=="object"&&"uri"in He&&l.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(_e=>_e instanceof o.$WM)))}Me.is=je;function Ee(ee){return{documents:ee.documents.map(Fe=>Fe.map(He=>({uri:l.URI.from(He.uri),version:He.version,ranges:He.ranges.map(_e=>f.from(_e))})))}}Me.from=Ee})(Ke||(e.MappedEditsContext=Ke={}));var Re;(function(Me){function je(ee){return{start:ee.start,end:ee.end}}Me.from=je;function Ee(ee){return new o.$jO(ee.start,ee.end)}Me.to=Ee})(Re||(e.NotebookRange=Re={}));var tt;(function(Me){function je(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Me.to=je;function Ee(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Me.from=Ee})(tt||(e.NotebookCellExecutionSummary=tt={}));var ht;(function(Me){function je(Ee){if(Ee===t.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Ee===t.NotebookCellExecutionState.Pending)return;if(Ee===t.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Me.to=je})(ht||(e.NotebookCellExecutionState=ht={}));var wt;(function(Me){function je(ee){switch(ee){case o.NotebookCellKind.Markup:return t.CellKind.Markup;case o.NotebookCellKind.Code:default:return t.CellKind.Code}}Me.from=je;function Ee(ee){switch(ee){case t.CellKind.Markup:return o.NotebookCellKind.Markup;case t.CellKind.Code:default:return o.NotebookCellKind.Code}}Me.to=Ee})(wt||(e.NotebookCellKind=wt={}));var Nt;(function(Me){function je(ee){const Fe={metadata:ee.metadata??Object.create(null),cells:[]};for(const He of ee.cells)o.$kO.validate(He),Fe.cells.push(At.from(He));return Fe}Me.from=je;function Ee(ee){const Fe=new o.$lO(ee.cells.map(At.to));return(0,v.$fg)(ee.metadata)||(Fe.metadata=ee.metadata),Fe}Me.to=Ee})(Nt||(e.NotebookData=Nt={}));var At;(function(Me){function je(ee){return{cellKind:wt.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:tt.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(_t.from):[]}}Me.from=je;function Ee(ee){return new o.$kO(wt.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(_t.to):void 0,ee.metadata,ee.internalMetadata?tt.to(ee.internalMetadata):void 0)}Me.to=Ee})(At||(e.NotebookCellData=At={}));var xt;(function(Me){function je(ee){return{mime:ee.mime,valueBytes:N.$Ce.wrap(ee.data)}}Me.from=je;function Ee(ee){return new o.$mO(ee.valueBytes.buffer,ee.mime)}Me.to=Ee})(xt||(e.NotebookCellOutputItem=xt={}));var _t;(function(Me){function je(ee){return{outputId:ee.id,items:ee.items.map(xt.from),metadata:ee.metadata}}Me.from=je;function Ee(ee){const Fe=ee.items.map(xt.to);return new o.$nO(Fe,ee.outputId,ee.metadata)}Me.to=Ee})(_t||(e.NotebookCellOutput=_t={}));var Pt;(function(Me){function je(Fe){return ee(Fe)?{include:ce.from(Fe.include)??void 0,exclude:ce.from(Fe.exclude)??void 0}:ce.from(Fe)??void 0}Me.from=je;function Ee(Fe){return ee(Fe)?{include:ce.to(Fe.include),exclude:ce.to(Fe.exclude)}:ce.to(Fe)}Me.to=Ee;function ee(Fe){const He=Fe;return He?!(0,v.$bg)(He.include)&&!(0,v.$bg)(He.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var qt;(function(Me){function je(Ee,ee,Fe){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(He,Fe),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Me.from=je})(qt||(e.NotebookStatusBarItem=qt={}));var Xt;(function(Me){function je(Ee,ee,Fe){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:ee.toInternal(He,Fe),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Me.from=je})(Xt||(e.NotebookKernelSourceAction=Xt={}));var et;(function(Me){function je(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Me.from=je})(et||(e.NotebookDocumentContentOptions=et={}));var si;(function(Me){function je(ee){return{uri:ee.uri,provides:ee.provides}}Me.from=je;function Ee(ee){return new o.$pO(l.URI.revive(ee.uri),ee.provides)}Me.to=Ee})(si||(e.NotebookRendererScript=si={}));var Yt;(function(Me){function je(ee){return{message:B.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:f.from(ee.location.range),uri:ee.location.uri}}}Me.from=je;function Ee(ee){const Fe=new o.$vO(typeof ee.message=="string"?ee.message:B.to(ee.message));return Fe.actualOutput=ee.actual,Fe.expectedOutput=ee.expected,Fe.contextValue=ee.contextValue,Fe.location=ee.location?re.to(ee.location):void 0,Fe}Me.to=Ee})(Yt||(e.TestMessage=Yt={}));var dt;(function(Me){Me.namespace=a.$JL,Me.denamespace=a.$KL})(dt||(e.TestTag=dt={}));var vt;(function(Me){function je(ee){const Fe=(0,i.$bP)(ee).controllerId;return{extId:d.$EL.fromExtHostTestItem(ee,Fe).toString(),label:ee.label,uri:l.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(He=>dt.namespace(Fe,He.id)),range:g.$nt.lift(f.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&B.fromStrict(ee.error)||null}}Me.from=je;function Ee(ee){return{parent:void 0,error:void 0,id:d.$EL.fromString(ee.extId).localId,label:ee.label,uri:l.URI.revive(ee.uri),tags:(ee.tags||[]).map(Fe=>{const{tagId:He}=dt.denamespace(Fe);return new o.$wO(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:f.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Me.toPlain=Ee})(vt||(e.TestItem=vt={})),function(Me){function je(ee){return{id:ee.id}}Me.from=je;function Ee(ee){return new o.$wO(ee.id)}Me.to=Ee}(dt||(e.TestTag=dt={}));var ti;(function(Me){const je=(ee,Fe)=>{const He=ee.value;if(!He)return;const _e={...vt.toPlain(He.item),parent:Fe,taskStates:He.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(lt=>lt.type===0).map(Yt.to)})),children:[]};if(ee.children)for(const Je of ee.children.values()){const lt=je(Je,_e);lt&&_e.children.push(lt)}return _e};function Ee(ee){const Fe=new m.$7O;for(const Je of ee.items)Fe.insert(d.$EL.fromString(Je.item.extId).path,Je);const He=[Fe.nodes],_e=[];for(;He.length;)for(const Je of He.pop())Je.value?_e.push(Je):Je.children&&He.push(Je.children.values());return{completedAt:ee.completedAt,results:_e.map(Je=>je(Je)).filter(v.$ag)}}Me.to=Ee})(ti||(e.TestResults=ti={}));var Zt;(function(Me){function je(He){return{covered:He.covered,total:He.total}}function Ee(He){return"line"in He?k.from(He):f.from(He)}function ee(He){if(typeof He.executed=="number"&&He.executed<0)throw new Error(`Invalid coverage count ${He.executed}`);return"branches"in He?{count:He.executed,location:Ee(He.location),type:1,branches:He.branches.length?He.branches.map(_e=>({count:_e.executed,location:_e.location&&Ee(_e.location),label:_e.label})):void 0}:{type:0,name:He.name,count:He.executed,location:Ee(He.location)}}Me.fromDetails=ee;function Fe(He,_e){return o.$yO(_e.statementCoverage),o.$yO(_e.branchCoverage),o.$yO(_e.declarationCoverage),{id:He,uri:_e.uri,statement:je(_e.statementCoverage),branch:_e.branchCoverage&&je(_e.branchCoverage),declaration:_e.declarationCoverage&&je(_e.declarationCoverage)}}Me.fromFile=Fe})(Zt||(e.TestCoverage=Zt={}));var zt;(function(Me){function je(Ee){switch(Ee){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Me.to=je})(zt||(e.CodeActionTriggerKind=zt={}));var gt;(function(Me){function je(ee){const Fe=new o.$DO(ve.to(ee.kind),ee.name,ee.detail||"",l.URI.revive(ee.uri),f.to(ee.range),f.to(ee.selectionRange));return Fe._sessionId=ee._sessionId,Fe._itemId=ee._itemId,Fe}Me.to=je;function Ee(ee,Fe,He){if(Fe=Fe??ee._sessionId,He=He??ee._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:ve.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:f.from(ee.range),selectionRange:f.from(ee.selectionRange),tags:ee.tags?.map(te.from)}}Me.from=Ee})(gt||(e.TypeHierarchyItem=gt={}));var Ut;(function(Me){function je(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Me.from=je})(Ut||(e.ViewBadge=Ut={}));var Wt;(function(Me){function je(He,_e,Je){const lt=_e.fileData;return lt?new o.$KN(new o.$LN(lt.name,l.URI.revive(lt.uri),lt.id,(0,A.$db)(()=>Je(lt.id)))):He===L.$Ks.uriList&&_e.uriListData?new o.$JN(Fe(_e.uriListData)):new o.$JN(_e.asString)}Me.to=je;async function Ee(He,_e){const Je=await _e.asString();if(He===L.$Ks.uriList)return{asString:Je,fileData:void 0,uriListData:ee(Je)};const lt=_e.asFile();return{asString:Je,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}Me.from=Ee;function ee(He){return M.$Nt.split(He).map(_e=>{if(_e.startsWith("#"))return _e;try{return l.URI.parse(_e)}catch{}return _e})}function Fe(He){return M.$Nt.create(He.map(_e=>typeof _e=="string"?_e:l.URI.revive(_e)))}})(Wt||(e.DataTransferItem=Wt={}));var Ht;(function(Me){function je(ee,Fe){const He=ee.items.map(([_e,Je])=>[_e,Wt.to(_e,Je,Fe)]);return new o.$MN(He)}Me.toDataTransfer=je;async function Ee(ee){const Fe={items:[]},He=[];for(const[_e,Je]of ee)He.push((async()=>{Fe.items.push([_e,await Wt.from(_e,Je)])})());return await Promise.all(He),Fe}Me.from=Ee})(Ht||(e.DataTransfer=Ht={}));var Ze;(function(Me){function je(ee,Fe){return{kind:"reply",agentId:ee.participant??Fe?.agentId??"",subCommand:ee.command??Fe?.command,message:ee.prompt,title:ee.label}}Me.from=je;function Ee(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Me.to=Ee})(Ze||(e.ChatFollowup=Ze={}));var ui;(function(Me){function je(Ee){return"commandId"in Ee?{kind:"command",title:Ee.title??"",commandId:Ee.commandId??"",when:Ee.when??"",args:Ee.args}:{kind:"reply",message:Ee.message,title:Ee.title,tooltip:Ee.tooltip}}Me.from=je})(ui||(e.ChatInlineFollowup=ui={}));var Gt;(function(Me){function je(ee){switch(ee.role){case 0:return new o.$2O(ee.content);case 1:return new o.$3O(ee.content);case 2:return new o.$4O(ee.content)}}Me.to=je;function Ee(ee){if(ee instanceof o.$2O)return{role:0,content:ee.content};if(ee instanceof o.$3O)return{role:1,content:ee.content};if(ee instanceof o.$4O)return{role:2,content:ee.content};throw new Error("Invalid LanguageModelMessage")}Me.from=Ee})(Gt||(e.LanguageModelMessage=Gt={}));var Bt;(function(Me){function je(Fe){const He={};for(const _e of Object.keys(Fe))He[_e]=Fe[_e].map(Me.to);return He}Me.objectTo=je;function Ee(Fe){return{level:mt.to(Fe.level),kind:Fe.kind,value:(0,l.$wc)(Fe.value)?l.URI.revive(Fe.value):Fe.value,description:Fe.description}}Me.to=Ee;function ee(Fe){return{level:mt.from(Fe.level),kind:Fe.kind,value:Fe.value,description:Fe.description}}Me.from=ee})(Bt||(e.ChatVariable=Bt={}));var mt;(function(Me){function je(ee){switch(ee){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}Me.to=je;function Ee(ee){switch(ee){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}Me.from=Ee})(mt||(e.ChatVariableLevel=mt={}));var Tt;(function(Me){function je(Ee){switch(Ee){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return o.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=je})(Tt||(e.InteractiveEditorResponseFeedbackKind=Tt={}));var Rt;(function(Me){function je(ee){return{kind:"markdownContent",content:B.from(ee.value)}}Me.from=je;function Ee(ee){return new o.$QO(B.to(ee.content))}Me.to=Ee})(Rt||(e.ChatResponseMarkdownPart=Rt={}));var Ft;(function(Me){function je(ee){return{kind:"markdownVuln",content:B.from(ee.value),vulnerabilities:ee.vulnerabilities}}Me.from=je;function Ee(ee){return new o.$RO(B.to(ee.content),ee.vulnerabilities)}Me.to=Ee})(Ft||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ft={}));var ii;(function(Me){function je(ee){return{kind:"agentDetection",agentId:ee.participant,command:ee.command}}Me.from=je;function Ee(ee){return new o.$SO(ee.agentId,ee.command)}Me.to=Ee})(ii||(e.ChatResponseDetectedParticipantPart=ii={}));var Kt;(function(Me){function je(ee){const{value:Fe,baseUri:He}=ee;function _e(Je,lt){return Je.map(kt=>{const jt=l.URI.joinPath(lt,kt.name);return{label:kt.name,uri:jt,children:kt.children&&_e(kt.children,jt)}})}return{kind:"treeData",treeData:{label:(0,y.$2g)(He),uri:He,children:_e(Fe,He)}}}Me.from=je;function Ee(ee){const Fe=(0,S.$1h)(ee.treeData);function He(lt){return lt.map(kt=>({name:kt.label,children:kt.children&&He(kt.children)}))}const _e=Fe.uri,Je=Fe.children?He(Fe.children):[];return new o.$TO(Je,_e)}Me.to=Ee})(Kt||(e.ChatResponseFilesPart=Kt={}));var ni;(function(Me){function je(ee){return{kind:"inlineReference",name:ee.title,inlineReference:l.URI.isUri(ee.value)?ee.value:D.from(ee.value)}}Me.from=je;function Ee(ee){const Fe=(0,S.$1h)(ee);return new o.$UO(l.URI.isUri(Fe.inlineReference)?Fe.inlineReference:D.to(Fe.inlineReference),ee.name)}Me.to=Ee})(ni||(e.ChatResponseAnchorPart=ni={}));var Ot;(function(Me){function je(ee){return{kind:"progressMessage",content:B.from(ee.value)}}Me.from=je;function Ee(ee){return new o.$VO(ee.content.value)}Me.to=Ee})(Ot||(e.ChatResponseProgressPart=Ot={}));var Lt;(function(Me){function je(ee,Fe,He){return{kind:"command",command:Fe.toInternal(ee.value,He)??{command:ee.value.command,title:ee.value.title}}}Me.from=je;function Ee(ee,Fe){return new o.$WO(Fe.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Me.to=Ee})(Lt||(e.ChatResponseCommandButtonPart=Lt={}));var It;(function(Me){function je(ee){return{kind:"textEdit",uri:ee.uri,edits:ee.edits.map(Fe=>ge.from(Fe))}}Me.from=je;function Ee(ee){return new o.$YO(l.URI.revive(ee.uri),ee.edits.map(Fe=>ge.to(Fe)))}Me.to=Ee})(It||(e.ChatResponseTextEditPart=It={}));var St;(function(Me){function je(ee){return"variableName"in ee.value?{kind:"reference",reference:{variableName:ee.value.variableName,value:l.URI.isUri(ee.value.value)||!ee.value.value?ee.value.value:D.from(ee.value.value)}}:{kind:"reference",reference:l.URI.isUri(ee.value)?ee.value:D.from(ee.value)}}Me.from=je;function Ee(ee){const Fe=(0,S.$1h)(ee),He=_e=>l.URI.isUri(_e)?_e:D.to(_e);return new o.$XO("variableName"in Fe.reference?{variableName:Fe.reference.variableName,value:Fe.reference.value&&He(Fe.reference.value)}:He(Fe.reference))}Me.to=Ee})(St||(e.ChatResponseReferencePart=St={}));var bt;(function(Me){function je(Fe,He,_e){return Fe instanceof o.$QO?Rt.from(Fe):Fe instanceof o.$UO?ni.from(Fe):Fe instanceof o.$XO?St.from(Fe):Fe instanceof o.$VO?Ot.from(Fe):Fe instanceof o.$TO?Kt.from(Fe):Fe instanceof o.$WO?Lt.from(Fe,He,_e):Fe instanceof o.$YO?It.from(Fe):Fe instanceof o.$RO?Ft.from(Fe):Fe instanceof o.$SO?ii.from(Fe):{kind:"markdownContent",content:B.from("")}}Me.from=je;function Ee(Fe,He){switch(Fe.kind){case"reference":return St.to(Fe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(Fe,He)}}Me.to=Ee;function ee(Fe,He){switch(Fe.kind){case"markdownContent":return Rt.to(Fe);case"inlineReference":return ni.to(Fe);case"progressMessage":return;case"treeData":return Kt.to(Fe);case"command":return Lt.to(Fe,He)}}Me.toContent=ee})(bt||(e.ChatResponsePart=bt={}));var Ct;(function(Me){function je(Ee){return{prompt:Ee.message,command:Ee.command,attempt:Ee.attempt??0,enableCommandDetection:Ee.enableCommandDetection??!0,variables:Ee.variables.variables.map(Dt.to),location:li.to(Ee.location)}}Me.to=je})(Ct||(e.ChatAgentRequest=Ct={}));var li;(function(Me){function je(Ee){switch(Ee){case r.ChatAgentLocation.Notebook:return o.ChatLocation.Notebook;case r.ChatAgentLocation.Terminal:return o.ChatLocation.Terminal;case r.ChatAgentLocation.Panel:return o.ChatLocation.Panel;case r.ChatAgentLocation.Editor:return o.ChatLocation.Editor}}Me.to=je})(li||(e.ChatLocation=li={}));var Dt;(function(Me){function je(Ee){return{name:Ee.name,range:Ee.range&&[Ee.range.start,Ee.range.endExclusive],values:Ee.values.map(Bt.to)}}Me.to=je})(Dt||(e.ChatAgentResolvedVariable=Dt={}));var hi;(function(Me){function je(Ee,ee,Fe){return{label:Ee.label,values:Ee.values.map(Bt.from),insertText:Ee.insertText,detail:Ee.detail,documentation:Ee.documentation,command:ee.toInternal(Ee.command,Fe)}}Me.from=je})(hi||(e.ChatAgentCompletionItem=hi={}));var Qt;(function(Me){function je(Ee){return{errorDetails:Ee.errorDetails,metadata:Ee.metadata}}Me.to=je})(Qt||(e.ChatAgentResult=Qt={}));var wi;(function(Me){function je(Ee,ee,Fe){if(ee.action.kind==="vote")return;const He=Qt.to(Ee);if(ee.action.kind==="command"){const _e=ee.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Fe.fromInternal(_e)??{command:_e.id,title:_e.title}}},result:He}}else return ee.action.kind==="followUp"?{action:{kind:"followUp",followup:Ze.to(ee.action.followup)},result:He}:ee.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ee.action.action==="accepted"},result:He}:{action:ee.action,result:He}}Me.to=je})(wi||(e.ChatAgentUserActionEvent=wi={}));var ei;(function(Me){function je(Ee,ee,Fe){return"terminalCommand"in Ee?{terminalCommand:Ee.terminalCommand,shouldExecute:Ee.shouldExecute}:"uri"in Ee?{uri:Ee.uri}:ee.toInternal(Ee,Fe)}Me.from=je})(ei||(e.TerminalQuickFix=ei={}));var vi;(function(Me){function je(Ee){return{kind:Et.to(Ee.kind)}}Me.to=je})(vi||(e.PartialAcceptInfo=vi={}));var Et;(function(Me){function je(Ee){switch(Ee){case 0:return o.PartialAcceptTriggerKind.Word;case 1:return o.PartialAcceptTriggerKind.Line;case 2:return o.PartialAcceptTriggerKind.Suggest;default:return o.PartialAcceptTriggerKind.Unknown}}Me.to=je})(Et||(e.PartialAcceptTriggerKind=Et={}));var $i;(function(Me){function je(Ee,ee){return{id:ee,label:Ee.label,description:Ee.description,canEdit:Ee.canEdit,collapsibleState:Ee.collapsibleState||0,contextValue:Ee.contextValue}}Me.from=je})($i||(e.DebugTreeItem=$i={}))}),define(ke[327],Se([1,0,6,20,16,48]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;let R=class{constructor($,S){this.a=$.getProxy(u.$SM.MainThreadBulkEdits),this.b={getTextDocumentVersion:L=>S.getDocument(L)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,S,L){const C=new A.$ow(M.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(C,void 0,L?.isRefactoring??!1)}};e.$Nkc=R,e.$Nkc=R=Qe([Ve(0,N.$fP)],R)}),define(ke[328],Se([1,0,19,8,47,4,39,3,40,18,2,25,6,16,7,291,26]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=void 0;class c{constructor(r,t,d,a,h){this.j=r,this.k=t,this.l=d,this.m=a,this.n=h,this.b=$.$0d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(a){if(r.c){const h=new Error("Response stream has been closed");throw Error.captureStackTrace(h,a),h}};const r=this;this.b.reset();const d=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a)};this.g={markdown(a){t(this.markdown);const h=new v.$QO(a),o=y.ChatResponseMarkdownPart.from(h);return d(o),this},markdownWithVulnerabilities(a,h){t(this.markdown),h&&(0,g.$AG)(r.j,"chatParticipantAdditions");const o=new v.$RO(a,h),p=y.ChatResponseMarkdownWithVulnerabilitiesPart.from(o);return d(p),this},filetree(a,h){t(this.filetree);const o=new v.$TO(a,h),p=y.ChatResponseFilesPart.from(o);return d(p),this},anchor(a,h){t(this.anchor);const o=new v.$UO(a,h),p=y.ChatResponseAnchorPart.from(o);return d(p),this},button(a){t(this.anchor);const h=new v.$WO(a),o=y.ChatResponseCommandButtonPart.from(h,r.m,r.n);return d(o),this},progress(a){t(this.progress);const h=new v.$VO(a),o=y.ChatResponseProgressPart.from(h);return d(o),this},reference(a){if(t(this.reference),"variableName"in a&&!a.value){const h=r.k.variables.variables.find(o=>o.name===a.variableName);if(h){let o;if(h.references?.length)o=h.references.map(p=>({kind:"reference",reference:{variableName:a.variableName,value:p.reference}}));else{const p=new v.$XO(a);o=[y.ChatResponseReferencePart.from(p)]}return o.forEach(p=>d(p)),this}}else{const h=new v.$XO(a),o=y.ChatResponseReferencePart.from(h);d(o)}return this},textEdit(a,h){t(this.textEdit),(0,g.$AG)(r.j,"chatParticipantAdditions");const o=new v.$YO(a,h),p=y.ChatResponseTextEditPart.from(o);return d(p),this},detectedParticipant(a,h){t(this.detectedParticipant),(0,g.$AG)(r.j,"chatParticipantAdditions");const o=new v.$SO(a,h),p=y.ChatResponseDetectedParticipantPart.from(o);return d(p),this},push(a){if(t(this.push),(a instanceof v.$YO||a instanceof v.$RO||a instanceof v.$SO)&&(0,g.$AG)(r.j,"chatParticipantAdditions"),a instanceof v.$XO)this.reference(a.value);else{const h=y.ChatResponsePart.from(a,r.m,r.n);d(h)}return this}}}return this.g}}class n extends w.$Uc{static{this.b=0}constructor(r,t,d){super(),this.n=t,this.s=d,this.c=new Map,this.j=this.B(new w.$4c),this.m=this.B(new w.$Tc),this.g=r.getProxy(m.$SM.MainThreadChatAgents2)}transferActiveChat(r){this.g.$transferActiveChatSession(r)}createChatAgent(r,t,d){const a=n.b++,h=new i(r,t,this.g,a,d);return this.c.set(a,h),this.g.$registerAgent(a,r.identifier,t,{},void 0),h.apiAgent}createDynamicChatAgent(r,t,d,a,h){const o=n.b++,p=new i(r,t,this.g,o,h);return this.c.set(o,p),this.g.$registerAgent(o,r.identifier,t,{isSticky:!0},{name:d,description:a}),p.apiAgent}async $invokeAgent(r,t,d,a){const h=this.c.get(r);if(!h)throw new Error(`[CHAT](${r}) CANNOT invoke agent because the agent is not registered`);let o=this.j.get(t.sessionId);o||(o=new w.$Tc,this.j.set(t.sessionId,o));const p=new c(h.extension,t,this.g,this.s.converter,o);try{const f=await this.t(t.agentId,d),D=h.invoke(y.ChatAgentRequest.to(t),{history:f},p.apiObject,a);return await(0,N.$fh)(Promise.resolve(D).then(b=>{if(b?.metadata)try{JSON.stringify(b.metadata)}catch(k){const E=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.n.error(`[${h.extension.identifier.value}] [@${h.id}] ${E}`,h.extension),{errorDetails:{message:E},timings:p.timings}}return{errorDetails:b?.errorDetails,timings:p.timings,metadata:b?.metadata}}),a)}catch(f){return this.n.error(f,h.extension),{errorDetails:{message:(0,M.$cj)(f),responseIsIncomplete:!0}}}finally{p.close()}}async t(r,t){const d=[];for(const a of t.history){const h=y.ChatAgentResult.to(a.result),o=r===a.request.agentId?h:{...h,metadata:void 0};d.push(new v.$ZO(a.request.message,a.request.command,a.request.variables.variables.map(y.ChatAgentResolvedVariable.to),a.request.agentId));const p=(0,u.$Hb)(a.response.map(f=>y.ChatResponsePart.toContent(f,this.s.converter)));d.push(new v.$1O(p,o,a.request.agentId,a.request.command))}return d}$releaseSession(r){this.j.deleteAndDispose(r)}async $provideFollowups(r,t,d,a,h){const o=this.c.get(t);if(!o)return Promise.resolve([]);const p=await this.t(o.id,a),f=y.ChatAgentResult.to(d);return(await o.provideFollowups(f,{history:p},h)).filter(D=>{const b=!D.participant||R.Iterable.some(this.c.values(),k=>k.id===D.participant&&C.$Mm.equals(k.extension.identifier,o.extension.identifier));return b||this.n.warn(`[@${o.id}] ChatFollowup refers to an unknown participant: ${D.participant}`),b}).map(D=>y.ChatFollowup.from(D,r))}$acceptFeedback(r,t,d,a){const h=this.c.get(r);if(!h)return;const o=y.ChatAgentResult.to(t);let p;switch(d){case l.InteractiveSessionVoteDirection.Down:p=v.ChatResultFeedbackKind.Unhelpful;break;case l.InteractiveSessionVoteDirection.Up:p=v.ChatResultFeedbackKind.Helpful;break}h.acceptFeedback(Object.freeze(a?{result:o,kind:p,reportIssue:a}:{result:o,kind:p}))}$acceptAction(r,t,d){const a=this.c.get(r);if(!a||d.action.kind==="vote")return;const h=y.ChatAgentUserActionEvent.to(t,d,this.s.converter);h&&a.acceptAction(Object.freeze(h))}async $invokeCompletionProvider(r,t,d){const a=this.c.get(r);return a?(await a.invokeCompletionProvider(t,d)).map(o=>y.ChatAgentCompletionItem.from(o,this.s.converter,this.m)):[]}async $provideWelcomeMessage(r,t,d){const a=this.c.get(r);if(a)return await a.provideWelcomeMessage(y.ChatLocation.to(t),d)}async $provideSampleQuestions(r,t,d){const a=this.c.get(r);if(a)return(await a.provideSampleQuestions(y.ChatLocation.to(t),d)).map(h=>y.ChatFollowup.from(h,void 0))}}e.$Okc=n;class i{constructor(r,t,d,a,h){this.extension=r,this.id=t,this.u=d,this.w=a,this.x=h,this.n=new A.$be,this.o=new A.$be}acceptFeedback(r){this.n.fire(r)}acceptAction(r){this.o.fire(r)}async invokeCompletionProvider(r,t){return this.q?await this.q.provider.provideCompletionItems(r,t)??[]:[]}async provideFollowups(r,t,d){if(!this.b)return[];const a=await this.b.provideFollowups(r,t,d);return a?a.filter(h=>!(h&&"commandId"in h)).filter(h=>!(h&&"message"in h)):[]}async provideWelcomeMessage(r,t){if(!this.s)return[];const d=await this.s.provideWelcomeMessage(r,t);return d?d.map(a=>typeof a=="string"?a:y.MarkdownString.from(a)):[]}async provideSampleQuestions(r,t){if(!this.s||!this.s.provideSampleQuestions)return[];const d=await this.s.provideSampleQuestions(r,t);return d||[]}get apiAgent(){let r=!1,t=!1;const d=()=>{r||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof L.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof v.$QN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:y.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:y.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:y.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,g.$AG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName(h){(0,g.$AG)(a.extension,"defaultChatParticipant"),a.c=h,d()},get iconPath(){return a.d},set iconPath(h){a.d=h,d()},get requestHandler(){return a.x},set requestHandler(h){(0,S.$cg)(typeof h=="function","Invalid request handler"),a.x=h},get followupProvider(){return a.b},set followupProvider(h){a.b=h,d()},get isDefault(){return(0,g.$AG)(a.extension,"defaultChatParticipant"),a.g},set isDefault(h){(0,g.$AG)(a.extension,"defaultChatParticipant"),a.g=h,d()},get helpTextPrefix(){return(0,g.$AG)(a.extension,"defaultChatParticipant"),a.j},set helpTextPrefix(h){(0,g.$AG)(a.extension,"defaultChatParticipant"),a.j=h,d()},get helpTextVariablesPrefix(){return(0,g.$AG)(a.extension,"defaultChatParticipant"),a.k},set helpTextVariablesPrefix(h){(0,g.$AG)(a.extension,"defaultChatParticipant"),a.k=h,d()},get helpTextPostfix(){return(0,g.$AG)(a.extension,"defaultChatParticipant"),a.l},set helpTextPostfix(h){(0,g.$AG)(a.extension,"defaultChatParticipant"),a.l=h,d()},get isSecondary(){return(0,g.$AG)(a.extension,"defaultChatParticipant"),a.m},set isSecondary(h){(0,g.$AG)(a.extension,"defaultChatParticipant"),a.m=h,d()},get supportIssueReporting(){return(0,g.$AG)(a.extension,"chatParticipantAdditions"),a.p},set supportIssueReporting(h){(0,g.$AG)(a.extension,"chatParticipantAdditions"),a.p=h,d()},get onDidReceiveFeedback(){return a.n.event},set participantVariableProvider(h){if((0,g.$AG)(a.extension,"chatParticipantAdditions"),a.q=h,h){if(!h.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,h.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,g.$AG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(h){(0,g.$AG)(a.extension,"defaultChatParticipant"),a.s=h,d()},get welcomeMessageProvider(){return(0,g.$AG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,g.$zG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(h){a.t=h,d()},get requester(){return a.t},dispose(){r=!0,a.b=void 0,a.n.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(r,t,d,a){return this.x(r,t,d,a)}}}),define(ke[329],Se([1,0,13,3,6,16,7,26]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class ${static{this.a=0}constructor(C){this.b=new Map,this.c=C.getProxy(M.$SM.MainThreadChatVariables)}async $resolveVariable(C,m,y,v){const l=this.b.get(C);if(l)try{if(l.resolver.resolve2){(0,w.$AG)(l.extension,"chatParticipantAdditions");const g=new S(m,this.c),c=await l.resolver.resolve2(l.data.name,{prompt:y},g.apiObject,v);if(c)return c.map(A.ChatVariable.from)}else{const g=await l.resolver.resolve(l.data.name,{prompt:y},v);if(g)return g.map(A.ChatVariable.from)}}catch(g){(0,u.$2)(g)}}registerVariableResolver(C,m,y,v){const l=$.a++;return this.b.set(l,{extension:C,data:{name:m,description:y},resolver:v}),this.c.$registerVariable(l,{name:m,description:y}),(0,N.$Sc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$Pkc=$;class S{constructor(C,m){this.c=C,this.d=m,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let m=function(v){if(C.a){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,v),l}};const C=this,y=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){m(this.progress);const l=new R.$VO(v),g=A.ChatResponseProgressPart.from(l);return y(g),this},reference(v){m(this.reference);const l=new R.$XO(v),g=A.ChatResponseReferencePart.from(l);return y(g),this},push(v){return m(this.push),v instanceof R.$XO?y(A.ChatResponseReferencePart.from(v)):v instanceof R.$VO&&y(A.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(ke[330],Se([1,0,8,55,4,3,2,83,25,16,7,6,26]),function(le,e,u,N,M,A,R,w,$,S,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=y;function y(v,l,g){const c=v.getProxy(C.$SM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Om,l.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const D=this.b.get(f.handle);return D?D.value:f}else if(f&&f.$mid===7){const D=f,b=this.b.get(D.commentControlHandle);if(!b)return D;const k=b.getCommentThread(D.commentThreadHandle);return k?k.value:D}else if(f&&(f.$mid===9||f.$mid===8)){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const b=D.getCommentThread(f.thread.commentThreadHandle);return b?f.$mid===8?b.value:{thread:b.value,text:f.text}:f}else if(f&&f.$mid===10){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const b=D.getCommentThread(f.thread.commentThreadHandle);if(!b)return f;const k=f.commentUniqueId,E=b.getCommentByUniqueId(k);return E||f}else if(f&&f.$mid===11){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const b=D.getCommentThread(f.thread.commentThreadHandle);if(!b)return f;const k=f.text,E=f.commentUniqueId,P=b.getCommentByUniqueId(E);return P?(typeof P.body=="string"?P.body=k:P.body=new L.$jN(k),P):f}return f}})}createCommentController(f,D,b){const k=n.a++,E=new s(f,k,D,b);this.b.set(E.handle,E);const P=this.c.get(f.identifier)||[];return P.push(E),this.c.set(f.identifier,P),E.value}async $createCommentThreadTemplate(f,D,b){const k=this.b.get(f);k&&k.$createCommentThreadTemplate(D,b)}async $setActiveComment(f,D){const b=this.b.get(f);b&&b.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(f,D,b){const k=this.b.get(f);k&&k.$updateCommentThreadTemplate(D,b)}$deleteCommentThread(f,D){this.b.get(f)?.$deleteCommentThread(D)}async $provideCommentingRanges(f,D,b){const k=this.b.get(f);if(!k||!k.commentingRangeProvider)return Promise.resolve(void 0);const E=await g.ensureDocumentData(R.URI.revive(D));return(0,u.$jh)(async()=>{const P=await k.commentingRangeProvider.provideCommentingRanges(E.document,b);let I;return Array.isArray(P)?I={ranges:P,fileComments:!1}:P?I={ranges:P.ranges||[],fileComments:P.fileComments||!1}:I=P??void 0,I}).then(P=>{let I;return P&&(I={ranges:P.ranges.map(F=>S.Range.from(F)),fileComments:P.fileComments}),I})}$toggleReaction(f,D,b,k,E){const P=this.b.get(f);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,u.$jh)(()=>{const I=P.getCommentThread(D);if(I){const F=I.getCommentByUniqueId(k.uniqueIdInThread);if(P!==void 0&&F&&P.reactionHandler)return P.reactionHandler(F,d(E))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,typeof f=="object"?((0,m.$AG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=f.resolved,this.b.applicability=f.applicability):this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,D,b,k,E,P,I,F){this.m=D,this.n=b,this.o=k,this.p=E,this.q=P,this.extensionDescription=I,this.r=F,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$be,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Vc,this.l.value=new A.$Tc,this.n===void 0&&(this.n=`${f}.${this.handle}`),c.$createCommentThread(D,this.handle,this.n,this.o,S.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{c.$deleteCommentThread(D,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(z){j.range=z},get comments(){return j.comments},set comments(z){j.comments=z},get collapsibleState(){return j.collapsibleState},set collapsibleState(z){j.collapsibleState=z},get canReply(){return j.canReply},set canReply(z){j.canReply=z},get contextValue(){return j.contextValue},set contextValue(z){j.contextValue=z},get label(){return j.label},set label(z){j.label=z},get state(){return j.state},set state(z){j.state=z},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Tc);const f=b=>Object.prototype.hasOwnProperty.call(this.b,b),D={};f("range")&&(D.range=S.Range.from(this.p)),f("label")&&(D.label=this.label),f("contextValue")&&(D.contextValue=this.contextValue??null),f("comments")&&(D.comments=this.q.map(b=>r(this,b,this.k,this.extensionDescription))),f("collapsibleState")&&(D.collapseState=a(this.g)),f("canReply")&&(D.canReply=this.canReply),f("state")&&(D.state=h(this.h)),f("applicability")&&(D.applicability=o(this.h)),f("isTemplate")&&(D.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(f){for(const D of this.k){const b=D[0],k=D[1];if(f===k)return b}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Qe([(0,N.$Wh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class s{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,f?.resourceHints&&(0,m.$AG)(this.h,"commentingRangeHint"),c.$updateCommentingRanges(this.handle,f?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,m.$AG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,m.$AG)(this.h,"activeComment"),this.f}constructor(f,D,b,k){this.h=f,this.i=D,this.j=b,this.k=k,this.a=new Map,c.$registerCommentController(this.handle,b,k,this.h.identifier.value);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(P){E.options=P},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(P){E.commentingRangeProvider=P},get reactionHandler(){return E.reactionHandler},set reactionHandler(P){E.reactionHandler=P},get activeCommentThread(){return E.activeCommentThread},createCommentThread(P,I,F){return E.createCommentThread(P,I,F).value},dispose:()=>{E.dispose()}}),this.g=[],this.g.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(f,D,b){D===void 0&&(0,m.$AG)(this.h,"fileComments");const k=new i(this.id,this.handle,void 0,f,D,b,this.h,!1);return this.a.set(k.handle,k),k}$setActiveComment(f){if(!f){this.e=void 0,this.f=void 0;return}const D=this.a.get(f.commentThreadHandle);D&&(this.e=f.uniqueIdInThread?D.getCommentByUniqueId(f.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(f,D){const b=new i(this.id,this.handle,void 0,R.URI.revive(f),S.Range.to(D),[],this.h,!0);return b.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this.a.set(b.handle,b),b}$updateCommentThreadTemplate(f,D){const b=this.a.get(f);b&&(b.range=S.Range.to(D))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.g.forEach(f=>f.dispose())}}function r(p,f,D,b){let k=D.get(f);return k||(k=++p.commentHandle,D.set(f,k)),f.state!==void 0&&(0,m.$AG)(b,"commentsDraftState"),f.reactions?.some(E=>E.reactors!==void 0)&&(0,m.$AG)(b,"commentReactor"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:k,body:typeof f.body=="string"?f.body:S.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(E=>t(E)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function t(p){return{label:p.label,iconPath:p.iconPath?S.$eP(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(f=>f.name):p.reactors}}function d(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?R.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(f=>({name:f}))}}function a(p){if(p!==void 0)switch(p){case L.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function h(p){let f;if(typeof p=="object"?f=p.resolved:f=p,f!==void 0)switch(f){case L.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}function o(p){let f;if(typeof p=="object"&&(f=p.applicability),f!==void 0)switch(f){case L.CommentThreadApplicability.Current:return w.CommentThreadApplicability.Current;case L.CommentThreadApplicability.Outdated:return w.CommentThreadApplicability.Outdated}return w.CommentThreadApplicability.Current}return new n}}),define(ke[331],Se([1,0,22,56,3,15,23,2,16,92,111,6,7]),function(le,e,u,N,M,A,R,w,$,S,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;class y{constructor(d,a){this.document=d,this.b=a,this.a=1,this.c=new L.$zkc("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,a){await this.f(d).undo(),a||this.disposeBackup()}async redo(d,a){await this.f(d).redo(),a||this.disposeBackup()}disposeEdits(d){for(const a of d)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=r(this.document.uri)+this.a++;return(0,R.$5g)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const a=this.c.get(d,0);if(!a)throw new Error("No edit found");return a}}class v{constructor(){this.a=new Map}get(d,a){return this.a.get(this.b(d,a))}add(d,a,h){const o=this.b(d,a.uri);if(this.a.has(o))throw new Error(`Document already exists for viewType:${d} resource:${a.uri}`);const p=new y(a,h);return this.a.set(o,p),p}delete(d,a){const h=this.b(d,a.uri);this.a.delete(h)}b(d,a){return`${d}@@@${a}`}}var l;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(l||(l={}));class g{constructor(){this.a=new Map}addTextProvider(d,a,h){return this.b(0,d,a,h)}addCustomProvider(d,a,h){return this.b(1,d,a,h)}get(d){return this.a.get(d)}b(d,a,h,o){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:d,extension:h,provider:o}),new m.$UM(()=>this.a.delete(a))}}class c{constructor(d,a,h,o,p){this.d=a,this.f=h,this.g=o,this.h=p,this.b=new g,this.c=new v,this.a=d.getProxy(C.$SM.MainThreadCustomEditors)}registerCustomEditorProvider(d,a,h,o){const p=new M.$Tc;return i(h)?(p.add(this.b.addTextProvider(a,d,h)),this.a.$registerTextEditorProvider((0,S.$9kc)(d),a,o.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,S.$7kc)(d))):(p.add(this.b.addCustomProvider(a,d,h)),n(h)&&p.add(h.onDidChangeCustomDocument(f=>{const D=this.i(a,f.document.uri);if(s(f)){const b=D.addEdit(f);this.a.$onDidEdit(f.document.uri,a,b,f.label)}else this.a.$onContentChange(f.document.uri,a)})),this.a.$registerCustomEditorProvider((0,S.$9kc)(d),a,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,S.$7kc)(d))),m.$UM.from(p,new m.$UM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(d,a,h,o,p){const f=this.b.get(a);if(!f)throw new Error(`No provider found for '${a}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${a}'`);const D=w.URI.revive(d),b=await f.provider.openCustomDocument(D,{backupId:h,untitledDocumentData:o?.buffer},p);let k;return n(f.provider)&&this.f&&(k=this.f.workspaceValue(f.extension)??this.f.globalValue(f.extension)),this.c.add(a,b,k),{editable:n(f.provider)}}async $disposeCustomDocument(d,a){const h=this.b.get(a);if(!h)throw new Error(`No provider found for '${a}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${a}'`);const o=w.URI.revive(d),{document:p}=this.i(a,o);this.c.delete(a,p),p.dispose()}async $resolveCustomEditor(d,a,h,o,p,f){const D=this.b.get(h);if(!D)throw new Error(`No provider found for '${h}'`);const b=$.ViewColumn.to(p),k=this.g.createNewWebview(a,o.contentOptions,D.extension),E=this.h.createNewWebviewPanel(a,h,o.title,b,o.options,k,o.active),P=w.URI.revive(d);switch(D.type){case 1:{const{document:I}=this.i(h,P);return D.provider.resolveCustomEditor(I,E,f)}case 0:{const I=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(I,E,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,a,h){this.i(a,d).disposeEdits(h)}async $onMoveCustomEditor(d,a,h){const o=this.b.get(h);if(!o)throw new Error(`No provider found for '${h}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const p=this.h.getWebviewPanel(d);if(!p)throw new Error("No webview found");const f=w.URI.revive(a),D=this.d.getDocument(f);await o.provider.moveCustomTextEditor(D,p,u.CancellationToken.None)}async $undo(d,a,h,o){return this.i(a,d).undo(h,o)}async $redo(d,a,h,o){return this.i(a,d).redo(h,o)}async $revert(d,a,h){const o=this.i(a,d);await this.j(a).revertCustomDocument(o.document,h),o.disposeBackup()}async $onSave(d,a,h){const o=this.i(a,d);await this.j(a).saveCustomDocument(o.document,h),o.disposeBackup()}async $onSaveAs(d,a,h,o){const p=this.i(a,d);return this.j(a).saveCustomDocumentAs(p.document,w.URI.revive(h),o)}async $backup(d,a,h){const o=this.i(a,d),f=await this.j(a).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},h);return o.updateBackup(f),f.id}i(d,a){const h=this.c.get(d,w.URI.revive(a));if(!h)throw new Error("No custom document found");return h}j(d){const h=this.b.get(d)?.provider;if(!h||!n(h))throw new Error("Custom document is not editable");return h}}e.$_kc=c;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function r(t){const d=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,N.$fj)(d)+""}}),define(ke[332],Se([1,0,218,138,2,6,7,16,4,12,27,60]),function(le,e,u,N,M,A,R,w,$,S,L,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=e.$Gkc=void 0;class y{#e;#t;#i;constructor(g,c,n,i,s,r,t,d){this.d=g,this.e=c,this.f=n,this.g=i,this.h=s,this.c=!1,this.f=Math.max(i,n),this.#i=new L.$Bc(a=>r.getComparisonKey(a)),this.#e=t,this.#t=d}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(g,c){if(!g){this.clear();return}this.j();let n=[];if(M.URI.isUri(g)){if(!c){this.delete(g);return}this.#i.set(g,c.slice()),n=[g]}else if(Array.isArray(g)){n=[];let r;g=[...g].sort(y.k);for(const t of g){const[d,a]=t;if((!r||d.toString()!==r.toString())&&(r&&this.#i.get(r).length===0&&this.#i.delete(r),r=d,n.push(d),this.#i.set(d,[])),a)this.#i.get(d)?.push(...a);else{const h=this.#i.get(d);h&&(h.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let s=0;for(const r of n){let t=[];const d=this.#i.get(r);if(d)if(d.length>this.g){t=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(const o of d)if(o.severity===a[h]&&t.push({...w.Diagnostic.from(o),modelVersionId:this.h(r)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,u.localize)(0,null,d.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=d.map(a=>({...w.Diagnostic.from(a),modelVersionId:this.h(r)}));if(i.push([r,t]),s+=t.length,s>this.f)break}this.#e.$changeMany(this.e,i)}delete(g){this.j(),this.#t.fire([g]),this.#i.delete(g),this.#e?.$changeMany(this.e,[[g,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(g,c){this.j();for(const[n,i]of this)g.call(c,n,i,this)}*[Symbol.iterator](){this.j();for(const g of this.#i.keys())yield[g,this.get(g)]}get(g){this.j();const c=this.#i.get(g);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(g){return this.j(),Array.isArray(this.#i.get(g))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(g,c){return g[0].toString()<c[0].toString()?-1:g[0].toString()>c[0].toString()?1:0}}e.$Gkc=y;let v=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(g){const c=new L.$Bc;for(const n of g)c.set(n,n);return{uris:Object.freeze(Array.from(c.values()))}}constructor(g,c,n,i){this.j=c,this.k=n,this.l=i,this.g=new Map,this.h=new $.$fe({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=g.getProxy(A.$SM.MainThreadDiagnostics)}createDiagnosticCollection(g,c){const{g:n,f:i,h:s,j:r,k:t,l:d}=this,a=new class{$changeMany(p,f){i.$changeMany(p,f),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,p,f.length===0?"CLEARING":f)}$clear(p){i.$clear(p),r.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,p)}dispose(){i.dispose()}};let h;if(!c)c="_generated_diagnostic_collection_name_#"+m.c++,h=c;else if(!n.has(c))h=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do h=c+m.c++;while(n.has(h))}return new class extends y{constructor(){super(c,h,m.e,m.d,p=>d.getDocument(p)?.version,t.extUri,a,s),n.set(h,this)}dispose(){super.dispose(),n.delete(h)}}}getDiagnostics(g){if(g)return this.m(g);{const c=new Map,n=[];for(const i of this.g.values())i.forEach((s,r)=>{let t=c.get(s.toString());typeof t>"u"&&(t=n.length,c.set(s.toString(),t),n.push([s,[]])),n[t][1]=n[t][1].concat(...r)});return n}}m(g){let c=[];for(const n of this.g.values())n.has(g)&&(c=c.concat(n.get(g)));return c}$acceptMarkersChange(g){if(!this.n){const c="_generated_mirror",n=new y(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(c,n),this.n=n}for(const[c,n]of g)this.n.set(M.URI.revive(c),n.map(w.Diagnostic.to))}};e.$Hkc=v,e.$Hkc=v=m=Qe([Ve(1,S.$Xj),Ve(2,C.$Fkc)],v)}),define(ke[333],Se([1,0,2,13,7,16,75,48]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=void 0;class ${constructor(L,C,m,y={timeout:1500,errors:3}){this.c=L,this.d=C,this.f=m,this.g=y,this.a=new R.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(L){return(C,m,y)=>{const l={dispose:this.a.push([C,m,L])};return Array.isArray(y)&&y.push(l),l}}async $participateInSave(L,C){const m=u.URI.revive(L);let y=!1;const v=setTimeout(()=>y=!0,this.g.timeout),l=[];try{for(const g of[...this.a]){if(y)break;const c=this.d.getDocument(m),n=await this.h(g,{document:c,reason:A.TextDocumentSaveReason.to(C)});l.push(n)}}finally{clearTimeout(v)}return l}h([L,C,m],y){const v=this.b.get(L);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(m,L,C,y).then(()=>!0,l=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' threw ERROR`),this.c.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const g=this.b.get(L);this.b.set(L,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(L,C,m,y){const v=[],l=Date.now(),{document:g,reason:c}=y,{version:n}=g,i=Object.freeze({document:g,reason:c,waitUntil(s){if(Object.isFrozen(v))throw(0,N.$8)("waitUntil can not be called async");v.push(Promise.resolve(s))}});try{C.apply(m,[i])}catch(s){return Promise.reject(s)}return Object.freeze(v),new Promise((s,r)=>{const t=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(v).then(d=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${L.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(t),s(d)}).catch(d=>{clearTimeout(t),r(d)})}).then(s=>{const r={edits:[]};for(const t of s)if(Array.isArray(t)&&t.every(d=>d instanceof M.$2M))for(const{newText:d,newEol:a,range:h}of t)r.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:h&&A.Range.from(h),text:d,eol:a&&A.EndOfLine.from(a)}});if(r.edits.length!==0)return n===g.version?this.f.$tryApplyWorkspaceEdit(new w.$ow(r)):Promise.reject(new Error("concurrent_edits"))})}}e.$Plc=$}),define(ke[334],Se([1,0,4,3,2,6,152,16,18,24,7]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=void 0;class C{constructor(y,v){this.a=new u.$be,this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=y.getProxy(A.$SM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(l=>{for(const g of l)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const g of l)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(y){if(!y)return;const v=this.g.getDocument(y);if(v)return v}getDocument(y){const v=this.getDocumentData(y);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return v.document}ensureDocumentData(y){const v=this.g.getDocument(y);if(v)return Promise.resolve(v);let l=this.h.get(y.toString());return l||(l=this.f.$tryOpenDocument(y).then(g=>{this.h.delete(y.toString());const c=M.URI.revive(g);return(0,$.$dg)(this.g.getDocument(c))},g=>(this.h.delete(y.toString()),Promise.reject(g))),this.h.set(y.toString(),l)),l}createDocumentData(y){return this.f.$tryCreateDocument(y).then(v=>M.URI.revive(v))}$acceptModelLanguageChanged(y,v){const l=M.URI.revive(y),g=this.g.getDocument(l);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(v),this.a.fire(g.document)}$acceptModelSaved(y){const v=M.URI.revive(y),l=this.g.getDocument(v);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(y,v){const l=M.URI.revive(y),g=this.g.getDocument(l);if(!g)throw new Error("unknown document");g._acceptIsDirty(v),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,v,l){const g=M.URI.revive(y),c=this.g.getDocument(g);if(!c)throw new Error("unknown document");c._acceptIsDirty(l),c.onEvents(v);let n;v.isUndoing?n=L.TextDocumentChangeReason.Undo:v.isRedoing&&(n=L.TextDocumentChangeReason.Redo),this.c.fire((0,S.$Yn)({document:c.document,contentChanges:v.changes.map(i=>({range:w.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(y,v){(0,R.$hP)(y,v)}}e.$Ikc=C}),define(ke[71],Se([1,0,73,4,18,2,5,6,20,16,7]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=e.$alc=void 0,e.$alc=(0,R.$ri)("IExtHostEditorTabs");class C{constructor(g,c,n){this.e=n,this.d=c,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,c={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new L.$EO(A.URI.revive(this.b.input.uri));case 2:return new L.$FO(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new L.$GO(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new L.$HO(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new L.$IO(this.b.input.viewType);case 4:return new L.$JO(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new L.$KO(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new L.$LO;case 9:return new L.$MO(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new L.$NO;case 11:return new L.$OO(this.b.input.diffEditors.map(g=>new L.$FO(A.URI.revive(g.original),A.URI.revive(g.modified))));default:return}}}class m{constructor(g,c){this.c=[],this.d="",this.b=g,this.e=c;for(const n of g.tabs)n.isActive&&(this.d=n.id),this.c.push(new C(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,c={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return S.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(n=>n.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(n=>n.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const n=new C(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,n),g.tabDto.isActive&&(this.d=n.tabId),n}else if(g.kind===1){const n=this.c.splice(g.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(g.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,n),n}const c=this.c.find(n=>n.tabId===g.tabDto.id);if(!c)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(g.tabDto),c}activeTabId(){return this.d}}let y=class{constructor(g){this.b=new N.$be,this.c=new N.$be,this.e=[],this.a=g.getProxy(w.$SM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,c={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(n=>n.apiObject))},get activeTabGroup(){const n=g.d;return(0,M.$dg)(g.e.find(s=>s.groupId===n)?.apiObject)},close:async(n,i)=>{const s=Array.isArray(n)?n:[n];return s.length?v(s[0])?this.j(s,i):this.i(s,i):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(g){const c=new Set(this.e.map(a=>a.groupId)),n=new Set(g.map(a=>a.groupId)),i=(0,u.$L)(c,n),s=this.e.filter(a=>i.removed.includes(a.groupId)).map(a=>a.apiObject),r=[],t=[];this.e=g.map(a=>{const h=new m(a,()=>this.d);return i.added.includes(h.groupId)?r.push(h.apiObject):t.push(h.apiObject),h});const d=(0,M.$dg)(g.find(a=>a.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:r,closed:s,changed:t}))}$acceptTabGroupUpdate(g){const c=this.e.find(n=>n.groupId===g.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const c=this.e.find(i=>i.groupId===g.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const n=c.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(g){for(const c of this.e)for(const n of c.tabs)if(n.apiObject===g)return n}h(g){return this.e.find(c=>c.apiObject===g)}async i(g,c){const n=[];for(const i of g){const s=this.g(i);if(!s)throw new Error("Tab close: Invalid tab not found!");n.push(s.tabId)}return this.a.$closeTab(n,c)}async j(g,c){const n=[];for(const i of g){const s=this.h(i);if(!s)throw new Error("Group close: Invalid group not found!");n.push(s.groupId)}return this.a.$closeGroup(n,c)}};e.$blc=y,e.$blc=y=Qe([Ve(0,$.$fP)],y);function v(l){return l.tabs!==void 0}}),define(ke[335],Se([1,0,2,6,3,7,16,180,14,21,26,80]),function(le,e,u,N,M,A,R,w,$,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=void 0;class m{constructor(){this.a=[]}add(l){this.b=void 0,this.a.push(l)}delete(l){const g=this.a.indexOf(l);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const l=this.a.sort(),g=[];let c,n,i=14,s=14;for(const r of l){let t=c?(0,$.$wf)(c,r):0;for(t===0?n=1:n=s;t<r.length;t++)t+1===r.length?(i=s,s=9):s+=1,g.push([n,r.toUpperCase().charCodeAt(t),s]),g.push([n,r.toLowerCase().charCodeAt(t),s]),n=s;c=r,s=i}g.push([9,58,10]),g.push([10,47,12]),this.b=new w.$62(g)}}provideDocumentLinks(l){this.c();const g=[],c=w.$72.computeLinks({getLineContent(n){return l.lineAt(n-1).text},getLineCount(){return l.lineCount}},this.b);for(const n of c){const i=R.DocumentLink.to(n);i.target&&g.push(i)}return g}}class y{constructor(l,g){this.i=g,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=l.getProxy(N.$SM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(l,g,c,n={}){if(y.j(c),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(l,"*",this.b));const i=this.h++;this.b.add(g),this.d.add(g),this.c.set(i,c);let s=2;n.isCaseSensitive&&(s+=1024),n.isReadonly&&(s+=2048),typeof c.copy=="function"&&(s+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,L.$AG)(l,"fsChunks"),s+=4);let r;n.isReadonly&&(0,C.$Qk)(n.isReadonly)&&n.isReadonly.value!==""&&(r={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,g,s,r).catch(d=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${g}`),console.error(d)});const t=c.onDidChangeFile(d=>{const a=[];for(const h of d){const{uri:o,type:p}=h;if(o.scheme!==g)continue;let f;switch(p){case A.FileChangeType.Changed:f=0;break;case A.FileChangeType.Created:f=1;break;case A.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:o,type:f})}this.a.$onFileSystemChange(i,a)});return(0,M.$Sc)(()=>{t.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static k(l){const{type:g,ctime:c,mtime:n,size:i,permissions:s}=l;return{type:g,ctime:c,mtime:n,size:i,permissions:s}}$stat(l,g){return Promise.resolve(this.l(l).stat(u.URI.revive(g))).then(c=>y.k(c))}$readdir(l,g){return Promise.resolve(this.l(l).readDirectory(u.URI.revive(g)))}$readFile(l,g){return Promise.resolve(this.l(l).readFile(u.URI.revive(g))).then(c=>S.$Ce.wrap(c))}$writeFile(l,g,c,n){return Promise.resolve(this.l(l).writeFile(u.URI.revive(g),c.buffer,n))}$delete(l,g,c){return Promise.resolve(this.l(l).delete(u.URI.revive(g),c))}$rename(l,g,c,n){return Promise.resolve(this.l(l).rename(u.URI.revive(g),u.URI.revive(c),n))}$copy(l,g,c,n){const i=this.l(l);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(u.URI.revive(g),u.URI.revive(c),n))}$mkdir(l,g){return Promise.resolve(this.l(l).createDirectory(u.URI.revive(g)))}$watch(l,g,c,n){const i=this.l(l).watch(u.URI.revive(c),n);this.f.set(g,i)}$unwatch(l,g){const c=this.f.get(g);c&&(c.dispose(),this.f.delete(g))}$open(l,g,c){const n=this.l(l);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(u.URI.revive(g),c))}$close(l,g){const c=this.l(l);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(g))}$read(l,g,c,n){const i=this.l(l);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const s=S.$Ce.alloc(n);return Promise.resolve(i.read(g,c,s.buffer,0,n)).then(r=>s.slice(0,r))}$write(l,g,c,n){const i=this.l(l);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(g,c,n.buffer,0,n.byteLength))}l(l){const g=this.c.get(l);if(!g){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return g}}e.$Rlc=y}),define(ke[336],Se([1,0,4,35,2,6,16,7,46]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=void 0;class S{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,v,l,g,c,n){this.a=Math.random(),this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$lk)(c),s=typeof c=="string",r=n?.correlate,t=g(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(r&&typeof d.session>"u")){if(!n?.ignoreCreateEvents)for(const a of d.created){const h=M.URI.revive(a);i(h.fsPath)&&(!s||v.getWorkspaceFolder(h))&&this.b.fire(h)}if(!n?.ignoreChangeEvents)for(const a of d.changed){const h=M.URI.revive(a);i(h.fsPath)&&(!s||v.getWorkspaceFolder(h))&&this.c.fire(h)}if(!n?.ignoreDeleteEvents)for(const a of d.deleted){const h=M.URI.revive(a);i(h.fsPath)&&(!s||v.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=w.$UM.from(this.i(y,l,c,n,n?.correlate),this.b,this.c,this.d,t)}i(y,v,l,g,c){const n=w.$UM.from();if(typeof l=="string"||g?.ignoreChangeEvents&&g?.ignoreCreateEvents&&g?.ignoreDeleteEvents)return n;const i=y.getProxy(A.$SM.MainThreadFileSystemEventService);let s=!1;(l.pattern.includes(N.$hk)||l.pattern.includes(N.$ik))&&(s=!0);let r;return c&&(g?.ignoreChangeEvents||g?.ignoreCreateEvents||g?.ignoreDeleteEvents)&&(r=14,g?.ignoreChangeEvents&&(r&=-3),g?.ignoreCreateEvents&&(r&=-5),g?.ignoreDeleteEvents&&(r&=-9)),i.$watch(v.identifier.value,this.a,l.baseUri,{recursive:s,excludes:g?.excludes??[],filter:r},!!c),w.$UM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class L{constructor(y){this.a=y,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(M.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(y,v,l){this.j=y,this.k=v,this.l=l,this.a=new u.$be,this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.g=new u.$de,this.h=new u.$de,this.i=new u.$de,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,v,l,g){return new S(this.j,y,v,this.a.event,R.GlobPattern.from(l),g)}$onFileEvent(y){this.a.fire(new L(y))}$onDidRunFileOperation(y,v){switch(y){case 2:this.b.fire(Object.freeze({files:v.map(l=>({oldUri:M.URI.revive(l.source),newUri:M.URI.revive(l.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(l=>M.URI.revive(l.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(l=>M.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,v){return(l,g,c)=>{const n=function(s){l.call(g,s)};return n.extension=y,v.event(n,void 0,c)}}async $onWillRunFileOperation(y,v,l,g){switch(y){case 2:return await this.n(this.g,{files:v.map(c=>({oldUri:M.URI.revive(c.source),newUri:M.URI.revive(c.target)}))},l,g);case 1:return await this.n(this.i,{files:v.map(c=>M.URI.revive(c.target))},l,g);case 0:case 3:return await this.n(this.h,{files:v.map(c=>M.URI.revive(c.target))},l,g)}}async n(y,v,l,g){const c=new Set,n=[];if(await y.fireAsync(v,g,async(s,r)=>{const t=Date.now(),d=await Promise.resolve(s);d instanceof w.$5M&&(n.push([r.extension,d]),c.add(r.extension.displayName??r.extension.identifier.value)),Date.now()-t>l&&this.k.warn("SLOW file-participant",r.extension.identifier)}),g.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,s]of n){const{edits:r}=R.WorkspaceEdit.from(s,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(r)}return{edit:i,extensionNames:Array.from(c)}}}e.$Slc=C}),define(ke[337],Se([1,0,19,8,22,13,124,3,24,40,14,18,2,29,176,83,134,220,25,16,7,26,111,6]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s,r,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=void 0;class a{constructor(V,q){this.d=V,this.e=q}async provideDocumentSymbols(V,q){const Q=this.d.getDocument(V),J=await this.e.provideDocumentSymbols(Q,q);if(!(0,u.$Kb)(J))return J[0]instanceof s.$bN?J.map(i.DocumentSymbol.from):a.f(J)}static f(V){V=V.slice(0).sort((J,he)=>{let pe=J.location.range.start.compareTo(he.location.range.start);return pe===0&&(pe=he.location.range.end.compareTo(J.location.range.end)),pe});const q=[],Q=[];for(const J of V){const he={name:J.name||"!!MISSING: name!!",kind:i.SymbolKind.from(J.kind),tags:J.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:i.Range.from(J.location.range),selectionRange:i.Range.from(J.location.range),children:[]};for(;;){if(Q.length===0){Q.push(he),q.push(he);break}const pe=Q[Q.length-1];if(y.$nt.containsRange(pe.range,he.range)&&!y.$nt.equalsRange(pe.range,he.range)){pe.children?.push(he),Q.push(he);break}Q.pop()}}return q}}class h{constructor(V,q,Q,J,he,pe){this.f=V,this.g=q,this.h=Q,this.j=J,this.k=he,this.l=pe,this.d=new t.$zkc("CodeLens"),this.e=new Map}async provideCodeLenses(V,q){const Q=this.f.getDocument(V),J=await this.h.provideCodeLenses(Q,q);if(!J||q.isCancellationRequested)return;const he=this.d.add(J),pe=new w.$Tc;this.e.set(he,pe);const ze={cacheId:he,lenses:[]};for(let qe=0;qe<J.length;qe++)ze.lenses.push({cacheId:[he,qe],range:i.Range.from(J[qe].range),command:this.g.toInternal(J[qe].command,pe)});return ze}async resolveCodeLens(V,q){const Q=V.cacheId&&this.d.get(...V.cacheId);if(!Q)return;let J;if(typeof this.h.resolveCodeLens!="function"||Q.isResolved?J=Q:J=await this.h.resolveCodeLens(Q,q),J||(J=Q),q.isCancellationRequested)return;const he=V.cacheId&&this.e.get(V.cacheId[0]);if(he){if(!J.command){const pe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,pe),this.l.error(pe);return}return V.command=this.g.toInternal(J.command,he),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function o(Te){return Array.isArray(Te)?Te.map(i.DefinitionLink.from):Te?[i.DefinitionLink.from(Te)]:[]}class p{constructor(V,q){this.d=V,this.e=q}async provideDefinition(V,q,Q){const J=this.d.getDocument(V),he=i.Position.to(q),pe=await this.e.provideDefinition(J,he,Q);return o(pe)}}class f{constructor(V,q){this.d=V,this.e=q}async provideDeclaration(V,q,Q){const J=this.d.getDocument(V),he=i.Position.to(q),pe=await this.e.provideDeclaration(J,he,Q);return o(pe)}}class D{constructor(V,q){this.d=V,this.e=q}async provideImplementation(V,q,Q){const J=this.d.getDocument(V),he=i.Position.to(q),pe=await this.e.provideImplementation(J,he,Q);return o(pe)}}class b{constructor(V,q){this.d=V,this.e=q}async provideTypeDefinition(V,q,Q){const J=this.d.getDocument(V),he=i.Position.to(q),pe=await this.e.provideTypeDefinition(J,he,Q);return o(pe)}}class k{constructor(V,q){this.d=V,this.e=q}async provideHover(V,q,Q){const J=this.d.getDocument(V),he=i.Position.to(q),pe=await this.e.provideHover(J,he,Q);if(!(!pe||(0,u.$Kb)(pe.contents)))return pe.range||(pe.range=J.getWordRangeAtPosition(he)),pe.range||(pe.range=new s.$WM(he,he)),i.Hover.from(pe)}}class E{constructor(V,q){this.d=V,this.e=q}async provideEvaluatableExpression(V,q,Q){const J=this.d.getDocument(V),he=i.Position.to(q),pe=await this.e.provideEvaluatableExpression(J,he,Q);if(pe)return i.EvaluatableExpression.from(pe)}}class P{constructor(V,q){this.d=V,this.e=q}async provideInlineValues(V,q,Q,J){const he=this.d.getDocument(V),pe=await this.e.provideInlineValues(he,i.Range.to(q),i.InlineValueContext.to(Q),J);if(Array.isArray(pe))return pe.map(ze=>i.InlineValue.from(ze))}}class I{constructor(V,q){this.d=V,this.e=q}async provideDocumentHighlights(V,q,Q){const J=this.d.getDocument(V),he=i.Position.to(q),pe=await this.e.provideDocumentHighlights(J,he,Q);if(Array.isArray(pe))return pe.map(i.DocumentHighlight.from)}}class F{constructor(V,q){this.d=V,this.e=q}async provideMultiDocumentHighlights(V,q,Q,J){const he=this.d.getDocument(V),pe=Q.map(Ye=>this.d.getDocument(Ye)),ze=i.Position.to(q),qe=await this.e.provideMultiDocumentHighlights(he,ze,pe,J);if(Array.isArray(qe))return qe.map(i.MultiDocumentHighlight.from)}}class j{constructor(V,q){this.d=V,this.e=q}async provideLinkedEditingRanges(V,q,Q){const J=this.d.getDocument(V),he=i.Position.to(q),pe=await this.e.provideLinkedEditingRanges(J,he,Q);if(pe&&Array.isArray(pe.ranges))return{ranges:(0,u.$Hb)(pe.ranges.map(i.Range.from)),wordPattern:pe.wordPattern}}}class z{constructor(V,q){this.d=V,this.e=q}async provideReferences(V,q,Q,J){const he=this.d.getDocument(V),pe=i.Position.to(q),ze=await this.e.provideReferences(he,pe,Q,J);if(Array.isArray(ze))return ze.map(i.location.from)}}class O{static{this.d=1e3}constructor(V,q,Q,J,he,pe,ze){this.g=V,this.h=q,this.j=Q,this.k=J,this.l=he,this.m=pe,this.n=ze,this.e=new t.$zkc("CodeAction"),this.f=new Map}async provideCodeActions(V,q,Q,J){const he=this.g.getDocument(V),pe=v.$pt.isISelection(q)?i.Selection.to(q):i.Range.to(q),ze=[];for(const st of this.j.getDiagnostics(V))if(pe.intersection(st.range)&&ze.push(st)>O.d)break;const qe={diagnostics:ze,only:Q.only?new s.$dN(Q.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Q.trigger)},Ye=await this.k.provideCodeActions(he,pe,qe,J);if(!(0,u.$Lb)(Ye)||J.isCancellationRequested)return;const it=this.e.add(Ye),ot=new w.$Tc;this.f.set(it,ot);const nt=[];for(let st=0;st<Ye.length;st++){const Ce=Ye[st];if(Ce)if(O.o(Ce))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:Ce.title,command:this.h.toInternal(Ce,ot)});else{qe.only&&(Ce.kind?qe.only.contains(Ce.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action is of kind '${Ce.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Ce.ranges??[];nt.push({cacheId:[it,st],title:Ce.title,command:Ce.command&&this.h.toInternal(Ce.command,ot),diagnostics:Ce.diagnostics&&Ce.diagnostics.map(i.Diagnostic.from),edit:Ce.edit&&i.WorkspaceEdit.from(Ce.edit,void 0),kind:Ce.kind&&Ce.kind.value,isPreferred:Ce.isPreferred,isAI:(0,r.$zG)(this.m,"codeActionAI")?Ce.isAI:!1,ranges:(0,r.$zG)(this.m,"codeActionRanges")?(0,u.$Hb)(Be.map(i.Range.from)):void 0,disabled:Ce.disabled?.reason})}}return{cacheId:it,actions:nt}}async resolveCodeAction(V,q){const[Q,J]=V,he=this.e.get(Q,J);if(!he||O.o(he))return{};if(!this.k.resolveCodeAction)return{};const pe=await this.k.resolveCodeAction(he,q)??he;let ze;pe.edit&&(ze=i.WorkspaceEdit.from(pe.edit,void 0));let qe;if(pe.command){const Ye=this.f.get(Q);Ye&&(qe=this.h.toInternal(pe.command,Ye))}return{edit:ze,command:qe}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class T{constructor(V,q,Q,J,he){this.e=V,this.f=q,this.g=Q,this.h=J,this.j=he,this.d=new t.$zkc("DocumentPasteEdit")}async prepareDocumentPaste(V,q,Q,J){if(!this.g.prepareDocumentPaste)return;const he=this.f.getDocument(V),pe=q.map(Ye=>i.Range.to(Ye)),ze=i.DataTransfer.toDataTransfer(Q,()=>{throw new A.$$});if(await this.g.prepareDocumentPaste(he,pe,ze,J),J.isCancellationRequested)return;const qe=Array.from(ze).filter(([,Ye])=>!(Ye instanceof s.$JN));return i.DataTransfer.from(qe)}async providePasteEdits(V,q,Q,J,he,pe){if(!this.g.provideDocumentPasteEdits)return[];const ze=this.f.getDocument(q),qe=Q.map(nt=>i.Range.to(nt)),Ye=i.DataTransfer.toDataTransfer(J,async nt=>(await this.e.$resolvePasteFileData(this.h,V,nt)).buffer),it=await this.g.provideDocumentPasteEdits(ze,qe,Ye,{only:he.only?new s.$ON(he.only):void 0,triggerKind:he.triggerKind},pe);if(!it||pe.isCancellationRequested)return[];const ot=this.d.add(it);return it.map((nt,st)=>({_cacheId:[ot,st],title:nt.title??(0,c.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(Ce=>Ce.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,q){const[Q,J]=V,he=this.d.get(Q,J);if(!he||!this.g.resolveDocumentPasteEdit)return{};const pe=await this.g.resolveDocumentPasteEdit(he,q)??he;return{additionalEdit:pe.additionalEdit?i.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class B{constructor(V,q){this.d=V,this.e=q}async provideDocumentFormattingEdits(V,q,Q){const J=this.d.getDocument(V),he=await this.e.provideDocumentFormattingEdits(J,q,Q);if(Array.isArray(he))return he.map(i.TextEdit.from)}}class W{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeFormattingEdits(V,q,Q,J){const he=this.d.getDocument(V),pe=i.Range.to(q),ze=await this.e.provideDocumentRangeFormattingEdits(he,pe,Q,J);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,q,Q,J){(0,C.$cg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const he=this.d.getDocument(V),pe=q.map(i.Range.to),ze=await this.e.provideDocumentRangesFormattingEdits(he,pe,Q,J);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class X{constructor(V,q){this.d=V,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,q,Q,J,he){const pe=this.d.getDocument(V),ze=i.Position.to(q),qe=await this.e.provideOnTypeFormattingEdits(pe,ze,Q,J,he);if(Array.isArray(qe))return qe.map(i.TextEdit.from)}}class Z{constructor(V,q){this.e=V,this.f=q,this.d=new t.$zkc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,q){const Q=await this.e.provideWorkspaceSymbols(V,q);if(!(0,u.$Lb)(Q))return{symbols:[]};const J=this.d.add(Q),he={cacheId:J,symbols:[]};for(let pe=0;pe<Q.length;pe++){const ze=Q[pe];if(!ze||!ze.name){this.f.warn("INVALID SymbolInformation",ze);continue}he.symbols.push({...i.WorkspaceSymbol.from(ze),cacheId:[J,pe]})}return he}async resolveWorkspaceSymbol(V,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const Q=this.d.get(...V.cacheId);if(Q){const J=await this.e.resolveWorkspaceSymbol(Q,q);return J&&(0,$.$1n)(V,i.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class Y{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,q,Q){this.d=V,this.e=q,this.f=Q}async provideRenameEdits(V,q,Q,J){const he=this.d.getDocument(V),pe=i.Position.to(q);try{const ze=await this.e.provideRenameEdits(he,pe,Q,J);return ze?i.WorkspaceEdit.from(ze):void 0}catch(ze){const qe=Y.g(ze);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(ze)}}async resolveRenameLocation(V,q,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(V),he=i.Position.to(q);try{const pe=await this.e.prepareRename(J,he,Q);let ze,qe;if(s.$WM.isRange(pe)?(ze=pe,qe=J.getText(pe)):(0,C.$7f)(pe)&&(ze=pe.range,qe=pe.placeholder),!ze||!qe)return;if(ze.start.line>he.line||ze.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(ze),text:qe}}catch(pe){const ze=Y.g(pe);return ze?{rejectReason:ze,range:void 0,text:void 0}:Promise.reject(pe)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class x{constructor(V,q,Q){this.d=V,this.e=q,this.f=Q}async provideNewSymbolNames(V,q,Q){const J=this.d.getDocument(V),he=i.Range.to(q);try{const pe=await this.e.provideNewSymbolNames(J,he,Q);return pe?pe.map(ze=>typeof ze=="string"?{newSymbolName:ze}:{newSymbolName:ze.newSymbolName,tags:ze.tags}):void 0}catch(pe){this.f.error(x.g(pe)??JSON.stringify(pe,null,"	"));return}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ne{constructor(V,q){this.resultId=V,this.tokens=q}}class ge{constructor(V,q){this.f=V,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,q,Q){const J=this.f.getDocument(V),he=q!==0?this.d.get(q):null;let pe=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,he.resultId,Q):await this.g.provideDocumentSemanticTokens(J,Q);return he&&this.d.delete(q),pe?(pe=ge.h(pe),this.o(ge.n(he,pe),pe)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return ge.j(V)?ge.k(V)?V:new s.$cO(new Uint32Array(V.data),V.resultId):ge.l(V)?ge.m(V)?V:new s.$eO(V.edits.map(q=>new s.$dO(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const q of V.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(V,q){if(!ge.j(q)||!V||!V.tokens)return q;const Q=V.tokens,J=Q.length,he=q.data,pe=he.length;let ze=0;const qe=Math.min(J,pe);for(;ze<qe&&Q[ze]===he[ze];)ze++;if(ze===J&&ze===pe)return new s.$eO([],q.resultId);let Ye=0;const it=qe-ze;for(;Ye<it&&Q[J-Ye-1]===he[pe-Ye-1];)Ye++;return new s.$eO([{start:ze,deleteCount:J-ze-Ye,data:he.subarray(ze,pe-Ye)}],q.resultId)}o(V,q){if(ge.j(V)){const Q=this.e++;return this.d.set(Q,new ne(V.resultId,V.data)),(0,g.$Mbb)({id:Q,type:"full",data:V.data})}if(ge.l(V)){const Q=this.e++;return ge.j(q)?this.d.set(Q,new ne(q.resultId,q.data)):this.d.set(Q,new ne(V.resultId)),(0,g.$Mbb)({id:Q,type:"delta",deltas:(V.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class ue{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeSemanticTokens(V,q,Q){const J=this.d.getDocument(V),he=await this.e.provideDocumentRangeSemanticTokens(J,i.Range.to(q),Q);return he?this.f(he):null}f(V){return(0,g.$Mbb)({id:0,type:"full",data:V.data})}}class ve{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,q,Q,J,he){this.f=V,this.g=q,this.h=Q,this.j=J,this.k=he,this.d=new t.$zkc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,q,Q,J){const he=this.f.getDocument(V),pe=i.Position.to(q),ze=he.getWordRangeAtPosition(pe)||new s.$WM(pe,pe),qe=ze.with({end:pe}),Ye=new S.$0d,it=await this.h.provideCompletionItems(he,pe,J,i.CompletionContext.to(Q));if(!it||J.isCancellationRequested)return;const ot=Array.isArray(it)?new s.$qN(it):it,nt=ve.supportsResolving(this.h)?this.d.add(ot.items):this.d.add([]),st=new w.$Tc;this.e.set(nt,st);const Ce=[],Be={x:nt,b:Ce,a:{replace:i.Range.from(ze),insert:i.Range.from(qe)},c:ot.isIncomplete||void 0,d:Ye.elapsed()};for(let Ge=0;Ge<ot.items.length;Ge++){const Ne=ot.items[Ge],Xe=this.l(Ne,[nt,Ge],qe,ze);Ce.push(Xe)}return Be}async resolveCompletionItem(V,q){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...V);if(!Q)return;const J=this.l(Q,V),he=await this.h.resolveCompletionItem(Q,q);if(!he)return;const pe=this.l(he,V);return(J.h!==pe.h||J.i!==pe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==pe.n||J.o!==pe.o||!(0,$.$2n)(J.p,pe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:pe.d,c:pe.c,l:pe.l,h:pe.h,i:pe.i,n:pe.n,o:pe.o,p:pe.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q,Q,J){const he=this.e.get(q[0]);if(!he)throw Error("DisposableStore is missing...");const pe=this.g.toInternal(V.command,he),ze={x:q,a:V.label,b:V.kind!==void 0?i.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(i.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:i.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(i.TextEdit.from),n:pe?.$ident,o:pe?.id,p:pe?.$ident?void 0:pe?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ze.h=V.textEdit.newText):typeof V.insertText=="string"?ze.h=V.insertText:V.insertText instanceof s.$6M&&(ze.h=V.insertText.value,ze.i|=4);let qe;return V.textEdit?qe=V.textEdit.range:V.range&&(qe=V.range),s.$WM.isRange(qe)?ze.j=i.Range.from(qe):qe&&(!Q?.isEqual(qe.inserting)||!J?.isEqual(qe.replacing))&&(ze.j={insert:i.Range.from(qe.inserting),replace:i.Range.from(qe.replacing)}),ze}}class te{async provideInlineCompletions(V,q,Q,J){}disposeCompletions(V){}handleDidShowCompletionItem(V,q,Q){}handlePartialAccept(V,q,Q,J){}}class U extends te{constructor(V,q,Q,J){super(),this.f=V,this.g=q,this.h=Q,this.j=J,this.d=new be,this.e=(0,r.$zG)(this.f,"inlineCompletionsAdditions"),this.k={[l.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[l.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$zG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,q,Q,J){const he=this.g.getDocument(V),pe=i.Position.to(q),ze=await this.h.provideInlineCompletionItems(he,pe,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},J);if(!ze||J.isCancellationRequested)return;const qe=Array.isArray(ze)?ze:ze.items,Ye=this.e?Array.isArray(ze)?[]:ze.commands||[]:[],it=this.e&&!Array.isArray(ze)?ze.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:qe}),items:qe.map((st,Ce)=>{let Be;st.command&&(ot||(ot=new w.$Tc),Be=this.j.toInternal(st.command,ot));const Ge=st.insertText;return{insertText:typeof Ge=="string"?Ge:{snippet:Ge.value},filterText:st.filterText,range:st.range?i.Range.from(st.range):void 0,command:Be,idx:Ce,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:Ye.map(st=>(ot||(ot=new w.$Tc),this.j.toInternal(st,ot))),suppressSuggestions:!1,enableForwardStability:it}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,q,Q){const J=this.d.get(V)?.items[q];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,Q)}handlePartialAccept(V,q,Q,J){const he=this.d.get(V)?.items[q];he&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(he,Q),this.h.handleDidPartiallyAcceptCompletionItem(he,i.PartialAcceptInfo.to(J)))}}class _{async provideInlineEdits(V,q,Q){const J=this.f.getDocument(V),he=await this.g.provideInlineEdit(J,{triggerKind:this.e[q.triggerKind]},Q);if(!he||Q.isCancellationRequested)return;let pe;const ze=this.d.createReferenceId({dispose(){pe?.dispose()},item:he});let qe;he.accepted&&(pe||(pe=new w.$Tc),qe=this.h.toInternal(he.accepted,pe));let Ye;return he.rejected&&(pe||(pe=new w.$Tc),Ye=this.h.toInternal(he.rejected,pe)),{pid:ze,text:he.text,range:i.Range.from(he.range),accepted:qe,rejected:Ye}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,q,Q,J){this.f=q,this.g=Q,this.h=J,this.d=new be,this.e={[l.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[l.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const q=this.e++;return this.d.set(q,V),q}disposeReferenceId(V){const q=this.d.get(V);return this.d.delete(V),q}get(V){return this.d.get(V)}}class Pe{constructor(V,q){this.e=V,this.f=q,this.d=new t.$zkc("SignatureHelp")}async provideSignatureHelp(V,q,Q,J){const he=this.e.getDocument(V),pe=i.Position.to(q),ze=this.g(Q),qe=await this.f.provideSignatureHelp(he,pe,J,ze);if(qe){const Ye=this.d.add([qe]);return{...i.SignatureHelp.from(qe),id:Ye}}}g(V){let q;if(V.activeSignatureHelp){const Q=i.SignatureHelp.to(V.activeSignatureHelp),J=this.d.get(V.activeSignatureHelp.id,0);J?(q=J,q.activeSignature=Q.activeSignature,q.activeParameter=Q.activeParameter):q=Q}return{...V,activeSignatureHelp:q}}releaseSignatureHelp(V){this.d.delete(V)}}class se{constructor(V,q,Q,J,he){this.f=V,this.g=q,this.h=Q,this.j=J,this.k=he,this.d=new t.$zkc("InlayHints"),this.e=new Map}async provideInlayHints(V,q,Q){const J=this.f.getDocument(V),he=i.Range.to(q),pe=await this.h.provideInlayHints(J,he,Q);if(!Array.isArray(pe)||pe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(Q.isCancellationRequested)return;const ze=this.d.add(pe);this.e.set(ze,new w.$Tc);const qe={hints:[],cacheId:ze};for(let Ye=0;Ye<pe.length;Ye++)this.l(pe[Ye],he)&&qe.hints.push(this.m(pe[Ye],[ze,Ye]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),qe}async resolveInlayHint(V,q){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...V);if(!Q)return;const J=await this.h.resolveInlayHint(Q,q);if(J&&this.l(J))return this.m(J,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q){return V.label.length===0||Array.isArray(V.label)&&V.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(q&&!q.contains(V.position))}m(V,q){const Q=this.e.get(q[0]);if(!Q)throw Error("DisposableStore is missing...");const J={label:"",cacheId:q,tooltip:i.MarkdownString.fromStrict(V.tooltip),position:i.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(i.TextEdit.from),kind:V.kind&&i.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")J.label=V.label;else{const he=[];J.label=he;for(const pe of V.label){if(!pe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ze={label:pe.value,tooltip:i.MarkdownString.fromStrict(pe.tooltip)};s.$7M.isLocation(pe.location)&&(ze.location=i.location.from(pe.location)),pe.command&&(ze.command=this.g.toInternal(pe.command,Q)),he.push(ze)}}return J}}class re{constructor(V,q){this.e=V,this.f=q,this.d=new t.$zkc("DocumentLink")}async provideLinks(V,q){const Q=this.e.getDocument(V),J=await this.f.provideDocumentLinks(Q,q);if(!(!Array.isArray(J)||J.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(re.g).map(i.DocumentLink.from)};{const he=this.d.add(J),pe={links:[],cacheId:he};for(let ze=0;ze<J.length;ze++){if(!re.g(J[ze]))continue;const qe=i.DocumentLink.from(J[ze]);qe.cacheId=[he,ze],pe.links.push(qe)}return pe}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,q){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...V);if(!Q)return;const J=await this.f.resolveDocumentLink(Q,q);if(!(!J||!re.g(J)))return i.DocumentLink.from(J)}releaseLinks(V){this.d.delete(V)}}class oe{constructor(V,q){this.d=V,this.e=q}async provideColors(V,q){const Q=this.d.getDocument(V),J=await this.e.provideDocumentColors(Q,q);return Array.isArray(J)?J.map(pe=>({color:i.Color.from(pe.color),range:i.Range.from(pe.range)})):[]}async provideColorPresentations(V,q,Q){const J=this.d.getDocument(V),he=i.Range.to(q.range),pe=i.Color.to(q.color),ze=await this.e.provideColorPresentations(pe,{document:J,range:he},Q);if(Array.isArray(ze))return ze.map(i.ColorPresentation.from)}}class K{constructor(V,q){this.d=V,this.e=q}async provideFoldingRanges(V,q,Q){const J=this.d.getDocument(V),he=await this.e.provideFoldingRanges(J,q,Q);if(Array.isArray(he))return he.map(i.FoldingRange.from)}}class ie{constructor(V,q,Q){this.d=V,this.e=q,this.f=Q}async provideSelectionRanges(V,q,Q){const J=this.d.getDocument(V),he=q.map(i.Position.to),pe=await this.e.provideSelectionRanges(J,he,Q);if(!(0,u.$Lb)(pe))return[];if(pe.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ze=[];for(let qe=0;qe<he.length;qe++){const Ye=[];ze.push(Ye);let it=he[qe],ot=pe[qe];for(;;){if(!ot.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(Ye.push(i.SelectionRange.from(ot)),!ot.parent)break;it=ot.range,ot=ot.parent}}return ze}}class $e{constructor(V,q){this.f=V,this.g=q,this.d=new R.$kP(""),this.e=new Map}async prepareSession(V,q,Q){const J=this.f.getDocument(V),he=i.Position.to(q),pe=await this.g.prepareCallHierarchy(J,he,Q);if(!pe)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(pe)?pe.map(qe=>this.h(ze,qe)):[this.h(ze,pe)]}async provideCallsTo(V,q,Q){const J=this.j(V,q);if(!J)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(J,Q);if(he)return he.map(pe=>({from:this.h(V,pe.from),fromRanges:pe.fromRanges.map(ze=>i.Range.from(ze))}))}async provideCallsFrom(V,q,Q){const J=this.j(V,q);if(!J)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(J,Q);if(he)return he.map(pe=>({to:this.h(V,pe.to),fromRanges:pe.fromRanges.map(ze=>i.Range.from(ze))}))}releaseSession(V){this.e.delete(V)}h(V,q){const Q=this.e.get(V),J=i.CallHierarchyItem.from(q,V,Q.size.toString(36));return Q.set(J._itemId,q),J}j(V,q){return this.e.get(V)?.get(q)}}class we{constructor(V,q){this.f=V,this.g=q,this.d=new R.$kP(""),this.e=new Map}async prepareSession(V,q,Q){const J=this.f.getDocument(V),he=i.Position.to(q),pe=await this.g.prepareTypeHierarchy(J,he,Q);if(!pe)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(pe)?pe.map(qe=>this.h(ze,qe)):[this.h(ze,pe)]}async provideSupertypes(V,q,Q){const J=this.j(V,q);if(!J)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(J,Q);if(he)return he.map(pe=>this.h(V,pe))}async provideSubtypes(V,q,Q){const J=this.j(V,q);if(!J)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(J,Q);if(he)return he.map(pe=>this.h(V,pe))}releaseSession(V){this.e.delete(V)}h(V,q){const Q=this.e.get(V),J=i.TypeHierarchyItem.from(q,V,Q.size.toString(36));return Q.set(J._itemId,q),J}j(V,q){return this.e.get(V)?.get(q)}}class Le{constructor(V,q,Q,J,he){this.e=V,this.f=q,this.g=Q,this.h=J,this.j=he,this.d=new t.$zkc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,q,Q,J,he){const pe=this.f.getDocument(q),ze=i.Position.to(Q),qe=i.DataTransfer.toDataTransfer(J,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,nt)).buffer),Ye=await this.g.provideDocumentDropEdits(pe,ze,qe,he);if(!Ye)return;const it=(0,u.$3b)(Ye),ot=this.d.add(it);return it.map((nt,st)=>({_cacheId:[ot,st],title:nt.title??(0,c.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(Ce=>Ce.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,q){const[Q,J]=V,he=this.d.get(Q,J);if(!he||!this.g.resolveDocumentDropEdit)return{};const pe=await this.g.resolveDocumentDropEdit(he,q)??he;return{additionalEdit:pe.additionalEdit?i.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class fe{constructor(V,q){this.d=V,this.e=q}async provideMappedEdits(V,q,Q,J){const he=m.URI.revive(V),pe=this.d.getDocument(he),ze=Q.documents.map(it=>it.map(ot=>({uri:m.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(nt=>i.Range.to(nt))}))),qe={documents:ze,selections:ze[0]?.[0]?.ranges??[]},Ye=await this.e.provideMappedEdits(pe,q,qe,J);return Ye?i.WorkspaceEdit.from(Ye):null}}class De{constructor(V,q){this.adapter=V,this.extension=q}}class Ie{static{this.d=0}constructor(V,q,Q,J,he,pe,ze,qe){this.g=q,this.h=Q,this.j=J,this.k=he,this.l=pe,this.m=ze,this.n=qe,this.f=new Map,this.e=V.getProxy(d.$SM.MainThreadLanguageFeatures)}o(V,q){return i.DocumentSelector.from(V,this.g,q)}p(V){return new s.$UM(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Ie.d++}async s(V,q,Q,J,he,pe=!1){const ze=this.f.get(V);if(!ze||!(ze.adapter instanceof q))return J;const qe=Date.now();pe||this.l.trace(`[${ze.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const Ye=Q(ze.adapter,ze.extension);return Promise.resolve(Ye).catch(it=>{(0,A.$4)(it)||(this.l.error(`[${ze.extension.identifier.value}] provider FAILED`),this.l.error(it),this.n.onExtensionError(ze.extension.identifier,it))}).finally(()=>{pe||this.l.trace(`[${ze.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),M.CancellationToken.isCancellationToken(he)?(0,N.$gh)(Ye,he):Ye}t(V,q){const Q=this.q();return this.f.set(Q,new De(V,q)),Q}static u(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,q,Q,J){const he=this.t(new a(this.h,Q),V),pe=J&&J.label||Ie.u(V);return this.e.$registerDocumentSymbolProvider(he,this.o(q,V),pe),this.p(he)}$provideDocumentSymbols(V,q,Q){return this.s(V,a,J=>J.provideDocumentSymbols(m.URI.revive(q),Q),void 0,Q)}registerCodeLensProvider(V,q,Q){const J=this.q(),he=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new De(new h(this.h,this.j.converter,Q,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(J,this.o(q,V),he);let pe=this.p(J);if(he!==void 0){const ze=Q.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(he));pe=s.$UM.from(pe,ze)}return pe}$provideCodeLenses(V,q,Q){return this.s(V,h,J=>J.provideCodeLenses(m.URI.revive(q),Q),void 0,Q)}$resolveCodeLens(V,q,Q){return this.s(V,h,J=>J.resolveCodeLens(q,Q),void 0,void 0)}$releaseCodeLenses(V,q){this.s(V,h,Q=>Promise.resolve(Q.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(V,q,Q){const J=this.t(new p(this.h,Q),V);return this.e.$registerDefinitionSupport(J,this.o(q,V)),this.p(J)}$provideDefinition(V,q,Q,J){return this.s(V,p,he=>he.provideDefinition(m.URI.revive(q),Q,J),[],J)}registerDeclarationProvider(V,q,Q){const J=this.t(new f(this.h,Q),V);return this.e.$registerDeclarationSupport(J,this.o(q,V)),this.p(J)}$provideDeclaration(V,q,Q,J){return this.s(V,f,he=>he.provideDeclaration(m.URI.revive(q),Q,J),[],J)}registerImplementationProvider(V,q,Q){const J=this.t(new D(this.h,Q),V);return this.e.$registerImplementationSupport(J,this.o(q,V)),this.p(J)}$provideImplementation(V,q,Q,J){return this.s(V,D,he=>he.provideImplementation(m.URI.revive(q),Q,J),[],J)}registerTypeDefinitionProvider(V,q,Q){const J=this.t(new b(this.h,Q),V);return this.e.$registerTypeDefinitionSupport(J,this.o(q,V)),this.p(J)}$provideTypeDefinition(V,q,Q,J){return this.s(V,b,he=>he.provideTypeDefinition(m.URI.revive(q),Q,J),[],J)}registerHoverProvider(V,q,Q,J){const he=this.t(new k(this.h,Q),V);return this.e.$registerHoverProvider(he,this.o(q,V)),this.p(he)}$provideHover(V,q,Q,J){return this.s(V,k,he=>he.provideHover(m.URI.revive(q),Q,J),void 0,J)}registerEvaluatableExpressionProvider(V,q,Q,J){const he=this.t(new E(this.h,Q),V);return this.e.$registerEvaluatableExpressionProvider(he,this.o(q,V)),this.p(he)}$provideEvaluatableExpression(V,q,Q,J){return this.s(V,E,he=>he.provideEvaluatableExpression(m.URI.revive(q),Q,J),void 0,J)}registerInlineValuesProvider(V,q,Q,J){const he=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,pe=this.t(new P(this.h,Q),V);this.e.$registerInlineValuesProvider(pe,this.o(q,V),he);let ze=this.p(pe);if(he!==void 0){const qe=Q.onDidChangeInlineValues(Ye=>this.e.$emitInlineValuesEvent(he));ze=s.$UM.from(ze,qe)}return ze}$provideInlineValues(V,q,Q,J,he){return this.s(V,P,pe=>pe.provideInlineValues(m.URI.revive(q),Q,J,he),void 0,he)}registerDocumentHighlightProvider(V,q,Q){const J=this.t(new I(this.h,Q),V);return this.e.$registerDocumentHighlightProvider(J,this.o(q,V)),this.p(J)}registerMultiDocumentHighlightProvider(V,q,Q){const J=this.t(new F(this.h,Q),V);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(q,V)),this.p(J)}$provideDocumentHighlights(V,q,Q,J){return this.s(V,I,he=>he.provideDocumentHighlights(m.URI.revive(q),Q,J),void 0,J)}$provideMultiDocumentHighlights(V,q,Q,J,he){return this.s(V,F,pe=>pe.provideMultiDocumentHighlights(m.URI.revive(q),Q,J.map(ze=>m.URI.revive(ze)),he),void 0,he)}registerLinkedEditingRangeProvider(V,q,Q){const J=this.t(new j(this.h,Q),V);return this.e.$registerLinkedEditingRangeProvider(J,this.o(q,V)),this.p(J)}$provideLinkedEditingRanges(V,q,Q,J){return this.s(V,j,async he=>{const pe=await he.provideLinkedEditingRanges(m.URI.revive(q),Q,J);if(pe)return{ranges:pe.ranges,wordPattern:pe.wordPattern?Ie.w(pe.wordPattern):void 0}},void 0,J)}registerReferenceProvider(V,q,Q){const J=this.t(new z(this.h,Q),V);return this.e.$registerReferenceSupport(J,this.o(q,V)),this.p(J)}$provideReferences(V,q,Q,J,he){return this.s(V,z,pe=>pe.provideReferences(m.URI.revive(q),Q,J,he),void 0,he)}registerCodeActionProvider(V,q,Q,J){const he=new w.$Tc,pe=this.t(new O(this.h,this.j.converter,this.k,Q,this.l,V,this.m),V);return this.e.$registerQuickFixSupport(pe,this.o(q,V),{providedKinds:J?.providedCodeActionKinds?.map(ze=>ze.value),documentation:J?.documentation?.map(ze=>({kind:ze.kind.value,command:this.j.converter.toInternal(ze.command,he)}))},Ie.u(V),!!Q.resolveCodeAction),he.add(this.p(pe)),he}$provideCodeActions(V,q,Q,J,he){return this.s(V,O,pe=>pe.provideCodeActions(m.URI.revive(q),Q,J,he),void 0,he)}$resolveCodeAction(V,q,Q){return this.s(V,O,J=>J.resolveCodeAction(q,Q),{},void 0)}$releaseCodeActions(V,q){this.s(V,O,Q=>Promise.resolve(Q.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(V,q,Q){const J=this.t(new B(this.h,Q),V);return this.e.$registerDocumentFormattingSupport(J,this.o(q,V),V.identifier,V.displayName||V.name),this.p(J)}$provideDocumentFormattingEdits(V,q,Q,J){return this.s(V,B,he=>he.provideDocumentFormattingEdits(m.URI.revive(q),Q,J),void 0,J)}registerDocumentRangeFormattingEditProvider(V,q,Q){const J=typeof Q.provideDocumentRangesFormattingEdits=="function",he=this.t(new W(this.h,Q),V);return this.e.$registerRangeFormattingSupport(he,this.o(q,V),V.identifier,V.displayName||V.name,J),this.p(he)}$provideDocumentRangeFormattingEdits(V,q,Q,J,he){return this.s(V,W,pe=>pe.provideDocumentRangeFormattingEdits(m.URI.revive(q),Q,J,he),void 0,he)}$provideDocumentRangesFormattingEdits(V,q,Q,J,he){return this.s(V,W,pe=>pe.provideDocumentRangesFormattingEdits(m.URI.revive(q),Q,J,he),void 0,he)}registerOnTypeFormattingEditProvider(V,q,Q,J){const he=this.t(new X(this.h,Q),V);return this.e.$registerOnTypeFormattingSupport(he,this.o(q,V),J,V.identifier),this.p(he)}$provideOnTypeFormattingEdits(V,q,Q,J,he,pe){return this.s(V,X,ze=>ze.provideOnTypeFormattingEdits(m.URI.revive(q),Q,J,he,pe),void 0,pe)}registerWorkspaceSymbolProvider(V,q){const Q=this.t(new Z(q,this.l),V);return this.e.$registerNavigateTypeSupport(Q,typeof q.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(V,q,Q){return this.s(V,Z,J=>J.provideWorkspaceSymbols(q,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(V,q,Q){return this.s(V,Z,J=>J.resolveWorkspaceSymbol(q,Q),void 0,void 0)}$releaseWorkspaceSymbols(V,q){this.s(V,Z,Q=>Q.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(V,q,Q){const J=this.t(new Y(this.h,Q,this.l),V);return this.e.$registerRenameSupport(J,this.o(q,V),Y.supportsResolving(Q)),this.p(J)}$provideRenameEdits(V,q,Q,J,he){return this.s(V,Y,pe=>pe.provideRenameEdits(m.URI.revive(q),Q,J,he),void 0,he)}$resolveRenameLocation(V,q,Q,J){return this.s(V,Y,he=>he.resolveRenameLocation(m.URI.revive(q),Q,J),void 0,J)}registerNewSymbolNamesProvider(V,q,Q){const J=this.t(new x(this.h,Q,this.l),V);return this.e.$registerNewSymbolNamesProvider(J,this.o(q,V)),this.p(J)}$provideNewSymbolNames(V,q,Q,J){return this.s(V,x,he=>he.provideNewSymbolNames(m.URI.revive(q),Q,J),void 0,J)}registerDocumentSemanticTokensProvider(V,q,Q,J){const he=this.t(new ge(this.h,Q),V),pe=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(q,V),J,pe);let ze=this.p(he);if(pe){const qe=Q.onDidChangeSemanticTokens(Ye=>this.e.$emitDocumentSemanticTokensEvent(pe));ze=s.$UM.from(ze,qe)}return ze}$provideDocumentSemanticTokens(V,q,Q,J){return this.s(V,ge,he=>he.provideDocumentSemanticTokens(m.URI.revive(q),Q,J),null,J)}$releaseDocumentSemanticTokens(V,q){this.s(V,ge,Q=>Q.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,q,Q,J){const he=this.t(new ue(this.h,Q),V);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(q,V),J),this.p(he)}$provideDocumentRangeSemanticTokens(V,q,Q,J){return this.s(V,ue,he=>he.provideDocumentRangeSemanticTokens(m.URI.revive(q),Q,J),null,J)}registerCompletionItemProvider(V,q,Q,J){const he=this.t(new ve(this.h,this.j.converter,Q,this.m,V),V);return this.e.$registerCompletionsProvider(he,this.o(q,V),J,ve.supportsResolving(Q),V.identifier),this.p(he)}$provideCompletionItems(V,q,Q,J,he){return this.s(V,ve,pe=>pe.provideCompletionItems(m.URI.revive(q),Q,J,he),void 0,he)}$resolveCompletionItem(V,q,Q){return this.s(V,ve,J=>J.resolveCompletionItem(q,Q),void 0,Q)}$releaseCompletionItems(V,q){this.s(V,ve,Q=>Q.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(V,q,Q,J){const he=new U(V,this.h,Q,this.j.converter),pe=this.t(he,V);return this.e.$registerInlineCompletionsSupport(pe,this.o(q,V),he.supportsHandleEvents,n.$Mm.toKey(V.identifier.value),J?.yieldTo?.map(ze=>n.$Mm.toKey(ze))||[]),this.p(pe)}$provideInlineCompletions(V,q,Q,J,he){return this.s(V,te,pe=>pe.provideInlineCompletions(m.URI.revive(q),Q,J,he),void 0,he)}$handleInlineCompletionDidShow(V,q,Q,J){this.s(V,te,async he=>{he.handleDidShowCompletionItem(q,Q,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,q,Q,J,he){this.s(V,te,async pe=>{pe.handlePartialAccept(q,Q,J,he)},void 0,void 0)}$freeInlineCompletionsList(V,q){this.s(V,te,async Q=>{Q.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(V,q,Q){const J=new _(V,this.h,Q,this.j.converter),he=this.t(J,V);return this.e.$registerInlineEditProvider(he,this.o(q,V),V.identifier),this.p(he)}$provideInlineEdit(V,q,Q,J){return this.s(V,_,he=>he.provideInlineEdits(m.URI.revive(q),Q,J),void 0,J)}$freeInlineEdit(V,q){this.s(V,_,async Q=>{Q.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(V,q,Q,J){const he=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,pe=this.t(new Pe(this.h,Q),V);return this.e.$registerSignatureHelpProvider(pe,this.o(q,V),he),this.p(pe)}$provideSignatureHelp(V,q,Q,J,he){return this.s(V,Pe,pe=>pe.provideSignatureHelp(m.URI.revive(q),Q,J,he),void 0,he)}$releaseSignatureHelp(V,q){this.s(V,Pe,Q=>Q.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(V,q,Q){const J=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new se(this.h,this.j.converter,Q,this.l,V),V);this.e.$registerInlayHintsProvider(he,this.o(q,V),typeof Q.resolveInlayHint=="function",J,Ie.u(V));let pe=this.p(he);if(J!==void 0){const ze=Q.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(J));pe=s.$UM.from(pe,ze)}return pe}$provideInlayHints(V,q,Q,J){return this.s(V,se,he=>he.provideInlayHints(m.URI.revive(q),Q,J),void 0,J)}$resolveInlayHint(V,q,Q){return this.s(V,se,J=>J.resolveInlayHint(q,Q),void 0,Q)}$releaseInlayHints(V,q){this.s(V,se,Q=>Q.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(V,q,Q){const J=this.t(new re(this.h,Q),V);return this.e.$registerDocumentLinkProvider(J,this.o(q,V),typeof Q.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(V,q,Q){return this.s(V,re,J=>J.provideLinks(m.URI.revive(q),Q),void 0,Q,q.scheme==="output")}$resolveDocumentLink(V,q,Q){return this.s(V,re,J=>J.resolveLink(q,Q),void 0,void 0,!0)}$releaseDocumentLinks(V,q){this.s(V,re,Q=>Q.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(V,q,Q){const J=this.t(new oe(this.h,Q),V);return this.e.$registerDocumentColorProvider(J,this.o(q,V)),this.p(J)}$provideDocumentColors(V,q,Q){return this.s(V,oe,J=>J.provideColors(m.URI.revive(q),Q),[],Q)}$provideColorPresentations(V,q,Q,J){return this.s(V,oe,he=>he.provideColorPresentations(m.URI.revive(q),Q,J),void 0,J)}registerFoldingRangeProvider(V,q,Q){const J=this.q(),he=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new De(new K(this.h,Q),V)),this.e.$registerFoldingRangeProvider(J,this.o(q,V),V.identifier,he);let pe=this.p(J);if(he!==void 0){const ze=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));pe=s.$UM.from(pe,ze)}return pe}$provideFoldingRanges(V,q,Q,J){return this.s(V,K,he=>he.provideFoldingRanges(m.URI.revive(q),Q,J),void 0,J)}registerSelectionRangeProvider(V,q,Q){const J=this.t(new ie(this.h,Q,this.l),V);return this.e.$registerSelectionRangeProvider(J,this.o(q,V)),this.p(J)}$provideSelectionRanges(V,q,Q,J){return this.s(V,ie,he=>he.provideSelectionRanges(m.URI.revive(q),Q,J),[],J)}registerCallHierarchyProvider(V,q,Q){const J=this.t(new $e(this.h,Q),V);return this.e.$registerCallHierarchyProvider(J,this.o(q,V)),this.p(J)}$prepareCallHierarchy(V,q,Q,J){return this.s(V,$e,he=>Promise.resolve(he.prepareSession(m.URI.revive(q),Q,J)),void 0,J)}$provideCallHierarchyIncomingCalls(V,q,Q,J){return this.s(V,$e,he=>he.provideCallsTo(q,Q,J),void 0,J)}$provideCallHierarchyOutgoingCalls(V,q,Q,J){return this.s(V,$e,he=>he.provideCallsFrom(q,Q,J),void 0,J)}$releaseCallHierarchy(V,q){this.s(V,$e,Q=>Promise.resolve(Q.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(V,q,Q){const J=this.t(new we(this.h,Q),V);return this.e.$registerTypeHierarchyProvider(J,this.o(q,V)),this.p(J)}$prepareTypeHierarchy(V,q,Q,J){return this.s(V,we,he=>Promise.resolve(he.prepareSession(m.URI.revive(q),Q,J)),void 0,J)}$provideTypeHierarchySupertypes(V,q,Q,J){return this.s(V,we,he=>he.provideSupertypes(q,Q,J),void 0,J)}$provideTypeHierarchySubtypes(V,q,Q,J){return this.s(V,we,he=>he.provideSubtypes(q,Q,J),void 0,J)}$releaseTypeHierarchy(V,q){this.s(V,we,Q=>Promise.resolve(Q.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(V,q,Q,J){const he=this.q();return this.f.set(he,new De(new Le(this.e,this.h,Q,he,V),V)),this.e.$registerDocumentOnDropEditProvider(he,this.o(q,V),(0,r.$zG)(V,"documentPaste")&&J?{supportsResolve:!!Q.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this.p(he)}$provideDocumentOnDropEdits(V,q,Q,J,he,pe){return this.s(V,Le,ze=>Promise.resolve(ze.provideDocumentOnDropEdits(q,m.URI.revive(Q),J,he,pe)),void 0,void 0)}$resolveDropEdit(V,q,Q){return this.s(V,Le,J=>J.resolveDropEdit(q,Q),{},void 0)}$releaseDropEdits(V,q){this.s(V,Le,Q=>Promise.resolve(Q.releaseDropEdits(q)),void 0,void 0)}registerMappedEditsProvider(V,q,Q){const J=this.t(new fe(this.h,Q),V);return this.e.$registerMappedEditsProvider(J,this.o(q,V)),this.p(J)}$provideMappedEdits(V,q,Q,J,he){return this.s(V,fe,pe=>Promise.resolve(pe.provideMappedEdits(q,Q,J,he)),null,he)}registerDocumentPasteEditProvider(V,q,Q,J){const he=this.q();return this.f.set(he,new De(new T(this.e,this.h,Q,he,V),V)),this.e.$registerPasteEditProvider(he,this.o(q,V),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,supportsResolve:!!Q.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(pe=>pe.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(he)}$prepareDocumentPaste(V,q,Q,J,he){return this.s(V,T,pe=>pe.prepareDocumentPaste(m.URI.revive(q),Q,J,he),void 0,he)}$providePasteEdits(V,q,Q,J,he,pe,ze){return this.s(V,T,qe=>qe.providePasteEdits(q,m.URI.revive(Q),J,he,pe,ze),void 0,ze)}$resolvePasteEdit(V,q,Q){return this.s(V,T,J=>J.resolvePasteEdit(q,Q),{},void 0)}$releasePasteEdits(V,q){this.s(V,T,Q=>Promise.resolve(Q.releasePasteEdits(q)),void 0,void 0)}static w(V){return{pattern:V.source,flags:V.flags}}static y(V){return{decreaseIndentPattern:Ie.w(V.decreaseIndentPattern),increaseIndentPattern:Ie.w(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ie.w(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ie.w(V.unIndentedLinePattern):void 0}}static z(V){return{beforeText:Ie.w(V.beforeText),afterText:V.afterText?Ie.w(V.afterText):void 0,previousLineText:V.previousLineText?Ie.w(V.previousLineText):void 0,action:V.action}}static B(V){return V.map(Ie.z)}static C(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(q=>s.SyntaxTokenType.toString(q)):void 0}}static D(V){return V.map(Ie.C)}setLanguageConfiguration(V,q,Q){const{wordPattern:J}=Q;if(J&&(0,L.$gf)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(q,J):this.h.setWordDefinitionFor(q,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const he=this.q(),pe={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Ie.w(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Ie.y(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Ie.B(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Ie.D(Q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(he,q,pe),this.p(he)}$setWordDefinitions(V){for(const q of V)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$Jkc=Ie}),define(ke[121],Se([1,0,3,6,16,7,108,25,8,4,221,145,13,5,20,120,12,39]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=e.$qlc=void 0,e.$qlc=(0,y.$ri)("IExtHostLanguageModels");class i{constructor(d,a){this.option=d,this.stream=new $.$Uh,this.stream=a??new $.$Uh}}class s{constructor(){this.a=new Map,this.b=new $.$Uh,this.c=!1,this.d=!1;const d=this;this.apiObject={stream:d.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;this.d=!0;let a=this.a.get(d.index);a||(this.a.size===0?a=new i(d.index,this.b):a=new i(d.index),this.a.set(d.index,a)),a.stream.emitOne(d.part)}get isStreaming(){return this.d}reject(d){this.c=!0;for(const a of this.f())a.reject(d)}resolve(){this.c=!0;for(const d of this.f())d.resolve()}}let r=class{static{n=this}static{this.a=1}constructor(d,a,h){this.j=a,this.k=h,this.c=new S.$be,this.d=new S.$be,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new w.$Om,this.i=new Map,this.o=new Set,this.b=d.getProxy(N.$SM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,a,h,o){const p=n.a++;this.f.set(p,{extension:d.identifier,provider:h,languageModelId:a});let f;return o.auth&&(f={providerLabel:d.displayName||d.name,accountLabel:typeof o.auth=="object"?o.auth.label:void 0}),this.b.$registerLanguageModelProvider(p,a,{extension:d.identifier,identifier:a,name:o.name??"",version:o.version,tokens:o.tokens,auth:f}),(0,u.$Sc)(()=>{this.f.delete(p),this.b.$unregisterProvider(p)})}async $provideLanguageModelResponse(d,a,h,o,p,f){const D=this.f.get(d);if(!D)return;const b=new R.$3v(async k=>{if(f.isCancellationRequested){this.j.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:k.index,part:k.part})});return D.provider.provideLanguageModelResponse2(o.map(M.LanguageModelMessage.to),p,w.$Mm.toKey(h),b,f)}$provideTokenLength(d,a,h){const o=this.f.get(d);return o?Promise.resolve(o.provider.provideTokenCount(a,h)):Promise.resolve(0)}$updateLanguageModels(d){const a=[],h=[];if(d.added)for(const o of d.added)this.g.set(o.identifier,o),a.push(o.identifier);if(d.removed)for(const o of d.removed){this.g.delete(o),h.push(o);for(const[p,f]of this.i)f.languageModelId===o&&(f.res.reject(new m.$5),this.i.delete(p))}this.d.fire(Object.freeze({added:Object.freeze(a),removed:Object.freeze(h)})),d.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(d){const a=new Array;for(const{from:h,to:o,enabled:p}of d){const f=this.h.get(h)??new w.$Nm;if(f.has(o)!==p){p?f.add(o):f.delete(o),this.h.set(h,f);const b={from:h,to:o};a.push(b),this.c.fire(b)}}}async sendChatRequest(d,a,h,o,p){const f=d.identifier,D=await this.b.$prepareChatAccess(f,a,o.justification);if(!D||!this.g.has(a))throw A.$5O.NotFound(`Language model '${a}' is unknown.`);if(this.m(f,D)&&(!await this.l(d,{identifier:D.extension,displayName:D.auth.providerLabel},o.justification,o.silent)||!this.h.get(f)?.has(D.extension)))throw A.$5O.NoPermissions(`Language model '${a}' cannot be used by '${f.value}'.`);const b=Math.random()*1e6|0,k=this.b.$fetchResponse(f,a,b,h.map(M.LanguageModelMessage.from),o.modelOptions??{},p),E=new $.$qh,P=new s;this.i.set(b,{languageModelId:a,res:P});let I;if(k.catch(F=>{E.isOpen()?P.reject(F):I=F}).finally(()=>{this.i.delete(b),P.resolve(),E.open()}),await E.wait(),I)throw new A.$5O(`Language model '${a}' errored, check cause for more details`,"Unknown",I);return P.apiObject}async $handleResponseFragment(d,a){const h=this.i.get(d);h&&h.res.handleFragment(a)}async l(d,a,h,o){const p=C.$UL+a.identifier.value;if(await this.k.getSession(d,p,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:a.identifier,enabled:!0}]),!0;if(o)return!1;try{const D=h?(0,L.localize)(0,null,a.displayName,h):(0,L.localize)(1,null,a.displayName);return await this.k.getSession(d,p,[],{forceNewSession:{detail:D}}),this.$updateModelAccesslist([{from:d.identifier,to:a.identifier,enabled:!0}]),!0}catch{return!1}}m(d,a){return!!a.auth&&!w.$Mm.equals(a.extension,d)}async n(d){for(const a of this.o)try{await this.l(a,{identifier:d.extension,displayName:""},void 0,!0)}catch(h){this.j.error("Fake Auth request failed"),this.j.error(h)}}async computeTokenLength(d,a,h){const o=this.g.get(d);if(!o)throw A.$5O.NotFound(`Language model '${d}' is unknown.`);const p=c.Iterable.find(this.f.values(),f=>f.languageModelId===d);return p?p.provider.provideTokenCount(a,h):this.b.$countTokens(o.identifier,typeof a=="string"?a:M.LanguageModelMessage.from(a),h)}getLanguageModelInfo(d){const a=this.g.get(d);if(a)return{id:a.identifier,name:a.name,version:a.version,tokens:a.tokens}}createLanguageModelAccessInformation(d){this.o.add(d);const a=this,h=S.Event.signal(S.Event.filter(this.c.event,p=>w.$Mm.equals(p.from,d.identifier))),o=S.Event.signal(this.d.event);return{get onDidChange(){return S.Event.any(h,o)},canSendRequest(p){const f=a.g.get(p);if(!f)return;if(!a.m(d.identifier,f))return!0;const D=a.h.get(d.identifier);if(D)return D.has(f.extension)}}}};e.$rlc=r,e.$rlc=r=n=Qe([Ve(0,v.$fP),Ve(1,g.$Xj),Ve(2,l.$Lkc)],r)}),define(ke[338],Se([1,0,6,16,7,41,8,3,26]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;class S{constructor(C,m,y,v){this.c=m,this.d=y,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(u.$SM.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const y=this.c.getDocumentData(C);if(!y)throw new Error(`document '${C.toString()}' NOT found`);return y.document}async tokenAtPosition(C,m){const y=C.version,v=N.Position.from(m),l=await this.a.$tokensAtPosition(C.uri,v),g={type:M.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new M.$WM(m.line,m.character,m.line,m.character)};if(!l)return g;const c={range:N.Range.to(l.range),type:N.TokenType.to(l.type)};return!c.range.contains(m)||y!==C.version?g:c}createLanguageStatusItem(C,m,y){const v=this.f++,l=this.a,g=this.g,c=`${C.identifier.value}/${m}`;if(g.has(c))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);g.add(c);const n={selector:y,id:m,name:C.displayName??C.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const s=new w.$Tc,r=()=>{if(i?.dispose(),!g.has(c)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$th)(()=>{s.clear(),this.a.$setLanguageStatus(v,{id:c,name:n.name??C.displayName??C.name,source:C.displayName??C.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===M.LanguageStatusSeverity.Error?A.default.Error:n.severity===M.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:n.command&&this.d.toInternal(n.command,s),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){s.dispose(),i?.dispose(),l.$removeLanguageStatus(v),g.delete(c)},get id(){return n.id},get name(){return n.name},set name(d){n.name=d,r()},get selector(){return n.selector},set selector(d){n.selector=d,r()},get text(){return n.text},set text(d){n.text=d,r()},set text2(d){(0,$.$AG)(C,"languageStatusText"),n.text=d,r()},get text2(){return(0,$.$AG)(C,"languageStatusText"),n.text},get detail(){return n.detail},set detail(d){n.detail=d,r()},get severity(){return n.severity},set severity(d){n.severity=d,r()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(d){n.accessibilityInformation=d,r()},get command(){return n.command},set command(d){n.command=d,r()},get busy(){return n.busy},set busy(d){n.busy=d,r()}};return r(),t}}e.$9lc=S}),define(ke[339],Se([1,0,15,2,16,7,119]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=void 0;class w{constructor(C,m,y,v){this.start=C,this.deletedCount=m,this.deletedItems=y,this.items=v}asApiEvent(){return{range:new A.$jO(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C){return{EOL:C.eol,lines:C.source,languageId:C.language,uri:C.uri,isDirty:!1,versionId:1}}constructor(C,m,y){this.notebook=C,this.h=m,this.j=y,this.handle=y.handle,this.uri=N.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(M.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(v){C.g=v},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(y)}return this.f}setOutputs(C){this.a=C.map(M.NotebookCellOutput.to)}setOutputItems(C,m,y){const v=y.map(M.NotebookCellOutputItem.to),l=this.a.find(g=>g.id===C);if(l&&(m||(l.items.length=0),l.items.push(...v),l.items.length>1&&l.items.every(g=>R.$PK(g.mime)))){const g=new Map,c=[];l.items.forEach(n=>{let i;g.has(n.mime)?i=g.get(n.mime):(i=[],g.set(n.mime,i),c.push(n.mime)),i.push(n.data)}),l.items.length=0,c.forEach(n=>{const i=R.$QK(g.get(n));l.items.push({mime:n,data:i.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$Ulc=$;class S{static{this.a=0}constructor(C,m,y,v,l){this.k=C,this.l=m,this.m=y,this.uri=v,this.handle=S.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===u.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(y){return y=C.n(y),C.b[y].apiCell},getCells(y){return(y?C.p(y):C.b).map(l=>l.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,y){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:y});const v={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},l=[];for(const c of C.rawEvents)c.kind===R.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,v.contentChanges):c.kind===R.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,v.contentChanges):c.kind===R.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),l.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),l.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),l.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===R.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),l.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),l.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const g=new Map;for(let c=0;c<l.length;c++){const n=l[c],i=g.get(n.cell);if(i===void 0){const s=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});g.set(n.cell,s-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,y=C.end|0;return m<0&&(m=0),y>this.b.length&&(y=this.b.length),C.with({start:m,end:y})}p(C){C=this.o(C);const m=[];for(let y=C.start;y<C.end;y++)m.push(this.b[y]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,y){if(this.j)return;const v=[],l=[],g=[];if(C.reverse().forEach(c=>{const i=c[2].map(t=>{const d=new $(this,this.l,t);return m||l.push($.asModelAddData(t)),d}),s=new w(c[0],c[1],[],i),r=this.b.splice(c[0],c[1],...i);for(const t of r)g.push(t.uri),s.deletedItems.push(t.apiCell);v.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:g}),y)for(const c of v)y.push(c.asApiEvent())}s(C,m,y,v){const l=this.b.splice(C,m);this.b.splice(y,0,...l);const g=[new w(C,m,l.map(c=>c.apiCell),[]),new w(y,0,[],l)];for(const c of g)v.push(c.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,y,v){this.b[C].setOutputItems(m,y,v)}v(C,m){const y=this.b[C];y.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(y.uri,m)}w(C,m){const y=this.b[C];y.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$Vlc=S}),define(ke[340],Se([1,0,4,2,16,7,48]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;class w{constructor(S,L,C,m={timeout:1500,errors:3}){this.b=S,this.c=L,this.d=C,this.f=m,this.a=new u.$de}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(L,C,m)=>{const y=function(l){L.call(C,l)};return y.extension=S,this.a.event(y,void 0,m)}}async $participateInSave(S,L,C){const m=N.URI.revive(S),y=this.c.getNotebookDocument(m);if(!y)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:y.apiNotebook,reason:M.TextDocumentSaveReason.to(L)},C,async(g,c)=>{const n=Date.now(),i=await await Promise.resolve(g);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!C.isCancellationRequested&&i&&(i instanceof A.$5M?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),C.isCancellationRequested)return!1;if(v.length===0)return!0;const l={edits:[]};for(const g of v){const{edits:c}=M.WorkspaceEdit.from(g);l.edits=l.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new R.$ow(l))}}e.$$lc=w}),define(ke[153],Se([1,0,13,16,7]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(w,$,S,L,C,m){this.id=w,this.f=$,this.notebookData=S,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=L,this.c=m}get apiEditor(){if(!this.e){const w=this;this.e={get notebook(){return w.notebookData.apiNotebook},get selection(){return w.a[0]},set selection($){this.selections=[$]},get selections(){return w.a},set selections($){if(!Array.isArray($)||!$.every(M.$jO.isNotebookRange))throw(0,u.$7)("selections");w.a=$,w.g($)},get visibleRanges(){return w.b},revealRange($,S){w.f.$tryRevealRange(w.id,N.NotebookRange.from($),S??M.NotebookEditorRevealType.Default)},get viewColumn(){return w.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(w){this.d=w}_acceptVisibleRanges(w){this.b=w}_acceptSelections(w){this.a=w}g(w){this.f.$trySetSelections(this.id,w.map(N.NotebookRange.from))}_acceptViewColumn(w){this.c=w}}e.$Wlc=A}),define(ke[341],Se([1,0,4,12,16]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=void 0;let A=class{constructor(w,$){this.c=w,this.d=$,this.a=new u.$be,this.b=new u.$be,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,$);const S=this.d.getEditorById(w);$.visibleRanges&&S._acceptVisibleRanges($.visibleRanges.ranges.map(M.NotebookRange.to)),$.selections&&S._acceptSelections($.selections.selections.map(M.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:S.apiEditor,visibleRanges:S.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:S.apiEditor,selections:S.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const $ in w)this.d.getEditorById($)._acceptViewColumn(M.ViewColumn.to(w[$]))}};e.$amc=A,e.$amc=A=Qe([Ve(0,N.$Xj)],A)}),define(ke[342],Se([1,0,4,6,153]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class A{constructor(w,$){this.c=$,this.a=new Map,this.b=w.getProxy(N.$SM.MainThreadNotebookRenderers)}$postRendererMessage(w,$,S){const L=this.c.getEditorById(w);this.a.get($)?.fire({editor:L.apiEditor,message:S})}createRendererMessaging(w,$){if(!w.contributes?.notebookRenderer?.some(L=>L.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(L,C,m)=>this.d($).event(L,C,m),postMessage:(L,C)=>{M.$Wlc.apiEditorsToExtHost.has(L)&&([L,C]=[C,L]);const m=C&&M.$Wlc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,L)}}}d(w){let $=this.a.get(w);return $||($=new u.$be({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(w)}}),this.a.set(w,$),$)}}e.$dmc=A}),define(ke[343],Se([1,0,16,108,22,55,13]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=void 0;class w{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,m,y){const v=this.b++,{title:l,location:g,cancellable:c}=m,n={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(v,{location:u.ProgressLocation.from(g),title:l,source:n,cancellable:c},C.isUnderDevelopment?void 0:C.identifier.value).catch(R.$2),this.d(v,y,!!c)}d(C,m,y){let v;y&&(v=new M.$me,this.c.set(C,v));const l=c=>{this.a.$progressEnd(c),this.c.delete(c),v?.dispose()};let g;try{g=m(new S(this.a,C),y&&v?v.token:M.CancellationToken.None)}catch(c){throw l(C),c}return g.then(c=>l(C),c=>l(C)),g}$acceptProgressCanceled(C){const m=this.c.get(C);m&&(m.cancel(),this.c.delete(C))}}e.$hmc=w;function $(L,C){return L.message=C.message,typeof C.increment=="number"&&(typeof L.increment=="number"?L.increment+=C.increment:L.increment=C.increment),L}class S extends N.$3v{constructor(C,m){super(y=>this.throttledReport(y)),this.c=C,this.d=m}throttledReport(C){this.c.$progressReport(this.d,C)}}Qe([(0,A.$Xh)(100,(L,C)=>$(L,C),()=>Object.create(null))],S.prototype,"throttledReport",null)}),define(ke[344],Se([1,0,2,6,8,16]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=void 0;class R{static{this.a=0}constructor($,S){this.d=S,this.c=new Map,this.b=$.getProxy(N.$SM.MainThreadQuickDiff)}$provideOriginalResource($,S,L){const C=u.URI.revive(S),m=this.c.get($);return m?(0,M.$jh)(()=>m.provideOriginalResource(C,L)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider($,S,L,C){const m=R.a++;return this.c.set(m,S),this.b.$registerQuickDiffProvider(m,A.DocumentSelector.from($,this.d),L,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$imc=R}),define(ke[345],Se([1,0,22,4,3,6,2,7,13,19,41,57,26,16]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=v;function v(l,g,c){const n=l.getProxy(A.$SM.MainThreadQuickOpen);class i{constructor(f,D){this.e=new Map,this.f=0,this.a=f,this.b=D}showQuickPick(f,D,b,k=u.CancellationToken.None){this.c=void 0;const E=Promise.resolve(D),P=++this.f,I=n.$show(P,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},k),F={},j=I.then(()=>F);return Promise.race([j,E]).then(z=>{if(z===F)return;const O=(0,m.$zG)(f,"quickPickItemTooltip");return E.then(T=>{const B=[];for(let W=0;W<T.length;W++){const X=T[W];if(typeof X=="string")B.push({label:X,handle:W});else if(X.kind===w.QuickPickItemKind.Separator)B.push({type:"separator",label:X.label});else{X.tooltip&&!O&&console.warn(`Extension '${f.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`);const Z=X.iconPath?a(X.iconPath):void 0;B.push({label:X.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:X.description,detail:X.detail,picked:X.picked,alwaysShow:X.alwaysShow,tooltip:O?y.MarkdownString.fromStrict(X.tooltip):void 0,handle:W})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=W=>{b.onDidSelectItem(T[W])}),n.$setItems(P,B),I.then(W=>{if(typeof W=="number")return T[W];if(Array.isArray(W))return W.map(X=>T[X])})})}).then(void 0,z=>{if(!(0,$.$4)(z))return n.$setError(P,z),Promise.reject(z)})}$onItemSelected(f){this.c?.(f)}showInput(f,D=u.CancellationToken.None){return this.d=f?.validateInput,n.$input(f,typeof this.d=="function",D).then(void 0,b=>{if(!(0,$.$4)(b))return Promise.reject(b)})}async $validateInput(f){if(!this.d)return;const D=await this.d(f);if(!D||typeof D=="string")return D;let b;switch(D.severity){case w.InputBoxValidationSeverity.Info:b=L.default.Info;break;case w.InputBoxValidationSeverity.Warning:b=L.default.Warning;break;case w.InputBoxValidationSeverity.Error:b=L.default.Error;break;default:b=D.message?L.default.Error:L.default.Ignore;break}return{content:D.message,severity:b}}async showWorkspaceFolderPick(f,D=u.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!b)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(E=>E.uri.toString()===b.uri.toString())}createQuickPick(f){const D=new h(f,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(f){const D=new o(f,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(f,D){this.e.get(f)?._fireDidChangeValue(D)}$onDidAccept(f){this.e.get(f)?._fireDidAccept()}$onDidChangeActive(f,D){const b=this.e.get(f);b instanceof h&&b._fireDidChangeActive(D)}$onDidChangeSelection(f,D){const b=this.e.get(f);b instanceof h&&b._fireDidChangeSelection(D)}$onDidTriggerButton(f,D){this.e.get(f)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(f,D,b){const k=this.e.get(f);k instanceof h&&k._fireDidTriggerItemButton(D,b)}$onDidHide(f){this.e.get(f)?._fireDidHide()}}class s{static{this.a=1}constructor(f,D){this.x=f,this.y=D,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$be,this.q=new N.$be,this.r=new N.$be,this.s=new N.$be,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(f){this.b=f,this.z({title:f})}get step(){return this.c}set step(f){this.c=f,this.z({step:f})}get totalSteps(){return this.d}set totalSteps(f){this.d=f,this.z({totalSteps:f})}get enabled(){return this.g}set enabled(f){this.g=f,this.z({enabled:f})}get busy(){return this.j}set busy(f){this.j=f,this.z({busy:f})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(f){this.k=f,this.z({ignoreFocusOut:f})}get value(){return this.l}set value(f){this.l=f,this.z({value:f})}get placeholder(){return this.m}set placeholder(f){this.m=f,this.z({placeholder:f})}get buttons(){return this.n}set buttons(f){this.n=f.slice(),this.o.clear(),f.forEach((D,b)=>{const k=D===w.$gO.Back?-1:b;this.o.set(k,D)}),this.z({buttons:f.map((D,b)=>({...a(D.iconPath),tooltip:D.tooltip,handle:D===w.$gO.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(f){this.l=f,this.q.fire(f)}_fireDidTriggerButton(f){const D=this.o.get(f);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(f){if(!this.v){for(const D of Object.keys(f)){const b=f[D];this.u[D]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function r(p){if(p instanceof w.$QN)return{id:p.id};const f=d(p),D=t(p);return{dark:typeof f=="string"?R.URI.file(f):f,light:typeof D=="string"?R.URI.file(D):D}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function d(p){return typeof p=="object"&&"dark"in p?p.dark:p}function a(p){const f=r(p);let D,b;return"id"in f?b=C.ThemeIcon.asClassName(f):D=f,{iconPath:D,iconClass:b}}class h extends s{constructor(f,D){super(f.identifier,D),this.O=f,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$be,this.L=[],this.M=new N.$be,this.N=new N.$be,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(f){this.B=f.slice(),this.C.clear(),this.D.clear(),f.forEach((k,E)=>{this.C.set(E,k),this.D.set(k,E)});const D=(0,m.$zG)(this.O,"quickPickItemTooltip"),b=[];for(let k=0;k<f.length;k++){const E=f[k];if(E.kind===w.QuickPickItemKind.Separator)b.push({type:"separator",label:E.label});else{E.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=E.iconPath?a(E.iconPath):void 0;b.push({handle:k,label:E.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:D?y.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((I,F)=>({...a(I.iconPath),tooltip:I.tooltip,handle:F}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(f){this.E=f,this.z({canSelectMany:f})}get matchOnDescription(){return this.F}set matchOnDescription(f){this.F=f,this.z({matchOnDescription:f})}get matchOnDetail(){return this.G}set matchOnDetail(f){this.G=f,this.z({matchOnDetail:f})}get sortByLabel(){return this.H}set sortByLabel(f){this.H=f,this.z({sortByLabel:f})}get keepScrollPosition(){return this.I}set keepScrollPosition(f){this.I=f,this.z({keepScrollPosition:f})}get activeItems(){return this.J}set activeItems(f){this.J=f.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(f){this.L=f.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(f){const D=(0,S.$Hb)(f.map(b=>this.C.get(b)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(f){const D=(0,S.$Hb)(f.map(b=>this.C.get(b)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(f,D){const b=this.C.get(f);if(!b||!b.buttons||!b.buttons.length)return;const k=b.buttons[D];k&&this.N.fire({button:k,item:b})}}class o extends s{constructor(f,D){super(f.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(f){this.B=f,this.z({password:f})}get prompt(){return this.C}set prompt(f){this.C=f,this.z({prompt:f})}get valueSelection(){return this.D}set valueSelection(f){this.D=f,this.z({valueSelection:f})}get validationMessage(){return this.E}set validationMessage(f){this.E=f,f?typeof f=="string"?this.z({validationMessage:f,severity:L.default.Error}):this.z({validationMessage:f.message,severity:f.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new i(g,c)}}),define(ke[346],Se([1,0,2,4,55,3,8,6,19,131,12,25,57,16,26,15,11]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0;function n(P){return P instanceof u.URI}function i(P,I){return P.scheme===l.Schemas.file&&I.scheme===l.Schemas.file&&g.$k?P.toString()===I.toString():P.toString().toLowerCase()===I.toString().toLowerCase()}function s(P){if(P)return typeof P.iconPath=="string"?u.URI.file(P.iconPath):u.URI.isUri(P.iconPath)||m.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function r(P){if(P.icon){if(u.URI.isUri(P.icon))return P.icon;if(m.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const I=P.icon;return{light:I.light,dark:I.dark}}}else return}function t(P,I){if(!P.iconPath&&!I.iconPath)return 0;if(P.iconPath){if(!I.iconPath)return 1}else return-1;const F=typeof P.iconPath=="string"?P.iconPath:u.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,j=typeof I.iconPath=="string"?I.iconPath:u.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,S.$lr)(F,j)}function d(P,I){let F=0;if(P.strikeThrough!==I.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==I.faded)return P.faded?1:-1;if(P.tooltip!==I.tooltip)return(P.tooltip||"").localeCompare(I.tooltip||"");if(F=t(P,I),F!==0)return F;if(P.light&&I.light)F=t(P.light,I.light);else{if(P.light)return 1;if(I.light)return-1}if(F!==0)return F;if(P.dark&&I.dark)F=t(P.dark,I.dark);else{if(P.dark)return 1;if(I.dark)return-1}return F}function a(P,I){if(P.command!==I.command)return P.command<I.command?-1:1;if(P.title!==I.title)return P.title<I.title?-1:1;if(P.tooltip!==I.tooltip){if(P.tooltip!==void 0&&I.tooltip!==void 0)return P.tooltip<I.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(P.arguments===I.arguments)return 0;if(P.arguments)if(I.arguments){if(P.arguments.length!==I.arguments.length)return P.arguments.length-I.arguments.length}else return 1;else return-1;for(let F=0;F<P.arguments.length;F++){const j=P.arguments[F],z=I.arguments[F];if(j!==z&&!(n(j)&&n(z)&&i(j,z)))return j<z?-1:1}return 0}function h(P,I){let F=(0,S.$lr)(P.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(F!==0)return F;if(P.command&&I.command)F=a(P.command,I.command);else{if(P.command)return 1;if(I.command)return-1}if(F!==0)return F;if(P.decorations&&I.decorations)F=d(P.decorations,I.decorations);else{if(P.decorations)return 1;if(I.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)F=(0,S.$lr)(P.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)F=(0,S.$lr)(P.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return F}function o(P,I){for(let F=0;F<P.length;F++)if(P[F]!==I[F])return!1;return!0}function p(P,I){return P.command===I.command&&P.title===I.title&&P.tooltip===I.tooltip&&(P.arguments&&I.arguments?o(P.arguments,I.arguments):P.arguments===I.arguments)}function f(P,I){return(0,$.$ub)(P,I,p)}class D{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,v.$AG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,v.$AG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,v.$AG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,F,j,z,O){this.k=I,this.l=z,this.m=O,this.d="",this.e=new N.$be,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=j}showValidationMessage(I,F){(0,v.$AG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,F)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$kmc=D;class b{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,F,j,z,O,T,B){this.q=I,this.s=F,this.t=j,this.u=z,this.v=O,this.multiDiffEditorEnableViewChanges=T,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$be,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$be,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=b.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,F){const j=this.h.get(I);return j?(0,R.$jh)(()=>this.s.executeCommand(j.command,...j.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(h),j=(0,$.$Db)(this.o,I,h).map(T=>{const B=T.toInsert.map(W=>{const X=this.e++;this.g.set(X,W);const Z=W.resourceUri;let Y;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"||W.command.command==="vscode.changes"){const oe=new A.$Tc;Y=this.s.converter.toInternal(W.command,oe),this.j.set(X,oe)}else this.h.set(X,W.command);const x=(0,v.$zG)(this.w,"scmMultiDiffEditor"),ne=x?W.multiDiffEditorOriginalUri:void 0,ge=x?W.multiFileDiffEditorModifiedUri:void 0,ue=s(W.decorations),ve=W.decorations&&s(W.decorations.light)||ue,te=W.decorations&&s(W.decorations.dark)||ue,U=[ve,te],_=W.decorations&&W.decorations.tooltip||"",be=W.decorations&&!!W.decorations.strikeThrough,Pe=W.decorations&&!!W.decorations.faded,se=W.contextValue||"";return{rawResource:[X,Z,U,_,be,Pe,se,Y,ne,ge],handle:X}});return{start:T.start,deleteCount:T.deleteCount,toInsert:B}}),z=j.map(({start:T,deleteCount:B,toInsert:W})=>[T,B,W.map(X=>X.rawResource)]),O=j.reverse();for(const{start:T,deleteCount:B,toInsert:W}of O){const X=W.map(Y=>Y.handle),Z=this.n.splice(T,B,...X);for(const Y of Z)this.g.delete(Y),this.h.delete(Y),this.j.get(Y)?.dispose(),this.j.delete(Y)}return this.o=I,z}dispose(){this.l=!0,this.m.fire()}}class k{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let F;(0,v.$zG)(this.x,"quickDiffProvider")&&(F=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:F})}get historyProvider(){return(0,v.$AG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,v.$AG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new A.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new A.$Tc,this.o=I;const F=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:F})}get actionButton(){return(0,v.$AG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,v.$AG)(this.x,"scmActionButton"),this.p.value=new A.$Tc,this.q=I;const F=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(j=>j.map(z=>this.y.converter.toInternal(z,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:F??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&f(this.t,I))return;this.s.value=new A.$Tc,this.t=I;const F=(I||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:F})}get selected(){return this.u}constructor(I,F,j,z,O,T,B){this.x=I,this.y=z,this.z=O,this.A=T,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Vc,this.m=void 0,this.n=new A.$Vc,this.o=void 0,this.p=new A.$Vc,this.s=new A.$Vc,this.t=void 0,this.u=!1,this.v=new N.$be,this.onDidChangeSelection=this.v.event,this.w=k.d++,this.C=new Map,this.D=new Set,this.#e=j;const W=u.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${O}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new D(I,F,this.#e,this.w,W),this.#e.$registerSourceControl(this.w,O,T,B,W)}createResourceGroup(I,F,j){const z=(0,v.$zG)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,O=new b(this.#e,this.y,this.w,I,F,z,this.x),T=N.Event.once(O.onDidDispose)(()=>this.C.delete(O));return this.C.set(O,T),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const I=[],F=[];for(const[j,z]of this.C){z.dispose();const O=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});N.Event.once(j.onDidDispose)(()=>{this.D.delete(j),O.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),I.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const T=j._takeResourceStateSnapshot();T.length>0&&F.push([j.handle,T]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,I,F),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(F=>{const j=F._takeResourceStateSnapshot();j.length!==0&&I.push([F.handle,j])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Qe([(0,M.$Wh)(100)],k.prototype,"eventuallyAddResourceGroups",null),Qe([(0,M.$Wh)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let E=class{static{c=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,F,j,z){this.l=F,this.m=j,this.n=z,this.g=new Map,this.h=new C.$Om,this.j=new N.$be,this.e=I.getProxy(w.$SM.MainThreadSCM),this.f=I.getProxy(w.$SM.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const T=this.g.get(O.sourceControlHandle);if(!T)return O;const B=T.getResourceGroup(O.groupHandle);return B?B.getResourceState(O.handle):O}else if(O&&O.$mid===4){const T=this.g.get(O.sourceControlHandle);return T?T.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const T=this.g.get(O.handle);return T||O}return O}})}createSourceControl(I,F,j,z){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,F,j,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const O=c.d++,T=new k(I,this.m,this.e,this.l,F,j,z);this.g.set(O,T);const B=this.h.get(I.identifier)||[];return B.push(T),this.h.set(I.identifier,B),T}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const F=this.h.get(I.identifier),j=F&&F[F.length-1];return j&&j.inputBox}$provideOriginalResource(I,F,j){const z=u.URI.revive(F);this.n.trace("ExtHostSCM#$provideOriginalResource",I,z.toString());const O=this.g.get(I);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$jh)(()=>O.quickDiffProvider.provideOriginalResource(z,j)).then(T=>T||null)}$onInputBoxValueChange(I,F){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const j=this.g.get(I);return j&&j.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(I,F,j,z){this.n.trace("ExtHostSCM#$executeResourceCommand",I,F,j);const O=this.g.get(I);if(!O)return Promise.resolve(void 0);const T=O.getResourceGroup(F);return T?T.$executeResourceCommand(j,z):Promise.resolve(void 0)}$validateInput(I,F,j){this.n.trace("ExtHostSCM#$validateInput",I);const z=this.g.get(I);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,R.$jh)(()=>z.inputBox.validateInput(F,j)).then(O=>{if(!O)return Promise.resolve(void 0);const T=y.MarkdownString.fromStrict(O.message);return T?Promise.resolve([T,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,F,j,z){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,j,z)??void 0}async $provideHistoryItems(I,F,j,z){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(F,j,z))?.map(B=>({...B,icon:r(B)}))??void 0}async $provideHistoryItemSummary(I,F,j,z){const O=this.g.get(I)?.historyProvider;if(typeof O?.provideHistoryItemSummary!="function")return;const T=await O.provideHistoryItemSummary(F,j,z);return T?{...T,icon:r(T)}:void 0}async $provideHistoryItemChanges(I,F,j,z){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(F,j,z)??void 0}};e.$lmc=E,e.$lmc=E=c=Qe([Ve(3,L.$Xj)],E)}),define(ke[347],Se([1,0,6,16,2]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class A{static{this.a=0}constructor(w,$){this.d=$,this.c=new Map,this.b=w.getProxy(u.$SM.MainThreadShare)}async $provideShare(w,$,S){return await this.c.get(w)?.provideShare({selection:N.Range.to($.selection),resourceUri:M.URI.revive($.resourceUri)},S)??void 0}registerShareProvider(w,$){const S=A.a++;return this.c.set(S,$),this.b.$registerShareProvider(S,N.DocumentSelector.from(w,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(S),this.c.delete(S)}}}}e.$mmc=A}),define(ke[348],Se([1,0,7,6,224,3,16,18]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=e.$omc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new u.$RN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.$RN("statusBarItem.warningForeground")]])}#e;#t;constructor(m,y,v,l,g,c=u.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new A.$Tc,this.#e=m,this.#t=y,g&&l){this.c=(0,u.$tN)(l.identifier,g);const i=v.get(this.c);i&&(c=i.alignLeft?u.StatusBarAlignment.Left:u.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=l,this.f=g,this.g=c,this.h=this.u(n)}u(m){if((0,w.$9f)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new A.$Tc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let y;this.m?y=this.m:y=(0,M.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=$.b.get(this.o.id));const l=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,y,this.k,l,this.r?.internal,v,this.o,this.g===u.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$omc=$;class S{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const y={message:m};return this.b.unshift(y),this.c(),new u.$UM(()=>{const v=this.b.indexOf(y);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class L{constructor(m,y){this.e=new Map,this.a=m.getProxy(N.$SM.MainThreadStatusBar),this.b=y,this.c=new S(this)}$acceptStaticEntries(m){for(const y of m)this.e.set(y.entryId,y)}createStatusBarEntry(m,y,v,l){return new $(this.a,this.b,this.e,m,y,v,l)}setStatusBarMessage(m,y){const v=this.c.setMessage(m);let l;return typeof y=="number"?l=setTimeout(()=>v.dispose(),y):typeof y<"u"&&y.then(()=>v.dispose(),()=>v.dispose()),new u.$UM(()=>{v.dispose(),clearTimeout(l)})}}e.$pmc=L}),define(ke[154],Se([1,0,29,144,68,112,89,16,2]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.$tP=e.$sP=e.$rP=void 0;const S=(i,s,r,t)=>{let d=s;return{enumerable:!0,configurable:!1,get(){return d},set(a){if(!r(d,a)){const h=d;d=a,i.listener?.(t(a,h))}}}},L=(i,s)=>i===s,C={range:(i,s)=>i===s?!0:!i||!s?!1:i.isEqual(s),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(i,s)=>!(i.length!==s.length||i.some(r=>!s.find(t=>r.id===t.id)))},m=i=>s=>({op:4,update:i(s)}),y=(i,s)=>({range:(()=>{let r;const t=m(d=>({range:u.$nt.lift(w.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return r},set(d){i.listener?.({op:6}),C.range(r,d)||(r=d,i.listener?.(t(d)))}}})(),label:S(i,s,C.label,m(r=>({label:r}))),description:S(i,void 0,C.description,m(r=>({description:r}))),sortText:S(i,void 0,C.sortText,m(r=>({sortText:r}))),canResolveChildren:S(i,!1,C.canResolveChildren,r=>({op:2,state:r})),busy:S(i,!1,C.busy,m(r=>({busy:r}))),error:S(i,void 0,C.error,m(r=>({error:w.MarkdownString.fromStrict(r)||null}))),tags:S(i,[],C.tags,(r,t)=>({op:1,new:r.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),v=i=>{const s=M.$EL.fromString(i.extId),r=new g(s.controllerId,s.localId,i.label,$.URI.revive(i.uri)||void 0);return r.range=w.Range.to(i.range||void 0),r.description=i.description||void 0,r.sortText=i.sortText||void 0,r.tags=i.tags.map(t=>w.TestTag.to({id:(0,R.$KL)(t).tagId})),r},l=i=>{let s;for(const r of i.tests){const t=v(r.item);(0,N.$bP)(t).parent=s,s=t}return s};e.$rP=l;class g{constructor(s,r,t,d){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const a=(0,N.$aP)(this,s);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof c?void 0:a.parent}},children:{value:(0,A.$_O)(a,N.$bP,g),enumerable:!0,writable:!1},...y(a,t)})}}e.$sP=g;class c extends g{constructor(s,r){super(s,s,r,void 0),this._isRoot=!0}}e.$tP=c;class n extends A.$8O{constructor(s,r,t){super({controllerId:s,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:N.$bP,getChildren:d=>d.children,root:new c(s,r),toITestItem:w.TestItem.from})}}e.$uP=n}),define(ke[33],Se([1,0,18,7,16,24,6,19,12,58,29,50,2,3,5,20,154,21,48,47,40,87,90,30]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s,r,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=void 0;let a=class{#e;#t;#i;constructor(b,k,E){this.b=new Map,this.c=new Map,this.#e=b.getProxy(R.$SM.MainThreadCommands),this.d=k,this.#i=E,this.#t=b.getProxy(R.$SM.MainThreadTelemetry),this.converter=new h(this,P=>{const I=this.c.get(P);return I?.result===p.Void?I:void 0},k),this.f=[{processArgument(P){return(0,S.$1h)(P)}},{processArgument(P){return(0,A.$Zn)(P,function(I){if(L.$nt.isIRange(I))return M.Range.to(I);if(C.$mt.isIPosition(I))return M.Position.to(I);if(L.$nt.isIRange(I.range)&&m.URI.isUri(I.uri))return M.location.to(I);if(I instanceof c.$Ce)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const k=this.registerCommand(!1,b.id,async(...E)=>{const P=b.args.map((F,j)=>{if(!F.validate(E[j]))throw new Error(`Invalid argument '${F.name}' when running '${b.id}', received: ${typeof E[j]=="object"?JSON.stringify(E[j],null,"	"):E[j]} `);return F.convert(E[j])}),I=await this.executeCommand(b.internalId,...P);return b.result.convert(I,E,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new N.$UM(()=>{k.dispose(),this.c.delete(b.id)})}registerCommand(b,k,E,P,I,F){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:E,thisArg:P,metadata:I,extension:F}),b&&this.#e.$registerCommand(k),new N.$UM(()=>{this.b.delete(k)&&b&&this.#e.$unregisterCommand(k)})}executeCommand(b,...k){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,k,!0)}async g(b,k,E){if(this.b.has(b))return this.#e.$fireCommandActivationEvent(b),this.h(b,k,!1);{let P=!1;const I=(0,A.$Zn)(k,function(F){if(F instanceof N.$VM)return M.Position.from(F);if(F instanceof N.$WM)return M.Range.from(F);if(F instanceof N.$7M)return M.location.from(F);if(N.$jO.isNotebookRange(F))return M.NotebookRange.from(F);if(F instanceof ArrayBuffer)return P=!0,c.$Ce.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return P=!0,c.$Ce.wrap(F);if(F instanceof c.$Ce)return P=!0,F;if(!Array.isArray(F))return F});try{const F=await this.#e.$executeCommand(b,P?new n.$ow(I):I,E);return(0,S.$1h)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this.g(b,k,!1);throw F}}}async h(b,k,E){const P=this.b.get(b);if(!P)throw new Error("Unknown command");const{callback:I,thisArg:F,metadata:j}=P;if(j?.args)for(let O=0;O<j.args.length;O++)try{(0,u.$jg)(k[O],j.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${j.args[O].name}' - ${j.args[O].description}`)}const z=s.$0d.create();try{return await I.apply(F,k)}catch(O){if(b===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...k);T&&(b=T.command)}if(this.d.error(O,b,P.extension?.identifier),!E)throw O;if(P.extension?.identifier){const T=this.#i.onExtensionError(P.extension.identifier,O);this.d.trace("forwarded error to extension?",T,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$cj)(O)),this.id=b,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,b,z.elapsed())}}j(b,k,E){b.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new r.$ap(k),duration:E})}$executeContributedCommand(b,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const E=this.b.get(b);return E?(k=k.map(P=>this.f.reduce((I,F)=>F.processArgument(I,E.extension?.identifier),P)),this.h(b,k,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),this.#e.$getCommands().then(k=>(b&&(k=k.filter(E=>E[0]!=="_")),k))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[k,E]of this.b){const{metadata:P}=E;P&&(b[k]=P)}return Promise.resolve(b)}};e.$AP=a,e.$AP=a=Qe([Ve(0,l.$fP),Ve(1,$.$Xj),Ve(2,t.$zP)],a),e.$BP=(0,v.$ri)("IExtHostCommands");class h{constructor(b,k,E){this.d=b,this.f=k,this.g=E,this.delegatingCommandId=`__vsc${(0,d.$Ng)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,k){if(!b)return;const E={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return E;const P=this.f(b.command);if(P)E.id=P.internalId,E.arguments=P.args.map((I,F)=>I.convert(b.arguments&&b.arguments[F]));else if((0,w.$Lb)(b.arguments)){const I=`${b.command} /${++this.c}`;this.b.set(I,b),k.add((0,y.$Sc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),E.$ident=I,E.id=this.delegatingCommandId,E.arguments=[I],this.g.trace("CommandsConverter#CREATE",b.command,I)}return E}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const k=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$CP=h;class o{static{this.Uri=new o("uri","Uri of a text document",b=>m.URI.isUri(b),b=>b)}static{this.Position=new o("position","A position in a text document",b=>N.$VM.isPosition(b),M.Position.from)}static{this.Range=new o("range","A range in a text document",b=>N.$WM.isRange(b),M.Range.from)}static{this.Selection=new o("selection","A selection in a text document",b=>N.$XM.isSelection(b),M.Selection.from)}static{this.Number=new o("number","",b=>typeof b=="number",b=>b)}static{this.String=new o("string","",b=>typeof b=="string",b=>b)}static{this.StringArray=o.Arr(o.String)}static Arr(b){return new o(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,k=>Array.isArray(k)&&k.every(E=>b.validate(E)),k=>k.map(E=>b.convert(E)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",b=>b instanceof N.$fN,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",b=>b instanceof N.$DO,M.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",b=>b instanceof g.$sP,M.TestItem.from)}constructor(b,k,E,P){this.name=b,this.description=k,this.validate=E,this.convert=P}optional(){return new o(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,k){return new o(b??this.name,k??this.description,this.validate,this.convert)}}e.$DP=o;class p{static{this.Void=new p("no result",b=>b)}constructor(b,k){this.description=b,this.convert=k}}e.$EP=p;class f{constructor(b,k,E,P,I){this.id=b,this.internalId=k,this.description=E,this.args=P,this.result=I}}e.$FP=f}),define(ke[349],Se([1,0,19,15,2,83,134,37,33,16,7]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=void 0;const C=[new $.$FP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$DP.Uri,$.$DP.Position],new $.$EP("A promise that resolves to an array of DocumentHighlight-instances.",y(S.DocumentHighlight.to))),new $.$FP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$DP.Uri],new $.$EP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,g)=>{if((0,u.$Kb)(l))return;class c extends L.$aN{static to(i){const s=new c(i.name,S.SymbolKind.to(i.kind),i.containerName||"",new L.$7M(g[0],S.Range.to(i.range)));return s.detail=i.detail,s.range=s.location.range,s.selectionRange=S.Range.to(i.selectionRange),s.children=i.children?i.children.map(c.to):[],s}}return l.map(c.to)})),new $.$FP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$DP.Uri,new $.$DP("options","Formatting options",l=>!0,l=>l)],new $.$EP("A promise that resolves to an array of TextEdits.",y(S.TextEdit.to))),new $.$FP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$DP.Uri,$.$DP.Range,new $.$DP("options","Formatting options",l=>!0,l=>l)],new $.$EP("A promise that resolves to an array of TextEdits.",y(S.TextEdit.to))),new $.$FP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$DP.Uri,$.$DP.Position,new $.$DP("ch","Trigger character",l=>typeof l=="string",l=>l),new $.$DP("options","Formatting options",l=>!0,l=>l)],new $.$EP("A promise that resolves to an array of TextEdits.",y(S.TextEdit.to))),new $.$FP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$DP.Uri,$.$DP.Position],new $.$EP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$FP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$DP.Uri,$.$DP.Position],new $.$EP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$FP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$DP.Uri,$.$DP.Position],new $.$EP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$FP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$DP.Uri,$.$DP.Position],new $.$EP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$FP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$DP.Uri,$.$DP.Position],new $.$EP("A promise that resolves to an array of Location-instances.",y(S.location.to))),new $.$FP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$DP.Uri,$.$DP.Position],new $.$EP("A promise that resolves to an array of Hover-instances.",y(S.Hover.to))),new $.$FP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$DP.Uri,new $.$DP("position","A position in a text document",l=>Array.isArray(l)&&l.every(g=>L.$VM.isPosition(g)),l=>l.map(S.Position.from))],new $.$EP("A promise that resolves to an array of ranges.",l=>l.map(g=>{let c;for(const n of g.reverse())c=new L.$eN(S.Range.to(n),c);return c}))),new $.$FP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$DP.String.with("query","Search string")],new $.$EP("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(S.WorkspaceSymbol.to))),new $.$FP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$DP.Uri,$.$DP.Position],new $.$EP("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(S.CallHierarchyItem.to))),new $.$FP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$DP.CallHierarchyItem],new $.$EP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(S.CallHierarchyIncomingCall.to))),new $.$FP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$DP.CallHierarchyItem],new $.$EP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(S.CallHierarchyOutgoingCall.to))),new $.$FP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$DP.Uri,$.$DP.Position],new $.$EP("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:S.Range.to(l.range),placeholder:l.text}})),new $.$FP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$DP.Uri,$.$DP.Position,$.$DP.String.with("newName","The new symbol name")],new $.$EP("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return S.WorkspaceEdit.to(l)}})),new $.$FP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$DP.Uri,$.$DP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$EP("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(S.DocumentLink.to))),new $.$FP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$DP.Uri],new $.$EP("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new L.$aO(l.tokenTypes,l.tokenModifiers)})),new $.$FP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$DP.Uri],new $.$EP("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const g=(0,R.$Nbb)(l);if(g.type==="full")return new L.$cO(g.data,void 0)})),new $.$FP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$DP.Uri,$.$DP.Range.optional()],new $.$EP("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new L.$aO(l.tokenTypes,l.tokenModifiers)})),new $.$FP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$DP.Uri,$.$DP.Range],new $.$EP("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const g=(0,R.$Nbb)(l);if(g.type==="full")return new L.$cO(g.data,void 0)})),new $.$FP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$DP.Uri,$.$DP.Position,$.$DP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$DP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$EP("A promise that resolves to a CompletionList-instance.",(l,g,c)=>{if(!l)return new L.$qN([]);const n=l.suggestions.map(i=>S.CompletionItem.to(i,c));return new L.$qN(n,l.incomplete)})),new $.$FP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$DP.Uri,$.$DP.Position,$.$DP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$EP("A promise that resolves to SignatureHelp.",l=>{if(l)return S.SignatureHelp.to(l)})),new $.$FP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$DP.Uri,$.$DP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$EP("A promise that resolves to an array of CodeLens-instances.",(l,g,c)=>y(n=>new L.$iN(S.Range.to(n.range),n.command&&c.fromInternal(n.command)))(l))),new $.$FP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$DP.Uri,new $.$DP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>L.$WM.isRange(l),l=>L.$XM.isSelection(l)?S.Selection.from(l):S.Range.from(l)),$.$DP.String.with("kind","Code action kind to return code actions for").optional(),$.$DP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$EP("A promise that resolves to an array of Command-instances.",(l,g,c)=>y(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(n.command)}else{const i=new L.$cN(n.title,n.kind?new L.$dN(n.kind):void 0);return n.edit&&(i.edit=S.WorkspaceEdit.to(n.edit)),n.command&&(i.command=c.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(l))),new $.$FP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$DP.Uri],new $.$EP("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(g=>new L.$wN(S.Range.to(g.range),S.Color.to(g.color))):[])),new $.$FP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$DP("color","The color to show and insert",l=>l instanceof L.$vN,S.Color.from),new $.$DP("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:S.Range.from(l.range)}))],new $.$EP("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(S.ColorPresentation.to):[])),new $.$FP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$DP.Uri,$.$DP.Range],new $.$EP("A promise that resolves to an array of Inlay objects",(l,g,c)=>l.map(S.InlayHint.to.bind(void 0,c)))),new $.$FP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$DP.Uri],new $.$EP("A promise that resolves to an array of FoldingRange objects",(l,g)=>{if(l)return l.map(S.FoldingRange.to)})),new $.$FP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$EP("A promise that resolves to an array of NotebookContentProvider static info objects.",y(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(g=>S.NotebookExclusiveDocumentPattern.to(g))})))),new $.$FP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$DP.Uri,$.$DP.Range,new $.$DP("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof L.$WM,l=>S.InlineValueContext.from(l))],new $.$EP("A promise that resolves to an array of InlineValue objects",l=>l.map(S.InlineValue.to))),new $.$FP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$DP("uriOrString","Uri-instance or string (only http/https)",l=>M.URI.isUri(l)||typeof l=="string"&&(0,N.$Bg)(l,N.Schemas.http,N.Schemas.https),l=>l),new $.$DP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[S.ViewColumn.from(l),void 0]:[S.ViewColumn.from(l.viewColumn),S.TextEditorOpenOptions.from(l)])).optional(),$.$DP.String.with("label","").optional()],$.$EP.Void),new $.$FP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$DP.Uri.with("resource","Resource to open"),$.$DP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$DP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[S.ViewColumn.from(l),void 0]:[S.ViewColumn.from(l.viewColumn),S.TextEditorOpenOptions.from(l)])).optional()],$.$EP.Void),new $.$FP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$DP.Uri.with("left","Left-hand side resource of the diff editor"),$.$DP.Uri.with("right","Right-hand side resource of the diff editor"),$.$DP.String.with("title","Human readable title for the diff editor").optional(),new $.$DP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[S.ViewColumn.from(l.viewColumn),S.TextEditorOpenOptions.from(l)]).optional()],$.$EP.Void),new $.$FP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$DP.String.with("title","Human readable title for the changes editor"),new $.$DP("resourceList","List of resources to compare",l=>{for(const g of l){if(g.length!==3)return!1;const[c,n,i]=g;if(!M.URI.isUri(c)||!M.URI.isUri(n)&&n!==void 0&&n!==null||!M.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},l=>l)],$.$EP.Void),new $.$FP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$DP.Uri,$.$DP.Position],new $.$EP("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(S.TypeHierarchyItem.to))),new $.$FP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$DP.TypeHierarchyItem],new $.$EP("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(S.TypeHierarchyItem.to))),new $.$FP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$DP.TypeHierarchyItem],new $.$EP("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(S.TypeHierarchyItem.to))),new $.$FP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$DP.TestItem],$.$EP.Void),new $.$FP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$DP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$EP.Void),new $.$FP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$DP.String.with("name","The context key name"),new $.$DP("value","The context key value",()=>!0,l=>l)],$.$EP.Void),new $.$FP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$DP.Uri,$.$DP.StringArray,new $.$DP("MappedEditsContext","Mapped Edits Context",l=>S.MappedEditsContext.is(l),l=>S.MappedEditsContext.from(l))],new $.$EP("A promise that resolves to a workspace edit or null",l=>l?S.WorkspaceEdit.to(l):null))];class m{static register(g){C.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",w.$qj)}}e.$Kkc=m;function y(l){return g=>{if(Array.isArray(g))return g.map(l)}}function v(l){if(!Array.isArray(l))return;const g=[];for(const c of l)A.$5t(c)?g.push(S.DefinitionLink.to(c)):g.push(S.location.to(c));return g}}),define(ke[350],Se([1,0,8,3,2,6,33,16,7]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=void 0;class S{static{this.a=0}constructor(y,v){this.extension=y,this.provider=v,this.handle=S.a++}}class L{constructor(y){this.session=y,this.responses=[]}}class C{static{this.a=0}constructor(y,v,l,g){this.f=l,this.g=g,this.b=new Map,this.d=new Map,this.e=y.getProxy(A.$SM.MainThreadInlineChat),v.registerApiCommand(new R.$FP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$DP("Run arguments","",c=>!0,c=>{if(c)return{initialRange:c.initialRange?w.Range.from(c.initialRange):void 0,initialSelection:$.$XM.isSelection(c.initialSelection)?w.Selection.from(c.initialSelection):void 0,message:c.message,autoSend:c.autoSend,position:c.position?w.Position.from(c.position):void 0}})],R.$EP.Void))}registerProvider(y,v,l){const g=new S(y,v);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,l?.label??y.displayName??y.name,y.identifier,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",l?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareSession(y,v,l,g){const c=this.b.get(y);if(!c){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(M.URI.revive(v)),i=w.Selection.to(l),s=await c.provider.prepareInteractiveEditorSession({document:n,selection:i},g);if(!s)return;if(s.wholeRange&&!s.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const r=C.a++;return this.d.set(r,new L(s)),{id:r,placeholder:s.placeholder,input:s.input,slashCommands:s.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:w.Range.from(s.wholeRange),message:s.message}}async $provideResponse(y,v,l,g){const c=this.b.get(y);if(!c)return;const n=this.d.get(v.id);if(!n)return;const i={prompt:l.prompt,selection:w.Selection.to(l.selection),wholeRange:w.Range.to(l.wholeRange),attempt:l.attempt,live:l.live,previewDocument:this.f.getDocument(M.URI.revive(l.previewDocument)),withIntentDetection:l.withIntentDetection};let s=!1;const r={report:async D=>{if(!l.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");s||g.isCancellationRequested||await this.e.$handleProgressChunk(l.requestId,{message:D.message,edits:D.edits?.map(w.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:$.$jN.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(c.provider.provideInteractiveEditorResponse(n.session,i,r,g));let d;try{d=await(0,u.$fh)(t,g)}finally{s=!0}if(!d)return;const a=n.responses.push(d)-1,h={wholeRange:w.Range.from(d.wholeRange),placeholder:d.placeholder};if(!C.h(d))return{...h,id:a,type:"editorEdit",message:w.MarkdownString.from(d.contents),edits:[]};const{edits:o,contents:p}=d,f=p!==void 0?w.MarkdownString.from(p):void 0;return o instanceof $.$5M?{...h,id:a,type:"bulkEdit",edits:w.WorkspaceEdit.from(o),message:f}:{...h,id:a,type:"editorEdit",edits:o.map(w.TextEdit.from),message:f}}async $provideFollowups(y,v,l,g){const c=this.b.get(y),n=this.d.get(v),i=n?.responses[l];if(c&&i&&c.provider.provideFollowups){const s=Promise.resolve(c.provider.provideFollowups(n.session,i,g));return(await(0,u.$fh)(s,g))?.map(w.ChatInlineFollowup.from)}}$handleFeedback(y,v,l,g){const c=this.b.get(y),n=this.d.get(v),i=n?.responses[l];if(c&&i){const s=w.InteractiveEditorResponseFeedbackKind.to(g);c.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,s)}}$releaseSession(y,v){}static h(y){return typeof y=="object"&&typeof y.edits=="object"}}e.$Tlc=C}),define(ke[351],Se([1,0,2,33]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=void 0;class M{constructor(R,w,$,S,L){this.a=w,this.b=$,this.c=S;const C=new N.$FP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$DP("showOptions","Show Options",m=>!0,m=>m),new N.$DP("resource","Interactive resource Uri",m=>!0,m=>m),new N.$DP("controllerId","Notebook controller Id",m=>!0,m=>m),new N.$DP("title","Interactive editor title",m=>!0,m=>m)],new N.$EP("Notebook and input URI",m=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const y=this.a.getEditorById(m.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:u.URI.revive(m.notebookUri),inputUri:u.URI.revive(m.inputUri),notebookEditor:y.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:u.URI.revive(m.notebookUri),inputUri:u.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(R,w,$,S){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,w){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$7lc=M}),define(ke[352],Se([1,0,19,8,22,4,3,27,2,25,12,6,33,16,7,113,296,26,48,297]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=void 0,e.$cmc=o;let s=class{constructor(f,D,b,k,E){this.m=D,this.n=b,this.o=k,this.q=E,this.b=new w.$Bc,this.c=new w.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$be,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=f.getProxy(C.$SM.MainThreadNotebookKernels);const P=new m.$FP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$DP("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const j=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:j}}else if(F&&"notebookEditor"in F){const j=this.n.getIdByEditor(F.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return F})],m.$EP.Void),I=new m.$FP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[m.$DP.Uri],new m.$EP("A promise that resolves to an array of variables",(F,j)=>F.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(I)}createNotebookController(f,D,b,k,E,P){for(const ue of this.j.values())if(ue.controller.id===D&&S.$Mm.equals(f.identifier,ue.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const I=this.k++,F=this;this.q.trace(`NotebookController[${I}], CREATED by ${f.identifier.value}, ${D}`);const j=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${f.identifier}'`);let z=!1;const O=new A.$be,T=new A.$be,B={id:o(f.identifier,D),notebookType:b,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:k||f.identifier.value,preloads:P?P.map(y.NotebookRendererScript.from):[]};let W=E??j,X,Z;this.a.$addKernel(I,B).catch(ue=>{console.log(ue),z=!0});let Y=0;const x=()=>{if(z)return;const ue=++Y;Promise.resolve().then(()=>{ue===Y&&this.a.$updateKernel(I,B)})},ne=new w.$Bc,ge={get id(){return D},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return B.label},set label(ue){B.label=ue??f.displayName??f.name,x()},get detail(){return B.detail??""},set detail(ue){B.detail=ue,x()},get description(){return B.description??""},set description(ue){B.description=ue,x()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ue){B.supportedLanguages=ue,x()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){B.supportsExecutionOrder=ue,x()},get rendererScripts(){return B.preloads?B.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(ue){W=ue??j},get interruptHandler(){return X},set interruptHandler(ue){X=ue,B.supportsInterrupt=!!ue,x()},set variableProvider(ue){(0,c.$AG)(f,"notebookVariableProvider"),Z=ue,B.hasVariableProvider=!!ue,ue?.onDidChangeVariables(ve=>F.a.$variablesUpdated(ve.uri)),x()},get variableProvider(){return Z},createNotebookCellExecution(ue){if(z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ue.notebook.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return F._createNotebookCellExecution(ue,o(f.identifier,this.id))},createNotebookExecution(ue){if((0,c.$AG)(f,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ue.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.uri.toString()}`);return F._createNotebookExecution(ue,o(f.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${I}], DISPOSED`),z=!0,this.j.delete(I),O.dispose(),T.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ue,ve){ve===v.NotebookControllerAffinity2.Hidden&&(0,c.$AG)(f,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(I,ue.uri,ve)},onDidReceiveMessage:T.event,postMessage(ue,ve){return(0,c.$AG)(f,"notebookMessaging"),F.a.$postMessage(I,ve&&F.n.getIdByEditor(ve),ue)},asWebviewUri(ue){return(0,c.$AG)(f,"notebookMessaging"),(0,l.$_xb)(ue,F.m.remote)}};return this.j.set(I,{extensionId:f.identifier,controller:ge,onDidReceiveMessage:T,onDidChangeSelection:O,associatedNotebooks:ne}),ge}getIdByController(f){for(const[D,b]of this.j)if(b.controller===f)return o(b.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,D){const b=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(b,D);const E={dispose:()=>{this.f.delete(b),k.a.$removeKernelDetectionTask(b)}};return this.f.set(b,E),E}registerKernelSourceActionProvider(f,D,b){const k=this.i++,E=typeof b.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,P=this;this.h.set(k,b),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,D);let I;return E!==void 0&&(I=b.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(E))),{dispose:()=>{this.h.delete(k),P.a.$removeKernelSourceActionProvider(k,k),I?.dispose()}}}async $provideKernelSourceActions(f,D){const b=this.h.get(f);if(b){const k=new R.$Tc;return(await b.provideNotebookKernelSourceActions(D)??[]).map(P=>y.NotebookKernelSourceAction.from(P,this.o.converter,k))}return[]}$acceptNotebookAssociation(f,D,b){const k=this.j.get(f);if(k){const E=this.n.getNotebookDocument($.URI.revive(D));b?k.associatedNotebooks.set(E.uri,!0):k.associatedNotebooks.delete(E.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,E.uri.toString(),b),k.onDidChangeSelection.fire({selected:b,notebook:E.apiNotebook})}}async $executeCells(f,D,b){const k=this.j.get(f);if(!k)return;const E=this.n.getNotebookDocument($.URI.revive(D)),P=[];for(const I of b){const F=E.getCell(I);F&&P.push(F.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,E.uri.toString(),P.length),await k.controller.executeHandler.call(k.controller,P,E.apiNotebook,k.controller)}catch(I){this.q.error(`NotebookController[${f}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(f,D,b){const k=this.j.get(f);if(!k)return;const E=this.n.getNotebookDocument($.URI.revive(D));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,E.apiNotebook);else for(const P of b){const I=E.getCell(P);I&&this.b.get(I.uri)?.cancel()}if(k.controller.interruptHandler){const P=this.c.get(E.uri);b.length&&Array.isArray(P)&&P.length&&P.forEach(I=>I.dispose())}}async $provideVariables(f,D,b,k,E,P,I){const F=this.j.get(f);if(!F)return;const j=this.n.getNotebookDocument($.URI.revive(b)),z=F.controller.variableProvider;if(!z)return;let O;if(k!==void 0){if(O=this.s[k],!O)return}else this.s={};const T=E==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,B=z.provideVariables(j.apiNotebook,O,T,P,I);let W=0;for await(const X of B){if(I.isCancellationRequested)return;const Z={id:this.r++,name:X.variable.name,value:X.variable.value,type:X.variable.type,interfaces:X.variable.interfaces,language:X.variable.language,expression:X.variable.expression,hasNamedChildren:X.hasNamedChildren,indexedChildrenCount:X.indexedChildrenCount,extensionId:F.extensionId.value};if(this.s[Z.id]=X.variable,this.a.$receiveVariable(D,Z),W++>=i.$Pib)return}}$acceptKernelMessageFromRenderer(f,D,b){const k=this.j.get(f);if(!k)return;const E=this.n.getEditorById(D);k.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:b}))}$cellExecutionChanged(f,D,b){const E=this.n.getNotebookDocument($.URI.revive(f)).getCell(D);if(E){const P=b?y.NotebookCellExecutionState.to(b):v.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:E.apiCell,state:P})}}_createNotebookCellExecution(f,D){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const E=new t(D,k,this.a);this.b.set(k.uri,E);const P=E.onDidChangeState(()=>{E.state===r.Resolved&&(E.dispose(),P.dispose(),this.b.delete(k.uri))});return E.asApiObject()}_createNotebookExecution(f,D){const b=this.n.getNotebookDocument(f.uri),k=f.getCells().find(I=>{const F=b.getCellFromApiCell(I);return F&&this.b.has(F.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const E=new a(D,b,this.a),P=E.onDidChangeState(()=>{E.state===d.Resolved&&(E.dispose(),P.dispose(),this.c.delete(b.uri))});return this.c.set(b.uri,[E,P]),E.asApiObject()}};e.$bmc=s,e.$bmc=s=Qe([Ve(4,L.$Xj)],s);var r;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(r||(r={}));class t extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(f,D,b){super(),this.m=D,this.n=b,this.b=t.a++,this.c=new A.$be,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new M.$me),this.h=new h(10,k=>this.s(k)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const D=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$ow(D))}t(){if(this.f===r.Init)throw new Error("Must call start before modifying cell output");if(this.f===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let D=this.m;if(f&&(D=this.m.notebook.getCellFromApiCell(f)),!D)throw new Error("INVALID cell");return D.handle}y(f){return f.map(D=>{const b=v.$nO.ensureUniqueMimeTypes(D.items,!0);return b===D.items?y.NotebookCellOutput.from(D):y.NotebookCellOutput.from({items:b,id:D.id,metadata:D.metadata})})}async z(f,D,b){const k=this.w(D),E=this.y((0,u.$3b)(f));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:k,append:b,outputs:E})}async C(f,D,b){return f=v.$nO.ensureUniqueMimeTypes((0,u.$3b)(f),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:f.map(y.NotebookCellOutputItem.from),outputId:D.id,append:b})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(b){f.j=b,f.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(b){if(f.f===r.Resolved||f.f===r.Started)throw new Error("Cannot call start again");f.f=r.Started,f.c.fire(),f.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,k,E){if(f.f===r.Resolved)throw new Error("Cannot call resolve twice");f.f=r.Resolved,f.c.fire(),f.h.flush();const P=E?{message:E.message,stack:E.stack,location:E?.location?{startLineNumber:E.location.start.line,startColumn:E.location.start.character,endLineNumber:E.location.end.line,endColumn:E.location.end.character}:void 0,uri:E.uri}:void 0;f.n.$completeExecution(f.b,new n.$ow({runEndTime:k,lastRunSuccess:b,error:P}))},clearOutput(b){return f.t(),f.z([],b,!1)},appendOutput(b,k){return f.t(),f.z(b,k,!0)},replaceOutput(b,k){return f.t(),f.z(b,k,!1)},appendOutputItems(b,k){return f.t(),f.C(b,k,!0)},replaceOutputItems(b,k){return f.t(),f.C(b,k,!1)}})}}var d;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(d||(d={}));class a extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(f,D,b){super(),this.h=D,this.j=b,this.b=a.a++,this.c=new A.$be,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new M.$me),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===d.Resolved||this.f===d.Started)throw new Error("Cannot call start again");this.f=d.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===d.Resolved)throw new Error("Cannot call resolve twice");this.f=d.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class h{constructor(f,D){this.f=f,this.g=D,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new N.$Oh,this.b=Date.now(),(0,N.$sh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>f.complete())}}function o(p,f){return`${p.value}/${f}`}}),define(ke[43],Se([1,0,4,6,5,2,20,3,7,226,13,272,22,30,273,57,8,16,33]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=e.$nlc=e.$mlc=void 0,e.$mlc=(0,M.$ri)("IExtHostTerminalService");class i extends w.$Uc{constructor(b,k,E,P){super(),this.u=b,this._id=k,this.w=E,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new u.$be),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(F=>this.g=F);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(F,j=!0){I.C(),I.u.$sendText(I._id,F,j)},show(F){I.C(),I.u.$show(I._id,F)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(b,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??k?.cwd??void 0,env:b.env??void 0,icon:o(b.iconPath)??void 0,color:l.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,forceShellIntegration:k?.forceShellIntegration??void 0,isFeatureTerminal:k?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:k?.useShellEnvironment??void 0,location:k?.location||this.z(b.location,k?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,k,E,P,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:l.ThemeColor.isThemeColor(I)?I.id:void 0,location:k?.location||this.z(b,E),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(b,k){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&k?{parentTerminal:k}:"viewColumn"in b?{viewColumn:c.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.y=b}setExitStatus(b,k){this.j=Object.freeze({code:b,reason:k})}setDimensions(b,k){return b===this.f&&k===this.h||b===0||k===0?!1:(this.f=b,this.h=k,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(b){this.n=b}_setProcessId(b){this.g?(this.g(b),this.g=void 0):this.b.then(k=>{k!==b&&(this.b=Promise.resolve(b))})}}e.$nlc=i;class s{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new u.$be,this.onProcessData=this.a.event,this.b=new u.$be,this.d=new u.$be,this.onDidChangeProperty=this.d.event,this.f=new u.$be,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,k){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${k}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,k){this.g.setDimensions?.({columns:b,rows:k})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(k=>this.a.fire(k)),this.g.onDidClose?.((k=void 0)=>{this.f.fire(k===void 0?void 0:k)}),this.g.onDidOverrideDimensions?.(k=>{k&&this.d.fire({type:"overrideDimensions",value:{cols:k.columns,rows:k.rows}})}),this.g.onDidChangeName?.(k=>{this.d.fire({type:"title",value:k})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let r=1,t=class extends w.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,k,E){super(),this.Q=k,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new w.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new u.$be,this.onDidCloseTerminal=this.H.event,this.I=new u.$be,this.onDidOpenTerminal=this.I.event,this.J=new u.$be,this.onDidChangeActiveTerminal=this.J.event,this.L=new u.$be,this.onDidChangeTerminalDimensions=this.L.event,this.M=new u.$be,this.onDidChangeTerminalState=this.M.event,this.N=new u.$be,this.onDidChangeShell=this.N.event,this.O=new u.$be({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new u.$be({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(N.$SM.MainThreadTerminalService),this.y=new v.$$sb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:P=>{const I=F=>{const j=F;return this.getTerminalById(j.instanceId)?.value};switch(P?.$mid){case 15:return I(P);default:{if(Array.isArray(P))for(let F=0;F<P.length&&P[F].$mid===15;F++)P[F]=I(P[F]);return P}}}}),this.B({dispose:()=>{for(const[P,I]of this.g)I.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,k){const E=new i(this.a,(0,y.$Ng)(),b,b.name),P=new s(b.pty);return E.createExtensionTerminal(b.location,k,this.R(b,k).resolvedExtHostIdentifier,o(b.iconPath),p(b.color)).then(I=>{const F=this.S(I,P);this.h[I]=F}),this.f.push(E),E.value}R(b,k){if(k=k||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const E=b.location.parentTerminal;if(E){const P=this.f.find(I=>I.value===E);P&&(k.resolvedExtHostIdentifier=P._id)}}else b.location&&typeof b.location!="object"?k.location=b.location:k.location&&typeof k.location=="object"&&"splitActiveTerminal"in k.location&&(k.location={splitActiveTerminal:!0});return k}attachPtyToTerminal(b,k){if(!this.getTerminalById(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const P=new s(k),I=this.S(b,P);this.h[b]=I}async $acceptActiveTerminalChanged(b){const k=this.b;if(b===null){this.b=void 0,k!==this.b&&this.J.fire(this.b);return}const E=this.getTerminalById(b);E&&(this.b=E,k!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,k){const E=this.getTerminalById(b);E&&this.O.fire({terminal:E.value,data:k})}async $acceptTerminalDimensions(b,k,E){const P=this.getTerminalById(b);P&&P.setDimensions(k,E)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(b,k){const E=this.getTerminalById(b);E&&this.P.fire({terminal:E.value,...k})}async $acceptTerminalMaximumDimensions(b,k,E){this.g.get(b)?.resize(k,E)}async $acceptTerminalTitleChange(b,k){const E=this.getTerminalById(b);E&&(E.name=k)}async $acceptTerminalClosed(b,k,E){const P=this.X(this.f,b);if(P!==null){const I=this.f.splice(P,1)[0];I.setExitStatus(k,E),this.H.fire(I.value)}}$acceptTerminalOpened(b,k,E,P){if(k){const j=this.X(this.f,k);if(j!==null){this.f[j]._id=b,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const I={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:A.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},F=new i(this.a,b,I,E);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(b,k){this.getTerminalById(b)?._setProcessId(k)}async $startExtensionTerminal(b,k){const E=this.getTerminalById(b);if(!E)return{message:(0,S.localize)(0,null,b)};E.isOpen||await new Promise(I=>{const F=this.onDidOpenTerminal(async j=>{j===E.value&&(F.dispose(),I())})});const P=this.g.get(b);P?P.startSendingEvents(k):this.j[b]={initialDimensions:k}}S(b,k){const E=new w.$Tc;E.add(k.onProcessReady(I=>this.a.$sendProcessReady(b,I.pid,I.cwd,I.windowsPty))),E.add(k.onDidChangeProperty(I=>this.a.$sendProcessProperty(b,I))),this.y.startBuffering(b,k.onProcessData),E.add(k.onProcessExit(I=>this.U(b,I))),this.g.set(b,k);const P=this.j[b];return P&&k instanceof s&&(k.startSendingEvents(P.initialDimensions),delete this.j[b]),E}$acceptProcessAckDataEvent(b,k){this.g.get(b)?.acknowledgeDataEvent(k)}$acceptProcessInput(b,k){this.g.get(b)?.input(k)}$acceptTerminalInteraction(b){const k=this.getTerminalById(b);k?.setInteractedWith()&&this.M.fire(k.value)}$acceptTerminalSelection(b,k){this.getTerminalById(b)?.setSelection(k)}$acceptProcessResize(b,k,E){try{this.g.get(b)?.resize(k,E)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(b,k){this.g.get(b)?.shutdown(k)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(k=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:k}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(k=>this.a.$sendProcessProperty(b,{type:"cwd",value:k}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new $.$UM(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,k,E){if(this.C.has(k))throw new Error(`Terminal profile provider "${k}" already registered`);return this.C.set(k,E),this.a.$registerProfileProvider(k,b.identifier.value),new $.$UM(()=>{this.C.delete(k),this.a.$unregisterProfileProvider(k)})}registerTerminalQuickFixProvider(b,k,E){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,E),this.a.$registerQuickFixProvider(b,k),new $.$UM(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,k){const E=new m.$me().token;if(E.isCancellationRequested)return;const P=this.D.get(b);if(!P)return;const I=await P.provideTerminalQuickFixes(k,E);if(I===null||Array.isArray(I)&&I.length===0)return;const F=new w.$Tc;if(this.w.value=F,!Array.isArray(I))return I?c.TerminalQuickFix.from(I,this.Q.converter,F):void 0;const j=[];for(const z of I){const O=c.TerminalQuickFix.from(z,this.Q.converter,F);O&&j.push(O)}return j}async $createContributedProfileTerminal(b,k){const E=new m.$me().token;let P=await this.C.get(b)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,k);return}this.createTerminalFromOptions(P.options,k)}}async $provideLinks(b,k){const E=this.getTerminalById(b);if(!E)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const I=new m.$me;this.G.set(b,I);const F=[],j={terminal:E.value,line:k},z=[];for(const B of this.z)z.push(g.Promises.withAsyncBody(async W=>{I.token.onCancellationRequested(()=>W({provider:B,links:[]}));const X=await B.provideTerminalLinks(j,I.token)||[];I.token.isCancellationRequested||W({provider:B,links:X})}));const O=await Promise.all(z);if(I.token.isCancellationRequested)return[];const T=new Map;for(const B of O)B&&B.links.length>0&&F.push(...B.links.map(W=>{const X={id:r++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return T.set(X.id,{provider:B.provider,link:W}),X}));return this.F.set(b,T),F}$activateLink(b,k){const E=this.F.get(b)?.get(k);E&&E.provider.handleTerminalLink(E.link)}U(b,k){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const E=this.h[b];E&&(E.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,k)}getTerminalById(b){return this.W(this.f,b)}getTerminalIdByApiObject(b){const k=this.f.findIndex(E=>E.value===b);return k>=0?k:null}W(b,k){const E=this.X(b,k);return E!==null?b[E]:null}X(b,k){const E=b.findIndex(P=>P._id===k);return E>=0?E:null}getEnvironmentVariableCollection(b){let k=this.n.get(b.identifier.value);return k||(k=new d,this.Z(b.identifier.value,k)),k.getScopedEnvironmentVariableCollection(void 0)}Y(b,k){const E=(0,C.$fs)(k.map),P=(0,C.$gs)(k.descriptionMap);this.a.$setEnvironmentVariableCollection(b,k.persistent,E.length===0?void 0:E,P)}$initEnvironmentVariableCollections(b){b.forEach(k=>{const E=k[0],P=new d(k[1]);this.Z(E,P)})}$acceptDefaultProfile(b,k){const E=this.s;this.s=b,this.u=k,E?.path!==b.path&&this.N.fire(b.path)}Z(b,k){this.n.set(b,k),k.onDidChangeCollection(()=>{this.Y(b,k)})}};e.$olc=t,e.$olc=t=Qe([Ve(1,n.$BP),Ve(2,R.$fP)],t);class d{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new u.$be,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const k=this.h(b);let E=this.a.get(k);return E||(E=new a(this,b),this.a.set(k,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(b,k,E,P){this.f(b,{value:k,type:$.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:P})}append(b,k,E,P){this.f(b,{value:k,type:$.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:P})}prepend(b,k,E,P){this.f(b,{value:k,type:$.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:P})}f(b,k){if(k.options&&k.options.applyAtProcessCreation===!1&&!k.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(b,k.scope),P=this.map.get(E),I=k.options?{applyAtProcessCreation:k.options.applyAtProcessCreation??!1,applyAtShellIntegration:k.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==k.value||P.type!==k.type||P.options?.applyAtProcessCreation!==I.applyAtProcessCreation||P.options?.applyAtShellIntegration!==I.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==k.scope?.workspaceFolder?.index){const F=this.g(b,k.scope),j={variable:b,...k,options:I};this.map.set(F,j),this.d.fire()}}get(b,k){const E=this.g(b,k),P=this.map.get(E);return P?f(P):void 0}g(b,k){const E=this.h(k);return E.length?`${b}:::${E}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const k=new Map;for(const[E,P]of this.map)this.h(P.scope)===this.h(b)&&k.set(P.variable,f(P));return k}delete(b,k){const E=this.g(b,k);this.map.delete(E),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[k,E]of this.map)E.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(k);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,k){const E=this.h(k),P=this.descriptionMap.get(E);if(!P||P.description!==b){let I;typeof b=="string"?I=b:I=b?.value.split(`

`)[0];const F={description:I,scope:k};this.descriptionMap.set(E,F),this.d.fire()}}getDescription(b){const k=this.h(b);return this.descriptionMap.get(k)?.description}k(b){const k=this.h(b);this.descriptionMap.delete(k)}}class a{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,k){this.b=b,this.d=k,this.a=new u.$be}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,k,E){this.b.replace(b,k,E,this.d)}append(b,k,E){this.b.append(b,k,E,this.d)}prepend(b,k,E){this.b.prepend(b,k,E,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,k){this.b.getVariableMap(this.d).forEach((E,P)=>b.call(k,P,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let h=class extends t{constructor(b,k){super(!1,b,k)}createTerminal(b,k,E){throw new L.$_}createTerminalFromOptions(b,k){throw new L.$_}};e.$plc=h,e.$plc=h=Qe([Ve(0,n.$BP),Ve(1,R.$fP)],h);function o(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function p(D){return l.ThemeColor.isThemeColor(D)?D:void 0}function f(D){const b={...D};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(ke[155],Se([1,0,7,3,5,6,20,43,4,2,8]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=void 0,e.$tmc=(0,M.$ri)("IExtHostTerminalShellIntegration");let C=class extends N.$Uc{constructor(g,c){super(),this.h=c,this.b=new Map,this.c=new $.$be,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$be,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$be,this.onDidEndTerminalShellExecution=this.g.event,this.a=g.getProxy(A.$SM.MainThreadTerminalShellIntegration),this.B((0,N.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(g){const c=this.h.getTerminalById(g);if(!c)return;const n=c.value;let i=this.b.get(g);i||(i=new m(c.value,this.f),this.b.set(g,i),i.store.add(c.onWillDispose(()=>this.b.get(g)?.dispose())),i.store.add(i.onDidRequestShellExecution(s=>this.a.$executeCommand(g,s))),i.store.add(i.onDidRequestEndExecution(s=>this.g.fire(s))),i.store.add(i.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),c.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(g,c,n,i,s){this.b.has(g)||this.$shellIntegrationChange(g);const r={value:c,confidence:n,isTrusted:i};this.b.get(g)?.startShellExecution(r,s)}$shellExecutionEnd(g,c,n,i,s){const r={value:c,confidence:n,isTrusted:i};this.b.get(g)?.endShellExecution(r,s)}$shellExecutionData(g,c){this.b.get(g)?.emitData(c)}$cwdChange(g,c){this.b.get(g)?.setCwd((0,S.$wc)(c)?S.URI.revive(c):c)}$closeTerminal(g){this.b.get(g)?.dispose(),this.b.delete(g)}};e.$umc=C,e.$umc=C=Qe([Ve(0,R.$fP),Ve(1,w.$mlc)],C);class m extends N.$Uc{get currentExecution(){return this.a}constructor(g,c){super(),this.j=g,this.m=c,this.b=!1,this.store=this.B(new N.$Tc),this.f=this.B(new $.$be),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$be),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$be),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,s){let r=i;s&&(r+=` "${s.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(r);const t={value:r,confidence:u.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},d=n.startShellExecution(t,n.c,!0).value;return n.b=!0,d}}}startShellExecution(g,c,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new y(g,c);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(g){this.currentExecution?.emitData(g)}endShellExecution(g,c){this.a&&(this.a.endExecution(g),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(g){let c=!1;S.URI.isUri(this.c)?c=!S.URI.isUri(g)||this.c.toString()!==g.toString():this.c!==g&&(c=!0),c&&(this.c=g,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class y{constructor(g,c){this.c=g,this.cwd=c,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return L.$Rh.EMPTY;this.a=new v}return this.a.createIterable()}emitData(g){this.a?.emitData(g)}endExecution(g){g&&(this.c=g),this.a?.endExecution(),this.a=void 0,this.b=!0}}class v extends N.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const g=this.a=new L.$qh;return new L.$Rh(async n=>{this.b.push(n),await g.wait()})}emitData(g){for(const c of this.b)c.emitOne(g)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[353],Se([1,0,8,21,22,4,74,56,3,18,30,12,6,20,154,16,7,68,112,89]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=e.$xmc=e.$wmc=e.$vmc=void 0;let s=class extends $.$Uc{constructor(I,F,j,z){super(),this.w=z,this.f=this.B(new A.$be),this.g=new Map,this.s=this.B(new A.$be),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy(m.$SM.MainThreadTesting),this.m=new D(this.h),this.j=new a(this.h,F),j.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const T=O,B=T.tests[T.tests.length-1].item.extId;return this.g.get(c.$EL.root(B))?.collection.tree.get(B)?.actual??(0,v.$rP)(O)}case 18:{const{test:T,message:B}=O,W=T.item.extId;return{test:this.g.get(c.$EL.root(W))?.collection.tree.get(W)?.actual??(0,v.$rP)({$mid:16,tests:[T]}),message:l.TestMessage.to(B)}}default:return O}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await j.executeCommand("_testing.getExplorerSelection"),T=B=>{const W=this.g.get(c.$EL.root(B));if(W)return c.$EL.isRoot(B)?W.controller:W.collection.tree.get(B)?.actual};return{include:O?.include.map(T).filter(S.$ag)||[],exclude:O?.exclude.map(T).filter(S.$ag)||[]}})}createTestController(I,F,j,z){if(this.g.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const O=new $.$Tc,T=O.add(new v.$uP(F,j,this.w));T.root.label=j;const B=new Map,W=new Set,X=this.h,Z={items:T.root.children,get label(){return j},set label(x){j=x,T.root.label=x,X.$updateController(F,{label:j})},get refreshHandler(){return z},set refreshHandler(x){z=x,X.$updateController(F,{canRefresh:!!x})},get id(){return F},createRunProfile:(x,ne,ge,ue,ve,te)=>{let U=(0,w.$fj)(x);for(;B.has(U);)U++;return new k(this.h,B,W,this.s.event,F,U,x,ne,ge,ue,ve,te)},createTestItem(x,ne,ge){return new v.$sP(F,x,ne,ge)},createTestRun:(x,ne,ge=!0)=>this.j.createTestRun(F,T,x,ne,ge),invalidateTestResults:x=>{if(x===void 0)this.h.$markTestRetired(void 0);else{const ne=x instanceof Array?x:[x];this.h.$markTestRetired(ne.map(ge=>c.$EL.fromExtHostTestItem(ge,F).toString()))}},set resolveHandler(x){T.resolveHandler=x},get resolveHandler(){return T.resolveHandler},dispose:()=>{O.dispose()}};X.$registerTestController(F,j,!!z),O.add((0,$.$Sc)(()=>X.$unregisterTestController(F)));const Y={controller:Z,collection:T,profiles:B,extension:I,activeProfiles:W};return this.g.set(F,Y),O.add((0,$.$Sc)(()=>this.g.delete(F))),O.add(T.onDidGenerateDiff(x=>X.$publishDiff(F,x.map(i.TestsDiffOp.serialize)))),Z}createTestObserver(){return this.m.checkout()}async runTests(I,F=M.CancellationToken.None){const j=h(I);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(j.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:I.include?.map(O=>c.$EL.fromExtHostTestItem(O,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:E[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:I.exclude?.map(O=>O.id)},F)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,F){return(await this.j.getCoverageDetails(I,F))?.map(l.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,F){this.g.get(I)?.profiles.get(F)?.configureHandler?.()}$setDefaultRunProfiles(I){const F=new Map;for(const[j,z]of Object.entries(I)){const O=this.g.get(j);if(!O)continue;const T=new Map,B=z.filter(X=>!O.activeProfiles.has(X)),W=[...O.activeProfiles].filter(X=>!z.includes(X));for(const X of B)T.set(X,!0),O.activeProfiles.add(X);for(const X of W)T.set(X,!1),O.activeProfiles.delete(X);T.size&&F.set(j,T)}this.s.fire(F)}async $refreshTests(I,F){await this.g.get(I)?.controller.refreshHandler?.(F)}$publishTestResults(I){this.results=Object.freeze(I.map(l.TestResults.to).concat(this.results).sort((F,j)=>j.completedAt-F.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,F){const j=this.g.get(c.$EL.fromString(I).controllerId)?.collection;j&&(await j.expand(I,F<0?1/0:F),j.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(F=>i.TestsDiffOp.deserialize({asCanonicalUri:j=>j},F)))}async $runControllerTests(I,F){return Promise.all(I.map(j=>this.y(j,!1,F)))}async $startContinuousRun(I,F){const j=new M.$me(F),z=await Promise.all(I.map(O=>this.y(O,!0,j.token)));return!F.isCancellationRequested&&!z.some(O=>O.error)&&await new Promise(O=>F.onCancellationRequested(O)),j.dispose(!0),z}async y(I,F,j){const z=this.g.get(I.controllerId);if(!z)return{};const{collection:O,profiles:T}=z,B=T.get(I.profileId);if(!B)return{};const W=I.testIds.map(x=>O.tree.get(x)).filter(S.$ag),X=I.excludeExtIds.map(x=>z.collection.tree.get(x)).filter(S.$ag).filter(x=>W.some(ne=>ne.fullId.compare(x.fullId)===2));if(!W.length)return{};const Z=new g.$uO(W.some(x=>x.actual instanceof v.$tP)?void 0:W.map(x=>x.actual),X.map(x=>x.actual),B,F),Y=(0,i.$HL)(I)&&this.j.prepareForMainThreadTestRun(Z,o.fromInternal(I,z.collection),B,j);try{return await B.runHandler(Z,j),{}}catch(x){return{error:String(x)}}finally{Y&&Y.hasRunningTasks&&!j.isCancellationRequested&&await A.Event.toPromise(Y.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$vmc=s,e.$vmc=s=Qe([Ve(0,y.$fP),Ve(1,C.$Xj)],s);const r=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class d extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,F,j,z,O){super(),this.y=I,this.z=F,this.C=j,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$be),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new M.$me(O));const T=this.B(new u.$Dh(()=>this.F(),r));this.B(this.j.token.onCancellationRequested(()=>T.schedule()));const B=new A.$be;this.s=B.event,this.B((0,$.$Sc)(()=>{B.fire(),B.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,F){const[,j,z]=c.$EL.fromString(I).path,O=this.w.get(z);if(!O)return[];const T=this.g.get(j);if(!T)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(T.run,O,F)??[]}createRun(I){const F=this.y.id,j=this.y.controllerId,z=(0,L.$Ng)(),O=X=>(Z,...Y)=>{if(B){this.C.warn(`Setting the state of test "${Z.id}" is a no-op after the run ends.`);return}this.y.isIncluded(Z)&&(this.H(Z),X(Z,...Y))},T=(X,Z)=>{const Y=Z instanceof Array?Z.map(l.TestMessage.from):[l.TestMessage.from(Z)];if(X.uri&&X.range){const x={range:l.Range.from(X.range),uri:X.uri};for(const ne of Y)ne.location=ne.location||x}this.z.$appendTestMessagesInRun(F,z,c.$EL.fromExtHostTestItem(X,j).toString(),Y)};let B=!1;const W={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:X=>{const Z=X.uri.toString(),Y=new c.$EL([F,z,Z]).toString();this.w.set(Z,X),this.z.$appendCoverage(F,z,l.TestCoverage.fromFile(Y,X))},enqueued:O(X=>{this.z.$updateTestStateInRun(F,z,c.$EL.fromExtHostTestItem(X,j).toString(),1)}),skipped:O(X=>{this.z.$updateTestStateInRun(F,z,c.$EL.fromExtHostTestItem(X,j).toString(),5)}),started:O(X=>{this.z.$updateTestStateInRun(F,z,c.$EL.fromExtHostTestItem(X,j).toString(),2)}),errored:O((X,Z,Y)=>{T(X,Z),this.z.$updateTestStateInRun(F,z,c.$EL.fromExtHostTestItem(X,j).toString(),6,Y)}),failed:O((X,Z,Y)=>{T(X,Z),this.z.$updateTestStateInRun(F,z,c.$EL.fromExtHostTestItem(X,j).toString(),4,Y)}),passed:O((X,Z)=>{this.z.$updateTestStateInRun(F,z,c.$EL.fromExtHostTestItem(X,this.y.controllerId).toString(),3,Z)}),appendOutput:(X,Z,Y)=>{B||(Y&&(this.y.isIncluded(Y)?this.H(Y):Y=void 0),this.z.$appendOutputToRun(F,z,N.$Ce.fromString(X),Z&&l.location.from(Z),Y&&c.$EL.fromExtHostTestItem(Y,j).toString()))},end:()=>{B||(B=!0,this.z.$finishedTestRunTask(F,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:W}),this.z.$startedTestRunTask(F,{id:z,name:I,running:!0}),W}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof v.$sP))throw new n.$0O(I.id);if(this.h.has(c.$EL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const F=[],j=this.y.colllection.root;for(;;){const z=l.TestItem.from(I);if(F.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),I===j))break;I=I.parent||j}this.z.$addTestsToRun(this.y.controllerId,this.y.id,F)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(I,F){this.g=I,this.h=F,this.c=new Map,this.f=new Map}getCoverageDetails(I,F){const j=c.$EL.root(I);return this.f.get(j)?.getCoverageDetails(I,F)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[F,{id:j}]of this.c)j===I&&this.c.delete(F)}prepareForMainThreadTestRun(I,F,j,z){return this.j(I,F,j,z)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,F,j,z,O){const T=this.c.get(j);if(T)return T.createRun(z);const B=o.fromPublic(I,F,j,O),W=h(j);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!j.continuous,profile:W&&{group:E[W.kind],id:W.profileId},exclude:j.exclude?.map(Z=>c.$EL.fromExtHostTestItem(Z,F.root.id).toString())??[],id:B.id,include:j.include?.map(Z=>c.$EL.fromExtHostTestItem(Z,F.root.id).toString())??[F.root.id],persist:O});const X=this.j(j,B,j.profile);return A.Event.once(X.onEnd)(()=>{this.g.$finishedExtensionTestRun(B.id)}),X.createRun(z)}j(I,F,j,z){const O=new d(F,this.g,this.h,j,z);return this.c.set(I,O),this.f.set(O.id,O),O}}e.$wmc=a;const h=P=>{if(P.profile){if(!(P.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class o{static fromPublic(I,F,j,z){return new o(I,(0,L.$Ng)(),j.include?.map(O=>c.$EL.fromExtHostTestItem(O,I).toString())??[I],j.exclude?.map(O=>c.$EL.fromExtHostTestItem(O,I).toString())??[],z,F)}static fromInternal(I,F){return new o(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,F)}constructor(I,F,j,z,O,T){this.controllerId=I,this.id=F,this.isPersisted=O,this.colllection=T,this.c=j.map(B=>B+"\0"),this.f=z.map(B=>B+"\0")}isIncluded(I){const F=c.$EL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const j of this.f)if(F===j||F.startsWith(j))return!1;for(const j of this.c)if(F===j||F.startsWith(j))return!0;return!1}}e.$xmc=o;class p{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,l.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const F=c.$EL.parentId(I.item.extId);if(F&&this.h.has(F.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:F,g:j}=this;return{get added(){return[...I].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...j].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends i.$NL{constructor(){super(...arguments),this.s=new A.$be,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,F){return{...I,revived:l.TestItem.toPlain(I.item),depth:F?F.depth+1:0,children:new Set}}v(){return new p(this.s)}}class D{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(F=>F.revived)},dispose:(0,R.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new f({asCanonicalUri:F=>F});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const b=(P,I,F,j)=>{F?Object.assign(F,j):I.$updateTestRunConfig(P.controllerId,P.profileId,j)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,b(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,b(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),b(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,b(this,this.#e,this.#n,{tag:I?l.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,b(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return A.Event.chain(this.#i,I=>I.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(S.$ag))}constructor(I,F,j,z,O,T,B,W,X,Z=!1,Y=void 0,x=!1){this.controllerId=O,this.profileId=T,this.f=B,this.kind=W,this.runHandler=X,this._tag=Y,this.g=x,this.#e=I,this.#s=F,this.#t=j,this.#i=z,F.set(T,this);const ne=E[W];if(typeof ne!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);Z&&j.add(T),this.#n={profileId:T,controllerId:O,tag:Y?l.TestTag.namespace(this.controllerId,Y.id):null,label:B,group:ne,isDefault:Z,hasConfigurationHandler:!1,supportsContinuousRun:x},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$ymc=k;const E={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(ke[156],Se([1,0,62,13,124,16,7]),function(le,e,u,N,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=e.$nP=e.$mP=void 0;class w{static{this.c=new M.$kP("TextEditorDecorationType")}constructor(m,y,v){const l=w.c.nextId();m.$registerTextEditorDecorationType(y.identifier,l,A.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:l,dispose(){m.$removeTextEditorDecorationType(l)}})}}e.$mP=w;class ${constructor(m,y){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,y){this.k();let v=null;if(m instanceof R.$VM)v=new R.$WM(m,m);else if(m instanceof R.$WM)v=m;else throw new Error("Unrecognized location");this.l(v,y,!1)}insert(m,y){this.k(),this.l(new R.$WM(m,m),y,!0)}delete(m){this.k();let y=null;if(m instanceof R.$WM)y=m;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(m,y,v){const l=this.c.validateRange(m);this.g.push({range:l,text:y,forceMoveMarkers:v})}setEndOfLine(m){if(this.k(),m!==R.EndOfLine.LF&&m!==R.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=m}}class S{constructor(m,y,v,l){this.c=m,this.d=y,this._accept(v),this.e=l;const g=this;this.value={get tabSize(){return g.f},set tabSize(c){g.n(c)},get indentSize(){return g.g},set indentSize(c){g.p(c)},get insertSpaces(){return g.j},set insertSpaces(c){g.s(c)},get cursorStyle(){return g.k},set cursorStyle(c){g.t(c)},get lineNumbers(){return g.l},set lineNumbers(c){g.u(c)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const y=Math.floor(m);return y>0?y:null}if(typeof m=="string"){const y=parseInt(m,10);return isNaN(y)?null:y>0?y:null}return null}n(m){const y=this.m(m);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const y=Math.floor(m);return y>0?y:null}if(typeof m=="string"){const y=parseInt(m,10);return isNaN(y)?null:y>0?y:null}return null}p(m){const y=this.o(m);if(y!==null){if(typeof y=="number"){if(this.h===y)return;this.g=y,this.h=y}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const y=this.q(m);if(typeof y=="boolean"){if(this.j===y)return;this.j=y}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(m)})))}assign(m){const y={};let v=!1;if(typeof m.tabSize<"u"){const l=this.m(m.tabSize);l==="auto"?(v=!0,y.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,v=!0,y.tabSize=l)}if(typeof m.indentSize<"u"){const l=this.o(m.indentSize);l==="tabSize"?(v=!0,y.indentSize=l):typeof l=="number"&&this.h!==l&&(this.g=l,this.h=l,v=!0,y.indentSize=l)}if(typeof m.insertSpaces<"u"){const l=this.q(m.insertSpaces);l==="auto"?(v=!0,y.insertSpaces=l):this.j!==l&&(this.j=l,v=!0,y.insertSpaces=l)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,v=!0,y.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,v=!0,y.lineNumbers=A.TextEditorLineNumbersStyle.from(m.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,y))}v(m,y){y.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(v)})}}e.$nP=S;class L{constructor(m,y,v,l,g,c,n,i){this.id=m,this.j=y,this.k=v,this.g=!1,this.h=new Set,this.c=g,this.d=new S(this.j,this.id,c,v),this.e=n,this.f=i;const s=this;this.value=Object.freeze({get document(){return l.value},set document(r){throw new N.$9("document")},get selection(){return s.c&&s.c[0]},set selection(r){if(!(r instanceof R.$XM))throw(0,N.$7)("selection");s.c=[r],s.l()},get selections(){return s.c},set selections(r){if(!Array.isArray(r)||r.some(t=>!(t instanceof R.$XM)))throw(0,N.$7)("selections");s.c=r,s.l()},get visibleRanges(){return s.e},set visibleRanges(r){throw new N.$9("visibleRanges")},get options(){return s.d.value},set options(r){s.g||s.d.assign(r)},get viewColumn(){return s.f},set viewColumn(r){throw new N.$9("viewColumn")},edit(r,t={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new $(l.value,t);return r(d),s.m(d)},insertSnippet(r,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=s.c.map(h=>A.Range.from(h));else if(t instanceof R.$VM){const{lineNumber:h,column:o}=A.Position.from(t);a=[{startLineNumber:h,startColumn:o,endLineNumber:h,endColumn:o}]}else if(t instanceof R.$WM)a=[A.Range.from(t)];else{a=[];for(const h of t)if(h instanceof R.$WM)a.push(A.Range.from(h));else{const{lineNumber:o,column:p}=A.Position.from(h);a.push({startLineNumber:o,startColumn:p,endLineNumber:o,endColumn:p})}}return y.$tryInsertSnippet(m,l.value.version,r.value,a,d)},setDecorations(r,t){const d=t.length===0;d&&!s.h.has(r.key)||(d?s.h.delete(r.key):s.h.add(r.key),s.n(()=>{if(A.$cP(t))return y.$trySetDecorations(m,r.key,A.$dP(t));{const a=new Array(4*t.length);for(let h=0,o=t.length;h<o;h++){const p=t[h];a[4*h]=p.start.line+1,a[4*h+1]=p.start.character+1,a[4*h+2]=p.end.line+1,a[4*h+3]=p.end.character+1}return y.$trySetDecorationsFast(m,r.key,a)}}))},revealRange(r,t){s.n(()=>y.$tryRevealRange(m,A.Range.from(r),t||R.TextEditorRevealType.Default))},show(r){y.$tryShowEditor(m,A.ViewColumn.from(r))},hide(){y.$tryHideEditor(m)}})}dispose(){(0,u.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,u.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,u.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,u.ok)(!this.g),this.f=m}_acceptSelections(m){(0,u.ok)(!this.g),this.c=m}async l(){const m=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const y=m.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const v=y.edits.map(g=>g.range);v.sort((g,c)=>g.end.line===c.end.line?g.end.character===c.end.character?g.start.line===c.start.line?g.start.character-c.start.character:g.start.line-c.start.line:g.end.character-c.end.character:g.end.line-c.end.line);for(let g=0,c=v.length-1;g<c;g++){const n=v[g].end;if(v[g+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=y.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,l,{setEndOfLine:typeof y.setEndOfLine=="number"?A.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$oP=L}),define(ke[72],Se([1,0,62,4,3,2,5,6,152,20,156,16,12,27,15,39,46]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=e.$pP=void 0;class c{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(s,r){this.h=s,this.i=r,this.a=null,this.b=new Map,this.c=new y.$Bc,this.d=new N.$be,this.e=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const r=[],t=[],d=[];if(s.removedDocuments)for(const a of s.removedDocuments){const h=A.URI.revive(a),o=this.c.get(h);o?.unref()&&(this.c.delete(h),r.push(o.value))}if(s.addedDocuments)for(const a of s.addedDocuments){const h=A.URI.revive(a.uri);let o=this.c.get(h);if(o&&h.scheme!==v.Schemas.vscodeNotebookCell&&h.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);o||(o=new c(new $.$iP(this.h.getProxy(w.$SM.MainThreadDocuments),h,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(h,o),t.push(o.value)),o.ref()}if(s.removedEditors)for(const a of s.removedEditors){const h=this.b.get(a);this.b.delete(a),h&&d.push(h)}if(s.addedEditors)for(const a of s.addedEditors){const h=A.URI.revive(a.documentUri);u.ok(this.c.has(h),`document '${h}' does not exist`),u.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const o=this.c.get(h).value,p=new L.$oP(a.id,this.h.getProxy(w.$SM.MainThreadTextEditors),this.i,new g.$V(()=>o.document),a.selections.map(C.Selection.to),a.options,a.visibleRanges.map(f=>C.Range.to(f)),typeof a.editorPosition=="number"?C.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,p)}s.newActiveEditor!==void 0&&(u.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,M.$Pc)(r),(0,M.$Pc)(d),s.removedDocuments&&this.e.fire(r),s.addedDocuments&&this.d.fire(t),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return l.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const r=this.b.get(this.a);return s?r:r?.value}allEditors(){return[...this.b.values()]}};e.$pP=n,e.$pP=n=Qe([Ve(0,S.$fP),Ve(1,m.$Xj)],n),e.$qP=(0,R.$ri)("IExtHostDocumentsAndEditors")}),define(ke[354],Se([1,0,19,4,6,156,16,7]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;class ${constructor(L,C){this.i=C,this.a=new N.$be,this.b=new N.$be,this.c=new N.$be,this.d=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(M.$SM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const C=this.i.allEditors();return L?C:C.map(m=>m.value)}async showTextDocument(L,C,m){let y;typeof C=="number"?y={position:R.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?y={position:R.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?R.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:y={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(L.uri,y),l=v&&this.i.getEditor(v);if(l)return l.value;throw v?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,C){return new A.$mP(this.h,L,C).value}$acceptEditorPropertiesChanged(L,C){const m=this.i.getEditor(L);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const y=C.selections.selections.map(R.Selection.to);m._acceptSelections(y)}if(C.visibleRanges){const y=u.$Hb(C.visibleRanges.map(R.Range.to));m._acceptVisibleRanges(y)}if(C.options&&this.b.fire({textEditor:m.value,options:{...C.options,lineNumbers:R.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const y=w.TextEditorSelectionChangeKind.fromValue(C.selections.source),v=C.selections.selections.map(R.Selection.to);this.a.fire({textEditor:m.value,selections:v,kind:y})}if(C.visibleRanges){const y=u.$Hb(C.visibleRanges.map(R.Range.to));this.c.fire({textEditor:m.value,visibleRanges:y})}}$acceptEditorPositionData(L){for(const C in L){const m=this.i.getEditor(C);if(!m)throw new Error("Unknown text editor");const y=R.ViewColumn.to(L[C]);m.value.viewColumn!==y&&(m._acceptViewColumn(y),this.d.fire({textEditor:m.value,viewColumn:y}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.$Rkc=$}),define(ke[355],Se([1,0,2,5,6,3,7,16,25,18]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=e.$Amc=void 0,e.$Amc=(0,N.$ri)("IExtHostTimeline");class L{constructor(y,v){this.b=new Map,this.c=new Map,this.a=y.getProxy(M.$SM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(l,g)=>{if(l&&l.$mid===12)if(this.b.get(l.source)&&$.$Mm.equals(g,this.b.get(l.source)?.extension)){const c=l.uri===void 0?void 0:u.URI.revive(l.uri);return this.c.get(l.source)?.get(C(c))?.get(l.handle)}else return;return l}})}async $getTimeline(y,v,l,g){return this.b.get(y)?.provider.provideTimeline(u.URI.revive(v),l,g)}registerTimelineProvider(y,v,l,g){const c=new A.$Tc,n=this.d(v.id,g,c).bind(this);let i;v.onDidChange&&(i=v.onDidChange(r=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...r,id:v.id}),this));const s=this.c;return this.f({...v,scheme:y,onDidChange:void 0,async provideTimeline(r,t,d){t?.resetCache&&(c.clear(),s.get(v.id)?.clear());const a=await v.provideTimeline(r,t,d);if(a==null)return;const h=n(r,t);return{...a,source:v.id,items:a.items.map(h)}},dispose(){for(const r of s.values())r.get(v.id)?.clear();i?.dispose(),c.dispose()}},l)}d(y,v,l){return(g,c)=>{let n;if(c?.cacheResults){let i=this.c.get(y);i===void 0&&(i=new Map,this.c.set(y,i));const s=C(g);n=i.get(s),n===void 0&&(n=new Map,i.set(s,n))}return i=>{const{iconPath:s,...r}=i,t=`${y}|${i.id??i.timestamp}`;n?.set(t,i);let d,a,h;i.iconPath&&(s instanceof R.$QN?h={id:s.id,color:s.color}:u.URI.isUri(s)?(d=s,a=s):{light:d,dark:a}=s);let o;return R.$jN.isMarkdownString(r.tooltip)?o=w.MarkdownString.from(r.tooltip):(0,S.$5f)(r.tooltip)?o=r.tooltip:R.$jN.isMarkdownString(r.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=w.MarkdownString.from(r.detail)):(0,S.$5f)(r.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=r.detail),{...r,id:r.id??void 0,handle:t,source:y,command:i.command?v.toInternal(i.command,l):void 0,icon:d,iconDark:a,themeIcon:h,tooltip:o,accessibilityInformation:i.accessibilityInformation}}}}f(y,v){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:v}),(0,A.$Sc)(()=>{for(const g of this.c.values())g.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$Bmc=L;function C(m){return m?.toString()}}),define(ke[356],Se([1,0,227,23,2,4,3,288,8,7,18,19,16,80,22,184,26]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;function c(s,r){if((0,L.$5f)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class n extends R.$Uc{constructor(r,t,d){super(),this.f=r,this.g=t,this.h=d,this.a=new Map,this.b=new l.$u9;function a(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:h=>a(h)?this.r(h):Array.isArray(h)&&h.length>0?h.map(o=>a(o)?this.r(o):o):h})}registerTreeDataProvider(r,t,d){const a=this.createTreeView(r,{treeDataProvider:t},d);return{dispose:()=>a.dispose()}}createTreeView(r,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],h=t.dragAndDropController?.dragMimeTypes??[],o=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,f=this.m(r,t,d),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:h,hasHandleDrag:o,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(r,D),k={get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get activeItem(){return(0,g.$AG)(d,"treeViewActiveItem"),f.focusedElement},get onDidChangeActiveItem(){return(0,g.$AG)(d,"treeViewActiveItem"),f.onDidChangeActiveItem},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return f.onDidChangeCheckboxState},get message(){return f.message},set message(E){(0,y.$Qk)(E)&&(0,g.$AG)(d,"treeViewMarkdownMessage"),f.message=E},get title(){return f.title},set title(E){f.title=E},get description(){return f.description},set description(E){f.description=E},get badge(){return f.badge},set badge(E){E!==void 0&&S.ViewBadge.isViewBadge(E)?f.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(f.badge=void 0)},reveal:(E,P)=>f.reveal(E,P),dispose:async()=>{await b,this.a.delete(r),f.dispose()}};return this.B(k),k}$getChildren(r,t){const d=this.a.get(r);return d?d.getChildren(t):Promise.reject(new w.$PF(r))}async $handleDrop(r,t,d,a,h,o,p,f){const D=this.a.get(r);if(!D)return Promise.reject(new w.$PF(r));const b=m.DataTransfer.toDataTransfer(d,async k=>(await this.f.$resolveDropFileData(r,t,k)).buffer);return p===r&&f&&await this.j(b,D,f,h,o),D.onDrop(b,a,h)}async j(r,t,d,a,h){const o=this.b.removeDragOperationTransfer(h);if(o)(await o)?.forEach((p,f)=>{p&&r.set(f,p)});else if(h&&t.handleDrag){const p=t.handleDrag(d,r,a);this.b.addDragOperationTransfer(h,p),await p}return r}async $handleDrag(r,t,d,a){const h=this.a.get(r);if(!h)return Promise.reject(new w.$PF(r));const o=await this.j(new S.$MN,h,t,a,d);if(!(!o||a.isCancellationRequested))return m.DataTransfer.from(o)}async $hasResolve(r){const t=this.a.get(r);if(!t)throw new w.$PF(r);return t.hasResolve}$resolve(r,t,d){const a=this.a.get(r);if(!a)throw new w.$PF(r);return a.resolveTreeItem(t,d)}$setExpanded(r,t,d){const a=this.a.get(r);if(!a)throw new w.$PF(r);a.setExpanded(t,d)}$setSelectionAndFocus(r,t,d){const a=this.a.get(r);if(!a)throw new w.$PF(r);a.setSelectionAndFocus(t,d)}$setVisible(r,t){const d=this.a.get(r);if(!d){if(!t)return;throw new w.$PF(r)}d.setVisible(t)}$changeCheckboxState(r,t){const d=this.a.get(r);if(!d)throw new w.$PF(r);d.setCheckboxState(t)}m(r,t,d){const a=this.B(new i(r,t,this.f,this.g.converter,this.h,d));return this.a.set(r,a),a}r(r){const t=this.a.get(r.$treeViewId);return t&&"$treeItemHandle"in r?t.getExtensionElement(r.$treeItemHandle):t&&"$focusedTreeItem"in r&&r.$focusedTreeItem?t.focusedElement:null}}e.$Cmc=n;class i extends R.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(r=>this.getExtensionElement(r)).filter(r=>!(0,L.$bg)(r))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(r,t,d,a,h,o){if(super(),this.I=r,this.J=d,this.L=a,this.M=h,this.N=o,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$be),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$be),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$be),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$be),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$be),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$be),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$be),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$me,o.contributes&&o.contributes.views)for(const b in o.contributes.views)for(const k of o.contributes.views[b])k.id===r&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let p,f;const D=A.Event.debounce(this.F.event,(b,k)=>(b||(b={message:!1,elements:[]}),k.element!==!1&&(p||(p=new Promise(E=>f=E),this.G=this.G.then(()=>p)),Array.isArray(k.element)?b.elements.push(...k.element):b.elements.push(k.element)),k.message&&(b.message=!0),b),200,!0);this.B(D(({message:b,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const E=f;return p=null,this.$(k).then(()=>E())})),b&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(r){const t=r?this.getExtensionElement(r):void 0;if(r&&!t)return this.M.error(`No tree item with id '${r}' found.`),Promise.resolve([]);let d=this.X(r);return d||(d=await this.Y(t)),d?d.map(a=>a.item):void 0}getExtensionElement(r){return this.j.get(r)}reveal(r,t){t=t||{select:!0,focus:!1};const d=(0,L.$bg)(t.select)?!0:t.select,a=(0,L.$bg)(t.focus)?!1:t.focus,h=(0,L.$bg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):r?this.G.then(()=>this.S(r)).then(o=>this.W(r,o[o.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:o.map(f=>f.item)},{select:d,focus:a,expand:h})),o=>this.M.error(o)):this.J.$reveal(this.I,void 0,{select:d,focus:a,expand:h})}get message(){return this.O}set message(r){this.O=r,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(r){this.P=r,this.J.$setTitle(this.I,r,this.Q)}get description(){return this.Q}set description(r){this.Q=r,this.J.$setTitle(this.I,this.P,r)}get badge(){return this.R}set badge(r){this.R?.value===r?.value&&this.R?.tooltip===r?.tooltip||(this.R=m.ViewBadge.from(r),this.J.$setBadge(this.I,r))}setExpanded(r,t){const d=this.getExtensionElement(r);d&&(t?this.u.fire(Object.freeze({element:d})):this.w.fire(Object.freeze({element:d})))}setSelectionAndFocus(r,t){const d=!(0,C.$ub)(this.s,r);this.s=r;const a=this.t!==t;this.t=t,d&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(r){r!==this.r&&(this.r=r,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(r){const t=(await Promise.all(r.map(async d=>{const a=this.getExtensionElement(d.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:d.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(r,t,d){const a=[];for(const h of r){const o=this.getExtensionElement(h);o&&a.push(o)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(r,t,d){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,$.$jh)(()=>this.g?.handleDrop?this.g.handleDrop(a,r,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(r,t){if(!this.f.resolveTreeItem)return;const d=this.j.get(r);if(d){const a=this.m.get(d);if(a){const h=await this.f.resolveTreeItem(a.extensionItem,d,t)??a.extensionItem;return this.hb(h),a.item.tooltip=this.eb(h.tooltip),a.item.command=this.fb(a.disposableStore,h.command),a.item}}}S(r){return this.U(r).then(t=>t?this.S(t).then(d=>this.W(t,d[d.length-1]).then(a=>(d.push(a),d))):Promise.resolve([]))}U(r){const t=this.m.get(r);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$jh)(()=>this.f.getParent(r))}W(r,t){const d=this.m.get(r);return d?Promise.resolve(d):(0,$.$jh)(()=>this.f.getTreeItem(r)).then(a=>this.kb(r,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const h=this.getExtensionElement(a);if(h){const o=this.m.get(h);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(r){if(r){let t;if(typeof r=="string"){const d=this.getExtensionElement(r);t=d?this.m.get(d):void 0}else t=r;return t&&t.children||void 0}return this.h}async Y(r){this.rb(r);const t=new v.$me(this.Z.token);try{const d=r?this.m.get(r):void 0,a=await this.f.getChildren(r);if(t.token.isCancellationRequested)return;const h=(0,C.$Hb)(a||[]),o=await Promise.all((0,C.$Hb)(h).map(f=>this.f.getTreeItem(f)));if(t.token.isCancellationRequested)return;const p=o.map((f,D)=>f?this.db(h[D],f,d):null);return(0,C.$Hb)(p)}finally{t.dispose()}}$(r){if(r.some(d=>!d))return this.Z.dispose(!0),this.Z=new v.$me,this.tb(),this.J.$refresh(this.I);{const d=this.ab(r);if(d.length)return this.bb(d)}return Promise.resolve(void 0)}ab(r){const t=new Set,d=r.map(h=>this.m.get(h));for(const h of d)if(h&&!t.has(h.item.handle)){let o=h;for(;o&&o.parent&&d.findIndex(p=>o&&o.parent&&p&&p.item.handle===o.parent.item.handle)===-1;){const p=this.j.get(o.parent.item.handle);o=p?this.m.get(p):void 0}o&&!o.parent&&t.add(h.item.handle)}const a=[];return t.forEach(h=>{const o=this.j.get(h);if(o){const p=this.m.get(o);p&&(!p.parent||!t.has(p.parent.item.handle))&&a.push(h)}}),a}bb(r){const t={};return Promise.all(r.map(d=>this.cb(d).then(a=>{a&&(t[d]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(r){const t=this.getExtensionElement(r);if(t){const d=this.m.get(t);if(d)return this.rb(t),(0,$.$jh)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const h=this.ib(t,a,d.parent);return this.pb(t,h,d,d.parent),d.dispose(),h}return null})}return Promise.resolve(null)}db(r,t,d){const a=this.ib(r,t,d);if(t.id&&this.j.has(a.item.handle))throw new Error((0,u.localize)(0,null,t.id));return this.ob(r,a),this.qb(a,d),a}eb(r){return S.$jN.isMarkdownString(r)?m.MarkdownString.from(r):r}fb(r,t){return t?{...this.L.toInternal(t,r),originalId:t.command}:void 0}gb(r){if(r.checkboxState===void 0)return;let t,d,a;return typeof r.checkboxState=="number"?t=r.checkboxState:(t=r.checkboxState.state,d=r.checkboxState.tooltip,a=r.checkboxState.accessibilityInformation),{isChecked:t===S.TreeItemCheckboxState.Checked,tooltip:d,accessibilityInformation:a}}hb(r){if(!S.$HN.isTreeItem(r,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(r,t,d){this.hb(t);const a=this.B(new R.$Tc),h=this.kb(r,t,d),o=this.lb(t);return{item:{handle:h,parentHandle:d?d.item.handle:void 0,label:c(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:o,iconDark:this.mb(t)||o,themeIcon:this.jb(t),collapsibleState:(0,L.$bg)(t.collapsibleState)?S.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(r){return r.iconPath instanceof S.$QN?r.iconPath:void 0}kb(r,{id:t,label:d,resourceUri:a},h,o){if(t)return`${i.b}/${t}`;const p=c(d,this.N),f=h?h.item.handle:i.a;let D=p?p.label:a?(0,N.$2g)(a):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const b=this.m.has(r)?this.m.get(r).item.handle:void 0,k=this.X(h)||[];let E,P=0;do{if(E=`${f}/${P}:${D}`,o||!this.j.has(E)||b===E)break;P++}while(P<=k.length);return E}lb(r){if(r.iconPath&&!(r.iconPath instanceof S.$QN))return typeof r.iconPath=="string"||M.URI.isUri(r.iconPath)?this.nb(r.iconPath):this.nb(r.iconPath.light)}mb(r){if(r.iconPath&&!(r.iconPath instanceof S.$QN)&&r.iconPath.dark)return this.nb(r.iconPath.dark)}nb(r){return M.URI.isUri(r)?r:M.URI.file(r)}ob(r,t){this.j.set(t.item.handle,r),this.m.set(r,t)}pb(r,t,d,a){this.j.delete(t.item.handle),this.m.delete(r),t.item.handle!==d.item.handle&&this.j.delete(d.item.handle),this.ob(r,t);const h=this.X(a)||[],o=h.filter(p=>p.item.handle===d.item.handle)[0];o&&h.splice(h.indexOf(o),1,t)}qb(r,t){t?(t.children||(t.children=[]),t.children.push(r)):(this.h||(this.h=[]),this.h.push(r))}rb(r){if(r){const t=this.m.get(r);if(t){if(t.children)for(const d of t.children){const a=this.j.get(d.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(r){const t=this.m.get(r);if(t){if(t.children)for(const d of t.children){const a=this.j.get(d.item.handle);a&&this.sb(a)}this.m.delete(r),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(r=>r.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[357],Se([1,0,4,3,2,30,16,92,6,7]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class L extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,l,g,c){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new u.$be),this.onDidDispose=this.#d.event,this.#h=this.B(new u.$be),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=l,this.#n=g,this.#i=c.viewType,this.#s=c.panelOptions,this.#o=c.viewColumn,this.#r=c.title,this.#u=c.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,M.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,l){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:R.ViewColumn.from(v),preserveFocus:!!l})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends N.$Uc{static c(){return(0,A.$Ng)()}constructor(v,l,g){super(),this.j=l,this.m=g,this.g=new Map,this.h=new Map,this.f=v.getProxy($.$SM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,l,g,c,n={}){const i=typeof c=="object"?c.viewColumn:c,s={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof c=="object"&&!!c.preserveFocus},r=(0,w.$7kc)(v),t=C.c();this.f.$createWebviewPanel((0,w.$9kc)(v),t,l,{title:g,panelOptions:m(n),webviewOptions:(0,w.$0kc)(v,this.m,n),serializeBuffersForPostMessage:r},s);const d=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,l,g,i,n,d,!0)}$onDidChangeWebviewPanelViewStates(v){const l=Object.keys(v);l.sort((g,c)=>{const n=v[g],i=v[c];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const g of l){const c=this.getWebviewPanel(g);if(!c)continue;const n=v[g];c._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,l,g){if(this.h.has(l))throw new Error(`Serializer for '${l}' already registered`);return this.h.set(l,{serializer:g,extension:v}),this.f.$registerSerializer(l,{serializeBuffersForPostMessage:(0,w.$7kc)(v)}),new S.$UM(()=>{this.h.delete(l),this.f.$unregisterSerializer(l)})}async $deserializeWebviewPanel(v,l,g,c){const n=this.h.get(l);if(!n)throw new Error(`No serializer found for '${l}'`);const{serializer:i,extension:s}=n,r=this.j.createNewWebview(v,g.webviewOptions,s),t=this.createNewWebviewPanel(v,l,g.title,c,g.panelOptions,r,g.active);await i.deserializeWebviewPanel(t,g.state)}createNewWebviewPanel(v,l,g,c,n,i,s){const r=new L(v,this.f,i,{viewType:l,title:g,viewColumn:c,panelOptions:n,active:s});return this.g.set(v,r),r}getWebviewPanel(v){return this.g.get(v)}}e.$$kc=C;function m(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(ke[358],Se([1,0,4,3,92,16,6,7]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class $ extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,m,y,v,l,g){super(),this.#s=!1,this.#u=this.B(new u.$be),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new u.$be),this.onDidDispose=this.#l.event,this.#i=y,this.#a=v,this.#e=C,this.#t=m,this.#n=l,this.#r=g}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class S{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(R.$SM.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,y,v){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:y,extension:C}),this.a.$registerWebviewViewProvider((0,M.$9kc)(C),m,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$7kc)(C)}),new w.$UM(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,y,v,l){const g=this.b.get(m);if(!g)throw new Error(`No view provider found for '${m}'`);const{provider:c,extension:n}=g,i=this.d.createNewWebview(C,{},n),s=new $(C,this.a,m,y,i,!0);this.c.set(C,s),await c.resolveWebviewView(s,{state:v},l)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$Fmc=S}),define(ke[359],Se([1,0,69,15,12,259,32,11]),function(le,e,u,N,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(N.Schemas.file,new S(m),{isCaseSensitive:w.$k})}};e.$knc=$,e.$knc=$=Qe([Ve(0,u.$3kc),Ve(1,M.$Xj)],$);class S{constructor(C){this.b=C,this.a=new A.$7q(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,y){return this.a.writeFile(C,m,{...y,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,y){return this.a.rename(C,m,y)}copy(C,m,y){return this.a.copy(C,m,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(ke[360],Se([1,0,17,64,30,33,3,6,2,20]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;let L=class extends R.$Uc{constructor(m,y){super();const v=m.getProxy(w.$SM.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async l=>{const g=$.URI.file((0,u.$kc)((0,N.tmpdir)(),(0,M.$Ng)()));return await v.$download(l,g),g})}};e.$inc=L,e.$inc=L=Qe([Ve(0,S.$fP),Ve(1,A.$BP)],L)}),define(ke[361],Se([1,0,52,17,2,93,3,15,8,31]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;class L extends A.$5kc{constructor(){super(...arguments),this.i=null}async g(t){const d=await super.g(t);if(d.scheme!==w.Schemas.file)return d;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const a=d.fsPath;let h=0;do{let o;h===0?o=a:o=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${h}`:`${a}-${h}`,await C(o);const p=N.$kc(o,"vscode.lock"),f=await l(this.d,p,!1);if(f)return this.i=f,process.on("exit",()=>{f.dispose()}),M.URI.file(o);h++}while(h<10);return d}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$unc=L;async function C(r){try{await S.Promises.stat(r);return}catch{}try{await S.Promises.mkdir(r,{recursive:!0})}catch{}}const m=1e3,y=10*60*1e3;class v extends R.$Uc{constructor(t,d){super(),this.b=t,this.c=d,this.a=this.B(new $.$Ch),this.a.cancelAndSet(async()=>{const a=await g(t,d);(!a||a.pid!==process.pid)&&(t.info(`Lock '${d}': The lock was lost unexpectedly.`),this.a.cancel());try{await S.Promises.utimes(d,new Date,new Date)}catch(h){t.error(h),t.info(`Lock '${d}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{u.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+t};await S.Promises.writeFile(this.c,JSON.stringify(d),{flag:"w"})}catch(d){this.b.error(d)}}}async function l(r,t,d){try{const h={pid:process.pid,willReleaseAt:0};await S.Promises.writeFile(t,JSON.stringify(h),{flag:"wx"})}catch(h){r.error(h)}const a=await g(r,t);return!a||a.pid!==process.pid?d?(r.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(r.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(r,t)):(r.info(`Lock '${t}': Lock acquired.`),new v(r,t))}async function g(r,t){let d;try{d=await S.Promises.readFile(t)}catch(a){return r.error(a),null}try{return JSON.parse(String(d))}catch(a){return r.error(a),null}}async function c(r,t){let d;try{d=await S.Promises.stat(t)}catch(a){return r.error(a),0}return d.mtime.getTime()}function n(r){try{return process.kill(r,0),!0}catch{return!1}}async function i(r,t){const d=await g(r,t);if(!d)return r.info(`Lock '${t}': Could not read pid of lock holder.`),s(r,t);if(d.willReleaseAt){let f=d.willReleaseAt-Date.now();if(f<5e3){for(f>0?r.info(`Lock '${t}': The lockfile is scheduled to be released in ${f} ms.`):r.info(`Lock '${t}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,$.$sh)(Math.min(100,f)),await c(r,t)===0)return s(r,t);f=d.willReleaseAt-Date.now()}return s(r,t)}}if(!n(d.pid))return r.info(`Lock '${t}': The pid ${d.pid} appears to be gone.`),s(r,t);const a=await c(r,t),h=Date.now()-a;if(h<=y)return r.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null;r.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$sh)(2e3);const o=await c(r,t),p=Date.now()-o;return p<=y?(r.info(`Lock '${t}': The lock does not look stale, elapsed: ${p} ms, giving up.`),null):(r.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),s(r,t))}async function s(r,t){r.info(`Lock '${t}': Deleting a stale lock.`);try{await S.Promises.unlink(t)}catch{}return l(r,t,!0)}}),define(ke[362],Se([1,0,30,20,43,33]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;let R=class extends M.$olc{constructor($,S){super(!0,$,S)}createTerminal($,S,L){return this.createTerminalFromOptions({name:$,shellPath:S,shellArgs:L})}createTerminalFromOptions($,S){const L=new M.$nlc(this.a,(0,u.$Ng)(),$,$.name);return this.f.push(L),L.create($,this.R($,S)),L.value}};e.$Pmc=R,e.$Pmc=R=Qe([Ve(0,A.$BP),Ve(1,N.$fP)],R)}),define(ke[363],Se([1,0,4,38,37,5]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=e.OutputChannelUpdateMode=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=void 0,e.$1L="text/x-code-output",e.$2L="output",e.$3L="Log",e.$4L="text/x-code-log-output",e.$5L="log",e.$6L="workbench.panel.output",e.$7L=new M.$Ij("inOutput",!1),e.$8L=new M.$Ij("activeLogOutput",!1),e.$9L=new M.$Ij("activeLogOutput.levelSettable",!1),e.$0L=new M.$Ij("activeLogOutput.level",""),e.$$L=new M.$Ij("activeLogOutput.levelIsDefault",!1),e.$_L=new M.$Ij("outputView.scrollLock",!1),e.$aM=(0,A.$ri)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$bM={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.a=new Map,this.b=new u.$be,this.onDidRegisterChannel=this.b.event,this.c=new u.$be,this.onDidRemoveChannel=this.c.event}registerChannel(S){this.a.has(S.id)||(this.a.set(S.id,S),this.b.fire(S.id))}getChannels(){const S=[];return this.a.forEach(L=>S.push(L)),S}getChannel(S){return this.a.get(S)}removeChannel(S){this.a.delete(S),this.c.fire(S)}}N.$0n.add(e.$bM.OutputChannels,new w),e.$cM=new M.$Ij("activeOutputChannel","")}),define(ke[157],Se([1,0,6,5,20,25,12,363,69,28,60,189,21,18,32,4,3]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=e.$emc=void 0;class c extends R.$4j{get disposed(){return this.n}constructor(r,t,d,a,h){super(),this.id=r,this.name=t,this.r=d,this.s=a,this.extension=h,this.m=0,this.n=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(r){this.append(r+`
`)}append(r){this.info(r)}clear(){const r=this.m;this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Clear,r)}replace(r){const t=this.m;this.info(r),this.s.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(r,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof r=="boolean"?r:t))}hide(){this.s.$close(this.id)}g(r,t){this.m+=m.$Ce.fromString(t).byteLength,(0,R.log)(this.r,r,t),this.visible&&(this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends c{appendLine(r){this.append(r)}}let i=class{constructor(r,t,d,a,h,o){this.i=t,this.j=d,this.k=a,this.l=h,this.m=o,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=r.getProxy(u.$SM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$Ym)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(r){this.h=r;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(r,t,d){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,h=(0,y.$5f)(t)?t:void 0;if((0,y.$5f)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const p=this.i.environment.extensionLogLevel?.find(([D])=>A.$Mm.equals(d.identifier,D))?.[1];p&&(o=(0,R.$ck)(p));const f=a?this.o(r,o,d):this.n(r,h,d);return f.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),a?this.r(r,o??this.m.getLevel(),f):this.q(r,f)}async n(r,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,h=this.k.extUri.joinPath(a,`${this.f++}-${r.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(r,h,t,d.identifier.value);return new c(p,r,o,this.a,d)}async o(r,t,d){const a=await this.p(d),h=r.replace(/[\\/:\*\?"<>\|]/g,""),o=this.k.extUri.joinPath(a,`${h}.log`),p=`${d.identifier.value}.${h}`,f=this.l.createLogger(o,{id:p,name:r,logLevel:t,extensionId:d.identifier.value});return new n(p,r,f,this.a,d)}p(r){let t=this.d.get(r.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,r.identifier.value);this.d.set(r.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(a){if((0,v.$bl)(a)!==v.FileSystemProviderErrorCode.FileExists)throw a}return d})())}return t}q(r,t){let d=!1;const a=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return r},append(h){a(),t.then(o=>o.append(h))},appendLine(h){a(),t.then(o=>o.appendLine(h))},clear(){a(),t.then(h=>h.clear())},replace(h){a(),t.then(o=>o.replace(h))},show(h,o){a(),t.then(p=>p.show(h,o))},hide(){a(),t.then(h=>h.hide())},dispose(){d=!0,t.then(h=>h.dispose())}}}r(r,t,d){const a=new g.$Tc,h=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},o=a.add(new l.$be);function p(f){t=f,o.fire(f)}return d.then(f=>{a.add(f),f.logLevel!==t&&p(f.logLevel),a.add(f.onDidChangeLogLevel(D=>p(D)))}),{...this.q(r,d),get logLevel(){return t},onDidChangeLogLevel:o.event,trace(f,...D){h(),d.then(b=>b.trace(f,...D))},debug(f,...D){h(),d.then(b=>b.debug(f,...D))},info(f,...D){h(),d.then(b=>b.info(f,...D))},warn(f,...D){h(),d.then(b=>b.warn(f,...D))},error(f,...D){h(),d.then(b=>b.error(f,...D))},dispose(){a.dispose()}}}};e.$emc=i,e.$emc=i=Qe([Ve(0,M.$fP),Ve(1,S.$vP),Ve(2,$.$3kc),Ve(3,L.$Fkc),Ve(4,R.$Yj),Ve(5,R.$Xj)],i),e.$fmc=(0,N.$ri)("IExtHostOutputService")}),define(ke[158],Se([1,0,5,8]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=void 0,e.$bn=(0,u.$ri)("remoteAgentService"),e.$cn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let A=1/0;for(let w=0;w<this.maxSampleCount;w++){const $=await M.getRoundTripTime();if($===void 0)return;A=Math.min(A,$/2),await(0,N.$sh)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(A):R=this.initial.reduce((w,$)=>w+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:A,average:this.average.reduce((w,$)=>w+$,0)/this.average.length,high:typeof R>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[364],Se([1,0,231,85,38,42,54,3,4,158,11,24,8]),function(le,e,u,N,M,A,R,w,$,S,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=void 0,e.$tJ=Object.freeze({id:"application",order:100,title:(0,u.localize)(0,null),type:"object"}),e.$uJ=Object.freeze({id:"workbench",order:7,title:(0,u.localize)(1,null),type:"object"}),e.$vJ=Object.freeze({id:"security",scope:1,title:(0,u.localize)(2,null),type:"object",order:7}),e.$wJ=Object.freeze({id:"problems",title:(0,u.localize)(3,null),type:"object",order:101}),e.$xJ={ConfigurationMigration:"base.contributions.configuration.migration"};class y{constructor(){this.migrations=[],this.a=new $.$be,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new y;M.$0n.add(e.$xJ.ConfigurationMigration,v);let l=class extends w.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async s=>{for(const r of s.added)await this.f(r,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(s=>this.c(s)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(s=>this.g(s,n?.uri))])}async g(n,i){const s=this.a.inspect(n.key,{resource:i}),r=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,d]of r){const a=s[t];if(!a)continue;const h=[];if(a.value!==void 0){const o=await this.h(n,t,a.value,i,void 0);for(const p of o??[])h.push([p,[]])}for(const{identifiers:o,value:p}of a.overrides??[])if(p!==void 0){const f=await this.h(n,t,p,i,o);for(const D of f??[])h.push([D,o])}h.length&&await Promise.allSettled(h.map(async([[o,p],f])=>this.a.updateValue(o,p.value,{resource:i,overrideIdentifiers:f},d)))}}async h(n,i,s,r,t){const d=h=>{const p=this.a.inspect(h,{resource:r})[i];if(p)return t?p.overrides?.find(({identifiers:f})=>(0,C.$2n)(f,t))?.value:p.value},a=await n.migrateFn(s,d);return Array.isArray(a)?a:[[n.key,a]]}};e.$yJ=l,e.$yJ=l=Qe([Ve(0,R.$Xi),Ve(1,A.$Ai)],l);let g=class extends w.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new m.$Oh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!L.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$0n.as(N.$co.Configuration).registerConfiguration({...e.$vJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,u.localize)(4,null)},default:[],markdownDescription:(0,u.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,u.localize)(6,null),scope:2}}})}};e.$zJ=g,e.$zJ=g=Qe([Ve(0,S.$bn)],g)}),define(ke[365],Se([1,0,35,15,17,23,241,364,85,5,38]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Pgb=e.$Ogb=void 0,e.$Qgb=l,e.$Rgb=g,e.$Ogb=(0,S.$ri)("editorResolverService"),e.$Pgb="workbench.editorAssociations";const C=L.$0n.as($.$co.Configuration),m={...w.$uJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var y;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(y||(e.RegisteredEditorPriority=y={}));var v;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function l(c){switch(c){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}function g(c,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const r=typeof c=="string"&&c.indexOf(M.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,A.$2g)(n);return u.$kk(typeof c=="string"?c.toLowerCase():c,r.toLowerCase())}}),define(ke[366],Se([1,0,34,15,17,11,23,2,5,277,42,147,158]),function(le,e,u,N,M,A,R,w,$,S,L,C,m){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=void 0,e.$uM=(0,$.$ri)("pathService");let v=y=class{constructor(g,c,n,i){this.d=g,this.e=c,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??g})()}hasValidBasename(g,c,n){return typeof c=="string"||typeof c>"u"?this.a.then(i=>this.h(g,i,c)):this.h(g,c,n)}h(g,c,n){return g.scheme===N.Schemas.file||g.scheme===N.Schemas.vscodeRemote?(0,u.$pg)(n??(0,R.$2g)(g),c===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,c){if(g.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,S.$rM)(c.getWorkspace());if(n)return n;const i=c.getWorkspace().folders[0];if(i)return i.uri.scheme;const s=c.getWorkspace().configuration;return s?s.scheme:N.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===1?M.$gc:M.$hc)}async fileURI(g){let c="";if(await this.a===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const i=g.indexOf("/",2);i===-1?(c=g.substring(2),g="/"):(c=g.substring(2,i),g=g.substring(i)||"/")}return w.URI.from({scheme:N.Schemas.file,authority:c,path:g,query:"",fragment:""})}};e.$vM=v,e.$vM=v=y=Qe([Ve(1,m.$bn),Ve(2,C.$dM),Ve(3,L.$Ai)],v)}),define(ke[367],Se([1,0,243,19,55,4,56,3,2,54,248,12,66,279,88,42,147,26,22,18,24,37]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=e.OnPortForward=e.$iM=e.$hM=e.TunnelSource=e.TunnelCloseReason=e.$fM=e.$eM=void 0,e.$gM=o,e.$jM=D,e.$kM=b,e.$lM=k,e.$mM=P;const t=10*1e3,d="remote.tunnels.toRestore",a="remote.tunnels.toRestoreExpiration",h=1e3*60*60*24*14;e.$eM="onTunnel",e.$fM=new r.$Ij("forwardedPortsViewEnabled",!1,u.localize(0,null));function o(j){const z=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}var p;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(p||(e.TunnelCloseReason=p={}));var f;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(f||(e.TunnelSource=f={})),e.$hM={source:f.User,description:u.localize(1,null)},e.$iM={source:f.Auto,description:u.localize(2,null)};function D(j,z,O){const T=j.get(k(z,O));if(T)return T;if((0,v.$bw)(z))for(const B of v.$aw){const W=k(B,O);if(j.has(W))return j.get(W)}else if((0,v.$dw)(z))for(const B of v.$cw){const W=k(B,O);if(j.has(W))return j.get(W)}}function b(j,z,O){const T=D(j,z,O);if(T)return T;const B=(0,v.$dw)(z)?"localhost":(0,v.$bw)(z)?"0.0.0.0":void 0;if(B)return D(j,B,O)}function k(j,z){return j+":"+z}var E;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(E||(e.OnPortForward=E={}));function P(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}class I extends w.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new A.$be,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(O=>{(O.affectsConfiguration(I.c)||O.affectsConfiguration(I.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,O,T){let B=this.w(z,O,T,this.j,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const X=this.j[B];X.key===z?(W.onAutoForward=X.onAutoForward??W.onAutoForward,W.elevateIfNeeded=X.elevateIfNeeded!==void 0?X.elevateIfNeeded:W.elevateIfNeeded,W.label=X.label??W.label,W.requireLocalPort=X.requireLocalPort,W.protocol=X.protocol):(W.onAutoForward=W.onAutoForward??X.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:X.elevateIfNeeded,W.label=W.label??X.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??X.protocol),B=this.w(z,O,T,this.j,B+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,i.$5f)(z.host)&&(0,i.$9f)(z.port)}w(z,O,T,B,W){if(W>=B.length)return-1;const X=!(0,v.$bw)(O)&&!(0,v.$dw)(O),Y=B.slice(W).findIndex(x=>(0,i.$9f)(x.key)?X?!1:x.key===z:this.t(x.key)?X?!1:z>=x.key.start&&z<=x.key.end:this.u(x.key)?z===x.key.port&&O===x.key.host:T?x.key.test(T):!1);return Y>=0?Y+W:-1}y(){const z=this.r.getValue(I.c);if(!z||!(0,i.$7f)(z))return[];const O=[];for(const B in z){if(B===void 0)continue;const W=z[B];let X;if(Number(B))X=Number(B);else if((0,i.$5f)(B))if(I.g.test(B)){const Z=B.match(I.g);X={start:Number(Z[1]),end:Number(Z[2])}}else if(I.h.test(B)){const Z=B.match(I.h);X={host:Z[1],port:Number(Z[2])}}else{let Z;try{Z=RegExp(B)}catch{}Z&&(X=Z)}X&&O.push({key:X,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const T=this.r.getValue(I.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(O)}z(z){function O(T,B){return(0,i.$9f)(T.key)?T.key:B.t(T.key)?T.key.start:B.u(T.key)?T.key.port:Number.MAX_VALUE}return z.sort((T,B)=>O(T,this)-O(B,this))}C(){return this.m}static providedActionToAction(z){switch(z){case v.ProvidedOnAutoForward.Notify:return E.Notify;case v.ProvidedOnAutoForward.OpenBrowser:return E.OpenBrowser;case v.ProvidedOnAutoForward.OpenBrowserOnce:return E.OpenBrowserOnce;case v.ProvidedOnAutoForward.OpenPreview:return E.OpenPreview;case v.ProvidedOnAutoForward.Silent:return E.Silent;case v.ProvidedOnAutoForward.Ignore:return E.Ignore;default:return}}async addAttributes(z,O,T){const W=this.r.inspect(I.c).userRemoteValue;let X;!W||!(0,i.$7f)(W)?X={}:X=(0,s.$Xn)(W),X[`${z}`]||(X[`${z}`]={});for(const Z in O)X[`${z}`][Z]=O[Z];return this.r.updateValue(I.c,X,T)}}e.$nM=I;let F=class extends w.$Uc{constructor(z,O,T,B,W,X,Z,Y,x,ne){super(),this.H=z,this.I=O,this.J=T,this.L=B,this.M=W,this.N=X,this.O=Z,this.P=Y,this.Q=x,this.R=ne,this.c=new Map,this.g=new A.$be,this.onForwardPort=this.g.event,this.h=new A.$be,this.onClosePort=this.h.event,this.j=new A.$be,this.onPortName=this.j.event,this.n=new A.$be,this.onCandidatesChanged=this.n.event,this.t=new A.$be,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$be,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new I(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ge=>{const ue=await this.getAttributes(ge.map(ve=>({port:ve.tunnelRemotePort,host:ve.tunnelRemoteHost})));for(const ve of ge)if(ve.localAddress){const te=k(ve.tunnelRemoteHost,ve.tunnelRemotePort),U=b(this.m??new Map,ve.tunnelRemoteHost,ve.tunnelRemotePort);this.forwarded.set(te,{remotePort:ve.tunnelRemotePort,remoteHost:ve.tunnelRemoteHost,localAddress:ve.localAddress,protocol:ue?.get(ve.tunnelRemotePort)?.protocol??v.TunnelProtocol.Http,localUri:await this.X(ve.localAddress,ue?.get(ve.tunnelRemotePort)),localPort:ve.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:ve.privacy,source:e.$hM}),this.f.set(te,ve)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ge=>{const ue=k(ge.tunnelRemoteHost,ge.tunnelRemotePort);if(!b(this.forwarded,ge.tunnelRemoteHost,ge.tunnelRemotePort)&&!b(this.detected,ge.tunnelRemoteHost,ge.tunnelRemotePort)&&!b(this.c,ge.tunnelRemoteHost,ge.tunnelRemotePort)&&ge.localAddress){const ve=b(this.m??new Map,ge.tunnelRemoteHost,ge.tunnelRemotePort),te=(await this.getAttributes([{port:ge.tunnelRemotePort,host:ge.tunnelRemoteHost}]))?.get(ge.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:ge.tunnelRemoteHost,remotePort:ge.tunnelRemotePort,localAddress:ge.localAddress,protocol:te?.protocol??v.TunnelProtocol.Http,localUri:await this.X(ge.localAddress,te),localPort:ge.tunnelLocalPort,closeable:!0,runningProcess:ve?.detail,hasRunningProcess:!!ve,pid:ve?.pid,privacy:ge.privacy,source:e.$hM})}await this.cb(),this.f.set(ue,ge),this.g.fire(this.forwarded.get(ue))})),this.B(this.H.onTunnelClosed(ge=>this.W(ge,p.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$eM))?(this.R.createKey(e.$fM.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,O){const T=k(z.host,z.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(z))}X(z,O){if(z.startsWith("http"))return $.URI.parse(z);const T=O?.protocol??"http";return $.URI.parse(`${T}://${z}`)}async Y(z){const O=this.N.getWorkspace(),T=O.configuration?(0,R.$fj)(O.configuration.path):O.folders.length>0?(0,R.$fj)(O.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${z}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(d)}async $(){return this.Y(a)}async ab(){const z=this.I.get(d,1);if(z)return this.I.remove(d,1),await this.cb(),z;const O=await this.Z();if(O)return this.I.get(O,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const O=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${O.map(T=>T.remotePort).join(", ")}`);for(const T of O){const B=b(this.detected,T.remoteHost,T.remotePort);T.source.source!==f.Extension&&!B||T.source.source===f.Extension&&B?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===f.Extension&&!B&&this.D.set(k(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Z();this.w=this.B(new w.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async O=>{O.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}bb(){const z=this.I.keys(0,0).filter(O=>O.startsWith(a));for(const O of z){const T=this.I.getNumber(O,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const B=O.replace(a,d);this.I.remove(O,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=Array.from(this.forwarded.values()),O=z.map(X=>({remoteHost:X.remoteHost,remotePort:X.remotePort,localPort:X.localPort,name:X.name,localAddress:X.localAddress,localUri:X.localUri,protocol:X.protocol,source:X.source}));let T;z.length>0&&(T=JSON.stringify(O));const B=await this.Z(),W=await this.$();!T&&B&&W?(this.I.remove(B,0),this.I.remove(W,0)):T!==this.y&&B&&W&&(this.I.store(B,T,0,0),this.I.store(W,Date.now()+h,0,0)),this.y=T}}async eb(z,O,T){if(!z.tunnelLocalPort||!T?.requireLocalPort||z.tunnelLocalPort===O)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const W=u.localize(3,null,O,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(W)}async forward(z,O){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(z,O)}async fb(z,O){await this.Q.activateByEvent(e.$eM);const T=b(this.forwarded,z.remote.host,z.remote.port);O=O??(O!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const B=z.local!==void 0?z.local:z.remote.port;let W;if(T)return this.hb(T,z,O);{const X=this.L.remoteAuthority,Z=X?{getAddress:async()=>(await this.M.resolveAuthority(X)).authority}:void 0,Y=k(z.remote.host,z.remote.port);this.c.set(Y,!0),z=this.gb(Y,z);const x=await this.H.openTunnel(Z,z.remote.host,z.remote.port,void 0,B,z.elevateIfNeeded?z.elevateIfNeeded:O?.elevateIfNeeded,z.privacy,O?.protocol);if(typeof x=="string")W=x;else if(x&&x.localAddress){const ne=b(this.m??new Map,z.remote.host,z.remote.port),ge=x.protocol?x.protocol===v.TunnelProtocol.Https?v.TunnelProtocol.Https:v.TunnelProtocol.Http:O?.protocol??v.TunnelProtocol.Http,ue={remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localPort:x.tunnelLocalPort,name:O?.label??z.name,closeable:!0,localAddress:x.localAddress,protocol:ge,localUri:await this.X(x.localAddress,O),runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,source:z.source??e.$hM,privacy:x.privacy};return this.forwarded.set(Y,ue),this.f.set(Y,x),this.c.delete(Y),await this.cb(),await this.eb(x,B,O),this.g.fire(ue),x}this.c.delete(Y)}return W}gb(z,O){const T=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(T){const B=T.get(z);T.delete(z),B&&(O.name=B.name??O.name,O.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??O.local,O.privacy=O.privacy)}return O}async hb(z,O,T){const B=T?.label??O.name;let W;(function(Z){Z[Z.None=0]="None",Z[Z.Fire=1]="Fire",Z[Z.Reopen=2]="Reopen"})(W||(W={}));let X=W.None;switch(B!==z.name&&(z.name=B,X=W.Fire),(T?.protocol||z.protocol!==v.TunnelProtocol.Http)&&T?.protocol!==z.protocol&&(O.source=z.source,X=W.Reopen),O.privacy&&z.privacy!==O.privacy&&(X=W.Reopen),X){case W.Fire:{this.g.fire();break}case W.Reopen:await this.close(z.remoteHost,z.remotePort,p.User),await this.fb(O,T)}return b(this.f,O.remote.host,O.remote.port)}async name(z,O,T){const B=b(this.forwarded,z,O),W=k(z,O);if(B){B.name=T,await this.cb(),this.j.fire({host:z,port:O});return}else this.detected.has(W)&&(this.detected.get(W).name=T,this.j.fire({host:z,port:O}))}async close(z,O,T){const B=k(z,O),W=this.forwarded.get(B);return T===p.AutoForwardEnd&&W&&W.source.source===f.Auto&&this.F.set(B,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.H.closeTunnel(z,O),this.W({host:z,port:O},T)}address(z,O){const T=k(z,O);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const O of z){const T=b(this.m??new Map,O.remoteAddress.host,O.remoteAddress.port),B=typeof O.localAddress=="string"?O.localAddress:k(O.localAddress.host,O.localAddress.port);this.detected.set(k(O.remoteAddress.host,O.remoteAddress.port),{remoteHost:O.remoteAddress.host,remotePort:O.remoteAddress.port,localAddress:B,protocol:v.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:v.TunnelPrivacyId.ConstantPrivate,source:{source:f.Extension,description:u.localize(4,null)}}),this.H.setEnvironmentTunnel(O.remoteAddress.host,O.remoteAddress.port,B,v.TunnelPrivacyId.ConstantPrivate,v.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let O=z;this.r&&(O=await this.r(z));const T=this.ib(O);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(B=>B.port).join(", ")}`),this.n.fire(T)}ib(z){const O=this.m??new Map,T=new Map;return this.m=T,z.forEach(B=>{const W=k(B.host,B.port);T.set(W,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),O.has(W)&&O.delete(W);const X=b(this.forwarded,B.host,B.port);X&&(X.runningProcess=B.detail,X.hasRunningProcess=!0,X.pid=B.pid)}),O.forEach((B,W)=>{const X=o(W);if(!X)return;const Z=b(this.forwarded,X.host,X.port);Z&&(Z.runningProcess=void 0,Z.hasRunningProcess=!1,Z.pid=void 0);const Y=b(this.detected,X.host,X.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0)}),O}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const z=Array.from(this.forwarded.values()),O=await this.getAttributes(z.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(O)for(const T of z){const B=O.get(T.remotePort);(B?.protocol||T.protocol!==v.TunnelProtocol.Http)&&B?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},B),B&&B.label&&B.label!==T.name&&await this.name(T.remoteHost,T.remotePort,B.label)}}async getAttributes(z,O=!0){const T=new Map,B=new Map;z.forEach(x=>{const ne=b(this.m??new Map,v.$aw[0],x.port)??x;if(ne){T.set(x.port,ne);const ge=P(ne)?ne.pid:void 0;B.has(ge)||B.set(ge,[]),B.get(ge)?.push(x.port)}});const W=new Map;if(z.forEach(x=>{const ne=this.configPortsAttributes.getAttributes(x.port,x.host,T.get(x.port)?.detail);ne&&W.set(x.port,ne)}),this.G.length===0||!O)return W.size>0?W:void 0;const X=await Promise.all((0,N.$Rb)(this.G.map(x=>Array.from(B.entries()).map(ne=>{const ge=ne[1],ue=T.get(ge[0]);return x.providePortAttributes(ge,ue?.pid,ue?.detail,n.CancellationToken.None)})))),Z=new Map;if(X.forEach(x=>x.forEach(ne=>{ne&&Z.set(ne.port,ne)})),!W&&!Z)return;const Y=new Map;return z.forEach(x=>{const ne=W.get(x.port),ge=Z.get(x.port);Y.set(x.port,{elevateIfNeeded:ne?.elevateIfNeeded,label:ne?.label,onAutoForward:ne?.onAutoForward??I.providedActionToAction(ge?.autoForwardAction),requireLocalPort:ne?.requireLocalPort,protocol:ne?.protocol})}),Y}addAttributesProvider(z){this.G.push(z)}};e.$oM=F,Qe([(0,M.$Wh)(1e3)],F.prototype,"cb",null),e.$oM=F=Qe([Ve(0,v.$8v),Ve(1,y.$Vp),Ve(2,S.$Xi),Ve(3,g.$dM),Ve(4,m.$Cl),Ve(5,l.$Ai),Ve(6,C.$Xj),Ve(7,L.$Aw),Ve(8,c.$wG),Ve(9,r.$Jj)],F)}),define(ke[94],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$1K=e.$ZK=void 0;class u{constructor(R,w){this.line=R,this.character=w}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,w){return new u(0,0)}with(R){return new u(0,0)}}e.$ZK=u;class N{constructor(R,w,$,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(R,w),this.end=new u($,S)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new N(0,0,0,0)}with(R){return new N(0,0,0,0)}}e.$1K=N;var M;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(ke[36],Se([1,0,19,35,24,34,14,5,17,13,94,8]),function(le,e,u,N,M,A,R,w,$,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nL=e.$lL=e.$eL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$bL=e.$aL=e.$_K=e.$$K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.TextSearchCompleteMessageType=void 0,e.$8K=c,e.$9K=n,e.$0K=i,e.$cL=f,e.$dL=D,e.$fL=E,e.$gL=P,e.$hL=I,e.$iL=F,e.$jL=j,e.$kL=z,e.$mL=T,e.$oL=X,e.$pL=Z,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$2K="workbench.view.search",e.$3K="workbench.panel.search",e.$4K="workbench.view.search",e.$5K="search-result",e.$6K="search.exclude";const m="\u27EA ",y=" characters skipped \u27EB",v=(m.length+y.length+5)*2;e.$7K=(0,w.$ri)("searchService");var l;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(l||(e.SearchProviderType=l={}));var g;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(g||(e.QueryType=g={}));function c(x){return!!x.preview}function n(x){return!!x.resource}function i(x){return!!x.message}var s;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class r{constructor(ne){this.resource=ne,this.results=[]}}e.$$K=r;class t{constructor(ne,ge,ue,ve){this.ranges=ge,this.webviewIndex=ve;const te=Array.isArray(ge)?ge:[ge];if(ue&&ue.matchLines===1&&d(te)){ne=(0,R.$Xf)(ne,ue.matchLines);let U="",_=0,be=0;const Pe=Math.floor(ue.charsPerLine/5),se=[];for(const re of te){const oe=Math.max(re.startColumn-Pe,0),K=re.startColumn+ue.charsPerLine;if(oe>be+Pe+v){const ie=m+(oe-be)+y;U+=ie+ne.slice(oe,K),_+=oe-(be+ie.length)}else U+=ne.slice(be,K);se.push(new h(0,re.startColumn-_,re.endColumn-_)),be=K}this.preview={text:U,matches:Array.isArray(this.ranges)?se:se[0]}}else{const U=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:ne,matches:(0,u.$2b)(ge,_=>new a(_.startLineNumber-U,_.startColumn,_.endLineNumber-U,_.endColumn))}}}}e.$_K=t;function d(x){const ne=x[0].startLineNumber;for(const ge of x)if(ge.startLineNumber!==ne||ge.endLineNumber!==ne)return!1;return!0}class a{constructor(ne,ge,ue,ve){this.startLineNumber=ne,this.startColumn=ge,this.endLineNumber=ue,this.endColumn=ve}}e.$aL=a;class h extends a{constructor(ne,ge,ue){super(ne,ge,ne,ue)}}e.$bL=h;var o;(function(x){x.List="list",x.Tree="tree"})(o||(e.ViewMode=o={}));var p;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function f(x,ne=!0){const ge=x&&x.files&&x.files.exclude,ue=ne&&x&&x.search&&x.search.exclude;if(!ge&&!ue)return;if(!ge||!ue)return ge||ue;let ve=Object.create(null);return ve=M.$1n(ve,M.$Xn(ge)),ve=M.$1n(ve,M.$Xn(ue),!0),ve}function D(x,ne){return x.excludePattern&&N.$kk(x.excludePattern,ne)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&N.$kk(x.includePattern,ne)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(ge=>{const ue=ge.folder.fsPath;if(A.$rg(ne,ue)){const ve=$.$mc(ue,ne);return!ge.includePattern||!!N.$kk(ge.includePattern,ve)}else return!1}):!1:!0}var b;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class k extends Error{constructor(ne,ge){super(ne),this.code=ge}}e.$eL=k;function E(x){const ne=x.message;if((0,S.$4)(x))return new k(ne,b.canceled);try{const ge=JSON.parse(ne);return new k(ge.message,ge.code)}catch{return new k(ne,b.other)}}function P(x){const ne={message:x.message,code:x.code};return new Error(JSON.stringify(ne))}function I(x){return x.type==="error"?!0:x.type==="success"}function F(x){return x.type==="success"}function j(x){return!!x.path}function z(x,ne,ge=!0){const ue=x.searchPath?x.searchPath:x.relativePath;return ge?(0,R.$Uf)(ue,ne):N.$kk(ne,ue)}class O{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$lL=O;function T(x,ne){const ge={...x||{},...ne||{}};return Object.keys(ge).filter(ue=>{const ve=ge[ue];return typeof ve=="boolean"&&ve})}class B{constructor(ne,ge){this.c=null,this.a={...ne.excludePattern||{},...ge.excludePattern||{}},this.b=N.$lk(this.a);let ue=ne.includePattern;ge.includePattern&&(ue?ue={...ue,...ge.includePattern}:ue=ge.includePattern),ue&&(this.c=N.$lk(ue))}matchesExcludesSync(ne,ge,ue){return!!(this.b&&this.b(ne,ge,ue))}includedInQuerySync(ne,ge,ue){return!(this.b&&this.b(ne,ge,ue)||this.c&&!this.c(ne,ge,ue))}includedInQuery(ne,ge,ue){const ve=this.b(ne,ge,ue),te=()=>this.c?!!this.c(ne,ge,ue):!0;return(0,C.$dh)(ve)?ve.then(U=>U?!1:te()):te()}hasSiblingExcludeClauses(){return W(this.a)}}e.$nL=B;function W(x){for(const ne in x)if(typeof x[ne]!="boolean")return!0;return!1}function X(x){if(!x)return;let ne;return ge=>(ne||(ne=(x()||Promise.resolve([])).then(ue=>ue?Y(ue):{})),ne.then(ue=>!!ue[ge]))}function Z(x){if(!x)return;let ne;return ge=>{if(!ne){const ue=x();ne=ue?Y(ue):{}}return!!ne[ge]}}function Y(x){const ne={};for(const ge of x)ne[ge]=!0;return ne}}),define(ke[44],Se([1,0,19,8,22,4,3,77,15,125,23,14,2,229,5,12,262,42,60,28,20,16,7,67,36,6,58]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s,r,t,d,a,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=e.$Wkc=void 0;function p(F,j,z){return new L.$Tg(O=>k(O,z)).isEqual(F,j)}function f(F,j,z){return p(F.uri,j.uri,z)?0:(0,C.$nf)(F.uri.toString(),j.uri.toString())}function D(F,j,z){return F.index!==j.index?F.index<j.index?-1:1:p(F.uri,j.uri,z)?(0,C.$nf)(F.name,j.name):(0,C.$nf)(F.uri.toString(),j.uri.toString())}function b(F,j,z,O){const T=F.slice(0).sort((W,X)=>z(W,X,O)),B=j.slice(0).sort((W,X)=>z(W,X,O));return(0,u.$Eb)(T,B,(W,X)=>z(W,X,O))}function k(F,j){const z=j.getCapabilities(F.scheme);return!(z&&z&1024)}class E extends c.$Ki{static toExtHostWorkspace(j,z,O,T){if(!j)return{workspace:null,added:[],removed:[]};const{id:B,name:W,folders:X,configuration:Z,transient:Y,isUntitled:x}=j,ne=[],ge=z;z?X.forEach((U,_)=>{const be=m.URI.revive(U.uri),Pe=E.o(O||z,be,T);Pe?(Pe.name=U.name,Pe.index=U.index,ne.push(Pe)):ne.push({uri:be,name:U.name,index:_})}):ne.push(...X.map(({uri:U,name:_,index:be})=>({uri:m.URI.revive(U),name:_,index:be}))),ne.sort((U,_)=>U.index<_.index?-1:1);const ue=new E(B,W,ne,!!Y,Z?m.URI.revive(Z):null,!!x,U=>k(U,T)),{added:ve,removed:te}=b(ge?ge.workspaceFolders:[],ue.workspaceFolders,f,T);return{workspace:ue,added:ve,removed:te}}static o(j,z,O){for(let T=0;T<j.folders.length;T++){const B=j.workspaceFolders[T];if(p(B.uri,z,O))return B}}constructor(j,z,O,T,B,W,X){super(j,O.map(Z=>new c.$Li(Z)),T,B,X),this.t=z,this.u=W,this.q=[],this.s=w.$xi.forUris(X),O.forEach(Z=>{this.q.push(Z),this.s.set(Z.uri,Z)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,L.$4g)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let P=class{constructor(j,z,O,T,B){this.c=new A.$be,this.onDidChangeWorkspace=this.c.event,this.g=new A.$be,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new A.$de,this.C=new Map,this.h=T,this.s=O,this.t=B,this.j=new S.$ym,this.k=new N.$qh,this.o=j.getProxy(h.$SM.MainThreadWorkspace),this.q=j.getProxy(h.$SM.MainThreadMessageService);const W=z.workspace;this.l=W?new E(W.id,W.name,[],!!W.transient,W.configuration?m.URI.revive(W.configuration):null,!!W.isUntitled,X=>k(X,O)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,L.$2g)((0,L.$4g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,O,...T){const B=[];if(Array.isArray(T)&&T.forEach(x=>{m.URI.isUri(x.uri)&&!B.some(ne=>p(ne.uri,x.uri,this.s))&&B.push({uri:x.uri,name:x.name||(0,L.$1g)(x.uri)})}),this.n||[z,O].some(x=>typeof x!="number"||x<0)||O===0&&B.length===0)return!1;const W=this.x?this.x.workspaceFolders:[];if(z+O>W.length)return!1;const X=W.slice(0);X.splice(z,O,...B.map(x=>({uri:x.uri,name:x.name||(0,L.$1g)(x.uri),index:void 0})));for(let x=0;x<X.length;x++){const ne=X[x];if(X.some((ge,ue)=>ue!==x&&p(ne.uri,ge.uri,this.s)))return!1}X.forEach((x,ne)=>x.index=ne);const{added:Z,removed:Y}=b(W,X,D,this.s);if(Z.length===0&&Y.length===0)return!1;if(this.o){const x=j.displayName||j.name;this.o.$updateWorkspaceFolders(x,z,O,B).then(void 0,ne=>{this.n=void 0;const ge={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(g.Severity.Error,(0,y.localize)(0,null,x,ne.toString()),ge,[])})}return this.y(X),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let O,T="";if(typeof j=="string"?(O=m.URI.file(j),T=j):typeof j<"u"&&(O=j,T=j.fsPath),!O)return T;const B=this.getWorkspaceFolder(O,!0);if(!B)return T;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let W=(0,L.$7g)(B.uri,O);return z&&B.name&&(W=`${B.name}/${W}`),W}y(j){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:O,removed:T}=E.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:T}))}findFiles(j,z,O,T,B=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let W="",X=!0;return z===null?X=!1:z!==void 0&&(typeof z=="string"?W=z:W=z.pattern),this.z(j,void 0,{exclude:W,maxResults:O,useDefaultExcludes:X,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(j,z={},O,T=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${O.value}, entryPoint: findFiles2`),this.z(void 0,j,z,T)}async z(j,z,O,T=M.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const B=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,W={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof O.useDefaultSearchExcludes=="boolean"?!O.useDefaultSearchExcludes:!1,maxResults:O.maxResults,excludePattern:B,shouldGlobSearch:typeof O.fuzzy=="boolean"?!O.fuzzy:!0,_reason:"startFileSearch"};let X;if(j){const{includePattern:Z,folder:Y}=I(r.GlobPattern.from(j));X=Y,W.includePattern=Z}else{const{includePattern:Z,folder:Y}=I(r.GlobPattern.from(z));X=Y,W.filePattern=Z}return this.o.$startFileSearch(X??null,W,T).then(Z=>Array.isArray(Z)?Z.map(Y=>m.URI.revive(Y)):[])}async findTextInFiles(j,z,O,T,B=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const W=this.j.getNext(),X=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:Z,folder:Y}=I(r.GlobPattern.from(z.include)),x=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ne={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:X,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:Z,excludePattern:x},ge=!1;if(this.u[W]=ue=>{if(ge)return;const ve=m.URI.revive(ue.resource);ue.results.forEach(te=>{const U=(0,o.$1h)(te);(0,a.$8K)(U)?O({uri:ve,preview:{text:U.preview.text,matches:(0,u.$2b)(U.preview.matches,_=>new t.$WM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,u.$2b)(U.ranges,_=>new t.$WM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):O({uri:ve,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const ue=await this.o.$startTextSearch(j,Y??null,ne,W,B);return delete this.u[W],ue||{}}catch(ue){throw delete this.u[W],ue}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return m.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return m.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const O=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,O),(0,R.$Sc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const O=await this.resolveWorkspaceFolder(m.URI.revive(j));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const T=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!T),!T)return;const B=await T.provideEditSessionIdentity(O,z);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(j,z,O,T){this.h.info("Getting edit session identifier for workspaceFolder",j);const B=await this.resolveWorkspaceFolder(m.URI.revive(j));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const W=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!W),!W)return;const X=await W.provideEditSessionIdentityMatch?.(z,O,T);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(j){return(z,O,T)=>{const B=function(X){z.call(O,X)};return B.extension=j,this.B.event(B,void 0,T)}}async $onWillCreateEditSessionIdentity(j,z,O){const T=await this.resolveWorkspaceFolder(m.URI.revive(j));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},z,async(B,W)=>{const X=Date.now();await Promise.resolve(B),Date.now()-X>O&&this.h.warn("SLOW edit session create-participant",W.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const O=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerCanonicalUriProvider(T,O),(0,R.$Sc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(j,z,O){const T=this.C.get(j.scheme);if(!T)return;const B=await T.provideCanonicalUri?.(m.URI.revive(j),z,O);if(B)return B}async $provideCanonicalUri(j,z,O){return this.provideCanonicalUri(m.URI.revive(j),{targetScheme:z},O)}};e.$Wkc=P,e.$Wkc=P=Qe([Ve(0,s.$fP),Ve(1,i.$vP),Ve(2,n.$Fkc),Ve(3,l.$Xj),Ve(4,d.$Ukc)],P),e.$Xkc=(0,v.$ri)("IExtHostWorkspace");function I(F){let j,z;return F&&(typeof F=="string"?j=F:(j=F.pattern,z=m.URI.revive(F.baseUri))),{includePattern:j,folder:z}}}),define(ke[45],Se([1,0,24,4,44,6,7,264,85,18,8,5,20,12,2]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=e.$Zkc=e.$Ykc=void 0;function l(d,a){if(a){const h=a.split(".");let o=d;for(let p=0;o&&p<h.length;p++)o=o[h[p]];return o}}function g(d){return d instanceof v.URI}function c(d){return d&&d.uri instanceof v.URI&&d.languageId&&typeof d.languageId=="string"}function n(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&d.uri instanceof v.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function s(d){if(g(d))return{resource:d};if(c(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(n(d))return{overrideIdentifier:d.languageId};if(i(d))return{resource:d.uri};if(d===null)return{resource:null}}let r=class{constructor(a,h,o){this.a=a.getProxy(A.$SM.MainThreadConfiguration),this.c=h,this.b=o,this.d=new L.$qh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,h){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(a,h))}};e.$Ykc=r,e.$Ykc=r=Qe([Ve(0,m.$fP),Ve(1,M.$Xkc),Ve(2,y.$Xj)],r);class t{constructor(a,h,o,p){this.a=new N.$be,this.b=a,this.f=p,this.c=h,this.e=w.$vo.parse(o,p),this.d=this.k(o.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,h){const o={data:this.e.toData(),workspace:this.c.workspace};this.e=w.$vo.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(h,o))}getConfiguration(a,h,o){const p=s(h)||{},f=this.g(a?l(this.e.getValue(void 0,p,this.c.workspace),a):this.e.getValue(void 0,p,this.c.workspace));a&&this.h(a,p,o?.identifier);function D(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(k){return typeof l(f,k)<"u"},get:(k,E)=>{this.h(a?`${a}.${k}`:k,p,o?.identifier);let P=l(f,k);if(typeof P>"u")P=E;else{let I;const F=(j,z)=>{if((0,S.$7f)(j)){let O;const T=()=>{I=I||(0,u.$Xn)(f),O=O||l(I,z)};return new Proxy(j,{get:(B,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return T(),()=>O;if(I)return O=O||l(I,z),O[W];const X=B[W];return typeof W=="string"?F(X,`${z}.${W}`):X},set:(B,W,X)=>(T(),O&&(O[W]=X),!0),deleteProperty:(B,W)=>(T(),O&&delete O[W],!0),defineProperty:(B,W,X)=>(T(),O&&Object.defineProperty(O,W,X),!0)})}return Array.isArray(j)?(0,u.$Xn)(j):j};P=F(P,k)}return P},update:(k,E,P,I)=>{k=a?`${a}.${k}`:k;const F=D(P);return E!==void 0?this.b.$updateConfigurationOption(F,k,E,p,I):this.b.$removeConfigurationOption(F,k,p,I)},inspect:k=>{k=a?`${a}.${k}`:k;const E=this.e.inspect(k,p,this.c.workspace);if(E)return{key:k,defaultValue:(0,u.$Xn)(E.policy?.value??E.default?.value),globalValue:(0,u.$Xn)(E.user?.value??E.application?.value),workspaceValue:(0,u.$Xn)(E.workspace?.value),workspaceFolderValue:(0,u.$Xn)(E.workspaceFolder?.value),defaultLanguageValue:(0,u.$Xn)(E.default?.override),globalLanguageValue:(0,u.$Xn)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,u.$Xn)(E.workspace?.override),workspaceFolderLanguageValue:(0,u.$Xn)(E.workspaceFolder?.override),languageIds:(0,u.$Xn)(E.overrideIdentifiers)}}};return typeof f=="object"&&(0,u.$1n)(b,f,!1),Object.freeze(b)}g(a){const h=o=>(0,S.$7f)(o)?new Proxy(o,{get:(p,f)=>h(p[f]),set:(p,f,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(p,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(p,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return h(a)}h(a,h,o){const p=$.$mo.test(a)?4:this.d.get(a),f=o?`[${o.value}] `:"";if(p===4){typeof h?.resource>"u"&&this.f.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){h?.resource&&this.f.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,h){const o=new w.$xo(a,h,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(p,f)=>o.affectsConfiguration(p,s(f))})}k(a){return a.reduce((h,o)=>(h.set(o[0],o[1]),h),new Map)}}e.$Zkc=t,e.$1kc=(0,C.$ri)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,8,4,6,7,44,72,45,22,43,20,28,5,15,11,12,91,308,13]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=e.$qmc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var r;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(r||(r={}));var t;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(t||(t={}));var d;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(d||(d={}));var a;(function(F){function j(T){if(T){const B=T;return B&&!!B.process}else return!1}F.is=j;function z(T){if(T==null)return;const B={process:T.process,args:T.args};return T.options&&(B.options=d.from(T.options)),B}F.from=z;function O(T){if(T!=null)return new R.$DN(T.process,T.args,T.options)}F.to=O})(a||(a={}));var h;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(h||(h={}));var o;(function(F){function j(T){if(T){const B=T;return B&&(!!B.commandLine||!!B.command)}else return!1}F.is=j;function z(T){if(T==null)return;const B={};return T.commandLine!==void 0?B.commandLine=T.commandLine:(B.command=T.command,B.args=T.args),T.options&&(B.options=h.from(T.options)),B}F.from=z;function O(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new R.$EN(T.commandLine,T.options):new R.$EN(T.command,T.args?T.args:[],T.options)}F.to=O})(o||(o={}));var p;(function(F){function j(T){if(T){const B=T;return B&&B.customExecution==="customExecution"}else return!1}F.is=j;function z(T){return{customExecution:"customExecution"}}F.from=z;function O(T,B){return B.get(T)}F.to=O})(p||(e.CustomExecutionDTO=p={}));var f;(function(F){function j(z,O){let T;return z.scope!==void 0&&typeof z.scope!="number"?T=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&O&&O.workspaceFile?T=O.workspaceFile:T=i.$YH),{id:z._id,workspaceFolder:T}}F.from=j})(f||(e.TaskHandleDTO=f={}));var D;(function(F){function j(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}F.from=j})(D||(D={}));var b;(function(F){function j(T,B){if(T==null)return[];const W=[];for(const X of T){const Z=z(X,B);Z&&W.push(Z)}return W}F.fromMany=j;function z(T,B){if(T==null)return;let W;T.execution instanceof R.$DN?W=a.from(T.execution):T.execution instanceof R.$EN?W=o.from(T.execution):T.execution&&T.execution instanceof R.$FN&&(W=p.from(T.execution));const X=r.from(T.definition);let Z;return T.scope?typeof T.scope=="number"?Z=T.scope:Z=T.scope.uri:Z=R.TaskScope.Workspace,!X||!Z?void 0:{_id:T._id,definition:X,name:T.name,source:{extensionId:B.identifier.value,label:T.source,scope:Z},execution:W,isBackground:T.isBackground,group:D.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}F.from=z;async function O(T,B,W){if(T==null)return;let X;a.is(T.execution)?X=a.to(T.execution):o.is(T.execution)?X=o.to(T.execution):p.is(T.execution)&&(X=p.to(T._id,W));const Z=r.to(T.definition);let Y;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Y=T.source.scope:Y=await B.resolveWorkspaceFolder(u.URI.revive(T.source.scope)):Y=R.TaskScope.Workspace),!Z||!Y)return;const x=new R.$GN(Z,Y,T.name,T.source.label,X,T.problemMatchers);return T.isBackground!==void 0&&(x.isBackground=T.isBackground),T.group!==void 0&&(x.group=R.$CN.from(T.group._id),x.group&&T.group.isDefault&&(x.group=new R.$CN(x.group.id,x.group.label),T.group.isDefault===!0&&(x.group.isDefault=T.group.isDefault))),T.presentationOptions&&(x.presentationOptions=t.to(T.presentationOptions)),T._id&&(x._id=T._id),T.detail&&(x.detail=T.detail),x}F.to=O})(b||(e.TaskDTO=b={}));var k;(function(F){function j(O){return O}F.from=j;function z(O){if(O)return Object.assign(Object.create(null),O)}F.to=z})(k||(k={}));class E{#e;constructor(j,z,O){this._id=z,this.a=O,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let P=class{constructor(j,z,O,T,B,W,X,Z){this.q=new M.$be,this.r=new M.$be,this.s=new M.$be,this.u=new M.$be,this.a=j.getProxy(A.$SM.MainThreadTask),this.b=O,this.c=T,this.d=B,this.e=W,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=X,this.g=Z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,z,O){if(!O)return new R.$UM(()=>{});const T=this.x();return this.j.set(T,{type:z,provider:O,extension:j}),this.a.$registerTaskProvider(T,z),new R.$UM(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(j,z){this.a.$registerTaskSystem(j,z)}fetchTasks(j){return this.a.$fetchTasks(k.from(j)).then(async z=>{const O=[];for(const T of z){const B=await b.to(T,this.b,this.m);B&&O.push(B)}return O})}get taskExecutions(){const j=[];return this.k.forEach(z=>j.push(z)),j}terminateTask(j){if(!(j instanceof E))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,z,O){const T=this.m.get(j.id);T&&(this.o.set(j.id,T),this.e.attachPtyToTerminal(z,await T.callback(O))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const z=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const z=await this.z(j.id);this.s.fire({execution:z,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const z=await this.z(j.id);this.u.fire({execution:z,exitCode:j.exitCode})}$provideTasks(j,z){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));const T=[],B=(0,N.$jh)(()=>O.provider.provideTasks(L.CancellationToken.None)).then(W=>this.v(z,T,O,W));return new Promise(W=>{B.then(X=>{Promise.all(T).then(()=>{W(X)})})})}async $resolveTask(j,z){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));if(z.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${O.type}].`);const T=await b.to(z,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask(T,L.CancellationToken.None);if(!B)return;this.A(B,O);const W=b.from(B,O.extension);if(!W)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(W.execution)&&await this.y(W,B,!0),await this.w(W)}x(){return this.h++}async y(j,z,O){const T=await this.a.$createTaskId(j);!O&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,z.execution)),this.m.set(T,z.execution)}async z(j,z){if(typeof j=="string"){const B=this.l.get(j);if(!B)throw new s.$bb("Unexpected: The specified task is missing an execution");return B}const O=this.l.get(j.id);if(O)return O;let T;return z?T=Promise.resolve(new E(this,j.id,z)):T=b.to(j.task,this.b,this.m).then(B=>{if(!B)throw new s.$bb("Unexpected: Task does not exist.");return new E(this,j.id,B)}),this.l.set(j.id,T),T.then(B=>(this.k.set(j.id,B),B))}A(j,z){j._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const O=this.n.values();let T=O.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=O.next()}};e.$qmc=P,e.$qmc=P=Qe([Ve(0,m.$fP),Ve(1,y.$vP),Ve(2,w.$Xkc),Ve(3,$.$qP),Ve(4,S.$1kc),Ve(5,C.$mlc),Ve(6,c.$Xj),Ve(7,n.$Bkc)],P);let I=class extends P{constructor(j,z,O,T,B,W,X,Z){super(j,z,O,T,B,W,X,Z),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:g.$h(0)})}async executeTask(j,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const O=b.from(z,j);if(O===void 0)throw new Error("Task is not valid");if(p.is(O.execution))await this.y(O,z,!1);else throw new s.$_;const T=await this.z(await this.a.$getTaskExecution(O),z);return this.a.$executeTask(O).catch(B=>{throw new Error(B)}),T}v(j,z,O,T){const B=[];if(T)for(const W of T){if(this.A(W,O),!W.definition||!j[W.definition.type]){const Z=W.source?W.source:"No task source";this.f.warn(`The task [${Z}, ${W.name}] uses an undefined task type. The task will be ignored in the future.`)}const X=b.from(W,O.extension);X&&p.is(X.execution)?(B.push(X),z.push(this.y(X,W,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async w(j){if(p.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,z,O){}};e.$rmc=I,e.$rmc=I=Qe([Ve(0,m.$fP),Ve(1,y.$vP),Ve(2,w.$Xkc),Ve(3,$.$qP),Ve(4,S.$1kc),Ve(5,C.$mlc),Ve(6,c.$Xj),Ve(7,n.$Bkc)],I),e.$smc=(0,v.$ri)("IExtHostTask")}),define(ke[368],Se([1,0,36,29]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wL=void 0,e.$vL=M,e.$xL=A;function M(R){return"cellResults"in R}e.$wL="rawCell#";function A(R,w){let $=-1;const S=[];let L=[];return R.forEach(m=>{m.range.startLineNumber!==$&&L.length>0&&(S.push([...L]),L=[]),L.push(m),$=m.range.endLineNumber}),L.length>0&&S.push([...L]),S.map(m=>{const y=[],v=m[0].range.startLineNumber,l=m[m.length-1].range.endLineNumber;for(let g=v;g<=l;g++)y.push(w.getLineContent(g));return new u.$_K(y.join(`
`)+`
`,m.map(g=>new N.$nt(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}}),define(ke[369],Se([1,0,223,21,4,3,27,14,18,2,32,111,6,33,16,7,48,339,153,24,15,298,368,365]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s,r,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(o=>o.apiEditor)}constructor(o,p,f,D,b,k){this.q=f,this.r=D,this.s=b,this.t=k,this.f=new Map,this.g=new R.$Bc,this.h=new Map,this.j=new M.$be,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$be,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$be,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$be,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$zkc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=o.getProxy(m.$SM.MainThreadNotebook),this.c=o.getProxy(m.$SM.MainThreadNotebookDocuments),this.d=o.getProxy(m.$SM.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const P=E.notebookEditor?.notebookUri,I=E.cell.handle,j=this.g.get(P)?.getCell(I);if(j)return j.apiCell}if(E&&E.$mid===14){const P=E.uri,I=this.g.get(P);if(I)return I.apiNotebook}return E}}),a.B(p)}getEditorById(o){const p=this.h.get(o);if(!p)throw new Error(`unknown text editor: ${o}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(o){for(const[p,f]of this.h)if(f.apiEditor===o)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(o,p){const f=this.g.get(o);if(!f&&!p)throw new Error(`NO notebook document for '${o}'`);return f}static u(o,p){if(!p)return;const f=p.filenamePattern.map(D=>v.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(p.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:p.displayName,filenamePattern:f,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,p,f){const D=a.a++,b=typeof f.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(D,f),this.b.$registerNotebookCellStatusBarItemProvider(D,b,p);let k;return b!==void 0&&(k=f.onDidChangeCellStatusBarItems(E=>this.b.$emitCellStatusBarEvent(b))),new l.$UM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,b),k?.dispose()})}async createNotebookDocument(o){const p=await this.c.$tryCreateNotebook({viewType:o.viewType,content:o.content&&v.NotebookData.from(o.content)});return S.URI.revive(p)}async openNotebookDocument(o){const p=this.g.get(o);if(p)return p.apiNotebook;const f=await this.c.$tryOpenNotebook(o),D=this.g.get(S.URI.revive(f));return(0,$.$dg)(D?.apiNotebook)}async showNotebookDocument(o,p){S.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let f;typeof p=="object"?f={position:v.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(v.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:f={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(o.uri,o.notebookType,f),b=D&&this.h.get(D)?.apiEditor;if(b)return b;throw D?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,p,f,D){const b=this.f.get(o),k=S.URI.revive(p),E=this.g.get(k);if(!E||!b)return;const P=E.getCellFromIndex(f);if(!P)return;const I=await b.provideCellStatusBarItems(P.apiCell,D);if(!I)return;const F=new A.$Tc,j=this.p.add([F]),O=(Array.isArray(I)?I:[I]).map(T=>v.NotebookStatusBarItem.from(T,this.i,F));return{cacheId:j,items:O}}$releaseNotebookCellStatusBarItems(o){this.p.delete(o)}registerNotebookSerializer(o,p,f,D,b){if((0,w.$4e)(p))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:p,serializer:f,options:D}),this.b.$registerNotebookSerializer(k,{id:o.identifier,location:o.extensionLocation},p,v.NotebookDocumentContentOptions.from(D),a.u(o,b)),(0,A.$Sc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(o,p,f){const D=this.x.get(o);if(!D)throw new Error("NO serializer found");const b=await D.serializer.deserializeNotebook(p.buffer,f);return new g.$ow(v.NotebookData.from(b))}async $notebookToData(o,p,f){const D=this.x.get(o);if(!D)throw new Error("NO serializer found");const b=await D.serializer.serializeNotebook(v.NotebookData.to(p.value),f);return N.$Ce.wrap(b)}async $saveNotebook(o,p,f,D,b){const k=S.URI.revive(p),E=this.x.get(o);if(!E)throw new Error("NO serializer found");const P=this.g.get(k);if(!P)throw new Error("Document NOT found");if(P.versionId!==f)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new L.$gl((0,u.localize)(0,null,this.z(k)),6);await this.y(k,D);const I={metadata:(0,i.$6n)(P.apiNotebook.metadata,T=>!(E.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of P.apiNotebook.getCells()){const B=new l.$kO(T.kind,T.document.getText(),T.document.languageId,T.mime,E.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);B.metadata=(0,i.$6n)(T.metadata,W=>!(E.options?.transientCellMetadata??{})[W]),I.cells.push(B)}const F=await E.serializer.serializeNotebook(I,b);await this.s.value.writeFile(k,F);const j=this.s.getFileSystemProviderExtUri(k.scheme),z=await this.s.value.stat(k);return{name:j.basename(k),isFile:(z.type&L.FileType.File)!==0,isDirectory:(z.type&L.FileType.Directory)!==0,isSymbolicLink:(z.type&L.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&L.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((z.permissions??0)&L.FilePermission.Locked),etag:L.$rl({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(o,p,f,D,b){const k=this.x.get(o)?.serializer;if(!k)return{limitHit:!1,results:[]};const E=new R.$Cc;await(async(z,O,T)=>{await Promise.all(z.map(async B=>await Promise.all(B.filenamePatterns.map(W=>{const X={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:W};return this.t.doInternalFileSearchWithCustomCallback(X,O,Z=>{Z.forEach(Y=>{E.has(Y)||D.some(ne=>B.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(ge=>(0,d.$Rgb)(ge,Y)))||E.add(Y)})}).catch(Z=>{if(Z.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Z})}))))})(f,b,p);const I=new R.$Bc;let F=!1;const j=Array.from(E).map(async z=>{const O=[];try{if(b.isCancellationRequested)return;if(p.maxResults&&[...I.values()].reduce((X,Z)=>X+Z.cellResults.length,0)>p.maxResults){F=!0;return}const T=[],B=this.g.get(z);if(B)B.apiNotebook.getCells().forEach(Z=>T.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(Y=>Y.items.map(x=>x.data.toString()))}));else{const X=await this.s.value.readFile(z),Z=N.$Ce.fromString(X.toString()),Y=await k.deserializeNotebook(Z.buffer,b);if(b.isCancellationRequested)return;v.NotebookData.from(Y).cells.forEach(ne=>T.push({input:ne.source,outputs:ne.outputs.flatMap(ge=>ge.items.map(ue=>ue.valueBytes.toString()))}))}if(b.isCancellationRequested)return;T.forEach((X,Z)=>{const Y=p.contentPattern.pattern,x=new r.$IWb(X.input,void 0,X.outputs),ne=x.findInInputs(Y),ge=x.findInOutputs(Y),ue=ge.flatMap(ve=>(0,t.$xL)(ve.matches,ve.textBuffer)).map((ve,te)=>(ve.webviewIndex=te,ve));if(ne.length>0||ge.length>0){const ve={index:Z,contentResults:(0,t.$xL)(ne,x.inputTextBuffer),webviewResults:ue};O.push(ve)}});const W={resource:z,cellResults:O};I.set(z,W);return}catch{return}});return await Promise.all(j),{limitHit:F,results:[...I.values()]}}async y(o,p){const f=await this.s.value.stat(o);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==L.$ql&&typeof f.mtime=="number"&&typeof f.size=="number"&&p.mtime<f.mtime&&p.etag!==L.$rl({mtime:p.mtime,size:f.size}))throw new L.$gl((0,u.localize)(1,null),3,p)}z(o){return o.scheme===s.Schemas.file?o.fsPath:o.toString()}A(o,p,f){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const D=new n.$Wlc(p,this.d,o,f.visibleRanges.map(v.NotebookRange.to),f.selections.map(v.NotebookRange.to),typeof f.viewColumn=="number"?v.ViewColumn.to(f.viewColumn):void 0);this.h.set(p,D)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const f of o.value.removedDocuments){const D=S.URI.revive(f),b=this.g.get(D);b&&(b.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(b.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===D.toString()&&this.h.delete(k.id)}if(o.value.addedDocuments){const f=[];for(const D of o.value.addedDocuments){const b=S.URI.revive(D.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const k=new c.$Vlc(this.c,this.q,this.r,b,D);f.push(...D.cells.map(E=>c.$Ulc.asModelAddData(E))),this.g.get(b)?.dispose(),this.g.set(b,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this.m.fire(k.apiNotebook)}}if(o.value.addedEditors)for(const f of o.value.addedEditors){if(this.h.has(f.id))return;const D=S.URI.revive(f.documentUri),b=this.g.get(D);b&&this.A(b,f.id,f)}const p=[];if(o.value.removedEditors)for(const f of o.value.removedEditors){const D=this.h.get(f);D&&(this.h.delete(f),this.k?.id===D.id&&(this.k=void 0),p.push(D))}if(o.value.visibleEditors){this.l=o.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const f=new Set;this.l.forEach(D=>f.add(D.id));for(const D of this.h.values()){const b=f.has(D.id);D._acceptVisibility(b)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this.k=void 0:o.value.newActiveEditor&&(this.h.get(o.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${o.value.newActiveEditor}`),this.k=this.h.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(o){const p=y.$DP.String.with("notebookType","A notebook type"),f=new y.$FP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new y.$DP("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>N.$Ce.wrap(b))],new y.$EP("Notebook Data",b=>v.NotebookData.to(b.value))),D=new y.$FP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new y.$DP("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new g.$ow(v.NotebookData.from(b)))],new y.$EP("Bytes",b=>b.buffer));o.registerApiCommand(f),o.registerApiCommand(D)}}e.$6lc=a}),define(ke[370],Se([1,0,17,22,47,35,23,40,36]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=void 0;class S{constructor(m,y,v){this.k=m,this.l=y,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&A.$lk(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&A.$lk(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const y=this.k.folderQueries||[];return new Promise((v,l)=>{const g=c=>{this.f++,m(c)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const n=c.toString(),i=u.$oc(n);this.j&&this.j(n,i)||this.v(g,{base:c,basename:i})}),Promise.all(y.map(c=>this.p(c,g))).then(c=>{v({limitHit:this.e,stats:c[0]||void 0})},c=>{l(new Error((0,M.$cj)(c)))})})}async p(m,y){const v=new N.$me,l=this.q(m),g=this.r(),c=new $.$nL(this.k,m),n=!c.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=w.$0d.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,v.token),r=i.elapsed(),t=w.$0d.create();return this.g&&!this.e||(s&&s.forEach(d=>{const a=u.$hc.relative(m.folder.path,d.path);if(n){const h=u.$oc(d.path);this.v(y,{base:m.folder,relativePath:a,basename:h});return}this.s(g,m.folder,a,y)}),this.g&&!this.e)?null:(this.u(g,c,y),{providerTime:r,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(m){const y=(0,$.$mL)(this.k.includePattern,m.includePattern),v=(0,$.$mL)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:v,includes:y,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},y,v,l){if(v===this.a){const c=u.$oc(this.a);this.v(l,{base:y,relativePath:this.a,basename:c})}function g(c){const n=u.$oc(c),i=u.$nc(c);let s=m[i];s||(s=m[i]=[],g(i)),s.push({base:y,relativePath:c,basename:n})}g(v)}u({rootEntries:m,pathToEntries:y},v,l){const g=this,c=this.a;function n(i){const s=(0,$.$pL)(()=>i.map(r=>r.basename));for(let r=0,t=i.length;r<t;r++){const d=i[r],{relativePath:a,basename:h}=d;if(v.matchesExcludesSync(a,h,c!==h?s:void 0))continue;const o=y[a];if(o)n(o);else{if(a===c)continue;g.v(l,d)}if(g.e)break}}n(m)}v(m,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(y))}}class L{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,y,v,l){const g=this.c(m.cacheKey),c=new S(m,y,g&&g.token);let n=0;const i=s=>{n+=s.length,v(s.map(r=>this.d(r)))};return this.e(c,L.a,i,l).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:s.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new N.$me),this.b.get(m)}d(m){return m.relativePath?{resource:R.$5g(m.base,m.relativePath)}:{resource:m.base}}e(m,y,v,l){const g=l.onCancellationRequested(()=>{m.cancel()}),c=i=>{i&&(n.push(i),y>0&&n.length>=y&&(v(n),n=[]))};let n=[];return m.search(c).then(i=>(n.length&&v(n),g.dispose(),i),i=>(n.length&&v(n),g.dispose(),Promise.reject(i)))}}e.$Xlc=L}),define(ke[371],Se([1,0,19,73,35,103,27,15,17,23,14,18,2,100,244,54,12,42,146,366,36]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=void 0,e.$xM=D;let r=class{constructor(k,E,P,I,F){this.a=k,this.b=E,this.c=P,this.d=I,this.e=F}text(k,E,P={}){k=this.f(k,P);const I=this.a.getValue(),F=E&&E.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(E?.map(c.$Mi),P),type:2,contentPattern:k,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:I.search.usePCRE2||F||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(k,E){const P=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const I={...k,wordSeparators:P.editor.wordSeparators};return this.j(k,E)&&(I.isCaseSensitive=!0),this.k(k)&&(I.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),I}file(k,E={}){return{...this.h(k,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey,shouldGlobMatchFilePattern:E.shouldGlobSearch}}g(k,E){return k?(k=Array.isArray(k)?k.map(o):o(k),E?this.parseSearchPaths(k):{pattern:d(...Array.isArray(k)?k:[k])}):{}}h(k=[],E={}){const P=this.g(E.includePattern,E.expandPatterns),I=this.g(E.excludePattern,E.expandPatterns),F=k.length>1,j=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(T=>this.q(T,E,I)):k.map(T=>this.r(T,E,I,F))).filter(T=>!!T),z={_reason:E._reason,folderQueries:j,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:I.pattern,includePattern:P.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const T=u.$Hb(u.$Rb(this.c.groups.map(X=>X.editors.map(Z=>Z.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const B=T.filter(X=>(0,s.$dL)(z,X.fsPath)),W=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...z,...W}}const O=E.extraFileResources&&E.extraFileResources.filter(T=>(0,s.$dL)(z,T.fsPath));return z.extraFileResources=O&&O.length?O:void 0,z}i(k){const E=[],P=new R.$Bc,I={};let F=!1;return k.forEach(j=>{if(j.scheme===w.Schemas.walkThrough)return;if((0,S.$9g)(j)){const O=this.b.getWorkspaceFolder(j)?.uri??j.with({path:$.$nc(j.fsPath)});let T=P.get(O);T||(F=!0,T={folder:O,includePattern:{}},E.push(T),P.set(O,T));const B=$.$mc(O.fsPath,j.fsPath);(0,C.$dg)(T.includePattern)[B.replace(/\\/g,"/")]=!0}else j.fsPath&&(F=!0,I[j.fsPath]=!0)}),{folderQueries:E,includePattern:I,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}j(k,E){if(E.isSmartCase){if(k.isRegExp){if(L.$Vf(k.pattern,!0))return!0}else if(L.$Vf(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,y.$DC)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const E=W=>$.$jc(W)||/^\.\.?([\/\\]|$)/.test(W),I=(Array.isArray(k)?k:a(k)).map(W=>{const X=this.e.resolvedUserHome;return X?(0,A.$tw)(W,X.scheme===w.Schemas.file?X.fsPath:X.path):W}),F=N.$K(I,W=>E(W)?"searchPaths":"exprSegments"),j=(F.exprSegments||[]).map(W=>L.$cf(W,"/")).map(W=>L.$cf(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),h(W))),z={},O=this.m(F.searchPaths||[]);O&&O.length&&(z.searchPaths=O);const T=u.$Rb(j),B=d(...T);return B&&(z.pattern=B),z}l(k,E){return E.disregardExcludeSettings?void 0:(0,s.$cL)(k,!E.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const E=k.flatMap(I=>{let{pathPortion:F,globPortion:j}=t(I);return j&&(j=p(j)),this.n(F).flatMap(O=>this.o(O,j))}),P=new Map;return E.forEach(I=>{const F=I.searchPath.toString(),j=P.get(F);j?I.pattern&&(j.pattern=j.pattern||{},j.pattern[I.pattern]=!0):P.set(F,{searchPath:I.searchPath,pattern:I.pattern?d(I.pattern):void 0})}),Array.from(P.values())}n(k){if($.$jc(k)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==w.Schemas.file?[{searchPath:E[0].uri.with({path:k})}]:[{searchPath:m.URI.file($.$ic(k))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(k=o(k),k.startsWith("../")||k===".."){const I=$.$hc.resolve(E.path,k);return[{searchPath:E.with({path:I})}]}const P=p(k);return[{searchPath:E,pattern:P}]}else{if(k==="./"||k===".\\")return[];{const E=k.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(F=>{const j=E.match(new RegExp(`^${L.$9e(F.name)}(?:/(.*)|$)`));return j?{match:j,folder:F}:null}).filter(C.$ag);if(I.length)return I.map(F=>{const j=F.match[1];return{searchPath:F.folder.uri,pattern:j&&p(j)}});{const F=k.match(/\.[\/\\](.+)[\/\\]?/),j=F?F[1]:k,z=v.localize(0,null,j);throw new Error(z)}}}}o(k,E){const P=k.pattern&&E?`${k.pattern}/${E}`:k.pattern||E,I=[{searchPath:k.searchPath,pattern:P}];return P&&!P.endsWith("**")&&I.push({searchPath:k.searchPath,pattern:P+"/**"}),I}q(k,E,P){const I=this.r((0,c.$Mi)(k.searchPath),E,P,!1);return I?{...I,includePattern:k.pattern}:null}r(k,E,P,I){let F;const j=m.URI.isUri(k)?k:k.uri;if(P.searchPaths){const W=P.searchPaths.filter(X=>(0,S.$Xg)(X.searchPath,j))[0];if(W&&!W.pattern)return null;W&&(F=W.pattern)}const z=this.a.getValue({resource:j}),T={...this.l(z,E)||{},...F||{}},B=m.URI.isUri(k)?(0,S.$2g)(k):k.name;return{folder:j,folderName:I?B:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!z.search.followSymlinks}}};e.$wM=r,e.$wM=r=Qe([Ve(0,l.$Xi),Ve(1,c.$Ai),Ve(2,n.$KD),Ve(3,g.$Xj),Ve(4,i.$uM)],r);function t(b){const k=b.match(/[\*\{\}\(\)\[\]\?]/);if(k){const E=k.index,P=b.substr(0,E).match(/[/|\\][^/\\]*$/);if(P){let I=b.substr(0,P.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:b.substr((P.index||0)+1)}}}return{pathPortion:b}}function d(...b){return b.length?b.reduce((k,E)=>(k[E]=!0,k),Object.create(null)):void 0}function a(b){return M.$jk(b,",").map(k=>k.trim()).filter(k=>!!k.length)}function h(b){return[`**/${b}/**`,`**/${b}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function o(b){return b.replace(/\\/g,"/")}function p(b){return o(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(b){return b.replace(/([?*[\]])/g,"[$1]")}function D(b,k){b=u.$Mb(b,I=>I.toString());const E=[],P=k.getWorkspace();return b&&b.forEach(I=>{let F;if(k.getWorkbenchState()===2)F=(0,S.$7g)(P.folders[0].uri,I),F&&F!=="."&&(F="./"+F);else{const j=k.getWorkspaceFolder(I);if(j){const z=j.name;if(P.folders.filter(T=>T.name===z).length===1){const T=(0,S.$7g)(j.uri,I);T===""?F=`./${j.name}`:F=`./${j.name}/${T}`}else F=I.fsPath}}F&&E.push(f(F))}),E}}),define(ke[372],Se([1,0,23,2,22,13,5,371,36,42,8]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rtb=m,e.$Stb=l;const C=7e3;function m(g,c){const n=c.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],s=[];for(const o of n)if(/^workspaceContains:/.test(o)){const p=o.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||g.forceUsingSearch?s.push(p):i.push(p)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:r,resolve:t}=(0,L.$kh)(),d=o=>t({activationEvent:o}),a=Promise.all(i.map(o=>y(g,o,d))).then(()=>{}),h=v(g,c.identifier,s,d);return Promise.all([a,h]).then(()=>{t(void 0)}),r}async function y(g,c,n){for(const i of g.folders)if(await g.exists(u.$5g(N.URI.revive(i),c))){n(`workspaceContains:${c}`);return}}async function v(g,c,n,i){if(n.length===0)return Promise.resolve(void 0);const s=new M.$me,r=g.checkExists(g.folders,n,s.token),t=setTimeout(async()=>{s.cancel(),g.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},C);let d=!1;try{d=await r}catch(a){A.$4(a)||A.$1(a)}s.dispose(),clearTimeout(t),d&&i(`workspaceContains:${n.join(",")}`)}function l(g,c,n,i){const s=g.get(R.$qi),r=g.get($.$7K),d=s.createInstance(w.$wM).file(c.map(a=>(0,S.$Mi)(N.URI.revive(a))),{_reason:"checkExists",includePattern:n,exists:!0});return r.fileSearch(d,i).then(a=>!!a.limitHit,a=>A.$4(a)?!1:Promise.reject(a))}}),define(ke[49],Se([1,0,219,17,59,23,8,3,77,2,12,6,45,304,118,44,26,148,13,25,21,281,7,66,5,28,93,20,107,70,43,121,4,372,117,283,15,115,40,11,116]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s,r,t,d,a,h,o,p,f,D,b,k,E,P,I,F,j,z,O,T,B){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=e.$Blc=e.$Alc=e.$zlc=void 0,e.$zlc=(0,a.$ri)("IHostUtils");let X=W=class extends w.$Uc{constructor(U,_,be,Pe,se,re,oe,K,ie,$e,we,Le,fe){super(),this.Y=Le,this.Z=fe,this.a=this.B(new E.$be),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=_,this.g=be,this.f=oe,this.j=Pe,this.m=se,this.s=re,this.t=ie,this.u=$e,this.w=we,this.y=this.g.getProxy(C.$SM.MainThreadWorkspace),this.z=this.g.getProxy(C.$SM.MainThreadTelemetry),this.C=this.g.getProxy(C.$SM.MainThreadExtensionService),this.D=new R.$qh,this.F=new R.$qh,this.G=new R.$qh,this.H=new R.$qh,this.I=new ve(this.f.extensions.activationEvents),this.L=new c.$b_b(this.I,this.f.extensions.allExtensions);const De=new i.$Nm(this.f.extensions.myExtensions);this.J=new c.$b_b(this.I,ge(this.L,De)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${x(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${x(this.J)}`)),this.M=new v.$ilc(this.g,this.s),this.N=new I.$slc(this.g),this.O=K,this.h=U.createChild(new f.$pi([v.$jlc,this.M],[I.$tlc,this.N])),this.P=this.B(new y.$hlc(this.J,this.L,{onExtensionActivationError:(Ie,Te,V)=>{this.C.$onExtensionActivationError(Ie,n.$3(Te),V)},actualActivateExtension:async(Ie,Te)=>{if(c.$b_b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Te),new y.$glc;const V=this.J.getExtensionDescription(Ie);return this.fb(V,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this.eb(se))}catch{}await Promise.all(U)}terminate(U,_=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Pe=>{this.s.error(Pe)}),this.g.dispose();const be=this.$();Promise.race([(0,R.$sh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.s.info(`Extension host exiting with code ${_}`),this.s.flush(),this.s.dispose(),this.c.exit(_)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const _=await this.C.$getExtension(U);return _&&{..._,identifier:new i.$Mm(_.identifier.value),extensionLocation:S.URI.revive(_.extensionLocation)}}ab(U,_){return this.P.activateByEvent(U,_)}bb(U,_){return this.P.activateById(U,_)}activateByIdWithErrors(U,_){return this.bb(U,_).then(()=>{const be=this.P.getActivatedExtension(U);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===j.Schemas.file&&this.c.fsRealpath){const _=U.fsPath;this.R.has(_)||this.R.set(_,this.c.fsRealpath(_));const be=await this.R.get(_);return S.URI.file(be)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new ue(U))),this.Q}async db(U){const _=$.$xi.forUris(be=>A.$Vg.ignorePathCasing(be));return await Promise.all(U.map(async be=>{if(this.wb(be)){const Pe=await this.cb(be.extensionLocation);_.set(Pe,be)}})),_}eb(U){let _=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return _;const be=this.P.getActivatedExtension(U);if(!be)return _;try{typeof be.module.deactivate=="function"&&(_=Promise.resolve(be.module.deactivate()).then(void 0,Pe=>(this.s.error(Pe),Promise.resolve(void 0))))}catch(Pe){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Pe)}try{(0,w.$Pc)(be.subscriptions)}catch(Pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Pe)}return _}async fb(U,_){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,_).then(be=>{const Pe=be.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Pe.codeLoadingTime,Pe.activateCallTime,Pe.activateResolvedTime,_),this.gb(U,_,"success",Pe),be},be=>{throw this.gb(U,_,"failure"),be})}gb(U,_,be,Pe){const se=Y(U,_);this.z.$publicLog2("extensionActivationTimes",{...se,...Pe||{},outcome:be})}hb(U,_){const be=Y(U,_);this.z.$publicLog2("activatePlugin",be);const Pe=this.wb(U);if(!Pe)return Promise.resolve(new y.$flc(y.$clc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${U.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.s.flush();const se=new y.$dlc(_.startup);return Promise.all([this.xb(U,(0,A.$5g)(U.extensionLocation,Pe),se),this.ib(U)]).then(re=>(M.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),W.jb(this.s,U.identifier,re[0],re[1],se))).then(re=>(M.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),re))}ib(U){const _=this.Z.createLanguageModelAccessInformation(U),be=new r.$llc(U,this.M),Pe=new r.$klc(U.identifier.value,!1,this.M),se=new F.$ulc(U,this.N),re=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,oe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([be.whenReady,Pe.whenReady,this.O.whenReady]).then(()=>{const K=this;let ie,$e;const we=(0,g.$zG)(U,"ipc")?this.f.messagePorts?.get(i.$Mm.toKey(U.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Pe,secrets:se,subscriptions:[],get languageModelAccessInformation(){return _},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Le){return N.$kc(U.extensionLocation.fsPath,Le)},get storagePath(){return K.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return K.O.globalValue(U).fsPath},get logPath(){return N.$kc(K.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return S.URI.joinPath(K.f.logsLocation,U.identifier.value)},get storageUri(){return K.O.workspaceValue(U)},get globalStorageUri(){return K.O.globalValue(U)},get extensionMode(){return re},get extension(){return ie===void 0&&(ie=new ne(K,U.identifier,U,oe,!1)),ie},get extensionRuntime(){return(0,g.$AG)(U,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!$e){if(!we)return;const Le=E.Event.buffer(E.Event.fromDOMEventEmitter(we,"message",fe=>fe.data));we.start(),$e={onDidReceiveMessage:Le,postMessage:we.postMessage.bind(we)}}return $e}})})}static jb(U,_,be,Pe,se){return be=be||{activate:void 0,deactivate:void 0},this.kb(U,_,be,Pe,se).then(re=>new y.$elc(!1,null,se.build(),be,re,Pe.subscriptions))}static kb(U,_,be,Pe,se){if(typeof be.activate=="function")try{se.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${_.value}`);const re=typeof global=="object"?global:self,oe=be.activate.apply(re,[Pe]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(oe).then(K=>(se.activateResolveStop(),K))}catch(re){return Promise.reject(re)}else return Promise.resolve(be)}lb(U,_){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:_}).then(void 0,be=>{this.s.error(be)})}mb(U,_=0){const Pe=Date.now();(0,T.$B)(()=>{for(let se=_;se<U.length;se+=1){const re=U[se];for(const oe of re.activationEvents??[])if(oe==="onStartupFinished")if(Date.now()-Pe>50){this.mb(U,se);break}else this.lb(re,oe)}})}nb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(U=>{const _=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(_)this.mb(be);else for(const Pe of be)if(Pe.activationEvents)for(const se of Pe.activationEvents)se==="onStartupFinished"&&this.lb(Pe,se)})}ob(){const U=this.ab("*",!0).then(void 0,re=>{this.s.error(re)});this.B(this.j.onDidChangeWorkspace(re=>this.pb(re.added)));const _=this.j.workspace?this.j.workspace.folders:[],be=this.pb(_),Pe=this.rb(),se=Promise.all([Pe,U,be]).then(()=>{});return Promise.race([se,(0,R.$sh)(1e4)]).then(()=>{this.nb()}),se}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(_=>this.qb(U,_))).then(()=>{})}async qb(U,_){if(this.isActivated(_.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Pe={logService:this.s,folders:U.map(re=>re.uri),forceUsingSearch:be||!this.c.fsExists,exists:re=>this.c.fsExists(re.fsPath),checkExists:(re,oe,K)=>this.y.$checkExists(re,oe,K)},se=await(0,P.$Rtb)(Pe,_);if(se)return this.bb(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:se.activationEvent}).then(void 0,re=>this.s.error(re))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:_}=this.f.environment;if(!U||!_)throw new Error(u.localize(0,null));const be=await this.xb(null,_,new y.$dlc(!1));if(!be||typeof be.run!="function")throw new Error(u.localize(1,null,_.toString()));return new Promise((Pe,se)=>{const re=(ie,$e)=>{ie?(T.$t&&this.s.error("Test runner called back with error",ie),se(ie)):(T.$t&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),Pe(typeof $e=="number"&&$e>0?1:0))},oe=(0,A.$Sg)(_),K=be.run(oe,re);K&&K.then&&K.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),Pe(0)}).catch(ie=>{T.$t&&this.s.error("Test runner finished with error",ie),se(ie instanceof Error&&ie.stack?ie.stack:String(ie))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$sh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,_){return this.S[U]=_,(0,w.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:_}=await this.ub(U);return _?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const _=U.indexOf("+");if(_===-1)throw new t.$1M("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=U.substr(0,_);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(U,_){const be=O.$0d.create(!1),Pe=()=>`[resolveAuthority(${(0,d.$Gl)(U)},${_})][${be.elapsed()}ms] `,se=q=>this.s.info(`${Pe()}${q}`),re=q=>this.s.warn(`${Pe()}${q}`),oe=(q,Q=void 0)=>this.s.error(`${Pe()}${q}`,Q),K=q=>{if(q instanceof t.$1M)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},ie=async q=>{se(`activating resolver for ${q}...`);const{resolver:Q,authorityPrefix:J}=await this.ub(q);if(!Q)throw oe(`no resolver for ${J}`),new t.$1M(`No remote extension installed to resolve ${J}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:J,remoteAuthority:q}},$e=U.split(/@|%40/g).reverse();se(`activating remote resolvers ${$e.join(" -> ")}`);let we;try{we=await Promise.all($e.map(ie)).catch(async q=>{if(!(q instanceof t.$1M)||q._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return re(`resolving nested authorities failed: ${q.message}`),[await ie(U)]})}catch(q){return K(q)}const Le=new R.$Ch;Le.cancelAndSet(()=>se("waiting..."),1e3);let fe,De;for(const[q,{authorityPrefix:Q,resolver:J,remoteAuthority:he}]of we.entries())try{if(q===we.length-1)se("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${Q}`),fe=await J.resolve(he,{resolveAttempt:_,execServer:De}),M.mark(`code/extHost/didResolveAuthorityOK/${Q}`),se("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,t.$ZM.isManagedResolvedAuthority(fe)?fe:void 0));else{if(se(`invoking resolveExecServer() for ${he}`),M.mark(`code/extHost/willResolveExecServer/${Q}`),De=await J.resolveExecServer?.(he,{resolveAttempt:_,execServer:De}),!De)throw new t.$1M(`Exec server was not available for ${he}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(pe){return M.mark(`code/extHost/didResolveAuthorityError/${Q}`),oe("returned an error",pe),Le.dispose(),K(pe)}Le.dispose();const Ie={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};se(`returned ${t.$ZM.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let V;if(t.$ZM.isManagedResolvedAuthority(fe)){const q=_;this.Y.setFactory(q,fe.makeConnection),V={authority:U,connectTo:new d.$Dl(q),connectionToken:fe.connectionToken}}else V={authority:U,connectTo:new d.$El(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:V,options:Te,tunnelInformation:Ie}}}async $getCanonicalURI(U,_){this.s.info(`$getCanonicalURI invoked for authority (${(0,d.$Gl)(U)})`);const{resolver:be}=await this.ub(U);if(!be)return null;const Pe=S.URI.revive(_);if(typeof be.getCanonicalURI>"u")return Pe;const se=await(0,R.$jh)(()=>be.getCanonicalURI(Pe));return se||Pe}async $startExtensionHost(U){U.toAdd.forEach(re=>re.extensionLocation=S.URI.revive(re.extensionLocation));const{globalRegistry:_,myExtensions:be}=Z(this.I,this.L,this.J,U),Pe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(_.getAllExtensionDescriptions()),this.J.set(be),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${x(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${x(this.J)}`)),this.tb()}$activateByEvent(U,_){return _===1?this.D.wait().then(be=>this.ab(U,!1)):this.G.wait().then(be=>this.ab(U,!1))}async $activate(U,_){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,_),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(re=>re.extensionLocation=S.URI.revive(re.extensionLocation));const{globalRegistry:_,myExtensions:be}=Z(this.I,this.L,this.J,U),Pe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(_.getAllExtensionDescriptions()),this.J.set(be),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${x(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${x(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const _=s.$Ce.alloc(U),be=Math.random()%256;for(let Pe=0;Pe<U;Pe++)_.writeUInt8(be,Pe);return _}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$Alc=X,e.$Alc=X=W=Qe([Ve(0,a.$qi),Ve(1,e.$zlc),Ve(2,p.$fP),Ve(3,l.$Xkc),Ve(4,m.$1kc),Ve(5,L.$Xj),Ve(6,h.$vP),Ve(7,o.$4kc),Ve(8,D.$WCb),Ve(9,b.$mlc),Ve(10,z.$wlc),Ve(11,B.$xlc),Ve(12,k.$qlc)],X);function Z(te,U,_,be){te.addActivationEvents(be.addActivationEvents);const Pe=new c.$b_b(te,U.getAllExtensionDescriptions());Pe.deltaExtensions(be.toAdd,be.toRemove);const se=new i.$Nm(_.getAllExtensionDescriptions().map(oe=>oe.identifier));for(const oe of be.myToRemove)se.delete(oe);for(const oe of be.myToAdd)se.add(oe);const re=ge(Pe,se);return{globalRegistry:Pe,myExtensions:re}}function Y(te,U){return{id:te.identifier.value,name:te.name,extensionVersion:te.version,publisherDisplayName:te.publisher,activationEvents:te.activationEvents?te.activationEvents.join(","):null,isBuiltin:te.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function x(te){return te.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$Blc=(0,a.$ri)("IExtHostExtensionService");class ne{#e;#t;#i;constructor(U,_,be,Pe,se){this.#e=U,this.#t=_,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=N.$ic((0,A.$Sg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Pe,this.isFromDifferentExtensionHost=se}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Clc=ne;function ge(te,U){return te.getAllExtensionDescriptions().filter(_=>U.has(_.identifier))}class ue{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$Dlc=ue;class ve{constructor(U){this.a=new i.$Om,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const _ of Object.keys(U))this.a.set(_,U[_])}}}),define(ke[373],Se([1,0,59,2,6,45,26,25,20,28,5,49,12,14]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;let l=class{constructor(s,r,t,d,a,h,o){this.c=s,this.d=r,this.e=t,this.f=d,this.g=a,this.h=h,this.i=o,this.a=new Map,this.b=[]}async install(){this.j(),u.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new c(this.c,r,this.d,s,this.i)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,r,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const r of s.nodeModuleName)this.a.set(r,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(r=>s.alternativeModuleName(r))}};e.$Mmc=l,e.$Mmc=l=Qe([Ve(2,L.$qi),Ve(3,A.$1kc),Ve(4,C.$Blc),Ve(5,S.$vP),Ve(6,m.$Xj)],l);let g=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&v.a.size){const r=(0,y.$9e)(this.c(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",d=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${a}\\/)(${d})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const r=this.b.exec(this.c(s));if(!r)return;const[,t,d,a]=r,h=v.a.get(d);if(h!==void 0)return console.warn(`${d} as been renamed to ${h}, please update your imports`),t+h+a}c(s){return s.replace(/\\/g,"/")}};g=v=Qe([Ve(0,S.$vP)],g);class c{constructor(s,r,t,d,a){this.c=s,this.d=r,this.e=t,this.f=d,this.g=a,this.nodeModuleName="vscode",this.a=new w.$Om}load(s,r){const t=this.d.findSubstr(r);if(t){let d=this.a.get(t.identifier);return d||(d=this.c(t,this.e,this.f),this.a.set(t.identifier,d)),d}if(!this.b){let d="";this.d.forEach((a,h)=>d+=`	${h} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${d}`),this.b=this.c(R.$uG,this.e,this.f)}return this.b}}let n=class{constructor(s,r,t){this.e=s,this.f=r,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$SM.MainThreadTelemetry);const d=t.getProxy(M.$SM.MainThreadWindow);this.c=(a,h)=>{const o=N.URI.parse(a);return h?this.g(a,h):o.scheme==="http"||o.scheme==="https"?d.$openUri(o,a,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this.f?d.$openUri(o,a,{}):this.g(a,h)}}load(s,r,t){const d=this.e.findSubstr(r);return d&&(this.a=d.identifier.value,this.h()),this.b=t(s),this.c}g(s,r){return this.i(),this.b(s,r)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Qe([Ve(2,$.$fP)],n)}),define(ke[61],Se([1,0,46,3,17,51,5,72,71,49,7,44,301,45]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=e.$Elc=void 0,e.$Elc=(0,R.$ri)("IExtHostVariableResolverProvider");class v extends m.$hQ{constructor(c,n,i,s,r,t,d){function a(){if(i){const h=i.activeEditor();if(h)return h.document.uri;const o=s.tabGroups.all.find(p=>p.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof L.$FO||o.input instanceof L.$KO)return o.input.modified;if(o.input instanceof L.$EO||o.input instanceof L.$JO||o.input instanceof L.$HO)return o.input.uri}}}super({getFolderUri:h=>{const o=t.folders.filter(p=>p.name===h);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(h,o)=>r.getConfiguration(void 0,h).get(o),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=a();if(h)return M.$ic(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const h=a();if(h){const o=n.getWorkspaceFolder(h);if(o)return M.$ic(o.uri.fsPath)}}},getSelectedText:()=>{if(i){const h=i.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(i){const h=i.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>c.getExtension(h)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(A.env))}}let l=class extends N.$Uc{constructor(c,n,i,s,r){super(),this.b=c,this.c=n,this.g=i,this.h=s,this.j=r,this.a=new u.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$Flc=l,e.$Flc=l=Qe([Ve(0,S.$Blc),Ve(1,C.$Xkc),Ve(2,w.$qP),Ve(3,y.$1kc),Ve(4,$.$alc)],l)}),define(ke[96],Se([1,0,8,4,2,25,5,6,71,49,20,7,44,143,293,45,61,3,57,33,16]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=e.$Jlc=e.$Ilc=e.$Hlc=e.$Glc=void 0,e.$Glc=(0,R.$ri)("IExtHostDebugService");let r=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(f,D,b,k,E,P,I){this.N=D,this.O=b,this.P=k,this.Q=E,this.R=P,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$be,this.o=new N.$be,this.q=new N.$be,this.w=new N.$be,this.l=f.getProxy(w.$SM.MainThreadDebugService),this.A=new N.$be,this.C=new N.$be,this.y=new d(this.l),this.z=new Map,this.O.getExtensionRegistry().then(F=>{F.onDidChange(j=>{this.V(F)}),this.V(F)})}async $getVisualizerTreeItem(f,D){const b=this.W(D);if(!b)return;const k=await this.H.get(f)?.getTreeItem?.(b);return k?this.U(f,k):void 0}registerDebugVisualizationTree(f,D,b){const k=A.$Mm.toKey(f.identifier),E=this.jb(k,D);if(this.G.has(E))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(E,b),this.l.$registerDebugVisualizerTree(E,!!b.editItem),(0,c.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(E),this.H.delete(D)})}async $getVisualizerTreeItemChildren(f,D){const b=this.J.get(D)?.item;return b?(await this.H.get(f)?.getChildren?.(b))?.map(E=>this.U(f,E))||[]:[]}async $editVisualizerTreeItem(f,D){const b=this.J.get(f);if(!b)return;const k=await this.H.get(b.provider)?.editItem?.(b.item,D);return this.U(b.provider,k||b.item)}$disposeVisualizedTree(f){const D=this.J.get(f);if(!D)return;const b=[D.children];for(const k of b)if(k)for(const E of k)b.push(this.J.get(E)?.children),this.J.delete(E)}U(f,D){let b=this.I.get(D);return b||(b=this.F++,this.I.set(D,b),this.J.set(b,{provider:f,item:D})),s.DebugTreeItem.from(D,b)}asDebugSourceUri(f,D){const b=f;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let k=`debug:${encodeURIComponent(b.path||"")}`,E="?";return D&&(k+=`${E}session=${encodeURIComponent(D.id)}`,E="&"),k+=`${E}ref=${b.sourceReference}`,M.URI.parse(k)}else{if(b.path)return M.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(f){const D=[];for(const b of f.getAllExtensionDescriptions())if(b.contributes){const k=b.contributes.debuggers;if(k&&k.length>0)for(const E of k)(0,v.$cH)(E)&&D.push(E.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const f=[];return this.z.forEach(D=>f.push(D)),f}async $resolveDebugVisualizer(f,D){const b=this.L.get(f);if(!b)throw new Error(`No debug visualizer found with id '${f}'`);let{v:k,provider:E,extensionId:P}=b;if(k.visualization||(k=await E.resolveDebugVisualization?.(k,D)||k,b.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${E}'`);return this.kb(P,k.visualization)}async $executeDebugVisualizerCommand(f){const D=this.L.get(f);if(!D)throw new Error(`No debug visualizer found with id '${f}'`);const b=D.v.visualization;b&&"command"in b&&this.S.executeCommand(b.command,...b.arguments||[])}W(f){const D=this.m.get(f.sessionId);return D&&{session:D.api,variable:f.variable,containerId:f.containerId,frameId:f.frameId,threadId:f.threadId}}async $provideDebugVisualizers(f,D,b,k){const E=this.W(b),P=this.jb(f,D),I=this.G.get(P);if(!E||!I)return[];const F=await I.provideDebugVisualization(E,k);return F?F.map(j=>{const z=++this.M;this.L.set(z,{v:j,provider:I,extensionId:f});const O=j.iconPath?this.lb(j.iconPath):void 0;return{id:z,name:j.name,iconClass:O?.iconClass,iconPath:O?.iconPath,visualization:this.kb(f,j.visualization)}}):[]}$disposeDebugVisualizers(f){for(const D of f)this.L.delete(D)}registerDebugVisualizationProvider(f,D,b){if(!f.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const k=A.$Mm.toKey(f.identifier),E=this.jb(k,D);if(this.G.has(E))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(E,b),this.l.$registerDebugVisualizer(k,D),(0,c.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,D),this.G.delete(D)})}addBreakpoints(f){const D=f.filter(E=>{const P=E.id;return this.z.has(P)?!1:(this.z.set(P,E),!0)});this.gb(D,[],[]);const b=[],k=new Map;for(const E of D)if(E instanceof C.$VN){let P=k.get(E.location.uri.toString());P||(P={type:"sourceMulti",uri:E.location.uri,lines:[]},k.set(E.location.uri.toString(),P),b.push(P)),P.lines.push({id:E.id,enabled:E.enabled,condition:E.condition,hitCondition:E.hitCondition,logMessage:E.logMessage,line:E.location.range.start.line,character:E.location.range.start.character,mode:E.mode})}else E instanceof C.$WN&&b.push({type:"function",id:E.id,enabled:E.enabled,hitCondition:E.hitCondition,logMessage:E.logMessage,condition:E.condition,functionName:E.functionName,mode:E.mode});return this.l.$registerBreakpoints(b)}removeBreakpoints(f){const D=f.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const b=D.filter(P=>P instanceof C.$VN).map(P=>P.id),k=D.filter(P=>P instanceof C.$WN).map(P=>P.id),E=D.filter(P=>P instanceof C.$XN).map(P=>P.id);return this.l.$unregisterBreakpoints(b,k,E)}startDebugging(f,D,b){return this.l.$startDebugging(f?f.uri:void 0,D,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(f){return this.l.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,D,b){if(!D)return new C.$UM(()=>{});const k=this.d++;return this.f.push({type:f,handle:k,provider:D}),this.l.$registerDebugConfigurationProvider(f,b,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,k),new C.$UM(()=>{this.f=this.f.filter(E=>E.provider!==D),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(f,D,b){if(!b)return new C.$UM(()=>{});if(!this.cb(f,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:D,handle:k,factory:b}),this.l.$registerDebugAdapterDescriptorFactory(D,k),new C.$UM(()=>{this.h=this.h.filter(E=>E.factory!==b),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(f,D){if(!D)return new C.$UM(()=>{});const b=this.j++;return this.k.push({type:f,handle:b,factory:D}),new C.$UM(()=>{this.k=this.k.filter(k=>k.factory!==D)})}async $runInTerminal(f,D){return Promise.resolve(void 0)}async $substituteVariables(f,D){let b;const k=await this.ib(f);return k&&(b={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(b,D)}X(f,D){if(f.type==="implementation")return new h(f.implementation)}Y(){}async $startDASession(f,D){const b=this,k=await this.hb(D);return this.eb(this.$(k.type),k).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const P=this.Z(E),I=this.X(P,k);if(!I)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const F=I;return this.D.set(f,F),this.db(k).then(j=>(j&&this.E.set(f,j),F.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const O=z,T={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(O.arguments.value);T.body={signature:B},F.sendResponse(T)}else throw new Error("no signer")}catch(B){T.success=!1,T.message=B.message,F.sendResponse(T)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(z),z=(0,v.$hH)(z,!0),b.l.$acceptDAMessage(f,z)}),F.onError(z=>{j&&j.onError&&j.onError(z),this.l.$acceptDAError(f,z.name,z.message,z.stack)}),F.onExit(z=>{j&&j.onExit&&j.onExit(z??void 0,void 0),this.l.$acceptDAExit(f,z??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),F.startSession()))})}$sendDAMessage(f,D){D=(0,v.$gH)(D,!1);const b=this.E.get(f);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(D),this.D.get(f)?.sendMessage(D)}$stopDASession(f){const D=this.E.get(f);this.E.delete(f),D&&D.onWillStopSession&&D.onWillStopSession();const b=this.D.get(f);return this.D.delete(f),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const D=[],b=[],k=[];if(f.added)for(const E of f.added){const P=E.id;if(P&&!this.z.has(P)){let I;if(E.type==="function")I=new C.$WN(E.functionName,E.enabled,E.condition,E.hitCondition,E.logMessage,E.mode);else if(E.type==="data")I=new C.$XN(E.label,E.dataId,E.canPersist,E.enabled,E.hitCondition,E.condition,E.logMessage,E.mode);else{const F=M.URI.revive(E.uri);I=new C.$VN(new C.$7M(F,new C.$VM(E.line,E.character)),E.enabled,E.condition,E.hitCondition,E.logMessage,E.mode)}(0,C.$TN)(I,P),this.z.set(P,I),D.push(I)}}if(f.removed)for(const E of f.removed){const P=this.z.get(E);P&&(this.z.delete(E),b.push(P))}if(f.changed){for(const E of f.changed)if(E.id){const P=this.z.get(E.id);if(P){if(P instanceof C.$WN&&E.type==="function"){const I=P;I.enabled=E.enabled,I.condition=E.condition,I.hitCondition=E.hitCondition,I.logMessage=E.logMessage,I.functionName=E.functionName}else if(P instanceof C.$VN&&E.type==="source"){const I=P;I.enabled=E.enabled,I.condition=E.condition,I.hitCondition=E.hitCondition,I.logMessage=E.logMessage,I.location=new C.$7M(M.URI.revive(E.uri),new C.$VM(E.line,E.character))}k.push(P)}}}this.gb(D,b,k)}async $acceptStackFrameFocus(f){let D;if(f){const b=await this.hb(f.sessionId);f.kind==="thread"?D=new C.$4N(b.api,f.threadId):D=new C.$3N(b.api,f.threadId,f.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(f,D,b){return(0,u.$jh)(async()=>{const k=this.bb(f);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const E=await this.ib(D);return k.provideDebugConfigurations(E,b)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(f,D,b,k){return(0,u.$jh)(async()=>{const E=this.bb(f);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return E.resolveDebugConfiguration(P,b,k)})}$resolveDebugConfigurationWithSubstitutedVariables(f,D,b,k){return(0,u.$jh)(async()=>{const E=this.bb(f);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return E.resolveDebugConfigurationWithSubstitutedVariables(P,b,k)})}async $provideDebugAdapter(f,D){const b=this.ab(f);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(D);return this.eb(b,k).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(E)})}async $acceptDebugSessionStarted(f){const D=await this.hb(f);this.n.fire(D.api)}async $acceptDebugSessionTerminated(f){const D=await this.hb(f);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(f){this.u=f?await this.hb(f):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(f,D){(await this.hb(f))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(f,D){const k={session:(await this.hb(f)).api,event:D.event,body:D.body};this.w.fire(k)}Z(f){if(f instanceof C.$YN)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof C.$ZN)return{type:"server",port:f.port,host:f.host};if(f instanceof C.$1N)return{type:"pipeServer",path:f.path};if(f instanceof C.$2N)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}$(f){const D=this.h.filter(b=>b.type===f);if(D.length>0)return D[0].factory}ab(f){const D=this.h.filter(b=>b.handle===f);if(D.length>0)return D[0].factory}bb(f){const D=this.f.filter(b=>b.handle===f);if(D.length>0)return D[0].provider}cb(f,D){if(f.contributes){const b=f.contributes.debuggers;if(b&&b.length>0){for(const k of b)if(k.label&&k.type&&k.type===D)return!0}}return!1}db(f){const b=f.configuration.type,k=this.k.filter(E=>E.type===b||E.type==="*").map(E=>(0,u.$jh)(()=>E.factory.createDebugAdapterTracker(f.api)).then(P=>P,P=>null));return Promise.race([Promise.all(k).then(E=>{const P=E.filter(I=>!!I);if(P.length>0)return new a(P)}),new Promise(E=>setTimeout(()=>E(void 0),1e3))]).catch(E=>{})}async eb(f,D){const b=D.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new C.$ZN(b));if(f){const E=await this.O.getExtensionRegistry();return(0,u.$jh)(()=>f.createDebugAdapterDescriptor(D.api,this.fb(D,E))).then(P=>{if(P)return P})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,k))}fb(f,D){}gb(f,D,b){(f.length>0||D.length>0||b.length>0)&&this.A.fire(Object.freeze({added:f,removed:D,changed:b}))}async hb(f){if(f)if(typeof f=="string"){const D=this.m.get(f);if(D)return D}else{let D=this.m.get(f.id);if(!D){const b=await this.ib(f.folderUri),k=f.parent?this.m.get(f.parent):void 0;D=new t(this.l,f.id,f.type,f.name,b,f.configuration,k?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(f){if(f){const D=M.URI.revive(f);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(f,D){return`${f}\0${D}`}kb(f,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${f}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(f){const D=this.mb(f);let b,k;return"id"in D?k=n.ThemeIcon.asClassName(D):b=D,{iconPath:b,iconClass:k}}mb(f){if(f instanceof C.$QN)return{id:f.id};const D=typeof f=="object"&&"dark"in f?f.dark:f,b=typeof f=="object"&&"light"in f?f.light:f;return{dark:typeof D=="string"?M.URI.file(D):D,light:typeof b=="string"?M.URI.file(b):b}}};e.$Hlc=r,e.$Hlc=r=Qe([Ve(0,L.$fP),Ve(1,m.$Xkc),Ve(2,S.$Blc),Ve(3,l.$1kc),Ve(4,$.$alc),Ve(5,g.$Elc),Ve(6,i.$BP)],r);class t{constructor(f,D,b,k,E,P,I){this.f=f,this.g=D,this.h=b,this.j=k,this.k=E,this.l=P,this.m=I}get api(){const f=this;return this.d??=Object.freeze({id:f.g,type:f.h,get name(){return f.j},set name(D){f.j=D,f.f.$setDebugSessionName(f.g,D)},parentSession:f.m,workspaceFolder:f.k,configuration:f.l,customRequest(D,b){return f.f.$customDebugAdapterRequest(f.g,D,b)},getDebugProtocolBreakpoint(D){return f.f.$getDebugProtocolBreakpoint(f.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(f){this.j=f}get configuration(){return this.l}}e.$Ilc=t;class d{constructor(f){this.value=Object.freeze({append(D){f.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$Jlc=d;class a{constructor(f){this.d=f}onWillStartSession(){this.d.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(f):void 0)}onWillStopSession(){this.d.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.d.forEach(D=>D.onError?D.onError(f):void 0)}onExit(f,D){this.d.forEach(b=>b.onExit?b.onExit(f,D):void 0)}}class h extends y.$Xob{constructor(f){super(),this.h=f,f.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.h.handleMessage(f)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let o=class extends r{constructor(f,D,b,k,E,P,I){super(f,D,b,k,E,P,I)}};e.$Klc=o,e.$Klc=o=Qe([Ve(0,L.$fP),Ve(1,m.$Xkc),Ve(2,S.$Blc),Ve(3,l.$1kc),Ve(4,$.$alc),Ve(5,g.$Elc),Ve(6,i.$BP)],o)}),define(ke[374],Se([1,0,13,59,2,6,321,12,84,107,28,257,20,67,49,90]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=e.$Nmc=void 0;class g{static async installEarlyHandler(i){Error.stackTraceLimit=100;const s=i.get(w.$Xj),t=i.get(m.$fP).getProxy(A.$SM.MainThreadErrors);u.setUnexpectedErrorHandler(d=>{s.error(d);const a=u.$3(d);t.$onUnexpectedError(a)})}static async installFullHandler(i){const s=i.get(w.$Xj),r=i.get(m.$fP),t=i.get(v.$Blc),d=i.get(l.$zP),a=r.getProxy(A.$SM.MainThreadExtensionService),h=r.getProxy(A.$SM.MainThreadErrors),o=await t.getExtensionPathIndex(),p=new WeakMap;function f(k,E){if(p.has(k))return p.get(k).stack;let P="",I,F;for(const z of E)P+=`
	at ${z.toString()}`,F=z.getFileName(),!I&&F&&(I=o.findSubstr(M.URI.file(F)));const j=`${k.name||"Error"}: ${k.message||""}${P}`;return p.set(k,{extensionIdentifier:I?.identifier,stack:j}),j}const D=Symbol("prepareStackTrace wrapped");let b=f;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(k){if(k===f||!k||k[D]){b=k||f;return}b=function(E,P){return f(E,P),k.call(Error,E,P)},Object.assign(b,{[D]:!0})}}),u.setUnexpectedErrorHandler(k=>{s.error(k);const E=u.$3(k),P=p.get(k);if(!P?.extensionIdentifier){h.$onUnexpectedError(E);return}a.$onExtensionRuntimeError(P.extensionIdentifier,E);const I=d.onExtensionError(P.extensionIdentifier,k);s.trace("forwarded error to extension?",I,P)})}}e.$Nmc=g;class c{constructor(i,s,r,t,d){this.a=r,this.b=new R.$j_b(i,null,t),s=c.e(s,this.b);const a=new S.$pi(...(0,$.$ss)());a.set(L.$vP,{_serviceBrand:void 0,...s,messagePorts:d}),a.set(m.$fP,new m.$gP(this.b)),a.set(y.$Ukc,new y.$Vkc(t)),a.set(v.$zlc,r);const h=new C.$0q(a,!0);h.invokeFunction(g.installEarlyHandler),this.d=h.invokeFunction(o=>o.get(w.$Xj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=h.invokeFunction(o=>o.get(v.$Blc)),this.c.initialize(),h.invokeFunction(g.installFullHandler)}async asBrowserUri(i){const s=this.b.getProxy(A.$SM.MainThreadExtensionService);return M.URI.revive(await s.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,s){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=M.URI.revive(s.transformIncomingURIs(i.environment.appRoot));const r=i.environment.extensionDevelopmentLocationURI;return r&&(i.environment.extensionDevelopmentLocationURI=r.map(t=>M.URI.revive(s.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=M.URI.revive(s.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=M.URI.revive(s.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=M.URI.revive(s.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=M.URI.revive(s.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=M.URI.revive(s.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=M.URI.revive(s.transformIncomingURIs(i.logsLocation)),i.workspace=s.transformIncomingURIs(i.workspace),i}}e.$Omc=c}),define(ke[375],Se([1,0,8,11,230,250,141,96,71,49,20,43,7,61,44,294,295,45,33]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;let i=class extends w.$Hlc{constructor(a,h,o,p,f,D,b,k){super(a,h,o,p,D,b,k),this.pb=f,this.nb=new t}X(a,h){switch(a.type){case"server":return new l.$Tmc(a);case"pipeServer":return new l.$Umc(a);case"executable":return new l.$Vmc(a,h.type)}return super.X(a,h)}fb(a,h){const o=l.$Vmc.platformAdapterExecutable(h.getAllExtensionDescriptions(),a.type);if(o)return new m.$YN(o.command,o.args,o.options)}Y(){return new R.$0cc}async $runInTerminal(a,h){if(a.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(z=>{this.nb.onTerminalClosed(z)}));const o=await this.P.getConfigProvider(),p=this.pb.getDefaultShell(!0),f=this.pb.getDefaultShellArgs(!0),D=a.title||M.localize(0,null),b=JSON.stringify({shell:p,shellArgs:f});let k=await this.nb.checkout(b,D),E,P=!1;if(k)E=a.cwd;else{const z={shellPath:p,shellArgs:f,cwd:a.cwd,name:D,iconPath:new m.$QN("debug")};P=!0,k=this.pb.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(k,b)}k.show(!0);const I=await k.processId;P?await new Promise(z=>setTimeout(z,1e3)):(k.state.isInteractedWith&&k.sendText(""),o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(p.indexOf("powershell")>=0||p.indexOf("pwsh")>=0||p.indexOf("cmd.exe")>=0?k.sendText("cls"):p.indexOf("bash")>=0?k.sendText("clear"):N.$i?k.sendText("cls"):k.sendText("clear")));const F=(0,g.$Xmc)(p,a.args,!!a.argsCanBeInterpretedByShell,E,a.env);k.sendText(F);const j=this.onDidTerminateDebugSession(z=>{z.id===h&&(this.nb.free(k),j.dispose())});return I}else if(a.kind==="external")return r(a,await this.P.getConfigProvider());return super.$runInTerminal(a,h)}};e.$Ymc=i,e.$Ymc=i=Qe([Ve(0,L.$fP),Ve(1,v.$Xkc),Ve(2,S.$Blc),Ve(3,c.$1kc),Ve(4,C.$mlc),Ve(5,$.$alc),Ve(6,y.$Elc),Ve(7,n.$BP)],i);let s;function r(d,a){if(!s)if(N.$i)s=new A.$Ubc;else if(N.$j)s=new A.$Vbc;else if(N.$k)s=new A.$Wbc;else throw new Error("external terminals not supported on this platform");const h=a.getConfiguration("terminal");return s.runInTerminal(d.title,d.cwd,d.args,d.env||{},h.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(a,h,o=!1){const f=[...this.b.entries()].map(([D,b])=>(0,u.$eh)(async k=>{if(D.name!==h||b.lastUsedAt!==-1&&await(0,g.$Wmc)(await D.processId))return null;const E=Date.now();return b.lastUsedAt+t.a>E||k.isCancellationRequested?null:b.config!==a?(o&&D.dispose(),null):(b.lastUsedAt=E,D)}));return await(0,u.$wh)(f,D=>!!D)}insert(a,h){this.b.set(a,{lastUsedAt:Date.now(),config:h})}free(a){const h=this.b.get(a);h&&(h.lastUsedAt=-1)}onTerminalClosed(a){this.b.delete(a)}}}),define(ke[376],Se([1,0,17,2,105,44,72,45,42,43,20,28,95,15,12,91,23,64,61]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=void 0;let i=class extends m.$qmc{constructor(r,t,d,a,h,o,p,f,D){super(r,t,d,a,h,o,p,f),this.C=d,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(r,t){const d=t;if(!t.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const a=m.TaskHandleDTO.from(d,this.C),h=await this.a.$getTaskExecution(a);if(h.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.z(h,t);return this.a.$executeTask(a).catch(()=>{}),o}else{const a=m.TaskDTO.from(t,r);if(a===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(a.execution)&&await this.y(a,t,!1);const h=await this.z(await this.a.$getTaskExecution(a),t);return this.a.$executeTask(a).catch(()=>{}),h}}v(r,t,d,a){const h=[];if(a)for(const o of a){this.A(o,d),(!o.definition||!r[o.definition.type])&&this.f.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const p=m.TaskDTO.from(o,d.extension);p&&(h.push(p),m.CustomExecutionDTO.is(p.execution)&&t.push(this.y(p,o,!0)))}return{tasks:h,extension:d.extension}}async w(r){return r}async G(r){let t=r&&r.length>0?r[0]:void 0;if(!t){const d=N.URI.file((0,c.homedir)());t=new $.$Li({uri:d,name:g.$2g(d),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(r,t){const d=N.URI.revive(r),a={process:void 0,variables:Object.create(null)},h=await this.b.resolveWorkspaceFolder(d),o=await this.b.getWorkspaceFolders2()??[],p=await this.D.getResolver(),f=h?{uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(o);for(const D of t.variables)a.variables[D]=await p.resolveAsync(f,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(u.$uc);for(let b=0;b<D.length;b++)D[b]=await p.resolveAsync(f,D[b])}a.process=await M.win32.findExecutable(await p.resolveAsync(f,t.process.name),t.process.cwd!==void 0?await p.resolveAsync(f,t.process.cwd):void 0,D)}return a}async $jsonTasksSupported(){return!0}async $findExecutable(r,t,d){return M.win32.findExecutable(r,t,d)}};e.$Qmc=i,e.$Qmc=i=Qe([Ve(0,L.$fP),Ve(1,C.$vP),Ve(2,A.$Xkc),Ve(3,R.$qP),Ve(4,w.$1kc),Ve(5,S.$mlc),Ve(6,v.$Xj),Ve(7,l.$Bkc),Ve(8,n.$Elc)],i)}),define(ke[377],Se([1,0,64,61]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=void 0;class M extends N.$Flc{m(){return(0,u.homedir)()}}e.$wnc=M}),define(ke[159],Se([1,0,19,8,22,47,15,17,23,2,36]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$Zlc=e.$Ylc=void 0,e.$1lc=l;class C{constructor(n,i,s){this.d=n,this.e=i,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const s=this.g.folderQueries||[],r=new M.$me(i);return new Promise((t,d)=>{this.a=new y(n);let a=!1;const h=(o,p)=>{if(!a&&!this.b){const f=this.h(o);l(o)&&typeof this.g.maxResults=="number"&&this.c+f>this.g.maxResults&&(this.b=!0,a=!0,r.cancel(),o=this.j(o,this.g.maxResults-this.c));const D=this.h(o);this.c+=D,(D>0||!l(o))&&this.a.add(o,p)}};Promise.all(s.map((o,p)=>this.k(o,f=>h(f,p),r.token))).then(o=>{r.dispose(),this.a.flush();const p=o.some(f=>!!f&&!!f.limitHit);t({limitHit:this.b||p,messages:(0,u.$Rb)(o.map(f=>f?.message?Array.isArray(f.message)?f.message:[f.message]:[])),stats:{type:this.f}})},o=>{r.dispose();const p=(0,A.$cj)(o);d(new Error(p))})})}h(n){return l(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const s=Array.isArray(n.ranges)?n.ranges:[n.ranges],r=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:s.slice(0,i),preview:{matches:r.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,s){const r=new L.$nL(this.g,n),t=[],d={report:o=>{if(!this.l(o))return;const p=n.folder.scheme===R.Schemas.file?(0,L.$oL)(()=>this.e.readdir($.$4g(o.uri))):void 0,f=$.$7g(n.folder,o.uri);if(f){const D=r.includedInQuery(f,w.$oc(f),p);(0,N.$dh)(D)?t.push(D.then(b=>{b&&i(o)})):D&&i(o)}}},a=this.n(n);let h;return this.d.query.type===3?h=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,d,s):h=await this.d.provider.provideTextSearchResults(m(this.d.query.contentPattern),a,d,s),t.length&&await Promise.all(t),h}l(n){if(l(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,L.$mL)(this.g.includePattern,n.includePattern),s=(0,L.$mL)(this.g.excludePattern,n.excludePattern),r={folder:S.URI.from(n.folder),excludes:s,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(r.usePCRE2=this.g.usePCRE2),r}}e.$Ylc=C;function m(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class y{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new g(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$Xg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Zlc=y;function v(c){return l(c)?{preview:{matches:(0,u.$2b)(c.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:c.preview.text},ranges:(0,u.$2b)(c.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function l(c){return!!c.preview}class g{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$2lc=g}),define(ke[97],Se([1,0,3,6,5,370,20,67,12,2,159]),function(le,e,u,N,M,A,R,w,$,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0,e.$5lc=m,e.$3lc=(0,M.$ri)("IExtHostSearch");let C=class{constructor(l,g,c){this.n=l,this.o=g,this.q=c,this.c=this.n.getProxy(N.$SM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new A.$Xlc}s(l){return this.o.transformOutgoingScheme(l)}registerTextSearchProvider(l,g){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const c=this.d++;return this.e.set(c,g),this.c.$registerTextSearchProvider(c,this.s(l)),(0,u.$Sc)(()=>{this.g.delete(l),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(l,g){if(this.i.has(l))throw new Error(`an AI text search provider for the scheme '${l}'is already registered`);this.i.add(l);const c=this.d++;return this.h.set(c,g),this.c.$registerAITextSearchProvider(c,this.s(l)),(0,u.$Sc)(()=>{this.i.delete(l),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(l,g){if(this.k.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.k.add(l);const c=this.d++;return this.j.set(c,g),this.c.$registerFileSearchProvider(c,this.s(l)),(0,u.$Sc)(()=>{this.k.delete(l),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(l,g,c,n){const i=m(c),s=this.j.get(l);if(s)return this.l.fileSearch(i,s,r=>{this.c.$handleFileMatch(l,g,r.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,g,c){return{messages:[]}}$clearCache(l){return this.l.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,g,c,n){const i=this.e.get(l);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${l}`);const s=m(c);return this.t(s,i).search(t=>this.c.$handleTextMatch(l,g,t),n)}$provideAITextSearchResults(l,g,c,n){const i=this.h.get(l);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${l}`);const s=m(c);return this.v(s,i).search(t=>this.c.$handleTextMatch(l,g,t),n)}$enableExtensionHostSearch(){}t(l,g){return new L.$Ylc({query:l,provider:g},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(l,g){return new L.$Ylc({query:l,provider:g},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$4lc=C,e.$4lc=C=Qe([Ve(0,R.$fP),Ve(1,w.$Ukc),Ve(2,$.$Xj)],C);function m(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(y),extraFileResources:v.extraFileResources&&v.extraFileResources.map(l=>S.URI.revive(l))}}function y(v){return{...v,folder:S.URI.revive(v.folder)}}}),define(ke[378],Se([1,0,22,13,4,3,15,41,2,135,198,179,79,25,32,12,86,87,276,6,323,349,91,120,327,328,329,310,299,33,330,45,331,96,151,332,312,324,333,334,72,71,325,49,335,69,336,60,28,350,351,313,337,121,338,115,116,314,369,340,282,341,352,342,157,315,343,344,345,20,346,97,117,347,316,348,118,93,95,90,43,155,353,354,326,355,356,70,16,7,317,67,318,92,357,358,150,44,292,114,26,94]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s,r,t,d,a,h,o,p,f,D,b,k,E,P,I,F,j,z,O,T,B,W,X,Z,Y,x,ne,ge,ue,ve,te,U,_,be,Pe,se,re,oe,K,ie,$e,we,Le,fe,De,Ie,Te,V,q,Q,J,he,pe,ze,qe,Ye,it,ot,nt,st,Ce,Be,Ge,Ne,Xe,ae,ce,Ae,Ke,Re,tt,ht,wt,Nt,At,xt,_t,Pt,qt,Xt,et,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=Yt;function Yt(dt){const vt=dt.get(ue.$vP),ti=dt.get(ge.$Fkc),Zt=dt.get(x.$3kc),zt=dt.get(Z.$Blc),gt=dt.get(Pt.$Xkc),Ut=dt.get(st.$zP),Wt=dt.get(k.$1kc),Ht=dt.get(ht.$Ukc),Ze=dt.get(Q.$fP),ui=dt.get(it.$jlc),Gt=dt.get(ot.$4kc),Bt=dt.get(l.$Yj),mt=dt.get(l.$Xj),Tt=dt.get(Ae.$WCb),Rt=dt.get(t.$Bkc),Ft=dt.get(_t.$Hmc),ii=dt.get(pe.$tlc),Kt=dt.get(W.$alc),ni=dt.get(re.$xlc),Ot=dt.get(d.$Lkc),Lt=dt.get(be.$qlc);Ze.set(i.$TM.ExtHostFileSystemInfo,ti),Ze.set(i.$TM.ExtHostLogLevelServiceShape,Bt),Ze.set(i.$TM.ExtHostWorkspace,gt),Ze.set(i.$TM.ExtHostConfiguration,Wt),Ze.set(i.$TM.ExtHostExtensionService,zt),Ze.set(i.$TM.ExtHostStorage,ui),Ze.set(i.$TM.ExtHostTunnelService,Tt),Ze.set(i.$TM.ExtHostWindow,Ft),Ze.set(i.$TM.ExtHostSecretState,ii),Ze.set(i.$TM.ExtHostTelemetry,Ut),Ze.set(i.$TM.ExtHostEditorTabs,Kt),Ze.set(i.$TM.ExtHostManagedSockets,ni),Ze.set(i.$TM.ExtHostAuthentication,Ot),Ze.set(i.$TM.ExtHostChatProvider,Lt);const It=Ze.set(i.$TM.ExtHostDecorations,dt.get(I.$Mlc)),St=Ze.set(i.$TM.ExtHostDocumentsAndEditors,dt.get(B.$qP)),bt=Ze.set(i.$TM.ExtHostCommands,dt.get(D.$BP)),Ct=Ze.set(i.$TM.ExtHostTerminalService,dt.get(Ce.$mlc)),li=Ze.set(i.$TM.ExtHostTerminalShellIntegration,dt.get(Be.$tmc)),Dt=Ze.set(i.$TM.ExtHostDebugService,dt.get(P.$Glc)),hi=Ze.set(i.$TM.ExtHostSearch,dt.get(he.$3lc)),Qt=Ze.set(i.$TM.ExtHostTask,dt.get(nt.$smc)),wi=Ze.set(i.$TM.ExtHostOutputService,dt.get(De.$fmc)),ei=Ze.set(i.$TM.ExtHostLocalization,dt.get(se.$wlc)),vi=Ze.set(i.$TM.ExtHostUrls,new wt.$Emc(Ze)),Et=Ze.set(i.$TM.ExtHostDocuments,new T.$Ikc(Ze,St)),$i=Ze.set(i.$TM.ExtHostDocumentContentProviders,new z.$Olc(Ze,St,mt)),Me=Ze.set(i.$TM.ExtHostDocumentSaveParticipant,new O.$Plc(mt,Et,Ze.getProxy(i.$SM.MainThreadBulkEdits))),je=Ze.set(i.$TM.ExtHostNotebook,new K.$6lc(Ze,bt,St,Et,Zt,hi)),Ee=Ze.set(i.$TM.ExtHostNotebookDocuments,new $e.$_lc(je)),ee=Ze.set(i.$TM.ExtHostNotebookEditors,new we.$amc(mt,je)),Fe=Ze.set(i.$TM.ExtHostNotebookKernels,new Le.$bmc(Ze,vt,je,bt,mt)),He=Ze.set(i.$TM.ExtHostNotebookRenderers,new fe.$dmc(Ze,je)),_e=Ze.set(i.$TM.ExtHostNotebookDocumentSaveParticipant,new ie.$$lc(mt,je,Ze.getProxy(i.$SM.MainThreadBulkEdits))),Je=Ze.set(i.$TM.ExtHostEditors,new Ne.$Rkc(Ze,St)),lt=Ze.set(i.$TM.ExtHostTreeViews,new ce.$Cmc(Ze.getProxy(i.$SM.MainThreadTreeViews),bt,mt)),kt=Ze.set(i.$TM.ExtHostEditorInsets,new f.$Skc(Ze.getProxy(i.$SM.MainThreadEditorInsets),Je,vt.remote)),jt=Ze.set(i.$TM.ExtHostDiagnostics,new F.$Hkc(Ze,mt,ti,St)),Vt=Ze.set(i.$TM.ExtHostLanguages,new Pe.$9lc(Ze,Et,bt.converter,Ht)),ut=Ze.set(i.$TM.ExtHostLanguageFeatures,new _.$Jkc(Ze,Ht,Et,bt,jt,mt,Rt,Ut)),ri=Ze.set(i.$TM.ExtHostFileSystem,new Y.$Rlc(Ze,ut)),di=Ze.set(i.$TM.ExtHostFileSystemEventService,new ne.$Slc(Ze,mt,St)),bi=Ze.set(i.$TM.ExtHostQuickOpen,(0,q.$jmc)(Ze,gt,bt)),Di=Ze.set(i.$TM.ExtHostSCM,new J.$lmc(Ze,bt,Et,mt)),Ai=Ze.set(i.$TM.ExtHostQuickDiff,new V.$imc(Ze,Ht)),Ri=Ze.set(i.$TM.ExtHostShare,new ze.$mmc(Ze,Ht)),Mi=Ze.set(i.$TM.ExtHostComments,(0,b.$Tkc)(Ze,bt,Et)),Ni=Ze.set(i.$TM.ExtHostProgress,new Te.$hmc(Ze.getProxy(i.$SM.MainThreadProgress))),cn=Ze.set(i.$TM.ExtHostLabelService,new U.$8lc(Ze)),Oi=Ze.set(i.$TM.ExtHostTheming,new Xe.$zmc(Ze)),Ti=Ze.set(i.$TM.ExtHostTimeline,new ae.$Bmc(Ze,bt)),yi=Ze.set(i.$TM.ExtHostWebviews,new Nt.$8kc(Ze,vt.remote,gt,mt,Rt)),Ci=Ze.set(i.$TM.ExtHostWebviewPanels,new At.$$kc(Ze,yi,gt)),Gi=Ze.set(i.$TM.ExtHostCustomEditors,new E.$_kc(Ze,Et,Gt,yi,Ci)),Ki=Ze.set(i.$TM.ExtHostWebviewViews,new xt.$Fmc(Ze,yi)),pi=Ze.set(i.$TM.ExtHostTesting,new Ge.$vmc(Ze,mt,bt,St)),Qi=Ze.set(i.$TM.ExtHostUriOpeners,new tt.$Dmc(Ze)),Ji=Ze.set(i.$TM.ExtHostProfileContentHandlers,new Ie.$gmc(Ze));Ze.set(i.$TM.ExtHostInteractive,new te.$7lc(Ze,je,St,bt,mt));const un=Ze.set(i.$TM.ExtHostInlineChat,new ve.$Tlc(Ze,bt,Et,mt)),Fi=Ze.set(i.$TM.ExtHostChatAgents2,new h.$Okc(Ze,mt,bt)),ji=Ze.set(i.$TM.ExtHostChatVariables,new o.$Pkc(Ze)),Pi=Ze.set(i.$TM.ExtHostAiRelatedInformation,new s.$Akc(Ze)),ln=Ze.set(i.$TM.ExtHostAiEmbeddingVector,new X.$Qlc(Ze)),Xi=Ze.set(i.$TM.ExtHostStatusBar,new Ye.$pmc(Ze,bt.converter)),Yi=Ze.set(i.$TM.ExtHostSpeech,new qe.$nmc(Ze)),hn=Object.values(i.$TM);Ze.assertRegistered(hn);const zi=new a.$Nkc(Ze,St),Zi=new p.$Qkc(Ze),Ii=new oe.$0lc(Ze,mt),Bi=new j.$Nlc(Ze);return r.$Kkc.register(bt),function(We,oi,Ui){function at(de){return(ye,Ue,ct)=>{const yt=de(Mt=>{try{ye.call(Ue,Mt)}catch(Si){N.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Ut.onExtensionError(We.identifier,Si)}});return ct?.push(yt),yt}}const pt=function(){let de=!We.isUnderDevelopment;function ye(){de||(mt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),de=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")ye();else{const yt=ct;typeof yt.scheme>"u"&&ye(),typeof yt.exclusive=="boolean"&&(0,et.$AG)(We,"documentFiltersExclusive")}return ct}}(),dn={getSession(de,ye,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,et.$AG)(We,"authLearnMore"),Ot.getSession(We,de,ye,Ue)},getSessions(de,ye){return(0,et.$AG)(We,"authGetSessions"),Ot.getSessions(We,de,ye)},async hasSession(de,ye){return(0,et.$AG)(We,"authSession"),!!await Ot.getSession(We,de,ye,{silent:!0})},get onDidChangeSessions(){return at(Ot.onDidChangeSessions)},registerAuthenticationProvider(de,ye,Ue,ct){return Ot.registerAuthenticationProvider(de,ye,Ue,ct)}},ai={registerCommand(de,ye,Ue){return bt.registerCommand(!0,de,ye,Ue,void 0,We)},registerTextEditorCommand(de,ye,Ue){return bt.registerCommand(!0,de,(...ct)=>{const yt=Je.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}return yt.edit(Mt=>{ye.apply(Ue,[yt,Mt,...ct])}).then(Mt=>{Mt||mt.warn("Edits from command "+de+" were not applied.")},Mt=>{mt.warn("An error occurred while running command "+de,Mt)})},void 0,void 0,We)},registerDiffInformationCommand:(de,ye,Ue)=>((0,et.$AG)(We,"diffCommand"),bt.registerCommand(!0,de,async(...ct)=>{const yt=St.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}const Mt=await Je.getDiffInformation(yt.id);ye.apply(Ue,[Mt,...ct])},void 0,void 0,We)),executeCommand(de,...ye){return bt.executeCommand(de,...ye)},getCommands(de=!1){return bt.getCommands(de)}},Ei={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Zi.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return at(Ct.onDidChangeShell)},get isTelemetryEnabled(){return Ut.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Ut.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$AG)(We,"telemetry"),Ut.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$AG)(We,"telemetry"),at(Ut.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,st.$yP)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(de,ye){return st.$xP.validateSender(de),Ut.instantiateLogger(We,de,ye)},openExternal(de,ye){return Ft.openUri(de,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(de){if(de.scheme===vt.environment.appUriScheme)return vi.createAppUri(de);try{return await Ft.asExternalUri(de,{allowTunneling:!!vt.remote.authority})}catch(ye){if((0,R.$Ag)(de,R.Schemas.http)||(0,R.$Ag)(de,R.Schemas.https))return de;throw ye}},get remoteName(){return(0,g.$Dm)(vt.remote.authority)},get remoteAuthority(){return(0,et.$AG)(We,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return at(mt.onDidChangeLogLevel)},get appQuality(){return(0,et.$AG)(We,"resolvers"),vt.quality},get appCommit(){return(0,et.$AG)(We,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(Ei);const xi={createTestController(de,ye,Ue){return pi.createTestController(We,de,ye,Ue)},createTestObserver(){return(0,et.$AG)(We,"testObserver"),pi.createTestObserver()},runTests(de){return(0,et.$AG)(We,"testObserver"),pi.runTests(de)},get onDidChangeTestResults(){return(0,et.$AG)(We,"testObserver"),at(pi.onResultsChanged)},get testResults(){return(0,et.$AG)(We,"testObserver"),pi.results}},ki=vt.remote.isRemote?Re.ExtensionKind.Workspace:Re.ExtensionKind.UI,_i={getExtension(de,ye){(0,et.$zG)(We,"extensionsAny")||(ye=!1);const Ue=oi.mine.getExtensionDescription(de);if(Ue)return new Z.$Clc(zt,We.identifier,Ue,ki,!1);if(ye){const ct=oi.all.getExtensionDescription(de);if(ct)return new Z.$Clc(zt,We.identifier,ct,ki,!0)}},get all(){const de=[];for(const ye of oi.mine.getAllExtensionDescriptions())de.push(new Z.$Clc(zt,We.identifier,ye,ki,!1));return de},get allAcrossExtensionHosts(){(0,et.$AG)(We,"extensionsAny");const de=new y.$Nm(oi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ye=[];for(const Ue of oi.all.getAllExtensionDescriptions()){const ct=!de.has(Ue.identifier);ye.push(new Z.$Clc(zt,We.identifier,Ue,ki,ct))}return ye},get onDidChange(){return(0,et.$zG)(We,"extensionsAny")?at(M.Event.any(oi.mine.onDidChange,oi.all.onDidChange)):at(oi.mine.onDidChange)}},en={createDiagnosticCollection(de){return jt.createDiagnosticCollection(We.identifier,de)},get onDidChangeDiagnostics(){return at(jt.onDidChangeDiagnostics)},getDiagnostics:de=>jt.getDiagnostics(de),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(de,ye){return Vt.changeLanguage(de.uri,ye)},match(de,ye){const Ue=Ke.LanguageSelector.from(de);let ct;return(0,L.$Yt)(Ue)&&(ct=je.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Mt=>Mt.document===ye))?.apiNotebook),(0,L.$Xt)(Ue,ye.uri,ye.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(de,ye,Ue){return ut.registerCodeActionProvider(We,pt(de),ye,Ue)},registerDocumentPasteEditProvider(de,ye,Ue){return(0,et.$AG)(We,"documentPaste"),ut.registerDocumentPasteEditProvider(We,pt(de),ye,Ue)},registerCodeLensProvider(de,ye){return ut.registerCodeLensProvider(We,pt(de),ye)},registerDefinitionProvider(de,ye){return ut.registerDefinitionProvider(We,pt(de),ye)},registerDeclarationProvider(de,ye){return ut.registerDeclarationProvider(We,pt(de),ye)},registerImplementationProvider(de,ye){return ut.registerImplementationProvider(We,pt(de),ye)},registerTypeDefinitionProvider(de,ye){return ut.registerTypeDefinitionProvider(We,pt(de),ye)},registerHoverProvider(de,ye){return ut.registerHoverProvider(We,pt(de),ye,We.identifier)},registerEvaluatableExpressionProvider(de,ye){return ut.registerEvaluatableExpressionProvider(We,pt(de),ye,We.identifier)},registerInlineValuesProvider(de,ye){return ut.registerInlineValuesProvider(We,pt(de),ye,We.identifier)},registerDocumentHighlightProvider(de,ye){return ut.registerDocumentHighlightProvider(We,pt(de),ye)},registerMultiDocumentHighlightProvider(de,ye){return ut.registerMultiDocumentHighlightProvider(We,pt(de),ye)},registerLinkedEditingRangeProvider(de,ye){return ut.registerLinkedEditingRangeProvider(We,pt(de),ye)},registerReferenceProvider(de,ye){return ut.registerReferenceProvider(We,pt(de),ye)},registerRenameProvider(de,ye){return ut.registerRenameProvider(We,pt(de),ye)},registerNewSymbolNamesProvider(de,ye){return(0,et.$AG)(We,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(We,pt(de),ye)},registerDocumentSymbolProvider(de,ye,Ue){return ut.registerDocumentSymbolProvider(We,pt(de),ye,Ue)},registerWorkspaceSymbolProvider(de){return ut.registerWorkspaceSymbolProvider(We,de)},registerDocumentFormattingEditProvider(de,ye){return ut.registerDocumentFormattingEditProvider(We,pt(de),ye)},registerDocumentRangeFormattingEditProvider(de,ye){return ut.registerDocumentRangeFormattingEditProvider(We,pt(de),ye)},registerOnTypeFormattingEditProvider(de,ye,Ue,...ct){return ut.registerOnTypeFormattingEditProvider(We,pt(de),ye,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(de,ye,Ue){return ut.registerDocumentSemanticTokensProvider(We,pt(de),ye,Ue)},registerDocumentRangeSemanticTokensProvider(de,ye,Ue){return ut.registerDocumentRangeSemanticTokensProvider(We,pt(de),ye,Ue)},registerSignatureHelpProvider(de,ye,Ue,...ct){return typeof Ue=="object"?ut.registerSignatureHelpProvider(We,pt(de),ye,Ue):ut.registerSignatureHelpProvider(We,pt(de),ye,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(de,ye,...Ue){return ut.registerCompletionItemProvider(We,pt(de),ye,Ue)},registerInlineCompletionItemProvider(de,ye,Ue){return ye.handleDidShowCompletionItem&&(0,et.$AG)(We,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,et.$AG)(We,"inlineCompletionsAdditions"),Ue&&(0,et.$AG)(We,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(We,pt(de),ye,Ue)},registerInlineEditProvider(de,ye){return(0,et.$AG)(We,"inlineEdit"),ut.registerInlineEditProvider(We,pt(de),ye)},registerDocumentLinkProvider(de,ye){return ut.registerDocumentLinkProvider(We,pt(de),ye)},registerColorProvider(de,ye){return ut.registerColorProvider(We,pt(de),ye)},registerFoldingRangeProvider(de,ye){return ut.registerFoldingRangeProvider(We,pt(de),ye)},registerSelectionRangeProvider(de,ye){return ut.registerSelectionRangeProvider(We,de,ye)},registerCallHierarchyProvider(de,ye){return ut.registerCallHierarchyProvider(We,de,ye)},registerTypeHierarchyProvider(de,ye){return ut.registerTypeHierarchyProvider(We,de,ye)},setLanguageConfiguration:(de,ye)=>ut.setLanguageConfiguration(We,de,ye),getTokenInformationAtPosition(de,ye){return(0,et.$AG)(We,"tokenInformation"),Vt.tokenAtPosition(de,ye)},registerInlayHintsProvider(de,ye){return ut.registerInlayHintsProvider(We,de,ye)},createLanguageStatusItem(de,ye){return Vt.createLanguageStatusItem(We,de,ye)},registerDocumentDropEditProvider(de,ye,Ue){return ut.registerDocumentOnDropEditProvider(We,de,ye,(0,et.$zG)(We,"documentPaste")?Ue:void 0)}},fn={get activeTextEditor(){return Je.getActiveTextEditor()},get visibleTextEditors(){return Je.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(de,ye,Ue){$.URI.isUri(de)&&de.scheme===R.Schemas.vscodeRemote&&!de.authority&&Rt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await($.URI.isUri(de)?Promise.resolve(Wi.openTextDocument(de)):Promise.resolve(de));return Je.showTextDocument(ct,ye,Ue)},createTextEditorDecorationType(de){return Je.createTextEditorDecorationType(We,de)},onDidChangeActiveTextEditor(de,ye,Ue){return at(Je.onDidChangeActiveTextEditor)(de,ye,Ue)},onDidChangeVisibleTextEditors(de,ye,Ue){return at(Je.onDidChangeVisibleTextEditors)(de,ye,Ue)},onDidChangeTextEditorSelection(de,ye,Ue){return at(Je.onDidChangeTextEditorSelection)(de,ye,Ue)},onDidChangeTextEditorOptions(de,ye,Ue){return at(Je.onDidChangeTextEditorOptions)(de,ye,Ue)},onDidChangeTextEditorVisibleRanges(de,ye,Ue){return at(Je.onDidChangeTextEditorVisibleRanges)(de,ye,Ue)},onDidChangeTextEditorViewColumn(de,ye,Ue){return at(Je.onDidChangeTextEditorViewColumn)(de,ye,Ue)},onDidCloseTerminal(de,ye,Ue){return at(Ct.onDidCloseTerminal)(de,ye,Ue)},onDidOpenTerminal(de,ye,Ue){return at(Ct.onDidOpenTerminal)(de,ye,Ue)},onDidChangeActiveTerminal(de,ye,Ue){return at(Ct.onDidChangeActiveTerminal)(de,ye,Ue)},onDidChangeTerminalDimensions(de,ye,Ue){return(0,et.$AG)(We,"terminalDimensions"),at(Ct.onDidChangeTerminalDimensions)(de,ye,Ue)},onDidChangeTerminalState(de,ye,Ue){return at(Ct.onDidChangeTerminalState)(de,ye,Ue)},onDidWriteTerminalData(de,ye,Ue){return(0,et.$AG)(We,"terminalDataWriteEvent"),at(Ct.onDidWriteTerminalData)(de,ye,Ue)},onDidExecuteTerminalCommand(de,ye,Ue){return(0,et.$AG)(We,"terminalExecuteCommandEvent"),at(Ct.onDidExecuteTerminalCommand)(de,ye,Ue)},onDidChangeTerminalShellIntegration(de,ye,Ue){return(0,et.$AG)(We,"terminalShellIntegration"),at(li.onDidChangeTerminalShellIntegration)(de,ye,Ue)},onDidStartTerminalShellExecution(de,ye,Ue){return(0,et.$AG)(We,"terminalShellIntegration"),at(li.onDidStartTerminalShellExecution)(de,ye,Ue)},onDidEndTerminalShellExecution(de,ye,Ue){return(0,et.$AG)(We,"terminalShellIntegration"),at(li.onDidEndTerminalShellExecution)(de,ye,Ue)},get state(){return Ft.getState()},onDidChangeWindowState(de,ye,Ue){return at(Ft.onDidChangeWindowState)(de,ye,Ue)},showInformationMessage(de,...ye){return Ii.showMessage(We,w.default.Info,de,ye[0],ye.slice(1))},showWarningMessage(de,...ye){return Ii.showMessage(We,w.default.Warning,de,ye[0],ye.slice(1))},showErrorMessage(de,...ye){return Ii.showMessage(We,w.default.Error,de,ye[0],ye.slice(1))},showQuickPick(de,ye,Ue){return bi.showQuickPick(We,de,ye,Ue)},showWorkspaceFolderPick(de){return bi.showWorkspaceFolderPick(de)},showInputBox(de,ye){return bi.showInput(de,ye)},showOpenDialog(de){return Bi.showOpenDialog(We,de)},showSaveDialog(de){return Bi.showSaveDialog(de)},createStatusBarItem(de,ye,Ue){let ct,yt,Mt;return typeof de=="string"?(ct=de,yt=ye,Mt=Ue):(yt=de,Mt=ye),Xi.createStatusBarEntry(We,ct,yt,Mt)},setStatusBarMessage(de,ye){return Xi.setStatusBarMessage(de,ye)},withScmProgress(de){return Rt.report("window.withScmProgress",We,"Use 'withProgress' instead."),Ni.withProgress(We,{location:Re.ProgressLocation.SourceControl},(ye,Ue)=>de({report(ct){}}))},withProgress(de,ye){return Ni.withProgress(We,de,ye)},createOutputChannel(de,ye){return wi.createOutputChannel(de,ye,We)},createWebviewPanel(de,ye,Ue,ct){return Ci.createWebviewPanel(We,de,ye,Ue,ct)},createWebviewTextEditorInset(de,ye,Ue,ct){return(0,et.$AG)(We,"editorInsets"),kt.createWebviewEditorInset(de,ye,Ue,ct,We)},createTerminal(de,ye,Ue){return typeof de=="object"?"pty"in de?Ct.createExtensionTerminal(de):Ct.createTerminalFromOptions(de):Ct.createTerminal(de,ye,Ue)},registerTerminalLinkProvider(de){return Ct.registerLinkProvider(de)},registerTerminalProfileProvider(de,ye){return Ct.registerProfileProvider(We,de,ye)},registerTerminalQuickFixProvider(de,ye){return(0,et.$AG)(We,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(de,We.identifier.value,ye)},registerTreeDataProvider(de,ye){return lt.registerTreeDataProvider(de,ye,We)},createTreeView(de,ye){return lt.createTreeView(de,ye,We)},registerWebviewPanelSerializer:(de,ye)=>Ci.registerWebviewPanelSerializer(We,de,ye),registerCustomEditorProvider:(de,ye,Ue={})=>Gi.registerCustomEditorProvider(We,de,ye,Ue),registerFileDecorationProvider(de){return It.registerFileDecorationProvider(de,We)},registerUriHandler(de){return vi.registerUriHandler(We,de)},createQuickPick(){return bi.createQuickPick(We)},createInputBox(){return bi.createInputBox(We)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(de,ye,Ue){return at(Oi.onDidChangeActiveColorTheme)(de,ye,Ue)},registerWebviewViewProvider(de,ye,Ue){return Ki.registerWebviewViewProvider(We,de,ye,Ue?.webviewOptions)},get activeNotebookEditor(){return je.activeNotebookEditor},onDidChangeActiveNotebookEditor(de,ye,Ue){return at(je.onDidChangeActiveNotebookEditor)(de,ye,Ue)},get visibleNotebookEditors(){return je.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(je.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(de,ye,Ue){return at(ee.onDidChangeNotebookEditorSelection)(de,ye,Ue)},onDidChangeNotebookEditorVisibleRanges(de,ye,Ue){return at(ee.onDidChangeNotebookEditorVisibleRanges)(de,ye,Ue)},showNotebookDocument(de,ye){return je.showNotebookDocument(de,ye)},registerExternalUriOpener(de,ye,Ue){return(0,et.$AG)(We,"externalUriOpener"),Qi.registerExternalUriOpener(We.identifier,de,ye,Ue)},registerProfileContentHandler(de,ye){return(0,et.$AG)(We,"profileContentHandlers"),Ji.registerProfileContentHandler(We,de,ye)},registerQuickDiffProvider(de,ye,Ue,ct){return(0,et.$AG)(We,"quickDiffProvider"),Ai.registerQuickDiffProvider(pt(de),ye,Ue,ct)},get tabGroups(){return Kt.tabGroups},registerShareProvider(de,ye){return(0,et.$AG)(We,"shareProvider"),Ri.registerShareProvider(pt(de),ye)}},Wi={get rootPath(){return Rt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(de){throw new N.$9("rootPath")},getWorkspaceFolder(de){return gt.getWorkspaceFolder(de)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(de){throw new N.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(de){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(de,ye,...Ue)=>gt.updateWorkspaceFolders(We,de,ye||0,...Ue),onDidChangeWorkspaceFolders:function(de,ye,Ue){return at(gt.onDidChangeWorkspace)(de,ye,Ue)},asRelativePath:(de,ye)=>gt.getRelativePath(de,ye),findFiles:(de,ye,Ue,ct)=>gt.findFiles(de,ye,Ue,We.identifier,ct),findFiles2:(de,ye,Ue)=>((0,et.$AG)(We,"findFiles2"),gt.findFiles2(de,ye,We.identifier,Ue)),findTextInFiles:(de,ye,Ue,ct)=>{(0,et.$AG)(We,"findTextInFiles");let yt,Mt;return typeof ye=="object"?(yt=ye,Mt=Ue):(yt={},Mt=ye,ct=Ue),gt.findTextInFiles(de,yt||{},Mt,We.identifier,ct)},save:de=>gt.save(de),saveAs:de=>gt.saveAs(de),saveAll:de=>gt.saveAll(de),applyEdit(de,ye){return zi.applyWorkspaceEdit(de,We,ye)},createFileSystemWatcher:(de,ye,Ue,ct)=>{let yt;return typeof ye=="boolean"?yt={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:ye&&((0,et.$AG)(We,"createFileSystemWatcher"),yt={...ye,correlate:!0}),di.createFileSystemWatcher(gt,We,de,yt)},get textDocuments(){return Et.getAllDocumentData().map(de=>de.document)},set textDocuments(de){throw new N.$9("textDocuments")},openTextDocument(de){let ye;const Ue=de;if(typeof de=="string")ye=Promise.resolve($.URI.file(de));else if($.URI.isUri(de))ye=Promise.resolve(de);else if(!Ue||typeof Ue=="object")ye=Et.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ct=>(ct.scheme===R.Schemas.vscodeRemote&&!ct.authority&&Rt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),Et.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(de,ye,Ue)=>at(Et.onDidAddDocument)(de,ye,Ue),onDidCloseTextDocument:(de,ye,Ue)=>at(Et.onDidRemoveDocument)(de,ye,Ue),onDidChangeTextDocument:(de,ye,Ue)=>at(Et.onDidChangeDocument)(de,ye,Ue),onDidSaveTextDocument:(de,ye,Ue)=>at(Et.onDidSaveDocument)(de,ye,Ue),onWillSaveTextDocument:(de,ye,Ue)=>at(Me.getOnWillSaveTextDocumentEvent(We))(de,ye,Ue),get notebookDocuments(){return je.notebookDocuments.map(de=>de.apiNotebook)},async openNotebookDocument(de,ye){let Ue;if($.URI.isUri(de))Ue=de,await je.openNotebookDocument(de);else if(typeof de=="string")Ue=$.URI.revive(await je.createNotebookDocument({viewType:de,content:ye}));else throw new Error("Invalid arguments");return je.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(de,ye,Ue){return at(Ee.onDidSaveNotebookDocument)(de,ye,Ue)},onDidChangeNotebookDocument(de,ye,Ue){return at(Ee.onDidChangeNotebookDocument)(de,ye,Ue)},onWillSaveNotebookDocument(de,ye,Ue){return at(_e.getOnWillSaveNotebookDocumentEvent(We))(de,ye,Ue)},get onDidOpenNotebookDocument(){return at(je.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(je.onDidCloseNotebookDocument)},registerNotebookSerializer(de,ye,Ue,ct){return je.registerNotebookSerializer(We,de,ye,Ue,(0,et.$zG)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(de,ye,Ue)=>at(Ui.onDidChangeConfiguration)(de,ye,Ue),getConfiguration(de,ye){return ye=arguments.length===1?void 0:ye,Ui.getConfiguration(de,ye,We)},registerTextDocumentContentProvider(de,ye){return $i.registerTextDocumentContentProvider(de,ye)},registerTaskProvider:(de,ye)=>(Rt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(We,de,ye)),registerFileSystemProvider(de,ye,Ue){return(0,A.$Rc)(ri.registerFileSystemProvider(We,de,ye,Ue),Zt.addFileSystemProvider(de,ye,Ue))},get fs(){return Zt.value},registerFileSearchProvider:(de,ye)=>((0,et.$AG)(We,"fileSearchProvider"),hi.registerFileSearchProvider(de,ye)),registerTextSearchProvider:(de,ye)=>((0,et.$AG)(We,"textSearchProvider"),hi.registerTextSearchProvider(de,ye)),registerAITextSearchProvider:(de,ye)=>((0,et.$AG)(We,"aiTextSearchProvider"),(0,et.$AG)(We,"textSearchProvider"),hi.registerAITextSearchProvider(de,ye)),registerRemoteAuthorityResolver:(de,ye)=>((0,et.$AG)(We,"resolvers"),zt.registerRemoteAuthorityResolver(de,ye)),registerResourceLabelFormatter:de=>((0,et.$AG)(We,"resolvers"),cn.$registerResourceLabelFormatter(de)),getRemoteExecServer:de=>((0,et.$AG)(We,"resolvers"),zt.getRemoteExecServer(de)),onDidCreateFiles:(de,ye,Ue)=>at(di.onDidCreateFile)(de,ye,Ue),onDidDeleteFiles:(de,ye,Ue)=>at(di.onDidDeleteFile)(de,ye,Ue),onDidRenameFiles:(de,ye,Ue)=>at(di.onDidRenameFile)(de,ye,Ue),onWillCreateFiles:(de,ye,Ue)=>at(di.getOnWillCreateFileEvent(We))(de,ye,Ue),onWillDeleteFiles:(de,ye,Ue)=>at(di.getOnWillDeleteFileEvent(We))(de,ye,Ue),onWillRenameFiles:(de,ye,Ue)=>at(di.getOnWillRenameFileEvent(We))(de,ye,Ue),openTunnel:de=>((0,et.$AG)(We,"tunnels"),Tt.openTunnel(We,de).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,et.$AG)(We,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(de,ye,Ue)=>((0,et.$AG)(We,"tunnels"),at(Tt.onDidChangeTunnels)(de,ye,Ue)),registerPortAttributesProvider:(de,ye)=>((0,et.$AG)(We,"portsAttributes"),Tt.registerPortsAttributesProvider(de,ye)),registerTunnelProvider:(de,ye)=>((0,et.$AG)(We,"tunnelFactory"),Tt.registerTunnelProvider(de,ye)),registerTimelineProvider:(de,ye)=>((0,et.$AG)(We,"timeline"),Ti.registerTimelineProvider(de,ye,We.identifier,bt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:de=>((0,et.$AG)(We,"workspaceTrust"),gt.requestWorkspaceTrust(de)),onDidGrantWorkspaceTrust:(de,ye,Ue)=>at(gt.onDidGrantWorkspaceTrust)(de,ye,Ue),registerEditSessionIdentityProvider:(de,ye)=>((0,et.$AG)(We,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(de,ye)),onWillCreateEditSessionIdentity:(de,ye,Ue)=>((0,et.$AG)(We,"editSessionIdentityProvider"),at(gt.getOnWillCreateEditSessionIdentityEvent(We))(de,ye,Ue)),registerCanonicalUriProvider:(de,ye)=>((0,et.$AG)(We,"canonicalUriProvider"),gt.registerCanonicalUriProvider(de,ye)),getCanonicalUri:(de,ye,Ue)=>((0,et.$AG)(We,"canonicalUriProvider"),gt.provideCanonicalUri(de,ye,Ue))},tn={get inputBox(){return Rt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),Di.getLastInputBox(We)},createSourceControl(de,ye,Ue){return Di.createSourceControl(We,de,ye,Ue)}},gn={createCommentController(de,ye){return Mi.createCommentController(We,de,ye)}},mn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,et.$zG)(We,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(de,ye){return(0,et.$AG)(We,"debugVisualization"),Dt.registerDebugVisualizationProvider(We,de,ye)},registerDebugVisualizationTreeProvider(de,ye){return(0,et.$AG)(We,"debugVisualization"),Dt.registerDebugVisualizationTree(We,de,ye)},onDidStartDebugSession(de,ye,Ue){return at(Dt.onDidStartDebugSession)(de,ye,Ue)},onDidTerminateDebugSession(de,ye,Ue){return at(Dt.onDidTerminateDebugSession)(de,ye,Ue)},onDidChangeActiveDebugSession(de,ye,Ue){return at(Dt.onDidChangeActiveDebugSession)(de,ye,Ue)},onDidReceiveDebugSessionCustomEvent(de,ye,Ue){return at(Dt.onDidReceiveDebugSessionCustomEvent)(de,ye,Ue)},onDidChangeBreakpoints(de,ye,Ue){return at(Dt.onDidChangeBreakpoints)(de,ye,Ue)},onDidChangeActiveStackItem(de,ye,Ue){return(0,et.$AG)(We,"debugFocus"),at(Dt.onDidChangeActiveStackItem)(de,ye,Ue)},registerDebugConfigurationProvider(de,ye,Ue){return Dt.registerDebugConfigurationProvider(de,ye,Ue||qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(de,ye){return Dt.registerDebugAdapterDescriptorFactory(We,de,ye)},registerDebugAdapterTrackerFactory(de,ye){return Dt.registerDebugAdapterTrackerFactory(de,ye)},startDebugging(de,ye,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Dt.startDebugging(de,ye,{parentSession:Ue}):Dt.startDebugging(de,ye,Ue||{})},stopDebugging(de){return Dt.stopDebugging(de)},addBreakpoints(de){return Dt.addBreakpoints(de)},removeBreakpoints(de){return Dt.removeBreakpoints(de)},asDebugSourceUri(de,ye){return Dt.asDebugSourceUri(de,ye)}},nn={registerTaskProvider:(de,ye)=>Qt.registerTaskProvider(We,de,ye),fetchTasks:de=>Qt.fetchTasks(de),executeTask:de=>Qt.executeTask(We,de),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(de,ye,Ue)=>at(Qt.onDidStartTask)(de,ye,Ue),onDidEndTask:(de,ye,Ue)=>at(Qt.onDidEndTask)(de,ye,Ue),onDidStartTaskProcess:(de,ye,Ue)=>at(Qt.onDidStartTaskProcess)(de,ye,Ue),onDidEndTaskProcess:(de,ye,Ue)=>at(Qt.onDidEndTaskProcess)(de,ye,Ue)},Vi={createNotebookController(de,ye,Ue,ct,yt){return Fe.createNotebookController(We,de,ye,Ue,ct,(0,et.$zG)(We,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(de,ye)=>je.registerNotebookCellStatusBarItemProvider(We,de,ye),createRendererMessaging(de){return He.createRendererMessaging(We,de)},createNotebookControllerDetectionTask(de){return(0,et.$AG)(We,"notebookKernelSource"),Fe.createNotebookControllerDetectionTask(We,de)},registerKernelSourceActionProvider(de,ye){return(0,et.$AG)(We,"notebookKernelSource"),Fe.registerKernelSourceActionProvider(We,de,ye)},onDidChangeNotebookCellExecutionState(de,ye,Ue){return(0,et.$AG)(We,"notebookCellExecutionState"),at(Fe.onDidChangeNotebookCellExecutionState)(de,ye,Ue)}},rn={t(...de){if(typeof de[0]=="string"){const ye=de.shift(),Ue=!de||typeof de[0]!="object"?de:de[0];return ei.getMessage(We.identifier.value,{message:ye,args:Ue})}return ei.getMessage(We.identifier.value,de[0])},get bundle(){return ei.getBundle(We.identifier.value)},get uri(){return ei.getBundleUri(We.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(de,ye){return(0,et.$AG)(We,"interactive"),un.registerProvider(We,de,ye)},transferActiveChat(de){return(0,et.$AG)(We,"interactive"),Fi.transferActiveChat(de)}},on={getRelatedInformation(de,ye){return(0,et.$AG)(We,"aiRelatedInformation"),Pi.getRelatedInformation(We,de,ye)},registerRelatedInformationProvider(de,ye){return(0,et.$AG)(We,"aiRelatedInformation"),Pi.registerRelatedInformationProvider(We,de,ye)},registerEmbeddingVectorProvider(de,ye){return(0,et.$AG)(We,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(We,de,ye)}},$n={registerChatResponseProvider(de,ye,Ue){return(0,et.$AG)(We,"chatProvider"),Lt.registerLanguageModel(We,de,ye,Ue)},registerChatVariableResolver(de,ye,Ue){return(0,et.$AG)(We,"chatVariableResolver"),ji.registerVariableResolver(We,de,ye,Ue)},registerMappedEditsProvider(de,ye){return(0,et.$AG)(We,"mappedEditsProvider"),ut.registerMappedEditsProvider(We,de,ye)},createChatParticipant(de,ye){return(0,et.$AG)(We,"chatParticipant"),Fi.createChatAgent(We,de,ye)},createDynamicChatParticipant(de,ye,Ue,ct){return(0,et.$AG)(We,"chatParticipantAdditions"),Fi.createDynamicChatAgent(We,de,ye,Ue,ct)}},bn={get languageModels(){return(0,et.$AG)(We,"languageModels"),Lt.getLanguageModelIds()},onDidChangeLanguageModels:(de,ye,Ue)=>((0,et.$AG)(We,"languageModels"),Lt.onDidChangeProviders(de,ye,Ue)),sendChatRequest(de,ye,Ue,ct){return(0,et.$AG)(We,"languageModels"),Lt.sendChatRequest(We,de,ye,Ue,ct)},computeTokenLength(de,ye,Ue){return(0,et.$AG)(We,"languageModels"),Ue??=u.CancellationToken.None,Lt.computeTokenLength(de,ye,Ue)},getLanguageModelInformation(de){return(0,et.$AG)(We,"languageModels"),Lt.getLanguageModelInfo(de)}},an={registerSpeechProvider(de,ye){return(0,et.$AG)(We,"speech"),Yi.registerProvider(We.identifier,de,ye)}};return{version:vt.version,ai:on,authentication:dn,commands:ai,comments:gn,chat:$n,debug:mn,env:Ei,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:bn,notebooks:Vi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Wi,Breakpoint:Re.$UN,TerminalOutputAnchor:Re.TerminalOutputAnchor,ChatResultFeedbackKind:Re.ChatResultFeedbackKind,ChatVariableLevel:Re.ChatVariableLevel,ChatCompletionItem:Re.$PO,CallHierarchyIncomingCall:Re.$gN,CallHierarchyItem:Re.$fN,CallHierarchyOutgoingCall:Re.$hN,CancellationError:N.$5,CancellationTokenSource:u.$me,CandidatePortSource:i.CandidatePortSource,CodeAction:Re.$cN,CodeActionKind:Re.$dN,CodeActionTriggerKind:Re.CodeActionTriggerKind,CodeLens:Re.$iN,Color:Re.$vN,ColorInformation:Re.$wN,ColorPresentation:Re.$xN,ColorThemeKind:Re.ColorThemeKind,CommentMode:Re.CommentMode,CommentState:Re.CommentState,CommentThreadCollapsibleState:Re.CommentThreadCollapsibleState,CommentThreadState:Re.CommentThreadState,CommentThreadApplicability:Re.CommentThreadApplicability,CompletionItem:Re.$pN,CompletionItemKind:Re.CompletionItemKind,CompletionItemTag:Re.CompletionItemTag,CompletionList:Re.$qN,CompletionTriggerKind:Re.CompletionTriggerKind,ConfigurationTarget:Re.ConfigurationTarget,CustomExecution:Re.$FN,DebugAdapterExecutable:Re.$YN,DebugAdapterInlineImplementation:Re.$2N,DebugAdapterNamedPipeServer:Re.$1N,DebugAdapterServer:Re.$ZN,DebugConfigurationProviderTriggerKind:qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Re.DebugConsoleMode,DebugVisualization:Re.$fO,DecorationRangeBehavior:Re.DecorationRangeBehavior,Diagnostic:Re.$9M,DiagnosticRelatedInformation:Re.$8M,DiagnosticSeverity:Re.DiagnosticSeverity,DiagnosticTag:Re.DiagnosticTag,Disposable:Re.$UM,DocumentHighlight:Re.$$M,DocumentHighlightKind:Re.DocumentHighlightKind,MultiDocumentHighlight:Re.$_M,DocumentLink:Re.$uN,DocumentSymbol:Re.$bN,EndOfLine:Re.EndOfLine,EnvironmentVariableMutatorType:Re.EnvironmentVariableMutatorType,EvaluatableExpression:Re.$5N,InlineValueText:Re.$6N,InlineValueVariableLookup:Re.$7N,InlineValueEvaluatableExpression:Re.$8N,InlineCompletionTriggerKind:Re.InlineCompletionTriggerKind,EventEmitter:M.$be,ExtensionKind:Re.ExtensionKind,ExtensionMode:Re.ExtensionMode,ExternalUriOpenerPriority:Re.ExternalUriOpenerPriority,FileChangeType:Re.FileChangeType,FileDecoration:Re.$hO,FileDecoration2:Re.$hO,FileSystemError:Re.$$N,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Re.$_N,FoldingRangeKind:Re.FoldingRangeKind,FunctionBreakpoint:Re.$WN,InlineCompletionItem:Re.$rN,InlineCompletionList:Re.$sN,Hover:Re.$0M,IndentAction:C.IndentAction,Location:Re.$7M,MarkdownString:Re.$jN,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Re.$kN,PortAutoForwardAction:Re.PortAutoForwardAction,Position:Re.$VM,ProcessExecution:Re.$DN,ProgressLocation:Re.ProgressLocation,QuickInputButtons:Re.$gO,Range:Re.$WM,RelativePattern:Re.$SN,Selection:Re.$XM,SelectionRange:Re.$eN,SemanticTokens:Re.$cO,SemanticTokensBuilder:Re.$bO,SemanticTokensEdit:Re.$dO,SemanticTokensEdits:Re.$eO,SemanticTokensLegend:Re.$aO,ShellExecution:Re.$EN,ShellQuoting:Re.ShellQuoting,SignatureHelp:Re.$mN,SignatureHelpTriggerKind:Re.SignatureHelpTriggerKind,SignatureInformation:Re.$lN,SnippetString:Re.$6M,SourceBreakpoint:Re.$VN,StandardTokenType:Re.StandardTokenType,StatusBarAlignment:Re.StatusBarAlignment,SymbolInformation:Re.$aN,SymbolKind:Re.SymbolKind,SymbolTag:Re.SymbolTag,Task:Re.$GN,TaskGroup:Re.$CN,TaskPanelKind:Re.TaskPanelKind,TaskRevealKind:Re.TaskRevealKind,TaskScope:Re.TaskScope,TerminalLink:Re.$yN,TerminalQuickFixTerminalCommand:Re.$AN,TerminalQuickFixOpener:Re.$zN,TerminalLocation:Re.TerminalLocation,TerminalProfile:Re.$BN,TerminalExitReason:Re.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Re.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Re.TextDocumentSaveReason,TextEdit:Re.$2M,SnippetTextEdit:Re.$4M,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:Re.TextEditorLineNumbersStyle,TextEditorRevealType:Re.TextEditorRevealType,TextEditorSelectionChangeKind:Re.TextEditorSelectionChangeKind,SyntaxTokenType:Re.SyntaxTokenType,TextDocumentChangeReason:Re.TextDocumentChangeReason,ThemeColor:Re.$RN,ThemeIcon:Re.$QN,TreeItem:Re.$HN,TreeItemCheckboxState:Re.TreeItemCheckboxState,TreeItemCollapsibleState:Re.TreeItemCollapsibleState,TypeHierarchyItem:Re.$DO,UIKind:Xt.UIKind,Uri:$.URI,ViewColumn:Re.ViewColumn,WorkspaceEdit:Re.$5M,DocumentPasteTriggerKind:Re.DocumentPasteTriggerKind,DocumentDropEdit:Re.$NN,DocumentDropOrPasteEditKind:Re.$ON,DocumentPasteEdit:Re.$PN,InlayHint:Re.$oN,InlayHintLabelPart:Re.$nN,InlayHintKind:Re.InlayHintKind,RemoteAuthorityResolverError:Re.$1M,ResolvedAuthority:Re.$YM,ManagedResolvedAuthority:Re.$ZM,SourceControlInputBoxValidationType:Re.SourceControlInputBoxValidationType,ExtensionRuntime:Re.ExtensionRuntime,TimelineItem:Re.$rO,NotebookRange:Re.$jO,NotebookCellKind:Re.NotebookCellKind,NotebookCellExecutionState:Re.NotebookCellExecutionState,NotebookCellData:Re.$kO,NotebookData:Re.$lO,NotebookRendererScript:Re.$pO,NotebookCellStatusBarAlignment:Re.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Re.NotebookEditorRevealType,NotebookCellOutput:Re.$nO,NotebookCellOutputItem:Re.$mO,NotebookCellStatusBarItem:Re.$oO,NotebookControllerAffinity:Re.NotebookControllerAffinity,NotebookControllerAffinity2:Re.NotebookControllerAffinity2,NotebookEdit:Re.$3M,NotebookKernelSourceAction:Re.$qO,NotebookVariablesRequestKind:Re.NotebookVariablesRequestKind,PortAttributes:Re.$tO,LinkedEditingRanges:Re.$sO,TestResultState:Re.TestResultState,TestRunRequest:Re.$uO,TestMessage:Re.$vO,TestTag:Re.$wO,TestRunProfileKind:Re.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:Re.$MN,DataTransferItem:Re.$IN,TestCoverageCount:Re.$xO,FileCoverage:Re.$zO,StatementCoverage:Re.$AO,BranchCoverage:Re.$BO,DeclarationCoverage:Re.$CO,WorkspaceTrustState:Re.WorkspaceTrustState,LanguageStatusSeverity:Re.LanguageStatusSeverity,QuickPickItemKind:Re.QuickPickItemKind,InputBoxValidationSeverity:Re.InputBoxValidationSeverity,TabInputText:Re.$EO,TabInputTextDiff:Re.$FO,TabInputTextMerge:Re.$GO,TabInputCustom:Re.$HO,TabInputNotebook:Re.$JO,TabInputNotebookDiff:Re.$KO,TabInputWebview:Re.$IO,TabInputTerminal:Re.$LO,TabInputInteractiveWindow:Re.$MO,TabInputChat:Re.$NO,TabInputTextMultiDiff:Re.$OO,TelemetryTrustedValue:c.$ap,LogLevel:l.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Re.InteractiveSessionVoteDirection,ChatCopyKind:Re.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Re.InteractiveEditorResponseFeedbackKind,StackFrame:Re.$3N,Thread:Re.$4N,RelatedInformationType:Re.RelatedInformationType,SpeechToTextStatus:Re.SpeechToTextStatus,PartialAcceptTriggerKind:Re.PartialAcceptTriggerKind,KeywordRecognitionStatus:Re.KeywordRecognitionStatus,ChatResponseMarkdownPart:Re.$QO,ChatResponseFileTreePart:Re.$TO,ChatResponseAnchorPart:Re.$UO,ChatResponseProgressPart:Re.$VO,ChatResponseReferencePart:Re.$XO,ChatResponseTextEditPart:Re.$YO,ChatResponseMarkdownWithVulnerabilitiesPart:Re.$RO,ChatResponseCommandButtonPart:Re.$WO,ChatResponseDetectedParticipantPart:Re.$SO,ChatRequestTurn:Re.$ZO,ChatResponseTurn:Re.$1O,ChatLocation:Re.ChatLocation,LanguageModelChatSystemMessage:Re.$2O,LanguageModelChatUserMessage:Re.$3O,LanguageModelChatAssistantMessage:Re.$4O,LanguageModelSystemMessage:Re.$2O,LanguageModelUserMessage:Re.$3O,LanguageModelAssistantMessage:Re.$4O,LanguageModelError:Re.$5O,NewSymbolName:Re.$0N,NewSymbolNameTag:Re.NewSymbolNameTag,InlineEdit:Re.$6O,InlineEditTriggerKind:Re.InlineEditTriggerKind}}}}),define(ke[379],Se([1,0,84,157,44,151,45,33,72,43,95,96,97,118,70,91,150,69,60,117,90,71,149,12,61,115,116,120,121,155]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s,r,t,d,a,h,o,p,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$rs)(h.$wlc,h.$vlc,1),(0,u.$rs)(d.$Yj,t.$Jmc,1),(0,u.$rs)(l.$Bkc,l.$Ckc,1),(0,u.$rs)(w.$BP,w.$AP,0),(0,u.$rs)(p.$Lkc,p.$Mkc,0),(0,u.$rs)(f.$qlc,f.$rlc,0),(0,u.$rs)(R.$1kc,R.$Ykc,0),(0,u.$rs)(c.$3kc,c.$2kc,0),(0,u.$rs)(C.$Glc,C.$Klc,0),(0,u.$rs)(A.$Mlc,A.$Llc,0),(0,u.$rs)($.$qP,$.$pP,0),(0,u.$rs)(o.$xlc,o.$ylc,0),(0,u.$rs)(n.$Fkc,n.$Ekc,0),(0,u.$rs)(N.$fmc,N.$emc,1),(0,u.$rs)(m.$3lc,m.$4lc,0),(0,u.$rs)(y.$jlc,y.$ilc,0),(0,u.$rs)(L.$smc,L.$rmc,0),(0,u.$rs)(S.$mlc,S.$plc,0),(0,u.$rs)(D.$tmc,D.$umc,0),(0,u.$rs)(v.$WCb,v.$XCb,0),(0,u.$rs)(g.$Hmc,g.$Gmc,0),(0,u.$rs)(M.$Xkc,M.$Wkc,0),(0,u.$rs)(i.$tlc,i.$slc,0),(0,u.$rs)(s.$zP,s.$wP,0),(0,u.$rs)(r.$alc,r.$blc,0),(0,u.$rs)(a.$Elc,a.$Flc,0)}),define(ke[122],Se([1,0,19,12,36,94]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0,e.$Zmc=R,e.$1mc=w;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}function w(C,m,y,v){const l=(0,u.$2b)(y,$),g=new M.$_K(m,l,v),c=g.preview.matches;return{ranges:(0,u.$2b)(l,S),uri:C,preview:{text:g.preview.text,matches:(0,u.$2b)(c,S)}}}function $(C){return new M.$aL(C.start.line,C.start.character,C.end.line,C.end.character)}function S(C){return new A.$1K(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let L=class{constructor(m,y){this.a=m,this.b=y}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$2mc=L,e.$2mc=L=Qe([Ve(1,N.$Xj)],L)}),define(ke[380],Se([1,0,53,17,76,34,11,14,122,381]),function(le,e,u,N,M,A,R,w,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=C,e.$4mc=g,e.$5mc=n;const L=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(i,s,r,t){const d=m(i,s,r,t),a=s.folder.fsPath;return{cmd:u.spawn(L,d.args,{cwd:a}),rgDiskPath:L,siblingClauses:d.siblingClauses,rgArgs:d,cwd:a}}function m(i,s,r,t){const d=["--files","--hidden","--case-sensitive","--no-require-git"];v([s],r,!1).forEach(h=>{const o=(0,$.$Zmc)(h);if(d.push("-g",o),R.$j){const p=(0,M.$0l)(o);p!==o&&d.push("-g",p)}});const a=y([s],t,void 0,!1);return a.globArgs.forEach(h=>{const o=`!${(0,$.$Zmc)(h)}`;if(d.push("-g",o),R.$j){const p=(0,M.$0l)(o);p!==o&&d.push("-g",p)}}),s.disregardIgnoreFiles!==!1?d.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),s.ignoreSymlinks||d.push("--follow"),i.exists&&d.push("--quiet"),d.push("--no-config"),s.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:a.siblingClauses}}function y(i,s,r,t=!0){const d=[];let a={};return i.forEach(h=>{const o=Object.assign({},h.excludePattern||{},s||{}),p=l(o,t?h.folder.fsPath:void 0,r);d.push(...p.globArgs),p.siblingClauses&&(a=Object.assign(a,p.siblingClauses))}),{globArgs:d,siblingClauses:a}}function v(i,s,r=!0){const t=[];return i.forEach(d=>{const a=Object.assign({},s||{},d.includePattern||{}),h=l(a,r?d.folder.fsPath:void 0);t.push(...h.globArgs)}),t}function l(i,s,r){const t=[],d={};return Object.keys(i).forEach(a=>{if(r&&r.has(a)||!a)return;const h=i[a];a=c(s?g(s,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof h=="boolean"&&h?(a.startsWith("\\\\")&&(a+="**"),t.push(n(a))):h&&h.when&&(d[a]=h)}),{globArgs:t,siblingClauses:d}}function g(i,s){return N.$jc(s)?s:N.$kc(i,s)}function c(i){return i=w.$cf(i,"\\"),w.$cf(i,"/")}function n(i){return A.$ng(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[382],Se([1,0,53,52,17,383,19,47,35,76,34,11,40,14,18,31,36,380,132]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=e.$6mc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(a=>a())});class s{constructor(h){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=h,this.b=h.filePattern||"",this.d=h.includePattern&&$.$lk(h.includePattern),this.f=h.maxResults||null,this.g=!!h.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=h.shouldGlobMatchFilePattern?null:(0,n.$sr)(this.b).normalizedLowercase),this.u=h.excludePattern&&$.$lk(h.excludePattern),this.t=new Map,h.folderQueries.forEach(o=>{const p=Object.assign({},o.excludePattern||{},this.a.excludePattern||{}),f=o.folder.fsPath;h.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==f).forEach(D=>{(0,L.$rg)(D,f)&&(p[M.$mc(f,D)]=!0)}),this.t.set(f,new t(p,f))})}cancel(){this.l=!0,i.forEach(h=>h())}walk(h,o,p,f,D){if(this.m=m.$0d.create(!1),this.l)return D(null,this.j);o.forEach(b=>{const k=M.$oc(b.fsPath);this.u&&this.u(b.fsPath,k)||this.J(p,{relativePath:b.fsPath,searchPath:void 0})}),this.r=m.$0d.create(!1),this.w(h,(b,k)=>{this.x(this.y,this,b,p,f,E=>{if(E){const P=(0,w.$cj)(E);console.error(P),this.q.push(P),k(E,void 0)}else k(null,void 0)})},(b,k)=>{this.m.stop();const E=b?R.$Hb(b)[0]:null;D(E,this.j)})}w(h,o,p){const f=new Array(h.length),D=new Array(h.length);let b=!1,k=0;if(h.length===0)return p(null,[]);h.forEach((E,P)=>{o(E,(I,F)=>{if(I?(b=!0,f[P]=null,D[P]=I):(f[P]=F,D[P]=null),++k===h.length)return p(b?D:null,f)})})}x(h,o,...p){try{h.apply(o,p)}catch(f){p[p.length-1](f)}}y(h,o,p,f){const D=h.folder.fsPath,b=C.$j,k=()=>j&&j.kill();i.add(k);let E=B=>{i.delete(k),E=()=>{},f(B)},P="";const I=this.D(),F=(0,c.$3mc)(this.a,h,this.a.includePattern,this.t.get(h.folder.fsPath).expression),j=F.cmd,z=!Object.keys(F.siblingClauses).length,O=F.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let T=`${F.rgDiskPath} ${O}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),p({message:T}),this.s=0,this.z(j,"utf8",p,(B,W,X)=>{if(B){E(B);return}if(this.j){E();return}const Y=(P+(b?S.$9l(W||""):W)).split(`
`);if(X){const x=Y.length;Y[x-1]=Y[x-1].trim(),Y[x-1]||Y.pop()}else P=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.s+=Y.length,z){for(const x of Y)if(this.J(o,{base:D,relativePath:x,searchPath:this.N(h,x)}),this.j){k();break}(X||this.j)&&E();return}this.G(h,I,D,Y,o),X&&(this.H(I,D,o),E())})}spawnFindCmd(h){const o=this.t.get(h.folder.fsPath),p=o.getBasenameTerms(),f=o.getPathTerms(),D=["-L","."];if(p.length||f.length){D.push("-not","(","(");for(const b of p)D.push("-name",b),D.push("-o");for(const b of f)D.push("-path",b),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),u.spawn("find",D,{cwd:h.folder.fsPath})}readStdout(h,o,p){let f="";this.z(h,o,()=>{},(D,b,k)=>{if(D){p(D);return}f+=b,k&&p(null,f)})}z(h,o,p,f){let D=(E,P,I)=>{(E||I)&&(D=()=>{},this.r?.stop()),f(E,P,I)},b=!1;h.stdout?(this.A(h.stdout,o,D),h.stdout.once("data",()=>b=!0)):p({message:"stdout is null"});let k;h.stderr?k=this.B(h.stderr):p({message:"stderr is null"}),h.on("error",E=>{D(E)}),h.on("close",E=>{let P;!b&&(P=this.C(k,o))&&d(P)?D(new Error(`command failed with error code ${E}: ${this.C(k,o)}`)):(this.g&&E===0&&(this.j=!0),D(null,"",!0))})}A(h,o,p){const f=new A.StringDecoder(o);return h.on("data",D=>{p(null,f.write(D))}),f}B(h){const o=[];return h.on("data",p=>{o.push(p)}),o}C(h,o){const p=new A.StringDecoder(o);return h.map(f=>p.write(f)).join("")}D(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}G(h,{pathToEntries:o},p,f,D){f.indexOf(this.b)!==-1&&this.J(D,{base:p,relativePath:this.b,searchPath:this.N(h,this.b)});const b=k=>{const E=M.$oc(k),P=M.$nc(k);let I=o[P];I||(I=o[P]=[],b(P)),I.push({base:p,relativePath:k,basename:E,searchPath:this.N(h,k)})};f.forEach(b)}H({rootEntries:h,pathToEntries:o},p,f){const D=this,b=this.t.get(p),k=this.b;function E(P){D.o++;const I=(0,g.$pL)(()=>P.map(F=>F.basename));for(let F=0,j=P.length;F<j;F++){const z=P[F],{relativePath:O,basename:T}=z;if(b.test(O,T,k!==T?I:void 0))continue;const B=o[O];if(B)E(B);else{if(D.p++,O===k)continue;D.J(f,z)}if(D.j)break}}E(h)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(h,o,p,f,D){const b=h.folder,k=(0,g.$pL)(()=>p);this.w(p,(E,P)=>{if(this.l||this.j)return P(null);const I=o?[o,E].join(M.sep):E;if(this.t.get(h.folder.fsPath).test(I,E,this.a.filePattern!==E?k:void 0))return P(null);const F=[b.fsPath,I].join(M.sep);N.lstat(F,(j,z)=>{if(j||this.l||this.j)return P(null);this.L(F,z,(O,T)=>O||this.l||this.j?P(null):T.isDirectory()?(this.o++,this.M(F,z,(B,W)=>B||this.l||this.j||(W=W||"",this.v[W])?P(null):(this.v[W]=!0,l.Promises.readdir(F).then(X=>{if(this.l||this.j)return P(null);this.I(h,I,X,f,Z=>P(Z||null))},X=>{P(null)})))):(this.p++,I===this.b||this.h&&v.$9f(T.size)&&T.size>this.h||this.J(f,{base:b.fsPath,relativePath:I,searchPath:this.N(h,I)}),P(null,void 0)))})},E=>{const P=E&&R.$Hb(E);return D(P&&P.length>0?P[0]:void 0)})}J(h,o){this.K(o)&&(!this.d||this.d(o.relativePath,M.$oc(o.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||h(o))}K(h){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$kL)(h,this.c);if(this.b)return(0,g.$kL)(h,this.b,!1)}return!0}L(h,o,p){return o.isSymbolicLink()?N.stat(h,p):p(null,o)}M(h,o,p){return o.isSymbolicLink()?N.realpath(h,(f,D)=>f?p(f):p(null,D)):p(null,h)}N(h,o){return h.folderName?M.$kc(h.folderName,o):o}}e.$6mc=s;class r{constructor(h){this.a=h.folderQueries,this.b=h.extraFileResources||[],this.c=new s(h)}search(h,o,p){this.c.walk(this.a,this.b,h,o,(f,D)=>{p(f,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$7mc=r;class t{constructor(h,o){this.expression=h,this.c=o,this.d(h)}d(h){let o,p;Object.keys(h).filter(f=>h[f]).forEach(f=>{M.$jc(f)?(o=o||$.$gk(),o[f]=h[f]):(p=p||$.$gk(),p[f]=h[f])}),this.a=o&&$.$lk(o,{trimForExclusions:!0}),this.b=p&&$.$lk(p,{trimForExclusions:!0})}test(h,o,p){return this.b&&this.b(h,o,p)||this.a&&this.a(M.$kc(this.c,h),o,p)}getBasenameTerms(){const h=[];return this.a&&h.push(...$.$nk(this.a)),this.b&&h.push(...$.$nk(this.b)),h}getPathTerms(){const h=[];return this.a&&h.push(...$.$ok(this.a)),this.b&&h.push(...$.$ok(this.b)),h}}function d(a){const h=a.trim().split(`
`),o=h[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return y.$Wf(h[h.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}}),define(ke[384],Se([1,0,98,21,193,22]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$D=e.$3D=e.DecodeStreamErrorKind=e.$2D=e.$1D=e.$ZD=e.$XD=e.$WD=e.$VD=e.$UD=void 0,e.$YD=R,e.$4D=v,e.$5D=l,e.$6D=g,e.$7D=c,e.$8D=n,e.$9D=a,e.$0D=h,e.$UD="utf8",e.$VD="utf8bom",e.$WD="utf16be",e.$XD="utf16le";function R(o){return[e.$UD,e.$VD,e.$WD,e.$XD].some(p=>p===o)}e.$ZD=[254,255],e.$1D=[255,254],e.$2D=[239,187,191];const w=512,$=512,S=512*8,L=512*128;var C;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(p,f){super(p),this.decodeStreamErrorKind=f}}e.$3D=m;class y{static async create(p){let f;if(p!==e.$UD)f=(await(0,M.$TD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(c(p));else{const D=new TextDecoder;f={write(b){return D.decode(b,{stream:!0})},end(){return D.decode()}}}return new y(f)}constructor(p){this.a=p}write(p){return this.a.write(p)}end(){return this.a.end()}}function v(o,p){const f=p.minBytesRequiredForDetection??p.guessEncoding?S:$;return new Promise((D,b)=>{const k=(0,u.$qe)(z=>z.join("")),E=[];let P=0,I;const F=new A.$me,j=async()=>{try{const z=await h({buffer:N.$Ce.concat(E),bytesRead:P},p.guessEncoding);if(z.seemsBinary&&p.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);z.encoding=await p.overwriteEncoding(z.encoding),I=await y.create(z.encoding);const O=I.write(N.$Ce.concat(E).buffer);k.write(O),E.length=0,P=0,D({stream:k,detected:z})}catch(z){F.cancel(),k.destroy(),b(z)}};(0,u.$ue)(o,{onData:async z=>{I?k.write(I.write(z.buffer)):(E.push(z),P+=z.byteLength,P>=f&&(o.pause(),await j(),setTimeout(()=>o.resume())))},onError:z=>k.error(z),onEnd:async()=>{I||await j(),k.end(I?.end())}},F.token)})}async function l(o,p,f){const b=(await(0,M.$TD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(c(p),f);let k=!1,E=!1;return{read(){if(E)return null;const P=o.read();if(typeof P!="string"){if(E=!0,!k&&f?.addBOM)switch(p){case e.$UD:case e.$VD:return N.$Ce.wrap(Uint8Array.from(e.$2D));case e.$WD:return N.$Ce.wrap(Uint8Array.from(e.$ZD));case e.$XD:return N.$Ce.wrap(Uint8Array.from(e.$1D))}const I=b.end();return I&&I.length>0?(k=!0,N.$Ce.wrap(I)):null}return k=!0,N.$Ce.wrap(b.write(P))}}}async function g(o){return(await(0,M.$TD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(c(o))}function c(o){return o===e.$VD||o===null?e.$UD:o}function n(o,p){if(!o||p<e.$ZD.length)return null;const f=o.readUInt8(0),D=o.readUInt8(1);if(f===e.$ZD[0]&&D===e.$ZD[1])return e.$WD;if(f===e.$1D[0]&&D===e.$1D[1])return e.$XD;if(p<e.$2D.length)return null;const b=o.readUInt8(2);return f===e.$2D[0]&&D===e.$2D[1]&&b===e.$2D[2]?e.$VD:null}const i=["ascii","utf-16","utf-32"];async function s(o){const p=await(0,M.$TD)("jschardet","dist/jschardet.min.js"),f=o.slice(0,L),D=d(f.buffer),b=p.detect(D);if(!b||!b.encoding)return null;const k=b.encoding.toLowerCase();return 0<=i.indexOf(k)?null:t(b.encoding)}const r={ibm866:"cp866",big5:"cp950"};function t(o){const p=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return r[p]||p}function d(o){let p="";for(let f=0;f<o.length;f++)p+=String.fromCharCode(o[f]);return p}function a(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const p=o.match(/windows(\d+)/);return p?"windows-"+p[1]:o}}}function h({buffer:o,bytesRead:p},f){let D=n(o,p),b=!1;if(D!==e.$WD&&D!==e.$XD&&o){let k=!0,E=!0,P=!1;for(let I=0;I<p&&I<w;I++){const F=I%2===1,j=o.readUInt8(I)===0;if(j&&(P=!0),k&&(F&&!j||!F&&j)&&(k=!1),E&&(F&&j||!F&&!j)&&(E=!1),j&&!k&&!E)break}P&&(k?D=e.$XD:E?D=e.$WD:b=!0)}return f&&!b&&!D&&o?s(o.slice(0,p)).then(k=>({seemsBinary:!1,encoding:k})):{seemsBinary:b,encoding:D}}e.$$D={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[160],Se([1,0,384,31,159]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0;class A extends M.$Ylc{constructor(w,$,S=N,L="searchProcess"){super({query:w,provider:$},{readdir:C=>S.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,u.$9D)(C)},L)}}e.$cnc=A}),define(ke[161],Se([1,0,53,400,383,19,73,35,14,2,36,94,401,381,122]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=e.$8mc=void 0,e.$0mc=t,e.$$mc=a,e.$_mc=o,e.$anc=p,e.$bnc=D;const l=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(k){this.a=k}provideTextSearchResults(k,E,P,I){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((F,j)=>{I.onCancellationRequested(()=>Y());const z=t(k,E),O=E.folder.fsPath,T=z.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.a.appendLine(`${l} ${T}
 - cwd: ${O}`);let B=u.spawn(l,z,{cwd:O});B.on("error",ve=>{console.error(ve),this.a.appendLine("Error: "+(ve&&ve.message)),j((0,L.$gL)(new L.$eL(ve&&ve.message,L.SearchErrorCode.rgProcessError)))});let W=!1;const X=new i(E.maxResults,E.folder,E.previewOptions);X.on("result",ve=>{W=!0,ne="",P.report(ve)});let Z=!1;const Y=()=>{Z=!0,B?.kill(),X?.cancel()};let x=!1;X.on("hitLimit",()=>{x=!0,Y()});let ne="";B.stdout.on("data",ve=>{X.handleData(ve),W||(ne+=ve)});let ge=!1;B.stdout.once("data",()=>ge=!0);let ue="";B.stderr.on("data",ve=>{const te=ve.toString();this.a.appendLine(te),ue.length+te.length<1e6&&(ue+=te)}),B.on("close",()=>{if(this.a.appendLine(ge?"Got data from stdout":"No data from stdout"),this.a.appendLine(W?"Got result from parser":"No result from parser"),ne&&this.a.appendLine(`Got data without result: ${ne}`),this.a.appendLine(""),Z)F({limitHit:x});else{X.flush(),B=null;let ve;ue&&!ge&&(ve=c(ue))?j((0,L.$gL)(new L.$eL(ve.message,ve.code))):F({limitHit:x})}})})}}e.$8mc=g;function c(b){const k=b.split(`
`),E=k[0].trim();if(k.some(I=>I.startsWith("regex parse error")))return new L.$eL(n(k),L.SearchErrorCode.regexParseError);const P=E.match(/grep config error: unknown encoding: (.*)/);if(P)return new L.$eL(`Unknown encoding: ${P[1]}`,L.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new L.$eL(E.charAt(0).toUpperCase()+E.substr(1),L.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new L.$eL(E.charAt(0).toUpperCase()+E.substr(1),L.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new L.$eL(E,L.SearchErrorCode.regexParseError)}function n(b){const k=["Regex parse error"],E=b.filter(P=>P.startsWith("PCRE2:"));if(E.length>=1){const P=E[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const I=P.split(":")[1];k.push(":"+I)}}return k.join("")}class i extends N.EventEmitter{constructor(k,E,P){super(),this.g=k,this.h=E,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new M.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,E){return super.on(k,E),this}handleData(k){if(this.b)return;const E=typeof k=="string"?k:this.d.write(k);this.k(E)}k(k){let E=k.indexOf(`
`);const P=this.a+k;if(E>=0)E+=this.a.length;else{this.a=P;return}let I=0;for(;E>=0;)this.m(P.substring(I,E).trim()),I=E+1,E=P.indexOf(`
`,I);this.a=P.substring(I)}m(k){if(this.b||!k)return;let E;try{E=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(E.type==="match"){const P=s(E.data.path),I=S.URI.joinPath(this.h,P),F=this.n(E.data,I);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const P=s(E.data.path),I=S.URI.joinPath(this.h,P);this.o(E.data,I).forEach(j=>this.p(j))}}n(k,E){const P=k.line_number-1,I=s(k.lines),F=Buffer.from(I);let j=0,z=0,O=P;k.submatches.length===0&&k.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const T=(0,A.$Hb)(k.submatches.map((B,W)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const X=s(B.match),Z=F.slice(j,B.start).toString(),Y=r(Z),x=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+z,ne=r(X),ge=Y.numLines+O,ue=ne.numLines+ge,ve=ne.numLines>0?ne.lastLineLength:ne.lastLineLength+x;return j=B.end,z=ve,O=ue,new C.$1K(ge,x,ue,ve)}));return(0,v.$1mc)(E,I,T,this.j)}o(k,E){const P=s(k.lines),I=k.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((F,j)=>({text:F,uri:E,lineNumber:I+j}))}p(k){this.emit("result",k)}}e.$9mc=i;function s(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function r(b){const k=/\n/g;let E=0,P=-1,I;for(;I=k.exec(b);)E++,P=I.index;const F=P>=0?b.length-P-1:b.length;return{numLines:E,lastLineLength:F}}function t(b,k){const E=["--hidden","--no-require-git"];E.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:I}=(0,R.$K)(k.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const j=new Set;I.forEach(z=>{j.add(z)}),E.push("-g","!*"),j.forEach(z=>{d(z).map(v.$Zmc).forEach(O=>{E.push("-g",O)})})}P&&P.length&&P.forEach(j=>{E.push("-g",j)}),k.excludes.map(v.$Zmc).forEach(j=>E.push("-g",`!${j}`)),k.maxFileSize&&E.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),k.followSymlinks&&E.push("--follow"),k.encoding&&k.encoding!=="utf8"&&E.push("--encoding",k.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,$.$9e)(b.pattern),b.isRegExp=!0),k.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),b.isRegExp&&(b.pattern=a(b.pattern),E.push("--engine","auto"));let F;if(b.isWordMatch){const z=(0,$.$ff)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",z)}else if(b.isRegExp){let j=o(b.pattern);j=p(j),E.push("--regexp",j)}else F=b.pattern,E.push("--fixed-strings");return E.push("--no-config"),k.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),b.isMultiline&&E.push("--multiline"),k.beforeContext&&E.push("--before-context",k.beforeContext+""),k.afterContext&&E.push("--after-context",k.afterContext+""),E.push("--"),F&&E.push(F),E.push("."),E}function d(b){return D(b).flatMap(E=>{const P=(0,w.$jk)(E,"/");return P.map((I,F)=>P.slice(0,F+1).join("/"))})}function a(b){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(k);)b=b.replace(k,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(E);)b=b.replace(E,"$1\\x{$2}");return b}const h=b=>b.type==="Assertion"&&b.kind==="lookbehind";function o(b){let k;try{k=new m.RegExpParser().parsePattern(b)}catch{return b}let E="",P=0;const I=(z,O,T)=>{E+=b.slice(P,z)+T,P=O},F=[];return new m.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const O=F[0];if(!O)I(z.start,z.end,"\\r?\\n");else if(!F.some(h))if(O.type==="CharacterClass")if(O.negate){const T=b.slice(O.start+2,z.start)+b.slice(z.end,O.end-1);O.parent?.type==="Quantifier"?I(O.start,O.end,T?`[^${T}]`:"."):I(O.start,O.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=b.slice(O.start+1,z.start)+b.slice(z.end,O.end-1);I(O.start,O.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else O.type==="Quantifier"&&I(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){F.unshift(z)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(z){F.unshift(z)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(z){F.unshift(z)},onCharacterClassLeave(){F.shift()},onAssertionEnter(z){h(z)&&F.push(z)},onAssertionLeave(z){F[0]===z&&F.shift()}}).visit(k),E+=b.slice(P),E}function p(b){return b.replace(/\n/g,"\\r?\\n")}function f(b){let k=!1,E=!1,P="",I="";for(let F=0;F<b.length;F++){const j=b[F];switch(j){case"\\":E?(k?I+="\\"+j:P+="\\"+j,E=!1):E=!0;break;case"{":if(E)k?I+=j:P+=j,E=!1;else{if(k)return{strInBraces:P+"{"+I+"{"+b.substring(F+1)};k=!0}break;case"}":if(E)k?I+=j:P+=j,E=!1;else{if(k)return{fixedStart:P,strInBraces:I,fixedEnd:b.substring(F+1)};P+=j}break;default:k?I+=(E?"\\":"")+j:P+=(E?"\\":"")+j,E=!1;break}}return{strInBraces:P+(k?"{"+I:"")}}function D(b){const{fixedStart:k,strInBraces:E,fixedEnd:P}=f(b);if(k===void 0||P===void 0)return[E];let I=(0,w.$jk)(E,",");I.length||(I=[""]);const F=D(P);return I.flatMap(j=>{const z=k+j;return F.map(O=>z+O)})}}),define(ke[385],Se([1,0,22,161,108,15]),function(le,e,u,N,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0;class R{constructor(S){this.b=S,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(S,L,C,m){const y=new N.$8mc(this.b);if(L.folder.scheme===A.Schemas.vscodeUserData){const v={...L,folder:L.folder.with({scheme:A.Schemas.file})},l=new M.$3v(g=>C.report({...g,uri:g.uri.with({scheme:L.folder.scheme})}));return this.c(m,g=>y.provideTextSearchResults(S,v,l,g))}else return this.c(m,v=>y.provideTextSearchResults(S,L,C,v))}async c(S,L){const C=w(S);this.a.add(C);const m=await L(C.token);return this.a.delete(C),m}d(){this.a.forEach(S=>S.cancel())}}e.$fnc=R;function w($){const S=new u.$me;return $.onCancellationRequested(()=>S.cancel()),S}}),define(ke[386],Se([1,0,31,161,160]),function(le,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=void 0;class A{constructor($){this.a=$}search($,S,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(y){L({message:y})}},m=new M.$cnc(this.a,new N.$8mc(C),u);return new Promise((y,v)=>m.search(l=>{S(l.map(R))},$).then(l=>y({limitHit:l.limitHit,type:"success",stats:l.stats}),v))}}e.$dnc=A;function R(w){return{path:w.resource&&w.resource.fsPath,results:w.results,numMatches:(w.results||[]).reduce(($,S)=>{if(S.ranges){const L=S;return $+(Array.isArray(L.ranges)?L.ranges.length:1)}else return $+1},0)}}}),define(ke[387],Se([1,0,19,8,13,4,132,17,40,2,32,36,382,386]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=void 0;class v{static{this.a=512}constructor(s="searchProcess"){this.d=s,this.b=Object.create(null)}fileSearch(s){let r;const t=c(s),d=new A.$be({onDidAddFirstListener:()=>{r=(0,N.$eh)(a=>this.doFileSearchWithEngine(m.$7mc,t,h=>d.fire(h),a)),r.then(a=>d.fire(a),a=>d.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{r.cancel()}});return d.event}textSearch(s){let r;const t=c(s),d=new A.$be({onDidAddFirstListener:()=>{r=(0,N.$eh)(a=>this.f(t,h=>d.fire(h),a)),r.then(a=>d.fire(a),a=>d.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{r.cancel()}});return d.event}f(s,r,t){return s.maxFileSize=this.g().maxFileSize,new y.$dnc(s).search(t,r,r)}g(){return{maxFileSize:16*L.$tl.GB}}doFileSearch(s,r,t){return this.doFileSearchWithEngine(m.$7mc,s,r,t)}doFileSearchWithEngine(s,r,t,d,a=v.a){let h=0;const o=f=>{Array.isArray(f)?(h+=f.length,t(f.map(D=>this.h(D)))):f.relativePath?(h++,t(this.h(f))):t(f)};if(r.sortByScore){let f=this.l(r,o,d);if(!f){const D=r.maxResults?Object.assign({},r,{maxResults:null}):r,b=new s(D);f=this.j(b,r,t,o,d)}return new Promise((D,b)=>{f.then(([k,E])=>{const P=E.map(I=>this.h(I));this.o(P,t,a),D(k)},b)})}const p=new s(r);return this.r(p,o,a,d).then(f=>({limitHit:f.limitHit,type:"success",stats:{detailStats:f.stats,type:this.d,fromCache:!1,resultCount:h,sortingTime:void 0}}))}h(s){return{path:s.base?(0,w.$kc)(s.base,s.relativePath):s.relativePath}}j(s,r,t,d,a){const h=new A.$be;let o=(0,N.$eh)(f=>{let D=[];const b=k=>{Array.isArray(k)?D=k:(d(k),h.fire(k))};return this.r(s,b,-1,f).then(k=>[k,D])}),p;if(r.cacheKey){p=this.k(r.cacheKey);const f={promise:o,event:h.event,resolved:!1};p.resultsToSearchCache[r.filePattern||""]=f,o.then(()=>{f.resolved=!0},D=>{delete p.resultsToSearchCache[r.filePattern||""]}),o=this.s(o)}return o.then(([f,D])=>{const b=p?p.scorerCache:Object.create(null),k=(typeof r.maxResults!="number"||r.maxResults>0)&&$.$0d.create(!1);return this.n(r,D,b,a).then(E=>{const P=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:f.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:r.folderQueries.length,resultCount:E.length},messages:f.messages,limitHit:f.limitHit||typeof r.maxResults=="number"&&D.length>r.maxResults},E]})})}k(s){const r=this.b[s];return r||(this.b[s]=new l)}l(s,r,t){const d=s.cacheKey&&this.b[s.cacheKey];if(!d)return;const a=this.q(d,s.filePattern||"",r,t);if(a)return a.then(([h,o,p])=>{const f=$.$0d.create(!1);return this.n(s,o,d.scorerCache,t).then(D=>{const b=f.elapsed(),k={fromCache:!0,detailStats:p,type:this.d,resultCount:o.length,sortingTime:b};return[{type:"success",limitHit:h.limitHit||typeof s.maxResults=="number"&&o.length>s.maxResults,stats:k},D]})})}n(s,r,t,d){const a=(0,R.$sr)(s.filePattern||""),h=(p,f)=>(0,R.$rr)(p,f,a,!0,g,t),o=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return u.$Gb(r,h,o,1e4,d)}o(s,r,t){if(t&&t>0)for(let d=0;d<s.length;d+=t)r(s.slice(d,d+t));else r(s)}q(s,r,t,d){const a=$.$0d.create(!1),h=r.indexOf(w.sep)>=0;let o;for(const b in s.resultsToSearchCache)if(r.startsWith(b)){if(h&&b.indexOf(w.sep)<0&&b!=="")continue;const k=s.resultsToSearchCache[b];o={promise:this.s(k.promise),event:k.event,resolved:k.resolved};break}if(!o)return null;const p=a.elapsed(),f=$.$0d.create(!1),D=o.event(t);return d&&d.onCancellationRequested(()=>{D.dispose()}),o.promise.then(([b,k])=>{if(d&&d.isCancellationRequested)throw(0,M.$6)();const E=[],P=(0,R.$sr)(r).normalizedLowercase;for(const I of k)(0,C.$kL)(I,P)&&E.push(I);return[b,E,{cacheWasResolved:o.resolved,cacheLookupTime:p,cacheFilterTime:f.elapsed(),cacheEntryCount:k.length}]})}r(s,r,t,d){return new Promise((a,h)=>{let o=[];d?.onCancellationRequested(()=>s.cancel()),s.search(p=>{p&&(t?(o.push(p),t>0&&o.length>=t&&(r(o),o=[])):r(p))},p=>{r(p)},(p,f)=>{o.length&&r(o),p?(r({message:"Search finished. Error: "+p.message}),h(p)):(r({message:"Search finished. Stats: "+JSON.stringify(f.stats)}),a(f))})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}s(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,t){return s.then(r,t)}catch(r){return this.then(void 0,r)}finally(r){return s.finally(r)}}}}e.$enc=v;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(i){return(0,w.$oc)(i.relativePath)}getItemDescription(i){return(0,w.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function c(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>S.URI.revive(s))}}function n(i){return{...i,folder:S.URI.revive(i.folder)}}}),define(ke[388],Se([1,0,3,15,2,31,12,28,20,97,67,36,387,385,122,160]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=void 0;let g=class extends S.$4lc{constructor(n,i,s,r){super(n,s,r),this.w=A,this.x=-1,this.y=null,this.z=!1,this.A=new u.$Tc;const t=new v.$2mc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new y.$fnc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$2mc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.file,new y.$fnc(n))),this.A.add(this.C(N.Schemas.file,new m.$enc("fileSearchProvider")))}C(n,i){const s=this.d++;return this.y=i,this.x=s,this.c.$registerFileSearchProvider(s,this.s(n)),(0,u.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(s)})}$provideFileSearchResults(n,i,s,r){const t=(0,S.$5lc)(s);if(n===this.x){const d=Date.now();return this.D(n,i,t,r).then(a=>{const h=Date.now()-d;return this.q.debug(`Ext host file search time: ${h}ms`),a})}return super.$provideFileSearchResults(n,i,s,r)}doInternalFileSearchWithCustomCallback(n,i,s){const r=t=>{if((0,C.$jL)(t)&&(t=[t]),Array.isArray(t)){s(t.map(d=>M.URI.file(d.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,r,i)}async D(n,i,s,r){return this.doInternalFileSearchWithCustomCallback(s,r,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new l.$cnc(n,i,void 0,"textSearchProvider")}};e.$gnc=g,e.$gnc=g=Qe([Ve(0,$.$fP),Ve(1,w.$vP),Ve(2,L.$Ukc),Ve(3,R.$Xj)],g)}),define(ke[123],Se([1,0,402,63,64,403,21,13,4,3,17,11,30,81,82]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ii=e.$hi=e.$gi=void 0,e.$ji=a,e.$ki=h,e.$mi=f,e.$ni=D;class l{traceSocketEvent(k,E){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,E)}constructor(k,E=""){this.f=!0,this.debugLabel=E,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,w.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const E=P=>{this.traceSocketEvent("read",P),k(R.$Ce.wrap(P))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(k){const E=P=>{k({type:0,hadError:P,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(k){const E=()=>{k()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,w.$1)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,w.$1)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$gi=l;var g;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var c;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(c||(c={}));class n extends S.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,E){this.socket.traceSocketEvent(k,E)}constructor(k,E,P,I){super(),this.f=this.B(new $.$be),this.g=this.B(new $.$be),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:P?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new i(this,E,P,I,this.f,(F,j)=>this.m(F,j))),this.B(this.a.onError(F=>{console.error(F),(0,w.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new v.$bi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let E=0;for(;E<k.byteLength;)this.a.writeMessage(k.slice(E,Math.min(E+262144,k.byteLength)),{compressed:!0,opcode:2}),E+=262144}m(k,{compressed:E,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let I=2;k.byteLength<126?I+=0:k.byteLength<2**16?I+=2:I+=8;const F=R.$Ce.alloc(I),j=E?64:0,z=P&15;if(F.writeUInt8(128|j|z,0),k.byteLength<126)F.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){F.writeUInt8(126,1);let O=1;F.writeUInt8(k.byteLength>>>8&255,++O),F.writeUInt8(k.byteLength>>>0&255,++O)}else{F.writeUInt8(127,1);let O=1;F.writeUInt8(0,++O),F.writeUInt8(0,++O),F.writeUInt8(0,++O),F.writeUInt8(0,++O),F.writeUInt8(k.byteLength>>>24&255,++O),F.writeUInt8(k.byteLength>>>16&255,++O),F.writeUInt8(k.byteLength>>>8&255,++O),F.writeUInt8(k.byteLength>>>0&255,++O)}this.socket.write(R.$Ce.concat([F,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),P=E.readUInt8(0),I=(P&128)>>>7,F=(P&64)>>>6,j=P&15,z=E.readUInt8(1),O=(z&128)>>>7,T=z&127;this.j.state=2,this.j.readLen=2+(O?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),P=E.readUInt8(1),I=(P&128)>>>7;let F=P&127,j=1;F===126?F=E.readUInt8(++j)*2**8+E.readUInt8(++j):F===127&&(F=E.readUInt8(++j)*0+E.readUInt8(++j)*0+E.readUInt8(++j)*0+E.readUInt8(++j)*0+E.readUInt8(++j)*2**24+E.readUInt8(++j)*2**16+E.readUInt8(++j)*2**8+E.readUInt8(++j));let z=0;I&&(z=E.readUInt8(++j)*2**24+E.readUInt8(++j)*2**16+E.readUInt8(++j)*2**8+E.readUInt8(++j)),this.j.state=3,this.j.readLen=F,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$hi=n;class i extends S.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Ce.alloc(0)}constructor(k,E,P,I,F,j){super(),this.n=k,this.r=F,this.s=j,this.a=this.B(new $.$be),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$be),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$be),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new s(this.n,I,P,{windowBits:15})),this.f=this.B(new r(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(k,E){this.g.push({data:k,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:E}=this.g.shift();if(this.f&&E.compressed){const P=await this.w(this.f,k);this.s(P,E)}else this.s(k,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,E){return new Promise((P,I)=>{k.write(E),k.flush(F=>P(F))})}acceptFrame(k,E,P){this.h.push({data:k,isCompressed:E,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const E=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,E,P){return new Promise((I,F)=>{k.write(E),P&&k.write(R.$Ce.fromByteArray([0,0,255,255])),k.flush(j=>I(j))})}}class s extends S.$Uc{get recordedInflateBytes(){return this.j?R.$Ce.concat(this.f):R.$Ce.alloc(0)}constructor(k,E,P,I){super(),this.h=k,this.j=E,this.a=this.B(new $.$be),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(I),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(R.$Ce.wrap(F))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=R.$Ce.concat(this.g);this.g.length=0,k(E)})}}class r extends S.$Uc{constructor(k,E){super(),this.g=k,this.a=this.B(new $.$be),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(R.$Ce.wrap(P))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=R.$Ce.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),k(E)})}}function t(b,k){if(k===0)return;const E=b.byteLength>>>2;for(let O=0;O<E;O++){const T=b.readUInt32BE(O*4);b.writeUInt32BE(T^k,O*4)}const P=E*4,I=b.byteLength-P,F=k>>>24&255,j=k>>>16&255,z=k>>>8&255;I>=1&&b.writeUInt8(b.readUInt8(P)^F,P),I>=2&&b.writeUInt8(b.readUInt8(P+1)^j,P+1),I>=3&&b.writeUInt8(b.readUInt8(P+2)^z,P+2)}e.$ii=process.env.XDG_RUNTIME_DIR;const d={2:107,1:103};function a(){const b=(0,m.$Ng)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const k=process.platform!=="darwin"&&e.$ii?e.$ii:(0,M.tmpdir)(),E=(0,L.$kc)(k,`vscode-ipc-${b}.sock`);return o(E),E}function h(b,k,E){const I=(0,u.createHash)("sha256").update(b).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${E}-${k}-sock`;const F=E.substr(0,4),j=k.substr(0,6);let z;return process.platform!=="darwin"&&e.$ii&&!process.env.VSCODE_PORTABLE?z=(0,L.$kc)(e.$ii,`vscode-${I}-${F}-${j}.sock`):z=(0,L.$kc)(b,`${F}-${j}.sock`),o(z),z}function o(b){const k=d[C.$u];typeof k=="number"&&b.length>=k&&console.warn(`WARNING: IPC handle "${b}" is longer than ${k} chars, try a shorter --user-data-dir`)}class p extends y.$8h{static b(k){const E=$.Event.fromNodeEventEmitter(k,"connection");return $.Event.map(E,P=>({protocol:new v.$ci(new l(P,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(P,"close"))}))}constructor(k){super(p.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$li=p;function f(b){return new Promise((k,E)=>{const P=(0,N.createServer)();P.on("error",E),P.listen(b,()=>{P.removeListener("error",E),k(new p(P))})})}function D(b,k){return new Promise((E,P)=>{const I=(0,N.createConnection)(b,()=>{I.removeListener("error",P),E(v.$di.fromSocket(new l(I,`ipc-client${k}`),k))});I.once("error",P)})}}),define(ke[389],Se([1,0,63,64,173,123,8,3,11,54,12,139,266,267,110,88,21]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=e.$7cc=e.$6cc=e.$5cc=void 0;async function c(t,d,a,h,o){let p;for(let f=3;f&&(p?.dispose(),p=await new n(t,d,a,h,o).waitForReady(),!(o&&M.$Qg[o]||!M.$Qg[p.tunnelLocalPort]));f--);return p}class n extends w.$Uc{constructor(d,a,h,o,p){super(),this.m=a,this.n=p,this.privacy=l.TunnelPrivacyId.Private,this.j=new Map,this.a=d,this.b=u.createServer(),this.c=new R.$qh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=f=>this.r(f),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=o,this.tunnelRemoteHost=h}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(a=>{a()})}async waitForReady(){const d=this.n??this.tunnelRemotePort,a=(0,l.$dw)(this.m)?"0.0.0.0":"127.0.0.1";let h=await(0,M.$Rg)(d,2,1e3,a),o=null;return this.b.listen(h,this.m),await this.c.wait(),o=this.b.address(),o||(h=0,this.b.listen(h,this.m),await this.c.wait(),o=this.b.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async r(d){d.pause();const a=(0,l.$bw)(this.tunnelRemoteHost)||(0,l.$dw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,h=await(0,m.$Nl)(this.a,a,this.tunnelRemotePort),o=h.getSocket(),p=h.readEntireBuffer();h.dispose(),p.byteLength>0&&d.write(p.buffer),d.on("end",()=>{d.localAddress&&this.j.delete(d.localAddress),o.end()}),d.on("close",()=>o.end()),d.on("error",()=>{d.localAddress&&this.j.delete(d.localAddress),o instanceof A.$gi?o.socket.destroy():o.end()}),o instanceof A.$gi?this.t(d,o):this.s(d,o),d.localAddress&&this.j.set(d.localAddress,()=>{d.end(),o.end()})}s(d,a){a.onClose(()=>d.destroy()),a.onEnd(()=>d.end()),a.onData(h=>d.write(h.buffer)),d.on("data",h=>a.write(g.$Ce.wrap(h))),d.resume()}t(d,a){const h=a.socket;h.on("end",()=>d.end()),h.on("close",()=>d.end()),h.on("error",()=>{d.destroy()}),h.pipe(d),d.pipe(h)}}e.$5cc=n;let i=class extends l.$gw{constructor(d,a,h,o,p){super(a,p),this.v=d,this.w=h,this.y=o}isPortPrivileged(d){return(0,l.$ew)(d,this.m,$.OS,N.release())}t(d,a,h,o,p,f,D,b){const k=this.s(a,h);if(k)return++k.refcount,k.value;if((0,l.$0v)(d))return this.u(d,a,h,p,f,D,b);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${h} on local port ${p}.`);const E={commit:this.y.commit,quality:this.y.quality,addressProvider:d,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=c(E,o,a,h,p);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(a,h,P),P}}};e.$6cc=i,e.$6cc=i=Qe([Ve(0,y.$Hl),Ve(1,L.$Xj),Ve(2,v.$Kl),Ve(3,C.$ek),Ve(4,S.$Xi)],i);let s=class extends i{constructor(d,a,h,o,p){super(d,a,h,o,p)}};e.$7cc=s,e.$7cc=s=Qe([Ve(0,y.$Hl),Ve(1,L.$Xj),Ve(2,v.$Kl),Ve(3,C.$ek),Ve(4,S.$Xi)],s);let r=class extends w.$Uc{constructor(d,a,h,o,p){super(),this.b=d,this.c=a,this.f=h,this.g=o,this.h=p,this.a=new Map}async openTunnel(d,a,h,o,p,f,D,b,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${h}:${o} on local port ${f}.`),!this.a.has(d)){const E=new s(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(d,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(d))})}return this.a.get(d).openTunnel(a,h,o,p,f,D,b,k)}};e.$8cc=r,e.$8cc=r=Qe([Ve(0,y.$Hl),Ve(1,L.$Xj),Ve(2,C.$ek),Ve(3,v.$Kl),Ve(4,S.$Xi)],r)}),define(ke[390],Se([1,0,123,286,52,33,2,12,42]),function(le,e,u,N,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.$GP=void 0;class S{constructor(m,y,v){this.b=m,this.c=y,this.f=v,this.a=N.createServer((l,g)=>this.h(l,g)),this.g().catch(l=>(y.error(l),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,y){const v=(g,c)=>{y.writeHead(g,{"content-type":"application/json"}),y.end(JSON.stringify(c||null),n=>n&&this.c.error(n))},l=[];m.setEncoding("utf8"),m.on("data",g=>l.push(g)),m.on("end",async()=>{try{const g=JSON.parse(l.join(""));let c;switch(g.type){case"open":c=await this.i(g);break;case"openExternal":c=await this.j(g);break;case"status":c=await this.l(g);break;case"extensionManagement":c=await this.k(g);break;default:v(404,`Unknown message type: ${g.type}`);break}v(200,c)}catch(g){const c=g instanceof Error?g.message:JSON.stringify(g);v(500,c),this.c.error("Error while processing pipe request",g)}})}async i(m){const{fileURIs:y,folderURIs:v,forceNewWindow:l,diffMode:g,mergeMode:c,addMode:n,forceReuseWindow:i,gotoLineMode:s,waitMarkerFilePath:r,remoteAuthority:t}=m,d=[];if(Array.isArray(v))for(const p of v)try{d.push({folderUri:R.URI.parse(p)})}catch{}if(Array.isArray(y))for(const p of y)try{(0,$.$Wi)(p)?d.push({workspaceUri:R.URI.parse(p)}):d.push({fileUri:R.URI.parse(p)})}catch{}const a=r?R.URI.file(r):void 0,o={forceNewWindow:l,diffMode:g,mergeMode:c,addMode:n,gotoLineMode:s,forceReuseWindow:i,preferNewWindow:!i&&!a&&!n,waitMarkerFileURI:a,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",d,o)}async j(m){for(const y of m.uris){const v=R.URI.parse(y),l=v.scheme==="file"?v:y;await this.b.executeCommand("_remoteCLI.openExternal",l)}}async k(m){const y=l=>l?.map(g=>/\.vsix$/i.test(g)?R.URI.parse(g):g),v={list:m.list,install:y(m.install),uninstall:y(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&M.existsSync(this.f)&&M.unlinkSync(this.f)}}e.$GP=S;let L=class extends S{constructor(m,y){super(m,y,(0,u.$ji)())}};e.$HP=L,e.$HP=L=Qe([Ve(0,A.$BP),Ve(1,w.$Xj)],L)}),define(ke[391],Se([1,0,59,378,373,285,49,360,2,15,7,390,104,319,359]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class l extends M.$Mmc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(a,h,o){return a=t(a),n.a.has(a)?n.a.get(a).load(a,$.URI.file((0,m.$2q)(h.filename)),p=>s.apply(this,[p,h,o])):s.apply(this,arguments)};const r=i._resolveLookupPaths;i._resolveLookupPaths=(d,a)=>r.call(this,t(d),a);const t=d=>{for(const a of n.b){const h=a(d);if(h){d=h;break}}return d}}}class g extends R.$Alc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async vb(){this.h.createInstance(y.$jnc);const n=this.h.invokeFunction(N.$Imc);if(this.h.createInstance(w.$inc),this.f.remote.isRemote&&this.f.remote.authority){const r=this.h.createInstance(C.$HP);process.env.VSCODE_IPC_HOOK_CLI=r.ipcHandlePath}this.h.createInstance(v.$knc),await this.h.createInstance(l,n,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI");const s=await this.m.getConfigProvider();await(0,A.$hnc)(this.j,s,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,s){if(i.scheme!==S.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let r=null;s.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&u.mark(`code/extHost/willLoadExtensionCode/${t}`),r=le.__$__nodeRequire(i.fsPath)}finally{t&&u.mark(`code/extHost/didLoadExtensionCode/${t}`),s.codeLoadingStop()}return r}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const s=n[i];s===null?delete process.env[i]:process.env[i]=s}}}e.$lnc=g}),define(ke[392],Se([1,0,53,21,4,3,125,11,23,2,31,12,265,66,110,88,389,28,20,70,367]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0,e.$mnc=r,e.$nnc=t,e.$onc=d,e.$pnc=a,e.$qnc=o,e.$rnc=p,e.$snc=f;function r(k){const E=k.trim().split(`
`),P=[];return E.forEach(F=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);j&&j.length>=3&&P.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),P.reduce((F,j)=>(F[j.socket]=j,F),{})}function t(...k){const E=[].concat(...k.map(a));return[...new Map(E.filter(P=>P.st==="0A").map(P=>{const I=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:d(I[0]),port:parseInt(I[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}function d(k){let E="";if(k.length===8)for(let P=k.length-2;P>=0;P-=2)E+=parseInt(k.substr(P,2),16),P!==0&&(E+=".");else for(let P=0;P<k.length;P+=8){const I=k.substring(P,P+8);let F="";for(let j=8;j>=2;j-=2)F+=I.substring(j-2,j),(j===6||j===2)&&(F=parseInt(F,16).toString(16),E+=`${F}`,F="",P+j!==k.length-6&&(E+=":"))}return E}function a(k){const E=k.trim().split(`
`),P=E.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return E.map(F=>F.trim().split(/\s+/).reduce((j,z,O)=>(j[P[O]||O]=z,j),{}))}function h(k){return!!k.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||k.indexOf("out/server-main.js")!==-1||k.indexOf("_productName=VSCode")!==-1}function o(k){const E=k.trim().split(`
`),P=[];return E.forEach(I=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);F&&F.length>=4&&P.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),P}async function p(k,E,P){const I=P.reduce((j,z)=>(j[z.pid]=z,j),{}),F=[];return k.forEach(({socket:j,ip:z,port:O})=>{const T=E[j]?E[j].pid:void 0,B=T?I[T]?.cmd:void 0;T&&B&&!h(B)&&F.push({host:z,port:O,detail:B,pid:T})}),F}function f(k,E,P){const I=new Map,F=o(E);for(const j of k){const z=P.get(j.port);if(z){I.set(j.port,z);continue}const O=F.find(T=>T.cmd.includes(`${j.port}`));if(O){let T=O,B;do B=F.find(W=>W.ppid===T.pid),B&&(T=B);while(B);I.set(j.port,{host:j.ip,port:j.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else I.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return I}let D=class extends i.$XCb{constructor(E,P,I,F){super(E,P,I),this.D=P,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,w.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(E){if(E&&this.C)return;this.C=E;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new R.$zm;let F=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(B=>(0,l.$bw)(B.host)||(0,l.$dw)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(B=>B.port).join(", ")}`);const O=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${O} ms.`),F++>3&&I.update(O),(!P||JSON.stringify(P)!==JSON.stringify(z))&&(P=z,await this.a.$onFoundNewCandidates(P));const T=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(B=>setTimeout(()=>B(),T))}}G(E){return Math.max(E*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(E=>E.port).join(", ")}`)}async I(){let E="",P="";try{E=await L.Promises.readFile("/proc/net/tcp","utf8"),P=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(E,P),F=await new Promise(Z=>{(0,u.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Y,x,ne)=>{Z(x)})}),j=r(F),z=await L.Promises.readdir("/proc"),O=[];for(const Z of z)try{const Y=Number(Z),x=$.$5g(S.URI.file("/proc"),Z);if((await L.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(Y)){const ge=await L.Promises.readlink($.$5g(x,"cwd").fsPath),ue=await L.Promises.readFile($.$5g(x,"cmdline").fsPath,"utf8");O.push({pid:Y,cwd:ge,cmd:ue})}}catch{}const T=[],B=I.filter(Z=>{const Y=j[Z.socket];return Y||T.push(Z),Y}),W=p(B,j,O);let X;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const Z=await new Promise(Y=>{(0,u.exec)("ps -F -A -l | grep root",(x,ne,ge)=>{Y(ne)})});this.z=f(T,Z,this.z),X=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${X.map(Y=>Y.port).join(", ")}`)}return W.then(Z=>X?Z.concat(X):Z)}w(E){return async P=>{const I=new g.$5cc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,O,T){const B=await E.makeConnection();return b.connect(B,z,O,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Dl(0),connectionToken:E.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await I.waitForReady();const F=new M.$be;return{localAddress:(0,s.$gM)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{I.dispose(),F.fire(),F.dispose()}}}}};e.$tnc=D,e.$tnc=D=Qe([Ve(0,n.$fP),Ve(1,c.$vP),Ve(2,C.$Xj),Ve(3,v.$Kl)],D);class b extends m.$Ssb{static connect(E,P,I,F){const j=new A.$Tc,z={onClose:j.add(new M.$be),onData:j.add(new M.$be),onEnd:j.add(new M.$be)};j.add(E.onDidReceiveMessage(T=>z.onData.fire(N.$Ce.wrap(T)))),j.add(E.onDidEnd(()=>z.onEnd.fire())),j.add(E.onDidClose(T=>z.onClose.fire({type:0,error:T,hadError:!!T})));const O=new b(E,F,z);return O.B(j),(0,m.$Rsb)(O,P,I,F,z)}constructor(E,P,I){super(P,I),this.n=E}write(E){this.n.send(E.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[393],Se([1,0,84,362,376,375,388,391,392,96,49,97,95,43,70,93,361,320,12,377,61,280,106,110,141]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c,n,i,s,r,t,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$rs)(L.$Blc,w.$lnc,0),(0,u.$rs)(n.$Yj,c.$vnc,1),(0,u.$rs)(n.$Xj,new t.$oi(r.$Lmc,[!1],!0)),(0,u.$rs)(d.$Kl,a.$0cc,1),(0,u.$rs)(l.$4kc,g.$unc,0),(0,u.$rs)(S.$Glc,A.$Ymc,0),(0,u.$rs)(C.$3lc,R.$gnc,0),(0,u.$rs)(m.$smc,M.$Qmc,0),(0,u.$rs)(y.$mlc,N.$Pmc,0),(0,u.$rs)(v.$WCb,$.$tnc,0),(0,u.$rs)(s.$Elc,i.$wnc,0)}),define(ke[404],Se([1,0,63,405,59,13,82,123,263,114,374,21,31,104,8,135,287,303,379,393]),function(le,e,u,N,M,A,R,w,$,S,L,C,m,y,v,l,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let f=0;f<process.execArgv.length;f++)process.execArgv[f]==="--inspect-port=0"&&(process.execArgv.splice(f,1),f--)}();const n=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const p=globalThis._VSCODE_NODE_MODULES.module,f=p._load;p._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return f.apply(this,arguments)}})();const i=process.exit.bind(process),s=process.on.bind(process);function r(p){process.exit=function(f){if(p)i(f);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const f=new Error("An extension called process.crash() and this was prevented.");console.warn(f.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(f,D){f==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),s(f,D)}}let t=function(p){i()};function d(){const p=(0,c.$jn)(process.env);if(p.type===3)return new Promise((f,D)=>{const b=k=>{const E=k[0],P=new R.$ei;E.on("message",I=>P.fire(C.$Ce.wrap(I.data))),E.on("close",()=>{t("renderer closed the MessagePort")}),E.start(),f({onMessage:P.event,send:I=>E.postMessage(I.buffer)})};process.parentPort.on("message",k=>b(k.ports))});if(p.type===2)return new Promise((f,D)=>{let b=null;const k=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,P=3e5,I=new v.$Eh(()=>t("renderer disconnected for too long (1)"),E),F=new v.$Eh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(z,O)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const T=C.$Ce.wrap(Buffer.from(z.initialDataChunk,"base64"));let B;if(z.skipWebSocketFrames)B=new w.$gi(O,"extHost-socket");else{const W=C.$Ce.wrap(Buffer.from(z.inflateBytes,"base64"));B=new w.$hi(new w.$gi(O,"extHost-socket"),z.permessageDeflate,W,!1)}b?(I.cancel(),F.cancel(),b.beginAcceptReconnection(B,T),b.endAcceptReconnection(),b.sendResume()):(clearTimeout(k),b=new R.$fi({socket:B,initialChunk:T}),b.sendResume(),b.onDidDispose(()=>t("renderer disconnected")),f(b),b.onSocketClose(()=>{I.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;I.isScheduled()&&F.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const f=p.pipeName;return new Promise((D,b)=>{const k=u.createConnection(f,()=>{k.removeListener("error",b);const E=new R.$fi({socket:new w.$gi(k,"extHost-renderer")});E.sendResume(),D(E)});k.once("error",b),k.on("close",()=>{t("renderer closed the socket")})})}}async function a(){const p=await d();return new class{constructor(){this.a=new R.$ei,this.onMessage=this.a.event,this.b=!1,p.onMessage(f=>{(0,S.$Vm)(f,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(f)})}send(f){this.b||p.send(f)}async drain(){if(p.drain)return p.drain()}}}function h(p){return new Promise(f=>{const D=p.onMessage(b=>{D.dispose();const k=JSON.parse(b.toString()),E=k.commit,P=$.default.commit;if(E&&P&&E!==P&&i(55),k.parentPid){let I=0;setInterval(function(){try{process.kill(k.parentPid,0),I=0}catch(j){j&&j.code==="EPERM"?(I++,I>=3&&t(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${k.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(k.parentPid)}catch(j){(0,A.$1)(j)}}p.send((0,S.$Um)(0)),f({protocol:p,initData:k})});p.send((0,S.$Um)(1))})}async function o(){const p=[];process.on("unhandledRejection",(I,F)=>{p.push(F),setTimeout(()=>{const j=p.indexOf(F);j>=0&&F.catch(z=>{p.splice(j,1),(0,A.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),I&&(0,A.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const F=p.indexOf(I);F>=0&&p.splice(F,1)}),process.on("uncaughtException",function(I){(0,A.$Z)(I)||(0,A.$1)(I)}),M.mark("code/extHost/willConnectToRenderer");const f=await a();M.mark("code/extHost/didConnectToRenderer");const D=await h(f);M.mark("code/extHost/didWaitForInitData");const{initData:b}=D;r(!!b.environment.extensionTestsLocationURI),b.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,b.environment.skipWorkspaceStorageLock=(0,l.boolean)(n.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(F){i(F)}fsExists(F){return m.Promises.exists(F)}fsRealpath(F){return(0,y.$1q)(F)}};let E=null;b.remote.authority&&n.transformURIs&&(E=(0,g.$vs)(b.remote.authority));const P=new L.$Omc(D.protocol,b,k,E);t=I=>P.terminate(I)}o().catch(p=>console.log(p))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/910284865c34fd492e3f6fd5a8ab8e571432cc58/core/vs/workbench/api/node/extensionHostProcess.js.map
