/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],I=0,N=ge.length;I<N;I++)e[I]=Ce[ge[I]];return e};define(Ce[68],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=N,e.$Wh=A,e.$Xh=F;function I(M){return(p,f,E)=>{let T=null,y=null;if(typeof E.value=="function"?(T="value",y=E.value):typeof E.get=="function"&&(T="get",y=E.get),!y)throw new Error("not supported");E[T]=M(y,f)}}function N(M,p,f){let E=null,T=null;if(typeof f.value=="function"?(E="value",T=f.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(E="get",T=f.get),!T)throw new Error("not supported");const y=`$memoize$${p}`;f[E]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,u)}),this[y]}}function A(M,p,f){return I((E,T)=>{const y=`$debounce$${T}`,u=`$debounce$result$${T}`;return function(...v){this[u]||(this[u]=f?f():void 0),clearTimeout(this[y]),p&&(this[u]=p(this[u],...v),v=[this[u]]),this[y]=setTimeout(()=>{E.apply(this,v),this[u]=f?f():void 0},M)}})}function F(M,p,f){return I((E,T)=>{const y=`$throttle$timer$${T}`,u=`$throttle$result$${T}`,v=`$throttle$lastRun$${T}`,m=`$throttle$pending$${T}`;return function(...s){if(this[u]||(this[u]=f?f():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),p&&(this[u]=p(this[u],...s)),this[m])return;const o=this[v]+M;o<=Date.now()?(this[v]=Date.now(),E.apply(this,[this[u]]),this[u]=f?f():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[v]=Date.now(),E.apply(this,[this[u]]),this[u]=f?f():void 0},o-Date.now()))}})}}),define(Ce[90],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=void 0;class I{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$kP=I,e.$lP=new I("id#")}),define(Ce[123],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Cn=M,e.$Dn=y,e.$En=u,e.$Fn=v,e.$Gn=m,e.$Hn=s,e.$In=o,e.$Jn=r,e.$Kn=n,e.$Ln=t,e.$Mn=c,e.$Nn=l;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var A;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var F;(function(i){i.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function M(i,$=!1){let a=0;const b=i.length;let h="",D=0,d=16,k=0;function g(q){let R=0,j=0;for(;R<q;){const K=i.charCodeAt(a);if(K>=48&&K<=57)j=j*16+K-48;else if(K>=65&&K<=70)j=j*16+K-65+10;else if(K>=97&&K<=102)j=j*16+K-97+10;else break;a++,R++}return R<q&&(j=-1),j}function S(q){a=q,h="",D=0,d=16,k=0}function w(){const q=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&E(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&E(i.charCodeAt(a)))for(a++;a<i.length&&E(i.charCodeAt(a));)a++;else return k=3,i.substring(q,a);let R=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&E(i.charCodeAt(a))){for(a++;a<i.length&&E(i.charCodeAt(a));)a++;R=a}else k=3;return i.substring(q,R)}function C(){let q="",R=a;for(;;){if(a>=b){q+=i.substring(R,a),k=2;break}const j=i.charCodeAt(a);if(j===34){q+=i.substring(R,a),a++;break}if(j===92){if(q+=i.substring(R,a),a++,a>=b){k=2;break}switch(i.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const re=g(4);re>=0?q+=String.fromCharCode(re):k=4;break}default:k=5}R=a;continue}if(j>=0&&j<=31)if(f(j)){q+=i.substring(R,a),k=2;break}else k=6;a++}return q}function P(){if(h="",k=0,D=a,a>=b)return D=b,d=17;let q=i.charCodeAt(a);if(p(q)){do a++,h+=String.fromCharCode(q),q=i.charCodeAt(a);while(p(q));return d=15}if(f(q))return a++,h+=String.fromCharCode(q),q===13&&i.charCodeAt(a)===10&&(a++,h+=`
`),d=14;switch(q){case 123:return a++,d=1;case 125:return a++,d=2;case 91:return a++,d=3;case 93:return a++,d=4;case 58:return a++,d=6;case 44:return a++,d=5;case 34:return a++,h=C(),d=10;case 47:{const R=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<b&&!f(i.charCodeAt(a));)a++;return h=i.substring(R,a),d=12}if(i.charCodeAt(a+1)===42){a+=2;const j=b-1;let K=!1;for(;a<j;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,k=1),h=i.substring(R,a),d=13}return h+=String.fromCharCode(q),a++,d=16}case 45:if(h+=String.fromCharCode(q),a++,a===b||!E(i.charCodeAt(a)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=w(),d=11;default:for(;a<b&&W(q);)a++,q=i.charCodeAt(a);if(D!==a){switch(h=i.substring(D,a),h){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return h+=String.fromCharCode(q),a++,d=16}}function W(q){if(p(q)||f(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:S,getPosition:()=>a,scan:$?V:P,getToken:()=>d,getTokenValue:()=>h,getTokenOffset:()=>D,getTokenLength:()=>a-D,getTokenError:()=>k}}function p(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function E(i){return i>=48&&i<=57}var T;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(T||(T={}));function y(i,$){const a=[],b=new Object;let h;const D={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function k(g,S,w,C){D.value=g,D.offset=S,D.length=w,D.type=C,D.colonOffset=void 0,h=D}try{t(i,{onObjectBegin:(g,S)=>{if($<=g)throw b;h=void 0,d=$>g,a.push("")},onObjectProperty:(g,S,w)=>{if($<S||(k(g,S,w,"property"),a[a.length-1]=g,$<=S+w))throw b},onObjectEnd:(g,S)=>{if($<=g)throw b;h=void 0,a.pop()},onArrayBegin:(g,S)=>{if($<=g)throw b;h=void 0,a.push(0)},onArrayEnd:(g,S)=>{if($<=g)throw b;h=void 0,a.pop()},onLiteralValue:(g,S,w)=>{if($<S||(k(g,S,w,l(g)),$<=S+w))throw b},onSeparator:(g,S,w)=>{if($<=S)throw b;if(g===":"&&h&&h.type==="property")h.colonOffset=S,d=!1,h=void 0;else if(g===","){const C=a[a.length-1];typeof C=="number"?a[a.length-1]=C+1:(d=!0,a[a.length-1]=""),h=void 0}}})}catch(g){if(g!==b)throw g}return{path:a,previousNode:h,isAtPropertyKey:d,matches:g=>{let S=0;for(let w=0;S<g.length&&w<a.length;w++)if(g[S]===a[w]||g[S]==="*")S++;else if(g[S]!=="**")return!1;return S===g.length}}}function u(i,$=[],a=F.DEFAULT){let b=null,h=[];const D=[];function d(g){Array.isArray(h)?h.push(g):b!==null&&(h[b]=g)}return t(i,{onObjectBegin:()=>{const g={};d(g),D.push(h),h=g,b=null},onObjectProperty:g=>{b=g},onObjectEnd:()=>{h=D.pop()},onArrayBegin:()=>{const g=[];d(g),D.push(h),h=g,b=null},onArrayEnd:()=>{h=D.pop()},onLiteralValue:d,onError:(g,S,w)=>{$.push({error:g,offset:S,length:w})}},a),h[0]}function v(i,$=[],a=F.DEFAULT){let b={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(g){b.type==="property"&&(b.length=g-b.offset,b=b.parent)}function D(g){return b.children.push(g),g}t(i,{onObjectBegin:g=>{b=D({type:"object",offset:g,length:-1,parent:b,children:[]})},onObjectProperty:(g,S,w)=>{b=D({type:"property",offset:S,length:-1,parent:b,children:[]}),b.children.push({type:"string",value:g,offset:S,length:w,parent:b})},onObjectEnd:(g,S)=>{b.length=g+S-b.offset,b=b.parent,h(g+S)},onArrayBegin:(g,S)=>{b=D({type:"array",offset:g,length:-1,parent:b,children:[]})},onArrayEnd:(g,S)=>{b.length=g+S-b.offset,b=b.parent,h(g+S)},onLiteralValue:(g,S,w)=>{D({type:l(g),offset:S,length:w,parent:b,value:g}),h(S+w)},onSeparator:(g,S,w)=>{b.type==="property"&&(g===":"?b.colonOffset=S:g===","&&h(S))},onError:(g,S,w)=>{$.push({error:g,offset:S,length:w})}},a);const k=b.children[0];return k&&delete k.parent,k}function m(i,$){if(!i)return;let a=i;for(const b of $)if(typeof b=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let h=!1;for(const D of a.children)if(Array.isArray(D.children)&&D.children[0].value===b){a=D.children[1],h=!0;break}if(!h)return}else{const h=b;if(a.type!=="array"||h<0||!Array.isArray(a.children)||h>=a.children.length)return;a=a.children[h]}return a}function s(i){if(!i.parent||!i.parent.children)return[];const $=s(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;$.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&$.push(a)}return $}function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const $=Object.create(null);for(const a of i.children){const b=a.children[1];b&&($[a.children[0].value]=o(b))}return $}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function r(i,$,a=!1){return $>=i.offset&&$<i.offset+i.length||a&&$===i.offset+i.length}function n(i,$,a=!1){if(r(i,$,a)){const b=i.children;if(Array.isArray(b))for(let h=0;h<b.length&&b[h].offset<=$;h++){const D=n(b[h],$,a);if(D)return D}return i}}function t(i,$,a=F.DEFAULT){const b=M(i,!1);function h(Me){return Me?()=>Me(b.getTokenOffset(),b.getTokenLength()):()=>!0}function D(Me){return Me?ce=>Me(ce,b.getTokenOffset(),b.getTokenLength()):()=>!0}const d=h($.onObjectBegin),k=D($.onObjectProperty),g=h($.onObjectEnd),S=h($.onArrayBegin),w=h($.onArrayEnd),C=D($.onLiteralValue),P=D($.onSeparator),W=h($.onComment),V=D($.onError),q=a&&a.disallowComments,R=a&&a.allowTrailingComma;function j(){for(;;){const Me=b.scan();switch(b.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Me){case 12:case 13:q?K(10):W();break;case 16:K(1);break;case 15:case 14:break;default:return Me}}}function K(Me,ce=[],Ae=[]){if(V(Me),ce.length+Ae.length>0){let ie=b.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){j();break}else if(Ae.indexOf(ie)!==-1)break;ie=j()}}}function re(Me){const ce=b.getTokenValue();return Me?C(ce):k(ce),j(),!0}function ae(){switch(b.getToken()){case 11:{let Me=0;try{Me=JSON.parse(b.getTokenValue()),typeof Me!="number"&&(K(2),Me=0)}catch{K(2)}C(Me);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return j(),!0}function ve(){return b.getToken()!==10?(K(3,[],[2,5]),!1):(re(!1),b.getToken()===6?(P(":"),j(),me()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Ie(){d(),j();let Me=!1;for(;b.getToken()!==2&&b.getToken()!==17;){if(b.getToken()===5){if(Me||K(4,[],[]),P(","),j(),b.getToken()===2&&R)break}else Me&&K(6,[],[]);ve()||K(4,[],[2,5]),Me=!0}return g(),b.getToken()!==2?K(7,[2],[]):j(),!0}function de(){S(),j();let Me=!1;for(;b.getToken()!==4&&b.getToken()!==17;){if(b.getToken()===5){if(Me||K(4,[],[]),P(","),j(),b.getToken()===4&&R)break}else Me&&K(6,[],[]);me()||K(4,[],[4,5]),Me=!0}return w(),b.getToken()!==4?K(8,[4],[]):j(),!0}function me(){switch(b.getToken()){case 3:return de();case 1:return Ie();case 10:return re(!0);default:return ae()}}return j(),b.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):me()?(b.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(i,$){const a=M(i),b=[];let h,D=0,d;do switch(d=a.getPosition(),h=a.scan(),h){case 12:case 13:case 17:D!==d&&b.push(i.substring(D,d)),$!==void 0&&b.push(a.getTokenValue().replace(/[^\r\n]/g,$)),D=a.getPosition();break}while(h!==17);return b.join("")}function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(ge,e){typeof define=="function"&&define.amd?define(Ce[124],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ee,pe){for(var fe=0;fe<pe.length;fe++){var X=pe[fe];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(Ee,X.key,X)}}function I(Ee,pe,fe){return pe&&e(Ee.prototype,pe),fe&&e(Ee,fe),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function N(Ee,pe){if(Ee){if(typeof Ee=="string")return A(Ee,pe);var fe=Object.prototype.toString.call(Ee).slice(8,-1);if(fe==="Object"&&Ee.constructor&&(fe=Ee.constructor.name),fe==="Map"||fe==="Set")return Array.from(Ee);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return A(Ee,pe)}}function A(Ee,pe){(pe==null||pe>Ee.length)&&(pe=Ee.length);for(var fe=0,X=new Array(pe);fe<pe;fe++)X[fe]=Ee[fe];return X}function F(Ee,pe){var fe=typeof Symbol<"u"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(fe)return(fe=fe.call(Ee)).next.bind(fe);if(Array.isArray(Ee)||(fe=N(Ee))||pe&&Ee&&typeof Ee.length=="number"){fe&&(Ee=fe);var X=0;return function(){return X>=Ee.length?{done:!0}:{done:!1,value:Ee[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=M();function p(Ee){ge.defaults=Ee}var f=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(pe){return u[pe]};function m(Ee,pe){if(pe){if(f.test(Ee))return Ee.replace(E,v)}else if(T.test(Ee))return Ee.replace(y,v);return Ee}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ee){return Ee.replace(s,function(pe,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var r=/(^|[^\[])\^/g;function n(Ee,pe){Ee=typeof Ee=="string"?Ee:Ee.source,pe=pe||"";var fe={replace:function(Z,le){return le=le.source||le,le=le.replace(r,"$1"),Ee=Ee.replace(Z,le),fe},getRegex:function(){return new RegExp(Ee,pe)}};return fe}var t=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(Ee,pe,fe){if(Ee){var X;try{X=decodeURIComponent(o(fe)).replace(t,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}pe&&!c.test(fe)&&(fe=h(pe,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},$=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,b=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(Ee,pe){i[" "+Ee]||($.test(Ee)?i[" "+Ee]=Ee+"/":i[" "+Ee]=g(Ee,"/",!0)),Ee=i[" "+Ee];var fe=Ee.indexOf(":")===-1;return pe.substring(0,2)==="//"?fe?pe:Ee.replace(a,"$1")+pe:pe.charAt(0)==="/"?fe?pe:Ee.replace(b,"$1")+pe:Ee+pe}var D={exec:function(){}};function d(Ee){for(var pe=1,fe,X;pe<arguments.length;pe++){fe=arguments[pe];for(X in fe)Object.prototype.hasOwnProperty.call(fe,X)&&(Ee[X]=fe[X])}return Ee}function k(Ee,pe){var fe=Ee.replace(/\|/g,function(le,ue,Te){for(var he=!1,Pe=ue;--Pe>=0&&Te[Pe]==="\\";)he=!he;return he?"|":" |"}),X=fe.split(/ \|/),Z=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>pe)X.splice(pe);else for(;X.length<pe;)X.push("");for(;Z<X.length;Z++)X[Z]=X[Z].trim().replace(/\\\|/g,"|");return X}function g(Ee,pe,fe){var X=Ee.length;if(X===0)return"";for(var Z=0;Z<X;){var le=Ee.charAt(X-Z-1);if(le===pe&&!fe)Z++;else if(le!==pe&&fe)Z++;else break}return Ee.slice(0,X-Z)}function S(Ee,pe){if(Ee.indexOf(pe[1])===-1)return-1;for(var fe=Ee.length,X=0,Z=0;Z<fe;Z++)if(Ee[Z]==="\\")Z++;else if(Ee[Z]===pe[0])X++;else if(Ee[Z]===pe[1]&&(X--,X<0))return Z;return-1}function w(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(Ee,pe){if(pe<1)return"";for(var fe="";pe>1;)pe&1&&(fe+=Ee),pe>>=1,Ee+=Ee;return fe+Ee}function P(Ee,pe,fe,X){var Z=pe.href,le=pe.title?m(pe.title):null,ue=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){X.state.inLink=!0;var Te={type:"link",raw:fe,href:Z,title:le,text:ue,tokens:X.inlineTokens(ue)};return X.state.inLink=!1,Te}return{type:"image",raw:fe,href:Z,title:le,text:m(ue)}}function W(Ee,pe){var fe=Ee.match(/^(\s+)(?:```)/);if(fe===null)return pe;var X=fe[1];return pe.split(`
`).map(function(Z){var le=Z.match(/^\s+/);if(le===null)return Z;var ue=le[0];return ue.length>=X.length?Z.slice(X.length):Z}).join(`
`)}var V=function(){function Ee(fe){this.options=fe||ge.defaults}var pe=Ee.prototype;return pe.space=function(X){var Z=this.rules.block.newline.exec(X);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},pe.code=function(X){var Z=this.rules.block.code.exec(X);if(Z){var le=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?le:g(le,`
`)}}},pe.fences=function(X){var Z=this.rules.block.fences.exec(X);if(Z){var le=Z[0],ue=W(le,Z[3]||"");return{type:"code",raw:le,lang:Z[2]?Z[2].trim():Z[2],text:ue}}},pe.heading=function(X){var Z=this.rules.block.heading.exec(X);if(Z){var le=Z[2].trim();if(/#$/.test(le)){var ue=g(le,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(le=ue.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:le,tokens:this.lexer.inline(le)}}},pe.hr=function(X){var Z=this.rules.block.hr.exec(X);if(Z)return{type:"hr",raw:Z[0]}},pe.blockquote=function(X){var Z=this.rules.block.blockquote.exec(X);if(Z){var le=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},pe.list=function(X){var Z=this.rules.block.list.exec(X);if(Z){var le,ue,Te,he,Pe,Ne,ze,U,z,G,H,ee,ne=Z[1].trim(),Fe=ne.length>1,Be={type:"list",raw:"",ordered:Fe,start:Fe?+ne.slice(0,-1):"",loose:!1,items:[]};ne=Fe?"\\d{1,9}\\"+ne.slice(-1):"\\"+ne,this.options.pedantic&&(ne=Fe?ne:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(ee=!1,!(!(Z=Xe.exec(X))||this.rules.block.hr.test(X)));){if(le=Z[0],X=X.substring(le.length),U=Z[2].split(`
`,1)[0],z=X.split(`
`,1)[0],this.options.pedantic?(he=2,H=U.trimLeft()):(he=Z[2].search(/[^ ]/),he=he>4?1:he,H=U.slice(he),he+=Z[1].length),Ne=!1,!U&&/^ *$/.test(z)&&(le+=z+`
`,X=X.substring(z.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,he-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,he-1)+"}#");X&&(G=X.split(`
`,1)[0],U=G,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(U)||it.test(U)||_e.test(U)||et.test(X)));){if(U.search(/[^ ]/)>=he||!U.trim())H+=`
`+U.slice(he);else if(!Ne)H+=`
`+U;else break;!Ne&&!U.trim()&&(Ne=!0),le+=G+`
`,X=X.substring(G.length+1)}Be.loose||(ze?Be.loose=!0:/\n *\n *$/.test(le)&&(ze=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(H),ue&&(Te=ue[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:le,task:!!ue,checked:Te,loose:!1,text:H}),Be.raw+=le}Be.items[Be.items.length-1].raw=le.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(Pe=0;Pe<nt;Pe++){this.lexer.state.top=!1,Be.items[Pe].tokens=this.lexer.blockTokens(Be.items[Pe].text,[]);var at=Be.items[Pe].tokens.filter(function(je){return je.type==="space"}),mt=at.every(function(je){for(var st=je.raw.split(""),Y=0,Q=F(st),$e;!($e=Q()).done;){var He=$e.value;if(He===`
`&&(Y+=1),Y>1)return!0}return!1});!Be.loose&&at.length&&mt&&(Be.loose=!0,Be.items[Pe].loose=!0)}return Be}},pe.html=function(X){var Z=this.rules.block.html.exec(X);if(Z){var le={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(Z[0]):m(Z[0]);le.type="paragraph",le.text=ue,le.tokens=this.lexer.inline(ue)}return le}},pe.def=function(X){var Z=this.rules.block.def.exec(X);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var le=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:Z[0],href:Z[2],title:Z[3]}}},pe.table=function(X){var Z=this.rules.block.table.exec(X);if(Z){var le={type:"table",header:k(Z[1]).map(function(ze){return{text:ze}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=Z[0];var ue=le.align.length,Te,he,Pe,Ne;for(Te=0;Te<ue;Te++)/^ *-+: *$/.test(le.align[Te])?le.align[Te]="right":/^ *:-+: *$/.test(le.align[Te])?le.align[Te]="center":/^ *:-+ *$/.test(le.align[Te])?le.align[Te]="left":le.align[Te]=null;for(ue=le.rows.length,Te=0;Te<ue;Te++)le.rows[Te]=k(le.rows[Te],le.header.length).map(function(ze){return{text:ze}});for(ue=le.header.length,he=0;he<ue;he++)le.header[he].tokens=this.lexer.inline(le.header[he].text);for(ue=le.rows.length,he=0;he<ue;he++)for(Ne=le.rows[he],Pe=0;Pe<Ne.length;Pe++)Ne[Pe].tokens=this.lexer.inline(Ne[Pe].text);return le}}},pe.lheading=function(X){var Z=this.rules.block.lheading.exec(X);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},pe.paragraph=function(X){var Z=this.rules.block.paragraph.exec(X);if(Z){var le=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:le,tokens:this.lexer.inline(le)}}},pe.text=function(X){var Z=this.rules.block.text.exec(X);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},pe.escape=function(X){var Z=this.rules.inline.escape.exec(X);if(Z)return{type:"escape",raw:Z[0],text:m(Z[1])}},pe.tag=function(X){var Z=this.rules.inline.tag.exec(X);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):m(Z[0]):Z[0]}},pe.link=function(X){var Z=this.rules.inline.link.exec(X);if(Z){var le=Z[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var ue=g(le.slice(0,-1),"\\");if((le.length-ue.length)%2===0)return}else{var Te=S(Z[2],"()");if(Te>-1){var he=Z[0].indexOf("!")===0?5:4,Pe=he+Z[1].length+Te;Z[2]=Z[2].substring(0,Te),Z[0]=Z[0].substring(0,Pe).trim(),Z[3]=""}}var Ne=Z[2],ze="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);U&&(Ne=U[1],ze=U[3])}else ze=Z[3]?Z[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(le)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),P(Z,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},pe.reflink=function(X,Z){var le;if((le=this.rules.inline.reflink.exec(X))||(le=this.rules.inline.nolink.exec(X))){var ue=(le[2]||le[1]).replace(/\s+/g," ");if(ue=Z[ue.toLowerCase()],!ue||!ue.href){var Te=le[0].charAt(0);return{type:"text",raw:Te,text:Te}}return P(le,ue,le[0],this.lexer)}},pe.emStrong=function(X,Z,le){le===void 0&&(le="");var ue=this.rules.inline.emStrong.lDelim.exec(X);if(ue&&!(ue[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=ue[1]||ue[2]||"";if(!Te||Te&&(le===""||this.rules.inline.punctuation.exec(le))){var he=ue[0].length-1,Pe,Ne,ze=he,U=0,z=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,Z=Z.slice(-1*X.length+he);(ue=z.exec(Z))!=null;)if(Pe=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Pe){if(Ne=Pe.length,ue[3]||ue[4]){ze+=Ne;continue}else if((ue[5]||ue[6])&&he%3&&!((he+Ne)%3)){U+=Ne;continue}if(ze-=Ne,!(ze>0)){if(Ne=Math.min(Ne,Ne+ze+U),Math.min(he,Ne)%2){var G=X.slice(1,he+ue.index+Ne);return{type:"em",raw:X.slice(0,he+ue.index+Ne+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=X.slice(2,he+ue.index+Ne-1);return{type:"strong",raw:X.slice(0,he+ue.index+Ne+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},pe.codespan=function(X){var Z=this.rules.inline.code.exec(X);if(Z){var le=Z[2].replace(/\n/g," "),ue=/[^ ]/.test(le),Te=/^ /.test(le)&&/ $/.test(le);return ue&&Te&&(le=le.substring(1,le.length-1)),le=m(le,!0),{type:"codespan",raw:Z[0],text:le}}},pe.br=function(X){var Z=this.rules.inline.br.exec(X);if(Z)return{type:"br",raw:Z[0]}},pe.del=function(X){var Z=this.rules.inline.del.exec(X);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},pe.autolink=function(X,Z){var le=this.rules.inline.autolink.exec(X);if(le){var ue,Te;return le[2]==="@"?(ue=m(this.options.mangle?Z(le[1]):le[1]),Te="mailto:"+ue):(ue=m(le[1]),Te=ue),{type:"link",raw:le[0],text:ue,href:Te,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.url=function(X,Z){var le;if(le=this.rules.inline.url.exec(X)){var ue,Te;if(le[2]==="@")ue=m(this.options.mangle?Z(le[0]):le[0]),Te="mailto:"+ue;else{var he;do he=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(he!==le[0]);ue=m(le[0]),le[1]==="www."?Te="http://"+ue:Te=ue}return{type:"link",raw:le[0],text:ue,href:Te,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.inlineText=function(X,Z){var le=this.rules.inline.text.exec(X);if(le){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]):le[0]:ue=m(this.options.smartypants?Z(le[0]):le[0]),{type:"text",raw:le[0],text:ue}}},Ee}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:D,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=n(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=n(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=n(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=n(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=n(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=d({},q),q.gfm=d({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=n(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=d({},q.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:D,paragraph:n(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:D,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:D,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=n(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=n(q._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=n(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=n(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=n(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=n(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=n(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=n(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=n(R.reflink).replace("label",R._label).replace("ref",q._label).getRegex(),R.nolink=n(R.nolink).replace("ref",q._label).getRegex(),R.reflinkSearch=n(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=d({},R),R.pedantic=d({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=d({},R.normal,{escape:n(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=n(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=d({},R.gfm,{br:n(R.br).replace("{2,}","*").getRegex(),text:n(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(Ee){var pe="",fe,X,Z=Ee.length;for(fe=0;fe<Z;fe++)X=Ee.charCodeAt(fe),Math.random()>.5&&(X="x"+X.toString(16)),pe+="&#"+X+";";return pe}var re=function(){function Ee(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ge.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:q.normal,inline:R.normal};this.options.pedantic?(X.block=q.pedantic,X.inline=R.pedantic):this.options.gfm&&(X.block=q.gfm,this.options.breaks?X.inline=R.breaks:X.inline=R.gfm),this.tokenizer.rules=X}Ee.lex=function(X,Z){var le=new Ee(Z);return le.lex(X)},Ee.lexInline=function(X,Z){var le=new Ee(Z);return le.inlineTokens(X)};var pe=Ee.prototype;return pe.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},pe.blockTokens=function(X,Z){var le=this;Z===void 0&&(Z=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(ze,U,z){return U+"    ".repeat(z.length)});for(var ue,Te,he,Pe;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(ue=ze.call({lexer:le},X,Z))?(X=X.substring(ue.raw.length),Z.push(ue),!0):!1}))){if(ue=this.tokenizer.space(X)){X=X.substring(ue.raw.length),ue.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(ue);continue}if(ue=this.tokenizer.code(X)){X=X.substring(ue.raw.length),Te=Z[Z.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ue.raw,Te.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Z.push(ue);continue}if(ue=this.tokenizer.fences(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.heading(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.hr(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.blockquote(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.list(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.html(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.def(X)){X=X.substring(ue.raw.length),Te=Z[Z.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ue.raw,Te.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.lheading(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(he=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,U=X.slice(1),z=void 0;le.options.extensions.startBlock.forEach(function(G){z=G.call({lexer:this},U),typeof z=="number"&&z>=0&&(ze=Math.min(ze,z))}),ze<1/0&&ze>=0&&(he=X.substring(0,ze+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(he))){Te=Z[Z.length-1],Pe&&Te.type==="paragraph"?(Te.raw+=`
`+ue.raw,Te.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Z.push(ue),Pe=he.length!==X.length,X=X.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(X)){X=X.substring(ue.raw.length),Te=Z[Z.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+ue.raw,Te.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Z.push(ue);continue}if(X){var Ne="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return this.state.top=!0,Z},pe.inline=function(X,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:X,tokens:Z}),Z},pe.inlineTokens=function(X,Z){var le=this;Z===void 0&&(Z=[]);var ue,Te,he,Pe=X,Ne,ze,U;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)z.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ne.index)+"["+C("a",Ne[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ne.index)+"["+C("a",Ne[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ne.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(ze||(U=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(ue=H.call({lexer:le},X,Z))?(X=X.substring(ue.raw.length),Z.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.tag(X)){X=X.substring(ue.raw.length),Te=Z[Z.length-1],Te&&ue.type==="text"&&Te.type==="text"?(Te.raw+=ue.raw,Te.text+=ue.text):Z.push(ue);continue}if(ue=this.tokenizer.link(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(ue.raw.length),Te=Z[Z.length-1],Te&&ue.type==="text"&&Te.type==="text"?(Te.raw+=ue.raw,Te.text+=ue.text):Z.push(ue);continue}if(ue=this.tokenizer.emStrong(X,Pe,U)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.codespan(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.br(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.del(X)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(ue=this.tokenizer.autolink(X,K)){X=X.substring(ue.raw.length),Z.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(X,K))){X=X.substring(ue.raw.length),Z.push(ue);continue}if(he=X,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=X.slice(1),ne=void 0;le.options.extensions.startInline.forEach(function(Fe){ne=Fe.call({lexer:this},ee),typeof ne=="number"&&ne>=0&&(H=Math.min(H,ne))}),H<1/0&&H>=0&&(he=X.substring(0,H+1))}(),ue=this.tokenizer.inlineText(he,j)){X=X.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(U=ue.raw.slice(-1)),ze=!0,Te=Z[Z.length-1],Te&&Te.type==="text"?(Te.raw+=ue.raw,Te.text+=ue.text):Z.push(ue);continue}if(X){var G="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Z},I(Ee,null,[{key:"rules",get:function(){return{block:q,inline:R}}}]),Ee}(),ae=function(){function Ee(fe){this.options=fe||ge.defaults}var pe=Ee.prototype;return pe.code=function(X,Z,le){var ue=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(X,ue);Te!=null&&Te!==X&&(le=!0,X=Te)}return X=X.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+m(ue,!0)+'">'+(le?X:m(X,!0))+`</code></pre>
`:"<pre><code>"+(le?X:m(X,!0))+`</code></pre>
`},pe.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},pe.html=function(X){return X},pe.heading=function(X,Z,le,ue){if(this.options.headerIds){var Te=this.options.headerPrefix+ue.slug(le);return"<h"+Z+' id="'+Te+'">'+X+"</h"+Z+`>
`}return"<h"+Z+">"+X+"</h"+Z+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(X,Z,le){var ue=Z?"ol":"ul",Te=Z&&le!==1?' start="'+le+'"':"";return"<"+ue+Te+`>
`+X+"</"+ue+`>
`},pe.listitem=function(X){return"<li>"+X+`</li>
`},pe.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(X){return"<p>"+X+`</p>
`},pe.table=function(X,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+Z+`</table>
`},pe.tablerow=function(X){return`<tr>
`+X+`</tr>
`},pe.tablecell=function(X,Z){var le=Z.header?"th":"td",ue=Z.align?"<"+le+' align="'+Z.align+'">':"<"+le+">";return ue+X+("</"+le+`>
`)},pe.strong=function(X){return"<strong>"+X+"</strong>"},pe.em=function(X){return"<em>"+X+"</em>"},pe.codespan=function(X){return"<code>"+X+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(X){return"<del>"+X+"</del>"},pe.link=function(X,Z,le){if(X=l(this.options.sanitize,this.options.baseUrl,X),X===null)return le;var ue='<a href="'+m(X)+'"';return Z&&(ue+=' title="'+Z+'"'),ue+=">"+le+"</a>",ue},pe.image=function(X,Z,le){if(X=l(this.options.sanitize,this.options.baseUrl,X),X===null)return le;var ue='<img src="'+X+'" alt="'+le+'"';return Z&&(ue+=' title="'+Z+'"'),ue+=this.options.xhtml?"/>":">",ue},pe.text=function(X){return X},Ee}(),ve=function(){function Ee(){}var pe=Ee.prototype;return pe.strong=function(X){return X},pe.em=function(X){return X},pe.codespan=function(X){return X},pe.del=function(X){return X},pe.html=function(X){return X},pe.text=function(X){return X},pe.link=function(X,Z,le){return""+le},pe.image=function(X,Z,le){return""+le},pe.br=function(){return""},Ee}(),Ie=function(){function Ee(){this.seen={}}var pe=Ee.prototype;return pe.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(X,Z){var le=X,ue=0;if(this.seen.hasOwnProperty(le)){ue=this.seen[X];do ue++,le=X+"-"+ue;while(this.seen.hasOwnProperty(le))}return Z||(this.seen[X]=ue,this.seen[le]=0),le},pe.slug=function(X,Z){Z===void 0&&(Z={});var le=this.serialize(X);return this.getNextSafeSlug(le,Z.dryrun)},Ee}(),de=function(){function Ee(fe){this.options=fe||ge.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new Ie}Ee.parse=function(X,Z){var le=new Ee(Z);return le.parse(X)},Ee.parseInline=function(X,Z){var le=new Ee(Z);return le.parseInline(X)};var pe=Ee.prototype;return pe.parse=function(X,Z){Z===void 0&&(Z=!0);var le="",ue,Te,he,Pe,Ne,ze,U,z,G,H,ee,ne,Fe,Be,Xe,_e,et,tt,it,nt=X.length;for(ue=0;ue<nt;ue++){if(H=X[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(it=this.options.extensions.renderers[H.type].call({parser:this},H),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){le+=it||"";continue}switch(H.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(z="",U="",Pe=H.header.length,Te=0;Te<Pe;Te++)U+=this.renderer.tablecell(this.parseInline(H.header[Te].tokens),{header:!0,align:H.align[Te]});for(z+=this.renderer.tablerow(U),G="",Pe=H.rows.length,Te=0;Te<Pe;Te++){for(ze=H.rows[Te],U="",Ne=ze.length,he=0;he<Ne;he++)U+=this.renderer.tablecell(this.parseInline(ze[he].tokens),{header:!1,align:H.align[he]});G+=this.renderer.tablerow(U)}le+=this.renderer.table(z,G);continue}case"blockquote":{G=this.parse(H.tokens),le+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,ne=H.start,Fe=H.loose,Pe=H.items.length,G="",Te=0;Te<Pe;Te++)Xe=H.items[Te],_e=Xe.checked,et=Xe.task,Be="",Xe.task&&(tt=this.renderer.checkbox(_e),Fe?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=tt+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=tt+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:tt}):Be+=tt),Be+=this.parse(Xe.tokens,Fe),G+=this.renderer.listitem(Be,et,_e);le+=this.renderer.list(G,ee,ne);continue}case"html":{le+=this.renderer.html(H.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;ue+1<nt&&X[ue+1].type==="text";)H=X[++ue],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);le+=Z?this.renderer.paragraph(G):G;continue}default:{var at='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return le},pe.parseInline=function(X,Z){Z=Z||this.renderer;var le="",ue,Te,he,Pe=X.length;for(ue=0;ue<Pe;ue++){if(Te=X[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(he=this.options.extensions.renderers[Te.type].call({parser:this},Te),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){le+=he||"";continue}switch(Te.type){case"escape":{le+=Z.text(Te.text);break}case"html":{le+=Z.html(Te.text);break}case"link":{le+=Z.link(Te.href,Te.title,this.parseInline(Te.tokens,Z));break}case"image":{le+=Z.image(Te.href,Te.title,Te.text);break}case"strong":{le+=Z.strong(this.parseInline(Te.tokens,Z));break}case"em":{le+=Z.em(this.parseInline(Te.tokens,Z));break}case"codespan":{le+=Z.codespan(Te.text);break}case"br":{le+=Z.br();break}case"del":{le+=Z.del(this.parseInline(Te.tokens,Z));break}case"text":{le+=Z.text(Te.text);break}default:{var Ne='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return le},Ee}();function me(Ee,pe,fe){if(typeof Ee>"u"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof pe=="function"&&(fe=pe,pe=null),pe=d({},me.defaults,pe||{}),w(pe),fe){var X=pe.highlight,Z;try{Z=re.lex(Ee,pe)}catch(Pe){return fe(Pe)}var le=function(Ne){var ze;if(!Ne)try{pe.walkTokens&&me.walkTokens(Z,pe.walkTokens),ze=de.parse(Z,pe)}catch(U){Ne=U}return pe.highlight=X,Ne?fe(Ne):fe(null,ze)};if(!X||X.length<3||(delete pe.highlight,!Z.length))return le();var ue=0;me.walkTokens(Z,function(Pe){Pe.type==="code"&&(ue++,setTimeout(function(){X(Pe.text,Pe.lang,function(Ne,ze){if(Ne)return le(Ne);ze!=null&&ze!==Pe.text&&(Pe.text=ze,Pe.escaped=!0),ue--,ue===0&&le()})},0))}),ue===0&&le();return}function Te(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+m(Pe.message+"",!0)+"</pre>";throw Pe}try{var he=re.lex(Ee,pe);if(pe.walkTokens){if(pe.async)return Promise.all(me.walkTokens(he,pe.walkTokens)).then(function(){return de.parse(he,pe)}).catch(Te);me.walkTokens(he,pe.walkTokens)}return de.parse(he,pe)}catch(Pe){Te(Pe)}}me.options=me.setOptions=function(Ee){return d(me.defaults,Ee),p(me.defaults),me},me.getDefaults=M,me.defaults=ge.defaults,me.use=function(){for(var Ee=arguments.length,pe=new Array(Ee),fe=0;fe<Ee;fe++)pe[fe]=arguments[fe];var X=d.apply(void 0,[{}].concat(pe)),Z=me.defaults.extensions||{renderers:{},childTokens:{}},le;pe.forEach(function(ue){if(ue.extensions&&(le=!0,ue.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Pe=Z.renderers?Z.renderers[he.name]:null;Pe?Z.renderers[he.name]=function(){for(var Ne=arguments.length,ze=new Array(Ne),U=0;U<Ne;U++)ze[U]=arguments[U];var z=he.renderer.apply(this,ze);return z===!1&&(z=Pe.apply(this,ze)),z}:Z.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[he.level]?Z[he.level].unshift(he.tokenizer):Z[he.level]=[he.tokenizer],he.start&&(he.level==="block"?Z.startBlock?Z.startBlock.push(he.start):Z.startBlock=[he.start]:he.level==="inline"&&(Z.startInline?Z.startInline.push(he.start):Z.startInline=[he.start]))}he.childTokens&&(Z.childTokens[he.name]=he.childTokens)})),ue.renderer&&function(){var he=me.defaults.renderer||new ae,Pe=function(U){var z=he[U];he[U]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var ne=ue.renderer[U].apply(he,H);return ne===!1&&(ne=z.apply(he,H)),ne}};for(var Ne in ue.renderer)Pe(Ne);X.renderer=he}(),ue.tokenizer&&function(){var he=me.defaults.tokenizer||new V,Pe=function(U){var z=he[U];he[U]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var ne=ue.tokenizer[U].apply(he,H);return ne===!1&&(ne=z.apply(he,H)),ne}};for(var Ne in ue.tokenizer)Pe(Ne);X.tokenizer=he}(),ue.walkTokens){var Te=me.defaults.walkTokens;X.walkTokens=function(he){var Pe=[];return Pe.push(ue.walkTokens.call(this,he)),Te&&(Pe=Pe.concat(Te.call(this,he))),Pe}}le&&(X.extensions=Z),me.setOptions(X)})},me.walkTokens=function(Ee,pe){for(var fe=[],X=function(){var Te=le.value;switch(fe=fe.concat(pe.call(me,Te)),Te.type){case"table":{for(var he=F(Te.header),Pe;!(Pe=he()).done;){var Ne=Pe.value;fe=fe.concat(me.walkTokens(Ne.tokens,pe))}for(var ze=F(Te.rows),U;!(U=ze()).done;)for(var z=U.value,G=F(z),H;!(H=G()).done;){var ee=H.value;fe=fe.concat(me.walkTokens(ee.tokens,pe))}break}case"list":{fe=fe.concat(me.walkTokens(Te.items,pe));break}default:me.defaults.extensions&&me.defaults.extensions.childTokens&&me.defaults.extensions.childTokens[Te.type]?me.defaults.extensions.childTokens[Te.type].forEach(function(ne){fe=fe.concat(me.walkTokens(Te[ne],pe))}):Te.tokens&&(fe=fe.concat(me.walkTokens(Te.tokens,pe)))}},Z=F(Ee),le;!(le=Z()).done;)X();return fe},me.parseInline=function(Ee,pe){if(typeof Ee>"u"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");pe=d({},me.defaults,pe||{}),w(pe);try{var fe=re.lexInline(Ee,pe);return pe.walkTokens&&me.walkTokens(fe,pe.walkTokens),de.parseInline(fe,pe)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+m(X.message+"",!0)+"</pre>";throw X}},me.Parser=de,me.parser=de.parse,me.Renderer=ae,me.TextRenderer=ve,me.Lexer=re,me.lexer=re.lex,me.Tokenizer=V,me.Slugger=Ie,me.parse=me;var Me=me.options,ce=me.setOptions,Ae=me.use,ie=me.walkTokens,L=me.parseInline,x=me,be=de.parse,Oe=re.lex;ge.Lexer=re,ge.Parser=de,ge.Renderer=ae,ge.Slugger=Ie,ge.TextRenderer=ve,ge.Tokenizer=V,ge.getDefaults=M,ge.lexer=Oe,ge.marked=me,ge.options=Me,ge.parse=x,ge.parseInline=L,ge.parser=be,ge.setOptions=ce,ge.use=Ae,ge.walkTokens=ie,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Ce[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=I;function I(s){const o=F(s);if(o&&o.length>0)return new Uint32Array(o)}let N=0;const A=new Uint32Array(10);function F(s){if(N=0,M(s,y,4352),N>0||(M(s,u,4449),N>0)||(M(s,v,4520),N>0)||(M(s,m,12593),N))return A.subarray(0,N);if(s>=44032&&s<=55203){const o=s-44032,r=o%588,n=Math.floor(o/588),t=Math.floor(r/28),c=r%28-1;if(n<y.length?M(n,y,0):4352+n-12593<m.length&&M(4352+n,m,12593),t<u.length?M(t,u,0):4449+t-12593<m.length&&M(4449+t-12593,m,12593),c>=0&&(c<v.length?M(c,v,0):4520+c-12593<m.length&&M(4520+c-12593,m,12593)),N>0)return A.subarray(0,N)}}function M(s,o,r){s>=r&&s<r+o.length&&p(o[s-r])}function p(s){s!==0&&(A[N++]=s&255,s>>8&&(A[N++]=s>>8&255),s>>16&&(A[N++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var E;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(E||(E={}));var T;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(T||(T={}));const y=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),m=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[126],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=void 0,e.$wm=I,e.rot=N;function I(p,f,E){return Math.min(Math.max(p,f),E)}function N(p,f){return(f+p%f)%f}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$ym=A;class F{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$zm=F;class M{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const E=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Am=M}),function(){function ge(A){const F=[];typeof A=="number"&&F.push("code/timeOrigin",A);function M(f){F.push(f,Date.now())}function p(){const f=[];for(let E=0;E<F.length;E+=2)f.push({name:F[E],startTime:F[E+1]});return f}return{mark:M,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const M of performance.getEntriesByType("mark"))F.push({name:M.name,startTime:Math.round(A+M.startTime)});return F}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function I(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=I(N))}(),define(Ce[127],Re([1,0,40]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=void 0;const N=Symbol("unset");class A{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(f,E,T){this.d(f,y=>y._value=E,T)}mutate(f,E){this.d(f,T=>T._value=E(T._value===N?void 0:T._value))}delete(f){const E=this.c(f);if(!E)return;let T=E.length-1;const y=E[T].node._value;if(y!==N){for(this.b--,E[T].node._value=N;T>0;T--){const{node:u,part:v}=E[T];if(u.children?.size||u._value!==N)break;E[T-1].node.children.delete(v)}return y}}*deleteRecursive(f){const E=this.c(f);if(!E)return;const T=E[E.length-1].node;for(let y=E.length-1;y>0;y--){const u=E[y-1];if(u.node.children.delete(E[y].part),u.node.children.size>0||u.node._value!==N)break}for(const y of F(T))y._value!==N&&(this.b--,yield y._value)}find(f){let E=this.a;for(const T of f){const y=E.children?.get(T);if(!y)return;E=y}return E._value===N?void 0:E._value}hasKeyOrParent(f){let E=this.a;for(const T of f){const y=E.children?.get(T);if(!y)return!1;if(y._value!==N)return!0;E=y}return!1}hasKeyOrChildren(f){let E=this.a;for(const T of f){const y=E.children?.get(T);if(!y)return!1;E=y}return!0}hasKey(f){let E=this.a;for(const T of f){const y=E.children?.get(T);if(!y)return!1;E=y}return E._value!==N}c(f){const E=[{part:"",node:this.a}];let T=0;for(const y of f){const u=E[T].node.children?.get(y);if(!u)return;E.push({part:y,node:u}),T++}return E}d(f,E,T){let y=this.a;for(const m of f){if(y.children)if(y.children.has(m))y=y.children.get(m);else{const s=new M;y.children.set(m,s),y=s}else{const s=new M;y.children=new Map([[m,s]]),y=s}T?.(y)}const u=y._value===N?0:1;E(y);const v=y._value===N?0:1;this.b+=v-u}*values(){for(const{_value:f}of F(this.a))f!==N&&(yield f)}}e.$7O=A;function*F(p){const f=[p];for(;f.length>0;){const E=f.pop();if(yield E,E.children)for(const T of E.children.values())f.push(T)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(f){this._value=f===void 0?N:f}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var N in I)(typeof exports=="object"?exports:ge)[N]=I[N]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function I(N){if(e[N])return e[N].exports;var A=e[N]={i:N,l:!1,exports:{}};return ge[N].call(A.exports,A,A.exports,I),A.l=!0,A.exports}return I.m=ge,I.c=e,I.d=function(N,A,F){I.o(N,A)||Object.defineProperty(N,A,{enumerable:!0,get:F})},I.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},I.t=function(N,A){if(1&A&&(N=I(N)),8&A||4&A&&typeof N=="object"&&N&&N.__esModule)return N;var F=Object.create(null);if(I.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:N}),2&A&&typeof N!="string")for(var M in N)I.d(F,M,function(p){return N[p]}.bind(null,M));return F},I.n=function(N){var A=N&&N.__esModule?function(){return N.default}:function(){return N};return I.d(A,"a",A),A},I.o=function(N,A){return Object.prototype.hasOwnProperty.call(N,A)},I.p="",I(I.s=0)}([function(ge,e,I){(function(N){var A;e=ge.exports=Ae,A=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],f=e.src=[],E=0,T=E++;f[T]="0|[1-9]\\d*";var y=E++;f[y]="[0-9]+";var u=E++;f[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=E++;f[v]="("+f[T]+")\\.("+f[T]+")\\.("+f[T]+")";var m=E++;f[m]="("+f[y]+")\\.("+f[y]+")\\.("+f[y]+")";var s=E++;f[s]="(?:"+f[T]+"|"+f[u]+")";var o=E++;f[o]="(?:"+f[y]+"|"+f[u]+")";var r=E++;f[r]="(?:-("+f[s]+"(?:\\."+f[s]+")*))";var n=E++;f[n]="(?:-?("+f[o]+"(?:\\."+f[o]+")*))";var t=E++;f[t]="[0-9A-Za-z-]+";var c=E++;f[c]="(?:\\+("+f[t]+"(?:\\."+f[t]+")*))";var l=E++,i="v?"+f[v]+f[r]+"?"+f[c]+"?";f[l]="^"+i+"$";var $="[v=\\s]*"+f[m]+f[n]+"?"+f[c]+"?",a=E++;f[a]="^"+$+"$";var b=E++;f[b]="((?:<|>)?=?)";var h=E++;f[h]=f[y]+"|x|X|\\*";var D=E++;f[D]=f[T]+"|x|X|\\*";var d=E++;f[d]="[v=\\s]*("+f[D]+")(?:\\.("+f[D]+")(?:\\.("+f[D]+")(?:"+f[r]+")?"+f[c]+"?)?)?";var k=E++;f[k]="[v=\\s]*("+f[h]+")(?:\\.("+f[h]+")(?:\\.("+f[h]+")(?:"+f[n]+")?"+f[c]+"?)?)?";var g=E++;f[g]="^"+f[b]+"\\s*"+f[d]+"$";var S=E++;f[S]="^"+f[b]+"\\s*"+f[k]+"$";var w=E++;f[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;f[C]="(?:~>?)";var P=E++;f[P]="(\\s*)"+f[C]+"\\s+",p[P]=new RegExp(f[P],"g");var W=E++;f[W]="^"+f[C]+f[d]+"$";var V=E++;f[V]="^"+f[C]+f[k]+"$";var q=E++;f[q]="(?:\\^)";var R=E++;f[R]="(\\s*)"+f[q]+"\\s+",p[R]=new RegExp(f[R],"g");var j=E++;f[j]="^"+f[q]+f[d]+"$";var K=E++;f[K]="^"+f[q]+f[k]+"$";var re=E++;f[re]="^"+f[b]+"\\s*("+$+")$|^$";var ae=E++;f[ae]="^"+f[b]+"\\s*("+i+")$|^$";var ve=E++;f[ve]="(\\s*)"+f[b]+"\\s*("+$+"|"+f[d]+")",p[ve]=new RegExp(f[ve],"g");var Ie=E++;f[Ie]="^\\s*("+f[d]+")\\s+-\\s+("+f[d]+")\\s*$";var de=E++;f[de]="^\\s*("+f[k]+")\\s+-\\s+("+f[k]+")\\s*$";var me=E++;f[me]="(<|>)?=?\\s*\\*";for(var Me=0;Me<35;Me++)A(Me,f[Me]),p[Me]||(p[Me]=new RegExp(f[Me]));function ce(z,G){if(z instanceof Ae)return z;if(typeof z!="string"||z.length>F||!(G?p[a]:p[l]).test(z))return null;try{return new Ae(z,G)}catch{return null}}function Ae(z,G){if(z instanceof Ae){if(z.loose===G)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof Ae))return new Ae(z,G);A("SemVer",z,G),this.loose=G;var H=z.trim().match(G?p[a]:p[l]);if(!H)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var ne=+ee;if(ne>=0&&ne<M)return ne}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=ce,e.valid=function(z,G){var H=ce(z,G);return H?H.version:null},e.clean=function(z,G){var H=ce(z.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Ae,Ae.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ae.prototype.toString=function(){return this.version},Ae.prototype.compare=function(z){return A("SemVer.compare",this.version,this.loose,z),z instanceof Ae||(z=new Ae(z,this.loose)),this.compareMain(z)||this.comparePre(z)},Ae.prototype.compareMain=function(z){return z instanceof Ae||(z=new Ae(z,this.loose)),L(this.major,z.major)||L(this.minor,z.minor)||L(this.patch,z.patch)},Ae.prototype.comparePre=function(z){if(z instanceof Ae||(z=new Ae(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=z.prerelease[G];if(A("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return L(H,ee)}while(++G)},Ae.prototype.inc=function(z,G){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Ae(z,H).inc(G,ee).version}catch{return null}},e.diff=function(z,G){if(Ee(z,G))return null;var H=ce(z),ee=ce(G);if(H.prerelease.length||ee.prerelease.length){for(var ne in H)if((ne==="major"||ne==="minor"||ne==="patch")&&H[ne]!==ee[ne])return"pre"+ne;return"prerelease"}for(var ne in H)if((ne==="major"||ne==="minor"||ne==="patch")&&H[ne]!==ee[ne])return ne},e.compareIdentifiers=L;var ie=/^[0-9]+$/;function L(z,G){var H=ie.test(z),ee=ie.test(G);return H&&ee&&(z=+z,G=+G),H&&!ee?-1:ee&&!H?1:z<G?-1:z>G?1:0}function x(z,G,H){return new Ae(z,H).compare(new Ae(G,H))}function be(z,G,H){return x(z,G,H)>0}function Oe(z,G,H){return x(z,G,H)<0}function Ee(z,G,H){return x(z,G,H)===0}function pe(z,G,H){return x(z,G,H)!==0}function fe(z,G,H){return x(z,G,H)>=0}function X(z,G,H){return x(z,G,H)<=0}function Z(z,G,H,ee){var ne;switch(G){case"===":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),ne=z===H;break;case"!==":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),ne=z!==H;break;case"":case"=":case"==":ne=Ee(z,H,ee);break;case"!=":ne=pe(z,H,ee);break;case">":ne=be(z,H,ee);break;case">=":ne=fe(z,H,ee);break;case"<":ne=Oe(z,H,ee);break;case"<=":ne=X(z,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return ne}function le(z,G){if(z instanceof le){if(z.loose===G)return z;z=z.value}if(!(this instanceof le))return new le(z,G);A("comparator",z,G),this.loose=G,this.parse(z),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(z,G){return L(G,z)},e.major=function(z,G){return new Ae(z,G).major},e.minor=function(z,G){return new Ae(z,G).minor},e.patch=function(z,G){return new Ae(z,G).patch},e.compare=x,e.compareLoose=function(z,G){return x(z,G,!0)},e.rcompare=function(z,G,H){return x(G,z,H)},e.sort=function(z,G){return z.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(z,G){return z.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=be,e.lt=Oe,e.eq=Ee,e.neq=pe,e.gte=fe,e.lte=X,e.cmp=Z,e.Comparator=le;var ue={};function Te(z,G){if(z instanceof Te)return z.loose===G?z:new Te(z.raw,G);if(z instanceof le)return new Te(z.value,G);if(!(this instanceof Te))return new Te(z,G);if(this.loose=G,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function he(z){return!z||z.toLowerCase()==="x"||z==="*"}function Pe(z,G,H,ee,ne,Fe,Be,Xe,_e,et,tt,it,nt){return((G=he(H)?"":he(ee)?">="+H+".0.0":he(ne)?">="+H+"."+ee+".0":">="+G)+" "+(Xe=he(_e)?"":he(et)?"<"+(+_e+1)+".0.0":he(tt)?"<"+_e+"."+(+et+1)+".0":it?"<="+_e+"."+et+"."+tt+"-"+it:"<="+Xe)).trim()}function Ne(z,G){for(var H=0;H<z.length;H++)if(!z[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<z.length;H++)if(A(z[H].semver),z[H].semver!==ue&&z[H].semver.prerelease.length>0){var ee=z[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function ze(z,G,H){try{G=new Te(G,H)}catch{return!1}return G.test(z)}function U(z,G,H,ee){var ne,Fe,Be,Xe,_e;switch(z=new Ae(z,ee),G=new Te(G,ee),H){case">":ne=be,Fe=X,Be=Oe,Xe=">",_e=">=";break;case"<":ne=Oe,Fe=fe,Be=be,Xe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(z,G,ee))return!1;for(var et=0;et<G.set.length;++et){var tt=G.set[et],it=null,nt=null;if(tt.forEach(function(at){at.semver===ue&&(at=new le(">=0.0.0")),it=it||at,nt=nt||at,ne(at.semver,it.semver,ee)?it=at:Be(at.semver,nt.semver,ee)&&(nt=at)}),it.operator===Xe||it.operator===_e||(!nt.operator||nt.operator===Xe)&&Fe(z,nt.semver)||nt.operator===_e&&Be(z,nt.semver))return!1}return!0}le.prototype.parse=function(z){var G=this.loose?p[re]:p[ae],H=z.match(G);if(!H)throw new TypeError("Invalid comparator: "+z);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Ae(H[2],this.loose):this.semver=ue},le.prototype.toString=function(){return this.value},le.prototype.test=function(z){return A("Comparator.test",z,this.loose),this.semver===ue||(typeof z=="string"&&(z=new Ae(z,this.loose)),Z(z,this.operator,this.semver,this.loose))},le.prototype.intersects=function(z,G){if(!(z instanceof le))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Te(z.value,G),ze(this.value,H,G);if(z.operator==="")return H=new Te(this.value,G),ze(z.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ne=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Fe=this.semver.version===z.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Xe=Z(this.semver,"<",z.semver,G)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),_e=Z(this.semver,">",z.semver,G)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ee||ne||Fe&&Be||Xe||_e},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(z){var G=this.loose;z=z.trim(),A("range",z,G);var H=G?p[de]:p[Ie];z=z.replace(H,Pe),A("hyphen replace",z),z=z.replace(p[ve],"$1$2$3"),A("comparator trim",z,p[ve]),z=(z=(z=z.replace(p[P],"$1~")).replace(p[R],"$1^")).split(/\s+/).join(" ");var ee=G?p[re]:p[ae],ne=z.split(" ").map(function(Fe){return function(Be,Xe){return A("comp",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){A("caret",it,nt);var at=nt?p[K]:p[j];return it.replace(at,function(mt,je,st,Y,Q){var $e;return A("caret",it,mt,je,st,Y,Q),he(je)?$e="":he(st)?$e=">="+je+".0.0 <"+(+je+1)+".0.0":he(Y)?$e=je==="0"?">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":">="+je+"."+st+".0 <"+(+je+1)+".0.0":Q?(A("replaceCaret pr",Q),Q.charAt(0)!=="-"&&(Q="-"+Q),$e=je==="0"?st==="0"?">="+je+"."+st+"."+Y+Q+" <"+je+"."+st+"."+(+Y+1):">="+je+"."+st+"."+Y+Q+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+Y+Q+" <"+(+je+1)+".0.0"):(A("no pr"),$e=je==="0"?st==="0"?">="+je+"."+st+"."+Y+" <"+je+"."+st+"."+(+Y+1):">="+je+"."+st+"."+Y+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+Y+" <"+(+je+1)+".0.0"),A("caret return",$e),$e})}(tt,et)}).join(" ")}(Be,Xe),A("caret",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){var at=nt?p[V]:p[W];return it.replace(at,function(mt,je,st,Y,Q){var $e;return A("tilde",it,mt,je,st,Y,Q),he(je)?$e="":he(st)?$e=">="+je+".0.0 <"+(+je+1)+".0.0":he(Y)?$e=">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":Q?(A("replaceTilde pr",Q),Q.charAt(0)!=="-"&&(Q="-"+Q),$e=">="+je+"."+st+"."+Y+Q+" <"+je+"."+(+st+1)+".0"):$e=">="+je+"."+st+"."+Y+" <"+je+"."+(+st+1)+".0",A("tilde return",$e),$e})}(tt,et)}).join(" ")}(Be,Xe),A("tildes",Be),Be=function(_e,et){return A("replaceXRanges",_e,et),_e.split(/\s+/).map(function(tt){return function(it,nt){it=it.trim();var at=nt?p[S]:p[g];return it.replace(at,function(mt,je,st,Y,Q,$e){A("xRange",it,mt,je,st,Y,Q,$e);var He=he(st),ye=He||he(Y),ot=ye||he(Q);return je==="="&&ot&&(je=""),He?mt=je===">"||je==="<"?"<0.0.0":"*":je&&ot?(ye&&(Y=0),ot&&(Q=0),je===">"?(je=">=",ye?(st=+st+1,Y=0,Q=0):ot&&(Y=+Y+1,Q=0)):je==="<="&&(je="<",ye?st=+st+1:Y=+Y+1),mt=je+st+"."+Y+"."+Q):ye?mt=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(mt=">="+st+"."+Y+".0 <"+st+"."+(+Y+1)+".0"),A("xRange return",mt),mt})}(tt,et)}).join(" ")}(Be,Xe),A("xrange",Be),Be=function(_e,et){return A("replaceStars",_e,et),_e.trim().replace(p[me],"")}(Be,Xe),A("stars",Be),Be}(Fe,G)}).join(" ").split(/\s+/);return this.loose&&(ne=ne.filter(function(Fe){return!!Fe.match(ee)})),ne=ne.map(function(Fe){return new le(Fe,G)})},Te.prototype.intersects=function(z,G){if(!(z instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return z.set.some(function(ne){return ne.every(function(Fe){return ee.intersects(Fe,G)})})})})},e.toComparators=function(z,G){return new Te(z,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new Ae(z,this.loose));for(var G=0;G<this.set.length;G++)if(Ne(this.set[G],z))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(z,G,H){var ee=null,ne=null;try{var Fe=new Te(G,H)}catch{return null}return z.forEach(function(Be){Fe.test(Be)&&(ee&&ne.compare(Be)!==-1||(ne=new Ae(ee=Be,H)))}),ee},e.minSatisfying=function(z,G,H){var ee=null,ne=null;try{var Fe=new Te(G,H)}catch{return null}return z.forEach(function(Be){Fe.test(Be)&&(ee&&ne.compare(Be)!==1||(ne=new Ae(ee=Be,H)))}),ee},e.validRange=function(z,G){try{return new Te(z,G).range||"*"}catch{return null}},e.ltr=function(z,G,H){return U(z,G,"<",H)},e.gtr=function(z,G,H){return U(z,G,">",H)},e.outside=U,e.prerelease=function(z,G){var H=ce(z,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(z,G,H){return z=new Te(z,H),G=new Te(G,H),z.intersects(G)},e.coerce=function(z){if(z instanceof Ae)return z;if(typeof z!="string")return null;var G=z.match(p[w]);return G==null?null:ce((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,I(1))},function(ge,e){var I,N,A=ge.exports={};function F(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function p(o){if(I===setTimeout)return setTimeout(o,0);if((I===F||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:F}catch{I=F}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var f,E=[],T=!1,y=-1;function u(){T&&f&&(T=!1,f.length?E=f.concat(E):y=-1,E.length&&v())}function v(){if(!T){var o=p(u);T=!0;for(var r=E.length;r;){for(f=E,E=[];++y<r;)f&&f[y].run();y=-1,r=E.length}f=null,T=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(o)}}function m(o,r){this.fun=o,this.array=r}function s(){}A.nextTick=function(o){var r=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)r[n-1]=arguments[n];E.push(new m(o,r)),E.length!==1||T||p(v)},m.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=s,A.addListener=s,A.once=s,A.off=s,A.removeListener=s,A.removeAllListeners=s,A.emit=s,A.prependListener=s,A.prependOnceListener=s,A.listeners=function(o){return[]},A.binding=function(o){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(o){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Ce[128],Re([1,0,14,6]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=A,e.$oe=F,e.$pe=M,e.$qe=p,e.$re=E,e.$se=T,e.$te=y,e.$ue=u,e.$ve=v,e.$we=m,e.$xe=s,e.$ye=o,e.$ze=r,e.$Ae=n,e.$Be=t;function A(c){const l=c;return l?typeof l.read=="function":!1}function F(c){const l=c;return l?[l.on,l.pause,l.resume,l.destroy].every(i=>typeof i=="function"):!1}function M(c){const l=c;return l?F(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}function p(c,l){return new f(c,l)}class f{constructor(l,i){this.e=l,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(i=>i(l))}h(l){this.c.error.length===0?(0,I.$1)(l):this.c.error.slice(0).forEach(i=>i(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,i){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(l,i){if(this.a.destroyed)return;let $;switch(l){case"data":$=this.c.data;break;case"end":$=this.c.end;break;case"error":$=this.c.error;break}if($){const a=$.indexOf(i);a>=0&&$.splice(a,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach($=>$())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,l){const i=[];let $;for(;($=c.read())!==null;)i.push($);return l(i)}function T(c,l,i){const $=[];let a;for(;(a=c.read())!==null&&$.length<i;)$.push(a);return a===null&&$.length>0?l($):{read:()=>{if($.length>0)return $.shift();if(typeof a<"u"){const b=a;return a=void 0,b}return c.read()}}}function y(c,l){return new Promise((i,$)=>{const a=[];u(c,{onData:b=>{l&&a.push(b)},onError:b=>{l?$(b):i(void 0)},onEnd:()=>{i(l?l(a):void 0)}})})}function u(c,l,i){c.on("error",$=>{i?.isCancellationRequested||l.onError($)}),c.on("end",()=>{i?.isCancellationRequested||l.onEnd()}),c.on("data",$=>{i?.isCancellationRequested||l.onData($)})}function v(c,l){return new Promise((i,$)=>{const a=new N.$Tc,b=[],h=k=>{if(b.push(k),b.length>l)return a.dispose(),c.pause(),i({stream:c,buffer:b,ended:!1})},D=k=>(a.dispose(),$(k)),d=()=>(a.dispose(),i({stream:c,buffer:b,ended:!0}));a.add((0,N.$Sc)(()=>c.removeListener("error",D))),c.on("error",D),a.add((0,N.$Sc)(()=>c.removeListener("end",d))),c.on("end",d),a.add((0,N.$Sc)(()=>c.removeListener("data",h))),c.on("data",h)})}function m(c,l){const i=p(l);return i.end(c),i}function s(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}function o(c){let l=!1;return{read:()=>l?null:(l=!0,c)}}function r(c,l,i){const $=p(i);return u(c,{onData:a=>$.write(l.data(a)),onError:a=>$.error(l.error?l.error(a):a),onEnd:()=>$.end()}),$}function n(c,l,i){let $=!1;return{read:()=>{const a=l.read();return $?a:($=!0,a!==null?i([c,a]):c)}}}function t(c,l,i){let $=!1;const a=p(i);return u(l,{onData:b=>$?a.write(b):($=!0,a.write(i([c,b]))),onError:b=>a.error(b),onEnd:()=>{$||($=!0,a.write(c)),a.end()}}),a}}),define(Ce[22],Re([1,0,41,128]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=E,e.$Ee=T,e.$Fe=y,e.$Ge=u,e.$He=v,e.$Ie=m,e.$Je=s,e.$Ke=o,e.$Le=r,e.$Me=n,e.$Ne=t,e.$Oe=c,e.$Pe=l,e.$Qe=i,e.$Re=$,e.$Se=a,e.$Te=b,e.$Ue=h,e.$Ve=D,e.$We=g;const A=typeof Buffer<"u",F=new I.$V(()=>new Uint8Array(256));let M,p;class f{static alloc(w){return A?new f(Buffer.allocUnsafe(w)):new f(new Uint8Array(w))}static wrap(w){return A&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new f(w)}static fromString(w,C){return!(C?.dontUseNodeBuffer||!1)&&A?new f(Buffer.from(w)):(M||(M=new TextEncoder),new f(M.encode(w)))}static fromByteArray(w){const C=f.alloc(w.length);for(let P=0,W=w.length;P<W;P++)C.buffer[P]=w[P];return C}static concat(w,C){if(typeof C>"u"){C=0;for(let V=0,q=w.length;V<q;V++)C+=w[V].byteLength}const P=f.alloc(C);let W=0;for(let V=0,q=w.length;V<q;V++){const R=w[V];P.set(R,W),W+=R.byteLength}return P}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=f.alloc(this.byteLength);return w.set(this),w}toString(){return A?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(w,C){return new f(this.buffer.subarray(w,C))}set(w,C){if(w instanceof f)this.buffer.set(w.buffer,C);else if(w instanceof Uint8Array)this.buffer.set(w,C);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),C);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return u(this.buffer,w)}writeUInt32BE(w,C){v(this.buffer,w,C)}readUInt32LE(w){return m(this.buffer,w)}writeUInt32LE(w,C){s(this.buffer,w,C)}readUInt8(w){return o(this.buffer,w)}writeUInt8(w,C){r(this.buffer,w,C)}indexOf(w,C=0){return E(this.buffer,w instanceof f?w.buffer:w,C)}}e.$Ce=f;function E(S,w,C=0){const P=w.byteLength,W=S.byteLength;if(P===0)return 0;if(P===1)return S.indexOf(w[0]);if(P>W-C)return-1;const V=F.value;V.fill(w.length);for(let K=0;K<w.length;K++)V[w[K]]=w.length-K-1;let q=C+w.length-1,R=q,j=-1;for(;q<W;)if(S[q]===w[R]){if(R===0){j=q;break}q--,R--}else q+=Math.max(w.length-R,V[S[q]]),R=w.length-1;return j}function T(S,w){return S[w+0]<<0>>>0|S[w+1]<<8>>>0}function y(S,w,C){S[C+0]=w&255,w=w>>>8,S[C+1]=w&255}function u(S,w){return S[w]*2**24+S[w+1]*2**16+S[w+2]*2**8+S[w+3]}function v(S,w,C){S[C+3]=w,w=w>>>8,S[C+2]=w,w=w>>>8,S[C+1]=w,w=w>>>8,S[C]=w}function m(S,w){return S[w+0]<<0>>>0|S[w+1]<<8>>>0|S[w+2]<<16>>>0|S[w+3]<<24>>>0}function s(S,w,C){S[C+0]=w&255,w=w>>>8,S[C+1]=w&255,w=w>>>8,S[C+2]=w&255,w=w>>>8,S[C+3]=w&255}function o(S,w){return S[w]}function r(S,w,C){S[C]=w}function n(S){return N.$re(S,w=>f.concat(w))}function t(S){return N.$ye(S)}function c(S){return N.$te(S,w=>f.concat(w))}async function l(S){return S.ended?f.concat(S.buffer):f.concat([...S.buffer,await c(S.stream)])}function i(S){return N.$we(S,w=>f.concat(w))}function $(S){return N.$ze(S,{data:w=>typeof w=="string"?f.fromString(w):f.wrap(w)},w=>f.concat(w))}function a(S){return N.$qe(w=>f.concat(w),S)}function b(S,w){return N.$Ae(S,w,C=>f.concat(C))}function h(S,w){return N.$Be(S,w,C=>f.concat(C))}function D(S){let w=0,C=0,P=0;const W=new Uint8Array(Math.floor(S.length/4*3)),V=R=>{switch(C){case 3:W[P++]=w|R,C=0;break;case 2:W[P++]=w|R>>>2,w=R<<6,C=3;break;case 1:W[P++]=w|R>>>4,w=R<<4,C=2;break;default:w=R<<2,C=1}};for(let R=0;R<S.length;R++){const j=S.charCodeAt(R);if(j>=65&&j<=90)V(j-65);else if(j>=97&&j<=122)V(j-97+26);else if(j>=48&&j<=57)V(j-48+52);else if(j===43||j===45)V(62);else if(j===47||j===95)V(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${S[R]}`)}}const q=P;for(;C>0;)V(0);return f.wrap(W).slice(0,q)}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:S},w=!0,C=!1){const P=C?k:d;let W="";const V=S.byteLength%3;let q=0;for(;q<S.byteLength-V;q+=3){const R=S[q+0],j=S[q+1],K=S[q+2];W+=P[R>>>2],W+=P[(R<<4|j>>>4)&63],W+=P[(j<<2|K>>>6)&63],W+=P[K&63]}if(V===1){const R=S[q+0];W+=P[R>>>2],W+=P[R<<4&63],w&&(W+="==")}else if(V===2){const R=S[q+0],j=S[q+1];W+=P[R>>>2],W+=P[(R<<4|j>>>4)&63],W+=P[j<<2&63],w&&(W+="=")}return W}}),define(Ce[129],Re([1,0,28,125,15]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.FuzzyScore=e.$tk=e.$sk=void 0,e.or=F,e.$uk=p,e.$vk=f,e.$wk=y,e.$xk=D,e.$yk=d,e.$zk=P,e.$Ak=W,e.$Bk=V,e.$Ck=q,e.$Dk=x,e.$Fk=pe,e.$Gk=Z,e.$Hk=le;function F(...he){return function(Pe,Ne){for(let ze=0,U=he.length;ze<U;ze++){const z=he[ze](Pe,Ne);if(z)return z}return null}}e.$sk=M.bind(void 0,!1),e.$tk=M.bind(void 0,!0);function M(he,Pe,Ne){if(!Ne||Ne.length<Pe.length)return null;let ze;return he?ze=A.$vf(Ne,Pe):ze=Ne.indexOf(Pe)===0,ze?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(he,Pe){const Ne=Pe.toLowerCase().indexOf(he.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+he.length}]}function f(he,Pe){return E(he.toLowerCase(),Pe.toLowerCase(),0,0)}function E(he,Pe,Ne,ze){if(Ne===he.length)return[];if(ze===Pe.length)return null;if(he[Ne]===Pe[ze]){let U=null;return(U=E(he,Pe,Ne+1,ze+1))?c({start:ze,end:ze+1},U):null}return E(he,Pe,Ne,ze+1)}function T(he){return 97<=he&&he<=122}function y(he){return 65<=he&&he<=90}function u(he){return 48<=he&&he<=57}function v(he){return he===32||he===9||he===10||he===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(he=>m.add(he.charCodeAt(0)));function s(he){return v(he)||m.has(he)}function o(he,Pe){return he===Pe||s(he)&&s(Pe)}const r=new Map;function n(he){if(r.has(he))return r.get(he);let Pe;const Ne=(0,N.$qk)(he);return Ne&&(Pe=Ne),r.set(he,Pe),Pe}function t(he){return T(he)||y(he)||u(he)}function c(he,Pe){return Pe.length===0?Pe=[he]:he.end===Pe[0].start?Pe[0].start=he.start:Pe.unshift(he),Pe}function l(he,Pe){for(let Ne=Pe;Ne<he.length;Ne++){const ze=he.charCodeAt(Ne);if(y(ze)||u(ze)||Ne>0&&!t(he.charCodeAt(Ne-1)))return Ne}return he.length}function i(he,Pe,Ne,ze){if(Ne===he.length)return[];if(ze===Pe.length)return null;if(he[Ne]!==Pe[ze].toLowerCase())return null;{let U=null,z=ze+1;for(U=i(he,Pe,Ne+1,ze+1);!U&&(z=l(Pe,z))<Pe.length;)U=i(he,Pe,Ne+1,z),z++;return U===null?null:c({start:ze,end:ze+1},U)}}function $(he){let Pe=0,Ne=0,ze=0,U=0,z=0;for(let Fe=0;Fe<he.length;Fe++)z=he.charCodeAt(Fe),y(z)&&Pe++,T(z)&&Ne++,t(z)&&ze++,u(z)&&U++;const G=Pe/he.length,H=Ne/he.length,ee=ze/he.length,ne=U/he.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:ne}}function a(he){const{upperPercent:Pe,lowerPercent:Ne}=he;return Ne===0&&Pe>.6}function b(he){const{upperPercent:Pe,lowerPercent:Ne,alphaPercent:ze,numericPercent:U}=he;return Ne>.2&&Pe<.8&&ze>.6&&U<.2}function h(he){let Pe=0,Ne=0,ze=0,U=0;for(let z=0;z<he.length;z++)ze=he.charCodeAt(z),y(ze)&&Pe++,T(ze)&&Ne++,v(ze)&&U++;return(Pe===0||Ne===0)&&U===0?he.length<=30:Pe<=5}function D(he,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!h(he))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Ne=$(Pe);if(!b(Ne)){if(!a(Ne))return null;Pe=Pe.toLowerCase()}let ze=null,U=0;for(he=he.toLowerCase();U<Pe.length&&(ze=i(he,Pe,0,U))===null;)U=l(Pe,U+1);return ze}function d(he,Pe,Ne=!1){if(!Pe||Pe.length===0)return null;let ze=null,U=0;for(he=he.toLowerCase(),Pe=Pe.toLowerCase();U<Pe.length&&(ze=k(he,Pe,0,U,Ne),ze===null);)U=g(Pe,U+1);return ze}function k(he,Pe,Ne,ze,U){let z=0;if(Ne===he.length)return[];if(ze===Pe.length)return null;if(!o(he.charCodeAt(Ne),Pe.charCodeAt(ze))){const ee=n(he.charCodeAt(Ne));if(!ee)return null;for(let ne=0;ne<ee.length;ne++)if(!o(ee[ne],Pe.charCodeAt(ze+ne)))return null;z+=ee.length-1}let G=null,H=ze+z+1;if(G=k(he,Pe,Ne+1,H,U),!U)for(;!G&&(H=g(Pe,H))<Pe.length;)G=k(he,Pe,Ne+1,H,U),H++;if(!G)return null;if(he.charCodeAt(Ne)!==Pe.charCodeAt(ze)){const ee=n(he.charCodeAt(Ne));if(!ee)return G;for(let ne=0;ne<ee.length;ne++)if(ee[ne]!==Pe.charCodeAt(ze+ne))return G}return c({start:ze,end:ze+z+1},G)}function g(he,Pe){for(let Ne=Pe;Ne<he.length;Ne++)if(s(he.charCodeAt(Ne))||Ne>0&&s(he.charCodeAt(Ne-1)))return Ne;return he.length}const S=F(e.$tk,D,p),w=F(e.$tk,D,f),C=new I.$Ec(1e4);function P(he,Pe,Ne=!1){if(typeof he!="string"||typeof Pe!="string")return null;let ze=C.get(he);ze||(ze=new RegExp(A.$df(he),"i"),C.set(he,ze));const U=ze.exec(Pe);return U?[{start:U.index,end:U.index+U[0].length}]:Ne?w(he,Pe):S(he,Pe)}function W(he,Pe){const Ne=pe(he,he.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?q(Ne):null}function V(he,Pe,Ne,ze,U,z){const G=Math.min(13,he.length);for(;Ne<G;Ne++){const H=pe(he,Pe,Ne,ze,U,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,z]}function q(he){if(typeof he>"u")return[];const Pe=[],Ne=he[1];for(let ze=he.length-1;ze>1;ze--){const U=he[ze]+Ne,z=Pe[Pe.length-1];z&&z.end===U?z.end=U+1:Pe.push({start:U,end:U+1})}return Pe}const R=128;function j(){const he=[],Pe=[];for(let Ne=0;Ne<=R;Ne++)Pe[Ne]=0;for(let Ne=0;Ne<=R;Ne++)he.push(Pe.slice(0));return he}function K(he){const Pe=[];for(let Ne=0;Ne<=he;Ne++)Pe[Ne]=0;return Pe}const re=K(2*R),ae=K(2*R),ve=j(),Ie=j(),de=j(),me=!1;function Me(he,Pe,Ne,ze,U){function z(H,ee,ne=" "){for(;H.length<ee;)H=ne+H;return H}let G=` |   |${ze.split("").map(H=>z(H,3)).join("|")}
`;for(let H=0;H<=Ne;H++)H===0?G+=" |":G+=`${Pe[H-1]}|`,G+=he[H].slice(0,U+1).map(ee=>z(ee.toString(),3)).join("|")+`
`;return G}function ce(he,Pe,Ne,ze){he=he.substr(Pe),Ne=Ne.substr(ze),console.log(Me(Ie,he,he.length,Ne,Ne.length)),console.log(Me(de,he,he.length,Ne,Ne.length)),console.log(Me(ve,he,he.length,Ne,Ne.length))}function Ae(he,Pe){if(Pe<0||Pe>=he.length)return!1;const Ne=he.codePointAt(Pe);switch(Ne){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.$Nf(Ne)}}function ie(he,Pe){if(Pe<0||Pe>=he.length)return!1;switch(he.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function L(he,Pe,Ne){return Pe[he]!==Ne[he]}function x(he,Pe,Ne,ze,U,z,G=!1){for(;Pe<Ne&&U<z;)he[Pe]===ze[U]&&(G&&(re[Pe]=U),Pe+=1),U+=1;return Pe===Ne}var be;(function(he){he[he.Diag=1]="Diag",he[he.Left=2]="Left",he[he.LeftLeft=3]="LeftLeft"})(be||(be={}));var Oe;(function(he){he.Default=[-100,0];function Pe(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}he.isDefault=Pe})(Oe||(e.FuzzyScore=Oe={}));class Ee{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Ne){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Ne}}e.$Ek=Ee;function pe(he,Pe,Ne,ze,U,z,G=Ee.default){const H=he.length>R?R:he.length,ee=ze.length>R?R:ze.length;if(Ne>=H||z>=ee||H-Ne>ee-z||!x(Pe,Ne,H,U,z,ee,!0))return;fe(H,ee,Ne,z,Pe,U);let ne=1,Fe=1,Be=Ne,Xe=z;const _e=[!1];for(ne=1,Be=Ne;Be<H;ne++,Be++){const at=re[Be],mt=ae[Be],je=Be+1<H?ae[Be+1]:ee;for(Fe=at-z+1,Xe=at;Xe<je;Fe++,Xe++){let st=Number.MIN_SAFE_INTEGER,Y=!1;Xe<=mt&&(st=X(he,Pe,Be,Ne,ze,U,Xe,ee,z,ve[ne-1][Fe-1]===0,_e));let Q=0;st!==Number.MAX_SAFE_INTEGER&&(Y=!0,Q=st+Ie[ne-1][Fe-1]);const $e=Xe>at,He=$e?Ie[ne][Fe-1]+(ve[ne][Fe-1]>0?-5:0):0,ye=Xe>at+1&&ve[ne][Fe-1]>0,ot=ye?Ie[ne][Fe-2]+(ve[ne][Fe-2]>0?-5:0):0;if(ye&&(!$e||ot>=He)&&(!Y||ot>=Q))Ie[ne][Fe]=ot,de[ne][Fe]=3,ve[ne][Fe]=0;else if($e&&(!Y||He>=Q))Ie[ne][Fe]=He,de[ne][Fe]=2,ve[ne][Fe]=0;else if(Y)Ie[ne][Fe]=Q,de[ne][Fe]=1,ve[ne][Fe]=ve[ne-1][Fe-1]+1;else throw new Error("not possible")}}if(me&&ce(he,Ne,ze,z),!_e[0]&&!G.firstMatchCanBeWeak)return;ne--,Fe--;const et=[Ie[ne][Fe],z];let tt=0,it=0;for(;ne>=1;){let at=Fe;do{const mt=de[ne][at];if(mt===3)at=at-2;else if(mt===2)at=at-1;else break}while(at>=1);tt>1&&Pe[Ne+ne-1]===U[z+Fe-1]&&!L(at+z-1,ze,U)&&tt+1>ve[ne][at]&&(at=Fe),at===Fe?tt++:tt=1,it||(it=at),ne--,Fe=at-1,et.push(Fe)}ee===H&&G.boostFullMatch&&(et[0]+=2);const nt=it-H;return et[0]-=nt,et}function fe(he,Pe,Ne,ze,U,z){let G=he-1,H=Pe-1;for(;G>=Ne&&H>=ze;)U[G]===z[H]&&(ae[G]=H,G--),H--}function X(he,Pe,Ne,ze,U,z,G,H,ee,ne,Fe){if(Pe[Ne]!==z[G])return Number.MIN_SAFE_INTEGER;let Be=1,Xe=!1;return G===Ne-ze?Be=he[Ne]===U[G]?7:5:L(G,U,z)&&(G===0||!L(G-1,U,z))?(Be=he[Ne]===U[G]?7:5,Xe=!0):Ae(z,G)&&(G===0||!Ae(z,G-1))?Be=5:(Ae(z,G-1)||ie(z,G-1))&&(Be=5,Xe=!0),Be>1&&Ne===ze&&(Fe[0]=!0),Xe||(Xe=L(G,U,z)||Ae(z,G-1)||ie(z,G-1)),Ne===ze?G>ee&&(Be-=Xe?3:5):ne?Be+=Xe?2:0:Be+=Xe?0:1,G+1===H&&(Be-=Xe?3:5),Be}function Z(he,Pe,Ne,ze,U,z,G){return ue(he,Pe,Ne,ze,U,z,!0,G)}function le(he,Pe,Ne,ze,U,z,G){return ue(he,Pe,Ne,ze,U,z,!1,G)}function ue(he,Pe,Ne,ze,U,z,G,H){let ee=pe(he,Pe,Ne,ze,U,z,H);if(ee&&!G)return ee;if(he.length>=3){const ne=Math.min(7,he.length-1);for(let Fe=Ne+1;Fe<ne;Fe++){const Be=Te(he,Fe);if(Be){const Xe=pe(Be,Be.toLowerCase(),Ne,ze,U,z,H);Xe&&(Xe[0]-=3,(!ee||Xe[0]>ee[0])&&(ee=Xe))}}}return ee}function Te(he,Pe){if(Pe+1>=he.length)return;const Ne=he[Pe],ze=he[Pe+1];if(Ne!==ze)return he.slice(0,Pe)+ze+Ne+he.slice(Pe+2)}}),define(Ce[33],Re([1,0,15]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(N||(N={})),function(A){const F="error",M="warning",p="warn",f="info",E="ignore";function T(u){return u?I.$uf(F,u)?A.Error:I.$uf(M,u)||I.$uf(p,u)?A.Warning:I.$uf(f,u)?A.Info:A.Ignore:A.Ignore}A.fromValue=T;function y(u){switch(u){case A.Error:return F;case A.Warning:return M;case A.Info:return f;default:return E}}A.toString=y}(N||(N={})),e.default=N}),define(Ce[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(Ce[52],Re([1,0,18,15]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=void 0;class A{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const m=v.charCodeAt(0),s=this.b.charCodeAt(this.c);return m-s}value(){return this.b[this.c]}}e.$ti=A;class F{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,N.$of)(v,this.b,0,v.length,this.c,this.d):(0,N.$qf)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ui=F;class M{constructor(v=!0,m=!0){this.f=v,this.g=m}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let m=v.length-1;m>=0;m--,this.c--){const s=this.b.charCodeAt(m);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,N.$of)(v,this.b,0,v.length,this.d,this.e):(0,N.$qf)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$vi=M;var p;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(p||(p={}));class f{constructor(v,m){this.f=v,this.g=m,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,N.$pf)(v,this.c.scheme);if(this.d[this.e]===2)return(0,N.$pf)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,N.$nf)(v,this.c.query);if(this.d[this.e]===5)return(0,N.$nf)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$wi=f;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(T||(T={}));class y{static forUris(v=()=>!1,m=()=>!1){return new y(new f(v,m))}static forPaths(v=!1){return new y(new M(void 0,!v))}static forStrings(){return new y(new A)}static forConfigKeys(){return new y(new F)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,m){if(m){const s=m.slice(0);(0,I.$Xb)(s);for(const o of s)this.set(o,v)}else{const s=v.slice(0);(0,I.$Xb)(s);for(const o of s)this.set(o[0],o[1])}}set(v,m){const s=this.b.reset(v);let o;this.c||(this.c=new E,this.c.segment=s.value());const r=[];for(o=this.c;;){const t=s.cmp(o.segment);if(t>0)o.left||(o.left=new E,o.left.segment=s.value()),r.push([-1,o]),o=o.left;else if(t<0)o.right||(o.right=new E,o.right.segment=s.value()),r.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new E,o.mid.segment=s.value()),r.push([0,o]),o=o.mid;else break}const n=o.value;o.value=m,o.key=v;for(let t=r.length-1;t>=0;t--){const c=r[t][1];c.updateHeight();const l=c.balanceFactor();if(l<-1||l>1){const i=r[t][0],$=r[t+1][0];if(i===1&&$===1)r[t][1]=c.rotateLeft();else if(i===-1&&$===-1)r[t][1]=c.rotateRight();else if(i===1&&$===-1)c.right=r[t+1][1]=r[t+1][1].rotateRight(),r[t][1]=c.rotateLeft();else if(i===-1&&$===1)c.left=r[t+1][1]=r[t+1][1].rotateLeft(),r[t][1]=c.rotateRight();else throw new Error;if(t>0)switch(r[t-1][0]){case-1:r[t-1][1].left=r[t][1];break;case 1:r[t-1][1].right=r[t][1];break;case 0:r[t-1][1].mid=r[t][1];break}else this.c=r[0][1]}}return n}get(v){return this.d(v)?.value}d(v){const m=this.b.reset(v);let s=this.c;for(;s;){const o=m.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(m.hasNext())m.next(),s=s.mid;else break}return s}has(v){const m=this.d(v);return!(m?.value===void 0&&m?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,m){const s=this.b.reset(v),o=[];let r=this.c;for(;r;){const n=s.cmp(r.segment);if(n>0)o.push([-1,r]),r=r.left;else if(n<0)o.push([1,r]),r=r.right;else if(s.hasNext())s.next(),o.push([0,r]),r=r.mid;else break}if(r){if(m?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const n=this.f(r.right);if(n.key){const{key:t,value:c,segment:l}=n;this.e(n.key,!1),r.key=t,r.value=c,r.segment=l}}else{const n=r.left??r.right;if(o.length>0){const[t,c]=o[o.length-1];switch(t){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const t=o[n][1];t.updateHeight();const c=t.balanceFactor();if(c>1?(t.right.balanceFactor()>=0||(t.right=t.right.rotateRight()),o[n][1]=t.rotateLeft()):c<-1&&(t.left.balanceFactor()<=0||(t.left=t.left.rotateLeft()),o[n][1]=t.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const m=this.b.reset(v);let s=this.c,o;for(;s;){const r=m.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(m.hasNext())m.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(v){return this.g(v,!1)}g(v,m){const s=this.b.reset(v);let o=this.c;for(;o;){const r=s.cmp(o.segment);if(r>0)o=o.left;else if(r<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[m,s]of this)v(s,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const m=[];return this.j(v,m),m[Symbol.iterator]()}j(v,m){v&&(v.left&&this.j(v.left,m),v.value&&m.push([v.key,v.value]),v.mid&&this.j(v.mid,m),v.right&&this.j(v.right,m))}_isBalanced(){const v=m=>{if(!m)return!0;const s=m.balanceFactor();return s<-1||s>1?!1:v(m.left)&&v(m.right)};return v(this.c)}}e.$xi=y}),define(Ce[42],Re([1,0,91]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Rj=A;var N;(function(M){function p(f){return f&&typeof f=="object"&&typeof f.id=="string"}M.isThemeColor=p})(N||(e.ThemeColor=N={}));function A(M){return{id:M}}var F;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function f(n){const t=p.exec(n.id);if(!t)return f(I.$Qj.error);const[,c,l]=t,i=["codicon","codicon-"+c];return l&&i.push("codicon-modifier-"+l.substring(1)),i}M.asClassNameArray=f;function E(n){return f(n).join(" ")}M.asClassName=E;function T(n){return"."+f(n).join(".")}M.asCSSSelector=T;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}M.isThemeIcon=y;const u=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function v(n){const t=u.exec(n);if(!t)return;const[,c]=t;return{id:c}}M.fromString=v;function m(n){return{id:n}}M.fromId=m;function s(n,t){let c=n.id;const l=c.lastIndexOf("~");return l!==-1&&(c=c.substring(0,l)),t&&(c=`${c}~${t}`),{id:c}}M.modify=s;function o(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}M.getModifier=o;function r(n,t){return n.id===t.id&&n.color?.id===t.color?.id}M.isEqual=r})(F||(e.ThemeIcon=F={}))}),define(Ce[131],Re([1,0,129,15,42]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=f,e.$Jk=T,e.$Kk=u,e.$Lk=v,e.$Mk=s,e.$Nk=o;const F="$(",M=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${M.source}`,"g");function f(r){return r.replace(p,(n,t)=>t?n:`\\${n}`)}const E=new RegExp(`\\\\${M.source}`,"g");function T(r){return r.replace(E,n=>`\\${n}`)}const y=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function u(r){return r.indexOf(F)===-1?r:r.replace(y,(n,t,c,l)=>c?n:t||l||"")}function v(r){return r?r.replace(/\$\((.*?)\)/g,(n,t)=>` ${t} `).trim():""}const m=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(r){m.lastIndex=0;let n="";const t=[];let c=0;for(;;){const l=m.lastIndex,i=m.exec(r),$=r.substring(l,i?.index);if($.length>0){n+=$;for(let a=0;a<$.length;a++)t.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:t}}function o(r,n,t=!1){const{text:c,iconOffsets:l}=n;if(!l||l.length===0)return(0,I.$zk)(r,c,t);const i=(0,N.$bf)(c," "),$=c.length-i.length,a=(0,I.$zk)(r,i,t);if(a)for(const b of a){const h=l[b.start+$]+$;b.start+=h,b.end+=h}return a}}),define(Ce[35],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=void 0,e.$Mg=N;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(A){return I.test(A)}e.$Ng=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(p){for(let f=0;f<p.length;f++)p[f]=Math.floor(Math.random()*256);return p};const F=new Uint8Array(16),M=[];for(let p=0;p<256;p++)M.push(p.toString(16).padStart(2,"0"));return function(){A(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let f=0,E="";return E+=M[F[f++]],E+=M[F[f++]],E+=M[F[f++]],E+=M[F[f++]],E+="-",E+=M[F[f++]],E+=M[F[f++]],E+="-",E+=M[F[f++]],E+=M[F[f++]],E+="-",E+=M[F[f++]],E+=M[F[f++]],E+="-",E+=M[F[f++]],E+=M[F[f++]],E+=M[F[f++]],E+=M[F[f++]],E+=M[F[f++]],E+=M[F[f++]],E}}()}),define(Ce[132],Re([1,0,18,40,35]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=e.$Lt=void 0,e.$Jt=F,e.$Kt=M,e.$Mt=E;function F(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function M(y,u,v){const m={id:(0,A.$Ng)(),name:y,uri:u,data:v};return{asString:async()=>"",asFile:()=>m,value:void 0}}class p{constructor(){this.a=new Map}get size(){let u=0;for(const v of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const v=[...this.a.keys()];return N.Iterable.some(this,([m,s])=>s.asFile())&&v.push("files"),T(f(u),v)}get(u){return this.a.get(this.b(u))?.[0]}append(u,v){const m=this.a.get(u);m?m.push(v):this.a.set(this.b(u),[v])}replace(u,v){this.a.set(this.b(u),[v])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,v]of this.a)for(const m of v)yield[u,m]}b(u){return f(u)}}e.$Lt=p;function f(y){return y.toLowerCase()}function E(y,u){return T(f(y),u.map(f))}function T(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const v=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[m,s,o]=v;return o==="*"?u.some(r=>r.startsWith(s+"/")):!1}e.$Nt=Object.freeze({create:y=>(0,I.$Mb)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Nt.split(y).filter(u=>!u.startsWith("#"))})}),define(Ce[133],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Qt=N;var I;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function N(A){let F=0,M=0,p=0,f=0;for(let E=0,T=A.length;E<T;E++){const y=A.charCodeAt(E);y===13?(F===0&&(M=E),F++,E+1<T&&A.charCodeAt(E+1)===10?(f|=2,E++):f|=3,p=E+1):y===10&&(f|=1,F===0&&(M=E),F++,p=E+1)}return F===0&&(M=A.length),[F,M,A.length-p,f]}}),define(Ce[134],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0,e.$Xs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[135],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=e.$du=e.IndentAction=void 0;var I;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class N{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let f=0,E=p.notIn.length;f<E;f++)switch(p.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,f){if(p.getTokenCount()===0)return!0;const E=p.findTokenIndexAtOffset(f-2),T=p.getStandardTokenType(E);return this.isOK(T)}g(p,f){for(let E=p;E<=f;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$du=N;class A{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of p)F(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),F(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),F(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),F(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&F(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$eu=A;function F(M,p,f){M.has(p)?M.get(p).push(f):M.set(p,[f])}}),define(Ce[136],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tC=e.NodeColor=e.$sC=void 0,e.$uC=A,e.$vC=F,e.$wC=E,e.$xC=T,e.$yC=y,e.$zC=u,e.$AC=v,e.$BC=m;class I{constructor(o,r){this.piece=o,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$tC)return A(this.right);let o=this;for(;o.parent!==e.$tC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$tC?e.$tC:o.parent}prev(){if(this.left!==e.$tC)return F(this.left);let o=this;for(;o.parent!==e.$tC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$tC?e.$tC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$sC=I;var N;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$tC=new I(null,0),e.$tC.parent=e.$tC,e.$tC.left=e.$tC,e.$tC.right=e.$tC,e.$tC.color=0;function A(s){for(;s.left!==e.$tC;)s=s.left;return s}function F(s){for(;s.right!==e.$tC;)s=s.right;return s}function M(s){return s===e.$tC?0:s.size_left+s.piece.length+M(s.right)}function p(s){return s===e.$tC?0:s.lf_left+s.piece.lineFeedCnt+p(s.right)}function f(){e.$tC.parent=e.$tC}function E(s,o){const r=o.right;r.size_left+=o.size_left+(o.piece?o.piece.length:0),r.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=r.left,r.left!==e.$tC&&(r.left.parent=o),r.parent=o.parent,o.parent===e.$tC?s.root=r:o.parent.left===o?o.parent.left=r:o.parent.right=r,r.left=o,o.parent=r}function T(s,o){const r=o.left;o.left=r.right,r.right!==e.$tC&&(r.right.parent=o),r.parent=o.parent,o.size_left-=r.size_left+(r.piece?r.piece.length:0),o.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),o.parent===e.$tC?s.root=r:o===o.parent.right?o.parent.right=r:o.parent.left=r,r.right=o,o.parent=r}function y(s,o){let r,n;if(o.left===e.$tC?(n=o,r=n.right):o.right===e.$tC?(n=o,r=n.left):(n=A(o.right),r=n.right),n===s.root){s.root=r,r.color=0,o.detach(),f(),s.root.parent=e.$tC;return}const t=n.color===1;if(n===n.parent.left?n.parent.left=r:n.parent.right=r,n===o?(r.parent=n.parent,m(s,r)):(n.parent===o?r.parent=n:r.parent=n.parent,m(s,r),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===s.root?s.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$tC&&(n.left.parent=n),n.right!==e.$tC&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,m(s,n)),o.detach(),r.parent.left===r){const l=M(r),i=p(r);if(l!==r.parent.size_left||i!==r.parent.lf_left){const $=l-r.parent.size_left,a=i-r.parent.lf_left;r.parent.size_left=l,r.parent.lf_left=i,v(s,r.parent,$,a)}}if(m(s,r.parent),t){f();return}let c;for(;r!==s.root&&r.color===0;)r===r.parent.left?(c=r.parent.right,c.color===1&&(c.color=0,r.parent.color=1,E(s,r.parent),c=r.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.right.color===0&&(c.left.color=0,c.color=1,T(s,c),c=r.parent.right),c.color=r.parent.color,r.parent.color=0,c.right.color=0,E(s,r.parent),r=s.root)):(c=r.parent.left,c.color===1&&(c.color=0,r.parent.color=1,T(s,r.parent),c=r.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(s,c),c=r.parent.left),c.color=r.parent.color,r.parent.color=0,c.left.color=0,T(s,r.parent),r=s.root));r.color=0,f()}function u(s,o){for(m(s,o);o!==s.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const r=o.parent.parent.right;r.color===1?(o.parent.color=0,r.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,E(s,o)),o.parent.color=0,o.parent.parent.color=1,T(s,o.parent.parent))}else{const r=o.parent.parent.left;r.color===1?(o.parent.color=0,r.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,T(s,o)),o.parent.color=0,o.parent.parent.color=1,E(s,o.parent.parent))}s.root.color=0}function v(s,o,r,n){for(;o!==s.root&&o!==e.$tC;)o.parent.left===o&&(o.parent.size_left+=r,o.parent.lf_left+=n),o=o.parent}function m(s,o){let r=0,n=0;if(o!==s.root){for(;o!==s.root&&o===o.parent.right;)o=o.parent;if(o!==s.root)for(o=o.parent,r=M(o.left)-o.size_left,n=p(o.left)-o.lf_left,o.size_left+=r,o.lf_left+=n;o!==s.root&&(r!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=r,o.parent.lf_left+=n),o=o.parent}}}),define(Ce[92],Re([1,0,93,29,94,136,95]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=e.$LC=e.$KC=void 0,e.$IC=T,e.$JC=y;const p=65535;function f(r){let n;return r[r.length-1]<65536?n=new Uint16Array(r.length):n=new Uint32Array(r.length),n.set(r,0),n}class E{constructor(n,t,c,l,i){this.lineStarts=n,this.cr=t,this.lf=c,this.crlf=l,this.isBasicASCII=i}}function T(r,n=!0){const t=[0];let c=1;for(let l=0,i=r.length;l<i;l++){const $=r.charCodeAt(l);$===13?l+1<i&&r.charCodeAt(l+1)===10?(t[c++]=l+2,l++):t[c++]=l+1:$===10&&(t[c++]=l+1)}return n?f(t):t}function y(r,n){r.length=0,r[0]=0;let t=1,c=0,l=0,i=0,$=!0;for(let b=0,h=n.length;b<h;b++){const D=n.charCodeAt(b);D===13?b+1<h&&n.charCodeAt(b+1)===10?(i++,r[t++]=b+2,b++):(c++,r[t++]=b+1):D===10?(l++,r[t++]=b+1):$&&D!==9&&(D<32||D>126)&&($=!1)}const a=new E(f(r),c,l,i,$);return r.length=0,a}class u{constructor(n,t,c,l,i){this.bufferIndex=n,this.start=t,this.end=c,this.lineFeedCnt=l,this.length=i}}e.$KC=u;class v{constructor(n,t){this.buffer=n,this.lineStarts=t}}e.$LC=v;class m{constructor(n,t){this.a=[],this.c=n,this.d=t,this.b=0,n.root!==F.$tC&&n.iterate(n.root,c=>(c!==F.$tC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(n){this.a=n,this.b=[]}get(n){for(let t=this.b.length-1;t>=0;t--){const c=this.b[t];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let t=this.b.length-1;t>=0;t--){const c=this.b[t];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let t=!1;const c=this.b;for(let l=0;l<c.length;l++){const i=c[l];if(i.node.parent===null||i.nodeStartOffset>=n){c[l]=null,t=!0;continue}}if(t){const l=[];for(const i of c)i!==null&&l.push(i);this.b=l}}}class o{constructor(n,t,c){this.create(n,t,c)}create(n,t,c){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=F.$tC,this.b=1,this.c=0,this.d=t,this.e=t.length,this.f=c;let l=null;for(let i=0,$=n.length;i<$;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=T(n[i].buffer));const a=new u(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),l=this.S(l,a)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const t=p,c=t-Math.floor(t/3),l=c*2;let i="",$=0;const a=[];if(this.iterate(this.root,b=>{const h=this.R(b),D=h.length;if($<=c||$+D<l)return i+=h,$+=D,!0;const d=i.replace(/\r\n|\r|\n/g,n);return a.push(new v(d,T(d))),i=h,$=D,!0}),$>0){const b=i.replace(/\r\n|\r|\n/g,n);a.push(new v(b,T(b)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new m(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let t=0;return this.iterate(this.root,l=>{if(l===F.$tC)return!0;const i=this.R(l),$=i.length,a=n.G(t),b=n.G(t+$),h=n.getValueInRange2(a,b);return t+=$,i===h})}getOffsetAt(n,t){let c=0,l=this.root;for(;l!==F.$tC;)if(l.left!==F.$tC&&l.lf_left+1>=n)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=n){c+=l.size_left;const i=this.B(l,n-l.lf_left-2);return c+=i+t-1}else n-=l.lf_left+l.piece.lineFeedCnt,c+=l.size_left+l.piece.length,l=l.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let t=this.root,c=0;const l=n;for(;t!==F.$tC;)if(t.size_left!==0&&t.size_left>=n)t=t.left;else if(t.size_left+t.piece.length>=n){const i=this.A(t,n-t.size_left);if(c+=t.lf_left+i.index,i.index===0){const $=this.getOffsetAt(c+1,1),a=l-$;return new I.$mt(c+1,a+1)}return new I.$mt(c+1,i.remainder+1)}else if(n-=t.size_left+t.piece.length,c+=t.lf_left+t.piece.lineFeedCnt,t.right===F.$tC){const i=this.getOffsetAt(c+1,1),$=l-n-i;return new I.$mt(c+1,$+1)}else t=t.right;return new I.$mt(1,1)}getValueInRange(n,t){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),l=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,l);return t?t!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,t):t===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,t):i}getValueInRange2(n,t){if(n.node===t.node){const a=n.node,b=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);return b.substring(h+n.remainder,h+t.remainder)}let c=n.node;const l=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let $=l.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==F.$tC;){const a=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);if(c===t.node){$+=a.substring(b,b+t.remainder);break}else $+=a.substr(b,c.piece.length);c=c.next()}return $}getLinesContent(){const n=[];let t=0,c="",l=!1;return this.iterate(this.root,i=>{if(i===F.$tC)return!0;const $=i.piece;let a=$.length;if(a===0)return!0;const b=this.a[$.bufferIndex].buffer,h=this.a[$.bufferIndex].lineStarts,D=$.start.line,d=$.end.line;let k=h[D]+$.start.column;if(l&&(b.charCodeAt(k)===10&&(k++,a--),n[t++]=c,c="",l=!1,a===0))return!0;if(D===d)return!this.f&&b.charCodeAt(k+a-1)===13?(l=!0,c+=b.substr(k,a-1)):c+=b.substr(k,a),!0;c+=this.f?b.substring(k,Math.max(k,h[D+1]-this.e)):b.substring(k,h[D+1]).replace(/(\r\n|\r|\n)$/,""),n[t++]=c;for(let g=D+1;g<d;g++)c=this.f?b.substring(h[g],h[g+1]-this.e):b.substring(h[g],h[g+1]).replace(/(\r\n|\r|\n)$/,""),n[t++]=c;return!this.f&&b.charCodeAt(h[d]+$.end.column-1)===13?(l=!0,$.end.column===0?t--:c=b.substr(h[d],$.end.column-1)):c=b.substr(h[d],$.end.column),!0}),l&&(n[t++]=c,c=""),n[t++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t)return 0;const c=this.a[t.piece.bufferIndex],l=this.u(t.piece.bufferIndex,t.piece.start);return c.buffer.charCodeAt(l)}else{const t=this.a[n.node.piece.bufferIndex],l=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return t.buffer.charCodeAt(l)}}getLineCharCode(n,t){const c=this.H(n,t+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const t=this.getOffsetAt(n,1);return this.getLength()-t}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const t=this.G(n);return this.l(t)}findMatchesInNode(n,t,c,l,i,$,a,b,h,D,d){const k=this.a[n.piece.bufferIndex],g=this.u(n.piece.bufferIndex,n.piece.start),S=this.u(n.piece.bufferIndex,i),w=this.u(n.piece.bufferIndex,$);let C;const P={line:0,column:0};let W,V;t._wordSeparators?(W=k.buffer.substring(S,w),V=q=>q+S,t.reset(0)):(W=k.buffer,V=q=>q,t.reset(S));do if(C=t.next(W),C){if(V(C.index)>=w)return D;this.s(n,V(C.index)-g,P);const q=this.t(n.piece.bufferIndex,i,P),R=P.line===i.line?P.column-i.column+l:P.column+1,j=R+C[0].length;if(d[D++]=(0,M.$EC)(new N.$nt(c+q,R,c+q,j),C,b),V(C.index)+C[0].length>=w||D>=h)return D}while(C);return D}findMatchesLineByLine(n,t,c,l){const i=[];let $=0;const a=new M.$HC(t.wordSeparators,t.regex);let b=this.H(n.startLineNumber,n.startColumn);if(b===null)return[];const h=this.H(n.endLineNumber,n.endColumn);if(h===null)return[];let D=this.s(b.node,b.remainder);const d=this.s(h.node,h.remainder);if(b.node===h.node)return this.findMatchesInNode(b.node,a,n.startLineNumber,n.startColumn,D,d,t,c,l,$,i),i;let k=n.startLineNumber,g=b.node;for(;g!==h.node;){const w=this.t(g.piece.bufferIndex,D,g.piece.end);if(w>=1){const P=this.a[g.piece.bufferIndex].lineStarts,W=this.u(g.piece.bufferIndex,g.piece.start),V=P[D.line+w],q=k===n.startLineNumber?n.startColumn:1;if($=this.findMatchesInNode(g,a,k,q,D,this.s(g,V-W),t,c,l,$,i),$>=l)return i;k+=w}const C=k===n.startLineNumber?n.startColumn-1:0;if(k===n.endLineNumber){const P=this.getLineContent(k).substring(C,n.endColumn-1);return $=this.n(t,a,P,n.endLineNumber,C,$,i,c,l),i}if($=this.n(t,a,this.getLineContent(k).substr(C),k,C,$,i,c,l),$>=l)return i;k++,b=this.H(k,1),g=b.node,D=this.s(b.node,b.remainder)}if(k===n.endLineNumber){const w=k===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(k).substring(w,n.endColumn-1);return $=this.n(t,a,C,n.endLineNumber,w,$,i,c,l),i}const S=k===n.startLineNumber?n.startColumn:1;return $=this.findMatchesInNode(h.node,a,k,S,D,d,t,c,l,$,i),i}n(n,t,c,l,i,$,a,b,h){const D=n.wordSeparators;if(!b&&n.simpleSearch){const k=n.simpleSearch,g=k.length,S=c.length;let w=-g;for(;(w=c.indexOf(k,w+g))!==-1;)if((!D||(0,M.$GC)(D,c,S,w,g))&&(a[$++]=new A.$yv(new N.$nt(l,w+1+i,l,w+1+g+i),null),$>=h))return $;return $}let d;t.reset(0);do if(d=t.next(c),d&&(a[$++]=(0,M.$EC)(new N.$nt(l,d.index+1+i,l,d.index+1+d[0].length+i),d,b),$>=h))return $;while(d);return $}insert(n,t,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==F.$tC){const{node:l,remainder:i,nodeStartOffset:$}=this.G(n),a=l.piece,b=a.bufferIndex,h=this.s(l,i);if(l.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&$+a.length===n&&t.length<p){this.F(l,t),this.y();return}if($===n)this.o(t,l),this.h.validate(n);else if($+l.piece.length>n){const D=[];let d=new u(a.bufferIndex,h,a.end,this.t(a.bufferIndex,h,a.end),this.u(b,a.end)-this.u(b,h));if(this.K()&&this.M(t)&&this.I(l,i)===10){const w={line:d.start.line+1,column:0};d=new u(d.bufferIndex,w,d.end,this.t(d.bufferIndex,w,d.end),d.length-1),t+=`
`}if(this.K()&&this.L(t))if(this.I(l,i-1)===13){const w=this.s(l,i-1);this.C(l,w),t="\r"+t,l.piece.length===0&&D.push(l)}else this.C(l,h);else this.C(l,h);const k=this.w(t);d.length>0&&this.S(l,d);let g=l;for(let S=0;S<k.length;S++)g=this.S(g,k[S]);this.v(D)}else this.q(t,l)}else{const l=this.w(t);let i=this.T(null,l[0]);for(let $=1;$<l.length;$++)i=this.S(i,l[$])}this.y()}delete(n,t){if(this.j.lineNumber=0,this.j.value="",t<=0||this.root===F.$tC)return;const c=this.G(n),l=this.G(n+t),i=c.node,$=l.node;if(i===$){const k=this.s(i,c.remainder),g=this.s(i,l.remainder);if(c.nodeStartOffset===n){if(t===i.piece.length){const S=i.next();(0,F.$yC)(this,i),this.N(S),this.y();return}this.D(i,g),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+t){this.C(i,k),this.O(i),this.y();return}this.E(i,k,g),this.y();return}const a=[],b=this.s(i,c.remainder);this.C(i,b),this.h.validate(n),i.piece.length===0&&a.push(i);const h=this.s($,l.remainder);this.D($,h),$.piece.length===0&&a.push($);const D=i.next();for(let k=D;k!==F.$tC&&k!==$;k=k.next())a.push(k);const d=i.piece.length===0?i.prev():i;this.v(a),this.O(d),this.y()}o(n,t){const c=[];if(this.K()&&this.M(n)&&this.L(t)){const $=t.piece,a={line:$.start.line+1,column:0},b=new u($.bufferIndex,a,$.end,this.t($.bufferIndex,a,$.end),$.length-1);t.piece=b,n+=`
`,(0,F.$AC)(this,t,-1,-1),t.piece.length===0&&c.push(t)}const l=this.w(n);let i=this.T(t,l[l.length-1]);for(let $=l.length-2;$>=0;$--)i=this.T(i,l[$]);this.N(i),this.v(c)}q(n,t){this.Q(n,t)&&(n+=`
`);const c=this.w(n),l=this.S(t,c[0]);let i=l;for(let $=1;$<c.length;$++)i=this.S(i,c[$]);this.N(l)}s(n,t,c){const l=n.piece,i=n.piece.bufferIndex,$=this.a[i].lineStarts,b=$[l.start.line]+l.start.column+t;let h=l.start.line,D=l.end.line,d=0,k=0,g=0;for(;h<=D&&(d=h+(D-h)/2|0,g=$[d],d!==D);)if(k=$[d+1],b<g)D=d-1;else if(b>=k)h=d+1;else break;return c?(c.line=d,c.column=b-g,null):{line:d,column:b-g}}t(n,t,c){if(c.column===0)return c.line-t.line;const l=this.a[n].lineStarts;if(c.line===l.length-1)return c.line-t.line;const i=l[c.line+1],$=l[c.line]+c.column;if(i>$+1)return c.line-t.line;const a=$-1;return this.a[n].buffer.charCodeAt(a)===13?c.line-t.line+1:c.line-t.line}u(n,t){return this.a[n].lineStarts[t.line]+t.column}v(n){for(let t=0;t<n.length;t++)(0,F.$yC)(this,n[t])}w(n){if(n.length>p){const D=[];for(;n.length>p;){const k=n.charCodeAt(p-1);let g;k===13||k>=55296&&k<=56319?(g=n.substring(0,p-1),n=n.substring(p-1)):(g=n.substring(0,p),n=n.substring(p));const S=T(g);D.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:g.length-S[S.length-1]},S.length-1,g.length)),this.a.push(new v(g,S))}const d=T(n);return D.push(new u(this.a.length,{line:0,column:0},{line:d.length-1,column:n.length-d[d.length-1]},d.length-1,n.length)),this.a.push(new v(n,d)),D}let t=this.a[0].buffer.length;const c=T(n,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===t&&t!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let D=0;D<c.length;D++)c[D]+=t+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,t+=1}else{if(t!==0)for(let D=0;D<c.length;D++)c[D]+=t;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,$=this.a[0].lineStarts.length-1,a=i-this.a[0].lineStarts[$],b={line:$,column:a},h=new u(0,l,b,this.t(0,l,b),i-t);return this.g=b,[h]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,t=0){let c=this.root,l="";const i=this.h.get2(n);if(i){c=i.node;const $=this.B(c,n-i.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)l=a.substring(b+$,b+c.piece.length);else{const h=this.B(c,n-i.nodeStartLineNumber);return a.substring(b+$,b+h-t)}}else{let $=0;const a=n;for(;c!==F.$tC;)if(c.left!==F.$tC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const b=this.B(c,n-c.lf_left-2),h=this.B(c,n-c.lf_left-1),D=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);return $+=c.size_left,this.h.set({node:c,nodeStartOffset:$,nodeStartLineNumber:a-(n-1-c.lf_left)}),D.substring(d+b,d+h-t)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const b=this.B(c,n-c.lf_left-2),h=this.a[c.piece.bufferIndex].buffer,D=this.u(c.piece.bufferIndex,c.piece.start);l=h.substring(D+b,D+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,$+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==F.$tC;){const $=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),b=this.u(c.piece.bufferIndex,c.piece.start);return l+=$.substring(b,b+a-t),l}else{const a=this.u(c.piece.bufferIndex,c.piece.start);l+=$.substr(a,c.piece.length)}c=c.next()}return l}y(){let n=this.root,t=1,c=0;for(;n!==F.$tC;)t+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=t,this.c=c,this.h.validate(this.c)}A(n,t){const c=n.piece,l=this.s(n,t),i=l.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===t){const $=this.t(n.piece.bufferIndex,c.start,l);if($!==i)return{index:$,remainder:0}}return{index:i,remainder:l.column}}B(n,t){if(t<0)return 0;const c=n.piece,l=this.a[c.bufferIndex].lineStarts,i=c.start.line+t+1;return i>c.end.line?l[c.end.line]+c.end.column-l[c.start.line]-c.start.column:l[i]-l[c.start.line]-c.start.column}C(n,t){const c=n.piece,l=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),$=t,a=this.u(c.bufferIndex,$),b=this.t(c.bufferIndex,c.start,$),h=b-l,D=a-i,d=c.length+D;n.piece=new u(c.bufferIndex,c.start,$,b,d),(0,F.$AC)(this,n,D,h)}D(n,t){const c=n.piece,l=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),$=t,a=this.t(c.bufferIndex,$,c.end),b=this.u(c.bufferIndex,$),h=a-l,D=i-b,d=c.length+D;n.piece=new u(c.bufferIndex,$,c.end,a,d),(0,F.$AC)(this,n,D,h)}E(n,t,c){const l=n.piece,i=l.start,$=l.end,a=l.length,b=l.lineFeedCnt,h=t,D=this.t(l.bufferIndex,l.start,h),d=this.u(l.bufferIndex,t)-this.u(l.bufferIndex,i);n.piece=new u(l.bufferIndex,l.start,h,D,d),(0,F.$AC)(this,n,d-a,D-b);const k=new u(l.bufferIndex,c,$,this.t(l.bufferIndex,c,$),this.u(l.bufferIndex,$)-this.u(l.bufferIndex,c)),g=this.S(n,k);this.N(g)}F(n,t){this.Q(t,n)&&(t+=`
`);const c=this.K()&&this.L(t)&&this.M(n),l=this.a[0].buffer.length;this.a[0].buffer+=t;const i=T(t,!1);for(let g=0;g<i.length;g++)i[g]+=l;if(c){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const $=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[$],b={line:$,column:a},h=n.piece.length+t.length,D=n.piece.lineFeedCnt,d=this.t(0,n.piece.start,b),k=d-D;n.piece=new u(n.piece.bufferIndex,n.piece.start,b,d,h),this.g=b,(0,F.$AC)(this,n,t.length,k)}G(n){let t=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let l=0;for(;t!==F.$tC;)if(t.size_left>n)t=t.left;else if(t.size_left+t.piece.length>=n){l+=t.size_left;const i={node:t,remainder:n-t.size_left,nodeStartOffset:l};return this.h.set(i),i}else n-=t.size_left+t.piece.length,l+=t.size_left+t.piece.length,t=t.right;return null}H(n,t){let c=this.root,l=0;for(;c!==F.$tC;)if(c.left!==F.$tC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),$=this.B(c,n-c.lf_left-1);return l+=c.size_left,{node:c,remainder:Math.min(i+t-1,$),nodeStartOffset:l}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+t-1<=c.piece.length)return{node:c,remainder:i+t-1,nodeStartOffset:l};t-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,l+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==F.$tC;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),$=this.J(c);return{node:c,remainder:Math.min(t-1,i),nodeStartOffset:$}}else if(c.piece.length>=t-1){const i=this.J(c);return{node:c,remainder:t-1,nodeStartOffset:i}}else t-=c.piece.length;c=c.next()}return null}I(n,t){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],l=this.u(n.piece.bufferIndex,n.piece.start)+t;return c.buffer.charCodeAt(l)}J(n){if(!n)return 0;let t=n.size_left;for(;n!==this.root;)n.parent.right===n&&(t+=n.parent.size_left+n.parent.piece.length),n=n.parent;return t}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===F.$tC||n.piece.lineFeedCnt===0)return!1;const t=n.piece,c=this.a[t.bufferIndex].lineStarts,l=t.start.line,i=c[l]+t.start.column;return l===c.length-1||c[l+1]>i+1?!1:this.a[t.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===F.$tC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const t=n.prev();this.M(t)&&this.P(t,n)}}O(n){if(this.K()&&this.M(n)){const t=n.next();this.L(t)&&this.P(n,t)}}P(n,t){const c=[],l=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:l[n.piece.end.line]-l[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const $=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new u(n.piece.bufferIndex,n.piece.start,i,a,$),(0,F.$AC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const b={line:t.piece.start.line+1,column:0},h=t.piece.length-1,D=this.t(t.piece.bufferIndex,b,t.piece.end);t.piece=new u(t.piece.bufferIndex,b,t.piece.end,D,h),(0,F.$AC)(this,t,-1,-1),t.piece.length===0&&c.push(t);const d=this.w(`\r
`);this.S(n,d[0]);for(let k=0;k<c.length;k++)(0,F.$yC)(this,c[k])}Q(n,t){if(this.K()&&this.M(n)){const c=t.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,F.$yC)(this,c);else{const l=c.piece,i={line:l.start.line+1,column:0},$=l.length-1,a=this.t(l.bufferIndex,i,l.end);c.piece=new u(l.bufferIndex,i,l.end,a,$),(0,F.$AC)(this,c,-1,-1)}return!0}}return!1}iterate(n,t){if(n===F.$tC)return t(F.$tC);const c=this.iterate(n.left,t);return c&&t(n)&&this.iterate(n.right,t)}R(n){if(n===F.$tC)return"";const t=this.a[n.piece.bufferIndex],c=n.piece,l=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return t.buffer.substring(l,i)}getPieceContent(n){const t=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),l=this.u(n.bufferIndex,n.end);return t.buffer.substring(c,l)}S(n,t){const c=new F.$sC(t,1);if(c.left=F.$tC,c.right=F.$tC,c.parent=F.$tC,c.size_left=0,c.lf_left=0,this.root===F.$tC)this.root=c,c.color=0;else if(n.right===F.$tC)n.right=c,c.parent=n;else{const i=(0,F.$uC)(n.right);i.left=c,c.parent=i}return(0,F.$zC)(this,c),c}T(n,t){const c=new F.$sC(t,1);if(c.left=F.$tC,c.right=F.$tC,c.parent=F.$tC,c.size_left=0,c.lf_left=0,this.root===F.$tC)this.root=c,c.color=0;else if(n.left===F.$tC)n.left=c,c.parent=n;else{const l=(0,F.$vC)(n.left);l.right=c,c.parent=l}return(0,F.$zC)(this,c),c}U(n){let t="";return this.iterate(n,c=>(t+=this.R(c),!0)),t}}e.$MC=o}),define(Ce[137],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v9=e.$u9=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const M=this.a.get(F);return this.a.delete(F),M}}addDragOperationTransfer(F,M){this.a.set(F,M)}}e.$u9=I;class N{constructor(F){this.identifier=F}}e.$v9=N}),define(Ce[138],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Ce[139],Re([1,0,5,6,138]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=void 0,e.$bj=T;class F extends N.$Uc{constructor(u,v="",m="",s=!0,o){super(),this.h=this.B(new I.$be),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=v,this.u=m,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,v){this.C&&await this.C(u)}}e.$9i=F;class M extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$be),this.onWillRun=this.f.event,this.m=this.B(new I.$be),this.onDidRun=this.m.event}async run(u,v){if(!u.enabled)return;this.f.fire({action:u});let m;try{await this.u(u,v)}catch(s){m=s}this.m.fire({action:u,error:m})}async u(u,v){await u.run(v)}}e.$0i=M;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let v=[];for(const m of u)m.length&&(v.length?v=[...v,new p,...m]:v=m);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$$i=p;class f{get actions(){return this.a}constructor(u,v,m,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=v,this.class=s,this.a=m}async run(){}}e.$_i=f;class E extends F{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,A.localize(0,null),void 0,!1)}}e.$aj=E;function T(y){return{id:y.id,label:y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u),tooltip:y.label}}}),define(Ce[140],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Ce[141],Re([1,0,140]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=E,e.$Xm=T,e.$Ym=y;const N=60,A=N*60,F=A*24,M=F*7,p=F*30,f=F*365;function E(u,v,m,s){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,I.localize)(0,null,E(new Date().getTime()+o*1e3,!1));if(!s&&o<30)return(0,I.localize)(1,null);let r;return o<N?(r=o,v?r===1?m?(0,I.localize)(2,null,r):(0,I.localize)(3,null,r):m?(0,I.localize)(4,null,r):(0,I.localize)(5,null,r):r===1?m?(0,I.localize)(6,null,r):(0,I.localize)(7,null,r):m?(0,I.localize)(8,null,r):(0,I.localize)(9,null,r)):o<A?(r=Math.floor(o/N),v?r===1?m?(0,I.localize)(10,null,r):(0,I.localize)(11,null,r):m?(0,I.localize)(12,null,r):(0,I.localize)(13,null,r):r===1?m?(0,I.localize)(14,null,r):(0,I.localize)(15,null,r):m?(0,I.localize)(16,null,r):(0,I.localize)(17,null,r)):o<F?(r=Math.floor(o/A),v?r===1?m?(0,I.localize)(18,null,r):(0,I.localize)(19,null,r):m?(0,I.localize)(20,null,r):(0,I.localize)(21,null,r):r===1?m?(0,I.localize)(22,null,r):(0,I.localize)(23,null,r):m?(0,I.localize)(24,null,r):(0,I.localize)(25,null,r)):o<M?(r=Math.floor(o/F),v?r===1?(0,I.localize)(26,null,r):(0,I.localize)(27,null,r):r===1?(0,I.localize)(28,null,r):(0,I.localize)(29,null,r)):o<p?(r=Math.floor(o/M),v?r===1?m?(0,I.localize)(30,null,r):(0,I.localize)(31,null,r):m?(0,I.localize)(32,null,r):(0,I.localize)(33,null,r):r===1?m?(0,I.localize)(34,null,r):(0,I.localize)(35,null,r):m?(0,I.localize)(36,null,r):(0,I.localize)(37,null,r)):o<f?(r=Math.floor(o/p),v?r===1?m?(0,I.localize)(38,null,r):(0,I.localize)(39,null,r):m?(0,I.localize)(40,null,r):(0,I.localize)(41,null,r):r===1?m?(0,I.localize)(42,null,r):(0,I.localize)(43,null,r):m?(0,I.localize)(44,null,r):(0,I.localize)(45,null,r)):(r=Math.floor(o/f),v?r===1?m?(0,I.localize)(46,null,r):(0,I.localize)(47,null,r):m?(0,I.localize)(48,null,r):(0,I.localize)(49,null,r):r===1?m?(0,I.localize)(50,null,r):(0,I.localize)(51,null,r):m?(0,I.localize)(52,null,r):(0,I.localize)(53,null,r))}function T(u,v){const m=Math.abs(u/1e3);return m<1?v?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):m<N?v?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):m<A?v?(0,I.localize)(58,null,Math.round(u/(1e3*N))):(0,I.localize)(59,null,Math.round(u/(1e3*N))):m<F?v?(0,I.localize)(60,null,Math.round(u/(1e3*A))):(0,I.localize)(61,null,Math.round(u/(1e3*A))):(0,I.localize)(62,null,Math.round(u/(1e3*F)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[142],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Ce[43],Re([1,0,18,17,142]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=f,e.$dj=E,e.$ej=T;function F(y,u){return u&&(y.stack||y.stacktrace)?A.localize(0,null,p(y),M(y.stack)||M(y.stacktrace)):p(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function p(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?A.localize(1,null,y.message):y.message||A.localize(2,null)}function f(y=null,u=!1){if(!y)return A.localize(3,null);if(Array.isArray(y)){const v=I.$Hb(y),m=f(v[0],u);return v.length>1?A.localize(4,null,m,v.length):m}if(N.$5f(y))return y;if(y.detail){const v=y.detail;if(v.error)return F(v.error,u);if(v.exception)return F(v.exception,u)}return y.stack?F(y,u):y.message?y.message:A.localize(5,null)}function E(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function T(y,u){let v;return typeof y=="string"?v=new Error(y):v=y,v.actions=u,v}}),define(Ce[143],Re([1,0,41,19]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=p,e.$cr=f,e.$dr=E,e.$er=T,e.$fr=y,e.$gr=u,e.$hr=v,e.$ir=m,e.$jr=s,e.$kr=o,e.$lr=h,e.$mr=D,e.$nr=d;const A=new I.$V(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),F=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(k,g,S=!1){const w=k||"",C=g||"",P=A.value.collator.compare(w,C);return A.value.collatorIsNumeric&&P===0&&w!==C?w<C?-1:1:P}function f(k,g){const S=F.value.collator;return k=k||"",g=g||"",c(S,k,g)}function E(k,g){const S=F.value.collator;return k=k||"",g=g||"",a(k,g)||c(S,k,g)}function T(k,g){const S=F.value.collator;return k=k||"",g=g||"",$(k,g)||c(S,k,g)}function y(k,g){return k=k||"",g=g||"",k===g?0:k<g?-1:1}function u(k,g){const[S,w]=n(k),[C,P]=n(g);let W=A.value.collator.compare(w,P);if(W===0){if(A.value.collatorIsNumeric&&w!==P)return w<P?-1:1;if(W=A.value.collator.compare(S,C),A.value.collatorIsNumeric&&W===0&&S!==C)return S<C?-1:1}return W}function v(k,g){k=k||"",g=g||"";const S=t(k),w=t(g),C=F.value.collator,P=M.value.collator;return c(P,S,w)||c(C,k,g)}function m(k,g){k=k||"",g=g||"";const S=t(k),w=t(g),C=F.value.collator,P=M.value.collator;return c(P,S,w)||a(k,g)||c(C,k,g)}function s(k,g){k=k||"",g=g||"";const S=t(k),w=t(g),C=F.value.collator,P=M.value.collator;return c(P,S,w)||$(k,g)||c(C,k,g)}function o(k,g){k=k||"",g=g||"";const S=t(k).toLowerCase(),w=t(g).toLowerCase();return S!==w?S<w?-1:1:k!==g?k<g?-1:1:0}const r=/^(.*?)(\.([^.]*))?$/;function n(k,g=!1){const S=k?r.exec(k):[];let w=[S&&S[1]||"",S&&S[3]||""];return g&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function t(k){const g=k?r.exec(k):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function c(k,g,S){const w=k.compare(g,S);return w!==0?w:g.length!==S.length?g.length<S.length?-1:1:0}function l(k){const g=k.charAt(0);return g.toLocaleUpperCase()!==g}function i(k){const g=k.charAt(0);return g.toLocaleLowerCase()!==g}function $(k,g){return l(k)&&i(g)?-1:i(k)&&l(g)?1:0}function a(k,g){return i(k)&&l(g)?-1:l(k)&&i(g)?1:0}function b(k,g,S=!1){return S||(k=k&&k.toLowerCase(),g=g&&g.toLowerCase()),k===g?0:k<g?-1:1}function h(k,g,S=!1){const w=k.split(N.sep),C=g.split(N.sep),P=w.length-1,W=C.length-1;let V,q;for(let R=0;;R++){if(V=P===R,q=W===R,V&&q)return p(w[R],C[R],S);if(V)return-1;if(q)return 1;const j=b(w[R],C[R],S);if(j!==0)return j}}function D(k,g,S){const w=k.toLowerCase(),C=g.toLowerCase(),P=d(k,g,S);if(P)return P;const W=w.endsWith(S),V=C.endsWith(S);if(W!==V)return W?-1:1;const q=p(w,C);return q!==0?q:w.localeCompare(C)}function d(k,g,S){const w=k.toLowerCase(),C=g.toLowerCase(),P=w.startsWith(S),W=C.startsWith(S);if(P!==W)return P?-1:1;if(P&&W){if(w.length<C.length)return-1;if(w.length>C.length)return 1}return 0}}),define(Ce[47],Re([1,0,19,21,15,17]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=M,e.$lg=p,e.$mg=f,e.$ng=E,e.$og=T,e.$pg=m,e.$qg=s,e.$rg=o,e.$sg=r,e.$tg=n,e.$ug=t,e.$vg=c,e.$wg=l,e.$xg=i,e.$yg=$,e.$zg=h;function M(D){return D===47||D===92}function p(D){return D.replace(/[\\/]/g,I.$hc.sep)}function f(D){return D.indexOf("/")===-1&&(D=p(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}function E(D,d=I.$hc.sep){if(!D)return"";const k=D.length,g=D.charCodeAt(0);if(M(g)){if(M(D.charCodeAt(1))&&!M(D.charCodeAt(2))){let w=3;const C=w;for(;w<k&&!M(D.charCodeAt(w));w++);if(C!==w&&!M(D.charCodeAt(w+1))){for(w+=1;w<k;w++)if(M(D.charCodeAt(w)))return D.slice(0,w+1).replace(/[\\/]/g,d)}}return d}else if(r(g)&&D.charCodeAt(1)===58)return M(D.charCodeAt(2))?D.slice(0,2)+d:D.slice(0,2);let S=D.indexOf("://");if(S!==-1){for(S+=3;S<k;S++)if(M(D.charCodeAt(S)))return D.slice(0,S+1)}return""}function T(D){if(!N.$i||!D||D.length<5)return!1;let d=D.charCodeAt(0);if(d!==92||(d=D.charCodeAt(1),d!==92))return!1;let k=2;const g=k;for(;k<D.length&&(d=D.charCodeAt(k),d!==92);k++);return!(g===k||(d=D.charCodeAt(k+1),isNaN(d)||d===92))}const y=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(D,d=N.$i){const k=d?y:u;return!(!D||D.length===0||/^\s+$/.test(D)||(k.lastIndex=0,k.test(D))||d&&v.test(D)||D==="."||D===".."||d&&D[D.length-1]==="."||d&&D.length!==D.trim().length||D.length>255)}function s(D,d,k){const g=D===d;return!k||g?g:!D||!d?!1:(0,A.$uf)(D,d)}function o(D,d,k,g=I.sep){if(D===d)return!0;if(!D||!d||d.length>D.length)return!1;if(k){if(!(0,A.$vf)(D,d))return!1;if(d.length===D.length)return!0;let w=d.length;return d.charAt(d.length-1)===g&&w--,D.charAt(w)===g}return d.charAt(d.length-1)!==g&&(d+=g),D.indexOf(d)===0}function r(D){return D>=65&&D<=90||D>=97&&D<=122}function n(D,d){return N.$i&&D.endsWith(":")&&(D+=I.sep),(0,I.$jc)(D)||(D=(0,I.$kc)(d,D)),D=(0,I.$ic)(D),N.$i?(D=(0,A.$cf)(D,I.sep),D.endsWith(":")&&(D+=I.sep)):(D=(0,A.$cf)(D,I.sep),D||(D=I.sep)),D}function t(D){const d=(0,I.$ic)(D);return N.$i?D.length>3?!1:c(d)&&(D.length===2||d.charCodeAt(2)===92):d===I.$hc.sep}function c(D,d=N.$i){return d?r(D.charCodeAt(0))&&D.charCodeAt(1)===58:!1}function l(D,d=N.$i){return c(D,d)?D[0]:void 0}function i(D,d,k){return d.length>D.length?-1:D===d?0:(k&&(D=D.toLowerCase(),d=d.toLowerCase()),D.indexOf(d))}function $(D){const d=D.split(":");let k,g,S;for(const w of d){const C=Number(w);(0,F.$9f)(C)?g===void 0?g=C:S===void 0&&(S=C):k=k?[k,w].join(":"):w}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:g!==void 0?g:void 0,column:S!==void 0?S:g!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",b="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function h(D,d,k=8){let g="";for(let w=0;w<k;w++){let C;w===0&&N.$i&&!d&&(k===3||k===4)?C=b:C=a,g+=C.charAt(Math.floor(Math.random()*C.length))}let S;return d?S=`${d}-${g}`:S=g,D?(0,I.$kc)(D,S):S}}),define(Ce[69],Re([1,0,19]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=void 0,e.$Ls=F,e.$Ms=M,e.$Ns=p,e.$Os=E,e.$Ks=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(T){const y=(0,I.$pc)(T),u=N[y.toLowerCase()];return u!==void 0?u:M(T)}function M(T){const y=(0,I.$pc)(T);return A[y.toLowerCase()]}function p(T){for(const y in A)if(A[y]===T)return y}const f=/^(.+)\/(.+?)(;.+)?$/;function E(T,y){const u=f.exec(T);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:T}}),define(Ce[53],Re([1,0,22,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=A,e.$Zh=F,e.$1h=p;function A(f){return JSON.stringify(f,M)}function F(f){let E=JSON.parse(f);return E=p(E),E}function M(f,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function p(f,E=0){if(!f||E>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return N.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof I.$Ce||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let T=0;T<f.length;++T)f[T]=p(f[T],E+1);else for(const T in f)Object.hasOwnProperty.call(f,T)&&(f[T]=p(f[T],E+1))}return f}}),define(Ce[12],Re([1,0,14,21,15,2,19]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Eg=e.$Dg=e.$Cg=e.Schemas=void 0,e.$Ag=f,e.$Bg=E,e.$Fg=y;var p;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.commentsInput="comment",m.codeSetting="code-setting"})(p||(e.Schemas=p={}));function f(m,s){return F.URI.isUri(m)?(0,A.$uf)(m.scheme,s):(0,A.$vf)(m,s+":")}function E(m,...s){return s.some(o=>f(m,o))}e.$Cg="vscode-tkn",e.$Dg="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,o){this.f=y(s,o)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,p.vscodeRemoteResource)}set(s,o,r){this.a[s]=o,this.b[s]=r}setConnectionToken(s,o){this.c[s]=o}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(l){return I.$1(l),s}const o=s.authority;let r=this.a[o];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const n=this.b[o],t=this.c[o];let c=`path=${encodeURIComponent(s.path)}`;return typeof t=="string"&&(c+=`&${e.$Dg}=${encodeURIComponent(t)}`),F.URI.from({scheme:N.$o?this.d:p.vscodeRemoteResource,authority:`${r}:${n}`,path:this.g,query:c})}}e.$Eg=new T;function y(m,s){return M.$hc.join(s??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$Gg="vs/../../extensions",e.$Hg="vs/../../node_modules",e.$Ig="vs/../../node_modules.asar",e.$Jg="vs/../../node_modules.asar.unpacked",e.$Kg="vscode-app";class u{static{this.a=e.$Kg}asBrowserUri(s){const o=this.b(s,ge);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===p.vscodeRemote?e.$Eg.rewrite(s):s.scheme===p.file&&(N.$m||N.$q===`${p.vscodeFileResource}://${u.a}`)?s.with({scheme:p.vscodeFileResource,authority:s.authority||u.a,query:null,fragment:null}):s}asFileUri(s){const o=this.b(s,ge);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===p.vscodeFileResource?s.with({scheme:p.file,authority:s.authority!==u.a?s.authority:null,query:null,fragment:null}):s}b(s,o){return F.URI.isUri(s)?s:F.URI.parse(o.toUrl(s))}}e.$Lg=new u;var v;(function(m){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function r(t){let c;typeof t=="string"?c=new URL(t).searchParams:t instanceof URL?c=t.searchParams:F.URI.isUri(t)&&(c=new URL(t.toString(!0)).searchParams);const l=c?.get(o);if(l)return s.get(l)}m.getHeadersFromQuery=r;function n(t,c,l){if(!globalThis.crossOriginIsolated)return;const i=c&&l?"3":l?"2":"1";t instanceof URLSearchParams?t.set(o,i):t[o]=i}m.addSearchParam=n})(v||(e.COI=v={}))}),define(Ce[23],Re([1,0,47,12,19,21,15,2]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0,e.$Sg=f,e.$bh=T,e.$ch=u;function f(v){return(0,p.$xc)(v,!0)}class E{constructor(m){this.a=m}compare(m,s,o=!1){return m===s?0:(0,M.$nf)(this.getComparisonKey(m,o),this.getComparisonKey(s,o))}isEqual(m,s,o=!1){return m===s?!0:!m||!s?!1:this.getComparisonKey(m,o)===this.getComparisonKey(s,o)}getComparisonKey(m,s=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,s,o=!1){if(m.scheme===s.scheme){if(m.scheme===N.Schemas.file)return I.$rg(f(m),f(s),this.a(m))&&m.query===s.query&&(o||m.fragment===s.fragment);if((0,e.$0g)(m.authority,s.authority))return I.$rg(m.path,s.path,this.a(m),"/")&&m.query===s.query&&(o||m.fragment===s.fragment)}return!1}joinPath(m,...s){return p.URI.joinPath(m,...s)}basenameOrAuthority(m){return(0,e.$2g)(m)||m.authority}basename(m){return A.$hc.basename(m.path)}extname(m){return A.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let s;return m.scheme===N.Schemas.file?s=p.URI.file(A.$nc(f(m))).path:(s=A.$hc.dirname(m.path),m.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),s="/")),m.with({path:s})}normalizePath(m){if(!m.path.length)return m;let s;return m.scheme===N.Schemas.file?s=p.URI.file(A.$ic(f(m))).path:s=A.$hc.normalize(m.path),m.with({path:s})}relativePath(m,s){if(m.scheme!==s.scheme||!(0,e.$0g)(m.authority,s.authority))return;if(m.scheme===N.Schemas.file){const n=A.$mc(f(m),f(s));return F.$i?I.$lg(n):n}let o=m.path||"/";const r=s.path||"/";if(this.a(m)){let n=0;for(const t=Math.min(o.length,r.length);n<t&&!(o.charCodeAt(n)!==r.charCodeAt(n)&&o.charAt(n).toLowerCase()!==r.charAt(n).toLowerCase());n++);o=r.substr(0,n)+o.substr(n)}return A.$hc.relative(o,r)}resolvePath(m,s){if(m.scheme===N.Schemas.file){const o=p.URI.file(A.$lc(f(m),s));return m.with({authority:o.authority,path:o.path})}return s=I.$mg(s),m.with({path:A.$hc.resolve(m.path,s)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,s){return m===s||m!==void 0&&s!==void 0&&(0,M.$uf)(m,s)}hasTrailingPathSeparator(m,s=A.sep){if(m.scheme===N.Schemas.file){const o=f(m);return o.length>I.$ng(o).length&&o[o.length-1]===s}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,s=A.sep){return(0,e.$$g)(m,s)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,s=A.sep){let o=!1;if(m.scheme===N.Schemas.file){const r=f(m);o=r!==void 0&&r.length===I.$ng(r).length&&r[r.length-1]===s}else{s="/";const r=m.path;o=r.length===1&&r.charCodeAt(r.length-1)===47}return!o&&!(0,e.$$g)(m,s)?m.with({path:m.path+"/"}):m}}e.$Tg=E,e.$Ug=new E(()=>!1),e.$Vg=new E(v=>v.scheme===N.Schemas.file?!F.$k:!0),e.$Wg=new E(v=>!0),e.$Xg=e.$Ug.isEqual.bind(e.$Ug),e.$Yg=e.$Ug.isEqualOrParent.bind(e.$Ug),e.$Zg=e.$Ug.getComparisonKey.bind(e.$Ug),e.$1g=e.$Ug.basenameOrAuthority.bind(e.$Ug),e.$2g=e.$Ug.basename.bind(e.$Ug),e.$3g=e.$Ug.extname.bind(e.$Ug),e.$4g=e.$Ug.dirname.bind(e.$Ug),e.$5g=e.$Ug.joinPath.bind(e.$Ug),e.$6g=e.$Ug.normalizePath.bind(e.$Ug),e.$7g=e.$Ug.relativePath.bind(e.$Ug),e.$8g=e.$Ug.resolvePath.bind(e.$Ug),e.$9g=e.$Ug.isAbsolutePath.bind(e.$Ug),e.$0g=e.$Ug.isEqualAuthority.bind(e.$Ug),e.$$g=e.$Ug.hasTrailingPathSeparator.bind(e.$Ug),e.$_g=e.$Ug.removeTrailingPathSeparator.bind(e.$Ug),e.$ah=e.$Ug.addTrailingPathSeparator.bind(e.$Ug);function T(v,m){const s=[];for(let o=0;o<v.length;o++){const r=m(v[o]);v.some((n,t)=>t===o?!1:(0,e.$Yg)(r,m(n)))||s.push(v[o])}return s}var y;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function m(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(t=>{const[c,l]=t.split(":");c&&l&&o.set(c,l)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&o.set(v.META_DATA_MIME,n),o}v.parseMetaData=m})(y||(e.DataUri=y={}));function u(v,m,s){if(m){let o=v.path;return o&&o[0]!==A.$hc.sep&&(o=A.$hc.sep+o),v.with({scheme:s,authority:m,path:o})}return v.with({scheme:s})}}),define(Ce[11],Re([1,0,24,14,5,6,23,21,130,41]),function(ge,e,I,N,A,F,M,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.Promises=e.$Oh=e.$Nh=e.$Mh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0,e.$dh=T,e.$eh=y,e.$fh=u,e.$gh=v,e.$hh=m,e.$ih=s,e.$jh=o,e.$kh=r,e.$sh=D,e.$th=d,e.$uh=k,e.$vh=g,e.$wh=S,e.$Lh=Ie,e.$Th=Ee;function T(fe){return!!fe&&typeof fe.then=="function"}function y(fe){const X=new I.$me,Z=fe(X.token),le=new Promise((ue,Te)=>{const he=X.token.onCancellationRequested(()=>{he.dispose(),Te(new N.$5)});Promise.resolve(Z).then(Pe=>{he.dispose(),X.dispose(),ue(Pe)},Pe=>{he.dispose(),X.dispose(),Te(Pe)})});return new class{cancel(){X.cancel(),X.dispose()}then(ue,Te){return le.then(ue,Te)}catch(ue){return this.then(void 0,ue)}finally(ue){return le.finally(ue)}}}function u(fe,X,Z){return new Promise((le,ue)=>{const Te=X.onCancellationRequested(()=>{Te.dispose(),le(Z)});fe.then(le,ue).finally(()=>Te.dispose())})}function v(fe,X){return new Promise((Z,le)=>{const ue=X.onCancellationRequested(()=>{ue.dispose(),le(new N.$5)});fe.then(Z,le).finally(()=>ue.dispose())})}async function m(fe){let X=-1;const Z=fe.map((le,ue)=>le.then(Te=>(X=ue,Te)));try{return await Promise.race(Z)}finally{fe.forEach((le,ue)=>{ue!==X&&le.cancel()})}}function s(fe,X,Z){let le;const ue=setTimeout(()=>{le?.(void 0),Z?.()},X);return Promise.race([fe.finally(()=>clearTimeout(ue)),new Promise(Te=>le=Te)])}function o(fe){return new Promise((X,Z)=>{const le=fe();T(le)?le.then(X,Z):X(le)})}function r(){let fe,X;return{promise:new Promise((le,ue)=>{fe=le,X=ue}),resolve:fe,reject:X}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const Z=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(Z,Z).then(le)})}return new Promise((Z,le)=>{this.b.then(Z,le)})}return this.a=X(),new Promise((Z,le)=>{this.a.then(ue=>{this.a=null,Z(ue)},ue=>{this.a=null,le(ue)})})}dispose(){this.f=!0}}e.$lh=n;class t{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$mh=t;class c{constructor(){this.a=new Map}queue(X,Z){const ue=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(X)===ue&&this.a.delete(X)});return this.a.set(X,ue),ue}}e.$nh=c;const l=(fe,X)=>{let Z=!0;const le=setTimeout(()=>{Z=!1,X()},fe);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(le),Z=!1}}},i=fe=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,fe())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class ${constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,Z=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((ue,Te)=>{this.d=ue,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=Z===f.$$d?i(le):l(Z,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$oh=$;class a{constructor(X){this.a=new $(X),this.b=new n}trigger(X,Z){return this.a.trigger(()=>this.b.queue(X),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ph=a;class b{constructor(){this.a=!1,this.b=new Promise((X,Z)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$qh=b;class h extends b{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$rh=h;function D(fe,X){return X?new Promise((Z,le)=>{const ue=setTimeout(()=>{Te.dispose(),Z()},fe),Te=X.onCancellationRequested(()=>{clearTimeout(ue),Te.dispose(),le(new N.$5)})}):y(Z=>D(fe,Z))}function d(fe,X=0,Z){const le=setTimeout(()=>{fe(),Z&&ue.dispose()},X),ue=(0,F.$Sc)(()=>{clearTimeout(le),Z?.deleteAndLeak(ue)});return Z?.add(ue),ue}function k(fe){const X=[];let Z=0;const le=fe.length;function ue(){return Z<le?fe[Z++]():null}function Te(he){he!=null&&X.push(he);const Pe=ue();return Pe?Pe.then(Te):Promise.resolve(X)}return Promise.resolve(null).then(Te)}function g(fe,X=le=>!!le,Z=null){let le=0;const ue=fe.length,Te=()=>{if(le>=ue)return Promise.resolve(Z);const he=fe[le++];return Promise.resolve(he()).then(Ne=>X(Ne)?Promise.resolve(Ne):Te())};return Te()}function S(fe,X=le=>!!le,Z=null){if(fe.length===0)return Promise.resolve(Z);let le=fe.length;const ue=()=>{le=-1;for(const Te of fe)Te.cancel?.()};return new Promise((Te,he)=>{for(const Pe of fe)Pe.then(Ne=>{--le>=0&&X(Ne)?(ue(),Te(Ne)):le===0&&Te(Z)}).catch(Ne=>{--le>=0&&(ue(),he(Ne))})})}class w{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new A.$be}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Z,le)=>{this.g.push({factory:X,c:Z,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const Z=X.factory();Z.then(X.c,X.e),Z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$xh=w;class C extends w{constructor(){super(1)}}e.$yh=C;class P{constructor(){this.a=new de,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$zh=P;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new ce;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,Z=M.$Ug){const le=Z.getComparisonKey(X);return this.a.get(le)?.size??0}queueFor(X,Z,le=M.$Ug){const ue=le.getComparisonKey(X);let Te=this.a.get(ue);if(!Te){Te=new C;const he=this.f++,Pe=A.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$4c),this.d.set(he,Pe),this.a.set(ue,Te)}return Te.queue(Z)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ah=W;class V{constructor(X,Z){this.a=-1,typeof X=="function"&&typeof Z=="number"&&this.setIfNotSet(X,Z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,Z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},Z)}setIfNotSet(X,Z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},Z))}}e.$Bh=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,Z,le=globalThis){this.cancel();const ue=le.setInterval(()=>{X()},Z);this.d=(0,F.$Sc)(()=>{le.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$Ch=q;class R{constructor(X,Z){this.b=-1,this.a=X,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Dh=R;class j{constructor(X,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=X,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Eh=j;class K extends R{constructor(X,Z){super(X,Z),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Fh=K;class re extends F.$Uc{constructor(X,Z){super(),this.g=X,this.h=Z,this.a=[],this.b=this.B(new F.$Vc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of X)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Gh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ih=(fe,X)=>{(0,p.$B)(()=>{if(Z)return;const le=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$Ih=(fe,X,Z)=>{const le=fe.requestIdleCallback(X,typeof Z=="number"?{timeout:Z}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,fe.cancelIdleCallback(le))}}},e.$Hh=fe=>(0,e.$Ih)(globalThis,fe)}();class ae{constructor(X,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Ih)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Jh=ae;class ve extends ae{constructor(X){super(globalThis,X)}}e.$Kh=ve;async function Ie(fe,X,Z){let le;for(let ue=0;ue<Z;ue++)try{return await fe()}catch(Te){le=Te,await D(X)}throw le}class de{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,Z,le){return this.a={taskId:X,cancel:()=>le?.(),promise:Z},Z.then(()=>this.d(X),()=>this.d(X)),Z}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:Z,resolve:le,reject:ue}=r();this.b={run:X,promise:Z,promiseResolve:le,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Mh=de;class me{constructor(X,Z=()=>Date.now()){this.d=X,this.f=Z,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Nh=me;var Me;(function(fe){fe[fe.Resolved=0]="Resolved",fe[fe.Rejected=1]="Rejected"})(Me||(Me={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((X,Z)=>{this.a=X,this.b=Z})}complete(X){return new Promise(Z=>{this.a(X),this.d={outcome:0,value:X},Z()})}error(X){return new Promise(Z=>{this.b(X),this.d={outcome:1,value:X},Z()})}cancel(){return this.error(new N.$5)}}e.$Oh=ce;var Ae;(function(fe){async function X(le){let ue;const Te=await Promise.all(le.map(he=>he.then(Pe=>Pe,Pe=>{ue||(ue=Pe)})));if(typeof ue<"u")throw ue;return Te}fe.settled=X;function Z(le){return new Promise(async(ue,Te)=>{try{await le(ue,Te)}catch(he){Te(he)}})}fe.withAsyncBody=Z})(Ae||(e.Promises=Ae={}));class ie{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(Z=>(this.a=Z,this.d=!0,Z),Z=>{throw this.b=Z,this.d=!0,Z})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ph=ie;class L{constructor(X){this.b=X,this.a=new E.$V(()=>new ie(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Qh=L;var x;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(x||(x={}));class be{static fromArray(X){return new be(Z=>{Z.emitMany(X)})}static fromPromise(X){return new be(async Z=>{Z.emitMany(await X)})}static fromPromises(X){return new be(async Z=>{await Promise.all(X.map(async le=>Z.emitOne(await le)))})}static merge(X){return new be(async Z=>{await Promise.all(X.map(async le=>{for await(const ue of le)Z.emitOne(ue)}))})}static{this.EMPTY=be.fromArray([])}constructor(X,Z){this.a=0,this.b=[],this.d=null,this.f=Z,this.g=new A.$be,queueMicrotask(async()=>{const le={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(X(le)),this.k()}catch(ue){this.l(ue)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,Z){return new be(async le=>{for await(const ue of X)le.emitOne(Z(ue))})}map(X){return be.map(this,X)}static filter(X,Z){return new be(async le=>{for await(const ue of X)Z(ue)&&le.emitOne(ue)})}filter(X){return be.filter(this,X)}static coalesce(X){return be.filter(X,Z=>!!Z)}coalesce(){return be.coalesce(this)}static async toPromise(X){const Z=[];for await(const le of X)Z.push(le);return Z}toPromise(){return be.toPromise(this)}h(X){this.a===0&&(this.b.push(X),this.g.fire())}j(X){this.a===0&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(X){this.a===0&&(this.a=2,this.d=X,this.g.fire())}}e.$Rh=be;class Oe extends be{constructor(X,Z){super(Z),this.m=X}cancel(){this.m.cancel()}}e.$Sh=Oe;function Ee(fe){const X=new I.$me,Z=fe(X.token);return new Oe(X,async le=>{const ue=X.token.onCancellationRequested(()=>{ue.dispose(),X.dispose(),le.reject(new N.$5)});try{for await(const Te of Z){if(X.token.isCancellationRequested)return;le.emitOne(Te)}ue.dispose(),X.dispose()}catch(Te){ue.dispose(),X.dispose(),le.reject(Te)}})}class pe{constructor(X){this.a=new ce,this.b=new be(ue=>{if(Z){ue.reject(Z);return}return le&&ue.emitMany(le),this.d=Te=>ue.reject(Te),this.f=Te=>ue.emitOne(Te),this.a.p},X);let Z,le;this.f=ue=>{le||(le=[]),le.push(ue)},this.d=ue=>{Z||(Z=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$Uh=pe}),define(Ce[36],Re([1,0,18,11,47,28,19,21,15]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=void 0,e.$gk=E,e.$jk=m,e.$kk=C,e.$lk=P,e.$mk=W,e.$nk=V,e.$ok=q,e.$pk=re;function E(){return Object.create(null)}e.$hk="**",e.$ik="/";const T="[/\\\\]",y="[^/\\\\]",u=/\//g;function v(ae,ve){switch(ae){case 0:return"";case 1:return`${y}*?`;default:return`(?:${T}|${y}+${T}${ve?`|${T}${y}+`:""})*?`}}function m(ae,ve){if(!ae)return[];const Ie=[];let de=!1,me=!1,Me="";for(const ce of ae){switch(ce){case ve:if(!de&&!me){Ie.push(Me),Me="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":me=!0;break;case"]":me=!1;break}Me+=ce}return Me&&Ie.push(Me),Ie}function s(ae){if(!ae)return"";let ve="";const Ie=m(ae,e.$ik);if(Ie.every(de=>de===e.$hk))ve=".*";else{let de=!1;Ie.forEach((me,Me)=>{if(me===e.$hk){if(de)return;ve+=v(2,Me===Ie.length-1)}else{let ce=!1,Ae="",ie=!1,L="";for(const x of me){if(x!=="}"&&ce){Ae+=x;continue}if(ie&&(x!=="]"||!L)){let be;x==="-"?be=x:(x==="^"||x==="!")&&!L?be="^":x===e.$ik?be="":be=(0,f.$9e)(x),L+=be;continue}switch(x){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const Oe=`(?:${m(Ae,",").map(Ee=>s(Ee)).join("|")})`;ve+=Oe,ce=!1,Ae="";break}case"]":{ve+="["+L+"]",ie=!1,L="";break}case"?":ve+=y;continue;case"*":ve+=v(1);continue;default:ve+=(0,f.$9e)(x)}}Me<Ie.length-1&&(Ie[Me+1]!==e.$hk||Me+2<Ie.length)&&(ve+=T)}de=me===e.$hk})}return ve}const o=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,t=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new F.$Ec(1e4),$=function(){return!1},a=function(){return null};function b(ae,ve){if(!ae)return a;let Ie;typeof ae!="string"?Ie=ae.pattern:Ie=ae,Ie=Ie.trim();const de=`${Ie}_${!!ve.trimForExclusions}`;let me=i.get(de);if(me)return h(me,ae);let Me;return o.test(Ie)?me=d(Ie.substr(4),Ie):(Me=r.exec(D(Ie,ve)))?me=k(Me[1],Ie):(ve.trimForExclusions?t:n).test(Ie)?me=g(Ie,ve):(Me=c.exec(D(Ie,ve)))?me=S(Me[1].substr(1),Ie,!0):(Me=l.exec(D(Ie,ve)))?me=S(Me[1],Ie,!1):me=w(Ie),i.set(de,me),h(me,ae)}function h(ae,ve){if(typeof ve=="string")return ae;const Ie=function(de,me){return(0,A.$rg)(de,ve.base,!p.$k)?ae((0,f.$bf)(de.substr(ve.base.length),M.sep),me):null};return Ie.allBasenames=ae.allBasenames,Ie.allPaths=ae.allPaths,Ie.basenames=ae.basenames,Ie.patterns=ae.patterns,Ie}function D(ae,ve){return ve.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function d(ae,ve){return function(Ie,de){return typeof Ie=="string"&&Ie.endsWith(ae)?ve:null}}function k(ae,ve){const Ie=`/${ae}`,de=`\\${ae}`,me=function(ce,Ae){return typeof ce!="string"?null:Ae?Ae===ae?ve:null:ce===ae||ce.endsWith(Ie)||ce.endsWith(de)?ve:null},Me=[ae];return me.basenames=Me,me.patterns=[ve],me.allBasenames=Me,me}function g(ae,ve){const Ie=K(ae.slice(1,-1).split(",").map(Ae=>b(Ae,ve)).filter(Ae=>Ae!==a),ae),de=Ie.length;if(!de)return a;if(de===1)return Ie[0];const me=function(Ae,ie){for(let L=0,x=Ie.length;L<x;L++)if(Ie[L](Ae,ie))return ae;return null},Me=Ie.find(Ae=>!!Ae.allBasenames);Me&&(me.allBasenames=Me.allBasenames);const ce=Ie.reduce((Ae,ie)=>ie.allPaths?Ae.concat(ie.allPaths):Ae,[]);return ce.length&&(me.allPaths=ce),me}function S(ae,ve,Ie){const de=M.sep===M.$hc.sep,me=de?ae:ae.replace(u,M.sep),Me=M.sep+me,ce=M.$hc.sep+ae;let Ae;return Ie?Ae=function(ie,L){return typeof ie=="string"&&(ie===me||ie.endsWith(Me)||!de&&(ie===ae||ie.endsWith(ce)))?ve:null}:Ae=function(ie,L){return typeof ie=="string"&&(ie===me||!de&&ie===ae)?ve:null},Ae.allPaths=[(Ie?"*/":"./")+ae],Ae}function w(ae){try{const ve=new RegExp(`^${s(ae)}$`);return function(Ie){return ve.lastIndex=0,typeof Ie=="string"&&ve.test(Ie)?ae:null}}catch{return a}}function C(ae,ve,Ie){return!ae||typeof ve!="string"?!1:P(ae)(ve,void 0,Ie)}function P(ae,ve={}){if(!ae)return $;if(typeof ae=="string"||W(ae)){const Ie=b(ae,ve);if(Ie===a)return $;const de=function(me,Me){return!!Ie(me,Me)};return Ie.allBasenames&&(de.allBasenames=Ie.allBasenames),Ie.allPaths&&(de.allPaths=Ie.allPaths),de}return R(ae,ve)}function W(ae){const ve=ae;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}function V(ae){return ae.allBasenames||[]}function q(ae){return ae.allPaths||[]}function R(ae,ve){const Ie=K(Object.getOwnPropertyNames(ae).map(Ae=>j(Ae,ae[Ae],ve)).filter(Ae=>Ae!==a)),de=Ie.length;if(!de)return a;if(!Ie.some(Ae=>!!Ae.requiresSiblings)){if(de===1)return Ie[0];const Ae=function(x,be){let Oe;for(let Ee=0,pe=Ie.length;Ee<pe;Ee++){const fe=Ie[Ee](x,be);if(typeof fe=="string")return fe;(0,N.$dh)(fe)&&(Oe||(Oe=[]),Oe.push(fe))}return Oe?(async()=>{for(const Ee of Oe){const pe=await Ee;if(typeof pe=="string")return pe}return null})():null},ie=Ie.find(x=>!!x.allBasenames);ie&&(Ae.allBasenames=ie.allBasenames);const L=Ie.reduce((x,be)=>be.allPaths?x.concat(be.allPaths):x,[]);return L.length&&(Ae.allPaths=L),Ae}const me=function(Ae,ie,L){let x,be;for(let Oe=0,Ee=Ie.length;Oe<Ee;Oe++){const pe=Ie[Oe];pe.requiresSiblings&&L&&(ie||(ie=(0,M.$oc)(Ae)),x||(x=ie.substr(0,ie.length-(0,M.$pc)(Ae).length)));const fe=pe(Ae,ie,x,L);if(typeof fe=="string")return fe;(0,N.$dh)(fe)&&(be||(be=[]),be.push(fe))}return be?(async()=>{for(const Oe of be){const Ee=await Oe;if(typeof Ee=="string")return Ee}return null})():null},Me=Ie.find(Ae=>!!Ae.allBasenames);Me&&(me.allBasenames=Me.allBasenames);const ce=Ie.reduce((Ae,ie)=>ie.allPaths?Ae.concat(ie.allPaths):Ae,[]);return ce.length&&(me.allPaths=ce),me}function j(ae,ve,Ie){if(ve===!1)return a;const de=b(ae,Ie);if(de===a)return a;if(typeof ve=="boolean")return de;if(ve){const me=ve.when;if(typeof me=="string"){const Me=(ce,Ae,ie,L)=>{if(!L||!de(ce,Ae))return null;const x=me.replace("$(basename)",()=>ie),be=L(x);return(0,N.$dh)(be)?be.then(Oe=>Oe?ae:null):be?ae:null};return Me.requiresSiblings=!0,Me}}return de}function K(ae,ve){const Ie=ae.filter(Ae=>!!Ae.basenames);if(Ie.length<2)return ae;const de=Ie.reduce((Ae,ie)=>{const L=ie.basenames;return L?Ae.concat(L):Ae},[]);let me;if(ve){me=[];for(let Ae=0,ie=de.length;Ae<ie;Ae++)me.push(ve)}else me=Ie.reduce((Ae,ie)=>{const L=ie.patterns;return L?Ae.concat(L):Ae},[]);const Me=function(Ae,ie){if(typeof Ae!="string")return null;if(!ie){let x;for(x=Ae.length;x>0;x--){const be=Ae.charCodeAt(x-1);if(be===47||be===92)break}ie=Ae.substr(x)}const L=de.indexOf(ie);return L!==-1?me[L]:null};Me.basenames=de,Me.patterns=me,Me.allBasenames=de;const ce=ae.filter(Ae=>!Ae.basenames);return ce.push(Me),ce}function re(ae,ve){return(0,I.$ub)(ae,ve,(Ie,de)=>typeof Ie=="string"&&typeof de=="string"?Ie===de:typeof Ie!="string"&&typeof de!="string"?Ie.base===de.base&&Ie.pattern===de.pattern:!1)}}),define(Ce[54],Re([1,0,14,131,23,15,2]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.MarkdownStringTextNewlineStyle=void 0,e.$Pk=E,e.$Qk=T,e.$Rk=y,e.$Sk=u,e.$Tk=v,e.$Uk=m,e.$Vk=s,e.$Wk=o;var p;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class f{constructor(n="",t=!1){if(this.value=n,typeof this.value!="string")throw(0,I.$7)("value");typeof t=="boolean"?(this.isTrusted=t,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=t.isTrusted??void 0,this.supportThemeIcons=t.supportThemeIcons??!1,this.supportHtml=t.supportHtml??!1)}appendText(n,t=0){return this.value+=u(this.supportThemeIcons?(0,N.$Ik)(n):n).replace(/([ \t]+)/g,(c,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,t===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,t){return this.value+=`
${v(t,n)}
`,this}appendLink(n,t,c){return this.value+="[",this.value+=this.c(t,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,t){const c=new RegExp((0,F.$9e)(t),"g");return n.replace(c,(l,i)=>n.charAt(i-1)!=="\\"?`\\${l}`:l)}}e.$Ok=f;function E(r){return T(r)?!r.value:Array.isArray(r)?r.every(E):!0}function T(r){return r instanceof f?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}function y(r,n){return r===n?!0:!r||!n?!1:r.value===n.value&&r.isTrusted===n.isTrusted&&r.supportThemeIcons===n.supportThemeIcons&&r.supportHtml===n.supportHtml&&(r.baseUri===n.baseUri||!!r.baseUri&&!!n.baseUri&&(0,A.$Xg)(M.URI.from(r.baseUri),M.URI.from(n.baseUri)))}function u(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function v(r,n){const t=r.match(/^`+/gm)?.reduce((l,i)=>l.length>i.length?l:i).length??0,c=t>=3?t+1:3;return[`${"`".repeat(c)}${n}`,r,`${"`".repeat(c)}`].join(`
`)}function m(r){return r.replace(/"/g,"&quot;")}function s(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(r){const n=[],t=r.split("|").map(l=>l.trim());r=t[0];const c=t[1];if(c){const l=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),$=l?l[1]:"",a=i?i[1]:"",b=isFinite(parseInt(a)),h=isFinite(parseInt($));b&&n.push(`width="${a}"`),h&&n.push(`height="${$}"`)}return{href:r,dimensions:n}}}),define(Ce[96],Re([1,0,18,47,19,21,23,15]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=f,e.$rw=T,e.$sw=u,e.$tw=v,e.$uw=r,e.$vw=t,e.$ww=c,e.$xw=l,e.$yw=i,e.$zw=$;function f(b,h){const{os:D,tildify:d,relative:k}=h;if(k){const w=E(b,k,D);if(typeof w=="string")return w}let g=b.fsPath;if(D===1&&!F.$i?g=g.replace(/\//g,"\\"):D!==1&&F.$i&&(g=g.replace(/\\/g,"/")),D!==1&&d?.userHome){const w=d.userHome.fsPath;let C;b.scheme!==d.userHome.scheme&&b.path[0]===A.$hc.sep&&b.path[1]!==A.$hc.sep?C=d.userHome.with({path:b.path}).fsPath:C=g,g=u(C,w,D)}return(D===1?A.$gc:A.$hc).normalize(T(g,D===1))}function E(b,h,D){const d=D===1?A.$gc:A.$hc,k=D===3?M.$Ug:M.$Wg,g=h.getWorkspace(),S=(0,I.$Ob)(g.folders);if(!S)return;b.scheme!==S.uri.scheme&&b.path[0]===A.$hc.sep&&b.path[1]!==A.$hc.sep&&(b=S.uri.with({path:b.path}));const w=h.getWorkspaceFolder(b);if(!w)return;let C;if(k.isEqual(w.uri,b)?C="":C=k.relativePath(w.uri,b)??"",C&&(C=d.normalize(C)),g.folders.length>1&&!h.noPrefix){const P=w.name?w.name:k.basenameOrAuthority(w.uri);C=C?`${P} \u2022 ${C}`:P}return C}function T(b,h=F.$i){return(0,N.$vg)(b,h)?b.charAt(0).toUpperCase()+b.slice(1):b}let y=Object.create(null);function u(b,h,D=F.OS){if(D===1||!b||!h)return b;let d=y.original===h?y.normalized:void 0;d||(d=h,F.$i&&(d=(0,N.$lg)(d)),d=`${(0,p.$cf)(d,A.$hc.sep)}${A.$hc.sep}`,y={original:h,normalized:d});let k=b;return F.$i&&(k=(0,N.$lg)(k)),(D===3?k.startsWith(d):(0,p.$vf)(k,d))?`~/${k.substr(d.length)}`:b}function v(b,h){return b.replace(/^~($|\/|\\)/,`${h}$1`)}const m="\u2026",s="\\\\",o="~";function r(b,h=A.sep){const D=new Array(b.length);let d=!1;for(let k=0;k<b.length;k++){const g=b[k];if(g===""){D[k]=`.${h}`;continue}if(!g){D[k]=g;continue}d=!0;let S="",w=g;w.indexOf(s)===0?(S=w.substr(0,w.indexOf(s)+s.length),w=w.substr(w.indexOf(s)+s.length)):w.indexOf(h)===0?(S=w.substr(0,w.indexOf(h)+h.length),w=w.substr(w.indexOf(h)+h.length)):w.indexOf(o)===0&&(S=w.substr(0,w.indexOf(o)+o.length),w=w.substr(w.indexOf(o)+o.length));const C=w.split(h);for(let P=1;d&&P<=C.length;P++)for(let W=C.length-P;d&&W>=0;W--){d=!1;let V=C.slice(W,W+P).join(h);for(let q=0;!d&&q<b.length;q++)if(q!==k&&b[q]&&b[q].indexOf(V)>-1){const R=W+P===C.length,j=W>0&&b[q].indexOf(h)>-1?h+V:V,K=b[q].endsWith(j);d=!R||K}if(!d){let q="";(C[0].endsWith(":")||S!=="")&&(W===1&&(W=0,P++,V=C[0]+h+V),W>0&&(q=C[0]+h),q=S+q),W>0&&(q=q+m+h),q=q+V,W+P<C.length&&(q=q+h+m),D[k]=q}}d&&(D[k]=g)}return D}var n;(function(b){b[b.TEXT=0]="TEXT",b[b.VARIABLE=1]="VARIABLE",b[b.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function t(b,h=Object.create(null)){const D=[];let d=!1,k="";for(const g of b)if(g==="$"||d&&g==="{")k&&D.push({value:k,type:n.TEXT}),k="",d=!0;else if(g==="}"&&d){const S=h[k];if(typeof S=="string")S.length&&D.push({value:S,type:n.VARIABLE});else if(S){const w=D[D.length-1];(!w||w.type!==n.SEPARATOR)&&D.push({value:S.label,type:n.SEPARATOR})}k="",d=!1}else k+=g;return k&&!d&&D.push({value:k,type:n.TEXT}),D.filter((g,S)=>{if(g.type===n.SEPARATOR){const w=D[S-1],C=D[S+1];return[w,C].every(P=>P&&(P.type===n.VARIABLE||P.type===n.TEXT)&&P.value.length>0)}return!0}).map(g=>g.value).join("")}function c(b,h){return F.$j||h?b.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$j?"&":"&&"):b.replace(/&&|&/g,D=>D==="&"?"&&":"&")}function l(b,h){return F.$j||h?b.replace(/\(&&\w\)|&&/g,""):F.$i?b.replace(/&&|&/g,D=>D==="&"?"&&":"&"):b.replace(/&&/g,"_")}function i(b){return b.replace(/&/g,"&&")}function $(b){if(b.endsWith("]")){const h=b.lastIndexOf(" [",b.length-2);if(h!==-1){const D=a(b.substring(0,h)),d=b.substring(h);return{name:D.name+d,parentPath:D.parentPath}}}return a(b)}function a(b){const h=b.indexOf("/")!==-1?A.$hc:A.$gc,D=h.basename(b),d=h.dirname(b);return D.length?{name:D,parentPath:d}:{name:d,parentPath:""}}}),define(Ce[144],Re([1,0,22,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=void 0,e.$vn=p,e.$wn=E,e.$xn=T;function A(y){return y.toJSON()}class F{constructor(u){this.a=u}transformIncoming(u){const v=this.a.transformIncoming(u);return v===u?u:A(N.URI.from(v))}transformOutgoing(u){const v=this.a.transformOutgoing(u);return v===u?u:A(N.URI.from(v))}transformOutgoingURI(u){const v=this.a.transformOutgoing(u);return v===u?u:N.URI.from(v)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$tn=F,e.$un=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function M(y,u,v){if(!y||v>200)return null;if(typeof y=="object"){if(y instanceof N.URI)return u.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const s=M(y[m],u,v+1);s!==null&&(y[m]=s)}}return null}function p(y,u){const v=M(y,u,0);return v===null?y:v}function f(y,u,v,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return v?N.URI.revive(u.transformIncoming(y)):u.transformIncoming(y);if(y instanceof I.$Ce)return null;for(const s in y)if(Object.hasOwnProperty.call(y,s)){const o=f(y[s],u,v,m+1);o!==null&&(y[s]=o)}}return null}function E(y,u){const v=f(y,u,!1,0);return v===null?y:v}function T(y,u){const v=f(y,u,!0,0);return v===null?y:v}}),define(Ce[145],Re([1,0,15,21,22]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=void 0,e.$wt=T,e.$xt=y;let F;function M(){return F||(F=new TextDecoder("UTF-16LE")),F}let p;function f(){return p||(p=new TextDecoder("UTF-16BE")),p}let E;function T(){return E||(E=N.$D()?M():f()),E}function y(m,s,o){const r=new Uint16Array(m.buffer,s,o);return o>0&&(r[0]===65279||r[0]===65534)?u(m,s,o):M().decode(r)}function u(m,s,o){const r=[];let n=0;for(let t=0;t<o;t++){const c=A.$Ee(m,s);s+=2,r[n++]=String.fromCharCode(c)}return r.join("")}class v{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return T().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const o=this.a-this.d;o<=1&&(o===0||I.$yf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const o=s.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=s;return}for(let r=0;r<o;r++)this.b[this.d++]=s.charCodeAt(r)}}e.$yt=v}),define(Ce[146],Re([1,0,22,145]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=void 0,e.$At=M;function A(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class F{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,T,y,u){this.oldPosition=E,this.oldText=T,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,T,y){const u=T.length;I.$He(E,u,y),y+=4;for(let v=0;v<u;v++)I.$Fe(E,T.charCodeAt(v),y),y+=2;return y}static d(E,T){const y=I.$Ge(E,T);return T+=4,(0,N.$xt)(E,T,y)}writeSize(){return 8+F.a(this.oldText)+F.a(this.newText)}write(E,T){return I.$He(E,this.oldPosition,T),T+=4,I.$He(E,this.newPosition,T),T+=4,T=F.c(E,this.oldText,T),T=F.c(E,this.newText,T),T}static read(E,T,y){const u=I.$Ge(E,T);T+=4;const v=I.$Ge(E,T);T+=4;const m=F.d(E,T);T+=F.a(m);const s=F.d(E,T);return T+=F.a(s),y.push(new F(u,m,v,s)),T}}e.$zt=F;function M(f,E){return f===null||f.length===0?E:new p(f,E).compress()}class p{constructor(E,T){this.a=E,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,T=0,y=this.n(E),u=this.l(T);for(;E<this.f||T<this.h;){if(y===null){this.k(u),u=this.l(++T);continue}if(u===null){this.m(y),y=this.n(++E);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++T);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++E);continue}if(u.oldPosition<y.newPosition){const[r,n]=p.r(u,y.newPosition-u.oldPosition);this.k(r),u=n;continue}if(y.newPosition<u.oldPosition){const[r,n]=p.q(y,u.oldPosition-y.newPosition);this.m(r),y=n;continue}let s,o;if(u.oldEnd===y.newEnd)s=y,o=u,y=this.n(++E),u=this.l(++T);else if(u.oldEnd<y.newEnd){const[r,n]=p.q(y,u.oldLength);s=r,o=u,y=n,u=this.l(++T)}else{const[r,n]=p.r(u,y.newLength);s=y,o=r,y=this.n(++E),u=n}this.d[this.e++]=new F(s.oldPosition,s.oldText,o.newPosition,o.newText),this.g+=s.newLength-s.oldLength,this.j+=o.newLength-o.oldLength}const v=p.s(this.d);return p.t(v)}k(E){this.d[this.e++]=p.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=p.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,T){return new F(T.oldPosition-E,T.oldText,T.newPosition,T.newText)}static p(E,T){return new F(T.oldPosition,T.oldText,T.newPosition+E,T.newText)}static q(E,T){const y=E.newText.substr(0,T),u=E.newText.substr(T);return[new F(E.oldPosition,E.oldText,E.newPosition,y),new F(E.oldEnd,"",E.newPosition+T,u)]}static r(E,T){const y=E.oldText.substr(0,T),u=E.oldText.substr(T);return[new F(E.oldPosition,y,E.newPosition,E.newText),new F(E.oldPosition+T,u,E.newEnd,"")]}static s(E){if(E.length===0)return E;const T=[];let y=0,u=E[0];for(let v=1;v<E.length;v++){const m=E[v];u.oldEnd===m.oldPosition?u=new F(u.oldPosition,u.oldText+m.oldText,u.newPosition,u.newText+m.newText):(T[y++]=u,u=m)}return T[y++]=u,T}static t(E){if(E.length===0)return E;const T=[];let y=0;for(let u=0;u<E.length;u++){const v=E[u];v.oldText!==v.newText&&(T[y++]=v)}return T}}}),define(Ce[147],Re([1,0,36,19]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=A,e.$Yt=F;function A(M,p,f,E,T,y){if(Array.isArray(M)){let u=0;for(const v of M){const m=A(v,p,f,E,T,y);if(m===10)return m;m>u&&(u=m)}return u}else{if(typeof M=="string")return E?M==="*"?5:M===f?10:0:0;if(M){const{language:u,pattern:v,scheme:m,hasAccessToAllModels:s,notebookType:o}=M;if(!E&&!s)return 0;o&&T&&(p=T);let r=0;if(m)if(m===p.scheme)r=10;else if(m==="*")r=5;else return 0;if(u)if(u===f)r=10;else if(u==="*")r=Math.max(r,5);else return 0;if(o)if(o===y)r=10;else if(o==="*"&&y!==void 0)r=Math.max(r,5);else return 0;if(v){let n;if(typeof v=="string"?n=v:n={...v,base:(0,N.$ic)(v.base)},n===p.fsPath||(0,I.$kk)(n,p.fsPath))r=10;else return 0}return r}else return 0}}function F(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(F):!!M.notebookType}}),define(Ce[148],Re([1,0,5,15,29,94,92,133,146,6]),function(ge,e,I,N,A,F,M,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=void 0;class T extends E.$Uc{constructor(u,v,m,s,o,r,n){super(),this.m=this.B(new I.$be),this.onDidChangeContent=this.m.event,this.f=v,this.j=!r,this.g=s,this.h=o,this.c=new M.$MC(u,m,n)}equals(u){return!(u instanceof T)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,v){return this.c.getOffsetAt(u,v)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,v){const m=u+v,s=this.getPositionAt(u),o=this.getPositionAt(m);return new A.$nt(s.lineNumber,s.column,o.lineNumber,o.column)}getValueInRange(u,v=0){if(u.isEmpty())return"";const m=this.n(v);return this.c.getValueInRange(u,m)}getValueLengthInRange(u,v=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const m=this.getOffsetAt(u.startLineNumber,u.startColumn),s=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const r=this.n(v),n=this.getEOL();if(r.length!==n.length){const t=r.length-n.length,c=u.endLineNumber-u.startLineNumber;o=t*c}return s-m+o}getCharacterCountInRange(u,v=0){if(this.j){let m=0;const s=u.startLineNumber,o=u.endLineNumber;for(let r=s;r<=o;r++){const n=this.getLineContent(r),t=r===s?u.startColumn-1:0,c=r===o?u.endColumn-1:n.length;for(let l=t;l<c;l++)N.$yf(n.charCodeAt(l))?(m=m+1,l=l+1):m=m+1}return m+=this.n(v).length*(o-s),m}return this.getValueLengthInRange(u,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,v){return this.c.getLineCharCode(u,v)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const v=N.$jf(this.getLineContent(u));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(u){const v=N.$lf(this.getLineContent(u));return v===-1?0:v+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,v,m){let s=this.g,o=this.h,r=this.j,n=!0,t=[];for(let h=0;h<u.length;h++){const D=u[h];n&&D._isTracked&&(n=!1);const d=D.range;if(D.text){let C=!0;r||(C=!N.$Jf(D.text),r=C),!s&&C&&(s=N.$If(D.text)),!o&&C&&(o=N.$Lf(D.text))}let k="",g=0,S=0,w=0;if(D.text){let C;[g,S,w,C]=(0,p.$Qt)(D.text);const P=this.getEOL();C===0||C===(P===`\r
`?2:1)?k=D.text:k=D.text.replace(/\r\n|\r|\n/g,P)}t[h]={sortIndex:h,identifier:D.identifier||null,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d),text:k,eolCount:g,firstLineLength:S,lastLineLength:w,forceMoveMarkers:!!D.forceMoveMarkers,isAutoWhitespaceEdit:D.isAutoWhitespaceEdit||!1}}t.sort(T.u);let c=!1;for(let h=0,D=t.length-1;h<D;h++){const d=t[h].range.getEndPosition(),k=t[h+1].range.getStartPosition();if(k.isBeforeOrEqual(d)){if(k.isBefore(d))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(t=this.s(t));const l=m||v?T._getInverseEditRanges(t):[],i=[];if(v)for(let h=0;h<t.length;h++){const D=t[h],d=l[h];if(D.isAutoWhitespaceEdit&&D.range.isEmpty())for(let k=d.startLineNumber;k<=d.endLineNumber;k++){let g="";k===d.startLineNumber&&(g=this.getLineContent(D.range.startLineNumber),N.$jf(g)!==-1)||i.push({lineNumber:k,oldContent:g})}}let $=null;if(m){let h=0;$=[];for(let D=0;D<t.length;D++){const d=t[D],k=l[D],g=this.getValueInRange(d.range),S=d.rangeOffset+h;h+=d.text.length-g.length,$[D]={sortIndex:d.sortIndex,identifier:d.identifier,range:k,text:g,textChange:new f.$zt(d.rangeOffset,g,S,d.text)}}c||$.sort((D,d)=>D.sortIndex-d.sortIndex)}this.g=s,this.h=o,this.j=r;const a=this.t(t);let b=null;if(v&&i.length>0){i.sort((h,D)=>D.lineNumber-h.lineNumber),b=[];for(let h=0,D=i.length;h<D;h++){const d=i[h].lineNumber;if(h>0&&i[h-1].lineNumber===d)continue;const k=i[h].oldContent,g=this.getLineContent(d);g.length===0||g===k||N.$jf(g)!==-1||b.push(d)}}return this.m.fire(),new F.$Cv($,a,b)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let v=!1;const m=u[0].range,s=u[u.length-1].range,o=new A.$nt(m.startLineNumber,m.startColumn,s.endLineNumber,s.endColumn);let r=m.startLineNumber,n=m.startColumn;const t=[];for(let a=0,b=u.length;a<b;a++){const h=u[a],D=h.range;v=v||h.forceMoveMarkers,t.push(this.getValueInRange(new A.$nt(r,n,D.startLineNumber,D.startColumn))),h.text.length>0&&t.push(h.text),r=D.endLineNumber,n=D.endColumn}const c=t.join(""),[l,i,$]=(0,p.$Qt)(c);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:l,firstLineLength:i,lastLineLength:$,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(u){u.sort(T.w);const v=[];for(let m=0;m<u.length;m++){const s=u[m],o=s.range.startLineNumber,r=s.range.startColumn,n=s.range.endLineNumber,t=s.range.endColumn;if(o===n&&r===t&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new A.$nt(o,r,n,t);v.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return v}findMatchesLineByLine(u,v,m,s){return this.c.findMatchesLineByLine(u,v,m,s)}getPieceTree(){return this.c}static _getInverseEditRange(u,v){const m=u.startLineNumber,s=u.startColumn,[o,r,n]=(0,p.$Qt)(v);let t;if(v.length>0){const c=o+1;c===1?t=new A.$nt(m,s,m,s+r):t=new A.$nt(m,s,m+c-1,n+1)}else t=new A.$nt(m,s,m,s);return t}static _getInverseEditRanges(u){const v=[];let m=0,s=0,o=null;for(let r=0,n=u.length;r<n;r++){const t=u[r];let c,l;o?o.range.endLineNumber===t.range.startLineNumber?(c=m,l=s+(t.range.startColumn-o.range.endColumn)):(c=m+(t.range.startLineNumber-o.range.endLineNumber),l=t.range.startColumn):(c=t.range.startLineNumber,l=t.range.startColumn);let i;if(t.text.length>0){const $=t.eolCount+1;$===1?i=new A.$nt(c,l,c,l+t.firstLineLength):i=new A.$nt(c,l,c+$-1,t.lastLineLength+1)}else i=new A.$nt(c,l,c,l);m=i.endLineNumber,s=i.endColumn,v.push(i),o=t}return v}static u(u,v){const m=A.$nt.compareRangesUsingEnds(u.range,v.range);return m===0?u.sortIndex-v.sortIndex:m}static w(u,v){const m=A.$nt.compareRangesUsingEnds(u.range,v.range);return m===0?v.sortIndex-u.sortIndex:-m}}e.$NC=T}),define(Ce[149],Re([1,0,15,92,148]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OC=void 0;class F{constructor(f,E,T,y,u,v,m,s,o){this.a=f,this.b=E,this.c=T,this.d=y,this.e=u,this.f=v,this.g=m,this.h=s,this.j=o}k(f){const E=this.c+this.d+this.e,T=this.c+this.e;return E===0?f===1?`
`:`\r
`:T>E/2?`\r
`:`
`}create(f){const E=this.k(f),T=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let u=0,v=T.length;u<v;u++){const m=T[u].buffer.replace(/\r\n|\r|\n/g,E),s=(0,N.$IC)(m);T[u]=new N.$LC(m,s)}const y=new A.$NC(T,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:y,disposable:y}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&I.$Sf(f)&&(this.b=I.$Rf,f=f.substr(1));const E=f.charCodeAt(f.length-1);E===13||E>=55296&&E<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=E):(this.m(f,!1),this.c=!1,this.d=E)}m(f,E){!E&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const E=(0,N.$JC)(this.e,f);this.a.push(new N.$LC(f,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=I.$If(f)),this.k||(this.k=I.$Lf(f)))}finish(f=!0){return this.o(),new F(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const E=(0,N.$IC)(f.buffer);f.lineStarts=E,this.d===13&&this.f++}}}e.$OC=M}),define(Ce[97],Re([1,0,22,21]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbb=f,e.$Nbb=T;var A;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(A||(A={}));function F(y){for(let u=0,v=y.length;u<v;u+=4){const m=y[u+0],s=y[u+1],o=y[u+2],r=y[u+3];y[u+0]=r,y[u+1]=o,y[u+2]=s,y[u+3]=m}}function M(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return N.$D()||F(u),I.$Ce.wrap(u)}function p(y){const u=y.buffer;if(N.$D()||F(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const v=new Uint8Array(u.byteLength);return v.set(u),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function f(y){const u=new Uint32Array(E(y));let v=0;if(u[v++]=y.id,y.type==="full")u[v++]=1,u[v++]=y.data.length,u.set(y.data,v),v+=y.data.length;else{u[v++]=2,u[v++]=y.deltas.length;for(const m of y.deltas)u[v++]=m.start,u[v++]=m.deleteCount,m.data?(u[v++]=m.data.length,u.set(m.data,v),v+=m.data.length):u[v++]=0}return M(u)}function E(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const v of y.deltas)v.data&&(u+=v.data.length)}return u}function T(y){const u=p(y);let v=0;const m=u[v++];if(u[v++]===1){const n=u[v++],t=u.subarray(v,v+n);return v+=n,{id:m,type:"full",data:t}}const o=u[v++],r=[];for(let n=0;n<o;n++){const t=u[v++],c=u[v++],l=u[v++];let i;l>0&&(i=u.subarray(v,v+l),v+=l),r[n]={start:t,deleteCount:c,data:i}}return{id:m,type:"delta",deltas:r}}}),define(Ce[150],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Ce[151],Re([1,0,18,25,21,134,152,150]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=n,e.clampedFloat=c,e.stringSet=$,e.cursorStyleToString=w,e.filterValidationDecorations=ue;var f;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class y{constructor(Q,$e,He,ye){this.id=Q,this.name=$e,this.defaultValue=He,this.schema=ye}applyUpdate(Q,$e){return v(Q,$e)}compute(Q,$e,He){return He}}class u{constructor(Q,$e){this.newValue=Q,this.didChange=$e}}e.ApplyUpdateResult=u;function v(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new u(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const He=Array.isArray(Y)&&Array.isArray(Q)&&I.$ub(Y,Q);return new u(Q,!He)}let $e=!1;for(const He in Q)if(Q.hasOwnProperty(He)){const ye=v(Y[He],Q[He]);ye.didChange&&(Y[He]=ye.newValue,$e=!0)}return new u(Y,$e)}class m{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,$e){return v(Q,$e)}validate(Q){return this.defaultValue}}class s{constructor(Q,$e,He,ye){this.id=Q,this.name=$e,this.defaultValue=He,this.schema=ye}applyUpdate(Q,$e){return v(Q,$e)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,$e,He){return He}}function o(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:!!Y}class r extends s{constructor(Q,$e,He,ye=void 0){typeof ye<"u"&&(ye.type="boolean",ye.default=He),super(Q,$e,He,ye)}validate(Q){return o(Q,this.defaultValue)}}function n(Y,Q,$e,He){if(typeof Y>"u")return Q;let ye=parseInt(Y,10);return isNaN(ye)?Q:(ye=Math.max($e,ye),ye=Math.min(He,ye),ye|0)}class t extends s{static clampedInt(Q,$e,He,ye){return n(Q,$e,He,ye)}constructor(Q,$e,He,ye,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=He,dt.minimum=ye,dt.maximum=ot),super(Q,$e,He,dt),this.minimum=ye,this.maximum=ot}validate(Q){return t.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function c(Y,Q,$e,He){if(typeof Y>"u")return Q;const ye=l.float(Y,Q);return l.clamp(ye,$e,He)}class l extends s{static clamp(Q,$e,He){return Q<$e?$e:Q>He?He:Q}static float(Q,$e){if(typeof Q=="number")return Q;if(typeof Q>"u")return $e;const He=parseFloat(Q);return isNaN(He)?$e:He}constructor(Q,$e,He,ye,ot){typeof ot<"u"&&(ot.type="number",ot.default=He),super(Q,$e,He,ot),this.validationFn=ye}validate(Q){return this.validationFn(l.float(Q,this.defaultValue))}}class i extends s{static string(Q,$e){return typeof Q!="string"?$e:Q}constructor(Q,$e,He,ye=void 0){typeof ye<"u"&&(ye.type="string",ye.default=He),super(Q,$e,He,ye)}validate(Q){return i.string(Q,this.defaultValue)}}function $(Y,Q,$e,He){return typeof Y!="string"?Q:He&&Y in He?He[Y]:$e.indexOf(Y)===-1?Q:Y}class a extends s{constructor(Q,$e,He,ye,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=ye,ot.default=He),super(Q,$e,He,ot),this.c=ye}validate(Q){return $(Q,this.defaultValue,this.c)}}class b extends y{constructor(Q,$e,He,ye,ot,dt,It=void 0){typeof It<"u"&&(It.type="string",It.enum=ot,It.default=ye),super(Q,$e,He,It),this.c=ot,this.d=dt}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function h(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class D extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,$e,He){return He===0?Q.accessibilitySupport:He}}class d extends y{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:p.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{insertSpace:o($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function g(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function w(Y){switch(Y){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}function C(Y){switch(Y){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class P extends m{constructor(){super(142)}compute(Q,$e,He){const ye=["monaco-editor"];return $e.get(39)&&ye.push($e.get(39)),Q.extraEditorClassName&&ye.push(Q.extraEditorClassName),$e.get(74)==="default"?ye.push("mouse-default"):$e.get(74)==="copy"&&ye.push("mouse-copy"),$e.get(111)&&ye.push("showUnused"),$e.get(140)&&ye.push("showDeprecated"),ye.join(" ")}}class W extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(Q,$e,He){return He&&Q.emptySelectionClipboard}}class V extends y{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:p.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:p.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{cursorMoveOnType:o($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":$($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":$($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o($e.loop,this.defaultValue.loop)}}}class q extends y{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"||Q.length===0?q.OFF:Q==="true"?q.ON:Q:Q?q.ON:q.OFF}}e.EditorFontLigatures=q;class R extends y{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?R.OFF:Q==="true"?R.TRANSLATE:Q:Q?R.TRANSLATE:R.OFF}compute(Q,$e,He){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=R;class j extends m{constructor(){super(50)}compute(Q,$e,He){return Q.fontInfo}}class K extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(Q){const $e=l.float(Q,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp($e,6,100)}compute(Q,$e,He){return Q.fontInfo.fontSize}}class re extends y{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.d,maximum:re.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(t.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,re.d,re.e))}}class ae extends y{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:He,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:He,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:He,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:He,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:He,description:p.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{multiple:$($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??$($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??$($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??$($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??$($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??$($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends y{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:p.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),delay:t.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:o($e.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o($e.above,this.defaultValue.above)}}}var Ie;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class de extends m{constructor(){super(145)}compute(Q,$e,He){return de.computeLayout($e,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const $e=Q.height/Q.lineHeight,He=Math.floor(Q.paddingTop/Q.lineHeight);let ye=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(ye=Math.max(ye,$e-1));const ot=(He+Q.viewLineCount+ye)/(Q.pixelRatio*Q.height),dt=Math.floor(Q.viewLineCount/ot);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:ye,desiredRatio:ot,minimapLineCount:dt}}static c(Q,$e){const He=Q.outerWidth,ye=Q.outerHeight,ot=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const dt=$e.stableMinimapLayoutInput,It=dt&&Q.outerHeight===dt.outerHeight&&Q.lineHeight===dt.lineHeight&&Q.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Q.pixelRatio===dt.pixelRatio&&Q.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Q.paddingTop===dt.paddingTop&&Q.paddingBottom===dt.paddingBottom&&Q.minimap.enabled===dt.minimap.enabled&&Q.minimap.side===dt.minimap.side&&Q.minimap.size===dt.minimap.size&&Q.minimap.showSlider===dt.minimap.showSlider&&Q.minimap.renderCharacters===dt.minimap.renderCharacters&&Q.minimap.maxColumn===dt.minimap.maxColumn&&Q.minimap.scale===dt.minimap.scale&&Q.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Q.isViewportWrapping===dt.isViewportWrapping,Xt=Q.lineHeight,Ut=Q.typicalHalfwidthCharacterWidth,xt=Q.scrollBeyondLastLine,_t=Q.minimap.renderCharacters;let Pt=ot>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Wt=Q.minimap.maxColumn,Qt=Q.minimap.size,Ye=Q.minimap.side,si=Q.verticalScrollbarWidth,Yt=Q.viewLineCount,lt=Q.remainingWidth,vt=Q.isViewportWrapping,ti=_t?2:3;let Zt=Math.floor(ot*ye);const Lt=Zt/ot;let ft=!1,jt=!1,Bt=ti*Pt,qt=Pt/ot,Ge=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:Ft,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Gt,desiredRatio:ni,minimapLineCount:Nt}=de.computeContainedMinimapLineCount({viewLineCount:Yt,scrollBeyondLastLine:xt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:ye,lineHeight:Xt,pixelRatio:ot});if(Yt/Nt>1)ft=!0,jt=!0,Pt=1,Bt=1,qt=Pt/ot;else{let Ct=!1,Dt=Pt+1;if(Qt==="fit"){const pt=Math.ceil((ii+Yt+Gt)*Bt);vt&&It&&lt<=$e.stableFitRemainingWidth?(Ct=!0,Dt=$e.stableFitMaxMinimapScale):Ct=pt>Zt}if(Qt==="fill"||Ct){ft=!0;const pt=Pt;Bt=Math.min(Xt*ot,Math.max(1,Math.floor(1/ni))),vt&&It&&lt<=$e.stableFitRemainingWidth&&(Dt=$e.stableFitMaxMinimapScale),Pt=Math.min(Dt,Math.max(1,Math.floor(Bt/ti))),Pt>pt&&(Ge=Math.min(2,Pt/pt)),qt=Pt/ot/Ge,Zt=Math.ceil(Math.max(Ft,ii+Yt+Gt)*Bt),vt?($e.stableMinimapLayoutInput=Q,$e.stableFitRemainingWidth=lt,$e.stableFitMaxMinimapScale=Pt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const ui=Math.floor(Wt*qt),Ht=Math.min(ui,Math.max(0,Math.floor((lt-si-2)*qt/(Ut+qt)))+e.MINIMAP_GUTTER_WIDTH);let zt=Math.floor(ot*Ht);const gt=zt/ot;zt=Math.floor(zt*Ge);const Tt=_t?1:2,Rt=Ye==="left"?0:He-Ht-si;return{renderMinimap:Tt,minimapLeft:Rt,minimapWidth:Ht,minimapHeightIsEditorHeight:ft,minimapIsSampling:jt,minimapScale:Pt,minimapLineHeight:Bt,minimapCanvasInnerWidth:zt,minimapCanvasInnerHeight:Zt,minimapCanvasOuterWidth:gt,minimapCanvasOuterHeight:Lt}}static computeLayout(Q,$e){const He=$e.outerWidth|0,ye=$e.outerHeight|0,ot=$e.lineHeight|0,dt=$e.lineNumbersDigitCount|0,It=$e.typicalHalfwidthCharacterWidth,Xt=$e.maxDigitWidth,Ut=$e.pixelRatio,xt=$e.viewLineCount,_t=Q.get(137),Pt=_t==="inherit"?Q.get(136):_t,Wt=Pt==="inherit"?Q.get(132):Pt,Qt=Q.get(135),Ye=$e.isDominatedByLongLines,si=Q.get(57),Yt=Q.get(68).renderType!==0,lt=Q.get(69),vt=Q.get(105),ti=Q.get(84),Zt=Q.get(73),Lt=Q.get(103),ft=Lt.verticalScrollbarSize,jt=Lt.verticalHasArrows,Bt=Lt.arrowSize,qt=Lt.horizontalScrollbarSize,Ge=Q.get(43),ui=Q.get(110)!=="never";let Ht=Q.get(66);Ge&&ui&&(Ht+=16);let zt=0;if(Yt){const li=Math.max(dt,lt);zt=Math.round(li*Xt)}let gt=0;si&&(gt=ot*$e.glyphMarginDecorationLaneCount);let Tt=0,Rt=Tt+gt,Ft=Rt+zt,ii=Ft+Ht;const Gt=He-gt-zt-Ht;let ni=!1,Nt=!1,At=-1;Pt==="inherit"&&Ye?(ni=!0,Nt=!0):Wt==="on"||Wt==="bounded"?Nt=!0:Wt==="wordWrapColumn"&&(At=Qt);const Ct=de.c({outerWidth:He,outerHeight:ye,lineHeight:ot,typicalHalfwidthCharacterWidth:It,pixelRatio:Ut,scrollBeyondLastLine:vt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:Zt,verticalScrollbarWidth:ft,viewLineCount:xt,remainingWidth:Gt,isViewportWrapping:Nt},$e.memory||new T);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(Tt+=Ct.minimapWidth,Rt+=Ct.minimapWidth,Ft+=Ct.minimapWidth,ii+=Ct.minimapWidth);const Dt=Gt-Ct.minimapWidth,pt=Math.max(1,Math.floor((Dt-ft-2)/It)),St=jt?Bt:0;return Nt&&(At=Math.max(1,pt),Wt==="bounded"&&(At=Math.min(At,Qt))),{width:He,height:ye,glyphMarginLeft:Tt,glyphMarginWidth:gt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Rt,lineNumbersWidth:zt,decorationsLeft:Ft,decorationsWidth:Ht,contentLeft:ii,contentWidth:Dt,minimap:Ct,viewportColumn:pt,isWordWrapMinified:ni,isViewportWrapping:Nt,wrappingColumn:At,verticalScrollbarWidth:ft,horizontalScrollbarHeight:qt,overviewRuler:{top:St,width:ft,height:ye-2*St,right:0}}}}e.EditorLayoutInfoComputer=de;class me extends y{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(Q){return $(Q,"simple",["simple","advanced"])}compute(Q,$e,He){return $e.get(2)===2?"advanced":He}}var Me;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(Me||(e.ShowLightbulbIconMode=Me={}));class ce extends y{constructor(){const Q={enabled:Me.On};super(65,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Me.Off,Me.OnCode,Me.On],default:Q.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:$(Q.enabled,this.defaultValue.enabled,[Me.Off,Me.OnCode,Me.On])}}}class Ae extends y{constructor(){const Q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:p.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ie extends y{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:p.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:$($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),padding:o($e.padding,this.defaultValue.padding)}}}class L extends y{constructor(){super(66,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):t.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,$e,He){return He<0?t.clampedInt(-He*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class x extends l{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>l.clamp(Q,0,150),{markdownDescription:p.localize(66,null)})}compute(Q,$e,He){return Q.fontInfo.lineHeight}}class be extends y{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:Q.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Q.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Q.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Q.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),autohide:o($e.autohide,this.defaultValue.autohide),size:$($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:$($e.side,this.defaultValue.side,["right","left"]),showSlider:$($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o($e.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt($e.scale,1,1,3),maxColumn:t.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o($e.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o($e.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:l.clamp($e.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Oe(Y){return Y==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class Ee extends y{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{top:t.clampedInt($e.top,0,0,1e3),bottom:t.clampedInt($e.bottom,0,0,1e3)}}}class pe extends y{constructor(){const Q={enabled:!0,cycle:!0};super(86,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:p.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),cycle:o($e.cycle,this.defaultValue.cycle)}}}class fe extends m{constructor(){super(143)}compute(Q,$e,He){return Q.pixelRatio}}class X extends y{constructor(){const Q={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:Q.strings,description:p.localize(88,null)},comments:{anyOf:$e,default:Q.comments,description:p.localize(89,null)},other:{anyOf:$e,default:Q.other,description:p.localize(90,null)}},default:Q,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Ut=Q?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:$e,comments:He,strings:ye}=Q,ot=["on","inline","off"];let dt,It,Xt;return typeof $e=="boolean"?dt=$e?"on":"off":dt=$($e,this.defaultValue.other,ot),typeof He=="boolean"?It=He?"on":"off":It=$(He,this.defaultValue.comments,ot),typeof ye=="boolean"?Xt=ye?"on":"off":Xt=$(ye,this.defaultValue.strings,ot),{other:dt,comments:It,strings:Xt}}}var Z;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(Z||(e.RenderLineNumbersType=Z={}));class le extends y{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(Q){let $e=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?($e=4,He=Q):Q==="interval"?$e=3:Q==="relative"?$e=2:Q==="on"?$e=1:$e=0),{renderType:$e,renderFn:He}}}function ue(Y){const Q=Y.get(98);return Q==="editable"?Y.get(91):Q!=="on"}class Te extends y{constructor(){const Q=[],$e={type:"number",description:p.localize(97,null)};super(102,"rulers",Q,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:Q,description:p.localize(99,null)})}validate(Q){if(Array.isArray(Q)){const $e=[];for(const He of Q)if(typeof He=="number")$e.push({column:t.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const ye=He;$e.push({column:t.clampedInt(ye.column,0,0,1e4),color:ye.color})}return $e.sort((He,ye)=>He.column-ye.column),$e}return this.defaultValue}}class he extends y{constructor(){super(92,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Pe(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ne extends y{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q,He=t.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=t.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe($e.vertical,this.defaultValue.vertical),horizontal:Pe($e.horizontal,this.defaultValue.horizontal),useShadows:o($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:o($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:t.clampedInt($e.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:t.clampedInt($e.verticalSliderSize,ye,0,1e3),scrollByPage:o($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends y{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:p.localize(118,null)}})}applyUpdate(Q,$e){let He=!1;$e.allowedCharacters&&Q&&(N.$2n(Q.allowedCharacters,$e.allowedCharacters)||(Q={...Q,allowedCharacters:$e.allowedCharacters},He=!0)),$e.allowedLocales&&Q&&(N.$2n(Q.allowedLocales,$e.allowedLocales)||(Q={...Q,allowedLocales:$e.allowedLocales},He=!0));const ye=super.applyUpdate(Q,$e);return He?new u(ye.newValue,!0):ye}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{nonBasicASCII:ee($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,$e){if(typeof Q!="object"||!Q)return $e;const He={};for(const[ye,ot]of Object.entries(Q))ot===!0&&(He[ye]=!0);return He}}class U extends y{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Q.fontFamily,description:p.localize(125,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),mode:$($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily)}}}class z extends y{constructor(){const Q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Q.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Q.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Q.backgroundColoring,description:p.localize(132,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),showToolbar:$($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o($e.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends y{constructor(){const Q={enabled:F.$Xs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Xs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends y{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:Q.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:Q.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:Q.highlightActiveIndentation,description:p.localize(148,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{bracketPairs:ee($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Y,Q,$e){const He=$e.indexOf(Y);return He===-1?Q:$e[He]}class ne extends y{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:Q.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:Q.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{insertMode:$($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o($e.showIcons,this.defaultValue.showIcons),showStatusBar:o($e.showStatusBar,this.defaultValue.showStatusBar),preview:o($e.preview,this.defaultValue.preview),previewMode:$($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o($e.showMethods,this.defaultValue.showMethods),showFunctions:o($e.showFunctions,this.defaultValue.showFunctions),showConstructors:o($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:o($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o($e.showFields,this.defaultValue.showFields),showVariables:o($e.showVariables,this.defaultValue.showVariables),showClasses:o($e.showClasses,this.defaultValue.showClasses),showStructs:o($e.showStructs,this.defaultValue.showStructs),showInterfaces:o($e.showInterfaces,this.defaultValue.showInterfaces),showModules:o($e.showModules,this.defaultValue.showModules),showProperties:o($e.showProperties,this.defaultValue.showProperties),showEvents:o($e.showEvents,this.defaultValue.showEvents),showOperators:o($e.showOperators,this.defaultValue.showOperators),showUnits:o($e.showUnits,this.defaultValue.showUnits),showValues:o($e.showValues,this.defaultValue.showValues),showConstants:o($e.showConstants,this.defaultValue.showConstants),showEnums:o($e.showEnums,this.defaultValue.showEnums),showEnumMembers:o($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o($e.showKeywords,this.defaultValue.showKeywords),showWords:o($e.showWords,this.defaultValue.showWords),showColors:o($e.showColors,this.defaultValue.showColors),showFiles:o($e.showFiles,this.defaultValue.showFiles),showReferences:o($e.showReferences,this.defaultValue.showReferences),showFolders:o($e.showFolders,this.defaultValue.showFolders),showTypeParameters:o($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o($e.showSnippets,this.defaultValue.showSnippets),showUsers:o($e.showUsers,this.defaultValue.showUsers),showIssues:o($e.showIssues,this.defaultValue.showIssues)}}}class Fe extends y{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Q.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends y{constructor(){const Q=[];super(130,"wordSegmenterLocales",Q,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Q){if(typeof Q=="string"&&(Q=[Q]),Array.isArray(Q)){const $e=[];for(const He of Q)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&$e.push(He)}catch{}return $e}return this.defaultValue}}var Xe;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Xe||(e.WrappingIndent=Xe={}));class _e extends y{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,$e,He){return $e.get(2)===2?0:He}}class et extends m{constructor(){super(146)}compute(Q,$e,He){const ye=$e.get(145);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}class tt extends y{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),showDropSelector:$($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends y{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),showPasteSelector:$($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?at:A.$k?mt:nt,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var st;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=89]="quickSuggestions",Y[Y.quickSuggestionsDelay=90]="quickSuggestionsDelay",Y[Y.readOnly=91]="readOnly",Y[Y.readOnlyMessage=92]="readOnlyMessage",Y[Y.renameOnType=93]="renameOnType",Y[Y.renderControlCharacters=94]="renderControlCharacters",Y[Y.renderFinalNewline=95]="renderFinalNewline",Y[Y.renderLineHighlight=96]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=98]="renderValidationDecorations",Y[Y.renderWhitespace=99]="renderWhitespace",Y[Y.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Y[Y.roundedSelection=101]="roundedSelection",Y[Y.rulers=102]="rulers",Y[Y.scrollbar=103]="scrollbar",Y[Y.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=105]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=106]="scrollPredominantAxis",Y[Y.selectionClipboard=107]="selectionClipboard",Y[Y.selectionHighlight=108]="selectionHighlight",Y[Y.selectOnLineNumbers=109]="selectOnLineNumbers",Y[Y.showFoldingControls=110]="showFoldingControls",Y[Y.showUnused=111]="showUnused",Y[Y.snippetSuggestions=112]="snippetSuggestions",Y[Y.smartSelect=113]="smartSelect",Y[Y.smoothScrolling=114]="smoothScrolling",Y[Y.stickyScroll=115]="stickyScroll",Y[Y.stickyTabStops=116]="stickyTabStops",Y[Y.stopRenderingLineAfter=117]="stopRenderingLineAfter",Y[Y.suggest=118]="suggest",Y[Y.suggestFontSize=119]="suggestFontSize",Y[Y.suggestLineHeight=120]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Y[Y.suggestSelection=122]="suggestSelection",Y[Y.tabCompletion=123]="tabCompletion",Y[Y.tabIndex=124]="tabIndex",Y[Y.unicodeHighlighting=125]="unicodeHighlighting",Y[Y.unusualLineTerminators=126]="unusualLineTerminators",Y[Y.useShadowDOM=127]="useShadowDOM",Y[Y.useTabStops=128]="useTabStops",Y[Y.wordBreak=129]="wordBreak",Y[Y.wordSegmenterLocales=130]="wordSegmenterLocales",Y[Y.wordSeparators=131]="wordSeparators",Y[Y.wordWrap=132]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=135]="wordWrapColumn",Y[Y.wordWrapOverride1=136]="wordWrapOverride1",Y[Y.wordWrapOverride2=137]="wordWrapOverride2",Y[Y.wrappingIndent=138]="wrappingIndent",Y[Y.wrappingStrategy=139]="wrappingStrategy",Y[Y.showDeprecated=140]="showDeprecated",Y[Y.inlayHints=141]="inlayHints",Y[Y.editorClassName=142]="editorClassName",Y[Y.pixelRatio=143]="pixelRatio",Y[Y.tabFocusMode=144]="tabFocusMode",Y[Y.layoutInfo=145]="layoutInfo",Y[Y.wrappingInfo=146]="wrappingInfo",Y[Y.defaultColorDecorators=147]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:je(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:je(new D),accessibilityPageSize:je(new t(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new i(4,"ariaLabel",p.localize(218,null))),ariaRequired:je(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:je(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:je(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:je(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:je(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:je(new b(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:je(new r(13,"automaticLayout",!1)),autoSurround:je(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:je(new G),bracketPairGuides:je(new H),stickyTabStops:je(new r(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:je(new r(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:je(new i(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:je(new t(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:je(new r(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:je(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:je(new t(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:je(new r(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:je(new d),contextmenu:je(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new r(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:je(new b(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:je(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:je(new b(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:p.localize(260,null)})),cursorSurroundingLines:je(new t(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:je(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:je(new t(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:je(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new r(34,"domReadOnly",!1)),dragAndDrop:je(new r(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:je(new W),dropIntoEditor:je(new tt),stickyScroll:je(new Ae),experimentalWhitespaceRendering:je(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:je(new i(39,"extraEditorClassName","")),fastScrollSensitivity:je(new l(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:p.localize(271,null)})),find:je(new V),fixedOverflowWidgets:je(new r(42,"fixedOverflowWidgets",!1)),folding:je(new r(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:je(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:je(new r(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:je(new r(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:je(new t(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:je(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:je(new j),fontLigatures2:je(new q),fontSize:je(new K),fontWeight:je(new re),fontVariations:je(new R),formatOnPaste:je(new r(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:je(new r(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:je(new r(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:je(new ae),hideCursorInOverviewRuler:je(new r(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:je(new ve),inDiffEditor:je(new r(61,"inDiffEditor",!1)),letterSpacing:je(new l(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>l.clamp(Y,-5,20),{description:p.localize(285,null)})),lightbulb:je(new ce),lineDecorationsWidth:je(new L),lineHeight:je(new x),lineNumbers:je(new le),lineNumbersMinChars:je(new t(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new r(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:je(new r(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:je(new a(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:je(new be),mouseStyle:je(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new l(75,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:je(new r(76,"mouseWheelZoom",!1,{markdownDescription:A.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:je(new r(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:je(new b(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Oe,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:je(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:je(new t(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:je(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:je(new r(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:je(new t(83,"overviewRulerLanes",3,0,3)),padding:je(new Ee),pasteAs:je(new it),parameterHints:je(new pe),peekWidgetDefaultFocus:je(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:je(new r(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:je(new X),quickSuggestionsDelay:je(new t(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:je(new r(91,"readOnly",!1)),readOnlyMessage:je(new he),renameOnType:je(new r(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:je(new r(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:je(new a(95,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:je(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new r(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:je(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:je(new t(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new r(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:je(new Te),scrollbar:je(new Ne),scrollBeyondLastColumn:je(new t(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:je(new r(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:je(new r(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:je(new r(107,"selectionClipboard",!0,{description:p.localize(325,null),included:A.$k})),selectionHighlight:je(new r(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:je(new r(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:je(new r(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:je(new r(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:je(new ie),snippetSuggestions:je(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:je(new Fe),smoothScrolling:je(new r(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:je(new t(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new ne),inlineSuggest:je(new U),inlineEdit:je(new z),inlineCompletionsAccessibilityVerbose:je(new r(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:je(new t(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new t(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new r(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:je(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:je(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:je(new t(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new ze),unusualLineTerminators:je(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:je(new r(127,"useShadowDOM",!0)),useTabStops:je(new r(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:je(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new i(131,"wordSeparators",M.$Ys,{description:p.localize(359,null)})),wordWrap:je(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:je(new i(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new i(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new t(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:je(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new P),defaultColorDecorators:je(new r(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:je(new fe),tabFocusMode:je(new r(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:je(new de),wrappingInfo:je(new et),wrappingIndent:je(new _e),wrappingStrategy:je(new me)}}),define(Ce[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[157],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[158],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Ce[159],Re([9,10]),function(ge,e){return ge.create("vs/platform/log/common/log",e)}),define(Ce[160],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Ce[161],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[162],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Ce[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Ce[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Ce[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Ce[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ce[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[180],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[181],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[182],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[183],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[184],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[185],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[186],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[187],Re([1,0,14,155]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.TokenType=void 0;var A;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(A||(e.TokenType=A={}));function F(...E){switch(E.length){case 1:return(0,N.localize)(0,null,E[0]);case 2:return(0,N.localize)(1,null,E[0],E[1]);case 3:return(0,N.localize)(2,null,E[0],E[1],E[2]);default:return}}const M=(0,N.localize)(3,null),p=(0,N.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const y=this.d,u=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:u};this.g.push({offset:y,lexeme:u,additionalInfo:T}),this.f.push(v)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const y=this.c.substring(this.d,this.e),u=f.b.get(y);u?this.k(u):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,y=!1,u=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(p);return}const m=this.c.charCodeAt(T);if(y)y=!1;else if(m===47&&!u){T++;break}else m===91?u=!0:m===92?y=!0:m===93&&(u=!1);T++}for(;T<this.c.length&&f.a.has(this.c.charCodeAt(T));)T++;this.e=T;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$mj=f}),define(Ce[188],Re([1,0,23,33,157,300]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=f,e.$Cp=E,e.$Dp=T,e.$Ep=y,e.$Fp=u,e.$Gp=v,e.$Hp=m;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function f(r){return r=r.trim(),r==="*"||M.test(r)}function E(r){if(!f(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=r.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function T(r){if(!r)return null;const n=r.majorBase,t=r.majorMustEqual,c=r.minorBase;let l=r.minorMustEqual;const i=r.patchBase;let $=r.patchMustEqual;r.hasCaret&&(n===0||(l=!1),$=!1);let a=0;if(r.preRelease){const b=p.exec(r.preRelease);if(b){const[,h,D,d]=b;a=Date.UTC(Number(h),Number(D)-1,Number(d))}}return{majorBase:n,majorMustEqual:t,minorBase:c,minorMustEqual:l,patchBase:i,patchMustEqual:$,isMinimum:r.hasGreaterEquals,notBefore:a}}function y(r,n,t){let c;typeof r=="string"?c=T(E(r)):c=r;let l;n instanceof Date?l=n.getTime():typeof n=="string"&&(l=new Date(n).getTime());let i;if(typeof t=="string"?i=T(E(t)):i=t,!c||!i)return!1;const $=c.majorBase,a=c.minorBase,b=c.patchBase;let h=i.majorBase,D=i.minorBase,d=i.patchBase;const k=i.notBefore;let g=i.majorMustEqual,S=i.minorMustEqual,w=i.patchMustEqual;return i.isMinimum?$>h?!0:$<h?!1:a>D?!0:a<D||l&&l<k?!1:b>=d:($===1&&h===0&&(!g||!S||!w)&&(h=1,D=0,d=0,g=!0,S=!1,w=!1),$<h?!1:$>h?!g:a<D?!1:a>D?!S:b<d?!1:b>d?!w:!(l&&l<k))}function u(r,n,t,c,l){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([N.default.Error,A.localize(0,null)]),i;if(typeof c.name!="string")return i.push([N.default.Error,A.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([N.default.Error,A.localize(2,null,"version")]),i;if(!c.engines)return i.push([N.default.Error,A.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([N.default.Error,A.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([N.default.Error,A.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([N.default.Error,A.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([N.default.Error,A.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([N.default.Warning,A.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([N.default.Error,A.localize(9,null,"main")]),i;{const b=(0,I.$5g)(t,c.main);(0,I.$Yg)(b,t)||i.push([N.default.Warning,A.localize(10,null,b.path,t.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([N.default.Error,A.localize(11,null,"browser")]),i;{const b=(0,I.$5g)(t,c.browser);(0,I.$Yg)(b,t)||i.push([N.default.Warning,A.localize(12,null,b.path,t.path)])}}if(!F.valid(c.version))return i.push([N.default.Error,A.localize(13,null)]),i;const $=[];if(!v(r,n,c,l,$))for(const b of $)i.push([N.default.Error,b]);return i}function v(r,n,t,c,l){return c||typeof t.main>"u"&&typeof t.browser>"u"?!0:s(r,n,t.engines.vscode,l)}function m(r,n,t){return r==="*"||s(n,t,r)}function s(r,n,t,c=[]){const l=T(E(t));if(!l)return c.push(A.localize(14,null,t)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return c.push(A.localize(15,null,t)),!1}else if(!l.majorMustEqual)return c.push(A.localize(16,null,t)),!1;return y(r,n,l)?!0:(c.push(A.localize(17,null,r,t)),!1)}function o(r){if(!Array.isArray(r))return!1;for(let n=0,t=r.length;n<t;n++)if(typeof r[n]!="string")return!1;return!0}}),define(Ce[70],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class I{constructor(A,F=[],M=!1){this.ctor=A,this.staticArguments=F,this.supportsDelayedInstantiation=M}}e.$oi=I}),define(Ce[55],Re([1,0,70]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$rs=F,e.$ss=M;const N=[];var A;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function F(p,f,E){f instanceof I.$oi||(f=new I.$oi(f,[],!!E)),N.push([p,f])}function M(){return N}}),define(Ce[189],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=void 0;class I{constructor(F,M){this.key=F,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$8q=I;class N{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const M of this.a.values())M.outgoing.size===0&&F.push(M);return F}insertEdge(F,M){const p=this.lookupOrInsertNode(F),f=this.lookupOrInsertNode(M);p.outgoing.set(f.key,f),f.incoming.set(p.key,p)}removeNode(F){const M=this.b(F);this.a.delete(M);for(const p of this.a.values())p.outgoing.delete(M),p.incoming.delete(M)}lookupOrInsertNode(F){const M=this.b(F);let p=this.a.get(M);return p||(p=new I(M,F),this.a.set(M,p)),p}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[M,p]of this.a)F.push(`${M}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,M]of this.a){const p=new Set([F]),f=this.c(M,p);if(f)return f}}c(F,M){for(const[p,f]of F.outgoing){if(M.has(p))return[...M,p].join(" -> ");M.add(p);const E=this.c(f,M);if(E)return E;M.delete(p)}}}e.$9q=N}),define(Ce[3],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e._util=void 0,e.$ri=A,e.$si=F;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function p(f){return f[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=p})(I||(e._util=I={})),e.$qi=A("instantiationService");function N(M,p,f){p[I.DI_TARGET]===p?p[I.DI_DEPENDENCIES].push({id:M,index:f}):(p[I.DI_DEPENDENCIES]=[{id:M,index:f}],p[I.DI_TARGET]=p)}function A(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const p=function(f,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(p,f,T)};return p.toString=()=>M,I.serviceIds.set(M,p),p}function F(M){return M}}),define(Ce[48],Re([1,0,17,2,3]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Xi=void 0,e.$Yi=F,e.$Zi=M,e.$1i=f,e.$2i=E,e.$3i=T,e.$4i=y,e.$5i=u,e.$6i=m,e.$7i=s,e.$8i=o,e.$Xi=(0,A.$ri)("configurationService");function F(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof N.URI)}function M(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof N.URI)}var p;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function f(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}function T(r,n){const t=Object.create(null);for(const c in r)y(t,c,r[c],n);return t}function y(r,n,t,c){const l=n.split("."),i=l.pop();let $=r;for(let a=0;a<l.length;a++){const b=l[a];let h=$[b];switch(typeof h){case"undefined":h=$[b]=Object.create(null);break;case"object":if(h===null){c(`Ignoring ${n} as ${l.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${n} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(h)}`);return}$=h}if(typeof $=="object"&&$!==null)try{$[i]=t}catch{c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify($)}`)}else c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify($)}`)}function u(r,n){const t=n.split(".");v(r,t)}function v(r,n){const t=n.shift();if(n.length===0){delete r[t];return}if(Object.keys(r).indexOf(t)!==-1){const c=r[t];typeof c=="object"&&!Array.isArray(c)&&(v(c,n),Object.keys(c).length===0&&delete r[t])}}function m(r,n,t){function c($,a){let b=$;for(const h of a){if(typeof b!="object"||b===null)return;b=b[h]}return b}const l=n.split("."),i=c(r,l);return typeof i>"u"?t:i}function s(r,n,t){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in r?I.$7f(r[c])&&I.$7f(n[c])?s(r[c],n[c],t):t&&(r[c]=n[c]):r[c]=n[c])})}function o(r){return r.replace(/[\[\]]/g,"")}}),define(Ce[31],Re([1,0,21,15,187,3,154,14]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$pj=e.$oj=e.ContextKeyExprType=void 0,e.$nj=E,e.$qj=$,e.$rj=a,e.$Kj=Me;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",I.$j),f.set("isLinux",I.$k),f.set("isWindows",I.$i),f.set("isWeb",I.$o),f.set("isMacNative",I.$j&&!I.$o),f.set("isEdge",I.$H),f.set("isFirefox",I.$F),f.set("isChrome",I.$E),f.set("isSafari",I.$G);function E(ie,L){if(f.get(ie)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(ie,L)}const T=Object.prototype.hasOwnProperty;var y;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const u={regexParsingWithErrorRecovery:!0},v=(0,M.localize)(0,null),m=(0,M.localize)(1,null),s=(0,M.localize)(2,null),o=(0,M.localize)(3,null),r=(0,M.localize)(4,null),n=(0,M.localize)(5,null),t=(0,M.localize)(6,null),c=(0,M.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=u){this.k=L,this.d=new A.$mj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const be=this.D(),Oe=be.type===17?n:void 0;throw this.h.push({message:r,offset:be.offset,lexeme:A.$mj.getLexeme(be),additionalInfo:Oe}),l.c}return x}catch(x){if(x!==l.c)throw x;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(16);){const x=this.o();L.push(x)}return L.length===1?L[0]:i.or(...L)}o(){const L=[this.s()];for(;this.y(15);){const x=this.s();L.push(x)}return L.length===1?L[0]:i.and(...L)}s(){if(this.y(2)){const L=this.D();switch(L.type){case 11:return this.z(),h.INSTANCE;case 12:return this.z(),D.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),C.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=L.lexeme;if(this.z(),this.y(9)){const Oe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Oe.type!==10)throw this.B("REGEX",Oe);const Ee=Oe.lexeme,pe=Ee.lastIndexOf("/"),fe=pe===Ee.length-1?void 0:this.w(Ee.substring(pe+1));let X;try{X=new RegExp(Ee.substring(1,pe),fe)}catch{throw this.B("REGEX",Oe)}return j.create(x,X)}switch(Oe.type){case 10:case 19:{const Ee=[Oe.lexeme];this.z();let pe=this.D(),fe=0;for(let Te=0;Te<Oe.lexeme.length;Te++)Oe.lexeme.charCodeAt(Te)===40?fe++:Oe.lexeme.charCodeAt(Te)===41&&fe--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:fe++;break;case 1:fe--;break;case 10:case 18:for(let Te=0;Te<pe.lexeme.length;Te++)pe.lexeme.charCodeAt(Te)===40?fe++:Oe.lexeme.charCodeAt(Te)===41&&fe--}if(fe<0)break;Ee.push(A.$mj.getLexeme(pe)),this.z(),pe=this.D()}const X=Ee.join(""),Z=X.lastIndexOf("/"),le=Z===X.length-1?void 0:this.w(X.substring(Z+1));let ue;try{ue=new RegExp(X.substring(1,Z),le)}catch{throw this.B("REGEX",Oe)}return i.regex(x,ue)}case 18:{const Ee=Oe.lexeme;this.z();let pe=null;if(!(0,N.$4e)(Ee)){const fe=Ee.indexOf("/"),X=Ee.lastIndexOf("/");if(fe!==X&&fe>=0){const Z=Ee.slice(fe+1,X),le=Ee[X+1]==="i"?"i":"";try{pe=new RegExp(Z,le)}catch{throw this.B("REGEX",Oe)}}}if(pe===null)throw this.B("REGEX",Oe);return j.create(x,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Oe=this.u();return i.notIn(x,Oe)}switch(this.D().type){case 3:{this.z();const Oe=this.u();if(this.x().type===18)return i.equals(x,Oe);switch(Oe){case"true":return i.has(x);case"false":return i.not(x);default:return i.equals(x,Oe)}}case 4:{this.z();const Oe=this.u();if(this.x().type===18)return i.notEquals(x,Oe);switch(Oe){case"true":return i.not(x);case"false":return i.has(x);default:return i.notEquals(x,Oe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),R.create(x,this.u());case 7:return this.z(),W.create(x,this.u());case 8:return this.z(),V.create(x,this.u());case 13:return this.z(),i.in(x,this.u());default:return i.has(x)}}case 20:throw this.h.push({message:t,offset:L.offset,lexeme:"",additionalInfo:c}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case 17:case 18:return this.z(),L.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,x){if(this.C(L))return this.z();throw this.B(x,this.D())}B(L,x,be){const Oe=(0,M.localize)(8,null,L,A.$mj.getLexeme(x)),Ee=x.offset,pe=A.$mj.getLexeme(x);return this.h.push({message:Oe,offset:Ee,lexeme:pe,additionalInfo:be}),l.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$oj=l;class i{static false(){return h.INSTANCE}static true(){return D.INSTANCE}static has(L){return d.create(L)}static equals(L,x){return k.create(L,x)}static notEquals(L,x){return w.create(L,x)}static regex(L,x){return j.create(L,x)}static in(L,x){return g.create(L,x)}static notIn(L,x){return S.create(L,x)}static not(L){return C.create(L)}static and(...L){return ae.create(L,null,!0)}static or(...L){return ve.create(L,null,!0)}static greater(L,x){return W.create(L,x)}static greaterEquals(L,x){return V.create(L,x)}static smaller(L,x){return q.create(L,x)}static smallerEquals(L,x){return R.create(L,x)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$pj=i;function $(ie){const L=new l({regexParsingWithErrorRecovery:!1});return ie.map(x=>(L.parse(x),L.lexingErrors.length>0?L.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,M.localize)(9,null,be.additionalInfo):(0,M.localize)(10,null),offset:be.offset,length:be.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function a(ie,L){const x=ie?ie.substituteConstants():void 0,be=L?L.substituteConstants():void 0;return!x&&!be?!0:!x||!be?!1:x.equals(be)}function b(ie,L){return ie.cmp(L)}class h{static{this.INSTANCE=new h}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return D.INSTANCE}}e.$sj=h;class D{static{this.INSTANCE=new D}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return h.INSTANCE}}e.$tj=D;class d{static create(L,x=null){const be=f.get(L);return typeof be=="boolean"?be?D.INSTANCE:h.INSTANCE:new d(L,x)}constructor(L,x){this.key=L,this.c=x,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:de(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=f.get(this.key);return typeof L=="boolean"?L?D.INSTANCE:h.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$uj=d;class k{static create(L,x,be=null){if(typeof x=="boolean")return x?d.create(L,be):C.create(L,be);const Oe=f.get(L);return typeof Oe=="boolean"?x===(Oe?"true":"false")?D.INSTANCE:h.INSTANCE:new k(L,x,be)}constructor(L,x,be){this.c=L,this.d=x,this.f=be,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=f.get(this.c);if(typeof L=="boolean"){const x=L?"true":"false";return this.d===x?D.INSTANCE:h.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$vj=k;class g{static create(L,x){return new g(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:me(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const x=L.getValue(this.f),be=L.getValue(this.d);return Array.isArray(x)?x.includes(be):typeof be=="string"&&typeof x=="object"&&x!==null?T.call(x,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$wj=g;class S{static create(L,x){return new S(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=11,this.c=g.create(L,x)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$xj=S;class w{static create(L,x,be=null){if(typeof x=="boolean")return x?C.create(L,be):d.create(L,be);const Oe=f.get(L);return typeof Oe=="boolean"?x===(Oe?"true":"false")?h.INSTANCE:D.INSTANCE:new w(L,x,be)}constructor(L,x,be){this.c=L,this.d=x,this.f=be,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=f.get(this.c);if(typeof L=="boolean"){const x=L?"true":"false";return this.d===x?h.INSTANCE:D.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$yj=w;class C{static create(L,x=null){const be=f.get(L);return typeof be=="boolean"?be?h.INSTANCE:D.INSTANCE:new C(L,x)}constructor(L,x){this.c=L,this.d=x,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=f.get(this.c);return typeof L=="boolean"?L?h.INSTANCE:D.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=d.create(this.c,this)),this.d}}e.$zj=C;function P(ie,L){if(typeof ie=="string"){const x=parseFloat(ie);isNaN(x)||(ie=x)}return typeof ie=="string"||typeof ie=="number"?L(ie):h.INSTANCE}class W{static create(L,x,be=null){return P(x,Oe=>new W(L,Oe,be))}constructor(L,x,be){this.c=L,this.d=x,this.f=be,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Aj=W;class V{static create(L,x,be=null){return P(x,Oe=>new V(L,Oe,be))}constructor(L,x,be){this.c=L,this.d=x,this.f=be,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Bj=V;class q{static create(L,x,be=null){return P(x,Oe=>new q(L,Oe,be))}constructor(L,x,be){this.c=L,this.d=x,this.f=be,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Cj=q;class R{static create(L,x,be=null){return P(x,Oe=>new R(L,Oe,be))}constructor(L,x,be){this.c=L,this.d=x,this.f=be,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Dj=R;class j{static create(L,x){return new j(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const x=this.f?this.f.source:"",be=L.f?L.f.source:"";return x<be?-1:x>be?1:0}equals(L){if(L.type===this.type){const x=this.f?this.f.source:"",be=L.f?L.f.source:"";return this.d===L.d&&x===be}return!1}substituteConstants(){return this}evaluate(L){const x=L.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Ej=j;class K{static create(L){return new K(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new K(this.c.map(L))}negate(){return this.c}}e.$Fj=K;function re(ie){let L=null;for(let x=0,be=ie.length;x<be;x++){const Oe=ie[x].substituteConstants();if(ie[x]!==Oe&&L===null){L=[];for(let Ee=0;Ee<x;Ee++)L[Ee]=ie[Ee]}L!==null&&(L[x]=Oe)}return L===null?ie:L}class ae{static create(L,x,be){return ae.d(L,x,be)}constructor(L,x){this.expr=L,this.c=x,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Oe=b(this.expr[x],L.expr[x]);if(Oe!==0)return Oe}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(L.expr[x]))return!1;return!0}return!1}substituteConstants(){const L=re(this.expr);return L===this.expr?this:ae.create(L,this.c,!1)}evaluate(L){for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].evaluate(L))return!1;return!0}static d(L,x,be){const Oe=[];let Ee=!1;for(const pe of L)if(pe){if(pe.type===1){Ee=!0;continue}if(pe.type===0)return h.INSTANCE;if(pe.type===6){Oe.push(...pe.expr);continue}Oe.push(pe)}if(Oe.length===0&&Ee)return D.INSTANCE;if(Oe.length!==0){if(Oe.length===1)return Oe[0];Oe.sort(b);for(let pe=1;pe<Oe.length;pe++)Oe[pe-1].equals(Oe[pe])&&(Oe.splice(pe,1),pe--);if(Oe.length===1)return Oe[0];for(;Oe.length>1;){const pe=Oe[Oe.length-1];if(pe.type!==9)break;Oe.pop();const fe=Oe.pop(),X=Oe.length===0,Z=ve.create(pe.expr.map(le=>ae.create([le,fe],null,be)),null,X);Z&&(Oe.push(Z),Oe.sort(b))}if(Oe.length===1)return Oe[0];if(be){for(let pe=0;pe<Oe.length;pe++)for(let fe=pe+1;fe<Oe.length;fe++)if(Oe[pe].negate().equals(Oe[fe]))return h.INSTANCE;if(Oe.length===1)return Oe[0]}return new ae(Oe,x)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const x of this.expr)L.push(...x.keys());return L}map(L){return new ae(this.expr.map(x=>x.map(L)),null)}negate(){if(!this.c){const L=[];for(const x of this.expr)L.push(x.negate());this.c=ve.create(L,this,!0)}return this.c}}e.$Gj=ae;class ve{static create(L,x,be){return ve.d(L,x,be)}constructor(L,x){this.expr=L,this.c=x,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Oe=b(this.expr[x],L.expr[x]);if(Oe!==0)return Oe}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(L.expr[x]))return!1;return!0}return!1}substituteConstants(){const L=re(this.expr);return L===this.expr?this:ve.create(L,this.c,!1)}evaluate(L){for(let x=0,be=this.expr.length;x<be;x++)if(this.expr[x].evaluate(L))return!0;return!1}static d(L,x,be){let Oe=[],Ee=!1;if(L){for(let pe=0,fe=L.length;pe<fe;pe++){const X=L[pe];if(X){if(X.type===0){Ee=!0;continue}if(X.type===1)return D.INSTANCE;if(X.type===9){Oe=Oe.concat(X.expr);continue}Oe.push(X)}}if(Oe.length===0&&Ee)return h.INSTANCE;Oe.sort(b)}if(Oe.length!==0){if(Oe.length===1)return Oe[0];for(let pe=1;pe<Oe.length;pe++)Oe[pe-1].equals(Oe[pe])&&(Oe.splice(pe,1),pe--);if(Oe.length===1)return Oe[0];if(be){for(let pe=0;pe<Oe.length;pe++)for(let fe=pe+1;fe<Oe.length;fe++)if(Oe[pe].negate().equals(Oe[fe]))return D.INSTANCE;if(Oe.length===1)return Oe[0]}return new ve(Oe,x)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const x of this.expr)L.push(...x.keys());return L}map(L){return new ve(this.expr.map(x=>x.map(L)),null)}negate(){if(!this.c){const L=[];for(const x of this.expr)L.push(x.negate());for(;L.length>1;){const x=L.shift(),be=L.shift(),Oe=[];for(const Ee of Ae(x))for(const pe of Ae(be))Oe.push(ae.create([Ee,pe],null,!1));L.unshift(ve.create(Oe,null,!1))}this.c=ve.create(L,this,!0)}return this.c}}e.$Hj=ve;class Ie extends d{static{this.d=[]}static all(){return Ie.d.values()}constructor(L,x,be){super(L,null),this.f=x,typeof be=="object"?Ie.d.push({...be,key:L}):be!==!0&&Ie.d.push({key:L,description:be,type:x!=null?typeof x:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return k.create(this.key,L)}notEqualsTo(L){return w.create(this.key,L)}}e.$Ij=Ie,e.$Jj=(0,F.$ri)("contextKeyService");function de(ie,L){return ie<L?-1:ie>L?1:0}function me(ie,L,x,be){return ie<x?-1:ie>x?1:L<be?-1:L>be?1:0}function Me(ie,L){if(ie.type===0||L.type===1)return!0;if(ie.type===9)return L.type===9?ce(ie.expr,L.expr):!1;if(L.type===9){for(const x of L.expr)if(Me(ie,x))return!0;return!1}if(ie.type===6){if(L.type===6)return ce(L.expr,ie.expr);for(const x of ie.expr)if(Me(x,L))return!0;return!1}return ie.equals(L)}function ce(ie,L){let x=0,be=0;for(;x<ie.length&&be<L.length;){const Oe=ie[x].cmp(L[be]);if(Oe<0)return!1;Oe===0&&x++,be++}return x===ie.length}function Ae(ie){return ie.type===9?ie.expr:[ie]}}),define(Ce[190],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=void 0,e.$yi=(0,I.$ri)("environmentService"),e.$zi=(0,I.$si)(e.$yi)}),define(Ce[98],Re([1,0,156,3]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.ExtensionGalleryErrorCode=e.$2o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$1o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$Uo=A,e.$Vo=F,e.$Wo=M,e.$Xo=p,e.$Yo=f,e.$Zo=E,e.$Oo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Po=new RegExp(e.$Oo),e.$Qo="__web_extension",e.$Ro="skipWalkthrough",e.$So="extensionsSync",e.$To="dependecyOrPackExtensionInstall";function A(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function F(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(t,c){switch(t){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(t,c){return c==="web"&&!t.includes("web")}function f(t,c,l){return p(c,l)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===l}function E(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var T;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var y;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var u;(function(t){t.Install="install",t.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var v;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$1o=(0,N.$ri)("extensionGalleryService");var m;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Unknown="Unknown",t.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var s;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class o extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.$2o=o;var r;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class n extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.$3o=n,e.$4o=(0,N.$ri)("extensionManagementService"),e.$5o="extensionsIdentifiers/disabled",e.$6o="extensionsIdentifiers/enabled",e.$7o=(0,N.$ri)("IGlobalExtensionEnablementService"),e.$8o=(0,N.$ri)("IExtensionTipsService"),e.$9o=(0,I.localize2)(0,"Extensions"),e.$0o=(0,I.localize2)(1,"Preferences")}),define(Ce[44],Re([1,0,52,19,15,17,2,158,3,21,12,41]),function(ge,e,I,N,A,F,M,p,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$ql=e.FileKind=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.FileOperationResult=e.$il=e.$hl=e.$gl=e.$el=e.FileChangeType=e.$dl=e.FileOperation=e.$0k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$Xk=void 0,e.$Yk=u,e.$Zk=o,e.$1k=n,e.$2k=t,e.$3k=c,e.$4k=l,e.$5k=i,e.$6k=$,e.$7k=a,e.$8k=b,e.$9k=h,e.$$k=k,e.$_k=g,e.$al=S,e.$bl=w,e.$cl=C,e.$fl=R,e.$rl=Ie,e.$sl=de,e.$ul=Me,e.$Xk=(0,f.$ri)("fileService");function u(ce){return ce.create===!0}var v;(function(ce){ce[ce.Unknown=0]="Unknown",ce[ce.File=1]="File",ce[ce.Directory=2]="Directory",ce[ce.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var m;(function(ce){ce[ce.Readonly=1]="Readonly",ce[ce.Locked=2]="Locked"})(m||(e.FilePermission=m={}));var s;(function(ce){ce[ce.UPDATED=2]="UPDATED",ce[ce.ADDED=4]="ADDED",ce[ce.DELETED=8]="DELETED"})(s||(e.FileChangeFilter=s={}));function o(ce){const Ae=ce;return!!Ae&&typeof Ae.onDidChange=="function"}var r;(function(ce){ce[ce.None=0]="None",ce[ce.FileReadWrite=2]="FileReadWrite",ce[ce.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ce[ce.FileReadStream=16]="FileReadStream",ce[ce.FileFolderCopy=8]="FileFolderCopy",ce[ce.PathCaseSensitive=1024]="PathCaseSensitive",ce[ce.Readonly=2048]="Readonly",ce[ce.Trash=4096]="Trash",ce[ce.FileWriteUnlock=8192]="FileWriteUnlock",ce[ce.FileAtomicRead=16384]="FileAtomicRead",ce[ce.FileAtomicWrite=32768]="FileAtomicWrite",ce[ce.FileAtomicDelete=65536]="FileAtomicDelete",ce[ce.FileClone=131072]="FileClone"})(r||(e.FileSystemProviderCapabilities=r={}));function n(ce){return!!(ce.capabilities&2)}function t(ce){return!!(ce.capabilities&8)}function c(ce){return!!(ce.capabilities&131072)}function l(ce){return!!(ce.capabilities&4)}function i(ce){return!!(ce.capabilities&16)}function $(ce){return n(ce)?!!(ce.capabilities&16384):!1}function a(ce){return n(ce)?!!(ce.capabilities&32768):!1}function b(ce){return!!(ce.capabilities&65536)}function h(ce){return!!(ce.capabilities&2048)}var D;(function(ce){ce.FileExists="EntryExists",ce.FileNotFound="EntryNotFound",ce.FileNotADirectory="EntryNotADirectory",ce.FileIsADirectory="EntryIsADirectory",ce.FileExceedsStorageQuota="EntryExceedsStorageQuota",ce.FileTooLarge="EntryTooLarge",ce.FileWriteLocked="EntryWriteLocked",ce.NoPermissions="NoPermissions",ce.Unavailable="Unavailable",ce.Unknown="Unknown"})(D||(e.FileSystemProviderErrorCode=D={}));class d extends Error{static create(Ae,ie){const L=new d(Ae.toString(),ie);return S(L,ie),L}constructor(Ae,ie){super(Ae),this.code=ie}}e.$0k=d;function k(ce,Ae){return d.create(ce,Ae)}function g(ce){return ce||k((0,p.localize)(0,null),D.Unknown)}function S(ce,Ae){return ce.name=Ae?`${Ae} (FileSystemError)`:"FileSystemError",ce}function w(ce){if(!ce)return D.Unknown;if(ce instanceof d)return ce.code;const Ae=/^(.+) \(FileSystemError\)$/.exec(ce.name);if(!Ae)return D.Unknown;switch(Ae[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}function C(ce){if(ce instanceof j)return ce.fileOperationResult;switch(w(ce)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 9;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileTooLarge:return 7;default:return 10}}var P;(function(ce){ce[ce.CREATE=0]="CREATE",ce[ce.DELETE=1]="DELETE",ce[ce.MOVE=2]="MOVE",ce[ce.COPY=3]="COPY",ce[ce.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class W{constructor(Ae,ie,L){this.resource=Ae,this.operation=ie,this.target=L}isOperation(Ae){return this.operation===Ae}}e.$dl=W;var V;(function(ce){ce[ce.UPDATED=0]="UPDATED",ce[ce.ADDED=1]="ADDED",ce[ce.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class q{static{this.a=null}constructor(Ae,ie){this.c=ie,this.b=void 0,this.d=new y.$V(()=>{const L=I.$xi.forUris(()=>this.c);return L.fill(this.rawAdded.map(x=>[x,!0])),L}),this.f=new y.$V(()=>{const L=I.$xi.forUris(()=>this.c);return L.fill(this.rawUpdated.map(x=>[x,!0])),L}),this.g=new y.$V(()=>{const L=I.$xi.forUris(()=>this.c);return L.fill(this.rawDeleted.map(x=>[x,!0])),L}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const L of Ae){switch(L.type){case 1:this.rawAdded.push(L.resource);break;case 0:this.rawUpdated.push(L.resource);break;case 2:this.rawDeleted.push(L.resource);break}this.b!==q.a&&(typeof L.cId=="number"?this.b===void 0?this.b=L.cId:this.b!==L.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Ae,...ie){return this.h(Ae,{includeChildren:!1},...ie)}affects(Ae,...ie){return this.h(Ae,{includeChildren:!0},...ie)}h(Ae,ie,...L){if(!Ae)return!1;const x=L.length>0;return!!((!x||L.includes(1))&&(this.d.value.get(Ae)||ie.includeChildren&&this.d.value.findSuperstr(Ae))||(!x||L.includes(0))&&(this.f.value.get(Ae)||ie.includeChildren&&this.f.value.findSuperstr(Ae))||(!x||L.includes(2))&&(this.g.value.findSubstr(Ae)||ie.includeChildren&&this.g.value.findSuperstr(Ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ae){return this.b===Ae}hasCorrelation(){return typeof this.b=="number"}}e.$el=q;function R(ce,Ae,ie){return!ce||!Ae||ce===Ae||Ae.length>ce.length?!1:(Ae.charAt(Ae.length-1)!==N.sep&&(Ae+=N.sep),ie?(0,A.$vf)(ce,Ae):ce.indexOf(Ae)===0)}class j extends Error{constructor(Ae,ie,L){super(Ae),this.fileOperationResult=ie,this.options=L}}e.$gl=j;class K extends j{constructor(Ae,ie,L,x){super(Ae,ie,x),this.fileOperationResult=ie,this.size=L}}e.$hl=K;class re extends j{constructor(Ae,ie,L){super(Ae,2,L),this.stat=ie}}e.$il=re;var ae;(function(ce){ce[ce.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ce[ce.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ce[ce.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ce[ce.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ce[ce.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ce[ce.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ce[ce.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ce[ce.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ce[ce.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ce[ce.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ce[ce.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$jl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$kl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ll="files.associations",e.$ml="files.exclude",e.$nl="files.readonlyInclude",e.$ol="files.readonlyExclude",e.$pl="files.readonlyFromPermissions";var ve;(function(ce){ce[ce.FILE=0]="FILE",ce[ce.FOLDER=1]="FOLDER",ce[ce.ROOT_FOLDER=2]="ROOT_FOLDER"})(ve||(e.FileKind=ve={})),e.$ql="";function Ie(ce){if(!(typeof ce.size!="number"||typeof ce.mtime!="number"))return ce.mtime.toString(29)+ce.size.toString(31)}async function de(ce,Ae){if(!Ae.hasProvider(M.URI.from({scheme:ce.scheme})))return new Promise(ie=>{const L=Ae.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===ce.scheme&&x.added&&(L.dispose(),ie())})})}class me{static{this.KB=1024}static{this.MB=me.KB*me.KB}static{this.GB=me.MB*me.KB}static{this.TB=me.GB*me.KB}static formatSize(Ae){return(0,F.$9f)(Ae)||(Ae=0),Ae<me.KB?(0,p.localize)(1,null,Ae.toFixed(0)):Ae<me.MB?(0,p.localize)(2,null,(Ae/me.KB).toFixed(2)):Ae<me.GB?(0,p.localize)(3,null,(Ae/me.MB).toFixed(2)):Ae<me.TB?(0,p.localize)(4,null,(Ae/me.GB).toFixed(2)):(0,p.localize)(5,null,(Ae/me.TB).toFixed(2))}}e.$tl=me;function Me(ce){const Ae=typeof ce=="string"||ce?.scheme===T.Schemas.vscodeRemote;return typeof ce!="string"&&ce?.scheme===T.Schemas.file?1024*me.MB:Ae?10*me.MB:E.$o?50*me.MB:1024*me.MB}}),define(Ce[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=void 0;class I{constructor(...A){this.a=new Map;for(const[F,M]of A)this.set(F,M)}set(A,F){const M=this.a.get(A);return this.a.set(A,F),M}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$pi=I}),define(Ce[191],Re([1,0,11,14,6,70,189,3,71,192]),function(ge,e,I,N,A,F,M,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=void 0;const T=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new f.$pi,r=!1,n,t=T){this.i=o,this.j=r,this.k=n,this.l=t,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$qi,this),this._globalGraph=t?n?._globalGraph??new M.$9q(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,A.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const r=new class extends u{dispose(){this.h.delete(r),super.dispose()}}(o,this.j,this,this.l);return this.h.add(r),r}invokeFunction(o,...r){this.m();const n=m.traceInvocation(this.l,o);let t=!1;try{return o({get:l=>{if(t)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(l,n);if(!i)throw new Error(`[invokeFunction] unknown service '${l}'`);return i}},...r)}finally{t=!0,n.stop()}}createInstance(o,...r){this.m();let n,t;return o instanceof F.$oi?(n=m.traceCreation(this.l,o.ctor),t=this.o(o.ctor,o.staticArguments.concat(r),n)):(n=m.traceCreation(this.l,o),t=this.o(o,r,n)),n.stop(),t}o(o,r=[],n){const t=p._util.getServiceDependencies(o).sort((i,$)=>i.index-$.index),c=[];for(const i of t){const $=this.s(i.id,n);$||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push($)}const l=t.length>0?t[0].index:r.length;if(r.length!==l){console.trace(`[createInstance] First service dependency of ${o.name} at position ${l+1} conflicts with ${r.length} static arguments`);const i=l-r.length;i>0?r=r.concat(new Array(i)):r=r.slice(0,l)}return Reflect.construct(o,r.concat(c))}q(o,r){if(this.i.get(o)instanceof F.$oi)this.i.set(o,r);else if(this.k)this.k.q(o,r);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const r=this.i.get(o);return!r&&this.k?this.k.r(o):r}s(o,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.r(o);return n instanceof F.$oi?this.u(o,n,r.branch(o,!0)):(r.branch(o,!1),n)}u(o,r,n){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,r,n)}finally{this.t.delete(o)}}v(o,r,n){const t=new M.$9q(i=>i.id.toString());let c=0;const l=[{id:o,desc:r,_trace:n}];for(;l.length;){const i=l.pop();if(t.lookupOrInsertNode(i),c++>1e3)throw new y(t);for(const $ of p._util.getServiceDependencies(i.desc.ctor)){const a=this.r($.id);if(a||this.y(`[createInstance] ${o} depends on ${$.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String($.id)),a instanceof F.$oi){const b={id:$.id,desc:a,_trace:i._trace.branch($.id,!0)};t.insertEdge(i,b),l.push(b)}}}for(;;){const i=t.roots();if(i.length===0){if(!t.isEmpty())throw new y(t);break}for(const{data:$}of i){if(this.r($.id)instanceof F.$oi){const b=this.w($.id,$.desc.ctor,$.desc.staticArguments,$.desc.supportsDelayedInstantiation,$._trace);this.q($.id,b)}t.removeNode($)}}return this.r(o)}w(o,r,n=[],t,c){if(this.i.get(o)instanceof F.$oi)return this.x(o,r,n,t,c,this.g);if(this.k)return this.k.w(o,r,n,t,c);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}x(o,r,n=[],t,c,l){if(t){const i=new u(void 0,this.j,this,this.l);i.c=String(o);const $=new Map,a=new I.$Kh(()=>{const b=i.o(r,n,c);for(const[h,D]of $){const d=b[h];if(typeof d=="function")for(const k of D)k.disposable=d.apply(b,k.listener)}return $.clear(),l.add(b),b});return new Proxy(Object.create(null),{get(b,h){if(!a.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let k=$.get(h);return k||(k=new E.$5c,$.set(h,k)),(S,w,C)=>{if(a.isInitialized)return a.value[h](S,w,C);{const P={listener:[S,w,C],disposable:void 0},W=k.push(P);return(0,A.$Sc)(()=>{W(),P.disposable?.dispose()})}}}if(h in b)return b[h];const D=a.value;let d=D[h];return typeof d!="function"||(d=d.bind(D),b[h]=d),d},set(b,h,D){return a.value[h]=D,!0},getPrototypeOf(b){return r.prototype}})}else{const i=this.o(r,n,c);return l.add(i),i}}y(o,r){if(r&&console.warn(o),this.j)throw new Error(o)}}e.$0q=u;var v;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(v||(v={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,r){return o?new m(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,r){return o?new m(1,r.name):m.c}static{this.f=0}constructor(o,r){this.type=o,this.name=r,this.g=Date.now(),this.h=[]}branch(o,r){const n=new m(3,o.toString());return this.h.push([o,r,n]),n}stop(){const o=Date.now()-this.g;m.f+=o;let r=!1;function n(c,l){const i=[],$=new Array(c+1).join("	");for(const[a,b,h]of l.h)if(b&&h){r=!0,i.push(`${$}CREATES -> ${a}`);const D=n(c+1,h);D&&i.push(D)}else i.push(`${$}uses -> ${a}`);return i.join(`
`)}const t=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||r)&&m.all.add(t.join(`
`))}}e.$$q=m}),define(Ce[13],Re([1,0,159,43,5,99,6,28,21,23,17,2,31,3]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$1j=e.LogLevel=e.$Yj=e.$Xj=void 0,e.$Zj=s,e.log=r,e.$_j=d,e.$ak=k,e.$bk=g,e.$ck=S,e.$Xj=(0,v.$ri)("logService"),e.$Yj=(0,v.$ri)("loggerService");function m(){return new Date().toISOString()}function s(w){return(0,T.$9f)(w)}var o;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$1j=o.Info;function r(w,C,P){switch(C){case o.Trace:w.trace(P);break;case o.Debug:w.debug(P);break;case o.Info:w.info(P);break;case o.Warning:w.warn(P);break;case o.Error:w.error(P);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(w,C=!1){let P="";for(let W=0;W<w.length;W++){let V=w[W];if(V instanceof Error&&(V=(0,N.$cj)(V,C)),typeof V=="object")try{V=JSON.stringify(V)}catch{}P+=(W>0?" ":"")+V}return P}class t extends M.$Uc{constructor(){super(...arguments),this.b=e.$1j,this.c=this.B(new A.$be),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$3j=t;class c extends t{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...P){this.f(o.Trace)&&this.g(o.Trace,n([C,...P],!0))}debug(C,...P){this.f(o.Debug)&&this.g(o.Debug,n([C,...P]))}info(C,...P){this.f(o.Info)&&this.g(o.Info,n([C,...P]))}warn(C,...P){this.f(o.Warning)&&this.g(o.Warning,n([C,...P]))}error(C,...P){if(this.f(o.Error))if(C instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=C.stack,this.g(o.Error,n(W))}else this.g(o.Error,n([C,...P]))}flush(){}}e.$4j=c;class l extends t{constructor(C=e.$1j){super(),this.setLevel(C),this.g=!f.$i}trace(C,...P){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,C,...P):console.warn(`[main ${m()}]`,C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,C,...P):console.error(`[main ${m()}]`,C,...P))}flush(){}}e.$5j=l;class i extends t{constructor(C=e.$1j,P=!0){super(),this.g=P,this.setLevel(C)}trace(C,...P){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...P):console.log(C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...P):console.log(C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...P):console.log(C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...P):console.log(C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...P):console.error(C,...P))}flush(){}}e.$6j=i;class $ extends t{constructor(C,P=e.$1j){super(),this.g=C,this.setLevel(P)}trace(C,...P){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...P])}debug(C,...P){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...P])}info(C,...P){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...P])}warn(C,...P){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...P])}error(C,...P){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...P])}h(C){return typeof C=="string"?C:(0,N.$cj)(C,this.f(o.Trace))}flush(){}}e.$7j=$;class a extends t{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const P of this.g)P.setLevel(C);super.setLevel(C)}trace(C,...P){for(const W of this.g)W.trace(C,...P)}debug(C,...P){for(const W of this.g)W.debug(C,...P)}info(C,...P){for(const W of this.g)W.info(C,...P)}warn(C,...P){for(const W of this.g)W.warn(C,...P)}error(C,...P){for(const W of this.g)W.error(C,...P)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$8j=a;class b extends M.$Uc{constructor(C,P,W){if(super(),this.h=C,this.j=P,this.b=new p.$Bc,this.c=this.B(new A.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$be),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(C){return(0,T.$5f)(C)?[...this.b.values()].find(P=>P.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,P){const W=this.n(C),V=(0,T.$5f)(C)?C:P?.id??(0,F.$fj)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const R=P?.logLevel==="always"?o.Trace:P?.logLevel;q||(q=this.s(W,R??this.getLogLevel(W)??this.h,{...P,id:V}));const j={logger:q,info:{resource:W,id:V,logLevel:R,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(j.info),this.b.set(W,j),q}n(C){return(0,T.$5f)(C)?(0,E.$5g)(this.j,`${C}.log`):C}setLogLevel(C,P){if(y.URI.isUri(C)){const W=C,V=P,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=C;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,P){const W=this.m(C);W&&P!==!W.info.hidden&&(W.info.hidden=!P,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,P]))}getLogLevel(C){let P;return C&&(P=this.b.get(C)?.info.logLevel),P??this.h}registerLogger(C){const P=this.b.get(C.resource);P?P.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const P=this.b.get(C);P&&(P.logger&&P.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$9j=b;class h{constructor(){this.onDidChangeLogLevel=new A.$be().event}setLevel(C){}getLevel(){return o.Info}trace(C,...P){}debug(C,...P){}info(C,...P){}warn(C,...P){}error(C,...P){}critical(C,...P){}dispose(){}flush(){}}e.$0j=h;class D extends h{}e.$$j=D;function d(w){if(w.verbose)return o.Trace;if(typeof w.logLevel=="string"){const C=S(w.logLevel.toLowerCase());if(C!==void 0)return C}return e.$1j}function k(w){switch(w){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function g(w){switch(w){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function S(w){switch(w){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$dk=new u.$Ij("logLevel",k(o.Info))}),define(Ce[193],Re([1,0,6,13]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=void 0;class A extends I.$Uc{constructor(M,p=[]){super(),this.a=new N.$8j([M,...p]),this.B(M.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...p){this.a.trace(M,...p)}debug(M,...p){this.a.debug(M,...p)}info(M,...p){this.a.info(M,...p)}warn(M,...p){this.a.warn(M,...p)}error(M,...p){this.a.error(M,...p)}flush(){this.a.flush()}}e.$DQ=A}),define(Ce[100],Re([1,0,33,160,3]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var M;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(f){function E(m,s){return s-m}f.compare=E;const T=Object.create(null);T[f.Error]=(0,N.localize)(0,null),T[f.Warning]=(0,N.localize)(1,null),T[f.Info]=(0,N.localize)(2,null);function y(m){return T[m]||""}f.toString=y;function u(m){switch(m){case I.default.Error:return f.Error;case I.default.Warning:return f.Warning;case I.default.Info:return f.Info;case I.default.Ignore:return f.Hint}}f.fromSeverity=u;function v(m){switch(m){case f.Error:return I.default.Error;case f.Warning:return I.default.Warning;case f.Info:return I.default.Info;case f.Hint:return I.default.Ignore}}f.toSeverity=v}(M||(e.MarkerSeverity=M={}));var p;(function(f){const E="";function T(u){return y(u,!0)}f.makeKey=T;function y(u,v){const m=[E];return u.source?m.push(u.source.replace("\xA6","\\\xA6")):m.push(E),u.code?typeof u.code=="string"?m.push(u.code.replace("\xA6","\\\xA6")):m.push(u.code.value.replace("\xA6","\\\xA6")):m.push(E),u.severity!==void 0&&u.severity!==null?m.push(M.toString(u.severity)):m.push(E),u.message&&v?m.push(u.message.replace("\xA6","\\\xA6")):m.push(E),u.startLineNumber!==void 0&&u.startLineNumber!==null?m.push(u.startLineNumber.toString()):m.push(E),u.startColumn!==void 0&&u.startColumn!==null?m.push(u.startColumn.toString()):m.push(E),u.endLineNumber!==void 0&&u.endLineNumber!==null?m.push(u.endLineNumber.toString()):m.push(E),u.endColumn!==void 0&&u.endColumn!==null?m.push(u.endColumn.toString()):m.push(E),m.push(E),m.join("\xA6")}f.makeKeyOptionalMessage=y})(p||(e.IMarkerData=p={})),e.$Wt=(0,A.$ri)("markerService")}),define(Ce[194],Re([1,0,5,33,3]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zv=e.$Yv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Wv=e.Severity=void 0,e.$Xv=p,e.Severity=N.default,e.$Wv=(0,A.$ri)("notificationService");var F;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var M;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function p(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var f;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class E{constructor(){this.progress=new T,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Yv=E;class T{infinite(){}done(){}total(u){}worked(u){}}e.$Zv=T}),define(Ce[195],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ek=void 0,e.$ek=(0,I.$ri)("productService"),e.$fk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,I,N){var A=arguments.length,F=A<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,I):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(ge,e,I,N);else for(var p=ge.length-1;p>=0;p--)(M=ge[p])&&(F=(A<3?M(F):A>3?M(e,I,F):M(e,I))||F);return A>3&&F&&Object.defineProperty(e,I,F),F},We=this&&this.__param||function(ge,e){return function(I,N){e(I,N,ge)}};define(Ce[101],Re([1,0,11,24,6,3]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.ProgressLocation=e.$1v=void 0,e.$1v=(0,F.$ri)("progressService");var M;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$2v=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$3v=p;class f{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const v=this.d;this.d=()=>{v?.(),u()}}):Promise.resolve()}}e.$4v=f;let E=class extends A.$Uc{constructor(u,v){super(),this.a=new I.$Oh,v.withProgress(u,m=>(this.b=m,this.c&&m.report(this.c),this.a.p)),this.B((0,A.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$5v=E,e.$5v=E=Je([We(1,e.$1v)],E);class T extends A.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new A.$Tc)}start(u){this.stop();const v=++this.a,m=new N.$me;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,A.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Sc)(()=>m.cancel())),this.b.add((0,A.$Sc)(()=>this.c?this.c.done():void 0)),{id:v,token:m.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$6v=T,e.$7v=(0,F.$ri)("editorProgressService")}),define(Ce[30],Re([1,0,56,17]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0;class A{constructor(){this.a=new Map}add(M,p){I.ok(N.$5f(M)),I.ok(N.$7f(p)),I.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,p)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$0n=new A}),define(Ce[72],Re([1,0,5,30]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=void 0,e.$$n={JSONContribution:"base.contributions.json"};function A(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class F{constructor(){this.b=new I.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,E){this.a[A(f)]=E,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const M=new F;N.$0n.add(e.$$n.JSONContribution,M)}),define(Ce[57],Re([1,0,18,5,17,153,48,72,30]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.ConfigurationScope=e.$co=e.EditPresentationTypes=void 0,e.$no=s,e.$oo=o,e.$po=r,e.$qo=t,e.$ro=c;var E;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$co={Configuration:"base.contributions.configuration"};var T;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo="vscode://schemas/settings/resourceLanguage",e.$ko="vscode://schemas/settings/configurationDefaults";const y=f.$0n.as(p.$$n.JSONContribution);class u{constructor(){this.h=new Set,this.i=new N.$be,this.onDidSchemaChange=this.i.event,this.j=new N.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$jo,this.g),this.v()}registerConfiguration(i,$=!0){this.registerConfigurations([i],$)}registerConfigurations(i,$=!0){const a=new Set;this.n(i,$,a),y.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(i){const $=new Set;this.o(i,$),y.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:$})}updateConfigurations({add:i,remove:$}){const a=new Set;this.o($,a),this.n(i,!1,a),y.registerSchema(e.$jo,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(i){const $=new Set;this.k(i,$),this.i.fire(),this.j.fire({properties:$,defaultsOverrides:!0})}k(i,$){const a=[];for(const{overrides:b,source:h}of i)for(const D in b)if($.add(D),e.$mo.test(D)){const d=this.a.get(D),k=d?.valuesSources??new Map;if(h)for(const C of Object.keys(b[D]))k.set(C,h);const g={...d?.value||{},...b[D]};this.a.set(D,{source:h,value:g,valuesSources:k});const S=(0,M.$8i)(D),w={type:"object",default:g,description:F.localize(1,null,S),$ref:e.$jo,defaultDefaultValue:g,source:A.$5f(h)?void 0:h,defaultValueSource:h};a.push(...s(D)),this.d[D]=w,this.b.properties[D]=w}else{this.a.set(D,{value:b[D],source:h});const d=this.d[D];d&&(this.w(D,d),this.r(D,d))}this.m(a)}deregisterDefaultConfigurations(i){const $=new Set;this.l(i,$),this.i.fire(),this.j.fire({properties:$,defaultsOverrides:!0})}l(i,$){for(const{overrides:a,source:b}of i)for(const h in a){const D=this.a.get(h),d=A.$5f(b)?b:b?.id,k=A.$5f(D?.source)?D?.source:D?.source?.id;if(d===k)if($.add(h),this.a.delete(h),e.$mo.test(h))delete this.d[h],delete this.b.properties[h];else{const g=this.d[h];g&&(this.w(h,g),this.r(h,g))}}this.u()}deltaConfiguration(i){let $=!1;const a=new Set;i.removedDefaults&&(this.l(i.removedDefaults,a),$=!0),i.addedDefaults&&(this.k(i.addedDefaults,a),$=!0),i.removedConfigurations&&this.o(i.removedConfigurations,a),i.addedConfigurations&&this.n(i.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:$})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const $ of i)this.h.add($);this.u()}n(i,$,a){i.forEach(b=>{this.p(b,$,b.extensionInfo,b.restrictedProperties,void 0,a),this.c.push(b),this.q(b)})}o(i,$){const a=b=>{if(b.properties)for(const h in b.properties){$.add(h);const D=this.d[h];D?.policy?.name&&this.e.delete(D.policy.name),delete this.d[h],this.s(h,b.properties[h])}b.allOf?.forEach(h=>a(h))};for(const b of i){a(b);const h=this.c.indexOf(b);h!==-1&&this.c.splice(h,1)}}p(i,$=!0,a,b,h=3,D){h=A.$bg(i.scope)?h:i.scope;const d=i.properties;if(d)for(const g in d){const S=d[g];if($&&t(g,S)){delete d[g];continue}if(S.source=a,S.defaultDefaultValue=d[g].default,this.w(g,S),e.$mo.test(g)?S.scope=void 0:(S.scope=A.$bg(S.scope)?h:S.scope,S.restricted=A.$bg(S.restricted)?!!b?.includes(g):S.restricted),d[g].hasOwnProperty("included")&&!d[g].included){this.f[g]=d[g],delete d[g];continue}else this.d[g]=d[g],d[g].policy?.name&&this.e.set(d[g].policy.name,g);!d[g].deprecationMessage&&d[g].markdownDeprecationMessage&&(d[g].deprecationMessage=d[g].markdownDeprecationMessage),D.add(g)}const k=i.allOf;if(k)for(const g of k)this.p(g,$,a,b,h,D)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const $=a=>{const b=a.properties;if(b)for(const D in b)this.r(D,b[D]);a.allOf?.forEach($)};$(i)}r(i,$){switch(e.$do.properties[i]=$,$.scope){case 1:e.$eo.properties[i]=$;break;case 2:e.$fo.properties[i]=$;break;case 6:e.$go.properties[i]=$;break;case 3:e.$ho.properties[i]=$;break;case 4:e.$io.properties[i]=$;break;case 5:e.$io.properties[i]=$,this.g.properties[i]=$;break}}s(i,$){switch(delete e.$do.properties[i],$.scope){case 1:delete e.$eo.properties[i];break;case 2:delete e.$fo.properties[i];break;case 6:delete e.$go.properties[i];break;case 3:delete e.$ho.properties[i];break;case 4:case 5:delete e.$io.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const $=`[${i}]`,a={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$jo};this.w($,a),e.$do.properties[$]=a,e.$eo.properties[$]=a,e.$fo.properties[$]=a,e.$go.properties[$]=a,e.$ho.properties[$]=a,e.$io.properties[$]=a}}v(){const i={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$jo};e.$do.patternProperties[e.$lo]=i,e.$eo.patternProperties[e.$lo]=i,e.$fo.patternProperties[e.$lo]=i,e.$go.patternProperties[e.$lo]=i,e.$ho.patternProperties[e.$lo]=i,e.$io.patternProperties[e.$lo]=i,this.i.fire()}w(i,$){const a=this.a.get(i);let b=a?.value,h=a?.source;A.$_f(b)&&(b=$.defaultDefaultValue,h=void 0),A.$_f(b)&&(b=r($.type)),$.default=b,$.defaultValueSource=h}}const v="\\[([^\\]]+)\\]",m=new RegExp(v,"g");e.$lo=`^(${v})+$`,e.$mo=new RegExp(e.$lo);function s(l){const i=[];if(e.$mo.test(l)){let $=m.exec(l);for(;$?.length;){const a=$[1].trim();a&&i.push(a),$=m.exec(l)}}return(0,I.$Mb)(i)}function o(l){return l.reduce((i,$)=>`${i}[${$}]`,"")}function r(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new u;f.$0n.add(e.$co.Configuration,n);function t(l,i){return l.trim()?e.$mo.test(l)?F.localize(7,null,l):n.getConfigurationProperties()[l]!==void 0?F.localize(8,null,l):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?F.localize(9,null,l,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:F.localize(6,null)}function c(){const l=[],i=n.getConfigurationProperties();for(const $ of Object.keys(i))l.push([$,i[$].scope]);return l.push(["launch",4]),l.push(["task",4]),l}}),define(Ce[196],Re([1,0,18,5,123,6,28,25,17,2,48,57,30]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=e.$vo=e.$uo=e.$to=e.$so=void 0,e.$wo=t;function v($){return Object.isFrozen($)?$:p.$Yn($)}class m{static createEmptyModel(a){return new m({},[],[],void 0,a)}constructor(a,b,h,D,d){this.b=a,this.c=b,this.d=h,this.raw=D,this.f=d,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(b=>{if(b instanceof m)return b;const h=new s("",this.f);return h.parseRaw(b),h.configurationModel});this.g=a.reduce((b,h)=>h===b?h:b.merge(h),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,T.$6i)(this.contents,a):this.contents}inspect(a,b){const h=this;return{get value(){return v(h.rawConfiguration.getValue(a))},get override(){return b?v(h.rawConfiguration.getOverrideValue(a,b)):void 0},get merged(){return v(b?h.rawConfiguration.override(b).getValue(a):h.rawConfiguration.getValue(a))},get overrides(){const D=[];for(const{contents:d,identifiers:k,keys:g}of h.rawConfiguration.overrides){const S=new m(d,g,[],void 0,h.f).getValue(a);S!==void 0&&D.push({identifiers:k,value:S})}return D.length?v(D):void 0}}}getOverrideValue(a,b){const h=this.j(b);return h?a?(0,T.$6i)(h,a):h:void 0}getKeysForOverrideIdentifier(a){const b=[];for(const h of this.overrides)h.identifiers.includes(a)&&b.push(...h.keys);return I.$Mb(b)}getAllOverrideIdentifiers(){const a=[];for(const b of this.overrides)a.push(...b.identifiers);return I.$Mb(a)}override(a){let b=this.a.get(a);return b||(b=this.h(a),this.a.set(a,b)),b}merge(...a){const b=p.$Xn(this.contents),h=p.$Xn(this.overrides),D=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const k of a)if(d.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(b,k.contents);for(const g of k.overrides){const[S]=h.filter(w=>I.$ub(w.identifiers,g.identifiers));S?(this.i(S.contents,g.contents),S.keys.push(...g.keys),S.keys=I.$Mb(S.keys)):h.push(p.$Xn(g))}for(const g of k.keys)D.indexOf(g)===-1&&D.push(g)}return new m(b,D,h,d.every(k=>k instanceof m)?void 0:d,this.f)}h(a){const b=this.j(a);if(!b||typeof b!="object"||!Object.keys(b).length)return this;const h={};for(const D of I.$Mb([...Object.keys(this.contents),...Object.keys(b)])){let d=this.contents[D];const k=b[D];k&&(typeof d=="object"&&typeof k=="object"?(d=p.$Xn(d),this.i(d,k)):d=k),h[D]=d}return new m(h,this.keys,this.overrides,void 0,this.f)}i(a,b){for(const h of Object.keys(b)){if(h in a&&f.$7f(a[h])&&f.$7f(b[h])){this.i(a[h],b[h]);continue}a[h]=p.$Xn(b[h])}}j(a){let b=null,h=null;const D=d=>{d&&(h?this.i(h,d):h=p.$Xn(d))};for(const d of this.overrides)d.identifiers.length===1&&d.identifiers[0]===a?b=d.contents:d.identifiers.includes(a)&&D(d.contents);return D(b),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,b){this.k(a,b,!0)}setValue(a,b){this.k(a,b,!1)}removeValue(a){const b=this.keys.indexOf(a);b!==-1&&(this.keys.splice(b,1),(0,T.$5i)(this.contents,a),y.$mo.test(a)&&this.overrides.splice(this.overrides.findIndex(h=>I.$ub(h.identifiers,(0,y.$no)(a))),1))}k(a,b,h){(0,T.$4i)(this.contents,a,b,D=>this.f.error(D)),h=h||this.keys.indexOf(a)===-1,h&&this.keys.push(a),y.$mo.test(a)&&this.overrides.push({identifiers:(0,y.$no)(a),keys:Object.keys(this.contents[a]),contents:(0,T.$3i)(this.contents[a],D=>this.f.error(D))})}}e.$so=m;class s{constructor(a,b){this.f=a,this.g=b,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,b){if(!f.$bg(a)){const h=this.h(a);this.parseRaw(h,b)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,b){this.a=a;const{contents:h,keys:D,overrides:d,restricted:k,hasExcludedProperties:g}=this.i(a,b);this.b=new m(h,D,d,g?[a]:void 0,this.g),this.c=k||[]}h(a){let b={},h=null,D=[];const d=[],k=[];function g(w){Array.isArray(D)?D.push(w):h!==null&&(D[h]=w)}const S={onObjectBegin:()=>{const w={};g(w),d.push(D),D=w,h=null},onObjectProperty:w=>{h=w},onObjectEnd:()=>{D=d.pop()},onArrayBegin:()=>{const w=[];g(w),d.push(D),D=w,h=null},onArrayEnd:()=>{D=d.pop()},onLiteralValue:g,onError:(w,C,P)=>{k.push({error:w,offset:C,length:P})}};if(a)try{A.$Ln(a,S),b=D[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return b}i(a,b){const h=u.$0n.as(y.$co.Configuration).getConfigurationProperties(),D=this.j(a,h,!0,b);a=D.raw;const d=(0,T.$3i)(a,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`)),k=Object.keys(a),g=this.l(a,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:d,keys:k,overrides:g,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(a,b,h,D){let d=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:d};const k={},g=[];for(const S in a)if(y.$mo.test(S)&&h){const w=this.j(a[S],b,!1,D);k[S]=w.raw,d=d||w.hasExcludedProperties,g.push(...w.restricted)}else{const w=b[S],C=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&g.push(S),!D.exclude?.includes(S)&&(D.include?.includes(S)||(C===void 0||D.scopes===void 0||D.scopes.includes(C))&&!(D.skipRestricted&&w?.restricted))?k[S]=a[S]:d=!0}return{raw:k,restricted:g,hasExcludedProperties:d}}l(a,b){const h=[];for(const D of Object.keys(a))if(y.$mo.test(D)){const d={};for(const k in a[D])d[k]=a[D][k];h.push({identifiers:(0,y.$no)(D),keys:Object.keys(d),contents:(0,T.$3i)(d,b)})}return h}}e.$to=s;class o extends F.$Uc{constructor(a,b,h,D,d){super(),this.c=a,this.f=b,this.g=D,this.h=d,this.b=this.B(new N.$be),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),d),this.B(this.g.watch(h.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&h.isEqual(k.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$uo=o;class r{constructor(a,b,h,D,d,k,g,S,w,C,P,W,V){this.a=a,this.b=b,this.c=h,this.overrideIdentifiers=D,this.d=d,this.f=k,this.g=g,this.h=S,this.i=w,this.j=C,this.k=P,this.l=W,this.m=V}get value(){return v(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,b,h,D,d,k,g,S,w,C){this.j=a,this.l=b,this.m=h,this.n=D,this.p=d,this.q=k,this.r=g,this.s=S,this.t=w,this.u=C,this.h=null,this.i=new M.$Bc,this.v=null}getValue(a,b,h){return this.w(a,b,h).getValue(a)}updateValue(a,b,h={}){let D;h.resource?(D=this.t.get(h.resource),D||(D=m.createEmptyModel(this.u),this.t.set(h.resource,D))):D=this.s,b===void 0?D.removeValue(a):D.setValue(a,b),h.resource||(this.h=null)}inspect(a,b,h){const D=this.w(a,b,h),d=this.A(b.resource,h),k=b.resource?this.t.get(b.resource)||this.s:this.s,g=new Set;for(const S of D.overrides)for(const w of S.identifiers)D.getOverrideValue(a,w)!==void 0&&g.add(w);return new r(a,b,D.getValue(a),g.size?[...g]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,h?this.q:void 0,d||void 0,k)}keys(a){const b=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:b?b.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,b){this.r.set(a,b),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,b){const h=[];if(!b){const{added:D,updated:d,removed:k}=l(this.j,a);b=[...D,...d,...k]}for(const D of b)for(const d of(0,y.$no)(D)){const k=this.j.getKeysForOverrideIdentifier(d),g=a.getKeysForOverrideIdentifier(d),S=[...g.filter(w=>k.indexOf(w)===-1),...k.filter(w=>g.indexOf(w)===-1),...k.filter(w=>!p.$2n(this.j.override(d).getValue(w),a.override(d).getValue(w)))];h.push([d,S])}return this.updateDefaultConfiguration(a),{keys:b,overrides:h}}compareAndUpdatePolicyConfiguration(a){const{added:b,updated:h,removed:D}=l(this.l,a),d=[...b,...h,...D];return d.length&&this.updatePolicyConfiguration(a),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:b,updated:h,removed:D,overrides:d}=l(this.applicationConfiguration,a),k=[...b,...h,...D];return k.length&&this.updateApplicationConfiguration(a),{keys:k,overrides:d}}compareAndUpdateLocalUserConfiguration(a){const{added:b,updated:h,removed:D,overrides:d}=l(this.localUserConfiguration,a),k=[...b,...h,...D];return k.length&&this.updateLocalUserConfiguration(a),{keys:k,overrides:d}}compareAndUpdateRemoteUserConfiguration(a){const{added:b,updated:h,removed:D,overrides:d}=l(this.remoteUserConfiguration,a),k=[...b,...h,...D];return k.length&&this.updateRemoteUserConfiguration(a),{keys:k,overrides:d}}compareAndUpdateWorkspaceConfiguration(a){const{added:b,updated:h,removed:D,overrides:d}=l(this.workspaceConfiguration,a),k=[...b,...h,...D];return k.length&&this.updateWorkspaceConfiguration(a),{keys:k,overrides:d}}compareAndUpdateFolderConfiguration(a,b){const h=this.folderConfigurations.get(a),{added:D,updated:d,removed:k,overrides:g}=l(h,b),S=[...D,...d,...k];return(S.length||!h)&&this.updateFolderConfiguration(a,b),{keys:S,overrides:g}}compareAndDeleteFolderConfiguration(a){const b=this.folderConfigurations.get(a);if(!b)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:h,updated:D,removed:d,overrides:k}=l(b,void 0);return{keys:[...h,...D,...d],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,b,h){let D=this.x(b,h);return b.overrideIdentifier&&(D=D.override(b.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(D=D.merge(this.l)),D}x({resource:a},b){let h=this.y();if(b&&a){const D=b.getFolder(a);D&&(h=this.z(D.uri)||h);const d=this.t.get(a);d&&(h=h.merge(d))}return h}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let b=this.i.get(a);if(!b){const h=this.y(),D=this.r.get(a);D?(b=h.merge(D),this.i.set(a,b)):b=h}return b}A(a,b){if(b&&a){const h=b.getFolder(a);if(h)return this.r.get(h.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,b)=>{const{contents:h,overrides:D,keys:d}=this.r.get(b);return a.push([b,{contents:h,overrides:D,keys:d}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(b=>a.add(b)),this.userConfiguration.keys.forEach(b=>a.add(b)),this.q.keys.forEach(b=>a.add(b)),this.r.forEach(b=>b.keys.forEach(h=>a.add(h))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(b=>a.add(b)),this.userConfiguration.getAllOverrideIdentifiers().forEach(b=>a.add(b)),this.q.getAllOverrideIdentifiers().forEach(b=>a.add(b)),this.r.forEach(b=>b.getAllOverrideIdentifiers().forEach(h=>a.add(h))),[...a.values()]}D(a){const b=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(h=>b.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(h=>b.add(h)),this.q.getKeysForOverrideIdentifier(a).forEach(h=>b.add(h)),this.r.forEach(h=>h.getKeysForOverrideIdentifier(a).forEach(D=>b.add(D))),[...b.values()]}static parse(a,b){const h=this.E(a.defaults,b),D=this.E(a.policy,b),d=this.E(a.application,b),k=this.E(a.user,b),g=this.E(a.workspace,b),S=a.folders.reduce((w,C)=>(w.set(E.URI.revive(C[0]),this.E(C[1],b)),w),new M.$Bc);return new n(h,D,d,k,m.createEmptyModel(b),g,S,m.createEmptyModel(b),new M.$Bc,b)}static E(a,b){return new m(a.contents,a.keys,a.overrides,void 0,b)}}e.$vo=n;function t(...$){if($.length===0)return{keys:[],overrides:[]};if($.length===1)return $[0];const a=new Set,b=new Map;for(const D of $)D.keys.forEach(d=>a.add(d)),D.overrides.forEach(([d,k])=>{const g=(0,M.$yc)(b,d,new Set);k.forEach(S=>g.add(S))});const h=[];return b.forEach((D,d)=>h.push([d,[...D.values()]])),{keys:[...a.values()],overrides:h}}class c{constructor(a,b,h,D,d){this.change=a,this.f=b,this.g=h,this.h=D,this.i=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of a.keys)this.affectedKeys.add(k);for(const[,k]of a.overrides)for(const g of k)this.affectedKeys.add(g);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,b){const h=this.a+a,D=this.d.indexOf(h);if(D<0)return!1;const d=D+h.length;if(d>=this.d.length)return!1;const k=this.d.charCodeAt(d);if(k!==this.b&&k!==this.c)return!1;if(b){const g=this.previousConfiguration?this.previousConfiguration.getValue(a,b,this.f?.workspace):void 0,S=this.g.getValue(a,b,this.h);return!p.$2n(g,S)}return!0}}e.$xo=c;function l($,a){const{added:b,removed:h,updated:D}=i(a?.rawConfiguration,$?.rawConfiguration),d=[],k=$?.getAllOverrideIdentifiers()||[],g=a?.getAllOverrideIdentifiers()||[];if(a){const S=g.filter(w=>!k.includes(w));for(const w of S)d.push([w,a.getKeysForOverrideIdentifier(w)])}if($){const S=k.filter(w=>!g.includes(w));for(const w of S)d.push([w,$.getKeysForOverrideIdentifier(w)])}if(a&&$){for(const S of k)if(g.includes(S)){const w=i({contents:$.getOverrideValue(void 0,S)||{},keys:$.getKeysForOverrideIdentifier(S)},{contents:a.getOverrideValue(void 0,S)||{},keys:a.getKeysForOverrideIdentifier(S)});d.push([S,[...w.added,...w.removed,...w.updated]])}}return{added:b,removed:h,updated:D,overrides:d}}function i($,a){const b=$?a?$.keys.filter(d=>a.keys.indexOf(d)===-1):[...$.keys]:[],h=a?$?a.keys.filter(d=>$.keys.indexOf(d)===-1):[...a.keys]:[],D=[];if($&&a){for(const d of a.keys)if($.keys.indexOf(d)!==-1){const k=(0,T.$6i)(a.contents,d),g=(0,T.$6i)($.contents,d);p.$2n(k,g)||D.push(d)}}return{added:b,removed:h,updated:D}}}),define(Ce[102],Re([1,0,14,3]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.RemoteAuthorityResolverErrorCode=e.$El=e.$Dl=e.RemoteConnectionType=e.$Cl=void 0,e.$Gl=E,e.$Cl=(0,N.$ri)("remoteAuthorityResolverService");var A;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class F{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Dl=F;class M{constructor(y,u){this.host=y,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$El=M;var p;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class f extends I.$bb{static isNotAvailable(y){return y instanceof f&&y._code===p.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof f&&y._code===p.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof f&&y._code===p.NoResolverFound}static isInvalidAuthority(y){return y instanceof f&&y._code===p.InvalidAuthority}static isHandled(y){return y instanceof f&&y.isHandled}constructor(y,u=p.Unknown,v){super(y),this._message=y,this._code=u,this._detail=v,this.isHandled=u===p.NotAvailable&&v===!0,Object.setPrototypeOf(this,f.prototype)}}e.$Fl=f;function E(T){const y=T.indexOf("+");return y===-1?T:T.substring(0,y)}}),define(Ce[58],Re([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=N,e.$Dm=A,e.$Em=F,e.$Fm=M;function N(f){return f.scheme===I.Schemas.vscodeRemote?f.authority:void 0}function A(f){if(!f)return;const E=f.indexOf("+");return E<0?f:f.substr(0,E)}function F(f){const{host:E,port:T}=p(f);if(typeof T>"u")throw new Error(`Invalid remote authority: ${f}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:T}}function M(f,E){let{host:T,port:y}=p(f);return typeof y>"u"&&(y=E),{host:T,port:y}}function p(f){const E=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const T=f.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const y=f.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:f,port:void 0}}}),define(Ce[20],Re([1,0,15,3,58]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Om=e.$Nm=e.$Mm=e.TargetPlatform=e.ExtensionType=e.$Lm=e.$Jm=e.$Im=e.$Hm=e.$Gm=void 0,e.$Km=F,e.$Pm=y,e.$Qm=u,e.$Rm=v,e.$Sm=m,e.$Gm="extensions.user.cache",e.$Hm="extensions.builtin.cache",e.$Im="undefined_publisher",e.$Jm=["ui","workspace","web"];function F(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$Lm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(M||(e.ExtensionType=M={}));var p;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class f{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,r){if(typeof o>"u"||o===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof o=="string"||typeof r=="string"){const n=typeof o=="string"?o:o.value,t=typeof r=="string"?r:r.value;return I.$uf(n,t)}return o._lower===r._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Mm=f;class E{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const r of o)this.add(r)}add(o){this.c.add(f.toKey(o))}delete(o){return this.c.delete(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}}e.$Nm=E;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(f.toKey(o))}get(o){return this.c.get(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}set(o,r){this.c.set(f.toKey(o),r)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Om=T;function y(s){return u(s)}function u(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function v(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function m(s,o){if(o){const r=`onResolveRemoteAuthority:${(0,A.$Dm)(o)}`;return!!s.activationEvents?.includes(r)}return!1}e.$Tm=(0,N.$ri)("IBuiltinExtensionsScannerService")}),define(Ce[103],Re([1,0,14,20]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fG=e.$eG=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(M,p){this.a.set(M,p)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const p=Object.create(null);for(const f of M){const E=this.readActivationEvents(f);E.length>0&&(p[N.$Mm.toKey(f.identifier)]=E)}return p}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const p=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let f=0;f<p.length;f++)p[f]==="onUri"&&(p[f]=`onUri:${N.$Mm.toKey(M.identifier)}`);if(!M.contributes)return p;for(const f in M.contributes){const E=this.a.get(f);if(!E)continue;const T=M.contributes[f],y=Array.isArray(T)?T:[T];try{E(y,p)}catch(u){(0,I.$1)(u)}}return p}}e.$eG=A,e.$fG=new A}),define(Ce[197],Re([1,0,21,73,35]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=M,e.$_o=p;function F(f){if(I.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function M(f,E,T,y,u,v,m,s,o){const r=Object.create(null);r["common.machineId"]=v,r["common.sqmId"]=m,r.sessionID=(0,A.$Ng)()+Date.now(),r.commitHash=y,r.version=u,r["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,I.$h)(I.$u),r["common.nodePlatform"]=N.$ec,r["common.nodeArch"]=T,r["common.product"]=o||"desktop",s&&(r["common.msftInternal"]=s);let n=0;const t=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),I.$l&&(r["common.snap"]="true");const c=F(E);return c&&(r["common.platformDetail"]=c),r}function p(f){const E=N.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return f.some(y=>T===y)}}),define(Ce[198],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0,e.$Wl=(0,I.$ri)("telemetryService"),e.$Xl=(0,I.$ri)("customEndpointTelemetryService"),e.$Yl="telemetry.currentSessionDate",e.$Zl="telemetry.firstSessionDate",e.$1l="telemetry.lastSessionDate",e.$2l="telemetry.machineId",e.$3l="telemetry.sqmId",e.$4l="telemetry",e.$5l="telemetry.telemetryLevel",e.$6l="telemetry.enableCrashReporter",e.$7l="telemetry.enableTelemetry";var N;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var A;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(Ce[59],Re([1,0,25,17,58,197,198]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0,e.$hp=T,e.$ip=y,e.$jp=u,e.$kp=v,e.$lp=s,e.$mp=r,e.$np=n,e.$op=l;class p{constructor($){this.value=$,this.isTrustedTelemetryValue=!0}}e.$ap=p;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$bp=f,e.$cp=new f;class E{async publicLog($,a,b){}async publicLogError($,a,b){}}e.$dp=E,e.$ep="telemetry",e.$fp="extensionTelemetryLog",e.$gp={log:()=>null,flush:()=>Promise.resolve(null)};function T(i,$){return!$.isBuilt&&!$.disableTelemetry?!0:!($.disableTelemetry||!i.enableTelemetry)}function y(i,$){return $.extensionTestsLocationURI?!0:!($.isBuilt||$.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function u(i){const $=i.getValue(M.$5l),a=i.getValue(M.$6l);if(i.getValue(M.$7l)===!1||a===!1)return 0;switch($??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function v(i){const $={},a={},b={};o(i,b);for(let h in b){h=h.length>150?h.substr(h.length-149):h;const D=b[h];typeof D=="number"?a[h]=D:typeof D=="boolean"?a[h]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${D.length}`),$[h]=D.substring(0,8191)):typeof D<"u"&&D!==null&&($[h]=D)}return{properties:$,measurements:a}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const $=(0,A.$Dm)(i);return m.has($)?$:"other"}function o(i,$,a=0,b){if(i)for(const h of Object.getOwnPropertyNames(i)){const D=i[h],d=b?b+h:h;Array.isArray(D)?$[d]=(0,I.$3n)(D):D instanceof Date?$[d]=D.toISOString():(0,N.$7f)(D)?a<2?o(D,$,a+1,d+"."):$[d]=(0,I.$3n)(D):$[d]=D}}function r(i,$){const a=i.msftInternalDomains||[],b=$.getValue("telemetry.internalTesting");return(0,F.$_o)(a)||b}function n(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function t(i,$){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const b=[];for(const k of $)for(;;){const g=k.exec(i);if(!g)break;b.push([g.index,k.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(a="";;){const k=D.exec(i);if(!k)break;const g=b.some(([S,w])=>k.index<w&&S<D.lastIndex);!h.test(k[0])&&!g&&(a+=i.substring(d,k.index)+"<REDACTED: user-file-path>",d=D.lastIndex)}return d<i.length&&(a+=i.substr(d)),a}function c(i){if(!i)return i;const $=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of $)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function l(i,$){return(0,I.$Zn)(i,a=>{if(a instanceof p||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let b=a.replaceAll("%20"," ");b=t(b,$);for(const h of $)b=b.replace(h,"");return b=c(b),b}})}}),define(Ce[199],Re([1,0,15,98,20,21,2,14,73,59]),function(ge,e,I,N,A,F,M,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$qp=void 0,e.$pp=T,e.$rp=m,e.$sp=s,e.$tp=o,e.$up=r,e.$vp=n,e.$wp=t,e.$xp=c,e.$zp=l,e.$Ap=$;function T(a,b){return a.uuid&&b.uuid?a.uuid===b.uuid:a.id===b.id?!0:(0,I.$pf)(a.id,b.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(b){const h=b.manifest?b.manifest.version:b.version,D=b.manifest?b.targetPlatform:b.properties.targetPlatform;return new u(b.identifier,h,D)}static parse(b){const h=y.exec(b);return h&&h[1]&&h[2]?new u({id:h[1]},h[2],h[4]||void 0):null}constructor(b,h,D="undefined"){this.version=h,this.targetPlatform=D,this.id=b.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(b){return b instanceof u?T(this,b)&&this.version===b.version&&this.targetPlatform===b.targetPlatform:!1}}e.$qp=u;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(a){const b=v.exec(a);return b&&b[1]?[o(b[1]),b[2]]:[o(a),void 0]}function s(a,b){return`${a}.${b}`}function o(a){return a.toLowerCase()}function r(a,b){return o(s(a??A.$Im,b))}function n(a,b){const h=[],D=d=>{for(const k of h)if(k.some(g=>T(b(g),b(d))))return k;return null};for(const d of a){const k=D(d);k?k.push(d):h.push([d])}return h}function t(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new E.$ap(a.identifier.id),name:new E.$ap(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$yp=new A.$Mm("pprice.better-merge");function l(a,b){const h=[],D=b.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const d=D.shift();if(d&&h.every(k=>!T(k.identifier,{id:d}))){const k=a.filter(g=>T(g.identifier,{id:d}));k.length===1&&(h.push(k[0]),D.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function i(a,b){if(!F.$k)return!1;let h;try{h=(await a.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await a.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){b.debug("Error while getting the os-release file.",(0,p.$0)(d))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function $(a,b){const h=await i(a,b),D=(0,N.$Wo)(h?"alpine":F.$u,f.$fc);return b.debug("ComputeTargetPlatform:",D),D}}),define(Ce[200],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=I,e.$gs=N,e.$hs=A,e.$is=F,e.$js=M,e.$ks=p;function I(f){return[...f.entries()]}function N(f){return f?[...f.entries()]:[]}function A(f){return new Map(f)}function F(f){return new Map(f??[])}function M(f){return Array.from(f.entries()).map(E=>[E[0],I(E[1].map),N(E[1].descriptionMap)])}function p(f){return new Map(f.map(E=>[E[0],{map:A(E[1]),descriptionMap:F(E[2])}]))}}),define(Ce[201],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$sb=void 0;class I{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,F,M=5){const p=F(f=>{const E=typeof f=="string"?f:f.data;let T=this.a.get(A);if(T){T.data.push(E);return}const y=setTimeout(()=>this.flushBuffer(A),M);T={data:[E],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(A),p.dispose()}},this.a.set(A,T)});return p}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const F=this.a.get(A);F&&(this.a.delete(A),this.b(A,F.data.join("")))}}e.$$sb=I}),define(Ce[202],Re([1,0,11,91,301,42,5,17,2,161,72,30]),function(ge,e,I,N,A,F,M,p,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_w=e.$$w=e.$0w=e.$9w=e.$8w=e.$7w=e.IconFontDefinition=e.IconContribution=e.$4w=void 0,e.$5w=o,e.$6w=r,e.$4w={IconContribution:"base.contributions.icons"};var u;(function(l){function i($,a){let b=$.defaults;for(;F.ThemeIcon.isThemeIcon(b);){const h=s.getIcon(b.id);if(!h)return;b=h.defaults}return b}l.getDefinition=i})(u||(e.IconContribution=u={}));var v;(function(l){function i(a){return{weight:a.weight,style:a.style,src:a.src.map(b=>({format:b.format,location:b.location.toString()}))}}l.toJSONObject=i;function $(a){const b=h=>(0,p.$5f)(h)?h:void 0;if(a&&Array.isArray(a.src)&&a.src.every(h=>(0,p.$5f)(h.format)&&(0,p.$5f)(h.location)))return{weight:b(a.weight),style:b(a.style),src:a.src.map(h=>({format:h.format,location:f.URI.parse(h.location)}))}}l.fromJSONObject=$})(v||(e.IconFontDefinition=v={}));class m{constructor(){this.a=new M.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${F.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,$,a,b){const h=this.b[i];if(h){if(a&&!h.description){h.description=a,this.d.properties[i].markdownDescription=`${a} $(${i})`;const k=this.e.enum.indexOf(i);k!==-1&&(this.e.enumDescriptions[k]=a),this.a.fire()}return h}const D={id:i,description:a,defaults:$,deprecationMessage:b};this.b[i]=D;const d={$ref:"#/definitions/icons"};return b&&(d.deprecationMessage=b),a&&(d.markdownDescription=`${a}: $(${i})`),this.d.properties[i]=d,this.e.enum.push(i),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const $=this.e.enum.indexOf(i);$!==-1&&(this.e.enum.splice($,1),this.e.enumDescriptions.splice($,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,$){const a=this.f[i];return a||(this.f[i]=$,this.a.fire(),$)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(h,D)=>h.id.localeCompare(D.id),$=h=>{for(;F.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const b=Object.keys(this.b).map(h=>this.b[h]);for(const h of b.filter(D=>!!D.description).sort(i))a.push(`|<i class="${$(h)}"></i>|${h.id}|${F.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const h of b.filter(D=>!F.ThemeIcon.isThemeIcon(D.defaults)).sort(i))a.push(`|<i class="${$(h)}"></i>|${h.id}|`);return a.join(`
`)}}const s=new m;y.$0n.add(e.$4w.IconContribution,s);function o(l,i,$,a){return s.registerIcon(l,i,$,a)}function r(){return s}function n(){const l=(0,A.$Mj)();for(const i in l){const $="\\"+l[i].toString(16);s.registerIcon(i,{fontCharacter:$})}}n(),e.$7w="vscode://schemas/icons";const t=y.$0n.as(T.$$n.JSONContribution);t.registerSchema(e.$7w,s.getIconSchema());const c=new I.$Dh(()=>t.notifySchemaChanged(e.$7w),200);s.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$8w=o("widget-close",N.$Qj.close,(0,E.localize)(2,null)),e.$9w=o("goto-previous-location",N.$Qj.arrowUp,(0,E.localize)(3,null)),e.$0w=o("goto-next-location",N.$Qj.arrowDown,(0,E.localize)(4,null)),e.$$w=F.ThemeIcon.modify(N.$Qj.sync,"spin"),e.$_w=F.ThemeIcon.modify(N.$Qj.loading,"spin")}),define(Ce[203],Re([1,0,5,2,48,3,13]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$cw=e.$aw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$9v=e.$8v=void 0,e.$0v=E,e.$$v=y,e.$_v=u,e.$bw=v,e.$dw=m,e.$ew=s,e.$8v=(0,F.$ri)("tunnelService"),e.$9v=(0,F.$ri)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var f;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(f||(e.TunnelPrivacyId=f={}));function E(n){return!!n.forwardPort}var T;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function y(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function u(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const c of t){const l=c.split("=")[1];if(/^https?:/.exec(l)){const i=y(N.URI.parse(l));if(i)return i}}}e.$aw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(n){return e.$aw.indexOf(n)>=0}e.$cw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(n){return e.$cw.indexOf(n)>=0}function s(n,t,c,l){if(c===1)return!1;if(c===2&&m(t)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(i?.length===4&&parseInt(i[1])>=18)return!1}return n<1024}class o{constructor(t,c,l){this.remoteAddress=t,this.localAddress=c,this.b=l,this.a=new I.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$fw=o;let r=class{constructor(t,c){this.k=t,this.l=c,this.a=new I.$be,this.onTunnelOpened=this.a.event,this.b=new I.$be,this.onTunnelClosed=this.b.event,this.c=new I.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const t=this.l.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.i=t.privacyOptions,this.h=t.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const t=[],c=Array.from(this.e.values());for(const l of c){const i=Array.from(l.values());for(const $ of i){const a=await $.value;a&&typeof a!="string"&&t.push(a)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:c}of t.values())await c.then(l=>typeof l!="string"?l?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,c,l,i,$){this.q(t,c,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:c,localAddress:l,privacy:i,protocol:$,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,c){(m(t)||v(t))&&(t=e.$aw[0]);const l=this.s(t,c);if(l)return++l.refcount,l.value}openTunnel(t,c,l,i,$,a=!1,b,h){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${l} on local port ${$}.`);const D=this.f??t;if(!D)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(l)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.t(D,c,l,i,$,a,b,h);return d?d.then(k=>{if(k){if(typeof k=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,l),k}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,l);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.o(k);return(k.tunnelRemoteHost!==c||k.tunnelRemotePort!==l)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),b&&k.privacy!==b&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}o(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const c=this.e.get(t.tunnelRemoteHost);if(c){const l=c.get(t.tunnelRemotePort);l&&(l.refcount--,await this.p(t.tunnelRemoteHost,t.tunnelRemotePort,l))}}}}async p(t,c,l){if(l.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${c}.`);const i=l.value.then(async $=>{$&&typeof $!="string"&&(await $.dispose(!0),this.b.fire({host:$.tunnelRemoteHost,port:$.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(c),i}}async closeTunnel(t,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${c} `);const l=this.e.get(t);if(l&&l.has(c)){const i=l.get(c);i.refcount=0,await this.p(t,c,i)}}q(t,c,l){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(c,{refcount:1,value:l})}async r(t,c){const l=this.e.get(t);if(l){const i=l.get(c),$=i?await i.value:void 0;(!$||typeof $=="string")&&l.delete(c),l.size===0&&this.e.delete(t)}}s(t,c){const l=[t];v(t)?(l.push(...e.$aw),l.push(...e.$cw)):m(t)&&l.push(...e.$cw);const i=l.map($=>this.e.get($));for(const $ of i){const a=$?.get(c);if(a)return a}}canTunnel(t){return!!y(t)}u(t,c,l,i,$,a,b){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${l} on local port ${i}.`);const h=l;this.j.add(h);const D=i===void 0?l:i,d={elevationRequired:$?this.isPortPrivileged(D):!1},k={remoteAddress:{host:c,port:l},localAddressPort:i,privacy:a,public:a?a!==f.Private:void 0,protocol:b},g=t.forwardPort(k,d);return g?(this.q(c,l,g),g.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(h)})):this.j.delete(h),g}};e.$gw=r,e.$gw=r=Je([We(0,M.$Xj),We(1,A.$Xi)],r)}),define(Ce[204],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$hw=void 0,e.$hw=(0,I.$ri)("editSessionIdentityService");var N;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Ce[205],Re([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=N,e.$qM=A,e.$rM=F,e.$sM=M,e.$tM=p;function N(f){return f.scheme!==I.Schemas.file&&f.scheme!==I.Schemas.vscodeRemote}function A(f){if(f.folders.length)return f.folders.every(E=>N(E.uri))?f.folders[0].uri:void 0;if(f.configuration&&N(f.configuration))return f.configuration}function F(f){return A(f)?.scheme}function M(f){return A(f)?.authority}function p(f){return A(f)!==void 0}}),define(Ce[49],Re([1,0,162,19,52,23,2,3,12]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Li=e.$Ki=e.WorkbenchState=e.$Ei=e.$Di=e.$Ai=void 0,e.$Bi=E,e.$Ci=T,e.$Fi=y,e.$Gi=u,e.$Hi=v,e.$Ii=s,e.$Ji=o,e.$Mi=t,e.$Ri=c,e.$Si=l,e.$Ui=i,e.$Vi=$,e.$Wi=a,e.$Ai=(0,p.$ri)("contextService");function E(b){const h=b;return typeof h?.id=="string"&&M.URI.isUri(h.uri)}function T(b){return typeof b?.id=="string"&&!E(b)&&!u(b)}e.$Di={id:"ext-dev"},e.$Ei={id:"empty-window"};function y(b,h){if(typeof b=="string"||typeof b>"u")return typeof b=="string"?{id:(0,N.$oc)(b)}:h?e.$Di:e.$Ei;const D=b;return D.configuration?{id:D.id,configPath:D.configuration}:D.folders.length===1?{id:D.id,uri:D.folders[0].uri}:{id:D.id}}function u(b){const h=b;return typeof h?.id=="string"&&M.URI.isUri(h.configPath)}function v(b){const h=b;if(h?.uri)return{id:h.id,uri:M.URI.revive(h.uri)};const D=b;if(D?.configPath)return{id:D.id,configPath:M.URI.revive(D.configPath)};if(b?.id)return{id:b.id}}var m;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function s(b){const h=b;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function o(b){const h=b;return!!(h&&typeof h=="object"&&M.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class r{constructor(h,D,d,k,g){this.h=h,this.j=d,this.k=k,this.l=g,this.c=A.$xi.forUris(this.l,()=>!0),this.folders=D}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=A.$xi.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ki=r;class n{constructor(h,D){this.raw=D,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,F.$5g)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Li=n;function t(b){return new n({uri:b,index:0,name:(0,F.$1g)(b)},{uri:b.toString()})}e.$Ni="code-workspace",e.$Oi=`.${e.$Ni}`,e.$Pi=[{name:(0,I.localize)(0,null),extensions:[e.$Ni]}],e.$Qi="workspace.json";function c(b,h){return F.$Vg.isEqualOrParent(b,h.untitledWorkspacesHome)}function l(b){let h;return M.URI.isUri(b)?h=b:h=b.configuration,h?.scheme===f.Schemas.tmp}e.$Ti="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(b){return b.id===e.$Ti}function $(b,h){return!c(b,h)&&!l(b)}function a(b){return(typeof b=="string"?(0,N.$pc)(b):(0,F.$3g)(b))===e.$Oi}}),define(Ce[74],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class I{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const F=this.c++;return this.b.set(F,A),this.e(),F}get(A,F){return this.b.has(A)?this.b.get(A)[F]:void 0}delete(A){this.b.delete(A),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$zkc=I}),define(Ce[45],Re([1,0,12,23,3]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=e.$Ekc=void 0;class F{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new N.$Tg(p=>{const f=this.b.get(p.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(p,f){f===null?this.b.delete(p.scheme):this.b.set(p.scheme,f)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Ekc=F,e.$Fkc=(0,A.$ri)("IExtHostFileSystemInfo")}),define(Ce[27],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=void 0,e.$vP=(0,I.$ri)("IExtHostInitDataService")}),define(Ce[206],Re([1,0,167,13,193,27]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=void 0;let M=class extends A.$DQ{constructor(f,E,T){const y=T.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",u=T.remote.isRemote?(0,I.localize)(0,null):f?(0,I.localize)(1,null):(0,I.localize)(2,null);super(E.createLogger(y,{name:u}))}};e.$Lmc=M,e.$Lmc=M=Je([We(1,N.$Yj),We(2,F.$vP)],M)}),define(Ce[207],Re([1,0,11]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=void 0;class N{constructor(M,p,f){this.h=new Map,this.a=M,this.b=p,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new I.$Dh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of E.values())T.complete()}catch(T){for(const y of E.values())y.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,p){let f=this.f[M];return typeof f>"u"&&(f=p),f}update(M,p){this.f[M]=p;const f=this.h.get(M);if(f!==void 0)return f.p;const E=new I.$Oh;return this.h.set(M,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$klc=N;class A extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,p){super(M.identifier.value,!0,p),this.j=M}}e.$llc=A}),define(Ce[208],Re([1,0,5,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;class A{constructor(M){this.c=M,this.a=new I.$be,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$be,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,p,f,E){const y=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(p.value,f,E);this.b.fire(y)}$acceptDirtyStateChanged(M,p){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(p)}$acceptModelSaved(M){const p=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(p.apiNotebook)}}e.$_lc=A}),define(Ce[16],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0,e.$fP=(0,I.$ri)("IExtHostRpcService");class N{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$gP=N}),define(Ce[209],Re([1,0,20,5]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class A{#e;constructor(M,p){this.b=new N.$be,this.onDidChange=this.b.event,this.a=I.$Mm.toKey(M.identifier),this.#e=p,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(M){return this.#e.get(this.a,M)}store(M,p){return this.#e.store(this.a,M,p)}delete(M){return this.#e.delete(this.a,M)}}e.$ulc=A}),define(Ce[60],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=e.$Ukc=void 0,e.$Ukc=(0,I.$ri)("IURITransformerService");class N{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$Vkc=N}),define(Ce[210],Re([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qob=A,e.$rob=M;class N{constructor(){this.buffers=[]}add(f){let E=this.buffers.indexOf(f);return E<0&&(E=this.buffers.length,this.buffers.push(f)),E}}function A(p,f){if(f.serializeBuffersForPostMessage){const E=new N,y=JSON.stringify(p,(v,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(m)};if(ArrayBuffer.isView(m)){const s=F(m);if(s)return{$$vscode_array_buffer_reference$$:!0,index:E.add(m.buffer),view:{type:s,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),u=E.buffers.map(v=>{const m=new Uint8Array(v);return I.$Ce.wrap(m)});return{message:y,buffers:u}}else return{message:JSON.stringify(p),buffers:[]}}function F(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(p,f){const E=f.map(u=>{const v=new ArrayBuffer(u.byteLength);return new Uint8Array(v).set(u.buffer),v}),T=f.length?(u,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const m=v,{index:s}=m,o=E[s];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(p,T),arrayBuffers:E}}}),define(Ce[104],Re([1,0,176,17,2,6,3,30,44,12,43,139,33]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$DF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$uF=e.EditorInputCapabilities=e.$tF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=void 0,e.$kF=s,e.$lF=o,e.$mF=r,e.$nF=n,e.$oF=t,e.$pF=c,e.$qF=l,e.$rF=i,e.$sF=$,e.$vF=k,e.$wF=S,e.$xF=w,e.$yF=C,e.$zF=P,e.$AF=W,e.$BF=V,e.$CF=ae,e.$EF=de,e.$FF=Me,e.$GF=ce,e.$HF=Ae,e.$fF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$gF={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$hF="workbench.editor.sidebysideEditor",e.$iF="workbench.editors.textDiffEditor",e.$jF="workbench.editors.binaryResourceDiffEditor";var v;(function(ie){ie[ie.PROGRAMMATIC=1]="PROGRAMMATIC",ie[ie.USER=2]="USER",ie[ie.EDIT=3]="EDIT",ie[ie.NAVIGATION=4]="NAVIGATION",ie[ie.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var m;(function(ie){ie[ie.IDENTICAL=1]="IDENTICAL",ie[ie.SIMILAR=2]="SIMILAR",ie[ie.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function s(ie){const L=ie;return!!L&&typeof L.getSelection=="function"&&!!L.onDidChangeSelection}function o(ie){const L=ie;return!!L&&typeof L.getScrollPosition=="function"&&typeof L.setScrollPosition=="function"&&!!L.onDidChangeScroll}function r(ie,L,x){for(const be of x.visibleEditorPanes)if(be.group.id===L&&ie.matches(be.input))return be.getViewState()}function n(ie){if(k(ie))return!1;const L=ie;return A.URI.isUri(L?.resource)}function t(ie){if(k(ie))return!1;const L=ie;return L?.original!==void 0&&L.modified!==void 0}function c(ie){if(k(ie))return!1;const L=ie;return!L||L.resources&&!Array.isArray(L.resources)?!1:!!L.resources||!!L.multiDiffSource}function l(ie){if(k(ie)||t(ie))return!1;const L=ie;return L?.primary!==void 0&&L.secondary!==void 0}function i(ie){if(k(ie))return!1;const L=ie;return L?L.resource===void 0||L.resource.scheme===E.Schemas.untitled||L.forceUntitled===!0:!1}function $(ie){if(k(ie))return!1;const L=ie;return A.URI.isUri(L?.base?.resource)&&A.URI.isUri(L?.input1?.resource)&&A.URI.isUri(L?.input2?.resource)&&A.URI.isUri(L?.result?.resource)}var a;(function(ie){ie[ie.SHORT=0]="SHORT",ie[ie.MEDIUM=1]="MEDIUM",ie[ie.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var b;(function(ie){ie[ie.EXPLICIT=1]="EXPLICIT",ie[ie.AUTO=2]="AUTO",ie[ie.FOCUS_CHANGE=3]="FOCUS_CHANGE",ie[ie.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b||(e.SaveReason=b={}));class h{constructor(){this.a=new Map}registerSource(L,x){let be=this.a.get(L);return be||(be={source:L,label:x},this.a.set(L,be)),be.source}getSourceLabel(L){return this.a.get(L)?.label??L}}e.$tF=new h;var D;(function(ie){ie[ie.None=0]="None",ie[ie.Readonly=2]="Readonly",ie[ie.Untitled=4]="Untitled",ie[ie.Singleton=8]="Singleton",ie[ie.RequiresTrust=16]="RequiresTrust",ie[ie.CanSplitInGroup=32]="CanSplitInGroup",ie[ie.ForceDescription=64]="ForceDescription",ie[ie.CanDropIntoEditor=128]="CanDropIntoEditor",ie[ie.MultipleEditors=256]="MultipleEditors",ie[ie.Scratchpad=512]="Scratchpad"})(D||(e.EditorInputCapabilities=D={}));class d extends F.$Uc{}e.$uF=d;function k(ie){return ie instanceof d}function g(ie){const L=ie;return A.URI.isUri(L?.preferredResource)}function S(ie){const L=ie;return k(L?.primary)&&k(L?.secondary)}function w(ie){const L=ie;return k(L?.modified)&&k(L?.original)}function C(ie,L,x,be,Oe){return Ae(be,[(0,y.$bj)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const Ee={...x,limits:{size:Number.MAX_VALUE}};ie.openEditor(L,Ee)}}),(0,y.$bj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Oe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function P(ie){return k(ie?.editor)}function W(ie){const L=ie;return P(ie)&&L?.group!==void 0}function V(ie){const L=ie;return typeof L?.groupId=="number"&&k(L.editor)}var q;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.REPLACE=1]="REPLACE",ie[ie.MOVE=2]="MOVE",ie[ie.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var R;(function(ie){ie[ie.GROUP_ACTIVE=0]="GROUP_ACTIVE",ie[ie.GROUP_INDEX=1]="GROUP_INDEX",ie[ie.GROUP_LABEL=2]="GROUP_LABEL",ie[ie.GROUP_LOCKED=3]="GROUP_LOCKED",ie[ie.EDITOR_OPEN=4]="EDITOR_OPEN",ie[ie.EDITOR_CLOSE=5]="EDITOR_CLOSE",ie[ie.EDITOR_MOVE=6]="EDITOR_MOVE",ie[ie.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ie[ie.EDITOR_LABEL=8]="EDITOR_LABEL",ie[ie.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ie[ie.EDITOR_PIN=10]="EDITOR_PIN",ie[ie.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ie[ie.EDITOR_STICKY=12]="EDITOR_STICKY",ie[ie.EDITOR_DIRTY=13]="EDITOR_DIRTY",ie[ie.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var j;(function(ie){ie[ie.PRIMARY=1]="PRIMARY",ie[ie.SECONDARY=2]="SECONDARY",ie[ie.BOTH=3]="BOTH",ie[ie.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class K{getOriginalUri(L,x){if(!L)return;if($(L))return e.$DF.getOriginalUri(L.result,x);if(x?.supportSideBySide){const{primary:Oe,secondary:Ee}=this.a(L);if(Oe&&Ee){if(x?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(Oe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(Ee,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getOriginalUri(Oe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(Ee,{filterByScheme:x.filterByScheme});L=x.supportSideBySide===j.PRIMARY?Oe:Ee}}if(t(L)||c(L)||l(L)||$(L))return;const be=g(L)?L.preferredResource:L.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}a(L){return S(L)||l(L)?{primary:L.primary,secondary:L.secondary}:w(L)||t(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,x){if(!L)return;if($(L))return e.$DF.getCanonicalUri(L.result,x);if(x?.supportSideBySide){const{primary:Oe,secondary:Ee}=this.a(L);if(Oe&&Ee){if(x?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(Oe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(Ee,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getCanonicalUri(Oe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(Ee,{filterByScheme:x.filterByScheme});L=x.supportSideBySide===j.PRIMARY?Oe:Ee}}if(t(L)||c(L)||l(L)||$(L))return;const be=L.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}b(L,x){if(Array.isArray(x)){if(x.some(be=>L.scheme===be))return L}else if(x===L.scheme)return L}}var re;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.KEYBOARD=1]="KEYBOARD",ie[ie.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function ae(ie,L,x,be){if(!ie.isSticky(L))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return x===re.MOUSE||x===re.KEYBOARD;case"mouse":return x===re.MOUSE;case"keyboard":return x===re.KEYBOARD}return!1}e.$DF=new K;var ve;(function(ie){ie[ie.LEFT=0]="LEFT",ie[ie.RIGHT=1]="RIGHT"})(ve||(e.CloseDirection=ve={}));class Ie{constructor(){this.c=new Map,this.d=new Map}start(L){const x=this.a=L.get(M.$qi);for(const[be,Oe]of this.c)this.e(be,Oe,x);this.c.clear()}e(L,x,be){const Oe=be.createInstance(x);this.d.set(L,Oe)}registerFileEditorFactory(L){if(this.b)throw new Error("Can only register one file editor factory.");this.b=L}getFileEditorFactory(){return(0,N.$dg)(this.b)}registerEditorSerializer(L,x){if(this.c.has(L)||this.d.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.a?this.e(L,x,this.a):this.c.set(L,x),(0,F.$Sc)(()=>{this.c.delete(L),this.d.delete(L)})}getEditorSerializer(L){return this.d.get(typeof L=="string"?L:L.typeId)}}p.$0n.add(e.$fF.EditorFactory,new Ie);async function de(ie,L,x){return!ie||!ie.length?[]:await Promise.all(ie.map(async be=>{const Oe=A.URI.revive(be.fileUri);if(!Oe){x.info("Cannot resolve the path because it is not valid.",be);return}if(!await L.canHandleResource(Oe)){x.info("Cannot resolve the path because it cannot be handled",be);return}let pe=be.exists,fe=be.type;if(typeof pe!="boolean"||typeof fe!="number")try{fe=(await L.stat(Oe)).isDirectory?f.FileType.Directory:f.FileType.Unknown,pe=!0}catch(Z){x.error(Z),pe=!1}if(!pe&&be.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",be);return}if(fe===f.FileType.Directory){x.info("Cannot resolve the path because it is a directory",be);return}const X={...be.options,pinned:!0};return pe?{resource:Oe,options:X}:{resource:Oe,options:X,forceUntitled:!0}}))}var me;(function(ie){ie[ie.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ie[ie.SEQUENTIAL=1]="SEQUENTIAL"})(me||(e.EditorsOrder=me={}));function Me(ie){const L=ie;if(!L)return!1;const x=L;if(x.modified)return Me(x.modified);const be=L;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function ce(ie){return(0,T.$dj)(ie)}function Ae(ie,L,x){const be=(0,T.$ej)(ie,L);return be.forceMessage=x?.forceMessage,be.forceSeverity=x?.forceSeverity,be.allowDialog=x?.allowDialog,be}}),define(Ce[211],Re([1,0,5,177,3,6,28,30,18,25,91,202]),function(ge,e,I,N,A,F,M,p,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PF=e.$OF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$NF=e.ViewContentGroups=e.$LF=e.ViewContainerLocation=e.Extensions=e.$KF=e.$JF=e.$IF=void 0,e.$MF=m,e.$IF="views",e.$JF=(0,N.localize)(0,null),e.$KF=(0,y.$5w)("default-view-icon",T.$Qj.window,(0,N.localize)(1,null));var u;(function($){$.ViewContainersRegistry="workbench.registry.view.containers",$.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var v;(function($){$[$.Sidebar=0]="Sidebar",$[$.Panel=1]="Panel",$[$.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$LF=[0,1,2];function m($){switch($){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class s extends F.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onDidRegister=this.c.event,this.f=this.B(new I.$be),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(a,b,h){const D=this.get(a.id);if(D)return D;const d=a;return d.openCommandActionDescriptor=h?.doNotRegisterOpenCommand?void 0:d.openCommandActionDescriptor??{id:d.id},(0,M.$yc)(this.g,b,[]).push(d),h?.isDefault&&this.h.push(d),this.c.fire({viewContainer:d,viewContainerLocation:b}),d}deregisterViewContainer(a){for(const b of this.g.keys()){const h=this.g.get(b),D=h?.indexOf(a);if(D!==-1){h?.splice(D,1),h.length===0&&this.g.delete(b),this.f.fire({viewContainer:a,viewContainerLocation:b});return}}}get(a){return this.all.filter(b=>b.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(b=>this.getViewContainers(b).filter(h=>h?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(b=>this.getViewContainerLocation(b)===a)}}p.$0n.add(u.ViewContainersRegistry,new s);var o;(function($){$.Open="2_open",$.Debug="4_debug",$.SCM="5_scm",$.More="9_more"})(o||(e.ViewContentGroups=o={}));function r($,a){const b=$.group??o.More,h=a.group??o.More;return b!==h?b.localeCompare(h):($.order??5)-(a.order??5)}class n extends F.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$be),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$be),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$be),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(a,b){this.registerViews2([{views:a,viewContainer:b}])}registerViews2(a){a.forEach(({views:b,viewContainer:h})=>this.r(b,h)),this.c.fire(a)}deregisterViews(a,b){const h=this.s(a,b);h.length&&this.f.fire({views:h,viewContainer:b})}moveViews(a,b){for(const h of this.m.keys())if(h!==b){const D=this.s(a,h);D.length&&(this.r(D,b),this.g.fire({views:D,from:h,to:b}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const b of this.j){const h=(this.m.get(b)||[]).filter(D=>D.id===a)[0];if(h)return h}return null}getViewContainer(a){for(const b of this.j)if((this.m.get(b)||[]).filter(D=>D.id===a)[0])return b;return null}registerViewWelcomeContent(a,b){return this.n.add(a,b),this.h.fire(a),(0,F.$Sc)(()=>{this.n.delete(a,b),this.h.fire(a)})}registerViewWelcomeContent2(a,b){const h=new Map;for(const[D,d]of b)this.n.add(a,d),h.set(D,(0,F.$Sc)(()=>{this.n.delete(a,d),this.h.fire(a)}));return this.h.fire(a),h}getViewWelcomeContent(a){const b=[];return this.n.forEach(a,h=>b.push(h)),b.sort(r)}r(a,b){let h=this.m.get(b);h||(h=[],this.m.set(b,h),this.j.push(b));for(const D of a){if(this.getView(D.id)!==null)throw new Error((0,N.localize)(2,null,D.id));h.push(D)}}s(a,b){const h=this.m.get(b);if(!h)return[];const D=[],d=[];for(const k of h)a.includes(k)?D.push(k):d.push(k);return D.length&&(d.length?this.m.set(b,d):(this.m.delete(b),this.j.splice(this.j.indexOf(b),1))),D}}p.$0n.add(u.ViewsRegistry,new n),e.$NF=(0,A.$ri)("viewDescriptorService");var t;(function($){$[$.Default=0]="Default",$[$.Expand=1]="Expand"})(t||(e.ViewVisibilityState=t={}));var c;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class l{constructor(a,b){this.c=!1,this.d=!1,(0,E.$1n)(this,a),this.d=!!b,this.resolve=async h=>{if(b&&!this.c){const D=await b(h);D&&(this.tooltip=this.tooltip??D.tooltip,this.command=this.command??D.command)}h.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$OF=l;class i extends Error{constructor(a){super((0,N.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$PF=i}),define(Ce[212],Re([1,0,178,31]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0,e.$TF=new N.$Ij("chatSessionResponseVote","",{type:"string",description:(0,I.localize)(0,null)}),e.$UF=new N.$Ij("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,I.localize)(1,null)}),e.$VF=new N.$Ij("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,I.localize)(2,null)}),e.$WF=new N.$Ij("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,I.localize)(3,null)}),e.$XF=new N.$Ij("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,I.localize)(4,null)}),e.$YF=new N.$Ij("chatResponse",!1,{type:"boolean",description:(0,I.localize)(5,null)}),e.$ZF=new N.$Ij("chatRequest",!1,{type:"boolean",description:(0,I.localize)(6,null)}),e.$1F=new N.$Ij("chatInputHasText",!1,{type:"boolean",description:(0,I.localize)(7,null)}),e.$2F=new N.$Ij("chatInputHasFocus",!1,{type:"boolean",description:(0,I.localize)(8,null)}),e.$3F=new N.$Ij("inChatInput",!1,{type:"boolean",description:(0,I.localize)(9,null)}),e.$4F=new N.$Ij("inChat",!1,{type:"boolean",description:(0,I.localize)(10,null)}),e.$5F=new N.$Ij("chatIsEnabled",!1,{type:"boolean",description:(0,I.localize)(11,null)}),e.$6F=new N.$Ij("chatCursorAtTop",!1),e.$7F=new N.$Ij("chatInputHasAgent",!1),e.$8F=new N.$Ij("chatLocation",void 0)}),define(Ce[213],Re([1,0,5,40,6,31,3,212]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8G=e.$7G=e.$6G=e.ChatAgentLocation=void 0;var f;(function(y){y.Panel="panel",y.Terminal="terminal",y.Notebook="notebook",y.Editor="editor"})(f||(e.ChatAgentLocation=f={})),function(y){function u(v){switch(v){case"panel":return y.Panel;case"terminal":return y.Terminal;case"notebook":return y.Notebook;case"editor":return y.Editor}return y.Panel}y.fromRaw=u}(f||(e.ChatAgentLocation=f={})),e.$6G=(0,M.$ri)("chatAgentService");let E=class{static{this.AGENT_LEADER="@"}constructor(u){this.f=u,this.b=[],this.d=new I.$be,this.onDidChangeAgents=this.d.event,this.e=p.$5F.bindTo(this.f)}registerAgent(u,v){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const s=this,o=v.slashCommands;v={...v,get slashCommands(){return o.filter(n=>!n.when||s.f.contextMatchesRules(F.$pj.deserialize(n.when)))}};const r={data:v};return this.b.push(r),(0,A.$Sc)(()=>{this.b=this.b.filter(n=>n!==r),this.d.fire(void 0)})}registerAgentImplementation(u,v){const m=this.g(u);if(!m)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(m.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return m.data.isDefault&&this.e.set(!0),m.impl=v,this.d.fire(new T(m.data,v)),(0,A.$Sc)(()=>{m.impl=void 0,this.d.fire(void 0),m.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(u,v){const m={data:u,impl:v};return this.b.push(m),this.d.fire(new T(u,v)),(0,A.$Sc)(()=>{this.b=this.b.filter(s=>s!==m),this.d.fire(void 0)})}updateAgent(u,v){const m=this.g(u);if(!m?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);m.data.metadata={...m.data.metadata,...v},this.d.fire(new T(m.data,m.impl))}getDefaultAgent(u){return this.getActivatedAgents().find(v=>!!v.isDefault&&v.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(v=>!!v.isDefault&&v.locations.includes(u))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),u=>!!u.data.metadata.isSecondary)?.data}g(u){return this.b.find(v=>v.data.id===u)}getAgent(u){return this.g(u)?.data}getAgents(){return this.b.map(u=>u.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(u=>!!u.impl).map(u=>new T(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(v=>v.name===u)}async invokeAgent(u,v,m,s,o){const r=this.g(u);if(!r?.impl)throw new Error(`No activated agent with id ${u}`);return await r.impl.invoke(v,m,s,o)}async getFollowups(u,v,m,s,o){const r=this.g(u);if(!r?.impl)throw new Error(`No activated agent with id ${u}`);return r.impl?.provideFollowups?r.impl.provideFollowups(v,m,s,o):[]}};e.$7G=E,e.$7G=E=Je([We(0,F.$Jj)],E);class T{constructor(u,v){this.b=u,this.d=v}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(u,v,m,s){return this.d.invoke(u,v,m,s)}async provideFollowups(u,v,m,s){return this.d.provideFollowups?this.d.provideFollowups(u,v,m,s):[]}provideWelcomeMessage(u,v){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(u,v)}provideSampleQuestions(u,v){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(u,v)}}e.$8G=T}),define(Ce[214],Re([1,0,2,29,3]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$aG=F,e.$bG=M;function F(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof I.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(N.$nt.isIRange)}function M(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(F)}var p;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var f;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(f||(e.ChatCopyKind=f={})),e.$cG=(0,A.$ri)("IChatService"),e.$dG="accessibility.voice.keywordActivation"}),define(Ce[215],Re([1,0,5,11,179]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xob=void 0;class F{constructor(){this.f=new Map,this.m=[],this.n=new I.$be,this.o=new I.$be,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,f,E,T){const y={command:p};if(f&&Object.keys(f).length>0&&(y.arguments=f),this.u("request",y),typeof T=="number"){const u=setTimeout(()=>{clearTimeout(u);const v=this.f.get(y.seq);if(v){this.f.delete(y.seq);const m={type:"response",seq:0,request_seq:y.seq,success:!1,command:p,message:(0,A.localize)(0,null,T,p)};v(m)}},T)}return E&&this.f.set(y.seq,E),y.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,f){return p.type!=="event"||f.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,N.$sh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const f=p,E=this.f.get(f.request_seq);E&&(this.f.delete(f.request_seq),E(f));break}}}}u(p,f){f.type=p,f.seq=this.d++,this.sendMessage(f)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((f,E)=>p.set(E,f)),await(0,N.$sh)(500),p.forEach((f,E)=>{f({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Xob=F}),define(Ce[216],Re([1,0,2,180,31,3]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$lJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$jJ=e.MemoryRangeType=e.State=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=void 0,e.$iJ=f,e.$kJ=T,e.$9H="workbench.view.debug",e.$0H="workbench.debug.variablesView",e.$$H="workbench.debug.watchExpressionsView",e.$_H="workbench.debug.callStackView",e.$aI="workbench.debug.loadedScriptsView",e.$bI="workbench.debug.breakPointsView",e.$cI="workbench.debug.disassemblyView",e.$dI="workbench.panel.repl",e.$eI="workbench.panel.repl.view",e.$fI=new A.$Ij("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$gI=new A.$Ij("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$hI=new A.$Ij("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$iI="debugUx",e.$jI=new A.$Ij(e.$iI,"default",{type:"string",description:N.localize(3,null)}),e.$kI=new A.$Ij("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$lI=new A.$Ij("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$mI=new A.$Ij("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$nI=new A.$Ij("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$oI=new A.$Ij("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$pI=new A.$Ij("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$qI=new A.$Ij("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$rI=new A.$Ij("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$sI=new A.$Ij("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$tI=new A.$Ij("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$uI=new A.$Ij("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$vI=new A.$Ij("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$wI=new A.$Ij("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$xI=new A.$Ij("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$yI=new A.$Ij("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$zI=new A.$Ij("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$AI=new A.$Ij("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$BI=new A.$Ij("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$CI=new A.$Ij("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$DI=new A.$Ij("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$EI=new A.$Ij("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$FI=new A.$Ij("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$GI=new A.$Ij("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$HI=new A.$Ij("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$II=new A.$Ij("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$JI=new A.$Ij("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$KI=new A.$Ij("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$LI=new A.$Ij("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$MI=new A.$Ij("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$NI=new A.$Ij("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$OI=new A.$Ij("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$PI=new A.$Ij("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$QI=new A.$Ij("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$RI=new A.$Ij("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$SI=new A.$Ij("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$TI=new A.$Ij("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$UI=new A.$Ij("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$VI=new A.$Ij("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$WI=new A.$Ij("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$XI=new A.$Ij("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$YI=new A.$Ij("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$ZI=new A.$Ij("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$1I=new A.$Ij("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$2I=new A.$Ij("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$3I=new A.$Ij("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$4I=new A.$Ij("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$5I=new A.$Ij("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$6I=new A.$Ij("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$7I=new A.$Ij("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$8I=new A.$Ij("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$9I=new A.$Ij("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$0I=new A.$Ij("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$$I=new A.$Ij("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$_I=new A.$Ij("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$aJ=new A.$Ij("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$bJ=new A.$Ij("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$cJ=new A.$Ij("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=t=>N.localize(61,null,t);e.$dJ=M,e.$eJ="editor.contrib.debug",e.$fJ="editor.contrib.breakpoint",e.$gJ="debug",e.$hJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var p;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(p||(e.State=p={}));function f(t){switch(t){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$jJ="vscode-debug-memory";function T(t){return t.source.presentationHint==="deemphasize"||t.presentationHint==="deemphasize"||t.presentationHint==="subtle"}var y;(function(t){t[t.Variable=0]="Variable",t[t.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var v;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(v||(e.DebuggerString=v={})),e.$lJ=(0,F.$ri)("debugService");var m;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(m||(e.BreakpointWidgetContext=m={}));var s;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(s||(e.DebugVisualizationType=s={}));var o;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var r;(function(t){t.deserialize=c=>c,t.serialize=c=>c})(r||(e.IDebugVisualizationTreeItem=r={}));var n;(function(t){t.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:I.URI.revive(c.iconPath.light),dark:I.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),t.serialize=c=>c})(n||(e.IDebugVisualization=n={}))}),define(Ce[217],Re([1,0,15,2,19,25,12,29,24,18]),function(ge,e,I,N,A,F,M,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kH=void 0,e.$$G=y,e.$_G=u,e.$aH=v,e.$bH=m,e.$cH=s,e.$dH=o,e.$eH=r,e.$fH=t,e.$gH=i,e.$hH=$,e.$iH=b,e.$jH=D;const T=/{([^}]+)}/g;function y(k,g,S){return k.replace(T,function(w,C){return g&&C.length>0&&C[0]!=="_"?w:S&&S.hasOwnProperty(C)?S[C]:w})}function u(k){const g={};for(const S of Object.keys(k))S.startsWith("!")||(g[S]=k[S]);return g}function v(k){return k.configuration.request==="attach"&&!m(k)&&(!k.parentSession||v(k.parentSession))}function m(k){let g=k.configuration.type;if(g)return g==="vslsShare"&&(g=k.configuration.adapterProxy.configuration.type),(0,I.$uf)(g,"extensionhost")||(0,I.$uf)(g,"pwa-extensionhost")?k:k.parentSession?m(k.parentSession):void 0}function s(k){return k.type&&(k.label||k.program||k.runtime)}function o(k,g,S){let w,C=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=P.exec(k);){const V=W.index+1,q=V+W[0].length;if(V<=g&&q>=S){w=W[0],C=V;break}}if(w){const V=/\w+/g;let q=null;for(;(q=V.exec(w))&&!(q.index+1+C+q[0].length>=S););q&&(w=w.substring(0,V.lastIndex))}return w?{start:C,end:C+w.length-1}:{start:0,end:0}}async function r(k,g,S,w){if(k.evaluatableExpressionProvider.has(g)){const C=k.evaluatableExpressionProvider.ordered(g),P=(0,E.$Hb)(await Promise.all(C.map(async W=>{try{return await W.provideEvaluatableExpression(g,S,w??f.CancellationToken.None)}catch{return}})));if(P.length>0){let W=P[0].expression;const V=P[0].range;return W||(W=g.getLineContent(S.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const C=g.getLineContent(S.lineNumber),{start:P,end:W}=o(C,S.column,S.column),V=C.substring(P-1,W);return{matchingExpression:V,range:new p.$nt(S.lineNumber,P,S.lineNumber,P+V.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(k){return!!(k&&k.match(n))}function c(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(t(k.path))return N.URI.parse(k.path);if((0,A.$jc)(k.path))return N.URI.file(k.path)}return k.path}function l(k){if(typeof k.path=="object"){const g=N.URI.revive(k.path);if(g)return g.scheme===M.Schemas.file?g.fsPath:g.toString()}return k.path}function i(k,g){const S=g?c:l,w=(0,F.$Xn)(k);return a(w,(C,P)=>{C&&P&&(P.path=S(P))}),w}function $(k,g){const S=g?c:l,w=(0,F.$Xn)(k);return a(w,(C,P)=>{!C&&P&&(P.path=S(P))}),w}function a(k,g){switch(k.type){case"event":{const S=k;switch(S.event){case"output":g(!1,S.body.source);break;case"loadedSource":g(!1,S.body.source);break;case"breakpoint":g(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=k;switch(S.command){case"setBreakpoints":g(!0,S.arguments.source);break;case"breakpointLocations":g(!0,S.arguments.source);break;case"source":g(!0,S.arguments.source);break;case"gotoTargets":g(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(w=>g(!1,w));break;default:break}break}case"response":{const S=k;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(w=>g(!1,w.source));break;case"loadedSources":S.body.sources.forEach(w=>g(!1,w));break;case"scopes":S.body.scopes.forEach(w=>g(!1,w.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(w=>g(!1,w.source));break;case"setBreakpoints":S.body.breakpoints.forEach(w=>g(!1,w.source));break;case"disassemble":S.body?.instructions.forEach(C=>g(!1,C.location));break;default:break}break}}}function b(k){return k.filter(g=>!g.presentation?.hidden).sort((g,S)=>g.presentation?S.presentation?g.presentation.group?S.presentation.group?g.presentation.group!==S.presentation.group?g.presentation.group.localeCompare(S.presentation.group):h(g.presentation.order,S.presentation.order):-1:S.presentation.group?1:h(g.presentation.order,S.presentation.order):-1:S.presentation?1:0)}function h(k,g){return typeof k!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:k-g}async function D(k,g){const S=k.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(S!=="none"&&(await g.saveAll(),S==="allEditorsInActiveGroup")){const w=g.activeEditorPane;w&&w.input.resource?.scheme===M.Schemas.untitled&&await g.save({editor:w.input,groupId:w.group.id})}await k.reloadConfiguration()}const d=(k,g)=>!k||!g?k===g:k.name===g.name&&k.path===g.path&&k.sourceReference===g.sourceReference;e.$kH=d}),define(Ce[218],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yK=e.CellExecutionUpdateType=void 0;var N;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$yK=(0,I.$ri)("INotebookExecutionService")}),define(Ce[219],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rib=e.$Qib=e.ProxyKernelState=e.$Pib=void 0,e.$Pib=100;var N;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$Qib=(0,I.$ri)("INotebookKernelService"),e.$Rib=(0,I.$ri)("INotebookKernelHistoryService")}),define(Ce[220],Re([1,0,6,29,149,95]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IWb=void 0;class M extends I.$Uc{constructor(f,E,T){super(),this._source=f,this.b=E,this.c=T,this.a=void 0}f(f){const E=f.getLineCount();return new N.$nt(1,1,E,this.g(f,E))}g(f,E){if(E<1||E>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const f=new A.$OC;f.acceptChunk(this._source);const E=f.finish(!0),{textBuffer:T,disposable:y}=E.create(1);this.b=T,this.B(y)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const E=new A.$OC;E.acceptChunk(f);const T=E.finish(!0),{textBuffer:y,disposable:u}=T.create(1);return this.B(u),y})),this.a}findInInputs(f){const T=new F.$CC(f,!1,!1,null).parseSearchRequest();if(!T)return[];const y=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(y,T,!0,5e3)}findInOutputs(f){const T=new F.$CC(f,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(y=>{const u=y.findMatchesLineByLine(this.f(y),T,!0,5e3);if(u.length!==0)return{textBuffer:y,matches:u}}).filter(y=>!!y):[]}}e.$IWb=M}),define(Ce[50],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(F){F.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var N;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class A{static fromExtHostTestItem(M,p,f=M.parent){if(M._isRoot)return new A([p]);const E=[M.id];for(let T=f;T&&T.id!==p;T=T.parent)E.push(T.id);return E.push(p),new A(E.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const p=M.indexOf("\0");return p===-1?M:M.slice(0,p)}static fromString(M){return new A(M.split("\0"))}static join(M,p){return new A([...M.path,p])}static joinToString(M,p){return M.toString()+"\0"+p}static parentId(M){const p=M.lastIndexOf("\0");return p===-1?void 0:M.slice(0,p)}static localId(M){const p=M.lastIndexOf("\0");return p===-1?M:M.slice(p+1)}static isChild(M,p){return p.startsWith(M)&&p[M.length]==="\0"}static compare(M,p){return M===p?0:A.isChild(M,p)?2:A.isChild(p,M)?3:1}constructor(M,p=M.length){if(this.path=M,this.d=p,M.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new A(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new A(this.path,M)}compare(M){if(typeof M=="string")return A.compare(this.toString(),M);for(let p=0;p<M.d&&p<this.d;p++)if(M.path[p]!==this.path[p])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$EL=A}),define(Ce[61],Re([1,0,2,93,29,50]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$ML=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$LL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$KL=e.$JL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$IL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$HL=e.$GL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$FL=e.TestResultState=void 0;var M;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$FL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var f;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$GL=[2,4,8,16,32,64];const E=R=>"runId"in R;e.$HL=E;var T;(function(R){R.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),R.deserialize=(j,K)=>({range:A.$nt.lift(K.range),uri:j.asCanonicalUri(I.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var y;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(R){R.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&T.serialize(j.location)}),R.deserialize=(j,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(j,K.location)})})(u||(e.ITestErrorMessage=u={}));const v=(R,j)=>`${j?"s":"e"}${R}`;e.$IL=v;var m;(function(R){R.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&T.serialize(j.location)}),R.deserialize=(j,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(j,K.location)})})(m||(e.ITestOutputMessage=m={}));var s;(function(R){R.serialize=j=>j.type===0?u.serialize(j):m.serialize(j),R.deserialize=(j,K)=>K.type===0?u.deserialize(j,K):m.deserialize(j,K)})(s||(e.ITestMessage=s={}));var o;(function(R){R.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),R.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(s.serialize)}),R.deserialize=(j,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(re=>s.deserialize(j,re))})})(o||(e.ITestTaskState=o={}));const r="\0",n=(R,j)=>R+r+j;e.$JL=n;const t=R=>{const j=R.indexOf(r);return{ctrlId:R.slice(0,j),tagId:R.slice(j+1)}};e.$KL=t;var c;(function(R){R.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),R.deserialize=(j,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?j.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?A.$nt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var l;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var i;(function(R){R.serialize=j=>({expand:j.expand,item:c.serialize(j.item)}),R.deserialize=(j,K)=>({controllerId:F.$EL.root(K.item.extId),expand:K.expand,item:c.deserialize(j,K.item)})})(i||(e.InternalTestItem=i={}));var $;(function(R){R.serialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.uri!==void 0&&(K.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(K.range=j.item.range?.toJSON()),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}},R.deserialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.range!==void 0&&(K.range=j.item.range?A.$nt.lift(j.item.range):null),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}}})($||(e.ITestItemUpdate=$={}));const a=(R,j)=>{j.expand!==void 0&&(R.expand=j.expand),j.item!==void 0&&(R.item=R.item?Object.assign(R.item,j.item):j.item)};e.$LL=a;var b;(function(R){R.serializeWithoutMessages=j=>({...i.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serializeWithoutMessages)}),R.serialize=j=>({...i.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serialize)}),R.deserialize=(j,K)=>({...i.deserialize(j,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(re=>o.deserialize(j,re)),retired:!0})})(b||(e.TestResultItem=b={}));var h;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(j,K)=>{j.covered+=K.covered,j.total+=K.total}})(h||(e.ICoverageCount=h={}));var D;(function(R){R.serialize=j=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,uri:j.uri.toJSON()}),R.deserialize=(j,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:j.asCanonicalUri(I.URI.revive(K.uri))})})(D||(e.IFileCoverage=D={}));function d(R){return{...R,location:R.location?.toJSON()}}function k(R){return R.location=R.location?N.$mt.isIPosition(R.location)?N.$mt.lift(R.location):A.$nt.lift(R.location):void 0,R}e.$ML=3;var g;(function(R){R[R.Declaration=0]="Declaration",R[R.Statement=1]="Statement",R[R.Branch=2]="Branch"})(g||(e.DetailType=g={}));var S;(function(R){R.serialize=j=>j.type===0?C.serialize(j):P.serialize(j),R.deserialize=j=>j.type===0?C.deserialize(j):P.deserialize(j)})(S||(e.CoverageDetails=S={}));var w;(function(R){R.serialize=d,R.deserialize=k})(w||(e.IBranchCoverage=w={}));var C;(function(R){R.serialize=d,R.deserialize=k})(C||(e.IDeclarationCoverage=C={}));var P;(function(R){R.serialize=j=>({...d(j),branches:j.branches?.map(w.serialize)}),R.deserialize=j=>({...k(j),branches:j.branches?.map(w.deserialize)})})(P||(e.IStatementCoverage=P={}));var W;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(R){R.deserialize=(j,K)=>K.op===0?{op:K.op,item:i.deserialize(j,K.item)}:K.op===1?{op:K.op,item:$.deserialize(K.item)}:K.op===2?{op:K.op,uri:j.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,R.serialize=j=>j.op===0?{op:j.op,item:i.serialize(j.item)}:j.op===1?{op:j.op,item:$.serialize(j.item)}:j})(V||(e.TestsDiffOp=V={}));class q{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const K=this.v();for(const re of j)switch(re.op){case 0:this.l(i.deserialize(this.k,re.item),K);break;case 1:this.o($.deserialize(re.item),K);break;case 3:this.p(re.itemId,K);break;case 5:this.q(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this.c.set(re.tag.id,re.tag);break;case 7:this.c.delete(re.id);break}K.complete?.()}l(j,K){const re=F.$EL.parentId(j.item.extId)?.toString();let ae;if(!re)ae=this.w(j),this.g.add(ae),this.f.set(j.item.extId,ae);else if(this.f.has(re)){const ve=this.f.get(re);ve.children.add(j.item.extId),ae=this.w(j,ve),this.f.set(j.item.extId,ae)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return K.add?.(ae),j.expand===2&&this.h++,ae}o(j,K){const re=this.f.get(j.extId);if(re)return j.expand!==void 0&&(re.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$LL)(re,j),K.update?.(re),re}p(j,K){const re=this.f.get(j);if(!re)return;const ae=F.$EL.parentId(re.item.extId)?.toString();ae?this.f.get(ae).children.delete(re.item.extId):this.g.delete(re);const ve=[[j]];for(;ve.length;)for(const Ie of ve.pop()){const de=this.f.get(Ie);de&&(ve.push(de.children),this.f.delete(Ie),K.remove?.(de,de!==re),de.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$NL=q}),define(Ce[75],Re([1,0,11,5,6,56,61,50]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.TestItemEventOp=void 0;var f;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const E=(n,t)=>n===t,y=Object.entries({range:(n,t)=>n===t?!0:!n||!t?!1:n.equalsRange(t),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,t)=>!(n.length!==t.length||n.some(c=>!t.includes(c)))}),u=(n,t)=>{let c;for(const[l,i]of y)i(n[l],t[l])||(c?c[l]=t[l]:c={[l]:t[l]});return c};class v extends A.$Uc{get root(){return this.s.root}constructor(t){super(),this.s=t,this.f=this.B(new I.$Dh(()=>this.flushDiff(),200)),this.g=this.B(new N.$be),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(t){this.h=t;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const t=this.m;return this.m=[],t}pushDiff(t){switch(t.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===t.uri){c.docv=t.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===t.item.extId){(0,M.$LL)(c.item,t.item);return}if(c.op===0&&c.item.item.extId===t.item.extId){(0,M.$LL)(c.item,t.item);return}}break}}this.m.push(t),this.f.isScheduled()||this.f.schedule()}expand(t,c){const l=this.tree.get(t);if(l){if((l.expandLevels===void 0||c>l.expandLevels)&&(l.expandLevels=c),l.expand===1){const i=this.M(l);return i.isOpen()?this.L(l,c-1):i.wait().then(()=>this.L(l,c-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,c-1)):this.L(l,c-1)}}dispose(){for(const t of this.tree.values())this.s.getApiFor(t.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(t,c){switch(c.op){case 3:this.O(p.$EL.joinToString(t.fullId,c.id));break;case 0:this.z(c.item,t);break;case 5:for(const l of c.ops)this.w(t,l);break;case 1:this.C(c.new,c.old,t.fullId.toString());break;case 2:this.J(t);break;case 4:this.pushDiff({op:1,item:{extId:t.fullId.toString(),item:c.update}});break;case 6:this.y(t.actual.uri);break;default:(0,F.$cd)(c)}}y(t){t&&this.pushDiff({op:2,uri:t,docv:this.s.getDocumentVersion(t)})}z(t,c){const l=p.$EL.fromExtHostTestItem(t,this.root.id,c?.actual),i=this.s.getApiFor(t);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(t.id);let $=this.tree.get(l.toString());if(!$){$={fullId:l,actual:t,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},t.tags.forEach(this.D,this),this.tree.set($.fullId.toString(),$),this.G(t,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:$.expand,item:this.s.toITestItem(t)}}),this.I(t,$,c);return}if($.actual===t){this.H(t,$,c);return}if($.actual.uri?.toString()!==t.uri?.toString())return this.O(l.toString()),this.z(t,c);const a=this.s.getChildren($.actual),b=$.actual,h=u(this.s.toITestItem(b),this.s.toITestItem(t));this.s.getApiFor(b).listener=void 0,$.actual=t,$.resolveBarrier=void 0,$.expand=0,h&&(h.hasOwnProperty("tags")&&(this.C(t.tags,b.tags,l.toString()),delete h.tags),this.w($,{op:4,update:h})),this.I(t,$,c);for(const[d,k]of a)this.s.getChildren(t).get(k.id)||this.O(p.$EL.joinToString(l,k.id));const D=$.expandLevels;D!==void 0&&queueMicrotask(()=>{$.expand===1&&($.expandLevels=void 0,this.expand(l.toString(),D))}),this.y($.actual.uri)}C(t,c,l){const i=new Set(c.map($=>$.id));for(const $ of t)i.delete($.id)||this.D($);this.pushDiff({op:1,item:{extId:l,item:{tags:t.map($=>(0,M.$JL)(this.s.controllerId,$.id))}}}),i.forEach(this.F,this)}D(t){const c=this.j.get(t.id);c?c.refCount++:(this.j.set(t.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$JL)(this.s.controllerId,t.id)}}))}F(t){const c=this.j.get(t);c&&!--c.refCount&&(this.j.delete(t),this.pushDiff({op:7,id:(0,M.$JL)(this.s.controllerId,t)}))}G(t,c){this.s.getApiFor(t).parent=c&&c.actual!==this.root?c.actual:void 0}H(t,c,l){this.G(t,l);const i=this.s.getApiFor(t);i.parent=l?.actual,i.listener=$=>this.w(c,$),this.J(c)}I(t,c,l){this.H(t,c,l);for(const[i,$]of this.s.getChildren(t))this.z($,c)}J(t){let c;this.h?t.resolveBarrier?c=t.resolveBarrier.isOpen()?3:2:c=t.actual.canResolveChildren?1:0:c=0,c!==t.expand&&(t.expand=c,this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:c}}),c===1&&t.expandLevels!==void 0&&this.M(t))}L(t,c){if(c<0)return;const l=[];for(const[i,$]of this.s.getChildren(t.actual)){const a=this.expand(p.$EL.joinToString(t.fullId,$.id),c);(0,I.$dh)(a)&&l.push(a)}if(l.length)return Promise.all(l).then(()=>{})}M(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this.h){const $=new I.$qh;return $.open(),$}t.expand=2,this.N(t);const c=t.resolveBarrier=new I.$qh,l=$=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,$)};let i;try{i=this.h(t.actual===this.root?void 0:t.actual)}catch($){l($)}return(0,I.$dh)(i)?i.catch(l).then(()=>{c.open(),this.J(t)}):(c.open(),this.J(t)),t.resolveBarrier}N(t){this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:t.expand}})}O(t){const c=this.tree.get(t);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:t});const l=[c];for(;l.length;){const i=l.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const $ of i.actual.tags)this.F($.id);this.tree.delete(i.fullId.toString());for(const[$,a]of this.s.getChildren(i.actual))l.push(this.tree.get(p.$EL.joinToString(i.fullId,a.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.g.fire(t)}}e.$8O=v;class m extends Error{constructor(t){super(`Attempted to insert a duplicate test item ID ${t}`)}}e.$9O=m;class s extends Error{constructor(t){super(`TestItem with ID "${t}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$0O=s;class o extends Error{constructor(t,c,l){super(`TestItem with ID "${t}" is from controller "${c}" and cannot be added as a child of an item from controller "${l}".`)}}e.$$O=o;const r=(n,t,c)=>{let l=new Map;return{get size(){return l.size},forEach(i,$){for(const a of l.values())i.call($,a,this)},[Symbol.iterator](){return l.entries()},replace(i){const $=new Map,a=new Set(l.keys()),b={op:5,ops:[]};for(const h of i){if(!(h instanceof c))throw new s(h.id);const D=t(h).controllerId;if(D!==n.controllerId)throw new o(h.id,D,n.controllerId);if($.has(h.id))throw new m(h.id);$.set(h.id,h),a.delete(h.id),b.ops.push({op:0,item:h})}for(const h of a.keys())b.ops.push({op:3,id:h});n.listener?.(b),l=$},add(i){if(!(i instanceof c))throw new s(i.id);l.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){l.delete(i)&&n.listener?.({op:3,id:i})},get(i){return l.get(i)},toJSON(){return Array.from(l.values())}}};e.$_O=r}),define(Ce[105],Re([1,0,75]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=void 0;const N=new WeakMap,A=(M,p)=>{const f={controllerId:p};return N.set(M,f),f};e.$aP=A;const F=M=>{const p=N.get(M);if(!p)throw new I.$0O(M?.id||"<unknown>");return p};e.$bP=F}),define(Ce[76],Re([1,0,12,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$xb=e.$0xb=e.$9xb=void 0,e.$_xb=A,e.$ayb=M,e.$9xb="vscode-cdn.net",e.$0xb=`vscode-resource.${e.$9xb}`,e.$$xb=`'self' https://*.${e.$9xb}`;function A(p,f){return p.scheme===I.Schemas.http||p.scheme===I.Schemas.https?p:(f&&f.authority&&f.isRemote&&p.scheme===I.Schemas.file&&(p=N.URI.from({scheme:I.Schemas.vscodeRemote,authority:f.authority,path:p.path})),N.URI.from({scheme:I.Schemas.https,authority:`${p.scheme}+${F(p.authority)}.${e.$0xb}`,path:p.path,fragment:p.fragment,query:p.query}))}function F(p){return p.replace(/./g,f=>{const E=f.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?f:"-"+E.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,(f,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Ce[221],Re([1,0,5,6,76]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=void 0;class F{constructor(p,f,E){this.d=p,this.e=f,this.f=E,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const T=f.getVisibleTextEditors();for(const y of this.c.values())T.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,f,E,T,y){let u;for(const t of this.e.getVisibleTextEditors(!0))if(t.value===p){u=t;break}if(!u)throw new Error("not a visible editor");const v=this,m=this.a++,s=new I.$be,o=new I.$be,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(t){return(0,A.$_xb)(t,v.f)}get cspSource(){return A.$$xb}set options(t){this.b=t,v.d.$setOptions(m,t)}get options(){return this.b}set html(t){this.a=t,v.d.$setHtml(m,t)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(t){return v.d.$postMessage(m,t)}},n=new class{constructor(){this.editor=p,this.line=f,this.height=E,this.webview=r,this.onDidDispose=o.event}dispose(){v.c.has(m)&&(v.c.delete(m),v.d.$disposeEditorInset(m),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(m,u.id,u.value.document.uri,f+1,E,T||{},y.identifier,y.extensionLocation),this.c.set(m,{editor:p,inset:n,onDidReceiveMessage:s}),n}$onDidDispose(p){const f=this.c.get(p);f&&f.inset.dispose()}$onDidReceiveMessage(p,f){this.c.get(p)?.onDidReceiveMessage.fire(f)}}e.$Skc=F}),define(Ce[106],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=e.$UL=void 0,e.$UL="__",e.$VL=(0,I.$ri)("IAuthenticationService"),e.$WL=(0,I.$ri)("IAuthenticationExtensionsService")}),define(Ce[222],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=e.VariableKind=e.$4P=void 0,e.$4P=(0,I.$ri)("configurationResolverService");var N;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator",F.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class A extends Error{constructor(M,p){super(p),this.variable=M}}e.$5P=A}),define(Ce[223],Re([1,0,19,73,17,25,21,96,183,222,15]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hQ=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,m,s,o){this.h=new Map,this.a=v,this.b=m,this.g=s,o&&(this.c=o.then(r=>this.i(r)))}i(v){if(M.$i){const m=Object.create(null);return Object.keys(v).forEach(s=>{m[s.toLowerCase()]=v[s]}),m}return v}resolveWithEnvironment(v,m,s){return this.l({env:this.i(v),userHome:void 0},m?m.uri:void 0,s)}async resolveAsync(v,m){const s={env:await this.c,userHome:await this.g};return this.l(s,v?v.uri:void 0,m)}async j(v,m,s,o){const r=F.$Xn(m);M.$i&&r.windows?Object.keys(r.windows).forEach(t=>r[t]=r.windows[t]):M.$j&&r.osx?Object.keys(r.osx).forEach(t=>r[t]=r.osx[t]):M.$k&&r.linux&&Object.keys(r.linux).forEach(t=>r[t]=r.linux[t]),delete r.windows,delete r.osx,delete r.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,v?v.uri:void 0,r,s,o)}async resolveAnyAsync(v,m,s){return this.j(v,m,s)}async resolveAnyMap(v,m,s){const o=new Map;return{newConfig:await this.j(v,m,s,o),resolvedVariables:o}}resolveWithInteractionReplace(v,m,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,m,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,m){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,m)}async l(v,m,s,o,r){if(A.$5f(s))return this.m(v,m,s,o,r);if(Array.isArray(s))return Promise.all(s.map(n=>this.l(v,m,n,o,r)));if(A.$7f(s)){const n=Object.create(null),t=await Promise.all(Object.keys(s).map(async c=>[await this.m(v,m,c,o,r),await this.l(v,m,s[c],o,r)]));for(const[c,l]of t)n[c]=l;return n}return s}m(v,m,s,o,r){return(0,T.$mf)(s,y.VARIABLE_REGEXP,async(n,t)=>{if(t.includes(y.VARIABLE_LHS))return n;let c=await this.o(v,n,t,m,o);return r?.set(t,c),c!==n&&A.$5f(c)&&c.match(y.VARIABLE_REGEXP)&&(c=await this.m(v,m,c,o,r)),c})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,m,s,o,r){let n;const t=s.split(":");t.length>1&&(s=t[0],n=t[1]);const c=$=>{const a=this.a.getFilePath();if(a)return(0,p.$rw)(a);throw new E.$5P($,(0,f.localize)(0,null,m))},l=$=>{const a=c($);if(this.a.getWorkspaceFolderPathForFile){const b=this.a.getWorkspaceFolderPathForFile();if(b)return(0,p.$rw)(b)}throw new E.$5P($,(0,f.localize)(1,null,m,I.$oc(a)))},i=$=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new E.$5P($,(0,f.localize)(2,null,m,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new E.$5P($,(0,f.localize)(3,null,m)):new E.$5P($,(0,f.localize)(4,null,m))};switch(s){case"env":if(n){if(v.env){const $=v.env[M.$i?n.toLowerCase():n];if(A.$5f($))return $}return""}throw new E.$5P(E.VariableKind.Env,(0,f.localize)(5,null,m));case"config":if(n){const $=this.a.getConfigurationValue(o,n);if(A.$bg($))throw new E.$5P(E.VariableKind.Config,(0,f.localize)(6,null,m,n));if(A.$7f($))throw new E.$5P(E.VariableKind.Config,(0,f.localize)(7,null,m,n));return $}throw new E.$5P(E.VariableKind.Config,(0,f.localize)(8,null,m));case"command":return this.p(E.VariableKind.Command,m,n,r,"command");case"input":return this.p(E.VariableKind.Input,m,n,r,"input");case"extensionInstallFolder":if(n){const $=await this.a.getExtension(n);if(!$)throw new E.$5P(E.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,m,n));return this.n($.extensionLocation)}throw new E.$5P(E.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,m));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,p.$rw)(this.n(i(E.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,p.$rw)(this.n(i(E.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$rw)(I.$oc(this.n(i(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new E.$5P(E.VariableKind.UserHome,(0,f.localize)(11,null,m))}case"lineNumber":{const $=this.a.getLineNumber();if($)return $;throw new E.$5P(E.VariableKind.LineNumber,(0,f.localize)(12,null,m))}case"selectedText":{const $=this.a.getSelectedText();if($)return $;throw new E.$5P(E.VariableKind.SelectedText,(0,f.localize)(13,null,m))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return l(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(l(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?I.$mc(this.n(i(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const $=I.$nc(c(E.VariableKind.RelativeFileDirname));if(o||n){const a=I.$mc(this.n(i(E.VariableKind.RelativeFileDirname)),$);return a.length===0?".":a}return $}case"fileDirname":return I.$nc(c(E.VariableKind.FileDirname));case"fileExtname":return I.$pc(c(E.VariableKind.FileExtname));case"fileBasename":return I.$oc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const $=I.$oc(c(E.VariableKind.FileBasenameNoExtension));return $.slice(0,$.length-I.$pc($).length)}case"fileDirnameBasename":return I.$oc(I.$nc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const $=this.a.getExecPath();return $||m}case"execInstallFolder":{const $=this.a.getAppRoot();return $||m}case"pathSeparator":case"/":return I.sep;default:try{const $=n?`${s}:${n}`:s;return this.p(E.VariableKind.Unknown,m,$,r,void 0)}catch{return m}}}}p(v,m,s,o,r){if(s&&o){const n=r===void 0?o[s]:o[r+":"+s];if(typeof n=="string")return n;throw new E.$5P(v,(0,f.localize)(14,null,m))}return m}}e.$hQ=y}),define(Ce[107],Re([1,0,3,104]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$KD=void 0,e.$LD=E,e.$MD=u,e.$ND=v,e.$KD=(0,I.$ri)("editorGroupsService");var A;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var F;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var M;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var p;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EXPAND=1]="EXPAND",m[m.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var f;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function E(m){const s=m;return(0,N.$vF)(s?.editor)&&(0,N.$vF)(s?.replacement)}var T;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var y;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(m){const s=m;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}function v(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ce[224],Re([1,0,3,107]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RD=e.$QD=e.$PD=e.$OD=void 0,e.$SD=A,e.$OD=(0,I.$ri)("editorService"),e.$PD=-1,e.$QD=-2,e.$RD=-3;function A(F){const M=F;return typeof F=="number"||(0,N.$MD)(M)}}),define(Ce[225],Re([1,0,3,190]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=void 0,e.$dM=(0,I.$si)(N.$yi)}),define(Ce[108],Re([1,0,20,5,19,6,11]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_b=e.$d_b=e.$c_b=e.$b_b=e.$a_b=void 0;class p{constructor(n,t){this.versionId=n,this.removedDueToLooping=t}}e.$a_b=p;class f{static isHostExtension(n,t,c){if(t.getExtensionDescription(n))return!1;const l=c.getExtensionDescription(n);return l?!!((l.main||l.browser)&&l.api==="none"):!1}constructor(n,t){this.j=n,this.c=new N.$be,this.onDidChange=this.c.event,this.d=0,this.e=t,this.k()}k(){this.e.sort(s),this.f=new I.$Om,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const t=this.j.readActivationEvents(n);for(const c of t)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,t){this.e=o(this.e,t),this.e=this.e.concat(n);const c=f.l(this.e);return this.e=o(this.e,c.map(l=>l.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,c)}static l(n){const t=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,b){this.addNode(a),this.addNode(b),this.c.has(a)?this.c.get(a).push(b):this.c.set(a,[b])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,b){const h=t.getArcs(a);for(let D=0;D<h.length;D++)if(!b.has(h[D]))return!1;return!0}getNodes(){return this.e}},c=new I.$Om;for(const a of n)if(c.set(a.identifier,a),a.extensionDependencies)for(const b of a.extensionDependencies)t.addArc(I.$Mm.toKey(a.identifier),I.$Mm.toKey(b));const l=new Set;t.getNodes().filter(a=>t.getArcs(a).length===0).forEach(a=>l.add(a));const i=t.getNodes().filter(a=>!l.has(a));let $;do{$=!1;for(let a=0;a<i.length;a++){const b=i[a];t.hasOnlyGoodArcs(b,l)&&(i.splice(a,1),a--,l.add(b),$=!0)}}while($);return i.map(a=>c.get(a))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const t=this.h.get(n);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const t=this.f.get(n);return t||void 0}getExtensionDescriptionByUUID(n){for(const t of this.g)if(t.uuid===n)return t}getExtensionDescriptionByIdOrUUID(n,t){return this.getExtensionDescription(n)??(t?this.getExtensionDescriptionByUUID(t):void 0)}}e.$b_b=f;class E{constructor(n,t){this.versionId=n,this.extensions=t}}e.$c_b=E;class T{constructor(n){this.d=new v,this.c=new f(n,[])}async acquireLock(n){const t=await this.d.acquire(n);return new y(this,t)}deltaExtensions(n,t,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(t,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,t){return this.c.getExtensionDescriptionByIdOrUUID(n,t)}}e.$d_b=T;class y extends F.$Uc{constructor(n,t){super(),this.f=n,this.c=!1,this.B(t)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$e_b=y;class u{constructor(n){this.name=n;const t=(0,M.$kh)();this.promise=t.promise,this.c=t.resolve}resolve(n){this.c(n)}}class v{constructor(){this.c=[],this.d=!1}async acquire(n){const t=new u(n);return this.c.push(t),this.e(),t.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let t=!0;const c=setTimeout(()=>{t&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),l=()=>{t&&(clearTimeout(c),t=!1,this.d=!1,this.e())};n.resolve((0,F.$Sc)(l))}}var m;(function(r){r[r.Builtin=0]="Builtin",r[r.User=1]="User",r[r.Dev=2]="Dev"})(m||(m={}));function s(r,n){const t=r.isBuiltin?0:r.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(t!==c)return t-c;const l=A.$hc.basename(r.extensionLocation.path),i=A.$hc.basename(n.extensionLocation.path);return l<i?-1:l>i?1:0}function o(r,n){const t=new I.$Nm(n);return r.filter(c=>!t.has(c.identifier))}}),define(Ce[77],Re([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Um=M,e.$Vm=p;var N;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(N||(e.UIKind=N={}));var A;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var F;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function M(E){const T=I.$Ce.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function p(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var f;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Ce[62],Re([1,0,3,5,13,27,77,58,59,25,2,6,170]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=e.$xP=e.$wP=void 0,e.$yP=s;let v=class extends y.$Uc{constructor(r,n){super(),this.s=r,this.t=n,this.a=this.B(new N.$be),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$be),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:f.$fp,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(t=>{(0,A.$Zj)(t)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,n,t){const c=this.getTelemetryDetails(),l=new m(n,t,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...i,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(r,n,t){this.f=r,this.g=n,this.c=t??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const n=Object.create(null);switch(n["common.extname"]=`${r.publisher}.${r.name}`,n["common.extversion"]=r.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$Dm)((0,f.$lp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const n=this.getTelemetryDetails();this.r.forEach((t,c)=>{const l=t.filter(i=>!i.isDisposed);l.length===0?this.r.delete(c):this.r.set(c,l)}),this.r.forEach(t=>{for(const c of t)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,n){const c=this.r.get(r.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(r.value),!1;let l=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),l=!0);return l}};e.$wP=v,e.$wP=v=Je([We(0,F.$vP),We(1,A.$Yj)],v);class m{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,n,t,c,l,i,$){this.g=t,this.h=c,this.i=l,this.j=i,this.a=new N.$be,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}}updateTelemetryEnablements(r,n){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let n="properties"in r?r.properties??{}:r;return n=(0,f.$op)(n,[]),this.c&&(n=(0,E.$1n)(n,this.c)),this.b||(n=(0,E.$1n)(n,this.j)),"properties"in r?r.properties=n:r=n,r}k(r,n){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(r,n),this.h.trace(r,n))}logUsage(r,n){this.d.isUsageEnabled&&this.k(r,n)}logError(r,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,n);else{const t={name:r.name,message:r.message,stack:r.stack,cause:r.cause},c=(0,f.$op)(t,[]),l=new Error(c.message,{cause:c.cause});l.stack=c.stack,l.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(l,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const r=this,n={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$xP=m;function s(o){const r=Date.now()-new Date(o).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$zP=(0,I.$ri)("IExtHostTelemetry")}),define(Ce[26],Re([1,0,5,2,199,103,20,3]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FG=e.ActivationKind=e.$CG=e.$BG=e.$yG=e.ExtensionHostStartup=e.$xG=e.$wG=e.$vG=e.$uG=void 0,e.$zG=u,e.$AG=v,e.$DG=r,e.$EG=n,e.$uG=Object.freeze({identifier:new M.$Mm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$vG="extensions.webWorker",e.$wG=(0,p.$ri)("extensionService");class f{constructor(l){this.dependency=l}}e.$xG=f;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,i,$){this.c=l,this.d=i.slice(0),this.e=$.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$fG.createActivationEventsMap(this.d)}}set(l,i,$){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const a=[],b=[],h=[],D=[],d=y(this.d),k=y(i),g=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=k.get(W.identifier);if(!V){a.push(W.identifier),d.delete(W.identifier);continue}if(!g(W,V)){a.push(W.identifier),d.delete(W.identifier);continue}}for(const W of i){const V=d.get(W.identifier);if(!V){b.push(W);continue}if(!g(V,W)){a.push(V.identifier),d.delete(V.identifier);continue}}const S=new M.$Nm(this.e),w=new M.$Nm($);for(const W of this.e)w.has(W)||h.push(W);for(const W of $)S.has(W)||D.push(W);const C=F.$fG.createActivationEventsMap(b),P={versionId:l,toRemove:a,toAdd:b,addActivationEvents:C,myToRemove:h,myToAdd:D};return this.delta(P),P}delta(l){if(this.c>=l.versionId)return null;const{toRemove:i,toAdd:$,myToRemove:a,myToAdd:b}=l,h=new M.$Nm(i),D=new M.$Nm(a);for(let d=0;d<this.d.length;d++)h.has(this.d[d].identifier)&&(this.d.splice(d,1),d--);for(let d=0;d<this.e.length;d++)D.has(this.e[d])&&(this.e.splice(d,1),d--);for(const d of $)this.d.push(d);for(const d of b)this.e.push(d);return this.f=null,l}containsExtension(l){for(const i of this.e)if(M.$Mm.equals(i,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const $=F.$fG.readActivationEvents(i);for(const a of $)l.add(a)}return l}}e.$yG=T;function y(c){const l=new M.$Om;for(const i of c)l.set(i.identifier,i);return l}function u(c,l){return c.enabledApiProposals?c.enabledApiProposals.includes(l):!1}function v(c,l){if(!u(c,l))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class m{constructor(l,i,$,a){this.codeLoadingTime=l,this.activateCallTime=i,this.activateResolvedTime=$,this.activationReason=a}}e.$BG=m;class s{constructor(l,i){this.description=l,this.value=i}}e.$CG=s;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,A.$up)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function n(c,l){return{identifier:new M.$Mm((0,A.$sp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!l,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class t{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,i){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$FG=t}),define(Ce[226],Re([1,0,14,108,20,26,13,11]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=e.$glc=e.$flc=e.$elc=e.$dlc=e.$clc=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(r,n,t,c){this.startup=r,this.codeLoadingTime=n,this.activateCallTime=t,this.activateResolvedTime=c}}e.$clc=f;class E{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,n){return r===-1||n===-1?-1:n-r}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$dlc=E;class T{constructor(r,n,t,c,l,i){this.activationFailed=r,this.activationFailedError=n,this.activationTimes=t,this.module=c,this.exports=l,this.subscriptions=i}}e.$elc=T;class y extends T{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$flc=y;class u extends T{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$glc=u;class v extends T{constructor(r){super(!0,r,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(r,n,t,c){this.g=c,this.a=r,this.b=n,this.c=t,this.d=new A.$Om,this.f=Object.create(null)}dispose(){for(const[r,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const r=[];for(const[n,t]of this.d)r.push(t.wait());await Promise.all(r)}isActivated(r){const n=this.d.get(r);return!!(n&&n.value)}getActivatedExtension(r){const n=this.d.get(r);if(!n||!n.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return n.value}async activateByEvent(r,n){if(this.f[r])return;const t=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(t.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,n){const t=this.a.getExtensionDescription(r);if(!t)throw new Error(`Extension '${r.value}' is not known`);return this.h([{id:t.identifier,reason:n}])}async h(r){const n=r.filter(t=>!this.isActivated(t.id)).map(t=>this.j(t));await Promise.all(n.map(t=>t.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const n=this.a.getExtensionDescription(r.id);if(!n){const l=new Error(`Cannot activate unknown extension '${r.id.value}'`),i=this.k(r,null,[],new v(l));return this.c.onExtensionActivationError(r.id,l,new F.$xG(r.id.value)),i}const t=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const l of c){if(this.m(l))continue;const i=this.d.get(l);if(i){t.push(i);continue}if(this.l(l)){t.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:r.reason}));continue}const $=this.a.getExtensionDescription(l);if($){if(!$.main&&!$.browser)continue;t.push(this.j({id:$.identifier,reason:r.reason}));continue}const a=n.displayName||n.identifier.value,b=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${l}'`),h=this.k(r,n.displayName,[],new v(b));return this.c.onExtensionActivationError(n.identifier,b,new F.$xG(l)),h}return this.k(r,n.displayName,t,null)}k(r,n,t,c){const l=new s(r.id,n,r.reason,t,c,this.c,this.g);return this.d.set(r.id,l),l}l(r){return N.$b_b.isHostExtension(r,this.a,this.b)}m(r){const n=this.b.getExtensionDescription(r);return n?!n.main&&!n.browser:!1}};e.$hlc=m,e.$hlc=m=Je([We(3,M.$Xj)],m);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,n,t,c,l,i,$){this.c=r,this.d=n,this.f=t,this.g=c,this.h=l,this.j=i,this.k=$,this.a=new p.$qh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const n=this.g[r];if(n.value&&!n.value.activationFailed){this.g.splice(r,1),r--;continue}if(n.value&&n.value.activationFailed){const t=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);t.detail=n.value.activationFailedError,this.h=new v(t),this.j.onExtensionActivationError(this.c,t,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const n=new Error;if(r&&r.name&&(n.name=r.name),r&&r.message?n.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(n.stack=r.stack),this.h=new v(n),this.b&&I.$4(r))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};s=Je([We(6,M.$Xj)],s)}),define(Ce[227],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[228],Re([1,0,185,14,33,98,72,30,20,227,195,103]),function(ge,e,I,N,A,F,M,p,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=void 0;const u=p.$0n.as(M.$$n.JSONContribution);class v{constructor(l,i,$){this.a=l,this.b=i,this.c=$}d(l,i){this.a({type:l,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(A.default.Error,l)}warn(l){this.d(A.default.Warning,l)}info(l){this.d(A.default.Info,l)}}e.$oG=v;class m{static a(l){const i=new f.$Nm;for(let $=0,a=l.length;$<a;$++)i.add(l[$].description.identifier);return i}static compute(l,i){if(!l||!l.length)return new m(i,[]);if(!i||!i.length)return new m([],l);const $=this.a(l),a=this.a(i),b=i.filter(D=>!$.has(D.description.identifier)),h=l.filter(D=>!a.has(D.description.identifier));return new m(b,h)}constructor(l,i){this.added=l,this.removed=i}}e.$pG=m;class s{constructor(l,i){this.name=l,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=m.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,N.$1)(l)}}}e.$qG=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$rG={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$Lm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Oo}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Oo}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const i=new s(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,i),l.activationEventsGenerator&&y.$fG.register(l.extensionPoint,l.activationEventsGenerator),e.$rG.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,u.registerSchema(r,e.$rG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$sG=n;const t={ExtensionsRegistry:"ExtensionsRegistry"};p.$0n.add(t.ExtensionsRegistry,new n),e.$tG=p.$0n.as(t.ExtensionsRegistry),u.registerSchema(r,e.$rG),u.registerSchema(T.$fk,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Ce[229],Re([1,0,181,17,25,228,31,5]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var E;(function(u){function v(m,s,o){if(!m)return;const r=N.$5f(m.type)?m.type:void 0;if(!r||r.length===0){o.error(I.localize(3,null));return}const n=[];if(Array.isArray(m.required))for(const t of m.required)N.$5f(t)&&n.push(t);return{extensionId:s.value,taskType:r,required:n,properties:m.properties?A.$Xn(m.properties):{},when:m.when?M.$pj.deserialize(m.when):void 0}}u.from=v})(E||(E={}));const T=F.$tG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,v)=>{for(const m of u)m.type&&v.push(`onTaskType:${m.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:f}});class y{constructor(){this.d=new p.$be,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,m)=>{T.setHandler((s,o)=>{this.c=void 0;try{for(const r of o.removed){const n=r.value;for(const t of n)this.a&&t.type&&this.a[t.type]&&delete this.a[t.type]}for(const r of o.added){const n=r.value;for(const t of n){const c=E.from(t,r.description.identifier,r.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const m of this.all()){const s={type:"object",additionalProperties:!1};m.required.length>0&&(s.required=m.required.slice(0)),m.properties!==void 0?s.properties=A.$Xn(m.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[m.taskType]},v.push(s)}this.c={oneOf:v}}return this.c}}e.$XH=new y}),define(Ce[230],Re([1,0,182,17,23,25,31,229]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$8H=e.JsonSchemaVersion=e.ExecutionEngine=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$2H=e.ShellQuoting=e.$1H=e.$ZH=e.$YH=void 0,e.$YH="settings",e.$ZH=new M.$Ij("taskRunning",!1,I.localize(0,null)),e.$1H=I.localize2(2,"Tasks");var f;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$2H="$customized",function(R){function j(K){if(!K)return R.Strong;switch(K.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=j}(f||(e.ShellQuoting=f={}));var E;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(T||(e.RevealKind=T={})),function(R){function j(K){switch(K.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=j}(T||(e.RevealKind=T={}));var y;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(y||(e.RevealProblemKind=y={})),function(R){function j(K){switch(K.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=j}(y||(e.RevealProblemKind=y={}));var u;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(u||(e.PanelKind=u={})),function(R){function j(K){switch(K.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=j}(u||(e.PanelKind=u={}));var v;(function(R){R.defaults={echo:!0,reveal:T.Always,revealProblems:y.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var m;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(R){function j(re){switch(re.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=j;function K(re){switch(re){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=K}(m||(e.RuntimeType=m={}));var s;(function(R){function j(K){return N.$5f(K)?K:K.value}R.value=j})(s||(e.CommandString=s={}));var o;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function j(re){return re===R.Clean._id||re===R.Build._id||re===R.Rebuild._id||re===R.Test._id}R.is=j;function K(re){if(re!==void 0)return N.$5f(re)?j(re)?{_id:re,isDefault:!1}:void 0:re}R.from=K})(o||(e.TaskGroup=o={}));var r;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var n;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function j(K){switch(K){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=j})(n||(e.TaskSourceKind=n={}));var t;(function(R){R.parallel="parallel",R.sequence="sequence"})(t||(e.DependsOrder=t={}));var c;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var l;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class i{constructor(j,K,re,ae,ve,Ie){this._label="",this._id=j,K&&(this._label=K),re&&(this.type=re),this.runOptions=ae,this.configurationProperties=ve,this._source=Ie}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,K=!1){if(j===void 0)return!1;if(N.$5f(j))return j===this._label||j===this.configurationProperties.identifier||K&&j===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$3H=i;class $ extends i{constructor(j,K,re,ae,ve,Ie,de,me){super(j,re,void 0,de,me,K),this.command={},this._source=K,this.hasDefinedMatchers=Ie,ve&&(this.command=ve)}clone(){return new $(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case m.Shell:K="shell";break;case m.Process:K="process";break;case m.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(j){return j instanceof $}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$YH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const re={type:e.$2H,folder:j,id:K};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$2g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new $(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$4H=$;class a extends i{constructor(j,K,re,ae,ve,Ie,de){super(j,re,ae,Ie,de,K),this._source=K,this.configures=ve}static is(j){return j instanceof a}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$2g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$YH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const re={type:e.$2H,folder:j,id:K};return JSON.stringify(re)}}e.$5H=a;class b extends i{constructor(j,K,re,ae,ve,Ie,de,me,Me){super(j,re,ae,me,Me,K),this.defines=ve,this.hasDefinedMatchers=de,this.command=Ie,this.icon=Me.icon,this.hide=Me.hide}clone(){return new b(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof b}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new b(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$6H=b;class h extends i{constructor(j,K,re,ae,ve,Ie){super(j,re,ae,ve,Ie,K),this._source=K}clone(){return new h(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof h}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new h(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$7H=h;var D;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(R){R._default=R.Terminal}(D||(e.ExecutionEngine=D={}));var d;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(d||(e.JsonSchemaVersion=d={}));class k{constructor(j){this.c=new Map;for(let K=0;K<j.length;K++)this.c.set(j[K].uri.toString(),K)}compare(j,K){const re=j.getWorkspaceFolder(),ae=K.getWorkspaceFolder();if(re&&ae){let ve=this.c.get(re.uri.toString());ve=ve===void 0?0:ve+1;let Ie=this.c.get(ae.uri.toString());return Ie=Ie===void 0?0:Ie+1,ve===Ie?j._label.localeCompare(K._label):ve-Ie}else return!re&&ae?-1:re&&!ae?1:0}}e.$8H=k;var g;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(g||(e.TaskEventKind=g={}));var S;(function(R){R.SingleRun="singleRun",R.Background="background"})(S||(e.TaskRunType=S={}));var w;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var C;(function(R){function j(me){return{taskId:me._id,taskName:me.configurationProperties.name,runType:me.configurationProperties.isBackground?"background":"singleRun",group:me.configurationProperties.group,__task:me}}function K(me,Me,ce){return{...j(me),kind:"start",terminalId:Me,resolvedVariables:ce}}R.start=K;function re(me,Me,ce){return{...j(me),kind:"processStarted",terminalId:Me,processId:ce}}R.processStarted=re;function ae(me,Me,ce){return{...j(me),kind:"processEnded",terminalId:Me,exitCode:ce}}R.processEnded=ae;function ve(me,Me,ce){return{...j(me),kind:"terminated",exitReason:ce,terminalId:Me}}R.terminated=ve;function Ie(me,Me,ce){return{...j(Me),kind:me,terminalId:ce}}R.general=Ie;function de(){return{kind:"changed"}}R.changed=de})(C||(e.TaskEvent=C={}));var P;(function(R){function j(re){const ae=Object.keys(re).sort();let ve="";for(const Ie of ae){let de=re[Ie];de instanceof Object?de=j(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),ve+=Ie+","+de+","}return ve}function K(re){const ve={_key:j(re),type:re.taskType};return Object.assign(ve,re),ve}R.create=K})(P||(e.KeyedTaskIdentifier=P={}));var W;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(R){function j(K,re){const ae=p.$XH.get(K.type);if(ae===void 0){const me=F.$Xn(K);return delete me._key,P.create(me)}const ve=Object.create(null);ve.type=ae.taskType;const Ie=new Set;ae.required.forEach(me=>Ie.add(me));const de=ae.properties;for(const me of Object.keys(de)){const Me=K[me];if(Me!=null)ve[me]=Me;else if(Ie.has(me)){const ce=de[me];if(ce.default!==void 0)ve[me]=F.$Xn(ce.default);else switch(ce.type){case"boolean":ve[me]=!1;break;case"number":case"integer":ve[me]=0;break;case"string":ve[me]="";break;default:re.error(I.localize(1,null,JSON.stringify(K,void 0,0),me));return}}}return P.create(ve)}R.createTaskIdentifier=j})(q||(e.TaskDefinition=q={}))}),define(Ce[231],Re([1,0,14]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g_b=e.$f_b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,p)=>{this.b=M,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,I.$1)(M))}then(M,p){return this.j().then(M,p)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$f_b=N;class A extends N{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$g_b=A}),define(Ce[34],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$lw=void 0,e.$mw=A,e.$nw=F;class I{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++I.count}}e.$lw=I;const N=[];function A(p){const f=new I(p);return N[f.nid]=f,f}function F(p){return N[p].sid}class M{constructor(f){this.value=f}}e.$ow=M}),define(Ce[4],Re([1,0,34]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$RM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var A;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput",s[s.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var F;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var M;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var p;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var f;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var E;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$RM=y;var u;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var m;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$SM={MainThreadAuthentication:(0,I.$mw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$mw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$mw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$mw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$mw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$mw)("MainThreadClipboard"),MainThreadCommands:(0,I.$mw)("MainThreadCommands"),MainThreadComments:(0,I.$mw)("MainThreadComments"),MainThreadConfiguration:(0,I.$mw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$mw)("MainThreadConsole"),MainThreadDebugService:(0,I.$mw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$mw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$mw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$mw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$mw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$mw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$mw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$mw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$mw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$mw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$mw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$mw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$mw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$mw)("MainThreadLanguages"),MainThreadLogger:(0,I.$mw)("MainThreadLogger"),MainThreadMessageService:(0,I.$mw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$mw)("MainThreadOutputService"),MainThreadProgress:(0,I.$mw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$mw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$mw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$mw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$mw)("MainThreadSecretState"),MainThreadStorage:(0,I.$mw)("MainThreadStorage"),MainThreadSpeech:(0,I.$mw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$mw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$mw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$mw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$mw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$mw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$mw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$mw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$mw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$mw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$mw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$mw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$mw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$mw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$mw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$mw)("MainThreadSCM"),MainThreadSearch:(0,I.$mw)("MainThreadSearch"),MainThreadShare:(0,I.$mw)("MainThreadShare"),MainThreadTask:(0,I.$mw)("MainThreadTask"),MainThreadWindow:(0,I.$mw)("MainThreadWindow"),MainThreadLabelService:(0,I.$mw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$mw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$mw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$mw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$mw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$mw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$mw)("MainThreadInteractive"),MainThreadInlineChat:(0,I.$mw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$mw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$mw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$mw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$mw)("MainThreadTimeline"),MainThreadTesting:(0,I.$mw)("MainThreadTesting"),MainThreadLocalization:(0,I.$mw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$mw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$mw)("MainThreadAiEmbeddingVector")},e.$TM={ExtHostCommands:(0,I.$mw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$mw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$mw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$mw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$mw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$mw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$mw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$mw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$mw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$mw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$mw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$mw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$mw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$mw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$mw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$mw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$mw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$mw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$mw)("ExtHostStatusBar"),ExtHostShare:(0,I.$mw)("ExtHostShare"),ExtHostExtensionService:(0,I.$mw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$mw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$mw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$mw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$mw)("ExtHostSCM"),ExtHostSearch:(0,I.$mw)("ExtHostSearch"),ExtHostTask:(0,I.$mw)("ExtHostTask"),ExtHostWorkspace:(0,I.$mw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$mw)("ExtHostWindow"),ExtHostWebviews:(0,I.$mw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$mw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$mw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$mw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$mw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$mw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$mw)("ExtHostProgress"),ExtHostComments:(0,I.$mw)("ExtHostComments"),ExtHostSecretState:(0,I.$mw)("ExtHostSecretState"),ExtHostStorage:(0,I.$mw)("ExtHostStorage"),ExtHostUrls:(0,I.$mw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$mw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$mw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$mw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$mw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$mw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$mw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$mw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$mw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$mw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$mw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$mw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$mw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,I.$mw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$mw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$mw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$mw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$mw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$mw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$mw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$mw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$mw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$mw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$mw)("ExtHostTimeline"),ExtHostTesting:(0,I.$mw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$mw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$mw)("ExtHostLocalization")}}),define(Ce[78],Re([1,0,3,13,4,16]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=e.$Ckc=e.$Bkc=void 0,e.$Bkc=(0,I.$ri)("IExtHostApiDeprecationService");let M=class{constructor(f,E){this.c=E,this.a=new Set,this.b=f.getProxy(A.$SM.MainThreadTelemetry)}report(f,E,T){const y=this.d(f,E);this.a.has(y)||(this.a.add(y),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:f}))}d(f,E){return`${f}-${E.identifier.value}`}};e.$Ckc=M,e.$Ckc=M=Je([We(0,F.$fP),We(1,N.$Xj)],M),e.$Dkc=Object.freeze(new class{report(p,f,E){}})}),define(Ce[232],Re([1,0,4]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;class N{constructor(F){const M=F.getProxy(I.$SM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(p){return M.$writeText(p)}})}}e.$Qkc=N}),define(Ce[233],Re([1,0,25,4,27,16]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=void 0;let M=class{constructor(T,y){this.a=T.getProxy(N.$SM.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,y){const u=this,v=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){u.e(T,y,v,arguments)}})}e(T,y,u,v){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:f(v,this.b)}),this.c&&this.f(T,u,v)}};e.$Kmc=M,e.$Kmc=M=Je([We(0,F.$fP),We(1,A.$vP)],M);const p=1e5;function f(E,T){const y=[];if(E.length)for(let u=0;u<E.length;u++){let v=E[u];if(typeof v>"u")v="undefined";else if(v instanceof Error){const m=v;m.stack?v=m.stack:v=m.toString()}y.push(v)}if(T){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.$3n)(y);return u.length>p?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ce[234],Re([1,0,2,4,26]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;class F{constructor(p){this.a=p.getProxy(N.$SM.MainThreadDialogs)}showOpenDialog(p,f){return f?.allowUIResources&&(0,A.$AG)(p,"showLocal"),this.a.$showOpenDialog(f).then(E=>E?E.map(T=>I.URI.revive(T)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(f=>f?I.URI.revive(f):void 0)}}e.$Nlc=F}),define(Ce[235],Re([1,0,6,4]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=void 0;class A{constructor(M){this.b=0,this.a=M.getProxy(N.$SM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,M),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$8lc=A}),define(Ce[79],Re([1,0,21,15,2,3,13,4,27,16]),function(ge,e,I,N,A,F,M,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$vlc=void 0;let T=class{constructor(u,v,m){this.f=m,this.d=new Map,this.a=v.getProxy(p.$SM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===I.$g}getMessage(u,v){const{message:m,args:s,comment:o}=v;if(this.c)return(0,N.$6e)(m,s??{});let r=m;o&&o.length>0&&(r+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(u)?.contents[r];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,N.$6e)(n??m,s??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let v;const m=await this.g(u);if(!m){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(m),o=JSON.parse(s);v=u.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${u.identifier.value} from ${m}: ${s.message}`);return}v&&this.d.set(u.identifier.value,{contents:v,uri:m})}async g(u){if(u.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return A.URI.revive(v)}return u.l10n?A.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$vlc=T,e.$vlc=T=Je([We(0,f.$vP),We(1,E.$fP),We(2,M.$Xj)],T),e.$wlc=(0,F.$ri)("IExtHostLocalizationService")}),define(Ce[236],Re([1,0,13,4,27,16,2,53]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;let f=class extends I.$9j{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(v=>(0,p.$1h)(v))),this.r=y.getProxy(N.$SM.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(M.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,v){return new E(this.r,y,u,v)}};e.$Jmc=f,e.$Jmc=f=Je([We(0,F.$fP),We(1,A.$vP)],f);class E extends I.$4j{constructor(y,u,v,m){super(m?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(u,m).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const v=[[y,u]];this.m?this.u(v):this.n.push(...v)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ce[80],Re([1,0,4,3,6,16,22]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=e.$xlc=void 0,e.$xlc=(0,N.$ri)("IExtHostManagedSockets");let p=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(I.$SM.MainThreadManagedSockets)}setFactory(y,u){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,v=await this.c.makeConnection(),m=new A.$Tc;return this.d.set(u,new E(u,v,m)),m.add((0,A.$Sc)(()=>this.d.delete(u))),m.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),m.dispose()})),m.add(v.onDidClose(s=>{this.a.$onDidManagedSocketClose(u,s?.stack??s?.message),m.dispose()})),m.add(v.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(u,M.$Ce.wrap(s)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$ylc=p,e.$ylc=p=Je([We(0,F.$fP)],p);class f{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class E extends A.$Uc{constructor(y,u,v){super(),this.socketId=y,this.actual=u,this.B(v)}}}),define(Ce[237],Re([1,0,4,13,26]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;function F(p){return p&&p.title}let M=class{constructor(f,E){this.b=E,this.a=f.getProxy(I.$SM.MainThreadMessageService)}showMessage(f,E,T,y,u){const v={source:{identifier:f.identifier,label:f.displayName||f.name}};let m;typeof y=="string"||F(y)?m=[y,...u]:(v.modal=y?.modal,v.useCustom=y?.useCustom,v.detail=y?.detail,m=u),v.useCustom&&(0,A.$AG)(f,"resolvers");const s=[];let o=!1;for(let r=0;r<m.length;r++){const n=m[r];if(typeof n=="string")s.push({title:n,handle:r,isCloseAffordance:!1});else if(typeof n=="object"){const{title:t,isCloseAffordance:c}=n;s.push({title:t,isCloseAffordance:!!c,handle:r}),c&&(o?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,T,v,s).then(r=>{if(typeof r=="number")return m[r]})}};e.$0lc=M,e.$0lc=M=Je([We(1,N.$Xj)],M)}),define(Ce[238],Re([1,0,6,17,2,26,4]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;class p{constructor(E){this.b=new Map,this.a=E.getProxy(M.$SM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,T,y){if((0,F.$AG)(E,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,y),this.a.$registerProfileContentHandler(T,y.name,y.description,E.identifier.value),(0,I.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,y,u){const v=this.b.get(E);if(!v)throw new Error(`Unknown handler with id: ${E}`);return v.saveProfile(T,y,u)}async $readProfile(E,T,y){const u=this.b.get(E);if(!u)throw new Error(`Unknown handler with id: ${E}`);return u.readProfile((0,N.$5f)(T)?T:A.URI.revive(T),y)}}e.$gmc=p}),define(Ce[81],Re([1,0,4,5,3]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=e.$slc=void 0;class F{constructor(p){this.b=new N.$be,this.onDidChangePassword=this.b.event,this.a=p.getProxy(I.$SM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,f){return this.a.$getPassword(p,f)}store(p,f,E){return this.a.$setPassword(p,f,E)}delete(p,f){return this.a.$deletePassword(p,f)}}e.$slc=F,e.$tlc=(0,A.$ri)("IExtHostSecretState")}),define(Ce[239],Re([1,0,24,6,4]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=void 0;class F{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(A.$SM.MainThreadSpeech)}async $createSpeechToTextSession(p,f,E){const T=this.c.get(p);if(!T)return;const y=new N.$Tc,u=new I.$me;this.d.set(f,u);const v=y.add(T.provideSpeechToTextSession(u.token,E?{language:E}:void 0));y.add(v.onDidChange(m=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,m)})),y.add(u.token.onCancellationRequested(()=>y.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,f){const E=this.c.get(p);if(!E)return;const T=new N.$Tc,y=new I.$me;this.d.set(f,y);const u=T.add(E.provideKeywordRecognitionSession(y.token));T.add(u.onDidChange(v=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(f,v)})),T.add(y.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,f,E){const T=F.a++;return this.c.set(T,E),this.b.$registerProvider(T,f,{extension:p,displayName:p.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$nmc=F}),define(Ce[82],Re([1,0,4,5,3]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=e.$ilc=void 0;class F{constructor(p,f){this.c=f,this.b=new N.$be,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(I.$SM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,f){this.a.$registerExtensionStorageKeysToSync(p,f)}async initializeExtensionStorage(p,f,E){const T=await this.a.$initializeExtensionStorage(p,f);let y;return T&&(y=this.d(p,f,T)),y||E}setValue(p,f,E){return this.a.$setValue(p,f,E)}$acceptValue(p,f,E){const T=this.d(p,f,E);T&&this.b.fire({shared:p,key:f,value:T})}d(p,f,E){try{return JSON.parse(E)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${p}): ${T}`)}}}e.$ilc=F,e.$jlc=(0,A.$ri)("IExtHostStorage")}),define(Ce[240],Re([1,0,6,12,2,4]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(F.$SM.MainThreadUriOpeners)}registerExternalUriOpener(f,E,T,y){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const u=y.schemes.find(v=>!M.a.has(v));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(E,T),this.b.$registerUriOpener(E,y.schemes,f,y.label),(0,I.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(f,E,T){const y=this.c.get(f);if(!y)throw new Error(`Unknown opener with id: ${f}`);const u=A.URI.revive(E);return y.canOpenExternalUri(u,T)}async $openUri(f,E,T){const y=this.c.get(f);if(!y)throw new Error(`Unknown opener id: '${f}'`);return y.openExternalUri(A.URI.revive(E.resolvedUri),{sourceUri:A.URI.revive(E.sourceUri)},T)}}e.$Dmc=M}),define(Ce[241],Re([1,0,4,2,6,14,20]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class p{static{this.a=0}constructor(E){this.c=new M.$Nm,this.d=new Map,this.b=E.getProxy(I.$SM.MainThreadUrls)}registerUriHandler(E,T){const y=E.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=p.a++;return this.c.add(y),this.d.set(u,T),this.b.$registerUriHandler(u,y,E.displayName||E.name),(0,A.$Sc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(E,T){const y=this.d.get(E);if(!y)return Promise.resolve(void 0);try{y.handleUri(N.URI.revive(T))}catch(u){(0,F.$1)(u)}return Promise.resolve(void 0)}async createAppUri(E){return N.URI.revive(await this.b.$createAppUri(E))}}e.$Emc=p}),define(Ce[63],Re([1,0,5,6,12,25,2,188,210,76,4]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=e.$6kc=void 0,e.$7kc=u,e.$9kc=s,e.$0kc=o;class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,l,i,$,a,b,h){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$be,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$be,this._onDidDispose=this.#h.event,this.#e=c,this.#t=l,this.#o=i,this.#n=$,this.#s=a,this.#r=b,this.#l=u(b),this.#d=v(b),this.#i=h}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,E.$_xb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===A.Schemas.https||c.scheme===A.Schemas.http){let l=c.toString();return l.endsWith("/")||(l+="/"),l+" "+E.$$xb}return E.$$xb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),F.$2n(this.#o,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const l=(0,f.$qob)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const l=this.#r.extensionLocation?.scheme===A.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,a,b,h,D,d)=>{const k=M.URI.from({scheme:h||"file",path:decodeURIComponent(D)}),g=(0,E.$_xb)(k,{isRemote:l,authority:i}).toString();return`${a}${g}${d}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,a,b,h,D,d)=>{const k=M.URI.from({scheme:h||"file",path:decodeURIComponent(D)}),g=(0,E.$_xb)(k,{isRemote:l,authority:i}).toString();return`${a}${g}${d}`})}}e.$6kc=y;function u(t){try{const c=(0,p.$Dp)((0,p.$Cp)(t.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function v(t){try{const c=(0,p.$Dp)((0,p.$Cp)(t.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class m extends N.$Uc{constructor(c,l,i,$,a){super(),this.c=l,this.f=i,this.g=$,this.h=a,this.b=new Map,this.a=c.getProxy(T.$SM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,l,i){const $=this.j(c);if($){const{message:a}=(0,f.$rob)(l,i.value);$._onMessageEmitter.fire(a)}}$onMissingCsp(c,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,l,i){const $=new y(c,this.a,r(l),this.c,this.f,i,this.h);this.b.set(c,$);const a=$._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return $}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$8kc=m;function s(t){return{id:t.identifier,location:t.extensionLocation}}function o(t,c,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||n(t,c)}}function r(t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots?.map(c=>M.URI.from(c))}}function n(t,c){return[...(c?.getWorkspaceFolders()||[]).map(l=>l.uri),t.extensionLocation]}}),define(Ce[109],Re([1,0,5,12,15,2,3,16,4]),function(ge,e,I,N,A,F,M,p,f){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=e.$Gmc=void 0;let T=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new I.$be,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=u.getProxy(f.$SM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:m})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",m)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,v){v!==this.d[u]&&(this.d={...this.d,[u]:v},this.c.fire(this.d))}openUri(u,v){let m;if(typeof u=="string"){m=u;try{u=F.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,A.$4e)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,m,v)}async asExternalUri(u,v){if((0,A.$4e)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this.b.$asExternalUri(u,v);return F.URI.from(m)}};e.$Gmc=T,e.$Gmc=T=E=Je([We(0,p.$fP)],T),e.$Hmc=(0,M.$ri)("IExtHostWindow")}),define(Ce[242],Re([1,0,233,27,16]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=void 0;let F=class extends I.$Kmc{constructor(p,f){super(p,f)}f(p,f,E){f.apply(console,E)}};e.$Soc=F,e.$Soc=F=Je([We(0,A.$fP),We(1,N.$vP)],F)}),define(Ce[243],Re([1,0,11,22,24,14,5,6,144,231,34]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$h_b=o,e.$i_b=r;function u(w,C){try{return JSON.stringify(w,C)}catch{return"null"}}const v="$$ref$$",m={[v]:-1};class s{constructor(C,P){this.jsonString=C,this.referencedBuffers=P}}function o(w,C=null,P=!1){const W=[];return{jsonString:(P?u:JSON.stringify)(w,(q,R)=>{if(typeof R>"u")return m;if(typeof R=="object"){if(R instanceof N.$Ce){const j=W.push(R)-1;return{[v]:j}}if(C)return C(q,R)}return R}),referencedBuffers:W}}function r(w,C,P){return JSON.parse(w,(W,V)=>{if(V){const q=V[v];if(typeof q=="number")return C[q];if(P&&V.$mid===1)return P.transformIncoming(V)}return V})}function n(w,C){return JSON.stringify(w,C)}function t(w){return w?(C,P)=>P&&P.$mid===1?w.transformOutgoing(P):P:null}var c;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var l;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const i=()=>{},$=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class b extends p.$Uc{static{y=$}static{this.a=3*1e3}constructor(C,P=null,W=null){super(),this[y]=!0,this.b=this.B(new M.$be),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=P,this.g=W,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=T.$lw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$Dh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const P=this.w[C];delete this.w[C],P.resolveErr(F.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+b.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+b.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,f.$wn)(C,this.g):C}getProxy(C){const{nid:P,sid:W}=C;return this.s[P]||(this.s[P]=this.J(P,W)),this.s[P]}J(C,P){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...R)=>this.U(C,q,R)),q===a?P:V[q])};return new Proxy(Object.create(null),W)}set(C,P){return this.m[C.nid]=P,P}assertRegistered(C){for(let P=0,W=C.length;P<W;P++){const V=C[P];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(C){if(this.j)return;const P=C.byteLength,W=D.read(C,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:R,method:j,args:K}=k.deserializeRequestJSONArgs(W);this.g&&(K=(0,f.$wn)(K,this.g)),this.M(P,q,R,j,K,V===2);break}case 3:case 4:{let{rpcId:R,method:j,args:K}=k.deserializeRequestMixedArgs(W);this.g&&(K=(0,f.$wn)(K,this.g)),this.M(P,q,R,j,K,V===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let R=k.deserializeReplyOKJSON(W);this.g&&(R=(0,f.$wn)(R,this.g)),this.O(P,q,R);break}case 10:{const R=k.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(P,q,R);break}case 8:{const R=k.deserializeReplyOKVSBuffer(W);this.O(P,q,R);break}case 11:{let R=k.deserializeReplyErrError(W);this.g&&(R=(0,f.$wn)(R,this.g)),this.P(P,q,R);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,P,W,V,q,R){this.f?.logIncoming(C,P,1,`receiveRequest ${(0,T.$nw)(W)}.${V}(`,q);const j=String(P);let K,re;if(R){const ve=new A.$me;q.push(ve.token),K=this.Q(W,V,q),re=()=>ve.cancel()}else K=this.Q(W,V,q),re=i;this.u[j]=re;const ae=k.serializeAcknowledged(P);this.f?.logOutgoing(ae.byteLength,P,1,"ack"),this.c.send(ae),K.then(ve=>{delete this.u[j];const Ie=k.serializeReplyOK(P,ve,this.h);this.f?.logOutgoing(Ie.byteLength,P,1,"reply:",ve),this.c.send(Ie)},ve=>{delete this.u[j];const Ie=k.serializeReplyErr(P,ve);this.f?.logOutgoing(Ie.byteLength,P,1,"replyErr:",ve),this.c.send(Ie)})}N(C,P){this.f?.logIncoming(C,P,1,"receiveCancel");const W=String(P);this.u[W]?.()}O(C,P,W){this.f?.logIncoming(C,P,0,"receiveReply:",W);const V=String(P);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(C,P,W){this.f?.logIncoming(C,P,0,"receiveReplyErr:",W);const V=String(P);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let R;W&&(W.$isError?(R=new Error,R.name=W.name,R.message=W.message,R.stack=W.stack):R=W),q.resolveErr(R)}Q(C,P,W){try{return Promise.resolve(this.S(C,P,W))}catch(V){return Promise.reject(V)}}S(C,P,W){const V=this.m[C];if(!V)throw new Error("Unknown actor "+(0,T.$nw)(C));const q=V[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,T.$nw)(C));return q.apply(V,W)}U(C,P,W){if(this.j)return new E.$g_b;let V=null;if(W.length>0&&A.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(F.$6());const q=k.serializeRequestArguments(W,this.h),R=++this.t,j=String(R),K=new E.$f_b,re=new p.$Tc;V&&re.add(V.onCancellationRequested(()=>{const ve=k.serializeCancel(R);this.f?.logOutgoing(ve.byteLength,R,0,"cancel"),this.c.send(k.serializeCancel(R))})),this.w[j]=new h(K,re),this.F(R);const ae=k.serializeRequest(R,C,P,q,!!V);return this.f?.logOutgoing(ae.byteLength,R,0,`request: ${(0,T.$nw)(C)}.${P}(`,W),this.c.send(ae),K}}e.$j_b=b;class h{constructor(C,P){this.a=C,this.b=P}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class D{static alloc(C,P,W){const V=new D(N.$Ce.alloc(W+1+4),0);return V.writeUInt8(C),V.writeUInt32(P),V}static read(C,P){return new D(C,P)}get buffer(){return this.a}constructor(C,P){this.a=C,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+C);return this.b+=C,P}static sizeMixedArray(C){let P=0;P+=1;for(let W=0,V=C.length;W<V;W++){const q=C[W];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let R=0;R<q.buffers.length;++R)P+=this.sizeVSBuffer(q.buffers[R]);break;case 4:break}}return P}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let P=0,W=C.length;P<W;P++){const V=C[P];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const P=new Array(C);for(let W=0;W<C;W++)switch(this.readUInt8()){case 1:P[W]=this.readLongString();break;case 2:P[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),R=this.readLongString(),j=[];for(let K=0;K<q;++K)j.push(this.readVSBuffer());P[W]=new T.$ow(r(R,j,null));break}case 4:P[W]=void 0;break}return P}}var d;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(d||(d={}));class k{static a(C){for(let P=0,W=C.length;P<W;P++)if(C[P]instanceof N.$Ce||C[P]instanceof T.$ow||typeof C[P]>"u")return!0;return!1}static serializeRequestArguments(C,P){if(this.a(C)){const W=[];for(let V=0,q=C.length;V<q;V++){const R=C[V];if(R instanceof N.$Ce)W[V]={type:2,value:R};else if(typeof R>"u")W[V]={type:4};else if(R instanceof T.$ow){const{jsonString:j,referencedBuffers:K}=o(R.value,P);W[V]={type:3,value:N.$Ce.fromString(j),buffers:K}}else W[V]={type:1,value:N.$Ce.fromString(n(R,P))}}return{type:1,args:W}}return{type:0,args:n(C,P)}}static serializeRequest(C,P,W,V,q){switch(V.type){case 0:return this.b(C,P,W,V.args,q);case 1:return this.c(C,P,W,V.args,q)}}static b(C,P,W,V,q){const R=N.$Ce.fromString(W),j=N.$Ce.fromString(V);let K=0;K+=D.sizeUInt8(),K+=D.sizeShortString(R),K+=D.sizeLongString(j);const re=D.alloc(q?2:1,C,K);return re.writeUInt8(P),re.writeShortString(R),re.writeLongString(j),re.buffer}static deserializeRequestJSONArgs(C){const P=C.readUInt8(),W=C.readShortString(),V=C.readLongString();return{rpcId:P,method:W,args:JSON.parse(V)}}static c(C,P,W,V,q){const R=N.$Ce.fromString(W);let j=0;j+=D.sizeUInt8(),j+=D.sizeShortString(R),j+=D.sizeMixedArray(V);const K=D.alloc(q?4:3,C,j);return K.writeUInt8(P),K.writeShortString(R),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(C){const P=C.readUInt8(),W=C.readShortString(),V=C.readMixedArray(),q=new Array(V.length);for(let R=0,j=V.length;R<j;R++){const K=V[R];typeof K=="string"?q[R]=JSON.parse(K):q[R]=K}return{rpcId:P,method:W,args:q}}static serializeAcknowledged(C){return D.alloc(5,C,0).buffer}static serializeCancel(C){return D.alloc(6,C,0).buffer}static serializeReplyOK(C,P,W){if(typeof P>"u")return this.d(C);if(P instanceof N.$Ce)return this.e(C,P);if(P instanceof T.$ow){const{jsonString:V,referencedBuffers:q}=o(P.value,W,!0);return this.g(C,V,q)}else return this.f(C,u(P,W))}static d(C){return D.alloc(7,C,0).buffer}static e(C,P){let W=0;W+=D.sizeVSBuffer(P);const V=D.alloc(8,C,W);return V.writeVSBuffer(P),V.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,P){const W=N.$Ce.fromString(P);let V=0;V+=D.sizeLongString(W);const q=D.alloc(9,C,V);return q.writeLongString(W),q.buffer}static g(C,P,W){const V=N.$Ce.fromString(P);let q=0;q+=D.sizeUInt32,q+=D.sizeLongString(V);for(const j of W)q+=D.sizeVSBuffer(j);const R=D.alloc(10,C,q);R.writeUInt32(W.length),R.writeLongString(V);for(const j of W)R.writeBuffer(j);return R.buffer}static deserializeReplyOKJSON(C){const P=C.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(C,P){const W=C.readUInt32(),V=C.readLongString(),q=[];for(let R=0;R<W;++R)q.push(C.readVSBuffer());return new T.$ow(r(V,q,P))}static serializeReplyErr(C,P){const W=P?u(F.$3(P),null):void 0;if(typeof W!="string")return this.h(C);const V=N.$Ce.fromString(W);let q=0;q+=D.sizeLongString(V);const R=D.alloc(11,C,q);return R.writeLongString(V),R.buffer}static deserializeReplyErrError(C){const P=C.readLongString();return JSON.parse(P)}static h(C){return D.alloc(12,C,0).buffer}}var g;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var S;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(S||(S={}))}),define(Ce[244],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uoc=void 0;const I=function(F){const M=p=>{globalThis.removeEventListener("message",M);const f=p.data;Object.defineProperties(globalThis,{postMessage:{value(E,T){f.postMessage(E,T)}},onmessage:{get(){return f.onmessage},set(E){f.onmessage=E}}}),f.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",M)}.toString();class N extends EventTarget{constructor(F,M,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${I})('${M}'))`,E=new Blob([f],{type:"application/javascript"}),T=URL.createObjectURL(E),y=new MessageChannel,u=T,v={type:"_newWorker",id:u,port:y.port2,url:T,options:p};F(v,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{F({type:"_terminateWorker",id:u}),URL.revokeObjectURL(T),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(m){y.port1.onmessage=m}},onmessageerror:{get(){return y.port1.onmessageerror},set(m){y.port1.onmessageerror=m}}}),y.port1.addEventListener("messageerror",m=>{const s=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(s)}),y.port1.addEventListener("message",m=>{const s=new MessageEvent("message",{data:m.data});this.dispatchEvent(s)}),y.port1.start()}}e.$Uoc=N}),define(Ce[245],Re([1,0,22,28,12,55,3]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xK=e.$uK=void 0,e.$vK=T,e.$wK=y,e.$uK=(0,M.$ri)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${p.join("")}]+`),E=7;function T(v){if(v.scheme!==A.Schemas.vscodeNotebookCell)return;const m=v.fragment.indexOf("s");if(m<0)return;const s=parseInt(v.fragment.substring(0,m).replace(f,""),E),o=(0,I.$Ve)(v.fragment.substring(m+1)).toString();if(!isNaN(s))return{handle:s,notebook:v.with({scheme:o,fragment:null})}}function y(v,m){const s=m.toString(E),r=`${s.length<p.length?p[s.length-1]:"z"}${s}s${(0,I.$We)(I.$Ce.fromString(v.scheme),!0,!0)}`;return v.with({scheme:A.Schemas.vscodeNotebookCell,fragment:r})}class u{constructor(){this.a=new N.$Bc}getNotebook(m){if(m.scheme===A.Schemas.vscodeNotebookCell){const s=T(m);if(s){const o=this.a.get(s.notebook);if(o)return o}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$xK=u,(0,F.$rs)(e.$uK,u,1)}),define(Ce[83],Re([1,0,22,36,40,69,12,19,21,31,245]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.$OK=e.CellStatusbarAlignment=e.$NK=e.NotebookEditorPriority=e.$KK=e.$JK=e.$HK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$GK=e.$FK=e.$EK=e.$DK=e.CellKind=e.$CK=e.$BK=e.$AK=void 0,e.$IK=$,e.$LK=b,e.$MK=h,e.$PK=k,e.$QK=S,e.$AK="workbench.editor.notebook",e.$BK="workbench.editor.notebookTextDiffEditor",e.$CK="workbench.editor.interactive";var y;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(y||(e.CellKind=y={})),e.$DK=["application/json","application/javascript","text/html","image/svg+xml",F.$Ks.latex,F.$Ks.markdown,"image/png","image/jpeg",F.$Ks.text],e.$EK=[F.$Ks.latex,F.$Ks.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$Ks.text],e.$FK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$GK="_notAvailable";var u;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var v;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var m;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var s;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var r;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var n;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var t;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(t||(e.CellEditType=t={}));var c;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function re(Me,ce){return(0,T.$wK)(Me,ce)}K.generate=re;function ae(Me){return(0,T.$vK)(Me)}K.parse=ae;function ve(Me,ce){return Me.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${ce??""},${Me.scheme!==M.Schemas.file?Me.scheme:""}`})}K.generateCellOutputUri=ve;function Ie(Me){if(Me.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Me.fragment);if(!ce)return;const Ae=ce[1]&&ce[1]!==""?ce[1]:void 0,ie=ce[2];return{outputId:Ae,notebook:Me.with({scheme:ie||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=Ie;function de(Me,ce,Ae){return K.generate(Me,ce).with({scheme:Ae})}K.generateCellPropertyUri=de;function me(Me,ce){if(Me.scheme===ce)return K.parse(Me.with({scheme:K.scheme}))}K.parseCellPropertyUri=me})(c||(e.CellUri=c={}));const l=K=>f.$i?K.replace(/\//g,"\\"):K;class i{constructor(re=[],ae=e.$DK){this.e=ae,this.d=[...new Set(re)].map(ve=>({pattern:ve,matches:N.$lk(l(ve))}))}sort(re){const ae=new Map(A.Iterable.map(re,Ie=>[Ie,l(Ie)]));let ve=[];for(const{matches:Ie}of this.d)for(const[de,me]of ae)if(Ie(me)){ve.push(de),ae.delete(de);break}return ae.size&&(ve=ve.concat([...ae.keys()].sort((Ie,de)=>this.e.indexOf(Ie)-this.e.indexOf(de)))),ve}prioritize(re,ae){const ve=this.f(re);if(ve===-1){this.d.unshift({pattern:re,matches:N.$lk(l(re))});return}const Ie=new Set(ae.map(me=>this.f(me,ve)));Ie.delete(-1);const de=Array.from(Ie).sort();this.d.splice(ve+1,0,...de.map(me=>this.d[me]));for(let me=de.length-1;me>=0;me--)this.d.splice(de[me],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,ae=this.d.length){const ve=l(re);for(let Ie=0;Ie<ae;Ie++)if(this.d[Ie].matches(ve))return Ie;return-1}}e.$HK=i;function $(K,re,ae,ve=(Ie,de)=>Ie===de){const Ie=[];function de(ce,Ae,ie){if(Ae===0&&ie.length===0)return;const L=Ie[Ie.length-1];L&&L.start+L.deleteCount===ce?(L.deleteCount+=Ae,L.toInsert.push(...ie)):Ie.push({start:ce,deleteCount:Ae,toInsert:ie})}let me=0,Me=0;for(;;){if(me===K.length){de(me,0,re.slice(Me));break}if(Me===re.length){de(me,K.length-me,[]);break}const ce=K[me],Ae=re[Me];if(ve(ce,Ae)){me+=1,Me+=1;continue}ae(Ae)?(de(me,1,[]),me+=1):(de(me,0,[Ae]),Me+=1)}return Ie}e.$JK=new E.$Ij("notebookEditorCursorAtBoundary","none"),e.$KK=new E.$Ij("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function b(K){const re=K;return!!((typeof re.include=="string"||N.$mk(re.include))&&(typeof re.exclude=="string"||N.$mk(re.exclude)))}function h(K,re,ae){if(Array.isArray(K.viewType)&&K.viewType.indexOf(re)>=0||K.viewType===re)return!0;if(K.filenamePattern){const ve=b(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Ie=b(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(N.$kk(ve,(0,p.$oc)(ae.fsPath).toLowerCase()))return!(Ie&&N.$kk(Ie,(0,p.$oc)(ae.fsPath).toLowerCase()))}return!1}e.$NK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var D;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class d{static{this.d="notebook/"}static create(re){return`${d.d}${re}`}static parse(re){if(re.startsWith(d.d))return re.substring(d.d.length)}}e.$OK=d;function k(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const g=new TextDecoder;function S(K){const re=[];let ae=!1;for(const me of K)(re.length===0||ae)&&(re.push(me),ae=!0);let ve=P(re);const Ie=I.$Ce.concat(re.map(me=>I.$Ce.wrap(me))),de=j(Ie);return ve=ve||de.byteLength!==Ie.byteLength,{data:de,didCompression:ve}}e.$RK="\x1B[A";const w=e.$RK.split("").map(K=>K.charCodeAt(0)),C=10;function P(K){let re=!1;return K.forEach((ae,ve)=>{if(ve===0||ae.length<e.$RK.length)return;const Ie=K[ve-1],de=ae.subarray(0,e.$RK.length);if(de[0]===w[0]&&de[1]===w[1]&&de[2]===w[2]){const me=Ie.lastIndexOf(C);if(me===-1)return;re=!0,K[ve-1]=Ie.subarray(0,me),K[ve]=ae.subarray(e.$RK.length)}}),re}function W(K){let re=K;do K=re,re=K.replace(/[^\n]\x08/gm,"");while(re.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const re=K.match(/^(.*)\r+/m)[1];let ae=K.match(/\r+(.*)$/m)[1];ae=ae+re.slice(ae.length,re.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return K}const q=8,R=13;function j(K){return!K.buffer.includes(q)&&!K.buffer.includes(R)?K:I.$Ce.fromString(V(W(g.decode(K.buffer))))}}),define(Ce[7],Re([1,0,18,14,54,28,69,15,17,2,35,20,44,102,83]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m){"use strict";var s,o,r,n,t,c,l,i,$,a,b,h,D,d,k,g,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$6O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$5O=e.$4O=e.$3O=e.$2O=e.ChatLocation=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$PO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$CO=e.$BO=e.$AO=e.$zO=e.$xO=e.$wO=e.$vO=e.$uO=e.TestRunProfileKind=e.TestResultState=e.$tO=e.$sO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$rO=e.NotebookVariablesRequestKind=e.$qO=e.$pO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$oO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.ColorThemeKind=e.$iO=e.$hO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$gO=e.$fO=e.DebugConsoleMode=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$_N=e.$$N=e.FileChangeType=e.$0N=e.NewSymbolNameTag=e.$9N=e.$8N=e.$7N=e.$6N=e.InlineCompletionTriggerKind=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$SN=e.ConfigurationTarget=e.$RN=e.$QN=e.$PN=e.$ON=e.DocumentPasteTriggerKind=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$HN=e.ViewBadge=e.ProgressLocation=e.$GN=e.$FN=e.TaskScope=e.ShellQuoting=e.$EN=e.$DN=e.$CN=e.TaskPanelKind=e.TaskRevealKind=e.$BN=e.TerminalLocation=e.$AN=e.$zN=e.$yN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$xN=e.$wN=e.$vN=e.$uN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$sN=e.$rN=e.$qN=e.$pN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$oN=e.$nN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.LanguageStatusSeverity=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.CodeActionTriggerKind=e.$bN=e.$aN=e.SymbolTag=e.SymbolKind=e.$_M=e.$$M=e.DocumentHighlightKind=e.$0M=e.$9M=e.$8M=e.$7M=e.DiagnosticSeverity=e.DiagnosticTag=e.$6M=e.$5M=e.FileEditType=e.$4M=e.$3M=e.$2M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$tN=dt,e.$TN=J,e.$yO=Mt;function w(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const De=te.length===1?[]:te[1];return Reflect.construct(B,De,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[De,...Ke]=te;return Reflect.construct(B,Ke,De.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var P;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let W=s=class{static from(...O){let te=O;return new s(function(){if(te){for(const De of te)De&&typeof De.dispose=="function"&&De.dispose();te=void 0}})}#e;constructor(O){this.#e=O}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$UM=W,e.$UM=W=s=Je([w],W);let V=o=class{static Min(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let De=1;De<O.length;De++){const Ke=O[De];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let De=1;De<O.length;De++){const Ke=O[De];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(O){if(!O)return!1;if(O instanceof o)return!0;const{line:te,character:De}=O;return typeof te=="number"&&typeof De=="number"}static of(O){if(O instanceof o)return O;if(this.isPosition(O))return new o(O.line,O.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(O,te){if(O<0)throw(0,N.$7)("line must be non-negative");if(te<0)throw(0,N.$7)("character must be non-negative");this.c=O,this.e=te}isBefore(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<O.e}isBeforeOrEqual(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<=O.e}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this.c===O.c&&this.e===O.e}compareTo(O){return this.c<O.c?-1:this.c>O.line?1:this.e<O.e?-1:this.e>O.e?1:0}translate(O,te=0){if(O===null||te===null)throw(0,N.$7)();let De;return typeof O>"u"?De=0:typeof O=="number"?De=O:(De=typeof O.lineDelta=="number"?O.lineDelta:0,te=typeof O.characterDelta=="number"?O.characterDelta:0),De===0&&te===0?this:new o(this.line+De,this.character+te)}with(O,te=this.character){if(O===null||te===null)throw(0,N.$7)();let De;return typeof O>"u"?De=this.line:typeof O=="number"?De=O:(De=typeof O.line=="number"?O.line:this.line,te=typeof O.character=="number"?O.character:this.character),De===this.line&&te===this.character?this:new o(De,te)}toJSON(){return{line:this.line,character:this.character}}};e.$VM=V,e.$VM=V=o=Je([w],V);let q=r=class{static isRange(O){return O instanceof r?!0:O?V.isPosition(O.start)&&V.isPosition(O.end):!1}static of(O){if(O instanceof r)return O;if(this.isRange(O))return new r(O.start,O.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(O,te,De,Ke){let Ze,ht;if(typeof O=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"?(Ze=new V(O,te),ht=new V(De,Ke)):V.isPosition(O)&&V.isPosition(te)&&(Ze=V.of(O),ht=V.of(te)),!Ze||!ht)throw new Error("Invalid arguments");Ze.isBefore(ht)?(this.c=Ze,this.e=ht):(this.c=ht,this.e=Ze)}contains(O){return r.isRange(O)?this.contains(O.start)&&this.contains(O.end):V.isPosition(O)?!(V.of(O).isBefore(this.c)||this.e.isBefore(O)):!1}isEqual(O){return this.c.isEqual(O.c)&&this.e.isEqual(O.e)}intersection(O){const te=V.Max(O.start,this.c),De=V.Min(O.end,this.e);if(!te.isAfter(De))return new r(te,De)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const te=V.Min(O.start,this.c),De=V.Max(O.end,this.end);return new r(te,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(O,te=this.end){if(O===null||te===null)throw(0,N.$7)();let De;return O?V.isPosition(O)?De=O:(De=O.start||this.start,te=O.end||this.end):De=this.start,De.isEqual(this.c)&&te.isEqual(this.end)?this:new r(De,te)}toJSON(){return[this.start,this.end]}};e.$WM=q,e.$WM=q=r=Je([w],q);let R=n=class extends q{static isSelection(O){return O instanceof n?!0:O?q.isRange(O)&&V.isPosition(O.anchor)&&V.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(O,te,De,Ke){let Ze,ht;if(typeof O=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"?(Ze=new V(O,te),ht=new V(De,Ke)):V.isPosition(O)&&V.isPosition(te)&&(Ze=V.of(O),ht=V.of(te)),!Ze||!ht)throw new Error("Invalid arguments");super(Ze,ht),this.f=Ze,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$XM=R,e.$XM=R=n=Je([w],R);const j=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,N.$7)("connectionToken")};class K{static isResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.host=="string"&&typeof O.port=="number"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,te,De){if(typeof O!="string"||O.length===0)throw(0,N.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,N.$7)("port");typeof De<"u"&&j(De),this.host=O,this.port=Math.round(te),this.connectionToken=De}}e.$YM=K;class re{static isManagedResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.makeConnection=="function"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,te){this.makeConnection=O,this.connectionToken=te,typeof te<"u"&&j(te)}}e.$ZM=re;class ae extends Error{static NotAvailable(O,te){return new ae(O,v.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(O){return new ae(O,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(O,te=v.RemoteAuthorityResolverErrorCode.Unknown,De){super(O),this._message=O,this._code=te,this._detail=De,Object.setPrototypeOf(this,ae.prototype)}}e.$1M=ae;var ve;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ve||(e.EndOfLine=ve={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let de=t=class{static isTextEdit(O){return O instanceof t?!0:O?q.isRange(O)&&typeof O.newText=="string":!1}static replace(O,te){return new t(O,te)}static insert(O,te){return t.replace(new q(O,O),te)}static delete(O){return t.replace(O,"")}static setEndOfLine(O){const te=new t(new q(new V(0,0),new V(0,0)),"");return te.newEol=O,te}get range(){return this.c}set range(O){if(O&&!q.isRange(O))throw(0,N.$7)("range");this.c=O}get newText(){return this.e||""}set newText(O){if(O&&typeof O!="string")throw(0,N.$7)("newText");this.e=O}get newEol(){return this.f}set newEol(O){if(O&&typeof O!="number")throw(0,N.$7)("newEol");this.f=O}constructor(O,te){this.c=O,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$2M=de,e.$2M=de=t=Je([w],de);let me=c=class{static isNotebookCellEdit(O){return O instanceof c?!0:O?xe.isNotebookRange(O)&&Array.isArray(O.newCells):!1}static replaceCells(O,te){return new c(O,te)}static insertCells(O,te){return new c(new xe(O,O),te)}static deleteCells(O){return new c(O,[])}static updateCellMetadata(O,te){const De=new c(new xe(O,O),[]);return De.newCellMetadata=te,De}static updateNotebookMetadata(O){const te=new c(new xe(0,0),[]);return te.newNotebookMetadata=O,te}constructor(O,te){this.range=O,this.newCells=te}};e.$3M=me,e.$3M=me=c=Je([w],me);class Me{static isSnippetTextEdit(O){return O instanceof Me?!0:O?q.isRange(O.range)&&ie.isSnippetString(O.snippet):!1}static replace(O,te){return new Me(O,te)}static insert(O,te){return Me.replace(new q(O,O),te)}constructor(O,te){this.range=O,this.snippet=te}}e.$4M=Me;var ce;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ce||(e.FileEditType=ce={}));let Ae=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(O,te,De,Ke){this.c.push({_type:1,from:O,to:te,options:De,metadata:Ke})}createFile(O,te,De){this.c.push({_type:1,from:void 0,to:O,options:te,metadata:De})}deleteFile(O,te,De){this.c.push({_type:1,from:O,to:void 0,options:te,metadata:De})}e(O,te,De){this.c.push({_type:3,metadata:De,uri:O,edit:{editType:5,metadata:te},notebookMetadata:te})}f(O,te,De,Ke){const Ze=te.start,ht=te.end;(Ze!==ht||De.length>0)&&this.c.push({_type:5,uri:O,index:Ze,count:ht-Ze,cells:De,metadata:Ke})}g(O,te,De,Ke){this.c.push({_type:3,metadata:Ke,uri:O,edit:{editType:3,index:te,metadata:De}})}replace(O,te,De,Ke){this.c.push({_type:2,uri:O,edit:new de(te,De),metadata:Ke})}insert(O,te,De,Ke){this.replace(O,new q(te,te),De,Ke)}delete(O,te,De){this.replace(O,te,"",De)}has(O){return this.c.some(te=>te._type===2&&te.uri.toString()===O.toString())}set(O,te){if(te)for(const De of te){if(!De)continue;let Ke,Ze;Array.isArray(De)?(Ke=De[0],Ze=De[1]):Ke=De,me.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(O,Ke.range.start,Ke.newCellMetadata,Ze):Ke.newNotebookMetadata?this.e(O,Ke.newNotebookMetadata,Ze):this.f(O,Ke.range,Ke.newCells,Ze):Me.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:O,range:Ke.range,edit:Ke.snippet,metadata:Ze}):this.c.push({_type:2,uri:O,edit:Ke,metadata:Ze})}else{for(let De=0;De<this.c.length;De++){const Ke=this.c[De];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===O.toString()&&(this.c[De]=void 0);break}}(0,I.$Ib)(this.c)}}get(O){const te=[];for(const De of this.c)De._type===2&&De.uri.toString()===O.toString()&&te.push(De.edit);return te}entries(){const O=new F.$Bc;for(const te of this.c)if(te._type===2){let De=O.get(te.uri);De||(De=[te.uri,[]],O.set(te.uri,De)),De[1].push(te.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$5M=Ae,e.$5M=Ae=Je([w],Ae);let ie=l=class{static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static c(O){return O.replace(/\$|}|\\/g,"\\$&")}constructor(O){this.e=1,this.value=O||""}appendText(O){return this.value+=l.c(O),this}appendTabstop(O=this.e++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,te=this.e++){if(typeof O=="function"){const De=new l;De.e=this.e,O(De),this.e=De.e,O=De.value}else O=l.c(O);return this.value+="${",this.value+=te,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,te=this.e++){const De=O.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(O,te){if(typeof te=="function"){const De=new l;De.e=this.e,te(De),this.e=De.e,te=De.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$6M=ie,e.$6M=ie=l=Je([w],ie);var L;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(L||(e.DiagnosticTag=L={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let be=i=class{static isLocation(O){return O instanceof i?!0:O?q.isRange(O.range)&&E.URI.isUri(O.uri):!1}constructor(O,te){if(this.uri=O,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$7M=be,e.$7M=be=i=Je([w],be);let Oe=class{static is(O){return O?typeof O.message=="string"&&O.location&&q.isRange(O.location.range)&&E.URI.isUri(O.location.uri):!1}constructor(O,te){this.location=O,this.message=te}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.location.range.isEqual(te.location.range)&&O.location.uri.toString()===te.location.uri.toString()}};e.$8M=Oe,e.$8M=Oe=Je([w],Oe);let Ee=class{constructor(O,te,De=x.Error){if(!q.isRange(O))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=O,this.message=te,this.severity=De}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.severity===te.severity&&O.code===te.code&&O.severity===te.severity&&O.source===te.source&&O.range.isEqual(te.range)&&(0,I.$ub)(O.tags,te.tags)&&(0,I.$ub)(O.relatedInformation,te.relatedInformation,Oe.isEqual)}};e.$9M=Ee,e.$9M=Ee=Je([w],Ee);let pe=class{constructor(O,te){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=te}};e.$0M=pe,e.$0M=pe=Je([w],pe);var fe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(fe||(e.DocumentHighlightKind=fe={}));let X=class{constructor(O,te=fe.Text){this.range=O,this.kind=te}toJSON(){return{range:this.range,kind:fe[this.kind]}}};e.$$M=X,e.$$M=X=Je([w],X);let Z=class{constructor(O,te){this.uri=O,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(O=>O.toJSON())}}};e.$_M=Z,e.$_M=Z=Je([w],Z);var le;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var ue;(function(B){B[B.Deprecated=1]="Deprecated"})(ue||(e.SymbolTag=ue={}));let Te=$=class{static validate(O){if(!O.name)throw new Error("name must not be falsy")}constructor(O,te,De,Ke,Ze){this.name=O,this.kind=te,this.containerName=Ze,typeof De=="string"&&(this.containerName=De),Ke instanceof be?this.location=Ke:De instanceof q&&(this.location=new be(Ke,De)),$.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$aN=Te,e.$aN=Te=$=Je([w],Te);let he=a=class{static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children?.forEach(a.validate)}constructor(O,te,De,Ke,Ze){this.name=O,this.detail=te,this.kind=De,this.range=Ke,this.selectionRange=Ze,this.children=[],a.validate(this)}};e.$bN=he,e.$bN=he=a=Je([w],he);var Pe;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Pe||(e.CodeActionTriggerKind=Pe={}));let Ne=class{constructor(O,te){this.title=O,this.kind=te}};e.$cN=Ne,e.$cN=Ne=Je([w],Ne);let ze=class{static{b=this}static{this.c="."}constructor(O){this.value=O}append(O){return new b(this.value?this.value+b.c+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+b.c)}};e.$dN=ze,e.$dN=ze=b=Je([w],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let U=class{constructor(O,te){if(this.range=O,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$eN=U,e.$eN=U=Je([w],U);class z{constructor(O,te,De,Ke,Ze,ht){this.kind=O,this.name=te,this.detail=De,this.uri=Ke,this.range=Ze,this.selectionRange=ht}}e.$fN=z;class G{constructor(O,te){this.fromRanges=te,this.from=O}}e.$gN=G;class H{constructor(O,te){this.fromRanges=te,this.to=O}}e.$hN=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let ne=class{constructor(O,te){this.range=O,this.command=te}get isResolved(){return!!this.command}};e.$iN=ne,e.$iN=ne=Je([w],ne);let Fe=h=class{#e;static isMarkdownString(O){return O instanceof h?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}constructor(O,te=!1){this.#e=new A.$Ok(O,{supportThemeIcons:te})}get value(){return this.#e.value}set value(O){this.#e.value=O}get isTrusted(){return this.#e.isTrusted}set isTrusted(O){this.#e.isTrusted=O}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(O){this.#e.supportThemeIcons=O}get supportHtml(){return this.#e.supportHtml}set supportHtml(O){this.#e.supportHtml=O}get baseUri(){return this.#e.baseUri}set baseUri(O){this.#e.baseUri=O}appendText(O){return this.#e.appendText(O),this}appendMarkdown(O){return this.#e.appendMarkdown(O),this}appendCodeblock(O,te){return this.#e.appendCodeblock(te??"",O),this}};e.$jN=Fe,e.$jN=Fe=h=Je([w],Fe);let Be=class{constructor(O,te){this.label=O,this.documentation=te}};e.$kN=Be,e.$kN=Be=Je([w],Be);let Xe=class{constructor(O,te){this.label=O,this.documentation=te,this.parameters=[]}};e.$lN=Xe,e.$lN=Xe=Je([w],Xe);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$mN=_e,e.$mN=_e=Je([w],_e);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let it=class{constructor(O){this.value=O}};e.$nN=it,e.$nN=it=Je([w],it);let nt=class{constructor(O,te,De){this.position=O,this.label=te,this.kind=De}};e.$oN=nt,e.$oN=nt=Je([w],nt);var at;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var mt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(mt||(e.CompletionItemKind=mt={}));var je;(function(B){B[B.Deprecated=1]="Deprecated"})(je||(e.CompletionItemTag=je={}));let st=class{constructor(O,te){this.label=O,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&mt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$pN=st,e.$pN=st=Je([w],st);let Y=class{constructor(O=[],te=!1){this.items=O,this.isIncomplete=te}};e.$qN=Y,e.$qN=Y=Je([w],Y);let Q=class{constructor(O,te,De){this.insertText=O,this.range=te,this.command=De}};e.$rN=Q,e.$rN=Q=Je([w],Q);let $e=class{constructor(O){this.commands=void 0,this.suppressSuggestions=void 0,this.items=O}};e.$sN=$e,e.$sN=$e=Je([w],$e);var He;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(He||(e.PartialAcceptTriggerKind=He={}));var ye;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ye||(e.ViewColumn=ye={}));var ot;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function dt(B,O){return`${y.$Mm.toKey(B)}.${O}`}var It;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(It||(e.TextEditorLineNumbersStyle=It={}));var Xt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Xt||(e.TextDocumentSaveReason=Xt={}));var Ut;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ut||(e.TextEditorRevealType=Ut={}));var xt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(xt||(e.TextEditorSelectionChangeKind=xt={}));var _t;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Pt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Pt||(e.DecorationRangeBehavior=Pt={})),function(B){function O(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(xt||(e.TextEditorSelectionChangeKind=xt={}));var Wt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(B){function O(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=O}(Wt||(e.SyntaxTokenType=Wt={}));let Qt=class{constructor(O,te){if(te&&!E.URI.isUri(te))throw(0,N.$7)("target");if(!q.isRange(O)||O.isEmpty)throw(0,N.$7)("range");this.range=O,this.target=te}};e.$uN=Qt,e.$uN=Qt=Je([w],Qt);let Ye=class{constructor(O,te,De,Ke){this.red=O,this.green=te,this.blue=De,this.alpha=Ke}};e.$vN=Ye,e.$vN=Ye=Je([w],Ye);let si=class{constructor(O,te){if(te&&!(te instanceof Ye))throw(0,N.$7)("color");if(!q.isRange(O)||O.isEmpty)throw(0,N.$7)("range");this.range=O,this.color=te}};e.$wN=si,e.$wN=si=Je([w],si);let Yt=class{constructor(O){if(!O||typeof O!="string")throw(0,N.$7)("label");this.label=O}};e.$xN=Yt,e.$xN=Yt=Je([w],Yt);var lt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(lt||(e.ColorFormat=lt={}));var vt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(vt||(e.SourceControlInputBoxValidationType=vt={}));var ti;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));var Zt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(Zt||(e.TerminalShellExecutionCommandLineConfidence=Zt={}));class Lt{constructor(O,te,De){if(this.startIndex=O,this.length=te,this.tooltip=De,typeof O!="number"||O<0)throw(0,N.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,N.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,N.$7)("tooltip")}}e.$yN=Lt;class ft{constructor(O){this.uri=O}}e.$zN=ft;class jt{constructor(O){this.terminalCommand=O}}e.$AN=jt;var Bt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Bt||(e.TerminalLocation=Bt={}));class qt{constructor(O){if(this.options=O,typeof O!="object")throw(0,N.$7)("options")}}e.$BN=qt;var Ge;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ge||(e.TaskRevealKind=Ge={}));var ui;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Ht=class{static{D=this}static{this.Clean=new D("clean","Clean")}static{this.Build=new D("build","Build")}static{this.Rebuild=new D("rebuild","Rebuild")}static{this.Test=new D("test","Test")}static from(O){switch(O){case"clean":return D.Clean;case"build":return D.Build;case"rebuild":return D.Rebuild;case"test":return D.Test;default:return}}constructor(O,te){if(this.label=te,typeof O!="string"||typeof te!="string")throw(0,N.$7)("name");this.c=O}get id(){return this.c}};e.$CN=Ht,e.$CN=Ht=D=Je([w],Ht);function zt(B){let O="";for(let te=0;te<B.length;te++)O+=B[te].replace(/,/g,",,")+",";return O}let gt=class{constructor(O,te,De){if(typeof O!="string")throw(0,N.$7)("process");this.e=[],this.c=O,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=De):this.f=te)}get process(){return this.c}set process(O){if(typeof O!="string")throw(0,N.$7)("process");this.c=O}get args(){return this.e}set args(O){Array.isArray(O)||(O=[]),this.e=O}get options(){return this.f}set options(O){this.f=O}computeId(){const O=[];if(O.push("process"),this.c!==void 0&&O.push(this.c),this.e&&this.e.length>0)for(const te of this.e)O.push(te);return zt(O)}};e.$DN=gt,e.$DN=gt=Je([w],gt);let Tt=class{constructor(O,te,De){if(this.f=[],Array.isArray(te)){if(!O)throw(0,N.$7)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,N.$7)("command");this.e=O,this.f=te,this.g=De}else{if(typeof O!="string")throw(0,N.$7)("commandLine");this.c=O,this.g=te}}get commandLine(){return this.c}set commandLine(O){if(typeof O!="string")throw(0,N.$7)("commandLine");this.c=O}get command(){return this.e?this.e:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,N.$7)("command");this.e=O}get args(){return this.f}set args(O){this.f=O||[]}get options(){return this.g}set options(O){this.g=O}computeId(){const O=[];if(O.push("shell"),this.c!==void 0&&O.push(this.c),this.e!==void 0&&O.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)O.push(typeof te=="string"?te:te.value);return zt(O)}};e.$EN=Tt,e.$EN=Tt=Je([w],Tt);var Rt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Rt||(e.ShellQuoting=Rt={}));var Ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Ft||(e.TaskScope=Ft={}));class ii{constructor(O){this.c=O}computeId(){return"customExecution"+(0,T.$Ng)()}set callback(O){this.c=O}get callback(){return this.c}}e.$FN=ii;let Gt=class{static{d=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(O,te,De,Ke,Ze,ht){this.k=!1,this.l=this.definition=O;let $t;typeof te=="string"?(this.o=this.name=te,this.w=this.source=De,this.execution=Ke,$t=Ze,this.k=!0):te===Ft.Global||te===Ft.Workspace?(this.target=te,this.o=this.name=De,this.w=this.source=Ke,this.execution=Ze,$t=ht):(this.target=te,this.o=this.name=De,this.w=this.source=Ke,this.execution=Ze,$t=ht),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(O){this.j=O}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof gt?this.l={type:d.e,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:d.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:d.c,id:this.q.computeId()}:this.l={type:d.g,id:(0,T.$Ng)()}}get definition(){return this.l}set definition(O){if(O==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=O}get scope(){return this.m}set target(O){this.B(),this.m=O}get name(){return this.o}set name(O){if(typeof O!="string")throw(0,N.$7)("name");this.B(),this.o=O}get execution(){return this.q}set execution(O){O===null&&(O=void 0),this.B(),this.q=O;const te=this.l.type;(d.g===te||d.e===te||d.f===te||d.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(O){if(Array.isArray(O))this.B(),this.r=O,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.B(),this.u=O}get source(){return this.w}set source(O){if(typeof O!="string"||O.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=O}get group(){return this.x}set group(O){O===null&&(O=void 0),this.B(),this.x=O}get detail(){return this.A}set detail(O){O===null&&(O=void 0),this.A=O}get presentationOptions(){return this.y}set presentationOptions(O){O==null&&(O=Object.create(null)),this.B(),this.y=O}get runOptions(){return this.z}set runOptions(O){O==null&&(O=Object.create(null)),this.B(),this.z=O}};e.$GN=Gt,e.$GN=Gt=d=Je([w],Gt);var ni;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var Nt;(function(B){function O(te){const De=te;return(0,f.$9f)(De.value)?De.tooltip&&!(0,f.$5f)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=O})(Nt||(e.ViewBadge=Nt={}));let At=k=class{static isTreeItem(O,te){const De=O;if(De.checkboxState!==void 0){const Ke=(0,f.$9f)(De.checkboxState)?De.checkboxState:(0,f.$7f)(De.checkboxState)&&(0,f.$9f)(De.checkboxState.state)?De.checkboxState.state:void 0,Ze=!(0,f.$9f)(De.checkboxState)&&(0,f.$7f)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Dt.Checked&&Ke!==Dt.Unchecked||Ze!==void 0&&!(0,f.$5f)(Ze))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(O instanceof k)return!0;if(De.label!==void 0&&!(0,f.$5f)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,f.$5f)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,f.$5f)(De.iconPath)&&!E.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,f.$5f)(De.iconPath.id))){const Ke=De.iconPath;if(!Ke||!(0,f.$5f)(Ke.light)&&!E.URI.isUri(Ke.light)&&!(0,f.$5f)(Ke.dark)&&!E.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,f.$5f)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!E.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,f.$5f)(De.tooltip)&&!(De.tooltip instanceof Fe)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Ct.None&&De.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,f.$5f)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(O,te=Ct.None){this.collapsibleState=te,E.URI.isUri(O)?this.resourceUri=O:this.label=O}};e.$HN=At,e.$HN=At=k=Je([w],At);var Ct;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Ct||(e.TreeItemCollapsibleState=Ct={}));var Dt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(O){this.value=O}};e.$IN=pt,e.$IN=pt=Je([w],pt);class St extends pt{}e.$JN=St;class li extends St{#e;constructor(O){super(""),this.#e=O}asFile(){return this.#e}}e.$KN=li;class kt{constructor(O,te,De,Ke){this.name=O,this.uri=te,this._itemId=De,this.c=Ke}data(){return this.c()}}e.$LN=kt;let hi=class{#e=new Map;constructor(O){for(const[te,De]of O??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(De):this.#e.set(this.#t(te),[De])}}get(O){return this.#e.get(this.#t(O))?.[0]}set(O,te){this.#e.set(this.#t(O),[te])}forEach(O,te){for(const[De,Ke]of this.#e)for(const Ze of Ke)O.call(te,Ze,De,this)}*[Symbol.iterator](){for(const[O,te]of this.#e)for(const De of te)yield[O,De]}#t(O){return O.toLowerCase()}};e.$MN=hi,e.$MN=hi=Je([w],hi);let Kt=class{constructor(O,te,De){this.insertText=O,this.title=te,this.kind=De}};e.$NN=Kt,e.$NN=Kt=Je([w],Kt);var vi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class ei{static{this.c="."}constructor(O){this.value=O}append(...O){return new ei((this.value?[this.value,...O]:O).join(ei.c))}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+ei.c)}}e.$ON=ei,ei.Empty=new ei("");class wi{constructor(O,te,De){this.title=te,this.insertText=O,this.kind=De}}e.$PN=wi;let yt=class{constructor(O,te){this.id=O,this.color=te}static isThemeIcon(O){return typeof O.id!="string"?(console.log("INVALID ThemeIcon, invalid id",O.id),!1):!0}};e.$QN=yt,e.$QN=yt=Je([w],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let $i=class{constructor(O){this.id=O}};e.$RN=$i,e.$RN=$i=Je([w],$i);var we;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(we||(e.ConfigurationTarget=we={}));let Se=class{get base(){return this.c}set base(O){this.c=O,this.e=E.URI.file(O)}get baseUri(){return this.e}set baseUri(O){this.e=O,this.c=O.fsPath}constructor(O,te){if(typeof O!="string"&&(!O||!E.URI.isUri(O)&&!E.URI.isUri(O.uri)))throw(0,N.$7)("base");if(typeof te!="string")throw(0,N.$7)("pattern");typeof O=="string"?this.baseUri=E.URI.file(O):E.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$SN=Se,e.$SN=Se=Je([w],Se);const oe=new WeakMap;function J(B,O){oe.set(B,O)}let ke=class{constructor(O,te,De,Ke,Ze){this.enabled=typeof O=="boolean"?O:!0,typeof te=="string"&&(this.condition=te),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke),typeof Ze=="string"&&(this.mode=Ze)}get id(){return this.c||(this.c=oe.get(this)??(0,T.$Ng)()),this.c}};e.$UN=ke,e.$UN=ke=Je([w],ke);let Ve=class extends ke{constructor(O,te,De,Ke,Ze,ht){if(super(te,De,Ke,Ze,ht),O===null)throw(0,N.$7)("location");this.location=O}};e.$VN=Ve,e.$VN=Ve=Je([w],Ve);let Qe=class extends ke{constructor(O,te,De,Ke,Ze,ht){super(te,De,Ke,Ze,ht),this.functionName=O}};e.$WN=Qe,e.$WN=Qe=Je([w],Qe);let qe=class extends ke{constructor(O,te,De,Ke,Ze,ht,$t,Jt){if(super(Ke,Ze,ht,$t,Jt),!te)throw(0,N.$7)("dataId");this.label=O,this.dataId=te,this.canPersist=De}};e.$XN=qe,e.$XN=qe=Je([w],qe);let ut=class{constructor(O,te,De){this.command=O,this.args=te||[],this.options=De}};e.$YN=ut,e.$YN=ut=Je([w],ut);let Et=class{constructor(O,te){this.port=O,this.host=te}};e.$ZN=Et,e.$ZN=Et=Je([w],Et);let Ot=class{constructor(O){this.path=O}};e.$1N=Ot,e.$1N=Ot=Je([w],Ot);let Vt=class{constructor(O){this.implementation=O}};e.$2N=Vt,e.$2N=Vt=Je([w],Vt);class ct{constructor(O,te,De){this.session=O,this.threadId=te,this.frameId=De}}e.$3N=ct;class ri{constructor(O,te){this.session=O,this.threadId=te}}e.$4N=ri;let di=class{constructor(O,te){this.range=O,this.expression=te}};e.$5N=di,e.$5N=di=Je([w],di);var pi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(pi||(e.InlineCompletionTriggerKind=pi={}));let Si=class{constructor(O,te){this.range=O,this.text=te}};e.$6N=Si,e.$6N=Si=Je([w],Si);let Ri=class{constructor(O,te,De=!0){this.range=O,this.variableName=te,this.caseSensitiveLookup=De}};e.$7N=Ri,e.$7N=Ri=Je([w],Ri);let Mi=class{constructor(O,te){this.range=O,this.expression=te}};e.$8N=Mi,e.$8N=Mi=Je([w],Mi);let Ni=class{constructor(O,te){this.frameId=O,this.stoppedLocation=te}};e.$9N=Ni,e.$9N=Ni=Je([w],Ni);var Ti;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ti||(e.NewSymbolNameTag=Ti={}));class cn{constructor(O,te){this.newSymbolName=O,this.tags=te}}e.$0N=cn;var Fi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Oi=g=class extends Error{static FileExists(O){return new g(O,u.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(O){return new g(O,u.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(O){return new g(O,u.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(O){return new g(O,u.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(O){return new g(O,u.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(O){return new g(O,u.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(O,te=u.FileSystemProviderErrorCode.Unknown,De){super(E.URI.isUri(O)?O.toString(!0):O),this.code=De?.name??"Unknown",(0,u.$al)(this,te),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$$N=Oi,e.$$N=Oi=g=Je([w],Oi);let yi=class{constructor(O,te,De){this.start=O,this.end=te,this.kind=De}};e.$_N=yi,e.$_N=yi=Je([w],yi);var Ii;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ii||(e.FoldingRangeKind=Ii={}));var Gi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Gi||(e.CommentThreadCollapsibleState=Gi={}));var Ki;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var bi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(bi||(e.CommentState=bi={}));var Ji;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Ji||(e.CommentThreadState=Ji={}));var Xi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Xi||(e.CommentThreadApplicability=Xi={}));class un{constructor(O,te=[]){this.tokenTypes=O,this.tokenModifiers=te}}e.$aO=un;function Li(B){return typeof B>"u"||(0,f.$6f)(B)}class zi{constructor(O){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,O){this.m=!0;for(let te=0,De=O.tokenTypes.length;te<De;te++)this.k.set(O.tokenTypes[te],te);for(let te=0,De=O.tokenModifiers.length;te<De;te++)this.l.set(O.tokenModifiers[te],te)}}push(O,te,De,Ke,Ze){if(typeof O=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.q(O,te,De,Ke,Ze);if(q.isRange(O)&&typeof te=="string"&&Li(De))return this.o(O,te,De);throw(0,N.$7)()}o(O,te,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=O.start.line,Ze=O.start.character,ht=O.end.character-O.start.character,$t=this.k.get(te);let Jt=0;if(De)for(const ci of De){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ci);Jt|=1<<fi>>>0}this.q(Ke,Ze,ht,$t,Jt)}q(O,te,De,Ke,Ze){if(this.f&&(O<this.c||O===this.c&&te<this.e)){this.f=!1;const Jt=this.g.length/5|0;let ci=0,fi=0;for(let gi=0;gi<Jt;gi++){let mi=this.g[5*gi],qi=this.g[5*gi+1];mi===0?(mi=ci,qi+=fi):mi+=ci,this.g[5*gi]=mi,this.g[5*gi+1]=qi,ci=mi,fi=qi}}let ht=O,$t=te;this.f&&this.j>0&&(ht-=this.c,ht===0&&($t-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=$t,this.g[this.j++]=De,this.g[this.j++]=Ke,this.g[this.j++]=Ze,this.c=O,this.e=te}static r(O){const te=[],De=O.length/5|0;for(let $t=0;$t<De;$t++)te[$t]=$t;te.sort(($t,Jt)=>{const ci=O[5*$t],fi=O[5*Jt];if(ci===fi){const gi=O[5*$t+1],mi=O[5*Jt+1];return gi-mi}return ci-fi});const Ke=new Uint32Array(O.length);let Ze=0,ht=0;for(let $t=0;$t<De;$t++){const Jt=5*te[$t],ci=O[Jt+0],fi=O[Jt+1],gi=O[Jt+2],mi=O[Jt+3],qi=O[Jt+4],Mn=ci-Ze,ur=Mn===0?fi-ht:fi,Hi=5*$t;Ke[Hi+0]=Mn,Ke[Hi+1]=ur,Ke[Hi+2]=gi,Ke[Hi+3]=mi,Ke[Hi+4]=qi,Ze=ci,ht=fi}return Ke}build(O){return this.f?new Pi(new Uint32Array(this.g),O):new Pi(zi.r(this.g),O)}}e.$bO=zi;class Pi{constructor(O,te){this.resultId=te,this.data=O}}e.$cO=Pi;class ln{constructor(O,te,De){this.start=O,this.deleteCount=te,this.data=De}}e.$dO=ln;class Qi{constructor(O,te){this.resultId=te,this.edits=O}}e.$eO=Qi;var Yi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));class hn{constructor(O){this.name=O}}e.$fO=hn;let Ui=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$gO=Ui,e.$gO=Ui=Je([w],Ui);var Zi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Zi||(e.QuickPickItemKind=Zi={}));var Ci;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Ci||(e.InputBoxValidationSeverity=Ci={}));var ji;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(ji||(e.ExtensionKind=ji={}));class Ue{static validate(O){if(typeof O.badge=="string"){let te=(0,p.$Ef)(O.badge,0);if(te<O.badge.length&&(te+=(0,p.$Ef)(O.badge,te)),O.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(O.badge&&!yt.isThemeIcon(O.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}constructor(O,te,De){this.badge=O,this.tooltip=te,this.color=De}}e.$hO=Ue;let oi=class{constructor(O){this.kind=O}};e.$iO=oi,e.$iO=oi=Je([w],oi);var Bi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Bi||(e.ColorThemeKind=Bi={}));class xe{static isNotebookRange(O){return O instanceof xe?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(O,te){if(O<0)throw(0,N.$7)("start must be positive");if(te<0)throw(0,N.$7)("end must be positive");O<=te?(this.c=O,this.e=te):(this.c=te,this.e=O)}with(O){let te=this.c,De=this.e;return O.start!==void 0&&(te=O.start),O.end!==void 0&&(De=O.end),te===this.c&&De===this.e?this:new xe(te,De)}}e.$jO=xe;class bt{static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(te=>bt.isNotebookCellData(te))}static isNotebookCellData(O){return!0}constructor(O,te,De,Ke,Ze,ht,$t){this.kind=O,this.value=te,this.languageId=De,this.mime=Ke,this.outputs=Ze??[],this.metadata=ht,this.executionSummary=$t,bt.validate(this)}}e.$kO=bt;class dn{constructor(O){this.cells=O}}e.$lO=dn;class ai{static isNotebookCellOutputItem(O){return O instanceof ai?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const te={name:O.name,message:O.message,stack:O.stack};return ai.json(te,"application/vnd.code.notebook.error")}static stdout(O){return ai.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ai.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,te="application/octet-stream"){return new ai(O,te)}static#e=new TextEncoder;static text(O,te=M.$Ks.text){const De=ai.#e.encode(String(O));return new ai(De,te)}static json(O,te="text/x-json"){const De=JSON.stringify(O,void 0,"	");return ai.text(De,te)}constructor(O,te){this.data=O,this.mime=te;const De=(0,M.$Os)(te,!0);if(!De)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$mO=ai;class Ei{static isNotebookCellOutput(O){return O instanceof Ei?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&Array.isArray(O.items)}static ensureUniqueMimeTypes(O,te=!1){const De=new Set,Ke=new Set;for(let Ze=0;Ze<O.length;Ze++){const ht=O[Ze],$t=(0,M.$Os)(ht.mime);if(!De.has($t)||(0,m.$PK)($t)){De.add($t);continue}Ke.add(Ze),te&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ke.size===0?O:O.filter((Ze,ht)=>!Ke.has(ht))}constructor(O,te,De){this.items=Ei.ensureUniqueMimeTypes(O,!0),typeof te=="string"?(this.id=te,this.metadata=De):(this.id=(0,T.$Ng)(),this.metadata=te??De)}}e.$nO=Ei;var xi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var Di;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Di||(e.NotebookCellExecutionState=Di={}));var _i;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(O,te){this.text=O,this.alignment=te}}e.$oO=fn;var Vi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Vi||(e.NotebookControllerAffinity=Vi={}));var tn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(O,te=[]){this.uri=O,this.provides=(0,I.$3b)(te)}}e.$pO=gn;class mn{constructor(O){this.label=O}}e.$qO=mn;var nn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Wi=class{constructor(O,te){this.label=O,this.timestamp=te}};e.$rO=Wi,e.$rO=Wi=Je([w],Wi);var rn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(O,te){this.ranges=O,this.wordPattern=te}}e.$sO=$n;class pn{constructor(O){this.c=O}get autoForwardAction(){return this.c}}e.$tO=pn;var an;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var _;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(_||(e.TestRunProfileKind=_={}));let se=class{constructor(O=void 0,te=void 0,De=void 0,Ke=!1){this.include=O,this.exclude=te,this.profile=De,this.continuous=Ke}};e.$uO=se,e.$uO=se=Je([w],se);let Le=S=class{static diff(O,te,De){const Ke=new S(O);return Ke.expectedOutput=te,Ke.actualOutput=De,Ke}constructor(O){this.message=O}};e.$vO=Le,e.$vO=Le=S=Je([w],Le);let rt=class{constructor(O){this.id=O}};e.$wO=rt,e.$wO=rt=Je([w],rt);class wt{constructor(O,te){this.covered=O,this.total=te,Mt(this)}}e.$xO=wt;function Mt(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class ki{static fromDetails(O,te){const De=new wt(0,0),Ke=new wt(0,0),Ze=new wt(0,0);for(const $t of te)if("branches"in $t){De.total+=1,De.covered+=$t.executed?1:0;for(const Jt of $t.branches)Ke.total+=1,Ke.covered+=Jt.executed?1:0}else Ze.total+=1,Ze.covered+=$t.executed?1:0;const ht=new ki(O,De,Ke.total>0?Ke:void 0,Ze.total>0?Ze:void 0);return ht.detailedCoverage=te,ht}constructor(O,te,De,Ke){this.uri=O,this.statementCoverage=te,this.branchCoverage=De,this.declarationCoverage=Ke}}e.$zO=ki;class Nn{get executionCount(){return+this.executed}set executionCount(O){this.executed=O}constructor(O,te,De=[]){this.executed=O,this.location=te,this.branches=De}}e.$AO=Nn;class Tn{get executionCount(){return+this.executed}set executionCount(O){this.executed=O}constructor(O,te,De){this.executed=O,this.location=te,this.label=De}}e.$BO=Tn;class Fn{get executionCount(){return+this.executed}set executionCount(O){this.executed=O}constructor(O,te,De){this.name=O,this.executed=te,this.location=De}}e.$CO=Fn;var bn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(bn||(e.ExternalUriOpenerPriority=bn={}));var vn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(vn||(e.WorkspaceTrustState=vn={}));var wn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn||(e.PortAutoForwardAction=wn={}));class On{constructor(O,te,De,Ke,Ze,ht){this.kind=O,this.name=te,this.detail=De,this.uri=Ke,this.range=Ze,this.selectionRange=ht}}e.$DO=On;class Ln{constructor(O){this.uri=O}}e.$EO=Ln;class zn{constructor(O,te){this.original=O,this.modified=te}}e.$FO=zn;class Un{constructor(O,te,De,Ke){this.base=O,this.input1=te,this.input2=De,this.result=Ke}}e.$GO=Un;class jn{constructor(O,te){this.uri=O,this.viewType=te}}e.$HO=jn;class Bn{constructor(O){this.viewType=O}}e.$IO=Bn;class Vn{constructor(O,te){this.uri=O,this.notebookType=te}}e.$JO=Vn;class Wn{constructor(O,te,De){this.original=O,this.modified=te,this.notebookType=De}}e.$KO=Wn;class qn{constructor(){}}e.$LO=qn;class Hn{constructor(O,te){this.uri=O,this.inputBoxUri=te}}e.$MO=Hn;class Gn{constructor(){}}e.$NO=Gn;class Kn{constructor(O){this.textDiffs=O}}e.$OO=Kn;var yn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var En;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(En||(e.ChatCopyKind=En={}));var Dn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Jn{constructor(O,te){this.label=O,this.values=te}}e.$PO=Jn;var kn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(kn||(e.InteractiveEditorResponseFeedbackKind=kn={}));var Sn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class Xn{constructor(O){if(typeof O!="string"&&O.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof O=="string"?new Fe(O):O}}e.$QO=Xn;class Qn{constructor(O,te){if(typeof O!="string"&&O.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof O=="string"?new Fe(O):O,this.vulnerabilities=te}}e.$RO=Qn;class Yn{constructor(O,te){this.participant=O,this.command=te}}e.$SO=Yn;class Zn{constructor(O,te){this.value=O,this.baseUri=te}}e.$TO=Zn;class xn{constructor(O,te){this.value=O,this.title=te}}e.$UO=xn;class _n{constructor(O){this.value=O}}e.$VO=_n;class er{constructor(O){this.value=O}}e.$WO=er;class tr{constructor(O){this.value=O}}e.$XO=tr;class ir{constructor(O,te){this.uri=O,this.edits=Array.isArray(te)?te:[te]}}e.$YO=ir;class nr{constructor(O,te,De,Ke){this.prompt=O,this.command=te,this.variables=De,this.participant=Ke}}e.$ZO=nr;class rr{constructor(O,te,De,Ke){this.response=O,this.result=te,this.participant=De,this.command=Ke}}e.$1O=rr;var In;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(In||(e.ChatLocation=In={}));class sr{constructor(O){this.content=O}}e.$2O=sr;class or{constructor(O,te){this.content=O,this.name=te}}e.$3O=or;class ar{constructor(O,te){this.content=O,this.name=te}}e.$4O=ar;class Ai extends Error{static NotFound(O){return new Ai(O,Ai.NotFound.name)}static NoPermissions(O){return new Ai(O,Ai.NoPermissions.name)}constructor(O,te,De){super(O,{cause:De}),this.name="LanguageModelError",this.code=te??""}}e.$5O=Ai;var Pn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var Cn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Cn||(e.SpeechToTextStatus=Cn={}));var An;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class cr{constructor(O,te){this.text=O,this.range=te}}e.$6O=cr;var Rn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Rn||(e.InlineEditTriggerKind=Rn={}))}),define(Ce[246],Re([1,0,4,7]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;class A{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$SM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,p,f){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(M);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(p,f)??[]}getRelatedInformation(M,p,f){return this.c.$getAiRelatedInformation(p,f)}registerRelatedInformationProvider(M,p,f){const E=this.b;return this.b++,this.a.set(E,f),this.c.$registerAiRelatedInformationProvider(E,p),new N.$UM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Akc=A}),define(Ce[84],Re([1,0,5,4,7,20,106,3,16]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=e.$Lkc=void 0,e.$Lkc=(0,p.$ri)("IExtHostAuthentication");let E=class{constructor(u){this.b=new Map,this.c=new I.$be,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=u.getProxy(N.$SM.MainThreadAuthentication)}async getSession(u,v,m,s={}){const o=F.$Mm.toKey(u.identifier),r=[...m].sort().join(" ");return await this.d.getOrCreate(`${o} ${v} ${r}`,async()=>{await this.a.$ensureProvider(v);const n=u.displayName||u.name;return this.a.$getSession(v,m,o,n,s)})}async getSessions(u,v,m){const s=F.$Mm.toKey(u.identifier),o=[...m].sort().join(" ");return await this.f.getOrCreate(`${s} ${o}`,async()=>{await this.a.$ensureProvider(v);const r=u.displayName||u.name;return this.a.$getSessions(v,m,s,r)})}async removeSession(u,v){const m=this.b.get(u);return m?m.provider.removeSession(v):this.a.$removeSession(u,v)}registerAuthenticationProvider(u,v,m,s){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:v,provider:m,options:s??{supportsMultipleAccounts:!1}});const o=m.onDidChangeSessions(r=>this.a.$sendDidChangeSessions(u,r));return this.a.$registerAuthenticationProvider(u,v,s?.supportsMultipleAccounts??!1),new A.$UM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}$createSession(u,v,m){const s=this.b.get(u);if(s)return Promise.resolve(s.provider.createSession(v,m));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$removeSession(u,v){const m=this.b.get(u);if(m)return Promise.resolve(m.provider.removeSession(v));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$getSessions(u,v){const m=this.b.get(u);if(m)return Promise.resolve(m.provider.getSessions(v));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,v){return u.startsWith(M.$UL)||this.c.fire({provider:{id:u,label:v}}),Promise.resolve()}};e.$Mkc=E,e.$Mkc=E=Je([We(0,f.$fP)],E);class T{constructor(){this.a=new Map}getOrCreate(u,v){const m=this.a.get(u);if(m)return m;const s=v().finally(()=>this.a.delete(u));return this.a.set(u,s),s}}}),define(Ce[110],Re([1,0,2,4,7,3,16,13,18,15,19,26]),function(ge,e,I,N,A,F,M,p,f,E,T,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0;let v=class{static{u=this}static{this.c=0}static{this.d=250}constructor(s,o){this.h=o,this.f=new Map,this.g=s.getProxy(N.$SM.MainThreadDecorations)}registerFileDecorationProvider(s,o){const r=u.c++;this.f.set(r,{provider:s,extensionDescription:o}),this.g.$registerDecorationProvider(r,o.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(t=>{if(!t){this.g.$onDidChange(r,null);return}const c=(0,f.$3b)(t);if(c.length<=u.d){this.g.$onDidChange(r,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const l=c.map(a=>({uri:a,rank:(0,E.$0e)(a.path,"/")})),i=(0,f.$zb)(l,(a,b)=>a.rank-b.rank||(0,E.$nf)(a.uri.path,b.uri.path)),$=[];e:for(const a of i){let b;for(const h of a){const D=(0,T.$nc)(h.uri.path);if(b!==D&&(b=D,$.push(h.uri)>=u.d))break e}}this.g.$onDidChange(r,$)});return new A.$UM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(s,o,r){if(!this.f.has(s))return Object.create(null);const n=Object.create(null),{provider:t,extensionDescription:c}=this.f.get(s);return await Promise.all(o.map(async l=>{try{const{uri:i,id:$}=l,a=await Promise.resolve(t.provideFileDecoration(I.URI.revive(i),r));if(!a)return;try{A.$hO.validate(a),a.badge&&typeof a.badge!="string"&&(0,y.$AG)(c,"codiconDecoration"),n[$]=[a.propagate,a.tooltip,a.badge,a.color]}catch(b){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${b}`)}}catch(i){this.h.error(i)}})),n}};e.$Llc=v,e.$Llc=v=u=Je([We(0,M.$fP),We(1,p.$Xj)],v),e.$Mlc=(0,F.$ri)("IExtHostDecorations")}),define(Ce[247],Re([1,0,14,2,7,4,12,24,15]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=void 0;class E{static{this.a=0}constructor(y,u,v){this.d=u,this.e=v,this.b=new Map,this.c=y.getProxy(F.$SM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(M.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const v=E.a++;this.b.set(v,u),this.c.$registerTextContentProvider(v,y);let m;if(typeof u.onDidChange=="function"){let s;m=u.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;s&&await s;const r=this.$provideTextDocumentContent(v,o).then(async n=>{if(!n&&typeof n!="string")return;const t=this.d.getDocument(o);if(!t)return;const c=(0,f.$hf)(n);if(!t.equalLines(c))return this.c.$onVirtualDocumentChange(o,n)}).catch(I.$1).finally(()=>{s===r&&(s=void 0)});s=r})}return new A.$UM(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(y,u){const v=this.b.get(y);return v?Promise.resolve(v.provideTextDocumentContent(N.URI.revive(u),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Olc=E}),define(Ce[111],Re([1,0,56,12,15,302,152,7,18]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jP=e.$iP=void 0,e.$hP=T;const E=new Map;function T(m,s){s?E.set(m,s):E.delete(m)}function y(m){return E.get(m)}class u extends F.$Sv{constructor(s,o,r,n,t,c,l){super(o,r,n,t),this.c=s,this.m=c,this.q=l,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,f.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===N.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,r){return s.y(o,r)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,I.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,I.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const r=this.g,n=o.start.line,t=o.end.line,c=[];c.push(this.f[n].substring(o.start.character));for(let l=n+1;l<t;l++)c.push(this.f[l]);return c.push(this.f[t].substring(0,o.end.character)),c.join(r)}t(s){let o;if(s instanceof p.$VM?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.f[o],o===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const o=this.j.getIndexOf(s),r=this.f[o.index].length;return new p.$VM(o.index,Math.min(o.remainder,r))}w(s){if(!(s instanceof p.$WM))throw new Error("Invalid argument");const o=this.x(s.start),r=this.x(s.end);return o===s.start&&r===s.end?s:new p.$WM(o.line,o.character,r.line,r.character)}x(s){if(!(s instanceof p.$VM))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:o,character:r}=s,n=!1;if(o<0)o=0,r=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,r=this.f[o].length,n=!0;else{const t=this.f[o].length;r<0?(r=0,n=!0):r>t&&(r=t,n=!0)}return n?new p.$VM(o,r):s}y(s,o){const r=this.x(s);if(!o)o=y(this.m);else if((0,A.$gf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,M.$3s)(r.character+1,(0,M.$1s)(o),this.f[r.line],0);if(n)return new p.$WM(r.line,n.startColumn-1,r.line,n.endColumn-1)}}e.$iP=u;class v{constructor(s,o,r){this.a=s,this.b=o,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$WM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$WM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$jP=v}),define(Ce[248],Re([1,0,4,7]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=void 0;class A{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$SM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,p,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(M);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector(p,f);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(M,p,f){const E=this.b;return this.b++,this.a.set(E,f),this.c.$registerAiEmbeddingVectorProvider(p,E),new N.$UM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$Qlc=A}),define(Ce[64],Re([1,0,4,44,7,22,3,16,45,6,11,23,12]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=e.$2kc=void 0;let m=v=class{constructor(o,r){this.b=new Map,this.c=new T.$Ah,this.a=o.getProxy(I.$SM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(t){try{let c;const l=n.b.get(t.scheme);return l?(await n.a.$ensureActivation(t.scheme),c=await l.impl.stat(t)):c=await n.a.$stat(t),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===N.FilePermission.Readonly?1:void 0}}catch(c){v.e(c)}},async readDirectory(t){try{const c=n.b.get(t.scheme);return c?(await n.a.$ensureActivation(t.scheme),(await c.impl.readDirectory(t)).slice()):await n.a.$readdir(t)}catch(c){return v.e(c)}},async createDirectory(t){try{const c=n.b.get(t.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(t.scheme),await n.d(c.impl,c.extUri,t)):await n.a.$mkdir(t)}catch(c){return v.e(c)}},async readFile(t){try{const c=n.b.get(t.scheme);return c?(await n.a.$ensureActivation(t.scheme),(await c.impl.readFile(t)).slice()):(await n.a.$readFile(t)).buffer}catch(c){return v.e(c)}},async writeFile(t,c){try{const l=n.b.get(t.scheme);return l&&!l.isReadonly?(await n.a.$ensureActivation(t.scheme),await n.d(l.impl,l.extUri,l.extUri.dirname(t)),await n.c.queueFor(t,()=>Promise.resolve(l.impl.writeFile(t,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(t,F.$Ce.wrap(c))}catch(l){return v.e(l)}},async delete(t,c){try{const l=n.b.get(t.scheme);return l&&!l.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(t.scheme),await l.impl.delete(t,{recursive:!1,...c})):await n.a.$delete(t,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(l){return v.e(l)}},async rename(t,c,l){try{return await n.a.$rename(t,c,{overwrite:!1,...l})}catch(i){return v.e(i)}},async copy(t,c,l){try{return await n.a.$copy(t,c,{overwrite:!1,...l})}catch(i){return v.e(i)}},isWritableFileSystem(t){const c=r.getCapabilities(t);if(typeof c=="number")return!(c&2048)}})}async d(o,r,n){const t=[];for(;!r.isEqual(n,r.dirname(n));)try{if(!((await o.stat(n)).type&N.FileType.Directory))throw A.$$N.FileExists(`Unable to create folder '${n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(N.$bl(c)!==N.FileSystemProviderErrorCode.FileNotFound)throw c;t.push(r.basename(n)),n=r.dirname(n)}for(let c=t.length-1;c>=0;c--){n=r.joinPath(n,t[c]);try{await o.createDirectory(n)}catch(l){if(N.$bl(l)!==N.FileSystemProviderErrorCode.FileExists)throw l}}}static e(o){if(o instanceof A.$$N)throw o;if(o instanceof N.$0k)switch(o.code){case N.FileSystemProviderErrorCode.FileExists:throw A.$$N.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw A.$$N.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw A.$$N.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw A.$$N.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw A.$$N.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw A.$$N.Unavailable(o.message);default:throw new A.$$N(o.message,o.name)}if(!(o instanceof Error))throw new A.$$N(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw A.$$N.Unavailable(o.message);switch(o.name){case N.FileSystemProviderErrorCode.FileExists:throw A.$$N.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw A.$$N.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw A.$$N.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw A.$$N.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw A.$$N.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw A.$$N.Unavailable(o.message);default:throw new A.$$N(o.message,o.name)}}addFileSystemProvider(o,r,n){return this.b.set(o,{impl:r,extUri:n?.isCaseSensitive?y.$Ug:y.$Wg,isReadonly:!!n?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$Ug}};e.$2kc=m,e.$2kc=m=v=Je([We(0,p.$fP),We(1,f.$Fkc)],m),e.$3kc=(0,M.$ri)("IExtHostConsumerFileSystem")}),define(Ce[85],Re([1,0,3,27,13,64,2]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=e.$4kc=void 0,e.$4kc=(0,I.$ri)("IExtensionStoragePaths");let p=class{constructor(E,T,y){this.d=T,this.f=y,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(E){return M.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,T=await this.g(E);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(M.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(E){if(this.c)return M.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return M.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$5kc=p,e.$5kc=p=Je([We(0,N.$vP),We(1,A.$Xj),We(2,F.$3kc)],p)}),define(Ce[249],Re([1,0,7,16,5]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;let F=class{constructor(p){this.a=new I.$iO(I.ColorThemeKind.Dark),this.b=new A.$be}get activeColorTheme(){return this.a}$onColorThemeChange(p){let f;switch(p){case"light":f=I.ColorThemeKind.Light;break;case"hcDark":f=I.ColorThemeKind.HighContrast;break;case"hcLight":f=I.ColorThemeKind.HighContrastLight;break;default:f=I.ColorThemeKind.Dark}this.a=new I.$iO(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$zmc=F,e.$zmc=F=Je([We(0,N.$fP)],F)}),define(Ce[86],Re([1,0,24,5,6,173,3,13,203,4,27,16,7]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XCb=e.$WCb=e.TunnelDtoConverter=void 0;class v extends f.$fw{}var m;(function(o){function r(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,privacy:t.privacy??(t.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:t.protocol}}o.fromApiTunnel=r;function n(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.privacy!==f.TunnelPrivacyId.ConstantPrivate&&t.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:t.privacy,protocol:t.protocol}}o.fromServiceTunnel=n})(m||(e.TunnelDtoConverter=m={})),e.$WCb=(0,M.$ri)("IExtHostTunnelService");let s=class extends A.$Uc{constructor(r,n,t){super(),this.s=t,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$be,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(E.$SM.MainThreadTunnelService)}async openTunnel(r,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const t=await this.a.$openTunnel(n,r.displayName);if(t){const c=new v(t.remoteAddress,t.localAddress,()=>this.a.$closeTunnel(t.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,n){r.portRange===void 0&&r.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const t=this.u();return this.r.set(t,{selector:r,provider:n}),this.a.$registerPortsAttributesProvider(r,t),new u.$UM(()=>{this.r.delete(t),this.a.$unregisterPortsAttributesProvider(t)})}async $providePortAttributes(r,n,t,c,l){const i=[];for(const a of r){const b=this.r.get(a);if(!b)return[];i.push(...await Promise.all(n.map(async h=>{let D;try{D=await b.provider.providePortAttributes({port:h,pid:t,commandLine:c},l)}catch{D=await b.provider.providePortAttributes(h,t,c,l)}return{providedAttributes:D,port:h}})))}const $=i.filter(a=>!!a.providedAttributes);return $.length>0?$.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,l)=>await r.provideTunnel(c,l,I.CancellationToken.None)??void 0;const t=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(t),Promise.resolve((0,A.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,n){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const t=r.tunnelFactory??(n?this.w(n):void 0);if(t){this.b=t;let c=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const l=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,A.$Sc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,n){if(this.g.has(r.host)){const t=this.g.get(r.host);t.has(r.port)&&(n&&t.get(r.port).disposeListener.dispose(),await t.get(r.port).tunnel.dispose(),t.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const t=this.b(r,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),t!==void 0){const c=await t;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const l=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:c,disposeListener:l}),m.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(t){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),t instanceof Error)return t.message}}async $applyCandidateFilter(r){const n=await Promise.all(r.map(c=>this.f(c.host,c.port,c.detail??""))),t=r.filter((c,l)=>n[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(c=>c.port).join(", ")} to ${t.map(c=>c.port).join(", ")}`),t}};e.$XCb=s,e.$XCb=s=Je([We(0,y.$fP),We(1,T.$vP),We(2,p.$Xj)],s)}),define(Ce[8],Re([1,0,18,22,132,250,54,28,124,53,69,25,127,23,17,2,29,87,100,105,104,213,83,50,61,224,7]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t,c,l,i,$,a,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$cP=j,e.$dP=re,e.$eP=ae;var D;(function(we){function Se(J){const{selectionStartLineNumber:ke,selectionStartColumn:Ve,positionLineNumber:Qe,positionColumn:qe}=J,ut=new h.$VM(ke-1,Ve-1),Et=new h.$VM(Qe-1,qe-1);return new h.$XM(ut,Et)}we.to=Se;function oe(J){const{anchor:ke,active:Ve}=J;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}we.from=oe})(D||(e.Selection=D={}));var d;(function(we){function Se(J){if(!J)return;const{start:ke,end:Ve}=J;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}we.from=Se;function oe(J){if(!J)return;const{startLineNumber:ke,startColumn:Ve,endLineNumber:Qe,endColumn:qe}=J;return new h.$WM(ke-1,Ve-1,Qe-1,qe-1)}we.to=oe})(d||(e.Range=d={}));var k;(function(we){function Se(J){return{uri:J.uri,range:d.from(J.range)}}we.from=Se;function oe(J){return new h.$7M(s.URI.revive(J.uri),d.to(J.range))}we.to=oe})(k||(e.Location=k={}));var g;(function(we){function Se(oe){switch(oe){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}we.to=Se})(g||(e.TokenType=g={}));var S;(function(we){function Se(J){return new h.$VM(J.lineNumber-1,J.column-1)}we.to=Se;function oe(J){return{lineNumber:J.line+1,column:J.character+1}}we.from=oe})(S||(e.Position=S={}));var w;(function(we){function Se(ke,Ve,Qe){return(0,I.$Hb)((0,I.$3b)(ke).map(qe=>oe(qe,Ve,Qe)))}we.from=Se;function oe(ke,Ve,Qe){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Qe?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:J(ke.scheme,Ve),pattern:Q.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Qe?.isBuiltin}}function J(ke,Ve){return Ve&&typeof ke=="string"?Ve.transformOutgoingScheme(ke):ke}})(w||(e.DocumentSelector=w={}));var C;(function(we){function Se(J){switch(J){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}we.from=Se;function oe(J){switch(J){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}we.to=oe})(C||(e.DiagnosticTag=C={}));var P;(function(we){function Se(J){let ke;return J.code&&((0,m.$5f)(J.code)||(0,m.$9f)(J.code)?ke=String(J.code):ke={value:String(J.code.value),target:J.code.target}),{...d.from(J.range),message:J.message,source:J.source,code:ke,severity:V.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(W.from),tags:Array.isArray(J.tags)?(0,I.$Hb)(J.tags.map(C.from)):void 0}}we.from=Se;function oe(J){const ke=new h.$9M(d.to(J),J.message,V.to(J.severity));return ke.source=J.source,ke.code=(0,m.$5f)(J.code)?J.code:J.code?.value,ke.relatedInformation=J.relatedInformation&&J.relatedInformation.map(W.to),ke.tags=J.tags&&(0,I.$Hb)(J.tags.map(C.to)),ke}we.to=oe})(P||(e.Diagnostic=P={}));var W;(function(we){function Se(J){return{...d.from(J.location.range),message:J.message,resource:J.location.uri}}we.from=Se;function oe(J){return new h.$8M(new h.$7M(J.resource,d.to(J)),J.message)}we.to=oe})(W||(e.DiagnosticRelatedInformation=W={}));var V;(function(we){function Se(J){switch(J){case h.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}we.from=Se;function oe(J){switch(J){case n.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}we.to=oe})(V||(e.DiagnosticSeverity=V={}));var q;(function(we){function Se(J){return typeof J=="number"&&J>=h.ViewColumn.One?J-1:J===h.ViewColumn.Beside?b.$QD:b.$PD}we.from=Se;function oe(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=oe})(q||(e.ViewColumn=q={}));function R(we){return typeof we.range<"u"}function j(we){return we.length===0?!0:!!R(we[0])}var K;(function(we){function Se(qe){return qe.map(we.from)}we.fromMany=Se;function oe(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(oe(qe)){const{language:ct,value:ri}=qe;ut={value:"```"+ct+`
`+ri+"\n```\n"}}else h.$jN.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const Et=Object.create(null);ut.uris=Et;const Ot=ct=>{try{let ri=s.URI.parse(ct,!0);ri=ri.with({query:ke(ri.query,Et)}),Et[ct]=ri}catch{}return""},Vt=new f.marked.Renderer;return Vt.link=Ot,Vt.image=ct=>typeof ct=="string"?Ot(M.$Wk(ct).href):"",(0,f.marked)(ut.value,{renderer:Vt}),ut}we.from=J;function ke(qe,ut){if(!qe)return qe;let Et;try{Et=(0,E.$Zh)(qe)}catch{}if(!Et)return qe;let Ot=!1;return Et=(0,y.$Zn)(Et,Vt=>{if(s.URI.isUri(Vt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ct]=Vt,Ot=!0,ct}else return}),Ot?JSON.stringify(Et):qe}function Ve(qe){const ut=new h.$jN(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?s.URI.from(qe.baseUri):void 0,ut}we.to=Ve;function Qe(qe){if(qe)return typeof qe=="string"?qe:we.from(qe)}we.fromStrict=Qe})(K||(e.MarkdownString=K={}));function re(we){return j(we)?we.map(Se=>({range:d.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?K.fromMany(Se.hoverMessage):Se.hoverMessage?K.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):we.map(Se=>({range:d.from(Se)}))}function ae(we){return typeof we>"u"?we:typeof we=="string"?s.URI.file(we):we}var ve;(function(we){function Se(oe){return typeof oe>"u"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?ae(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}we.from=Se})(ve||(e.ThemableDecorationAttachmentRenderOptions=ve={}));var Ie;(function(we){function Se(oe){return typeof oe>"u"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ae(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ve.from(oe.before):void 0,after:oe.after?ve.from(oe.after):void 0}}we.from=Se})(Ie||(e.ThemableDecorationRenderOptions=Ie={}));var de;(function(we){function Se(oe){if(typeof oe>"u")return oe;switch(oe){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Se})(de||(e.DecorationRangeBehavior=de={}));var me;(function(we){function Se(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?de.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?Ie.from(oe.light):void 0,dark:oe.dark?Ie.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ae(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ve.from(oe.before):void 0,after:oe.after?ve.from(oe.after):void 0}}we.from=Se})(me||(e.DecorationRenderOptions=me={}));var Me;(function(we){function Se(J){return{text:J.newText,eol:J.newEol&&at.from(J.newEol),range:d.from(J.range)}}we.from=Se;function oe(J){const ke=new h.$2M(d.to(J.range),J.text);return ke.newEol=typeof J.eol>"u"?void 0:at.to(J.eol),ke}we.to=oe})(Me||(e.TextEdit=Me={}));var ce;(function(we){function Se(J,ke){const Ve={edits:[]};if(J instanceof h.$5M){const Qe=new p.$Cc;for(const qe of J._allEntries())qe._type===1&&s.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,N.$We)(N.$Ce.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:Me.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:d.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Ut.from)}})}return Ve}we.from=Se;function oe(J){const ke=new h.$5M,Ve=new p.$Bc;for(const Qe of J.edits)if(Qe.textEdit){const qe=Qe,ut=s.URI.revive(qe.resource),Et=d.to(qe.textEdit.range),Ot=qe.textEdit.text,Vt=qe.textEdit.insertAsSnippet;let ct;Vt?ct=h.$4M.replace(Et,new h.$6M(Ot)):ct=h.$2M.replace(Et,Ot);const ri=Ve.get(ut);ri?ri.push(ct):Ve.set(ut,[ct])}else ke.renameFile(s.URI.revive(Qe.oldResource),s.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of Ve)ke.set(Qe,qe);return ke}we.to=oe})(ce||(e.WorkspaceEdit=ce={}));var Ae;(function(we){const Se=Object.create(null);Se[h.SymbolKind.File]=0,Se[h.SymbolKind.Module]=1,Se[h.SymbolKind.Namespace]=2,Se[h.SymbolKind.Package]=3,Se[h.SymbolKind.Class]=4,Se[h.SymbolKind.Method]=5,Se[h.SymbolKind.Property]=6,Se[h.SymbolKind.Field]=7,Se[h.SymbolKind.Constructor]=8,Se[h.SymbolKind.Enum]=9,Se[h.SymbolKind.Interface]=10,Se[h.SymbolKind.Function]=11,Se[h.SymbolKind.Variable]=12,Se[h.SymbolKind.Constant]=13,Se[h.SymbolKind.String]=14,Se[h.SymbolKind.Number]=15,Se[h.SymbolKind.Boolean]=16,Se[h.SymbolKind.Array]=17,Se[h.SymbolKind.Object]=18,Se[h.SymbolKind.Key]=19,Se[h.SymbolKind.Null]=20,Se[h.SymbolKind.EnumMember]=21,Se[h.SymbolKind.Struct]=22,Se[h.SymbolKind.Event]=23,Se[h.SymbolKind.Operator]=24,Se[h.SymbolKind.TypeParameter]=25;function oe(ke){return typeof Se[ke]=="number"?Se[ke]:6}we.from=oe;function J(ke){for(const Ve in Se)if(Se[Ve]===ke)return Number(Ve);return h.SymbolKind.Property}we.to=J})(Ae||(e.SymbolKind=Ae={}));var ie;(function(we){function Se(J){switch(J){case h.SymbolTag.Deprecated:return 1}}we.from=Se;function oe(J){switch(J){case 1:return h.SymbolTag.Deprecated}}we.to=oe})(ie||(e.SymbolTag=ie={}));var L;(function(we){function Se(J){return{name:J.name,kind:Ae.from(J.kind),tags:J.tags&&J.tags.map(ie.from),containerName:J.containerName,location:pe.from(J.location)}}we.from=Se;function oe(J){const ke=new h.$aN(J.name,Ae.to(J.kind),J.containerName,pe.to(J.location));return ke.tags=J.tags&&J.tags.map(ie.to),ke}we.to=oe})(L||(e.WorkspaceSymbol=L={}));var x;(function(we){function Se(J){const ke={name:J.name||"!!MISSING: name!!",detail:J.detail,range:d.from(J.range),selectionRange:d.from(J.selectionRange),kind:Ae.from(J.kind),tags:J.tags?.map(ie.from)??[]};return J.children&&(ke.children=J.children.map(Se)),ke}we.from=Se;function oe(J){const ke=new h.$bN(J.name,J.detail,Ae.to(J.kind),d.to(J.range),d.to(J.selectionRange));return(0,I.$Lb)(J.tags)&&(ke.tags=J.tags.map(ie.to)),J.children&&(ke.children=J.children.map(oe)),ke}we.to=oe})(x||(e.DocumentSymbol=x={}));var be;(function(we){function Se(J){const ke=new h.$fN(Ae.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),d.to(J.range),d.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}we.to=Se;function oe(J,ke,Ve){if(ke=ke??J._sessionId,Ve=Ve??J._itemId,ke===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ve,name:J.name,detail:J.detail,kind:Ae.from(J.kind),uri:J.uri,range:d.from(J.range),selectionRange:d.from(J.selectionRange),tags:J.tags?.map(ie.from)}}we.from=oe})(be||(e.CallHierarchyItem=be={}));var Oe;(function(we){function Se(oe){return new h.$gN(be.to(oe.from),oe.fromRanges.map(J=>d.to(J)))}we.to=Se})(Oe||(e.CallHierarchyIncomingCall=Oe={}));var Ee;(function(we){function Se(oe){return new h.$hN(be.to(oe.to),oe.fromRanges.map(J=>d.to(J)))}we.to=Se})(Ee||(e.CallHierarchyOutgoingCall=Ee={}));var pe;(function(we){function Se(J){return{range:J.range&&d.from(J.range),uri:J.uri}}we.from=Se;function oe(J){return new h.$7M(s.URI.revive(J.uri),d.to(J.range))}we.to=oe})(pe||(e.location=pe={}));var fe;(function(we){function Se(J){const ke=J,Ve=J;return{originSelectionRange:ke.originSelectionRange?d.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Ve.uri,range:d.from(ke.targetRange?ke.targetRange:Ve.range),targetSelectionRange:ke.targetSelectionRange?d.from(ke.targetSelectionRange):void 0}}we.from=Se;function oe(J){return{targetUri:s.URI.revive(J.uri),targetRange:d.to(J.range),targetSelectionRange:J.targetSelectionRange?d.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?d.to(J.originSelectionRange):void 0}}we.to=oe})(fe||(e.DefinitionLink=fe={}));var X;(function(we){function Se(J){return{range:d.from(J.range),contents:K.fromMany(J.contents)}}we.from=Se;function oe(J){return new h.$0M(J.contents.map(K.to),d.to(J.range))}we.to=oe})(X||(e.Hover=X={}));var Z;(function(we){function Se(J){return{range:d.from(J.range),expression:J.expression}}we.from=Se;function oe(J){return new h.$5N(d.to(J.range),J.expression)}we.to=oe})(Z||(e.EvaluatableExpression=Z={}));var le;(function(we){function Se(J){if(J instanceof h.$6N)return{type:"text",range:d.from(J.range),text:J.text};if(J instanceof h.$7N)return{type:"variable",range:d.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof h.$8N)return{type:"expression",range:d.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Se;function oe(J){switch(J.type){case"text":return{range:d.to(J.range),text:J.text};case"variable":return{range:d.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:d.to(J.range),expression:J.expression}}}we.to=oe})(le||(e.InlineValue=le={}));var ue;(function(we){function Se(J){return{frameId:J.frameId,stoppedLocation:d.from(J.stoppedLocation)}}we.from=Se;function oe(J){return new h.$9N(J.frameId,d.to(J.stoppedLocation))}we.to=oe})(ue||(e.InlineValueContext=ue={}));var Te;(function(we){function Se(J){return{range:d.from(J.range),kind:J.kind}}we.from=Se;function oe(J){return new h.$$M(d.to(J.range),J.kind)}we.to=oe})(Te||(e.DocumentHighlight=Te={}));var he;(function(we){function Se(J){return{uri:J.uri,highlights:J.highlights.map(Te.from)}}we.from=Se;function oe(J){return new h.$_M(s.URI.revive(J.uri),J.highlights.map(Te.to))}we.to=oe})(he||(e.MultiDocumentHighlight=he={}));var Pe;(function(we){function Se(oe){switch(oe){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}we.to=Se})(Pe||(e.CompletionTriggerKind=Pe={}));var Ne;(function(we){function Se(oe){return{triggerKind:Pe.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}we.to=Se})(Ne||(e.CompletionContext=Ne={}));var ze;(function(we){function Se(J){switch(J){case h.CompletionItemTag.Deprecated:return 1}}we.from=Se;function oe(J){switch(J){case 1:return h.CompletionItemTag.Deprecated}}we.to=oe})(ze||(e.CompletionItemTag=ze={}));var U;(function(we){const Se=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function oe(Ve){return Se.get(Ve)??9}we.from=oe;const J=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function ke(Ve){return J.get(Ve)??h.CompletionItemKind.Property}we.to=ke})(U||(e.CompletionItemKind=U={}));var z;(function(we){function Se(oe,J){const ke=new h.$pN(oe.label);return ke.insertText=oe.insertText,ke.kind=U.to(oe.kind),ke.tags=oe.tags?.map(ze.to),ke.detail=oe.detail,ke.documentation=M.$Qk(oe.documentation)?K.to(oe.documentation):oe.documentation,ke.sortText=oe.sortText,ke.filterText=oe.filterText,ke.preselect=oe.preselect,ke.commitCharacters=oe.commitCharacters,o.$nt.isIRange(oe.range)?ke.range=d.to(oe.range):typeof oe.range=="object"&&(ke.range={inserting:d.to(oe.range.insert),replacing:d.to(oe.range.replace)}),ke.keepWhitespace=typeof oe.insertTextRules>"u"?!1:!!(oe.insertTextRules&1),typeof oe.insertTextRules<"u"&&oe.insertTextRules&4?ke.insertText=new h.$6M(oe.insertText):(ke.insertText=oe.insertText,ke.textEdit=ke.range instanceof h.$WM?new h.$2M(ke.range,ke.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(ke.additionalTextEdits=oe.additionalTextEdits.map(Ve=>Me.to(Ve))),ke.command=J&&oe.command?J.fromInternal(oe.command):void 0,ke}we.to=Se})(z||(e.CompletionItem=z={}));var G;(function(we){function Se(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:K.fromStrict(J.documentation)}}we.from=Se;function oe(J){return{label:J.label,documentation:M.$Qk(J.documentation)?K.to(J.documentation):J.documentation}}we.to=oe})(G||(e.ParameterInformation=G={}));var H;(function(we){function Se(J){return{label:J.label,documentation:K.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(G.from):[],activeParameter:J.activeParameter}}we.from=Se;function oe(J){return{label:J.label,documentation:M.$Qk(J.documentation)?K.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(G.to):[],activeParameter:J.activeParameter}}we.to=oe})(H||(e.SignatureInformation=H={}));var ee;(function(we){function Se(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(H.from):[]}}we.from=Se;function oe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(H.to):[]}}we.to=oe})(ee||(e.SignatureHelp=ee={}));var ne;(function(we){function Se(oe,J){const ke=new h.$oN(S.to(J.position),typeof J.label=="string"?J.label:J.label.map(Fe.to.bind(void 0,oe)),J.kind&&Be.to(J.kind));return ke.textEdits=J.textEdits&&J.textEdits.map(Me.to),ke.tooltip=M.$Qk(J.tooltip)?K.to(J.tooltip):J.tooltip,ke.paddingLeft=J.paddingLeft,ke.paddingRight=J.paddingRight,ke}we.to=Se})(ne||(e.InlayHint=ne={}));var Fe;(function(we){function Se(oe,J){const ke=new h.$nN(J.label);return ke.tooltip=M.$Qk(J.tooltip)?K.to(J.tooltip):J.tooltip,r.Command.is(J.command)&&(ke.command=oe.fromInternal(J.command)),J.location&&(ke.location=pe.to(J.location)),ke}we.to=Se})(Fe||(e.InlayHintLabelPart=Fe={}));var Be;(function(we){function Se(J){return J}we.from=Se;function oe(J){return J}we.to=oe})(Be||(e.InlayHintKind=Be={}));var Xe;(function(we){function Se(J){return{range:d.from(J.range),url:J.target,tooltip:J.tooltip}}we.from=Se;function oe(J){let ke;if(J.url)try{ke=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}return new h.$uN(d.to(J.range),ke)}we.to=oe})(Xe||(e.DocumentLink=Xe={}));var _e;(function(we){function Se(J){const ke=new h.$xN(J.label);return J.textEdit&&(ke.textEdit=Me.to(J.textEdit)),J.additionalTextEdits&&(ke.additionalTextEdits=J.additionalTextEdits.map(Ve=>Me.to(Ve))),ke}we.to=Se;function oe(J){return{label:J.label,textEdit:J.textEdit?Me.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ke=>Me.from(ke)):void 0}}we.from=oe})(_e||(e.ColorPresentation=_e={}));var et;(function(we){function Se(J){return new h.$vN(J[0],J[1],J[2],J[3])}we.to=Se;function oe(J){return[J.red,J.green,J.blue,J.alpha]}we.from=oe})(et||(e.Color=et={}));var tt;(function(we){function Se(J){return{range:d.from(J.range)}}we.from=Se;function oe(J){return new h.$eN(d.to(J.range))}we.to=oe})(tt||(e.SelectionRange=tt={}));var it;(function(we){function Se(oe){switch(oe){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}we.to=Se})(it||(e.TextDocumentSaveReason=it={}));var nt;(function(we){function Se(J){switch(J){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.Interval:return 3;case h.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Se;function oe(J){switch(J){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 3:return h.TextEditorLineNumbersStyle.Interval;case 1:default:return h.TextEditorLineNumbersStyle.On}}we.to=oe})(nt||(e.TextEditorLineNumbersStyle=nt={}));var at;(function(we){function Se(J){if(J===h.EndOfLine.CRLF)return 1;if(J===h.EndOfLine.LF)return 0}we.from=Se;function oe(J){if(J===1)return h.EndOfLine.CRLF;if(J===0)return h.EndOfLine.LF}we.to=oe})(at||(e.EndOfLine=at={}));var mt;(function(we){function Se(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Se})(mt||(e.ProgressLocation=mt={}));var je;(function(we){function Se(J){const ke={start:J.start+1,end:J.end+1};return J.kind&&(ke.kind=st.from(J.kind)),ke}we.from=Se;function oe(J){const ke={start:J.start-1,end:J.end-1};return J.kind&&(ke.kind=st.to(J.kind)),ke}we.to=oe})(je||(e.FoldingRange=je={}));var st;(function(we){function Se(J){if(J)switch(J){case h.FoldingRangeKind.Comment:return r.$9t.Comment;case h.FoldingRangeKind.Imports:return r.$9t.Imports;case h.FoldingRangeKind.Region:return r.$9t.Region}}we.from=Se;function oe(J){if(J)switch(J.value){case r.$9t.Comment.value:return h.FoldingRangeKind.Comment;case r.$9t.Imports.value:return h.FoldingRangeKind.Imports;case r.$9t.Region.value:return h.FoldingRangeKind.Region}}we.to=oe})(st||(e.FoldingRangeKind=st={}));var Y;(function(we){function Se(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?d.from(oe.selection):void 0,override:typeof oe.override=="boolean"?c.$gF.id:void 0}}we.from=Se})(Y||(e.TextEditorOpenOptions=Y={}));var Q;(function(we){function Se(Ve){return Ve instanceof h.$SN?Ve.toJSON():typeof Ve=="string"?Ve:oe(Ve)||J(Ve)?new h.$SN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}we.from=Se;function oe(Ve){const Qe=Ve;return Qe?s.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function J(Ve){const Qe=Ve;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function ke(Ve){return typeof Ve=="string"?Ve:new h.$SN(s.URI.revive(Ve.baseUri),Ve.pattern)}we.to=ke})(Q||(e.GlobPattern=Q={}));var $e;(function(we){function Se(oe){if(oe){if(Array.isArray(oe))return oe.map(Se);if(typeof oe=="string")return oe;{const J=oe;return{language:J.language,scheme:J.scheme,pattern:Q.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}we.from=Se})($e||(e.LanguageSelector=$e={}));var He;(function(we){function Se(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ke=>Array.isArray(ke)&&ke.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&s.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Qe=>Qe instanceof h.$WM)))}we.is=Se;function oe(J){return{documents:J.documents.map(ke=>ke.map(Ve=>({uri:s.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Qe=>d.from(Qe))})))}}we.from=oe})(He||(e.MappedEditsContext=He={}));var ye;(function(we){function Se(J){return{start:J.start,end:J.end}}we.from=Se;function oe(J){return new h.$jO(J.start,J.end)}we.to=oe})(ye||(e.NotebookRange=ye={}));var ot;(function(we){function Se(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}we.to=Se;function oe(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}we.from=oe})(ot||(e.NotebookCellExecutionSummary=ot={}));var dt;(function(we){function Se(oe){if(oe===i.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(oe===i.NotebookCellExecutionState.Pending)return;if(oe===i.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${oe}`)}we.to=Se})(dt||(e.NotebookCellExecutionState=dt={}));var It;(function(we){function Se(J){switch(J){case h.NotebookCellKind.Markup:return i.CellKind.Markup;case h.NotebookCellKind.Code:default:return i.CellKind.Code}}we.from=Se;function oe(J){switch(J){case i.CellKind.Markup:return h.NotebookCellKind.Markup;case i.CellKind.Code:default:return h.NotebookCellKind.Code}}we.to=oe})(It||(e.NotebookCellKind=It={}));var Xt;(function(we){function Se(J){const ke={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)h.$kO.validate(Ve),ke.cells.push(Ut.from(Ve));return ke}we.from=Se;function oe(J){const ke=new h.$lO(J.cells.map(Ut.to));return(0,m.$fg)(J.metadata)||(ke.metadata=J.metadata),ke}we.to=oe})(Xt||(e.NotebookData=Xt={}));var Ut;(function(we){function Se(J){return{cellKind:It.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:ot.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(_t.from):[]}}we.from=Se;function oe(J){return new h.$kO(It.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(_t.to):void 0,J.metadata,J.internalMetadata?ot.to(J.internalMetadata):void 0)}we.to=oe})(Ut||(e.NotebookCellData=Ut={}));var xt;(function(we){function Se(J){return{mime:J.mime,valueBytes:N.$Ce.wrap(J.data)}}we.from=Se;function oe(J){return new h.$mO(J.valueBytes.buffer,J.mime)}we.to=oe})(xt||(e.NotebookCellOutputItem=xt={}));var _t;(function(we){function Se(J){return{outputId:J.id,items:J.items.map(xt.from),metadata:J.metadata}}we.from=Se;function oe(J){const ke=J.items.map(xt.to);return new h.$nO(ke,J.outputId,J.metadata)}we.to=oe})(_t||(e.NotebookCellOutput=_t={}));var Pt;(function(we){function Se(ke){return J(ke)?{include:Q.from(ke.include)??void 0,exclude:Q.from(ke.exclude)??void 0}:Q.from(ke)??void 0}we.from=Se;function oe(ke){return J(ke)?{include:Q.to(ke.include),exclude:Q.to(ke.exclude)}:Q.to(ke)}we.to=oe;function J(ke){const Ve=ke;return Ve?!(0,m.$bg)(Ve.include)&&!(0,m.$bg)(Ve.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var Wt;(function(we){function Se(oe,J,ke){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,ke),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}we.from=Se})(Wt||(e.NotebookStatusBarItem=Wt={}));var Qt;(function(we){function Se(oe,J,ke){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{command:J.toInternal(Ve,ke),label:oe.label,description:oe.description,detail:oe.detail,documentation:oe.documentation}}we.from=Se})(Qt||(e.NotebookKernelSourceAction=Qt={}));var Ye;(function(we){function Se(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{},cellContentMetadata:oe?.cellContentMetadata??{}}}we.from=Se})(Ye||(e.NotebookDocumentContentOptions=Ye={}));var si;(function(we){function Se(J){return{uri:J.uri,provides:J.provides}}we.from=Se;function oe(J){return new h.$pO(s.URI.revive(J.uri),J.provides)}we.to=oe})(si||(e.NotebookRendererScript=si={}));var Yt;(function(we){function Se(J){return{message:K.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:d.from(J.location.range),uri:J.location.uri}}}we.from=Se;function oe(J){const ke=new h.$vO(typeof J.message=="string"?J.message:K.to(J.message));return ke.actualOutput=J.actual,ke.expectedOutput=J.expected,ke.contextValue=J.contextValue,ke.location=J.location?pe.to(J.location):void 0,ke}we.to=oe})(Yt||(e.TestMessage=Yt={}));var lt;(function(we){we.namespace=a.$JL,we.denamespace=a.$KL})(lt||(e.TestTag=lt={}));var vt;(function(we){function Se(J){const ke=(0,t.$bP)(J).controllerId;return{extId:$.$EL.fromExtHostTestItem(J,ke).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>lt.namespace(ke,Ve.id)),range:o.$nt.lift(d.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&K.fromStrict(J.error)||null}}we.from=Se;function oe(J){return{parent:void 0,error:void 0,id:$.$EL.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(ke=>{const{tagId:Ve}=lt.denamespace(ke);return new h.$wO(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}we.toPlain=oe})(vt||(e.TestItem=vt={})),function(we){function Se(J){return{id:J.id}}we.from=Se;function oe(J){return new h.$wO(J.id)}we.to=oe}(lt||(e.TestTag=lt={}));var ti;(function(we){const Se=(J,ke)=>{const Ve=J.value;if(!Ve)return;const Qe={...vt.toPlain(Ve.item),parent:ke,taskStates:Ve.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(Yt.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Se(qe,Qe);ut&&Qe.children.push(ut)}return Qe};function oe(J){const ke=new u.$7O;for(const qe of J.items)ke.insert($.$EL.fromString(qe.item.extId).path,qe);const Ve=[ke.nodes],Qe=[];for(;Ve.length;)for(const qe of Ve.pop())qe.value?Qe.push(qe):qe.children&&Ve.push(qe.children.values());return{completedAt:J.completedAt,results:Qe.map(qe=>Se(qe)).filter(m.$ag)}}we.to=oe})(ti||(e.TestResults=ti={}));var Zt;(function(we){function Se(Ve){return{covered:Ve.covered,total:Ve.total}}function oe(Ve){return"line"in Ve?S.from(Ve):d.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:oe(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Qe=>({count:Qe.executed,location:Qe.location&&oe(Qe.location),label:Qe.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:oe(Ve.location)}}we.fromDetails=J;function ke(Ve,Qe){return h.$yO(Qe.statementCoverage),h.$yO(Qe.branchCoverage),h.$yO(Qe.declarationCoverage),{id:Ve,uri:Qe.uri,statement:Se(Qe.statementCoverage),branch:Qe.branchCoverage&&Se(Qe.branchCoverage),declaration:Qe.declarationCoverage&&Se(Qe.declarationCoverage)}}we.fromFile=ke})(Zt||(e.TestCoverage=Zt={}));var Lt;(function(we){function Se(oe){switch(oe){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}we.to=Se})(Lt||(e.CodeActionTriggerKind=Lt={}));var ft;(function(we){function Se(J){const ke=new h.$DO(Ae.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),d.to(J.range),d.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}we.to=Se;function oe(J,ke,Ve){if(ke=ke??J._sessionId,Ve=Ve??J._itemId,ke===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ve,kind:Ae.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:d.from(J.range),selectionRange:d.from(J.selectionRange),tags:J.tags?.map(ie.from)}}we.from=oe})(ft||(e.TypeHierarchyItem=ft={}));var jt;(function(we){function Se(oe){if(oe)return{value:oe.value,tooltip:oe.tooltip}}we.from=Se})(jt||(e.ViewBadge=jt={}));var Bt;(function(we){function Se(Ve,Qe,qe){const ut=Qe.fileData;return ut?new h.$KN(new h.$LN(ut.name,s.URI.revive(ut.uri),ut.id,(0,F.$db)(()=>qe(ut.id)))):Ve===T.$Ks.uriList&&Qe.uriListData?new h.$JN(ke(Qe.uriListData)):new h.$JN(Qe.asString)}we.to=Se;async function oe(Ve,Qe){const qe=await Qe.asString();if(Ve===T.$Ks.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Qe.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}we.from=oe;function J(Ve){return A.$Nt.split(Ve).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return s.URI.parse(Qe)}catch{}return Qe})}function ke(Ve){return A.$Nt.create(Ve.map(Qe=>typeof Qe=="string"?Qe:s.URI.revive(Qe)))}})(Bt||(e.DataTransferItem=Bt={}));var qt;(function(we){function Se(J,ke){const Ve=J.items.map(([Qe,qe])=>[Qe,Bt.to(Qe,qe,ke)]);return new h.$MN(Ve)}we.toDataTransfer=Se;async function oe(J){const ke={items:[]},Ve=[];for(const[Qe,qe]of J)Ve.push((async()=>{ke.items.push([Qe,await Bt.from(Qe,qe)])})());return await Promise.all(Ve),ke}we.from=oe})(qt||(e.DataTransfer=qt={}));var Ge;(function(we){function Se(J,ke){return{kind:"reply",agentId:J.participant??ke?.agentId??"",subCommand:J.command??ke?.command,message:J.prompt,title:J.label}}we.from=Se;function oe(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}we.to=oe})(Ge||(e.ChatFollowup=Ge={}));var ui;(function(we){function Se(oe){return"commandId"in oe?{kind:"command",title:oe.title??"",commandId:oe.commandId??"",when:oe.when??"",args:oe.args}:{kind:"reply",message:oe.message,title:oe.title,tooltip:oe.tooltip}}we.from=Se})(ui||(e.ChatInlineFollowup=ui={}));var Ht;(function(we){function Se(J){switch(J.role){case 0:return new h.$2O(J.content);case 1:return new h.$3O(J.content);case 2:return new h.$4O(J.content)}}we.to=Se;function oe(J){if(J instanceof h.$2O)return{role:0,content:J.content};if(J instanceof h.$3O)return{role:1,content:J.content};if(J instanceof h.$4O)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}we.from=oe})(Ht||(e.LanguageModelMessage=Ht={}));var zt;(function(we){function Se(ke){const Ve={};for(const Qe of Object.keys(ke))Ve[Qe]=ke[Qe].map(we.to);return Ve}we.objectTo=Se;function oe(ke){return{level:gt.to(ke.level),kind:ke.kind,value:(0,s.$wc)(ke.value)?s.URI.revive(ke.value):ke.value,description:ke.description}}we.to=oe;function J(ke){return{level:gt.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}we.from=J})(zt||(e.ChatVariable=zt={}));var gt;(function(we){function Se(J){switch(J){case"short":return h.ChatVariableLevel.Short;case"medium":return h.ChatVariableLevel.Medium;case"full":default:return h.ChatVariableLevel.Full}}we.to=Se;function oe(J){switch(J){case h.ChatVariableLevel.Short:return"short";case h.ChatVariableLevel.Medium:return"medium";case h.ChatVariableLevel.Full:default:return"full"}}we.from=oe})(gt||(e.ChatVariableLevel=gt={}));var Tt;(function(we){function Se(oe){switch(oe){case 1:return h.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return h.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return h.InteractiveEditorResponseFeedbackKind.Undone;case 3:return h.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return h.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Se})(Tt||(e.InteractiveEditorResponseFeedbackKind=Tt={}));var Rt;(function(we){function Se(J){return{kind:"markdownContent",content:K.from(J.value)}}we.from=Se;function oe(J){return new h.$QO(K.to(J.content))}we.to=oe})(Rt||(e.ChatResponseMarkdownPart=Rt={}));var Ft;(function(we){function Se(J){return{kind:"markdownVuln",content:K.from(J.value),vulnerabilities:J.vulnerabilities}}we.from=Se;function oe(J){return new h.$RO(K.to(J.content),J.vulnerabilities)}we.to=oe})(Ft||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ft={}));var ii;(function(we){function Se(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}we.from=Se;function oe(J){return new h.$SO(J.agentId,J.command)}we.to=oe})(ii||(e.ChatResponseDetectedParticipantPart=ii={}));var Gt;(function(we){function Se(J){const{value:ke,baseUri:Ve}=J;function Qe(qe,ut){return qe.map(Et=>{const Ot=s.URI.joinPath(ut,Et.name);return{label:Et.name,uri:Ot,children:Et.children&&Qe(Et.children,Ot)}})}return{kind:"treeData",treeData:{label:(0,v.$2g)(Ve),uri:Ve,children:Qe(ke,Ve)}}}we.from=Se;function oe(J){const ke=(0,E.$1h)(J.treeData);function Ve(ut){return ut.map(Et=>({name:Et.label,children:Et.children&&Ve(Et.children)}))}const Qe=ke.uri,qe=ke.children?Ve(ke.children):[];return new h.$TO(qe,Qe)}we.to=oe})(Gt||(e.ChatResponseFilesPart=Gt={}));var ni;(function(we){function Se(J){return{kind:"inlineReference",name:J.title,inlineReference:s.URI.isUri(J.value)?J.value:k.from(J.value)}}we.from=Se;function oe(J){const ke=(0,E.$1h)(J);return new h.$UO(s.URI.isUri(ke.inlineReference)?ke.inlineReference:k.to(ke.inlineReference),J.name)}we.to=oe})(ni||(e.ChatResponseAnchorPart=ni={}));var Nt;(function(we){function Se(J){return{kind:"progressMessage",content:K.from(J.value)}}we.from=Se;function oe(J){return new h.$VO(J.content.value)}we.to=oe})(Nt||(e.ChatResponseProgressPart=Nt={}));var At;(function(we){function Se(J,ke,Ve){return{kind:"command",command:ke.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}we.from=Se;function oe(J,ke){return new h.$WO(ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}we.to=oe})(At||(e.ChatResponseCommandButtonPart=At={}));var Ct;(function(we){function Se(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ke=>Me.from(ke))}}we.from=Se;function oe(J){return new h.$YO(s.URI.revive(J.uri),J.edits.map(ke=>Me.to(ke)))}we.to=oe})(Ct||(e.ChatResponseTextEditPart=Ct={}));var Dt;(function(we){function Se(J){return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:k.from(J.value.value)}}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:k.from(J.value)}}we.from=Se;function oe(J){const ke=(0,E.$1h)(J),Ve=Qe=>s.URI.isUri(Qe)?Qe:k.to(Qe);return new h.$XO("variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&Ve(ke.reference.value)}:Ve(ke.reference))}we.to=oe})(Dt||(e.ChatResponseReferencePart=Dt={}));var pt;(function(we){function Se(ke,Ve,Qe){return ke instanceof h.$QO?Rt.from(ke):ke instanceof h.$UO?ni.from(ke):ke instanceof h.$XO?Dt.from(ke):ke instanceof h.$VO?Nt.from(ke):ke instanceof h.$TO?Gt.from(ke):ke instanceof h.$WO?At.from(ke,Ve,Qe):ke instanceof h.$YO?Ct.from(ke):ke instanceof h.$RO?Ft.from(ke):ke instanceof h.$SO?ii.from(ke):{kind:"markdownContent",content:K.from("")}}we.from=Se;function oe(ke,Ve){switch(ke.kind){case"reference":return Dt.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ke,Ve)}}we.to=oe;function J(ke,Ve){switch(ke.kind){case"markdownContent":return Rt.to(ke);case"inlineReference":return ni.to(ke);case"progressMessage":return;case"treeData":return Gt.to(ke);case"command":return At.to(ke,Ve)}}we.toContent=J})(pt||(e.ChatResponsePart=pt={}));var St;(function(we){function Se(oe){return{prompt:oe.message,command:oe.command,attempt:oe.attempt??0,enableCommandDetection:oe.enableCommandDetection??!0,variables:oe.variables.variables.map(kt.to),location:li.to(oe.location)}}we.to=Se})(St||(e.ChatAgentRequest=St={}));var li;(function(we){function Se(oe){switch(oe){case l.ChatAgentLocation.Notebook:return h.ChatLocation.Notebook;case l.ChatAgentLocation.Terminal:return h.ChatLocation.Terminal;case l.ChatAgentLocation.Panel:return h.ChatLocation.Panel;case l.ChatAgentLocation.Editor:return h.ChatLocation.Editor}}we.to=Se})(li||(e.ChatLocation=li={}));var kt;(function(we){function Se(oe){return{name:oe.name,range:oe.range&&[oe.range.start,oe.range.endExclusive],values:oe.values.map(zt.to)}}we.to=Se})(kt||(e.ChatAgentResolvedVariable=kt={}));var hi;(function(we){function Se(oe,J,ke){return{label:oe.label,values:oe.values.map(zt.from),insertText:oe.insertText,detail:oe.detail,documentation:oe.documentation,command:J.toInternal(oe.command,ke)}}we.from=Se})(hi||(e.ChatAgentCompletionItem=hi={}));var Kt;(function(we){function Se(oe){return{errorDetails:oe.errorDetails,metadata:oe.metadata}}we.to=Se})(Kt||(e.ChatAgentResult=Kt={}));var vi;(function(we){function Se(oe,J,ke){if(J.action.kind==="vote")return;const Ve=Kt.to(oe);if(J.action.kind==="command"){const Qe=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(Qe)??{command:Qe.id,title:Qe.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:Ge.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}we.to=Se})(vi||(e.ChatAgentUserActionEvent=vi={}));var ei;(function(we){function Se(oe,J,ke){return"terminalCommand"in oe?{terminalCommand:oe.terminalCommand,shouldExecute:oe.shouldExecute}:"uri"in oe?{uri:oe.uri}:J.toInternal(oe,ke)}we.from=Se})(ei||(e.TerminalQuickFix=ei={}));var wi;(function(we){function Se(oe){return{kind:yt.to(oe.kind)}}we.to=Se})(wi||(e.PartialAcceptInfo=wi={}));var yt;(function(we){function Se(oe){switch(oe){case 0:return h.PartialAcceptTriggerKind.Word;case 1:return h.PartialAcceptTriggerKind.Line;case 2:return h.PartialAcceptTriggerKind.Suggest;default:return h.PartialAcceptTriggerKind.Unknown}}we.to=Se})(yt||(e.PartialAcceptTriggerKind=yt={}));var $i;(function(we){function Se(oe,J){return{id:J,label:oe.label,description:oe.description,canEdit:oe.canEdit,collapsibleState:oe.collapsibleState||0,contextValue:oe.contextValue}}we.from=Se})($i||(e.DebugTreeItem=$i={}))}),define(Ce[251],Re([1,0,4,16,8,34]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;let M=class{constructor(f,E){this.a=f.getProxy(I.$SM.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>E.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(f,E,T){const y=new F.$ow(A.WorkspaceEdit.from(f,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,T?.isRefactoring??!1)}};e.$Nkc=M,e.$Nkc=M=Je([We(0,N.$fP)],M)}),define(Ce[252],Re([1,0,18,11,43,5,40,6,65,17,2,20,4,8,7,214,26]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=void 0;class r{constructor(l,i,$,a,b){this.j=l,this.k=i,this.l=$,this.m=a,this.n=b,this.b=f.$0d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(a){if(l.c){const b=new Error("Response stream has been closed");throw Error.captureStackTrace(b,a),b}};const l=this;this.b.reset();const $=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a)};this.g={markdown(a){i(this.markdown);const b=new m.$QO(a),h=v.ChatResponseMarkdownPart.from(b);return $(h),this},markdownWithVulnerabilities(a,b){i(this.markdown),b&&(0,o.$AG)(l.j,"chatParticipantAdditions");const h=new m.$RO(a,b),D=v.ChatResponseMarkdownWithVulnerabilitiesPart.from(h);return $(D),this},filetree(a,b){i(this.filetree);const h=new m.$TO(a,b),D=v.ChatResponseFilesPart.from(h);return $(D),this},anchor(a,b){i(this.anchor);const h=new m.$UO(a,b),D=v.ChatResponseAnchorPart.from(h);return $(D),this},button(a){i(this.anchor);const b=new m.$WO(a),h=v.ChatResponseCommandButtonPart.from(b,l.m,l.n);return $(h),this},progress(a){i(this.progress);const b=new m.$VO(a),h=v.ChatResponseProgressPart.from(b);return $(h),this},reference(a){if(i(this.reference),"variableName"in a&&!a.value){const b=l.k.variables.variables.find(h=>h.name===a.variableName);if(b){let h;if(b.references?.length)h=b.references.map(D=>({kind:"reference",reference:{variableName:a.variableName,value:D.reference}}));else{const D=new m.$XO(a);h=[v.ChatResponseReferencePart.from(D)]}return h.forEach(D=>$(D)),this}}else{const b=new m.$XO(a),h=v.ChatResponseReferencePart.from(b);$(h)}return this},textEdit(a,b){i(this.textEdit),(0,o.$AG)(l.j,"chatParticipantAdditions");const h=new m.$YO(a,b),D=v.ChatResponseTextEditPart.from(h);return $(D),this},detectedParticipant(a,b){i(this.detectedParticipant),(0,o.$AG)(l.j,"chatParticipantAdditions");const h=new m.$SO(a,b),D=v.ChatResponseDetectedParticipantPart.from(h);return $(D),this},push(a){if(i(this.push),(a instanceof m.$YO||a instanceof m.$RO||a instanceof m.$SO)&&(0,o.$AG)(l.j,"chatParticipantAdditions"),a instanceof m.$XO)this.reference(a.value);else{const b=v.ChatResponsePart.from(a,l.m,l.n);$(b)}return this}}}return this.g}}class n extends p.$Uc{static{this.b=0}constructor(l,i,$){super(),this.n=i,this.s=$,this.c=new Map,this.j=this.B(new p.$4c),this.m=this.B(new p.$Tc),this.g=l.getProxy(u.$SM.MainThreadChatAgents2)}transferActiveChat(l){this.g.$transferActiveChatSession(l)}createChatAgent(l,i,$){const a=n.b++,b=new t(l,i,this.g,a,$);return this.c.set(a,b),this.g.$registerAgent(a,l.identifier,i,{},void 0),b.apiAgent}createDynamicChatAgent(l,i,$,a,b){const h=n.b++,D=new t(l,i,this.g,h,b);return this.c.set(h,D),this.g.$registerAgent(h,l.identifier,i,{isSticky:!0},{name:$,description:a}),D.apiAgent}async $invokeAgent(l,i,$,a){const b=this.c.get(l);if(!b)throw new Error(`[CHAT](${l}) CANNOT invoke agent because the agent is not registered`);let h=this.j.get(i.sessionId);h||(h=new p.$Tc,this.j.set(i.sessionId,h));const D=new r(b.extension,i,this.g,this.s.converter,h);try{const d=await this.t(i.agentId,$),k=b.invoke(v.ChatAgentRequest.to(i),{history:d},D.apiObject,a);return await(0,N.$fh)(Promise.resolve(k).then(g=>{if(g?.metadata)try{JSON.stringify(g.metadata)}catch(S){const w=`result.metadata MUST be JSON.stringify-able. Got error: ${S.message}`;return this.n.error(`[${b.extension.identifier.value}] [@${b.id}] ${w}`,b.extension),{errorDetails:{message:w},timings:D.timings}}return{errorDetails:g?.errorDetails,timings:D.timings,metadata:g?.metadata}}),a)}catch(d){return this.n.error(d,b.extension),{errorDetails:{message:(0,A.$cj)(d),responseIsIncomplete:!0}}}finally{D.close()}}async t(l,i){const $=[];for(const a of i.history){const b=v.ChatAgentResult.to(a.result),h=l===a.request.agentId?b:{...b,metadata:void 0};$.push(new m.$ZO(a.request.message,a.request.command,a.request.variables.variables.map(v.ChatAgentResolvedVariable.to),a.request.agentId));const D=(0,I.$Hb)(a.response.map(d=>v.ChatResponsePart.toContent(d,this.s.converter)));$.push(new m.$1O(D,h,a.request.agentId,a.request.command))}return $}$releaseSession(l){this.j.deleteAndDispose(l)}async $provideFollowups(l,i,$,a,b){const h=this.c.get(i);if(!h)return Promise.resolve([]);const D=await this.t(h.id,a),d=v.ChatAgentResult.to($);return(await h.provideFollowups(d,{history:D},b)).filter(k=>{const g=!k.participant||M.Iterable.some(this.c.values(),S=>S.id===k.participant&&y.$Mm.equals(S.extension.identifier,h.extension.identifier));return g||this.n.warn(`[@${h.id}] ChatFollowup refers to an unknown participant: ${k.participant}`),g}).map(k=>v.ChatFollowup.from(k,l))}$acceptFeedback(l,i,$,a){const b=this.c.get(l);if(!b)return;const h=v.ChatAgentResult.to(i);let D;switch($){case s.InteractiveSessionVoteDirection.Down:D=m.ChatResultFeedbackKind.Unhelpful;break;case s.InteractiveSessionVoteDirection.Up:D=m.ChatResultFeedbackKind.Helpful;break}b.acceptFeedback(Object.freeze(a?{result:h,kind:D,reportIssue:a}:{result:h,kind:D}))}$acceptAction(l,i,$){const a=this.c.get(l);if(!a||$.action.kind==="vote")return;const b=v.ChatAgentUserActionEvent.to(i,$,this.s.converter);b&&a.acceptAction(Object.freeze(b))}async $invokeCompletionProvider(l,i,$){const a=this.c.get(l);return a?(await a.invokeCompletionProvider(i,$)).map(h=>v.ChatAgentCompletionItem.from(h,this.s.converter,this.m)):[]}async $provideWelcomeMessage(l,i,$){const a=this.c.get(l);if(a)return await a.provideWelcomeMessage(v.ChatLocation.to(i),$)}async $provideSampleQuestions(l,i,$){const a=this.c.get(l);if(a)return(await a.provideSampleQuestions(v.ChatLocation.to(i),$)).map(b=>v.ChatFollowup.from(b,void 0))}}e.$Okc=n;class t{constructor(l,i,$,a,b){this.extension=l,this.id=i,this.u=$,this.w=a,this.x=b,this.n=new F.$be,this.o=new F.$be}acceptFeedback(l){this.n.fire(l)}acceptAction(l){this.o.fire(l)}async invokeCompletionProvider(l,i){return this.q?await this.q.provider.provideCompletionItems(l,i)??[]:[]}async provideFollowups(l,i,$){if(!this.b)return[];const a=await this.b.provideFollowups(l,i,$);return a?a.filter(b=>!(b&&"commandId"in b)).filter(b=>!(b&&"message"in b)):[]}async provideWelcomeMessage(l,i){if(!this.s)return[];const $=await this.s.provideWelcomeMessage(l,i);return $?$.map(a=>typeof a=="string"?a:v.MarkdownString.from(a)):[]}async provideSampleQuestions(l,i){if(!this.s||!this.s.provideSampleQuestions)return[];const $=await this.s.provideSampleQuestions(l,i);return $||[]}get apiAgent(){let l=!1,i=!1;const $=()=>{l||i||(i=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof m.$QN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:v.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),i=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,o.$AG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName(b){(0,o.$AG)(a.extension,"defaultChatParticipant"),a.c=b,$()},get iconPath(){return a.d},set iconPath(b){a.d=b,$()},get requestHandler(){return a.x},set requestHandler(b){(0,E.$cg)(typeof b=="function","Invalid request handler"),a.x=b},get followupProvider(){return a.b},set followupProvider(b){a.b=b,$()},get isDefault(){return(0,o.$AG)(a.extension,"defaultChatParticipant"),a.g},set isDefault(b){(0,o.$AG)(a.extension,"defaultChatParticipant"),a.g=b,$()},get helpTextPrefix(){return(0,o.$AG)(a.extension,"defaultChatParticipant"),a.j},set helpTextPrefix(b){(0,o.$AG)(a.extension,"defaultChatParticipant"),a.j=b,$()},get helpTextVariablesPrefix(){return(0,o.$AG)(a.extension,"defaultChatParticipant"),a.k},set helpTextVariablesPrefix(b){(0,o.$AG)(a.extension,"defaultChatParticipant"),a.k=b,$()},get helpTextPostfix(){return(0,o.$AG)(a.extension,"defaultChatParticipant"),a.l},set helpTextPostfix(b){(0,o.$AG)(a.extension,"defaultChatParticipant"),a.l=b,$()},get isSecondary(){return(0,o.$AG)(a.extension,"defaultChatParticipant"),a.m},set isSecondary(b){(0,o.$AG)(a.extension,"defaultChatParticipant"),a.m=b,$()},get supportIssueReporting(){return(0,o.$AG)(a.extension,"chatParticipantAdditions"),a.p},set supportIssueReporting(b){(0,o.$AG)(a.extension,"chatParticipantAdditions"),a.p=b,$()},get onDidReceiveFeedback(){return a.n.event},set participantVariableProvider(b){if((0,o.$AG)(a.extension,"chatParticipantAdditions"),a.q=b,b){if(!b.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,b.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,o.$AG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(b){(0,o.$AG)(a.extension,"defaultChatParticipant"),a.s=b,$()},get welcomeMessageProvider(){return(0,o.$AG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,o.$zG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(b){a.t=b,$()},get requester(){return a.t},dispose(){l=!0,a.b=void 0,a.n.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(l,i,$,a){return this.x(l,i,$,a)}}}),define(Ce[253],Re([1,0,14,6,4,8,7,26]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class f{static{this.a=0}constructor(y){this.b=new Map,this.c=y.getProxy(A.$SM.MainThreadChatVariables)}async $resolveVariable(y,u,v,m){const s=this.b.get(y);if(s)try{if(s.resolver.resolve2){(0,p.$AG)(s.extension,"chatParticipantAdditions");const o=new E(u,this.c),r=await s.resolver.resolve2(s.data.name,{prompt:v},o.apiObject,m);if(r)return r.map(F.ChatVariable.from)}else{const o=await s.resolver.resolve(s.data.name,{prompt:v},m);if(o)return o.map(F.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(y,u,v,m){const s=f.a++;return this.b.set(s,{extension:y,data:{name:u,description:v},resolver:m}),this.c.$registerVariable(s,{name:u,description:v}),(0,N.$Sc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$Pkc=f;class E{constructor(y,u){this.c=y,this.d=u,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let u=function(m){if(y.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,m),s}};const y=this,v=m=>{this.d.$handleProgressChunk(this.c,m)};this.b={progress(m){u(this.progress);const s=new M.$VO(m),o=F.ChatResponseProgressPart.from(s);return v(o),this},reference(m){u(this.reference);const s=new M.$XO(m),o=F.ChatResponseReferencePart.from(s);return v(o),this},push(m){return u(this.push),m instanceof M.$XO?v(F.ChatResponseReferencePart.from(m)):m instanceof M.$VO&&v(F.ChatResponseProgressPart.from(m)),this}}}return this.b}}}),define(Ce[254],Re([1,0,11,68,5,6,2,87,20,8,7,4,26]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=v;function v(m,s,o){const r=m.getProxy(y.$SM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$Om,s.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const k=this.b.get(d.handle);return k?k.value:d}else if(d&&d.$mid===7){const k=d,g=this.b.get(k.commentControlHandle);if(!g)return k;const S=g.getCommentThread(k.commentThreadHandle);return S?S.value:k}else if(d&&(d.$mid===9||d.$mid===8)){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const g=k.getCommentThread(d.thread.commentThreadHandle);return g?d.$mid===8?g.value:{thread:g.value,text:d.text}:d}else if(d&&d.$mid===10){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const g=k.getCommentThread(d.thread.commentThreadHandle);if(!g)return d;const S=d.commentUniqueId,w=g.getCommentByUniqueId(S);return w||d}else if(d&&d.$mid===11){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const g=k.getCommentThread(d.thread.commentThreadHandle);if(!g)return d;const S=d.text,w=d.commentUniqueId,C=g.getCommentByUniqueId(w);return C?(typeof C.body=="string"?C.body=S:C.body=new T.$jN(S),C):d}return d}})}createCommentController(d,k,g){const S=n.a++,w=new c(d,S,k,g);this.b.set(w.handle,w);const C=this.c.get(d.identifier)||[];return C.push(w),this.c.set(d.identifier,C),w.value}async $createCommentThreadTemplate(d,k,g){const S=this.b.get(d);S&&S.$createCommentThreadTemplate(k,g)}async $setActiveComment(d,k){const g=this.b.get(d);g&&g.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(d,k,g){const S=this.b.get(d);S&&S.$updateCommentThreadTemplate(k,g)}$deleteCommentThread(d,k){this.b.get(d)?.$deleteCommentThread(k)}async $provideCommentingRanges(d,k,g){const S=this.b.get(d);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const w=await o.ensureDocumentData(M.URI.revive(k));return(0,I.$jh)(async()=>{const C=await S.commentingRangeProvider.provideCommentingRanges(w.document,g);let P;return Array.isArray(C)?P={ranges:C,fileComments:!1}:C?P={ranges:C.ranges||[],fileComments:C.fileComments||!1}:P=C??void 0,P}).then(C=>{let P;return C&&(P={ranges:C.ranges.map(W=>E.Range.from(W)),fileComments:C.fileComments}),P})}$toggleReaction(d,k,g,S,w){const C=this.b.get(d);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,I.$jh)(()=>{const P=C.getCommentThread(k);if(P){const W=P.getCommentByUniqueId(S.uniqueIdInThread);if(C!==void 0&&W&&C.reactionHandler)return C.reactionHandler(W,$(w))}return Promise.resolve(void 0)})}}class t{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,typeof d=="object"?((0,u.$AG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=d.resolved,this.b.applicability=d.applicability):this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,k,g,S,w,C,P,W){this.m=k,this.n=g,this.o=S,this.p=w,this.q=C,this.extensionDescription=P,this.r=W,this.handle=t.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$be,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Vc,this.l.value=new F.$Tc,this.n===void 0&&(this.n=`${d}.${this.handle}`),r.$createCommentThread(k,this.handle,this.n,this.o,E.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{r.$deleteCommentThread(k,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(q){V.range=q},get comments(){return V.comments},set comments(q){V.comments=q},get collapsibleState(){return V.collapsibleState},set collapsibleState(q){V.collapsibleState=q},get canReply(){return V.canReply},set canReply(q){V.canReply=q},get contextValue(){return V.contextValue},set contextValue(q){V.contextValue=q},get label(){return V.label},set label(q){V.label=q},get state(){return V.state},set state(q){V.state=q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Tc);const d=g=>Object.prototype.hasOwnProperty.call(this.b,g),k={};d("range")&&(k.range=E.Range.from(this.p)),d("label")&&(k.label=this.label),d("contextValue")&&(k.contextValue=this.contextValue??null),d("comments")&&(k.comments=this.q.map(g=>l(this,g,this.k,this.extensionDescription))),d("collapsibleState")&&(k.collapseState=a(this.g)),d("canReply")&&(k.canReply=this.canReply),d("state")&&(k.state=b(this.h)),d("applicability")&&(k.applicability=h(this.h)),d("isTemplate")&&(k.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(d){for(const k of this.k){const g=k[0],S=k[1];if(d===S)return g}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Je([(0,N.$Wh)(100)],t.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,d?.resourceHints&&(0,u.$AG)(this.h,"commentingRangeHint"),r.$updateCommentingRanges(this.handle,d?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,u.$AG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,u.$AG)(this.h,"activeComment"),this.f}constructor(d,k,g,S){this.h=d,this.i=k,this.j=g,this.k=S,this.a=new Map,r.$registerCommentController(this.handle,g,S,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(C){w.options=C},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(C){w.commentingRangeProvider=C},get reactionHandler(){return w.reactionHandler},set reactionHandler(C){w.reactionHandler=C},get activeCommentThread(){return w.activeCommentThread},createCommentThread(C,P,W){return w.createCommentThread(C,P,W).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(d,k,g){k===void 0&&(0,u.$AG)(this.h,"fileComments");const S=new t(this.id,this.handle,void 0,d,k,g,this.h,!1);return this.a.set(S.handle,S),S}$setActiveComment(d){if(!d){this.e=void 0,this.f=void 0;return}const k=this.a.get(d.commentThreadHandle);k&&(this.e=d.uniqueIdInThread?k.getCommentByUniqueId(d.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(d,k){const g=new t(this.id,this.handle,void 0,M.URI.revive(d),E.Range.to(k),[],this.h,!0);return g.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(d,k){const g=this.a.get(d);g&&(g.range=E.Range.to(k))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.g.forEach(d=>d.dispose())}}function l(D,d,k,g){let S=k.get(d);return S||(S=++D.commentHandle,k.set(d,S)),d.state!==void 0&&(0,u.$AG)(g,"commentsDraftState"),d.reactions?.some(w=>w.reactors!==void 0)&&(0,u.$AG)(g,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:S,body:typeof d.body=="string"?d.body:E.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(w=>i(w)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function i(D){return{label:D.label,iconPath:D.iconPath?E.$eP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(d=>d.name):D.reactors}}function $(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?M.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(d=>({name:d}))}}function a(D){if(D!==void 0)switch(D){case T.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function b(D){let d;if(typeof D=="object"?d=D.resolved:d=D,d!==void 0)switch(d){case T.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function h(D){let d;if(typeof D=="object"&&(d=D.applicability),d!==void 0)switch(d){case T.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(Ce[255],Re([1,0,24,99,6,12,23,2,8,63,74,4,7]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;class v{constructor($,a){this.document=$,this.b=a,this.a=1,this.c=new T.$zkc("custom documents")}addEdit($){return this.c.add([$])}async undo($,a){await this.f($).undo(),a||this.disposeBackup()}async redo($,a){await this.f($).redo(),a||this.disposeBackup()}disposeEdits($){for(const a of $)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const $=l(this.document.uri)+this.a++;return(0,M.$5g)(this.b,$)}updateBackup($){this.d?.delete(),this.d=$}disposeBackup(){this.d?.delete(),this.d=void 0}f($){const a=this.c.get($,0);if(!a)throw new Error("No edit found");return a}}class m{constructor(){this.a=new Map}get($,a){return this.a.get(this.b($,a))}add($,a,b){const h=this.b($,a.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${$} resource:${a.uri}`);const D=new v(a,b);return this.a.set(h,D),D}delete($,a){const b=this.b($,a.uri);this.a.delete(b)}b($,a){return`${$}@@@${a}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider($,a,b){return this.b(0,$,a,b)}addCustomProvider($,a,b){return this.b(1,$,a,b)}get($){return this.a.get($)}b($,a,b,h){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:$,extension:b,provider:h}),new u.$UM(()=>this.a.delete(a))}}class r{constructor($,a,b,h,D){this.d=a,this.f=b,this.g=h,this.h=D,this.b=new o,this.c=new m,this.a=$.getProxy(y.$SM.MainThreadCustomEditors)}registerCustomEditorProvider($,a,b,h){const D=new A.$Tc;return t(b)?(D.add(this.b.addTextProvider(a,$,b)),this.a.$registerTextEditorProvider((0,E.$9kc)($),a,h.webviewOptions||{},{supportsMove:!!b.moveCustomTextEditor},(0,E.$7kc)($))):(D.add(this.b.addCustomProvider(a,$,b)),n(b)&&D.add(b.onDidChangeCustomDocument(d=>{const k=this.i(a,d.document.uri);if(c(d)){const g=k.addEdit(d);this.a.$onDidEdit(d.document.uri,a,g,d.label)}else this.a.$onContentChange(d.document.uri,a)})),this.a.$registerCustomEditorProvider((0,E.$9kc)($),a,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,E.$7kc)($))),u.$UM.from(D,new u.$UM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument($,a,b,h,D){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${a}'`);const k=p.URI.revive($),g=await d.provider.openCustomDocument(k,{backupId:b,untitledDocumentData:h?.buffer},D);let S;return n(d.provider)&&this.f&&(S=this.f.workspaceValue(d.extension)??this.f.globalValue(d.extension)),this.c.add(a,g,S),{editable:n(d.provider)}}async $disposeCustomDocument($,a){const b=this.b.get(a);if(!b)throw new Error(`No provider found for '${a}'`);if(b.type!==1)throw new Error(`Invalid provider type for '${a}'`);const h=p.URI.revive($),{document:D}=this.i(a,h);this.c.delete(a,D),D.dispose()}async $resolveCustomEditor($,a,b,h,D,d){const k=this.b.get(b);if(!k)throw new Error(`No provider found for '${b}'`);const g=f.ViewColumn.to(D),S=this.g.createNewWebview(a,h.contentOptions,k.extension),w=this.h.createNewWebviewPanel(a,b,h.title,g,h.options,S,h.active),C=p.URI.revive($);switch(k.type){case 1:{const{document:P}=this.i(b,C);return k.provider.resolveCustomEditor(P,w,d)}case 0:{const P=this.d.getDocument(C);return k.provider.resolveCustomTextEditor(P,w,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits($,a,b){this.i(a,$).disposeEdits(b)}async $onMoveCustomEditor($,a,b){const h=this.b.get(b);if(!h)throw new Error(`No provider found for '${b}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${b}'`);const D=this.h.getWebviewPanel($);if(!D)throw new Error("No webview found");const d=p.URI.revive(a),k=this.d.getDocument(d);await h.provider.moveCustomTextEditor(k,D,I.CancellationToken.None)}async $undo($,a,b,h){return this.i(a,$).undo(b,h)}async $redo($,a,b,h){return this.i(a,$).redo(b,h)}async $revert($,a,b){const h=this.i(a,$);await this.j(a).revertCustomDocument(h.document,b),h.disposeBackup()}async $onSave($,a,b){const h=this.i(a,$);await this.j(a).saveCustomDocument(h.document,b),h.disposeBackup()}async $onSaveAs($,a,b,h){const D=this.i(a,$);return this.j(a).saveCustomDocumentAs(D.document,p.URI.revive(b),h)}async $backup($,a,b){const h=this.i(a,$),d=await this.j(a).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},b);return h.updateBackup(d),d.id}i($,a){const b=this.c.get($,p.URI.revive(a));if(!b)throw new Error("No custom document found");return b}j($){const b=this.b.get($)?.provider;if(!b||!n(b))throw new Error("Custom document is not editable");return b}}e.$_kc=r;function n(i){return!!i.onDidChangeCustomDocument}function t(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function l(i){const $=i.scheme===F.Schemas.file||i.scheme===F.Schemas.untitled?i.fsPath:i.toString();return(0,N.$fj)($)+""}}),define(Ce[256],Re([1,0,163,100,2,4,7,8,5,13,28,45]),function(ge,e,I,N,A,F,M,p,f,E,T,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=e.$Gkc=void 0;class v{#e;#t;#i;constructor(o,r,n,t,c,l,i,$){this.d=o,this.e=r,this.f=n,this.g=t,this.h=c,this.c=!1,this.f=Math.max(t,n),this.#i=new T.$Bc(a=>l.getComparisonKey(a)),this.#e=i,this.#t=$}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,r){if(!o){this.clear();return}this.j();let n=[];if(A.URI.isUri(o)){if(!r){this.delete(o);return}this.#i.set(o,r.slice()),n=[o]}else if(Array.isArray(o)){n=[];let l;o=[...o].sort(v.k);for(const i of o){const[$,a]=i;if((!l||$.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=$,n.push($),this.#i.set($,[])),a)this.#i.get($)?.push(...a);else{const b=this.#i.get($);b&&(b.length=0)}}}if(this.#t.fire(n),!this.#e)return;const t=[];let c=0;for(const l of n){let i=[];const $=this.#i.get(l);if($)if($.length>this.g){i=[];const a=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let b=0;b<4;b++)for(const h of $)if(h.severity===a[b]&&i.push({...p.Diagnostic.from(h),modelVersionId:this.h(l)})===this.g)break e;i.push({severity:N.MarkerSeverity.Info,message:(0,I.localize)(0,null,$.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=$.map(a=>({...p.Diagnostic.from(a),modelVersionId:this.h(l)}));if(t.push([l,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,t)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,r){this.j();for(const[n,t]of this)o.call(r,n,t,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const r=this.#i.get(o);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,r){return o[0].toString()<r[0].toString()?-1:o[0].toString()>r[0].toString()?1:0}}e.$Gkc=v;let m=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const r=new T.$Bc;for(const n of o)r.set(n,n);return{uris:Object.freeze(Array.from(r.values()))}}constructor(o,r,n,t){this.j=r,this.k=n,this.l=t,this.g=new Map,this.h=new f.$fe({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,u._mapper),this.f=o.getProxy(F.$SM.MainThreadDiagnostics)}createDiagnosticCollection(o,r){const{g:n,f:t,h:c,j:l,k:i,l:$}=this,a=new class{$changeMany(D,d){t.$changeMany(D,d),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,D,d.length===0?"CLEARING":d)}$clear(D){t.$clear(D),l.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,D)}dispose(){t.dispose()}};let b;if(!r)r="_generated_diagnostic_collection_name_#"+u.c++,b=r;else if(!n.has(r))b=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do b=r+u.c++;while(n.has(b))}return new class extends v{constructor(){super(r,b,u.e,u.d,D=>$.getDocument(D)?.version,i.extUri,a,c),n.set(b,this)}dispose(){super.dispose(),n.delete(b)}}}getDiagnostics(o){if(o)return this.m(o);{const r=new Map,n=[];for(const t of this.g.values())t.forEach((c,l)=>{let i=r.get(c.toString());typeof i>"u"&&(i=n.length,r.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...l)});return n}}m(o){let r=[];for(const n of this.g.values())n.has(o)&&(r=r.concat(n.get(o)));return r}$acceptMarkersChange(o){if(!this.n){const r="_generated_mirror",n=new v(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(r,n),this.n=n}for(const[r,n]of o)this.n.set(A.URI.revive(r),n.map(p.Diagnostic.to))}};e.$Hkc=m,e.$Hkc=m=u=Je([We(1,E.$Xj),We(2,y.$Fkc)],m)}),define(Ce[257],Re([1,0,2,14,7,8,192,34]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=void 0;class f{constructor(T,y,u,v={timeout:1500,errors:3}){this.c=T,this.d=y,this.f=u,this.g=v,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(y,u,v)=>{const s={dispose:this.a.push([y,u,T])};return Array.isArray(v)&&v.push(s),s}}async $participateInSave(T,y){const u=I.URI.revive(T);let v=!1;const m=setTimeout(()=>v=!0,this.g.timeout),s=[];try{for(const o of[...this.a]){if(v)break;const r=this.d.getDocument(u),n=await this.h(o,{document:r,reason:F.TextDocumentSaveReason.to(y)});s.push(n)}}finally{clearTimeout(m)}return s}h([T,y,u],v){const m=this.b.get(T);return typeof m=="number"&&m>this.g.errors?Promise.resolve(!1):this.i(u,T,y,v).then(()=>!0,s=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const o=this.b.get(T);this.b.set(T,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,y,u,v){const m=[],s=Date.now(),{document:o,reason:r}=v,{version:n}=o,t=Object.freeze({document:o,reason:r,waitUntil(c){if(Object.isFrozen(m))throw(0,N.$8)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{y.apply(u,[t])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,l)=>{const i=setTimeout(()=>l(new Error("timeout")),this.g.timeout);return Promise.all(m).then($=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(i),c($)}).catch($=>{clearTimeout(i),l($)})}).then(c=>{const l={edits:[]};for(const i of c)if(Array.isArray(i)&&i.every($=>$ instanceof A.$2M))for(const{newText:$,newEol:a,range:b}of i)l.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:b&&F.Range.from(b),text:$,eol:a&&F.EndOfLine.from(a)}});if(l.edits.length!==0)return n===o.version?this.f.$tryApplyWorkspaceEdit(new p.$ow(l)):Promise.reject(new Error("concurrent_edits"))})}}e.$Plc=f}),define(Ce[258],Re([1,0,5,6,2,4,111,8,17,25,7]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=void 0;class y{constructor(v,m){this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=v.getProxy(F.$SM.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const m=this.g.getDocument(v);if(m)return m}getDocument(v){const m=this.getDocumentData(v);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return m.document}ensureDocumentData(v){const m=this.g.getDocument(v);if(m)return Promise.resolve(m);let s=this.h.get(v.toString());return s||(s=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const r=A.URI.revive(o);return(0,f.$dg)(this.g.getDocument(r))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),s)),s}createDocumentData(v){return this.f.$tryCreateDocument(v).then(m=>A.URI.revive(m))}$acceptModelLanguageChanged(v,m){const s=A.URI.revive(v),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(v){const m=A.URI.revive(v),s=this.g.getDocument(m);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(v,m){const s=A.URI.revive(v),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,m,s){const o=A.URI.revive(v),r=this.g.getDocument(o);if(!r)throw new Error("unknown document");r._acceptIsDirty(s),r.onEvents(m);let n;m.isUndoing?n=T.TextDocumentChangeReason.Undo:m.isRedoing&&(n=T.TextDocumentChangeReason.Redo),this.c.fire((0,E.$Yn)({document:r.document,contentChanges:m.changes.map(t=>({range:p.Range.to(t.range),rangeOffset:t.rangeOffset,rangeLength:t.rangeLength,text:t.text})),reason:n}))}setWordDefinitionFor(v,m){(0,M.$hP)(v,m)}}e.$Ikc=y}),define(Ce[66],Re([1,0,259,5,17,2,3,4,16,8,7]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=e.$alc=void 0,e.$alc=(0,M.$ri)("IExtHostEditorTabs");class y{constructor(o,r,n){this.e=n,this.d=r,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,r={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$EO(F.URI.revive(this.b.input.uri));case 2:return new T.$FO(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified));case 3:return new T.$GO(F.URI.revive(this.b.input.base),F.URI.revive(this.b.input.input1),F.URI.revive(this.b.input.input2),F.URI.revive(this.b.input.result));case 6:return new T.$HO(F.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$IO(this.b.input.viewType);case 4:return new T.$JO(F.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$KO(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$LO;case 9:return new T.$MO(F.URI.revive(this.b.input.uri),F.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$NO;case 11:return new T.$OO(this.b.input.diffEditors.map(o=>new T.$FO(F.URI.revive(o.original),F.URI.revive(o.modified))));default:return}}}class u{constructor(o,r){this.c=[],this.d="",this.b=o,this.e=r;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new y(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,r={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return E.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const r=this.c.find(n=>n.tabId===o.tabDto.id);if(!r)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(o.tabDto),r}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new N.$be,this.c=new N.$be,this.e=[],this.a=o.getProxy(p.$SM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,r={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,A.$dg)(o.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,t)=>{const c=Array.isArray(n)?n:[n];return c.length?m(c[0])?this.j(c,t):this.i(c,t):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(o){const r=new Set(this.e.map(a=>a.groupId)),n=new Set(o.map(a=>a.groupId)),t=(0,I.$L)(r,n),c=this.e.filter(a=>t.removed.includes(a.groupId)).map(a=>a.apiObject),l=[],i=[];this.e=o.map(a=>{const b=new u(a,()=>this.d);return t.added.includes(b.groupId)?l.push(b.apiObject):i.push(b.apiObject),b});const $=(0,A.$dg)(o.find(a=>a.isActive===!0)?.groupId);$!==void 0&&this.d!==$&&(this.d=$),this.c.fire(Object.freeze({opened:l,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const r=this.e.find(n=>n.groupId===o.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const r=this.e.find(t=>t.groupId===o.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const n=r.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const r of this.e)for(const n of r.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(r=>r.apiObject===o)}async i(o,r){const n=[];for(const t of o){const c=this.g(t);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,r)}async j(o,r){const n=[];for(const t of o){const c=this.h(t);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,r)}};e.$blc=v,e.$blc=v=Je([We(0,f.$fP)],v);function m(s){return s.tabs!==void 0}}),define(Ce[260],Re([1,0,2,4,6,7,8,303,15,22,26,54]),function(ge,e,I,N,A,F,M,p,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=void 0;class u{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const o=this.a.indexOf(s);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),o=[];let r,n,t=14,c=14;for(const l of s){let i=r?(0,f.$wf)(r,l):0;for(i===0?n=1:n=c;i<l.length;i++)i+1===l.length?(t=c,c=9):c+=1,o.push([n,l.toUpperCase().charCodeAt(i),c]),o.push([n,l.toLowerCase().charCodeAt(i),c]),n=c;r=l,c=t}o.push([9,58,10]),o.push([10,47,12]),this.b=new p.$62(o)}}provideDocumentLinks(s){this.c();const o=[],r=p.$72.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this.b);for(const n of r){const t=M.DocumentLink.to(n);t.target&&o.push(t)}return o}}class v{constructor(s,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(N.$SM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,o,r,n={}){if(v.j(r),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const t=this.h++;this.b.add(o),this.d.add(o),this.c.set(t,r);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof r.copy=="function"&&(c+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,T.$AG)(s,"fsChunks"),c+=4);let l;n.isReadonly&&(0,y.$Qk)(n.isReadonly)&&n.isReadonly.value!==""&&(l={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,o,c,l).catch($=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${o}`),console.error($)});const i=r.onDidChangeFile($=>{const a=[];for(const b of $){const{uri:h,type:D}=b;if(h.scheme!==o)continue;let d;switch(D){case F.FileChangeType.Changed:d=0;break;case F.FileChangeType.Created:d=1;break;case F.FileChangeType.Deleted:d=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:h,type:d})}this.a.$onFileSystemChange(t,a)});return(0,A.$Sc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:o,ctime:r,mtime:n,size:t,permissions:c}=s;return{type:o,ctime:r,mtime:n,size:t,permissions:c}}$stat(s,o){return Promise.resolve(this.l(s).stat(I.URI.revive(o))).then(r=>v.k(r))}$readdir(s,o){return Promise.resolve(this.l(s).readDirectory(I.URI.revive(o)))}$readFile(s,o){return Promise.resolve(this.l(s).readFile(I.URI.revive(o))).then(r=>E.$Ce.wrap(r))}$writeFile(s,o,r,n){return Promise.resolve(this.l(s).writeFile(I.URI.revive(o),r.buffer,n))}$delete(s,o,r){return Promise.resolve(this.l(s).delete(I.URI.revive(o),r))}$rename(s,o,r,n){return Promise.resolve(this.l(s).rename(I.URI.revive(o),I.URI.revive(r),n))}$copy(s,o,r,n){const t=this.l(s);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(I.URI.revive(o),I.URI.revive(r),n))}$mkdir(s,o){return Promise.resolve(this.l(s).createDirectory(I.URI.revive(o)))}$watch(s,o,r,n){const t=this.l(s).watch(I.URI.revive(r),n);this.f.set(o,t)}$unwatch(s,o){const r=this.f.get(o);r&&(r.dispose(),this.f.delete(o))}$open(s,o,r){const n=this.l(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(I.URI.revive(o),r))}$close(s,o){const r=this.l(s);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(o))}$read(s,o,r,n){const t=this.l(s);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$Ce.alloc(n);return Promise.resolve(t.read(o,r,c.buffer,0,n)).then(l=>c.slice(0,l))}$write(s,o,r,n){const t=this.l(s);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(o,r,n.buffer,0,n.byteLength))}l(s){const o=this.c.get(s);if(!o){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return o}}e.$Rlc=v}),define(Ce[261],Re([1,0,5,36,2,4,8,7,41]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,m,s,o,r,n){this.a=Math.random(),this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const t=(0,N.$lk)(r),c=typeof r=="string",l=n?.correlate,i=o($=>{if(!(typeof $.session=="number"&&$.session!==this.a)&&!(l&&typeof $.session>"u")){if(!n?.ignoreCreateEvents)for(const a of $.created){const b=A.URI.revive(a);t(b.fsPath)&&(!c||m.getWorkspaceFolder(b))&&this.b.fire(b)}if(!n?.ignoreChangeEvents)for(const a of $.changed){const b=A.URI.revive(a);t(b.fsPath)&&(!c||m.getWorkspaceFolder(b))&&this.c.fire(b)}if(!n?.ignoreDeleteEvents)for(const a of $.deleted){const b=A.URI.revive(a);t(b.fsPath)&&(!c||m.getWorkspaceFolder(b))&&this.d.fire(b)}}});this.g=p.$UM.from(this.i(v,s,r,n,n?.correlate),this.b,this.c,this.d,i)}i(v,m,s,o,r){const n=p.$UM.from();if(typeof s=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return n;const t=v.getProxy(F.$SM.MainThreadFileSystemEventService);let c=!1;(s.pattern.includes(N.$hk)||s.pattern.includes(N.$ik))&&(c=!0);let l;return r&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(l=14,o?.ignoreChangeEvents&&(l&=-3),o?.ignoreCreateEvents&&(l&=-5),o?.ignoreDeleteEvents&&(l&=-9)),t.$watch(m.identifier.value,this.a,s.baseUri,{recursive:c,excludes:o?.excludes??[],filter:l},!!r),p.$UM.from({dispose:()=>t.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(v){this.a=v,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(A.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(A.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class y{constructor(v,m,s){this.j=v,this.k=m,this.l=s,this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.g=new I.$de,this.h=new I.$de,this.i=new I.$de,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,m,s,o){return new E(this.j,v,m,this.a.event,M.GlobPattern.from(s),o)}$onFileEvent(v){this.a.fire(new T(v))}$onDidRunFileOperation(v,m){switch(v){case 2:this.b.fire(Object.freeze({files:m.map(s=>({oldUri:A.URI.revive(s.source),newUri:A.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(s=>A.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(s=>A.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,m){return(s,o,r)=>{const n=function(c){s.call(o,c)};return n.extension=v,m.event(n,void 0,r)}}async $onWillRunFileOperation(v,m,s,o){switch(v){case 2:return await this.n(this.g,{files:m.map(r=>({oldUri:A.URI.revive(r.source),newUri:A.URI.revive(r.target)}))},s,o);case 1:return await this.n(this.i,{files:m.map(r=>A.URI.revive(r.target))},s,o);case 0:case 3:return await this.n(this.h,{files:m.map(r=>A.URI.revive(r.target))},s,o)}}async n(v,m,s,o){const r=new Set,n=[];if(await v.fireAsync(m,o,async(c,l)=>{const i=Date.now(),$=await Promise.resolve(c);$ instanceof p.$5M&&(n.push([l.extension,$]),r.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-i>s&&this.k.warn("SLOW file-participant",l.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const t={edits:[]};for(const[,c]of n){const{edits:l}=M.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});t.edits=t.edits.concat(l)}return{edit:t,extensionNames:Array.from(r)}}}e.$Slc=y}),define(Ce[262],Re([1,0,18,11,24,14,90,6,25,65,15,17,2,29,304,87,97,165,20,8,7,26,74,4]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t,c,l,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=void 0;class a{constructor(U,z){this.d=U,this.e=z}async provideDocumentSymbols(U,z){const G=this.d.getDocument(U),H=await this.e.provideDocumentSymbols(G,z);if(!(0,I.$Kb)(H))return H[0]instanceof c.$bN?H.map(t.DocumentSymbol.from):a.f(H)}static f(U){U=U.slice(0).sort((H,ee)=>{let ne=H.location.range.start.compareTo(ee.location.range.start);return ne===0&&(ne=ee.location.range.end.compareTo(H.location.range.end)),ne});const z=[],G=[];for(const H of U){const ee={name:H.name||"!!MISSING: name!!",kind:t.SymbolKind.from(H.kind),tags:H.tags?.map(t.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:t.Range.from(H.location.range),selectionRange:t.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),z.push(ee);break}const ne=G[G.length-1];if(v.$nt.containsRange(ne.range,ee.range)&&!v.$nt.equalsRange(ne.range,ee.range)){ne.children?.push(ee),G.push(ee);break}G.pop()}}return z}}class b{constructor(U,z,G,H,ee,ne){this.f=U,this.g=z,this.h=G,this.j=H,this.k=ee,this.l=ne,this.d=new i.$zkc("CodeLens"),this.e=new Map}async provideCodeLenses(U,z){const G=this.f.getDocument(U),H=await this.h.provideCodeLenses(G,z);if(!H||z.isCancellationRequested)return;const ee=this.d.add(H),ne=new p.$Tc;this.e.set(ee,ne);const Fe={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Fe.lenses.push({cacheId:[ee,Be],range:t.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,ne)});return Fe}async resolveCodeLens(U,z){const G=U.cacheId&&this.d.get(...U.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,z),H||(H=G),z.isCancellationRequested)return;const ee=U.cacheId&&this.e.get(U.cacheId[0]);if(ee){if(!H.command){const ne=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ne),this.l.error(ne);return}return U.command=this.g.toInternal(H.command,ee),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function h(ze){return Array.isArray(ze)?ze.map(t.DefinitionLink.from):ze?[t.DefinitionLink.from(ze)]:[]}class D{constructor(U,z){this.d=U,this.e=z}async provideDefinition(U,z,G){const H=this.d.getDocument(U),ee=t.Position.to(z),ne=await this.e.provideDefinition(H,ee,G);return h(ne)}}class d{constructor(U,z){this.d=U,this.e=z}async provideDeclaration(U,z,G){const H=this.d.getDocument(U),ee=t.Position.to(z),ne=await this.e.provideDeclaration(H,ee,G);return h(ne)}}class k{constructor(U,z){this.d=U,this.e=z}async provideImplementation(U,z,G){const H=this.d.getDocument(U),ee=t.Position.to(z),ne=await this.e.provideImplementation(H,ee,G);return h(ne)}}class g{constructor(U,z){this.d=U,this.e=z}async provideTypeDefinition(U,z,G){const H=this.d.getDocument(U),ee=t.Position.to(z),ne=await this.e.provideTypeDefinition(H,ee,G);return h(ne)}}class S{constructor(U,z){this.d=U,this.e=z}async provideHover(U,z,G){const H=this.d.getDocument(U),ee=t.Position.to(z),ne=await this.e.provideHover(H,ee,G);if(!(!ne||(0,I.$Kb)(ne.contents)))return ne.range||(ne.range=H.getWordRangeAtPosition(ee)),ne.range||(ne.range=new c.$WM(ee,ee)),t.Hover.from(ne)}}class w{constructor(U,z){this.d=U,this.e=z}async provideEvaluatableExpression(U,z,G){const H=this.d.getDocument(U),ee=t.Position.to(z),ne=await this.e.provideEvaluatableExpression(H,ee,G);if(ne)return t.EvaluatableExpression.from(ne)}}class C{constructor(U,z){this.d=U,this.e=z}async provideInlineValues(U,z,G,H){const ee=this.d.getDocument(U),ne=await this.e.provideInlineValues(ee,t.Range.to(z),t.InlineValueContext.to(G),H);if(Array.isArray(ne))return ne.map(Fe=>t.InlineValue.from(Fe))}}class P{constructor(U,z){this.d=U,this.e=z}async provideDocumentHighlights(U,z,G){const H=this.d.getDocument(U),ee=t.Position.to(z),ne=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(ne))return ne.map(t.DocumentHighlight.from)}}class W{constructor(U,z){this.d=U,this.e=z}async provideMultiDocumentHighlights(U,z,G,H){const ee=this.d.getDocument(U),ne=G.map(Xe=>this.d.getDocument(Xe)),Fe=t.Position.to(z),Be=await this.e.provideMultiDocumentHighlights(ee,Fe,ne,H);if(Array.isArray(Be))return Be.map(t.MultiDocumentHighlight.from)}}class V{constructor(U,z){this.d=U,this.e=z}async provideLinkedEditingRanges(U,z,G){const H=this.d.getDocument(U),ee=t.Position.to(z),ne=await this.e.provideLinkedEditingRanges(H,ee,G);if(ne&&Array.isArray(ne.ranges))return{ranges:(0,I.$Hb)(ne.ranges.map(t.Range.from)),wordPattern:ne.wordPattern}}}class q{constructor(U,z){this.d=U,this.e=z}async provideReferences(U,z,G,H){const ee=this.d.getDocument(U),ne=t.Position.to(z),Fe=await this.e.provideReferences(ee,ne,G,H);if(Array.isArray(Fe))return Fe.map(t.location.from)}}class R{static{this.d=1e3}constructor(U,z,G,H,ee,ne,Fe){this.g=U,this.h=z,this.j=G,this.k=H,this.l=ee,this.m=ne,this.n=Fe,this.e=new i.$zkc("CodeAction"),this.f=new Map}async provideCodeActions(U,z,G,H){const ee=this.g.getDocument(U),ne=m.$pt.isISelection(z)?t.Selection.to(z):t.Range.to(z),Fe=[];for(const it of this.j.getDiagnostics(U))if(ne.intersection(it.range)&&Fe.push(it)>R.d)break;const Be={diagnostics:Fe,only:G.only?new c.$dN(G.only):void 0,triggerKind:t.CodeActionTriggerKind.to(G.trigger)},Xe=await this.k.provideCodeActions(ee,ne,Be,H);if(!(0,I.$Lb)(Xe)||H.isCancellationRequested)return;const _e=this.e.add(Xe),et=new p.$Tc;this.f.set(_e,et);const tt=[];for(let it=0;it<Xe.length;it++){const nt=Xe[it];if(nt)if(R.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,et)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=nt.ranges??[];tt.push({cacheId:[_e,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,et),diagnostics:nt.diagnostics&&nt.diagnostics.map(t.Diagnostic.from),edit:nt.edit&&t.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,l.$zG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,l.$zG)(this.m,"codeActionRanges")?(0,I.$Hb)(at.map(t.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:_e,actions:tt}}async resolveCodeAction(U,z){const[G,H]=U,ee=this.e.get(G,H);if(!ee||R.o(ee))return{};if(!this.k.resolveCodeAction)return{};const ne=await this.k.resolveCodeAction(ee,z)??ee;let Fe;ne.edit&&(Fe=t.WorkspaceEdit.from(ne.edit,void 0));let Be;if(ne.command){const Xe=this.f.get(G);Xe&&(Be=this.h.toInternal(ne.command,Xe))}return{edit:Fe,command:Be}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class j{constructor(U,z,G,H,ee){this.e=U,this.f=z,this.g=G,this.h=H,this.j=ee,this.d=new i.$zkc("DocumentPasteEdit")}async prepareDocumentPaste(U,z,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(U),ne=z.map(Xe=>t.Range.to(Xe)),Fe=t.DataTransfer.toDataTransfer(G,()=>{throw new F.$$});if(await this.g.prepareDocumentPaste(ee,ne,Fe,H),H.isCancellationRequested)return;const Be=Array.from(Fe).filter(([,Xe])=>!(Xe instanceof c.$JN));return t.DataTransfer.from(Be)}async providePasteEdits(U,z,G,H,ee,ne){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(z),Be=G.map(tt=>t.Range.to(tt)),Xe=t.DataTransfer.toDataTransfer(H,async tt=>(await this.e.$resolvePasteFileData(this.h,U,tt)).buffer),_e=await this.g.provideDocumentPasteEdits(Fe,Be,Xe,{only:ee.only?new c.$ON(ee.only):void 0,triggerKind:ee.triggerKind},ne);if(!_e||ne.isCancellationRequested)return[];const et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,r.localize)(0,null,this.j.displayName||this.j.name),kind:tt.kind,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?t.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,z){const[G,H]=U,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const ne=await this.g.resolveDocumentPasteEdit(ee,z)??ee;return{additionalEdit:ne.additionalEdit?t.WorkspaceEdit.from(ne.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class K{constructor(U,z){this.d=U,this.e=z}async provideDocumentFormattingEdits(U,z,G){const H=this.d.getDocument(U),ee=await this.e.provideDocumentFormattingEdits(H,z,G);if(Array.isArray(ee))return ee.map(t.TextEdit.from)}}class re{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeFormattingEdits(U,z,G,H){const ee=this.d.getDocument(U),ne=t.Range.to(z),Fe=await this.e.provideDocumentRangeFormattingEdits(ee,ne,G,H);if(Array.isArray(Fe))return Fe.map(t.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,z,G,H){(0,y.$cg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(U),ne=z.map(t.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(ee,ne,G,H);if(Array.isArray(Fe))return Fe.map(t.TextEdit.from)}}class ae{constructor(U,z){this.d=U,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,z,G,H,ee){const ne=this.d.getDocument(U),Fe=t.Position.to(z),Be=await this.e.provideOnTypeFormattingEdits(ne,Fe,G,H,ee);if(Array.isArray(Be))return Be.map(t.TextEdit.from)}}class ve{constructor(U,z){this.e=U,this.f=z,this.d=new i.$zkc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,z){const G=await this.e.provideWorkspaceSymbols(U,z);if(!(0,I.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let ne=0;ne<G.length;ne++){const Fe=G[ne];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}ee.symbols.push({...t.WorkspaceSymbol.from(Fe),cacheId:[H,ne]})}return ee}async resolveWorkspaceSymbol(U,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const G=this.d.get(...U.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,z);return H&&(0,f.$1n)(U,t.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class Ie{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,z,G){this.d=U,this.e=z,this.f=G}async provideRenameEdits(U,z,G,H){const ee=this.d.getDocument(U),ne=t.Position.to(z);try{const Fe=await this.e.provideRenameEdits(ee,ne,G,H);return Fe?t.WorkspaceEdit.from(Fe):void 0}catch(Fe){const Be=Ie.g(Fe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(U,z,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(U),ee=t.Position.to(z);try{const ne=await this.e.prepareRename(H,ee,G);let Fe,Be;if(c.$WM.isRange(ne)?(Fe=ne,Be=H.getText(ne)):(0,y.$7f)(ne)&&(Fe=ne.range,Be=ne.placeholder),!Fe||!Be)return;if(Fe.start.line>ee.line||Fe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:t.Range.from(Fe),text:Be}}catch(ne){const Fe=Ie.g(ne);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(ne)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class de{constructor(U,z,G){this.d=U,this.e=z,this.f=G}async provideNewSymbolNames(U,z,G){const H=this.d.getDocument(U),ee=t.Range.to(z);try{const ne=await this.e.provideNewSymbolNames(H,ee,G);return ne?ne.map(Fe=>typeof Fe=="string"?{newSymbolName:Fe}:{newSymbolName:Fe.newSymbolName,tags:Fe.tags}):void 0}catch(ne){this.f.error(de.g(ne)??JSON.stringify(ne,null,"	"));return}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class me{constructor(U,z){this.resultId=U,this.tokens=z}}class Me{constructor(U,z){this.f=U,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,z,G){const H=this.f.getDocument(U),ee=z!==0?this.d.get(z):null;let ne=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(z),ne?(ne=Me.h(ne),this.o(Me.n(ee,ne),ne)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return Me.j(U)?Me.k(U)?U:new c.$cO(new Uint32Array(U.data),U.resultId):Me.l(U)?Me.m(U)?U:new c.$eO(U.edits.map(z=>new c.$dO(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const z of U.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(U,z){if(!Me.j(z)||!U||!U.tokens)return z;const G=U.tokens,H=G.length,ee=z.data,ne=ee.length;let Fe=0;const Be=Math.min(H,ne);for(;Fe<Be&&G[Fe]===ee[Fe];)Fe++;if(Fe===H&&Fe===ne)return new c.$eO([],z.resultId);let Xe=0;const _e=Be-Fe;for(;Xe<_e&&G[H-Xe-1]===ee[ne-Xe-1];)Xe++;return new c.$eO([{start:Fe,deleteCount:H-Fe-Xe,data:ee.subarray(Fe,ne-Xe)}],z.resultId)}o(U,z){if(Me.j(U)){const G=this.e++;return this.d.set(G,new me(U.resultId,U.data)),(0,o.$Mbb)({id:G,type:"full",data:U.data})}if(Me.l(U)){const G=this.e++;return Me.j(z)?this.d.set(G,new me(z.resultId,z.data)):this.d.set(G,new me(U.resultId)),(0,o.$Mbb)({id:G,type:"delta",deltas:(U.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class ce{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeSemanticTokens(U,z,G){const H=this.d.getDocument(U),ee=await this.e.provideDocumentRangeSemanticTokens(H,t.Range.to(z),G);return ee?this.f(ee):null}f(U){return(0,o.$Mbb)({id:0,type:"full",data:U.data})}}class Ae{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,z,G,H,ee){this.f=U,this.g=z,this.h=G,this.j=H,this.k=ee,this.d=new i.$zkc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,z,G,H){const ee=this.f.getDocument(U),ne=t.Position.to(z),Fe=ee.getWordRangeAtPosition(ne)||new c.$WM(ne,ne),Be=Fe.with({end:ne}),Xe=new E.$0d,_e=await this.h.provideCompletionItems(ee,ne,H,t.CompletionContext.to(G));if(!_e||H.isCancellationRequested)return;const et=Array.isArray(_e)?new c.$qN(_e):_e,tt=Ae.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),it=new p.$Tc;this.e.set(tt,it);const nt=[],at={x:tt,b:nt,a:{replace:t.Range.from(Fe),insert:t.Range.from(Be)},c:et.isIncomplete||void 0,d:Xe.elapsed()};for(let mt=0;mt<et.items.length;mt++){const je=et.items[mt],st=this.l(je,[tt,mt],Be,Fe);nt.push(st)}return at}async resolveCompletionItem(U,z){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...U);if(!G)return;const H=this.l(G,U),ee=await this.h.resolveCompletionItem(G,z);if(!ee)return;const ne=this.l(ee,U);return(H.h!==ne.h||H.i!==ne.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==ne.n||H.o!==ne.o||!(0,f.$2n)(H.p,ne.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:ne.d,c:ne.c,l:ne.l,h:ne.h,i:ne.i,n:ne.n,o:ne.o,p:ne.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z,G,H){const ee=this.e.get(z[0]);if(!ee)throw Error("DisposableStore is missing...");const ne=this.g.toInternal(U.command,ee),Fe={x:z,a:U.label,b:U.kind!==void 0?t.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(t.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:t.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(t.TextEdit.from),n:ne?.$ident,o:ne?.id,p:ne?.$ident?void 0:ne?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=U.textEdit.newText):typeof U.insertText=="string"?Fe.h=U.insertText:U.insertText instanceof c.$6M&&(Fe.h=U.insertText.value,Fe.i|=4);let Be;return U.textEdit?Be=U.textEdit.range:U.range&&(Be=U.range),c.$WM.isRange(Be)?Fe.j=t.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Fe.j={insert:t.Range.from(Be.inserting),replace:t.Range.from(Be.replacing)}),Fe}}class ie{async provideInlineCompletions(U,z,G,H){}disposeCompletions(U){}handleDidShowCompletionItem(U,z,G){}handlePartialAccept(U,z,G,H){}}class L extends ie{constructor(U,z,G,H){super(),this.f=U,this.g=z,this.h=G,this.j=H,this.d=new be,this.e=(0,l.$zG)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,l.$zG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,z,G,H){const ee=this.g.getDocument(U),ne=t.Position.to(z),Fe=await this.h.provideInlineCompletionItems(ee,ne,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:t.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Fe||H.isCancellationRequested)return;const Be=Array.isArray(Fe)?Fe:Fe.items,Xe=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],_e=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Be}),items:Be.map((it,nt)=>{let at;it.command&&(et||(et=new p.$Tc),at=this.j.toInternal(it.command,et));const mt=it.insertText;return{insertText:typeof mt=="string"?mt:{snippet:mt.value},filterText:it.filterText,range:it.range?t.Range.from(it.range):void 0,command:at,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Xe.map(it=>(et||(et=new p.$Tc),this.j.toInternal(it,et))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,z,G){const H=this.d.get(U)?.items[z];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(U,z,G,H){const ee=this.d.get(U)?.items[z];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,t.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(U,z,G){const H=this.f.getDocument(U),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[z.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let ne;const Fe=this.d.createReferenceId({dispose(){ne?.dispose()},item:ee});let Be;ee.accepted&&(ne||(ne=new p.$Tc),Be=this.h.toInternal(ee.accepted,ne));let Xe;return ee.rejected&&(ne||(ne=new p.$Tc),Xe=this.h.toInternal(ee.rejected,ne)),{pid:Fe,text:ee.text,range:t.Range.from(ee.range),accepted:Be,rejected:Xe}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,z,G,H){this.f=z,this.g=G,this.h=H,this.d=new be,this.e={[s.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const z=this.e++;return this.d.set(z,U),z}disposeReferenceId(U){const z=this.d.get(U);return this.d.delete(U),z}get(U){return this.d.get(U)}}class Oe{constructor(U,z){this.e=U,this.f=z,this.d=new i.$zkc("SignatureHelp")}async provideSignatureHelp(U,z,G,H){const ee=this.e.getDocument(U),ne=t.Position.to(z),Fe=this.g(G),Be=await this.f.provideSignatureHelp(ee,ne,H,Fe);if(Be){const Xe=this.d.add([Be]);return{...t.SignatureHelp.from(Be),id:Xe}}}g(U){let z;if(U.activeSignatureHelp){const G=t.SignatureHelp.to(U.activeSignatureHelp),H=this.d.get(U.activeSignatureHelp.id,0);H?(z=H,z.activeSignature=G.activeSignature,z.activeParameter=G.activeParameter):z=G}return{...U,activeSignatureHelp:z}}releaseSignatureHelp(U){this.d.delete(U)}}class Ee{constructor(U,z,G,H,ee){this.f=U,this.g=z,this.h=G,this.j=H,this.k=ee,this.d=new i.$zkc("InlayHints"),this.e=new Map}async provideInlayHints(U,z,G){const H=this.f.getDocument(U),ee=t.Range.to(z),ne=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(ne)||ne.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`);return}if(G.isCancellationRequested)return;const Fe=this.d.add(ne);this.e.set(Fe,new p.$Tc);const Be={hints:[],cacheId:Fe};for(let Xe=0;Xe<ne.length;Xe++)this.l(ne[Xe],ee)&&Be.hints.push(this.m(ne[Xe],[Fe,Xe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`),Be}async resolveInlayHint(U,z){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...U);if(!G)return;const H=await this.h.resolveInlayHint(G,z);if(H&&this.l(H))return this.m(H,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z){return U.label.length===0||Array.isArray(U.label)&&U.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(z&&!z.contains(U.position))}m(U,z){const G=this.e.get(z[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:z,tooltip:t.MarkdownString.fromStrict(U.tooltip),position:t.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(t.TextEdit.from),kind:U.kind&&t.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")H.label=U.label;else{const ee=[];H.label=ee;for(const ne of U.label){if(!ne.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:ne.value,tooltip:t.MarkdownString.fromStrict(ne.tooltip)};c.$7M.isLocation(ne.location)&&(Fe.location=t.location.from(ne.location)),ne.command&&(Fe.command=this.g.toInternal(ne.command,G)),ee.push(Fe)}}return H}}class pe{constructor(U,z){this.e=U,this.f=z,this.d=new i.$zkc("DocumentLink")}async provideLinks(U,z){const G=this.e.getDocument(U),H=await this.f.provideDocumentLinks(G,z);if(!(!Array.isArray(H)||H.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(pe.g).map(t.DocumentLink.from)};{const ee=this.d.add(H),ne={links:[],cacheId:ee};for(let Fe=0;Fe<H.length;Fe++){if(!pe.g(H[Fe]))continue;const Be=t.DocumentLink.from(H[Fe]);Be.cacheId=[ee,Fe],ne.links.push(Be)}return ne}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,z){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...U);if(!G)return;const H=await this.f.resolveDocumentLink(G,z);if(!(!H||!pe.g(H)))return t.DocumentLink.from(H)}releaseLinks(U){this.d.delete(U)}}class fe{constructor(U,z){this.d=U,this.e=z}async provideColors(U,z){const G=this.d.getDocument(U),H=await this.e.provideDocumentColors(G,z);return Array.isArray(H)?H.map(ne=>({color:t.Color.from(ne.color),range:t.Range.from(ne.range)})):[]}async provideColorPresentations(U,z,G){const H=this.d.getDocument(U),ee=t.Range.to(z.range),ne=t.Color.to(z.color),Fe=await this.e.provideColorPresentations(ne,{document:H,range:ee},G);if(Array.isArray(Fe))return Fe.map(t.ColorPresentation.from)}}class X{constructor(U,z){this.d=U,this.e=z}async provideFoldingRanges(U,z,G){const H=this.d.getDocument(U),ee=await this.e.provideFoldingRanges(H,z,G);if(Array.isArray(ee))return ee.map(t.FoldingRange.from)}}class Z{constructor(U,z,G){this.d=U,this.e=z,this.f=G}async provideSelectionRanges(U,z,G){const H=this.d.getDocument(U),ee=z.map(t.Position.to),ne=await this.e.provideSelectionRanges(H,ee,G);if(!(0,I.$Lb)(ne))return[];if(ne.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let Be=0;Be<ee.length;Be++){const Xe=[];Fe.push(Xe);let _e=ee[Be],et=ne[Be];for(;;){if(!et.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(t.SelectionRange.from(et)),!et.parent)break;_e=et.range,et=et.parent}}return Fe}}class le{constructor(U,z){this.f=U,this.g=z,this.d=new M.$kP(""),this.e=new Map}async prepareSession(U,z,G){const H=this.f.getDocument(U),ee=t.Position.to(z),ne=await this.g.prepareCallHierarchy(H,ee,G);if(!ne)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(ne)?ne.map(Be=>this.h(Fe,Be)):[this.h(Fe,ne)]}async provideCallsTo(U,z,G){const H=this.j(U,z);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(ne=>({from:this.h(U,ne.from),fromRanges:ne.fromRanges.map(Fe=>t.Range.from(Fe))}))}async provideCallsFrom(U,z,G){const H=this.j(U,z);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(ne=>({to:this.h(U,ne.to),fromRanges:ne.fromRanges.map(Fe=>t.Range.from(Fe))}))}releaseSession(U){this.e.delete(U)}h(U,z){const G=this.e.get(U),H=t.CallHierarchyItem.from(z,U,G.size.toString(36));return G.set(H._itemId,z),H}j(U,z){return this.e.get(U)?.get(z)}}class ue{constructor(U,z){this.f=U,this.g=z,this.d=new M.$kP(""),this.e=new Map}async prepareSession(U,z,G){const H=this.f.getDocument(U),ee=t.Position.to(z),ne=await this.g.prepareTypeHierarchy(H,ee,G);if(!ne)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(ne)?ne.map(Be=>this.h(Fe,Be)):[this.h(Fe,ne)]}async provideSupertypes(U,z,G){const H=this.j(U,z);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(ne=>this.h(U,ne))}async provideSubtypes(U,z,G){const H=this.j(U,z);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(ne=>this.h(U,ne))}releaseSession(U){this.e.delete(U)}h(U,z){const G=this.e.get(U),H=t.TypeHierarchyItem.from(z,U,G.size.toString(36));return G.set(H._itemId,z),H}j(U,z){return this.e.get(U)?.get(z)}}class Te{constructor(U,z,G,H,ee){this.e=U,this.f=z,this.g=G,this.h=H,this.j=ee,this.d=new i.$zkc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,z,G,H,ee){const ne=this.f.getDocument(z),Fe=t.Position.to(G),Be=t.DataTransfer.toDataTransfer(H,async tt=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,tt)).buffer),Xe=await this.g.provideDocumentDropEdits(ne,Fe,Be,ee);if(!Xe)return;const _e=(0,I.$3b)(Xe),et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,r.localize)(1,null,this.j.displayName||this.j.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?t.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,z){const[G,H]=U,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const ne=await this.g.resolveDocumentDropEdit(ee,z)??ee;return{additionalEdit:ne.additionalEdit?t.WorkspaceEdit.from(ne.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class he{constructor(U,z){this.d=U,this.e=z}async provideMappedEdits(U,z,G,H){const ee=u.URI.revive(U),ne=this.d.getDocument(ee),Fe=G.documents.map(_e=>_e.map(et=>({uri:u.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(tt=>t.Range.to(tt))}))),Be={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Xe=await this.e.provideMappedEdits(ne,z,Be,H);return Xe?t.WorkspaceEdit.from(Xe):null}}class Pe{constructor(U,z){this.adapter=U,this.extension=z}}class Ne{static{this.d=0}constructor(U,z,G,H,ee,ne,Fe,Be){this.g=z,this.h=G,this.j=H,this.k=ee,this.l=ne,this.m=Fe,this.n=Be,this.f=new Map,this.e=U.getProxy($.$SM.MainThreadLanguageFeatures)}o(U,z){return t.DocumentSelector.from(U,this.g,z)}p(U){return new c.$UM(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Ne.d++}async s(U,z,G,H,ee,ne=!1){const Fe=this.f.get(U);if(!Fe||!(Fe.adapter instanceof z))return H;const Be=Date.now();ne||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Xe=G(Fe.adapter,Fe.extension);return Promise.resolve(Xe).catch(_e=>{(0,F.$4)(_e)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Fe.extension.identifier,_e))}).finally(()=>{ne||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),A.CancellationToken.isCancellationToken(ee)?(0,N.$gh)(Xe,ee):Xe}t(U,z){const G=this.q();return this.f.set(G,new Pe(U,z)),G}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,z,G,H){const ee=this.t(new a(this.h,G),U),ne=H&&H.label||Ne.u(U);return this.e.$registerDocumentSymbolProvider(ee,this.o(z,U),ne),this.p(ee)}$provideDocumentSymbols(U,z,G){return this.s(U,a,H=>H.provideDocumentSymbols(u.URI.revive(z),G),void 0,G)}registerCodeLensProvider(U,z,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Pe(new b(this.h,this.j.converter,G,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(H,this.o(z,U),ee);let ne=this.p(H);if(ee!==void 0){const Fe=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));ne=c.$UM.from(ne,Fe)}return ne}$provideCodeLenses(U,z,G){return this.s(U,b,H=>H.provideCodeLenses(u.URI.revive(z),G),void 0,G)}$resolveCodeLens(U,z,G){return this.s(U,b,H=>H.resolveCodeLens(z,G),void 0,void 0)}$releaseCodeLenses(U,z){this.s(U,b,G=>Promise.resolve(G.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(U,z,G){const H=this.t(new D(this.h,G),U);return this.e.$registerDefinitionSupport(H,this.o(z,U)),this.p(H)}$provideDefinition(U,z,G,H){return this.s(U,D,ee=>ee.provideDefinition(u.URI.revive(z),G,H),[],H)}registerDeclarationProvider(U,z,G){const H=this.t(new d(this.h,G),U);return this.e.$registerDeclarationSupport(H,this.o(z,U)),this.p(H)}$provideDeclaration(U,z,G,H){return this.s(U,d,ee=>ee.provideDeclaration(u.URI.revive(z),G,H),[],H)}registerImplementationProvider(U,z,G){const H=this.t(new k(this.h,G),U);return this.e.$registerImplementationSupport(H,this.o(z,U)),this.p(H)}$provideImplementation(U,z,G,H){return this.s(U,k,ee=>ee.provideImplementation(u.URI.revive(z),G,H),[],H)}registerTypeDefinitionProvider(U,z,G){const H=this.t(new g(this.h,G),U);return this.e.$registerTypeDefinitionSupport(H,this.o(z,U)),this.p(H)}$provideTypeDefinition(U,z,G,H){return this.s(U,g,ee=>ee.provideTypeDefinition(u.URI.revive(z),G,H),[],H)}registerHoverProvider(U,z,G,H){const ee=this.t(new S(this.h,G),U);return this.e.$registerHoverProvider(ee,this.o(z,U)),this.p(ee)}$provideHover(U,z,G,H){return this.s(U,S,ee=>ee.provideHover(u.URI.revive(z),G,H),void 0,H)}registerEvaluatableExpressionProvider(U,z,G,H){const ee=this.t(new w(this.h,G),U);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(z,U)),this.p(ee)}$provideEvaluatableExpression(U,z,G,H){return this.s(U,w,ee=>ee.provideEvaluatableExpression(u.URI.revive(z),G,H),void 0,H)}registerInlineValuesProvider(U,z,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,ne=this.t(new C(this.h,G),U);this.e.$registerInlineValuesProvider(ne,this.o(z,U),ee);let Fe=this.p(ne);if(ee!==void 0){const Be=G.onDidChangeInlineValues(Xe=>this.e.$emitInlineValuesEvent(ee));Fe=c.$UM.from(Fe,Be)}return Fe}$provideInlineValues(U,z,G,H,ee){return this.s(U,C,ne=>ne.provideInlineValues(u.URI.revive(z),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(U,z,G){const H=this.t(new P(this.h,G),U);return this.e.$registerDocumentHighlightProvider(H,this.o(z,U)),this.p(H)}registerMultiDocumentHighlightProvider(U,z,G){const H=this.t(new W(this.h,G),U);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(z,U)),this.p(H)}$provideDocumentHighlights(U,z,G,H){return this.s(U,P,ee=>ee.provideDocumentHighlights(u.URI.revive(z),G,H),void 0,H)}$provideMultiDocumentHighlights(U,z,G,H,ee){return this.s(U,W,ne=>ne.provideMultiDocumentHighlights(u.URI.revive(z),G,H.map(Fe=>u.URI.revive(Fe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(U,z,G){const H=this.t(new V(this.h,G),U);return this.e.$registerLinkedEditingRangeProvider(H,this.o(z,U)),this.p(H)}$provideLinkedEditingRanges(U,z,G,H){return this.s(U,V,async ee=>{const ne=await ee.provideLinkedEditingRanges(u.URI.revive(z),G,H);if(ne)return{ranges:ne.ranges,wordPattern:ne.wordPattern?Ne.w(ne.wordPattern):void 0}},void 0,H)}registerReferenceProvider(U,z,G){const H=this.t(new q(this.h,G),U);return this.e.$registerReferenceSupport(H,this.o(z,U)),this.p(H)}$provideReferences(U,z,G,H,ee){return this.s(U,q,ne=>ne.provideReferences(u.URI.revive(z),G,H,ee),void 0,ee)}registerCodeActionProvider(U,z,G,H){const ee=new p.$Tc,ne=this.t(new R(this.h,this.j.converter,this.k,G,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(ne,this.o(z,U),{providedKinds:H?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:H?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,ee)}))},Ne.u(U),!!G.resolveCodeAction),ee.add(this.p(ne)),ee}$provideCodeActions(U,z,G,H,ee){return this.s(U,R,ne=>ne.provideCodeActions(u.URI.revive(z),G,H,ee),void 0,ee)}$resolveCodeAction(U,z,G){return this.s(U,R,H=>H.resolveCodeAction(z,G),{},void 0)}$releaseCodeActions(U,z){this.s(U,R,G=>Promise.resolve(G.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(U,z,G){const H=this.t(new K(this.h,G),U);return this.e.$registerDocumentFormattingSupport(H,this.o(z,U),U.identifier,U.displayName||U.name),this.p(H)}$provideDocumentFormattingEdits(U,z,G,H){return this.s(U,K,ee=>ee.provideDocumentFormattingEdits(u.URI.revive(z),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(U,z,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new re(this.h,G),U);return this.e.$registerRangeFormattingSupport(ee,this.o(z,U),U.identifier,U.displayName||U.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(U,z,G,H,ee){return this.s(U,re,ne=>ne.provideDocumentRangeFormattingEdits(u.URI.revive(z),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(U,z,G,H,ee){return this.s(U,re,ne=>ne.provideDocumentRangesFormattingEdits(u.URI.revive(z),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(U,z,G,H){const ee=this.t(new ae(this.h,G),U);return this.e.$registerOnTypeFormattingSupport(ee,this.o(z,U),H,U.identifier),this.p(ee)}$provideOnTypeFormattingEdits(U,z,G,H,ee,ne){return this.s(U,ae,Fe=>Fe.provideOnTypeFormattingEdits(u.URI.revive(z),G,H,ee,ne),void 0,ne)}registerWorkspaceSymbolProvider(U,z){const G=this.t(new ve(z,this.l),U);return this.e.$registerNavigateTypeSupport(G,typeof z.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(U,z,G){return this.s(U,ve,H=>H.provideWorkspaceSymbols(z,G),{symbols:[]},G)}$resolveWorkspaceSymbol(U,z,G){return this.s(U,ve,H=>H.resolveWorkspaceSymbol(z,G),void 0,void 0)}$releaseWorkspaceSymbols(U,z){this.s(U,ve,G=>G.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(U,z,G){const H=this.t(new Ie(this.h,G,this.l),U);return this.e.$registerRenameSupport(H,this.o(z,U),Ie.supportsResolving(G)),this.p(H)}$provideRenameEdits(U,z,G,H,ee){return this.s(U,Ie,ne=>ne.provideRenameEdits(u.URI.revive(z),G,H,ee),void 0,ee)}$resolveRenameLocation(U,z,G,H){return this.s(U,Ie,ee=>ee.resolveRenameLocation(u.URI.revive(z),G,H),void 0,H)}registerNewSymbolNamesProvider(U,z,G){const H=this.t(new de(this.h,G,this.l),U);return this.e.$registerNewSymbolNamesProvider(H,this.o(z,U)),this.p(H)}$provideNewSymbolNames(U,z,G,H){return this.s(U,de,ee=>ee.provideNewSymbolNames(u.URI.revive(z),G,H),void 0,H)}registerDocumentSemanticTokensProvider(U,z,G,H){const ee=this.t(new Me(this.h,G),U),ne=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(z,U),H,ne);let Fe=this.p(ee);if(ne){const Be=G.onDidChangeSemanticTokens(Xe=>this.e.$emitDocumentSemanticTokensEvent(ne));Fe=c.$UM.from(Fe,Be)}return Fe}$provideDocumentSemanticTokens(U,z,G,H){return this.s(U,Me,ee=>ee.provideDocumentSemanticTokens(u.URI.revive(z),G,H),null,H)}$releaseDocumentSemanticTokens(U,z){this.s(U,Me,G=>G.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,z,G,H){const ee=this.t(new ce(this.h,G),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(z,U),H),this.p(ee)}$provideDocumentRangeSemanticTokens(U,z,G,H){return this.s(U,ce,ee=>ee.provideDocumentRangeSemanticTokens(u.URI.revive(z),G,H),null,H)}registerCompletionItemProvider(U,z,G,H){const ee=this.t(new Ae(this.h,this.j.converter,G,this.m,U),U);return this.e.$registerCompletionsProvider(ee,this.o(z,U),H,Ae.supportsResolving(G),U.identifier),this.p(ee)}$provideCompletionItems(U,z,G,H,ee){return this.s(U,Ae,ne=>ne.provideCompletionItems(u.URI.revive(z),G,H,ee),void 0,ee)}$resolveCompletionItem(U,z,G){return this.s(U,Ae,H=>H.resolveCompletionItem(z,G),void 0,G)}$releaseCompletionItems(U,z){this.s(U,Ae,G=>G.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(U,z,G,H){const ee=new L(U,this.h,G,this.j.converter),ne=this.t(ee,U);return this.e.$registerInlineCompletionsSupport(ne,this.o(z,U),ee.supportsHandleEvents,n.$Mm.toKey(U.identifier.value),H?.yieldTo?.map(Fe=>n.$Mm.toKey(Fe))||[]),this.p(ne)}$provideInlineCompletions(U,z,G,H,ee){return this.s(U,ie,ne=>ne.provideInlineCompletions(u.URI.revive(z),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(U,z,G,H){this.s(U,ie,async ee=>{ee.handleDidShowCompletionItem(z,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,z,G,H,ee){this.s(U,ie,async ne=>{ne.handlePartialAccept(z,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(U,z){this.s(U,ie,async G=>{G.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(U,z,G){const H=new x(U,this.h,G,this.j.converter),ee=this.t(H,U);return this.e.$registerInlineEditProvider(ee,this.o(z,U),U.identifier),this.p(ee)}$provideInlineEdit(U,z,G,H){return this.s(U,x,ee=>ee.provideInlineEdits(u.URI.revive(z),G,H),void 0,H)}$freeInlineEdit(U,z){this.s(U,x,async G=>{G.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(U,z,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,ne=this.t(new Oe(this.h,G),U);return this.e.$registerSignatureHelpProvider(ne,this.o(z,U),ee),this.p(ne)}$provideSignatureHelp(U,z,G,H,ee){return this.s(U,Oe,ne=>ne.provideSignatureHelp(u.URI.revive(z),G,H,ee),void 0,ee)}$releaseSignatureHelp(U,z){this.s(U,Oe,G=>G.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(U,z,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new Ee(this.h,this.j.converter,G,this.l,U),U);this.e.$registerInlayHintsProvider(ee,this.o(z,U),typeof G.resolveInlayHint=="function",H,Ne.u(U));let ne=this.p(ee);if(H!==void 0){const Fe=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));ne=c.$UM.from(ne,Fe)}return ne}$provideInlayHints(U,z,G,H){return this.s(U,Ee,ee=>ee.provideInlayHints(u.URI.revive(z),G,H),void 0,H)}$resolveInlayHint(U,z,G){return this.s(U,Ee,H=>H.resolveInlayHint(z,G),void 0,G)}$releaseInlayHints(U,z){this.s(U,Ee,G=>G.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(U,z,G){const H=this.t(new pe(this.h,G),U);return this.e.$registerDocumentLinkProvider(H,this.o(z,U),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(U,z,G){return this.s(U,pe,H=>H.provideLinks(u.URI.revive(z),G),void 0,G,z.scheme==="output")}$resolveDocumentLink(U,z,G){return this.s(U,pe,H=>H.resolveLink(z,G),void 0,void 0,!0)}$releaseDocumentLinks(U,z){this.s(U,pe,G=>G.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(U,z,G){const H=this.t(new fe(this.h,G),U);return this.e.$registerDocumentColorProvider(H,this.o(z,U)),this.p(H)}$provideDocumentColors(U,z,G){return this.s(U,fe,H=>H.provideColors(u.URI.revive(z),G),[],G)}$provideColorPresentations(U,z,G,H){return this.s(U,fe,ee=>ee.provideColorPresentations(u.URI.revive(z),G,H),void 0,H)}registerFoldingRangeProvider(U,z,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Pe(new X(this.h,G),U)),this.e.$registerFoldingRangeProvider(H,this.o(z,U),U.identifier,ee);let ne=this.p(H);if(ee!==void 0){const Fe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));ne=c.$UM.from(ne,Fe)}return ne}$provideFoldingRanges(U,z,G,H){return this.s(U,X,ee=>ee.provideFoldingRanges(u.URI.revive(z),G,H),void 0,H)}registerSelectionRangeProvider(U,z,G){const H=this.t(new Z(this.h,G,this.l),U);return this.e.$registerSelectionRangeProvider(H,this.o(z,U)),this.p(H)}$provideSelectionRanges(U,z,G,H){return this.s(U,Z,ee=>ee.provideSelectionRanges(u.URI.revive(z),G,H),[],H)}registerCallHierarchyProvider(U,z,G){const H=this.t(new le(this.h,G),U);return this.e.$registerCallHierarchyProvider(H,this.o(z,U)),this.p(H)}$prepareCallHierarchy(U,z,G,H){return this.s(U,le,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(z),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(U,z,G,H){return this.s(U,le,ee=>ee.provideCallsTo(z,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(U,z,G,H){return this.s(U,le,ee=>ee.provideCallsFrom(z,G,H),void 0,H)}$releaseCallHierarchy(U,z){this.s(U,le,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(U,z,G){const H=this.t(new ue(this.h,G),U);return this.e.$registerTypeHierarchyProvider(H,this.o(z,U)),this.p(H)}$prepareTypeHierarchy(U,z,G,H){return this.s(U,ue,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(z),G,H)),void 0,H)}$provideTypeHierarchySupertypes(U,z,G,H){return this.s(U,ue,ee=>ee.provideSupertypes(z,G,H),void 0,H)}$provideTypeHierarchySubtypes(U,z,G,H){return this.s(U,ue,ee=>ee.provideSubtypes(z,G,H),void 0,H)}$releaseTypeHierarchy(U,z){this.s(U,ue,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(U,z,G,H){const ee=this.q();return this.f.set(ee,new Pe(new Te(this.e,this.h,G,ee,U),U)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(z,U),(0,l.$zG)(U,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(U,z,G,H,ee,ne){return this.s(U,Te,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(z,u.URI.revive(G),H,ee,ne)),void 0,void 0)}$resolveDropEdit(U,z,G){return this.s(U,Te,H=>H.resolveDropEdit(z,G),{},void 0)}$releaseDropEdits(U,z){this.s(U,Te,G=>Promise.resolve(G.releaseDropEdits(z)),void 0,void 0)}registerMappedEditsProvider(U,z,G){const H=this.t(new he(this.h,G),U);return this.e.$registerMappedEditsProvider(H,this.o(z,U)),this.p(H)}$provideMappedEdits(U,z,G,H,ee){return this.s(U,he,ne=>Promise.resolve(ne.provideMappedEdits(z,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(U,z,G,H){const ee=this.q();return this.f.set(ee,new Pe(new j(this.e,this.h,G,ee,U),U)),this.e.$registerPasteEditProvider(ee,this.o(z,U),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(ne=>ne.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(U,z,G,H,ee){return this.s(U,j,ne=>ne.prepareDocumentPaste(u.URI.revive(z),G,H,ee),void 0,ee)}$providePasteEdits(U,z,G,H,ee,ne,Fe){return this.s(U,j,Be=>Be.providePasteEdits(z,u.URI.revive(G),H,ee,ne,Fe),void 0,Fe)}$resolvePasteEdit(U,z,G){return this.s(U,j,H=>H.resolvePasteEdit(z,G),{},void 0)}$releasePasteEdits(U,z){this.s(U,j,G=>Promise.resolve(G.releasePasteEdits(z)),void 0,void 0)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:Ne.w(U.decreaseIndentPattern),increaseIndentPattern:Ne.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Ne.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Ne.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:Ne.w(U.beforeText),afterText:U.afterText?Ne.w(U.afterText):void 0,previousLineText:U.previousLineText?Ne.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(Ne.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(z=>c.SyntaxTokenType.toString(z)):void 0}}static D(U){return U.map(Ne.C)}setLanguageConfiguration(U,z,G){const{wordPattern:H}=G;if(H&&(0,T.$gf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(z,H):this.h.setWordDefinitionFor(z,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ee=this.q(),ne={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ne.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Ne.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ne.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Ne.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,z,ne),this.p(ee)}$setWordDefinitions(U){for(const z of U)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.$Jkc=Ne}),define(Ce[88],Re([1,0,6,4,8,7,101,20,11,5,166,106,14,3,16,84,13,40]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=e.$qlc=void 0,e.$qlc=(0,v.$ri)("IExtHostLanguageModels");class t{constructor($,a){this.option=$,this.stream=new f.$Uh,this.stream=a??new f.$Uh}}class c{constructor(){this.a=new Map,this.b=new f.$Uh,this.c=!1,this.d=!1;const $=this;this.apiObject={stream:$.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,$]of this.a)yield $.stream;else yield this.b}handleFragment($){if(this.c)return;this.d=!0;let a=this.a.get($.index);a||(this.a.size===0?a=new t($.index,this.b):a=new t($.index),this.a.set($.index,a)),a.stream.emitOne($.part)}get isStreaming(){return this.d}reject($){this.c=!0;for(const a of this.f())a.reject($)}resolve(){this.c=!0;for(const $ of this.f())$.resolve()}}let l=class{static{n=this}static{this.a=1}constructor($,a,b){this.j=a,this.k=b,this.c=new E.$be,this.d=new E.$be,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Om,this.i=new Map,this.o=new Set,this.b=$.getProxy(N.$SM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel($,a,b,h){const D=n.a++;this.f.set(D,{extension:$.identifier,provider:b,languageModelId:a});let d;return h.auth&&(d={providerLabel:$.displayName||$.name,accountLabel:typeof h.auth=="object"?h.auth.label:void 0}),this.b.$registerLanguageModelProvider(D,a,{extension:$.identifier,identifier:a,name:h.name??"",version:h.version,tokens:h.tokens,auth:d}),(0,I.$Sc)(()=>{this.f.delete(D),this.b.$unregisterProvider(D)})}async $provideLanguageModelResponse($,a,b,h,D,d){const k=this.f.get($);if(!k)return;const g=new M.$3v(async S=>{if(d.isCancellationRequested){this.j.warn(`[CHAT](${k.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:S.index,part:S.part})});return k.provider.provideLanguageModelResponse2(h.map(A.LanguageModelMessage.to),D,p.$Mm.toKey(b),g,d)}$provideTokenLength($,a,b){const h=this.f.get($);return h?Promise.resolve(h.provider.provideTokenCount(a,b)):Promise.resolve(0)}$updateLanguageModels($){const a=[],b=[];if($.added)for(const h of $.added)this.g.set(h.identifier,h),a.push(h.identifier);if($.removed)for(const h of $.removed){this.g.delete(h),b.push(h);for(const[D,d]of this.i)d.languageModelId===h&&(d.res.reject(new u.$5),this.i.delete(D))}this.d.fire(Object.freeze({added:Object.freeze(a),removed:Object.freeze(b)})),$.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist($){const a=new Array;for(const{from:b,to:h,enabled:D}of $){const d=this.h.get(b)??new p.$Nm;if(d.has(h)!==D){D?d.add(h):d.delete(h),this.h.set(b,d);const g={from:b,to:h};a.push(g),this.c.fire(g)}}}async sendChatRequest($,a,b,h,D){const d=$.identifier,k=await this.b.$prepareChatAccess(d,a,h.justification);if(!k||!this.g.has(a))throw F.$5O.NotFound(`Language model '${a}' is unknown.`);if(this.m(d,k)&&(!await this.l($,{identifier:k.extension,displayName:k.auth.providerLabel},h.justification,h.silent)||!this.h.get(d)?.has(k.extension)))throw F.$5O.NoPermissions(`Language model '${a}' cannot be used by '${d.value}'.`);const g=Math.random()*1e6|0,S=this.b.$fetchResponse(d,a,g,b.map(A.LanguageModelMessage.from),h.modelOptions??{},D),w=new f.$qh,C=new c;this.i.set(g,{languageModelId:a,res:C});let P;if(S.catch(W=>{w.isOpen()?C.reject(W):P=W}).finally(()=>{this.i.delete(g),C.resolve(),w.open()}),await w.wait(),P)throw new F.$5O(`Language model '${a}' errored, check cause for more details`,"Unknown",P);return C.apiObject}async $handleResponseFragment($,a){const b=this.i.get($);b&&b.res.handleFragment(a)}async l($,a,b,h){const D=y.$UL+a.identifier.value;if(await this.k.getSession($,D,[],{silent:!0}))return this.$updateModelAccesslist([{from:$.identifier,to:a.identifier,enabled:!0}]),!0;if(h)return!1;try{const k=b?(0,T.localize)(0,null,a.displayName,b):(0,T.localize)(1,null,a.displayName);return await this.k.getSession($,D,[],{forceNewSession:{detail:k}}),this.$updateModelAccesslist([{from:$.identifier,to:a.identifier,enabled:!0}]),!0}catch{return!1}}m($,a){return!!a.auth&&!p.$Mm.equals(a.extension,$)}async n($){for(const a of this.o)try{await this.l(a,{identifier:$.extension,displayName:""},void 0,!0)}catch(b){this.j.error("Fake Auth request failed"),this.j.error(b)}}async computeTokenLength($,a,b){const h=this.g.get($);if(!h)throw F.$5O.NotFound(`Language model '${$}' is unknown.`);const D=r.Iterable.find(this.f.values(),d=>d.languageModelId===$);return D?D.provider.provideTokenCount(a,b):this.b.$countTokens(h.identifier,typeof a=="string"?a:A.LanguageModelMessage.from(a),b)}getLanguageModelInfo($){const a=this.g.get($);if(a)return{id:a.identifier,name:a.name,version:a.version,tokens:a.tokens}}createLanguageModelAccessInformation($){this.o.add($);const a=this,b=E.Event.signal(E.Event.filter(this.c.event,D=>p.$Mm.equals(D.from,$.identifier))),h=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(b,h)},canSendRequest(D){const d=a.g.get(D);if(!d)return;if(!a.m($.identifier,d))return!0;const k=a.h.get($.identifier);if(k)return k.has(d.extension)}}}};e.$rlc=l,e.$rlc=l=n=Je([We(0,m.$fP),We(1,o.$Xj),We(2,s.$Lkc)],l)}),define(Ce[263],Re([1,0,4,8,7,33,11,6,26]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;class E{constructor(y,u,v,m){this.c=u,this.d=v,this.e=m,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(I.$SM.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const v=this.c.getDocumentData(y);if(!v)throw new Error(`document '${y.toString()}' NOT found`);return v.document}async tokenAtPosition(y,u){const v=y.version,m=N.Position.from(u),s=await this.a.$tokensAtPosition(y.uri,m),o={type:A.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new A.$WM(u.line,u.character,u.line,u.character)};if(!s)return o;const r={range:N.Range.to(s.range),type:N.TokenType.to(s.type)};return!r.range.contains(u)||v!==y.version?o:r}createLanguageStatusItem(y,u,v){const m=this.f++,s=this.a,o=this.g,r=`${y.identifier.value}/${u}`;if(o.has(r))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(r);const n={selector:v,id:u,name:y.displayName??y.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let t;const c=new p.$Tc,l=()=>{if(t?.dispose(),!o.has(r)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}t=(0,M.$th)(()=>{c.clear(),this.a.$setLanguageStatus(m,{id:r,name:n.name??y.displayName??y.name,source:y.displayName??y.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===A.LanguageStatusSeverity.Error?F.default.Error:n.severity===A.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),t?.dispose(),s.$removeLanguageStatus(m),o.delete(r)},get id(){return n.id},get name(){return n.name},set name($){n.name=$,l()},get selector(){return n.selector},set selector($){n.selector=$,l()},get text(){return n.text},set text($){n.text=$,l()},set text2($){(0,f.$AG)(y,"languageStatusText"),n.text=$,l()},get text2(){return(0,f.$AG)(y,"languageStatusText"),n.text},get detail(){return n.detail},set detail($){n.detail=$,l()},get severity(){return n.severity},set severity($){n.severity=$,l()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation($){n.accessibilityInformation=$,l()},get command(){return n.command},set command($){n.command=$,l()},get busy(){return n.busy},set busy($){n.busy=$,l()}};return l(),i}}e.$9lc=E}),define(Ce[264],Re([1,0,12,2,8,7,83]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=void 0;class p{constructor(y,u,v,m){this.start=y,this.deletedCount=u,this.deletedItems=v,this.items=m}asApiEvent(){return{range:new F.$jO(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,v){this.notebook=y,this.h=u,this.j=v,this.handle=v.handle,this.uri=N.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(A.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(m){y.g=m},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(v)}return this.f}setOutputs(y){this.a=y.map(A.NotebookCellOutput.to)}setOutputItems(y,u,v){const m=v.map(A.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===y);if(s&&(u||(s.items.length=0),s.items.push(...m),s.items.length>1&&s.items.every(o=>M.$PK(o.mime)))){const o=new Map,r=[];s.items.forEach(n=>{let t;o.has(n.mime)?t=o.get(n.mime):(t=[],o.set(n.mime,t),r.push(n.mime)),t.push(n.data)}),s.items.length=0,r.forEach(n=>{const t=M.$QK(o.get(n));s.items.push({mime:n,data:t.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Ulc=f;class E{static{this.a=0}constructor(y,u,v,m,s){this.k=y,this.l=u,this.m=v,this.uri=m,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===I.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(v){return v=y.n(v),y.b[v].apiCell},getCells(v){return(v?y.p(v):y.b).map(s=>s.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,v){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:v});const m={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},s=[];for(const r of y.rawEvents)r.kind===M.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,m.contentChanges):r.kind===M.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,m.contentChanges):r.kind===M.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===M.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===M.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),s.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),s.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const o=new Map;for(let r=0;r<s.length;r++){const n=s[r],t=o.get(n.cell);if(t===void 0){const c=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,c-1)}else m.cellChanges[t]={...m.cellChanges[t],...n}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,v=y.end|0;return u<0&&(u=0),v>this.b.length&&(v=this.b.length),y.with({start:u,end:v})}p(y){y=this.o(y);const u=[];for(let v=y.start;v<y.end;v++)u.push(this.b[v]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,v){if(this.j)return;const m=[],s=[],o=[];if(y.reverse().forEach(r=>{const t=r[2].map(i=>{const $=new f(this,this.l,i);return u||s.push(f.asModelAddData(i)),$}),c=new p(r[0],r[1],[],t),l=this.b.splice(r[0],r[1],...t);for(const i of l)o.push(i.uri),c.deletedItems.push(i.apiCell);m.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),v)for(const r of m)v.push(r.asApiEvent())}s(y,u,v,m){const s=this.b.splice(y,u);this.b.splice(v,0,...s);const o=[new p(y,u,s.map(r=>r.apiCell),[]),new p(v,0,[],s)];for(const r of o)m.push(r.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,v,m){this.b[y].setOutputItems(u,v,m)}v(y,u){const v=this.b[y];v.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(v.uri,u)}w(y,u){const v=this.b[y];v.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Vlc=E}),define(Ce[265],Re([1,0,5,2,8,7,34]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;class p{constructor(E,T,y,u={timeout:1500,errors:3}){this.b=E,this.c=T,this.d=y,this.f=u,this.a=new I.$de}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(T,y,u)=>{const v=function(s){T.call(y,s)};return v.extension=E,this.a.event(v,void 0,u)}}async $participateInSave(E,T,y){const u=N.URI.revive(E),v=this.c.getNotebookDocument(u);if(!v)throw new Error("Unable to resolve notebook document");const m=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:A.TextDocumentSaveReason.to(T)},y,async(o,r)=>{const n=Date.now(),t=await await Promise.resolve(o);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier),!y.isCancellationRequested&&t&&(t instanceof F.$5M?m.push(t):this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(m.length===0)return!0;const s={edits:[]};for(const o of m){const{edits:r}=A.WorkspaceEdit.from(o);s.edits=s.edits.concat(r)}return this.d.$tryApplyWorkspaceEdit(new M.$ow(s))}}e.$$lc=p}),define(Ce[112],Re([1,0,14,8,7]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,f,E,T,y,u){this.id=p,this.f=f,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=T,this.c=u}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(f){this.selections=[f]},get selections(){return p.a},set selections(f){if(!Array.isArray(f)||!f.every(A.$jO.isNotebookRange))throw(0,I.$7)("selections");p.a=f,p.g(f)},get visibleRanges(){return p.b},revealRange(f,E){p.f.$tryRevealRange(p.id,N.NotebookRange.from(f),E??A.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(N.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Wlc=F}),define(Ce[266],Re([1,0,5,13,8]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=void 0;let F=class{constructor(p,f){this.c=p,this.d=f,this.a=new I.$be,this.b=new I.$be,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,f);const E=this.d.getEditorById(p);f.visibleRanges&&E._acceptVisibleRanges(f.visibleRanges.ranges.map(A.NotebookRange.to)),f.selections&&E._acceptSelections(f.selections.selections.map(A.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const f in p)this.d.getEditorById(f)._acceptViewColumn(A.ViewColumn.to(p[f]))}};e.$amc=F,e.$amc=F=Je([We(0,N.$Xj)],F)}),define(Ce[267],Re([1,0,5,4,112]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class F{constructor(p,f){this.c=f,this.a=new Map,this.b=p.getProxy(N.$SM.MainThreadNotebookRenderers)}$postRendererMessage(p,f,E){const T=this.c.getEditorById(p);this.a.get(f)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging(p,f){if(!p.contributes?.notebookRenderer?.some(T=>T.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(T,y,u)=>this.d(f).event(T,y,u),postMessage:(T,y)=>{A.$Wlc.apiEditorsToExtHost.has(T)&&([T,y]=[y,T]);const u=y&&A.$Wlc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,f,T)}}}d(p){let f=this.a.get(p);return f||(f=new I.$be({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(p)}}),this.a.set(p,f),f)}}e.$dmc=F}),define(Ce[268],Re([1,0,8,101,24,68,14]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=void 0;class p{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,v){const m=this.b++,{title:s,location:o,cancellable:r}=u,n={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(m,{location:I.ProgressLocation.from(o),title:s,source:n,cancellable:r},y.isUnderDevelopment?void 0:y.identifier.value).catch(M.$2),this.d(m,v,!!r)}d(y,u,v){let m;v&&(m=new A.$me,this.c.set(y,m));const s=r=>{this.a.$progressEnd(r),this.c.delete(r),m?.dispose()};let o;try{o=u(new E(this.a,y),v&&m?m.token:A.CancellationToken.None)}catch(r){throw s(y),r}return o.then(r=>s(y),r=>s(y)),o}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$hmc=p;function f(T,y){return T.message=y.message,typeof y.increment=="number"&&(typeof T.increment=="number"?T.increment+=y.increment:T.increment=y.increment),T}class E extends N.$3v{constructor(y,u){super(v=>this.throttledReport(v)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,F.$Xh)(100,(T,y)=>f(T,y),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Ce[269],Re([1,0,2,4,11,8]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=void 0;class M{static{this.a=0}constructor(f,E){this.d=E,this.c=new Map,this.b=f.getProxy(N.$SM.MainThreadQuickDiff)}$provideOriginalResource(f,E,T){const y=I.URI.revive(E),u=this.c.get(f);return u?(0,A.$jh)(()=>u.provideOriginalResource(y,T)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(f,E,T,y){const u=M.a++;return this.c.set(u,E),this.b.$registerQuickDiffProvider(u,F.DocumentSelector.from(f,this.d),T,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$imc=M}),define(Ce[270],Re([1,0,24,5,6,4,2,7,14,18,33,42,26,8]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=m;function m(s,o,r){const n=s.getProxy(F.$SM.MainThreadQuickOpen);class t{constructor(d,k){this.e=new Map,this.f=0,this.a=d,this.b=k}showQuickPick(d,k,g,S=I.CancellationToken.None){this.c=void 0;const w=Promise.resolve(k),C=++this.f,P=n.$show(C,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},S),W={},V=P.then(()=>W);return Promise.race([V,w]).then(q=>{if(q===W)return;const R=(0,u.$zG)(d,"quickPickItemTooltip");return w.then(j=>{const K=[];for(let re=0;re<j.length;re++){const ae=j[re];if(typeof ae=="string")K.push({label:ae,handle:re});else if(ae.kind===p.QuickPickItemKind.Separator)K.push({type:"separator",label:ae.label});else{ae.tooltip&&!R&&console.warn(`Extension '${d.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`);const ve=ae.iconPath?a(ae.iconPath):void 0;K.push({label:ae.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:R?v.MarkdownString.fromStrict(ae.tooltip):void 0,handle:re})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=re=>{g.onDidSelectItem(j[re])}),n.$setItems(C,K),P.then(re=>{if(typeof re=="number")return j[re];if(Array.isArray(re))return re.map(ae=>j[ae])})})}).then(void 0,q=>{if(!(0,f.$4)(q))return n.$setError(C,q),Promise.reject(q)})}$onItemSelected(d){this.c?.(d)}showInput(d,k=I.CancellationToken.None){return this.d=d?.validateInput,n.$input(d,typeof this.d=="function",k).then(void 0,g=>{if(!(0,f.$4)(g))return Promise.reject(g)})}async $validateInput(d){if(!this.d)return;const k=await this.d(d);if(!k||typeof k=="string")return k;let g;switch(k.severity){case p.InputBoxValidationSeverity.Info:g=T.default.Info;break;case p.InputBoxValidationSeverity.Warning:g=T.default.Warning;break;case p.InputBoxValidationSeverity.Error:g=T.default.Error;break;default:g=k.message?T.default.Error:T.default.Ignore;break}return{content:k.message,severity:g}}async showWorkspaceFolderPick(d,k=I.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!g)return;const S=await this.a.getWorkspaceFolders2();if(S)return S.find(w=>w.uri.toString()===g.uri.toString())}createQuickPick(d){const k=new b(d,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(d){const k=new h(d,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(d,k){this.e.get(d)?._fireDidChangeValue(k)}$onDidAccept(d){this.e.get(d)?._fireDidAccept()}$onDidChangeActive(d,k){const g=this.e.get(d);g instanceof b&&g._fireDidChangeActive(k)}$onDidChangeSelection(d,k){const g=this.e.get(d);g instanceof b&&g._fireDidChangeSelection(k)}$onDidTriggerButton(d,k){this.e.get(d)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(d,k,g){const S=this.e.get(d);S instanceof b&&S._fireDidTriggerItemButton(k,g)}$onDidHide(d){this.e.get(d)?._fireDidHide()}}class c{static{this.a=1}constructor(d,k){this.x=d,this.y=k,this._id=b.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$be,this.q=new N.$be,this.r=new N.$be,this.s=new N.$be,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(d){this.b=d,this.z({title:d})}get step(){return this.c}set step(d){this.c=d,this.z({step:d})}get totalSteps(){return this.d}set totalSteps(d){this.d=d,this.z({totalSteps:d})}get enabled(){return this.g}set enabled(d){this.g=d,this.z({enabled:d})}get busy(){return this.j}set busy(d){this.j=d,this.z({busy:d})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(d){this.k=d,this.z({ignoreFocusOut:d})}get value(){return this.l}set value(d){this.l=d,this.z({value:d})}get placeholder(){return this.m}set placeholder(d){this.m=d,this.z({placeholder:d})}get buttons(){return this.n}set buttons(d){this.n=d.slice(),this.o.clear(),d.forEach((k,g)=>{const S=k===p.$gO.Back?-1:g;this.o.set(S,k)}),this.z({buttons:d.map((k,g)=>({...a(k.iconPath),tooltip:k.tooltip,handle:k===p.$gO.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(d){this.l=d,this.q.fire(d)}_fireDidTriggerButton(d){const k=this.o.get(d);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(d){if(!this.v){for(const k of Object.keys(d)){const g=d[k];this.u[k]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function l(D){if(D instanceof p.$QN)return{id:D.id};const d=$(D),k=i(D);return{dark:typeof d=="string"?M.URI.file(d):d,light:typeof k=="string"?M.URI.file(k):k}}function i(D){return typeof D=="object"&&"light"in D?D.light:D}function $(D){return typeof D=="object"&&"dark"in D?D.dark:D}function a(D){const d=l(D);let k,g;return"id"in d?g=y.ThemeIcon.asClassName(d):k=d,{iconPath:k,iconClass:g}}class b extends c{constructor(d,k){super(d.identifier,k),this.O=d,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$be,this.L=[],this.M=new N.$be,this.N=new N.$be,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(d){this.B=d.slice(),this.C.clear(),this.D.clear(),d.forEach((S,w)=>{this.C.set(w,S),this.D.set(S,w)});const k=(0,u.$zG)(this.O,"quickPickItemTooltip"),g=[];for(let S=0;S<d.length;S++){const w=d[S];if(w.kind===p.QuickPickItemKind.Separator)g.push({type:"separator",label:w.label});else{w.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=w.iconPath?a(w.iconPath):void 0;g.push({handle:S,label:w.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:k?v.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((P,W)=>({...a(P.iconPath),tooltip:P.tooltip,handle:W}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(d){this.E=d,this.z({canSelectMany:d})}get matchOnDescription(){return this.F}set matchOnDescription(d){this.F=d,this.z({matchOnDescription:d})}get matchOnDetail(){return this.G}set matchOnDetail(d){this.G=d,this.z({matchOnDetail:d})}get sortByLabel(){return this.H}set sortByLabel(d){this.H=d,this.z({sortByLabel:d})}get keepScrollPosition(){return this.I}set keepScrollPosition(d){this.I=d,this.z({keepScrollPosition:d})}get activeItems(){return this.J}set activeItems(d){this.J=d.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(d){this.L=d.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(d){const k=(0,E.$Hb)(d.map(g=>this.C.get(g)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(d){const k=(0,E.$Hb)(d.map(g=>this.C.get(g)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(d,k){const g=this.C.get(d);if(!g||!g.buttons||!g.buttons.length)return;const S=g.buttons[k];S&&this.N.fire({button:S,item:g})}}class h extends c{constructor(d,k){super(d.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(d){this.B=d,this.z({password:d})}get prompt(){return this.C}set prompt(d){this.C=d,this.z({prompt:d})}get valueSelection(){return this.D}set valueSelection(d){this.D=d,this.z({valueSelection:d})}get validationMessage(){return this.E}set validationMessage(d){this.E=d,d?typeof d=="string"?this.z({validationMessage:d,severity:T.default.Error}):this.z({validationMessage:d.message,severity:d.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new t(o,r)}}),define(Ce[271],Re([1,0,2,5,68,6,11,4,18,143,13,20,42,8,26,12,21]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0;function n(C){return C instanceof I.URI}function t(C,P){return C.scheme===s.Schemas.file&&P.scheme===s.Schemas.file&&o.$k?C.toString()===P.toString():C.toString().toLowerCase()===P.toString().toLowerCase()}function c(C){if(C)return typeof C.iconPath=="string"?I.URI.file(C.iconPath):I.URI.isUri(C.iconPath)||u.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function l(C){if(C.icon){if(I.URI.isUri(C.icon))return C.icon;if(u.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const P=C.icon;return{light:P.light,dark:P.dark}}}else return}function i(C,P){if(!C.iconPath&&!P.iconPath)return 0;if(C.iconPath){if(!P.iconPath)return 1}else return-1;const W=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,V=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,E.$lr)(W,V)}function $(C,P){let W=0;if(C.strikeThrough!==P.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==P.faded)return C.faded?1:-1;if(C.tooltip!==P.tooltip)return(C.tooltip||"").localeCompare(P.tooltip||"");if(W=i(C,P),W!==0)return W;if(C.light&&P.light)W=i(C.light,P.light);else{if(C.light)return 1;if(P.light)return-1}if(W!==0)return W;if(C.dark&&P.dark)W=i(C.dark,P.dark);else{if(C.dark)return 1;if(P.dark)return-1}return W}function a(C,P){if(C.command!==P.command)return C.command<P.command?-1:1;if(C.title!==P.title)return C.title<P.title?-1:1;if(C.tooltip!==P.tooltip){if(C.tooltip!==void 0&&P.tooltip!==void 0)return C.tooltip<P.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(C.arguments===P.arguments)return 0;if(C.arguments)if(P.arguments){if(C.arguments.length!==P.arguments.length)return C.arguments.length-P.arguments.length}else return 1;else return-1;for(let W=0;W<C.arguments.length;W++){const V=C.arguments[W],q=P.arguments[W];if(V!==q&&!(n(V)&&n(q)&&t(V,q)))return V<q?-1:1}return 0}function b(C,P){let W=(0,E.$lr)(C.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(W!==0)return W;if(C.command&&P.command)W=a(C.command,P.command);else{if(C.command)return 1;if(P.command)return-1}if(W!==0)return W;if(C.decorations&&P.decorations)W=$(C.decorations,P.decorations);else{if(C.decorations)return 1;if(P.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)W=(0,E.$lr)(C.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)W=(0,E.$lr)(C.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return W}function h(C,P){for(let W=0;W<C.length;W++)if(C[W]!==P[W])return!1;return!0}function D(C,P){return C.command===P.command&&C.title===P.title&&C.tooltip===P.tooltip&&(C.arguments&&P.arguments?h(C.arguments,P.arguments):C.arguments===P.arguments)}function d(C,P){return(0,f.$ub)(C,P,D)}class k{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,m.$AG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,m.$AG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,m.$AG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,W,V,q,R){this.k=P,this.l=q,this.m=R,this.d="",this.e=new N.$be,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(P,W){(0,m.$AG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,W)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$kmc=k;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,W,V,q,R,j,K){this.q=P,this.s=W,this.t=V,this.u=q,this.v=R,this.multiDiffEditorEnableViewChanges=j,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$be,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$be,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,W){const V=this.h.get(P);return V?(0,M.$jh)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(b),V=(0,f.$Db)(this.o,P,b).map(j=>{const K=j.toInsert.map(re=>{const ae=this.e++;this.g.set(ae,re);const ve=re.resourceUri;let Ie;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const fe=new F.$Tc;Ie=this.s.converter.toInternal(re.command,fe),this.j.set(ae,fe)}else this.h.set(ae,re.command);const de=(0,m.$zG)(this.w,"scmMultiDiffEditor"),me=de?re.multiDiffEditorOriginalUri:void 0,Me=de?re.multiFileDiffEditorModifiedUri:void 0,ce=c(re.decorations),Ae=re.decorations&&c(re.decorations.light)||ce,ie=re.decorations&&c(re.decorations.dark)||ce,L=[Ae,ie],x=re.decorations&&re.decorations.tooltip||"",be=re.decorations&&!!re.decorations.strikeThrough,Oe=re.decorations&&!!re.decorations.faded,Ee=re.contextValue||"";return{rawResource:[ae,ve,L,x,be,Oe,Ee,Ie,me,Me],handle:ae}});return{start:j.start,deleteCount:j.deleteCount,toInsert:K}}),q=V.map(({start:j,deleteCount:K,toInsert:re})=>[j,K,re.map(ae=>ae.rawResource)]),R=V.reverse();for(const{start:j,deleteCount:K,toInsert:re}of R){const ae=re.map(Ie=>Ie.handle),ve=this.n.splice(j,K,...ae);for(const Ie of ve)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let W;(0,m.$zG)(this.x,"quickDiffProvider")&&(W=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:W})}get historyProvider(){return(0,m.$AG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,m.$AG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new F.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new F.$Tc,this.o=P;const W=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,m.$AG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,m.$AG)(this.x,"scmActionButton"),this.p.value=new F.$Tc,this.q=P;const W=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&d(this.t,P))return;this.s.value=new F.$Tc,this.t=P;const W=(P||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(P,W,V,q,R,j,K){this.x=P,this.y=q,this.z=R,this.A=j,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Vc,this.m=void 0,this.n=new F.$Vc,this.o=void 0,this.p=new F.$Vc,this.s=new F.$Vc,this.t=void 0,this.u=!1,this.v=new N.$be,this.onDidChangeSelection=this.v.event,this.w=S.d++,this.C=new Map,this.D=new Set,this.#e=V;const re=I.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${R}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new k(P,W,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,R,j,K,re)}createResourceGroup(P,W,V){const q=(0,m.$zG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,R=new g(this.#e,this.y,this.w,P,W,q,this.x),j=N.Event.once(R.onDidDispose)(()=>this.C.delete(R));return this.C.set(R,j),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const P=[],W=[];for(const[V,q]of this.C){q.dispose();const R=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});N.Event.once(V.onDidDispose)(()=>{this.D.delete(V),R.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),P.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const j=V._takeResourceStateSnapshot();j.length>0&&W.push([V.handle,j]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,P,W),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&P.push([W.handle,V])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,A.$Wh)(100)],S.prototype,"eventuallyAddResourceGroups",null),Je([(0,A.$Wh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new y.$Om,this.j=new N.$be,this.e=P.getProxy(p.$SM.MainThreadSCM),this.f=P.getProxy(p.$SM.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const j=this.g.get(R.sourceControlHandle);if(!j)return R;const K=j.getResourceGroup(R.groupHandle);return K?K.getResourceState(R.handle):R}else if(R&&R.$mid===4){const j=this.g.get(R.sourceControlHandle);return j?j.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const j=this.g.get(R.handle);return j||R}return R}})}createSourceControl(P,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const R=r.d++,j=new S(P,this.m,this.e,this.l,W,V,q);this.g.set(R,j);const K=this.h.get(P.identifier)||[];return K.push(j),this.h.set(P.identifier,K),j}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const W=this.h.get(P.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(P,W,V){const q=I.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const R=this.g.get(P);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$jh)(()=>R.quickDiffProvider.provideOriginalResource(q,V)).then(j=>j||null)}$onInputBoxValueChange(P,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const V=this.g.get(P);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(P,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,W,V);const R=this.g.get(P);if(!R)return Promise.resolve(void 0);const j=R.getResourceGroup(W);return j?j.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(P,W,V){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$jh)(()=>q.inputBox.validateInput(W,V)).then(R=>{if(!R)return Promise.resolve(void 0);const j=v.MarkdownString.fromStrict(R.message);return j?Promise.resolve([j,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,W,V,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(P,W,V,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(W,V,q))?.map(K=>({...K,icon:l(K)}))??void 0}async $provideHistoryItemSummary(P,W,V,q){const R=this.g.get(P)?.historyProvider;if(typeof R?.provideHistoryItemSummary!="function")return;const j=await R.provideHistoryItemSummary(W,V,q);return j?{...j,icon:l(j)}:void 0}async $provideHistoryItemChanges(P,W,V,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$lmc=w,e.$lmc=w=r=Je([We(3,T.$Xj)],w)}),define(Ce[272],Re([1,0,4,8,2]),function(ge,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class F{static{this.a=0}constructor(p,f){this.d=f,this.c=new Map,this.b=p.getProxy(I.$SM.MainThreadShare)}async $provideShare(p,f,E){return await this.c.get(p)?.provideShare({selection:N.Range.to(f.selection),resourceUri:A.URI.revive(f.resourceUri)},E)??void 0}registerShareProvider(p,f){const E=F.a++;return this.c.set(E,f),this.b.$registerShareProvider(E,N.DocumentSelector.from(p,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$mmc=F}),define(Ce[273],Re([1,0,7,4,169,6,8,17]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=e.$omc=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$RN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$RN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,v,m,s,o,r=I.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new F.$Tc,this.#e=u,this.#t=v,o&&s){this.c=(0,I.$tN)(s.identifier,o);const t=m.get(this.c);t&&(r=t.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,n=t.priority,this.j=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this.c=String(f.a++);this.e=s,this.f=o,this.g=r,this.h=this.u(n)}u(u){if((0,p.$9f)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!f.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new F.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let v;this.m?v=this.m:v=(0,A.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=f.b.get(this.o.id));const s=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,v,this.k,s,this.r?.internal,m,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$omc=f;class E{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const v={message:u};return this.b.unshift(v),this.c(),new I.$UM(()=>{const m=this.b.indexOf(v);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(u,v){this.e=new Map,this.a=u.getProxy(N.$SM.MainThreadStatusBar),this.b=v,this.c=new E(this)}$acceptStaticEntries(u){for(const v of u)this.e.set(v.entryId,v)}createStatusBarEntry(u,v,m,s){return new f(this.a,this.b,this.e,u,v,m,s)}setStatusBarMessage(u,v){const m=this.c.setMessage(u);let s;return typeof v=="number"?s=setTimeout(()=>m.dispose(),v):typeof v<"u"&&v.then(()=>m.dispose(),()=>m.dispose()),new I.$UM(()=>{m.dispose(),clearTimeout(s)})}}e.$pmc=T}),define(Ce[113],Re([1,0,29,105,50,75,61,8,2]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.$tP=e.$sP=e.$rP=void 0;const E=(t,c,l,i)=>{let $=c;return{enumerable:!0,configurable:!1,get(){return $},set(a){if(!l($,a)){const b=$;$=a,t.listener?.(i(a,b))}}}},T=(t,c)=>t===c,y={range:(t,c)=>t===c?!0:!t||!c?!1:t.isEqual(c),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(t,c)=>!(t.length!==c.length||t.some(l=>!c.find(i=>l.id===i.id)))},u=t=>c=>({op:4,update:t(c)}),v=(t,c)=>({range:(()=>{let l;const i=u($=>({range:I.$nt.lift(p.Range.from($))}));return{enumerable:!0,configurable:!1,get(){return l},set($){t.listener?.({op:6}),y.range(l,$)||(l=$,t.listener?.(i($)))}}})(),label:E(t,c,y.label,u(l=>({label:l}))),description:E(t,void 0,y.description,u(l=>({description:l}))),sortText:E(t,void 0,y.sortText,u(l=>({sortText:l}))),canResolveChildren:E(t,!1,y.canResolveChildren,l=>({op:2,state:l})),busy:E(t,!1,y.busy,u(l=>({busy:l}))),error:E(t,void 0,y.error,u(l=>({error:p.MarkdownString.fromStrict(l)||null}))),tags:E(t,[],y.tags,(l,i)=>({op:1,new:l.map(p.TestTag.from),old:i.map(p.TestTag.from)}))}),m=t=>{const c=A.$EL.fromString(t.extId),l=new o(c.controllerId,c.localId,t.label,f.URI.revive(t.uri)||void 0);return l.range=p.Range.to(t.range||void 0),l.description=t.description||void 0,l.sortText=t.sortText||void 0,l.tags=t.tags.map(i=>p.TestTag.to({id:(0,M.$KL)(i).tagId})),l},s=t=>{let c;for(const l of t.tests){const i=m(l.item);(0,N.$bP)(i).parent=c,c=i}return c};e.$rP=s;class o{constructor(c,l,i,$){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const a=(0,N.$aP)(this,c);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:$,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof r?void 0:a.parent}},children:{value:(0,F.$_O)(a,N.$bP,o),enumerable:!0,writable:!1},...v(a,i)})}}e.$sP=o;class r extends o{constructor(c,l){super(c,c,l,void 0),this._isRoot=!0}}e.$tP=r;class n extends F.$8O{constructor(c,l,i){super({controllerId:c,getDocumentVersion:$=>$&&i.getDocument($)?.version,getApiFor:N.$bP,getChildren:$=>$.children,root:new r(c,l),toITestItem:p.TestItem.from})}}e.$uP=n}),define(Ce[32],Re([1,0,17,7,8,25,4,18,13,53,29,93,2,6,3,16,113,22,34,43,65,59,62,35]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t,c,l,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=void 0;let a=class{#e;#t;#i;constructor(g,S,w){this.b=new Map,this.c=new Map,this.#e=g.getProxy(M.$SM.MainThreadCommands),this.d=S,this.#i=w,this.#t=g.getProxy(M.$SM.MainThreadTelemetry),this.converter=new b(this,C=>{const P=this.c.get(C);return P?.result===D.Void?P:void 0},S),this.f=[{processArgument(C){return(0,E.$1h)(C)}},{processArgument(C){return(0,F.$Zn)(C,function(P){if(T.$nt.isIRange(P))return A.Range.to(P);if(y.$mt.isIPosition(P))return A.Position.to(P);if(T.$nt.isIRange(P.range)&&u.URI.isUri(P.uri))return A.location.to(P);if(P instanceof r.$Ce)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const S=this.registerCommand(!1,g.id,async(...w)=>{const C=g.args.map((W,V)=>{if(!W.validate(w[V]))throw new Error(`Invalid argument '${W.name}' when running '${g.id}', received: ${typeof w[V]=="object"?JSON.stringify(w[V],null,"	"):w[V]} `);return W.convert(w[V])}),P=await this.executeCommand(g.internalId,...C);return g.result.convert(P,w,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new N.$UM(()=>{S.dispose(),this.c.delete(g.id)})}registerCommand(g,S,w,C,P,W){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:w,thisArg:C,metadata:P,extension:W}),g&&this.#e.$registerCommand(S),new N.$UM(()=>{this.b.delete(S)&&g&&this.#e.$unregisterCommand(S)})}executeCommand(g,...S){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,S,!0)}async g(g,S,w){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,S,!1);{let C=!1;const P=(0,F.$Zn)(S,function(W){if(W instanceof N.$VM)return A.Position.from(W);if(W instanceof N.$WM)return A.Range.from(W);if(W instanceof N.$7M)return A.location.from(W);if(N.$jO.isNotebookRange(W))return A.NotebookRange.from(W);if(W instanceof ArrayBuffer)return C=!0,r.$Ce.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return C=!0,r.$Ce.wrap(W);if(W instanceof r.$Ce)return C=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(g,C?new n.$ow(P):P,w);return(0,E.$1h)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(g,S,!1);throw W}}}async h(g,S,w){const C=this.b.get(g);if(!C)throw new Error("Unknown command");const{callback:P,thisArg:W,metadata:V}=C;if(V?.args)for(let R=0;R<V.args.length;R++)try{(0,I.$jg)(S[R],V.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${V.args[R].name}' - ${V.args[R].description}`)}const q=c.$0d.create();try{return await P.apply(W,S)}catch(R){if(g===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...S);j&&(g=j.command)}if(this.d.error(R,g,C.extension?.identifier),!w)throw R;if(C.extension?.identifier){const j=this.#i.onExtensionError(C.extension.identifier,R);this.d.trace("forwarded error to extension?",j,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,t.$cj)(R)),this.id=g,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,g,q.elapsed())}}j(g,S,w){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new l.$ap(S),duration:w})}$executeContributedCommand(g,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const w=this.b.get(g);return w?(S=S.map(C=>this.f.reduce((P,W)=>W.processArgument(P,w.extension?.identifier),C)),this.h(g,S,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(S=>(g&&(S=S.filter(w=>w[0]!=="_")),S))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[S,w]of this.b){const{metadata:C}=w;C&&(g[S]=C)}return Promise.resolve(g)}};e.$AP=a,e.$AP=a=Je([We(0,s.$fP),We(1,f.$Xj),We(2,i.$zP)],a),e.$BP=(0,m.$ri)("IExtHostCommands");class b{constructor(g,S,w){this.d=g,this.f=S,this.g=w,this.delegatingCommandId=`__vsc${(0,$.$Ng)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,S){if(!g)return;const w={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return w;const C=this.f(g.command);if(C)w.id=C.internalId,w.arguments=C.args.map((P,W)=>P.convert(g.arguments&&g.arguments[W]));else if((0,p.$Lb)(g.arguments)){const P=`${g.command} /${++this.c}`;this.b.set(P,g),S.add((0,v.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),w.$ident=P,w.id=this.delegatingCommandId,w.arguments=[P],this.g.trace("CommandsConverter#CREATE",g.command,P)}return w}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const S=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$CP=b;class h{static{this.Uri=new h("uri","Uri of a text document",g=>u.URI.isUri(g),g=>g)}static{this.Position=new h("position","A position in a text document",g=>N.$VM.isPosition(g),A.Position.from)}static{this.Range=new h("range","A range in a text document",g=>N.$WM.isRange(g),A.Range.from)}static{this.Selection=new h("selection","A selection in a text document",g=>N.$XM.isSelection(g),A.Selection.from)}static{this.Number=new h("number","",g=>typeof g=="number",g=>g)}static{this.String=new h("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=h.Arr(h.String)}static Arr(g){return new h(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,S=>Array.isArray(S)&&S.every(w=>g.validate(w)),S=>S.map(w=>g.convert(w)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",g=>g instanceof N.$fN,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",g=>g instanceof N.$DO,A.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",g=>g instanceof o.$sP,A.TestItem.from)}constructor(g,S,w,C){this.name=g,this.description=S,this.validate=w,this.convert=C}optional(){return new h(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,S){return new h(g??this.name,S??this.description,this.validate,this.convert)}}e.$DP=h;class D{static{this.Void=new D("no result",g=>g)}constructor(g,S){this.description=g,this.convert=S}}e.$EP=D;class d{constructor(g,S,w,C,P){this.id=g,this.internalId=S,this.description=w,this.args=C,this.result=P}}e.$FP=d}),define(Ce[274],Re([1,0,18,12,2,87,97,31,32,8,7]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=void 0;const y=[new f.$FP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$DP.Uri,f.$DP.Position],new f.$EP("A promise that resolves to an array of DocumentHighlight-instances.",v(E.DocumentHighlight.to))),new f.$FP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$DP.Uri],new f.$EP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,I.$Kb)(s))return;class r extends T.$aN{static to(t){const c=new r(t.name,E.SymbolKind.to(t.kind),t.containerName||"",new T.$7M(o[0],E.Range.to(t.range)));return c.detail=t.detail,c.range=c.location.range,c.selectionRange=E.Range.to(t.selectionRange),c.children=t.children?t.children.map(r.to):[],c}}return s.map(r.to)})),new f.$FP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$DP.Uri,new f.$DP("options","Formatting options",s=>!0,s=>s)],new f.$EP("A promise that resolves to an array of TextEdits.",v(E.TextEdit.to))),new f.$FP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$DP.Uri,f.$DP.Range,new f.$DP("options","Formatting options",s=>!0,s=>s)],new f.$EP("A promise that resolves to an array of TextEdits.",v(E.TextEdit.to))),new f.$FP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$DP.Uri,f.$DP.Position,new f.$DP("ch","Trigger character",s=>typeof s=="string",s=>s),new f.$DP("options","Formatting options",s=>!0,s=>s)],new f.$EP("A promise that resolves to an array of TextEdits.",v(E.TextEdit.to))),new f.$FP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$DP.Uri,f.$DP.Position],new f.$EP("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$FP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$DP.Uri,f.$DP.Position],new f.$EP("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$FP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$DP.Uri,f.$DP.Position],new f.$EP("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$FP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$DP.Uri,f.$DP.Position],new f.$EP("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$FP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$DP.Uri,f.$DP.Position],new f.$EP("A promise that resolves to an array of Location-instances.",v(E.location.to))),new f.$FP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$DP.Uri,f.$DP.Position],new f.$EP("A promise that resolves to an array of Hover-instances.",v(E.Hover.to))),new f.$FP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$DP.Uri,new f.$DP("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>T.$VM.isPosition(o)),s=>s.map(E.Position.from))],new f.$EP("A promise that resolves to an array of ranges.",s=>s.map(o=>{let r;for(const n of o.reverse())r=new T.$eN(E.Range.to(n),r);return r}))),new f.$FP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$DP.String.with("query","Search string")],new f.$EP("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(E.WorkspaceSymbol.to))),new f.$FP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$DP.Uri,f.$DP.Position],new f.$EP("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(E.CallHierarchyItem.to))),new f.$FP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$DP.CallHierarchyItem],new f.$EP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(E.CallHierarchyIncomingCall.to))),new f.$FP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$DP.CallHierarchyItem],new f.$EP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(E.CallHierarchyOutgoingCall.to))),new f.$FP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$DP.Uri,f.$DP.Position],new f.$EP("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:E.Range.to(s.range),placeholder:s.text}})),new f.$FP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$DP.Uri,f.$DP.Position,f.$DP.String.with("newName","The new symbol name")],new f.$EP("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return E.WorkspaceEdit.to(s)}})),new f.$FP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$DP.Uri,f.$DP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$EP("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(E.DocumentLink.to))),new f.$FP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$DP.Uri],new f.$EP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$aO(s.tokenTypes,s.tokenModifiers)})),new f.$FP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$DP.Uri],new f.$EP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$Nbb)(s);if(o.type==="full")return new T.$cO(o.data,void 0)})),new f.$FP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$DP.Uri,f.$DP.Range.optional()],new f.$EP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$aO(s.tokenTypes,s.tokenModifiers)})),new f.$FP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$DP.Uri,f.$DP.Range],new f.$EP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$Nbb)(s);if(o.type==="full")return new T.$cO(o.data,void 0)})),new f.$FP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$DP.Uri,f.$DP.Position,f.$DP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$DP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$EP("A promise that resolves to a CompletionList-instance.",(s,o,r)=>{if(!s)return new T.$qN([]);const n=s.suggestions.map(t=>E.CompletionItem.to(t,r));return new T.$qN(n,s.incomplete)})),new f.$FP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$DP.Uri,f.$DP.Position,f.$DP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$EP("A promise that resolves to SignatureHelp.",s=>{if(s)return E.SignatureHelp.to(s)})),new f.$FP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$DP.Uri,f.$DP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$EP("A promise that resolves to an array of CodeLens-instances.",(s,o,r)=>v(n=>new T.$iN(E.Range.to(n.range),n.command&&r.fromInternal(n.command)))(s))),new f.$FP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$DP.Uri,new f.$DP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.$WM.isRange(s),s=>T.$XM.isSelection(s)?E.Selection.from(s):E.Range.from(s)),f.$DP.String.with("kind","Code action kind to return code actions for").optional(),f.$DP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$EP("A promise that resolves to an array of Command-instances.",(s,o,r)=>v(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(n.command)}else{const t=new T.$cN(n.title,n.kind?new T.$dN(n.kind):void 0);return n.edit&&(t.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(t.command=r.fromInternal(n.command)),t.isPreferred=n.isPreferred,t}})(s))),new f.$FP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$DP.Uri],new f.$EP("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new T.$wN(E.Range.to(o.range),E.Color.to(o.color))):[])),new f.$FP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$DP("color","The color to show and insert",s=>s instanceof T.$vN,E.Color.from),new f.$DP("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:E.Range.from(s.range)}))],new f.$EP("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(E.ColorPresentation.to):[])),new f.$FP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$DP.Uri,f.$DP.Range],new f.$EP("A promise that resolves to an array of Inlay objects",(s,o,r)=>s.map(E.InlayHint.to.bind(void 0,r)))),new f.$FP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$DP.Uri],new f.$EP("A promise that resolves to an array of FoldingRange objects",(s,o)=>{if(s)return s.map(E.FoldingRange.to)})),new f.$FP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$EP("A promise that resolves to an array of NotebookContentProvider static info objects.",v(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>E.NotebookExclusiveDocumentPattern.to(o))})))),new f.$FP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$DP.Uri,f.$DP.Range,new f.$DP("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof T.$WM,s=>E.InlineValueContext.from(s))],new f.$EP("A promise that resolves to an array of InlineValue objects",s=>s.map(E.InlineValue.to))),new f.$FP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$DP("uriOrString","Uri-instance or string (only http/https)",s=>A.URI.isUri(s)||typeof s=="string"&&(0,N.$Bg)(s,N.Schemas.http,N.Schemas.https),s=>s),new f.$DP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[E.ViewColumn.from(s),void 0]:[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)])).optional(),f.$DP.String.with("label","").optional()],f.$EP.Void),new f.$FP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$DP.Uri.with("resource","Resource to open"),f.$DP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$DP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[E.ViewColumn.from(s),void 0]:[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)])).optional()],f.$EP.Void),new f.$FP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$DP.Uri.with("left","Left-hand side resource of the diff editor"),f.$DP.Uri.with("right","Right-hand side resource of the diff editor"),f.$DP.String.with("title","Human readable title for the diff editor").optional(),new f.$DP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)]).optional()],f.$EP.Void),new f.$FP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$DP.String.with("title","Human readable title for the changes editor"),new f.$DP("resourceList","List of resources to compare",s=>{for(const o of s){if(o.length!==3)return!1;const[r,n,t]=o;if(!A.URI.isUri(r)||!A.URI.isUri(n)&&n!==void 0&&n!==null||!A.URI.isUri(t)&&t!==void 0&&t!==null)return!1}return!0},s=>s)],f.$EP.Void),new f.$FP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$DP.Uri,f.$DP.Position],new f.$EP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new f.$FP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$DP.TypeHierarchyItem],new f.$EP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new f.$FP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$DP.TypeHierarchyItem],new f.$EP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new f.$FP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$DP.TestItem],f.$EP.Void),new f.$FP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$DP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$EP.Void),new f.$FP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$DP.String.with("name","The context key name"),new f.$DP("value","The context key value",()=>!0,s=>s)],f.$EP.Void),new f.$FP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$DP.Uri,f.$DP.StringArray,new f.$DP("MappedEditsContext","Mapped Edits Context",s=>E.MappedEditsContext.is(s),s=>E.MappedEditsContext.from(s))],new f.$EP("A promise that resolves to a workspace edit or null",s=>s?E.WorkspaceEdit.to(s):null))];class u{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",p.$qj)}}e.$Kkc=u;function v(s){return o=>{if(Array.isArray(o))return o.map(s)}}function m(s){if(!Array.isArray(s))return;const o=[];for(const r of s)F.$5t(r)?o.push(E.DefinitionLink.to(r)):o.push(E.location.to(r));return o}}),define(Ce[275],Re([1,0,11,6,2,4,32,8,7]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=void 0;class E{static{this.a=0}constructor(v,m){this.extension=v,this.provider=m,this.handle=E.a++}}class T{constructor(v){this.session=v,this.responses=[]}}class y{static{this.a=0}constructor(v,m,s,o){this.f=s,this.g=o,this.b=new Map,this.d=new Map,this.e=v.getProxy(F.$SM.MainThreadInlineChat),m.registerApiCommand(new M.$FP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$DP("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?p.Range.from(r.initialRange):void 0,initialSelection:f.$XM.isSelection(r.initialSelection)?p.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?p.Position.from(r.position):void 0}})],M.$EP.Void))}registerProvider(v,m,s){const o=new E(v,m);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,s?.label??v.displayName??v.name,v.identifier,typeof m.handleInteractiveEditorResponseFeedback=="function",typeof m.provideFollowups=="function",s?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(v,m,s,o){const r=this.b.get(v);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(A.URI.revive(m)),t=p.Selection.to(s),c=await r.provider.prepareInteractiveEditorSession({document:n,selection:t},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(t))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=y.a++;return this.d.set(l,new T(c)),{id:l,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:p.Range.from(c.wholeRange),message:c.message}}async $provideResponse(v,m,s,o){const r=this.b.get(v);if(!r)return;const n=this.d.get(m.id);if(!n)return;const t={prompt:s.prompt,selection:p.Selection.to(s.selection),wholeRange:p.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(A.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let c=!1;const l={report:async k=>{if(!s.live&&k.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:k.message,edits:k.edits?.map(p.TextEdit.from),editsShouldBeInstant:k.editsShouldBeInstant,slashCommand:k.slashCommand?.command,markdownFragment:f.$jN.isMarkdownString(k.content)?k.content.value:k.content})}},i=Promise.resolve(r.provider.provideInteractiveEditorResponse(n.session,t,l,o));let $;try{$=await(0,I.$fh)(i,o)}finally{c=!0}if(!$)return;const a=n.responses.push($)-1,b={wholeRange:p.Range.from($.wholeRange),placeholder:$.placeholder};if(!y.h($))return{...b,id:a,type:"editorEdit",message:p.MarkdownString.from($.contents),edits:[]};const{edits:h,contents:D}=$,d=D!==void 0?p.MarkdownString.from(D):void 0;return h instanceof f.$5M?{...b,id:a,type:"bulkEdit",edits:p.WorkspaceEdit.from(h),message:d}:{...b,id:a,type:"editorEdit",edits:h.map(p.TextEdit.from),message:d}}async $provideFollowups(v,m,s,o){const r=this.b.get(v),n=this.d.get(m),t=n?.responses[s];if(r&&t&&r.provider.provideFollowups){const c=Promise.resolve(r.provider.provideFollowups(n.session,t,o));return(await(0,I.$fh)(c,o))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(v,m,s,o){const r=this.b.get(v),n=this.d.get(m),t=n?.responses[s];if(r&&t){const c=p.InteractiveEditorResponseFeedbackKind.to(o);r.provider.handleInteractiveEditorResponseFeedback?.(n.session,t,c)}}$releaseSession(v,m){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$Tlc=y}),define(Ce[276],Re([1,0,2,32]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=void 0;class A{constructor(M,p,f,E,T){this.a=p,this.b=f,this.c=E;const y=new N.$FP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$DP("showOptions","Show Options",u=>!0,u=>u),new N.$DP("resource","Interactive resource Uri",u=>!0,u=>u),new N.$DP("controllerId","Notebook controller Id",u=>!0,u=>u),new N.$DP("title","Interactive editor title",u=>!0,u=>u)],new N.$EP("Notebook and input URI",u=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const v=this.a.getEditorById(u.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:v.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(M,p,f,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:f,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$7lc=A}),define(Ce[277],Re([1,0,18,11,24,5,6,28,2,20,13,4,32,8,7,76,218,26,34,219]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=void 0,e.$cmc=h;let c=class{constructor(d,k,g,S,w){this.m=k,this.n=g,this.o=S,this.q=w,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new F.$be,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(y.$SM.MainThreadNotebookKernels);const C=new u.$FP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$DP("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],u.$EP.Void),P=new u.$FP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$DP.Uri],new u.$EP("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(P)}createNotebookController(d,k,g,S,w,C){for(const ce of this.j.values())if(ce.controller.id===k&&E.$Mm.equals(d.identifier,ce.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const P=this.k++,W=this;this.q.trace(`NotebookController[${P}], CREATED by ${d.identifier.value}, ${k}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${d.identifier}'`);let q=!1;const R=new F.$be,j=new F.$be,K={id:h(d.identifier,k),notebookType:g,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:S||d.identifier.value,preloads:C?C.map(v.NotebookRendererScript.from):[]};let re=w??V,ae,ve;this.a.$addKernel(P,K).catch(ce=>{console.log(ce),q=!0});let Ie=0;const de=()=>{if(q)return;const ce=++Ie;Promise.resolve().then(()=>{ce===Ie&&this.a.$updateKernel(P,K)})},me=new p.$Bc,Me={get id(){return k},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return K.label},set label(ce){K.label=ce??d.displayName??d.name,de()},get detail(){return K.detail??""},set detail(ce){K.detail=ce,de()},get description(){return K.description??""},set description(ce){K.description=ce,de()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(ce){K.supportedLanguages=ce,de()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){K.supportsExecutionOrder=ce,de()},get rendererScripts(){return K.preloads?K.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler(ce){re=ce??V},get interruptHandler(){return ae},set interruptHandler(ce){ae=ce,K.supportsInterrupt=!!ce,de()},set variableProvider(ce){(0,r.$AG)(d,"notebookVariableProvider"),ve=ce,K.hasVariableProvider=!!ce,ce?.onDidChangeVariables(Ae=>W.a.$variablesUpdated(Ae.uri)),de()},get variableProvider(){return ve},createNotebookCellExecution(ce){if(q)throw new Error("notebook controller is DISPOSED");if(!me.has(ce.notebook.uri))throw W.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(Ae=>Ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return W._createNotebookCellExecution(ce,h(d.identifier,this.id))},createNotebookExecution(ce){if((0,r.$AG)(d,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!me.has(ce.uri))throw W.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(Ae=>Ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.uri.toString()}`);return W._createNotebookExecution(ce,h(d.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),R.dispose(),j.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(ce,Ae){Ae===m.NotebookControllerAffinity2.Hidden&&(0,r.$AG)(d,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(P,ce.uri,Ae)},onDidReceiveMessage:j.event,postMessage(ce,Ae){return(0,r.$AG)(d,"notebookMessaging"),W.a.$postMessage(P,Ae&&W.n.getIdByEditor(Ae),ce)},asWebviewUri(ce){return(0,r.$AG)(d,"notebookMessaging"),(0,s.$_xb)(ce,W.m.remote)}};return this.j.set(P,{extensionId:d.identifier,controller:Me,onDidReceiveMessage:j,onDidChangeSelection:R,associatedNotebooks:me}),Me}getIdByController(d){for(const[k,g]of this.j)if(g.controller===d)return h(g.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,k){const g=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(g,k);const w={dispose:()=>{this.f.delete(g),S.a.$removeKernelDetectionTask(g)}};return this.f.set(g,w),w}registerKernelSourceActionProvider(d,k,g){const S=this.i++,w=typeof g.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,C=this;this.h.set(S,g),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,k);let P;return w!==void 0&&(P=g.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(S),C.a.$removeKernelSourceActionProvider(S,S),P?.dispose()}}}async $provideKernelSourceActions(d,k){const g=this.h.get(d);if(g){const S=new M.$Tc;return(await g.provideNotebookKernelSourceActions(k)??[]).map(C=>v.NotebookKernelSourceAction.from(C,this.o.converter,S))}return[]}$acceptNotebookAssociation(d,k,g){const S=this.j.get(d);if(S){const w=this.n.getNotebookDocument(f.URI.revive(k));g?S.associatedNotebooks.set(w.uri,!0):S.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,w.uri.toString(),g),S.onDidChangeSelection.fire({selected:g,notebook:w.apiNotebook})}}async $executeCells(d,k,g){const S=this.j.get(d);if(!S)return;const w=this.n.getNotebookDocument(f.URI.revive(k)),C=[];for(const P of g){const W=w.getCell(P);W&&C.push(W.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,w.uri.toString(),C.length),await S.controller.executeHandler.call(S.controller,C,w.apiNotebook,S.controller)}catch(P){this.q.error(`NotebookController[${d}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(d,k,g){const S=this.j.get(d);if(!S)return;const w=this.n.getNotebookDocument(f.URI.revive(k));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,w.apiNotebook);else for(const C of g){const P=w.getCell(C);P&&this.b.get(P.uri)?.cancel()}if(S.controller.interruptHandler){const C=this.c.get(w.uri);g.length&&Array.isArray(C)&&C.length&&C.forEach(P=>P.dispose())}}async $provideVariables(d,k,g,S,w,C,P){const W=this.j.get(d);if(!W)return;const V=this.n.getNotebookDocument(f.URI.revive(g)),q=W.controller.variableProvider;if(!q)return;let R;if(S!==void 0){if(R=this.s[S],!R)return}else this.s={};const j=w==="named"?m.NotebookVariablesRequestKind.Named:m.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(V.apiNotebook,R,j,C,P);let re=0;for await(const ae of K){if(P.isCancellationRequested)return;const ve={id:this.r++,name:ae.variable.name,value:ae.variable.value,type:ae.variable.type,interfaces:ae.variable.interfaces,language:ae.variable.language,expression:ae.variable.expression,hasNamedChildren:ae.hasNamedChildren,indexedChildrenCount:ae.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[ve.id]=ae.variable,this.a.$receiveVariable(k,ve),re++>=t.$Pib)return}}$acceptKernelMessageFromRenderer(d,k,g){const S=this.j.get(d);if(!S)return;const w=this.n.getEditorById(k);S.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:g}))}$cellExecutionChanged(d,k,g){const w=this.n.getNotebookDocument(f.URI.revive(d)).getCell(k);if(w){const C=g?v.NotebookCellExecutionState.to(g):m.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:w.apiCell,state:C})}}_createNotebookCellExecution(d,k){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const w=new i(k,S,this.a);this.b.set(S.uri,w);const C=w.onDidChangeState(()=>{w.state===l.Resolved&&(w.dispose(),C.dispose(),this.b.delete(S.uri))});return w.asApiObject()}_createNotebookExecution(d,k){const g=this.n.getNotebookDocument(d.uri),S=d.getCells().find(P=>{const W=g.getCellFromApiCell(P);return W&&this.b.has(W.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const w=new a(k,g,this.a),C=w.onDidChangeState(()=>{w.state===$.Resolved&&(w.dispose(),C.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[w,C]),w.asApiObject()}};e.$bmc=c,e.$bmc=c=Je([We(4,T.$Xj)],c);var l;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(l||(l={}));class i extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(d,k,g){super(),this.m=k,this.n=g,this.b=i.a++,this.c=new F.$be,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new A.$me),this.h=new b(10,S=>this.s(S)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const k=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new n.$ow(k))}t(){if(this.f===l.Init)throw new Error("Must call start before modifying cell output");if(this.f===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let k=this.m;if(d&&(k=this.m.notebook.getCellFromApiCell(d)),!k)throw new Error("INVALID cell");return k.handle}y(d){return d.map(k=>{const g=m.$nO.ensureUniqueMimeTypes(k.items,!0);return g===k.items?v.NotebookCellOutput.from(k):v.NotebookCellOutput.from({items:g,id:k.id,metadata:k.metadata})})}async z(d,k,g){const S=this.w(k),w=this.y((0,I.$3b)(d));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:S,append:g,outputs:w})}async C(d,k,g){return d=m.$nO.ensureUniqueMimeTypes((0,I.$3b)(d),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:d.map(v.NotebookCellOutputItem.from),outputId:k.id,append:g})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(g){d.j=g,d.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(g){if(d.f===l.Resolved||d.f===l.Started)throw new Error("Cannot call start again");d.f=l.Started,d.c.fire(),d.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,S,w){if(d.f===l.Resolved)throw new Error("Cannot call resolve twice");d.f=l.Resolved,d.c.fire(),d.h.flush();const C=w?{message:w.message,stack:w.stack,location:w?.location?{startLineNumber:w.location.start.line,startColumn:w.location.start.character,endLineNumber:w.location.end.line,endColumn:w.location.end.character}:void 0,uri:w.uri}:void 0;d.n.$completeExecution(d.b,new n.$ow({runEndTime:S,lastRunSuccess:g,error:C}))},clearOutput(g){return d.t(),d.z([],g,!1)},appendOutput(g,S){return d.t(),d.z(g,S,!0)},replaceOutput(g,S){return d.t(),d.z(g,S,!1)},appendOutputItems(g,S){return d.t(),d.C(g,S,!0)},replaceOutputItems(g,S){return d.t(),d.C(g,S,!1)}})}}var $;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})($||($={}));class a extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(d,k,g){super(),this.h=k,this.j=g,this.b=a.a++,this.c=new F.$be,this.onDidChangeState=this.c.event,this.f=$.Init,this.g=this.B(new A.$me),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===$.Resolved||this.f===$.Started)throw new Error("Cannot call start again");this.f=$.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===$.Resolved)throw new Error("Cannot call resolve twice");this.f=$.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class b{constructor(d,k){this.f=d,this.g=k,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new N.$Oh,this.b=Date.now(),(0,N.$sh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>d.complete())}}function h(D,d){return`${D.value}/${d}`}}),define(Ce[51],Re([1,0,5,4,3,2,16,6,7,171,14,200,24,35,201,42,11,8,32]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=e.$nlc=e.$mlc=void 0,e.$mlc=(0,A.$ri)("IExtHostTerminalService");class t extends p.$Uc{constructor(g,S,w,C){super(),this.u=g,this._id=S,this.w=w,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$be),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(W,V=!0){P.C(),P.u.$sendText(P._id,W,V)},show(W){P.C(),P.u.$show(P._id,W)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(g,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??S?.cwd??void 0,env:g.env??void 0,icon:h(g.iconPath)??void 0,color:s.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this.z(g.location,S?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,S,w,C,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:s.ThemeColor.isThemeColor(P)?P.id:void 0,location:S?.location||this.z(g,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(g,S){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in g?{viewColumn:r.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.y=g}setExitStatus(g,S){this.j=Object.freeze({code:g,reason:S})}setDimensions(g,S){return g===this.f&&S===this.h||g===0||S===0?!1:(this.f=g,this.h=S,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(g){this.n=g}_setProcessId(g){this.g?(this.g(g),this.g=void 0):this.b.then(S=>{S!==g&&(this.b=Promise.resolve(g))})}}e.$nlc=t;class c{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new I.$be,this.onProcessData=this.a.event,this.b=new I.$be,this.d=new I.$be,this.onDidChangeProperty=this.d.event,this.f=new I.$be,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${S}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,S){this.g.setDimensions?.({columns:g,rows:S})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(S=>this.a.fire(S)),this.g.onDidClose?.((S=void 0)=>{this.f.fire(S===void 0?void 0:S)}),this.g.onDidOverrideDimensions?.(S=>{S&&this.d.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this.g.onDidChangeName?.(S=>{this.d.fire({type:"title",value:S})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,i=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,S,w){super(),this.Q=S,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$be,this.onDidCloseTerminal=this.H.event,this.I=new I.$be,this.onDidOpenTerminal=this.I.event,this.J=new I.$be,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$be,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$be,this.onDidChangeTerminalState=this.M.event,this.N=new I.$be,this.onDidChangeShell=this.N.event,this.O=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(N.$SM.MainThreadTerminalService),this.y=new m.$$sb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:C=>{const P=W=>{const V=W;return this.getTerminalById(V.instanceId)?.value};switch(C?.$mid){case 15:return P(C);default:{if(Array.isArray(C))for(let W=0;W<C.length&&C[W].$mid===15;W++)C[W]=P(C[W]);return C}}}}),this.B({dispose:()=>{for(const[C,P]of this.g)P.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,S){const w=new t(this.a,(0,v.$Ng)(),g,g.name),C=new c(g.pty);return w.createExtensionTerminal(g.location,S,this.R(g,S).resolvedExtHostIdentifier,h(g.iconPath),D(g.color)).then(P=>{const W=this.S(P,C);this.h[P]=W}),this.f.push(w),w.value}R(g,S){if(S=S||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const w=g.location.parentTerminal;if(w){const C=this.f.find(P=>P.value===w);C&&(S.resolvedExtHostIdentifier=C._id)}}else g.location&&typeof g.location!="object"?S.location=g.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(g,S){if(!this.getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const C=new c(S),P=this.S(g,C);this.h[g]=P}async $acceptActiveTerminalChanged(g){const S=this.b;if(g===null){this.b=void 0,S!==this.b&&this.J.fire(this.b);return}const w=this.getTerminalById(g);w&&(this.b=w,S!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,S){const w=this.getTerminalById(g);w&&this.O.fire({terminal:w.value,data:S})}async $acceptTerminalDimensions(g,S,w){const C=this.getTerminalById(g);C&&C.setDimensions(S,w)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(g,S){const w=this.getTerminalById(g);w&&this.P.fire({terminal:w.value,...S})}async $acceptTerminalMaximumDimensions(g,S,w){this.g.get(g)?.resize(S,w)}async $acceptTerminalTitleChange(g,S){const w=this.getTerminalById(g);w&&(w.name=S)}async $acceptTerminalClosed(g,S,w){const C=this.X(this.f,g);if(C!==null){const P=this.f.splice(C,1)[0];P.setExitStatus(S,w),this.H.fire(P.value)}}$acceptTerminalOpened(g,S,w,C){if(S){const V=this.X(this.f,S);if(V!==null){this.f[V]._id=g,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:F.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},W=new t(this.a,g,P,w);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(g,S){this.getTerminalById(g)?._setProcessId(S)}async $startExtensionTerminal(g,S){const w=this.getTerminalById(g);if(!w)return{message:(0,E.localize)(0,null,g)};w.isOpen||await new Promise(P=>{const W=this.onDidOpenTerminal(async V=>{V===w.value&&(W.dispose(),P())})});const C=this.g.get(g);C?C.startSendingEvents(S):this.j[g]={initialDimensions:S}}S(g,S){const w=new p.$Tc;w.add(S.onProcessReady(P=>this.a.$sendProcessReady(g,P.pid,P.cwd,P.windowsPty))),w.add(S.onDidChangeProperty(P=>this.a.$sendProcessProperty(g,P))),this.y.startBuffering(g,S.onProcessData),w.add(S.onProcessExit(P=>this.U(g,P))),this.g.set(g,S);const C=this.j[g];return C&&S instanceof c&&(S.startSendingEvents(C.initialDimensions),delete this.j[g]),w}$acceptProcessAckDataEvent(g,S){this.g.get(g)?.acknowledgeDataEvent(S)}$acceptProcessInput(g,S){this.g.get(g)?.input(S)}$acceptTerminalInteraction(g){const S=this.getTerminalById(g);S?.setInteractedWith()&&this.M.fire(S.value)}$acceptTerminalSelection(g,S){this.getTerminalById(g)?.setSelection(S)}$acceptProcessResize(g,S,w){try{this.g.get(g)?.resize(S,w)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(g,S){this.g.get(g)?.shutdown(S)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(S=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(S=>this.a.$sendProcessProperty(g,{type:"cwd",value:S}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new f.$UM(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,S,w){if(this.C.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this.C.set(S,w),this.a.$registerProfileProvider(S,g.identifier.value),new f.$UM(()=>{this.C.delete(S),this.a.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(g,S,w){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,w),this.a.$registerQuickFixProvider(g,S),new f.$UM(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,S){const w=new u.$me().token;if(w.isCancellationRequested)return;const C=this.D.get(g);if(!C)return;const P=await C.provideTerminalQuickFixes(S,w);if(P===null||Array.isArray(P)&&P.length===0)return;const W=new p.$Tc;if(this.w.value=W,!Array.isArray(P))return P?r.TerminalQuickFix.from(P,this.Q.converter,W):void 0;const V=[];for(const q of P){const R=r.TerminalQuickFix.from(q,this.Q.converter,W);R&&V.push(R)}return V}async $createContributedProfileTerminal(g,S){const w=new u.$me().token;let C=await this.C.get(g)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,S);return}this.createTerminalFromOptions(C.options,S)}}async $provideLinks(g,S){const w=this.getTerminalById(g);if(!w)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const P=new u.$me;this.G.set(g,P);const W=[],V={terminal:w.value,line:S},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async re=>{P.token.onCancellationRequested(()=>re({provider:K,links:[]}));const ae=await K.provideTerminalLinks(V,P.token)||[];P.token.isCancellationRequested||re({provider:K,links:ae})}));const R=await Promise.all(q);if(P.token.isCancellationRequested)return[];const j=new Map;for(const K of R)K&&K.links.length>0&&W.push(...K.links.map(re=>{const ae={id:l++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return j.set(ae.id,{provider:K.provider,link:re}),ae}));return this.F.set(g,j),W}$activateLink(g,S){const w=this.F.get(g)?.get(S);w&&w.provider.handleTerminalLink(w.link)}U(g,S){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const w=this.h[g];w&&(w.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,S)}getTerminalById(g){return this.W(this.f,g)}getTerminalIdByApiObject(g){const S=this.f.findIndex(w=>w.value===g);return S>=0?S:null}W(g,S){const w=this.X(g,S);return w!==null?g[w]:null}X(g,S){const w=g.findIndex(C=>C._id===S);return w>=0?w:null}getEnvironmentVariableCollection(g){let S=this.n.get(g.identifier.value);return S||(S=new $,this.Z(g.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}Y(g,S){const w=(0,y.$fs)(S.map),C=(0,y.$gs)(S.descriptionMap);this.a.$setEnvironmentVariableCollection(g,S.persistent,w.length===0?void 0:w,C)}$initEnvironmentVariableCollections(g){g.forEach(S=>{const w=S[0],C=new $(S[1]);this.Z(w,C)})}$acceptDefaultProfile(g,S){const w=this.s;this.s=g,this.u=S,w?.path!==g.path&&this.N.fire(g.path)}Z(g,S){this.n.set(g,S),S.onDidChangeCollection(()=>{this.Y(g,S)})}};e.$olc=i,e.$olc=i=Je([We(1,n.$BP),We(2,M.$fP)],i);class ${get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$be,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const S=this.h(g);let w=this.a.get(S);return w||(w=new a(this,g),this.a.set(S,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(g,S,w,C){this.f(g,{value:S,type:f.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:C})}append(g,S,w,C){this.f(g,{value:S,type:f.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:C})}prepend(g,S,w,C){this.f(g,{value:S,type:f.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:C})}f(g,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(g,S.scope),C=this.map.get(w),P=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==S.value||C.type!==S.type||C.options?.applyAtProcessCreation!==P.applyAtProcessCreation||C.options?.applyAtShellIntegration!==P.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const W=this.g(g,S.scope),V={variable:g,...S,options:P};this.map.set(W,V),this.d.fire()}}get(g,S){const w=this.g(g,S),C=this.map.get(w);return C?d(C):void 0}g(g,S){const w=this.h(S);return w.length?`${g}:::${w}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const S=new Map;for(const[w,C]of this.map)this.h(C.scope)===this.h(g)&&S.set(C.variable,d(C));return S}delete(g,S){const w=this.g(g,S);this.map.delete(w),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[S,w]of this.map)w.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(S);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,S){const w=this.h(S),C=this.descriptionMap.get(w);if(!C||C.description!==g){let P;typeof g=="string"?P=g:P=g?.value.split(`

`)[0];const W={description:P,scope:S};this.descriptionMap.set(w,W),this.d.fire()}}getDescription(g){const S=this.h(g);return this.descriptionMap.get(S)?.description}k(g){const S=this.h(g);this.descriptionMap.delete(S)}}class a{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,S){this.b=g,this.d=S,this.a=new I.$be}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,S,w){this.b.replace(g,S,w,this.d)}append(g,S,w){this.b.append(g,S,w,this.d)}prepend(g,S,w){this.b.prepend(g,S,w,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,S){this.b.getVariableMap(this.d).forEach((w,C)=>g.call(S,C,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let b=class extends i{constructor(g,S){super(!1,g,S)}createTerminal(g,S,w){throw new T.$_}createTerminalFromOptions(g,S){throw new T.$_}};e.$plc=b,e.$plc=b=Je([We(0,n.$BP),We(1,M.$fP)],b);function h(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function D(k){return s.ThemeColor.isThemeColor(k)?k:void 0}function d(k){const g={...k};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ce[114],Re([1,0,7,6,3,4,16,51,5,2,11]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=void 0,e.$tmc=(0,A.$ri)("IExtHostTerminalShellIntegration");let y=class extends N.$Uc{constructor(o,r){super(),this.h=r,this.b=new Map,this.c=new f.$be,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new f.$be,this.onDidStartTerminalShellExecution=this.f.event,this.g=new f.$be,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(F.$SM.MainThreadTerminalShellIntegration),this.B((0,N.$Sc)(()=>{for(const[n,t]of this.b)t.dispose();this.b.clear()}))}$shellIntegrationChange(o){const r=this.h.getTerminalById(o);if(!r)return;const n=r.value;let t=this.b.get(o);t||(t=new u(r.value,this.f),this.b.set(o,t),t.store.add(r.onWillDispose(()=>this.b.get(o)?.dispose())),t.store.add(t.onDidRequestShellExecution(c=>this.a.$executeCommand(o,c))),t.store.add(t.onDidRequestEndExecution(c=>this.g.fire(c))),t.store.add(t.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),r.shellIntegration=t.value),this.c.fire({terminal:n,shellIntegration:t.value})}$shellExecutionStart(o,r,n,t,c){this.b.has(o)||this.$shellIntegrationChange(o);const l={value:r,confidence:n,isTrusted:t};this.b.get(o)?.startShellExecution(l,c)}$shellExecutionEnd(o,r,n,t,c){const l={value:r,confidence:n,isTrusted:t};this.b.get(o)?.endShellExecution(l,c)}$shellExecutionData(o,r){this.b.get(o)?.emitData(r)}$cwdChange(o,r){this.b.get(o)?.setCwd((0,E.$wc)(r)?E.URI.revive(r):r)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$umc=y,e.$umc=y=Je([We(0,M.$fP),We(1,p.$mlc)],y);class u extends N.$Uc{get currentExecution(){return this.a}constructor(o,r){super(),this.j=o,this.m=r,this.b=!1,this.store=this.B(new N.$Tc),this.f=this.B(new f.$be),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new f.$be),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new f.$be),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(t,c){let l=t;c&&(l+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(l);const i={value:l,confidence:I.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},$=n.startShellExecution(i,n.c,!0).value;return n.b=!0,$}}}startShellExecution(o,r,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const t=this.a=new v(o,r);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:t.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,r){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:r}),this.a=void 0)}setCwd(o){let r=!1;E.URI.isUri(this.c)?r=!E.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(r=!0),r&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class v{constructor(o,r){this.c=o,this.cwd=r,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return T.$Rh.EMPTY;this.a=new m}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class m extends N.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const o=this.a=new T.$qh;return new T.$Rh(async n=>{this.b.push(n),await o.wait()})}emitData(o){for(const r of this.b)r.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ce[278],Re([1,0,11,22,24,5,250,99,6,17,35,13,4,16,113,8,7,50,75,61]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=e.$xmc=e.$wmc=e.$vmc=void 0;let c=class extends f.$Uc{constructor(P,W,V,q){super(),this.w=q,this.f=this.B(new F.$be),this.g=new Map,this.s=this.B(new F.$be),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(u.$SM.MainThreadTesting),this.m=new k(this.h),this.j=new a(this.h,W),V.registerArgumentProcessor({processArgument:R=>{switch(R?.$mid){case 16:{const j=R,K=j.tests[j.tests.length-1].item.extId;return this.g.get(r.$EL.root(K))?.collection.tree.get(K)?.actual??(0,m.$rP)(R)}case 18:{const{test:j,message:K}=R,re=j.item.extId;return{test:this.g.get(r.$EL.root(re))?.collection.tree.get(re)?.actual??(0,m.$rP)({$mid:16,tests:[j]}),message:s.TestMessage.to(K)}}default:return R}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const R=await V.executeCommand("_testing.getExplorerSelection"),j=K=>{const re=this.g.get(r.$EL.root(K));if(re)return r.$EL.isRoot(K)?re.controller:re.collection.tree.get(K)?.actual};return{include:R?.include.map(j).filter(E.$ag)||[],exclude:R?.exclude.map(j).filter(E.$ag)||[]}})}createTestController(P,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const R=new f.$Tc,j=R.add(new m.$uP(W,V,this.w));j.root.label=V;const K=new Map,re=new Set,ae=this.h,ve={items:j.root.children,get label(){return V},set label(de){V=de,j.root.label=de,ae.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(de){q=de,ae.$updateController(W,{canRefresh:!!de})},get id(){return W},createRunProfile:(de,me,Me,ce,Ae,ie)=>{let L=(0,p.$fj)(de);for(;K.has(L);)L++;return new S(this.h,K,re,this.s.event,W,L,de,me,Me,ce,Ae,ie)},createTestItem(de,me,Me){return new m.$sP(W,de,me,Me)},createTestRun:(de,me,Me=!0)=>this.j.createTestRun(W,j,de,me,Me),invalidateTestResults:de=>{if(de===void 0)this.h.$markTestRetired(void 0);else{const me=de instanceof Array?de:[de];this.h.$markTestRetired(me.map(Me=>r.$EL.fromExtHostTestItem(Me,W).toString()))}},set resolveHandler(de){j.resolveHandler=de},get resolveHandler(){return j.resolveHandler},dispose:()=>{R.dispose()}};ae.$registerTestController(W,V,!!q),R.add((0,f.$Sc)(()=>ae.$unregisterTestController(W)));const Ie={controller:ve,collection:j,profiles:K,extension:P,activeProfiles:re};return this.g.set(W,Ie),R.add((0,f.$Sc)(()=>this.g.delete(W))),R.add(j.onDidGenerateDiff(de=>ae.$publishDiff(W,de.map(t.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(P,W=A.CancellationToken.None){const V=b(P);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(R=>r.$EL.fromExtHostTestItem(R,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:w[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:P.exclude?.map(R=>R.id)},W)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,W){return(await this.j.getCoverageDetails(P,W))?.map(s.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,W){this.g.get(P)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(P){const W=new Map;for(const[V,q]of Object.entries(P)){const R=this.g.get(V);if(!R)continue;const j=new Map,K=q.filter(ae=>!R.activeProfiles.has(ae)),re=[...R.activeProfiles].filter(ae=>!q.includes(ae));for(const ae of K)j.set(ae,!0),R.activeProfiles.add(ae);for(const ae of re)j.set(ae,!1),R.activeProfiles.delete(ae);j.size&&W.set(V,j)}this.s.fire(W)}async $refreshTests(P,W){await this.g.get(P)?.controller.refreshHandler?.(W)}$publishTestResults(P){this.results=Object.freeze(P.map(s.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,W){const V=this.g.get(r.$EL.fromString(P).controllerId)?.collection;V&&(await V.expand(P,W<0?1/0:W),V.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(W=>t.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(P,W){return Promise.all(P.map(V=>this.y(V,!1,W)))}async $startContinuousRun(P,W){const V=new A.$me(W),q=await Promise.all(P.map(R=>this.y(R,!0,V.token)));return!W.isCancellationRequested&&!q.some(R=>R.error)&&await new Promise(R=>W.onCancellationRequested(R)),V.dispose(!0),q}async y(P,W,V){const q=this.g.get(P.controllerId);if(!q)return{};const{collection:R,profiles:j}=q,K=j.get(P.profileId);if(!K)return{};const re=P.testIds.map(de=>R.tree.get(de)).filter(E.$ag),ae=P.excludeExtIds.map(de=>q.collection.tree.get(de)).filter(E.$ag).filter(de=>re.some(me=>me.fullId.compare(de.fullId)===2));if(!re.length)return{};const ve=new o.$uO(re.some(de=>de.actual instanceof m.$tP)?void 0:re.map(de=>de.actual),ae.map(de=>de.actual),K,W),Ie=(0,t.$HL)(P)&&this.j.prepareForMainThreadTestRun(ve,h.fromInternal(P,q.collection),K,V);try{return await K.runHandler(ve,V),{}}catch(de){return{error:String(de)}}finally{Ie&&Ie.hasRunningTasks&&!V.isCancellationRequested&&await F.Event.toPromise(Ie.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$vmc=c,e.$vmc=c=Je([We(0,v.$fP),We(1,y.$Xj)],c);const l=1e4;var i;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(i||(i={}));class $ extends f.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(P,W,V,q,R){super(),this.y=P,this.z=W,this.C=V,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new F.$be),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new A.$me(R));const j=this.B(new I.$Dh(()=>this.F(),l));this.B(this.j.token.onCancellationRequested(()=>j.schedule()));const K=new F.$be;this.s=K.event,this.B((0,f.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(P,W){const[,V,q]=r.$EL.fromString(P).path,R=this.w.get(q);if(!R)return[];const j=this.g.get(V);if(!j)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(j.run,R,W)??[]}createRun(P){const W=this.y.id,V=this.y.controllerId,q=(0,T.$Ng)(),R=ae=>(ve,...Ie)=>{if(K){this.C.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ve)&&(this.H(ve),ae(ve,...Ie))},j=(ae,ve)=>{const Ie=ve instanceof Array?ve.map(s.TestMessage.from):[s.TestMessage.from(ve)];if(ae.uri&&ae.range){const de={range:s.Range.from(ae.range),uri:ae.uri};for(const me of Ie)me.location=me.location||de}this.z.$appendTestMessagesInRun(W,q,r.$EL.fromExtHostTestItem(ae,V).toString(),Ie)};let K=!1;const re={isPersisted:this.y.isPersisted,token:this.j.token,name:P,onDidDispose:this.s,addCoverage:ae=>{const ve=ae.uri.toString(),Ie=new r.$EL([W,q,ve]).toString();this.w.set(ve,ae),this.z.$appendCoverage(W,q,s.TestCoverage.fromFile(Ie,ae))},enqueued:R(ae=>{this.z.$updateTestStateInRun(W,q,r.$EL.fromExtHostTestItem(ae,V).toString(),1)}),skipped:R(ae=>{this.z.$updateTestStateInRun(W,q,r.$EL.fromExtHostTestItem(ae,V).toString(),5)}),started:R(ae=>{this.z.$updateTestStateInRun(W,q,r.$EL.fromExtHostTestItem(ae,V).toString(),2)}),errored:R((ae,ve,Ie)=>{j(ae,ve),this.z.$updateTestStateInRun(W,q,r.$EL.fromExtHostTestItem(ae,V).toString(),6,Ie)}),failed:R((ae,ve,Ie)=>{j(ae,ve),this.z.$updateTestStateInRun(W,q,r.$EL.fromExtHostTestItem(ae,V).toString(),4,Ie)}),passed:R((ae,ve)=>{this.z.$updateTestStateInRun(W,q,r.$EL.fromExtHostTestItem(ae,this.y.controllerId).toString(),3,ve)}),appendOutput:(ae,ve,Ie)=>{K||(Ie&&(this.y.isIncluded(Ie)?this.H(Ie):Ie=void 0),this.z.$appendOutputToRun(W,q,N.$Ce.fromString(ae),ve&&s.location.from(ve),Ie&&r.$EL.fromExtHostTestItem(Ie,V).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(W,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:re}),this.z.$startedTestRunTask(W,{id:q,name:P,running:!0}),re}F(){for(const{run:P}of this.g.values())P.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(P){if(!(P instanceof m.$sP))throw new n.$0O(P.id);if(this.h.has(r.$EL.fromExtHostTestItem(P,this.y.controllerId).toString()))return;const W=[],V=this.y.colllection.root;for(;;){const q=s.TestItem.from(P);if(W.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),P===V))break;P=P.parent||V}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(P,W){this.g=P,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(P,W){const V=r.$EL.root(P);return this.f.get(V)?.getCoverageDetails(P,W)||[]}disposeTestRun(P){this.f.get(P)?.dispose(),this.f.delete(P);for(const[W,{id:V}]of this.c)V===P&&this.c.delete(W)}prepareForMainThreadTestRun(P,W,V,q){return this.j(P,W,V,q)}cancelRunById(P){this.f.get(P)?.cancel()}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,W,V,q,R){const j=this.c.get(V);if(j)return j.createRun(q);const K=h.fromPublic(P,W,V,R),re=b(V);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!V.continuous,profile:re&&{group:w[re.kind],id:re.profileId},exclude:V.exclude?.map(ve=>r.$EL.fromExtHostTestItem(ve,W.root.id).toString())??[],id:K.id,include:V.include?.map(ve=>r.$EL.fromExtHostTestItem(ve,W.root.id).toString())??[W.root.id],persist:R});const ae=this.j(V,K,V.profile);return F.Event.once(ae.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ae.createRun(q)}j(P,W,V,q){const R=new $(W,this.g,this.h,V,q);return this.c.set(P,R),this.f.set(R.id,R),R}}e.$wmc=a;const b=C=>{if(C.profile){if(!(C.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class h{static fromPublic(P,W,V,q){return new h(P,(0,T.$Ng)(),V.include?.map(R=>r.$EL.fromExtHostTestItem(R,P).toString())??[P],V.exclude?.map(R=>r.$EL.fromExtHostTestItem(R,P).toString())??[],q,W)}static fromInternal(P,W){return new h(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,W)}constructor(P,W,V,q,R,j){this.controllerId=P,this.id=W,this.isPersisted=R,this.colllection=j,this.c=V.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(P){const W=r.$EL.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const V of this.f)if(W===V||W.startsWith(V))return!1;for(const V of this.c)if(W===V||W.startsWith(V))return!0;return!1}}e.$xmc=h;class D{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(P){this.j=P,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,s.TestItem.toPlain(P.item)),this.c.has(P)||this.f.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.f.delete(P);const W=r.$EL.parentId(P.item.extId);if(W&&this.h.has(W.toString())){this.h.add(P.item.extId);return}this.g.add(P)}getChangeEvent(){const{c:P,f:W,g:V}=this;return{get added(){return[...P].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class d extends t.$NL{constructor(){super(...arguments),this.s=new F.$be,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(P){return this.f.get(P)}getMirroredTestDataByReference(P){return this.f.get(P.id)}w(P,W){return{...P,revived:s.TestItem.toPlain(P.item),depth:W?W.depth+1:0,children:new Set}}v(){return new D(this.s)}}class k{constructor(P){this.f=P}checkout(){this.c||(this.c=this.g());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(W=>W.revived)},dispose:(0,M.$db)(()=>{--P.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}g(){const P=new d({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:P}}}const g=(C,P,W,V)=>{W?Object.assign(W,V):P.$updateTestRunConfig(C.controllerId,C.profileId,V)};class S{#e;#t;#i;#n;#s;get label(){return this.f}set label(P){P!==this.f&&(this.f=P,g(this,this.#e,this.#n,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,g(this,this.#e,this.#n,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),g(this,this.#e,this.#n,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,g(this,this.#e,this.#n,{tag:P?s.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,g(this,this.#e,this.#n,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return F.Event.chain(this.#i,P=>P.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(E.$ag))}constructor(P,W,V,q,R,j,K,re,ae,ve=!1,Ie=void 0,de=!1){this.controllerId=R,this.profileId=j,this.f=K,this.kind=re,this.runHandler=ae,this._tag=Ie,this.g=de,this.#e=P,this.#s=W,this.#t=V,this.#i=q,W.set(j,this);const me=w[re];if(typeof me!="number")throw new Error(`Unknown TestRunProfile.group ${re}`);ve&&V.add(j),this.#n={profileId:j,controllerId:R,tag:Ie?s.TestTag.namespace(this.controllerId,Ie.id):null,label:K,group:me,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:de},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$ymc=S;const w={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ce[115],Re([1,0,56,14,90,8,7]),function(ge,e,I,N,A,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=e.$nP=e.$mP=void 0;class p{static{this.c=new A.$kP("TextEditorDecorationType")}constructor(u,v,m){const s=p.c.nextId();u.$registerTextEditorDecorationType(v.identifier,s,F.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:s,dispose(){u.$removeTextEditorDecorationType(s)}})}}e.$mP=p;class f{constructor(u,v){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,v){this.k();let m=null;if(u instanceof M.$VM)m=new M.$WM(u,u);else if(u instanceof M.$WM)m=u;else throw new Error("Unrecognized location");this.l(m,v,!1)}insert(u,v){this.k(),this.l(new M.$WM(u,u),v,!0)}delete(u){this.k();let v=null;if(u instanceof M.$WM)v=u;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(u,v,m){const s=this.c.validateRange(u);this.g.push({range:s,text:v,forceMoveMarkers:m})}setEndOfLine(u){if(this.k(),u!==M.EndOfLine.LF&&u!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=u}}class E{constructor(u,v,m,s){this.c=u,this.d=v,this._accept(m),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(r){o.n(r)},get indentSize(){return o.g},set indentSize(r){o.p(r)},get insertSpaces(){return o.j},set insertSpaces(r){o.s(r)},get cursorStyle(){return o.k},set cursorStyle(r){o.t(r)},get lineNumbers(){return o.l},set lineNumbers(r){o.u(r)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=F.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const v=Math.floor(u);return v>0?v:null}if(typeof u=="string"){const v=parseInt(u,10);return isNaN(v)?null:v>0?v:null}return null}n(u){const v=this.m(u);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const v=Math.floor(u);return v>0?v:null}if(typeof u=="string"){const v=parseInt(u,10);return isNaN(v)?null:v>0?v:null}return null}p(u){const v=this.o(u);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const v=this.q(u);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(u)})))}assign(u){const v={};let m=!1;if(typeof u.tabSize<"u"){const s=this.m(u.tabSize);s==="auto"?(m=!0,v.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,m=!0,v.tabSize=s)}if(typeof u.indentSize<"u"){const s=this.o(u.indentSize);s==="tabSize"?(m=!0,v.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,m=!0,v.indentSize=s)}if(typeof u.insertSpaces<"u"){const s=this.q(u.insertSpaces);s==="auto"?(m=!0,v.insertSpaces=s):this.j!==s&&(this.j=s,m=!0,v.insertSpaces=s)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,m=!0,v.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,m=!0,v.lineNumbers=F.TextEditorLineNumbersStyle.from(u.lineNumbers)),m&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(u,v){v.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(m)})}}e.$nP=E;class T{constructor(u,v,m,s,o,r,n,t){this.id=u,this.j=v,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new E(this.j,this.id,r,m),this.e=n,this.f=t;const c=this;this.value=Object.freeze({get document(){return s.value},set document(l){throw new N.$9("document")},get selection(){return c.c&&c.c[0]},set selection(l){if(!(l instanceof M.$XM))throw(0,N.$7)("selection");c.c=[l],c.l()},get selections(){return c.c},set selections(l){if(!Array.isArray(l)||l.some(i=>!(i instanceof M.$XM)))throw(0,N.$7)("selections");c.c=l,c.l()},get visibleRanges(){return c.e},set visibleRanges(l){throw new N.$9("visibleRanges")},get options(){return c.d.value},set options(l){c.g||c.d.assign(l)},get viewColumn(){return c.f},set viewColumn(l){throw new N.$9("viewColumn")},edit(l,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const $=new f(s.value,i);return l($),c.m($)},insertSnippet(l,i,$={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=c.c.map(b=>F.Range.from(b));else if(i instanceof M.$VM){const{lineNumber:b,column:h}=F.Position.from(i);a=[{startLineNumber:b,startColumn:h,endLineNumber:b,endColumn:h}]}else if(i instanceof M.$WM)a=[F.Range.from(i)];else{a=[];for(const b of i)if(b instanceof M.$WM)a.push(F.Range.from(b));else{const{lineNumber:h,column:D}=F.Position.from(b);a.push({startLineNumber:h,startColumn:D,endLineNumber:h,endColumn:D})}}return v.$tryInsertSnippet(u,s.value.version,l.value,a,$)},setDecorations(l,i){const $=i.length===0;$&&!c.h.has(l.key)||($?c.h.delete(l.key):c.h.add(l.key),c.n(()=>{if(F.$cP(i))return v.$trySetDecorations(u,l.key,F.$dP(i));{const a=new Array(4*i.length);for(let b=0,h=i.length;b<h;b++){const D=i[b];a[4*b]=D.start.line+1,a[4*b+1]=D.start.character+1,a[4*b+2]=D.end.line+1,a[4*b+3]=D.end.character+1}return v.$trySetDecorationsFast(u,l.key,a)}}))},revealRange(l,i){c.n(()=>v.$tryRevealRange(u,F.Range.from(l),i||M.TextEditorRevealType.Default))},show(l){v.$tryShowEditor(u,F.ViewColumn.from(l))},hide(){v.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,I.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,I.ok)(!this.g),this.f=u}_acceptSelections(u){(0,I.ok)(!this.g),this.c=u}async l(){const u=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const v=u.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const m=v.edits.map(o=>o.range);m.sort((o,r)=>o.end.line===r.end.line?o.end.character===r.end.character?o.start.line===r.start.line?o.start.character-r.start.character:o.start.line-r.start.line:o.end.character-r.end.character:o.end.line-r.end.line);for(let o=0,r=m.length-1;o<r;o++){const n=m[o].end;if(m[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=v.edits.map(o=>({range:F.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,s,{setEndOfLine:typeof v.setEndOfLine=="number"?F.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$oP=T}),define(Ce[67],Re([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,40,41]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=e.$pP=void 0;class r{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,l){this.h=c,this.i=l,this.a=null,this.b=new Map,this.c=new v.$Bc,this.d=new N.$be,this.e=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const l=[],i=[],$=[];if(c.removedDocuments)for(const a of c.removedDocuments){const b=F.URI.revive(a),h=this.c.get(b);h?.unref()&&(this.c.delete(b),l.push(h.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const b=F.URI.revive(a.uri);let h=this.c.get(b);if(h&&b.scheme!==m.Schemas.vscodeNotebookCell&&b.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${b} already exists!'`);h||(h=new r(new f.$iP(this.h.getProxy(p.$SM.MainThreadDocuments),b,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(b,h),i.push(h.value)),h.ref()}if(c.removedEditors)for(const a of c.removedEditors){const b=this.b.get(a);this.b.delete(a),b&&$.push(b)}if(c.addedEditors)for(const a of c.addedEditors){const b=F.URI.revive(a.documentUri);I.ok(this.c.has(b),`document '${b}' does not exist`),I.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const h=this.c.get(b).value,D=new T.$oP(a.id,this.h.getProxy(p.$SM.MainThreadTextEditors),this.i,new o.$V(()=>h.document),a.selections.map(y.Selection.to),a.options,a.visibleRanges.map(d=>y.Range.to(d)),typeof a.editorPosition=="number"?y.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,D)}c.newActiveEditor!==void 0&&(I.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,A.$Pc)(l),(0,A.$Pc)($),c.removedDocuments&&this.e.fire(l),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const l=this.b.get(this.a);return c?l:l?.value}allEditors(){return[...this.b.values()]}};e.$pP=n,e.$pP=n=Je([We(0,E.$fP),We(1,u.$Xj)],n),e.$qP=(0,M.$ri)("IExtHostDocumentsAndEditors")}),define(Ce[279],Re([1,0,18,5,4,115,8,7]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;class f{constructor(T,y){this.i=y,this.a=new N.$be,this.b=new N.$be,this.c=new N.$be,this.d=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(A.$SM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const y=this.i.allEditors();return T?y:y.map(u=>u.value)}async showTextDocument(T,y,u){let v;typeof y=="number"?v={position:M.ViewColumn.from(y),preserveFocus:u}:typeof y=="object"?v={position:M.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?M.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:v={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(T.uri,v),s=m&&this.i.getEditor(m);if(s)return s.value;throw m?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,y){return new F.$mP(this.h,T,y).value}$acceptEditorPropertiesChanged(T,y){const u=this.i.getEditor(T);if(!u)throw new Error("unknown text editor");if(y.options&&u._acceptOptions(y.options),y.selections){const v=y.selections.selections.map(M.Selection.to);u._acceptSelections(v)}if(y.visibleRanges){const v=I.$Hb(y.visibleRanges.map(M.Range.to));u._acceptVisibleRanges(v)}if(y.options&&this.b.fire({textEditor:u.value,options:{...y.options,lineNumbers:M.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const v=p.TextEditorSelectionChangeKind.fromValue(y.selections.source),m=y.selections.selections.map(M.Selection.to);this.a.fire({textEditor:u.value,selections:m,kind:v})}if(y.visibleRanges){const v=I.$Hb(y.visibleRanges.map(M.Range.to));this.c.fire({textEditor:u.value,visibleRanges:v})}}$acceptEditorPositionData(T){for(const y in T){const u=this.i.getEditor(y);if(!u)throw new Error("Unknown text editor");const v=M.ViewColumn.to(T[y]);u.value.viewColumn!==v&&(u._acceptViewColumn(v),this.d.fire({textEditor:u.value,viewColumn:v}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$Rkc=f}),define(Ce[280],Re([1,0,2,3,4,6,7,8,20,17]),function(ge,e,I,N,A,F,M,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=e.$Amc=void 0,e.$Amc=(0,N.$ri)("IExtHostTimeline");class T{constructor(v,m){this.b=new Map,this.c=new Map,this.a=v.getProxy(A.$SM.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&f.$Mm.equals(o,this.b.get(s.source)?.extension)){const r=s.uri===void 0?void 0:I.URI.revive(s.uri);return this.c.get(s.source)?.get(y(r))?.get(s.handle)}else return;return s}})}async $getTimeline(v,m,s,o){return this.b.get(v)?.provider.provideTimeline(I.URI.revive(m),s,o)}registerTimelineProvider(v,m,s,o){const r=new F.$Tc,n=this.d(m.id,o,r).bind(this);let t;m.onDidChange&&(t=m.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:m.id}),this));const c=this.c;return this.f({...m,scheme:v,onDidChange:void 0,async provideTimeline(l,i,$){i?.resetCache&&(r.clear(),c.get(m.id)?.clear());const a=await m.provideTimeline(l,i,$);if(a==null)return;const b=n(l,i);return{...a,source:m.id,items:a.items.map(b)}},dispose(){for(const l of c.values())l.get(m.id)?.clear();t?.dispose(),r.dispose()}},s)}d(v,m,s){return(o,r)=>{let n;if(r?.cacheResults){let t=this.c.get(v);t===void 0&&(t=new Map,this.c.set(v,t));const c=y(o);n=t.get(c),n===void 0&&(n=new Map,t.set(c,n))}return t=>{const{iconPath:c,...l}=t,i=`${v}|${t.id??t.timestamp}`;n?.set(i,t);let $,a,b;t.iconPath&&(c instanceof M.$QN?b={id:c.id,color:c.color}:I.URI.isUri(c)?($=c,a=c):{light:$,dark:a}=c);let h;return M.$jN.isMarkdownString(l.tooltip)?h=p.MarkdownString.from(l.tooltip):(0,E.$5f)(l.tooltip)?h=l.tooltip:M.$jN.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=p.MarkdownString.from(l.detail)):(0,E.$5f)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=l.detail),{...l,id:l.id??void 0,handle:i,source:v,command:t.command?m.toInternal(t.command,s):void 0,icon:$,iconDark:a,themeIcon:b,tooltip:h,accessibilityInformation:t.accessibilityInformation}}}}f(v,m){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:m}),(0,F.$Sc)(()=>{for(const o of this.c.values())o.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$Bmc=T;function y(u){return u?.toString()}}),define(Ce[281],Re([1,0,172,23,2,5,6,211,11,7,17,18,8,54,24,137,26]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;function r(c,l){if((0,T.$5f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter($=>$.length===2&&typeof $[0]=="number"&&typeof $[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends M.$Uc{constructor(l,i,$){super(),this.f=l,this.g=i,this.h=$,this.a=new Map,this.b=new s.$u9;function a(b){return b&&b.$treeViewId&&(b.$treeItemHandle||b.$selectedTreeItems||b.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:b=>a(b)?this.r(b):Array.isArray(b)&&b.length>0?b.map(h=>a(h)?this.r(h):h):b})}registerTreeDataProvider(l,i,$){const a=this.createTreeView(l,{treeDataProvider:i},$);return{dispose:()=>a.dispose()}}createTreeView(l,i,$){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=i.dragAndDropController?.dropMimeTypes??[],b=i.dragAndDropController?.dragMimeTypes??[],h=!!i.dragAndDropController?.handleDrag,D=!!i.dragAndDropController?.handleDrop,d=this.m(l,i,$),k={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:a,dragMimeTypes:b,hasHandleDrag:h,hasHandleDrop:D,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(l,k),S={get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get activeItem(){return(0,o.$AG)($,"treeViewActiveItem"),d.focusedElement},get onDidChangeActiveItem(){return(0,o.$AG)($,"treeViewActiveItem"),d.onDidChangeActiveItem},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return d.onDidChangeCheckboxState},get message(){return d.message},set message(w){(0,v.$Qk)(w)&&(0,o.$AG)($,"treeViewMarkdownMessage"),d.message=w},get title(){return d.title},set title(w){d.title=w},get description(){return d.description},set description(w){d.description=w},get badge(){return d.badge},set badge(w){w!==void 0&&E.ViewBadge.isViewBadge(w)?d.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(d.badge=void 0)},reveal:(w,C)=>d.reveal(w,C),dispose:async()=>{await g,this.a.delete(l),d.dispose()}};return this.B(S),S}$getChildren(l,i){const $=this.a.get(l);return $?$.getChildren(i):Promise.reject(new p.$PF(l))}async $handleDrop(l,i,$,a,b,h,D,d){const k=this.a.get(l);if(!k)return Promise.reject(new p.$PF(l));const g=u.DataTransfer.toDataTransfer($,async S=>(await this.f.$resolveDropFileData(l,i,S)).buffer);return D===l&&d&&await this.j(g,k,d,b,h),k.onDrop(g,a,b)}async j(l,i,$,a,b){const h=this.b.removeDragOperationTransfer(b);if(h)(await h)?.forEach((D,d)=>{D&&l.set(d,D)});else if(b&&i.handleDrag){const D=i.handleDrag($,l,a);this.b.addDragOperationTransfer(b,D),await D}return l}async $handleDrag(l,i,$,a){const b=this.a.get(l);if(!b)return Promise.reject(new p.$PF(l));const h=await this.j(new E.$MN,b,i,a,$);if(!(!h||a.isCancellationRequested))return u.DataTransfer.from(h)}async $hasResolve(l){const i=this.a.get(l);if(!i)throw new p.$PF(l);return i.hasResolve}$resolve(l,i,$){const a=this.a.get(l);if(!a)throw new p.$PF(l);return a.resolveTreeItem(i,$)}$setExpanded(l,i,$){const a=this.a.get(l);if(!a)throw new p.$PF(l);a.setExpanded(i,$)}$setSelectionAndFocus(l,i,$){const a=this.a.get(l);if(!a)throw new p.$PF(l);a.setSelectionAndFocus(i,$)}$setVisible(l,i){const $=this.a.get(l);if(!$){if(!i)return;throw new p.$PF(l)}$.setVisible(i)}$changeCheckboxState(l,i){const $=this.a.get(l);if(!$)throw new p.$PF(l);$.setCheckboxState(i)}m(l,i,$){const a=this.B(new t(l,i,this.f,this.g.converter,this.h,$));return this.a.set(l,a),a}r(l){const i=this.a.get(l.$treeViewId);return i&&"$treeItemHandle"in l?i.getExtensionElement(l.$treeItemHandle):i&&"$focusedTreeItem"in l&&l.$focusedTreeItem?i.focusedElement:null}}e.$Cmc=n;class t extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,T.$bg)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,i,$,a,b,h){if(super(),this.I=l,this.J=$,this.L=a,this.M=b,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$be),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$be),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$be),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$be),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$be),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$be),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$be),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$me,h.contributes&&h.contributes.views)for(const g in h.contributes.views)for(const S of h.contributes.views[g])S.id===l&&(this.P=S.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let D,d;const k=F.Event.debounce(this.F.event,(g,S)=>(g||(g={message:!1,elements:[]}),S.element!==!1&&(D||(D=new Promise(w=>d=w),this.G=this.G.then(()=>D)),Array.isArray(S.element)?g.elements.push(...S.element):g.elements.push(S.element)),S.message&&(g.message=!0),g),200,!0);this.B(k(({message:g,elements:S})=>{S.length&&(this.H=this.H.then(()=>{const w=d;return D=null,this.$(S).then(()=>w())})),g&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const i=l?this.getExtensionElement(l):void 0;if(l&&!i)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let $=this.X(l);return $||($=await this.Y(i)),$?$.map(a=>a.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,i){i=i||{select:!0,focus:!1};const $=(0,T.$bg)(i.select)?!0:i.select,a=(0,T.$bg)(i.focus)?!1:i.focus,b=(0,T.$bg)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(h=>this.W(l,h[h.length-1]).then(D=>this.J.$reveal(this.I,{item:D.item,parentChain:h.map(d=>d.item)},{select:$,focus:a,expand:b})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:$,focus:a,expand:b})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=u.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,i){const $=this.getExtensionElement(l);$&&(i?this.u.fire(Object.freeze({element:$})):this.w.fire(Object.freeze({element:$})))}setSelectionAndFocus(l,i){const $=!(0,y.$ub)(this.s,l);this.s=l;const a=this.t!==i;this.t=i,$&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const i=(await Promise.all(l.map(async $=>{const a=this.getExtensionElement($.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:$.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter($=>$!==void 0);i.forEach($=>{$.treeItem.checkboxState=$.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map($=>[$.extensionItem,$.newState])})}async handleDrag(l,i,$){const a=[];for(const b of l){const h=this.getExtensionElement(b);h&&a.push(h)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,i,$),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,i,$){const a=i?this.getExtensionElement(i):void 0;if(!(!a&&i||!this.g?.handleDrop))return(0,f.$jh)(()=>this.g?.handleDrop?this.g.handleDrop(a,l,$):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,i){if(!this.f.resolveTreeItem)return;const $=this.j.get(l);if($){const a=this.m.get($);if(a){const b=await this.f.resolveTreeItem(a.extensionItem,$,i)??a.extensionItem;return this.hb(b),a.item.tooltip=this.eb(b.tooltip),a.item.command=this.fb(a.disposableStore,b.command),a.item}}}S(l){return this.U(l).then(i=>i?this.S(i).then($=>this.W(i,$[$.length-1]).then(a=>($.push(a),$))):Promise.resolve([]))}U(l){const i=this.m.get(l);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,f.$jh)(()=>this.f.getParent(l))}W(l,i){const $=this.m.get(l);return $?Promise.resolve($):(0,f.$jh)(()=>this.f.getTreeItem(l)).then(a=>this.kb(l,a,i,!0)).then(a=>this.getChildren(i?i.item.handle:void 0).then(()=>{const b=this.getExtensionElement(a);if(b){const h=this.m.get(b);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let i;if(typeof l=="string"){const $=this.getExtensionElement(l);i=$?this.m.get($):void 0}else i=l;return i&&i.children||void 0}return this.h}async Y(l){this.rb(l);const i=new m.$me(this.Z.token);try{const $=l?this.m.get(l):void 0,a=await this.f.getChildren(l);if(i.token.isCancellationRequested)return;const b=(0,y.$Hb)(a||[]),h=await Promise.all((0,y.$Hb)(b).map(d=>this.f.getTreeItem(d)));if(i.token.isCancellationRequested)return;const D=h.map((d,k)=>d?this.db(b[k],d,$):null);return(0,y.$Hb)(D)}finally{i.dispose()}}$(l){if(l.some($=>!$))return this.Z.dispose(!0),this.Z=new m.$me,this.tb(),this.J.$refresh(this.I);{const $=this.ab(l);if($.length)return this.bb($)}return Promise.resolve(void 0)}ab(l){const i=new Set,$=l.map(b=>this.m.get(b));for(const b of $)if(b&&!i.has(b.item.handle)){let h=b;for(;h&&h.parent&&$.findIndex(D=>h&&h.parent&&D&&D.item.handle===h.parent.item.handle)===-1;){const D=this.j.get(h.parent.item.handle);h=D?this.m.get(D):void 0}h&&!h.parent&&i.add(b.item.handle)}const a=[];return i.forEach(b=>{const h=this.j.get(b);if(h){const D=this.m.get(h);D&&(!D.parent||!i.has(D.parent.item.handle))&&a.push(b)}}),a}bb(l){const i={};return Promise.all(l.map($=>this.cb($).then(a=>{a&&(i[$]=a.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(l){const i=this.getExtensionElement(l);if(i){const $=this.m.get(i);if($)return this.rb(i),(0,f.$jh)(()=>this.f.getTreeItem(i)).then(a=>{if(a){const b=this.ib(i,a,$.parent);return this.pb(i,b,$,$.parent),$.dispose(),b}return null})}return Promise.resolve(null)}db(l,i,$){const a=this.ib(l,i,$);if(i.id&&this.j.has(a.item.handle))throw new Error((0,I.localize)(0,null,i.id));return this.ob(l,a),this.qb(a,$),a}eb(l){return E.$jN.isMarkdownString(l)?u.MarkdownString.from(l):l}fb(l,i){return i?{...this.L.toInternal(i,l),originalId:i.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let i,$,a;return typeof l.checkboxState=="number"?i=l.checkboxState:(i=l.checkboxState.state,$=l.checkboxState.tooltip,a=l.checkboxState.accessibilityInformation),{isChecked:i===E.TreeItemCheckboxState.Checked,tooltip:$,accessibilityInformation:a}}hb(l){if(!E.$HN.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,i,$){this.hb(i);const a=this.B(new M.$Tc),b=this.kb(l,i,$),h=this.lb(i);return{item:{handle:b,parentHandle:$?$.item.handle:void 0,label:r(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(a,i.command),contextValue:i.contextValue,icon:h,iconDark:this.mb(i)||h,themeIcon:this.jb(i),collapsibleState:(0,T.$bg)(i.collapsibleState)?E.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:$,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(l){return l.iconPath instanceof E.$QN?l.iconPath:void 0}kb(l,{id:i,label:$,resourceUri:a},b,h){if(i)return`${t.b}/${i}`;const D=r($,this.N),d=b?b.item.handle:t.a;let k=D?D.label:a?(0,N.$2g)(a):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const g=this.m.has(l)?this.m.get(l).item.handle:void 0,S=this.X(b)||[];let w,C=0;do{if(w=`${d}/${C}:${k}`,h||!this.j.has(w)||g===w)break;C++}while(C<=S.length);return w}lb(l){if(l.iconPath&&!(l.iconPath instanceof E.$QN))return typeof l.iconPath=="string"||A.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof E.$QN)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return A.URI.isUri(l)?l:A.URI.file(l)}ob(l,i){this.j.set(i.item.handle,l),this.m.set(l,i)}pb(l,i,$,a){this.j.delete(i.item.handle),this.m.delete(l),i.item.handle!==$.item.handle&&this.j.delete($.item.handle),this.ob(l,i);const b=this.X(a)||[],h=b.filter(D=>D.item.handle===$.item.handle)[0];h&&b.splice(b.indexOf(h),1,i)}qb(l,i){i?(i.children||(i.children=[]),i.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const i=this.m.get(l);if(i){if(i.children)for(const $ of i.children){const a=this.j.get($.item.handle);a&&this.sb(a)}i.children=void 0}}else this.tb()}sb(l){const i=this.m.get(l);if(i){if(i.children)for(const $ of i.children){const a=this.j.get($.item.handle);a&&this.sb(a)}this.m.delete(l),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[282],Re([1,0,5,6,2,35,8,63,4,7]),function(ge,e,I,N,A,F,M,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class T extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(m,s,o,r){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$be),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$be),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=s,this.#n=o,this.#i=r.viewType,this.#s=r.panelOptions,this.#o=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(m){this.c(),this.#r!==m&&(this.#r=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#a}set iconPath(m){this.c(),this.#a!==m&&(this.#a=m,this.#t.$setIconPath(this.#e,A.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(m){this.#l||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#u=m.active,this.#c=m.visible,this.#o=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:M.ViewColumn.from(m),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends N.$Uc{static c(){return(0,F.$Ng)()}constructor(m,s,o){super(),this.j=s,this.m=o,this.g=new Map,this.h=new Map,this.f=m.getProxy(f.$SM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,s,o,r,n={}){const t=typeof r=="object"?r.viewColumn:r,c={viewColumn:M.ViewColumn.from(t),preserveFocus:typeof r=="object"&&!!r.preserveFocus},l=(0,p.$7kc)(m),i=y.c();this.f.$createWebviewPanel((0,p.$9kc)(m),i,s,{title:o,panelOptions:u(n),webviewOptions:(0,p.$0kc)(m,this.m,n),serializeBuffersForPostMessage:l},c);const $=this.j.createNewWebview(i,n,m);return this.createNewWebviewPanel(i,s,o,t,n,$,!0)}$onDidChangeWebviewPanelViewStates(m){const s=Object.keys(m);s.sort((o,r)=>{const n=m[o],t=m[r];return n.active?1:t.active?-1:+n.visible-+t.visible});for(const o of s){const r=this.getWebviewPanel(o);if(!r)continue;const n=m[o];r._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,s,o){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:o,extension:m}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,p.$7kc)(m)}),new E.$UM(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(m,s,o,r){const n=this.h.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:t,extension:c}=n,l=this.j.createNewWebview(m,o.webviewOptions,c),i=this.createNewWebviewPanel(m,s,o.title,r,o.panelOptions,l,o.active);await t.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(m,s,o,r,n,t,c){const l=new T(m,this.f,t,{viewType:s,title:o,viewColumn:r,panelOptions:n,active:c});return this.g.set(m,l),l}getWebviewPanel(m){return this.g.get(m)}}e.$$kc=y;function u(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ce[283],Re([1,0,5,6,63,8,4,7]),function(ge,e,I,N,A,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class f extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,v,m,s,o){super(),this.#s=!1,this.#u=this.B(new I.$be),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$be),this.onDidDispose=this.#l.event,this.#i=v,this.#a=m,this.#e=y,this.#t=u,this.#n=s,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=F.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(M.$SM.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,v,m){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:v,extension:y}),this.a.$registerWebviewViewProvider((0,A.$9kc)(y),u,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$7kc)(y)}),new p.$UM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,v,m,s){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:r,extension:n}=o,t=this.d.createNewWebview(y,{},n),c=new f(y,this.a,u,v,t,!0);this.c.set(y,c),await r.resolveWebviewView(c,{state:m},s)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$Fmc=E}),define(Ce[284],Re([1,0,5,30,31,3]),function(ge,e,I,N,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=e.OutputChannelUpdateMode=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=void 0,e.$1L="text/x-code-output",e.$2L="output",e.$3L="Log",e.$4L="text/x-code-log-output",e.$5L="log",e.$6L="workbench.panel.output",e.$7L=new A.$Ij("inOutput",!1),e.$8L=new A.$Ij("activeLogOutput",!1),e.$9L=new A.$Ij("activeLogOutput.levelSettable",!1),e.$0L=new A.$Ij("activeLogOutput.level",""),e.$$L=new A.$Ij("activeLogOutput.levelIsDefault",!1),e.$_L=new A.$Ij("outputView.scrollLock",!1),e.$aM=(0,F.$ri)("outputService");var M;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$bM={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new I.$be,this.onDidRegisterChannel=this.b.event,this.c=new I.$be,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(T=>E.push(T)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}N.$0n.add(e.$bM.OutputChannels,new p),e.$cM=new A.$Ij("activeOutputChannel","")}),define(Ce[116],Re([1,0,4,3,16,20,13,284,64,27,45,141,22,17,44,5,6]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=e.$emc=void 0;class r extends M.$4j{get disposed(){return this.n}constructor(l,i,$,a,b){super(),this.id=l,this.name=i,this.r=$,this.s=a,this.extension=b,this.m=0,this.n=!1,this.visible=!1,this.setLevel($.getLevel()),this.B($.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,l)}replace(l){const i=this.m;this.info(l),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(l,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:i))}hide(){this.s.$close(this.id)}g(l,i){this.m+=u.$Ce.fromString(i).byteLength,(0,M.log)(this.r,l,i),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends r{appendLine(l){this.append(l)}}let t=class{constructor(l,i,$,a,b,h){this.i=i,this.j=$,this.k=a,this.l=b,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(I.$SM.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,y.$Ym)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[i,$]of this.g)$.visible=i===this.h}createOutputChannel(l,i,$){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const a=typeof i=="object"&&i.log,b=(0,v.$5f)(i)?i:void 0;if((0,v.$5f)(b)&&!b.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const D=this.i.environment.extensionLogLevel?.find(([k])=>F.$Mm.equals($.identifier,k))?.[1];D&&(h=(0,M.$ck)(D));const d=a?this.o(l,h,$):this.n(l,b,$);return d.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),a?this.r(l,h??this.m.getLevel(),d):this.q(l,d)}async n(l,i,$){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,b=this.k.extUri.joinPath(a,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(b,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),D=await this.a.$register(l,b,i,$.identifier.value);return new r(D,l,h,this.a,$)}async o(l,i,$){const a=await this.p($),b=l.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath(a,`${b}.log`),D=`${$.identifier.value}.${b}`,d=this.l.createLogger(h,{id:D,name:l,logLevel:i,extensionId:$.identifier.value});return new n(D,l,d,this.a,$)}p(l){let i=this.d.get(l.identifier.value);if(!i){const $=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,i=(async()=>{try{await this.j.value.createDirectory($)}catch(a){if((0,m.$bl)(a)!==m.FileSystemProviderErrorCode.FileExists)throw a}return $})())}return i}q(l,i){let $=!1;const a=()=>{if($)throw new Error("Channel has been closed")};return{get name(){return l},append(b){a(),i.then(h=>h.append(b))},appendLine(b){a(),i.then(h=>h.appendLine(b))},clear(){a(),i.then(b=>b.clear())},replace(b){a(),i.then(h=>h.replace(b))},show(b,h){a(),i.then(D=>D.show(b,h))},hide(){a(),i.then(b=>b.hide())},dispose(){$=!0,i.then(b=>b.dispose())}}}r(l,i,$){const a=new o.$Tc,b=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},h=a.add(new s.$be);function D(d){i=d,h.fire(d)}return $.then(d=>{a.add(d),d.logLevel!==i&&D(d.logLevel),a.add(d.onDidChangeLogLevel(k=>D(k)))}),{...this.q(l,$),get logLevel(){return i},onDidChangeLogLevel:h.event,trace(d,...k){b(),$.then(g=>g.trace(d,...k))},debug(d,...k){b(),$.then(g=>g.debug(d,...k))},info(d,...k){b(),$.then(g=>g.info(d,...k))},warn(d,...k){b(),$.then(g=>g.warn(d,...k))},error(d,...k){b(),$.then(g=>g.error(d,...k))},dispose(){a.dispose()}}}};e.$emc=t,e.$emc=t=Je([We(0,A.$fP),We(1,E.$vP),We(2,f.$3kc),We(3,T.$Fkc),We(4,M.$Yj),We(5,M.$Xj)],t),e.$fmc=(0,N.$ri)("IExtHostOutputService")}),define(Ce[117],Re([1,0,3,11]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=void 0,e.$bn=(0,I.$ri)("remoteAgentService"),e.$cn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let F=1/0;for(let p=0;p<this.maxSampleCount;p++){const f=await A.getRoundTripTime();if(f===void 0)return;F=Math.min(F,f/2),await(0,N.$sh)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(F):M=this.initial.reduce((p,f)=>p+f,0)/this.initial.length,this.lastMeasurement={initial:M,current:F,average:this.average.reduce((p,f)=>p+f,0)/this.average.length,high:typeof M>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[285],Re([1,0,175,57,30,49,48,6,5,117,21,25,11]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=void 0,e.$tJ=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$uJ=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$vJ=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$wJ=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$xJ={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new f.$be,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const m=new v;A.$0n.add(e.$xJ.ConfigurationMigration,m);let s=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const l of c.added)await this.f(l,m.migrations)})),this.c(m.migrations),this.B(m.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(c=>this.g(c,n?.uri))])}async g(n,t){const c=this.a.inspect(n.key,{resource:t}),l=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,$]of l){const a=c[i];if(!a)continue;const b=[];if(a.value!==void 0){const h=await this.h(n,i,a.value,t,void 0);for(const D of h??[])b.push([D,[]])}for(const{identifiers:h,value:D}of a.overrides??[])if(D!==void 0){const d=await this.h(n,i,D,t,h);for(const k of d??[])b.push([k,h])}b.length&&await Promise.allSettled(b.map(async([[h,D],d])=>this.a.updateValue(h,D.value,{resource:t,overrideIdentifiers:d},$)))}}async h(n,t,c,l,i){const $=b=>{const D=this.a.inspect(b,{resource:l})[t];if(D)return i?D.overrides?.find(({identifiers:d})=>(0,y.$2n)(d,i))?.value:D.value},a=await n.migrateFn(c,$);return Array.isArray(a)?a:[[n.key,a]]}};e.$yJ=s,e.$yJ=s=Je([We(0,M.$Xi),We(1,F.$Ai)],s);let o=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$Oh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;A.$0n.as(N.$co.Configuration).registerConfiguration({...e.$vJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$zJ=o,e.$zJ=o=Je([We(0,E.$bn)],o)}),define(Ce[286],Re([1,0,36,12,19,23,184,285,57,3,30]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Pgb=e.$Ogb=void 0,e.$Qgb=s,e.$Rgb=o,e.$Ogb=(0,E.$ri)("editorResolverService"),e.$Pgb="workbench.editorAssociations";const y=T.$0n.as(f.$co.Configuration),u={...p.$uJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var v;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(v||(e.RegisteredEditorPriority=v={}));var m;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(m||(e.ResolvedStatus=m={}));function s(r){switch(r){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}function o(r,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const l=typeof r=="string"&&r.indexOf(A.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,F.$2g)(n);return I.$kk(typeof r=="string"?r.toLowerCase():r,l.toLowerCase())}}),define(Ce[287],Re([1,0,47,12,19,21,23,2,3,205,49,225,117]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=void 0,e.$uM=(0,f.$ri)("pathService");let m=v=class{constructor(o,r,n,t){this.d=o,this.e=r,this.f=n,this.g=t,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,r,n){return typeof r=="string"||typeof r>"u"?this.a.then(t=>this.h(o,t,r)):this.h(o,r,n)}h(o,r,n){return o.scheme===N.Schemas.file||o.scheme===N.Schemas.vscodeRemote?(0,I.$pg)(n??(0,M.$2g)(o),r===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,r){if(o.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,E.$rM)(r.getWorkspace());if(n)return n;const t=r.getWorkspace().folders[0];if(t)return t.uri.scheme;const c=r.getWorkspace().configuration;return c?c.scheme:N.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?A.$gc:A.$hc)}async fileURI(o){let r="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const t=o.indexOf("/",2);t===-1?(r=o.substring(2),o="/"):(r=o.substring(2,t),o=o.substring(t)||"/")}return p.URI.from({scheme:N.Schemas.file,authority:r,path:o,query:"",fragment:""})}};e.$vM=m,e.$vM=m=v=Je([We(1,u.$bn),We(2,y.$dM),We(3,T.$Ai)],m)}),define(Ce[118],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$1K=e.$ZK=void 0;class I{constructor(M,p){this.line=M,this.character=p}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,p){return new I(0,0)}with(M){return new I(0,0)}}e.$ZK=I;class N{constructor(M,p,f,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(M,p),this.end=new I(f,E)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$1K=N;var A;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(Ce[46],Re([1,0,18,36,25,47,15,3,19,14,118,11]),function(ge,e,I,N,A,F,M,p,f,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nL=e.$lL=e.$eL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$bL=e.$aL=e.$_K=e.$$K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.TextSearchCompleteMessageType=void 0,e.$8K=r,e.$9K=n,e.$0K=t,e.$cL=d,e.$dL=k,e.$fL=w,e.$gL=C,e.$hL=P,e.$iL=W,e.$jL=V,e.$kL=q,e.$mL=j,e.$oL=ae,e.$pL=ve,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$2K="workbench.view.search",e.$3K="workbench.panel.search",e.$4K="workbench.view.search",e.$5K="search-result",e.$6K="search.exclude";const u="\u27EA ",v=" characters skipped \u27EB",m=(u.length+v.length+5)*2;e.$7K=(0,p.$ri)("searchService");var s;(function(de){de[de.file=0]="file",de[de.text=1]="text",de[de.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var o;(function(de){de[de.File=1]="File",de[de.Text=2]="Text",de[de.aiText=3]="aiText"})(o||(e.QueryType=o={}));function r(de){return!!de.preview}function n(de){return!!de.resource}function t(de){return!!de.message}var c;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class l{constructor(me){this.resource=me,this.results=[]}}e.$$K=l;class i{constructor(me,Me,ce,Ae){this.ranges=Me,this.webviewIndex=Ae;const ie=Array.isArray(Me)?Me:[Me];if(ce&&ce.matchLines===1&&$(ie)){me=(0,M.$Xf)(me,ce.matchLines);let L="",x=0,be=0;const Oe=Math.floor(ce.charsPerLine/5),Ee=[];for(const pe of ie){const fe=Math.max(pe.startColumn-Oe,0),X=pe.startColumn+ce.charsPerLine;if(fe>be+Oe+m){const Z=u+(fe-be)+v;L+=Z+me.slice(fe,X),x+=fe-(be+Z.length)}else L+=me.slice(be,X);Ee.push(new b(0,pe.startColumn-x,pe.endColumn-x)),be=X}this.preview={text:L,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const L=Array.isArray(Me)?Me[0].startLineNumber:Me.startLineNumber;this.preview={text:me,matches:(0,I.$2b)(Me,x=>new a(x.startLineNumber-L,x.startColumn,x.endLineNumber-L,x.endColumn))}}}}e.$_K=i;function $(de){const me=de[0].startLineNumber;for(const Me of de)if(Me.startLineNumber!==me||Me.endLineNumber!==me)return!1;return!0}class a{constructor(me,Me,ce,Ae){this.startLineNumber=me,this.startColumn=Me,this.endLineNumber=ce,this.endColumn=Ae}}e.$aL=a;class b extends a{constructor(me,Me,ce){super(me,Me,me,ce)}}e.$bL=b;var h;(function(de){de.List="list",de.Tree="tree"})(h||(e.ViewMode=h={}));var D;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(D||(e.SearchSortOrder=D={}));function d(de,me=!0){const Me=de&&de.files&&de.files.exclude,ce=me&&de&&de.search&&de.search.exclude;if(!Me&&!ce)return;if(!Me||!ce)return Me||ce;let Ae=Object.create(null);return Ae=A.$1n(Ae,A.$Xn(Me)),Ae=A.$1n(Ae,A.$Xn(ce),!0),Ae}function k(de,me){return de.excludePattern&&N.$kk(de.excludePattern,me)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&N.$kk(de.includePattern,me)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(Me=>{const ce=Me.folder.fsPath;if(F.$rg(me,ce)){const Ae=f.$mc(ce,me);return!Me.includePattern||!!N.$kk(Me.includePattern,Ae)}else return!1}):!1:!0}var g;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class S extends Error{constructor(me,Me){super(me),this.code=Me}}e.$eL=S;function w(de){const me=de.message;if((0,E.$4)(de))return new S(me,g.canceled);try{const Me=JSON.parse(me);return new S(Me.message,Me.code)}catch{return new S(me,g.other)}}function C(de){const me={message:de.message,code:de.code};return new Error(JSON.stringify(me))}function P(de){return de.type==="error"?!0:de.type==="success"}function W(de){return de.type==="success"}function V(de){return!!de.path}function q(de,me,Me=!0){const ce=de.searchPath?de.searchPath:de.relativePath;return Me?(0,M.$Uf)(ce,me):N.$kk(me,ce)}class R{constructor(me){this.path=me,this.results=[]}addMatch(me){this.results.push(me)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$lL=R;function j(de,me){const Me={...de||{},...me||{}};return Object.keys(Me).filter(ce=>{const Ae=Me[ce];return typeof Ae=="boolean"&&Ae})}class K{constructor(me,Me){this.c=null,this.a={...me.excludePattern||{},...Me.excludePattern||{}},this.b=N.$lk(this.a);let ce=me.includePattern;Me.includePattern&&(ce?ce={...ce,...Me.includePattern}:ce=Me.includePattern),ce&&(this.c=N.$lk(ce))}matchesExcludesSync(me,Me,ce){return!!(this.b&&this.b(me,Me,ce))}includedInQuerySync(me,Me,ce){return!(this.b&&this.b(me,Me,ce)||this.c&&!this.c(me,Me,ce))}includedInQuery(me,Me,ce){const Ae=this.b(me,Me,ce),ie=()=>this.c?!!this.c(me,Me,ce):!0;return(0,y.$dh)(Ae)?Ae.then(L=>L?!1:ie()):ie()}hasSiblingExcludeClauses(){return re(this.a)}}e.$nL=K;function re(de){for(const me in de)if(typeof de[me]!="boolean")return!0;return!1}function ae(de){if(!de)return;let me;return Me=>(me||(me=(de()||Promise.resolve([])).then(ce=>ce?Ie(ce):{})),me.then(ce=>!!ce[Me]))}function ve(de){if(!de)return;let me;return Me=>{if(!me){const ce=de();me=ce?Ie(ce):{}}return!!me[Me]}}function Ie(de){const me={};for(const Me of de)me[Me]=!0;return me}}),define(Ce[37],Re([1,0,18,11,24,5,6,52,12,126,23,15,2,174,3,13,194,49,45,27,16,8,7,60,46,4,53]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t,c,l,i,$,a,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=e.$Wkc=void 0;function D(W,V,q){return new T.$Tg(R=>S(R,q)).isEqual(W,V)}function d(W,V,q){return D(W.uri,V.uri,q)?0:(0,y.$nf)(W.uri.toString(),V.uri.toString())}function k(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:D(W.uri,V.uri,q)?(0,y.$nf)(W.name,V.name):(0,y.$nf)(W.uri.toString(),V.uri.toString())}function g(W,V,q,R){const j=W.slice(0).sort((re,ae)=>q(re,ae,R)),K=V.slice(0).sort((re,ae)=>q(re,ae,R));return(0,I.$Eb)(j,K,(re,ae)=>q(re,ae,R))}function S(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class w extends r.$Ki{static toExtHostWorkspace(V,q,R,j){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:re,folders:ae,configuration:ve,transient:Ie,isUntitled:de}=V,me=[],Me=q;q?ae.forEach((L,x)=>{const be=u.URI.revive(L.uri),Oe=w.o(R||q,be,j);Oe?(Oe.name=L.name,Oe.index=L.index,me.push(Oe)):me.push({uri:be,name:L.name,index:x})}):me.push(...ae.map(({uri:L,name:x,index:be})=>({uri:u.URI.revive(L),name:x,index:be}))),me.sort((L,x)=>L.index<x.index?-1:1);const ce=new w(K,re,me,!!Ie,ve?u.URI.revive(ve):null,!!de,L=>S(L,j)),{added:Ae,removed:ie}=g(Me?Me.workspaceFolders:[],ce.workspaceFolders,d,j);return{workspace:ce,added:Ae,removed:ie}}static o(V,q,R){for(let j=0;j<V.folders.length;j++){const K=V.workspaceFolders[j];if(D(K.uri,q,R))return K}}constructor(V,q,R,j,K,re,ae){super(V,R.map(ve=>new r.$Li(ve)),j,K,ae),this.t=q,this.u=re,this.q=[],this.s=p.$xi.forUris(ae),R.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,T.$4g)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let C=class{constructor(V,q,R,j,K){this.c=new F.$be,this.onDidChangeWorkspace=this.c.event,this.g=new F.$be,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new F.$de,this.C=new Map,this.h=j,this.s=R,this.t=K,this.j=new E.$ym,this.k=new N.$qh,this.o=V.getProxy(b.$SM.MainThreadWorkspace),this.q=V.getProxy(b.$SM.MainThreadMessageService);const re=q.workspace;this.l=re?new w(re.id,re.name,[],!!re.transient,re.configuration?u.URI.revive(re.configuration):null,!!re.isUntitled,ae=>S(ae,R)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:f.Schemas.untitled,path:(0,T.$2g)((0,T.$4g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,R,...j){const K=[];if(Array.isArray(j)&&j.forEach(de=>{u.URI.isUri(de.uri)&&!K.some(me=>D(me.uri,de.uri,this.s))&&K.push({uri:de.uri,name:de.name||(0,T.$1g)(de.uri)})}),this.n||[q,R].some(de=>typeof de!="number"||de<0)||R===0&&K.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(q+R>re.length)return!1;const ae=re.slice(0);ae.splice(q,R,...K.map(de=>({uri:de.uri,name:de.name||(0,T.$1g)(de.uri),index:void 0})));for(let de=0;de<ae.length;de++){const me=ae[de];if(ae.some((Me,ce)=>ce!==de&&D(me.uri,Me.uri,this.s)))return!1}ae.forEach((de,me)=>de.index=me);const{added:ve,removed:Ie}=g(re,ae,k,this.s);if(ve.length===0&&Ie.length===0)return!1;if(this.o){const de=V.displayName||V.name;this.o.$updateWorkspaceFolders(de,q,R,K).then(void 0,me=>{this.n=void 0;const Me={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(o.Severity.Error,(0,v.localize)(0,null,de,me.toString()),Me,[])})}return this.y(ae),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let R,j="";if(typeof V=="string"?(R=u.URI.file(V),j=V):typeof V<"u"&&(R=V,j=V.fsPath),!R)return j;const K=this.getWorkspaceFolder(R,!0);if(!K)return j;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let re=(0,T.$7g)(K.uri,R);return q&&K.name&&(re=`${K.name}/${re}`),re}y(V){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:R,removed:j}=w.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:j}))}findFiles(V,q,R,j,K=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let re="",ae=!0;return q===null?ae=!1:q!==void 0&&(typeof q=="string"?re=q:re=q.pattern),this.z(V,void 0,{exclude:re,maxResults:R,useDefaultExcludes:ae,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,q={},R,j=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${R.value}, entryPoint: findFiles2`),this.z(void 0,V,q,j)}async z(V,q,R,j=A.CancellationToken.None){if(j&&j.isCancellationRequested)return Promise.resolve([]);const K=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,re={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof R.useDefaultSearchExcludes=="boolean"?!R.useDefaultSearchExcludes:!1,maxResults:R.maxResults,excludePattern:K,shouldGlobSearch:typeof R.fuzzy=="boolean"?!R.fuzzy:!0,_reason:"startFileSearch"};let ae;if(V){const{includePattern:ve,folder:Ie}=P(l.GlobPattern.from(V));ae=Ie,re.includePattern=ve}else{const{includePattern:ve,folder:Ie}=P(l.GlobPattern.from(q));ae=Ie,re.filePattern=ve}return this.o.$startFileSearch(ae??null,re,j).then(ve=>Array.isArray(ve)?ve.map(Ie=>u.URI.revive(Ie)):[])}async findTextInFiles(V,q,R,j,K=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),ae=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ve,folder:Ie}=P(l.GlobPattern.from(q.include)),de=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,me={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ae,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ve,excludePattern:de},Me=!1;if(this.u[re]=ce=>{if(Me)return;const Ae=u.URI.revive(ce.resource);ce.results.forEach(ie=>{const L=(0,h.$1h)(ie);(0,a.$8K)(L)?R({uri:Ae,preview:{text:L.preview.text,matches:(0,I.$2b)(L.preview.matches,x=>new i.$WM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,I.$2b)(L.ranges,x=>new i.$WM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):R({uri:Ae,text:L.text,lineNumber:L.lineNumber})})},K.isCancellationRequested)return{};try{const ce=await this.o.$startTextSearch(V,Ie??null,me,re,K);return delete this.u[re],ce||{}}catch(ce){throw delete this.u[re],ce}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return u.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return u.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const R=this.t.transformOutgoingScheme(V),j=this.A++;return this.o.$registerEditSessionIdentityProvider(j,R),(0,M.$Sc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const R=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const j=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!j),!j)return;const K=await j.provideEditSessionIdentity(R,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,q,R,j){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const re=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!re),!re)return;const ae=await re.provideEditSessionIdentityMatch?.(q,R,j);if(this.h.info("Provider returned edit session identifier match result: ",ae),!!ae)return ae}getOnWillCreateEditSessionIdentityEvent(V){return(q,R,j)=>{const K=function(ae){q.call(R,ae)};return K.extension=V,this.B.event(K,void 0,j)}}async $onWillCreateEditSessionIdentity(V,q,R){const j=await this.resolveWorkspaceFolder(u.URI.revive(V));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:j},q,async(K,re)=>{const ae=Date.now();await Promise.resolve(K),Date.now()-ae>R&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const R=this.t.transformOutgoingScheme(V),j=this.A++;return this.o.$registerCanonicalUriProvider(j,R),(0,M.$Sc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(V,q,R){const j=this.C.get(V.scheme);if(!j)return;const K=await j.provideCanonicalUri?.(u.URI.revive(V),q,R);if(K)return K}async $provideCanonicalUri(V,q,R){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:q},R)}};e.$Wkc=C,e.$Wkc=C=Je([We(0,c.$fP),We(1,t.$vP),We(2,n.$Fkc),We(3,s.$Xj),We(4,$.$Ukc)],C),e.$Xkc=(0,m.$ri)("IExtHostWorkspace");function P(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=u.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(Ce[38],Re([1,0,25,5,37,4,7,196,57,17,11,3,16,13,2]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=e.$Zkc=e.$Ykc=void 0;function s($,a){if(a){const b=a.split(".");let h=$;for(let D=0;h&&D<b.length;D++)h=h[b[D]];return h}}function o($){return $ instanceof m.URI}function r($){return $&&$.uri instanceof m.URI&&$.languageId&&typeof $.languageId=="string"}function n($){return $&&!$.uri&&$.languageId&&typeof $.languageId=="string"}function t($){return $&&$.uri instanceof m.URI&&(!$.name||typeof $.name=="string")&&(!$.index||typeof $.index=="number")}function c($){if(o($))return{resource:$};if(r($))return{resource:$.uri,overrideIdentifier:$.languageId};if(n($))return{overrideIdentifier:$.languageId};if(t($))return{resource:$.uri};if($===null)return{resource:null}}let l=class{constructor(a,b,h){this.a=a.getProxy(F.$SM.MainThreadConfiguration),this.c=b,this.b=h,this.d=new T.$qh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new i(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,b){this.getConfigProvider().then(h=>h.$acceptConfigurationChanged(a,b))}};e.$Ykc=l,e.$Ykc=l=Je([We(0,u.$fP),We(1,A.$Xkc),We(2,v.$Xj)],l);class i{constructor(a,b,h,D){this.a=new N.$be,this.b=a,this.f=D,this.c=b,this.e=p.$vo.parse(h,D),this.d=this.k(h.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,b){const h={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$vo.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(b,h))}getConfiguration(a,b,h){const D=c(b)||{},d=this.g(a?s(this.e.getValue(void 0,D,this.c.workspace),a):this.e.getValue(void 0,D,this.c.workspace));a&&this.h(a,D,h?.identifier);function k(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(S){return typeof s(d,S)<"u"},get:(S,w)=>{this.h(a?`${a}.${S}`:S,D,h?.identifier);let C=s(d,S);if(typeof C>"u")C=w;else{let P;const W=(V,q)=>{if((0,E.$7f)(V)){let R;const j=()=>{P=P||(0,I.$Xn)(d),R=R||s(P,q)};return new Proxy(V,{get:(K,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return j(),()=>R;if(P)return R=R||s(P,q),R[re];const ae=K[re];return typeof re=="string"?W(ae,`${q}.${re}`):ae},set:(K,re,ae)=>(j(),R&&(R[re]=ae),!0),deleteProperty:(K,re)=>(j(),R&&delete R[re],!0),defineProperty:(K,re,ae)=>(j(),R&&Object.defineProperty(R,re,ae),!0)})}return Array.isArray(V)?(0,I.$Xn)(V):V};C=W(C,S)}return C},update:(S,w,C,P)=>{S=a?`${a}.${S}`:S;const W=k(C);return w!==void 0?this.b.$updateConfigurationOption(W,S,w,D,P):this.b.$removeConfigurationOption(W,S,D,P)},inspect:S=>{S=a?`${a}.${S}`:S;const w=this.e.inspect(S,D,this.c.workspace);if(w)return{key:S,defaultValue:(0,I.$Xn)(w.policy?.value??w.default?.value),globalValue:(0,I.$Xn)(w.user?.value??w.application?.value),workspaceValue:(0,I.$Xn)(w.workspace?.value),workspaceFolderValue:(0,I.$Xn)(w.workspaceFolder?.value),defaultLanguageValue:(0,I.$Xn)(w.default?.override),globalLanguageValue:(0,I.$Xn)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,I.$Xn)(w.workspace?.override),workspaceFolderLanguageValue:(0,I.$Xn)(w.workspaceFolder?.override),languageIds:(0,I.$Xn)(w.overrideIdentifiers)}}};return typeof d=="object"&&(0,I.$1n)(g,d,!1),Object.freeze(g)}g(a){const b=h=>(0,E.$7f)(h)?new Proxy(h,{get:(D,d)=>b(D[d]),set:(D,d,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(D,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(D,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):h;return b(a)}h(a,b,h){const D=f.$mo.test(a)?4:this.d.get(a),d=h?`[${h.value}] `:"";if(D===4){typeof b?.resource>"u"&&this.f.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(D===3){b?.resource&&this.f.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,b){const h=new p.$xo(a,b,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,d)=>h.affectsConfiguration(D,c(d))})}k(a){return a.reduce((b,h)=>(b.set(h[0],h[1]),b),new Map)}}e.$Zkc=i,e.$1kc=(0,y.$ri)("IExtHostConfiguration")}),define(Ce[119],Re([1,0,2,11,5,4,7,37,67,38,24,51,16,27,3,12,21,13,78,230,14]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=e.$qmc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})(l||(l={}));var i;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})(i||(i={}));var $;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})($||($={}));var a;(function(W){function V(j){if(j){const K=j;return K&&!!K.process}else return!1}W.is=V;function q(j){if(j==null)return;const K={process:j.process,args:j.args};return j.options&&(K.options=$.from(j.options)),K}W.from=q;function R(j){if(j!=null)return new M.$DN(j.process,j.args,j.options)}W.to=R})(a||(a={}));var b;(function(W){function V(R){if(R!=null)return R}W.from=V;function q(R){if(R!=null)return R}W.to=q})(b||(b={}));var h;(function(W){function V(j){if(j){const K=j;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=V;function q(j){if(j==null)return;const K={};return j.commandLine!==void 0?K.commandLine=j.commandLine:(K.command=j.command,K.args=j.args),j.options&&(K.options=b.from(j.options)),K}W.from=q;function R(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new M.$EN(j.commandLine,j.options):new M.$EN(j.command,j.args?j.args:[],j.options)}W.to=R})(h||(h={}));var D;(function(W){function V(j){if(j){const K=j;return K&&K.customExecution==="customExecution"}else return!1}W.is=V;function q(j){return{customExecution:"customExecution"}}W.from=q;function R(j,K){return K.get(j)}W.to=R})(D||(e.CustomExecutionDTO=D={}));var d;(function(W){function V(q,R){let j;return q.scope!==void 0&&typeof q.scope!="number"?j=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&R&&R.workspaceFile?j=R.workspaceFile:j=t.$YH),{id:q._id,workspaceFolder:j}}W.from=V})(d||(e.TaskHandleDTO=d={}));var k;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(k||(k={}));var g;(function(W){function V(j,K){if(j==null)return[];const re=[];for(const ae of j){const ve=q(ae,K);ve&&re.push(ve)}return re}W.fromMany=V;function q(j,K){if(j==null)return;let re;j.execution instanceof M.$DN?re=a.from(j.execution):j.execution instanceof M.$EN?re=h.from(j.execution):j.execution&&j.execution instanceof M.$FN&&(re=D.from(j.execution));const ae=l.from(j.definition);let ve;return j.scope?typeof j.scope=="number"?ve=j.scope:ve=j.scope.uri:ve=M.TaskScope.Workspace,!ae||!ve?void 0:{_id:j._id,definition:ae,name:j.name,source:{extensionId:K.identifier.value,label:j.source,scope:ve},execution:re,isBackground:j.isBackground,group:k.from(j.group),presentationOptions:i.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}W.from=q;async function R(j,K,re){if(j==null)return;let ae;a.is(j.execution)?ae=a.to(j.execution):h.is(j.execution)?ae=h.to(j.execution):D.is(j.execution)&&(ae=D.to(j._id,re));const ve=l.to(j.definition);let Ie;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?Ie=j.source.scope:Ie=await K.resolveWorkspaceFolder(I.URI.revive(j.source.scope)):Ie=M.TaskScope.Workspace),!ve||!Ie)return;const de=new M.$GN(ve,Ie,j.name,j.source.label,ae,j.problemMatchers);return j.isBackground!==void 0&&(de.isBackground=j.isBackground),j.group!==void 0&&(de.group=M.$CN.from(j.group._id),de.group&&j.group.isDefault&&(de.group=new M.$CN(de.group.id,de.group.label),j.group.isDefault===!0&&(de.group.isDefault=j.group.isDefault))),j.presentationOptions&&(de.presentationOptions=i.to(j.presentationOptions)),j._id&&(de._id=j._id),j.detail&&(de.detail=j.detail),de}W.to=R})(g||(e.TaskDTO=g={}));var S;(function(W){function V(R){return R}W.from=V;function q(R){if(R)return Object.assign(Object.create(null),R)}W.to=q})(S||(S={}));class w{#e;constructor(V,q,R){this._id=q,this.a=R,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let C=class{constructor(V,q,R,j,K,re,ae,ve){this.q=new A.$be,this.r=new A.$be,this.s=new A.$be,this.u=new A.$be,this.a=V.getProxy(F.$SM.MainThreadTask),this.b=R,this.c=j,this.d=K,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ae,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,R){if(!R)return new M.$UM(()=>{});const j=this.x();return this.j.set(j,{type:q,provider:R,extension:V}),this.a.$registerTaskProvider(j,q),new M.$UM(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(S.from(V)).then(async q=>{const R=[];for(const j of q){const K=await g.to(j,this.b,this.m);K&&R.push(K)}return R})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,R){const j=this.m.get(V.id);j&&(this.o.set(V.id,j),this.e.attachPtyToTerminal(q,await j.callback(R))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const R=this.j.get(V);if(!R)return Promise.reject(new Error("no handler found"));const j=[],K=(0,N.$jh)(()=>R.provider.provideTasks(T.CancellationToken.None)).then(re=>this.v(q,j,R,re));return new Promise(re=>{K.then(ae=>{Promise.all(j).then(()=>{re(ae)})})})}async $resolveTask(V,q){const R=this.j.get(V);if(!R)return Promise.reject(new Error("no handler found"));if(q.definition.type!==R.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${R.type}].`);const j=await g.to(q,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const K=await R.provider.resolveTask(j,T.CancellationToken.None);if(!K)return;this.A(K,R);const re=g.from(K,R.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(re.execution)&&await this.y(re,K,!0),await this.w(re)}x(){return this.h++}async y(V,q,R){const j=await this.a.$createTaskId(V);!R&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,q.execution)),this.m.set(j,q.execution)}async z(V,q){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const R=this.l.get(V.id);if(R)return R;let j;return q?j=Promise.resolve(new w(this,V.id,q)):j=g.to(V.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new w(this,V.id,K)}),this.l.set(V.id,j),j.then(K=>(this.k.set(V.id,K),K))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const R=this.n.values();let j=R.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=R.next()}};e.$qmc=C,e.$qmc=C=Je([We(0,u.$fP),We(1,v.$vP),We(2,p.$Xkc),We(3,f.$qP),We(4,E.$1kc),We(5,y.$mlc),We(6,r.$Xj),We(7,n.$Bkc)],C);let P=class extends C{constructor(V,q,R,j,K,re,ae,ve){super(V,q,R,j,K,re,ae,ve),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const R=g.from(q,V);if(R===void 0)throw new Error("Task is not valid");if(D.is(R.execution))await this.y(R,q,!1);else throw new c.$_;const j=await this.z(await this.a.$getTaskExecution(R),q);return this.a.$executeTask(R).catch(K=>{throw new Error(K)}),j}v(V,q,R,j){const K=[];if(j)for(const re of j){if(this.A(re,R),!re.definition||!V[re.definition.type]){const ve=re.source?re.source:"No task source";this.f.warn(`The task [${ve}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=g.from(re,R.extension);ae&&D.is(ae.execution)?(K.push(ae),q.push(this.y(ae,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:R.extension}}async w(V){if(D.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,R){}};e.$rmc=P,e.$rmc=P=Je([We(0,u.$fP),We(1,v.$vP),We(2,p.$Xkc),We(3,f.$qP),We(4,E.$1kc),We(5,y.$mlc),We(6,r.$Xj),We(7,n.$Bkc)],P),e.$smc=(0,m.$ri)("IExtHostTask")}),define(Ce[288],Re([1,0,46,29]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wL=void 0,e.$vL=A,e.$xL=F;function A(M){return"cellResults"in M}e.$wL="rawCell#";function F(M,p){let f=-1;const E=[];let T=[];return M.forEach(u=>{u.range.startLineNumber!==f&&T.length>0&&(E.push([...T]),T=[]),T.push(u),f=u.range.endLineNumber}),T.length>0&&E.push([...T]),E.map(u=>{const v=[],m=u[0].range.startLineNumber,s=u[u.length-1].range.endLineNumber;for(let o=m;o<=s;o++)v.push(p.getLineContent(o));return new I.$_K(v.join(`
`)+`
`,u.map(o=>new N.$nt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ce[289],Re([1,0,168,22,5,6,28,15,17,2,44,74,4,32,8,7,34,264,112,25,12,220,288,286]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t,c,l,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,D,d,k,g,S){this.q=d,this.r=k,this.s=g,this.t=S,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new A.$be,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$be,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$be,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$be,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.$zkc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy(u.$SM.MainThreadNotebook),this.c=h.getProxy(u.$SM.MainThreadNotebookDocuments),this.d=h.getProxy(u.$SM.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===13){const C=w.notebookEditor?.notebookUri,P=w.cell.handle,V=this.g.get(C)?.getCell(P);if(V)return V.apiCell}if(w&&w.$mid===14){const C=w.uri,P=this.g.get(C);if(P)return P.apiNotebook}return w}}),a.B(D)}getEditorById(h){const D=this.h.get(h);if(!D)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(h){for(const[D,d]of this.h)if(d.apiEditor===h)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,D){const d=this.g.get(h);if(!d&&!D)throw new Error(`NO notebook document for '${h}'`);return d}static u(h,D){if(!D)return;const d=D.filenamePattern.map(k=>m.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(D.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:D.displayName,filenamePattern:d,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,D,d){const k=a.a++,g=typeof d.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(k,d),this.b.$registerNotebookCellStatusBarItemProvider(k,g,D);let S;return g!==void 0&&(S=d.onDidChangeCellStatusBarItems(w=>this.b.$emitCellStatusBarEvent(g))),new s.$UM(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,g),S?.dispose()})}async createNotebookDocument(h){const D=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&m.NotebookData.from(h.content)});return E.URI.revive(D)}async openNotebookDocument(h){const D=this.g.get(h);if(D)return D.apiNotebook;const d=await this.c.$tryOpenNotebook(h),k=this.g.get(E.URI.revive(d));return(0,f.$dg)(k?.apiNotebook)}async showNotebookDocument(h,D){E.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let d;typeof D=="object"?d={position:m.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(m.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:d={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,d),g=k&&this.h.get(k)?.apiEditor;if(g)return g;throw k?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,D,d,k){const g=this.f.get(h),S=E.URI.revive(D),w=this.g.get(S);if(!w||!g)return;const C=w.getCellFromIndex(d);if(!C)return;const P=await g.provideCellStatusBarItems(C.apiCell,k);if(!P)return;const W=new F.$Tc,V=this.p.add([W]),R=(Array.isArray(P)?P:[P]).map(j=>m.NotebookStatusBarItem.from(j,this.i,W));return{cacheId:V,items:R}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,D,d,k,g){if((0,p.$4e)(D))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:D,serializer:d,options:k}),this.b.$registerNotebookSerializer(S,{id:h.identifier,location:h.extensionLocation},D,m.NotebookDocumentContentOptions.from(k),a.u(h,g)),(0,F.$Sc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(h,D,d){const k=this.x.get(h);if(!k)throw new Error("NO serializer found");const g=await k.serializer.deserializeNotebook(D.buffer,d);return new o.$ow(m.NotebookData.from(g))}async $notebookToData(h,D,d){const k=this.x.get(h);if(!k)throw new Error("NO serializer found");const g=await k.serializer.serializeNotebook(m.NotebookData.to(D.value),d);return N.$Ce.wrap(g)}async $saveNotebook(h,D,d,k,g){const S=E.URI.revive(D),w=this.x.get(h);if(!w)throw new Error("NO serializer found");const C=this.g.get(S);if(!C)throw new Error("Document NOT found");if(C.versionId!==d)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new T.$gl((0,I.localize)(0,null,this.z(S)),6);await this.y(S,k);const P={metadata:(0,t.$6n)(C.apiNotebook.metadata,j=>!(w.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of C.apiNotebook.getCells()){const K=new s.$kO(j.kind,j.document.getText(),j.document.languageId,j.mime,w.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);K.metadata=(0,t.$6n)(j.metadata,re=>!(w.options?.transientCellMetadata??{})[re]),P.cells.push(K)}const W=await w.serializer.serializeNotebook(P,g);await this.s.value.writeFile(S,W);const V=this.s.getFileSystemProviderExtUri(S.scheme),q=await this.s.value.stat(S);return{name:V.basename(S),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$rl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(h,D,d,k,g){const S=this.x.get(h)?.serializer;if(!S)return{limitHit:!1,results:[]};const w=new M.$Cc;await(async(q,R,j)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(re=>{const ae={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(ae,R,ve=>{ve.forEach(Ie=>{w.has(Ie)||k.some(me=>K.isFromSettings&&!me.isFromSettings?!1:me.filenamePatterns.some(Me=>(0,$.$Rgb)(Me,Ie)))||w.add(Ie)})}).catch(ve=>{if(ve.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ve})}))))})(d,g,D);const P=new M.$Bc;let W=!1;const V=Array.from(w).map(async q=>{const R=[];try{if(g.isCancellationRequested)return;if(D.maxResults&&[...P.values()].reduce((ae,ve)=>ae+ve.cellResults.length,0)>D.maxResults){W=!0;return}const j=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ve=>j.push({input:ve.document.getText(),outputs:ve.outputs.flatMap(Ie=>Ie.items.map(de=>de.data.toString()))}));else{const ae=await this.s.value.readFile(q),ve=N.$Ce.fromString(ae.toString()),Ie=await S.deserializeNotebook(ve.buffer,g);if(g.isCancellationRequested)return;m.NotebookData.from(Ie).cells.forEach(me=>j.push({input:me.source,outputs:me.outputs.flatMap(Me=>Me.items.map(ce=>ce.valueBytes.toString()))}))}if(g.isCancellationRequested)return;j.forEach((ae,ve)=>{const Ie=D.contentPattern.pattern,de=new l.$IWb(ae.input,void 0,ae.outputs),me=de.findInInputs(Ie),Me=de.findInOutputs(Ie),ce=Me.flatMap(Ae=>(0,i.$xL)(Ae.matches,Ae.textBuffer)).map((Ae,ie)=>(Ae.webviewIndex=ie,Ae));if(me.length>0||Me.length>0){const Ae={index:ve,contentResults:(0,i.$xL)(me,de.inputTextBuffer),webviewResults:ce};R.push(Ae)}});const re={resource:q,cellResults:R};P.set(q,re);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...P.values()]}}async y(h,D){const d=await this.s.value.stat(h);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==T.$ql&&typeof d.mtime=="number"&&typeof d.size=="number"&&D.mtime<d.mtime&&D.etag!==T.$rl({mtime:D.mtime,size:d.size}))throw new T.$gl((0,I.localize)(1,null),3,D)}z(h){return h.scheme===c.Schemas.file?h.fsPath:h.toString()}A(h,D,d){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const k=new n.$Wlc(D,this.d,h,d.visibleRanges.map(m.NotebookRange.to),d.selections.map(m.NotebookRange.to),typeof d.viewColumn=="number"?m.ViewColumn.to(d.viewColumn):void 0);this.h.set(D,k)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const d of h.value.removedDocuments){const k=E.URI.revive(d),g=this.g.get(k);g&&(g.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(g.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===k.toString()&&this.h.delete(S.id)}if(h.value.addedDocuments){const d=[];for(const k of h.value.addedDocuments){const g=E.URI.revive(k.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const S=new r.$Vlc(this.c,this.q,this.r,g,k);d.push(...k.cells.map(w=>r.$Ulc.asModelAddData(w))),this.g.get(g)?.dispose(),this.g.set(g,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:d}),this.m.fire(S.apiNotebook)}}if(h.value.addedEditors)for(const d of h.value.addedEditors){if(this.h.has(d.id))return;const k=E.URI.revive(d.documentUri),g=this.g.get(k);g&&this.A(g,d.id,d)}const D=[];if(h.value.removedEditors)for(const d of h.value.removedEditors){const k=this.h.get(d);k&&(this.h.delete(d),this.k?.id===k.id&&(this.k=void 0),D.push(k))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const d=new Set;this.l.forEach(k=>d.add(k.id));for(const k of this.h.values()){const g=d.has(k.id);k._acceptVisibility(g)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const D=v.$DP.String.with("notebookType","A notebook type"),d=new v.$FP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new v.$DP("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>N.$Ce.wrap(g))],new v.$EP("Notebook Data",g=>m.NotebookData.to(g.value))),k=new v.$FP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new v.$DP("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new o.$ow(m.NotebookData.from(g)))],new v.$EP("Bytes",g=>g.buffer));h.registerApiCommand(d),h.registerApiCommand(k)}}e.$6lc=a}),define(Ce[290],Re([1,0,19,24,43,36,23,65,46]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=void 0;class E{constructor(u,v,m){this.k=u,this.l=v,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&F.$lk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&F.$lk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const v=this.k.folderQueries||[];return new Promise((m,s)=>{const o=r=>{this.f++,u(r)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const n=r.toString(),t=I.$oc(n);this.j&&this.j(n,t)||this.v(o,{base:r,basename:t})}),Promise.all(v.map(r=>this.p(r,o))).then(r=>{m({limitHit:this.e,stats:r[0]||void 0})},r=>{s(new Error((0,A.$cj)(r)))})})}async p(u,v){const m=new N.$me,s=this.q(u),o=this.r(),r=new f.$nL(this.k,u),n=!r.hasSiblingExcludeClauses();let t;try{this.h.add(m),t=p.$0d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,m.token),l=t.elapsed(),i=p.$0d.create();return this.g&&!this.e||(c&&c.forEach($=>{const a=I.$hc.relative(u.folder.path,$.path);if(n){const b=I.$oc($.path);this.v(v,{base:u.folder,relativePath:a,basename:b});return}this.s(o,u.folder,a,v)}),this.g&&!this.e)?null:(this.u(o,r,v),{providerTime:l,postProcessTime:i.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(u){const v=(0,f.$mL)(this.k.includePattern,u.includePattern),m=(0,f.$mL)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:m,includes:v,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},v,m,s){if(m===this.a){const r=I.$oc(this.a);this.v(s,{base:v,relativePath:this.a,basename:r})}function o(r){const n=I.$oc(r),t=I.$nc(r);let c=u[t];c||(c=u[t]=[],o(t)),c.push({base:v,relativePath:r,basename:n})}o(m)}u({rootEntries:u,pathToEntries:v},m,s){const o=this,r=this.a;function n(t){const c=(0,f.$pL)(()=>t.map(l=>l.basename));for(let l=0,i=t.length;l<i;l++){const $=t[l],{relativePath:a,basename:b}=$;if(m.matchesExcludesSync(a,b,r!==b?c:void 0))continue;const h=v[a];if(h)n(h);else{if(a===r)continue;o.v(s,$)}if(o.e)break}}n(u)}v(u,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(v))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,v,m,s){const o=this.c(u.cacheKey),r=new E(u,v,o&&o.token);let n=0;const t=c=>{n+=c.length,m(c.map(l=>this.d(l)))};return this.e(r,T.a,t,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new N.$me),this.b.get(u)}d(u){return u.relativePath?{resource:M.$5g(u.base,u.relativePath)}:{resource:u.base}}e(u,v,m,s){const o=s.onCancellationRequested(()=>{u.cancel()}),r=t=>{t&&(n.push(t),v>0&&n.length>=v&&(m(n),n=[]))};let n=[];return u.search(r).then(t=>(n.length&&m(n),o.dispose(),t),t=>(n.length&&m(n),o.dispose(),Promise.reject(t)))}}e.$Xlc=T}),define(Ce[291],Re([1,0,18,259,36,96,28,12,19,23,15,17,2,95,186,48,13,49,107,287,46]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=void 0,e.$xM=k;let l=class{constructor(S,w,C,P,W){this.a=S,this.b=w,this.c=C,this.d=P,this.e=W}text(S,w,C={}){S=this.f(S,C);const P=this.a.getValue(),W=w&&w.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(w?.map(r.$Mi),C),type:2,contentPattern:S,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:P.search.usePCRE2||W||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(S,w){const C=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const P={...S,wordSeparators:C.editor.wordSeparators};return this.j(S,w)&&(P.isCaseSensitive=!0),this.k(S)&&(P.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),P}file(S,w={}){return{...this.h(S,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey,shouldGlobMatchFilePattern:w.shouldGlobSearch}}g(S,w){return S?(S=Array.isArray(S)?S.map(h):h(S),w?this.parseSearchPaths(S):{pattern:$(...Array.isArray(S)?S:[S])}):{}}h(S=[],w={}){const C=this.g(w.includePattern,w.expandPatterns),P=this.g(w.excludePattern,w.expandPatterns),W=S.length>1,V=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(j=>this.q(j,w,P)):S.map(j=>this.r(j,w,P,W))).filter(j=>!!j),q={_reason:w._reason,folderQueries:V,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:P.pattern,includePattern:C.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const j=I.$Hb(I.$Rb(this.c.groups.map(ae=>ae.editors.map(ve=>ve.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const K=j.filter(ae=>(0,c.$dL)(q,ae.fsPath)),re=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...q,...re}}const R=w.extraFileResources&&w.extraFileResources.filter(j=>(0,c.$dL)(q,j.fsPath));return q.extraFileResources=R&&R.length?R:void 0,q}i(S){const w=[],C=new M.$Bc,P={};let W=!1;return S.forEach(V=>{if(V.scheme===p.Schemas.walkThrough)return;if((0,E.$9g)(V)){const R=this.b.getWorkspaceFolder(V)?.uri??V.with({path:f.$nc(V.fsPath)});let j=C.get(R);j||(W=!0,j={folder:R,includePattern:{}},w.push(j),C.set(R,j));const K=f.$mc(R.fsPath,V.fsPath);(0,y.$dg)(j.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,P[V.fsPath]=!0)}),{folderQueries:w,includePattern:P,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(S,w){if(w.isSmartCase){if(S.isRegExp){if(T.$Vf(S.pattern,!0))return!0}else if(T.$Vf(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,v.$DC)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const w=re=>f.$jc(re)||/^\.\.?([\/\\]|$)/.test(re),P=(Array.isArray(S)?S:a(S)).map(re=>{const ae=this.e.resolvedUserHome;return ae?(0,F.$tw)(re,ae.scheme===p.Schemas.file?ae.fsPath:ae.path):re}),W=N.$K(P,re=>w(re)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(re=>T.$cf(re,"/")).map(re=>T.$cf(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),b(re))),q={},R=this.m(W.searchPaths||[]);R&&R.length&&(q.searchPaths=R);const j=I.$Rb(V),K=$(...j);return K&&(q.pattern=K),q}l(S,w){return w.disregardExcludeSettings?void 0:(0,c.$cL)(S,!w.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const w=S.flatMap(P=>{let{pathPortion:W,globPortion:V}=i(P);return V&&(V=D(V)),this.n(W).flatMap(R=>this.o(R,V))}),C=new Map;return w.forEach(P=>{const W=P.searchPath.toString(),V=C.get(W);V?P.pattern&&(V.pattern=V.pattern||{},V.pattern[P.pattern]=!0):C.set(W,{searchPath:P.searchPath,pattern:P.pattern?$(P.pattern):void 0})}),Array.from(C.values())}n(S){if(f.$jc(S)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==p.Schemas.file?[{searchPath:w[0].uri.with({path:S})}]:[{searchPath:u.URI.file(f.$ic(S))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(S=h(S),S.startsWith("../")||S===".."){const P=f.$hc.resolve(w.path,S);return[{searchPath:w.with({path:P})}]}const C=D(S);return[{searchPath:w,pattern:C}]}else{if(S==="./"||S===".\\")return[];{const w=S.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(W=>{const V=w.match(new RegExp(`^${T.$9e(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(y.$ag);if(P.length)return P.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&D(V)}});{const W=S.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:S,q=m.localize(0,null,V);throw new Error(q)}}}}o(S,w){const C=S.pattern&&w?`${S.pattern}/${w}`:S.pattern||w,P=[{searchPath:S.searchPath,pattern:C}];return C&&!C.endsWith("**")&&P.push({searchPath:S.searchPath,pattern:C+"/**"}),P}q(S,w,C){const P=this.r((0,r.$Mi)(S.searchPath),w,C,!1);return P?{...P,includePattern:S.pattern}:null}r(S,w,C,P){let W;const V=u.URI.isUri(S)?S:S.uri;if(C.searchPaths){const re=C.searchPaths.filter(ae=>(0,E.$Xg)(ae.searchPath,V))[0];if(re&&!re.pattern)return null;re&&(W=re.pattern)}const q=this.a.getValue({resource:V}),j={...this.l(q,w)||{},...W||{}},K=u.URI.isUri(S)?(0,E.$2g)(S):S.name;return{folder:V,folderName:P?K:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!q.search.followSymlinks}}};e.$wM=l,e.$wM=l=Je([We(0,s.$Xi),We(1,r.$Ai),We(2,n.$KD),We(3,o.$Xj),We(4,t.$uM)],l);function i(g){const S=g.match(/[\*\{\}\(\)\[\]\?]/);if(S){const w=S.index,C=g.substr(0,w).match(/[/|\\][^/\\]*$/);if(C){let P=g.substr(0,C.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:g.substr((C.index||0)+1)}}}return{pathPortion:g}}function $(...g){return g.length?g.reduce((S,w)=>(S[w]=!0,S),Object.create(null)):void 0}function a(g){return A.$jk(g,",").map(S=>S.trim()).filter(S=>!!S.length)}function b(g){return[`**/${g}/**`,`**/${g}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function h(g){return g.replace(/\\/g,"/")}function D(g){return h(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(g){return g.replace(/([?*[\]])/g,"[$1]")}function k(g,S){g=I.$Mb(g,P=>P.toString());const w=[],C=S.getWorkspace();return g&&g.forEach(P=>{let W;if(S.getWorkbenchState()===2)W=(0,E.$7g)(C.folders[0].uri,P),W&&W!=="."&&(W="./"+W);else{const V=S.getWorkspaceFolder(P);if(V){const q=V.name;if(C.folders.filter(j=>j.name===q).length===1){const j=(0,E.$7g)(V.uri,P);j===""?W=`./${V.name}`:W=`./${V.name}/${j}`}else W=P.fsPath}}W&&w.push(d(W))}),w}}),define(Ce[292],Re([1,0,23,2,24,14,3,291,46,49,11]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rtb=u,e.$Stb=s;const y=7e3;function u(o,r){const n=r.activationEvents;if(!n)return Promise.resolve(void 0);const t=[],c=[];for(const h of n)if(/^workspaceContains:/.test(h)){const D=h.substr(18);D.indexOf("*")>=0||D.indexOf("?")>=0||o.forceUsingSearch?c.push(D):t.push(D)}if(t.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:l,resolve:i}=(0,T.$kh)(),$=h=>i({activationEvent:h}),a=Promise.all(t.map(h=>v(o,h,$))).then(()=>{}),b=m(o,r.identifier,c,$);return Promise.all([a,b]).then(()=>{i(void 0)}),l}async function v(o,r,n){for(const t of o.folders)if(await o.exists(I.$5g(N.URI.revive(t),r))){n(`workspaceContains:${r}`);return}}async function m(o,r,n,t){if(n.length===0)return Promise.resolve(void 0);const c=new A.$me,l=o.checkExists(o.folders,n,c.token),i=setTimeout(async()=>{c.cancel(),o.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},y);let $=!1;try{$=await l}catch(a){F.$4(a)||F.$1(a)}c.dispose(),clearTimeout(i),$&&t(`workspaceContains:${n.join(",")}`)}function s(o,r,n,t){const c=o.get(M.$qi),l=o.get(f.$7K),$=c.createInstance(p.$wM).file(r.map(a=>(0,E.$Mi)(N.URI.revive(a))),{_reason:"checkExists",includePattern:n,exists:!0});return l.fileSearch($,t).then(a=>!!a.limitHit,a=>F.$4(a)?!1:Promise.reject(a))}}),define(Ce[39],Re([1,0,164,19,89,23,11,6,52,2,13,4,38,226,82,37,26,108,14,20,22,207,7,102,3,27,85,16,71,86,51,88,5,292,81,209,12,79,65,21,80]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t,c,l,i,$,a,b,h,D,d,k,g,S,w,C,P,W,V,q,R,j,K){"use strict";var re;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=e.$Blc=e.$Alc=e.$zlc=void 0,e.$zlc=(0,a.$ri)("IHostUtils");let ae=re=class extends p.$Uc{constructor(L,x,be,Oe,Ee,pe,fe,X,Z,le,ue,Te,he){super(),this.Y=Te,this.Z=he,this.a=this.B(new w.$be),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=be,this.f=fe,this.j=Oe,this.m=Ee,this.s=pe,this.t=Z,this.u=le,this.w=ue,this.y=this.g.getProxy(y.$SM.MainThreadWorkspace),this.z=this.g.getProxy(y.$SM.MainThreadTelemetry),this.C=this.g.getProxy(y.$SM.MainThreadExtensionService),this.D=new M.$qh,this.F=new M.$qh,this.G=new M.$qh,this.H=new M.$qh,this.I=new Ae(this.f.extensions.activationEvents),this.L=new r.$b_b(this.I,this.f.extensions.allExtensions);const Pe=new t.$Nm(this.f.extensions.myExtensions);this.J=new r.$b_b(this.I,Me(this.L,Pe)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${de(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${de(this.J)}`)),this.M=new m.$ilc(this.g,this.s),this.N=new P.$slc(this.g),this.O=X,this.h=L.createChild(new d.$pi([m.$jlc,this.M],[P.$tlc,this.N])),this.P=this.B(new v.$hlc(this.J,this.L,{onExtensionActivationError:(Ne,ze,U)=>{this.C.$onExtensionActivationError(Ne,n.$3(ze),U)},actualActivateExtension:async(Ne,ze)=>{if(r.$b_b.isHostExtension(Ne,this.J,this.L))return await this.C.$activateExtension(Ne,ze),new v.$glc;const U=this.J.getExtensionDescription(Ne);return this.fb(U,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(L){n.$1(L)}}async $(){this.O.onWillDeactivateAll();let L=[];try{L=this.J.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.eb(Ee))}catch{}await Promise.all(L)}terminate(L,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${L}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Oe=>{this.s.error(Oe)}),this.g.dispose();const be=this.$();Promise.race([(0,M.$sh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(L){return this.G.isOpen()?this.P.isActivated(L):!1}async getExtension(L){const x=await this.C.$getExtension(L);return x&&{...x,identifier:new t.$Mm(x.identifier.value),extensionLocation:E.URI.revive(x.extensionLocation)}}ab(L,x){return this.P.activateByEvent(L,x)}bb(L,x){return this.P.activateById(L,x)}activateByIdWithErrors(L,x){return this.bb(L,x).then(()=>{const be=this.P.getActivatedExtension(L);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(L=>this.J)}getExtensionExports(L){if(this.G.isOpen())return this.P.getActivatedExtension(L).exports;try{return this.P.getActivatedExtension(L).exports}catch{return null}}async cb(L){if(L.scheme===V.Schemas.file&&this.c.fsRealpath){const x=L.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const be=await this.R.get(x);return E.URI.file(be)}return L}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(L=>new ce(L))),this.Q}async db(L){const x=f.$xi.forUris(be=>F.$Vg.ignorePathCasing(be));return await Promise.all(L.map(async be=>{if(this.wb(be)){const Oe=await this.cb(be.extensionLocation);x.set(Oe,be)}})),x}eb(L){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(L))return x;const be=this.P.getActivatedExtension(L);if(!be)return x;try{typeof be.module.deactivate=="function"&&(x=Promise.resolve(be.module.deactivate()).then(void 0,Oe=>(this.s.error(Oe),Promise.resolve(void 0))))}catch(Oe){this.s.error(`An error occurred when deactivating the extension '${L.value}':`),this.s.error(Oe)}try{(0,p.$Pc)(be.subscriptions)}catch(Oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${L.value}':`),this.s.error(Oe)}return x}async fb(L,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(L.identifier):await this.C.$onWillActivateExtension(L.identifier),this.hb(L,x).then(be=>{const Oe=be.activationTimes;return this.C.$onDidActivateExtension(L.identifier,Oe.codeLoadingTime,Oe.activateCallTime,Oe.activateResolvedTime,x),this.gb(L,x,"success",Oe),be},be=>{throw this.gb(L,x,"failure"),be})}gb(L,x,be,Oe){const Ee=Ie(L,x);this.z.$publicLog2("extensionActivationTimes",{...Ee,...Oe||{},outcome:be})}hb(L,x){const be=Ie(L,x);this.z.$publicLog2("activatePlugin",be);const Oe=this.wb(L);if(!Oe)return Promise.resolve(new v.$flc(v.$clc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${L.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${L.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const Ee=new v.$dlc(x.startup);return Promise.all([this.xb(L,(0,F.$5g)(L.extensionLocation,Oe),Ee),this.ib(L)]).then(pe=>(A.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),re.jb(this.s,L.identifier,pe[0],pe[1],Ee))).then(pe=>(A.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),pe))}ib(L){const x=this.Z.createLanguageModelAccessInformation(L),be=new l.$llc(L,this.M),Oe=new l.$klc(L.identifier.value,!1,this.M),Ee=new W.$ulc(L,this.N),pe=L.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,fe=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([be.whenReady,Oe.whenReady,this.O.whenReady]).then(()=>{const X=this;let Z,le;const ue=(0,o.$zG)(L,"ipc")?this.f.messagePorts?.get(t.$Mm.toKey(L.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Oe,secrets:Ee,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(Te){return N.$kc(L.extensionLocation.fsPath,Te)},get storagePath(){return X.O.workspaceValue(L)?.fsPath},get globalStoragePath(){return X.O.globalValue(L).fsPath},get logPath(){return N.$kc(X.f.logsLocation.fsPath,L.identifier.value)},get logUri(){return E.URI.joinPath(X.f.logsLocation,L.identifier.value)},get storageUri(){return X.O.workspaceValue(L)},get globalStorageUri(){return X.O.globalValue(L)},get extensionMode(){return pe},get extension(){return Z===void 0&&(Z=new me(X,L.identifier,L,fe,!1)),Z},get extensionRuntime(){return(0,o.$AG)(L,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(L)},get messagePassingProtocol(){if(!le){if(!ue)return;const Te=w.Event.buffer(w.Event.fromDOMEventEmitter(ue,"message",he=>he.data));ue.start(),le={onDidReceiveMessage:Te,postMessage:ue.postMessage.bind(ue)}}return le}})})}static jb(L,x,be,Oe,Ee){return be=be||{activate:void 0,deactivate:void 0},this.kb(L,x,be,Oe,Ee).then(pe=>new v.$elc(!1,null,Ee.build(),be,pe,Oe.subscriptions))}static kb(L,x,be,Oe,Ee){if(typeof be.activate=="function")try{Ee.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${x.value}`);const pe=typeof global=="object"?global:self,fe=be.activate.apply(pe,[Oe]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(fe).then(X=>(Ee.activateResolveStop(),X))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(be)}lb(L,x){this.bb(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:x}).then(void 0,be=>{this.s.error(be)})}mb(L,x=0){const Oe=Date.now();(0,j.$B)(()=>{for(let Ee=x;Ee<L.length;Ee+=1){const pe=L[Ee];for(const fe of pe.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-Oe>50){this.mb(L,Ee);break}else this.lb(pe,fe)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(L=>{const x=L.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(x)this.mb(be);else for(const Oe of be)if(Oe.activationEvents)for(const Ee of Oe.activationEvents)Ee==="onStartupFinished"&&this.lb(Oe,Ee)})}ob(){const L=this.ab("*",!0).then(void 0,pe=>{this.s.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.pb(pe.added)));const x=this.j.workspace?this.j.workspace.folders:[],be=this.pb(x),Oe=this.rb(),Ee=Promise.all([Oe,L,be]).then(()=>{});return Promise.race([Ee,(0,M.$sh)(1e4)]).then(()=>{this.nb()}),Ee}pb(L){return L.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(L,x))).then(()=>{})}async qb(L,x){if(this.isActivated(x.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Oe={logService:this.s,folders:L.map(pe=>pe.uri),forceUsingSearch:be||!this.c.fsExists,exists:pe=>this.c.fsExists(pe.fsPath),checkExists:(pe,fe,X)=>this.y.$checkExists(pe,fe,X)},Ee=await(0,C.$Rtb)(Oe,x);if(Ee)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:Ee.activationEvent}).then(void 0,pe=>this.s.error(pe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(L){throw console.error(L),L}}async sb(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:x}=this.f.environment;if(!L||!x)throw new Error(I.localize(0,null));const be=await this.xb(null,x,new v.$dlc(!1));if(!be||typeof be.run!="function")throw new Error(I.localize(1,null,x.toString()));return new Promise((Oe,Ee)=>{const pe=(Z,le)=>{Z?(j.$t&&this.s.error("Test runner called back with error",Z),Ee(Z)):(j.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),Oe(typeof le=="number"&&le>0?1:0))},fe=(0,F.$Sg)(x),X=be.run(fe,pe);X&&X.then&&X.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),Oe(0)}).catch(Z=>{j.$t&&this.s.error("Test runner finished with error",Z),Ee(Z instanceof Error&&Z.stack?Z.stack:String(Z))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$sh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(L,x){return this.S[L]=x,(0,p.$Sc)(()=>{delete this.S[L]})}async getRemoteExecServer(L){const{resolver:x}=await this.ub(L);return x?.resolveExecServer?.(L,{resolveAttempt:0})}async ub(L){const x=L.indexOf("+");if(x===-1)throw new i.$1M("Not an authority that can be resolved!",$.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=L.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(L,x){const be=R.$0d.create(!1),Oe=()=>`[resolveAuthority(${(0,$.$Gl)(L)},${x})][${be.elapsed()}ms] `,Ee=z=>this.s.info(`${Oe()}${z}`),pe=z=>this.s.warn(`${Oe()}${z}`),fe=(z,G=void 0)=>this.s.error(`${Oe()}${z}`,G),X=z=>{if(z instanceof i.$1M)return{type:"error",error:{code:z._code,message:z._message,detail:z._detail}};throw z},Z=async z=>{Ee(`activating resolver for ${z}...`);const{resolver:G,authorityPrefix:H}=await this.ub(z);if(!G)throw fe(`no resolver for ${H}`),new i.$1M(`No remote extension installed to resolve ${H}.`,$.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:z}},le=L.split(/@|%40/g).reverse();Ee(`activating remote resolvers ${le.join(" -> ")}`);let ue;try{ue=await Promise.all(le.map(Z)).catch(async z=>{if(!(z instanceof i.$1M)||z._code!==$.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw z;return pe(`resolving nested authorities failed: ${z.message}`),[await Z(L)]})}catch(z){return X(z)}const Te=new M.$Ch;Te.cancelAndSet(()=>Ee("waiting..."),1e3);let he,Pe;for(const[z,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of ue.entries())try{if(z===ue.length-1)Ee("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${G}`),he=await H.resolve(ee,{resolveAttempt:x,execServer:Pe}),A.mark(`code/extHost/didResolveAuthorityOK/${G}`),Ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,i.$ZM.isManagedResolvedAuthority(he)?he:void 0));else{if(Ee(`invoking resolveExecServer() for ${ee}`),A.mark(`code/extHost/willResolveExecServer/${G}`),Pe=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Pe}),!Pe)throw new i.$1M(`Exec server was not available for ${ee}`,$.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(ne){return A.mark(`code/extHost/didResolveAuthorityError/${G}`),fe("returned an error",ne),Te.dispose(),X(ne)}Te.dispose();const Ne={environmentTunnels:he.environmentTunnels,features:he.tunnelFeatures?{elevation:he.tunnelFeatures.elevation,privacyOptions:he.tunnelFeatures.privacyOptions,protocol:he.tunnelFeatures.protocol===void 0?!0:he.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:he.extensionHostEnv,isTrusted:he.isTrusted,authenticationSession:he.authenticationSessionForInitializingExtensions?{id:he.authenticationSessionForInitializingExtensions.id,providerId:he.authenticationSessionForInitializingExtensions.providerId}:void 0};Ee(`returned ${i.$ZM.isManagedResolvedAuthority(he)?"managed authority":`${he.host}:${he.port}`}`);let U;if(i.$ZM.isManagedResolvedAuthority(he)){const z=x;this.Y.setFactory(z,he.makeConnection),U={authority:L,connectTo:new $.$Dl(z),connectionToken:he.connectionToken}}else U={authority:L,connectTo:new $.$El(he.host,he.port),connectionToken:he.connectionToken};return{type:"ok",value:{authority:U,options:ze,tunnelInformation:Ne}}}async $getCanonicalURI(L,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,$.$Gl)(L)})`);const{resolver:be}=await this.ub(L);if(!be)return null;const Oe=E.URI.revive(x);if(typeof be.getCanonicalURI>"u")return Oe;const Ee=await(0,M.$jh)(()=>be.getCanonicalURI(Oe));return Ee||Oe}async $startExtensionHost(L){L.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:be}=ve(this.I,this.L,this.J,L),Oe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${de(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${de(this.J)}`)),this.tb()}$activateByEvent(L,x){return x===1?this.D.wait().then(be=>this.ab(L,!1)):this.G.wait().then(be=>this.ab(L,!1))}async $activate(L,x){return await this.G.wait(),this.J.getExtensionDescription(L)?(await this.bb(L,x),!0):!1}async $deltaExtensions(L){L.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:be}=ve(this.I,this.L,this.J,L),Oe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${de(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${de(this.J)}`)),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){const x=c.$Ce.alloc(L),be=Math.random()%256;for(let Oe=0;Oe<L;Oe++)x.writeUInt8(be,Oe);return x}async $updateRemoteConnectionData(L){this.X=L,this.a.fire()}};e.$Alc=ae,e.$Alc=ae=re=Je([We(0,a.$qi),We(1,e.$zlc),We(2,D.$fP),We(3,s.$Xkc),We(4,u.$1kc),We(5,T.$Xj),We(6,b.$vP),We(7,h.$4kc),We(8,k.$WCb),We(9,g.$mlc),We(10,q.$wlc),We(11,K.$xlc),We(12,S.$qlc)],ae);function ve(ie,L,x,be){ie.addActivationEvents(be.addActivationEvents);const Oe=new r.$b_b(ie,L.getAllExtensionDescriptions());Oe.deltaExtensions(be.toAdd,be.toRemove);const Ee=new t.$Nm(x.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of be.myToRemove)Ee.delete(fe);for(const fe of be.myToAdd)Ee.add(fe);const pe=Me(Oe,Ee);return{globalRegistry:Oe,myExtensions:pe}}function Ie(ie,L){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}function de(ie){return ie.getAllExtensionDescriptions().map(L=>L.identifier.value).join(",")}e.$Blc=(0,a.$ri)("IExtHostExtensionService");class me{#e;#t;#i;constructor(L,x,be,Oe,Ee){this.#e=L,this.#t=x,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=N.$ic((0,F.$Sg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Oe,this.isFromDifferentExtensionHost=Ee}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Clc=me;function Me(ie,L){return ie.getAllExtensionDescriptions().filter(x=>L.has(x.identifier))}class ce{constructor(L){this.a=L}setSearchTree(L){this.a=L}findSubstr(L){return this.a.findSubstr(L)}forEach(L){return this.a.forEach(L)}}e.$Dlc=ce;class Ae{constructor(L){this.a=new t.$Om,this.addActivationEvents(L)}readActivationEvents(L){return this.a.get(L.identifier)??[]}addActivationEvents(L){for(const x of Object.keys(L))this.a.set(x,L[x])}}}),define(Ce[293],Re([1,0,89,2,4,38,26,20,16,27,3,39,13,15]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;let s=class{constructor(c,l,i,$,a,b,h){this.c=c,this.d=l,this.e=i,this.f=$,this.g=a,this.h=b,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new r(this.c,l,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,l,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const l of c.nodeModuleName)this.a.set(l,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(l=>c.alternativeModuleName(l))}};e.$Mmc=s,e.$Mmc=s=Je([We(2,T.$qi),We(3,F.$1kc),We(4,y.$Blc),We(5,E.$vP),We(6,u.$Xj)],s);let o=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&m.a.size){const l=(0,v.$9e)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",$=`@${i}+\\/${i}+|${i}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${a}\\/)(${$})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const l=this.b.exec(this.c(c));if(!l)return;const[,i,$,a]=l,b=m.a.get($);if(b!==void 0)return console.warn(`${$} as been renamed to ${b}, please update your imports`),i+b+a}c(c){return c.replace(/\\/g,"/")}};o=m=Je([We(0,E.$vP)],o);class r{constructor(c,l,i,$,a){this.c=c,this.d=l,this.e=i,this.f=$,this.g=a,this.nodeModuleName="vscode",this.a=new p.$Om}load(c,l){const i=this.d.findSubstr(l);if(i){let $=this.a.get(i.identifier);return $||($=this.c(i,this.e,this.f),this.a.set(i.identifier,$)),$}if(!this.b){let $="";this.d.forEach((a,b)=>$+=`	${b} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${$}`),this.b=this.c(M.$uG,this.e,this.f)}return this.b}}let n=class{constructor(c,l,i){this.e=c,this.f=l,this.nodeModuleName=["open","opn"],this.d=i.getProxy(A.$SM.MainThreadTelemetry);const $=i.getProxy(A.$SM.MainThreadWindow);this.c=(a,b)=>{const h=N.URI.parse(a);return b?this.g(a,b):h.scheme==="http"||h.scheme==="https"?$.$openUri(h,a,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?$.$openUri(h,a,{}):this.g(a,b)}}load(c,l,i){const $=this.e.findSubstr(l);return $&&(this.a=$.identifier.value,this.h()),this.b=i(c),this.c}g(c,l){return this.i(),this.b(c,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([We(2,f.$fP)],n)}),define(Ce[120],Re([1,0,41,6,19,73,3,67,66,39,7,37,223,38]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=e.$Elc=void 0,e.$Elc=(0,M.$ri)("IExtHostVariableResolverProvider");class m extends u.$hQ{constructor(r,n,t,c,l,i,$){function a(){if(t){const b=t.activeEditor();if(b)return b.document.uri;const h=c.tabGroups.all.find(D=>D.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof T.$FO||h.input instanceof T.$KO)return h.input.modified;if(h.input instanceof T.$EO||h.input instanceof T.$JO||h.input instanceof T.$HO)return h.input.uri}}}super({getFolderUri:b=>{const h=i.folders.filter(D=>D.name===b);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(b,h)=>l.getConfiguration(void 0,b).get(h),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const b=a();if(b)return A.$ic(b.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const b=a();if(b){const h=n.getWorkspaceFolder(b);if(h)return A.$ic(h.uri.fsPath)}}},getSelectedText:()=>{if(t){const b=t.activeEditor();if(b&&!b.selection.isEmpty)return b.document.getText(b.selection)}},getLineNumber:()=>{if(t){const b=t.activeEditor();if(b)return String(b.selection.end.line+1)}},getExtension:b=>r.getExtension(b)},void 0,$?Promise.resolve($):void 0,Promise.resolve(F.env))}}let s=class extends N.$Uc{constructor(r,n,t,c,l){super(),this.b=r,this.c=n,this.g=t,this.h=c,this.j=l,this.a=new I.$V(async()=>{const i=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async b=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,i,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$Flc=s,e.$Flc=s=Je([We(0,E.$Blc),We(1,y.$Xkc),We(2,p.$qP),We(3,v.$1kc),We(4,f.$alc)],s)}),define(Ce[121],Re([1,0,11,5,2,20,3,4,66,39,16,7,37,215,217,38,120,6,42,32,8]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=e.$Jlc=e.$Ilc=e.$Hlc=e.$Glc=void 0,e.$Glc=(0,M.$ri)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(d,k,g,S,w,C,P){this.N=k,this.O=g,this.P=S,this.Q=w,this.R=C,this.S=P,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$be,this.o=new N.$be,this.q=new N.$be,this.w=new N.$be,this.l=d.getProxy(p.$SM.MainThreadDebugService),this.A=new N.$be,this.C=new N.$be,this.y=new $(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(V=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(d,k){const g=this.W(k);if(!g)return;const S=await this.H.get(d)?.getTreeItem?.(g);return S?this.U(d,S):void 0}registerDebugVisualizationTree(d,k,g){const S=F.$Mm.toKey(d.identifier),w=this.jb(S,k);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${k}' is already registered`);return this.H.set(w,g),this.l.$registerDebugVisualizerTree(w,!!g.editItem),(0,r.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(w),this.H.delete(k)})}async $getVisualizerTreeItemChildren(d,k){const g=this.J.get(k)?.item;return g?(await this.H.get(d)?.getChildren?.(g))?.map(w=>this.U(d,w))||[]:[]}async $editVisualizerTreeItem(d,k){const g=this.J.get(d);if(!g)return;const S=await this.H.get(g.provider)?.editItem?.(g.item,k);return this.U(g.provider,S||g.item)}$disposeVisualizedTree(d){const k=this.J.get(d);if(!k)return;const g=[k.children];for(const S of g)if(S)for(const w of S)g.push(this.J.get(w)?.children),this.J.delete(w)}U(d,k){let g=this.I.get(k);return g||(g=this.F++,this.I.set(k,g),this.J.set(g,{provider:d,item:k})),c.DebugTreeItem.from(k,g)}asDebugSourceUri(d,k){const g=d;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let S=`debug:${encodeURIComponent(g.path||"")}`,w="?";return k&&(S+=`${w}session=${encodeURIComponent(k.id)}`,w="&"),S+=`${w}ref=${g.sourceReference}`,A.URI.parse(S)}else{if(g.path)return A.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(d){const k=[];for(const g of d.getAllExtensionDescriptions())if(g.contributes){const S=g.contributes.debuggers;if(S&&S.length>0)for(const w of S)(0,m.$cH)(w)&&k.push(w.type)}this.l.$registerDebugTypes(k)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const d=[];return this.z.forEach(k=>d.push(k)),d}async $resolveDebugVisualizer(d,k){const g=this.L.get(d);if(!g)throw new Error(`No debug visualizer found with id '${d}'`);let{v:S,provider:w,extensionId:C}=g;if(S.visualization||(S=await w.resolveDebugVisualization?.(S,k)||S,g.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${w}'`);return this.kb(C,S.visualization)}async $executeDebugVisualizerCommand(d){const k=this.L.get(d);if(!k)throw new Error(`No debug visualizer found with id '${d}'`);const g=k.v.visualization;g&&"command"in g&&this.S.executeCommand(g.command,...g.arguments||[])}W(d){const k=this.m.get(d.sessionId);return k&&{session:k.api,variable:d.variable,containerId:d.containerId,frameId:d.frameId,threadId:d.threadId}}async $provideDebugVisualizers(d,k,g,S){const w=this.W(g),C=this.jb(d,k),P=this.G.get(C);if(!w||!P)return[];const W=await P.provideDebugVisualization(w,S);return W?W.map(V=>{const q=++this.M;this.L.set(q,{v:V,provider:P,extensionId:d});const R=V.iconPath?this.lb(V.iconPath):void 0;return{id:q,name:V.name,iconClass:R?.iconClass,iconPath:R?.iconPath,visualization:this.kb(d,V.visualization)}}):[]}$disposeDebugVisualizers(d){for(const k of d)this.L.delete(k)}registerDebugVisualizationProvider(d,k,g){if(!d.contributes?.debugVisualizers?.some(C=>C.id===k))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${k})`);const S=F.$Mm.toKey(d.identifier),w=this.jb(S,k);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${k}' is already registered`);return this.G.set(w,g),this.l.$registerDebugVisualizer(S,k),(0,r.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,k),this.G.delete(k)})}addBreakpoints(d){const k=d.filter(w=>{const C=w.id;return this.z.has(C)?!1:(this.z.set(C,w),!0)});this.gb(k,[],[]);const g=[],S=new Map;for(const w of k)if(w instanceof y.$VN){let C=S.get(w.location.uri.toString());C||(C={type:"sourceMulti",uri:w.location.uri,lines:[]},S.set(w.location.uri.toString(),C),g.push(C)),C.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character,mode:w.mode})}else w instanceof y.$WN&&g.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName,mode:w.mode});return this.l.$registerBreakpoints(g)}removeBreakpoints(d){const k=d.filter(C=>this.z.delete(C.id));this.gb([],k,[]);const g=k.filter(C=>C instanceof y.$VN).map(C=>C.id),S=k.filter(C=>C instanceof y.$WN).map(C=>C.id),w=k.filter(C=>C instanceof y.$XN).map(C=>C.id);return this.l.$unregisterBreakpoints(g,S,w)}startDebugging(d,k,g){return this.l.$startDebugging(d?d.uri:void 0,k,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(d){return this.l.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,k,g){if(!k)return new y.$UM(()=>{});const S=this.d++;return this.f.push({type:d,handle:S,provider:k}),this.l.$registerDebugConfigurationProvider(d,g,!!k.provideDebugConfigurations,!!k.resolveDebugConfiguration,!!k.resolveDebugConfigurationWithSubstitutedVariables,S),new y.$UM(()=>{this.f=this.f.filter(w=>w.provider!==k),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(d,k,g){if(!g)return new y.$UM(()=>{});if(!this.cb(d,k))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${k}' debugger.`);if(this.$(k))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:k,handle:S,factory:g}),this.l.$registerDebugAdapterDescriptorFactory(k,S),new y.$UM(()=>{this.h=this.h.filter(w=>w.factory!==g),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(d,k){if(!k)return new y.$UM(()=>{});const g=this.j++;return this.k.push({type:d,handle:g,factory:k}),new y.$UM(()=>{this.k=this.k.filter(S=>S.factory!==k)})}async $runInTerminal(d,k){return Promise.resolve(void 0)}async $substituteVariables(d,k){let g;const S=await this.ib(d);return S&&(g={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(g,k)}X(d,k){if(d.type==="implementation")return new b(d.implementation)}Y(){}async $startDASession(d,k){const g=this,S=await this.hb(k);return this.eb(this.$(S.type),S).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const C=this.Z(w),P=this.X(C,S);if(!P)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const W=P;return this.D.set(d,W),this.db(S).then(V=>(V&&this.E.set(d,V),W.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const R=q,j={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(R.arguments.value);j.body={signature:K},W.sendResponse(j)}else throw new Error("no signer")}catch(K){j.success=!1,j.message=K.message,W.sendResponse(j)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(q),q=(0,m.$hH)(q,!0),g.l.$acceptDAMessage(d,q)}),W.onError(q=>{V&&V.onError&&V.onError(q),this.l.$acceptDAError(d,q.name,q.message,q.stack)}),W.onExit(q=>{V&&V.onExit&&V.onExit(q??void 0,void 0),this.l.$acceptDAExit(d,q??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),W.startSession()))})}$sendDAMessage(d,k){k=(0,m.$gH)(k,!1);const g=this.E.get(d);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(k),this.D.get(d)?.sendMessage(k)}$stopDASession(d){const k=this.E.get(d);this.E.delete(d),k&&k.onWillStopSession&&k.onWillStopSession();const g=this.D.get(d);return this.D.delete(d),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const k=[],g=[],S=[];if(d.added)for(const w of d.added){const C=w.id;if(C&&!this.z.has(C)){let P;if(w.type==="function")P=new y.$WN(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode);else if(w.type==="data")P=new y.$XN(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage,w.mode);else{const W=A.URI.revive(w.uri);P=new y.$VN(new y.$7M(W,new y.$VM(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode)}(0,y.$TN)(P,C),this.z.set(C,P),k.push(P)}}if(d.removed)for(const w of d.removed){const C=this.z.get(w);C&&(this.z.delete(w),g.push(C))}if(d.changed){for(const w of d.changed)if(w.id){const C=this.z.get(w.id);if(C){if(C instanceof y.$WN&&w.type==="function"){const P=C;P.enabled=w.enabled,P.condition=w.condition,P.hitCondition=w.hitCondition,P.logMessage=w.logMessage,P.functionName=w.functionName}else if(C instanceof y.$VN&&w.type==="source"){const P=C;P.enabled=w.enabled,P.condition=w.condition,P.hitCondition=w.hitCondition,P.logMessage=w.logMessage,P.location=new y.$7M(A.URI.revive(w.uri),new y.$VM(w.line,w.character))}S.push(C)}}}this.gb(k,g,S)}async $acceptStackFrameFocus(d){let k;if(d){const g=await this.hb(d.sessionId);d.kind==="thread"?k=new y.$4N(g.api,d.threadId):k=new y.$3N(g.api,d.threadId,d.frameId)}this.B=k,this.C.fire(this.B)}$provideDebugConfigurations(d,k,g){return(0,I.$jh)(async()=>{const S=this.bb(d);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.ib(k);return S.provideDebugConfigurations(w,g)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(d,k,g,S){return(0,I.$jh)(async()=>{const w=this.bb(d);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(k);return w.resolveDebugConfiguration(C,g,S)})}$resolveDebugConfigurationWithSubstitutedVariables(d,k,g,S){return(0,I.$jh)(async()=>{const w=this.bb(d);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(k);return w.resolveDebugConfigurationWithSubstitutedVariables(C,g,S)})}async $provideDebugAdapter(d,k){const g=this.ab(d);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(k);return this.eb(g,S).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(w)})}async $acceptDebugSessionStarted(d){const k=await this.hb(d);this.n.fire(k.api)}async $acceptDebugSessionTerminated(d){const k=await this.hb(d);k&&(this.o.fire(k.api),this.m.delete(k.id))}async $acceptDebugSessionActiveChanged(d){this.u=d?await this.hb(d):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(d,k){(await this.hb(d))?._acceptNameChanged(k)}async $acceptDebugSessionCustomEvent(d,k){const S={session:(await this.hb(d)).api,event:k.event,body:k.body};this.w.fire(S)}Z(d){if(d instanceof y.$YN)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof y.$ZN)return{type:"server",port:d.port,host:d.host};if(d instanceof y.$1N)return{type:"pipeServer",path:d.path};if(d instanceof y.$2N)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}$(d){const k=this.h.filter(g=>g.type===d);if(k.length>0)return k[0].factory}ab(d){const k=this.h.filter(g=>g.handle===d);if(k.length>0)return k[0].factory}bb(d){const k=this.f.filter(g=>g.handle===d);if(k.length>0)return k[0].provider}cb(d,k){if(d.contributes){const g=d.contributes.debuggers;if(g&&g.length>0){for(const S of g)if(S.label&&S.type&&S.type===k)return!0}}return!1}db(d){const g=d.configuration.type,S=this.k.filter(w=>w.type===g||w.type==="*").map(w=>(0,I.$jh)(()=>w.factory.createDebugAdapterTracker(d.api)).then(C=>C,C=>null));return Promise.race([Promise.all(S).then(w=>{const C=w.filter(P=>!!P);if(C.length>0)return new a(C)}),new Promise(w=>setTimeout(()=>w(void 0),1e3))]).catch(w=>{})}async eb(d,k){const g=k.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new y.$ZN(g));if(d){const w=await this.O.getExtensionRegistry();return(0,I.$jh)(()=>d.createDebugAdapterDescriptor(k.api,this.fb(k,w))).then(C=>{if(C)return C})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(k,S))}fb(d,k){}gb(d,k,g){(d.length>0||k.length>0||g.length>0)&&this.A.fire(Object.freeze({added:d,removed:k,changed:g}))}async hb(d){if(d)if(typeof d=="string"){const k=this.m.get(d);if(k)return k}else{let k=this.m.get(d.id);if(!k){const g=await this.ib(d.folderUri),S=d.parent?this.m.get(d.parent):void 0;k=new i(this.l,d.id,d.type,d.name,g,d.configuration,S?.api),this.m.set(k.id,k),this.l.$sessionCached(k.id)}return k}throw new Error("cannot find session")}ib(d){if(d){const k=A.URI.revive(d);return this.N.resolveWorkspaceFolder(k)}return Promise.resolve(void 0)}jb(d,k){return`${d}\0${k}`}kb(d,k){if(k){if("title"in k&&"command"in k)return{type:0};if("treeId"in k)return{type:1,id:`${d}\0${k.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(d){const k=this.mb(d);let g,S;return"id"in k?S=n.ThemeIcon.asClassName(k):g=k,{iconPath:g,iconClass:S}}mb(d){if(d instanceof y.$QN)return{id:d.id};const k=typeof d=="object"&&"dark"in d?d.dark:d,g=typeof d=="object"&&"light"in d?d.light:d;return{dark:typeof k=="string"?A.URI.file(k):k,light:typeof g=="string"?A.URI.file(g):g}}};e.$Hlc=l,e.$Hlc=l=Je([We(0,T.$fP),We(1,u.$Xkc),We(2,E.$Blc),We(3,s.$1kc),We(4,f.$alc),We(5,o.$Elc),We(6,t.$BP)],l);class i{constructor(d,k,g,S,w,C,P){this.f=d,this.g=k,this.h=g,this.j=S,this.k=w,this.l=C,this.m=P}get api(){const d=this;return this.d??=Object.freeze({id:d.g,type:d.h,get name(){return d.j},set name(k){d.j=k,d.f.$setDebugSessionName(d.g,k)},parentSession:d.m,workspaceFolder:d.k,configuration:d.l,customRequest(k,g){return d.f.$customDebugAdapterRequest(d.g,k,g)},getDebugProtocolBreakpoint(k){return d.f.$getDebugProtocolBreakpoint(d.g,k.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(d){this.j=d}get configuration(){return this.l}}e.$Ilc=i;class ${constructor(d){this.value=Object.freeze({append(k){d.$appendDebugConsole(k)},appendLine(k){this.append(k+`
`)}})}}e.$Jlc=$;class a{constructor(d){this.d=d}onWillStartSession(){this.d.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.d.forEach(k=>k.onWillReceiveMessage?k.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.d.forEach(k=>k.onDidSendMessage?k.onDidSendMessage(d):void 0)}onWillStopSession(){this.d.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.d.forEach(k=>k.onError?k.onError(d):void 0)}onExit(d,k){this.d.forEach(g=>g.onExit?g.onExit(d,k):void 0)}}class b extends v.$Xob{constructor(d){super(),this.h=d,d.onDidSendMessage(k=>{this.acceptMessage(k)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.h.handleMessage(d)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends l{constructor(d,k,g,S,w,C,P){super(d,k,g,S,w,C,P)}};e.$Klc=h,e.$Klc=h=Je([We(0,T.$fP),We(1,u.$Xkc),We(2,E.$Blc),We(3,s.$1kc),We(4,f.$alc),We(5,o.$Elc),We(6,t.$BP)],h)}),define(Ce[294],Re([1,0,14,89,2,4,243,13,55,71,27,191,16,60,39,62]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=e.$Nmc=void 0;class o{static async installEarlyHandler(t){Error.stackTraceLimit=100;const c=t.get(p.$Xj),i=t.get(u.$fP).getProxy(F.$SM.MainThreadErrors);I.setUnexpectedErrorHandler($=>{c.error($);const a=I.$3($);i.$onUnexpectedError(a)})}static async installFullHandler(t){const c=t.get(p.$Xj),l=t.get(u.$fP),i=t.get(m.$Blc),$=t.get(s.$zP),a=l.getProxy(F.$SM.MainThreadExtensionService),b=l.getProxy(F.$SM.MainThreadErrors),h=await i.getExtensionPathIndex(),D=new WeakMap;function d(S,w){if(D.has(S))return D.get(S).stack;let C="",P,W;for(const q of w)C+=`
	at ${q.toString()}`,W=q.getFileName(),!P&&W&&(P=h.findSubstr(A.URI.file(W)));const V=`${S.name||"Error"}: ${S.message||""}${C}`;return D.set(S,{extensionIdentifier:P?.identifier,stack:V}),V}const k=Symbol("prepareStackTrace wrapped");let g=d;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(S){if(S===d||!S||S[k]){g=S||d;return}g=function(w,C){return d(w,C),S.call(Error,w,C)},Object.assign(g,{[k]:!0})}}),I.setUnexpectedErrorHandler(S=>{c.error(S);const w=I.$3(S),C=D.get(S);if(!C?.extensionIdentifier){b.$onUnexpectedError(w);return}a.$onExtensionRuntimeError(C.extensionIdentifier,w);const P=$.onExtensionError(C.extensionIdentifier,S);c.trace("forwarded error to extension?",P,C)})}}e.$Nmc=o;class r{constructor(t,c,l,i,$){this.a=l,this.b=new M.$j_b(t,null,i),c=r.e(c,this.b);const a=new E.$pi(...(0,f.$ss)());a.set(T.$vP,{_serviceBrand:void 0,...c,messagePorts:$}),a.set(u.$fP,new u.$gP(this.b)),a.set(v.$Ukc,new v.$Vkc(i)),a.set(m.$zlc,l);const b=new y.$0q(a,!0);b.invokeFunction(o.installEarlyHandler),this.d=b.invokeFunction(h=>h.get(p.$Xj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=b.invokeFunction(h=>h.get(m.$Blc)),this.c.initialize(),b.invokeFunction(o.installFullHandler)}async asBrowserUri(t){const c=this.b.getProxy(F.$SM.MainThreadExtensionService);return A.URI.revive(await c.$asBrowserUri(t))}terminate(t){this.c.terminate(t)}static e(t,c){t.extensions.allExtensions.forEach(i=>{i.extensionLocation=A.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),t.environment.appRoot=A.URI.revive(c.transformIncomingURIs(t.environment.appRoot));const l=t.environment.extensionDevelopmentLocationURI;return l&&(t.environment.extensionDevelopmentLocationURI=l.map(i=>A.URI.revive(c.transformIncomingURIs(i)))),t.environment.extensionTestsLocationURI=A.URI.revive(c.transformIncomingURIs(t.environment.extensionTestsLocationURI)),t.environment.globalStorageHome=A.URI.revive(c.transformIncomingURIs(t.environment.globalStorageHome)),t.environment.workspaceStorageHome=A.URI.revive(c.transformIncomingURIs(t.environment.workspaceStorageHome)),t.environment.extensionTelemetryLogResource=A.URI.revive(c.transformIncomingURIs(t.environment.extensionTelemetryLogResource)),t.nlsBaseUrl=A.URI.revive(c.transformIncomingURIs(t.nlsBaseUrl)),t.logsLocation=A.URI.revive(c.transformIncomingURIs(t.logsLocation)),t.workspace=c.transformIncomingURIs(t.workspace),t}}e.$Omc=r}),define(Ce[295],Re([1,0,18,11,24,43,12,19,23,2,46]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$Zlc=e.$Ylc=void 0,e.$1lc=s;class y{constructor(n,t,c){this.d=n,this.e=t,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,t){const c=this.g.folderQueries||[],l=new A.$me(t);return new Promise((i,$)=>{this.a=new v(n);let a=!1;const b=(h,D)=>{if(!a&&!this.b){const d=this.h(h);s(h)&&typeof this.g.maxResults=="number"&&this.c+d>this.g.maxResults&&(this.b=!0,a=!0,l.cancel(),h=this.j(h,this.g.maxResults-this.c));const k=this.h(h);this.c+=k,(k>0||!s(h))&&this.a.add(h,D)}};Promise.all(c.map((h,D)=>this.k(h,d=>b(d,D),l.token))).then(h=>{l.dispose(),this.a.flush();const D=h.some(d=>!!d&&!!d.limitHit);i({limitHit:this.b||D,messages:(0,I.$Rb)(h.map(d=>d?.message?Array.isArray(d.message)?d.message:[d.message]:[])),stats:{type:this.f}})},h=>{l.dispose();const D=(0,F.$cj)(h);$(new Error(D))})})}h(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,t){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],l=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,t),preview:{matches:l.slice(0,t),text:n.preview.text},uri:n.uri}}async k(n,t,c){const l=new T.$nL(this.g,n),i=[],$={report:h=>{if(!this.l(h))return;const D=n.folder.scheme===M.Schemas.file?(0,T.$oL)(()=>this.e.readdir(f.$4g(h.uri))):void 0,d=f.$7g(n.folder,h.uri);if(d){const k=l.includedInQuery(d,p.$oc(d),D);(0,N.$dh)(k)?i.push(k.then(g=>{g&&t(h)})):k&&t(h)}}},a=this.n(n);let b;return this.d.query.type===3?b=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,$,c):b=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),a,$,c),i.length&&await Promise.all(i),b}l(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const t=(0,T.$mL)(this.g.includePattern,n.includePattern),c=(0,T.$mL)(this.g.excludePattern,n.excludePattern),l={folder:E.URI.from(n.folder),excludes:c,includes:t,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(l.usePCRE2=this.g.usePCRE2),l}}e.$Ylc=y;function u(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class v{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,t=>this.g(t))}add(n,t){this.d&&(this.b!==t||!f.$Xg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=t,this.d={resource:n.uri,results:[]}),this.d.results.push(m(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Zlc=v;function m(r){return s(r)?{preview:{matches:(0,I.$2b)(r.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:r.preview.text},ranges:(0,I.$2b)(r.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function s(r){return!!r.preview}class o{static{this.a=4e3}static{this.b=50}constructor(n,t){this.g=n,this.h=t,this.c=0,this.d=[],this.e=0}addItem(n,t){n&&this.j(n,t)}addItems(n,t){n&&this.k(n,t)}j(n,t){this.d.push(n),this.e+=t,this.l()}k(n,t){this.d=this.d.concat(n),this.e+=t,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$2lc=o}),define(Ce[122],Re([1,0,6,4,3,290,16,60,13,2,295]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0,e.$5lc=u,e.$3lc=(0,A.$ri)("IExtHostSearch");let y=class{constructor(s,o,r){this.n=s,this.o=o,this.q=r,this.c=this.n.getProxy(N.$SM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new F.$Xlc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const r=this.d++;return this.e.set(r,o),this.c.$registerTextSearchProvider(r,this.s(s)),(0,I.$Sc)(()=>{this.g.delete(s),this.e.delete(r),this.c.$unregisterProvider(r)})}registerAITextSearchProvider(s,o){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const r=this.d++;return this.h.set(r,o),this.c.$registerAITextSearchProvider(r,this.s(s)),(0,I.$Sc)(()=>{this.i.delete(s),this.h.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(s,o){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const r=this.d++;return this.j.set(r,o),this.c.$registerFileSearchProvider(r,this.s(s)),(0,I.$Sc)(()=>{this.k.delete(s),this.j.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(s,o,r,n){const t=u(r),c=this.j.get(s);if(c)return this.l.fileSearch(t,c,l=>{this.c.$handleFileMatch(s,o,l.map(i=>i.resource))},n);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,o,r){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,r,n){const t=this.e.get(s);if(!t||!t.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const c=u(r);return this.t(c,t).search(i=>this.c.$handleTextMatch(s,o,i),n)}$provideAITextSearchResults(s,o,r,n){const t=this.h.get(s);if(!t||!t.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const c=u(r);return this.v(c,t).search(i=>this.c.$handleTextMatch(s,o,i),n)}$enableExtensionHostSearch(){}t(s,o){return new T.$Ylc({query:s,provider:o},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}v(s,o){return new T.$Ylc({query:s,provider:o},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"aiTextSearchProvider")}};e.$4lc=y,e.$4lc=y=Je([We(0,M.$fP),We(1,p.$Ukc),We(2,f.$Xj)],y);function u(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(v),extraFileResources:m.extraFileResources&&m.extraFileResources.map(s=>E.URI.revive(s))}}function v(m){return{...m,folder:E.URI.revive(m.folder)}}}),define(Ce[296],Re([1,0,24,14,5,6,12,33,2,151,147,135,94,20,44,13,58,59,204,4,246,274,78,84,251,252,253,232,221,32,254,38,255,121,110,256,234,247,257,258,67,66,248,39,260,64,261,45,27,275,276,235,262,88,263,79,80,237,289,265,208,266,277,267,116,238,268,269,270,16,271,122,81,272,239,273,82,85,119,62,51,114,278,279,249,280,281,86,8,7,240,60,241,63,282,283,109,37,216,77,26,118]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t,c,l,i,$,a,b,h,D,d,k,g,S,w,C,P,W,V,q,R,j,K,re,ae,ve,Ie,de,me,Me,ce,Ae,ie,L,x,be,Oe,Ee,pe,fe,X,Z,le,ue,Te,he,Pe,Ne,ze,U,z,G,H,ee,ne,Fe,Be,Xe,_e,et,tt,it,nt,at,mt,je,st,Y,Q,$e,He,ye,ot,dt,It,Xt,Ut,xt,_t,Pt,Wt,Qt,Ye,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=Yt;function Yt(lt){const vt=lt.get(ce.$vP),ti=lt.get(Me.$Fkc),Zt=lt.get(de.$3kc),Lt=lt.get(ve.$Blc),ft=lt.get(Pt.$Xkc),jt=lt.get(it.$zP),Bt=lt.get(S.$1kc),qt=lt.get(dt.$Ukc),Ge=lt.get(G.$fP),ui=lt.get(_e.$jlc),Ht=lt.get(et.$4kc),zt=lt.get(s.$Yj),gt=lt.get(s.$Xj),Tt=lt.get($e.$WCb),Rt=lt.get(i.$Bkc),Ft=lt.get(_t.$Hmc),ii=lt.get(ne.$tlc),Gt=lt.get(re.$alc),ni=lt.get(pe.$xlc),Nt=lt.get($.$Lkc),At=lt.get(be.$qlc);Ge.set(t.$TM.ExtHostFileSystemInfo,ti),Ge.set(t.$TM.ExtHostLogLevelServiceShape,zt),Ge.set(t.$TM.ExtHostWorkspace,ft),Ge.set(t.$TM.ExtHostConfiguration,Bt),Ge.set(t.$TM.ExtHostExtensionService,Lt),Ge.set(t.$TM.ExtHostStorage,ui),Ge.set(t.$TM.ExtHostTunnelService,Tt),Ge.set(t.$TM.ExtHostWindow,Ft),Ge.set(t.$TM.ExtHostSecretState,ii),Ge.set(t.$TM.ExtHostTelemetry,jt),Ge.set(t.$TM.ExtHostEditorTabs,Gt),Ge.set(t.$TM.ExtHostManagedSockets,ni),Ge.set(t.$TM.ExtHostAuthentication,Nt),Ge.set(t.$TM.ExtHostChatProvider,At);const Ct=Ge.set(t.$TM.ExtHostDecorations,lt.get(P.$Mlc)),Dt=Ge.set(t.$TM.ExtHostDocumentsAndEditors,lt.get(K.$qP)),pt=Ge.set(t.$TM.ExtHostCommands,lt.get(k.$BP)),St=Ge.set(t.$TM.ExtHostTerminalService,lt.get(nt.$mlc)),li=Ge.set(t.$TM.ExtHostTerminalShellIntegration,lt.get(at.$tmc)),kt=Ge.set(t.$TM.ExtHostDebugService,lt.get(C.$Glc)),hi=Ge.set(t.$TM.ExtHostSearch,lt.get(ee.$3lc)),Kt=Ge.set(t.$TM.ExtHostTask,lt.get(tt.$smc)),vi=Ge.set(t.$TM.ExtHostOutputService,lt.get(Pe.$fmc)),ei=Ge.set(t.$TM.ExtHostLocalization,lt.get(Ee.$wlc)),wi=Ge.set(t.$TM.ExtHostUrls,new It.$Emc(Ge)),yt=Ge.set(t.$TM.ExtHostDocuments,new j.$Ikc(Ge,Dt)),$i=Ge.set(t.$TM.ExtHostDocumentContentProviders,new q.$Olc(Ge,Dt,gt)),we=Ge.set(t.$TM.ExtHostDocumentSaveParticipant,new R.$Plc(gt,yt,Ge.getProxy(t.$SM.MainThreadBulkEdits))),Se=Ge.set(t.$TM.ExtHostNotebook,new X.$6lc(Ge,pt,Dt,yt,Zt,hi)),oe=Ge.set(t.$TM.ExtHostNotebookDocuments,new le.$_lc(Se)),J=Ge.set(t.$TM.ExtHostNotebookEditors,new ue.$amc(gt,Se)),ke=Ge.set(t.$TM.ExtHostNotebookKernels,new Te.$bmc(Ge,vt,Se,pt,gt)),Ve=Ge.set(t.$TM.ExtHostNotebookRenderers,new he.$dmc(Ge,Se)),Qe=Ge.set(t.$TM.ExtHostNotebookDocumentSaveParticipant,new Z.$$lc(gt,Se,Ge.getProxy(t.$SM.MainThreadBulkEdits))),qe=Ge.set(t.$TM.ExtHostEditors,new je.$Rkc(Ge,Dt)),ut=Ge.set(t.$TM.ExtHostTreeViews,new Q.$Cmc(Ge.getProxy(t.$SM.MainThreadTreeViews),pt,gt)),Et=Ge.set(t.$TM.ExtHostEditorInsets,new d.$Skc(Ge.getProxy(t.$SM.MainThreadEditorInsets),qe,vt.remote)),Ot=Ge.set(t.$TM.ExtHostDiagnostics,new W.$Hkc(Ge,gt,ti,Dt)),Vt=Ge.set(t.$TM.ExtHostLanguages,new Oe.$9lc(Ge,yt,pt.converter,qt)),ct=Ge.set(t.$TM.ExtHostLanguageFeatures,new x.$Jkc(Ge,qt,yt,pt,Ot,gt,Rt,jt)),ri=Ge.set(t.$TM.ExtHostFileSystem,new Ie.$Rlc(Ge,ct)),di=Ge.set(t.$TM.ExtHostFileSystemEventService,new me.$Slc(Ge,gt,Dt)),pi=Ge.set(t.$TM.ExtHostQuickOpen,(0,z.$jmc)(Ge,ft,pt)),Si=Ge.set(t.$TM.ExtHostSCM,new H.$lmc(Ge,pt,yt,gt)),Ri=Ge.set(t.$TM.ExtHostQuickDiff,new U.$imc(Ge,qt)),Mi=Ge.set(t.$TM.ExtHostShare,new Fe.$mmc(Ge,qt)),Ni=Ge.set(t.$TM.ExtHostComments,(0,g.$Tkc)(Ge,pt,yt)),Ti=Ge.set(t.$TM.ExtHostProgress,new ze.$hmc(Ge.getProxy(t.$SM.MainThreadProgress))),cn=Ge.set(t.$TM.ExtHostLabelService,new L.$8lc(Ge)),Fi=Ge.set(t.$TM.ExtHostTheming,new st.$zmc(Ge)),Oi=Ge.set(t.$TM.ExtHostTimeline,new Y.$Bmc(Ge,pt)),yi=Ge.set(t.$TM.ExtHostWebviews,new Xt.$8kc(Ge,vt.remote,ft,gt,Rt)),Ii=Ge.set(t.$TM.ExtHostWebviewPanels,new Ut.$$kc(Ge,yi,ft)),Gi=Ge.set(t.$TM.ExtHostCustomEditors,new w.$_kc(Ge,yt,Ht,yi,Ii)),Ki=Ge.set(t.$TM.ExtHostWebviewViews,new xt.$Fmc(Ge,yi)),bi=Ge.set(t.$TM.ExtHostTesting,new mt.$vmc(Ge,gt,pt,Dt)),Ji=Ge.set(t.$TM.ExtHostUriOpeners,new ot.$Dmc(Ge)),Xi=Ge.set(t.$TM.ExtHostProfileContentHandlers,new Ne.$gmc(Ge));Ge.set(t.$TM.ExtHostInteractive,new ie.$7lc(Ge,Se,Dt,pt,gt));const un=Ge.set(t.$TM.ExtHostInlineChat,new Ae.$Tlc(Ge,pt,yt,gt)),Li=Ge.set(t.$TM.ExtHostChatAgents2,new b.$Okc(Ge,gt,pt)),zi=Ge.set(t.$TM.ExtHostChatVariables,new h.$Pkc(Ge)),Pi=Ge.set(t.$TM.ExtHostAiRelatedInformation,new c.$Akc(Ge)),ln=Ge.set(t.$TM.ExtHostAiEmbeddingVector,new ae.$Qlc(Ge)),Qi=Ge.set(t.$TM.ExtHostStatusBar,new Xe.$pmc(Ge,pt.converter)),Yi=Ge.set(t.$TM.ExtHostSpeech,new Be.$nmc(Ge)),hn=Object.values(t.$TM);Ge.assertRegistered(hn);const Ui=new a.$Nkc(Ge,Dt),Zi=new D.$Qkc(Ge),Ci=new fe.$0lc(Ge,gt),ji=new V.$Nlc(Ge);return l.$Kkc.register(pt),function(Ue,oi,Bi){function xe(_){return(se,Le,rt)=>{const wt=_(Mt=>{try{se.call(Le,Mt)}catch(ki){N.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${ki.toString()}`,{cause:ki})),jt.onExtensionError(Ue.identifier,ki)}});return rt?.push(wt),wt}}const bt=function(){let _=!Ue.isUnderDevelopment;function se(){_||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")se();else{const wt=rt;typeof wt.scheme>"u"&&se(),typeof wt.exclusive=="boolean"&&(0,Ye.$AG)(Ue,"documentFiltersExclusive")}return rt}}(),dn={getSession(_,se,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ye.$AG)(Ue,"authLearnMore"),Nt.getSession(Ue,_,se,Le)},getSessions(_,se){return(0,Ye.$AG)(Ue,"authGetSessions"),Nt.getSessions(Ue,_,se)},async hasSession(_,se){return(0,Ye.$AG)(Ue,"authSession"),!!await Nt.getSession(Ue,_,se,{silent:!0})},get onDidChangeSessions(){return xe(Nt.onDidChangeSessions)},registerAuthenticationProvider(_,se,Le,rt){return Nt.registerAuthenticationProvider(_,se,Le,rt)}},ai={registerCommand(_,se,Le){return pt.registerCommand(!0,_,se,Le,void 0,Ue)},registerTextEditorCommand(_,se,Le){return pt.registerCommand(!0,_,(...rt)=>{const wt=qe.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}return wt.edit(Mt=>{se.apply(Le,[wt,Mt,...rt])}).then(Mt=>{Mt||gt.warn("Edits from command "+_+" were not applied.")},Mt=>{gt.warn("An error occurred while running command "+_,Mt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(_,se,Le)=>((0,Ye.$AG)(Ue,"diffCommand"),pt.registerCommand(!0,_,async(...rt)=>{const wt=Dt.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Mt=await qe.getDiffInformation(wt.id);se.apply(Le,[Mt,...rt])},void 0,void 0,Ue)),executeCommand(_,...se){return pt.executeCommand(_,...se)},getCommands(_=!1){return pt.getCommands(_)}},Ei={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Zi.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return xe(St.onDidChangeShell)},get isTelemetryEnabled(){return jt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return xe(jt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$AG)(Ue,"telemetry"),jt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$AG)(Ue,"telemetry"),xe(jt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$yP)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,se){return it.$xP.validateSender(_),jt.instantiateLogger(Ue,_,se)},openExternal(_,se){return Ft.openUri(_,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:se?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===vt.environment.appUriScheme)return wi.createAppUri(_);try{return await Ft.asExternalUri(_,{allowTunneling:!!vt.remote.authority})}catch(se){if((0,M.$Ag)(_,M.Schemas.http)||(0,M.$Ag)(_,M.Schemas.https))return _;throw se}},get remoteName(){return(0,o.$Dm)(vt.remote.authority)},get remoteAuthority(){return(0,Ye.$AG)(Ue,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return xe(gt.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$AG)(Ue,"resolvers"),vt.quality},get appCommit(){return(0,Ye.$AG)(Ue,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(Ei);const xi={createTestController(_,se,Le){return bi.createTestController(Ue,_,se,Le)},createTestObserver(){return(0,Ye.$AG)(Ue,"testObserver"),bi.createTestObserver()},runTests(_){return(0,Ye.$AG)(Ue,"testObserver"),bi.runTests(_)},get onDidChangeTestResults(){return(0,Ye.$AG)(Ue,"testObserver"),xe(bi.onResultsChanged)},get testResults(){return(0,Ye.$AG)(Ue,"testObserver"),bi.results}},Di=vt.remote.isRemote?ye.ExtensionKind.Workspace:ye.ExtensionKind.UI,_i={getExtension(_,se){(0,Ye.$zG)(Ue,"extensionsAny")||(se=!1);const Le=oi.mine.getExtensionDescription(_);if(Le)return new ve.$Clc(Lt,Ue.identifier,Le,Di,!1);if(se){const rt=oi.all.getExtensionDescription(_);if(rt)return new ve.$Clc(Lt,Ue.identifier,rt,Di,!0)}},get all(){const _=[];for(const se of oi.mine.getAllExtensionDescriptions())_.push(new ve.$Clc(Lt,Ue.identifier,se,Di,!1));return _},get allAcrossExtensionHosts(){(0,Ye.$AG)(Ue,"extensionsAny");const _=new v.$Nm(oi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),se=[];for(const Le of oi.all.getAllExtensionDescriptions()){const rt=!_.has(Le.identifier);se.push(new ve.$Clc(Lt,Ue.identifier,Le,Di,rt))}return se},get onDidChange(){return(0,Ye.$zG)(Ue,"extensionsAny")?xe(A.Event.any(oi.mine.onDidChange,oi.all.onDidChange)):xe(oi.mine.onDidChange)}},en={createDiagnosticCollection(_){return Ot.createDiagnosticCollection(Ue.identifier,_)},get onDidChangeDiagnostics(){return xe(Ot.onDidChangeDiagnostics)},getDiagnostics:_=>Ot.getDiagnostics(_),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(_,se){return Vt.changeLanguage(_.uri,se)},match(_,se){const Le=He.LanguageSelector.from(_);let rt;return(0,T.$Yt)(Le)&&(rt=Se.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Mt=>Mt.document===se))?.apiNotebook),(0,T.$Xt)(Le,se.uri,se.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,se,Le){return ct.registerCodeActionProvider(Ue,bt(_),se,Le)},registerDocumentPasteEditProvider(_,se,Le){return(0,Ye.$AG)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,bt(_),se,Le)},registerCodeLensProvider(_,se){return ct.registerCodeLensProvider(Ue,bt(_),se)},registerDefinitionProvider(_,se){return ct.registerDefinitionProvider(Ue,bt(_),se)},registerDeclarationProvider(_,se){return ct.registerDeclarationProvider(Ue,bt(_),se)},registerImplementationProvider(_,se){return ct.registerImplementationProvider(Ue,bt(_),se)},registerTypeDefinitionProvider(_,se){return ct.registerTypeDefinitionProvider(Ue,bt(_),se)},registerHoverProvider(_,se){return ct.registerHoverProvider(Ue,bt(_),se,Ue.identifier)},registerEvaluatableExpressionProvider(_,se){return ct.registerEvaluatableExpressionProvider(Ue,bt(_),se,Ue.identifier)},registerInlineValuesProvider(_,se){return ct.registerInlineValuesProvider(Ue,bt(_),se,Ue.identifier)},registerDocumentHighlightProvider(_,se){return ct.registerDocumentHighlightProvider(Ue,bt(_),se)},registerMultiDocumentHighlightProvider(_,se){return ct.registerMultiDocumentHighlightProvider(Ue,bt(_),se)},registerLinkedEditingRangeProvider(_,se){return ct.registerLinkedEditingRangeProvider(Ue,bt(_),se)},registerReferenceProvider(_,se){return ct.registerReferenceProvider(Ue,bt(_),se)},registerRenameProvider(_,se){return ct.registerRenameProvider(Ue,bt(_),se)},registerNewSymbolNamesProvider(_,se){return(0,Ye.$AG)(Ue,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(Ue,bt(_),se)},registerDocumentSymbolProvider(_,se,Le){return ct.registerDocumentSymbolProvider(Ue,bt(_),se,Le)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(Ue,_)},registerDocumentFormattingEditProvider(_,se){return ct.registerDocumentFormattingEditProvider(Ue,bt(_),se)},registerDocumentRangeFormattingEditProvider(_,se){return ct.registerDocumentRangeFormattingEditProvider(Ue,bt(_),se)},registerOnTypeFormattingEditProvider(_,se,Le,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,bt(_),se,[Le].concat(rt))},registerDocumentSemanticTokensProvider(_,se,Le){return ct.registerDocumentSemanticTokensProvider(Ue,bt(_),se,Le)},registerDocumentRangeSemanticTokensProvider(_,se,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ue,bt(_),se,Le)},registerSignatureHelpProvider(_,se,Le,...rt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ue,bt(_),se,Le):ct.registerSignatureHelpProvider(Ue,bt(_),se,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(_,se,...Le){return ct.registerCompletionItemProvider(Ue,bt(_),se,Le)},registerInlineCompletionItemProvider(_,se,Le){return se.handleDidShowCompletionItem&&(0,Ye.$AG)(Ue,"inlineCompletionsAdditions"),se.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$AG)(Ue,"inlineCompletionsAdditions"),Le&&(0,Ye.$AG)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,bt(_),se,Le)},registerInlineEditProvider(_,se){return(0,Ye.$AG)(Ue,"inlineEdit"),ct.registerInlineEditProvider(Ue,bt(_),se)},registerDocumentLinkProvider(_,se){return ct.registerDocumentLinkProvider(Ue,bt(_),se)},registerColorProvider(_,se){return ct.registerColorProvider(Ue,bt(_),se)},registerFoldingRangeProvider(_,se){return ct.registerFoldingRangeProvider(Ue,bt(_),se)},registerSelectionRangeProvider(_,se){return ct.registerSelectionRangeProvider(Ue,_,se)},registerCallHierarchyProvider(_,se){return ct.registerCallHierarchyProvider(Ue,_,se)},registerTypeHierarchyProvider(_,se){return ct.registerTypeHierarchyProvider(Ue,_,se)},setLanguageConfiguration:(_,se)=>ct.setLanguageConfiguration(Ue,_,se),getTokenInformationAtPosition(_,se){return(0,Ye.$AG)(Ue,"tokenInformation"),Vt.tokenAtPosition(_,se)},registerInlayHintsProvider(_,se){return ct.registerInlayHintsProvider(Ue,_,se)},createLanguageStatusItem(_,se){return Vt.createLanguageStatusItem(Ue,_,se)},registerDocumentDropEditProvider(_,se,Le){return ct.registerDocumentOnDropEditProvider(Ue,_,se,(0,Ye.$zG)(Ue,"documentPaste")?Le:void 0)}},fn={get activeTextEditor(){return qe.getActiveTextEditor()},get visibleTextEditors(){return qe.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(_,se,Le){f.URI.isUri(_)&&_.scheme===M.Schemas.vscodeRemote&&!_.authority&&Rt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(f.URI.isUri(_)?Promise.resolve(Vi.openTextDocument(_)):Promise.resolve(_));return qe.showTextDocument(rt,se,Le)},createTextEditorDecorationType(_){return qe.createTextEditorDecorationType(Ue,_)},onDidChangeActiveTextEditor(_,se,Le){return xe(qe.onDidChangeActiveTextEditor)(_,se,Le)},onDidChangeVisibleTextEditors(_,se,Le){return xe(qe.onDidChangeVisibleTextEditors)(_,se,Le)},onDidChangeTextEditorSelection(_,se,Le){return xe(qe.onDidChangeTextEditorSelection)(_,se,Le)},onDidChangeTextEditorOptions(_,se,Le){return xe(qe.onDidChangeTextEditorOptions)(_,se,Le)},onDidChangeTextEditorVisibleRanges(_,se,Le){return xe(qe.onDidChangeTextEditorVisibleRanges)(_,se,Le)},onDidChangeTextEditorViewColumn(_,se,Le){return xe(qe.onDidChangeTextEditorViewColumn)(_,se,Le)},onDidCloseTerminal(_,se,Le){return xe(St.onDidCloseTerminal)(_,se,Le)},onDidOpenTerminal(_,se,Le){return xe(St.onDidOpenTerminal)(_,se,Le)},onDidChangeActiveTerminal(_,se,Le){return xe(St.onDidChangeActiveTerminal)(_,se,Le)},onDidChangeTerminalDimensions(_,se,Le){return(0,Ye.$AG)(Ue,"terminalDimensions"),xe(St.onDidChangeTerminalDimensions)(_,se,Le)},onDidChangeTerminalState(_,se,Le){return xe(St.onDidChangeTerminalState)(_,se,Le)},onDidWriteTerminalData(_,se,Le){return(0,Ye.$AG)(Ue,"terminalDataWriteEvent"),xe(St.onDidWriteTerminalData)(_,se,Le)},onDidExecuteTerminalCommand(_,se,Le){return(0,Ye.$AG)(Ue,"terminalExecuteCommandEvent"),xe(St.onDidExecuteTerminalCommand)(_,se,Le)},onDidChangeTerminalShellIntegration(_,se,Le){return(0,Ye.$AG)(Ue,"terminalShellIntegration"),xe(li.onDidChangeTerminalShellIntegration)(_,se,Le)},onDidStartTerminalShellExecution(_,se,Le){return(0,Ye.$AG)(Ue,"terminalShellIntegration"),xe(li.onDidStartTerminalShellExecution)(_,se,Le)},onDidEndTerminalShellExecution(_,se,Le){return(0,Ye.$AG)(Ue,"terminalShellIntegration"),xe(li.onDidEndTerminalShellExecution)(_,se,Le)},get state(){return Ft.getState()},onDidChangeWindowState(_,se,Le){return xe(Ft.onDidChangeWindowState)(_,se,Le)},showInformationMessage(_,...se){return Ci.showMessage(Ue,p.default.Info,_,se[0],se.slice(1))},showWarningMessage(_,...se){return Ci.showMessage(Ue,p.default.Warning,_,se[0],se.slice(1))},showErrorMessage(_,...se){return Ci.showMessage(Ue,p.default.Error,_,se[0],se.slice(1))},showQuickPick(_,se,Le){return pi.showQuickPick(Ue,_,se,Le)},showWorkspaceFolderPick(_){return pi.showWorkspaceFolderPick(_)},showInputBox(_,se){return pi.showInput(_,se)},showOpenDialog(_){return ji.showOpenDialog(Ue,_)},showSaveDialog(_){return ji.showSaveDialog(_)},createStatusBarItem(_,se,Le){let rt,wt,Mt;return typeof _=="string"?(rt=_,wt=se,Mt=Le):(wt=_,Mt=se),Qi.createStatusBarEntry(Ue,rt,wt,Mt)},setStatusBarMessage(_,se){return Qi.setStatusBarMessage(_,se)},withScmProgress(_){return Rt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Ti.withProgress(Ue,{location:ye.ProgressLocation.SourceControl},(se,Le)=>_({report(rt){}}))},withProgress(_,se){return Ti.withProgress(Ue,_,se)},createOutputChannel(_,se){return vi.createOutputChannel(_,se,Ue)},createWebviewPanel(_,se,Le,rt){return Ii.createWebviewPanel(Ue,_,se,Le,rt)},createWebviewTextEditorInset(_,se,Le,rt){return(0,Ye.$AG)(Ue,"editorInsets"),Et.createWebviewEditorInset(_,se,Le,rt,Ue)},createTerminal(_,se,Le){return typeof _=="object"?"pty"in _?St.createExtensionTerminal(_):St.createTerminalFromOptions(_):St.createTerminal(_,se,Le)},registerTerminalLinkProvider(_){return St.registerLinkProvider(_)},registerTerminalProfileProvider(_,se){return St.registerProfileProvider(Ue,_,se)},registerTerminalQuickFixProvider(_,se){return(0,Ye.$AG)(Ue,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(_,Ue.identifier.value,se)},registerTreeDataProvider(_,se){return ut.registerTreeDataProvider(_,se,Ue)},createTreeView(_,se){return ut.createTreeView(_,se,Ue)},registerWebviewPanelSerializer:(_,se)=>Ii.registerWebviewPanelSerializer(Ue,_,se),registerCustomEditorProvider:(_,se,Le={})=>Gi.registerCustomEditorProvider(Ue,_,se,Le),registerFileDecorationProvider(_){return Ct.registerFileDecorationProvider(_,Ue)},registerUriHandler(_){return wi.registerUriHandler(Ue,_)},createQuickPick(){return pi.createQuickPick(Ue)},createInputBox(){return pi.createInputBox(Ue)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(_,se,Le){return xe(Fi.onDidChangeActiveColorTheme)(_,se,Le)},registerWebviewViewProvider(_,se,Le){return Ki.registerWebviewViewProvider(Ue,_,se,Le?.webviewOptions)},get activeNotebookEditor(){return Se.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,se,Le){return xe(Se.onDidChangeActiveNotebookEditor)(_,se,Le)},get visibleNotebookEditors(){return Se.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return xe(Se.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,se,Le){return xe(J.onDidChangeNotebookEditorSelection)(_,se,Le)},onDidChangeNotebookEditorVisibleRanges(_,se,Le){return xe(J.onDidChangeNotebookEditorVisibleRanges)(_,se,Le)},showNotebookDocument(_,se){return Se.showNotebookDocument(_,se)},registerExternalUriOpener(_,se,Le){return(0,Ye.$AG)(Ue,"externalUriOpener"),Ji.registerExternalUriOpener(Ue.identifier,_,se,Le)},registerProfileContentHandler(_,se){return(0,Ye.$AG)(Ue,"profileContentHandlers"),Xi.registerProfileContentHandler(Ue,_,se)},registerQuickDiffProvider(_,se,Le,rt){return(0,Ye.$AG)(Ue,"quickDiffProvider"),Ri.registerQuickDiffProvider(bt(_),se,Le,rt)},get tabGroups(){return Gt.tabGroups},registerShareProvider(_,se){return(0,Ye.$AG)(Ue,"shareProvider"),Mi.registerShareProvider(bt(_),se)}},Vi={get rootPath(){return Rt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new N.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new N.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(_,se,...Le)=>ft.updateWorkspaceFolders(Ue,_,se||0,...Le),onDidChangeWorkspaceFolders:function(_,se,Le){return xe(ft.onDidChangeWorkspace)(_,se,Le)},asRelativePath:(_,se)=>ft.getRelativePath(_,se),findFiles:(_,se,Le,rt)=>ft.findFiles(_,se,Le,Ue.identifier,rt),findFiles2:(_,se,Le)=>((0,Ye.$AG)(Ue,"findFiles2"),ft.findFiles2(_,se,Ue.identifier,Le)),findTextInFiles:(_,se,Le,rt)=>{(0,Ye.$AG)(Ue,"findTextInFiles");let wt,Mt;return typeof se=="object"?(wt=se,Mt=Le):(wt={},Mt=se,rt=Le),ft.findTextInFiles(_,wt||{},Mt,Ue.identifier,rt)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,se){return Ui.applyWorkspaceEdit(_,Ue,se)},createFileSystemWatcher:(_,se,Le,rt)=>{let wt;return typeof se=="boolean"?wt={ignoreCreateEvents:!!se,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt,correlate:!1}:se&&((0,Ye.$AG)(Ue,"createFileSystemWatcher"),wt={...se,correlate:!0}),di.createFileSystemWatcher(ft,Ue,_,wt)},get textDocuments(){return yt.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new N.$9("textDocuments")},openTextDocument(_){let se;const Le=_;if(typeof _=="string")se=Promise.resolve(f.URI.file(_));else if(f.URI.isUri(_))se=Promise.resolve(_);else if(!Le||typeof Le=="object")se=yt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return se.then(rt=>(rt.scheme===M.Schemas.vscodeRemote&&!rt.authority&&Rt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),yt.ensureDocumentData(rt).then(wt=>wt.document)))},onDidOpenTextDocument:(_,se,Le)=>xe(yt.onDidAddDocument)(_,se,Le),onDidCloseTextDocument:(_,se,Le)=>xe(yt.onDidRemoveDocument)(_,se,Le),onDidChangeTextDocument:(_,se,Le)=>xe(yt.onDidChangeDocument)(_,se,Le),onDidSaveTextDocument:(_,se,Le)=>xe(yt.onDidSaveDocument)(_,se,Le),onWillSaveTextDocument:(_,se,Le)=>xe(we.getOnWillSaveTextDocumentEvent(Ue))(_,se,Le),get notebookDocuments(){return Se.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,se){let Le;if(f.URI.isUri(_))Le=_,await Se.openNotebookDocument(_);else if(typeof _=="string")Le=f.URI.revive(await Se.createNotebookDocument({viewType:_,content:se}));else throw new Error("Invalid arguments");return Se.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,se,Le){return xe(oe.onDidSaveNotebookDocument)(_,se,Le)},onDidChangeNotebookDocument(_,se,Le){return xe(oe.onDidChangeNotebookDocument)(_,se,Le)},onWillSaveNotebookDocument(_,se,Le){return xe(Qe.getOnWillSaveNotebookDocumentEvent(Ue))(_,se,Le)},get onDidOpenNotebookDocument(){return xe(Se.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return xe(Se.onDidCloseNotebookDocument)},registerNotebookSerializer(_,se,Le,rt){return Se.registerNotebookSerializer(Ue,_,se,Le,(0,Ye.$zG)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,se,Le)=>xe(Bi.onDidChangeConfiguration)(_,se,Le),getConfiguration(_,se){return se=arguments.length===1?void 0:se,Bi.getConfiguration(_,se,Ue)},registerTextDocumentContentProvider(_,se){return $i.registerTextDocumentContentProvider(_,se)},registerTaskProvider:(_,se)=>(Rt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Ue,_,se)),registerFileSystemProvider(_,se,Le){return(0,F.$Rc)(ri.registerFileSystemProvider(Ue,_,se,Le),Zt.addFileSystemProvider(_,se,Le))},get fs(){return Zt.value},registerFileSearchProvider:(_,se)=>((0,Ye.$AG)(Ue,"fileSearchProvider"),hi.registerFileSearchProvider(_,se)),registerTextSearchProvider:(_,se)=>((0,Ye.$AG)(Ue,"textSearchProvider"),hi.registerTextSearchProvider(_,se)),registerAITextSearchProvider:(_,se)=>((0,Ye.$AG)(Ue,"aiTextSearchProvider"),(0,Ye.$AG)(Ue,"textSearchProvider"),hi.registerAITextSearchProvider(_,se)),registerRemoteAuthorityResolver:(_,se)=>((0,Ye.$AG)(Ue,"resolvers"),Lt.registerRemoteAuthorityResolver(_,se)),registerResourceLabelFormatter:_=>((0,Ye.$AG)(Ue,"resolvers"),cn.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ye.$AG)(Ue,"resolvers"),Lt.getRemoteExecServer(_)),onDidCreateFiles:(_,se,Le)=>xe(di.onDidCreateFile)(_,se,Le),onDidDeleteFiles:(_,se,Le)=>xe(di.onDidDeleteFile)(_,se,Le),onDidRenameFiles:(_,se,Le)=>xe(di.onDidRenameFile)(_,se,Le),onWillCreateFiles:(_,se,Le)=>xe(di.getOnWillCreateFileEvent(Ue))(_,se,Le),onWillDeleteFiles:(_,se,Le)=>xe(di.getOnWillDeleteFileEvent(Ue))(_,se,Le),onWillRenameFiles:(_,se,Le)=>xe(di.getOnWillRenameFileEvent(Ue))(_,se,Le),openTunnel:_=>((0,Ye.$AG)(Ue,"tunnels"),Tt.openTunnel(Ue,_).then(se=>{if(!se)throw new Error("cannot open tunnel");return se})),get tunnels(){return(0,Ye.$AG)(Ue,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(_,se,Le)=>((0,Ye.$AG)(Ue,"tunnels"),xe(Tt.onDidChangeTunnels)(_,se,Le)),registerPortAttributesProvider:(_,se)=>((0,Ye.$AG)(Ue,"portsAttributes"),Tt.registerPortsAttributesProvider(_,se)),registerTunnelProvider:(_,se)=>((0,Ye.$AG)(Ue,"tunnelFactory"),Tt.registerTunnelProvider(_,se)),registerTimelineProvider:(_,se)=>((0,Ye.$AG)(Ue,"timeline"),Oi.registerTimelineProvider(_,se,Ue.identifier,pt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Ye.$AG)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,se,Le)=>xe(ft.onDidGrantWorkspaceTrust)(_,se,Le),registerEditSessionIdentityProvider:(_,se)=>((0,Ye.$AG)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,se)),onWillCreateEditSessionIdentity:(_,se,Le)=>((0,Ye.$AG)(Ue,"editSessionIdentityProvider"),xe(ft.getOnWillCreateEditSessionIdentityEvent(Ue))(_,se,Le)),registerCanonicalUriProvider:(_,se)=>((0,Ye.$AG)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,se)),getCanonicalUri:(_,se,Le)=>((0,Ye.$AG)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(_,se,Le))},tn={get inputBox(){return Rt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(Ue)},createSourceControl(_,se,Le){return Si.createSourceControl(Ue,_,se,Le)}},gn={createCommentController(_,se){return Ni.createCommentController(Ue,_,se)}},mn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,Ye.$zG)(Ue,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(_,se){return(0,Ye.$AG)(Ue,"debugVisualization"),kt.registerDebugVisualizationProvider(Ue,_,se)},registerDebugVisualizationTreeProvider(_,se){return(0,Ye.$AG)(Ue,"debugVisualization"),kt.registerDebugVisualizationTree(Ue,_,se)},onDidStartDebugSession(_,se,Le){return xe(kt.onDidStartDebugSession)(_,se,Le)},onDidTerminateDebugSession(_,se,Le){return xe(kt.onDidTerminateDebugSession)(_,se,Le)},onDidChangeActiveDebugSession(_,se,Le){return xe(kt.onDidChangeActiveDebugSession)(_,se,Le)},onDidReceiveDebugSessionCustomEvent(_,se,Le){return xe(kt.onDidReceiveDebugSessionCustomEvent)(_,se,Le)},onDidChangeBreakpoints(_,se,Le){return xe(kt.onDidChangeBreakpoints)(_,se,Le)},onDidChangeActiveStackItem(_,se,Le){return(0,Ye.$AG)(Ue,"debugFocus"),xe(kt.onDidChangeActiveStackItem)(_,se,Le)},registerDebugConfigurationProvider(_,se,Le){return kt.registerDebugConfigurationProvider(_,se,Le||Wt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,se){return kt.registerDebugAdapterDescriptorFactory(Ue,_,se)},registerDebugAdapterTrackerFactory(_,se){return kt.registerDebugAdapterTrackerFactory(_,se)},startDebugging(_,se,Le){return!Le||typeof Le=="object"&&"configuration"in Le?kt.startDebugging(_,se,{parentSession:Le}):kt.startDebugging(_,se,Le||{})},stopDebugging(_){return kt.stopDebugging(_)},addBreakpoints(_){return kt.addBreakpoints(_)},removeBreakpoints(_){return kt.removeBreakpoints(_)},asDebugSourceUri(_,se){return kt.asDebugSourceUri(_,se)}},nn={registerTaskProvider:(_,se)=>Kt.registerTaskProvider(Ue,_,se),fetchTasks:_=>Kt.fetchTasks(_),executeTask:_=>Kt.executeTask(Ue,_),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(_,se,Le)=>xe(Kt.onDidStartTask)(_,se,Le),onDidEndTask:(_,se,Le)=>xe(Kt.onDidEndTask)(_,se,Le),onDidStartTaskProcess:(_,se,Le)=>xe(Kt.onDidStartTaskProcess)(_,se,Le),onDidEndTaskProcess:(_,se,Le)=>xe(Kt.onDidEndTaskProcess)(_,se,Le)},Wi={createNotebookController(_,se,Le,rt,wt){return ke.createNotebookController(Ue,_,se,Le,rt,(0,Ye.$zG)(Ue,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(_,se)=>Se.registerNotebookCellStatusBarItemProvider(Ue,_,se),createRendererMessaging(_){return Ve.createRendererMessaging(Ue,_)},createNotebookControllerDetectionTask(_){return(0,Ye.$AG)(Ue,"notebookKernelSource"),ke.createNotebookControllerDetectionTask(Ue,_)},registerKernelSourceActionProvider(_,se){return(0,Ye.$AG)(Ue,"notebookKernelSource"),ke.registerKernelSourceActionProvider(Ue,_,se)},onDidChangeNotebookCellExecutionState(_,se,Le){return(0,Ye.$AG)(Ue,"notebookCellExecutionState"),xe(ke.onDidChangeNotebookCellExecutionState)(_,se,Le)}},rn={t(..._){if(typeof _[0]=="string"){const se=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return ei.getMessage(Ue.identifier.value,{message:se,args:Le})}return ei.getMessage(Ue.identifier.value,_[0])},get bundle(){return ei.getBundle(Ue.identifier.value)},get uri(){return ei.getBundleUri(Ue.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(_,se){return(0,Ye.$AG)(Ue,"interactive"),un.registerProvider(Ue,_,se)},transferActiveChat(_){return(0,Ye.$AG)(Ue,"interactive"),Li.transferActiveChat(_)}},on={getRelatedInformation(_,se){return(0,Ye.$AG)(Ue,"aiRelatedInformation"),Pi.getRelatedInformation(Ue,_,se)},registerRelatedInformationProvider(_,se){return(0,Ye.$AG)(Ue,"aiRelatedInformation"),Pi.registerRelatedInformationProvider(Ue,_,se)},registerEmbeddingVectorProvider(_,se){return(0,Ye.$AG)(Ue,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(Ue,_,se)}},$n={registerChatResponseProvider(_,se,Le){return(0,Ye.$AG)(Ue,"chatProvider"),At.registerLanguageModel(Ue,_,se,Le)},registerChatVariableResolver(_,se,Le){return(0,Ye.$AG)(Ue,"chatVariableResolver"),zi.registerVariableResolver(Ue,_,se,Le)},registerMappedEditsProvider(_,se){return(0,Ye.$AG)(Ue,"mappedEditsProvider"),ct.registerMappedEditsProvider(Ue,_,se)},createChatParticipant(_,se){return(0,Ye.$AG)(Ue,"chatParticipant"),Li.createChatAgent(Ue,_,se)},createDynamicChatParticipant(_,se,Le,rt){return(0,Ye.$AG)(Ue,"chatParticipantAdditions"),Li.createDynamicChatAgent(Ue,_,se,Le,rt)}},pn={get languageModels(){return(0,Ye.$AG)(Ue,"languageModels"),At.getLanguageModelIds()},onDidChangeLanguageModels:(_,se,Le)=>((0,Ye.$AG)(Ue,"languageModels"),At.onDidChangeProviders(_,se,Le)),sendChatRequest(_,se,Le,rt){return(0,Ye.$AG)(Ue,"languageModels"),At.sendChatRequest(Ue,_,se,Le,rt)},computeTokenLength(_,se,Le){return(0,Ye.$AG)(Ue,"languageModels"),Le??=I.CancellationToken.None,At.computeTokenLength(_,se,Le)},getLanguageModelInformation(_){return(0,Ye.$AG)(Ue,"languageModels"),At.getLanguageModelInfo(_)}},an={registerSpeechProvider(_,se){return(0,Ye.$AG)(Ue,"speech"),Yi.registerProvider(Ue.identifier,_,se)}};return{version:vt.version,ai:on,authentication:dn,commands:ai,comments:gn,chat:$n,debug:mn,env:Ei,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:pn,notebooks:Wi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Vi,Breakpoint:ye.$UN,TerminalOutputAnchor:ye.TerminalOutputAnchor,ChatResultFeedbackKind:ye.ChatResultFeedbackKind,ChatVariableLevel:ye.ChatVariableLevel,ChatCompletionItem:ye.$PO,CallHierarchyIncomingCall:ye.$gN,CallHierarchyItem:ye.$fN,CallHierarchyOutgoingCall:ye.$hN,CancellationError:N.$5,CancellationTokenSource:I.$me,CandidatePortSource:t.CandidatePortSource,CodeAction:ye.$cN,CodeActionKind:ye.$dN,CodeActionTriggerKind:ye.CodeActionTriggerKind,CodeLens:ye.$iN,Color:ye.$vN,ColorInformation:ye.$wN,ColorPresentation:ye.$xN,ColorThemeKind:ye.ColorThemeKind,CommentMode:ye.CommentMode,CommentState:ye.CommentState,CommentThreadCollapsibleState:ye.CommentThreadCollapsibleState,CommentThreadState:ye.CommentThreadState,CommentThreadApplicability:ye.CommentThreadApplicability,CompletionItem:ye.$pN,CompletionItemKind:ye.CompletionItemKind,CompletionItemTag:ye.CompletionItemTag,CompletionList:ye.$qN,CompletionTriggerKind:ye.CompletionTriggerKind,ConfigurationTarget:ye.ConfigurationTarget,CustomExecution:ye.$FN,DebugAdapterExecutable:ye.$YN,DebugAdapterInlineImplementation:ye.$2N,DebugAdapterNamedPipeServer:ye.$1N,DebugAdapterServer:ye.$ZN,DebugConfigurationProviderTriggerKind:Wt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:ye.DebugConsoleMode,DebugVisualization:ye.$fO,DecorationRangeBehavior:ye.DecorationRangeBehavior,Diagnostic:ye.$9M,DiagnosticRelatedInformation:ye.$8M,DiagnosticSeverity:ye.DiagnosticSeverity,DiagnosticTag:ye.DiagnosticTag,Disposable:ye.$UM,DocumentHighlight:ye.$$M,DocumentHighlightKind:ye.DocumentHighlightKind,MultiDocumentHighlight:ye.$_M,DocumentLink:ye.$uN,DocumentSymbol:ye.$bN,EndOfLine:ye.EndOfLine,EnvironmentVariableMutatorType:ye.EnvironmentVariableMutatorType,EvaluatableExpression:ye.$5N,InlineValueText:ye.$6N,InlineValueVariableLookup:ye.$7N,InlineValueEvaluatableExpression:ye.$8N,InlineCompletionTriggerKind:ye.InlineCompletionTriggerKind,EventEmitter:A.$be,ExtensionKind:ye.ExtensionKind,ExtensionMode:ye.ExtensionMode,ExternalUriOpenerPriority:ye.ExternalUriOpenerPriority,FileChangeType:ye.FileChangeType,FileDecoration:ye.$hO,FileDecoration2:ye.$hO,FileSystemError:ye.$$N,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:ye.$_N,FoldingRangeKind:ye.FoldingRangeKind,FunctionBreakpoint:ye.$WN,InlineCompletionItem:ye.$rN,InlineCompletionList:ye.$sN,Hover:ye.$0M,IndentAction:y.IndentAction,Location:ye.$7M,MarkdownString:ye.$jN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:ye.$kN,PortAutoForwardAction:ye.PortAutoForwardAction,Position:ye.$VM,ProcessExecution:ye.$DN,ProgressLocation:ye.ProgressLocation,QuickInputButtons:ye.$gO,Range:ye.$WM,RelativePattern:ye.$SN,Selection:ye.$XM,SelectionRange:ye.$eN,SemanticTokens:ye.$cO,SemanticTokensBuilder:ye.$bO,SemanticTokensEdit:ye.$dO,SemanticTokensEdits:ye.$eO,SemanticTokensLegend:ye.$aO,ShellExecution:ye.$EN,ShellQuoting:ye.ShellQuoting,SignatureHelp:ye.$mN,SignatureHelpTriggerKind:ye.SignatureHelpTriggerKind,SignatureInformation:ye.$lN,SnippetString:ye.$6M,SourceBreakpoint:ye.$VN,StandardTokenType:ye.StandardTokenType,StatusBarAlignment:ye.StatusBarAlignment,SymbolInformation:ye.$aN,SymbolKind:ye.SymbolKind,SymbolTag:ye.SymbolTag,Task:ye.$GN,TaskGroup:ye.$CN,TaskPanelKind:ye.TaskPanelKind,TaskRevealKind:ye.TaskRevealKind,TaskScope:ye.TaskScope,TerminalLink:ye.$yN,TerminalQuickFixTerminalCommand:ye.$AN,TerminalQuickFixOpener:ye.$zN,TerminalLocation:ye.TerminalLocation,TerminalProfile:ye.$BN,TerminalExitReason:ye.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:ye.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:ye.TextDocumentSaveReason,TextEdit:ye.$2M,SnippetTextEdit:ye.$4M,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:ye.TextEditorLineNumbersStyle,TextEditorRevealType:ye.TextEditorRevealType,TextEditorSelectionChangeKind:ye.TextEditorSelectionChangeKind,SyntaxTokenType:ye.SyntaxTokenType,TextDocumentChangeReason:ye.TextDocumentChangeReason,ThemeColor:ye.$RN,ThemeIcon:ye.$QN,TreeItem:ye.$HN,TreeItemCheckboxState:ye.TreeItemCheckboxState,TreeItemCollapsibleState:ye.TreeItemCollapsibleState,TypeHierarchyItem:ye.$DO,UIKind:Qt.UIKind,Uri:f.URI,ViewColumn:ye.ViewColumn,WorkspaceEdit:ye.$5M,DocumentPasteTriggerKind:ye.DocumentPasteTriggerKind,DocumentDropEdit:ye.$NN,DocumentDropOrPasteEditKind:ye.$ON,DocumentPasteEdit:ye.$PN,InlayHint:ye.$oN,InlayHintLabelPart:ye.$nN,InlayHintKind:ye.InlayHintKind,RemoteAuthorityResolverError:ye.$1M,ResolvedAuthority:ye.$YM,ManagedResolvedAuthority:ye.$ZM,SourceControlInputBoxValidationType:ye.SourceControlInputBoxValidationType,ExtensionRuntime:ye.ExtensionRuntime,TimelineItem:ye.$rO,NotebookRange:ye.$jO,NotebookCellKind:ye.NotebookCellKind,NotebookCellExecutionState:ye.NotebookCellExecutionState,NotebookCellData:ye.$kO,NotebookData:ye.$lO,NotebookRendererScript:ye.$pO,NotebookCellStatusBarAlignment:ye.NotebookCellStatusBarAlignment,NotebookEditorRevealType:ye.NotebookEditorRevealType,NotebookCellOutput:ye.$nO,NotebookCellOutputItem:ye.$mO,NotebookCellStatusBarItem:ye.$oO,NotebookControllerAffinity:ye.NotebookControllerAffinity,NotebookControllerAffinity2:ye.NotebookControllerAffinity2,NotebookEdit:ye.$3M,NotebookKernelSourceAction:ye.$qO,NotebookVariablesRequestKind:ye.NotebookVariablesRequestKind,PortAttributes:ye.$tO,LinkedEditingRanges:ye.$sO,TestResultState:ye.TestResultState,TestRunRequest:ye.$uO,TestMessage:ye.$vO,TestTag:ye.$wO,TestRunProfileKind:ye.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:ye.$MN,DataTransferItem:ye.$IN,TestCoverageCount:ye.$xO,FileCoverage:ye.$zO,StatementCoverage:ye.$AO,BranchCoverage:ye.$BO,DeclarationCoverage:ye.$CO,WorkspaceTrustState:ye.WorkspaceTrustState,LanguageStatusSeverity:ye.LanguageStatusSeverity,QuickPickItemKind:ye.QuickPickItemKind,InputBoxValidationSeverity:ye.InputBoxValidationSeverity,TabInputText:ye.$EO,TabInputTextDiff:ye.$FO,TabInputTextMerge:ye.$GO,TabInputCustom:ye.$HO,TabInputNotebook:ye.$JO,TabInputNotebookDiff:ye.$KO,TabInputWebview:ye.$IO,TabInputTerminal:ye.$LO,TabInputInteractiveWindow:ye.$MO,TabInputChat:ye.$NO,TabInputTextMultiDiff:ye.$OO,TelemetryTrustedValue:r.$ap,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:ye.InteractiveSessionVoteDirection,ChatCopyKind:ye.ChatCopyKind,InteractiveEditorResponseFeedbackKind:ye.InteractiveEditorResponseFeedbackKind,StackFrame:ye.$3N,Thread:ye.$4N,RelatedInformationType:ye.RelatedInformationType,SpeechToTextStatus:ye.SpeechToTextStatus,PartialAcceptTriggerKind:ye.PartialAcceptTriggerKind,KeywordRecognitionStatus:ye.KeywordRecognitionStatus,ChatResponseMarkdownPart:ye.$QO,ChatResponseFileTreePart:ye.$TO,ChatResponseAnchorPart:ye.$UO,ChatResponseProgressPart:ye.$VO,ChatResponseReferencePart:ye.$XO,ChatResponseTextEditPart:ye.$YO,ChatResponseMarkdownWithVulnerabilitiesPart:ye.$RO,ChatResponseCommandButtonPart:ye.$WO,ChatResponseDetectedParticipantPart:ye.$SO,ChatRequestTurn:ye.$ZO,ChatResponseTurn:ye.$1O,ChatLocation:ye.ChatLocation,LanguageModelChatSystemMessage:ye.$2O,LanguageModelChatUserMessage:ye.$3O,LanguageModelChatAssistantMessage:ye.$4O,LanguageModelSystemMessage:ye.$2O,LanguageModelUserMessage:ye.$3O,LanguageModelAssistantMessage:ye.$4O,LanguageModelError:ye.$5O,NewSymbolName:ye.$0N,NewSymbolNameTag:ye.NewSymbolNameTag,InlineEdit:ye.$6O,InlineEditTriggerKind:ye.InlineEditTriggerKind}}}}),define(Ce[297],Re([1,0,55,116,37,110,38,32,67,51,119,121,122,82,86,78,109,64,45,81,62,66,236,13,120,79,80,84,88,114]),function(ge,e,I,N,A,F,M,p,f,E,T,y,u,v,m,s,o,r,n,t,c,l,i,$,a,b,h,D,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$rs)(b.$wlc,b.$vlc,1),(0,I.$rs)($.$Yj,i.$Jmc,1),(0,I.$rs)(s.$Bkc,s.$Ckc,1),(0,I.$rs)(p.$BP,p.$AP,0),(0,I.$rs)(D.$Lkc,D.$Mkc,0),(0,I.$rs)(d.$qlc,d.$rlc,0),(0,I.$rs)(M.$1kc,M.$Ykc,0),(0,I.$rs)(r.$3kc,r.$2kc,0),(0,I.$rs)(y.$Glc,y.$Klc,0),(0,I.$rs)(F.$Mlc,F.$Llc,0),(0,I.$rs)(f.$qP,f.$pP,0),(0,I.$rs)(h.$xlc,h.$ylc,0),(0,I.$rs)(n.$Fkc,n.$Ekc,0),(0,I.$rs)(N.$fmc,N.$emc,1),(0,I.$rs)(u.$3lc,u.$4lc,0),(0,I.$rs)(v.$jlc,v.$ilc,0),(0,I.$rs)(T.$smc,T.$rmc,0),(0,I.$rs)(E.$mlc,E.$plc,0),(0,I.$rs)(k.$tmc,k.$umc,0),(0,I.$rs)(m.$WCb,m.$XCb,0),(0,I.$rs)(o.$Hmc,o.$Gmc,0),(0,I.$rs)(A.$Xkc,A.$Wkc,0),(0,I.$rs)(t.$tlc,t.$slc,0),(0,I.$rs)(c.$zP,c.$wP,0),(0,I.$rs)(l.$alc,l.$blc,0),(0,I.$rs)(a.$Elc,a.$Flc,0)}),define(Ce[298],Re([1,0,296,39,2,293,7,11,242]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;class E extends F.$Mmc{j(){}getModule(v,m){for(const s of this.b){const o=s(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends N.$Alc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(f.$Soc);const v=this.h.invokeFunction(I.$Imc);this.r=this.h.createInstance(E,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(v){return v.browser}async xb(v,m,s){m=m.with({path:y(m.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const r=A.URI.revive(await this.C.$asBrowserUri(m)),n=await fetch(r.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const t=await n.text(),c=`${m.toString(!0)}#vscode-extension`,l=`${t}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",l)}catch(h){throw console.error(o?`Loading code for extension ${o} failed: ${h.message}`:`Loading code failed: ${h.message}`),console.error(`${m.toString(!0)}${typeof h.line=="number"?` line ${h.line}`:""}${typeof h.column=="number"?` column ${h.column}`:""}`),console.error(h),h}v&&await this.w.initializeLocalizedMessages(v);const $={},a={exports:$},b=h=>{const D=this.r.getModule(h,m);if(D===void 0)throw new Error(`Cannot load module '${h}'`);return D};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(a,$,b),a.exports!==$?a.exports:$}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(v){}async Bb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+v;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,p.$sh)(10)}}e.$Toc=T;function y(u,v){return u.endsWith(v)?u:u+v}}),define(Ce[299],Re([1,0,70,55,13,39,206,85,298]),function(ge,e,I,N,A,F,M,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,N.$rs)(A.$Xj,new I.$oi(M.$Lmc,[!0],!0)),(0,N.$rs)(F.$Blc,f.$Toc,0),(0,N.$rs)(p.$4kc,p.$5kc,0)}),define(Ce[305],Re([1,0,22,5,77,294,244,19,89,12,2,297,299]),function(ge,e,I,N,A,F,M,p,f,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=l;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(i){return/^(file|vscode-remote):/i.test(i)}const m=fetch.bind(self);function s(i){self.fetch=async function($,a){return $ instanceof Request||v(String($))&&($=(await i(T.URI.parse(String($)))).toString(!0)),m($,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open($,a,b,h,D){(async()=>(v(a.toString())&&(a=(await i(T.URI.parse(a.toString()))).toString(!0)),super.open($,a,b??!0,h,D)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function($,a){if(/^file:/i.test($.toString()))$=E.$Lg.uriToBrowserUri(T.URI.parse($.toString())).toString(!0);else if(/^vscode-remote:/i.test($.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const h=`(${function(g){function S(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const w=fetch.bind(self);self.fetch=function(P,W){return P instanceof Request?w(P,W):w(S(P),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,W,V,q,R){return super.open(P,S(W),V??!0,q,R)}};const C=importScripts.bind(self);self.importScripts=(...P)=>{C(...P.map(S))},C(g)}.toString()}('${$}'))`;a=a||{},a.name=`${name} -> ${a.name||p.$oc($.toString())}`;const D=new Blob([h],{type:"application/javascript"}),d=URL.createObjectURL(D);return new i(d,a)}}else self.Worker=class extends M.$Uoc{constructor(i,$){super(u,i,{name:p.$oc(i.toString()),...$})}};const o=new class{constructor(){this.pid=void 0}exit(i){y()}};class r{constructor(){const $=new MessageChannel,a=new N.$be;let b=!1;u($.port2,[$.port2]),$.port1.onmessage=h=>{const{data:D}=h;if(!(D instanceof ArrayBuffer)){console.warn("UNKNOWN data received",D);return}const d=I.$Ce.wrap(new Uint8Array(D,0,D.byteLength));if((0,A.$Vm)(d,2)){b=!0,t("received terminate message from renderer");return}a.fire(d)},this.protocol={onMessage:a.event,send:h=>{if(!b){const D=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);$.port1.postMessage(D,[D])}}}}}function n(i){return new Promise($=>{const a=i.onMessage(b=>{a.dispose();const h=JSON.parse(b.toString());i.send((0,A.$Um)(0)),$({protocol:i,initData:h})});i.send((0,A.$Um)(1))})}let t=i=>y();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function l(){f.mark("code/extHost/willConnectToRenderer");const i=new r;return{onmessage($){c($)&&n(i.protocol).then(a=>{f.mark("code/extHost/didWaitForInitData");const b=new F.$Omc(a.protocol,a.initData,o,null,$.data);s(h=>b.asBrowserUri(h)),t=h=>b.terminate(h)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/910284865c34fd492e3f6fd5a8ab8e571432cc58/core/vs/workbench/api/worker/extensionHostWorker.js.map
