/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var de=["require","exports","vs/base/common/platform","vs/base/common/errors","vs/base/common/path","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/cancellation","vs/base/common/types","vs/base/common/event","vs/base/common/buffer","vs/base/common/strings","vs/base/common/lazy","vs/base/common/objects","vs/base/common/process","vs/base/common/network","vs/base/common/async","vs/base/common/arrays","vs/base/common/functional","vs/base/common/map","vs/base/common/extpath","vs/base/common/processes","vs/base/common/resources","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/uuid","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/amdX","vs/base/node/pfs","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/instantiation","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryUtils","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/nls","vs/nls!vs/workbench/contrib/debug/node/telemetryApp","fs","os","util","child_process","https","vs/workbench/contrib/debug/node/telemetryApp"],$e=function(le){for(var e=[],C=0,z=le.length;C<z;C++)e[C]=de[le[C]];return e};define(de[23],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class C{static get(){const M=new Map,O=new Map,W=new Map,P=new Map;function c(U,u){U.has(u.detail)||U.set(u.detail,-u.timestamp)}function g(U,u){const l=U.get(u.detail);l&&(l>=0||U.set(u.detail,l+u.timestamp))}let L=[];typeof le=="function"&&typeof le.getStats=="function"&&(L=le.getStats().slice(0).sort((U,u)=>U.timestamp-u.timestamp));for(const U of L)switch(U.type){case 10:c(M,U);break;case 11:case 12:g(M,U);break;case 21:c(O,U);break;case 22:g(O,U);break;case 33:c(W,U);break;case 34:g(W,U);break;case 31:c(P,U);break;case 32:g(P,U);break}let _=0;W.forEach(U=>_+=U);function T(U){const u=[];return U.forEach((l,D)=>u.push([D,l])),u}return{amdLoad:T(M),amdInvoke:T(O),nodeRequire:T(W),nodeEval:T(P),nodeRequireTotal:_}}static toMarkdownTable(M,O){let W="";const P=[];return M.forEach((c,g)=>{P[g]=c.length}),O.forEach(c=>{c.forEach((g,L)=>{typeof g>"u"&&(g=c[L]="-");const _=g.toString().length;P[L]=Math.max(_,P[L])})}),M.forEach((c,g)=>{W+=`| ${c+" ".repeat(P[g]-c.toString().length)} `}),W+=`|
`,M.forEach((c,g)=>{W+=`| ${"-".repeat(P[g])} `}),W+=`|
`,O.forEach(c=>{c.forEach((g,L)=>{typeof g<"u"&&(W+=`| ${g+" ".repeat(P[L]-g.toString().length)} `)}),W+=`|
`}),W}}e.$U=C}),define(de[24],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=C,e.$gb=z,e.$hb=M,e.$ib=O,e.$jb=W,e.$kb=P,e.$lb=c,e.$nb=L,e.$ob=_,e.$pb=T,e.$qb=U,e.$rb=u;function C(l,D){const $=z(l,D);if($!==-1)return l[$]}function z(l,D,$=l.length-1){for(let S=$;S>=0;S--){const I=l[S];if(D(I))return S}return-1}function M(l,D){const $=O(l,D);return $===-1?void 0:l[$]}function O(l,D,$=0,S=l.length){let I=$,s=S;for(;I<s;){const i=Math.floor((I+s)/2);D(l[i])?I=i+1:s=i}return I-1}function W(l,D){const $=P(l,D);return $===l.length?void 0:l[$]}function P(l,D,$=0,S=l.length){let I=$,s=S;for(;I<s;){const i=Math.floor((I+s)/2);D(l[i])?s=i:I=i+1}return I}function c(l,D,$=0,S=l.length){const I=P(l,D,$,S);return I===l.length?-1:I}class g{static{this.assertInvariants=!1}constructor(D){this.e=D,this.c=0}findLastMonotonous(D){if(g.assertInvariants){if(this.d){for(const S of this.e)if(this.d(S)&&!D(S))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=D}const $=O(this.e,D,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$mb=g;function L(l,D){if(l.length===0)return;let $=l[0];for(let S=1;S<l.length;S++){const I=l[S];D(I,$)>0&&($=I)}return $}function _(l,D){if(l.length===0)return;let $=l[0];for(let S=1;S<l.length;S++){const I=l[S];D(I,$)>=0&&($=I)}return $}function T(l,D){return L(l,($,S)=>-D($,S))}function U(l,D){if(l.length===0)return-1;let $=0;for(let S=1;S<l.length;S++){const I=l[S];D(I,l[$])>0&&($=S)}return $}function u(l,D){for(const $ of l){const S=D($);if(S!==void 0)return S}}}),define(de[25],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=C,e.$L=z,e.$M=M,e.$N=O;function C(W,P){const c=Object.create(null);for(const g of W){const L=P(g);let _=c[L];_||(_=c[L]=[]),_.push(g)}return c}function z(W,P){const c=[],g=[];for(const L of W)P.has(L)||c.push(L);for(const L of P)W.has(L)||g.push(L);return{removed:c,added:g}}function M(W,P){const c=[],g=[];for(const[L,_]of W)P.has(L)||c.push(_);for(const[L,_]of P)W.has(L)||g.push(_);return{removed:c,added:g}}function O(W,P){const c=new Set;for(const g of P)W.has(g)&&c.add(g);return c}}),define(de[26],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=z,e.$Wh=M,e.$Xh=O;function C(W){return(P,c,g)=>{let L=null,_=null;if(typeof g.value=="function"?(L="value",_=g.value):typeof g.get=="function"&&(L="get",_=g.get),!_)throw new Error("not supported");g[L]=W(_,c)}}function z(W,P,c){let g=null,L=null;if(typeof c.value=="function"?(g="value",L=c.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(g="get",L=c.get),!L)throw new Error("not supported");const _=`$memoize$${P}`;c[g]=function(...T){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,T)}),this[_]}}function M(W,P,c){return C((g,L)=>{const _=`$debounce$${L}`,T=`$debounce$result$${L}`;return function(...U){this[T]||(this[T]=c?c():void 0),clearTimeout(this[_]),P&&(this[T]=P(this[T],...U),U=[this[T]]),this[_]=setTimeout(()=>{g.apply(this,U),this[T]=c?c():void 0},W)}})}function O(W,P,c){return C((g,L)=>{const _=`$throttle$timer$${L}`,T=`$throttle$result$${L}`,U=`$throttle$lastRun$${L}`,u=`$throttle$pending$${L}`;return function(...l){if(this[T]||(this[T]=c?c():void 0),(this[U]===null||this[U]===void 0)&&(this[U]=-Number.MAX_VALUE),P&&(this[T]=P(this[T],...l)),this[u])return;const D=this[U]+W;D<=Date.now()?(this[U]=Date.now(),g.apply(this,[this[T]]),this[T]=c?c():void 0):(this[u]=!0,this[_]=setTimeout(()=>{this[u]=!1,this[U]=Date.now(),g.apply(this,[this[T]]),this[T]=c?c():void 0},D-Date.now()))}})}}),define(de[3],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=z,e.$Z=M,e.$1=O,e.$2=W,e.$3=P,e.$4=g,e.$6=_,e.$7=T,e.$8=U,e.$0=l;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?I.isErrorNoTelemetry(t)?new I(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(n=>{n(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=C,e.$X=new C;function z(i){e.$X.setUnexpectedErrorHandler(i)}function M(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function O(i){g(i)||e.$X.onUnexpectedError(i)}function W(i){g(i)||e.$X.onUnexpectedExternalError(i)}function P(i){if(i instanceof Error){const{name:t,message:n}=i,b=i.stacktrace||i.stack;return{$isError:!0,name:t,message:n,stack:b,noTelemetry:I.isErrorNoTelemetry(i)}}return i}const c="Canceled";function g(i){return i instanceof L?!0:i instanceof Error&&i.name===c&&i.message===c}class L extends Error{constructor(){super(c),this.name=this.message}}e.$5=L;function _(){const i=new Error(c);return i.name=i.message,i}function T(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function U(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class u extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=u;function l(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class D extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=D;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=$;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=S;class I extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof I)return t;const n=new I;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=I;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$cb=s}),define(de[17],$e([0,1,3,24]),function(le,e,C,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=M,e.$tb=O,e.$ub=W,e.$vb=P,e.$wb=c,e.$xb=g,e.$yb=L,e.$zb=_,e.$Ab=T,e.$Bb=U,e.$Cb=u,e.$Db=l,e.$Eb=D,e.top=$,e.$Gb=S,e.$Hb=s,e.$Ib=i,e.$Jb=t,e.$Kb=n,e.$Lb=b,e.$Mb=w,e.$Nb=m,e.$Ob=r,e.$Pb=A,e.$Qb=j,e.$Rb=Z,e.$Sb=v,e.$Tb=h,e.$Ub=a,e.$Vb=p,e.$Wb=R,e.$Xb=x,e.$Yb=ue,e.$Zb=ce,e.$1b=H,e.$2b=X,e.$3b=te,e.$4b=ne,e.$5b=N,e.$6b=y,e.$7b=ie,e.$8b=oe,e.$$b=ve;function M(k,F=0){return k[k.length-(1+F)]}function O(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}function W(k,F,d=(o,E)=>o===E){if(k===F)return!0;if(!k||!F||k.length!==F.length)return!1;for(let o=0,E=k.length;o<E;o++)if(!d(k[o],F[o]))return!1;return!0}function P(k,F){const d=k.length-1;F<d&&(k[F]=k[d]),k.pop()}function c(k,F,d){return g(k.length,o=>d(k[o],F))}function g(k,F){let d=0,o=k-1;for(;d<=o;){const E=(d+o)/2|0,B=F(E);if(B<0)d=E+1;else if(B>0)o=E-1;else return E}return-(d+1)}function L(k,F,d){if(k=k|0,k>=F.length)throw new TypeError("invalid index");const o=F[Math.floor(F.length*Math.random())],E=[],B=[],G=[];for(const J of F){const Y=d(J,o);Y<0?E.push(J):Y>0?B.push(J):G.push(J)}return k<E.length?L(k,E,d):k<E.length+G.length?G[0]:L(k-(E.length+G.length),B,d)}function _(k,F){const d=[];let o;for(const E of k.slice(0).sort(F))!o||F(o[0],E)!==0?(o=[E],d.push(o)):o.push(E);return d}function*T(k,F){let d,o;for(const E of k)o!==void 0&&F(o,E)?d.push(E):(d&&(yield d),d=[E]),o=E;d&&(yield d)}function U(k,F){for(let d=0;d<=k.length;d++)F(d===0?void 0:k[d-1],d===k.length?void 0:k[d])}function u(k,F){for(let d=0;d<k.length;d++)F(d===0?void 0:k[d-1],k[d],d+1===k.length?void 0:k[d+1])}function l(k,F,d){const o=[];function E(J,Y,se){if(Y===0&&se.length===0)return;const re=o[o.length-1];re&&re.start+re.deleteCount===J?(re.deleteCount+=Y,re.toInsert.push(...se)):o.push({start:J,deleteCount:Y,toInsert:se})}let B=0,G=0;for(;;){if(B===k.length){E(B,0,F.slice(G));break}if(G===F.length){E(B,k.length-B,[]);break}const J=k[B],Y=F[G],se=d(J,Y);se===0?(B+=1,G+=1):se<0?(E(B,1,[]),B+=1):se>0&&(E(B,0,[Y]),G+=1)}return o}function D(k,F,d){const o=l(k,F,d),E=[],B=[];for(const G of o)E.push(...k.slice(G.start,G.start+G.deleteCount)),B.push(...G.toInsert);return{removed:E,added:B}}function $(k,F,d){if(d===0)return[];const o=k.slice(0,d).sort(F);return I(k,F,o,d,k.length),o}function S(k,F,d,o,E){return d===0?Promise.resolve([]):new Promise((B,G)=>{(async()=>{const J=k.length,Y=k.slice(0,d).sort(F);for(let se=d,re=Math.min(d+o,J);se<J;se=re,re=Math.min(re+o,J)){if(se>d&&await new Promise(he=>setTimeout(he)),E&&E.isCancellationRequested)throw new C.$5;I(k,F,Y,se,re)}return Y})().then(B,G)})}function I(k,F,d,o,E){for(const B=d.length;o<E;o++){const G=k[o];if(F(G,d[B-1])<0){d.pop();const J=(0,z.$kb)(d,Y=>F(G,Y)<0);d.splice(J,0,G)}}}function s(k){return k.filter(F=>!!F)}function i(k){let F=0;for(let d=0;d<k.length;d++)k[d]&&(k[F]=k[d],F+=1);k.length=F}function t(k,F,d){k.splice(d,0,k.splice(F,1)[0])}function n(k){return!Array.isArray(k)||k.length===0}function b(k){return Array.isArray(k)&&k.length>0}function w(k,F=d=>d){const d=new Set;return k.filter(o=>{const E=F(o);return d.has(E)?!1:(d.add(E),!0)})}function m(k){const F=new Set;return d=>{const o=k(d);return F.has(o)?!1:(F.add(o),!0)}}function r(k,F){return k.length>0?k[0]:F}function A(k,F){return k.length>0?k[k.length-1]:F}function j(k,F,d=(o,E)=>o===E){let o=0;for(let E=0,B=Math.min(k.length,F.length);E<B&&d(k[E],F[E]);E++)o++;return o}function Z(k){return[].concat(...k)}function v(k,F){let d=typeof F=="number"?k:0;typeof F=="number"?d=k:(d=0,F=k);const o=[];if(d<=F)for(let E=d;E<F;E++)o.push(E);else for(let E=d;E>F;E--)o.push(E);return o}function h(k,F,d){return k.reduce((o,E)=>(o[F(E)]=d?d(E):E,o),Object.create(null))}function a(k,F){return k.push(F),()=>p(k,F)}function p(k,F){const d=k.indexOf(F);if(d>-1)return k.splice(d,1),F}function R(k,F,d){const o=k.slice(0,F),E=k.slice(F);return o.concat(d,E)}function x(k,F){let d;if(typeof F=="number"){let o=F;d=()=>{const E=Math.sin(o++)*179426549;return E-Math.floor(E)}}else d=Math.random;for(let o=k.length-1;o>0;o-=1){const E=Math.floor(d()*(o+1)),B=k[o];k[o]=k[E],k[E]=B}}function ue(k,F){const d=k.indexOf(F);d>-1&&(k.splice(d,1),k.unshift(F))}function ce(k,F){const d=k.indexOf(F);d>-1&&(k.splice(d,1),k.push(F))}function H(k,F){for(const d of F)k.push(d)}function X(k,F){return Array.isArray(k)?k.map(F):F(k)}function te(k){return Array.isArray(k)?k:[k]}function ne(k){return k[Math.floor(Math.random()*k.length)]}function N(k,F,d){const o=V(k,F),E=k.length,B=d.length;k.length=E+B;for(let G=E-1;G>=o;G--)k[G+B]=k[G];for(let G=0;G<B;G++)k[G+o]=d[G]}function y(k,F,d,o){const E=V(k,F);let B=k.splice(E,d);return B===void 0&&(B=[]),N(k,E,o),B}function V(k,F){return F<0?Math.max(F+k.length,0):Math.min(F,k.length)}var K;(function(k){function F(B){return B<0}k.isLessThan=F;function d(B){return B<=0}k.isLessThanOrEqual=d;function o(B){return B>0}k.isGreaterThan=o;function E(B){return B===0}k.isNeitherLessOrGreaterThan=E,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(K||(e.CompareResult=K={}));function ie(k,F){return(d,o)=>F(k(d),k(o))}function oe(...k){return(F,d)=>{for(const o of k){const E=o(F,d);if(!K.isNeitherLessOrGreaterThan(E))return E}return K.neitherLessOrGreaterThan}}const ge=(k,F)=>k-F;e.$9b=ge;const ae=(k,F)=>(0,e.$9b)(k?1:0,F?1:0);e.$0b=ae;function ve(k){return(F,d)=>-k(F,d)}class be{constructor(F){this.g=F,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(F){let d=this.c;for(;d<this.g.length&&F(this.g[d]);)d++;const o=d===this.c?null:this.g.slice(this.c,d);return this.c=d,o}takeFromEndWhile(F){let d=this.d;for(;d>=0&&F(this.g[d]);)d--;const o=d===this.d?null:this.g.slice(d+1,this.d+1);return this.d=d,o}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const F=this.g[this.c];return this.c++,F}removeLast(){const F=this.g[this.d];return this.d--,F}takeCount(F){const d=this.g.slice(this.c,this.c+F);return this.c+=F,d}}e.$_b=be;class me{static{this.empty=new me(F=>{})}constructor(F){this.iterate=F}forEach(F){this.iterate(d=>(F(d),!0))}toArray(){const F=[];return this.iterate(d=>(F.push(d),!0)),F}filter(F){return new me(d=>this.iterate(o=>F(o)?d(o):!0))}map(F){return new me(d=>this.iterate(o=>d(F(o))))}some(F){let d=!1;return this.iterate(o=>(d=F(o),!d)),d}findFirst(F){let d;return this.iterate(o=>F(o)?(d=o,!1):!0),d}findLast(F){let d;return this.iterate(o=>(F(o)&&(d=o),!0)),d}findLastMaxBy(F){let d,o=!0;return this.iterate(E=>((o||K.isGreaterThan(F(E,d)))&&(o=!1,d=E),!0)),d}}e.$ac=me;class Ce{constructor(F){this.c=F}static createSortPermutation(F,d){const o=Array.from(F.keys()).sort((E,B)=>d(F[E],F[B]));return new Ce(o)}apply(F){return F.map((d,o)=>F[this.c[o]])}inverse(){const F=this.c.slice();for(let d=0;d<this.c.length;d++)F[this.c[d]]=d;return new Ce(F)}}e.$bc=Ce}),define(de[18],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=C;function C(z,M){const O=this;let W=!1,P;return function(){if(W)return P;if(W=!0,M)try{P=z.apply(O,arguments)}finally{M()}else P=z.apply(O,arguments);return P}}}),define(de[27],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(z){function M(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}z.is=M;const O=Object.freeze([]);function W(){return O}z.empty=W;function*P(t){yield t}z.single=P;function c(t){return M(t)?t:P(t)}z.wrap=c;function g(t){return t||O}z.from=g;function*L(t){for(let n=t.length-1;n>=0;n--)yield t[n]}z.reverse=L;function _(t){return!t||t[Symbol.iterator]().next().done===!0}z.isEmpty=_;function T(t){return t[Symbol.iterator]().next().value}z.first=T;function U(t,n){for(const b of t)if(n(b))return!0;return!1}z.some=U;function u(t,n){for(const b of t)if(n(b))return b}z.find=u;function*l(t,n){for(const b of t)n(b)&&(yield b)}z.filter=l;function*D(t,n){let b=0;for(const w of t)yield n(w,b++)}z.map=D;function*$(...t){for(const n of t)yield*n}z.concat=$;function S(t,n,b){let w=b;for(const m of t)w=n(w,m);return w}z.reduce=S;function*I(t,n,b=t.length){for(n<0&&(n+=t.length),b<0?b+=t.length:b>t.length&&(b=t.length);n<b;n++)yield t[n]}z.slice=I;function s(t,n=Number.POSITIVE_INFINITY){const b=[];if(n===0)return[b,t];const w=t[Symbol.iterator]();for(let m=0;m<n;m++){const r=w.next();if(r.done)return[b,z.empty()];b.push(r.value)}return[b,{[Symbol.iterator](){return w}}]}z.consume=s;async function i(t){const n=[];for await(const b of t)n.push(b);return Promise.resolve(n)}z.asyncToArray=i})(C||(e.Iterable=C={}))}),define(de[12],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class C{constructor(M){this.d=M,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(M){this.c=M}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=C}),define(de[28],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class C{static{this.Undefined=new C(void 0)}constructor(O){this.element=O,this.next=C.Undefined,this.prev=C.Undefined}}class z{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let O=this.a;for(;O!==C.Undefined;){const W=O.next;O.prev=C.Undefined,O.next=C.Undefined,O=W}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,W){const P=new C(O);if(this.a===C.Undefined)this.a=P,this.b=P;else if(W){const g=this.b;this.b=P,P.prev=g,g.next=P}else{const g=this.a;this.a=P,P.next=g,g.prev=P}this.c+=1;let c=!1;return()=>{c||(c=!0,this.e(P))}}shift(){if(this.a!==C.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==C.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==C.Undefined&&O.next!==C.Undefined){const W=O.prev;W.next=O.next,O.next.prev=W}else O.prev===C.Undefined&&O.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):O.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):O.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==C.Undefined;)yield O.element,O=O.next}}e.$5c=z}),define(de[19],$e([0,1]),function(le,e){"use strict";var C,z,M;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=O,e.$zc=W,e.$Ac=P,e.$Ic=S;function O(I,s,i){let t=I.get(s);return t===void 0&&(t=i,I.set(s,t)),t}function W(I){const s=[];return I.forEach((i,t)=>{s.push(`${t} => ${i}`)}),`Map(${I.size}) {${s.join(", ")}}`}function P(I){const s=[];return I.forEach(i=>{s.push(i)}),`Set(${I.size}) {${s.join(", ")}}`}class c{constructor(s,i){this.uri=s,this.value=i}}function g(I){return Array.isArray(I)}class L{static{this.c=s=>s.toString()}constructor(s,i){if(this[C]="ResourceMap",s instanceof L)this.d=new Map(s.d),this.e=i??L.c;else if(g(s)){this.d=new Map,this.e=i??L.c;for(const[t,n]of s)this.set(t,n)}else this.d=new Map,this.e=s??L.c}set(s,i){return this.d.set(this.e(s),new c(s,i)),this}get(s){return this.d.get(this.e(s))?.value}has(s){return this.d.has(this.e(s))}get size(){return this.d.size}clear(){this.d.clear()}delete(s){return this.d.delete(this.e(s))}forEach(s,i){typeof i<"u"&&(s=s.bind(i));for(const[t,n]of this.d)s(n.value,n.uri,this)}*values(){for(const s of this.d.values())yield s.value}*keys(){for(const s of this.d.values())yield s.uri}*entries(){for(const s of this.d.values())yield[s.uri,s.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.d)yield[s.uri,s.value]}}e.$Bc=L;class _{constructor(s,i){this[z]="ResourceSet",!s||typeof s=="function"?this.c=new L(s):(this.c=new L(i),s.forEach(this.add,this))}get size(){return this.c.size}add(s){return this.c.set(s,s),this}clear(){this.c.clear()}delete(s){return this.c.delete(s)}forEach(s,i){this.c.forEach((t,n)=>s.call(i,n,n,this))}has(s){return this.c.has(s)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(z=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=_;var T;(function(I){I[I.None=0]="None",I[I.AsOld=1]="AsOld",I[I.AsNew=2]="AsNew"})(T||(e.Touch=T={}));class U{constructor(){this[M]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(s){return this.c.has(s)}get(s,i=0){const t=this.c.get(s);if(t)return i!==0&&this.l(t,i),t.value}set(s,i,t=0){let n=this.c.get(s);if(n)n.value=i,t!==0&&this.l(n,t);else{switch(n={key:s,value:i,next:void 0,previous:void 0},t){case 0:this.j(n);break;case 1:this.i(n);break;case 2:this.j(n);break;default:this.j(n);break}this.c.set(s,n),this.f++}return this}delete(s){return!!this.remove(s)}remove(s){const i=this.c.get(s);if(i)return this.c.delete(s),this.k(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const s=this.d;return this.c.delete(s.key),this.k(s),this.f--,s.value}forEach(s,i){const t=this.g;let n=this.d;for(;n;){if(i?s.bind(i)(n.value,n.key,this):s(n.value,n.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const s=this,i=this.g;let t=this.d;const n={[Symbol.iterator](){return n},next(){if(s.g!==i)throw new Error("LinkedMap got modified during iteration.");if(t){const b={value:t.key,done:!1};return t=t.next,b}else return{value:void 0,done:!0}}};return n}values(){const s=this,i=this.g;let t=this.d;const n={[Symbol.iterator](){return n},next(){if(s.g!==i)throw new Error("LinkedMap got modified during iteration.");if(t){const b={value:t.value,done:!1};return t=t.next,b}else return{value:void 0,done:!0}}};return n}entries(){const s=this,i=this.g;let t=this.d;const n={[Symbol.iterator](){return n},next(){if(s.g!==i)throw new Error("LinkedMap got modified during iteration.");if(t){const b={value:[t.key,t.value],done:!1};return t=t.next,b}else return{value:void 0,done:!0}}};return n}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(s){if(s>=this.size)return;if(s===0){this.clear();return}let i=this.d,t=this.size;for(;i&&t>s;)this.c.delete(i.key),i=i.next,t--;this.d=i,this.f=t,i&&(i.previous=void 0),this.g++}i(s){if(!this.d&&!this.e)this.e=s;else if(this.d)s.next=this.d,this.d.previous=s;else throw new Error("Invalid list");this.d=s,this.g++}j(s){if(!this.d&&!this.e)this.d=s;else if(this.e)s.previous=this.e,this.e.next=s;else throw new Error("Invalid list");this.e=s,this.g++}k(s){if(s===this.d&&s===this.e)this.d=void 0,this.e=void 0;else if(s===this.d){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.d=s.next}else if(s===this.e){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.e=s.previous}else{const i=s.next,t=s.previous;if(!i||!t)throw new Error("Invalid list");i.previous=t,t.next=i}s.next=void 0,s.previous=void 0,this.g++}l(s,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(s===this.d)return;const t=s.next,n=s.previous;s===this.e?(n.next=void 0,this.e=n):(t.previous=n,n.next=t),s.previous=void 0,s.next=this.d,this.d.previous=s,this.d=s,this.g++}else if(i===2){if(s===this.e)return;const t=s.next,n=s.previous;s===this.d?(t.previous=void 0,this.d=t):(t.previous=n,n.next=t),s.next=void 0,s.previous=this.e,this.e.next=s,this.e=s,this.g++}}}toJSON(){const s=[];return this.forEach((i,t)=>{s.push([t,i])}),s}fromJSON(s){this.clear();for(const[i,t]of s)this.set(i,t)}}e.$Dc=U;class u extends U{constructor(s,i=1){super(),this.m=s,this.n=Math.min(Math.max(0,i),1)}get limit(){return this.m}set limit(s){this.m=s,this.o()}get ratio(){return this.n}set ratio(s){this.n=Math.min(Math.max(0,s),1),this.o()}get(s,i=2){return super.get(s,i)}peek(s){return super.get(s,0)}set(s,i){return super.set(s,i,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=u;class l{constructor(){this.c=new Map}add(s){return this.c.set(s,(this.c.get(s)||0)+1),this}delete(s){let i=this.c.get(s)||0;return i===0?!1:(i--,i===0?this.c.delete(s):this.c.set(s,i),!0)}has(s){return this.c.has(s)}}e.$Fc=l;class D{constructor(s){if(this.c=new Map,this.d=new Map,s)for(const[i,t]of s)this.set(i,t)}clear(){this.c.clear(),this.d.clear()}set(s,i){this.c.set(s,i),this.d.set(i,s)}get(s){return this.c.get(s)}getKey(s){return this.d.get(s)}delete(s){const i=this.c.get(s);return i===void 0?!1:(this.c.delete(s),this.d.delete(i),!0)}forEach(s,i){this.c.forEach((t,n)=>{s.call(i,t,n,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=D;class ${constructor(){this.c=new Map}add(s,i){let t=this.c.get(s);t||(t=new Set,this.c.set(s,t)),t.add(i)}delete(s,i){const t=this.c.get(s);t&&(t.delete(i),t.size===0&&this.c.delete(s))}forEach(s,i){const t=this.c.get(s);t&&t.forEach(i)}get(s){const i=this.c.get(s);return i||new Set}}e.$Hc=$;function S(I,s){if(I===s)return!0;if(I.size!==s.size)return!1;for(const[i,t]of I)if(!s.has(i)||s.get(i)!==t)return!1;for(const[i]of s)if(!I.has(i))return!1;return!0}}),define(de[6],$e([0,1,17,25,19,18,27]),function(le,e,C,z,M,O,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=L,e.$Lc=_,e.$Mc=T,e.$Nc=l,e.$Oc=D,e.$Pc=$,e.$Qc=S,e.$Rc=I,e.$Sc=s,e.$3c=Z;const P=!1;let c=null;class g{constructor(){this.b=new Map}static{this.a=0}c(a){let p=this.b.get(a);return p||(p={parent:null,source:null,isSingleton:!1,value:a,idx:g.a++},this.b.set(a,p)),p}trackDisposable(a){const p=this.c(a);p.source||(p.source=new Error().stack)}setParent(a,p){const R=this.c(a);R.parent=p}markAsDisposed(a){this.b.delete(a)}markAsSingleton(a){this.c(a).isSingleton=!0}f(a,p){const R=p.get(a);if(R)return R;const x=a.parent?this.f(this.c(a.parent),p):a;return p.set(a,x),x}getTrackedDisposables(){const a=new Map;return[...this.b.entries()].filter(([,R])=>R.source!==null&&!this.f(R,a).isSingleton).flatMap(([R])=>R)}computeLeakingDisposables(a=10,p){let R;if(p)R=p;else{const X=new Map,te=[...this.b.values()].filter(N=>N.source!==null&&!this.f(N,X).isSingleton);if(te.length===0)return;const ne=new Set(te.map(N=>N.value));if(R=te.filter(N=>!(N.parent&&ne.has(N.parent))),R.length===0)throw new Error("There are cyclic diposable chains!")}if(!R)return;function x(X){function te(N,y){for(;N.length>0&&y.some(V=>typeof V=="string"?V===N[0]:N[0].match(V));)N.shift()}const ne=X.source.split(`
`).map(N=>N.trim().replace("at ","")).filter(N=>N!=="");return te(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const ue=new M.$Hc;for(const X of R){const te=x(X);for(let ne=0;ne<=te.length;ne++)ue.add(te.slice(0,ne).join(`
`),X)}R.sort((0,C.$7b)(X=>X.idx,C.$9b));let ce="",H=0;for(const X of R.slice(0,a)){H++;const te=x(X),ne=[];for(let N=0;N<te.length;N++){let y=te[N];y=`(shared with ${ue.get(te.slice(0,N+1).join(`
`)).size}/${R.length} leaks) at ${y}`;const K=ue.get(te.slice(0,N).join(`
`)),ie=(0,z.$K)([...K].map(oe=>x(oe)[N]),oe=>oe);delete ie[te[N]];for(const[oe,ge]of Object.entries(ie))ne.unshift(`    - stacktraces of ${ge.length} other leaks continue with ${oe}`);ne.unshift(y)}ce+=`


==================== Leaking disposable ${H}/${R.length}: ${X.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return R.length>a&&(ce+=`


... and ${R.length-a} more leaking disposables

`),{leaks:R,details:ce}}}e.$Jc=g;function L(h){c=h}if(P){const h="__is_disposable_tracked__";L(new class{trackDisposable(a){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[h]||console.log(p)},3e3)}setParent(a,p){if(a&&a!==t.None)try{a[h]=!0}catch{}}markAsDisposed(a){if(a&&a!==t.None)try{a[h]=!0}catch{}}markAsSingleton(a){}})}function _(h){return c?.trackDisposable(h),h}function T(h){c?.markAsDisposed(h)}function U(h,a){c?.setParent(h,a)}function u(h,a){if(c)for(const p of h)c.setParent(p,a)}function l(h){return c?.markAsSingleton(h),h}function D(h){return typeof h=="object"&&h!==null&&typeof h.dispose=="function"&&h.dispose.length===0}function $(h){if(W.Iterable.is(h)){const a=[];for(const p of h)if(p)try{p.dispose()}catch(R){a.push(R)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}function S(h){for(const a of h)D(a)&&a.dispose();return[]}function I(...h){const a=s(()=>$(h));return u(h,a),a}function s(h){const a=_({dispose:(0,O.$db)(()=>{T(a),h()})});return a}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,_(this)}dispose(){this.g||(T(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return U(a,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(a),a}delete(a){if(a){if(a===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(a),a.dispose()}}deleteAndLeak(a){a&&this.f.has(a)&&(this.f.delete(a),U(a,null))}}e.$Tc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,_(this),U(this.q,this)}dispose(){T(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.$Uc=t;class n{constructor(){this.b=!1,_(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&U(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,T(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&U(a,null),a}}e.$Vc=n;class b{constructor(a){this.a=new n,this.b=!1,this.a.value=a}get value(){return this.a.value}set value(a){this.b||a===this.a.value||(this.a.value=a)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=b;class w{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=w;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(a){let p=a;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,T(this))},this}}e.$Yc=m;class r{constructor(){this.a=new Map}acquire(a,...p){let R=this.a.get(a);R||(R={counter:0,object:this.b(a,...p)},this.a.set(a,R));const{object:x}=R,ue=(0,O.$db)(()=>{--R.counter===0&&(this.c(a,R.object),this.a.delete(a))});return R.counter++,{object:x,dispose:ue}}}e.$Zc=r;class A{constructor(a){this.a=a}async acquire(a,...p){const R=this.a.acquire(a,...p);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(x){throw R.dispose(),x}}}e.$1c=A;class j{constructor(a){this.object=a}dispose(){}}e.$2c=j;function Z(h){const a=new i;try{h(a)}finally{a.dispose()}}class v{constructor(){this.a=new Map,this.b=!1,_(this)}dispose(){T(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get size(){return this.a.size}get(a){return this.a.get(a)}set(a,p,R=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),R||this.a.get(a)?.dispose(),this.a.set(a,p)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=v}),define(de[29],$e([0,1,19]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=void 0,e.$9l=M,e.$0l=W;const z=new C.$Ec(1e4);function M(g){return c(g,"NFC",z)}const O=new C.$Ec(1e4);function W(g){return c(g,"NFD",O)}const P=/[^\u0000-\u0080]/;function c(g,L,_){if(!g)return g;const T=_.get(g);if(T)return T;let U;return P.test(g)?U=g.normalize(L):U=g,_.set(g,U),U}e.$$l=function(){const g=/[\u0300-\u036f]/g;return function(L){return W(L).replace(g,"")}}()}),define(de[30],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class z{static create(O){return new z(O)}constructor(O){this.c=C&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$0d=z}),define(de[9],$e([0,1,3,18,6,28,30]),function(le,e,C,z,M,O,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$_d=e.Event=void 0,e.$ae=U;const P=!1,c=!1,g=!1;var L;(function(p){p.None=()=>M.$Uc.None;function R(J){if(g){const{onDidAddListener:Y}=J,se=l.create();let re=0;J.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),se.print()),Y?.()}}}function x(J,Y){return K(J,()=>{},0,void 0,!0,void 0,Y)}p.defer=x;function ue(J){return(Y,se=null,re)=>{let he=!1,we;return we=J(Ae=>{if(!he)return we?we.dispose():he=!0,Y.call(se,Ae)},null,re),he&&we.dispose(),we}}p.once=ue;function ce(J,Y,se){return y((re,he=null,we)=>J(Ae=>re.call(he,Y(Ae)),null,we),se)}p.map=ce;function H(J,Y,se){return y((re,he=null,we)=>J(Ae=>{Y(Ae),re.call(he,Ae)},null,we),se)}p.forEach=H;function X(J,Y,se){return y((re,he=null,we)=>J(Ae=>Y(Ae)&&re.call(he,Ae),null,we),se)}p.filter=X;function te(J){return J}p.signal=te;function ne(...J){return(Y,se=null,re)=>{const he=(0,M.$Rc)(...J.map(we=>we(Ae=>Y.call(se,Ae))));return V(he,re)}}p.any=ne;function N(J,Y,se,re){let he=se;return ce(J,we=>(he=Y(he,we),he),re)}p.reduce=N;function y(J,Y){let se;const re={onWillAddFirstListener(){se=J(he.fire,he)},onDidRemoveLastListener(){se?.dispose()}};Y||R(re);const he=new i(re);return Y?.add(he),he.event}function V(J,Y){return Y instanceof Array?Y.push(J):Y&&Y.add(J),J}function K(J,Y,se=100,re=!1,he=!1,we,Ae){let Ee,Pe,je,Oe=0,Re;const Fe={leakWarningThreshold:we,onWillAddFirstListener(){Ee=J(We=>{Oe++,Pe=Y(Pe,We),re&&!je&&(Ne.fire(Pe),Pe=void 0),Re=()=>{const qe=Pe;Pe=void 0,je=void 0,(!re||Oe>1)&&Ne.fire(qe),Oe=0},typeof se=="number"?(clearTimeout(je),je=setTimeout(Re,se)):je===void 0&&(je=0,queueMicrotask(Re))})},onWillRemoveListener(){he&&Oe>0&&Re?.()},onDidRemoveLastListener(){Re=void 0,Ee.dispose()}};Ae||R(Fe);const Ne=new i(Fe);return Ae?.add(Ne),Ne.event}p.debounce=K;function ie(J,Y=0,se){return p.debounce(J,(re,he)=>re?(re.push(he),re):[he],Y,void 0,!0,void 0,se)}p.accumulate=ie;function oe(J,Y=(re,he)=>re===he,se){let re=!0,he;return X(J,we=>{const Ae=re||!Y(we,he);return re=!1,he=we,Ae},se)}p.latch=oe;function ge(J,Y,se){return[p.filter(J,Y,se),p.filter(J,re=>!Y(re),se)]}p.split=ge;function ae(J,Y=!1,se=[],re){let he=se.slice(),we=J(Pe=>{he?he.push(Pe):Ee.fire(Pe)});re&&re.add(we);const Ae=()=>{he?.forEach(Pe=>Ee.fire(Pe)),he=null},Ee=new i({onWillAddFirstListener(){we||(we=J(Pe=>Ee.fire(Pe)),re&&re.add(we))},onDidAddFirstListener(){he&&(Y?setTimeout(Ae):Ae())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return re&&re.add(Ee),Ee.event}p.buffer=ae;function ve(J,Y){return(re,he,we)=>{const Ae=Y(new me);return J(function(Ee){const Pe=Ae.evaluate(Ee);Pe!==be&&re.call(he,Pe)},void 0,we)}}p.chain=ve;const be=Symbol("HaltChainable");class me{constructor(){this.f=[]}map(Y){return this.f.push(Y),this}forEach(Y){return this.f.push(se=>(Y(se),se)),this}filter(Y){return this.f.push(se=>Y(se)?se:be),this}reduce(Y,se){let re=se;return this.f.push(he=>(re=Y(re,he),re)),this}latch(Y=(se,re)=>se===re){let se=!0,re;return this.f.push(he=>{const we=se||!Y(he,re);return se=!1,re=he,we?he:be}),this}evaluate(Y){for(const se of this.f)if(Y=se(Y),Y===be)break;return Y}}function Ce(J,Y,se=re=>re){const re=(...Ee)=>Ae.fire(se(...Ee)),he=()=>J.on(Y,re),we=()=>J.removeListener(Y,re),Ae=new i({onWillAddFirstListener:he,onDidRemoveLastListener:we});return Ae.event}p.fromNodeEventEmitter=Ce;function k(J,Y,se=re=>re){const re=(...Ee)=>Ae.fire(se(...Ee)),he=()=>J.addEventListener(Y,re),we=()=>J.removeEventListener(Y,re),Ae=new i({onWillAddFirstListener:he,onDidRemoveLastListener:we});return Ae.event}p.fromDOMEventEmitter=k;function F(J){return new Promise(Y=>ue(J)(Y))}p.toPromise=F;function d(J){const Y=new i;return J.then(se=>{Y.fire(se)},()=>{Y.fire(void 0)}).finally(()=>{Y.dispose()}),Y.event}p.fromPromise=d;function o(J,Y,se){return Y(se),J(re=>Y(re))}p.runAndSubscribe=o;class E{constructor(Y,se){this._observable=Y,this.f=0,this.g=!1;const re={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};se||R(re),this.emitter=new i(re),se&&se.add(this.emitter)}beginUpdate(Y){this.f++}handlePossibleChange(Y){}handleChange(Y,se){this.g=!0}endUpdate(Y){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function B(J,Y){return new E(J,Y).emitter.event}p.fromObservable=B;function G(J){return(Y,se,re)=>{let he=0,we=!1;const Ae={beginUpdate(){he++},endUpdate(){he--,he===0&&(J.reportChanges(),we&&(we=!1,Y.call(se)))},handlePossibleChange(){},handleChange(){we=!0}};J.addObserver(Ae),J.reportChanges();const Ee={dispose(){J.removeObserver(Ae)}};return re instanceof M.$Tc?re.add(Ee):Array.isArray(re)&&re.push(Ee),Ee}}p.fromObservableLight=G})(L||(e.Event=L={}));class _{static{this.all=new Set}static{this.f=0}constructor(R){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${R}_${_.f++}`,_.all.add(this)}start(R){this.g=new W.$0d,this.listenerCount=R}stop(){if(this.g){const R=this.g.elapsed();this.durations.push(R),this.elapsedOverall+=R,this.invocationCount+=1,this.g=void 0}}}e.$_d=_;let T=-1;function U(p){const R=T;return T=p,{dispose(){T=R}}}class u{constructor(R,x=Math.random().toString(18).slice(2,5)){this.threshold=R,this.name=x,this.g=0}dispose(){this.f?.clear()}check(R,x){const ue=this.threshold;if(ue<=0||x<ue)return;this.f||(this.f=new Map);const ce=this.f.get(R.value)||0;if(this.f.set(R.value,ce+1),this.g-=1,this.g<=0){this.g=ue*.5;let H,X=0;for(const[te,ne]of this.f)(!H||X<ne)&&(H=te,X=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${x} listeners already. MOST frequent listener (${X}):`),console.warn(H)}return()=>{const H=this.f.get(R.value)||0;this.f.set(R.value,H-1)}}}class l{static create(){return new l(new Error().stack??"")}constructor(R){this.value=R}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let D=0;class ${constructor(R){this.value=R,this.id=D++}}const S=2,I=(p,R)=>{if(p instanceof $)R(p);else for(let x=0;x<p.length;x++){const ue=p[x];ue&&R(ue)}},s=P?new FinalizationRegistry(p=>{typeof p=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(p))}):void 0;class i{constructor(R){this.w=0,this.f=R,this.g=T>0||this.f?.leakWarningThreshold?new u(this.f?.leakWarningThreshold??T):void 0,this.j=this.f?._profName?new _(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(c){const R=this.t;queueMicrotask(()=>{I(R,x=>x.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(R,x,ue)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),M.$Uc.None;if(this.m)return M.$Uc.None;x&&(R=R.bind(x));const ce=new $(R);let H,X;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ce.stack=l.create(),H=this.g.check(ce.stack,this.w+1)),c&&(ce.stack=X??l.create()),this.t?this.t instanceof $?(this.u??=new n,this.t=[this.t,ce]):this.t.push(ce):(this.f?.onWillAddFirstListener?.(this),this.t=ce,this.f?.onDidAddFirstListener?.(this)),this.w++;const te=(0,M.$Sc)(()=>{s?.unregister(te),H?.(),this.x(ce)});if(ue instanceof M.$Tc?ue.add(te):Array.isArray(ue)&&ue.push(te),s){const ne=new Error().stack.split(`
`).slice(2).join(`
`).trim();s.register(te,ne,te)}return te},this.q}x(R){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const x=this.t,ue=x.indexOf(R);if(ue===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,x[ue]=void 0;const ce=this.u.current===this;if(this.w*S<=x.length){let H=0;for(let X=0;X<x.length;X++)x[X]?x[H++]=x[X]:ce&&(this.u.end--,H<this.u.i&&this.u.i--);x.length=H}}y(R,x){if(!R)return;const ue=this.f?.onListenerError||C.$1;if(!ue){R.value(x);return}try{R.value(x)}catch(ce){ue(ce)}}z(R){const x=R.current.t;for(;R.i<R.end;)this.y(x[R.i++],R.value);R.reset()}fire(R){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,R);else{const x=this.u;x.enqueue(this,R,this.t.length),this.z(x)}this.j?.stop()}hasListeners(){return this.w>0}}e.$be=i;const t=()=>new n;e.$ce=t;class n{constructor(){this.i=-1,this.end=0}enqueue(R,x,ue){this.i=0,this.end=ue,this.current=R,this.value=x}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class b extends i{async fireAsync(R,x,ue){if(this.t)for(this.h||(this.h=new O.$5c),I(this.t,ce=>this.h.push([ce.value,R]));this.h.size>0&&!x.isCancellationRequested;){const[ce,H]=this.h.shift(),X=[],te={...H,token:x,waitUntil:ne=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");ue&&(ne=ue(ne,ce)),X.push(ne)}};try{ce(te)}catch(ne){(0,C.$1)(ne);continue}Object.freeze(X),await Promise.allSettled(X).then(ne=>{for(const N of ne)N.status==="rejected"&&(0,C.$1)(N.reason)})}}}e.$de=b;class w extends i{get isPaused(){return this.h!==0}constructor(R){super(R),this.h=0,this.s=new O.$5c,this.A=R?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const R=Array.from(this.s);this.s.clear(),super.fire(this.A(R))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(R){this.w&&(this.h!==0?this.s.push(R):super.fire(R))}}e.$ee=w;class m extends w{constructor(R){super(R),this.k=R.delay??100}fire(R){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(R)}}e.$fe=m;class r extends i{constructor(R){super(R),this.h=[],this.k=R?.merge}fire(R){this.hasListeners()&&(this.h.push(R),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(x=>super.fire(x)),this.h=[]}))}}e.$ge=r;class A{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(R){const x={event:R,listener:null};this.h.push(x),this.g&&this.m(x);const ue=()=>{this.g&&this.o(x);const ce=this.h.indexOf(x);this.h.splice(ce,1)};return(0,M.$Sc)((0,z.$db)(ue))}j(){this.g=!0,this.h.forEach(R=>this.m(R))}k(){this.g=!1,this.h.forEach(R=>this.o(R))}m(R){R.listener=R.event(x=>this.f.fire(x))}o(R){R.listener?.dispose(),R.listener=null}dispose(){this.f.dispose();for(const R of this.h)R.listener?.dispose();this.h=[]}}e.$he=A;class j{constructor(R,x,ue,ce){this.f=new M.$Tc;const H=this.f.add(new A),X=this.f.add(new M.$4c);function te(ne){X.set(ne,H.add(ce(ne)))}for(const ne of R)te(ne);this.f.add(x(ne=>{te(ne)})),this.f.add(ue(ne=>{X.deleteAndDispose(ne)})),this.event=H.event}dispose(){this.f.dispose()}}e.$ie=j;class Z{constructor(){this.f=[]}wrapEvent(R){return(x,ue,ce)=>R(H=>{const X=this.f[this.f.length-1];X?X.push(()=>x.call(ue,H)):x.call(ue,H)},void 0,ce)}bufferEvents(R){const x=[];this.f.push(x);const ue=R();return this.f.pop(),x.forEach(ce=>ce()),ue}}e.$je=Z;class v{constructor(){this.f=!1,this.g=L.None,this.h=M.$Uc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(R){this.g=R,this.f&&(this.h.dispose(),this.h=R(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ke=v;class h{static const(R){return new a(R)}constructor(R){this.g=R,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(R){R!==this.g&&(this.g=R,this.f.fire(void 0))}}e.$le=h;class a{constructor(R){this.value=R,this.onDidChange=L.None}}}),define(de[7],$e([0,1,9]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.CancellationToken=void 0;const z=Object.freeze(function(P,c){const g=setTimeout(P.bind(c),0);return{dispose(){clearTimeout(g)}}});var M;(function(P){function c(g){return g===P.None||g===P.Cancelled||g instanceof O?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}P.isCancellationToken=c,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:z})})(M||(e.CancellationToken=M={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?z:(this.b||(this.b=new C.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class W{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=M.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=M.None}}e.$me=W}),define(de[31],$e([0,1,7]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1e=e.$Ze=e.$Xe=void 0,e.$Ye=M;class z{constructor(c){this.b=c,this.a=null}get(){if(this.a)return this.a;const c=new C.$me,g=this.b(c.token);return this.a={promise:g,dispose:()=>{this.a=null,c.cancel(),c.dispose()}},this.a}}e.$Xe=z;function M(P){return P}class O{constructor(c,g){this.a=void 0,this.b=void 0,typeof c=="function"?(this.c=c,this.d=M):(this.c=g,this.d=c.getCacheKey)}get(c){const g=this.d(c);return this.b!==g&&(this.b=g,this.a=this.c(c)),this.a}}e.$Ze=O;class W{get cachedValues(){return this.a}constructor(c,g){this.a=new Map,this.b=new Map,typeof c=="function"?(this.c=c,this.d=M):(this.c=g,this.d=c.getCacheKey)}get(c){const g=this.d(c);if(this.b.has(g))return this.b.get(g);const L=this.c(c);return this.a.set(c,L),this.b.set(g,L),L}}e.$1e=W}),define(de[32],$e([0,1,3,6]),function(le,e,C,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=M,e.$oe=O,e.$pe=W,e.$qe=P,e.$re=g,e.$se=L,e.$te=_,e.$ue=T,e.$ve=U,e.$we=u,e.$xe=l,e.$ye=D,e.$ze=$,e.$Ae=S,e.$Be=I;function M(s){const i=s;return i?typeof i.read=="function":!1}function O(s){const i=s;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function W(s){const i=s;return i?O(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function P(s,i){return new c(s,i)}class c{constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,C.$1)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let n;switch(i){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const b=n.indexOf(t);b>=0&&n.splice(b,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(s,i){const t=[];let n;for(;(n=s.read())!==null;)t.push(n);return i(t)}function L(s,i,t){const n=[];let b;for(;(b=s.read())!==null&&n.length<t;)n.push(b);return b===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof b<"u"){const w=b;return b=void 0,w}return s.read()}}}function _(s,i){return new Promise((t,n)=>{const b=[];T(s,{onData:w=>{i&&b.push(w)},onError:w=>{i?n(w):t(void 0)},onEnd:()=>{t(i?i(b):void 0)}})})}function T(s,i,t){s.on("error",n=>{t?.isCancellationRequested||i.onError(n)}),s.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),s.on("data",n=>{t?.isCancellationRequested||i.onData(n)})}function U(s,i){return new Promise((t,n)=>{const b=new z.$Tc,w=[],m=j=>{if(w.push(j),w.length>i)return b.dispose(),s.pause(),t({stream:s,buffer:w,ended:!1})},r=j=>(b.dispose(),n(j)),A=()=>(b.dispose(),t({stream:s,buffer:w,ended:!0}));b.add((0,z.$Sc)(()=>s.removeListener("error",r))),s.on("error",r),b.add((0,z.$Sc)(()=>s.removeListener("end",A))),s.on("end",A),b.add((0,z.$Sc)(()=>s.removeListener("data",m))),s.on("data",m)})}function u(s,i){const t=P(i);return t.end(s),t}function l(){const s=P(()=>{throw new Error("not supported")});return s.end(),s}function D(s){let i=!1;return{read:()=>i?null:(i=!0,s)}}function $(s,i,t){const n=P(t);return T(s,{onData:b=>n.write(i.data(b)),onError:b=>n.error(i.error?i.error(b):b),onEnd:()=>n.end()}),n}function S(s,i,t){let n=!1;return{read:()=>{const b=i.read();return n?b:(n=!0,b!==null?t([s,b]):s)}}}function I(s,i,t){let n=!1;const b=P(t);return T(i,{onData:w=>n?b.write(w):(n=!0,b.write(t([s,w]))),onError:w=>b.error(w),onEnd:()=>{n||(n=!0,b.write(s)),b.end()}}),b}}),define(de[10],$e([0,1,12,32]),function(le,e,C,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=g,e.$Ee=L,e.$Fe=_,e.$Ge=T,e.$He=U,e.$Ie=u,e.$Je=l,e.$Ke=D,e.$Le=$,e.$Me=S,e.$Ne=I,e.$Oe=s,e.$Pe=i,e.$Qe=t,e.$Re=n,e.$Se=b,e.$Te=w,e.$Ue=m,e.$Ve=r,e.$We=Z;const M=typeof Buffer<"u",O=new C.$V(()=>new Uint8Array(256));let W,P;class c{static alloc(h){return M?new c(Buffer.allocUnsafe(h)):new c(new Uint8Array(h))}static wrap(h){return M&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new c(h)}static fromString(h,a){return!(a?.dontUseNodeBuffer||!1)&&M?new c(Buffer.from(h)):(W||(W=new TextEncoder),new c(W.encode(h)))}static fromByteArray(h){const a=c.alloc(h.length);for(let p=0,R=h.length;p<R;p++)a.buffer[p]=h[p];return a}static concat(h,a){if(typeof a>"u"){a=0;for(let x=0,ue=h.length;x<ue;x++)a+=h[x].byteLength}const p=c.alloc(a);let R=0;for(let x=0,ue=h.length;x<ue;x++){const ce=h[x];p.set(ce,R),R+=ce.byteLength}return p}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=c.alloc(this.byteLength);return h.set(this),h}toString(){return M?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(h,a){return new c(this.buffer.subarray(h,a))}set(h,a){if(h instanceof c)this.buffer.set(h.buffer,a);else if(h instanceof Uint8Array)this.buffer.set(h,a);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),a);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),a);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return T(this.buffer,h)}writeUInt32BE(h,a){U(this.buffer,h,a)}readUInt32LE(h){return u(this.buffer,h)}writeUInt32LE(h,a){l(this.buffer,h,a)}readUInt8(h){return D(this.buffer,h)}writeUInt8(h,a){$(this.buffer,h,a)}indexOf(h,a=0){return g(this.buffer,h instanceof c?h.buffer:h,a)}}e.$Ce=c;function g(v,h,a=0){const p=h.byteLength,R=v.byteLength;if(p===0)return 0;if(p===1)return v.indexOf(h[0]);if(p>R-a)return-1;const x=O.value;x.fill(h.length);for(let X=0;X<h.length;X++)x[h[X]]=h.length-X-1;let ue=a+h.length-1,ce=ue,H=-1;for(;ue<R;)if(v[ue]===h[ce]){if(ce===0){H=ue;break}ue--,ce--}else ue+=Math.max(h.length-ce,x[v[ue]]),ce=h.length-1;return H}function L(v,h){return v[h+0]<<0>>>0|v[h+1]<<8>>>0}function _(v,h,a){v[a+0]=h&255,h=h>>>8,v[a+1]=h&255}function T(v,h){return v[h]*2**24+v[h+1]*2**16+v[h+2]*2**8+v[h+3]}function U(v,h,a){v[a+3]=h,h=h>>>8,v[a+2]=h,h=h>>>8,v[a+1]=h,h=h>>>8,v[a]=h}function u(v,h){return v[h+0]<<0>>>0|v[h+1]<<8>>>0|v[h+2]<<16>>>0|v[h+3]<<24>>>0}function l(v,h,a){v[a+0]=h&255,h=h>>>8,v[a+1]=h&255,h=h>>>8,v[a+2]=h&255,h=h>>>8,v[a+3]=h&255}function D(v,h){return v[h]}function $(v,h,a){v[a]=h}function S(v){return z.$re(v,h=>c.concat(h))}function I(v){return z.$ye(v)}function s(v){return z.$te(v,h=>c.concat(h))}async function i(v){return v.ended?c.concat(v.buffer):c.concat([...v.buffer,await s(v.stream)])}function t(v){return z.$we(v,h=>c.concat(h))}function n(v){return z.$ze(v,{data:h=>typeof h=="string"?c.fromString(h):c.wrap(h)},h=>c.concat(h))}function b(v){return z.$qe(h=>c.concat(h),v)}function w(v,h){return z.$Ae(v,h,a=>c.concat(a))}function m(v,h){return z.$Be(v,h,a=>c.concat(a))}function r(v){let h=0,a=0,p=0;const R=new Uint8Array(Math.floor(v.length/4*3)),x=ce=>{switch(a){case 3:R[p++]=h|ce,a=0;break;case 2:R[p++]=h|ce>>>2,h=ce<<6,a=3;break;case 1:R[p++]=h|ce>>>4,h=ce<<4,a=2;break;default:h=ce<<2,a=1}};for(let ce=0;ce<v.length;ce++){const H=v.charCodeAt(ce);if(H>=65&&H<=90)x(H-65);else if(H>=97&&H<=122)x(H-97+26);else if(H>=48&&H<=57)x(H-48+52);else if(H===43||H===45)x(62);else if(H===47||H===95)x(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${v[ce]}`)}}const ue=p;for(;a>0;)x(0);return c.wrap(R).slice(0,ue)}const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function Z({buffer:v},h=!0,a=!1){const p=a?j:A;let R="";const x=v.byteLength%3;let ue=0;for(;ue<v.byteLength-x;ue+=3){const ce=v[ue+0],H=v[ue+1],X=v[ue+2];R+=p[ce>>>2],R+=p[(ce<<4|H>>>4)&63],R+=p[(H<<2|X>>>6)&63],R+=p[X&63]}if(x===1){const ce=v[ue+0];R+=p[ce>>>2],R+=p[ce<<4&63],h&&(R+="==")}else if(x===2){const ce=v[ue+0],H=v[ue+1];R+=p[ce>>>2],R+=p[(ce<<4|H>>>4)&63],R+=p[H<<2&63],h&&(R+="=")}return R}}),define(de[11],$e([0,1,31,12]),function(le,e,C,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.GraphemeBreakType=e.$Rf=e.$Kf=e.$Df=e.$Cf=void 0,e.$4e=M,e.$5e=W,e.$6e=c,e.$7e=g,e.$8e=L,e.$9e=_,e.$0e=T,e.$$e=U,e.$_e=u,e.$af=l,e.$bf=D,e.$cf=$,e.$df=S,e.$ef=I,e.$ff=s,e.$gf=i,e.$hf=t,e.$if=n,e.$jf=b,e.$kf=w,e.$lf=m,e.$mf=r,e.$nf=A,e.$of=j,e.$pf=Z,e.$qf=v,e.$rf=h,e.$sf=a,e.$tf=p,e.$uf=R,e.$vf=x,e.$wf=ue,e.$xf=ce,e.$yf=H,e.$zf=X,e.$Af=te,e.$Bf=ne,e.$Ef=K,e.$Ff=ie,e.$Gf=oe,e.$Hf=ge,e.$If=be,e.$Jf=Ce,e.$Lf=k,e.$Mf=F,e.$Nf=d,e.$Of=o,e.$Pf=B,e.$Qf=G,e.$Sf=J,e.$Tf=Y,e.$Uf=se,e.$Vf=re,e.$Wf=he,e.$Xf=we,e.$Yf=Ae,e.$Zf=Ee,e.$1f=Fe;function M(f){return!f||typeof f!="string"?!0:f.trim().length===0}const O=/{(\d+)}/g;function W(f,...q){return q.length===0?f:f.replace(O,function(Q,ee){const fe=parseInt(ee,10);return isNaN(fe)||fe<0||fe>=q.length?Q:q[fe]})}const P=/{([^}]+)}/g;function c(f,q){return Object.keys(q).length===0?f:f.replace(P,(Q,ee)=>q[ee]??Q)}function g(f){return f.replace(/[<>"'&]/g,q=>{switch(q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return q})}function L(f){return f.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}function _(f){return f.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function T(f,q){let Q=0;const ee=q.charCodeAt(0);for(let fe=f.length-1;fe>=0;fe--)f.charCodeAt(fe)===ee&&Q++;return Q}function U(f,q,Q="\u2026"){return f.length<=q?f:`${f.substr(0,q)}${Q}`}function u(f,q,Q="\u2026"){if(f.length<=q)return f;const ee=Math.ceil(q/2)-Q.length/2,fe=Math.floor(q/2)-Q.length/2;return`${f.substr(0,ee)}${Q}${f.substr(f.length-fe)}`}function l(f,q=" "){const Q=D(f,q);return $(Q,q)}function D(f,q){if(!f||!q)return f;const Q=q.length;if(Q===0||f.length===0)return f;let ee=0;for(;f.indexOf(q,ee)===ee;)ee=ee+Q;return f.substring(ee)}function $(f,q){if(!f||!q)return f;const Q=q.length,ee=f.length;if(Q===0||ee===0)return f;let fe=ee,ye=-1;for(;ye=f.lastIndexOf(q,fe-1),!(ye===-1||ye+Q!==fe);){if(ye===0)return"";fe=ye}return f.substring(0,fe)}function S(f){return f.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function I(f){return f.replace(/\*/g,"")}function s(f,q,Q={}){if(!f)throw new Error("Cannot create regex from empty string");q||(f=_(f)),Q.wholeWord&&(/\B/.test(f.charAt(0))||(f="\\b"+f),/\B/.test(f.charAt(f.length-1))||(f=f+"\\b"));let ee="";return Q.global&&(ee+="g"),Q.matchCase||(ee+="i"),Q.multiline&&(ee+="m"),Q.unicode&&(ee+="u"),new RegExp(f,ee)}function i(f){return f.source==="^"||f.source==="^$"||f.source==="$"||f.source==="^\\s*$"?!1:!!(f.exec("")&&f.lastIndex===0)}function t(f){return f.split(/\r\n|\r|\n/)}function n(f){const q=[],Q=f.split(/(\r\n|\r|\n)/);for(let ee=0;ee<Math.ceil(Q.length/2);ee++)q.push(Q[2*ee]+(Q[2*ee+1]??""));return q}function b(f){for(let q=0,Q=f.length;q<Q;q++){const ee=f.charCodeAt(q);if(ee!==32&&ee!==9)return q}return-1}function w(f,q=0,Q=f.length){for(let ee=q;ee<Q;ee++){const fe=f.charCodeAt(ee);if(fe!==32&&fe!==9)return f.substring(q,ee)}return f.substring(q,Q)}function m(f,q=f.length-1){for(let Q=q;Q>=0;Q--){const ee=f.charCodeAt(Q);if(ee!==32&&ee!==9)return Q}return-1}function r(f,q,Q){const ee=[];let fe=0;for(const ye of f.matchAll(q)){if(ee.push(f.slice(fe,ye.index)),ye.index===void 0)throw new Error("match.index should be defined");fe=ye.index+ye[0].length,ee.push(Q(ye[0],...ye.slice(1),ye.index,f,ye.groups))}return ee.push(f.slice(fe)),Promise.all(ee).then(ye=>ye.join(""))}function A(f,q){return f<q?-1:f>q?1:0}function j(f,q,Q=0,ee=f.length,fe=0,ye=q.length){for(;Q<ee&&fe<ye;Q++,fe++){const Le=f.charCodeAt(Q),ke=q.charCodeAt(fe);if(Le<ke)return-1;if(Le>ke)return 1}const Se=ee-Q,Me=ye-fe;return Se<Me?-1:Se>Me?1:0}function Z(f,q){return v(f,q,0,f.length,0,q.length)}function v(f,q,Q=0,ee=f.length,fe=0,ye=q.length){for(;Q<ee&&fe<ye;Q++,fe++){let Le=f.charCodeAt(Q),ke=q.charCodeAt(fe);if(Le===ke)continue;if(Le>=128||ke>=128)return j(f.toLowerCase(),q.toLowerCase(),Q,ee,fe,ye);a(Le)&&(Le-=32),a(ke)&&(ke-=32);const De=Le-ke;if(De!==0)return De}const Se=ee-Q,Me=ye-fe;return Se<Me?-1:Se>Me?1:0}function h(f){return f>=48&&f<=57}function a(f){return f>=97&&f<=122}function p(f){return f>=65&&f<=90}function R(f,q){return f.length===q.length&&v(f,q)===0}function x(f,q){const Q=q.length;return q.length>f.length?!1:v(f,q,0,Q)===0}function ue(f,q){const Q=Math.min(f.length,q.length);let ee;for(ee=0;ee<Q;ee++)if(f.charCodeAt(ee)!==q.charCodeAt(ee))return ee;return Q}function ce(f,q){const Q=Math.min(f.length,q.length);let ee;const fe=f.length-1,ye=q.length-1;for(ee=0;ee<Q;ee++)if(f.charCodeAt(fe-ee)!==q.charCodeAt(ye-ee))return ee;return Q}function H(f){return 55296<=f&&f<=56319}function X(f){return 56320<=f&&f<=57343}function te(f,q){return(f-55296<<10)+(q-56320)+65536}function ne(f,q,Q){const ee=f.charCodeAt(Q);if(H(ee)&&Q+1<q){const fe=f.charCodeAt(Q+1);if(X(fe))return te(ee,fe)}return ee}function N(f,q){const Q=f.charCodeAt(q-1);if(X(Q)&&q>1){const ee=f.charCodeAt(q-2);if(H(ee))return te(ee,Q)}return Q}class y{get offset(){return this.e}constructor(q,Q=0){this.c=q,this.d=q.length,this.e=Q}setOffset(q){this.e=q}prevCodePoint(){const q=N(this.c,this.e);return this.e-=q>=65536?2:1,q}nextCodePoint(){const q=ne(this.c,this.d,this.e);return this.e+=q>=65536?2:1,q}eol(){return this.e>=this.d}}e.$Cf=y;class V{get offset(){return this.c.offset}constructor(q,Q=0){this.c=new y(q,Q)}nextGraphemeLength(){const q=Oe.getInstance(),Q=this.c,ee=Q.offset;let fe=q.getGraphemeBreakType(Q.nextCodePoint());for(;!Q.eol();){const ye=Q.offset,Se=q.getGraphemeBreakType(Q.nextCodePoint());if(Pe(fe,Se)){Q.setOffset(ye);break}fe=Se}return Q.offset-ee}prevGraphemeLength(){const q=Oe.getInstance(),Q=this.c,ee=Q.offset;let fe=q.getGraphemeBreakType(Q.prevCodePoint());for(;Q.offset>0;){const ye=Q.offset,Se=q.getGraphemeBreakType(Q.prevCodePoint());if(Pe(Se,fe)){Q.setOffset(ye);break}fe=Se}return ee-Q.offset}eol(){return this.c.eol()}}e.$Df=V;function K(f,q){return new V(f,q).nextGraphemeLength()}function ie(f,q){return new V(f,q).prevGraphemeLength()}function oe(f,q){q>0&&X(f.charCodeAt(q))&&q--;const Q=q+K(f,q);return[Q-ie(f,Q),Q]}function ge(f){const q=new V(f);let Q=0;for(;!q.eol();)Q++,q.nextGraphemeLength();return Q}let ae;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function be(f){return ae||(ae=ve()),ae.test(f)}const me=/^[\t\n\r\x20-\x7E]*$/;function Ce(f){return me.test(f)}e.$Kf=/[\u2028\u2029]/;function k(f){return e.$Kf.test(f)}function F(f){return f>=11904&&f<=55215||f>=63744&&f<=64255||f>=65281&&f<=65374}function d(f){return f>=127462&&f<=127487||f===8986||f===8987||f===9200||f===9203||f>=9728&&f<=10175||f===11088||f===11093||f>=127744&&f<=128591||f>=128640&&f<=128764||f>=128992&&f<=129008||f>=129280&&f<=129535||f>=129648&&f<=129782}function o(f,q,Q=""){const ee=f.trimStart();if(ee.length<q)return ee;const fe=/\b/g;let ye=0;for(;fe.test(ee)&&!(ee.length-fe.lastIndex<q);)ye=fe.lastIndex,fe.lastIndex+=1;return ye===0?ee:Q+ee.substring(ye).trimStart()}const E=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*B(f){let q=0;for(const Q of f.matchAll(E))q!==Q.index&&(yield{isCode:!1,str:f.substring(q,Q.index)}),yield{isCode:!0,str:Q[0]},q=Q.index+Q[0].length;q!==f.length&&(yield{isCode:!1,str:f.substring(q)})}function G(f){return f&&(f=f.replace(E,"")),f}e.$Rf="\uFEFF";function J(f){return!!(f&&f.length>0&&f.charCodeAt(0)===65279)}function Y(f){return J(f)?f.substr(1):f}function se(f,q){if(!f||!q||f.length<q.length)return!1;const Q=q.length,ee=f.toLowerCase();let fe=0,ye=-1;for(;fe<Q;){const Se=ee.indexOf(q[fe],ye+1);if(Se<0)return!1;ye=Se,fe++}return!0}function re(f,q=!1){return f?(q&&(f=f.replace(/\\./g,"")),f.toLowerCase()!==f):!1}function he(f){return f.charAt(0).toUpperCase()+f.slice(1)}function we(f,q=1){if(q===0)return"";let Q=-1;do Q=f.indexOf(`
`,Q+1),q--;while(q>0&&Q>=0);return Q===-1?f:(f[Q-1]==="\r"&&Q--,f.substr(0,Q))}function Ae(f){return f=f%(2*26),f<26?String.fromCharCode(97+f):String.fromCharCode(65+f-26)}function Ee(f){return Oe.getInstance().getGraphemeBreakType(f)}function Pe(f,q){return f===0?q!==5&&q!==7:f===2&&q===3?!1:f===4||f===2||f===3||q===4||q===2||q===3?!0:!(f===8&&(q===8||q===9||q===11||q===12)||(f===11||f===9)&&(q===9||q===10)||(f===12||f===10)&&q===10||q===5||q===13||q===7||f===1||f===13&&q===14||f===6&&q===6)}var je;(function(f){f[f.Other=0]="Other",f[f.Prepend=1]="Prepend",f[f.CR=2]="CR",f[f.LF=3]="LF",f[f.Control=4]="Control",f[f.Extend=5]="Extend",f[f.Regional_Indicator=6]="Regional_Indicator",f[f.SpacingMark=7]="SpacingMark",f[f.L=8]="L",f[f.V=9]="V",f[f.T=10]="T",f[f.LV=11]="LV",f[f.LVT=12]="LVT",f[f.ZWJ=13]="ZWJ",f[f.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class Oe{static{this.c=null}static getInstance(){return Oe.c||(Oe.c=new Oe),Oe.c}constructor(){this.d=Re()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const Q=this.d,ee=Q.length/3;let fe=1;for(;fe<=ee;)if(q<Q[3*fe])fe=2*fe;else if(q>Q[3*fe+1])fe=2*fe+1;else return Q[3*fe+2];return 0}}function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(f,q){if(f===0)return 0;const Q=Ne(f,q);if(Q!==void 0)return Q;const ee=new y(q,f);return ee.prevCodePoint(),ee.offset}function Ne(f,q){const Q=new y(q,f);let ee=Q.prevCodePoint();for(;We(ee)||ee===65039||ee===8419;){if(Q.offset===0)return;ee=Q.prevCodePoint()}if(!d(ee))return;let fe=Q.offset;return fe>0&&Q.prevCodePoint()===8205&&(fe=Q.offset),fe}function We(f){return 127995<=f&&f<=127999}var qe;(function(f){f[f.zwj=8205]="zwj",f[f.emojiVariantSelector=65039]="emojiVariantSelector",f[f.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$2f="\xA0";class Te{static{this.c=new z.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$Ze({getCacheKey:JSON.stringify},q=>{function Q(De){const Ue=new Map;for(let Ie=0;Ie<De.length;Ie+=2)Ue.set(De[Ie],De[Ie+1]);return Ue}function ee(De,Ue){const Ie=new Map(De);for(const[ze,_e]of Ue)Ie.set(ze,_e);return Ie}function fe(De,Ue){if(!De)return Ue;const Ie=new Map;for(const[ze,_e]of De)Ue.has(ze)&&Ie.set(ze,_e);return Ie}const ye=this.c.value;let Se=q.filter(De=>!De.startsWith("_")&&De in ye);Se.length===0&&(Se=["_default"]);let Me;for(const De of Se){const Ue=Q(ye[De]);Me=fe(Me,Ue)}const Le=Q(ye._common),ke=ee(Le,Me);return new Te(ke)})}static getInstance(q){return Te.d.get(Array.from(q))}static{this.e=new z.$V(()=>Object.keys(Te.c.value).filter(q=>!q.startsWith("_")))}static getLocales(){return Te.e.value}constructor(q){this.f=q}isAmbiguous(q){return this.f.has(q)}getPrimaryConfusable(q){return this.f.get(q)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$3f=Te;class pe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(pe.c())),this.d}static isInvisibleCharacter(q){return pe.e().has(q)}static get codePoints(){return pe.e()}}e.$4f=pe}),define(de[33],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(de[8],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=C,e.$6f=z,e.$7f=M,e.$8f=O,e.$9f=W,e.$0f=P,e.$$f=c,e.$_f=g,e.$ag=L,e.$bg=_,e.$cg=T,e.$dg=U,e.$eg=u,e.$fg=D,e.$gg=$,e.$hg=S,e.$ig=I,e.$jg=s;function C(i){return typeof i=="string"}function z(i){return Array.isArray(i)&&i.every(t=>C(t))}function M(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function O(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function W(i){return typeof i=="number"&&!isNaN(i)}function P(i){return!!i&&typeof i[Symbol.iterator]=="function"}function c(i){return i===!0||i===!1}function g(i){return typeof i>"u"}function L(i){return!_(i)}function _(i){return g(i)||i===null}function T(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function U(i){if(_(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function u(...i){const t=[];for(let n=0;n<i.length;n++){const b=i[n];if(_(b))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(b)}return t}const l=Object.prototype.hasOwnProperty;function D(i){if(!M(i))return!1;for(const t in i)if(l.call(i,t))return!1;return!0}function $(i){return typeof i=="function"}function S(...i){return i.length>0&&i.every($)}function I(i,t){const n=Math.min(i.length,t.length);for(let b=0;b<n;b++)s(i[b],t[b])}function s(i,t){if(C(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if($(t)){try{if(i instanceof t)return}catch{}if(!_(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(de[13],$e([0,1,8]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=z,e.$Yn=M,e.$Zn=W,e.$1n=c,e.$2n=g,e.$3n=L,e.$4n=_,e.$5n=T,e.$6n=U,e.$7n=u,e.$8n=l,e.$9n=D;function z($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const S=Array.isArray($)?[]:{};return Object.entries($).forEach(([I,s])=>{S[I]=s&&typeof s=="object"?z(s):s}),S}function M($){if(!$||typeof $!="object")return $;const S=[$];for(;S.length>0;){const I=S.shift();Object.freeze(I);for(const s in I)if(O.call(I,s)){const i=I[s];typeof i=="object"&&!Object.isFrozen(i)&&!(0,C.$8f)(i)&&S.push(i)}}return $}const O=Object.prototype.hasOwnProperty;function W($,S){return P($,S,new Set)}function P($,S,I){if((0,C.$bg)($))return $;const s=S($);if(typeof s<"u")return s;if(Array.isArray($)){const i=[];for(const t of $)i.push(P(t,S,I));return i}if((0,C.$7f)($)){if(I.has($))throw new Error("Cannot clone recursive data-structure");I.add($);const i={};for(const t in $)O.call($,t)&&(i[t]=P($[t],S,I));return I.delete($),i}return $}function c($,S,I=!0){return(0,C.$7f)($)?((0,C.$7f)(S)&&Object.keys(S).forEach(s=>{s in $?I&&((0,C.$7f)($[s])&&(0,C.$7f)(S[s])?c($[s],S[s],I):$[s]=S[s]):$[s]=S[s]}),$):S}function g($,S){if($===S)return!0;if($==null||S===null||S===void 0||typeof $!=typeof S||typeof $!="object"||Array.isArray($)!==Array.isArray(S))return!1;let I,s;if(Array.isArray($)){if($.length!==S.length)return!1;for(I=0;I<$.length;I++)if(!g($[I],S[I]))return!1}else{const i=[];for(s in $)i.push(s);i.sort();const t=[];for(s in S)t.push(s);if(t.sort(),!g(i,t))return!1;for(I=0;I<i.length;I++)if(!g($[i[I]],S[i[I]]))return!1}return!0}function L($){const S=new Set;return JSON.stringify($,(I,s)=>{if((0,C.$7f)(s)||Array.isArray(s)){if(S.has(s))return"[Circular]";S.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function _($,S){const I=Object.create(null);return!$||!S||Object.keys(S).forEach(i=>{const t=$[i],n=S[i];g(t,n)||(I[i]=n)}),I}function T($,S){const I=S.toLowerCase(),s=Object.keys($).find(i=>i.toLowerCase()===I);return s?$[s]:$[S]}function U($,S){const I=Object.create(null);for(const[s,i]of Object.entries($))S(s,i)&&(I[s]=i);return I}function u($){let S=[];for(;Object.prototype!==$;)S=S.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return S}function l($){const S=[];for(const I of u($))typeof $[I]=="function"&&S.push(I);return S}function D($,S){const I=i=>function(){const t=Array.prototype.slice.call(arguments,0);return S(i,t)},s={};for(const i of $)s[i]=I(i);return s}}),define(de[34],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=void 0,e.$Mg=z;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function z(M){return C.test(M)}e.$Ng=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(P){for(let c=0;c<P.length;c++)P[c]=Math.floor(Math.random()*256);return P};const O=new Uint8Array(16),W=[];for(let P=0;P<256;P++)W.push(P.toString(16).padStart(2,"0"));return function(){M(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let c=0,g="";return g+=W[O[c++]],g+=W[O[c++]],g+=W[O[c++]],g+=W[O[c++]],g+="-",g+=W[O[c++]],g+=W[O[c++]],g+="-",g+=W[O[c++]],g+=W[O[c++]],g+="-",g+=W[O[c++]],g+=W[O[c++]],g+="-",g+=W[O[c++]],g+=W[O[c++]],g+=W[O[c++]],g+=W[O[c++]],g+=W[O[c++]],g+=W[O[c++]],g}}()}),define(de[35],$e([51,52]),function(le,e){return le.create("vs/base/common/platform",e)}),define(de[2],$e([0,1,35]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=n,e.$D=j,e.$J=Z,e.$g="en";let z=!1,M=!1,O=!1,W=!1,P=!1,c=!1,g=!1,L=!1,_=!1,T=!1,U,u=e.$g,l=e.$g,D,$;const S=globalThis;let I;typeof S.vscode<"u"&&typeof S.vscode.process<"u"?I=S.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(I=process);const s=typeof I?.versions?.electron=="string",i=s&&I?.type==="renderer";if(typeof I=="object"){z=I.platform==="win32",M=I.platform==="darwin",O=I.platform==="linux",W=O&&!!I.env.SNAP&&!!I.env.SNAP_REVISION,g=s,_=!!I.env.CI||!!I.env.BUILD_ARTIFACTSTAGINGDIRECTORY,U=e.$g,u=e.$g;const v=I.env.VSCODE_NLS_CONFIG;if(v)try{const h=JSON.parse(v),a=h.availableLanguages["*"];U=h.locale,l=h.osLocale,u=a||e.$g,D=h._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!i?($=navigator.userAgent,z=$.indexOf("Windows")>=0,M=$.indexOf("Macintosh")>=0,L=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=$.indexOf("Linux")>=0,T=$?.indexOf("Mobi")>=0,c=!0,U=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$g,u=U,l=navigator.language):console.error("Unable to resolve platform.");var t;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(t||(e.Platform=t={}));function n(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let b=0;M?b=1:z?b=3:O&&(b=2),e.$i=z,e.$j=M,e.$k=O,e.$l=W,e.$m=P,e.$n=g,e.$o=c,e.$p=c&&typeof S.importScripts=="function",e.$q=e.$p?S.origin:void 0,e.$r=L,e.$s=T,e.$t=_,e.$u=b,e.$v=$,e.$w=u;var w;(function(v){function h(){return e.$w}v.value=h;function a(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=a;function p(){return e.$w==="en"}v.isDefault=p})(w||(e.Language=w={})),e.$x=U,e.$y=l,e.$z=D,e.$A=typeof S.postMessage=="function"&&!S.importScripts,e.$B=(()=>{if(e.$A){const v=[];S.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let p=0,R=v.length;p<R;p++){const x=v[p];if(x.id===a.data.vscodeScheduleAsyncWork){v.splice(p,1),x.callback();return}}});let h=0;return a=>{const p=++h;v.push({id:p,callback:a}),S.postMessage({vscodeScheduleAsyncWork:p},"*")}}return v=>setTimeout(v)})();var m;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(m||(e.OperatingSystem=m={})),e.OS=M||L?2:z?1:3;let r=!0,A=!1;function j(){if(!A){A=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,r=new Uint16Array(v.buffer)[0]===513}return r}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function Z(v){return parseFloat(v)>=20}}),define(de[14],$e([0,1,2]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let z;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const O=M.process;z={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?z={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:z={get platform(){return C.$i?"win32":C.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=z.cwd,e.env=z.env,e.$ec=z.platform,e.$fc=z.arch}),define(de[4],$e([0,1,14]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const z=65,M=97,O=90,W=122,P=46,c=47,g=92,L=58,_=63;class T extends Error{constructor(n,b,w){let m;typeof b=="string"&&b.indexOf("not ")===0?(m="must not be",b=b.replace(/^not /,"")):m="must be";const r=n.indexOf(".")!==-1?"property":"argument";let A=`The "${n}" ${r} ${m} of type ${b}`;A+=`. Received type ${typeof w}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function U(t,n){if(t===null||typeof t!="object")throw new T(n,"Object",t)}function u(t,n){if(typeof t!="string")throw new T(n,"string",t)}const l=C.$ec==="win32";function D(t){return t===c||t===g}function $(t){return t===c}function S(t){return t>=z&&t<=O||t>=M&&t<=W}function I(t,n,b,w){let m="",r=0,A=-1,j=0,Z=0;for(let v=0;v<=t.length;++v){if(v<t.length)Z=t.charCodeAt(v);else{if(w(Z))break;Z=c}if(w(Z)){if(!(A===v-1||j===1))if(j===2){if(m.length<2||r!==2||m.charCodeAt(m.length-1)!==P||m.charCodeAt(m.length-2)!==P){if(m.length>2){const h=m.lastIndexOf(b);h===-1?(m="",r=0):(m=m.slice(0,h),r=m.length-1-m.lastIndexOf(b)),A=v,j=0;continue}else if(m.length!==0){m="",r=0,A=v,j=0;continue}}n&&(m+=m.length>0?`${b}..`:"..",r=2)}else m.length>0?m+=`${b}${t.slice(A+1,v)}`:m=t.slice(A+1,v),r=v-A-1;A=v,j=0}else Z===P&&j!==-1?++j:j=-1}return m}function s(t,n){U(n,"pathObject");const b=n.dir||n.root,w=n.base||`${n.name||""}${n.ext||""}`;return b?b===n.root?`${b}${w}`:`${b}${t}${w}`:w}e.$gc={resolve(...t){let n="",b="",w=!1;for(let m=t.length-1;m>=-1;m--){let r;if(m>=0){if(r=t[m],u(r,"path"),r.length===0)continue}else n.length===0?r=C.cwd():(r=C.env[`=${n}`]||C.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==n.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${n}\\`));const A=r.length;let j=0,Z="",v=!1;const h=r.charCodeAt(0);if(A===1)D(h)&&(j=1,v=!0);else if(D(h))if(v=!0,D(r.charCodeAt(1))){let a=2,p=a;for(;a<A&&!D(r.charCodeAt(a));)a++;if(a<A&&a!==p){const R=r.slice(p,a);for(p=a;a<A&&D(r.charCodeAt(a));)a++;if(a<A&&a!==p){for(p=a;a<A&&!D(r.charCodeAt(a));)a++;(a===A||a!==p)&&(Z=`\\\\${R}\\${r.slice(p,a)}`,j=a)}}}else j=1;else S(h)&&r.charCodeAt(1)===L&&(Z=r.slice(0,2),j=2,A>2&&D(r.charCodeAt(2))&&(v=!0,j=3));if(Z.length>0)if(n.length>0){if(Z.toLowerCase()!==n.toLowerCase())continue}else n=Z;if(w){if(n.length>0)break}else if(b=`${r.slice(j)}\\${b}`,w=v,v&&n.length>0)break}return b=I(b,!w,"\\",D),w?`${n}\\${b}`:`${n}${b}`||"."},normalize(t){u(t,"path");const n=t.length;if(n===0)return".";let b=0,w,m=!1;const r=t.charCodeAt(0);if(n===1)return $(r)?"\\":t;if(D(r))if(m=!0,D(t.charCodeAt(1))){let j=2,Z=j;for(;j<n&&!D(t.charCodeAt(j));)j++;if(j<n&&j!==Z){const v=t.slice(Z,j);for(Z=j;j<n&&D(t.charCodeAt(j));)j++;if(j<n&&j!==Z){for(Z=j;j<n&&!D(t.charCodeAt(j));)j++;if(j===n)return`\\\\${v}\\${t.slice(Z)}\\`;j!==Z&&(w=`\\\\${v}\\${t.slice(Z,j)}`,b=j)}}}else b=1;else S(r)&&t.charCodeAt(1)===L&&(w=t.slice(0,2),b=2,n>2&&D(t.charCodeAt(2))&&(m=!0,b=3));let A=b<n?I(t.slice(b),!m,"\\",D):"";return A.length===0&&!m&&(A="."),A.length>0&&D(t.charCodeAt(n-1))&&(A+="\\"),w===void 0?m?`\\${A}`:A:m?`${w}\\${A}`:`${w}${A}`},isAbsolute(t){u(t,"path");const n=t.length;if(n===0)return!1;const b=t.charCodeAt(0);return D(b)||n>2&&S(b)&&t.charCodeAt(1)===L&&D(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,b;for(let r=0;r<t.length;++r){const A=t[r];u(A,"path"),A.length>0&&(n===void 0?n=b=A:n+=`\\${A}`)}if(n===void 0)return".";let w=!0,m=0;if(typeof b=="string"&&D(b.charCodeAt(0))){++m;const r=b.length;r>1&&D(b.charCodeAt(1))&&(++m,r>2&&(D(b.charCodeAt(2))?++m:w=!1))}if(w){for(;m<n.length&&D(n.charCodeAt(m));)m++;m>=2&&(n=`\\${n.slice(m)}`)}return e.$gc.normalize(n)},relative(t,n){if(u(t,"from"),u(n,"to"),t===n)return"";const b=e.$gc.resolve(t),w=e.$gc.resolve(n);if(b===w||(t=b.toLowerCase(),n=w.toLowerCase(),t===n))return"";let m=0;for(;m<t.length&&t.charCodeAt(m)===g;)m++;let r=t.length;for(;r-1>m&&t.charCodeAt(r-1)===g;)r--;const A=r-m;let j=0;for(;j<n.length&&n.charCodeAt(j)===g;)j++;let Z=n.length;for(;Z-1>j&&n.charCodeAt(Z-1)===g;)Z--;const v=Z-j,h=A<v?A:v;let a=-1,p=0;for(;p<h;p++){const x=t.charCodeAt(m+p);if(x!==n.charCodeAt(j+p))break;x===g&&(a=p)}if(p!==h){if(a===-1)return w}else{if(v>h){if(n.charCodeAt(j+p)===g)return w.slice(j+p+1);if(p===2)return w.slice(j+p)}A>h&&(t.charCodeAt(m+p)===g?a=p:p===2&&(a=3)),a===-1&&(a=0)}let R="";for(p=m+a+1;p<=r;++p)(p===r||t.charCodeAt(p)===g)&&(R+=R.length===0?"..":"\\..");return j+=a,R.length>0?`${R}${w.slice(j,Z)}`:(w.charCodeAt(j)===g&&++j,w.slice(j,Z))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.$gc.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===g){if(n.charCodeAt(1)===g){const b=n.charCodeAt(2);if(b!==_&&b!==P)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(S(n.charCodeAt(0))&&n.charCodeAt(1)===L&&n.charCodeAt(2)===g)return`\\\\?\\${n}`;return t},dirname(t){u(t,"path");const n=t.length;if(n===0)return".";let b=-1,w=0;const m=t.charCodeAt(0);if(n===1)return D(m)?t:".";if(D(m)){if(b=w=1,D(t.charCodeAt(1))){let j=2,Z=j;for(;j<n&&!D(t.charCodeAt(j));)j++;if(j<n&&j!==Z){for(Z=j;j<n&&D(t.charCodeAt(j));)j++;if(j<n&&j!==Z){for(Z=j;j<n&&!D(t.charCodeAt(j));)j++;if(j===n)return t;j!==Z&&(b=w=j+1)}}}}else S(m)&&t.charCodeAt(1)===L&&(b=n>2&&D(t.charCodeAt(2))?3:2,w=b);let r=-1,A=!0;for(let j=n-1;j>=w;--j)if(D(t.charCodeAt(j))){if(!A){r=j;break}}else A=!1;if(r===-1){if(b===-1)return".";r=b}return t.slice(0,r)},basename(t,n){n!==void 0&&u(n,"ext"),u(t,"path");let b=0,w=-1,m=!0,r;if(t.length>=2&&S(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(b=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let A=n.length-1,j=-1;for(r=t.length-1;r>=b;--r){const Z=t.charCodeAt(r);if(D(Z)){if(!m){b=r+1;break}}else j===-1&&(m=!1,j=r+1),A>=0&&(Z===n.charCodeAt(A)?--A===-1&&(w=r):(A=-1,w=j))}return b===w?w=j:w===-1&&(w=t.length),t.slice(b,w)}for(r=t.length-1;r>=b;--r)if(D(t.charCodeAt(r))){if(!m){b=r+1;break}}else w===-1&&(m=!1,w=r+1);return w===-1?"":t.slice(b,w)},extname(t){u(t,"path");let n=0,b=-1,w=0,m=-1,r=!0,A=0;t.length>=2&&t.charCodeAt(1)===L&&S(t.charCodeAt(0))&&(n=w=2);for(let j=t.length-1;j>=n;--j){const Z=t.charCodeAt(j);if(D(Z)){if(!r){w=j+1;break}continue}m===-1&&(r=!1,m=j+1),Z===P?b===-1?b=j:A!==1&&(A=1):b!==-1&&(A=-1)}return b===-1||m===-1||A===0||A===1&&b===m-1&&b===w+1?"":t.slice(b,m)},format:s.bind(null,"\\"),parse(t){u(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const b=t.length;let w=0,m=t.charCodeAt(0);if(b===1)return D(m)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(D(m)){if(w=1,D(t.charCodeAt(1))){let a=2,p=a;for(;a<b&&!D(t.charCodeAt(a));)a++;if(a<b&&a!==p){for(p=a;a<b&&D(t.charCodeAt(a));)a++;if(a<b&&a!==p){for(p=a;a<b&&!D(t.charCodeAt(a));)a++;a===b?w=a:a!==p&&(w=a+1)}}}}else if(S(m)&&t.charCodeAt(1)===L){if(b<=2)return n.root=n.dir=t,n;if(w=2,D(t.charCodeAt(2))){if(b===3)return n.root=n.dir=t,n;w=3}}w>0&&(n.root=t.slice(0,w));let r=-1,A=w,j=-1,Z=!0,v=t.length-1,h=0;for(;v>=w;--v){if(m=t.charCodeAt(v),D(m)){if(!Z){A=v+1;break}continue}j===-1&&(Z=!1,j=v+1),m===P?r===-1?r=v:h!==1&&(h=1):r!==-1&&(h=-1)}return j!==-1&&(r===-1||h===0||h===1&&r===j-1&&r===A+1?n.base=n.name=t.slice(A,j):(n.name=t.slice(A,r),n.base=t.slice(A,j),n.ext=t.slice(r,j))),A>0&&A!==w?n.dir=t.slice(0,A-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(l){const t=/\\/g;return()=>{const n=C.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>C.cwd()})();e.$hc={resolve(...t){let n="",b=!1;for(let w=t.length-1;w>=-1&&!b;w--){const m=w>=0?t[w]:i();u(m,"path"),m.length!==0&&(n=`${m}/${n}`,b=m.charCodeAt(0)===c)}return n=I(n,!b,"/",$),b?`/${n}`:n.length>0?n:"."},normalize(t){if(u(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===c,b=t.charCodeAt(t.length-1)===c;return t=I(t,!n,"/",$),t.length===0?n?"/":b?"./":".":(b&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return u(t,"path"),t.length>0&&t.charCodeAt(0)===c},join(...t){if(t.length===0)return".";let n;for(let b=0;b<t.length;++b){const w=t[b];u(w,"path"),w.length>0&&(n===void 0?n=w:n+=`/${w}`)}return n===void 0?".":e.$hc.normalize(n)},relative(t,n){if(u(t,"from"),u(n,"to"),t===n||(t=e.$hc.resolve(t),n=e.$hc.resolve(n),t===n))return"";const b=1,w=t.length,m=w-b,r=1,A=n.length-r,j=m<A?m:A;let Z=-1,v=0;for(;v<j;v++){const a=t.charCodeAt(b+v);if(a!==n.charCodeAt(r+v))break;a===c&&(Z=v)}if(v===j)if(A>j){if(n.charCodeAt(r+v)===c)return n.slice(r+v+1);if(v===0)return n.slice(r+v)}else m>j&&(t.charCodeAt(b+v)===c?Z=v:v===0&&(Z=0));let h="";for(v=b+Z+1;v<=w;++v)(v===w||t.charCodeAt(v)===c)&&(h+=h.length===0?"..":"/..");return`${h}${n.slice(r+Z)}`},toNamespacedPath(t){return t},dirname(t){if(u(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===c;let b=-1,w=!0;for(let m=t.length-1;m>=1;--m)if(t.charCodeAt(m)===c){if(!w){b=m;break}}else w=!1;return b===-1?n?"/":".":n&&b===1?"//":t.slice(0,b)},basename(t,n){n!==void 0&&u(n,"ext"),u(t,"path");let b=0,w=-1,m=!0,r;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let A=n.length-1,j=-1;for(r=t.length-1;r>=0;--r){const Z=t.charCodeAt(r);if(Z===c){if(!m){b=r+1;break}}else j===-1&&(m=!1,j=r+1),A>=0&&(Z===n.charCodeAt(A)?--A===-1&&(w=r):(A=-1,w=j))}return b===w?w=j:w===-1&&(w=t.length),t.slice(b,w)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===c){if(!m){b=r+1;break}}else w===-1&&(m=!1,w=r+1);return w===-1?"":t.slice(b,w)},extname(t){u(t,"path");let n=-1,b=0,w=-1,m=!0,r=0;for(let A=t.length-1;A>=0;--A){const j=t.charCodeAt(A);if(j===c){if(!m){b=A+1;break}continue}w===-1&&(m=!1,w=A+1),j===P?n===-1?n=A:r!==1&&(r=1):n!==-1&&(r=-1)}return n===-1||w===-1||r===0||r===1&&n===w-1&&n===b+1?"":t.slice(n,w)},format:s.bind(null,"/"),parse(t){u(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const b=t.charCodeAt(0)===c;let w;b?(n.root="/",w=1):w=0;let m=-1,r=0,A=-1,j=!0,Z=t.length-1,v=0;for(;Z>=w;--Z){const h=t.charCodeAt(Z);if(h===c){if(!j){r=Z+1;break}continue}A===-1&&(j=!1,A=Z+1),h===P?m===-1?m=Z:v!==1&&(v=1):m!==-1&&(v=-1)}if(A!==-1){const h=r===0&&b?1:r;m===-1||v===0||v===1&&m===A-1&&m===r+1?n.base=n.name=t.slice(h,A):(n.name=t.slice(h,m),n.base=t.slice(h,A),n.ext=t.slice(m,A))}return r>0?n.dir=t.slice(0,r-1):b&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=l?e.$gc.normalize:e.$hc.normalize,e.$jc=l?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=l?e.$gc.join:e.$hc.join,e.$lc=l?e.$gc.resolve:e.$hc.resolve,e.$mc=l?e.$gc.relative:e.$hc.relative,e.$nc=l?e.$gc.dirname:e.$hc.dirname,e.$oc=l?e.$gc.basename:e.$hc.basename,e.$pc=l?e.$gc.extname:e.$hc.extname,e.$qc=l?e.$gc.format:e.$hc.format,e.$rc=l?e.$gc.parse:e.$hc.parse,e.$sc=l?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=l?e.$gc.sep:e.$hc.sep,e.$uc=l?e.$gc.delimiter:e.$hc.delimiter}),define(de[20],$e([0,1,4,2,11,8]),function(le,e,C,z,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=W,e.$lg=P,e.$mg=c,e.$ng=g,e.$og=L,e.$pg=u,e.$qg=l,e.$rg=D,e.$sg=$,e.$tg=S,e.$ug=I,e.$vg=s,e.$wg=i,e.$xg=t,e.$yg=n,e.$zg=m;function W(r){return r===47||r===92}function P(r){return r.replace(/[\\/]/g,C.$hc.sep)}function c(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}function g(r,A=C.$hc.sep){if(!r)return"";const j=r.length,Z=r.charCodeAt(0);if(W(Z)){if(W(r.charCodeAt(1))&&!W(r.charCodeAt(2))){let h=3;const a=h;for(;h<j&&!W(r.charCodeAt(h));h++);if(a!==h&&!W(r.charCodeAt(h+1))){for(h+=1;h<j;h++)if(W(r.charCodeAt(h)))return r.slice(0,h+1).replace(/[\\/]/g,A)}}return A}else if($(Z)&&r.charCodeAt(1)===58)return W(r.charCodeAt(2))?r.slice(0,2)+A:r.slice(0,2);let v=r.indexOf("://");if(v!==-1){for(v+=3;v<j;v++)if(W(r.charCodeAt(v)))return r.slice(0,v+1)}return""}function L(r){if(!z.$i||!r||r.length<5)return!1;let A=r.charCodeAt(0);if(A!==92||(A=r.charCodeAt(1),A!==92))return!1;let j=2;const Z=j;for(;j<r.length&&(A=r.charCodeAt(j),A!==92);j++);return!(Z===j||(A=r.charCodeAt(j+1),isNaN(A)||A===92))}const _=/[\\/:\*\?"<>\|]/g,T=/[\\/]/g,U=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(r,A=z.$i){const j=A?_:T;return!(!r||r.length===0||/^\s+$/.test(r)||(j.lastIndex=0,j.test(r))||A&&U.test(r)||r==="."||r===".."||A&&r[r.length-1]==="."||A&&r.length!==r.trim().length||r.length>255)}function l(r,A,j){const Z=r===A;return!j||Z?Z:!r||!A?!1:(0,M.$uf)(r,A)}function D(r,A,j,Z=C.sep){if(r===A)return!0;if(!r||!A||A.length>r.length)return!1;if(j){if(!(0,M.$vf)(r,A))return!1;if(A.length===r.length)return!0;let h=A.length;return A.charAt(A.length-1)===Z&&h--,r.charAt(h)===Z}return A.charAt(A.length-1)!==Z&&(A+=Z),r.indexOf(A)===0}function $(r){return r>=65&&r<=90||r>=97&&r<=122}function S(r,A){return z.$i&&r.endsWith(":")&&(r+=C.sep),(0,C.$jc)(r)||(r=(0,C.$kc)(A,r)),r=(0,C.$ic)(r),z.$i?(r=(0,M.$cf)(r,C.sep),r.endsWith(":")&&(r+=C.sep)):(r=(0,M.$cf)(r,C.sep),r||(r=C.sep)),r}function I(r){const A=(0,C.$ic)(r);return z.$i?r.length>3?!1:s(A)&&(r.length===2||A.charCodeAt(2)===92):A===C.$hc.sep}function s(r,A=z.$i){return A?$(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}function i(r,A=z.$i){return s(r,A)?r[0]:void 0}function t(r,A,j){return A.length>r.length?-1:r===A?0:(j&&(r=r.toLowerCase(),A=A.toLowerCase()),r.indexOf(A))}function n(r){const A=r.split(":");let j,Z,v;for(const h of A){const a=Number(h);(0,O.$9f)(a)?Z===void 0?Z=a:v===void 0&&(v=a):j=j?[j,h].join(":"):h}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:Z!==void 0?Z:void 0,column:v!==void 0?v:Z!==void 0?1:void 0}}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(r,A,j=8){let Z="";for(let h=0;h<j;h++){let a;h===0&&z.$i&&!A&&(j===3||j===4)?a=w:a=b,Z+=a.charAt(Math.floor(Math.random()*a.length))}let v;return A?v=`${A}-${Z}`:v=Z,r?(0,C.$kc)(r,v):v}}),define(de[21],$e([0,1,2]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=O,e.$im=W;var z;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(z||(e.Source=z={}));var M;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(M||(e.TerminateResponseCode=M={}));function O(P,...c){const g=c.reduce((T,U)=>(T[U]=!0,T),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(T=>!g[T]).forEach(T=>{for(let U=0;U<L.length;U++)if(T.search(L[U])!==-1){delete P[T];break}})}function W(P){P&&(delete P.DEBUG,C.$j&&delete P.DYLD_LIBRARY_PATH,C.$k&&delete P.LD_PRELOAD)}}),define(de[5],$e([0,1,4,2]),function(le,e,C,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=u,e.$xc=s;const M=/^\w[\w\d+.-]*$/,O=/^\//,W=/^\/\//;function P(w,m){if(!w.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${w.authority}", path: "${w.path}", query: "${w.query}", fragment: "${w.fragment}"}`);if(w.scheme&&!M.test(w.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(w.path){if(w.authority){if(!O.test(w.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(W.test(w.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(w,m){return!w&&!m?"file":w}function g(w,m){switch(w){case"https":case"http":case"file":m?m[0]!==_&&(m=_+m):m=_;break}return m}const L="",_="/",T=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class U{static isUri(m){return m instanceof U?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,r,A,j,Z,v=!1){typeof m=="object"?(this.scheme=m.scheme||L,this.authority=m.authority||L,this.path=m.path||L,this.query=m.query||L,this.fragment=m.fragment||L):(this.scheme=c(m,v),this.authority=r||L,this.path=g(this.scheme,A||L),this.query=j||L,this.fragment=Z||L,P(this,v))}get fsPath(){return s(this,!1)}with(m){if(!m)return this;let{scheme:r,authority:A,path:j,query:Z,fragment:v}=m;return r===void 0?r=this.scheme:r===null&&(r=L),A===void 0?A=this.authority:A===null&&(A=L),j===void 0?j=this.path:j===null&&(j=L),Z===void 0?Z=this.query:Z===null&&(Z=L),v===void 0?v=this.fragment:v===null&&(v=L),r===this.scheme&&A===this.authority&&j===this.path&&Z===this.query&&v===this.fragment?this:new D(r,A,j,Z,v)}static parse(m,r=!1){const A=T.exec(m);return A?new D(A[2]||L,b(A[4]||L),b(A[5]||L),b(A[7]||L),b(A[9]||L),r):new D(L,L,L,L,L)}static file(m){let r=L;if(z.$i&&(m=m.replace(/\\/g,_)),m[0]===_&&m[1]===_){const A=m.indexOf(_,2);A===-1?(r=m.substring(2),m=_):(r=m.substring(2,A),m=m.substring(A)||_)}return new D("file",r,m,L,L)}static from(m,r){return new D(m.scheme,m.authority,m.path,m.query,m.fragment,r)}static joinPath(m,...r){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let A;return z.$i&&m.scheme==="file"?A=U.file(C.$gc.join(s(m,!0),...r)).path:A=C.$hc.join(m.path,...r),m.with({path:A})}toString(m=!1){return i(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof U)return m;{const r=new D(m);return r._formatted=m.external??null,r._fsPath=m._sep===l?m.fsPath??null:null,r}}else return m}}e.URI=U;function u(w){return!w||typeof w!="object"?!1:typeof w.scheme=="string"&&(typeof w.authority=="string"||typeof w.authority>"u")&&(typeof w.path=="string"||typeof w.path>"u")&&(typeof w.query=="string"||typeof w.query>"u")&&(typeof w.fragment=="string"||typeof w.fragment>"u")}const l=z.$i?1:void 0;class D extends U{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(m=!1){return m?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const m={$mid:1};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=l),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const $={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function S(w,m,r){let A,j=-1;for(let Z=0;Z<w.length;Z++){const v=w.charCodeAt(Z);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||m&&v===47||r&&v===91||r&&v===93||r&&v===58)j!==-1&&(A+=encodeURIComponent(w.substring(j,Z)),j=-1),A!==void 0&&(A+=w.charAt(Z));else{A===void 0&&(A=w.substr(0,Z));const h=$[v];h!==void 0?(j!==-1&&(A+=encodeURIComponent(w.substring(j,Z)),j=-1),A+=h):j===-1&&(j=Z)}}return j!==-1&&(A+=encodeURIComponent(w.substring(j))),A!==void 0?A:w}function I(w){let m;for(let r=0;r<w.length;r++){const A=w.charCodeAt(r);A===35||A===63?(m===void 0&&(m=w.substr(0,r)),m+=$[A]):m!==void 0&&(m+=w[r])}return m!==void 0?m:w}function s(w,m){let r;return w.authority&&w.path.length>1&&w.scheme==="file"?r=`//${w.authority}${w.path}`:w.path.charCodeAt(0)===47&&(w.path.charCodeAt(1)>=65&&w.path.charCodeAt(1)<=90||w.path.charCodeAt(1)>=97&&w.path.charCodeAt(1)<=122)&&w.path.charCodeAt(2)===58?m?r=w.path.substr(1):r=w.path[1].toLowerCase()+w.path.substr(2):r=w.path,z.$i&&(r=r.replace(/\//g,"\\")),r}function i(w,m){const r=m?I:S;let A="",{scheme:j,authority:Z,path:v,query:h,fragment:a}=w;if(j&&(A+=j,A+=":"),(Z||j==="file")&&(A+=_,A+=_),Z){let p=Z.indexOf("@");if(p!==-1){const R=Z.substr(0,p);Z=Z.substr(p+1),p=R.lastIndexOf(":"),p===-1?A+=r(R,!1,!1):(A+=r(R.substr(0,p),!1,!1),A+=":",A+=r(R.substr(p+1),!1,!0)),A+="@"}Z=Z.toLowerCase(),p=Z.lastIndexOf(":"),p===-1?A+=r(Z,!1,!0):(A+=r(Z.substr(0,p),!1,!0),A+=Z.substr(p))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const p=v.charCodeAt(1);p>=65&&p<=90&&(v=`/${String.fromCharCode(p+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const p=v.charCodeAt(0);p>=65&&p<=90&&(v=`${String.fromCharCode(p+32)}:${v.substr(2)}`)}A+=r(v,!0,!1)}return h&&(A+="?",A+=r(h,!1,!1)),a&&(A+="#",A+=m?a:S(a,!1,!1)),A}function t(w){try{return decodeURIComponent(w)}catch{return w.length>3?w.substr(0,3)+t(w.substr(3)):w}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(w){return w.match(n)?w.replace(n,m=>t(m)):w}}),define(de[36],$e([0,1,5]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=z,e.$Rq=M,e.$Sq=O,e.log=P;function z(g){const L=g;return L&&typeof L.type=="string"&&typeof L.severity=="string"}function M(g){const L=[];let _;try{const T=JSON.parse(g.arguments),U=T[T.length-1];U&&U.__$stack&&(T.pop(),_=U.__$stack),L.push(...T)}catch{L.push("Unable to log remote console arguments",g.arguments)}return{args:L,stack:_}}function O(g){if(typeof g!="string")return O(M(g).stack);const L=g;if(L){const _=W(L),T=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(_||"");if(T&&T.length===4)return{uri:C.URI.file(T[1]),line:Number(T[2]),column:Number(T[3])}}}function W(g){if(!g)return g;const L=g.indexOf(`
`);return L===-1?g:g.substring(0,L)}function P(g,L){const{args:_,stack:T}=M(g),U=typeof _[0]=="string"&&_.length===1;let u=W(T);u&&(u=`(${u.trim()})`);let l=[];if(typeof _[0]=="string"?u&&U?l=[`%c[${L}] %c${_[0]} %c${u}`,c("blue"),c(""),c("grey")]:l=[`%c[${L}] %c${_[0]}`,c("blue"),c(""),..._.slice(1)]:l=[`%c[${L}]%`,c("blue"),..._],u&&!U&&l.push(u),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,l)}function c(g){return`color: ${g}`}}),define(de[37],$e([0,1,10,5]),function(le,e,C,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=M,e.$Zh=O,e.$1h=P;function M(c){return JSON.stringify(c,W)}function O(c){let g=JSON.parse(c);return g=P(g),g}function W(c,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function P(c,g=0){if(!c||g>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return z.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 17:return new Date(c.source)}if(c instanceof C.$Ce||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let L=0;L<c.length;++L)c[L]=P(c[L],g+1);else for(const L in c)Object.hasOwnProperty.call(c,L)&&(c[L]=P(c[L],g+1))}return c}}),define(de[15],$e([0,1,3,2,11,5,4]),function(le,e,C,z,M,O,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Eg=e.$Dg=e.$Cg=e.Schemas=void 0,e.$Ag=c,e.$Bg=g,e.$Fg=_;var P;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatCodeBlock="vscode-chat-code-block",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm",u.commentsInput="comment",u.codeSetting="code-setting"})(P||(e.Schemas=P={}));function c(u,l){return O.URI.isUri(u)?(0,M.$uf)(u.scheme,l):(0,M.$vf)(u,l+":")}function g(u,...l){return l.some(D=>c(u,D))}e.$Cg="vscode-tkn",e.$Dg="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l,D){this.f=_(l,D)}getServerRootPath(){return this.f}get g(){return W.$hc.join(this.f,P.vscodeRemoteResource)}set(l,D,$){this.a[l]=D,this.b[l]=$}setConnectionToken(l,D){this.c[l]=D}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(i){return C.$1(i),l}const D=l.authority;let $=this.a[D];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const S=this.b[D],I=this.c[D];let s=`path=${encodeURIComponent(l.path)}`;return typeof I=="string"&&(s+=`&${e.$Dg}=${encodeURIComponent(I)}`),O.URI.from({scheme:z.$o?this.d:P.vscodeRemoteResource,authority:`${$}:${S}`,path:this.g,query:s})}}e.$Eg=new L;function _(u,l){return W.$hc.join(l??"/",`${u.quality??"oss"}-${u.commit??"dev"}`)}e.$Gg="vs/../../extensions",e.$Hg="vs/../../node_modules",e.$Ig="vs/../../node_modules.asar",e.$Jg="vs/../../node_modules.asar.unpacked",e.$Kg="vscode-app";class T{static{this.a=e.$Kg}asBrowserUri(l){const D=this.b(l,le);return this.uriToBrowserUri(D)}uriToBrowserUri(l){return l.scheme===P.vscodeRemote?e.$Eg.rewrite(l):l.scheme===P.file&&(z.$m||z.$q===`${P.vscodeFileResource}://${T.a}`)?l.with({scheme:P.vscodeFileResource,authority:l.authority||T.a,query:null,fragment:null}):l}asFileUri(l){const D=this.b(l,le);return this.uriToFileUri(D)}uriToFileUri(l){return l.scheme===P.vscodeFileResource?l.with({scheme:P.file,authority:l.authority!==T.a?l.authority:null,query:null,fragment:null}):l}b(l,D){return O.URI.isUri(l)?l:O.URI.parse(D.toUrl(l))}}e.$Lg=new T;var U;(function(u){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(l.get("3"));const D="vscode-coi";function $(I){let s;typeof I=="string"?s=new URL(I).searchParams:I instanceof URL?s=I.searchParams:O.URI.isUri(I)&&(s=new URL(I.toString(!0)).searchParams);const i=s?.get(D);if(i)return l.get(i)}u.getHeadersFromQuery=$;function S(I,s,i){if(!globalThis.crossOriginIsolated)return;const t=s&&i?"3":i?"2":"1";I instanceof URLSearchParams?I.set(D,t):I[D]=t}u.addSearchParam=S})(U||(e.COI=U={}))}),define(de[38],$e([0,1,23,15,2,5]),function(le,e,C,z,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TD=L;class W{constructor(T,U,u){this.id=T,this.dependencies=U,this.callback=u}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(T,U,u)=>{typeof T!="string"&&(u=U,U=T,T=null),(typeof U!="object"||!Array.isArray(U))&&(u=U,U=null),this.c.push(new W(T,U,u))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(T){if(T.startsWith(window.location.origin)||T.startsWith("vscode-file://vscode-app"))return T;throw new Error(`[trusted_script_src] Invalid script url: ${T}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(T){return T}})))}async load(T){this.g();const U=await(this.a?this.i(T):this.b?this.h(T):this.j(T));if(!U)throw new Error(`Did not receive a define call from script ${T}`);if(Array.isArray(U.dependencies)&&U.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${T}. The dependencies are: ${U.dependencies.join(", ")}`);return typeof U.callback=="function"?U.callback([]):U.callback}h(T){return new Promise((U,u)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const D=()=>{l.removeEventListener("load",$),l.removeEventListener("error",S)},$=I=>{D(),U(this.c.pop())},S=I=>{D(),u(I)};l.addEventListener("load",$),l.addEventListener("error",S),this.f&&(T=this.f.createScriptURL(T)),l.setAttribute("src",T),window.document.getElementsByTagName("head")[0].appendChild(l)})}i(T){return new Promise((U,u)=>{try{this.f&&(T=this.f.createScriptURL(T)),importScripts(T),U(this.c.pop())}catch(l){u(l)}})}async j(T){try{const U=globalThis._VSCODE_NODE_MODULES.fs,u=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,D=O.URI.parse(T).fsPath,$=U.readFileSync(D).toString(),S=l.wrap($.replace(/^#!.*/,""));return new u.Script(S).runInThisContext().apply(),this.c.pop()}catch(U){throw U}}}const c=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function L(_,T,U){if(C.$T){U===void 0&&(U=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[_]&&(_=g[_]);const u=`${_}/${T}`;if(c.has(u))return c.get(u);let l;if(/^\w[\w\d+.-]*:\/\//.test(u))l=u;else{const I=`${U&&!M.$o?z.$Ig:z.$Hg}/${u}`;l=z.$Lg.asBrowserUri(I).toString(!0)}const D=P.INSTANCE.load(l);return c.set(u,D),D}else return await new Promise((u,l)=>{le([_],u,l)})}}),define(de[22],$e([0,1,20,15,4,2,11,5]),function(le,e,C,z,M,O,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0,e.$Sg=c,e.$bh=L,e.$ch=T;function c(U){return(0,P.$xc)(U,!0)}class g{constructor(u){this.a=u}compare(u,l,D=!1){return u===l?0:(0,W.$nf)(this.getComparisonKey(u,D),this.getComparisonKey(l,D))}isEqual(u,l,D=!1){return u===l?!0:!u||!l?!1:this.getComparisonKey(u,D)===this.getComparisonKey(l,D)}getComparisonKey(u,l=!1){return u.with({path:this.a(u)?u.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(u){return this.a(u)}isEqualOrParent(u,l,D=!1){if(u.scheme===l.scheme){if(u.scheme===z.Schemas.file)return C.$rg(c(u),c(l),this.a(u))&&u.query===l.query&&(D||u.fragment===l.fragment);if((0,e.$0g)(u.authority,l.authority))return C.$rg(u.path,l.path,this.a(u),"/")&&u.query===l.query&&(D||u.fragment===l.fragment)}return!1}joinPath(u,...l){return P.URI.joinPath(u,...l)}basenameOrAuthority(u){return(0,e.$2g)(u)||u.authority}basename(u){return M.$hc.basename(u.path)}extname(u){return M.$hc.extname(u.path)}dirname(u){if(u.path.length===0)return u;let l;return u.scheme===z.Schemas.file?l=P.URI.file(M.$nc(c(u))).path:(l=M.$hc.dirname(u.path),u.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),l="/")),u.with({path:l})}normalizePath(u){if(!u.path.length)return u;let l;return u.scheme===z.Schemas.file?l=P.URI.file(M.$ic(c(u))).path:l=M.$hc.normalize(u.path),u.with({path:l})}relativePath(u,l){if(u.scheme!==l.scheme||!(0,e.$0g)(u.authority,l.authority))return;if(u.scheme===z.Schemas.file){const S=M.$mc(c(u),c(l));return O.$i?C.$lg(S):S}let D=u.path||"/";const $=l.path||"/";if(this.a(u)){let S=0;for(const I=Math.min(D.length,$.length);S<I&&!(D.charCodeAt(S)!==$.charCodeAt(S)&&D.charAt(S).toLowerCase()!==$.charAt(S).toLowerCase());S++);D=$.substr(0,S)+D.substr(S)}return M.$hc.relative(D,$)}resolvePath(u,l){if(u.scheme===z.Schemas.file){const D=P.URI.file(M.$lc(c(u),l));return u.with({authority:D.authority,path:D.path})}return l=C.$mg(l),u.with({path:M.$hc.resolve(u.path,l)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,l){return u===l||u!==void 0&&l!==void 0&&(0,W.$uf)(u,l)}hasTrailingPathSeparator(u,l=M.sep){if(u.scheme===z.Schemas.file){const D=c(u);return D.length>C.$ng(D).length&&D[D.length-1]===l}else{const D=u.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,l=M.sep){return(0,e.$$g)(u,l)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,l=M.sep){let D=!1;if(u.scheme===z.Schemas.file){const $=c(u);D=$!==void 0&&$.length===C.$ng($).length&&$[$.length-1]===l}else{l="/";const $=u.path;D=$.length===1&&$.charCodeAt($.length-1)===47}return!D&&!(0,e.$$g)(u,l)?u.with({path:u.path+"/"}):u}}e.$Tg=g,e.$Ug=new g(()=>!1),e.$Vg=new g(U=>U.scheme===z.Schemas.file?!O.$k:!0),e.$Wg=new g(U=>!0),e.$Xg=e.$Ug.isEqual.bind(e.$Ug),e.$Yg=e.$Ug.isEqualOrParent.bind(e.$Ug),e.$Zg=e.$Ug.getComparisonKey.bind(e.$Ug),e.$1g=e.$Ug.basenameOrAuthority.bind(e.$Ug),e.$2g=e.$Ug.basename.bind(e.$Ug),e.$3g=e.$Ug.extname.bind(e.$Ug),e.$4g=e.$Ug.dirname.bind(e.$Ug),e.$5g=e.$Ug.joinPath.bind(e.$Ug),e.$6g=e.$Ug.normalizePath.bind(e.$Ug),e.$7g=e.$Ug.relativePath.bind(e.$Ug),e.$8g=e.$Ug.resolvePath.bind(e.$Ug),e.$9g=e.$Ug.isAbsolutePath.bind(e.$Ug),e.$0g=e.$Ug.isEqualAuthority.bind(e.$Ug),e.$$g=e.$Ug.hasTrailingPathSeparator.bind(e.$Ug),e.$_g=e.$Ug.removeTrailingPathSeparator.bind(e.$Ug),e.$ah=e.$Ug.addTrailingPathSeparator.bind(e.$Ug);function L(U,u){const l=[];for(let D=0;D<U.length;D++){const $=u(U[D]);U.some((S,I)=>I===D?!1:(0,e.$Yg)($,u(S)))||l.push(U[D])}return l}var _;(function(U){U.META_DATA_LABEL="label",U.META_DATA_DESCRIPTION="description",U.META_DATA_SIZE="size",U.META_DATA_MIME="mime";function u(l){const D=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(I=>{const[s,i]=I.split(":");s&&i&&D.set(s,i)});const S=l.path.substring(0,l.path.indexOf(";"));return S&&D.set(U.META_DATA_MIME,S),D}U.parseMetaData=u})(_||(e.DataUri=_={}));function T(U,u,l){if(u){let D=U.path;return D&&D[0]!==M.$hc.sep&&(D=M.$hc.sep+D),U.with({scheme:l,authority:u,path:D})}return U.with({scheme:l})}}),define(de[16],$e([0,1,7,3,9,6,22,2,33,12]),function(le,e,C,z,M,O,W,P,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.Promises=e.$Oh=e.$Nh=e.$Mh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0,e.$dh=L,e.$eh=_,e.$fh=T,e.$gh=U,e.$hh=u,e.$ih=l,e.$jh=D,e.$kh=$,e.$sh=r,e.$th=A,e.$uh=j,e.$vh=Z,e.$wh=v,e.$Lh=y,e.$Th=k;function L(d){return!!d&&typeof d.then=="function"}function _(d){const o=new C.$me,E=d(o.token),B=new Promise((G,J)=>{const Y=o.token.onCancellationRequested(()=>{Y.dispose(),J(new z.$5)});Promise.resolve(E).then(se=>{Y.dispose(),o.dispose(),G(se)},se=>{Y.dispose(),o.dispose(),J(se)})});return new class{cancel(){o.cancel(),o.dispose()}then(G,J){return B.then(G,J)}catch(G){return this.then(void 0,G)}finally(G){return B.finally(G)}}}function T(d,o,E){return new Promise((B,G)=>{const J=o.onCancellationRequested(()=>{J.dispose(),B(E)});d.then(B,G).finally(()=>J.dispose())})}function U(d,o){return new Promise((E,B)=>{const G=o.onCancellationRequested(()=>{G.dispose(),B(new z.$5)});d.then(E,B).finally(()=>G.dispose())})}async function u(d){let o=-1;const E=d.map((B,G)=>B.then(J=>(o=G,J)));try{return await Promise.race(E)}finally{d.forEach((B,G)=>{G!==o&&B.cancel()})}}function l(d,o,E){let B;const G=setTimeout(()=>{B?.(void 0),E?.()},o);return Promise.race([d.finally(()=>clearTimeout(G)),new Promise(J=>B=J)])}function D(d){return new Promise((o,E)=>{const B=d();L(B)?B.then(o,E):o(B)})}function $(){let d,o;return{promise:new Promise((B,G)=>{d=B,o=G}),resolve:d,reject:o}}class S{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const E=()=>{if(this.b=null,this.f)return;const B=this.queue(this.d);return this.d=null,B};this.b=new Promise(B=>{this.a.then(E,E).then(B)})}return new Promise((E,B)=>{this.b.then(E,B)})}return this.a=o(),new Promise((E,B)=>{this.a.then(G=>{this.a=null,E(G)},G=>{this.a=null,B(G)})})}dispose(){this.f=!0}}e.$lh=S;class I{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}e.$mh=I;class s{constructor(){this.a=new Map}queue(o,E){const G=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(o)===G&&this.a.delete(o)});return this.a.set(o,G),G}}e.$nh=s;const i=(d,o)=>{let E=!0;const B=setTimeout(()=>{E=!1,o()},d);return{isTriggered:()=>E,dispose:()=>{clearTimeout(B),E=!1}}},t=d=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,d())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class n{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,E=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((G,J)=>{this.d=G,this.f=J}).then(()=>{if(this.b=null,this.d=null,this.g){const G=this.g;return this.g=null,G()}}));const B=()=>{this.a=null,this.d?.(null)};return this.a=E===c.$$d?t(B):i(E,B),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new z.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$oh=n;class b{constructor(o){this.a=new n(o),this.b=new S}trigger(o,E){return this.a.trigger(()=>this.b.queue(o),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ph=b;class w{constructor(){this.a=!1,this.b=new Promise((o,E)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$qh=w;class m extends w{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}e.$rh=m;function r(d,o){return o?new Promise((E,B)=>{const G=setTimeout(()=>{J.dispose(),E()},d),J=o.onCancellationRequested(()=>{clearTimeout(G),J.dispose(),B(new z.$5)})}):_(E=>r(d,E))}function A(d,o=0,E){const B=setTimeout(()=>{d(),E&&G.dispose()},o),G=(0,O.$Sc)(()=>{clearTimeout(B),E?.deleteAndLeak(G)});return E?.add(G),G}function j(d){const o=[];let E=0;const B=d.length;function G(){return E<B?d[E++]():null}function J(Y){Y!=null&&o.push(Y);const se=G();return se?se.then(J):Promise.resolve(o)}return Promise.resolve(null).then(J)}function Z(d,o=B=>!!B,E=null){let B=0;const G=d.length,J=()=>{if(B>=G)return Promise.resolve(E);const Y=d[B++];return Promise.resolve(Y()).then(re=>o(re)?Promise.resolve(re):J())};return J()}function v(d,o=B=>!!B,E=null){if(d.length===0)return Promise.resolve(E);let B=d.length;const G=()=>{B=-1;for(const J of d)J.cancel?.()};return new Promise((J,Y)=>{for(const se of d)se.then(re=>{--B>=0&&o(re)?(G(),J(re)):B===0&&J(E)}).catch(re=>{--B>=0&&(G(),Y(re))})})}class h{constructor(o){this.a=0,this.b=!1,this.f=o,this.g=[],this.d=0,this.h=new M.$be}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(o){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((E,B)=>{this.g.push({factory:o,c:E,e:B}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const o=this.g.shift();this.d++;const E=o.factory();E.then(o.c,o.e),E.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$xh=h;class a extends h{constructor(){super(1)}}e.$yh=a;class p{constructor(){this.a=new V,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}e.$zh=p;class R{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new oe;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueSize(o,E=W.$Ug){const B=E.getComparisonKey(o);return this.a.get(B)?.size??0}queueFor(o,E,B=W.$Ug){const G=B.getComparisonKey(o);let J=this.a.get(G);if(!J){J=new a;const Y=this.f++,se=M.Event.once(J.onDrained)(()=>{J?.dispose(),this.a.delete(G),this.h(),this.d?.deleteAndDispose(Y),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(Y,se),this.a.set(G,J)}return J.queue(E)}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ah=R;class x{constructor(o,E){this.a=-1,typeof o=="function"&&typeof E=="number"&&this.setIfNotSet(o,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},E)}setIfNotSet(o,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},E))}}e.$Bh=x;class ue{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(o,E,B=globalThis){this.cancel();const G=B.setInterval(()=>{o()},E);this.d=(0,O.$Sc)(()=>{B.clearInterval(G),this.d=void 0})}dispose(){this.cancel()}}e.$Ch=ue;class ce{constructor(o,E){this.b=-1,this.a=o,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Dh=ce;class H{constructor(o,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=o,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Eh=H;class X extends ce{constructor(o,E){super(o,E),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}e.$Fh=X;class te extends O.$Uc{constructor(o,E){super(),this.g=o,this.h=E,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of o)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ce(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Gh=te,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ih=(d,o)=>{(0,P.$B)(()=>{if(E)return;const B=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let E=!1;return{dispose(){E||(E=!0)}}}:e.$Ih=(d,o,E)=>{const B=d.requestIdleCallback(o,typeof E=="number"?{timeout:E}:void 0);let G=!1;return{dispose(){G||(G=!0,d.cancelIdleCallback(B))}}},e.$Hh=d=>(0,e.$Ih)(globalThis,d)}();class ne{constructor(o,E){this.g=!1,this.d=()=>{try{this.j=E()}catch(B){this.l=B}finally{this.g=!0}},this.f=(0,e.$Ih)(o,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Jh=ne;class N extends ne{constructor(o){super(globalThis,o)}}e.$Kh=N;async function y(d,o,E){let B;for(let G=0;G<E;G++)try{return await d()}catch(J){B=J,await r(o)}throw B}class V{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,E,B){return this.a={taskId:o,cancel:()=>B?.(),promise:E},E.then(()=>this.d(o),()=>this.d(o)),E}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{const{promise:E,resolve:B,reject:G}=$();this.b={run:o,promise:E,promiseResolve:B,promiseReject:G}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Mh=V;class K{constructor(o,E=()=>Date.now()){this.d=o,this.f=E,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}e.$Nh=K;var ie;(function(d){d[d.Resolved=0]="Resolved",d[d.Rejected=1]="Rejected"})(ie||(ie={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,E)=>{this.a=o,this.b=E})}complete(o){return new Promise(E=>{this.a(o),this.d={outcome:0,value:o},E()})}error(o){return new Promise(E=>{this.b(o),this.d={outcome:1,value:o},E()})}cancel(){return this.error(new z.$5)}}e.$Oh=oe;var ge;(function(d){async function o(B){let G;const J=await Promise.all(B.map(Y=>Y.then(se=>se,se=>{G||(G=se)})));if(typeof G<"u")throw G;return J}d.settled=o;function E(B){return new Promise(async(G,J)=>{try{await B(G,J)}catch(Y){J(Y)}})}d.withAsyncBody=E})(ge||(e.Promises=ge={}));class ae{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(o){this.a=void 0,this.b=void 0,this.d=!1,this.promise=o.then(E=>(this.a=E,this.d=!0,E),E=>{throw this.b=E,this.d=!0,E})}requireValue(){if(!this.d)throw new z.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ph=ae;class ve{constructor(o){this.b=o,this.a=new g.$V(()=>new ae(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Qh=ve;var be;(function(d){d[d.Initial=0]="Initial",d[d.DoneOK=1]="DoneOK",d[d.DoneError=2]="DoneError"})(be||(be={}));class me{static fromArray(o){return new me(E=>{E.emitMany(o)})}static fromPromise(o){return new me(async E=>{E.emitMany(await o)})}static fromPromises(o){return new me(async E=>{await Promise.all(o.map(async B=>E.emitOne(await B)))})}static merge(o){return new me(async E=>{await Promise.all(o.map(async B=>{for await(const G of B)E.emitOne(G)}))})}static{this.EMPTY=me.fromArray([])}constructor(o,E){this.a=0,this.b=[],this.d=null,this.f=E,this.g=new M.$be,queueMicrotask(async()=>{const B={emitOne:G=>this.h(G),emitMany:G=>this.j(G),reject:G=>this.l(G)};try{await Promise.resolve(o(B)),this.k()}catch(G){this.l(G)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(o,E){return new me(async B=>{for await(const G of o)B.emitOne(E(G))})}map(o){return me.map(this,o)}static filter(o,E){return new me(async B=>{for await(const G of o)E(G)&&B.emitOne(G)})}filter(o){return me.filter(this,o)}static coalesce(o){return me.filter(o,E=>!!E)}coalesce(){return me.coalesce(this)}static async toPromise(o){const E=[];for await(const B of o)E.push(B);return E}toPromise(){return me.toPromise(this)}h(o){this.a===0&&(this.b.push(o),this.g.fire())}j(o){this.a===0&&(this.b=this.b.concat(o),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(o){this.a===0&&(this.a=2,this.d=o,this.g.fire())}}e.$Rh=me;class Ce extends me{constructor(o,E){super(E),this.m=o}cancel(){this.m.cancel()}}e.$Sh=Ce;function k(d){const o=new C.$me,E=d(o.token);return new Ce(o,async B=>{const G=o.token.onCancellationRequested(()=>{G.dispose(),o.dispose(),B.reject(new z.$5)});try{for await(const J of E){if(o.token.isCancellationRequested)return;B.emitOne(J)}G.dispose(),o.dispose()}catch(J){G.dispose(),o.dispose(),B.reject(J)}})}class F{constructor(o){this.a=new oe,this.b=new me(G=>{if(E){G.reject(E);return}return B&&G.emitMany(B),this.d=J=>G.reject(J),this.f=J=>G.emitOne(J),this.a.p},o);let E,B;this.f=G=>{B||(B=[]),B.push(G)},this.d=G=>{E||(E=G)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(o){this.d(o),this.a.complete()}emitOne(o){this.f(o)}}e.$Uh=F}),define(de[39],$e([0,1,53,54,55,16,20,29,4,2,22,5]),function(le,e,C,z,M,O,W,P,c,g,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=D,e.readdirSync=I,e.whenDeleted=t,e.configureFlushOnWrite=r,e.writeFileSync=j;var T;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(T||(e.RimRafMode=T={}));async function U(H,X=T.UNLINK,te){if((0,W.$ug)(H))throw new Error("rimraf - will refuse to recursively delete root");return X===T.UNLINK?l(H):u(H,te)}async function u(H,X=(0,W.$zg)((0,z.tmpdir)())){try{try{await C.promises.rename(H,X)}catch(te){return te.code==="ENOENT"?void 0:l(H)}l(X).catch(te=>{})}catch(te){if(te.code!=="ENOENT")throw te}}async function l(H){return(0,M.promisify)(C.rm)(H,{recursive:!0,force:!0,maxRetries:3})}function D(H){if((0,W.$ug)(H))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}async function $(H,X){return s(await(X?S(H):(0,M.promisify)(C.readdir)(H)))}async function S(H){try{return await(0,M.promisify)(C.readdir)(H,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const X=[],te=await $(H);for(const ne of te){let N=!1,y=!1,V=!1;try{const K=await e.Promises.lstat((0,c.$kc)(H,ne));N=K.isFile(),y=K.isDirectory(),V=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}X.push({name:ne,isFile:()=>N,isDirectory:()=>y,isSymbolicLink:()=>V})}return X}function I(H){return s(C.readdirSync(H))}function s(H){return H.map(X=>typeof X=="string"?g.$j?(0,P.$9l)(X):X:(X.name=g.$j?(0,P.$9l)(X.name):X.name,X))}async function i(H){const X=await $(H),te=[];for(const ne of X)await n.existsDirectory((0,c.$kc)(H,ne))&&te.push(ne);return te}function t(H,X=1e3){return new Promise(te=>{let ne=!1;const N=setInterval(()=>{ne||(ne=!0,C.access(H,y=>{ne=!1,y&&(clearInterval(N),te(void 0))}))},X)})}var n;(function(H){async function X(N){let y;try{if(y=await e.Promises.lstat(N),!y.isSymbolicLink())return{stat:y}}catch{}try{return{stat:await e.Promises.stat(N),symbolicLink:y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&y)return{stat:y,symbolicLink:{dangling:!0}};if(g.$i&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&y)return{stat:y,symbolicLink:{dangling:!0}};throw K}throw V}}H.stat=X;async function te(N){try{const{stat:y,symbolicLink:V}=await H.stat(N);return y.isFile()&&V?.dangling!==!0}catch{}return!1}H.existsFile=te;async function ne(N){try{const{stat:y,symbolicLink:V}=await H.stat(N);return y.isDirectory()&&V?.dangling!==!0}catch{}return!1}H.existsDirectory=ne})(n||(e.SymlinkSupport=n={}));const b=new O.$Ah;function w(H,X,te){return b.queueFor(_.URI.file(H),()=>{const ne=Z(te);return new Promise((N,y)=>A(H,X,ne,V=>V?y(V):N()))},L.$Vg)}let m=!0;function r(H){m=H}function A(H,X,te,ne){if(!m)return C.writeFile(H,X,{mode:te.mode,flag:te.flag},ne);C.open(H,te.flag,te.mode,(N,y)=>{if(N)return ne(N);C.writeFile(y,X,V=>{if(V)return C.close(y,()=>ne(V));C.fdatasync(y,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),r(!1)),C.close(y,ie=>ne(ie))))})})}function j(H,X,te){const ne=Z(te);if(!m)return C.writeFileSync(H,X,{mode:ne.mode,flag:ne.flag});const N=C.openSync(H,ne.flag,ne.mode);try{C.writeFileSync(N,X);try{C.fdatasyncSync(N)}catch(y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",y),r(!1)}}finally{C.closeSync(N)}}function Z(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function v(H,X,te=6e4){if(H!==X)try{g.$i&&typeof te=="number"?await h(H,X,Date.now(),te):await(0,M.promisify)(C.rename)(H,X)}catch(ne){if(H.toLowerCase()!==X.toLowerCase()&&ne.code==="EXDEV"||H.endsWith("."))await a(H,X,{preserveSymlinks:!1}),await U(H,T.MOVE);else throw ne}}async function h(H,X,te,ne,N=0){try{return await(0,M.promisify)(C.rename)(H,X)}catch(y){if(y.code!=="EACCES"&&y.code!=="EPERM"&&y.code!=="EBUSY")throw y;if(Date.now()-te>=ne)throw console.error(`[node.js fs] rename failed after ${N} retries with error: ${y}`),y;if(N===0){let V=!1;try{const{stat:K}=await n.stat(X);K.isFile()||(V=!0)}catch{}if(V)throw y}return await(0,O.$sh)(Math.min(100,N*10)),h(H,X,te,ne,N+1)}}async function a(H,X,te){return R(H,X,{root:{source:H,target:X},options:te,handledSourcePaths:new Set})}const p=511;async function R(H,X,te){if(te.handledSourcePaths.has(H))return;te.handledSourcePaths.add(H);const{stat:ne,symbolicLink:N}=await n.stat(H);if(N){if(te.options.preserveSymlinks)try{return await ce(H,X,te)}catch{}if(N.dangling)return}return ne.isDirectory()?x(H,X,ne.mode&p,te):ue(H,X,ne.mode&p)}async function x(H,X,te,ne){await e.Promises.mkdir(X,{recursive:!0,mode:te});const N=await $(H);for(const y of N)await R((0,c.$kc)(H,y),(0,c.$kc)(X,y),ne)}async function ue(H,X,te){await e.Promises.copyFile(H,X),await e.Promises.chmod(X,te)}async function ce(H,X,te){let ne=await e.Promises.readlink(H);(0,W.$rg)(ne,te.root.source,!g.$k)&&(ne=(0,c.$kc)(te.root.target,ne.substr(te.root.source.length+1))),await e.Promises.symlink(ne,X)}e.Promises=new class{get access(){return(0,M.promisify)(C.access)}get stat(){return(0,M.promisify)(C.stat)}get lstat(){return(0,M.promisify)(C.lstat)}get utimes(){return(0,M.promisify)(C.utimes)}get read(){return(H,X,te,ne,N)=>new Promise((y,V)=>{C.read(H,X,te,ne,N,(K,ie,oe)=>K?V(K):y({bytesRead:ie,buffer:oe}))})}get readFile(){return(0,M.promisify)(C.readFile)}get write(){return(H,X,te,ne,N)=>new Promise((y,V)=>{C.write(H,X,te,ne,N,(K,ie,oe)=>K?V(K):y({bytesWritten:ie,buffer:oe}))})}get appendFile(){return(0,M.promisify)(C.appendFile)}get fdatasync(){return(0,M.promisify)(C.fdatasync)}get truncate(){return(0,M.promisify)(C.truncate)}get copyFile(){return(0,M.promisify)(C.copyFile)}get open(){return(0,M.promisify)(C.open)}get close(){return(0,M.promisify)(C.close)}get symlink(){return(0,M.promisify)(C.symlink)}get readlink(){return(0,M.promisify)(C.readlink)}get chmod(){return(0,M.promisify)(C.chmod)}get mkdir(){return(0,M.promisify)(C.mkdir)}get unlink(){return(0,M.promisify)(C.unlink)}get rmdir(){return(0,M.promisify)(C.rmdir)}get realpath(){return(0,M.promisify)(C.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return i}get writeFile(){return w}get rm(){return U}get rename(){return v}get copy(){return a}}}),define(de[40],$e([0,1,4,2,14,21,8,39]),function(le,e,C,z,M,O,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$jm=c,e.$km=g,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function c(_=M.env){return _.comspec||"cmd.exe"}function g(_){let T=[],U=!1;const u=function(l){if(U){T.push(l);return}(!_.send(l,$=>{if($&&console.error($),U=!1,T.length>0){const S=T.slice(0);T=[],S.forEach(I=>u(I))}})||z.$i)&&(U=!0)};return{send:u}}var L;(function(_){async function T(U,u,l){if(C.$jc(U))return U;if(u===void 0&&(u=M.cwd()),C.$nc(U)!=="."||(l===void 0&&W.$5f(M.env.PATH)&&(l=M.env.PATH.split(C.$uc)),l===void 0||l.length===0))return C.$kc(u,U);async function $(S){if(await P.Promises.exists(S)){let I;try{I=await P.Promises.stat(S)}catch(s){s.message.startsWith("EACCES")&&(I=await P.Promises.lstat(S))}return I?!I.isDirectory():!1}return!1}for(const S of l){let I;if(C.$jc(S)?I=C.$kc(S,U):I=C.$kc(u,S,U),await $(I))return I;let s=I+".com";if(await $(s)||(s=I+".exe",await $(s)))return s}return C.$kc(u,U)}_.findExecutable=T})(L||(e.win32=L={}))});var Ve=this&&this.__decorate||function(le,e,C,z){var M=arguments.length,O=M<3?e:z===null?z=Object.getOwnPropertyDescriptor(e,C):z,W;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(le,e,C,z);else for(var P=le.length-1;P>=0;P--)(W=le[P])&&(O=(M<3?W(O):M>3?W(e,C,O):W(e,C))||O);return M>3&&O&&Object.defineProperty(e,C,O),O};define(de[41],$e([0,1,17,16,10,7,26,3,9,6,37,11,8]),function(le,e,C,z,M,O,W,P,c,g,L,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.ProxyChannel=e.$_h=e.$9h=e.$8h=e.$7h=e.RequestInitiator=e.$6h=e.$3h=e.$2h=void 0,e.$4h=r,e.$5h=A,e.$0h=p,e.$$h=R;var U;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(U||(U={}));function u(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(l||(l={}));function D(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})($||($={}));function S(N){let y=0;for(let V=0;;V+=7){const K=N.read(1);if(y|=(K.buffer[0]&127)<<V,!(K.buffer[0]&128))return y}}const I=b(0);function s(N,y){if(y===0){N.write(I);return}let V=0;for(let ie=y;ie!==0;ie=ie>>>7)V++;const K=M.$Ce.alloc(V);for(let ie=0;y!==0;ie++)K.buffer[ie]=y&127,y=y>>>7,y>0&&(K.buffer[ie]|=128);N.write(K)}class i{constructor(y){this.b=y,this.a=0}read(y){const V=this.b.slice(this.a,this.a+y);return this.a+=V.byteLength,V}}e.$2h=i;class t{constructor(){this.a=[]}get buffer(){return M.$Ce.concat(this.a)}write(y){this.a.push(y)}}e.$3h=t;var n;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object",N[N.Int=6]="Int"})(n||(n={}));function b(N){const y=M.$Ce.alloc(1);return y.writeUInt8(N,0),y}const w={Undefined:b(n.Undefined),String:b(n.String),Buffer:b(n.Buffer),VSBuffer:b(n.VSBuffer),Array:b(n.Array),Object:b(n.Object),Uint:b(n.Int)},m=typeof Buffer<"u";function r(N,y){if(typeof y>"u")N.write(w.Undefined);else if(typeof y=="string"){const V=M.$Ce.fromString(y);N.write(w.String),s(N,V.byteLength),N.write(V)}else if(m&&Buffer.isBuffer(y)){const V=M.$Ce.wrap(y);N.write(w.Buffer),s(N,V.byteLength),N.write(V)}else if(y instanceof M.$Ce)N.write(w.VSBuffer),s(N,y.byteLength),N.write(y);else if(Array.isArray(y)){N.write(w.Array),s(N,y.length);for(const V of y)r(N,V)}else if(typeof y=="number"&&(y|0)===y)N.write(w.Uint),s(N,y);else{const V=M.$Ce.fromString(JSON.stringify(y));N.write(w.Object),s(N,V.byteLength),N.write(V)}}function A(N){switch(N.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return N.read(S(N)).toString();case n.Buffer:return N.read(S(N)).buffer;case n.VSBuffer:return N.read(S(N));case n.Array:{const V=S(N),K=[];for(let ie=0;ie<V;ie++)K.push(A(N));return K}case n.Object:return JSON.parse(N.read(S(N)).toString());case n.Int:return S(N)}}class j{constructor(y,V,K=null,ie=1e3){this.h=y,this.j=V,this.k=K,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(y,V){this.b.set(y,V),setTimeout(()=>this.w(y),0)}m(y){switch(y.type){case 200:{const V=this.o([y.type]);this.k?.logOutgoing(V,0,1,D(y.type));return}case 201:case 202:case 204:case 203:{const V=this.o([y.type,y.id],y.data);this.k?.logOutgoing(V,y.id,1,D(y.type),y.data);return}}}o(y,V=void 0){const K=new t;return r(K,y),r(K,V),this.p(K.buffer)}p(y){try{return this.h.send(y),y.byteLength}catch{return 0}}q(y){const V=new i(y),K=A(V),ie=A(V),oe=K[0];switch(oe){case 100:return this.k?.logIncoming(y.byteLength,K[1],1,`${u(oe)}: ${K[2]}.${K[3]}`,ie),this.s({type:oe,id:K[1],channelName:K[2],name:K[3],arg:ie});case 102:return this.k?.logIncoming(y.byteLength,K[1],1,`${u(oe)}: ${K[2]}.${K[3]}`,ie),this.t({type:oe,id:K[1],channelName:K[2],name:K[3],arg:ie});case 101:return this.k?.logIncoming(y.byteLength,K[1],1,`${u(oe)}`),this.u({type:oe,id:K[1]});case 103:return this.k?.logIncoming(y.byteLength,K[1],1,`${u(oe)}`),this.u({type:oe,id:K[1]})}}s(y){const V=this.b.get(y.channelName);if(!V){this.v(y);return}const K=new O.$me;let ie;try{ie=V.call(this.j,y.name,y.arg,K.token)}catch(ae){ie=Promise.reject(ae)}const oe=y.id;ie.then(ae=>{this.m({id:oe,data:ae,type:201})},ae=>{ae instanceof Error?this.m({id:oe,data:{message:ae.message,name:ae.name,stack:ae.stack?ae.stack.split?ae.stack.split(`
`):ae.stack:void 0},type:202}):this.m({id:oe,data:ae,type:203})}).finally(()=>{ge.dispose(),this.d.delete(y.id)});const ge=(0,g.$Sc)(()=>K.cancel());this.d.set(y.id,ge)}t(y){const V=this.b.get(y.channelName);if(!V){this.v(y);return}const K=y.id,oe=V.listen(this.j,y.name,y.arg)(ge=>this.m({id:K,data:ge,type:204}));this.d.set(y.id,oe)}u(y){const V=this.d.get(y.id);V&&(V.dispose(),this.d.delete(y.id))}v(y){let V=this.g.get(y.channelName);V||(V=[],this.g.set(y.channelName,V));const K=setTimeout(()=>{console.error(`Unknown channel: ${y.channelName}`),y.type===100&&this.m({id:y.id,data:{name:"Unknown channel",message:`Channel name '${y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:y,timeoutTimer:K})}w(y){const V=this.g.get(y);if(V){for(const K of V)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.s(K.request);break;case 102:this.t(K.request);break}this.g.delete(y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Pc)(this.d.values()),this.d.clear()}}e.$6h=j;var Z;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(Z||(e.RequestInitiator=Z={}));class v{constructor(y,V=null){this.l=y,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new c.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=V}getChannel(y){const V=this;return{call(K,ie,oe){return V.a?Promise.reject(new P.$5):V.m(y,K,ie,oe)},listen(K,ie){return V.a?c.Event.None:V.o(y,K,ie)}}}m(y,V,K,ie=O.CancellationToken.None){const oe=this.g++,ae={id:oe,type:100,channelName:y,name:V,arg:K};if(ie.isCancellationRequested)return Promise.reject(new P.$5);let ve;return new Promise((me,Ce)=>{if(ie.isCancellationRequested)return Ce(new P.$5);const k=()=>{const E=B=>{switch(B.type){case 201:this.f.delete(oe),me(B.data);break;case 202:{this.f.delete(oe);const G=new Error(B.data.message);G.stack=Array.isArray(B.data.stack)?B.data.stack.join(`
`):B.data.stack,G.name=B.data.name,Ce(G);break}case 203:this.f.delete(oe),Ce(B.data);break}};this.f.set(oe,E),this.p(ae)};let F=null;this.b===$.Idle?k():(F=(0,z.$eh)(E=>this.u()),F.then(()=>{F=null,k()}));const d=()=>{F?(F.cancel(),F=null):this.p({id:oe,type:101}),Ce(new P.$5)},o=ie.onCancellationRequested(d);ve=(0,g.$Rc)((0,g.$Sc)(d),o),this.d.add(ve)}).finally(()=>{ve.dispose(),this.d.delete(ve)})}o(y,V,K){const ie=this.g++,ge={id:ie,type:102,channelName:y,name:V,arg:K};let ae=null;const ve=new c.$be({onWillAddFirstListener:()=>{ae=(0,z.$eh)(me=>this.u()),ae.then(()=>{ae=null,this.d.add(ve),this.p(ge)})},onDidRemoveLastListener:()=>{ae?(ae.cancel(),ae=null):(this.d.delete(ve),this.p({id:ie,type:103}))}}),be=me=>ve.fire(me.data);return this.f.set(ie,be),ve.event}p(y){switch(y.type){case 100:case 102:{const V=this.q([y.type,y.id,y.channelName,y.name],y.arg);this.j?.logOutgoing(V,y.id,0,`${u(y.type)}: ${y.channelName}.${y.name}`,y.arg);return}case 101:case 103:{const V=this.q([y.type,y.id]);this.j?.logOutgoing(V,y.id,0,u(y.type));return}}}q(y,V=void 0){const K=new t;return r(K,y),r(K,V),this.r(K.buffer)}r(y){try{return this.l.send(y),y.byteLength}catch{return 0}}s(y){const V=new i(y),K=A(V),ie=A(V),oe=K[0];switch(oe){case 200:return this.j?.logIncoming(y.byteLength,0,0,D(oe)),this.t({type:K[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(y.byteLength,K[1],0,D(oe),ie),this.t({type:K[0],id:K[1],data:ie})}}t(y){if(y.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(y.id)?.(y)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Pc)(this.d.values()),this.d.clear()}}e.$7h=v,Ve([W.$Vh],v.prototype,"onDidInitializePromise",null);class h{get connections(){const y=[];return this.f.forEach(V=>y.push(V)),y}constructor(y,V,K){this.a=new Map,this.f=new Set,this.g=new c.$be,this.onDidAddConnection=this.g.event,this.h=new c.$be,this.onDidRemoveConnection=this.h.event,this.j=new g.$Tc,this.j.add(y(({protocol:ie,onDidClientDisconnect:oe})=>{const ge=c.Event.once(ie.onMessage);this.j.add(ge(ae=>{const ve=new i(ae),be=A(ve),me=new j(ie,be,V,K),Ce=new v(ie,V);this.a.forEach((F,d)=>me.registerChannel(d,F));const k={channelServer:me,channelClient:Ce,ctx:be};this.f.add(k),this.g.fire(k),this.j.add(oe(()=>{me.dispose(),Ce.dispose(),this.f.delete(k),this.h.fire(k)}))}))}))}getChannel(y,V){const K=this;return{call(ie,oe,ge){let ae;if((0,T.$gg)(V)){const be=(0,C.$4b)(K.connections.filter(V));ae=be?Promise.resolve(be):c.Event.toPromise(c.Event.filter(K.onDidAddConnection,V))}else ae=V.routeCall(K,ie,oe);const ve=ae.then(be=>be.channelClient.getChannel(y));return p(ve).call(ie,oe,ge)},listen(ie,oe){if((0,T.$gg)(V))return K.k(y,V,ie,oe);const ge=V.routeEvent(K,ie,oe).then(ae=>ae.channelClient.getChannel(y));return p(ge).listen(ie,oe)}}}k(y,V,K,ie){const oe=this;let ge;const ae=new c.$be({onWillAddFirstListener:()=>{ge=new g.$Tc;const ve=new c.$he,be=new Map,me=k=>{const d=k.channelClient.getChannel(y).listen(K,ie),o=ve.add(d);be.set(k,o)},Ce=k=>{const F=be.get(k);F&&(F.dispose(),be.delete(k))};oe.connections.filter(V).forEach(me),c.Event.filter(oe.onDidAddConnection,V)(me,void 0,ge),oe.onDidRemoveConnection(Ce,void 0,ge),ve.event(ae.fire,ae,ge),ge.add(ve)},onDidRemoveLastListener:()=>{ge?.dispose(),ge=void 0}});return ae.event}registerChannel(y,V){this.a.set(y,V);for(const K of this.f)K.channelServer.registerChannel(y,V)}dispose(){this.j.dispose();for(const y of this.f)y.channelClient.dispose(),y.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$8h=h;class a{constructor(y,V,K=null){const ie=new t;r(ie,V),y.send(ie.buffer),this.a=new v(y,K),this.d=new j(y,V,K)}getChannel(y){return this.a.getChannel(y)}registerChannel(y,V){this.d.registerChannel(y,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$9h=a;function p(N){return{call(y,V,K){return N.then(ie=>ie.call(y,V,K))},listen(y,V){const K=new c.$ke;return N.then(ie=>K.input=ie.listen(y,V)),K.event}}}function R(N){let y=!1;return{call(V,K,ie){return y?N.call(V,K,ie):(0,z.$sh)(0).then(()=>y=!0).then(()=>N.call(V,K,ie))},listen(V,K){if(y)return N.listen(V,K);const ie=new c.$ke;return(0,z.$sh)(0).then(()=>y=!0).then(()=>ie.input=N.listen(V,K)),ie.event}}}class x{constructor(y){this.a=y}routeCall(y){return this.b(y)}routeEvent(y){return this.b(y)}async b(y){for(const V of y.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await c.Event.toPromise(y.onDidAddConnection),await this.b(y)}}e.$_h=x;var ue;(function(N){function y(oe,ge,ae){const ve=oe,be=ae&&ae.disableMarshalling,me=new Map;for(const Ce in ve)K(Ce)&&me.set(Ce,c.Event.buffer(ve[Ce],!0,void 0,ge));return new class{listen(Ce,k,F){const d=me.get(k);if(d)return d;const o=ve[k];if(typeof o=="function"){if(ie(k))return o.call(ve,F);if(K(k))return me.set(k,c.Event.buffer(ve[k],!0,void 0,ge)),me.get(k)}throw new P.$bb(`Event not found: ${k}`)}call(Ce,k,F){const d=ve[k];if(typeof d=="function"){if(!be&&Array.isArray(F))for(let E=0;E<F.length;E++)F[E]=(0,L.$1h)(F[E]);let o=d.apply(ve,F);return o instanceof Promise||(o=Promise.resolve(o)),o}throw new P.$bb(`Method not found: ${k}`)}}}N.fromService=y;function V(oe,ge){const ae=ge&&ge.disableMarshalling;return new Proxy({},{get(ve,be){if(typeof be=="string")return ge?.properties?.has(be)?ge.properties.get(be):ie(be)?function(me){return oe.listen(be,me)}:K(be)?oe.listen(be):async function(...me){let Ce;ge&&!(0,T.$bg)(ge.context)?Ce=[ge.context,...me]:Ce=me;const k=await oe.call(be,Ce);return ae?k:(0,L.$1h)(k)};throw new P.$bb(`Property not found: ${String(be)}`)}})}N.toService=V;function K(oe){return oe[0]==="o"&&oe[1]==="n"&&_.$tf(oe.charCodeAt(2))}function ie(oe){return/^onDynamic/.test(oe)&&_.$tf(oe.charCodeAt(9))}})(ue||(e.ProxyChannel=ue={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const y=N.toString();if(y!=="[object Object]")return y}return N}function X(N){return Array.isArray(N)?N.map(H):H(N)}function te(N,y,V,K,ie,oe,ge){ge=X(ge);const ae=ce[ie],ve=ae[K%ae.length];let be=[`%c[${N}]%c[${String(y).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(oe)?(be=be.concat(ge),be.push(")")):be.push(ge),console.log.apply(console,be)}class ne{constructor(y,V){this.d=y,this.f=V,this.a=0,this.b=0}logOutgoing(y,V,K,ie,oe){this.b+=y,te(this.d,this.b,y,V,K,ie,oe)}logIncoming(y,V,K,ie,oe){this.a+=y,te(this.f,this.a,y,V,K,ie,oe)}}e.$ai=ne}),define(de[42],$e([0,1,56,16,10,7,36,3,9,6,13,40,21,41]),function(le,e,C,z,M,O,W,P,c,g,L,_,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;class u extends U.$6h{constructor($){super({send:S=>{try{process.send?.(S.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",S=>M.$Ce.wrap(Buffer.from(S,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$Uq=u;class l{constructor($,S){this.i=$,this.j=S,this.c=new Set,this.g=new Map,this.h=new c.$be,this.onDidProcessExit=this.h.event;const I=S&&S.timeout?S.timeout:6e4;this.b=new z.$oh(I),this.d=null,this.f=null}getChannel($){const S=this;return{call(I,s,i){return S.k($,I,s,i)},listen(I,s){return S.l($,I,s)}}}k($,S,I,s=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const i=this.n($),t=(0,z.$eh)(w=>i.call(S,I,w)),n=s.onCancellationRequested(()=>t.cancel()),b=(0,g.$Sc)(()=>t.cancel());return this.c.add(b),t.finally(()=>{n.dispose(),this.c.delete(b),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l($,S,I){if(!this.b)return c.Event.None;this.b.cancel();let s;const i=new c.$be({onWillAddFirstListener:()=>{s=this.n($).listen(S,I)(i.fire,i),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],S=Object.create(null);S.env={...(0,L.$Xn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(S.env={...S.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(S.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,T.$im)(S.env),this.d=(0,C.fork)(this.i,$,S);const I=new c.$be,i=c.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,W.$Qq)(r)){(0,W.log)(r,`IPC Library: ${this.j.serverName}`);return}I.fire(M.$Ce.wrap(Buffer.from(r,"base64")))}),t=this.j.useQueue?(0,_.$km)(this.d):this.d,n=r=>this.d&&this.d.connected&&t.send(r.buffer.toString("base64")),b=I.event,w={send:n,onMessage:b};this.f=new U.$7h(w);const m=()=>this.o();process.once("exit",m),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,A)=>{process.removeListener("exit",m),i.dispose(),this.c.forEach(j=>(0,g.$Pc)(j)),this.c.clear(),r!==0&&A!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+A),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:A})})}return this.f}n($){let S=this.g.get($);return S||(S=this.m.getChannel($),this.g.set($,S)),S}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Vq=l}),define(de[43],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e._util=void 0,e.$ri=M,e.$si=O;var C;(function(W){W.serviceIds=new Map,W.DI_TARGET="$di$target",W.DI_DEPENDENCIES="$di$dependencies";function P(c){return c[W.DI_DEPENDENCIES]||[]}W.getServiceDependencies=P})(C||(e._util=C={})),e.$qi=M("instantiationService");function z(W,P,c){P[C.DI_TARGET]===P?P[C.DI_DEPENDENCIES].push({id:W,index:c}):(P[C.DI_DEPENDENCIES]=[{id:W,index:c}],P[C.DI_TARGET]=P)}function M(W){if(C.serviceIds.has(W))return C.serviceIds.get(W);const P=function(c,g,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");z(P,c,L)};return P.toString=()=>W,C.serviceIds.set(W,P),P}function O(W){return W}}),define(de[44],$e([0,1,15]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=z,e.$Dm=M,e.$Em=O,e.$Fm=W;function z(c){return c.scheme===C.Schemas.vscodeRemote?c.authority:void 0}function M(c){if(!c)return;const g=c.indexOf("+");return g<0?c:c.substr(0,g)}function O(c){const{host:g,port:L}=P(c);if(typeof L>"u")throw new Error(`Invalid remote authority: ${c}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:g,port:L}}function W(c,g){let{host:L,port:_}=P(c);return typeof _>"u"&&(_=g),{host:L,port:_}}function P(c){const g=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const L=c.match(/^(\[[0-9a-z:]+\])$/);if(L)return{host:L[1],port:void 0};const _=c.match(/(.*):(\d+)$/);return _?{host:_[1],port:parseInt(_[2],10)}:{host:c,port:void 0}}}),define(de[45],$e([0,1,2,14,34]),function(le,e,C,z,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=W,e.$_o=P;function O(c){if(C.$u===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}function W(c,g,L,_,T,U,u,l,D){const $=Object.create(null);$["common.machineId"]=U,$["common.sqmId"]=u,$.sessionID=(0,M.$Ng)()+Date.now(),$.commitHash=_,$.version=T,$["common.platformVersion"]=(c||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,C.$h)(C.$u),$["common.nodePlatform"]=z.$ec,$["common.nodeArch"]=L,$["common.product"]=D||"desktop",l&&($["common.msftInternal"]=l);let S=0;const I=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-I,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),C.$l&&($["common.snap"]="true");const s=O(g);return s&&($["common.platformDetail"]=s),$}function P(c){const g=z.env.USERDNSDOMAIN;if(!g)return!1;const L=g.toLowerCase();return c.some(_=>L===_)}}),define(de[46],$e([0,1,43]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0,e.$Wl=(0,C.$ri)("telemetryService"),e.$Xl=(0,C.$ri)("customEndpointTelemetryService"),e.$Yl="telemetry.currentSessionDate",e.$Zl="telemetry.firstSessionDate",e.$1l="telemetry.lastSessionDate",e.$2l="telemetry.machineId",e.$3l="telemetry.sqmId",e.$4l="telemetry",e.$5l="telemetry.telemetryLevel",e.$6l="telemetry.enableCrashReporter",e.$7l="telemetry.enableTelemetry";var z;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(z||(e.TelemetryLevel=z={}));var M;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(de[47],$e([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;class C{constructor(O){this.b=O}listen(O,W){throw new Error(`Event not found: ${W}`)}call(O,W,{eventName:P,data:c}){return this.b.forEach(g=>g.log(P,c)),Promise.resolve(null)}}e.$mcc=C;class z{constructor(O){this.b=O}log(O,W){return this.b.call("log",{eventName:O,data:W}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$ncc=z}),define(de[48],$e([0,1,13,8,44,45,46]),function(le,e,C,z,M,O,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0,e.$hp=L,e.$ip=_,e.$jp=T,e.$kp=U,e.$lp=l,e.$mp=$,e.$np=S,e.$op=i;class P{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$ap=P;class c{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$bp=c,e.$cp=new c;class g{async publicLog(n,b,w){}async publicLogError(n,b,w){}}e.$dp=g,e.$ep="telemetry",e.$fp="extensionTelemetryLog",e.$gp={log:()=>null,flush:()=>Promise.resolve(null)};function L(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}function _(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function T(t){const n=t.getValue(W.$5l),b=t.getValue(W.$6l);if(t.getValue(W.$7l)===!1||b===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function U(t){const n={},b={},w={};D(t,w);for(let m in w){m=m.length>150?m.substr(m.length-149):m;const r=w[m];typeof r=="number"?b[m]=r:typeof r=="boolean"?b[m]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${r.length}`),n[m]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(n[m]=r)}return{properties:n,measurements:b}}const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(t){if(!t)return"none";const n=(0,M.$Dm)(t);return u.has(n)?n:"other"}function D(t,n,b=0,w){if(t)for(const m of Object.getOwnPropertyNames(t)){const r=t[m],A=w?w+m:m;Array.isArray(r)?n[A]=(0,C.$3n)(r):r instanceof Date?n[A]=r.toISOString():(0,z.$7f)(r)?b<2?D(r,n,b+1,A+"."):n[A]=(0,C.$3n)(r):n[A]=r}}function $(t,n){const b=t.msftInternalDomains||[],w=n.getValue("telemetry.internalTesting");return(0,O.$_o)(b)||w}function S(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function I(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let b=t;const w=[];for(const j of n)for(;;){const Z=j.exec(t);if(!Z)break;w.push([Z.index,j.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let A=0;for(b="";;){const j=r.exec(t);if(!j)break;const Z=w.some(([v,h])=>j.index<h&&v<r.lastIndex);!m.test(j[0])&&!Z&&(b+=t.substring(A,j.index)+"<REDACTED: user-file-path>",A=r.lastIndex)}return A<t.length&&(b+=t.substr(A)),b}function s(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const b of n)if(b.regex.test(t))return`<REDACTED: ${b.label}>`;return t}function i(t,n){return(0,C.$Zn)(t,b=>{if(b instanceof P||Object.hasOwnProperty.call(b,"isTrustedTelemetryValue"))return b.value;if(typeof b=="string"){let w=b.replaceAll("%20"," ");w=I(w,n);for(const m of n)w=w.replace(m,"");return w=s(w),w}})}}),define(de[49],$e([0,1,38,3,13,48]),function(le,e,C,z,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=void 0;const W="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function c(L,_,T){const U=await(0,C.$TD)("@microsoft/1ds-core-js","dist/ms.core.js"),u=await(0,C.$TD)("@microsoft/1ds-post-js","dist/ms.post.js"),l=new U.AppInsightsCore,D=new u.PostChannel,$={instrumentationKey:L,endpointUrl:W,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[D]]};if(T){$.extensionConfig={};const S={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:T};$.extensionConfig[D.identifier]=S}return l.initialize($,[]),l.addTelemetryInitializer(S=>{S.ext=S.ext??{},S.ext.web=S.ext.web??{},S.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',_&&(S.ext.utc=S.ext.utc??{},S.ext.utc.flags=8462029)}),l}class g{constructor(_,T,U,u,l){this.e=_,this.f=T,this.g=U,this.h=l,this.c=W,this.d=P,this.g||(this.g={}),typeof u=="function"?this.a=u():this.a=u,this.b=null}i(_){if(this.a){if(typeof this.a!="string"){_(this.a);return}this.b||(this.b=c(this.a,this.e,this.h)),this.b.then(T=>{_(T)},T=>{(0,z.$1)(T),console.error(T)})}}log(_,T){if(!this.a)return;T=(0,M.$1n)(T,this.g),T=(0,O.$kp)(T);const U=this.f+"/"+_;try{this.i(u=>{u.pluginVersionString=T?.properties.version??"Unknown",u.track({name:U,baseData:{name:U,properties:T?.properties,measurements:T?.measurements}})})}catch{}}flush(){return this.a?new Promise(_=>{this.i(T=>{T.unload(!0,()=>{this.a=void 0,_(void 0)})})}):Promise.resolve(void 0)}}e.$qQ=g}),define(de[50],$e([0,1,10,7,57,49]),function(le,e,C,z,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rQ=void 0;async function W(L,_){const T=await _.request(L,z.CancellationToken.None),U=(await(0,C.$Oe)(T.stream)).toString(),u=T.res.statusCode??200;return{headers:T.res.headers,statusCode:u,responseData:U}}async function P(L){const _={method:L.type,headers:L.headers};return new Promise((U,u)=>{const l=M.request(L.url??"",_,D=>{D.on("data",function($){U({headers:D.headers,statusCode:D.statusCode??200,responseData:$.toString()})}),D.on("error",function($){u($)})});l.write(L.data,D=>{D&&u(D)}),l.end()})}async function c(L,_,T){const U=typeof _.data=="string"?_.data:new TextDecoder().decode(_.data),u={type:"POST",headers:{..._.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(_.data).toString()},url:_.urlString,data:U};try{const l=L?await W(u,L):await P(u);T(l.statusCode,l.headers,l.responseData)}catch{T(0,{})}}class g extends O.$qQ{constructor(_,T,U,u,l){const D={sendPOST:($,S)=>{c(_,$,S)}};super(T,U,u,l,D)}}e.$rQ=g}),define(de[58],$e([0,1,42,47,50]),function(le,e,C,z,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});const O=new M.$rQ(void 0,!1,process.argv[2],JSON.parse(process.argv[3]),process.argv[4]);process.once("exit",()=>O.flush());const W=new z.$mcc([O]);new C.$Uq("telemetry").registerChannel("telemetryAppender",W)})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/910284865c34fd492e3f6fd5a8ab8e571432cc58/core/vs/workbench/contrib/debug/node/telemetryApp.js.map
